/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
/*
*
* Script de DDL e DML
*
* Versao 2.01.2
*
* Fabio Bertoldi - 20121112
*
*/

----------------
-- Ticket #18261
----------------

-- CREATE OR REPLACE FUNCTION tr_plano_conta_valida_indicador_superavit() RETURNS TRIGGER AS $$
-- DECLARE
-- BEGIN
--     IF (NEW.indicador_superavit IS NOT NULL) AND (trim(NEW.indicador_superavit) != '') THEN
--         PERFORM 1
--            FROM contabilidade.sistema_contabil
--           WHERE (    '1' = ANY(string_to_array(grupos,','))
--                   OR '2' = ANY(string_to_array(grupos,','))
--                 )
--             AND NEW.cod_sistema = cod_sistema
--               ;
--         IF FOUND THEN
--             RETURN NEW;
--         ELSE
--             RAISE EXCEPTION 'Indicador de Superávit (%) inválido para o Sistema Contábil utilizado (%)!',trim(NEW.indicador_superavit), NEW.cod_sistema;
--             -- RETURN NULL;
--         END IF;
--     ELSE
--         RETURN NEW;
--     END IF;
-- END;
-- $$ LANGUAGE 'plpgsql';
--
--
-- CREATE OR REPLACE FUNCTION tr_plano_conta_valida_escrituracao() RETURNS TRIGGER AS $$
-- DECLARE
-- BEGIN
--     IF (     NEW.natureza_info       IS NULL
--          AND NEW.natureza_saldo      IS NULL
--          AND NEW.indicador_superavit IS NULL
--          AND NEW.escrituracao        = 'sintetica'
--        )
--        OR
--        ( NEW.escrituracao        = 'analitica'
--        )
--     THEN
--         RETURN NEW;
--     ELSE
--         RAISE EXCEPTION 'Erro ao especificar conta Sintética ou Analítica!';
--         -- RETURN NULL;
--     END IF;
-- END;
-- $$ LANGUAGE 'plpgsql';


CREATE OR REPLACE FUNCTION manutencao() RETURNS VOID AS $$
DECLARE
    stSQL               VARCHAR;
    reRecord            RECORD;
    inCountPlanoConta   INTEGER := 1;
    inCountAnalitica    INTEGER := 1;
BEGIN

    PERFORM 1
       FROM administracao.configuracao
      WHERE exercicio  = '2012'
        AND cod_modulo = 2
        AND parametro  = 'cnpj'
        AND valor      = '15424948000141'
          ;
    IF NOT FOUND THEN


        CREATE TABLE contabilidade.configuracao_contabilidade (
            exercicio       CHAR(4)     NOT NULL,
            parametro       VARCHAR(40) NOT NULL,
            valor           TEXT        NOT NULL,
            fixo            BOOLEAN     NOT NULL DEFAULT FALSE,
            CONSTRAINT pk_configuracao_contabilidade    PRIMARY KEY (exercicio, parametro)
        );
        GRANT ALL ON contabilidade.configuracao_contabilidade TO siamweb;

        INSERT INTO contabilidade.configuracao_contabilidade (exercicio, parametro, valor, fixo) VALUES ('2012', 'mascara_uniao'  , '9.9.9.9.9.99.99', TRUE );
        INSERT INTO contabilidade.configuracao_contabilidade (exercicio, parametro, valor, fixo) VALUES ('2012', 'mascara_sistema', '99.999'         , FALSE);

        DELETE FROM contabilidade.classificacao_plano    WHERE exercicio = '2013';
        DELETE FROM contabilidade.plano_recurso          WHERE exercicio = '2013';
        DELETE FROM contabilidade.plano_banco            WHERE exercicio = '2013';
        DELETE FROM contabilidade.plano_analitica        WHERE exercicio = '2013';
        DELETE FROM contabilidade.plano_conta            WHERE exercicio = '2013';
        DELETE FROM contabilidade.classificacao_contabil WHERE exercicio = '2013';
        DELETE FROM contabilidade.sistema_contabil       WHERE exercicio = '2013';
        INSERT INTO contabilidade.classificacao_contabil SELECT cod_classificacao, '2013' AS exercicio, nom_classificacao FROM contabilidade.classificacao_contabil WHERE exercicio = '2012';

        ALTER TABLE contabilidade.sistema_contabil ADD COLUMN grupos VARCHAR(20);
        INSERT INTO contabilidade.sistema_contabil (cod_sistema, exercicio, nom_sistema, grupos) VALUES (1, '2013', 'Patrimonial'  , '1,2,3,4');
        INSERT INTO contabilidade.sistema_contabil (cod_sistema, exercicio, nom_sistema, grupos) VALUES (2, '2013', 'Orçamentário' , '5,6'    );
        INSERT INTO contabilidade.sistema_contabil (cod_sistema, exercicio, nom_sistema, grupos) VALUES (3, '2013', 'Controle'     , '7,8'    );
        INSERT INTO contabilidade.sistema_contabil (cod_sistema, exercicio, nom_sistema, grupos) VALUES (4, '2013', 'Não Informado', '0'      );


        ALTER TABLE contabilidade.plano_conta ADD   COLUMN escrituracao         CHAR(9);
        ALTER TABLE contabilidade.plano_conta ADD   COLUMN natureza_saldo       CHAR(7);
        ALTER TABLE contabilidade.plano_conta ADD   COLUMN indicador_superavit  CHAR(12);
        ALTER TABLE contabilidade.plano_conta ADD   COLUMN funcao               TEXT;
        ALTER TABLE contabilidade.plano_conta ALTER COLUMN nom_conta       TYPE VARCHAR(200);

        ALTER TABLE contabilidade.plano_conta DROP CONSTRAINT uk_plano_conta_1;
        ALTER TABLE contabilidade.plano_conta ADD  CONSTRAINT ck_plano_conta_1  CHECK  (escrituracao        IN ('analitica','sintetica'));
        ALTER TABLE contabilidade.plano_conta ADD  CONSTRAINT ck_plano_conta_2  CHECK  (natureza_saldo      IN ('credor','devedor','S', 'misto',''));
        ALTER TABLE contabilidade.plano_conta ADD  CONSTRAINT ck_plano_conta_3  CHECK  (indicador_superavit IN ('permanente','financeiro','misto', ''));
        ALTER TABLE contabilidade.plano_conta ADD  CONSTRAINT uk_plano_conta_1  UNIQUE (cod_estrutural, indicador_superavit);

        PERFORM 1
           FROM pg_trigger
          WHERE tgname = 'tr_monta_codigo_estrutural'
              ;
        IF FOUND THEN
            DROP TRIGGER tr_monta_codigo_estrutural on contabilidade.plano_conta;
        END IF;

        CREATE TRIGGER tr_plano_conta_valida_indicador_funcional AFTER INSERT OR UPDATE ON contabilidade.plano_conta FOR EACH ROW EXECUTE PROCEDURE tr_plano_conta_valida_indicador_superavit();


        CREATE TABLE contabilidade.configuracao_lancamento_debito (
            cod_conta           INTEGER     NOT NULL,
            exercicio           CHAR(4)     NOT NULL,
            cod_conta_despesa   INTEGER     NOT NULL,
            estorno             BOOLEAN     NOT NULL,
            tipo                CHAR(20)    NOT NULL,
            rpps                BOOLEAN     NOT NULL,
            CONSTRAINT pk_configuracao_lancamento_debito    PRIMARY KEY                            (cod_conta, exercicio, cod_conta_despesa, estorno),
            CONSTRAINT fk_configuracao_lancamento_debito_1  FOREIGN KEY                            (cod_conta, exercicio)
                                                            REFERENCES contabilidade.plano_conta   (cod_conta, exercicio),
            CONSTRAINT fk_configuracao_lancamento_debito_2  FOREIGN KEY                            (exercicio, cod_conta_despesa)
                                                            REFERENCES orcamento.conta_despesa     (exercicio, cod_conta),
            CONSTRAINT ck_configuracao_lancamento_debito_1  CHECK (tipo IN ('almoxarifado','arrecadacao','empenho','implantacao_saldo','liquidacao','manual','pagamento','suplementacao','transferencia'))
        );
        GRANT ALL ON contabilidade.configuracao_lancamento_debito TO siamweb;


        CREATE TABLE contabilidade.configuracao_lancamento_credito (
            cod_conta           INTEGER     NOT NULL,
            exercicio           CHAR(4)     NOT NULL,
            cod_conta_despesa   INTEGER     NOT NULL,
            estorno             BOOLEAN     NOT NULL,
            tipo                CHAR(20)    NOT NULL,
            rpps                BOOLEAN     NOT NULL,
            CONSTRAINT pk_configuracao_lancamento_credito   PRIMARY KEY                            (cod_conta, exercicio, cod_conta_despesa, estorno),
            CONSTRAINT fk_configuracao_lancamento_credito_1 FOREIGN KEY                            (cod_conta, exercicio)
                                                            REFERENCES contabilidade.plano_conta   (cod_conta, exercicio),
            CONSTRAINT fk_configuracao_lancamento_credito_2 FOREIGN KEY                            (exercicio, cod_conta_despesa)
                                                            REFERENCES orcamento.conta_despesa     (exercicio, cod_conta),
            CONSTRAINT ck_configuracao_lancamento_credito_1 CHECK (tipo IN ('almoxarifado', 'arrecadacao','empenho','implantacao_saldo','liquidacao','manual','pagamento','suplementacao','transferencia'))
        );
        GRANT ALL ON contabilidade.configuracao_lancamento_credito TO siamweb;


        CREATE TABLE contabilidade.configuracao_lancamento_receita (
            cod_conta           INTEGER     NOT NULL,
            exercicio           CHAR(4)     NOT NULL,
            cod_conta_receita   INTEGER     NOT NULL,
            estorno             BOOLEAN     NOT NULL,
            CONSTRAINT pk_configuracao_lancamento_receita   PRIMARY KEY                            (cod_conta, exercicio, cod_conta_receita, estorno),
            CONSTRAINT fk_configuracao_lancamento_receita_1 FOREIGN KEY                            (cod_conta, exercicio)
                                                            REFERENCES contabilidade.plano_conta   (cod_conta, exercicio),
            CONSTRAINT fk_configuracao_lancamento_receita_2 FOREIGN KEY                            (exercicio, cod_conta_receita)
                                                            REFERENCES orcamento.conta_receita     (exercicio, cod_conta)
        );
        GRANT ALL ON contabilidade.configuracao_lancamento_receita TO siamweb;


        INSERT
          INTO administracao.configuracao
        VALUES
             ( '2011'
             , 9
             , 'nova_contabiliade'
             ,'true'
             );

        INSERT
          INTO administracao.acao
             ( cod_acao
             , cod_funcionalidade
             , nom_arquivo
             , parametro
             , ordem
             , complemento_acao
             , nom_acao )
        VALUES
             ( 2805
             , 56
             , 'FMConfigurarLancamentosDespesa.php'
             , 'configurar'
             , 13
             , ''
             , 'Configurar Lançamentos de Despesa'
             );

        INSERT
          INTO administracao.acao
          ( cod_acao
          , cod_funcionalidade
          , nom_arquivo
          , parametro
          , ordem
          , complemento_acao
          , nom_acao )
          VALUES
          ( 2806
          , 63
          , 'FLRelatorioConfiguracaoLancamentoDespesa.php'
          , 'emitir'
          , 23
          , ''
          , 'Relatório de Configuração do Lançamento de Despesa'
          );

        INSERT
          INTO administracao.relatorio
          ( cod_gestao
          , cod_modulo
          , cod_relatorio
          , nom_relatorio
          , arquivo )
          VALUES
          ( 2
          , 9
          , 7
          , 'Relatório de Configuração do Lançamento de Despesa'
          , 'relatorioConfiguracaoLancamentoDespesa.rptdesign'
          );

        INSERT
          INTO administracao.acao
             ( cod_acao
             , cod_funcionalidade
             , nom_arquivo
             , parametro
             , ordem
             , complemento_acao
             , nom_acao )
        VALUES
             ( 2807
             , 56
             , 'FMConfigurarLancamentosReceita.php'
             , 'configurar'
             , 14
             , ''
             , 'Configurar Lançamentos de Receita'
             );

        INSERT
          INTO administracao.acao
          ( cod_acao
          , cod_funcionalidade
          , nom_arquivo
          , parametro
          , ordem
          , complemento_acao
          , nom_acao )
          VALUES
          ( 2808
          , 63
          , 'FLRelatorioConfiguracaoLancamentoReceita.php'
          , 'emitir'
          , 24
          , ''
          , 'Relatório de Configuração do Lançamento de Receita'
          );

        INSERT
          INTO administracao.relatorio
          ( cod_gestao
          , cod_modulo
          , cod_relatorio
          , nom_relatorio
          , arquivo )
          VALUES
          ( 2
          , 9
          , 8
          , 'Relatório de Configuração do Lançamento de Receita'
          , 'relatorioConfiguracaoLancamentoReceita.rptdesign'
          );


    END IF;

END;
$$ LANGUAGE 'plpgsql';

SELECT        manutencao();
DROP FUNCTION manutencao();


----------------
-- Ticket #19760
----------------

INSERT
  INTO administracao.configuracao
  ( cod_modulo
  , exercicio
  , parametro
  , valor
  )
  VALUES
  ( 9
  , '2012'
  , 'utilizar_encerramento_mes'
  , 'false'
  );


INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2853
  , 56
  , 'FMManterEncerramentoMes.php'
  , 'encerrar'
  , 11
  , ''
  , 'Encerrar Mês'
  , TRUE
  );

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2854
  , 56
  , 'FMManterEncerramentoMes.php'
  , 'reabrir'
  , 12
  , ''
  , 'Reabrir Mês Encerrado'
  , TRUE
  );


CREATE TABLE contabilidade.encerramento_mes (
    mes             INTEGER             NOT NULL,
    exercicio       CHAR(4)             NOT NULL,
    timestamp       TIMESTAMP           NOT NULL DEFAULT ('now'::text)::timestamp(3),
    situacao        CHAR(1)             NOT NULL,
    CONSTRAINT pk_encerramento_mes      PRIMARY KEY (mes, exercicio, timestamp),
    CONSTRAINT ck_encerramento_mes_1    CHECK (situacao IN ('A', 'F'))
);
GRANT ALL ON contabilidade.encerramento_mes TO siamweb;


----------------
-- Ticket #19900
----------------

UPDATE administracao.acao           SET ativo = FALSE WHERE cod_acao           = 820;
UPDATE administracao.acao           SET ativo = FALSE WHERE cod_acao           = 821;
UPDATE administracao.funcionalidade SET ativo = FALSE WHERE cod_funcionalidade =  62;


----------------
-- Ticket #19766
----------------

CREATE TABLE contabilidade.plano_conta_geral(
    cod_uf              INTEGER             NOT NULL,
    cod_plano           INTEGER             NOT NULL,
    versao              CHAR(10)            NOT NULL,
    dt_versao           DATE                NOT NULL,
    CONSTRAINT pk_plano_conta_geral         PRIMARY KEY         (cod_uf, cod_plano),
    CONSTRAINT fk_plano_conta_geral_1       FOREIGN KEY         (cod_uf)
                                            REFERENCES sw_uf    (cod_uf)
);
GRANT ALL ON contabilidade.plano_conta_geral TO siamweb;


CREATE TABLE contabilidade.plano_conta_estrutura(
    cod_uf              INTEGER             NOT NULL,
    cod_plano           INTEGER             NOT NULL,
    codigo_estrutural   VARCHAR(25)         NOT NULL,
    titulo              VARCHAR(200)        NOT NULL,
    funcao              TEXT                        ,
    natureza_saldo      CHAR(1)                     ,
    escrituracao        CHAR(1)             NOT NULL,
    natureza_informacao CHAR(1)                     ,
    indicador_superavit CHAR(1)                     ,
    CONSTRAINT pk_plano_conta_estrutura     PRIMARY KEY                                 (cod_uf, cod_plano, codigo_estrutural),
    CONSTRAINT fk_plano_conta_estrutura_1   FOREIGN KEY                                 (cod_uf, cod_plano)
                                            REFERENCES contabilidade.plano_conta_geral  (cod_uf, cod_plano)
);
GRANT ALL ON contabilidade.plano_conta_estrutura TO siamweb;

CREATE TABLE contabilidade.plano_conta_historico(
    cod_uf              INTEGER             NOT NULL,
    cod_plano           INTEGER             NOT NULL,
    timestamp           TIMESTAMP           NOT NULL DEFAULT ('now'::text)::timestamp(3) with time zone,
    exercicio           CHAR(4)             NOT NULL,
    CONSTRAINT pk_plano_conta_historico     PRIMARY KEY                                 (cod_uf, cod_plano, timestamp),
    CONSTRAINT fk_plano_conta_historico_1   FOREIGN KEY                                 (cod_uf, cod_plano)
                                            REFERENCES contabilidade.plano_conta_geral  (cod_uf, cod_plano)
);
GRANT ALL ON contabilidade.plano_conta_historico TO siamweb;

ALTER TABLE orcamento.receita ADD COLUMN credito_tributario BOOLEAN NOT NULL DEFAULT FALSE;

-- CREATE OR REPLACE FUNCTION manutencao() RETURNS VOID AS $$
-- DECLARE
-- BEGIN
--     PERFORM 1
--        FROM pg_trigger
--       WHERE tgname = 'tr_monta_codigo_estrutural'
--           ;
--     IF FOUND THEN
--         DROP TRIGGER tr_monta_codigo_estrutural on contabilidade.plano_conta;
--     END IF;
-- END;
-- $$ LANGUAGE 'plpgsql';
-- SELECT manutencao();
-- DROP FUNCTION manutencao();

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2858
  , 57
  , 'FMManterEscolhaPlanoConta.php'
  , 'incluir'
  , 6
  , ''
  , 'Escolher Plano de Contas'
  , TRUE
  );

INSERT
  INTO administracao.relatorio
  ( cod_gestao
  , cod_modulo
  , cod_relatorio
  , nom_relatorio
  , arquivo )
  VALUES
  ( 2
  , 9
  , 10
  , 'Alteração Plano de Contas'
  , 'alteracaoPlanooConta.rptdesign'
  );

ALTER TABLE almoxarifado.centro_custo_dotacao ADD CONSTRAINT fk_centro_custo_dotacao_2 FOREIGN KEY (cod_despesa, exercicio) REFERENCES orcamento.despesa (cod_despesa, exercicio);

-- PLANO CONTA TCE-RS 2013 v1.0
INSERT INTO contabilidade.plano_conta_geral (cod_uf, cod_plano, versao, dt_versao) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23)+1, 1), '1.0', '2012-07-16');

INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.0.0.0.0.00.00.00.00.00','ATIVO','Compreende os recursos controlados por uma entidade como consequência de eventos passados e dos quais se espera que fluam benefícios econômicos ou potencial de serviços futuros a unidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.0.0.0.00.00.00.00.00','ATIVO CIRCULANTE','Compreende os ativos que atendam a qualquer um dos seguintes critérios: sejam caixa ou equivalente de caixa; sejam realizáveis ou mantidos para venda ou consumo dentro do ciclo operacional da entidade; sejam mantidos primariamente para negociação; sejam realizáveis no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.0.0.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA','Compreende o somatório dos valores em caixa e em bancos, bem como equivalentes, que representam recursos com livre movimentação para aplicação nas operações da entidade e para os quais não haja restrições para uso imediato.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.0.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL','Compreende o somatório dos valores em caixa e em bancos, bem como equivalentes, que representam recursos com livre movimentação para aplicação nas operações da entidade e para os quais não haja restrições para uso imediato. Compreende o somatorio dos valores de caixa e equivalentes de caixa em moeda nacional.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - CONSOLIDAÇÃO','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda nacional. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.01.00.00.00.00','CAIXA','REGISTRA O SOMATORIO DE NUMERARIOS EM ESPECIE E OUTROS VALORES EM TESOURARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.00.00.00.00','CONTA ÚNICA  - RPPS','COMPREENDE O SOMATÓRIO DOS VALORES DISPONÍVEIS NA CONTA ÚNICA DO RPPS, NOS AGENTES FINANCEIROS AUTORIZADOS NO ÂMBITO DO ENTE PÚBLICO. ESSA CONTA DEVERÁ SER DESDOBRADA PELO RPPS NA QUANTIDADE DE AGENTES FINANCEIROS EM QUE MANTENHA CONTA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.01.00.00.00','BANCO CONTA MOVIMENTO - RPPS','REGISTRA A MOVIMENTAÇÃO DE RECURSOS NA CONTA MOVIMENTO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS .','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.02.00.00.00','BANCO CONTA MOVIMENTO - PLANO FINANCEIRO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DO PLANO FINANCEIRO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.03.00.00.00','BANCO CONTA MOVIMENTO - PLANO PREVIDENCIÁRIO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DO PLANO PREVIDENCIÁRIO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.04.00.00.00','BANCO CONTA MOVIMENTO - TAXA DE ADMINISTRAÇÃO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DA TAXA DE ADMINISTRAÇÃO, ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.00.00.00.00','BANCOS CONTA MOVIMENTO - DEMAIS CONTAS','COMPREENDE O SOMATORIO DAS DISPONIBILIDADES EXISTENTES NAS CONTAS BANCARIAS, AGREGADAS PELOS SUBITENS IDENTIFICATIVOS DOS BANCOS CORRESPONDENTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.02.00.00.00','BANCO DO BRASIL','REGISTRA O SOMATORIO DA MOVIMENTAÇÃO FINANCEIRA DAS CONTAS EXISTENTES NA INSTITUIÇÃO FINANCEIRA BANCO DO BRASIL.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.03.00.00.00','CAIXA ECONOMICA FEDERAL','REGISTRA O SOMATORIO DA MOVIMENTAÇÃO FINANCEIRA DAS CONTAS EXISTENTES NA INSTITUIÇÃO FINANCEIRA CAIXA ECONÔMICA FEDERAL.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.12.00.00.00','BANCO DO ESTADO DO RIO GRANDE DO SUL','REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO DO ESTADO DO RIO GRANDE DO SUL.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.99.00.00.00','DEMAIS CONTAS BANCARIAS','REGISTRA AS ARRECADAÇÕES DE RECEITAS DA ENTIDADE E DE OUTROS VALORES DESTA SOB SUA GUARDA OU RESPONSABILIDADE, ESPECIFICAMENTE QUANDO O BANCO NÃO SE ENCONTRA RELACIONADO NAS CONTAS ACIMA.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.30.00.00.00.00','REDE BANCARIA - ARRECADACAO','COMPREENDE O SOMATORIO DOS RECURSOS REFERENTES A RECEITAS ARRECADADAS E NÃO RECOLHIDAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.30.01.00.00.00','ARRECADACAO DIRETA','REGISTRA OS VALORES DAS RECEITAS ARRECADADAS DIRETAMENTE PELA ENTIDADE.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.30.02.00.00.00','ARRECADACAO INDIRETA','REGISTRA OS VALORES DA RECEITA ARRECADADA PELOS AGENTES FINANCEIROS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.00.00.00.00','APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA','COMPREENDE AS APLICAÇÕES FINANCEIRAS DE ALTA LIQUIDEZ EM MOEDA NACIONAL, QUE SÃO PRONTAMENTE CONVERSIVEIS EM VALORES CONHECIDOS DE CAIXA E QUE ESTÃO SUJEITAS A UM INSIGNIFICANTE RISCO DE MUDANCA DE VALOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.05.00.00.00','POUPANCA','REGISTRA O VALOR DAS APLICAÇÕES FINANCEIRAS EM POUPANÇAS E SEUS RENDIMENTOS (JUROS E ATUALIZAÇÃO MONETARIA) POSTERIORES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.06.00.00.00','FUNDO DE APLICACAO FINANCEIRA','REGISTRA O VALOR DAS APLICAÇÕES FINANCEIRAS EM FUNDO DE APLICAÇÃO E SEUS RENDIMENTOS (JUROS E ATUALIZAÇÃO) POSTERIORES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.10.00.00.00','CDB','REGISTRA OS VALORES DAS DISPONIBILIDADES  DAS INSTITUICOES, ENTIDADES OU UNIDADES APLICADAS CERTIFICADOS DE DEPOSITOS BANCARIOS.(CDB)','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.99.00.00.00','OUTRAS APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA','REGISTRA OUTRAS APLICAÇÕES FINANCEIRAS, NÃO CLASSIFICADAS EM ITENS ANTERIORES, DAS DISPONIBILIDADES  FINANCEIRAS DAS ENTIDADES, INSTITUIÇÕES OU UNIDADES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - INTRA OFSS','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda nacional. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.20.00.00.00.00','RECURSOS LIBERADOS PELO TESOURO MUNICIPAL','COMPREENDE OS RECURSOS LIBERADOS PELO TESOURO  MUNICIPAL, PARA ATENDER A DESPESAS DO EXERCICIO E DE EXERCICIO ANTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.20.01.00.00.00','LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO','REGISTRA O VALOR DO LIMITE DE SAQUE DA CONTA UNICA DO ENTE FEDERATIVO, ESTABELECIDO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA, PARA ATENDER  A DESPESAS COM VINCULACAO DE PAGAMENTO.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.20.08.00.00.00','REPASSES A RECEBER','REGISTRA OS RECURSOS A RECEBER REFERENTES AS PARCELAS NAO RECEBIDAS DO ORCAMENTO PELAS ENTIDADES DA ADMINISTRACAO INDIRETA.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.2.0.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda estrangeira.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.2.1.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA - CONSOLIDAÇÃO','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda estrangeira. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.0.0.00.00.00.00.00','CRÉDITOS A CURTO PRAZO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos realizáveis no curso do exercício social subsequente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.0.00.00.00.00.00','CLIENTES','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorram no curso normal das operações da entidade, representando um direito a cobrar de seus clientes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.00.00.00.00.00','CLIENTES- CONSOLIDAÇÃO','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.00.00.00.00','FATURAS/DUPLICATAS A RECEBER','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVIÇOS QUE OCORREM NO CURSO NORMAL DAS OPERAÇÕES DA UNIDADE, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.03.00.00.00','FATURAS/ DUPLICATAS A RECEBER   - ESTOQUE PROPRIO','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS  DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.06.00.00.00','FATURAS/ DUPLICATAS A RECEBER  - PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.80.00.00.00','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.97.00.00.00','(-) DUPLICATAS DESCONTADAS - ESTOQUES PROPRIOS','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS  PROVENIENTES DO FATURAMENTO  DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.02.00.00.00.00','FATURAS/DUPLICATAS A FATURAR','REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.03.00.00.00.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.00.00.00.00.00','CLIENTES-INTRA OFSS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.00.00.00.00','FATURAS/DUPLICATAS A RECEBER','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVIÇOS QUE OCORREM NO CURSO NORMAL DAS OPERAÇÕES DA UNIDADE, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.03.00.00.00','FATURAS/ DUPLICATAS A RECEBER   - ESTOQUE PROPRIO','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS  DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.06.00.00.00','FATURAS/ DUPLICATAS A RECEBER  - PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.80.00.00.00','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.97.00.00.00','(-) DUPLICATAS DESCONTADAS - ESTOQUES PROPRIOS','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS  PROVENIENTES DO FATURAMENTO  DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.02.00.00.00.00','FATURAS/DUPLICATAS A FATURAR','REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.03.00.00.00.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.00.00.00.00.00','CLIENTES - INTER OFSS - UNIÃO','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.01.00.00.00.00','FATURAS/DUPLICATAS A RECEBER','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVIÇOS QUE OCORREM NO CURSO NORMAL DAS OPERAÇÕES DA UNIDADE, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.01.03.00.00.00','FATURAS/ DUPLICATAS A RECEBER   - ESTOQUE PROPRIO','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS  DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.01.06.00.00.00','FATURAS/ DUPLICATAS A RECEBER  - PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.01.80.00.00.00','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.01.97.00.00.00','(-) DUPLICATAS DESCONTADAS - ESTOQUES PROPRIOS','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS  PROVENIENTES DO FATURAMENTO  DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.02.00.00.00.00','FATURAS/DUPLICATAS A FATURAR','REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.03.00.00.00.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.00.00.00.00.00','CLIENTES - INTER OFSS - ESTADO','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.01.00.00.00.00','FATURAS/DUPLICATAS A RECEBER','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.01.03.00.00.00','FATURAS/ DUPLICATAS A RECEBER   - ESTOQUE PROPRIO','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS  DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.01.06.00.00.00','FATURAS/ DUPLICATAS A RECEBER  - PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.01.80.00.00.00','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.01.97.00.00.00','(-) DUPLICATAS DESCONTADAS - ESTOQUES PROPRIOS','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS  PROVENIENTES DO FATURAMENTO  DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.02.00.00.00.00','FATURAS/DUPLICATAS A FATURAR','REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.03.00.00.00.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.00.00.00.00.00','CLIENTES - INTER OFSS - MUNICIPIO','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.01.00.00.00.00','FATURAS/DUPLICATAS A RECEBER','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.01.03.00.00.00','FATURAS/ DUPLICATAS A RECEBER   - ESTOQUE PROPRIO','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS  DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.01.06.00.00.00','FATURAS/ DUPLICATAS A RECEBER  - PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.01.80.00.00.00','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.01.97.00.00.00','(-) DUPLICATAS DESCONTADAS - ESTOQUES PROPRIOS','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS  PROVENIENTES DO FATURAMENTO  DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.02.00.00.00.00','FATURAS/DUPLICATAS A FATURAR','REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.03.00.00.00.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.0.00.00.00.00.00','CREDITOS TRIBUTARIOS A RECEBER','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.0.00.01.00.00.00','CREDITOS TRIBUTARIOS A RECEBER','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.00.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - CONSOLIDAÇÃO','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.01.00.00.00.00','IPTU','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE IPTU A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.02.00.00.00.00','ITBI','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ITBI A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.03.00.00.00.00','ISS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ISS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.04.00.00.00.00','ITR','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ITR A RECEBER - MUNICIPIOS CONVENIADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.05.00.00.00.00','TAXAS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS A RECEBER.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.05.01.00.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.05.02.00.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS PELA PRESTAÇÃO DE SERVIÇOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.06.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE CONTRIBUIÇÃO DE MELHORIA A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.2.00.00.00.00.00','CREDITOS TRIBUTARIOS  A RECEBER - INTRA OFSS','Registra os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.3.00.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - UNIÃO','Registra os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente.  Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.4.00.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - ESTADO','Registra os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente.  Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.5.00.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - MUNICÍPIO','Registra os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente.  Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.0.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - CONSOLIDAÇÃO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.00.00.00.00','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA NÃO PREVIDENCIARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.01.00.00.00','IPTU','REGISTRA OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE IPTU INSCRITOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.02.00.00.00','ITBI','REGISTRA OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE ITBI INSCRITOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.03.00.00.00','ISS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE ISS INSCRITOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.04.00.00.00','ITR','REGISTRA OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE ITR - MUNICIPIOS CONVENIADOS INSCRITOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.05.00.00.00','TAXAS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE TAXAS A RECEBER.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.05.01.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA  A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.05.02.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE TAXAS PELA PRESTAÇÃO DE SERVIÇOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.06.00.00.00','CONTRIBUIÇÃO DE MELHORIA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE CONTRIBUIÇÃO DE MELHORIA A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.02.00.00.00.00','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA  PREVIDENCIARIA.EX: CONTRIBUIÇÃO SOCIAL PARA O RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.2.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - INTRA OFSS','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.2.01.00.00.00.00','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA NÃO PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.2.02.00.00.00.00','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA  PREVIDENCIARIA.EX: CONTRIBUIÇÃO PATRONAL PARA O RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - INTER OFSS - UNIÃO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.01.00.00.00.00','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA NÃO PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.02.00.00.00.00','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA  PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.4.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - INTER OFSS - ESTADO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.4.01.00.00.00.00','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA NÃO PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.4.02.00.00.00.00','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA  PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.5.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - INTER OFSS - MUNICÍPIO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.5.01.00.00.00.00','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA NÃO PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.5.02.00.00.00.00','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA  PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.0.00.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA - CLIENTES','Compreende os valores dos créditos de divida ativa não tributaria inscritos, derivados de clientes, realizáveis no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.1.00.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA - CLIENTES - CONSOLIDAÇÃO','Registra os valores dos créditos de divida ativa não tributaria inscritos, derivados de clientes, realizáveis no curso do exercício social subsequente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.0.00.00.00.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Compreende os valores relativos a créditos a receber oriundos da variação patrimonial aumentativa decorrente de transferências obrigatórias da União, estados, Distrito Federal e municípios.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.3.00.00.00.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - UNIÃO','Compreende os valores relativos a créditos a receber oriundos da variação patrimonial aumentativa decorrente de transferências obrigatórias da União, estados, Distrito Federal e municípios.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.4.00.00.00.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - ESTADO','Compreende os valores relativos a créditos a receber oriundos da variação patrimonial aumentativa decorrente de transferências obrigatórias da União, estados, Distrito Federal e municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.5.00.00.00.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - MUNICÍPIO','Compreende os valores relativos a créditos a receber oriundos da variação patrimonial aumentativa decorrente de transferências obrigatórias da União, estados, Distrito Federal e municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.0.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS- CONSOLIDAÇÃO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.01.00.00.00.00','EMPRESTIMOS CONCEDIDOS A RECEBER','REGISTRA A APROPRIAÇÃO DOS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUIÇÕES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS, COM VENCIMENTOS A CURTO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.02.00.00.00.00','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA A APROPRIAÇÃO DOS VALORES DOS FINANCIAMENTOS, A CURTO  PRAZO, CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUIÇÕES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.04.00.00.00.00','ENCARGOS SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','COMPREENDE OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.04.01.00.00.00','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS  A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.04.03.00.00.00','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.07.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSÃO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.07.01.00.00.00','EMPRÉSTIMOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.07.02.00.00.00','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.3.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - UNIÃO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a união.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.4.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - ESTADO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.5.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - MUNICÍPIO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.0.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO- CONSOLIDAÇÃO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.01.00.00.00.00','(-) AJUSTE DE PERDAS DE CREDITOS DE LIQUIDACAO DUVIDOSA','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANÇA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.02.00.00.00.00','(-) AJUSTE DE PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.03.00.00.00.00','(-) AJUSTE DE PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.04.00.00.00.00','(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NÃO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.05.00.00.00.00','(-)  AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.2.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTRA OFSS','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.2.01.00.00.00.00','(-) AJUSTE DE PERDAS DE CREDITOS DE LIQUIDACAO DUVIDOSA','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANÇA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.2.02.00.00.00.00','(-) AJUSTE PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.2.03.00.00.00.00','(-)  AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.01.00.00.00.00','(-) AJUSTE PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.02.00.00.00.00','(-)  AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.03.00.00.00.00','(-) AJUSTE PARA PERDA DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDA DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.05.00.00.00.00','(-)  AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER PROVENIENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.01.00.00.00.00','(-) AJUSTE PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.02.00.00.00.00','(-)  AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.03.00.00.00.00','(-) AJUSTE PARA PERDA DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDA DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.05.00.00.00.00','(-)  AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER PROVENIENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.01.00.00.00.00','(-) AJUSTE PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.02.00.00.00.00','(-)  AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.03.00.00.00.00','(-) AJUSTE PARA PERDA DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDA DECRÉDITOS DE TRANSFERÊNCIAS A RECEBER.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.05.00.00.00.00','(-)  AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER PROVENIENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.0.0.00.00.00.00.00','DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','Compreende os valores a receber por demais transações realizáveis no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.0.00.00.00.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','Compreende as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.00.00.00.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS - CONSOLIDAÇÃO','Compreende as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.00.00.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL','COMPREENDE OS VALORES DAS ANTECIPAÇÕES CONCEDIDAS A SERVIDORES E A DIRIGENTES DA UNIDADE, TAIS COMO ANTECIPAÇÕES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E DE GRATIFICAÇÕES NATALINAS, ENTRE OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.01.00.00.00','13 SALARIO - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE AO 13º SALARIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.02.00.00.00','1/3 DE FERIAS - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A 1/3 DE FERIAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.05.00.00.00','SALARIOS E ORDENADOS - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A SALARIOS E ORDENADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.99.00.00.00','OUTROS ADIANTAMENTOS CONCEDIDOS A PESSOAL','REGISTRA OUTROS ADIANTAMENTOS CONCEDIDOS A PESSOAL NÃO REGISTRADOS NAS CONTAS ACIMA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.02.00.00.00.00','SUPRIMENTO DE FUNDOS','REGISTRA O ADIANTAMENTO A SERVIDOR PARA DESPESAS SUJEITAS A PRESTAÇÃO DE CONTAS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.05.00.00.00.00','ADIANTAMENTOS A PRESTADORES DE SERVIÇOS','REGISTRA OS VALORES DE ANTECIPAÇÕES CONCEDIDAS A PRESTADORES DE SERVIÇOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVIÇOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.99.00.00.00.00','ADIANTAMENTOS DIVERSOS CONCEDIDOS','REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NÃO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.2.0.00.00.00.00.00','TRIBUTOS A RECUPERAR / COMPENSAR','Compreende o somatório dos valores dos tributos a recuperar/ compensar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.2.1.00.00.00.00.00','TRIBUTOS A RECUPERAR / COMPENSAR - CONSOLIDAÇÃO','Compreende o somatório dos valores dos tributos a recuperar /compensar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.3.0.00.00.00.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Compreende os créditos a receber decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta como por meio de delegação, nas formas de concessão, inclusive parcerias público-privada - PPP, permissão ou autorização ao particular do direito de exploração de serviços públicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.3.1.00.00.00.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS - CONSOLIDAÇÃO','Compreende os créditos a receber decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta, como por meio de delegação, nas formas de concessão, inclusive parcerias público-privada - PPP, permissão ou autorização ao particular do direito de exploração de serviços públicos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.0.00.00.00.00.00','CRÉDITOS POR DANOS AO PATRIMÔNIO','Compreende os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em sindicância, prestação de contas, tomada de contas, processos judiciais e outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.00.00.00.00.00','CRÉDITOS POR DANOS AO PATRIMONIO- CONSOLIDAÇÃO','Compreende os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em sindicância, prestação de contas, tomada de contas, processos judiciais e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.00.00.00.00','CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS','COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.01.00.00.00','CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','REGISTRA O CREDITO DO MUNICIPIO CORRESPONDENTE A DEBITOS ADMINISTRATIVOS  DECORRENTES DE FOLHA DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.02.00.00.00','CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','REGISTRA O CREDITO DO MUNICIPIO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.03.00.00.00','CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','REGISTRA O CREDITO DO MUNICIPIO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.04.00.00.00','CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','REGISTRA O CREDITO DO MUNICIPIO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.05.00.00.00','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NAO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELEIDO EM NORMAS LEGAIS OU DETERMINACAO  ADMINISTRATIVA OU SEJA, QUANDO O PRODUTO A ARRECADAR NAO TENHA SIDO RECOLHIDO NO PRAZO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.06.00.00.00','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.07.00.00.00','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO,  POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (MULTA DE TRANSITO, ETC).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.10.00.00.00','CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS','REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE  CONTAS ESPECIAL).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.99.00.00.00','OUTROS CREDITOS ADMINISTRATIVOS','REGISTRA O CREDITO DO MUNICIPIO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.03.00.00.00.00','CREDITOS POR DANOS AO PATRIMONIO APURADOS EM PROCESSOS JUDICIAIS','REGISTRA OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS JUDICIAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.0.00.00.00.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.00.00.00.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS- CONSOLIDAÇÃO','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.01.00.00.00.00','DEPOSITOS  E CAUCOES RELATIVOS A CONTRATOS OU CONVENÇÕES','REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES, EFETUADOS  POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES  ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.02.00.00.00.00','DEPOSITOS JUDICIAIS','REGISTRA OS VALORES A RECEBER DECORRENTES DE DEPOSITOS EFETUADOS POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.02.01.00.00.00','DEPOSITOS JUDICIAIS - PODER EXECUTIVO/INDIRETAS','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE SENTENÇAS JUDICIAIS DO PODER EXECUTIVO/INDIRETAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.02.02.00.00.00','DEPOSITOS JUDICIAIS - PODER LEGISLATIVO','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE SENTENÇAS JUDICIAIS DO PODER LEGISLATIVO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.02.03.00.00.00','DEPOSITOS JUDICIAIS - RPPS','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE SENTENÇAS JUDICIAIS DO RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.02.04.00.00.00','DEPOSITOS JUDICIAIS DE RESTOS A PAGAR - PODER EXECUTIVO/INDIRETAS','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE DEMANDAS JUDICIAS , DECORRENTES DE VALORES INSCRITOS EM RESTOS A PAGAR NO PODER EXECUTIVO/INDIRETAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.02.05.00.00.00','DEPOSITOS JUDICIAIS DE RESTOS A PAGAR - PODER LEGISLATIVO','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE DEMANDAS JUDICIAS , DECORRENTES DE VALORES INSCRITOS EM RESTOS A PAGAR NO PODER LEGISLATIVO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.02.06.00.00.00','DEPOSITOS JUDICIAIS DE RESTOS A PAGAR - RPPS','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE DEMANDAS JUDICIAS , DECORRENTES DE VALORES INSCRITOS EM RESTOS A PAGAR NO RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.03.00.00.00.00','DEPOSITOS PARA INTERPOSICAO DE RECURSOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS, DECORRENTES DE INTERPOSICAO DE  RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.04.00.00.00.00','DEPOSITOS ESPECIAIS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.99.00.00.00.00','OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS NO CURTO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.6.0.00.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA - DEMAIS CRÉDITOS','Compreende os valores dos créditos de divida ativa não tributaria inscritos, exceto as derivadas de clientes, realizáveis no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.6.1.00.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA - DEMAIS CRÉDITOS - CONSOLIDAÇÃO','Registra os valores dos créditos de divida ativa não tributaria inscritos, exceto as derivadas de clientes, realizáveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.6.1.01.00.00.00.00','NSCRICAO DE CERTIDAO DE DECISAO - TITULO EXECUTIVO DO TCE/RS','REPRESENTA CRÉDITOS DE NATUREZA NÃO-TRIBUTÁRIA EXIGÍVEIS A PARTIR DO RECEBIMENTO, PELA ENTIDADE, DE CERTIDÃO DE DECISÃO - TÍTULO EXECUTIVO, EMITIDA PELO TRIBUNAL DE CONTAS DO ESTADO COM CARACTERÍSTICA DE LIQUIDEZ E CERTEZA, INSCRITOS COMO DÍVIDA ATIVA NÃO-TRIBUTÁRIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.0.00.00.00.00.00','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO','Compreende os outros créditos e valores realizáveis no curto prazo, provenientes de direitos obtidos junto a diversos devedores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.00.00.00.00.00','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os outros créditos e valores realizáveis no curto prazo, provenientes de direitos obtidos junto a diversos devedores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.01.00.00.00.00','ALUGUEIS A RECEBER','REGISTRA OS VALORES A RECEBER DECORRENTES DE CONTRATOS DE ALUGUEL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.02.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS','REGISTRA OS VALORES A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.03.00.00.00.00','VALORES A RECUPERAR DECORRENTES DE INDENIZACOES POR SINISTROS PAGOS','REGISTRA OS VALORES A RECUPERAR REFERENTES A INDENIZACOES PELO PAGAMENTO DE SINISTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.04.00.00.00.00','VALES, TICKETS E BILHETES','REGISTRA O VALOR DE VALES, TICKETS E BILHETES ADQUIRIDOS PARA FUTURA DISTRIBUICAO AOS SERVIDORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.06.00.00.00.00','VALORES EM TRANSITO REALIZAVEIS A CURTO PRAZO','COMPREENDE O SOMATORIO DOS VALORES CONTABILIZADOS INDEVIDAMENTE EM CONTA BANCARIA, GUIA DE RECEBIMENTO E ORDENS BANCARIAS EMITIDAS A COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.07.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE INFRACOES LEGAIS E CONTRATUAIS','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS  DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES  ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.08.00.00.00.00','CREDITOS A RECEBER POR REEMBOLSO DE SALARIO FAMILIA PAGO','REGISTRA OS VALORES RELATIVOS AO SALARIO-FAMILIA, INCLUIDOS EM FOLHAS DE PAGAMENTO, PAGOS AOS EMPREGADOS (CLT), COM FILHOS MENORES, A COMPENSAR COM AS CONTRIBUICOES DEVIDAS PELO EMPREGADOR A PREVIDENCIA SOCIAL.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.09.00.00.00.00','CREDITOS A RECEBER POR REEMBOLSO DE SALARIO MATERNIDADE PAGO','REGISTRA OS SALARIOS PAGOS AS SERVIDORAS GESTANTES, REGIDAS PELA CLT NO PERIODO QUE PERDURAR A LICENCA MATERNIDADE, PREVISTA EM LEI, A DEDUZIR DAS OBRIGACOES SOCIAIS DEVIDAS PELOS ORGAOS E ENTIDADES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.10.00.00.00.00','AUXILIO NATALIDADE PAGO A RECUPERAR','REGISTRA OS VALORES RELATIVOS A AUXILIO NATALIDADE, PAGOS AOS EMPREGADOS REGIDOS PELA CLT, QUANDO DO NASCIMENTO DE FILHOS DESTES, A RECUPERAR, POR SE TRATAR DE OBRIGACOES DA PREVIDENCIA SOCIAL.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.11.00.00.00.00','CREDITOS A RECEBER POR REEMBOLSO DE AUXILIO DOENCA E ACIDENTES PAGOS','REGISTRA OS SALARIOS PAGOS AOS SERVIDORES, REGIDOS PELA CLT, A  TITULO DE AUXILIO DOENCA/ACIDENTES, PREVISTO EM LEI, A SEREM REEMBOLSADOS PELO INSS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.12.00.00.00.00','CREDITOS A RECEBER POR CESSAO DE PESSOAL','REGISTRA OS VALORES DE CREDITOS A RECEBER TAIS COMO: FOLHA DE PAGAMENTO, DESPESA DE TRANSPORTE, ALIMENTACAO E OUTRAS RELATIVAS A CESSAO DE PESSOAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.13.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE CESSAO DE AREAS PUBLICAS','REGISTRA OS VALORES A RECEBER DECORRENTES DA CESSAO DE AREAS PUBLICAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.14.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS OU IMOVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.15.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESAS DE TERCEIROS','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE PAGAMENTOS DE DESPESAS DE TERCEIROS DECORRENTES DE CLAUSULAS CONTRATUAIS, TAIS COMO: AGUA, LUZ, TELEFONE,  INSTALACOES, TRANSPORTE E ALUGUEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.17.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE  FOLHA DE PAGAMENTO','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.27.00.00.00.00','TITULOS A RECEBER','COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.28.00.00.00.00','CREDITOS A RECEBER DE ENTIDADES FEDERAIS','REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ENTIDADES FEDERAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.29.00.00.00.00','CREDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS','REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ESTADOS, DF E MUNICIPIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.99.00.00.00.00','OUTROS CREDITOS A  RECEBER E VALORES A CURTO PRAZO','REGISTRA OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO, PARA OS QUAIS NAO TENHAM CONTAS ESPECIFICAS NESTE SUBGRUPO DE CONTAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.0.00.00.00.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos e valores a curto prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.1.00.00.00.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos e valores a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.1.02.00.00.00.00','(-)  AJUSTE DE PERDAS DE CREDITOS POR DANOS AO PATRIMONIO','COMPREENDE O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS OU APURADOS EM TOMADA DE CONTAS ESPECIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.1.03.00.00.00.00','(-)  AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, EXCETO AS DERIVADAS DE CLIENTES DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.1.99.00.00.00.00','(-) OUTROS AJUSTES DE PERDAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO','REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE  DEMAIS CREDITOS E VALORES A CURTO PRAZO, NAO CLASSIFICADAS ANTERIORMENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.0.0.00.00.00.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A CURTO PRAZO','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo, alem das aplicações temporárias em metais preciosos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.0.00.00.00.00.00','TÍTULOS E VALORES MOBILIÁRIOS','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.00.00.00.00.00','TÍTULOS E VALORES MOBILIARIOS- CONSOLIDAÇÃO','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.03.00.00.00.00','TITULOS PUBLICOS - MERCADO ABERTO','REGISTRA O VALOR RELATIVO A TITULOS PUBLICOS, EMITIDOS E EM CIRCULACAO NO MERCADO ABERTO PARA FINS DE NEGOCIACAO NO MERCADO DE ACOES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.04.00.00.00.00','ACOES','REGISTRA OS VALORES DAS ACOES REPRESENTATIVAS DAS PARTICIPACOES DOS ORGAOS E ENTIDADES NO CAPITAL DAS SOCIEDADES POR ACOES HAVIDAS POR AQUISICOES, SUBSCRICOES, BONIFICACOES E DOACOES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.00.00.00.00','APLICACOES EM SEGMENTO DE RENDA FIXA','APRESENTAR O SOMATÓRIO DOS INVESTIMENTOS REALIZADOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, DA RESOLUÇÃO CMN N° 3.922/2010.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.01.00.00.00','TITULOS DE RESPONSABILIDADE DO TESOURO','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM TÍTULOS DE EMISSÃO DO TESOURO NACIONAL, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO I, ALÍNEA "A"(INCLUÍ OPERAÇÕES COMPROMISSADAS) DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.02.00.00.00','TITULOS DE RESPONSABILIDADE DO BANCO CENTRAL','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM TITULOS DE EMISSAO DO BANCO CENTRAL DO BRASIL; SALDOS REMANESCENTES PARA RESGATES,   CONSIDERANDO QUE O BC NAO EMITE MAIS TITULOS DA DIVIDA PUBLICA- ART 34 LC 101/2000.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.03.00.00.00','POUPANÇA','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM POUPANÇA, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO III, DA RESOLUÇÃO CMN N° 3.506/2007','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.04.00.00.00','FUNDOS DE INVESTIMENTO EM RENDA FIXA','APRESENTAR OS INVESTIMENTOS REALIZADOS PELOS RPPS, EM FUNDOS DE INVESTIMENTOS EM RENDA FIXA, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO IV,  DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.05.00.00.00','FUNDOS DE INVESTIMENTOS EM RENDA FIXA - CRÉDITO PRIVADO','APRESENTAR OS INVESTIMENTOS REALIZADOS PELOS RPPS, EM FUNDOS DE INVESTIMENTOS EM RENDA FIXA - CRÉDITO PRIVADO, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO V, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.06.00.00.00','FUNDOS DE INVESTIMENTOS REFERENCIADOS','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM  FUNDOS DE INVESTIMENTOS REFERENCIADOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO III, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.07.00.00.00','FUNDOS DE INVESTIMENTOS EM DIREITOS CREDITORIOS','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM  FUNDOS DE INVESTIMENTOS EM DIREITO CREDITÓRIO, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO VI E ALÍNEA "A" DO INCISO VII, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.08.00.00.00','FUNDOS DE INVESTIMENTOS EM TITULOS DO TESOURO','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM  FUNDOS DE INVESTIMENTOS EM TÍTULOS DO TESOURO, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO I, ALÍNEA"B",  DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.09.00.00.00','OPERACOES COMPROMISSADAS','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM  OPERAÇÕES COMPROMISSADAS, EFETUADOS EM CONFORMIDADE COM O ART.  7º , INCISO II, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.00.00.00.00','APLICACOES EM SEGMENTO DE RENDA VARIAVEL','APRESENTAR O SOMATÓRIO DOS INVESTIMENTOS REALIZADOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, DA RESOLUÇÃO CMN N° 3.922/2010.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.01.00.00.00','FUNDOS DE AÇÕES REFERENCIADOS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE AÇÕES REFERENCIADOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO III, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.02.00.00.00','FUNDOS DE ACOES','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE AÇÕES, EFETUADOS EM CONFORMIDADE COM O ART. 8º, INCISO III, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.03.00.00.00','FUNDO MULTIMERCADO','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE MULTIMERCADO, EFETUADOS EM CONFORMIDADE COM O ART. 8º, INCISO IV, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.04.00.00.00','FUNDOS DE INDICES REFERENCIADOS EM ACOES','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM  FUNDOS DE ÍNDICES REFERENCIADOS EM AÇÕES, EFETUADOS EM CONFORMIDADE COM O ART. 8º, INCISO II, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.05.00.00.00','FUNDOS DE INVESTIMENTOS EM PARTICIPACOES','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM  FUNDOS DE INVESTIMENTOS EM PARTICIPAÇÕES, EFETUADOS EM CONFORMIDADE COM O ART. 8º, INCISO V, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.06.00.00.00','FUNDO DE INVESTIMENTOS IMOBILIÁRIOS','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE INVESTIMENTOS IMOBILIÁRIOS, EFETUADOS EM CONFORMIDADE COM O ART. 8º, INCISO VI, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.11.00.00.00.00','APLICAÇÕES EM SEGMENTO IMOBILIÁRIO','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, NO SEGMENTO DE IMÓVEIS EFETUADOS EM CONFORMIDADE COM O ART. 8º DA RESOLUCAO CMN N° 3.790/2009.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.11.01.00.00.00','FUNDOS DE INVESTIMENTOS IMOBILIÁRIOS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, NO SEGMENTO DE IMÓVEIS','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.12.00.00.00.00','APLICAÇÕES EM ENQUADRAMENTO','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM DESACORDO COM AS REGRAS ESTABELECIDAS PELA RESOLUCAO CMN Nº 3790/2009, ARTIGO 25.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.12.01.00.00.00','TÍTULOS E VALORES EM ENQUADRAMENTO','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM DESACORDO COM AS REGRAS ESTABELECIDAS PELA RESOLUCAO CMN Nº 3790/2009, ARTIGO 25.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.13.00.00.00.00','TITULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM ATIVOS NÃO SUJEITOS ÀS REGRAS DA RESOLUÇÃO CMN Nº 3922/2010.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.13.01.00.00.00','TITULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM ATIVOS NÃO SUJEITOS ÀS REGRAS DA RESOLUÇÃO CMN Nº 3922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.14.00.00.00.00','APLICACOES COM A TAXA DE ADMINISTRACAO DO RPPS','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, COM RECURSOS DA TAXA DE ADMINISTRAÇÃO, SUJEITOS ÀS REGRAS DA RESOLUÇÃO CMN Nº 3922/2010.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.14.01.00.00.00','APLICACOES COM A TAXA DE ADMINISTRACAO DO RPPS','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, COM RECURSOS DA TAXA DE ADMINISTRAÇÃO, SUJEITOS ÀS REGRAS DA RESOLUÇÃO CMN Nº 3922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.2.0.00.00.00.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','Compreende as aplicações de recursos em metais preciosos, não destinados a negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.2.1.00.00.00.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS- CONSOLIDAÇÃO','Compreende as aplicações de recursos em metais preciosos, não destinados a negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.9.0.00.00.00.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.9.1.00.00.00.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS - CONSOLIDAÇÃO','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.9.1.01.00.00.00.00','(-) AJUSTES DE PERDAS COM TÍTULOS E VALORES MOBILIÁRIOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS EM TITULOS E VALORES MOBILIARIOS A CURTO PRAZO. INCLUSIVE OS VALORES DE AJUSTES PARA PERDAS EM APLICAÇÕES DA CARTEIRA DO RPPS E EM INVESTIMENTOS COM RECURSOS DA TAXA DE ADMINISTRAÇÃO DO RPPS, SUJEITOS ÀS REGRAS DA RESOLUÇÃO DO CMN Nº 3922/2010.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.9.1.02.00.00.00.00','(-) AJUSTES PARA PERDAS EM APLICACOES TEMPORARIAS EM METAIS PRECIOSOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS EM APLICACOES EM OURO E OUTROS METAIS PRECIOSOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.0.0.00.00.00.00.00','ESTOQUES','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.1.0.00.00.00.00.00','MERCADORIAS PARA REVENDA','Compreende todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.1.1.00.00.00.00.00','MERCADORIAS PARA REVENDA - CONSOLIDAÇÃO','Compreende todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.1.1.01.00.00.00.00','MERCADORIAS - ESTOQUES PROGRAMAS PRÓPRIOS','COMPREENDE O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA, RELATIVAS A PROGRAMAS PRÓPRIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.1.1.01.01.00.00.00','MERCADORIAS PARA VENDA OU REVENDA','REGISTRA O VALOR DAS MERCADORIAS PARA VENDA OU REVENDA E DOAÇÕES RELATIVAS A ESTOQUES DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.2.0.00.00.00.00.00','PRODUTOS E SERVIÇOS ACABADOS','Compreende os produtos já terminados e oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.2.1.00.00.00.00.00','PRODUTOS E SERVIÇOS ACABADOS - CONSOLIDAÇÃO','Compreende os produtos já terminados oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.2.1.01.00.00.00.00','PRODUTOS ACABADOS','REGISTRA O VALOR DE PRODUTOS MANUFATURADOS JA TERMINADOS, ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPÓSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.2.1.02.00.00.00.00','SERVIÇOS ACABADOS','REGISTRA OS VALORES PERTINENTES A SERVIÇOS ACABADOS QUE ESTAO PENDENTES DE FATURAMENTO OU DE TRANSFERENCIA PARA OUTRAS CONTAS DO ATIVO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.3.0.00.00.00.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','Compreende os produtos e serviços em andamento não concluídos na data do balanço.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.3.1.00.00.00.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO - CONSOLIDAÇÃO','Compreende os produtos e serviços em andamento não concluídos na data do balanço. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.3.1.01.00.00.00.00','PRODUTOS EM ELABORAÇÃO','REGISTRA A TOTALIDADE DAS MATÉRIAS-PRIMAS  JA REQUISITADAS QUE ESTAO EM PROCESSO DE TRANSFORMACAO E O MONTANTE DE CUSTOS DIRETOS E INDIRETOS RELATIVOS AOS PRODUTOS EM ELABORACAO  NÃO CONCLUIDOS NA DATA DO BALANCO PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.3.1.02.00.00.00.00','SERVIÇOS EM ELABORAÇÃO','REGISTRA OS CUSTOS DIRETOS E INDIRETOS RELATIVOS AOS SERVIÇOS EM ELABORACAO NÃO CONCLUIDOS NA DATA DO BALANCO PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.4.0.00.00.00.00.00','MATÉRIAS-PRIMAS','Compreende o estoque de matérias-primas, que será utilizado no processo produtivo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.4.1.00.00.00.00.00','MATÉRIAS-PRIMAS - CONSOLIDAÇÃO','Compreende o estoque de matérias-primas, que será utilizado no processo produtivo.. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.4.1.01.00.00.00.00','MATÉRIAS-PRIMAS - ARMAZENS PRÓPRIOS','REGISTRA O ESTOQUE DE MATÉRIAS-PRIMAS QUE SERAO UTILIZADOS NO PROCESSO PRODUTIVO, GUARDADAS EM ARMAZENS PRÓPRIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.5.0.00.00.00.00.00','MATÉRIAIS EM TRANSITO','Compreende o valor dos materiais em processo de transferência para outras unidades da entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.5.1.00.00.00.00.00','MATÉRIAIS EM TRANSITO - CONSOLIDAÇÃO','Compreende o valor dos materiais em processo de transferência para outras unidades da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.0.00.00.00.00.00','ALMOXARIFADO','Compreende o valor dos materiais destinados ao consumo interno da unidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.00.00.00.00.00','ALMOXARIFADO - CONSOLIDAÇÃO','Compreende o valor dos materiais destinados ao consumo interno da unidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.01.00.00.00.00','MATERIAL DE CONSUMO','REGISTRAR OS VALORES DOS MATERIAIS DE CONSUMO ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AS NECESSIDADES DA INSTITUIÇÃO E DE OUTRAS UNIDADES','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.02.00.00.00.00','GENEROS ALIMENTICIOS','REGISTRA OS VALORES DOS GENEROS ALIMENTICIOS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AS NECESSIDADES DA ENTIDADE  E DE OUTRAS UNIDADES DESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.03.00.00.00.00','MATERIAIS DE CONSTRUCAO','REGISTRA OS VALORES DOS MATERIAIS DE CONSTRUCAO ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE  E DE OUTRAS UNIDADES DESSA..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.05.00.00.00.00','AUTOPECAS','REGISTRA OS VALORES DE AUTOPECAS ADQUIRIDAS E ESTOCADAS EM ALMOXARIFADOS, DESTINADAS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.06.00.00.00.00','MEDICAMENTOS E MATERIAIS HOSPITALARES','REGISTRA OS VALORES DOS MEDICAMENTOS E MATERIAS HOSPITALARES ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.07.00.00.00.00','MATERIAIS GRAFICOS','REGISTRA OS VALORES DOS MATERIAIS GRAFICOS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.08.00.00.00.00','MATERIAL DE EXPEDIENTE','REGISTRA OS VALORES DOS MATERIAIS DE EXPEDIENTE ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.09.00.00.00.00','MATERIAIS A CLASSIFICAR','REGISTRA OS VALORES DOS MATERIAIS ESTOCADOS PENDENTES DE CLASSIFICACAO E IDENTIFICACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.10.00.00.00.00','ESTOQUE SOBRESSALENTES A ALIENAR','REGISTRA OS VALORES DE BENS SOBRESSALENTES QUE ESTEJAM DISPONIVEIS PARA ALIENACAO SOB DIVERSAS FORMAS (VENDA, LEILÃO, ETC).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.99.00.00.00.00','OUTROS ALMOXARIFIDOS','REGISTRA OS VALORES DOS OUTROS ALMOXARIFADOS ADQUIRIDOS E ESTOCADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.7.0.00.00.00.00.00','ADIANTAMENTOS A FORNECEDORES','Compreende os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.00.00.00.00.00','ADIANTAMENTOS A FORNECEDORES - CONSOLIDAÇÃO','Registra os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.0.00.00.00.00.00','OUTROS ESTOQUES','Compreende o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.00.00.00.00.00','OUTROS ESTOQUES - CONSOLIDAÇÃO','Compreende o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.01.00.00.00.00','MATERIAIS DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA OS VALORES DE ESTOQUE QUE SE DESTINAM A EMBALAGEM DO PRODUTO OU A SEU ACONDICIONAMENTO PARA REMESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.02.00.00.00.00','ESTOQUES PARA DISTRIBUIÇÃO','COMPREENDE O VALOR DO MATERIAL EM ESTOQUE, DESTINADO A DISTRIBUICAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.02.01.00.00.00','MATERIAL DE CONSUMO - ESTOQUE INTERNO - DESTINADO A DISTRIBUIÇÃO','REGISTRA OS VALORES RELATIVOS AS AQUISICOES E OU TRANSFERENCIAS DE MATERIAIS DE CONSUMO PARA A FORMACAO DE ESTOQUE INTERNO DESTINADO A DISTRIBUICAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.02.03.00.00.00','MEDICAMENTOS - ESTOQUE INTERNO - DESTINADO A DISTRIBUIÇÃO','REGISTRA OS VALORES DOS MEDICAMENTOS E OUTROS PRODUTOS FARMACEUTICOS, ADQUIRIDOS OU FABRICADOS PELA UNIDADE,  DESTINADOS A FORMACAO DE ESTOQUE DE DISTRIBUICAO PARA CONSUMO INTERNO OU REDISTRIBUICAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.02.05.00.00.00','ESTOQUE DE MATERIAIS PARA PREMIAÇÕES','REGISTRA OS VALORES DAS PREMIAÇÕES COMO: MEDALHAS E PLACAS DESTINADOS A FORMACAO DE ESTOQUE DE DISTRIBUICAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.03.00.00.00.00','ESTOQUES PARA DOAÇÃO E/OU PERMUTA','COMPREENDE O VALOR DAS MERCADORIAS EM ESTOQUES PARA DOACAO E/OU PERMUTA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.04.00.00.00.00','ESTOQUES DE PRODUTOS PARA PESQUISA E ENSINO','COMPREENDE O VALOR DO MATERIAL EM ESTOQUE, RELATIVO A ANIMAL, VEGETAL OU MINERAL, DESTINADO A PESQUISA E ENSINO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.05.00.00.00.00','IMPORTAÇÕES EM ANDAMENTO','COMPREENDE O VALOR DAS IMPORTAÇÕES EM ANDAMENTO DE BENS DE ESTOQUE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.05.01.00.00.00','IMPORTAÇÕES EM ANDAMENTO DO EXERCÍCIO','REGISTRA O VALOR DAS IMPORTAÇÕES EM ANDAMENTO DE BENS DE ESTOQUE, DURANTE O EXERCICIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.05.02.00.00.00','IMPORTAÇÕES EM ANDAMENTO DE EXERCÍCIOS ANTERIORES','REGISTRA O VALOR DAS IMPORTAÇÕES EM ANDAMENTO DE BENS DE ESTOQUE, INICIADAS EM EXERCICIOS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.06.00.00.00.00','CONSTRUÇÕES CIVIS','COMPREENDE OS VALORES DOS IMOVEIS QUE DEVAM SER COLOCADOS A VENDA OU QUE TENHAM SIDO ADQUIRIDOS PARA VENDA OU REVENDA, PODENDO A COMERCIALIZACAO SER OU NÃO OBJETO PRINCIPAL DA EMPRESA, ENTIDADE, INSTITUICAO OU ORGAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.06.01.00.00.00','TERRENOS','REGISTRA OS VALORES DE TERRENOS, INCLUINDO-SE OS CUSTOS DE FORMACAO OU DE URBANIZACAO E AJUSTES MONETARIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.06.02.00.00.00','PROJETOS','REGISTRA OS VALORES DOS CUSTOS RELATIVOS AOS PROJETOS   DE ARQUITETURA E URBANISMO PARA CONSTRUCOES E URBANIZAÇÕES DE IMOVEIS QUE DEVERAO SER COLOCADOS A VENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.06.03.00.00.00','OBRAS EM ANDAMENTO','REGISTRA OS VALORES RELATIVOS A OBRAS EM ANDAMENTO, DESTINADAS A VENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.06.04.00.00.00','OBRAS CONCLUÍDAS A COMERCIALIZAR','REGISTRA OS VALORES RELATIVOS AS CONSTRUCOES E AS EDIFICAÇÕES CONCLUÍDAS QUE DEVERAO SER COLOCADAS A VENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.06.05.00.00.00','CUSTOS ACESSÓRIOS DE CONSTRUÇÃO CIVIL','REGISTRA OS VALORES DE SEGUROS, REMUNERAÇÕES A AGENTES FINANCEIROS, IMPOSTOS E TAXAS, DESPESAS COM LEGALIZAÇÕES E CARTORARIAS RELATIVOS A IMOVEIS DESTINADOS A VENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.98.00.00.00.00','ESTOQUES DIVERSOS','REGISTRA OS ESTOQUES NÃO CLASSIFICAVEIS NAS DEMAIS CONTAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.9.0.00.00.00.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES','Compreende o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro do ajuste  de perdas para os estoque que tiverem o valor de mercado inferior ao seu custo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.9.1.00.00.00.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','Compreende o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro do ajuste  de perdas para os estoque que tiverem o valor de mercado inferior ao seu custo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.9.1.01.00.00.00.00','(-) AJUSTE  PARA PERDAS EM ESTOQUES','REGISTRA AS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NÃO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NÃO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.9.1.02.00.00.00.00','(-) AJUSTE PARA REDUÇÃO AO VALOR DE MERCADO','REGISTRA O AJUSTE PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.0.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço a entidade ocorrerão no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.1.0.00.00.00.00.00','PRÊMIOS DE SEGUROS A APROPRIAR','Compreende os valores pagos a titulo de prêmios de seguro a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.1.1.00.00.00.00.00','PRÊMIOS DE SEGUROS A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de prêmios de seguro a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.2.0.00.00.00.00.00','VPD FINANCEIRAS A APROPRIAR','Compreende os valores pagos, a título de VPD financeiras a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.2.1.00.00.00.00.00','VPD FINANCEIRAS A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos, a título de VPD financeiras a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.3.0.00.00.00.00.00','ASSINATURAS E ANUIDADES A APROPRIAR','Compreende os valores pagos a titulo de assinaturas e anuidades a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.3.1.00.00.00.00.00','ASSINATURAS E ANUIDADES A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de assinaturas e anuidades a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.4.0.00.00.00.00.00','ALUGUEIS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de aluguel a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.4.1.00.00.00.00.00','ALUGUEIS PAGOS A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de aluguel a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.5.0.00.00.00.00.00','TRIBUTOS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de tributos a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.5.1.00.00.00.00.00','TRIBUTOS PAGOS A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de tributos a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.6.0.00.00.00.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','Compreende os valores pagos a titulo de contribuições confederativas a apropriar','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.6.1.00.00.00.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de contribuições confederativas a apropriar.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.7.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL A APROPRIAR','Compreende os valores pagos a titulo de beneficio a pessoal a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.7.1.00.00.00.00.00','BENEFÍCIOS A PESSOAL A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de beneficio a pessoal a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.8.0.00.00.00.00.00','DEMAIS VPD A APROPRIAR','Compreende os demais valores pagos a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.8.1.00.00.00.00.00','DEMAIS VPD A APROPRIAR - CONSOLIDAÇÃO','Compreende os demais valores pagos a apropriar.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.0.0.0.00.00.00.00.00','ATIVO NÃO CIRCULANTE','Compreende o ativo não circulante: o ativo realizável a longo prazo, os investimentos, o imobilizado e o intangível.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.0.0.00.00.00.00.00','ATIVO REALIZÁVEL A LONGO PRAZO','Compreende os bens, direitos e despesas antecipadas realizáveis no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.0.00.00.00.00.00','CRÉDITOS A LONGO PRAZO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos e com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.01.00.00.00.00','CLIENTES','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.01.03.00.00.00','FATURAS/DUPLICATAS A RECEBER - PRODUTOS/MERCADORIAS','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.01.06.00.00.00','FATURAS/DUPLICATAS A RECEBER - PRESTAÇÃO DE SERVIÇOS','REGISTRA A  APROPRIAÇÃO E MOVIMENTAÇÃO DOS FATURAMENTOS, A CURTO PRAZO,  PROVENIENTES DE VENDAS DE PRODUTOS DO ESTOQUE','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.01.99.00.00.00','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NÃO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.02.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento no longo prazo, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.01.00.00.00','CREDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','COMPREENDE OS CREDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.01.01.00.00','CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.01.01.01.00','CREDITOS A ENCAMINHAR PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITOS A SEREM ENCAMINHADOS PELAS UG PARA  INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.01.01.02.00','CREDITOS  ENCAMINHADOS PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS ENCAMINHADOS PELAS UG, PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.01.02.00.00','CREDITOS INSCRITOS EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS  CONTRA TERCEIROS  PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS  LANCADOS NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO DE ORIGEM QUE CONSTITUIREM EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.02.00.00.00','CREDITOS PREVIDENCIÁRIOS INSCRITOS','COMPREENDE OS CREDITOS PREVIDENCIÁRIOS INSCRITOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.02.01.00.00','CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.02.01.01.00','CREDITOS A ENCAMINHAR PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITOS A SEREM ENCAMINHADOS PELAS UG PARA  INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.02.01.02.00','CREDITOS  ENCAMINHADOS PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS ENCAMINHADOS PELAS UG, PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.02.02.00.00','CREDITOS INSCRITOS EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS  CONTRA TERCEIROS  PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS  LANCADOS NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO DE ORIGEM QUE CONSTITUIREM EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA - CLIENTES','Registra os valores dos créditos de divida ativa não tributaria derivados de clientes, em processo de inscrição e já inscritos, realizáveis no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.00.00.00','CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.01.00.00','CREDITOS A ENCAMINHAR PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITOS A SEREM ENCAMINHADOS PELAS UG PARA  INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.02.00.00','CREDITOS  ENCAMINHADOS PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS ENCAMINHADOS PELAS UG, PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.02.00.00.00','CREDITOS INSCRITOS EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS  CONTRA TERCEIROS  NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO DE ORIGEM QUE CONSTITUIREM EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.01.00.00.00','EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELO MUNICIPIO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.02.00.00.00','EMPRÉSTIMOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A EMPRÉSTIMOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL, REALIZÁVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.03.00.00.00','EMPRESTIMOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS  CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS  OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.06.00.00.00','ENCARGOS  SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.08.00.00.00','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES RELATIVOS AOS FINANCIAMENTOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES MUNICIPAIS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.08.01.00.00','FINANCIAMENTOS HABITACIONAIS','REPRESENTA O VALOR DOS CRÉDITOS DEVIDOS A ENTIDADES MUNICIPAIS  DECORRENTES DE FINANCIAMENTOS HABITACIONAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.10.00.00.00','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL, REALIZÁVEIS  APOS O TERMINO DO EXERCICIO SEGUINTE (EXEMPLO: FINANCIAMENTOS IMOBILIÁRIOS)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.11.00.00.00','FINANCIAMENTOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS AOS FINANCIAMENTOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES MUNICIPAIS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.12.00.00.00','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER','REGISTRA O VALOR  DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS. JUROS PRO-RATA SAO AQUELES DEFINIDOS  POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.18.00.00.00','RESIDUO DE EMPRESTIMOS CONCEDIDOS','REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM LONGO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.99.00.00.00','OUTROS EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.01.00.00.00','(-) AJUSTE DE PERDAS  PARA CREDITOS DE LIQUIDACAO DUVIDOSA','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.02.00.00.00','(-) AJUSTE PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.03.00.00.00','(-) AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS NA DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.04.00.00.00','(-) AJUSTE DE PERDAS  DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.05.00.00.00','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - INTRA OFSS','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.02.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento após término exercício seguinte, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.03.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.03.01.00.00.00','CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.03.01.01.00.00','CREDITOS A ENCAMINHAR PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITOS A SEREM ENCAMINHADOS PELAS UG PARA  INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.03.01.02.00.00','CREDITOS  ENCAMINHADOS PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS ENCAMINHADOS PELAS UG, PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.03.02.00.00.00','CREDITOS INSCRITOS EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS  CONTRA TERCEIROS  PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS  LANCADOS NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO DE ORIGEM QUE CONSTITUIREM EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.01.00.00.00','EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELO MUNICIPIO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.02.00.00.00','EMPRÉSTIMOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A EMPRÉSTIMOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL, REALIZÁVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.03.00.00.00','EMPRESTIMOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS  CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS  OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.06.00.00.00','ENCARGOS  SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.08.00.00.00','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES RELATIVOS AOS FINANCIAMENTOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES MUNICIPAIS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.10.00.00.00','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL, REALIZÁVEIS  APOS O TERMINO DO EXERCICIO SEGUINTE (EXEMPLO: FINANCIAMENTOS IMOBILIÁRIOS)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.11.00.00.00','FINANCIAMENTOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS A FINANCIAMENTOS  CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS  OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.12.00.00.00','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER','REGISTRA O VALOR  DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS. JUROS PRO-RATA SAO AQUELES DEFINIDOS  POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.18.00.00.00','RESIDUO DE EMPRESTIMOS CONCEDIDOS','REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM LONGO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.99.00.00.00','OUTROS EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende  os ajustes de perdas estimadas com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.99.02.00.00.00','(-) AJUSTE  PARA PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE  PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.99.03.00.00.00','(-) AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES O AJUSTE  PARA PERDAS PARA A DIVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.99.05.00.00.00','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.02.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento após término exercício seguinte, oriundos daw variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.03.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.03.01.00.00.00','CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.03.01.01.00.00','CREDITOS A ENCAMINHAR PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITOS A SEREM ENCAMINHADOS PELAS UG PARA  INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.03.01.02.00.00','CREDITOS  ENCAMINHADOS PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS ENCAMINHADOS PELAS UG, PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.03.02.00.00.00','CREDITOS INSCRITOS EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS  CONTRA TERCEIROS  PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS  LANCADOS NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO DE ORIGEM QUE CONSTITUIREM EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.05.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.05.01.00.00.00','EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS CRÉDITOS POR EMPRÉSTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.05.03.00.00.00','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.05.99.00.00.00','OUTROS EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS - INTER OFSS - UNIÃO','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende  os ajustes de perdas estimadas com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.99.02.00.00.00','(-) AJUSTE PARA PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE  PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.99.03.00.00.00','(-) AJUSTE  PARA PERDAS DE DIVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE  PARA PERDAS PARA A DIVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.99.05.00.00.00','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.02.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento no longo prazo, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.03.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.05.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende os ajustes de perdas estimadas s com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.99.02.00.00.00','(-) AJUSTE PARA PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE  PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.99.03.00.00.00','(-) AJUSTE  PARA PERDAS DE DIVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE  PARA PERDAS PARA A DIVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.99.05.00.00.00','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.02.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento no longo prazo, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.03.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.05.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende os ajustes de perdas estimadas s com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.99.02.00.00.00','(-) AJUSTE PARA PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE  PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.99.03.00.00.00','(-) AJUSTE  PARA PERDAS DE DIVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE  PARA PERDAS PARA A DIVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.99.05.00.00.00','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.0.00.00.00.00.00','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','Compreende os valores a receber por demais transações, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.00.00.00.00.00','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os valores a receber por demais transações, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.01.00.00.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','Compreende as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.02.00.00.00.00','TRIBUTOS A RECUPERAR / COMPENSAR','Compreende o somatório dos valores dos tributos a recuperar / compensar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.03.00.00.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Compreende os créditos a receber com realização após os doze meses seguintes a data de públicação das demonstrações contábeis, decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta como por meio de delegação, nas formas de concessão, permissão ou autorização ao particular do direito de exploração de serviços públicos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.00.00.00.00','CRÉDITOS POR DANOS AO PATRIMÔNIO PROVENIENTES DE CRÉDITOS ADMINISTRATIVOS','Compreende os valores realizáveis após os doze meses seguintes a data de públicação das demonstrações contábeis, provenientes de direitos oriundos de danos ao patrimônio, apurados em processos administrativos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.01.00.00.00','CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','REGISTRA O CREDITO DO ENTE CORRESPONDENTE A DEBITOS ADMINISTRATIVOS  DECORRENTES DE FOLHA DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.02.00.00.00','CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','REGISTRA O CREDITO DO ENTE CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.03.00.00.00','CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','REGISTRA O CREDITO DO ENTE CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.04.00.00.00','CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','REGISTRA O CREDITO DO ENTE CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.05.00.00.00','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NAO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU DETERMINACAO  ADMINISTRATIVA OU SEJA, QUANDO O PRODUTO A ARRECADAR NAO TENHA SIDO RECOLHIDO NO PRAZO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.06.00.00.00','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.07.00.00.00','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO,  POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.10.00.00.00','CRÉDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFÍCIOS PREVIDENCIÁRIOS','REGISTRA O CRÉDITO A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFÍCIOS PREVIDENCIÁRIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.99.00.00.00','OUTROS CREDITOS ADMINISTRATIVOS','REGISTRA O CREDITO DO ENTE CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.00.00.00.00','CRÉDITOS POR DANOS AO PATRIMÔNIO APURADOS EM TOMADA DE CONTAS ESPECIAL','Compreende os valores realizáveis após os doze meses seguintes a data de públicação das demonstrações contábeis, provenientes de direitos oriundos de danos ao patrimônio, apurados em tomada de contas especial.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.01.00.00.00','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS  RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE,  INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.02.00.00.00','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL  - TOMADA DE CONTAS ESPECIAL','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES, NAO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU DETERMIMANACAO  ADMINISTRATIVA, OU SEJA, QUANDO O PRODUTO A ARRECADAR NAO TENHA SIDO RECOLHIDO NO PRAZO LEGAL..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.03.00.00.00','CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS  - TOMADA DE CONTAS ESPECIAL','REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DO MUNICIPIO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.04.00.00.00','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.05.00.00.00','CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS A FAZENDA PUBLICA SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.06.00.00.00','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO  - TOMADA DE CONTAS ESPECIAL','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS  COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.07.00.00.00','CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS  - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.08.00.00.00','CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO  - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTA','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.09.00.00.00','CREDITOS  A RECEBER DECORRENTES DE FALTA DE LICITACAO  - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A   NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR  DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA  RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.10.00.00.00','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO,  POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE .','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.11.00.00.00','CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS  - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO  OU  PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO:  PARTE  DO  EMPREGADOR  DE OBRIGAÇÕES PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E  NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM O ENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.13.00.00.00','CREDITOS  A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE   - TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS  RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.99.00.00.00','OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO  ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.00.00.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis após os doze meses seguintes a data de públicação das demonstrações contábeis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.01.00.00.00','DEPOSITOS  E CAUCOES RELATIVOS A CONTRATOS OU CONVENCOES','REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES, EFETUADOS  POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES  ESPECIFICAS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.02.00.00.00','DEPOSITOS JUDICIAIS','REGISTRA OS VALORES A RECEBER DECORRENTES DE DEPOSITOS EFETUADOS POR DETERMINACAO JUDICIAL, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.03.00.00.00','DEPOSITOS PARA INTERPOSICAO DE RECURSOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS, DECORRENTES DE INTERPOSICAO DE  RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.04.00.00.00','DEPOSITOS ESPECIAIS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.05.00.00.00','VALORES  APREENDIDOS POR DECISAO JUDICIAL','REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.99.00.00.00','OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.07.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA - DEMAIS CRÉDITOS','Registra os valores dos créditos de divida ativa não tributaria, exceto as derivadas de clientes, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de públicação dos demonstrativos contábeis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.07.01.00.00.00','INSCRICAO DE CERTIDAO DE DECISAO - TITULO EXECUTIVO DO TCE/RS','REPRESENTA CRÉDITOS DE NATUREZA NÃO-TRIBUTÁRIA EXIGÍVEIS A PARTIR DO RECEBIMENTO, PELA ENTIDADE, DE CERTIDÃO DE DECISÃO - TÍTULO EXECUTIVO, EMITIDA PELO TRIBUNAL DE CONTAS DO ESTADO COM CARACTERÍSTICA DE LIQUIDEZ E CERTEZA, PODENDO SER, FACULTATIVAMENTE INSCRITA COMO DIVIDA ATIVA NÃO TRIBUTARIA','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.00.00.00.00','OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO','Compreende os outros créditos e valores realizáveis após os doze meses seguintes a data da publicação das demonstrações contábeis, provenientes de direitos obtidos junto a diversos devedores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.01.00.00.00','CRÉDITOS A RECEBER DE ENTIDADES FEDERAIS','REGISTRA OS VALORES REALIZÁVEIS APOS O TERMINO DO EXERCICIO SEGUINTE DECORRENTES DE DEBITO DE ENTIDADES FEDERAIS COM A UNIAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.03.00.00.00','CREDITOS ORIUNDOS DE CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS','REGISTRA O VALOR DOS CREDITOS ORIUNDOS DAS CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS DO ENTE, PARA TERCEIROS OU PARA OUTRAS ENTIDADES GOVERNAMENTAIS, REALIZAVEIS A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.04.00.00.00','CREDITOS A RECEBER DE DEVEDORES DE CONVENIOS','REGISTRA OS VALORES ORIUNDOS DE CREDITOS DE CONVENIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.05.00.00.00','CREDITOS A RECEBER DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS E IMOVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.07.00.00.00','CREDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRACAO','REGISTRA O VALOR DOS CREDITOS ADMINISTRATIVOS ORIUNDOS DE AUTOS DE INFRACAO E OUTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.08.00.00.00','CREDITOS A RECEBER EM PARCELAS/ LOTES ORIUNDOS DE DESAPROPRIACOES','REGISTRA OS VALORES A RECEBER ORIUNDOS DE DESAPROPRIACOES DE IMOVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.12.00.00.00','VALORES A RECUPERAR DECORRENTES DE INDENIZACAO DE SINISTROS PAGOS','REGISTRA OS VALORES A RECUPERAR DECORRENTES DE PAGAMENTOS DE INDENIZACOES DE SINISTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.13.00.00.00','INDENIZACOES A RECEBER','REGISTRA OS VALORES DAS INDENIZACOES A RECEBER A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.14.00.00.00','CREDITOS A RECUPERAR','REGISTRA O VALOR DOS CREDITOS A RECUPERAR APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.16.00.00.00','CREDITOS EM LIQUIDACAO','REGISTRA OS VALORES ORIUNDOS DE CREDITOS EM LIQUIDACAO DE DIFICIL REALIZACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.17.00.00.00','CREDITOS PARCELADOS','REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.19.00.00.00','CREDITOS A RECEBER EM PODER DA JUSTICA','REGISTRA OS VALORES A RECEBER EM PODER DA JUSTICA, SEM PREVISAO DE RECEBIMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.20.00.00.00','TITULOS A RECEBER','COMPREENDE OS VALORES A RECEBER A LONGO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.99.00.00.00','OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO','COMPREENDE OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO, NAO CLASSIFICAVEIS EM OUTRAS CONTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.99.01.00.00','INSCRICAO DE CERTIDAO DE DECISAO - TITULO EXECUTIVO DO TCE/RS','REPRESENTA CRÉDITOS EXIGÍVEIS A PARTIR DO RECEBIMENTO, PELA ENTIDADE, DE CERTIDÃO DE DECISÃO - TÍTULO EXECUTIVO, EMITIDA PELO TRIBUNAL DE CONTAS DO ESTADO COM CARACTERÍSTICA DE LIQUIDEZ E CERTEZA, PODENDO SER, FACULTATIVAMENTE INSCRITA COMO DIVIDA ATIVA NÃO TRIBUTARIA','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.00.00.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos a longo prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.02.00.00.00','(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','REGISTRA O AJUSTE PARA PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DIVIDA ATIVA NAO TRIBUTARIA DE LONGO PRAZO, EXCETO AS DERIVADAS DE CLIENTES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.03.00.00.00','(-) AJUSTE DE PERDAS DE CREDITOS ADMINISTRATIVOS','REGISTRA OS VALORES DOS AJUSTES PARA PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.04.00.00.00','(-) AJUSTE DE PERDAS DE CREDITOS  APURADOS EM TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES  DOS AJUSTES PARA PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.98.00.00.00','(-) AJUSTE DE PERDAS DE OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO','REGISTRA OS VALORES DOS AJUSTES DE PERDAS DE OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.0.00.00.00.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','Compreende as aplicações de recursos em títulos, valores mobiliários e imobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.00.00.00.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as aplicações de recursos em títulos, valores mobiliários e imobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.00.00.00.00','TÍTULOS E VALORES MOBILIÁRIOS','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis após os doze meses seguintes a data da publicação das demonstrações contábeis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.01.00.00.00','TÍTULOS DO GOVERNO FEDERAL COM RECURSOS NÃO VINCULADOS','REGISTRA OS VALORES APLICADOS EM TÍTULOS, CLASSIFICADOS EM INVESTIMENTOS COM RECURSOS NÃO VINCULADOS, EXCETO DO RPPS .','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.02.00.00.00','TÍTULOS DO GOVERNO FEDERAL COM RECURSOS  VINCULADOS','REGISTRA OS VALORES APLICADOS EM TÍTULOS, CLASSIFICADOS EM INVESTIMENTOS COM RECURSOS NÃO VINCULADOS, EXCETO DO RPPS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.03.00.00.00','ACOES E COTAS DE SOCIEDADES','REPRESENTA O SOMATORIO DOS VALORES APLICADOS EM ACOES E COTAS DE SOCIEDADES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.07.00.00.00','FUNDO DE APLICACOES EM COTAS - RENDA VARIAVEL','REGISTRA OS VALORES APLICADOS EM FUNDOS DE APLICACOES EM COTAS - RENDA VARIAVEL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.09.00.00.00','APLICACOES EM ATIVOS EM ENQUADRAMENTO - TITULOS E VALORES - RPPS','REGISTRAR OS VALORES DOS ATIVOS EM FASE DE ENQUADRAMENTO CONFORME ESTABELECE O ARTIGO 21 DA RESOLUÇÃO CMN Nº 3922/2010, REALIZÁVEIS OU NÃO APÓS O TÉRMINO DO EXERCÍCIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.10.00.00.00','APLICACOES EM ATIVOS NAO SUJEITOS A RESOLUCAO DO CMN - TITULOS E VALORES','REGISTRA OS VALORES DOS ATIVOS - TÍTULOS E VALORES- NÃO SUJEITOS AS REGRAS ESTABELECIDAS NA RESOLUCAO CMN Nº 3790/2009, REALIZÁVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.99.00.00.00','OUTROS TITULOS E VALORES MOBILIARIOS','REGISTRA OS OUTROS TÍTULOS E VALORES MOBILIÁRIOS A LONGO PRAZO, NÃO CLASSIFICAVEIS NAS CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.02.00.00.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','compreendem as aplicacoes de recursos em metais preciosos, nao destinados a negociacao e que nao facam parte das atividades operacionais da entidade, resgataveis apos os doze meses seguintes a data da publicacao das demonstracoes contabeis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.03.00.00.00.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS','Compreende os investimentos de longo prazo realizados em segmento de imóveis, realizáveis no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.03.01.00.00.00','EDIFICACOES','REGISTRA OS INVESTIMENTOS EM EDIFICACOES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.03.02.00.00.00','TERRENOS','REGISTRA OS INVESTIMENTOS EM TERRENOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.03.03.00.00.00','SALAS E ESCRITORIOS','REGISTRA OS INVESTIMENTOS EM SALAS E ESCRITORIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.03.04.00.00.00','OUTROS BENS IMOVEIS','REGISTRA OS INVESTIMENTOS EM OUTROS BENS IMOVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.99.00.00.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.99.01.00.00.00','(-) AJUSTE PARA PERDAS EM TÍTULOS, VALORES MOBILIÁRIOS E IMOVEIS','REGISTRA OS VALORES DOS AJUSTES PARA PERDAS EM TÍTULOS , VALORES MOBILIÁRIOS E IMOVEIS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.99.02.00.00.00','(-) AJUSTE PARA PERDAS EM TÍTULOS, VALORES MOBILIÁRIOS E IMOVEIS - RPPS','REGISTRA OS VALORES DOS AJUSTES  PARA PERDAS EM TÍTULOS , VALORES MOBILIÁRIOS E IMOVEIS A LONGO PRAZO DO RPPS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.0.00.00.00.00.00','ESTOQUES','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade para utilização própria ou para venda, previstos para período posterior ao término do exercício seguinte.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.00.00.00.00.00','ESTOQUES - CONSOLIDAÇÃO','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.01.00.00.00.00','MERCADORIAS PARA REVENDA','Compreende todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.02.00.00.00.00','PRODUTOS E SERVIÇOS ACABADOS','Compreende os produtos já terminados e oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.03.00.00.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','Compreende os produtos e serviços em andamento que não serão concluídos até o término do exercício subsequente a data do balanço patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.04.00.00.00.00','MATÉRIAS-PRIMAS','Compreende o estoque de matérias-primas que será utilizado no processo produtivo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.05.00.00.00.00','MATÉRIAIS EM TRANSITO','Compreende o valor dos materiais em processo de transferência para outras unidades da entidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.06.00.00.00.00','ALMOXARIFADO','Compreende o valor dos materiais destinados ao consumo interno da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.07.00.00.00.00','ADIANTAMENTOS A FORNECEDORES','Compreende os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.98.00.00.00.00','OUTROS ESTOQUES','Compreende o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.99.00.00.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES','Compreende o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro de perdas estimadas para os estoque que tiverem o valor de mercado inferior ao seu custo. Conta a ser utilizada apenas para os estoques classificados no ativo realizável a longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.99.01.00.00.00','(-) AJUSTE PARA PERDAS EM ESTOQUES','REGISTRA AS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NAO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NAO ESTAREM IDENTIFICADAS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.99.02.00.00.00','(-) AJUSTE PARA REDUCAO AO VALOR DE MERCADO','REGISTRA O AJUSTE PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço à entidade ocorrerão no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE- CONSOLIDAÇÃO','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço a entidade ocorrerão no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.01.00.00.00.00','PRÊMIOS DE SEGUROS A APROPRIAR','Compreende os valores pagos a titulo de prêmios de seguro a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.02.00.00.00.00','VPD FINANCEIRAS A APROPRIAR','Compreende os valores pagos a título de VPD financeiras a apropriar.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.03.00.00.00.00','ASSINATURAS E ANUIDADES A APROPRIAR','Compreende os valores pagos a titulo de assinaturas e anuidades a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.04.00.00.00.00','ALUGUEIS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de aluguel a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.05.00.00.00.00','TRIBUTOS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de tributos a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.06.00.00.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','Compreende os valores pagos a titulo de contribuições confederativas a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.07.00.00.00.00','BENEFÍCIOS A APROPRIAR','Compreende os valores pagos a titulo de beneficio a pessoal a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.99.00.00.00.00','DEMAIS VPD A APROPRIAR','Compreende os demais valores pagos a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.0.0.00.00.00.00.00','INVESTIMENTOS','Compreende as participações permanentes em outras sociedades, bem como os bens e direitos não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção da atividade da entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.0.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - CONSOLIDAÇÃO','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.01.01.00.00.00','PARTICIPACOES EM EMPRESAS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.01.03.00.00.00','PARTICIPACOES EM CONSORCIOS PUBLICOS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM CONSORCIOS PUBLICOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.01.95.00.00.00','OUTRAS PARTICIPACOES - MEP','REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.02.01.00.00.00','PARTICIPACOES EM EMPRESAS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.02.99.00.00.00','OUTRAS PARTICIPACOES - METODO DE CUSTO','REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.2.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - INTRA OFSS','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.2.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.2.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.3.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - UNIÃO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.3.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.3.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.4.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - ESTADO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.4.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.4.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.5.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - MUNICÍPIO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.5.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.5.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.2.0.00.00.00.00.00','PROPRIEDADES PARA INVESTIMENTO','Compreende a propriedade (terreno ou edifício - ou parte de edifício - ou ambos) mantida (pelo proprietário ou pelo arrendatário em arrendamento financeiro) para auferir aluguel ou para valorização do capital ou para ambas, e não para: uso na produção ou fornecimento de bens ou serviços ou para finalidades administrativas; ou venda no curso ordinário do negócio.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.2.1.00.00.00.00.00','PROPRIEDADES PARA INVESTIMENTO - CONSOLIDAÇÃO','Compreende a propriedade (terreno ou edifício - ou parte de edifício - ou ambos) mantida (pelo proprietário ou pelo arrendatário em arrendamento financeiro) para auferir aluguel ou para valorização do capital ou para ambas, e não para: uso na produção ou fornecimento de bens ou serviços ou para finalidades administrativas; ou venda no curso ordinário do negócio. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.2.1.01.00.00.00.00','TERRENOS E IMOVEIS PARA FUTURA UTILIZAÇÃO','REGISTRA OS VALORES DE IMOVEIS DA UNIDADE MANTIDOS PARA FUTURA UTILIZACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.2.1.02.00.00.00.00','BENS IMOVEIS NÃO DESTINADOS A USO','REGISTRA OS VALORES DE IMOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.0.00.00.00.00.00','INVESTIMENTOS DO RPPS DE LONGO PRAZO','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social, em conformidade com a legislação que trata das aplicações e investimentos dos RPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.00.00.00.00.00','INVESTIMENTOS DO RPPS DE LONGO PRAZO - CONSOLIDAÇÃO','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social, em conformidade com a legislação que trata das aplicações e investimentos dos RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.01.00.00.00.00','TÍTULOS E VALORES MOBILIÁRIOS - RPPS','COMPREENDE OS INVESTIMENTOS REALIZADOS PELO REGIME PRÓPRIO DA PREVIDÊNCIA SOCIAL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.01.01.00.00.00','APLICAÇÕES EM ATIVOS EM ENQUADRAMENTO - TÍTULOS E VALORES','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM DESACORDO COM AS REGRAS ESTABELECIDAS PELA RESOLUCAO CMN Nº 3790/2009, ARTIGO 25.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.01.02.00.00.00','APLICAÇÕES EM ATIVOS NÃO SUJEITOS À RESOLUÇÃO DO CMN - TÍTULOS E VALORES','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM ATIVOS NÃO SUJEITOS AS REGRAS DA  RESOLUCAO CMN Nº 3790/2009.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.02.00.00.00.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS - RPPS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, NO SEGMENTO DE IMÓVEIS EFETUADOS EM CONFORMIDADE COM O ART. 8º DA RESOLUCAO CMN N° 3.790/2009.','','N','','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.02.01.00.00.00','IMÓVEIS - RPPS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM IMÓVEIS SUJEITOS AS REGRAS DA  RESOLUCAO CMN Nº 3790/2009.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.0.00.00.00.00.00','DEMAIS INVESTIMENTOS PERMANENTES','Compreende os demais direitos de qualquer natureza não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção das atividades da entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.1.00.00.00.00.00','DEMAIS INVESTIMENTOS PERMANENTES - CONSOLIDAÇÃO','Compreende os demais direitos de qualquer natureza não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção das atividades da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.1.01.00.00.00.00','OBRAS DE ARTE','REGISTRA OS VALORES REFERENTES A OBRAS DE ARTE DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.1.03.00.00.00.00','BENS MOVEIS NÃO DESTINADOS A USO','REGISTRA OS VALORES DE MOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.1.05.00.00.00.00','BENS INTANGIVEIS NÃO DESTINADOS A USO','REGISTRA O VALOR DE BENS INTANGIVEIS NÃO DESTINADOS AO USO E QUE A UNIDADE NÃO EXPLORA COMERCIALMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.1.06.00.00.00.00','TÍTULOS E VALORES MOBILIÁRIOS PERMANENTES','REGISTRA O VALOR DOS TÍTULOS E VALORES MOBILIÁRIOS  NÃO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZÁVEL A LONGO PRAZO, COMO POR EXEMPLO AS DEBENTURES (PERPETUAS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.1.99.00.00.00.00','DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA O VALOR DE INVESTIMENTOS PERMANENTES, NÃO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.8.0.00.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS','Compreende a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, como a depreciação das propriedades mantidas para investimento.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.8.1.00.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, como a depreciação das propriedades mantidas para investimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.8.1.01.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS - CONSOLIDAÇÃO - PROPRIEDADES PARA INVESTIMENTO','Registra a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, das propriedades mantidas para investimento.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.0.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.02.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Registra os valores de ajuste ao valor recuperável de propriedades para investimento, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.03.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS','Registra os valores de ajuste ao valor recuperável de investimentos do RPPS, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.2.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTRA OFSS','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.2.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.2.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.3.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - UNIÃO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.3.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil. Conta de uso exclusivo para as empresas estatais.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.3.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil. Conta de uso exclusivo para as empresas estatais.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.4.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - ESTADO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.4.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.4.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.5.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - MUNICÍPIO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.5.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.5.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.0.0.00.00.00.00.00','IMOBILIZADO','Compreende os direitos que tenham por objeto bens corpóreos destinados a manutenção das atividades da entidade ou exercidos com essa finalidade, inclusive os decorrentes de operações que transfiram a ela os benefícios, os riscos e o controle desses bens.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.0.00.00.00.00.00','BENS MOVEIS','Compreende o valor da aquisição ou incorporação de bens corpóreos, que tem existência material e que podem ser transportados por movimento próprio ou removidos por forca alheia sem alteração da substancia ou da destinação economico-social, que constituam meio para a produção de outros bens ou serviços.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.00.00.00.00.00','BENS MOVEIS- CONSOLIDAÇÃO','Compreende o valor da aquisição ou incorporação de bens corpóreos, que tem existência material e que podem ser transportados por movimento próprio ou removidos por forca alheia sem alteração da substancia ou da destinação economico-social, que constituam meio para a produção de outros bens ou serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.00.00.00.00','MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MAQUINAS, FERRAMENTAS, APARELHOS, EQUIPAMENTOS,  ACESSORIOS, ETC.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.01.00.00.00','APARELHOS DE MEDICAO E ORIENTACAO','REGISTRA OS APARELHOS UTILIZADOS PARA MEDICAO E ORIENTACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.02.00.00.00','APARELHOS E EQUIPAMENTOS DE COMUNICACAO','REGISTRA OS APARELHOS E EQUIPAMENTOS UTILIZADOS PARA COMUNICACAO','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.03.00.00.00','APARELHOS, EQUIPAMENTOS E UTENSILIOS MEDICOS, ODONTOLOGICOS, LABORATORIAIS E HOSPITALARES','REGISTRA OS APARELHOS, EQUIPAMENTOS E UTENSILIOS PARA USO MEDICO, ODONTOLOGICO, LABORATORIAL E HOSPITALAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.04.00.00.00','APARELHOS E EQUIPAMENTOS PARA ESPORTES E DIVERSOES','REGISTRA OS APARELHOS E EQUIPAMENTOS UTILIZADOS PARA MODALIDADES DE ESPORTES E DIVERSOES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.05.00.00.00','EQUIPAMENTO DE PROTECAO, SEGURANCA E SOCORRO','REGISTRA OS EQUIPAMENTOS UTILIZACOES PARA PROTECAO, SEGURANCA E SOCORRO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.06.00.00.00','MAQUINAS E EQUIPAMENTOS INDUSTRIAIS','REGISTRA AS MAQUINAS E EQUIPAMENTOS DE NATUREZA INDUSTRIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.07.00.00.00','MAQUINAS E EQUIPAMENTOS ENERGETICOS','REGISTRA AS MAQUINAS E EQUIPAMENTOS ENERGETICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.08.00.00.00','MAQUINAS E EQUIPAMENTOS GRAFICOS','REGISTRA AS MAQUINAS E EQUIPAMENTOS EMPREGADOS NA INDUSTRIA GRAFICA OU NECESSARIOS PARA SUA INDUSTRIALIZACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.09.00.00.00','MAQUINAS, FERRAMENTAS E UTENSILIOS DE OFICINA','REGISTRA AS MAQUINAS, FERRAMENTAS E UTENSILIOS UTILIZADOS EM OFICINAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.12.00.00.00','EQUIPAMENTOS, PECAS E ACESSORIOS PARA AUTOMOVEIS','REGISTRA OS EQUIPAMENTOS, PECAS E ACESSORIOS PARA AUTOMOVEIS QUE PODEM SER DESINCORPORADOS, SEM PREJUIZO DOS MESMOS, PARA APLICACAO EM OUTRO VEICULO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.13.00.00.00','EQUIPAMENTOS, PECAS E ACESSORIOS MARITIMOS','REGISTRA OS EQUIPAMENTOS, PECAS E ACESSORIOS MARITIMOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.16.00.00.00','EQUIPAMENTOS DE MERGULHO E SALVAMENTO','REGISTRA OS EQUIPAMENTOS DE MERGULHO E SALVAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.20.00.00.00','MAQUINAS, EQUIPAMENTOS E UTENSILIOS AGROPECUARIOS E REDOVIARIOS','REGISTRA OS VALORES RELATIVOS A MAQUINAS, EQUIPAMENTOS, FERRAMENTAS E UTENSILIOS AGROPECUARIOS E REDOVIARIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.21.00.00.00','EQUIPAMENTOS HIDRAULICOS E ELETRICOS','REGISTRA OS EQUIPAMENTOS HIDRAULICOS E ELETRICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.22.00.00.00','EQUIPAMENTOS E MATERIAIS PERMANENTES VINCULADOS A CONVÊNIO','REGISTRA OS EQUIPAMENTOS E MATERIAIS PERMANENTES VINCULADOS A CONVÊNIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.30.00.00.00','MATERIAL DE USO DURADOURO','REGISTRA OS VALORES RELATIVOS AOS MATERIAIS DE CONSUMO QUE DEVIDO    ASUA DURABILIDADE E NATUREZA DEVEM COMPOR O ATIVO DA ENTIDADE.O CONTROLE PATRIMONIAL DOS BENS REGISTRADOS NESTA CONTA DEVERA     SER         SIMPLIFICADO, POR MEIO DE RELACAO DO MATERIAL (RELACAO-CARGA) E/OU VE-RIFICACAO PERIODICA DA QUANTIDADE DE ITENS REQUISITADOS,  DEVIDO     ASUA DURABILIDADE E CARACTERISTICAS PROPRIAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.40.00.00.00','PECAS NAO INCORPORAVEIS A IMOVEIS','REGISTRA OS VALORES RELATIVOS A AQUISICAO DE PECAS NAO INCORPORAVEIS A IMOVEIS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.99.00.00.00','OUTRAS MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','REGISTRA OS VALORES REFERENTES A MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS NAO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.02.00.00.00.00','BENS DE INFORMATICA','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E SISTEMAS APLICATIVOS, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.02.01.00.00.00','EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','REGISTRA OS EQUIPAMENTOS DE PROCESSAMENTO DE DADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.02.02.00.00.00','EQUIPAMENTOS DE TECNOLOGIA DA INFORMACAO','REGISTRA OS EQUIPAMENTOS RELACIONADOS COM TECNOLOGIA DA INFORMACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.03.00.00.00.00','MOVEIS E UTENSILIOS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MOBILIARIO EM GERAL E UTENSILIOS, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.03.01.00.00.00','APARELHOS E UTENSILIOS DOMESTICOS','REGISTRA OS OBJETOS OU PECAS DE USO CASEIRO OU NECESSARIOS A VIDA FAMILIAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.03.02.00.00.00','MAQUINAS E UTENSILIOS DE ESCRITORIO','REGISTRA AS MAQUINAS E UTENSILIOS DE ESCRITORIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.03.03.00.00.00','MOBILIARIO EM GERAL','REGISTRA OS VALORES RELATIVOS AOS BENS MOVEIS, DE CARATER GERAL, EM USO NA UNIDADE, NAO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.03.04.00.00.00','UTENSILIOS EM GERAL','REGISTRA OS VALORES RELATIVOS A UTENSILIOS, DE CARATER GERAL, EM USO NA UNIDADE, NAO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.00.00.00.00','MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICACAO','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MATERIAIS BIBLIOGRAFICOS, DISCOTECAS, FILMOTECAS, DE COMUNICACAO, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.01.00.00.00','BANDEIRAS, FLAMULAS E INSIGNIAS','REGISTRA OS VALORES RELATIVOS A BANDEIRAS, FLAMULAS E INSIGNIAS, GERALMENTE UTILIZADAS COMO DISTINTIVO DA NACAO E DE CORPORACOES, PEQUENAS CHAMAS, ADORNOS, SINAL DISTINTIVO, EMBLEMAS, ESTANDARTES E OUTROS SIMBOLOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.02.00.00.00','COLECOES E MATERIAIS BIBLIOGRAFICOS','REGISTRA OS VALORES RELATIVOS AOS OBJETOS E MATERIAIS BIBLIOGRAFICOS DESTINADOS A REUNIR, GERALMENTE, PARA FORMACAO DE BIBLIOTECAS DE USO DA UNIDADE OU CUMPRIR OBJETIVOS DESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.03.00.00.00','DISCOTECAS E FILMOTECAS','REGISTRA OS VALORES RELATIVOS A DISCOS, CDS E COLECOES DE FITAS GRAVADAS COM MUSICAS E FITAS CINEMATOGRAFICAS DE CARATER EDUCATIVO, CIENTIFICO E INFORMATIVO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.04.00.00.00','INSTRUMENTOS MUSICAIS E ARTISTICOS','REGISTRA OS VALORES RELATIVOS AOS INSTRUMENTOS MUSICAIS E ARTISTICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.05.00.00.00','EQUIPAMENTOS PARA AUDIO, VIDEO E FOTO','REGISTRA OS VALORES DE EQUIPAMENTOS DE AUDIO, VIDEO E FOTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.06.00.00.00','OBRAS DE ARTE E PECAS PARA EXPOSICAO','REGISTRA OS VALORES RELATIVOS A OBRAS E OBJETOS DE ARTE E DE PECAS PARA DECORACAO OU EXPOSICAO EM GERAL EM MUSEUS, GALERIAS, HALLS, PREDIOS PUBLICOS E OUTROS, DESDE QUE  SE DESTINEM A MANUTENCAO DE SUA ATIVIDADE, CASO CONTRARIO, DEVE SER CLASSIFICADO COMO INVESTIMENTOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.99.00.00.00','OUTROS MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICACAO','REGISTRA OS VALORES REFERENTES A MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICACAO NAO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.05.00.00.00.00','VEICULOS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MEIOS DE TRANSPORTES AEREOS, AQUATICOS E TERRESTRES, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.05.01.00.00.00','VEICULOS EM GERAL','REGISTRA OS VEICULOS DE DIVERSOS TIPOS, NAO MOTORIZADOS, PARA OS QUAIS NAO TENHAM SIDO CRIADAS CONTAS ESPECIFICAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.05.03.00.00.00','VEICULOS DE TRACAO MECANICA','REGISTRA OS VEICULOS DE TRACAO MECANICA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.06.00.00.00.00','PECAS E CONJUNTOS DE REPOSICAO','REGISTRA O VALOR DA AQUISICAO OU INCORPORACAO DE PECAS E CONJUNTOS DE REPOSICAO DESTINADOS A SUBSTITUICAO EM MAQUINAS E EQUIPAMENTOS, AERONAVES E EMBARCACOES, BENS DE SEGURANCA E SOCORRO, ENTRE OUTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.07.00.00.00.00','BENS MOVEIS EM ANDAMENTO','COMPREENDE OS VALORES DE BENS MOVEIS EM ANDAMENTO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.07.01.00.00.00','BENS MOVEIS EM ELABORAÇÃO','REGISTRA OS VALORES RELATIVOS A TODOS OS GASTOS OCORRIDOS COM BENS MOVEIS EM FASE DE ELABORACAO E ACABAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.07.02.00.00.00','IMPORTAÇÕES EM ANDAMENTO','REGISTRA OS VALORES RELATIVOS A TODOS OS GASTOS COM IMPORTAÇÕES EM ANDAMENTO DE EQUIPAMENTOS, MAQUINAS, APARELHOS E OUTROS BENS MOVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.08.00.00.00.00','BENS MOVEIS EM ALMOXARIFADO','COMPREENDE OS VALORES DE BENS PERMANENTES A SEREM ESTOCADOS EM ALMOXARIFADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.08.01.00.00.00','ESTOQUE INTERNO','REGISTRA OS VALORES DOS BENS MOVEIS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADO, DESTINADOS A ATENDER AS NECESSIDADES DOS ORGAOS ADQUIRENTES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.08.03.00.00.00','BENS MÓVEIS A REPARAR','REGISTRA OS VALORES DOS BENS MOVEIS  A REPARAR ESTOCADOS EM ALMOXARIFADO','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.08.04.00.00.00','BENS MÓVEIS EM REPARO','REGISTRA OS VALORES DOS BENS MOVEIS  EM REPARO ESTOCADOS EM ALMOXARIFADO','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.08.05.00.00.00','BENS MOVEIS INSERVIVEIS','REGISTRA OS VALORES DOS BENS MOVEIS INSERVIVEIS EM ALMOXARIFADO, QUE DEPENDEM DE PARECER DA COMISSAO E HOMOLOGACAO DA AUTORIDADE COMPETENTE PARA SEREM DESCARREGADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.10.00.00.00.00','SEMOVENTES','REGISTRA OS VALORES RELATIVOS AOS ANIMAIS DESTINADOS A PRODUCAO, REPRODUCAO, ENGORDA E AOS SERVIÇOS  UTILITARIOS EM GERAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.99.00.00.00.00','DEMAIS BENS MOVEIS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DOS DEMAIS BENS MOVEIS NAO CLASSIFICADOS EM GRUPOS ESPECIFICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.99.99.00.00.00','OUTROS BENS MÓVEIS','REGISTRA O VALOR DA AQUISICAO OU INCORPORACAO DOS OUTROS BENS MOVEIS NÃO CLASSIFICADOS ANTERIORMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.0.00.00.00.00.00','BENS IMÓVEIS','Compreende o valor dos bens imóveis, os quais são bens vinculados ao solo e que não podem ser retirados sem destruição ou dano, destinados ao uso e que a entidade não esteja explorando comercialmente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.00.00.00.00.00','BENS IMOVEIS- CONSOLIDAÇÃO','Compreende o valor dos bens imóveis, os quais são bens vinculados ao solo e que não podem ser retirados sem destruição ou dano, destinados ao uso e que a entidade não esteja explorando comercialmente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.00.00.00.00','BENS DE USO ESPECIAL','COMPREENDE OS BENS, TAIS COMO EDIFICIOS OU TERRENOS DESTINADOS A SERVICO OU ESTABELECIMENTO DA ADMINISTRACAO DIRETA MUNICIPAL, INCLUSIVE OS DE SUAS AUTARQUIAS E FUNDACOES PUBLICAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.01.00.00.00','IMÓVEIS RESIDENCIAIS/COMERCIAIS','REGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE : APARTAMENTOS; CASAS; RESIDENCIAS; CONJUNTOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.02.00.00.00','EDIFICIOS','REGISTRA OS VALORES RELATIVOS AOS PREDIOS EDIFICADOS, DE PROPRIEDADE DA ENTIDADE, LOCALIZADOS EM AREAS URBANAS E RURAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.03.00.00.00','TERRENOS/GLEBAS','REGISTRA OS VALORES PERTINENTES AS PROPRIEDADES AGRICOLAS CONSTITUINDO GLEBAS E FAZENDAS, REGISTRADAS EM CARTORIO E OU TITULADAS, DE PROPRIEDADE DA UNIDADE, RESERVADAS OU NAO A EXPLORACAO AGROPECUARIA E REGISTRA OS VALORES RELATIVOS AOS TERRENOS  DE PROPRIEDADE DA ENTIDADE, LOCALIZADOS EM AREAS URBANAS E RURAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.04.00.00.00','ARMAZENS/GALPOES/SILOS','REGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: ARMAZENS; GALPOES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.07.00.00.00','IMOVEIS DE USO EDUCACIONAL','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO:  ESCOLAS; FACULDADES; UNIVERSIDADES;  BIBLIOTECAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.08.00.00.00','REPRESAS/ACUDES','REGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: AÇUDES;  REPRESAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.09.00.00.00','FAZENDAS, PARQUES E RESERVAS','RREGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: FAZENDAS; PARQUES; RESERVAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.10.00.00.00','IMOVEIS DE USO RECREATIVO','REGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: CLUBES; ESTADIOS; GINÁSIOS; TEATROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.16.00.00.00','HOSPITAIS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO HOSPITAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.19.00.00.00','PORTOS/ESTALEIROS','REGISTRA OS SEGUINES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: ESTALEIROS; PORTOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.20.00.00.00','COMPLEXOS/FABRICAS/USINAS','RREGISTRA OS SEGUINES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: FABRICAS; USINAS; COMPLEXOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.21.00.00.00','CEMITERIOS','RREGISTRA OS SEGUINES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: CEMITERIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.22.00.00.00','ESTACIONAMENTOS E GARAGENS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO ESTACIONAMENTOS. TAMBEM DEVEM SER  REGISTRADOS NESTA CONTA AS GARAGENS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.23.00.00.00','LOJAS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO LOJAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.24.00.00.00','SALAS E ESCRITORIOS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO SALAS E ESCRITORIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.98.00.00.00','OUTROS BENS IMÓVEIS DE USO ESPECIAL','REGISTRA OUTROS OS BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.00.00.00.00','BENS DOMINICAIS','COMPREENDE OS BENS  QUE CONSTITUEM O PATRIMÔNIO DAS PESSOAS JURIDICAS DE DIREITO PUBLICO, COMO OBJETO DE DIREITO PESSOAL, OU REAL. COMPREENDE AINDA, NÃO DISPONDO A LEI EM CONTRARIO, OS BENS PERTENCENTES AS PESSOAS JURIDICAS DE DIREITO PUBLICO A QUE SE TENHA DADO ESTRUTURA DE DIREITO PRIVADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.01.00.00.00','EDIFICIOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS : EDIFICIOS/PREDIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.02.00.00.00','APARTAMENTOS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS :   APARTAMENTOS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.03.00.00.00','ARMAZENS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: ARMAZENS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.04.00.00.00','CASAS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: CASAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.05.00.00.00','CEMITERIOS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: CEMITERIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.07.00.00.00','GARAGENS E ESTACIONAMENTOS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: GARAGENS E ESTACIONAMENTOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.08.00.00.00','FAZENDAS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: FAZENDAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.09.00.00.00','GALPOES','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: GALPÕES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.10.00.00.00','GLEBAS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: GLEBAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.11.00.00.00','LOJAS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: LOJAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.12.00.00.00','SALAS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: SALAS E ESCRITÓRIOS..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.13.00.00.00','TERRENOS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: TERRENOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.14.00.00.00','LOTES','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: LOTES .','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.16.00.00.00','GLEBAS URBANAS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: GLEBAS URBANAS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.18.00.00.00','GLEBAS RURAIS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS:  GLEBAS RURAIS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.99.00.00.00','OUTROS BENS DOMINICAIS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS A OUTROS BENS IMOVEIS DOMINIAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.00.00.00.00','BENS DE USO COMUM DO POVO','COMPREENDE OS BENS DE USO COMUM DO POVO CONSTRUIDOS OU ADQUIRIDOS POR PESSOAS JURIDICAS DE DIREITO PUBLICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.01.00.00.00','RUAS','REGISTRA OS VALORES DE RUAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.02.00.00.00','PRACAS','REGISTRA OS VALORES DE PRACAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.03.00.00.00','ESTRADAS','REGISTRA OS VALORES DE ESTRADAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.04.00.00.00','PONTES','REGISTRA OS VALORES DE PONTES QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.05.00.00.00','VIADUTOS','REGISTRA OS VALORES DE VIADUTOS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.99.00.00.00','OUTROS BENS DE USO COMUM DO POVO','REGISTRA OS VALORES BENS DE USO COMUM, NÃO CLASSIFICADOS ANTERIORMENTE NESTE PLANO DE CONTAS, QUE FORAM ADQUIRIDOS, PRODUZIDOS OU CONSTRUIDOS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.06.00.00.00.00','BENS IMOVEIS EM ANDAMENTO','COMPREENDE OS VALORES DE BENS IMOVEIS EM ANDAMENTO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.06.01.00.00.00','OBRAS EM ANDAMENTO','REGISTRA OS VALORES PERTINENTES A OBRAS, DESDE SUA CONSTRUCAO ATE O TERMINO DA MESMA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.06.05.00.00.00','ESTUDOS E PROJETOS','REGISTRA OS VALORES RELATIVOS A ESTUDOS E PROJETOS, ENGLOBANDO LIMPEZA DO TERRENO, SERVIÇOS TOPOGRÁFICOS, SONDAGENS DE RECONHECIMENTO, TERRAPLENAGEM, DRENAGENS, INSTALAÇÕES PROVISORIAS COMO GALPOES, INSTALAÇÕES ELETRICAS E HIDRAULICAS, UTILIZADAS DURANTE AS OBRAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.06.06.00.00.00','ALMOXARIFADO DE INVERSOES FIXAS','REGISTRA TODOS OS MATERIAIS E BENS DA EMPRESA DESTINADOS A APLICACAO NA CONSTRUCAO DE BENS IMOVEIS EM ANDAMENTO. COMO, POR EXEMPLO, ALMOXARIFADO DE MATÉRIAS DE CONSTRUCAO PARA APLICAR EM UMA OBRA EM ANDAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.07.00.00.00.00','INSTALACOES','REGISTRA EQUIPAMENTOS, MATERIAIS E CUSTO DE IMPLANTACAO DE INSTALACOES QUE, NAO OBSTANTE INTEGRADAS AOS EDIFICIOS, DEVEM SER SEGREGADAS DAS OBRAS CIVIS, COMO, POR EXEMPLO, AS INSTALCOES ELETRICAS, HIDRAULICAS, SANITARIAS, DE VAPOR, DE AR COMPRIMIDO, FRIGORIFICAS, CONTRA INCENDIO, DE COMUNICACOES, DE CLIMATIZACAO, PARA COMBUSTIVEIS, GASES, DE ANTIPOLUICAO, PARA COZINHA, DENTRE OUTROS.  E TAMBEM APLICAVEL A CONSTRUCAO DE TRECHOS FERROVIARIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.08.00.00.00.00','BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','REGISTRA CONSTRUCOES EM TERRENOS ARRENDADOS DE TERCERIOS E INSTALACOES E OUTRAS BENFEITORIAS EM PREDIOS ALUGADOS. SAO CONSIDERADOS SOMENTE OS GASTOS COM CONSTRUCAO E INSTALACAO QUE SE INCORPORAM AO IMOVEL E REVERTEM AO PROPRIETARIO DO IMOVEL AO FINAL DA LOCACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.99.00.00.00.00','DEMAIS BENS IMOVEIS','COMPREENDE OS DEMAIS BENS IMOVEIS NAO CLASSIFICADOS ANTERIORMENTE NESSE PLANO DE CONTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.99.99.00.00.00','OUTROS BENS IMOVEIS','REGISTRA OS VALORES RELATIVOS A OUTROS BENS IMOVEIS, PARA OS QUAIS NAO TENHAM SIDO CRIADAS CONTAS PROPRIAS OU ESPECIFICAS NESTE PLANO DE CONTAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.0.00.00.00.00.00','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS','Compreende a diminuição do valor dos elementos do ativo imobilizado devido a desgaste pelo uso, ação da natureza ou obsolescência, bem como a perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração e a perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.00.00.00.00.00','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS - CONSOLIDAÇÃO','Compreende a diminuição do valor dos elementos do ativo imobilizado devido a desgaste pelo uso, ação da natureza ou obsolescência, bem como a perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração e a perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.01.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA - BENS MÓVEIS','Compreende a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido a desgaste pelo uso, ação da natureza ou obsolescência.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.02.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA - BENS IMÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens imóveis, devido a desgaste pelo uso, ação da natureza ou obsolescência.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.03.00.00.00.00','(-) EXAUSTÃO ACUMULADA - BENS MÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido à perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.04.00.00.00.00','(-) EXAUSTÃO ACUMULADA - BENS IMÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens imóveis, devido à perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.05.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA - BENS MÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido à perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.06.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA - BENS IMÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens Imóveis, devido à perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.9.0.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO','Compreende os valores de ajuste ao valor recuperável do imobilizado, quando esse for inferior ao valor liquido contábil.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.9.1.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável do imobilizado, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.9.1.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - BENS MOVEIS','Registra os valores de ajuste ao valor recuperável de bens moveis, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.9.1.02.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - BENS IMÓVEIS','Registra os valores de ajuste ao valor recuperável de bens imóveis, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.0.0.00.00.00.00.00','INTANGÍVEL','Compreende os direitos que tenham por objeto bens incorpóreos destinados a manutenção da entidade ou exercidos com essa finalidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.1.0.00.00.00.00.00','SOFTWARES','Compreende os valores dos softwares pertencentes à entidade e não integrantes a um hardware, englobando os valores referentes à sua construção, implementação e instalação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.1.1.00.00.00.00.00','SOFTWARES- CONSOLIDAÇÃO','Registra os valores dos softwares pertencentes à entidade e não integrantes a um hardware, englobando os valores referentes à sua construção, implementação e instalação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.2.0.00.00.00.00.00','MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS','Compreende os valores pertinentes a bens intangíveis, englobando os gastos com registro de marca, nome, invenções próprias, direitos de uso de comunicação e direitos autorais, alem de desembolsos a terceiros por contratos de uso de marcas, patentes ou processos de fabricação (tecnologia).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.2.1.00.00.00.00.00','MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS- CONSOLIDAÇÃO','Compreende os valores pertinentes a bens intangíveis, englobando os gastos com registro de marca, nome, invenções próprias, direitos de uso de comunicação, direitos autorais e direitos sobre recursos naturais, alem de desembolsos a terceiros por contratos de uso de marcas, patentes ou processos de fabricação (tecnologia). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.3.0.00.00.00.00.00','DIREITO DE USO DE IMÓVEIS','Compreende os valores pertinentes a bens intangíveis representados pela aquisição do direito de uso de imóveis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.3.1.00.00.00.00.00','DIREITO DE USO DE IMOVEIS- CONSOLIDAÇÃO','Registra os valores pertinentes a bens intangíveis representados pela aquisição de direito de uso de imóveis. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.0.00.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA','Compreende a diminuição do valor do capital aplicado na aquisição de direitos da propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.1.00.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA- CONSOLIDAÇÃO','Compreende a diminuição do valor do capital aplicado na aquisição de direitos da propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.1.01.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA - SOFTWARES','Registra a diminuição do valor do capital aplicado em softwares, pertencentes ao ativo intangível.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.1.02.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA - MARCAS, DIREITOS E PATÉNTES','Registra a diminuição do valor do capital aplicado em marcas, direitos e patentes, pertencentes ao ativo intangível.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.1.03.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA - DIREITO DE USO DE IMÓVEIS','Registra a diminuição do valor do capital aplicado em direito de uso de imóveis, pertencentes ao ativo intangível.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.0.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL','Compreende os valores de ajuste ao valor recuperável do ativo intangível, quando esse for inferior ao valor liquido contábil. Conta de uso exclusivo para as empresas estatais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.1.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável do ativo intangível, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.1.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - SOFTWARES','Registra os valores de ajuste ao valor recuperável do software pertencente ao ativo intangível, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.1.02.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - MARCAS, DIREITOS E PATÉNTES','Registra os valores de ajuste ao valor recuperável das marcas, direitos e patentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.1.03.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL-DIREITO DE USO','Registra os valores de ajuste ao valor recuperável de direito de uso, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.0.0.0.0.00.00.00.00.00','PASSIVO E PATRIMÔNIO LIQUIDO','Passivo compreende as obrigações existentes da entidade oriundas de eventos passados de cuja liquidação se espera que resulte em fluxo de saída de recursos que incorporem benefícios econômicos ou serviços em potencial. Patrimônio liquido compreende a diferença entre o ativo e o passivo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.0.0.0.00.00.00.00.00','PASSIVO CIRCULANTE','Compreende as obrigações conhecidas e estimadas que atendam a qualquer um dos seguintes critérios: tenham prazos estabelecidos ou esperados dentro do ciclo operacional da entidade; sejam mantidos primariamente para negociação; tenham prazos estabelecidos ou esperados no curto prazo; sejam valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, independentemente do prazo de exigibilidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.0.0.00.00.00.00.00','OBRIGAÇÕES TRABALHISTAS, PREVIDENCIÁRIAS E ASSISTENCIAIS A PAGAR A CURTO PRAZO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, aposentadorias, reformas, pensões e encargos a pagar,  benefícios assistenciais, inclusive os precatórios decorrentes dessas obrigações , com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.0.00.00.00.00.00','PESSOAL A PAGAR','Compreende as obrigações a curto prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.00.00.00.00.00','PESSOAL A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.00.00.00.00','PESSOAL A PAGAR DO EXERCICIO','COMPREENDE AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS AO EXERCICIO ATUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.01.00.00.00','SALARIOS, REMUNERACOES E BENEFICIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS AO EXERCICIO ATUAL.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.02.00.00.00','PROVISAO PARA 13. SALARIO','REGISTRA AS OBRIGACOES REFERENTES AO DECIMO TERCEIRO SALARIO, GERALMENTE APROPRIADAS NA BASE DE 1/12 DO VALOR BRUTO DA FOLHA DE PAGAMENTO DA UNIDADE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.03.00.00.00','PROVISAO PARA FERIAS','REGISTRA AS OBRIGACOES REFERENTES A FERIAS, GERALMENTE APROPRIADAS COMO PERCENTUAIS DA FOLHA DE PAGAMENTO DA UNIDADE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.04.00.00.00','PROVISAO PARA LICENÇA-PRÊMIO','REGISTRA OS VALORES DAS OBRIGACOES CONSTITUIDAS COM BASE EM PERCENTUAIS  DE SALARIOS, DESTINADOS AO PAGAMENTO DE LICENCA-PREMIO EM PECUNIA PREVISTA EM LEI MUNICIPAL..','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.06.00.00.00','ENCARGOS SOCIAIS SOBRE PROVISOES','COMPREENDE OS VALORES DOS ENCARGOS SOCIAIS SOBRE PROVISOES PARA 13° .SALARIO, FERIAS, LICENCA-PREMIO E OUTRAS CONSTITUIDAS NA FORMA DA LEI SOBRE A FOLHA DE PAGAMENTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.06.01.00.00','INSS','REGISTRA OS VALORES PROVISIONADOS RELATIVOS A CONTRIBUICAO PARA O INSS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.06.02.00.00','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS PROVISIONADOS RELATIVOS  AO FGTS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.06.03.00.00','RPPS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS PROVISIONADOS RELATIVOS  AO RPPS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.07.00.00.00','AGENTES POLÍTICOS','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DA REMUNERAÇÃO  DEVIDA AOS AGENTES POLÍTICOS, RELATIVAS AO EXERCÍCIO ATUAL.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.02.00.00.00.00','PESSOAL A PAGAR DE EXERCICIOS ANTERIORES','COMPREENDE AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS A EXERCICIOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.02.01.00.00.00','SALÁRIOS, REMUNERAÇÕES E BENEFÍCIOS DE EXERCÍCIOS ANTERIORES','REGISTRA AS OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS A EXERCICIOS ANTERIORES.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.00.00.00.00','PRECATORIOS DE PESSOAL','COMPREENDE OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.01.00.00.00','PRECATORIOS DE PESSOAL DO EXERCICIO','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.02.00.00.00','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES -  ANTES DE 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, ANTERIORES A 05/05/2000 (LRF).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.02.01.00.00','PESSOAL - ANTERIORES A 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, ATE     05/05/2000.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.02.02.00.00','PRECATORIOS DE PESSOAL - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, ATE 05/05/2000 DO PODER EXCUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.02.03.00.00','PRECATORIOS DE PESSOAL - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, ATE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.02.04.00.00','PRECATORIOS DE PESSOAL - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, ATE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.03.00.00.00','PRECATÓRIOS DE PESSOAL DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/5/2000','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LRF).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.03.01.00.00','PESSOAL - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, A PARTIR DE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.03.02.00.00','PESSOAL - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS  DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, A PARTIR DE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.03.03.00.00','PESSOAL - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS  DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, A PARTIR DE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.0.00.00.00.00.00','BENEFICIOS PREVIDENCIARIOS A PAGAR','Compreende as obrigações a curto prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.01.00.00.00.00','BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS NO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.02.00.00.00.00','BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS EM EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.03.00.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.03.01.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.03.02.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.03.03.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.2.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - INTRA','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.3.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - INTER UNIÃO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.4.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - INTER ESTADO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Estado.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.5.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - INTER MUNICIPIO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Município.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.3.0.00.00.00.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR','Compreende as obrigações a curto prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.3.1.00.00.00.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.3.1.01.00.00.00.00','BENEFICIOS ASSISTENCIAIS A PAGAR DO EXERCICIO','REGISTRA AS OBRIGACOES RELATIVAS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL LIQUIDADOS NO EXERCICIO E AINDA NAO PAGOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.3.1.02.00.00.00.00','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, DE EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.0.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR','Compreende as obrigações a curto prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.01.00.00.00.00','INSS A PAGAR','COMPREENDE OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL,  INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS E SOBRE SERVIÇOS DE TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.01.01.00.00.00','INSS - CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL,  INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.01.02.00.00.00','INSS - DÉBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.01.03.00.00.00','INSS - CONTRIBUIÇÃO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES INCIDENTES SOBRE SERVIÇOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.01.04.00.00.00','INSS - FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','REGISTRA OS VALORES RELATIVOS AS FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL .','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.03.00.00.00.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES COM  O  PLANO DE SEGURIDADE DO SERVIDOR .','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.04.00.00.00.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA','COMPREENDE OS VALORES RELATIVOS AS OBRIGAÇÕES COM REGIMES PRÓPRIOS DE   PREVIDENCIA, NÃO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.04.01.00.00.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA DO ENTE','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES COM REGIMES PRÓPRIOS DE   PREVIDENCIA DE PESSOAL DO ENTE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.04.02.00.00.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA - PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES COM REGIMES PRÓPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.06.00.00.00.00','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.08.00.00.00.00','ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR','COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.08.01.00.00.00','CONTRIBUICAO A ENTIDADES DE PREVIDENCIA PRIVADA E ASSISTENCIA MEDICO-ODONTOLOGICA','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS  A   RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA E DE ASSISTENCIA MEDICO - ODONTOLOGICA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.08.02.00.00.00','CONTRIBUICAO PREVIDENCIA PRIVADA E ASSISTENCIA MEDICO-ODONTOLOGICA - DE EXERCICIOS ANTERIORES','DESTINADA AOS REGISTROS DOS VALORES DOS ENCARGOS SOCIAIS  A   RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA  PRIVADA E DE ASSISTENCIA MEDICO-ODONTOLOGICA DE EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS - CONSOLIDAÇÃO','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.04.00.00.00.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE   PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.04.01.00.00.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS) DO EXERCÍCIO','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE REFERENTES AO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.04.02.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS - DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS LIQUIDADAS E  NÃO PAGAS DENTRO DO EXERCICIO, FICANDO PORTANTO EM RESTOS A PAGAR','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.08.00.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.08.01.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.08.02.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.00.00.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS','COMPREENDE OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.01.00.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS - DO EXERCICIO','COMPREENDE OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO EM CURSO, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.01.01.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT - DO EXERCICIO - APOSENTADORIAS EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO EM CURSO, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS  APOSENTADORIAS DO  EXECUTIVO / INDIRETAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.01.02.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT - DO EXERCICIO - APOSENTADORIAS LEGISLATIVO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO EM CURSO, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS  APOSENTADORIAS DO  LEGISLATIVO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.01.03.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT - DO EXERCICIO - PENSOES','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO EM CURSO, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS  PENSOES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.02.00.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS - DO EXERCICIO ANTERIOR','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.02.01.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT - DO EXERCICIO ANTERIOR - APOSENTADORIAS -  EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS  APOSENTADORIAS DO  EXECUTIVO / INDIRETAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.02.02.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT - DO EXERCICIO ANTERIOR - APOSENTADORIAS - LEGISLATIVO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS  APOSENTADORIAS DO  LEGISLATIVO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.02.03.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT - DO EXERCICIO ANTERIOR - PENSOES','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS  PENSOES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.00.00.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DA FONTE TESOURO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DE  RESPONSABILIDADE DA FONTE TESOURO NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.01.00.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DA FONTE TESOURO - DO EXERCICIO','COMPREENDE OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.01.01.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DA FONTE TESOURO - DO EXERCICIO - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DO EXECUTIVO / INDIRETAS DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.01.02.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DA FONTE TESOURO - DO EXERCICIO - LEGISLATIVO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DO LEGISLATIVO DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.01.03.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSOES DA FONTE TESOURO - DO EXERCICIO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSOES DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.02.00.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DA FONTE TESOURO - DO EXERCICIO ANTERIOR','COMPREENDE OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.02.01.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DA FONTE TESOURO - DO EXERCICIO ANTERIOR - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DO EXECUTIVO / INDIRETAS DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.02.02.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DA FONTE TESOURO - DO EXERCICIO ANTERIOR - LEGISLATIVO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DO LEGISLATIVO DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.02.03.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSOES DA FONTE TESOURO - DO EXERCICIO ANTERIOR','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSOES DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.23.00.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR','COMPREENDE OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE PARA O   PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR LIQUIDADAS E  AINDA NÃO PAGAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.23.01.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR - DO EXERCICIO','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE PARA O   PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR LIQUIDADAS E  AINDA NÃO PAGAS DURANTE O EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.23.02.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR - DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE PARA O   PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR LIQUIDADAS E  AINDA NÃO PAGAS REFERENTES AO EXERCICIO ANTERIOR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS - INTRA','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.00.00.00.00','INSS A PAGAR','COMPREENDE OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL,  INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.01.00.00.00','INSS - DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE  SALARIOS PAGOS OU CREDITADOS  DEVIDOS POR ENCARGOS DO EMPREGADOR (UNIDADE) A PREVIDENCIA SOCIAL. REFERENTES AO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.02.00.00.00','INSS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE  SALARIOS PAGOS OU CREDITADOS, OU SERVICOS DE TERCEIROS  DEVIDOS POR ENCARGOS DO EMPREGADOR (UNIDADE) A PREVIDENCIA SOCIAL. REFERENTES A  RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS E DEVERAO SER DESDOBRADAS POR EXERCICIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.03.00.00.00','INSS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE  SALARIOS PAGOS OU CREDITADOS, OU SERVICOS DE TERCEIROS  DEVIDOS POR ENCARGOS DO EMPREGADOR (UNIDADE) A PREVIDENCIA SOCIAL. REFERENTES A  RESTOS A PAGAR PROCESSADOS - LEGISLATIVO E DEVERAO SER DESDOBRADAS POR EXERCICIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.04.00.00.00','INSS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE  SALARIOS PAGOS OU CREDITADOS, OU SERVICOS DE TERCEIROS  DEVIDOS POR ENCARGOS DO EMPREGADOR (UNIDADE) A PREVIDENCIA SOCIAL. REFERENTES A  RESTOS A PAGAR PROCESSADOS - RPPS E DEVERAO SER DESDOBRADAS POR EXERCICIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.05.00.00.00','INSS - CONTRIBUICAO SOBRE SERVICOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','COMPREENDE OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE SERVICOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.05.01.00.00','INSS - CONTRIBUICAO SOBRE SERVICOS DE TERCEIROS OU CONTRIBUINTES AVULSOS - DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDIDAS SOBRES SERVICOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.05.02.00.00','INSS - CONTRIBUICAO SOBRE SERVICOS DE TERCEIROS OU CONTRIBUINTES AVULSOS - DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDIDAS SOBRES SERVICOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS DE  EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.06.00.00.00.00','FGTS','COMPREENDE OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.06.01.00.00.00','FGTS - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS GERADOS POR PAGAMENTOS DE SALARIOS A RECOLHER AO FGTS REFERENTES AO EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.06.02.00.00.00','FGTS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS GERADOS POR PAGAMENTOS DE SALARIOS A RECOLHER AO FGTS REFERENTES A RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.06.03.00.00.00','FGTS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS GERADOS POR PAGAMENTOS DE SALARIOS A RECOLHER AO FGTS REFERENTES A RESTOS A PAGAR PROCESSADOS - LEGISLATIVO E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.06.04.00.00.00','FGTS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS GERADOS POR PAGAMENTOS DE SALARIOS A RECOLHER AO FGTS REFERENTES A RESTOS A PAGAR PROCESSADOS - RPPS E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.08.00.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA','COMPREENDE OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.08.01.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.08.02.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.20.00.00.00.00','PIS/PASEP','COMPREENDE OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALARIOS A RECOLHER AO FUNDO DE PARTICIPACAO DESTINADO A EXECUCAO    DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALARIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.20.01.00.00.00','PIS/PASEP - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALARIOS A RECOLHER AO FUNDO DE PARTICIPACAO DESTINADO A EXECUCAO    DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALARIOS RELATIVOS AO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.20.02.00.00.00','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALARIOS A RECOLHER AO FUNDO DE PARTICIPACAO DESTINADO A EXECUCAO    DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALARIOS RELATIVOS A RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS E','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.20.03.00.00.00','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALARIOS A RECOLHER AO FUNDO DE PARTICIPACAO DESTINADO A EXECUCAO    DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALARIOS RELATIVOS A RESTOS A PAGAR PROCESSADOS - LEGISLATIVO E DEVERAO SE','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.20.04.00.00.00','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALARIOS A RECOLHER AO FUNDO DE PARTICIPACAO DESTINADO A EXECUCAO    DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALARIOS RELATIVOS A RESTOS A PAGAR PROCESSADOS - RRPS E DEVERAO SER DESDO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS - INTER - UNIÃO','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.01.00.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS DO ESTADO - DO EXERCICIO','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS DO ESTADO  LIQUIDADAS E AINDA NÃO PAGAS DURANTE O EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.02.00.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS DO ESTADO - DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS DO ESTADO  LIQUIDADAS E NÃO PAGAS DENTRO DO EXERCICIO, FICANDO PORTANTO EM RESTOS A PAGAR','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.03.00.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA','COMPREENDE OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.03.01.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.03.02.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS - INTER ESTADO','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.01.00.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS DE OUTROS MUNICIPIOS - DO EXERCICIO','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS DE OUTROS MUNICIPIOS LIQUIDADAS E AINDA NÃO PAGAS DURANTE O EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.02.00.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS DE OUTROS MUNICIPIOS - DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS DE OUTROS MUNICIPIOS LIQUIDADAS E  NÃO PAGAS DENTRO DO EXERCICIO, FICANDO PORTANTO EM RESTOS A PAGAR','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.03.00.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA','COMPREENDE OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.03.01.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.03.02.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS - INTER - MUNICIPIOS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.0.0.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO','Compreende as obrigações financeiras externas e internas da entidade a titulo de empréstimos, bem como as aquisições efetuadas diretamente com o fornecedor, com vencimentos no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.0.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.01.00.00.00.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS INTERNOS','REGISTRA AS PARCELAS DOS EMPRESTIMOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.02.00.00.00.00','EMPRESTIMOS INTERNOS - EM TITULOS','REGISTRA O RECONHECIMENTO DOS EMPRÉSTIMOS DECORRENTES DE TÍTULOS MOBILIÁRIOS ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO ATÉ O TERMINO DO EXERCÍCIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.03.00.00.00.00','EMPRESTIMOS INTERNOS -  EM CONTRATOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.03.03.00.00.00','CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.03.05.00.00.00','CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.03.07.00.00.00','ANTECIPACAO DE RECEITA ORCAMENTARIA','REGISTRA OS VALORES REFERENTES A OPERACOES DE CREDITO POR ANTECIPACAO DE RECEITA DESTINADA A ATENDER INSUFICIENCIA DE CAIXA DURANTE O EXERCICIO FINANCEIRO, DEVENDO CUMPRIR AS EXIGENCIAS MENCIONADAS NO ART. 32 DA LEI COMPLEMENTAR Nº 101, PUBLICADA EM 04/05/2000 E AQUELAS PREVISTAS NO ART. 38 DA REFERIDA LEI.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.03.10.00.00.00','OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES - DO EXERCICIO','REGISTRA O VALOR DAS OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.03.98.00.00.00','OUTROS CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS, PARA AS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - INTER OFSS - UNIÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.01.00.00.00.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS INTERNOS','REGISTRA AS PARCELAS DOS EMPRESTIMOS ASSUMIDOS CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.02.00.00.00.00','EMPRESTIMOS INTERNOS - EM TITULOS','REGISTRA O RECONHECIMENTO DOS EMPRÉSTIMOS DECORRENTES DE TÍTULOS MOBILIÁRIOS COM VENCIMENTO ATÉ O TERMINO DO EXERCÍCIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.03.00.00.00.00','EMPRESTIMOS INTERNOS -  EM CONTRATOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.03.01.00.00.00','CONTRATOS DE EMPRESTIMOS DO EXERCICIO','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.03.02.00.00.00','CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.03.03.00.00.00','OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES - DO EXERCICIO','REGISTRA O VALOR DAS OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.03.98.00.00.00','DEMAIS EMPRESTIMOS INTERNOS -  EM CONTRATOS','REGISTRA OS DEMAIS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS NÃO COMPREENDIDOS NAS CONTAS ACIMA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.4.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - INTER OFSS - ESTADO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.5.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.0.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO- EXTERNO CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.01.00.00.00.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS EXTERNOS','REGISTRA AS PARCELAS DOS EMPRESTIMOS EXTERNOS ASSUMIDOS, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.03.00.00.00.00','EMPRESTIMOS EXTERNOS -  EM CONTRATOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITO EXTERNAS EM CONTRATOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.03.01.00.00.00','CONTRATOS DE EMPRESTIMOS DO EXERCICIO','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.03.02.00.00.00','CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.03.10.00.00.00','OPERACOES DE CREDITO EXTERNAS COM PRAZO INFERIOR A DOZE MESES - DO EXERCICIO','REGISTRA O VALOR DAS OPERACOES DE CREDITO EXTERNAS COM PRAZO INFERIOR A DOZE MESES','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.03.98.00.00.00','DEMAIS EMPRESTIMOS EXTERNOS -  EM CONTRATOS','REGISTRA OS DEMAIS VALORES DAS OPERACOES DE CREDITO EXTERNOS EM CONTRATOS NÃO COMPREENDIDOS NAS CONTAS ACIMA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.0.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO - INTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO- INTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.01.00.00.00.00','PARCELA A CURTO PRAZO DOS FINANCIAMENTOS INTERNOS','REGISTRA AS PARCELAS DOS FINANCIAMENTOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.02.00.00.00.00','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.02.01.00.00.00','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.02.02.00.00.00','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.02.98.00.00.00','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES  DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.03.00.00.00.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO- INTERNO -INTER OFSS - UNIÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.01.00.00.00.00','PARCELA A CURTO PRAZO DOS FINANCIAMENTOS INTERNOS','REGISTRA AS PARCELAS DOS FINANCIAMENTOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.02.00.00.00.00','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.02.01.00.00.00','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.02.02.00.00.00','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.02.98.00.00.00','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES  DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.03.00.00.00.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO - INTERNO - INTER OFSS - ESTADO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.01.00.00.00.00','PARCELA A CURTO PRAZO DOS FINANCIAMENTOS INTERNOS','REGISTRA AS PARCELAS DOS FINANCIAMENTOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.02.00.00.00.00','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.02.01.00.00.00','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.02.02.00.00.00','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.02.98.00.00.00','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES  DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.03.00.00.00.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO - INTERNO - INTER OFSS - MUNICÍPIO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.01.00.00.00.00','PARCELA A CURTO PRAZO DOS FINANCIAMENTOS INTERNOS','REGISTRA AS PARCELAS DOS FINANCIAMENTOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.02.00.00.00.00','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.02.01.00.00.00','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.02.02.00.00.00','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.02.98.00.00.00','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES  DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.03.00.00.00.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.0.00.00.00.00.00','FINANCIAMENTO A CURTO PRAZO - EXTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.00.00.00.00.00','FINANCIAMENTO A CURTO PRAZO - EXTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no curto prazo.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.01.00.00.00.00','PARCELA A CURTO PRAZO DOS FINANCIAMENTOS EXTERNOS','REGISTRA AS PARCELAS DOS FINANCIAMENTOS EXTERNOS ASSUMIDOS CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.02.00.00.00.00','FINANCIAMENTOS EXTERNOS','COMPREENDE OS VALORES DOS FINANCIAMENTOS EXTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.02.01.00.00.00','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS  A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.02.98.00.00.00','OUTROS FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES  DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.03.00.00.00.00','FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.0.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.01.01.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.01.02.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.01.03.00.00.00','JUROS PRO-RATA  SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.02.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.02.01.00.00.00','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.02.02.00.00.00','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.03.01.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.03.02.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.03.03.00.00.00','JUROS PRO-RATA  SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.04.01.00.00.00','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.04.02.00.00.00','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO -INTER OFSS - UNIÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.01.01.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.01.02.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.01.03.00.00.00','JUROS PRO-RATA  SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.02.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.02.01.00.00.00','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.02.02.00.00.00','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.03.01.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.03.02.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.03.03.00.00.00','JUROS PRO-RATA  SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.04.01.00.00.00','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.04.02.00.00.00','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO -INTER OFSS - ESTADO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.02.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.5.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO -INTER OFSS - MUNICÍPIO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.0.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - EXTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - EXTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.02.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.0.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR - INTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.1.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR - INTERNO - CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.3.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR - INTERNO - INTER OFSS - UNIÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.4.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR - INTERNO - INTER OFFS - ESTADO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.5.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR - INTERNO - INTER OFSS - MUNICÍPIO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.9.0.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.9.1.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR- CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.0.0.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR A CURTO PRAZO','Compreende as obrigações junto a fornecedores de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar, inclusive os precatórios decorrentes dessas obrigações, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.0.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.01.00.00.00.00','FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.02.00.00.00.00','FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.00.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.01.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.02.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES - ANTERIORES A 05/05/2000','COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES, ANTERIORES A 05/05/2000  (LEI DE RESPONSABILIDADE FISCAL).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.02.01.00.00','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.02.02.00.00','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.02.03.00.00','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.03.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000','COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.03.01.00.00','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS  DE  PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.03.02.00.00','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE  PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.03.03.00.00','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE  PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.04.00.00.00.00','CONTAS A PAGAR CREDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES AO EXERCICIO ATUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.04.01.00.00.00','CONTAS A PAGAR  DO EXERCICIO','REGISTRA O RECONHECIMENTO PATRIMONIAL DE VALORES A PAGAR AOS CREDORES NACIONAIS DE BENS, MATERIAIS E SERVIÇOS, REFERENTES AO EXERCICIO ATUAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.04.02.00.00.00','CONTAS A PAGAR  DO EXERCICIO - EMPENHADOS','REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DE BENS, MATERIAIS E SERVIÇOS, REFERENTES AO EXERCICIO ATUAL, QUE JÁ PASSARAM PELA EXECUÇÃO ORÇAMENTÁRIA DA DESPESA (EMPENHO).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.05.00.00.00.00','CONTAS A PAGAR CREDORES NACIONAIS DE EXERCICIOS ANTERIORES','COMPREENDE OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES A EXERCICIOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.05.01.00.00.00','CREDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA O MONTANTE DAS DESPESAS COM CREDORES REALIZADAS E LIQUIDADAS PELO PODER EXECUTIVO E ENTIDADES DA ADMINISTRAÇÃO INDIRETA E NÃO PAGAS ATÉ 31 DE DEZEMBRO DO ANO ANTERIOR E DEVEM SER DESDOBRADAS POR EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.05.02.00.00.00','CREDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA O MONTANTE DAS DESPESAS COM CREDORES REALIZADAS E LIQUIDADAS PELO PODER LEGISLATIVO E NÃO PAGAS ATÉ 31 DE DEZEMBRO DO ANO ANTERIOR E DEVERAO SER DESDOBRADAS POR EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.05.03.00.00.00','CREDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA O MONTANTE DAS DESPESAS COM CREDORES REALIZADAS E LIQUIDADAS PELO REGIME PRÓPRIO DE PREVIDÊNCIA DO SERVIDOR E NÃO PAGAS ATÉ 31 DE DEZEMBRO DO ANO ANTERIOR E DEVERAO SER DESDOBRADAS POR EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.00.00.00.00','PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.01.00.00.00','PRECATORIOS DE  CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DO EXERCICIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.00.00.00','PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES','COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DE EXERCICIOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.01.00.00','PRECATORIOS A PAGAR (ANTERIORES 05/05/2000)','COMPREENDE O VALOR DOS PRECATORIOS A PAGAR  REFERENTE A PESSOAL, FORNECEDORES E TERCEIROS, ANTERIORES A 05/05/2000.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.01.01.00','CREDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.01.02.00','CREDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.01.03.00','CREDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.02.00.00','CREDORES - A PARTIR DE 05/05/2000','COMPREENDE OS VALORES DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.02.01.00','CREDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS  DE  PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.02.02.00','CREDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE  PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.02.03.00','CREDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE  PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.07.00.00.00.00','POR INSUFICIENCIA DE CREDITOS/RECURSOS','REGISTRA OS VALORES DAS OBRIGACOES TRIBUTARIAS DEVIDAMENTE RECONHECIDAS, DE FORDECEDORES E/OU CREDORES DE BENS E/OU SERVICOS, NAO CONTEMPLADAS PELA EXECUCAO ORCAMENTARIA EM VIRTUDE DA LIMITACAO DA  PROGRAMACAO  FINANCEIRA OU POR INSUFICEINCIA DE CREDITOS, OU AINDA EM FASE DE IDENTIFICACAO DOCREDITO ORCAMENTARIO, CONFORME DISPOSTO NA NOTA TECNICA STN/CCONT  Nº2309, DE 28 DE DEZEMBRO DE 2007.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.0.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO','Compreende as obrigações junto a fornecedores estrangeiros de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores estrangeiros de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.01.00.00.00.00','FORNECEDORES ESTRANGEIROS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.02.00.00.00.00','FORNECEDORES ESTRANGEIROS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.03.00.00.00.00','CONTAS A PAGAR - CREDORES ESTRANGEIROS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS CREDORES ESTRANGEIROS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES AO EXERCICIO ATUAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.04.00.00.00.00','CONTAS A PAGAR - CREDORES ESTRANGEIROS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS CREDORES ESTRANGEIROS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.0.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO','Compreende as obrigações das entidades com o governo relativas a impostos, taxas e contribuições com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO- CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.01.00.00.00.00','IPI A RECOLHER','REGISTRA O VALOR DAS OBRIGAÇÕES TRIBUTÁRIAS A RECOLHER REFERENTES AO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS DAS UNIDADES INDUSTRIAIS OU COM CARACTERISTICAS DESSAS, GERADAS PELAS VENDAS DE PRODUTOS INDUSTRIAIS E SUJEITAS A COMPENSACAO COM OS CRÉDITOS ADQUIRIDOS POR COMPRAS DE MATÉRIAS-PRIMAS, EM CONFORMIDADE COM A SISTEMATICA DE APURACAO DESSE IMPOSTO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.02.00.00.00.00','IRPJ A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO DE RENDA PESSOA JURIDICA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.11.00.00.00.00','PIS/PASEP A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO PROGRAMA DE INTEGRACAO SOCIAL (PIS) E PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO ( PASEP).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.11.01.00.00.00','PIS/PASEP - DO EXERCICIO','REGISTRA AS OBRIGACOES REALTIVAS AO PIS/PASEP REFERENTE A COMPETENCIA DO EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.11.02.00.00.00','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA AS OBRIGACOES REALTIVAS AO PIS/PASEP REFERENTE A COMPETENCIA DE EXERCICOS ANTERIORES REGISTRADAS EM RESTOS A PAGAR DO PODER EXECUTIVO E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.11.03.00.00.00','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA AS OBRIGACOES REALTIVAS AO PIS/PASEP REFERENTE A COMPETENCIA DE EXERCICOS ANTERIORES REGISTRADAS EM RESTOS A PAGAR DO PODER LEGISLATIVO E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.11.04.00.00.00','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA AS OBRIGACOES REALTIVAS AO PIS/PASEP REFERENTE A COMPETENCIA DE EXERCICOS ANTERIORES REGISTRADAS EM RESTOS A PAGAR DO RPPS E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.12.00.00.00.00','TRIBUTOS FEDERAIS RENEGOCIADOS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS FEDERAIS QUE TENHAM SIDO RENEGOCIADOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.13.00.00.00.00','RECURSOS FISCAIS - DARF A EMITIR','REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELAS REPARTICOES PUBLICAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, OU SEJA, VALORES A SEREM RECOLHIDOS POR MEIO DE DARF. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, POR MEIO DE DOCUMENTO DE ARRECADACAO DE RECEITAS FEDERAIS (DARF).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.99.00.00.00.00','OUTROS TRIBUTOS E CONTRIBUICOES FEDERAIS  A RECOLHER','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS','Compreende as obrigações das entidades com os tributos de competência estadual com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS- CONSOLIDAÇÃO','Compreende as obrigações das entidades com os tributos de competência estadual com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.01.00.00.00.00','ICMS A RECOLHER','COMPREENDE O VALOR DAS OBRIGAÇÕES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVIÇOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVIÇOS (ICMS), SUJEITOS A COMPENSAÇÕES COM OS CRÉDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVIÇOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO OU SOBRE MERCADORIAS DE TERCEIROS ENTREGUES PARA DEPOSITO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.01.01.00.00.00','ICMS A RECOLHER - SOBRE MERCADORIAS PARA REVENDA','REGISTRA O VALOR DAS OBRIGAÇÕES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVIÇOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVIÇOS (ICMS), SUJEITAS A COMPENSAÇÕES COM OS CRÉDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVIÇOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.01.02.00.00.00','ICMS A RECOLHER - SOBRE MERCADORIAS DE TERCEIROS PARA DEPOSITO','REGISTRA O VALOR DAS OBRIGAÇÕES EXIGIVEIS EM FUNCAO DA ENTRADA DE MERCADORIAS DE TERCEIROS ENTREGUES A UNIDADE PARA DEPOSITO EM ARMAZEM.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.02.00.00.00.00','IPVA A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES (IPVA).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.03.00.00.00.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.06.00.00.00.00','TAXA DE LICENCIAMENTO ANUAL DE VEICULOS','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTE AO PAGAMENTO DA TAXA DE LICENCIAMENTO ANUAL DE VEICULOS, DECORRENTE DO SERVICO DE LICENCIAMENTO DE VEICULOS AUTOMOTORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.07.00.00.00.00','RECURSOS FISCAIS ESTADUAIS','REGISTRA O VALOR DOS CREDITOS FISCAIS ORIUNDOS DE RECEBIMENTOS DE TRIBUTOS ESTADUAIS CUJO RECOLHIMENTO E REALIZADO POR MEIO DE DAR. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, POR MEIO DE DOCUMENTO DE ARRECADACAO (DAR).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.08.00.00.00.00','TAXA DE LICENCIAMENTO AMBIENTAL','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.99.00.00.00.00','OUTROS TRIBUTOS E CONTRIBUICOES ESTADUAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS','Compreende as obrigações das entidades com os tributos de competência municipal com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com os tributos de competência municipal com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.01.00.00.00.00','ISS A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA (ISS)  EM QUE A PROPRIA UNIDADE SEJA A PRESTADORA  DO SERVICO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.02.00.00.00.00','IPTU/TLP A RECOLHER','REGISTRA O VALOR  DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA (IPTU) E TAXA DE LIMPEZA PUBLICA (TLP).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.03.00.00.00.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS A TRIBUTOS QUE  FORAM RENEGOCIADOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.04.00.00.00.00','CONTRIBUICAO PARA O CUSTEIO DE ILUMINAÇÃO PUBLICA A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL REFERENTES A CONTRIBUICAO PARA CUSTEIO DE ILUMINACAO PUBLICA.(ART.149-A DA CONSTITUICAO FEDERAL)','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.06.00.00.00.00','RECURSOS FISCAIS MUNICIPAIS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO MUNICIPAL, POR MEIO DE DOCUMENTO DE ARRECADACAO (DAR).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.07.00.00.00.00','TAXA DE LICENCIAMENTO AMBIENTAL','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.08.00.00.00.00','TAXA DE INSPEÇÃO VEICULAR','REGISTRA O VALOR DAS OBRIGAÇÕES JUNTO AO GOVERNO MUNICIPAL REFERENTES A CTAXA DE INSPEÇÃO VEICULAR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.99.00.00.00.00','OUTROS TRIBUTOS E CONTRIBUICOES MUNICIPAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO  HAJA  CONTAS ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.5.0.0.00.00.00.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.5.0.3.00.00.00.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - UNIÃO','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.5.0.4.00.00.00.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - ESTADO','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.5.0.5.00.00.00.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - MUNICÍPIO','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.0.0.00.00.00.00.00','PROVISÕES A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.1.0.00.00.00.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.1.1.00.00.00.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.1.1.01.00.00.00.00','PROVISAO PARA INDENIZAÇÕES TRABALHISTAS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE INDENIZAÇÕES TRABALHISTAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.1.1.02.00.00.00.00','PROVISAO PARA PAGAMENTO DE DISSIDIOS COLETIVOS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE DISSIDIOS COLETIVOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.0.00.00.00.00.00','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.00.00.00.00.00','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.01.00.00.00.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTOS DE INFRAÇÃO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.01.01.00.00.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO NÃO RECORRIDOS','REGISTRA OS VALORES RELATIVOS A PROVISÃO REFERENTE A AUTOS DE INFRAÇÃO NÃO RECORRIDOS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.01.02.00.00.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO RECORRIDOS','REGISTRA OS VALORES RELATIVOS A  PROVISÃO REFERENTE  A AUTOS DE INFRAÇÃO RECORRIDOS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.02.00.00.00.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS - ESFERA JUDICIAL','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUAÇÕES FICAIS - ESFERA JUDICIAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.02.01.00.00.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','REGISTRA OS VALORES RELATIVOS A  PROVISÃO REFERENTE A AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.02.02.00.00.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','REGISTRA OS VALORES RELATIVOS A  PROVISÃO REFERENTE A AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.4.0.00.00.00.00.00','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.4.1.00.00.00.00.00','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.4.1.01.00.00.00.00','PROVISÃO PARA INDENIZAÇÕES CÍVEIS','REGISTRA OS VALORES RELATIVOS A  PROVISÃO PARA  PAGAMENTO DE SPARA INDENIZAÇÕES CÍVEIS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.5.0.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta específica de passivo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.5.3.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.5.4.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.5.5.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.6.0.00.00.00.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.6.1.00.00.00.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO- CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP. Compreende os valores de operações efetuadas entre uma unidade pertencente ao orçamento fiscal e da seguridade social (OFSS) com pessoa ou unidade que não pertença ao OFSS de ente público, alem dos demais fatos que não compreendem transações entre partes.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.9.0.00.00.00.00.00','OUTRAS PROVISÕES A CURTO PRAZO','Compreende os demais passivos de prazo ou de valor incertos, com prazo provável no curto prazo, não classificadas anteriormente neste plano de contas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.9.1.00.00.00.00.00','OUTRAS PROVISÕES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os demais passivos de prazo ou de valor incertos, com prazo provável no curto prazo, não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.0.0.00.00.00.00.00','DEMAIS OBRIGAÇÕES A CURTO PRAZO','Compreende as obrigações da entidade junto a terceiros não inclusas nos subgrupos anteriores, com vencimento no curto prazo, inclusive os precatórios decorrentes dessas obrigações, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.1.0.00.00.00.00.00','ADIANTAMENTOS DE CLIENTES','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.1.1.00.00.00.00.00','ADIANTAMENTOS DE CLIENTES- CONSOLIDAÇÃO','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.2.0.00.00.00.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS','Compreende os valores exigíveis no curto prazo, provenientes de danos a terceiros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.2.1.00.00.00.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS - CONSOLIDAÇÃO','Compreende os valores exigíveis no curto prazo, provenientes de danos a terceiros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.3.0.00.00.00.00.00','ARRENDAMENTO OPERACIONAL A PAGAR','Compreende as obrigações a curto prazo referentes a arrendamentos mercantis, nos quais não são transferidos ao arrendador os riscos e benefícios inerentes a propriedade, não havendo a possibilidade de opção de compra do bem arrendado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.3.1.00.00.00.00.00','ARRENDAMENTO OPERACIONAL A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações a curto prazo referentes a arrendamentos mercantis, nos quais não são transferidos ao arrendador os riscos e benefícios inerentes a propriedade, não havendo a possibilidade de opção de compra do bem arrendado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.4.0.00.00.00.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A CURTO PRAZO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.4.1.00.00.00.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A CURTO PRAZO- CONSOLIDAÇÃO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.5.0.00.00.00.00.00','DIVIDENDOS A PAGAR','Compreende os dividendos aprovados pela assembleia geral a serem pagos aos acionistas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.5.1.00.00.00.00.00','DIVIDENDOS A PAGAR- CONSOLIDAÇÃO','Compreende os dividendos aprovados pela assembleia geral a serem pagos aos acionistas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.0.00.00.00.00.00','VALORES RESTITUÍVEIS','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, independentemente do prazo de exigibilidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.00.00.00.00.00','VALORES RESTITUÍVEIS - CONSOLIDAÇÃO','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, independentemente do prazo de exigibilidade.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.00.00.00.00','CONSIGNACOES','COMPREENDE OS VALORES ENTREGUES EM CONFIANCA OU EM CONSIGNACOES, GERALMENTE RETIDOS EM FOLHA DE PAGAMENTO DE EMPREGADOS OU SERVIDORES OU NOS PAGAMENTOS REFERENTES A COMPRAS DE BENS E SERVICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.02.00.00.00','INSS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE EMPREGADOS REGIDOS PELA CONSOLIDACAO DAS LEIS DO TRABALHO (CLT) E AGENTES POLITICOS OU DE  SERVICOS DE TERCEIROS, A SER RECOLHIDO AO INSTITUTO NACIONAL DO SEGURO SOCIAL/PREVIDENCIA SOCIAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.03.00.00.00','ENCARGOS SOCIAIS - OUTRAS ENTIDADES','REGISTRA O VALOR A SER RECOLHIDO A OUTRAS ENTIDADES, EM  FUNCAO DE DISPOSITIVOS LEGAIS COM AS QUAIS A ENTIDADE  MANTENHA CONVENIO DE ARRECADACAO DIRETA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.04.00.00.00','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF DEVIDO AO TESOURO MUNICIPAL','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DO IMPOSTO SOBRE A RENDA, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS  OU CREDITADAS A SERVIDORES OU EMPREGADOS, SOBRE AS QUAIS INCIDA O REFERIDO IMPOSTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.04.01.00.00','RETENCAO IRRF S/RENDIMENTO TRABALHO SERVIDORES ATIVOS','REPRESENTA VALORES MONETÁRIOS RETIDOS NA FOLHA DE PAGAMENTO DE SERVIDORES ATIVOS REFERENTE AO IRRF','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.04.02.00.00','RETENCAO IRRF S/RENDIMENTO TRABALHO SERVIDORES INATIVOS/PENSIONISTAS','REPRESENTA VALORES MONETÁRIOS RETIDOS NA FOLHA DE PAGAMENTO DE SERVIDORES INATIVOS E PENSIONISTAS REFERENTE AO IRRF.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.04.03.00.00','IMPOSTOS A REPASSAR - IRRF','REPRESENTA VALORES MONETÁRIOS DE IMPOSTOS A REPASSAR - IRRF.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.04.04.00.00','DEVOLUCAO DO IRRF','REPRESENTA VALORES MONETÁRIOS DE DEVOLUÇÃO DO IRRF.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.05.00.00.00','INDENIZACOES E RESTITUICOES','REGISTRA OS VALORES RELATIVOS AS INDENIZACOES E RESTITUICOES DE TRIBUTOS COM AUTORIZACOES CONCEDIDAS, POREM NAO DEVOLVIDAS AOS LEGITIMOS CREDORES PELA UNIDADE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.06.00.00.00','IMPOSTOS E CONTRIBUICOES DIVERSOS','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA UNIDADE, DE IMPOSTOS E CONTRIBUICOES DIVERSOS, RELATIVAS AS IMPORTANCIAS PAGAS   A TERCEIROS, SOBRE OS QUAIS INCIDAM OS REFERIDOS TRIBUTOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.07.00.00.00','OUTROS TRIBUTOS DO TESOURO NACIONAL','REGISTRA OS VALORES RELATIVOS A OUTROS TRIBUTOS DO TESOURO NACIONAL RETIDOS PELA UNIDADE SOBRE VALORES   PAGOS OU CREDITADOS E QUE, SOBRE OS QUAIS, INCIDA O REFERIDO TRIBUTO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.08.00.00.00','ICMS','REGISTRA OS VALORES RELATIVOS AO IMPOSTO SOBRE A CIRCULACAO DE  MERCADORIAS E SERVICOS RETIDOS POR FORCA DE LEGISLACAO OU POR ACORDO  ENTRE AS PARTES ENVOLVIDAS NA TRANSACAO EM CONSIGNACOES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.09.00.00.00','ISS','REGISTRA OS VALORES DO IMPOSTO SOBRE SERVICOS RETIDO EM CONSIGNACOES  POR FORCA DE LEGISLACAO, CIRCUNSTANCIAS OU ACORDO ENTRE AS PARTES ENVOLVIDOS NA TRANSACAO, EM SITUACOES QUE A UG COMO PARTE CONTRATANTE,  ATUE COMO SUBSTITUTA TRIBUTARIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.13.00.00.00','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS','REGISTRA OS VALORES EM CONSIGNACAO RELATIVOS A TRIBUTOS DEVIDOS A ESTADOS E MUNICIPIOS QUE NAO POSSUEM CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.14.00.00.00','PENSAO ALIMENTICIA','REGISTRA OS VALORES DAS RETENCOES PROCEDIDAS EM PAGAMENTOS A  EMPREGADOS OU A SERVIDORES AUTORIZADOS POR ESSES OU POR DETERMINACAO  JUDICIAL, A TITULO DE PENSAO ALIMENTICIA DESTINADA A MANUTENCAO DE FAMILIAR','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.15.00.00.00','PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS  DE  PAGAMENTO  DO  PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES DE PREVIDENCIA E ASSISTENCIA MEDICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.15.01.00.00','RETENCOES - CONTRIBUICOES AO RPPS A RECOLHER-EXECUTIVO/INDIRETAS','REPRESENTA VALORES MONETÁRIOS RETIDOS NA FOLHA DE PAGAMENTO DE SERVIDORES DO EXECUTIVO / INDIRETAS REFERENTES AS CONTRIBUIÇÕES PARA O RPPS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.15.02.00.00','RETENCOES - CONTRIBUICOES AO RPPS A RECOLHER - LEGISLATIVO','REPRESENTA VALORES MONETÁRIOS RETIDOS NA FOLHA DE PAGAMENTO DE SERVIDORES DO LEGISLATIVO REFERENTES AS CONTRIBUIÇÕES PARA O RPPS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.16.00.00.00','ASSISTENCIA A SAUDE - ADMINISTRACAO PROPRIA','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, QUE SERAO ADMINISTRADOS PELO PROPRIO ORGAO/ENTIDADE PARA ASSISTENCIA A SAUDE DE SEUS SERVIDORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.17.00.00.00','ENTIDADES REPRESENTATIVAS DE CLASSES','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS  DE  PAGAMENTO  DE  PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE  INSTITUICOES  REPRESENTATIVAS DE CLASSE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.21.00.00.00','PLANOS DE SEGUROS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS   EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES AS CONTRIBUICOES A PLANOS DE SEGURO DE VIDA EM GRUPO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.22.00.00.00','EMPRESTIMOS E FINANCIAMENTOS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS  EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES A EMPRESTIMOS E  FINANCIAMENTOS  CONCEDIDOS  POR TERCEIROS, BEM COMO RETENCOES DE PARCELAS DE CONSORCIOS E SEGURADOS DO INSS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.24.00.00.00','RETENCAO RELATIVA A VALE TRANSPORTE','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM  REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO  DE VALE-TRANSPORTE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.25.00.00.00','RETENCAO RELATIVA A VALE ALIMENTACAO','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM  REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO  DE CARTAO-ALIMENTACAO/REFEICAO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.99.00.00.00','OUTROS CONSIGNATARIOS','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, EM CONFIANCA, POR DIVERSOS CONTRIBUINTES  SUJEITOS A RECOLHIMENTOS E OU PAGAMENTOS AOS FAVORECIDOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.02.00.00.00.00','GARANTIAS','COMPREENDE A GARANTIA DO CUMPRIMENTO DE UMA OBRIGACAO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENCOES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.03.00.00.00.00','DEPOSITOS JUDICIAIS','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL E DEPOSITOS PARA RECURSOS JUDICIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.03.01.00.00.00','DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.03.02.00.00.00','DEPOSITOS PARA RECURSOS JUDICIAIS','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS EFETUADOS A FAVOR DA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.00.00.00.00','DEPOSITOS NAO JUDICIAIS','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS, EXCETO DEPOSITOS JUDICIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.01.00.00.00','DEPOSITOS E CAUCOES','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS E/OU CAUCOES VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.01.01.00.00','REPASSES A FUNDOS/AUTARQUIAS REFERENTE A COMPENSAÇÃO FINANCEIRA DO RPPS, RECEBIDA UNIAO','REGISTRA OS VALORES REFERENTES A COMPENSAÇÃO FINANCEIRA RECEBIDA DA UNIAO E QUE DEVE SER REPASSADA A AUTARQUIA OU FUNDOS PREVIDENCIÁRIOS','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.01.02.00.00','CAUCOES EM DINHEIRO','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS NO CURSO DO EXERCICIO  SEGUINTE, CONTRAIDAS COMO RECEBIMENTO DE  CAUCOES VINCULADOS A CONTRATOS OU A CONVENCOES, PARA GARANTIAS DE OPERACOES  ESPECIFICAS','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.02.00.00.00','DEPOSITOS ESPECIAIS','REGISTRA O VALOR RELATIVO A RETENCOES DE DEPOSITOS VINCULADOS A RESTITUIR NO CURSO DO EXERCICIO SEGUINTE A ENTIDADE TRANSFERIDORA, DECORRENTE  DE CONTRATOS OU  INSTRUMENTOS CONGENERES, CONVENCAO, ACORDO OU AJUSTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.02.01.00.00','RETENCOES CONTRATUAIS','REGISTRAR O VALOR RELATIVO A RETENÇÕES DE DEPÓSITOS VINCULADOS A RESTITUIÇÕES NO CURSO DO EXERCÍCIO, DECORRENTE DE CONTRATO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.02.02.00.00','RETENCOES SEGURIDADE SOCIAL','REGISTRAR O VALOR RELATIVO A RETENÇÕES DE DEPÓSITOS VINCULADOS A RESTITUIÇÕES NO CURSO DO EXERCÍCIO, DECORRENTE DA SEGURIDADE SOCIAL','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.03.00.00.00','DEPOSITOS RETIDOS DE FORNECEDORES','REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE FORNECEDORES EM FUNCAO DE APLICACAO DE MULTAS E OUTRAS DETERMINACOES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.06.00.00.00','DEPOSITOS DE TERCEIROS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TERCEIROS  DE  DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NAO RECLAMADOS  PELOS CREDORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.09.00.00.00','DEPOSITOS DE RENDIMENTOS DO PIS/PASEP','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RENDIMENTOS DO PIS/PASEP PARA CREDITO EM FOLHA DE PAGAMENTO AOS SERVIDORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.99.00.00.00','OUTROS DEPOSITOS','REGISTRA COMPROMISSOS EXIGIVEIS ATE O TERMINO DO  EXERCICIO  SEGUINTE, DECORRENTES DE RECEBIMENTOS A TITULO DE DEPOSITOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.99.00.00.00.00','OUTROS VALORES RESTITUIVEIS','OUTROS VALORES RESTITUIVEIS EM POSSE DA ENTIDADE, NO PAPEL DE FIEL DEPOSITARIA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.0.00.00.00.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.00.00.00.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.01.00.00.00.00','INDENIZACOES E RESTITUICOES','COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.01.01.00.00.00','INDENIZACOES A SERVIDORES','REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO  REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.01.02.00.00.00','INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES NO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.01.03.00.00.00','INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.02.00.00.00.00','DIARIAS A PAGAR','REGISTRA OS VALORES RELATIVOS AS DIARIAS A PAGAR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.03.00.00.00.00','SUPRIMENTOS DE FUNDOS A PAGAR','REGISTRA OS VALORES RELATIVOS AOS SUPRIMENTOS DE FUNDOS A PAGAR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.05.00.00.00.00','CONVENIOS A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.05.01.00.00.00','CONVENIOS A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO  EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.05.02.00.00.00','CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM  EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.00.00.00.00','PRECATORIOS DE TERCEIROS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.01.00.00.00','PRECATORIOS DE TERCEIROS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.02.00.00.00','PRECATORIOS A PAGAR - TERCEIROS - DO EXERCÍCIO ANTERIOR','REGISTRA OS VALORES DE PRECATORIOS PARA PAGAMENTO DE TERCEIROS, NO SISTEMA PATRIMONIAL O QUAL DEVERIA TER SIDO PAGO ATÉ O FINAL DO EXERCICIO E NÃO OCORREU A EXECUÇÃO ORÇAMENTÁRIA','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.03.00.00.00','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES -  ANTES DE 05/05/2000','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.03.01.00.00','TERCEIROS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIACAO DE TERRAS E OUTRAS DE RESPONSABILIDADE DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.03.02.00.00','TERCEIROS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIACAO DE TERRAS E OUTRAS DE RESPONSABILIDADE DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.03.03.00.00','TERCEIROS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIACAO DE TERRAS E OUTRAS DE RESPONSABILIDADE DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.04.00.00.00','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000','COMPREENDE OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.04.01.00.00','TERCEIROS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIACAO DE TERRAS E OUTRAS, A PARTIR DE 05/05/2000 DE RESPONSABILIDADE DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.04.02.00.00','TERCEIROS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIACAO DE TERRAS E OUTRAS, A PARTIR DE 05/05/2000 DE RESPONSABILIDADE DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.04.03.00.00','TERCEIROS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIACAO DE TERRAS E OUTRAS, A PARTIR DE 05/05/2000 DE RESPONSABILIDADE DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.14.00.00.00.00','COMPENSACAO PREVIDENCIARIA','COMPREENDE O VALOR DAS OBRIGACOES  COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A  LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3.112/1999.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.14.01.00.00.00','COMPENSACAO PREVIDENCIARIA DO EXERCICIO','REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS  Nº 98, BEM COMO A   LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.14.02.00.00.00','COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES','REGISTRA O VALOR DAS OBRIGACOES DE  EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE   O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A   LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.20.00.00.00.00','CONTRATOS DE GESTAO','REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.23.00.00.00.00','AUXILIOS FINANCEIROS A PESQUISADORES','REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A  PESQUISADORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.26.00.00.00.00','ENTIDADES CREDORAS - FEDERAIS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE OBRIGACOES JUNTO A ENTIDADES FEDERAIS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.27.00.00.00.00','ENTIDADES CREDORAS - ESTADOS, DF E MUNICIPIOS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DECORRENTES DE OBRIGACOES JUNTO A ESTADOS, DF E MUNICIPIOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.35.00.00.00.00','INTERMEDIARIOS DE INVESTIMENTOS','COMPREENDE OS VALORES DE OBRIGACOES A CURTO PRAZO COM INTERMEDIARIOS DE INVESTIMENTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.35.01.00.00.00','VALORES DE INVESTIMENTOS A PAGAR','REGISTRA OS VALORES DE INVESTIMENTOS REALIZADOS NO MERCADO FINANCEIRO E NAO LIQUIDADOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.36.00.00.00.00','VALORES EM TRANSITO EXIGIVEIS','REGISTRA O VALOR DA ORDEM BANCARIA OU OUTRO DOCUMENTO EMITIDO PARA SAQUE CONTRA ESTABELECIMENTO BANCARIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.37.00.00.00.00','SUBVENCOES A PAGAR','COMPREENDE O SOMATORIO DAS SUBVENCOES A PAGAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.37.01.00.00.00','SUBVENCOES A PAGAR DO EXERCICIO','REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DO  EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.37.02.00.00.00','SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DE  EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.38.00.00.00.00','RESTITUICOES DE RECEITAS A PAGAR','REGISTRA O VALOR DAS RESTITUICOES DE RECEITAS A PAGAR APROPRIADAS  PELAS UNIDADES GESTORAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.39.00.00.00.00','TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS','REGISTRA OS VALORES DE DEVOLUCOES DE RECURSOS DE TRANSFERENCIAS VOLUNTARIAS PARA POSTERIOR RECOLHIMENTO AO CONCEDENTE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.40.00.00.00.00','RECURSOS ESPECIAIS A LIBERAR','COMPREENDE A DESPESA EMPENHADA E NAO PAGA, APURADA AO FINAL DO EXERCICIO E INSCRITA EM RESTOS A PAGAR, PROCESSADOS E NAO PROCESSADOS,  BEM  COMO OS RECURSOS APROVADOS E NAO LIBERADOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.40.03.00.00.00','RESTOS A PAGAR NAO PROCESSADOS A LIQUIDAR','COMPREENDE AS OBRIGACOES PROVENIENTES DA INSCRICAO DE RESTOS A PAGAR DEPENDENTES DO ESTAGIO DA LIQUIDACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.40.03.01.00.00','RESTOS A PAGAR NAO PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA AS OBRIGACOES PROVENIENTES DA INSCRICAO DE RESTOS A PAGAR DEPENDENTE DO ESTAGIO DA LIQUIDACAO DE RESPONSABILIDADE DO PODER EXECUTIVO E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.40.03.02.00.00','RESTOS A PAGAR NAO PROCESSADOS - LEGISLATIVO','REGISTRA AS OBRIGACOES PROVENIENTES DA INSCRICAO DE RESTOS A PAGAR DEPENDENTE DO ESTAGIO DA LIQUIDACAO DE RESPONSABILIDADE DO PODER LEGISLATIVO E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.40.03.03.00.00','RESTOS A PAGAR NAO PROCESSADOS - RPPS','REGISTRA AS OBRIGACOES PROVENIENTES DA INSCRICAO DE RESTOS A PAGAR DEPENDENTE DO ESTAGIO DA LIQUIDACAO DE RESPONSABILIDADE DO RPPS E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.40.07.00.00.00','RECURSOS A LIBERAR POR VINCULACAO DE PAGAMENTO','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU  SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE  DE  SAQUE  COM VINCULACAO DE PAGAMENTO, ESTABELECIDO PELO ORGAO CENTRAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.40.10.00.00.00','RECURSOS A LIBERAR PARA PAGAMENTO DE RP','REGISTRA O VALOR DO RECURSO A LIBERAR PARA PAGAMENTO DE RESTOS A PAGAR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.00.00.00.00','OUTROS CREDORES A CURTO PRAZO','COMPREENDE OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES  PARA OS  QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.01.00.00.00','ADIANTAMENTOS DIVERSOS RECEBIDOS','REGISTRA VALORES EXIGIVEIS EM ATE 12 MESES,  DECORRENTES  DE  DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.02.00.00.00','OUTROS CREDORES DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES  NO EXERCICIO, PARA OS  QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.03.00.00.00','OUTROS CREDORES DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCICIOS ANTERIORES, PARA OS  QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.04.00.00.00','SERVIÇO DA DIVIDA DE PARCELAMENTOS A PAGAR - DO EXERCICIO','REGISTRA O VALOR DO SERVIÇO DA DIVIDA DE PARCELAMENTOS A PAGAR - DO EXERCICIO','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.05.00.00.00','DEBITOS DIVERSOS - DO EXERCICIO','REGISTRA O VALOR DOS DEBITOS DIVERSOS DO EXERCICO PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.06.00.00.00','DEBITOS DIVERSOS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO/INDIRETAS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS REFERENTES A DEBITOS DIVERSOS  PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA DE RESPONSABILIDADE DO PODER EXECUTIVO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.07.00.00.00','DEBITOS DIVERSOS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS REFERENTES A DEBITOS DIVERSOS  PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA DE RESPONSABILIDADE DO PODER LEGISLATIVO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.08.00.00.00','DEBITOS DIVERSOS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS REFERENTES A DEBITOS DIVERSOS  PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA DE RESPONSABILIDADE DO RPPS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.09.00.00.00','RESTOS A PAGAR PROCESSADOS DE DEBITOS DIVERSOS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS REFERENTES A DEBITOS DIVERSOS  PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.10.00.00.00','RESTOS A PAGAR PROCESSADOS - SERVIÇO DA DIVIDA DE PARCELAMENTO','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS - SERVICO DA DIVIDA DE PARCELAMENTO','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.99.00.00.00.00','OUTRAS OBRIGAÇÕES  CONSOLIDAÇÃO','COMPREENDE OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES  PARA OS  QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.99.01.00.00.00','OUTRAS OBRIGAÇÕES  DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES  NO EXERCICIO, PARA OS  QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.99.02.00.00.00','OUTRAS OBRIGAÇÕES  DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCICIOS ANTERIORES, PARA OS  QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.00.00.00.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO-INTRA OFSS','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.01.00.00.00.00','INDENIZACOES E RESTITUICOES','COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.01.02.00.00.00','INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES NO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.01.03.00.00.00','INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.05.00.00.00.00','CONVENIOS A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.05.01.00.00.00','CONVENIOS A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO  EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.05.02.00.00.00','CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM  EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.40.00.00.00.00','RECURSOS ESPECIAIS A LIBERAR','COMPREENDE A DESPESA EMPENHADA E NAO PAGA, APURADA AO FINAL DO EXERCICIO E INSCRITA EM RESTOS A PAGAR, PROCESSADOS E NAO PROCESSADOS,  BEM  COMO OS RECURSOS APROVADOS E NAO LIBERADOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.40.03.00.00.00','RESTOS A PAGAR NAO PROCESSADOS A LIQUIDAR','REGISTRA AS OBRIGACOES PROVENIENTES DA INSCRICAO DE RESTOS A PAGAR DEPENDENTES DO ESTAGIO DA LIQUIDACAO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.40.07.00.00.00','RECURSOS A LIBERAR POR VINCULACAO DE PAGAMENTO','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU  SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE  DE  SAQUE  COM VINCULACAO DE PAGAMENTO, ESTABELECIDO PELO ORGAO CENTRAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.40.10.00.00.00','RECURSOS A LIBERAR PARA PAGAMENTO DE RP','REGISTRA O VALOR DO RECURSO A LIBERAR PARA PAGAMENTO DE RESTOS A PAGAR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.98.00.00.00.00','OUTROS CREDORES A CURTO PRAZO','COMPREENDE OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES  PARA OS  QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.98.01.00.00.00','OUTROS CREDORES DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES  NO EXERCICIO, PARA OS  QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.98.02.00.00.00','OUTROS CREDORES DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCICIOS ANTERIORES, PARA OS  QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.0.0.0.00.00.00.00.00','PASSIVO NAO-CIRCULANTE','Compreende as obrigações conhecidas e estimadas que não atendam a nenhum dos critérios para serem classificadas no passivo circulante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.0.0.00.00.00.00.00','OBRIGAÇÕES TRABALHISTAS, PREVIDENCIÁRIAS E ASSISTENCIAIS A PAGAR A LONGO PRAZO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, aposentadorias, reformas, pensões e encargos a pagar,  benefícios assistenciais, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.0.00.00.00.00.00','PESSOAL A PAGAR','Compreende as obrigações a longo prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.00.00.00.00.00','PESSOAL A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações a longo prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.01.00.00.00.00','PESSOAL A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS A VENCIMENTOS E VANTAGENS FIXAS E VARIAVEIS  DEVIDAS AO SERVIDORES, BEM COMO AS APOSENTADORIAS, REFORMAS E PENSOES, RELATIVAS A EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.02.00.00.00.00','PRECATORIOS DE PESSOAL','COMPREENDE OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.02.01.00.00.00','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCICIOS ANTERIORES AO ANTERIOR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.02.02.00.00.00','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES - ANTERIORES A 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, ATE05/05/2000, EXIGIVEIS NO LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.02.03.00.00.00','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.0.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR','Compreende as obrigações a longo prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações a longo prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.01.00.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.01.01.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.01.02.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTERIORES A 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E ATERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.01.03.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.3.0.00.00.00.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR','Compreende as obrigações a longo prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.3.1.00.00.00.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações a longo prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.3.1.01.00.00.00.00','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.0.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.1.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.1.01.00.00.00.00','INSS - DEBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.1.03.00.00.00.00','FGTS - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR DOS DÉBITOS PARCELADOS, REFERENTE AO NÃO RECOLHIMENTO DE FGTS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.1.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.2.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.2.02.00.00.00.00','RPPS - DÉBITO PARCELADO','COMPREENREGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR DOS DÉBITOS PARCELADOS, REFERENTE AO NÃO RECOLHIMENTO DE CONTRIBUIÇÕES SOCIAIS AO RPPS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.2.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.3.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.3.01.00.00.00.00','INSS A PAGAR - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR REFERENTE A DÉBITOS PARCELADOS JUNTO AO INSS , REFERENTE AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DE FOLHA DE PAGAMENTO E OUTROS AFINS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.3.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.4.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.4.02.00.00.00.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS) DO ESTADO - DEBITO PARCELADO','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE   PREVIDENCIA DO ESTADO (IPE), NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.4.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.5.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.5.02.00.00.00.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS) DE OU TRO MUNICIPIO - DEBITO PARCELADO','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE   PREVIDENCIA DE OUTRO MUNICIPIO, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.5.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.0.0.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO','Compreende as obrigações financeiras da entidade a titulo de empréstimos, bem como as aquisições efetuadas diretamente com o fornecedor, com vencimentos no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.0.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.1.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO - CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.1.01.00.00.00.00','EMPRESTIMOS INTERNOS - EM TITULOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.1.03.00.00.00.00','EMPRESTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.3.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO - INTER OFSS - UNIÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.3.01.00.00.00.00','EMPRESTIMOS INTERNOS - EM TITULOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.3.03.00.00.00.00','EMPRESTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.4.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO - INTER OFSS - ESTADO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.4.03.00.00.00.00','EMPRESTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.5.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.2.0.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - EXTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.2.1.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO- EXTERNO CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.2.1.02.00.00.00.00','EMPRÉSTIMOS EXTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERAÇÕES DE CRÉDITO EXTERNAS EM CONTRATOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.0.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO - INTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.1.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO- INTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.1.01.00.00.00.00','FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.3.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO- INTERNO -INTER OFSS - UNIÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.3.01.00.00.00.00','FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.4.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO - INTERNO - INTER OFSS - ESTADO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.4.01.00.00.00.00','FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.5.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO - INTERNO - INTER OFSS - MUNICÍPIO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.4.0.00.00.00.00.00','FINANCIAMENTO A LONGO PRAZO - EXTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.4.1.00.00.00.00.00','FINANCIAMENTO A LONGO PRAZO - EXTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no longo prazo.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.4.1.01.00.00.00.00','FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.0.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo.. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.03.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.05.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.07.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.3.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO -INTER OFSS - UNIÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.3.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.3.03.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.3.05.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.3.07.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.4.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO -INTER OFSS - ESTADO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.4.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.4.03.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.4.05.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.4.07.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.5.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO -INTER OFSS - MUNICÍPIO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.5.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.5.03.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.5.05.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.5.07.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.0.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.02.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.04.00.00.00.00','ENCARGOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.06.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.08.00.00.00.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.0.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.1.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.3.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - INTER OFSS - UNIÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.4.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - INTER OFFS - ESTADO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.5.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - INTER OFSS - MUNICÍPIO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.9.0.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.9.1.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO - CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.0.0.00.00.00.00.00','FORNECEDORES A LONGO PRAZO','Compreende as obrigações junto a fornecedores de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.0.00.00.00.00.00','FORNECEDORES NACIONAIS A LONGO PRAZO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.00.00.00.00.00','FORNECEDORES NACIONAIS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.01.00.00.00.00','FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.02.00.00.00.00','FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.03.00.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.03.01.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.03.02.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS - EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR DE PRECATORIOS DE FORNECEDORES DE  BENS  E SERVICOS DE EXERCICIOS ANTERIORES AO ANTERIOR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.03.03.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS - ANTERIORES A 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES,ATE05/05/2000, EXIGIVEIS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.03.04.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS  - A PARTIR DE 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000, EXIGIVEL A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.2.0.00.00.00.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO','Compreende as obrigações junto a fornecedores estrangeiros de matérias primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.2.1.00.00.00.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores estrangeiros de matérias primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.2.1.01.00.00.00.00','FORNECEDORES ESTRANGEIROS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.2.1.02.00.00.00.00','FORNECEDORES ESTRANGEIROS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.0.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO','Compreende as obrigações das entidades com o governo relativas a impostos, taxas e contribuições com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.2.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTRA OFSS','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS - UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.01.00.00.00.00','OBRIGACOES LEGAIS E TRIBUTARIAS','COMPREENDE OS VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DE OBRIGACOES JUNTO AO GOVERNO RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.01.01.00.00.00','OBRIGACOES TRIBUTARIAS RENEGOCIADAS','REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS AO MONTANTE PRINCIPAL DAS OBRIGACOES TRIBUTARIAS QUE FORAM RENEGOCIADAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.01.02.00.00.00','OUTRAS OBRIGACOES LEGAIS E TRIBUTARIAS','COMPREENDE OS VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DE OBRIGACOES LEGAIS E TRIBUTARIAS, PARA OS QUAIS NAO HAJA CONTAS  ESPECIFICAS.EX: PARCELAMENTO DO PASEP','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.01.02.01.00.00','PARCELAMENTOS DO FGTS','REGISTRA OS VALORES DAS OBRIGACOES, EXIGIVEIS A  LONGO  PRAZO,  DECORRENTES DE PARCELAMENTOS DO FGTS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.01.02.02.00.00','PARCELAMENTOS DO PASEP','REGISTRA OS VALORES DAS OBRIGACOES, EXIGIVEIS A  LONGO  PRAZO,  DECORRENTES DE PARCELAMENTOS DOPASEP','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.4.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS - ESTADO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.5.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS - MUNICÍPIO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.2.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.2.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.2.2.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - INTRA OFSS','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.3.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS','Compreende as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.3.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.3.2.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS-INTRA OFSS','Compreende as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.0.0.00.00.00.00.00','PROVISÕES A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.1.0.00.00.00.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.1.1.00.00.00.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.1.1.01.00.00.00.00','PROVISÃO PARA INDENIZAÇÕES TRABALHISTAS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE INDENIZAÇÕES TRABALHISTAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.1.1.02.00.00.00.00','PROVISÃO PARA PAGAMENTO DE DISSIDIOS COLETIVOS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE DISSIDIOS COLETIVOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.0.00.00.00.00.00','PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes, com probabilidade de ocorrerem no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.00.00.00.00.00','PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.00.00.00.00','PLANO FINANCEIRO - PROVISOES DE BENEFICIOS CONCEDIDOS','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios já concedidos aos assistidos e beneficiários em gozo de beneficio de prestação continuada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.01.00.00.00','APOSENTADORIAS/        PENSOES /OUTROS BENEFICIOS CONCEDIDOS DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS PRESTACOES FUTURAS DOS BENEFICIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTACAO CONTINUADA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.02.00.00.00','(-) CONTRIBUICOES DO ENTE PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR  OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.03.00.00.00','(-) CONTRIBUICOES DO APOSENTADO PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS INATIVOS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.04.00.00.00','(-) CONTRIBUICOES DO PENSIONISTA PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS PENSIONISTAS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.05.00.00.00','(-) COMPENSACAO PREVIDENCIARIA DO PLANO FINANCEIRO DO RPPS','REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.06.00.00.00','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO FUNDO SOB O REGIME DE PARCELAMENTO DE DEBITOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.07.00.00.00','(-) ASSUNCAO DE INSUFICIENCIA FINANCEIRA DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM  O  RESULTADO DA AVALIACAO ATUARIAL, O  VALOR PRESENTE DAS INSUFICIENCIAS FINANCEIRAS FUTURAS  DO  PLANO FINANCEIRO CONSIDERANDO O § 1º DO ARTIGO 2º DA LEI 9717/98.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.00.00.00.00','PLANO FINANCEIRO - PROVISOES DE BENEFICIOS A CONCEDER','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios a conceder para a geração atual (servidores ativos).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.01.00.00.00','APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS A CONCEDER DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DOS BENEFICIOS A SEREM CONCEDIDOS AOS INTEGRANTES DA GERACAO ATUAL QUE AINDA NAO ESTEJAM EM GOZO DE BENEFICIOS DE PRESTACAO CONTINUADA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.02.00.00.00','(-) CONTRIBUICOES DO ENTE PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR  PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.03.00.00.00','(-) CONTRIBUICOES DO SERVIDOR PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O SOMATORIO DO VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS SERVIDORES ATIVOS, INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.04.00.00.00','(-) COMPENSACAO PREVIDENCIARIA DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.05.00.00.00','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO PLANO, CONSIDERANDO O PARCELAMENTO DOS VALORES NAO RECOLHIDOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.06.00.00.00','(-) ASSUNCAO DE INSUFICIENCIA FINANCEIRA DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM  O  RESULTADO DA AVALIACAO ATUARIAL, O  VALOR PRESENTE DAS INSUFICIENCIAS FINANCEIRAS FUTURAS  DO  PLANO FINANCEIRO, CONSIDERANDO O § 1º DO ARTIGO 2º DA LEI 9717/98.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.00.00.00.00','PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS CONCEDIDOS','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios já concedidos aos assistidos e beneficiários em gozo de beneficio de prestação continuada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.01.00.00.00','APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS CONCEDIDOS DO PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS PRESTACOES FUTURAS DOS BENEFICIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTACAO CONTINUADA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.02.00.00.00','(-) CONTRIBUICOES DO ENTE PARA O PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS)  FUTURAS DO ENTE, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.03.00.00.00','(-) CONTRIBUICOES DO APOSENTADO PARA O PLANO PREVIDENCIARIO DO RPPS','REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS INATIVOS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.04.00.00.00','(-) CONTRIBUICOES DO PENSIONISTA PARA O PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS PENSIONISTAS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.05.00.00.00','(-) COMPENSACAO PREVIDENCIARIA DO PLANO PREVIDENCIARIO DO RPPS','REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11 DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.06.00.00.00','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS DO PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO PLANO, CONSIDERANDO O PARCELAMENTO DE VALORES NAO RECOLHIDOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.00.00.00.00','PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS A CONCEDER','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios a conceder para a geração atual (servidores ativos).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.01.00.00.00','APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS A CONCEDER DO PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DOS BENEFICIOS A SEREM CONCEDIDOS AOS INTEGRANTES DA GERACAO ATUAL QUE AINDA NAO ESTEJAM EM GOZO DE BENEFICIOS DE PRESTACAO CONTINUADA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.02.00.00.00','(-) CONTRIBUICOES DO ENTE PARA O PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS)  FUTURAS DO ENTE, INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.03.00.00.00','(-) CONTRIBUICOES DO SERVIDOR PARA O PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O SOMATORIO DO VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS SERVIDORES ATIVOS,  INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.04.00.00.00','(-) COMPENSACAO PREVIDENCIARIA DO PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.05.00.00.00','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO PLANO, SOB O REGIME DE PARCELAMENTO DE DEBITOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.05.00.00.00.00','PLANO PREVIDENCIARIO - PLANO DE AMORTIZACAO','Compreende, de acordo com resultado da avaliação atuarial, o valor presente liquido dos direitos incorporados ao patrimônio do RPPS com base em legislação especifica, bem como registro tempestivo do plano de amortização implementado em lei do ente federativo, considerando que o ajuste contábil das reservas matemáticas somente ocorrera na apresentação de uma nova reavaliação atuarial.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.05.98.00.00.00','(-) OUTROS CREDITOS DO PLANO DE AMORTIZACAO','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE LIQUIDO DOS DIREITOS INCORPORADOS AO PATRIMONIO DO RPPS COM BASE EM LEGISLACAO ESPECIFICA, COMO EXEMPLO: DIREITOS SOBRE ROYALTIES, BEM COMO REGISTRO TEMPESTIVO DO PLANO DE AMORTIZACAO IMPLEMENTADO EM LEI DO ENTE FEDERATIVO, CONSIDERANDO QUE O AJUSTE CONTABIL DAS RESERVAS MATEMATICAS SOMENTE OCORRERA NA APRESENTACAO DE UMA NOVA REAVALIACAO ATUARIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.06.00.00.00.00','PROVISOES ATUARIAIS PARA AJUSTES DO PLANO FINANCEIRO','Compreende o somatório das provisões atuariais constituídas para ajustes do plano financeiro, conforme o resultado da avaliação atuarial.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.06.01.00.00.00','PROVISAO ATUARIAL PARA OSCILACAO DE RISCOS','REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, A PROVISAO ATUARIAL CORRESPONDENTE A EVENTUAIS DESVIOS DOS COMPROMISSOS ESPERADOS OU PELA ADOCAO DE BASES TECNICAS QUE NAO SE ADAPTAM AO PLANO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.00.00.00.00','PROVISOES ATUARIAIS PARA AJUSTES DO PLANO PREVIDENCIARIO','Compreende o somatório das provisões atuariais constituídas para ajustes do plano previdenciário, conforme o resultado da avaliação atuarial.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.01.00.00.00','AJUSTE DE RESULTADO ATUARIAL SUPERAVITARIO','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, PROVISAO ATUARIAL PARA AJUSTE DO PLANO PREVIDENCIARIO QUANDO O PLANO APRESENTAR RESULTADO SUPERAVITARIO, CONSIDERANDO O ARTIGO 25, DA PORTARIA MPS 403/2008.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.02.00.00.00','PROVISÃO ATUARIAL PARA OSCILAÇÃO DE RISCOS','REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, A PROVISAO ATUARIAL CORRESPONDENTE A EVENTUAIS DESVIOS DOS COMPROMISSOS ESPERADOS OU PELA ADOCAO DE BASES TECNICAS QUE NÃO SE ADAPTAM AO PLANO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.03.00.00.00','PROVISÃO ATUARIAL PARA BENEFÍCIOS A REGULARIZAR','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.04.00.00.00','PROVISÃO ATUARIAL PARA CONTINGÊNCIAS DE BENEFÍCIOS','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.98.00.00.00','OUTRAS PROVISÕES ATUARIAIS PARA AJUSTES DO PLANO','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.3.0.00.00.00.00.00','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.3.1.00.00.00.00.00','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.4.0.00.00.00.00.00','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.4.1.00.00.00.00.00','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.5.0.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.5.3.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.5.4.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.5.5.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.6.0.00.00.00.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.6.1.00.00.00.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO - CONSOLIDAÇÃO OFSS','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.9.0.00.00.00.00.00','OUTRAS PROVISÕES A LONGO PRAZO','Compreende os demais passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no longo prazo, não classificadas anteriormente neste plano de contas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.9.1.00.00.00.00.00','OUTRAS PROVISÕES A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os demais passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no longo prazo, não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.0.0.00.00.00.00.00','DEMAIS OBRIGAÇÕES A LONGO PRAZO','Compreende as obrigações da entidade junto a terceiros não inclusas nos subgrupos anteriores, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.1.0.00.00.00.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.1.1.00.00.00.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO- CONSOLIDAÇÃO','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.2.0.00.00.00.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO','Compreende os valores exigíveis no longo prazo, provenientes de danos a terceiros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.2.1.00.00.00.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os valores exigíveis no longo prazo, provenientes de danos a terceiros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.3.0.00.00.00.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A LONGO PRAZO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.3.1.00.00.00.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A LONGO PRAZO- CONSOLIDAÇÃO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.4.0.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando haja a possibilidade de devolução destes recursos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.4.1.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando haja a possibilidade de devolução destes recursos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.0.00.00.00.00.00','OUTRAS OBRIGAÇÕES A LONGO PRAZO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.00.00.00.00.00','OUTRAS OBRIGAÇÕES A LONGO PRAZO- CONSOLIDAÇÃO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.01.00.00.00.00','INDENIZACOES E RESTITUICOES','COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.01.01.00.00.00','IINDENIZAÇÕES A SERVIDORES','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DAS OBRIGAÇÕES  CONSTITUÍDAS VISANDO O PAGAMENTO DE INDENIZAÇÕES TRABALHISTAS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.01.02.00.00.00','INDENIZAÇÕES E RESTITUIÇÕES DIVERSAS DO EXERCÍCIO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DAS OBRIGAÇÕES CONSTITUÍDAS VISANDO O PAGAMENTO DE INDENIZAÇÕES CÍVEIS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.01.03.00.00.00','INDENIZAÇÕES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZAÇÕES E RESTITUICOES DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.01.04.00.00.00','RESTITUICOES DE CONTRIBUIÇÕES PREVIDENCIARIAS','REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUIÇÕES PREVIDENCIARIAS  A SEREM EFETIVADAS PELAS UNIDADES DO INSS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.02.00.00.00.00','DEPÓSITOS JUDICIAIS ','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DE OBRIGAÇÕES, EXIGÍVEIS A LONGO PRAZO, DECORRENTES DE RECEBIMENTOS DE DEPÓSITOS POR DETERMINAÇÃO DA JUSTIÇA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.03.00.00.00.00','OUTROS DEPÓSITOS ','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DE OBRIGAÇÕES, EXIGÍVEIS A LONGO  PRAZO,  CONTRAÍDAS COM O RECEBIMENTO DE DEPÓSITOS VINCULADOS QUE NÃO POSSUEM CONTAS ESPECÍFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.04.00.00.00.00','CONVENIOS A PAGAR','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.10.00.00.00.00','PRECATORIOS DE TERCEIROS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.10.01.00.00.00','PRECATORIOS DE TERCEIROS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.10.02.00.00.00','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES -  ANTES DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.10.03.00.00.00','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000','REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.11.00.00.00.00','COMPENSAÇÃO PREVIDENCIÁRIA','','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.11.01.00.00.00','COMPENSAÇÃO PREVIDENCIÁRIA DO EXERCÍCIO','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.11.02.00.00.00','COMPENSAÇÃO PREVIDENCIÁRIA DE EXERCÍCIOS ANTERIORES','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.13.00.00.00.00','CONTRATOS DE GESTAO','REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.14.00.00.00.00','OPERACOES DE CREDITO ENTRE ENTIDADES DA ADMINISTRACAO MUNICIPAL','REGISTRA OS VALORES DAS OBRIGACOES, EXIGIVEIS A  LONGO  PRAZO,  ENTRE ENTIDADES DA ADMINISTRACAO MUNICIPAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.99.00.00.00.00','OUTROS CREDORES A LONGO PRAZO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES  PARA OS  QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.0.0.00.00.00.00.00','RESULTADO DIFERIDO','Compreende o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade.  Compreende também o saldo existente na antiga conta resultado de exercícios futuros em 31 de dezembro de 2008.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.1.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA (VPA) DIFERIDA','Compreende o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.1.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA DIFERIDA - CONSOLIDAÇÃO','Compreende o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.2.0.00.00.00.00.00','(-) CUSTO DIFERIDO','Compreende o custo relacionado às variações patrimoniais aumentativas (VPA) diferidas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.2.1.00.00.00.00.00','(-) CUSTO DIFERIDO - CONSOLIDAÇÃO','Compreende o custo relacionado às variações patrimoniais aumentativas (VPA) diferidas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.0.0.0.00.00.00.00.00','PATRIMÔNIO LIQUIDO','Compreende o valor residual dos ativos depois de deduzidos todos os passivos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.0.0.00.00.00.00.00','PATRIMÔNIO SOCIAL E CAPITAL SOCIAL','Compreende o patrimônio social das autarquias, fundações e fundos e o capital social das demais entidades da administração indireta.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.1.0.00.00.00.00.00','PATRIMÔNIO SOCIAL','Compreende o patrimônio das autarquias, fundações e fundos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.1.1.00.00.00.00.00','PATRIMÔNIO SOCIAL - CONSOLIDAÇÃO','Registra o patrimônio das autarquias, fundações e fundos, pertencentes ao orçamento fiscal e da seguridade social.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.0.00.00.00.00.00','CAPITAL SOCIAL REALIZADO','Compreende o capital social subscrito das empresas públicas e sociedades de economia mista, deduzido da parcela ainda não realizada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.1.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - CONSOLIDAÇÃO','Compreende o capital social subscrito das empresas públicas e sociedades de economia mista, deduzido da parcela ainda não realizada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.2.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - INTRA OFSS','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.3.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - UNIÃO','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.4.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - ESTADO','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.5.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - MUNICÍPIO','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.0.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.1.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.2.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTRA OFSS','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.3.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - UNIÃO','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.4.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - ESTADO','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.5.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - MUNICÍPIO.','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.0.0.00.00.00.00.00','RESERVAS DE CAPITAL','Compreende os valores acrescidos ao patrimônio que não transitaram pelo resultado como variações patrimoniais aumentativas (VPA).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.0.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.1.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - CONSOLIDAÇÃO','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.2.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTRA OFSS','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.3.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - UNIÃO','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.4.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - ESTADO','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.5.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - MUNICÍPIO','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.0.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS','Compreende o produto da alienação de partes beneficiárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.1.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - CONSOLIDAÇÃO','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.2.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTRA OFSS','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.3.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - UNIÃO','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.4.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - ESTADO','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.5.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - MUNICÍPIO','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.0.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO','Compreende o produto da alienação de bônus de subscrição.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.1.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - CONSOLIDAÇÃO','Registra o produto da alienação de bônus de subscrição. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.2.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTRA OFSS','Registra o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.3.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - UNIÃO','Registra o produto da alienação de bônus de subscrição.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.4.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - ESTADO','Registra o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.5.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - MUNICÍPIO','Registra o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.0.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.1.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - CONSOLIDAÇÃO','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.2.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTRA OFSS','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.3.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - UNIÃO','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.4.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - ESTADO','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.5.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - MUNICÍPIO','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.0.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.1.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - CONSOLIDAÇÃO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.2.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - INTRA OFSS','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.3.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - UNIÃO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.4.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - ESTADO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.5.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - MUNICÍPIO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.0.0.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo e do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício em obediência ao regime de competência.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.1.0.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.1.1.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS - CONSOLIDAÇÃO','Registra as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.2.0.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.2.1.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS - CONSOLIDAÇÃO','Registra as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.0.0.00.00.00.00.00','RESERVAS DE LUCROS','Compreende as reservas constituídas com parcelas do lucro liquido das entidades para finalidades especificas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.0.00.00.00.00.00','RESERVA LEGAL','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.1.00.00.00.00.00','RESERVA LEGAL- CONSOLIDAÇÃO','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.2.00.00.00.00.00','RESERVA LEGAL- INTRA OFSS','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.3.00.00.00.00.00','RESERVA LEGAL- INTER OFSS - UNIÃO','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.4.00.00.00.00.00','RESERVA LEGAL- INTER OFSS - ESTADO','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.5.00.00.00.00.00','RESERVA LEGAL- INTER OFSS - MUNICÍPIO','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.0.00.00.00.00.00','RESERVAS ESTATUTÁRIAS','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.1.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - CONSOLIDAÇÃO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.2.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - INTRA OFSS','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.3.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - UNIÃO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.4.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - ESTADO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.5.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - MUNICÍPIO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.0.00.00.00.00.00','RESERVA PARA CONTINGENCIAS','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.1.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - CONSOLIDAÇÃO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.2.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - INTRA OFSS','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.3.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - UNIÃO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.4.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - ESTADO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.5.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - MUNICÍPIO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.0.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.1.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - CONSOLIDAÇÃO','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.2.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - INTRA OFSS','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.3.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - UNIÃO','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.4.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - ESTADO','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.5.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - MUNICÍPIO','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.0.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.1.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - CONSOLIDAÇÃO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.2.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTRA OFSS','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.3.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS - UNIÃO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.4.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS -ESTADO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.5.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS - MUNICÍPIO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.0.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.1.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- CONSOLIDAÇÃO','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.2.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- INTRA OFSS','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.3.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - UNIÃO','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.4.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - ESTADO','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.5.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - MUNICÍPIO','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.0.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES','Compreende a parcela do lucro líquido do exercício decorrente do prêmio na emissão de debêntures.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.1.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- CONSOLIDAÇÃO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.2.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTRA OFSS','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.3.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - UNIÃO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.4.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - ESTADO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.5.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - MUNICÍPIO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.0.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.1.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - CONSOLIDAÇÃO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.2.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - INTRA OFSS','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.3.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - UNIÃO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.4.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - ESTADO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.5.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - MUNICÍPIO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.0.0.00.00.00.00.00','DEMAIS RESERVAS','Compreende as demais reservas, não classificadas como reservas de capital ou de lucro, inclusive aquelas que terão seus saldos realizados por terem sido extintas pela legislação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.0.00.00.00.00.00','RESERVA DE REAVALIAÇÃO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - CONSOLIDAÇÃO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.01.00.00.00.00','REAVALIACAO DE BENS IMOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS  BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES,  QUANDO  O  CONTROLE FOR POR INSCRICAO GENERICA DO TIPO INDIVIDUALIZACAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.02.00.00.00.00','REAVALIAÇÃO DE ATIVOS DE COLIGADAS E CONTROLADAS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, DAS REAVALIAÇÕES EFETUADAS NOS ATIVOS DAS COLIGADAS E CONTROLADAS AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.03.00.00.00.00','REAVALIACAO DE BENS MOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS  BENS MOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.04.00.00.00.00','REAVALIAÇÃO DE BENS INTANGIVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS  BENS INTANGIVEIS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES, QUANDO O CONTROLE FOR POR CGC, CPF, IG OU UG.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.98.00.00.00.00','OUTRAS RESERVAS DE REAVALIACAO','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS  A  OUTROS  BENS DA ENTIDADE, DECORRENTES DE REAVALIACOES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.99.00.00.00.00','(-) TRIBUTOS SOBRE A RESERVA DE REAVALIACAO','REGISTRA O VALOR DA CARGA TRIBUTARIA (IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL) DEVIDA SOBRE A FUTURA REALIZACAO DE ATIVO QUE A GERARAM (PARA EFEITO DE CONTROLE FISCAL).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - INTRA OFSS','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.01.00.00.00.00','REAVALIAÇÃO DE BENS IMOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS  BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES,  QUANDO  O  CONTROLE FOR POR INSCRICAO GENERICA DO TIPO INDIVIDUALIZACAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.02.00.00.00.00','REAVALIAÇÃO DE ATIVOS DE COLIGADAS E CONTROLADAS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, DAS REAVALIAÇÕES EFETUADAS NOS ATIVOS DAS COLIGADAS E CONTROLADAS AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.03.00.00.00.00','REAVALIAÇÃO DE BENS MOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS  BENS MOVEIS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.04.00.00.00.00','REAVALIAÇÃO DE BENS INTANGIVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS  BENS INTANGIVEIS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES, QUANDO O CONTROLE FOR POR CGC, CPF, IG OU UG.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.98.00.00.00.00','OUTRAS RESERVAS DE REAVALIAÇÃO','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS  A  OUTROS  BENS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.99.00.00.00.00','(-) TRIBUTOS SOBRE A RESERVA DE REAVALIAÇÃO','REGISTRA O VALOR DA CARGA TRIBUTÁRIA (IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL) DEVIDA SOBRE A FUTURA REALIZACAO DE ATIVO QUE A GERARAM (PARA EFEITO DE CONTROLE FISCAL).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.3.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - UNIÃO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.4.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - ESTADO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.5.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - MUNICÍPIO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.0.00.00.00.00.00','OUTRAS RESERVAS','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.1.00.00.00.00.00','OUTRAS RESERVAS - CONSOLIDAÇÃO','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.1.01.00.00.00.00','RESERVAS TECNICAS','REGISTRA O VALOR DO PATRIMONIO LIQUIDO DA RESERVA ORIGINARIA DE UM EXCEDENTE QUE NAO PODE SER CONSIDERADO COMO LUCRO, DEVENDO SER  GUARDADO COMO GARANTIA PARA USO FUTURO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.1.01.01.00.00.00','RESERVAS PARA SINISTROS IMOBILIARIOS','REGISTRA  O VALOR DO PATRIMONIO LIQUIDO DA  RESERVA ORIGINARIA DA CONTRIBUICAO DE SEGURADOS (PREMIOS) PARA A COBERTURA, QUANDO DA  OCORRENCIA DE SINISTRO IMOBILIARIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.1.01.02.00.00.00','RESERVA DE GARANTIA','REGISTRA O VALOR NO PATRIMONIO LIQUIDO DA RESERVA ORIGINARIA DE   CONTRIBUICOES COMO FORMA DE GARANTIR O DIREITO DO SERVIDOR OU DA  EMPRESA EM ACONTECIMENTOS EVENTUAIS QUE VENHAM A OCORRER.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.1.01.03.00.00.00','RESERVAS ADMINISTRATIVAS','REGISTRA O VALOR DAS RESERVAS CONSTITUIDAS COM AS SOBRAS  DO  CUSTEIO ADMINISTRATIVO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.2.00.00.00.00.00','OUTRAS RESERVAS - INTRA OFSS','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.3.00.00.00.00.00','OUTRAS RESERVAS - INTER OFSS - UNIÃO','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.4.00.00.00.00.00','OUTRAS RESERVAS - INTER OFSS - ESTADO','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.5.00.00.00.00.00','OUTRAS RESERVAS - INTER OFSS - MUNICÍPIO','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.0.0.00.00.00.00.00','RESULTADOS ACUMULADOS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas e os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.0.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - CONSOLIDAÇÃO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTRA OFSS','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - UNIÃO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - ESTADO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - MUNICÍPIO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.0.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - CONSOLIDAÇÃO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.02.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.03.00.00.00.00','AJUSTES DE EXERCÍCIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Compreende o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTRA OFSS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.02.00.00.00.00','LUCROS EPREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - UNIÃO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.02.00.00.00.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - ESTADO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.02.00.00.00.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - MUNICÍPIO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.02.00.00.00.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.0.0.00.00.00.00.00','(-) AÇÕES / COTAS EM TESOURARIA','Compreende o valor das ações ou cotas da entidade que foram adquiridas pela própria entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.0.00.00.00.00.00','(-) AÇÕES EM TESOURARIA','Compreende o valor das ações da entidade que foram adquiridas pela própria entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.1.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - CONSOLIDAÇÃO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.2.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - INTRA OFSS','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.3.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - UNIÃO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.4.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - ESTADO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.5.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - MUNICÍPIO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.0.00.00.00.00.00','(-) COTAS EM TESOURARIA','Compreende o valor das cotas da entidade que foram adquiridas pela própria entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.1.00.00.00.00.00','(-) COTAS EM TESOURARIA - CONSOLIDAÇÃO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.2.00.00.00.00.00','(-) COTAS EM TESOURARIA - INTRA OFSS','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.3.00.00.00.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - UNIÃO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.4.00.00.00.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - ESTADO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.5.00.00.00.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - MUNICÍPIO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.0.0.0.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA','Compreende o decréscimo no beneficio econômico durante o período contábil sob a forma de saída de recurso ou redução de ativo ou incremento em passivo, que resulte em decréscimo do patrimônio liquido e que não seja proveniente de distribuição aos proprietários da entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.0.0.0.00.00.00.00.00','PESSOAL E ENCARGOS','Compreende a remuneração do pessoal ativo civil ou militar, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos, soldos e vantagens pecuniárias fixas ou variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo, emprego ou função de confiança no setor público. Compreende ainda, obrigações trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos órgãos e demais entidades do setor público, contribuições a entidades fechadas de previdência e benefícios eventuais a pessoal civil e militar, destacados os custos de pessoal e encargos inerentes as mercadorias e produtos vendidos e serviços prestados.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.0.0.00.00.00.00.00','REMUNERAÇÃO A PESSOAL','Compreende a remuneração do pessoal ativo civil ou militar, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos, soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo, emprego ou função de confiança no setor público, bem como as com contratos de terceirização de mão de obra que se refiram à substituição de servidores e empregados públicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.0.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO RPPS','Compreende a remuneração do pessoal ativo civil abrangidos pelo RPPS, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO RPPS  - CONSOLIDAÇÃO','Compreende a remuneração do pessoal ativo civil abrangidos pelo RPPS, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.00.00.00.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RPPS','COMPREENDE O SOMATORIO DOS VALORES COM VENCIMENTOS  E VANTAGENS FIXAS DO PESSOAL CIVIL DO TIPO: GRATIFICACAO, REPRESENTACAO, ADICIONAL INSALUBRIDADE, FERIAS, 13 SALARIO, LICENCA-PREMIO, ABONO PECUNIARIO, ADICIONAL NOTURNO, ETC.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.02.00.00.00.00','OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL - RPPS','COMPREENDE O VALOR DAS APROPRIACOES DAS AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL ABRANGIDOS PELO REGIME PROPRIO, RELACIONADAS AS ATIVIDADES DO CARGO OU FUNCAO DO SERVIDOR E CUJO PAGAMENTO SO SE REALIZA  EM CIRCUSTANCIAS ESPECIAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.03.00.00.00.00','SENTENCAS JUDICIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SENTENCAS JUDICIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.0.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO - RGPS','Compreende a remuneração do pessoal ativo civil abrangidos pelo RGPS, correspondente ao somatório das variações patrimoniais diminutivas com vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do emprego, inclusive os ocupantes de cargos em comissão não investidos em cargo efetivo, no setor público.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO - RGPS - CONSOLIDAÇÃO','Compreende a remuneração do pessoal ativo civil abrangidos pelo RGPS, correspondente ao somatório das variações patrimoniais diminutivas com vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do emprego, inclusive os ocupantes de cargos em comissão não investidos em cargo efetivo, no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.01.00.00.00.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS','REGISTRA O VALOR DAS APROPRIACOES DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM VENCIMENTOS  E VANTAGENS FIXAS DO PESSOAL CIVIL DO TIPO: GRATIFICACAO, REPRESENTACAO, ADICIONAL INSALUBRIDADE, FERIAS, 13 SALARIO, LICENCA-PREMIO, ABONO PECUNIARIO, ADICIONAL NOTURNO, ETC.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.02.00.00.00.00','OUTRAS VPD VARIAVEIS - PESSOAL CIVIL - RGPS','REGISTRA O VALOR DAS APROPRIACOES DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL ABRANGIDOS PELO REGIME GERAL, RELACIONADAS AS ATIVIDADES DO CARGO OU FUNCAO DO EMPREGADO E CUJO PAGAMENTO SO SE REALIZA  EM CIRCUSTANCIAS ESPECIAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.03.00.00.00.00','SENTENCAS JUDICIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SENTENCAS JUDICIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.04.00.00.00.00','CONTRATACAO POR TEMPO DETERMINADO','REGISTRA O VALOR DAS APROPRIACOES DE VARIACOES PATRIMONIAIS DIMINUTIVAS COM A CONTRATACAO DE PESSOAL POR TEMPO DETERMINADO PARA ATENDER A NECESSIDADE TEMPORARIA DE EXCEPCIONAL INTERESSE PUBLICO, DE ACORDO COM LEGISLACAO ESPECIFICA DE CADA ENTE DA FEDERACAO, INCLUSIVE OBRIGACOES PATRONAIS E OUTRAS DESPESAS VARIAVEIS, QUAND0 FOR O CASO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.3.0.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO MILITAR - ABRANGIDOS PELO REGIME PRÓPRIO DOS MILITARES','Compreende a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.3.1.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO MILITAR - ABRANGIDOS PELO REGIME PRÓPRIO DOS MILITARES - CONSOLIDAÇÃO','Compreende a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.0.0.00.00.00.00.00','ENCARGOS PATRONAIS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores e empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como contribuições a entidades fechadas de previdência e ainda outras contribuições patronais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.0.00.00.00.00.00','ENCARGOS PATRONAIS - RPPS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores públicos ativos, pertencentes aos órgãos e demais entidades do setor público.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.2.00.00.00.00.00','ENCARGOS PATRONAIS - RPPS - INTRA OFSS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores públicos ativos, pertencentes aos órgãos e demais entidades do setor público.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.2.01.00.00.00.00','CONTRIBUICAO PATRONAL PARA O RPPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.2.02.00.00.00.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.2.06.00.00.00.00','CONTRIBUIÇÃO PARA O PASEP SOBRE FOLHA DE PAGAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS  REALIZADAS COM A CONTRIBUIÇÃO PARA O PASEP SOBRE FOLHA DE PAGAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.2.99.00.00.00.00','OUTROS ENCARGOS PATRONAIS - RPPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RPPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.0.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investidos, em cargo efetivo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.1.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - CONSOLIDAÇÃO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.1.01.00.00.00.00','CONTRIBUICOES PREVIDENCIARIAS - INSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES QUE NAO PERTENCAM AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS AO INSS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.1.04.00.00.00.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.1.99.00.00.00.00','OUTROS ENCARGOS PATRONAIS - RGPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.2.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - INTRA OFSS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.3.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - UNIÃO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.3.01.00.00.00.00','CONTRIBUICOES PREVIDENCIARIAS - INSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES QUE NAO PERTENCAM AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS AO INSS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.3.04.00.00.00.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.3.99.00.00.00.00','OUTROS ENCARGOS PATRONAIS - RGPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.4.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - ESTADO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.5.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - MUNICÍPIO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investidos em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.3.0.00.00.00.00.00','ENCARGOS PATRONAIS - FGTS','Compreende os valores recolhidos mensalmente pelos empregadores, em conta bancaria vinculada do trabalhador no FGTS, correspondente a percentual definido em lei sobre a remuneração paga ou devida, no mês anterior, a cada trabalhador, incluídas na remuneração as parcelas de que tratam os artigos. 457 e 458 da CLT e a gratificação de natal a que se refere à lei nº 4.090, de 13 de julho de 1962, com as modificações da lei nº 4.749, de 12 de agosto de 1965. Entende-se por empregador a pessoa física ou a pessoa jurídica de direito privado ou de direito público, da administração pública direta, indireta ou fundacional de qualquer dos poderes, da União, dos estados, do distrito federal e dos municípios, que admitir trabalhadores a seu serviço, bem assim aquele que, regido por legislação especial, encontrar-se nessa condição ou figurar como fornecedor ou tomador de mão de obra, independente da responsabilidade solidaria e/ou subsidiaria a que eventualmente venha obrigar-se. Considera-se trabalhador toda pessoa física que prestar serviços a empregador, a locador ou tomador de mão de obra, excluídos os eventuais, os autônomos e os servidores públicos civis e militares sujeitos a regime jurídico próprio. O recolhimento do FGTS e obrigatório também nos casos de afastamento para prestação do serviço militar obrigatório e licença por acidente do trabalho. Não se incluem na remuneração, para os fins desta lei, as parcelas elencadas no § 9º do art. 28 da lei nº 8.212, de 24 de julho de 1991.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.3.1.00.00.00.00.00','ENCARGOS PATRONAIS - FGTS - CONSOLIDAÇÃO','Compreende os valores recolhidos mensalmente pelos empregadores, em conta bancaria vinculada do trabalhador no FGTS, correspondente a percentual definido em lei sobre a remuneração paga ou devida, no mês anterior, a cada trabalhador, incluídas na remuneração as parcelas de que tratam os artigos. 457 e 458 da CLT e a gratificação de natal a que se refere à lei nº 4.090, de 13 de julho de 1962, com as modificações da lei nº 4.749, de 12 de agosto de 1965. Entende-se por empregador a pessoa física ou a pessoa jurídica de direito privado ou de direito público, da administração pública direta, indireta ou fundacional de qualquer dos poderes, da União, dos estados, do distrito federal e dos municípios, que admitir trabalhadores a seu serviço, bem assim aquele que, regido por legislação especial, encontrar-se nessa condição ou figurar como fornecedor ou tomador de mão de obra, independente da responsabilidade solidaria e/ou subsidiaria a que eventualmente venha obrigar-se. Considera-se trabalhador toda pessoa física que prestar serviços a empregador, a locador ou tomador de mão de obra, excluídos os eventuais, os autônomos e os servidores públicos civis e militares sujeitos a regime jurídico próprio. O recolhimento do FGTS e obrigatório também nos casos de afastamento para prestação do serviço militar obrigatório e licença por acidente do trabalho. Não se incluem na remuneração, para os fins desta lei, as parcelas elencadas no § 9º do art. 28 da lei nº 8.212, de 24 de julho de 1991. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.3.1.01.00.00.00.00','FGTS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM OBRIGACOES RELATIVAS AO RECOLHIMENTO DO FGTS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.4.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS GERAIS','Compreende os encargos patronais relativos ao salário educação e as contribuições compulsórias dos empregadores sobre a folha de salários, destinados as entidades privadas de serviço social e de formação profissional, vinculadas ao sistema sindical, tais como SESI, SENAI, SESC e SENAC.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.4.1.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS GERAIS - CONSOLIDAÇÃO','Compreende os encargos patronais relativos ao salário educação e as contribuições compulsórias dos empregadores sobre a folha de salários, destinados as entidades privadas de serviço social e de formação profissional, vinculadas ao sistema sindical, tais como SESI, SENAI, SESC e SENAC. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.5.0.00.00.00.00.00','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA','Compreende o valor total das variações patrimoniais diminutivas relacionadas ao regime de previdência privada, de caráter complementar, organizado de forma autônoma em relação ao regime geral de previdência social, de caráter facultativo, baseado na constituição de reservas que garantam o benefício, nos termos do caput do art. 202 da constituição federal. Entende-se por entidades fechadas aquelas acessíveis, na forma regulamentada pelo órgão regulador e fiscalizador, exclusivamente aos empregados de uma empresa ou grupo de empresas e aos servidores da União, dos estados, do distrito federal e dos municípios, entes denominados patrocinadores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.5.1.00.00.00.00.00','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas relacionadas ao regime de previdência privada, de caráter complementar, organizado de forma autônoma em relação ao regime geral de previdência social, de caráter facultativo, baseado na constituição de reservas que garantam o benefício, nos termos do caput do art. 202 da constituição federal. Entende-se por entidades fechadas aquelas acessíveis, na forma regulamentada pelo órgão regulador e fiscalizador, exclusivamente aos empregados de uma empresa ou grupo de empresas e aos servidores da União, dos estados, do distrito federal e dos municípios, entes denominados patrocinadores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.5.1.01.00.00.00.00','COMPLEMENTACAO DE PREVIDENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   COM CONTRIBUICOES DE RESPONSABILIDADE DAS ENTIDADES PATROCINADORAS PARA ATENDER PLANO DE PREVIDENCIA COMPLEMENTAR, ADMINISTRADO POR SUAS INSTITUICOES DE SEGURIDADE SOCIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.5.1.03.00.00.00.00','CONTRIBUIÇÃO PATRONAL PREVIDENCIA PRIVADA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   COM CONTRIBUICAO PATRONAL, DEVIDA A ENTIDADES DE PREVIDENCIA PRIVADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.5.1.99.00.00.00.00','OUTRAS CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   COM CONTRIBUICOES A ENTIDADES PRIVADAS NAO ENQUADRADAS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.0.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.1.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - CONSOLIDAÇÃO','Registra outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.2.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - INTRA OFSS','Registra outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.2.01.00.00.00.00','OBRIGACOES PATRONAIS PARA O ATENDIMENTO A SAUDE E A ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ENCARGOS QUE A ADMINISTRAÇÃO TEM PELA SUA CONDIÇÃO DE EMPREGADORA, E RESULTANTES DE PAGAMENTO DE PESSOAL ATIVO, INATIVO E PENSIONISTAS,COM OBRIGACOES PATRONAIS PARA O ATENDIMENTO A SAUDE E A ASSISTENCIA SOCIAL DO SERVIDOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.3.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - UNIÃO','Registra outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.4.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - ESTADO','Registra outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.5.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - MUNICÍPIO','Registra outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.0.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal civil e militar , tais como para o pessoal civil: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxilia-alimentação, auxilia-transporte bem como outros decorrentes de acordo ou convenção coletiva no que se refere aos empregados públicos.  Para os militares: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda-de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo as despesas com vencimentos, soldos e quaisquer outras vantagens pecuniárias, bem como as despesas relacionadas aos benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL - RPPS','Compreende o valor total das variações patrimoniais diminutivas com benefícios a servidor público, tais como: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxílio-transporte,auxílio-alimentação e outros benefícios relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias permanentes, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizados e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.00.00.00.00.00','BENEFÍCIOS A PESSOAL - RPPS - CONSOLIDAÇÃO','Compreende o valor total das  variações patrimoniais diminutivas com benefícios a servidor público, tais como: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxílio-transporte,auxílio-alimentação e outros benefícios relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias permanentes, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.01.00.00.00.00','AUXILIO ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE  DESPESAS COM AUXÍLIO-ALIMENTAÇÃO PAGO/FORNECIDO AOS SERVIDORES OU EMPREGADOS DA ADMINISTRAÇÃO PÚBLICA DIRETA E INDIRETA., EM PECUNIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.02.00.00.00.00','AUXILIO TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   COM AUXILIO-TRANSPORTE PAGAS EM FORMA DE PECUNIA DIRETAMENTE AOS SERVIDORES, DESTINADO AO CUSTEIO PARCIAL DAS DESPESAS REALIZADAS COM TRANSPORTE COLETIVO MUNICIPAL INTERMUNICIPAL OU INTERESTADUAL NOS DESLOCAMENTOS DE SUAS RESIDENCIAS PARA OS LOCAIS DE TRABALHO E VICE-VERSA, OU TRABALHO-TRABALHO NOS CASOS DE ACUMULACAO LICITA DE CARGOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.04.00.00.00.00','AJUDA DE CUSTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AJUDA DE CUSTO DE PESSOAL CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.05.00.00.00.00','PLANO DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE  DESPESAS COM PLANO DE SAUDE AO SERVIDOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.06.00.00.00.00','AUXILIO CRECHE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-CRECHE, DEVIDO A SERVIDOR PUBLICO, DECORRENTE DE RESSARCIMENTO DE GASTOS COM A EDUCACAO PRE-ESCOLAR DE SEUS DEPENDENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.99.00.00.00.00','OUTROS BENEFICIOS A PESSOAL - RPPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM OUTROS BENEFICIOS A PESSOAL - RPPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL - RGPS','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos aos empregados públicos, e ainda outros relativos a acordo ou convenção coletiva. Estão excluídos deste grupo os vencimentos e quaisquer outras vantagens pecuniárias, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.00.00.00.00.00','BENEFÍCIOS A PESSOAL - RGPS - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos aos empregados públicos, e ainda outros relativos a acordo ou convenção coletiva. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídos ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizados e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.01.00.00.00.00','AUXILIO ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE  DESPESAS COM AUXÍLIO-ALIMENTAÇÃO PAGO/FORNECIDO AOS SERVIDORES OU EMPREGADOS DA ADMINISTRAÇÃO PÚBLICA DIRETA E INDIRETA., EM PECUNIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.02.00.00.00.00','AUXILIO TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   COM AUXILIO-TRANSPORTE PAGAS EM FORMA DE PECUNIA DIRETAMENTE AOS SERVIDORES, DESTINADO AO CUSTEIO PARCIAL DAS DESPESAS REALIZADAS COM TRANSPORTE COLETIVO MUNICIPAL INTERMUNICIPAL OU INTERESTADUAL NOS DESLOCAMENTOS DE SUAS RESIDENCIAS PARA OS LOCAIS DE TRABALHO E VICE-VERSA, OU TRABALHO-TRABALHO NOS CASOS DE ACUMULACAO LICITA DE CARGOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.04.00.00.00.00','AJUDA DE CUSTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS A TITULO DE AJUDA DE CUSTO DE PESSOAL CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.05.00.00.00.00','PLANO DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE  DESPESAS COM PLANO DE SAUDE AO SERVIDOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.06.00.00.00.00','AUXILIO CRECHE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   COM AUXILIO-CRECHE, DEVIDO A SERVIDOR PUBLICO, DECORRENTE DE RESSARCIMENTO DE GASTOS COM A EDUCACAO PRE-ESCOLAR DE SEUS DEPENDENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.99.00.00.00.00','OUTROS BENEFICIOS A PESSOAL - RGPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM OUTROS BENEFICIOS A PESSOAL - RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.3.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL - MILITAR','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal militar, tais como: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda-de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídos deste grupo os soldos e quaisquer outras vantagens pecuniárias permanentes, bem como as os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.3.1.00.00.00.00.00','BENEFÍCIOS A PESSOAL - MILITAR - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal militar, tais como: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda-de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídos deste grupo os soldos e quaisquer outras vantagens pecuniárias permanentes, bem como as os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.0.0.00.00.00.00.00','CUSTO DE PESSOAL E ENCARGOS','Compreende a variação patrimonial diminutiva relativa à pessoal e encargos utilizados na produção de bens ou serviços, sendo registrada apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.1.0.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - PESSOAL E ENCARGOS','Compreende as variações patrimoniais diminutivas relativas à pessoal e encargos apropriadas às mercadorias, sendo registradas apenas no momento da venda destas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.1.1.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a pessoal e encargos apropriadas as mercadorias, sendo registradas apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.2.0.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS - PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas relativas à pessoal e encargos, utilizadas na produção de bens, sendo registradas apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.2.1.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS - PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas à pessoal e encargos, utilizadas na produção de bens, sendo registradas apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.3.0.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS - PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas relativas a pessoal e encargos, utilizadas na produção de serviços, sendo registradas apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.3.1.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS - PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas a pessoal e encargos, utilizadas na produção de serviços, sendo registrada apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores, tais como as indenizações e restituições trabalhistas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.0.00.00.00.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS','Compreende o valor total com variações patrimoniais diminutivas resultante do pagamento efetuado a servidores públicos civis e empregados de entidades integrantes da administração pública, inclusive ferias e aviso prévio indenizados, multas e contribuições incidentes sobre os depósitos do fundo de garantia por tempo de serviço, etc., em função da perda da condição de servidor ou empregado, podendo ser em decorrência da participação em programa de desligamento voluntario.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.1.00.00.00.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS - CONSOLIDAÇÃO','Compreende o valor total com variações patrimoniais diminutivas resultante do pagamento efetuado a servidores públicos civis e empregados de entidades integrantes da administração pública, inclusive ferias e aviso prévio indenizados, multas e contribuições incidentes sobre os depósitos do fundo de garantia por tempo de serviço, etc., em função da perda da condição de servidor ou empregado, podendo ser em decorrência da participação em programa de desligamento voluntario. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.1.01.00.00.00.00','INDENIZACOES E RESTITUICOES TRABALHISTAS - ATIVO CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REFERENTE A INDENIZACOES E  RESTITUICOES TRABALHISTAS DO PESSOAL ATIVO CIVIL, INCLUSIVE AS DESPESAS COM PROGRAMA DE DESLIGAMENTO VOLUNTARIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.1.03.00.00.00.00','INDENIZACOES E RESTITUICOES TRABALHISTAS - INATIVO CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REFERENTE A INDENIZACOES E RESTITUICOES TRABALHISTAS DO PESSOAL  INATIVO CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.1.06.00.00.00.00','INDENIZACOES E RESTITUICOES TRABALHISTAS - PENSIONISTA CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESDE DESPESAS REFERENTE A INDENIZACOES E  RESTITUICOES TRABALHISTAS DO PESSOAL PENSIONISTA CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.1.07.00.00.00.00','ENCARGOS SOBRE INDENIZACOES TRABALHISTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE ENCARGOS SOBRE INDENIZACOES TRABALHISTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.1.99.00.00.00.00','DIVERSAS INDENIZACOES TRABALHISTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   DE INDENIZACOES TRABALHISTA QUE NAO SE PROCESSARAM NA EPOCA PROPRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.2.0.00.00.00.00.00','PESSOAL REQUISITADO DE OUTROS ORGAOS','Compreende as variações patrimoniais diminutivas  com pessoal requisitado de outros órgãos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.2.1.00.00.00.00.00','PESSOAL REQUISITADO DE OUTROS ORGAOS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas  com pessoal requisitado de outros órgãos.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.9.0.00.00.00.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.9.1.00.00.00.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.0.0.0.00.00.00.00.00','BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS','Compreendem as variações patrimoniais diminutivas relativas às aposentadorias, pensões, reformas, reserva remunerada e outros benefícios previdenciários de caráter contributivo, do regime próprio da previdência social - RPPS e do regime geral da previdência social - RGPS, bem como as ações de assistência social, que são políticas de seguridade social não contributiva, visando ao enfrentamento da pobreza, a garantia dos mínimos sociais, ao provimento de condições para atender contingencias sociais e a universalização dos direitos sociais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.0.0.00.00.00.00.00','APOSENTADORIAS E REFORMAS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.0.00.00.00.00.00','APOSENTADORIAS - RPPS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.1.00.00.00.00.00','APOSENTADORIAS - RPPS - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.1.01.00.00.00.00','PROVENTOS - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM PROVENTOS DE  APOSENTADORIAS PESSOAL CIVIL REGIDOS PELO RPPS APROVADA PELO TRIBUNAL DE CONTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.1.06.00.00.00.00','13 SALARIO - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS A TITULO DE 13 SALARIO - PESSOAL CIVIL - RPPS - APOSENTADORIAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.1.99.00.00.00.00','OUTRAS APOSENTADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS APOSENTADORIAS NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.2.0.00.00.00.00.00','APOSENTADORIAS - RGPS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RGPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.2.1.00.00.00.00.00','APOSENTADORIAS - RGPS - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidos pelo RGPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.3.0.00.00.00.00.00','RESERVA REMUNERADA E REFORMAS - MILITAR','Compreende as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.3.1.00.00.00.00.00','RESERVA REMUNERADA E REFORMAS - MILITAR - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.9.0.00.00.00.00.00','OUTRAS APOSENTADORIAS','Compreende as variações patrimoniais diminutivas provenientes de outras aposentadorias','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.9.1.00.00.00.00.00','OUTRAS APOSENTADORIAS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de outras aposentadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.0.0.00.00.00.00.00','PENSÕES','Compreendem os benefícios da previdência social que garantem uma renda aos dependentes do segurado falecido.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.1.0.00.00.00.00.00','PENSÕES - RPPS','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, pelo regime próprio da previdência social - RPPS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.1.1.00.00.00.00.00','PENSÕES - RPPS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, pelo regime próprio da previdência social - RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.1.1.01.00.00.00.00','PENSOES CIVIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM  PENSOES ORIGINARIAS DE PESSOAL CIVIL - RPPS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.1.1.02.00.00.00.00','13 SALARIO - PESSOAL CIVIL - PENSIONISTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS A TITULO DE 13 SALARIO - PESSOAL MILITAR - PENSIONISTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.1.1.99.00.00.00.00','OUTRAS PENSOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM OUTRAS PENSOES NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.2.0.00.00.00.00.00','PENSÕES - RGPS','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, regidos pelo regime geral da previdência social -RGPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.2.1.00.00.00.00.00','PENSÕES - RGPS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, regidos pelo regime geral da previdência social - RGPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.3.0.00.00.00.00.00','PENSÕES - MILITAR','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos militares, após seu óbito, regidos pelo regime próprio.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.3.1.00.00.00.00.00','PENSÕES - MILITAR - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos militares, após seu óbito, regidos pelo regime próprio. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.9.0.00.00.00.00.00','OUTRAS PENSÕES','Compreende as variações patrimoniais diminutivas provenientes de outras pensões.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.9.1.00.00.00.00.00','OUTRAS PENSÕES - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de outras pensões. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.0.0.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','Compreendem os benefícios de prestação continuada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.1.0.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO','Compreendem os benefícios de prestação continuada ao idoso e renda mensal vitalícia por idade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.1.1.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada e renda mensal vitalícia por idade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.2.0.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA','Compreendem os benefícios de prestação continuada ao portador de deficiência e renda mensal vitalícia - invalidez','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.2.1.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada ao portador de deficiência e renda mensal vitalícia - invalidez. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.9.0.00.00.00.00.00','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','Compreendem outros benefícios de prestação continuada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.9.1.00.00.00.00.00','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA - CONSOLIDAÇÃO','Registra outros benefícios de prestação continuada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.0.0.00.00.00.00.00','BENEFÍCIOS EVENTUAIS','Compreendem as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de nascimento, morte, situações de vulnerabilidade temporária e de calamidade pública. As provisões relativas a programas, projetos, serviços e benefícios diretamente vinculados ao campo da saúde, educação, integração nacional e das demais políticas setoriais não se incluem na modalidade de benefícios eventuais da assistência social.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.1.0.00.00.00.00.00','AUXÍLIO POR NATALIDADE','Compreende o beneficio eventual que visa o pagamento de auxílio por natalidade as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.1.1.00.00.00.00.00','AUXÍLIO POR NATALIDADE - CONSOLIDAÇÃO','Registra o beneficio eventual que visa o pagamento de auxílio por natalidade as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.2.0.00.00.00.00.00','AUXÍLIO POR MORTE','Compreende o beneficio eventual que visa o pagamento de auxílio por morte as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.2.1.00.00.00.00.00','AUXÍLIO POR MORTE - CONSOLIDAÇÃO','Registra o beneficio eventual que visa o pagamento de auxílio por morte as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.3.0.00.00.00.00.00','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORÁRIA','Compreende as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de situações de vulnerabilidade temporária, com prioridade para a criança, a família, o idoso, a pessoa portadora de deficiência, a gestante e a nutriz.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.3.1.00.00.00.00.00','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORÁRIA - CONSOLIDAÇÃO','Registra as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de situações de vulnerabilidade temporária, com prioridade para a criança, a família, o idoso, a pessoa portadora de deficiência, a gestante e a nutriz. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.4.0.00.00.00.00.00','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA','Compreendem os benefícios para atendimento de vitimas de calamidade pública, de modo a assegurar lhes a sobrevivência e a reconstrução de sua autonomia. Entende-se se por estado de calamidade pública o reconhecimento pelo poder público de situação anormal, advinda de baixas ou altas temperaturas, tempestades, enchentes, inversão térmica, desabamentos, incêndios, epidemias, causando sérios danos à comunidade afetada, inclusive a incolumidade ou a vida de seus integrantes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.4.1.00.00.00.00.00','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA - COSOLIDAÇÃO','Compreendem os benefícios para atendimento de vitimas de calamidade pública, de modo a assegurar - lhes a sobrevivência e a reconstrução de sua autonomia. Entende-se por estado de calamidade pública o reconhecimento pelo poder público de situação anormal, advinda de baixas ou altas temperaturas, tempestades, enchentes, inversão térmica, desabamentos, incêndios, epidemias, causando sérios danos à comunidade afetada, inclusive a incolumidade ou a vida de seus integrantes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.9.0.00.00.00.00.00','OUTROS BENEFÍCIOS EVENTUAIS','Compreende a variação patrimonial diminutiva proveniente de outros benefícios eventuais','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.9.1.00.00.00.00.00','OUTROS BENEFÍCIOS EVENTUAIS - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva proveniente de outros benefícios eventuais.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.5.0.0.00.00.00.00.00','POLÍTICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA','Compreende as políticas públicas que visem contribuir para a redução da fome, da pobreza, da desigualdade e de outras formas de privação vividas pelas famílias mais excluídas, considerando três dimensões: o alivio imediato da pobreza, por meio da transferência de renda diretamente as famílias pobres e extremamente pobres; a contribuição para a redução da pobreza da geração seguinte, por meio do reforço do direito de acesso aos serviços de saúde e de educação, com o cumprimento das condicionalidades nestas áreas; e a articulação de ações complementares, de forma a desenvolver as capacidades das famílias beneficiárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.5.0.1.00.00.00.00.00','POLÍTICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA - CONSOLIDAÇÃO','Compreende as políticas públicas que visem contribuir para a redução da fome, da pobreza, da desigualdade e de outras formas de privação vividas pelas famílias mais excluídas, considerando três dimensões: o alivio imediato da pobreza, por meio da transferência de renda diretamente as famílias pobres e extremamente pobres; a contribuição para a redução da pobreza da geração seguinte, por meio do reforço do direito de acesso aos serviços de saúde e de educação, com o cumprimento das condicionalidades nestas áreas; e a articulação de ações complementares, de forma a desenvolver as capacidades das famílias beneficiarias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.0.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários ou assistenciais, não abrangidas nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RPPS, não abrangidas nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RPPS, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.01.00.00.00.00','AUXILIO-DOENCA','REGISTRA AS  VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-DOENCA, DEVIDO AO SEGURADO QUE  FICAR INCAPACITADO PARA O TRABALHO','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.02.00.00.00.00','SALARIO MATERNIDADE','REGISTRA AS  VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-MATERNIDADE, DEVIDO A SEGURADA GESTANTE, NA FORMA DA LEI, DURANTE O PERIODO DE LICENCA GESTANTE PREVISTO EM LEI.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.03.00.00.00.00','SALARIO-FAMILIA','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO FAMILIA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.04.00.00.00.00','AUXILIO-RECLUSAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXILIO-RECLUSAO PAGO COM RECURSOS DO TESOURO DO MUNICIPIO OU COM RECURSOS DO RPPS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.05.00.00.00.00','AUXILIO-ACIDENTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM  AUXILIO-ACIDENTE  PREVIDENCIARIO  CONCEDIDO, COMO INDENIZACAO, AO SEGURADO QUANDO, DE ACORDO COM A LEGISLACAO VIGENTE,  APOS A  CONSOLIDACAO  DAS  LESOES  DECORRENTES  DE ACIDENTES DE QUALQUER NATUREZA  RESULTAR  SEQUELAS  QUE IMPLIQUEM  REDUCAO DA CAPACIDADE FUNCIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.06.00.00.00.00','ABONO ANUAL - 13° SALARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ABONO ANUAL - 13º SALÁRIO, DEVIDO AOS SEGURADOS BENEFICIÁRIOS, A PARTIR DE 15 DIAS EM GOZO DE BENEFÍCIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.99.00.00.00.00','OUTROS BENEFICIOS PREVIDENCIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTROS BENEFICIOS PREVIDENCIARIOS NÃO PREVISTOS NOS ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.2.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RGPS, não abrangidas nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.2.1.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RGPS, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.3.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do regime próprio dos militares, não abrangidas nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.3.1.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do regime próprio dos militares, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','Compreende as variações patrimoniais diminutivas provenientes de outros benefícios previdenciários e assistenciais','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de outros benefícios previdenciários e assistenciais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.01.00.00.00.00','AUXILIO FUNERAL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO DEVIDO A FAMILIA DO SERVIDOR FALECIDO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.02.00.00.00.00','AUXILIO NATALIDADE','REGISTRA O VALOR DAS  VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE,  DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR  MOTIVO DE NASCIMENTO DE FILHO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.03.00.00.00.00','AUXILIO RECLUSAO','REGISTRA O VALOR DAS  VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR, AFASTADO POR MOTIVO DE PRISAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.04.00.00.00.00','ASSISTENCIA PRE-ESCOLAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ASSISTENCIA PRE-ESCOLAR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.05.00.00.00.00','AUXILIO INVALIDEZ','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-INVALIDEZ.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.06.00.00.00.00','CONTRIBUICAO DA ENTIDADE PARA O ATENDIMENTO A SAUDE DO SERVIDOR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM A  CONTRIBUICAO DA ENTIDADE PARA O ATENDIMENTO A SAUDE DO SERVIDOR. POR EXEMPLO: IPE E UNIMED.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.0.0.0.00.00.00.00.00','USO DE BENS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende o somatório das variações patrimoniais diminutivas com manutenção e operação da maquina pública, exceto despesas com pessoal e encargos que serão registradas em grupo específico (despesas de pessoal e encargos). Compreende: diárias, material de consumo, material de distribuição gratuita, passagens e despesas com locomoção, serviços de terceiros, arrendamento mercantil operacional, aluguel, depreciação, amortização, exaustão, entre outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.0.0.00.00.00.00.00','USO DE MATERIAL DE CONSUMO','Compreende as variações patrimoniais diminutivas provenientes da distribuição do material de consumo. Um material é considerado de consumo quando for de duração inferior a dois anos, frágil, perecível, incorporável, transformável ou cuja finalidade seja para consumo imediato ou para reposição.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.0.00.00.00.00.00','CONSUMO DE MATERIAL','Compreende as variações patrimoniais diminutivas provenientes de requisição de material de consumo para uso interno.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.00.00.00.00.00','CONSUMO DE MATERIAL - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de requisição de material de consumo para uso interno.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.01.00.00.00.00','COMBUSTIVEIS E LUBRIFICANTES AUTOMOTIVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE  COMBUSTIVEIS PARA MOTORES A  COMBUSTAO INTERNA DE VEICULOS RODOVIARIOS, TRATORES EM GERAL, EMBARCACOES  DIVERSAS E GRUPOS GERADORES ESTACIONADOS OU TRANSPORTAVEIS, E TODOS OS  OLEOS LUBRIFICANTES DESTINADOS AOS SISTEMAS HIDRAULICOS, HIDRAMATICOS,  DE CAIXA DE TRANSMISSAO DE FORCA E GRAXAS GRAFITADAS PARA ALTAS E BAIXAS TEMPERATURAS. ADITIVOS - ALCOOL HIDRATADO - FLUIDO PARA AMORTECEDOR - FLUIDO PARA  TRANSMISSAO HIDRAULICA - GASOLINA - GRAXAS - OLEO DIESEL - OLEO PARA  CARTER - OLEO PARA FREIO HIDRAULICO E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.02.00.00.00.00','COMBUSTIVEIS E LUBRIFICANTES DE AVIACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COMBUSTIVEIS E LUBRIFICANTES  DESTINADOS A QUALQUER TIPO DE AERONAVE. ADITIVOS - GASOLINA - GRAXAS - OLEOS E FLUIDOS EM GERAL - QUEROSENE  E  OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.03.00.00.00.00','COMBUSTIVEIS E LUBRIFICANTES PARA OUTRAS FINALIDADES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COMBUSTIVEIS E LUBRIFICANTES PARA  OUTRAS FINALIDADES QUE NAO SE ENQUADRAM EM ITENS ANTERIORES. CARBURETO - CARVAO MINERAL - CARVAO VEGETAL - LENHA - QUEROSENE COMUM - COMBUSTIVEIS E LUBRIFICANTES DE USO FERROVIARIO E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.04.00.00.00.00','GAS E OUTROS MATERIAIS ENGARRAFADOS','REGISTRA  AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE GAS DE USO INDUSTRIAL,  DE TRATAMENTO DE AGUA, DE ILUMINACAO, DE USO MEDICO, BEM COMO GASES NOBRES PARA USO EM  LABORATORIO CIENTIFICO, TAIS COMO: ACETILENO - CARBONICO FREON  -  HELIO  -  HIDROGENIO  -  LIQUEFEITO DE PETROLEO - NITROGENIO - OXIGENIO E OUTROS. REGISTRA, AINDA, O VALOR DAS DESPESAS COM GAS, PO QUIMICO, AGUA  PRESSURIZADA E OUTROS MATERIAIS UTILIZADOS NA RECARGA DE EXTINTORES DE INCENDIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.05.00.00.00.00','EXPLOSIVOS E MUNICOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE CARGAS DE PROJECAO  EM PECAS DE ARTILHARIA, MISSEIS GUIADOS E NAO GUIADOS, CAPSULAS OU  ESTOJOS PARA RECARGA E EXPLOSIVOS DE USO MILITAR E PARAMILITAR. BALAS E SIMILARES - ESTOPIM - EXPLOSIVOS, TAIS COMO: ARTEFATOS EXPLOSIVOS - ARTIGOS PIROTECNICOS - CAPSULAS DE DETONACAO - DINAMITE - ESPOLETA - FOGOS DE ARTIFICIO - GRANADA - POLVORA E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.06.00.00.00.00','ALIMENTOS PARA ANIMAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ALIMENTOS DESTINADOS A GADO  BOVINO, EQUINO, MUAR E BUFALINO, CAPRINOS, SUINOS, OVINOS,  AVES  DE  QUALQUER ESPECIE, COMO TAMBEM PARA ANIMAIS SILVESTRES EM CATIVEIRO (JARDINS ZOOLOGICOS OU LABORATORIOS) E OUTROS. ALFAFA - ALPISTE - CAPIM VERDE - FARELO - FARINHAS EM  GERAL  -  FUBA GROSSO - MILHO EM GRAO - RACAO BALANCEADA - SAL MINERAL - SUPLEMENTOS VITAMINICOS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.07.00.00.00.00','GENEROS DE ALIMENTACAO','REGISTRA  AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE GENEROS DE ALIMENTACAO AO NATURAL, BENEFICIADOS OU CONSERVADOS. ACUCAR - ADOCANTE - AGUA MINERAL - BEBIDAS - CAFE - CARNES EM GERAL - CEREAIS - CHAS - CONDIMENTOS - FRUTAS - GELO - LEGUMES - REFRIGERANTES - SUCOS - TEMPEROS - VERDURAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.08.00.00.00.00','ANIMAIS PARA PESQUISA E ABATE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ANIMAIS PARA PESQUISA E ABATE. INCLUEM-SE NESTA CLASSIFICACAO OS PEIXES E MARISCOS, TODAS AS ESPECIES DE MAMIFEROS, ABELHAS PARA ESTUDOS, PESQUISA E PRODUCAO DE MEL, BEM ASSIM QUALQUER OUTRO ANIMAL DESTINADO A ESTUDO GENETICO OU ALIMENTACAO. BOI - CABRITO - COBAIAS EM GERAL - MACACO - RATO - RA E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.09.00.00.00.00','MATERIAL FARMACOLOGICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MEDICAMENTOS OU COMPONENTES DESTINADOS A MANIPULACAO DE DROGAS MEDICAMENTOSAS. MEDICAMENTOS - SORO - VACINAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.10.00.00.00.00','MATERIAL ODONTOLOGICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA PACIENTES DA AREA ODONTOLOGICA, BEM COMO OS UTILIZADOS INDIRETAMENTE PELOS PROTETICOS NA CONFECCAO DE PROTESES DIVERSAS. AGULHAS - AMALGAMA - ANESTESICOS  -  BROCA  -  CIMENTO ODONTOLOGICO  -ESPATULA ODONTOLOGICA - FILMES PARA RAIO X  -  PLATINA  -  RESINAS ODONTOLOGICAS - SERINGAS  - SUGADOR E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.11.00.00.00.00','MATERIAL QUIMICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS ELEMENTOS OU COMPOSTOS QUIMICOS DESTINADOS AO FABRICO DE PRODUTOS QUIMICOS, ANALISES LABORATORIAIS, BEM COMO AQUELES DESTINADOS AO COMBATE DE PRAGAS OU EPIZOOTIAS. ACIDOS - INSETICIDAS - PRODUTOS QUIMICOS PARA  TRATAMENTO  DE  AGUA  -REAGENTES QUIMICOS - SAIS - SOLVENTES -  SUBSTANCIAS  UTILIZADAS  PARA COMBATER INSETOS, FUNGOS E BACTERIAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.12.00.00.00.00','MATERIAL DE COUDELARIA OU DE USO ZOOTECNICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS  NO  ARREAMENTO DE ANIMAIS DESTINADOS A MONTARIA, COM EXCECAO  DA  SELA,  COMO  TAMBEM AQUELES DESTINADOS AO ADESTRAMENTO DE CAES DE GUARDA OU  OUTRO ANIMAL DOMESTICO. ARGOLAS DE METAL - ARREAMENTO - BARRIGUEIRAS - BRIDOES -  CABRESTOS  - CINCHAS - CRAVOS - ESCOVAS PARA ANIMAIS  -  ESTRIBOS  -  FERRADURAS  - MANTAS DE PANO - MATERIAL PARA APICULTURA -  MATERIAL  DE FERRAGEM  E CONTENCAO DE ANIMAIS - PEITORAIS - RASPADEIRAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.13.00.00.00.00','MATERIAL DE CACA E PESCA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA CACA E PESCA DE ANIMAIS. ANZOIS - CORDOALHAS PARA REDES CHUMBADAS - ISCAS - LINHAS  DE  NYLON - MASCARAS PARA VISAO SUBMARINA - MOLINETES - NADADEIRAS  DE  BORRACHA - REDES - ROUPAS E ACESSORIOS PARA MERGULHO - VARAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.14.00.00.00.00','MATERIAL EDUCATIVO E ESPORTIVO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS CONSUMIDOS DIRETAMENTE NAS ATIVIDADES EDUCATIVAS E ESPORTIVAS DE CRIANCAS E ADULTOS. APITOS - BOLAS - BONES - BOTAS ESPECIAIS  -  BRINQUEDOS  EDUCATIVOS  - CALCOES  -  CAMISAS  DE  MALHA  -  CHUTEIRAS  -  CORDAS  -  ESTEIRAS -JOELHEIRAS - LUVAS - MATERIAIS  PEDAGOGICOS  -  MEIAS  -  OCULOS  PARA MOTOCICLISTAS - PATINS - QUIMONOS - RAQUETES - REDES PARA  PRATICA  DE ESPORTES - TENIS E SAPATILHAS - TORNOZELEIRAS - TOUCA PARA NATACAO   E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.15.00.00.00.00','MATERIAL PARA  FESTIVIDADES E HOMENAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO UTILIZADOS  EM FESTIVIDADES E HOMENAGENS, INCLUINDO ARTIGOS PARA DECORACAO E BUFFET. ARRANJOS E COROAS DE FLORES - BEBIDAS - DOCES - SALGADOS - PLACAS COMEMORATIVAS (EXCETO AS PLACAS PARA DISTRIBUICAO GRATUITA) E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.16.00.00.00.00','MATERIAL DE EXPEDIENTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS APLICADOS  DIRETAMENTE NOS TRABALHOS ADMINISTRATIVOS, NOS ESCRITORIOS PUBLICOS,  NOS  CENTROS DE  ESTUDOS E PESQUISAS, NAS ESCOLAS, NAS UNIVERSIDADES ETC.  AGENDA - ALFINETE DE ACO - ALMOFADA P/ CARIMBOS - APAGADOR - APONTADOR DE LAPIS - ARQUIVO P/ DISQUETE - BANDEJA PARA PAPEIS - BLOCO P/ RASCU-NHO - BOBINA PAPEL P/ CALCULADORAS - BORRACHA -  CADERNO  -  CANETA  -CAPA DE PROCESSO - CARIMBOS EM GERAL -  CARTOLINA  -  CLASSIFICADOR  -CLIPE - COLA - COLCHETE - CORRETIVO - ENVELOPE - ESPATULA - ESTENCIL -ESTILETE - EXTRATOR DE GRAMPOS - FITA ADESIVA - FITA P/ MAQUINA DE ES-CREVER E CALCULAR - GIZ - GOMA  ELASTICA  -  GRAFITE  -  GRAMPEADOR  -GRAMPOS - GUIA P/ ARQUIVO - GUIA DE ENDERECAMENTO POSTAL - IMPRESSOS E FORMULARIOS EM GERAL - INTERCALADOR P/ FICHARIO  -  LACRE  -  LAPIS  -LAPISEIRA - LIMPA TIPOS - LIVROS DE ATA, DE PONTO  E  DE  PROTOCOLO  -PAPEIS - PASTAS EM GERAL - PERCEVEJO - PERFURADOR - PINCA - PLACAS DE ACRILICO - PLASTICOS - PORTA-LAPIS - REGISTRADOR - REGUA - SELOS P/ CORRESPONDENCIA - TESOURA - TINTAS - TONER - TRANSPARENCIAS - ETIQUETAS E  OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.17.00.00.00.00','MATERIAL DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SUPRIMENTOS DE TI, INCLUSIVE PECAS  PARA REPOSICAO. CARTUCHOS DE TINTA - CAPAS PLASTICAS PROTETORAS PARA MICROS E IMPRES- SORAS - CD-ROM VIRGEM - DISQUETES - ETIQUETAS EM FORMULARIOS-CONTINUOS -LEITORA/SMARTCARD - MOUSE E TECLADO (REPOSICAO) - MOUSE PAD - PECAS E ACESSORIOS PARA COMPUTADORES E PERIFERICOS - RECARGA DE CARTUCHOS DE TINTA - TONER PARA IMPRESORAS A LASER - CARTOES MAGNETICOS - REPOSICAO DE LEITORA/TOKEN PEN-DRIVE/OUTROS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.18.00.00.00.00','MATERIAIS E MEDICAMENTOS P/ USO VETERINARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS E MEDICAMENTOS PARA USO   VETERINARIO.   VACINAS - MEDICAMENTOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.19.00.00.00.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS APLICADOS DIRETAMENTE  NAS PRESERVACOES, ACOMODACOES OU EMBALAGENS DE QUALQUER PRODUTO. ARAME - BARBANTE - CAIXAS PLASTICAS, DE MADEIRA, PAPELAO  E  ISOPOR  -CORDAS - ENGRADADOS - FITAS DE ACO OU METALICAS -  FITAS  GOMADORAS  -GARRAFAS E POTES - LINHA - PAPEL DE EMBRULHO -  PAPELAO  -  SACOLAS  -SACOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.20.00.00.00.00','MATERIAL DE CAMA, MESA E BANHO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS EM  DORMITORIOS COLETIVOS, RESIDENCIAIS, HOTEIS, RESTAURANTES ETC.   COBERTORES - COLCHAS - COLCHONETES - FRONHAS - GUARDANAPOS - LENCOIS -TOALHAS - TRAVESSEIROS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.21.00.00.00.00','MATERIAL DE COPA E COZINHA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA REFEITORIOS DE QUALQUER TIPO, COZINHAS RESIDENCIAIS, DE HOTEIS, DE  HOSPITAIS,  DEESCOLAS, DE UNIVERSIDADES, DE FABRICAS ETC. ABRIDOR DE GARRAFA - ACUCAREIROS -  ARTIGOS  DE  VIDRO  E  PLASTICO  -BANDEJAS - COADORES  -  COLHERES  -  COPOS  -  EBULIDORES  -  FACAS  -FARINHEIROS - FOSFOROS - FRIGIDEIRAS - GARFOS -  GARRAFAS  TERMICAS  -PALITEIROS - PANELAS - PANOS DE COZINHA - PAPEL ALUMINIO  -  PRATOS  -RECIPIENTES PARA AGUA - SUPORTES DE COPOS  P/ CAFEZINHO  -  TIGELAS  -VELAS - XICARAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.22.00.00.00.00','MATERIAL DE LIMPEZA E PROD. DE HIGIENIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DESTINADOS A  HIGIENIZACAO PESSOAL, DE AMBIENTES DE TRABALHO, DE HOSPITAIS ETC. ALCOOL ETILICO - ANTICORROSIVO - APARELHO  DE  BARBEAR  DESCARTAVEL  -BALDE PLASTICO - BOMBA P/ INSETICIDA - CAPACHO - CERA - CESTO  P/ LIXO- CREME DENTAL - DESINFETANTE - DESODORIZANTE - DETERGENTE - ESCOVA DEDENTES - ESCOVA P/ ROUPAS E SAPATOS - ESPANADOR - ESPONJA -  ESTOPA  -FLANELA - INSETICIDA - LUSTRA-MOVEIS - MANGUEIRA - NAFTALINA - PA PARALIXO - PALHA DE ACO - PANOS P/ LIMPEZA - PAPEL HIGIENICO - PASTA  PARALIMPEZA DE UTENSILIOS - PORTA-SABAO -  REMOVEDOR  -  RODO  -  SABAO  -SABONETE - SACO P/ LIXO - SAPONACEO - SODA CAUSTICA - TOALHA DE  PAPEL- VASSOURA - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.23.00.00.00.00','UNIFORMES, TECIDOS E AVIAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE UNIFORMES OU QUALQUER TECIDO OU MATERIAL SINTETICO QUE SE DESTINE A CONFECCAO DE ROUPAS, COM LINHAS DE  QUALQUER ESPECIE DESTINADAS A COSTURAS E OUTROS MATERIAIS DE CONSUMO  EMPREGADOS DIRETA OU INDIRETAMENTE NA CONFECCAO DE ROUPAS.            AGASALHOS - ARTIGOS DE COSTURA - AVENTAIS - BLUSAS - BOTOES - CADARCOS- CALCADOS - CALCAS - CAMISAS - CAPAS - CHAPEUS - CINTOS - ELASTICOS -GRAVATAS - GUARDA-POS - LINHAS - MACACOES - MEIAS - TECIDOS EM GERAL -UNIFORMES MILITARES OU DE USO CIVIL - ZIPERES - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.24.00.00.00.00','MATERIAL PARA MANUTENÇÃO DE BENS IMOVEIS/INSTALACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO PARA APLICACAO,MANUTENCAO E REPOSICAO DE QUALQUER BEM PUBLICO. AMIANTO - APARELHOS SANITARIOS - ARAMES  LISO  E  FARPADO  -  AREIA  -BASCULANTE - BOCA DE LOBO - BOIA - BRITA - BROCHA -  CABO  METALICO  -CAL - CANO - CERAMICA - CIMENTO - COLA - CONDUTORES DE FIOS - CONEXOES- CURVAS - ESQUADRIAS - FECHADURAS  -  FERRO  -  GAXETAS  -  GRADES  -IMPERMEABILIZANTES -  ISOLANTES  ACUSTICOS  E  TERMICOS  -  JANELAS  -JOELHOS - LADRILHOS -  LAVATORIOS  -  LIXAS  -  MADEIRA  -  MARCOS  DECONCRETO - MASSA CORRIDA - NIPLE - PAPEL DE PAREDE - PARAFUSOS -  - PECAS P/ELEVADORES,PORTOES ELETRICOS, AR CONDICIONADO CENTRAL, ETC- PIAS- PIGMENTOS - PORTAS E PORTAIS - PREGOS - ROLOS SOLVENTES  -  SIFAO  -TACOS - TAMPA P/ VASO - TAMPAO DE FERRO - TANQUE - TELA DE  ESTUQUE  -TELHA - TIJOLO - TINTA - TORNEIRA -  TRINCHA  -  TUBO  DE  CONCRETO  -VALVULAS - VERNIZ - VIDRO - AQUECEDORES A GAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.25.00.00.00.00','MATERIAL PARA MANUTENCAO DE BENS MOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COMPONENTES, PECAS, ACESSORIOS E SOBRESSALENTES PARA APLICACAO, MANUTENCAO  E  REPOSICAO  EM  BENS MOVEIS EM GERAL.. CABOS - CHAVES - CILINDROS P/ MAQUINAS COPIADORAS -  COMPRESSOR  P/ AR   CONDICIONADO -  MANGUEIRA  P/ FOGAO    -  PECAS DE REPOSICAO DE APARELHOS E MAQUINAS EM  GERAL  -MATERIAIS DE REPOSICAO PARA INSTRUMENTOS MUSICAIS - VIDRO DE MESA E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.26.00.00.00.00','MATERIAL ELETRICO E ELETRONICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO PARA APLICACAO,MANUTENCAO E REPOSICAO DOS SISTEMAS, APARELHOS E EQUIPAMENTOS  ELETRICOS E ELETRONICOS. BENJAMINS - BOCAIS - CALHAS - CAPACITORES E  RESISTORES  -  CHAVES  DE LIGACAO - CIRCUITOS ELETRONICOS - CONDUTORES - COMPONENTES DE APARELHOELETRONICO - DIODOS - DISJUNTORES - ELETRODOS - ELIMINADOR DE PILHAS -ESPELHOS PARA INTERRUPTORES - FIOS E CABOS - FITA ISOLANTE -  FUSIVEIS- INTERRUPTORES - LAMPADAS E LUMINARIAS - PILHAS E BATERIAS - PINOS  E PLUGS - PLACAS DE BAQUELITE - REATORES - RECEPTACULOS - RESISTENCIAS -STARTS - SUPORTES - TOMADA DE CORRENTE - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.27.00.00.00.00','MATERIAL DE MANOBRA E PATRULHAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO  UTILIZADOS  EM CAMPANHA MILITAR OU PARAMILITAR, EM MANOBRAS DE TROPAS, EM TREINAMENTOOU EM ACAO EM PATRULLHAMENTO OSTENSIVO OU RODOVIARIO, EM  CAMPANHA  DE SAUDE PUBLICA ETC.   BINOCULO - CARTA NAUTICA - CANTIL - CORDAS - FLAMULAS E  BANDEIRAS  DESINALIZACAO - LANTERNAS - MEDICAMENTOS DE PRONTO-SOCORRO - MOCHILAS  - PIQUETES - SACOLAS - SACOS DE DORMIR - SINALEIROS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.28.00.00.00.00','MATERIAL DE PROTECAO E SEGURANCA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO UTILIZADOS  DIRETAMENTE NA PROTECAO DE PESSOAS OU BENS  PUBLICOS,  PARA  SOCORRO  DE PESSOAS E ANIMAIS OU PARA SOCORRO DE VEICULOS, AERONAVES E EMBARCACOES, ASSIM COMO QUALQUER OUTRO ITEM APLICADO DIRETAMENTE NAS ATIVIDADES  DE SOBREVIVENCIA DE PESSOAS, NA SELVA, NO MAR OU EM SINISTROS DIVERSOS.  BOTAS - CADEADOS - CALCADOS ESPECIAIS - CAPACETES - CHAVES - CINTOS  -COLETES -  DEDAIS - GUARDA-CHUVAS - LONA - LUVAS - MANGUEIRA DE LONA -MASCARAS - PASSADEIRA ANTIDERRAPANTE - OCULOS - CABINA DE PAPELAO E OUTROS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.29.00.00.00.00','MATERIAL PARA  AUDIO, VIDEO E FOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO DE EMPREGO  DIRETO EM FILMAGEM E REVELACAO, AMPLIACOES E REPRODUCOES DE SONS E  IMAGENS. AETZE ESPECIAL P/ CHAPA DE PAPEL - ALBUNS P/ RETRATOS -  ALTO-FALANTES- ANTENAS - ARTIGOS PARA GRAVACAO EM ACETATO - FILMES VIRGENS -  FITASVIRGENS DE AUDIO E VIDEO - LAMPADAS ESPECIAIS - MATERIAL  P/ RADIOGRA-FIA, MICROFILMAGEM E CINEMATOGRAFIA - MOLDURAS - PAPEL P/ REVELACAO DEFOTOGRAFIAS - PEGADORES - REVELADORES - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.30.00.00.00.00','MATERIAL PARA COMUNICACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA COMUNICACOES, ASSIM COMO OS COMPONENTES, CIRCUITOS IMPRESSOS OU INTEGRADOS, PECAS OU ACESSORIOS DE REPOSICAO, CHIPS, E  PARTES DE EQUIPAMENTOS DE  COMUNIC.MATERIAIS PARA INSTALACOES: RADIOFONICAS, RADIOTELEGRAFICAS,  TELEGRAFICAS E OUTROS. - BATERIA PARA TELEFONE CELULAR- BLOQUEADOR TELEFONICO - CHAVE COMUTADORA PARA TELEFONE - FIO PARA TELEFONE - TOMADA PARA TELEFONE - MATERIAIS PARA INSTALACOES RADIOFONICAS - RADIOTELEGRAFICAS - TELEGRAFICAS - OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.31.00.00.00.00','SEMENTES, MUDAS DE PLANTAS E INSUMOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE QUALQUER TIPO DE SEMENTE DESTINADA AAO PLANTIO E MUDAS DE PLANTAS FRUTIFERAS OU  ORNAMENTAIS,  ASSIM  COMO TODOS OS INSUMOS UTILIZADOS PARA FERTILIZACAO. ADUBOS - ARGILA - PLANTAS ORNAMENTAIS - BORBULHAS - BULBOS -  ENXERTOS- FERTILIZANTES - MUDAS ENVASADAS OU COM  RAIZES  NUAS  -  SEMENTES  -TERRA - TUBERCULOS - XAXIM - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.32.00.00.00.00','SUPRIMENTO DE AVIACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS EMPREGADOS NA MANUTENCAO E REPARO DE AERONAVES. ACESSORIOS - PECAS  DE  REPOSICAO  DE  AERONAVES  -  SOBRESSALENTES  -E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.33.00.00.00.00','MATERIAL PARA PRODUCAO INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAS-PRIMAS UTILIZADAS NA TRANSFORMACAO, BENEFICIAMENTO E INDUSTRIALIZACAO DE UM PRODUTO FINAL.      BORRACHA - COURO - MATERIAS-PRIMAS EM GERAL - MINERIOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.34.00.00.00.00','SUPRIMENTOS PARA MAQ.E MOTORES NAVIOS E EMBARCACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA MANUTENCAO E REPARO DE MAQUINAS E MOTORES DE NAVIOS, INCLUSIVE DA  ESQUADRA, E DE EMBARCACOES EM GERAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.35.00.00.00.00','MATERIAL LABORATORIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS UTENSILIOS USADOS EM ANALISES LABORATORIAIS. ALMOFARIZES - BASTOES - BICO DE GAS - CALICES - CORANTES - FILTROS  DEPAPEL - FIXADORAS - FRASCOS - FUNIS -  GARRA  METALICA  -  LAMINAS  DEVIDRO P/ MICROSCOPIO - LAMPADAS ESPECIAIS - LUVAS DE BORRACHA - METAISE MATALOIDES P/ ANALISE - PINCAS - ROLHAS - VIDRARIA: BALAO VOLUMETRI-CO - BECKER - CONTA-GOTAS - ERLEMEYER - PIPETA - PROVETA -  TERMOMETRO- TUBO DE ENSAIO - MATERIAL DE LABORATORIO DIDATICO E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.36.00.00.00.00','MATERIAL HOSPITALAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO PARA AREA HOSPITALAR OU AMBULATORIAL. AGULHAS HIPODERMICAS - ALGODAO - CANULAS - CATETERES  -  COMPRESSA  DEGAZE - DRENOS - ESPARADRAPO - FIOS CIRURGICOS - LAMINAS P/  BISTURI  -LUVAS - SERINGAS - TERMOMETRO CLINICO - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.37.00.00.00.00','SUPRIMENTOS DE ARMAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA MANUTENCAO E REPARO DE ARMAMENTO. MATERIAL DE MANUTENCAO E ARMAMENTO - PECAS DE REPOSICAO - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.38.00.00.00.00','SUPRIMENTO DE PROTECAO AO VOO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PECAS DE REPOSICAO DE RADARES E SISTEMAS DE COMUNICACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.39.00.00.00.00','MATERIAL PARA MANUTENCAO DE VEICULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA APLICACAO E  MANUTENCAO DE VEICULOS RODOVIARIOS, VIATURAS BLINDADAS E TRATORES EM GERAL.  AGUA DESTILADA - AMORTECEDORES - BATERIAS - BORRACHAS - BUZINA - CABOSDE ACELERADOR - CABOS DE EMBREAGEM - CAMARA DE AR  -  CARBURADOR  COMPLETO - CIFA - COLAR DE EMBREAGEM - CONDENSADOR E PLATINADO - CORREIAS- DISCO DE EMBREAGEM - IGNICAO  -  JUNTA  HOMOCINETICA  -  LAMPADAS  E LANTERNAS P/ VEICULOS - LONAS E PASTILHAS  DE  FREIO  -  MANGUEIRAS  -MATERIAL UTILIZADO EM LANTERNAGEM E PINTURA -  MOTOR  DE  REPOSICAO  -PARA-BRISA - PARA-CHOQUE - PLATO - PNEUS  -  REPAROS  -  RETENTORES  -RETROVISORES - ROLAMENTOS  -  TAPETES  -  VALVULA  DA  MARCHA-LENTA  E TERMOSTATICA - VELAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.40.00.00.00.00','MATERIAL BIOLOGICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE AMOSTRAS E OUTROS ITENS DE MATERIAIS BIOLOGICOS UTILIZADOS EM ESTUDOS E PESQUISAS CIENTIFICAS EM SERES  VIVOS E INSEMINACAO ARTIFICIAL. MEIOS DE CULTURA - SEMEN - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.41.00.00.00.00','MATERIAL PARA UTILIZACAO EM GRAFICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS MATERIAIS DE CONSUMO DE USO GRAFICO, TAIS COMO:  CHAPAS DE OFF-SET - CLICHES - COLA - ESPIRAIS - FOTOLITOS - LOGOTIPOS - PAPEL - SOLVENTES - TINTA - TIPOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.42.00.00.00.00','FERRAMENTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS TIPOS DE FERRAMENTAS UTILIZADAS EM OFICINAS, CARPINTARIAS, JARDINS ETC.  ALICATE - BROCA - CAIXA P/ FERRAMENTAS - CANIVETE - CHAVES EM  GERAL -ENXADA - ESPATULAS - FERRO DE SOLDA - FOICE - LAMINA DE SERRA - LIMA -MACHADO - MARTELO - PA - PICARETA -  PONTEIRA  -  PRUMO  -  SERROTE  -TESOURA DE PODAR - TRENA - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.43.00.00.00.00','MATERIAL PARA REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA PROGRAMAS DE REABILITACAO PROFISSIONAL. BASTOES - BENGALAS - JOELHEIRAS - MEIAS  ELASTICAS  E  ASSEMELHADOS  -OCULOS - ORTESES - PESOS - PROTESES, INSTRUMENTOS DE TRABALHO E IMPLEMENTOS PROFISSIONAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.44.00.00.00.00','MATERIAL DE SINALIZACAO VISUAL E OUTROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA IDENTIFICACAO, SINALIZACAO VISUAL, ENDERECAMENTO E OUTROS.  PLACAS DE SINALIZACAO EM GERAL, TAIS COMO, PLACAS INDICATIVAS  PARA O SETORES E SECOES, PLACAS PARA VEICULOS, PLAQUETAS PARA TOMBAMENTO DE MATERIAL, PLACAS SINALIZADORAS DE TRANSITO, CONES SINALIZADORES DE TRANSITO, CRACHAS, BOTONS IDENTIFICADORES PARA SERVIDORES E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.45.00.00.00.00','MATERIAL TECNICO PARA SELECAO E TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS  TECNICOS UTILIZADOS EM PROCESSOS DE SELECAO E TREINAMENTO PELA PROPRIA  UNIDADE GESTORA OU PARA DISTRIBUICAO NAO GRATUITA, TAIS COMO:  APOSTILAS E SIMILARES - FOLHETOS DE  ORIENTACAO  -  LIVROS  -  MANUAIS EXPLICATIVOS PARA CANDIDATOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.46.00.00.00.00','MATERIAL BIBLIOGRAFICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL BIBLIOGRAFICO TAIS COMO:   JORNAIS - REVISTAS - PERIODICOS EM GERAL - ANUARIOS MEDICOS -  ANUARIO ESTATISCO - LIVROS EM GERAL E OUTROS, PODENDO ESTAR NA FORMA DE CD-ROM E OS MATERIAIS BIBLIOGRAFICOS PARA BIBLIOTECAS PUBLICAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.49.00.00.00.00','BILHETES DE PASSAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE BILHETES DE PASSAGEM PARA GUARDA EM ESTOQUE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.50.00.00.00.00','BANDEIRAS, FLAMULAS E INSIGNIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE BANDEIRAS, FLAMULAS E  INSIGNIAS, A SABER: BRASOES, ESCUDOS, ARMAS DA REPUBLICA, SELO NACIONAL E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.51.00.00.00.00','DISCOTECAS E FILMOTECAS NAO IMOBILIZAVEL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA AQUISICAO DE DISCOS, CD E COLECOES DE FITAS GRAVADAS COM MUSICAS E FITAS CINEMATOGRAFICAS  DE  CARATER EDUCATIVO, CIENTIFICO E INFORMATIVO, CUJA DEFASAGEM CONTABIL OCORRE EM UM PRAZO MAXIMO DE DOIS ANOS E QUE ATENDA OS PARAMETROS EXCLUDENTES DE MATERIAL PERMANENTE, CONFORME MANUAL DE CONTABILIDADE APLICADO AO SETOR PUBLICO - MACASP, VOLUME I - PROCEDIMENTOS CONTABEIS ORCAMENTARIOS, TAIS COMO:    - DISCO EDUCATIVO - FITA  DE  AUDIO  E  VIDEO  COM  AULA  DE   CARATER EDUCATIVO, MICROFILME E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.54.00.00.00.00','MATERIAL PARA MANUTENÇÃO E CONSERVAÇÃO DE ESTRADAS E VIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA REPAROS, RECUPERACOES E ADAPTACOES DE ESTRADAS, FERROVIAS E RODOVIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.99.00.00.00.00','OUTROS MATERIAIS DE CONSUMO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTROS MATERIAIS DE CONSUMO QUE NAO SE ENQUADREM NAS RUBRICAS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.0.00.00.00.00.00','DISTRIBUIÇÃO DE MATERIAL GRATUITO','Compreende as variações patrimoniais diminutivas provenientes da distribuição de material gratuito.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.00.00.00.00.00','DISTRIBUIÇÃO DE MATERIAL GRATUITO - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da distribuição de material gratuito. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.01.00.00.00.00','MERCADORIAS DOADAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.02.00.00.00.00','MATERIAL DESTINADO A ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL DE SAUDE (FARMACOLOGICO, ODONTOLOGICO, HOSPITALAR, MEDICAMENTOS, ORTESE E PROTESE), GENEROS ALIMENTICIOS, MATER.DE CAMA, MESA, COPA, COZINHA, LIMPEZA, HIGIENIZACAO, UNIFORMES, TECIDOS, AVIAMENTOS, MANUTENÇAO DE MOVEIS E IMOVEIS, FERRAMENTAS E OUTROS DISTINADOS A ASSISTENCIA SOCIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.03.00.00.00.00','MATERIAL EDUCACIONAL E CULTURAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL   EDUCACIONAL,(MATERIAL ESCOLAR, DIDATICO, TECNICO, MATERIAL P/AUDIO, VIDEO E  FOTO)E MATERIAL CULTURAL (MATERIAL RELIGIOSO E ESPORTIVO).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.04.00.00.00.00','MATERIAL PARA CERIMONIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OFERECIDOS A  TITULO DE HOMENAGEM.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.05.00.00.00.00','MATERIAL PARA REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OU BEM DESTINADO A SEGURADO INSCRITO EM PROGRAMA DE REABILITACAO PROFISSIONAL, INDISPENSAVEIS AO DESENVOLVIMENTO DO PROCESSO DE REABILITACAO, TAIS COMO: - PROTESES (APARELHOS DE SUBSTITUICAO) - ORTESES (APARELHOS DE CORRECAO OU COMPLEMENTACAO) - IMPLEMENTO PROFISSIONAL (INSTRUMENTOS TECNICOS E EQUIPAMENTOS DE PROTECAO INDIVIDUAL) - MAQUINAS ACESSORIOS E FERRAMENTAS INDISPENSAVEIS PARA O DESENVOLVIMENTO DE UMA FUNCAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.06.00.00.00.00','MATERIAL PARA DIVULGACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA PUBLICIDADE E DIVULGACAO DE PROGRAMAS DO GOVERNO, PARA CONSCIENTIZACAO SOCIAL EX: CAMISETAS, BONES, CHAVEIROS, CANETAS, BOTONS, ETC, COM LOGOMARCAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.99.00.00.00.00','OUTROS MATERIAIS DE DISTRIBUICAO GRATUITA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA DISTRIBUICAO GRATUITA, NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.0.0.00.00.00.00.00','SERVIÇOS','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços fornecidas à entidade governamental.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.0.00.00.00.00.00','DIÁRIAS','Compreende as variações patrimoniais diminutivas provenientes da utilização de diárias pagas aos servidores, empregados públicos e colaboradores eventuais, para fazer face a despesas com pousada, alimentação e locomoção urbana.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.00.00.00.00.00','DIÁRIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da utilização de diárias pagas aos servidores, empregados públicos e colaboradores eventuais, para fazer face a despesas com pousada, alimentação e locomoção urbana.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.01.00.00.00.00','DIARIAS  PESSOAL CIVIL','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE  PESSOAL  CIVIL,COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO  SERVIDOR  PUBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.01.01.00.00.00','DIARIAS - PESSOAL CIVIL - NO PAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE  PESSOAL  CIVIL  NO  PAIS,COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO  SERVIDOR  PUBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.01.02.00.00.00','DIARIAS - PESSOAL CIVIL - NO EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE  PESSOAL  CIVIL  NO  EXTERIOR,COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO  SERVIDOR  PUBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.01.99.00.00.00','DIARIAS - PESSOAL CIVIL - OUTRAS','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS DIARIAS - PESSOAL CIVIL NAO CLASSIFICAVEIS NAS RUBRICAS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.03.00.00.00.00','DIARIAS - COLABORADORES EVENTUAIS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS A PRESTADORES DE  SERVICOS DE CARATER EVENTUAL, SEM VINCULO COM A ADMINISTRACAO PUBLICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.03.01.00.00.00','DIARIAS - COLABORADORES EVENTUAIS - NO PAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS A PRESTADORES DE  SERVICOS PARA A ADMINISTRACAO PUBLICA, EXCETO A SERVIDORES PUBLICOS OU CELETISTAS. (NO PAIS)','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.03.02.00.00.00','DIARIAS - COLABORADORES EVENTUAIS - NO EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS A PRESTADORES DE  SERVICOS DE CARATER EVENTUAL, SEM VINCULO COM A ADMINISTRACAO PUBLICA (NOEXTERIOR).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.03.99.00.00.00','DIARIAS - COLABORADORES EVENTUAIS - OUTRAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTRAS DIARIAS  A COLABORADORES EVENTUAIS NAO CLASSIFICAVEIS NAS RUBRICAS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.04.00.00.00.00','DIARIAS A CONSELHEIROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS A MEMBROS DE ORGAOS DE DELIBERACAO COLETIVA (CONSELHOS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.0.00.00.00.00.00','SERVIÇOS TERCEIROS - PF','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa física fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.00.00.00.00.00','SERVIÇOS TERCEIROS - PF - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa física fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.01.00.00.00.00','CONSULTORIA E ASSESSORIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.02.00.00.00.00','PERICIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR PROFISSIONAIS TECNICOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.03.00.00.00.00','AUDITORIA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE AUDITORIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.04.00.00.00.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS  HONORARIOS ADVOCATICIOS A VENCEDORA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.05.00.00.00.00','SERVICOS MEDICOS E ODONTOLOGICOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS MEDICOS E ODONTOLOGICOS    PRESTADOS POR PESSOA FISICA, SEM VINCULO EMPREGATICIO.CONSULTAS - RAIO X - TRATAMENTO ODONTOLOGICO - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.06.00.00.00.00','SELECAO E TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS  DE  INSTRUCAO  E  ORIENTACAO PROFISSIONAL, RECRUTAMENTO E SELECAO DE  PESSOAL  E  TREINAMENTO,  POR PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.07.00.00.00.00','COMUNICACAO EM GERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE COMUNICACAO GERAL  PRESTADOS POR PESSOA FISICA, TAIS COMO:  CONFECCAO DE MATERIAL P/ COMUNICACAO VISUAL; GERACAO DE MATERIAS PARA DIVULGACAO POR MEIO DOS VEICULOS DE COMUNICACAO;   E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.08.00.00.00.00','LIMPEZA E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LIMPEZA E CONSERVACAO DE BENS IMOVEIS.DEDETIZACAO - FAXINA - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.09.00.00.00.00','SERVICOS DOMESTICOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS  DOMESTICOS  PRESTADOS  POR PESSOA FISICA SEM VINCULO EMPREGATICIO, TAIS COMO: COZINHA - LAVAGEM DE ROUPAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.11.00.00.00.00','MANUTENCAO E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS E IMOVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.12.00.00.00.00','CONDOMINIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS CONDOMINIAIS A CONTA DO LOCATORIO, QUANDO PREVISTAS NO CONTRATO DE LOCACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.13.00.00.00.00','COMISSOES E CORRETAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR:  CORRETORES - DESPACHANTES - LEILOEIROS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.14.00.00.00.00','DIREITOS AUTORAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE DIREITOS AUTORAIS DE PROPRIEDADE DE TERCEIROS SOBRE OBRAS  CIENTIFICAS, LITERARIAS, ETC, EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO.  REGISTRA O VALOR REFERENTE A UTILIZACAO DE SERVICOS DECORRENTES DE INCENTIVOS AOS AUTORES    A TITULO DE ROYALTIES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.15.00.00.00.00','SERVICOS TECNICOS PROFISSIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PROFISSIONAIS TECNICOS, NAS SEGUINTES AREAS: ADMINISTRACAO - ADVOCACIA - ARQUITETURA - CONTABILIDADE -  ECONOMIA  -ENGENHARIA - ESTATISTICA E OUTRAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.16.00.00.00.00','ESTAGIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR ESTUDANTES NA CONDICAO DE ESTAGIARIOS OU MONITORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.19.00.00.00.00','CONFERENCIAS, EXPOSICOES E ESPETACULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR CONFERENCISTAS, EXPOSITORES E ARTISTAS PELOS SERVICOS PRESTADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.20.00.00.00.00','ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE  ALUGUEL DE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, OS DISPENDIOS DE GARANTIA DOS ESTOQUES ARMAZENADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.21.00.00.00.00','LOCACOES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE  LOCACAO DE BENS MOVEIS E IMOVEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.21.01.00.00.00','LOCACAO DE IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE  ALUGUEL DE PREDIOS, SALAS E OUTROS IMOVEIS DE PROPRIEDADE DE PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.21.02.00.00.00','LOCACAO DE BENS MOVEIS E INTANGIVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE  ALUGUEIS  DE  MAQUINAS,EQUIPAMENTOS, TELEFONE FIXO E CELULAR E OUTROS BENS MOVEIS DE PROPRIEDADE DE PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.21.03.00.00.00','TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DOS TRIBUTOS A CONTA DO LOCATARIO OU DO CESSIONARIO, QUANDO PREVISTOS NO CONTRATO DE LOCACAO OU CESSAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.22.00.00.00.00','FORNECIMENTO DE ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE REFEICOES  PREPARADAS, INCLUSIVE LANCHES E SIMILARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.24.00.00.00.00','SERVICOS DE REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO, COMO OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE)  OS MEIOS INDICADOS PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO.  EX: CONTRATACAO DE PROFISSIONAL PARA MINISTRAR CURSO PROFISSIONALIZANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.25.00.00.00.00','SERVICOS DE ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS  DE  ASSISTENCIA SOCIAL PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A  SEUS  DEPENDENTES, TAIS COMO AJUDA DE CUSTO SUPLETIVA, GENEROS  ALIMENTICIOS, DOCUMENTACAO, TRANSPORTE E SEPULTAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.26.00.00.00.00','SERVIÇO DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE NATUREZA EVENTUAL PRESTADOS POR PESSOA FISICA, TAIS COMO: ASSISTENCIA TECNICA - CAPINA - JARDINAGEM - OPERADORES DE  MAQUINAS  E MOTORISTAS - RECEPCIONISTAS - SERVICOS AUXILIARES - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.27.00.00.00.00','SERVIÇO DE CONSERVAÇÃO E REBENEFICIAMENTO DE MERCADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO  DE SERVICOS DE NATUREZA EVENTUAL  PRESTADOS POR PESSOA FISICA NA CONSERVACAO E REBENEFICIAMENTO DE  MERCADORIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.28.00.00.00.00','CONFECCAO DE MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO  DE SERVICOS PRESTADOS POR PESSOA FISICA NA CONFECCAO DE:  BOLSAS - CAIXAS - MOCHILAS - SACOLAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.29.00.00.00.00','CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO  DE SERVICOS DE COSTUREIRAS, ALFAIATES E AFINS UTILIZADOS NA CONFECCAO DE UNIFORMES, BANDEIRAS, FLAMULAS,  BRASOES E ESTANDARTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.30.00.00.00.00','FRETES E TRANSPORTES DE ENCOMENDAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO  DE SERVICOS  PRESTADOS POR PESSOA FISICA EM: FRETES E CARRETOS - REMESSA DE ENCOMENDAS - TRANSPORTE DE  MERCADORIAS E PRODUTOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.31.00.00.00.00','JETONS E GRATIFICACOES A CONSELHEIROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA PARTICIPACAO EM ORGAOS DE DELIBERACOES COLETIVAS(CONSELHOS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.34.00.00.00.00','SERVICOS DE AUDIO, VIDEO E FOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO  DE SERVICOS DE FILMAGENS, GRAVACOES   E FOTOGRAFIAS, PRESTADOS POR PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.38.00.00.00.00','DESPESAS COM LOCOMOCAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIOS DE TRANSPORTES AEREOS,TERRESTRES, FLUVIAIS OU MARITIMAS,  LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM   DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.38.01.00.00.00','LOCACAO DE MEIOS DE TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA LOCACAO DE MEIOS DE TRANSPORTE, TAIS COMO: VEICULOS, AERONAVES, EMBARCACOES E ASSEMELHADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.38.03.00.00.00','LOCOMOCAO URBANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIO DE TRANSPORTE URBANO, COMO: ONIBUS, TAXI E OUTROS VEICULOS DE TRANSPORTES URBANOS,PARA ATENDER NECESSIDADE DO SERVICO,  COMPREENDENDO,  TAMBEM, DESLOCAMENTOS PARA REALIZACAO DE PESQUISAS E REEMBOLSO COM TRANSPORTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.38.99.00.00.00','OUTRAS DESPESAS COM LOCOMOCAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIOS DE TRANSPORTES NAO ESPECIFICADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.39.00.00.00.00','SERVICOS GRAFICOS E EDITORIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SERVICOS DE ARTES GRAFICAS PRESTADOS POR PESSOA FISICA, BEM COMO COM SERVICOS EDITORIAIS DIVERSOS. CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS   E REVISTAS  - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVICOS DE  IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVICOS EDITORIAIS  DIVERSOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.40.00.00.00.00','BOLSA DE INICIACAO AO TRABALHO','REGISTRA O VALOR DAS VPAS COM REMUNERACAO A CANDIDATOS PARTICIPANTES DE CURSO DE FORMACAO PARA O EXERCICIO DE CARGO DECORRENTE DE  CONCURSO PUBLICO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.99.00.00.00.00','OUTROS SERVICOS PRESTADOS POR PESSOA FISICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTROS SERVICOS PRESTADOS POR PESSOA FISICA, NAO CONTEMPLADOS EM ITENS ESPECIFICOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.0.00.00.00.00.00','SERVIÇOS TERCEIROS - PJ','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa jurídica fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.00.00.00.00.00','SERVIÇOS TERCEIROS - PJ - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa jurídica fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.01.00.00.00.00','CONSULTORIA E ASSESSORIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.02.00.00.00.00','PERICIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.03.00.00.00.00','AUDITORIA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AUDITORIA EXTERNA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.04.00.00.00.00','COMUNICACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE  COMUNICACAO,  PRESTADOS POR PESSOA JURIDICA.  EX: TELECOMUNICAÇÕES; CORRESPONDÊNCIAS; COMUNICAÇÃO DE DADOS E OUTROS SERVIÇOS DE COMUNICAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.05.00.00.00.00','PUBLICIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE. PUBLICIDADE LEGAL; PUBLICIDADE DE UTILIZADE PUBLICA; PUBLICIDADE INSTITUCIONAL, BEM COMO OUTROS SERVICOS DE PUBLICIDADE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.06.00.00.00.00','MANUTENCAO E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS. TAIS COMO: MANUTENÇÃO E CONSERVAÇÃO DE ESTRADAS E VIAS; BENS IMOVEIS; VEICULOS; EQUIPAMENTOS DE PROCESSAMENTO DE DADOS; MAQUINAS E EQUIPAMENTOS; SOFTWARE; BENS MOVEIS, BEM COMO OUTROS SERVICOS DE MANUTENCAO E CONSERVACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.07.00.00.00.00','SERVICOS DE APOIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS  PRESTADOS  POR  PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS   E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE   O   CONTRATO  NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL  A SER UTILIZADO. EX: LIMPEZA E CONSERVACAO; VIGILANCIA OSTENSIVA/ MONITORADA; SERVICOS DE SOCORRO E SALVAMENTO; SERVICOS DOMESTICOS, BEM COMO OUTROS SERVICOS DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.08.00.00.00.00','SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.09.00.00.00.00','SERVICOS DE ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE  REFEICOES  PREPARADAS, INCLUSIVE LANCHES E SIMILARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.10.00.00.00.00','LOCACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE LOCACAO DE BENS MOVEIS, IMOVEIS OU INTAGIVEIS. EX: IMÓVEIS; SOFTWARE; MAQUINAS E EQUIPAMENTOS; BENS MOVEIS DE OUTRAS NATUREZAS E INTANGIVEIS; EQUIPAMENTOS DE PROCESSAMENTO DE DADOS; TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIO','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.11.00.00.00.00','SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PRESTADOS POR EMPRESAS  ESPECIALIZADAS NA AREA DE INFORMATICA; ATUALIZACAO E ADAPTACAO DE PROGRAMAS DE PROCESSAMENTO DE DADOS; SUPORTE TECNICO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS,ANALISE P/ACRESCENTAR NOVAS FUNCOES, HOSPEDAGEM DE SISTEMAS E OUTROS. EX: DESENVOLVIMENTO DE SOFTWARE; SUPORTE DE INFRAESTRUTURA DE T.I.; SUPORTE A USUARIOS DE T.I.; HOSPEDAGEM DE SISTEMAS; SERVICOS TECNICOS PROFISSIONAIS DE T.I.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.12.00.00.00.00','SERVICOS DE TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE SERVIDORES, TRABALHADORES DE UMA ENTIDADE OU DE MERCADORIAS E PRODUTOS DIVERSOS. EX: VALE- TRANSPORTE; TRANSPORTE DE SERVIDORES; FRETE E TRANSPORTE DE ENCOMENDAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.13.00.00.00.00','ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS  DE  ALUGUELDE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, AS VARIACOES PROVENIENTESS DE GARANTIA DOS ESTOQUES ARMAZENADOS E A UTILIZACAO DE SERVICO ESPECIALIZADO NA SOLUCAO DE GESTAO DE ESTOQUE, INCLUINDO GESTAO DE MATERIAIS E TRANSPORTE DE MATERIAIS E EQUIPAMENTOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.14.00.00.00.00','ASSINATURAS DE PERIODICOS E ANUIDADES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ASSINATURAS DE TV  (TVA CABO), JORNAIS, INCLUSIVE DIARIO OFICIAL, REVISTAS, RECORTES DE  PUBLICACOES, SOFTWARE, PODENDO ESTAR NA FORMA DE DISQUETE, CD-ROM, BOLE-INS E  OUTROS QUE NAO SE DESTINEM A COLECOES OU BIBLIOTECAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.17.00.00.00.00','COMISSOES E CORRETAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE VALOR REFERENTE A COMISSOES E CORRETAGENS  DECORRENTES DE SERVICOS PRESTADOS POR EMPRESAS DE  INTERMEDIACAO  E  REPRESENTACAO COMERCIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.18.00.00.00.00','CONDOMINIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DAS TAXAS CONDOMINIAIS A CONTA DO  PROPRIETARIO, OU DO LOCATARIO, CONFORME PREVISTO NO CONTRATO DE LOCACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.19.00.00.00.00','CONFECCAO DE MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS  DE CONFECCAO  DE MATERIAIS   DESTINADOS  A  PRESERVACAO,  ACOMODACAO  OU  EMBALAGEM  DE PRODUTOS DIVERSOS, TAIS COMO:- BOLSAS - CAIXAS - MOCHILAS - SACOLAS E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.20.00.00.00.00','CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE:- BANDEIRAS - BRASOES - ESTANDARTES - FLAMULAS - UNIFORMES (INCLUSIVEAS DESPESAS RELACIONADAS COM AUXILIO FARDAMENTO DESCRITOS NA LEI  NUM.8237/91) E OUTROS.  SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.21.00.00.00.00','DIREITOS AUTORAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIREITOS AUTORAIS SOBRE OBRAS  CIENTIFICAS, LITERARIAS OU EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.22.00.00.00.00','EXPOSICOES, CONGRESSOS, CONFERENCIAS E OUTROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA INSTALACAO  E MANUTENCAO DE: CONFERENCIAS - REUNIOES TECNICAS - CONGRESSOS - EXPOSICOES - FEIRAS - FESTEJOS POPULARES - FESTIVAIS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.23.00.00.00.00','FESTIVIDADES E HOMENAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA  ORGANIZACAO   DE EVENTOS, TAIS COMO: COQUETEIS - FESTAS DE CONGRACAMENTO - RECEPCOES - E OUTRAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.24.00.00.00.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS HONORARIOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS  HONORARIOS ADVOCATICIOS A VENCEDORA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.25.00.00.00.00','HOSPEDAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS  DE  HOSPEDAGENS  E ALIMENTACAO DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS  OFICIAIS PAGOS DIRETAMENTE A  ESTABELECIMENTOS  HOTELEIROS (QUANDO  NAO  HOUVER   PAGAMENTO DE DIARIAS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.26.00.00.00.00','PATROCINIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PATROCINIOS  A  ATIVIDADES  OU  EVENTOS, DE NATUREZA  CULTURAL,  ESPORTIVA,  EDUCACIONAL,  AMBIENTAL,  CIENTIFICA, COMUNITARIA,  PROMOCIONAL  ETC.  PARA  INFLUENCIAR  FAVORAVELMENTE   O PUBLICO E/OU ATINGIR OUTROS OBJETIVOS RELACIONADOS COM A  PROMOCAO  DE ATOS, OBRAS, PLANOS, ACOES, BENS OU SERVICOS. NAO INCLUI O  PATROCINIO DE MIDIA, ASSIM CONSIDERADOS AQUELES EM QUE O PROPONENTE E UM VEICULO DE COMUNICACAO OU UM GESTOR DE MEIOS OU INSTALACOES QUE FUNCIONEM COMO VEICULO  DE  MIDIA  ALTERNATIVA  E  AQUELES  EM  QUE  UM  VEICULO   DE COMUNICACAO E O UNICO OU O PRINCIPAL REALIZADOR DA ACAO  PATROCINADA, AINDA QUE O PROPONENTE DO PROJETO E PROVEDOR DE CONTEUDO PARA  A  ACAO PATROCINADA NAO SE ENQUADRE NA DEFINICAO DE VEICULO DE COMUNICACAO  OU MEIO DE MIDIA ALTERNATIVA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.27.00.00.00.00','PRODUCOES JORNALISTICAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS  DE EDICAO DE JORNAIS, REVISTAS, NOTICIARIOS E MATERIAIS JORNALISTICOS PARA VIDEOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.29.00.00.00.00','SEGUROS EM GERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE  PREMIOS  PAGOS  POR  SEGUROS  DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS  OU BENS DE TERCEIROS,  PREMIOS  DE  SEGUROS  DE  BENS  DO  ESTADO  OU  DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.30.00.00.00.00','SELECAO E TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTACAO PROFISSIONAL, RECRUTAMENTO E  SELECAO  DE  PESSOAL (CONCURSO PUBLICO) E TREINAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.31.00.00.00.00','SERVIÇO MEDICO-HOSPITALAR,ODONTOLÓGICO E LABORATORIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS MEDICO-HOSPITALARES,  ODONTOLOGICOS E LABORATORIAIS, PRESTADOS POR PESSOAS JURIDICAS SEM VINCULO EMPREGATICIO, TAIS COMO:   ANALISES CLINICAS - CIRURGIAS - CONSULTAS - ECOGRAFIAS - ENDOSCOPIAS -ENFERMAGEM  -  ESTERILIZACAO  -  EXAMES  DE  LABORATORIO  -  RAIO X  -TOMOGRAFIAS - TRATAMENTO ODONTOLOGICO - ULTRASSONOGRAFIAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.32.00.00.00.00','SERVICOS BANCARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE COMISSOES,  TARIFAS  E  REMUNERACOES DECORRENTES DE SERVICOS PRESTADOS POR  BANCOS  E  OUTRAS  INSTITUICOES FINANCEIRAS, BEM COMO DESPESAS COM AGUARDA/CUSTODIA DE VALORES (COFRES DE ALUGUEL).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.33.00.00.00.00','SERVICOS DE ANALISES E PESQUISA CIENTIFICAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ANALISES FISICO-QUIMICAS E PESQUISAS CIENTIFICAS, NAO RELACIONADAS COM APOIO AO ENSINO - ANALISES MINERAIS - ANALISES DE SOLO - ANALISES QUIMICAS - COLETA DE DADOS EM EXPERIMENTOS - TRATAMENTO E DESTINACAO DE RESIDUOS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.34.00.00.00.00','SERVICOS DE APOIO DO ENSINO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE PROPORCIONAR O  DESENVOLVIMENTO  E  O  APERFEICOAMENTO  DO ENSINO,  EM  TODOS  OS  NIVEIS,  INCLUSIVE  PESQUISAS  EXPERIENCIAS  E ASSEMELHADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.35.00.00.00.00','SERVICOS DE ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS  DE  ASSISTENCIA SOCIAL   PRESTADA  A   SERVIDORES,  SEGURADOS  CARENTES,  ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES, TAIS COMO:- AJUDA DE CUSTO SUPLETIVA - GENEROS  ALIMENTICIOS  -  DOCUMENTACAO - TRANSPORTE E SEPULTAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.36.00.00.00.00','SERVICOS DE AUDIO VIDEO E FOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS  DE  FILMAGENS,  GRAVACOES, REVELACOES, AMPLIACOES E REPRODUCOES DE SONS E IMAGENS - CONFECCAO DE ALBUNS - CONFECCAO DE CRACHAS FUNCIONAIS   POR   FIRMAS ESPECIALIZADAS - EMOLDURAMENTO DE FOTOGRAFIAS - IMAGENS  DE  SATELITES - REVELACAO DE FILMES - MICROFILMAGEM E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.40.00.00.00.00','SERVICOS DE CONTROLE AMBIENTAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONTROLE AMBIENTAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.41.00.00.00.00','SERVICOS DE COPIAS E REPRODUCAO DE DOCUMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COPIAS XEROGRAFICAS, INCLUSIVE A LOCACAO E A MANUTENCAO DE EQUIPAMENTOS REPROGRAFICOS, COPIASE REPRODUCOES DE DOCUMENTOS E PUBLICACOES EM GERAL, INCLUSIVE POR MEIO MAGNETICO E DIGITALIZACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.42.00.00.00.00','SERVICOS DE CRECHE E ASSISTENCIA PRE ESCOLAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS  PRESTADOS  POR  ENTIDADES DE ASSISTENCIA SOCIAL PARA ATENDER OS DEPENDENTES DE SERVIDORES DO ORGAO, HABILITADOS A USUFRUIREM DESSE BENEFICIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.45.00.00.00.00','SERVICOS DE REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE  SERVICOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA JURIDICA, COM O OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE), OS MEIOS INDICADOS  PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL,  DE  MODO  QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO.EX: CONTRATACAO DE EMPRESA PARA MINISTRAR CURSO PROFISSIONALIZANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.47.00.00.00.00','SERVICOS FUNERARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REMOCOES,  SEPULTAMENTOS E TRANSLADACOES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.48.00.00.00.00','SERVICOS GRAFICOS E EDITORIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ARTES GRAFICAS PRESTADOS POR PESSOA JURIDICA, BEM COMO COM SERVICOS EDITORIAIS DIVERSOS.- CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS   E REVISTAS  - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVICOS DE  IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVICOS EDITORIAIS DIVERSOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.49.00.00.00.00','SERVICOS JUDICIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE  CUSTAS  PROCESSUAIS DECORRENTES DE ACOES JUDICIAIS, DILIGENCIAS (INCLUSIVE CONDUCAO) SALARIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E OFICIAIS DE JUSTICA E SERVICOS DE CARTORIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.51.00.00.00.00','SERVICOS TECNICOS PROFISSIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NAS SEGUINTES AREAS:   ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA - ESTATISTICA E OUTRAS. EXCETO OS SERVICOS DE CONSULTORIA QUE DEVEM SER CLASSIFICADOS EM CONTA ESPECIFICA .','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.52.00.00.00.00','TAXA DE ADMINISTRACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ORGANIZACAO E ADMINISTRACAO PRESTADOS POR PESSOA JURIDICA, TAIS COMO: TAXA DE ADMINISTRACAO PAGA DECORRENTE DOS SERVICOS DE SELECAO E RECRUTAMENTO DE ESTUDANTES, TENDO COMO OBJETIVO  O  INGRESSO AO MERCADO DE TRABALHO E PROGRAMAS DE ESTAGIO; E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.54.00.00.00.00','LOCACAO DE MAO-DE-OBRA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR  PESSOAS JURIDICAS PARA ORGAOS PUBLICOS, TAIS COMO LIMPEZA E HIGIENE,  VIGILANCIA OSTENSIVA E OUTROS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. EX: LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL; DE LIMPEZA E CONSERVACAO; DE VIGILANCIA OSTENSIVA ; E MANUTENCAO E CONSERVACAO DE BENS IMOVEIS; DE  SERVICOS DE COPA E COZINHA;  DE  MANUTENCAO E CONSERVACAO DE BENS MOVEIS; DE MANUTENCAO DE SOFTWARE; DE SUPORTE DE INFRAESTRUTURA DE T.I.; DE SUPORTE A USUARIOS DE T.I. E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.55.00.00.00.00','ARRENDAMENTO MERCANTIL OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL OPERACIONAL, TAIS COMO: ARRENDAMENTO MERCANTIL OPERACIONAL  DE MAQUINAS E APARELHOS;  DE VEICULOS RODOVIARIOS; DE OUTROS BENS MOVEIS;  DE BENS IMOVEIS E OUTROS ARRENDAMENTOS MERCANTIS OPERACIONAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.56.00.00.00.00','PASSAGENS E DESPESAS COM LOCOMOCAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS,TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE, SEGUROS, FRETAMENTO, PEDAGIOS, LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM   DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO. TAIS COMO: PASSAGENS PARA O PAIS; PASSAGENS PARA O EXTERIOR; LOCACAO DE MEIOS DE TRANSPORTE; LOCOMOCAO URBANA; PEDAGIOS; TRANSPORTE DE SERVIDORES ALEM DE OUTRAS DESPESAS COM LOCOMOCAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.57.00.00.00.00','ASSOCIACOES, FEDERACOES E CONFEDERACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ASSOCIACOES, FEDERACOES E CONFEDERACOES EFETUADAS PELO ENTE. EX: ASCAMSUL; AZONASUL; FAMURS; UVERGS; ASCAM; ARTAFAM; ACOPERGS; AGIP; ETC.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.99.00.00.00.00','OUTROS SERVICOS PRESTADOS POR PESSOA JURIDICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA, QUE NAO ESTEJA ESPECIFICADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.4.0.00.00.00.00.00','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA - ART. 18 § 1, LC 101/00','Compreende a apropriação das despesas relativas à mão de obra, constantes dos contratos de terceirização, classificáveis no grupo de despesa com pessoal e encargos em obediência ao disposto no artigo 18, § 1º, da lei complementar nº 101, de 2000.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.4.1.00.00.00.00.00','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA - ART. 18 § 1, LC 101/00 - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas relativas à mão de obra, constantes dos contratos de terceirização, classificáveis no grupo de despesa com pessoal e encargos em obediência ao disposto no artigo 18, § 1º, da lei complementar nº 101, de 2000. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.0.0.00.00.00.00.00','DEPRECIAÇÃO, AMORTIZAÇÃO E EXAUSTÃO','Compreende o decréscimo no beneficio de um bem durante o período contábil decorrente de depreciação, amortização e exaustão.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.1.0.00.00.00.00.00','DEPRECIAÇÃO','Compreende a redução do valor dos bens tangíveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.1.1.00.00.00.00.00','DEPRECIAÇÃO - CONSOLIDAÇÃO','Compreende a redução do valor dos bens tangíveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.1.1.01.00.00.00.00','DEPRECIACAO DE IMOBILIZADO','REGISTRA A REDUCAO DO VALOR DOS BENS TANGIVEIS ,DO ATIVO IMOBILIZADO, PELO DESGASTE OU PERDA DE UTILIDADE POR USO, ACAO DA NATUREZA OU OBSOLESCENCIA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.2.0.00.00.00.00.00','AMORTIZAÇÃO','Compreende a redução do valor aplicado na aquisição de direitos de propriedade e quaisquer outros, inclusive ativos intangíveis, com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.2.1.00.00.00.00.00','AMORTIZAÇÃO - CONSOLIDAÇÃO','Compreende a redução do valor aplicado na aquisição de direitos de propriedade e quaisquer outros, inclusive ativos intangíveis, com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.2.1.01.00.00.00.00','AMORTIZACAO DE IMOBILIZADO','REGISTRA A REDUCAO DO VALOR APLICADO NA AQUISICAO DE DIREITOS, DO ATIVO IMOBILIZADO, COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.2.1.02.00.00.00.00','AMORTIZACAO DE INTANGIVEL','REGISTRA A REDUCAO DO VALOR APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE E QUAISQUER OUTROS, INCLUSIVE ATIVOS INTANGIVEIS, COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.3.0.00.00.00.00.00','EXAUSTÃO','Compreende a redução do valor decorrente da exploração dos recursos minerais, florestais e outros recursos naturais esgotáveis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.3.1.00.00.00.00.00','EXAUSTÃO - CONSOLIDAÇÃO','Compreende a redução do valor decorrente da exploração dos recursos minerais, florestais e outros recursos naturais esgotáveis. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.3.1.01.00.00.00.00','EXAUSTAO DE IMOBILIZADO','REGISTRA A REDUCAO DO VALOR, DECORRENTE DA EXPLORACAO, DOS RECURSOS MINERAIS, FLORESTAIS E OUTROS RECURSOS NATURAIS ESGOTAVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.0.0.00.00.00.00.00','CUSTO DE MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende a variação patrimonial diminutiva relativa a materiais, serviços e consumo de capital fixo utilizados na produção de bens ou serviços, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.1.0.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende as variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo apropriadas as mercadorias, sendo registrado apenas no momento da venda destas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.1.1.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo apropriadas as mercadorias, sendo registrado apenas no momento da venda destas.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.2.0.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS - MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de bens, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.2.1.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS - MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de bens, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.3.0.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS - MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de serviços, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.3.1.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS - MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de serviços, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.0.0.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.0.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.0.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.1.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.1.01.00.00.00.00','JUROS DA DIVIDA CONTRATADA COM INSTITUIÇÕES FINANCEIRAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM INSTITUICOES FINANCEIRAS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.1.03.00.00.00.00','ENCARGOS DA DIVIDA CONTRATUAL COM INSTITUIÇÕES FINANCEIRAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM INSTITUICOES FINANCEIRAS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.1.99.00.00.00.00','JUROS E ENCARGOS DE OUTRAS  DIVIDAS CONTRATUAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.3.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.3.05.00.00.00.00','JUROS DA DIVIDA CONTRATADA COM GOVERNOS','REGISTRA  A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS JUROS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.3.06.00.00.00.00','ENCARGOS DA DIVIDA CONTRATADA COM GOVERNOS','REGISTRA  A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS ENCARGIOS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.4.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.4.05.00.00.00.00','JUROS DA DIVIDA CONTRATADA COM GOVERNOS','REGISTRA  A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS JUROS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.4.06.00.00.00.00','ENCARGOS DA DIVIDA CONTRATADA COM GOVERNOS','REGISTRA  A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS ENCARGIOS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.5.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.5.05.00.00.00.00','JUROS DA DIVIDA CONTRATADA COM GOVERNOS','REGISTRA  A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS JUROS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.5.06.00.00.00.00','ENCARGOS DA DIVIDA CONTRATADA COM GOVERNOS','REGISTRA  A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS ENCARGIOS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.2.0.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL EXTERNA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública externa derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.2.1.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública externa derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.2.1.01.00.00.00.00','JUROS DA DIVIDA CONTRATADA NO EXTERIOR','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA CONTRATADA NO EXTERIOR  COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVIÇOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.2.1.02.00.00.00.00','ENCARGOS DA DIVIDA CONTRATADA NO EXTERIOR','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA CONTRATADA NO EXTERIOR  COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVIÇOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.3.0.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA MOBILIARIA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública representada por títulos emitidos pelo governo. São considerados encargos da divida mobiliaria: comissões, corretagens, seguros, deságio e outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.3.1.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA MOBILIARIA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública representada por títulos emitidos pelo governo. São considerados encargos da divida mobiliaria: comissões, corretagens, seguros, deságio e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.3.1.01.00.00.00.00','JUROS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS DA DIVIDA PUBLICA MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.3.1.02.00.00.00.00','DESAGIOS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE DESAGIOS DA DIVIDA PUBLICA MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.3.1.03.00.00.00.00','ENCARGOS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS DA DIVIDA PUBLICA MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.4.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA','Compreende a variação patrimonial diminutiva com juros e encargos sobre empréstimos contraídos por antecipação de receita orçamentária para atender insuficiência de caixa durante o exercício financeiro.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.4.1.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos sobre empréstimos contraídos por antecipação de receita orçamentária para atender insuficiência de caixa durante o exercício financeiro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.4.1.01.00.00.00.00','JUROS S/ ADIANTAMENTOS BANCARIOS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS INCIDENTES SOBRE ANTECIPAÇÕES DE CRÉDITOS CONTRATADAS COM BANCOS E OUTROS AGENTES FINANCEIROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.0.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.1.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.3.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - UNIÃO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.4.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - ESTADO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.5.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - MUNICÍPIO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.9.0.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos externos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.9.1.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos externos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.0.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA','Compreende o montante de variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos contratuais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.1.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.1.02.00.00.00.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.3.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.3.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.3.02.00.00.00.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.4.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.4.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.4.02.00.00.00.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.5.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.5.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.5.02.00.00.00.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.2.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos externos contraídos com pessoas jurídicas de direito público ou privado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.2.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos externos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.2.1.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.2.1.02.00.00.00.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.3.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços e aquisição de bens.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.3.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços e aquisição de bens. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.3.1.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVIÇOS E AQUISICAO DE BENS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.3.1.02.00.00.00.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DE MORA REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVIÇOS E AQUISICAO DE BENS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.4.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos de obrigações tributárias devidas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.4.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos de obrigações tributárias devidas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.4.1.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DAS OBRIGAÇÕES TRIBUTÁRIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.4.1.02.00.00.00.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DE MORA REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DAS OBRIGAÇÕES TRIBUTÁRIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.9.0.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos em situações não compreendidas nas classificações anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.9.1.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos em situações não compreendidas nas classificações anteriores.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.0.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.1.01.00.00.00.00','VARIACOES MONETARIAS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.1.02.00.00.00.00','VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.3.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.3.01.00.00.00.00','VARIACOES MONETARIAS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.3.02.00.00.00.00','VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.4.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.4.01.00.00.00.00','VARIACOES MONETARIAS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.4.02.00.00.00.00','VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.5.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.5.01.00.00.00.00','VARIACOES MONETARIAS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.5.02.00.00.00.00','VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.2.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.2.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.2.1.01.00.00.00.00','VARIAÇÕES MONETÁRIAS DA DIVIDA CONTRATUAL EXTERNA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.2.1.02.00.00.00.00','VARIAÇÕES CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.3.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA INTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.3.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.3.1.01.00.00.00.00','VARIAÇÕES MONETARIAS DE DIVIDA MOBILIARIA INTERNA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA MOBILIARIA. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.3.1.02.00.00.00.00','VARIAÇÕES CAMBIAIS DE DIVIDA MOBILIARIA INTERNA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.4.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.4.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.0.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.1.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.1.01.00.00.00.00','OUTRAS VARIAÇÕES MONETARIAS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.1.02.00.00.00.00','OUTRAS VARIAÇÕES CAMBIAIS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.3.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.3.01.00.00.00.00','OUTRAS VARIAÇÕES MONETARIAS  - INTER OFSS - UNIÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.3.02.00.00.00.00','OUTRAS VARIAÇÕES CAMBIAIS - INTER OFSS - UNIÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.4.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.4.01.00.00.00.00','OUTRAS VARIAÇÕES MONETARIAS TER OFSS  - INTER OFSS - ESTADO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.4.02.00.00.00.00','OUTRAS VARIAÇÕES CAMBIAIS  - INTER OFSS - ESTADO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.5.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.5.01.00.00.00.00','OUTRAS VARIAÇÕES MONETARIAS TER OFSS - INTER OFSS - MUNICÍPIO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.5.02.00.00.00.00','OUTRAS VARIAÇÕES CAMBIAIS - INTER OFSS - MUNICÍPIO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.4.0.0.00.00.00.00.00','DESCONTOS FINANCEIROS CONCEDIDOS','Compreende o valor da variação patrimonial diminutiva com descontos financeiros concedidos a clientes por pagamentos antecipados de duplicatas e outros títulos. Não se confundem com descontos nos preços de venda concedidos incondicionalmente, ou abatimentos de preços, que são deduções da receita','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.4.0.1.00.00.00.00.00','DESCONTOS FINANCEIROS CONCEDIDOS - CONSOLIDAÇÃO','Compreende o valor da variação patrimonial diminutiva com descontos financeiros concedidos a clientes por pagamentos antecipados de duplicatas e outros títulos. Não se confundem com descontos nos preços de venda concedidos incondicionalmente, ou abatimentos de preços, que são deduções da receita.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - FINANCEIRAS','Compreende outras variações patrimoniais diminutivas financeiras, não abrangidas nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.1.0.00.00.00.00.00','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS','Compreende os juros e encargos resultantes de pagamento de precatórios e de sentenças judiciais transitadas em julgado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.1.1.00.00.00.00.00','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS - CONSOLIDAÇÃO','Compreende os juros e encargos resultantes de pagamento de precatórios e de sentenças judiciais transitadas em julgado.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.1.1.01.00.00.00.00','JUROS EM SENTENCAS JUDICIAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DOS JUROS  RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.1.1.02.00.00.00.00','ENCARGOS EM SENTECAS JUDICIAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DOS  ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.2.0.00.00.00.00.00','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES','Compreende as variações patrimoniais diminutivas com indenizações e restituições referentes a juros e encargos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.2.1.00.00.00.00.00','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com indenizações e restituições referentes a juros e encargos.     Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.2.1.01.00.00.00.00','JUROS E ENCARGOS EM INDENIZACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES REFERENTES A JUROS E ENCARGOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.2.1.02.00.00.00.00','JUROS E ENCARGOS EM  RESTITUICOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUICOES REFERENTES A JUROS E ENCARGOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.9.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','Compreende as variações patrimoniais diminutivas provenientes de operações financeiras não compreendidas nas contas anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.9.1.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de operações financeiras não compreendidas nas contas anteriores.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.0.0.0.00.00.00.00.00','TRANSFERÊNCIAS E DELEGAÇÕES CONCEDIDAS','Compreende o somatório das variações patrimoniais diminutivas com transferências inter governamentais, transferências intragovernamentais, transferências a instituições multigovernamentais, transferências a instituições privadas com ou sem fins lucrativos, transferências a convênios, transferências ao exterior e execuções orçamentárias delegadas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.0.0.00.00.00.00.00','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes das transferências financeiras relativas à execução orçamentária, e de bens e valores, referentes às transações intragovernamentais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.0.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS PARA A EXECUCAO ORCAMENTARIA','Compreende o valor das transferências financeiras concedidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Inclui também o valor repassado para a cobertura do déficit financeiro do RPPS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS PARA A   EXECUÇÃO ORÇAMENTARIA - INTRA OFSS','Compreende o valor das transferências financeiras concedidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Inclui também o valor repassado para a cobertura do déficit financeiro do RPPS. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.00.00.00.00','TRANSFERENCIAS CONCEDIDAS - COM EXECUCAO ORCAMENTARIA','COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS CONCEDIDAS E CORRESPONDENCIA DE CREDITOS EM VIRTUDE DA EXECUCAO ORCAMENTARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.01.00.00.00','COTA CONCEDIDA','REGISTRA VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO  VALOR DA CONCESSAO DE COTA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA PARA ORGAO SETORIAL CORRESPONDENTE AO ORCAMENTO ANUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.02.00.00.00','REPASSE CONCEDIDO','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR DOS RECURSOS CONCEDIDOS A TITULO DE  TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DIFERENTES DA ADMINISTRACAO DIRETA OU INDIRETA, CORRESPONDENTES AO ORCAMENTO ANUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.02.01.00.00','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR DO REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.02.01.01.00','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE - RECURSO LIVRE','REGISTRA O VALOR DO REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE COM RECURSO LIVRE','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.02.01.02.00','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE - RECURSO DO MDE','REGISTRA O VALOR DO REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE COM RECURSO DA MDE','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.02.01.03.00','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE - RECURSO DAS ASPS','REGISTRA O VALOR DO REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE COM RECURSO DAS ASPS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.02.01.04.00','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE - DEMAIS RECURSOS VINCULADOS','REGISTRA O VALOR DO REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE COM OS DEMAIS RECURSOS VINCULADOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.03.00.00.00','SUB-REPASSE CONCEDIDO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR TOTAL DOS SUB-REPASSES CONCEDIDOS POR  TRANSFERENCIAS FINANCEIRAS ENTRE UG DE UM MESMO ORGAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.04.00.00.00','VALORES DIFERIDOS - BAIXA - COTA DIFERIDA','REGISTRA O VALOR DA COTA DIFERIDA NO PROCESSO DE INSCRICAO E BAIXA DOS RECURSOS DIFERIDOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.05.00.00.00','VALORES DIFERIDOS - BAIXA - REPASSE DIFERIDO','REGISTRA O VALOR DOS RECURSOS DE REPASSE DIFERIDO DECORRENTES DO  PROCESSO DE INSCRICAO/BAIXA DE RECURSOS DIFERIDOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.06.00.00.00','VALORES DIFERIDOS - BAIXA - SUB-REPASSE DIFERIDO','REGISTRA A APROPRIACAO DO VALOR REFERENTE AO SUB-REPASSE CONCEDIDO ENTRE AS UGS DA ADMINISTRACAO DIRETA OU INDIRETA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.07.00.00.00','VALORES DIFERIDOS - INSCRICAO - COTA DIFERIDA - INSCRICAO','REGISTRA O VALOR DA COTA DIFERIDA NO PROCESSO DE INSCRICAO  DOS RECURSOS DIFERIDOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.08.00.00.00','VALORES DIFERIDOS - INSCRICAO - REPASSE DIFERIDO - INSCRICAO','REGISTRA O VALOR DOS RECURSOS DE REPASSE DIFERIDO DECORRENTES DO  PROCESSO DE INSCRICAO DE RECURSOS DIFERIDOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.09.00.00.00','VALORES DIFERIDOS - INSCRICAO - SUB-REPASSE DIFERIDO - INSCRICAO','REGISTRA A APROPRIACAO DO VALOR REFERENTE AO SUB-REPASSE CONCEDIDO ENTRE AS UGS DA ADMINISTRACAO DIRETA OU INDIRETA POR OCASIAO DA  INSCRICAO DOS VALORES DIRERIDOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.00.00.00','REPASSES PREVIDENCIARIOS CONCEDIDOS PARA O RPPS','COMPREENDE O VALOR TOTAL DOS REPASSES PREVIDENCIARIOS CONCEDIDOS REFERENTES A CONTRIBUICAO PREVIDENCIARIA DO ENTE ESTATAL AO REGIME PROPRIODE PREVIDENCIA SOCIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.01.00.00','REPASSE PREVIDENCIARIO CONCEDIDO P/COBERTURA DEFICIT - APOSENTADORIAS EXECUTIVO / INDIRETAS','REGISTRA O SOMATORIO DOS VALORES REPASSADOS PARA O RPPS A TITULO DE COBERTURA DE   DEFICIT DO EXERCICIO ATUAL - APOSENTADORIAS DO PODER EXECUTIVO / INDIRETAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.02.00.00','REPASSE PREVIDENCIARIO CONCEDIDO P/COBERTURA DEFICIT - APOSENTADORIAS LEGISLATIVO','REGISTRA O SOMATORIO DOS VALORES REPASSADOS PARA O RPPS A TITULO DE COBERTURA DE   DEFICIT DO EXERCICIO ATUAL - APOSENTADORIAS DO PODER LEGISLATIVO','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.03.00.00','REPASSE PREVIDENCIARIO CONCEDIDO P/COBERTURA DEFICIT - PENSOES','REGISTRA O SOMATORIO DOS VALORES REPASSADOS PARA O RPPS A TITULO DE COBERTURA DE   DEFICIT DO EXERCICIO ATUAL - PENSOES','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.04.00.00','REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS - EXECUTIVO/INDIRETAS','REGISTRA OS REPASSES CONCEDIDOS AO RPPS DO MUNICIPIO PARA QUE ESTE EXECUTE O PAGAMENTO DE APOSENTADORIAS DE COMPETÊNCIA DAS ENTIDADES DO EXECUTIVO/INDIRETAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.05.00.00','REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS - LEGISLATIVO','REGISTRA OS REPASSES CONCEDIDOS AO RPPS DO MUNICIPIO PARA QUE ESTE EXECUTE O PAGAMENTO DE APOSENTADORIAS DE COMPETÊNCIA DO PODER LEGISLATIVO','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.06.00.00','REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSÕES','REGISTRA OS REPASSES CONCEDIDOS AO RPPS DO MUNICIPIO PARA QUE ESTE EXECUTE O PAGAMENTO DE PENSÕES DE COMPETÊNCIA DAS ENTIDADES DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.07.00.00','REPASSE  CONCEDIDO AO RPPS A TITULO DE APORTE PARA AMORTIZAÇÃO DO DEFICIT ATUARIAL','REGISTRA TODOS OS REPASSES CONCEDIDOS AO RPPS DO MUNICIPIO A TITULO DE APORTE PARA AMORITIZAÇÃO DO DEFICIT ATUARIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.99.00.00.00','OUTROS APORTES AO RPPS','REGISTRAR OS OUTROS APORTES FINANCEIROS REPASSADOS PELO ENTE AO RPPS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.0.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORCAMENTARIA','Compreende o valor das transferências financeiras, de bens ou valores concedidas para restos a pagar e outras finalidades independentes da execução orçamentária.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORCAMENTARIA - INTRA OFSS','Compreende o valor das transferências financeiras, de bens ou valores concedidas para restos a pagar e outras finalidades independentes da execução orçamentária.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.01.00.00.00.00','TRANSFERENCIAS CONCEDIDAS - INDEPENDENTE DE EXECUCAO ORCAMENTARIA','COMPREENDE AS TRANSFERENCIAS FINANCEIRAS PARA RESTOS A PAGAR E OUTROS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.01.01.00.00.00','ORDEM DE TRANSFERENCIAS CONCEDIDAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO TOTAL DAS TRANSFERENCIAS NAO VINCULADAS AO ORCAMENTO, INCLUSIVE TRANSFERENCIAS PARA ATENDER RESTOS A PAGAR E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.01.02.00.00.00','DEVOLUCAO DE TRANSFERENCIAS RECEBIDAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR  DAS DEVOLUCOES  REFERENTES A RESTOS A PAGAR RECEBIDO E NAO UTILIZADO OU UTILIZADO PARCIALMENTE, SEM O RESTABELECIMENTO DO DIREITO CORRESPONDENTE AO LIMITE DE RP.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.01.03.00.00.00','TRANSFERENCIAS CONCEDIDAS DE BENS IMOVEIS','REGISTRA O VALOR DAS TRANSFERENCIAS DE BENS IMOVEIS ENTRE UNIDADES  DO MESMO ORGAO .','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.01.04.00.00.00','DOACOES CONCEDIDAS DE BENS IMOVEIS','REGISTRA O VALOR DE DOACOES DE BENS IMOVEIS ENTRE UNIDADES DE ORGAOS DIFERENTES','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.01.05.00.00.00','TRANFERENCIAS CONCEDIDAS DE BENS MOVEIS POR UNIDADE LOCALIZADA NO PAIS','REGISTRA O VALOR DOS BENS MOVEIS  CONCEDIDOS  POR UNIDADE LOCALIZADA NO  PAIS  PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DO MESMO ORGAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.01.06.00.00.00','DOACOES CONCEDIDAS DE BENS MOVEIS POR UNIDADE LOCALIZADA NO PAIS','REGISTRA O VALOR DOS BENS MOVEIS  CONCEDIDOS  POR UNIDADE LOCALIZADA NO  PAIS  PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DE ORGAOS DIFERENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.01.07.00.00.00','DOACOES CONCEDIDAS DE BENS MOVEIS POR UNIDADE LOCALIZADA DO EXTERIOR','REGISTRA O VALOR DOS BENS MOVEIS  CONCEDIDOS  POR UNIDADE LOCALIZADA NO  EXTERIOR  PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR,  DE ORGAOS DIFERENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.3.0.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS PARA COBERTURA DO DÉFICIT ATUARIAL DO RPPS POR APORTE PERIÓDICO','Compreende o valor das transferências financeiras para aportes periódicos destinados à cobertura do déficit atuarial do Regime Próprio de Previdência Social  - RPPS, conforme plano de amortização estabelecido em lei do respectivo ente Federativo, exceto as decorrentes de alíquota de contribuição suplementar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.3.2.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS PARA COBERTURA DO DÉFICIT ATUARIAL DO RPPS POR APORTE PERIÓDICO - INTRA OFSS','Compreende o valor das transferências financeiras para aportes periódicos destinados à cobertura do déficit atuarial do Regime Próprio de Previdência Social  - RPPS, conforme plano de amortização estabelecido em lei do respectivo ente Federativo, exceto as decorrentes de alíquota de contribuição suplementar. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.0.0.00.00.00.00.00','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes de transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.0.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS','Compreende as variações patrimoniais diminutivas  decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.1.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).  Por exemplo, empresa independente de um ente recebendo transferência de outro ente. (a empresa independente não pertence ao OFSS mas pertence ao conceito de governamental).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.3.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.3.01.00.00.00.00','PAGAMENTO DE LAUDEMIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA PRESTACAO DE SERVICOS POR PESSOAS JURIDICAS PARA ORGAOS PUBLICOS, DECORRENTES DE PAGAMENTO DE LAUDEMIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.3.02.00.00.00.00','CONTRIBUICOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS CONTRIBUICOES CONCEDIDAS A UNIAO PARA REALIZACAO DE OUTRAS DESPESAS CORRENTES, OU SEJA, DESPESAS AS  QUAIS  NAO  CORRESPONDA CONTRAPRESTACAO DIRETA EM BENS E SERVICOS E NAO SEJA REEMBOLSAVEL PELO RECEBEDOR, INCLUSIVE AS DESTINADAS A ATENDER A DESPESAS DE MANUTENÇÃO DE OUTRAS ENTIDADES DE DIREITO PÚBLICO OU PRIVADO, OBSERVADO O DISPOSTO NA LEGISLAÇÃO VIGENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.3.03.00.00.00.00','TRANSFERENCIAS FUNSET-FUNDO NAC.SEGURANCA EDUC.TRANSITO(LF 9503/97)','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA PARCELA DAS MULTAS DE TRÂNSITO TRANSFERIDAS PARA O FUNDO FUNSET - 5% DA PARCELA RECEBIDA PELOS MUNICÍPIOS RELATIVA À REPASSES DO ESTADO DAS MULTAS DE TRÂNSITO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.3.04.00.00.00.00','TRANSFERENCIA VALORES A JUSTICA ELEITORAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE TRANSFERÊNCIAS DE VALORES À JUSTIÇA ELEITORAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.3.05.00.00.00.00','RESTITUICAO DE TRANSFERENCIAS E CONVENIOS RECEBIDOS DA UNIAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUIÇÕES DE CONVÊNIOS E TRANSFERÊNCIAS RECEBIDAS DA UNIÃO, COMO, POR EXEMPLO: SALDO DE JUROS DE APLICAÇÕES FINANCEIRAS; SALDOS DE VALORES NÃO UTILIZADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.01.00.00.00.00','CONTRIBUIÇÃO PATRONAL PARA O RPPS DO ESTADO REFERENTE A PESSOAL REQUISITADO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PAGAMENTO DE CONTRIBUIÇÃO PATRONAL QUANDO O SERVIDOR É CONTRIBUINTE DO RPPS DO ESTADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.02.00.00.00.00','PROGRAMA TROCA-TROCA','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS QUE O MUNICÍPIO TEM QUE REPASSAR PARA O ESTADO REFERENTE AO PROGRAMA TROCA-TROCA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.03.00.00.00.00','TRANSFERENCIAS PARA GRUPAMENTOS DE INCENDIO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS QUE O MUNICÍPIO TEM QUE REPASSAR PARA OS GRUPAMENTOS DE INCÊNDIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.04.00.00.00.00','RESTITUICAO DE TRANSFERENCIAS E CONVENIOS RECEBIDOS DO ESTADO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUIÇÕES DE CONVÊNIOS E TRANSFERÊNCIAS RECEBIDAS DO ESTADO, COMO, POR EXEMPLO: SALDO DE JUROS DE APLICAÇÕES FINANCEIRAS; SALDOS DE VALORES NÃO UTILIZADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.05.00.00.00.00','RESTITUICAO DE IPVA','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUIÇÕES DE IPVA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.5.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.5.01.00.00.00.00','CONTRIBUIÇÃO PATRONAL PARA RPPS DE OUTRO MUNICIPIO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS  DAS CONTRIBUICOES PATRONAIS QUE UM MUNICIPIO DEVA REPASSAR PARA O RPPS DE OUTRO MUNICIPIO EM RAZÃO DE OBRIGAÇAO PATRONAL DECORRENTE DE PRESTAÇÃO DE SERVIÇO DE SERVIDOR EFETIVO DE OUTRO MUNICIPIO COM ONUS PARA O MUNICIPIO REQUISITANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.5.02.00.00.00.00','CONTRIBUICOES A ESCOLAS MUNICIPAIS','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DAS CONTRIBUIÇÕES PARA A MANUTENÇÃO DE ALUNOS MATRICULADOS EM ESCOLAS DE OUTROS MUNICÍPIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.5.03.00.00.00.00','CONTRIBUICOES MUNICIPIO POLO DA CONTRAPARTIDA CONVENIO C/UNIAO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DAS CONTRIBUIÇÕES PARA O MUNICÍPIO POLO REFERENTE A CONTRAPARTIDA DE CONVÊNIOS RECEBIDOS POR VÁRIOS MUNICÍPIOS DA UNIÃO. EX: CONTRAPARTIDA FNDE','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.5.04.00.00.00.00','TRANSFERENCIA A MUNICIPIO EMANCIPADO PARA ACERTO DE  CONTAS','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DAS TRANSFERÊNCIAS REALIZADAS PELO MUNICÍPIO PARA O MUNICÍPIO EMANCIPADO PARA FINS DE ACERTO DE CONTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.5.05.00.00.00.00','RESTITUICAO DE TRANSFERENCIAS E CONVENIOS RECEBIDOS DOS MUNICIPIOS','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUIÇÕES DE CONVÊNIOS E TRANSFERÊNCIAS RECEBIDAS DOS MUNICÍPIOS, COMO, POR EXEMPLO: SALDO DE JUROS DE APLICAÇÕES FINANCEIRAS; SALDOS DE VALORES NÃO UTILIZADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.2.0.00.00.00.00.00','TRANSFERÊNCIAS AO FUNDEB','Compreende as variações patrimoniais diminutivas decorrentes da transferência de recursos dos entes, incluindo a complementação da União, para a composição do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.2.4.00.00.00.00.00','TRANSFERÊNCIAS AO FUNDEB -  INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes da transferência de recursos dos entes, incluindo a complementação da União, para a composição do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.0.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, bem como a demais entidades, de bens e/ou valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.1.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas decorrentes de transferências voluntárias a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).  Por exemplo, empresa independente de um ente recebendo transferência de outro ente. (A empresa independente não pertence ao OFSS, mas pertence ao conceito de governamental).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.3.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.4.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.5.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.0.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS','Compreende as variações patrimoniais diminutivas decorrentes de demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.1.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.3.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes de demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.4.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes de demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.5.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes de demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.0.0.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS','Compreende as variações patrimoniais diminutivas decorrentes das transferências financeiras a instituições privadas, inclusive de bens e valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.0.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas sem fins lucrativos que não tenham vinculo com a administração pública, exemplo: ONGs, OSCIPS e OS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.1.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas sem fins lucrativos que não tenham vinculo com a administração pública, exemplo: ONGs,OSCIPS E OS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.1.01.00.00.00.00','INSTITUIÇÃO DE CARATER ASSISTENCIAL, CULTURAL E EDUCACIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS   EFETUADAS A INSTITUICOES DE CARATER ASSISTENCIAL, CULTURAL E EDUCACIONAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.1.02.00.00.00.00','ORGANIZAÇÕES DE SOCIEDADE CIVIL DE INTERESSE PUBLICO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS   EFETUADAS A ORGANIZAÇÕES DE SOCIEDADE CIVIL DE INTERESSE PUBLICO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.1.99.00.00.00.00','OUTRAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS   EFETUADAS A OUTRAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO  DE  CONTRIBUIÇÕES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.2.0.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas com fins lucrativos que não tenham vínculos com administração pública.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.2.1.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas com fins lucrativos, que não tenham vínculos com a administração pública. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.4.0.0.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES MULTIGOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes das transferências a instituições multigovernamentais, da quais o ente transferidor não participe.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.4.0.1.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências a instituições multigovernamentais, das quais o ente transferidor não participe.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.5.0.0.00.00.00.00.00','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências a consórcios públicos, dos quais o ente transferidor participe.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.5.0.1.00.00.00.00.00','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências a consórcios públicos, dos quais o ente transferidor participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.6.0.0.00.00.00.00.00','TRANSFERÊNCIAS AO EXTERIOR','Compreende as variações patrimoniais diminutivas decorrentes de transferências a organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.6.0.1.00.00.00.00.00','TRANSFERÊNCIAS AO EXTERIOR - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferências a organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior. Compreende os valores de operações efetuadas entre uma unidade pertencente ao orçamento fiscal e da seguridade social (OFSS) com unidade que não pertença ao OFSS de ente público.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.0.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) ou Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.1.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.1.3.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.1.4.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.1.5.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.2.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.2.1.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante. Compreende os valores de operações efetuadas entre uma unidade pertencente ao orçamento fiscal e da seguridade social (OFSS) com unidade que não pertença ao OFSS de ente público.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.0.0.0.00.00.00.00.00','DESVALORIZAÇÃO E PERDA DE ATIVOS','Compreende a variação patrimonial diminutiva com desvalorização e perdas de ativos, com redução a valor recuperável, com provisões para perdas, perdas com alienação e perdas involuntárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.0.0.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL E AJUSTE PARA PERDAS','Compreende o ajuste ao valor de mercado ou de consenso entre as partes para itens do ativo, quando esse for inferior ao valor liquido contábil, visando a assegurar que os ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda e também registra as variações patrimoniais diminutivas com ajustes para perdas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.0.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS','Compreende o ajuste ao valor de mercado ou de consenso entre as partes para investimentos, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','Registra o ajuste ao valor de mercado ou de consenso entre as partes para investimentos, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.2.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTRA OFSS','Registra o ajuste ao valor de mercado ou de consenso entre as partes para investimentos, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.3.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - UNIÃO','Registra o ajuste ao valor de mercado ou de consenso entre as partes para investimentos, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.4.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - ESTADO','Registra o ajuste ao valor de mercado ou de consenso entre as partes para investimentos, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.5.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Registra o ajuste ao valor de mercado ou de consenso entre as partes para investimentos, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.2.0.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO','Compreende o ajuste ao valor de mercado ou de consenso entre as partes para itens do ativo imobilizado, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.2.1.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','Registra o ajuste ao valor de mercado ou de consenso entre as partes para itens do ativo imobilizado, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.3.0.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS','Compreende o ajuste ao valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.3.1.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS - CONSOLIDAÇÃO','Registra o ajuste ao valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Por exemplo, a variação patrimonial diminutiva com ajuste para créditos de liquidação duvidosa e ajuste para créditos da divida ativa.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.00.00.00.00','VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS - DIVIDA ATIVA TRIBUTARIA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS DA DIVIDA ATIVA  TRIBUTARIA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.01.00.00.00','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DE CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.02.00.00.00','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSAO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.03.00.00.00','DIVIDA ATIVA TRIBUTARIA -ANULACAO','REGISTRA OS VALORES RELATIVOS A ANULACAO DE CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.04.00.00.00','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE','REGISTRA OS VALORES RELATIVOS A PRESCRICAO INTERCORRENTE DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.05.00.00.00','DIVIDA ATIVA TRIBUTARIA - ADJUDICAÇÃO','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.06.00.00.00','DIVIDA ATIVA TRIBUTARIA -EXTINCAO','REGISTRA OS VALORES RELATIVOS A EXTINCAO DE CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.07.00.00.00','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.99.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS DE OUTROS CRÉDITOS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS DE OUTROS CRÉDITOS, NÃO ESPECIFICADOS ACIMA,POR INADIMPLENCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CRÉDITOS. POR EXEMPLO: AJUSTE PARA CRÉDITOS DE LIQUIDACAO DUVIDOSA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.2.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTRA OFSS','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.3.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.4.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.5.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.5.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES','Compreende a variação patrimonial diminutiva com ajuste para redução a valor de mercado de estoques.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.5.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com ajuste para redução a valor de mercado de estoques. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.0.0.00.00.00.00.00','PERDAS COM ALIENAÇÃO','Compreende a perda com alienação de ativos, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.1.0.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS','Compreende a perda com alienação de investimentos, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.1.1.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','Registra a perda com alienação de investimentos, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.2.0.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE IMOBILIZADO','Compreende a perda com alienação de ativos imobilizados, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.2.1.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Registra a perda com alienação de ativos imobilizados, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.3.0.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS','Compreende a perda com alienação de ativos intangíveis, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.3.1.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Registra a perda com alienação de ativos intangíveis, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.0.0.00.00.00.00.00','PERDAS INVOLUNTÁRIAS','Compreendem o desfazimento físico involuntário do bem, como o que resulta de sinistros como incêndio e inundações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.1.0.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO','Compreendem o desfazimento físico involuntário de bem do ativo imobilizado, como o que resulta de sinistros como incêndio e inundações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.1.1.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO - CONSOLIDAÇÃO','Registra o desfazimento físico involuntário de bem do ativo imobilizado, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.2.0.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS','Compreendem o desfazimento físico involuntário de bem do ativo intangível, como o que resulta de sinistros como incêndio e inundações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.2.1.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS - CONSOLIDAÇÃO','Registra o desfazimento físico involuntário de bem do ativo intangível, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.3.0.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM ESTOQUES','Compreendem o desfazimento físico involuntário de bem do estoque, como o que resulta de sinistros como incêndio e inundações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.3.1.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM ESTOQUES - CONSOLIDAÇÃO','Registra o desfazimento físico involuntário de bem do estoque, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.9.0.00.00.00.00.00','OUTRAS PERDAS INVOLUNTÁRIAS','Compreendem o desfazimento físico involuntário de outros bens, como as que resultam de sinistros como incêndio e inundações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.9.1.00.00.00.00.00','OUTRAS PERDAS INVOLUNTÁRIAS - CONSOLIDAÇÃO','Registra o desfazimento físico involuntário de outros bens, como as que resultam de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.0.0.0.00.00.00.00.00','TRIBUTÁRIAS','Compreendem as variações patrimoniais diminutivas relativas aos impostos, taxas, contribuições de melhoria, contribuições sociais, contribuições econômicas e contribuições especiais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.0.0.00.00.00.00.00','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','Compreendem as variações patrimoniais diminutivas relativas às obrigações relativas às prestações pecuniárias compulsórias, em moeda ou cujo valor nela possa se exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade vinculada. Como: impostos, taxas e contribuições de melhoria.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.0.00.00.00.00.00','IMPOSTOS','Compreende as variações patrimoniais diminutivas com impostos, apurados no período de competência, e vinculados à atividade administrativa do contribuinte, definidos no CTN.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.00.00.00.00.00','IMPOSTOS- CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com impostos, apurados no período de competência e vinculados atividade administrativa do contribuinte, definidos no CTN. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.01.00.00.00.00','IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE PROPRIEDADE TERRITORIAL RURAL DE COMPETENCIA DA UNIAO RELATIVO A PROPRIEDADE, O DOMINIO UTIL OU POSSE DE IMOVEL POR NATUREZA LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO EM 01 DE JANEIRO DE CADA ANO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.02.00.00.00.00','IMPOSTO S/ PROPRIEDADE PREDIAL E TERRITORIAL URBANA','REGISTRA O VALOR DA VPD COM  IMPOSTO, DE COMPETENCIA DOS MUNICIPIOS E DISTRITO FEDERAL, SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM IMOVEL POR NATUREZA OU POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICIPIO E DO DISTRITO FEDERAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.03.00.00.00.00','IMPOSTO DE RENDA','REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I  DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II  DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NÃO COMPREENDIDOS NO ITEM ANTERIOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.04.00.00.00.00','ADICIONAL DO IMPOSTO DE RENDA','REGISTRA O VALOR DA VPD COM O ADICIONAL AO IRPJ.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.05.00.00.00.00','IMPOSTO S/ PROPRIEDADE DE VEICULOS AUTOMOTORES','REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.06.00.00.00.00','IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS','REGISTRA O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II  A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III  A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.07.00.00.00.00','IMPOSTO S/ CIRCULAÇÃO DE MERCADORIAS E SERVIÇOS','REGISTRA O VALOR  DA VPD COM IMPOSTO INCIDENTE SOBRE OPERAÇÕES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTAÇÕES DE SERVIÇOS DE TRANSPORTE INTERESTADUAL, INTERMUNICIPAL E DE COMUNICACAO, E E DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.08.00.00.00.00','IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA','REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA, DE COMPETENCIA DOS MUNICIPIOS E DO DISTRITO FEDERAL, TEM COMO FATO GERADOR A PRESTACAO DE SERVIÇOS CONSTANTES DA LISTA ANEXA DA LC 116/2003, AINDA QUE ESSES NÃO SE CONSTITUAM COMO ATIVIDADE PREPONDERANTE DO PRESTADOR. PODE SER RECOLHIDO PELO SUBSTITUTO TRIBUTARIO CONFORME LC 116/2003.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.09.00.00.00.00','IMPOSTO S/ OPERAÇÕES FINANCEIRAS','REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERAÇÕES DE CRÉDITO, CAMBIO E SEGURO, E SOBRE OPERAÇÕES RELATIVAS A TÍTULOS E VALORES MOBILIÁRIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERAÇÕES DE CRÉDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERAÇÕES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERAÇÕES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERAÇÕES RELATIVAS A TÍTULOS E VALORES MOBILIÁRIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.10.00.00.00.00','IMPOSTO S/ IMPORTAÇÃO','REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS TEM COMO FATO GERADOR A ENTRADA DESTES NO TERRITORIO NACIONAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.11.00.00.00.00','IMPOSTO S/ TRANSMISSAO DE IMOVEL INTER VIVOS','REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE A TRANSMISSAO "INTER VIVOS", A QUALQUER TITULO, POR ATO ONEROSO, DE BENS IMOVEIS, POR NATUREZA OU ACESSAO FISICA, E DE DIREITOS REAIS SOBRE IMOVEIS, EXCETO OS DE GARANTIA, BEM COMO CESSAO DE DIREITOS A SUA AQUISICAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.99.00.00.00.00','OUTROS IMPOSTOS','REGISTRA O VALOR DE VPDS COM OUTROS IMPOSTOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.2.0.00.00.00.00.00','TAXAS','Compreende as variações patrimoniais diminutivas com taxas cobradas pela União, Estados, Distrito Federal ou Municípios, no âmbito de suas respectivas contribuições, decorrentes da contraprestação de serviços públicos ao contribuinte postos a sua disposição, inclusive o exercício de poder de policia.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.2.1.00.00.00.00.00','TAXAS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas com taxas cobradas pela União, Estados, Distrito Federal ou Municípios, no âmbito de suas respectivas contribuições, decorrentes da contraprestação de serviços públicos ao contribuinte postos a sua disposição, inclusive o exercício de poder de policia. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.3.0.00.00.00.00.00','CONTRIBUIÇÕES DE MELHORIA','Compreende as variações patrimoniais diminutivas com tributo cuja obrigação tem por fato gerador um beneficio especial auferido pelo contribuinte que por consequência promove uma valorização imobiliária e patrimonial decorrente de obra pública de competência da União, Estados, Distrito Federal ou Municípios , amparadas em lei e limitadas ao total da despesa pública realizada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.3.1.00.00.00.00.00','CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas com titulo cuja obrigação tem por fato gerador um beneficio especial auferido pelo contribuinte que por consequência promove uma valorização imobiliária e patrimonial decorrente de obra pública de competência da União, Estados, Distrito Federal ou municípios, amparadas em lei e limitadas ao total da despesa pública realizada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.0.0.00.00.00.00.00','CONTRIBUIÇÕES','Compreende as variações patrimoniais diminutivas com contribuições sociais, econômicas e outras, decorrentes da intervenção do estado (União, estados, distrito federal e municípios) no domínio econômico e de interesse da categoria de profissionais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo estado, entre elas o PIS/PASEP, CSLL e COFINS, etc.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.01.00.00.00.00','CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS - CONSOLIDAÇÃO','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.02.00.00.00.00','PIS/PASEP','REGISTRA O VALOR DA  VPD  COM  CONTRIBUICAO  PARA  O  PROGRAMA  DE INTEGRACAO SOCIAL(PIS) OU PARA O PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO(PASEP)','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.03.00.00.00.00','CONTRIBUIÇÃO SOCIAL S/ LUCRO LIQUIDO - CSLL - CONSOLIDAÇÃO','REGISTRA O VALOR DA VPD COM CONTRIBUICAO SOCIAL INCIDENTE SOBRE  O LUCRO DA PESSOA JURIDICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.04.00.00.00.00','OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA FISICA','REGISTRA O VALOR DA VPD COM CONTRIBUICOES PREVIDENCIARIAS  SOBRE SERVICOS DE TERCEIROS PESSOAS FISICAS   CONTRATADAS PARA A EXECUCAO DE SERVICOS, SEM VINCULO COM A ADMINISTRACAO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.05.00.00.00.00','OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA JURIDICA','REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES  SOBRE  SERVICOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO:  - INSS (LEI 9876/99)','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.99.00.00.00.00','OUTRAS CONTRIBUICOES SOCIAIS','REGISTRA O VALOR DA VPD COM OUTRAS CONTRIBUICOES SOCIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.2.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - INTRA OFSS','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.3.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.4.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.5.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP,CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.2.0.00.00.00.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Compreende a variação patrimonial diminutiva com contribuições de intervenção no domínio econômico.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.2.1.00.00.00.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com contribuições de intervenção no domínio econômico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.2.1.01.00.00.00.00','CONTRIBUIÇÃO SINDICAL','REGISTRA O VALOR DA DESPESA COM ENCARGOS PATRONAIS RELATIVO A  CONTRIBUICAO SINDICAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.2.1.99.00.00.00.00','OUTRAS CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMINIO ECONOMICO','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM OUTRAS CONTRIBUIÇÕES ECONOMICAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.3.0.00.00.00.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP','Compreende o valor da variação patrimonial diminutiva com a contribuição para custeio do serviço de iluminação pública (art.149-a da C.F.)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.3.1.00.00.00.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP - CONSOLIDAÇÃO','Registra o valor da variação patrimonial diminutiva com a contribuição para custeio da iluminação pública (art.149-a da C.F.). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.9.0.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES','Compreende a variação patrimonial diminutiva com contribuições que não se enquadram na condição de sociais e econômicas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.9.1.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com contribuições que não se enquadram na condição de sociais e econômicas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.0.0.00.00.00.00.00','CUSTO COM TRIBUTOS','Compreende a variação patrimonial diminutiva relativa a tributos utilizados na produção de bens ou serviços, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.0.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.1.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - CONSOLIDAÇÃO','Compreende as variações diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.2.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTRA OFSS','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.3.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.4.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.5.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.0.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.1.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.2.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTRA OFSS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.3.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.4.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.5.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.0.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.1.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS -TRIBUTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.2.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS -TRIBUTOS -INTRA OFSS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.3.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.4.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.5.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.0.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','Compreende o somatório das variações patrimoniais diminutivas não incluídas nos grupos anteriores. Compreende: premiações, incentivos, equalizações de preços e taxas, participações e contribuições, resultado negativo com participações, dentre outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.0.0.00.00.00.00.00','PREMIAÇÕES','Compreende as aquisições de prêmios, condecorações, medalhas, troféus, etc., bem como com o pagamento de prêmios em pecúnia, inclusive decorrentes de sorteios lotéricos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.1.0.00.00.00.00.00','PREMIAÇÕES CULTURAIS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cultural.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.1.1.00.00.00.00.00','PREMIAÇÕES CULTURAIS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cultural.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.2.0.00.00.00.00.00','PREMIAÇÕES ARTÍSTICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter artístico.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.2.1.00.00.00.00.00','PREMIAÇÕES ARTÍSTICAS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter artístico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.3.0.00.00.00.00.00','PREMIAÇÕES CIENTIFICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cientifico.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.3.1.00.00.00.00.00','PREMIAÇÕES CIENTIFICAS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cientifico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.4.0.00.00.00.00.00','PREMIAÇÕES DESPORTIVAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter desportivo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.4.1.00.00.00.00.00','PREMIAÇÕES DESPORTIVAS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter desportivo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.5.0.00.00.00.00.00','ORDENS HONORIFICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, insígnias etc., relativo a ordens honorificas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.5.1.00.00.00.00.00','ORDENS HONORIFICAS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, insígnias etc., relativo a ordens honorificas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.9.0.00.00.00.00.00','OUTRAS PREMIAÇÕES','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., para finalidades diferentes das previstas nos detalhamentos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.9.1.00.00.00.00.00','OUTRAS PREMIAÇÕES - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., para finalidades diferentes das previstas nos detalhamentos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.0.0.00.00.00.00.00','RESULTADO NEGATIVO DE PARTICIPAÇÕES','Compreende a apropriação do resultado negativo de participações, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.0.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.1.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.2.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTRA OFSS','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.3.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - UNIÃO','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.4.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - ESTADO','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.5.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.0.0.00.00.00.00.00','INCENTIVOS','Compreende os incentivos financeiros concedidos relativos à educação, a ciência e a cultura','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.0.00.00.00.00.00','INCENTIVOS A EDUCAÇÃO','Compreende a ajuda financeira concedida pelo estado a estudantes comprovadamente carentes, e concessão de auxílio para o desenvolvimento de estudos e pesquisas de natureza cientifica realizadas por pessoas físicas na condição de estudante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.1.00.00.00.00.00','INCENTIVOS A EDUCAÇÃO - CONSOLIDAÇÃO','Compreende a ajuda financeira concedida pelo estado a estudantes comprovadamente carentes, e concessão de auxílio para o desenvolvimento de estudos e pesquisas de natureza cientifica realizadas por pessoas físicas na condição de estudante. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.1.01.00.00.00.00','BOLSA DE ESTUDOS NO PAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM BOLSAS DE ESTUDO    NO PAIS, A QUALQUER TITULO, E DEMAIS AUXILIOS FINANCEIROS A ESTUDANTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.1.02.00.00.00.00','BOLSA DE ESTUDOS NO EXTERIOR','REGISTRA AS  VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM BOLSAS DE ESTUDO   NO  EXTERIOR, A QUALQUER TITULO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.1.03.00.00.00.00','BOLSA ESCOLA - BENEFICIO','REGISTRA AS VPDS REALIZADAS COM DESEMBOLSO A TITULO DE  PAGAMENTOS DE BENEFICIOS DO PROGRAMA NACIONAL DE RENDA MINIMA VINCULADA A  EDUCACAO - BOLSA ESCOLA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.1.99.00.00.00.00','OUTROS INCENTIVOS A EDUCACAO','REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INCENTIVOS A EDUCACAO NAO CONTEMPLADOS NOS ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.2.0.00.00.00.00.00','INCENTIVOS A CIÊNCIA','Compreende o apoio financeiro concedido a pesquisadores, individual ou coletivamente, exceto na condição de estudante, no desenvolvimento de pesquisas cientificas e tecnológicas, nas suas mais diversas modalidades.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.2.1.00.00.00.00.00','INCENTIVOS A CIÊNCIA - CONSOLIDAÇÃO','Compreende o apoio financeiro concedido a pesquisadores, individual ou coletivamente, exceto na condição de estudante, no desenvolvimento de pesquisas cientificas e tecnológicas, nas suas mais diversas modalidades. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.2.1.01.00.00.00.00','AUXILIO A PESQUISADORES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO FINANCEIRO A PESQUISADORES, INDIVIDUAL OU  COLETIVAMENTE, EXCETO NA CONDICAO DE ESTUDANTE, NO DESENVOLVIMENTO DE PESQUISAS CIENTIFICAS E TECNOLOGICAS, NAS  SUAS DIVERSAS MODALIDADES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.2.1.99.00.00.00.00','OUTROS INCENTIVOS A CIENCIA','REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INCENTIVOS A CULTURA NÃO CONTEMPLADOS NOS ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.3.0.00.00.00.00.00','INCENTIVOS A CULTURA','Compreende os incentivos financeiros concedidos, visando à promoção da cultura.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.3.1.00.00.00.00.00','INCENTIVOS A CULTURA - CONSOLIDAÇÃO','Registra os incentivos financeiros concedidos, visando à promoção da cultura.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.4.0.00.00.00.00.00','INCENTIVOS AO ESPORTE','Compreende os incentivos financeiros concedidos, visando à promoção do esporte.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.4.1.00.00.00.00.00','INCENTIVOS AO ESPORTE - CONSOLIDAÇÃO','Registra os incentivos financeiros concedidos, visando à promoção do esporte.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.9.0.00.00.00.00.00','OUTROS INCENTIVOS','Compreende outros incentivos financeiros concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.9.1.00.00.00.00.00','OUTROS INCENTIVOS - CONSOLIDAÇÃO','Registra os incentivos financeiros concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.5.0.0.00.00.00.00.00','SUBVENÇÕES ECONÔMICAS','Compreende a variação patrimonial diminutiva com o pagamento de subvenções econômicas, a qualquer título, autorizadas em leis específicas, tais como: ajuda financeira a entidades privadas com fins lucrativos; concessão de bonificações a produtores, distribuidores e vendedores; cobertura, direta ou indireta, de parcela de encargos de empréstimos e financiamentos e dos custos de aquisição, de produção, de escoamento, de distribuição, de venda e de manutenção de bens, produtos e serviços em geral; e, ainda, outras operações com características semelhantes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.5.0.1.00.00.00.00.00','SUBVENÇÕES ECONÔMICAS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com o pagamento de subvenções econômicas, a qualquer título, autorizadas em leis específicas, tais como: ajuda financeira a entidades privadas com fins lucrativos; concessão de bonificações a produtores, distribuidores e vendedores; cobertura, direta ou indireta, de parcela de encargos de empréstimos e financiamentos e dos custos de aquisição, de produção, de escoamento, de distribuição, de venda e de manutenção de bens, produtos e serviços em geral; e, ainda, outras operações com características semelhantes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.0.0.00.00.00.00.00','PARTICIPAÇÕES E CONTRIBUIÇÕES','Compreende as participações de terceiros nos lucros, não relativas ao investimento dos acionistas, tais como: participações de debêntures, empregados, administradores e partes beneficiárias, mesmo na forma de instrumentos financeiros, além da contribuição a instituições ou fundos de assistência ou previdência de empregados.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.1.0.00.00.00.00.00','PARTICIPAÇÕES DE DEBÊNTURES','Compreende as participações de debêntures incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.1.1.00.00.00.00.00','PARTICIPAÇÕES DE DEBÊNTURES - CONSOLIDAÇÃO','Registra as participações de debêntures incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.2.0.00.00.00.00.00','PARTICIPAÇÕES DE EMPREGADOS','Compreende as participações de empregados incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.2.1.00.00.00.00.00','PARTICIPAÇÕES DE EMPREGADOS - CONSOLIDAÇÃO','Registra as participações de empregados incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.3.0.00.00.00.00.00','PARTICIPAÇÕES DE ADMINISTRADORES','Compreende as participações de administradores incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.3.1.00.00.00.00.00','PARTICIPAÇÕES DE ADMINISTRADORES - CONSOLIDAÇÃO','Registra as participações de administradores incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.4.0.00.00.00.00.00','PARTICIPAÇÕES DE PARTES BENEFICIARIAS','Compreende as participações de partes beneficiarias incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.4.1.00.00.00.00.00','PARTICIPAÇÕES DE PARTES BENEFICIARIAS - CONSOLIDAÇÃO','Registra as participações de partes beneficiarias incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.5.0.00.00.00.00.00','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS','Compreende as contribuições da empresa, incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido, para instituições ou fundos de assistência ou previdência de empregados.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.5.1.00.00.00.00.00','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS - CONSOLIDAÇÃO','Registra as contribuições da empresa, incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro líquido, para instituições ou fundos de assistência ou previdência de empregados. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.0.0.00.00.00.00.00','VPD DE CONSTITUIÇÃO DE PROVISÕES','Registra a constituição de provisões, entendidas como os passivos de vencimento ou montante incertos. Não se confundem com os passivos derivados de apropriação por competência, como férias e décimo - terceiro salário.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.1.0.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.1.1.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS - CONSOLIDAÇÃO','Registra os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.2.0.00.00.00.00.00','VPD DE PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.2.1.00.00.00.00.00','VPD DE PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Registra a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.3.0.00.00.00.00.00','VPD DE PROVISÕES PARA RISCOS FISCAIS','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.3.1.00.00.00.00.00','VPD DE PROVISÕES PARA RISCOS FISCAIS - CONSOLIDAÇÃO','Registra a constituição de provisões de passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.4.0.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS CÍVEIS','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.4.1.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS CÍVEIS - CONSOLIDAÇÃO','Registra a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a pagamentos de indenizações a fornecedores e clientes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.5.0.00.00.00.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS','Compreende a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.5.3.00.00.00.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS - INTER OFSS - UNIÃO','Registra a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.5.4.00.00.00.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS - INTER OFSS - ESTADO','Registra a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.5.5.00.00.00.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS - INTER OFSS - MUNICÍPIO','Registra a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.6.0.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP','Compreende a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.6.1.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP - CONSOLIDAÇÃO','Registra a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.9.0.00.00.00.00.00','VPD DE OUTRAS PROVISÕES','Compreende a constituição de provisões de passivos de prazo ou de valor incertos não classificadas anteriormente neste plano de contas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.9.1.00.00.00.00.00','VPD DE OUTRAS PROVISÕES - CONSOLIDAÇÃO','Registra a constituição de provisões de passivos de prazo ou de valor incertos não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.0.0.00.00.00.00.00','CUSTO DE OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de bens ou serviços, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.1.0.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas as mercadorias, sendo registrado apenas no momento da venda destas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.1.1.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - OUTRAS VPD - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas apropriadas as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.2.0.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS - OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de bens, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.2.1.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS - OUTRAS VPD - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas apropriadas na produção de bens, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.3.0.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS - OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de serviços, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.3.1.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS - OUTRAS VPD - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas apropriadas na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.0.0.00.00.00.00.00','DIVERSAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','Compreende outras variações patrimoniais diminutivas não classificadas em itens específicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.1.0.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.1.2.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','Registra as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.1.3.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','Registra as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.1.4.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','Registra as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.1.5.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.2.0.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.2.3.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.2.4.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.2.5.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.3.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES','Compreende as variações patrimoniais diminutivas provenientes de bonificações concedidas na venda de mercadorias','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.3.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de bonificações concedidas na venda de mercadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.0.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.1.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.                                                                           Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.2.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTRA OFSS','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.                                                                                                Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.3.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.                                                                                                Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.4.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.                                                                                                Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.5.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.                                                                                                Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.9.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','Compreende as variações patrimoniais diminutivas decorrentes de fatos geradores diversos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.9.1.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de fatos geradores diversos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.0.0.0.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA','Compreende o aumento no beneficio econômico durante o período contábil sob a forma de entrada de recurso ou aumento de ativo ou diminuição de passivo, que resulte em aumento do patrimônio liquido e que não sejam provenientes de aporte dos proprietários.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.0.0.0.00.00.00.00.00','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','Compreende toda prestação pecuniária compulsória, em moeda ou cujo valor nela se possa exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade administrativa plenamente vinculada. Como: impostos, taxas e contribuições de melhoria.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.0.0.00.00.00.00.00','IMPOSTOS','Compreende como imposto o tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal especifica, relativa ao contribuinte.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.1.0.00.00.00.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR','Compreende os impostos sobre operações de comercio exterior, como por exemplo: impostos sobre a importação e imposto sobre a exportação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.1.1.00.00.00.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR - CONSOLIDAÇÃO','Compreende os impostos sobre operações de comercio exterior, como exemplo: impostos sobre a importação e imposto sobre a exportação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.0.00.00.00.00.00','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA','Compreende os impostos sobre patrimônio e a renda, como por exemplo: imposto sobre a propriedade territorial rural, imposto sobre a propriedade predial e territorial urbana, imposto sobre a transmissão de bens imóveis e de direitos a eles relativos e impostos sobre a renda e proventos de qualquer natureza.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.00.00.00.00.00','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA - CONSOLIDAÇÃO','Compreende os impostos sobre patrimônio e a renda, como exemplo: imposto sobre a propriedade territorial rural,imposto sobre a propriedade predial e territorial urbana,imposto sobre a transmissão de bens imóveis e de direitos a eles relativos e imposto sobre a renda e proventos de qualquer natureza. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.01.00.00.00.00','ITR - MUNICIPIOS CONVENIADOS','REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS. FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO, CONFORME CONVENIO  COM A UNIAO PARA FISCALIZACAO DO REFERIDO IMPOSTO; DESTINACAO LEGAL: O MUNICIPIO OU O DISTRITO FEDERAL OPTANTE FARA JUS A TOTALIDADE DO PRODUTO DA ARRECADACAO DO ITR REFERENTE  AOS  IMOVEIS RURAIS NELE SITUADOS, A PARTIR DO MOMENTO DISCIPLINADO NO CONVENIO;  AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III; B)LEI 5172/1966 ART 29 A 31; C) EC 42/2003; D) LEI 9393/1996; E) LEI 11250/2005. INCLUI-SE AQUI O REGISTRO DA VPA DA DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.02.00.00.00.00','IR RETIDO NAS FONTES - TRABALHO','REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - TRABALHO. INCLUI-SE AQUI O REGISTRO DA VPA DA DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.03.00.00.00.00','IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA - IPTU','REGISTRA O VALOR TOTAL DA VPA DE IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA,  DE COMPETENCIA DOS MUNICIPIOS. TEM  COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM    IMOVEL POR NATUREZA OU  POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICIPIO. INCLUI-SE AQUI O REGISTRO DA VPA DA DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.04.00.00.00.00','IMPOSTO SOBRE TRANSMISSAO "INTER-VIVOS" DE BENS IMOVEIS E DE DIREITOS REAIS SOBRE IMOVEIS - ITBI','REGISTRA O VALOR TOTAL DA VPA DE IMPOSTO SOBRE TRANSMISSÃO "INTER-VIVOS" DE BENS IMÓVEIS E DE DIREITOS REAIS SOBRE IMÓVEIS DE COMPETÊNCIA MUNICIPAL, INCIDE SOBRE O VALOR VENAL DOS BENS OU DIREITOS TRANSMITIDOS OU CEDIDOS. TEM O FATO GERADOR NO MOMENTO DA LAVRADURA DO INSTRUMENTO OU ATO QUE SERVIR DE TÍTULO ÀS TRANSMISSÕES OU ÀS CESSÕES. INCLUI-SE AQUI O REGISTRO DA VPA DA DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.97.00.00.00.00','(-) DEDUCOES DO IMPOSTOS SOBRE PATRIMONIO E A RENDA','COMPREENDEM  AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM OS IMPOSTOS SOBRE O PATRIMONIO E A RENDA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.97.01.00.00.00','(-) DEDUÇÕES DO IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','REGISTRA AS DEDUÇÕES DAS VPA COM O IMPOSTO S/PROPRIEDADE TERRITORIAL RURAL, DE COMPETENCIA DA UNIAO. TEM COMO FATO GERADOR A  PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL POR NATUREZA, COMO  DEFINIDO NA LEI CIVIL, LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.97.02.00.00.00','(-) DEDUÇÕES DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','REGISTRA O VALOR DAS DEDUÇÕES DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA. TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I - DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II - DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.97.03.00.00.00','(-) DEDUÇÕES DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA - IPTU','REGISTRA O VALOR TOTAL DAS DEDUÇÕES DE VPA DE IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA,  DE COMPETENCIA DOS MUNICIPIOS. TEM  COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM    IMOVEL POR NATUREZA OU  POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICIPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.97.04.00.00.00','(-) DEDUÇÕES DO IMPOSTO SOBRE TRANSMISSAO "INTER-VIVOS" DE BENS IMOVEIS E DE DIREITOS REAIS SOBRE IMOVEIS - ITBI','REGISTRA O VALOR TOTAL DA DEDUÇÃO DA VPA DE IMPOSTO SOBRE TRANSMISSÃO "INTER-VIVOS" DE BENS IMÓVEIS E DE DIREITOS REAIS SOBRE IMÓVEIS DE COMPETÊNCIA MUNICIPAL, INCIDE SOBRE O VALOR VENAL DOS BENS OU DIREITOS TRANSMITIDOS OU CEDIDOS. TEM O FATO GERADOR NO MOMENTO DA LAVRADURA DO INSTRUMENTO OU ATO QUE SERVIR DE TÍTULO ÀS TRANSMISSÕES OU ÀS CESSÕES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.0.00.00.00.00.00','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO','Compreende os impostos sobre a produção e a circulação, como por exemplo: imposto sobre produtos industrializados; imposto sobre operações de credito, câmbio e seguro, e sobre operações relativas a títulos e valores mobiliários; imposto sobre serviços de qualquer natureza.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.00.00.00.00.00','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO - CONSOLIDAÇÃO','Com prende os impostos sobre a produção e a circulação como, por exemplo, imposto sobre produtos industrializados;imposto sobre operações de credito, cambio e seguro, e sobre operações relativas a títulos e valores mobiliários, imposto sobre serviços de qualquer natureza.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.01.00.00.00.00','IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA','REGISTRA O VALOR TOTAL DA VPA DE IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA DE COMPETÊNCIA DOS MUNICÍPIOS. TEM COMO FATO GERADOR A PRESTAÇÃO, POR EMPRESA OU PROFISSIONAL AUTÔNOMO, COM OU SEM ESTABELECIMENTO FIXO, DE SERVIÇOS CONSTANTES EM LISTA PRÓPRIA. O ADICIONAL DE ISS PARA CONSTITUIÇÃO DO FUNDO MUNICIPAL DE COMBATE À POBREZA SERÁ REGISTRADO EM NATUREZA ESPECÍFICA.INCLUI-SE AQUI O REGISTRO DA VPA DA DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.02.00.00.00.00','ADICIONAL ISS - FUNDO MUNICIPAL DE COMBATE Á POBREZA','REGISTRA O VALOR DA VPA DECORRENTE DA APLICAÇÃO DE ADICIONAL DE ATÉ MEIO PONTO PERCENTUAL NA ALÍQUOTA DO IMPOSTO SOBRE SERVIÇOS OU DO IMPOSTO QUE VIER A SUBSTITUÍ-LO, SOBRE PRODUTOS SUPÉRFLUOS, PARA A CONSTITUIÇÃO DO FUNDO MUNICIPAL DE COMBATE À POBREZA, CONFORME ESTABELECE O ARTIGO 82, § 2º, ADCT, CF/1988.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.97.00.00.00.00','(-) DEDUÇÃO DOS IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO','COMPREENDE A DEDUÇÃO DOS IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO, COMO POR EXEMPLO: IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS; IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS;IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA;','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.97.01.00.00.00','(-) DEDUÇÃO DO IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA','REGISTRA O VALOR TOTAL DEDUÇÃO DA VPA DE IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA DE COMPETÊNCIA DOS MUNICÍPIOS. TEM COMO FATO GERADOR A PRESTAÇÃO, POR EMPRESA OU PROFISSIONAL AUTÔNOMO, COM OU SEM ESTABELECIMENTO FIXO, DE SERVIÇOS CONSTANTES EM LISTA PRÓPRIA. O ADICIONAL DE ISS PARA CONSTITUIÇÃO DO FUNDO MUNICIPAL DE COMBATE À POBREZA SERÁ REGISTRADO EM NATUREZA ESPECÍFICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.97.02.00.00.00','(-) DEDUÇÃO DO ADICIONAL ISS - FUNDO MUNICIPAL DE COMBATE Á POBREZA','REGISTRA O VALOR DA DEDUÇÃO DA VPA DECORRENTE DA APLICAÇÃO DE ADICIONAL DE ATÉ MEIO PONTO PERCENTUAL NA ALÍQUOTA DO IMPOSTO SOBRE SERVIÇOS OU DO IMPOSTO QUE VIER A SUBSTITUÍ-LO, SOBRE PRODUTOS SUPÉRFLUOS, PARA A CONSTITUIÇÃO DO FUNDO MUNICIPAL DE COMBATE À POBREZA, CONFORME ESTABELECE O ARTIGO 82, § 2º, ADCT, CF/1988.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.4.0.00.00.00.00.00','IMPOSTOS EXTRAORDINÁRIOS','Compreende os impostos instituídos pela União, temporariamente, na iminência ou no caso de guerra externa, suprimidos, gradativamente, no prazo Maximo de cinco anos, contados da celebração da paz.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.4.1.00.00.00.00.00','IMPOSTOS EXTRAORDINÁRIOS - CONSOLIDAÇÃO','Registra os impostos instituídos pela União, temporariamente, na iminência ou no caso de guerra externa, suprimidos,gradativamente, no prazo Maximo de cinco anos, contados da celebração da paz.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.9.0.00.00.00.00.00','OUTROS IMPOSTOS','Compreende os demais impostos não classificados nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.9.1.00.00.00.00.00','OUTROS IMPOSTOS - CONSOLIDAÇÃO','Compreende os demais impostos não classificados nos grupos anteriores.  Compreende os valores de operações efetuadas entre uma unidade pertinente ao orçamento fiscal e da seguridade social (OFSS) com pessoa ou unidade que não pertença ao OFSS de ente público, alem dos demais fatos que não compreendem transações entre partes.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.0.0.00.00.00.00.00','TAXAS','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, tem como fato gerador o exercício regular do poder de policia, ou a utilização, efetiva ou potencial, de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.0.00.00.00.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a prática de ato ou abstenção de fato, em razão de interesse público.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.00.00.00.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA - CONSOLIDAÇÃO','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.01.00.00.00.00','TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA','REGISTRA A VPA COM  TAXA PELA FISCALIZACAO DE VIGILANCIA SANITARIA EXERCIDA PELA AGENCIA NACIONAL DE VIGILANCIA  SANITARIA SOBRE AS PESSOAS FISICAS E JURIDICAS QUE EXERCAM ATIVIDADES   DE FABRICACAO, DISTRIBUICAO E VENDA DE PRODUTOS E A PRESTACAO DE SERVICOS MENCIONADOS NO ARTIGO 8. DA LEI 9782/99. OS RECURSOS SAO VINCULADOS  A AGENCIA NACIONAL DE VIGILANCIA SANITARIA. INCLUI-SE AQUI O REGISTRO DA VPA DA DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.02.00.00.00.00','TAXA DE CONTROLE E FISCALIZACAO AMBIENTAL','REGISTRA  A VPA PROVENIENTE  DA  TAXA  DE  FISCALIZACAO AMBIENTAL, DEVIDA POR PESSOAS FISICAS OU JURIDICAS OBRIGADAS AO REGISTRO NO CADASTRO TECNICO FEDERAL  DE  ATIVIDADES  POTENCIALMENTE  POLUIDORAS OU UTILIZADORAS DE RECURSOS AMBIENTAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.03.00.00.00.00','TAXA DE LICENCA PARA FUNCIONAMENTO DE ESTABELECIMENTOS COMERCIAIS,  INDUSTRIAIS E PRESTADORA DE SERVIÇOS','REGISTRA O VALOR DA VPA DE TAXA DE FISCALIZAÇÃO DA LOCALIZAÇÃO DE ESTABELECIMENTOS COMERCIAIS, INDUSTRIAS E DE PRESTAÇÃO DE SERVIÇOS, INSTITUÍDA PELA LEGISLAÇÃO DO USO E OCUPAÇÃO DO SOLO URBANO ÀS POSTURAS MUNICIPAIS RELATIVAS À SEGURANÇA, ORDEM E TRANQÜILIDADE PÚBLICAS. EX: TAXA DE FISCALIZAÇÃO OU VISTORIA EM ESTABELECIMENTOS DE QUALQUER NATUREZA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.04.00.00.00.00','TAXA DE PUBLICIDADE COMERCIAL','REGISTRA O VALOR DA VPA DE RECEITA DE TAXA DE UTILIZAÇÃO DE ESPAÇO PÚBLICO DESTINADO PARA DIVULGAÇÃO DE PRODUTOS DO COMÉRCIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.05.00.00.00.00','TAXA DE APREENSAO E DEPOSITO','REGISTRA O VALOR DA VPA  DE TAXA DE APREENSÃO E DEPÓSITO DE BENS ORIUNDOS DE IRREGULARIDADES APRESENTADAS QUANDO DA FISCALIZAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.06.00.00.00.00','TAXA DE FUNCIONAMENTO DE ESTABELECIMENTOS EM HORARIO ESPECIAL','REGISTRA O VALOR DA VPA DE TAXA DE FUNCIONAMENTO DE ESTABELECIMENTOS EM HORÁRIO ESPECIAL. A RESPECTIVA TAXA É DESTINADA A BARES, BOATES, BARRACAS POR OCASIÃO DE FESTAS CARNAVALESCAS, PODENDO FUNCIONAR A QUALQUER HORA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.07.00.00.00.00','TAXA DE LICENCA PARA EXECUCAO DE OBRAS','REGISTRA O VALOR DA VPA DE TAXA DE LICENÇA PARA EXECUÇÃO DE OBRAS. A RESPECTIVA TAXA É COBRADA DO RESPONSÁVEL PELA EXECUÇÃO DAS OBRAS EM OBSERVÂNCIA AOS CRITÉRIOS DESCRITOS EM LEI.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.08.00.00.00.00','TAXA DE AUTORIZACAO DE FUNCIONAMENTO DE TRANSPORTE','REGISTRA O VALOR DA VPA DE TAXA DE AUTORIZAÇÃO DE FUNCIONAMENTO DE TRANSPORTE, CARACTERIZADA PELA AUTORIZAÇÃO AOS PROPRIETÁRIOS DE VEÍCULOS QUE PRESTAM SERVIÇOS À COMUNIDADE DE TRANSPORTE DE PASSAGEIROS TAIS COMO: TRANSPORTE ESCOLAR, DE FUNCIONÁRIOS E OUTROS PASSAGEIROS. EX: TAXA DE FISCALIZAÇÃO DE VEÍCULOS DE USO COLETIVO','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.09.00.00.00.00','TAXA DE UTILIZACAO DE AREA DE DOMINIO PUBLICO','REGISTRA O VALOR DA VPA DE TAXA DE UTILIZAÇÃO DE ÁREA DE DOMÍNIO PÚBLICO, REFERENTE A ESPAÇO OCUPADO POR BALCÕES, BARRACAS, MESAS, TABULEIROS E SEMELHANTES, NAS FEIRAS, VIAS E LOGRADOUROS PÚBLICOS OU COMO DEPÓSITO DE MATERIAIS OU ESTACIONAMENTO DE VEÍCULOS EM LOCAIS DESIGNADOS PELA PREFEITURA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.10.00.00.00.00','TAXA DE APROVACAO DO PROJETO DE CONSTRUCAO CIVIL','REGISTRA O VALOR DA VPA DA TAXA DE LICENÇA E APROVAÇÃO DO PROJETO DE CONSTRUÇÃO CIVIL CORRESPONDENTE A CERTIFICAÇÃO DAS CONDIÇÕES DE UTILIZAÇÃO DE PRÉDIOS E RESIDÊNCIAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.11.00.00.00.00','TAXA DE FISCALIZACAO DE APARELHOS DE TRANSPORTE','REGISTRA O VALOR DA VPA DA TAXA DE FISCALIZAÇÃO EXERCIDA EM INSTALAÇÕES (CONSERVAÇÃO E FUNCIONAMENTO) DE ELEVADORES DE PASSAGEIROS E DE CARGAS, DE ALÇAPÕES, ESCADAS ROLANTES, PLANOS INCLINADOS MÓVEIS E OUTROS DE NATUREZA ESPECIAL, EM OBSERVÂNCIA A LEGISLAÇÃO ESPECÍFICA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.12.00.00.00.00','TAXA DE ALINHAMENTO E NIVELAMENTO','REGISTRA O VALOR DA VPA DA TAXA DE FISCALIZAÇÃO DA METRAGEM NO TOCANTE AO ALINHAMENTO E NIVELAMENTO DE ÁREAS OU TERRENOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.13.00.00.00.00','TAXA DE APREENSAO, DEPOSITO OU LIBERACAO DE ANIMAIS','REGISTRA O VALOR DA VPA DA TAXA DE APREENSÃO, DEPÓSITO OU LIBERAÇÃO DE ANIMAIS RECOLHIDOS EM RUAS EM FUNÇÃO DE RISCOS CAUSADOS À POPULAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.96.00.00.00.00','OUTRAS TAXAS PELO EXERCICIO DO PODER DE POLICIA','REGISTRA O VALOR DA VPA DE OUTRAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA, NÃO CLASSIFICADAS NOS ITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.97.00.00.00.00','(-) DEDUCOES DAS TAXAS PELO EXERCICIO DO PODER DE POLÍCIA','REGISTRA  AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS REFERENTES AS TAXAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.0.00.00.00.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, tem como fato gerador a utilização, efetiva ou potencial, de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.00.00.00.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições tem como fato gerador a utilização, efetiva ou potencial, de serviço público específico e divisível prestado ao contribuinte ou posto a sua disposição. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.01.00.00.00.00','EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRATIVAS','REGISTRA A  VPA PROVENIENTE DE TAXA DE EMOLUMENTOS E CUSTAS PROCESSUAIS POR ENTIDADES DA ADMINISTRAÇÃO PÚBLICA FEDERAL, ESTADUAL E MUNICIPAL, EM DECORRÊNCIA DA PRESTAÇÃO DE SERVIÇOS DE CONSULTAS E ANÁLISES DE PROCESSOS EM SUAS RESPECTIVAS COMPETENCIAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.02.00.00.00.00','TAXAS DE SERVICOS CADASTRAIS','REGISTRA A VPA PROVENIENTE DAS TAXAS DE SERVICOS  CADASTRAIS, TENDO COMO FATO GERADOR A  APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA, DA TAXA DE SERVICOS CADASTRAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.03.00.00.00.00','TAXA DE CEMITERIO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TAXA DE PRESTAÇÃO DE SERVIÇOS DE ADMINISTRAÇÃO DE CEMITÉRIOS REFERENTES A UTILIZAÇÃO DE NECROTÉRIO E OCUPAÇÃO DA SALA MORTUÁRIA, BEM COMO MATRÍCULAS, ENTRADA E SAÍDA DE OSSOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.04.00.00.00.00','EMOLUMENTOS E CUSTAS EXTRAJUDICIAIS','REGISTRA O VALOR DA VPA DA TAXA DE SERVIÇOS EXTRAJUDCIAIS REFERENTES AOS ATOS PRATICADOS EM RAZÃO DO OFÍCIO. SERVENTIAS EXTRAJUDICIAIS, ATIVIDADES PRATICADAS PELOS SERVIÇOS NOTARIAIS E DE REGISTRO: LANÇAMENTO EM LIVROS, CERTIDÕES, TRANS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.05.00.00.00.00','TAXA DE LIMPEZA PUBLICA','REGISTRA O VALOR DA VPA RECEBIDA PELA UTILIZAÇÃO EFETIVA OU POTENCIAL DO SERVIÇO PELO PROPRIETÁRIO DE IMÓVEL EDIFICADO OU NÃO, SITUADO EM LOGRADOURO BENEFICIADO PELA COLETA DO LIXO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.06.00.00.00.00','TAXA DE REGISTRO/INSPECAO DE PRODUTOS AGROPECUARIOS','REGISTRA O VALOR DA VPA DA TAXA DE REGISTRO E INSPEÇÃO DE PRODUTOS AGROPECUÁRIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.07.00.00.00.00','TAXA DE SERVICOS PRESTADOS - ARQUIVO HISTORICO MUNICIPAL','REGISTRA O VALOR DA VPA DA TAXA DE SERVIÇOS PRESTADOS - ARQUIVO HISTÓRICO MUNICIPAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.08.00.00.00.00','TAXA DE REGISTRO NO CADASTRO TECNICO AMBIENTAL MUNICIPAL','REGISTRA O VALOR DA VPA DA TAXA DE REGISTRO NO CADASTRO TÉCNICO AMBIENTAL MUNICIPAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.09.00.00.00.00','TAXA DE EMISSAO DE CERTIDOES','REGISTRA O VALOR DA VPA DA TAXA DE EMISSÃO DE CERTIDÕES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.10.00.00.00.00','TAXA DE AGUA SOBRE TERRENOS BALDIOS','REGISTRA O VALOR DA VPA DA TAXA DE ÁGUA SOBRE TERRENOS BALDIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.96.00.00.00.00','OUTRAS TAXAS PELA PRESTACAO DE SERVICOS','REGISTRA A VPA PROVENIENTE DE OUTRAS TAXAS PELA UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU  POSTO A SUA DISPOSICAO, QUE NAO ESTEJAM REFERENCIADAS NAS NATUREZAS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.97.00.00.00.00','(-) DEDUCOES DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA  AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM TAXAS PELA PRESTAÇÃO DE SERVIÇOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.0.0.00.00.00.00.00','CONTRIBUIÇÕES DE MELHORIA','Compreende como contribuição de melhoria o tributo cobrado pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, sendo instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária, tendo como limite total a despesa realizada e como limite individual o acréscimo de valor que da obra resultar para cada imóvel beneficiado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.1.0.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede de água potável e esgoto sanitário.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.1.1.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO - CONSOLIDAÇÃO','Registra o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedade em função da pavimentação asiática, bem como pela colocação de guias, sarjetas e calcamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.2.0.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede de iluminação pública na cidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.2.1.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE - CONSOLIDAÇÃO','Registra o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede iluminação pública na cidade.   Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.3.0.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL','Compreende o valor da arrecadação de receita sobre a cobrança decorrente de valorização de propriedades em função da expansão da rede de iluminação pública rural.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.3.1.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL - CONSOLIDAÇÃO','Registra o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede iluminação pública rural.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.4.0.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da pavimentação asfáltica, bem como pela colocação de guias, sarjetas e calçamento.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.4.1.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES - CONSOLIDAÇÃO','Registra o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da pavimentação asfáltica, bem como pela colocação de guias, sarjetas e calçamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.9.0.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA','Compreende o valor de outras contribuições de melhorias, não classificadas em itens específicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.9.1.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','Registra o valor de outras contribuições de melhorias, não classificadas em itens específicos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.0.0.0.00.00.00.00.00','CONTRIBUIÇÕES','Compreende toda prestação pecuniária compulsória, em moeda ou cujo valor nela se possa exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade administrativa plenamente vinculada. Como: contribuições.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.0.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS','Compreendem como contribuições sociais: a) as das empresas, incidentes sobre a remuneração paga ou creditada aos segurados a seu serviço; b) as dos empregadores domésticos; c) as dos trabalhadores, incidentes sobre o seu salário-de-contribuição; d) as sobre a receita e faturamento; e) as sobre o lucro; f) do importador de bens ou serviços do exterior; g) e outros','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - CONSOLIDAÇÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social.   Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.01.00.00.00.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','Compreende a contribuição patronal destinada ao custeio do Regime Próprio de Previdência Social.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.00.00.00.00','CONTRIBUIÇÃO DO SEGURADO AO RPPS','Compreende a contribuição ao RPPS dos segurados, servidor ativo, servidor inativo e pensionista sobre a sua remuneração.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.01.00.00.00','CONTRIBUIÇÃO DO SERVIDOR CIVIL - RPPS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DO SERVIDOR CIVIL - RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.02.00.00.00','CONTRIBUIÇÃO DO APOSENTADO CIVIL - RPPS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DO APOSENTADO CIVIL - RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.03.00.00.00','CONTRIBUIÇÃO DE PENSIONISTA CIVIL - RPPS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DE PENSIONISTA CIVIL - RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.04.00.00.00','CONTRIBUIÇÃO DE SERVIDOR CIVIL - PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DE SERVIDOR CIVIL - PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.05.00.00.00','CONTRIBUIÇÃO DE APOSENTADO CIVIL - PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DE APOSENTADO CIVIL - PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.06.00.00.00','CONTRIBUIÇÃO DE PENSIONISTA CIVIL - PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DE PENSIONISTA CIVIL - PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.03.00.00.00.00','CONTRIBUIÇÃO PREVIDENCIÁRIA  PARA AMORTIZAÇÃO DO DÉFICIT ATUARIAL','Registra a VPA oriunda de contribuições previdenciárias para amortização do déficit atuarial.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.04.00.00.00.00','CONTRIBUIÇÕES PARA  CUSTEIO DAS PENSÕES  MILITARES','Registra as VPA provenientes de contribuição para custeio das pensões militares, efetivadas por todos os militares, com valor correspondente a seu posto ou graduação, observando as exceções previstas na lei especifica. De competência da União e dos Estados.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.97.00.00.00.00','(-) DEDUCOES','Compreendem as deduções das contribuições sociais - RPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.97.10.00.00.00','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CONTRIBUIÇÕES SOCIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.99.00.00.00.00','OUTRAS CONTRIBUIÇÕES  SOCIAIS - RPPS','Registra o valor das VPA oriundas de contribuições previdenciárias não enquadradas nos subitens anteriores.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTRA OFSS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.01.00.00.00.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.01.01.00.00.00','CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL - RPPS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL - RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.01.02.00.00.00','CONTRIBUIÇÃO PATRONAL - PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE CONTRIBUIÇÃO PATRONAL - PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.97.00.00.00.00','(-) DEDUCOES','REGISTRA A DEDUCAO POR RENUNCIA DE VARIAÇÕES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CRÉDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NÃO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUIÇÕES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.97.10.00.00.00','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CONTRIBUIÇÕES SOCIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.99.00.00.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUIÇÕES PREVIDENCIARIAS NÃO EN-QUADRADAS NOS SUBITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.3.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - UNIÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social.    Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.3.01.00.00.00.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.3.01.01.00.00.00','CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL - RPPS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL - RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.3.01.02.00.00.00','CONTRIBUIÇÃO PATRONAL - PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE CONTRIBUIÇÃO PATRONAL - PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.3.99.00.00.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUIÇÕES PREVIDENCIARIAS NÃO EN-QUADRADAS NOS SUBITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.4.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - ESTADO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.5.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - MUNICÍPIO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.1.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - CONSOLIDAÇÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.2.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTRA OFSS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.3.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - UNIÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.4.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - ESTADO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.5.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - MUNICÍPIO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.3.0.00.00.00.00.00','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO','Compreende a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre a receita ou o faturamento, como por exemplo: COFINS, PIS/PASEP.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.3.1.00.00.00.00.00','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO - CONSOLIDAÇÃO','Compreende a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre a receita ou o faturamento, como por exemplo: COFINS, PIS/PASEP.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.4.0.00.00.00.00.00','CONTRIBUIÇÃO SOBRE O LUCRO','Compreende a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre o lucro, como por exemplo: CSLL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.4.1.00.00.00.00.00','CONTRIBUIÇÃO SOBRE O LUCRO - CONSOLIDAÇÃO','Registra a contribuição do empregador,da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre o lucro, como por exemplo: CSLL.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.5.0.00.00.00.00.00','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO','Compreende a contribuição sobre a receita de concursos de prognósticos, que são todos e quaisquer concursos de sorteios de números, loterias, apostas, inclusive as realizadas em reuniões hípicas, nos âmbitos federal, estadual, do Distrito Federal e municipais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.5.1.00.00.00.00.00','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO - CONSOLIDAÇÃO','Compreende a contribuição sobre a receita de concursos de prognósticos, que são todos e quaisquer concursos de sorteios de números, loterias, apostas, inclusive as realizadas em reuniões hípicas, nos âmbitos federal, estadual, do Distrito Federal e municipais.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.6.0.00.00.00.00.00','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR','Compreende a contribuição social paga pelo importador de bens ou serviços do exterior, ou de quem a lei a ele equiparar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.6.1.00.00.00.00.00','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR - CONSOLIDAÇÃO','Registra a contribuição social paga pelo importador de bens ou serviços do exterior, ou de quem a lei a ele equiparar.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.0.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','Compreende o valor de outras contribuições sociais, não classificadas em itens específicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','Compreende o valor de outras contribuições sociais, não classificadas em itens específicos.     Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.00.00.00.00','CONTRIBUIÇÃO SOCIAL PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL','APRESENTAR O SOMATÓRIO DAS CONTRIBUICOES PARA O FINANCIAMENTO DA  SEGURIDADE SOCIAL RECEBIDAS DOS SERVIDORES MUNICIPAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.01.00.00.00','CONTRIBUICAO DOS SERVIDORES ATIVOS PARA A ASSISTENCIA SOCIAL DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO SERVIDOR ATIVO PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.02.00.00.00','CONTRIBUICAO SERVIDORES INATIVOS E PENSIONISTAS PARA A ASSISTENCIA SOCIAL DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO SERVIDOR INATIVO E PENSIONISTAS PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.03.00.00.00','CONTRIBUICAO DOS SERVIDORES ATIVOS PARA A ASSISTENCIA MEDICA DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO SERVIDOR ATIVO PARA A ASSISTÊNCIA MEDICA DO SERVIDOR','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.04.00.00.00','CONTRIBUICAO DOS SERVIDORES INATIVOS PARA A ASSISTENCIA MEDICA DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO SERVIDOR INATIVO PARA A ASSISTÊNCIA MEDICA DO SERVIDOR','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.05.00.00.00','CONTRIBUICAO DOS PENSIONISTAS PARA A ASSISTENCIA MEDICA DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO PENSIONISTA PARA A ASSISTÊNCIA MEDICA DO SERVIDOR','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.96.00.00.00.00','OUTRAS CONTRIBUICOES SOCIAIS','REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUICOES SOCIAIS NAO ENQUADRADAS NOS SUBITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.97.00.00.00.00','(-) DEDUÇÕES DE OUTRAS CONTRIBUIÇÕES SOCIAIS','COMPREENDEM  AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM OUTRAS CONTRIBUIÇÕES SOCIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.2.0.0.00.00.00.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Compreendem as contribuições de intervenção no domínio econômico, como por exemplo, a CIDE-combustível.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.2.0.1.00.00.00.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','Compreendem as contribuições de intervenção no domínio econômico, como por exemplo, a CIDE combustível. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.2.0.1.03.00.00.00.00','CONTRIBUIÇÕES PARA O DESENVOLVIMENTO E APERFEIÇOAMENTO DAS ATIVIDADES DE FISCALIZAÇÃO','REGISTRA O VALOR DA VPA DE CONTRIBUIÇÕES ECONÔMICAS PARA FINANCIAR O REAPARELHAMENTO E O REEQUIPAMENTO E A ATENDER AOS DEMAIS ENCARGOS ESPECÍFICOS INERENTES AO DESENVOLVIMENTO E AO APERFEIÇOAMENTO DAS ATIVIDADES DE FISCALIZAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.2.0.1.99.00.00.00.00','OUTRAS CONTRIBUICOES ECONOMICAS','COMPREENDE A VPA PROVENIENTE DAS OUTRAS CONTRIBUICOES ECONOMICAS DE NATUREZA EVENTUAL, PARA AS QUAIS NAO HA CONTA ESPECIFICA,INCLUSIVE RECURSOS ORIUNDOS DO PROGRAMA DE RECUPERACAO FISCAL E DO PARCELAMENTO ESPECIAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.3.0.0.00.00.00.00.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA','Compreende as contribuições de iluminação pública, nos termos do artigo 149-a da constituição federal, acrescentado pela emenda constitucional n.ºª 39/02, sendo facultada a cobrança da contribuição na fatura de consumo de energia elétrica.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.3.0.1.00.00.00.00.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA - CONSOLIDAÇÃO','Compreende as contribuições de iluminação pública, nos termos do artigo 149-a da constituição federal, acrescentado pela emenda constitucional n.ºª 39/02, sendo facultada a cobrança da contribuição na fatura de consumo de energia elétrica. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.4.0.0.00.00.00.00.00','CONTRIBUIÇÕES DE INTERESSE DAS CATÉGORIAS PROFISSIONAIS','Compreende as variações patrimoniais aumentativas provenientes de contribuições de interesse das categorias profissionais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.4.0.1.00.00.00.00.00','CONTRIBUIÇÕES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de contribuições de interesse das categorias profissionais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.0.0.0.00.00.00.00.00','EXPLORAÇÃO E VENDA DE BENS, SERVIÇOS E DIREITOS','Compreende as variações patrimoniais aumentativas auferidas com a exploração e venda de bens, serviços e direitos, que resultem em aumento do patrimônio liquido, independentemente de ingresso, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.0.0.00.00.00.00.00','VENDA DE MERCADORIAS','Compreende as variações patrimoniais aumentativas auferidas com a venda de mercadorias, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.1.0.00.00.00.00.00','VENDA BRUTA DE MERCADORIAS','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.1.1.00.00.00.00.00','VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.9.0.00.00.00.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS','Compreende as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.9.1.00.00.00.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','Compreende as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos.    Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.0.0.00.00.00.00.00','VENDA DE PRODUTOS','Compreende as variações patrimoniais aumentativas auferidas com a venda de produtos, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.1.0.00.00.00.00.00','VENDA BRUTA DE PRODUTOS','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de produtos, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.1.1.00.00.00.00.00','VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de produtos, que resultem em aumento do patrimônio liquido, independentemente de ingresso.        Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.9.0.00.00.00.00.00','(-) DEDUÇÕES DE VENDA BRUTA DE PRODUTOS','Compreende as deduções das vendas de produtos, como devoluções, abatimentos e descontos comerciais concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.9.1.00.00.00.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','Compreende as deduções das vendas de produtos, como devoluções, abatimentos e descontos comerciais concedidos.    Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.0.0.00.00.00.00.00','EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.0.00.00.00.00.00','VALOR BRUTO DE EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.00.00.00.00.00','VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido independentemente de ingresso. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.01.00.00.00.00','EXPLORACAO DO PATRIMONIO IMOBILIARIO','COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA  UTILIZACAO, POR TERCEIROS, DE BENS IMOVEIS PERTENCENTES AO SETOR PUBLICO. EX: ALUGUEIS, ARRENDAMENTOS, FOROS, LAUDEMIOS, TAXA DE OCUPACAO DE IMOVEIS E OUTRAS VPA DE EXPLORACAO DE BENS IMOVEIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.02.00.00.00.00','SERVICOS DE ESTUDOS E PESQUISAS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE PESQUISAS E ESTUDOS TECNICO-SOCIAIS, ECONOMICOS, CIENTIFICOS, CULTURAIS ETC., REALIZADAS SOB CONTRATO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.03.00.00.00.00','SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS PRESTADOS. VPA PROPORCIONADA POR CONSULTORIAS TECNICO-FINANCEIRAS, ASSESSORIA, ORGANIZACAO   E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.04.00.00.00.00','PRESTACAO DE SERVICOS RELACIONADOS A T.I','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO. EX: DESENVOLVIMENTO DE SOFTWARE, LICENÇA/CESSAO DE DIREITO DE USO DE PROGRAMAS, MANUTENÇÃO E ATUALIZACAO DE SOFTWARE,  INSTALAÇÃO E CONFIGURACAO DE SOFTWARE, PRESTACAO DE SERVICOS DE PAGINAS ELETRONICAS, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.05.00.00.00.00','SERVICOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS  PROVENIENTES  DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VPA DECORRENTE DE PRESTACAO DE SERVICOS DE   PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE    DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.06.00.00.00.00','SERVICO DE INFORMACOES CIENTIFICAS E TECNOLOGICAS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES CIENTIFICAS E TECNOLOGICAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.07.00.00.00.00','SERVICOS DE TECNOLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS TECNOLOGICOS PRESTADOS. VPA PROPORCIONADA POR: A) ANALISES QUIMICAS, ENSAIOS FISICOS E MECANICOS, CONTROLE E EXPERIMENTACAO QUALITATIVA DE MATERIAS-PRIMAS, INSUMOS E PRODUTOS FABRICADOS; PADRONIZACAO E ESPECIFICACAO DE PRODUTOS; AJUSTES DOS PROCESSOS ETECNICAS DE PRODUCAO INDUSTRIAL (SISTEMA DE TECNOLOGIA) B) ESPECIFICACAO E CONTROLE DE QUALIDADE DE MEDICAMENTOS, INSUMOS FARMACEUTICOS, DROGAS, COSMETICOS, PRODUTOS QUIMICOS, ALIMENTOS, E OUTROS, POR MEIO DE PROVAS ESPECIFICAS DE IDENTIFICACAO, DE PUREZA E  DE TESTES DE CONTAMINACAO MICROBIOLOGICA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.08.00.00.00.00','SERVICOS DE COMUNICACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMUNICACAO, CONFORME DESCRICAO: A) SERVICO POSTAL, DE ENTREGA E TRANSPORTE  DE VOLUMES E CORRESPONDENCIAS; B) SERVICO DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E  INTERNACIONAL E DE TRANSMISSAO DE DADOS; C) SERVICO DE RADIODIFUSAO E DE AGENCIAMENTO DE PUBLICIDADE. INCLUSIVE DIVIDA ATIVA. EX: SERVICOS DE PUBLICIDADE LEGAL, SERVICOS DE RADIODIFUSAO E OUTROS SERVICOS DE COMUNICACAO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.09.00.00.00.00','PRESTACAO DE SERVICOS DE ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ARMAZENAGEM.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.10.00.00.00.00','SERVICOS DE HOSPEDAGEM E ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE HOSPEDAGEM E ALIMENTACAO PRESTADOS. VPA PROPORCIONADA POR HOSPEDAGEM, COM OU   SEM ALIMENTACAO, FORNECIMENTO DE REFEICOES, LANCHES E BEBIDAS PARA CONSUMO IMEDIATO. EXCLUEM AS VPA PROVENIENTES DE EMPRESAS FORNECEDORAS DE ALIMENTOS PREPARADOS PARA HOSPITAIS, FABRICAS, ETC... QUE SE CLASSIFICAM EM VPA DE PRODUTOS ALIMENTARES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.11.00.00.00.00','RECEITA DE CONCESSOES E PERMISSOES','REGISTRA O VALOR TOTAL DA ARRECADAÇÃO DE VPAS ORIGINADAS DA CONCESSÃO OU PERMISSÃO AO PARTICULAR DO DIREITO DE EXPLORAÇÃO DE SERVIÇOS PÚBLICOS, OS QUAIS ESTÃO SUJEITOS AO CONTROLE, FISCALIZAÇÃO E REGULAÇÃO DO PODER PÚBLICO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.12.00.00.00.00','COMPENSACOES FINANCEIRAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DOS RECURSOS DECORRENTES DO ARTIGO 20, PARAGRAFO 1º DA CONSTITUICAO FEDERAL, O QUAL DISPOE: "E ASSEGURADA, NOS TERMOS DA LEI, AOS ESTADOS, AO DISTRI-TO FEDERAL E AOS MUNICIPIOS, BEM COMO AOS ORGAOS DA ADMINISTRACAO DIRETA DA UNIAO, PARTICIPACAO NO RESULTADO DA EXPLORACAO DE PETROLEO OU   GAS NATURAL, DE RECURSOS HIDRICOS PARA FINS DE GERACAO DE ENERGIA ELETRICA E DE OUTROS RECURSOS MINERAIS NO RESPECTIVO TERRITORIO, PLATAFORMA CONTINENTAL, MAR TERRITORIAL OU ZONA ECONOMIA EXCLUSIVA, OU COMPENSACAO FINANCEIRA POR ESSA EXPLORACAO". EX: EXPLORACAO DE RECURSOS MINERAIS, ROYALTIES PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL - EM TERRA, ROYALTIES PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL - EM PLATAFORMA, ROYALTIES EXCEDENTES PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL - EM TERRA, ROYALTIES EXCEDENTES PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL - EM PLATAFORMA, PARTICIPAÇÃO ESPECIAL PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL ALÉM DE OUTRAS COMPENSACOES FINANCEIRAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.13.00.00.00.00','SERVICOS DE TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE TRANSPORTE  RODOVIARIO, FERROVIARIO, HIDROVIARIO, AEREO, ESPECIAIS, RECEITAS DE TERMINAIS RODOVIARIOS, TARIFA DE PEDAGIO ASSIM COMO OUTROS SERVICOS DE TRANSPORTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.14.00.00.00.00','SERVICOS PORTUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS  PROVENIENTES DE SERVICOS PORTUARIOS. ABRANGEM OS RECURSOS ORIUNDOS DA EXPLORACAO DOS PORTOS,   TERMINAIS MARITIMOS, ATRACADOUROS E ANCORADOUROS, REFERENTES A ESTIVA,  DESESTIVA, DRAGAGEM, ATRACACAO, SINALIZACAO, COMUNICACAO NAUTICA,  DOCAGEM, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.15.00.00.00.00','SERVICOS DE SOCORRO MARITIMO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICO DE SOCORRO MARITIMO PRESTADO. VPA DE SERVICOS DE SALVAMENTO, POR NAVIO DE SOCORRO OU EQUIPE DE SALVAMENTO DA MARINHA, DE EMBARCACAO E CARGAS   PERIGO (DESENCALHE, MERGULHO, OUTROS SOCORROS), BEM COMO SERVICOS DE REBOQUE MARITIMO, DENTRE OUTROS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.16.00.00.00.00','SERVICOS DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE SAUDE: HOSPITALARES GERAIS OU ESPECIALIZADOS,   MATERNIDADE, CENTRO DE REABILITACAO, ASSISTENCIA MEDICO-ODONTOLOGICA (INCLUSIVE AMBULATORIAL), SAUDE PUBLICA, SERVICOS DE REGISTRO DE ANALISE E DE CONTROLE DE PRODUTOS SUJEITOS A NORMAS DE VIGILANCIA SANITARIA, SERVICOS RADIOLOGICOS E LABORATORIAIS, ASSIM COMO OUTROS SERVICOS DE SAUDE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.17.00.00.00.00','SERVICOS DE METROLOGIA E CERTIFICACAO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA E CERTIFICACAO PRESTADOS.VPA DE SERVICOS METROLOGICOS GERAL, TAIS COMO AFERICAO DE MEDIDAS E INSTRUMENTOS DE MEDIR, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, METROLOGIA LEGAL E CERTIFICATORIA DELEGADA, METROLOGIA CIENTIFICA E INDUSTRIAL, CERTIFICACAO DE PRODUTOS E SERVICOS INFORMACAO TECNOLOGICA BEM COMO OUTROS SERVICO DE METROLOGIA E CERTIFICACAO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.18.00.00.00.00','SERVICOS DE INSPECAO E FISCALIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE INSPECAO E FISCALIZACAO PRESTADOS. VPA PROPORCIONADA PELA   CONSTATACAO DAS CONDICOES HIGIENICO-SANITARIAS E TECNICAS DE PRODUTOS OU ESTABELECIMENTOS, OU RESULTANTES DE ACAO EXTERNA E DIRETA DOS ORGAOS DO  PODER PUBLICO DESTINADA A VERIFICACAO DO CUMPRIMENTO DA LEGISLACAO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.19.00.00.00.00','SERVICOS ADMINISTRATIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS ADMINISTRATIVOS PRESTADOS, DAS ATIVIDADES DE APOIO ADMINSITRATIVO EXECUTADAS EM ORGANIZACOES DE QUALQUER NATUREZA, TAIS COMO: TAXAS DE EXPEDICAO DE CERTIFICADOS; TAXAS DE REGISTRO, RENOVACAO, VISTORIA DE VEICULOS, LICENCA, CADASTRAMENTO, ETC. DATILOGRAFIA, MICROFILMAGEM, COPIAS XEROGRAFICAS, HELIOGRAFICAS, FOTOSTATICAS, ETC; TAXAS DE INSCRICAO EM CONCURSOS PUBLICOS. TAXA DE ADMINISTRACAO DE SERVICOS. VENDA DE EDITAIS. SERVICOS DE FORNECIMENTO DE LISTAGENS, BEM COMO OUTROS SERVICOS ADMINISTRATIVOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.20.00.00.00.00','SERVICOS DE METEOROLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE METEOROLOGIA PRESTADOS. VPA PROPORCIONADA PELO FORNECIMENTO DE    DADOS METEOROLOGICOS E DE PARECERES TECNICOS, BEM COMO CONSERTO,  COMPARACAO  E AFERICAO DE EQUIPAMENTOS DE METEOROLOGIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.21.00.00.00.00','SERVICOS EDUCACIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DO SISTEMA EDUCACIONAL, CUJA NATUREZA ESTEJA DIRETAMENTE RELACIONADA A FORMACAO DO EDUCANDO (MATRICULAS, ANUIDADES, ETC...). AS VPA DE ATIVIDADES AUXILIARES, DE APOIO OU DERIVADAS DOS SERVICOS EDUCACIONAIS PROPRIAMENTE DITOS, DEVEM SER CLASSIFICADAS NOS TITULOS APROPRIADOS. EXEMPLOS: MATRICULAS E ANUIDADES, SERVICOS EDUCACIONAIS, TAXAS DE  EXPEDICAO DE DOCUMENTOS, COPIAS XEROGRAFICAS, HELIOGRAFICAS, ETC.., SERVICO DE CREDENCIAMENTO, AUTORIZACAO E RECONHECIMENTO DE CURSOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.22.00.00.00.00','SERVICOS AGROPECUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS AGROPECUARIO: A)PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO, ARACAO, GRADEACAO, CALAGEM, ADUBACAO, DRENAGEM, IRRIGACAO, CAPINA, DESMATAMENTO, ETC.);  B)SEMEADURA E PLANTIO; C)COMBATE A PRAGAS (PULVERIZACAO, DEDETIZACAO);  D)COLHEITA E PREPARACAO DE PRODUTOS AGRICOLAS; E)INSEMINACAO ARTIFICIAL; F)INCUBACAO DE OVOS; G)VACINACAO DE ANIMAIS; H)OUTROS SERVICOS AUXILIARES DE AGRICULTURA E PECUARIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.23.00.00.00.00','SERVICOS DE REPARACAO,MANUTENCAO E INSTALACAO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE  REPARACAO, MANUTENCAO E INSTALACAO PRESTADOS. VPA DE SERVICOS DE REPARACAO DE ARTEFATOS DE METAL; REPARACAO E MANUTENCAO DE MAQUINAS E APARELHOS DE USO DOMESTICO; REPARACAO, MANUTENCAO E INSTALACAO DE  MAQUINAS E APARELHOS ELETRICOS E ELETRONICOS E DE COMUNICACAO; REPARACAO  E MANUTENCAO DE INSTALACOES ELETRICAS, DE GAS, DE AGUA, ETC...INCLUEM-SE TAMBEM, NESSE TITULO, OS SERVICOS DE CONFECCAO SOB MEDIDA. NAO SAO CONSIDERADOS NESSE TITULO, CLASSIFICANDO-SE EM VPA INDUSTRIAL: REPARACAO E MANUTENCAO DE VEICULOS FERROVIARIOS, EMBARCACOES E   AERONAVES (INDUSTRIA DE MATERIAL DE TRANSPORTE).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.24.00.00.00.00','SERVICOS RECREATIVOS E CULTURAIS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS RECREATIVOS E CULTURAIS PRESTADOS. VPA PROPORCIONADA PELA EXPLORACAO    DE INSTALACOES PARA RECREACAO, PRATICA DESPORTIVA E CULTURAL (CINEMAS, TEATROS, SALOES PARA RECITAIS, CONCERTOS, CONFERENCIAS, PLANETARIOS, ESTADIOS DESPORTIVOS, AUTODROMOS, MUSEUS, BIBLIOTECAS, PROMOCAO E/OU PRODUCAO DE ESPETACULOS ARTISTICOS CULTURAIS E ESPORTIVOS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.25.00.00.00.00','SERVICOS DE FORNECIMENTO DE AGUA','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS  PRESTADOS DE FORNECIMENTO DE AGUA AOS IRRIGANTES A AMORTIZACAO DOS INVESTIMENTOS DA INFRA-ESTRUTURA DE IRRIGACAO DOS PROJETOS PUBLICOS. INCLUSIVE DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.26.00.00.00.00','SERVICOS DE PERFURACAO E INSTALACAO DE POCOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS  PRESTADOS DE PERFURACAO EINSTALACAO DE POCOS TUBULARES PROFUNDOS, POCOS ARTESIANOS OU   SIMILARES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.27.00.00.00.00','SERVICOS DE GEOPROCESSAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS A TERCEIROS DE INTERPRETACAO DE IMAGEM AERO FOTOGRAMETRICA, EXECUCAO DE MAPAS DIGITALIZADOS DIVERSOS, VENDA DE CARTAS E IMAGENS DE SATELITES, VIDEOGRAFICAS E SIMILARES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.28.00.00.00.00','SERVICOS DE CADASTRAMENTO DE FORNECEDORES','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE CADASTRAMENTO DE EMPRESAS FORNECEDORAS DE BENS  E SERVICOS AO GOVERNO FEDERAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.29.00.00.00.00','TARIFAS DE INSCRIÇÃO EM CONCURSOS E PROCESSOS SELETIVOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE TARIFAS DE INSCRICAO EM CONCURSOS E PROCESSOS SELETIVOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.30.00.00.00.00','SERVICOS VETERINARIOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS VETERINARIOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.31.00.00.00.00','SERVICOS FINANCEIROS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM SERVICOS FINANCEIROS TAIS COMO: SERVICOS DE REMUNERACAO SOBRE REPASSE PARA PROGRAMAS DE DESENVOLVIMENTO ECONOMICO, COMISSOES PELA PRESTACAO  DE GARANTIA, SERVICOS FINANCEIROS DE GARANTIA DA ATIVIDADE AGROPECUARIA, SERVIÇOS FINANCEIROS PROVENIENTES DA EXECUÇÃO DE GARANTIA - OPERAÇÕES DE CREDITO INTERNA, SERVIÇOS FINANCEIROS PROVENIENTES DA EXECUÇÃO DE GARANTIA - OPERAÇÕES DE CREDITO EXTERNAS BEM COMO OUTROS SERVICOS FINANCEIROS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.32.00.00.00.00','SERVICOS COMERCIAIS','REGISTRA A VPA DE SERVICOS COMERCIAIS E FINANCEIRAS ORIUNDAS DAS ATIVIDADES DO COMERCIO VAREJISTA E ATACADISTA, OU SEJA, OPERACOES DE REVENDA DE MERCADORIAS PARA CONSUMO, USO PESSOAL OU USO DOMESTICO, BEM COMO A REVENDA DE MERCADORIAS A COMERCIANTES VAREJISTAS, A CONSUMIDORES INDUSTRIAIS, A INSTITUICOES, PROFISSIONAIS    E OUTROS COMERCIANTES ATACADISTAS. ABRANGE TAMBEM OS  SERVICOS AUXILIARES DE COMERCIO: AGENTES, CORRETORES E INTERMEDIARIOS DE VENDA DE MERCADORIAS A BASE DE COMISSAO. NAO ESTAO INCLUIDAS AS VPA ORIUNDAS DA VENDA DE MERCADORIAS QUE TENHAM SOFRIDO PROCESSO    DE TRANSFORMACAO NO PROPRIO ESTABELECIMENTO, AS QUAIS DEVERAO SER CLASSIFICADAS EM VPA DA INDUSTRIA DE TRANSFORMACAO. EX: COMERCIALIZACAO DE MEDICAMENTOS, COMERCIALIZACAO DE LIVROS, PERIODICOS, MATERIAIS ESCOLARES  E PUBLICIDADE, COMERCIALIZACAO E DISTRIBUICAO DE  PRODUTOS  AGROPECUARIOS, COMERCIALIZACAO DE PRODUTOS, DADOS E MATERIAIS DE INFORMATICA ALÉM DE OUTROS SERVICOS COMERCIAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.33.00.00.00.00','SERVIÇOS AGROPECUARIOS','REGISTRA O VALOR TOTAL DA VPA COM SERVICOS AGROPECUARIO TAIS COMO: PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO, ARACAO, GRADEACAO, CALAGEM, ADUBACAO, DRENAGEM, IRRIGACAO, CAPINA, DESMATAMENTO, ETC.); SEMEADURA E PLANTIO; COMBATE A PRAGAS (PULVERIZACAO, DEDETIZACAO); COLHEITA E PREPARACAO DE PRODUTOS AGRICOLAS; INSEMINACAO ARTIFICIAL; INCUBACAO DE OVOS; VACINACAO DE ANIMAIS; OUTROS SERVICOS AUXILIARES DE AGRICULTURA E PECUARIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.34.00.00.00.00','SERVIÇO INDUSTRIAL','REGISTRA O VALOR TOTAL DA VPA DA INDÚSTRIA DE EXTRAÇÃO MINERAL, SERVIÇO DA INDUSTRIA DE TRANSFORMACAO, SERVIÇO DA INDUSTRIA DE CONSTRUCAO E OUTROS, PROVENIENTES DAS ATIVIDADES INDUSTRIAIS DEFINIDAS COMO TAIS PELA FUNDAÇÃO INSTITUTO BRASILEIRO DE GEOGRAFIA E ESTATÍSTICA - IBGE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.35.00.00.00.00','SERVICOS DE CAPTACAO, ADUCAO, TRATAMENTO, RESERVACAO E DISTRIBUICAO DE AGUA','REGISTRA O VALOR DA VPA DE SERVIÇOS PRESTADOS A USUÁRIOS PELO FORNECIMENTO DE ÁGUA POTÁVEL REPRESENTADOS PELO CONSUMO AUFERIDO QUANDO DA UTILIZAÇÃO DO SERVIÇO A DISPOSIÇÃO DO PROPRIETÁRIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.36.00.00.00.00','SERVICOS DE COLETA, TRANSPORTE, TRATAMENTO E DESTINO FINAL DE ESGOTOS','REGISTRA O VALOR DA VPA DE SERVIÇOS PRESTADOS A USUÁRIOS BENEFICIADOS COM ESGOTAMENTO SANITÁRIO REPRESENTADOS PELO CONSUMO AUFERIDO QUANDO DA UTILIZAÇÃO DO SERVIÇO A DISPOSIÇÃO DO PROPRIETÁRIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.37.00.00.00.00','SERVICOS DE COLETA, TRANSPORTE, TRATAMENTO E DESTINO FINAL DE RESIDUOS SOLIDOS','REGISTRA O VALOR DA VPA DE SERVIÇOS COM A COLETA, TRANSPORTE, TRATAMENTO E DESTINO FINAL DE RESÍDUOS SÓLIDOS REPRESENTADOS PELO CONSUMO AUFERIDO QUANDO DA UTILIZAÇÃO DO SERVIÇO A DISPOSIÇÃO DO PROPRIETÁRIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.38.00.00.00.00','SERVICOS DE ABATE DE ANIMAIS','REGISTRA O VALOR DA VPA DE SERVIÇOS DE ABATE DE ANIMAIS PRATICADOS POR MATADOURO MUNICIPAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.39.00.00.00.00','SERVICOS DE PREPARACAO DA TERRA EM PROPRIEDADES PARTICULARES','REGISTRA O VALOR DA VPA DE SERVIÇOS DE PREPARAÇÃO DA TERRA EM PROPRIEDADES PARTICULARES, INCLUSIVE COLHEITA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.40.00.00.00.00','SERVICOS DE CEMITERIO','REGISTRA O VALOR DA VPA DE SERVIÇOS DE CONSTRUÇÃO E LIMPEZA DE TÚMULOS PERPÉTUOS E OUTROS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.41.00.00.00.00','SERVICOS DE ILUMINACAO PUBLICA','REGISTRA O VALOR DA VPA DE SERVIÇOS DE ILUMINAÇÃO PÚBLICA REPRESENTADO PELO CONSUMO AUFERIDO QUANDO DA UTILIZAÇÃO DO SERVIÇO A DISPOSIÇÃO DO PROPRIETÁRIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.42.00.00.00.00','SERVICOS DE RELIGAMENTO DE AGUA','REGISTRA O VALOR DA VPA DE SERVIÇOS DE RELIGAMENTO DE ÁGUA, OCASIONADOS POR CORTE DE FORNECIMENTO EM FUNÇÃO DO NÃO PAGAMENTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.43.00.00.00.00','SERVICO DE INFORMACOES ESTATISTICAS','REGISTRA O VALOR TOTAL DA VPA PROVENIENTE DA PRESTAÇÃO DE SERVIÇOS DE INFORMAÇÕES ESTATÍSTICAS, FORNECIDAS A ENTIDADES PÚBLICAS OU PRIVADAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.44.00.00.00.00','SERVICO DE MAQUINAS','REGISTRA O VALOR DA ARRECADAÇÃO PROVENIENTE DO SERVIÇO DE MÁQUINA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.45.00.00.00.00','SERVICO DE PAVIMENTACAO E REPAVIMENTACAO','REGISTRA O VALOR DA ARRECADAÇÃO PROVENIENTE DO SERVIÇO DE PAVIMENTAÇÃO E REPAVIMENTAÇÃO','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.46.00.00.00.00','SERVICOS DE LIGACAO DE AGUA E ESGOTO','REGISTRA O VALOR DA ARRECADAÇÃO PROVENIENTE DO SERVIÇO DE LIGAÇÃO DE ÁGUA E ESGOTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.47.00.00.00.00','SERVICOS RELATIVOS A EVENTOS EDUCACIONAIS','REGISTRA O VALOR DA ARRECADAÇÃO PROVENIENTE DO SERVIÇOS RELATIVOS A EVENTOS EDUCACIONAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.99.00.00.00.00','OUTROS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.9.0.00.00.00.00.00','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as deduções das prestações de serviços, como devoluções, abatimentos e descontos comerciais concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.9.1.00.00.00.00.00','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Compreende as deduções das prestações de serviços, como devoluções, abatimentos e descontos comerciais concedidos.     Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.0.0.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS FINANCEIRAS','Compreende o somatório das variações patrimoniais aumentativas com operações financeiras. Compreende: descontos obtidos, juros auferidos, prêmio de resgate de títulos e debêntures, entre outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.0.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas provenientes de juros e encargos de empréstimos e financiamentos concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.1.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.3.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.4.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS -ESTADO','Registra as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.5.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.2.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos externos concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.2.1.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos externos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.0.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.1.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.3.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.4.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.5.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.4.0.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos externos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.4.1.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos externos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.0.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA','Compreende as variações patrimoniais aumentativas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação representando o resultado das aplicações impostas ao contribuinte.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.3.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.4.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.5.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.2.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos externos concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.2.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos externos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a fornecimento de bens e serviços.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a fornecimento de bens e serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.02.00.00.00.00','MULTAS E JUROS DE MORA DE ALUGUEIS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLIC. ATRAS. PAGAMEN. DE ALUGUEIS DEVIDOS POR USO  DO PATRIMONIO IMOBILIARIO DO MUNICIPIO, DECORRENTES DE CLAUSULAS  CONTRATUAIS PACTUADAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.03.00.00.00.00','MULTAS E JUROS DE MORA DE ARRENDAMENTOS','REGISTRA A VPA PROVENIENTE DE MUL.JUR. MORA APLIC.P/ ATRAS. NO PAGAMENTO DE RENDAS DEVIDAS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO SOB A FORMA DE ARRENDAMENTO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.04.00.00.00.00','MULTAS E JUROS DE MORA DE LAUDEMIOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA ATRASOS NOS RECOLHIMEN. DAS DIFERENCAS DE LAUDEMIOS, GERADAS ANTES DA EDICAO DA M.P NUM 1647 - 14, DE 24 DE MARCO DE 1998, DE ACORDO COM O PREVISTO NO ART. 5. DO DECRETO NUM. 95.760, DE 01 DE MARCO DE 1988.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.05.00.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DO PROGRAMA TROCA-TROCA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DO PROGRAMA TROCA-TROCA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.06.00.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DA PRESTACAO DE SERVICOS','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DA PRESTAÇÃO DE SERVIÇOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.07.00.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DOS AUTOS DE INFRACAO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DOS AUTOS DE INFRAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.99.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS','Compreende a variação patrimonial aumentativa com juros e encargos a titulo de penalidade aplicada em virtude de atrasos e não cumprimento dos prazos de créditos tributários.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa com juros e encargos a titulo de penalidade aplicada em virtude de atrasos e não cumprimento dos prazos de créditos tributários. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.01.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE IMPOSTOS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA COM JUROS E ENCARGOS  A TITULO DE PENALIDADE APLICADA EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS IMPOSTOS DEVIDOS PELOS CONTRIBUINTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.01.01.00.00.00','MULTAS  E JUROS DE MORA DO IMPOSTO SOBRE A RENDA RETIDO NAS FONTES - IRRF','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A   MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRITUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO  CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.01.02.00.00.00','MULTA E JUROS DE MORA DO ITR MUNICIPIOS CONVENIADOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO  CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTE   REFERENTES AO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.01.03.00.00.00','MULTAS E JUROS DE MORA DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA - IPTU','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL URBANA - IPTU.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.01.04.00.00.00','MULTAS E JUROS DE MORA DO IMPOSTO SOBRE A TRANSMISSAO INTER-VIVOS DE BENS IMOVEIS - ITBI','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA DO IMPOSTO SOBRE A TRANSMISSÃO INTER-VIVOS DE BENS IMÓVEIS - ITBI.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.01.05.00.00.00','MULTAS E JUROS DE MORA DO IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA - ISS','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA DO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA- ISS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.02.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE AS TAXAS','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA DAS TAXAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.02.01.00.00.00','MULTAS E JUROS DE MORA DA TAXA DE FISCALIZACAO E VIGILANCIA  SANITARIA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.03.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE AS CONTRIBUICOES DE MELHORIA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS E JUROS DE MORA DAS CONTRIBUIÇÕES DE MELHORIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.04.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE A DIVIDA ATIVA DOS IMPOSTOS','REGISTRA O VALOR TOTAL DA VPA DE MULTAS E JUROS DE MORA INCIDENTES SOBRE A DÍVIDA ATIVA DOS IMPOSTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.04.01.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA RETIDO NA FONTE','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COM A FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA - RETIDO NAS FONTES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.04.02.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIO CONVENIADO','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS  PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE   A DIVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIO CONVENIADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.04.03.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA - IPTU','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA INCIDENTE SOBRE A DÍVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA - IPTU.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.04.04.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DO IMPOSTO SOBRE A TRANSMISSAO INTER-VIVOS DE BENS IMOVEIS - ITBI','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA INCIDENTE SOBRE A DÍVIDA ATIVA DO IMPOSTO SOBRE A TRANSMISSÃO INTER-VIVOS DE BENS IMÓVEIS - ITBI.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.04.05.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DO IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA - ISS','REGISTRA O VALOR DA ARRECADAÇÃO DE VPAS DE MULTAS E JUROS DE MORA INCIDENTE SOBRE A DÍVIDA ATIVA DO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA - ISS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.05.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE A DIVIDA ATIVA DAS TAXAS','REGISTRA O VALOR TOTAL DA VPA DE MULTAS E JUROS DE MORA INCIDENTES SOBRE A DÍVIDA ATIVA DAS TAXAS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.05.01.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DA TAXA DE FISCALIZACAO E VIGILANCIA SANITARIA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPAS DE MULTAS E JUROS DE MORA INCIDENTE SOBRE A DÍVIDA ATIVA DA TAXA DE FISCALIZAÇÃO E VIGILÂNCIA SANITÁRIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.06.00.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DAS CONTRIBUICOES DE MELHORIA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPAS DE MULTAS E JUROS DE MORA INCIDENTES SOBRE A DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.07.00.00.00.00','MULTA E JUROS MORA DA CONTRIBUIÇÃO DO SERVIDOR PARA O RPPS','REGISTRA A  VARIACAO PATRIMONIAL AUMENTATIVAS PROVENIENTES DE MULTA E JUROS MORA DA CONTRIBUIÇÃO DO SERVIDOR PARA O RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.96.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE OUTROS CREDITOS TRIBUTARIOS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE OUTRAS CREDITOS TRIBUTARIOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.96.01.00.00.00','JUROS E ENCARGOS DE MORA SOBRE OUTROS TRIBUTOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE OUTROS TRIBUTOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.96.02.00.00.00','JUROS E ENCARGOS DE MORA SOBRE DIVIDA ATIVA DE OUTROS TRIBUTOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE DIVIDA ATIVA DE OUTROS TRIBUTOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.97.00.00.00.00','(-) DEDUCOES DOS JUROS E ENCARGOS DE MORA SOBRE  CREDITOS TRIBUTARIOS','REGISTRA  AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS JUROS E ENCARGOS DE MORA SOBRE  CREDITOS TRIBUTARIOS INCLUSIVE DIVIDA ATIVA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.0.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA','Compreende as outras variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.1.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','Compreende as outras variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.1.01.00.00.00.00','MULTAS E JUROS DE MORA DA ALIENACAO DE DOMINIO UTIL','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS JUROS DE MORA ALIEN. DOM.UTIL. MULTAS APLICADAS POR ATRASOS NO RECOLHIMENTO DE PARCELAS REFERENTES  A AQUISICAO DE DOMINIO UTIL DE TERRENOS DA UNIAO, DE ACORDO COM O   PREVISTO NO ARTIGO 4 DO DECRETO-LEI NUM 1561, DE 13 DE JULHO DE 1977    E ARTIGOS 25 A 27 DA MP NUM. 1647-14, DE 24 DE FEVEREIRO DE 1998.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.1.02.00.00.00.00','MULTAS E JUROS DE MORA DA  ALIENAÇÃO DE OUTROS BENS IMOVEIS','REGISTRA  A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE ALIEN. DE OUTROS BENS IMOVEIS. MULTAS APLICADAS POR ATRASOS NOS RECOLHIMENTOS DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL OU PLENO DE IMOVEIS DA UNIAO, DE ACORDO COM O PREVISTO NOS ARTIGOS 25 A 27 DA MP NUM. 1647-14 DE 24 DE MARCO DE 1998.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.1.04.00.00.00.00','MULTAS E JUROS DE MORA DE DIVIDENDOS','REGISTRA  A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA  APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE DIVIDENDOS DEVIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.1.05.00.00.00.00','MULTAS E JUROS DE MORA DE PARTICIPACOES','REGISTRA  A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA  APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE  PARTICIPACOES DEVIDAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.1.99.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE OUTROS JUROS E ENCARGOS DE MORA','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.0.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.1.01.00.00.00.00','VARIAÇÕES MONETARIAS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE  UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.1.02.00.00.00.00','VARIAÇÕES CAMBIAIS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRÉSTIMOS CONCEDIDOS.  COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE  UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.3.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.3.01.00.00.00.00','VARIAÇÕES MONETARIAS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE  UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.3.02.00.00.00.00','VARIAÇÕES CAMBIAIS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRÉSTIMOS CONCEDIDOS.  COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE  UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.4.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.4.01.00.00.00.00','VARIAÇÕES MONETARIAS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE  UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.4.02.00.00.00.00','VARIAÇÕES CAMBIAIS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRÉSTIMOS CONCEDIDOS.  COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE  UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.5.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.2.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.2.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.1.01.00.00.00.00','VARIAÇÕES MONETARIAS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO FINANCIAMENTOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.1.02.00.00.00.00','VARIAÇÕES CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO FINANCIAMENTOS CONCEDIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.3.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.4.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.5.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.4.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.4.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.0.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nos moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.1.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.1.01.00.00.00.00','OUTRAS VARIAÇÕES MONETARIAS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.1.02.00.00.00.00','OUTRAS VARIAÇÕES CAMBIAIS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.3.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - UNIÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.4.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - ESTADO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.5.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.4.0.0.00.00.00.00.00','DESCONTOS FINANCEIROS OBTIDOS','Compreende a variação patrimonial aumentativa decorrente de descontos financeiros obtidos em virtude de liquidação antecipada de obrigações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.4.0.1.00.00.00.00.00','DESCONTOS FINANCEIROS OBTIDOS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa decorrente de descontos financeiros obtidos em virtude de liquidação antecipada de obrigações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.0.0.00.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS E APLICAÇÕES FINANCEIRAS','Compreende o valor total das variações patrimoniais aumentativas decorrentes da remuneração do saldo diário dos depósitos da União existentes no banco central, bem como aplicação de recursos da conta única de acordo com a rentabilidade media intrínseca dos títulos do tesouro.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.0.00.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS','Compreende a variação patrimonial aumentativa decorrente da remuneração dos depósitos bancários do ente existentes no agente financeiro.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.00.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa decorrente da remuneração dos depósitos bancários do ente existentes no agente financeiro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.01.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS DE RECURSOS VINCULADOS','REGISTRA O VALOR DA VPA PROVENIENTE DA REMUNERAÇÃO DE DEPOSITOS BANCARIOS DE RECURSOS VINCULADOS, TAIS COMO: ROYALTIES, FUNDEB, FUNDO DE SAÚDE, REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL DOS SERVIDORES, MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO, AÇÕES E SERVIÇOS PÚBLICOS DE SAÚDE (ASPS), FUNDETUR, ETC.DA REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS VINCULADOS, TAIS COMO: ROYALTIES, FUNDEB, FUNDO DE SAÚDE, REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL DOS SERVIDORES, MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO, ASPS, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.02.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS DE RECURSOS NÃO VINCULADOS','REGISTRA O VALOR DA VPA PROVENIENTE DA REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS DE RECURSOS NÃO VINCULADOS, INCLUSIVE RECURSOS PRÓPRIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.03.00.00.00.00','REMUNERAÇÃO DOS INVESTIMENTOS DO REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL','REGISTRA O SOMATÓRIO DAS VPAS DECORRENTES DE REMUNERAÇÃO DA CARTEIRA DE INVESTIMENTOS DOS RPPS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.96.00.00.00.00','REMUNERACAO DE OUTROS DEPOSITOS BANCARIOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DA REMUNERACAO DE OUTROS DEPOSITOS BANCARIOS DO ENTE EXISTENTES NO AGENTE FINANCEIRO NÃO RELACIONADOS NAS CONTAS ACIMA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.97.00.00.00.00','(-) DEDUÇÃO DA REMUNERACAO DE DEPOSITOS BANCARIOS','REGISTRA AS DEDUÇÕES DE VPA OCORRIDAS NAS CONTAS ACIMA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.0.00.00.00.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS','Compreende a variação patrimonial aumentativa proveniente da remuneração de depósitos bancários, recursos oriundos de aplicações de entidades da administração pública no mercado financeiro, autorizadas por lei, em caderneta de poupança, fundo de investimento, contas remuneradas e outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.00.00.00.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente da remuneração de depósitos bancários, recursos oriundos de aplicações de entidades da administração pública no mercado financeiro, autorizadas por lei, em caderneta de poupança, fundo de investimento, contas remuneradas e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.01.00.00.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS VINCULADOS','REGISTRA O VALOR DA VPA PROVENIENTE DA REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS VINCULADOS, TAIS COMO: ROYALTIES, FUNDEB, FUNDO DE SAÚDE, REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL DOS SERVIDORES, MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO, AÇÕES E SERVIÇOS PÚBLICOS DE SAÚDE (ASPS), FUNDETUR, ETC.DA REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS VINCULADOS, TAIS COMO: ROYALTIES, FUNDEB, FUNDO DE SAÚDE, REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL DOS SERVIDORES, MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO, ASPS, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.02.00.00.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS NÃO VINCULADOS','REGISTRA O VALOR DA VPA PROVENIENTE DA REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS NÃO VINCULADOS, INCLUSIVE RECURSOS PRÓPRIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.03.00.00.00.00','REMUNERAÇÃO DOS INVESTIMENTOS DO REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL','REGISTRA O VALOR DA VPA DECORRENTES DE REMUNERAÇÃO DA CARTEIRA DE INVESTIMENTOS DOS RPPS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.96.00.00.00.00','REMUNERACAO DE OUTRAS APLICAÇÕES FINANCEIRAS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DA REMUNERACAO DE OUTRAS APLICAÇÕES FINANCEIRAS DO ENTE EXISTENTES NO AGENTE FINANCEIRO NÃO RELACIONADOS NAS CONTAS ACIMA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.97.00.00.00.00','(-) DEDUÇÃO DA REMUNERACAO DE APLICAÇÕES FINANCEIRAS','REGISTRA AS DEDUÇÕES DE VPA OCORRIDAS NAS CONTAS ACIMA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.9.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS','Compreende as variações patrimoniais aumentativas provenientes de operações financeiras não compreendidas nos subgrupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.9.0.1.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de operações financeiras não compreendidas nos subgrupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.0.0.0.00.00.00.00.00','TRANSFERÊNCIAS E DELEGAÇÕES RECEBIDAS','Compreende o somatório das variações patrimoniais aumentativas com transferências inter governamentais, transferências intragovernamentais, transferências de instituições multigovernamentais, transferências de instituições privadas com ou sem fins lucrativos, transferências de convênios, transferências do exterior e execuções orçamentárias delegadas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.0.0.00.00.00.00.00','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras relativas à execução orçamentária, e de bens e valores, referentes às transações intragovernamentais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.0.00.00.00.00.00','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras recebidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Inclui também o valor repassado para a cobertura do déficit financeiro do RPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.00.00.00.00.00','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','Compreende o valor das transferências financeiras recebidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Inclui também o valor repassado para a cobertura do déficit financeiro do RPPS. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.00.00.00.00','TRANSFERENCIAS RECEBIDAS - COM EXECUCAO ORCAMENTARIA','COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS RECEBIDAS E CORRESPONDENCIA DE DEBITOS EM VIRTUDE DA EXECUCAO ORCAMENTARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.01.00.00.00','COTA RECEBIDA','REGISTRA O VALOR DOS RECURSOS RECEBIDOS PELA  ADMINISTRACAO DIRETA DECORRENTES DA PROGRAMACAO FINANCEIRA CORRESPONDENTE AO ORCAMENTO ANUAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.02.00.00.00','REPASSE RECEBIDO','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA, CORRESPONDENTES AO ORCAMENTO ANUAL .','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.02.01.00.00','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE  TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.02.01.01.00','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE - RECURSO LIVRE','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE  TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA. COM RECURSOS LIVRES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.02.01.02.00','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE - RECURSO MDE','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE  TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA. COM RECURSOS DA MDE','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.02.01.03.00','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE - RECURSO DAS ASPS','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE  TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA. COM RECURSOS DAS ASPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.02.01.04.00','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE - DEMAIS RECURSOS VINCULADOS','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE  TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA. COM OS DEMAIS RECURSOS VINCULADOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.03.00.00.00','SUB-REPASSE RECEBIDO','REGISTRA O VALOR DOS SUB-REPASSES RECEBIDOS NO EXERCICIO,  DECORRENTES DE TRANSFERENCIAS ENTRE UGZS DO MESMO ORGAO, CORRESPONDENTE AO ORCAMENTO ANUAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.05.00.00.00','VALORES DIFERIDOS - BAIXA - COTA DIFERIDA','REGISTRA O VALOR DA COTA DIFERIDA NO PROCESSO DE INSCRICAO E BAIXA DOS RECURSOS DIFERIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.06.00.00.00','VALORES DIFERIDOS - BAIXA - REPASSE DIFERIDO','REGISTRA O VALOR DOS RECURSOS DE REPASSE DIFERIDO DECORRENTES DO PROCESSO DE INSCRICAO/BAIXA DE RECURSOS DIFERIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.07.00.00.00','VALORES DIFERIDOS - BAIXA - SUB-REPASSE DIFERIDO','REGISTRA A APROPRIACAO DO VALOR REFERENTE AO SUB-REPASSE CONCEDIDO ENTRE AS UGS DA ADMINISTRACAO DIRETA OU INDIRETA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.08.00.00.00','VALORES DIFERIDOS - INSCRICAO - COTA DIFERIDA - INSCRICAO','REGISTRA O VALOR DA COTA DIFERIDA NO PROCESSO DE INSCRICAO DOS RECURSOS DIFERIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.09.00.00.00','VALORES DIFERIDOS - INSCRICAO - REPASSE DIFERIDO - INSCRICAO','REGISTRA O VALOR DOS RECURSOS DE REPASSE DIFERIDO DECORRENTES DO PROCESSO DE INSCRICAO DE RECURSOS DIFERIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.10.00.00.00','VALORES DIFERIDOS - INSCRICAO - SUB-REPASSE DIFERIDO - INSCRICAO','REGISTRA A APROPRIACAO DO VALOR REFERENTE AO SUB-REPASSE CONCEDIDO ENTRE AS UGS DA ADMINISTRACAO DIRETA OU INDIRETA POR OCASIAO DA  INSCRICAO DOS VALORES DIRERIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.11.00.00.00','APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO - REPASSE PARA COBERTURA DE INSUFICIENCIAS FINANCEIRAS','REGISTRA OS RECURSOS ORCAMENTARIOS EFETIVAMENTE UTILIZADOS PARA COBERTURA DE INSUFICIENCIAS FINANCEIRAS ENTRE AS RECEITAS E DESPESAS PREVIDENCIARIAS, NO EXERCICIO DE REFERENCIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.12.00.00.00','APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO - REPASSE PREVIDENCIARIO PARA FORMACAO DE RESERVA','REGISTRA O MONTANTE DOS RECURSOS RECEBIDOS DO PROPRIO ENTE PARA FORMACAO  DE  RESERVA ESPONTANEA PARA FUTUROS PAGAMENTOS DE BENEFICIOS DO PLANO FINANCEIRO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.13.00.00.00','APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO - OUTROS APORTES PARA O RPPS','REGISTRA O SOMATORIO DOS RECEBIMENTOS DE EVENTUAIS APORTES DE RECURSOS PARA O REGIME PROPRIO DE PREVIDENCIA DO SERVIDOR - RPPS, PARA OUTRAS NECESSIDADES FINANCEIRAS QUE NAO A COBERTURA DE INSUFICIENCIAS  FINANCEIRAS E FORMACAO DE RESERVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.14.00.00.00','APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDENCIARIO - REPASSE PARA COBERTURA DE DEFICIT FINANCEIRO','REGISTRA O MONTANTE DOS RECURSOS RECEBIDOS DO PROPRIO ENTE, NECESSARIOS AO EQUILIBRIO FINANCEIRO DO PLANO PREVIDENCIARIO, OU SEJA, A COBERTURA DE DEFICIT ENTRE AS RECEITAS E AS DESPESAS PREVIDENCIARIAS, REFERENTES AO EXERCICIO ATUAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.15.00.00.00','APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDENCIARIO - REPASSE PARA COBERTURA DE DEFICIT ATUARIAL','REGISTRA O MONTANTE DOS RECURSOS ORCAMENTARIOS ALOCADOS P/ COBERTURA DE DEFICIT ATUARIAL NO EXERCICIO DE REFERENCIA, CUJO OBJETIVO E GARANTIR A EQUIVALENCIA, A VALOR PRESENTE, ENTRE O FLUXO DE RECEITAS  ESTIMADAS  E  DAS OBRIGACOES PROJETADAS, APURADAS  ATUARIALMENTE, EM LONGO PRAZO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.16.00.00.00','APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDENCIARIO - OUTROS APORTES PARA O RPPS','REGISTRA OUTROS APORTES FINANCEIROS PARA O REGIME PROPRIO DE PREVIDENCIA DO SERVIDOR PUBLICO - RPPS, TAIS COMO CAPITALIZACOES DO REGIME.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.97.00.00.00.00','(-) DEDUÇÕES DAS TRANSFERENCIAS INTRA GOVERNAMENTAIS','REGISTRA AS DEDUÇÕES DAS VPA DE TRANSFERENCIA INTRA GOVERNAMENTAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.2.0.00.00.00.00.00','TRANSFERÊNCIAS RECEBIDAS INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras, de bens ou valores recebidas para restos a pagar e outras finalidades independentes da execução orçamentária.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.2.2.00.00.00.00.00','TRANSFERÊNCIAS RECEBIDAS INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','Compreende o valor das transferências financeiras de bens ou valores recebidas para restos a pagar e outras finalidades independentes da execução orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.2.2.02.00.00.00.00','TRANSFERENCIAS RECEBIDAS - INDEPENDENTE DE EXECUCAO ORCAMENTARIA','COMPREENDE AS TRANSFERENCIAS FINANCEIRAS PARA RESTOS A PAGAR E OUTROS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.2.2.02.01.00.00.00','ORDEM TRANSFERENCIAS RECEBIDAS','REGISTRA O VALOR DA TRANSFERENCIA DE OTR`S LIBERADAS PELAS   SETORIAIS DE PROGRAMACAO FINANCEIRA DE CADA ORGAO PARA SUAS SUBORDINADAS,  NAO VINCULADAS AO ORCAMENTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.2.2.02.02.00.00.00','RECEBIMENTO DE TRANSFERENCIAS CONCEDIDAS','REGISTRA O VALOR DOS RECEBIMENTOS REFERENTES A RESTOS A PAGAR, QUE FORAM DEVOLVIDOS PELAS UG BENEFICIARIAS, QUE NAO FORAM UTILIZADOS OU UTILIZADOS PARCIALMENTE, SEM O RESTABELECIMENTO DA OBRIGACAO CORRESPONDENTE AO LIMITE DE RP .','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.2.2.97.00.00.00.00','(-) DEDUÇÕES DAS TRANSFERENCIAS INTRA GOVERNAMENTAIS','REGISTRA AS DEDUÇÕES DAS VPA DE TRANSFERENCIA INTRA GOVERNAMENTAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.3.0.00.00.00.00.00','TRANSFERENCIAS RECEBIDAS PARA COBERTURA DO DÉFICIT ATUARIAL DO RPPS POR APORTE PERIÓDICO','Compreende o valor das transferências financeiras para aportes periódicos destinados à cobertura do déficit atuarial do Regime Próprio de Previdência Social  - RPPS, conforme plano de amortização estabelecido em lei do respectivo ente Federativo, exceto as decorrentes de alíquota de contribuição suplementar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.3.2.00.00.00.00.00','TRANSFERENCIAS RECEBIDAS PARA COBERTURA DO DÉFICIT ATUARIAL DO RPPS POR APORTE PERIÓDICO - INTRA OFSS','Compreende o valor das transferências financeiras para aportes periódicos destinados à cobertura do déficit atuarial do Regime Próprio de Previdência Social  - RPPS, conforme plano de amortização estabelecido em lei do respectivo ente Federativo, exceto as decorrentes de alíquota de contribuição suplementar. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.0.0.00.00.00.00.00','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','Compreendem as variações patrimoniais aumentativas decorrentes de transferências da União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.0.00.00.00.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS','Compreendem as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.1.00.00.00.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - CONSOLIDAÇÃO','Compreendem as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).  Por exemplo, empresa independente de um ente recebendo transferência de outro ente (a empresa independente não pertence ao OFSS mas pertence ao conceito de governamental).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.00.00.00.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS - UNIÃO','Compreendem as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.01.00.00.00.00','COTA-PARTE DO FUNDO DE PARTICIPACAO DOS MUNICIPIOS - FPM','REGISTRA O VALOR TOTAL DAS VPAS RECEBIDAS ATRAVÉS DE COTA-PARTE DO FUNDO DE PARTICIPAÇÃO DOS MUNICÍPIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.02.00.00.00.00','COTA-PARTE DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - ITR','REGISTRA O VALOR TOTAL DAS VPAS RECEBIDAS ATRAVÉS DE TRANSFERÊNCIAS DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.03.00.00.00.00','COTA-PARTE DO IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO OU RELATIVAS A TITULOS OU VALORES MOBILIARIOS - COMERCIALIZACAO DO OURO','REGISTRA O VALOR TOTAL DAS VPAS RECEBIDAS ATRAVÉS DE COTA-PARTE DO  IMPOSTO SOBRE OPERAÇÕES CRÉDITO CÂMBIO E SEGUROS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.04.00.00.00.00','TRANSFERENCIA DA COMPENSACAO FINANCEIRA PELA EXPLORACAO DE RECURSOS NATURAIS','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA COMPENSAÇÃO FINANCEIRA PELA EXPLORACAO DE RECURSOS NATURAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.05.00.00.00.00','TRANSFERENCIA DE RECURSOS DO SISTEMA UNICO DE SAUDE - SUS - REPASSE FUNDO A FUNDO','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS DO FUNDO NACIONAL DE SAUDE RECEBIDOS PELOS FUNDOS DE SAUDE DOS  ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS, REFERENTE AO SISTEMA ÚNICO DE SAÚDE - SUS,  (PISO DE ATENÇÃO BÁSICA - FIXO E VARIÁVEL, TRANSFERÊN','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.06.00.00.00.00','TRANSFERENCIAS DE RECURSOS DO FUNDO NACIONAL DE ASSISTENCIA SOCIAL - FNAS','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS DA UNIÃO RECEBIDOS PELOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS, REFERENTE AO FUNDO NACIONAL DE ASSISTÊNCIA SOCIAL - FNAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.07.00.00.00.00','TRANSFERENCIAS DE RECURSOS DO FUNDO NACIONAL DO DESENVOLVIMENTO DA EDUCACAO - FNDE','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS DA UNIÃO RECEBIDOS PELOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS, RELATIVOS AO FUNDO NACIONAL DO DESENVOLVIMENTO DA EDUCAÇÃO - FNDE, COMPREENDENDO OS REPASSES REFERENTES AO SALÁRIO-EDUCAÇÃO E DEMAIS PRO','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.08.00.00.00.00','TRANSFERENCIA FINANCEIRA DO ICMS - DESONERACAO - L.C. N° 87/96','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS DA UNIÃO AOS ESTADOS, DISTRITO FEDERAL E AOS MUNICÍPIOS, ATENDIDOS OS LIMITES, CRITÉRIOS, PRAZOS E DEMAIS CONDIÇÕES FIXADOS NO ANEXO A LEI COMPLEMENTAR Nº 87 DE 13/09/96, COM BASE NO PRODUTO DE ARRECAD','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.09.00.00.00.00','TRANSFERENCIA DA UNIAO PARA O ASPS','REGISTRA O VALOR DA TRANSFERÊNCIA RECEBIDA DA UNIÃO CONFORME O QUE DETERMINA O PARÁGRAFO 2° DO ART. 77 DO ADCT DA CF/88 COM A REDAÇÃO DADA PELA EC N° 29, PARA VINCULAÇÃO ESPECÍFICA  NO ATENDIMENTO DAS AÇÕES E SERVIÇOS PÚBLICOS DE SAÚDE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.10.00.00.00.00','TRANSFERENCIA DA UNIAO PARA O FUNDO MUNICIPAL DA CRIANCA E DO ADOLESCENTE','REGISTRA A VPA RECEBIDA DA UNIÃO REFERENTE A INCENTIVOS FISCAIS PREVISTOS NA LEGISLAÇÃO DO IMPOSTO DE RENDA, EM ATENDIMENTO AO ESTATUTO DA CRIANÇA E DO ADOLESCENTE - ECA, LEI N° 8069/90.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.11.00.00.00.00','TRANSFERENCIA DA UNIAO - PASEP','REGISTRA A VPA RECEBIDA DA UNIÃO REFERENTE AO PASEP.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.12.00.00.00.00','AUXÍLIO FINANCEIRO - ESFORÇO EXPORTADOR (MP N° 193/04)','REGISTRA O VALOR DA TRANSFERENCIA RECEBIDA DA UNIAO REFERENTE AO AUXILIO EXPORTADOR - CEX (REGISTRA O VALOR DA ARRECADAÇÃO DE RECEITA DE TRANSFERÊNCIA DA COMPENSAÇÃO FINANCEIRA.), INSTITUIDA PELA MEDIDA PROVISORIA 193.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.13.00.00.00.00','FPM - APOIO FINANCEIRO (MP 462/2009)','REGISTRA O VALOR DA PRESTAÇÃO DE APOIO FINANCEIRO PELA UNIÃO AOS ENTES FEDERADOS QUE RECEBEM RECURSOS DO FUNDO DE PARTICIPAÇÃO DOS MUNICÍPIOS - FPM, NO EXERCÍCIO DE 2009, COM O OBJETIVO DE SUPERAR DIFICULDADES FINANCEIRAS EMERGENCIAIS. SALIENTA-SE QUE ESS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.14.00.00.00.00','FPM - APOIO FINANCEIRO (MP 480/2010)','REGISTRA O VALOR DA PRESTAÇÃO DE APOIO FINANCEIRO PELA UNIÃO AOS ENTES FEDERADOS QUE RECEBEM RECURSOS DO FUNDO DE PARTICIPAÇÃO DOS MUNICÍPIOS - FPM, NO EXERCÍCIO DE 2010, COM O OBJETIVO DE SUPERAR DIFICULDADES FINANCEIRAS EMERGENCIAIS. SALIENTA-SE QUE ESS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.15.00.00.00.00','TRANSFERENCIAS DE CONVENIOS DA UNIAO E DE SUAS ENTIDADES','REGISTRA O VALOR TOTAL DOS RECURSOS ORIUNDOS DE CONVÊNIOS FIRMADOS, COM OU SEM CONTRAPRESTAÇÕES DE SERVIÇOS, COM A UNIÃO OU COM SUAS ENTIDADES, PARA REALIZAÇÃO DE OBJETIVOS DE INTERESSE COMUM DOS PARTÍCIPES, E DESTINADOS A CUSTEAR DESPESAS CORRENTES. EX: PARA O SISTEMA UNICO DE SAUDE - SUS, CONVENIOS DA UNIAO DESTINADAS A PROGRAMAS DE EDUCACAO, CONVENIOS DA UNIAO DESTINADAS A PROGRAMAS DE ASSISTENCIA SOCIAL, CONVENIOS DA UNIAO DESTINADAS A PROGRAMAS DE COMBATE A FOME, DESTINADAS A PROGRAMAS DE SANEAMENTO BASICO ALÉM DE OUTRAS TRANSFERENCIAS DE CONVENIOS DA UNIAO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.99.00.00.00.00','OUTRAS TRANSFERENCIAS DA UNIAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERENCIAS DA UNIAO AOS ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.97.00.00.00.00','(-) DEDUÇÕES DAS TRANSFERENCIAS INTER GOVERNAMENTAIS','REGISTRA AS DEDUÇÕES DAS VPA DE TRANSFERENCIA INTER GOVERNAMENTAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.00.00.00.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS - ESTADO','Compreendem as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.01.00.00.00.00','COTA-PARTE DO ICMS','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA PARTICIPAÇÃO DE MUNICÍPIOS NA ARRECADAÇÃO DO IMPOSTO SOBRE A CIRCULAÇÃO DE MERCADORIAS E PRESTAÇÃO DE SERVIÇOS - ICMS, PELO ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.02.00.00.00.00','COTA-PARTE DO IPVA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA PARTICIPAÇÃO DE MUNICÍPIOS NA ARRECADAÇÃO DO IMPOSTO SOBRE A PROPRIEDADE DE VEÍCULOS AUTOMOTORES - IPVA, PELO ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.03.00.00.00.00','COTA-PARTE DO IPI SOBRE EXPORTACAO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA PARTICIPAÇÃO DE MUNICÍPIOS NA ARRECADAÇÃO DO IMPOSTO SOBRE A PRODUTOS INDUSTRIALIZADOS - IPI, PARA EXPORTAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.04.00.00.00.00','COTA-PARTE DO ANTIGO ITCD (CF/67)','REGISTRA O VALOR, NO CASO DO MUNICÍPIO RECEBER DO ESTADO ALGUMA TRANSFERÊNCIA REFERENTE A ARRECADAÇÃO INCIDENTE SOBRE A TRANSMISSÃO DA PROPRIEDADE DE BENS IMÓVEIS, INCLUSIVE DOS DIREITOS A ELES RELATIVOS, BENS MÓVEIS, DIREITOS, TÍTULOS E CRÉDITOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.05.00.00.00.00','TRANSFERENCIA DA COTA-PARTE DA COMPENSACAO FINANCEIRA (25%)','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA COTA-PARTE DA  COMPENSAÇÃO FINANCEIRA PROVENIENTE DA EXPLORACAO DE RECURSOS NATURAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.06.00.00.00.00','TRANSFERENCIA DE RECURSOS DO ESTADO PARA PROGRAMAS DE SAUDE - REPASSE FUNDO A FUNDO','REGISTRA A VPA DA TRANSFERÊNCIA DE RECURSOS DO SISTEMA ÚNICO DE SAÚDE ORIUNDO DO FUNDO ESTADUAL DE SAUDE PARA O FUNDO MUNICIPAL DE SAUDE (AÇÕES BÁSICAS DE VIGILÂNCIA SANITÁRIA, ATENÇÃO À SAÚDE DOS POVOS INDÍGENAS, PROGRAMA DE ASSISTÊNCIA FARMACÊUTICA BÁSICA, PROGRAMA DE COMBATE ÀS CARÊNCIAS NUTRICIONAIS, PROGRAMA DE SAÚDE DA FAMÍLIA, PROGRAMA DE AGENTES COMUNITÁRIOS, PROGRAMA NACIONAL DE VIGILÂNCIA EPIDEMIOLÓGICA E CONTROLE DE DOENÇAS E OUTROS).  ESTA CONTA DEVERÁ SER DESDOBRADA PELO MUNICIPIO EM TANTAS CONTAS ANALITICAS QUANTAS FOREM AS FINANLIDADES DIVERSAS DOS RECURSOS RECEBIDOS, SENDO VINCULADO UM CÓDIGO DE RECURSO PARA CADA UMA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.07.00.00.00.00','COTA-PARTE DA MULTA DE TRANSITO','REGISTRA O VALOR TOTAL DAS VPAS RECEBIDAS ATRAVÉS DE COTA-PARTE DA MULTA DE TRÂNSITO TRANSFERIDA PELO ESTADO E EXECUTADAS COMO RECURSO LIVRE ATÉ 30 DE JUNHO DE 2009.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.08.00.00.00.00','TRANSFERENCIAS DE CONVENIOS DOS ESTADOS E DO DISTRITO FEDERAL E DE SUAS ENTIDADES','REGISTRA O VALOR TOTAL DOS RECURSOS ORIUNDOS DE CONVÊNIOS FIRMADOS, COM OU SEM CONTRAPRESTAÇÕES DE SERVIÇOS COM ESTADOS OU COM O DISTRITO FEDERAL E RESPECTIVAS ENTIDADES PÚBLICAS, PARA REALIZAÇÃO DE OBJETIVOS DE INTERESSE COMUM DOS PARTÍCIPES, E DESTINADOS A CUSTEAR DESPESAS CORRENTES. EX: CONVENIOS DOS ESTADOS PARA O SISTEMA UNICO DE SAUDE - SUS, CONVENIOS DOS ESTADOS DESTINADAS A PROGRAMAS DE EDUCACAO, PROGRAMA DE ABRIGAGEM A POPULACAO ADULTA DE RUA, REVISAO DE BENEFICIOS DE PRESTACAO CONTINUADA - BPC, PROGRAMA DE ATENDIMENTO A CRIANCA, PROGRAMA DE APOIO A PESSOA PORTADORA DE DEFICIENCIA, PROGRAMA DE ATENCAO A PESSOA IDOSA, PROGRAMA ASEMA-APOIO SOCIO-EDUCATIVO EM MEIO ABERTO, PROGRAMA OASF - ORIENTACAO E APOIO SOCIO-FAMILIAR, PROGRAMA DE ABRIGO AS CRIANCAS E ADOLESCENTES, TRANSFERENCIAS RELATIVAS AO PROSAN ALÉM DE OUTRAS TRANSFERENCIAS DE CONVENIOS DOS ESTADOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.99.00.00.00.00','OUTRAS TRANSFERENCIAS DOS ESTADOS E DF','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERENCIAS DOS ESTADOS E  DISTRITO FEDERAL A UNIAO E AOS  MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.97.00.00.00.00','(-) DEDUÇÕES DAS TRANSFERENCIAS INTER GOVERNAMENTAIS','REGISTRA AS DEDUÇÕES DAS VPA DE TRANSFERENCIA INTER GOVERNAMENTAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.2.0.00.00.00.00.00','TRANSFERÊNCIAS DO FUNDEB','Compreende as variações patrimoniais aumentativas decorrentes da recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.2.3.00.00.00.00.00','TRANSFERÊNCIAS DO FUNDEB - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas decorrentes de recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007, decorrentes de complementação da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.2.4.00.00.00.00.00','TRANSFERÊNCIAS DO FUNDEB - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas decorrentes da recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.0.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.1.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.3.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - UNIÃO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.4.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - ESTADO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.5.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - MUNICÍPIO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.0.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.1.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.3.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - UNIÃO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.4.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - ESTADO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.5.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - MUNICÍPIO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.0.0.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas, inclusive de bens e valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.1.0.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas sem fins lucrativos, inclusive de bens e valores. Exemplo: ONGs, OSCIPS e OS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.1.1.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas sem fins lucrativos, inclusive de bens e valores. Exemplo: ONGs, OSCIPS e OS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.2.0.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas com fins lucrativos, inclusive de bens e valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.2.1.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas com fins lucrativos, inclusive de bens e valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.4.0.0.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES MULTIGOVERNAMENTAIS','Compreende as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.4.0.1.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.4.0.1.01.00.00.00.00','TRANSFERENCIAS DE RECURSOS DO FUNDEB','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS RECEBIDOS DIRETAMENTE DO FUNDEB, PELOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS, INDEPENDENTE DO VALOR QUE FOI DEDUZIDO NO ENTE PARA FORMACAO DO FUNDEB.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.4.0.1.02.00.00.00.00','OUTRAS TRANSFERENCIAS MULTIGOVERNAMENTAIS','REGISTRA O VALOR DA VPA DE OUTRAS TRANSFERÊNCIAS MULTIGOVERNAMENTAIS , NÃO CLASSIFICADOS NOS ITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.5.0.0.00.00.00.00.00','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências de consórcios públicos, dos quais o ente recebedor participe.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.5.0.1.00.00.00.00.00','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes das transferências de consórcios públicos, dos quais o ente recebedor participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.6.0.0.00.00.00.00.00','TRANSFERÊNCIAS DO EXTERIOR','Compreende as variações patrimoniais aumentativas decorrentes de transferências de organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.6.0.1.00.00.00.00.00','TRANSFERÊNCIAS DO EXTERIOR - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de transferências de organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.0.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) ou Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.1.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.1.3.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.1.4.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.1.5.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.2.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização de Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.2.1.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização de Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.8.0.0.00.00.00.00.00','TRANSFERÊNCIAS DE PESSOAS FÍSICAS','Compreende as variações patrimoniais aumentativas decorrentes de contribuições e doações a governos e entidades da administração descentralizada realizadas por pessoas físicas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.8.0.1.00.00.00.00.00','TRANSFERÊNCIAS DE PESSOAS FÍSICAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de contribuições e doações a governos e entidades da administração descentralizada realizadas por pessoas físicas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.0.0.0.00.00.00.00.00','VALORIZAÇÃO E GANHOS COM ATIVOS','Compreende a variação patrimonial aumentativa com reavaliação e ganhos de ativos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.0.0.00.00.00.00.00','REAVALIAÇÃO DE ATIVOS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo, quando esse for superior ao valor liquido contábil.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.1.0.00.00.00.00.00','REAVALIAÇÃO DE IMOBILIZADO','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for superior ao valor liquido contábil.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.1.1.00.00.00.00.00','REAVALIAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for superior ao valor liquido contábil.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.2.0.00.00.00.00.00','REAVALIAÇÃO DE INTANGÍVEIS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for superior ao valor liquido contábil.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.2.1.00.00.00.00.00','REAVALIAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for superior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.9.0.00.00.00.00.00','REAVALIAÇÃO DE OUTROS ATIVOS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for superior ao valor liquido contábil.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.9.1.00.00.00.00.00','REAVALIAÇÃO DE OUTROS ATIVOS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for superior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.0.0.00.00.00.00.00','GANHOS COM ALIENAÇÃO','Compreende o ganho com alienação de ativos, ou seja, quando o valor alienado do ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.1.0.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS','Compreende o ganho com alienação de investimentos, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.1.1.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','Registra o ganho com alienação de investimentos, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.2.0.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE IMOBILIZADO','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.2.1.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.3.0.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS','Compreende o ganho com alienação de ativos intangíveis, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.3.1.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Registra o ganho com alienação de ativos intangíveis, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.0.0.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS','Compreende a contrapartida da incorporação de novos ativos descobertos, a contrapartida da incorporação de ativos semoventes nascidos, por exemplo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.1.0.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS','Compreende os ganhos com a incorporação de novos ativos descobertos, como por exemplo, descoberta de jazidas de recursos naturais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.1.1.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS - CONSOLIDAÇÃO','Registra os ganhos com a incorporação de novos ativos descobertos, como por exemplo, descoberta de jazidas de recursos naturais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.2.0.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS','Compreende os ganhos com a incorporação de semoventes nascidos, como por exemplo, nascimento de bovinos e aves.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.2.1.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS - CONSOLIDAÇÃO','Registra os ganhos com a incorporação de semoventes nascidos, como por exemplo, nascimento de bovinos e aves. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.3.0.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE VALORES APREENDIDOS','Compreende os ganhos  com a incorporação de valores apreendidos, como por exemplo, os valores apreendidos associados ao trafico ilícito de entorpecentes e drogas afins.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.3.1.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS APREENDIDOS - CONSOLIDAÇÃO','Registra os ganhos  com a incorporação de ativos apreendidos, como por exemplo, os valores apreendidos associados ao trafico ilícito de entorpecentes e drogas afins. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.3.9.00.00.00.00.00','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS','Compreende a contrapartida da incorporação de outros novos ativos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.3.9.01.00.00.00.00','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS - CONSOLIDAÇÃO','Compreende a contrapartida da incorporação de outros novos ativos.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.0.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','Compreende o somatório das demais variações patrimoniais aumentativas não incluídas nos grupos anteriores, tais como: resultado positivo da equivalência patrimonial, dividendos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.1.0.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR','Compreende os recursos referentes à variação patrimonial aumentativa recebidas e não classificadas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.1.0.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - CONSOLIDAÇÃO','Compreende os recursos referentes à variação patrimonial aumentativa recebidas e não classificadas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.0.0.00.00.00.00.00','RESULTADO POSITIVO DE PARTICIPAÇÕES','Compreende o resultado positivo das participações de caráter permanente no capital social de sociedades investidas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.0.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.1.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.2.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTRA OFSS','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros.   Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.3.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - UNIÃO','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.4.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - ESTADO','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.5.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.2.0.00.00.00.00.00','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS','Compreende as variações aumentativas oriundas de lucros apurados em outros investimentos não avaliados pelo método da equivalência patrimonial.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.2.1.00.00.00.00.00','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - CONSOLIDAÇÃO','Registra as variações aumentativas oriundas de lucros apurados em outros investimentos não avaliados pelo método da equivalência patrimonial. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.0.0.00.00.00.00.00','REVERSÃO DE PROVISÕES E AJUSTES DE PERDAS','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões e ajustes de perdas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.0.00.00.00.00.00','REVERSÃO DE PROVISÕES','Registra as variações patrimoniais aumentativas provenientes de reversões de provisões.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.1.00.00.00.00.00','REVERSÃO DE PROVISÕES - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.3.00.00.00.00.00','REVERSÃO DE PROVISÕES - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.4.00.00.00.00.00','REVERSÃO DE PROVISÕES - INTER OFSS - ESTADOS','Registra as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.5.00.00.00.00.00','REVERSÃO DE PROVISÕES - INTER OFSS - MUNICÍPIOS','Registra as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.0.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.1.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.2.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS - INTRA OFSS','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.3.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS -INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.4.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS -INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.5.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS -INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.0.0.00.00.00.00.00','DIVERSAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','Compreende outras variações patrimoniais aumentativas não classificadas em itens específicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.0.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.2.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','Registra as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.3.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.3.01.00.00.00.00','COMPENSAÇÕES FINANCEIRAS ENTRE O REGIME GERAL E OS REGIMES PRÓPRIOS DE PREVIDÊNCIA DOS SERVIDORES - PRINCIPAL','REGISTRA A VPA DECORRENTE DE COMPENSAÇÕES FINANCEIRAS ENTRE O REGIME GERAL E OS REGIMES PRÓPRIOS DE PREVIDÊNCIA DOS SERVIDORES - PRINCIPAL','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.3.02.00.00.00.00','COMPENSAÇÕES FINANCEIRAS ENTRE O REGIME GERAL E OS REGIMES PRÓPRIOS DE PREVIDÊNCIA DOS SERVIDORES - PARCELAMENTOS','REGISTRA A VPA DECORRENTE DE COMPENSAÇÕES FINANCEIRAS ENTRE O REGIME GERAL E OS REGIMES PRÓPRIOS DE PREVIDÊNCIA DOS SERVIDORES - PARCELAMENTOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.4.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.5.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.2.0.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.2.3.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.2.4.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.2.5.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.3.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES','Compreende as variações patrimoniais aumentativas provenientes de bonificações recebidas nas aquisições de mercadorias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.3.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de bonificações recebidas nas aquisições de mercadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.0.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.1.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.2.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTRA OFSS','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.3.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.4.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.5.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.0.00.00.00.00.00','MULTAS ADMINISTRATIVAS','Compreende as variações patrimoniais aumentativas provenientes de penalidades pecuniárias decorrentes da inobservância de normas, e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Representa o resultado das aplicações impostas ao contribuinte faltoso, como sanção legal no campo tributário (impostos, taxas e contribuição de melhoria) e não-tributário (contribuições sociais e econômicas, patrimoniais, industriais, serviços e diversas) e de natureza administrativa, por infrações a regulamentos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.00.00.00.00.00','MULTAS ADMINISTRATIVAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de penalidades pecuniárias decorrentes da inobservância de normas, e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Representa o resultado das aplicações impostas ao contribuinte faltoso, como sanção legal no campo tributário (impostos, taxas e contribuição de melhoria) e não-tributário (contribuições sociais e econômicas, patrimoniais, industriais, serviços e diversas) e de natureza administrativa, por infrações a regulamentos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.03.00.00.00.00','MULTA DE POLUICAO DE AGUAS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DESTINADAS A PUNIR O INFRATOR  PELA  POLUICAO  DE  AGUAS.  MULTAS   DEV.  LANCAMENTO   OLEOS,PRODUTOS OLEOSOS E SUBSTANCIAS QUIMICAS TOXICAS NAS AGUAS PUBLICAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.07.00.00.00.00','MULTAS PREVISTAS NA LEGISLAÇÃO SANITARIA','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE MULTAS  APLICADAS  COM O FIM DE PUNIR A QUEM TRANSGRIDE O DISPOSTO NA LEGISLACAO SANITARIA. DEVIDASQUANDO DA INFRACAO, FRAUDE, FALSIFICACAO E ADULTERACAO DAS   MATERIAS-PRIMAS E PRODUTOS FARMACEUTICOS, BEM COMO QUAISQUER PRODUTOS OU  INSUMOS QUE INTERESSEM A SAUDE PUBLICA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.08.00.00.00.00','MULTAS PREVISTAS LEGISLAÇÃO DE REGISTRO COMERCIO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS  COM  O FIM DE PUNIR A QUEM INFRINGE AS LEIS OU REGULAMENTOS QUE DISCIPLINAM AS ATIVIDADES DE AGENTES AUXILIARES DO COMERCIO, DE ARMAZENS GERAIS E  OUTROS SUJEITOS AO CONTROLE E FISCALIZACAO DOS ORGAOS DE REGISTRO DO COMERCIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.11.00.00.00.00','MULTAS PREVISTAS NA LEGISLAÇÃO DE TRANSITO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE MULTAS  APLICADAS  COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A TRANSITO.  CONSTITUEM VPA VINCULADA AO MINISTERIO DA JUSTICA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.14.00.00.00.00','MULTAS E JUROS PREVISTOS EM CONTRATOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE  MULTAS E JUROS PREVISTOS EM CONTRATOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.15.00.00.00.00','MULTAS DECORRENTES DE OPERAÇÕES DE TRANSPORTE RODOVIARIO DE PASSAGEIROS E CARGAS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES DAS LEGISLACOES DE OPERACAO DO TRANSPORTE RODOVIARIO DE PASSAGEIROS  E CARGAS, BEM COMO DOS CONTRATOS DE CONCESSAO DE SERVICOS DE  TRANSPORTE RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS E CARGAS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.21.00.00.00.00','MULTAS POR DANOS AO MEIO AMBIENTE','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE  MULTAS POR DANOS AO MEIO AMBIENTE. AMPARO LEGAL: LEI 9 605 DE 12FEV1998','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.25.00.00.00.00','MULTAS APLICADAS PELOS TRIBUNAIS DE CONTAS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS MULTAS APLICADAS PELOS TRIBUNAIS DE CONTAS,  PELO NAO CUMPRIMENTO A DECISAO DOS MESMOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.27.00.00.00.00','MULTAS POR AUTOS DE INFRACAO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE MULTAS PUNITIVAS  APLICADAS PELO NAO CUMPRIMENTO NOS CASOS PREVISTOS NOS REGULAMENTOS OU NOS CONTRATOS, OU PELA REINCIDENCIA EM FATOS QUE TENHAM GERADO ADVERTENCIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.28.00.00.00.00','MULTA POR INFRAÇÃO À LEGISLAÇÃO DE LICITAÇÃO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS APLICADAS POR INFRAÇÕES PRATICADAS EM INOBSERVÂNCIA À LEGISLAÇÃO APLICADA AOS PROCEDIMENTOS DE LICITAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.99.00.00.00.00','OUTRAS MULTAS ADMINISTRATIVAS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE OUTRAS MULTAS ADMINISTRATIVAS NAO ENQUADRADAS NAS CONTAS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.0.00.00.00.00.00','INDENIZAÇÕES','Compreende as variações patrimoniais aumentativas provenientes de indenizações diversas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.1.00.00.00.00.00','INDENIZAÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de indenizações diversas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.1.01.00.00.00.00','INDENIZACOES POR DANOS CAUSADOS AO PATRIMONIO PUBLICO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR     DANOS CAUSADOS AO PATRIMONIO PUBLICO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.1.99.00.00.00.00','OUTRAS INDENIZACOES','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE INDENIZACOES QUE NAO SE ENQUADRAM NOS ITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.7.0.00.00.00.00.00','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS','Compreende o somatório das variações patrimoniais aumentativas geradas pela alienação de mercadorias, objeto da pena de perdimento. O produto da arrecadação tem a seguinte destinação: 60% ao fundo especial de desenvolvimento e aperfeiçoamento das atividades de fiscalização - fundão e 40% ao fundo nacional de assistência social - Ministério da Previdência e Assistência Social ao fundo nacional antidroga - FUNAD, para aplicação conforme legislação em vigor, quando da apreensão de bens, direitos e valores objeto do crime de trafico ilícito de substancias entorpecentes ou drogas afins. (lei 6368 de 21/10/76, lei 7460 de 19/12/86 e lei 9804 de 30/06/99)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.7.1.00.00.00.00.00','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS - CONSOLIDAÇÃO','Compreende o somatório das variações patrimoniais aumentativas geradas pela alienação de mercadorias, objeto da pena de perdimento. O produto da arrecadação tem a seguinte destinação: 60% ao fundo especial de desenvolvimento e aperfeiçoamento das atividades de fiscalização - fundão e 40% ao fundo nacional de assistência social - Ministério da Previdência e Assistência Social ao fundo nacional antidroga - FUNAD, para aplicação conforme legislação em vigor, quando da apreensão de bens, direitos e valores objeto do crime de trafico ilícito de substancias entorpecentes ou drogas afins. (lei 6368 de 21/10/76, lei 7460 de 19/12/86 e lei 9804 de 30/06/99). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.7.1.01.00.00.00.00','VPA DE ALIENAÇÃO DE BENS E/OU MERCADORIAS APREENDIDAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE ALIENACAO DE BENS E/OU DE MERCADORIAS APREENDIDAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','Compreende as variações patrimoniais aumentativas decorrentes de fatos geradores diversos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de fatos geradores diversos.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.01.00.00.00.00','VPA DE ONUS SUCUMBENCIA DE ACOES JUDICIAIS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DO MUNICIPIO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA MUNICIPAL, PAGA PELO DEVEDOR DA ACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.01.01.00.00.00','VPA DE HONORARIOS DE ADVOGADOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA  DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.02.00.00.00.00','"TERCEIRIZAÇÃO" DA FOLHA DE PAGAMENTO DOS AGENTES PUBLICOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA TERCEIRIZACAO DA FOLHA  DE PAGAMENTO DOS AGENTES PUBLICOS COMO CONTRAPARTIDA DA PRESTACAO DE SERVICOS DE DISPONIBILIZACAO DE CREDITOS EM CONTAS CORRENTES E DA CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS COM AMORTIZACAO CONSIGNADA EM FOLHA DE PAGAMENTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.03.00.00.00.00','OUTRAS RECEITAS DIRETAMENTE ARRECADADAS PELO RPPS','REGISTRA O VALOR TOTAL DAS DEMAIS VPAS CORRENTES ARRECADADAS DIRETAMENTE PELO REGIME PRÓPRIO DE PREVIDÊNCIA','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.04.00.00.00.00','RECEITAS DIRETAMENTE ARRECADADAS PELO FUNDO DE ASSISTENCIA SOCIAL DOS SERVIDORES','REGISTRA O VALOR TOTAL DAS VPAS CORRENTES ARRECADADAS DIRETAMENTE PELO FUNDO DE ASSISTÊNCIA SOCIAL DOS SERVIDORES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.05.00.00.00.00','RECEITAS DIRETAMENTE ARRECADADAS PELO FUNDO DE ASSISTENCIA A SAUDE DOS SERVIDORES','REGISTRA O VALOR TOTAL DAS VPAS CORRENTES ARRECADADAS DIRETAMENTE PELO FUNDO DE ASSISTÊNCIA A SAÚDE DOS SERVIDORES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.06.00.00.00.00','RECEITAS DECORRENTES DA COMPRA DE DOSES DE SEMEN DE ANIMAIS PELOS PRODUTORES','REGISTRA O VALOR TOTAL DA VPA DECORRENTE DA COMPRA PELOS PRODUTOS DE SÊMEN DE ANIMAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.07.00.00.00.00','RECEITAS DECORRENTES DO RECEBIMENTO DE CERTIDÃO - TÍTULO EXECUTIVO DO TCE/RS','REGISTRA A VPA DECORRENTES DO RECEBIMENTO TOTAL OU PARCIAL  DE CERTIDÃO - TÍTULO EXECUTIVOEMITIDO PELO  TCE/RS O QUAL FOI REGISTRADO NO ATIVO COMO CRÉDITOS A RECEBER E NÃO COMO DIVIDA ATIVA NÃO-TRIBUTÁRIA','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.08.00.00.00.00','PROGRAMA TROCA-TROCA','REGISTRA O VALOR TOTAL DA VPA PROVENIENTE DO PAGAMENTO PELOS AGRICULTORES DO VALOR QUE LHES FOI ENTREGUE EM SEMENTES PELO MUNICÍPIO. INCLUSIVE A VPA DA DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.09.00.00.00.00','RESTITUICOES DETERMINADAS PELO TCE','REGISTRA A VPA PROVENIENTE DE CRÉDITOS EXIGÍVEIS A PARTIR DO RECEBIMENTO, PELO CREDOR, DE CERTIDÃO DE DECISÃO - TÍTULO EXECUTIVO, EMITIDA PELO TRIBUNAL DE CONTAS DO ESTADO, COM CARACTERÍSTICA DE LIQUIDEZ E CERTEZA, CUJA INSCRIÇÃO DO DIREITO DEU-SE, FA','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.10.00.00.00.00','RESTITUICAO PELO USO DE BENS DO MUNICIPIO','REGISTRA O VALOR TOTAL DA ARRECADAÇÃO DA VPA PROVENIENTE DA UTILIZAÇÃO DE BENS DO MUNICÍPIO. EX: TELEFONE MÓVEL','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.11.00.00.00.00','RESTITUICAO PELO PAGAMENTO INDEVIDO','REGISTRA O VALOR DA RESTITUIÇÃO PROVENIENTE DE PAGAMENTO INDEVIDO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.12.00.00.00.00','RESTITUICAO DE AUXILIOS','REGISTRA A ARRECADAÇÃO DE RECURSOS PROVENIENTES DA DEVOLUÇÃO DE SALDOS DE AUXÍLIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.0.0.0.0.00.00.00.00.00','CONTROLES DA APROVAÇÃO DO PLANEJAMENTO E ORÇAMENTO','Compreende as contas com função de registrar os atos e fatos ligados a execução orçamentária.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.0.0.0.00.00.00.00.00','PLANEJAMENTO APROVADO','Compreende o somatório dos valores monetários previstos para execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei orçamentária anual.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.1.0.0.00.00.00.00.00','PPA - APROVADO','Compreende o somatório dos valores monetários previstos para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.1.1.0.00.00.00.00.00','PPA POR PROGRAMA DE TRABALHO','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL APROVADO PARA O PERIODO DE QUATRO ANOS, DETALHADO POR PROGRAMA DE TRABALHO .','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.1.2.0.00.00.00.00.00','REVISAO DO PPA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DAS REVISOES ANUAIS AUTORIZADAS DURANTE O PERIODO DE VIGENCIA DO PLANO PLURIANUAL, DETALHADO POR PROGRAMA DE TRABALHO.','X','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.0.0.00.00.00.00.00','PLOA','Compreende o somatório dos valores monetários previstos para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no projeto de lei orçamentária anual.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.1.0.00.00.00.00.00','PROJETO INICIAL DA LEI ORCAMENTARIA  - RECEITA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS CONSTANTES DO PROJETO DA LEI ORCAMENTARIA ANUAL REMETIDO PELO PODER EXECUTIVO AO PODER LEGISLATIVO PARA APRECIACAO E APROVACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.1.1.00.00.00.00.00','PLOA INICIAL DA RECEITA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DA PREVISAO DE RECEITA CONSTANTE DO PLOA INICIAL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.1.2.00.00.00.00.00','ALTERACOES  DO PROJETO INICIAL DA LOA - RECEITA','REGISTRA O SOMATORIO DAS ALTERACOES NO PROJETO INICIAL DA LOA EM RELACAO A RECEITA.','X','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.2.0.00.00.00.00.00','PROJETO INICIAL DA LOA - DESPESA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS CONSTANTES DO PROJETO DA LEI ORCAMENTARIA ANUAL REMETIDO PELO PODER EXECUTIVO AO PODER LEGISLATIVO PARA APRECIACAO E APROVACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.2.1.00.00.00.00.00','PLOA INICIAL DA DESPESA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DA FIXACAO DA DESPESA CONSTANTE DO PLOA INICIAL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.2.2.00.00.00.00.00','ALTERACOES DO PROJETO INICIAL DA LOA - DESPESA','REGISTRA O SOMATORIO DAS ALTERACOES NO PROJETO INICIAL DA LOA EM RELACAO A DESPESA.','X','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.0.0.0.00.00.00.00.00','ORÇAMENTO APROVADO','Compreende o somatório dos valores relativos à previsão da receita, fixação da despesa e suas alterações no orçamento geral da União durante o exercício financeiro.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.0.0.00.00.00.00.00','PREVISÃO DA RECEITA','Compreende o somatório dos valores relativos à previsão da receita pública aprovada pela lei orçamentária anual e suas alterações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.1.0.00.00.00.00.00','PREVISÃO INICIAL DA RECEITA','Compreende o valor da receita previsão inicial da receita aprovado na LOA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.1.0.01.00.00.00.00','PREVISAO INICIAL DA RECEITA  BRUTA','REGISTRA O VALOR BRUTO DA RECEITA PREVISÃO INICIAL DA RECEITA .','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.1.0.02.00.00.00.00','(-) PREVISÃO DE DEDUÇÕES DA RECEITA','REGISTRA O VALOR DAS DEDUÇÕES DE  RECEITA ORÇAMENTÁRIA PREVISTAS  EM ORÇAMENTO PARA O EXERCÍCIO VIGENTE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.2.0.00.00.00.00.00','ALTERAÇÃO DA PREVISÃO DA RECEITA','Registra o valor dos créditos previstos após a aprovação do orçamento independente da autorização já concedida na lei orçamentária para abertura de credito suplementar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.2.1.00.00.00.00.00','PREVISÃO ADICIONAL DA RECEITA','Registra o valor adicional da receita para abertura de créditos adicionais.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.2.9.00.00.00.00.00','(-) ANULAÇÃO DA PREVISÃO DA RECEITA','Registra o valor da anulação da receita prevista no orçamento, na gestão fundos e nas administrações direta e indireta.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.0.0.00.00.00.00.00','FIXAÇÃO DA DESPESA','Compreende o somatório dos valores relativos à fixação da despesa pública aprovada pela lei orçamentária e suas alterações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.0.00.00.00.00.00','DOTAÇÃO ORÇAMENTÁRIA','Compreende o somatório dos valores monetários da dotação orçamentária inicial, adicional e seus cancelamentos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.1.00.00.00.00.00','DOTAÇÃO INICIAL','Compreende a dotação inicial autorizada na lei orçamentária anual.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.1.01.00.00.00.00','CREDITO INICIAL','COMPREENDE OS VALORES PERTINENTES AOS CREDITOS INICIALMENTE APROVADOS PARA DAR SUPORTE A EXECUCAO ORCAMENTARIA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.1.01.01.00.00.00','ORIGINARIO DO OGM','REGISTRA OS VALORES PERTINENTES AOS CREDITOS INICIAIS  APROVADOS  PELA LEI ORCAMENTARIA, PARA EXECUCAO DO ORCAMENTO DOS ORGAOS/ENTIDADES  INTEGRANTES DO OGM REFERENTES AO OFSS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.00.00.00.00.00','DOTAÇÃO ADICIONAL POR TIPO DE CREDITO','Compreende o somatório dos valores monetários da dotação orçamentária decorrentes da abertura de créditos adicionais e seus cancelamentos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.01.00.00.00.00','CREDITO ADICIONAL - SUPLEMENTAR','Compreende o somatório dos valores relativos aos créditos adicionais suplementares com vista ao reforço da dotação orçamentária constante da lei orçamentária.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.02.00.00.00.00','CREDITO ADICIONAL - ESPECIAL','Compreende o somatório dos valores dos créditos adicionais especiais destinados a atender programas não contemplados na lei orçamentária anual.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.02.01.00.00.00','CRÉDITOS ESPECIAIS ABERTOS','Registra os valores referentes à abertura de créditos especiais autorizados em lei especifica.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.02.02.00.00.00','CRÉDITOS ESPECIAIS REABERTOS','Registra os valores referentes à reabertura de créditos especiais cujo ato de autorização foi promulgado nos últimos quatro meses do exercício anterior.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.02.03.00.00.00','CRÉDITOS ESPECIAIS REABERTOS - SUPLEMENTAÇÃO','Registra os valores referentes à suplementação de créditos especiais reabertos nos termos do § 2º do art. 167 da C.F./88.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.03.00.00.00.00','CREDITO ADICIONAL - EXTRAORDINÁRIO','Compreende o somatório dos valores referentes à abertura de créditos adicionais extraordinários destinados a despesas imprevisíveis e urgentes como as decorrentes de guerra, comoção interna ou calamidade pública.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.03.01.00.00.00','CRÉDITOS EXTRAORDINÁRIOS ABERTOS','Registra os valores referentes aos créditos extraordinários abertos por decreto do poder executivo.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.03.02.00.00.00','CRÉDITOS EXTRAORDINÁRIOS REABERTOS','Registra os valores referentes à reabertura de créditos extraordinários cujo ato de autorização foi promulgado nos últimos quatro meses do exercício anterior.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.03.03.00.00.00','CRÉDITOS EXTRAORDINÁRIOS REABERTOS - SUPLEMENTAÇÃO','Registra os valores referentes à suplementação de créditos extraordinários reabertos nos termos do § 2º do art. 168 da C.F./88.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.00.00.00.00.00','DOTAÇÃO ADICIONAL POR FONTE','Compreende o somatório dos valores da dotação adicional por fonte de recursos para abertura do credito adicional.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.00.00.00.00','CREDITO SUPLEMENTAR','REGISTRA O SOMATÓRIO DA  MOVIMENTACAO DOS CREDITOS SUPLEMENTARES, DESTINADOS A REFORCO DE DOTACAO ORCAMENTARIA JA EXISTENTE NO ORCAMENTO EM VIGOR, PARA  A REALIZACAO DE DESPESAS,  AUTORIZADA POR LEI E ABERTA POR DECRETOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.01.00.00.00','SUPERAVIT FINANCEIRO DE EXERCICIO ANTERIOR','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA SUPERAVIT FINANCEIRO APURADO NO BALANCO PATRIMONIAL DO EXERCICIO ANTERIOR.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.02.00.00.00','EXCESSO DE ARRECADACAO.','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.02.01.00.00','EXCESSO DE ARRECADACAO PROPRIAMENTE DITA','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO DE VALORES RECEBIDOS A MAIOR QUE O PREVISTO NO ORÇAMENTO ORIGINAL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.02.02.00.00','DOACOES','REGISTRA OS VALORES PERTINENTES AOS CREDITOS SUPLEMENTARES ABERTOS  NO EXERCICIO, PROVENIENTES DE  DOACOES RECEBIDAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.02.03.00.00','AUXILIOS E CONVENIOS','RECURSO OFERECIDO PARA ABERTURA DE CRÉDITOS SUPLEMENTARES ADICIONAIS PROVENIENTE DO RECEBIMENTO DE AUXÍLIOS E CONVÊNIOS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.03.00.00.00','OPERACOES DE CREDITO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA OPERACOES DE CREDITO AUTORIZADAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.04.00.00.00','ANULACAO DE DOTACAO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA A ANULACAO PARCIAL OU TOTAL DE DOTACOES ORCAMENTARIAS OU CREDITOS ADICIONAIS, AUTORIZADOS EM LEI.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.00.00.00.00','CREDITO ESPECIAL','REGISTRA O SOMATÓRIO DA  MOVIMENTACAO DOS CREDITOS ESPECIAIS, DESTINADOS A NOVAS DOTACÕES ORCAMENTARIAS NÇAO EXISTENTES NO ORCAMENTO EM VIGOR, PARA  A REALIZACAO DE DESPESAS,  AUTORIZADA POR LEI E ABERTA POR DECRETOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.01.00.00.00','SUPERAVIT FINANCEIRO DE EXERCICIO ANTERIOR','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA SUPERAVIT FINANCEIRO APURADO NO BALANCO PATRIMONIAL DO EXERCICIO ANTERIOR.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.02.00.00.00','EXCESSO DE ARRECADACAO.','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.02.01.00.00','EXCESSO DE ARRECADACAO PROPRIAMENTE DITA','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO DE VALORES RECEBIDOS A MAIOR QUE O PREVISTO NO ORÇAMENTO ORIGINAL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.02.02.00.00','DOACOES','REGISTRA OS VALORES PERTINENTES AOS CREDITOS SUPLEMENTARES ABERTOS  NO EXERCICIO, PROVENIENTES DE  DOACOES RECEBIDAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.02.03.00.00','AUXILIOS E CONVENIOS','RECURSO OFERECIDO PARA ABERTURA DE CRÉDITOS SUPLEMENTARES ADICIONAIS PROVENIENTE DO RECEBIMENTO DE AUXÍLIOS E CONVÊNIOS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.03.00.00.00','OPERACOES DE CREDITO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA OPERACOES DE CREDITO AUTORIZADAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.04.00.00.00','ANULACAO DE DOTACAO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA A ANULACAO PARCIAL OU TOTAL DE DOTACOES ORCAMENTARIAS OU CREDITOS ADICIONAIS, AUTORIZADOS EM LEI.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.09.00.00.00.00','(-) CANCELAMENTO DE DOTACOES','REGISTRA O CANCELAMENTO / REMANEJAMENTO DE DOTACOES PARA ABERTURA DE CREDITOS ADICIONAIS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.99.00.00.00.00','VALOR GLOBAL DA DOTACAO ADICIONAL POR FONTE','REGISTRA O VALOR DA CONTRAPARTIDA DOS LANCAMENTOS DAS DOTACOES ADICIONAIS POR ORIGEM DE CREDITO.','X','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.00.00.00.00.00','CANCELAMENTO/REMANEJAMENTO DE DOTAÇÃO','Compreende o somatório dos valores relativos aos créditos inicial, suplementar, especial e extraordinário cancelados ou remanejados, em casos regularmente previstos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.01.00.00.00.00','ALTERACAO DO QUADRO DE DETALHAMENTO DA DESPESA','REGISTRA  A MOVIMENTACAO DOS CREDITOS POR ACRESCIMO OU REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.01.01.00.00.00','ACRESCIMO','REGISTRA  A MOVIMENTACAO DOS CREDITOS POR ACRESCIMO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.01.09.00.00.00','(-) REDUCAO','REGISTRA  A MOVIMENTACAO DOS CREDITOS POR REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.02.00.00.00.00','ALTERACAO DA LEI ORCAMENTARIA','REGISTRA OS VALORES DOS CREDITOS ORCAMENTARIOS INDISPONIVEIS PARA EXECUCAO DA DESPESA, POR MEDIDA DE VETO, CONTINGENCIAMENTO OU  CONTENCAO, E POSTERIORMENTE CANCELADAS, NOS CASOS REGULARMENTE PREVISTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.02.01.00.00.00','ACRESCIMO','REGISTRA OS VALORES DOS ACRESCIMOS  RESULTANTES DE ALTERACOES  DA LEI ORCAMENTARIA EM VIRTUDE DE REMANEJAMENTO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.02.09.00.00.00','(-) REDUCAO','REGISTRA O VALOR DA REDUCAO DA DOTACAO DEVIDO A ALTERACAO DA LEI  ORCAMENTARIA EM VIRTUDE DE REMANEJAMENTO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.0.00.00.00.00.00','MOVIMENTAÇÃO DE CRÉDITOS RECEBIDOS','Compreende o somatório dos valores dos recebimentos de créditos orçamentários através de destaque, provisão ou por fusão, cisão ou extinção de unidades.','','N','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.1.00.00.00.00.00','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO','Compreende os valores dos créditos descentralizados das unidades orçamentárias para as unidades administrativas sob sua jurisdição ou entre estas, no âmbito do próprio ministério, secretaria ou órgão equivalente, recebidos ao longo do exercício.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.1.01.00.00.00.00','PROVISAO RECEBIDA','REGISTRA A PARCELA DE CREDITO RECEBIDA POR UMA UNIDADE  ADMINISTRATIVA OU ORCAMENTARIA, DECORRENTE DA DESCENTRALIZACAO DO  CREDITO ORCAMENTARIO OU ADICIONAL, DENTRO DO PROPRIO ORGAO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.00.00.00.00.00','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','Compreende a descentralização do credito inicial ou adicional recebido de unidades ou órgãos pertencentes a ministérios, secretarias e órgãos equivalentes distintos ou entre estes e entidades da administração indireta.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.01.00.00.00.00','ADMINISTRACAO DIRETA','COMPREENDE O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES  DE RECEBIMENTO OU DE TRANSFERENCIA DE OUTROS ORGAOS E ENTIDADES  DE   IGUAL OU DE DIFERENTE UNIDADE ORCAMENTARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.01.01.00.00.00','CREDITOS RECEBIDOS','REGISTRA O VALOR DOS CREDITOS RECEBIDOS PELA ADMINISTRACAO DIRETA   DE OUTROS ORGAOS E ENTIDADES.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.01.09.00.00.00','(-) CREDITOS TRANSFERIDOS','REGISTRA A MOVIMENTACAO DE CREDITOS DE ENTIDADES DA ADMINISTRACAO INDIRETA OU ENTRE ORGAOS DA ADMINISTRACAO DIRETA DE UNIDADE ORCAMENTARIA DIFERENTE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.02.00.00.00.00','ADMINISTRACAO INDIRETA','COMPREENDE O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES   DE RECEBIMENTO OU DE TRANSFERENCIA DE OUTROS ORGAOS E ENTIDADES DE   IGUAL OU DE DIFERENTE UNIDADE ORCAMENTARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.02.01.00.00.00','CREDITOS RECEBIDOS','REGISTRA O VALOR DOS CREDITOS RECEBIDOS PELA ADMINISTRACAO INDIRETA DE MESMA OU DE DIFERENTE UNIDADE ORCAMENTARIA DO ORGAO EMITENTE.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.02.09.00.00.00','(-) CREDITOS TRANSFERIDOS','REGISTRA A MOVIMENTACAO DE CREDITOS DE ORGAOS DA ADMINISTRACAO DIRETA OU ENTRE ENTIDADES DA ADMINISTRACAO INDIRETA DE MESMA OU DE   DIFERENTE UNIDADE ORCAMENTARIA, NAO FORMALIZADA A TERMO DE CONTRATO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.9.00.00.00.00.00','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','Compreende as movimentações de créditos recebidos por cisão, fusão, extinção, compensação e outras transações.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.3.0.00.00.00.00.00','DETALHAMENTO DE CREDITO','Compreende o somatório relativos às dotações detalhadas relativas a cada ação orçamentária (projeto, atividade ou operações especiais).','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.0.00.00.00.00.00','OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA','Compreende o somatório dos valores das despesas pré-empenhadas e empenhadas por detalhamento específico.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.1.00.00.00.00.00','EMPENHOS POR EMISSAO','COMPREENDE O SOMATORIO DOS VALORES EMPENHADOS POR DETALHAMENTO ESPECIFICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.1.01.00.00.00.00','EMPENHOS POR NOTA DE EMPENHO','COMPREENDE O CONTROLE DOS EMPENHOS EMITIDOS, REFORCADOS E TRANSFERIDOS, QUE ENVOLVAM DESPESAS ORCAMENTARIAS REALIZADAS PELA ADMINISTRACAO PUBLICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.1.01.01.00.00.00','EMISSAO DE EMPENHOS','REGISTRA O VALOR DA EMISSAO DE EMPENHO DA DESPESA, INCLUSIVE AQUELAS QUE FORAM OBJETO DE PRE-EMPENHO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.1.01.03.00.00.00','ANULACAO DE EMPENHOS','REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA ORCAMENTARIA  A DOTACAO CORRESPONDENTE.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.00.00.00.00.00','EMPENHOS POR MODALIDADE DE LICITACAO','COMPREENDE O SOMATORIO DOS VALORES DA EMISSAO DE EMPENHOS DE DESPESAS COM LICITACOES PARA OBRAS, SERVICOS, FORNECIMENTOS OU ALIENACOES, BEM COMO SUAS DISPENSAS E INEXIGIBILIDADES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.02.01.00.00.00','CONCORRENCIA','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO CONCORRENCIA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.02.02.00.00.00','TOMADA DE PRECOS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO TOMADA DE PRECOS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.02.03.00.00.00','CONVITE','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO CONVITE.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.02.04.00.00.00','CONCURSO','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO CONCURSO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.02.05.00.00.00','PREGAO','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE  PREGAO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.02.06.00.00.00','CONSULTA','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE  CONSULTA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.02.07.00.00.00','DISPENSAVEL POR LIMITE','REGISTRA O VALOR DO EMPENHOS EMITIDOS POR DISPENSA DE LICITACAO NO ASPECTO RELACIONADO AOS LIMITES MONETARIOS DE DISPENSA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.02.09.00.00.00','LICITACAO INEXIGIVEL','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PELA REALIZACAO DE DESPESAS  EM QUE E INEXIGIVEL A LICITACAO QUANDO HOUVER INVIABILIDADE DE  COMPETICAO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.03.00.00.00.00','NAO APLICAVEL','COMPREENDE O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS  EM QUE NAO SE APLICA A LICITACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.03.01.00.00.00','SUPRIMENTO DE FUNDOS -','REGISTRA O VALOR DOS EMPENHOS EMITIDOS RELATIVOS A SUPRIMENTOS DE FUNDOS PARA ATENDER DESPESAS EVENTUAIS, INCLUSIVE EM VIAGENS E COM SERVICOS ESPECIAIS, DESPESA DE CARATER SIGILOSO OU PARA ATENDER DESPESAS  DE  PEQUENO VULTO, DE ACORDO COM A LEGISLACAO VIGENTE.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.03.02.00.00.00','PESSOAL E ENCARGOS SOCIAIS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS  EM QUE NAO SE APLICA A LICITACAO, REFERENTES A PESSOAL E ENCARGOS SOCIAIS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.03.04.00.00.00','TRANSFERENCIAS VOLUNTARIAS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS  EM QUE NAO SE APLICA A LICITACAO, REFERENTES A TRANSFERENCIAS VOLUNTARIAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.03.05.00.00.00','AMORTIZACAO DA DIVIDA','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS  EM QUE NAO SE APLICA A LICITACAO, REFERENTES A AMORTIZACAO DA DIVIDA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.03.06.00.00.00','RESSARCIMENTOS E RESTITUICOES','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS  EM QUE NAO SE APLICA A LICITACAO, REFERENTES A RESSARCIMENTOS E RESTITUICOES.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.03.09.00.00.00','NAO APLICAVEL - OUTRAS DESPESAS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS  EM QUE NAO SE APLICA A LICITACAO, REFERENTES A OUTRAS DESPESAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.06.00.00.00.00','EMPENHOS POR CREDOR','COMPREENDE O SOMATARIO DOS VALORES DOS EMPENHOS EMITIDOS CONTROLADOS POR   BENEFICIARIOS DO EMPENHO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.06.01.00.00.00','VALORES COMPROMETIDOS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS CONTROLADOS POR BENEFICIARIO DO EMPENHO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.0.0.0.00.00.00.00.00','INSCRIÇÃO DE RESTOS A PAGAR','Compreende o somatório relativo ao valor da inscrição das despesas empenhadas e não pagas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.0.0.00.00.00.00.00','INSCRIÇÃO DE RP NÃO PROCESSADOS','Compreende o somatório dos valores inscritos em restos a pagar não-processados relativos às despesas empenhadas e não liquidadas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.1.0.00.00.00.00.00','RP NÃO PROCESSADOS INSCRITOS','Registra os valores inscritos em restos a pagar não-processados relativos às despesas empenhadas e não liquidadas até o ultimo dia do exercício financeiro.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.2.0.00.00.00.00.00','RP NÃO PROCESSADOS - EXERCÍCIOS ANTERIORES','Registra o valor de restos a pagar não processados relativo a exercícios anteriores que não foram cancelados porque tiveram seu prazo de validade prorrogado.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.3.0.00.00.00.00.00','RP NÃO PROCESSADOS RESTABELECIDOS','Registra o valor por restabelecimento de empenho de restos a pagar já cancelados em exercícios anteriores com base em ato normativo específico.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.6.0.00.00.00.00.00','RP NÃO PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','Registra o valor da transferência de restos a pagar não processados decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.7.0.00.00.00.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 531100000.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.0.0.00.00.00.00.00','INSCRIÇÃO DE RP PROCESSADOS','Compreende o somatório dos valores inscritos em restos a pagar processados.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.1.0.00.00.00.00.00','RP PROCESSADOS - INSCRITOS','Registra o somatório dos valores inscritos em restos a pagar processados relativos às despesas empenhadas, liquidadas e não pagas no exercício financeiro em que foi empenhado.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.2.0.00.00.00.00.00','RP PROCESSADOS - EXERCÍCIOS ANTERIORES','Registra os valores de restos a pagar processados relativos às despesas empenhadas, liquidadas e não pagas no exercício financeiro subseqüente.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.6.0.00.00.00.00.00','RP PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','Registra o valor da transferência de restos a pagar processados decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.7.0.00.00.00.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 532100000.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.0.0.0.0.00.00.00.00.00','CONTROLES DA EXECUÇÃO DO PLANEJAMENTO E ORÇAMENTO','Compreende as contas com função de registra os atos e fatos ligados a execução orçamentária.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.0.0.0.00.00.00.00.00','EXECUÇÃO DO PLANEJAMENTO','Compreende o somatório dos valores monetários relativos à execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei orçamentária anual.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.1.0.0.00.00.00.00.00','EXECUÇÃO DO PPA','Compreende o somatório dos valores monetários relativos à execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.1.1.0.00.00.00.00.00','PPA A ALOCAR NO PLOA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL DURANTE O SEU PERIODO DE VIGENCIA DETALHADO POR PROGRAMAS DE TRABALHO A SEREM SELECIONADOS NA ELABORACAO DO PLOA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.1.2.0.00.00.00.00.00','PPA ALOCADO NA LOA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL APROVADO, DETALHADO POR PROGRAMA DE TRABALHO ALOCADO NA LOA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.1.3.0.00.00.00.00.00','PPA EXECUTADO','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL EXECUTADO NO SEU PERIODO DE VIGENCIA, DETALHADO POR PROGRAMA DE TRABALHO AUTORIZADO NAS LEIS ORCAMENTARIAS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.2.0.0.00.00.00.00.00','EXECUÇÃO DO PLOA','Compreende o somatório dos valores monetários de receitas e despesas previstos no projeto de lei orçamentária durante as suas fases de tramitação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.2.1.0.00.00.00.00.00','PROCESSAMENTO DO PLOA -RECEITA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS DAS RECEITAS PREVISTAS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITACAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.2.2.0.00.00.00.00.00','PROCESSAMENTO DO PLOA -DESPESA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS FIXADOS PARA AS DESPESAS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITACAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.0.0.0.00.00.00.00.00','EXECUÇÃO DO ORÇAMENTO','Compreende o somatório dos valores relativos à realização da receita, execução da despesa e suas alterações no orçamento geral da União durante o exercício financeiro.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.0.0.00.00.00.00.00','EXECUÇÃO DA RECEITA','Compreende o somatório dos valores relativos à realização da receita pública aprovada pela lei orçamentária anual e suas alterações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.1.0.00.00.00.00.00','RECEITA A REALIZAR','Registra o somatório dos valores relativos à receita pública aprovada pela lei orçamentária anual e suas alterações, detalhada por natureza da receita.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.2.0.00.00.00.00.00','RECEITA REALIZADA','Registra o somatório dos valores relativos às receitas realizadas, detalhada por natureza de receita.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.3.0.00.00.00.00.00','(-) DEDUÇÕES DA RECEITA ORÇAMENTÁRIA','Registra o somatório dos valores relativos às deduções de receitas realizadas (devoluções, restituições, e outras), detalhada por natureza de receita.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.0.0.00.00.00.00.00','EXECUÇÃO DA DESPESA','Compreende o somatório da disponibilidade de credito orçamentário e da execução da despesa em suas diversas etapas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.0.00.00.00.00.00','DISPONIBILIDADES DE CREDITO','Compreende o somatório da disponibilidade de credito orçamentário e suas alterações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.1.00.00.00.00.00','CREDITO DISPONÍVEL','Registra o valor da disponibilidade de credito referente à dotação inicial e adicional aprovada no orçamento geral da União na loa ou lei especifica ou antecipada pela lei de diretrizes orçamentárias - LDO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.2.00.00.00.00.00','CREDITO INDISPONÍVEL','Compreende o valor da indisponibilidade de credito orçamentário pelo seu contingenciamento ou liberação pendentes de autorização legislativa.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.2.01.00.00.00.00','BLOQUEIO DE CREDITO','COMPREENDE O VALOR DA DISPONIBILIDADE DE CREDITOS ORCAMENTARIOS   POR CONTENCAO OU CONTINGENCIAMENTO PELA SETORIAL ORCAMENTARIA, SOF E OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.2.01.01.00.00.00','CREDITO BLOQUEADO PARA REMANEJAMENTO','REGISTRA O VALOR DA INDISPONIBILIDADE DE CREDITOS ORCAMENTARIOS PELA SETORIAIS DE ORCAMENTO PARA REMANEJAMENTO DE FONTE OU GRUPO DE DESPESA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.2.01.02.00.00.00','CREDITO BLOQUEADO PARA CONTROLE INTERNO','REGISTRA OS VALORES DE CREDITOS INDISPONIBILIZADOS INTERNAMENTE  PELOS ORGAOS PARA CONTROLE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.2.99.00.00.00.00','OUTRAS INDISPONIBILIDADES','REGISTRA O VALOR DAS INDISPONIBILIDADES DE CREDITOS ORCAMENTARIOS DE NATUREZA EVENTUAL, PARA AS QUAIS NAO HA CONTAS ESPECIFICAS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.00.00.00.00.00','CREDITO UTILIZADO','Compreende o somatório dos valores referentes aos créditos orçamentários empenhados.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.01.00.00.00.00','CREDITO EMPENHADO A LIQUIDAR','Registra o valor da despesa empenhada a ser liquidada','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.02.00.00.00.00','CREDITO EMPENHADO EM LIQUIDAÇÃO','Registra o valor da despesa cujo fato gerador já ocorreu, mas que ainda não foram conferidos o objeto, e o valor, ou seja, não houve a liquidação.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.03.00.00.00.00','CREDITO EMPENHADO LIQUIDADO A PAGAR','Registra o valor da apropriação das despesas empenhadas com posterior verificação de sua regularidade por constituição do direto do credor.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.04.00.00.00.00','CREDITO EMPENHADO LIQUIDADO PAGO','Demonstra o valor da despesa empenhada liquidada paga.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.05.00.00.00.00','EMPENHOS A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NÃO PROCESSADOS','Registra o montante dos valores a liquidar inscritos em restos a pagar nao processados.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.06.00.00.00.00','EMPENHOS EM LIQUIDACAO INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS','Registra o montante dos valores em liquidação inscritos em restos a pagar nao processados.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.07.00.00.00.00','EMPENHOS LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS','Registra o montante dos valores liquidados inscritos em restos a pagar processados.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.99.00.00.00.00','(-) OUTROS CRÉDITOS UTILIZADOS','Registra a contrapartida de despesas realizadas pelas entidades ou órgão da administração direta/indireta que utilizam o SIAFI no modulo parcial.   Registra a contrapartida de despesas liquidadas na rotina de suprimento de fundos para evitar a emissão de lista de item (li) para reclassificação da despesa.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.0.00.00.00.00.00','MOVIMENTAÇÃO DE CRÉDITOS CONCEDIDOS','Compreende o somatório dos valores dos créditos orçamentários concedidos através de destaque, provisão ou por fusão, cisão ou extinção de unidades.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.1.00.00.00.00.00','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO','Compreende os valores dos créditos descentralizados das unidades orçamentárias para as unidades administrativas sob sua jurisdição ou entre estas, no âmbito do próprio ministério, secretaria ou órgão equivalente, concedidos ao longo do exercício.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.1.01.00.00.00.00','PROVISAO CONCEDIDA','REGISTRA O CREDITO CONCEDIDO PELA UNIDADE ORCAMENTARIA A PARTIR DE SUA PROPRIA DOTACAO OU DE UM DESTAQUE A SEU FAVOR, PARA UNIDADE ADMINISTRATIVA OU ORCAMENTARIA, NO AMBITO DO PROPRIO MINISTERIO OU ORGAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.00.00.00.00.00','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','Compreende a descentralização do credito inicial ou adicional concedido de unidades ou órgãos pertencentes a ministérios, secretarias e órgãos equivalentes distintos ou entre estes e entidades da administração indireta.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.01.00.00.00.00','ADMINISTRACAO DIRETA','REGISTRA O VALOR REFERENTE AO MOVIMENTO DE CREDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO DIRETA TRANSFERIDORA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.01.01.00.00.00','CREDITOS CONCEDIDOS','REGISTRA O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES   DE CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO DIRETA  TRANSFERIDORA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.02.00.00.00.00','ADMINISTRACAO INDIRETA','REGISTRA O VALOR REFERENTE AO MOVIMENTO DE CREDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DA ENTIDADE DA ADMINISTRACAO INDIRETA TRANSFERIDORA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.02.01.00.00.00','CREDITOS CONCEDIDOS','REGISTRA O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES   DE SUA CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO  INDIRETA TRANSFERIDORA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.9.00.00.00.00.00','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','Compreende as movimentações de créditos concedidos por cisão, fusão, extinção, compensação e outras transações.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.3.0.00.00.00.00.00','DETALHAMENTO DE CREDITO','Registra o detalhamento das dotações orçamentárias relativas a cada programa de trabalho.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.0.00.00.00.00.00','OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA','Compreende o somatório dos valores executados das despesas pré-empenhadas e empenhadas por detalhamento específico.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.00.00.00.00.00','EMISSAO DE EMPENHO','COMPREENDE O SOMATORIO DOS VALORES EXECUTADOS DAS DESPESAS EMPENHADAS POR DETALHAMENTO ESPECIFICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.00.00.00.00','EMPENHOS POR NOTA DE EMPENHO + SUBITEM','COMPREENDE O VALOR DA EMISSAO DE DOCUMENTOS ATRAVES DOS QUAIS SAO REGISTRADOS OS ESTAGIOS DAS DESPESAS ORCAMENTARIAS REALIZADAS PELA ADMINISTRACAO PUBLICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.01.00.00.00','EMPENHOS A LIQUIDAR','REGISTRA O VALOR DOS EMPENHOS DE DESPESAS PENDENTES DE  LIQUIDACAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.02.00.00.00','EMPENHOS EM LIQUIDACAO','REGISTRA O SOMATORIO DAS DESPESAS  CUJO FATO GERADOR TENHA OCORRIDO, TENDO INICIADO E NAO CONCLUIDO O PROCESSO DE LIQUIDACAO DA DESPESA ORCAMENTARIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.03.00.00.00','EMPENHOS LIQUIDADOS','REGISTRA O VALOR DOS EMPENHOS APOS VERIFICACAO DO DIREITO ADQUIRIDO PELO CREDOR OU ENTIDADE BENEFICIARIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.07.00.00.00','ANULACAO DE EMPENHOS','REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA ORCAMENTARIA  A DOTACAO CORRESPONDENTE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.08.00.00.00','CANCEL. DE EMPENHO POR FALTA DE DISPON. CAIXA','REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA  ORCAMENTARIA A DOTACAO CORRESPONDENTE POR FALTA DE DISPONIBILIDADE DE CAIXA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.02.00.00.00.00','EMPENHOS POR MODALIDADE DE LICITACAO - A LIQUIDAR','COMPREENDE O VALOR DOS EMPENHOS A LIQUIDAR, COM CONTROLE POR MODALIDADE DE LICITACAO OU POR SUA DISPENSA OU INEXIGIBILIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.02.01.00.00.00','CONCORRENCIA','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO - CONCORRENCIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.02.02.00.00.00','TOMADA DE PRECOS','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO - TOMADA DE PRECOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.02.03.00.00.00','CONVITE','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO-CONVITE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.02.04.00.00.00','CONCURSO','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCURSO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.02.05.00.00.00','PREGAO','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS NA MODALIDADE DE PREGAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.02.06.00.00.00','CONSULTA','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS NA MODALIDADE DE CONSULTA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.02.07.00.00.00','DISPENSAVEL POR LIMITE','REGISTRA O VALOR DO EMPENHOS A LIQUIDAR, CONTROLADOS POR DISPENSA DE LICITACAO NO ASPECTO RELACIONADO AOS LIMITES MONETARIOS DE DISPENSA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.02.08.00.00.00','OUTRAS DISPENSAS DE LICITACAO','REGISTRA O VALOR DO EMPENHOS A LIQUIDAR, CONTROLADOS POR DISPENSA DE LICITACAO EXCETO AQUELES RELACIONADOS AOS LIMITES MONETARIOS DE DISPENSA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.02.09.00.00.00','LICITACAO INEXIGIVEL','REGISTRA O VALOR DO EMPENHOS A LIQUIDAR, CONTROLADOS POR INEXIGIBILIDADE DE LICITACAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.02.10.00.00.00','NAO APLICAVEL','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, ONDE NAO SE APLICA A LICITACAO, DENTRE OS QUAIS CABE DESTACAR: PESSOAL E ENCARGOS SOCIAIS, TRANSFERENCIAS CONSTITUCIONAIS, TRANSFERENCIAS VOLUNTARIAS, AMORTIZACAO DA DIVIDA E RESSARCIMENTO E RESTITUICOES.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.02.11.00.00.00','SUPRIMENTOS DE FUNDOS','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR DESTINADOS A ATENDER SUPRIMENTOS DE FUNDOS, NA FORMA DA LEGISLACAO EM VIGOR.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.00.00.00.00','EMPENHOS POR MODALIDADE DE LICITACAO - LIQUIDADO','COMPREENDE O VALOR DOS EMPENHOS LIQUIDADOS, COM CONTROLE POR MODALIDADE DE LICITACAO OU POR SUA DISPENSA OU INEXIGIBILIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.01.00.00.00','CONCORRENCIA','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCORRENCIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.02.00.00.00','TOMADA DE PRECOS','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-TOMADA DE PRECOS .','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.03.00.00.00','CONVITE','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONVITE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.04.00.00.00','CONCURSO','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCURSO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.05.00.00.00','PREGAO','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-PREGAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.06.00.00.00','CONSULTA','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONSULTA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.07.00.00.00','DISPENSAVEL POR LIMITE','REGISTRA O VALOR DO EMPENHOS A LIQUIDADOS, CONTROLADOS POR DISPENSA DE LICITACAO NO ASPECTO RELACIONADO AOS LIMITES MONETARIOS DE DISPENSA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.08.00.00.00','OUTRAS DISPENSAS DE LICITACAO','REGISTRA O VALOR DO EMPENHOS A LIQUIDADOS, CONTROLADOS POR DISPENSA DE LICITACAO EXCETO AQUELES RELACIONADOS AOS LIMITES MONETARIOS DE DISPENSA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.09.00.00.00','LICITACAO INEXIGIVEL','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR INEXIGIBILIDADE DE LICITACAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.10.00.00.00','NAO APLICAVEL','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, ONDE NAO SE APLICA A LICITACAO, DENTRE OS QUAIS CABE DESTACAR: PESSOAL E ENCARGOS SOCIAIS, TRANSFERENCIAS CONSTITUCIONAIS, TRANSFERENCIAS VOLUNTARIAS, AMORTIZACAO DA DIVIDA E RESSARCIMENTO E RESTITUICOES.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.11.00.00.00','SUPRIMENTOS DE FUNDOS','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS DESTINADOS A ATENDER SUPRIMENTOS DE FUNDOS, NA FORMA DA LEGISLACAO EM VIGOR.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.00.00.00.00','EMPENHOS POR CREDOR','COMPREENDE O SOMATORIO DA EXECUCAO DE CREDITOS ORCAMENTARIOS, CONTROLADOS POR BENEFICIARIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.01.00.00.00','VALORES A LIQUIDAR','REGISTRA O MONTANTE DOS VALORES A LIQUIDAR, A SEREM PAGOS, POR BENEFICIARIOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.02.00.00.00','VALORES EM LIQUIDACAO','REGISTRA O SOMATORIO DAS DESPESAS  CUJO FATO GERADOR TENHA OCORRIDO, TENDO INICIADO E NAO CONCLUIDO O PROCESSO DE LIQUIDACAO DA DESPESA ORCAMENTARIA, CONTROLADOS POR BENEFICIARIO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.03.00.00.00','VALORES LIQUIDADOS A PAGAR','REGISTRA O MONTANTE DOS VALORES LIQUIDADOS, A SEREM PAGOS, POR BENEFICIARIOS.  O SALDO DESTA CONTA EM 31 DE DEZEMEBRO SERA TRANSFERIDO PARA A CONTA 532110000 - RP PROCESSADO INSCRITO EM 01 DE JANEIRO DO EXERCICIO SUBSEQUENTE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.04.00.00.00','VALORES PAGOS','REGISTRA O MONTANTE DOS VALORES PAGOS, CONTROLADOS POR BENEFICIARIOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.05.00.00.00','EMPENHOS INSCRITOS EM RESTOS A PAGAR','REGISTRA O MONTANTE DOS VALORES DOS EMPENHOS INSCRITOS EM RESTOS A PAGAR, CONTROLADOS POR BENEFICIARIO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.00.00.00.00','EMPENHOS DE RESTOS A PAGAR - POR CREDOR','REGISTRA O VALOR DOS EMPENHOS DE RESTOS A PAGAR, CONTROLADOS POR BENEFICIARIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.01.00.00.00','RESTOS A PAGAR A LIQUIDAR','REGISTRA O VALOR DOS EMPENHOS DE RESTOS A PAGAR INSCRITOS NO  ENCERRAMENTO DO EXERCICIO FINANCEIRO DE EMISSAO DA NOTA DE EMPENHO E TRANSFERIDOS AUTOMATICAMENTE DA CONTA 292410505.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.02.00.00.00','RESTOS A PAGAR LIQUIDADOS - NO EXERCICIO CORRENTE','REGISTRA O VALOR DOS RESTOS A PAGAR, CONTROLADOS POR  BENEFICIARIO LIQUIDADOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.03.00.00.00','RESTOS A PAGAR PAGOS - CONTROLE POR CNPJ','REGISTRA O VALOR DOS RESTOS A PAGAR PAGOS, CONTROLADOS POR  BENEFICIARIO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.04.00.00.00','INSCRICAO DE RESTOS A PAGAR','REGISTRA O VALOR DOS EMPENHOS DE RESTOS A PAGAR INSCRITOS NO  ENCERRAMENTO DO EXERCICIO FINANCEIRO DE EMISSAO DA NOTA DE EMPENHO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.05.00.00.00','RESTOS A PAGAR LIQUIDADOS - NO EXERCICIO  ANTERIOR','REGISTRAR O VALOR DOS RESTOS A PAGAR LIQUIDADOS (A PAGAR) CONTROLADOS POR NÚMERO DE EMPENHO. O SALDO DESTA CONTA É ORIGINADO DA LEITURA DO SALDO EXISTENTE NA CONTA 2.9.2.4.1.04.02, SENDO TRANSPORTADO NO EXERCÍCIO POSTERIOR PARA A CONTA 2.9.2.3.1.05.08. SE','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.06.00.00.00','CANCELAMENTO DE RESTOS A PAGAR  NAO PROCESSADOS','REGISTRA OS VALORES DOS RESTOS A PAGAR CANCELADOS PELA UNIDADE  GESTORA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.07.00.00.00','RESTOS A PAGAR PROCESSADOS PAGOS - CONTROLE POR NE','REGISTRA O VALOR DOS RESTOS A PAGAR PAGOS, CONTROLADOS POR  NUMERO  DE EMPENHO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.08.00.00.00','CANCELAMENTO DE RESTOS A PAGAR PROCESSADOS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS CANCELADOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.99.00.00.00','OUTRAS INSCRICOES DE RESTOS A PAGAR','REGISTRA A CONTRAPARTIDA DOS LANCAMENTOS EFETUADOS EM EMPENHOS DE RESTOS A PAGAR CONTROLADOS POR BENEFICIARIO, POR OCASIAO DO ENCERRAMENTO DO EXERCICIO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.0.0.0.00.00.00.00.00','EXECUÇÃO DE RESTOS A PAGAR','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas e não pagas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.0.0.00.00.00.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, não liquidadas no exercício financeiro de sua inscrição e não pagas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.1.0.00.00.00.00.00','RP NÃO PROCESSADOS A LIQUIDAR','Registra o valor dos RP não processados ainda não liquidados.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.2.0.00.00.00.00.00','RP NÃO PROCESSADOS EM LIQUIDAÇÃO','Registra o valor dos RP não processados ainda não liquidados cujo fato gerador já ocorreu.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.3.0.00.00.00.00.00','RP NÃO PROCESSADOS LIQUIDADOS A PAGAR','Registra o valor dos RP não processados, liquidados após sua inscrição e ainda não pagos.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.4.0.00.00.00.00.00','RP NÃO PROCESSADOS PAGOS','Registra o valor dos RP não processados, liquidados após sua inscrição e pagos.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.5.0.00.00.00.00.00','RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS','Registra o valor de restos a pagar não processados a liquidar, bloqueado por decreto.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.6.0.00.00.00.00.00','RP NÃO PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar não processados pela desincorporação de saldos decorrentes de transformação, cisão, fusão e extinção de órgãos ou UG.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.7.0.00.00.00.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 631100000 e 631200000.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.9.0.00.00.00.00.00','RP NÃO PROCESSADOS CANCELADOS','Compreende o cancelamento de restos a pagar não processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.9.1.00.00.00.00.00','POR INSUFICIENCIA DE RECURSOS','REGISTRA O VALOR DOS RESTOS A PAGAR NAO PROCESSADOS  CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO POR INSUFICIENCIA DE RECURSOS FINANCEIROS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.9.9.00.00.00.00.00','OUTROS CANCELAMENTOS DE RP','REGISTRA O VALOR DOS RESTOS A PAGAR NAO PROCESSADOS  CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO, EXCETO OS CANCELADOS POR INSUFICIENCIA DE RECURSOS FINANCEIROS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.0.0.00.00.00.00.00','EXECUÇÃO DE RP PROCESSADOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, liquidadas no exercício financeiro de sua inscrição e não pagas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.1.0.00.00.00.00.00','RP PROCESSADOS A PAGAR','Registra o valor dos RP processados e não pagos.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.2.0.00.00.00.00.00','RP PROCESSADOS PAGOS','Registra o valor dos RP processados pagos.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.6.0.00.00.00.00.00','RP PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar pela desincorporação de saldos decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.7.0.00.00.00.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 632100000.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.9.0.00.00.00.00.00','RP PROCESSADOS CANCELADOS','Compreende o cancelamento de restos a pagar processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.9.1.00.00.00.00.00','POR VALORES E/OU INSCRICOES INDEVIDAS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS  CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO POR VALORES E/OU INSCRICOES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.9.1.01.00.00.00.00','CANCELAMENTO DE RP PROCESSADOS - NE','REGISTRA O VALOR DE RESTOS A PAGAR PROCESSADOS CANCELADOS NO EXERCICIO SEGUINTE, CONTROLADOS POR NOTA DE EMPENHO, COM A RESPECTIVA BAIXA NO PASSIVO FINANCEIRO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.9.1.02.00.00.00.00','AJUSTE DE CONTROLE RP DE EXERC ANTERIORES','REGISTRA O VALOR DO AJUSTE DE RESTOS A PAGAR PROCESSADOS CANCELADOS SEM PASSIVO CORRESPONDENTE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.9.9.00.00.00.00.00','OUTROS CANCELAMENTOS DE RP','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS  CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO, EXCETO OS CANCELADOS POR INSUFICIENCIA DE RECURSOS FINANCEIROS OU POR INSCRICAO INDEVIDA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.0.0.0.0.00.00.00.00.00','CONTROLES DEVEDORES','Compreende as contas em que são registrados atos potenciais e controles específicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.0.0.0.00.00.00.00.00','ATOS POTENCIAIS','Compreende contas relacionadas às situações não compreendidas no patrimônio, mas que, direta ou indiretamente, possam vir à afeta-lo, exclusive as que dizem respeito a atos e fatos ligados a execução orçamentária e financeira e as contas com função precípua de controle.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.0.0.00.00.00.00.00','ATOS POTENCIAIS ATIVOS','Registra os atos e fatos que possam vir a aumentar o ativo da entidade governamental.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.0.00.00.00.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS','Compreende contas relacionadas ao registro de avais, fianças e hipotecas recebidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.00.00.00.00.00','GARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO  FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO PAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.01.00.00.00.00','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.02.00.00.00.00','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA NO PAIS, POR ORGAOS E ENTIDADES,  PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE  NAO CUMPRA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.03.00.00.00.00','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS   NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.04.00.00.00.00','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.05.00.00.00.00','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.06.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.07.00.00.00.00','APOLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS  NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.99.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS   NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.00.00.00.00.00','GARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO  FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.01.00.00.00.00','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.02.00.00.00.00','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE  NAO CUMPRA, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.03.00.00.00.00','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS   NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.04.00.00.00.00','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.05.00.00.00.00','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.06.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.07.00.00.00.00','APOLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS  NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.99.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS   NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.3.00.00.00.00.00','CONTRAGARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS  CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.3.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES  DAS  CONCESSOES  DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.3.02.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS  RECEBIDAS TERCEIROS DECORRENTES  DAS  CONCESSOES  DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.3.03.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES  DAS  CONCESSOES  DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.3.99.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS   NOS ITENS ANTERIORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.4.00.00.00.00.00','CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS  CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.4.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS','REGISTRA  O  VALOR  DAS  CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.4.02.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.4.03.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS EM VIRTUDE DE GARANTIAS INSTITUI-DAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.4.99.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS   NOS ITENS ANTERIORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.2.0.00.00.00.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no convenente, dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.2.1.00.00.00.00.00','VALORES FIRMADOS','REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES  FIRMADOS  MANTENDO-O  ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.2.2.00.00.00.00.00','TERMO DE COOPERACAO','COMPREENDE O VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO  FIRMADOS  MANTENDO-O  ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.0.00.00.00.00.00','DIREITOS CONTRATUAIS','Compreende contas relacionadas ao registro dos valores de direitos contratuais, quando a administração pública participa como contratada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.00.00.00.00.00','DE TERCEIROS','COMPREENDE O VALOR DOS DIREITOS E OBRIGACOES CONTRATUAIS EM QUE A  ADMINISTRACAO PUBLICA SEJA SEGNATARIA DO CONTRATO COM TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.01.00.00.00.00','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.02.00.00.00.00','CONTRATOS DE SERVICOS','REGISTRA O VALOR DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.03.00.00.00.00','CONTRATOS DE ALUGUEIS','REGISTRA O VALOR DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.04.00.00.00.00','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS PELA  ADMINISTRACAO PUBLICA A TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.05.00.00.00.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','REGISTRA O VALOR DO CONTRATO DE OBRIGACAO DA ENTEDADE PUBLICA COM TERCEIROS REFEREN-E A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.2.00.00.00.00.00','CONTRATO DE GESTAO','COMPREENDE O VALOR CONSOLIDADO DOS DESDOBRAMENTOS DA REFERIDA CONTA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.2.01.00.00.00.00','CONTRATOS DE GESTAO A LIQUIDAR','REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO  PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.2.02.00.00.00.00','CONTRATOS DE GESTAO LIQUIDADOS','REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.9.0.00.00.00.00.00','OUTROS ATOS POTENCIAIS ATIVOS','Compreende os atos potenciais ativos não contemplados em contas especificas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.9.1.00.00.00.00.00','PLANO DE AMORTIZAÇÃO DO DÉFICIT ATUARIAL','REGISTRAR, A TÍTULO DE CONTROLE, OS VALORES RELATIVOS AO PLANO DE AMORTIZAÇÃO DO DÉFICIT ATUARIAL DO RPPS PELO ENTE PÚBLICO QUE O INSTITUIU.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.9.2.00.00.00.00.00','PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','REGISTRAR, A TÍTULO DE CONTROLE, OS VALORES RELATIVOS ÀS PARCELAS DE DÉBITOS PREVIDENCIÁRIOS DO RPPS DEVIDAS PELO ENTE PÚBLICO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.0.0.00.00.00.00.00','ATOS POTENCIAIS PASSIVOS','Compreende os atos e fatos que possam vir a aumentar o passivo ou diminuir o ativo da entidade governamental.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.0.00.00.00.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','Compreende contas relacionadas ao registro de avais, fianças e hipotecas concedidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.00.00.00.00.00','GARANTIAS CONCEDIDAS NO PAIS','COMPREENDE O VALOR CONCEDIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO  FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO PAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.01.00.00.00.00','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, CONCEDIDA A TERCEIROS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.02.00.00.00.00','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA NO PAIS, POR ORGAOS E ENTIDADES,  PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE  NAO CUMPRA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.03.00.00.00.00','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS  NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.99.00.00.00.00','OUTRAS GARANTIAS CONCEDIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NAO INCLUIDAS   NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.2.00.00.00.00.00','GARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE O VALOR CONCEDIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO  FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.2.01.00.00.00.00','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.2.02.00.00.00.00','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE  NAO CUMPRA, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.2.03.00.00.00.00','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS   NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.3.00.00.00.00.00','CONTRAGARANTIAS CONCEDIDAS NO PAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS  CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.3.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS DECORRENTES  DAS  CONCESSOES  DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.3.02.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS  CONCEDIDAS TERCEIROS DECORRENTES  DAS  CONCESSOES  DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.3.03.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS DECORRENTES  DAS  CONCESSOES  DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.3.99.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NAO INCLUIDAS   NOS ITENS ANTERIORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.4.00.00.00.00.00','CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS  CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.4.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDAS','REGISTRA  O  VALOR  DAS  CONTRAGARANTIASCONCEDIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.4.02.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.4.03.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS EM VIRTUDE DE GARANTIAS INSTITUI-DAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.4.99.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NAO INCLUIDAS   NOS ITENS ANTERIORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.2.0.00.00.00.00.00','OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no concedente, do valor dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.0.00.00.00.00.00','OBRIGAÇÕES CONTRATUAIS','Compreende contas relacionadas ao registro dos valores de obrigações contratuais, quando a administração pública participa como contratante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.00.00.00.00.00','COM TERCEIROS','COMPREENDE O VALOR DO CONTRATO ASSINADO ENTRE A UG CONTRATANTE  E PARTICULARES OU OUTRO ORGAO OU ENTIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.01.00.00.00.00','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.02.00.00.00.00','CONTRATOS DE SERVICOS','REGISTRA O VALOR DO CONTRATO ASSINADO ENTRE A ADMINISTRACAO PUBLICA E O  PRESTADOR DE SERVICOS A TITULO DE OBRAS E INSTALACAO E DEMAIS SERVICOS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.03.00.00.00.00','CONTRATOS DE ALUGUEIS','REGISTRA O VALOR DO CONTRATO DE LOCACAO DE BENS MOVEIS E IMOVEIS ENTRE A ADMINISTRACAO E TERCEIROS LOCADORES DE TAIS BENS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.04.00.00.00.00','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS ENTRE A  ADMINISTRACAO E O FORNECEDOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.05.00.00.00.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','REGISTRA A APROPRIACAO DE AJUSTE OU ASSINATURA DE CONTRATOS DE CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.06.00.00.00.00','CONTRATO DE GESTAO','COMPREENDE AS CONTAS QUE REGISTRAM OS CONTRATOS DE GESTAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.06.01.00.00.00','CONTRATOS DE GESTAO A LIQUIDAR','REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO  PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.06.02.00.00.00','CONTRATOS DE GESTAO LIQUIDADOS','REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.07.00.00.00.00','CONTRATOS DE OPERACOES DE CREDITO','REGISTRA O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO  ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.9.0.00.00.00.00.00','OUTROS ATOS POTENCIAIS PASSIVOS','Compreende os atos potenciais passivos não contemplados em contas especificas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.9.1.00.00.00.00.00','BENEFICIARIOS DE SENTENCAS JUDICIAIS INCLUIDAS NO ORCAMENTO','REGISTRA OS PRECATÓRIOS, RECEBIDOS NO EXERCÍCIO ANTERIOR E INCLUÍDOS NO ORÇAMENTO PARA PAGAMENTO ATÉ O FINAL DO EXERCÍCIO. PODE SE MANTER O CONTROLE  NESTE GRUPO POR BENEFICIÁRIO','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.9.2.00.00.00.00.00','BENEFICIARIOS DE SENTENCAS JUDICIAIS AINDA NAO INCLUIDAS NO ORCAMENTO','REGISTRA OS PRECATÓRIOS, RECEBIDOS NO EXERCÍCIO E QUE SERÃO INCLUÍDOS NO ORÇAMENTO SEGUINTE PARA PAGAMENTO ATÉ O FINAL DAQUELE EXERCÍCIO. PODE SE MANTER O CONTROLE  NESTE GRUPO POR BENEFICIÁRIO','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.0.0.0.00.00.00.00.00','ADMINISTRAÇÃO FINANCEIRA','Compreende as contas de registro da programação financeira e de controle das disponibilidades.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.0.0.00.00.00.00.00','DISPONIBILIDADES POR DESTINAÇÃO','Compreende as contas que registram os controles sobre as disponibilidades por destinação de recursos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.1.0.00.00.00.00.00','CONTROLE DA DISPONIBILIDADE DE RECURSOS','Compreende as contas que registram as disponibilidades de recursos recebidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.1.1.00.00.00.00.00','DISPONIBILIDADE DE RECURSOS','REGISTRA O TOTAL DE RECURSOS DISPONIBILIZADOS, JA COMPROMETIDOS OU NAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.2.0.00.00.00.00.00','LIMITE DE RESTOS A PAGAR POR DESTINAÇÃO','Compreende as contas que controlam a inscrição do limite de restos a pagar, classificados por destinação de recursos','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.2.1.00.00.00.00.00','INSCRICAO DO LIMITE DE RESTOS A PAGAR CONCEDIDO POR DESTINACAO','REGISTRA AS CONTAS QUE CONTROLAM A INSCRICAO DO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS, NAS UG''S RESPONSAVEIS EM ENVIAR RECURSOS FINANCEIROS DESTINADOS AO PAGAMENTO DE RESTOS A PAGAR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.2.2.00.00.00.00.00','INSCRICAO DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINACAO','REGISTRA AS CONTAS QUE CONTROLAM A INSCRICAO DO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS, NAS UG''S CUJOS RECURSOS FINANCEIROS SAO INSUFICIENTES PARA HONRAREM TODOS OS COMPROMISSOS INSCRITOS EM RESTOS A PAGAR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.3.0.00.00.00.00.00','RECURSO DIFERIDO POR DESTINAÇÃO','Compreende as contas que controlam a inscrição dos recursos diferidos. Recursos diferidos são as sobras de recursos financeiros ao final do exercício (recurso diferido), que deveriam ser devolvidas a conta única, porem, ao invés disso, essas sobras são liberadas para uso (apenas no exercício seguinte) através de descontos das transferências financeiras (cota, repasse e sub-repasse) do exercício seguinte.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.0.0.00.00.00.00.00','PROGRAMAÇÃO FINANCEIRA','Compreende as contas que registram as cotas, repasses e sub-repasses para atender a despesas orçamentárias, restos a pagar autorizados e demais dispêndios extra orçamentários.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.1.0.00.00.00.00.00','CONCESSAO DE RECURSOS FINANCEIROS','COMPREENDE AS CONTAS QUE REGISTRAM A CONCESSAO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.1.1.00.00.00.00.00','COTAS DECORRENTES DO ORCAMENTO','REGISTRAM O VALOR TOTAL DAS COTAS, CONCEDIDAS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.1.4.00.00.00.00.00','REPASSES DECORRENTES DO ORCAMENTO','REGISTRA O VALOR TOTAL DOS REPASSES, CONCEDIDOS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.1.7.00.00.00.00.00','SUB-REPASSES DECORRENTES DO ORCAMENTO','REGISTRAM O VALOR TOTAL DOS SUB-REPASSES, CONCEDIDOS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.2.0.00.00.00.00.00','RECEBIMENTO DE RECURSOS FINANCEIROS','COMPREENDE AS CONTAS QUE REGISTRAM O RECEBIMENTO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.2.1.00.00.00.00.00','COTAS DECORRENTES DO ORCAMENTO','REGISTRAM O VALOR TOTAL DAS COTAS, RECEBIDAS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.2.4.00.00.00.00.00','REPASSES DECORRENTES DO ORCAMENTO','REGISTRAM O VALOR TOTAL DOS REPASSES, RECEBIDOS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.2.7.00.00.00.00.00','SUB-REPASSES DECORRENTES DO ORCAMENTO','REGISTRA O VALOR TOTAL DOS SUB-REPASSES, RECEBIDOS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.3.0.0.00.00.00.00.00','INSCRIÇÃO DO LIMITE ORÇAMENTÁRIO','Compreende as contas que controlam o limite de empenho e movimentação de créditos orçamentários, conforme estabelecidos em ato próprio dos poderes e ministério público.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.3.1.0.00.00.00.00.00','CONTROLE DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','COMPREENDE AS CONTAS QUE CONTROLAM O LIMITE ORCAMENTARIO NO OCPF','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.4.0.0.00.00.00.00.00','CONTROLES DA ARRECADAÇÃO','Compreende as contas que registram o valor da arrecadação liquida da receita orçamentária, por meio de documentos de arrecadação como DARF, GRU, DAR, entre outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.4.1.0.00.00.00.00.00','CONTROLES DE DOCUMENTOS DE ARRECADAÇÃO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.4.1.1.00.00.00.00.00','CONTROLES DE DOCUMENTOS DE ARRECADAÇÃO POR CODIGO DE RECEITA','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADAÇÃO, CLASSIFICADA POR CODIGO DE RECEITA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.4.1.3.00.00.00.00.00','CONTROLES DE DOCUMENTOS DE ARRECADAÇÃO POR CODIGO DE DESTINACAO VINCULADA','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADAÇÃO, CLASSIFICADA POR CODIGO DE DESTINACAO VINCULADA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.0.0.0.00.00.00.00.00','DIVIDA ATIVA','Registra o controle dos créditos a serem inscritos em divida ativa, dos que se encontram em processamento. Compreende as contas que controlam os créditos passiveis de serem encaminhados e inscritos em divida ativa o de inscrição e a tramitação dos créditos inscritos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.1.0.0.00.00.00.00.00','CONTROLE DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DIVIDA ATIVA','Registra os valores passiveis de serem encaminhados e inscritos em divida ativa.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.1.1.0.00.00.00.00.00','ENCAMINHAMENTO DE CREDITOS','REGISTRA OS VALORES PASSIVEIS DE SEREM ENCAMINHADOS E INSCRITOS EM DIVIDA ATIVA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.2.0.0.00.00.00.00.00','CONTROLE DA INSCRIÇÃO DE CRÉDITOS EM DIVIDA ATIVA','Compreende as contas que controlam os créditos passiveis de serem inscritos em divida ativa pelo órgão responsável pela inscrição em divida ativa.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.2.1.0.00.00.00.00.00','INSCRICAO DE CREDITOS','REGISTRA OS VALORES DOS CREDITOS PASSIVEIS DE SEREM INSCRITOS EM DIVIDA ATIVA PELO ORGAO RESPONSAVEL PELA INSCRICAO EM DIVIDA ATIVA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.0.0.0.00.00.00.00.00','RISCOS FISCAIS','Compreende as contas que controlam os riscos fiscais que não preencham os requisitos para reconhecimento como passivo, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.1.0.0.00.00.00.00.00','CONTROLE DE PASSIVOS CONTINGENTES','Compreende as contas que registram o controle dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.1.1.0.00.00.00.00.00','PASSIVOS CONTINGENTES','REGISTRA OS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.2.0.0.00.00.00.00.00','CONTROLE DOS DEMAIS RISCOS FISCAIS','Compreende as contas que registram os riscos fiscais que não preencham os requisitos para reconhecimento como passivo, não classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.2.1.0.00.00.00.00.00','DEMAIS RISCOS FISCAIS','REGISTRA OS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.8.0.0.0.00.00.00.00.00','CUSTOS','Compreende as contas que controlam os custos de bens e serviços produzidos.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.0.0.0.00.00.00.00.00','OUTROS CONTROLES','Compreende as contas de controles não especificadas anteriormente nos grupos dessa classe.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.1.0.0.00.00.00.00.00','OUTROS CONTROLES DE PROGRAMACAO FINANCEIRA','COMPREENDE AS CONTAS QUE CONTROLAM OUTRAS PECULIARIDADES DA PROGRAMACAO FINANCEIRA','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.2.0.0.00.00.00.00.00','OUTROS CONTROLES DE DISPONIBILIDADES','COMPREENDE AS CONTAS QUE CONTROLAM OUTROS CONTROLES DE DISPONIBILIDADES','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.3.0.0.00.00.00.00.00','OUTROS CONTROLES DE BENEFICIOS PAGOS','COMPREENDE AS CONTAS QUE REGISTRAM O PAGAMENTO DE BENEFICIOS PREVIDENCIARIOS','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.4.0.0.00.00.00.00.00','OUTROS CONTROLES DA CONTA UNICA','COMPREENDE AS CONTAS QUE CONTROLAM A CONTA UNICA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.4.1.0.00.00.00.00.00','CONCILIACAO DA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO','COMPREENDE AS CONTAS QUE CONTROLAM A CONCILIACAO DA CONTA UNICA','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.4.4.0.00.00.00.00.00','CONTROLE DE APLICACAO FINANCEIRA NA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO','REGISTRA OS VALORES REFERENTE AO CONTROLE DE FONTE DE RECURSOS NA  NA PLICACAO FINANCEIRA','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.6.0.0.00.00.00.00.00','OUTROS CONTROLES DE OPERACOES DE CREDITOS','COMPREENDE AS CONTAS QUE CONTROLAM OPERACOES DE CREDITO','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.0.0.00.00.00.00.00','OUTROS CONTROLES DE RESPONSABILIDADES POR VALORES, TITULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DAS RESPONSABILIDADES POR VALORES, TITULOS E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.1.0.00.00.00.00.00','RESPONSABILIDADES DE TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.1.1.00.00.00.00.00','RESPONSABILIDADES DE TERCEIROS','REGISTRA AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.1.1.01.00.00.00.00','SUPRIMENTO DE FUNDOS','REGISTRA OS VALORES CONCEDIDOS A  SERVIDOR  RESPONSAVEL  PARA  ATENDER DESPESAS QUE NAO POSSAM SUBORDINAR-SE AO PROCESSO NORMAL DE APLICACAO,ATE A SUA PRESTACAO DE CONTAS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.1.1.02.00.00.00.00','OUTRAS RESPONSABILIDADES DE TERCEIROS','REGISTRA O VALOR DE OUTRAS RESPONSABILIDADES DE TERCEIROS, DE NATUREZA EVENTUAL, POR TITULOS, VALORES E BENS, PARA AS QUAIS NAO HA CONTAS ESPECIFICAS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.2.0.00.00.00.00.00','RESPONSABILIDADES COM TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.2.1.00.00.00.00.00','RESPONSABILIDADE COM TERCEIROS','REGISTRA AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.2.1.01.00.00.00.00','RECEBIDOS EM CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.2.1.02.00.00.00.00','DEPOSITOS JUDICIAIS','REGISTRA OS DEPOSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EM CONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOS POR ESTA PARA TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.2.1.03.00.00.00.00','DEPOSITOS COMPULSORIOS','REGISTRA O SOMATÓRIO DOS VALORES DOS DEPÓSITOS COMPULSÓRIOS REALIZADOS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.2.1.99.00.00.00.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NAO INDIVIDUALIZADAS NAS OUTRAS CONTAS DESSE GRUPO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.3.0.00.00.00.00.00','DIVERSOS RESPONSAVEIS EM APURACAO','REGISTRA  AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE  ATOS PRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAR EM PREJUIZOS PARA A FAZENDA MUNICIPAL.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.9.0.0.00.00.00.00.00','DEMAIS CONTROLES','COMPREENDE AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS SUBGRUPOS DESTE GRUPO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.9.8.0.00.00.00.00.00','CONTROLES REFERENTES A CONSÓRCIOS PÚBLICOS','REGISTRA A CONTRAPARTIDA DAS INFORMAÇÕES ENVIADAS PELOS CONSÓRCIOS PÚBLICOS, INSTITUIDOS DE ACORDO COM A LEI FEDERAL Nº 11.107/2005 PARA FINS DE CONSOLIDAÇÃO QUANTO AS INFORMAÇÕES PARA VERIFICAÇÃO DA APLICAÇÃO DOS INDICES MINIMOS E MÁXIMOS TRAZIDOS PELA CF/88 E LRF.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.9.9.0.00.00.00.00.00','DEMAIS CONTROLES','COMPREENDE AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS TITULOS DESTE SUBGRUPO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.0.0.0.0.00.00.00.00.00','CONTROLES CREDORES','Compreende as contas em que são registradas a execução de atos potenciais e controles específicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.0.0.0.00.00.00.00.00','EXECUÇÃO DOS ATOS POTENCIAIS','Compreende contas relacionadas à execução de situações não compreendidas no patrimônio, mas que, direta ou indiretamente, possam vir à afeta-lo, exclusive as que dizem respeito a atos e fatos ligados a execução orçamentária e financeira e as contas com função precípua de controle.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.0.0.00.00.00.00.00','EXECUÇÃO DOS ATOS POTENCIAIS ATIVOS','Registra a execução dos atos e fatos que possa vir a afetar o ativo da entidade governamental.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.0.00.00.00.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS','Compreende as contas relacionadas ao registro da execução de avais, fianças e hipotecas recebidos no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.00.00.00.00.00','EXECUCAO DE GARANTIAS RECEBIDAS NO PAIS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEDIDOS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E   CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.00.00.00.00','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS  POR AVAL PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.02.00.00.00.00','AVAIS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS RECEBIDAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.03.00.00.00.00','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS RECEBIDAS POR AVAL  NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.04.00.00.00.00','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR FIANCAS, PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.05.00.00.00.00','FIANCAS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS POR FIANCAS  EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.06.00.00.00.00','FIANCAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.07.00.00.00.00','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.08.00.00.00.00','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.09.00.00.00.00','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.10.00.00.00.00','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.11.00.00.00.00','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA  EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.12.00.00.00.00','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.13.00.00.00.00','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.14.00.00.00.00','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.15.00.00.00.00','CAUCAO EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.16.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.17.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA  EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.18.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.19.00.00.00.00','APOLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.20.00.00.00.00','APOLICES DE SEGUROS EM EXECUCAO','REGISTRA O VALOR  NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.21.00.00.00.00','APOLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.22.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.23.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS  EM EXECUCAO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.24.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS  NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.00.00.00.00.00','EXECUCAO DE GARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E   CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.01.00.00.00.00','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.02.00.00.00.00','AVAIS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.03.00.00.00.00','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR AVAL NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.04.00.00.00.00','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.05.00.00.00.00','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.06.00.00.00.00','FIANCAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.07.00.00.00.00','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.08.00.00.00.00','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.09.00.00.00.00','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.10.00.00.00.00','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.11.00.00.00.00','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA  EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.12.00.00.00.00','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.13.00.00.00.00','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.14.00.00.00.00','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.15.00.00.00.00','CAUCAO EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.16.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.17.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA  EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.18.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.19.00.00.00.00','APOLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.20.00.00.00.00','APOLICES DE SEGUROS EM EXECUCAO','REGISTRA O VALOR  NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.21.00.00.00.00','APOLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.22.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.23.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS  EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.24.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS  NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.00.00.00.00.00','EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO PAIS','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS  REFERENTES AS GARANTIAS RECEBIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.02.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS  SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.03.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.04.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.05.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.06.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.07.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.08.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.09.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.10.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.11.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS  EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.12.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.00.00.00.00.00','EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS RECEBIDAS  REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.02.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS  SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.03.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.04.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.05.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.06.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.07.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.08.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.09.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.10.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.11.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS  EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.12.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.0.00.00.00.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no convenente, da execução dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.00.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES','COMPREENDE A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES A RECEBER','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.02.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES  A COMPROVAR DE CONVENIOS PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.03.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES  A APROVAR DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.04.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES  APROVADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.05.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.06.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.07.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO FIRMADO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.08.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES NAO RECEBIDOS','REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.09.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO  DE CONVENIO FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.00.00.00.00.00','TERMO DE COOPERACAO','COMPREENDE A EXECUCAO DOS VALORES DE TERMO DE COOPERACAO PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.01.00.00.00.00','TERMO DE COOPERACAO A RECEBER','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERACAO PARA SAIDA   DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.02.00.00.00.00','TERMO DE COOPERACAO A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES  A COMPROVAR DE TERMOS DE COOPERACAO PARA SAIDA   DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.03.00.00.00.00','TERMO DE COOPERACAO A APROVAR','REGISTRA A EXECUCAO DOS VALORES  A APROVAR DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.04.00.00.00.00','TERMO DE COOPERACAO APROVADOS','REGISTRA A EXECUCAO DOS VALORES  APROVADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.05.00.00.00.00','TERMO DE COOPERACAO IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.06.00.00.00.00','TERMO DE COOPERACAO CANCELADOS','REGISTRA O VALOR CANCELADO DO TERMOS DE COOPERACAO FIRMADOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.07.00.00.00.00','TERMO DE COOPERACAO NAO RECEBIDOS','REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADOS DO TERMOS DE COOPERACAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.08.00.00.00.00','TERMO DE COOPERACAO CONCLUIDOS','REGISTRA O VALOR CONCLUIDO  DE TERMOS DE COOPERACAO FIRMADOS , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.0.00.00.00.00.00','EXECUÇÃO DE DIREITOS CONTRATUAIS','Compreende contas relacionadas ao registro da execução dos valores de direitos contratuais, quando a administração pública participa como contratada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.00.00.00.00.00','DE TERCEIROS','COMPREENDE O VALOR DOS DIREITOS E OBRIGACOES CONTRATUAIS EM QUE A  ADMINISTRACAO PUBLICA SEJA SEGNATARIA DO CONTRATO COM TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.01.00.00.00.00','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.01.01.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS SERVICOS DE  SEGUROS , CONFORME PREVISAO CONTRATUAL.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.01.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES APROPRIADOS RELATIVOS AOS SERVICOS DE  SEGUROS , CONFORME PREVISAO CONTRATUAL.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.02.00.00.00.00','CONTRATOS DE SERVICOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.02.01.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A PRESTACAO DE SERVICOS, CONFORME INSTRUMENTO CONTRATUAL EM  QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.02.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.03.00.00.00.00','CONTRATOS DE ALUGUEIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.03.01.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.03.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.04.00.00.00.00','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA  ADMINISTRACAO PUBLICA A TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.04.01.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS  VALORES A REALIZAR  RELATIVOS AOS  CONTRATOS DE FORNECIMENTO DE BENS PELA  ADMINISTRACAO PUBLICA A TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.04.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS  VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS PELA  ADMINISTRACAO PUBLICA A TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.05.00.00.00.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.05.01.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.05.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DE VALORES LIBERADOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.2.00.00.00.00.00','EXECUJÇÃO DOS CONTRATO DE GESTAO','COMPREENDE O VALOR CONSOLIDADO DA EXECUÇÃO DOS DESDOBRAMENTOS DA REFERIDA CONTA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.2.01.00.00.00.00','CONTRATOS DE GESTAO A LIQUIDAR','REGISTRA O VALOR DA EXECUÇÃO DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO  PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.2.02.00.00.00.00','CONTRATOS DE GESTAO LIQUIDADOS','REGISTRA O VALOR DA EXECUÇÃO DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.9.0.00.00.00.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS ATIVOS','Compreende a execução dos atos potenciais ativos não contemplados em contas especificas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.9.1.00.00.00.00.00','PLANO DE AMORTIZAÇÃO DO DÉFICIT ATUARIAL','REGISTRAR, A TÍTULO DE CONTROLE, OS VALORES RELATIVOS AO PLANO DE AMORTIZAÇÃO DO DÉFICIT ATUARIAL DO RPPS PELO ENTE PÚBLICO QUE O INSTITUIU.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.9.2.00.00.00.00.00','PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','REGISTRAR, A TÍTULO DE CONTROLE, OS VALORES RELATIVOS ÀS PARCELAS DE DÉBITOS PREVIDENCIÁRIOS DO RPPS DEVIDAS PELO ENTE PÚBLICO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.0.0.00.00.00.00.00','EXECUÇÃO DOS ATOS POTENCIAIS PASSIVOS','Registra a execução dos atos e fatos que possa vir a afetar o passivo da entidade governamental.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.0.00.00.00.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','Compreende contas relacionadas ao registro da execução de avais, fianças e hipotecas concedidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.00.00.00.00.00','EXECUCAO DE GARANTIAS CONCEDIDAS NO PAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E   CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.00.00.00.00','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS  POR AVAL PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.02.00.00.00.00','AVAIS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS GARANTIAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.03.00.00.00.00','AVAIS EXECUTADOS','REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL  NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.04.00.00.00.00','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.05.00.00.00.00','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.06.00.00.00.00','FIANCAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.07.00.00.00.00','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.08.00.00.00.00','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.09.00.00.00.00','HIPOTECAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.10.00.00.00.00','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.11.00.00.00.00','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA  EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.12.00.00.00.00','SEGUROS-GARANTIA EXECUTADOS','REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.13.00.00.00.00','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.14.00.00.00.00','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.15.00.00.00.00','CAUCAO EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.16.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.17.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA  EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.18.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.19.00.00.00.00','OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.20.00.00.00.00','OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS  EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.21.00.00.00.00','OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS  NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.00.00.00.00.00','EXECUCAO DE GARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E   CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.01.00.00.00.00','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.02.00.00.00.00','AVAIS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.03.00.00.00.00','AVAIS EXECUTADOS','REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.04.00.00.00.00','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.05.00.00.00.00','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.06.00.00.00.00','FIANCAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.07.00.00.00.00','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.08.00.00.00.00','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.09.00.00.00.00','HIPOTECAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.10.00.00.00.00','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.11.00.00.00.00','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA  EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.12.00.00.00.00','SEGUROS-GARANTIA EXECUTADOS','REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.13.00.00.00.00','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.14.00.00.00.00','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.15.00.00.00.00','CAUCAO EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.16.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.17.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA  EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.18.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.19.00.00.00.00','OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.20.00.00.00.00','OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS  EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.21.00.00.00.00','OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS  NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.00.00.00.00.00','EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO PAIS','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS  REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.02.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS  SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.03.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.04.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.05.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGOS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.06.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.07.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.08.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.09.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.10.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.11.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS  EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.12.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.00.00.00.00.00','EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS  REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.02.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS  SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.03.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.04.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.05.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.06.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.07.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.08.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.09.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.10.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.11.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS  EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.12.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.0.00.00.00.00.00','EXECUÇÃO DE OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no concedente, da execução do valor dos convênios e outros instrumentos congêneres firmados entre entidades, objetivando o cumprimento de finalidades comuns.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.00.00.00.00.00','EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIBERAR','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIBERAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.02.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES  A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.03.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES  A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.04.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES  APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.05.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES  IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.06.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.07.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.08.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS','REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO  DA  TRANSACAO  EXCCONV,  TIPO  DE EXECUCAO NR. 13.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.09.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO  DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.2.00.00.00.00.00','EXECUCAO DE CONTRATOS DE REPASSE DE PROGRAMAS ESPECIFICOS','COMPREENDE O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS   ESPECIFICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.2.01.00.00.00.00','CONTRATOS DE REPASSE DE PROGRAMAS A LIBERAR','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS   ESPECIFICOS A LIBERAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.2.02.00.00.00.00','CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS   ESPECIFICOS LIBERADOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.2.03.00.00.00.00','CONTR.REPASSE DE PROGR. A APROVAR','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS   ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.2.04.00.00.00.00','CONTR.REPASSE DE PROGR. APROVADO','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS   ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.2.05.00.00.00.00','CONTR.REPASSE DE PROGR. HOMOLOGADO','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS   ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.2.06.00.00.00.00','CONTR.REPASSE DE PROGR. IMPUGNADO','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS   ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS  PELO CONTROLE INTERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.0.00.00.00.00.00','EXECUÇÃO DE OBRIGAÇÕES CONTRATUAIS','Compreende contas relacionadas ao registro da execução dos valores de obrigações contratuais, quando a administração pública participa como contratante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.00.00.00.00.00','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS  VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.01.00.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE  SEGUROS , EM QUE  ADMINISTRACAO SEJA A CONTRATANTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.02.00.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVO A CONTRATOS DE  SEGUROS , EM QUE  ADMINISTRACAO SEJA A CONTRATANTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.2.00.00.00.00.00','CONTRATOS DE SERVICOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.2.01.00.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS,  EM  QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.2.02.00.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.3.00.00.00.00.00','CONTRATOS DE ALUGUEIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.3.01.00.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.3.02.00.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.4.00.00.00.00.00','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA  ADMINISTRACAO PUBLICA A TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.4.01.00.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS  VALORES A REALIZAR  RELATIVOS AOS  CONTRATOS DE FORNECIMENTO DE BENS POR TERCEIROS A  ADMINISTRACAO PUBLICA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.4.02.00.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS  VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS POR ADMINISTRACAO A  PUBLICA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.5.00.00.00.00.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.5.01.00.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.5.02.00.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DE VALORES A LIBERAREDOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.6.00.00.00.00.00','EXECUCAO DE CONTRATO DE GESTAO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DOS CONTRATOS DE GESTAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.6.01.00.00.00.00','CONTRATOS DE GESTAO A LIQUIDAR','REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO  PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.6.02.00.00.00.00','CONTRATOS DE GESTAO LIQUIDADOS','REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.7.00.00.00.00.00','CONTRATOS DE OPERACOES DE CREDITO','COMPREENDE A EXECUCAO DAS CONTAS QUE REGISTRAM  O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO  ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.7.01.00.00.00.00','EM EXECUCAO','REGISTRA  A EXECUCAO DO VALOR DO CONTRATO A LIBERAR DECORRENTE DE OPERACOES DE CREDITO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.7.02.00.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DO VALOR DO CONTRATO LIBERADO DECORRENTE DE OPERACOES DE CREDITO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.9.0.00.00.00.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS PASSIVOS','Compreende a execução dos atos potenciais passivos não contemplados em contas especificas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.9.1.00.00.00.00.00','BENEFICIARIOS DE SENTENCAS JUDICIAIS INCLUIDAS NO ORCAMENTO','REGISTRA OS PRECATÓRIOS, RECEBIDOS NO EXERCÍCIO ANTERIOR E INCLUÍDOS NO ORÇAMENTO PARA PAGAMENTO ATÉ O FINAL DO EXERCÍCIO. PODE SE MANTER O CONTROLE  NESTE GRUPO POR BENEFICIÁRIO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.9.2.00.00.00.00.00','BENEFICIARIOS DE SENTENCAS JUDICIAIS AINDA NAO INCLUIDAS NO ORCAMENTO','REGISTRA OS PRECATÓRIOS, RECEBIDOS NO EXERCÍCIO E QUE SERÃO INCLUÍDOS NO ORÇAMENTO SEGUINTE PARA PAGAMENTO ATÉ O FINAL DAQUELE EXERCÍCIO. PODE SE MANTER O CONTROLE  NESTE GRUPO POR BENEFICIÁRIO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.0.0.0.00.00.00.00.00','EXECUÇÃO DA ADMINISTRAÇÃO FINANCEIRA','Compreende as contas de registro da execução da programação financeira e de controle das disponibilidades.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.0.0.00.00.00.00.00','EXECUÇÃO DAS DISPONIBILIDADES POR DESTINAÇÃO','Compreende as contas que registram a execução dos controles das disponibilidades por destinação de recursos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.0.00.00.00.00.00','EXECUÇÃO DA DISPONIBILIDADE DE RECURSOS','Compreende as contas que registram a execução das disponibilidades de recursos a utilizar, comprometidas e utilizadas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.1.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS','Registra o valor das disponibilidades de recursos a utilizar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.2.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR EMPENHO','Registra o valor das disponibilidades de recursos comprometidas por ocasião do empenho e não liquidadas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.3.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR LIQUIDAÇÃO E ENTRADAS COMPENSATÓRIAS','Registra o valor das disponibilidades de recursos comprometidas por ocasião da liquidação e de entradas compensatórias e não pagas/devolvidas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.4.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS UTILIZADA','Registra o valor das disponibilidades de recursos utilizadas por meio de pagamento de despesa orçamentária, depósitos e/ou outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.5.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR PROGRAMAÇÃO FINANCEIRA','Registra o valor das disponibilidades de recursos comprometidas por programação financeira no órgão central de programação financeira.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.0.00.00.00.00.00','EXECUÇÃO FINANCEIRA DO LIMITE DE RESTOS A PAGAR','Compreende as contas que registram a execução financeira do limite de restos a pagar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.1.00.00.00.00.00','EXECUCAO FINANCEIRA DO LIMITE  DE RESTOS A PAGAR CONCEDIDO POR DESTINACAO','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR CONCEDIDO POR DESTINACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.1.01.00.00.00.00','VALORES DE LIMITE DE RP A CONCEDER','REGISTRA O VALORES A CONCEDER, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.1.02.00.00.00.00','VALORES DE LIMITE DE RP CONCEDIDO','REGISTRA O VALORES CONCEDIDOS, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.2.00.00.00.00.00','EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINACAO','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.2.01.00.00.00.00','VALORES DE LIMITE DE RP A RECEBER','REGISTRA O VALORES A RECEBER, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.2.02.00.00.00.00','VALORES DE LIMITE DE RP RECEBIDO','REGISTRA O VALORES RECEBIDOS, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.3.0.00.00.00.00.00','EXECUÇÃO DO RECURSO DIFERIDO POR DESTINAÇÃO','Compreende as contas que controlam a execução dos recursos diferidos. Recursos diferidos são as sobras de recursos financeiros ao final do exercício (recurso diferido), que deveriam ser devolvidas a conta única, porem, ao invés disso, essas sobras são liberadas para uso (apenas no exercício seguinte) através de descontos das transferências financeiras (cota, repasse e sub-repasse) do exercício seguinte.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.0.0.00.00.00.00.00','EXECUÇÃO DA PROGRAMAÇÃO FINANCEIRA','Compreende as contas que registram a execução das cotas, repasses e sub-repasses para atender a despesas orçamentárias, restos a pagar autorizados e demais dispêndios extra orçamentários.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.1.0.00.00.00.00.00','EXECUCAO DE CONCESSAO DE RECURSOS FINANCEIROS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DAS COTAS, REPASSES E SUB-REPASSES A CONCEDER PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.1.1.00.00.00.00.00','CONCESSAO DE COTAS DECORRENTES DO ORCAMENTO','REGISTRA AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DAS COTAS DECORRENTES DO ORCAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.1.4.00.00.00.00.00','CONCESSAO DE REPASSES DECORRENTES DO ORCAMENTO','REGISTRA AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DOS REPASSES DECORRENTES DO ORCAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.1.7.00.00.00.00.00','CONCESSAO DE SUB-REPASSES DECORRENTES DO ORCAMENTO','REGISTRA AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DOS SUB-REPASSES DECORRENTES DO ORCAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.2.0.00.00.00.00.00','EXECUCAO DO RECEBIMENTO DE RECURSOS FINANCEIROS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DO RECEBIMENTO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.2.1.00.00.00.00.00','RECEBIMENTO DE COTAS DECORRENTES DO ORCAMENTO','REGISTRA O VALOR TOTAL DAS COTAS, RECEBIDAS OU NAO, DECORRENTES DO ORCAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.2.4.00.00.00.00.00','RECEBIMENTO DE REPASSES DECORRENTES DO ORCAMENTO','REGISTRA AS CONTAS DE REGISTRO DA EXECUCAO DA RECEBIMENTO DOS REPASSES DECORRENTES DO ORCAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.2.7.00.00.00.00.00','RECEBIMENTO DE SUB-REPASSES DECORRENTES DO ORCAMENTO','REGISTRA AS CONTAS DE REGISTRO DA EXECUCAO DA RECEBIMENTO DOS SUB-REPASSES DECORRENTES DO ORCAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.3.0.0.00.00.00.00.00','EXECUÇÃO DO LIMITE ORÇAMENTÁRIO','Compreende as contas que controlam a execução do limite de empenho e movimentação de créditos orçamentários, conforme estabelecidos em ato próprio dos poderes e ministério público.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.3.1.0.00.00.00.00.00','EXECUCAO DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','REGISTRA AS CONTAS QUE CONTROLAM A EXECUCAO DO LIMITE ORCAMENTARIO NO OCPF','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.4.0.0.00.00.00.00.00','CONTROLES DA ARRECADAÇÃO','Compreende as contas que registram os valores discriminados da arrecadação da receita orçamentária, por meio de documentos de arrecadação como DARF, GRU, DAR, entre outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.4.1.0.00.00.00.00.00','CONTROLES DE DOCUMENTO DE ARRECADAÇÃO','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTO DE ARRECADAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.4.1.1.00.00.00.00.00','CONTROLES DE DOCUMENTO DE ARRECADAÇÃO POR CODIGO DE RECEITA','REGISTRA AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.4.1.3.00.00.00.00.00','CONTROLES DE DOCUMENTO DE ARRECADAÇÃO POR CODIGO DE DESTINACAO VINCULADA','REGISTRA AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTO DE ARRECADAÇÃO, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.0.0.0.00.00.00.00.00','EXECUÇÃO DA DIVIDA ATIVA','Compreende as contas que controlam a execução dos créditos passiveis de serem encaminhados e inscritos em divida ativa.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.0.0.00.00.00.00.00','EXECUÇÃO DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DIVIDA ATIVA','Compreende as contas que registram os valores a serem encaminhados e os já encaminhados para o órgão competente em inscrever em divida ativa.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.1.0.00.00.00.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA','Registra os valores a serem encaminhados para o órgão competente em inscrever em divida ativa.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.2.0.00.00.00.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA','Registra os valores encaminhados para o órgão competente em inscrever em divida ativa.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.3.0.00.00.00.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA','Registra o cancelamento dos valores indevidamente encaminhados para o órgão competente em inscrever em divida ativa.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.0.0.00.00.00.00.00','EXECUÇÃO DA INSCRIÇÃO DE CRÉDITOS EM DIVIDA ATIVA','Compreende as contas que registram os valores a serem inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.1.0.00.00.00.00.00','CRÉDITOS A INSCREVER EM DIVIDA ATIVA','Registra os valores a serem inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.2.0.00.00.00.00.00','CRÉDITOS A INSCREVER EM DIVIDA ATIVA DEVOLVIDOS','Registra os valores a serem inscritos em divida ativa que foram devolvidos pelo órgão competente, por incorreções na formalização do processo de encaminhamento.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.0.00.00.00.00.00','CRÉDITOS INSCRITOS EM DIVIDA ATIVA A RECEBER','Registra os valores inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.0.00.00.00.00.00','CRÉDITOS INSCRITOS EM DIVIDA ATIVA RECEBIDOS','Registra os valores recebidos relativos aos créditos anteriormente inscritos em divida ativa.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.0.00.00.00.00.00','BAIXA DE CRÉDITOS INSCRITOS EM DIVIDA ATIVA','Registra os valores relativos às baixas de créditos inscritos em divida ativa.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.0.0.0.00.00.00.00.00','EXECUÇÃO DOS RISCOS FISCAIS','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.0.0.00.00.00.00.00','EXECUÇÃO DE PASSIVOS CONTINGENTES','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.1.0.00.00.00.00.00','PASSIVOS CONTINGENTES PREVISTOS','REGISTRA A PREVISAO DOS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.2.0.00.00.00.00.00','PASSIVOS CONTINGENTES CONFIRMADOS','REGISTRA A CONFIRMACAO DA PREVISAO DOS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.2.0.0.00.00.00.00.00','EXECUÇÃO DOS DEMAIS RISCOS FISCAIS','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, não classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.2.1.0.00.00.00.00.00','DEMAIS RISCOS FISCAIS PREVISTOS','REGISTRA A PREVISAO DOS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.2.2.0.00.00.00.00.00','DEMAIS RISCOS FISCAIS CONFIRMADOS','REGISTRA A CONFIRMACAO DA PREVISAO DOS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.8.0.0.0.00.00.00.00.00','APURAÇÃO DE CUSTOS','Compreende as contas que controlam a execução dos custos dos bens e serviços produzidos.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.0.0.0.00.00.00.00.00','OUTROS CONTROLES','Compreende as contas de controles da execução não especificados anteriormente nos grupos dessa classe.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.0.0.00.00.00.00.00','EXECUCAO DE OUTROS CONTROLES DE PROGRAMACAO FINANCEIRA','REGISTRA AS CONTAS QUE CONTROLAM A EXECUCAO DE OUTRAS PECULIARIDADES DA PROGRAMACAO FINANCEIRA','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.0.0.00.00.00.00.00','EXECUCAO DE OUTROS CONTROLES DE DISPONIBILIDADES','REGISTRA AS CONTAS QUE CONTROLAM A EXECUCAO DE OUTROS CONTROLES DE DISPONIBILIDADES','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.3.0.0.00.00.00.00.00','EXECUCAO DE CONTROLES DE BENEFICIOS PAGOS','REGISTRA AS CONTAS QUE REGISTRAM A EXECUCAO DO PAGAMENTO DE BENEFICIOS PREVIDENCIARIOS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.4.0.0.00.00.00.00.00','EXECUCAO DE CONTROLES DA CONTA UNICA','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA CONTA UNICA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.4.1.0.00.00.00.00.00','EXECUCAO DA CONCILIACAO DA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO','REGISTRA AS CONTAS QUE CONTROLAM A EXECUCAO DA CONCILIACAO DA CONTA UNICA','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.4.4.0.00.00.00.00.00','EXECUCAO DE CONTROLE DE APLICACAO FINANCEIRA NA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO','REGISTRA AS CONTAS QUE REGISTRAM OS VALORES REFERENTE AO CONTROLE DE FONTE DE RECURSOS NA  NA PLICACAO FINANCEIRA NA CONTA ÚNICA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.6.0.0.00.00.00.00.00','CONTROLES DE OPERACOES DE CREDITOS','REGISTRA AS CONTAS QUE CONTROLAM A EXECUCAO DE OPERACOES DE CREDITO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.0.0.00.00.00.00.00','OUTROS CONTROLES DE RESPONSABILIDADES POR VALORES, TITULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DAS RESPONSABILIDADES POR VALORES, TITULOS E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.0.00.00.00.00.00','EXECUCAO DE RESPONSABILIDADES DE TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.00.00.00.00.00','RESPONSABILIDADES DE TERCEIROS','COMPREENDE A RESPONSABILIDADE DE TERCEIROS POR TITULOS, VALORES  E  BENS CONCEDIDOS PELA UNIDADE GESTORA QUE EFETUA O REGISTRO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.01.00.00.00.00','SUPRIMENTO DE FUNDOS','REGISTRA OS VALORES CONCEDIDOS A  SERVIDOR  RESPONSAVEL  PARA  ATENDERDESPESAS QUE NAO POSSAM SUBORDINAR-SE AO PROCESSO NORMAL DE APLICACAO,ATE A SUA PRESTACAO DE CONTAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.00.00.00.00','OUTRAS RESPONSABILIDADES DE TERCEIROS','COMPREENDE A RESPONSABILIDADE DE TERCEIROS POR TITULOS, VALORES  E  BENS CONCEDIDOS PELA UNIDADE GESTORA QUE EFETUA O REGISTRO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.01.00.00.00','EM CAUCAO','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR TITULOS, VALORES  E  BENS OFERECIDOS EM CAUCAO PELA UNIDADE GESTORA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.02.00.00.00','CONCEDIDOS EM CUSTODIA','REGISTRA O CONTROLE DOS BENS, TITULOS E VALORES EM PODER DE TERCEIROSSOB CUSTODIA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.03.00.00.00','DESPESAS MEDICAS','REGISTRA O VALOR DAS DESPESAS MEDICAS PAGAS  A  HOSPITAIS  E  CLINICAS TENDO COMO USUARIO OS VEREADORES E SERVIDORES.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.04.00.00.00','EM COBRANCA - A RECEBER','REGISTRA O MONTANTE DA RESPONSABILIDADE DE TERCEIROS POR VALORES,  TI-TULOS E BENS EM FASE DE COBRANCA PELA UNIDADE GESTORA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.06.00.00.00','CONCEDIDOS EM CONSIGNACAO','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR VALORES, TITULOS  E  BENSCONCEDIDOS A TITULO DE CONSIGNACAO PELA UNIDADE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.07.00.00.00','DIARIAS','REGISTRA O VALOR DAS DIARIAS CONCEDIDAS, COM REGISTRO DA RESPONSABILI-DADE MEDIANTE CONTROLE INDIVIDUALIZADO POR TITULAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.08.00.00.00','TITULOS DE CREDITO','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES DE   TERCEIROS  PORTITULOS DE CREDITO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.09.00.00.00','CESSAO DE USO - BENS CEDIDOS','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR BENS CEDIDOS PELA UNIDADEA TITULO DE CESSAO DE USO, FORMALIZADA MEDIANTE TERMO, NO QUAL DEVERAOCONSTAR A FINALIDADE DA SUA REALIZACAO E O PRAZO PARA SEU CUMPRIMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.11.00.00.00','MERCADORIAS E BENS EM PODER DE TERCEIROS','REGISTRA O VALOR DAS MERCADORIAS E DOS BENS DAS UNIDADES GESTORAS QUEESTAO EM PODER DE TERCEIROS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.13.00.00.00','BENS EM MANUTENCAO','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR  BENS  MOVEIS  CONCEDIDOSPELA UNIDADE EM CARATER PROVISORIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.14.00.00.00','PERMISSAO DE USO - BENS CONCEDIDOS','REGISTRA O VALOR DOS BENS CONCEDIDOS A PARTICULAR  MEDIANTE  PERMISSAODE USO, POR ATO NEGOCIAL, UNILATERAL, DISCRICIONARIO E PRECARIO DA AD-MINISTRACAO PUBLICA, E CUJA UTILIZACAO SEJA DE INTERESSE DA  COLETIVI-DADE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.15.00.00.00','AUTORIZACAO DE USO','REGISTRA O CONTROLE DOS BENS  PERTENCENTES  A  ADMINISTRACAO  PUBLICA,SOBRE OS QUAIS FOI A AUTORIZADA A  PRATICA  DE  ATIVIDADE  INDIVIDUAL,TRANSITORIA E IRRELEVANTE PARA O PODER PUBLICO,  POR  ATO  UNILATERAL,DISCRICIONARIO E PRECARIO, DISPENSANDO LEI  AUTORIZATIVA  E  LICITACAOPARA SEU DEFERIMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.16.00.00.00','IMOVEIS DE INTERESSE DO MUNICIPIO','REGISTRA O CONTROLE DE IMOVEIS DE TERCEIROS QUE ESTAO SENDO ADMINISTRADOS PELA ENTIDADE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.17.00.00.00','CONCESSAO DE USO','REGISTRA A DELEGACAO  DE  SERVICO PUBLICO FEITA PELO PODER  CEDENTE,MEDIANTE CONTRATO, PARA SUA EXPLORACAO SEGUNDO DESTINACAO ESPECIFICADE ACORDO COM A LEI 8987 DE 13/02/1995.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.99.00.00.00','OUTRAS RESPONSABILIDADES DE TERCEIROS','REGISTRA O VALOR DE OUTRAS RESPONSABILIDADES DE TERCEIROS, DE NATUREZAEVENTUAL, POR TITULOS, VALORES E BENS, PARA AS QUAIS NAO HA CONTAS ES-PECIFICAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.2.0.00.00.00.00.00','EXECUCAO DE RESPONSABILIDADES COM TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.2.1.00.00.00.00.00','EXECUCAO DE RESPONSABILIDADES COM TERCEIROS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.2.1.01.00.00.00.00','RECEBIDOS EM CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.2.1.02.00.00.00.00','DEPOSITOS JUDICIAIS','REGISTRA OS DEPOSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EMCONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOSPOR ESTA PARA TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.2.1.03.00.00.00.00','DEPOSITOS COMPULSORIOS','REGISTRA OS DEPOSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EM CONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOS POR ESTA PARA TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.2.1.99.00.00.00.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NAO INDIVIDUALIZADAS NAS OU-TRAS CONTAS DESSE GRUPO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.0.00.00.00.00.00','DIVERSOS RESPONSAVEIS EM APURACAO','COMPREENDE AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE  ATOS PRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM  RESULTAR EM PREJUIZOS PARA A FAZENDA MUNICIPAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.00.00.00.00.00','DIVERSOS RESPONSAVEIS EM APURACAO','COMPREENDE AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE  ATOS PRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM   RESULTAR EM PREJUIZOS PARA A FAZENDA MUNICIPAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.01.00.00.00.00','PAGAMENTOS INDEVIDOS','REGISTRA AS RESPONSABILIDADES EM APURACAO DE GESTORES E OUTROS RESPONSAVEIS E CORESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.02.00.00.00.00','SALDOS NAO RECOLHIDOS','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NAO RECOLHIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU AD-MINISTRATIVAS CUJOS PROCESSOS ESTEJAM EM FASE DE APURACAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.03.00.00.00.00','DESFALQUES OU DESVIOS','REGISTRA OS DESFALQUES OU DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, EM APURACAO,DECORRENTES DE PROCESSOS POR ACOES ADMININISTRATIVAS, POLICIAIS OU JUDICIAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.04.00.00.00.00','DEBITOS DE TERCEIROS EM PRESTAÇÃO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADESEM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS ESTEJAM EM FASE DE APURACAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.05.00.00.00.00','RESPONSAVEIS POR DANOS OU PERDAS','DESTINADA AO REGISTRO DAS RESPONSABILIDADES EM INQUERITOS  ADMINISTRATIVOS OU POLICIAIS CONTRA SERVIDORES OU TERCEIROS, POR DANOS E  PERDAS CAUSADOS A FAZENDA NACIONAL, E QUE ESTEJAM EM FASE DE APURACAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.06.00.00.00.00','PAGAMENTOS SEM RESPALDO ORCAMENTARIO','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS  COM-PORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), EM FASE DE APURACAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.07.00.00.00.00','CREDITOS ANTECIPADOS','REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, EM FASE DE  APURACAO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.08.00.00.00.00','FALTA OU IRREGULARIDADE DE COMPROVACAO','REGISTRA OS VALORES CORRESPOND.A FALTA DE DOCUMENTACAO COMPROBAT.DA E-XECUCAO DA DESPESA, INCLUSIVE AS APRESENT.FORA DO PRAZOLEGAL, BEM  CO-MO A INADIMPLENCIA NA COMPROV.DE INSTRUMENT.DE TRANSFER.OU AINDA IRRE-GULARID. NA DOCUMENT., EM FASE DE APURACAO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.09.00.00.00.00','FALTA DE LICITACAO','REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO, INFRINGINDO A LEGISLACAO ESPECIFICA, EM  PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, EM  FASE DE APURACAO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.10.00.00.00.00','MULTAS E JUROS','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO,  POREM DE RESPONSABILIDADE DE SERVIDORES E QUE ESTEJAM EM FASE DE  APURACAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.11.00.00.00.00','FALTA DE RECOLHIMENTO OBRIGACOES PECUNIARIA','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO:  PARTE  DO  EMPREGADOR  DE OBRIGAÇÕES PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E  NAO  RECOLHIDOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.12.00.00.00.00','FRAUDES EM BENEFICIOS','REGISTRAR OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA  PREVIDENCIA SOCIAL QUE SE ENCONTRAM EM FASE DE APURACAO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.13.00.00.00.00','ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE','REGISTRA AS RESPONSABILIDADES EM APURACAO DE GESTORES E OUTROS RESPONSAVEIS E CORESPONSAVEIS POR CONCESSAO DE ADIANTAMENTOS  EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO ADIANTAMENTOS A FORNECEDORES OU A EMPREGADOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.99.00.00.00.00','OUTRAS RESPONSABILIDADES EM APURACAO','REGISTRA RESPONSABILIDADES EM APURACAO NAO INDIVIDUALIZADAS NAS OUTRASCONTAS DESSE GRUPO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.0.0.00.00.00.00.00','DEMAIS CONTROLES','COMPREENDE AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS SUBGRUPOS DESTE GRUPO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.0.00.00.00.00.00','EXECUÇÃO DOS CONTROLES REFERENTES A CONSÓRCIOS PÚBLICOS','COMPREENDE A EXECUÇÃO DOS RECURSOS TRANSFERIDOS AOS CONSORCIOS PUBLICOS ATRAVÉS DAS INFORMAÇÕES ENVIADAS PELOS CONSÓRCIOS PÚBLICOS, INSTITUIDOS DE ACORDO COM A LEI FEDERAL Nº 11.107/2005 PARA FINS DE CONSOLIDAÇÃO QUANTO AS INFORMAÇÕES PARA VERIFICAÇÃO DA APLICAÇÃO DOS INDICES MINIMOS E MÁXIMOS TRAZIDOS PELA CF/88, LRF E DEMAIS CONTROLES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.00.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL','COMPREENDE A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL. ESTA CONTA DEVERÁ SER DESDOBRADA POR BIMESTRE PARA COMPOR A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.01.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ANTERIOR','COMPREENDE A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NOS PERIODOS DO EXERCICIO ANTERIOR UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.01.01.00.00.00','DESPESA COM PESSOAL - EXERCICIO ANTERIOR - MAIO A DEZEMBRO','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO PERIODO DE MAIO A DEZEMBRO DO EXERCICIO ANTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.01.02.00.00.00','DESPESA COM PESSOAL - EXERCICIO ANTERIOR - JULHO A DEZEMBRO','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO PERIODO DE JULHO A DEZEMBRO DO EXERCICIO ANTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.01.03.00.00.00','DESPESA COM PESSOAL - EXERCICIO ANTERIOR - SETEMBRO A DEZEMBRO','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO PERIODO DE SETEMBRO A DEZEMBRO DO EXERCICIO ANTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.02.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NOS PERIODOS DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.02.01.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 1º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 1º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.02.02.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 2º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 2º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.02.03.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 3º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 3º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.02.04.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 4º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 4º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.02.05.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 5º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 5º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.02.06.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 6º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 6º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.2.00.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM ASPS','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM AÇÕES E SERVIÇOS PÚBLICOS DE SAÚDE - ASPS. ESTA CONTA DEVERÁ SER ACUMULADA NOS BIMESTRES E TRAZER APENAS A APLICAÇÃO EM SAUDE PARA FINS DE CONSOLIDAÇÃO DO MÍNIMO CONSTITUCIONAL, OU SEJA TRANSFERÊNCIAS AO CONSÓRCIO COM RECURSO VINCULADO 40.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.3.00.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM MDE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO - MDE. ESTA CONTA DEVERÁ SER ACUMULADA NOS BIMESTRES E TRAZER APENAS A APLICAÇÃO EM EDUCAÇÃO PARA FINS DE CONSOLIDAÇÃO DO MÍNIMO CONSTITUCIONAL, OU SEJA TRANSFERÊNCIAS AO CONSÓRCIO COM RECURSO VINCULADO 20.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.4.00.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM FUNDEB','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM O FUNDEB. ESTA CONTA DEVERÁ SER ACUMULADA NOS BIMESTRES E TRAZER APENAS A APLICAÇÃO NO FUNDEB PARA FINS DE CONSOLIDAÇÃO DO MÍNIMO CONSTITUCIONAL, OU SEJA TRANSFERÊNCIAS AO CONSÓRCIO COM RECURSO VINCULADO 31.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.5.00.00.00.00.00','INFORMAÇÃO DA INSUFICIÊNCIA DE CAIXA DO CONSORCIO PUBLICO','REGISTRA A INFORMAÇÃO DA INSUFICIÊNCIA DE CAIXA DO CONSORCIO PÚBLICO  PARA FINS DE ANALISE DO CUMPRIMENTO DO ART. 42 DA LRF, CONFORME ART. 11, § 2º DA PORTARIA STN Nº 72/2012.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.6.00.00.00.00.00','OPERAÇÕES DE CREDITO IRREGULARES','REGISTRA AS OPERAÇÕES DE CREDITO NÃO AUTORIZADAS POR RESOLUÇÃO DO SENADO FEDERAL,  AS VEDADAS E OUTRAS IRREGULARMENTE REALIZADAS E QUE DEVERÃO SER CONSOLIDADAS NOS DEMONSTRATIVOS DE OPERAÇÃO DE CREDITO E DIVIDA CONSOLIDADA LIQUIDA DO ENTE CONSORCIADO EM ATENDIMENTO AO ART. 18, PARÁGRAFO ÚNICO DA PORTARIA STN N° 72/2012..','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.7.00.00.00.00.00','INFORMAÇÃO DO ATENDIMENTO AO ART. 25 DA LC 141/2012','REGISTRA A APLICAÇÃO DIRETA EEXECUTADA PELO CONSORCIO PUBLICO À CONTA DOS RECURSOS REFERENTES À DIFERENÇA DA APLICAÇÃO MÍNIMA EM ASPS QUE DEIXOU DE SER APLICADA EM EXERCICIOS ANTERIORES. ATENDIMENTO AO ART. 25 DA LEI COMPLEMENTAR 141/2012 E PARÁGRAFO ÚNICO DO ART. 10 DA PORTARIA STN Nº 72/2012. O CONSORCIO DEVERÁ EXECUTAR ESTA DESPESA NA MODALIDADE DE APLICAÇÃO 96.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.9.0.00.00.00.00.00','DEMAIS CONTROLES','REGISTRA AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS TITULOS DESTE SUBGRUPO.','C','S','C','');

UPDATE contabilidade.plano_conta_estrutura SET escrituracao = 'S' WHERE escrituracao = 's';


-- PLANO CONTA TCE-RS 2013 v1.1
INSERT INTO contabilidade.plano_conta_geral (cod_uf, cod_plano, versao, dt_versao) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23)+1, 1), '1.1', '2012-09-11');

INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.0.0.0.0.00.00.00.00.00','ATIVO','Compreende os recursos controlados por uma entidade como consequência de eventos passados e dos quais se espera que fluam benefícios econômicos ou potencial de serviços futuros a unidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.0.0.0.00.00.00.00.00','ATIVO CIRCULANTE','Compreende os ativos que atendam a qualquer um dos seguintes critérios: sejam caixa ou equivalente de caixa; sejam realizáveis ou mantidos para venda ou consumo dentro do ciclo operacional da entidade; sejam mantidos primariamente para negociação; sejam realizáveis no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.0.0.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA','Compreende o somatório dos valores em caixa e em bancos, bem como equivalentes, que representam recursos com livre movimentação para aplicação nas operações da entidade e para os quais não haja restrições para uso imediato.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.0.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL','Compreende o somatório dos valores em caixa e em bancos, bem como equivalentes, que representam recursos com livre movimentação para aplicação nas operações da entidade e para os quais não haja restrições para uso imediato. Compreende o somatorio dos valores de caixa e equivalentes de caixa em moeda nacional.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - CONSOLIDAÇÃO','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda nacional. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.01.00.00.00.00','CAIXA','REGISTRA O SOMATORIO DE NUMERARIOS EM ESPECIE E OUTROS VALORES EM TESOURARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.00.00.00.00','CONTA ÚNICA  - RPPS','COMPREENDE O SOMATÓRIO DOS VALORES DISPONÍVEIS NA CONTA ÚNICA DO RPPS, NOS AGENTES FINANCEIROS AUTORIZADOS NO ÂMBITO DO ENTE PÚBLICO. ESSA CONTA DEVERÁ SER DESDOBRADA PELO RPPS NA QUANTIDADE DE AGENTES FINANCEIROS EM QUE MANTENHA CONTA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.01.00.00.00','BANCO CONTA MOVIMENTO - RPPS','REGISTRA A MOVIMENTAÇÃO DE RECURSOS NA CONTA MOVIMENTO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS .','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.02.00.00.00','BANCO CONTA MOVIMENTO - PLANO FINANCEIRO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DO PLANO FINANCEIRO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.03.00.00.00','BANCO CONTA MOVIMENTO - PLANO PREVIDENCIÁRIO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DO PLANO PREVIDENCIÁRIO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.04.00.00.00','BANCO CONTA MOVIMENTO - TAXA DE ADMINISTRAÇÃO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DA TAXA DE ADMINISTRAÇÃO, ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.00.00.00.00','BANCOS CONTA MOVIMENTO - DEMAIS CONTAS','COMPREENDE O SOMATORIO DAS DISPONIBILIDADES EXISTENTES NAS CONTAS BANCARIAS, AGREGADAS PELOS SUBITENS IDENTIFICATIVOS DOS BANCOS CORRESPONDENTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.02.00.00.00','BANCO DO BRASIL','REGISTRA O SOMATORIO DA MOVIMENTAÇÃO FINANCEIRA DAS CONTAS EXISTENTES NA INSTITUIÇÃO FINANCEIRA BANCO DO BRASIL.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.03.00.00.00','CAIXA ECONOMICA FEDERAL','REGISTRA O SOMATORIO DA MOVIMENTAÇÃO FINANCEIRA DAS CONTAS EXISTENTES NA INSTITUIÇÃO FINANCEIRA CAIXA ECONÔMICA FEDERAL.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.12.00.00.00','BANCO DO ESTADO DO RIO GRANDE DO SUL','REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO DO ESTADO DO RIO GRANDE DO SUL.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.99.00.00.00','DEMAIS CONTAS BANCARIAS','REGISTRA AS ARRECADAÇÕES DE RECEITAS DA ENTIDADE E DE OUTROS VALORES DESTA SOB SUA GUARDA OU RESPONSABILIDADE, ESPECIFICAMENTE QUANDO O BANCO NÃO SE ENCONTRA RELACIONADO NAS CONTAS ACIMA.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.30.00.00.00.00','REDE BANCARIA - ARRECADACAO','COMPREENDE O SOMATORIO DOS RECURSOS REFERENTES A RECEITAS ARRECADADAS E NÃO RECOLHIDAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.30.01.00.00.00','ARRECADACAO DIRETA','REGISTRA OS VALORES DAS RECEITAS ARRECADADAS DIRETAMENTE PELA ENTIDADE.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.30.02.00.00.00','ARRECADACAO INDIRETA','REGISTRA OS VALORES DA RECEITA ARRECADADA PELOS AGENTES FINANCEIROS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.00.00.00.00','APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA','COMPREENDE AS APLICAÇÕES FINANCEIRAS DE ALTA LIQUIDEZ EM MOEDA NACIONAL, QUE SÃO PRONTAMENTE CONVERSIVEIS EM VALORES CONHECIDOS DE CAIXA E QUE ESTÃO SUJEITAS A UM INSIGNIFICANTE RISCO DE MUDANCA DE VALOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.05.00.00.00','POUPANCA','REGISTRA O VALOR DAS APLICAÇÕES FINANCEIRAS EM POUPANÇAS E SEUS RENDIMENTOS (JUROS E ATUALIZAÇÃO MONETARIA) POSTERIORES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.06.00.00.00','FUNDO DE APLICACAO FINANCEIRA','REGISTRA O VALOR DAS APLICAÇÕES FINANCEIRAS EM FUNDO DE APLICAÇÃO E SEUS RENDIMENTOS (JUROS E ATUALIZAÇÃO) POSTERIORES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.10.00.00.00','CDB','REGISTRA OS VALORES DAS DISPONIBILIDADES  DAS INSTITUICOES, ENTIDADES OU UNIDADES APLICADAS CERTIFICADOS DE DEPOSITOS BANCARIOS.(CDB)','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.99.00.00.00','OUTRAS APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA','REGISTRA OUTRAS APLICAÇÕES FINANCEIRAS, NÃO CLASSIFICADAS EM ITENS ANTERIORES, DAS DISPONIBILIDADES  FINANCEIRAS DAS ENTIDADES, INSTITUIÇÕES OU UNIDADES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - INTRA OFSS','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda nacional. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.06.00.00.00.00','CONTA ÚNICA  - RPPS','COMPREENDE O SOMATÓRIO DOS VALORES DISPONÍVEIS NA CONTA ÚNICA DO RPPS, NOS AGENTES FINANCEIROS AUTORIZADOS NO ÂMBITO DO ENTE PÚBLICO. ESSA CONTA DEVERÁ SER DESDOBRADA PELO RPPS NA QUANTIDADE DE AGENTES FINANCEIROS EM QUE MANTENHA CONTA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.06.01.00.00.00','BANCO CONTA MOVIMENTO - RPPS','REGISTRA A MOVIMENTAÇÃO DE RECURSOS NA CONTA MOVIMENTO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS .','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.06.02.00.00.00','BANCO CONTA MOVIMENTO - PLANO FINANCEIRO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DO PLANO FINANCEIRO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.06.03.00.00.00','BANCO CONTA MOVIMENTO - PLANO PREVIDENCIÁRIO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DO PLANO PREVIDENCIÁRIO DO RPPS ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.06.04.00.00.00','BANCO CONTA MOVIMENTO - TAXA DE ADMINISTRAÇÃO','REGISTRA A MOVIMENTAÇÃO FINANCEIRA DOS RECURSOS NAS CONTAS MOVIMENTO DA TAXA DE ADMINISTRAÇÃO, ATRAVÉS DOS AGENTES FINANCEIROS CREDENCIADOS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.20.00.00.00.00','RECURSOS LIBERADOS PELO TESOURO MUNICIPAL','COMPREENDE OS RECURSOS LIBERADOS PELO TESOURO  MUNICIPAL, PARA ATENDER A DESPESAS DO EXERCICIO E DE EXERCICIO ANTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.20.01.00.00.00','LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO','REGISTRA O VALOR DO LIMITE DE SAQUE DA CONTA UNICA DO ENTE FEDERATIVO, ESTABELECIDO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA, PARA ATENDER  A DESPESAS COM VINCULACAO DE PAGAMENTO.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.20.08.00.00.00','REPASSES A RECEBER','REGISTRA OS RECURSOS A RECEBER REFERENTES AS PARCELAS NAO RECEBIDAS DO ORCAMENTO PELAS ENTIDADES DA ADMINISTRACAO INDIRETA.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.2.0.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda estrangeira.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.2.1.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA - CONSOLIDAÇÃO','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda estrangeira. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.0.0.00.00.00.00.00','CRÉDITOS A CURTO PRAZO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos realizáveis no curso do exercício social subsequente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.0.00.00.00.00.00','CLIENTES','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorram no curso normal das operações da entidade, representando um direito a cobrar de seus clientes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.00.00.00.00.00','CLIENTES- CONSOLIDAÇÃO','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.00.00.00.00','FATURAS/DUPLICATAS A RECEBER','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVIÇOS QUE OCORREM NO CURSO NORMAL DAS OPERAÇÕES DA UNIDADE, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.03.00.00.00','FATURAS/ DUPLICATAS A RECEBER   - ESTOQUE PROPRIO','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS  DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.06.00.00.00','FATURAS/ DUPLICATAS A RECEBER  - PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.80.00.00.00','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.97.00.00.00','(-) DUPLICATAS DESCONTADAS - ESTOQUES PROPRIOS','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS  PROVENIENTES DO FATURAMENTO  DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.02.00.00.00.00','FATURAS/DUPLICATAS A FATURAR','REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.03.00.00.00.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.00.00.00.00.00','CLIENTES-INTRA OFSS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.00.00.00.00','FATURAS/DUPLICATAS A RECEBER','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVIÇOS QUE OCORREM NO CURSO NORMAL DAS OPERAÇÕES DA UNIDADE, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.03.00.00.00','FATURAS/ DUPLICATAS A RECEBER   - ESTOQUE PROPRIO','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS  DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.06.00.00.00','FATURAS/ DUPLICATAS A RECEBER  - PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.80.00.00.00','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.97.00.00.00','(-) DUPLICATAS DESCONTADAS - ESTOQUES PROPRIOS','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS  PROVENIENTES DO FATURAMENTO  DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.02.00.00.00.00','FATURAS/DUPLICATAS A FATURAR','REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.03.00.00.00.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.00.00.00.00.00','CLIENTES - INTER OFSS - UNIÃO','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E A UNIÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.01.00.00.00.00','FATURAS/DUPLICATAS A RECEBER','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVIÇOS QUE OCORREM NO CURSO NORMAL DAS OPERAÇÕES DA UNIDADE, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.01.03.00.00.00','FATURAS/ DUPLICATAS A RECEBER   - ESTOQUE PROPRIO','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS  DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.01.06.00.00.00','FATURAS/ DUPLICATAS A RECEBER  - PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.01.80.00.00.00','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.01.97.00.00.00','(-) DUPLICATAS DESCONTADAS - ESTOQUES PROPRIOS','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS  PROVENIENTES DO FATURAMENTO  DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.02.00.00.00.00','FATURAS/DUPLICATAS A FATURAR','REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.03.00.00.00.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.00.00.00.00.00','CLIENTES - INTER OFSS - ESTADO','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.01.00.00.00.00','FATURAS/DUPLICATAS A RECEBER','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.01.03.00.00.00','FATURAS/ DUPLICATAS A RECEBER   - ESTOQUE PROPRIO','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS  DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.01.06.00.00.00','FATURAS/ DUPLICATAS A RECEBER  - PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.01.80.00.00.00','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.01.97.00.00.00','(-) DUPLICATAS DESCONTADAS - ESTOQUES PROPRIOS','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS  PROVENIENTES DO FATURAMENTO  DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.02.00.00.00.00','FATURAS/DUPLICATAS A FATURAR','REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.03.00.00.00.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.00.00.00.00.00','CLIENTES - INTER OFSS - MUNICIPIO','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.01.00.00.00.00','FATURAS/DUPLICATAS A RECEBER','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.01.03.00.00.00','FATURAS/ DUPLICATAS A RECEBER   - ESTOQUE PROPRIO','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS  DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.01.06.00.00.00','FATURAS/ DUPLICATAS A RECEBER  - PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.01.80.00.00.00','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.01.97.00.00.00','(-) DUPLICATAS DESCONTADAS - ESTOQUES PROPRIOS','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS  PROVENIENTES DO FATURAMENTO  DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.02.00.00.00.00','FATURAS/DUPLICATAS A FATURAR','REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.03.00.00.00.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.0.00.00.00.00.00','CREDITOS TRIBUTARIOS A RECEBER','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.0.00.01.00.00.00','CREDITOS TRIBUTARIOS A RECEBER','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.00.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - CONSOLIDAÇÃO','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.01.00.00.00.00','IPTU','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE IPTU A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.02.00.00.00.00','ITBI','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ITBI A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.03.00.00.00.00','ISS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ISS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.04.00.00.00.00','ITR','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE ITR A RECEBER - MUNICIPIOS CONVENIADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.05.00.00.00.00','TAXAS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS A RECEBER.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.05.01.00.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.05.02.00.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE TAXAS PELA PRESTAÇÃO DE SERVIÇOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.06.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS TRIBUTÁRIOS DE CONTRIBUIÇÃO DE MELHORIA A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.2.00.00.00.00.00','CREDITOS TRIBUTARIOS  A RECEBER - INTRA OFSS','Registra os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.3.00.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - UNIÃO','Registra os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente.  Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.4.00.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - ESTADO','Registra os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente.  Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.5.00.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - MUNICÍPIO','Registra os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente.  Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.0.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - CONSOLIDAÇÃO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.00.00.00.00','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA NÃO PREVIDENCIARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.01.00.00.00','IPTU','REGISTRA OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE IPTU INSCRITOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.02.00.00.00','ITBI','REGISTRA OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE ITBI INSCRITOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.03.00.00.00','ISS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE ISS INSCRITOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.04.00.00.00','ITR','REGISTRA OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE ITR - MUNICIPIOS CONVENIADOS INSCRITOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.05.00.00.00','TAXAS','COMPREENDE OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE TAXAS A RECEBER.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.05.01.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA  A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.05.02.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE TAXAS PELA PRESTAÇÃO DE SERVIÇOS A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.06.00.00.00','CONTRIBUIÇÃO DE MELHORIA','REGISTRA OS VALORES RELATIVOS A CRÉDITOS DE DIVIDA ATIVA TRIBUTÁRIA DE CONTRIBUIÇÃO DE MELHORIA A RECEBER.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.02.00.00.00.00','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA  PREVIDENCIARIA.EX: CONTRIBUIÇÃO SOCIAL PARA O RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.2.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - INTRA OFSS','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.2.01.00.00.00.00','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA NÃO PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.2.02.00.00.00.00','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA  PREVIDENCIARIA.EX: CONTRIBUIÇÃO PATRONAL PARA O RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - INTER OFSS - UNIÃO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.01.00.00.00.00','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA NÃO PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.02.00.00.00.00','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA  PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.4.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - INTER OFSS - ESTADO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.4.01.00.00.00.00','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA NÃO PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.4.02.00.00.00.00','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA  PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.5.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - INTER OFSS - MUNICÍPIO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.5.01.00.00.00.00','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA NÃO PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.5.02.00.00.00.00','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CRÉDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTÁRIA  PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.0.00.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA - CLIENTES','Compreende os valores dos créditos de divida ativa não tributaria inscritos, derivados de clientes, realizáveis no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.1.00.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA - CLIENTES - CONSOLIDAÇÃO','Registra os valores dos créditos de divida ativa não tributaria inscritos, derivados de clientes, realizáveis no curso do exercício social subsequente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.0.00.00.00.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Compreende os valores relativos a créditos a receber oriundos da variação patrimonial aumentativa decorrente de transferências obrigatórias da União, estados, Distrito Federal e municípios.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.3.00.00.00.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - UNIÃO','Compreende os valores relativos a créditos a receber oriundos da variação patrimonial aumentativa decorrente de transferências obrigatórias da União, estados, Distrito Federal e municípios.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.4.00.00.00.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - ESTADO','Compreende os valores relativos a créditos a receber oriundos da variação patrimonial aumentativa decorrente de transferências obrigatórias da União, estados, Distrito Federal e municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.5.00.00.00.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - MUNICÍPIO','Compreende os valores relativos a créditos a receber oriundos da variação patrimonial aumentativa decorrente de transferências obrigatórias da União, estados, Distrito Federal e municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.0.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS- CONSOLIDAÇÃO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.01.00.00.00.00','EMPRESTIMOS CONCEDIDOS A RECEBER','REGISTRA A APROPRIAÇÃO DOS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUIÇÕES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS, COM VENCIMENTOS A CURTO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.02.00.00.00.00','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA A APROPRIAÇÃO DOS VALORES DOS FINANCIAMENTOS, A CURTO  PRAZO, CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUIÇÕES, POR AUTORIZAÇÕES LEGAIS OU VINCULAÇÕES A CONTRATOS E ACORDOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.04.00.00.00.00','ENCARGOS SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','COMPREENDE OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.04.01.00.00.00','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS  A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.04.03.00.00.00','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS EM QUE TAIS ENCARGOS NÃO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.07.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSÃO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.07.01.00.00.00','EMPRÉSTIMOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.07.02.00.00.00','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.07.03.00.00.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER RPPS - RPPS','','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.07.04.00.00.00','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER RPPS - RPPS','','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.3.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - UNIÃO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a união.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.3.07.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSÃO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.3.07.01.00.00.00','EMPRÉSTIMOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.3.07.02.00.00.00','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.3.07.03.00.00.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER RPPS - RPPS','','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.3.07.04.00.00.00','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER RPPS - RPPS','','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.4.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - ESTADO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.4.07.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSÃO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.4.07.01.00.00.00','EMPRÉSTIMOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.4.07.02.00.00.00','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.4.07.03.00.00.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER RPPS - RPPS','','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.4.07.04.00.00.00','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER RPPS - RPPS','','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.5.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - MUNICÍPIO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.5.07.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSÃO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.5.07.01.00.00.00','EMPRÉSTIMOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.5.07.02.00.00.00','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.5.07.03.00.00.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER RPPS - RPPS','','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.5.07.04.00.00.00','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER RPPS - RPPS','','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.0.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO- CONSOLIDAÇÃO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.01.00.00.00.00','(-) AJUSTE DE PERDAS DE CREDITOS DE LIQUIDACAO DUVIDOSA','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANÇA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.02.00.00.00.00','(-) AJUSTE DE PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.03.00.00.00.00','(-) AJUSTE DE PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.04.00.00.00.00','(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NÃO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.05.00.00.00.00','(-)  AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.06.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.2.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTRA OFSS','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.2.01.00.00.00.00','(-) AJUSTE DE PERDAS DE CREDITOS DE LIQUIDACAO DUVIDOSA','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANÇA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.2.02.00.00.00.00','(-) AJUSTE PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.2.03.00.00.00.00','(-)  AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.2.06.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.01.00.00.00.00','(-) AJUSTE PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.02.00.00.00.00','(-)  AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.03.00.00.00.00','(-) AJUSTE PARA PERDA DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDA DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.05.00.00.00.00','(-)  AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER PROVENIENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.06.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.01.00.00.00.00','(-) AJUSTE PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.02.00.00.00.00','(-)  AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.03.00.00.00.00','(-) AJUSTE PARA PERDA DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDA DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.05.00.00.00.00','(-)  AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER PROVENIENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.06.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.01.00.00.00.00','(-) AJUSTE PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.02.00.00.00.00','(-)  AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.03.00.00.00.00','(-) AJUSTE PARA PERDA DE CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDA DECRÉDITOS DE TRANSFERÊNCIAS A RECEBER.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.05.00.00.00.00','(-)  AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER PROVENIENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.06.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.0.0.00.00.00.00.00','DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','Compreende os valores a receber por demais transações realizáveis no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.0.00.00.00.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','Compreende as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.00.00.00.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS - CONSOLIDAÇÃO','Compreende as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.00.00.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL','COMPREENDE OS VALORES DAS ANTECIPAÇÕES CONCEDIDAS A SERVIDORES E A DIRIGENTES DA UNIDADE, TAIS COMO ANTECIPAÇÕES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E DE GRATIFICAÇÕES NATALINAS, ENTRE OUTRAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.01.00.00.00','13 SALARIO - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE AO 13º SALARIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.02.00.00.00','1/3 DE FERIAS - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A 1/3 DE FERIAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.05.00.00.00','SALARIOS E ORDENADOS - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A SALARIOS E ORDENADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.99.00.00.00','OUTROS ADIANTAMENTOS CONCEDIDOS A PESSOAL','REGISTRA OUTROS ADIANTAMENTOS CONCEDIDOS A PESSOAL NÃO REGISTRADOS NAS CONTAS ACIMA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.02.00.00.00.00','SUPRIMENTO DE FUNDOS','REGISTRA O ADIANTAMENTO A SERVIDOR PARA DESPESAS SUJEITAS A PRESTAÇÃO DE CONTAS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.05.00.00.00.00','ADIANTAMENTOS A PRESTADORES DE SERVIÇOS','REGISTRA OS VALORES DE ANTECIPAÇÕES CONCEDIDAS A PRESTADORES DE SERVIÇOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVIÇOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.99.00.00.00.00','ADIANTAMENTOS DIVERSOS CONCEDIDOS','REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NÃO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.2.0.00.00.00.00.00','TRIBUTOS A RECUPERAR / COMPENSAR','Compreende o somatório dos valores dos tributos a recuperar/ compensar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.2.1.00.00.00.00.00','TRIBUTOS A RECUPERAR / COMPENSAR - CONSOLIDAÇÃO','Compreende o somatório dos valores dos tributos a recuperar /compensar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.3.0.00.00.00.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Compreende os créditos a receber decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta como por meio de delegação, nas formas de concessão, inclusive parcerias público-privada - PPP, permissão ou autorização ao particular do direito de exploração de serviços públicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.3.1.00.00.00.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS - CONSOLIDAÇÃO','Compreende os créditos a receber decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta, como por meio de delegação, nas formas de concessão, inclusive parcerias público-privada - PPP, permissão ou autorização ao particular do direito de exploração de serviços públicos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.0.00.00.00.00.00','CRÉDITOS POR DANOS AO PATRIMÔNIO','Compreende os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em sindicância, prestação de contas, tomada de contas, processos judiciais e outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.00.00.00.00.00','CRÉDITOS POR DANOS AO PATRIMONIO- CONSOLIDAÇÃO','Compreende os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em sindicância, prestação de contas, tomada de contas, processos judiciais e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.00.00.00.00','CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS','COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.01.00.00.00','CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','REGISTRA O CREDITO DO MUNICIPIO CORRESPONDENTE A DEBITOS ADMINISTRATIVOS  DECORRENTES DE FOLHA DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.02.00.00.00','CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','REGISTRA O CREDITO DO MUNICIPIO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.03.00.00.00','CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','REGISTRA O CREDITO DO MUNICIPIO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.04.00.00.00','CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','REGISTRA O CREDITO DO MUNICIPIO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.05.00.00.00','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NAO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELEIDO EM NORMAS LEGAIS OU DETERMINACAO  ADMINISTRATIVA OU SEJA, QUANDO O PRODUTO A ARRECADAR NAO TENHA SIDO RECOLHIDO NO PRAZO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.06.00.00.00','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.07.00.00.00','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO,  POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (MULTA DE TRANSITO, ETC).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.10.00.00.00','CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS','REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE  CONTAS ESPECIAL).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.99.00.00.00','OUTROS CREDITOS ADMINISTRATIVOS','REGISTRA O CREDITO DO MUNICIPIO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.03.00.00.00.00','CREDITOS POR DANOS AO PATRIMONIO APURADOS EM PROCESSOS JUDICIAIS','REGISTRA OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS JUDICIAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.0.00.00.00.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.00.00.00.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS- CONSOLIDAÇÃO','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.01.00.00.00.00','DEPOSITOS  E CAUCOES EFETUADOS RELATIVOS A CONTRATOS OU CONVENCOES','REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES, EFETUADOS  POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES  ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.02.00.00.00.00','DEPOSITOS  E CAUCOES RECEBIDOS RELATIVOS A CONTRATOS OU CONVENCOES','REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES RECEBIDOS PELA ENTIDADE, PRESTADOS  POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES  ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.03.00.00.00.00','DEPOSITOS JUDICIAIS EFETUADOS','REGISTRA OS VALORES A RECEBER DECORRENTES DE DEPOSITOS EFETUADOS POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.03.01.00.00.00','DEPOSITOS JUDICIAIS EFETUADOS - PODER EXECUTIVO/INDIRETAS','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE SENTENÇAS JUDICIAIS DO PODER EXECUTIVO/INDIRETAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.03.02.00.00.00','DEPOSITOS JUDICIAIS EFETUADOS - PODER LEGISLATIVO','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE SENTENÇAS JUDICIAIS DO PODER LEGISLATIVO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.03.03.00.00.00','DEPOSITOS JUDICIAIS EFETUADOS - RPPS','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE SENTENÇAS JUDICIAIS DO RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.03.04.00.00.00','DEPOSITOS JUDICIAIS EFETUADOS DE RESTOS A PAGAR - PODER EXECUTIVO/INDIRETAS','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE DEMANDAS JUDICIAS , DECORRENTES DE VALORES INSCRITOS EM RESTOS A PAGAR NO PODER EXECUTIVO/INDIRETAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.03.05.00.00.00','DEPOSITOS JUDICIAIS EFETUADOS DE RESTOS A PAGAR - PODER LEGISLATIVO','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE DEMANDAS JUDICIAS , DECORRENTES DE VALORES INSCRITOS EM RESTOS A PAGAR NO PODER LEGISLATIVO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.03.06.00.00.00','DEPOSITOS JUDICIAIS EFETUADOS DE RESTOS A PAGAR - RPPS','REGISTRA O SOMATÓRIOS DOS DEPÓSITOS EFETUADOS AO PODER JUDICIÁRIO DECORRENTE DE DETERMINAÇÃO JUDICIAL PARA GARANTIA DO CUMPRIMENTO DE DEMANDAS JUDICIAS , DECORRENTES DE VALORES INSCRITOS EM RESTOS A PAGAR NO RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.05.00.00.00.00','DEPOSITOS EFETUADOS PARA INTERPOSICAO DE RECURSOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS, DECORRENTES DE INTERPOSICAO DE  RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.07.00.00.00.00','DEPOSITOS ESPECIAIS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.99.00.00.00.00','OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS NO CURTO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.6.0.00.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA - DEMAIS CRÉDITOS','Compreende os valores dos créditos de divida ativa não tributaria inscritos, exceto as derivadas de clientes, realizáveis no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.6.1.00.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA - DEMAIS CRÉDITOS - CONSOLIDAÇÃO','Registra os valores dos créditos de divida ativa não tributaria inscritos, exceto as derivadas de clientes, realizáveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.6.1.01.00.00.00.00','NSCRICAO DE CERTIDAO DE DECISAO - TITULO EXECUTIVO DO TCE/RS','REPRESENTA CRÉDITOS DE NATUREZA NÃO-TRIBUTÁRIA EXIGÍVEIS A PARTIR DO RECEBIMENTO, PELA ENTIDADE, DE CERTIDÃO DE DECISÃO - TÍTULO EXECUTIVO, EMITIDA PELO TRIBUNAL DE CONTAS DO ESTADO COM CARACTERÍSTICA DE LIQUIDEZ E CERTEZA, INSCRITOS COMO DÍVIDA ATIVA NÃO-TRIBUTÁRIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.0.00.00.00.00.00','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO','Compreende os outros créditos e valores realizáveis no curto prazo, provenientes de direitos obtidos junto a diversos devedores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.00.00.00.00.00','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os outros créditos e valores realizáveis no curto prazo, provenientes de direitos obtidos junto a diversos devedores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.01.00.00.00.00','ALUGUEIS A RECEBER','REGISTRA OS VALORES A RECEBER DECORRENTES DE CONTRATOS DE ALUGUEL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.02.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS','REGISTRA OS VALORES A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.03.00.00.00.00','VALORES A RECUPERAR DECORRENTES DE INDENIZACOES POR SINISTROS PAGOS','REGISTRA OS VALORES A RECUPERAR REFERENTES A INDENIZACOES PELO PAGAMENTO DE SINISTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.04.00.00.00.00','VALES, TICKETS E BILHETES','REGISTRA O VALOR DE VALES, TICKETS E BILHETES ADQUIRIDOS PARA FUTURA DISTRIBUICAO AOS SERVIDORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.06.00.00.00.00','VALORES EM TRANSITO REALIZAVEIS A CURTO PRAZO','COMPREENDE O SOMATORIO DOS VALORES CONTABILIZADOS INDEVIDAMENTE EM CONTA BANCARIA, GUIA DE RECEBIMENTO E ORDENS BANCARIAS EMITIDAS A COMPENSAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.07.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE INFRACOES LEGAIS E CONTRATUAIS','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS  DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES  ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.08.00.00.00.00','CREDITOS A RECEBER POR REEMBOLSO DE SALARIO FAMILIA PAGO','REGISTRA OS VALORES RELATIVOS AO SALARIO-FAMILIA, INCLUIDOS EM FOLHAS DE PAGAMENTO, PAGOS AOS EMPREGADOS (CLT), COM FILHOS MENORES, A COMPENSAR COM AS CONTRIBUICOES DEVIDAS PELO EMPREGADOR A PREVIDENCIA SOCIAL.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.09.00.00.00.00','CREDITOS A RECEBER POR REEMBOLSO DE SALARIO MATERNIDADE PAGO','REGISTRA OS SALARIOS PAGOS AS SERVIDORAS GESTANTES, REGIDAS PELA CLT NO PERIODO QUE PERDURAR A LICENCA MATERNIDADE, PREVISTA EM LEI, A DEDUZIR DAS OBRIGACOES SOCIAIS DEVIDAS PELOS ORGAOS E ENTIDADES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.10.00.00.00.00','AUXILIO NATALIDADE PAGO A RECUPERAR','REGISTRA OS VALORES RELATIVOS A AUXILIO NATALIDADE, PAGOS AOS EMPREGADOS REGIDOS PELA CLT, QUANDO DO NASCIMENTO DE FILHOS DESTES, A RECUPERAR, POR SE TRATAR DE OBRIGACOES DA PREVIDENCIA SOCIAL.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.11.00.00.00.00','CREDITOS A RECEBER POR REEMBOLSO DE AUXILIO DOENCA E ACIDENTES PAGOS','REGISTRA OS SALARIOS PAGOS AOS SERVIDORES, REGIDOS PELA CLT, A  TITULO DE AUXILIO DOENCA/ACIDENTES, PREVISTO EM LEI, A SEREM REEMBOLSADOS PELO INSS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.12.00.00.00.00','CREDITOS A RECEBER POR CESSAO DE PESSOAL','REGISTRA OS VALORES DE CREDITOS A RECEBER TAIS COMO: FOLHA DE PAGAMENTO, DESPESA DE TRANSPORTE, ALIMENTACAO E OUTRAS RELATIVAS A CESSAO DE PESSOAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.13.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE CESSAO DE AREAS PUBLICAS','REGISTRA OS VALORES A RECEBER DECORRENTES DA CESSAO DE AREAS PUBLICAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.14.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS OU IMOVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.15.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESAS DE TERCEIROS','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE PAGAMENTOS DE DESPESAS DE TERCEIROS DECORRENTES DE CLAUSULAS CONTRATUAIS, TAIS COMO: AGUA, LUZ, TELEFONE,  INSTALACOES, TRANSPORTE E ALUGUEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.17.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE  FOLHA DE PAGAMENTO','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.27.00.00.00.00','TITULOS A RECEBER','COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.28.00.00.00.00','CREDITOS A RECEBER DE ENTIDADES FEDERAIS','REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ENTIDADES FEDERAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.29.00.00.00.00','CREDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS','REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ESTADOS, DF E MUNICIPIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.99.00.00.00.00','OUTROS CREDITOS A  RECEBER E VALORES A CURTO PRAZO','REGISTRA OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO, PARA OS QUAIS NAO TENHAM CONTAS ESPECIFICAS NESTE SUBGRUPO DE CONTAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.0.00.00.00.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos e valores a curto prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.1.00.00.00.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos e valores a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.1.02.00.00.00.00','(-)  AJUSTE DE PERDAS DE CREDITOS POR DANOS AO PATRIMONIO','COMPREENDE O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS OU APURADOS EM TOMADA DE CONTAS ESPECIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.1.03.00.00.00.00','(-)  AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, EXCETO AS DERIVADAS DE CLIENTES DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.1.99.00.00.00.00','(-) OUTROS AJUSTES DE PERDAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO','REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE  DEMAIS CREDITOS E VALORES A CURTO PRAZO, NAO CLASSIFICADAS ANTERIORMENTE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.0.0.00.00.00.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A CURTO PRAZO','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo, alem das aplicações temporárias em metais preciosos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.0.00.00.00.00.00','TÍTULOS E VALORES MOBILIÁRIOS','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.00.00.00.00.00','TÍTULOS E VALORES MOBILIARIOS- CONSOLIDAÇÃO','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.03.00.00.00.00','TITULOS PUBLICOS - MERCADO ABERTO','REGISTRA O VALOR RELATIVO A TITULOS PUBLICOS, EMITIDOS E EM CIRCULACAO NO MERCADO ABERTO PARA FINS DE NEGOCIACAO NO MERCADO DE ACOES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.04.00.00.00.00','ACOES','REGISTRA OS VALORES DAS ACOES REPRESENTATIVAS DAS PARTICIPACOES DOS ORGAOS E ENTIDADES NO CAPITAL DAS SOCIEDADES POR ACOES HAVIDAS POR AQUISICOES, SUBSCRICOES, BONIFICACOES E DOACOES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.00.00.00.00','APLICACOES EM SEGMENTO DE RENDA FIXA','APRESENTAR O SOMATÓRIO DOS INVESTIMENTOS REALIZADOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, DA RESOLUÇÃO CMN N° 3.922/2010.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.01.00.00.00','TITULOS DE RESPONSABILIDADE DO TESOURO','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM TÍTULOS DE EMISSÃO DO TESOURO NACIONAL, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO I, ALÍNEA "A"(INCLUÍ OPERAÇÕES COMPROMISSADAS) DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.02.00.00.00','TITULOS DE RESPONSABILIDADE DO BANCO CENTRAL','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM TITULOS DE EMISSAO DO BANCO CENTRAL DO BRASIL; SALDOS REMANESCENTES PARA RESGATES,   CONSIDERANDO QUE O BC NAO EMITE MAIS TITULOS DA DIVIDA PUBLICA- ART 34 LC 101/2000.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.03.00.00.00','POUPANÇA','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM POUPANÇA, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO III, DA RESOLUÇÃO CMN N° 3.506/2007','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.04.00.00.00','FUNDOS DE INVESTIMENTO EM RENDA FIXA','APRESENTAR OS INVESTIMENTOS REALIZADOS PELOS RPPS, EM FUNDOS DE INVESTIMENTOS EM RENDA FIXA, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO IV,  DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.05.00.00.00','FUNDOS DE INVESTIMENTOS EM RENDA FIXA - CRÉDITO PRIVADO','APRESENTAR OS INVESTIMENTOS REALIZADOS PELOS RPPS, EM FUNDOS DE INVESTIMENTOS EM RENDA FIXA - CRÉDITO PRIVADO, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO V, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.06.00.00.00','FUNDOS DE INVESTIMENTOS REFERENCIADOS','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM  FUNDOS DE INVESTIMENTOS REFERENCIADOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO III, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.07.00.00.00','FUNDOS DE INVESTIMENTOS EM DIREITOS CREDITORIOS','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM  FUNDOS DE INVESTIMENTOS EM DIREITO CREDITÓRIO, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO VI E ALÍNEA "A" DO INCISO VII, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.08.00.00.00','FUNDOS DE INVESTIMENTOS EM TITULOS DO TESOURO','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM  FUNDOS DE INVESTIMENTOS EM TÍTULOS DO TESOURO, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO I, ALÍNEA"B",  DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.09.00.00.00','OPERACOES COMPROMISSADAS','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM  OPERAÇÕES COMPROMISSADAS, EFETUADOS EM CONFORMIDADE COM O ART.  7º , INCISO II, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.00.00.00.00','APLICACOES EM SEGMENTO DE RENDA VARIAVEL','APRESENTAR O SOMATÓRIO DOS INVESTIMENTOS REALIZADOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, DA RESOLUÇÃO CMN N° 3.922/2010.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.01.00.00.00','FUNDOS DE AÇÕES REFERENCIADOS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE AÇÕES REFERENCIADOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO III, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.02.00.00.00','FUNDOS DE ACOES','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE AÇÕES, EFETUADOS EM CONFORMIDADE COM O ART. 8º, INCISO III, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.03.00.00.00','FUNDO MULTIMERCADO','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE MULTIMERCADO, EFETUADOS EM CONFORMIDADE COM O ART. 8º, INCISO IV, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.04.00.00.00','FUNDOS DE INDICES REFERENCIADOS EM ACOES','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM  FUNDOS DE ÍNDICES REFERENCIADOS EM AÇÕES, EFETUADOS EM CONFORMIDADE COM O ART. 8º, INCISO II, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.05.00.00.00','FUNDOS DE INVESTIMENTOS EM PARTICIPACOES','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM  FUNDOS DE INVESTIMENTOS EM PARTICIPAÇÕES, EFETUADOS EM CONFORMIDADE COM O ART. 8º, INCISO V, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.06.00.00.00','FUNDO DE INVESTIMENTOS IMOBILIÁRIOS','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE INVESTIMENTOS IMOBILIÁRIOS, EFETUADOS EM CONFORMIDADE COM O ART. 8º, INCISO VI, DA RESOLUÇÃO CMN N° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.11.00.00.00.00','APLICAÇÕES EM SEGMENTO IMOBILIÁRIO','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, NO SEGMENTO DE IMÓVEIS EFETUADOS EM CONFORMIDADE COM O ART. 8º DA RESOLUCAO CMN N° 3.790/2009.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.11.01.00.00.00','FUNDOS DE INVESTIMENTOS IMOBILIÁRIOS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, NO SEGMENTO DE IMÓVEIS','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.12.00.00.00.00','APLICAÇÕES EM ENQUADRAMENTO','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM DESACORDO COM AS REGRAS ESTABELECIDAS PELA RESOLUCAO CMN Nº 3790/2009, ARTIGO 25.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.12.01.00.00.00','TÍTULOS E VALORES EM ENQUADRAMENTO','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM DESACORDO COM AS REGRAS ESTABELECIDAS PELA RESOLUCAO CMN Nº 3790/2009, ARTIGO 25.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.13.00.00.00.00','TITULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM ATIVOS NÃO SUJEITOS ÀS REGRAS DA RESOLUÇÃO CMN Nº 3922/2010.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.13.01.00.00.00','TITULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, EM ATIVOS NÃO SUJEITOS ÀS REGRAS DA RESOLUÇÃO CMN Nº 3922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.14.00.00.00.00','APLICACOES COM A TAXA DE ADMINISTRACAO DO RPPS','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, COM RECURSOS DA TAXA DE ADMINISTRAÇÃO, SUJEITOS ÀS REGRAS DA RESOLUÇÃO CMN Nº 3922/2010.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.14.01.00.00.00','APLICACOES COM A TAXA DE ADMINISTRACAO DO RPPS','APRESENTAR OS INVESTIMENTOS REALIZADOS PELO RPPS, COM RECURSOS DA TAXA DE ADMINISTRAÇÃO, SUJEITOS ÀS REGRAS DA RESOLUÇÃO CMN Nº 3922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.2.0.00.00.00.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','Compreende as aplicações de recursos em metais preciosos, não destinados a negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.2.1.00.00.00.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS- CONSOLIDAÇÃO','Compreende as aplicações de recursos em metais preciosos, não destinados a negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.9.0.00.00.00.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.9.1.00.00.00.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS - CONSOLIDAÇÃO','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.9.1.01.00.00.00.00','(-) AJUSTES DE PERDAS COM TÍTULOS E VALORES MOBILIÁRIOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS EM TITULOS E VALORES MOBILIARIOS A CURTO PRAZO. INCLUSIVE OS VALORES DE AJUSTES PARA PERDAS EM APLICAÇÕES DA CARTEIRA DO RPPS E EM INVESTIMENTOS COM RECURSOS DA TAXA DE ADMINISTRAÇÃO DO RPPS, SUJEITOS ÀS REGRAS DA RESOLUÇÃO DO CMN Nº 3922/2010.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.9.1.02.00.00.00.00','(-) AJUSTES PARA PERDAS EM APLICACOES TEMPORARIAS EM METAIS PRECIOSOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS EM APLICACOES EM OURO E OUTROS METAIS PRECIOSOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.0.0.00.00.00.00.00','ESTOQUES','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.1.0.00.00.00.00.00','MERCADORIAS PARA REVENDA','Compreende todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.1.1.00.00.00.00.00','MERCADORIAS PARA REVENDA - CONSOLIDAÇÃO','Compreende todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.1.1.01.00.00.00.00','MERCADORIAS - ESTOQUES PROGRAMAS PRÓPRIOS','COMPREENDE O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA, RELATIVAS A PROGRAMAS PRÓPRIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.1.1.01.01.00.00.00','MERCADORIAS PARA VENDA OU REVENDA','REGISTRA O VALOR DAS MERCADORIAS PARA VENDA OU REVENDA E DOAÇÕES RELATIVAS A ESTOQUES DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.2.0.00.00.00.00.00','PRODUTOS E SERVIÇOS ACABADOS','Compreende os produtos já terminados e oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.2.1.00.00.00.00.00','PRODUTOS E SERVIÇOS ACABADOS - CONSOLIDAÇÃO','Compreende os produtos já terminados oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.2.1.01.00.00.00.00','PRODUTOS ACABADOS','REGISTRA O VALOR DE PRODUTOS MANUFATURADOS JA TERMINADOS, ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPÓSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.2.1.02.00.00.00.00','SERVIÇOS ACABADOS','REGISTRA OS VALORES PERTINENTES A SERVIÇOS ACABADOS QUE ESTAO PENDENTES DE FATURAMENTO OU DE TRANSFERENCIA PARA OUTRAS CONTAS DO ATIVO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.3.0.00.00.00.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','Compreende os produtos e serviços em andamento não concluídos na data do balanço.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.3.1.00.00.00.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO - CONSOLIDAÇÃO','Compreende os produtos e serviços em andamento não concluídos na data do balanço. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.3.1.01.00.00.00.00','PRODUTOS EM ELABORAÇÃO','REGISTRA A TOTALIDADE DAS MATÉRIAS-PRIMAS  JA REQUISITADAS QUE ESTAO EM PROCESSO DE TRANSFORMACAO E O MONTANTE DE CUSTOS DIRETOS E INDIRETOS RELATIVOS AOS PRODUTOS EM ELABORACAO  NÃO CONCLUIDOS NA DATA DO BALANCO PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.3.1.02.00.00.00.00','SERVIÇOS EM ELABORAÇÃO','REGISTRA OS CUSTOS DIRETOS E INDIRETOS RELATIVOS AOS SERVIÇOS EM ELABORACAO NÃO CONCLUIDOS NA DATA DO BALANCO PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.4.0.00.00.00.00.00','MATÉRIAS-PRIMAS','Compreende o estoque de matérias-primas, que será utilizado no processo produtivo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.4.1.00.00.00.00.00','MATÉRIAS-PRIMAS - CONSOLIDAÇÃO','Compreende o estoque de matérias-primas, que será utilizado no processo produtivo.. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.4.1.01.00.00.00.00','MATÉRIAS-PRIMAS - ARMAZENS PRÓPRIOS','REGISTRA O ESTOQUE DE MATÉRIAS-PRIMAS QUE SERAO UTILIZADOS NO PROCESSO PRODUTIVO, GUARDADAS EM ARMAZENS PRÓPRIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.5.0.00.00.00.00.00','MATÉRIAIS EM TRANSITO','Compreende o valor dos materiais em processo de transferência para outras unidades da entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.5.1.00.00.00.00.00','MATÉRIAIS EM TRANSITO - CONSOLIDAÇÃO','Compreende o valor dos materiais em processo de transferência para outras unidades da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.0.00.00.00.00.00','ALMOXARIFADO','Compreende o valor dos materiais destinados ao consumo interno da unidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.00.00.00.00.00','ALMOXARIFADO - CONSOLIDAÇÃO','Compreende o valor dos materiais destinados ao consumo interno da unidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.01.00.00.00.00','MATERIAL DE CONSUMO','REGISTRAR OS VALORES DOS MATERIAIS DE CONSUMO ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AS NECESSIDADES DA INSTITUIÇÃO E DE OUTRAS UNIDADES','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.02.00.00.00.00','GENEROS ALIMENTICIOS','REGISTRA OS VALORES DOS GENEROS ALIMENTICIOS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AS NECESSIDADES DA ENTIDADE  E DE OUTRAS UNIDADES DESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.03.00.00.00.00','MATERIAIS DE CONSTRUCAO','REGISTRA OS VALORES DOS MATERIAIS DE CONSTRUCAO ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE  E DE OUTRAS UNIDADES DESSA..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.05.00.00.00.00','AUTOPECAS','REGISTRA OS VALORES DE AUTOPECAS ADQUIRIDAS E ESTOCADAS EM ALMOXARIFADOS, DESTINADAS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.06.00.00.00.00','MEDICAMENTOS E MATERIAIS HOSPITALARES','REGISTRA OS VALORES DOS MEDICAMENTOS E MATERIAS HOSPITALARES ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.07.00.00.00.00','MATERIAIS GRAFICOS','REGISTRA OS VALORES DOS MATERIAIS GRAFICOS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.08.00.00.00.00','MATERIAL DE EXPEDIENTE','REGISTRA OS VALORES DOS MATERIAIS DE EXPEDIENTE ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.09.00.00.00.00','MATERIAIS A CLASSIFICAR','REGISTRA OS VALORES DOS MATERIAIS ESTOCADOS PENDENTES DE CLASSIFICACAO E IDENTIFICACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.10.00.00.00.00','ESTOQUE SOBRESSALENTES A ALIENAR','REGISTRA OS VALORES DE BENS SOBRESSALENTES QUE ESTEJAM DISPONIVEIS PARA ALIENACAO SOB DIVERSAS FORMAS (VENDA, LEILÃO, ETC).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.99.00.00.00.00','OUTROS ALMOXARIFIDOS','REGISTRA OS VALORES DOS OUTROS ALMOXARIFADOS ADQUIRIDOS E ESTOCADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE E DE OUTRAS UNIDADES DESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.7.0.00.00.00.00.00','ADIANTAMENTOS A FORNECEDORES','Compreende os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.7.1.00.00.00.00.00','ADIANTAMENTOS A FORNECEDORES - CONSOLIDAÇÃO','Registra os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.0.00.00.00.00.00','OUTROS ESTOQUES','Compreende o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.00.00.00.00.00','OUTROS ESTOQUES - CONSOLIDAÇÃO','Compreende o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.01.00.00.00.00','MATERIAIS DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA OS VALORES DE ESTOQUE QUE SE DESTINAM A EMBALAGEM DO PRODUTO OU A SEU ACONDICIONAMENTO PARA REMESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.02.00.00.00.00','ESTOQUES PARA DISTRIBUIÇÃO','COMPREENDE O VALOR DO MATERIAL EM ESTOQUE, DESTINADO A DISTRIBUICAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.02.01.00.00.00','MATERIAL DE CONSUMO - ESTOQUE INTERNO - DESTINADO A DISTRIBUIÇÃO','REGISTRA OS VALORES RELATIVOS AS AQUISICOES E OU TRANSFERENCIAS DE MATERIAIS DE CONSUMO PARA A FORMACAO DE ESTOQUE INTERNO DESTINADO A DISTRIBUICAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.02.03.00.00.00','MEDICAMENTOS - ESTOQUE INTERNO - DESTINADO A DISTRIBUIÇÃO','REGISTRA OS VALORES DOS MEDICAMENTOS E OUTROS PRODUTOS FARMACEUTICOS, ADQUIRIDOS OU FABRICADOS PELA UNIDADE,  DESTINADOS A FORMACAO DE ESTOQUE DE DISTRIBUICAO PARA CONSUMO INTERNO OU REDISTRIBUICAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.02.05.00.00.00','ESTOQUE DE MATERIAIS PARA PREMIAÇÕES','REGISTRA OS VALORES DAS PREMIAÇÕES COMO: MEDALHAS E PLACAS DESTINADOS A FORMACAO DE ESTOQUE DE DISTRIBUICAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.03.00.00.00.00','ESTOQUES PARA DOAÇÃO E/OU PERMUTA','COMPREENDE O VALOR DAS MERCADORIAS EM ESTOQUES PARA DOACAO E/OU PERMUTA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.04.00.00.00.00','ESTOQUES DE PRODUTOS PARA PESQUISA E ENSINO','COMPREENDE O VALOR DO MATERIAL EM ESTOQUE, RELATIVO A ANIMAL, VEGETAL OU MINERAL, DESTINADO A PESQUISA E ENSINO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.05.00.00.00.00','IMPORTAÇÕES EM ANDAMENTO','COMPREENDE O VALOR DAS IMPORTAÇÕES EM ANDAMENTO DE BENS DE ESTOQUE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.05.01.00.00.00','IMPORTAÇÕES EM ANDAMENTO DO EXERCÍCIO','REGISTRA O VALOR DAS IMPORTAÇÕES EM ANDAMENTO DE BENS DE ESTOQUE, DURANTE O EXERCICIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.05.02.00.00.00','IMPORTAÇÕES EM ANDAMENTO DE EXERCÍCIOS ANTERIORES','REGISTRA O VALOR DAS IMPORTAÇÕES EM ANDAMENTO DE BENS DE ESTOQUE, INICIADAS EM EXERCICIOS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.06.00.00.00.00','CONSTRUÇÕES CIVIS','COMPREENDE OS VALORES DOS IMOVEIS QUE DEVAM SER COLOCADOS A VENDA OU QUE TENHAM SIDO ADQUIRIDOS PARA VENDA OU REVENDA, PODENDO A COMERCIALIZACAO SER OU NÃO OBJETO PRINCIPAL DA EMPRESA, ENTIDADE, INSTITUICAO OU ORGAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.06.01.00.00.00','TERRENOS','REGISTRA OS VALORES DE TERRENOS, INCLUINDO-SE OS CUSTOS DE FORMACAO OU DE URBANIZACAO E AJUSTES MONETARIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.06.02.00.00.00','PROJETOS','REGISTRA OS VALORES DOS CUSTOS RELATIVOS AOS PROJETOS   DE ARQUITETURA E URBANISMO PARA CONSTRUCOES E URBANIZAÇÕES DE IMOVEIS QUE DEVERAO SER COLOCADOS A VENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.06.03.00.00.00','OBRAS EM ANDAMENTO','REGISTRA OS VALORES RELATIVOS A OBRAS EM ANDAMENTO, DESTINADAS A VENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.06.04.00.00.00','OBRAS CONCLUÍDAS A COMERCIALIZAR','REGISTRA OS VALORES RELATIVOS AS CONSTRUCOES E AS EDIFICAÇÕES CONCLUÍDAS QUE DEVERAO SER COLOCADAS A VENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.06.05.00.00.00','CUSTOS ACESSÓRIOS DE CONSTRUÇÃO CIVIL','REGISTRA OS VALORES DE SEGUROS, REMUNERAÇÕES A AGENTES FINANCEIROS, IMPOSTOS E TAXAS, DESPESAS COM LEGALIZAÇÕES E CARTORARIAS RELATIVOS A IMOVEIS DESTINADOS A VENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.98.00.00.00.00','ESTOQUES DIVERSOS','REGISTRA OS ESTOQUES NÃO CLASSIFICAVEIS NAS DEMAIS CONTAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.9.0.00.00.00.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES','Compreende o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro do ajuste  de perdas para os estoque que tiverem o valor de mercado inferior ao seu custo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.9.1.00.00.00.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','Compreende o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro do ajuste  de perdas para os estoque que tiverem o valor de mercado inferior ao seu custo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.9.1.01.00.00.00.00','(-) AJUSTE  PARA PERDAS EM ESTOQUES','REGISTRA AS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NÃO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NÃO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.9.1.02.00.00.00.00','(-) AJUSTE PARA REDUÇÃO AO VALOR DE MERCADO','REGISTRA O AJUSTE PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.0.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço a entidade ocorrerão no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.1.0.00.00.00.00.00','PRÊMIOS DE SEGUROS A APROPRIAR','Compreende os valores pagos a titulo de prêmios de seguro a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.1.1.00.00.00.00.00','PRÊMIOS DE SEGUROS A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de prêmios de seguro a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.2.0.00.00.00.00.00','VPD FINANCEIRAS A APROPRIAR','Compreende os valores pagos, a título de VPD financeiras a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.2.1.00.00.00.00.00','VPD FINANCEIRAS A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos, a título de VPD financeiras a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.3.0.00.00.00.00.00','ASSINATURAS E ANUIDADES A APROPRIAR','Compreende os valores pagos a titulo de assinaturas e anuidades a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.3.1.00.00.00.00.00','ASSINATURAS E ANUIDADES A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de assinaturas e anuidades a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.4.0.00.00.00.00.00','ALUGUEIS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de aluguel a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.4.1.00.00.00.00.00','ALUGUEIS PAGOS A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de aluguel a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.5.0.00.00.00.00.00','TRIBUTOS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de tributos a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.5.1.00.00.00.00.00','TRIBUTOS PAGOS A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de tributos a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.6.0.00.00.00.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','Compreende os valores pagos a titulo de contribuições confederativas a apropriar','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.6.1.00.00.00.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de contribuições confederativas a apropriar.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.7.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL A APROPRIAR','Compreende os valores pagos a titulo de beneficio a pessoal a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.7.1.00.00.00.00.00','BENEFÍCIOS A PESSOAL A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de beneficio a pessoal a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.8.0.00.00.00.00.00','DEMAIS VPD A APROPRIAR','Compreende os demais valores pagos a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.8.1.00.00.00.00.00','DEMAIS VPD A APROPRIAR - CONSOLIDAÇÃO','Compreende os demais valores pagos a apropriar.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.0.0.0.00.00.00.00.00','ATIVO NÃO CIRCULANTE','Compreende o ativo não circulante: o ativo realizável a longo prazo, os investimentos, o imobilizado e o intangível.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.0.0.00.00.00.00.00','ATIVO REALIZÁVEL A LONGO PRAZO','Compreende os bens, direitos e despesas antecipadas realizáveis no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.0.00.00.00.00.00','CRÉDITOS A LONGO PRAZO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos e com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.01.00.00.00.00','CLIENTES','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.01.03.00.00.00','FATURAS/ DUPLICATAS A RECEBER   - ESTOQUE PROPRIO','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS  DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.01.06.00.00.00','FATURAS/DUPLICATAS A RECEBER - PRESTAÇÃO DE SERVIÇOS','REGISTRA A  APROPRIAÇÃO E MOVIMENTAÇÃO DOS FATURAMENTOS, A CURTO PRAZO,  PROVENIENTES DE VENDAS DE PRODUTOS DO ESTOQUE','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.01.99.00.00.00','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NÃO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.02.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento no longo prazo, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.01.00.00.00','CREDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','COMPREENDE OS CREDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.01.01.00.00','CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.01.01.01.00','CREDITOS A ENCAMINHAR PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITOS A SEREM ENCAMINHADOS PELAS UG PARA  INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.01.01.02.00','CREDITOS  ENCAMINHADOS PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS ENCAMINHADOS PELAS UG, PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.01.02.00.00','CREDITOS INSCRITOS EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS  CONTRA TERCEIROS  PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS  LANCADOS NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO DE ORIGEM QUE CONSTITUIREM EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.02.00.00.00','CREDITOS PREVIDENCIÁRIOS INSCRITOS','COMPREENDE OS CREDITOS PREVIDENCIÁRIOS INSCRITOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.02.01.00.00','CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.02.01.01.00','CREDITOS A ENCAMINHAR PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITOS A SEREM ENCAMINHADOS PELAS UG PARA  INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.02.01.02.00','CREDITOS  ENCAMINHADOS PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS ENCAMINHADOS PELAS UG, PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.02.02.00.00','CREDITOS INSCRITOS EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS  CONTRA TERCEIROS  PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS  LANCADOS NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO DE ORIGEM QUE CONSTITUIREM EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA - CLIENTES','Registra os valores dos créditos de divida ativa não tributaria derivados de clientes, em processo de inscrição e já inscritos, realizáveis no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.00.00.00','CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITO EM PROCESSO DE INSCRICAO EM DIVIDA ATIVA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.01.00.00','CREDITOS A ENCAMINHAR PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS A CREDITOS A SEREM ENCAMINHADOS PELAS UG PARA  INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.02.00.00','CREDITOS  ENCAMINHADOS PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS ENCAMINHADOS PELAS UG, PARA INSCRICAO EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.02.00.00.00','CREDITOS INSCRITOS EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AOS CREDITOS  CONTRA TERCEIROS  NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO DE ORIGEM QUE CONSTITUIREM EM DIVIDA ATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.01.00.00.00','EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELO MUNICIPIO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.02.00.00.00','EMPRESTIMOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS  CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS  OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.03.00.00.00','EMPRÉSTIMOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A EMPRÉSTIMOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL, REALIZÁVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.06.00.00.00','ENCARGOS  SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.08.00.00.00','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES RELATIVOS AOS FINANCIAMENTOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES MUNICIPAIS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.08.01.00.00','FINANCIAMENTOS HABITACIONAIS','REPRESENTA O VALOR DOS CRÉDITOS DEVIDOS A ENTIDADES MUNICIPAIS  DECORRENTES DE FINANCIAMENTOS HABITACIONAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.10.00.00.00','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL, REALIZÁVEIS  APOS O TERMINO DO EXERCICIO SEGUINTE (EXEMPLO: FINANCIAMENTOS IMOBILIÁRIOS)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.11.00.00.00','FINANCIAMENTOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS AOS FINANCIAMENTOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES MUNICIPAIS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.12.00.00.00','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER','REGISTRA O VALOR  DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS. JUROS PRO-RATA SAO AQUELES DEFINIDOS  POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.18.00.00.00','RESIDUO DE EMPRESTIMOS CONCEDIDOS','REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM LONGO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.99.00.00.00','OUTROS EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.01.00.00.00','(-) AJUSTE DE PERDAS  PARA CREDITOS DE LIQUIDACAO DUVIDOSA','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.02.00.00.00','(-) AJUSTE PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.03.00.00.00','(-) AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS NA DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MCASP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.04.00.00.00','(-) AJUSTE DE PERDAS  DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES','REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.05.00.00.00','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - INTRA OFSS','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.02.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento após término exercício seguinte, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.03.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.03.01.00.00.00','CREDITOS NAO PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.03.02.00.00.00','CREDITOS PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA  PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.01.00.00.00','EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELO MUNICIPIO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.02.00.00.00','EMPRESTIMOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS  CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS  OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.03.00.00.00','EMPRÉSTIMOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A EMPRÉSTIMOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL, REALIZÁVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.06.00.00.00','ENCARGOS  SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.08.00.00.00','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES RELATIVOS AOS FINANCIAMENTOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES MUNICIPAIS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.10.00.00.00','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIÁRIOS, QUANDO NÃO HAVIA IMPEDIMENTO LEGAL, REALIZÁVEIS  APOS O TERMINO DO EXERCICIO SEGUINTE (EXEMPLO: FINANCIAMENTOS IMOBILIÁRIOS)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.11.00.00.00','FINANCIAMENTOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS A FINANCIAMENTOS  CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS  OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.12.00.00.00','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER','REGISTRA O VALOR  DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS. JUROS PRO-RATA SAO AQUELES DEFINIDOS  POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.18.00.00.00','RESIDUO DE EMPRESTIMOS CONCEDIDOS','REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELO MUNICIPIO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM LONGO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.99.00.00.00','OUTROS EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende  os ajustes de perdas estimadas com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.99.02.00.00.00','(-) AJUSTE  PARA PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE  PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.99.03.00.00.00','(-) AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES O AJUSTE  PARA PERDAS PARA A DIVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.99.05.00.00.00','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.02.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento após término exercício seguinte, oriundos daw variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.03.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.03.01.00.00.00','CREDITOS NAO PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.03.02.00.00.00','CREDITOS PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA  PREVIDENCIARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.05.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.05.01.00.00.00','EMPRÉSTIMOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS CRÉDITOS POR EMPRÉSTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.05.03.00.00.00','FINANCIAMENTOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.05.99.00.00.00','OUTROS EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS - INTER OFSS - UNIÃO','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende  os ajustes de perdas estimadas com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.99.03.00.00.00','(-) AJUSTE PARA PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE  PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.99.04.00.00.00','(-) AJUSTE  PARA PERDAS DE DIVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE  PARA PERDAS PARA A DIVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.99.06.00.00.00','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.02.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento no longo prazo, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.03.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.05.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende os ajustes de perdas estimadas s com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.99.02.00.00.00','(-) AJUSTE PARA PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE  PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.99.03.00.00.00','(-) AJUSTE  PARA PERDAS DE DIVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE  PARA PERDAS PARA A DIVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.99.05.00.00.00','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.02.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento no longo prazo, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.03.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.05.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende os ajustes de perdas estimadas s com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.99.02.00.00.00','(-) AJUSTE PARA PERDAS DE CRÉDITOS TRIBUTÁRIOS','REGISTRA O AJUSTE  PARA COBRIR AS PERDAS ESTIMADAS NOS CRÉDITOS TRIBUTÁRIOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.99.03.00.00.00','(-) AJUSTE  PARA PERDAS DE DIVIDA ATIVA TRIBUTÁRIA','REGISTRA OS VALORES REFERENTES AO AJUSTE  PARA PERDAS PARA A DIVIDA ATIVA TRIBUTÁRIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.99.05.00.00.00','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.0.00.00.00.00.00','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','Compreende os valores a receber por demais transações, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.00.00.00.00.00','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os valores a receber por demais transações, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.01.00.00.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','Compreende as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.02.00.00.00.00','TRIBUTOS A RECUPERAR / COMPENSAR','Compreende o somatório dos valores dos tributos a recuperar / compensar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.03.00.00.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Compreende os créditos a receber com realização após os doze meses seguintes a data de públicação das demonstrações contábeis, decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta como por meio de delegação, nas formas de concessão, permissão ou autorização ao particular do direito de exploração de serviços públicos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.00.00.00.00','CRÉDITOS POR DANOS AO PATRIMÔNIO PROVENIENTES DE CRÉDITOS ADMINISTRATIVOS','Compreende os valores realizáveis após os doze meses seguintes a data de públicação das demonstrações contábeis, provenientes de direitos oriundos de danos ao patrimônio, apurados em processos administrativos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.01.00.00.00','CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','REGISTRA O CREDITO DO ENTE CORRESPONDENTE A DEBITOS ADMINISTRATIVOS  DECORRENTES DE FOLHA DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.02.00.00.00','CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','REGISTRA O CREDITO DO ENTE CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.03.00.00.00','CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','REGISTRA O CREDITO DO ENTE CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.04.00.00.00','CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','REGISTRA O CREDITO DO ENTE CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.05.00.00.00','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NAO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU DETERMINACAO  ADMINISTRATIVA OU SEJA, QUANDO O PRODUTO A ARRECADAR NAO TENHA SIDO RECOLHIDO NO PRAZO LEGAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.06.00.00.00','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.07.00.00.00','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO,  POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.10.00.00.00','CRÉDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFÍCIOS PREVIDENCIÁRIOS','REGISTRA O CRÉDITO A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFÍCIOS PREVIDENCIÁRIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.99.00.00.00','OUTROS CREDITOS ADMINISTRATIVOS','REGISTRA O CREDITO DO ENTE CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.00.00.00.00','CRÉDITOS POR DANOS AO PATRIMÔNIO APURADOS EM TOMADA DE CONTAS ESPECIAL','Compreende os valores realizáveis após os doze meses seguintes a data de públicação das demonstrações contábeis, provenientes de direitos oriundos de danos ao patrimônio, apurados em tomada de contas especial.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.01.00.00.00','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS  RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE,  INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.02.00.00.00','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL  - TOMADA DE CONTAS ESPECIAL','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES, NAO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU DETERMIMANACAO  ADMINISTRATIVA, OU SEJA, QUANDO O PRODUTO A ARRECADAR NAO TENHA SIDO RECOLHIDO NO PRAZO LEGAL..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.03.00.00.00','CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS  - TOMADA DE CONTAS ESPECIAL','REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DO MUNICIPIO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.04.00.00.00','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.05.00.00.00','CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS A FAZENDA PUBLICA SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.06.00.00.00','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO  - TOMADA DE CONTAS ESPECIAL','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS  COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.07.00.00.00','CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS  - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.08.00.00.00','CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO  - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTA','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.09.00.00.00','CREDITOS  A RECEBER DECORRENTES DE FALTA DE LICITACAO  - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A   NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR  DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA  RESPONSABILIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.10.00.00.00','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO,  POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE .','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.11.00.00.00','CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS  - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO  OU  PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO:  PARTE  DO  EMPREGADOR  DE OBRIGAÇÕES PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E  NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM O ENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.13.00.00.00','CREDITOS  A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE   - TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS  RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.99.00.00.00','OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO  ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.00.00.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis após os doze meses seguintes a data de públicação das demonstrações contábeis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.01.00.00.00','DEPOSITOS  E CAUCOES RELATIVOS A CONTRATOS OU CONVENCOES','REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES, EFETUADOS  POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES  ESPECIFICAS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.03.00.00.00','DEPOSITOS JUDICIAIS','REGISTRA OS VALORES A RECEBER DECORRENTES DE DEPOSITOS EFETUADOS POR DETERMINACAO JUDICIAL, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.05.00.00.00','DEPOSITOS PARA INTERPOSICAO DE RECURSOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS, DECORRENTES DE INTERPOSICAO DE  RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.07.00.00.00','DEPOSITOS ESPECIAIS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.08.00.00.00','VALORES  APREENDIDOS POR DECISAO JUDICIAL','REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.99.00.00.00','OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.07.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA - DEMAIS CRÉDITOS','Registra os valores dos créditos de divida ativa não tributaria, exceto as derivadas de clientes, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de públicação dos demonstrativos contábeis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.07.01.00.00.00','INSCRICAO DE CERTIDAO DE DECISAO - TITULO EXECUTIVO DO TCE/RS','REPRESENTA CRÉDITOS DE NATUREZA NÃO-TRIBUTÁRIA EXIGÍVEIS A PARTIR DO RECEBIMENTO, PELA ENTIDADE, DE CERTIDÃO DE DECISÃO - TÍTULO EXECUTIVO, EMITIDA PELO TRIBUNAL DE CONTAS DO ESTADO COM CARACTERÍSTICA DE LIQUIDEZ E CERTEZA, PODENDO SER, FACULTATIVAMENTE INSCRITA COMO DIVIDA ATIVA NÃO TRIBUTARIA','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.00.00.00.00','OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO','Compreende os outros créditos e valores realizáveis após os doze meses seguintes a data da publicação das demonstrações contábeis, provenientes de direitos obtidos junto a diversos devedores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.01.00.00.00','CRÉDITOS A RECEBER DE ENTIDADES FEDERAIS','REGISTRA OS VALORES REALIZÁVEIS APOS O TERMINO DO EXERCICIO SEGUINTE DECORRENTES DE DEBITO DE ENTIDADES FEDERAIS COM A UNIAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.03.00.00.00','CREDITOS ORIUNDOS DE CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS','REGISTRA O VALOR DOS CREDITOS ORIUNDOS DAS CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS DO ENTE, PARA TERCEIROS OU PARA OUTRAS ENTIDADES GOVERNAMENTAIS, REALIZAVEIS A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.04.00.00.00','CREDITOS A RECEBER DE DEVEDORES DE CONVENIOS','REGISTRA OS VALORES ORIUNDOS DE CREDITOS DE CONVENIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.05.00.00.00','CREDITOS A RECEBER DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS E IMOVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.07.00.00.00','CREDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRACAO','REGISTRA O VALOR DOS CREDITOS ADMINISTRATIVOS ORIUNDOS DE AUTOS DE INFRACAO E OUTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.08.00.00.00','CREDITOS A RECEBER EM PARCELAS/ LOTES ORIUNDOS DE DESAPROPRIACOES','REGISTRA OS VALORES A RECEBER ORIUNDOS DE DESAPROPRIACOES DE IMOVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.12.00.00.00','VALORES A RECUPERAR DECORRENTES DE INDENIZACAO DE SINISTROS PAGOS','REGISTRA OS VALORES A RECUPERAR DECORRENTES DE PAGAMENTOS DE INDENIZACOES DE SINISTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.13.00.00.00','INDENIZACOES A RECEBER','REGISTRA OS VALORES DAS INDENIZACOES A RECEBER A LONGO PRAZO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.14.00.00.00','CREDITOS A RECUPERAR','REGISTRA O VALOR DOS CREDITOS A RECUPERAR APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.16.00.00.00','CREDITOS EM LIQUIDACAO','REGISTRA OS VALORES ORIUNDOS DE CREDITOS EM LIQUIDACAO DE DIFICIL REALIZACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.17.00.00.00','CREDITOS PARCELADOS','REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.19.00.00.00','CREDITOS A RECEBER EM PODER DA JUSTICA','REGISTRA OS VALORES A RECEBER EM PODER DA JUSTICA, SEM PREVISAO DE RECEBIMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.20.00.00.00','TITULOS A RECEBER','COMPREENDE OS VALORES A RECEBER A LONGO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.99.00.00.00','OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO','COMPREENDE OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO, NAO CLASSIFICAVEIS EM OUTRAS CONTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.99.01.00.00','INSCRICAO DE CERTIDAO DE DECISAO - TITULO EXECUTIVO DO TCE/RS','REPRESENTA CRÉDITOS EXIGÍVEIS A PARTIR DO RECEBIMENTO, PELA ENTIDADE, DE CERTIDÃO DE DECISÃO - TÍTULO EXECUTIVO, EMITIDA PELO TRIBUNAL DE CONTAS DO ESTADO COM CARACTERÍSTICA DE LIQUIDEZ E CERTEZA, PODENDO SER, FACULTATIVAMENTE INSCRITA COMO DIVIDA ATIVA NÃO TRIBUTARIA','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.00.00.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos a longo prazo, por inadimplência de terceiros e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.02.00.00.00','(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','REGISTRA O AJUSTE PARA PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DIVIDA ATIVA NAO TRIBUTARIA DE LONGO PRAZO, EXCETO AS DERIVADAS DE CLIENTES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.03.00.00.00','(-) AJUSTE DE PERDAS DE CREDITOS ADMINISTRATIVOS','REGISTRA OS VALORES DOS AJUSTES PARA PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.04.00.00.00','(-) AJUSTE DE PERDAS DE CREDITOS  APURADOS EM TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES  DOS AJUSTES PARA PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.98.00.00.00','(-) AJUSTE DE PERDAS DE OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO','REGISTRA OS VALORES DOS AJUSTES DE PERDAS DE OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.0.00.00.00.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','Compreende as aplicações de recursos em títulos, valores mobiliários e imobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.00.00.00.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as aplicações de recursos em títulos, valores mobiliários e imobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.00.00.00.00','TÍTULOS E VALORES MOBILIÁRIOS','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis após os doze meses seguintes a data da publicação das demonstrações contábeis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.01.00.00.00','TITULOS DA DIVIDA AGRARIA - TDA','REGISTRA OS VALORES RELATIVOS AOS TITULOS DA DIVIDA AGRARIA,  PARA FINS DE INDENIZACOES DE PROPRIEDADES RURAIS, COM OBJETIVO DE REFORMA AGRARIA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.02.00.00.00','TITULOS PUBLICOS - LETRAS ESPECIAIS','REGISTRA O VALOR DAS LETRAS ESPECIAIS EM TITULOS PUBLICOS EMITIDOS NO MERCADO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.06.00.00.00','DEMAIS ACOES','REGISTRA OS VALORES DAS DAS DEMAIS ACOES REPRESENTATIVAS DAS PARTICIPACOES DOS ORGAOS E ENTIDADES NO CAPITAL DAS SOCIEDADES POR ACOES HAVIDAS POR AQUISICOES, SUBSCRICOES, BONIFICACOES E DOACOES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.07.00.00.00','FUNDO DE APLICACOES EM COTAS - RENDA VARIAVEL','REGISTRA OS VALORES APLICADOS EM FUNDOS DE APLICACOES EM COTAS - RENDA VARIAVEL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.09.00.00.00','APLICACOES EM ATIVOS EM ENQUADRAMENTO - TITULOS E VALORES - RPPS','REGISTRAR OS VALORES DOS ATIVOS EM FASE DE ENQUADRAMENTO CONFORME ESTABELECE O ARTIGO 21 DA RESOLUÇÃO CMN Nº 3922/2010, REALIZÁVEIS OU NÃO APÓS O TÉRMINO DO EXERCÍCIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.10.00.00.00','APLICACOES EM ATIVOS NAO SUJEITOS A RESOLUCAO DO CMN - TITULOS E VALORES','REGISTRA OS VALORES DOS ATIVOS - TÍTULOS E VALORES- NÃO SUJEITOS AS REGRAS ESTABELECIDAS NA RESOLUCAO CMN Nº 3790/2009, REALIZÁVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.99.00.00.00','OUTROS TITULOS E VALORES MOBILIARIOS','REGISTRA OS OUTROS TÍTULOS E VALORES MOBILIÁRIOS A LONGO PRAZO, NÃO CLASSIFICAVEIS NAS CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.02.00.00.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','compreendem as aplicacoes de recursos em metais preciosos, nao destinados a negociacao e que nao facam parte das atividades operacionais da entidade, resgataveis apos os doze meses seguintes a data da publicacao das demonstracoes contabeis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.03.00.00.00.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS','Compreende os investimentos de longo prazo realizados em segmento de imóveis, realizáveis no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.03.01.00.00.00','EDIFICACOES','REGISTRA OS INVESTIMENTOS EM EDIFICACOES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.03.02.00.00.00','TERRENOS','REGISTRA OS INVESTIMENTOS EM TERRENOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.03.03.00.00.00','SALAS E ESCRITORIOS','REGISTRA OS INVESTIMENTOS EM SALAS E ESCRITORIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.03.04.00.00.00','OUTROS BENS IMOVEIS','REGISTRA OS INVESTIMENTOS EM OUTROS BENS IMOVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.99.00.00.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.99.01.00.00.00','(-) AJUSTE PARA PERDAS EM TÍTULOS, VALORES MOBILIÁRIOS E IMOVEIS','REGISTRA OS VALORES DOS AJUSTES PARA PERDAS EM TÍTULOS , VALORES MOBILIÁRIOS E IMOVEIS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.99.02.00.00.00','(-) AJUSTE DE PERDAS COM APLICACOES TEMPORARIAS EM METAIS PRECIOSOS','REGISTRA OS VALORES DE AJUSTES PARA PERDAS EM APLICACOES EM OURO E OUTROS METAIS PRECIOSOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.0.00.00.00.00.00','ESTOQUES','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade para utilização própria ou para venda, previstos para período posterior ao término do exercício seguinte.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.00.00.00.00.00','ESTOQUES - CONSOLIDAÇÃO','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.01.00.00.00.00','MERCADORIAS PARA REVENDA','Compreende todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.02.00.00.00.00','PRODUTOS E SERVIÇOS ACABADOS','Compreende os produtos já terminados e oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.03.00.00.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','Compreende os produtos e serviços em andamento que não serão concluídos até o término do exercício subsequente a data do balanço patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.04.00.00.00.00','MATÉRIAS-PRIMAS','Compreende o estoque de matérias-primas que será utilizado no processo produtivo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.05.00.00.00.00','MATÉRIAIS EM TRANSITO','Compreende o valor dos materiais em processo de transferência para outras unidades da entidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.06.00.00.00.00','ALMOXARIFADO','Compreende o valor dos materiais destinados ao consumo interno da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.07.00.00.00.00','ADIANTAMENTOS A FORNECEDORES','Compreende os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.98.00.00.00.00','OUTROS ESTOQUES','Compreende o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.99.00.00.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES','Compreende o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro de perdas estimadas para os estoque que tiverem o valor de mercado inferior ao seu custo. Conta a ser utilizada apenas para os estoques classificados no ativo realizável a longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.99.01.00.00.00','(-) AJUSTE PARA PERDAS EM ESTOQUES','REGISTRA AS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NAO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NAO ESTAREM IDENTIFICADAS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.99.02.00.00.00','(-) AJUSTE PARA REDUCAO AO VALOR DE MERCADO','REGISTRA O AJUSTE PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço à entidade ocorrerão no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE- CONSOLIDAÇÃO','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço a entidade ocorrerão no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.01.00.00.00.00','PRÊMIOS DE SEGUROS A APROPRIAR','Compreende os valores pagos a titulo de prêmios de seguro a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.02.00.00.00.00','VPD FINANCEIRAS A APROPRIAR','Compreende os valores pagos a título de VPD financeiras a apropriar.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.03.00.00.00.00','ASSINATURAS E ANUIDADES A APROPRIAR','Compreende os valores pagos a titulo de assinaturas e anuidades a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.04.00.00.00.00','ALUGUEIS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de aluguel a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.05.00.00.00.00','TRIBUTOS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de tributos a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.06.00.00.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','Compreende os valores pagos a titulo de contribuições confederativas a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.07.00.00.00.00','BENEFÍCIOS A APROPRIAR','Compreende os valores pagos a titulo de beneficio a pessoal a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.99.00.00.00.00','DEMAIS VPD A APROPRIAR','Compreende os demais valores pagos a apropriar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.0.0.00.00.00.00.00','INVESTIMENTOS','Compreende as participações permanentes em outras sociedades, bem como os bens e direitos não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção da atividade da entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.0.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - CONSOLIDAÇÃO','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.01.01.00.00.00','PARTICIPACOES EM EMPRESAS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.01.03.00.00.00','PARTICIPACOES EM CONSORCIOS PUBLICOS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM CONSORCIOS PUBLICOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.01.95.00.00.00','OUTRAS PARTICIPACOES - MEP','REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.02.01.00.00.00','PARTICIPACOES EM EMPRESAS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.02.99.00.00.00','OUTRAS PARTICIPACOES - METODO DE CUSTO','REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.2.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - INTRA OFSS','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.2.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.2.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.3.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - UNIÃO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.3.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.3.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.4.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - ESTADO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.4.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.4.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.5.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - MUNICÍPIO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.5.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.5.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.2.0.00.00.00.00.00','PROPRIEDADES PARA INVESTIMENTO','Compreende a propriedade (terreno ou edifício - ou parte de edifício - ou ambos) mantida (pelo proprietário ou pelo arrendatário em arrendamento financeiro) para auferir aluguel ou para valorização do capital ou para ambas, e não para: uso na produção ou fornecimento de bens ou serviços ou para finalidades administrativas; ou venda no curso ordinário do negócio.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.2.1.00.00.00.00.00','PROPRIEDADES PARA INVESTIMENTO - CONSOLIDAÇÃO','Compreende a propriedade (terreno ou edifício - ou parte de edifício - ou ambos) mantida (pelo proprietário ou pelo arrendatário em arrendamento financeiro) para auferir aluguel ou para valorização do capital ou para ambas, e não para: uso na produção ou fornecimento de bens ou serviços ou para finalidades administrativas; ou venda no curso ordinário do negócio. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.2.1.01.00.00.00.00','TERRENOS E IMOVEIS PARA FUTURA UTILIZAÇÃO','REGISTRA OS VALORES DE IMOVEIS DA UNIDADE MANTIDOS PARA FUTURA UTILIZACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.2.1.02.00.00.00.00','BENS IMOVEIS NÃO DESTINADOS A USO','REGISTRA OS VALORES DE IMOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.0.00.00.00.00.00','INVESTIMENTOS DO RPPS DE LONGO PRAZO','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social, em conformidade com a legislação que trata das aplicações e investimentos dos RPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.00.00.00.00.00','INVESTIMENTOS DO RPPS DE LONGO PRAZO - CONSOLIDAÇÃO','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social, em conformidade com a legislação que trata das aplicações e investimentos dos RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.01.00.00.00.00','TÍTULOS E VALORES MOBILIÁRIOS - RPPS','COMPREENDE OS INVESTIMENTOS REALIZADOS PELO REGIME PRÓPRIO DA PREVIDÊNCIA SOCIAL. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.01.01.00.00.00','APLICAÇÕES EM ATIVOS EM ENQUADRAMENTO - TÍTULOS E VALORES','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM DESACORDO COM AS REGRAS ESTABELECIDAS PELA RESOLUCAO CMN Nº 3790/2009, ARTIGO 25.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.01.02.00.00.00','APLICAÇÕES EM ATIVOS NÃO SUJEITOS À RESOLUÇÃO DO CMN - TÍTULOS E VALORES','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM ATIVOS NÃO SUJEITOS AS REGRAS DA  RESOLUCAO CMN Nº 3790/2009.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.02.00.00.00.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS - RPPS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, NO SEGMENTO DE IMÓVEIS EFETUADOS EM CONFORMIDADE COM O ART. 8º DA RESOLUCAO CMN N° 3.790/2009.','','N','','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.02.01.00.00.00','IMÓVEIS - RPPS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM IMÓVEIS SUJEITOS AS REGRAS DA  RESOLUCAO CMN Nº 3790/2009.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.0.00.00.00.00.00','DEMAIS INVESTIMENTOS PERMANENTES','Compreende os demais direitos de qualquer natureza não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção das atividades da entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.1.00.00.00.00.00','DEMAIS INVESTIMENTOS PERMANENTES - CONSOLIDAÇÃO','Compreende os demais direitos de qualquer natureza não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção das atividades da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.1.01.00.00.00.00','OBRAS DE ARTE','REGISTRA OS VALORES REFERENTES A OBRAS DE ARTE DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.1.03.00.00.00.00','BENS MOVEIS NÃO DESTINADOS A USO','REGISTRA OS VALORES DE MOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.1.05.00.00.00.00','BENS INTANGIVEIS NÃO DESTINADOS A USO','REGISTRA O VALOR DE BENS INTANGIVEIS NÃO DESTINADOS AO USO E QUE A UNIDADE NÃO EXPLORA COMERCIALMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.1.06.00.00.00.00','TÍTULOS E VALORES MOBILIÁRIOS PERMANENTES','REGISTRA O VALOR DOS TÍTULOS E VALORES MOBILIÁRIOS  NÃO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZÁVEL A LONGO PRAZO, COMO POR EXEMPLO AS DEBENTURES (PERPETUAS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.1.99.00.00.00.00','DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA O VALOR DE INVESTIMENTOS PERMANENTES, NÃO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.8.0.00.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS','Compreende a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, como a depreciação das propriedades mantidas para investimento.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.8.1.00.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, como a depreciação das propriedades mantidas para investimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.8.1.01.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS - CONSOLIDAÇÃO - PROPRIEDADES PARA INVESTIMENTO','Registra a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, das propriedades mantidas para investimento.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.0.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.02.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Registra os valores de ajuste ao valor recuperável de propriedades para investimento, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.03.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS','Registra os valores de ajuste ao valor recuperável de investimentos do RPPS, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.2.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTRA OFSS','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.2.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.2.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.3.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - UNIÃO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.3.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil. Conta de uso exclusivo para as empresas estatais.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.3.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil. Conta de uso exclusivo para as empresas estatais.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.4.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - ESTADO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.4.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.4.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.5.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - MUNICÍPIO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.5.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.5.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.0.0.00.00.00.00.00','IMOBILIZADO','Compreende os direitos que tenham por objeto bens corpóreos destinados a manutenção das atividades da entidade ou exercidos com essa finalidade, inclusive os decorrentes de operações que transfiram a ela os benefícios, os riscos e o controle desses bens.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.0.00.00.00.00.00','BENS MOVEIS','Compreende o valor da aquisição ou incorporação de bens corpóreos, que tem existência material e que podem ser transportados por movimento próprio ou removidos por forca alheia sem alteração da substancia ou da destinação economico-social, que constituam meio para a produção de outros bens ou serviços.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.00.00.00.00.00','BENS MOVEIS- CONSOLIDAÇÃO','Compreende o valor da aquisição ou incorporação de bens corpóreos, que tem existência material e que podem ser transportados por movimento próprio ou removidos por forca alheia sem alteração da substancia ou da destinação economico-social, que constituam meio para a produção de outros bens ou serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.00.00.00.00','MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MAQUINAS, FERRAMENTAS, APARELHOS, EQUIPAMENTOS,  ACESSORIOS, ETC.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.01.00.00.00','APARELHOS DE MEDICAO E ORIENTACAO','REGISTRA OS APARELHOS UTILIZADOS PARA MEDICAO E ORIENTACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.02.00.00.00','APARELHOS E EQUIPAMENTOS DE COMUNICACAO','REGISTRA OS APARELHOS E EQUIPAMENTOS UTILIZADOS PARA COMUNICACAO','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.03.00.00.00','APARELHOS, EQUIPAMENTOS E UTENSILIOS MEDICOS, ODONTOLOGICOS, LABORATORIAIS E HOSPITALARES','REGISTRA OS APARELHOS, EQUIPAMENTOS E UTENSILIOS PARA USO MEDICO, ODONTOLOGICO, LABORATORIAL E HOSPITALAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.04.00.00.00','APARELHOS E EQUIPAMENTOS PARA ESPORTES E DIVERSOES','REGISTRA OS APARELHOS E EQUIPAMENTOS UTILIZADOS PARA MODALIDADES DE ESPORTES E DIVERSOES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.05.00.00.00','EQUIPAMENTO DE PROTECAO, SEGURANCA E SOCORRO','REGISTRA OS EQUIPAMENTOS UTILIZACOES PARA PROTECAO, SEGURANCA E SOCORRO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.06.00.00.00','MAQUINAS E EQUIPAMENTOS INDUSTRIAIS','REGISTRA AS MAQUINAS E EQUIPAMENTOS DE NATUREZA INDUSTRIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.07.00.00.00','MAQUINAS E EQUIPAMENTOS ENERGETICOS','REGISTRA AS MAQUINAS E EQUIPAMENTOS ENERGETICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.08.00.00.00','MAQUINAS E EQUIPAMENTOS GRAFICOS','REGISTRA AS MAQUINAS E EQUIPAMENTOS EMPREGADOS NA INDUSTRIA GRAFICA OU NECESSARIOS PARA SUA INDUSTRIALIZACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.09.00.00.00','MAQUINAS, FERRAMENTAS E UTENSILIOS DE OFICINA','REGISTRA AS MAQUINAS, FERRAMENTAS E UTENSILIOS UTILIZADOS EM OFICINAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.12.00.00.00','EQUIPAMENTOS, PECAS E ACESSORIOS PARA AUTOMOVEIS','REGISTRA OS EQUIPAMENTOS, PECAS E ACESSORIOS PARA AUTOMOVEIS QUE PODEM SER DESINCORPORADOS, SEM PREJUIZO DOS MESMOS, PARA APLICACAO EM OUTRO VEICULO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.13.00.00.00','EQUIPAMENTOS, PECAS E ACESSORIOS MARITIMOS','REGISTRA OS EQUIPAMENTOS, PECAS E ACESSORIOS MARITIMOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.16.00.00.00','EQUIPAMENTOS DE MERGULHO E SALVAMENTO','REGISTRA OS EQUIPAMENTOS DE MERGULHO E SALVAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.20.00.00.00','MAQUINAS, EQUIPAMENTOS E UTENSILIOS AGROPECUARIOS E REDOVIARIOS','REGISTRA OS VALORES RELATIVOS A MAQUINAS, EQUIPAMENTOS, FERRAMENTAS E UTENSILIOS AGROPECUARIOS E REDOVIARIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.21.00.00.00','EQUIPAMENTOS HIDRAULICOS E ELETRICOS','REGISTRA OS EQUIPAMENTOS HIDRAULICOS E ELETRICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.22.00.00.00','EQUIPAMENTOS E MATERIAIS PERMANENTES VINCULADOS A CONVÊNIO','REGISTRA OS EQUIPAMENTOS E MATERIAIS PERMANENTES VINCULADOS A CONVÊNIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.30.00.00.00','MATERIAL DE USO DURADOURO','REGISTRA OS VALORES RELATIVOS AOS MATERIAIS DE CONSUMO QUE DEVIDO    ASUA DURABILIDADE E NATUREZA DEVEM COMPOR O ATIVO DA ENTIDADE.O CONTROLE PATRIMONIAL DOS BENS REGISTRADOS NESTA CONTA DEVERA     SER         SIMPLIFICADO, POR MEIO DE RELACAO DO MATERIAL (RELACAO-CARGA) E/OU VE-RIFICACAO PERIODICA DA QUANTIDADE DE ITENS REQUISITADOS,  DEVIDO     ASUA DURABILIDADE E CARACTERISTICAS PROPRIAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.40.00.00.00','PECAS NAO INCORPORAVEIS A IMOVEIS','REGISTRA OS VALORES RELATIVOS A AQUISICAO DE PECAS NAO INCORPORAVEIS A IMOVEIS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.99.00.00.00','OUTRAS MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','REGISTRA OS VALORES REFERENTES A MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS NAO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.02.00.00.00.00','BENS DE INFORMATICA','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E SISTEMAS APLICATIVOS, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.02.01.00.00.00','EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','REGISTRA OS EQUIPAMENTOS DE PROCESSAMENTO DE DADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.02.02.00.00.00','EQUIPAMENTOS DE TECNOLOGIA DA INFORMACAO','REGISTRA OS EQUIPAMENTOS RELACIONADOS COM TECNOLOGIA DA INFORMACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.03.00.00.00.00','MOVEIS E UTENSILIOS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MOBILIARIO EM GERAL E UTENSILIOS, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.03.01.00.00.00','APARELHOS E UTENSILIOS DOMESTICOS','REGISTRA OS OBJETOS OU PECAS DE USO CASEIRO OU NECESSARIOS A VIDA FAMILIAR.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.03.02.00.00.00','MAQUINAS E UTENSILIOS DE ESCRITORIO','REGISTRA AS MAQUINAS E UTENSILIOS DE ESCRITORIO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.03.03.00.00.00','MOBILIARIO EM GERAL','REGISTRA OS VALORES RELATIVOS AOS BENS MOVEIS, DE CARATER GERAL, EM USO NA UNIDADE, NAO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.03.04.00.00.00','UTENSILIOS EM GERAL','REGISTRA OS VALORES RELATIVOS A UTENSILIOS, DE CARATER GERAL, EM USO NA UNIDADE, NAO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.00.00.00.00','MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICACAO','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MATERIAIS BIBLIOGRAFICOS, DISCOTECAS, FILMOTECAS, DE COMUNICACAO, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.01.00.00.00','BANDEIRAS, FLAMULAS E INSIGNIAS','REGISTRA OS VALORES RELATIVOS A BANDEIRAS, FLAMULAS E INSIGNIAS, GERALMENTE UTILIZADAS COMO DISTINTIVO DA NACAO E DE CORPORACOES, PEQUENAS CHAMAS, ADORNOS, SINAL DISTINTIVO, EMBLEMAS, ESTANDARTES E OUTROS SIMBOLOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.02.00.00.00','COLECOES E MATERIAIS BIBLIOGRAFICOS','REGISTRA OS VALORES RELATIVOS AOS OBJETOS E MATERIAIS BIBLIOGRAFICOS DESTINADOS A REUNIR, GERALMENTE, PARA FORMACAO DE BIBLIOTECAS DE USO DA UNIDADE OU CUMPRIR OBJETIVOS DESSA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.03.00.00.00','DISCOTECAS E FILMOTECAS','REGISTRA OS VALORES RELATIVOS A DISCOS, CDS E COLECOES DE FITAS GRAVADAS COM MUSICAS E FITAS CINEMATOGRAFICAS DE CARATER EDUCATIVO, CIENTIFICO E INFORMATIVO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.04.00.00.00','INSTRUMENTOS MUSICAIS E ARTISTICOS','REGISTRA OS VALORES RELATIVOS AOS INSTRUMENTOS MUSICAIS E ARTISTICOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.05.00.00.00','EQUIPAMENTOS PARA AUDIO, VIDEO E FOTO','REGISTRA OS VALORES DE EQUIPAMENTOS DE AUDIO, VIDEO E FOTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.06.00.00.00','OBRAS DE ARTE E PECAS PARA EXPOSICAO','REGISTRA OS VALORES RELATIVOS A OBRAS E OBJETOS DE ARTE E DE PECAS PARA DECORACAO OU EXPOSICAO EM GERAL EM MUSEUS, GALERIAS, HALLS, PREDIOS PUBLICOS E OUTROS, DESDE QUE  SE DESTINEM A MANUTENCAO DE SUA ATIVIDADE, CASO CONTRARIO, DEVE SER CLASSIFICADO COMO INVESTIMENTOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.99.00.00.00','OUTROS MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICACAO','REGISTRA OS VALORES REFERENTES A MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICACAO NAO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.05.00.00.00.00','VEICULOS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MEIOS DE TRANSPORTES AEREOS, AQUATICOS E TERRESTRES, ENTRE OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.05.01.00.00.00','VEICULOS EM GERAL','REGISTRA OS VEICULOS DE DIVERSOS TIPOS, NAO MOTORIZADOS, PARA OS QUAIS NAO TENHAM SIDO CRIADAS CONTAS ESPECIFICAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.05.03.00.00.00','VEICULOS DE TRACAO MECANICA','REGISTRA OS VEICULOS DE TRACAO MECANICA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.06.00.00.00.00','PECAS E CONJUNTOS DE REPOSICAO','REGISTRA O VALOR DA AQUISICAO OU INCORPORACAO DE PECAS E CONJUNTOS DE REPOSICAO DESTINADOS A SUBSTITUICAO EM MAQUINAS E EQUIPAMENTOS, AERONAVES E EMBARCACOES, BENS DE SEGURANCA E SOCORRO, ENTRE OUTROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.07.00.00.00.00','BENS MOVEIS EM ANDAMENTO','COMPREENDE OS VALORES DE BENS MOVEIS EM ANDAMENTO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.07.01.00.00.00','BENS MOVEIS EM ELABORAÇÃO','REGISTRA OS VALORES RELATIVOS A TODOS OS GASTOS OCORRIDOS COM BENS MOVEIS EM FASE DE ELABORACAO E ACABAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.07.02.00.00.00','IMPORTAÇÕES EM ANDAMENTO','REGISTRA OS VALORES RELATIVOS A TODOS OS GASTOS COM IMPORTAÇÕES EM ANDAMENTO DE EQUIPAMENTOS, MAQUINAS, APARELHOS E OUTROS BENS MOVEIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.08.00.00.00.00','BENS MOVEIS EM ALMOXARIFADO','COMPREENDE OS VALORES DE BENS PERMANENTES A SEREM ESTOCADOS EM ALMOXARIFADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.08.01.00.00.00','ESTOQUE INTERNO','REGISTRA OS VALORES DOS BENS MOVEIS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADO, DESTINADOS A ATENDER AS NECESSIDADES DOS ORGAOS ADQUIRENTES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.08.03.00.00.00','BENS MÓVEIS A REPARAR','REGISTRA OS VALORES DOS BENS MOVEIS  A REPARAR ESTOCADOS EM ALMOXARIFADO','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.08.04.00.00.00','BENS MÓVEIS EM REPARO','REGISTRA OS VALORES DOS BENS MOVEIS  EM REPARO ESTOCADOS EM ALMOXARIFADO','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.08.05.00.00.00','BENS MOVEIS INSERVIVEIS','REGISTRA OS VALORES DOS BENS MOVEIS INSERVIVEIS EM ALMOXARIFADO, QUE DEPENDEM DE PARECER DA COMISSAO E HOMOLOGACAO DA AUTORIDADE COMPETENTE PARA SEREM DESCARREGADOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.10.00.00.00.00','SEMOVENTES','REGISTRA OS VALORES RELATIVOS AOS ANIMAIS DESTINADOS A PRODUCAO, REPRODUCAO, ENGORDA E AOS SERVIÇOS  UTILITARIOS EM GERAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.99.00.00.00.00','DEMAIS BENS MOVEIS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DOS DEMAIS BENS MOVEIS NAO CLASSIFICADOS EM GRUPOS ESPECIFICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.99.99.00.00.00','OUTROS BENS MÓVEIS','REGISTRA O VALOR DA AQUISICAO OU INCORPORACAO DOS OUTROS BENS MOVEIS NÃO CLASSIFICADOS ANTERIORMENTE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.0.00.00.00.00.00','BENS IMÓVEIS','Compreende o valor dos bens imóveis, os quais são bens vinculados ao solo e que não podem ser retirados sem destruição ou dano, destinados ao uso e que a entidade não esteja explorando comercialmente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.00.00.00.00.00','BENS IMOVEIS- CONSOLIDAÇÃO','Compreende o valor dos bens imóveis, os quais são bens vinculados ao solo e que não podem ser retirados sem destruição ou dano, destinados ao uso e que a entidade não esteja explorando comercialmente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.00.00.00.00','BENS DE USO ESPECIAL','COMPREENDE OS BENS, TAIS COMO EDIFICIOS OU TERRENOS DESTINADOS A SERVICO OU ESTABELECIMENTO DA ADMINISTRACAO DIRETA MUNICIPAL, INCLUSIVE OS DE SUAS AUTARQUIAS E FUNDACOES PUBLICAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.01.00.00.00','IMÓVEIS RESIDENCIAIS/COMERCIAIS','REGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE : APARTAMENTOS; CASAS; RESIDENCIAS; CONJUNTOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.02.00.00.00','EDIFICIOS','REGISTRA OS VALORES RELATIVOS AOS PREDIOS EDIFICADOS, DE PROPRIEDADE DA ENTIDADE, LOCALIZADOS EM AREAS URBANAS E RURAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.03.00.00.00','TERRENOS/GLEBAS','REGISTRA OS VALORES PERTINENTES AS PROPRIEDADES AGRICOLAS CONSTITUINDO GLEBAS E FAZENDAS, REGISTRADAS EM CARTORIO E OU TITULADAS, DE PROPRIEDADE DA UNIDADE, RESERVADAS OU NAO A EXPLORACAO AGROPECUARIA E REGISTRA OS VALORES RELATIVOS AOS TERRENOS  DE PROPRIEDADE DA ENTIDADE, LOCALIZADOS EM AREAS URBANAS E RURAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.04.00.00.00','ARMAZENS/GALPOES/SILOS','REGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: ARMAZENS; GALPOES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.07.00.00.00','IMOVEIS DE USO EDUCACIONAL','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO:  ESCOLAS; FACULDADES; UNIVERSIDADES;  BIBLIOTECAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.08.00.00.00','REPRESAS/ACUDES','REGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: AÇUDES;  REPRESAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.09.00.00.00','FAZENDAS, PARQUES E RESERVAS','RREGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: FAZENDAS; PARQUES; RESERVAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.10.00.00.00','IMOVEIS DE USO RECREATIVO','REGISTRA OS SEGUINTES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: CLUBES; ESTADIOS; GINÁSIOS; TEATROS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.16.00.00.00','HOSPITAIS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO HOSPITAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.19.00.00.00','PORTOS/ESTALEIROS','REGISTRA OS SEGUINES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: ESTALEIROS; PORTOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.20.00.00.00','COMPLEXOS/FABRICAS/USINAS','RREGISTRA OS SEGUINES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: FABRICAS; USINAS; COMPLEXOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.21.00.00.00','CEMITERIOS','RREGISTRA OS SEGUINES BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE: CEMITERIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.22.00.00.00','ESTACIONAMENTOS E GARAGENS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO ESTACIONAMENTOS. TAMBEM DEVEM SER  REGISTRADOS NESTA CONTA AS GARAGENS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.23.00.00.00','LOJAS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO LOJAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.24.00.00.00','SALAS E ESCRITORIOS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL TAIS COMO SALAS E ESCRITORIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.02.98.00.00.00','OUTROS BENS IMÓVEIS DE USO ESPECIAL','REGISTRA OUTROS OS BENS IMOVEIS DE USO ESPECIAL DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.00.00.00.00','BENS DOMINICAIS','COMPREENDE OS BENS  QUE CONSTITUEM O PATRIMÔNIO DAS PESSOAS JURIDICAS DE DIREITO PUBLICO, COMO OBJETO DE DIREITO PESSOAL, OU REAL. COMPREENDE AINDA, NÃO DISPONDO A LEI EM CONTRARIO, OS BENS PERTENCENTES AS PESSOAS JURIDICAS DE DIREITO PUBLICO A QUE SE TENHA DADO ESTRUTURA DE DIREITO PRIVADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.01.00.00.00','EDIFICIOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS : EDIFICIOS/PREDIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.02.00.00.00','APARTAMENTOS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS :   APARTAMENTOS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.03.00.00.00','ARMAZENS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: ARMAZENS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.04.00.00.00','CASAS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: CASAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.05.00.00.00','CEMITERIOS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: CEMITERIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.07.00.00.00','GARAGENS E ESTACIONAMENTOS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: GARAGENS E ESTACIONAMENTOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.08.00.00.00','FAZENDAS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: FAZENDAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.09.00.00.00','GALPOES','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: GALPÕES.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.10.00.00.00','GLEBAS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: GLEBAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.11.00.00.00','LOJAS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: LOJAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.12.00.00.00','SALAS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: SALAS E ESCRITÓRIOS..','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.13.00.00.00','TERRENOS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: TERRENOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.14.00.00.00','LOTES','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: LOTES .','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.16.00.00.00','GLEBAS URBANAS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS: GLEBAS URBANAS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.18.00.00.00','GLEBAS RURAIS','REGISTRA OS VALORES  PATRIMONIAIS RELATIVOS DOS SEGUINTES  BENS IMOVEIS DOMINIAIS:  GLEBAS RURAIS','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.99.00.00.00','OUTROS BENS DOMINICAIS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS A OUTROS BENS IMOVEIS DOMINIAIS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.00.00.00.00','BENS DE USO COMUM DO POVO','COMPREENDE OS BENS DE USO COMUM DO POVO CONSTRUIDOS OU ADQUIRIDOS POR PESSOAS JURIDICAS DE DIREITO PUBLICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.01.00.00.00','RUAS','REGISTRA OS VALORES DE RUAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.02.00.00.00','PRACAS','REGISTRA OS VALORES DE PRACAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.03.00.00.00','ESTRADAS','REGISTRA OS VALORES DE ESTRADAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.04.00.00.00','PONTES','REGISTRA OS VALORES DE PONTES QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.05.00.00.00','VIADUTOS','REGISTRA OS VALORES DE VIADUTOS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.99.00.00.00','OUTROS BENS DE USO COMUM DO POVO','REGISTRA OS VALORES BENS DE USO COMUM, NÃO CLASSIFICADOS ANTERIORMENTE NESTE PLANO DE CONTAS, QUE FORAM ADQUIRIDOS, PRODUZIDOS OU CONSTRUIDOS UTILIZANDO-SE RECURSOS PÚBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA ENTIDADE.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.06.00.00.00.00','BENS IMOVEIS EM ANDAMENTO','COMPREENDE OS VALORES DE BENS IMOVEIS EM ANDAMENTO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.06.01.00.00.00','OBRAS EM ANDAMENTO','REGISTRA OS VALORES PERTINENTES A OBRAS, DESDE SUA CONSTRUCAO ATE O TERMINO DA MESMA.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.06.05.00.00.00','ESTUDOS E PROJETOS','REGISTRA OS VALORES RELATIVOS A ESTUDOS E PROJETOS, ENGLOBANDO LIMPEZA DO TERRENO, SERVIÇOS TOPOGRÁFICOS, SONDAGENS DE RECONHECIMENTO, TERRAPLENAGEM, DRENAGENS, INSTALAÇÕES PROVISORIAS COMO GALPOES, INSTALAÇÕES ELETRICAS E HIDRAULICAS, UTILIZADAS DURANTE AS OBRAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.06.06.00.00.00','ALMOXARIFADO DE INVERSOES FIXAS','REGISTRA TODOS OS MATERIAIS E BENS DA EMPRESA DESTINADOS A APLICACAO NA CONSTRUCAO DE BENS IMOVEIS EM ANDAMENTO. COMO, POR EXEMPLO, ALMOXARIFADO DE MATÉRIAS DE CONSTRUCAO PARA APLICAR EM UMA OBRA EM ANDAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.07.00.00.00.00','INSTALACOES','REGISTRA EQUIPAMENTOS, MATERIAIS E CUSTO DE IMPLANTACAO DE INSTALACOES QUE, NAO OBSTANTE INTEGRADAS AOS EDIFICIOS, DEVEM SER SEGREGADAS DAS OBRAS CIVIS, COMO, POR EXEMPLO, AS INSTALCOES ELETRICAS, HIDRAULICAS, SANITARIAS, DE VAPOR, DE AR COMPRIMIDO, FRIGORIFICAS, CONTRA INCENDIO, DE COMUNICACOES, DE CLIMATIZACAO, PARA COMBUSTIVEIS, GASES, DE ANTIPOLUICAO, PARA COZINHA, DENTRE OUTROS.  E TAMBEM APLICAVEL A CONSTRUCAO DE TRECHOS FERROVIARIOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.08.00.00.00.00','BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','REGISTRA CONSTRUCOES EM TERRENOS ARRENDADOS DE TERCERIOS E INSTALACOES E OUTRAS BENFEITORIAS EM PREDIOS ALUGADOS. SAO CONSIDERADOS SOMENTE OS GASTOS COM CONSTRUCAO E INSTALACAO QUE SE INCORPORAM AO IMOVEL E REVERTEM AO PROPRIETARIO DO IMOVEL AO FINAL DA LOCACAO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.99.00.00.00.00','DEMAIS BENS IMOVEIS','COMPREENDE OS DEMAIS BENS IMOVEIS NAO CLASSIFICADOS ANTERIORMENTE NESSE PLANO DE CONTAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.99.99.00.00.00','OUTROS BENS IMOVEIS','REGISTRA OS VALORES RELATIVOS A OUTROS BENS IMOVEIS, PARA OS QUAIS NAO TENHAM SIDO CRIADAS CONTAS PROPRIAS OU ESPECIFICAS NESTE PLANO DE CONTAS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.0.00.00.00.00.00','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS','Compreende a diminuição do valor dos elementos do ativo imobilizado devido a desgaste pelo uso, ação da natureza ou obsolescência, bem como a perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração e a perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.00.00.00.00.00','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS - CONSOLIDAÇÃO','Compreende a diminuição do valor dos elementos do ativo imobilizado devido a desgaste pelo uso, ação da natureza ou obsolescência, bem como a perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração e a perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.01.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA - BENS MÓVEIS','Compreende a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido a desgaste pelo uso, ação da natureza ou obsolescência.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.02.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA - BENS IMÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens imóveis, devido a desgaste pelo uso, ação da natureza ou obsolescência.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.03.00.00.00.00','(-) EXAUSTÃO ACUMULADA - BENS MÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido à perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.04.00.00.00.00','(-) EXAUSTÃO ACUMULADA - BENS IMÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens imóveis, devido à perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.05.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA - BENS MÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido à perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.06.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA - BENS IMÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens Imóveis, devido à perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.9.0.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO','Compreende os valores de ajuste ao valor recuperável do imobilizado, quando esse for inferior ao valor liquido contábil.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.9.1.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável do imobilizado, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.9.1.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - BENS MOVEIS','Registra os valores de ajuste ao valor recuperável de bens moveis, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.9.1.02.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - BENS IMÓVEIS','Registra os valores de ajuste ao valor recuperável de bens imóveis, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.0.0.00.00.00.00.00','INTANGÍVEL','Compreende os direitos que tenham por objeto bens incorpóreos destinados a manutenção da entidade ou exercidos com essa finalidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.1.0.00.00.00.00.00','SOFTWARES','Compreende os valores dos softwares pertencentes à entidade e não integrantes a um hardware, englobando os valores referentes à sua construção, implementação e instalação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.1.1.00.00.00.00.00','SOFTWARES- CONSOLIDAÇÃO','Registra os valores dos softwares pertencentes à entidade e não integrantes a um hardware, englobando os valores referentes à sua construção, implementação e instalação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.2.0.00.00.00.00.00','MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS','Compreende os valores pertinentes a bens intangíveis, englobando os gastos com registro de marca, nome, invenções próprias, direitos de uso de comunicação e direitos autorais, alem de desembolsos a terceiros por contratos de uso de marcas, patentes ou processos de fabricação (tecnologia).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.2.1.00.00.00.00.00','MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS- CONSOLIDAÇÃO','Compreende os valores pertinentes a bens intangíveis, englobando os gastos com registro de marca, nome, invenções próprias, direitos de uso de comunicação, direitos autorais e direitos sobre recursos naturais, alem de desembolsos a terceiros por contratos de uso de marcas, patentes ou processos de fabricação (tecnologia). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.3.0.00.00.00.00.00','DIREITO DE USO DE IMÓVEIS','Compreende os valores pertinentes a bens intangíveis representados pela aquisição do direito de uso de imóveis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.3.1.00.00.00.00.00','DIREITO DE USO DE IMOVEIS- CONSOLIDAÇÃO','Registra os valores pertinentes a bens intangíveis representados pela aquisição de direito de uso de imóveis. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.0.00.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA','Compreende a diminuição do valor do capital aplicado na aquisição de direitos da propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.1.00.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA- CONSOLIDAÇÃO','Compreende a diminuição do valor do capital aplicado na aquisição de direitos da propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.1.01.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA - SOFTWARES','Registra a diminuição do valor do capital aplicado em softwares, pertencentes ao ativo intangível.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.1.02.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA - MARCAS, DIREITOS E PATÉNTES','Registra a diminuição do valor do capital aplicado em marcas, direitos e patentes, pertencentes ao ativo intangível.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.1.03.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA - DIREITO DE USO DE IMÓVEIS','Registra a diminuição do valor do capital aplicado em direito de uso de imóveis, pertencentes ao ativo intangível.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.0.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL','Compreende os valores de ajuste ao valor recuperável do ativo intangível, quando esse for inferior ao valor liquido contábil. Conta de uso exclusivo para as empresas estatais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.1.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável do ativo intangível, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.1.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - SOFTWARES','Registra os valores de ajuste ao valor recuperável do software pertencente ao ativo intangível, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.1.02.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - MARCAS, DIREITOS E PATÉNTES','Registra os valores de ajuste ao valor recuperável das marcas, direitos e patentes, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.1.03.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL-DIREITO DE USO','Registra os valores de ajuste ao valor recuperável de direito de uso, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.0.0.0.0.00.00.00.00.00','PASSIVO E PATRIMÔNIO LIQUIDO','Passivo compreende as obrigações existentes da entidade oriundas de eventos passados de cuja liquidação se espera que resulte em fluxo de saída de recursos que incorporem benefícios econômicos ou serviços em potencial. Patrimônio liquido compreende a diferença entre o ativo e o passivo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.0.0.0.00.00.00.00.00','PASSIVO CIRCULANTE','Compreende as obrigações conhecidas e estimadas que atendam a qualquer um dos seguintes critérios: tenham prazos estabelecidos ou esperados dentro do ciclo operacional da entidade; sejam mantidos primariamente para negociação; tenham prazos estabelecidos ou esperados no curto prazo; sejam valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, independentemente do prazo de exigibilidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.0.0.00.00.00.00.00','OBRIGAÇÕES TRABALHISTAS, PREVIDENCIÁRIAS E ASSISTENCIAIS A PAGAR A CURTO PRAZO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, aposentadorias, reformas, pensões e encargos a pagar,  benefícios assistenciais, inclusive os precatórios decorrentes dessas obrigações , com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.0.00.00.00.00.00','PESSOAL A PAGAR','Compreende as obrigações a curto prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.00.00.00.00.00','PESSOAL A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.00.00.00.00','PESSOAL A PAGAR DO EXERCICIO','COMPREENDE AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS AO EXERCICIO ATUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.01.00.00.00','SALARIOS, REMUNERACOES E BENEFICIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS AO EXERCICIO ATUAL.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.02.00.00.00','PROVISAO PARA 13. SALARIO','REGISTRA AS OBRIGACOES REFERENTES AO DECIMO TERCEIRO SALARIO, GERALMENTE APROPRIADAS NA BASE DE 1/12 DO VALOR BRUTO DA FOLHA DE PAGAMENTO DA UNIDADE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.03.00.00.00','PROVISAO PARA FERIAS','REGISTRA AS OBRIGACOES REFERENTES A FERIAS, GERALMENTE APROPRIADAS COMO PERCENTUAIS DA FOLHA DE PAGAMENTO DA UNIDADE.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.04.00.00.00','PROVISAO PARA LICENÇA-PRÊMIO','REGISTRA OS VALORES DAS OBRIGACOES CONSTITUIDAS COM BASE EM PERCENTUAIS  DE SALARIOS, DESTINADOS AO PAGAMENTO DE LICENCA-PREMIO EM PECUNIA PREVISTA EM LEI MUNICIPAL..','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.06.00.00.00','ENCARGOS SOCIAIS SOBRE PROVISOES','COMPREENDE OS VALORES DOS ENCARGOS SOCIAIS SOBRE PROVISOES PARA 13° .SALARIO, FERIAS, LICENCA-PREMIO E OUTRAS CONSTITUIDAS NA FORMA DA LEI SOBRE A FOLHA DE PAGAMENTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.06.01.00.00','INSS','REGISTRA OS VALORES PROVISIONADOS RELATIVOS A CONTRIBUICAO PARA O INSS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.06.02.00.00','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS PROVISIONADOS RELATIVOS  AO FGTS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.06.03.00.00','RPPS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS PROVISIONADOS RELATIVOS  AO RPPS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.07.00.00.00','AGENTES POLÍTICOS','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DA REMUNERAÇÃO  DEVIDA AOS AGENTES POLÍTICOS, RELATIVAS AO EXERCÍCIO ATUAL.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.02.00.00.00.00','PESSOAL A PAGAR DE EXERCICIOS ANTERIORES','COMPREENDE AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS A EXERCICIOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.02.01.00.00.00','SALÁRIOS, REMUNERAÇÕES E BENEFÍCIOS DE EXERCÍCIOS ANTERIORES','REGISTRA AS OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS A EXERCICIOS ANTERIORES.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.00.00.00.00','PRECATORIOS DE PESSOAL','COMPREENDE OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.01.00.00.00','PRECATORIOS DE PESSOAL DO EXERCICIO','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.02.00.00.00','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES -  ANTES DE 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, ANTERIORES A 05/05/2000 (LRF).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.02.01.00.00','PESSOAL - ANTERIORES A 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, ATE     05/05/2000.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.02.02.00.00','PRECATORIOS DE PESSOAL - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, ATE 05/05/2000 DO PODER EXCUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.02.03.00.00','PRECATORIOS DE PESSOAL - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, ATE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.02.04.00.00','PRECATORIOS DE PESSOAL - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, ATE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.03.00.00.00','PRECATÓRIOS DE PESSOAL DE EXERCÍCIOS ANTERIORES - A PARTIR DE 05/5/2000','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LRF).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.03.01.00.00','PESSOAL - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, A PARTIR DE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.03.02.00.00','PESSOAL - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS  DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, A PARTIR DE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.03.03.00.00','PESSOAL - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS  DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, A PARTIR DE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.0.00.00.00.00.00','BENEFICIOS PREVIDENCIARIOS A PAGAR','Compreende as obrigações a curto prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.01.00.00.00.00','BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS NO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.02.00.00.00.00','BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS EM EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.03.00.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.03.01.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.03.02.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.03.03.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.2.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - INTRA','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.3.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - INTER UNIÃO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.4.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - INTER ESTADO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Estado.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.5.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - INTER MUNICIPIO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Município.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.3.0.00.00.00.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR','Compreende as obrigações a curto prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.3.1.00.00.00.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.3.1.01.00.00.00.00','BENEFICIOS ASSISTENCIAIS A PAGAR DO EXERCICIO','REGISTRA AS OBRIGACOES RELATIVAS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL LIQUIDADOS NO EXERCICIO E AINDA NAO PAGOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.3.1.02.00.00.00.00','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, DE EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.0.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR','Compreende as obrigações a curto prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.01.00.00.00.00','INSS A PAGAR','COMPREENDE OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL,  INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS E SOBRE SERVIÇOS DE TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.01.01.00.00.00','INSS - CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL,  INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.01.02.00.00.00','INSS - DÉBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.01.03.00.00.00','INSS - CONTRIBUIÇÃO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES INCIDENTES SOBRE SERVIÇOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.01.04.00.00.00','INSS - FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','REGISTRA OS VALORES RELATIVOS AS FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL .','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.03.00.00.00.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES COM  O  PLANO DE SEGURIDADE DO SERVIDOR .','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.04.00.00.00.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA','COMPREENDE OS VALORES RELATIVOS AS OBRIGAÇÕES COM REGIMES PRÓPRIOS DE   PREVIDENCIA, NÃO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.04.01.00.00.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA DO ENTE','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES COM REGIMES PRÓPRIOS DE   PREVIDENCIA DE PESSOAL DO ENTE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.04.02.00.00.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA - PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES COM REGIMES PRÓPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.06.00.00.00.00','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.08.00.00.00.00','ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR','COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.08.01.00.00.00','CONTRIBUICAO A ENTIDADES DE PREVIDENCIA PRIVADA E ASSISTENCIA MEDICO-ODONTOLOGICA','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS  A   RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA E DE ASSISTENCIA MEDICO - ODONTOLOGICA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.08.02.00.00.00','CONTRIBUICAO PREVIDENCIA PRIVADA E ASSISTENCIA MEDICO-ODONTOLOGICA - DE EXERCICIOS ANTERIORES','DESTINADA AOS REGISTROS DOS VALORES DOS ENCARGOS SOCIAIS  A   RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA  PRIVADA E DE ASSISTENCIA MEDICO-ODONTOLOGICA DE EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS - CONSOLIDAÇÃO','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.04.00.00.00.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE   PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.04.01.00.00.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS) DO EXERCÍCIO','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE REFERENTES AO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.04.02.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS - DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS LIQUIDADAS E  NÃO PAGAS DENTRO DO EXERCICIO, FICANDO PORTANTO EM RESTOS A PAGAR','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.08.00.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.08.01.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.08.02.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.00.00.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS','COMPREENDE OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.01.00.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS - DO EXERCICIO','COMPREENDE OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO EM CURSO, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.01.01.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT - DO EXERCICIO - APOSENTADORIAS EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO EM CURSO, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS  APOSENTADORIAS DO  EXECUTIVO / INDIRETAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.01.02.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT - DO EXERCICIO - APOSENTADORIAS LEGISLATIVO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO EM CURSO, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS  APOSENTADORIAS DO  LEGISLATIVO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.01.03.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT - DO EXERCICIO - PENSOES','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO EM CURSO, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS  PENSOES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.02.00.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS - DO EXERCICIO ANTERIOR','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.02.01.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT - DO EXERCICIO ANTERIOR - APOSENTADORIAS -  EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS  APOSENTADORIAS DO  EXECUTIVO / INDIRETAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.02.02.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT - DO EXERCICIO ANTERIOR - APOSENTADORIAS - LEGISLATIVO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS  APOSENTADORIAS DO  LEGISLATIVO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.02.03.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT - DO EXERCICIO ANTERIOR - PENSOES','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADO DENTRO DO MÊS DE COMPETENCIA REFERENTE A COBERTURA DAS  PENSOES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.00.00.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DA FONTE TESOURO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DE  RESPONSABILIDADE DA FONTE TESOURO NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.01.00.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DA FONTE TESOURO - DO EXERCICIO','COMPREENDE OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.01.01.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DA FONTE TESOURO - DO EXERCICIO - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DO EXECUTIVO / INDIRETAS DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.01.02.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DA FONTE TESOURO - DO EXERCICIO - LEGISLATIVO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DO LEGISLATIVO DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.01.03.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSOES DA FONTE TESOURO - DO EXERCICIO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSOES DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.02.00.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DA FONTE TESOURO - DO EXERCICIO ANTERIOR','COMPREENDE OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.02.01.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DA FONTE TESOURO - DO EXERCICIO ANTERIOR - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DO EXECUTIVO / INDIRETAS DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.02.02.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DA FONTE TESOURO - DO EXERCICIO ANTERIOR - LEGISLATIVO','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS DO LEGISLATIVO DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.02.03.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSOES DA FONTE TESOURO - DO EXERCICIO ANTERIOR','REGISTRA OS VALORES RELATIVOS A OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSOES DE RESPONSABILIDADE DA FONTE TESOURO REFERENTES AO EXERCICIO ANTERIOR, NÃO REPASSADAS DENTRO DO MÊS DE COMPETENCIA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.23.00.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR','COMPREENDE OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE PARA O   PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR LIQUIDADAS E  AINDA NÃO PAGAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.23.01.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR - DO EXERCICIO','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE PARA O   PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR LIQUIDADAS E  AINDA NÃO PAGAS DURANTE O EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.23.02.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR - DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE PARA O   PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR LIQUIDADAS E  AINDA NÃO PAGAS REFERENTES AO EXERCICIO ANTERIOR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS - INTRA','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.00.00.00.00','INSS A PAGAR','COMPREENDE OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL,  INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.01.00.00.00','INSS - DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE  SALARIOS PAGOS OU CREDITADOS  DEVIDOS POR ENCARGOS DO EMPREGADOR (UNIDADE) A PREVIDENCIA SOCIAL. REFERENTES AO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.02.00.00.00','INSS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE  SALARIOS PAGOS OU CREDITADOS, OU SERVICOS DE TERCEIROS  DEVIDOS POR ENCARGOS DO EMPREGADOR (UNIDADE) A PREVIDENCIA SOCIAL. REFERENTES A  RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS E DEVERAO SER DESDOBRADAS POR EXERCICIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.03.00.00.00','INSS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE  SALARIOS PAGOS OU CREDITADOS, OU SERVICOS DE TERCEIROS  DEVIDOS POR ENCARGOS DO EMPREGADOR (UNIDADE) A PREVIDENCIA SOCIAL. REFERENTES A  RESTOS A PAGAR PROCESSADOS - LEGISLATIVO E DEVERAO SER DESDOBRADAS POR EXERCICIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.04.00.00.00','INSS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE  SALARIOS PAGOS OU CREDITADOS, OU SERVICOS DE TERCEIROS  DEVIDOS POR ENCARGOS DO EMPREGADOR (UNIDADE) A PREVIDENCIA SOCIAL. REFERENTES A  RESTOS A PAGAR PROCESSADOS - RPPS E DEVERAO SER DESDOBRADAS POR EXERCICIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.05.00.00.00','INSS - CONTRIBUICAO SOBRE SERVICOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','COMPREENDE OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE SERVICOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.05.01.00.00','INSS - CONTRIBUICAO SOBRE SERVICOS DE TERCEIROS OU CONTRIBUINTES AVULSOS - DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDIDAS SOBRES SERVICOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.05.02.00.00','INSS - CONTRIBUICAO SOBRE SERVICOS DE TERCEIROS OU CONTRIBUINTES AVULSOS - DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDIDAS SOBRES SERVICOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS DE  EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.06.00.00.00.00','FGTS','COMPREENDE OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.06.01.00.00.00','FGTS - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS GERADOS POR PAGAMENTOS DE SALARIOS A RECOLHER AO FGTS REFERENTES AO EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.06.02.00.00.00','FGTS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS GERADOS POR PAGAMENTOS DE SALARIOS A RECOLHER AO FGTS REFERENTES A RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.06.03.00.00.00','FGTS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS GERADOS POR PAGAMENTOS DE SALARIOS A RECOLHER AO FGTS REFERENTES A RESTOS A PAGAR PROCESSADOS - LEGISLATIVO E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.06.04.00.00.00','FGTS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS GERADOS POR PAGAMENTOS DE SALARIOS A RECOLHER AO FGTS REFERENTES A RESTOS A PAGAR PROCESSADOS - RPPS E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.08.00.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA','COMPREENDE OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.08.01.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.08.02.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.20.00.00.00.00','PIS/PASEP','COMPREENDE OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALARIOS A RECOLHER AO FUNDO DE PARTICIPACAO DESTINADO A EXECUCAO    DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALARIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.20.01.00.00.00','PIS/PASEP - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALARIOS A RECOLHER AO FUNDO DE PARTICIPACAO DESTINADO A EXECUCAO    DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALARIOS RELATIVOS AO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.20.02.00.00.00','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALARIOS A RECOLHER AO FUNDO DE PARTICIPACAO DESTINADO A EXECUCAO    DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALARIOS RELATIVOS A RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS E','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.20.03.00.00.00','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALARIOS A RECOLHER AO FUNDO DE PARTICIPACAO DESTINADO A EXECUCAO    DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALARIOS RELATIVOS A RESTOS A PAGAR PROCESSADOS - LEGISLATIVO E DEVERAO SE','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.20.04.00.00.00','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS,GERADOS PELO PAGAMENTO DE SALARIOS A RECOLHER AO FUNDO DE PARTICIPACAO DESTINADO A EXECUCAO    DO PIS E DO PASEP, GERADOS PELO PAGAMENTO DE SALARIOS RELATIVOS A RESTOS A PAGAR PROCESSADOS - RRPS E DEVERAO SER DESDO','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS - INTER - UNIÃO','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.01.00.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS DO ESTADO - DO EXERCICIO','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS DO ESTADO  LIQUIDADAS E AINDA NÃO PAGAS DURANTE O EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.02.00.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS DO ESTADO - DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS DO ESTADO  LIQUIDADAS E NÃO PAGAS DENTRO DO EXERCICIO, FICANDO PORTANTO EM RESTOS A PAGAR','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.03.00.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA','COMPREENDE OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.03.01.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.03.02.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS - INTER ESTADO','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.01.00.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS DE OUTROS MUNICIPIOS - DO EXERCICIO','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS DE OUTROS MUNICIPIOS LIQUIDADAS E AINDA NÃO PAGAS DURANTE O EXERCÍCIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.02.00.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - RPPS DE OUTROS MUNICIPIOS - DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DAS OBRIGAÇÕES PATRONAIS DEVIDAS PELO ENTE AO RPPS DE OUTROS MUNICIPIOS LIQUIDADAS E  NÃO PAGAS DENTRO DO EXERCICIO, FICANDO PORTANTO EM RESTOS A PAGAR','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.03.00.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA','COMPREENDE OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.03.01.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.03.02.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA - DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO .PATRONAL A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA. DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS - INTER - MUNICIPIOS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.0.0.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO','Compreende as obrigações financeiras externas e internas da entidade a titulo de empréstimos, bem como as aquisições efetuadas diretamente com o fornecedor, com vencimentos no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.0.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.01.00.00.00.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS INTERNOS','REGISTRA AS PARCELAS DOS EMPRESTIMOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.02.00.00.00.00','EMPRESTIMOS INTERNOS - EM TITULOS','REGISTRA O RECONHECIMENTO DOS EMPRÉSTIMOS DECORRENTES DE TÍTULOS MOBILIÁRIOS ASSUMIDOS DENTRO DO PAÍS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO ATÉ O TERMINO DO EXERCÍCIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.03.00.00.00.00','EMPRESTIMOS INTERNOS -  EM CONTRATOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.03.03.00.00.00','CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.03.05.00.00.00','CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.03.07.00.00.00','ANTECIPACAO DE RECEITA ORCAMENTARIA','REGISTRA OS VALORES REFERENTES A OPERACOES DE CREDITO POR ANTECIPACAO DE RECEITA DESTINADA A ATENDER INSUFICIENCIA DE CAIXA DURANTE O EXERCICIO FINANCEIRO, DEVENDO CUMPRIR AS EXIGENCIAS MENCIONADAS NO ART. 32 DA LEI COMPLEMENTAR Nº 101, PUBLICADA EM 04/05/2000 E AQUELAS PREVISTAS NO ART. 38 DA REFERIDA LEI.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.03.10.00.00.00','OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES - DO EXERCICIO','REGISTRA O VALOR DAS OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.03.98.00.00.00','OUTROS CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS, PARA AS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - INTER OFSS - UNIÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.01.00.00.00.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS INTERNOS','REGISTRA AS PARCELAS DOS EMPRESTIMOS ASSUMIDOS CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.02.00.00.00.00','EMPRESTIMOS INTERNOS - EM TITULOS','REGISTRA O RECONHECIMENTO DOS EMPRÉSTIMOS DECORRENTES DE TÍTULOS MOBILIÁRIOS COM VENCIMENTO ATÉ O TERMINO DO EXERCÍCIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.03.00.00.00.00','EMPRESTIMOS INTERNOS -  EM CONTRATOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.03.01.00.00.00','CONTRATOS DE EMPRESTIMOS DO EXERCICIO','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.03.02.00.00.00','CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.03.03.00.00.00','OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES - DO EXERCICIO','REGISTRA O VALOR DAS OPERACOES DE CREDITO COM PRAZO INFERIOR A DOZE MESES','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.03.98.00.00.00','DEMAIS EMPRESTIMOS INTERNOS -  EM CONTRATOS','REGISTRA OS DEMAIS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS NÃO COMPREENDIDOS NAS CONTAS ACIMA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.4.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - INTER OFSS - ESTADO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.5.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.0.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO- EXTERNO CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.01.00.00.00.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS EXTERNOS','REGISTRA AS PARCELAS DOS EMPRESTIMOS EXTERNOS ASSUMIDOS, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.03.00.00.00.00','EMPRESTIMOS EXTERNOS -  EM CONTRATOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITO EXTERNAS EM CONTRATOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.03.01.00.00.00','CONTRATOS DE EMPRESTIMOS DO EXERCICIO','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.03.02.00.00.00','CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.03.10.00.00.00','OPERACOES DE CREDITO EXTERNAS COM PRAZO INFERIOR A DOZE MESES - DO EXERCICIO','REGISTRA O VALOR DAS OPERACOES DE CREDITO EXTERNAS COM PRAZO INFERIOR A DOZE MESES','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.03.98.00.00.00','DEMAIS EMPRESTIMOS EXTERNOS -  EM CONTRATOS','REGISTRA OS DEMAIS VALORES DAS OPERACOES DE CREDITO EXTERNOS EM CONTRATOS NÃO COMPREENDIDOS NAS CONTAS ACIMA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.0.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO - INTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO- INTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.01.00.00.00.00','PARCELA A CURTO PRAZO DOS FINANCIAMENTOS INTERNOS','REGISTRA AS PARCELAS DOS FINANCIAMENTOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.02.00.00.00.00','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.02.01.00.00.00','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.02.02.00.00.00','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.02.98.00.00.00','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES  DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.03.00.00.00.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO- INTERNO -INTER OFSS - UNIÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.01.00.00.00.00','PARCELA A CURTO PRAZO DOS FINANCIAMENTOS INTERNOS','REGISTRA AS PARCELAS DOS FINANCIAMENTOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.02.00.00.00.00','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.02.01.00.00.00','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.02.02.00.00.00','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.02.98.00.00.00','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES  DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.03.00.00.00.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO - INTERNO - INTER OFSS - ESTADO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.01.00.00.00.00','PARCELA A CURTO PRAZO DOS FINANCIAMENTOS INTERNOS','REGISTRA AS PARCELAS DOS FINANCIAMENTOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.02.00.00.00.00','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.02.01.00.00.00','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.02.02.00.00.00','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.02.98.00.00.00','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES  DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.03.00.00.00.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO - INTERNO - INTER OFSS - MUNICÍPIO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.01.00.00.00.00','PARCELA A CURTO PRAZO DOS FINANCIAMENTOS INTERNOS','REGISTRA AS PARCELAS DOS FINANCIAMENTOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.02.00.00.00.00','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.02.01.00.00.00','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.02.02.00.00.00','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.02.98.00.00.00','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES  DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.03.00.00.00.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.0.00.00.00.00.00','FINANCIAMENTO A CURTO PRAZO - EXTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.00.00.00.00.00','FINANCIAMENTO A CURTO PRAZO - EXTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no curto prazo.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.01.00.00.00.00','PARCELA A CURTO PRAZO DOS FINANCIAMENTOS EXTERNOS','REGISTRA AS PARCELAS DOS FINANCIAMENTOS EXTERNOS ASSUMIDOS CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.02.00.00.00.00','FINANCIAMENTOS EXTERNOS','COMPREENDE OS VALORES DOS FINANCIAMENTOS EXTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.02.01.00.00.00','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS  A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.02.98.00.00.00','OUTROS FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES  DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.03.00.00.00.00','FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.0.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.01.01.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.01.02.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.01.03.00.00.00','JUROS PRO-RATA  SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.02.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.02.01.00.00.00','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.02.02.00.00.00','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.03.01.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.03.02.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.03.03.00.00.00','JUROS PRO-RATA  SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.04.01.00.00.00','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.04.02.00.00.00','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO -INTER OFSS - UNIÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.01.01.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.01.02.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.01.03.00.00.00','JUROS PRO-RATA  SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.02.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.02.01.00.00.00','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.02.02.00.00.00','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.03.01.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.03.02.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.03.03.00.00.00','JUROS PRO-RATA  SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.04.01.00.00.00','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.04.02.00.00.00','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO -INTER OFSS - ESTADO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.02.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.5.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO -INTER OFSS - MUNICÍPIO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.0.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - EXTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - EXTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.02.00.00.00.00','ENCARGOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.0.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR - INTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.1.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR - INTERNO - CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.3.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR - INTERNO - INTER OFSS - UNIÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.4.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR - INTERNO - INTER OFFS - ESTADO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.5.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR - INTERNO - INTER OFSS - MUNICÍPIO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.9.0.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.9.1.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR- CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.0.0.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR A CURTO PRAZO','Compreende as obrigações junto a fornecedores de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar, inclusive os precatórios decorrentes dessas obrigações, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.0.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.01.00.00.00.00','FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.02.00.00.00.00','FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.00.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.01.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.02.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES - ANTERIORES A 05/05/2000','COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES, ANTERIORES A 05/05/2000  (LEI DE RESPONSABILIDADE FISCAL).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.02.01.00.00','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.02.02.00.00','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.02.03.00.00','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.03.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000','COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.03.01.00.00','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS  DE  PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.03.02.00.00','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE  PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.03.03.00.00','FORNECEDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE  PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.04.00.00.00.00','CONTAS A PAGAR CREDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES AO EXERCICIO ATUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.04.01.00.00.00','CONTAS A PAGAR  DO EXERCICIO','REGISTRA O RECONHECIMENTO PATRIMONIAL DE VALORES A PAGAR AOS CREDORES NACIONAIS DE BENS, MATERIAIS E SERVIÇOS, REFERENTES AO EXERCICIO ATUAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.04.02.00.00.00','CONTAS A PAGAR  DO EXERCICIO - EMPENHADOS','REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DE BENS, MATERIAIS E SERVIÇOS, REFERENTES AO EXERCICIO ATUAL, QUE JÁ PASSARAM PELA EXECUÇÃO ORÇAMENTÁRIA DA DESPESA (EMPENHO).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.05.00.00.00.00','CONTAS A PAGAR CREDORES NACIONAIS DE EXERCICIOS ANTERIORES','COMPREENDE OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES A EXERCICIOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.05.01.00.00.00','CREDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA O MONTANTE DAS DESPESAS COM CREDORES REALIZADAS E LIQUIDADAS PELO PODER EXECUTIVO E ENTIDADES DA ADMINISTRAÇÃO INDIRETA E NÃO PAGAS ATÉ 31 DE DEZEMBRO DO ANO ANTERIOR E DEVEM SER DESDOBRADAS POR EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.05.02.00.00.00','CREDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA O MONTANTE DAS DESPESAS COM CREDORES REALIZADAS E LIQUIDADAS PELO PODER LEGISLATIVO E NÃO PAGAS ATÉ 31 DE DEZEMBRO DO ANO ANTERIOR E DEVERAO SER DESDOBRADAS POR EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.05.03.00.00.00','CREDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA O MONTANTE DAS DESPESAS COM CREDORES REALIZADAS E LIQUIDADAS PELO REGIME PRÓPRIO DE PREVIDÊNCIA DO SERVIDOR E NÃO PAGAS ATÉ 31 DE DEZEMBRO DO ANO ANTERIOR E DEVERAO SER DESDOBRADAS POR EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.00.00.00.00','PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.01.00.00.00','PRECATORIOS DE  CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DO EXERCICIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.00.00.00','PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES','COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DE EXERCICIOS ANTERIORES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.01.00.00','PRECATORIOS A PAGAR (ANTERIORES 05/05/2000)','COMPREENDE O VALOR DOS PRECATORIOS A PAGAR  REFERENTE A PESSOAL, FORNECEDORES E TERCEIROS, ANTERIORES A 05/05/2000.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.01.01.00','CREDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.01.02.00','CREDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.01.03.00','CREDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, ATE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.02.00.00','CREDORES - A PARTIR DE 05/05/2000','COMPREENDE OS VALORES DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.02.01.00','CREDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS  DE  PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.02.02.00','CREDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE  PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.06.02.02.03.00','CREDORES - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE  PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000 DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.07.00.00.00.00','POR INSUFICIENCIA DE CREDITOS/RECURSOS','REGISTRA OS VALORES DAS OBRIGACOES TRIBUTARIAS DEVIDAMENTE RECONHECIDAS, DE FORDECEDORES E/OU CREDORES DE BENS E/OU SERVICOS, NAO CONTEMPLADAS PELA EXECUCAO ORCAMENTARIA EM VIRTUDE DA LIMITACAO DA  PROGRAMACAO  FINANCEIRA OU POR INSUFICEINCIA DE CREDITOS, OU AINDA EM FASE DE IDENTIFICACAO DOCREDITO ORCAMENTARIO, CONFORME DISPOSTO NA NOTA TECNICA STN/CCONT  Nº2309, DE 28 DE DEZEMBRO DE 2007.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.0.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO','Compreende as obrigações junto a fornecedores estrangeiros de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores estrangeiros de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.01.00.00.00.00','FORNECEDORES ESTRANGEIROS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.02.00.00.00.00','FORNECEDORES ESTRANGEIROS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.03.00.00.00.00','CONTAS A PAGAR - CREDORES ESTRANGEIROS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS CREDORES ESTRANGEIROS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES AO EXERCICIO ATUAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.04.00.00.00.00','CONTAS A PAGAR - CREDORES ESTRANGEIROS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS CREDORES ESTRANGEIROS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.0.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO','Compreende as obrigações das entidades com o governo relativas a impostos, taxas e contribuições com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO- CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.01.00.00.00.00','IPI A RECOLHER','REGISTRA O VALOR DAS OBRIGAÇÕES TRIBUTÁRIAS A RECOLHER REFERENTES AO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS DAS UNIDADES INDUSTRIAIS OU COM CARACTERISTICAS DESSAS, GERADAS PELAS VENDAS DE PRODUTOS INDUSTRIAIS E SUJEITAS A COMPENSACAO COM OS CRÉDITOS ADQUIRIDOS POR COMPRAS DE MATÉRIAS-PRIMAS, EM CONFORMIDADE COM A SISTEMATICA DE APURACAO DESSE IMPOSTO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.02.00.00.00.00','IRPJ A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO DE RENDA PESSOA JURIDICA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.11.00.00.00.00','PIS/PASEP A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO PROGRAMA DE INTEGRACAO SOCIAL (PIS) E PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO ( PASEP).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.11.01.00.00.00','PIS/PASEP - DO EXERCICIO','REGISTRA AS OBRIGACOES REALTIVAS AO PIS/PASEP REFERENTE A COMPETENCIA DO EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.11.02.00.00.00','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA AS OBRIGACOES REALTIVAS AO PIS/PASEP REFERENTE A COMPETENCIA DE EXERCICOS ANTERIORES REGISTRADAS EM RESTOS A PAGAR DO PODER EXECUTIVO E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.11.03.00.00.00','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA AS OBRIGACOES REALTIVAS AO PIS/PASEP REFERENTE A COMPETENCIA DE EXERCICOS ANTERIORES REGISTRADAS EM RESTOS A PAGAR DO PODER LEGISLATIVO E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.11.04.00.00.00','PIS/PASEP - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA AS OBRIGACOES REALTIVAS AO PIS/PASEP REFERENTE A COMPETENCIA DE EXERCICOS ANTERIORES REGISTRADAS EM RESTOS A PAGAR DO RPPS E DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.12.00.00.00.00','TRIBUTOS FEDERAIS RENEGOCIADOS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS FEDERAIS QUE TENHAM SIDO RENEGOCIADOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.13.00.00.00.00','RECURSOS FISCAIS - DARF A EMITIR','REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELAS REPARTICOES PUBLICAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, OU SEJA, VALORES A SEREM RECOLHIDOS POR MEIO DE DARF. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, POR MEIO DE DOCUMENTO DE ARRECADACAO DE RECEITAS FEDERAIS (DARF).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.99.00.00.00.00','OUTROS TRIBUTOS E CONTRIBUICOES FEDERAIS  A RECOLHER','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS','Compreende as obrigações das entidades com os tributos de competência estadual com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS- CONSOLIDAÇÃO','Compreende as obrigações das entidades com os tributos de competência estadual com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.01.00.00.00.00','ICMS A RECOLHER','COMPREENDE O VALOR DAS OBRIGAÇÕES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVIÇOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVIÇOS (ICMS), SUJEITOS A COMPENSAÇÕES COM OS CRÉDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVIÇOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO OU SOBRE MERCADORIAS DE TERCEIROS ENTREGUES PARA DEPOSITO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.01.01.00.00.00','ICMS A RECOLHER - SOBRE MERCADORIAS PARA REVENDA','REGISTRA O VALOR DAS OBRIGAÇÕES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVIÇOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVIÇOS (ICMS), SUJEITAS A COMPENSAÇÕES COM OS CRÉDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVIÇOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.01.02.00.00.00','ICMS A RECOLHER - SOBRE MERCADORIAS DE TERCEIROS PARA DEPOSITO','REGISTRA O VALOR DAS OBRIGAÇÕES EXIGIVEIS EM FUNCAO DA ENTRADA DE MERCADORIAS DE TERCEIROS ENTREGUES A UNIDADE PARA DEPOSITO EM ARMAZEM.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.02.00.00.00.00','IPVA A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES (IPVA).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.03.00.00.00.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.06.00.00.00.00','TAXA DE LICENCIAMENTO ANUAL DE VEICULOS','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTE AO PAGAMENTO DA TAXA DE LICENCIAMENTO ANUAL DE VEICULOS, DECORRENTE DO SERVICO DE LICENCIAMENTO DE VEICULOS AUTOMOTORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.07.00.00.00.00','RECURSOS FISCAIS ESTADUAIS','REGISTRA O VALOR DOS CREDITOS FISCAIS ORIUNDOS DE RECEBIMENTOS DE TRIBUTOS ESTADUAIS CUJO RECOLHIMENTO E REALIZADO POR MEIO DE DAR. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, POR MEIO DE DOCUMENTO DE ARRECADACAO (DAR).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.08.00.00.00.00','TAXA DE LICENCIAMENTO AMBIENTAL','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.99.00.00.00.00','OUTROS TRIBUTOS E CONTRIBUICOES ESTADUAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS','Compreende as obrigações das entidades com os tributos de competência municipal com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com os tributos de competência municipal com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.01.00.00.00.00','ISS A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA (ISS)  EM QUE A PROPRIA UNIDADE SEJA A PRESTADORA  DO SERVICO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.02.00.00.00.00','IPTU/TLP A RECOLHER','REGISTRA O VALOR  DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA (IPTU) E TAXA DE LIMPEZA PUBLICA (TLP).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.03.00.00.00.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS A TRIBUTOS QUE  FORAM RENEGOCIADOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.04.00.00.00.00','CONTRIBUICAO PARA O CUSTEIO DE ILUMINAÇÃO PUBLICA A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL REFERENTES A CONTRIBUICAO PARA CUSTEIO DE ILUMINACAO PUBLICA.(ART.149-A DA CONSTITUICAO FEDERAL)','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.06.00.00.00.00','RECURSOS FISCAIS MUNICIPAIS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO MUNICIPAL, POR MEIO DE DOCUMENTO DE ARRECADACAO (DAR).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.07.00.00.00.00','TAXA DE LICENCIAMENTO AMBIENTAL','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.08.00.00.00.00','TAXA DE INSPEÇÃO VEICULAR','REGISTRA O VALOR DAS OBRIGAÇÕES JUNTO AO GOVERNO MUNICIPAL REFERENTES A CTAXA DE INSPEÇÃO VEICULAR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.99.00.00.00.00','OUTROS TRIBUTOS E CONTRIBUICOES MUNICIPAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO  HAJA  CONTAS ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.5.0.0.00.00.00.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.5.0.3.00.00.00.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - UNIÃO','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.5.0.4.00.00.00.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - ESTADO','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.5.0.5.00.00.00.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - MUNICÍPIO','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.0.0.00.00.00.00.00','PROVISÕES A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.1.0.00.00.00.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.1.1.00.00.00.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.1.1.01.00.00.00.00','PROVISAO PARA INDENIZAÇÕES TRABALHISTAS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE INDENIZAÇÕES TRABALHISTAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.1.1.02.00.00.00.00','PROVISAO PARA PAGAMENTO DE DISSIDIOS COLETIVOS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE DISSIDIOS COLETIVOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.0.00.00.00.00.00','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.00.00.00.00.00','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.01.00.00.00.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTOS DE INFRAÇÃO','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.01.01.00.00.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO NÃO RECORRIDOS','REGISTRA OS VALORES RELATIVOS A PROVISÃO REFERENTE A AUTOS DE INFRAÇÃO NÃO RECORRIDOS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.01.02.00.00.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO RECORRIDOS','REGISTRA OS VALORES RELATIVOS A  PROVISÃO REFERENTE  A AUTOS DE INFRAÇÃO RECORRIDOS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.02.00.00.00.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS - ESFERA JUDICIAL','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUAÇÕES FICAIS - ESFERA JUDICIAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.02.01.00.00.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','REGISTRA OS VALORES RELATIVOS A  PROVISÃO REFERENTE A AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.02.02.00.00.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','REGISTRA OS VALORES RELATIVOS A  PROVISÃO REFERENTE A AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.4.0.00.00.00.00.00','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.4.1.00.00.00.00.00','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.4.1.01.00.00.00.00','PROVISÃO PARA INDENIZAÇÕES CÍVEIS','REGISTRA OS VALORES RELATIVOS A  PROVISÃO PARA  PAGAMENTO DE SPARA INDENIZAÇÕES CÍVEIS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.5.0.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta específica de passivo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.5.3.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.5.4.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.5.5.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.6.0.00.00.00.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.6.1.00.00.00.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO- CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP. Compreende os valores de operações efetuadas entre uma unidade pertencente ao orçamento fiscal e da seguridade social (OFSS) com pessoa ou unidade que não pertença ao OFSS de ente público, alem dos demais fatos que não compreendem transações entre partes.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.9.0.00.00.00.00.00','OUTRAS PROVISÕES A CURTO PRAZO','Compreende os demais passivos de prazo ou de valor incertos, com prazo provável no curto prazo, não classificadas anteriormente neste plano de contas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.9.1.00.00.00.00.00','OUTRAS PROVISÕES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os demais passivos de prazo ou de valor incertos, com prazo provável no curto prazo, não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.0.0.00.00.00.00.00','DEMAIS OBRIGAÇÕES A CURTO PRAZO','Compreende as obrigações da entidade junto a terceiros não inclusas nos subgrupos anteriores, com vencimento no curto prazo, inclusive os precatórios decorrentes dessas obrigações, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.1.0.00.00.00.00.00','ADIANTAMENTOS DE CLIENTES','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.1.1.00.00.00.00.00','ADIANTAMENTOS DE CLIENTES- CONSOLIDAÇÃO','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.2.0.00.00.00.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS','Compreende os valores exigíveis no curto prazo, provenientes de danos a terceiros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.2.1.00.00.00.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS - CONSOLIDAÇÃO','Compreende os valores exigíveis no curto prazo, provenientes de danos a terceiros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.3.0.00.00.00.00.00','ARRENDAMENTO OPERACIONAL A PAGAR','Compreende as obrigações a curto prazo referentes a arrendamentos mercantis, nos quais não são transferidos ao arrendador os riscos e benefícios inerentes a propriedade, não havendo a possibilidade de opção de compra do bem arrendado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.3.1.00.00.00.00.00','ARRENDAMENTO OPERACIONAL A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações a curto prazo referentes a arrendamentos mercantis, nos quais não são transferidos ao arrendador os riscos e benefícios inerentes a propriedade, não havendo a possibilidade de opção de compra do bem arrendado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.4.0.00.00.00.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A CURTO PRAZO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.4.1.00.00.00.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A CURTO PRAZO- CONSOLIDAÇÃO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.5.0.00.00.00.00.00','DIVIDENDOS A PAGAR','Compreende os dividendos aprovados pela assembleia geral a serem pagos aos acionistas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.5.1.00.00.00.00.00','DIVIDENDOS A PAGAR- CONSOLIDAÇÃO','Compreende os dividendos aprovados pela assembleia geral a serem pagos aos acionistas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.0.00.00.00.00.00','VALORES RESTITUÍVEIS','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, independentemente do prazo de exigibilidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.00.00.00.00.00','VALORES RESTITUÍVEIS - CONSOLIDAÇÃO','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, independentemente do prazo de exigibilidade.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.00.00.00.00','CONSIGNACOES','COMPREENDE OS VALORES ENTREGUES EM CONFIANCA OU EM CONSIGNACOES, GERALMENTE RETIDOS EM FOLHA DE PAGAMENTO DE EMPREGADOS OU SERVIDORES OU NOS PAGAMENTOS REFERENTES A COMPRAS DE BENS E SERVICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.02.00.00.00','INSS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE EMPREGADOS REGIDOS PELA CONSOLIDACAO DAS LEIS DO TRABALHO (CLT) E AGENTES POLITICOS OU DE  SERVICOS DE TERCEIROS, A SER RECOLHIDO AO INSTITUTO NACIONAL DO SEGURO SOCIAL/PREVIDENCIA SOCIAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.03.00.00.00','ENCARGOS SOCIAIS - OUTRAS ENTIDADES','REGISTRA O VALOR A SER RECOLHIDO A OUTRAS ENTIDADES, EM  FUNCAO DE DISPOSITIVOS LEGAIS COM AS QUAIS A ENTIDADE  MANTENHA CONVENIO DE ARRECADACAO DIRETA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.04.00.00.00','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF DEVIDO AO TESOURO MUNICIPAL','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DO IMPOSTO SOBRE A RENDA, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS  OU CREDITADAS A SERVIDORES OU EMPREGADOS, SOBRE AS QUAIS INCIDA O REFERIDO IMPOSTO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.04.01.00.00','RETENCAO IRRF S/RENDIMENTO TRABALHO SERVIDORES ATIVOS','REPRESENTA VALORES MONETÁRIOS RETIDOS NA FOLHA DE PAGAMENTO DE SERVIDORES ATIVOS REFERENTE AO IRRF','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.04.02.00.00','RETENCAO IRRF S/RENDIMENTO TRABALHO SERVIDORES INATIVOS/PENSIONISTAS','REPRESENTA VALORES MONETÁRIOS RETIDOS NA FOLHA DE PAGAMENTO DE SERVIDORES INATIVOS E PENSIONISTAS REFERENTE AO IRRF.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.04.03.00.00','IMPOSTOS A REPASSAR - IRRF','REPRESENTA VALORES MONETÁRIOS DE IMPOSTOS A REPASSAR - IRRF.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.04.04.00.00','DEVOLUCAO DO IRRF','REPRESENTA VALORES MONETÁRIOS DE DEVOLUÇÃO DO IRRF.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.05.00.00.00','INDENIZACOES E RESTITUICOES','REGISTRA OS VALORES RELATIVOS AS INDENIZACOES E RESTITUICOES DE TRIBUTOS COM AUTORIZACOES CONCEDIDAS, POREM NAO DEVOLVIDAS AOS LEGITIMOS CREDORES PELA UNIDADE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.06.00.00.00','IMPOSTOS E CONTRIBUICOES DIVERSOS','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA UNIDADE, DE IMPOSTOS E CONTRIBUICOES DIVERSOS, RELATIVAS AS IMPORTANCIAS PAGAS   A TERCEIROS, SOBRE OS QUAIS INCIDAM OS REFERIDOS TRIBUTOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.07.00.00.00','OUTROS TRIBUTOS DO TESOURO NACIONAL','REGISTRA OS VALORES RELATIVOS A OUTROS TRIBUTOS DO TESOURO NACIONAL RETIDOS PELA UNIDADE SOBRE VALORES   PAGOS OU CREDITADOS E QUE, SOBRE OS QUAIS, INCIDA O REFERIDO TRIBUTO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.08.00.00.00','ICMS','REGISTRA OS VALORES RELATIVOS AO IMPOSTO SOBRE A CIRCULACAO DE  MERCADORIAS E SERVICOS RETIDOS POR FORCA DE LEGISLACAO OU POR ACORDO  ENTRE AS PARTES ENVOLVIDAS NA TRANSACAO EM CONSIGNACOES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.09.00.00.00','ISS','REGISTRA OS VALORES DO IMPOSTO SOBRE SERVICOS RETIDO EM CONSIGNACOES  POR FORCA DE LEGISLACAO, CIRCUNSTANCIAS OU ACORDO ENTRE AS PARTES ENVOLVIDOS NA TRANSACAO, EM SITUACOES QUE A UG COMO PARTE CONTRATANTE,  ATUE COMO SUBSTITUTA TRIBUTARIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.13.00.00.00','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS','REGISTRA OS VALORES EM CONSIGNACAO RELATIVOS A TRIBUTOS DEVIDOS A ESTADOS E MUNICIPIOS QUE NAO POSSUEM CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.14.00.00.00','PENSAO ALIMENTICIA','REGISTRA OS VALORES DAS RETENCOES PROCEDIDAS EM PAGAMENTOS A  EMPREGADOS OU A SERVIDORES AUTORIZADOS POR ESSES OU POR DETERMINACAO  JUDICIAL, A TITULO DE PENSAO ALIMENTICIA DESTINADA A MANUTENCAO DE FAMILIAR','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.15.00.00.00','PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS  DE  PAGAMENTO  DO  PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES DE PREVIDENCIA E ASSISTENCIA MEDICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.15.01.00.00','RETENCOES - CONTRIBUICOES AO RPPS A RECOLHER-EXECUTIVO/INDIRETAS','REPRESENTA VALORES MONETÁRIOS RETIDOS NA FOLHA DE PAGAMENTO DE SERVIDORES DO EXECUTIVO / INDIRETAS REFERENTES AS CONTRIBUIÇÕES PARA O RPPS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.15.02.00.00','RETENCOES - CONTRIBUICOES AO RPPS A RECOLHER - LEGISLATIVO','REPRESENTA VALORES MONETÁRIOS RETIDOS NA FOLHA DE PAGAMENTO DE SERVIDORES DO LEGISLATIVO REFERENTES AS CONTRIBUIÇÕES PARA O RPPS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.16.00.00.00','ASSISTENCIA A SAUDE - ADMINISTRACAO PROPRIA','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, QUE SERAO ADMINISTRADOS PELO PROPRIO ORGAO/ENTIDADE PARA ASSISTENCIA A SAUDE DE SEUS SERVIDORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.17.00.00.00','ENTIDADES REPRESENTATIVAS DE CLASSES','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS  DE  PAGAMENTO  DE  PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE  INSTITUICOES  REPRESENTATIVAS DE CLASSE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.21.00.00.00','PLANOS DE SEGUROS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS   EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES AS CONTRIBUICOES A PLANOS DE SEGURO DE VIDA EM GRUPO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.22.00.00.00','EMPRESTIMOS E FINANCIAMENTOS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS  EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES A EMPRESTIMOS E  FINANCIAMENTOS  CONCEDIDOS  POR TERCEIROS, BEM COMO RETENCOES DE PARCELAS DE CONSORCIOS E SEGURADOS DO INSS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.24.00.00.00','RETENCAO RELATIVA A VALE TRANSPORTE','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM  REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO  DE VALE-TRANSPORTE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.25.00.00.00','RETENCAO RELATIVA A VALE ALIMENTACAO','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM  REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO  DE CARTAO-ALIMENTACAO/REFEICAO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.99.00.00.00','OUTROS CONSIGNATARIOS','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, EM CONFIANCA, POR DIVERSOS CONTRIBUINTES  SUJEITOS A RECOLHIMENTOS E OU PAGAMENTOS AOS FAVORECIDOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.02.00.00.00.00','GARANTIAS','COMPREENDE A GARANTIA DO CUMPRIMENTO DE UMA OBRIGACAO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENCOES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.03.00.00.00.00','DEPOSITOS JUDICIAIS','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL E DEPOSITOS PARA RECURSOS JUDICIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.03.01.00.00.00','DEPOSITOS A EFETUAR POR DETERMINACAO JUDICIAL','REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS  A EFETUAR PELA ENTIDADE POR DETERMINACAO JUDICIAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.03.02.00.00.00','DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL','REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS RECEBIDOS PELA ENTIDADE POR DETERMINACAO JUDICIAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.03.03.00.00.00','DEPOSITOS A EFETUAR PARA RECURSOS JUDICIAIS','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS A EFETUAR PELA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.03.04.00.00.00','DEPOSITOS RECEBIDOS PARA RECURSOS JUDICIAIS','REGISTRA OS VALORES RELATIVOS A DEPOSITOS RECEBIDOS PELA ENTIDADE RELATIVOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.00.00.00.00','DEPOSITOS NAO JUDICIAIS','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS, EXCETO DEPOSITOS JUDICIAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.01.00.00.00','DEPOSITOS E CAUCOES A EFETUAR','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS REFERENTES A DEPOSITOS E/OU CAUCOES A EFETUAR PELA ENTIDADE VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.01.01.00.00','REPASSES A FUNDOS/AUTARQUIAS REFERENTE A COMPENSAÇÃO FINANCEIRA DO RPPS, RECEBIDA UNIAO','REGISTRA OS VALORES REFERENTES A COMPENSAÇÃO FINANCEIRA RECEBIDA DA UNIAO E QUE DEVE SER REPASSADA A AUTARQUIA OU FUNDOS PREVIDENCIÁRIOS','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.01.02.00.00','CAUCOES EM DINHEIRO','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS NO CURSO DO EXERCICIO  SEGUINTE, CONTRAIDAS COMO RECEBIMENTO DE  CAUCOES VINCULADOS A CONTRATOS OU A CONVENCOES, PARA GARANTIAS DE OPERACOES  ESPECIFICAS','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.02.00.00.00','DEPOSITOS E CAUCOES RECEBIDOS','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS E/OU CAUCOES PELA ENTIDADE VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.05.00.00.00','DEPOSITOS ESPECIAIS','REGISTRA O VALOR RELATIVO A RETENCOES DE DEPOSITOS VINCULADOS A RESTITUIR NO CURSO DO EXERCICIO SEGUINTE A ENTIDADE TRANSFERIDORA, DECORRENTE  DE CONTRATOS OU  INSTRUMENTOS CONGENERES, CONVENCAO, ACORDO OU AJUSTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.05.01.00.00','RETENCOES CONTRATUAIS','REGISTRAR O VALOR RELATIVO A RETENÇÕES DE DEPÓSITOS VINCULADOS A RESTITUIÇÕES NO CURSO DO EXERCÍCIO, DECORRENTE DE CONTRATO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.05.02.00.00','RETENCOES SEGURIDADE SOCIAL','REGISTRAR O VALOR RELATIVO A RETENÇÕES DE DEPÓSITOS VINCULADOS A RESTITUIÇÕES NO CURSO DO EXERCÍCIO, DECORRENTE DA SEGURIDADE SOCIAL','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.06.00.00.00','DEPOSITOS RETIDOS DE FORNECEDORES','REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE FORNECEDORES EM FUNCAO DE APLICACAO DE MULTAS E OUTRAS DETERMINACOES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.09.00.00.00','DEPOSITOS DE TERCEIROS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TERCEIROS  DE  DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NAO RECLAMADOS  PELOS CREDORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.12.00.00.00','DEPOSITOS DE RENDIMENTOS DO PIS/PASEP','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RENDIMENTOS DO PIS/PASEP PARA CREDITO EM FOLHA DE PAGAMENTO AOS SERVIDORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.99.00.00.00','OUTROS DEPOSITOS','REGISTRA COMPROMISSOS EXIGIVEIS ATE O TERMINO DO  EXERCICIO  SEGUINTE, DECORRENTES DE RECEBIMENTOS A TITULO DE DEPOSITOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.99.00.00.00.00','OUTROS VALORES RESTITUIVEIS','OUTROS VALORES RESTITUIVEIS EM POSSE DA ENTIDADE, NO PAPEL DE FIEL DEPOSITARIA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.0.00.00.00.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.00.00.00.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.01.00.00.00.00','INDENIZACOES E RESTITUICOES','COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.01.01.00.00.00','INDENIZACOES A SERVIDORES','REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO  REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.01.02.00.00.00','INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES NO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.01.03.00.00.00','INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.02.00.00.00.00','DIARIAS A PAGAR','REGISTRA OS VALORES RELATIVOS AS DIARIAS A PAGAR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.03.00.00.00.00','SUPRIMENTOS DE FUNDOS A PAGAR','REGISTRA OS VALORES RELATIVOS AOS SUPRIMENTOS DE FUNDOS A PAGAR.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.05.00.00.00.00','CONVENIOS A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.05.01.00.00.00','CONVENIOS A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO  EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.05.02.00.00.00','CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM  EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.00.00.00.00','PRECATORIOS DE TERCEIROS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.01.00.00.00','PRECATORIOS DE TERCEIROS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.02.00.00.00','PRECATORIOS A PAGAR - TERCEIROS - DO EXERCÍCIO ANTERIOR','REGISTRA OS VALORES DE PRECATORIOS PARA PAGAMENTO DE TERCEIROS, NO SISTEMA PATRIMONIAL O QUAL DEVERIA TER SIDO PAGO ATÉ O FINAL DO EXERCICIO E NÃO OCORREU A EXECUÇÃO ORÇAMENTÁRIA','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.03.00.00.00','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES -  ANTES DE 05/05/2000','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.03.01.00.00','TERCEIROS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIACAO DE TERRAS E OUTRAS DE RESPONSABILIDADE DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.03.02.00.00','TERCEIROS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIACAO DE TERRAS E OUTRAS DE RESPONSABILIDADE DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.03.03.00.00','TERCEIROS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIACAO DE TERRAS E OUTRAS DE RESPONSABILIDADE DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.04.00.00.00','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000','COMPREENDE OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.04.01.00.00','TERCEIROS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIACAO DE TERRAS E OUTRAS, A PARTIR DE 05/05/2000 DE RESPONSABILIDADE DO PODER EXECUTIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.04.02.00.00','TERCEIROS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIACAO DE TERRAS E OUTRAS, A PARTIR DE 05/05/2000 DE RESPONSABILIDADE DO PODER LEGISLATIVO. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.13.04.03.00.00','TERCEIROS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS DE PRECATORIOS PARA PAGAMENTO DE TERCEIROS RELATIVOS A DESAPROPRIACAO DE TERRAS E OUTRAS, A PARTIR DE 05/05/2000 DE RESPONSABILIDADE DO RPPS. DEVERAO SER DESDOBRADAS POR EXERCICIO','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.14.00.00.00.00','COMPENSACAO PREVIDENCIARIA','COMPREENDE O VALOR DAS OBRIGACOES  COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A  LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3.112/1999.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.14.01.00.00.00','COMPENSACAO PREVIDENCIARIA DO EXERCICIO','REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS  Nº 98, BEM COMO A   LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.14.02.00.00.00','COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES','REGISTRA O VALOR DAS OBRIGACOES DE  EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE   O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A   LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.20.00.00.00.00','CONTRATOS DE GESTAO','REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.23.00.00.00.00','AUXILIOS FINANCEIROS A PESQUISADORES','REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A  PESQUISADORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.26.00.00.00.00','ENTIDADES CREDORAS - FEDERAIS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE OBRIGACOES JUNTO A ENTIDADES FEDERAIS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.27.00.00.00.00','ENTIDADES CREDORAS - ESTADOS, DF E MUNICIPIOS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DECORRENTES DE OBRIGACOES JUNTO A ESTADOS, DF E MUNICIPIOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.35.00.00.00.00','INTERMEDIARIOS DE INVESTIMENTOS','COMPREENDE OS VALORES DE OBRIGACOES A CURTO PRAZO COM INTERMEDIARIOS DE INVESTIMENTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.35.01.00.00.00','VALORES DE INVESTIMENTOS A PAGAR','REGISTRA OS VALORES DE INVESTIMENTOS REALIZADOS NO MERCADO FINANCEIRO E NAO LIQUIDADOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.36.00.00.00.00','VALORES EM TRANSITO EXIGIVEIS','REGISTRA O VALOR DA ORDEM BANCARIA OU OUTRO DOCUMENTO EMITIDO PARA SAQUE CONTRA ESTABELECIMENTO BANCARIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.37.00.00.00.00','SUBVENCOES A PAGAR','COMPREENDE O SOMATORIO DAS SUBVENCOES A PAGAR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.37.01.00.00.00','SUBVENCOES A PAGAR DO EXERCICIO','REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DO  EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.37.02.00.00.00','SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DE  EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.38.00.00.00.00','RESTITUICOES DE RECEITAS A PAGAR','REGISTRA O VALOR DAS RESTITUICOES DE RECEITAS A PAGAR APROPRIADAS  PELAS UNIDADES GESTORAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.39.00.00.00.00','TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS','REGISTRA OS VALORES DE DEVOLUCOES DE RECURSOS DE TRANSFERENCIAS VOLUNTARIAS PARA POSTERIOR RECOLHIMENTO AO CONCEDENTE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.40.00.00.00.00','RECURSOS ESPECIAIS A LIBERAR','COMPREENDE A DESPESA EMPENHADA E NAO PAGA, APURADA AO FINAL DO EXERCICIO E INSCRITA EM RESTOS A PAGAR, PROCESSADOS E NAO PROCESSADOS,  BEM  COMO OS RECURSOS APROVADOS E NAO LIBERADOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.40.07.00.00.00','RECURSOS A LIBERAR POR VINCULACAO DE PAGAMENTO','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU  SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE  DE  SAQUE  COM VINCULACAO DE PAGAMENTO, ESTABELECIDO PELO ORGAO CENTRAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.00.00.00.00','OUTROS CREDORES A CURTO PRAZO','COMPREENDE OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES  PARA OS  QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.01.00.00.00','OUTROS CREDORES DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES  NO EXERCICIO, PARA OS  QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.02.00.00.00','OUTROS CREDORES DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCICIOS ANTERIORES, PARA OS  QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.04.00.00.00','SERVIÇO DA DIVIDA DE PARCELAMENTOS A PAGAR - DO EXERCICIO','REGISTRA O VALOR DO SERVIÇO DA DIVIDA DE PARCELAMENTOS A PAGAR - DO EXERCICIO','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.05.00.00.00','DEBITOS DIVERSOS - DO EXERCICIO','REGISTRA O VALOR DOS DEBITOS DIVERSOS DO EXERCICO PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.06.00.00.00','RESTOS A PAGAR PROCESSADOS DE DEBITOS DIVERSOS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS REFERENTES A DEBITOS DIVERSOS  PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.06.01.00.00','DEBITOS DIVERSOS - RESTOS A PAGAR PROCESSADOS - EXECUTIVO/INDIRETAS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS REFERENTES A DEBITOS DIVERSOS  PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA DE RESPONSABILIDADE DO PODER EXECUTIVO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.06.02.00.00','DEBITOS DIVERSOS - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS REFERENTES A DEBITOS DIVERSOS  PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA DE RESPONSABILIDADE DO PODER LEGISLATIVO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.06.03.00.00','DEBITOS DIVERSOS - RESTOS A PAGAR PROCESSADOS - RPPS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS REFERENTES A DEBITOS DIVERSOS  PARA OS QUAIS NÃO HAJA CONTA ESPECIFICA DE RESPONSABILIDADE DO RPPS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.98.07.00.00.00','RESTOS A PAGAR PROCESSADOS - SERVIÇO DA DIVIDA DE PARCELAMENTO','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS - SERVICO DA DIVIDA DE PARCELAMENTO','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.99.00.00.00.00','OUTRAS OBRIGAÇÕES  CONSOLIDAÇÃO','COMPREENDE OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES  PARA OS  QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.99.01.00.00.00','OUTRAS OBRIGAÇÕES  DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES  NO EXERCICIO, PARA OS  QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.99.02.00.00.00','OUTRAS OBRIGAÇÕES  DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCICIOS ANTERIORES, PARA OS  QUAIS NÃO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.00.00.00.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO-INTRA OFSS','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.01.00.00.00.00','INDENIZACOES E RESTITUICOES','COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.01.02.00.00.00','INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES NO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.01.03.00.00.00','INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.05.00.00.00.00','CONVENIOS A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.05.01.00.00.00','CONVENIOS A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO  EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.05.02.00.00.00','CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM  EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.40.00.00.00.00','RECURSOS ESPECIAIS A LIBERAR','COMPREENDE A DESPESA EMPENHADA E NAO PAGA, APURADA AO FINAL DO EXERCICIO E INSCRITA EM RESTOS A PAGAR, PROCESSADOS E NAO PROCESSADOS,  BEM  COMO OS RECURSOS APROVADOS E NAO LIBERADOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.40.07.00.00.00','RECURSOS A LIBERAR POR VINCULACAO DE PAGAMENTO','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU  SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE  DE  SAQUE  COM VINCULACAO DE PAGAMENTO, ESTABELECIDO PELO ORGAO CENTRAL.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.98.00.00.00.00','OUTROS CREDORES A CURTO PRAZO','COMPREENDE OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES  PARA OS  QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.98.01.00.00.00','OUTROS CREDORES DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES  NO EXERCICIO, PARA OS  QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.98.02.00.00.00','OUTROS CREDORES DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCICIOS ANTERIORES, PARA OS  QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.0.0.0.00.00.00.00.00','PASSIVO NAO-CIRCULANTE','Compreende as obrigações conhecidas e estimadas que não atendam a nenhum dos critérios para serem classificadas no passivo circulante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.0.0.00.00.00.00.00','OBRIGAÇÕES TRABALHISTAS, PREVIDENCIÁRIAS E ASSISTENCIAIS A PAGAR A LONGO PRAZO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, aposentadorias, reformas, pensões e encargos a pagar,  benefícios assistenciais, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.0.00.00.00.00.00','PESSOAL A PAGAR','Compreende as obrigações a longo prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.00.00.00.00.00','PESSOAL A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações a longo prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.01.00.00.00.00','PESSOAL A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS A VENCIMENTOS E VANTAGENS FIXAS E VARIAVEIS  DEVIDAS AO SERVIDORES, BEM COMO AS APOSENTADORIAS, REFORMAS E PENSOES, RELATIVAS A EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.02.00.00.00.00','PRECATORIOS DE PESSOAL','COMPREENDE OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.02.01.00.00.00','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCICIOS ANTERIORES AO ANTERIOR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.02.02.00.00.00','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES - ANTERIORES A 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS PARA PAGAMENTO DE PESSOAL, ATE05/05/2000, EXIGIVEIS NO LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.02.03.00.00.00','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.0.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR','Compreende as obrigações a longo prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações a longo prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.01.00.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.01.01.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.01.02.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTERIORES A 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E ATERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.01.03.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.3.0.00.00.00.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR','Compreende as obrigações a longo prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.3.1.00.00.00.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações a longo prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.3.1.01.00.00.00.00','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.0.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.1.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.1.01.00.00.00.00','INSS A PAGAR','COMPREENDE OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL,  INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.1.01.01.00.00.00','INSS - DEBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.1.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.2.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.2.02.00.00.00.00','RPPS - DÉBITO PARCELADO','COMPREENREGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR DOS DÉBITOS PARCELADOS, REFERENTE AO NÃO RECOLHIMENTO DE CONTRIBUIÇÕES SOCIAIS AO RPPS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.2.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.3.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.3.01.00.00.00.00','INSS A PAGAR - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR REFERENTE A DÉBITOS PARCELADOS JUNTO AO INSS , REFERENTE AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DE FOLHA DE PAGAMENTO E OUTROS AFINS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.3.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.4.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.4.02.00.00.00.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS) DO ESTADO - DEBITO PARCELADO','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE   PREVIDENCIA DO ESTADO (IPE), NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.4.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.5.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.5.02.00.00.00.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS) DE OU TRO MUNICIPIO - DEBITO PARCELADO','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE   PREVIDENCIA DE OUTRO MUNICIPIO, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.5.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.0.0.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO','Compreende as obrigações financeiras da entidade a titulo de empréstimos, bem como as aquisições efetuadas diretamente com o fornecedor, com vencimentos no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.0.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.1.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO - CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.1.01.00.00.00.00','EMPRESTIMOS INTERNOS - EM TITULOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.1.02.00.00.00.00','EMPRESTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.3.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO - INTER OFSS - UNIÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.3.01.00.00.00.00','EMPRESTIMOS INTERNOS - EM TITULOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.3.03.00.00.00.00','EMPRESTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.4.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO - INTER OFSS - ESTADO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.4.02.00.00.00.00','EMPRESTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.5.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.2.0.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - EXTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.2.1.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO- EXTERNO CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.2.1.02.00.00.00.00','EMPRÉSTIMOS EXTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERAÇÕES DE CRÉDITO EXTERNAS EM CONTRATOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.0.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO - INTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.1.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO- INTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.1.01.00.00.00.00','FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.3.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO- INTERNO -INTER OFSS - UNIÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.3.01.00.00.00.00','FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.4.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO - INTERNO - INTER OFSS - ESTADO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.4.01.00.00.00.00','FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.5.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO - INTERNO - INTER OFSS - MUNICÍPIO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.4.0.00.00.00.00.00','FINANCIAMENTO A LONGO PRAZO - EXTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.4.1.00.00.00.00.00','FINANCIAMENTO A LONGO PRAZO - EXTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no longo prazo.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.4.1.01.00.00.00.00','FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.0.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo.. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.02.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.3.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO -INTER OFSS - UNIÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.3.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.3.03.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.3.05.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.3.07.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.4.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO -INTER OFSS - ESTADO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.4.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.4.02.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.4.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.4.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.5.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO -INTER OFSS - MUNICÍPIO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.5.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.5.02.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.5.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.5.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.0.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.02.00.00.00.00','ENCARGOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.0.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.1.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.3.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - INTER OFSS - UNIÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.4.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - INTER OFFS - ESTADO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.5.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO - INTER OFSS - MUNICÍPIO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.9.0.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.9.1.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO - CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.0.0.00.00.00.00.00','FORNECEDORES A LONGO PRAZO','Compreende as obrigações junto a fornecedores de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.0.00.00.00.00.00','FORNECEDORES NACIONAIS A LONGO PRAZO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.00.00.00.00.00','FORNECEDORES NACIONAIS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.01.00.00.00.00','FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.02.00.00.00.00','FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.03.00.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.03.01.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.03.02.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS - EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR DE PRECATORIOS DE FORNECEDORES DE  BENS  E SERVICOS DE EXERCICIOS ANTERIORES AO ANTERIOR.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.03.03.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS - ANTERIORES A 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES,ATE05/05/2000, EXIGIVEIS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.03.04.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS  - A PARTIR DE 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS  PARA PAGAMENTO DE FORNECEDORES, A PARTIR DE 05/05/2000, EXIGIVEL A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.2.0.00.00.00.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO','Compreende as obrigações junto a fornecedores estrangeiros de matérias primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.2.1.00.00.00.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores estrangeiros de matérias primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.2.1.01.00.00.00.00','FORNECEDORES ESTRANGEIROS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.2.1.02.00.00.00.00','FORNECEDORES ESTRANGEIROS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.0.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO','Compreende as obrigações das entidades com o governo relativas a impostos, taxas e contribuições com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.2.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTRA OFSS','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS - UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.01.00.00.00.00','OBRIGACOES LEGAIS E TRIBUTARIAS','COMPREENDE OS VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DE OBRIGACOES JUNTO AO GOVERNO RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.01.01.00.00.00','OBRIGACOES TRIBUTARIAS RENEGOCIADAS','REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS AO MONTANTE PRINCIPAL DAS OBRIGACOES TRIBUTARIAS QUE FORAM RENEGOCIADAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.01.02.00.00.00','OUTRAS OBRIGACOES LEGAIS E TRIBUTARIAS','COMPREENDE OS VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DE OBRIGACOES LEGAIS E TRIBUTARIAS, PARA OS QUAIS NAO HAJA CONTAS  ESPECIFICAS.EX: PARCELAMENTO DO PASEP','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.01.02.01.00.00','PARCELAMENTOS DO FGTS','REGISTRA OS VALORES DAS OBRIGACOES, EXIGIVEIS A  LONGO  PRAZO,  DECORRENTES DE PARCELAMENTOS DO FGTS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.01.02.02.00.00','PARCELAMENTOS DO PASEP','REGISTRA OS VALORES DAS OBRIGACOES, EXIGIVEIS A  LONGO  PRAZO,  DECORRENTES DE PARCELAMENTOS DOPASEP','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.4.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS - ESTADO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.5.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS - MUNICÍPIO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.2.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.2.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.2.2.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - INTRA OFSS','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.3.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS','Compreende as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.3.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.3.2.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS-INTRA OFSS','Compreende as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.0.0.00.00.00.00.00','PROVISÕES A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.1.0.00.00.00.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.1.1.00.00.00.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.1.1.01.00.00.00.00','PROVISÃO PARA INDENIZAÇÕES TRABALHISTAS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE INDENIZAÇÕES TRABALHISTAS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.1.1.02.00.00.00.00','PROVISÃO PARA PAGAMENTO DE DISSIDIOS COLETIVOS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE DISSIDIOS COLETIVOS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.0.00.00.00.00.00','PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes, com probabilidade de ocorrerem no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.00.00.00.00.00','PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.00.00.00.00','PLANO FINANCEIRO - PROVISOES DE BENEFICIOS CONCEDIDOS','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios já concedidos aos assistidos e beneficiários em gozo de beneficio de prestação continuada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.01.00.00.00','APOSENTADORIAS/        PENSOES /OUTROS BENEFICIOS CONCEDIDOS DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS PRESTACOES FUTURAS DOS BENEFICIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTACAO CONTINUADA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.02.00.00.00','(-) CONTRIBUICOES DO ENTE PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR  OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.03.00.00.00','(-) CONTRIBUICOES DO APOSENTADO PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS INATIVOS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.04.00.00.00','(-) CONTRIBUICOES DO PENSIONISTA PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS PENSIONISTAS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.05.00.00.00','(-) COMPENSACAO PREVIDENCIARIA DO PLANO FINANCEIRO DO RPPS','REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.06.00.00.00','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO FUNDO SOB O REGIME DE PARCELAMENTO DE DEBITOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.07.00.00.00','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA','REGISTRA, DE ACORDO COM  O  RESULTADO DA AVALIACAO ATUARIAL, O  VALOR PRESENTE DAS INSUFICIENCIAS FINANCEIRAS FUTURAS  DO  PLANO FINANCEIRO CONSIDERANDO O § 1º DO ARTIGO 2º DA LEI 9717/98.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.00.00.00.00','PLANO FINANCEIRO - PROVISOES DE BENEFICIOS A CONCEDER','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios a conceder para a geração atual (servidores ativos).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.01.00.00.00','APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS A CONCEDER DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DOS BENEFICIOS A SEREM CONCEDIDOS AOS INTEGRANTES DA GERACAO ATUAL QUE AINDA NAO ESTEJAM EM GOZO DE BENEFICIOS DE PRESTACAO CONTINUADA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.02.00.00.00','(-) CONTRIBUICOES DO ENTE PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR  PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.03.00.00.00','(-) CONTRIBUICOES DO SERVIDOR PARA O PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O SOMATORIO DO VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS SERVIDORES ATIVOS, INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.04.00.00.00','(-) COMPENSACAO PREVIDENCIARIA DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.05.00.00.00','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO PLANO, CONSIDERANDO O PARCELAMENTO DOS VALORES NAO RECOLHIDOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.06.00.00.00','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA','REGISTRA, DE ACORDO COM  O  RESULTADO DA AVALIACAO ATUARIAL, O  VALOR PRESENTE DAS INSUFICIENCIAS FINANCEIRAS FUTURAS  DO  PLANO FINANCEIRO, CONSIDERANDO O § 1º DO ARTIGO 2º DA LEI 9717/98.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.00.00.00.00','PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS CONCEDIDOS','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios já concedidos aos assistidos e beneficiários em gozo de beneficio de prestação continuada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.01.00.00.00','APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS CONCEDIDOS DO PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS PRESTACOES FUTURAS DOS BENEFICIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTACAO CONTINUADA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.02.00.00.00','(-) CONTRIBUICOES DO ENTE PARA O PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS)  FUTURAS DO ENTE, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.03.00.00.00','(-) CONTRIBUICOES DO APOSENTADO PARA O PLANO PREVIDENCIARIO DO RPPS','REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS INATIVOS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.04.00.00.00','(-) CONTRIBUICOES DO PENSIONISTA PARA O PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS PENSIONISTAS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.05.00.00.00','(-) COMPENSACAO PREVIDENCIARIA DO PLANO PREVIDENCIARIO DO RPPS','REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11 DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.06.00.00.00','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS DO PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO PLANO, CONSIDERANDO O PARCELAMENTO DE VALORES NAO RECOLHIDOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.00.00.00.00','PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS A CONCEDER','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios a conceder para a geração atual (servidores ativos).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.01.00.00.00','APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS A CONCEDER DO PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DOS BENEFICIOS A SEREM CONCEDIDOS AOS INTEGRANTES DA GERACAO ATUAL QUE AINDA NAO ESTEJAM EM GOZO DE BENEFICIOS DE PRESTACAO CONTINUADA.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.02.00.00.00','(-) CONTRIBUICOES DO ENTE PARA O PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS)  FUTURAS DO ENTE, INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.03.00.00.00','(-) CONTRIBUICOES DO SERVIDOR PARA O PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O SOMATORIO DO VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS SERVIDORES ATIVOS,  INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.04.00.00.00','(-) COMPENSACAO PREVIDENCIARIA DO PLANO PREVIDENCIARIO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.05.00.00.00','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO PLANO, SOB O REGIME DE PARCELAMENTO DE DEBITOS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.05.00.00.00.00','PLANO PREVIDENCIARIO - PLANO DE AMORTIZACAO','Compreende, de acordo com resultado da avaliação atuarial, o valor presente liquido dos direitos incorporados ao patrimônio do RPPS com base em legislação especifica, bem como registro tempestivo do plano de amortização implementado em lei do ente federativo, considerando que o ajuste contábil das reservas matemáticas somente ocorrera na apresentação de uma nova reavaliação atuarial.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.05.98.00.00.00','(-) OUTROS CREDITOS DO PLANO DE AMORTIZACAO','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE LIQUIDO DOS DIREITOS INCORPORADOS AO PATRIMONIO DO RPPS COM BASE EM LEGISLACAO ESPECIFICA, COMO EXEMPLO: DIREITOS SOBRE ROYALTIES, BEM COMO REGISTRO TEMPESTIVO DO PLANO DE AMORTIZACAO IMPLEMENTADO EM LEI DO ENTE FEDERATIVO, CONSIDERANDO QUE O AJUSTE CONTABIL DAS RESERVAS MATEMATICAS SOMENTE OCORRERA NA APRESENTACAO DE UMA NOVA REAVALIACAO ATUARIAL.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.06.00.00.00.00','PROVISOES ATUARIAIS PARA AJUSTES DO PLANO FINANCEIRO','Compreende o somatório das provisões atuariais constituídas para ajustes do plano financeiro, conforme o resultado da avaliação atuarial.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.06.01.00.00.00','PROVISAO ATUARIAL PARA OSCILACAO DE RISCOS','REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, A PROVISAO ATUARIAL CORRESPONDENTE A EVENTUAIS DESVIOS DOS COMPROMISSOS ESPERADOS OU PELA ADOCAO DE BASES TECNICAS QUE NAO SE ADAPTAM AO PLANO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.00.00.00.00','PROVISOES ATUARIAIS PARA AJUSTES DO PLANO PREVIDENCIARIO','Compreende o somatório das provisões atuariais constituídas para ajustes do plano previdenciário, conforme o resultado da avaliação atuarial.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.01.00.00.00','AJUSTE DE RESULTADO ATUARIAL SUPERAVITARIO','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, PROVISAO ATUARIAL PARA AJUSTE DO PLANO PREVIDENCIARIO QUANDO O PLANO APRESENTAR RESULTADO SUPERAVITARIO, CONSIDERANDO O ARTIGO 25, DA PORTARIA MPS 403/2008.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.02.00.00.00','PROVISÃO ATUARIAL PARA OSCILAÇÃO DE RISCOS','REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, A PROVISAO ATUARIAL CORRESPONDENTE A EVENTUAIS DESVIOS DOS COMPROMISSOS ESPERADOS OU PELA ADOCAO DE BASES TECNICAS QUE NÃO SE ADAPTAM AO PLANO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.03.00.00.00','PROVISÃO ATUARIAL PARA BENEFÍCIOS A REGULARIZAR','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.04.00.00.00','PROVISÃO ATUARIAL PARA CONTINGÊNCIAS DE BENEFÍCIOS','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.98.00.00.00','OUTRAS PROVISÕES ATUARIAIS PARA AJUSTES DO PLANO','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.3.0.00.00.00.00.00','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.3.1.00.00.00.00.00','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.4.0.00.00.00.00.00','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.4.1.00.00.00.00.00','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.5.0.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.5.3.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.5.4.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.5.5.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.6.0.00.00.00.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.6.1.00.00.00.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO - CONSOLIDAÇÃO OFSS','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.9.0.00.00.00.00.00','OUTRAS PROVISÕES A LONGO PRAZO','Compreende os demais passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no longo prazo, não classificadas anteriormente neste plano de contas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.9.1.00.00.00.00.00','OUTRAS PROVISÕES A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os demais passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no longo prazo, não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.0.0.00.00.00.00.00','DEMAIS OBRIGAÇÕES A LONGO PRAZO','Compreende as obrigações da entidade junto a terceiros não inclusas nos subgrupos anteriores, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.1.0.00.00.00.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.1.1.00.00.00.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO- CONSOLIDAÇÃO','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.2.0.00.00.00.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO','Compreende os valores exigíveis no longo prazo, provenientes de danos a terceiros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.2.1.00.00.00.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os valores exigíveis no longo prazo, provenientes de danos a terceiros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.3.0.00.00.00.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A LONGO PRAZO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.3.1.00.00.00.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A LONGO PRAZO- CONSOLIDAÇÃO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.4.0.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando haja a possibilidade de devolução destes recursos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.4.1.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando haja a possibilidade de devolução destes recursos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.0.00.00.00.00.00','OUTRAS OBRIGAÇÕES A LONGO PRAZO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no longo prazo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.00.00.00.00.00','OUTRAS OBRIGAÇÕES A LONGO PRAZO- CONSOLIDAÇÃO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.01.00.00.00.00','INDENIZACOES E RESTITUICOES','COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.01.01.00.00.00','IINDENIZAÇÕES A SERVIDORES','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DAS OBRIGAÇÕES  CONSTITUÍDAS VISANDO O PAGAMENTO DE INDENIZAÇÕES TRABALHISTAS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.01.02.00.00.00','INDENIZAÇÕES E RESTITUIÇÕES DIVERSAS DO EXERCÍCIO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DAS OBRIGAÇÕES CONSTITUÍDAS VISANDO O PAGAMENTO DE INDENIZAÇÕES CÍVEIS A LONGO PRAZO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.01.03.00.00.00','INDENIZAÇÕES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZAÇÕES E RESTITUICOES DE EXERCICIOS ANTERIORES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.01.04.00.00.00','RESTITUICOES DE CONTRIBUIÇÕES PREVIDENCIARIAS','REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUIÇÕES PREVIDENCIARIAS  A SEREM EFETIVADAS PELAS UNIDADES DO INSS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.04.00.00.00.00','CONVENIOS A PAGAR','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.10.00.00.00.00','PRECATORIOS DE TERCEIROS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.10.01.00.00.00','PRECATORIOS DE TERCEIROS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.10.02.00.00.00','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES -  ANTES DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.10.03.00.00.00','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000','REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.11.00.00.00.00','COMPENSAÇÃO PREVIDENCIÁRIA','','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.11.01.00.00.00','COMPENSAÇÃO PREVIDENCIÁRIA DO EXERCÍCIO','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.11.02.00.00.00','COMPENSAÇÃO PREVIDENCIÁRIA DE EXERCÍCIOS ANTERIORES','','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.13.00.00.00.00','CONTRATOS DE GESTAO','REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.99.00.00.00.00','OUTROS CREDORES A LONGO PRAZO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE  RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES  PARA OS  QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.99.01.00.00.00','OPERACOES DE CREDITO ENTRE ENTIDADES DA ADMINISTRACAO MUNICIPAL','REGISTRA OS VALORES DAS OBRIGACOES, EXIGIVEIS A  LONGO  PRAZO,  ENTRE ENTIDADES DA ADMINISTRACAO MUNICIPAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.0.0.00.00.00.00.00','RESULTADO DIFERIDO','Compreende o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade.  Compreende também o saldo existente na antiga conta resultado de exercícios futuros em 31 de dezembro de 2008.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.1.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA (VPA) DIFERIDA','Compreende o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.1.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA DIFERIDA - CONSOLIDAÇÃO','Compreende o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.2.0.00.00.00.00.00','(-) CUSTO DIFERIDO','Compreende o custo relacionado às variações patrimoniais aumentativas (VPA) diferidas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.2.1.00.00.00.00.00','(-) CUSTO DIFERIDO - CONSOLIDAÇÃO','Compreende o custo relacionado às variações patrimoniais aumentativas (VPA) diferidas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.0.0.0.00.00.00.00.00','PATRIMÔNIO LIQUIDO','Compreende o valor residual dos ativos depois de deduzidos todos os passivos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.0.0.00.00.00.00.00','PATRIMÔNIO SOCIAL E CAPITAL SOCIAL','Compreende o patrimônio social das autarquias, fundações e fundos e o capital social das demais entidades da administração indireta.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.1.0.00.00.00.00.00','PATRIMÔNIO SOCIAL','Compreende o patrimônio das autarquias, fundações e fundos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.1.1.00.00.00.00.00','PATRIMÔNIO SOCIAL - CONSOLIDAÇÃO','Registra o patrimônio das autarquias, fundações e fundos, pertencentes ao orçamento fiscal e da seguridade social.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.0.00.00.00.00.00','CAPITAL SOCIAL REALIZADO','Compreende o capital social subscrito das empresas públicas e sociedades de economia mista, deduzido da parcela ainda não realizada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.1.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - CONSOLIDAÇÃO','Compreende o capital social subscrito das empresas públicas e sociedades de economia mista, deduzido da parcela ainda não realizada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.2.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - INTRA OFSS','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.3.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - UNIÃO','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.4.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - ESTADO','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.5.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - MUNICÍPIO','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.0.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.1.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.2.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTRA OFSS','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.3.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - UNIÃO','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.4.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - ESTADO','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.5.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - MUNICÍPIO.','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.0.0.00.00.00.00.00','RESERVAS DE CAPITAL','Compreende os valores acrescidos ao patrimônio que não transitaram pelo resultado como variações patrimoniais aumentativas (VPA).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.0.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.1.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - CONSOLIDAÇÃO','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.2.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTRA OFSS','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.3.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - UNIÃO','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.4.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - ESTADO','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.5.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - MUNICÍPIO','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.0.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS','Compreende o produto da alienação de partes beneficiárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.1.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - CONSOLIDAÇÃO','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.2.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTRA OFSS','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.3.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - UNIÃO','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.4.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - ESTADO','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.5.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - MUNICÍPIO','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.0.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO','Compreende o produto da alienação de bônus de subscrição.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.1.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - CONSOLIDAÇÃO','Registra o produto da alienação de bônus de subscrição. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.2.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTRA OFSS','Registra o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.3.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - UNIÃO','Registra o produto da alienação de bônus de subscrição.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.4.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - ESTADO','Registra o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.5.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - MUNICÍPIO','Registra o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.0.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.1.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - CONSOLIDAÇÃO','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.2.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTRA OFSS','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.3.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - UNIÃO','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.4.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - ESTADO','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.5.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - MUNICÍPIO','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.0.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.1.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - CONSOLIDAÇÃO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.2.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - INTRA OFSS','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.3.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - UNIÃO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.4.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - ESTADO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.5.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - MUNICÍPIO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.0.0.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo e do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício em obediência ao regime de competência.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.1.0.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.1.1.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS - CONSOLIDAÇÃO','Registra as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.2.0.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.2.1.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS - CONSOLIDAÇÃO','Registra as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.0.0.00.00.00.00.00','RESERVAS DE LUCROS','Compreende as reservas constituídas com parcelas do lucro liquido das entidades para finalidades especificas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.0.00.00.00.00.00','RESERVA LEGAL','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.1.00.00.00.00.00','RESERVA LEGAL- CONSOLIDAÇÃO','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.2.00.00.00.00.00','RESERVA LEGAL- INTRA OFSS','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.3.00.00.00.00.00','RESERVA LEGAL- INTER OFSS - UNIÃO','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.4.00.00.00.00.00','RESERVA LEGAL- INTER OFSS - ESTADO','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.5.00.00.00.00.00','RESERVA LEGAL- INTER OFSS - MUNICÍPIO','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.0.00.00.00.00.00','RESERVAS ESTATUTÁRIAS','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.1.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - CONSOLIDAÇÃO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.2.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - INTRA OFSS','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.3.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - UNIÃO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.4.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - ESTADO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.5.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - MUNICÍPIO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.0.00.00.00.00.00','RESERVA PARA CONTINGENCIAS','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.1.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - CONSOLIDAÇÃO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.2.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - INTRA OFSS','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.3.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - UNIÃO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.4.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - ESTADO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.5.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - MUNICÍPIO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.0.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.1.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - CONSOLIDAÇÃO','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.2.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - INTRA OFSS','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.3.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - UNIÃO','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.4.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - ESTADO','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.5.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - MUNICÍPIO','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.0.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.1.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - CONSOLIDAÇÃO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.2.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTRA OFSS','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.3.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS - UNIÃO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.4.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS -ESTADO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.5.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS - MUNICÍPIO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.0.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.1.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- CONSOLIDAÇÃO','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.2.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- INTRA OFSS','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.3.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - UNIÃO','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.4.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - ESTADO','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.5.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - MUNICÍPIO','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.0.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES','Compreende a parcela do lucro líquido do exercício decorrente do prêmio na emissão de debêntures.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.1.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- CONSOLIDAÇÃO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.2.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTRA OFSS','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.3.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - UNIÃO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.4.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - ESTADO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.5.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - MUNICÍPIO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.0.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.1.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - CONSOLIDAÇÃO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.2.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - INTRA OFSS','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.3.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - UNIÃO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.4.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - ESTADO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.5.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - MUNICÍPIO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.0.0.00.00.00.00.00','DEMAIS RESERVAS','Compreende as demais reservas, não classificadas como reservas de capital ou de lucro, inclusive aquelas que terão seus saldos realizados por terem sido extintas pela legislação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.0.00.00.00.00.00','RESERVA DE REAVALIAÇÃO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - CONSOLIDAÇÃO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.01.00.00.00.00','REAVALIACAO DE BENS IMOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS  BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES,  QUANDO  O  CONTROLE FOR POR INSCRICAO GENERICA DO TIPO INDIVIDUALIZACAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.03.00.00.00.00','REAVALIACAO DE BENS MOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS  BENS MOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.04.00.00.00.00','REAVALIAÇÃO DE BENS INTANGIVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS  BENS INTANGIVEIS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES, QUANDO O CONTROLE FOR POR CGC, CPF, IG OU UG.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.05.00.00.00.00','REAVALIAÇÃO DE ATIVOS DE COLIGADAS E CONTROLADAS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, DAS REAVALIAÇÕES EFETUADAS NOS ATIVOS DAS COLIGADAS E CONTROLADAS AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.98.00.00.00.00','OUTRAS RESERVAS DE REAVALIACAO','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS  A  OUTROS  BENS DA ENTIDADE, DECORRENTES DE REAVALIACOES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.99.00.00.00.00','(-) TRIBUTOS SOBRE A RESERVA DE REAVALIACAO','REGISTRA O VALOR DA CARGA TRIBUTARIA (IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL) DEVIDA SOBRE A FUTURA REALIZACAO DE ATIVO QUE A GERARAM (PARA EFEITO DE CONTROLE FISCAL).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - INTRA OFSS','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.01.00.00.00.00','REAVALIAÇÃO DE BENS IMOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS  BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES,  QUANDO  O  CONTROLE FOR POR INSCRICAO GENERICA DO TIPO INDIVIDUALIZACAO DE IMOVEIS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.03.00.00.00.00','REAVALIAÇÃO DE BENS MOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS  BENS MOVEIS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.04.00.00.00.00','REAVALIAÇÃO DE BENS INTANGIVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS  BENS INTANGIVEIS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES, QUANDO O CONTROLE FOR POR CGC, CPF, IG OU UG.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.05.00.00.00.00','REAVALIAÇÃO DE ATIVOS DE COLIGADAS E CONTROLADAS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, DAS REAVALIAÇÕES EFETUADAS NOS ATIVOS DAS COLIGADAS E CONTROLADAS AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.98.00.00.00.00','OUTRAS RESERVAS DE REAVALIAÇÃO','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS  A  OUTROS  BENS DA ENTIDADE, DECORRENTES DE REAVALIAÇÕES.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.99.00.00.00.00','(-) TRIBUTOS SOBRE A RESERVA DE REAVALIAÇÃO','REGISTRA O VALOR DA CARGA TRIBUTÁRIA (IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL) DEVIDA SOBRE A FUTURA REALIZACAO DE ATIVO QUE A GERARAM (PARA EFEITO DE CONTROLE FISCAL).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.3.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - UNIÃO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.4.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - ESTADO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.5.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - MUNICÍPIO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.0.00.00.00.00.00','OUTRAS RESERVAS','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.1.00.00.00.00.00','OUTRAS RESERVAS - CONSOLIDAÇÃO','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.1.01.00.00.00.00','RESERVAS TECNICAS','REGISTRA O VALOR DO PATRIMONIO LIQUIDO DA RESERVA ORIGINARIA DE UM EXCEDENTE QUE NAO PODE SER CONSIDERADO COMO LUCRO, DEVENDO SER  GUARDADO COMO GARANTIA PARA USO FUTURO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.1.01.01.00.00.00','RESERVAS PARA SINISTROS IMOBILIARIOS','REGISTRA  O VALOR DO PATRIMONIO LIQUIDO DA  RESERVA ORIGINARIA DA CONTRIBUICAO DE SEGURADOS (PREMIOS) PARA A COBERTURA, QUANDO DA  OCORRENCIA DE SINISTRO IMOBILIARIO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.1.01.02.00.00.00','RESERVA DE GARANTIA','REGISTRA O VALOR NO PATRIMONIO LIQUIDO DA RESERVA ORIGINARIA DE   CONTRIBUICOES COMO FORMA DE GARANTIR O DIREITO DO SERVIDOR OU DA  EMPRESA EM ACONTECIMENTOS EVENTUAIS QUE VENHAM A OCORRER.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.1.01.03.00.00.00','RESERVAS ADMINISTRATIVAS','REGISTRA O VALOR DAS RESERVAS CONSTITUIDAS COM AS SOBRAS  DO  CUSTEIO ADMINISTRATIVO.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.2.00.00.00.00.00','OUTRAS RESERVAS - INTRA OFSS','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.3.00.00.00.00.00','OUTRAS RESERVAS - INTER OFSS - UNIÃO','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.4.00.00.00.00.00','OUTRAS RESERVAS - INTER OFSS - ESTADO','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.5.00.00.00.00.00','OUTRAS RESERVAS - INTER OFSS - MUNICÍPIO','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.0.0.00.00.00.00.00','RESULTADOS ACUMULADOS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas e os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.0.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - CONSOLIDAÇÃO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTRA OFSS','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - UNIÃO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - ESTADO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - MUNICÍPIO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.0.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - CONSOLIDAÇÃO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.02.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.03.00.00.00.00','AJUSTES DE EXERCÍCIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Compreende o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTRA OFSS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.02.00.00.00.00','LUCROS EPREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - UNIÃO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.02.00.00.00.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - ESTADO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.02.00.00.00.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - MUNICÍPIO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.02.00.00.00.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.0.0.00.00.00.00.00','(-) AÇÕES / COTAS EM TESOURARIA','Compreende o valor das ações ou cotas da entidade que foram adquiridas pela própria entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.0.00.00.00.00.00','(-) AÇÕES EM TESOURARIA','Compreende o valor das ações da entidade que foram adquiridas pela própria entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.1.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - CONSOLIDAÇÃO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.2.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - INTRA OFSS','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.3.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - UNIÃO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.4.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - ESTADO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.5.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - MUNICÍPIO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.0.00.00.00.00.00','(-) COTAS EM TESOURARIA','Compreende o valor das cotas da entidade que foram adquiridas pela própria entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.1.00.00.00.00.00','(-) COTAS EM TESOURARIA - CONSOLIDAÇÃO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.2.00.00.00.00.00','(-) COTAS EM TESOURARIA - INTRA OFSS','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.3.00.00.00.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - UNIÃO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.4.00.00.00.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - ESTADO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.5.00.00.00.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - MUNICÍPIO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.0.0.0.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA','Compreende o decréscimo no beneficio econômico durante o período contábil sob a forma de saída de recurso ou redução de ativo ou incremento em passivo, que resulte em decréscimo do patrimônio liquido e que não seja proveniente de distribuição aos proprietários da entidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.0.0.0.00.00.00.00.00','PESSOAL E ENCARGOS','Compreende a remuneração do pessoal ativo civil ou militar, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos, soldos e vantagens pecuniárias fixas ou variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo, emprego ou função de confiança no setor público. Compreende ainda, obrigações trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos órgãos e demais entidades do setor público, contribuições a entidades fechadas de previdência e benefícios eventuais a pessoal civil e militar, destacados os custos de pessoal e encargos inerentes as mercadorias e produtos vendidos e serviços prestados.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.0.0.00.00.00.00.00','REMUNERAÇÃO A PESSOAL','Compreende a remuneração do pessoal ativo civil ou militar, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos, soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo, emprego ou função de confiança no setor público, bem como as com contratos de terceirização de mão de obra que se refiram à substituição de servidores e empregados públicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.0.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO RPPS','Compreende a remuneração do pessoal ativo civil abrangidos pelo RPPS, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO RPPS  - CONSOLIDAÇÃO','Compreende a remuneração do pessoal ativo civil abrangidos pelo RPPS, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.00.00.00.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RPPS','COMPREENDE O SOMATORIO DOS VALORES COM VENCIMENTOS  E VANTAGENS FIXAS DO PESSOAL CIVIL DO TIPO: GRATIFICACAO, REPRESENTACAO, ADICIONAL INSALUBRIDADE, FERIAS, 13 SALARIO, LICENCA-PREMIO, ABONO PECUNIARIO, ADICIONAL NOTURNO, ETC.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.02.00.00.00.00','OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL - RPPS','COMPREENDE O VALOR DAS APROPRIACOES DAS AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL ABRANGIDOS PELO REGIME PROPRIO, RELACIONADAS AS ATIVIDADES DO CARGO OU FUNCAO DO SERVIDOR E CUJO PAGAMENTO SO SE REALIZA  EM CIRCUSTANCIAS ESPECIAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.03.00.00.00.00','SENTENCAS JUDICIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SENTENCAS JUDICIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.0.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO - RGPS','Compreende a remuneração do pessoal ativo civil abrangidos pelo RGPS, correspondente ao somatório das variações patrimoniais diminutivas com vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do emprego, inclusive os ocupantes de cargos em comissão não investidos em cargo efetivo, no setor público.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO - RGPS - CONSOLIDAÇÃO','Compreende a remuneração do pessoal ativo civil abrangidos pelo RGPS, correspondente ao somatório das variações patrimoniais diminutivas com vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do emprego, inclusive os ocupantes de cargos em comissão não investidos em cargo efetivo, no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.01.00.00.00.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS','REGISTRA O VALOR DAS APROPRIACOES DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM VENCIMENTOS  E VANTAGENS FIXAS DO PESSOAL CIVIL DO TIPO: GRATIFICACAO, REPRESENTACAO, ADICIONAL INSALUBRIDADE, FERIAS, 13 SALARIO, LICENCA-PREMIO, ABONO PECUNIARIO, ADICIONAL NOTURNO, ETC.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.02.00.00.00.00','OUTRAS VPD VARIAVEIS - PESSOAL CIVIL - RGPS','REGISTRA O VALOR DAS APROPRIACOES DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL ABRANGIDOS PELO REGIME GERAL, RELACIONADAS AS ATIVIDADES DO CARGO OU FUNCAO DO EMPREGADO E CUJO PAGAMENTO SO SE REALIZA  EM CIRCUSTANCIAS ESPECIAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.03.00.00.00.00','SENTENCAS JUDICIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SENTENCAS JUDICIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.04.00.00.00.00','CONTRATACAO POR TEMPO DETERMINADO','REGISTRA O VALOR DAS APROPRIACOES DE VARIACOES PATRIMONIAIS DIMINUTIVAS COM A CONTRATACAO DE PESSOAL POR TEMPO DETERMINADO PARA ATENDER A NECESSIDADE TEMPORARIA DE EXCEPCIONAL INTERESSE PUBLICO, DE ACORDO COM LEGISLACAO ESPECIFICA DE CADA ENTE DA FEDERACAO, INCLUSIVE OBRIGACOES PATRONAIS E OUTRAS DESPESAS VARIAVEIS, QUAND0 FOR O CASO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.3.0.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO MILITAR - ABRANGIDOS PELO REGIME PRÓPRIO DOS MILITARES','Compreende a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.3.1.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO MILITAR - ABRANGIDOS PELO REGIME PRÓPRIO DOS MILITARES - CONSOLIDAÇÃO','Compreende a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.0.0.00.00.00.00.00','ENCARGOS PATRONAIS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores e empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como contribuições a entidades fechadas de previdência e ainda outras contribuições patronais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.0.00.00.00.00.00','ENCARGOS PATRONAIS - RPPS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores públicos ativos, pertencentes aos órgãos e demais entidades do setor público.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.2.00.00.00.00.00','ENCARGOS PATRONAIS - RPPS - INTRA OFSS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores públicos ativos, pertencentes aos órgãos e demais entidades do setor público.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.2.01.00.00.00.00','CONTRIBUICAO PATRONAL PARA O RPPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.2.02.00.00.00.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.2.06.00.00.00.00','CONTRIBUIÇÃO PARA O PASEP SOBRE FOLHA DE PAGAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS  REALIZADAS COM A CONTRIBUIÇÃO PARA O PASEP SOBRE FOLHA DE PAGAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.2.99.00.00.00.00','OUTROS ENCARGOS PATRONAIS - RPPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RPPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.0.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investidos, em cargo efetivo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.1.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - CONSOLIDAÇÃO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.1.01.00.00.00.00','CONTRIBUICOES PREVIDENCIARIAS - INSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES QUE NAO PERTENCAM AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS AO INSS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.1.04.00.00.00.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.1.99.00.00.00.00','OUTROS ENCARGOS PATRONAIS - RGPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.2.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - INTRA OFSS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.3.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - UNIÃO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.3.01.00.00.00.00','CONTRIBUICOES PREVIDENCIARIAS - INSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES QUE NAO PERTENCAM AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS AO INSS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.3.04.00.00.00.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.3.99.00.00.00.00','OUTROS ENCARGOS PATRONAIS - RGPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.4.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - ESTADO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.5.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - MUNICÍPIO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investidos em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.3.0.00.00.00.00.00','ENCARGOS PATRONAIS - FGTS','Compreende os valores recolhidos mensalmente pelos empregadores, em conta bancaria vinculada do trabalhador no FGTS, correspondente a percentual definido em lei sobre a remuneração paga ou devida, no mês anterior, a cada trabalhador, incluídas na remuneração as parcelas de que tratam os artigos. 457 e 458 da CLT e a gratificação de natal a que se refere à lei nº 4.090, de 13 de julho de 1962, com as modificações da lei nº 4.749, de 12 de agosto de 1965. Entende-se por empregador a pessoa física ou a pessoa jurídica de direito privado ou de direito público, da administração pública direta, indireta ou fundacional de qualquer dos poderes, da União, dos estados, do distrito federal e dos municípios, que admitir trabalhadores a seu serviço, bem assim aquele que, regido por legislação especial, encontrar-se nessa condição ou figurar como fornecedor ou tomador de mão de obra, independente da responsabilidade solidaria e/ou subsidiaria a que eventualmente venha obrigar-se. Considera-se trabalhador toda pessoa física que prestar serviços a empregador, a locador ou tomador de mão de obra, excluídos os eventuais, os autônomos e os servidores públicos civis e militares sujeitos a regime jurídico próprio. O recolhimento do FGTS e obrigatório também nos casos de afastamento para prestação do serviço militar obrigatório e licença por acidente do trabalho. Não se incluem na remuneração, para os fins desta lei, as parcelas elencadas no § 9º do art. 28 da lei nº 8.212, de 24 de julho de 1991.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.3.1.00.00.00.00.00','ENCARGOS PATRONAIS - FGTS - CONSOLIDAÇÃO','Compreende os valores recolhidos mensalmente pelos empregadores, em conta bancaria vinculada do trabalhador no FGTS, correspondente a percentual definido em lei sobre a remuneração paga ou devida, no mês anterior, a cada trabalhador, incluídas na remuneração as parcelas de que tratam os artigos. 457 e 458 da CLT e a gratificação de natal a que se refere à lei nº 4.090, de 13 de julho de 1962, com as modificações da lei nº 4.749, de 12 de agosto de 1965. Entende-se por empregador a pessoa física ou a pessoa jurídica de direito privado ou de direito público, da administração pública direta, indireta ou fundacional de qualquer dos poderes, da União, dos estados, do distrito federal e dos municípios, que admitir trabalhadores a seu serviço, bem assim aquele que, regido por legislação especial, encontrar-se nessa condição ou figurar como fornecedor ou tomador de mão de obra, independente da responsabilidade solidaria e/ou subsidiaria a que eventualmente venha obrigar-se. Considera-se trabalhador toda pessoa física que prestar serviços a empregador, a locador ou tomador de mão de obra, excluídos os eventuais, os autônomos e os servidores públicos civis e militares sujeitos a regime jurídico próprio. O recolhimento do FGTS e obrigatório também nos casos de afastamento para prestação do serviço militar obrigatório e licença por acidente do trabalho. Não se incluem na remuneração, para os fins desta lei, as parcelas elencadas no § 9º do art. 28 da lei nº 8.212, de 24 de julho de 1991. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.3.1.01.00.00.00.00','FGTS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM OBRIGACOES RELATIVAS AO RECOLHIMENTO DO FGTS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.4.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS GERAIS','Compreende os encargos patronais relativos ao salário educação e as contribuições compulsórias dos empregadores sobre a folha de salários, destinados as entidades privadas de serviço social e de formação profissional, vinculadas ao sistema sindical, tais como SESI, SENAI, SESC e SENAC.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.4.1.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS GERAIS - CONSOLIDAÇÃO','Compreende os encargos patronais relativos ao salário educação e as contribuições compulsórias dos empregadores sobre a folha de salários, destinados as entidades privadas de serviço social e de formação profissional, vinculadas ao sistema sindical, tais como SESI, SENAI, SESC e SENAC. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.5.0.00.00.00.00.00','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA','Compreende o valor total das variações patrimoniais diminutivas relacionadas ao regime de previdência privada, de caráter complementar, organizado de forma autônoma em relação ao regime geral de previdência social, de caráter facultativo, baseado na constituição de reservas que garantam o benefício, nos termos do caput do art. 202 da constituição federal. Entende-se por entidades fechadas aquelas acessíveis, na forma regulamentada pelo órgão regulador e fiscalizador, exclusivamente aos empregados de uma empresa ou grupo de empresas e aos servidores da União, dos estados, do distrito federal e dos municípios, entes denominados patrocinadores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.5.1.00.00.00.00.00','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas relacionadas ao regime de previdência privada, de caráter complementar, organizado de forma autônoma em relação ao regime geral de previdência social, de caráter facultativo, baseado na constituição de reservas que garantam o benefício, nos termos do caput do art. 202 da constituição federal. Entende-se por entidades fechadas aquelas acessíveis, na forma regulamentada pelo órgão regulador e fiscalizador, exclusivamente aos empregados de uma empresa ou grupo de empresas e aos servidores da União, dos estados, do distrito federal e dos municípios, entes denominados patrocinadores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.5.1.01.00.00.00.00','COMPLEMENTACAO DE PREVIDENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   COM CONTRIBUICOES DE RESPONSABILIDADE DAS ENTIDADES PATROCINADORAS PARA ATENDER PLANO DE PREVIDENCIA COMPLEMENTAR, ADMINISTRADO POR SUAS INSTITUICOES DE SEGURIDADE SOCIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.5.1.03.00.00.00.00','CONTRIBUIÇÃO PATRONAL PREVIDENCIA PRIVADA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   COM CONTRIBUICAO PATRONAL, DEVIDA A ENTIDADES DE PREVIDENCIA PRIVADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.5.1.99.00.00.00.00','OUTRAS CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   COM CONTRIBUICOES A ENTIDADES PRIVADAS NAO ENQUADRADAS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.0.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.1.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - CONSOLIDAÇÃO','Registra outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.2.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - INTRA OFSS','Registra outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.2.01.00.00.00.00','OBRIGACOES PATRONAIS PARA O ATENDIMENTO A SAUDE E A ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ENCARGOS QUE A ADMINISTRAÇÃO TEM PELA SUA CONDIÇÃO DE EMPREGADORA, E RESULTANTES DE PAGAMENTO DE PESSOAL ATIVO, INATIVO E PENSIONISTAS,COM OBRIGACOES PATRONAIS PARA O ATENDIMENTO A SAUDE E A ASSISTENCIA SOCIAL DO SERVIDOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.3.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - UNIÃO','Registra outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.4.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - ESTADO','Registra outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.5.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - MUNICÍPIO','Registra outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.0.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal civil e militar , tais como para o pessoal civil: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxilia-alimentação, auxilia-transporte bem como outros decorrentes de acordo ou convenção coletiva no que se refere aos empregados públicos.  Para os militares: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda-de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo as despesas com vencimentos, soldos e quaisquer outras vantagens pecuniárias, bem como as despesas relacionadas aos benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL - RPPS','Compreende o valor total das variações patrimoniais diminutivas com benefícios a servidor público, tais como: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxílio-transporte,auxílio-alimentação e outros benefícios relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias permanentes, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizados e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.00.00.00.00.00','BENEFÍCIOS A PESSOAL - RPPS - CONSOLIDAÇÃO','Compreende o valor total das  variações patrimoniais diminutivas com benefícios a servidor público, tais como: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxílio-transporte,auxílio-alimentação e outros benefícios relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias permanentes, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.01.00.00.00.00','AUXILIO ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE  DESPESAS COM AUXÍLIO-ALIMENTAÇÃO PAGO/FORNECIDO AOS SERVIDORES OU EMPREGADOS DA ADMINISTRAÇÃO PÚBLICA DIRETA E INDIRETA., EM PECUNIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.02.00.00.00.00','AUXILIO TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   COM AUXILIO-TRANSPORTE PAGAS EM FORMA DE PECUNIA DIRETAMENTE AOS SERVIDORES, DESTINADO AO CUSTEIO PARCIAL DAS DESPESAS REALIZADAS COM TRANSPORTE COLETIVO MUNICIPAL INTERMUNICIPAL OU INTERESTADUAL NOS DESLOCAMENTOS DE SUAS RESIDENCIAS PARA OS LOCAIS DE TRABALHO E VICE-VERSA, OU TRABALHO-TRABALHO NOS CASOS DE ACUMULACAO LICITA DE CARGOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.04.00.00.00.00','AJUDA DE CUSTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AJUDA DE CUSTO DE PESSOAL CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.05.00.00.00.00','PLANO DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE  DESPESAS COM PLANO DE SAUDE AO SERVIDOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.06.00.00.00.00','AUXILIO CRECHE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-CRECHE, DEVIDO A SERVIDOR PUBLICO, DECORRENTE DE RESSARCIMENTO DE GASTOS COM A EDUCACAO PRE-ESCOLAR DE SEUS DEPENDENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.99.00.00.00.00','OUTROS BENEFICIOS A PESSOAL - RPPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM OUTROS BENEFICIOS A PESSOAL - RPPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL - RGPS','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos aos empregados públicos, e ainda outros relativos a acordo ou convenção coletiva. Estão excluídos deste grupo os vencimentos e quaisquer outras vantagens pecuniárias, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.00.00.00.00.00','BENEFÍCIOS A PESSOAL - RGPS - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos aos empregados públicos, e ainda outros relativos a acordo ou convenção coletiva. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídos ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizados e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.01.00.00.00.00','AUXILIO ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE  DESPESAS COM AUXÍLIO-ALIMENTAÇÃO PAGO/FORNECIDO AOS SERVIDORES OU EMPREGADOS DA ADMINISTRAÇÃO PÚBLICA DIRETA E INDIRETA., EM PECUNIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.02.00.00.00.00','AUXILIO TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   COM AUXILIO-TRANSPORTE PAGAS EM FORMA DE PECUNIA DIRETAMENTE AOS SERVIDORES, DESTINADO AO CUSTEIO PARCIAL DAS DESPESAS REALIZADAS COM TRANSPORTE COLETIVO MUNICIPAL INTERMUNICIPAL OU INTERESTADUAL NOS DESLOCAMENTOS DE SUAS RESIDENCIAS PARA OS LOCAIS DE TRABALHO E VICE-VERSA, OU TRABALHO-TRABALHO NOS CASOS DE ACUMULACAO LICITA DE CARGOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.04.00.00.00.00','AJUDA DE CUSTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS A TITULO DE AJUDA DE CUSTO DE PESSOAL CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.05.00.00.00.00','PLANO DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE  DESPESAS COM PLANO DE SAUDE AO SERVIDOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.06.00.00.00.00','AUXILIO CRECHE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   COM AUXILIO-CRECHE, DEVIDO A SERVIDOR PUBLICO, DECORRENTE DE RESSARCIMENTO DE GASTOS COM A EDUCACAO PRE-ESCOLAR DE SEUS DEPENDENTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.99.00.00.00.00','OUTROS BENEFICIOS A PESSOAL - RGPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM OUTROS BENEFICIOS A PESSOAL - RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.3.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL - MILITAR','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal militar, tais como: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda-de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídos deste grupo os soldos e quaisquer outras vantagens pecuniárias permanentes, bem como as os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.3.1.00.00.00.00.00','BENEFÍCIOS A PESSOAL - MILITAR - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal militar, tais como: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda-de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídos deste grupo os soldos e quaisquer outras vantagens pecuniárias permanentes, bem como as os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.0.0.00.00.00.00.00','CUSTO DE PESSOAL E ENCARGOS','Compreende a variação patrimonial diminutiva relativa à pessoal e encargos utilizados na produção de bens ou serviços, sendo registrada apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.1.0.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - PESSOAL E ENCARGOS','Compreende as variações patrimoniais diminutivas relativas à pessoal e encargos apropriadas às mercadorias, sendo registradas apenas no momento da venda destas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.1.1.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a pessoal e encargos apropriadas as mercadorias, sendo registradas apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.2.0.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS - PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas relativas à pessoal e encargos, utilizadas na produção de bens, sendo registradas apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.2.1.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS - PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas à pessoal e encargos, utilizadas na produção de bens, sendo registradas apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.3.0.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS - PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas relativas a pessoal e encargos, utilizadas na produção de serviços, sendo registradas apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.3.1.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS - PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas a pessoal e encargos, utilizadas na produção de serviços, sendo registrada apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores, tais como as indenizações e restituições trabalhistas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.0.00.00.00.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS','Compreende o valor total com variações patrimoniais diminutivas resultante do pagamento efetuado a servidores públicos civis e empregados de entidades integrantes da administração pública, inclusive ferias e aviso prévio indenizados, multas e contribuições incidentes sobre os depósitos do fundo de garantia por tempo de serviço, etc., em função da perda da condição de servidor ou empregado, podendo ser em decorrência da participação em programa de desligamento voluntario.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.1.00.00.00.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS - CONSOLIDAÇÃO','Compreende o valor total com variações patrimoniais diminutivas resultante do pagamento efetuado a servidores públicos civis e empregados de entidades integrantes da administração pública, inclusive ferias e aviso prévio indenizados, multas e contribuições incidentes sobre os depósitos do fundo de garantia por tempo de serviço, etc., em função da perda da condição de servidor ou empregado, podendo ser em decorrência da participação em programa de desligamento voluntario. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.1.01.00.00.00.00','INDENIZACOES E RESTITUICOES TRABALHISTAS - ATIVO CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REFERENTE A INDENIZACOES E  RESTITUICOES TRABALHISTAS DO PESSOAL ATIVO CIVIL, INCLUSIVE AS DESPESAS COM PROGRAMA DE DESLIGAMENTO VOLUNTARIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.1.03.00.00.00.00','INDENIZACOES E RESTITUICOES TRABALHISTAS - INATIVO CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REFERENTE A INDENIZACOES E RESTITUICOES TRABALHISTAS DO PESSOAL  INATIVO CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.1.06.00.00.00.00','INDENIZACOES E RESTITUICOES TRABALHISTAS - PENSIONISTA CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESDE DESPESAS REFERENTE A INDENIZACOES E  RESTITUICOES TRABALHISTAS DO PESSOAL PENSIONISTA CIVIL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.1.99.00.00.00.00','DIVERSAS INDENIZACOES TRABALHISTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   DE INDENIZACOES TRABALHISTA QUE NAO SE PROCESSARAM NA EPOCA PROPRIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.2.0.00.00.00.00.00','PESSOAL REQUISITADO DE OUTROS ORGAOS','Compreende as variações patrimoniais diminutivas  com pessoal requisitado de outros órgãos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.2.1.00.00.00.00.00','PESSOAL REQUISITADO DE OUTROS ORGAOS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas  com pessoal requisitado de outros órgãos.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.9.0.00.00.00.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.9.1.00.00.00.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.0.0.0.00.00.00.00.00','BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS','Compreendem as variações patrimoniais diminutivas relativas às aposentadorias, pensões, reformas, reserva remunerada e outros benefícios previdenciários de caráter contributivo, do regime próprio da previdência social - RPPS e do regime geral da previdência social - RGPS, bem como as ações de assistência social, que são políticas de seguridade social não contributiva, visando ao enfrentamento da pobreza, a garantia dos mínimos sociais, ao provimento de condições para atender contingencias sociais e a universalização dos direitos sociais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.0.0.00.00.00.00.00','APOSENTADORIAS E REFORMAS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.0.00.00.00.00.00','APOSENTADORIAS - RPPS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.1.00.00.00.00.00','APOSENTADORIAS - RPPS - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.1.01.00.00.00.00','PROVENTOS - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM PROVENTOS DE  APOSENTADORIAS PESSOAL CIVIL REGIDOS PELO RPPS APROVADA PELO TRIBUNAL DE CONTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.1.06.00.00.00.00','13 SALARIO - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS A TITULO DE 13 SALARIO - PESSOAL CIVIL - RPPS - APOSENTADORIAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.1.99.00.00.00.00','OUTRAS APOSENTADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS APOSENTADORIAS NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.2.0.00.00.00.00.00','APOSENTADORIAS - RGPS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RGPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.2.1.00.00.00.00.00','APOSENTADORIAS - RGPS - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidos pelo RGPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.3.0.00.00.00.00.00','RESERVA REMUNERADA E REFORMAS - MILITAR','Compreende as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.3.1.00.00.00.00.00','RESERVA REMUNERADA E REFORMAS - MILITAR - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.9.0.00.00.00.00.00','OUTRAS APOSENTADORIAS','Compreende as variações patrimoniais diminutivas provenientes de outras aposentadorias','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.9.1.00.00.00.00.00','OUTRAS APOSENTADORIAS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de outras aposentadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.0.0.00.00.00.00.00','PENSÕES','Compreendem os benefícios da previdência social que garantem uma renda aos dependentes do segurado falecido.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.1.0.00.00.00.00.00','PENSÕES - RPPS','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, pelo regime próprio da previdência social - RPPS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.1.1.00.00.00.00.00','PENSÕES - RPPS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, pelo regime próprio da previdência social - RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.1.1.01.00.00.00.00','PENSOES CIVIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM  PENSOES ORIGINARIAS DE PESSOAL CIVIL - RPPS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.1.1.02.00.00.00.00','13 SALARIO - PESSOAL CIVIL - PENSIONISTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS A TITULO DE 13 SALARIO - PESSOAL MILITAR - PENSIONISTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.1.1.99.00.00.00.00','OUTRAS PENSOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS   REALIZADAS COM OUTRAS PENSOES NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.2.0.00.00.00.00.00','PENSÕES - RGPS','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, regidos pelo regime geral da previdência social -RGPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.2.1.00.00.00.00.00','PENSÕES - RGPS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, regidos pelo regime geral da previdência social - RGPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.3.0.00.00.00.00.00','PENSÕES - MILITAR','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos militares, após seu óbito, regidos pelo regime próprio.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.3.1.00.00.00.00.00','PENSÕES - MILITAR - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos militares, após seu óbito, regidos pelo regime próprio. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.9.0.00.00.00.00.00','OUTRAS PENSÕES','Compreende as variações patrimoniais diminutivas provenientes de outras pensões.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.9.1.00.00.00.00.00','OUTRAS PENSÕES - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de outras pensões. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.0.0.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','Compreendem os benefícios de prestação continuada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.1.0.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO','Compreendem os benefícios de prestação continuada ao idoso e renda mensal vitalícia por idade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.1.1.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada e renda mensal vitalícia por idade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.2.0.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA','Compreendem os benefícios de prestação continuada ao portador de deficiência e renda mensal vitalícia - invalidez','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.2.1.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada ao portador de deficiência e renda mensal vitalícia - invalidez. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.9.0.00.00.00.00.00','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','Compreendem outros benefícios de prestação continuada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.9.1.00.00.00.00.00','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA - CONSOLIDAÇÃO','Registra outros benefícios de prestação continuada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.0.0.00.00.00.00.00','BENEFÍCIOS EVENTUAIS','Compreendem as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de nascimento, morte, situações de vulnerabilidade temporária e de calamidade pública. As provisões relativas a programas, projetos, serviços e benefícios diretamente vinculados ao campo da saúde, educação, integração nacional e das demais políticas setoriais não se incluem na modalidade de benefícios eventuais da assistência social.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.1.0.00.00.00.00.00','AUXÍLIO POR NATALIDADE','Compreende o beneficio eventual que visa o pagamento de auxílio por natalidade as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.1.1.00.00.00.00.00','AUXÍLIO POR NATALIDADE - CONSOLIDAÇÃO','Registra o beneficio eventual que visa o pagamento de auxílio por natalidade as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.2.0.00.00.00.00.00','AUXÍLIO POR MORTE','Compreende o beneficio eventual que visa o pagamento de auxílio por morte as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.2.1.00.00.00.00.00','AUXÍLIO POR MORTE - CONSOLIDAÇÃO','Registra o beneficio eventual que visa o pagamento de auxílio por morte as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.3.0.00.00.00.00.00','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORÁRIA','Compreende as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de situações de vulnerabilidade temporária, com prioridade para a criança, a família, o idoso, a pessoa portadora de deficiência, a gestante e a nutriz.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.3.1.00.00.00.00.00','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORÁRIA - CONSOLIDAÇÃO','Registra as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de situações de vulnerabilidade temporária, com prioridade para a criança, a família, o idoso, a pessoa portadora de deficiência, a gestante e a nutriz. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.4.0.00.00.00.00.00','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA','Compreendem os benefícios para atendimento de vitimas de calamidade pública, de modo a assegurar lhes a sobrevivência e a reconstrução de sua autonomia. Entende-se se por estado de calamidade pública o reconhecimento pelo poder público de situação anormal, advinda de baixas ou altas temperaturas, tempestades, enchentes, inversão térmica, desabamentos, incêndios, epidemias, causando sérios danos à comunidade afetada, inclusive a incolumidade ou a vida de seus integrantes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.4.1.00.00.00.00.00','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA - COSOLIDAÇÃO','Compreendem os benefícios para atendimento de vitimas de calamidade pública, de modo a assegurar - lhes a sobrevivência e a reconstrução de sua autonomia. Entende-se por estado de calamidade pública o reconhecimento pelo poder público de situação anormal, advinda de baixas ou altas temperaturas, tempestades, enchentes, inversão térmica, desabamentos, incêndios, epidemias, causando sérios danos à comunidade afetada, inclusive a incolumidade ou a vida de seus integrantes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.9.0.00.00.00.00.00','OUTROS BENEFÍCIOS EVENTUAIS','Compreende a variação patrimonial diminutiva proveniente de outros benefícios eventuais','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.9.1.00.00.00.00.00','OUTROS BENEFÍCIOS EVENTUAIS - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva proveniente de outros benefícios eventuais.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.5.0.0.00.00.00.00.00','POLÍTICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA','Compreende as políticas públicas que visem contribuir para a redução da fome, da pobreza, da desigualdade e de outras formas de privação vividas pelas famílias mais excluídas, considerando três dimensões: o alivio imediato da pobreza, por meio da transferência de renda diretamente as famílias pobres e extremamente pobres; a contribuição para a redução da pobreza da geração seguinte, por meio do reforço do direito de acesso aos serviços de saúde e de educação, com o cumprimento das condicionalidades nestas áreas; e a articulação de ações complementares, de forma a desenvolver as capacidades das famílias beneficiárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.5.0.1.00.00.00.00.00','POLÍTICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA - CONSOLIDAÇÃO','Compreende as políticas públicas que visem contribuir para a redução da fome, da pobreza, da desigualdade e de outras formas de privação vividas pelas famílias mais excluídas, considerando três dimensões: o alivio imediato da pobreza, por meio da transferência de renda diretamente as famílias pobres e extremamente pobres; a contribuição para a redução da pobreza da geração seguinte, por meio do reforço do direito de acesso aos serviços de saúde e de educação, com o cumprimento das condicionalidades nestas áreas; e a articulação de ações complementares, de forma a desenvolver as capacidades das famílias beneficiarias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.0.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários ou assistenciais, não abrangidas nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RPPS, não abrangidas nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RPPS, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.05.00.00.00.00','AUXILIO RECLUSAO ATIVO CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXILIO-RECLUSAO PAGO COM RECURSOS DO TESOURO DO MUNICIPIO OU COM RECURSOS DO RPPS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.10.00.00.00.00','AUXILIO-DOENCA','REGISTRA AS  VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-DOENCA, DEVIDO AO SEGURADO QUE  FICAR INCAPACITADO PARA O TRABALHO','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.11.00.00.00.00','SALARIO MATERNIDADE','REGISTRA AS  VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-MATERNIDADE, DEVIDO A SEGURADA GESTANTE, NA FORMA DA LEI, DURANTE O PERIODO DE LICENCA GESTANTE PREVISTO EM LEI.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.12.00.00.00.00','SALARIO-FAMILIA','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO FAMILIA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.99.00.00.00.00','OUTROS BENEFICIOS PREVIDENCIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTROS BENEFICIOS PREVIDENCIARIOS NÃO PREVISTOS NOS ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.2.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RGPS, não abrangidas nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.2.1.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RGPS, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.3.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do regime próprio dos militares, não abrangidas nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.3.1.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do regime próprio dos militares, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','Compreende as variações patrimoniais diminutivas provenientes de outros benefícios previdenciários e assistenciais','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de outros benefícios previdenciários e assistenciais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.01.00.00.00.00','AUXILIO FUNERAL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO DEVIDO A FAMILIA DO SERVIDOR FALECIDO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.02.00.00.00.00','AUXILIO NATALIDADE','REGISTRA O VALOR DAS  VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE,  DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR  MOTIVO DE NASCIMENTO DE FILHO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.03.00.00.00.00','AUXILIO RECLUSAO','REGISTRA O VALOR DAS  VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR, AFASTADO POR MOTIVO DE PRISAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.04.00.00.00.00','ASSISTENCIA PRE-ESCOLAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ASSISTENCIA PRE-ESCOLAR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.05.00.00.00.00','AUXILIO INVALIDEZ','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-INVALIDEZ.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.06.00.00.00.00','CONTRIBUICAO DA ENTIDADE PARA O ATENDIMENTO A SAUDE DO SERVIDOR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM A  CONTRIBUICAO DA ENTIDADE PARA O ATENDIMENTO A SAUDE DO SERVIDOR. POR EXEMPLO: IPE E UNIMED.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.0.0.0.00.00.00.00.00','USO DE BENS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende o somatório das variações patrimoniais diminutivas com manutenção e operação da maquina pública, exceto despesas com pessoal e encargos que serão registradas em grupo específico (despesas de pessoal e encargos). Compreende: diárias, material de consumo, material de distribuição gratuita, passagens e despesas com locomoção, serviços de terceiros, arrendamento mercantil operacional, aluguel, depreciação, amortização, exaustão, entre outras.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.0.0.00.00.00.00.00','USO DE MATERIAL DE CONSUMO','Compreende as variações patrimoniais diminutivas provenientes da distribuição do material de consumo. Um material é considerado de consumo quando for de duração inferior a dois anos, frágil, perecível, incorporável, transformável ou cuja finalidade seja para consumo imediato ou para reposição.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.0.00.00.00.00.00','CONSUMO DE MATERIAL','Compreende as variações patrimoniais diminutivas provenientes de requisição de material de consumo para uso interno.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.00.00.00.00.00','CONSUMO DE MATERIAL - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de requisição de material de consumo para uso interno.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.01.00.00.00.00','COMBUSTIVEIS E LUBRIFICANTES AUTOMOTIVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE  COMBUSTIVEIS PARA MOTORES A  COMBUSTAO INTERNA DE VEICULOS RODOVIARIOS, TRATORES EM GERAL, EMBARCACOES  DIVERSAS E GRUPOS GERADORES ESTACIONADOS OU TRANSPORTAVEIS, E TODOS OS  OLEOS LUBRIFICANTES DESTINADOS AOS SISTEMAS HIDRAULICOS, HIDRAMATICOS,  DE CAIXA DE TRANSMISSAO DE FORCA E GRAXAS GRAFITADAS PARA ALTAS E BAIXAS TEMPERATURAS. ADITIVOS - ALCOOL HIDRATADO - FLUIDO PARA AMORTECEDOR - FLUIDO PARA  TRANSMISSAO HIDRAULICA - GASOLINA - GRAXAS - OLEO DIESEL - OLEO PARA  CARTER - OLEO PARA FREIO HIDRAULICO E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.02.00.00.00.00','COMBUSTIVEIS E LUBRIFICANTES DE AVIACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COMBUSTIVEIS E LUBRIFICANTES  DESTINADOS A QUALQUER TIPO DE AERONAVE. ADITIVOS - GASOLINA - GRAXAS - OLEOS E FLUIDOS EM GERAL - QUEROSENE  E  OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.03.00.00.00.00','COMBUSTIVEIS E LUBRIFICANTES PARA OUTRAS FINALIDADES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COMBUSTIVEIS E LUBRIFICANTES PARA  OUTRAS FINALIDADES QUE NAO SE ENQUADRAM EM ITENS ANTERIORES. CARBURETO - CARVAO MINERAL - CARVAO VEGETAL - LENHA - QUEROSENE COMUM - COMBUSTIVEIS E LUBRIFICANTES DE USO FERROVIARIO E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.04.00.00.00.00','GAS E OUTROS MATERIAIS ENGARRAFADOS','REGISTRA  AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE GAS DE USO INDUSTRIAL,  DE TRATAMENTO DE AGUA, DE ILUMINACAO, DE USO MEDICO, BEM COMO GASES NOBRES PARA USO EM  LABORATORIO CIENTIFICO, TAIS COMO: ACETILENO - CARBONICO FREON  -  HELIO  -  HIDROGENIO  -  LIQUEFEITO DE PETROLEO - NITROGENIO - OXIGENIO E OUTROS. REGISTRA, AINDA, O VALOR DAS DESPESAS COM GAS, PO QUIMICO, AGUA  PRESSURIZADA E OUTROS MATERIAIS UTILIZADOS NA RECARGA DE EXTINTORES DE INCENDIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.05.00.00.00.00','EXPLOSIVOS E MUNICOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE CARGAS DE PROJECAO  EM PECAS DE ARTILHARIA, MISSEIS GUIADOS E NAO GUIADOS, CAPSULAS OU  ESTOJOS PARA RECARGA E EXPLOSIVOS DE USO MILITAR E PARAMILITAR. BALAS E SIMILARES - ESTOPIM - EXPLOSIVOS, TAIS COMO: ARTEFATOS EXPLOSIVOS - ARTIGOS PIROTECNICOS - CAPSULAS DE DETONACAO - DINAMITE - ESPOLETA - FOGOS DE ARTIFICIO - GRANADA - POLVORA E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.06.00.00.00.00','ALIMENTOS PARA ANIMAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ALIMENTOS DESTINADOS A GADO  BOVINO, EQUINO, MUAR E BUFALINO, CAPRINOS, SUINOS, OVINOS,  AVES  DE  QUALQUER ESPECIE, COMO TAMBEM PARA ANIMAIS SILVESTRES EM CATIVEIRO (JARDINS ZOOLOGICOS OU LABORATORIOS) E OUTROS. ALFAFA - ALPISTE - CAPIM VERDE - FARELO - FARINHAS EM  GERAL  -  FUBA GROSSO - MILHO EM GRAO - RACAO BALANCEADA - SAL MINERAL - SUPLEMENTOS VITAMINICOS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.07.00.00.00.00','GENEROS DE ALIMENTACAO','REGISTRA  AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE GENEROS DE ALIMENTACAO AO NATURAL, BENEFICIADOS OU CONSERVADOS. ACUCAR - ADOCANTE - AGUA MINERAL - BEBIDAS - CAFE - CARNES EM GERAL - CEREAIS - CHAS - CONDIMENTOS - FRUTAS - GELO - LEGUMES - REFRIGERANTES - SUCOS - TEMPEROS - VERDURAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.08.00.00.00.00','ANIMAIS PARA PESQUISA E ABATE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ANIMAIS PARA PESQUISA E ABATE. INCLUEM-SE NESTA CLASSIFICACAO OS PEIXES E MARISCOS, TODAS AS ESPECIES DE MAMIFEROS, ABELHAS PARA ESTUDOS, PESQUISA E PRODUCAO DE MEL, BEM ASSIM QUALQUER OUTRO ANIMAL DESTINADO A ESTUDO GENETICO OU ALIMENTACAO. BOI - CABRITO - COBAIAS EM GERAL - MACACO - RATO - RA E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.09.00.00.00.00','MATERIAL FARMACOLOGICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MEDICAMENTOS OU COMPONENTES DESTINADOS A MANIPULACAO DE DROGAS MEDICAMENTOSAS. MEDICAMENTOS - SORO - VACINAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.10.00.00.00.00','MATERIAL ODONTOLOGICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA PACIENTES DA AREA ODONTOLOGICA, BEM COMO OS UTILIZADOS INDIRETAMENTE PELOS PROTETICOS NA CONFECCAO DE PROTESES DIVERSAS. AGULHAS - AMALGAMA - ANESTESICOS  -  BROCA  -  CIMENTO ODONTOLOGICO  -ESPATULA ODONTOLOGICA - FILMES PARA RAIO X  -  PLATINA  -  RESINAS ODONTOLOGICAS - SERINGAS  - SUGADOR E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.11.00.00.00.00','MATERIAL QUIMICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS ELEMENTOS OU COMPOSTOS QUIMICOS DESTINADOS AO FABRICO DE PRODUTOS QUIMICOS, ANALISES LABORATORIAIS, BEM COMO AQUELES DESTINADOS AO COMBATE DE PRAGAS OU EPIZOOTIAS. ACIDOS - INSETICIDAS - PRODUTOS QUIMICOS PARA  TRATAMENTO  DE  AGUA  -REAGENTES QUIMICOS - SAIS - SOLVENTES -  SUBSTANCIAS  UTILIZADAS  PARA COMBATER INSETOS, FUNGOS E BACTERIAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.12.00.00.00.00','MATERIAL DE COUDELARIA OU DE USO ZOOTECNICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS  NO  ARREAMENTO DE ANIMAIS DESTINADOS A MONTARIA, COM EXCECAO  DA  SELA,  COMO  TAMBEM AQUELES DESTINADOS AO ADESTRAMENTO DE CAES DE GUARDA OU  OUTRO ANIMAL DOMESTICO. ARGOLAS DE METAL - ARREAMENTO - BARRIGUEIRAS - BRIDOES -  CABRESTOS  - CINCHAS - CRAVOS - ESCOVAS PARA ANIMAIS  -  ESTRIBOS  -  FERRADURAS  - MANTAS DE PANO - MATERIAL PARA APICULTURA -  MATERIAL  DE FERRAGEM  E CONTENCAO DE ANIMAIS - PEITORAIS - RASPADEIRAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.13.00.00.00.00','MATERIAL DE CACA E PESCA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA CACA E PESCA DE ANIMAIS. ANZOIS - CORDOALHAS PARA REDES CHUMBADAS - ISCAS - LINHAS  DE  NYLON - MASCARAS PARA VISAO SUBMARINA - MOLINETES - NADADEIRAS  DE  BORRACHA - REDES - ROUPAS E ACESSORIOS PARA MERGULHO - VARAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.14.00.00.00.00','MATERIAL EDUCATIVO E ESPORTIVO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS CONSUMIDOS DIRETAMENTE NAS ATIVIDADES EDUCATIVAS E ESPORTIVAS DE CRIANCAS E ADULTOS. APITOS - BOLAS - BONES - BOTAS ESPECIAIS  -  BRINQUEDOS  EDUCATIVOS  - CALCOES  -  CAMISAS  DE  MALHA  -  CHUTEIRAS  -  CORDAS  -  ESTEIRAS -JOELHEIRAS - LUVAS - MATERIAIS  PEDAGOGICOS  -  MEIAS  -  OCULOS  PARA MOTOCICLISTAS - PATINS - QUIMONOS - RAQUETES - REDES PARA  PRATICA  DE ESPORTES - TENIS E SAPATILHAS - TORNOZELEIRAS - TOUCA PARA NATACAO   E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.15.00.00.00.00','MATERIAL PARA  FESTIVIDADES E HOMENAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO UTILIZADOS  EM FESTIVIDADES E HOMENAGENS, INCLUINDO ARTIGOS PARA DECORACAO E BUFFET. ARRANJOS E COROAS DE FLORES - BEBIDAS - DOCES - SALGADOS - PLACAS COMEMORATIVAS (EXCETO AS PLACAS PARA DISTRIBUICAO GRATUITA) E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.16.00.00.00.00','MATERIAL DE EXPEDIENTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS APLICADOS  DIRETAMENTE NOS TRABALHOS ADMINISTRATIVOS, NOS ESCRITORIOS PUBLICOS,  NOS  CENTROS DE  ESTUDOS E PESQUISAS, NAS ESCOLAS, NAS UNIVERSIDADES ETC.  AGENDA - ALFINETE DE ACO - ALMOFADA P/ CARIMBOS - APAGADOR - APONTADOR DE LAPIS - ARQUIVO P/ DISQUETE - BANDEJA PARA PAPEIS - BLOCO P/ RASCU-NHO - BOBINA PAPEL P/ CALCULADORAS - BORRACHA -  CADERNO  -  CANETA  -CAPA DE PROCESSO - CARIMBOS EM GERAL -  CARTOLINA  -  CLASSIFICADOR  -CLIPE - COLA - COLCHETE - CORRETIVO - ENVELOPE - ESPATULA - ESTENCIL -ESTILETE - EXTRATOR DE GRAMPOS - FITA ADESIVA - FITA P/ MAQUINA DE ES-CREVER E CALCULAR - GIZ - GOMA  ELASTICA  -  GRAFITE  -  GRAMPEADOR  -GRAMPOS - GUIA P/ ARQUIVO - GUIA DE ENDERECAMENTO POSTAL - IMPRESSOS E FORMULARIOS EM GERAL - INTERCALADOR P/ FICHARIO  -  LACRE  -  LAPIS  -LAPISEIRA - LIMPA TIPOS - LIVROS DE ATA, DE PONTO  E  DE  PROTOCOLO  -PAPEIS - PASTAS EM GERAL - PERCEVEJO - PERFURADOR - PINCA - PLACAS DE ACRILICO - PLASTICOS - PORTA-LAPIS - REGISTRADOR - REGUA - SELOS P/ CORRESPONDENCIA - TESOURA - TINTAS - TONER - TRANSPARENCIAS - ETIQUETAS E  OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.17.00.00.00.00','MATERIAL DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SUPRIMENTOS DE TI, INCLUSIVE PECAS  PARA REPOSICAO. CARTUCHOS DE TINTA - CAPAS PLASTICAS PROTETORAS PARA MICROS E IMPRES- SORAS - CD-ROM VIRGEM - DISQUETES - ETIQUETAS EM FORMULARIOS-CONTINUOS -LEITORA/SMARTCARD - MOUSE E TECLADO (REPOSICAO) - MOUSE PAD - PECAS E ACESSORIOS PARA COMPUTADORES E PERIFERICOS - RECARGA DE CARTUCHOS DE TINTA - TONER PARA IMPRESORAS A LASER - CARTOES MAGNETICOS - REPOSICAO DE LEITORA/TOKEN PEN-DRIVE/OUTROS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.18.00.00.00.00','MATERIAIS E MEDICAMENTOS P/ USO VETERINARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS E MEDICAMENTOS PARA USO   VETERINARIO.   VACINAS - MEDICAMENTOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.19.00.00.00.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS APLICADOS DIRETAMENTE  NAS PRESERVACOES, ACOMODACOES OU EMBALAGENS DE QUALQUER PRODUTO. ARAME - BARBANTE - CAIXAS PLASTICAS, DE MADEIRA, PAPELAO  E  ISOPOR  -CORDAS - ENGRADADOS - FITAS DE ACO OU METALICAS -  FITAS  GOMADORAS  -GARRAFAS E POTES - LINHA - PAPEL DE EMBRULHO -  PAPELAO  -  SACOLAS  -SACOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.20.00.00.00.00','MATERIAL DE CAMA, MESA E BANHO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS EM  DORMITORIOS COLETIVOS, RESIDENCIAIS, HOTEIS, RESTAURANTES ETC.   COBERTORES - COLCHAS - COLCHONETES - FRONHAS - GUARDANAPOS - LENCOIS -TOALHAS - TRAVESSEIROS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.21.00.00.00.00','MATERIAL DE COPA E COZINHA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA REFEITORIOS DE QUALQUER TIPO, COZINHAS RESIDENCIAIS, DE HOTEIS, DE  HOSPITAIS,  DEESCOLAS, DE UNIVERSIDADES, DE FABRICAS ETC. ABRIDOR DE GARRAFA - ACUCAREIROS -  ARTIGOS  DE  VIDRO  E  PLASTICO  -BANDEJAS - COADORES  -  COLHERES  -  COPOS  -  EBULIDORES  -  FACAS  -FARINHEIROS - FOSFOROS - FRIGIDEIRAS - GARFOS -  GARRAFAS  TERMICAS  -PALITEIROS - PANELAS - PANOS DE COZINHA - PAPEL ALUMINIO  -  PRATOS  -RECIPIENTES PARA AGUA - SUPORTES DE COPOS  P/ CAFEZINHO  -  TIGELAS  -VELAS - XICARAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.22.00.00.00.00','MATERIAL DE LIMPEZA E PROD. DE HIGIENIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DESTINADOS A  HIGIENIZACAO PESSOAL, DE AMBIENTES DE TRABALHO, DE HOSPITAIS ETC. ALCOOL ETILICO - ANTICORROSIVO - APARELHO  DE  BARBEAR  DESCARTAVEL  -BALDE PLASTICO - BOMBA P/ INSETICIDA - CAPACHO - CERA - CESTO  P/ LIXO- CREME DENTAL - DESINFETANTE - DESODORIZANTE - DETERGENTE - ESCOVA DEDENTES - ESCOVA P/ ROUPAS E SAPATOS - ESPANADOR - ESPONJA -  ESTOPA  -FLANELA - INSETICIDA - LUSTRA-MOVEIS - MANGUEIRA - NAFTALINA - PA PARALIXO - PALHA DE ACO - PANOS P/ LIMPEZA - PAPEL HIGIENICO - PASTA  PARALIMPEZA DE UTENSILIOS - PORTA-SABAO -  REMOVEDOR  -  RODO  -  SABAO  -SABONETE - SACO P/ LIXO - SAPONACEO - SODA CAUSTICA - TOALHA DE  PAPEL- VASSOURA - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.23.00.00.00.00','UNIFORMES, TECIDOS E AVIAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE UNIFORMES OU QUALQUER TECIDO OU MATERIAL SINTETICO QUE SE DESTINE A CONFECCAO DE ROUPAS, COM LINHAS DE  QUALQUER ESPECIE DESTINADAS A COSTURAS E OUTROS MATERIAIS DE CONSUMO  EMPREGADOS DIRETA OU INDIRETAMENTE NA CONFECCAO DE ROUPAS.            AGASALHOS - ARTIGOS DE COSTURA - AVENTAIS - BLUSAS - BOTOES - CADARCOS- CALCADOS - CALCAS - CAMISAS - CAPAS - CHAPEUS - CINTOS - ELASTICOS -GRAVATAS - GUARDA-POS - LINHAS - MACACOES - MEIAS - TECIDOS EM GERAL -UNIFORMES MILITARES OU DE USO CIVIL - ZIPERES - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.24.00.00.00.00','MATERIAL PARA MANUTENÇÃO DE BENS IMOVEIS/INSTALACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO PARA APLICACAO,MANUTENCAO E REPOSICAO DE QUALQUER BEM PUBLICO. AMIANTO - APARELHOS SANITARIOS - ARAMES  LISO  E  FARPADO  -  AREIA  -BASCULANTE - BOCA DE LOBO - BOIA - BRITA - BROCHA -  CABO  METALICO  -CAL - CANO - CERAMICA - CIMENTO - COLA - CONDUTORES DE FIOS - CONEXOES- CURVAS - ESQUADRIAS - FECHADURAS  -  FERRO  -  GAXETAS  -  GRADES  -IMPERMEABILIZANTES -  ISOLANTES  ACUSTICOS  E  TERMICOS  -  JANELAS  -JOELHOS - LADRILHOS -  LAVATORIOS  -  LIXAS  -  MADEIRA  -  MARCOS  DECONCRETO - MASSA CORRIDA - NIPLE - PAPEL DE PAREDE - PARAFUSOS -  - PECAS P/ELEVADORES,PORTOES ELETRICOS, AR CONDICIONADO CENTRAL, ETC- PIAS- PIGMENTOS - PORTAS E PORTAIS - PREGOS - ROLOS SOLVENTES  -  SIFAO  -TACOS - TAMPA P/ VASO - TAMPAO DE FERRO - TANQUE - TELA DE  ESTUQUE  -TELHA - TIJOLO - TINTA - TORNEIRA -  TRINCHA  -  TUBO  DE  CONCRETO  -VALVULAS - VERNIZ - VIDRO - AQUECEDORES A GAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.25.00.00.00.00','MATERIAL PARA MANUTENCAO DE BENS MOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COMPONENTES, PECAS, ACESSORIOS E SOBRESSALENTES PARA APLICACAO, MANUTENCAO  E  REPOSICAO  EM  BENS MOVEIS EM GERAL.. CABOS - CHAVES - CILINDROS P/ MAQUINAS COPIADORAS -  COMPRESSOR  P/ AR   CONDICIONADO -  MANGUEIRA  P/ FOGAO    -  PECAS DE REPOSICAO DE APARELHOS E MAQUINAS EM  GERAL  -MATERIAIS DE REPOSICAO PARA INSTRUMENTOS MUSICAIS - VIDRO DE MESA E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.26.00.00.00.00','MATERIAL ELETRICO E ELETRONICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO PARA APLICACAO,MANUTENCAO E REPOSICAO DOS SISTEMAS, APARELHOS E EQUIPAMENTOS  ELETRICOS E ELETRONICOS. BENJAMINS - BOCAIS - CALHAS - CAPACITORES E  RESISTORES  -  CHAVES  DE LIGACAO - CIRCUITOS ELETRONICOS - CONDUTORES - COMPONENTES DE APARELHOELETRONICO - DIODOS - DISJUNTORES - ELETRODOS - ELIMINADOR DE PILHAS -ESPELHOS PARA INTERRUPTORES - FIOS E CABOS - FITA ISOLANTE -  FUSIVEIS- INTERRUPTORES - LAMPADAS E LUMINARIAS - PILHAS E BATERIAS - PINOS  E PLUGS - PLACAS DE BAQUELITE - REATORES - RECEPTACULOS - RESISTENCIAS -STARTS - SUPORTES - TOMADA DE CORRENTE - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.27.00.00.00.00','MATERIAL DE MANOBRA E PATRULHAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO  UTILIZADOS  EM CAMPANHA MILITAR OU PARAMILITAR, EM MANOBRAS DE TROPAS, EM TREINAMENTOOU EM ACAO EM PATRULLHAMENTO OSTENSIVO OU RODOVIARIO, EM  CAMPANHA  DE SAUDE PUBLICA ETC.   BINOCULO - CARTA NAUTICA - CANTIL - CORDAS - FLAMULAS E  BANDEIRAS  DESINALIZACAO - LANTERNAS - MEDICAMENTOS DE PRONTO-SOCORRO - MOCHILAS  - PIQUETES - SACOLAS - SACOS DE DORMIR - SINALEIROS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.28.00.00.00.00','MATERIAL DE PROTECAO E SEGURANCA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO UTILIZADOS  DIRETAMENTE NA PROTECAO DE PESSOAS OU BENS  PUBLICOS,  PARA  SOCORRO  DE PESSOAS E ANIMAIS OU PARA SOCORRO DE VEICULOS, AERONAVES E EMBARCACOES, ASSIM COMO QUALQUER OUTRO ITEM APLICADO DIRETAMENTE NAS ATIVIDADES  DE SOBREVIVENCIA DE PESSOAS, NA SELVA, NO MAR OU EM SINISTROS DIVERSOS.  BOTAS - CADEADOS - CALCADOS ESPECIAIS - CAPACETES - CHAVES - CINTOS  -COLETES -  DEDAIS - GUARDA-CHUVAS - LONA - LUVAS - MANGUEIRA DE LONA -MASCARAS - PASSADEIRA ANTIDERRAPANTE - OCULOS - CABINA DE PAPELAO E OUTROS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.29.00.00.00.00','MATERIAL PARA  AUDIO, VIDEO E FOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO DE EMPREGO  DIRETO EM FILMAGEM E REVELACAO, AMPLIACOES E REPRODUCOES DE SONS E  IMAGENS. AETZE ESPECIAL P/ CHAPA DE PAPEL - ALBUNS P/ RETRATOS -  ALTO-FALANTES- ANTENAS - ARTIGOS PARA GRAVACAO EM ACETATO - FILMES VIRGENS -  FITASVIRGENS DE AUDIO E VIDEO - LAMPADAS ESPECIAIS - MATERIAL  P/ RADIOGRA-FIA, MICROFILMAGEM E CINEMATOGRAFIA - MOLDURAS - PAPEL P/ REVELACAO DEFOTOGRAFIAS - PEGADORES - REVELADORES - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.30.00.00.00.00','MATERIAL PARA COMUNICACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA COMUNICACOES, ASSIM COMO OS COMPONENTES, CIRCUITOS IMPRESSOS OU INTEGRADOS, PECAS OU ACESSORIOS DE REPOSICAO, CHIPS, E  PARTES DE EQUIPAMENTOS DE  COMUNIC.MATERIAIS PARA INSTALACOES: RADIOFONICAS, RADIOTELEGRAFICAS,  TELEGRAFICAS E OUTROS. - BATERIA PARA TELEFONE CELULAR- BLOQUEADOR TELEFONICO - CHAVE COMUTADORA PARA TELEFONE - FIO PARA TELEFONE - TOMADA PARA TELEFONE - MATERIAIS PARA INSTALACOES RADIOFONICAS - RADIOTELEGRAFICAS - TELEGRAFICAS - OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.31.00.00.00.00','SEMENTES, MUDAS DE PLANTAS E INSUMOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE QUALQUER TIPO DE SEMENTE DESTINADA AAO PLANTIO E MUDAS DE PLANTAS FRUTIFERAS OU  ORNAMENTAIS,  ASSIM  COMO TODOS OS INSUMOS UTILIZADOS PARA FERTILIZACAO. ADUBOS - ARGILA - PLANTAS ORNAMENTAIS - BORBULHAS - BULBOS -  ENXERTOS- FERTILIZANTES - MUDAS ENVASADAS OU COM  RAIZES  NUAS  -  SEMENTES  -TERRA - TUBERCULOS - XAXIM - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.32.00.00.00.00','SUPRIMENTO DE AVIACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS EMPREGADOS NA MANUTENCAO E REPARO DE AERONAVES. ACESSORIOS - PECAS  DE  REPOSICAO  DE  AERONAVES  -  SOBRESSALENTES  -E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.33.00.00.00.00','MATERIAL PARA PRODUCAO INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAS-PRIMAS UTILIZADAS NA TRANSFORMACAO, BENEFICIAMENTO E INDUSTRIALIZACAO DE UM PRODUTO FINAL.      BORRACHA - COURO - MATERIAS-PRIMAS EM GERAL - MINERIOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.34.00.00.00.00','SUPRIMENTOS PARA MAQ.E MOTORES NAVIOS E EMBARCACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA MANUTENCAO E REPARO DE MAQUINAS E MOTORES DE NAVIOS, INCLUSIVE DA  ESQUADRA, E DE EMBARCACOES EM GERAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.35.00.00.00.00','MATERIAL LABORATORIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS UTENSILIOS USADOS EM ANALISES LABORATORIAIS. ALMOFARIZES - BASTOES - BICO DE GAS - CALICES - CORANTES - FILTROS  DEPAPEL - FIXADORAS - FRASCOS - FUNIS -  GARRA  METALICA  -  LAMINAS  DEVIDRO P/ MICROSCOPIO - LAMPADAS ESPECIAIS - LUVAS DE BORRACHA - METAISE MATALOIDES P/ ANALISE - PINCAS - ROLHAS - VIDRARIA: BALAO VOLUMETRI-CO - BECKER - CONTA-GOTAS - ERLEMEYER - PIPETA - PROVETA -  TERMOMETRO- TUBO DE ENSAIO - MATERIAL DE LABORATORIO DIDATICO E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.36.00.00.00.00','MATERIAL HOSPITALAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO PARA AREA HOSPITALAR OU AMBULATORIAL. AGULHAS HIPODERMICAS - ALGODAO - CANULAS - CATETERES  -  COMPRESSA  DEGAZE - DRENOS - ESPARADRAPO - FIOS CIRURGICOS - LAMINAS P/  BISTURI  -LUVAS - SERINGAS - TERMOMETRO CLINICO - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.37.00.00.00.00','SUPRIMENTOS DE ARMAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA MANUTENCAO E REPARO DE ARMAMENTO. MATERIAL DE MANUTENCAO E ARMAMENTO - PECAS DE REPOSICAO - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.38.00.00.00.00','SUPRIMENTO DE PROTECAO AO VOO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PECAS DE REPOSICAO DE RADARES E SISTEMAS DE COMUNICACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.39.00.00.00.00','MATERIAL PARA MANUTENCAO DE VEICULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA APLICACAO E  MANUTENCAO DE VEICULOS RODOVIARIOS, VIATURAS BLINDADAS E TRATORES EM GERAL.  AGUA DESTILADA - AMORTECEDORES - BATERIAS - BORRACHAS - BUZINA - CABOSDE ACELERADOR - CABOS DE EMBREAGEM - CAMARA DE AR  -  CARBURADOR  COMPLETO - CIFA - COLAR DE EMBREAGEM - CONDENSADOR E PLATINADO - CORREIAS- DISCO DE EMBREAGEM - IGNICAO  -  JUNTA  HOMOCINETICA  -  LAMPADAS  E LANTERNAS P/ VEICULOS - LONAS E PASTILHAS  DE  FREIO  -  MANGUEIRAS  -MATERIAL UTILIZADO EM LANTERNAGEM E PINTURA -  MOTOR  DE  REPOSICAO  -PARA-BRISA - PARA-CHOQUE - PLATO - PNEUS  -  REPAROS  -  RETENTORES  -RETROVISORES - ROLAMENTOS  -  TAPETES  -  VALVULA  DA  MARCHA-LENTA  E TERMOSTATICA - VELAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.40.00.00.00.00','MATERIAL BIOLOGICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE AMOSTRAS E OUTROS ITENS DE MATERIAIS BIOLOGICOS UTILIZADOS EM ESTUDOS E PESQUISAS CIENTIFICAS EM SERES  VIVOS E INSEMINACAO ARTIFICIAL. MEIOS DE CULTURA - SEMEN - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.41.00.00.00.00','MATERIAL PARA UTILIZACAO EM GRAFICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS MATERIAIS DE CONSUMO DE USO GRAFICO, TAIS COMO:  CHAPAS DE OFF-SET - CLICHES - COLA - ESPIRAIS - FOTOLITOS - LOGOTIPOS - PAPEL - SOLVENTES - TINTA - TIPOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.42.00.00.00.00','FERRAMENTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS TIPOS DE FERRAMENTAS UTILIZADAS EM OFICINAS, CARPINTARIAS, JARDINS ETC.  ALICATE - BROCA - CAIXA P/ FERRAMENTAS - CANIVETE - CHAVES EM  GERAL -ENXADA - ESPATULAS - FERRO DE SOLDA - FOICE - LAMINA DE SERRA - LIMA -MACHADO - MARTELO - PA - PICARETA -  PONTEIRA  -  PRUMO  -  SERROTE  -TESOURA DE PODAR - TRENA - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.43.00.00.00.00','MATERIAL PARA REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA PROGRAMAS DE REABILITACAO PROFISSIONAL. BASTOES - BENGALAS - JOELHEIRAS - MEIAS  ELASTICAS  E  ASSEMELHADOS  -OCULOS - ORTESES - PESOS - PROTESES, INSTRUMENTOS DE TRABALHO E IMPLEMENTOS PROFISSIONAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.44.00.00.00.00','MATERIAL DE SINALIZACAO VISUAL E OUTROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA IDENTIFICACAO, SINALIZACAO VISUAL, ENDERECAMENTO E OUTROS.  PLACAS DE SINALIZACAO EM GERAL, TAIS COMO, PLACAS INDICATIVAS  PARA O SETORES E SECOES, PLACAS PARA VEICULOS, PLAQUETAS PARA TOMBAMENTO DE MATERIAL, PLACAS SINALIZADORAS DE TRANSITO, CONES SINALIZADORES DE TRANSITO, CRACHAS, BOTONS IDENTIFICADORES PARA SERVIDORES E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.45.00.00.00.00','MATERIAL TECNICO PARA SELECAO E TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS  TECNICOS UTILIZADOS EM PROCESSOS DE SELECAO E TREINAMENTO PELA PROPRIA  UNIDADE GESTORA OU PARA DISTRIBUICAO NAO GRATUITA, TAIS COMO:  APOSTILAS E SIMILARES - FOLHETOS DE  ORIENTACAO  -  LIVROS  -  MANUAIS EXPLICATIVOS PARA CANDIDATOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.46.00.00.00.00','MATERIAL BIBLIOGRAFICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL BIBLIOGRAFICO TAIS COMO:   JORNAIS - REVISTAS - PERIODICOS EM GERAL - ANUARIOS MEDICOS -  ANUARIO ESTATISCO - LIVROS EM GERAL E OUTROS, PODENDO ESTAR NA FORMA DE CD-ROM E OS MATERIAIS BIBLIOGRAFICOS PARA BIBLIOTECAS PUBLICAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.49.00.00.00.00','BILHETES DE PASSAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE BILHETES DE PASSAGEM PARA GUARDA EM ESTOQUE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.50.00.00.00.00','BANDEIRAS, FLAMULAS E INSIGNIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE BANDEIRAS, FLAMULAS E  INSIGNIAS, A SABER: BRASOES, ESCUDOS, ARMAS DA REPUBLICA, SELO NACIONAL E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.51.00.00.00.00','DISCOTECAS E FILMOTECAS NAO IMOBILIZAVEL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA AQUISICAO DE DISCOS, CD E COLECOES DE FITAS GRAVADAS COM MUSICAS E FITAS CINEMATOGRAFICAS  DE  CARATER EDUCATIVO, CIENTIFICO E INFORMATIVO, CUJA DEFASAGEM CONTABIL OCORRE EM UM PRAZO MAXIMO DE DOIS ANOS E QUE ATENDA OS PARAMETROS EXCLUDENTES DE MATERIAL PERMANENTE, CONFORME MANUAL DE CONTABILIDADE APLICADO AO SETOR PUBLICO - MACASP, VOLUME I - PROCEDIMENTOS CONTABEIS ORCAMENTARIOS, TAIS COMO:    - DISCO EDUCATIVO - FITA  DE  AUDIO  E  VIDEO  COM  AULA  DE   CARATER EDUCATIVO, MICROFILME E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.54.00.00.00.00','MATERIAL PARA MANUTENÇÃO E CONSERVAÇÃO DE ESTRADAS E VIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA REPAROS, RECUPERACOES E ADAPTACOES DE ESTRADAS, FERROVIAS E RODOVIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.99.00.00.00.00','OUTROS MATERIAIS DE CONSUMO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTROS MATERIAIS DE CONSUMO QUE NAO SE ENQUADREM NAS RUBRICAS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.0.00.00.00.00.00','DISTRIBUIÇÃO DE MATERIAL GRATUITO','Compreende as variações patrimoniais diminutivas provenientes da distribuição de material gratuito.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.00.00.00.00.00','DISTRIBUIÇÃO DE MATERIAL GRATUITO - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da distribuição de material gratuito. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.01.00.00.00.00','MERCADORIAS DOADAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.02.00.00.00.00','MATERIAL DESTINADO A ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL DE SAUDE (FARMACOLOGICO, ODONTOLOGICO, HOSPITALAR, MEDICAMENTOS, ORTESE E PROTESE), GENEROS ALIMENTICIOS, MATER.DE CAMA, MESA, COPA, COZINHA, LIMPEZA, HIGIENIZACAO, UNIFORMES, TECIDOS, AVIAMENTOS, MANUTENÇAO DE MOVEIS E IMOVEIS, FERRAMENTAS E OUTROS DISTINADOS A ASSISTENCIA SOCIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.03.00.00.00.00','MATERIAL EDUCACIONAL E CULTURAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL   EDUCACIONAL,(MATERIAL ESCOLAR, DIDATICO, TECNICO, MATERIAL P/AUDIO, VIDEO E  FOTO)E MATERIAL CULTURAL (MATERIAL RELIGIOSO E ESPORTIVO).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.04.00.00.00.00','MATERIAL PARA CERIMONIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OFERECIDOS A  TITULO DE HOMENAGEM.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.05.00.00.00.00','MATERIAL PARA REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OU BEM DESTINADO A SEGURADO INSCRITO EM PROGRAMA DE REABILITACAO PROFISSIONAL, INDISPENSAVEIS AO DESENVOLVIMENTO DO PROCESSO DE REABILITACAO, TAIS COMO: - PROTESES (APARELHOS DE SUBSTITUICAO) - ORTESES (APARELHOS DE CORRECAO OU COMPLEMENTACAO) - IMPLEMENTO PROFISSIONAL (INSTRUMENTOS TECNICOS E EQUIPAMENTOS DE PROTECAO INDIVIDUAL) - MAQUINAS ACESSORIOS E FERRAMENTAS INDISPENSAVEIS PARA O DESENVOLVIMENTO DE UMA FUNCAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.06.00.00.00.00','MATERIAL PARA DIVULGACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA PUBLICIDADE E DIVULGACAO DE PROGRAMAS DO GOVERNO, PARA CONSCIENTIZACAO SOCIAL EX: CAMISETAS, BONES, CHAVEIROS, CANETAS, BOTONS, ETC, COM LOGOMARCAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.99.00.00.00.00','OUTROS MATERIAIS DE DISTRIBUICAO GRATUITA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA DISTRIBUICAO GRATUITA, NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.0.0.00.00.00.00.00','SERVIÇOS','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços fornecidas à entidade governamental.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.0.00.00.00.00.00','DIÁRIAS','Compreende as variações patrimoniais diminutivas provenientes da utilização de diárias pagas aos servidores, empregados públicos e colaboradores eventuais, para fazer face a despesas com pousada, alimentação e locomoção urbana.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.00.00.00.00.00','DIÁRIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da utilização de diárias pagas aos servidores, empregados públicos e colaboradores eventuais, para fazer face a despesas com pousada, alimentação e locomoção urbana.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.01.00.00.00.00','DIARIAS  PESSOAL CIVIL','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE  PESSOAL  CIVIL,COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO  SERVIDOR  PUBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.01.01.00.00.00','DIARIAS - PESSOAL CIVIL - NO PAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE  PESSOAL  CIVIL  NO  PAIS,COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO  SERVIDOR  PUBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.01.02.00.00.00','DIARIAS - PESSOAL CIVIL - NO EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE  PESSOAL  CIVIL  NO  EXTERIOR,COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO  SERVIDOR  PUBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.01.99.00.00.00','DIARIAS - PESSOAL CIVIL - OUTRAS','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS DIARIAS - PESSOAL CIVIL NAO CLASSIFICAVEIS NAS RUBRICAS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.03.00.00.00.00','DIARIAS - COLABORADORES EVENTUAIS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS A PRESTADORES DE  SERVICOS DE CARATER EVENTUAL, SEM VINCULO COM A ADMINISTRACAO PUBLICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.03.01.00.00.00','DIARIAS - COLABORADORES EVENTUAIS - NO PAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS A PRESTADORES DE  SERVICOS PARA A ADMINISTRACAO PUBLICA, EXCETO A SERVIDORES PUBLICOS OU CELETISTAS. (NO PAIS)','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.03.02.00.00.00','DIARIAS - COLABORADORES EVENTUAIS - NO EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS A PRESTADORES DE  SERVICOS DE CARATER EVENTUAL, SEM VINCULO COM A ADMINISTRACAO PUBLICA (NOEXTERIOR).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.03.99.00.00.00','DIARIAS - COLABORADORES EVENTUAIS - OUTRAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTRAS DIARIAS  A COLABORADORES EVENTUAIS NAO CLASSIFICAVEIS NAS RUBRICAS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.04.00.00.00.00','DIARIAS A CONSELHEIROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS A MEMBROS DE ORGAOS DE DELIBERACAO COLETIVA (CONSELHOS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.0.00.00.00.00.00','SERVIÇOS TERCEIROS - PF','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa física fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.00.00.00.00.00','SERVIÇOS TERCEIROS - PF - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa física fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.01.00.00.00.00','CONSULTORIA E ASSESSORIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.02.00.00.00.00','PERICIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR PROFISSIONAIS TECNICOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.03.00.00.00.00','AUDITORIA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE AUDITORIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.04.00.00.00.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS  HONORARIOS ADVOCATICIOS A VENCEDORA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.05.00.00.00.00','SERVICOS MEDICOS E ODONTOLOGICOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS MEDICOS E ODONTOLOGICOS    PRESTADOS POR PESSOA FISICA, SEM VINCULO EMPREGATICIO.CONSULTAS - RAIO X - TRATAMENTO ODONTOLOGICO - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.06.00.00.00.00','SELECAO E TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS  DE  INSTRUCAO  E  ORIENTACAO PROFISSIONAL, RECRUTAMENTO E SELECAO DE  PESSOAL  E  TREINAMENTO,  POR PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.07.00.00.00.00','COMUNICACAO EM GERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE COMUNICACAO GERAL  PRESTADOS POR PESSOA FISICA, TAIS COMO:  CONFECCAO DE MATERIAL P/ COMUNICACAO VISUAL; GERACAO DE MATERIAS PARA DIVULGACAO POR MEIO DOS VEICULOS DE COMUNICACAO;   E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.08.00.00.00.00','LIMPEZA E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LIMPEZA E CONSERVACAO DE BENS IMOVEIS.DEDETIZACAO - FAXINA - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.09.00.00.00.00','SERVICOS DOMESTICOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS  DOMESTICOS  PRESTADOS  POR PESSOA FISICA SEM VINCULO EMPREGATICIO, TAIS COMO: COZINHA - LAVAGEM DE ROUPAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.11.00.00.00.00','MANUTENCAO E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS E IMOVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.12.00.00.00.00','CONDOMINIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS CONDOMINIAIS A CONTA DO LOCATORIO, QUANDO PREVISTAS NO CONTRATO DE LOCACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.13.00.00.00.00','COMISSOES E CORRETAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR:  CORRETORES - DESPACHANTES - LEILOEIROS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.14.00.00.00.00','DIREITOS AUTORAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE DIREITOS AUTORAIS DE PROPRIEDADE DE TERCEIROS SOBRE OBRAS  CIENTIFICAS, LITERARIAS, ETC, EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO.  REGISTRA O VALOR REFERENTE A UTILIZACAO DE SERVICOS DECORRENTES DE INCENTIVOS AOS AUTORES    A TITULO DE ROYALTIES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.15.00.00.00.00','SERVICOS TECNICOS PROFISSIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PROFISSIONAIS TECNICOS, NAS SEGUINTES AREAS: ADMINISTRACAO - ADVOCACIA - ARQUITETURA - CONTABILIDADE -  ECONOMIA  -ENGENHARIA - ESTATISTICA E OUTRAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.16.00.00.00.00','ESTAGIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR ESTUDANTES NA CONDICAO DE ESTAGIARIOS OU MONITORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.19.00.00.00.00','CONFERENCIAS, EXPOSICOES E ESPETACULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR CONFERENCISTAS, EXPOSITORES E ARTISTAS PELOS SERVICOS PRESTADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.20.00.00.00.00','ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE  ALUGUEL DE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, OS DISPENDIOS DE GARANTIA DOS ESTOQUES ARMAZENADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.21.00.00.00.00','LOCACOES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE  LOCACAO DE BENS MOVEIS E IMOVEIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.21.01.00.00.00','LOCACAO DE IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE  ALUGUEL DE PREDIOS, SALAS E OUTROS IMOVEIS DE PROPRIEDADE DE PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.21.02.00.00.00','LOCACAO DE BENS MOVEIS E INTANGIVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE  ALUGUEIS  DE  MAQUINAS,EQUIPAMENTOS, TELEFONE FIXO E CELULAR E OUTROS BENS MOVEIS DE PROPRIEDADE DE PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.21.03.00.00.00','TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DOS TRIBUTOS A CONTA DO LOCATARIO OU DO CESSIONARIO, QUANDO PREVISTOS NO CONTRATO DE LOCACAO OU CESSAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.22.00.00.00.00','FORNECIMENTO DE ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE REFEICOES  PREPARADAS, INCLUSIVE LANCHES E SIMILARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.24.00.00.00.00','SERVICOS DE REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO, COMO OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE)  OS MEIOS INDICADOS PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO.  EX: CONTRATACAO DE PROFISSIONAL PARA MINISTRAR CURSO PROFISSIONALIZANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.25.00.00.00.00','SERVICOS DE ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS  DE  ASSISTENCIA SOCIAL PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A  SEUS  DEPENDENTES, TAIS COMO AJUDA DE CUSTO SUPLETIVA, GENEROS  ALIMENTICIOS, DOCUMENTACAO, TRANSPORTE E SEPULTAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.26.00.00.00.00','SERVIÇO DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE NATUREZA EVENTUAL PRESTADOS POR PESSOA FISICA, TAIS COMO: ASSISTENCIA TECNICA - CAPINA - JARDINAGEM - OPERADORES DE  MAQUINAS  E MOTORISTAS - RECEPCIONISTAS - SERVICOS AUXILIARES - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.27.00.00.00.00','SERVIÇO DE CONSERVAÇÃO E REBENEFICIAMENTO DE MERCADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO  DE SERVICOS DE NATUREZA EVENTUAL  PRESTADOS POR PESSOA FISICA NA CONSERVACAO E REBENEFICIAMENTO DE  MERCADORIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.28.00.00.00.00','CONFECCAO DE MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO  DE SERVICOS PRESTADOS POR PESSOA FISICA NA CONFECCAO DE:  BOLSAS - CAIXAS - MOCHILAS - SACOLAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.29.00.00.00.00','CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO  DE SERVICOS DE COSTUREIRAS, ALFAIATES E AFINS UTILIZADOS NA CONFECCAO DE UNIFORMES, BANDEIRAS, FLAMULAS,  BRASOES E ESTANDARTES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.30.00.00.00.00','FRETES E TRANSPORTES DE ENCOMENDAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO  DE SERVICOS  PRESTADOS POR PESSOA FISICA EM: FRETES E CARRETOS - REMESSA DE ENCOMENDAS - TRANSPORTE DE  MERCADORIAS E PRODUTOS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.31.00.00.00.00','JETONS E GRATIFICACOES A CONSELHEIROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA PARTICIPACAO EM ORGAOS DE DELIBERACOES COLETIVAS(CONSELHOS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.34.00.00.00.00','SERVICOS DE AUDIO, VIDEO E FOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO  DE SERVICOS DE FILMAGENS, GRAVACOES   E FOTOGRAFIAS, PRESTADOS POR PESSOA FISICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.38.00.00.00.00','DESPESAS COM LOCOMOCAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIOS DE TRANSPORTES AEREOS,TERRESTRES, FLUVIAIS OU MARITIMAS,  LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM   DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.38.01.00.00.00','LOCACAO DE MEIOS DE TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA LOCACAO DE MEIOS DE TRANSPORTE, TAIS COMO: VEICULOS, AERONAVES, EMBARCACOES E ASSEMELHADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.38.03.00.00.00','LOCOMOCAO URBANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIO DE TRANSPORTE URBANO, COMO: ONIBUS, TAXI E OUTROS VEICULOS DE TRANSPORTES URBANOS,PARA ATENDER NECESSIDADE DO SERVICO,  COMPREENDENDO,  TAMBEM, DESLOCAMENTOS PARA REALIZACAO DE PESQUISAS E REEMBOLSO COM TRANSPORTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.38.99.00.00.00','OUTRAS DESPESAS COM LOCOMOCAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIOS DE TRANSPORTES NAO ESPECIFICADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.39.00.00.00.00','SERVICOS GRAFICOS E EDITORIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SERVICOS DE ARTES GRAFICAS PRESTADOS POR PESSOA FISICA, BEM COMO COM SERVICOS EDITORIAIS DIVERSOS. CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS   E REVISTAS  - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVICOS DE  IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVICOS EDITORIAIS  DIVERSOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.99.00.00.00.00','OUTROS SERVICOS PRESTADOS POR PESSOA FISICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTROS SERVICOS PRESTADOS POR PESSOA FISICA, NAO CONTEMPLADOS EM ITENS ESPECIFICOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.0.00.00.00.00.00','SERVIÇOS TERCEIROS - PJ','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa jurídica fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.00.00.00.00.00','SERVIÇOS TERCEIROS - PJ - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa jurídica fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.01.00.00.00.00','CONSULTORIA E ASSESSORIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.02.00.00.00.00','PERICIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.03.00.00.00.00','AUDITORIA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AUDITORIA EXTERNA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.04.00.00.00.00','COMUNICACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE  COMUNICACAO,  PRESTADOS POR PESSOA JURIDICA.  EX: TELECOMUNICAÇÕES; CORRESPONDÊNCIAS; COMUNICAÇÃO DE DADOS E OUTROS SERVIÇOS DE COMUNICAÇÃO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.05.00.00.00.00','PUBLICIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE. PUBLICIDADE LEGAL; PUBLICIDADE DE UTILIZADE PUBLICA; PUBLICIDADE INSTITUCIONAL, BEM COMO OUTROS SERVICOS DE PUBLICIDADE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.06.00.00.00.00','MANUTENCAO E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS. TAIS COMO: MANUTENÇÃO E CONSERVAÇÃO DE ESTRADAS E VIAS; BENS IMOVEIS; VEICULOS; EQUIPAMENTOS DE PROCESSAMENTO DE DADOS; MAQUINAS E EQUIPAMENTOS; SOFTWARE; BENS MOVEIS, BEM COMO OUTROS SERVICOS DE MANUTENCAO E CONSERVACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.07.00.00.00.00','SERVICOS DE APOIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS  PRESTADOS  POR  PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS   E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE   O   CONTRATO  NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL  A SER UTILIZADO. EX: LIMPEZA E CONSERVACAO; VIGILANCIA OSTENSIVA/ MONITORADA; SERVICOS DE SOCORRO E SALVAMENTO; SERVICOS DOMESTICOS, BEM COMO OUTROS SERVICOS DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.08.00.00.00.00','SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.09.00.00.00.00','SERVICOS DE ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE  REFEICOES  PREPARADAS, INCLUSIVE LANCHES E SIMILARES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.10.00.00.00.00','LOCACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE LOCACAO DE BENS MOVEIS, IMOVEIS OU INTAGIVEIS. EX: IMÓVEIS; SOFTWARE; MAQUINAS E EQUIPAMENTOS; BENS MOVEIS DE OUTRAS NATUREZAS E INTANGIVEIS; EQUIPAMENTOS DE PROCESSAMENTO DE DADOS; TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIO','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.11.00.00.00.00','SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PRESTADOS POR EMPRESAS  ESPECIALIZADAS NA AREA DE INFORMATICA; ATUALIZACAO E ADAPTACAO DE PROGRAMAS DE PROCESSAMENTO DE DADOS; SUPORTE TECNICO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS,ANALISE P/ACRESCENTAR NOVAS FUNCOES, HOSPEDAGEM DE SISTEMAS E OUTROS. EX: DESENVOLVIMENTO DE SOFTWARE; SUPORTE DE INFRAESTRUTURA DE T.I.; SUPORTE A USUARIOS DE T.I.; HOSPEDAGEM DE SISTEMAS; SERVICOS TECNICOS PROFISSIONAIS DE T.I.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.12.00.00.00.00','SERVICOS DE TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE SERVIDORES, TRABALHADORES DE UMA ENTIDADE OU DE MERCADORIAS E PRODUTOS DIVERSOS. EX: VALE- TRANSPORTE; TRANSPORTE DE SERVIDORES; FRETE E TRANSPORTE DE ENCOMENDAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.13.00.00.00.00','ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS  DE  ALUGUELDE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, AS VARIACOES PROVENIENTESS DE GARANTIA DOS ESTOQUES ARMAZENADOS E A UTILIZACAO DE SERVICO ESPECIALIZADO NA SOLUCAO DE GESTAO DE ESTOQUE, INCLUINDO GESTAO DE MATERIAIS E TRANSPORTE DE MATERIAIS E EQUIPAMENTOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.14.00.00.00.00','ASSINATURAS DE PERIODICOS E ANUIDADES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ASSINATURAS DE TV  (TVA CABO), JORNAIS, INCLUSIVE DIARIO OFICIAL, REVISTAS, RECORTES DE  PUBLICACOES, SOFTWARE, PODENDO ESTAR NA FORMA DE DISQUETE, CD-ROM, BOLE-INS E  OUTROS QUE NAO SE DESTINEM A COLECOES OU BIBLIOTECAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.17.00.00.00.00','COMISSOES E CORRETAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE VALOR REFERENTE A COMISSOES E CORRETAGENS  DECORRENTES DE SERVICOS PRESTADOS POR EMPRESAS DE  INTERMEDIACAO  E  REPRESENTACAO COMERCIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.18.00.00.00.00','CONDOMINIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DAS TAXAS CONDOMINIAIS A CONTA DO  PROPRIETARIO, OU DO LOCATARIO, CONFORME PREVISTO NO CONTRATO DE LOCACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.19.00.00.00.00','CONFECCAO DE MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS  DE CONFECCAO  DE MATERIAIS   DESTINADOS  A  PRESERVACAO,  ACOMODACAO  OU  EMBALAGEM  DE PRODUTOS DIVERSOS, TAIS COMO:- BOLSAS - CAIXAS - MOCHILAS - SACOLAS E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.20.00.00.00.00','CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE:- BANDEIRAS - BRASOES - ESTANDARTES - FLAMULAS - UNIFORMES (INCLUSIVEAS DESPESAS RELACIONADAS COM AUXILIO FARDAMENTO DESCRITOS NA LEI  NUM.8237/91) E OUTROS.  SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.21.00.00.00.00','DIREITOS AUTORAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIREITOS AUTORAIS SOBRE OBRAS  CIENTIFICAS, LITERARIAS OU EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.22.00.00.00.00','EXPOSICOES, CONGRESSOS, CONFERENCIAS E OUTROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA INSTALACAO  E MANUTENCAO DE: CONFERENCIAS - REUNIOES TECNICAS - CONGRESSOS - EXPOSICOES - FEIRAS - FESTEJOS POPULARES - FESTIVAIS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.23.00.00.00.00','FESTIVIDADES E HOMENAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA  ORGANIZACAO   DE EVENTOS, TAIS COMO: COQUETEIS - FESTAS DE CONGRACAMENTO - RECEPCOES - E OUTRAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.24.00.00.00.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS HONORARIOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS  HONORARIOS ADVOCATICIOS A VENCEDORA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.25.00.00.00.00','HOSPEDAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS  DE  HOSPEDAGENS  E ALIMENTACAO DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS  OFICIAIS PAGOS DIRETAMENTE A  ESTABELECIMENTOS  HOTELEIROS (QUANDO  NAO  HOUVER   PAGAMENTO DE DIARIAS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.26.00.00.00.00','PATROCINIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PATROCINIOS  A  ATIVIDADES  OU  EVENTOS, DE NATUREZA  CULTURAL,  ESPORTIVA,  EDUCACIONAL,  AMBIENTAL,  CIENTIFICA, COMUNITARIA,  PROMOCIONAL  ETC.  PARA  INFLUENCIAR  FAVORAVELMENTE   O PUBLICO E/OU ATINGIR OUTROS OBJETIVOS RELACIONADOS COM A  PROMOCAO  DE ATOS, OBRAS, PLANOS, ACOES, BENS OU SERVICOS. NAO INCLUI O  PATROCINIO DE MIDIA, ASSIM CONSIDERADOS AQUELES EM QUE O PROPONENTE E UM VEICULO DE COMUNICACAO OU UM GESTOR DE MEIOS OU INSTALACOES QUE FUNCIONEM COMO VEICULO  DE  MIDIA  ALTERNATIVA  E  AQUELES  EM  QUE  UM  VEICULO   DE COMUNICACAO E O UNICO OU O PRINCIPAL REALIZADOR DA ACAO  PATROCINADA, AINDA QUE O PROPONENTE DO PROJETO E PROVEDOR DE CONTEUDO PARA  A  ACAO PATROCINADA NAO SE ENQUADRE NA DEFINICAO DE VEICULO DE COMUNICACAO  OU MEIO DE MIDIA ALTERNATIVA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.27.00.00.00.00','PRODUCOES JORNALISTICAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS  DE EDICAO DE JORNAIS, REVISTAS, NOTICIARIOS E MATERIAIS JORNALISTICOS PARA VIDEOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.29.00.00.00.00','SEGUROS EM GERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE  PREMIOS  PAGOS  POR  SEGUROS  DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS  OU BENS DE TERCEIROS,  PREMIOS  DE  SEGUROS  DE  BENS  DO  ESTADO  OU  DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.30.00.00.00.00','SELECAO E TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTACAO PROFISSIONAL, RECRUTAMENTO E  SELECAO  DE  PESSOAL (CONCURSO PUBLICO) E TREINAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.31.00.00.00.00','SERVIÇO MEDICO-HOSPITALAR,ODONTOLÓGICO E LABORATORIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS MEDICO-HOSPITALARES,  ODONTOLOGICOS E LABORATORIAIS, PRESTADOS POR PESSOAS JURIDICAS SEM VINCULO EMPREGATICIO, TAIS COMO:   ANALISES CLINICAS - CIRURGIAS - CONSULTAS - ECOGRAFIAS - ENDOSCOPIAS -ENFERMAGEM  -  ESTERILIZACAO  -  EXAMES  DE  LABORATORIO  -  RAIO X  -TOMOGRAFIAS - TRATAMENTO ODONTOLOGICO - ULTRASSONOGRAFIAS - E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.32.00.00.00.00','SERVICOS BANCARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE COMISSOES,  TARIFAS  E  REMUNERACOES DECORRENTES DE SERVICOS PRESTADOS POR  BANCOS  E  OUTRAS  INSTITUICOES FINANCEIRAS, BEM COMO DESPESAS COM AGUARDA/CUSTODIA DE VALORES (COFRES DE ALUGUEL).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.33.00.00.00.00','SERVICOS DE ANALISES E PESQUISA CIENTIFICAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ANALISES FISICO-QUIMICAS E PESQUISAS CIENTIFICAS, NAO RELACIONADAS COM APOIO AO ENSINO - ANALISES MINERAIS - ANALISES DE SOLO - ANALISES QUIMICAS - COLETA DE DADOS EM EXPERIMENTOS - TRATAMENTO E DESTINACAO DE RESIDUOS E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.34.00.00.00.00','SERVICOS DE APOIO DO ENSINO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE PROPORCIONAR O  DESENVOLVIMENTO  E  O  APERFEICOAMENTO  DO ENSINO,  EM  TODOS  OS  NIVEIS,  INCLUSIVE  PESQUISAS  EXPERIENCIAS  E ASSEMELHADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.35.00.00.00.00','SERVICOS DE ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS  DE  ASSISTENCIA SOCIAL   PRESTADA  A   SERVIDORES,  SEGURADOS  CARENTES,  ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES, TAIS COMO:- AJUDA DE CUSTO SUPLETIVA - GENEROS  ALIMENTICIOS  -  DOCUMENTACAO - TRANSPORTE E SEPULTAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.36.00.00.00.00','SERVICOS DE AUDIO VIDEO E FOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS  DE  FILMAGENS,  GRAVACOES, REVELACOES, AMPLIACOES E REPRODUCOES DE SONS E IMAGENS - CONFECCAO DE ALBUNS - CONFECCAO DE CRACHAS FUNCIONAIS   POR   FIRMAS ESPECIALIZADAS - EMOLDURAMENTO DE FOTOGRAFIAS - IMAGENS  DE  SATELITES - REVELACAO DE FILMES - MICROFILMAGEM E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.40.00.00.00.00','SERVICOS DE CONTROLE AMBIENTAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONTROLE AMBIENTAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.41.00.00.00.00','SERVICOS DE COPIAS E REPRODUCAO DE DOCUMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COPIAS XEROGRAFICAS, INCLUSIVE A LOCACAO E A MANUTENCAO DE EQUIPAMENTOS REPROGRAFICOS, COPIASE REPRODUCOES DE DOCUMENTOS E PUBLICACOES EM GERAL, INCLUSIVE POR MEIO MAGNETICO E DIGITALIZACAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.42.00.00.00.00','SERVICOS DE CRECHE E ASSISTENCIA PRE ESCOLAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS  PRESTADOS  POR  ENTIDADES DE ASSISTENCIA SOCIAL PARA ATENDER OS DEPENDENTES DE SERVIDORES DO ORGAO, HABILITADOS A USUFRUIREM DESSE BENEFICIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.45.00.00.00.00','SERVICOS DE REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE  SERVICOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA JURIDICA, COM O OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE), OS MEIOS INDICADOS  PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL,  DE  MODO  QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO.EX: CONTRATACAO DE EMPRESA PARA MINISTRAR CURSO PROFISSIONALIZANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.47.00.00.00.00','SERVICOS FUNERARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REMOCOES,  SEPULTAMENTOS E TRANSLADACOES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.48.00.00.00.00','SERVICOS GRAFICOS E EDITORIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ARTES GRAFICAS PRESTADOS POR PESSOA JURIDICA, BEM COMO COM SERVICOS EDITORIAIS DIVERSOS.- CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS   E REVISTAS  - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVICOS DE  IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVICOS EDITORIAIS DIVERSOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.49.00.00.00.00','SERVICOS JUDICIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE  CUSTAS  PROCESSUAIS DECORRENTES DE ACOES JUDICIAIS, DILIGENCIAS (INCLUSIVE CONDUCAO) SALARIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E OFICIAIS DE JUSTICA E SERVICOS DE CARTORIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.51.00.00.00.00','SERVICOS TECNICOS PROFISSIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NAS SEGUINTES AREAS:   ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA - ESTATISTICA E OUTRAS. EXCETO OS SERVICOS DE CONSULTORIA QUE DEVEM SER CLASSIFICADOS EM CONTA ESPECIFICA .','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.52.00.00.00.00','TAXA DE ADMINISTRACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ORGANIZACAO E ADMINISTRACAO PRESTADOS POR PESSOA JURIDICA, TAIS COMO: TAXA DE ADMINISTRACAO PAGA DECORRENTE DOS SERVICOS DE SELECAO E RECRUTAMENTO DE ESTUDANTES, TENDO COMO OBJETIVO  O  INGRESSO AO MERCADO DE TRABALHO E PROGRAMAS DE ESTAGIO; E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.54.00.00.00.00','LOCACAO DE MAO-DE-OBRA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR  PESSOAS JURIDICAS PARA ORGAOS PUBLICOS, TAIS COMO LIMPEZA E HIGIENE,  VIGILANCIA OSTENSIVA E OUTROS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. EX: LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL; DE LIMPEZA E CONSERVACAO; DE VIGILANCIA OSTENSIVA ; E MANUTENCAO E CONSERVACAO DE BENS IMOVEIS; DE  SERVICOS DE COPA E COZINHA;  DE  MANUTENCAO E CONSERVACAO DE BENS MOVEIS; DE MANUTENCAO DE SOFTWARE; DE SUPORTE DE INFRAESTRUTURA DE T.I.; DE SUPORTE A USUARIOS DE T.I. E OUTROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.55.00.00.00.00','ARRENDAMENTO MERCANTIL OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL OPERACIONAL, TAIS COMO: ARRENDAMENTO MERCANTIL OPERACIONAL  DE MAQUINAS E APARELHOS;  DE VEICULOS RODOVIARIOS; DE OUTROS BENS MOVEIS;  DE BENS IMOVEIS E OUTROS ARRENDAMENTOS MERCANTIS OPERACIONAIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.56.00.00.00.00','PASSAGENS E DESPESAS COM LOCOMOCAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS,TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE, SEGUROS, FRETAMENTO, PEDAGIOS, LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM   DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO. TAIS COMO: PASSAGENS PARA O PAIS; PASSAGENS PARA O EXTERIOR; LOCACAO DE MEIOS DE TRANSPORTE; LOCOMOCAO URBANA; PEDAGIOS; TRANSPORTE DE SERVIDORES ALEM DE OUTRAS DESPESAS COM LOCOMOCAO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.99.00.00.00.00','OUTROS SERVICOS PRESTADOS POR PESSOA JURIDICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA, QUE NAO ESTEJA ESPECIFICADOS EM ITENS ANTERIORES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.4.0.00.00.00.00.00','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA - ART. 18 § 1, LC 101/00','Compreende a apropriação das despesas relativas à mão de obra, constantes dos contratos de terceirização, classificáveis no grupo de despesa com pessoal e encargos em obediência ao disposto no artigo 18, § 1º, da lei complementar nº 101, de 2000.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.4.1.00.00.00.00.00','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA - ART. 18 § 1, LC 101/00 - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas relativas à mão de obra, constantes dos contratos de terceirização, classificáveis no grupo de despesa com pessoal e encargos em obediência ao disposto no artigo 18, § 1º, da lei complementar nº 101, de 2000. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.0.0.00.00.00.00.00','DEPRECIAÇÃO, AMORTIZAÇÃO E EXAUSTÃO','Compreende o decréscimo no beneficio de um bem durante o período contábil decorrente de depreciação, amortização e exaustão.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.1.0.00.00.00.00.00','DEPRECIAÇÃO','Compreende a redução do valor dos bens tangíveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.1.1.00.00.00.00.00','DEPRECIAÇÃO - CONSOLIDAÇÃO','Compreende a redução do valor dos bens tangíveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.1.1.01.00.00.00.00','DEPRECIACAO DE IMOBILIZADO','REGISTRA A REDUCAO DO VALOR DOS BENS TANGIVEIS ,DO ATIVO IMOBILIZADO, PELO DESGASTE OU PERDA DE UTILIDADE POR USO, ACAO DA NATUREZA OU OBSOLESCENCIA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.2.0.00.00.00.00.00','AMORTIZAÇÃO','Compreende a redução do valor aplicado na aquisição de direitos de propriedade e quaisquer outros, inclusive ativos intangíveis, com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.2.1.00.00.00.00.00','AMORTIZAÇÃO - CONSOLIDAÇÃO','Compreende a redução do valor aplicado na aquisição de direitos de propriedade e quaisquer outros, inclusive ativos intangíveis, com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.2.1.01.00.00.00.00','AMORTIZACAO DE IMOBILIZADO','REGISTRA A REDUCAO DO VALOR APLICADO NA AQUISICAO DE DIREITOS, DO ATIVO IMOBILIZADO, COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.2.1.02.00.00.00.00','AMORTIZACAO DE INTANGIVEL','REGISTRA A REDUCAO DO VALOR APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE E QUAISQUER OUTROS, INCLUSIVE ATIVOS INTANGIVEIS, COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.3.0.00.00.00.00.00','EXAUSTÃO','Compreende a redução do valor decorrente da exploração dos recursos minerais, florestais e outros recursos naturais esgotáveis.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.3.1.00.00.00.00.00','EXAUSTÃO - CONSOLIDAÇÃO','Compreende a redução do valor decorrente da exploração dos recursos minerais, florestais e outros recursos naturais esgotáveis. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.3.1.01.00.00.00.00','EXAUSTAO DE IMOBILIZADO','REGISTRA A REDUCAO DO VALOR, DECORRENTE DA EXPLORACAO, DOS RECURSOS MINERAIS, FLORESTAIS E OUTROS RECURSOS NATURAIS ESGOTAVEIS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.0.0.00.00.00.00.00','CUSTO DE MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende a variação patrimonial diminutiva relativa a materiais, serviços e consumo de capital fixo utilizados na produção de bens ou serviços, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.1.0.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende as variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo apropriadas as mercadorias, sendo registrado apenas no momento da venda destas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.1.1.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo apropriadas as mercadorias, sendo registrado apenas no momento da venda destas.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.2.0.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS - MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de bens, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.2.1.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS - MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de bens, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.3.0.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS - MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de serviços, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.3.1.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS - MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de serviços, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.0.0.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.0.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.0.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.1.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.1.01.00.00.00.00','JUROS DA DIVIDA CONTRATADA COM INSTITUIÇÕES FINANCEIRAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM INSTITUICOES FINANCEIRAS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.1.02.00.00.00.00','ENCARGOS DA DIVIDA CONTRATUAL COM INSTITUIÇÕES FINANCEIRAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM INSTITUICOES FINANCEIRAS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.1.99.00.00.00.00','JUROS E ENCARGOS DE OUTRAS  DIVIDAS CONTRATUAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.3.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.3.05.00.00.00.00','JUROS DA DIVIDA CONTRATADA COM GOVERNOS','REGISTRA  A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS JUROS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.3.06.00.00.00.00','ENCARGOS DA DIVIDA CONTRATADA COM GOVERNOS','REGISTRA  A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS ENCARGIOS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.4.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.4.01.00.00.00.00','JUROS DA DIVIDA CONTRATADA COM GOVERNOS','REGISTRA  A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS JUROS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.4.02.00.00.00.00','ENCARGOS DA DIVIDA CONTRATADA COM GOVERNOS','REGISTRA  A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS ENCARGIOS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.5.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.5.01.00.00.00.00','JUROS DA DIVIDA CONTRATADA COM GOVERNOS','REGISTRA  A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS JUROS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.5.02.00.00.00.00','ENCARGOS DA DIVIDA CONTRATADA COM GOVERNOS','REGISTRA  A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS ENCARGIOS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.2.0.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL EXTERNA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública externa derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.2.1.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública externa derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.2.1.01.00.00.00.00','JUROS DA DIVIDA CONTRATADA NO EXTERIOR','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA CONTRATADA NO EXTERIOR  COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVIÇOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.2.1.02.00.00.00.00','ENCARGOS DA DIVIDA CONTRATADA NO EXTERIOR','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA CONTRATADA NO EXTERIOR  COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVIÇOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.3.0.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA MOBILIARIA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública representada por títulos emitidos pelo governo. São considerados encargos da divida mobiliaria: comissões, corretagens, seguros, deságio e outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.3.1.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA MOBILIARIA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública representada por títulos emitidos pelo governo. São considerados encargos da divida mobiliaria: comissões, corretagens, seguros, deságio e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.3.1.01.00.00.00.00','JUROS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS DA DIVIDA PUBLICA MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.3.1.02.00.00.00.00','DESAGIOS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE DESAGIOS DA DIVIDA PUBLICA MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.3.1.03.00.00.00.00','ENCARGOS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS DA DIVIDA PUBLICA MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.4.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA','Compreende a variação patrimonial diminutiva com juros e encargos sobre empréstimos contraídos por antecipação de receita orçamentária para atender insuficiência de caixa durante o exercício financeiro.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.4.1.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos sobre empréstimos contraídos por antecipação de receita orçamentária para atender insuficiência de caixa durante o exercício financeiro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.4.1.01.00.00.00.00','JUROS S/ ADIANTAMENTOS BANCARIOS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS INCIDENTES SOBRE ANTECIPAÇÕES DE CRÉDITOS CONTRATADAS COM BANCOS E OUTROS AGENTES FINANCEIROS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.0.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.1.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.3.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - UNIÃO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.4.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - ESTADO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.5.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - MUNICÍPIO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.9.0.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos externos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.9.1.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos externos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.0.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA','Compreende o montante de variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos contratuais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.1.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.1.02.00.00.00.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.3.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.3.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.3.02.00.00.00.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.4.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.4.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.4.02.00.00.00.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.5.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.5.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.5.02.00.00.00.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.2.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos externos contraídos com pessoas jurídicas de direito público ou privado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.2.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos externos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.2.1.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.2.1.02.00.00.00.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NÃO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRÉSTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.3.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços e aquisição de bens.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.3.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços e aquisição de bens. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.3.1.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVIÇOS E AQUISICAO DE BENS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.4.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos de obrigações tributárias devidas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.4.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos de obrigações tributárias devidas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.4.1.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DAS OBRIGAÇÕES TRIBUTÁRIAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.9.0.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos em situações não compreendidas nas classificações anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.9.1.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos em situações não compreendidas nas classificações anteriores.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.0.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.1.01.00.00.00.00','VARIACOES MONETARIAS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.1.02.00.00.00.00','VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.3.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.3.01.00.00.00.00','VARIACOES MONETARIAS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.3.02.00.00.00.00','VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.4.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.4.01.00.00.00.00','VARIACOES MONETARIAS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.4.02.00.00.00.00','VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.5.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.5.01.00.00.00.00','VARIACOES MONETARIAS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.5.02.00.00.00.00','VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.2.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.2.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.2.1.01.00.00.00.00','VARIAÇÕES MONETÁRIAS DA DIVIDA CONTRATUAL EXTERNA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.2.1.02.00.00.00.00','VARIAÇÕES CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.3.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA INTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.3.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.3.1.01.00.00.00.00','VARIAÇÕES MONETARIAS DE DIVIDA MOBILIARIA INTERNA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA MOBILIARIA. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.3.1.02.00.00.00.00','VARIAÇÕES CAMBIAIS DE DIVIDA MOBILIARIA INTERNA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.4.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.4.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.0.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.1.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.1.01.00.00.00.00','OUTRAS VARIAÇÕES MONETARIAS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.1.02.00.00.00.00','OUTRAS VARIAÇÕES CAMBIAIS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.3.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.3.01.00.00.00.00','OUTRAS VARIAÇÕES MONETARIAS  - INTER OFSS - UNIÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.3.02.00.00.00.00','OUTRAS VARIAÇÕES CAMBIAIS - INTER OFSS - UNIÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.4.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.4.01.00.00.00.00','OUTRAS VARIAÇÕES MONETARIAS TER OFSS  - INTER OFSS - ESTADO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.4.02.00.00.00.00','OUTRAS VARIAÇÕES CAMBIAIS  - INTER OFSS - ESTADO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.5.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.5.01.00.00.00.00','OUTRAS VARIAÇÕES MONETARIAS TER OFSS - INTER OFSS - MUNICÍPIO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.5.02.00.00.00.00','OUTRAS VARIAÇÕES CAMBIAIS - INTER OFSS - MUNICÍPIO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.4.0.0.00.00.00.00.00','DESCONTOS FINANCEIROS CONCEDIDOS','Compreende o valor da variação patrimonial diminutiva com descontos financeiros concedidos a clientes por pagamentos antecipados de duplicatas e outros títulos. Não se confundem com descontos nos preços de venda concedidos incondicionalmente, ou abatimentos de preços, que são deduções da receita','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.4.0.1.00.00.00.00.00','DESCONTOS FINANCEIROS CONCEDIDOS - CONSOLIDAÇÃO','Compreende o valor da variação patrimonial diminutiva com descontos financeiros concedidos a clientes por pagamentos antecipados de duplicatas e outros títulos. Não se confundem com descontos nos preços de venda concedidos incondicionalmente, ou abatimentos de preços, que são deduções da receita.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - FINANCEIRAS','Compreende outras variações patrimoniais diminutivas financeiras, não abrangidas nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.1.0.00.00.00.00.00','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS','Compreende os juros e encargos resultantes de pagamento de precatórios e de sentenças judiciais transitadas em julgado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.1.1.00.00.00.00.00','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS - CONSOLIDAÇÃO','Compreende os juros e encargos resultantes de pagamento de precatórios e de sentenças judiciais transitadas em julgado.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.1.1.01.00.00.00.00','JUROS EM SENTENCAS JUDICIAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DOS JUROS  RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.1.1.02.00.00.00.00','ENCARGOS EM SENTECAS JUDICIAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DOS  ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.2.0.00.00.00.00.00','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES','Compreende as variações patrimoniais diminutivas com indenizações e restituições referentes a juros e encargos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.2.1.00.00.00.00.00','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com indenizações e restituições referentes a juros e encargos.     Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.2.1.01.00.00.00.00','JUROS E ENCARGOS EM INDENIZACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES REFERENTES A JUROS E ENCARGOS.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.2.1.02.00.00.00.00','JUROS E ENCARGOS EM  RESTITUICOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUICOES REFERENTES A JUROS E ENCARGOS.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.9.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','Compreende as variações patrimoniais diminutivas provenientes de operações financeiras não compreendidas nas contas anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.9.1.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de operações financeiras não compreendidas nas contas anteriores.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.0.0.0.00.00.00.00.00','TRANSFERÊNCIAS E DELEGAÇÕES CONCEDIDAS','Compreende o somatório das variações patrimoniais diminutivas com transferências inter governamentais, transferências intragovernamentais, transferências a instituições multigovernamentais, transferências a instituições privadas com ou sem fins lucrativos, transferências a convênios, transferências ao exterior e execuções orçamentárias delegadas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.0.0.00.00.00.00.00','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes das transferências financeiras relativas à execução orçamentária, e de bens e valores, referentes às transações intragovernamentais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.0.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS PARA A EXECUCAO ORCAMENTARIA','Compreende o valor das transferências financeiras concedidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Inclui também o valor repassado para a cobertura do déficit financeiro do RPPS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS PARA A   EXECUÇÃO ORÇAMENTARIA - INTRA OFSS','Compreende o valor das transferências financeiras concedidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Inclui também o valor repassado para a cobertura do déficit financeiro do RPPS. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.00.00.00.00','COTA CONCEDIDA','REGISTRA VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO  VALOR DA CONCESSAO DE COTA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA PARA ORGAO SETORIAL CORRESPONDENTE AO ORCAMENTO ANUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.02.00.00.00.00','REPASSE CONCEDIDO','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR DOS RECURSOS CONCEDIDOS A TITULO DE  TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DIFERENTES DA ADMINISTRACAO DIRETA OU INDIRETA, CORRESPONDENTES AO ORCAMENTO ANUAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.02.01.00.00.00','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR DO REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.02.01.01.00.00','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE - RECURSO LIVRE','REGISTRA O VALOR DO REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE COM RECURSO LIVRE','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.02.01.02.00.00','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE - RECURSO DO MDE','REGISTRA O VALOR DO REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE COM RECURSO DA MDE','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.02.01.03.00.00','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE - RECURSO DAS ASPS','REGISTRA O VALOR DO REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE COM RECURSO DAS ASPS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.02.01.04.00.00','REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE - DEMAIS RECURSOS VINCULADOS','REGISTRA O VALOR DO REPASSE FINANCEIRO CONCEDIDO PARA OUTRA ENTIDADE COM OS DEMAIS RECURSOS VINCULADOS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.03.00.00.00.00','SUB-REPASSE CONCEDIDO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR TOTAL DOS SUB-REPASSES CONCEDIDOS POR  TRANSFERENCIAS FINANCEIRAS ENTRE UG DE UM MESMO ORGAO.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.05.00.00.00.00','VALORES DIFERIDOS - BAIXA','REGISTRA O VALOR DA COTA DO REPASSE E DO SUB-REPASSE DIFERIDOS NO PROCESSO DE INSCRICAO E BAIXA DOS RECURSOS DIFERIDOS.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.06.00.00.00.00','VALORES DIFERIDOS - INSCRICAO','REGISTRA O VALOR DA COTA, DO REPASSE E DO SUB-REPASSE  DIFERIDOS NO PROCESSO DE INSCRICAO  DOS RECURSOS DIFERIDOS.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.00.00.00','REPASSES PREVIDENCIARIOS CONCEDIDOS PARA O RPPS','COMPREENDE O VALOR TOTAL DOS REPASSES PREVIDENCIARIOS CONCEDIDOS REFERENTES A CONTRIBUICAO PREVIDENCIARIA DO ENTE ESTATAL AO REGIME PROPRIODE PREVIDENCIA SOCIAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.01.00.00','REPASSE PREVIDENCIARIO CONCEDIDO P/COBERTURA DEFICIT - APOSENTADORIAS EXECUTIVO / INDIRETAS','REGISTRA O SOMATORIO DOS VALORES REPASSADOS PARA O RPPS A TITULO DE COBERTURA DE   DEFICIT DO EXERCICIO ATUAL - APOSENTADORIAS DO PODER EXECUTIVO / INDIRETAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.02.00.00','REPASSE PREVIDENCIARIO CONCEDIDO P/COBERTURA DEFICIT - APOSENTADORIAS LEGISLATIVO','REGISTRA O SOMATORIO DOS VALORES REPASSADOS PARA O RPPS A TITULO DE COBERTURA DE   DEFICIT DO EXERCICIO ATUAL - APOSENTADORIAS DO PODER LEGISLATIVO','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.03.00.00','REPASSE PREVIDENCIARIO CONCEDIDO P/COBERTURA DEFICIT - PENSOES','REGISTRA O SOMATORIO DOS VALORES REPASSADOS PARA O RPPS A TITULO DE COBERTURA DE   DEFICIT DO EXERCICIO ATUAL - PENSOES','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.04.00.00','REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS - EXECUTIVO/INDIRETAS','REGISTRA OS REPASSES CONCEDIDOS AO RPPS DO MUNICIPIO PARA QUE ESTE EXECUTE O PAGAMENTO DE APOSENTADORIAS DE COMPETÊNCIA DAS ENTIDADES DO EXECUTIVO/INDIRETAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.05.00.00','REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS - LEGISLATIVO','REGISTRA OS REPASSES CONCEDIDOS AO RPPS DO MUNICIPIO PARA QUE ESTE EXECUTE O PAGAMENTO DE APOSENTADORIAS DE COMPETÊNCIA DO PODER LEGISLATIVO','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.06.00.00','REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE PENSÕES','REGISTRA OS REPASSES CONCEDIDOS AO RPPS DO MUNICIPIO PARA QUE ESTE EXECUTE O PAGAMENTO DE PENSÕES DE COMPETÊNCIA DAS ENTIDADES DO ENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.10.07.00.00','REPASSE  CONCEDIDO AO RPPS A TITULO DE APORTE PARA AMORTIZAÇÃO DO DEFICIT ATUARIAL','REGISTRA TODOS OS REPASSES CONCEDIDOS AO RPPS DO MUNICIPIO A TITULO DE APORTE PARA AMORITIZAÇÃO DO DEFICIT ATUARIAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.01.99.00.00.00','OUTROS APORTES AO RPPS','REGISTRAR OS OUTROS APORTES FINANCEIROS REPASSADOS PELO ENTE AO RPPS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.0.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORCAMENTARIA','Compreende o valor das transferências financeiras, de bens ou valores concedidas para restos a pagar e outras finalidades independentes da execução orçamentária.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORCAMENTARIA - INTRA OFSS','Compreende o valor das transferências financeiras, de bens ou valores concedidas para restos a pagar e outras finalidades independentes da execução orçamentária.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.01.00.00.00.00','ORDEM DE TRANSFERENCIAS CONCEDIDAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO TOTAL DAS TRANSFERENCIAS NAO VINCULADAS AO ORCAMENTO, INCLUSIVE TRANSFERENCIAS PARA ATENDER RESTOS A PAGAR E OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.11.00.00.00.00','TRANSFERENCIAS CONCEDIDAS DE BENS IMOVEIS','REGISTRA O VALOR DAS TRANSFERENCIAS DE BENS IMOVEIS ENTRE UNIDADES  DO MESMO ORGAO .','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.12.00.00.00.00','DOACOES CONCEDIDAS DE BENS IMOVEIS','REGISTRA O VALOR DE DOACOES DE BENS IMOVEIS ENTRE UNIDADES DE ORGAOS DIFERENTES','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.13.00.00.00.00','TRANFERENCIAS CONCEDIDAS DE BENS MOVEIS','REGISTRA O VALOR DOS BENS MOVEIS PARA OUTRA UNIDADE, NO PAIS OU NO EXTERIOR, DO MESMO ORGÃO.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.14.00.00.00.00','DOACOES CONCEDIDAS DE BENS MOVEIS','REGISTRA O VALOR DOS BENS MOVEIS  CONCEDIDOS  POR UNIDADE LOCALIZADA NO  PAIS  PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DE ORGAOS DIFERENTES.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.01.07.00.00.00','DOACOES CONCEDIDAS DE BENS MOVEIS POR UNIDADE LOCALIZADA DO EXTERIOR','REGISTRA O VALOR DOS BENS MOVEIS  CONCEDIDOS  POR UNIDADE LOCALIZADA NO  EXTERIOR  PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR,  DE ORGAOS DIFERENTES.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.3.0.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS PARA COBERTURA DO DÉFICIT ATUARIAL DO RPPS POR APORTE PERIÓDICO','Compreende o valor das transferências financeiras para aportes periódicos destinados à cobertura do déficit atuarial do Regime Próprio de Previdência Social  - RPPS, conforme plano de amortização estabelecido em lei do respectivo ente Federativo, exceto as decorrentes de alíquota de contribuição suplementar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.3.2.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS PARA COBERTURA DO DÉFICIT ATUARIAL DO RPPS POR APORTE PERIÓDICO - INTRA OFSS','Compreende o valor das transferências financeiras para aportes periódicos destinados à cobertura do déficit atuarial do Regime Próprio de Previdência Social  - RPPS, conforme plano de amortização estabelecido em lei do respectivo ente Federativo, exceto as decorrentes de alíquota de contribuição suplementar. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.0.0.00.00.00.00.00','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes de transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.0.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS','Compreende as variações patrimoniais diminutivas  decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.1.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).  Por exemplo, empresa independente de um ente recebendo transferência de outro ente. (a empresa independente não pertence ao OFSS mas pertence ao conceito de governamental).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.3.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.3.01.00.00.00.00','PAGAMENTO DE LAUDEMIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA PRESTACAO DE SERVICOS POR PESSOAS JURIDICAS PARA ORGAOS PUBLICOS, DECORRENTES DE PAGAMENTO DE LAUDEMIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.3.02.00.00.00.00','CONTRIBUICOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS CONTRIBUICOES CONCEDIDAS A UNIAO PARA REALIZACAO DE OUTRAS DESPESAS CORRENTES, OU SEJA, DESPESAS AS  QUAIS  NAO  CORRESPONDA CONTRAPRESTACAO DIRETA EM BENS E SERVICOS E NAO SEJA REEMBOLSAVEL PELO RECEBEDOR, INCLUSIVE AS DESTINADAS A ATENDER A DESPESAS DE MANUTENÇÃO DE OUTRAS ENTIDADES DE DIREITO PÚBLICO OU PRIVADO, OBSERVADO O DISPOSTO NA LEGISLAÇÃO VIGENTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.3.03.00.00.00.00','TRANSFERENCIAS FUNSET-FUNDO NAC.SEGURANCA EDUC.TRANSITO(LF 9503/97)','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA PARCELA DAS MULTAS DE TRÂNSITO TRANSFERIDAS PARA O FUNDO FUNSET - 5% DA PARCELA RECEBIDA PELOS MUNICÍPIOS RELATIVA À REPASSES DO ESTADO DAS MULTAS DE TRÂNSITO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.3.04.00.00.00.00','TRANSFERENCIA VALORES A JUSTICA ELEITORAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE TRANSFERÊNCIAS DE VALORES À JUSTIÇA ELEITORAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.3.05.00.00.00.00','RESTITUICAO DE TRANSFERENCIAS E CONVENIOS RECEBIDOS DA UNIAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUIÇÕES DE CONVÊNIOS E TRANSFERÊNCIAS RECEBIDAS DA UNIÃO, COMO, POR EXEMPLO: SALDO DE JUROS DE APLICAÇÕES FINANCEIRAS; SALDOS DE VALORES NÃO UTILIZADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.01.00.00.00.00','CONTRIBUIÇÃO PATRONAL PARA O RPPS DO ESTADO REFERENTE A PESSOAL REQUISITADO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PAGAMENTO DE CONTRIBUIÇÃO PATRONAL QUANDO O SERVIDOR É CONTRIBUINTE DO RPPS DO ESTADO.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.02.00.00.00.00','PROGRAMA TROCA-TROCA','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS QUE O MUNICÍPIO TEM QUE REPASSAR PARA O ESTADO REFERENTE AO PROGRAMA TROCA-TROCA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.03.00.00.00.00','TRANSFERENCIAS PARA GRUPAMENTOS DE INCENDIO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS QUE O MUNICÍPIO TEM QUE REPASSAR PARA OS GRUPAMENTOS DE INCÊNDIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.04.00.00.00.00','RESTITUICAO DE TRANSFERENCIAS E CONVENIOS RECEBIDOS DO ESTADO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUIÇÕES DE CONVÊNIOS E TRANSFERÊNCIAS RECEBIDAS DO ESTADO, COMO, POR EXEMPLO: SALDO DE JUROS DE APLICAÇÕES FINANCEIRAS; SALDOS DE VALORES NÃO UTILIZADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.05.00.00.00.00','RESTITUICAO DE IPVA','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUIÇÕES DE IPVA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.5.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.5.01.00.00.00.00','CONTRIBUIÇÃO PATRONAL PARA RPPS DE OUTRO MUNICIPIO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS  DAS CONTRIBUICOES PATRONAIS QUE UM MUNICIPIO DEVA REPASSAR PARA O RPPS DE OUTRO MUNICIPIO EM RAZÃO DE OBRIGAÇAO PATRONAL DECORRENTE DE PRESTAÇÃO DE SERVIÇO DE SERVIDOR EFETIVO DE OUTRO MUNICIPIO COM ONUS PARA O MUNICIPIO REQUISITANTE.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.5.02.00.00.00.00','CONTRIBUICOES A ESCOLAS MUNICIPAIS','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DAS CONTRIBUIÇÕES PARA A MANUTENÇÃO DE ALUNOS MATRICULADOS EM ESCOLAS DE OUTROS MUNICÍPIOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.5.03.00.00.00.00','CONTRIBUICOES MUNICIPIO POLO DA CONTRAPARTIDA CONVENIO C/UNIAO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DAS CONTRIBUIÇÕES PARA O MUNICÍPIO POLO REFERENTE A CONTRAPARTIDA DE CONVÊNIOS RECEBIDOS POR VÁRIOS MUNICÍPIOS DA UNIÃO. EX: CONTRAPARTIDA FNDE','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.5.04.00.00.00.00','TRANSFERENCIA A MUNICIPIO EMANCIPADO PARA ACERTO DE  CONTAS','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DAS TRANSFERÊNCIAS REALIZADAS PELO MUNICÍPIO PARA O MUNICÍPIO EMANCIPADO PARA FINS DE ACERTO DE CONTAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.5.05.00.00.00.00','RESTITUICAO DE TRANSFERENCIAS E CONVENIOS RECEBIDOS DOS MUNICIPIOS','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUIÇÕES DE CONVÊNIOS E TRANSFERÊNCIAS RECEBIDAS DOS MUNICÍPIOS, COMO, POR EXEMPLO: SALDO DE JUROS DE APLICAÇÕES FINANCEIRAS; SALDOS DE VALORES NÃO UTILIZADOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.2.0.00.00.00.00.00','TRANSFERÊNCIAS AO FUNDEB','Compreende as variações patrimoniais diminutivas decorrentes da transferência de recursos dos entes, incluindo a complementação da União, para a composição do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.2.4.00.00.00.00.00','TRANSFERÊNCIAS AO FUNDEB -  INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes da transferência de recursos dos entes, incluindo a complementação da União, para a composição do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.0.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, bem como a demais entidades, de bens e/ou valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.1.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas decorrentes de transferências voluntárias a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).  Por exemplo, empresa independente de um ente recebendo transferência de outro ente. (A empresa independente não pertence ao OFSS, mas pertence ao conceito de governamental).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.3.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.4.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.5.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.0.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS','Compreende as variações patrimoniais diminutivas decorrentes de demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.1.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.3.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes de demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.4.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes de demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.5.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes de demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.0.0.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS','Compreende as variações patrimoniais diminutivas decorrentes das transferências financeiras a instituições privadas, inclusive de bens e valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.0.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas sem fins lucrativos que não tenham vinculo com a administração pública, exemplo: ONGs, OSCIPS e OS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.1.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas sem fins lucrativos que não tenham vinculo com a administração pública, exemplo: ONGs,OSCIPS E OS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.1.01.00.00.00.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - CONTRIBUICOES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS   EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO  DE  CONTRIBUICOES - VPD AS QUAIS NAO CORRESPONDA CONTRAPRESTACAO DIRETA EM BENS E SERVICOS E NAO SEJA REEMBOLSAVEL PELO RECEBEDOR, INCLUSIVE AS DESTINADAS A ATENDER A VARIACAO PATRIMONIAL DIMINUTIVA DE MANUTENCAO DE OUTRAS ENTIDADES DE DIREITO PUBLICO OU PRIVADO, OBSERVADO O DISPOSTO NA LEGISLACAO VIGENTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.1.01.01.00.00.00','INSTITUIÇÃO DE CARATER ASSISTENCIAL, CULTURAL E EDUCACIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS   EFETUADAS A INSTITUICOES DE CARATER ASSISTENCIAL, CULTURAL E EDUCACIONAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.1.01.10.00.00.00','ORGANIZAÇÕES DE SOCIEDADE CIVIL DE INTERESSE PUBLICO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS   EFETUADAS A ORGANIZAÇÕES DE SOCIEDADE CIVIL DE INTERESSE PUBLICO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.1.01.99.00.00.00','OUTRAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS   EFETUADAS A OUTRAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO  DE  CONTRIBUIÇÕES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.2.0.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas com fins lucrativos que não tenham vínculos com administração pública.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.2.1.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas com fins lucrativos, que não tenham vínculos com a administração pública. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.4.0.0.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES MULTIGOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes das transferências a instituições multigovernamentais, da quais o ente transferidor não participe.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.4.0.1.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências a instituições multigovernamentais, das quais o ente transferidor não participe.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.5.0.0.00.00.00.00.00','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências a consórcios públicos, dos quais o ente transferidor participe.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.5.0.1.00.00.00.00.00','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências a consórcios públicos, dos quais o ente transferidor participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.6.0.0.00.00.00.00.00','TRANSFERÊNCIAS AO EXTERIOR','Compreende as variações patrimoniais diminutivas decorrentes de transferências a organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.6.0.1.00.00.00.00.00','TRANSFERÊNCIAS AO EXTERIOR - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferências a organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior. Compreende os valores de operações efetuadas entre uma unidade pertencente ao orçamento fiscal e da seguridade social (OFSS) com unidade que não pertença ao OFSS de ente público.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.0.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) ou Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.1.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.1.3.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.1.4.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.1.5.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.2.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.2.1.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante. Compreende os valores de operações efetuadas entre uma unidade pertencente ao orçamento fiscal e da seguridade social (OFSS) com unidade que não pertença ao OFSS de ente público.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.0.0.0.00.00.00.00.00','DESVALORIZAÇÃO E PERDA DE ATIVOS','Compreende a variação patrimonial diminutiva com desvalorização e perdas de ativos, com redução a valor recuperável, com provisões para perdas, perdas com alienação e perdas involuntárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.0.0.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL E AJUSTE PARA PERDAS','Compreende o ajuste ao valor de mercado ou de consenso entre as partes para itens do ativo, quando esse for inferior ao valor liquido contábil, visando a assegurar que os ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda e também registra as variações patrimoniais diminutivas com ajustes para perdas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.0.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS','Compreende o ajuste ao valor de mercado ou de consenso entre as partes para investimentos, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','Registra o ajuste ao valor de mercado ou de consenso entre as partes para investimentos, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.2.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTRA OFSS','Registra o ajuste ao valor de mercado ou de consenso entre as partes para investimentos, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.3.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - UNIÃO','Registra o ajuste ao valor de mercado ou de consenso entre as partes para investimentos, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.4.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - ESTADO','Registra o ajuste ao valor de mercado ou de consenso entre as partes para investimentos, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.5.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Registra o ajuste ao valor de mercado ou de consenso entre as partes para investimentos, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.2.0.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO','Compreende o ajuste ao valor de mercado ou de consenso entre as partes para itens do ativo imobilizado, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.2.1.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','Registra o ajuste ao valor de mercado ou de consenso entre as partes para itens do ativo imobilizado, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.3.0.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS','Compreende o ajuste ao valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.3.1.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS - CONSOLIDAÇÃO','Registra o ajuste ao valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for inferior ao valor liquido contábil, visando a assegurar que tais ativos não estejam registrados contabilmente por um valor superior aquele passível de ser recuperado por uso ou por venda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Por exemplo, a variação patrimonial diminutiva com ajuste para créditos de liquidação duvidosa e ajuste para créditos da divida ativa.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.00.00.00.00','VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS - DIVIDA ATIVA TRIBUTARIA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS DA DIVIDA ATIVA  TRIBUTARIA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.01.00.00.00','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO','REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DE CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.02.00.00.00','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO','REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSAO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.03.00.00.00','DIVIDA ATIVA TRIBUTARIA -ANULACAO','REGISTRA OS VALORES RELATIVOS A ANULACAO DE CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.04.00.00.00','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE','REGISTRA OS VALORES RELATIVOS A PRESCRICAO INTERCORRENTE DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.05.00.00.00','DIVIDA ATIVA TRIBUTARIA - ADJUDICAÇÃO','REGISTRA OS VALORES RELATIVOS A ADJUDICAÇÃO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.06.00.00.00','DIVIDA ATIVA TRIBUTARIA -EXTINCAO','REGISTRA OS VALORES RELATIVOS A EXTINCAO DE CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.07.00.00.00','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.02.00.00.00.00','VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS - DIVIDA ATIVA NÃO TRIBUTARIA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS DA DIVIDA ATIVA NÃO TRIBUTARIA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.99.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS DE OUTROS CRÉDITOS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA PERDAS DE OUTROS CRÉDITOS, NÃO ESPECIFICADOS ACIMA,POR INADIMPLENCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CRÉDITOS. POR EXEMPLO: AJUSTE PARA CRÉDITOS DE LIQUIDACAO DUVIDOSA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.2.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTRA OFSS','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.3.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.4.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.5.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.5.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES','Compreende a variação patrimonial diminutiva com ajuste para redução a valor de mercado de estoques.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.5.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com ajuste para redução a valor de mercado de estoques. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.0.0.00.00.00.00.00','PERDAS COM ALIENAÇÃO','Compreende a perda com alienação de ativos, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.1.0.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS','Compreende a perda com alienação de investimentos, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.1.1.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','Registra a perda com alienação de investimentos, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.2.0.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE IMOBILIZADO','Compreende a perda com alienação de ativos imobilizados, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.2.1.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Registra a perda com alienação de ativos imobilizados, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.3.0.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS','Compreende a perda com alienação de ativos intangíveis, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.3.1.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Registra a perda com alienação de ativos intangíveis, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.0.0.00.00.00.00.00','PERDAS INVOLUNTÁRIAS','Compreendem o desfazimento físico involuntário do bem, como o que resulta de sinistros como incêndio e inundações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.1.0.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO','Compreendem o desfazimento físico involuntário de bem do ativo imobilizado, como o que resulta de sinistros como incêndio e inundações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.1.1.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO - CONSOLIDAÇÃO','Registra o desfazimento físico involuntário de bem do ativo imobilizado, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.2.0.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS','Compreendem o desfazimento físico involuntário de bem do ativo intangível, como o que resulta de sinistros como incêndio e inundações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.2.1.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS - CONSOLIDAÇÃO','Registra o desfazimento físico involuntário de bem do ativo intangível, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.3.0.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM ESTOQUES','Compreendem o desfazimento físico involuntário de bem do estoque, como o que resulta de sinistros como incêndio e inundações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.3.1.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM ESTOQUES - CONSOLIDAÇÃO','Registra o desfazimento físico involuntário de bem do estoque, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.9.0.00.00.00.00.00','OUTRAS PERDAS INVOLUNTÁRIAS','Compreendem o desfazimento físico involuntário de outros bens, como as que resultam de sinistros como incêndio e inundações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.9.1.00.00.00.00.00','OUTRAS PERDAS INVOLUNTÁRIAS - CONSOLIDAÇÃO','Registra o desfazimento físico involuntário de outros bens, como as que resultam de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.0.0.0.00.00.00.00.00','TRIBUTÁRIAS','Compreendem as variações patrimoniais diminutivas relativas aos impostos, taxas, contribuições de melhoria, contribuições sociais, contribuições econômicas e contribuições especiais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.0.0.00.00.00.00.00','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','Compreendem as variações patrimoniais diminutivas relativas às obrigações relativas às prestações pecuniárias compulsórias, em moeda ou cujo valor nela possa se exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade vinculada. Como: impostos, taxas e contribuições de melhoria.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.0.00.00.00.00.00','IMPOSTOS','Compreende as variações patrimoniais diminutivas com impostos, apurados no período de competência, e vinculados à atividade administrativa do contribuinte, definidos no CTN.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.00.00.00.00.00','IMPOSTOS- CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com impostos, apurados no período de competência e vinculados atividade administrativa do contribuinte, definidos no CTN. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.01.00.00.00.00','IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE PROPRIEDADE TERRITORIAL RURAL DE COMPETENCIA DA UNIAO RELATIVO A PROPRIEDADE, O DOMINIO UTIL OU POSSE DE IMOVEL POR NATUREZA LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO EM 01 DE JANEIRO DE CADA ANO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.02.00.00.00.00','IMPOSTO S/ PROPRIEDADE PREDIAL E TERRITORIAL URBANA','REGISTRA O VALOR DA VPD COM  IMPOSTO, DE COMPETENCIA DOS MUNICIPIOS E DISTRITO FEDERAL, SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM IMOVEL POR NATUREZA OU POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICIPIO E DO DISTRITO FEDERAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.03.00.00.00.00','IMPOSTO DE RENDA','REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I  DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II  DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NÃO COMPREENDIDOS NO ITEM ANTERIOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.04.00.00.00.00','ADICIONAL DO IMPOSTO DE RENDA','REGISTRA O VALOR DA VPD COM O ADICIONAL AO IRPJ.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.05.00.00.00.00','IMPOSTO S/ PROPRIEDADE DE VEICULOS AUTOMOTORES','REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.06.00.00.00.00','IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS','REGISTRA O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I  O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II  A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III  A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.07.00.00.00.00','IMPOSTO S/ CIRCULAÇÃO DE MERCADORIAS E SERVIÇOS','REGISTRA O VALOR  DA VPD COM IMPOSTO INCIDENTE SOBRE OPERAÇÕES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTAÇÕES DE SERVIÇOS DE TRANSPORTE INTERESTADUAL, INTERMUNICIPAL E DE COMUNICACAO, E E DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.08.00.00.00.00','IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA','REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA, DE COMPETENCIA DOS MUNICIPIOS E DO DISTRITO FEDERAL, TEM COMO FATO GERADOR A PRESTACAO DE SERVIÇOS CONSTANTES DA LISTA ANEXA DA LC 116/2003, AINDA QUE ESSES NÃO SE CONSTITUAM COMO ATIVIDADE PREPONDERANTE DO PRESTADOR. PODE SER RECOLHIDO PELO SUBSTITUTO TRIBUTARIO CONFORME LC 116/2003.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.09.00.00.00.00','IMPOSTO S/ OPERAÇÕES FINANCEIRAS','REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERAÇÕES DE CRÉDITO, CAMBIO E SEGURO, E SOBRE OPERAÇÕES RELATIVAS A TÍTULOS E VALORES MOBILIÁRIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERAÇÕES DE CRÉDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERAÇÕES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERAÇÕES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERAÇÕES RELATIVAS A TÍTULOS E VALORES MOBILIÁRIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.10.00.00.00.00','IMPOSTO S/ IMPORTAÇÃO','REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS TEM COMO FATO GERADOR A ENTRADA DESTES NO TERRITORIO NACIONAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.11.00.00.00.00','IMPOSTO S/ TRANSMISSAO DE IMOVEL INTER VIVOS','REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE A TRANSMISSAO "INTER VIVOS", A QUALQUER TITULO, POR ATO ONEROSO, DE BENS IMOVEIS, POR NATUREZA OU ACESSAO FISICA, E DE DIREITOS REAIS SOBRE IMOVEIS, EXCETO OS DE GARANTIA, BEM COMO CESSAO DE DIREITOS A SUA AQUISICAO.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.99.00.00.00.00','OUTROS IMPOSTOS','REGISTRA O VALOR DE VPDS COM OUTROS IMPOSTOS.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.2.0.00.00.00.00.00','TAXAS','Compreende as variações patrimoniais diminutivas com taxas cobradas pela União, Estados, Distrito Federal ou Municípios, no âmbito de suas respectivas contribuições, decorrentes da contraprestação de serviços públicos ao contribuinte postos a sua disposição, inclusive o exercício de poder de policia.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.2.1.00.00.00.00.00','TAXAS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas com taxas cobradas pela União, Estados, Distrito Federal ou Municípios, no âmbito de suas respectivas contribuições, decorrentes da contraprestação de serviços públicos ao contribuinte postos a sua disposição, inclusive o exercício de poder de policia. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.3.0.00.00.00.00.00','CONTRIBUIÇÕES DE MELHORIA','Compreende as variações patrimoniais diminutivas com tributo cuja obrigação tem por fato gerador um beneficio especial auferido pelo contribuinte que por consequência promove uma valorização imobiliária e patrimonial decorrente de obra pública de competência da União, Estados, Distrito Federal ou Municípios , amparadas em lei e limitadas ao total da despesa pública realizada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.3.1.00.00.00.00.00','CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas com titulo cuja obrigação tem por fato gerador um beneficio especial auferido pelo contribuinte que por consequência promove uma valorização imobiliária e patrimonial decorrente de obra pública de competência da União, Estados, Distrito Federal ou municípios, amparadas em lei e limitadas ao total da despesa pública realizada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.0.0.00.00.00.00.00','CONTRIBUIÇÕES','Compreende as variações patrimoniais diminutivas com contribuições sociais, econômicas e outras, decorrentes da intervenção do estado (União, estados, distrito federal e municípios) no domínio econômico e de interesse da categoria de profissionais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo estado, entre elas o PIS/PASEP, CSLL e COFINS, etc.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.01.00.00.00.00','CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS - CONSOLIDAÇÃO','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.02.00.00.00.00','PIS/PASEP','REGISTRA O VALOR DA  VPD  COM  CONTRIBUICAO  PARA  O  PROGRAMA  DE INTEGRACAO SOCIAL(PIS) OU PARA O PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO(PASEP)','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.03.00.00.00.00','CONTRIBUIÇÃO SOCIAL S/ LUCRO LIQUIDO - CSLL - CONSOLIDAÇÃO','REGISTRA O VALOR DA VPD COM CONTRIBUICAO SOCIAL INCIDENTE SOBRE  O LUCRO DA PESSOA JURIDICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.04.00.00.00.00','OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA FISICA','REGISTRA O VALOR DA VPD COM CONTRIBUICOES PREVIDENCIARIAS  SOBRE SERVICOS DE TERCEIROS PESSOAS FISICAS   CONTRATADAS PARA A EXECUCAO DE SERVICOS, SEM VINCULO COM A ADMINISTRACAO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.05.00.00.00.00','OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA JURIDICA','REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES  SOBRE  SERVICOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO:  - INSS (LEI 9876/99)','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.99.00.00.00.00','OUTRAS CONTRIBUICOES SOCIAIS','REGISTRA O VALOR DA VPD COM OUTRAS CONTRIBUICOES SOCIAIS','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.2.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - INTRA OFSS','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.3.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.4.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.5.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP,CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.2.0.00.00.00.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Compreende a variação patrimonial diminutiva com contribuições de intervenção no domínio econômico.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.2.1.00.00.00.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com contribuições de intervenção no domínio econômico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.2.1.01.00.00.00.00','CONTRIBUIÇÃO SINDICAL','REGISTRA O VALOR DA DESPESA COM ENCARGOS PATRONAIS RELATIVO A  CONTRIBUICAO SINDICAL.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.2.1.99.00.00.00.00','OUTRAS CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMINIO ECONOMICO','REGISTRA O VALOR DAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS COM OUTRAS CONTRIBUIÇÕES ECONOMICAS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.3.0.00.00.00.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP','Compreende o valor da variação patrimonial diminutiva com a contribuição para custeio do serviço de iluminação pública (art.149-a da C.F.)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.3.1.00.00.00.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP - CONSOLIDAÇÃO','Registra o valor da variação patrimonial diminutiva com a contribuição para custeio da iluminação pública (art.149-a da C.F.). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.9.0.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES','Compreende a variação patrimonial diminutiva com contribuições que não se enquadram na condição de sociais e econômicas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.9.1.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com contribuições que não se enquadram na condição de sociais e econômicas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.0.0.00.00.00.00.00','CUSTO COM TRIBUTOS','Compreende a variação patrimonial diminutiva relativa a tributos utilizados na produção de bens ou serviços, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.0.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.1.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - CONSOLIDAÇÃO','Compreende as variações diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.2.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTRA OFSS','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.3.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.4.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.5.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.0.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.1.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.2.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTRA OFSS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.3.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.4.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.5.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.0.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.1.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS -TRIBUTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.2.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS -TRIBUTOS -INTRA OFSS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.3.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.4.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.5.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.0.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','Compreende o somatório das variações patrimoniais diminutivas não incluídas nos grupos anteriores. Compreende: premiações, incentivos, equalizações de preços e taxas, participações e contribuições, resultado negativo com participações, dentre outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.0.0.00.00.00.00.00','PREMIAÇÕES','Compreende as aquisições de prêmios, condecorações, medalhas, troféus, etc., bem como com o pagamento de prêmios em pecúnia, inclusive decorrentes de sorteios lotéricos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.1.0.00.00.00.00.00','PREMIAÇÕES CULTURAIS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cultural.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.1.1.00.00.00.00.00','PREMIAÇÕES CULTURAIS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cultural.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.2.0.00.00.00.00.00','PREMIAÇÕES ARTÍSTICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter artístico.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.2.1.00.00.00.00.00','PREMIAÇÕES ARTÍSTICAS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter artístico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.3.0.00.00.00.00.00','PREMIAÇÕES CIENTIFICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cientifico.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.3.1.00.00.00.00.00','PREMIAÇÕES CIENTIFICAS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cientifico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.4.0.00.00.00.00.00','PREMIAÇÕES DESPORTIVAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter desportivo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.4.1.00.00.00.00.00','PREMIAÇÕES DESPORTIVAS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter desportivo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.5.0.00.00.00.00.00','ORDENS HONORIFICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, insígnias etc., relativo a ordens honorificas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.5.1.00.00.00.00.00','ORDENS HONORIFICAS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, insígnias etc., relativo a ordens honorificas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.9.0.00.00.00.00.00','OUTRAS PREMIAÇÕES','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., para finalidades diferentes das previstas nos detalhamentos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.9.1.00.00.00.00.00','OUTRAS PREMIAÇÕES - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., para finalidades diferentes das previstas nos detalhamentos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.0.0.00.00.00.00.00','RESULTADO NEGATIVO DE PARTICIPAÇÕES','Compreende a apropriação do resultado negativo de participações, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.0.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.1.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.2.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTRA OFSS','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.3.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - UNIÃO','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.4.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - ESTADO','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.5.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.0.0.00.00.00.00.00','INCENTIVOS','Compreende os incentivos financeiros concedidos relativos à educação, a ciência e a cultura','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.0.00.00.00.00.00','INCENTIVOS A EDUCAÇÃO','Compreende a ajuda financeira concedida pelo estado a estudantes comprovadamente carentes, e concessão de auxílio para o desenvolvimento de estudos e pesquisas de natureza cientifica realizadas por pessoas físicas na condição de estudante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.1.00.00.00.00.00','INCENTIVOS A EDUCAÇÃO - CONSOLIDAÇÃO','Compreende a ajuda financeira concedida pelo estado a estudantes comprovadamente carentes, e concessão de auxílio para o desenvolvimento de estudos e pesquisas de natureza cientifica realizadas por pessoas físicas na condição de estudante. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.1.01.00.00.00.00','BOLSA DE ESTUDOS NO PAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM BOLSAS DE ESTUDO    NO PAIS, A QUALQUER TITULO, E DEMAIS AUXILIOS FINANCEIROS A ESTUDANTES.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.1.02.00.00.00.00','BOLSA DE ESTUDOS NO EXTERIOR','REGISTRA AS  VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM BOLSAS DE ESTUDO   NO  EXTERIOR, A QUALQUER TITULO.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.1.99.00.00.00.00','OUTROS INCENTIVOS A EDUCACAO','REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INCENTIVOS A EDUCACAO NAO CONTEMPLADOS NOS ITENS ANTERIORES.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.2.0.00.00.00.00.00','INCENTIVOS A CIÊNCIA','Compreende o apoio financeiro concedido a pesquisadores, individual ou coletivamente, exceto na condição de estudante, no desenvolvimento de pesquisas cientificas e tecnológicas, nas suas mais diversas modalidades.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.2.1.00.00.00.00.00','INCENTIVOS A CIÊNCIA - CONSOLIDAÇÃO','Compreende o apoio financeiro concedido a pesquisadores, individual ou coletivamente, exceto na condição de estudante, no desenvolvimento de pesquisas cientificas e tecnológicas, nas suas mais diversas modalidades. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.2.1.01.00.00.00.00','AUXILIO A PESQUISADORES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO FINANCEIRO A PESQUISADORES, INDIVIDUAL OU  COLETIVAMENTE, EXCETO NA CONDICAO DE ESTUDANTE, NO DESENVOLVIMENTO DE PESQUISAS CIENTIFICAS E TECNOLOGICAS, NAS  SUAS DIVERSAS MODALIDADES.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.2.1.99.00.00.00.00','OUTROS INCENTIVOS A CIENCIA','REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INCENTIVOS A CULTURA NÃO CONTEMPLADOS NOS ITENS ANTERIORES.','D','S','P','U');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.3.0.00.00.00.00.00','INCENTIVOS A CULTURA','Compreende os incentivos financeiros concedidos, visando à promoção da cultura.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.3.1.00.00.00.00.00','INCENTIVOS A CULTURA - CONSOLIDAÇÃO','Registra os incentivos financeiros concedidos, visando à promoção da cultura.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.4.0.00.00.00.00.00','INCENTIVOS AO ESPORTE','Compreende os incentivos financeiros concedidos, visando à promoção do esporte.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.4.1.00.00.00.00.00','INCENTIVOS AO ESPORTE - CONSOLIDAÇÃO','Registra os incentivos financeiros concedidos, visando à promoção do esporte.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.9.0.00.00.00.00.00','OUTROS INCENTIVOS','Compreende outros incentivos financeiros concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.9.1.00.00.00.00.00','OUTROS INCENTIVOS - CONSOLIDAÇÃO','Registra os incentivos financeiros concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.5.0.0.00.00.00.00.00','SUBVENÇÕES ECONÔMICAS','Compreende a variação patrimonial diminutiva com o pagamento de subvenções econômicas, a qualquer título, autorizadas em leis específicas, tais como: ajuda financeira a entidades privadas com fins lucrativos; concessão de bonificações a produtores, distribuidores e vendedores; cobertura, direta ou indireta, de parcela de encargos de empréstimos e financiamentos e dos custos de aquisição, de produção, de escoamento, de distribuição, de venda e de manutenção de bens, produtos e serviços em geral; e, ainda, outras operações com características semelhantes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.5.0.1.00.00.00.00.00','SUBVENÇÕES ECONÔMICAS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com o pagamento de subvenções econômicas, a qualquer título, autorizadas em leis específicas, tais como: ajuda financeira a entidades privadas com fins lucrativos; concessão de bonificações a produtores, distribuidores e vendedores; cobertura, direta ou indireta, de parcela de encargos de empréstimos e financiamentos e dos custos de aquisição, de produção, de escoamento, de distribuição, de venda e de manutenção de bens, produtos e serviços em geral; e, ainda, outras operações com características semelhantes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.0.0.00.00.00.00.00','PARTICIPAÇÕES E CONTRIBUIÇÕES','Compreende as participações de terceiros nos lucros, não relativas ao investimento dos acionistas, tais como: participações de debêntures, empregados, administradores e partes beneficiárias, mesmo na forma de instrumentos financeiros, além da contribuição a instituições ou fundos de assistência ou previdência de empregados.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.1.0.00.00.00.00.00','PARTICIPAÇÕES DE DEBÊNTURES','Compreende as participações de debêntures incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.1.1.00.00.00.00.00','PARTICIPAÇÕES DE DEBÊNTURES - CONSOLIDAÇÃO','Registra as participações de debêntures incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.2.0.00.00.00.00.00','PARTICIPAÇÕES DE EMPREGADOS','Compreende as participações de empregados incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.2.1.00.00.00.00.00','PARTICIPAÇÕES DE EMPREGADOS - CONSOLIDAÇÃO','Registra as participações de empregados incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.3.0.00.00.00.00.00','PARTICIPAÇÕES DE ADMINISTRADORES','Compreende as participações de administradores incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.3.1.00.00.00.00.00','PARTICIPAÇÕES DE ADMINISTRADORES - CONSOLIDAÇÃO','Registra as participações de administradores incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.4.0.00.00.00.00.00','PARTICIPAÇÕES DE PARTES BENEFICIARIAS','Compreende as participações de partes beneficiarias incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.4.1.00.00.00.00.00','PARTICIPAÇÕES DE PARTES BENEFICIARIAS - CONSOLIDAÇÃO','Registra as participações de partes beneficiarias incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.5.0.00.00.00.00.00','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS','Compreende as contribuições da empresa, incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido, para instituições ou fundos de assistência ou previdência de empregados.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.5.1.00.00.00.00.00','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS - CONSOLIDAÇÃO','Registra as contribuições da empresa, incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro líquido, para instituições ou fundos de assistência ou previdência de empregados. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.0.0.00.00.00.00.00','VPD DE CONSTITUIÇÃO DE PROVISÕES','Registra a constituição de provisões, entendidas como os passivos de vencimento ou montante incertos. Não se confundem com os passivos derivados de apropriação por competência, como férias e décimo - terceiro salário.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.1.0.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.1.1.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS - CONSOLIDAÇÃO','Registra os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.2.0.00.00.00.00.00','VPD DE PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.2.1.00.00.00.00.00','VPD DE PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Registra a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.3.0.00.00.00.00.00','VPD DE PROVISÕES PARA RISCOS FISCAIS','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.3.1.00.00.00.00.00','VPD DE PROVISÕES PARA RISCOS FISCAIS - CONSOLIDAÇÃO','Registra a constituição de provisões de passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.4.0.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS CÍVEIS','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.4.1.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS CÍVEIS - CONSOLIDAÇÃO','Registra a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a pagamentos de indenizações a fornecedores e clientes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.5.0.00.00.00.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS','Compreende a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.5.3.00.00.00.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS - INTER OFSS - UNIÃO','Registra a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.5.4.00.00.00.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS - INTER OFSS - ESTADO','Registra a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.5.5.00.00.00.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS - INTER OFSS - MUNICÍPIO','Registra a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.6.0.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP','Compreende a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.6.1.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP - CONSOLIDAÇÃO','Registra a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.9.0.00.00.00.00.00','VPD DE OUTRAS PROVISÕES','Compreende a constituição de provisões de passivos de prazo ou de valor incertos não classificadas anteriormente neste plano de contas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.9.1.00.00.00.00.00','VPD DE OUTRAS PROVISÕES - CONSOLIDAÇÃO','Registra a constituição de provisões de passivos de prazo ou de valor incertos não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.0.0.00.00.00.00.00','CUSTO DE OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de bens ou serviços, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.1.0.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas as mercadorias, sendo registrado apenas no momento da venda destas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.1.1.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - OUTRAS VPD - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas apropriadas as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.2.0.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS - OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de bens, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.2.1.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS - OUTRAS VPD - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas apropriadas na produção de bens, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.3.0.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS - OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de serviços, sendo registrado apenas no momento da venda destes.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.3.1.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS - OUTRAS VPD - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas apropriadas na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.0.0.00.00.00.00.00','DIVERSAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','Compreende outras variações patrimoniais diminutivas não classificadas em itens específicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.1.0.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.1.2.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','Registra as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.1.3.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','Registra as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.1.4.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','Registra as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.1.5.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.2.0.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.2.3.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.2.4.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.2.5.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.3.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES','Compreende as variações patrimoniais diminutivas provenientes de bonificações concedidas na venda de mercadorias','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.3.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de bonificações concedidas na venda de mercadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.0.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.1.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.                                                                           Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.2.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTRA OFSS','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.                                                                                                Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.3.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.                                                                                                Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.4.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.                                                                                                Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.5.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.                                                                                                Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.9.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','Compreende as variações patrimoniais diminutivas decorrentes de fatos geradores diversos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.9.1.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de fatos geradores diversos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.0.0.0.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA','Compreende o aumento no beneficio econômico durante o período contábil sob a forma de entrada de recurso ou aumento de ativo ou diminuição de passivo, que resulte em aumento do patrimônio liquido e que não sejam provenientes de aporte dos proprietários.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.0.0.0.00.00.00.00.00','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','Compreende toda prestação pecuniária compulsória, em moeda ou cujo valor nela se possa exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade administrativa plenamente vinculada. Como: impostos, taxas e contribuições de melhoria.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.0.0.00.00.00.00.00','IMPOSTOS','Compreende como imposto o tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal especifica, relativa ao contribuinte.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.1.0.00.00.00.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR','Compreende os impostos sobre operações de comercio exterior, como por exemplo: impostos sobre a importação e imposto sobre a exportação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.1.1.00.00.00.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR - CONSOLIDAÇÃO','Compreende os impostos sobre operações de comercio exterior, como exemplo: impostos sobre a importação e imposto sobre a exportação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.0.00.00.00.00.00','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA','Compreende os impostos sobre patrimônio e a renda, como por exemplo: imposto sobre a propriedade territorial rural, imposto sobre a propriedade predial e territorial urbana, imposto sobre a transmissão de bens imóveis e de direitos a eles relativos e impostos sobre a renda e proventos de qualquer natureza.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.00.00.00.00.00','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA - CONSOLIDAÇÃO','Compreende os impostos sobre patrimônio e a renda, como exemplo: imposto sobre a propriedade territorial rural,imposto sobre a propriedade predial e territorial urbana,imposto sobre a transmissão de bens imóveis e de direitos a eles relativos e imposto sobre a renda e proventos de qualquer natureza. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.01.00.00.00.00','ITR - MUNICIPIOS CONVENIADOS','REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS. FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO, CONFORME CONVENIO  COM A UNIAO PARA FISCALIZACAO DO REFERIDO IMPOSTO; DESTINACAO LEGAL: O MUNICIPIO OU O DISTRITO FEDERAL OPTANTE FARA JUS A TOTALIDADE DO PRODUTO DA ARRECADACAO DO ITR REFERENTE  AOS  IMOVEIS RURAIS NELE SITUADOS, A PARTIR DO MOMENTO DISCIPLINADO NO CONVENIO;  AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III; B)LEI 5172/1966 ART 29 A 31; C) EC 42/2003; D) LEI 9393/1996; E) LEI 11250/2005. INCLUI-SE AQUI O REGISTRO DA VPA DA DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.02.00.00.00.00','IR RETIDO NAS FONTES - TRABALHO','REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - TRABALHO. INCLUI-SE AQUI O REGISTRO DA VPA DA DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.03.00.00.00.00','IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA - IPTU','REGISTRA O VALOR TOTAL DA VPA DE IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA,  DE COMPETENCIA DOS MUNICIPIOS. TEM  COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM    IMOVEL POR NATUREZA OU  POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICIPIO. INCLUI-SE AQUI O REGISTRO DA VPA DA DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.04.00.00.00.00','IMPOSTO SOBRE TRANSMISSAO "INTER-VIVOS" DE BENS IMOVEIS E DE DIREITOS REAIS SOBRE IMOVEIS - ITBI','REGISTRA O VALOR TOTAL DA VPA DE IMPOSTO SOBRE TRANSMISSÃO "INTER-VIVOS" DE BENS IMÓVEIS E DE DIREITOS REAIS SOBRE IMÓVEIS DE COMPETÊNCIA MUNICIPAL, INCIDE SOBRE O VALOR VENAL DOS BENS OU DIREITOS TRANSMITIDOS OU CEDIDOS. TEM O FATO GERADOR NO MOMENTO DA LAVRADURA DO INSTRUMENTO OU ATO QUE SERVIR DE TÍTULO ÀS TRANSMISSÕES OU ÀS CESSÕES. INCLUI-SE AQUI O REGISTRO DA VPA DA DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.97.00.00.00.00','(-) DEDUCOES DO IMPOSTOS SOBRE PATRIMONIO E A RENDA','COMPREENDEM  AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM OS IMPOSTOS SOBRE O PATRIMONIO E A RENDA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.97.01.00.00.00','(-) DEDUÇÕES DO IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','REGISTRA AS DEDUÇÕES DAS VPA COM O IMPOSTO S/PROPRIEDADE TERRITORIAL RURAL, DE COMPETENCIA DA UNIAO. TEM COMO FATO GERADOR A  PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL POR NATUREZA, COMO  DEFINIDO NA LEI CIVIL, LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.97.02.00.00.00','(-) DEDUÇÕES DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','REGISTRA O VALOR DAS DEDUÇÕES DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA. TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I - DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II - DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.97.03.00.00.00','(-) DEDUÇÕES DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA - IPTU','REGISTRA O VALOR TOTAL DAS DEDUÇÕES DE VPA DE IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA,  DE COMPETENCIA DOS MUNICIPIOS. TEM  COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM    IMOVEL POR NATUREZA OU  POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICIPIO.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.97.04.00.00.00','(-) DEDUÇÕES DO IMPOSTO SOBRE TRANSMISSAO "INTER-VIVOS" DE BENS IMOVEIS E DE DIREITOS REAIS SOBRE IMOVEIS - ITBI','REGISTRA O VALOR TOTAL DA DEDUÇÃO DA VPA DE IMPOSTO SOBRE TRANSMISSÃO "INTER-VIVOS" DE BENS IMÓVEIS E DE DIREITOS REAIS SOBRE IMÓVEIS DE COMPETÊNCIA MUNICIPAL, INCIDE SOBRE O VALOR VENAL DOS BENS OU DIREITOS TRANSMITIDOS OU CEDIDOS. TEM O FATO GERADOR NO MOMENTO DA LAVRADURA DO INSTRUMENTO OU ATO QUE SERVIR DE TÍTULO ÀS TRANSMISSÕES OU ÀS CESSÕES.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.0.00.00.00.00.00','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO','Compreende os impostos sobre a produção e a circulação, como por exemplo: imposto sobre produtos industrializados; imposto sobre operações de credito, câmbio e seguro, e sobre operações relativas a títulos e valores mobiliários; imposto sobre serviços de qualquer natureza.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.00.00.00.00.00','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO - CONSOLIDAÇÃO','Com prende os impostos sobre a produção e a circulação como, por exemplo, imposto sobre produtos industrializados;imposto sobre operações de credito, cambio e seguro, e sobre operações relativas a títulos e valores mobiliários, imposto sobre serviços de qualquer natureza.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.01.00.00.00.00','IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA','REGISTRA O VALOR TOTAL DA VPA DE IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA DE COMPETÊNCIA DOS MUNICÍPIOS. TEM COMO FATO GERADOR A PRESTAÇÃO, POR EMPRESA OU PROFISSIONAL AUTÔNOMO, COM OU SEM ESTABELECIMENTO FIXO, DE SERVIÇOS CONSTANTES EM LISTA PRÓPRIA. O ADICIONAL DE ISS PARA CONSTITUIÇÃO DO FUNDO MUNICIPAL DE COMBATE À POBREZA SERÁ REGISTRADO EM NATUREZA ESPECÍFICA.INCLUI-SE AQUI O REGISTRO DA VPA DA DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.02.00.00.00.00','ADICIONAL ISS - FUNDO MUNICIPAL DE COMBATE Á POBREZA','REGISTRA O VALOR DA VPA DECORRENTE DA APLICAÇÃO DE ADICIONAL DE ATÉ MEIO PONTO PERCENTUAL NA ALÍQUOTA DO IMPOSTO SOBRE SERVIÇOS OU DO IMPOSTO QUE VIER A SUBSTITUÍ-LO, SOBRE PRODUTOS SUPÉRFLUOS, PARA A CONSTITUIÇÃO DO FUNDO MUNICIPAL DE COMBATE À POBREZA, CONFORME ESTABELECE O ARTIGO 82, § 2º, ADCT, CF/1988.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.97.00.00.00.00','(-) DEDUÇÃO DOS IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO','COMPREENDE A DEDUÇÃO DOS IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO, COMO POR EXEMPLO: IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS; IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS;IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA;','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.97.01.00.00.00','(-) DEDUÇÃO DO IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA','REGISTRA O VALOR TOTAL DEDUÇÃO DA VPA DE IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA DE COMPETÊNCIA DOS MUNICÍPIOS. TEM COMO FATO GERADOR A PRESTAÇÃO, POR EMPRESA OU PROFISSIONAL AUTÔNOMO, COM OU SEM ESTABELECIMENTO FIXO, DE SERVIÇOS CONSTANTES EM LISTA PRÓPRIA. O ADICIONAL DE ISS PARA CONSTITUIÇÃO DO FUNDO MUNICIPAL DE COMBATE À POBREZA SERÁ REGISTRADO EM NATUREZA ESPECÍFICA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.97.02.00.00.00','(-) DEDUÇÃO DO ADICIONAL ISS - FUNDO MUNICIPAL DE COMBATE Á POBREZA','REGISTRA O VALOR DA DEDUÇÃO DA VPA DECORRENTE DA APLICAÇÃO DE ADICIONAL DE ATÉ MEIO PONTO PERCENTUAL NA ALÍQUOTA DO IMPOSTO SOBRE SERVIÇOS OU DO IMPOSTO QUE VIER A SUBSTITUÍ-LO, SOBRE PRODUTOS SUPÉRFLUOS, PARA A CONSTITUIÇÃO DO FUNDO MUNICIPAL DE COMBATE À POBREZA, CONFORME ESTABELECE O ARTIGO 82, § 2º, ADCT, CF/1988.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.4.0.00.00.00.00.00','IMPOSTOS EXTRAORDINÁRIOS','Compreende os impostos instituídos pela União, temporariamente, na iminência ou no caso de guerra externa, suprimidos, gradativamente, no prazo Maximo de cinco anos, contados da celebração da paz.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.4.1.00.00.00.00.00','IMPOSTOS EXTRAORDINÁRIOS - CONSOLIDAÇÃO','Registra os impostos instituídos pela União, temporariamente, na iminência ou no caso de guerra externa, suprimidos,gradativamente, no prazo Maximo de cinco anos, contados da celebração da paz.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.9.0.00.00.00.00.00','OUTROS IMPOSTOS','Compreende os demais impostos não classificados nos grupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.9.1.00.00.00.00.00','OUTROS IMPOSTOS - CONSOLIDAÇÃO','Compreende os demais impostos não classificados nos grupos anteriores.  Compreende os valores de operações efetuadas entre uma unidade pertinente ao orçamento fiscal e da seguridade social (OFSS) com pessoa ou unidade que não pertença ao OFSS de ente público, alem dos demais fatos que não compreendem transações entre partes.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.0.0.00.00.00.00.00','TAXAS','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, tem como fato gerador o exercício regular do poder de policia, ou a utilização, efetiva ou potencial, de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.0.00.00.00.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a prática de ato ou abstenção de fato, em razão de interesse público.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.00.00.00.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA - CONSOLIDAÇÃO','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.01.00.00.00.00','TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA','REGISTRA A VPA COM  TAXA PELA FISCALIZACAO DE VIGILANCIA SANITARIA EXERCIDA PELA AGENCIA NACIONAL DE VIGILANCIA  SANITARIA SOBRE AS PESSOAS FISICAS E JURIDICAS QUE EXERCAM ATIVIDADES   DE FABRICACAO, DISTRIBUICAO E VENDA DE PRODUTOS E A PRESTACAO DE SERVICOS MENCIONADOS NO ARTIGO 8. DA LEI 9782/99. OS RECURSOS SAO VINCULADOS  A AGENCIA NACIONAL DE VIGILANCIA SANITARIA. INCLUI-SE AQUI O REGISTRO DA VPA DA DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.02.00.00.00.00','TAXA DE CONTROLE E FISCALIZACAO AMBIENTAL','REGISTRA  A VPA PROVENIENTE  DA  TAXA  DE  FISCALIZACAO AMBIENTAL, DEVIDA POR PESSOAS FISICAS OU JURIDICAS OBRIGADAS AO REGISTRO NO CADASTRO TECNICO FEDERAL  DE  ATIVIDADES  POTENCIALMENTE  POLUIDORAS OU UTILIZADORAS DE RECURSOS AMBIENTAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.03.00.00.00.00','TAXA DE LICENCA PARA FUNCIONAMENTO DE ESTABELECIMENTOS COMERCIAIS,  INDUSTRIAIS E PRESTADORA DE SERVIÇOS','REGISTRA O VALOR DA VPA DE TAXA DE FISCALIZAÇÃO DA LOCALIZAÇÃO DE ESTABELECIMENTOS COMERCIAIS, INDUSTRIAS E DE PRESTAÇÃO DE SERVIÇOS, INSTITUÍDA PELA LEGISLAÇÃO DO USO E OCUPAÇÃO DO SOLO URBANO ÀS POSTURAS MUNICIPAIS RELATIVAS À SEGURANÇA, ORDEM E TRANQÜILIDADE PÚBLICAS. EX: TAXA DE FISCALIZAÇÃO OU VISTORIA EM ESTABELECIMENTOS DE QUALQUER NATUREZA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.04.00.00.00.00','TAXA DE PUBLICIDADE COMERCIAL','REGISTRA O VALOR DA VPA DE RECEITA DE TAXA DE UTILIZAÇÃO DE ESPAÇO PÚBLICO DESTINADO PARA DIVULGAÇÃO DE PRODUTOS DO COMÉRCIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.05.00.00.00.00','TAXA DE APREENSAO E DEPOSITO','REGISTRA O VALOR DA VPA  DE TAXA DE APREENSÃO E DEPÓSITO DE BENS ORIUNDOS DE IRREGULARIDADES APRESENTADAS QUANDO DA FISCALIZAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.06.00.00.00.00','TAXA DE FUNCIONAMENTO DE ESTABELECIMENTOS EM HORARIO ESPECIAL','REGISTRA O VALOR DA VPA DE TAXA DE FUNCIONAMENTO DE ESTABELECIMENTOS EM HORÁRIO ESPECIAL. A RESPECTIVA TAXA É DESTINADA A BARES, BOATES, BARRACAS POR OCASIÃO DE FESTAS CARNAVALESCAS, PODENDO FUNCIONAR A QUALQUER HORA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.07.00.00.00.00','TAXA DE LICENCA PARA EXECUCAO DE OBRAS','REGISTRA O VALOR DA VPA DE TAXA DE LICENÇA PARA EXECUÇÃO DE OBRAS. A RESPECTIVA TAXA É COBRADA DO RESPONSÁVEL PELA EXECUÇÃO DAS OBRAS EM OBSERVÂNCIA AOS CRITÉRIOS DESCRITOS EM LEI.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.08.00.00.00.00','TAXA DE AUTORIZACAO DE FUNCIONAMENTO DE TRANSPORTE','REGISTRA O VALOR DA VPA DE TAXA DE AUTORIZAÇÃO DE FUNCIONAMENTO DE TRANSPORTE, CARACTERIZADA PELA AUTORIZAÇÃO AOS PROPRIETÁRIOS DE VEÍCULOS QUE PRESTAM SERVIÇOS À COMUNIDADE DE TRANSPORTE DE PASSAGEIROS TAIS COMO: TRANSPORTE ESCOLAR, DE FUNCIONÁRIOS E OUTROS PASSAGEIROS. EX: TAXA DE FISCALIZAÇÃO DE VEÍCULOS DE USO COLETIVO','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.09.00.00.00.00','TAXA DE UTILIZACAO DE AREA DE DOMINIO PUBLICO','REGISTRA O VALOR DA VPA DE TAXA DE UTILIZAÇÃO DE ÁREA DE DOMÍNIO PÚBLICO, REFERENTE A ESPAÇO OCUPADO POR BALCÕES, BARRACAS, MESAS, TABULEIROS E SEMELHANTES, NAS FEIRAS, VIAS E LOGRADOUROS PÚBLICOS OU COMO DEPÓSITO DE MATERIAIS OU ESTACIONAMENTO DE VEÍCULOS EM LOCAIS DESIGNADOS PELA PREFEITURA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.10.00.00.00.00','TAXA DE APROVACAO DO PROJETO DE CONSTRUCAO CIVIL','REGISTRA O VALOR DA VPA DA TAXA DE LICENÇA E APROVAÇÃO DO PROJETO DE CONSTRUÇÃO CIVIL CORRESPONDENTE A CERTIFICAÇÃO DAS CONDIÇÕES DE UTILIZAÇÃO DE PRÉDIOS E RESIDÊNCIAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.11.00.00.00.00','TAXA DE FISCALIZACAO DE APARELHOS DE TRANSPORTE','REGISTRA O VALOR DA VPA DA TAXA DE FISCALIZAÇÃO EXERCIDA EM INSTALAÇÕES (CONSERVAÇÃO E FUNCIONAMENTO) DE ELEVADORES DE PASSAGEIROS E DE CARGAS, DE ALÇAPÕES, ESCADAS ROLANTES, PLANOS INCLINADOS MÓVEIS E OUTROS DE NATUREZA ESPECIAL, EM OBSERVÂNCIA A LEGISLAÇÃO ESPECÍFICA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.12.00.00.00.00','TAXA DE ALINHAMENTO E NIVELAMENTO','REGISTRA O VALOR DA VPA DA TAXA DE FISCALIZAÇÃO DA METRAGEM NO TOCANTE AO ALINHAMENTO E NIVELAMENTO DE ÁREAS OU TERRENOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.13.00.00.00.00','TAXA DE APREENSAO, DEPOSITO OU LIBERACAO DE ANIMAIS','REGISTRA O VALOR DA VPA DA TAXA DE APREENSÃO, DEPÓSITO OU LIBERAÇÃO DE ANIMAIS RECOLHIDOS EM RUAS EM FUNÇÃO DE RISCOS CAUSADOS À POPULAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.96.00.00.00.00','OUTRAS TAXAS PELO EXERCICIO DO PODER DE POLICIA','REGISTRA O VALOR DA VPA DE OUTRAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA, NÃO CLASSIFICADAS NOS ITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.97.00.00.00.00','(-) DEDUCOES DAS TAXAS PELO EXERCICIO DO PODER DE POLÍCIA','REGISTRA  AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS REFERENTES AS TAXAS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.0.00.00.00.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, tem como fato gerador a utilização, efetiva ou potencial, de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.00.00.00.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições tem como fato gerador a utilização, efetiva ou potencial, de serviço público específico e divisível prestado ao contribuinte ou posto a sua disposição. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.01.00.00.00.00','EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRATIVAS','REGISTRA A  VPA PROVENIENTE DE TAXA DE EMOLUMENTOS E CUSTAS PROCESSUAIS POR ENTIDADES DA ADMINISTRAÇÃO PÚBLICA FEDERAL, ESTADUAL E MUNICIPAL, EM DECORRÊNCIA DA PRESTAÇÃO DE SERVIÇOS DE CONSULTAS E ANÁLISES DE PROCESSOS EM SUAS RESPECTIVAS COMPETENCIAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.02.00.00.00.00','TAXAS DE SERVICOS CADASTRAIS','REGISTRA A VPA PROVENIENTE DAS TAXAS DE SERVICOS  CADASTRAIS, TENDO COMO FATO GERADOR A  APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA, DA TAXA DE SERVICOS CADASTRAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.03.00.00.00.00','TAXA DE CEMITERIO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TAXA DE PRESTAÇÃO DE SERVIÇOS DE ADMINISTRAÇÃO DE CEMITÉRIOS REFERENTES A UTILIZAÇÃO DE NECROTÉRIO E OCUPAÇÃO DA SALA MORTUÁRIA, BEM COMO MATRÍCULAS, ENTRADA E SAÍDA DE OSSOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.04.00.00.00.00','EMOLUMENTOS E CUSTAS EXTRAJUDICIAIS','REGISTRA O VALOR DA VPA DA TAXA DE SERVIÇOS EXTRAJUDCIAIS REFERENTES AOS ATOS PRATICADOS EM RAZÃO DO OFÍCIO. SERVENTIAS EXTRAJUDICIAIS, ATIVIDADES PRATICADAS PELOS SERVIÇOS NOTARIAIS E DE REGISTRO: LANÇAMENTO EM LIVROS, CERTIDÕES, TRANS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.05.00.00.00.00','TAXA DE LIMPEZA PUBLICA','REGISTRA O VALOR DA VPA RECEBIDA PELA UTILIZAÇÃO EFETIVA OU POTENCIAL DO SERVIÇO PELO PROPRIETÁRIO DE IMÓVEL EDIFICADO OU NÃO, SITUADO EM LOGRADOURO BENEFICIADO PELA COLETA DO LIXO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.06.00.00.00.00','TAXA DE REGISTRO/INSPECAO DE PRODUTOS AGROPECUARIOS','REGISTRA O VALOR DA VPA DA TAXA DE REGISTRO E INSPEÇÃO DE PRODUTOS AGROPECUÁRIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.07.00.00.00.00','TAXA DE SERVICOS PRESTADOS - ARQUIVO HISTORICO MUNICIPAL','REGISTRA O VALOR DA VPA DA TAXA DE SERVIÇOS PRESTADOS - ARQUIVO HISTÓRICO MUNICIPAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.08.00.00.00.00','TAXA DE REGISTRO NO CADASTRO TECNICO AMBIENTAL MUNICIPAL','REGISTRA O VALOR DA VPA DA TAXA DE REGISTRO NO CADASTRO TÉCNICO AMBIENTAL MUNICIPAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.09.00.00.00.00','TAXA DE EMISSAO DE CERTIDOES','REGISTRA O VALOR DA VPA DA TAXA DE EMISSÃO DE CERTIDÕES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.10.00.00.00.00','TAXA DE AGUA SOBRE TERRENOS BALDIOS','REGISTRA O VALOR DA VPA DA TAXA DE ÁGUA SOBRE TERRENOS BALDIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.96.00.00.00.00','OUTRAS TAXAS PELA PRESTACAO DE SERVICOS','REGISTRA A VPA PROVENIENTE DE OUTRAS TAXAS PELA UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU  POSTO A SUA DISPOSICAO, QUE NAO ESTEJAM REFERENCIADAS NAS NATUREZAS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.97.00.00.00.00','(-) DEDUCOES DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','REGISTRA  AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM TAXAS PELA PRESTAÇÃO DE SERVIÇOS.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.0.0.00.00.00.00.00','CONTRIBUIÇÕES DE MELHORIA','Compreende como contribuição de melhoria o tributo cobrado pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, sendo instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária, tendo como limite total a despesa realizada e como limite individual o acréscimo de valor que da obra resultar para cada imóvel beneficiado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.1.0.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede de água potável e esgoto sanitário.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.1.1.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO - CONSOLIDAÇÃO','Registra o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedade em função da pavimentação asiática, bem como pela colocação de guias, sarjetas e calcamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.2.0.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede de iluminação pública na cidade.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.2.1.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE - CONSOLIDAÇÃO','Registra o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede iluminação pública na cidade.   Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.3.0.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL','Compreende o valor da arrecadação de receita sobre a cobrança decorrente de valorização de propriedades em função da expansão da rede de iluminação pública rural.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.3.1.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL - CONSOLIDAÇÃO','Registra o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede iluminação pública rural.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.4.0.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da pavimentação asfáltica, bem como pela colocação de guias, sarjetas e calçamento.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.4.1.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES - CONSOLIDAÇÃO','Registra o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da pavimentação asfáltica, bem como pela colocação de guias, sarjetas e calçamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.9.0.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA','Compreende o valor de outras contribuições de melhorias, não classificadas em itens específicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.9.1.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','Registra o valor de outras contribuições de melhorias, não classificadas em itens específicos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.0.0.0.00.00.00.00.00','CONTRIBUIÇÕES','Compreende toda prestação pecuniária compulsória, em moeda ou cujo valor nela se possa exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade administrativa plenamente vinculada. Como: contribuições.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.0.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS','Compreendem como contribuições sociais: a) as das empresas, incidentes sobre a remuneração paga ou creditada aos segurados a seu serviço; b) as dos empregadores domésticos; c) as dos trabalhadores, incidentes sobre o seu salário-de-contribuição; d) as sobre a receita e faturamento; e) as sobre o lucro; f) do importador de bens ou serviços do exterior; g) e outros','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - CONSOLIDAÇÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social.   Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.01.00.00.00.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','Compreende a contribuição patronal destinada ao custeio do Regime Próprio de Previdência Social.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.00.00.00.00','CONTRIBUIÇÃO DO SEGURADO AO RPPS','Compreende a contribuição ao RPPS dos segurados, servidor ativo, servidor inativo e pensionista sobre a sua remuneração.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.01.00.00.00','CONTRIBUIÇÃO DO SERVIDOR CIVIL - RPPS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DO SERVIDOR CIVIL - RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.02.00.00.00','CONTRIBUIÇÃO DO APOSENTADO CIVIL - RPPS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DO APOSENTADO CIVIL - RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.03.00.00.00','CONTRIBUIÇÃO DE PENSIONISTA CIVIL - RPPS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DE PENSIONISTA CIVIL - RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.04.00.00.00','CONTRIBUIÇÃO DE SERVIDOR CIVIL - PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DE SERVIDOR CIVIL - PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.05.00.00.00','CONTRIBUIÇÃO DE APOSENTADO CIVIL - PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DE APOSENTADO CIVIL - PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.06.00.00.00','CONTRIBUIÇÃO DE PENSIONISTA CIVIL - PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO DE PENSIONISTA CIVIL - PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.03.00.00.00.00','CONTRIBUIÇÃO PREVIDENCIÁRIA  PARA AMORTIZAÇÃO DO DÉFICIT ATUARIAL','Registra a VPA oriunda de contribuições previdenciárias para amortização do déficit atuarial.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.04.00.00.00.00','CONTRIBUIÇÕES PARA  CUSTEIO DAS PENSÕES  MILITARES','Registra as VPA provenientes de contribuição para custeio das pensões militares, efetivadas por todos os militares, com valor correspondente a seu posto ou graduação, observando as exceções previstas na lei especifica. De competência da União e dos Estados.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.97.00.00.00.00','(-) DEDUCOES','Compreendem as deduções das contribuições sociais - RPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.97.10.00.00.00','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CONTRIBUIÇÕES SOCIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.99.00.00.00.00','OUTRAS CONTRIBUIÇÕES  SOCIAIS - RPPS','Registra o valor das VPA oriundas de contribuições previdenciárias não enquadradas nos subitens anteriores.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTRA OFSS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.01.00.00.00.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.01.01.00.00.00','CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL - RPPS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL - RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.01.02.00.00.00','CONTRIBUIÇÃO PATRONAL - PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE CONTRIBUIÇÃO PATRONAL - PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.97.00.00.00.00','(-) DEDUCOES','REGISTRA A DEDUCAO POR RENUNCIA DE VARIAÇÕES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CRÉDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NÃO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUIÇÕES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.97.10.00.00.00','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CONTRIBUIÇÕES SOCIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.99.00.00.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUIÇÕES PREVIDENCIARIAS NÃO EN-QUADRADAS NOS SUBITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.3.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - UNIÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social.    Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.3.01.00.00.00.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.3.01.01.00.00.00','CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL - RPPS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE DA CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL - RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.3.01.02.00.00.00','CONTRIBUIÇÃO PATRONAL - PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VARIAÇÃO PATRIMONIAL AUMENTATIVA DECORRENTE CONTRIBUIÇÃO PATRONAL - PAGAMENTO DE SENTENÇAS JUDICIAIS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.3.99.00.00.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUIÇÕES PREVIDENCIARIAS NÃO EN-QUADRADAS NOS SUBITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.4.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - ESTADO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.5.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - MUNICÍPIO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.1.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - CONSOLIDAÇÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.2.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTRA OFSS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.3.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - UNIÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.4.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - ESTADO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.5.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - MUNICÍPIO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.3.0.00.00.00.00.00','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO','Compreende a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre a receita ou o faturamento, como por exemplo: COFINS, PIS/PASEP.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.3.1.00.00.00.00.00','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO - CONSOLIDAÇÃO','Compreende a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre a receita ou o faturamento, como por exemplo: COFINS, PIS/PASEP.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.4.0.00.00.00.00.00','CONTRIBUIÇÃO SOBRE O LUCRO','Compreende a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre o lucro, como por exemplo: CSLL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.4.1.00.00.00.00.00','CONTRIBUIÇÃO SOBRE O LUCRO - CONSOLIDAÇÃO','Registra a contribuição do empregador,da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre o lucro, como por exemplo: CSLL.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.5.0.00.00.00.00.00','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO','Compreende a contribuição sobre a receita de concursos de prognósticos, que são todos e quaisquer concursos de sorteios de números, loterias, apostas, inclusive as realizadas em reuniões hípicas, nos âmbitos federal, estadual, do Distrito Federal e municipais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.5.1.00.00.00.00.00','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO - CONSOLIDAÇÃO','Compreende a contribuição sobre a receita de concursos de prognósticos, que são todos e quaisquer concursos de sorteios de números, loterias, apostas, inclusive as realizadas em reuniões hípicas, nos âmbitos federal, estadual, do Distrito Federal e municipais.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.6.0.00.00.00.00.00','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR','Compreende a contribuição social paga pelo importador de bens ou serviços do exterior, ou de quem a lei a ele equiparar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.6.1.00.00.00.00.00','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR - CONSOLIDAÇÃO','Registra a contribuição social paga pelo importador de bens ou serviços do exterior, ou de quem a lei a ele equiparar.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.0.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','Compreende o valor de outras contribuições sociais, não classificadas em itens específicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','Compreende o valor de outras contribuições sociais, não classificadas em itens específicos.     Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.00.00.00.00','CONTRIBUIÇÃO SOCIAL PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL','APRESENTAR O SOMATÓRIO DAS CONTRIBUICOES PARA O FINANCIAMENTO DA  SEGURIDADE SOCIAL RECEBIDAS DOS SERVIDORES MUNICIPAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.01.00.00.00','CONTRIBUICAO DOS SERVIDORES ATIVOS PARA A ASSISTENCIA SOCIAL DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO SERVIDOR ATIVO PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.02.00.00.00','CONTRIBUICAO SERVIDORES INATIVOS E PENSIONISTAS PARA A ASSISTENCIA SOCIAL DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO SERVIDOR INATIVO E PENSIONISTAS PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.03.00.00.00','CONTRIBUICAO DOS SERVIDORES ATIVOS PARA A ASSISTENCIA MEDICA DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO SERVIDOR ATIVO PARA A ASSISTÊNCIA MEDICA DO SERVIDOR','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.04.00.00.00','CONTRIBUICAO DOS SERVIDORES INATIVOS PARA A ASSISTENCIA MEDICA DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO SERVIDOR INATIVO PARA A ASSISTÊNCIA MEDICA DO SERVIDOR','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.05.00.00.00','CONTRIBUICAO DOS PENSIONISTAS PARA A ASSISTENCIA MEDICA DO SERVIDOR','REGISTRA O VALOR TOTAL DA CONTRIBUIÇÃO DO PENSIONISTA PARA A ASSISTÊNCIA MEDICA DO SERVIDOR','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.96.00.00.00.00','OUTRAS CONTRIBUICOES SOCIAIS','REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUICOES SOCIAIS NAO ENQUADRADAS NOS SUBITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.97.00.00.00.00','(-) DEDUÇÕES DE OUTRAS CONTRIBUIÇÕES SOCIAIS','COMPREENDEM  AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM OUTRAS CONTRIBUIÇÕES SOCIAIS','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.2.0.0.00.00.00.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Compreendem as contribuições de intervenção no domínio econômico, como por exemplo, a CIDE-combustível.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.2.0.1.00.00.00.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','Compreendem as contribuições de intervenção no domínio econômico, como por exemplo, a CIDE combustível. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.2.0.1.03.00.00.00.00','CONTRIBUIÇÕES PARA O DESENVOLVIMENTO E APERFEIÇOAMENTO DAS ATIVIDADES DE FISCALIZAÇÃO','REGISTRA O VALOR DA VPA DE CONTRIBUIÇÕES ECONÔMICAS PARA FINANCIAR O REAPARELHAMENTO E O REEQUIPAMENTO E A ATENDER AOS DEMAIS ENCARGOS ESPECÍFICOS INERENTES AO DESENVOLVIMENTO E AO APERFEIÇOAMENTO DAS ATIVIDADES DE FISCALIZAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.2.0.1.99.00.00.00.00','OUTRAS CONTRIBUICOES ECONOMICAS','COMPREENDE A VPA PROVENIENTE DAS OUTRAS CONTRIBUICOES ECONOMICAS DE NATUREZA EVENTUAL, PARA AS QUAIS NAO HA CONTA ESPECIFICA,INCLUSIVE RECURSOS ORIUNDOS DO PROGRAMA DE RECUPERACAO FISCAL E DO PARCELAMENTO ESPECIAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.3.0.0.00.00.00.00.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA','Compreende as contribuições de iluminação pública, nos termos do artigo 149-a da constituição federal, acrescentado pela emenda constitucional n.ºª 39/02, sendo facultada a cobrança da contribuição na fatura de consumo de energia elétrica.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.3.0.1.00.00.00.00.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA - CONSOLIDAÇÃO','Compreende as contribuições de iluminação pública, nos termos do artigo 149-a da constituição federal, acrescentado pela emenda constitucional n.ºª 39/02, sendo facultada a cobrança da contribuição na fatura de consumo de energia elétrica. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.4.0.0.00.00.00.00.00','CONTRIBUIÇÕES DE INTERESSE DAS CATÉGORIAS PROFISSIONAIS','Compreende as variações patrimoniais aumentativas provenientes de contribuições de interesse das categorias profissionais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.4.0.1.00.00.00.00.00','CONTRIBUIÇÕES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de contribuições de interesse das categorias profissionais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.0.0.0.00.00.00.00.00','EXPLORAÇÃO E VENDA DE BENS, SERVIÇOS E DIREITOS','Compreende as variações patrimoniais aumentativas auferidas com a exploração e venda de bens, serviços e direitos, que resultem em aumento do patrimônio liquido, independentemente de ingresso, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.0.0.00.00.00.00.00','VENDA DE MERCADORIAS','Compreende as variações patrimoniais aumentativas auferidas com a venda de mercadorias, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.1.0.00.00.00.00.00','VENDA BRUTA DE MERCADORIAS','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.1.1.00.00.00.00.00','VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.9.0.00.00.00.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS','Compreende as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.9.1.00.00.00.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','Compreende as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos.    Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.0.0.00.00.00.00.00','VENDA DE PRODUTOS','Compreende as variações patrimoniais aumentativas auferidas com a venda de produtos, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.1.0.00.00.00.00.00','VENDA BRUTA DE PRODUTOS','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de produtos, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.1.1.00.00.00.00.00','VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de produtos, que resultem em aumento do patrimônio liquido, independentemente de ingresso.        Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.9.0.00.00.00.00.00','(-) DEDUÇÕES DE VENDA BRUTA DE PRODUTOS','Compreende as deduções das vendas de produtos, como devoluções, abatimentos e descontos comerciais concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.9.1.00.00.00.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','Compreende as deduções das vendas de produtos, como devoluções, abatimentos e descontos comerciais concedidos.    Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.0.0.00.00.00.00.00','EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.0.00.00.00.00.00','VALOR BRUTO DE EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.00.00.00.00.00','VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido independentemente de ingresso. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.01.00.00.00.00','EXPLORACAO DO PATRIMONIO IMOBILIARIO','COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA  UTILIZACAO, POR TERCEIROS, DE BENS IMOVEIS PERTENCENTES AO SETOR PUBLICO. EX: ALUGUEIS, ARRENDAMENTOS, FOROS, LAUDEMIOS, TAXA DE OCUPACAO DE IMOVEIS E OUTRAS VPA DE EXPLORACAO DE BENS IMOVEIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.02.00.00.00.00','SERVICOS DE ESTUDOS E PESQUISAS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE PESQUISAS E ESTUDOS TECNICO-SOCIAIS, ECONOMICOS, CIENTIFICOS, CULTURAIS ETC., REALIZADAS SOB CONTRATO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.03.00.00.00.00','SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS PRESTADOS. VPA PROPORCIONADA POR CONSULTORIAS TECNICO-FINANCEIRAS, ASSESSORIA, ORGANIZACAO   E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.04.00.00.00.00','PRESTACAO DE SERVICOS RELACIONADOS A T.I','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO. EX: DESENVOLVIMENTO DE SOFTWARE, LICENÇA/CESSAO DE DIREITO DE USO DE PROGRAMAS, MANUTENÇÃO E ATUALIZACAO DE SOFTWARE,  INSTALAÇÃO E CONFIGURACAO DE SOFTWARE, PRESTACAO DE SERVICOS DE PAGINAS ELETRONICAS, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.05.00.00.00.00','SERVICOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS  PROVENIENTES  DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VPA DECORRENTE DE PRESTACAO DE SERVICOS DE   PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE    DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.06.00.00.00.00','SERVICO DE INFORMACOES CIENTIFICAS E TECNOLOGICAS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES CIENTIFICAS E TECNOLOGICAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.07.00.00.00.00','SERVICOS DE TECNOLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS TECNOLOGICOS PRESTADOS. VPA PROPORCIONADA POR: A) ANALISES QUIMICAS, ENSAIOS FISICOS E MECANICOS, CONTROLE E EXPERIMENTACAO QUALITATIVA DE MATERIAS-PRIMAS, INSUMOS E PRODUTOS FABRICADOS; PADRONIZACAO E ESPECIFICACAO DE PRODUTOS; AJUSTES DOS PROCESSOS ETECNICAS DE PRODUCAO INDUSTRIAL (SISTEMA DE TECNOLOGIA) B) ESPECIFICACAO E CONTROLE DE QUALIDADE DE MEDICAMENTOS, INSUMOS FARMACEUTICOS, DROGAS, COSMETICOS, PRODUTOS QUIMICOS, ALIMENTOS, E OUTROS, POR MEIO DE PROVAS ESPECIFICAS DE IDENTIFICACAO, DE PUREZA E  DE TESTES DE CONTAMINACAO MICROBIOLOGICA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.08.00.00.00.00','SERVICOS DE COMUNICACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMUNICACAO, CONFORME DESCRICAO: A) SERVICO POSTAL, DE ENTREGA E TRANSPORTE  DE VOLUMES E CORRESPONDENCIAS; B) SERVICO DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E  INTERNACIONAL E DE TRANSMISSAO DE DADOS; C) SERVICO DE RADIODIFUSAO E DE AGENCIAMENTO DE PUBLICIDADE. INCLUSIVE DIVIDA ATIVA. EX: SERVICOS DE PUBLICIDADE LEGAL, SERVICOS DE RADIODIFUSAO E OUTROS SERVICOS DE COMUNICACAO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.09.00.00.00.00','PRESTACAO DE SERVICOS DE ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ARMAZENAGEM.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.10.00.00.00.00','SERVICOS DE HOSPEDAGEM E ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE HOSPEDAGEM E ALIMENTACAO PRESTADOS. VPA PROPORCIONADA POR HOSPEDAGEM, COM OU   SEM ALIMENTACAO, FORNECIMENTO DE REFEICOES, LANCHES E BEBIDAS PARA CONSUMO IMEDIATO. EXCLUEM AS VPA PROVENIENTES DE EMPRESAS FORNECEDORAS DE ALIMENTOS PREPARADOS PARA HOSPITAIS, FABRICAS, ETC... QUE SE CLASSIFICAM EM VPA DE PRODUTOS ALIMENTARES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.11.00.00.00.00','RECEITA DE CONCESSOES E PERMISSOES','REGISTRA O VALOR TOTAL DA ARRECADAÇÃO DE VPAS ORIGINADAS DA CONCESSÃO OU PERMISSÃO AO PARTICULAR DO DIREITO DE EXPLORAÇÃO DE SERVIÇOS PÚBLICOS, OS QUAIS ESTÃO SUJEITOS AO CONTROLE, FISCALIZAÇÃO E REGULAÇÃO DO PODER PÚBLICO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.12.00.00.00.00','COMPENSACOES FINANCEIRAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DOS RECURSOS DECORRENTES DO ARTIGO 20, PARAGRAFO 1º DA CONSTITUICAO FEDERAL, O QUAL DISPOE: "E ASSEGURADA, NOS TERMOS DA LEI, AOS ESTADOS, AO DISTRI-TO FEDERAL E AOS MUNICIPIOS, BEM COMO AOS ORGAOS DA ADMINISTRACAO DIRETA DA UNIAO, PARTICIPACAO NO RESULTADO DA EXPLORACAO DE PETROLEO OU   GAS NATURAL, DE RECURSOS HIDRICOS PARA FINS DE GERACAO DE ENERGIA ELETRICA E DE OUTROS RECURSOS MINERAIS NO RESPECTIVO TERRITORIO, PLATAFORMA CONTINENTAL, MAR TERRITORIAL OU ZONA ECONOMIA EXCLUSIVA, OU COMPENSACAO FINANCEIRA POR ESSA EXPLORACAO". EX: EXPLORACAO DE RECURSOS MINERAIS, ROYALTIES PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL - EM TERRA, ROYALTIES PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL - EM PLATAFORMA, ROYALTIES EXCEDENTES PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL - EM TERRA, ROYALTIES EXCEDENTES PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL - EM PLATAFORMA, PARTICIPAÇÃO ESPECIAL PELA PRODUÇÃO DE PETROLEO OU GAS NATURAL ALÉM DE OUTRAS COMPENSACOES FINANCEIRAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.13.00.00.00.00','SERVICOS DE TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE TRANSPORTE  RODOVIARIO, FERROVIARIO, HIDROVIARIO, AEREO, ESPECIAIS, RECEITAS DE TERMINAIS RODOVIARIOS, TARIFA DE PEDAGIO ASSIM COMO OUTROS SERVICOS DE TRANSPORTE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.14.00.00.00.00','SERVICOS PORTUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS  PROVENIENTES DE SERVICOS PORTUARIOS. ABRANGEM OS RECURSOS ORIUNDOS DA EXPLORACAO DOS PORTOS,   TERMINAIS MARITIMOS, ATRACADOUROS E ANCORADOUROS, REFERENTES A ESTIVA,  DESESTIVA, DRAGAGEM, ATRACACAO, SINALIZACAO, COMUNICACAO NAUTICA,  DOCAGEM, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.15.00.00.00.00','SERVICOS DE SOCORRO MARITIMO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICO DE SOCORRO MARITIMO PRESTADO. VPA DE SERVICOS DE SALVAMENTO, POR NAVIO DE SOCORRO OU EQUIPE DE SALVAMENTO DA MARINHA, DE EMBARCACAO E CARGAS   PERIGO (DESENCALHE, MERGULHO, OUTROS SOCORROS), BEM COMO SERVICOS DE REBOQUE MARITIMO, DENTRE OUTROS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.16.00.00.00.00','SERVICOS DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE SAUDE: HOSPITALARES GERAIS OU ESPECIALIZADOS,   MATERNIDADE, CENTRO DE REABILITACAO, ASSISTENCIA MEDICO-ODONTOLOGICA (INCLUSIVE AMBULATORIAL), SAUDE PUBLICA, SERVICOS DE REGISTRO DE ANALISE E DE CONTROLE DE PRODUTOS SUJEITOS A NORMAS DE VIGILANCIA SANITARIA, SERVICOS RADIOLOGICOS E LABORATORIAIS, ASSIM COMO OUTROS SERVICOS DE SAUDE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.17.00.00.00.00','SERVICOS DE METROLOGIA E CERTIFICACAO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA E CERTIFICACAO PRESTADOS.VPA DE SERVICOS METROLOGICOS GERAL, TAIS COMO AFERICAO DE MEDIDAS E INSTRUMENTOS DE MEDIR, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, METROLOGIA LEGAL E CERTIFICATORIA DELEGADA, METROLOGIA CIENTIFICA E INDUSTRIAL, CERTIFICACAO DE PRODUTOS E SERVICOS INFORMACAO TECNOLOGICA BEM COMO OUTROS SERVICO DE METROLOGIA E CERTIFICACAO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.18.00.00.00.00','SERVICOS DE INSPECAO E FISCALIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE INSPECAO E FISCALIZACAO PRESTADOS. VPA PROPORCIONADA PELA   CONSTATACAO DAS CONDICOES HIGIENICO-SANITARIAS E TECNICAS DE PRODUTOS OU ESTABELECIMENTOS, OU RESULTANTES DE ACAO EXTERNA E DIRETA DOS ORGAOS DO  PODER PUBLICO DESTINADA A VERIFICACAO DO CUMPRIMENTO DA LEGISLACAO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.19.00.00.00.00','SERVICOS ADMINISTRATIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS ADMINISTRATIVOS PRESTADOS, DAS ATIVIDADES DE APOIO ADMINSITRATIVO EXECUTADAS EM ORGANIZACOES DE QUALQUER NATUREZA, TAIS COMO: TAXAS DE EXPEDICAO DE CERTIFICADOS; TAXAS DE REGISTRO, RENOVACAO, VISTORIA DE VEICULOS, LICENCA, CADASTRAMENTO, ETC. DATILOGRAFIA, MICROFILMAGEM, COPIAS XEROGRAFICAS, HELIOGRAFICAS, FOTOSTATICAS, ETC; TAXAS DE INSCRICAO EM CONCURSOS PUBLICOS. TAXA DE ADMINISTRACAO DE SERVICOS. VENDA DE EDITAIS. SERVICOS DE FORNECIMENTO DE LISTAGENS, BEM COMO OUTROS SERVICOS ADMINISTRATIVOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.20.00.00.00.00','SERVICOS DE METEOROLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE METEOROLOGIA PRESTADOS. VPA PROPORCIONADA PELO FORNECIMENTO DE    DADOS METEOROLOGICOS E DE PARECERES TECNICOS, BEM COMO CONSERTO,  COMPARACAO  E AFERICAO DE EQUIPAMENTOS DE METEOROLOGIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.21.00.00.00.00','SERVICOS EDUCACIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DO SISTEMA EDUCACIONAL, CUJA NATUREZA ESTEJA DIRETAMENTE RELACIONADA A FORMACAO DO EDUCANDO (MATRICULAS, ANUIDADES, ETC...). AS VPA DE ATIVIDADES AUXILIARES, DE APOIO OU DERIVADAS DOS SERVICOS EDUCACIONAIS PROPRIAMENTE DITOS, DEVEM SER CLASSIFICADAS NOS TITULOS APROPRIADOS. EXEMPLOS: MATRICULAS E ANUIDADES, SERVICOS EDUCACIONAIS, TAXAS DE  EXPEDICAO DE DOCUMENTOS, COPIAS XEROGRAFICAS, HELIOGRAFICAS, ETC.., SERVICO DE CREDENCIAMENTO, AUTORIZACAO E RECONHECIMENTO DE CURSOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.22.00.00.00.00','SERVICOS AGROPECUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS AGROPECUARIO: A)PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO, ARACAO, GRADEACAO, CALAGEM, ADUBACAO, DRENAGEM, IRRIGACAO, CAPINA, DESMATAMENTO, ETC.);  B)SEMEADURA E PLANTIO; C)COMBATE A PRAGAS (PULVERIZACAO, DEDETIZACAO);  D)COLHEITA E PREPARACAO DE PRODUTOS AGRICOLAS; E)INSEMINACAO ARTIFICIAL; F)INCUBACAO DE OVOS; G)VACINACAO DE ANIMAIS; H)OUTROS SERVICOS AUXILIARES DE AGRICULTURA E PECUARIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.23.00.00.00.00','SERVICOS DE REPARACAO,MANUTENCAO E INSTALACAO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS DE  REPARACAO, MANUTENCAO E INSTALACAO PRESTADOS. VPA DE SERVICOS DE REPARACAO DE ARTEFATOS DE METAL; REPARACAO E MANUTENCAO DE MAQUINAS E APARELHOS DE USO DOMESTICO; REPARACAO, MANUTENCAO E INSTALACAO DE  MAQUINAS E APARELHOS ELETRICOS E ELETRONICOS E DE COMUNICACAO; REPARACAO  E MANUTENCAO DE INSTALACOES ELETRICAS, DE GAS, DE AGUA, ETC...INCLUEM-SE TAMBEM, NESSE TITULO, OS SERVICOS DE CONFECCAO SOB MEDIDA. NAO SAO CONSIDERADOS NESSE TITULO, CLASSIFICANDO-SE EM VPA INDUSTRIAL: REPARACAO E MANUTENCAO DE VEICULOS FERROVIARIOS, EMBARCACOES E   AERONAVES (INDUSTRIA DE MATERIAL DE TRANSPORTE).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.24.00.00.00.00','SERVICOS RECREATIVOS E CULTURAIS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS RECREATIVOS E CULTURAIS PRESTADOS. VPA PROPORCIONADA PELA EXPLORACAO    DE INSTALACOES PARA RECREACAO, PRATICA DESPORTIVA E CULTURAL (CINEMAS, TEATROS, SALOES PARA RECITAIS, CONCERTOS, CONFERENCIAS, PLANETARIOS, ESTADIOS DESPORTIVOS, AUTODROMOS, MUSEUS, BIBLIOTECAS, PROMOCAO E/OU PRODUCAO DE ESPETACULOS ARTISTICOS CULTURAIS E ESPORTIVOS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.25.00.00.00.00','SERVICOS DE FORNECIMENTO DE AGUA','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS  PRESTADOS DE FORNECIMENTO DE AGUA AOS IRRIGANTES A AMORTIZACAO DOS INVESTIMENTOS DA INFRA-ESTRUTURA DE IRRIGACAO DOS PROJETOS PUBLICOS. INCLUSIVE DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.26.00.00.00.00','SERVICOS DE PERFURACAO E INSTALACAO DE POCOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS  PRESTADOS DE PERFURACAO EINSTALACAO DE POCOS TUBULARES PROFUNDOS, POCOS ARTESIANOS OU   SIMILARES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.27.00.00.00.00','SERVICOS DE GEOPROCESSAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS A TERCEIROS DE INTERPRETACAO DE IMAGEM AERO FOTOGRAMETRICA, EXECUCAO DE MAPAS DIGITALIZADOS DIVERSOS, VENDA DE CARTAS E IMAGENS DE SATELITES, VIDEOGRAFICAS E SIMILARES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.28.00.00.00.00','SERVICOS DE CADASTRAMENTO DE FORNECEDORES','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE CADASTRAMENTO DE EMPRESAS FORNECEDORAS DE BENS  E SERVICOS AO GOVERNO FEDERAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.29.00.00.00.00','TARIFAS DE INSCRIÇÃO EM CONCURSOS E PROCESSOS SELETIVOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE TARIFAS DE INSCRICAO EM CONCURSOS E PROCESSOS SELETIVOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.30.00.00.00.00','SERVICOS VETERINARIOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE SERVICOS VETERINARIOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.31.00.00.00.00','SERVICOS FINANCEIROS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM SERVICOS FINANCEIROS TAIS COMO: SERVICOS DE REMUNERACAO SOBRE REPASSE PARA PROGRAMAS DE DESENVOLVIMENTO ECONOMICO, COMISSOES PELA PRESTACAO  DE GARANTIA, SERVICOS FINANCEIROS DE GARANTIA DA ATIVIDADE AGROPECUARIA, SERVIÇOS FINANCEIROS PROVENIENTES DA EXECUÇÃO DE GARANTIA - OPERAÇÕES DE CREDITO INTERNA, SERVIÇOS FINANCEIROS PROVENIENTES DA EXECUÇÃO DE GARANTIA - OPERAÇÕES DE CREDITO EXTERNAS BEM COMO OUTROS SERVICOS FINANCEIROS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.32.00.00.00.00','SERVICOS COMERCIAIS','REGISTRA A VPA DE SERVICOS COMERCIAIS E FINANCEIRAS ORIUNDAS DAS ATIVIDADES DO COMERCIO VAREJISTA E ATACADISTA, OU SEJA, OPERACOES DE REVENDA DE MERCADORIAS PARA CONSUMO, USO PESSOAL OU USO DOMESTICO, BEM COMO A REVENDA DE MERCADORIAS A COMERCIANTES VAREJISTAS, A CONSUMIDORES INDUSTRIAIS, A INSTITUICOES, PROFISSIONAIS    E OUTROS COMERCIANTES ATACADISTAS. ABRANGE TAMBEM OS  SERVICOS AUXILIARES DE COMERCIO: AGENTES, CORRETORES E INTERMEDIARIOS DE VENDA DE MERCADORIAS A BASE DE COMISSAO. NAO ESTAO INCLUIDAS AS VPA ORIUNDAS DA VENDA DE MERCADORIAS QUE TENHAM SOFRIDO PROCESSO    DE TRANSFORMACAO NO PROPRIO ESTABELECIMENTO, AS QUAIS DEVERAO SER CLASSIFICADAS EM VPA DA INDUSTRIA DE TRANSFORMACAO. EX: COMERCIALIZACAO DE MEDICAMENTOS, COMERCIALIZACAO DE LIVROS, PERIODICOS, MATERIAIS ESCOLARES  E PUBLICIDADE, COMERCIALIZACAO E DISTRIBUICAO DE  PRODUTOS  AGROPECUARIOS, COMERCIALIZACAO DE PRODUTOS, DADOS E MATERIAIS DE INFORMATICA ALÉM DE OUTROS SERVICOS COMERCIAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.33.00.00.00.00','SERVIÇOS AGROPECUARIOS','REGISTRA O VALOR TOTAL DA VPA COM SERVICOS AGROPECUARIO TAIS COMO: PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO, ARACAO, GRADEACAO, CALAGEM, ADUBACAO, DRENAGEM, IRRIGACAO, CAPINA, DESMATAMENTO, ETC.); SEMEADURA E PLANTIO; COMBATE A PRAGAS (PULVERIZACAO, DEDETIZACAO); COLHEITA E PREPARACAO DE PRODUTOS AGRICOLAS; INSEMINACAO ARTIFICIAL; INCUBACAO DE OVOS; VACINACAO DE ANIMAIS; OUTROS SERVICOS AUXILIARES DE AGRICULTURA E PECUARIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.34.00.00.00.00','SERVIÇO INDUSTRIAL','REGISTRA O VALOR TOTAL DA VPA DA INDÚSTRIA DE EXTRAÇÃO MINERAL, SERVIÇO DA INDUSTRIA DE TRANSFORMACAO, SERVIÇO DA INDUSTRIA DE CONSTRUCAO E OUTROS, PROVENIENTES DAS ATIVIDADES INDUSTRIAIS DEFINIDAS COMO TAIS PELA FUNDAÇÃO INSTITUTO BRASILEIRO DE GEOGRAFIA E ESTATÍSTICA - IBGE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.35.00.00.00.00','SERVICOS DE CAPTACAO, ADUCAO, TRATAMENTO, RESERVACAO E DISTRIBUICAO DE AGUA','REGISTRA O VALOR DA VPA DE SERVIÇOS PRESTADOS A USUÁRIOS PELO FORNECIMENTO DE ÁGUA POTÁVEL REPRESENTADOS PELO CONSUMO AUFERIDO QUANDO DA UTILIZAÇÃO DO SERVIÇO A DISPOSIÇÃO DO PROPRIETÁRIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.36.00.00.00.00','SERVICOS DE COLETA, TRANSPORTE, TRATAMENTO E DESTINO FINAL DE ESGOTOS','REGISTRA O VALOR DA VPA DE SERVIÇOS PRESTADOS A USUÁRIOS BENEFICIADOS COM ESGOTAMENTO SANITÁRIO REPRESENTADOS PELO CONSUMO AUFERIDO QUANDO DA UTILIZAÇÃO DO SERVIÇO A DISPOSIÇÃO DO PROPRIETÁRIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.37.00.00.00.00','SERVICOS DE COLETA, TRANSPORTE, TRATAMENTO E DESTINO FINAL DE RESIDUOS SOLIDOS','REGISTRA O VALOR DA VPA DE SERVIÇOS COM A COLETA, TRANSPORTE, TRATAMENTO E DESTINO FINAL DE RESÍDUOS SÓLIDOS REPRESENTADOS PELO CONSUMO AUFERIDO QUANDO DA UTILIZAÇÃO DO SERVIÇO A DISPOSIÇÃO DO PROPRIETÁRIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.38.00.00.00.00','SERVICOS DE ABATE DE ANIMAIS','REGISTRA O VALOR DA VPA DE SERVIÇOS DE ABATE DE ANIMAIS PRATICADOS POR MATADOURO MUNICIPAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.39.00.00.00.00','SERVICOS DE PREPARACAO DA TERRA EM PROPRIEDADES PARTICULARES','REGISTRA O VALOR DA VPA DE SERVIÇOS DE PREPARAÇÃO DA TERRA EM PROPRIEDADES PARTICULARES, INCLUSIVE COLHEITA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.40.00.00.00.00','SERVICOS DE CEMITERIO','REGISTRA O VALOR DA VPA DE SERVIÇOS DE CONSTRUÇÃO E LIMPEZA DE TÚMULOS PERPÉTUOS E OUTROS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.41.00.00.00.00','SERVICOS DE ILUMINACAO PUBLICA','REGISTRA O VALOR DA VPA DE SERVIÇOS DE ILUMINAÇÃO PÚBLICA REPRESENTADO PELO CONSUMO AUFERIDO QUANDO DA UTILIZAÇÃO DO SERVIÇO A DISPOSIÇÃO DO PROPRIETÁRIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.42.00.00.00.00','SERVICOS DE RELIGAMENTO DE AGUA','REGISTRA O VALOR DA VPA DE SERVIÇOS DE RELIGAMENTO DE ÁGUA, OCASIONADOS POR CORTE DE FORNECIMENTO EM FUNÇÃO DO NÃO PAGAMENTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.43.00.00.00.00','SERVICO DE INFORMACOES ESTATISTICAS','REGISTRA O VALOR TOTAL DA VPA PROVENIENTE DA PRESTAÇÃO DE SERVIÇOS DE INFORMAÇÕES ESTATÍSTICAS, FORNECIDAS A ENTIDADES PÚBLICAS OU PRIVADAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.44.00.00.00.00','SERVICO DE MAQUINAS','REGISTRA O VALOR DA ARRECADAÇÃO PROVENIENTE DO SERVIÇO DE MÁQUINA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.45.00.00.00.00','SERVICO DE PAVIMENTACAO E REPAVIMENTACAO','REGISTRA O VALOR DA ARRECADAÇÃO PROVENIENTE DO SERVIÇO DE PAVIMENTAÇÃO E REPAVIMENTAÇÃO','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.46.00.00.00.00','SERVICOS DE LIGACAO DE AGUA E ESGOTO','REGISTRA O VALOR DA ARRECADAÇÃO PROVENIENTE DO SERVIÇO DE LIGAÇÃO DE ÁGUA E ESGOTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.47.00.00.00.00','SERVICOS RELATIVOS A EVENTOS EDUCACIONAIS','REGISTRA O VALOR DA ARRECADAÇÃO PROVENIENTE DO SERVIÇOS RELATIVOS A EVENTOS EDUCACIONAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.99.00.00.00.00','OUTROS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.9.0.00.00.00.00.00','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as deduções das prestações de serviços, como devoluções, abatimentos e descontos comerciais concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.9.1.00.00.00.00.00','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Compreende as deduções das prestações de serviços, como devoluções, abatimentos e descontos comerciais concedidos.     Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.0.0.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS FINANCEIRAS','Compreende o somatório das variações patrimoniais aumentativas com operações financeiras. Compreende: descontos obtidos, juros auferidos, prêmio de resgate de títulos e debêntures, entre outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.0.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas provenientes de juros e encargos de empréstimos e financiamentos concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.1.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.3.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.4.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS -ESTADO','Registra as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.5.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.2.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos externos concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.2.1.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos externos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.0.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.1.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.3.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.4.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.5.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.4.0.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos externos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.4.1.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos externos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.0.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA','Compreende as variações patrimoniais aumentativas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação representando o resultado das aplicações impostas ao contribuinte.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.3.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.4.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.5.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.2.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos externos concedidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.2.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos externos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a fornecimento de bens e serviços.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a fornecimento de bens e serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.02.00.00.00.00','MULTAS E JUROS DE MORA DE ALUGUEIS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLIC. ATRAS. PAGAMEN. DE ALUGUEIS DEVIDOS POR USO  DO PATRIMONIO IMOBILIARIO DO MUNICIPIO, DECORRENTES DE CLAUSULAS  CONTRATUAIS PACTUADAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.03.00.00.00.00','MULTAS E JUROS DE MORA DE ARRENDAMENTOS','REGISTRA A VPA PROVENIENTE DE MUL.JUR. MORA APLIC.P/ ATRAS. NO PAGAMENTO DE RENDAS DEVIDAS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO SOB A FORMA DE ARRENDAMENTO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.04.00.00.00.00','MULTAS E JUROS DE MORA DE LAUDEMIOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA ATRASOS NOS RECOLHIMEN. DAS DIFERENCAS DE LAUDEMIOS, GERADAS ANTES DA EDICAO DA M.P NUM 1647 - 14, DE 24 DE MARCO DE 1998, DE ACORDO COM O PREVISTO NO ART. 5. DO DECRETO NUM. 95.760, DE 01 DE MARCO DE 1988.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.05.00.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DO PROGRAMA TROCA-TROCA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DO PROGRAMA TROCA-TROCA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.06.00.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DA PRESTACAO DE SERVICOS','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DA PRESTAÇÃO DE SERVIÇOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.07.00.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DOS AUTOS DE INFRACAO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS E JUROS DE MORA DA DÍVIDA ATIVA DOS AUTOS DE INFRAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.99.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS','Compreende a variação patrimonial aumentativa com juros e encargos a titulo de penalidade aplicada em virtude de atrasos e não cumprimento dos prazos de créditos tributários.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa com juros e encargos a titulo de penalidade aplicada em virtude de atrasos e não cumprimento dos prazos de créditos tributários. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.01.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE IMPOSTOS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA COM JUROS E ENCARGOS  A TITULO DE PENALIDADE APLICADA EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS IMPOSTOS DEVIDOS PELOS CONTRIBUINTES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.01.01.00.00.00','MULTAS  E JUROS DE MORA DO IMPOSTO SOBRE A RENDA RETIDO NAS FONTES - IRRF','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A   MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRITUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO  CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.01.02.00.00.00','MULTA E JUROS DE MORA DO ITR MUNICIPIOS CONVENIADOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO  CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTE   REFERENTES AO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.01.03.00.00.00','MULTAS E JUROS DE MORA DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA - IPTU','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL URBANA - IPTU.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.01.04.00.00.00','MULTAS E JUROS DE MORA DO IMPOSTO SOBRE A TRANSMISSAO INTER-VIVOS DE BENS IMOVEIS - ITBI','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA DO IMPOSTO SOBRE A TRANSMISSÃO INTER-VIVOS DE BENS IMÓVEIS - ITBI.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.01.05.00.00.00','MULTAS E JUROS DE MORA DO IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA - ISS','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA DO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA- ISS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.02.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE AS TAXAS','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA DAS TAXAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.02.01.00.00.00','MULTAS E JUROS DE MORA DA TAXA DE FISCALIZACAO E VIGILANCIA  SANITARIA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.03.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE AS CONTRIBUICOES DE MELHORIA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS E JUROS DE MORA DAS CONTRIBUIÇÕES DE MELHORIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.04.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE A DIVIDA ATIVA DOS IMPOSTOS','REGISTRA O VALOR TOTAL DA VPA DE MULTAS E JUROS DE MORA INCIDENTES SOBRE A DÍVIDA ATIVA DOS IMPOSTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.04.01.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA RETIDO NA FONTE','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COM A FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA - RETIDO NAS FONTES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.04.02.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIO CONVENIADO','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS  PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE   A DIVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIO CONVENIADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.04.03.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA - IPTU','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA INCIDENTE SOBRE A DÍVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA - IPTU.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.04.04.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DO IMPOSTO SOBRE A TRANSMISSAO INTER-VIVOS DE BENS IMOVEIS - ITBI','REGISTRA O VALOR DA VPA DE MULTAS E JUROS DE MORA INCIDENTE SOBRE A DÍVIDA ATIVA DO IMPOSTO SOBRE A TRANSMISSÃO INTER-VIVOS DE BENS IMÓVEIS - ITBI.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.04.05.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DO IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA - ISS','REGISTRA O VALOR DA ARRECADAÇÃO DE VPAS DE MULTAS E JUROS DE MORA INCIDENTE SOBRE A DÍVIDA ATIVA DO IMPOSTO SOBRE SERVIÇOS DE QUALQUER NATUREZA - ISS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.05.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE A DIVIDA ATIVA DAS TAXAS','REGISTRA O VALOR TOTAL DA VPA DE MULTAS E JUROS DE MORA INCIDENTES SOBRE A DÍVIDA ATIVA DAS TAXAS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.05.01.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DA TAXA DE FISCALIZACAO E VIGILANCIA SANITARIA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPAS DE MULTAS E JUROS DE MORA INCIDENTE SOBRE A DÍVIDA ATIVA DA TAXA DE FISCALIZAÇÃO E VIGILÂNCIA SANITÁRIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.06.00.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DAS CONTRIBUICOES DE MELHORIA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPAS DE MULTAS E JUROS DE MORA INCIDENTES SOBRE A DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.07.00.00.00.00','MULTA E JUROS MORA DA CONTRIBUIÇÃO DO SERVIDOR PARA O RPPS','REGISTRA A  VARIACAO PATRIMONIAL AUMENTATIVAS PROVENIENTES DE MULTA E JUROS MORA DA CONTRIBUIÇÃO DO SERVIDOR PARA O RPPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.96.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE OUTROS CREDITOS TRIBUTARIOS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE OUTRAS CREDITOS TRIBUTARIOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.96.01.00.00.00','JUROS E ENCARGOS DE MORA SOBRE OUTROS TRIBUTOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE OUTROS TRIBUTOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.96.02.00.00.00','JUROS E ENCARGOS DE MORA SOBRE DIVIDA ATIVA DE OUTROS TRIBUTOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE DIVIDA ATIVA DE OUTROS TRIBUTOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.97.00.00.00.00','(-) DEDUCOES DOS JUROS E ENCARGOS DE MORA SOBRE  CREDITOS TRIBUTARIOS','REGISTRA  AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS JUROS E ENCARGOS DE MORA SOBRE  CREDITOS TRIBUTARIOS INCLUSIVE DIVIDA ATIVA.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.0.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA','Compreende as outras variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.1.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','Compreende as outras variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.1.01.00.00.00.00','MULTAS E JUROS DE MORA DA ALIENACAO DE DOMINIO UTIL','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS JUROS DE MORA ALIEN. DOM.UTIL. MULTAS APLICADAS POR ATRASOS NO RECOLHIMENTO DE PARCELAS REFERENTES  A AQUISICAO DE DOMINIO UTIL DE TERRENOS DA UNIAO, DE ACORDO COM O   PREVISTO NO ARTIGO 4 DO DECRETO-LEI NUM 1561, DE 13 DE JULHO DE 1977    E ARTIGOS 25 A 27 DA MP NUM. 1647-14, DE 24 DE FEVEREIRO DE 1998.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.1.02.00.00.00.00','MULTAS E JUROS DE MORA DA  ALIENAÇÃO DE OUTROS BENS IMOVEIS','REGISTRA  A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE ALIEN. DE OUTROS BENS IMOVEIS. MULTAS APLICADAS POR ATRASOS NOS RECOLHIMENTOS DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL OU PLENO DE IMOVEIS DA UNIAO, DE ACORDO COM O PREVISTO NOS ARTIGOS 25 A 27 DA MP NUM. 1647-14 DE 24 DE MARCO DE 1998.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.1.04.00.00.00.00','MULTAS E JUROS DE MORA DE DIVIDENDOS','REGISTRA  A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA  APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE DIVIDENDOS DEVIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.1.05.00.00.00.00','MULTAS E JUROS DE MORA DE PARTICIPACOES','REGISTRA  A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA  APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE  PARTICIPACOES DEVIDAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.1.99.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE OUTROS JUROS E ENCARGOS DE MORA','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.0.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.1.01.00.00.00.00','VARIAÇÕES MONETARIAS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE  UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.1.02.00.00.00.00','VARIAÇÕES CAMBIAIS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRÉSTIMOS CONCEDIDOS.  COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE  UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.3.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.3.01.00.00.00.00','VARIAÇÕES MONETARIAS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE  UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.3.02.00.00.00.00','VARIAÇÕES CAMBIAIS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRÉSTIMOS CONCEDIDOS.  COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE  UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.4.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.4.01.00.00.00.00','VARIAÇÕES MONETARIAS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO EMPRÉSTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE  UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.4.02.00.00.00.00','VARIAÇÕES CAMBIAIS DE EMPRÉSTIMOS CONCEDIDOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRÉSTIMOS CONCEDIDOS.  COMPREENDE OS VALORES DE OPERAÇÕES EFETUADAS ENTRE  UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  COM PESSOA OU UNIDADE QUE NÃO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NÃO COMPREENDEM TRANSAÇÕES ENTRE PARTES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.5.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.2.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.2.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.1.01.00.00.00.00','VARIAÇÕES MONETARIAS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO FINANCIAMENTOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.1.02.00.00.00.00','VARIAÇÕES CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO FINANCIAMENTOS CONCEDIDOS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.3.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.4.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.5.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.4.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.4.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.0.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nos moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.1.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.1.01.00.00.00.00','OUTRAS VARIAÇÕES MONETARIAS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE  VARIAÇÕES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS  A CORRECAO MONETARIA POS-FIXADA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.1.02.00.00.00.00','OUTRAS VARIAÇÕES CAMBIAIS - CONSOLIDAÇÃO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.3.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - UNIÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.4.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - ESTADO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.5.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.4.0.0.00.00.00.00.00','DESCONTOS FINANCEIROS OBTIDOS','Compreende a variação patrimonial aumentativa decorrente de descontos financeiros obtidos em virtude de liquidação antecipada de obrigações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.4.0.1.00.00.00.00.00','DESCONTOS FINANCEIROS OBTIDOS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa decorrente de descontos financeiros obtidos em virtude de liquidação antecipada de obrigações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.0.0.00.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS E APLICAÇÕES FINANCEIRAS','Compreende o valor total das variações patrimoniais aumentativas decorrentes da remuneração do saldo diário dos depósitos da União existentes no banco central, bem como aplicação de recursos da conta única de acordo com a rentabilidade media intrínseca dos títulos do tesouro.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.0.00.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS','Compreende a variação patrimonial aumentativa decorrente da remuneração dos depósitos bancários do ente existentes no agente financeiro.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.00.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa decorrente da remuneração dos depósitos bancários do ente existentes no agente financeiro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.01.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS DE RECURSOS VINCULADOS','REGISTRA O VALOR DA VPA PROVENIENTE DA REMUNERAÇÃO DE DEPOSITOS BANCARIOS DE RECURSOS VINCULADOS, TAIS COMO: ROYALTIES, FUNDEB, FUNDO DE SAÚDE, REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL DOS SERVIDORES, MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO, AÇÕES E SERVIÇOS PÚBLICOS DE SAÚDE (ASPS), FUNDETUR, ETC.DA REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS VINCULADOS, TAIS COMO: ROYALTIES, FUNDEB, FUNDO DE SAÚDE, REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL DOS SERVIDORES, MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO, ASPS, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.02.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS DE RECURSOS NÃO VINCULADOS','REGISTRA O VALOR DA VPA PROVENIENTE DA REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS DE RECURSOS NÃO VINCULADOS, INCLUSIVE RECURSOS PRÓPRIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.03.00.00.00.00','REMUNERAÇÃO DOS INVESTIMENTOS DO REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL','REGISTRA O SOMATÓRIO DAS VPAS DECORRENTES DE REMUNERAÇÃO DA CARTEIRA DE INVESTIMENTOS DOS RPPS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.96.00.00.00.00','REMUNERACAO DE OUTROS DEPOSITOS BANCARIOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DA REMUNERACAO DE OUTROS DEPOSITOS BANCARIOS DO ENTE EXISTENTES NO AGENTE FINANCEIRO NÃO RELACIONADOS NAS CONTAS ACIMA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.97.00.00.00.00','(-) DEDUÇÃO DA REMUNERACAO DE DEPOSITOS BANCARIOS','REGISTRA AS DEDUÇÕES DE VPA OCORRIDAS NAS CONTAS ACIMA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.0.00.00.00.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS','Compreende a variação patrimonial aumentativa proveniente da remuneração de depósitos bancários, recursos oriundos de aplicações de entidades da administração pública no mercado financeiro, autorizadas por lei, em caderneta de poupança, fundo de investimento, contas remuneradas e outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.00.00.00.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente da remuneração de depósitos bancários, recursos oriundos de aplicações de entidades da administração pública no mercado financeiro, autorizadas por lei, em caderneta de poupança, fundo de investimento, contas remuneradas e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.01.00.00.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS VINCULADOS','REGISTRA O VALOR DA VPA PROVENIENTE DA REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS VINCULADOS, TAIS COMO: ROYALTIES, FUNDEB, FUNDO DE SAÚDE, REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL DOS SERVIDORES, MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO, AÇÕES E SERVIÇOS PÚBLICOS DE SAÚDE (ASPS), FUNDETUR, ETC.DA REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS VINCULADOS, TAIS COMO: ROYALTIES, FUNDEB, FUNDO DE SAÚDE, REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL DOS SERVIDORES, MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO, ASPS, ETC.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.02.00.00.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS NÃO VINCULADOS','REGISTRA O VALOR DA VPA PROVENIENTE DA REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS NÃO VINCULADOS, INCLUSIVE RECURSOS PRÓPRIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.03.00.00.00.00','REMUNERAÇÃO DOS INVESTIMENTOS DO REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL','REGISTRA O VALOR DA VPA DECORRENTES DE REMUNERAÇÃO DA CARTEIRA DE INVESTIMENTOS DOS RPPS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.96.00.00.00.00','REMUNERACAO DE OUTRAS APLICAÇÕES FINANCEIRAS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DA REMUNERACAO DE OUTRAS APLICAÇÕES FINANCEIRAS DO ENTE EXISTENTES NO AGENTE FINANCEIRO NÃO RELACIONADOS NAS CONTAS ACIMA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.97.00.00.00.00','(-) DEDUÇÃO DA REMUNERACAO DE APLICAÇÕES FINANCEIRAS','REGISTRA AS DEDUÇÕES DE VPA OCORRIDAS NAS CONTAS ACIMA','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.9.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS','Compreende as variações patrimoniais aumentativas provenientes de operações financeiras não compreendidas nos subgrupos anteriores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.9.0.1.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de operações financeiras não compreendidas nos subgrupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.0.0.0.00.00.00.00.00','TRANSFERÊNCIAS E DELEGAÇÕES RECEBIDAS','Compreende o somatório das variações patrimoniais aumentativas com transferências inter governamentais, transferências intragovernamentais, transferências de instituições multigovernamentais, transferências de instituições privadas com ou sem fins lucrativos, transferências de convênios, transferências do exterior e execuções orçamentárias delegadas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.0.0.00.00.00.00.00','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras relativas à execução orçamentária, e de bens e valores, referentes às transações intragovernamentais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.0.00.00.00.00.00','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras recebidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Inclui também o valor repassado para a cobertura do déficit financeiro do RPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.00.00.00.00.00','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','Compreende o valor das transferências financeiras recebidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Inclui também o valor repassado para a cobertura do déficit financeiro do RPPS. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.01.00.00.00.00','COTA RECEBIDA','REGISTRA O VALOR DOS RECURSOS RECEBIDOS PELA  ADMINISTRACAO DIRETA DECORRENTES DA PROGRAMACAO FINANCEIRA CORRESPONDENTE AO ORCAMENTO ANUAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.02.00.00.00.00','REPASSE RECEBIDO','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA, CORRESPONDENTES AO ORCAMENTO ANUAL .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.02.01.00.00.00','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE  TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.02.01.01.00.00','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE - RECURSO LIVRE','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE  TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA. COM RECURSOS LIVRES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.02.01.02.00.00','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE - RECURSO MDE','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE  TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA. COM RECURSOS DA MDE','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.02.01.03.00.00','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE - RECURSO DAS ASPS','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE  TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA. COM RECURSOS DAS ASPS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.02.01.04.00.00','TRANSFERENCIA DE COTA FINANCEIRA RECEBIDA DE OUTRA ENTIDADE - DEMAIS RECURSOS VINCULADOS','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE  TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA. COM OS DEMAIS RECURSOS VINCULADOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.03.00.00.00.00','SUB-REPASSE RECEBIDO','REGISTRA O VALOR DOS SUB-REPASSES RECEBIDOS NO EXERCICIO,  DECORRENTES DE TRANSFERENCIAS ENTRE UGS DO MESMO ORGAO, CORRESPONDENTE AO ORCAMENTO ANUAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.05.00.00.00.00','VALORES DIFERIDOS - BAIXA','REGISTRA O VALOR DA COTA, REPASSE E SUB-REPASSE DIFERIDOS NO PROCESSO DE INSCRICAO E BAIXA DOS RECURSOS DIFERIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.06.00.00.00.00','VALORES DIFERIDOS - INSCRICAO','REGISTRA O VALOR DA COTA, REPASSE E SUB-REPASSE DIFERIDOS NO PROCESSO DE INSCRICAO DOS RECURSOS DIFERIDOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.08.00.00.00.00','APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO','COMPREENDE O MONTANTE DOS VALORES RECEBIDOS DO PROPRIO ENTE,  NECESSARIOS A COBERTURA DE INSIFICIENCIAS  FINANCEIRAS, FORMACAO DE RESERVAS E OUTRAS NECESSIDADES DE RECURSOS PARA O RPPS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.08.01.00.00.00','APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO - REPASSE PARA COBERTURA DE INSUFICIENCIAS FINANCEIRAS','REGISTRA OS RECURSOS ORCAMENTARIOS EFETIVAMENTE UTILIZADOS PARA COBERTURA DE INSUFICIENCIAS FINANCEIRAS ENTRE AS RECEITAS E DESPESAS PREVIDENCIARIAS, NO EXERCICIO DE REFERENCIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.08.02.00.00.00','APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO - REPASSE PREVIDENCIARIO PARA FORMACAO DE RESERVA','REGISTRA O MONTANTE DOS RECURSOS RECEBIDOS DO PROPRIO ENTE PARA FORMACAO  DE  RESERVA ESPONTANEA PARA FUTUROS PAGAMENTOS DE BENEFICIOS DO PLANO FINANCEIRO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.08.99.00.00.00','APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO - OUTROS APORTES PARA O RPPS','REGISTRA O SOMATORIO DOS RECEBIMENTOS DE EVENTUAIS APORTES DE RECURSOS PARA O REGIME PROPRIO DE PREVIDENCIA DO SERVIDOR - RPPS, PARA OUTRAS NECESSIDADES FINANCEIRAS QUE NAO A COBERTURA DE INSUFICIENCIAS  FINANCEIRAS E FORMACAO DE RESERVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.09.00.00.00.00','APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDENCIARIO','REPRESENTA O MONTANTE DOS VALORES RECEBIDOS DO PROPRIO ENTE,  NECESSARIOS A COBERTURA DE DEFICIT FINANCEIRO OU ATUARIAL, NO AMBITO DO PLANO PREVIDENCIARIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.09.01.00.00.00','APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDENCIARIO - REPASSE PARA COBERTURA DE DEFICIT FINANCEIRO','REGISTRA O MONTANTE DOS RECURSOS RECEBIDOS DO PROPRIO ENTE, NECESSARIOS AO EQUILIBRIO FINANCEIRO DO PLANO PREVIDENCIARIO, OU SEJA, A COBERTURA DE DEFICIT ENTRE AS RECEITAS E AS DESPESAS PREVIDENCIARIAS, REFERENTES AO EXERCICIO ATUAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.09.02.00.00.00','APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDENCIARIO - REPASSE PARA COBERTURA DE DEFICIT ATUARIAL','REGISTRA O MONTANTE DOS RECURSOS ORCAMENTARIOS ALOCADOS P/ COBERTURA DE DEFICIT ATUARIAL NO EXERCICIO DE REFERENCIA, CUJO OBJETIVO E GARANTIR A EQUIVALENCIA, A VALOR PRESENTE, ENTRE O FLUXO DE RECEITAS  ESTIMADAS  E  DAS OBRIGACOES PROJETADAS, APURADAS  ATUARIALMENTE, EM LONGO PRAZO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.09.99.00.00.00','APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDENCIARIO - OUTROS APORTES PARA O RPPS','REGISTRA OUTROS APORTES FINANCEIROS PARA O REGIME PROPRIO DE PREVIDENCIA DO SERVIDOR PUBLICO - RPPS, TAIS COMO CAPITALIZACOES DO REGIME.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.97.00.00.00.00','(-) DEDUÇÕES DAS TRANSFERENCIAS INTRA GOVERNAMENTAIS','REGISTRA AS DEDUÇÕES DAS VPA DE TRANSFERENCIA INTRA GOVERNAMENTAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.2.0.00.00.00.00.00','TRANSFERÊNCIAS RECEBIDAS INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras, de bens ou valores recebidas para restos a pagar e outras finalidades independentes da execução orçamentária.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.2.2.00.00.00.00.00','TRANSFERÊNCIAS RECEBIDAS INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','Compreende o valor das transferências financeiras de bens ou valores recebidas para restos a pagar e outras finalidades independentes da execução orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.2.2.01.00.00.00.00','ORDEM DE TRANSFERENCIAS RECEBIDAS','REGISTRA O VALOR DA TRANSFERENCIA DE OTR`S LIBERADAS PELAS   SETORIAIS DE PROGRAMACAO FINANCEIRA DE CADA ORGAO PARA SUAS SUBORDINADAS,  NAO VINCULADAS AO ORCAMENTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.2.2.97.00.00.00.00','(-) DEDUÇÕES DAS TRANSFERENCIAS INTRA GOVERNAMENTAIS','REGISTRA AS DEDUÇÕES DAS VPA DE TRANSFERENCIA INTRA GOVERNAMENTAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.3.0.00.00.00.00.00','TRANSFERENCIAS RECEBIDAS PARA COBERTURA DO DÉFICIT ATUARIAL DO RPPS POR APORTE PERIÓDICO','Compreende o valor das transferências financeiras para aportes periódicos destinados à cobertura do déficit atuarial do Regime Próprio de Previdência Social  - RPPS, conforme plano de amortização estabelecido em lei do respectivo ente Federativo, exceto as decorrentes de alíquota de contribuição suplementar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.3.2.00.00.00.00.00','TRANSFERENCIAS RECEBIDAS PARA COBERTURA DO DÉFICIT ATUARIAL DO RPPS POR APORTE PERIÓDICO - INTRA OFSS','Compreende o valor das transferências financeiras para aportes periódicos destinados à cobertura do déficit atuarial do Regime Próprio de Previdência Social  - RPPS, conforme plano de amortização estabelecido em lei do respectivo ente Federativo, exceto as decorrentes de alíquota de contribuição suplementar. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.0.0.00.00.00.00.00','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','Compreendem as variações patrimoniais aumentativas decorrentes de transferências da União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.0.00.00.00.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS','Compreendem as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.1.00.00.00.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - CONSOLIDAÇÃO','Compreendem as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).  Por exemplo, empresa independente de um ente recebendo transferência de outro ente (a empresa independente não pertence ao OFSS mas pertence ao conceito de governamental).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.00.00.00.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS - UNIÃO','Compreendem as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.01.00.00.00.00','COTA-PARTE DO FUNDO DE PARTICIPACAO DOS MUNICIPIOS - FPM','REGISTRA O VALOR TOTAL DAS VPAS RECEBIDAS ATRAVÉS DE COTA-PARTE DO FUNDO DE PARTICIPAÇÃO DOS MUNICÍPIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.02.00.00.00.00','COTA-PARTE DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - ITR','REGISTRA O VALOR TOTAL DAS VPAS RECEBIDAS ATRAVÉS DE TRANSFERÊNCIAS DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.03.00.00.00.00','COTA-PARTE DO IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO OU RELATIVAS A TITULOS OU VALORES MOBILIARIOS - COMERCIALIZACAO DO OURO','REGISTRA O VALOR TOTAL DAS VPAS RECEBIDAS ATRAVÉS DE COTA-PARTE DO  IMPOSTO SOBRE OPERAÇÕES CRÉDITO CÂMBIO E SEGUROS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.04.00.00.00.00','TRANSFERENCIA DA COMPENSACAO FINANCEIRA PELA EXPLORACAO DE RECURSOS NATURAIS','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA COMPENSAÇÃO FINANCEIRA PELA EXPLORACAO DE RECURSOS NATURAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.05.00.00.00.00','TRANSFERENCIA DE RECURSOS DO SISTEMA UNICO DE SAUDE - SUS - REPASSE FUNDO A FUNDO','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS DO FUNDO NACIONAL DE SAUDE RECEBIDOS PELOS FUNDOS DE SAUDE DOS  ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS, REFERENTE AO SISTEMA ÚNICO DE SAÚDE - SUS,  (PISO DE ATENÇÃO BÁSICA - FIXO E VARIÁVEL, TRANSFERÊN','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.06.00.00.00.00','TRANSFERENCIAS DE RECURSOS DO FUNDO NACIONAL DE ASSISTENCIA SOCIAL - FNAS','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS DA UNIÃO RECEBIDOS PELOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS, REFERENTE AO FUNDO NACIONAL DE ASSISTÊNCIA SOCIAL - FNAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.07.00.00.00.00','TRANSFERENCIAS DE RECURSOS DO FUNDO NACIONAL DO DESENVOLVIMENTO DA EDUCACAO - FNDE','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS DA UNIÃO RECEBIDOS PELOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS, RELATIVOS AO FUNDO NACIONAL DO DESENVOLVIMENTO DA EDUCAÇÃO - FNDE, COMPREENDENDO OS REPASSES REFERENTES AO SALÁRIO-EDUCAÇÃO E DEMAIS PRO','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.08.00.00.00.00','TRANSFERENCIA FINANCEIRA DO ICMS - DESONERACAO - L.C. N° 87/96','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS DA UNIÃO AOS ESTADOS, DISTRITO FEDERAL E AOS MUNICÍPIOS, ATENDIDOS OS LIMITES, CRITÉRIOS, PRAZOS E DEMAIS CONDIÇÕES FIXADOS NO ANEXO A LEI COMPLEMENTAR Nº 87 DE 13/09/96, COM BASE NO PRODUTO DE ARRECAD','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.09.00.00.00.00','TRANSFERENCIA DA UNIAO PARA O ASPS','REGISTRA O VALOR DA TRANSFERÊNCIA RECEBIDA DA UNIÃO CONFORME O QUE DETERMINA O PARÁGRAFO 2° DO ART. 77 DO ADCT DA CF/88 COM A REDAÇÃO DADA PELA EC N° 29, PARA VINCULAÇÃO ESPECÍFICA  NO ATENDIMENTO DAS AÇÕES E SERVIÇOS PÚBLICOS DE SAÚDE.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.10.00.00.00.00','TRANSFERENCIA DA UNIAO PARA O FUNDO MUNICIPAL DA CRIANCA E DO ADOLESCENTE','REGISTRA A VPA RECEBIDA DA UNIÃO REFERENTE A INCENTIVOS FISCAIS PREVISTOS NA LEGISLAÇÃO DO IMPOSTO DE RENDA, EM ATENDIMENTO AO ESTATUTO DA CRIANÇA E DO ADOLESCENTE - ECA, LEI N° 8069/90.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.11.00.00.00.00','TRANSFERENCIA DA UNIAO - PASEP','REGISTRA A VPA RECEBIDA DA UNIÃO REFERENTE AO PASEP.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.12.00.00.00.00','AUXÍLIO FINANCEIRO - ESFORÇO EXPORTADOR (MP N° 193/04)','REGISTRA O VALOR DA TRANSFERENCIA RECEBIDA DA UNIAO REFERENTE AO AUXILIO EXPORTADOR - CEX (REGISTRA O VALOR DA ARRECADAÇÃO DE RECEITA DE TRANSFERÊNCIA DA COMPENSAÇÃO FINANCEIRA.), INSTITUIDA PELA MEDIDA PROVISORIA 193.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.13.00.00.00.00','FPM - APOIO FINANCEIRO (MP 462/2009)','REGISTRA O VALOR DA PRESTAÇÃO DE APOIO FINANCEIRO PELA UNIÃO AOS ENTES FEDERADOS QUE RECEBEM RECURSOS DO FUNDO DE PARTICIPAÇÃO DOS MUNICÍPIOS - FPM, NO EXERCÍCIO DE 2009, COM O OBJETIVO DE SUPERAR DIFICULDADES FINANCEIRAS EMERGENCIAIS. SALIENTA-SE QUE ESS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.14.00.00.00.00','FPM - APOIO FINANCEIRO (MP 480/2010)','REGISTRA O VALOR DA PRESTAÇÃO DE APOIO FINANCEIRO PELA UNIÃO AOS ENTES FEDERADOS QUE RECEBEM RECURSOS DO FUNDO DE PARTICIPAÇÃO DOS MUNICÍPIOS - FPM, NO EXERCÍCIO DE 2010, COM O OBJETIVO DE SUPERAR DIFICULDADES FINANCEIRAS EMERGENCIAIS. SALIENTA-SE QUE ESS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.15.00.00.00.00','TRANSFERENCIAS DE CONVENIOS DA UNIAO E DE SUAS ENTIDADES','REGISTRA O VALOR TOTAL DOS RECURSOS ORIUNDOS DE CONVÊNIOS FIRMADOS, COM OU SEM CONTRAPRESTAÇÕES DE SERVIÇOS, COM A UNIÃO OU COM SUAS ENTIDADES, PARA REALIZAÇÃO DE OBJETIVOS DE INTERESSE COMUM DOS PARTÍCIPES, E DESTINADOS A CUSTEAR DESPESAS CORRENTES. EX: PARA O SISTEMA UNICO DE SAUDE - SUS, CONVENIOS DA UNIAO DESTINADAS A PROGRAMAS DE EDUCACAO, CONVENIOS DA UNIAO DESTINADAS A PROGRAMAS DE ASSISTENCIA SOCIAL, CONVENIOS DA UNIAO DESTINADAS A PROGRAMAS DE COMBATE A FOME, DESTINADAS A PROGRAMAS DE SANEAMENTO BASICO ALÉM DE OUTRAS TRANSFERENCIAS DE CONVENIOS DA UNIAO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.99.00.00.00.00','OUTRAS TRANSFERENCIAS DA UNIAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERENCIAS DA UNIAO AOS ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.97.00.00.00.00','(-) DEDUÇÕES DAS TRANSFERENCIAS INTER GOVERNAMENTAIS','REGISTRA AS DEDUÇÕES DAS VPA DE TRANSFERENCIA INTER GOVERNAMENTAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.00.00.00.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS - ESTADO','Compreendem as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.01.00.00.00.00','COTA-PARTE DO ICMS','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA PARTICIPAÇÃO DE MUNICÍPIOS NA ARRECADAÇÃO DO IMPOSTO SOBRE A CIRCULAÇÃO DE MERCADORIAS E PRESTAÇÃO DE SERVIÇOS - ICMS, PELO ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.02.00.00.00.00','COTA-PARTE DO IPVA','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA PARTICIPAÇÃO DE MUNICÍPIOS NA ARRECADAÇÃO DO IMPOSTO SOBRE A PROPRIEDADE DE VEÍCULOS AUTOMOTORES - IPVA, PELO ESTADO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.03.00.00.00.00','COTA-PARTE DO IPI SOBRE EXPORTACAO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA PARTICIPAÇÃO DE MUNICÍPIOS NA ARRECADAÇÃO DO IMPOSTO SOBRE A PRODUTOS INDUSTRIALIZADOS - IPI, PARA EXPORTAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.04.00.00.00.00','COTA-PARTE DO ANTIGO ITCD (CF/67)','REGISTRA O VALOR, NO CASO DO MUNICÍPIO RECEBER DO ESTADO ALGUMA TRANSFERÊNCIA REFERENTE A ARRECADAÇÃO INCIDENTE SOBRE A TRANSMISSÃO DA PROPRIEDADE DE BENS IMÓVEIS, INCLUSIVE DOS DIREITOS A ELES RELATIVOS, BENS MÓVEIS, DIREITOS, TÍTULOS E CRÉDITOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.05.00.00.00.00','TRANSFERENCIA DA COTA-PARTE DA COMPENSACAO FINANCEIRA (25%)','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE TRANSFERÊNCIA DA COTA-PARTE DA  COMPENSAÇÃO FINANCEIRA PROVENIENTE DA EXPLORACAO DE RECURSOS NATURAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.06.00.00.00.00','TRANSFERENCIA DE RECURSOS DO ESTADO PARA PROGRAMAS DE SAUDE - REPASSE FUNDO A FUNDO','REGISTRA A VPA DA TRANSFERÊNCIA DE RECURSOS DO SISTEMA ÚNICO DE SAÚDE ORIUNDO DO FUNDO ESTADUAL DE SAUDE PARA O FUNDO MUNICIPAL DE SAUDE (AÇÕES BÁSICAS DE VIGILÂNCIA SANITÁRIA, ATENÇÃO À SAÚDE DOS POVOS INDÍGENAS, PROGRAMA DE ASSISTÊNCIA FARMACÊUTICA BÁSICA, PROGRAMA DE COMBATE ÀS CARÊNCIAS NUTRICIONAIS, PROGRAMA DE SAÚDE DA FAMÍLIA, PROGRAMA DE AGENTES COMUNITÁRIOS, PROGRAMA NACIONAL DE VIGILÂNCIA EPIDEMIOLÓGICA E CONTROLE DE DOENÇAS E OUTROS).  ESTA CONTA DEVERÁ SER DESDOBRADA PELO MUNICIPIO EM TANTAS CONTAS ANALITICAS QUANTAS FOREM AS FINANLIDADES DIVERSAS DOS RECURSOS RECEBIDOS, SENDO VINCULADO UM CÓDIGO DE RECURSO PARA CADA UMA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.07.00.00.00.00','COTA-PARTE DA MULTA DE TRANSITO','REGISTRA O VALOR TOTAL DAS VPAS RECEBIDAS ATRAVÉS DE COTA-PARTE DA MULTA DE TRÂNSITO TRANSFERIDA PELO ESTADO E EXECUTADAS COMO RECURSO LIVRE ATÉ 30 DE JUNHO DE 2009.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.08.00.00.00.00','TRANSFERENCIAS DE CONVENIOS DOS ESTADOS E DO DISTRITO FEDERAL E DE SUAS ENTIDADES','REGISTRA O VALOR TOTAL DOS RECURSOS ORIUNDOS DE CONVÊNIOS FIRMADOS, COM OU SEM CONTRAPRESTAÇÕES DE SERVIÇOS COM ESTADOS OU COM O DISTRITO FEDERAL E RESPECTIVAS ENTIDADES PÚBLICAS, PARA REALIZAÇÃO DE OBJETIVOS DE INTERESSE COMUM DOS PARTÍCIPES, E DESTINADOS A CUSTEAR DESPESAS CORRENTES. EX: CONVENIOS DOS ESTADOS PARA O SISTEMA UNICO DE SAUDE - SUS, CONVENIOS DOS ESTADOS DESTINADAS A PROGRAMAS DE EDUCACAO, PROGRAMA DE ABRIGAGEM A POPULACAO ADULTA DE RUA, REVISAO DE BENEFICIOS DE PRESTACAO CONTINUADA - BPC, PROGRAMA DE ATENDIMENTO A CRIANCA, PROGRAMA DE APOIO A PESSOA PORTADORA DE DEFICIENCIA, PROGRAMA DE ATENCAO A PESSOA IDOSA, PROGRAMA ASEMA-APOIO SOCIO-EDUCATIVO EM MEIO ABERTO, PROGRAMA OASF - ORIENTACAO E APOIO SOCIO-FAMILIAR, PROGRAMA DE ABRIGO AS CRIANCAS E ADOLESCENTES, TRANSFERENCIAS RELATIVAS AO PROSAN ALÉM DE OUTRAS TRANSFERENCIAS DE CONVENIOS DOS ESTADOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.99.00.00.00.00','OUTRAS TRANSFERENCIAS DOS ESTADOS E DF','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERENCIAS DOS ESTADOS E  DISTRITO FEDERAL A UNIAO E AOS  MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.97.00.00.00.00','(-) DEDUÇÕES DAS TRANSFERENCIAS INTER GOVERNAMENTAIS','REGISTRA AS DEDUÇÕES DAS VPA DE TRANSFERENCIA INTER GOVERNAMENTAL','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.2.0.00.00.00.00.00','TRANSFERÊNCIAS DO FUNDEB','Compreende as variações patrimoniais aumentativas decorrentes da recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.2.3.00.00.00.00.00','TRANSFERÊNCIAS DO FUNDEB - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas decorrentes de recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007, decorrentes de complementação da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.2.4.00.00.00.00.00','TRANSFERÊNCIAS DO FUNDEB - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas decorrentes da recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.0.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.1.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.3.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - UNIÃO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.4.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - ESTADO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.5.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - MUNICÍPIO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.0.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.1.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.3.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - UNIÃO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.4.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - ESTADO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.5.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - INTER OFSS - MUNICÍPIO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.0.0.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas, inclusive de bens e valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.1.0.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas sem fins lucrativos, inclusive de bens e valores. Exemplo: ONGs, OSCIPS e OS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.1.1.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas sem fins lucrativos, inclusive de bens e valores. Exemplo: ONGs, OSCIPS e OS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.2.0.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas com fins lucrativos, inclusive de bens e valores.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.2.1.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas com fins lucrativos, inclusive de bens e valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.4.0.0.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES MULTIGOVERNAMENTAIS','Compreende as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.4.0.1.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.4.0.1.01.00.00.00.00','TRANSFERENCIAS DE RECURSOS DO FUNDEB','REGISTRA O VALOR TOTAL DOS RECURSOS DE TRANSFERÊNCIAS RECEBIDOS DIRETAMENTE DO FUNDEB, PELOS ESTADOS, DISTRITO FEDERAL E MUNICÍPIOS, INDEPENDENTE DO VALOR QUE FOI DEDUZIDO NO ENTE PARA FORMACAO DO FUNDEB.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.4.0.1.02.00.00.00.00','OUTRAS TRANSFERENCIAS MULTIGOVERNAMENTAIS','REGISTRA O VALOR DA VPA DE OUTRAS TRANSFERÊNCIAS MULTIGOVERNAMENTAIS , NÃO CLASSIFICADOS NOS ITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.5.0.0.00.00.00.00.00','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências de consórcios públicos, dos quais o ente recebedor participe.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.5.0.1.00.00.00.00.00','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes das transferências de consórcios públicos, dos quais o ente recebedor participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.6.0.0.00.00.00.00.00','TRANSFERÊNCIAS DO EXTERIOR','Compreende as variações patrimoniais aumentativas decorrentes de transferências de organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.6.0.1.00.00.00.00.00','TRANSFERÊNCIAS DO EXTERIOR - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de transferências de organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.0.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) ou Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.1.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.1.3.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.1.4.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.1.5.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.2.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização de Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.2.1.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização de Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.8.0.0.00.00.00.00.00','TRANSFERÊNCIAS DE PESSOAS FÍSICAS','Compreende as variações patrimoniais aumentativas decorrentes de contribuições e doações a governos e entidades da administração descentralizada realizadas por pessoas físicas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.8.0.1.00.00.00.00.00','TRANSFERÊNCIAS DE PESSOAS FÍSICAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de contribuições e doações a governos e entidades da administração descentralizada realizadas por pessoas físicas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.0.0.0.00.00.00.00.00','VALORIZAÇÃO E GANHOS COM ATIVOS','Compreende a variação patrimonial aumentativa com reavaliação e ganhos de ativos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.0.0.00.00.00.00.00','REAVALIAÇÃO DE ATIVOS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo, quando esse for superior ao valor liquido contábil.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.1.0.00.00.00.00.00','REAVALIAÇÃO DE IMOBILIZADO','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for superior ao valor liquido contábil.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.1.1.00.00.00.00.00','REAVALIAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for superior ao valor liquido contábil.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.2.0.00.00.00.00.00','REAVALIAÇÃO DE INTANGÍVEIS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for superior ao valor liquido contábil.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.2.1.00.00.00.00.00','REAVALIAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for superior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.9.0.00.00.00.00.00','REAVALIAÇÃO DE OUTROS ATIVOS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for superior ao valor liquido contábil.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.9.1.00.00.00.00.00','REAVALIAÇÃO DE OUTROS ATIVOS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for superior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.0.0.00.00.00.00.00','GANHOS COM ALIENAÇÃO','Compreende o ganho com alienação de ativos, ou seja, quando o valor alienado do ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.1.0.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS','Compreende o ganho com alienação de investimentos, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.1.1.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','Registra o ganho com alienação de investimentos, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.2.0.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE IMOBILIZADO','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.2.1.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.3.0.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS','Compreende o ganho com alienação de ativos intangíveis, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.3.1.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Registra o ganho com alienação de ativos intangíveis, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.0.0.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS','Compreende a contrapartida da incorporação de novos ativos descobertos, a contrapartida da incorporação de ativos semoventes nascidos, por exemplo.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.1.0.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS','Compreende os ganhos com a incorporação de novos ativos descobertos, como por exemplo, descoberta de jazidas de recursos naturais.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.1.1.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS - CONSOLIDAÇÃO','Registra os ganhos com a incorporação de novos ativos descobertos, como por exemplo, descoberta de jazidas de recursos naturais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.2.0.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS','Compreende os ganhos com a incorporação de semoventes nascidos, como por exemplo, nascimento de bovinos e aves.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.2.1.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS - CONSOLIDAÇÃO','Registra os ganhos com a incorporação de semoventes nascidos, como por exemplo, nascimento de bovinos e aves. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.3.0.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE VALORES APREENDIDOS','Compreende os ganhos  com a incorporação de valores apreendidos, como por exemplo, os valores apreendidos associados ao trafico ilícito de entorpecentes e drogas afins.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.3.1.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS APREENDIDOS - CONSOLIDAÇÃO','Registra os ganhos  com a incorporação de ativos apreendidos, como por exemplo, os valores apreendidos associados ao trafico ilícito de entorpecentes e drogas afins. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.3.9.00.00.00.00.00','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS','Compreende a contrapartida da incorporação de outros novos ativos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.3.9.01.00.00.00.00','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS - CONSOLIDAÇÃO','Compreende a contrapartida da incorporação de outros novos ativos.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.0.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','Compreende o somatório das demais variações patrimoniais aumentativas não incluídas nos grupos anteriores, tais como: resultado positivo da equivalência patrimonial, dividendos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.1.0.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR','Compreende os recursos referentes à variação patrimonial aumentativa recebidas e não classificadas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.1.0.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - CONSOLIDAÇÃO','Compreende os recursos referentes à variação patrimonial aumentativa recebidas e não classificadas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.0.0.00.00.00.00.00','RESULTADO POSITIVO DE PARTICIPAÇÕES','Compreende o resultado positivo das participações de caráter permanente no capital social de sociedades investidas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.0.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.1.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.2.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTRA OFSS','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros.   Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.3.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - UNIÃO','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.4.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - ESTADO','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.5.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.2.0.00.00.00.00.00','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS','Compreende as variações aumentativas oriundas de lucros apurados em outros investimentos não avaliados pelo método da equivalência patrimonial.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.2.1.00.00.00.00.00','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - CONSOLIDAÇÃO','Registra as variações aumentativas oriundas de lucros apurados em outros investimentos não avaliados pelo método da equivalência patrimonial. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.0.0.00.00.00.00.00','REVERSÃO DE PROVISÕES E AJUSTES DE PERDAS','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões e ajustes de perdas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.0.00.00.00.00.00','REVERSÃO DE PROVISÕES','Registra as variações patrimoniais aumentativas provenientes de reversões de provisões.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.1.00.00.00.00.00','REVERSÃO DE PROVISÕES - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.3.00.00.00.00.00','REVERSÃO DE PROVISÕES - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.4.00.00.00.00.00','REVERSÃO DE PROVISÕES - INTER OFSS - ESTADOS','Registra as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.5.00.00.00.00.00','REVERSÃO DE PROVISÕES - INTER OFSS - MUNICÍPIOS','Registra as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.0.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.1.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.2.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS - INTRA OFSS','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.3.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS -INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.4.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS -INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.5.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS -INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.0.0.00.00.00.00.00','DIVERSAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','Compreende outras variações patrimoniais aumentativas não classificadas em itens específicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.0.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.2.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','Registra as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.3.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.3.01.00.00.00.00','COMPENSAÇÕES FINANCEIRAS ENTRE O REGIME GERAL E OS REGIMES PRÓPRIOS DE PREVIDÊNCIA DOS SERVIDORES - PRINCIPAL','REGISTRA A VPA DECORRENTE DE COMPENSAÇÕES FINANCEIRAS ENTRE O REGIME GERAL E OS REGIMES PRÓPRIOS DE PREVIDÊNCIA DOS SERVIDORES - PRINCIPAL','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.3.02.00.00.00.00','COMPENSAÇÕES FINANCEIRAS ENTRE O REGIME GERAL E OS REGIMES PRÓPRIOS DE PREVIDÊNCIA DOS SERVIDORES - PARCELAMENTOS','REGISTRA A VPA DECORRENTE DE COMPENSAÇÕES FINANCEIRAS ENTRE O REGIME GERAL E OS REGIMES PRÓPRIOS DE PREVIDÊNCIA DOS SERVIDORES - PARCELAMENTOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.4.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.5.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.2.0.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.2.3.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.2.4.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.2.5.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.3.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES','Compreende as variações patrimoniais aumentativas provenientes de bonificações recebidas nas aquisições de mercadorias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.3.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de bonificações recebidas nas aquisições de mercadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.0.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.1.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.2.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTRA OFSS','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.3.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.4.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.5.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e município.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.0.00.00.00.00.00','MULTAS ADMINISTRATIVAS','Compreende as variações patrimoniais aumentativas provenientes de penalidades pecuniárias decorrentes da inobservância de normas, e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Representa o resultado das aplicações impostas ao contribuinte faltoso, como sanção legal no campo tributário (impostos, taxas e contribuição de melhoria) e não-tributário (contribuições sociais e econômicas, patrimoniais, industriais, serviços e diversas) e de natureza administrativa, por infrações a regulamentos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.00.00.00.00.00','MULTAS ADMINISTRATIVAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de penalidades pecuniárias decorrentes da inobservância de normas, e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Representa o resultado das aplicações impostas ao contribuinte faltoso, como sanção legal no campo tributário (impostos, taxas e contribuição de melhoria) e não-tributário (contribuições sociais e econômicas, patrimoniais, industriais, serviços e diversas) e de natureza administrativa, por infrações a regulamentos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.03.00.00.00.00','MULTA DE POLUICAO DE AGUAS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DESTINADAS A PUNIR O INFRATOR  PELA  POLUICAO  DE  AGUAS.  MULTAS   DEV.  LANCAMENTO   OLEOS,PRODUTOS OLEOSOS E SUBSTANCIAS QUIMICAS TOXICAS NAS AGUAS PUBLICAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.07.00.00.00.00','MULTAS PREVISTAS NA LEGISLAÇÃO SANITARIA','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE MULTAS  APLICADAS  COM O FIM DE PUNIR A QUEM TRANSGRIDE O DISPOSTO NA LEGISLACAO SANITARIA. DEVIDASQUANDO DA INFRACAO, FRAUDE, FALSIFICACAO E ADULTERACAO DAS   MATERIAS-PRIMAS E PRODUTOS FARMACEUTICOS, BEM COMO QUAISQUER PRODUTOS OU  INSUMOS QUE INTERESSEM A SAUDE PUBLICA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.08.00.00.00.00','MULTAS PREVISTAS LEGISLAÇÃO DE REGISTRO COMERCIO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS  COM  O FIM DE PUNIR A QUEM INFRINGE AS LEIS OU REGULAMENTOS QUE DISCIPLINAM AS ATIVIDADES DE AGENTES AUXILIARES DO COMERCIO, DE ARMAZENS GERAIS E  OUTROS SUJEITOS AO CONTROLE E FISCALIZACAO DOS ORGAOS DE REGISTRO DO COMERCIO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.11.00.00.00.00','MULTAS PREVISTAS NA LEGISLAÇÃO DE TRANSITO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE MULTAS  APLICADAS  COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A TRANSITO.  CONSTITUEM VPA VINCULADA AO MINISTERIO DA JUSTICA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.14.00.00.00.00','MULTAS E JUROS PREVISTOS EM CONTRATOS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE  MULTAS E JUROS PREVISTOS EM CONTRATOS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.15.00.00.00.00','MULTAS DECORRENTES DE OPERAÇÕES DE TRANSPORTE RODOVIARIO DE PASSAGEIROS E CARGAS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES DAS LEGISLACOES DE OPERACAO DO TRANSPORTE RODOVIARIO DE PASSAGEIROS  E CARGAS, BEM COMO DOS CONTRATOS DE CONCESSAO DE SERVICOS DE  TRANSPORTE RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS E CARGAS','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.21.00.00.00.00','MULTAS POR DANOS AO MEIO AMBIENTE','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE  MULTAS POR DANOS AO MEIO AMBIENTE. AMPARO LEGAL: LEI 9 605 DE 12FEV1998','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.25.00.00.00.00','MULTAS APLICADAS PELOS TRIBUNAIS DE CONTAS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS MULTAS APLICADAS PELOS TRIBUNAIS DE CONTAS,  PELO NAO CUMPRIMENTO A DECISAO DOS MESMOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.27.00.00.00.00','MULTAS POR AUTOS DE INFRACAO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE MULTAS PUNITIVAS  APLICADAS PELO NAO CUMPRIMENTO NOS CASOS PREVISTOS NOS REGULAMENTOS OU NOS CONTRATOS, OU PELA REINCIDENCIA EM FATOS QUE TENHAM GERADO ADVERTENCIA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.28.00.00.00.00','MULTA POR INFRAÇÃO À LEGISLAÇÃO DE LICITAÇÃO','REGISTRA O VALOR DA ARRECADAÇÃO DE VPA DE MULTAS APLICADAS POR INFRAÇÕES PRATICADAS EM INOBSERVÂNCIA À LEGISLAÇÃO APLICADA AOS PROCEDIMENTOS DE LICITAÇÃO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.99.00.00.00.00','OUTRAS MULTAS ADMINISTRATIVAS','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE OUTRAS MULTAS ADMINISTRATIVAS NAO ENQUADRADAS NAS CONTAS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.0.00.00.00.00.00','INDENIZAÇÕES','Compreende as variações patrimoniais aumentativas provenientes de indenizações diversas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.1.00.00.00.00.00','INDENIZAÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de indenizações diversas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.1.01.00.00.00.00','INDENIZACOES POR DANOS CAUSADOS AO PATRIMONIO PUBLICO','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR     DANOS CAUSADOS AO PATRIMONIO PUBLICO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.1.99.00.00.00.00','OUTRAS INDENIZACOES','REGISTRA AS VARIACOES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE INDENIZACOES QUE NAO SE ENQUADRAM NOS ITENS ANTERIORES.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.7.0.00.00.00.00.00','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS','Compreende o somatório das variações patrimoniais aumentativas geradas pela alienação de mercadorias, objeto da pena de perdimento. O produto da arrecadação tem a seguinte destinação: 60% ao fundo especial de desenvolvimento e aperfeiçoamento das atividades de fiscalização - fundão e 40% ao fundo nacional de assistência social - Ministério da Previdência e Assistência Social ao fundo nacional antidroga - FUNAD, para aplicação conforme legislação em vigor, quando da apreensão de bens, direitos e valores objeto do crime de trafico ilícito de substancias entorpecentes ou drogas afins. (lei 6368 de 21/10/76, lei 7460 de 19/12/86 e lei 9804 de 30/06/99)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.7.1.00.00.00.00.00','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS - CONSOLIDAÇÃO','Compreende o somatório das variações patrimoniais aumentativas geradas pela alienação de mercadorias, objeto da pena de perdimento. O produto da arrecadação tem a seguinte destinação: 60% ao fundo especial de desenvolvimento e aperfeiçoamento das atividades de fiscalização - fundão e 40% ao fundo nacional de assistência social - Ministério da Previdência e Assistência Social ao fundo nacional antidroga - FUNAD, para aplicação conforme legislação em vigor, quando da apreensão de bens, direitos e valores objeto do crime de trafico ilícito de substancias entorpecentes ou drogas afins. (lei 6368 de 21/10/76, lei 7460 de 19/12/86 e lei 9804 de 30/06/99). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.7.1.01.00.00.00.00','VPA DE ALIENAÇÃO DE BENS E/OU MERCADORIAS APREENDIDAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS  AUMENTATIVAS PROVENIENTES DE ALIENACAO DE BENS E/OU DE MERCADORIAS APREENDIDAS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','Compreende as variações patrimoniais aumentativas decorrentes de fatos geradores diversos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de fatos geradores diversos.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.01.00.00.00.00','VPA DE ONUS SUCUMBENCIA DE ACOES JUDICIAIS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DO MUNICIPIO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA MUNICIPAL, PAGA PELO DEVEDOR DA ACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.01.01.00.00.00','VPA DE HONORARIOS DE ADVOGADOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA  DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.02.00.00.00.00','"TERCEIRIZAÇÃO" DA FOLHA DE PAGAMENTO DOS AGENTES PUBLICOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA TERCEIRIZACAO DA FOLHA  DE PAGAMENTO DOS AGENTES PUBLICOS COMO CONTRAPARTIDA DA PRESTACAO DE SERVICOS DE DISPONIBILIZACAO DE CREDITOS EM CONTAS CORRENTES E DA CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS COM AMORTIZACAO CONSIGNADA EM FOLHA DE PAGAMENTO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.03.00.00.00.00','OUTRAS RECEITAS DIRETAMENTE ARRECADADAS PELO RPPS','REGISTRA O VALOR TOTAL DAS DEMAIS VPAS CORRENTES ARRECADADAS DIRETAMENTE PELO REGIME PRÓPRIO DE PREVIDÊNCIA','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.04.00.00.00.00','RECEITAS DIRETAMENTE ARRECADADAS PELO FUNDO DE ASSISTENCIA SOCIAL DOS SERVIDORES','REGISTRA O VALOR TOTAL DAS VPAS CORRENTES ARRECADADAS DIRETAMENTE PELO FUNDO DE ASSISTÊNCIA SOCIAL DOS SERVIDORES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.05.00.00.00.00','RECEITAS DIRETAMENTE ARRECADADAS PELO FUNDO DE ASSISTENCIA A SAUDE DOS SERVIDORES','REGISTRA O VALOR TOTAL DAS VPAS CORRENTES ARRECADADAS DIRETAMENTE PELO FUNDO DE ASSISTÊNCIA A SAÚDE DOS SERVIDORES','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.06.00.00.00.00','RECEITAS DECORRENTES DA COMPRA DE DOSES DE SEMEN DE ANIMAIS PELOS PRODUTORES','REGISTRA O VALOR TOTAL DA VPA DECORRENTE DA COMPRA PELOS PRODUTOS DE SÊMEN DE ANIMAIS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.07.00.00.00.00','RECEITAS DECORRENTES DO RECEBIMENTO DE CERTIDÃO - TÍTULO EXECUTIVO DO TCE/RS','REGISTRA A VPA DECORRENTES DO RECEBIMENTO TOTAL OU PARCIAL  DE CERTIDÃO - TÍTULO EXECUTIVOEMITIDO PELO  TCE/RS O QUAL FOI REGISTRADO NO ATIVO COMO CRÉDITOS A RECEBER E NÃO COMO DIVIDA ATIVA NÃO-TRIBUTÁRIA','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.08.00.00.00.00','PROGRAMA TROCA-TROCA','REGISTRA O VALOR TOTAL DA VPA PROVENIENTE DO PAGAMENTO PELOS AGRICULTORES DO VALOR QUE LHES FOI ENTREGUE EM SEMENTES PELO MUNICÍPIO. INCLUSIVE A VPA DA DIVIDA ATIVA.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.09.00.00.00.00','RESTITUICOES DETERMINADAS PELO TCE','REGISTRA A VPA PROVENIENTE DE CRÉDITOS EXIGÍVEIS A PARTIR DO RECEBIMENTO, PELO CREDOR, DE CERTIDÃO DE DECISÃO - TÍTULO EXECUTIVO, EMITIDA PELO TRIBUNAL DE CONTAS DO ESTADO, COM CARACTERÍSTICA DE LIQUIDEZ E CERTEZA, CUJA INSCRIÇÃO DO DIREITO DEU-SE, FA','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.10.00.00.00.00','RESTITUICAO PELO USO DE BENS DO MUNICIPIO','REGISTRA O VALOR TOTAL DA ARRECADAÇÃO DA VPA PROVENIENTE DA UTILIZAÇÃO DE BENS DO MUNICÍPIO. EX: TELEFONE MÓVEL','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.11.00.00.00.00','RESTITUICAO PELO PAGAMENTO INDEVIDO','REGISTRA O VALOR DA RESTITUIÇÃO PROVENIENTE DE PAGAMENTO INDEVIDO.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.12.00.00.00.00','RESTITUICAO DE AUXILIOS','REGISTRA A ARRECADAÇÃO DE RECURSOS PROVENIENTES DA DEVOLUÇÃO DE SALDOS DE AUXÍLIOS.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.0.0.0.0.00.00.00.00.00','CONTROLES DA APROVAÇÃO DO PLANEJAMENTO E ORÇAMENTO','Compreende as contas com função de registrar os atos e fatos ligados a execução orçamentária.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.0.0.0.00.00.00.00.00','PLANEJAMENTO APROVADO','Compreende o somatório dos valores monetários previstos para execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei orçamentária anual.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.1.0.0.00.00.00.00.00','PPA - APROVADO','Compreende o somatório dos valores monetários previstos para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.1.1.0.00.00.00.00.00','PPA POR PROGRAMA DE TRABALHO','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL APROVADO PARA O PERIODO DE QUATRO ANOS, DETALHADO POR PROGRAMA DE TRABALHO .','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.1.2.0.00.00.00.00.00','REVISAO DO PPA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DAS REVISOES ANUAIS AUTORIZADAS DURANTE O PERIODO DE VIGENCIA DO PLANO PLURIANUAL, DETALHADO POR PROGRAMA DE TRABALHO.','X','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.0.0.00.00.00.00.00','PLOA','Compreende o somatório dos valores monetários previstos para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no projeto de lei orçamentária anual.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.1.0.00.00.00.00.00','PROJETO INICIAL DA LEI ORCAMENTARIA  - RECEITA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS CONSTANTES DO PROJETO DA LEI ORCAMENTARIA ANUAL REMETIDO PELO PODER EXECUTIVO AO PODER LEGISLATIVO PARA APRECIACAO E APROVACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.1.1.00.00.00.00.00','PLOA INICIAL DA RECEITA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DA PREVISAO DE RECEITA CONSTANTE DO PLOA INICIAL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.1.2.00.00.00.00.00','ALTERACOES  DO PROJETO INICIAL DA LOA - RECEITA','REGISTRA O SOMATORIO DAS ALTERACOES NO PROJETO INICIAL DA LOA EM RELACAO A RECEITA.','X','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.2.0.00.00.00.00.00','PROJETO INICIAL DA LOA - DESPESA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS CONSTANTES DO PROJETO DA LEI ORCAMENTARIA ANUAL REMETIDO PELO PODER EXECUTIVO AO PODER LEGISLATIVO PARA APRECIACAO E APROVACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.2.1.00.00.00.00.00','PLOA INICIAL DA DESPESA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DA FIXACAO DA DESPESA CONSTANTE DO PLOA INICIAL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.2.2.00.00.00.00.00','ALTERACOES DO PROJETO INICIAL DA LOA - DESPESA','REGISTRA O SOMATORIO DAS ALTERACOES NO PROJETO INICIAL DA LOA EM RELACAO A DESPESA.','X','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.0.0.0.00.00.00.00.00','ORÇAMENTO APROVADO','Compreende o somatório dos valores relativos à previsão da receita, fixação da despesa e suas alterações no orçamento geral da União durante o exercício financeiro.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.0.0.00.00.00.00.00','PREVISÃO DA RECEITA','Compreende o somatório dos valores relativos à previsão da receita pública aprovada pela lei orçamentária anual e suas alterações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.1.0.00.00.00.00.00','PREVISÃO INICIAL DA RECEITA','Compreende o valor da receita previsão inicial da receita aprovado na LOA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.1.0.01.00.00.00.00','PREVISAO INICIAL DA RECEITA  BRUTA','REGISTRA O VALOR BRUTO DA RECEITA PREVISÃO INICIAL DA RECEITA .','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.1.0.02.00.00.00.00','(-) PREVISÃO DE DEDUÇÕES DA RECEITA','REGISTRA O VALOR DAS DEDUÇÕES DE  RECEITA ORÇAMENTÁRIA PREVISTAS  EM ORÇAMENTO PARA O EXERCÍCIO VIGENTE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.2.0.00.00.00.00.00','ALTERAÇÃO DA PREVISÃO DA RECEITA','Registra o valor dos créditos previstos após a aprovação do orçamento independente da autorização já concedida na lei orçamentária para abertura de credito suplementar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.2.1.00.00.00.00.00','PREVISÃO ADICIONAL DA RECEITA','Registra o valor adicional da receita para abertura de créditos adicionais.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.2.9.00.00.00.00.00','(-) ANULAÇÃO DA PREVISÃO DA RECEITA','Registra o valor da anulação da receita prevista no orçamento, na gestão fundos e nas administrações direta e indireta.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.0.0.00.00.00.00.00','FIXAÇÃO DA DESPESA','Compreende o somatório dos valores relativos à fixação da despesa pública aprovada pela lei orçamentária e suas alterações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.0.00.00.00.00.00','DOTAÇÃO ORÇAMENTÁRIA','Compreende o somatório dos valores monetários da dotação orçamentária inicial, adicional e seus cancelamentos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.1.00.00.00.00.00','DOTAÇÃO INICIAL','Compreende a dotação inicial autorizada na lei orçamentária anual.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.1.01.00.00.00.00','CREDITO INICIAL','COMPREENDE OS VALORES PERTINENTES AOS CREDITOS INICIALMENTE APROVADOS PARA DAR SUPORTE A EXECUCAO ORCAMENTARIA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.1.01.01.00.00.00','ORIGINARIO DO OGM','REGISTRA OS VALORES PERTINENTES AOS CREDITOS INICIAIS  APROVADOS  PELA LEI ORCAMENTARIA, PARA EXECUCAO DO ORCAMENTO DOS ORGAOS/ENTIDADES  INTEGRANTES DO OGM REFERENTES AO OFSS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.00.00.00.00.00','DOTAÇÃO ADICIONAL POR TIPO DE CREDITO','Compreende o somatório dos valores monetários da dotação orçamentária decorrentes da abertura de créditos adicionais e seus cancelamentos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.01.00.00.00.00','CREDITO ADICIONAL - SUPLEMENTAR','Compreende o somatório dos valores relativos aos créditos adicionais suplementares com vista ao reforço da dotação orçamentária constante da lei orçamentária.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.02.00.00.00.00','CREDITO ADICIONAL - ESPECIAL','Compreende o somatório dos valores dos créditos adicionais especiais destinados a atender programas não contemplados na lei orçamentária anual.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.02.01.00.00.00','CRÉDITOS ESPECIAIS ABERTOS','Registra os valores referentes à abertura de créditos especiais autorizados em lei especifica.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.02.02.00.00.00','CRÉDITOS ESPECIAIS REABERTOS','Registra os valores referentes à reabertura de créditos especiais cujo ato de autorização foi promulgado nos últimos quatro meses do exercício anterior.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.02.03.00.00.00','CRÉDITOS ESPECIAIS REABERTOS - SUPLEMENTAÇÃO','Registra os valores referentes à suplementação de créditos especiais reabertos nos termos do § 2º do art. 167 da C.F./88.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.03.00.00.00.00','CREDITO ADICIONAL - EXTRAORDINÁRIO','Compreende o somatório dos valores referentes à abertura de créditos adicionais extraordinários destinados a despesas imprevisíveis e urgentes como as decorrentes de guerra, comoção interna ou calamidade pública.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.03.01.00.00.00','CRÉDITOS EXTRAORDINÁRIOS ABERTOS','Registra os valores referentes aos créditos extraordinários abertos por decreto do poder executivo.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.03.02.00.00.00','CRÉDITOS EXTRAORDINÁRIOS REABERTOS','Registra os valores referentes à reabertura de créditos extraordinários cujo ato de autorização foi promulgado nos últimos quatro meses do exercício anterior.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.03.03.00.00.00','CRÉDITOS EXTRAORDINÁRIOS REABERTOS - SUPLEMENTAÇÃO','Registra os valores referentes à suplementação de créditos extraordinários reabertos nos termos do § 2º do art. 168 da C.F./88.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.00.00.00.00.00','DOTAÇÃO ADICIONAL POR FONTE','Compreende o somatório dos valores da dotação adicional por fonte de recursos para abertura do credito adicional.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.00.00.00.00','CREDITO SUPLEMENTAR','REGISTRA O SOMATÓRIO DA  MOVIMENTACAO DOS CREDITOS SUPLEMENTARES, DESTINADOS A REFORCO DE DOTACAO ORCAMENTARIA JA EXISTENTE NO ORCAMENTO EM VIGOR, PARA  A REALIZACAO DE DESPESAS,  AUTORIZADA POR LEI E ABERTA POR DECRETOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.01.00.00.00','SUPERAVIT FINANCEIRO DE EXERCICIO ANTERIOR','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA SUPERAVIT FINANCEIRO APURADO NO BALANCO PATRIMONIAL DO EXERCICIO ANTERIOR.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.02.00.00.00','EXCESSO DE ARRECADACAO.','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.02.01.00.00','EXCESSO DE ARRECADACAO PROPRIAMENTE DITA','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO DE VALORES RECEBIDOS A MAIOR QUE O PREVISTO NO ORÇAMENTO ORIGINAL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.02.02.00.00','DOACOES','REGISTRA OS VALORES PERTINENTES AOS CREDITOS SUPLEMENTARES ABERTOS  NO EXERCICIO, PROVENIENTES DE  DOACOES RECEBIDAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.02.03.00.00','AUXILIOS E CONVENIOS','RECURSO OFERECIDO PARA ABERTURA DE CRÉDITOS SUPLEMENTARES ADICIONAIS PROVENIENTE DO RECEBIMENTO DE AUXÍLIOS E CONVÊNIOS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.03.00.00.00','OPERACOES DE CREDITO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA OPERACOES DE CREDITO AUTORIZADAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.04.00.00.00','ANULACAO DE DOTACAO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA A ANULACAO PARCIAL OU TOTAL DE DOTACOES ORCAMENTARIAS OU CREDITOS ADICIONAIS, AUTORIZADOS EM LEI.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.00.00.00.00','CREDITO ESPECIAL','REGISTRA O SOMATÓRIO DA  MOVIMENTACAO DOS CREDITOS ESPECIAIS, DESTINADOS A NOVAS DOTACÕES ORCAMENTARIAS NÇAO EXISTENTES NO ORCAMENTO EM VIGOR, PARA  A REALIZACAO DE DESPESAS,  AUTORIZADA POR LEI E ABERTA POR DECRETOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.01.00.00.00','SUPERAVIT FINANCEIRO DE EXERCICIO ANTERIOR','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA SUPERAVIT FINANCEIRO APURADO NO BALANCO PATRIMONIAL DO EXERCICIO ANTERIOR.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.02.00.00.00','EXCESSO DE ARRECADACAO.','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.02.01.00.00','EXCESSO DE ARRECADACAO PROPRIAMENTE DITA','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO DE VALORES RECEBIDOS A MAIOR QUE O PREVISTO NO ORÇAMENTO ORIGINAL.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.02.02.00.00','DOACOES','REGISTRA OS VALORES PERTINENTES AOS CREDITOS SUPLEMENTARES ABERTOS  NO EXERCICIO, PROVENIENTES DE  DOACOES RECEBIDAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.02.03.00.00','AUXILIOS E CONVENIOS','RECURSO OFERECIDO PARA ABERTURA DE CRÉDITOS SUPLEMENTARES ADICIONAIS PROVENIENTE DO RECEBIMENTO DE AUXÍLIOS E CONVÊNIOS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.03.00.00.00','OPERACOES DE CREDITO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA OPERACOES DE CREDITO AUTORIZADAS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.04.00.00.00','ANULACAO DE DOTACAO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA A ANULACAO PARCIAL OU TOTAL DE DOTACOES ORCAMENTARIAS OU CREDITOS ADICIONAIS, AUTORIZADOS EM LEI.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.09.00.00.00.00','(-) CANCELAMENTO DE DOTACOES','REGISTRA O CANCELAMENTO / REMANEJAMENTO DE DOTACOES PARA ABERTURA DE CREDITOS ADICIONAIS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.99.00.00.00.00','VALOR GLOBAL DA DOTACAO ADICIONAL POR FONTE','REGISTRA O VALOR DA CONTRAPARTIDA DOS LANCAMENTOS DAS DOTACOES ADICIONAIS POR ORIGEM DE CREDITO.','X','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.00.00.00.00.00','CANCELAMENTO/REMANEJAMENTO DE DOTAÇÃO','Compreende o somatório dos valores relativos aos créditos inicial, suplementar, especial e extraordinário cancelados ou remanejados, em casos regularmente previstos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.01.00.00.00.00','ALTERACAO DO QUADRO DE DETALHAMENTO DA DESPESA','REGISTRA  A MOVIMENTACAO DOS CREDITOS POR ACRESCIMO OU REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.01.01.00.00.00','ACRESCIMO','REGISTRA  A MOVIMENTACAO DOS CREDITOS POR ACRESCIMO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.01.09.00.00.00','(-) REDUCAO','REGISTRA  A MOVIMENTACAO DOS CREDITOS POR REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.02.00.00.00.00','ALTERACAO DA LEI ORCAMENTARIA','REGISTRA OS VALORES DOS CREDITOS ORCAMENTARIOS INDISPONIVEIS PARA EXECUCAO DA DESPESA, POR MEDIDA DE VETO, CONTINGENCIAMENTO OU  CONTENCAO, E POSTERIORMENTE CANCELADAS, NOS CASOS REGULARMENTE PREVISTOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.02.01.00.00.00','ACRESCIMO','REGISTRA OS VALORES DOS ACRESCIMOS  RESULTANTES DE ALTERACOES  DA LEI ORCAMENTARIA EM VIRTUDE DE REMANEJAMENTO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.02.09.00.00.00','(-) REDUCAO','REGISTRA O VALOR DA REDUCAO DA DOTACAO DEVIDO A ALTERACAO DA LEI  ORCAMENTARIA EM VIRTUDE DE REMANEJAMENTO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.04.00.00.00.00','(-) CANCELAMENTO DE DOTACOES','REGISTRA O VALOR DA REDUCAO DA DOTACAO DEVIDO A ALTERACAO DA LEI  ORCAMENTARIA EM VIRTUDE DE CANCELAMENTO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.0.00.00.00.00.00','MOVIMENTAÇÃO DE CRÉDITOS RECEBIDOS','Compreende o somatório dos valores dos recebimentos de créditos orçamentários através de destaque, provisão ou por fusão, cisão ou extinção de unidades.','','N','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.1.00.00.00.00.00','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO','Compreende os valores dos créditos descentralizados das unidades orçamentárias para as unidades administrativas sob sua jurisdição ou entre estas, no âmbito do próprio ministério, secretaria ou órgão equivalente, recebidos ao longo do exercício.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.1.01.00.00.00.00','PROVISAO RECEBIDA','REGISTRA A PARCELA DE CREDITO RECEBIDA POR UMA UNIDADE  ADMINISTRATIVA OU ORCAMENTARIA, DECORRENTE DA DESCENTRALIZACAO DO  CREDITO ORCAMENTARIO OU ADICIONAL, DENTRO DO PROPRIO ORGAO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.00.00.00.00.00','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','Compreende a descentralização do credito inicial ou adicional recebido de unidades ou órgãos pertencentes a ministérios, secretarias e órgãos equivalentes distintos ou entre estes e entidades da administração indireta.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.01.00.00.00.00','ADMINISTRACAO DIRETA','COMPREENDE O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES  DE RECEBIMENTO OU DE TRANSFERENCIA DE OUTROS ORGAOS E ENTIDADES  DE   IGUAL OU DE DIFERENTE UNIDADE ORCAMENTARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.01.01.00.00.00','CREDITOS RECEBIDOS','REGISTRA O VALOR DOS CREDITOS RECEBIDOS PELA ADMINISTRACAO DIRETA   DE OUTROS ORGAOS E ENTIDADES.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.01.09.00.00.00','(-) CREDITOS TRANSFERIDOS','REGISTRA A MOVIMENTACAO DE CREDITOS DE ENTIDADES DA ADMINISTRACAO INDIRETA OU ENTRE ORGAOS DA ADMINISTRACAO DIRETA DE UNIDADE ORCAMENTARIA DIFERENTE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.02.00.00.00.00','ADMINISTRACAO INDIRETA','COMPREENDE O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES   DE RECEBIMENTO OU DE TRANSFERENCIA DE OUTROS ORGAOS E ENTIDADES DE   IGUAL OU DE DIFERENTE UNIDADE ORCAMENTARIA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.02.01.00.00.00','CREDITOS RECEBIDOS','REGISTRA O VALOR DOS CREDITOS RECEBIDOS PELA ADMINISTRACAO INDIRETA DE MESMA OU DE DIFERENTE UNIDADE ORCAMENTARIA DO ORGAO EMITENTE.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.02.09.00.00.00','(-) CREDITOS TRANSFERIDOS','REGISTRA A MOVIMENTACAO DE CREDITOS DE ORGAOS DA ADMINISTRACAO DIRETA OU ENTRE ENTIDADES DA ADMINISTRACAO INDIRETA DE MESMA OU DE   DIFERENTE UNIDADE ORCAMENTARIA, NAO FORMALIZADA A TERMO DE CONTRATO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.9.00.00.00.00.00','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','Compreende as movimentações de créditos recebidos por cisão, fusão, extinção, compensação e outras transações.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.3.0.00.00.00.00.00','DETALHAMENTO DE CREDITO','Compreende o somatório relativos às dotações detalhadas relativas a cada ação orçamentária (projeto, atividade ou operações especiais).','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.0.00.00.00.00.00','OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA','Compreende o somatório dos valores das despesas pré-empenhadas e empenhadas por detalhamento específico.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.00.00.00.00.00','EMPENHOS POR EMISSAO','COMPREENDE O SOMATORIO DOS VALORES EMPENHADOS POR DETALHAMENTO ESPECIFICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.01.00.00.00.00','EMPENHOS POR NOTA DE EMPENHO','COMPREENDE O CONTROLE DOS EMPENHOS EMITIDOS, REFORCADOS E TRANSFERIDOS, QUE ENVOLVAM DESPESAS ORCAMENTARIAS REALIZADAS PELA ADMINISTRACAO PUBLICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.01.01.00.00.00','EMISSAO DE EMPENHOS','REGISTRA O VALOR DA EMISSAO DE EMPENHO DA DESPESA, INCLUSIVE AQUELAS QUE FORAM OBJETO DE PRE-EMPENHO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.01.04.00.00.00','ANULACAO DE EMPENHOS','REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA ORCAMENTARIA  A DOTACAO CORRESPONDENTE.','D','S',0,'');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.01.05.00.00.00','CANCELAMENTO DE EMPENHO POR FALTA DE DISPONIBILIDADE DE CAIXA','REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA ORCAMENTARIA A DOTACAO CORRESPONDENTE POR FALTA DE DISPONIBILIDADE DE CAIXA.','D','S',0,'');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.04.00.00.00.00','EMPENHOS POR MODALIDADE DE LICITACAO','COMPREENDE O SOMATORIO DOS VALORES DA EMISSAO DE EMPENHOS DE DESPESAS COM LICITACOES PARA OBRAS, SERVICOS, FORNECIMENTOS OU ALIENACOES, BEM COMO SUAS DISPENSAS E INEXIGIBILIDADES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.04.01.00.00.00','CONCURSO','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO CONCURSO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.04.02.00.00.00','CONVITE','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO CONVITE.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.04.03.00.00.00','TOMADA DE PRECOS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO TOMADA DE PRECOS.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.04.04.00.00.00','CONCORRENCIA','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO CONCORRENCIA.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.04.06.00.00.00','DISPENSA DE LICITAÇAO','REGISTRA O VALOR DO EMPENHOS EMITIDOS POR DISPENSA DE LICITACAO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.04.07.00.00.00','LICITACAO INEXIGIVEL','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PELA REALIZACAO DE DESPESAS  EM QUE E INEXIGIVEL A LICITACAO QUANDO HOUVER INVIABILIDADE DE  COMPETICAO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.04.08.00.00.00','NAO APLICAVEL','COMPREENDE O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS  EM QUE NAO SE APLICA A LICITACAO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.04.09.00.00.00','SUPRIMENTO DE FUNDOS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS RELATIVOS A SUPRIMENTOS DE FUNDOS PARA ATENDER DESPESAS EVENTUAIS, INCLUSIVE EM VIAGENS E COM SERVICOS ESPECIAIS, DESPESA DE CARATER SIGILOSO OU PARA ATENDER DESPESAS  DE  PEQUENO VULTO, DE ACORDO COM A LEGISLACAO VIGENTE.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.04.12.00.00.00','PREGAO','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE  PREGAO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.09.00.00.00.00','EMPENHOS POR CREDOR','COMPREENDE O SOMATARIO DOS VALORES DOS EMPENHOS EMITIDOS CONTROLADOS POR   BENEFICIARIOS DO EMPENHO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.09.01.00.00.00','VALORES COMPROMETIDOS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS CONTROLADOS POR BENEFICIARIO DO EMPENHO.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.0.0.0.00.00.00.00.00','INSCRIÇÃO DE RESTOS A PAGAR','Compreende o somatório relativo ao valor da inscrição das despesas empenhadas e não pagas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.0.0.00.00.00.00.00','INSCRIÇÃO DE RP NÃO PROCESSADOS','Compreende o somatório dos valores inscritos em restos a pagar não-processados relativos às despesas empenhadas e não liquidadas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.1.0.00.00.00.00.00','RP NÃO PROCESSADOS INSCRITOS','Registra os valores inscritos em restos a pagar não-processados relativos às despesas empenhadas e não liquidadas até o ultimo dia do exercício financeiro.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.2.0.00.00.00.00.00','RP NÃO PROCESSADOS - EXERCÍCIOS ANTERIORES','Registra o valor de restos a pagar não processados relativo a exercícios anteriores que não foram cancelados porque tiveram seu prazo de validade prorrogado.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.3.0.00.00.00.00.00','RP NÃO PROCESSADOS RESTABELECIDOS','Registra o valor por restabelecimento de empenho de restos a pagar já cancelados em exercícios anteriores com base em ato normativo específico.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.6.0.00.00.00.00.00','RP NÃO PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','Registra o valor da transferência de restos a pagar não processados decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.7.0.00.00.00.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 531100000.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.0.0.00.00.00.00.00','INSCRIÇÃO DE RP PROCESSADOS','Compreende o somatório dos valores inscritos em restos a pagar processados.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.1.0.00.00.00.00.00','RP PROCESSADOS - INSCRITOS','Registra o somatório dos valores inscritos em restos a pagar processados relativos às despesas empenhadas, liquidadas e não pagas no exercício financeiro em que foi empenhado.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.2.0.00.00.00.00.00','RP PROCESSADOS - EXERCÍCIOS ANTERIORES','Registra os valores de restos a pagar processados relativos às despesas empenhadas, liquidadas e não pagas no exercício financeiro subseqüente.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.6.0.00.00.00.00.00','RP PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','Registra o valor da transferência de restos a pagar processados decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.7.0.00.00.00.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 532100000.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.0.0.0.0.00.00.00.00.00','CONTROLES DA EXECUÇÃO DO PLANEJAMENTO E ORÇAMENTO','Compreende as contas com função de registra os atos e fatos ligados a execução orçamentária.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.0.0.0.00.00.00.00.00','EXECUÇÃO DO PLANEJAMENTO','Compreende o somatório dos valores monetários relativos à execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei orçamentária anual.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.1.0.0.00.00.00.00.00','EXECUÇÃO DO PPA','Compreende o somatório dos valores monetários relativos à execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.1.1.0.00.00.00.00.00','PPA A ALOCAR NO PLOA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL DURANTE O SEU PERIODO DE VIGENCIA DETALHADO POR PROGRAMAS DE TRABALHO A SEREM SELECIONADOS NA ELABORACAO DO PLOA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.1.2.0.00.00.00.00.00','PPA ALOCADO NA LOA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL APROVADO, DETALHADO POR PROGRAMA DE TRABALHO ALOCADO NA LOA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.1.3.0.00.00.00.00.00','PPA EXECUTADO','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL EXECUTADO NO SEU PERIODO DE VIGENCIA, DETALHADO POR PROGRAMA DE TRABALHO AUTORIZADO NAS LEIS ORCAMENTARIAS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.2.0.0.00.00.00.00.00','EXECUÇÃO DO PLOA','Compreende o somatório dos valores monetários de receitas e despesas previstos no projeto de lei orçamentária durante as suas fases de tramitação.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.2.1.0.00.00.00.00.00','PROCESSAMENTO DO PLOA -RECEITA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS DAS RECEITAS PREVISTAS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITACAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.2.2.0.00.00.00.00.00','PROCESSAMENTO DO PLOA -DESPESA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS FIXADOS PARA AS DESPESAS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITACAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.0.0.0.00.00.00.00.00','EXECUÇÃO DO ORÇAMENTO','Compreende o somatório dos valores relativos à realização da receita, execução da despesa e suas alterações no orçamento geral da União durante o exercício financeiro.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.0.0.00.00.00.00.00','EXECUÇÃO DA RECEITA','Compreende o somatório dos valores relativos à realização da receita pública aprovada pela lei orçamentária anual e suas alterações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.1.0.00.00.00.00.00','RECEITA A REALIZAR','Registra o somatório dos valores relativos à receita pública aprovada pela lei orçamentária anual e suas alterações, detalhada por natureza da receita.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.2.0.00.00.00.00.00','RECEITA REALIZADA','Registra o somatório dos valores relativos às receitas realizadas, detalhada por natureza de receita.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.3.0.00.00.00.00.00','(-) DEDUÇÕES DA RECEITA ORÇAMENTÁRIA','Registra o somatório dos valores relativos às deduções de receitas realizadas (devoluções, restituições, e outras), detalhada por natureza de receita.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.0.0.00.00.00.00.00','EXECUÇÃO DA DESPESA','Compreende o somatório da disponibilidade de credito orçamentário e da execução da despesa em suas diversas etapas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.0.00.00.00.00.00','DISPONIBILIDADES DE CREDITO','Compreende o somatório da disponibilidade de credito orçamentário e suas alterações.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.1.00.00.00.00.00','CREDITO DISPONÍVEL','Registra o valor da disponibilidade de credito referente à dotação inicial e adicional aprovada no orçamento geral da União na loa ou lei especifica ou antecipada pela lei de diretrizes orçamentárias - LDO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.2.00.00.00.00.00','CREDITO INDISPONÍVEL','Compreende o valor da indisponibilidade de credito orçamentário pelo seu contingenciamento ou liberação pendentes de autorização legislativa.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.2.01.00.00.00.00','BLOQUEIO DE CREDITO','COMPREENDE O VALOR DA DISPONIBILIDADE DE CREDITOS ORCAMENTARIOS   POR CONTENCAO OU CONTINGENCIAMENTO PELA SETORIAL ORCAMENTARIA, SOF E OUTROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.2.01.01.00.00.00','CREDITO BLOQUEADO PARA REMANEJAMENTO','REGISTRA O VALOR DA INDISPONIBILIDADE DE CREDITOS ORCAMENTARIOS PELA SETORIAIS DE ORCAMENTO PARA REMANEJAMENTO DE FONTE OU GRUPO DE DESPESA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.2.01.02.00.00.00','CREDITO BLOQUEADO PARA CONTROLE INTERNO','REGISTRA OS VALORES DE CREDITOS INDISPONIBILIZADOS INTERNAMENTE  PELOS ORGAOS PARA CONTROLE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.2.99.00.00.00.00','OUTRAS INDISPONIBILIDADES','REGISTRA O VALOR DAS INDISPONIBILIDADES DE CREDITOS ORCAMENTARIOS DE NATUREZA EVENTUAL, PARA AS QUAIS NAO HA CONTAS ESPECIFICAS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.00.00.00.00.00','CREDITO UTILIZADO','Compreende o somatório dos valores referentes aos créditos orçamentários empenhados.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.01.00.00.00.00','CREDITO EMPENHADO A LIQUIDAR','Registra o valor da despesa empenhada a ser liquidada','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.02.00.00.00.00','CREDITO EMPENHADO EM LIQUIDAÇÃO','Registra o valor da despesa cujo fato gerador já ocorreu, mas que ainda não foram conferidos o objeto, e o valor, ou seja, não houve a liquidação.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.03.00.00.00.00','CREDITO EMPENHADO LIQUIDADO A PAGAR','Registra o valor da apropriação das despesas empenhadas com posterior verificação de sua regularidade por constituição do direto do credor.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.04.00.00.00.00','CREDITO EMPENHADO LIQUIDADO PAGO','Demonstra o valor da despesa empenhada liquidada paga.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.05.00.00.00.00','EMPENHOS A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NÃO PROCESSADOS','Registra o montante dos valores a liquidar inscritos em restos a pagar nao processados.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.06.00.00.00.00','EMPENHOS EM LIQUIDACAO INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS','Registra o montante dos valores em liquidação inscritos em restos a pagar nao processados.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.07.00.00.00.00','EMPENHOS LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS','Registra o montante dos valores liquidados inscritos em restos a pagar processados.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.99.00.00.00.00','(-) OUTROS CRÉDITOS UTILIZADOS','Registra a contrapartida de despesas realizadas pelas entidades ou órgão da administração direta/indireta que utilizam o SIAFI no modulo parcial.   Registra a contrapartida de despesas liquidadas na rotina de suprimento de fundos para evitar a emissão de lista de item (li) para reclassificação da despesa.','D','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.0.00.00.00.00.00','MOVIMENTAÇÃO DE CRÉDITOS CONCEDIDOS','Compreende o somatório dos valores dos créditos orçamentários concedidos através de destaque, provisão ou por fusão, cisão ou extinção de unidades.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.1.00.00.00.00.00','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO','Compreende os valores dos créditos descentralizados das unidades orçamentárias para as unidades administrativas sob sua jurisdição ou entre estas, no âmbito do próprio ministério, secretaria ou órgão equivalente, concedidos ao longo do exercício.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.1.01.00.00.00.00','PROVISAO CONCEDIDA','REGISTRA O CREDITO CONCEDIDO PELA UNIDADE ORCAMENTARIA A PARTIR DE SUA PROPRIA DOTACAO OU DE UM DESTAQUE A SEU FAVOR, PARA UNIDADE ADMINISTRATIVA OU ORCAMENTARIA, NO AMBITO DO PROPRIO MINISTERIO OU ORGAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.00.00.00.00.00','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','Compreende a descentralização do credito inicial ou adicional concedido de unidades ou órgãos pertencentes a ministérios, secretarias e órgãos equivalentes distintos ou entre estes e entidades da administração indireta.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.01.00.00.00.00','ADMINISTRACAO DIRETA','REGISTRA O VALOR REFERENTE AO MOVIMENTO DE CREDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO DIRETA TRANSFERIDORA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.01.01.00.00.00','CREDITOS CONCEDIDOS','REGISTRA O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES   DE CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO DIRETA  TRANSFERIDORA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.02.00.00.00.00','ADMINISTRACAO INDIRETA','REGISTRA O VALOR REFERENTE AO MOVIMENTO DE CREDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DA ENTIDADE DA ADMINISTRACAO INDIRETA TRANSFERIDORA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.02.01.00.00.00','CREDITOS CONCEDIDOS','REGISTRA O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES   DE SUA CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO  INDIRETA TRANSFERIDORA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.9.00.00.00.00.00','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','Compreende as movimentações de créditos concedidos por cisão, fusão, extinção, compensação e outras transações.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.3.0.00.00.00.00.00','DETALHAMENTO DE CREDITO','Registra o detalhamento das dotações orçamentárias relativas a cada programa de trabalho.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.0.00.00.00.00.00','OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA','Compreende o somatório dos valores executados das despesas pré-empenhadas e empenhadas por detalhamento específico.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.00.00.00.00.00','EMISSAO DE EMPENHO','COMPREENDE O SOMATORIO DOS VALORES EXECUTADOS DAS DESPESAS EMPENHADAS POR DETALHAMENTO ESPECIFICO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.00.00.00.00','EMPENHOS POR NOTA DE EMPENHO','COMPREENDE O VALOR DA EMISSAO DE DOCUMENTOS ATRAVES DOS QUAIS SAO REGISTRADOS OS ESTAGIOS DAS DESPESAS ORCAMENTARIAS REALIZADAS PELA ADMINISTRACAO PUBLICA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.01.00.00.00','EMPENHOS A LIQUIDAR','REGISTRA O VALOR DOS EMPENHOS DE DESPESAS PENDENTES DE  LIQUIDACAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.02.00.00.00','EMPENHOS EM LIQUIDACAO','REGISTRA O SOMATORIO DAS DESPESAS  CUJO FATO GERADOR TENHA OCORRIDO, TENDO INICIADO E NAO CONCLUIDO O PROCESSO DE LIQUIDACAO DA DESPESA ORCAMENTARIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.03.00.00.00','EMPENHOS LIQUIDADOS A PAGAR','REGISTRA O VALOR DOS EMPENHOS APOS VERIFICACAO DO DIREITO ADQUIRIDO PELO CREDOR OU ENTIDADE BENEFICIARIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.04.00.00.00','EMPENHOS PAGOS','REGISTRA O MONTANTE DOS VALORES PAGOS, CONTROLADOS POR NOTA DE EMPENHO E SUBITEM.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.05.00.00.00','EMPENHOS A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS','REGISTRA O MONTANTE DOS VALORES A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS, CONTROLADOS POR NOTA DE EMPENHO E SUBITEM.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.06.00.00.00','EMPENHOS EM LIQUIDACAO INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS','REGISTRA O MONTANTE DOS VALORES EM LIQUIDACAO INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS, CONTROLADOS POR NOTA DE EMPENHO E SUBITEM.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.07.00.00.00','EMPENHOS LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS','REGISTRA O MONTANTE DOS VALORES LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS, CONTROLADOS POR NOTA DE EMPENHO E SUBITEM.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.10.00.00.00','ANULACAO DE EMPENHOS','REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA ORCAMENTARIA  A DOTACAO CORRESPONDENTE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.11.00.00.00','CANCEL. DE EMPENHO POR FALTA DE DISPON. CAIXA','REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA  ORCAMENTARIA A DOTACAO CORRESPONDENTE POR FALTA DE DISPONIBILIDADE DE CAIXA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.00.00.00.00','EMPENHOS POR MODALIDADE DE LICITACAO - A LIQUIDAR','COMPREENDE O VALOR DOS EMPENHOS A LIQUIDAR, COM CONTROLE POR MODALIDADE DE LICITACAO OU POR SUA DISPENSA OU INEXIGIBILIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.01.00.00.00','CONCURSO','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCURSO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.02.00.00.00','CONVITE','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO-CONVITE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.03.00.00.00','TOMADA DE PRECOS','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO - TOMADA DE PRECOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.04.00.00.00','CONCORRENCIA','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO - CONCORRENCIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.06.00.00.00','DISPENSA DE LICITAÇAO','REGISTRA O VALOR DO EMPENHOS A LIQUIDAR POR DISPENSA DE LICITACAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.07.00.00.00','LICITACAO INEXIGIVEL','REGISTRA O VALOR DO EMPENHOS A LIQUIDAR, CONTROLADOS POR INEXIGIBILIDADE DE LICITACAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.08.00.00.00','NAO APLICAVEL','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, ONDE NAO SE APLICA A LICITACAO, DENTRE OS QUAIS CABE DESTACAR: PESSOAL E ENCARGOS SOCIAIS, TRANSFERENCIAS CONSTITUCIONAIS, TRANSFERENCIAS VOLUNTARIAS, AMORTIZACAO DA DIVIDA E RESSARCIMENTO E RESTITUICOES.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.09.00.00.00','SUPRIMENTOS DE FUNDOS','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR DESTINADOS A ATENDER SUPRIMENTOS DE FUNDOS, NA FORMA DA LEGISLACAO EM VIGOR.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.11.00.00.00','CONSULTA','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS NA MODALIDADE DE CONSULTA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.04.12.00.00.00','PREGAO','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS NA MODALIDADE DE PREGAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.05.00.00.00.00','EMPENHOS POR MODALIDADE DE LICITACAO - EM LIQUIDAÇÃO','COMPREENDE O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, COM CONTROLE POR MODALIDADE DE LICITACAO OU POR SUA DISPENSA OU INEXIGIBILIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.05.01.00.00.00','CONCURSO','REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCURSO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.05.02.00.00.00','CONVITE','REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, CONTROLADOS POR MODALIDADE DE LICITACAO-CONVITE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.05.03.00.00.00','TOMADA DE PRECOS','REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, CONTROLADOS POR MODALIDADE DE LICITACAO - TOMADA DE PRECOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.05.04.00.00.00','CONCORRENCIA','REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, CONTROLADOS POR MODALIDADE DE LICITACAO - CONCORRENCIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.05.06.00.00.00','DISPENSA DE LICITAÇAO','REGISTRA O VALOR DO EMPENHOS EM LIQUIDAÇÃO POR DISPENSA DE LICITACAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.05.07.00.00.00','LICITACAO INEXIGIVEL','REGISTRA O VALOR DO EMPENHOS EM LIQUIDAÇÃO, CONTROLADOS POR INEXIGIBILIDADE DE LICITACAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.05.08.00.00.00','NAO APLICAVEL','REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, ONDE NAO SE APLICA A LICITACAO, DENTRE OS QUAIS CABE DESTACAR: PESSOAL E ENCARGOS SOCIAIS, TRANSFERENCIAS CONSTITUCIONAIS, TRANSFERENCIAS VOLUNTARIAS, AMORTIZACAO DA DIVIDA E RESSARCIMENTO E RESTITUICOES.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.05.09.00.00.00','SUPRIMENTOS DE FUNDOS','REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO DESTINADOS A ATENDER SUPRIMENTOS DE FUNDOS, NA FORMA DA LEGISLACAO EM VIGOR.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.05.11.00.00.00','CONSULTA','REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, CONTROLADOS NA MODALIDADE DE CONSULTA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.05.12.00.00.00','PREGAO','REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, CONTROLADOS NA MODALIDADE DE PREGAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.00.00.00.00','EMPENHOS POR MODALIDADE DE LICITACAO - LIQUIDADO','COMPREENDE O VALOR DOS EMPENHOS LIQUIDADOS, COM CONTROLE POR MODALIDADE DE LICITACAO OU POR SUA DISPENSA OU INEXIGIBILIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.01.00.00.00','CONCURSO','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCURSO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.02.00.00.00','CONVITE','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONVITE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.03.00.00.00','TOMADA DE PRECOS','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-TOMADA DE PRECOS .','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.04.00.00.00','CONCORRENCIA','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCORRENCIA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.06.00.00.00','DISPENSA DE LICITAÇAO','REGISTRA O VALOR DO EMPENHOS LIQUIDADOS POR DISPENSA DE LICITACAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.07.00.00.00','LICITACAO INEXIGIVEL','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR INEXIGIBILIDADE DE LICITACAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.08.00.00.00','NAO APLICAVEL','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, ONDE NAO SE APLICA A LICITACAO, DENTRE OS QUAIS CABE DESTACAR: PESSOAL E ENCARGOS SOCIAIS, TRANSFERENCIAS CONSTITUCIONAIS, TRANSFERENCIAS VOLUNTARIAS, AMORTIZACAO DA DIVIDA E RESSARCIMENTO E RESTITUICOES.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.09.00.00.00','SUPRIMENTOS DE FUNDOS','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS DESTINADOS A ATENDER SUPRIMENTOS DE FUNDOS, NA FORMA DA LEGISLACAO EM VIGOR.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.11.00.00.00','CONSULTA','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONSULTA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.06.12.00.00.00','PREGAO','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-PREGAO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.00.00.00.00','EMPENHOS DE RESTOS A PAGAR - POR CREDOR','REGISTRA O VALOR DOS EMPENHOS DE RESTOS A PAGAR, CONTROLADOS POR BENEFICIARIOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.01.00.00.00','RESTOS A PAGAR A LIQUIDAR','REGISTRA O VALOR DOS EMPENHOS DE RESTOS A PAGAR INSCRITOS NO  ENCERRAMENTO DO EXERCICIO FINANCEIRO DE EMISSAO DA NOTA DE EMPENHO E TRANSFERIDOS AUTOMATICAMENTE DA CONTA 292410505.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.02.00.00.00','RESTOS A PAGAR LIQUIDADOS - NO EXERCICIO CORRENTE','REGISTRA O VALOR DOS RESTOS A PAGAR, CONTROLADOS POR  BENEFICIARIO LIQUIDADOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.03.00.00.00','RESTOS A PAGAR PAGOS - CONTROLE POR CNPJ','REGISTRA O VALOR DOS RESTOS A PAGAR PAGOS, CONTROLADOS POR  BENEFICIARIO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.04.00.00.00','INSCRICAO DE RESTOS A PAGAR','REGISTRA O VALOR DOS EMPENHOS DE RESTOS A PAGAR INSCRITOS NO  ENCERRAMENTO DO EXERCICIO FINANCEIRO DE EMISSAO DA NOTA DE EMPENHO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.05.00.00.00','RESTOS A PAGAR LIQUIDADOS - NO EXERCICIO  ANTERIOR','REGISTRAR O VALOR DOS RESTOS A PAGAR LIQUIDADOS (A PAGAR) CONTROLADOS POR NÚMERO DE EMPENHO. O SALDO DESTA CONTA É ORIGINADO DA LEITURA DO SALDO EXISTENTE NA CONTA 2.9.2.4.1.04.02, SENDO TRANSPORTADO NO EXERCÍCIO POSTERIOR PARA A CONTA 2.9.2.3.1.05.08. SE','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.06.00.00.00','CANCELAMENTO DE RESTOS A PAGAR  NAO PROCESSADOS','REGISTRA OS VALORES DOS RESTOS A PAGAR CANCELADOS PELA UNIDADE  GESTORA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.07.00.00.00','RESTOS A PAGAR PROCESSADOS PAGOS - CONTROLE POR NE','REGISTRA O VALOR DOS RESTOS A PAGAR PAGOS, CONTROLADOS POR  NUMERO  DE EMPENHO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.08.00.00.00','CANCELAMENTO DE RESTOS A PAGAR PROCESSADOS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS CANCELADOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.07.99.00.00.00','OUTRAS INSCRICOES DE RESTOS A PAGAR','REGISTRA A CONTRAPARTIDA DOS LANCAMENTOS EFETUADOS EM EMPENHOS DE RESTOS A PAGAR CONTROLADOS POR BENEFICIARIO, POR OCASIAO DO ENCERRAMENTO DO EXERCICIO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.09.00.00.00.00','EMPENHOS POR CREDOR','COMPREENDE O SOMATORIO DA EXECUCAO DE CREDITOS ORCAMENTARIOS, CONTROLADOS POR BENEFICIARIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.09.01.00.00.00','VALORES A LIQUIDAR','REGISTRA O MONTANTE DOS VALORES A LIQUIDAR, A SEREM PAGOS, POR BENEFICIARIOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.09.02.00.00.00','VALORES EM LIQUIDACAO','REGISTRA O SOMATORIO DAS DESPESAS  CUJO FATO GERADOR TENHA OCORRIDO, TENDO INICIADO E NAO CONCLUIDO O PROCESSO DE LIQUIDACAO DA DESPESA ORCAMENTARIA, CONTROLADOS POR BENEFICIARIO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.09.03.00.00.00','VALORES LIQUIDADOS A PAGAR','REGISTRA O MONTANTE DOS VALORES LIQUIDADOS, A SEREM PAGOS, POR BENEFICIARIOS.  O SALDO DESTA CONTA EM 31 DE DEZEMEBRO SERA TRANSFERIDO PARA A CONTA 532110000 - RP PROCESSADO INSCRITO EM 01 DE JANEIRO DO EXERCICIO SUBSEQUENTE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.09.04.00.00.00','VALORES PAGOS','REGISTRA O MONTANTE DOS VALORES PAGOS, CONTROLADOS POR BENEFICIARIOS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.09.05.00.00.00','EMPENHOS INSCRITOS EM RESTOS A PAGAR','REGISTRA O MONTANTE DOS VALORES DOS EMPENHOS INSCRITOS EM RESTOS A PAGAR, CONTROLADOS POR BENEFICIARIO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.0.0.0.00.00.00.00.00','EXECUÇÃO DE RESTOS A PAGAR','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas e não pagas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.0.0.00.00.00.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, não liquidadas no exercício financeiro de sua inscrição e não pagas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.1.0.00.00.00.00.00','RP NÃO PROCESSADOS A LIQUIDAR','Registra o valor dos RP não processados ainda não liquidados.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.2.0.00.00.00.00.00','RP NÃO PROCESSADOS EM LIQUIDAÇÃO','Registra o valor dos RP não processados ainda não liquidados cujo fato gerador já ocorreu.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.3.0.00.00.00.00.00','RP NÃO PROCESSADOS LIQUIDADOS A PAGAR','Registra o valor dos RP não processados, liquidados após sua inscrição e ainda não pagos.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.4.0.00.00.00.00.00','RP NÃO PROCESSADOS PAGOS','Registra o valor dos RP não processados, liquidados após sua inscrição e pagos.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.5.0.00.00.00.00.00','RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS','Registra o valor de restos a pagar não processados a liquidar, bloqueado por decreto.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.6.0.00.00.00.00.00','RP NÃO PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar não processados pela desincorporação de saldos decorrentes de transformação, cisão, fusão e extinção de órgãos ou UG.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.7.0.00.00.00.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 631100000 e 631200000.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.9.0.00.00.00.00.00','RP NÃO PROCESSADOS CANCELADOS','Compreende o cancelamento de restos a pagar não processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.9.1.00.00.00.00.00','POR INSUFICIENCIA DE RECURSOS','REGISTRA O VALOR DOS RESTOS A PAGAR NAO PROCESSADOS  CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO POR INSUFICIENCIA DE RECURSOS FINANCEIROS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.9.9.00.00.00.00.00','OUTROS CANCELAMENTOS DE RP','REGISTRA O VALOR DOS RESTOS A PAGAR NAO PROCESSADOS  CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO, EXCETO OS CANCELADOS POR INSUFICIENCIA DE RECURSOS FINANCEIROS.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.0.0.00.00.00.00.00','EXECUÇÃO DE RP PROCESSADOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, liquidadas no exercício financeiro de sua inscrição e não pagas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.1.0.00.00.00.00.00','RP PROCESSADOS A PAGAR','Registra o valor dos RP processados e não pagos.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.2.0.00.00.00.00.00','RP PROCESSADOS PAGOS','Registra o valor dos RP processados pagos.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.6.0.00.00.00.00.00','RP PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar pela desincorporação de saldos decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.7.0.00.00.00.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 632100000.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.9.0.00.00.00.00.00','RP PROCESSADOS CANCELADOS','Compreende o cancelamento de restos a pagar processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.9.1.00.00.00.00.00','POR VALORES E/OU INSCRICOES INDEVIDAS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS  CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO POR VALORES E/OU INSCRICOES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.9.1.01.00.00.00.00','CANCELAMENTO DE RP PROCESSADOS - NE','REGISTRA O VALOR DE RESTOS A PAGAR PROCESSADOS CANCELADOS NO EXERCICIO SEGUINTE, CONTROLADOS POR NOTA DE EMPENHO, COM A RESPECTIVA BAIXA NO PASSIVO FINANCEIRO.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.9.1.02.00.00.00.00','AJUSTE DE CONTROLE RP DE EXERC ANTERIORES','REGISTRA O VALOR DO AJUSTE DE RESTOS A PAGAR PROCESSADOS CANCELADOS SEM PASSIVO CORRESPONDENTE.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.9.9.00.00.00.00.00','OUTROS CANCELAMENTOS DE RP','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS  CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO, EXCETO OS CANCELADOS POR INSUFICIENCIA DE RECURSOS FINANCEIROS OU POR INSCRICAO INDEVIDA.','C','S','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.0.0.0.0.00.00.00.00.00','CONTROLES DEVEDORES','Compreende as contas em que são registrados atos potenciais e controles específicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.0.0.0.00.00.00.00.00','ATOS POTENCIAIS','Compreende contas relacionadas às situações não compreendidas no patrimônio, mas que, direta ou indiretamente, possam vir à afeta-lo, exclusive as que dizem respeito a atos e fatos ligados a execução orçamentária e financeira e as contas com função precípua de controle.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.0.0.00.00.00.00.00','ATOS POTENCIAIS ATIVOS','Registra os atos e fatos que possam vir a aumentar o ativo da entidade governamental.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.0.00.00.00.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS','Compreende contas relacionadas ao registro de avais, fianças e hipotecas recebidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.00.00.00.00.00','GARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO  FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO PAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.01.00.00.00.00','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.02.00.00.00.00','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA NO PAIS, POR ORGAOS E ENTIDADES,  PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE  NAO CUMPRA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.03.00.00.00.00','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS   NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.04.00.00.00.00','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.05.00.00.00.00','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.06.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.07.00.00.00.00','APOLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS  NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.99.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS   NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.00.00.00.00.00','GARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO  FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.01.00.00.00.00','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.02.00.00.00.00','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE  NAO CUMPRA, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.03.00.00.00.00','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS   NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.04.00.00.00.00','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.05.00.00.00.00','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.06.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.07.00.00.00.00','APOLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS  NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.2.99.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS   NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.3.00.00.00.00.00','CONTRAGARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS  CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.3.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES  DAS  CONCESSOES  DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.3.02.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS  RECEBIDAS TERCEIROS DECORRENTES  DAS  CONCESSOES  DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.3.03.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES  DAS  CONCESSOES  DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.3.99.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS   NOS ITENS ANTERIORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.4.00.00.00.00.00','CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS  CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.4.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS','REGISTRA  O  VALOR  DAS  CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.4.02.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.4.03.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS EM VIRTUDE DE GARANTIAS INSTITUI-DAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.4.99.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS   NOS ITENS ANTERIORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.2.0.00.00.00.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no convenente, dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.2.1.00.00.00.00.00','VALORES FIRMADOS','REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES  FIRMADOS  MANTENDO-O  ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.2.2.00.00.00.00.00','TERMO DE COOPERACAO','COMPREENDE O VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO  FIRMADOS  MANTENDO-O  ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.0.00.00.00.00.00','DIREITOS CONTRATUAIS','Compreende contas relacionadas ao registro dos valores de direitos contratuais, quando a administração pública participa como contratada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.00.00.00.00.00','DE TERCEIROS','COMPREENDE O VALOR DOS DIREITOS E OBRIGACOES CONTRATUAIS EM QUE A  ADMINISTRACAO PUBLICA SEJA SEGNATARIA DO CONTRATO COM TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.01.00.00.00.00','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.02.00.00.00.00','CONTRATOS DE SERVICOS','REGISTRA O VALOR DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.03.00.00.00.00','CONTRATOS DE ALUGUEIS','REGISTRA O VALOR DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.04.00.00.00.00','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS PELA  ADMINISTRACAO PUBLICA A TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.05.00.00.00.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','REGISTRA O VALOR DO CONTRATO DE OBRIGACAO DA ENTEDADE PUBLICA COM TERCEIROS REFEREN-E A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.2.00.00.00.00.00','CONTRATO DE GESTAO','COMPREENDE O VALOR CONSOLIDADO DOS DESDOBRAMENTOS DA REFERIDA CONTA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.2.01.00.00.00.00','CONTRATOS DE GESTAO A LIQUIDAR','REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO  PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.2.02.00.00.00.00','CONTRATOS DE GESTAO LIQUIDADOS','REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.9.0.00.00.00.00.00','OUTROS ATOS POTENCIAIS ATIVOS','Compreende os atos potenciais ativos não contemplados em contas especificas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.9.1.00.00.00.00.00','PLANO DE AMORTIZAÇÃO DO DÉFICIT ATUARIAL','REGISTRAR, A TÍTULO DE CONTROLE, OS VALORES RELATIVOS AO PLANO DE AMORTIZAÇÃO DO DÉFICIT ATUARIAL DO RPPS PELO ENTE PÚBLICO QUE O INSTITUIU.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.9.2.00.00.00.00.00','PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','REGISTRAR, A TÍTULO DE CONTROLE, OS VALORES RELATIVOS ÀS PARCELAS DE DÉBITOS PREVIDENCIÁRIOS DO RPPS DEVIDAS PELO ENTE PÚBLICO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.0.0.00.00.00.00.00','ATOS POTENCIAIS PASSIVOS','Compreende os atos e fatos que possam vir a aumentar o passivo ou diminuir o ativo da entidade governamental.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.0.00.00.00.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','Compreende contas relacionadas ao registro de avais, fianças e hipotecas concedidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.00.00.00.00.00','GARANTIAS CONCEDIDAS NO PAIS','COMPREENDE O VALOR CONCEDIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO  FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO PAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.01.00.00.00.00','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, CONCEDIDA A TERCEIROS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.02.00.00.00.00','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA NO PAIS, POR ORGAOS E ENTIDADES,  PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE  NAO CUMPRA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.03.00.00.00.00','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS  NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.99.00.00.00.00','OUTRAS GARANTIAS CONCEDIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NAO INCLUIDAS   NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.2.00.00.00.00.00','GARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE O VALOR CONCEDIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO  FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.2.01.00.00.00.00','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.2.02.00.00.00.00','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE  NAO CUMPRA, NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.2.03.00.00.00.00','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS   NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.3.00.00.00.00.00','CONTRAGARANTIAS CONCEDIDAS NO PAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS  CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.3.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS DECORRENTES  DAS  CONCESSOES  DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.3.02.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS  CONCEDIDAS TERCEIROS DECORRENTES  DAS  CONCESSOES  DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.3.03.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS DECORRENTES  DAS  CONCESSOES  DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.3.99.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NAO INCLUIDAS   NOS ITENS ANTERIORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.4.00.00.00.00.00','CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS  CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.4.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDAS','REGISTRA  O  VALOR  DAS  CONTRAGARANTIASCONCEDIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.4.02.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.4.03.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS EM VIRTUDE DE GARANTIAS INSTITUI-DAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.4.99.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NAO INCLUIDAS   NOS ITENS ANTERIORES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.2.0.00.00.00.00.00','OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no concedente, do valor dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.0.00.00.00.00.00','OBRIGAÇÕES CONTRATUAIS','Compreende contas relacionadas ao registro dos valores de obrigações contratuais, quando a administração pública participa como contratante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.00.00.00.00.00','COM TERCEIROS','COMPREENDE O VALOR DO CONTRATO ASSINADO ENTRE A UG CONTRATANTE  E PARTICULARES OU OUTRO ORGAO OU ENTIDADE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.01.00.00.00.00','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.02.00.00.00.00','CONTRATOS DE SERVICOS','REGISTRA O VALOR DO CONTRATO ASSINADO ENTRE A ADMINISTRACAO PUBLICA E O  PRESTADOR DE SERVICOS A TITULO DE OBRAS E INSTALACAO E DEMAIS SERVICOS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.03.00.00.00.00','CONTRATOS DE ALUGUEIS','REGISTRA O VALOR DO CONTRATO DE LOCACAO DE BENS MOVEIS E IMOVEIS ENTRE A ADMINISTRACAO E TERCEIROS LOCADORES DE TAIS BENS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.04.00.00.00.00','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS ENTRE A  ADMINISTRACAO E O FORNECEDOR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.05.00.00.00.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','REGISTRA A APROPRIACAO DE AJUSTE OU ASSINATURA DE CONTRATOS DE CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.06.00.00.00.00','CONTRATO DE GESTAO','COMPREENDE AS CONTAS QUE REGISTRAM OS CONTRATOS DE GESTAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.06.01.00.00.00','CONTRATOS DE GESTAO A LIQUIDAR','REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO  PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.06.02.00.00.00','CONTRATOS DE GESTAO LIQUIDADOS','REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.07.00.00.00.00','CONTRATOS DE OPERACOES DE CREDITO','REGISTRA O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO  ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.9.0.00.00.00.00.00','OUTROS ATOS POTENCIAIS PASSIVOS','Compreende os atos potenciais passivos não contemplados em contas especificas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.9.1.00.00.00.00.00','BENEFICIARIOS DE SENTENCAS JUDICIAIS INCLUIDAS NO ORCAMENTO','REGISTRA OS PRECATÓRIOS, RECEBIDOS NO EXERCÍCIO ANTERIOR E INCLUÍDOS NO ORÇAMENTO PARA PAGAMENTO ATÉ O FINAL DO EXERCÍCIO. PODE SE MANTER O CONTROLE  NESTE GRUPO POR BENEFICIÁRIO','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.9.2.00.00.00.00.00','BENEFICIARIOS DE SENTENCAS JUDICIAIS AINDA NAO INCLUIDAS NO ORCAMENTO','REGISTRA OS PRECATÓRIOS, RECEBIDOS NO EXERCÍCIO E QUE SERÃO INCLUÍDOS NO ORÇAMENTO SEGUINTE PARA PAGAMENTO ATÉ O FINAL DAQUELE EXERCÍCIO. PODE SE MANTER O CONTROLE  NESTE GRUPO POR BENEFICIÁRIO','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.0.0.0.00.00.00.00.00','ADMINISTRAÇÃO FINANCEIRA','Compreende as contas de registro da programação financeira e de controle das disponibilidades.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.0.0.00.00.00.00.00','DISPONIBILIDADES POR DESTINAÇÃO','Compreende as contas que registram os controles sobre as disponibilidades por destinação de recursos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.1.0.00.00.00.00.00','CONTROLE DA DISPONIBILIDADE DE RECURSOS','Compreende as contas que registram as disponibilidades de recursos recebidos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.1.1.00.00.00.00.00','DISPONIBILIDADE DE RECURSOS','REGISTRA O TOTAL DE RECURSOS DISPONIBILIZADOS, JA COMPROMETIDOS OU NAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.2.0.00.00.00.00.00','LIMITE DE RESTOS A PAGAR POR DESTINAÇÃO','Compreende as contas que controlam a inscrição do limite de restos a pagar, classificados por destinação de recursos','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.2.1.00.00.00.00.00','INSCRICAO DO LIMITE DE RESTOS A PAGAR CONCEDIDO POR DESTINACAO','REGISTRA AS CONTAS QUE CONTROLAM A INSCRICAO DO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS, NAS UG''S RESPONSAVEIS EM ENVIAR RECURSOS FINANCEIROS DESTINADOS AO PAGAMENTO DE RESTOS A PAGAR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.2.2.00.00.00.00.00','INSCRICAO DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINACAO','REGISTRA AS CONTAS QUE CONTROLAM A INSCRICAO DO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS, NAS UG''S CUJOS RECURSOS FINANCEIROS SAO INSUFICIENTES PARA HONRAREM TODOS OS COMPROMISSOS INSCRITOS EM RESTOS A PAGAR.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.3.0.00.00.00.00.00','RECURSO DIFERIDO POR DESTINAÇÃO','Compreende as contas que controlam a inscrição dos recursos diferidos. Recursos diferidos são as sobras de recursos financeiros ao final do exercício (recurso diferido), que deveriam ser devolvidas a conta única, porem, ao invés disso, essas sobras são liberadas para uso (apenas no exercício seguinte) através de descontos das transferências financeiras (cota, repasse e sub-repasse) do exercício seguinte.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.0.0.00.00.00.00.00','PROGRAMAÇÃO FINANCEIRA','Compreende as contas que registram as cotas, repasses e sub-repasses para atender a despesas orçamentárias, restos a pagar autorizados e demais dispêndios extra orçamentários.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.1.0.00.00.00.00.00','CONCESSAO DE RECURSOS FINANCEIROS','COMPREENDE AS CONTAS QUE REGISTRAM A CONCESSAO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.1.1.00.00.00.00.00','COTAS DECORRENTES DO ORCAMENTO','REGISTRAM O VALOR TOTAL DAS COTAS, CONCEDIDAS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.1.4.00.00.00.00.00','REPASSES DECORRENTES DO ORCAMENTO','REGISTRA O VALOR TOTAL DOS REPASSES, CONCEDIDOS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.1.7.00.00.00.00.00','SUB-REPASSES DECORRENTES DO ORCAMENTO','REGISTRAM O VALOR TOTAL DOS SUB-REPASSES, CONCEDIDOS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.2.0.00.00.00.00.00','RECEBIMENTO DE RECURSOS FINANCEIROS','COMPREENDE AS CONTAS QUE REGISTRAM O RECEBIMENTO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.2.1.00.00.00.00.00','COTAS DECORRENTES DO ORCAMENTO','REGISTRAM O VALOR TOTAL DAS COTAS, RECEBIDAS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.2.4.00.00.00.00.00','REPASSES DECORRENTES DO ORCAMENTO','REGISTRAM O VALOR TOTAL DOS REPASSES, RECEBIDOS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.2.7.00.00.00.00.00','SUB-REPASSES DECORRENTES DO ORCAMENTO','REGISTRA O VALOR TOTAL DOS SUB-REPASSES, RECEBIDOS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.3.0.0.00.00.00.00.00','INSCRIÇÃO DO LIMITE ORÇAMENTÁRIO','Compreende as contas que controlam o limite de empenho e movimentação de créditos orçamentários, conforme estabelecidos em ato próprio dos poderes e ministério público.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.3.1.0.00.00.00.00.00','CONTROLE DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','COMPREENDE AS CONTAS QUE CONTROLAM O LIMITE ORCAMENTARIO NO OCPF','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.4.0.0.00.00.00.00.00','CONTROLES DA ARRECADAÇÃO','Compreende as contas que registram o valor da arrecadação liquida da receita orçamentária, por meio de documentos de arrecadação como DARF, GRU, DAR, entre outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.4.1.0.00.00.00.00.00','CONTROLES DE DOCUMENTOS DE ARRECADAÇÃO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.4.1.1.00.00.00.00.00','CONTROLES DE DOCUMENTOS DE ARRECADAÇÃO POR CODIGO DE RECEITA','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADAÇÃO, CLASSIFICADA POR CODIGO DE RECEITA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.4.1.3.00.00.00.00.00','CONTROLES DE DOCUMENTOS DE ARRECADAÇÃO POR CODIGO DE DESTINACAO VINCULADA','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADAÇÃO, CLASSIFICADA POR CODIGO DE DESTINACAO VINCULADA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.0.0.0.00.00.00.00.00','DIVIDA ATIVA','Registra o controle dos créditos a serem inscritos em divida ativa, dos que se encontram em processamento. Compreende as contas que controlam os créditos passiveis de serem encaminhados e inscritos em divida ativa o de inscrição e a tramitação dos créditos inscritos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.1.0.0.00.00.00.00.00','CONTROLE DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DIVIDA ATIVA','Registra os valores passiveis de serem encaminhados e inscritos em divida ativa.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.1.1.0.00.00.00.00.00','ENCAMINHAMENTO DE CREDITOS','REGISTRA OS VALORES PASSIVEIS DE SEREM ENCAMINHADOS E INSCRITOS EM DIVIDA ATIVA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.2.0.0.00.00.00.00.00','CONTROLE DA INSCRIÇÃO DE CRÉDITOS EM DIVIDA ATIVA','Compreende as contas que controlam os créditos passiveis de serem inscritos em divida ativa pelo órgão responsável pela inscrição em divida ativa.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.2.1.0.00.00.00.00.00','INSCRICAO DE CREDITOS','REGISTRA OS VALORES DOS CREDITOS PASSIVEIS DE SEREM INSCRITOS EM DIVIDA ATIVA PELO ORGAO RESPONSAVEL PELA INSCRICAO EM DIVIDA ATIVA.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.0.0.0.00.00.00.00.00','RISCOS FISCAIS','Compreende as contas que controlam os riscos fiscais que não preencham os requisitos para reconhecimento como passivo, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.1.0.0.00.00.00.00.00','CONTROLE DE PASSIVOS CONTINGENTES','Compreende as contas que registram o controle dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.1.1.0.00.00.00.00.00','PASSIVOS CONTINGENTES','REGISTRA OS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.2.0.0.00.00.00.00.00','CONTROLE DOS DEMAIS RISCOS FISCAIS','Compreende as contas que registram os riscos fiscais que não preencham os requisitos para reconhecimento como passivo, não classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.2.1.0.00.00.00.00.00','DEMAIS RISCOS FISCAIS','REGISTRA OS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.8.0.0.0.00.00.00.00.00','CUSTOS','Compreende as contas que controlam os custos de bens e serviços produzidos.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.0.0.0.00.00.00.00.00','OUTROS CONTROLES','Compreende as contas de controles não especificadas anteriormente nos grupos dessa classe.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.1.0.0.00.00.00.00.00','OUTROS CONTROLES DE PROGRAMACAO FINANCEIRA','COMPREENDE AS CONTAS QUE CONTROLAM OUTRAS PECULIARIDADES DA PROGRAMACAO FINANCEIRA','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.2.0.0.00.00.00.00.00','OUTROS CONTROLES DE DISPONIBILIDADES','COMPREENDE AS CONTAS QUE CONTROLAM OUTROS CONTROLES DE DISPONIBILIDADES','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.3.0.0.00.00.00.00.00','OUTROS CONTROLES DE BENEFICIOS PAGOS','COMPREENDE AS CONTAS QUE REGISTRAM O PAGAMENTO DE BENEFICIOS PREVIDENCIARIOS','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.4.0.0.00.00.00.00.00','OUTROS CONTROLES DA CONTA UNICA','COMPREENDE AS CONTAS QUE CONTROLAM A CONTA UNICA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.4.1.0.00.00.00.00.00','CONCILIACAO DA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO','COMPREENDE AS CONTAS QUE CONTROLAM A CONCILIACAO DA CONTA UNICA','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.4.4.0.00.00.00.00.00','CONTROLE DE APLICACAO FINANCEIRA NA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO','REGISTRA OS VALORES REFERENTE AO CONTROLE DE FONTE DE RECURSOS NA  NA PLICACAO FINANCEIRA','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.6.0.0.00.00.00.00.00','OUTROS CONTROLES DE OPERACOES DE CREDITOS','COMPREENDE AS CONTAS QUE CONTROLAM OPERACOES DE CREDITO','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.0.0.00.00.00.00.00','OUTROS CONTROLES DE RESPONSABILIDADES POR VALORES, TITULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DAS RESPONSABILIDADES POR VALORES, TITULOS E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.1.0.00.00.00.00.00','RESPONSABILIDADES DE TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.1.1.00.00.00.00.00','RESPONSABILIDADES DE TERCEIROS','REGISTRA AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.1.1.01.00.00.00.00','SUPRIMENTO DE FUNDOS','REGISTRA OS VALORES CONCEDIDOS A  SERVIDOR  RESPONSAVEL  PARA  ATENDER DESPESAS QUE NAO POSSAM SUBORDINAR-SE AO PROCESSO NORMAL DE APLICACAO,ATE A SUA PRESTACAO DE CONTAS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.1.1.02.00.00.00.00','OUTRAS RESPONSABILIDADES DE TERCEIROS','REGISTRA O VALOR DE OUTRAS RESPONSABILIDADES DE TERCEIROS, DE NATUREZA EVENTUAL, POR TITULOS, VALORES E BENS, PARA AS QUAIS NAO HA CONTAS ESPECIFICAS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.2.0.00.00.00.00.00','RESPONSABILIDADES COM TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.2.1.00.00.00.00.00','RESPONSABILIDADE COM TERCEIROS','REGISTRA AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.2.1.01.00.00.00.00','RECEBIDOS EM CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.2.1.02.00.00.00.00','DEPOSITOS JUDICIAIS','REGISTRA OS DEPOSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EM CONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOS POR ESTA PARA TERCEIROS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.2.1.03.00.00.00.00','DEPOSITOS COMPULSORIOS','REGISTRA O SOMATÓRIO DOS VALORES DOS DEPÓSITOS COMPULSÓRIOS REALIZADOS.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.2.1.99.00.00.00.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NAO INDIVIDUALIZADAS NAS OUTRAS CONTAS DESSE GRUPO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.7.3.0.00.00.00.00.00','DIVERSOS RESPONSAVEIS EM APURACAO','REGISTRA  AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE  ATOS PRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAR EM PREJUIZOS PARA A FAZENDA MUNICIPAL.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.9.0.0.00.00.00.00.00','DEMAIS CONTROLES','COMPREENDE AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS SUBGRUPOS DESTE GRUPO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.9.8.0.00.00.00.00.00','CONTROLES REFERENTES A CONSÓRCIOS PÚBLICOS','REGISTRA A CONTRAPARTIDA DAS INFORMAÇÕES ENVIADAS PELOS CONSÓRCIOS PÚBLICOS, INSTITUIDOS DE ACORDO COM A LEI FEDERAL Nº 11.107/2005 PARA FINS DE CONSOLIDAÇÃO QUANTO AS INFORMAÇÕES PARA VERIFICAÇÃO DA APLICAÇÃO DOS INDICES MINIMOS E MÁXIMOS TRAZIDOS PELA CF/88 E LRF.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.9.9.0.00.00.00.00.00','DEMAIS CONTROLES','COMPREENDE AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS TITULOS DESTE SUBGRUPO.','D','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.0.0.0.0.00.00.00.00.00','CONTROLES CREDORES','Compreende as contas em que são registradas a execução de atos potenciais e controles específicos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.0.0.0.00.00.00.00.00','EXECUÇÃO DOS ATOS POTENCIAIS','Compreende contas relacionadas à execução de situações não compreendidas no patrimônio, mas que, direta ou indiretamente, possam vir à afeta-lo, exclusive as que dizem respeito a atos e fatos ligados a execução orçamentária e financeira e as contas com função precípua de controle.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.0.0.00.00.00.00.00','EXECUÇÃO DOS ATOS POTENCIAIS ATIVOS','Registra a execução dos atos e fatos que possa vir a afetar o ativo da entidade governamental.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.0.00.00.00.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS','Compreende as contas relacionadas ao registro da execução de avais, fianças e hipotecas recebidos no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.00.00.00.00.00','EXECUCAO DE GARANTIAS RECEBIDAS NO PAIS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEDIDOS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E   CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.00.00.00.00','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS  POR AVAL PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.02.00.00.00.00','AVAIS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS RECEBIDAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.03.00.00.00.00','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS RECEBIDAS POR AVAL  NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.04.00.00.00.00','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR FIANCAS, PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.05.00.00.00.00','FIANCAS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS POR FIANCAS  EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.06.00.00.00.00','FIANCAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.07.00.00.00.00','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.08.00.00.00.00','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.09.00.00.00.00','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.10.00.00.00.00','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.11.00.00.00.00','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA  EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.12.00.00.00.00','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.13.00.00.00.00','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.14.00.00.00.00','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.15.00.00.00.00','CAUCAO EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.16.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.17.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA  EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.18.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.19.00.00.00.00','APOLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.20.00.00.00.00','APOLICES DE SEGUROS EM EXECUCAO','REGISTRA O VALOR  NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.21.00.00.00.00','APOLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.22.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.23.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS  EM EXECUCAO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.24.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS  NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.00.00.00.00.00','EXECUCAO DE GARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E   CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.01.00.00.00.00','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.02.00.00.00.00','AVAIS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.03.00.00.00.00','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR AVAL NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.04.00.00.00.00','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.05.00.00.00.00','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.06.00.00.00.00','FIANCAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.07.00.00.00.00','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.08.00.00.00.00','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.09.00.00.00.00','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.10.00.00.00.00','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.11.00.00.00.00','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA  EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.12.00.00.00.00','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.13.00.00.00.00','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.14.00.00.00.00','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.15.00.00.00.00','CAUCAO EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.16.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.17.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA  EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.18.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.19.00.00.00.00','APOLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.20.00.00.00.00','APOLICES DE SEGUROS EM EXECUCAO','REGISTRA O VALOR  NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.21.00.00.00.00','APOLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.22.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.23.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS  EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.2.24.00.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS  NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.00.00.00.00.00','EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO PAIS','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS  REFERENTES AS GARANTIAS RECEBIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.02.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS  SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.03.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.04.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.05.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.06.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.07.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.08.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.09.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.10.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.11.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS  EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.3.12.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.00.00.00.00.00','EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS RECEBIDAS  REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.02.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS  SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.03.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.04.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.05.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.06.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.07.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.08.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.09.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.10.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.11.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS  EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.4.12.00.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.0.00.00.00.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no convenente, da execução dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.00.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES','COMPREENDE A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES A RECEBER','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.02.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES  A COMPROVAR DE CONVENIOS PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.03.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES  A APROVAR DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.04.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES  APROVADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.05.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.06.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.07.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO FIRMADO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.08.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES NAO RECEBIDOS','REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.09.00.00.00.00','CONVENIOS E INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO  DE CONVENIO FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.00.00.00.00.00','TERMO DE COOPERACAO','COMPREENDE A EXECUCAO DOS VALORES DE TERMO DE COOPERACAO PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.01.00.00.00.00','TERMO DE COOPERACAO A RECEBER','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERACAO PARA SAIDA   DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.02.00.00.00.00','TERMO DE COOPERACAO A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES  A COMPROVAR DE TERMOS DE COOPERACAO PARA SAIDA   DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.03.00.00.00.00','TERMO DE COOPERACAO A APROVAR','REGISTRA A EXECUCAO DOS VALORES  A APROVAR DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.04.00.00.00.00','TERMO DE COOPERACAO APROVADOS','REGISTRA A EXECUCAO DOS VALORES  APROVADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.05.00.00.00.00','TERMO DE COOPERACAO IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.06.00.00.00.00','TERMO DE COOPERACAO CANCELADOS','REGISTRA O VALOR CANCELADO DO TERMOS DE COOPERACAO FIRMADOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.07.00.00.00.00','TERMO DE COOPERACAO NAO RECEBIDOS','REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADOS DO TERMOS DE COOPERACAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.2.08.00.00.00.00','TERMO DE COOPERACAO CONCLUIDOS','REGISTRA O VALOR CONCLUIDO  DE TERMOS DE COOPERACAO FIRMADOS , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.0.00.00.00.00.00','EXECUÇÃO DE DIREITOS CONTRATUAIS','Compreende contas relacionadas ao registro da execução dos valores de direitos contratuais, quando a administração pública participa como contratada.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.00.00.00.00.00','DE TERCEIROS','COMPREENDE O VALOR DOS DIREITOS E OBRIGACOES CONTRATUAIS EM QUE A  ADMINISTRACAO PUBLICA SEJA SEGNATARIA DO CONTRATO COM TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.01.00.00.00.00','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.01.01.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS SERVICOS DE  SEGUROS , CONFORME PREVISAO CONTRATUAL.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.01.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES APROPRIADOS RELATIVOS AOS SERVICOS DE  SEGUROS , CONFORME PREVISAO CONTRATUAL.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.02.00.00.00.00','CONTRATOS DE SERVICOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.02.01.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A PRESTACAO DE SERVICOS, CONFORME INSTRUMENTO CONTRATUAL EM  QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.02.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.03.00.00.00.00','CONTRATOS DE ALUGUEIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.03.01.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.03.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.04.00.00.00.00','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA  ADMINISTRACAO PUBLICA A TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.04.01.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS  VALORES A REALIZAR  RELATIVOS AOS  CONTRATOS DE FORNECIMENTO DE BENS PELA  ADMINISTRACAO PUBLICA A TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.04.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS  VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS PELA  ADMINISTRACAO PUBLICA A TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.05.00.00.00.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.05.01.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.05.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DE VALORES LIBERADOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.2.00.00.00.00.00','EXECUJÇÃO DOS CONTRATO DE GESTAO','COMPREENDE O VALOR CONSOLIDADO DA EXECUÇÃO DOS DESDOBRAMENTOS DA REFERIDA CONTA.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.2.01.00.00.00.00','CONTRATOS DE GESTAO A LIQUIDAR','REGISTRA O VALOR DA EXECUÇÃO DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO  PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.2.02.00.00.00.00','CONTRATOS DE GESTAO LIQUIDADOS','REGISTRA O VALOR DA EXECUÇÃO DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.9.0.00.00.00.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS ATIVOS','Compreende a execução dos atos potenciais ativos não contemplados em contas especificas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.9.1.00.00.00.00.00','PLANO DE AMORTIZAÇÃO DO DÉFICIT ATUARIAL','REGISTRAR, A TÍTULO DE CONTROLE, OS VALORES RELATIVOS AO PLANO DE AMORTIZAÇÃO DO DÉFICIT ATUARIAL DO RPPS PELO ENTE PÚBLICO QUE O INSTITUIU.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.9.2.00.00.00.00.00','PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','REGISTRAR, A TÍTULO DE CONTROLE, OS VALORES RELATIVOS ÀS PARCELAS DE DÉBITOS PREVIDENCIÁRIOS DO RPPS DEVIDAS PELO ENTE PÚBLICO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.0.0.00.00.00.00.00','EXECUÇÃO DOS ATOS POTENCIAIS PASSIVOS','Registra a execução dos atos e fatos que possa vir a afetar o passivo da entidade governamental.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.0.00.00.00.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','Compreende contas relacionadas ao registro da execução de avais, fianças e hipotecas concedidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.00.00.00.00.00','EXECUCAO DE GARANTIAS CONCEDIDAS NO PAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E   CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.00.00.00.00','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS  POR AVAL PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.02.00.00.00.00','AVAIS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS GARANTIAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.03.00.00.00.00','AVAIS EXECUTADOS','REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL  NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.04.00.00.00.00','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.05.00.00.00.00','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.06.00.00.00.00','FIANCAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.07.00.00.00.00','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.08.00.00.00.00','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.09.00.00.00.00','HIPOTECAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.10.00.00.00.00','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.11.00.00.00.00','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA  EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.12.00.00.00.00','SEGUROS-GARANTIA EXECUTADOS','REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.13.00.00.00.00','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.14.00.00.00.00','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.15.00.00.00.00','CAUCAO EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.16.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.17.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA  EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.18.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.19.00.00.00.00','OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.20.00.00.00.00','OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS  EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.21.00.00.00.00','OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS  NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.00.00.00.00.00','EXECUCAO DE GARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E   CONTRAGARANTIAS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.01.00.00.00.00','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.02.00.00.00.00','AVAIS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.03.00.00.00.00','AVAIS EXECUTADOS','REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.04.00.00.00.00','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.05.00.00.00.00','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.06.00.00.00.00','FIANCAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.07.00.00.00.00','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.08.00.00.00.00','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.09.00.00.00.00','HIPOTECAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.10.00.00.00.00','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.11.00.00.00.00','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA  EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.12.00.00.00.00','SEGUROS-GARANTIA EXECUTADOS','REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.13.00.00.00.00','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.14.00.00.00.00','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.15.00.00.00.00','CAUCAO EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.16.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.17.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA  EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.18.00.00.00.00','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.19.00.00.00.00','OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.20.00.00.00.00','OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS  EM EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.2.21.00.00.00.00','OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS  NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.00.00.00.00.00','EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO PAIS','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS  REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.02.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS  SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.03.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.04.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.05.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGOS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.06.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.07.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.08.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.09.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.10.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.11.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS  EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.3.12.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.00.00.00.00.00','EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS  REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.01.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.02.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS  SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.03.00.00.00.00','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.04.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.05.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.06.00.00.00.00','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.07.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.08.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.09.00.00.00.00','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS  INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.10.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.11.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS  EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.4.12.00.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO EXTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.0.00.00.00.00.00','EXECUÇÃO DE OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no concedente, da execução do valor dos convênios e outros instrumentos congêneres firmados entre entidades, objetivando o cumprimento de finalidades comuns.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.00.00.00.00.00','EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIBERAR','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIBERAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.02.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES  A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.03.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES  A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.04.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES  APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.05.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES  IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.06.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA   DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.07.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.08.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS','REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO  DA  TRANSACAO  EXCCONV,  TIPO  DE EXECUCAO NR. 13.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.09.00.00.00.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO  DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.2.00.00.00.00.00','EXECUCAO DE CONTRATOS DE REPASSE DE PROGRAMAS ESPECIFICOS','COMPREENDE O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS   ESPECIFICOS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.2.01.00.00.00.00','CONTRATOS DE REPASSE DE PROGRAMAS A LIBERAR','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS   ESPECIFICOS A LIBERAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.2.02.00.00.00.00','CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS   ESPECIFICOS LIBERADOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.2.03.00.00.00.00','CONTR.REPASSE DE PROGR. A APROVAR','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS   ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.2.04.00.00.00.00','CONTR.REPASSE DE PROGR. APROVADO','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS   ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.2.05.00.00.00.00','CONTR.REPASSE DE PROGR. HOMOLOGADO','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS   ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.2.06.00.00.00.00','CONTR.REPASSE DE PROGR. IMPUGNADO','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS   ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS  PELO CONTROLE INTERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.0.00.00.00.00.00','EXECUÇÃO DE OBRIGAÇÕES CONTRATUAIS','Compreende contas relacionadas ao registro da execução dos valores de obrigações contratuais, quando a administração pública participa como contratante.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.00.00.00.00.00','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS  VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.01.00.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE  SEGUROS , EM QUE  ADMINISTRACAO SEJA A CONTRATANTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.02.00.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVO A CONTRATOS DE  SEGUROS , EM QUE  ADMINISTRACAO SEJA A CONTRATANTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.2.00.00.00.00.00','CONTRATOS DE SERVICOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.2.01.00.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS,  EM  QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.2.02.00.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.3.00.00.00.00.00','CONTRATOS DE ALUGUEIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.3.01.00.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.3.02.00.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.4.00.00.00.00.00','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA  ADMINISTRACAO PUBLICA A TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.4.01.00.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DOS  VALORES A REALIZAR  RELATIVOS AOS  CONTRATOS DE FORNECIMENTO DE BENS POR TERCEIROS A  ADMINISTRACAO PUBLICA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.4.02.00.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS  VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS POR ADMINISTRACAO A  PUBLICA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.5.00.00.00.00.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.5.01.00.00.00.00','EM EXECUCAO','REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.5.02.00.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DE VALORES A LIBERAREDOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.6.00.00.00.00.00','EXECUCAO DE CONTRATO DE GESTAO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DOS CONTRATOS DE GESTAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.6.01.00.00.00.00','CONTRATOS DE GESTAO A LIQUIDAR','REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO  PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.6.02.00.00.00.00','CONTRATOS DE GESTAO LIQUIDADOS','REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.7.00.00.00.00.00','CONTRATOS DE OPERACOES DE CREDITO','COMPREENDE A EXECUCAO DAS CONTAS QUE REGISTRAM  O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO  ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.7.01.00.00.00.00','EM EXECUCAO','REGISTRA  A EXECUCAO DO VALOR DO CONTRATO A LIBERAR DECORRENTE DE OPERACOES DE CREDITO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.7.02.00.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DO VALOR DO CONTRATO LIBERADO DECORRENTE DE OPERACOES DE CREDITO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.9.0.00.00.00.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS PASSIVOS','Compreende a execução dos atos potenciais passivos não contemplados em contas especificas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.9.1.00.00.00.00.00','BENEFICIARIOS DE SENTENCAS JUDICIAIS INCLUIDAS NO ORCAMENTO','REGISTRA OS PRECATÓRIOS, RECEBIDOS NO EXERCÍCIO ANTERIOR E INCLUÍDOS NO ORÇAMENTO PARA PAGAMENTO ATÉ O FINAL DO EXERCÍCIO. PODE SE MANTER O CONTROLE  NESTE GRUPO POR BENEFICIÁRIO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.9.2.00.00.00.00.00','BENEFICIARIOS DE SENTENCAS JUDICIAIS AINDA NAO INCLUIDAS NO ORCAMENTO','REGISTRA OS PRECATÓRIOS, RECEBIDOS NO EXERCÍCIO E QUE SERÃO INCLUÍDOS NO ORÇAMENTO SEGUINTE PARA PAGAMENTO ATÉ O FINAL DAQUELE EXERCÍCIO. PODE SE MANTER O CONTROLE  NESTE GRUPO POR BENEFICIÁRIO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.0.0.0.00.00.00.00.00','EXECUÇÃO DA ADMINISTRAÇÃO FINANCEIRA','Compreende as contas de registro da execução da programação financeira e de controle das disponibilidades.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.0.0.00.00.00.00.00','EXECUÇÃO DAS DISPONIBILIDADES POR DESTINAÇÃO','Compreende as contas que registram a execução dos controles das disponibilidades por destinação de recursos.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.0.00.00.00.00.00','EXECUÇÃO DA DISPONIBILIDADE DE RECURSOS','Compreende as contas que registram a execução das disponibilidades de recursos a utilizar, comprometidas e utilizadas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.1.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS','Registra o valor das disponibilidades de recursos a utilizar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.2.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR EMPENHO','Registra o valor das disponibilidades de recursos comprometidas por ocasião do empenho e não liquidadas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.3.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR LIQUIDAÇÃO E ENTRADAS COMPENSATÓRIAS','Registra o valor das disponibilidades de recursos comprometidas por ocasião da liquidação e de entradas compensatórias e não pagas/devolvidas.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.4.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS UTILIZADA','Registra o valor das disponibilidades de recursos utilizadas por meio de pagamento de despesa orçamentária, depósitos e/ou outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.5.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR PROGRAMAÇÃO FINANCEIRA','Registra o valor das disponibilidades de recursos comprometidas por programação financeira no órgão central de programação financeira.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.0.00.00.00.00.00','EXECUÇÃO FINANCEIRA DO LIMITE DE RESTOS A PAGAR','Compreende as contas que registram a execução financeira do limite de restos a pagar.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.1.00.00.00.00.00','EXECUCAO FINANCEIRA DO LIMITE  DE RESTOS A PAGAR CONCEDIDO POR DESTINACAO','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR CONCEDIDO POR DESTINACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.1.01.00.00.00.00','VALORES DE LIMITE DE RP A CONCEDER','REGISTRA O VALORES A CONCEDER, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.1.02.00.00.00.00','VALORES DE LIMITE DE RP CONCEDIDO','REGISTRA O VALORES CONCEDIDOS, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.2.00.00.00.00.00','EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINACAO','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINACAO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.2.01.00.00.00.00','VALORES DE LIMITE DE RP A RECEBER','REGISTRA O VALORES A RECEBER, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.2.02.00.00.00.00','VALORES DE LIMITE DE RP RECEBIDO','REGISTRA O VALORES RECEBIDOS, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.3.0.00.00.00.00.00','EXECUÇÃO DO RECURSO DIFERIDO POR DESTINAÇÃO','Compreende as contas que controlam a execução dos recursos diferidos. Recursos diferidos são as sobras de recursos financeiros ao final do exercício (recurso diferido), que deveriam ser devolvidas a conta única, porem, ao invés disso, essas sobras são liberadas para uso (apenas no exercício seguinte) através de descontos das transferências financeiras (cota, repasse e sub-repasse) do exercício seguinte.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.0.0.00.00.00.00.00','EXECUÇÃO DA PROGRAMAÇÃO FINANCEIRA','Compreende as contas que registram a execução das cotas, repasses e sub-repasses para atender a despesas orçamentárias, restos a pagar autorizados e demais dispêndios extra orçamentários.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.1.0.00.00.00.00.00','EXECUCAO DE CONCESSAO DE RECURSOS FINANCEIROS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DAS COTAS, REPASSES E SUB-REPASSES A CONCEDER PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.1.1.00.00.00.00.00','CONCESSAO DE COTAS DECORRENTES DO ORCAMENTO','REGISTRA AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DAS COTAS DECORRENTES DO ORCAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.1.4.00.00.00.00.00','CONCESSAO DE REPASSES DECORRENTES DO ORCAMENTO','REGISTRA AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DOS REPASSES DECORRENTES DO ORCAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.1.7.00.00.00.00.00','CONCESSAO DE SUB-REPASSES DECORRENTES DO ORCAMENTO','REGISTRA AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DOS SUB-REPASSES DECORRENTES DO ORCAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.2.0.00.00.00.00.00','EXECUCAO DO RECEBIMENTO DE RECURSOS FINANCEIROS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DO RECEBIMENTO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.2.1.00.00.00.00.00','RECEBIMENTO DE COTAS DECORRENTES DO ORCAMENTO','REGISTRA O VALOR TOTAL DAS COTAS, RECEBIDAS OU NAO, DECORRENTES DO ORCAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.2.4.00.00.00.00.00','RECEBIMENTO DE REPASSES DECORRENTES DO ORCAMENTO','REGISTRA AS CONTAS DE REGISTRO DA EXECUCAO DA RECEBIMENTO DOS REPASSES DECORRENTES DO ORCAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.2.7.00.00.00.00.00','RECEBIMENTO DE SUB-REPASSES DECORRENTES DO ORCAMENTO','REGISTRA AS CONTAS DE REGISTRO DA EXECUCAO DA RECEBIMENTO DOS SUB-REPASSES DECORRENTES DO ORCAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.3.0.0.00.00.00.00.00','EXECUÇÃO DO LIMITE ORÇAMENTÁRIO','Compreende as contas que controlam a execução do limite de empenho e movimentação de créditos orçamentários, conforme estabelecidos em ato próprio dos poderes e ministério público.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.3.1.0.00.00.00.00.00','EXECUCAO DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','REGISTRA AS CONTAS QUE CONTROLAM A EXECUCAO DO LIMITE ORCAMENTARIO NO OCPF','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.4.0.0.00.00.00.00.00','CONTROLES DA ARRECADAÇÃO','Compreende as contas que registram os valores discriminados da arrecadação da receita orçamentária, por meio de documentos de arrecadação como DARF, GRU, DAR, entre outros.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.4.1.0.00.00.00.00.00','CONTROLES DE DOCUMENTO DE ARRECADAÇÃO','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTO DE ARRECADAÇÃO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.4.1.1.00.00.00.00.00','CONTROLES DE DOCUMENTO DE ARRECADAÇÃO POR CODIGO DE RECEITA','REGISTRA AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.4.1.3.00.00.00.00.00','CONTROLES DE DOCUMENTO DE ARRECADAÇÃO POR CODIGO DE DESTINACAO VINCULADA','REGISTRA AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTO DE ARRECADAÇÃO, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.0.0.0.00.00.00.00.00','EXECUÇÃO DA DIVIDA ATIVA','Compreende as contas que controlam a execução dos créditos passiveis de serem encaminhados e inscritos em divida ativa.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.0.0.00.00.00.00.00','EXECUÇÃO DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DIVIDA ATIVA','Compreende as contas que registram os valores a serem encaminhados e os já encaminhados para o órgão competente em inscrever em divida ativa.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.1.0.00.00.00.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA','Registra os valores a serem encaminhados para o órgão competente em inscrever em divida ativa.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.2.0.00.00.00.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA','Registra os valores encaminhados para o órgão competente em inscrever em divida ativa.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.3.0.00.00.00.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA','Registra o cancelamento dos valores indevidamente encaminhados para o órgão competente em inscrever em divida ativa.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.0.0.00.00.00.00.00','EXECUÇÃO DA INSCRIÇÃO DE CRÉDITOS EM DIVIDA ATIVA','Compreende as contas que registram os valores a serem inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.1.0.00.00.00.00.00','CRÉDITOS A INSCREVER EM DIVIDA ATIVA','Registra os valores a serem inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.2.0.00.00.00.00.00','CRÉDITOS A INSCREVER EM DIVIDA ATIVA DEVOLVIDOS','Registra os valores a serem inscritos em divida ativa que foram devolvidos pelo órgão competente, por incorreções na formalização do processo de encaminhamento.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.0.00.00.00.00.00','CRÉDITOS INSCRITOS EM DIVIDA ATIVA A RECEBER','Registra os valores inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.0.00.00.00.00.00','CRÉDITOS INSCRITOS EM DIVIDA ATIVA RECEBIDOS','Registra os valores recebidos relativos aos créditos anteriormente inscritos em divida ativa.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.0.00.00.00.00.00','BAIXA DE CRÉDITOS INSCRITOS EM DIVIDA ATIVA','Registra os valores relativos às baixas de créditos inscritos em divida ativa.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.0.0.0.00.00.00.00.00','EXECUÇÃO DOS RISCOS FISCAIS','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.0.0.00.00.00.00.00','EXECUÇÃO DE PASSIVOS CONTINGENTES','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.1.0.00.00.00.00.00','PASSIVOS CONTINGENTES PREVISTOS','REGISTRA A PREVISAO DOS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.2.0.00.00.00.00.00','PASSIVOS CONTINGENTES CONFIRMADOS','REGISTRA A CONFIRMACAO DA PREVISAO DOS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.2.0.0.00.00.00.00.00','EXECUÇÃO DOS DEMAIS RISCOS FISCAIS','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, não classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.2.1.0.00.00.00.00.00','DEMAIS RISCOS FISCAIS PREVISTOS','REGISTRA A PREVISAO DOS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.2.2.0.00.00.00.00.00','DEMAIS RISCOS FISCAIS CONFIRMADOS','REGISTRA A CONFIRMACAO DA PREVISAO DOS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.8.0.0.0.00.00.00.00.00','APURAÇÃO DE CUSTOS','Compreende as contas que controlam a execução dos custos dos bens e serviços produzidos.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.0.0.0.00.00.00.00.00','OUTROS CONTROLES','Compreende as contas de controles da execução não especificados anteriormente nos grupos dessa classe.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.0.0.00.00.00.00.00','EXECUCAO DE OUTROS CONTROLES DE PROGRAMACAO FINANCEIRA','REGISTRA AS CONTAS QUE CONTROLAM A EXECUCAO DE OUTRAS PECULIARIDADES DA PROGRAMACAO FINANCEIRA','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.0.0.00.00.00.00.00','EXECUCAO DE OUTROS CONTROLES DE DISPONIBILIDADES','REGISTRA AS CONTAS QUE CONTROLAM A EXECUCAO DE OUTROS CONTROLES DE DISPONIBILIDADES','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.3.0.0.00.00.00.00.00','EXECUCAO DE CONTROLES DE BENEFICIOS PAGOS','REGISTRA AS CONTAS QUE REGISTRAM A EXECUCAO DO PAGAMENTO DE BENEFICIOS PREVIDENCIARIOS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.4.0.0.00.00.00.00.00','EXECUCAO DE CONTROLES DA CONTA UNICA','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA CONTA UNICA','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.4.1.0.00.00.00.00.00','EXECUCAO DA CONCILIACAO DA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO','REGISTRA AS CONTAS QUE CONTROLAM A EXECUCAO DA CONCILIACAO DA CONTA UNICA','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.4.4.0.00.00.00.00.00','EXECUCAO DE CONTROLE DE APLICACAO FINANCEIRA NA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO','REGISTRA AS CONTAS QUE REGISTRAM OS VALORES REFERENTE AO CONTROLE DE FONTE DE RECURSOS NA  NA PLICACAO FINANCEIRA NA CONTA ÚNICA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.6.0.0.00.00.00.00.00','CONTROLES DE OPERACOES DE CREDITOS','REGISTRA AS CONTAS QUE CONTROLAM A EXECUCAO DE OPERACOES DE CREDITO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.0.0.00.00.00.00.00','OUTROS CONTROLES DE RESPONSABILIDADES POR VALORES, TITULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DAS RESPONSABILIDADES POR VALORES, TITULOS E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.0.00.00.00.00.00','EXECUCAO DE RESPONSABILIDADES DE TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.00.00.00.00.00','RESPONSABILIDADES DE TERCEIROS','COMPREENDE A RESPONSABILIDADE DE TERCEIROS POR TITULOS, VALORES  E  BENS CONCEDIDOS PELA UNIDADE GESTORA QUE EFETUA O REGISTRO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.01.00.00.00.00','SUPRIMENTO DE FUNDOS','REGISTRA OS VALORES CONCEDIDOS A  SERVIDOR  RESPONSAVEL  PARA  ATENDERDESPESAS QUE NAO POSSAM SUBORDINAR-SE AO PROCESSO NORMAL DE APLICACAO,ATE A SUA PRESTACAO DE CONTAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.00.00.00.00','OUTRAS RESPONSABILIDADES DE TERCEIROS','COMPREENDE A RESPONSABILIDADE DE TERCEIROS POR TITULOS, VALORES  E  BENS CONCEDIDOS PELA UNIDADE GESTORA QUE EFETUA O REGISTRO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.01.00.00.00','EM CAUCAO','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR TITULOS, VALORES  E  BENS OFERECIDOS EM CAUCAO PELA UNIDADE GESTORA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.02.00.00.00','CONCEDIDOS EM CUSTODIA','REGISTRA O CONTROLE DOS BENS, TITULOS E VALORES EM PODER DE TERCEIROSSOB CUSTODIA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.03.00.00.00','DESPESAS MEDICAS','REGISTRA O VALOR DAS DESPESAS MEDICAS PAGAS  A  HOSPITAIS  E  CLINICAS TENDO COMO USUARIO OS VEREADORES E SERVIDORES.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.04.00.00.00','EM COBRANCA - A RECEBER','REGISTRA O MONTANTE DA RESPONSABILIDADE DE TERCEIROS POR VALORES,  TI-TULOS E BENS EM FASE DE COBRANCA PELA UNIDADE GESTORA.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.06.00.00.00','CONCEDIDOS EM CONSIGNACAO','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR VALORES, TITULOS  E  BENSCONCEDIDOS A TITULO DE CONSIGNACAO PELA UNIDADE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.07.00.00.00','DIARIAS','REGISTRA O VALOR DAS DIARIAS CONCEDIDAS, COM REGISTRO DA RESPONSABILI-DADE MEDIANTE CONTROLE INDIVIDUALIZADO POR TITULAR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.08.00.00.00','TITULOS DE CREDITO','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES DE   TERCEIROS  PORTITULOS DE CREDITO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.09.00.00.00','CESSAO DE USO - BENS CEDIDOS','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR BENS CEDIDOS PELA UNIDADEA TITULO DE CESSAO DE USO, FORMALIZADA MEDIANTE TERMO, NO QUAL DEVERAOCONSTAR A FINALIDADE DA SUA REALIZACAO E O PRAZO PARA SEU CUMPRIMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.11.00.00.00','MERCADORIAS E BENS EM PODER DE TERCEIROS','REGISTRA O VALOR DAS MERCADORIAS E DOS BENS DAS UNIDADES GESTORAS QUEESTAO EM PODER DE TERCEIROS','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.13.00.00.00','BENS EM MANUTENCAO','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR  BENS  MOVEIS  CONCEDIDOSPELA UNIDADE EM CARATER PROVISORIO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.14.00.00.00','PERMISSAO DE USO - BENS CONCEDIDOS','REGISTRA O VALOR DOS BENS CONCEDIDOS A PARTICULAR  MEDIANTE  PERMISSAODE USO, POR ATO NEGOCIAL, UNILATERAL, DISCRICIONARIO E PRECARIO DA AD-MINISTRACAO PUBLICA, E CUJA UTILIZACAO SEJA DE INTERESSE DA  COLETIVI-DADE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.15.00.00.00','AUTORIZACAO DE USO','REGISTRA O CONTROLE DOS BENS  PERTENCENTES  A  ADMINISTRACAO  PUBLICA,SOBRE OS QUAIS FOI A AUTORIZADA A  PRATICA  DE  ATIVIDADE  INDIVIDUAL,TRANSITORIA E IRRELEVANTE PARA O PODER PUBLICO,  POR  ATO  UNILATERAL,DISCRICIONARIO E PRECARIO, DISPENSANDO LEI  AUTORIZATIVA  E  LICITACAOPARA SEU DEFERIMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.16.00.00.00','IMOVEIS DE INTERESSE DO MUNICIPIO','REGISTRA O CONTROLE DE IMOVEIS DE TERCEIROS QUE ESTAO SENDO ADMINISTRADOS PELA ENTIDADE.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.17.00.00.00','CONCESSAO DE USO','REGISTRA A DELEGACAO  DE  SERVICO PUBLICO FEITA PELO PODER  CEDENTE,MEDIANTE CONTRATO, PARA SUA EXPLORACAO SEGUNDO DESTINACAO ESPECIFICADE ACORDO COM A LEI 8987 DE 13/02/1995.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.1.1.02.99.00.00.00','OUTRAS RESPONSABILIDADES DE TERCEIROS','REGISTRA O VALOR DE OUTRAS RESPONSABILIDADES DE TERCEIROS, DE NATUREZAEVENTUAL, POR TITULOS, VALORES E BENS, PARA AS QUAIS NAO HA CONTAS ES-PECIFICAS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.2.0.00.00.00.00.00','EXECUCAO DE RESPONSABILIDADES COM TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.2.1.00.00.00.00.00','EXECUCAO DE RESPONSABILIDADES COM TERCEIROS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.2.1.01.00.00.00.00','RECEBIDOS EM CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.2.1.02.00.00.00.00','DEPOSITOS JUDICIAIS','REGISTRA OS DEPOSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EMCONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOSPOR ESTA PARA TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.2.1.03.00.00.00.00','DEPOSITOS COMPULSORIOS','REGISTRA OS DEPOSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EM CONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOS POR ESTA PARA TERCEIROS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.2.1.99.00.00.00.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NAO INDIVIDUALIZADAS NAS OU-TRAS CONTAS DESSE GRUPO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.0.00.00.00.00.00','DIVERSOS RESPONSAVEIS EM APURACAO','COMPREENDE AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE  ATOS PRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM  RESULTAR EM PREJUIZOS PARA A FAZENDA MUNICIPAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.00.00.00.00.00','DIVERSOS RESPONSAVEIS EM APURACAO','COMPREENDE AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE  ATOS PRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM   RESULTAR EM PREJUIZOS PARA A FAZENDA MUNICIPAL.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.01.00.00.00.00','PAGAMENTOS INDEVIDOS','REGISTRA AS RESPONSABILIDADES EM APURACAO DE GESTORES E OUTROS RESPONSAVEIS E CORESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.02.00.00.00.00','SALDOS NAO RECOLHIDOS','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NAO RECOLHIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU AD-MINISTRATIVAS CUJOS PROCESSOS ESTEJAM EM FASE DE APURACAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.03.00.00.00.00','DESFALQUES OU DESVIOS','REGISTRA OS DESFALQUES OU DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, EM APURACAO,DECORRENTES DE PROCESSOS POR ACOES ADMININISTRATIVAS, POLICIAIS OU JUDICIAIS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.04.00.00.00.00','DEBITOS DE TERCEIROS EM PRESTAÇÃO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADESEM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS ESTEJAM EM FASE DE APURACAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.05.00.00.00.00','RESPONSAVEIS POR DANOS OU PERDAS','DESTINADA AO REGISTRO DAS RESPONSABILIDADES EM INQUERITOS  ADMINISTRATIVOS OU POLICIAIS CONTRA SERVIDORES OU TERCEIROS, POR DANOS E  PERDAS CAUSADOS A FAZENDA NACIONAL, E QUE ESTEJAM EM FASE DE APURACAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.06.00.00.00.00','PAGAMENTOS SEM RESPALDO ORCAMENTARIO','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS  COM-PORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), EM FASE DE APURACAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.07.00.00.00.00','CREDITOS ANTECIPADOS','REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, EM FASE DE  APURACAO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.08.00.00.00.00','FALTA OU IRREGULARIDADE DE COMPROVACAO','REGISTRA OS VALORES CORRESPOND.A FALTA DE DOCUMENTACAO COMPROBAT.DA E-XECUCAO DA DESPESA, INCLUSIVE AS APRESENT.FORA DO PRAZOLEGAL, BEM  CO-MO A INADIMPLENCIA NA COMPROV.DE INSTRUMENT.DE TRANSFER.OU AINDA IRRE-GULARID. NA DOCUMENT., EM FASE DE APURACAO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.09.00.00.00.00','FALTA DE LICITACAO','REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO, INFRINGINDO A LEGISLACAO ESPECIFICA, EM  PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, EM  FASE DE APURACAO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.10.00.00.00.00','MULTAS E JUROS','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO,  POREM DE RESPONSABILIDADE DE SERVIDORES E QUE ESTEJAM EM FASE DE  APURACAO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.11.00.00.00.00','FALTA DE RECOLHIMENTO OBRIGACOES PECUNIARIA','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO:  PARTE  DO  EMPREGADOR  DE OBRIGAÇÕES PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E  NAO  RECOLHIDOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.12.00.00.00.00','FRAUDES EM BENEFICIOS','REGISTRAR OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA  PREVIDENCIA SOCIAL QUE SE ENCONTRAM EM FASE DE APURACAO','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.13.00.00.00.00','ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE','REGISTRA AS RESPONSABILIDADES EM APURACAO DE GESTORES E OUTROS RESPONSAVEIS E CORESPONSAVEIS POR CONCESSAO DE ADIANTAMENTOS  EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO ADIANTAMENTOS A FORNECEDORES OU A EMPREGADOS.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.7.3.1.99.00.00.00.00','OUTRAS RESPONSABILIDADES EM APURACAO','REGISTRA RESPONSABILIDADES EM APURACAO NAO INDIVIDUALIZADAS NAS OUTRASCONTAS DESSE GRUPO.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.0.0.00.00.00.00.00','DEMAIS CONTROLES','COMPREENDE AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS SUBGRUPOS DESTE GRUPO.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.0.00.00.00.00.00','EXECUÇÃO DOS CONTROLES REFERENTES A CONSÓRCIOS PÚBLICOS','COMPREENDE A EXECUÇÃO DOS RECURSOS TRANSFERIDOS AOS CONSORCIOS PUBLICOS ATRAVÉS DAS INFORMAÇÕES ENVIADAS PELOS CONSÓRCIOS PÚBLICOS, INSTITUIDOS DE ACORDO COM A LEI FEDERAL Nº 11.107/2005 PARA FINS DE CONSOLIDAÇÃO QUANTO AS INFORMAÇÕES PARA VERIFICAÇÃO DA APLICAÇÃO DOS INDICES MINIMOS E MÁXIMOS TRAZIDOS PELA CF/88, LRF E DEMAIS CONTROLES.','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.00.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL','COMPREENDE A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL. ESTA CONTA DEVERÁ SER DESDOBRADA POR BIMESTRE PARA COMPOR A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.01.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ANTERIOR','COMPREENDE A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NOS PERIODOS DO EXERCICIO ANTERIOR UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.01.01.00.00.00','DESPESA COM PESSOAL - EXERCICIO ANTERIOR - MAIO A DEZEMBRO','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO PERIODO DE MAIO A DEZEMBRO DO EXERCICIO ANTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.01.02.00.00.00','DESPESA COM PESSOAL - EXERCICIO ANTERIOR - JULHO A DEZEMBRO','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO PERIODO DE JULHO A DEZEMBRO DO EXERCICIO ANTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.01.03.00.00.00','DESPESA COM PESSOAL - EXERCICIO ANTERIOR - SETEMBRO A DEZEMBRO','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO PERIODO DE SETEMBRO A DEZEMBRO DO EXERCICIO ANTERIOR.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.02.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NOS PERIODOS DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.02.01.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 1º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 1º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.02.02.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 2º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 2º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.02.03.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 3º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 3º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.02.04.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 4º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 4º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.02.05.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 5º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 5º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.1.02.06.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 6º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 6º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.2.00.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM ASPS','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM AÇÕES E SERVIÇOS PÚBLICOS DE SAÚDE - ASPS. ESTA CONTA DEVERÁ SER ACUMULADA NOS BIMESTRES E TRAZER APENAS A APLICAÇÃO EM SAUDE PARA FINS DE CONSOLIDAÇÃO DO MÍNIMO CONSTITUCIONAL, OU SEJA TRANSFERÊNCIAS AO CONSÓRCIO COM RECURSO VINCULADO 40.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.3.00.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM MDE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO - MDE. ESTA CONTA DEVERÁ SER ACUMULADA NOS BIMESTRES E TRAZER APENAS A APLICAÇÃO EM EDUCAÇÃO PARA FINS DE CONSOLIDAÇÃO DO MÍNIMO CONSTITUCIONAL, OU SEJA TRANSFERÊNCIAS AO CONSÓRCIO COM RECURSO VINCULADO 20.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.4.00.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM FUNDEB','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM O FUNDEB. ESTA CONTA DEVERÁ SER ACUMULADA NOS BIMESTRES E TRAZER APENAS A APLICAÇÃO NO FUNDEB PARA FINS DE CONSOLIDAÇÃO DO MÍNIMO CONSTITUCIONAL, OU SEJA TRANSFERÊNCIAS AO CONSÓRCIO COM RECURSO VINCULADO 31.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.5.00.00.00.00.00','INFORMAÇÃO DA INSUFICIÊNCIA DE CAIXA DO CONSORCIO PUBLICO','REGISTRA A INFORMAÇÃO DA INSUFICIÊNCIA DE CAIXA DO CONSORCIO PÚBLICO  PARA FINS DE ANALISE DO CUMPRIMENTO DO ART. 42 DA LRF, CONFORME ART. 11, § 2º DA PORTARIA STN Nº 72/2012.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.6.00.00.00.00.00','OPERAÇÕES DE CREDITO IRREGULARES','REGISTRA AS OPERAÇÕES DE CREDITO NÃO AUTORIZADAS POR RESOLUÇÃO DO SENADO FEDERAL,  AS VEDADAS E OUTRAS IRREGULARMENTE REALIZADAS E QUE DEVERÃO SER CONSOLIDADAS NOS DEMONSTRATIVOS DE OPERAÇÃO DE CREDITO E DIVIDA CONSOLIDADA LIQUIDA DO ENTE CONSORCIADO EM ATENDIMENTO AO ART. 18, PARÁGRAFO ÚNICO DA PORTARIA STN N° 72/2012..','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.8.7.00.00.00.00.00','INFORMAÇÃO DO ATENDIMENTO AO ART. 25 DA LC 141/2012','REGISTRA A APLICAÇÃO DIRETA EEXECUTADA PELO CONSORCIO PUBLICO À CONTA DOS RECURSOS REFERENTES À DIFERENÇA DA APLICAÇÃO MÍNIMA EM ASPS QUE DEIXOU DE SER APLICADA EM EXERCICIOS ANTERIORES. ATENDIMENTO AO ART. 25 DA LEI COMPLEMENTAR 141/2012 E PARÁGRAFO ÚNICO DO ART. 10 DA PORTARIA STN Nº 72/2012. O CONSORCIO DEVERÁ EXECUTAR ESTA DESPESA NA MODALIDADE DE APLICAÇÃO 96.','C','S','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.9.0.00.00.00.00.00','DEMAIS CONTROLES','REGISTRA AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS TITULOS DESTE SUBGRUPO.','C','S','C','');

UPDATE contabilidade.plano_conta_estrutura SET escrituracao = 'S' WHERE escrituracao = 's';


-- PLANO CONTA UNIAO 2013 v4.0
INSERT INTO contabilidade.plano_conta_geral (cod_uf, cod_plano, versao, dt_versao) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0)+1, 1), '4', '2012-08-28');

INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.01.00', 'CAIXA', 'REGISTRA O SOMATORIO DE NUMERARIOS EM ESPECIE E OUTROS VALORES EM TESOURARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.02.01', 'BANCO CENTRAL DO BRASIL', 'REGISTRA A MOVIMENTACAO FINANCEIRA DA CONTA UNICA ATRAVES DO AGENTE FINANCEIRO BANCO CENTRAL DO BRASIL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.02.02', 'BANCO DO BRASIL', 'REGISTRA A MOVIMENTACAO FINANCEIRA DA CONTA UNICA ATRAVES DO AGENTE FINANCEIRO BANCO DO BRASIL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.02.03', 'CONTA UNICA - RECURSOS DE GPS RECOLHIDOS A TRANSFERIR', 'REGISTRA A MOVIMENTACAO FINANCEIRA DA PREVIDENCIA SOCIAL JUNTO A CONTA UNICA, COMO O RECOLHIMENTO DE RECEITAS FEDERAIS ATRAVES DE GPS INTRA-SIAFI, GPS ELETRONICA E REDE BANCARIA PARA POSTERIOR TRANSFERENCIA A CONTA UNICA DO INSS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.02.04', 'CONTA UNICA - RECURSOS VINCULADOS COM LIMITE PARA EMPENHO CONTRA ENTREGA', 'REGISTRA A MOVIMENTACAO FINANCEIRA DA CONTA UNICA DE RECURSOS VINCULADOS A PAGAMENTO ESPECIFICOS E PARA EMPENHO CONTRA ENTREGSA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.02.05', 'CONTA UNICA - RECURSOS VINCULADOS COM LIMITE DE SAQUE', 'REGISTRA A MOVIMENTACAO FINANCEIRA DA CONTA UNICA DE LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.02.06', 'CONTA UNICA - RECURSOS DA CONTA UNICA APLICADOS', 'REGISTRA A MOVIMENTACAO FINANCEIRA DE RECURSOS DA CONTA UNICA EM PROCESSO DE APLICACAO E RESGATE PELA PROPRIA UNIDADE GESTORA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.02.07', 'CONTA UNICA -RECURSOS DE CONTRIBUICAO PREVIDENCIARIA ARREC. POR DARF', 'REGISTRA A MOVIMENTACAO FINANCEIRA DA PREVIDENCIA SOCIAL JUNTO A CONTA UNICA REFERENTE A ARRECADACAO DE RECEITA PREVIDENCIARIA PELO DOCUMENTO DARF.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.03.01', 'CONTA UNICA - INSS', 'REGISTRA A MOVIMENTACAO FINANCEIRA EM SUBCONTA DO INSS MANTIDA JUNTO AO BANCO CENTRAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.03.02', 'CONTA UNICA - CONTROLE DE OBS EMITIDAS (INSS)', 'REGISTRA O CONTROLE DE ORDENS BANCARIAS EMITIDAS PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.03.03', 'CONTA UNICA - CONTROLE DE DARF EMITIDOS (INSS)', 'REGISTRA O CONTROLE DE DARF EMITIDOS PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.03.04', 'CONTA UNICA - CONTROLE DE GPS EMITIDAS (INSS)', 'REGISTRA O CONTROLE DE GPS EMITIDAS PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.03.05', 'CONTA UNICA - CONTROLE DE GRU EMITIDAS (INSS)', 'REGISTRA O CONTROLE DE GRU EMITIDAS PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.03.06', 'CONTA UNICA - CONTROLE DE NL EMITIDAS DE FONTE PROPRIA (INSS)', 'REGISTRA O CONTROLE DE NL EMITIDAS, DECORRENTES DE CLASSIFICACAO DE RECEITAS PROPRIAS, PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.03.07', 'CONTA UNICA - CONTROLE DE NL EMITIDAS DE VALORES DE TERCEIROS (INSS)', 'REGISTRA O CONTROLE DE NL EMITIDAS, DECORRENTES DE CLASSIFICACAO DE VALORES DE TERCEIROS, PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.03.08', 'CONTA UNICA - CONTROLE DE DAR EMITIDOS (INSS)', 'REGISTRA O CONTROLE DE DAR EMITIDAS PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.03.09', 'CONTA UNICA - CONTROLE DE GFIP EMITIDAS (INSS)', 'REGISTRA O CONTROLE DE GFIP EMITIDAS PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.04.01', 'CONTA UNICA - DIVIDA PUBLICA', 'REGISTRA A MOVIMENTACAO FINANCEIRA EM SUBCONTA DA DIVIDA PUBLICA MANTIDA JUNTO AO BANCO CENTRAL DO BRASIL COM A FINALIDADE DE ADMINISTRACAO DA DIVIDA PUBLICA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.04.02', 'CONTA UNICA - CONTROLE DE OBS EMITIDAS (DIVIDA PUBLICA)', 'REGISTRA O CONTROLE DE ORDENS BANCARIAS EMITIDAS PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.04.03', 'CONTA UNICA - REMUNERACAO DAS DISPONIBILIDADES DA DIVIDA PUBLICA', 'REGISTRA A REMUNERACAO DAS DISPONIBILIDADES DA DIVIDA PUBLICA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.05.00', 'BANCOS CONTA MOVIMENTO - RECURSOS DOS FUNDOS CONSTITUCIONAIS', 'REGISTRA A MOVIMENTACAO FINANCEIRA DOS FUNDOS CONSTITUCIONAIS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.06.00', 'RESERVADO PARA CONTA ÚNICA DO RPPS', 'REGISTRA OS RECURSOS DA CONTA UNICA DO RPPS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.01', 'DEMAIS CONTAS - BANCO CENTRAL DO BRASIL', 'REGISTRA A MOVIMENTACAO FINANCEIRA DE OUTRA CONTA BANCARIA EXISTENTE NO BANCO CENTRAL DO BRASIL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.02', 'DEMAIS CONTAS - BANCO DO BRASIL', 'REGISTRA A MOVIMENTACAO FINANCEIRA NO BANCO DO BRASIL EM CONTA BANCARIA QUE NAO SEJA A CONTA UNICA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.03', 'DEMAIS CONTAS - CAIXA ECONOMICA FEDERAL', 'REGISTRA OS VALORES ARRECADADOS OU RECEBIDOS PELA REDE DE AGENCIAS DA CAIXA ECONOMICA FEDERAL A CONTA DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.04', 'DEMAIS CONTAS - BANCO DA AMAZONIA', 'REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE, ARRECADADOS OU RECEBIDOS PELO BANCO DA AMAZONIA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.05', 'DEMAIS CONTAS - BANCO DO NORDESTE', 'REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE, ARRECADADOS OU RECEBIDOS PELO BANCO DO NORDESTE.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.06', 'DEMAIS CONTAS - BANCO ABN AMRO REAL S/A', 'REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO ABN AMRO REAL S/A.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.07', 'DEMAIS CONTAS - BANESPA', 'REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANESPA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.08', 'DEMAIS CONTAS - BANCO DE BRASILIA', 'REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO DE BRASILIA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.09', 'DEMAIS CONTAS - BANCO DO ESTADO DE GOIAS', 'REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO DO ESTADO DE GOIAS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.10', 'DEMAIS CONTAS - BANCO ITAU', 'REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO ITAU.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.11', 'DEMAIS CONTAS - BANCO NOSSA CAIXA', 'REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO NOSSA CAIXA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.12', 'DEMAIS CONTAS - BANCO DO ESTADO DE RIO GRANDE DO SUL', 'REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO DO RIO GRANDE SO SUL', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.13', 'DEMAIS CONTAS - BANCO DO ESTADO DE SANTA CATARINA', 'REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO DE SANTA CATARINA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.14', 'DEMAIS CONTAS - BRADESCO', 'REGISTRA AS RECEITAS E OUTROS VALORES ARRECADADOS PELA REDE DE AGENCIAS BANCARIAS DO BRADESCO A CONTA UNICA DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.15', 'DEMAIS CONTAS - BANCO REAL', 'REGISTRA OS RECURSOS DA UNIAO, ARRECADADOS OU RECEBIDOS PELAS AGENCIAS DO BANCO REAL S.A', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.99', 'DEMAIS CONTAS BANCARIAS', 'REGISTRA AS ARRECADACOES DE RECEITAS DA ENTIDADE E DE OUTROS VALORES DESTA SOB SUA GUARDA OU RESPONSABILIDADE, ESPECIFICAMENTE QUANDO O BANCO NAO SE ENCONTRA RELACIONADO NAS CONTAS ACIMA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.30.01', 'ARRECADACAO DIRETA', 'REGISTRA OS VALORES DAS RECEITAS ARRECADADAS DIRETAMENTE PELA ENTIDADE.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.30.02', 'ARRECADACAO INDIRETA', 'REGISTRA OS VALORES DA RECEITA ARRECADADA PELOS AGENTES FINANCEIROS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.01', 'LTN', 'REGISTRA OS VALORES DAS DISPONIBILIDADES DAS INSTITUICOES, ENTIDADES E UNIDADES APLICADAS EM LETRAS DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.02', 'CTN', 'REGISTRA OS VALORES DAS DISPONIBILIDADES DAS INSTITUICOES, ENTIDADES E UNIDADES APLICADAS EM CERTIFICADOS DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.03', 'LFT', 'REGISTRA OS VALORES DAS DISPONIBILIDADES DAS INSTITUICOES, ENTIDADES OU UNIDADES APLICADAS EM LETRAS FINANCEIRAS DO TESOURO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.04', 'CFT', 'REGISTRA OS VALORES DAS DISPONIBILIDADES DAS INSTITUICOES, ENTIDADES E UNIDADES APLICADOS EM CERTIFICADOS FINANCEIROS DO TESOURO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.05', 'POUPANCA', 'REGISTRA O VALOR DAS APLICACOES FINANCEIRAS EM POUPANCAS E SEU RENDIMENTOS (JUROS E ATUALIZACAO MONETARIA) POSTERIORES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.06', 'FUNDO DE APLICACAO FINANCEIRA', 'REGISTRA O VALOR DAS APLICACOES FINANCEIRAS EM FUNDO DE APLICACAO E SEUS RENDIMENTOS (JUROS E ATUALIZACAO) POSTERIORES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.07', 'DEPOSITOS ESPECIAIS REMUNERADOS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS ESPECIAIS REMUNERADOS, DECORRENTES DA CONVERSAO DE CRUZADOS NOVOS ANTERIORMENTE BLOQUEADOS PARA CRUZEIROS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.08', 'FUNDO DE APLICACAO - EXTRAMERCADO', 'REGISTROS DOS VALORES RELATIVOS A FUNDO DE APLICACAO EXTRA MERCADO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.09', 'FUNDO DE APLICACAO - EXTRAMERCADO- FAT/FUNCAFE/FNDE', 'REGISTRAR O VALOR DAS APLICACOES DAS DISPONIBILIDADES FINANCEIRAS DO FAT/ FUNCAFE/FNDE MEDIANTE RECURSOS DOS CONDOMINOS EM CARTEIRA, DE ATIVOS FINANCEIROS DE RENDA FIXA, OBSERVADAS AS LIMITACOES LEGAIS E REGULAMENTARES EM VIGOR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.10', 'CDB', 'REGISTRA OS VALORES DAS DISPONIBILIDADES DAS INSTITUICOES, ENTIDADES OU UNIDADES APLICADAS CERTIFICADOS DE DEPOSITOS BANCARIOS.(CDB)', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.11', 'APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA DOS RECURSOS DA CONTA UNICA', 'REGISTRA O VALOR DAS APLICACOES FINANCEIRAS DE RECURSOS DA CONTA UNICA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.99', 'OUTRAS APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA', 'REGISTRA OUTRAS APLICACOES FINANCEIRAS, NAO CLASSIFICADAS EM ITENS ANTERIORE, DAS DISPONIBILIDADES FINANCEIRAS DAS ENTIDADES, INSTITUICOES OU UNIDADES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.20.01', 'LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO', 'REGISTRA O VALOR DO LIMITE DE SAQUE DA CONTA UNICA DO ENTE FEDERATIVO OU DA CONTA UNICA INSTITUCIONAL DO INSS, ESTABELECIDO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA, PARA ATENDER A DESPESAS COM VINCULACAO DE PAGAMENTO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.20.02', 'LIMITE DE SAQUE PARA EMPENHO CONTRA ENTREGA', 'REGISTRA O VALOR DO LIMITE DE SAQUE DA CONTA UNICA DO ENTE FEDERATIVO OU DA CONTA UNICA INSTITUCIONAL DO INSS, ESTABELECIDO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA, PARA ATENDER A DESPESAS DE EMPENHO DE PAGAMENTO CONTRA ENTREGA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.20.03', 'RECURSOS DA PREVIDENCIA SOCIAL', 'REGISTRA O VALOR A RECEBER DO TESOURO DO ENTE FEDERATIVO REFERENTE A PREVIDENCIA SOCIAL E RECURSOS QUE O INSS TEM A REPASSAR AO TESOURO, RELATIVOS A ARRECADACAO DE BENEFICIOS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.20.04', 'LIMITE DE SAQUE RECURSOS DA DIVIDA PUBLICA', 'REGISTRA O VALOR DO LIMITE DE SAQUE DA SUBCONTA DA DIVIDA PUBLICA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.20.05', 'LIMITE DE SAQUE - ENTIDADES TCT', 'REGISTRA O VALOR DO LIMITE DE SAQUE POR PAGAMENTO A ENTIDADES QUE UTILIZAM A CONTA UNICA, EM CUMPRIMENTO AO TERMO DE COOPERACAO TECNICA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.20.06', 'LIMITE DE SAQUE BACEN', 'REGISTRA O VALOR DO LIMITE FINANCEIRO DO BACEN.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.2.1.01.00', 'CAIXA - MOEDA ESTRANGEIRA', 'REGISTRA O SOMATORIO DE NUMERARIOS EM ESPECIE E OUTROS VALORES EM TESOURARIA NO EXTERIOR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.2.1.02.00', 'BANCOS - MOEDA ESTRANGEIRA', 'REGISTRA A LIVRE MOVIMENTACAO DE RECURSOS FINANCEIROS EM MOEDA ESTRANGEIRA MANTIDOS EM CONTAS BANCARIAS NO EXTERIOR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.2.1.50.00', 'APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA - MOEDA ESTRANGEIRA', 'REGISTRA AS APLICACOES FINANCEIRAS DE ALTA LIQUIDEZ EM MOEDA ESTRANGEIRA, QUE SAO PRONTAMENTE CONVERSIVEIS EM VALORES CONHECIDOS DE CAIXA E QUE ESTAO SUJEITAS A UM INSIGNIFICANTE RISCO DE MUDANCA DE VALOR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.2.1.51.00', 'APLICACOES FINANCEIRAS - FECHAMENTO DE CAMBIO', 'REGISTRA O VALOR DAS APLICACOES FINANCEIRAS REFERENTES A FECHAMENTO DE CAMBIO PARA AQUISICAO DE MOEDA ESTRANGEIRA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.2.1.52.00', 'APLICACOES EM DEPOSITOS REALIZAVEIS A CURTISSIMO PRAZO', 'REGISTRA O VALOR DAS APLICACOES DE DEPOSITOS COM JUROS EM MOEDA ESTRANGEIRA REALIZAVEIS NO CURTISSIMO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.01', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUES ESTRATEGICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.02', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. REGULADORES PGPM', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADORES DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.03', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUE PROPRIO', 'REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.04', 'FATURAS/ DUPLICATAS A RECEBER - ABASTECIMENTO SOCIAL', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.05', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. POR ATACADO', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.06', 'FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.07', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. EM CONSIGNACAO', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES EM CONSIGNACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.08', 'FATURAS/ DUPLICATAS A RECEBER - AGRICULTURA FAMILIAR', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES DA AGRICULTURA FAMILIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.80', 'OUTRAS FATURA/ DUPLICATAS A RECEBER', 'REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.95', '(-) DUPLICATAS DESCONTADAS - EST. ESTRATEGICO', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICO DO GOVERNO FEDERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.96', '(-) DUPLICATAS DESCONTADAS - EST. REGULADOR', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADOR DO GOVERNO FEDERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.97', '(-) DUPLICATAS DESCONTADAS - EST. PROPRIOS', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.98', '(-) DUPLICATAS DESCONTADAS - ABASTECIMENTO SOCIAL', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.99', '(-) DUPLICATAS DESCONTADAS - EST. POR ATACADO', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.02.00', 'FATURAS/DUPLICATAS A FATURAR', 'REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.03.00', 'FATURAS/DUPLICATAS A RECEBER VENCIDAS', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.01', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUES ESTRATEGICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.02', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. REGULADORES PGPM', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADORES DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.03', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUE PROPRIO', 'REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.04', 'FATURAS/ DUPLICATAS A RECEBER - ABASTECIMENTO SOCIAL', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.05', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. POR ATACADO', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.06', 'FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.07', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. EM CONSIGNACAO', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES EM CONSIGNACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.08', 'FATURAS/ DUPLICATAS A RECEBER - AGRICULTURA FAMILIAR', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES DA AGRICULTURA FAMILIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.80', 'OUTRAS FATURA/ DUPLICATAS A RECEBER', 'REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.95', '(-) DUPLICATAS DESCONTADAS - EST. ESTRATEGICO', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICO DO GOVERNO FEDERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.96', '(-) DUPLICATAS DESCONTADAS - EST. REGULADOR', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADOR DO GOVERNO FEDERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.97', '(-) DUPLICATAS DESCONTADAS - EST. PROPRIOS', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.98', '(-) DUPLICATAS DESCONTADAS - ABASTECIMENTO SOCIAL', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.99', '(-) DUPLICATAS DESCONTADAS - EST. POR ATACADO', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.02.00', 'FATURAS/DUPLICATAS A FATURAR', 'REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.03.00', 'FATURAS/DUPLICATAS A RECEBER VENCIDAS', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.01', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUES ESTRATEGICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.02', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. REGULADORES PGPM', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADORES DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.03', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUE PROPRIO', 'REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.04', 'FATURAS/ DUPLICATAS A RECEBER - ABASTECIMENTO SOCIAL', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.05', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. POR ATACADO', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.06', 'FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.07', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. EM CONSIGNACAO', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES EM CONSIGNACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.08', 'FATURAS/ DUPLICATAS A RECEBER - AGRICULTURA FAMILIAR', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES DA AGRICULTURA FAMILIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.80', 'OUTRAS FATURA/ DUPLICATAS A RECEBER', 'REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.95', '(-) DUPLICATAS DESCONTADAS - EST. ESTRATEGICO', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICO DO GOVERNO FEDERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.96', '(-) DUPLICATAS DESCONTADAS - EST. REGULADOR', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADOR DO GOVERNO FEDERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.97', '(-) DUPLICATAS DESCONTADAS - EST. PROPRIOS', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.98', '(-) DUPLICATAS DESCONTADAS - ABASTECIMENTO SOCIAL', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.99', '(-) DUPLICATAS DESCONTADAS - EST. POR ATACADO', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.02.00', 'FATURAS/DUPLICATAS A FATURAR', 'REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.03.00', 'FATURAS/DUPLICATAS A RECEBER VENCIDAS', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.01', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUES ESTRATEGICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.02', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. REGULADORES PGPM', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADORES DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.03', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUE PROPRIO', 'REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.04', 'FATURAS/ DUPLICATAS A RECEBER - ABASTECIMENTO SOCIAL', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.05', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. POR ATACADO', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.06', 'FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.07', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. EM CONSIGNACAO', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES EM CONSIGNACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.08', 'FATURAS/ DUPLICATAS A RECEBER - AGRICULTURA FAMILIAR', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES DA AGRICULTURA FAMILIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.80', 'OUTRAS FATURA/ DUPLICATAS A RECEBER', 'REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.95', '(-) DUPLICATAS DESCONTADAS - EST. ESTRATEGICO', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICO DO GOVERNO FEDERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.96', '(-) DUPLICATAS DESCONTADAS - EST. REGULADOR', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADOR DO GOVERNO FEDERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.97', '(-) DUPLICATAS DESCONTADAS - EST. PROPRIOS', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.98', '(-) DUPLICATAS DESCONTADAS - ABASTECIMENTO SOCIAL', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.99', '(-) DUPLICATAS DESCONTADAS - EST. POR ATACADO', 'REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.02.00', 'FATURAS/DUPLICATAS A FATURAR', 'REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.03.00', 'FATURAS/DUPLICATAS A RECEBER VENCIDAS', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.2.0.00.01', 'CREDITOS TRIBUTARIOS A RECEBER', 'COMPREENDE OS VALORES RELATIVOS A CREDITOS A RECEBER ORIUNDOS DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TRIBUTARIAS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIOS .', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.2.1.00.00', 'CREDITOS TRIBUTARIOS A RECEBER - CONSOLIDACAO', 'REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER ORIUNDOS DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TRIBUTARIAS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIOS . COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.2.2.00.00', 'CREDITOS TRIBUTARIOS A RECEBER - INTRA OFSS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER ORIUNDOS DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TRIBUTARIAS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.2.4.00.00', 'CREDITOS TRIBUTARIOS A RECEBER - INTER OFSS - ESTADO', 'REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER ORIUNDOS DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TRIBUTARIAS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.2.5.00.00', 'CREDITOS TRIBUTARIOS A RECEBER - INTER OFSS - MUNICIPIO', 'REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER ORIUNDOS DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TRIBUTARIAS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.1.01.00', 'CREDITOS NAO PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.1.02.00', 'CREDITOS PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.2.01.00', 'CREDITOS NAO PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.2.02.00', 'CREDITOS PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.4.01.00', 'CREDITOS NAO PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.4.02.00', 'CREDITOS PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.5.01.00', 'CREDITOS NAO PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.5.02.00', 'CREDITOS PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.1.00.00', 'DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES - CONSOLIDACAO', 'REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, DERIVADOS DE CLIENTES, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.00.00', 'CREDITOS DE TRANSFERENCIAS A RECEBER - INTER OFSS - ESTADO', 'REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER ORIUNDOS DAS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS OBRIGATORIAS DA UNIAO, ESTADOS, DISTRITO FEDERAL E MUNICIPIOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.00.00', 'CREDITOS DE TRANSFERENCIAS A RECEBER - INTER OFSS - MUNICIPIO', 'REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER ORIUNDOS DAS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS OBRIGATORIAS DA UNIAO, ESTADOS, DISTRITO FEDERAL E MUNICIPIOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.01.00', 'EMPRESTIMOS CONCEDIDOS A RECEBER', 'REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.02.01', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO, EXCETO OS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.02.02', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO, REFERENTES AOS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.03.01', 'CREDITOS DE OPERACOES ESPECIAIS A RECEBER', 'REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS A RECEBER, INCLUSIVE JUROS E MULTAS, UTILIZADAS NORMALMENTE PELA COORDENACAO-GERAL DAS OPERACOES DE CREDITO DO TESOURO NACIONAL - COPEC.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.03.02', 'JUROS A RECEBER - OPERACOES ESPECIAIS', 'REGISTRA OS JUROS RELATIVOS A OPERACOES ESPECIAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.03.03', 'OPERACOES ESPECIAIS SECURITIZADAS', 'REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS SECURITIZADAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.03.04', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, EXCETO OS RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.03.05', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.04.01', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.04.02', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.04.03', 'ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT,EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.04.04', 'ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT,EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.05.00', 'RELACOES INTERFINANCEIRAS DE FUNDOS CONSTITUCIONAIS', 'REGISTRA OS VALORES DAS OPERACOES COM PERDAS IMPUTAVEIS AO PROAGRO E VALORES DE REPASSES BNB E OUTRAS INSTITUICOES', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.06.00', 'RESIDUO DE EMPRESTIMOS CONCEDIDOS', 'REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM CURTO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.07.01', 'EMPRESTIMOS A RECEBER - RPPS', 'REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.07.02', 'FINANCIAMENTOS A RECEBER - RPPS', 'REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.08.00', 'EMPRESTIMO COMPULSORIO A RECEBER', 'REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.09.00', 'EMPRESTIMOS A CONCEDER PELOS AGENTES FINANCEIROS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS A SEREM CONCEDIDOS PELOS AGENTES FINANCEIROS POR AUTORIZACOES LEGAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.10.00', 'FINANCIAMENTOS A CONCEDER PELOS AGENTES FINANCEIROS', 'REGISTRA A APROPRIACAO DOS VALORES DOS FINANCIAMENTOS, A CURTO PRAZO, A CONCEDER PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.11.00', 'OPERACOES COMPROMISSADAS - REVENDA', 'REGISTRA AS OPERACOES COMPROMISSADAS COM COMPROMISSO DE REVENDA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.01.00', 'EMPRESTIMOS CONCEDIDOS RECEBER', 'REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.02.01', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO, EXCETO OS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.02.02', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO, REFERENTES AOS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.03.01', 'CREDITOS DE OPERACOES ESPECIAIS A RECEBER', 'REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS A RECEBER, INCLUSIVE JUROS E MULTAS, UTILIZADAS NORMALMENTE PELA COORDENACAO-GERAL DAS OPERACOES DE CREDITO DO TESOURO NACIONAL - COPEC.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.03.02', 'JUROS A RECEBER - OPERACOES ESPECIAIS', 'REGISTRA OS JUROS RELATIVOS A OPERACOES ESPECIAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.03.03', 'OPERACOES ESPECIAIS SECURITIZADAS', 'REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS SECURITIZADAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.03.04', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, EXCETO OS RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.03.05', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.04.01', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.04.02', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.04.03', 'ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT,EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.04.04', 'ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT,EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.05.00', 'RELACOES INTERFINANCEIRAS DE FUNDOS CONSTITUCIONAIS', 'REGISTRA OS VALORES DAS OPERACOES COM PERDAS IMPUTAVEIS AO PROAGRO E VALORES DE REPASSES BNB E OUTRAS INSTITUICOES', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.06.00', 'RESIDUO DE EMPRESTIMOS CONCEDIDOS', 'REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM CURTO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.07.01', 'EMPRESTIMOS A RECEBER - RPPS', 'REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.07.02', 'FINANCIAMENTOS A RECEBER - RPPS', 'REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.08.00', 'EMPRESTIMO COMPULSORIO A RECEBER', 'REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.09.00', 'EMPRESTIMOS A CONCEDER PELOS AGENTES FINANCEIROS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS A SEREM CONCEDIDOS PELOS AGENTES FINANCEIROS POR AUTORIZACOES LEGAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.10.00', 'FINANCIAMENTOS A CONCEDER PELOS AGENTES FINANCEIROS', 'REGISTRA A APROPRIACAO DOS VALORES DOS FINANCIAMENTOS, A CURTO PRAZO, A CONCEDER PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.11.00', 'OPERACOES COMPROMISSADAS - REVENDA', 'REGISTRA AS OPERACOES COMPROMISSADAS COM COMPROMISSO DE REVENDA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.01.00', 'EMPRESTIMOS CONCEDIDOS RECEBER', 'REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.02.01', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO, EXCETO OS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.02.02', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO, REFERENTES AOS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.03.01', 'CREDITOS DE OPERACOES ESPECIAIS A RECEBER', 'REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS A RECEBER, INCLUSIVE JUROS E MULTAS, UTILIZADAS NORMALMENTE PELA COORDENACAO-GERAL DAS OPERACOES DE CREDITO DO TESOURO NACIONAL - COPEC.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.03.02', 'JUROS A RECEBER - OPERACOES ESPECIAIS', 'REGISTRA OS JUROS RELATIVOS A OPERACOES ESPECIAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.03.03', 'OPERACOES ESPECIAIS SECURITIZADAS', 'REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS SECURITIZADAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.03.04', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, EXCETO OS RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.03.05', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.04.01', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.04.02', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.04.03', 'ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT,EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.04.04', 'ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT,EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.05.00', 'RELACOES INTERFINANCEIRAS DE FUNDOS CONSTITUCIONAIS', 'REGISTRA OS VALORES DAS OPERACOES COM PERDAS IMPUTAVEIS AO PROAGRO E VALORES DE REPASSES BNB E OUTRAS INSTITUICOES', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.06.00', 'RESIDUO DE EMPRESTIMOS CONCEDIDOS', 'REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM CURTO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.07.01', 'EMPRESTIMOS A RECEBER - RPPS', 'REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.07.02', 'FINANCIAMENTOS A RECEBER - RPPS', 'REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.08.00', 'EMPRESTIMO COMPULSORIO A RECEBER', 'REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.09.00', 'EMPRESTIMOS A CONCEDER PELOS AGENTES FINANCEIROS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS A SEREM CONCEDIDOS PELOS AGENTES FINANCEIROS POR AUTORIZACOES LEGAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.10.00', 'FINANCIAMENTOS A CONCEDER PELOS AGENTES FINANCEIROS', 'REGISTRA A APROPRIACAO DOS VALORES DOS FINANCIAMENTOS, A CURTO PRAZO, A CONCEDER PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.11.00', 'OPERACOES COMPROMISSADAS - REVENDA', 'REGISTRA AS OPERACOES COMPROMISSADAS COM COMPROMISSO DE REVENDA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.01.00', 'EMPRESTIMOS CONCEDIDOS RECEBER', 'REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.02.01', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO, EXCETO OS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.02.02', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO, REFERENTES AOS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.03.01', 'CREDITOS DE OPERACOES ESPECIAIS A RECEBER', 'REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS A RECEBER, INCLUSIVE JUROS E MULTAS, UTILIZADAS NORMALMENTE PELA COORDENACAO-GERAL DAS OPERACOES DE CREDITO DO TESOURO NACIONAL - COPEC.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.03.02', 'JUROS A RECEBER - OPERACOES ESPECIAIS', 'REGISTRA OS JUROS RELATIVOS A OPERACOES ESPECIAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.03.03', 'OPERACOES ESPECIAIS SECURITIZADAS', 'REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS SECURITIZADAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.03.04', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, EXCETO OS RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.03.05', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.04.01', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.04.02', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.04.03', 'ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT,EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.04.04', 'ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT,EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.05.00', 'RELACOES INTERFINANCEIRAS DE FUNDOS CONSTITUCIONAIS', 'REGISTRA OS VALORES DAS OPERACOES COM PERDAS IMPUTAVEIS AO PROAGRO E VALORES DE REPASSES BNB E OUTRAS INSTITUICOES', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.06.00', 'RESIDUO DE EMPRESTIMOS CONCEDIDOS', 'REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM CURTO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.07.01', 'EMPRESTIMOS A RECEBER - RPPS', 'REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.07.02', 'FINANCIAMENTOS A RECEBER - RPPS', 'REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.08.00', 'EMPRESTIMO COMPULSORIO A RECEBER', 'REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.09.00', 'EMPRESTIMOS A CONCEDER PELOS AGENTES FINANCEIROS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS A SEREM CONCEDIDOS PELOS AGENTES FINANCEIROS POR AUTORIZACOES LEGAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.10.00', 'FINANCIAMENTOS A CONCEDER PELOS AGENTES FINANCEIROS', 'REGISTRA A APROPRIACAO DOS VALORES DOS FINANCIAMENTOS, A CURTO PRAZO, A CONCEDER PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.11.00', 'OPERACOES COMPROMISSADAS - REVENDA', 'REGISTRA AS OPERACOES COMPROMISSADAS COM COMPROMISSO DE REVENDA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.01.00', '(-) AJUSTE DE PERDAS DE CREDITOS DE LIQUIDACAO DUVIDOSA', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.02.00', '(-) AJUSTE DE PERDAS DE CREDITOS TRIBUTARIOS', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.03.00', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA TRIBUTARIA', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.04.00', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.05.01', '(-) AJUSTE DE PERDAS EM OPERACOES ESPECIAIS', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS NAS LIQUIDACOES DOS CREDITOS DE OPERACOES ESPECIAIS, A CURTO PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.05.02', '(-) AJUSTE DE PERDAS EM EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIARIOS', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.05.99', '(-) OUTROS AJUSTES DE PERDAS EM EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS EM DEMAIS EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, NAO CLASSIFICADAS ANTERIORMENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.01.00', '(-) AJUSTE DE PERDAS DE CREDITOS DE LIQUIDACAO DUVIDOSA', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.02.00', '(-) AJUSTE DE PERDAS DE CREDITOS TRIBUTARIOS', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.03.00', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA TRIBUTARIA', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.04.00', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.05.01', '(-) AJUSTE DE PERDAS EM OPERACOES ESPECIAIS', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS NAS LIQUIDACOES DOS CREDITOS DE OPERACOES ESPECIAIS, A CURTO PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.05.02', '(-) AJUSTE DE PERDAS EM EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIARIOS', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.05.99', '(-) OUTROS AJUSTES DE PERDAS EM EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS EM DEMAIS EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, NAO CLASSIFICADAS ANTERIORMENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.01.00', '(-) AJUSTE DE PERDAS DE CREDITOS DE LIQUIDACAO DUVIDOSA', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.02.00', '(-) AJUSTE DE PERDAS DE CREDITOS TRIBUTARIOS', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.03.00', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA TRIBUTARIA', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.04.00', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.05.01', '(-) AJUSTE DE PERDAS EM OPERACOES ESPECIAIS', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS NAS LIQUIDACOES DOS CREDITOS DE OPERACOES ESPECIAIS, A CURTO PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.05.02', '(-) AJUSTE DE PERDAS EM EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIARIOS', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.05.99', '(-) OUTROS AJUSTES DE PERDAS EM EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS EM DEMAIS EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, NAO CLASSIFICADAS ANTERIORMENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.01.00', '(-) AJUSTE DE PERDAS DE CREDITOS DE LIQUIDACAO DUVIDOSA', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.02.00', '(-) AJUSTE DE PERDAS DE CREDITOS TRIBUTARIOS', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.03.00', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA TRIBUTARIA', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.04.00', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.05.01', '(-) AJUSTE DE PERDAS EM OPERACOES ESPECIAIS', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS NAS LIQUIDACOES DOS CREDITOS DE OPERACOES ESPECIAIS, A CURTO PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.05.02', '(-) AJUSTE DE PERDAS EM EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIARIOS', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.05.99', '(-) OUTROS AJUSTES DE PERDAS EM EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS EM DEMAIS EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, NAO CLASSIFICADAS ANTERIORMENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.01', '13 SALARIO - ADIANTAMENTO', 'REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE AO 13 SALARIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.02', '1/3 DE FERIAS - ADIANTAMENTO', 'REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A 1/3 DE FERIAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.03', 'VIAGENS - ADIANTAMENTO', 'REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A VIAGENS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.04', 'ASSISTENCIA MEDICA - ADIANTAMENTO', 'REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A ASSISTENCIA MEDICA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.05', 'SALARIOS E ORDENADOS - ADIANTAMENTO', 'REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A SALARIOS E ORDENADOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.06', 'BENEFICIOS ADMINISTRADOS P/INSS-ANTECIPACAO', 'REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE AS DESPESAS ANTECIPADAS PELO INSS AOS SEGURADOS NA FORMA DISPOSTA NO DECRETO 7.223/2010.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.99', 'OUTROS ADIANTAMENTOS CONCEDIDOS A PESSOAL', 'REGISTRA OUTROS ADIANTAMENTOS CONCEDIDOS A PESSOAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.02.00', 'SUPRIMENTO DE FUNDOS', 'REGISTRA OS VALORES DE SUPRIMENTO DE FUNDOS POR MEIO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.03.01', 'ADIANTAMENTOS PARA OPERACOES ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS AOS ADIANTAMENTOS DE RECURSOS FINANCEIROS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE PELO MINISTERIO DAS RELACOES EXTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.03.02', 'ADIANTAMENTOS CONCEDIDOS AO INSS', 'REGISTRA OS RECURSOS A RECEBER DE ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA - COFIN/STN PARA TRANSFERENCIA DE PASSIVOS PARA O INSS EM DECORRENCIA DE ARRECADACAO POR DARF. A CONTA SERA UTILIZADA QUANDO O VALOR A TRANSFERIR FOR MAIOR QUE O VALOR ARRECADADO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.03.03', 'ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA A DEMAIS UNIDADES', 'REGISTRA OS RECURSOS A RECEBER DE ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA - COFIN/STN PARA OUTRAS UNIDADES, EXCETO INSS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.03.99', 'OUTROS ADIANTAMENTOS A UNIDADES E ENTIDADES', 'REGISTRA OUTROS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.04.00', 'ADIANTAMENTOS DE TRANSFERENCIAS VOLUNTARIAS', 'REGISTRA OS VALORES RELATIVOS A ADIANTAMENTOS DE RECURSOS FINANCEIROS FORMALIZADOS POR TRANSFERENCIAS VOLUNTARIAS GERADAS A PARTIR DA INTEGRACAO DO PORTAL SICONV COM O SIAFI.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.05.00', 'ADIANTAMENTOS A PRESTADORES DE SERVICOS', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A PRESTADORES DE SERVICOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVICOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.99.00', 'ADIANTAMENTOS DIVERSOS CONCEDIDOS', 'REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NAO CLASSIFICADOS EM CONTAS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.2.03.01', 'ADIANTAMENTOS PARA OPERACOES ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS AOS ADIANTAMENTOS DE RECURSOS FINANCEIROS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE PELO MINISTERIO DAS RELACOES EXTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.2.03.02', 'ADIANTAMENTOS CONCEDIDOS AO INSS', 'REGISTRA OS RECURSOS A RECEBER DE ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA - COFIN/STN PARA TRANSFERENCIA DE PASSIVOS PARA O INSS EM DECORRENCIA DE ARRECADACAO POR DARF. A CONTA SERA UTILIZADA QUANDO O VALOR A TRANSFERIR FOR MAIOR QUE O VALOR ARRECADADO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.2.03.03', 'ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA A DEMAIS UNIDADES', 'REGISTRA OS RECURSOS A RECEBER DE ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA - COFIN/STN PARA OUTRAS UNIDADES, EXCETO INSS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.2.03.99', 'OUTROS ADIANTAMENTOS A UNIDADES E ENTIDADES', 'REGISTRA OUTROS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.2.04.00', 'ADIANTAMENTOS DE TRANSFERENCIAS VOLUNTARIAS', 'REGISTRA OS VALORES RELATIVOS A ADIANTAMENTOS DE RECURSOS FINANCEIROS FORMALIZADOS POR TRANSFERENCIAS VOLUNTARIAS GERADAS A PARTIR DA INTEGRACAO DO PORTAL SICONV COM O SIAFI.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.2.05.00', 'ADIANTAMENTOS A PRESTADORES DE SERVICOS', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A PRESTADORES DE SERVICOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVICOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.2.99.00', 'ADIANTAMENTOS DIVERSOS CONCEDIDOS', 'REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NAO CLASSIFICADOS EM CONTAS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.4.03.01', 'ADIANTAMENTOS PARA OPERACOES ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS AOS ADIANTAMENTOS DE RECURSOS FINANCEIROS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE PELO MINISTERIO DAS RELACOES EXTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.4.03.02', 'ADIANTAMENTOS CONCEDIDOS AO INSS', 'REGISTRA OS RECURSOS A RECEBER DE ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA - COFIN/STN PARA TRANSFERENCIA DE PASSIVOS PARA O INSS EM DECORRENCIA DE ARRECADACAO POR DARF. A CONTA SERA UTILIZADA QUANDO O VALOR A TRANSFERIR FOR MAIOR QUE O VALOR ARRECADADO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.4.03.03', 'ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA A DEMAIS UNIDADES', 'REGISTRA OS RECURSOS A RECEBER DE ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA - COFIN/STN PARA OUTRAS UNIDADES, EXCETO INSS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.4.03.99', 'OUTROS ADIANTAMENTOS A UNIDADES E ENTIDADES', 'REGISTRA OUTROS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.4.04.00', 'ADIANTAMENTOS DE TRANSFERENCIAS VOLUNTARIAS', 'REGISTRA OS VALORES RELATIVOS A ADIANTAMENTOS DE RECURSOS FINANCEIROS FORMALIZADOS POR TRANSFERENCIAS VOLUNTARIAS GERADAS A PARTIR DA INTEGRACAO DO PORTAL SICONV COM O SIAFI.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.4.05.00', 'ADIANTAMENTOS A PRESTADORES DE SERVICOS', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A PRESTADORES DE SERVICOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVICOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.4.99.00', 'ADIANTAMENTOS DIVERSOS CONCEDIDOS', 'REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NAO CLASSIFICADOS EM CONTAS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.5.03.01', 'ADIANTAMENTOS PARA OPERACOES ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS AOS ADIANTAMENTOS DE RECURSOS FINANCEIROS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE PELO MINISTERIO DAS RELACOES EXTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.5.03.02', 'ADIANTAMENTOS CONCEDIDOS AO INSS', 'REGISTRA OS RECURSOS A RECEBER DE ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA - COFIN/STN PARA TRANSFERENCIA DE PASSIVOS PARA O INSS EM DECORRENCIA DE ARRECADACAO POR DARF. A CONTA SERA UTILIZADA QUANDO O VALOR A TRANSFERIR FOR MAIOR QUE O VALOR ARRECADADO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.5.03.03', 'ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA A DEMAIS UNIDADES', 'REGISTRA OS RECURSOS A RECEBER DE ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA - COFIN/STN PARA OUTRAS UNIDADES, EXCETO INSS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.5.03.99', 'OUTROS ADIANTAMENTOS A UNIDADES E ENTIDADES', 'REGISTRA OUTROS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.5.04.00', 'ADIANTAMENTOS DE TRANSFERENCIAS VOLUNTARIAS', 'REGISTRA OS VALORES RELATIVOS A ADIANTAMENTOS DE RECURSOS FINANCEIROS FORMALIZADOS POR TRANSFERENCIAS VOLUNTARIAS GERADAS A PARTIR DA INTEGRACAO DO PORTAL SICONV COM O SIAFI.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.5.05.00', 'ADIANTAMENTOS A PRESTADORES DE SERVICOS', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A PRESTADORES DE SERVICOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVICOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.5.99.00', 'ADIANTAMENTOS DIVERSOS CONCEDIDOS', 'REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NAO CLASSIFICADOS EM CONTAS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.01.00', 'IPI A RECUPERAR/ COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IPI A RECUPERAR/ COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.02.00', 'ICMS A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DE ICMS A RECUPERAR/ COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.03.00', 'ICMS DIFERIDO', 'REGISTRA O VALOR DO ICMS DIFERIDO DOS ESTOQUES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.04.00', 'IRRF A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IR RETIDO NA FONTE A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.05.00', 'IR E CSLL A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IR E DA CSLL A RECUPERAR/ COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.06.00', 'IR E CSLL DIFERIDOS', 'REGISTRA A PARCELA DO IR E CSLL QUE REPRESENTA A DIFERENCA ENTRE OS VALORES DE LUCRO APURADOS SEGUNDO AS NORMAS FISCAIS E O REGIME DE COMPETENCIA, QUANDO ESTES FOREM MENORES E AS DIFERENCAS FOREM TEMPORARIAS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.07.00', 'ISS A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO ISS A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.08.00', 'IPVA A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IPVA A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.09.00', 'IPTU A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IPTU A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.10.00', 'ITR A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO ITR A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.11.00', 'INSS A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO INSS A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.12.00', 'PSS A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO PSS A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.13.00', 'COFINS A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DA COFINS A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.14.00', 'PIS/PASEP A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO PIS/PASEP A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.99.00', 'OUTROS TRIBUTOS A RECUPERAR / COMPENSAR', 'COMPREENDE O SOMATORIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR/ COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.2.01.00', 'IPI A RECUPERAR/ COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IPI A RECUPERAR/ COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.2.04.00', 'IRRF A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IR RETIDO NA FONTE A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.2.05.00', 'IR E CSLL A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IR E DA CSLL A RECUPERAR/ COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.2.06.00', 'IR E CSLL DIFERIDOS', 'REGISTRA A PARCELA DO IR E CSLL QUE REPRESENTA A DIFERENCA ENTRE OS VALORES DE LUCRO APURADOS SEGUNDO AS NORMAS FISCAIS E O REGIME DE COMPETENCIA, QUANDO ESTES FOREM MENORES E AS DIFERENCAS FOREM TEMPORARIAS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.2.10.00', 'ITR A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO ITR A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.2.11.00', 'INSS A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO INSS A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.2.12.00', 'PSS A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO PSS A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.2.13.00', 'COFINS A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DA COFINS A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.2.14.00', 'PIS/PASEP A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO PIS/PASEP A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.2.99.00', 'OUTROS TRIBUTOS A RECUPERAR / COMPENSAR', 'COMPREENDE O SOMATORIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR/ COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.4.02.00', 'ICMS A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DE ICMS A RECUPERAR/ COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.4.03.00', 'ICMS DIFERIDO', 'REGISTRA O VALOR DO ICMS DIFERIDO DOS ESTOQUES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.4.08.00', 'IPVA A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IPVA A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.4.99.00', 'OUTROS TRIBUTOS A RECUPERAR / COMPENSAR', 'COMPREENDE O SOMATORIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR/ COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.5.07.00', 'ISS A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO ISS A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.5.09.00', 'IPTU A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IPTU A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.5.10.00', 'ITR A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO ITR A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.5.99.00', 'OUTROS TRIBUTOS A RECUPERAR / COMPENSAR', 'COMPREENDE O SOMATORIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR/ COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.3.1.01.01', 'TAXAS DE FISCALIZACAO DO FISTEL', 'REGISTRA OS VALORES A RECEBER REFERENTES AS TAXAS DE FISCALIZACAO DO FISTEL, TAIS COMO TAXAS DE INSTALACAO - TFI, TAXAS DE FUNCIONAMENTO - TFF, ACRESCIMOS MORATORIOS DAS TAXAS DE FISCALIZACAO DO FISTEL E OUTRAS CORRELATAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.3.1.01.02', 'CREDITOS POR DESCENTRALIZACAO DE SERVICOS DE TELECOMUNICACOES', 'REGISTRA OS VALORES A RECEBER REFERENTES A EXPLORACAO DE SERVICOS DE TELECOMUNICACOES, COMO COMUNICACAO DE MASSA, RADIODIFUSAO, DIREITOS DE USO DE RADIOFREQUENCIA, MULTAS PREVISTAS NA LEI GERAL DAS TELECOMUNICACOES (LGT), JUROS DE TITULOS DE RENDA, CERTIFICACAO DE PRODUTOS, INFORMACOES CIENTIFICAS E TECNOLOGICAS, REGULACAO DA EXPLORACAO DOS SERVICOS E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.3.1.01.03', 'CONTRIBUICAO SOBRE RECEITA DE SERVICOS DE TELECOMUNICACOES', 'REGISTRA OS VALORES A RECEBER REFERENTES AOS VALORES DAS CONTRIBUICOES DEVIDAS PELAS EMPRESAS QUE PRESTAM SERVICOS DE TELECOMUNICACOES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.3.1.02.00', 'CREDITOS A RECEBER POR DESCENTRALIZACAO DE SERVICOS DE TRANSPORTE PUBLICO', 'REGISTRA OS CREDITOS A RECEBER DECORRENTES DA DESCENTRALIZACAO DA PRESTACAO DE SERVICOS DE TRANSPORTE PUBLICO NAS FORMAS DE OUTORGA A ENTIDADES DA ADMINISTRACAO INDIRETA, CONCESSAO, PERMISSAO OU AUTORIZACAO AO PARTICULAR, O QUAL ESTA SUJEITO AO CONTROLE, FISCALIZACAO E REGULACAO DO PODER PUBLICO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.3.1.99.00', 'OUTROS CREDITOS A RECEBER POR DESCENTRALIZACAO DE SERVICOS PUBLICOS', 'REGISTRA OS CREDITOS A RECEBER DECORRENTES DA DESCENTRALIZACAO DA PRESTACAO DE SERVICOS PUBLICOS NAO CLASSIFICADOS NAS CONTAS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.01.01', 'CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITOS ADMINISTRATIVOS DECORRENTES DE FOLHA DE PAGAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.01.02', 'CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.01.03', 'CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.01.04', 'CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.01.05', 'CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL', 'REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NAO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELEIDO EM NORMAS LEGAIS OU DETERMINACAO ADMINISTRATIVA OU SEJA, QUANDO O PRODUTO A ARRECADAR NAO TENHA SIDO RECOLHIDO NO PRAZO LEGAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.01.06', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.01.07', 'MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS', 'REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO, POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.01.08', 'CREDITOS A RECEBER POR USO INDEVIDO DE COTA', 'REGISTRA OS DEBITOS (APURADOS E EM APURACAO) DE PARLAMENTARES EM RAZAO DE RECEBIMENTO INDEVIDO DE VALOR RELACIONADO A COTA DESTINA A CUSTEAR GASTOS VINCULADOS AO EXERCICIO DE ATIVIDADE PARLAMENTAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.01.09', 'CREDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL', 'REGISTRA OS DEBITOS (APURADOS E EM APURACAO) REFERENTES A DEBITOS DE PARLAMENTARES CONHECIDOS APOS SEU AFASTAMENTO DO MANDADO E QUE NAO PUDERAM SER DESCONTADOS EM FOLHA DE PAGAMENTO. EXEMPLOS: REMANESCENTE DE CONTA DE ENERGIA ELETRICA, GAS, TAXA DE LIMPEZA PUBLICA E ALUGUEIS DE OUTROS BENS IMOVEIS PERTENCENTE AO ORGAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.01.10', 'CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE CONTAS ESPECIAL).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.01.11', 'FALTA OU IRREGULARIDADE DE COMPROVACAO', 'REGISTRA A APROPRIACAO DE DIREITOS DECORRENTES DE ADIANTAMENTOS A UNIDADES E ENTIDADES NOS CASOS EM QUE HOUVE OMISSAO NO DEVER DE PRESTAR CONTAS E/OU PRESTACAO DE CONTAS COM IMPROPRIEDADES/IRREGULARIDADES. ESTA CONTA SERA UTILIZADA QUANDO NAO HOUVER NECESSIDADE DE INSTAURACAO DE TCE, CONFORME DEFINIDO NA MACROFUNCAO 021138.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.01.99', 'OUTROS CREDITOS ADMINISTRATIVOS', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.01', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.02', 'CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES, NAO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU DETERMIMANACAO ADMINISTRATIVA, OU SEJA, QUANDO O PRODUTO A ARRECADAR NAO TENHA SIDO RECOLHIDO NO PRAZO LEGAL.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.03', 'CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.04', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.05', 'CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS AFAZENDA NACIONAL SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.06', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.07', 'CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.08', 'CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTACAO APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.09', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE LICITACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.10', 'MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO, POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE .(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.11', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM A UNIAO. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.12', 'CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIA SOCIAL, COM A RESPONSABILIDADE DEVIDAMENTE APURADA E IMPUTADA A SERVIDORES OU TERCEIROS (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.13', 'CREDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.14', 'CREDITOS A RECEBER POR USO INDEVIDO DE COTA - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DEBITOS (APURADOS E EM APURACAO) DE PARLAMENTARES EM RAZAO DE RECEBIMENTO INDEVIDO DE VALOR RELACIONADO A COTA DESTINA A CUSTEAR GASTOS VINCULADOS AO EXERCICIO DE ATIVIDADE PARLAMENTAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.15', 'CREDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DEBITOS (APURADOS E EM APURACAO) REFERENTES A DEBITOS DE PARLAMENTARES CONHECIDOS APOS SEU AFASTAMENTO DO MANDADO E QUE NAO PUDERAM SER DESCONTADOS EM FOLHA DE PAGAMENTO. EXEMPLOS: REMANESCENTE DE CONTA DE ENERGIA ELETRICA, GAS, TAXA DE LIMPEZA PUBLICA E ALUGUEIS DE OUTROS BENS IMOVEIS PERTENCENTE AO ORGAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.16', 'RECEBIMENTO INDEVIDO DE SALARIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR RECEBIMENTO INDEVIDO DE SALARIOS,DECORRENTE DE AUSENCIAS INJUSTIFICADAS E CASOS SEMELHANTES (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.99', 'OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.03.00', 'CREDITOS POR DANOS AO PATRIMONIO APURADOS EM PROCESSOS JUDICIAIS', 'REGISTRA OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS JUDICIAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.01.02', 'CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.01.03', 'CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.01.04', 'CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.01.06', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.01.10', 'CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE CONTAS ESPECIAL).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.01.11', 'FALTA OU IRREGULARIDADE DE COMPROVACAO', 'REGISTRA A APROPRIACAO DE DIREITOS DECORRENTES DE ADIANTAMENTOS A UNIDADES E ENTIDADES NOS CASOS EM QUE HOUVE OMISSAO NO DEVER DE PRESTAR CONTAS E/OU PRESTACAO DE CONTAS COM IMPROPRIEDADES/IRREGULARIDADES. ESTA CONTA SERA UTILIZADA QUANDO NAO HOUVER NECESSIDADE DE INSTAURACAO DE TCE, CONFORME DEFINIDO NA MACROFUNCAO 021138.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.01.99', 'OUTROS CREDITOS ADMINISTRATIVOS', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.02.01', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.02.03', 'CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.02.04', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.02.05', 'CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS AFAZENDA NACIONAL SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.02.06', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.02.07', 'CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.02.08', 'CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTACAO APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.02.09', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE LICITACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.02.11', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM A UNIAO. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.02.12', 'CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIA SOCIAL, COM A RESPONSABILIDADE DEVIDAMENTE APURADA E IMPUTADA A SERVIDORES OU TERCEIROS (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.02.13', 'CREDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.02.99', 'OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.03.00', 'CREDITOS POR DANOS AO PATRIMONIO APURADOS EM PROCESSOS JUDICIAIS', 'REGISTRA OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS JUDICIAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.01.02', 'CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.01.03', 'CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.01.04', 'CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.01.06', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.01.10', 'CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE CONTAS ESPECIAL).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.01.11', 'FALTA OU IRREGULARIDADE DE COMPROVACAO', 'REGISTRA A APROPRIACAO DE DIREITOS DECORRENTES DE ADIANTAMENTOS A UNIDADES E ENTIDADES NOS CASOS EM QUE HOUVE OMISSAO NO DEVER DE PRESTAR CONTAS E/OU PRESTACAO DE CONTAS COM IMPROPRIEDADES/IRREGULARIDADES. ESTA CONTA SERA UTILIZADA QUANDO NAO HOUVER NECESSIDADE DE INSTAURACAO DE TCE, CONFORME DEFINIDO NA MACROFUNCAO 021138.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.01.99', 'OUTROS CREDITOS ADMINISTRATIVOS', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.02.01', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.02.03', 'CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.02.04', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.02.05', 'CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS AFAZENDA NACIONAL SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.02.06', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.02.07', 'CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.02.08', 'CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTACAO APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.02.09', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE LICITACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.02.11', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM A UNIAO. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.02.12', 'CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIA SOCIAL, COM A RESPONSABILIDADE DEVIDAMENTE APURADA E IMPUTADA A SERVIDORES OU TERCEIROS (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.02.13', 'CREDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.02.99', 'OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.03.00', 'CREDITOS POR DANOS AO PATRIMONIO APURADOS EM PROCESSOS JUDICIAIS', 'REGISTRA OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS JUDICIAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.01.02', 'CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.01.03', 'CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.01.04', 'CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.01.06', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.01.10', 'CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE CONTAS ESPECIAL).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.01.11', 'FALTA OU IRREGULARIDADE DE COMPROVACAO', 'REGISTRA A APROPRIACAO DE DIREITOS DECORRENTES DE ADIANTAMENTOS A UNIDADES E ENTIDADES NOS CASOS EM QUE HOUVE OMISSAO NO DEVER DE PRESTAR CONTAS E/OU PRESTACAO DE CONTAS COM IMPROPRIEDADES/IRREGULARIDADES. ESTA CONTA SERA UTILIZADA QUANDO NAO HOUVER NECESSIDADE DE INSTAURACAO DE TCE, CONFORME DEFINIDO NA MACROFUNCAO 021138.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.01.99', 'OUTROS CREDITOS ADMINISTRATIVOS', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.02.01', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.02.03', 'CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.02.04', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.02.05', 'CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS AFAZENDA NACIONAL SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.02.06', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.02.07', 'CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.02.08', 'CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTACAO APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.02.09', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE LICITACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.02.11', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM A UNIAO. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.02.12', 'CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIA SOCIAL, COM A RESPONSABILIDADE DEVIDAMENTE APURADA E IMPUTADA A SERVIDORES OU TERCEIROS (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.02.13', 'CREDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.02.99', 'OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.03.00', 'CREDITOS POR DANOS AO PATRIMONIO APURADOS EM PROCESSOS JUDICIAIS', 'REGISTRA OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS JUDICIAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.01.00', 'DEPOSITOS E CAUCOES EFETUADOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES EFETUADOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.02.00', 'DEPOSITOS E CAUCOES RECEBIDOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES RECEBIDOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.03.00', 'DEPOSITOS JUDICIAIS EFETUADOS', 'REGISTRA OS VALORES DECORRENTES DE DEPOSITOS EFETUADOS PELA ENTIDADE POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.04.00', 'DEPOSITOS JUDICIAIS RECEBIDOS', 'REGISTRA OS VALORES DECORRENTES DE DEPOSITOS RECEBIDOS PELA ENTIDADE POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.05.00', 'DEPOSITOS EFETUADOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS EFETUADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.06.00', 'DEPOSITOS RECEBIDOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS RECEBIDOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.07.00', 'DEPOSITOS ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.08.00', 'VALORES APREENDIDOS POR DECISAO JUDICIAL', 'REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.09.00', 'DEPOSITOS TRANSFERIDOS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS TRANSFERIDOS, PARA GARANTIA DE OPERACOES ESPECIFICAS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.10.00', 'DEMAIS DEPOSITOS DO INSS', 'REGISTRA OS VALORES DE OUTROS DEPOSITOS DO INSS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.01', 'DEPOSITOS ESPECIAIS DO FAT - PROGER URBANO NO BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL CORRESPONDENTES AO PROGRAMA PROGER URBANO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.02', 'DEPOSITOS ESPECIAIS DO FAT - PROGER RURALNO BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL CORRESPONDENTES AO PROGRAMA PROGER RURAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.03', 'DEPOSITOS ESPECIAIS DO FAT - PRONAF NO BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL CORRESPONDENTES AO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR DO MINISTERIO DO DESENVOLVIMENTO AGRARIO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.04', 'DEPOSITOS ESPECIAIS DO FAT - BENS DE CONSUMO DURAVEIS NO BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL, DESTINADOS AO FINANCIAMENTO DA LINHA DE CREDITO EMERGENCIAL E TEMPORARIA PARA AQUISICAO DE BENS DE CONSUMO DURAVEIS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.05', 'DEPOSITOS ESPECIAIS DO FAT - HABITACAO NO BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL CORRESPONDENTE A PROJETOS HABITACIONAIS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.06', 'DEPOSITOS ESPECIAIS DO FAT - INTEGRAR (FCO) NO BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL, APLICADOS NO PROGRAMA FAT INTEGRAR (FCO).', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.07', 'DEPOSITOS ESPECIAIS DO FAT - EXPORTAR NO BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL, REFERENTES AO PROGRAMA FAT EXPORTAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.08', 'DEPOSITOS ESPECIAIS DO FAT - INFRA- ESTRUTURA -BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL, CORRESPONDENTE AO PROGRAMA FAT - INFRA-ESTRUTURA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.09', 'DEPOSITOS ESPECIAIS DO FAT - PNMPO NO BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL, CORRESPONDENTE AO PROGRAMA NACIONAL DE MICROCREDITO PRODUTIVO ORIENTADO-PNMPO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.10', 'DEPOSITOS ESPECIAIS DO FAT - GIRO -RURAL NO BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL S/A., CORRESPONDENTES AO PROGRAMA GIRO-RURAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.11', 'DEPOSITOS ESPECIAIS DO FAT - INCLUSAO-DIGITAL NO BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL S/A., CORRESPONDENTES AO PROGRAMA FAT - INCLUSAO -DIGITAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.12', 'DEPOSITOS ESPECIAIS DO FAT - FOMENTAR - MGE NO BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL S/A., CORRESPONDENTES AO PROGRAMA FAT - FOMENTAR - MGE.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.13', 'DEPOSITOS ESPECIAIS DO FAT - GIRO SETORIAL - MGE NO BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL S/A., CORRESPONDENTES AO PROGRAMA FAT - GIRO SETORIAL - MGE.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.14', 'DEPOSITOS ESPECIAIS DO FAT - GIRO COOPERATIVO - AGROPECUARIO NO BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL S/A, CORRESPONDENTE AO PROGRAMA FAT - GIRO COOPERATIVO AGRO-PECUARIO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.15', 'DEPOSITOS ESPECIAIS DO FAT - TURISMO SENIOR NO BANCO DO BRASIL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL S/A, CORRESPONDENTES AA LINHA DE CREDITO ESPECIAL FAT - TURISMO SENIOR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.12.01', 'DEPOSITOS ESPECIAIS DO FAT - PROGER URBANO NO BANCO DO NORDESTE', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO DO NORDESTE S/A CORRESPONDENTES AO PROGRAMA PROGER URBANO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.12.02', 'DEPOSITOS ESPECIAIS DO FAT - PROGER RURAL NO BANCO DO NORDESTE', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE S/A, CORRESPONDENTE AO PROGRAMA PROGER RURAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.12.03', 'DEPOSITOS ESPECIAIS DO FAT - PRONAF NO BANCO DO NORDESTE', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE S/A CORRESPONDENTE AO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR DO MINISTERIO DO DESENVOLVIMENTO AGRARIO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.12.04', 'DEPOSITOS ESPECIAIS DO FAT - PROTRABALHO NO BANCO DO NORDESTE', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE S/A CORRESPONDENTE AO PROGRAMA PROTRABALHO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.12.05', 'DEPOSITOS ESPECIAIS DO FAT - ESTIAGEM NO BANCO DO NORDESTE', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE S/A PARA PROJETOS QUE VISEM ATENDIMENTO AS ESTIAGENS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.12.06', 'DEPOSITOS ESPECIAIS DO FAT - INFRA-ESTRUTURA NO BANCO DO NORDESTE', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE S/A, CORRESPONDENTES AO PROGRAMA FAT - INFRA-ESTRUTURA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.12.07', 'DEPOSITOS ESPECIAIS DO FAT - PNMPO NO BANCO DO NORDESTE', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE S/A, CORRESPONDENTES AO PROGRAMA NACIONAL DE MICROCREDITO PRODUTIVO ORIENTADO - PNMPO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.12.08', 'DEPOSITOS ESPECIAIS DO FAT - INCLUSAO-DIGITAL NO BANCO DO NORDESTE', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE DO BRASIL, CORRESPONDENTES AO PROGRAMA FAT - INCLUSAO - DIGITAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.13.01', 'DEPOSITOS ESPECIAIS DO FAT - PROEMPREGO NO BNDES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL CORRESPONDENTES AO PROGRAMA PROEMPREGO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.13.02', 'DEPOSITOS ESPECIAIS DO FAT- MICROCREDITO NO BNDES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DE DESENVOLVIMENTO ECONOMICO E SOCIAL - BNDES, PARA A CONCESSAO DE CREDITO PARA NEGOCIOS DE PEQUENO PORTE', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.13.03', 'DEPOSITOS ESPECIAIS DO FAT-PRONAF - NO BNDES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL - BNDES, CORRESPONDENTE AO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR DO MINISTERIO DO DESENVOLVIMENTO AGRARIO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.13.04', 'DEPOSITOS ESPECIAIS DO FAT - INFRA-ESTRUTURA NO BNDES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL- BNDES, CORRESPONDENTES AO PROGRAMA FAT - INFRA-ESTRUTURA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.13.05', 'DEPOSITOS ESPECIAIS DO FAT - FOMENTAR NO BNDES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL CORRESPONDENTES AO PROGRAMA FAT FOMENTAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.13.06', 'DEPOSITOS ESPECIAIS DO FAT - EXPORTAR NO BNDES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL CORRESPONDENTES AO PROGRAMA FAT EXPORTAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.13.07', 'DEPOSITOS ESPECIAIS DO FAT - PNMPO NO BNDES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL-BNDES, CORRESPONDENTES AO PROGRAMA NACIONAL DE MICROCREDITO PRODUTIVO ORIENTADO - PNMPO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.13.08', 'DEPOSITOS ESPECIAIS DO FAT - GIRO-RURAL NO BNDES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL-BNDES, CORRESPONDENTES AO PROGRAMA GIRO-RURAIS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.13.09', 'DEPOSITOS ESPECIAIS DO FAT - INCLUSAO-DIGITAL NO BNDES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL-BNDES, CORRESPONDENTES AO PROGRAMA FAT - DIGITAL - INCLUSAO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.14.01', 'DEPOSITOS ESPECIAIS DO FAT - PROGER URBANO NA CEF', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL - CEF - CORRESPONDENTE AO PROGRAMA PROGER URBANO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.14.02', 'DEPOSITOS ESPECIAIS DO FAT - HABITACAO NA CEF', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL - CEF - CORRESPONDENTE A PROJETOS HABITACIONAIS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.14.03', 'DEPOSITOS ESPECIAIS DO FAT - BENS DE CONSUMO DURAVEIS NA CEF', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, DESTINADOS AO FINANCIAMENTO DA LINHA DE CREDITO EMERGENCIAL E TEMPORARIA PARA AQUISICAO DE BENS DE CONSUMO DURAVEIS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.14.04', 'DEPOSITOS ESPECIAIS DO FAT - REVITALIZACAO NA CEF', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, APLICADOS NO PROGRAMA FAT REVITALIZACAO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.14.05', 'DEPOSITOS ESPECIAIS DO FAT - EXPORTAR NA CEF', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FUNDO DE AMPARO AO TRABALHADOR -FAT, NA CAIXA ECONOMICA FEDERAL, REFERENTES AO PROGRAMA FAT EXPORTAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.14.06', 'DEPOSITOS ESPECIAIS DO FAT - INFRA-ESTRUTURA NA CEF', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, CORRESPONDENTES AO PROGRAMA FAT - INFRA-ESTRUTURA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.14.07', 'DEPOSITOS ESPECIAIS DO FAT - PNMPO NA CEF', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, CORRESPONDENTES AO PROGRAMA NACIONAL DE MICROCREDITO PRODUTIVO ORIENTADO - PNMPO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.14.08', 'DEPOSITOS ESPECIAIS DO FAT - INCLUSAO-DIGITAL NA CEF', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, CORRESPONDENTES AO PROGRAMA FAR - INCLUSAO - DIGITAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.14.09', 'DEPOSITOS ESPECIAIS DO FAT - VILA-PANAMERICANA NA CEF', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, CORRESPONDENTES AO PROGRAMA FAR - VILA - PAN AMERICANA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.14.10', 'DEPOSITOS ESPECIAIS DO FAT - GIRO-SETORIAL NA CEF', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, CORRESPONDENTES AO PROGRAMA FAT- GIRO - SETORIAL, DESTINADOS A FINANCIAR CAPITAL DE GIRO PARA EMPRESAS INDUSTRIAIS EXPORTADORAS, INTENSIVAS EM MAO-DE-OBRA, PROPORCIONANDO GERACAO OU MANUTENCAO DE EMPREGO E RENDA, CONFORME RESOLUCAO CODE FAT N. 493, DE 15/05/2006.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.14.11', 'DEPOSITOS ESPECIAIS DO FAT - TURISMO SENIOR NA CEF', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, CORRESPONDENTES A LINHA DE CREDITO ESPECIAL FAT- TURISMO SENIOR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.15.01', 'DEPOSITOS ESPECIAIS DO FAT - PMC NA FINANCIADORA DE ESTUDOS E PROJETOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA FINEP - FINANCIADORA DE ESTUDOS E PROJETOS CORRESPONDENTES AO PROGRAMA PARA MELHORIA DA COMPETITIVIDADE (FAT - PMC).', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.15.02', 'DEPOSITOS ESPECIAIS DO FAT - PRO-INOVACAO NA FINANCIADORA DE ESTUDOS E PROJETOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA FINEP FINANCIADORA DE ESTUDOS E PROJETOS CORRESPONDENTES AO PROGRAMA FAT PRO- INOVACAO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.16.01', 'DEPOSITOS ESPECIAIS DO FAT - PROGER URBANO NO BANCO DA AMAZONIA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA, CORRESPONDENTES AO PROGRAMA PROGER URBANO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.16.02', 'DEPOSITOS ESPECIAIS DO FAT - PROGER TURISMO NO BANCO DA AMAZONIA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA, CORRESPONDENTES AO PROGRAMA PROGER TURISMO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.16.03', 'DEPOSITOS ESPECIAIS DO FAT - PROGER RURAL NO BANCO DA AMAZONIA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA, CORRESPONDENTES AO PROGRAMA PROGER RURAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.16.04', 'DEPOSITOS ESPECIAIS DO FAT - PRONAF - NO BANCO DA AMAZONIA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA, CORRESPONDENTES AO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR DO MINISTERIO DO DESENVOLVIMENTO AGRARIO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.16.05', 'DEPOSITOS ESPECIAIS DO FAT - RURAL NO BANCO DA AMAZONIA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA, CORRESPONDENTES AO PROGRAMA FAT RURAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.16.06', 'DEPOSITOS ESPECIAIS DO FAT - INFRA-ESTRUTURA NO BANCO DA AMAZONIA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA - BASA, CORRESPONDENTES AO PROGRAMA FAT - INFRA-ESTRUTURA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.16.07', 'DEPOSITOS ESPECIAIS DO FAT - PNMPO NO BANCO DA AMAZONIA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA - BASA, CORRESPONDENTES AO PROGRAMA NACIONAL DE MICROCREDITO PRODUTIVO ORIENTADO - PNMPO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.16.08', 'DEPOSITOS ESPECIAIS DO FAT - INTEGRAR-NORTE NO BANCO DA AMAZONIA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA - BASA, CORRESPONDENTES AO PROGRAMA INTEGRAR-NORTE.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.16.09', 'DEPOSITOS ESPECIAIS DO FAT - INCLUSAO-DIGITAL NO BANCO DA AMAZONIA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA - BASA, CORRESPONDENTES AO PROGRAMA FAT - INCLUSAO - DIGITAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.99.00', 'OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.01.00', 'DEPOSITOS E CAUCOES EFETUADOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES EFETUADOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.02.00', 'DEPOSITOS E CAUCOES RECEBIDOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES RECEBIDOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.03.00', 'DEPOSITOS JUDICIAIS EFETUADOS', 'REGISTRA OS VALORES DECORRENTES DE DEPOSITOS EFETUADOS PELA ENTIDADE POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.04.00', 'DEPOSITOS JUDICIAIS RECEBIDOS', 'REGISTRA OS VALORES DECORRENTES DE DEPOSITOS RECEBIDOS PELA ENTIDADE POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.05.00', 'DEPOSITOS EFETUADOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS EFETUADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.06.00', 'DEPOSITOS RECEBIDOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS RECEBIDOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.07.00', 'DEPOSITOS ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.08.00', 'VALORES APREENDIDOS POR DECISAO JUDICIAL', 'REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.09.00', 'DEPOSITOS TRANSFERIDOS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS TRANSFERIDOS, PARA GARANTIA DE OPERACOES ESPECIFICAS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.10.00', 'DEMAIS DEPOSITOS DO INSS', 'REGISTRA OS VALORES DE OUTROS DEPOSITOS DO INSS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.99.00', 'OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.01.00', 'DEPOSITOS E CAUCOES EFETUADOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES EFETUADOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.02.00', 'DEPOSITOS E CAUCOES RECEBIDOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES RECEBIDOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.03.00', 'DEPOSITOS JUDICIAIS EFETUADOS', 'REGISTRA OS VALORES DECORRENTES DE DEPOSITOS EFETUADOS PELA ENTIDADE POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.04.00', 'DEPOSITOS JUDICIAIS RECEBIDOS', 'REGISTRA OS VALORES DECORRENTES DE DEPOSITOS RECEBIDOS PELA ENTIDADE POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.05.00', 'DEPOSITOS EFETUADOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS EFETUADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.06.00', 'DEPOSITOS RECEBIDOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS RECEBIDOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.07.00', 'DEPOSITOS ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.08.00', 'VALORES APREENDIDOS POR DECISAO JUDICIAL', 'REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.09.00', 'DEPOSITOS TRANSFERIDOS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS TRANSFERIDOS, PARA GARANTIA DE OPERACOES ESPECIFICAS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.10.00', 'DEMAIS DEPOSITOS DO INSS', 'REGISTRA OS VALORES DE OUTROS DEPOSITOS DO INSS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.99.00', 'OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.01.00', 'DEPOSITOS E CAUCOES EFETUADOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES EFETUADOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.02.00', 'DEPOSITOS E CAUCOES RECEBIDOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES RECEBIDOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.04.00', 'DEPOSITOS JUDICIAIS RECEBIDOS', 'REGISTRA OS VALORES DECORRENTES DE DEPOSITOS RECEBIDOS PELA ENTIDADE POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.05.00', 'DEPOSITOS EFETUADOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS EFETUADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.06.00', 'DEPOSITOS RECEBIDOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS RECEBIDOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.07.00', 'DEPOSITOS ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.08.00', 'VALORES APREENDIDOS POR DECISAO JUDICIAL', 'REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.09.00', 'DEPOSITOS TRANSFERIDOS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS TRANSFERIDOS, PARA GARANTIA DE OPERACOES ESPECIFICAS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.10.00', 'DEMAIS DEPOSITOS DO INSS', 'REGISTRA OS VALORES DE OUTROS DEPOSITOS DO INSS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.99.00', 'OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.6.1.00.00', 'DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS - CONSOLIDACAO', 'REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, EXCETO AS DERIVADAS DE CLIENTES, REALIZAVEIS NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.6.2.00.00', 'DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS - INTRA OFSS', 'REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, EXCETO AS DERIVADAS DE CLIENTES, REALIZAVEIS NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.6.4.00.00', 'DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS - INTER OFSS - ESTADO', 'REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, EXCETO AS DERIVADAS DE CLIENTES, REALIZAVEIS NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.6.5.00.00', 'DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS - INTER OFSS - MUNICIPIO', 'REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, EXCETO AS DERIVADAS DE CLIENTES, REALIZAVEIS NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.01.00', 'ALUGUEIS A RECEBER', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE CONTRATOS DE ALUGUEL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.02.00', 'CREDITOS A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.03.00', 'VALORES A RECUPERAR DECORRENTES DE INDENIZACOES POR SINISTROS PAGOS', 'REGISTRA OS VALORES A RECUPERAR REFERENTES A INDENIZACOES PELO PAGAMENTO DE SINISTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.04.00', 'VALES, TICKETS E BILHETES', 'REGISTRA O VALOR DE VALES, TICKETS E BILHETES ADQUIRIDOS PARA FUTURA DISTRIBUICAO AOS SERVIDORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.06.01', 'VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS ESTORNADAS', 'REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS ESTORNADAS, CUJO FINANCEIRO NAO INGRESSOU NA CONTA UNICA DA UG.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.06.02', 'VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS VINCULADAS A CONVENIO ESTORNADAS', 'REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS VINCULADAS A CONVENIO ESTORNADAS, CUJO FINANCEIRO NAO INGRESSOU NA CONTA UNICA DA UG.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.06.03', 'VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS COM OBRIGACOES EXTERNAS', 'REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS VINCULADAS COM OBRIGACOES EXTERNAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.06.04', 'ORDENS BANCARIAS EMITIDAS A COMPENSAR', 'REGISTRA OS VALORES RELATIVOS AS ORDENS BANCARIAS EMITIDAS, EM TRANSITO OU A COMPENSAR PELO AGENTE FINANCEIRO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.06.05', 'RESTITUICOES DE RECEITAS EFETUADAS POR GRU A CLASSIFICAR', 'REGISTRA OS VALORES RELATIVOS AS GUIAS DE RECEBIMENTO EMITIDAS, EM TRANSITO, A COMPENSAR PELO AGENTE FINANCEIRO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.06.06', 'VALORES EM TRANSITO - UG EXTERIOR', 'REGISTRA O VALOR EM TRANSITO CORRESPONDENTE A TRANSFERENCIAS FINANCEIRAS ENTRE UG DO PAIS E DO EXTERIOR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.06.07', 'SAQUES POR CARTAO DE PAGAMENTO A CLASSIFICAR', 'REGISTRA OS VALORES A CLASSIFICAR DE SAQUES NA CONTA UNICA POR AGENTES CREDENCIADOS PELA UNIDADE GESTORA PENDENTES DE CLASSIFICACAO. QUANDO DA OCORRENCIA DE SAQUE SEM A DEVIDA LIQUIDACAO DA DESPESA GERARA SALDO NESTA CONTA. PARA EVIDENCIAR ESSE FATO, DEVE SER REGISTRADA RESTRICAO CONTABIL N. 013.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.06.08', 'TRANSFERENCIAS CONSTITUCIONAIS EM TRANSITO', 'REGISTRA OS VALORES DAS TRANSFERENCIAS CONSTITUCIONAIS (FPM, FPE, ITR, IOF-OURO, IPI-EXPORTACAO, FUNDEB, CIDE E ROYALTIES) QUANDO DA LIBERACAO DE RECURSOS PARA ESTADOS, DISTRITO FEDERAL E MUNICIPIOS POR MEIO DE ORDEM BANCARIA EM FAVOR DO BANCO DO BRASIL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.06.99', 'OUTROS VALORES EM TRANSITO', 'REGISTRA A TRANSFERENCIA DE SALDOS BANCARIOS ENTRE CONTAS DA UG, ENTRE UGS DE MESMA GESTAO OU ENTRE CONTA UNICA DO INSS E DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.07.00', 'CREDITOS A RECEBER DECORRENTES DE INFRACOES LEGAIS E CONTRATUAIS', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CREDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.08.00', 'CREDITOS A RECEBER POR REEMBOLSO DE SALARIO FAMILIA PAGO', 'REGISTRA OS VALORES RELATIVOS AO SALARIO-FAMILIA, INCLUIDOS EM FOLHAS DE PAGAMENTO, PAGOS AOS EMPREGADOS (CLT), COM FILHOS MENORES, A COMPENSAR COM AS CONTRIBUICOES DEVIDAS PELO EMPREGADOR A PREVIDENCIA SOCIAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.09.00', 'CREDITOS A RECEBER POR REEMBOLSO DE SALARIO MATERNIDADE PAGO', 'REGISTRA OS SALARIOS PAGOS AS SERVIDORAS GESTANTES, REGIDAS PELA CLT NO PERIODO QUE PERDURAR A LICENCA MATERNIDADE, PREVISTA EM LEI, A DEDUZIR DAS OBRIGACOES SOCIAIS DEVIDAS PELOS ORGAOS E ENTIDADES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.10.00', 'AUXILIO NATALIDADE PAGO A RECUPERAR', 'REGISTRA OS VALORES RELATIVOS A AUXILIO NATALIDADE, PAGOS AOS EMPREGADOS REGIDOS PELA CLY, QUANDO DO NASCIMENTO DE FILHOS DESTES, A RECUPERAR, POR SE TRATAR DE OBRIGACOES DA PREVIDENCIA SOCIAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.11.00', 'CREDITOS A RECEBER POR REEMBOLSO DE AUXILIO DOENCA E ACIDENTES PAGOS', 'REGISTRA OS SALARIOS PAGOS AOS SERVIDORES, REGIDOS PELA CLT, A TITULO DE AUXILIO DOENCA/ACIDENTES, PREVISTO EM LEI, A SEREM REEMBOLSADOS PELO INSS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.12.00', 'CREDITOS A RECEBER POR CESSAO DE PESSOAL', 'REGISTRA OS VALORES DE CREDITOS A RECEBER TAIS COMO: FOLHA DE PAGAMENTO, DESPESA DE TRANSPORTE, ALIMENTACAO E OUTRAS RELATIVAS A CESSAO DE PESSOAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.13.00', 'CREDITOS A RECEBER DECORRENTES DE CESSAO DE AREAS PUBLICAS', 'REGISTRA OS VALORES A RECEBER DECORRENTES DA CESSAO DE AREAS PUBLICAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.14.00', 'CREDITOS A RECEBE DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS OU IMOVEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.15.00', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESAS DE TERCEIROS', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE PAGAMENTOS DE DESPESAS DE TERCEIROS DECORRENTES DE CLAUSULAS CONTRATUAIS, TAIS COMO: AGUA, LUZ, TELEFONE, INSTALACOES, TRANSPORTE E ALUGUEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.16.00', 'CREDITO A RECEBER POR ACERTO FINANCEIRO COM SERVIDOR E EX- SERVIDOR', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DE ACERTOS FINANCEIROS COM SERVIDORES E EX-SERVIDORES DO ORGAO, CONFORME DISPOSTO NA LEI 8.112/90.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.17.00', 'CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.18.00', 'DIVIDENDOS PROPOSTOS A RECEBER', 'REGISTRA OS VALORES DOS DIVIDENDOS A QUE A EMPRESA TENHA DIREITO, EM FUNCAO DE PARTICIPACOES EM OUTRAS EMPRESAS, QUANDO TAIS EMPRESAS JA TENHAM REGISTRADO NA DEMONSTRACAO DE LUCROS OU PREJUIZOS ACUMULADOS A PARCELA DE DIVIDENDOS PROPOSTOS A DISTRIBUIR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.19.00', 'CREDITOS A RECEBER DECORRENTES DE VALORES ARRECADADOS POR OUTRAS ENTIDADES', 'REGISTRA OS CREDITOS A RECEBER REFERENTE A VALORES ARRECADADOS POR OUTRAS ENTIDADES DECORRENTES DE DESCENTRALIZACAO DE COBRANCA DE VALORES.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.20.00', 'REMUNERACAO DE DEBENTURES A RECEBER', 'REGISTRA OS VALORES DAS REMUNERACOES DE DEBENTURES A RECEBER.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.21.00', 'RECURSOS DA UNIAO', 'REGISTRA OS RECURSOS DA UNIAO A SEREM RECEBIDOS NA CONTA UNICA DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.22.00', 'CREDITOS ORIUNDOS DOS ENCARGOS CAPACID. EMERGENCIAL ECE', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DOS MONTANTES ORIGINADOS DOS ENCARGOS CAPACID. EMERGENCIAL - ECE, REGULAMENTADO PELA RESOLUCAO ANEEL Nº 249/2000.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.23.00', 'CREDITOS ORIUNDOS DA AQUISICAO DE ENERGIA ELETRICA EMERGENCIAL - EAE', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE AQUISICAO DE ENERGIA ELETRICA EMERGENCIAL - ECE, REGULAMENTADO PELA RESOLUCAO ANEEL Nº 249/2000.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.24.00', 'TITULOS DO TESOURO NACIONAL A RECEBER', 'REGISTRA OS VALORES A RECEBER REFERENTES A TITULOS DO TESOURO NACIONAL A SEREM EMITIDOS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.25.00', 'CREDITOS EM LIQUIDACAO', 'REGISTRA OS VALORES RELATIVOS A CREDITOS DA ENTIDADE ORIUNDOS DE CREDITOS EM LIQUIDACAO.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.26.00', 'CREDITOS A RECEBER POR CESSAO DE CREDITOS - CEDIDOS PELA UNIAO', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER CEDIDOS PELA UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.27.00', 'TITULOS A RECEBER', 'COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.28.00', 'CREDITOS A RECEBER DE ENTIDADES FEDERAIS', 'REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ENTIDADES FEDERAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.29.00', 'CREDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS', 'REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ESTADOS, DF E MUNICIPIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.30.01', 'RESULTADO POSITIVO DO BACEN - BALANCO APURADO', 'REGISTRA OS VALORES RELATIVOS AO RESULTADO POSITIVO DO BANCO CENTRAL CORRESPONDENTE AO APURADO NO BALANCO DE 31 DE DEZEMBRO DESTA INSTITUICAO A SER PAGO AO TESOURO NACIONAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.30.02', 'RESULTADO POSITIVO DO BACEN - CUSTOS DAS RESERVAS', 'REGISTRA OS VALORES RELATIVOS AO RESULTADO POSITIVO DO BANCO CENTRAL CORRESPONDENTE AO CUSTO DAS RESERVAS DESTA INSTITUICAO A SER PAGO AO TESOURO NACIONAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.31.00', 'CREDITOS PARCELADOS', 'REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.32.00', 'TITULOS RECOMPRADOS A CANCELAR', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A TITULOS RESGATADOS E QUE ESTEJAM AGUARDANDO AUTORIZACAO PARA CANCELAMENTO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.35.00', 'DEPOSITOS DO BACEN', 'REGISTRA AS OPERACOES DE DEPOSITOS A PRAZO FIXO COM JUROS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.99.00', 'OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO', 'REGISTRA OUTROS CREDITOS RECEBER E VALORES A CURTO PRAZO, PARA OS QUAIS NAO TENHAM CONTAS ESPECIFICAS NESTE SUBGRUPO DE CONTAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.01.00', 'ALUGUEIS A RECEBER', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE CONTRATOS DE ALUGUEL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.02.00', 'CREDITOS A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.03.00', 'VALORES A RECUPERAR DECORRENTES DE INDENIZACOES POR SINISTROS PAGOS', 'REGISTRA OS VALORES A RECUPERAR REFERENTES A INDENIZACOES PELO PAGAMENTO DE SINISTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.06.01', 'VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS ESTORNADAS', 'REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS ESTORNADAS, CUJO FINANCEIRO NAO INGRESSOU NA CONTA UNICA DA UG.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.06.02', 'VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS VINCULADAS A CONVENIO ESTORNADAS', 'REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS VINCULADAS A CONVENIO ESTORNADAS, CUJO FINANCEIRO NAO INGRESSOU NA CONTA UNICA DA UG.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.06.03', 'VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS COM OBRIGACOES EXTERNAS', 'REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS VINCULADAS COM OBRIGACOES EXTERNAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.06.04', 'ORDENS BANCARIAS EMITIDAS A COMPENSAR', 'REGISTRA OS VALORES RELATIVOS AS ORDENS BANCARIAS EMITIDAS, EM TRANSITO OU A COMPENSAR PELO AGENTE FINANCEIRO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.06.05', 'RESTITUICOES DE RECEITAS EFETUADAS POR GRU A CLASSIFICAR', 'REGISTRA OS VALORES RELATIVOS AS GUIAS DE RECEBIMENTO EMITIDAS, EM TRANSITO, A COMPENSAR PELO AGENTE FINANCEIRO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.06.06', 'VALORES EM TRANSITO - UG EXTERIOR', 'REGISTRA O VALOR EM TRANSITO CORRESPONDENTE A TRANSFERENCIAS FINANCEIRAS ENTRE UG DO PAIS E DO EXTERIOR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.06.07', 'SAQUES POR CARTAO DE PAGAMENTO A CLASSIFICAR', 'REGISTRA OS VALORES A CLASSIFICAR DE SAQUES NA CONTA UNICA POR AGENTES CREDENCIADOS PELA UNIDADE GESTORA PENDENTES DE CLASSIFICACAO. QUANDO DA OCORRENCIA DE SAQUE SEM A DEVIDA LIQUIDACAO DA DESPESA GERARA SALDO NESTA CONTA. PARA EVIDENCIAR ESSE FATO, DEVE SER REGISTRADA RESTRICAO CONTABIL N. 013.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.06.99', 'OUTROS VALORES EM TRANSITO', 'REGISTRA A TRANSFERENCIA DE SALDOS BANCARIOS ENTRE CONTAS DA UG, ENTRE UGS DE MESMA GESTAO OU ENTRE CONTA UNICA DO INSS E DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.07.00', 'CREDITOS A RECEBER DECORRENTES DE INFRACOES LEGAIS E CONTRATUAIS', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CREDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.08.00', 'CREDITOS A RECEBER POR REEMBOLSO DE SALARIO FAMILIA PAGO', 'REGISTRA OS VALORES RELATIVOS AO SALARIO-FAMILIA, INCLUIDOS EM FOLHAS DE PAGAMENTO, PAGOS AOS EMPREGADOS (CLT), COM FILHOS MENORES, A COMPENSAR COM AS CONTRIBUICOES DEVIDAS PELO EMPREGADOR A PREVIDENCIA SOCIAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.09.00', 'CREDITOS A RECEBER POR REEMBOLSO DE SALARIO MATERNIDADE PAGO', 'REGISTRA OS SALARIOS PAGOS AS SERVIDORAS GESTANTES, REGIDAS PELA CLT NO PERIODO QUE PERDURAR A LICENCA MATERNIDADE, PREVISTA EM LEI, A DEDUZIR DAS OBRIGACOES SOCIAIS DEVIDAS PELOS ORGAOS E ENTIDADES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.10.00', 'AUXILIO NATALIDADE PAGO A RECUPERAR', 'REGISTRA OS VALORES RELATIVOS A AUXILIO NATALIDADE, PAGOS AOS EMPREGADOS REGIDOS PELA CLY, QUANDO DO NASCIMENTO DE FILHOS DESTES, A RECUPERAR, POR SE TRATAR DE OBRIGACOES DA PREVIDENCIA SOCIAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.11.00', 'CREDITOS A RECEBER POR REEMBOLSO DE AUXILIO DOENCA E ACIDENTES PAGOS', 'REGISTRA OS SALARIOS PAGOS AOS SERVIDORES, REGIDOS PELA CLT, A TITULO DE AUXILIO DOENCA/ACIDENTES, PREVISTO EM LEI, A SEREM REEMBOLSADOS PELO INSS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.12.00', 'CREDITOS A RECEBER POR CESSAO DE PESSOAL', 'REGISTRA OS VALORES DE CREDITOS A RECEBER TAIS COMO: FOLHA DE PAGAMENTO, DESPESA DE TRANSPORTE, ALIMENTACAO E OUTRAS RELATIVAS A CESSAO DE PESSOAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.13.00', 'CREDITOS A RECEBER DECORRENTES DE CESSAO DE AREAS PUBLICAS', 'REGISTRA OS VALORES A RECEBER DECORRENTES DA CESSAO DE AREAS PUBLICAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.14.00', 'CREDITOS A RECEBE DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS OU IMOVEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.15.00', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESAS DE TERCEIROS', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE PAGAMENTOS DE DESPESAS DE TERCEIROS DECORRENTES DE CLAUSULAS CONTRATUAIS, TAIS COMO: AGUA, LUZ, TELEFONE, INSTALACOES, TRANSPORTE E ALUGUEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.18.00', 'DIVIDENDOS PROPOSTOS A RECEBER', 'REGISTRA OS VALORES DOS DIVIDENDOS A QUE A EMPRESA TENHA DIREITO, EM FUNCAO DE PARTICIPACOES EM OUTRAS EMPRESAS, QUANDO TAIS EMPRESAS JA TENHAM REGISTRADO NA DEMONSTRACAO DE LUCROS OU PREJUIZOS ACUMULADOS A PARCELA DE DIVIDENDOS PROPOSTOS A DISTRIBUIR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.19.00', 'CREDITOS A RECEBER DECORRENTES DE VALORES ARRECADADOS POR OUTRAS ENTIDADES', 'REGISTRA OS CREDITOS A RECEBER REFERENTE A VALORES ARRECADADOS POR OUTRAS ENTIDADES DECORRENTES DE DESCENTRALIZACAO DE COBRANCA DE VALORES.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.20.00', 'REMUNERACAO DE DEBENTURES A RECEBER', 'REGISTRA OS VALORES DAS REMUNERACOES DE DEBENTURES A RECEBER.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.22.00', 'CREDITOS ORIUNDOS DOS ENCARGOS CAPACID. EMERGENCIAL ECE', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DOS MONTANTES ORIGINADOS DOS ENCARGOS CAPACID. EMERGENCIAL - ECE, REGULAMENTADO PELA RESOLUCAO ANEEL Nº 249/2000.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.23.00', 'CREDITOS ORIUNDOS DA AQUISICAO DE ENERGIA ELETRICA EMERGENCIAL - EAE', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE AQUISICAO DE ENERGIA ELETRICA EMERGENCIAL - ECE, REGULAMENTADO PELA RESOLUCAO ANEEL Nº 249/2000.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.24.00', 'TITULOS DO TESOURO NACIONAL A RECEBER', 'REGISTRA OS VALORES A RECEBER REFERENTES A TITULOS DO TESOURO NACIONAL A SEREM EMITIDOS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.25.00', 'CREDITOS EM LIQUIDACAO', 'REGISTRA OS VALORES RELATIVOS A CREDITOS DA ENTIDADE ORIUNDOS DE CREDITOS EM LIQUIDACAO.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.26.00', 'CREDITOS A RECEBER POR CESSAO DE CREDITOS - CEDIDOS PELA UNIAO', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER CEDIDOS PELA UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.27.00', 'TITULOS A RECEBER', 'COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.28.00', 'CREDITOS A RECEBER DE ENTIDADES FEDERAIS', 'REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ENTIDADES FEDERAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.29.00', 'CREDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS', 'REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ESTADOS, DF E MUNICIPIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.31.00', 'CREDITOS PARCELADOS', 'REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.32.00', 'TITULOS RECOMPRADOS A CANCELAR', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A TITULOS RESGATADOS E QUE ESTEJAM AGUARDANDO AUTORIZACAO PARA CANCELAMENTO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.33.01', 'COTA CONCEDIDA DIFERIDA', 'REGISTRA A PARCELA DE RECURSOS FINANCEIROS, NAO UTILIZADA DURANTE O EXERCICIO, TRANSFERIDOS DE UM OGAO SETORIAL DE PROGRAMACAO FINANCEIROA PARA OUTRO, MAIS O LIMITE DE RP CONCEDIDO, MENOS O LIMITE DE RP RECEBIDO, CONSTITUINDO O TOTAL EM ANTECIPACAO DE COTA DO EXERCICIO SEGUINTE.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.33.02', 'REPASSE CONCEDIDO DIFERIDO', 'REGISTRA A PARCELA DE RECURSOS FINANCEIROS LIBERADA PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA, QUE NAO FOI UTILIZADA DURANTE O EXERCICIO PELAS UNIDADES, CONSTITUINDO ANTECIPACAO DE REPASSE.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.33.03', 'SUB-REPASSE CONCEDIDO DIFERIDO', 'REGISTRA A PARCELA DE RECURSOS FINANCEIROS LIBERADA PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA, QUE NAO FOI UTILIZADA DURANTE O EXERCICIO PELAS UNIDADES, CONSTITUINDO ANTECIPACAO DE SUB-REPASSE.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.35.00', 'DEPOSITOS DO BACEN', 'REGISTRA AS OPERACOES DE DEPOSITOS A PRAZO FIXO COM JUROS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.99.00', 'OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO', 'REGISTRA OUTROS CREDITOS RECEBER E VALORES A CURTO PRAZO, PARA OS QUAIS NAO TENHAM CONTAS ESPECIFICAS NESTE SUBGRUPO DE CONTAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.01.00', 'ALUGUEIS A RECEBER', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE CONTRATOS DE ALUGUEL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.02.00', 'CREDITOS A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.03.00', 'VALORES A RECUPERAR DECORRENTES DE INDENIZACOES POR SINISTROS PAGOS', 'REGISTRA OS VALORES A RECUPERAR REFERENTES A INDENIZACOES PELO PAGAMENTO DE SINISTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.06.01', 'VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS ESTORNADAS', 'REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS ESTORNADAS, CUJO FINANCEIRO NAO INGRESSOU NA CONTA UNICA DA UG.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.06.02', 'VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS VINCULADAS A CONVENIO ESTORNADAS', 'REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS VINCULADAS A CONVENIO ESTORNADAS, CUJO FINANCEIRO NAO INGRESSOU NA CONTA UNICA DA UG.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.06.03', 'VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS COM OBRIGACOES EXTERNAS', 'REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS VINCULADAS COM OBRIGACOES EXTERNAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.06.04', 'ORDENS BANCARIAS EMITIDAS A COMPENSAR', 'REGISTRA OS VALORES RELATIVOS AS ORDENS BANCARIAS EMITIDAS, EM TRANSITO OU A COMPENSAR PELO AGENTE FINANCEIRO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.06.05', 'RESTITUICOES DE RECEITAS EFETUADAS POR GRU A CLASSIFICAR', 'REGISTRA OS VALORES RELATIVOS AS GUIAS DE RECEBIMENTO EMITIDAS, EM TRANSITO, A COMPENSAR PELO AGENTE FINANCEIRO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.06.06', 'VALORES EM TRANSITO - UG EXTERIOR', 'REGISTRA O VALOR EM TRANSITO CORRESPONDENTE A TRANSFERENCIAS FINANCEIRAS ENTRE UG DO PAIS E DO EXTERIOR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.06.07', 'SAQUES POR CARTAO DE PAGAMENTO A CLASSIFICAR', 'REGISTRA OS VALORES A CLASSIFICAR DE SAQUES NA CONTA UNICA POR AGENTES CREDENCIADOS PELA UNIDADE GESTORA PENDENTES DE CLASSIFICACAO. QUANDO DA OCORRENCIA DE SAQUE SEM A DEVIDA LIQUIDACAO DA DESPESA GERARA SALDO NESTA CONTA. PARA EVIDENCIAR ESSE FATO, DEVE SER REGISTRADA RESTRICAO CONTABIL N. 013.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.06.99', 'OUTROS VALORES EM TRANSITO', 'REGISTRA A TRANSFERENCIA DE SALDOS BANCARIOS ENTRE CONTAS DA UG, ENTRE UGS DE MESMA GESTAO OU ENTRE CONTA UNICA DO INSS E DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.07.00', 'CREDITOS A RECEBER DECORRENTES DE INFRACOES LEGAIS E CONTRATUAIS', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CREDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.08.00', 'CREDITOS A RECEBER POR REEMBOLSO DE SALARIO FAMILIA PAGO', 'REGISTRA OS VALORES RELATIVOS AO SALARIO-FAMILIA, INCLUIDOS EM FOLHAS DE PAGAMENTO, PAGOS AOS EMPREGADOS (CLT), COM FILHOS MENORES, A COMPENSAR COM AS CONTRIBUICOES DEVIDAS PELO EMPREGADOR A PREVIDENCIA SOCIAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.09.00', 'CREDITOS A RECEBER POR REEMBOLSO DE SALARIO MATERNIDADE PAGO', 'REGISTRA OS SALARIOS PAGOS AS SERVIDORAS GESTANTES, REGIDAS PELA CLT NO PERIODO QUE PERDURAR A LICENCA MATERNIDADE, PREVISTA EM LEI, A DEDUZIR DAS OBRIGACOES SOCIAIS DEVIDAS PELOS ORGAOS E ENTIDADES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.10.00', 'AUXILIO NATALIDADE PAGO A RECUPERAR', 'REGISTRA OS VALORES RELATIVOS A AUXILIO NATALIDADE, PAGOS AOS EMPREGADOS REGIDOS PELA CLY, QUANDO DO NASCIMENTO DE FILHOS DESTES, A RECUPERAR, POR SE TRATAR DE OBRIGACOES DA PREVIDENCIA SOCIAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.11.00', 'CREDITOS A RECEBER POR REEMBOLSO DE AUXILIO DOENCA E ACIDENTES PAGOS', 'REGISTRA OS SALARIOS PAGOS AOS SERVIDORES, REGIDOS PELA CLT, A TITULO DE AUXILIO DOENCA/ACIDENTES, PREVISTO EM LEI, A SEREM REEMBOLSADOS PELO INSS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.12.00', 'CREDITOS A RECEBER POR CESSAO DE PESSOAL', 'REGISTRA OS VALORES DE CREDITOS A RECEBER TAIS COMO: FOLHA DE PAGAMENTO, DESPESA DE TRANSPORTE, ALIMENTACAO E OUTRAS RELATIVAS A CESSAO DE PESSOAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.13.00', 'CREDITOS A RECEBER DECORRENTES DE CESSAO DE AREAS PUBLICAS', 'REGISTRA OS VALORES A RECEBER DECORRENTES DA CESSAO DE AREAS PUBLICAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.14.00', 'CREDITOS A RECEBE DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS OU IMOVEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.15.00', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESAS DE TERCEIROS', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE PAGAMENTOS DE DESPESAS DE TERCEIROS DECORRENTES DE CLAUSULAS CONTRATUAIS, TAIS COMO: AGUA, LUZ, TELEFONE, INSTALACOES, TRANSPORTE E ALUGUEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.18.00', 'DIVIDENDOS PROPOSTOS A RECEBER', 'REGISTRA OS VALORES DOS DIVIDENDOS A QUE A EMPRESA TENHA DIREITO, EM FUNCAO DE PARTICIPACOES EM OUTRAS EMPRESAS, QUANDO TAIS EMPRESAS JA TENHAM REGISTRADO NA DEMONSTRACAO DE LUCROS OU PREJUIZOS ACUMULADOS A PARCELA DE DIVIDENDOS PROPOSTOS A DISTRIBUIR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.19.00', 'CREDITOS A RECEBER DECORRENTES DE VALORES ARRECADADOS POR OUTRAS ENTIDADES', 'REGISTRA OS CREDITOS A RECEBER REFERENTE A VALORES ARRECADADOS POR OUTRAS ENTIDADES DECORRENTES DE DESCENTRALIZACAO DE COBRANCA DE VALORES.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.20.00', 'REMUNERACAO DE DEBENTURES A RECEBER', 'REGISTRA OS VALORES DAS REMUNERACOES DE DEBENTURES A RECEBER.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.22.00', 'CREDITOS ORIUNDOS DOS ENCARGOS CAPACID. EMERGENCIAL ECE', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DOS MONTANTES ORIGINADOS DOS ENCARGOS CAPACID. EMERGENCIAL - ECE, REGULAMENTADO PELA RESOLUCAO ANEEL Nº 249/2000.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.23.00', 'CREDITOS ORIUNDOS DA AQUISICAO DE ENERGIA ELETRICA EMERGENCIAL - EAE', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE AQUISICAO DE ENERGIA ELETRICA EMERGENCIAL - ECE, REGULAMENTADO PELA RESOLUCAO ANEEL Nº 249/2000.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.24.00', 'TITULOS DO TESOURO NACIONAL A RECEBER', 'REGISTRA OS VALORES A RECEBER REFERENTES A TITULOS DO TESOURO NACIONAL A SEREM EMITIDOS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.25.00', 'CREDITOS EM LIQUIDACAO', 'REGISTRA OS VALORES RELATIVOS A CREDITOS DA ENTIDADE ORIUNDOS DE CREDITOS EM LIQUIDACAO.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.26.00', 'CREDITOS A RECEBER POR CESSAO DE CREDITOS - CEDIDOS PELA UNIAO', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER CEDIDOS PELA UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.27.00', 'TITULOS A RECEBER', 'COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.28.00', 'CREDITOS A RECEBER DE ENTIDADES FEDERAIS', 'REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ENTIDADES FEDERAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.29.00', 'CREDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS', 'REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ESTADOS, DF E MUNICIPIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.31.00', 'CREDITOS PARCELADOS', 'REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.32.00', 'TITULOS RECOMPRADOS A CANCELAR', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A TITULOS RESGATADOS E QUE ESTEJAM AGUARDANDO AUTORIZACAO PARA CANCELAMENTO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.34.00', 'PRECATORIOS ENCAMINHADOS - JUSTICA ESTADUAL', 'REGISTRA OS CREDITOS DECORRENTES DE PRECATORIOS DEVIDOS PELO INSS ORIUNDOS DAS SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO DE COMPETENCIA DA JUSTICA COMUM ESTADUAL, MAS QUE AINDA NAO FORAM EFETIVAMENTE PAGOS AO BENEFICIARIO DO PRECATORIO PELO PODER JUDICIARIO ESTADUAL. BASE LEGAL: CONSTITUICAO FEDERAL DE 1988 (ART.109, § 3º)', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.35.00', 'DEPOSITOS DO BACEN', 'REGISTRA AS OPERACOES DE DEPOSITOS A PRAZO FIXO COM JUROS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.99.00', 'OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO', 'REGISTRA OUTROS CREDITOS RECEBER E VALORES A CURTO PRAZO, PARA OS QUAIS NAO TENHAM CONTAS ESPECIFICAS NESTE SUBGRUPO DE CONTAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.01.00', 'ALUGUEIS A RECEBER', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE CONTRATOS DE ALUGUEL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.02.00', 'CREDITOS A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.03.00', 'VALORES A RECUPERAR DECORRENTES DE INDENIZACOES POR SINISTROS PAGOS', 'REGISTRA OS VALORES A RECUPERAR REFERENTES A INDENIZACOES PELO PAGAMENTO DE SINISTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.06.01', 'VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS ESTORNADAS', 'REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS ESTORNADAS, CUJO FINANCEIRO NAO INGRESSOU NA CONTA UNICA DA UG.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.06.02', 'VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS VINCULADAS A CONVENIO ESTORNADAS', 'REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS VINCULADAS A CONVENIO ESTORNADAS, CUJO FINANCEIRO NAO INGRESSOU NA CONTA UNICA DA UG.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.06.03', 'VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS COM OBRIGACOES EXTERNAS', 'REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS VINCULADAS COM OBRIGACOES EXTERNAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.06.04', 'ORDENS BANCARIAS EMITIDAS A COMPENSAR', 'REGISTRA OS VALORES RELATIVOS AS ORDENS BANCARIAS EMITIDAS, EM TRANSITO OU A COMPENSAR PELO AGENTE FINANCEIRO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.06.05', 'RESTITUICOES DE RECEITAS EFETUADAS POR GRU A CLASSIFICAR', 'REGISTRA OS VALORES RELATIVOS AS GUIAS DE RECEBIMENTO EMITIDAS, EM TRANSITO, A COMPENSAR PELO AGENTE FINANCEIRO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.06.06', 'VALORES EM TRANSITO - UG EXTERIOR', 'REGISTRA O VALOR EM TRANSITO CORRESPONDENTE A TRANSFERENCIAS FINANCEIRAS ENTRE UG DO PAIS E DO EXTERIOR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.06.07', 'SAQUES POR CARTAO DE PAGAMENTO A CLASSIFICAR', 'REGISTRA OS VALORES A CLASSIFICAR DE SAQUES NA CONTA UNICA POR AGENTES CREDENCIADOS PELA UNIDADE GESTORA PENDENTES DE CLASSIFICACAO. QUANDO DA OCORRENCIA DE SAQUE SEM A DEVIDA LIQUIDACAO DA DESPESA GERARA SALDO NESTA CONTA. PARA EVIDENCIAR ESSE FATO, DEVE SER REGISTRADA RESTRICAO CONTABIL N. 013.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.06.99', 'OUTROS VALORES EM TRANSITO', 'REGISTRA A TRANSFERENCIA DE SALDOS BANCARIOS ENTRE CONTAS DA UG, ENTRE UGS DE MESMA GESTAO OU ENTRE CONTA UNICA DO INSS E DO TESOURO NACIONAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.07.00', 'CREDITOS A RECEBER DECORRENTES DE INFRACOES LEGAIS E CONTRATUAIS', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CREDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.08.00', 'CREDITOS A RECEBER POR REEMBOLSO DE SALARIO FAMILIA PAGO', 'REGISTRA OS VALORES RELATIVOS AO SALARIO-FAMILIA, INCLUIDOS EM FOLHAS DE PAGAMENTO, PAGOS AOS EMPREGADOS (CLT), COM FILHOS MENORES, A COMPENSAR COM AS CONTRIBUICOES DEVIDAS PELO EMPREGADOR A PREVIDENCIA SOCIAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.09.00', 'CREDITOS A RECEBER POR REEMBOLSO DE SALARIO MATERNIDADE PAGO', 'REGISTRA OS SALARIOS PAGOS AS SERVIDORAS GESTANTES, REGIDAS PELA CLT NO PERIODO QUE PERDURAR A LICENCA MATERNIDADE, PREVISTA EM LEI, A DEDUZIR DAS OBRIGACOES SOCIAIS DEVIDAS PELOS ORGAOS E ENTIDADES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.10.00', 'AUXILIO NATALIDADE PAGO A RECUPERAR', 'REGISTRA OS VALORES RELATIVOS A AUXILIO NATALIDADE, PAGOS AOS EMPREGADOS REGIDOS PELA CLY, QUANDO DO NASCIMENTO DE FILHOS DESTES, A RECUPERAR, POR SE TRATAR DE OBRIGACOES DA PREVIDENCIA SOCIAL.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.11.00', 'CREDITOS A RECEBER POR REEMBOLSO DE AUXILIO DOENCA E ACIDENTES PAGOS', 'REGISTRA OS SALARIOS PAGOS AOS SERVIDORES, REGIDOS PELA CLT, A TITULO DE AUXILIO DOENCA/ACIDENTES, PREVISTO EM LEI, A SEREM REEMBOLSADOS PELO INSS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.12.00', 'CREDITOS A RECEBER POR CESSAO DE PESSOAL', 'REGISTRA OS VALORES DE CREDITOS A RECEBER TAIS COMO: FOLHA DE PAGAMENTO, DESPESA DE TRANSPORTE, ALIMENTACAO E OUTRAS RELATIVAS A CESSAO DE PESSOAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.13.00', 'CREDITOS A RECEBER DECORRENTES DE CESSAO DE AREAS PUBLICAS', 'REGISTRA OS VALORES A RECEBER DECORRENTES DA CESSAO DE AREAS PUBLICAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.14.00', 'CREDITOS A RECEBE DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS OU IMOVEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.15.00', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESAS DE TERCEIROS', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE PAGAMENTOS DE DESPESAS DE TERCEIROS DECORRENTES DE CLAUSULAS CONTRATUAIS, TAIS COMO: AGUA, LUZ, TELEFONE, INSTALACOES, TRANSPORTE E ALUGUEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.18.00', 'DIVIDENDOS PROPOSTOS A RECEBER', 'REGISTRA OS VALORES DOS DIVIDENDOS A QUE A EMPRESA TENHA DIREITO, EM FUNCAO DE PARTICIPACOES EM OUTRAS EMPRESAS, QUANDO TAIS EMPRESAS JA TENHAM REGISTRADO NA DEMONSTRACAO DE LUCROS OU PREJUIZOS ACUMULADOS A PARCELA DE DIVIDENDOS PROPOSTOS A DISTRIBUIR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.19.00', 'CREDITOS A RECEBER DECORRENTES DE VALORES ARRECADADOS POR OUTRAS ENTIDADES', 'REGISTRA OS CREDITOS A RECEBER REFERENTE A VALORES ARRECADADOS POR OUTRAS ENTIDADES DECORRENTES DE DESCENTRALIZACAO DE COBRANCA DE VALORES.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.20.00', 'REMUNERACAO DE DEBENTURES A RECEBER', 'REGISTRA OS VALORES DAS REMUNERACOES DE DEBENTURES A RECEBER.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.22.00', 'CREDITOS ORIUNDOS DOS ENCARGOS CAPACID. EMERGENCIAL ECE', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DOS MONTANTES ORIGINADOS DOS ENCARGOS CAPACID. EMERGENCIAL - ECE, REGULAMENTADO PELA RESOLUCAO ANEEL Nº 249/2000.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.23.00', 'CREDITOS ORIUNDOS DA AQUISICAO DE ENERGIA ELETRICA EMERGENCIAL - EAE', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE AQUISICAO DE ENERGIA ELETRICA EMERGENCIAL - ECE, REGULAMENTADO PELA RESOLUCAO ANEEL Nº 249/2000.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.24.00', 'TITULOS DO TESOURO NACIONAL A RECEBER', 'REGISTRA OS VALORES A RECEBER REFERENTES A TITULOS DO TESOURO NACIONAL A SEREM EMITIDOS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.25.00', 'CREDITOS EM LIQUIDACAO', 'REGISTRA OS VALORES RELATIVOS A CREDITOS DA ENTIDADE ORIUNDOS DE CREDITOS EM LIQUIDACAO.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.26.00', 'CREDITOS A RECEBER POR CESSAO DE CREDITOS - CEDIDOS PELA UNIAO', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER CEDIDOS PELA UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.27.00', 'TITULOS A RECEBER', 'COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.28.00', 'CREDITOS A RECEBER DE ENTIDADES FEDERAIS', 'REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ENTIDADES FEDERAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.29.00', 'CREDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS', 'REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ESTADOS, DF E MUNICIPIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.31.00', 'CREDITOS PARCELADOS', 'REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.32.00', 'TITULOS RECOMPRADOS A CANCELAR', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A TITULOS RESGATADOS E QUE ESTEJAM AGUARDANDO AUTORIZACAO PARA CANCELAMENTO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.35.00', 'DEPOSITOS DO BACEN', 'REGISTRA AS OPERACOES DE DEPOSITOS A PRAZO FIXO COM JUROS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.99.00', 'OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO', 'REGISTRA OUTROS CREDITOS RECEBER E VALORES A CURTO PRAZO, PARA OS QUAIS NAO TENHAM CONTAS ESPECIFICAS NESTE SUBGRUPO DE CONTAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.1.02.01', '(-) AJUSTE DE PERDAS DE CREDITOS ADMINISTRATIVOS', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.1.02.02', '(-) AJUSTE DE PERDAS DE CREDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.1.03.00', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, EXCETO AS DERIVADAS DE CLIENTES DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.1.99.00', '(-) OUTROS AJUSTES DE PERDAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO, NAO CLASSIFICADAS ANTERIORMENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.2.02.01', '(-) AJUSTE DE PERDAS DE CREDITOS ADMINISTRATIVOS', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.2.02.02', '(-) AJUSTE DE PERDAS DE CREDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.2.03.00', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, EXCETO AS DERIVADAS DE CLIENTES DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.2.99.00', '(-) OUTROS AJUSTES DE PERDAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO, NAO CLASSIFICADAS ANTERIORMENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.4.02.01', '(-) AJUSTE DE PERDAS DE CREDITOS ADMINISTRATIVOS', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.4.02.02', '(-) AJUSTE DE PERDAS DE CREDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.4.03.00', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, EXCETO AS DERIVADAS DE CLIENTES DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.4.99.00', '(-) OUTROS AJUSTES DE PERDAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO, NAO CLASSIFICADAS ANTERIORMENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.5.02.01', '(-) AJUSTE DE PERDAS DE CREDITOS ADMINISTRATIVOS', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.5.02.02', '(-) AJUSTE DE PERDAS DE CREDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.5.03.00', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, EXCETO AS DERIVADAS DE CLIENTES DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.5.99.00', '(-) OUTROS AJUSTES DE PERDAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO', 'REGISTRA O AJUSTE DE PERDAS ESTIMADAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO, NAO CLASSIFICADAS ANTERIORMENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.01.00', 'TITULOS DA DIVIDA AGRARIA - TDA', 'REGISTRA OS VALORES RELATIVOS AOS TITULOS DA DIVIDA AGRARIA, EMITIDOS E EM CIRCULACAO, PARA FINS DE INDENIZACOES DE PROPRIEDADES RURAIS, COM OBJETIVO DE REFORMA AGRARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.02.00', 'TITULOS DA DIVIDA - RESERVA BACEN', 'REGISTRA OS VALORES DE TITULOS DA RESERVA DO BACEN, EMITIDOS POR GOVERNOS OU ORGANISMOS INTERNACIONAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.03.01', 'TITULOS PUBLICOS - MERCADO ABERTO (EXCETO FSB)', 'REGISTRA O VALOR RELATIVO A TITULOS PUBLICOS, EMITIDOS E EM CIRCULACAO NO MERCADO ABERTO PARA FINS DE NEGOCIACAO NO MERCADO DE ACOES, EXCETO AQUELES EM FAVOR DO FUNDO SOBERANO DO BRASIL (FSB).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.03.02', 'TITULOS PUBLICOS - MERCADO ABERTO (FSB)', 'REGISTRA O VALOR RELATIVO A TITULOS PUBLICOS, EMITIDOS E EM CIRCULACAO NO MERCADO ABERTO PARA FINS DE NEGOCIACAO NO MERCADO DE ACOES, EM FAVOR DO FUNDO SOBERANO DO BRASIL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.04.01', 'ACOES - FAD/FND', 'REGISTRA AS ACOES DEPOSITADAS NO FAD E/OU FND E AS ALIENAVEIS POR MEIO DE ADESAO A OFERTA PUBLICA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.04.02', 'DEMAIS ACOES', 'REGISTRA OS VALORES DAS DAS DEMAIS ACOES REPRESENTATIVAS DAS PARTICIPACOES DOS ORGAOS E ENTIDADES NO CAPITAL DAS SOCIEDADES POR ACOES HAVIDAS POR AQUISICOES, SUBSCRICOES, BONIFICACOES E DOACOES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.05.00', 'BONUS', 'REGISTRA OS BONUS, COMO CUPONS DE BONUS DA UNESCO, DESTINADOS A PAGAMENTO DE BOLSAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.06.00', 'COTAS DO FUNDO NACIONAL DE DESENVOLVIMENTO (FND)', 'REGISTRA OS VALORES PERTINENTES AS COTAS DO FND, SUBSCRITAS PELA UNIAO OU PELA ADMINISTRACAO FEDERAL INDIRETA (DECRETO NR. 93.538, DE 06.11.86).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.07.01', 'OPERACOES COM DERIVATIVOS - SWAP', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE OPERACOES COM DERIVATIVOS SWAP.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.07.02', 'OPERACOES COM DERIVATIVOS - FORWARD', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE OPERACOES COM DERIVATIVOS FORWARD .', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.07.03', 'OPERACOES COM DERIVATIVOS - FUTUROS', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE OPERACOES COM DERIVATIVOS FUTUROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.07.04', 'OPERACOES COM DERIVATIVOS - TERMO', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE OPERACOES COM DERIVATIVOS TERMO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.07.05', 'OPERACOES COM DERIVATIVOS - BACEN', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE OPERACOES COM DERIVATIVOS REALIZADAS PELO BANCO CENTRAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.07.06', 'OPERACOES COM OPCOES DE COMPRA', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE OPERACOES COM OPCOES DE COMPRA (CALLS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.07.07', 'OPERACOES COM OPCOES DE VENDA', 'REGISTRA OS VALORES A RECEBER DECORRENTES DE OPERACOES COM OPCOES DE VENDA (PUTS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.08.00', 'TITULOS E VALORES MOBILIARIOS EM TRANSITO', 'REGISTRA OS TITULOS E VALORES MOBILIARIOS EM TRANSITO, DEVIDO A TRANSFERENCIAS EFETUADAS ENTRE UNIDADES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.01', 'TITULOS DE RESPONSABILIDADE DO TESOURO', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM TITULOS DE EMISSAO DO TESOURO NACIONAL, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO I, ALINEA A(INCLUI OPERACOES COMPROMISSADAS) DA RESOLUCAO CMN N° 3.790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.02', 'TITULOS DE RESPONSABILIDADE DO BANCO CENTRAL', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM TITULOS DE EMISSAO DO BANCO CENTRAL DO BRASIL; SALDOS REMANESCENTES PARA RESGATES, CONSIDERANDO QUE O BC NAO EMITE MAIS TITULOS DA DIVIDA PUBLICA- ART 34 LC 101/2000.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.03', 'POUPANCA', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS EM POUPANCA E SEUS RENDIMENTOS (JUROS E ATUALIZAÇAO MONETARIA) POSTERIORES', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.04', 'FUNDOS DE INVESTIMENTO EM RENDA FIXA', 'APRESENTAR OS INVESTIMENTOS REALIZADOS PELOS RPPS, EM FUNDOS DE INVESTIMENTOS EM RENDA FIXA, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO V, DA RESOLUCAO CMN N° 3.790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.05', 'FUNDO DE INVESTIMENTO EM RENDA FIXA - CREDITO PRIVADO', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS PREVIDENCIARIOS, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO III, ALINEA B DA RESOLUCAO CMN N° 3.790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.06', 'FUNDOS DE INVESTIMENTOS REFERENCIADOS', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS REFERENCIADOS, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO III, ALINEA A, DA RESOLUCAO CMN N° 3.790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.07', 'FUNDOS DE INVESTIMENTOS EM DIREITOS CREDITORIOS', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS EM DIREITO CREDITORIO, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO VI E VII, DA RESOLUCAO CMN N° 3.790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.08', 'FUNDOS DE INVESTIMENTOS EM TITULOS DO TESOURO', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS EM TITULOS DO TESOURO, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO I,ALINEA B DA RESOLUCAO CMN N° 3.790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.09', 'OPERACOES COMPROMISSADAS', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM OPERACOES COMPROMISSADAS, EFETUADOS EM CONFORMIDADE COM O ART.6º , INCISO II, DA RESOLUCAO CMN N° 3.790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.10.01', 'FUNDOS DE INVESTIMENTOS PREVIDENCIARIOS', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE INVESTIMENTOS PREVIDENCIARIOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO I, DA RESOLUCAO CMN N° 3.790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.10.02', 'FUNDOS DE ACOES', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE ACOES, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO III, DA RESOLUCAO CMN N° 3.790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.10.03', 'FUNDO MULTIMERCADO', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE MULTIMERCADO, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO IV, DA RESOLUCAO CMN N° 3.790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.10.04', 'FUNDOS DE INDICES REFERENCIADOS EM ACOES', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INDICES REFERENCIADOS EM ACOES, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCI SO II, DA RESOLUCAO CMN N° 3.790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.10.05', 'FUNDOS DE INVESTIMENTOS EM PARTICIPACOES', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS EM PARTICIPACOES, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO V, DA RESOLUCAO CMN N° 3.790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.11.00', 'FUNDOS DE INVESTIMENTOS IMOBILIARIOS - RPPS', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE INVESTIMENTOS IMOBILIARIOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO VI, DA RESOLUCAO CMN N° 3.790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.12.00', 'TITULOS E VALORES EM ENQUADRAMENTO - RPPS', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM DESACORDO COM AS REGRAS ESTABELECIDAS PELA RESOLUCAO CMN Nº 3790/2009, ARTIGO 25.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.13.00', 'TITULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO - RPPS', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM ATIVOS NAO SUJEITOS AS REGRAS DA RESOLUCAO CMN Nº 3790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.14.00', 'APLICACOES COM A TAXA DE ADMINISTRACAO DO RPPS', 'REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, COM RECURSOS DA TAXA DE ADMINISTRACAO, SUJEITOS AS REGRAS DA RESOLUCAO CMN Nº 3790/2009.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.99.00', 'OUTROS TITULOS E VALORES MOBILIARIOS', 'REGISTRA A ENTRADA DE OUTROS TITULOS E VALORES MOBILIARIOS NAO CONTEMPLADOS NO PLANO DE CONTAS, PROVENIENTES DE AQUISICAO, DOACAO E DEVOLUCAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.2.1.01.00', 'APLICACAO TEMPORARIA EM OURO', 'REGISTRA AS APLICACOES DE RECURSOS EM OURO, DEPOSITADOS NO BANCO CENTRAL DO BRASIL,DE ACORDO COM A LEI Nº 4595/64.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.2.1.99.00', 'APLICACAO TEMPORARIA EM OUTROS METAIS PRECIOSOS', 'REGISTRA O VALOR REFERENTE AS APLICACOES EM DEMAIS METAIS PRECIOSOS, DEPOSITADOS NO BANCO CENTRAL DO BRASIL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.9.1.01.00', '(-)AJUSTES DE PERDAS COM TITULOS E VALORES MOBILIARIOS', 'REGISTRA OS VALORES DE AJUSTES PARA PERDAS ESTIMADAS EM TITULOS E VALORES MOBILIARIOS A CURTO PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.9.1.02.00', 'AJUSTES DE PERDAS COM APLICACOES TEMPORARIAS EM METAIS PRECIOSOS', 'REGISTRA OS VALORES DE AJUSTES PARA PERDAS ESTIMADAS EM APLICACOES EM OURO E OUTROS METAIS PRECIOSOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.01.01', 'MERCADORIAS PARA VENDA OU REVENDA', 'REGISTRA O VALOR DAS MERCADORIAS PARA VENDA OU REVENDA E DOACOES RELATIVAS A ESTOQUES DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.01.02', 'MERCADORIAS EM CONSIGNACOES PARA REVENDA', 'REGISTRA O VALOR DAS MERCADORIAS EM CONSIGNACAO PARA REVENDA - REDE SOMAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.01.03', 'MERCADORIAS - ESTOQUE POR ATACADO', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA - ATACADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.02.01', 'MERCADORIAS - ESTOQUES ESTRATEGICOS', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES ESTRATEGICOS DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.02.02', 'MERCADORIAS - ESTOQUE REGULADORES PGPM', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES REGULADORES- PGPM DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.02.03', 'MERCADORIAS - ESTOQUE EGF ESP. PGPM(DEP. JUDICIAL)', 'REGISTRA O VALOR DAS MERCADORIAS DE EGFS ESPECIAIS ORIUNDOS DO BANCO DO BRASIL, PARA REVENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.02.04', 'MERCADORIAS - ESTOQUES AGRICULTURA FAMILIAR', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS AO PROGRAMA DE AGRICULTURA FAMILIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.02.05', 'MERCADORIAS - ESTOQUES MERCADO DE OPCOES', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES DE MERCADO DE OPCOES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.02.06', 'MERCADORIAS - ESTOQUES PROGRAMA FOME ZERO', 'REGISTRA O VALOR DAS MERCADORIAS E PRODUTOS RECEBIDOS POR DOACAO, CUJA FINALIDADE E SER REVERTIDO EM FUNDOS PARA O PROGRAMA FOME ZERO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.02.07', 'MERCADORIAS - ESTOQUES FUNCAFE', 'REGISTRA O VALOR DOS ESTOQUES DE CAFE TRANSFERIDOS DO FUNCAFE PARA A CONAB.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.03.01', 'MERCADORIAS EM ARMAZENS DE TERCEIROS PARA REVENDA', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES PROPRIOS EM ARMAZENS DE TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.03.02', 'MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES ESTRATEGICOS', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES ESTRATEGICOS DO GOVERNO FEDERAL EM ARMAZENS DE TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.03.03', 'MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES REGULADORES PGPM', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES REGULADORES - PGPM DO GOVERNO FEDERAL EM ARMAZENS DE TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.03.04', 'MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES POR ATACADO', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES POR ATACADO MANTIDOS EM EM ARMAZENS DE TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.03.05', 'MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES AGRICULTURA FAMILIAR', 'REGISTRA O VALOR DAS MERCADORIAS DO PROGRAMA NACIONAL DE COMPRA DA PRODUCAO DA AGRICULTURA FAMILIAR EM ARMAZENS DE TERCEIROS, ORIUNDAS DE AQUISICAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.03.06', 'MERCADORIAS - ESTOQUE EGF ESP. PGPM(DEP. JUDICIAL)', 'REGISTRA O VALOR DAS MERCADORIAS DE EGFS ESPECIAIS, ORIUNDAS DO BANCO DO BRASIL, EM ARMAZENS DE TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.2.1.01.00', 'PRODUTOS ACABADOS', 'REGISTRA O VALOR DE PRODUTOS MANUFATURADOS JA TERMINADOS, ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPOSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.2.1.02.00', 'SERVICOS ACABADOS', 'REGISTRA OS VALORES PERTINENTES A SERVICOS ACABADOS QUE ESTAO PENDENTES DE FATURAMENTO OU DE TRANSFERENCIA PARA OUTRAS CONTAS DO ATIVO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.3.1.01.00', 'PRODUTOS EM ELABORACAO', 'REGISTRA A TOTALIDADE DAS MATERIAS-PRIMAS JA REQUISITADAS QUE ESTAO EM PROCESSO DE TRANSFORMACAO E O MONTANTE DE CUSTOS DIRETOS E INDIRETOS RELATIVOS AOS PRODUTOS EM ELABORACAO NAO CONCLUIDOS NA DATA DO BALANCO PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.3.1.02.00', 'SERVICOS EM ELABORACAO', 'REGISTRA OS CUSTOS DIRETOS E INDIRETOS RELATIVOS AOS SERVICOS EM ELABORACAO NAO CONCLUIDOS NA DATA DO BALANCO PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.4.1.01.00', 'MATERIAS-PRIMAS - ARMAZENS PROPRIOS', 'REGISTRA O ESTOQUE DE MATERIAS-PRIMAS QUE SERAO UTILIZADOS NO PROCESSO PRODUTIVO, GUARDADAS EM ARMAZENS PROPRIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.4.1.02.00', 'MATERIAS-PRIMAS - ARMAZENS DE TERCEIROS', 'REGISTRA O ESTOQUE DE MATERIAS-PRIMAS QUE SERAO UTILIZADOS NO PROCESSO PRODUTIVO, GUARDADAS EM ARMAZENS DE TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.01.00', 'ESTOQUES MERCADORIAS PARA REVENDA EM TRANSITO', 'REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS A ESTOQUES PROPRIOS DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.02.00', 'ESTOQUES POR ATACADO EM TRANSITO', 'REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DO ESTOQUE POR ATACADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.03.00', 'ESTOQUES ESPECIAIS DE PRODUTOS EM PROCESSO DE AQUISICAO', 'REGISTRA O VALOR DOS PRODUTOS EM PROCESSO DE AQUISICAO RELATIVOS A RESTOS A PAGAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.04.00', 'ESTOQUES PUBLICOS ESTRATEGICOS EM TRANSITO', 'REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DOS ESTOQUES ESTRATEGICOS DE NATUREZA PUBLICA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.05.00', 'ESTOQUES PUBLICOS REGULADORES-PGPM EM TRANSITO', 'REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DOS ESTOQUES REGULADORES - PGPM.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.06.00', 'ESTOQUES PUBLICOS AGRICULTURA FAMILIAR EM TRANSITO', 'REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DOS ESTOQUES DA AGRICULTURA FAMILIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.07.00', 'MERCADORIAS PARA DOACAO EM TRANSITO', 'REGISTRA O VALOR DAS MERCADARIAS PARA DOACAO, EM TRANSITO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.08.00', 'ESTOQUES AGRICULTURA FAMILIAR PARA DOACAO EM TRANSITO', 'REGISTRA O VALOR DE MERCADORIAS DO PROGRAMA NACIONAL DE COMPRA DA PRODUCAO DA AGRICULTURA FAMILIAR PARA DOACAO EM TRANSITO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.09.00', 'PRODUTOS PARA PESQUISA EM TRANSITO', 'REGISTRA O VALOR DOS MATERIAIS EM TRANSITO RELATIVOS AS TRANSFERENCIAS ENTRE UG, DE PRODUTOS PARA PESQUISA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.10.01', 'MATERIAL DE CONSUMO EM TRANSITO - TRANSFERENCIAS DO EXERCICIO', 'REGISTRA OS VALORES DOS MATERIAIS DE CONSUMO EM TRANSITO, RELATIVOS A TRANSFERENCIAS EFETUADAS ENTRE UNIDADES, NO EXERCICIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.10.02', 'MATERIAL DE CONSUMO EM TRANSITO - TRANSFERENCIAS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES DOS MATERIAIS DE CONSUMO EM TRANSITO, RELATIVOS A TRANSFERENCIAS EFETUADAS ENTRE UNIDADES, NO EXERCICIO ANTERIOR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.01.00', 'MATERIAL DE CONSUMO', 'REGISTRA OS VALORES DOS MATERIAIS DE CONSUMO ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.02.00', 'GENEROS ALIMENTICIOS', 'REGISTRA OS VALORES DOS GENEROS ALIMENTICIOS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.03.00', 'MATERIAIS DE CONSTRUCAO', 'REGISTRA OS VALORES DOS MATERIAIS DE CONSTRUCAO ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.04.00', 'MATERIAIS DE TELECOMUNICACOES', 'REGISTRA OS VALORES DOS MATERIAIS DE TELECOMUNICACOES ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.05.00', 'AUTOPECAS', 'REGISTRA OS VALORES DE AUTOPECAS ADQUIRIDAS E ESTOCADAS EM ALMOXARIFADOS, DESTINADAS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.06.00', 'MEDICAMENTOS E MATERIAIS HOSPITALARES', 'REGISTRA OS VALORES DOS MEDICAMENTOS E MATERIAS HOSPITALARES ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.07.00', 'MATERIAIS GRAFICOS', 'REGISTRA OS VALORES DOS MATERIAIS GRAFICOS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.08.00', 'MATERIAL DE EXPEDIENTE', 'REGISTRA OS VALORES DOS MATERIAIS DE EXPEDIENTE ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.09.00', 'MATERIAIS A CLASSIFICAR', 'REGISTRA OS VALORES DOS MATERIAIS ESTOCADOS PENDENTES DE CLASSIFICACAO E IDENTIFICACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.10.00', 'ESTOQUE SOBRESSALENTES A ALIENAR', 'REGISTRA OS VALORES DE BENS SOBRESSALENTES QUE ESTEJAM DISPONIVEIS PARA ALIENACAO SOB DIVERSAS FORMAS (VENDA, LEILA, ETC)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.11.00', 'ESTOQUE SOBRESSALENTES EM REPARO', 'REGISTRA OS VALORES DE PECAS EM FASE DE RECONDICIONAMENTO QUE FORAM SUBSTITUIDAS POR MANUTENCAO PERIODICA OU QUEBRA. APOS REVISAO, RETORNARAO AO ESTOQUE DE PECAS DE REPOSICAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.12.00', 'ESTOQUE SOBRESSALENTES A REPARAR', 'REGISTRA OS VALORES DE PECAS QUE FORAM SUBSTITUIDAS POR MANUTENCAO PERIODICA OU QUEBRA E AINDA NAO FORAM ENCAMINHADAS PARA REPARO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.13.00', 'ESTOQUE - SELOS DE CONTROLE - RECEITA FEDERAL DO BRASIL', 'REGISTRA O ESTOQUE DE SELOS DE CONTROLE DO IPI UTILIZADOS PELAS DELEGACIAS DA RECEITA FEDERAL DO BRASIL - RFB NO CONTROLE SOBRE A PRODUCAO E IMPORTACAO DE CIGARROS, BEBIDAS ALCOOLICAS, RELOGIOS, ENTRE OUTRAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.7.1.00.00', 'ADIANTAMENTOS A FORNECEDORES - CONSOLIDACAO', 'REGISTRA OS ADIANTAMENTOS EFETUADOS PELA ENTIDADE A FORNECEDORES, VINCULADOS A COMPRAS ESPECIFICAS DE MATERIAIS QUE SERAO INCORPORADOS AOS ESTOQUES QUANDO DE SEU EFETIVO RECEBIMENTO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.01.00', 'MATERIAIS DE ACONDICIONAMENTO E EMBALAGEM', 'REGISTRA OS VALORES DE ESTOQUE QUE SE DESTINAM A EMBALAGEM DO PRODUTO OU A SEU ACONDICIONAMENTO PARA REMESSA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.02.01', 'MATERIAL DE CONSUMO - ESTOQUE INTERNO - DESTINADO A DISTRIBUICAO', 'REGISTRA OS VALORES RELATIVOS AS AQUISICOES E OU TRANSFERENCIAS DE MATERIAIS DE CONSUMO PARA A FORMACAO DE ESTOQUE INTERNO DESTINADO A DISTRIBUICAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.02.02', 'MATERIAL DE CONSUMO - ESTOQUE EM ARMAZEM DE TERCEIROS - DESTINADO A DISTRIBUICAO', 'REGISTRA OS VALORES RELATIVOS AS AQUISICOES E OU TRANSFERENCIAS DE MATERIAIS DE CONSUMO PARA A FORMACAO DE ESTOQUE ,MANTIDO EM ARMAZEM DE TERCEIROS, DESTINADO A DISTRIBUICAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.02.03', 'MEDICAMENTOS - ESTOQUE INTERNO - DESTINADO A DISTRIBUICAO', 'REGISTRA OS VALORES DOS MEDICAMENTOS E OUTROS PRODUTOS FARMACEUTICOS, ADQUIRIDOS OU FABRICADOS PELA UNIDADE, DESTINADOS A FORMACAO DE ESTOQUE DE DISTRIBUICAO PARA CONSUMO INTERNO OU REDISTRIBUICAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.02.04', 'MEDICAMENTOS - ESTOQUE EM ARMAZEM DE TERCEIROS - DESTINADO A DISTRIBUICAO', 'REGISTRA OS VALORES RELATIVOS A AQUISICOES E OU TRANSFERENCIAS DE MEDICAMENTOS, PARA A FORMACAO DE ESTOQUE, MANTIDO EM ARMAZEM DE TERCEIROS, DESTINADO A DISTRIBUICAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.02.05', 'ESTOQUE DE MATERIAIS PARA PREMIACOES', 'REGISTRA OS VALORES DAS PREMIACOES COMO: MEDALHAS E PLACAS DESTINADOS A FORMACAO DE ESTOQUE DE DISTRIBUICAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.03.01', 'MERCADORIAS PARA DOACAO - ESTOQUE INTERNO', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, MANTIDAS EM ARMAZENS PROPRIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.03.02', 'MERCADORIAS PARA DOACAO - ARMAZEM DE TERCEIROS', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, MANTIDAS EM ARMAZENS DE TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.03.03', 'MERCADORIAS PARA DOACAO - AGRICULTURA FAMILIAR- ESTOQUE INTERNO', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, DEPOSITADAS EM ARMAZENS PROPRIOS, RELATIVAS AO PROGRAMA DE AGRICULTURA FAMILIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.03.04', 'MERCADORIAS PARA DOACAO - AGRICULTURA FAMILIAR- ARMAZEM DE TERCEIROS', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, DEPOSITADAS EM ARMAZENS DE TERCEIROS, RELATIVAS AO PROGRAMA DE AGRICULTURA FAMILIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.03.05', 'MERCADORIAS PARA PERMUTA', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS COM A FINALIDADE DE PERMUTA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.04.01', 'ANIMAIS', 'REGISTRA O VALOR DOS ANIMAIS ADQUIRIDOS E DESTINADOS A PESQUISA DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.04.02', 'VEGETAIS', 'REGISTRA O VALOR DO VEGETAIS ADQUIRIDOS E DESTINADOS A PESQUISA DA ENTIDADE, BEM COMO PRODUTOS INDUSTRIALIZADOS TAIS COMO: VINHOS, SUCOS , VINAGRES E PUBLICACOES TECNICAS DE PESQUISAS', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.04.03', 'MINERAIS', 'REGISTRA O VALOR DOS MINERAIS ADQUIRIDOS E DESTINADOS A PESQUISA DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.05.01', 'IMPORTACOES EM ANDAMENTO DO EXERCICIO', 'REGISTRA O VALOR DAS IMPORTACOES EM ANDAMENTO DE BENS DE ESTOQUE, DURANTE O EXERCICIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.05.02', 'IMPORTACOES EM ANDAMENTO DE EXERCICIOS ANTERIORES', 'REGISTRA O VALOR DAS IMPORTACOES EM ANDAMENTO DE BENS DE ESTOQUE, INICIADAS EM EXERCICIOS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.06.01', 'TERRENOS', 'REGISTRA OS VALORES DE TERRENOS, INCLUINDO-SE OS CUSTOS DE FORMACAO OU DE URBANIZACAO E AJUSTES MONETARIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.06.02', 'PROJETOS', 'REGISTRA OS VALORES DOS CUSTOS RELATIVOS AOS PROJETOS DE ARQUITETURA E URBANISMO PARA CONSTRUCOES E URBANIZACOES DE IMOVEIS QUE DEVERAO SER COLOCADOS A VENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.06.03', 'OBRAS EM ANDAMENTO', 'REGISTRA OS VALORES RELATIVOS A OBRAS EM ANDAMENTO, DESTINADAS A VENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.06.04', 'OBRAS CONCLUIDAS A COMERCIALIZAR', 'REGISTRA OS VALORES RELATIVOS AS CONSTRUCOES E AS EDIFICACOES CONCLUIDAS QUE DEVERAO SER COLOCADAS A VENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.06.05', 'CUSTOS ACESSORIOS DE CONSTRUCAO CIVIL', 'REGISTRA OS VALORES DE SEGUROS, REMUNERACOES A AGENTES FINANCEIROS, IMPOSTOS E TAXAS, DESPESAS COM LEGALIZACOES E CARTORARIAS RELATIVOS A IMOVEIS DESTINADOS A VENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.06.06', 'IMOVEIS RETOMADOS', 'REGISTRA OS VALORES DE IMOVEIS RETOMADOS DE MUTUARIOS INADIMPLENTES, POR MEIO DE EXECUCAO JUDICIAL, QUE SERAO COLOCADOS A VENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.98.00', 'ESTOQUES DIVERSOS', 'REGISTRA OS ESTOQUES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.9.1.01.00', '(-) AJUSTE DE PERDAS EM ESTOQUES', 'REGISTRA AS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NAO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NAO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.9.1.02.00', '(-) AJUSTE PARA REDUCAO AO VALOR DE MERCADO', 'REGISTRA O AJUSTE PARA OS ESTOQUES QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.1.1.00.00', 'PREMIOS DE SEGUROS A APROPRIAR - CONSOLIDACAO', 'REGISTRA OS VALORES PAGOS A TITULO DE PREMIOS DE SEGURO A APROPRIAR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.2.1.00.00', 'VPD FINANCEIRAS A APROPRIAR - CONSOLIDACAO', 'COMPREENDE OS VALORES PAGOS A TITULO DE VPD FINANCEIRAS A APROPRIAR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.2.2.00.00', 'VPD FINANCEIRAS A APROPRIAR - INTRA OFSS', 'COMPREENDE OS VALORES PAGOS A TITULO DE VPD FINANCEIRAS A APROPRIAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.2.4.00.00', 'VPD FINANCEIRAS A APROPRIAR - INTER OFSS - ESTADO', 'COMPREENDE OS VALORES PAGOS A TITULO VPD FINANCEIRAS A APROPRIAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.2.5.00.00', 'VPD FINANCEIRAS A APROPRIAR - INTER OFSS - MUNICIPIO', 'COMPREENDE OS VALORES PAGOS A TITULO DE VPD FINANCEIRAS A APROPRIAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.3.1.00.00', 'ASSINATURAS E ANUIDADES A APROPRIAR - CONSOLIDACAO', 'REGISTRA OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.3.2.00.00', 'ASSINATURAS E ANUIDADES A APROPRIAR - INTRA OFSS', 'REGISTRA OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.3.4.00.00', 'ASSINATURAS E ANUIDADES A APROPRIAR - INTER OFSS - ESTADO', 'REGISTRA OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.3.5.00.00', 'ASSINATURAS E ANUIDADES A APROPRIAR - INTER OFSS - MUNICIPIO', 'REGISTRA OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.4.1.00.00', 'ALUGUEIS PAGOS A APROPRIAR - CONSOLIDACAO', 'REGISTRA OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.4.2.00.00', 'ALUGUEIS PAGOS A APROPRIAR - INTRA OFSS', 'REGISTRA OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.4.4.00.00', 'ALUGUEIS PAGOS A APROPRIAR - INTER OFSS - ESTADO', 'REGISTRA OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.4.5.00.00', 'ALUGUEIS PAGOS A APROPRIAR - INTER OFSS - MUNICIPIO', 'REGISTRA OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.5.1.00.00', 'TRIBUTOS PAGOS A APROPRIAR - CONSOLIDACAO', 'REGISTRA OS VALORES PAGOS A TITULO DE TRIBUTOS A APROPRIAR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.5.2.00.00', 'TRIBUTOS PAGOS A APROPRIAR - INTRA OFSS', 'REGISTRA OS VALORES PAGOS A TITULO DE TRIBUTOS A APROPRIAR.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.5.4.00.00', 'TRIBUTOS PAGOS A APROPRIAR - INTER OFSS - ESTADO', 'REGISTRA OS VALORES PAGOS A TITULO DE TRIBUTOS A APROPRIAR.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.5.5.00.00', 'TRIBUTOS PAGOS A APROPRIAR - INTER OFSS - MUNICIPIO', 'REGISTRA OS VALORES PAGOS A TITULO DE TRIBUTOS A APROPRIAR.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.6.1.00.00', 'CONTRIBUICOES CONFEDERATIVAS A APROPRIAR - CONSOLIDACAO', 'REGISTRA OS VALORES PAGOS A TITULO DE CONTRIBUICOES CONFEDERATIVAS A APROPRIAR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.7.1.00.00', 'BENEFICIOS A PESSOAL A APROPRIAR - CONSOLIDACAO', 'REGISTRA OS VALORES PAGOS A TITULO DE BENEFICIO A PESSOAL A APROPRIAR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.1.01.00', 'DIREITOS AUTORAIS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE DIREITOS AUTORAIS A SEREM APROPRIADOS QUANDO DA EFETIVACAO DA VPD.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.1.02.00', 'COMISSOES E PREMIOS PAGOS A APROPRIAR', 'REGISTRA OS PAGAMENTOS NAO RESTITUIVEIS A VENDEDORES OU REPRESENTANTES POR CONTA DE COMISSOES OU DE PREMIOS POR VENDAS QUE A ENTIDADE AINDA NAO CONTABILIZOU COMO VARIACOES PATRIMONIAIS AUMENTATIVAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.1.03.00', 'DESPESA A APROPRIAR POR PENDENCIA DE INFORMACOES', 'REGISTRA OS VALORES PAGOS REFERENTES A DESPESAS REALIZADAS E NAO APROPRIADAS POR PENDENCIAS DE INFORMACOES OPERACIONAIS OU DETALHAMENTOS, CUJAS CONDICOES ESTEJAM LEGALMENTE AMPARADAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.1.99.00', 'OUTRAS VPD A APROPRIAR', 'REGISTRA OUTROS VALORES PAGOS A APROPRIAR QUANDO DA EFETIVACAO DA VPD.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.2.03.00', 'DESPESA A APROPRIAR POR PENDENCIA DE INFORMACOES', 'REGISTRA OS VALORES PAGOS REFERENTES A DESPESAS REALIZADAS E NAO APROPRIADAS POR PENDENCIAS DE INFORMACOES OPERACIONAIS OU DETALHAMENTOS, CUJAS CONDICOES ESTEJAM LEGALMENTE AMPARADAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.2.99.00', 'OUTRAS VPD A APROPRIAR', 'REGISTRA OUTROS VALORES PAGOS A APROPRIAR QUANDO DA EFETIVACAO DA VPD.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.4.03.00', 'DESPESA A APROPRIAR POR PENDENCIA DE INFORMACOES', 'REGISTRA OS VALORES PAGOS REFERENTES A DESPESAS REALIZADAS E NAO APROPRIADAS POR PENDENCIAS DE INFORMACOES OPERACIONAIS OU DETALHAMENTOS, CUJAS CONDICOES ESTEJAM LEGALMENTE AMPARADAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.4.99.00', 'OUTRAS VPD A APROPRIAR', 'REGISTRA OUTROS VALORES PAGOS A APROPRIAR QUANDO DA EFETIVACAO DA VPD.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.5.03.00', 'DESPESA A APROPRIAR POR PENDENCIA DE INFORMACOES', 'REGISTRA OS VALORES PAGOS REFERENTES A DESPESAS REALIZADAS E NAO APROPRIADAS POR PENDENCIAS DE INFORMACOES OPERACIONAIS OU DETALHAMENTOS, CUJAS CONDICOES ESTEJAM LEGALMENTE AMPARADAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.5.99.00', 'OUTRAS VPD A APROPRIAR', 'REGISTRA OUTROS VALORES PAGOS A APROPRIAR QUANDO DA EFETIVACAO DA VPD.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.01.01', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUES ESTRATEGICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.01.02', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. REGULADORES PGPM', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADORES DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.01.03', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUE PROPRIO', 'REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.01.04', 'FATURAS/ DUPLICATAS A RECEBER - ABASTECIMENTO SOCIAL', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.01.05', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. POR ATACADO', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.01.06', 'FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.01.99', 'OUTRAS FATURA/ DUPLICATAS A RECEBER', 'REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.02.00', 'CREDITOS TRIBUTARIOS A RECEBER', 'REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER COM VENCIMENTO NO LONGO PRAZO, ORIUNDOS DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TRIBUTARIAS.OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.03.01', 'CREDITOS NAO PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.03.02', 'CREDITOS PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.04.00', 'DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES', 'REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA DERIVADOS DE CLIENTES , EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.01', 'EMPRESTIMOS CONCEDIDOS A RECEBER', 'REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.02', 'EMPRESTIMOS EM COBRANCA JUDICIAL A RECEBER', 'REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.03', 'EMPRESTIMOS A RECEBER - RPPS', 'REGISTRA OS VALORES DOS ATIVOS RELATIVOS A EMPRESTIMOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL, REALIZAVEIS NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.04', 'EMPRESTIMOS A DIRETORES, ACIONISTAS OU PARTICIPANTES NO LUCRO DA COMPANHIA', 'REGISTRA O SOMATORIO DOS VALORES DE EMPRESTIMOS CONCEDIDOS A DIRETORES E ACIONISTAS OU OUTROS PARTICIPANTES NO LUCRO, TAIS COMO OS DETENTORES DE PARTES BENEFICIARIAS OU DEBENTURES, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.05', 'EMPRESTIMOS A SOCIEDADES COLIGADAS OU CONTROLADAS', 'REGISTRA O SOMATORIO DOS VALORES DE EMPRESTIMOS CONCEDIDOS A SOCIEDADES COLIGADAS E CONTROLADAS, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.06', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.07', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.08', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO, EXCETO OS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.09', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO, REFERENTES AOS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.10', 'FINANCIAMENTOS A RECEBER - RPPS', 'REGISTRA OS VALORES DOS ATIVOS RELATIVOS A FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL, REALIZAVEIS NO LONGO PRAZO (EXEMPLO: FINANCIAMENTOS IMOBILIARIOS)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.11', 'FINANCIAMENTOS EM COBRANCA JUDICIAL A RECEBER', 'REGISTRA OS VALORES RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.12', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, EXCETO OS RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.13', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.14', 'CREDITOS DE OPERACOES ESPECIAIS A RECEBER', 'REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS A RECEBER, INCLUSIVE JUROS E MULTAS, UTILIZADAS NORMALMENTE PELA COORDENACAO-GERAL DAS OPERACOES DE CREDITO DO TESOURO NACIONAL - COPEC.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.15', 'OPERACOES ESPECIAIS C/ PARTICIPACOES GOVERNAMENTAIS', 'REGISTRAR OS VALORES DAS OPERACOES DE CREDITO ENTRE A UNIAO E OS ESTADOS, RELATIVOS A PARTICIPACAO GOVERNAMENTAL OBRIGATORIA NAS MODALIDADES ROYALTIES, PARTICIPACOES ESPECIAIS E COMPENSACOES FINANCEIRAS, REFERENTES A MP 2.181-45 DE 24/08/01, COM ALTERACOES IMPLEMENTADAS PELA LEI N. 10.712/2003.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.16', 'JUROS A RECEBER - OPERACOES ESPECIAIS', 'REGISTRA OS JUROS RELATIVOS A OPERACOES ESPECIAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.17', 'RELACOES INTERFINANCEIRAS DE FUNDOS CONSTITUCIONAIS', 'REGISTRA OS VALORES DAS OPERACOES COM PERDAS IMPUTAVEIS AO PROAGRO E VALORES DE REPASSES BNB E OUTRAS INSTITUICOES', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.18', 'RESIDUO DE EMPRESTIMOS CONCEDIDOS', 'REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM LONGO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.19', 'EMPRESTIMO COMPULSORIO A RECEBER', 'REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.99.01', '(-) AJUSTE DE PERDAS PARA CREDITOS DE LIQUIDACAO DUVIDOSA', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.99.02', '(-) AJUSTE DE PERDAS DE CREDITOS TRIBUTARIOS', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.99.03', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA TRIBUTARIA', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.99.04', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.99.05', '(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.01.01', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUES ESTRATEGICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.01.02', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. REGULADORES PGPM', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADORES DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.01.03', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUE PROPRIO', 'REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.01.04', 'FATURAS/ DUPLICATAS A RECEBER - ABASTECIMENTO SOCIAL', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.01.05', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. POR ATACADO', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.01.06', 'FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.01.99', 'OUTRAS FATURA/ DUPLICATAS A RECEBER', 'REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.02.00', 'CREDITOS TRIBUTARIOS A RECEBER', 'REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER COM VENCIMENTO NO LONGO PRAZO, ORIUNDOS DA VARIACOES PATRIMONIAIS AUMENTATIVAS TRIBUTARIAS.OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.03.01', 'CREDITOS NAO PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.03.02', 'CREDITOS PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.04.00', 'DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES', 'REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA DERIVADOS DE CLIENTES , EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.01', 'EMPRESTIMOS CONCEDIDOS A RECEBER', 'REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.02', 'EMPRESTIMOS EM COBRANCA JUDICIAL A RECEBER', 'REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.03', 'EMPRESTIMOS A RECEBER - RPPS', 'REGISTRA OS VALORES DOS ATIVOS RELATIVOS A EMPRESTIMOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL, REALIZAVEIS NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.04', 'EMPRESTIMOS A DIRETORES, ACIONISTAS OU PARTICIPANTES NO LUCRO DA COMPANHIA', 'REGISTRA O SOMATORIO DOS VALORES DE EMPRESTIMOS CONCEDIDOS A DIRETORES E ACIONISTAS OU OUTROS PARTICIPANTES NO LUCRO, TAIS COMO OS DETENTORES DE PARTES BENEFICIARIAS OU DEBENTURES, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.05', 'EMPRESTIMOS A SOCIEDADES COLIGADAS OU CONTROLADAS', 'REGISTRA O SOMATORIO DOS VALORES DE EMPRESTIMOS CONCEDIDOS A SOCIEDADES COLIGADAS E CONTROLADAS, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.06', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.07', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.08', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO, EXCETO OS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.09', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO, REFERENTES AOS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.10', 'FINANCIAMENTOS A RECEBER - RPPS', 'REGISTRA OS VALORES DOS ATIVOS RELATIVOS A FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL, REALIZAVEIS NO LONGO PRAZO (EXEMPLO: FINANCIAMENTOS IMOBILIARIOS)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.11', 'FINANCIAMENTOS EM COBRANCA JUDICIAL A RECEBER', 'REGISTRA OS VALORES RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.12', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, EXCETO OS RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.13', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.14', 'CREDITOS DE OPERACOES ESPECIAIS A RECEBER', 'REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS A RECEBER, INCLUSIVE JUROS E MULTAS, UTILIZADAS NORMALMENTE PELA COORDENACAO-GERAL DAS OPERACOES DE CREDITO DO TESOURO NACIONAL - COPEC.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.15', 'OPERACOES ESPECIAIS C/ PARTICIPACOES GOVERNAMENTAIS', 'REGISTRAR OS VALORES DAS OPERACOES DE CREDITO ENTRE A UNIAO E OS ESTADOS, RELATIVOS A PARTICIPACAO GOVERNAMENTAL OBRIGATORIA NAS MODALIDADES ROYALTIES, PARTICIPACOES ESPECIAIS E COMPENSACOES FINANCEIRAS, REFERENTES A MP 2.181-45 DE 24/08/01, COM ALTERACOES IMPLEMENTADAS PELA LEI N. 10.712/2003.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.16', 'JUROS A RECEBER - OPERACOES ESPECIAIS', 'REGISTRA OS JUROS RELATIVOS A OPERACOES ESPECIAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.17', 'RELACOES INTERFINANCEIRAS DE FUNDOS CONSTITUCIONAIS', 'REGISTRA OS VALORES DAS OPERACOES COM PERDAS IMPUTAVEIS AO PROAGRO E VALORES DE REPASSES BNB E OUTRAS INSTITUICOES', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.18', 'RESIDUO DE EMPRESTIMOS CONCEDIDOS', 'REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM LONGO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.19', 'EMPRESTIMO COMPULSORIO A RECEBER', 'REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.99.01', '(-) AJUSTE DE PERDAS PARA CREDITOS DE LIQUIDACAO DUVIDOSA', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.99.02', '(-) AJUSTE DE PERDAS DE CREDITOS TRIBUTARIOS', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.99.03', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA TRIBUTARIA', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.99.04', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.99.05', '(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.01.01', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUES ESTRATEGICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.01.02', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. REGULADORES PGPM', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADORES DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.01.03', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUE PROPRIO', 'REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.01.04', 'FATURAS/ DUPLICATAS A RECEBER - ABASTECIMENTO SOCIAL', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.01.05', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. POR ATACADO', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.01.06', 'FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.01.99', 'OUTRAS FATURA/ DUPLICATAS A RECEBER', 'REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.02.00', 'CREDITOS TRIBUTARIOS A RECEBER', 'REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER COM VENCIMENTO NO LONGO PRAZO, ORIUNDOS DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TRIBUTARIAS.OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.03.01', 'CREDITOS NAO PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.03.02', 'CREDITOS PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.04.00', 'DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES', 'REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA DERIVADOS DE CLIENTES , EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.01', 'EMPRESTIMOS CONCEDIDOS A RECEBER', 'REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.02', 'EMPRESTIMOS EM COBRANCA JUDICIAL A RECEBER', 'REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.03', 'EMPRESTIMOS A RECEBER - RPPS', 'REGISTRA OS VALORES DOS ATIVOS RELATIVOS A EMPRESTIMOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL, REALIZAVEIS NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.04', 'EMPRESTIMOS A DIRETORES, ACIONISTAS OU PARTICIPANTES NO LUCRO DA COMPANHIA', 'REGISTRA O SOMATORIO DOS VALORES DE EMPRESTIMOS CONCEDIDOS A DIRETORES E ACIONISTAS OU OUTROS PARTICIPANTES NO LUCRO, TAIS COMO OS DETENTORES DE PARTES BENEFICIARIAS OU DEBENTURES, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.05', 'EMPRESTIMOS A SOCIEDADES COLIGADAS OU CONTROLADAS', 'REGISTRA O SOMATORIO DOS VALORES DE EMPRESTIMOS CONCEDIDOS A SOCIEDADES COLIGADAS E CONTROLADAS, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.06', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.07', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.08', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO, EXCETO OS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.09', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO, REFERENTES AOS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.10', 'FINANCIAMENTOS A RECEBER - RPPS', 'REGISTRA OS VALORES DOS ATIVOS RELATIVOS A FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL, REALIZAVEIS NO LONGO PRAZO (EXEMPLO: FINANCIAMENTOS IMOBILIARIOS)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.11', 'FINANCIAMENTOS EM COBRANCA JUDICIAL A RECEBER', 'REGISTRA OS VALORES RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.12', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, EXCETO OS RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.13', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.14', 'CREDITOS DE OPERACOES ESPECIAIS A RECEBER', 'REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS A RECEBER, INCLUSIVE JUROS E MULTAS, UTILIZADAS NORMALMENTE PELA COORDENACAO-GERAL DAS OPERACOES DE CREDITO DO TESOURO NACIONAL - COPEC.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.15', 'OPERACOES ESPECIAIS C/ PARTICIPACOES GOVERNAMENTAIS', 'REGISTRAR OS VALORES DAS OPERACOES DE CREDITO ENTRE A UNIAO E OS ESTADOS, RELATIVOS A PARTICIPACAO GOVERNAMENTAL OBRIGATORIA NAS MODALIDADES ROYALTIES, PARTICIPACOES ESPECIAIS E COMPENSACOES FINANCEIRAS, REFERENTES A MP 2.181-45 DE 24/08/01, COM ALTERACOES IMPLEMENTADAS PELA LEI N. 10.712/2003.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.16', 'JUROS A RECEBER - OPERACOES ESPECIAIS', 'REGISTRA OS JUROS RELATIVOS A OPERACOES ESPECIAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.17', 'RELACOES INTERFINANCEIRAS DE FUNDOS CONSTITUCIONAIS', 'REGISTRA OS VALORES DAS OPERACOES COM PERDAS IMPUTAVEIS AO PROAGRO E VALORES DE REPASSES BNB E OUTRAS INSTITUICOES', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.18', 'RESIDUO DE EMPRESTIMOS CONCEDIDOS', 'REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM LONGO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.19', 'EMPRESTIMO COMPULSORIO A RECEBER', 'REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.99.01', '(-) AJUSTE DE PERDAS PARA CREDITOS DE LIQUIDACAO DUVIDOSA', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.99.02', '(-) AJUSTE DE PERDAS DE CREDITOS TRIBUTARIOS', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.99.03', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA TRIBUTARIA', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.99.04', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.99.05', '(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.01.01', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUES ESTRATEGICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.01.02', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. REGULADORES PGPM', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADORES DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.01.03', 'FATURAS/ DUPLICATAS A RECEBER - ESTOQUE PROPRIO', 'REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.01.04', 'FATURAS/ DUPLICATAS A RECEBER - ABASTECIMENTO SOCIAL', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.01.05', 'FATURAS/ DUPLICATAS A RECEBER - ESTQ. POR ATACADO', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.01.06', 'FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.01.99', 'OUTRAS FATURA/ DUPLICATAS A RECEBER', 'REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.02.00', 'CREDITOS TRIBUTARIOS A RECEBER', 'REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER COM VENCIMENTO NO LONGO PRAZO, ORIUNDOS DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TRIBUTARIAS.OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.03.01', 'CREDITOS NAO PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.03.02', 'CREDITOS PREVIDENCIARIOS INSCRITOS', 'REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.04.00', 'DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES', 'REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA DERIVADOS DE CLIENTES , EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.01', 'EMPRESTIMOS CONCEDIDOS A RECEBER', 'REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.02', 'EMPRESTIMOS EM COBRANCA JUDICIAL A RECEBER', 'REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.03', 'EMPRESTIMOS A RECEBER - RPPS', 'REGISTRA OS VALORES DOS ATIVOS RELATIVOS A EMPRESTIMOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL, REALIZAVEIS NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.04', 'EMPRESTIMOS A DIRETORES, ACIONISTAS OU PARTICIPANTES NO LUCRO DA COMPANHIA', 'REGISTRA O SOMATORIO DOS VALORES DE EMPRESTIMOS CONCEDIDOS A DIRETORES E ACIONISTAS OU OUTROS PARTICIPANTES NO LUCRO, TAIS COMO OS DETENTORES DE PARTES BENEFICIARIAS OU DEBENTURES, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.05', 'EMPRESTIMOS A SOCIEDADES COLIGADAS OU CONTROLADAS', 'REGISTRA O SOMATORIO DOS VALORES DE EMPRESTIMOS CONCEDIDOS A SOCIEDADES COLIGADAS E CONTROLADAS, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.06', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.07', 'ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.08', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO, EXCETO OS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.09', 'FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT', 'REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO, REFERENTES AOS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.10', 'FINANCIAMENTOS A RECEBER - RPPS', 'REGISTRA OS VALORES DOS ATIVOS RELATIVOS A FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL, REALIZAVEIS NO LONGO PRAZO (EXEMPLO: FINANCIAMENTOS IMOBILIARIOS)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.11', 'FINANCIAMENTOS EM COBRANCA JUDICIAL A RECEBER', 'REGISTRA OS VALORES RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.12', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - EXCETO RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, EXCETO OS RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.13', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - RECURSOS FAT', 'REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.14', 'CREDITOS DE OPERACOES ESPECIAIS A RECEBER', 'REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS A RECEBER, INCLUSIVE JUROS E MULTAS, UTILIZADAS NORMALMENTE PELA COORDENACAO-GERAL DAS OPERACOES DE CREDITO DO TESOURO NACIONAL - COPEC.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.15', 'OPERACOES ESPECIAIS C/ PARTICIPACOES GOVERNAMENTAIS', 'REGISTRAR OS VALORES DAS OPERACOES DE CREDITO ENTRE A UNIAO E OS ESTADOS, RELATIVOS A PARTICIPACAO GOVERNAMENTAL OBRIGATORIA NAS MODALIDADES ROYALTIES, PARTICIPACOES ESPECIAIS E COMPENSACOES FINANCEIRAS, REFERENTES A MP 2.181-45 DE 24/08/01, COM ALTERACOES IMPLEMENTADAS PELA LEI N. 10.712/2003.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.16', 'JUROS A RECEBER - OPERACOES ESPECIAIS', 'REGISTRA OS JUROS RELATIVOS A OPERACOES ESPECIAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.17', 'RELACOES INTERFINANCEIRAS DE FUNDOS CONSTITUCIONAIS', 'REGISTRA OS VALORES DAS OPERACOES COM PERDAS IMPUTAVEIS AO PROAGRO E VALORES DE REPASSES BNB E OUTRAS INSTITUICOES', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.18', 'RESIDUO DE EMPRESTIMOS CONCEDIDOS', 'REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM LONGO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.19', 'EMPRESTIMO COMPULSORIO A RECEBER', 'REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.99.01', '(-) AJUSTE DE PERDAS PARA CREDITOS DE LIQUIDACAO DUVIDOSA', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.99.02', '(-) AJUSTE DE PERDAS DE CREDITOS TRIBUTARIOS', 'REGISTRA O AJUSTE PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.99.03', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA TRIBUTARIA', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.99.04', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES', 'REGISTRA OS VALORES REFERENTES AO AJUSTE PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.99.05', '(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'REGISTRA OS VALORES DE AJUSTES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.01.01', 'ADIANTAMENTOS CONCEDIDOS A PESSOAL', 'REGISTRA OS VALORES DAS ANTECIPACOES CONCEDIDAS A SERVIDORES E A DIRIGENTES DA UNIDADE.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.01.02', 'ADIANTAMENTOS A UNIDADES E ENTIDADES', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.01.03', 'ADIANTAMENTOS DE TRANSFERENCIAS VOLUNTARIAS', 'REGISTRA OS VALORES RELATIVOS A ADIANTAMENTOS DE RECURSOS FINANCEIROS FORMALIZADOS POR TRANSFERENCIAS VOLUNTARIAS GERADAS A PARTIR DA INTEGRACAO DO PORTAL SICONV COM O SIAFI.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.01.04', 'ADIANTAMENTOS A PRESTADORES DE SERVICOS', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A PRESTADORES DE SERVICOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVICOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.01.05', 'ADIANTAMENTOS A DIRETORES, ACIONISTAS OU PARTICIPANTES NO LUCRO DA COMPANHIA', 'REGISTRA O SOMATORIO DOS VALORES DE ADIANTAMENTOS CONCEDIDOS A DIRETORES E ACIONISTAS OU OUTROS PARTICIPANTES NO LUCRO, TAIS COMO OS DETENTORES DE PARTES BENEFICIARIAS OU DEBENTURES, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.01.06', 'ADIANTAMENTOS A SOCIEDADES COLIGADAS OU CONTROLADAS', 'REGISTRA O SOMATORIO DOS VALORES DE ADIANTAMENTOS CONCEDIDOS A SOCIEDADES COLIGADAS E CONTROLADAS, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.01.99', 'ADIANTAMENTOS DIVERSOS CONCEDIDOS', 'REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NAO CLASSIFICADOS EM CONTAS ANTERIORES.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.01', 'IPI A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IPI A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.02', 'ICMS A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DE ICMS A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.03', 'ICMS DIFERIDO', 'REGISTRA O VALOR DO ICMS DIFERIDO DOS ESTOQUES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.04', 'IRRF A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IR RETIDO NA FONTE A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.05', 'IR E CSLL A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IR E DA CSLL A RECUPERAR/ COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.06', 'IR E CSLL DIFERIDOS', 'REGISTRA A PARCELA DO IR E CSLL QUE REPRESENTA A DIFERENCA ENTRE OS VALORES DE LUCRO APURADOS SEGUNDO AS NORMAS FISCAIS E O REGIME DE COMPETENCIA, QUANDO ESTES FOREM MENORES E AS DIFERENCAS FOREM TEMPORARIAS.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.07', 'ISS A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO ISS A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.08', 'IPVA A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IPVA A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.09', 'IPTU A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IPTU A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.10', 'ITR A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO ITR A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.11', 'INSS A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO INSS A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.12', 'PSS A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO PSS A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.13', 'COFINS A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DA COFINS A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.14', 'PIS/PASEP A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO PIS/PASEP A RECUPERAR / COMPENSRAR', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.99', 'OUTROS TRIBUTOS RECUPERAR / COMPENSAR', 'COMPREENDE O SOMATORIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.03.01', 'TAXAS DE FISCALIZACAO DO FISTEL', 'REGISTRA OS VALORES A RECEBER REFERENTES AS TAXAS DE FISCALIZACAO DO FISTEL, TAIS COMO TAXAS DE INSTALACAO - TFI, TAXAS DE FUNCIONAMENTO - TFF, ACRESCIMOS MORATORIOS DAS TAXAS DE FISCALIZACAO DO FISTEL E OUTRAS CORRELATAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.03.02', 'CREDITOS POR DESCENTRALIZACAO DE SERVICOS DE TELECOMUNICACOES', 'REGISTRA OS VALORES A RECEBER REFERENTES A EXPLORACAO DE SERVICOS DE TELECOMUNICACOES, COMO COMUNICACAO DE MASSA, RADIODIFUSAO, DIREITOS DE USO DE RADIOFREQUENCIA, MULTAS PREVISTAS NA LEI GERAL DAS TELECOMUNICACOES (LGT), JUROS DE TITULOS DE RENDA, CERTIFICACAO DE PRODUTOS, INFORMACOES CIENTIFICAS E TECNOLOGICAS, REGULACAO DA EXPLORACAO DOS SERVICOS E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.03.03', 'CONTRIBUICAO SOBRE RECEITA DE SERVICOS DE TELECOMUNICACOES', 'REGISTRA OS VALORES A RECEBER REFERENTES AOS VALORES DAS CONTRIBUICOES DEVIDAS PELAS EMPRESAS QUE PRESTAM SERVICOS DE TELECOMUNICACOES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.03.04', 'CREDITOS A RECEBER POR DESCENTRALIZACAO DE SERVICOS DE TRANSPORTE PUBLICO', 'REGISTRA OS CREDITOS A RECEBER DECORRENTES DA DESCENTRALIZACAO DA PRESTACAO DE SERVICOS DE TRANSPORTE PUBLICO NAS FORMAS DE OUTORGA A ENTIDADES DA ADMINISTRACAO INDIRETA QUE NAO PERTENCAM AO OFSS, CONCESSAO, PERMISSAO OU AUTORIZACAO AO PARTICULAR, O QUAL ESTA SUJEITO AO CONTROLE, FISCALIZACAO E REGULACAO DO PODER PUBLICO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.03.99', 'OUTROS CREDITOS A RECEBER POR DESCENTRALIZACAO DE SERVICOS PUBLICOS', 'REGISTRA OS CREDITOS A RECEBER DECORRENTES DA DESCENTRALIZACAO DA PRESTACAO DE SERVICOS PUBLICOS NAO CLASSIFICADOS NAS CONTAS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.01', 'CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITOS ADMINISTRATIVOS DECORRENTES DE FOLHA DE PAGAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.02', 'CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.03', 'CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.04', 'CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.05', 'CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL', 'REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NAO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELEIDO EM NORMAS LEGAIS OU DETERMINACAO ADMINISTRATIVA OU SEJA, QUANDO O PRODUTO A ARRECADAR NAO TENHA SIDO RECOLHIDO NO PRAZO LEGAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.06', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.07', 'MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS', 'REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO, POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.08', 'CREDITOS A RECEBER POR USO INDEVIDO DE COTA', 'REGISTRA OS DEBITOS (APURADOS E EM APURACAO) DE PARLAMENTARES EM RAZAO DE RECEBIMENTO INDEVIDO DE VALOR RELACIONADO A COTA DESTINA A CUSTEAR GASTOS VINCULADOS AO EXERCICIO DE ATIVIDADE PARLAMENTAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.09', 'CREDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL', 'REGISTRA OS DEBITOS (APURADOS E EM APURACAO) REFERENTES A DEBITOS DE PARLAMENTARES CONHECIDOS APOS SEU AFASTAMENTO DO MANDADO E QUE NAO PUDERAM SER DESCONTADOS EM FOLHA DE PAGAMENTO. EXEMPLOS: REMANESCENTE DE CONTA DE ENERGIA ELETRICA, GAS, TAXA DE LIMPEZA PUBLICA E ALUGUEIS DE OUTROS BENS IMOVEIS PERTENCENTE AO ORGAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.10', 'CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE CONTAS ESPECIAL).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.99', 'OUTROS CREDITOS ADMINISTRATIVOS', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.01', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.02', 'CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES, NAO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU DETERMIMANACAO ADMINISTRATIVA, OU SEJA, QUANDO O PRODUTO A ARRECADAR NAO TENHA SIDO RECOLHIDO NO PRAZO LEGAL.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.03', 'CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.04', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.05', 'CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS AFAZENDA NACIONAL SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.06', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.07', 'CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.08', 'CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTACAO APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.09', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE LICITACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.10', 'MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO, POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE .(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.11', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM A UNIAO. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.12', 'CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIA SOCIAL, COM A RESPONSABILIDADE DEVIDAMENTE APURADA E IMPUTADA A SERVIDORES OU TERCEIROS (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.13', 'CREDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.14', 'CREDITOS A RECEBER POR USO INDEVIDO DE COTA - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DEBITOS (APURADOS E EM APURACAO) DE PARLAMENTARES EM RAZAO DE RECEBIMENTO INDEVIDO DE VALOR RELACIONADO A COTA DESTINA A CUSTEAR GASTOS VINCULADOS AO EXERCICIO DE ATIVIDADE PARLAMENTAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.15', 'CREDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DEBITOS (APURADOS E EM APURACAO) REFERENTES A DEBITOS DE PARLAMENTARES CONHECIDOS APOS SEU AFASTAMENTO DO MANDADO E QUE NAO PUDERAM SER DESCONTADOS EM FOLHA DE PAGAMENTO. EXEMPLOS: REMANESCENTE DE CONTA DE ENERGIA ELETRICA, GAS, TAXA DE LIMPEZA PUBLICA E ALUGUEIS DE OUTROS BENS IMOVEIS PERTENCENTE AO ORGAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.99', 'OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.01', 'DEPOSITOS E CAUCOES EFETUADOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES EFETUADOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.02', 'DEPOSITOS E CAUCOES RECEBIDOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES RECEBIDOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.03', 'DEPOSITOS JUDICIAIS EFETUADOS', 'REGISTRA OS VALORES DECORRENTES DE DEPOSITOS EFETUADOS PELA ENTIDADE POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.04', 'DEPOSITOS JUDICIAIS RECEBIDOS', 'REGISTRA OS VALORES DECORRENTES DE DEPOSITOS RECEBIDOS PELA ENTIDADE POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.05', 'DEPOSITOS EFETUADOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS EFETUADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.06', 'DEPOSITOS RECEBIDOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS RECEBIDOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.07', 'DEPOSITOS ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.08', 'VALORES APREENDIDOS POR DECISAO JUDICIAL', 'REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.09', 'DEPOSITOS TRANSFERIDOS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS TRANSFERIDOS, PARA GARANTIA DE OPERACOES ESPECIFICAS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.10', 'DEPOSITOS COMPULSORIOS - COMBUSTIVEIS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS NAS AQUISICOES DE COMBUSTIVEIS, DE ACORDO COM A LEGISLACAO EM VIGOR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.11', 'DEPOSITOS COMPULSORIOS - VEICULOS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS NAS AQUISICOES DE VEICULOS, DE ACORDO COM A LEGISLACAO EM VIGOR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.12', 'DEPOSITOS COMPULSORIOS - ELETROBRAS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS PELO CONSUMO DE ENERGIA ELETRICA, DE ACORDO COM A LEGISLACAO EM VIGOR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.99', 'OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.07.00', 'DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS', 'REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA,EXCETO AS DERIVADAS DE CLIENTES, EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DOS DEMONSTRATIVOS CONTABEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.01', 'CREDITOS A RECEBER DE ENTIDADES FEDERAIS', 'REGISTRA OS VALORES REALIZAVEIS NO LONGO PRAZO DECORRENTES DE DEBITO DE ENTIDADES FEDERAIS COM A UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.02', 'CREDITOS A RECEBER POR CESSAO DE CREDITOS - CEDIDOS PELA UNIAO', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER CEDIDOS PELA UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.03', 'CREDITOS ORIUNDOS DE CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS', 'REGISTRA O VALOR DOS CREDITOS ORIUNDOS DAS CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS DA UNIAO, PARA TERCEIROS OU PARA OUTRAS ENTIDADES GOVERNAMENTAIS, REALIZAVEIS A LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.04', 'CREDITOS A RECEBER DE DEVEDORES DE CONVENIOS', 'REGISTRA OS VALORES ORIUNDOS DE CREDITOS DE CONVENIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.05', 'CREDITOS A RECEBER DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS E IMOVEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.06', 'CREDITOS A RECEBER POR ACERTO FINANCEIRO COM SERVIDOR E EX- SERVIDOR', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DE ACERTOS FINANCEIROS COM SERVIDORES E EX-SERVIDORES DO ORGAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.07', 'CREDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRACAO', 'REGISTRA O VALOR DOS CREDITOS ADMINISTRATIVOS ORIUNDOS DE AUTOS DE INFRACAO E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.08', 'CREDITOS A RECEBER EM PARCELAS/ LOTES ORIUNDOS DE DESAPROPRIACOES', 'REGISTRA OS VALORES A RECEBER ORIUNDOS DE DESAPROPRIACOES DE IMOVEIS RURAIS PARA FINS DE REFORMA AGRARIA, TITULADOS EM PARCELAS/LOTES, COM PAGAMENTOS PREVISTOS A PARTIR DO SEGUNDO ANO DA EMISSAO DOS TITULOS DE PROPRIEDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.09', 'RECURSOS DA UNIAO', 'REGISTRA O VALOR DOS RECURSOS A RECEBER DA UNIAO EM DECORRENCIA DE DESPESAS REALIZADAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.10', 'INCENTIVOS FISCAIS', 'REGISTRA O VALOR DAS COTAS RECOLHIDAS PELA ADMINISTRACAO INDIRETA, REFERENTE AO IRPJ POR OPCAO DE INCENTIVOS FISCAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.11', 'CREDITOS TRANSFERIDOS', 'REGISTRA OS VALORES RELATIVOS AOS CREDITOS TRANSFERIDOS DE TERCEIROS, PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS DA FAZENDA NACIONAL LANCADOS POREM NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO ORIGINAL, QUE CONSTITUI A DIVIDA ATIVA A PARTIR DA SUA INSCRICAO. REGISTRA AINDA OS RECURSOS A RECEBER CONSTANTES DO ORCAMENTO GERAL DA UNIAO PARA FINS DE OBRIGACOES CONTRATUAIS DECORRENTES DE EMPRESTIMOS E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.12', 'VALORES A RECUPERAR DECORRENTES DE INDENIZACAO DE SINISTROS PAGOS', 'REGISTRA OS VALORES A RECUPERAR DECORRENTES DE PAGAMENTOS DE INDENIZACOES DE SINISTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.13', 'INDENIZACOES A RECEBER', 'REGISTRA OS VALORES DAS INDENIZACOES A RECEBER A LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.14', 'CREDITOS A RECUPERAR', 'REGISTRA O VALOR DOS CREDITOS A RECUPERAR NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.15', 'DUPLICATAS E TITULOS EM CONTENCIOSO', 'REGISTRA O MONTANTE DOS VALORES ORIUNDOS DE DUPLICATAS E TITULOS EM CONTENCIOSO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.16', 'CREDITOS EM LIQUIDACAO', 'REGISTRA OS VALORES ORIUNDOS DE CREDITOS EM LIQUIDACAO DE DIFICIL REALIZACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.17', 'CREDITOS PARCELADOS', 'REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.18', 'CREDITOS SUB-ROGADOS', 'REGISTRA O VALOR DOS CREDITOS SUB-ROGADOS POR ASSUNCAO DE DIVIDA PELA UNIAO POR DETERMINACAO LEGAL, POR RENEGOCIACAO DE DIVIDAS OU POR PAGAMENTO DE GARANTIAS DE EMPRESTIMOS DADAS A TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.19', 'CREDITOS A RECEBER EM PODER DA JUSTICA', 'REGISTRA OS VALORES A RECEBER EM PODER DA JUSTICA, SEM PREVISAO DE RECEBIMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.20', 'TITULOS A RECEBER', 'COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.21', 'CREDITOS POR INFRACOES LEGAL/CONTR. L. PRAZO', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CREDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.22', 'CREDITOS A RECEBER POR CESSAO DE PESSOAL', 'REGISTRA OS VALORES DE CREDITOS A RECEBER RELATIVOS A CESSAO DE PESSOAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.23', 'CREDITOS A RECEBER PENDENTES DE DECISAO JUDICIAL', 'REGISTRA OS VALORES A RECEBER PENDENTES DE DECISAO JUDICIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.99', 'OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO R', 'REGISTRA OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO , NAO CLASSIFICAVEIS EM OUTRAS CONTAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.99.02', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS', 'REGISTRA O AJUSTE PARA PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DIVIDA ATIVA NAO TRIBUTARIA DE LONGO PRAZO, EXCETO AS DERIVADAS DE CLIENTES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.99.03', '(-) AJUSTE DE PERDAS DE CREDITOS ADMINISTRATIVOS', 'REGISTRA OS VALORES DOS AJUSTES PARA PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.99.04', '(-) AJUSTE DE PERDAS DE CREDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES DOS AJUSTES PARA PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.01.02', 'ADIANTAMENTOS A UNIDADES E ENTIDADES', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.01.03', 'ADIANTAMENTOS DE TRANSFERENCIAS VOLUNTARIAS', 'REGISTRA OS VALORES RELATIVOS A ADIANTAMENTOS DE RECURSOS FINANCEIROS FORMALIZADOS POR TRANSFERENCIAS VOLUNTARIAS GERADAS A PARTIR DA INTEGRACAO DO PORTAL SICONV COM O SIAFI.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.01.04', 'ADIANTAMENTOS A PRESTADORES DE SERVICOS', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A PRESTADORES DE SERVICOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVICOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.01.05', 'ADIANTAMENTOS A DIRETORES, ACIONISTAS OU PARTICIPANTES NO LUCRO DA COMPANHIA', 'REGISTRA O SOMATORIO DOS VALORES DE ADIANTAMENTOS CONCEDIDOS A DIRETORES E ACIONISTAS OU OUTROS PARTICIPANTES NO LUCRO, TAIS COMO OS DETENTORES DE PARTES BENEFICIARIAS OU DEBENTURES, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.01.06', 'ADIANTAMENTOS A SOCIEDADES COLIGADAS OU CONTROLADAS', 'REGISTRA O SOMATORIO DOS VALORES DE ADIANTAMENTOS CONCEDIDOS A SOCIEDADES COLIGADAS E CONTROLADAS, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.01.99', 'ADIANTAMENTOS DIVERSOS CONCEDIDOS', 'REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NAO CLASSIFICADOS EM CONTAS ANTERIORES.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.02.01', 'IPI A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IPI A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.02.04', 'IRRF A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IR RETIDO NA FONTE A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.02.05', 'IR E CSLL A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IR E DA CSLL A RECUPERAR/ COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.02.06', 'IR E CSLL DIFERIDOS', 'REGISTRA A PARCELA DO IR E CSLL QUE REPRESENTA A DIFERENCA ENTRE OS VALORES DE LUCRO APURADOS SEGUNDO AS NORMAS FISCAIS E O REGIME DE COMPETENCIA, QUANDO ESTES FOREM MENORES E AS DIFERENCAS FOREM TEMPORARIAS.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.02.10', 'ITR A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO ITR A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.02.11', 'INSS A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO INSS A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.02.12', 'PSS A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO PSS A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.02.13', 'COFINS A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DA COFINS A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.02.14', 'PIS/PASEP A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO PIS/PASEP A RECUPERAR / COMPENSRAR', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.02.99', 'OUTROS TRIBUTOS RECUPERAR / COMPENSAR', 'COMPREENDE O SOMATORIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.04.02', 'CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.04.03', 'CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.04.04', 'CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.04.06', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.04.10', 'CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE CONTAS ESPECIAL).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.04.99', 'OUTROS CREDITOS ADMINISTRATIVOS', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.05.01', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.05.03', 'CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.05.04', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.05.05', 'CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS AFAZENDA NACIONAL SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.05.06', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.05.07', 'CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.05.08', 'CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTACAO APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.05.09', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE LICITACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.05.11', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM A UNIAO. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.05.12', 'CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIA SOCIAL, COM A RESPONSABILIDADE DEVIDAMENTE APURADA E IMPUTADA A SERVIDORES OU TERCEIROS (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.05.13', 'CREDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.05.99', 'OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.06.01', 'DEPOSITOS E CAUCOES EFETUADOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES EFETUADOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.06.02', 'DEPOSITOS E CAUCOES RECEBIDOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES RECEBIDOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.06.03', 'DEPOSITOS JUDICIAIS EFETUADOS', 'REGISTRA OS VALORES DECORRENTES DE DEPOSITOS EFETUADOS PELA ENTIDADE POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.06.04', 'DEPOSITOS JUDICIAIS RECEBIDOS', 'REGISTRA OS VALORES DECORRENTES DE DEPOSITOS RECEBIDOS PELA ENTIDADE POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.06.05', 'DEPOSITOS EFETUADOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS EFETUADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.06.06', 'DEPOSITOS RECEBIDOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS RECEBIDOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.06.07', 'DEPOSITOS ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.06.08', 'VALORES APREENDIDOS POR DECISAO JUDICIAL', 'REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.06.09', 'DEPOSITOS TRANSFERIDOS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS TRANSFERIDOS, PARA GARANTIA DE OPERACOES ESPECIFICAS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.06.10', 'DEPOSITOS COMPULSORIOS - COMBUSTIVEIS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS NAS AQUISICOES DE COMBUSTIVEIS, DE ACORDO COM A LEGISLACAO EM VIGOR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.06.11', 'DEPOSITOS COMPULSORIOS - VEICULOS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS NAS AQUISICOES DE VEICULOS, DE ACORDO COM A LEGISLACAO EM VIGOR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.06.12', 'DEPOSITOS COMPULSORIOS - ELETROBRAS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS PELO CONSUMO DE ENERGIA ELETRICA, DE ACORDO COM A LEGISLACAO EM VIGOR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.06.99', 'OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.07.00', 'DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS', 'REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA,EXCETO AS DERIVADAS DE CLIENTES, EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DOS DEMONSTRATIVOS CONTABEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.01', 'CREDITOS A RECEBER DE ENTIDADES FEDERAIS', 'REGISTRA OS VALORES REALIZAVEIS NO LONGO PRAZO DECORRENTES DE DEBITO DE ENTIDADES FEDERAIS COM A UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.02', 'CREDITOS A RECEBER POR CESSAO DE CREDITOS - CEDIDOS PELA UNIAO', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER CEDIDOS PELA UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.03', 'CREDITOS ORIUNDOS DE CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS', 'REGISTRA O VALOR DOS CREDITOS ORIUNDOS DAS CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS DA UNIAO, PARA TERCEIROS OU PARA OUTRAS ENTIDADES GOVERNAMENTAIS, REALIZAVEIS A LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.04', 'CREDITOS A RECEBER DE DEVEDORES DE CONVENIOS', 'REGISTRA OS VALORES ORIUNDOS DE CREDITOS DE CONVENIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.05', 'CREDITOS A RECEBER DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS E IMOVEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.07', 'CREDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRACAO', 'REGISTRA O VALOR DOS CREDITOS ADMINISTRATIVOS ORIUNDOS DE AUTOS DE INFRACAO E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.08', 'CREDITOS A RECEBER EM PARCELAS/ LOTES ORIUNDOS DE DESAPROPRIACOES', 'REGISTRA OS VALORES A RECEBER ORIUNDOS DE DESAPROPRIACOES DE IMOVEIS RURAIS PARA FINS DE REFORMA AGRARIA, TITULADOS EM PARCELAS/LOTES, COM PAGAMENTOS PREVISTOS A PARTIR DO SEGUNDO ANO DA EMISSAO DOS TITULOS DE PROPRIEDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.09', 'RECURSOS DA UNIAO', 'REGISTRA O VALOR DOS RECURSOS A RECEBER DA UNIAO EM DECORRENCIA DE DESPESAS REALIZADAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.10', 'INCENTIVOS FISCAIS', 'REGISTRA O VALOR DAS COTAS RECOLHIDAS PELA ADMINISTRACAO INDIRETA, REFERENTE AO IRPJ POR OPCAO DE INCENTIVOS FISCAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.11', 'CREDITOS TRANSFERIDOS', 'REGISTRA OS VALORES RELATIVOS AOS CREDITOS TRANSFERIDOS DE TERCEIROS, PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS DA FAZENDA NACIONAL LANCADOS POREM NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO ORIGINAL, QUE CONSTITUI A DIVIDA ATIVA A PARTIR DA SUA INSCRICAO. REGISTRA AINDA OS RECURSOS A RECEBER CONSTANTES DO ORCAMENTO GERAL DA UNIAO PARA FINS DE OBRIGACOES CONTRATUAIS DECORRENTES DE EMPRESTIMOS E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.12', 'VALORES A RECUPERAR DECORRENTES DE INDENIZACAO DE SINISTROS PAGOS', 'REGISTRA OS VALORES A RECUPERAR DECORRENTES DE PAGAMENTOS DE INDENIZACOES DE SINISTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.13', 'INDENIZACOES A RECEBER', 'REGISTRA OS VALORES DAS INDENIZACOES A RECEBER A LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.14', 'CREDITOS A RECUPERAR', 'REGISTRA O VALOR DOS CREDITOS A RECUPERAR NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.15', 'DUPLICATAS E TITULOS EM CONTENCIOSO', 'REGISTRA O MONTANTE DOS VALORES ORIUNDOS DE DUPLICATAS E TITULOS EM CONTENCIOSO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.16', 'CREDITOS EM LIQUIDACAO', 'REGISTRA OS VALORES ORIUNDOS DE CREDITOS EM LIQUIDACAO DE DIFICIL REALIZACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.17', 'CREDITOS PARCELADOS', 'REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.18', 'CREDITOS SUB-ROGADOS', 'REGISTRA O VALOR DOS CREDITOS SUB-ROGADOS POR ASSUNCAO DE DIVIDA PELA UNIAO POR DETERMINACAO LEGAL, POR RENEGOCIACAO DE DIVIDAS OU POR PAGAMENTO DE GARANTIAS DE EMPRESTIMOS DADAS A TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.19', 'CREDITOS A RECEBER EM PODER DA JUSTICA', 'REGISTRA OS VALORES A RECEBER EM PODER DA JUSTICA, SEM PREVISAO DE RECEBIMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.20', 'TITULOS A RECEBER', 'COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.21', 'CREDITOS POR INFRACOES LEGAL/CONTR. L. PRAZO', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CREDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.22', 'CREDITOS A RECEBER POR CESSAO DE PESSOAL', 'REGISTRA OS VALORES DE CREDITOS A RECEBER RELATIVOS A CESSAO DE PESSOAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.23', 'CREDITOS A RECEBER PENDENTES DE DECISAO JUDICIAL', 'REGISTRA OS VALORES A RECEBER PENDENTES DE DECISAO JUDICIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.99', 'OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO', 'REGISTRA OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO, NAO CLASSIFICAVEIS EM OUTRAS CONTAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.99.02', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS', 'REGISTRA O AJUSTE PARA PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DIVIDA ATIVA NAO TRIBUTARIA DE LONGO PRAZO, EXCETO AS DERIVADAS DE CLIENTES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.99.03', '(-) AJUSTE DE PERDAS DE CREDITOS ADMINISTRATIVOS', 'REGISTRA OS VALORES DOS AJUSTES PARA PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.99.04', '(-) AJUSTE DE PERDAS DE CREDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES DOS AJUSTES PARA PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.01.02', 'ADIANTAMENTOS A UNIDADES E ENTIDADES', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.01.03', 'ADIANTAMENTOS DE TRANSFERENCIAS VOLUNTARIAS', 'REGISTRA OS VALORES RELATIVOS A ADIANTAMENTOS DE RECURSOS FINANCEIROS FORMALIZADOS POR TRANSFERENCIAS VOLUNTARIAS GERADAS A PARTIR DA INTEGRACAO DO PORTAL SICONV COM O SIAFI.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.01.04', 'ADIANTAMENTOS A PRESTADORES DE SERVICOS', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A PRESTADORES DE SERVICOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVICOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.01.05', 'ADIANTAMENTOS A DIRETORES, ACIONISTAS OU PARTICIPANTES NO LUCRO DA COMPANHIA', 'REGISTRA O SOMATORIO DOS VALORES DE ADIANTAMENTOS CONCEDIDOS A DIRETORES E ACIONISTAS OU OUTROS PARTICIPANTES NO LUCRO, TAIS COMO OS DETENTORES DE PARTES BENEFICIARIAS OU DEBENTURES, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.01.06', 'ADIANTAMENTOS A SOCIEDADES COLIGADAS OU CONTROLADAS', 'REGISTRA O SOMATORIO DOS VALORES DE ADIANTAMENTOS CONCEDIDOS A SOCIEDADES COLIGADAS E CONTROLADAS, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.01.99', 'ADIANTAMENTOS DIVERSOS CONCEDIDOS', 'REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NAO CLASSIFICADOS EM CONTAS ANTERIORES.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.02.02', 'ICMS A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DE ICMS A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.02.03', 'ICMS DIFERIDO', 'REGISTRA O VALOR DO ICMS DIFERIDO DOS ESTOQUES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.02.07', 'ISS A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO ISS A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.02.08', 'IPVA A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IPVA A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.02.09', 'IPTU A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IPTU A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.02.10', 'ITR A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO ITR A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.02.99', 'OUTROS TRIBUTOS RECUPERAR / COMPENSAR', 'COMPREENDE O SOMATORIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.04.02', 'CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.04.03', 'CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.04.04', 'CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.04.06', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.04.10', 'CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE CONTAS ESPECIAL).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.04.99', 'OUTROS CREDITOS ADMINISTRATIVOS', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.05.01', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.05.03', 'CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.05.04', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.05.05', 'CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS AFAZENDA NACIONAL SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.05.06', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.05.07', 'CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.05.08', 'CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTACAO APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.05.09', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE LICITACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.05.11', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM A UNIAO. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.05.12', 'CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIA SOCIAL, COM A RESPONSABILIDADE DEVIDAMENTE APURADA E IMPUTADA A SERVIDORES OU TERCEIROS (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.05.13', 'CREDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.05.99', 'OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.06.01', 'DEPOSITOS E CAUCOES EFETUADOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES EFETUADOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.06.02', 'DEPOSITOS E CAUCOES RECEBIDOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES RECEBIDOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.06.03', 'DEPOSITOS JUDICIAIS EFETUADOS', 'REGISTRA OS VALORES DECORRENTES DE DEPOSITOS EFETUADOS PELA ENTIDADE POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.06.04', 'DEPOSITOS JUDICIAIS RECEBIDOS', 'REGISTRA OS VALORES DECORRENTES DE DEPOSITOS RECEBIDOS PELA ENTIDADE POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.06.05', 'DEPOSITOS EFETUADOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS EFETUADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.06.06', 'DEPOSITOS RECEBIDOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS RECEBIDOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.06.07', 'DEPOSITOS ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.06.08', 'VALORES APREENDIDOS POR DECISAO JUDICIAL', 'REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.06.09', 'DEPOSITOS TRANSFERIDOS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS TRANSFERIDOS, PARA GARANTIA DE OPERACOES ESPECIFICAS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.06.10', 'DEPOSITOS COMPULSORIOS - COMBUSTIVEIS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS NAS AQUISICOES DE COMBUSTIVEIS, DE ACORDO COM A LEGISLACAO EM VIGOR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.06.11', 'DEPOSITOS COMPULSORIOS - VEICULOS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS NAS AQUISICOES DE VEICULOS, DE ACORDO COM A LEGISLACAO EM VIGOR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.06.12', 'DEPOSITOS COMPULSORIOS - ELETROBRAS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS PELO CONSUMO DE ENERGIA ELETRICA, DE ACORDO COM A LEGISLACAO EM VIGOR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.06.99', 'OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.07.00', 'DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS', 'REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA,EXCETO AS DERIVADAS DE CLIENTES, EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DOS DEMONSTRATIVOS CONTABEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.01', 'CREDITOS A RECEBER DE ENTIDADES FEDERAIS', 'REGISTRA OS VALORES REALIZAVEIS NO LONGO PRAZO DECORRENTES DE DEBITO DE ENTIDADES FEDERAIS COM A UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.02', 'CREDITOS A RECEBER POR CESSAO DE CREDITOS - CEDIDOS PELA UNIAO', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER CEDIDOS PELA UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.03', 'CREDITOS ORIUNDOS DE CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS', 'REGISTRA O VALOR DOS CREDITOS ORIUNDOS DAS CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS DA UNIAO, PARA TERCEIROS OU PARA OUTRAS ENTIDADES GOVERNAMENTAIS, REALIZAVEIS A LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.04', 'CREDITOS A RECEBER DE DEVEDORES DE CONVENIOS', 'REGISTRA OS VALORES ORIUNDOS DE CREDITOS DE CONVENIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.05', 'CREDITOS A RECEBER DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS E IMOVEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.07', 'CREDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRACAO', 'REGISTRA O VALOR DOS CREDITOS ADMINISTRATIVOS ORIUNDOS DE AUTOS DE INFRACAO E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.08', 'CREDITOS A RECEBER EM PARCELAS/ LOTES ORIUNDOS DE DESAPROPRIACOES', 'REGISTRA OS VALORES A RECEBER ORIUNDOS DE DESAPROPRIACOES DE IMOVEIS RURAIS PARA FINS DE REFORMA AGRARIA, TITULADOS EM PARCELAS/LOTES, COM PAGAMENTOS PREVISTOS A PARTIR DO SEGUNDO ANO DA EMISSAO DOS TITULOS DE PROPRIEDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.10', 'INCENTIVOS FISCAIS', 'REGISTRA O VALOR DAS COTAS RECOLHIDAS PELA ADMINISTRACAO INDIRETA, REFERENTE AO IRPJ POR OPCAO DE INCENTIVOS FISCAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.11', 'CREDITOS TRANSFERIDOS', 'REGISTRA OS VALORES RELATIVOS AOS CREDITOS TRANSFERIDOS DE TERCEIROS, PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS DA FAZENDA NACIONAL LANCADOS POREM NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO ORIGINAL, QUE CONSTITUI A DIVIDA ATIVA A PARTIR DA SUA INSCRICAO. REGISTRA AINDA OS RECURSOS A RECEBER CONSTANTES DO ORCAMENTO GERAL DA UNIAO PARA FINS DE OBRIGACOES CONTRATUAIS DECORRENTES DE EMPRESTIMOS E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.12', 'VALORES A RECUPERAR DECORRENTES DE INDENIZACAO DE SINISTROS PAGOS', 'REGISTRA OS VALORES A RECUPERAR DECORRENTES DE PAGAMENTOS DE INDENIZACOES DE SINISTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.13', 'INDENIZACOES A RECEBER', 'REGISTRA OS VALORES DAS INDENIZACOES A RECEBER A LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.14', 'CREDITOS A RECUPERAR', 'REGISTRA O VALOR DOS CREDITOS A RECUPERAR NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.15', 'DUPLICATAS E TITULOS EM CONTENCIOSO', 'REGISTRA O MONTANTE DOS VALORES ORIUNDOS DE DUPLICATAS E TITULOS EM CONTENCIOSO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.16', 'CREDITOS EM LIQUIDACAO', 'REGISTRA OS VALORES ORIUNDOS DE CREDITOS EM LIQUIDACAO DE DIFICIL REALIZACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.17', 'CREDITOS PARCELADOS', 'REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.18', 'CREDITOS SUB-ROGADOS', 'REGISTRA O VALOR DOS CREDITOS SUB-ROGADOS POR ASSUNCAO DE DIVIDA PELA UNIAO POR DETERMINACAO LEGAL, POR RENEGOCIACAO DE DIVIDAS OU POR PAGAMENTO DE GARANTIAS DE EMPRESTIMOS DADAS A TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.19', 'CREDITOS A RECEBER EM PODER DA JUSTICA', 'REGISTRA OS VALORES A RECEBER EM PODER DA JUSTICA, SEM PREVISAO DE RECEBIMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.20', 'TITULOS A RECEBER', 'COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.21', 'CREDITOS POR INFRACOES LEGAL/CONTR. L. PRAZO', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CREDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.22', 'CREDITOS A RECEBER POR CESSAO DE PESSOAL', 'REGISTRA OS VALORES DE CREDITOS A RECEBER RELATIVOS A CESSAO DE PESSOAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.23', 'CREDITOS A RECEBER PENDENTES DE DECISAO JUDICIAL', 'REGISTRA OS VALORES A RECEBER PENDENTES DE DECISAO JUDICIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.99', 'OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO', 'REGISTRA OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO, NAO CLASSIFICAVEIS EM OUTRAS CONTAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.99.02', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS', 'REGISTRA O AJUSTE PARA PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DIVIDA ATIVA NAO TRIBUTARIA DE LONGO PRAZO, EXCETO AS DERIVADAS DE CLIENTES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.99.03', '(-) AJUSTE DE PERDAS DE CREDITOS ADMINISTRATIVOS', 'REGISTRA OS VALORES DOS AJUSTES PARA PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.99.04', '(-) AJUSTE DE PERDAS DE CREDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES DOS AJUSTES PARA PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.01.02', 'ADIANTAMENTOS A UNIDADES E ENTIDADES', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.01.03', 'ADIANTAMENTOS DE TRANSFERENCIAS VOLUNTARIAS', 'REGISTRA OS VALORES RELATIVOS A ADIANTAMENTOS DE RECURSOS FINANCEIROS FORMALIZADOS POR TRANSFERENCIAS VOLUNTARIAS GERADAS A PARTIR DA INTEGRACAO DO PORTAL SICONV COM O SIAFI.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.01.04', 'ADIANTAMENTOS A PRESTADORES DE SERVICOS', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A PRESTADORES DE SERVICOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVICOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.01.05', 'ADIANTAMENTOS A DIRETORES, ACIONISTAS OU PARTICIPANTES NO LUCRO DA COMPANHIA', 'REGISTRA O SOMATORIO DOS VALORES DE ADIANTAMENTOS CONCEDIDOS A DIRETORES E ACIONISTAS OU OUTROS PARTICIPANTES NO LUCRO, TAIS COMO OS DETENTORES DE PARTES BENEFICIARIAS OU DEBENTURES, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.01.06', 'ADIANTAMENTOS A SOCIEDADES COLIGADAS OU CONTROLADAS', 'REGISTRA O SOMATORIO DOS VALORES DE ADIANTAMENTOS CONCEDIDOS A SOCIEDADES COLIGADAS E CONTROLADAS, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.01.99', 'ADIANTAMENTOS DIVERSOS CONCEDIDOS', 'REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NAO CLASSIFICADOS EM CONTAS ANTERIORES.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.02.02', 'ICMS A RECUPERAR / COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DE ICMS A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.02.03', 'ICMS DIFERIDO', 'REGISTRA O VALOR DO ICMS DIFERIDO DOS ESTOQUES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.02.07', 'ISS A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO ISS A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.02.08', 'IPVA A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IPVA A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.02.09', 'IPTU A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO IPTU A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.02.10', 'ITR A COMPENSAR', 'REGISTRA O SOMATORIO DOS VALORES DO ITR A COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.02.99', 'OUTROS TRIBUTOS RECUPERAR / COMPENSAR', 'COMPREENDE O SOMATORIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR / COMPENSAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.04.02', 'CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.04.03', 'CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.04.04', 'CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.04.06', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.04.10', 'CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE CONTAS ESPECIAL).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.04.99', 'OUTROS CREDITOS ADMINISTRATIVOS', 'REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.05.01', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.05.03', 'CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.05.04', 'CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.05.05', 'CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS AFAZENDA NACIONAL SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.05.06', 'CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.05.07', 'CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.05.08', 'CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTACAO APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.05.09', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE LICITACAO - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.05.11', 'CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM A UNIAO. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.05.12', 'CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS - TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIA SOCIAL, COM A RESPONSABILIDADE DEVIDAMENTE APURADA E IMPUTADA A SERVIDORES OU TERCEIROS (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.05.13', 'CREDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.05.99', 'OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.06.01', 'DEPOSITOS E CAUCOES EFETUADOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES EFETUADOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.06.02', 'DEPOSITOS E CAUCOES RECEBIDOS RELATIVOS A CONTRATOS OU CONVENCOES', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES RECEBIDOS PELA ENTIDADE, PRESTADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.06.04', 'DEPOSITOS JUDICIAIS RECEBIDOS', 'REGISTRA OS VALORES DECORRENTES DE DEPOSITOS RECEBIDOS PELA ENTIDADE POR DETERMINACAO JUDICIAL, REALIZAVEIS NO CURTO PRAZO.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.06.05', 'DEPOSITOS EFETUADOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS EFETUADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.06.06', 'DEPOSITOS RECEBIDOS PARA INTERPOSICAO DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS RECEBIDOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.06.07', 'DEPOSITOS ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.06.08', 'VALORES APREENDIDOS POR DECISAO JUDICIAL', 'REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.', 'D', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.06.09', 'DEPOSITOS TRANSFERIDOS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS TRANSFERIDOS, PARA GARANTIA DE OPERACOES ESPECIFICAS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.06.10', 'DEPOSITOS COMPULSORIOS - COMBUSTIVEIS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS NAS AQUISICOES DE COMBUSTIVEIS, DE ACORDO COM A LEGISLACAO EM VIGOR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.06.11', 'DEPOSITOS COMPULSORIOS - VEICULOS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS NAS AQUISICOES DE VEICULOS, DE ACORDO COM A LEGISLACAO EM VIGOR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.06.12', 'DEPOSITOS COMPULSORIOS - ELETROBRAS', 'REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS PELO CONSUMO DE ENERGIA ELETRICA, DE ACORDO COM A LEGISLACAO EM VIGOR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.06.99', 'OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.07.00', 'DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS', 'REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA,EXCETO AS DERIVADAS DE CLIENTES, EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DOS DEMONSTRATIVOS CONTABEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.01', 'CREDITOS A RECEBER DE ENTIDADES FEDERAIS', 'REGISTRA OS VALORES REALIZAVEIS NO LONGO PRAZO DECORRENTES DE DEBITO DE ENTIDADES FEDERAIS COM A UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.02', 'CREDITOS A RECEBER POR CESSAO DE CREDITOS - CEDIDOS PELA UNIAO', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER CEDIDOS PELA UNIAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.03', 'CREDITOS ORIUNDOS DE CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS', 'REGISTRA O VALOR DOS CREDITOS ORIUNDOS DAS CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS DA UNIAO, PARA TERCEIROS OU PARA OUTRAS ENTIDADES GOVERNAMENTAIS, REALIZAVEIS A LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.04', 'CREDITOS A RECEBER DE DEVEDORES DE CONVENIOS', 'REGISTRA OS VALORES ORIUNDOS DE CREDITOS DE CONVENIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.05', 'CREDITOS A RECEBER DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS', 'REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS E IMOVEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.07', 'CREDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRACAO', 'REGISTRA O VALOR DOS CREDITOS ADMINISTRATIVOS ORIUNDOS DE AUTOS DE INFRACAO E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.08', 'CREDITOS A RECEBER EM PARCELAS/ LOTES ORIUNDOS DE DESAPROPRIACOES', 'REGISTRA OS VALORES A RECEBER ORIUNDOS DE DESAPROPRIACOES DE IMOVEIS RURAIS PARA FINS DE REFORMA AGRARIA, TITULADOS EM PARCELAS/LOTES, COM PAGAMENTOS PREVISTOS A PARTIR DO SEGUNDO ANO DA EMISSAO DOS TITULOS DE PROPRIEDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.10', 'INCENTIVOS FISCAIS', 'REGISTRA O VALOR DAS COTAS RECOLHIDAS PELA ADMINISTRACAO INDIRETA, REFERENTE AO IRPJ POR OPCAO DE INCENTIVOS FISCAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.11', 'CREDITOS TRANSFERIDOS', 'REGISTRA OS VALORES RELATIVOS AOS CREDITOS TRANSFERIDOS DE TERCEIROS, PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS DA FAZENDA NACIONAL LANCADOS POREM NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO ORIGINAL, QUE CONSTITUI A DIVIDA ATIVA A PARTIR DA SUA INSCRICAO. REGISTRA AINDA OS RECURSOS A RECEBER CONSTANTES DO ORCAMENTO GERAL DA UNIAO PARA FINS DE OBRIGACOES CONTRATUAIS DECORRENTES DE EMPRESTIMOS E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.12', 'VALORES A RECUPERAR DECORRENTES DE INDENIZACAO DE SINISTROS PAGOS', 'REGISTRA OS VALORES A RECUPERAR DECORRENTES DE PAGAMENTOS DE INDENIZACOES DE SINISTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.13', 'INDENIZACOES A RECEBER', 'REGISTRA OS VALORES DAS INDENIZACOES A RECEBER A LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.14', 'CREDITOS A RECUPERAR', 'REGISTRA O VALOR DOS CREDITOS A RECUPERAR NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.15', 'DUPLICATAS E TITULOS EM CONTENCIOSO', 'REGISTRA O MONTANTE DOS VALORES ORIUNDOS DE DUPLICATAS E TITULOS EM CONTENCIOSO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.16', 'CREDITOS EM LIQUIDACAO', 'REGISTRA OS VALORES ORIUNDOS DE CREDITOS EM LIQUIDACAO DE DIFICIL REALIZACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.17', 'CREDITOS PARCELADOS', 'REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.18', 'CREDITOS SUB-ROGADOS', 'REGISTRA O VALOR DOS CREDITOS SUB-ROGADOS POR ASSUNCAO DE DIVIDA PELA UNIAO POR DETERMINACAO LEGAL, POR RENEGOCIACAO DE DIVIDAS OU POR PAGAMENTO DE GARANTIAS DE EMPRESTIMOS DADAS A TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.19', 'CREDITOS A RECEBER EM PODER DA JUSTICA', 'REGISTRA OS VALORES A RECEBER EM PODER DA JUSTICA, SEM PREVISAO DE RECEBIMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.20', 'TITULOS A RECEBER', 'COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.21', 'CREDITOS POR INFRACOES LEGAL/CONTR. L. PRAZO', 'REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CREDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.22', 'CREDITOS A RECEBER POR CESSAO DE PESSOAL', 'REGISTRA OS VALORES DE CREDITOS A RECEBER RELATIVOS AA CESSAO DE PESSOAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.23', 'CREDITOS A RECEBER PENDENTES DE DECISAO JUDICIAL', 'REGISTRA OS VALORES A RECEBER PENDENTES DE DECISAO JUDICIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.99', 'OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO', 'REGISTRA OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO, NAO CLASSIFICAVEIS EM OUTRAS CONTAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.99.02', '(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS', 'REGISTRA O AJUSTE PARA PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DIVIDA ATIVA NAO TRIBUTARIA DE LONGO PRAZO, EXCETO AS DERIVADAS DE CLIENTES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.99.03', '(-) AJUSTE DE PERDAS DE CREDITOS ADMINISTRATIVOS', 'REGISTRA OS VALORES DOS AJUSTES PARA PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.99.04', '(-) AJUSTE DE PERDAS DE CREDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL', 'REGISTRA OS VALORES DOS AJUSTES PARA PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.01', 'TITULOS DA DIVIDA AGRARIA - TDA', 'REGISTRA OS VALORES RELATIVOS AOS TITULOS DA DIVIDA AGRARIA, PARA FINS DE INDENIZACOES DE PROPRIEDADES RURAIS, COM OBJETIVO DE REFORMA AGRARIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.02', 'TITULOS PUBLICOS - LETRAS ESPECIAIS', 'REGISTRA O VALOR DAS LETRAS ESPECIAIS EM TITULOS PUBLICOS EMITIDOS NO MERCADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.03', 'TITULOS PUBLICOS DE PROPRIEDADE DO BACEN', 'REGISTRA OS TITULOS PUBLICOS DE PROPRIEDADE DO BACEN.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.04', 'TITULOS PUBLICOS - MERCADO ABERTO', 'REGISTRA O VALOR RELATIVO A TITULOS PUBLICOS, EMITIDOS E EM CIRCULACAO NO MERCADO ABERTO PARA FINS DE NEGOCIACAO NO MERCADO DE ACOES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.05', 'ACOES - FAD/FND', 'REGISTRA AS ACOES DEPOSITADAS NO FAD E/OU FND E AS ALIENAVEIS POR MEIO DE ADESAO A OFERTA PUBLICA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.06', 'DEMAIS ACOES', 'REGISTRA OS VALORES DAS DAS DEMAIS ACOES REPRESENTATIVAS DAS PARTICIPACOES DOS ORGAOS E ENTIDADES NO CAPITAL DAS SOCIEDADES POR ACOES HAVIDAS POR AQUISICOES, SUBSCRICOES, BONIFICACOES E DOACOES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.07', 'FUNDO DE APLICACOES EM COTAS - RENDA VARIAVEL', 'REGISTRA OS VALORES APLICADOS EM FUNDOS DE APLICACOES EM COTAS - RENDA VARIAVEL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.08', 'FUNDO DE APLICACOES EM COTAS - RENDA VARIAVEL (FSB)', 'REGISTRA OS VALORES APLICADOS EM FUNDOS DE APLICACOES EM COTAS - RENDA VARIAVEL, RELATIVAS A OPERACIONALIZACAO DO FUNDO SOBERANO DO BRASIL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.09', 'APLICACOES EM ATIVOS EM ENQUADRAMENTO - TITULOS E VALORES', 'REGISTRA AS APLICACOES DE RECURSOS DO REGIME PROPRIO DA PREVIDENCIA SOCIAL - RPPS EM DESACORDO COM A LEGISLACAO E MANTIDAS EM CARTEIRA ATE O CORRESPONDENTE VENCIMENTO OU, NA INEXISTENCIA DESSE, ATE O PRAZO ESTIPULADO EM LEGISLACAO CORRESPONDENTE, CASO SEJAM RESGATAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PUBLICACAO DAS DEMONSTRACOES CONTABEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.10', 'APLICACOES EM ATIVOS NAO SUJEITOS A RESOLUCAO DO CMN - TITULOS E VALORES', 'REGISTRA OS VALORES DOS ATIVOS - TITULOS E VALORES- NAO SUJEITOS AS REGRAS ESTABELECIDAS NA RESOLUCAO CMN Nº 3790/2009, REALIZAVEIS NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.99', 'OUTROS TITULOS E VALORES', 'REGISTRA OS OUTROS TITULOS E VALORES MOBILIARIOS A LONGO PRAZO, NAO CLASSIFICAVEIS NAS CONTAS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.02.01', 'APLICACAO TEMPORARIA EM OURO', 'REGISTRA AS APLICACOES DE RECURSOS EM OURO, DEPOSITADOS NO BANCO CENTRAL DO BRASIL,DE ACORDO COM A LEI Nº 4595/64.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.02.02', 'APLICACAO TEMPORARIA EM OUTROS METAIS PRECIOSOS', 'REGISTRA O VALOR REFERENTE AS APLICACOES EM DEMAIS METAIS PRECIOSOS, DEPOSITADOS NO BANCO CENTRAL DO BRASIL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.03.00', 'APLICACOES EM SEGMENTO DE IMOVEIS', 'REGISTRA OS INVESTIMENTOS DE LONGO PRAZO REALIZADOS EM SEGMENTO DE IMOVEIS, REALIZAVEIS NO LONGO PRAZO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.99.01', '(-) AJUSTE DE PERDAS COM TITULOS, VALORES MOBILIARIOS E IMOVEIS', 'REGISTRA OS VALORES DE AJUSTES PARA PERDAS EM TITULOS , VALORES MOBILIARIOS E IMOVEIS A LONGO PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.99.02', '(-) AJUSTE DE PERDAS COM APLICACOES TEMPORARIAS EM METAIS PRECIOSOS', 'REGISTRA OS VALORES DE AJUSTES PARA PERDAS EM APLICACOES EM OURO E OUTROS METAIS PRECIOSOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.01.01', 'MERCADORIAS PARA VENDA OU REVENDA- ESTOQUE PROGRAMAS PROPRIOS', 'REGISTRA O VALOR DAS MERCADORIAS PARA VENDA OU REVENDA E DOACOES RELATIVAS A ESTOQUES DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.01.02', 'MERCADORIAS EM CONSIGNACAO PARA REVENDA - ESTOQUE PROGRAMAS PROPRIOS', 'REGISTRA O VALOR DAS MERCADORIAS EM CONSIGNACAO PARA REVENDA - REDE SOMAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.01.03', 'MERCADORIAS - ATACADO - ESTOQUE PROGRAMAS PROPRIOS', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA - ATACADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.01.04', 'MERCADORIAS - ESTOQUES ESTRATEGICOS', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES ESTRATEGICOS DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.01.05', 'MERCADORIAS - ESTOQUE REGULADORES PGPM', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES REGULADORES- PGPM DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.01.06', 'MERCADORIAS - ESTOQUE EGF ESP. PGPM(DEP. JUDICIAL)', 'REGISTRA O VALOR DAS MERCADORIAS DE EGFS ESPECIAIS ORIUNDOS DO BANCO DO BRASIL, PARA REVENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.01.07', 'MERCADORIAS - ESTOQUES AGRICULTURA FAMILIAR', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS AO PROGRAMA DE AGRICULTURA FAMILIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.01.08', 'MERCADORIAS EM ARMAZENS DE TERCEIROS PARA REVENDA', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES PROPRIOS EM ARMAZENS DE TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.01.09', 'MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES ESTRATEGICOS', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES ESTRATEGICOS DO GOVERNO FEDERAL EM ARMAZENS DE TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.01.10', 'MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES REGULADORES PGPM', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES REGULADORES - PGPM DO GOVERNO FEDERAL EM ARMAZENS DE TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.01.11', 'MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES POR ATACADO', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES POR ATACADO MANTIDOS EM EM ARMAZENS DE TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.01.12', 'MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES AGRICULTURA FAMILIAR', 'REGISTRA O VALOR DAS MERCADORIAS DO PROGRAMA NACIONAL DE COMPRA DA PRODUCAO DA AGRICULTURA FAMILIAR EM ARMAZENS DE TERCEIROS, ORIUNDAS DE AQUISICAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.02.01', 'PRODUTOS ACABADOS', 'REGISTRA O VALOR DE PRODUTOS MANUFATURADOS JA TERMINADOS, ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPOSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.02.02', 'SERVICOS ACABADOS', 'REGISTRA OS VALORES PERTINENTES A SERVICOS ACABADOS QUE ESTAO PENDENTES DE FATURAMENTO OU DE TRANSFERENCIA PARA OUTRAS CONTAS DO ATIVO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.03.01', 'PRODUTOS EM ELABORACAO', 'REGISTRA A TOTALIDADE DAS MATERIAS-PRIMAS JA REQUISITADAS QUE ESTAO EM PROCESSO DE TRANSFORMACAO E O MONTANTE DE CUSTOS DIRETOS E INDIRETOS RELATIVOS AOS PRODUTOS EM ELABORACAO QUE NAO SERAO CONCLUIDOS ATE O TERMINO DO EXERCICIO SUBSEQUENTE A DATA DO BALANCO PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.03.02', 'SERVICOS EM ELABORACAO', 'REGISTRA OS CUSTOS DIRETOS E INDIRETOS RELATIVOS AOS SERVICOS EM ELABORACAO QUE NAO SERAO CONCLUIDOS ATE O TERMINO DO EXERCICIO SUBSEQUENTE A DATA DO BALANCO PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.04.01', 'MATERIAS-PRIMAS - ARMAZENS PROPRIOS', 'REGISTRA O ESTOQUE DE MATERIAS-PRIMAS QUE SERA UTILIZADO NO PROCESSO PRODUTIVO, GUARDADO EM ARMAZENS PROPRIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.04.02', 'MATERIAS-PRIMAS - ARMAZENS DE TERCEIROS', 'REGISTRA O ESTOQUE DE MATERIAS-PRIMAS QUE SERA UTILIZADO NO PROCESSO PRODUTIVO, GUARDADO EM ARMAZENS DE TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.05.01', 'ESTOQUES MERCADORIAS PARA REVENDA EM TRANSITO', 'REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS A ESTOQUES PROPRIOS DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.05.02', 'ESTOQUES POR ATACADO EM TRANSITO', 'REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DO ESTOQUE POR ATACADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.05.03', 'ESTOQUES ESPECIAIS DE PRODUTOS EM PROCESSO DE AQUISICAO', 'REGISTRA O VALOR DOS PRODUTOS EM PROCESSO DE AQUISICAO RELATIVOS A RESTOS A PAGAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.05.04', 'ESTOQUES PUBLICOS ESTRATEGICOS EM TRANSITO', 'REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DOS ESTOQUES ESTRATEGICOS DE NATUREZA PUBLICA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.05.05', 'ESTOQUES PUBLICOS REGULADORES-PGPM EM TRANSITO', 'REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DOS ESTOQUES REGULADORES - PGPM.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.05.06', 'ESTOQUES PUBLICOS AGRICULTURA FAMILIAR EM TRANSITO', 'REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DOS ESTOQUES DA AGRICULTURA FAMILIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.05.07', 'MERCADORIAS PARA DOACAO EM TRANSITO', 'REGISTRA O VALOR DAS MERCADARIAS PARA DOACAO, EM TRANSITO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.05.08', 'ESTOQUES AGRICULTURA FAMILIAR PARA DOACAO EM TRANSITO', 'REGISTRA O VALOR DE MERCADORIAS DO PROGRAMA NACIONAL DE COMPRA DA PRODUCAO DA AGRICULTURA FAMILIAR PARA DOACAO EM TRANSITO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.05.09', 'PRODUTOS PARA PESQUISA EM TRANSITO', 'REGISTRA O VALOR DOS MATERIAIS EM TRANSITO RELATIVOS AS TRANSFERENCIAS ENTRE UG, DE PRODUTOS PARA PESQUISA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.05.10', 'MATERIAL DE CONSUMO EM TRANSITO - TRANSFERENCIAS DO EXERCICIO', 'REGISTRA OS VALORES DOS MATERIAIS DE CONSUMO EM TRANSITO, RELATIVOS A TRANSFERENCIAS EFETUADAS ENTRE UNIDADES, NO EXERCICIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.05.11', 'MATERIAL DE CONSUMO EM TRANSITO - TRANSFERENCIAS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES DOS MATERIAIS DE CONSUMO EM TRANSITO, RELATIVOS A TRANSFERENCIAS EFETUADAS ENTRE UNIDADES, NO EXERCICIO ANTERIOR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.06.01', 'MATERIAL DE CONSUMO', 'REGISTRA OS VALORES DOS MATERIAIS DE CONSUMO ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.06.02', 'GENEROS ALIMENTICIOS', 'REGISTRA OS VALORES DOS GENEROS ALIMENTICIOS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.06.03', 'MATERIAIS DE CONSTRUCAO', 'REGISTRA OS VALORES DOS MATERIAIS DE CONSTRUCAO ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.06.04', 'MATERIAIS DE TELECOMUNICACOES', 'REGISTRA OS VALORES DOS MATERIAIS DE TELECOMUNICACOES ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.06.05', 'AUTOPECAS', 'REGISTRA OS VALORES DE AUTOPECAS ADQUIRIDAS E ESTOCADAS EM ALMOXARIFADOS, DESTINADAS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.06.06', 'MEDICAMENTOS E MATERIAIS HOSPITALARES', 'REGISTRA OS VALORES DOS MEDICAMENTOS E MATERIAS HOSPITALARES ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.06.07', 'MATERIAIS GRAFICOS', 'REGISTRA OS VALORES DOS MATERIAIS GRAFICOS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.06.08', 'MATERIAL DE EXPEDIENTE', 'REGISTRA OS VALORES DOS MATERIAIS DE EXPEDIENTE ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.06.09', 'MATERIAIS A CLASSIFICAR', 'REGISTRA OS VALORES DOS MATERIAIS ESTOCADOS PENDENTES DE CLASSIFICACAO E IDENTIFICACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.07.00', 'ADIANTAMENTOS A FORNECEDORES', 'REGISTRA OS ADIANTAMENTOS EFETUADOS PELA ENTIDADE A FORNECEDORES, VINCULADOS A COMPRAS ESPECIFICAS DE MATERIAIS QUE SERAO INCORPORADOS AOS ESTOQUES QUANDO DE SEU EFETIVO RECEBIMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.01', 'MATERIAIS DE ACONDICIONAMENTO E EMBALAGEM', 'REGISTRA OS VALORES DE ESTOQUE QUE SE DESTINAM A EMBALAGEM DO PRODUTO OU A SEU ACONDICIONAMENTO PARA REMESSA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.02', 'MATERIAL DE CONSUMO - ESTOQUE INTERNO - DESTINADO A DISTRIBUICAO', 'REGISTRA OS VALORES RELATIVOS AS AQUISICOES E OU TRANSFERENCIAS DE MATERIAIS DE CONSUMO PARA A FORMACAO DE ESTOQUE INTERNO DESTINADO A DISTRIBUICAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.03', 'MATERIAL DE CONSUMO - ESTOQUE EM ARMAZEM DE TERCEIROS - DESTINADO A DISTRIBUICAO', 'REGISTRA OS VALORES RELATIVOS AS AQUISICOES E OU TRANSFERENCIAS DE MATERIAIS DE CONSUMO PARA A FORMACAO DE ESTOQUE ,MANTIDO EM ARMAZEM DE TERCEIROS, DESTINADO A DISTRIBUICAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.04', 'MEDICAMENTOS - ESTOQUE INTERNO - DESTINADO A DISTRIBUICAO', 'REGISTRA OS VALORES DOS MEDICAMENTOS E OUTROS PRODUTOS FARMACEUTICOS, ADQUIRIDOS OU FABRICADOS PELA UNIDADE, DESTINADOS A FORMACAO DE ESTOQUE DE DISTRIBUICAO PARA CONSUMO INTERNO OU REDISTRIBUICAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.05', 'MEDICAMENTOS - ESTOQUE EM ARMAZEM DE TERCEIROS - DESTINADO A DISTRIBUICAO', 'REGISTRA OS VALORES RELATIVOS A AQUISICOES E OU TRANSFERENCIAS DE MEDICAMENTOS, PARA A FORMACAO DE ESTOQUE, MANTIDO EM ARMAZEM DE TERCEIROS, DESTINADO A DISTRIBUICAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.06', 'ESTOQUE DE MATERIAIS PARA PREMIACOES DESTINADO A DISTRIBUICAO', 'REGISTRA OS VALORES DAS PREMIACOES COMO: MEDALHAS E PLACAS DESTINADOS A FORMACAO DE ESTOQUE DE DISTRIBUICAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.07', 'MERCADORIAS PARA DOACAO - ESTOQUE INTERNO', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, MANTIDAS EM ARMAZENS PROPRIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.08', 'MERCADORIAS PARA DOACAO - ARMAZEM DE TERCEIROS', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, MANTIDAS EM ARMAZENS DE TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.09', 'MERCADORIAS PARA DOACAO - AGRICULTURA FAMILIAR- ESTOQUE INTERNO', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, DEPOSITADAS EM ARMAZENS PROPRIOS, RELATIVAS AO PROGRAMA DE AGRICULTURA FAMILIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.10', 'MERCADORIAS PARA DOACAO - AGRICULTURA FAMILIAR- ARMAZEM DE TERCEIROS', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, DEPOSITADAS EM ARMAZENS DE TERCEIROS, RELATIVAS AO PROGRAMA DE AGRICULTURA FAMILIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.11', 'MERCADORIAS PARA PERMUTA', 'REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS COM A FINALIDADE DE PERMUTA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.12', 'PRODUTOS PARA PESQUISA E ENSINO - ANIMAIS', 'REGISTRA O VALOR DOS ANIMAIS ADQUIRIDOS E DESTINADOS A PESQUISA DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.13', 'PRODUTOS PARA PESQUISA E ENSINO - VEGETAIS', 'REGISTRA O VALOR DO VEGETAIS ADQUIRIDOS E DESTINADOS A PESQUISA DA ENTIDADE, BEM COMO PRODUTOS INDUSTRIALIZADOS TAIS COMO: VINHOS, SUCOS , VINAGRES E PUBLICACOES TECNICAS DE PESQUISAS', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.14', 'PRODUTOS PARA PESQUISA E ENSINO - MINERAIS', 'REGISTRA O VALOR DOS MINERAIS ADQUIRIDOS E DESTINADOS A PESQUISA DA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.15', 'IMPORTACOES EM ANDAMENTO DO EXERCICIO', 'REGISTRA O VALOR DAS IMPORTACOES EM ANDAMENTO DE BENS DE ESTOQUE, DURANTE O EXERCICIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.16', 'IMPORTACOES EM ANDAMENTO DE EXERCICIOS ANTERIORES', 'REGISTRA O VALOR DAS IMPORTACOES EM ANDAMENTO DE BENS DE ESTOQUE, INICIADAS EM EXERCICIOS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.17', 'TERRENOS - CONSTRUCOES CIVIS', 'REGISTRA OS VALORES DE TERRENOS, INCLUINDO-SE OS CUSTOS DE FORMACAO OU DE URBANIZACAO E AJUSTES MONETARIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.18', 'PROJETOS - CONSTRUCOES CIVIS', 'REGISTRA OS VALORES DOS CUSTOS RELATIVOS AOS PROJETOS DE ARQUITETURA E URBANISMO PARA CONSTRUCOES E URBANIZACOES DE IMOVEIS QUE DEVERAO SER COLOCADOS A VENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.19', 'OBRAS EM ANDAMENTO - CONSTRUCOES CIVIS', 'REGISTRA OS VALORES RELATIVOS A OBRAS EM ANDAMENTO, DESTINADAS A VENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.20', 'OBRAS CONCLUIDAS A COMERCIALIZAR - CONSTRUCOES CIVIS', 'REGISTRA OS VALORES RELATIVOS AS CONSTRUCOES E AS EDIFICACOES CONCLUIDAS QUE DEVERAO SER COLOCADAS A VENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.21', 'CUSTOS ACESSORIOS DE CONSTRUCAO CIVIL', 'REGISTRA OS VALORES DE SEGUROS, REMUNERACOES A AGENTES FINANCEIROS, IMPOSTOS E TAXAS, DESPESAS COM LEGALIZACOES E CARTORARIAS RELATIVOS A IMOVEIS DESTINADOS A VENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.99', 'ESTOQUES DIVERSOS', 'REGISTRA ESTOQUES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.99.01', '(-) AJUSTE DE PERDAS EM ESTOQUES', 'REGISTRA AS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NAO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NAO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.99.02', '(-) AJUSTE DE REDUCAO AO VALOR DE MERCADO', 'REGISTRA O AJUSTE PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.01.00', 'PREMIOS DE SEGUROS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE PREMIOS DE SEGURO A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.02.00', 'VPD FINANCEIRAS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE VPD FINANCEIRAS A APROPRIAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.03.00', 'ASSINATURAS E ANUIDADES A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.04.00', 'ALUGUEIS PAGOS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.05.00', 'TRIBUTOS PAGOS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE TRIBUTOS A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.06.00', 'CONTRIBUICOES CONFEDERATIVAS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE CONTRIBUICOES CONFEDERATIVAS A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.07.00', 'BENEFICIOS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE BENEFICIO A PESSOAL A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.99.01', 'DIREITOS AUTORAIS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE DIREITOS AUTORAIS A SEREM APROPRIADOS QUANDO DA EFETIVACAO DA VPD.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.99.02', 'COMISSOES E PREMIOS PAGOS A APROPRIAR', 'REGISTRA OS PAGAMENTOS NAO RESTITUIVEIS A VENDEDORES OU REPRESENTANTES POR CONTA DE COMISSOES OU DE PREMIOS POR VENDAS QUE A ENTIDADE AINDA NAO CONTABILIZOU COMO VARIACOES PATRIMONIAIS AUMENTATIVAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.99.99', 'OUTRAS VPD A APROPRIAR', 'REGISTRA OUTROS VALORES PAGOS A APROPRIAR QUANDO DA EFETIVACAO DA VPD.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.2.02.00', 'VPD FINANCEIRAS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO VPD FINANCEIRAS A APROPRIAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.2.03.00', 'ASSINATURAS E ANUIDADES A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.2.04.00', 'ALUGUEIS PAGOS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.2.05.00', 'TRIBUTOS PAGOS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE TRIBUTOS A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.2.99.01', 'DIREITOS AUTORAIS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE DIREITOS AUTORAIS A SEREM APROPRIADOS QUANDO DA EFETIVACAO DA VPD.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.2.99.02', 'COMISSOES E PREMIOS PAGOS A APROPRIAR', 'REGISTRA OS PAGAMENTOS NAO RESTITUIVEIS A VENDEDORES OU REPRESENTANTES POR CONTA DE COMISSOES OU DE PREMIOS POR VENDAS QUE A ENTIDADE AINDA NAO CONTABILIZOU COMO VARIACOES PATRIMONIAIS AUMENTATIVAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.2.99.99', 'OUTRAS VPD A APROPRIAR', 'REGISTRA OUTROS VALORES PAGOS A APROPRIAR QUANDO DA EFETIVACAO DA VPD.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.4.02.00', 'VPD FINANCEIRAS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO VPD FINANCEIRAS A APROPRIAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.4.03.00', 'ASSINATURAS E ANUIDADES A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.4.04.00', 'ALUGUEIS PAGOS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.4.05.00', 'TRIBUTOS PAGOS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE TRIBUTOS A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.4.99.01', 'DIREITOS AUTORAIS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE DIREITOS AUTORAIS A SEREM APROPRIADOS QUANDO DA EFETIVACAO DA VPD.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.4.99.02', 'COMISSOES E PREMIOS PAGOS A APROPRIAR', 'REGISTRA OS PAGAMENTOS NAO RESTITUIVEIS A VENDEDORES OU REPRESENTANTES POR CONTA DE COMISSOES OU DE PREMIOS POR VENDAS QUE A ENTIDADE AINDA NAO CONTABILIZOU COMO VARIACOES PATRIMONIAIS AUMENTATIVAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.4.99.99', 'OUTRAS VPD A APROPRIAR', 'REGISTRA OUTROS VALORES PAGOS A APROPRIAR QUANDO DA EFETIVACAO DA VPD.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.5.02.00', 'VPD FINANCEIRAS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO VPD FINANCEIRAS A APROPRIAR.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.5.03.00', 'ASSINATURAS E ANUIDADES A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.5.04.00', 'ALUGUEIS PAGOS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.5.05.00', 'TRIBUTOS PAGOS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE TRIBUTOS A APROPRIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.5.99.01', 'DIREITOS AUTORAIS A APROPRIAR', 'REGISTRA OS VALORES PAGOS A TITULO DE DIREITOS AUTORAIS A SEREM APROPRIADOS QUANDO DA EFETIVACAO DA VPD.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.5.99.02', 'COMISSOES E PREMIOS PAGOS A APROPRIAR', 'REGISTRA OS PAGAMENTOS NAO RESTITUIVEIS A VENDEDORES OU REPRESENTANTES POR CONTA DE COMISSOES OU DE PREMIOS POR VENDAS QUE A ENTIDADE AINDA NAO CONTABILIZOU COMO VARIACOES PATRIMONIAIS AUMENTATIVAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.5.99.99', 'OUTRAS VPD A APROPRIAR', 'REGISTRA OUTROS VALORES PAGOS A APROPRIAR QUANDO DA EFETIVACAO DA VPD.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.01', 'PARTICIPACOES EM EMPRESAS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.02', 'PARTICIPACOES EM FUNDOS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM FUNDOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.03', 'PARTICIPACOES EM CONSORCIOS PUBLICOS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM CONSORCIOS PUBLICOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.04', 'ADIANTAMENTO PARA AUMENTO DE CAPITAL - PRINCIPAL', 'REGISTRA OS VALORES DO PRINCIPAL PARA AUMENTO DE CAPITAL NAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.05', 'ADIANTAMENTO PARA AUMENTO DE CAPITAL - CORRECAO SELIC', 'REGISTRA OS VALORES DA CORRECAO PELA TAXA SELIC PARA AUMENTO DE CAPITAL NAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.95', 'OUTRAS PARTICIPACOES - MEP', 'REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.96', 'AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA O VALOR DO AGIO NA AQUISICAO DE PARTICIPACOES, OU SEJA, A DIFERENCA ENTRE O CUSTO DO INVESTIMENTO E A PARTE DO INVESTIDOR NO VALOR JUSTO LIQUIDO DOS ATIVOS E PASSIVOS IDENTIFICAVEIS NA INVESTIDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.97', '(-) AMORTIZACAO DE AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA A AMORTIZACAO DE AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.98', '(-) DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA O DESAGIO NA AQUISICAO DE PARTICIPACOES, OU SEJA, A DIFERENCA A MENOR PAGA POR UMA PARTICIPACAO EM RELACAO AO SEU VALOR PATRIMONIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.99', 'AMORTIZACAO DE DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA A AMORTIZACAO DE DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.02.01', 'PARTICIPACOES EM EMPRESAS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.02.02', 'PARTICIPACOES EM FUNDOS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM FUNDOS, AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.02.03', 'PARTICIPACOES EM ORGANISMOS INTERNACIONAIS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM ORGANISMOS INTERNACIONAIS, AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.02.99', 'OUTRAS PARTICIPACOES - METODO DE CUSTO', 'REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.01', 'PARTICIPACOES EM EMPRESAS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.02', 'PARTICIPACOES EM FUNDOS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM FUNDOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.03', 'PARTICIPACOES EM CONSORCIOS PUBLICOS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM CONSORCIOS PUBLICOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.04', 'ADIANTAMENTO PARA AUMENTO DE CAPITAL - PRINCIPAL', 'REGISTRA OS VALORES DO PRINCIPAL PARA AUMENTO DE CAPITAL NAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.05', 'ADIANTAMENTO PARA AUMENTO DE CAPITAL - CORRECAO SELIC', 'REGISTRA OS VALORES DA CORRECAO PELA TAXA SELIC PARA AUMENTO DE CAPITAL NAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.95', 'OUTRAS PARTICIPACOES - MEP', 'REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.96', 'AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA O VALOR DO AGIO NA AQUISICAO DE PARTICIPACOES, OU SEJA, A DIFERENCA ENTRE O CUSTO DO INVESTIMENTO E A PARTE DO INVESTIDOR NO VALOR JUSTO LIQUIDO DOS ATIVOS E PASSIVOS IDENTIFICAVEIS NA INVESTIDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.97', '(-) AMORTIZACAO DE AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA A AMORTIZACAO DE AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.98', '(-) DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA O DESAGIO NA AQUISICAO DE PARTICIPACOES, OU SEJA, A DIFERENCA A MENOR PAGA POR UMA PARTICIPACAO EM RELACAO AO SEU VALOR PATRIMONIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.99', 'AMORTIZACAO DE DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA A AMORTIZACAO DE DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.02.01', 'PARTICIPACOES EM EMPRESAS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.02.02', 'PARTICIPACOES EM FUNDOS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM FUNDOS, AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.02.03', 'PARTICIPACOES EM ORGANISMOS INTERNACIONAIS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM ORGANISMOS INTERNACIONAIS, AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.02.99', 'OUTRAS PARTICIPACOES - METODO DE CUSTO', 'REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.01', 'PARTICIPACOES EM EMPRESAS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.02', 'PARTICIPACOES EM FUNDOS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM FUNDOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.03', 'PARTICIPACOES EM CONSORCIOS PUBLICOS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM CONSORCIOS PUBLICOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.04', 'ADIANTAMENTO PARA AUMENTO DE CAPITAL - PRINCIPAL', 'REGISTRA OS VALORES DO PRINCIPAL PARA AUMENTO DE CAPITAL NAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.05', 'ADIANTAMENTO PARA AUMENTO DE CAPITAL - CORRECAO SELIC', 'REGISTRA OS VALORES DA CORRECAO PELA TAXA SELIC PARA AUMENTO DE CAPITAL NAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.95', 'OUTRAS PARTICIPACOES - MEP', 'REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.96', 'AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA O VALOR DO AGIO NA AQUISICAO DE PARTICIPACOES, OU SEJA, A DIFERENCA ENTRE O CUSTO DO INVESTIMENTO E A PARTE DO INVESTIDOR NO VALOR JUSTO LIQUIDO DOS ATIVOS E PASSIVOS IDENTIFICAVEIS NA INVESTIDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.97', '(-) AMORTIZACAO DE AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA A AMORTIZACAO DE AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.98', '(-) DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA O DESAGIO NA AQUISICAO DE PARTICIPACOES, OU SEJA, A DIFERENCA A MENOR PAGA POR UMA PARTICIPACAO EM RELACAO AO SEU VALOR PATRIMONIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.99', 'AMORTIZACAO DE DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA A AMORTIZACAO DE DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.02.01', 'PARTICIPACOES EM EMPRESAS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.02.02', 'PARTICIPACOES EM FUNDOS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM FUNDOS, AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.02.03', 'PARTICIPACOES EM ORGANISMOS INTERNACIONAIS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM ORGANISMOS INTERNACIONAIS, AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.02.99', 'OUTRAS PARTICIPACOES - METODO DE CUSTO', 'REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.01', 'PARTICIPACOES EM EMPRESAS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.02', 'PARTICIPACOES EM FUNDOS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM FUNDOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.03', 'PARTICIPACOES EM CONSORCIOS PUBLICOS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM CONSORCIOS PUBLICOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.04', 'ADIANTAMENTO PARA AUMENTO DE CAPITAL - PRINCIPAL', 'REGISTRA OS VALORES DO PRINCIPAL PARA AUMENTO DE CAPITAL NAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.05', 'ADIANTAMENTO PARA AUMENTO DE CAPITAL - CORRECAO SELIC', 'REGISTRA OS VALORES DA CORRECAO PELA TAXA SELIC PARA AUMENTO DE CAPITAL NAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.95', 'OUTRAS PARTICIPACOES - MEP', 'REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.96', 'AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA O VALOR DO AGIO NA AQUISICAO DE PARTICIPACOES, OU SEJA, A DIFERENCA ENTRE O CUSTO DO INVESTIMENTO E A PARTE DO INVESTIDOR NO VALOR JUSTO LIQUIDO DOS ATIVOS E PASSIVOS IDENTIFICAVEIS NA INVESTIDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.97', '(-) AMORTIZACAO DE AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA A AMORTIZACAO DE AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.98', '(-) DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA O DESAGIO NA AQUISICAO DE PARTICIPACOES, OU SEJA, A DIFERENCA A MENOR PAGA POR UMA PARTICIPACAO EM RELACAO AO SEU VALOR PATRIMONIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.99', 'AMORTIZACAO DE DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'REGISTRA A AMORTIZACAO DE DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.02.01', 'PARTICIPACOES EM EMPRESAS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.02.02', 'PARTICIPACOES EM FUNDOS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM FUNDOS, AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.02.03', 'PARTICIPACOES EM ORGANISMOS INTERNACIONAIS', 'REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM ORGANISMOS INTERNACIONAIS, AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.02.99', 'OUTRAS PARTICIPACOES - METODO DE CUSTO', 'REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE CUSTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.2.1.01.00', 'TERRENOS E IMOVEIS PARA FUTURA UTILIZACAO', 'REGISTRA OS VALORES DE IMOVEIS DA UNIDADE MANTIDOS PARA FUTURA UTILIZACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.2.1.02.00', 'BENS IMOVEIS NAO DESTINADOS A USO', 'REGISTRA OS VALORES DE IMOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.1.01.00', 'OBRAS DE ARTE', 'REGISTRA OS VALORES REFERENTES A OBRAS DE ARTE DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.1.03.00', 'BENS MOVEIS NAO DESTINADOS A USO', 'REGISTRA OS VALORES DE MOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.1.05.00', 'BENS INTANGIVEIS NAO DESTINADOS A USO', 'REGISTRA O VALOR DE BENS INTANGIVEIS NAO DESTINADOS AO USO E QUE A UNIDADE NAO EXPLORA COMERCIALMENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.1.06.00', 'TITULOS E VALORES MOBILIARIOS PERMANENTES', 'REGISTRA O VALOR DOS TITULOS E VALORES MOBILIARIOS NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO, COMO POR EXEMPLO AS DEBENTURES (PERPETUAS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.1.99.00', 'DEMAIS INVESTIMENTOS PERMANENTES', 'REGISTRA O VALOR DE INVESTIMENTOS PERMANENTES, NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.2.01.00', 'OBRAS DE ARTE', 'REGISTRA OS VALORES REFERENTES A OBRAS DE ARTE DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.2.03.00', 'BENS MOVEIS NAO DESTINADOS A USO', 'REGISTRA OS VALORES DE MOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.2.05.00', 'BENS INTANGIVEIS NAO DESTINADOS A USO', 'REGISTRA O VALOR DE BENS INTANGIVEIS NAO DESTINADOS AO USO E QUE A UNIDADE NAO EXPLORA COMERCIALMENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.2.06.00', 'TITULOS E VALORES MOBILIARIOS PERMANENTES', 'REGISTRA O VALOR DOS TITULOS E VALORES MOBILIARIOS NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO, COMO POR EXEMPLO AS DEBENTURES (PERPETUAS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.2.99.00', 'DEMAIS INVESTIMENTOS PERMANENTES', 'REGISTRA O VALOR DE INVESTIMENTOS PERMANENTES, NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.4.01.00', 'OBRAS DE ARTE', 'REGISTRA OS VALORES REFERENTES A OBRAS DE ARTE DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.4.03.00', 'BENS MOVEIS NAO DESTINADOS A USO', 'REGISTRA OS VALORES DE MOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.4.05.00', 'BENS INTANGIVEIS NAO DESTINADOS A USO', 'REGISTRA O VALOR DE BENS INTANGIVEIS NAO DESTINADOS AO USO E QUE A UNIDADE NAO EXPLORA COMERCIALMENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.4.06.00', 'TITULOS E VALORES MOBILIARIOS PERMANENTES', 'REGISTRA O VALOR DOS TITULOS E VALORES MOBILIARIOS NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO, COMO POR EXEMPLO AS DEBENTURES (PERPETUAS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.4.99.00', 'DEMAIS INVESTIMENTOS PERMANENTES', 'REGISTRA O VALOR DE INVESTIMENTOS PERMANENTES, NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.5.01.00', 'OBRAS DE ARTE', 'REGISTRA OS VALORES REFERENTES A OBRAS DE ARTE DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.5.03.00', 'BENS MOVEIS NAO DESTINADOS A USO', 'REGISTRA OS VALORES DE MOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.5.05.00', 'BENS INTANGIVEIS NAO DESTINADOS A USO', 'REGISTRA O VALOR DE BENS INTANGIVEIS NAO DESTINADOS AO USO E QUE A UNIDADE NAO EXPLORA COMERCIALMENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.5.06.00', 'TITULOS E VALORES MOBILIARIOS PERMANENTES', 'REGISTRA O VALOR DOS TITULOS E VALORES MOBILIARIOS NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO, COMO POR EXEMPLO AS DEBENTURES (PERPETUAS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.5.99.00', 'DEMAIS INVESTIMENTOS PERMANENTES', 'REGISTRA O VALOR DE INVESTIMENTOS PERMANENTES, NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.8.1.01.00', '(-) DEPRECIACAO ACUMULADA DE INVESTIMENTOS - CONSOLIDACAO- PROPRIEDADES PARA INVESTIMENTO', 'REGISTRA A DIMINUICAO DO VALOR DE PROPRIEDADES PARA INVESTIMENTO DEVIDO AO DESGASTE PELO USO, ACAO DA NATUREZA OU OBSOLESCENCIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.1.01.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - PARTICIPACOES PERMANENTES', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE PARTICIPACOES PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.1.02.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE PROPRIEDADES PARA INVESTIMENTO', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE PROPRIEDADES PARA INVESTIMENTO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.1.03.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS DO RPPS', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS DO RPPS, QUANDO ESTE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.1.04.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DEMAIS INVESTIMENTOS PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.2.01.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - PARTICIPACOES PERMANENTES', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE PARTICIPACOES PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.2.04.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DEMAIS INVESTIMENTOS PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.4.01.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - PARTICIPACOES PERMANENTES', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE PARTICIPACOES PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.4.04.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DEMAIS INVESTIMENTOS PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.5.01.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - PARTICIPACOES PERMANENTES', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE PARTICIPACOES PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.5.04.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DEMAIS INVESTIMENTOS PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.01', 'APARELHOS DE MEDICAO E ORIENTACAO', 'REGISTRA OS APARELHOS UTILIZADOS PARA MEDICAO E ORIENTACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.02', 'APARELHOS E EQUIPAMENTOS DE COMUNICACAO', 'REGISTRA OS APARELHOS E EQUIPAMENTOS UTILIZADOS PARA COMUNICACAO', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.03', 'APARELHOS, EQUIPAMENTOS E UTENSILIOS MEDICOS, ODONTOLOGICOS, LABORATORIAIS E HOSPITALARES', 'REGISTRA OS APARELHOS, EQUIPAMENTOS E UTENSILIOS PARA USO MEDICO, ODONTOLOGICO, LABORATORIAL E HOSPITALAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.04', 'APARELHOS E EQUIPAMENTOS PARA ESPORTES E DIVERSOES', 'REGISTRA OS APARELHOS E EQUIPAMENTOS UTILIZADOS PARA MODALIDADES DE ESPORTES E DIVERSOES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.05', 'EQUIPAMENTO DE PROTECAO, SEGURANCA E SOCORRO', 'REGISTRA OS EQUIPAMENTOS UTILIZACOES PARA PROTECAO, SEGURANCA E SOCORRO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.06', 'MAQUINAS E EQUIPAMENTOS INDUSTRIAIS', 'REGISTRA AS MAQUINAS E EQUIPAMENTOS DE NATUREZA INDUSTRIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.07', 'MAQUINAS E EQUIPAMENTOS ENERGETICOS', 'REGISTRA AS MAQUINAS E EQUIPAMENTOS ENERGETICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.08', 'MAQUINAS E EQUIPAMENTOS GRAFICOS', 'REGISTRA AS MAQUINAS E EQUIPAMENTOS EMPREGADOS NA INDUSTRIA GRAFICA OU NECESSARIOS PARA SUA INDUSTRIALIZACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.09', 'MAQUINAS, FERRAMENTAS E UTENSILIOS DE OFICINA', 'REGISTRA AS MAQUINAS, FERRAMENTAS E UTENSILIOS UTILIZADOS EM OFICINAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.10', 'EQUIPAMENTOS DE MONTARIA', 'REGISTRA OS EQUIPAMENTOS UTILIZADOS EM MONTARIAS, BEM COMO OS SERVICOS CORRELACIONADOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.11', 'EQUIPAMENTOS E MATERIAL SIGILOSO E RESERVADO', 'REGISTRA OS EQUIPAMENTOS E MATERIAIS UTILIZADOS EM ATIVIDADES DE CARATER SIGILOSO OU RESERVADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.12', 'EQUIPAMENTOS, PECAS E ACESSORIOS PARA AUTOMOVEIS', 'REGISTRA OS EQUIPAMENTOS, PECAS E ACESSORIOS PARA AUTOMOVEIS QUE PODEM SER DESINCORPORADOS, SEM PREJUIZO DOS MESMOS, PARA APLICACAO EM OUTRO VEICULO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.13', 'EQUIPAMENTOS, PECAS E ACESSORIOS MARITIMOS', 'REGISTRA OS EQUIPAMENTOS, PECAS E ACESSORIOS MARITIMOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.14', 'EQUIPAMENTOS, PECAS E ACESSORIOS AERONAUTICOS', 'REGISTRA OS EQUIPAMENTOS, PECAS E ACESSORIOS AERONAUTICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.15', 'EQUIPAMENTOS, PECAS E ACESSORIOS DE PROTECAO AO VOO', 'REGISTRA OS EQUIPAMENTOS, PECAS E ACESSORIOS DE PROTECAO AO VOO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.16', 'EQUIPAMENTOS DE MERGULHO E SALVAMENTO', 'REGISTRA OS EQUIPAMENTOS DE MERGULHO E SALVAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.17', 'EQUIPAMENTOS SOBRESSALENTES DE MAQUINAS E MOTORES DE NAVIO DE ESQUADRA', 'REGISTRA OS EQUIPAMENTOS SOBRESSALENTES DE MAQUINAS E MOTORES DE NAVIOS DE ESQUADRA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.18', 'EQUIPAMENTOS DE MANOBRAS E PATRULHAMENTO', 'REGISTRA OS EQUIPAMENTOS DESTINADOS AO EXERCICIO MILITAR, SERVICOS DE BORDO, GUARNICOES, RONDAS OU VIGILANCIA UTILIZADOS PELA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.19', 'EQUIPAMENTOS DE PROTECAO E VIGILANCIA AMBIENTAL', 'REGISTRA OS EQUIPAMENTOS UTILIZADOS EM SISTEMAS DE PROTECAO E VIGILANCIA AEREA E AMBIENTAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.20', 'MAQUINAS, EQUIPAMENTOS E UTENSILIOS AGROPECUARIOS E RODOVIARIOS', 'REGISTRA OS VALORES RELATIVOS A MAQUINAS, EQUIPAMENTOS, FERRAMENTAS E UTENSILIOS AGROPECUARIOS E REDOVIARIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.21', 'EQUIPAMENTOS HIDRAULICOS E ELETRICOS', 'REGISTRA OS EQUIPAMENTOS HIDRAULICOS E ELETRICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.22', 'EQUIP E MAT PERMANENTES VINCULADOS A CONVENIO', 'REGISTRA OS EQUIPAMENTOS E MATERIAIS PERMANENTES ADQUIRIDOS COM RECURSOS DO CONVENIO DURANTE SUA VIGENCIA ATE DESTINACAO DEFINITIVA CONFORME DISPOE O ARTIGO 28 DA PORTARIA INTERMINISTERIAL MP/MF/CGU 127/2008', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.99', 'OUTRAS MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS', 'REGISTRA OS VALORES REFERENTES A MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS NAO CLASSIFICADOS EM CONTAS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.02.01', 'EQUIPAMENTOS DE PROCESSAMENTO DE DADOS', 'REGISTRA OS EQUIPAMENTOS DE PROCESSAMENTO DE DADOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.02.02', 'EQUIPAMENTOS DE TECNOLOGIA DA INFORMACAO', 'REGISTRA OS EQUIPAMENTOS RELACIONADOS COM TECNOLOGIA DA INFORMACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.03.01', 'APARELHOS E UTENSILIOS DOMESTICOS', 'REGISTRA OS OBJETOS OU PECAS DE USO CASEIRO OU NECESSARIOS A VIDA FAMILIAR.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.03.02', 'MAQUINAS E UTENSILIOS DE ESCRITORIO', 'REGISTRA AS MAQUINAS E UTENSILIOS DE ESCRITORIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.03.03', 'MOBILIARIO EM GERAL', 'REGISTRA OS VALORES RELATIVOS AOS BENS MOVEIS, DE CARATER GERAL, EM USO NA UNIDADE, NAO CLASSIFICADOS EM CONTAS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.03.04', 'UTENSILIOS EM GERAL', 'REGISTRA OS VALORES RELATIVOS A UTENSILIOS, DE CARATER GERAL, EM USO NA UNIDADE, NAO CLASSIFICADOS EM CONTAS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.01', 'BANDEIRAS, FLAMULAS E INSIGNIAS', 'REGISTRA OS VALORES RELATIVOS A BANDEIRAS, FLAMULAS E INSIGNIAS, GERALMENTE UTILIZADAS COMO DISTINTIVO DA NACAO E DE CORPORACOES, PEQUENAS CHAMAS, ADORNOS, SINAL DISTINTIVO, EMBLEMAS, ESTANDARTES E OUTROS SIMBOLOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.02', 'COLECOES E MATERIAIS BIBLIOGRAFICOS', 'REGISTRA OS VALORES RELATIVOS AOS OBJETOS E MATERIAIS BIBLIOGRAFICOS DESTINADOS A REUNIR, GERALMENTE, PARA FORMACAO DE BIBLIOTECAS DE USO DA UNIDADE OU CUMPRIR OBJETIVOS DESSA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.03', 'DISCOTECAS E FILMOTECAS', 'REGISTRA OS VALORES RELATIVOS A DISCOS, CDS E COLECOES DE FITAS GRAVADAS COM MUSICAS E FITAS CINEMATOGRAFICAS DE CARATER EDUCATIVO, CIENTIFICO E INFORMATIVO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.04', 'INSTRUMENTOS MUSICAIS E ARTISTICOS', 'REGISTRA OS VALORES RELATIVOS AOS INSTRUMENTOS MUSICAIS E ARTISTICOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.05', 'EQUIPAMENTOS PARA AUDIO, VIDEO E FOTO', 'REGISTRA OS VALORES DE EQUIPAMENTOS DE AUDIO, VIDEO E FOTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.06', 'OBRAS DE ARTE E PECAS PARA EXPOSICAO', 'REGISTRA OS VALORES RELATIVOS A OBRAS E OBJETOS DE ARTE E DE PECAS PARA DECORACAO OU EXPOSICAO EM GERAL EM MUSEUS, GALERIAS, HALLS, PREDIOS PUBLICOS E OUTROS, DESDE QUE SE DESTINEM A MANUTENCAO DE SUA ATIVIDADE, CASO CONTRARIO, DEVE SER CLASSIFICADO COMO INVESTIMENTOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.99', 'OUTROS MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICACAO', 'REGISTRA OS VALORES REFERENTES A MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICACAO NAO CLASSIFICADOS EM CONTAS ANTERIORES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.05.01', 'VEICULOS EM GERAL', 'REGISTRA OS VEICULOS DE DIVERSOS TIPOS, NAO MOTORIZADOS, PARA OS QUAIS NAO TENHAM SIDO CRIADAS CONTAS ESPECIFICAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.05.02', 'VEICULOS FERROVIARIOS', 'REGISTRA OS VEICULOS DESTINADOS AO TRAFEGO POR VIA FERREA E PARA USOS DIVERSOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.05.03', 'VEICULOS DE TRACAO MECANICA', 'REGISTRA OS VEICULOS DE TRACAO MECANICA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.05.04', 'CARROS DE COMBATE', 'REGISTRA OS CARROS DE COMBATE, TAIS COMO CARRO-TANQUE, AUTO-CHOQUE E ASSEMELHADOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.05.05', 'AERONAVES', 'REGISTRA OS VEICULOS DESTINADOS AO TRAFEGO AEREO, GERALMENTE DE USO COMERCIAL, NO TRANSPORTE DE PASSAGEIROS E CARGAS OU PARA TREINAMENTO, DEFESA E ATAQUE MILITAR, BEM COMO OUTRAS ATIVIDADES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.05.06', 'EMBARCACOES', 'REGISTRA AS EMBARCACOES ADQUIRIDAS OU CONSTRUIDAS E DESTINADAS A NAVEGACAO POR VIAS MARITIMAS, FLUVIAIS E OUTRAS VIAS NAVEGAVEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.06.00', 'PECAS E CONJUNTOS DE REPOSICAO', 'REGISTRA O VALOR DA AQUISICAO OU INCORPORACAO DE PECAS E CONJUNTOS DE REPOSICAO DESTINADOS A SUBSTITUICAO EM MAQUINAS E EQUIPAMENTOS, AERONAVES E EMBARCACOES, BENS DE SEGURANCA E SOCORRO, ENTRE OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.07.01', 'BENS MOVEIS EM ELABORACAO', 'REGISTRA OS VALORES RELATIVOS A TODOS OS GASTOS OCORRIDOS COM BENS MOVEIS EM FASE DE ELABORACAO E ACABAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.07.02', 'IMPORTACOES EM ANDAMENTO', 'REGISTRA OS VALORES RELATIVOS A TODOS OS GASTOS COM IMPORTACOES EM ANDAMENTO DE EQUIPAMENTOS, MAQUINAS, APARELHOS E OUTROS BENS MOVEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.07.03', 'ADIANTAMENTOS PARA INVERSOES EM BENS MOVEIS', 'REGISTRA OS ADIANTAMENTOS A FORNECEDORES POR FORNECIMENTO SOB ENCOMENDA DE BENS MOVEIS, QUE REPRESENTAM PAGAMENTOS POR UM VALOR PREVIAMENTE CONTRATADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.07.04', 'ALMOXARIFADO DE INVERSOES FIXAS', 'REGISTRA TODOS OS MATERIAIS E BENS DA EMPRESA DESTINADOS A APLICACAO NA ELABORACAO DE BENS MOVEIS EM ANDAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.08.01', 'ESTOQUE INTERNO', 'REGISTRA OS VALORES DOS BENS MOVEIS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADO, DESTINADOS A ATENDER AS NECESSIDADES DOS ORGAOS ADQUIRENTES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.08.02', 'ESTOQUE DE DISTRIBUICAO', 'REGISTRA OS VALORES DE BENS MOVEIS PARA FORMACAO DE ESTOQUE DE DISTRIBUICAO INTERNA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.08.03', 'BENS MOVEIS A REPARAR', 'REGISTRA OS VALORES DOS BENS MOVEIS QUE NECESSITAM DE REPAROS OU REFORMAS, ESTOCADOS EM ALMOXARIFADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.08.04', 'BENS MOVEIS EM REPARO', 'REGISTRA OS VALORES DOS BENS MOVEIS QUE ENCONTRAM-SE EM REPAROS OU REFORMAS, ESTOCADOS EM ALMOXARIFADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.08.05', 'BENS MOVEIS INSERVIVEIS', 'REGISTRA OS VALORES DOS BENS MOVEIS INSERVIVEIS EM ALMOXARIFADO, QUE DEPENDEM DE PARECER DA COMISSAO E HOMOLOGACAO DA AUTORIDADE COMPETENTE PARA SEREM DESCARREGADOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.09.00', 'ARMAMENTOS', 'REGISTRA OS VALORES DE ARMAS QUE CONSTITUEM OBJETOS DE DEFESA OU PREPARATIVOS DE GUERRA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.10.00', 'SEMOVENTES', 'REGISTRA OS VALORES RELATIVOS AOS ANIMAIS DESTINADOS A PRODUCAO, REPRODUCAO, ENGORDA E AOS SERVICOS UTILITARIOS EM GERAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.01', 'BENS MOVEIS A ALIENAR', 'REPRESENTA OS REGISTROS DOS VALORES RELATIVOS AOS BENS MOVEIS QUE, POR ALGUM MOTIVO, FORAM DESTINADOS A ALIENACAO, MEDIANTE VENDA, PERMUTA OU DOACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.02', 'BENS EM PODER DE OUTRA UNIDADE OU TERCEIROS', 'REGISTRA OS VALORES DE BENS MOVEIS DE PROPRIEDADE DA UNIDADE CEDENTE, ENTREGUES A OUTRA UNIDADE OU TERCEIROS POR MEIO DE CONVENIO, COMODATO OU OUTRAS FORMAS DE EMPRESTIMO, DISTRIBUICAO OU TRANSFERENCIA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.03', 'ESTOQUES EM ARMAZENS DE TERCEIROS A DISTRIBUIR', 'REGISTRA OS VALORES DE BENS MOVEIS ADQUIRIDOS OU TRANSFERIDOS PARA FORMACAO DE ESTOQUE DE DISTRIBUICAO EM ARMAZENS DE TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.04', 'ARMAZENS ESTRUTURAIS - COBERTURAS DE LONA', 'REGISTRA OS VALORES DE ARMAZENS ESTRUTURAIS DE COBERTURA DE LONA DESTINADOS A DEPOSITO DE MERCADORIAS, MUNICOES E DE OUTROS MATERIAIS, COM POSSIBILIDADE DE MUDANCA DE LOCAL DE INSTALACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.05', 'BENS MOVEIS EM TRANSITO', 'REGISTRA OS VALORES DE BENS MOVEIS TRANSFERIDOS PARA OUTRAS UNIDADES, QUANDO EM TRANSITO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.06', 'BENS MOVEIS EM RECUPERACAO', 'REGISTRA OS VALORES DOS BENS EM PROCESSO DE RECUPERACAO MAIS OS GASTOS REFERENTES AS ADAPTACOES OU REMODELAGENS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.07', 'BENS NAO LOCALIZADOS', 'REGISTRA OS BENS NAO ENCONTRADOS NO PROCESSO DE INVENTARIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.08', 'BENS MOVEIS A CLASSIFICAR', 'REGISTRA OS BENS MOVEIS PENDENTES DE CLASSIFICACAO E DE IDENTIFICACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.99', 'OUTROS BENS MOVEIS', 'REGISTRA O VALOR DA AQUISICAO OU INCORPORACAO DOS OUTROS BENS MOVEIS NAO CLASSIFICADOS ANTERIORMENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.01', 'IMOVEIS RESIDENCIAIS / COMERCIAIS', 'REGISTRA OS VALORES RELATIVOS AOS IMOVEIS RESIDENCIAIS/COMERCIAIS DA UNIAO, CONFIRME O CODIGO DA TABELA SPIU, A SABER: 05-APARTAMENTOS; 10-CASAS; 50-RESIDENCIAS; 15-CONJUNTOS. OS IMOVEIS FUNCIONAIS, OS PROPRIOS NACIONAIS RESIDENCIAIS (PNR) E AS VILAS MILITARES DEVEM SER REGISTRADOS NESSA CONTA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.02', 'EDIFICIOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 19- EDIFICIOS/PREDIOS; 17- CONVENTOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.03', 'TERRENOS/GLEBAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 53- TERRENOS; 34- GLEBAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.04', 'ARMAZENS/GALPOES', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 06- ARMAZENS; 33- GALPOES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.05', 'AQUARTELAMENTOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 08- BASES; 47- QUARTEIS; 31- FORTES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.06', 'AEROPORTOS/ESTACOES/AERODROMOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 02- AERODROMO; 03- AEROPORTO; 23- ESTACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.07', 'IMOVEIS DE USO EDUCACIONAL', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 22- ESCOLAS; 28- FACULDADES; 54- UNIVERSIDADES; 09- BIBLIOTECAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.08', 'REPRESAS/ACUDES', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 01- ACUDES; 48- REPRESAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.09', 'FAZENDAS, PARQUES E RESERVAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 30- FAZENDAS; 43- PARQUES; 49- RESERVAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.10', 'IMOVEIS DE USO RECREATIVO', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 12- CLUBES; 25- ESTADIOS; 52- TEATROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.11', 'ILHAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 37- ILHAS(ILHOTAS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.12', 'FAROIS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 29- FAROIS (FAROLETES). OS INSTRUMENTOS DE AUXILIO A NAVEGACAO AEREA TAMBEM DEVEM SER REGISTRADOS NESTA CONTA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.13', 'EMBAIXADAS E CONSULADOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 16- CONSULADOS; 20- EMBAIXADAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.14', 'MUSEUS/PALACIOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 40- MUSEUS; 42- PALACIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.15', 'LABORATORIOS/OBSERVATORIOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 38- LABORATORIOS; 41- OBSERVATORIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.16', 'HOSPITAIS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 35- HOSPITAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.17', 'HOTEIS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 36- HOTEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.18', 'PRESIDIOS/DELEGACIAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 46- PRESIDIOS; 18- DELEGACIAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.19', 'PORTOS/ESTALEIROS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 26- ESTALEIROS; 44- PORTOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.20', 'COMPLEXOS/FABRICAS/USINAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 27- FABRICAS; 55- USINAS; 14- COMPLEXOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.21', 'CEMITERIOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 11- CEMITERIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.22', 'ESTACIONAMENTOS E GARAGENS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 24- ESTACIONAMENTOS. TAMBEM DEVEM SER REGISTRADOS NESTA CONTA AS GARAGENS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.23', 'LOJAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 39- LOJAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.24', 'SALAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 51- SALAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.25', 'ALFANDEGAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 04- ALFANDEGAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.26', 'AUTARQUIAS/FUNDACOES', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 07- AUTARQUIAS/FUNDACOES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.27', 'POSTOS DE FISCALIZACAO', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 57-POSTOS POLICIAIS. TAMBEM DEVEM SER REGISTRADOS NESSA CONTA DOS DEMAIS POSTOS DE FISCALIZACAO, TAIS COMO OS DO IBAMA, FUNAI, ETC.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.98', 'OUTROS BENS IMOVEIS REGISTRADOS NO SPIUNET', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU:56- OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.01', 'IMOVEIS RESIDENCIAIS / COMERCIAIS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 05-APARTAMENTOS; 10-CASAS; 50-RESIDENCIAS; 15-CONJUNTOS. OS IMOVEIS FUNCIONAIS, OS PROPRIOS NACIONAIS RESIDENCIAIS (PNR) E AS VILAS MILITARES DEVEM SER REGISTRADOS NESSA CONTA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.02', 'EDIFICIOS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 19- EDIFICIOS/PREDIOS; 17- CONVENTOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.03', 'TERRENOS/GLEBAS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 53- TERRENOS; 34- GLEBAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.04', 'ARMAZENS/GALPOES/SILOS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 06- ARMAZENS; 33- GALPOES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.05', 'AQUARTELAMENTOS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 08- BASES; 47- QUARTEIS; 31- FORTES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.06', 'AEROPORTOS/ESTACOES/AERODROMOS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 02- AERODROMO; 03- AEROPORTO; 23- ESTACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.07', 'IMOVEIS DE USO EDUCACIONAL', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 22- ESCOLAS; 28- FACULDADES; 54- UNIVERSIDADES; 09- BIBLIOTECAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.08', 'REPRESAS/ACUDES', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 01- ACUDES; 48- REPRESAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.09', 'FAZENDAS, PARQUES E RESERVAS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 30- FAZENDAS; 43- PARQUES; 49- RESERVAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.10', 'IMOVEIS DE USO RECREATIVO', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 12- CLUBES; 25- ESTADIOS; 52- TEATROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.11', 'ILHAS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 37- ILHAS(ILHOTAS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.12', 'FAROIS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 29- FAROIS (FAROLETES). OS INSTRUMENTOS DE AUXILIO A NAVEGACAO AEREA TAMBEM DEVEM SER REGISTRADOS NESTA CONTA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.13', 'EMBAIXADAS E CONSULADOS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 16- CONSULADOS; 20- EMBAIXADAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.14', 'MUSEUS/PALACIOS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 40- MUSEUS; 42- PALACIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.15', 'LABORATORIOS/OBSERVATORIOS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 38- LABORATORIOS; 41- OBSERVATORIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.16', 'HOSPITAIS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 35- HOSPITAIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.17', 'HOTEIS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 36- HOTEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.18', 'PRESIDIOS/DELEGACIAS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 46- PRESIDIOS; 18- DELEGACIAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.19', 'PORTOS/ESTALEIROS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 26- ESTALEIROS; 44- PORTOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.20', 'COMPLEXOS/FABRICAS/USINAS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 27- FABRICAS; 55- USINAS; 14- COMPLEXOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.21', 'CEMITERIOS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 11- CEMITERIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.22', 'ESTACIONAMENTOS E GARAGENS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 24- ESTACIONAMENTOS. TAMBEM DEVEM SER REGISTRADOS NESTA CONTA AS GARAGENS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.23', 'LOJAS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 39- LOJAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.24', 'SALAS E ESCRITORIOS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 51- SALAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.25', 'ALFANDEGAS', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 04- ALFANDEGAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.26', 'POSTOS DE FISCALIZACAO', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 57-POSTOS POLICIAIS. TAMBEM DEVEM SER REGISTRADOS NESSA CONTA DOS DEMAIS POSTOS DE FISCALIZACAO, TAIS COMO OS DO IBAMA, FUNAI, ETC.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.27', 'ARMAZENS ESTRUTURAIS - COBERTURAS DE LONA', 'REGISTRA OS VALORES RELATIVOS AOS IMOVEIS PARA USO ESPECIFICO DE DEPOSITOS DE MERCADORIAS, MUNICOES OU ESTABELECIMENTOS COMERCIAIS E INDUSTRIAIS DE COBERTURA DE LONA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.28', 'AUTARQUIAS/FUNDACOES', 'REGISTRA OS VALORES DOS IMOVEIS DA UNIAO QUE NAO SAO CONTABILIZADOS NO SISTEMA DE PATRIMONIO DA UNIAO - SPIU, CORRESPONDENTES AOS CODIGOS DA TABELA SPIU: - AUTARQUIAS/FUNDACOES', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.98', 'OUTROS BENS IMOVEIS NAO REGISTRADOS NO SPIUNET', 'REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 56- OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.03.00', 'BENS DOMINICAIS REGISTRADOS NO SIAPA', 'COMPREENDE OS BENS QUE CONSTITUEM O PATRIMONIO DAS PESSOAS JURIDICAS DE DIREITO PUBLICO, COMO OBJETO DE DIREITO PESSOAL, OU REAL, DE CADA UMA DESSAS ENTIDADES REGISTRADOS NO SIAPA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.01', 'EDIFICIOS', 'REGISTRA OS VALORES RELATIVOS AOS IMOVEIS DE USO ESPECIAL DA UNIAO QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILIARIO DA UNIAO (SPIUNET) CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 19- EDIFICIOS/PREDIOS; 17- CONVENTOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.02', 'APARTAMENTOS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: APARTAMENTOS (CORRESPONDENTE AO CODIGO 05 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.03', 'ARMAZENS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: ARMAZENS (CORRESPONDENTE AO CODIGO 06 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.04', 'CASAS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: CASAS (CORRESPONDENTE AO CODIGO 10 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.05', 'CEMITERIOS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: CEMITERIOS (CORRESPONDENTE AO CODIGO 11 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.06', 'EDIFICIOS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: EDIFICIOS (CORRESPONDENTE AO CODIGO 19 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.07', 'GARAGENS E ESTACIONAMENTOS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAISDA UNIAO NAO-REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGO-RIA: GARAGENS E ESTACIONAMENTOS (CORRESPONDENTE AO CODIGO 24 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.08', 'FAZENDAS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAISDA UNIAO NAO-REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGO-RIA: FAZENDAS (CORRESPONDENTE AO CODIGO 30 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.09', 'GALPOES', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: GALPOES (CORRESPONDENTE AO CODIGO 33 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.10', 'GLEBAS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: GLEBAS (CORRESPONDENTE AO CODIGO 34 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.11', 'LOJAS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: LOJAS (CORRESPONDENTE AO CODIGO 39 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.12', 'SALAS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: SALAS (CORRESPONDENTE AO CODIGO 51 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.13', 'TERRENOS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: TERRENOS (CORRESPONDENTE AO CODIGO 53 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.14', 'LOTES', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: LOTES (CORRESPONDENTE AO CODIGO 57 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.15', 'LOTES INDUSTRIAIS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: LOTES INDUSTRIAIS (CORRESPONDENTE AO CODIGO 58 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.16', 'GLEBAS URBANAS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: GLEBAS URBANAS (CORRESPONDENTE AO CODIGO 59 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.17', 'GLEBAS URBANIZADAS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: GLEBAS URBANIZADAS (CORRESPONDENTE AO CODIGO 60 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.18', 'GLEBAS RURAIS', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: GLEBAS RURAIS (CORRESPONDENTE AO CODIGO 60 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.19', 'IMOV.REGISTRADOS CEDIDOS AOS ASSENTADOS - CCU', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO-REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: - BENS IMOVEIS DESTINADOS A REFORMA AGRARIA CEDIDOS AOS ASSENTADOS POR CONTRATO DE CONCESSAO DE USO. NESTE CASO, OS IMOVEIS JA FORAM REGISTRADOS EM CARTORIO EM NOME DO INCRA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.20', 'IMOV.REGIST.CEDIDOS AOS ASSENTADOS - CCDRU', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO-REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: - BENS IMOVEIS DESTINADOS A REFORMA AGRARIA CEDIDOS AOS ASSENTADOS POR CONTRATO DE CONCESSAO DE DIREITO REAL DE USO. NESTE CASO, OS IMOVEIS JA FORAM REGISTRADOS EM CARTORIO EM NOME DO INCRA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.21', 'IMOVEIS A REGISTRAR DESTINADOS A REFORMA AGRARIA', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO-REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: - BENS IMOVEIS A REGISTRAR DESTINADOS A REFORMA AGRARIA. NESTE CASO, OS IMOVEIS AINDA NAO FORAM REPASSADOS AOS ASSENTADOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.22', 'IMOVEIS A REGISTRAR CEDIDOS AOS ASSENTADOS - CCU', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO-REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: - BENS IMOVEIS A REGISTRAR DESTINADOS À REFORMA AGRARIA E QUE JA FORAM REPASSADOS AOS ASSENTADOS POR MEIO DE CONTRATO DE CONCESSAO DE USO. O REGISTRO SERA REALIZADO EM CARTORIO, EM NOME DO INCRA, APOS DECISAO JUDICIAL TRANSITADA EM JULGADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.23', 'IMOVEIS A REGISTRAR CEDIDOS AOS ASSENTADOS - CCDRU', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO-REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: - BENS IMOVEIS A REGISTRAR DESTINADOS A REFORMA AGRARIA E QUE JA FORAM REPASSADOS AOS ASSENTADOS POR MEIO DE CONTRATO DE CONCESSAO DE DIREITO REAL DE USO. O REGISTRO SERA REALIZADO EM CARTORIO, EM NOME DO INCRA, APOS DECISAO JUDICIAL TRANSITADA EM JULGADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.24', 'IMOVEIS REGISTRADOS DESTINADOS A REFOR.AGRARIA', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: - BENS IMOVEIS DESTINADOS A REFORMA AGRARIA. O REGISTRO DO IMOVEL JA FOI REALIZADO EM CARTORIO, EM NOME DO INCRA. NAO EXISTE MAIS PENDENCIA JUDICIAL ONDE SE DISCUTE O VALOR DO IMOVEL DESAPROPRIADO. NESTE CASO, O IMOVEL AINDA NAO FOI REPASSADO AOS ASSENTADOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.99', 'OUTROS BENS DOMINICAIS NAO REGISTRADOS NO SIAPA', 'REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIDAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: OUTROS (CORRESPONDENTE AO CODIGO 56 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.01', 'RUAS', 'REGISTRA OS VALORES DE RUAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PUBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.02', 'PRACAS', 'REGISTRA OS VALORES DE PRACAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PUBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.03', 'ESTRADAS', 'REGISTRA OS VALORES DE ESTRADAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PUBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.04', 'PONTES', 'REGISTRA OS VALORES DE PONTES QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PUBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.05', 'VIADUTOS', 'REGISTRA OS VALORES DE VIADUTOS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PUBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.99', 'OUTROS BENS DE USO COMUM DO POVO', 'REGISTRA OS VALORES BENS DE USO COMUM, NAO CLASSIFICADOS ANTERIORMENTE NESTE PLANO DE CONTAS, QUE FORAM ADQUIRIDOS, PRODUZIDOS OU CONSTRUIDOS UTILIZANDO-SE RECURSOS PUBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.06.01', 'OBRAS EM ANDAMENTO', 'REGISTRA OS VALORES PERTINENTES A OBRAS, DESDE SUA CONSTRUCAO ATE O TERMINO DA MESMA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.06.02', 'OBRAS EM ANDAMENTO - REGIME DE EXECUCAO ESPECIAL', 'REGISTRA O VALOR TOTAL DE OBRAS EM ANDAMENTO EM REGIME DE EXECUCAO ESPECIAL', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.06.03', 'OBRAS EM ANDAMENTO - CONVENIOS', 'REGISTRA O VALOR TOTAL DE OBRAS EM ANDAMENTO VINCULADAS EXCLUSIVAMENTE A CONVENIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.06.04', 'ADIANTAMENTOS PARA INVERSOES EM BENS IMOVEIS', 'REGISTRA OS ADIANTAMENTOS A FORNECEDORES POR ENCOMENDAS DE BENS IMOVEIS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.06.05', 'ESTUDOS E PROJETOS', 'REGISTRA OS VALORES RELATIVOS A ESTUDOS E PROJETOS, ENGLOBANDO LIMPEZA DO TERRENO, SERVICOS TOPOGRAFICOS, SONDAGENS DE RECONHECIMENTO, TERRAPLENAGEM, DRENAGENS, INSTALACOES PROVISORIAS COMO GALPOES, INSTALACOES ELETRICAS E HIDRAULICAS, UTILIZADAS DURANTE AS OBRAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.06.06', 'ALMOXARIFADO DE INVERSOES FIXAS', 'REGISTRA TODOS OS MATERIAIS E BENS DA EMPRESA DESTINADOS A APLICACAO NA CONSTRUCAO DE BENS IMOVEIS EM ANDAMENTO. COMO, POR EXEMPLO, ALMOXARIFADO DE MATERIAS DE CONSTRUCAO PARA APLICAR EM UMA OBRA EM ANDAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.07.00', 'INSTALACOES', 'REGISTRA EQUIPAMENTOS, MATERIAIS E CUSTO DE IMPLANTACAO DE INSTALACOES QUE, NAO OBSTANTE INTEGRADAS AOS EDIFICIOS, DEVEM SER SEGREGADAS DAS OBRAS CIVIS, COMO, POR EXEMPLO, AS INSTALACOES ELETRICAS, HIDRAULICAS, SANITARIAS, DE VAPOR, DE AR COMPRIMIDO, FRIGORIFICAS, CONTRA INCENDIO, DE COMUNICACOES, DE CLIMATIZACAO, PARA COMBUSTIVEIS, GASES, DE ANTIPOLUICAO, PARA COZINHA, DENTRE OUTROS. E TAMBEM APLICAVEL A CONSTRUCAO DE TRECHOS FERROVIARIOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.08.00', 'BENFEITORIAS EM PROPRIEDADE DE TERCEIROS', 'REGISTRA CONSTRUCOES EM TERRENOS ARRENDADOS DE TERCERIOS E INSTALACOES E OUTRAS BENFEITORIAS EM PREDIOS ALUGADOS. SAO CONSIDERADOS SOMENTE OS GASTOS COM CONSTRUCAO E INSTALACAO QUE SE INCORPORAM AO IMOVEL E REVERTEM AO PROPRIETARIO DO IMOVEL AO FINAL DA LOCACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.01', 'BENS IMOVEIS LOCADOS PARA TERCEIROS', 'REGISTRA OS BENS IMOVEIS LOCADOS PARA TERCEIROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.02', 'IMOVEIS EM PODER DE TERCEIROS', 'REGISTRA OS IMOVEIS CONCEDIDOS A TERCEIROS A TITULO DE EMPRESTIMO GRATUITO COM PRAZO DE DEVOLUCAO CONVENCIONADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.03', 'MATERIAIS TEMPORARIAMENTE SEPARADOS DE IMOVEIS', 'REGISTRA OS MATERIAIS PROVISORIAMENTE SEPARADOS DE UM IMOVEL, PARA NELE SE REEMPREGAREM.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.04', 'IMOVEIS - REGIME DE EXECUCAO ESPECIAL', 'REGISTRA O VALOR TOTAL DE IMOVEIS EM REGIME DE EXECUCAO EXPECIAL, ESTANDO A SUA REALIZACAO SUBORDINADA A APROVACAO DE PLANO DE APLICACAO QUE DISCRIMINE A DESPESA REALIZADA NOS TERMOS DA PORTARIA SOF NRO. 04, DE 21/02/90.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.05', 'BENS IMOVEIS A CLASSIFICAR', 'REGISTRA OS BENS IMOVEIS, CUJA CLASSIFCACAO ESTA PENDENTE POR ALGUM MOTIVO, GERALMENTE POR FALTA DE IDENTIFICACAO OU PENDENCIA DE LEGALIZACAO OU REGISTRO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.06', 'BENS IMOVEIS A ALIENAR', 'REGISTRA OS VALORES RELATIVOS AOS BENS IMOVEIS SEPARADOS PARA ALIENACAO, QUANDO CONSIDERADOS DESNECESSARIOS, INSERVIVEIS OU POR DECISAO ADMINISTRATIVA DA UNIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.99', 'OUTROS BENS IMOVEIS', 'REGISTRA OS VALORES RELATIVOS A OUTROS BENS IOVEIS, PARA OS QUAIS NAO TENHAM SIDO CRIADAS CONTAS PROPRIAS OU ESPECIFICAS NESTE PLANO DE CONTAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.01.00', '(-) DEPRECIACAO ACUMULADA - BENS MOVEIS', 'REGISTRA A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO, BENS MOVEIS, DEVIDO A DESGASTE PELO USO, ACAO DA NATUREZA OU OBSOLESCENCIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.02.00', '(-) DEPRECIACAO ACUMULADA-BENS IMOVEIS', 'REGISTRA A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO, BENS IMOVEIS, DEVIDO A DESGASTE PELO USO, ACAO DA NATUREZA OU OBSOLESCENCIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.03.00', '(-) EXAUSTAO ACUMULADA-BENS MOVEIS', 'REGISTRA A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO, BENS MOVEIS, DEVIDO A PERDA DO VALOR, DECORRENTE DE SUA EXPLORACAO, DE DIREITOS CUJO OBJETO SEJAM RECURSOS MINERAIS OU FLORESTAIS OU BENS APLICADOS NESSA EXPLORACAO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.04.00', '(-) EXAUSTAO ACUMULADA-BENS IMOVEIS', 'REGISTRA A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO, BENS IMOVEIS, DEVIDO A PERDA DO VALOR, DECORRENTE DE SUA EXPLORACAO, DE DIREITOS CUJO OBJETO SEJAM RECURSOS MINERAIS OU FLORESTAIS OU BENS APLICADOS NESSA EXPLORACAO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.05.00', '(-) AMORTIZACAO ACUMULADA-BENS MOVEIS', 'REGISTRA A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO, BENS MOVEIS, DEVIDO A PERDA DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.06.00', '(-) AMORTIZACAO ACUMULADA-BENS IMOVEIS', 'REGISTRA A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO, BENS IMOVEIS, DEVIDO A PERDA DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.01.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE IMOBILIZADO - BENS MOVEIS', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE BENS MOVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. CONTA DE USO EXCLUSIVO DAS EMPRESAS ESTATAIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.02.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE IMOBILIZADO - BENS IMOVEIS', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE BENS IMOVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. CONTA DE USO EXCLUSIVO DAS EMPRESAS ESTATAIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.1.1.00.00', 'SOFTWARES-CONSOLIDACAO', 'REGISTRA OS VALORES DOS SOFTWARES PERTENCENTES A ENTIDADE E NAO INTEGRANTES A UM HARDWARE, ENGLOBANDO OS VALORES REFERENTES A SUA CONSTRUCAO, IMPLEMENTACAO E INSTALACAO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.1.01.00', 'MARCAS E PATENTES INDUSTRIAIS', 'REGISTRA OS VALORES RELATIVOS A BENS INTANGIVEIS, ENGLOBANDO OS GASTOS COM REGISTRO DE MARCA, NOME, INVENCOES PROPRIAS, ALEM DE DESEMBOLSOS A TERCEIROS POR CONTRATOS DE USO DE MARCAS, PATENTES OU PROCESSOS DE FABRICACAO (TECNOLOGIA).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.1.02.00', 'CONCESSAO DE DIREITO DE USO DE COMUNICACAO', 'REGISTRA OS VALORES RELATIVOS A BENS INTANGIVEIS REPRESENTADO PELA CONCESSAO DE DIREITO DE USO DE COMUNICACAO E DIVULGACAO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.1.03.00', 'DIREITOS AUTORAIS', 'REGISTRA OS VALORES RELATIVOS AOS DIREITOS AUTORAIS ADQUIRIDOS PELA ENTIDADE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.1.04.00', 'DIREITOS SOBRE RECURSOS NATURAIS', 'REGISTRA OS VALORES RELATIVOS AOS DIREITOS OBTIDOS POR LEGISLACAO E/OU POR COMPRAS DE DIREITOS DE RESERVAS OU DE EXPLORACAO DE RECURSOS NATURAIS, TAIS COMO JAZIDAS E OUTROS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.1.05.00', 'ADIANTAMENTOS P/TRANSFERENCIA DE TECNOLOGIA', 'REGISTRA TODOS OS ADIANTAMENTOS A FORNECEDORES VINCULADOS A UM CONTRATO DE TRANSFERENCIA DE TECNOLOGIA. REPRESENTAM PAGAMENTOS POR CONTA DE UM VALOR PREVIAMENTE CONTRATADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.1.99.00', 'OUTROS DIREITOS - BENS INTANGIVEIS', 'REGISTRA OS VALORES RELATIVOS A OUTROS DIREITOS, CLASSIFICADOS COMO BENS INTANGIVEIS, CUJA CLASSIFICACAO NAO ESTEJA DEFINIDA EM CONTAS ESPECIFICAS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.3.1.00.00', 'DIREITO DE USO DE IMOVEIS-CONSOLIDACAO', 'REGISTRA OS VALORES PERTINENTES A BENS INTANGIVEIS REPRESENTADOS PELA AQUISICAO DE DIREITO DE USO DE IMOVEIS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.8.1.01.00', '(-) AMORTIZACAO ACUMULADA - SOFTWARES', 'REGISTRA A DIMINUICAO DO VALOR DO CAPITAL APLICADO EM SOFTWARES, PERTENCENTES AO ATIVO INTANGIVEL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.8.1.02.00', '(-) AMORTIZACAO ACUMULADA - MARCAS, DIREITOS E PATENTES', 'REGISTRA A DIMINUICAO DO VALOR DO CAPITAL APLICADO EM MARCAS, DIREITOS E PATENTES, PERTENCENTES AO ATIVO INTANGIVEL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.8.1.03.00', '(-) AMORTIZACAO ACUMULADA - DIREITO DE USO DE IMOVEIS', 'REGISTRA A DIMINUICAO DO VALOR DO CAPITAL APLICADO EM DIREITO DE USO DE IMOVEIS, PERTENCENTES AO ATIVO INTANGIVEL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.9.1.01.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INTANGIVEL - SOFTWARES', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO SOFTWARE PERTENCENTE AO ATIVO INTANGIVEL, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. CONTA DE USO EXCLUSIVO DAS EMPRESAS ESTATAIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.9.1.02.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INTANGIVEL - MARCAS, DIREITOS E PATENTES', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DAS MARCAS, DIREITOS E PATENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. CONTA DE USO EXCLUSIVO DAS EMPRESAS ESTATAIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.9.1.03.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INTANGIVEL -DIREITO DE USO', 'REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DIREITO DE USO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. CONTA DE USO EXCLUSIVO DAS EMPRESAS ESTATAIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.01.01', 'SALARIOS, REMUNERACOES E BENEFICIOS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS AO EXERCICIO ATUAL.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.01.02', 'DECIMO TERCEIRO SALARIO', 'REGISTRA AS OBRIGACOES REFERENTES AO DECIMO TERCEIRO SALARIO, GERALMENTE APROPRIADAS NA BASE DE 1/12 DO VALOR BRUTO DA FOLHA DE PAGAMENTO DA UNIDADE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.01.03', 'FERIAS', 'REGISTRA AS OBRIGACOES REFERENTES A FERIAS, GERALMENTE APROPRIADAS COMO PERCENTUAIS DA FOLHA DE PAGAMENTO DA UNIDADE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.01.04', 'LICENCA- PREMIO', 'REGISTRA OS VALORES DAS OBRIGACOES CONSTITUIDAS COM BASE EM PERCENTUAIS DE SALARIOS, DESTINADOS AO PAGAMENTO DE LICENCA-PREMIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.01.05', 'PARTICIPACOES A EMPREGADOS', 'REGISTRA OS VALORES DAS OBRIGACOES DO EXERCICIO CONSTITUIDAS PARA PAGAMENTO DE PARTICIPACOES A EMPREGADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.02.01', 'SALARIOS, REMUNERACOES E BENEFICIOS DE EXERCICIOS ANTERIORES', 'REGISTRA AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.02.02', 'PARTICIPACOES A EMPREGADOS - EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES DAS OBRIGACOES DE EXERCICIOS ANTERIORES CONSTITUIDAS PARA PAGAMENTO DE PARTICIPACOES A EMPREGADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.03.01', 'PRECATORIOS DE PESSOAL DO EXERCICIO', 'REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.03.02', 'PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000', 'REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.03.03', 'PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000', 'REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.2.00.00', 'PESSOAL A PAGAR - INTRA OFSS', 'REGISTRA AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR REQUISITADO TENHA DIREITO, PARA POSTERIOR REPASSE A UNIDADE CEDENTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.4.00.00', 'PESSOAL A PAGAR - INTER OFSS - ESTADO', 'REGISTRA AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR REQUISITADO TENHA DIREITO, PARA POSTERIOR REPASSE A UNIDADE CEDENTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.5.00.00', 'PESSOAL A PAGAR - INTER OFSS - MUNICIPIO', 'REGISTRA AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR REQUISITADO TENHA DIREITO, PARA POSTERIOR REPASSE A UNIDADE CEDENTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.1.01.00', 'BENEFICIOS PREVIDENCIARIOS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.1.02.00', 'BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES', 'REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.1.03.01', 'PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, DO EXERCICIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.1.03.02', 'PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.1.03.03', 'PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.2.00.00', 'BENEFICIOS PREVIDENCIARIOS A PAGAR-INTRA OFSS', 'REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA REQUISITADO TENHA DIREITO, PARA POSTERIOR REPASSE A UNIDADE CEDENTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.4.00.00', 'BENEFICIOS PREVIDENCIARIOS A PAGAR - INTER OFSS - ESTADO', 'REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA REQUISITADO TENHA DIREITO, PARA POSTERIOR REPASSE A UNIDADE CEDENTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.4.04.00', 'PRECATORIOS ENCAMINHADOS - JUSTICA ESTADUAL', 'COMPREENDE AS OBRIGACOES DECORRENTES DE PRECATORIOS DEVIDOS PELO INSS,ORIUNDOS DAS SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO DE COMPETENCIA DA JUSTICA COMUM ESTADUAL, MAS QUE AINDA NAO FORAM EFETIVAMENTE PAGOS AO BENEFICIARIO DO PRECATORIO PELO PODER JUDICIARIO ESTADUAL. BASE LEGAL: CONSTITUICAO FEDERAL DE 1988 (ART.109, § 3º)', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.3.1.01.00', 'BENEFICIOS ASSISTENCIAIS A PAGAR DO EXERCICIO', 'REGISTRA AS OBRIGACOES RELATIVAS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL LIQUIDADOS NO EXERCICIO E AINDA NAO PAGOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.3.1.02.00', 'BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES RELATIVOS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.01.01', 'INSS - CONTRIBUICAO SOBRE SALARIOS E REMUNERACOES', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.01.02', 'INSS - DEBITO PARCELADO', 'REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.01.03', 'INSS - CONTRIBUICAO SOBRE SERVICOS DE TERCEIROS OU CONTRIBUINTES AVULSOS', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE SERVICOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.01.04', 'INSS - FPAS', 'REGISTRA OS COMPROMISSOS PERANTE O FUNDO DA PREVIDENCIA E ASSISTENCIA SOCIAL (FPAS).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.02.01', 'ENCARGOS PREVIDENCIARIOS DA UNIAO - DO EXERCICIO', 'REGISTRA OS VALORES DOS ENCARGOS PREVIDENCIARIOS DA UNIAO, INCORRIDOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.02.02', 'ENCARGOS PREVIDENCIARIOS DA UNIAO - DE EXERCICIO ANTERIOR', 'REGISTRA OS VALORES DOS ENCARGOS PREVIDENCIARIOS DA UNIAO, INCORRIDOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.03.00', 'PSSS - CONTRIBUICAO SOBRE VENCIMENTOS E VANTAGENS', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, CONFORME ARTS. 3 E 4 DA LEI Nº. 8.688 DE 21/07/93.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.04.01', 'CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS) DO ENTE', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.04.02', 'CONTRIBUICAO AO RPPS - PESSOAL REQUISITADO DE OUTROS ENTES', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.05.00', 'PREVIDENCIA SOCIAL RURAL', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DA PREVIDENCIA SOCIAL RURAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.06.00', 'FGTS', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.07.00', 'SALARIO - EDUCACAO', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DO SALARIO - EDUCACAO, COM BASE NO MONTANTE DA FOLHA DE PAGAMENTO DE SALARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.08.01', 'CONTRIBUICAO A ENTIDADES DE PREVIDENCIA PRIVADA E ASSISTENCIA MEDICO-ODONTOLOGICA', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA E DE ASSISTENCIA MEDICO - ODONTOLOGICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.08.02', 'ENTIDADES DE PREVIDENCIA COMPLEMENTAR', 'REGISTRA AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA COMPLEMENTAR.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.08.04', 'DEFICIT JUNTO A ENTIDADES DE PREVIDENCIA FECHADAS', 'REGISTRA OS VALORES RELATIVOS AO DEFICIT JUNTO A ENTIDADES DE PREVIDENCIA FECHADA POR PARTE DA PATROCINADORA PARA SANEAMENTO ATE O TERMINO DO EXERCICIO SEGUINTE, EM ATENDIMENTO A EMENDA CONSTITUCIONAL Nº 20, DE 15/12/98.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.09.00', 'RECURSOS PREVIDENCIARIOS - GPS A EMITIR', 'REGISTRA O VALOR DOS CREDITOS PREVIDENCIARIOS RECEBIDOS PELAS REPARTICOES PUBLICAS PARA POSTERIOR RECOLHIMENTO AO INSS, ATRAVES DE GPS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.10.00', 'RECURSOS DO SALARIO EDUCACAO', 'REGISTRA O VALOR DOS CREDITOS DE SALARIO - EDUCACAO, REALIZADOS POR GE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.11.00', 'RECURSOS DA GFIP', 'REGISTRA O VALOR DOS CREDITOS DA GUIA DE RECOLHIMENTO DO FGTS - GFIP.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.12.00', 'ENCARGOS SOCIAIS - CONVENIO DE ARRECADACAO DIRETA', 'REGISTRA OS VALORES A SEREM RECOLHIDOS A OUTRAS ENTIDADES, EM FUNCAODE DISPOSIIVOS LEGAIS COM AS QUAIS A UNIDADE MANTENHA CONVENIO DE AR-RECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER,SEBRAE, SENAT, SESCOOP, SESC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.98.00', 'OUTROS ENCARGOS SOCIAIS', 'REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.01.01', 'INSS - CONTRIBUICAO SOBRE SALARIOS E REMUNERACOES', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.01.02', 'INSS - DEBITO PARCELADO', 'REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.01.03', 'INSS - CONTRIBUICAO SOBRE SERVICOS DE TERCEIROS OU CONTRIBUINTES AVULSOS', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE SERVICOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.01.04', 'INSS - FPAS', 'REGISTRA OS COMPROMISSOS PERANTE O FUNDO DA PREVIDENCIA E ASSISTENCIA SOCIAL (FPAS).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.02.01', 'ENCARGOS PREVIDENCIARIOS DA UNIAO - DO EXERCICIO', 'REGISTRA OS VALORES DOS ENCARGOS PREVIDENCIARIOS DA UNIAO, INCORRIDOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.02.02', 'ENCARGOS PREVIDENCIARIOS DA UNIAO - DE EXERCICIO ANTERIOR', 'REGISTRA OS VALORES DOS ENCARGOS PREVIDENCIARIOS DA UNIAO, INCORRIDOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.03.00', 'PSSS - CONTRIBUICAO SOBRE VENCIMENTOS E VANTAGENS', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, CONFORME ARTS. 3 E 4 DA LEI Nº. 8.688 DE 21/07/93.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.04.01', 'CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS) DO ENTE', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.04.02', 'CONTRIBUICAO AO RPPS - PESSOAL REQUISITADO DE OUTROS ENTES', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.05.00', 'PREVIDENCIA SOCIAL RURAL', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DA PREVIDENCIA SOCIAL RURAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.06.00', 'FGTS', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.07.00', 'SALARIO - EDUCACAO', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DO SALARIO - EDUCACAO, COM BASE NO MONTANTE DA FOLHA DE PAGAMENTO DE SALARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.08.01', 'CONTRIBUICAO A ENTIDADES DE PREVIDENCIA.PRIVADA E ASSISTENCIA MEDICO-ODONTOLOGICA', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA E DE ASSISTENCIA MEDICO - ODONTOLOGICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.08.02', 'ENTIDADES DE PREVIDENCIA COMPLEMENTAR', 'REGISTRA AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA COMPLEMENTAR.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.08.04', 'DEFICIT JUNTO A ENTIDADES DE PREVIDENCIA FECHADAS', 'REGISTRA OS VALORES RELATIVOS AO DEFICIT JUNTO A ENTIDADES DE PREVIDENCIA FECHADA POR PARTE DA PATROCINADORA PARA SANEAMENTO ATE O TERMINO DO EXERCICIO SEGUINTE, EM ATENDIMENTO A EMENDA CONSTITUCIONAL Nº 20, DE 15/12/98.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.09.00', 'RECURSOS PREVIDENCIARIOS - GPS A EMITIR', 'REGISTRA O VALOR DOS CREDITOS PREVIDENCIARIOS RECEBIDOS PELAS REPARTICOES PUBLICAS PARA POSTERIOR RECOLHIMENTO AO INSS, ATRAVES DE GPS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.10.00', 'RECURSOS DO SALARIO EDUCACAO', 'REGISTRA O VALOR DOS CREDITOS DE SALARIO - EDUCACAO, REALIZADOS POR GE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.11.00', 'RECURSOS DA GFIP', 'REGISTRA O VALOR DOS CREDITOS DA GUIA DE RECOLHIMENTO DO FGTS - GFIP.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.12.00', 'ENCARGOS SOCIAIS - CONVENIO DE ARRECADACAO DIRETA', 'REGISTRA OS VALORES A SEREM RECOLHIDOS A OUTRAS ENTIDADES, EM FUNCAODE DISPOSIIVOS LEGAIS COM AS QUAIS A UNIDADE MANTENHA CONVENIO DE AR-RECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER,SEBRAE, SENAT, SESCOOP, SESC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.98.00', 'OUTROS ENCARGOS SOCIAIS', 'REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.01.01', 'INSS - CONTRIBUICAO SOBRE SALARIOS E REMUNERACOES', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.01.02', 'INSS - DEBITO PARCELADO', 'REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.01.03', 'INSS - CONTRIBUICAO SOBRE SERVICOS DE TERCEIROS OU CONTRIBUINTES AVULSOS', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE SERVICOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.01.04', 'INSS - FPAS', 'REGISTRA OS COMPROMISSOS PERANTE O FUNDO DA PREVIDENCIA E ASSISTENCIA SOCIAL (FPAS).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.02.01', 'ENCARGOS PREVIDENCIARIOS DA UNIAO - DO EXERCICIO', 'REGISTRA OS VALORES DOS ENCARGOS PREVIDENCIARIOS DA UNIAO, INCORRIDOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.02.02', 'ENCARGOS PREVIDENCIARIOS DA UNIAO - DE EXERCICIO ANTERIOR', 'REGISTRA OS VALORES DOS ENCARGOS PREVIDENCIARIOS DA UNIAO, INCORRIDOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.03.00', 'PSSS - CONTRIBUICAO SOBRE VENCIMENTOS E VANTAGENS', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, CONFORME ARTS. 3 E 4 DA LEI Nº. 8.688 DE 21/07/93.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.04.01', 'CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS) DO ENTE', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.04.02', 'CONTRIBUICAO AO RPPS - PESSOAL REQUISITADO DE OUTROS ENTES', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.05.00', 'PREVIDENCIA SOCIAL RURAL', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DA PREVIDENCIA SOCIAL RURAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.06.00', 'FGTS', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.07.00', 'SALARIO - EDUCACAO', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DO SALARIO - EDUCACAO, COM BASE NO MONTANTE DA FOLHA DE PAGAMENTO DE SALARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.08.01', 'CONTRIBUICAO A ENTIDADES DE PREVIDENCIA.PRIVADA E ASSISTENCIA MEDICO-ODONTOLOGICA', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA E DE ASSISTENCIA MEDICO - ODONTOLOGICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.08.02', 'ENTIDADES DE PREVIDENCIA COMPLEMENTAR', 'REGISTRA AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA COMPLEMENTAR.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.08.04', 'DEFICIT JUNTO A ENTIDADES DE PREVIDENCIA FECHADAS', 'REGISTRA OS VALORES RELATIVOS AO DEFICIT JUNTO A ENTIDADES DE PREVIDENCIA FECHADA POR PARTE DA PATROCINADORA PARA SANEAMENTO ATE O TERMINO DO EXERCICIO SEGUINTE, EM ATENDIMENTO A EMENDA CONSTITUCIONAL Nº 20, DE 15/12/98.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.09.00', 'RECURSOS PREVIDENCIARIOS - GPS A EMITIR', 'REGISTRA O VALOR DOS CREDITOS PREVIDENCIARIOS RECEBIDOS PELAS REPARTICOES PUBLICAS PARA POSTERIOR RECOLHIMENTO AO INSS, ATRAVES DE GPS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.10.00', 'RECURSOS DO SALARIO EDUCACAO', 'REGISTRA O VALOR DOS CREDITOS DE SALARIO - EDUCACAO, REALIZADOS POR GE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.11.00', 'RECURSOS DA GFIP', 'REGISTRA O VALOR DOS CREDITOS DA GUIA DE RECOLHIMENTO DO FGTS - GFIP.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.12.00', 'ENCARGOS SOCIAIS - CONVENIO DE ARRECADACAO DIRETA', 'REGISTRA OS VALORES A SEREM RECOLHIDOS A OUTRAS ENTIDADES, EM FUNCAODE DISPOSIIVOS LEGAIS COM AS QUAIS A UNIDADE MANTENHA CONVENIO DE AR-RECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER,SEBRAE, SENAT, SESCOOP, SESC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.98.00', 'OUTROS ENCARGOS SOCIAIS', 'REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.01.01', 'INSS - CONTRIBUICAO SOBRE SALARIOS E REMUNERACOES', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.01.02', 'INSS - DEBITO PARCELADO', 'REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.01.03', 'INSS - CONTRIBUICAO SOBRE SERVICOS DE TERCEIROS OU CONTRIBUINTES AVULSOS', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE SERVICOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.01.04', 'INSS - FPAS', 'REGISTRA OS COMPROMISSOS PERANTE O FUNDO DA PREVIDENCIA E ASSISTENCIA SOCIAL (FPAS).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.02.01', 'ENCARGOS PREVIDENCIARIOS DA UNIAO - DO EXERCICIO', 'REGISTRA OS VALORES DOS ENCARGOS PREVIDENCIARIOS DA UNIAO, INCORRIDOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.02.02', 'ENCARGOS PREVIDENCIARIOS DA UNIAO - DE EXERCICIO ANTERIOR', 'REGISTRA OS VALORES DOS ENCARGOS PREVIDENCIARIOS DA UNIAO, INCORRIDOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.03.00', 'PSSS - CONTRIBUICAO SOBRE VENCIMENTOS E VANTAGENS', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, CONFORME ARTS. 3 E 4 DA LEI Nº. 8.688 DE 21/07/93.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.04.01', 'CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS) DO ENTE', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.04.02', 'CONTRIBUICAO AO RPPS - PESSOAL REQUISITADO DE OUTROS ENTES', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.05.00', 'PREVIDENCIA SOCIAL RURAL', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DA PREVIDENCIA SOCIAL RURAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.06.00', 'FGTS', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.07.00', 'SALARIO - EDUCACAO', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DO SALARIO - EDUCACAO, COM BASE NO MONTANTE DA FOLHA DE PAGAMENTO DE SALARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.08.01', 'CONTRIBUICAO A ENTIDADES DE PREVIDENCIA.PRIVADA E ASSISTENCIA MEDICO-ODONTOLOGICA', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA E DE ASSISTENCIA MEDICO - ODONTOLOGICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.08.02', 'ENTIDADES DE PREVIDENCIA COMPLEMENTAR', 'REGISTRA AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA COMPLEMENTAR.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.08.04', 'DEFICIT JUNTO A ENTIDADES DE PREVIDENCIA FECHADAS', 'REGISTRA OS VALORES RELATIVOS AO DEFICIT JUNTO A ENTIDADES DE PREVIDENCIA FECHADA POR PARTE DA PATROCINADORA PARA SANEAMENTO ATE O TERMINO DO EXERCICIO SEGUINTE, EM ATENDIMENTO A EMENDA CONSTITUCIONAL Nº 20, DE 15/12/98.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.09.00', 'RECURSOS PREVIDENCIARIOS - GPS A EMITIR', 'REGISTRA O VALOR DOS CREDITOS PREVIDENCIARIOS RECEBIDOS PELAS REPARTICOES PUBLICAS PARA POSTERIOR RECOLHIMENTO AO INSS, ATRAVES DE GPS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.10.00', 'RECURSOS DO SALARIO EDUCACAO', 'REGISTRA O VALOR DOS CREDITOS DE SALARIO - EDUCACAO, REALIZADOS POR GE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.11.00', 'RECURSOS DA GFIP', 'REGISTRA O VALOR DOS CREDITOS DA GUIA DE RECOLHIMENTO DO FGTS - GFIP.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.12.00', 'ENCARGOS SOCIAIS - CONVENIO DE ARRECADACAO DIRETA', 'REGISTRA OS VALORES A SEREM RECOLHIDOS A OUTRAS ENTIDADES, EM FUNCAODE DISPOSIIVOS LEGAIS COM AS QUAIS A UNIDADE MANTENHA CONVENIO DE AR-RECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER,SEBRAE, SENAT, SESCOOP, SESC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.98.00', 'OUTROS ENCARGOS SOCIAIS', 'REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.01.01', 'CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.01.02', 'CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.01.03', 'CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.02.01', 'DIVIDA MOBILIARIA', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA EMISSAO DE TITULOS DA DIVIDA MOBILIARIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.02.02', 'TITULOS DA DIVIDA AGRARIA (TDA)', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS DA DIVIDA AGRARIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.02.03', '(-) DESAGIO DE TITULOS', 'REGISTRA OS VALORES RELATIVOS A DESAGIO OCORRIDOS EM TITULOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.02.04', '(-) TITULOS A APROPRIAR - RECEBIMENTO DE DIVIDENDOS', 'REGISTRA OS VALORES A SEREM DEDUZIDOS DA DIVIDA DE TITULOS, CUJOS VALORES FORAM RECEBIDOS QUANDO DO PAGAMENTO DE DIVIDENDOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.02.05', 'TITULOS INTERNOS RESGATADOS E RECOMPRADOS (PRINC.,JUROS E ENCARGOS)', 'REGISTRA OS VALORES DOS TITULOS INTERNOS RESGATADOS E RECOMPRADOS, INCLUINDO PRINCIPAL, JUROS E ENCARGOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.02.98', 'OUTROS TITULOS - EMPRESTIMOS INTERNOS', 'REGISTRA OS VALORES DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.03.01', 'CREDITOS SECURITIZADOS DO EXERCICIO', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DO EXERCICIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.03.02', 'CREDITOS SECURITIZADOS DO EXERCICIO ANTERIOR', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.03.03', 'CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.03.04', 'CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.03.05', 'CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.03.06', 'CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO ANTERIOR', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.03.07', 'ANTECIPACAO DE RECEITA ORCAMENTARIA', 'REGISTRA OS VALORES REFERENTES A OPERACOES DE CREDITO POR ANTECIPACAO DE RECEITA DESTINADA A ATENDER INSUFICIENCIA DE CAIXA DURANTE O EXERCICIO FINANCEIRO, DEVENDO CUMPRIR AS EXIGENCIAS MENCIONADAS NO ART. 32 DA LEI COMPLEMENTAR Nº 101, PUBLICADA EM 04/05/2000 E AQUELAS PREVISTAS NO ART. 38 DA REFERIDA LEI.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.03.98', 'OUTROS CONTRATOS - EMPRESTIMOS INTERNOS', 'REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS, PARA AS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.04.01', 'OPERACOES COMPROMISSADAS INTERNAS - BACEN', 'REGISTRA OS VALORES DAS OPERACOES COMPROMISSADAS INTERNAS DO BACEN.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.05.01', 'MOEDAS A ENTREGAR P/ LIQUID. OPER. CONTRATADAS', 'REGISTRA OS VALORES DE OPERACOES COM MOEDA A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.05.02', 'TITULOS A ENTREGAR P/ LIQUID. OPER. CONTRATADAS', 'REGISTRA OS VALORES DE OPERACOES COM TITULOS A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.05.03', 'OURO A ENTREGAR P/ LIQUID. OPER. CONTRATADAS', 'REGISTRA OS VALORES DE OPERACOES COM OURO A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.05.04', 'DEPOSIT.A PRAZO EM MOEDA ESTRANG A CONSTITUIR', 'REGISTRA OS VALORES REFERENTES A DEPOSITOS A PRAZO EM MOEDA ESTRANGEIRA A CONSTITUIR, DECORRENTES DE OPERACOES CONTRATADAS DE VENDA DEFINITIVA A LIQUIDAR CONTA ESPECIFICA DO BANCO CENTRAL DO BRASIL', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.06.01', 'DEBITOS DE OPERACOES ESPECIAIS', 'REGISTRA A APROPRIACAO DOS VALORES DAS OPERACOES ESPECIAIS A PAGAR, CONTRAIDAS PELA UNIAO, ENTIDADES E INSTITUICOES, VINCULADAS A CONTRATOS E ACORDOS OU POR AUTORIZACOES LEGAIS, INCLUSIVE OS JUROS E SANCOES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.07.00', 'DEBITOS A TRANSFERIR', 'REGISTRA A APROPRIACAO DE VALORES DECORRENTES DE OPERACOES DE CREDITO EM LIQUIDACAO A SEREM TRANSFERIDOS PARA O ORCAMENTO GERAL DA UNIAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.01.01', 'CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.01.02', 'CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.01.03', 'CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.02.01', 'DIVIDA MOBILIARIA', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA EMISSAO DE TITULOS DA DIVIDA MOBILIARIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.02.02', 'TITULOS DA DIVIDA AGRARIA (TDA)', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS DA DIVIDA AGRARIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.02.03', '(-) DESAGIO DE TITULOS', 'REGISTRA OS VALORES RELATIVOS A DESAGIO OCORRIDOS EM TITULOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.02.04', '(-) TITULOS A APROPRIAR - RECEBIMENTO DE DIVIDENDOS', 'REGISTRA OS VALORES A SEREM DEDUZIDOS DA DIVIDA DE TITULOS, CUJOS VALORES FORAM RECEBIDOS QUANDO DO PAGAMENTO DE DIVIDENDOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.02.05', 'TITULOS INTERNOS RESGATADOS E RECOMPRADOS (PRINC.,JUROS E ENCARGOS)', 'REGISTRA OS VALORES DOS TITULOS INTERNOS RESGATADOS E RECOMPRADOS, INCLUINDO PRINCIPAL, JUROS E ENCARGOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.02.98', 'OUTROS TITULOS - EMPRESTIMOS INTERNOS', 'REGISTRA OS VALORES DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.03.01', 'CREDITOS SECURITIZADOS DO EXERCICIO', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DO EXERCICIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.03.02', 'CREDITOS SECURITIZADOS DO EXERCICIO ANTERIOR', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.03.03', 'CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.03.04', 'CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.03.05', 'CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.03.06', 'CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO ANTERIOR', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.03.07', 'ANTECIPACAO DE RECEITA ORCAMENTARIA', 'REGISTRA OS VALORES REFERENTES A OPERACOES DE CREDITO POR ANTECIPACAO DE RECEITA DESTINADA A ATENDER INSUFICIENCIA DE CAIXA DURANTE O EXERCICIO FINANCEIRO, DEVENDO CUMPRIR AS EXIGENCIAS MENCIONADAS NO ART. 32 DA LEI COMPLEMENTAR Nº 101, PUBLICADA EM 04/05/2000 E AQUELAS PREVISTAS NO ART. 38 DA REFERIDA LEI.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.03.98', 'OUTROS CONTRATOS - EMPRESTIMOS INTERNOS', 'REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS, PARA AS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.04.01', 'OPERACOES COMPROMISSADAS INTERNAS - BACEN', 'REGISTRA OS VALORES DAS OPERACOES COMPROMISSADAS INTERNAS DO BACEN.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.05.01', 'MOEDAS A ENTREGAR P/ LIQUID. OPER. CONTRATADAS', 'REGISTRA OS VALORES DE OPERACOES COM MOEDA A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.05.02', 'TITULOS A ENTREGAR P/ LIQUID. OPER. CONTRATADAS', 'REGISTRA OS VALORES DE OPERACOES COM TITULOS A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.05.03', 'OURO A ENTREGAR P/ LIQUID. OPER. CONTRATADAS', 'REGISTRA OS VALORES DE OPERACOES COM OURO A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.05.04', 'DEPOSIT.A PRAZO EM MOEDA ESTRANG A CONSTITUIR', 'REGISTRA OS VALORES REFERENTES A DEPOSITOS A PRAZO EM MOEDA ESTRANGEIRA A CONSTITUIR, DECORRENTES DE OPERACOES CONTRATADAS DE VENDA DEFINITIVA A LIQUIDAR CONTA ESPECIFICA DO BANCO CENTRAL DO BRASIL', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.06.01', 'DEBITOS DE OPERACOES ESPECIAIS', 'REGISTRA A APROPRIACAO DOS VALORES DAS OPERACOES ESPECIAIS A PAGAR, CONTRAIDAS PELA UNIAO, ENTIDADES E INSTITUICOES, VINCULADAS A CONTRATOS E ACORDOS OU POR AUTORIZACOES LEGAIS, INCLUSIVE OS JUROS E SANCOES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.07.00', 'DEBITOS A TRANSFERIR', 'REGISTRA A APROPRIACAO DE VALORES DECORRENTES DE OPERACOES DE CREDITO EM LIQUIDACAO A SEREM TRANSFERIDOS PARA O ORCAMENTO GERAL DA UNIAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.01.01', 'CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.01.02', 'CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.01.03', 'CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.02.01', 'DIVIDA MOBILIARIA', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA EMISSAO DE TITULOS DA DIVIDA MOBILIARIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.02.02', 'TITULOS DA DIVIDA AGRARIA (TDA)', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS DA DIVIDA AGRARIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.02.03', '(-) DESAGIO DE TITULOS', 'REGISTRA OS VALORES RELATIVOS A DESAGIO OCORRIDOS EM TITULOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.02.04', '(-) TITULOS A APROPRIAR - RECEBIMENTO DE DIVIDENDOS', 'REGISTRA OS VALORES A SEREM DEDUZIDOS DA DIVIDA DE TITULOS, CUJOS VALORES FORAM RECEBIDOS QUANDO DO PAGAMENTO DE DIVIDENDOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.02.05', 'TITULOS INTERNOS RESGATADOS E RECOMPRADOS (PRINC.,JUROS E ENCARGOS)', 'REGISTRA OS VALORES DOS TITULOS INTERNOS RESGATADOS E RECOMPRADOS, INCLUINDO PRINCIPAL, JUROS E ENCARGOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.02.98', 'OUTROS TITULOS - EMPRESTIMOS INTERNOS', 'REGISTRA OS VALORES DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.03.01', 'CREDITOS SECURITIZADOS DO EXERCICIO', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DO EXERCICIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.03.02', 'CREDITOS SECURITIZADOS DO EXERCICIO ANTERIOR', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.03.03', 'CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.03.04', 'CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.03.05', 'CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.03.06', 'CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO ANTERIOR', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.03.07', 'ANTECIPACAO DE RECEITA ORCAMENTARIA', 'REGISTRA OS VALORES REFERENTES A OPERACOES DE CREDITO POR ANTECIPACAO DE RECEITA DESTINADA A ATENDER INSUFICIENCIA DE CAIXA DURANTE O EXERCICIO FINANCEIRO, DEVENDO CUMPRIR AS EXIGENCIAS MENCIONADAS NO ART. 32 DA LEI COMPLEMENTAR Nº 101, PUBLICADA EM 04/05/2000 E AQUELAS PREVISTAS NO ART. 38 DA REFERIDA LEI.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.03.98', 'OUTROS CONTRATOS - EMPRESTIMOS INTERNOS', 'REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS, PARA AS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.04.01', 'OPERACOES COMPROMISSADAS INTERNAS - BACEN', 'REGISTRA OS VALORES DAS OPERACOES COMPROMISSADAS INTERNAS DO BACEN.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.05.01', 'MOEDAS A ENTREGAR P/ LIQUID. OPER. CONTRATADAS', 'REGISTRA OS VALORES DE OPERACOES COM MOEDA A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.05.02', 'TITULOS A ENTREGAR P/ LIQUID. OPER. CONTRATADAS', 'REGISTRA OS VALORES DE OPERACOES COM TITULOS A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.05.03', 'OURO A ENTREGAR P/ LIQUID. OPER. CONTRATADAS', 'REGISTRA OS VALORES DE OPERACOES COM OURO A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.05.04', 'DEPOSIT.A PRAZO EM MOEDA ESTRANG A CONSTITUIR', 'REGISTRA OS VALORES REFERENTES A DEPOSITOS A PRAZO EM MOEDA ESTRANGEIRA A CONSTITUIR, DECORRENTES DE OPERACOES CONTRATADAS DE VENDA DEFINITIVA A LIQUIDAR CONTA ESPECIFICA DO BANCO CENTRAL DO BRASIL', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.06.01', 'DEBITOS DE OPERACOES ESPECIAIS', 'REGISTRA A APROPRIACAO DOS VALORES DAS OPERACOES ESPECIAIS A PAGAR, CONTRAIDAS PELA UNIAO, ENTIDADES E INSTITUICOES, VINCULADAS A CONTRATOS E ACORDOS OU POR AUTORIZACOES LEGAIS, INCLUSIVE OS JUROS E SANCOES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.07.00', 'DEBITOS A TRANSFERIR', 'REGISTRA A APROPRIACAO DE VALORES DECORRENTES DE OPERACOES DE CREDITO EM LIQUIDACAO A SEREM TRANSFERIDOS PARA O ORCAMENTO GERAL DA UNIAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.01.01', 'CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.01.02', 'CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.01.03', 'CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.02.01', 'BRAZIL INVESTMENT BOND (BIB)', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO NO MERCADO DE BONUS DO GOVERNO BRASILEIRO (BRAZIL INVESTMENT BOND) COM O OBJETIVO DE REDUZIR PARTE DA DIVIDA EXTERNA DO PAIS JUNTO A BANCOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.02.02', 'TITULOS EXTERNOS RESGATADOS ( PRINC.,JUROS E ENCARGOS) E RECOMPRADOS (PRINCIPAL)', 'REGISTRA OS VALORES DO PRINCIPAL, JUROS E ENCARGOS DOS TITULOS EXTERNOS RESGATADOS E DO PRINCIPAL DOS RECOMPRADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.02.03', 'TITULOS EXTERNOS RECOMPRADOS (JUROS E ENCARGOS)', 'REGISTRA OS VALORES DOS JUROS E ENCARGOS DOS TITULOS EXTERNOS RECOMPRADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.02.98', 'OUTROS TITULOS - EMPRESTIMOS EXTERNOS', 'REGISTRA VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO DE TITULOS NO EXTERIOR, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.03.01', 'CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.03.02', 'CONTRATOS DE EMPRESTIMOS EXTERNOS DE EXERCICIO ANTERIOR', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DE EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.03.03', 'CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.03.04', 'CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO ANTERIOR', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.03.98', 'OUTROS CONTRATOS - EMPRESTIMOS EXTERNOS', 'REGISTRA OS VALORES DAS OPERACOES DE CREDITO EXTERNAS EM CONTRATOS, PARA AS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.04.01', 'OPERACOES COMPROMISSADAS EXTERNAS - BACEN', 'REGISTRA OS VALORES DAS OPERACOES COMPROMISSADAS EXTERNAS DO BACEN.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.05.01', 'MOEDAS A ENTREGAR P/ LIQUID. OPER. CONTRATADAS', 'REGISTRA OS VALORES DE OPERACOES COM MOEDA A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.05.02', 'TITULOS A ENTREGAR P/ LIQUID. OPER. CONTRATADAS', 'REGISTRA OS VALORES DE OPERACOES COM TITULOS A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.05.03', 'OURO A ENTREGAR P/ LIQUID. OPER. CONTRATADAS', 'REGISTRA OS VALORES DE OPERACOES COM OURO A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.05.04', 'DEPOSIT.A PRAZO EM MOEDA ESTRANG A CONSTITUIR', 'REGISTRA OS VALORES REFERENTES A DEPOSITOS A PRAZO EM MOEDA ESTRANGEIRA A CONSTITUIR, DECORRENTES DE OPERACOES CONTRATADAS DE VENDA DEFINITIVA A LIQUIDAR CONTA ESPECIFICA DO BANCO CENTRAL DO BRASIL', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.06.01', 'DEBITOS DE OPERACOES ESPECIAIS', 'REGISTRA A APROPRIACAO DOS VALORES DAS OPERACOES ESPECIAIS A PAGAR, CONTRAIDAS PELA UNIAO, ENTIDADES E INSTITUICOES, VINCULADAS A CONTRATOS E ACORDOS OU POR AUTORIZACOES LEGAIS, INCLUSIVE OS JUROS E SANCOES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.07.00', 'DEBITOS A TRANSFERIR', 'REGISTRA A APROPRIACAO DE VALORES DECORRENTES DE OPERACOES DE CREDITO EM LIQUIDACAO A SEREM TRANSFERIDOS PARA O ORCAMENTO GERAL DA UNIAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.01.01', 'CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.01.02', 'CONTRATOS DE FINANCIAMENTOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE FINANCIAMENTOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.01.03', 'CONTRATOS DE FINANCIAMENTOS INTERNOS COM CONTROLE DE AMORTIZACAO DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE FINANCIAMENTOS INTERNOS COM CONTROLE DE AMORTIZACAO, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.02.01', 'FINANCIAMENTOS DO ATIVO PERMANENTE', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.02.02', 'FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS HABITACIONAIS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.02.03', 'FINANCIAMENTO DE CAPITAL DE GIRO', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.02.98', 'OUTROS FINANCIAMENTOS INTERNOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.03.00', 'FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO', 'REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.01.01', 'CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.01.02', 'CONTRATOS DE FINANCIAMENTOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE FINANCIAMENTOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.01.03', 'CONTRATOS DE FINANCIAMENTOS INTERNOS COM CONTROLE DE AMORTIZACAO DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE FINANCIAMENTOS INTERNOS COM CONTROLE DE AMORTIZACAO, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.02.01', 'FINANCIAMENTOS DO ATIVO PERMANENTE', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.02.02', 'FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS HABITACIONAIS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.02.03', 'FINANCIAMENTO DE CAPITAL DE GIRO', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.02.98', 'OUTROS FINANCIAMENTOS INTERNOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.03.00', 'FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO', 'REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.5.01.01', 'CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.5.01.02', 'CONTRATOS DE FINANCIAMENTOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE FINANCIAMENTOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.5.01.03', 'CONTRATOS DE FINANCIAMENTOS INTERNOS COM CONTROLE DE AMORTIZACAO DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE FINANCIAMENTOS INTERNOS COM CONTROLE DE AMORTIZACAO, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.5.02.01', 'FINANCIAMENTOS DO ATIVO PERMANENTE', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.5.02.02', 'FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS HABITACIONAIS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.5.02.03', 'FINANCIAMENTO DE CAPITAL DE GIRO', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.5.02.98', 'OUTROS FINANCIAMENTOS INTERNOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.5.03.00', 'FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO', 'REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.1.01.01', 'CONTRATOS DE FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.1.01.02', 'CONTRATOS DE FINANCIAMENTOS EXTERNOS COM CONTROLE DE AMORTIZACAO DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE FINANCIAMENTOS EXTERNOS COM CONTROLE DE AMORTIZACAO, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.1.02.01', 'FINANCIAMENTOS DO ATIVO PERMANENTE', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.1.02.02', 'FINANCIAMENTOS DE CAPITAL DE GIRO', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.1.02.98', 'OUTROS FINANCIAMENTOS EXTERNOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.1.03.00', 'FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO', 'REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.01.01', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.01.02', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.01.03', 'JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.02.01', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.02.02', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.03.01', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.03.02', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.03.03', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.04.01', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.04.02', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.01.01', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.01.02', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.01.03', 'JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.02.01', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.02.02', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.03.01', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.03.02', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.03.03', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.04.01', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.04.02', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.01.01', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.01.02', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.01.03', 'JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.02.01', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.02.02', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.03.01', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.03.02', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.03.03', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.04.01', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.04.02', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.01.01', 'JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.01.02', 'JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.02.01', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.02.02', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.03.01', 'JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.03.02', 'JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.04.01', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.04.02', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.1.01.00', '(-) ENCARGOS PREFIXADOS DE EMPRESTIMOS INTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRESTIMOS INTERNOS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.1.02.00', '(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS INTERNOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.4.01.00', '(-) ENCARGOS PREFIXADOS DE EMPRESTIMOS INTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRESTIMOS INTERNOS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.4.02.00', '(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS INTERNOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.5.01.00', '(-) ENCARGOS PREFIXADOS DE EMPRESTIMOS INTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRESTIMOS INTERNOS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.5.02.00', '(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS INTERNOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.9.1.01.00', '(-) ENCARGOS PREFIXADOS DE EMPRESTIMOS EXTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRESTIMOS EXTERNOS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.9.1.02.00', '(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS EXTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS EXTERNOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.01.00', 'FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.02.00', 'FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.03.01', 'PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.03.03', 'PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000', 'COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.04.01', 'OBRIGACOES PARA FATURAMENTO - CONTROLE ESCRITURAL', 'REGISTRA OS VALORES DAS OBRIGACOES A PAGAR DECORRENTES DO FATURAMENTO DE BENS E SERVICOS, CONTROLADOS ESCRITURALMENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.06.01', 'PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.06.02', 'PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000', 'COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDDE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.2.01.00', 'FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.2.02.00', 'FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.2.03.01', 'PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.2.03.03', 'PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000', 'COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.2.04.01', 'OBRIGACOES PARA FATURAMENTO - CONTROLE ESCRITURAL', 'REGISTRA OS VALORES DAS OBRIGACOES A PAGAR DECORRENTES DO FATURAMENTO DE BENS E SERVICOS, CONTROLADOS ESCRITURALMENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.2.05.00', 'CONTAS A PAGAR NACIONAIS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.2.06.01', 'PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.2.06.02', 'PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000', 'COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.4.01.00', 'FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.4.02.00', 'FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.4.03.01', 'PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.4.03.03', 'PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000', 'COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.4.04.01', 'OBRIGACOES PARA FATURAMENTO - CONTROLE ESCRITURAL', 'REGISTRA OS VALORES DAS OBRIGACOES A PAGAR DECORRENTES DO FATURAMENTO DE BENS E SERVICOS, CONTROLADOS ESCRITURALMENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.4.05.00', 'CONTAS A PAGAR CREDORES NACIONAIS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.4.06.01', 'PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.4.06.02', 'PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000', 'COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.5.01.00', 'FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.5.02.00', 'FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.5.03.01', 'PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.5.03.03', 'PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000', 'COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.5.04.01', 'OBRIGACOES PARA FATURAMENTO - CONTROLE ESCRITURAL', 'REGISTRA OS VALORES DAS OBRIGACOES A PAGAR DECORRENTES DO FATURAMENTO DE BENS E SERVICOS, CONTROLADOS ESCRITURALMENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.5.05.00', 'CONTAS A PAGAR CREDORES NACIONAIS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.5.06.01', 'PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.5.06.02', 'PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000', 'COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.01.00', 'FORNECEDORES ESTRANGEIROS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.02.00', 'FORNECEDORES ESTRANGEIROS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.03.00', 'CONTAS A PAGAR - CREDORES ESTRANGEIROS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS CREDORES ESTRANGEIROS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES AO EXERCICIO ATUAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.04.00', 'CONTAS A PAGAR - CREDORES ESTRANGEIROS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR AOS CREDORES ESTRANGEIROS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.01.00', 'IPI A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES TRIBUTARIAS A RECOLHER REFERENTES AO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS DAS UNIDADES INDUSTRIAIS OU COM CARACTERISTICAS DESSAS, GERADAS PELAS VENDAS DE PRODUTOS INDUSTRIAIS E SUJEITAS A COMPENSACAO COM OS CREDITOS ADQUIRIDOS POR COMPRAS DE MATERIAS-PRIMAS, EM CONFORMIDADE COM A SISTEMATICA DE APURACAO DESSE IMPOSTO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.02.00', 'IRPJ A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO DE RENDA PESSOA JURIDICA.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.03.00', 'PASSIVO FISCAL DIFERIDO', 'REGISTRA OS VALORES DE DEBITOS FISCAIS DE CURTO PRAZO RELATIVOS A DIFERENCAS INTERTEMPORAIS (DELIBERACAO DA CVM Nº 273, DE 20/08/98),CORRESPONDENTES AO IMPOSTO DE RENDA PESSOA JURIDICA (IRPJ) E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO (CSSL), BEM COMO PIS/PASEP E COFINS (LEI Nº 9.718 DE 27/11/1998).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.04.00', 'II A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES A RECOLHER JUNTO AO GOVERNO FEDERAL, RELATIVAS AO IMPOSTO DE IMPORTACAO II).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.05.00', 'IOF A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO SOBRE OPERACOES FINANCEIRAS (IOF).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.06.00', 'ITR A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADETERRITORIAL RURAL (ITR).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.07.00', 'CPMF A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO PROVISORIA SOBRE MOVIMENTACAO OU TRANSMISSAO DE VALORES E DE CREDITOS DE NATUREZA FINANCEIRA (CPMF).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.08.00', 'CIDE A RECOLHER', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO (CIDE) (LEI Nº 10.168/2000).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.09.00', 'CSSL A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS (CSSL).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.10.00', 'COFINS A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO A RECOLHER RELATIVAS A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL (COFINS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.11.00', 'PIS/PASEP A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO PROGRAMA DE INTEGRACAO SOCIAL (PIS) E PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO ( PASEP).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.12.00', 'TRIBUTOS FEDERAIS RENEGOCIADOS', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS FEDERAIS QUE TENHAM SIDO RENEGOCIADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.13.00', 'RECURSOS FISCAIS - DARF A EMITIR', 'REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELAS REPARTICOES PUBLICAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, OU SEJA, VALORES A SEREM RECOLHIDOS POR MEIO DE DARF. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, POR MEIO DE DOCUMENTO DE ARRECADACAO DE RECEITAS FEDERAIS (DARF).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.99.00', 'OUTROS TRIBUTOS E CONTRIBUICOES FEDERAIS A RECOLHER', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.01.00', 'IPI A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES TRIBUTARIAS A RECOLHER REFERENTES AO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS DAS UNIDADES INDUSTRIAIS OU COM CARACTERISTICAS DESSAS, GERADAS PELAS VENDAS DE PRODUTOS INDUSTRIAIS E SUJEITAS A COMPENSACAO COM OS CREDITOS ADQUIRIDOS POR COMPRAS DE MATERIAS-PRIMAS, EM CONFORMIDADE COM A SISTEMATICA DE APURACAO DESSE IMPOSTO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.02.00', 'IRPJ A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO DE RENDA PESSOA JURIDICA.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.03.00', 'PASSIVO FISCAL DIFERIDO', 'REGISTRA OS VALORES DE DEBITOS FISCAIS DE CURTO PRAZO RELATIVOS A DIFERENCAS INTERTEMPORAIS (DELIBERACAO DA CVM Nº 273, DE 20/08/98),CORRESPONDENTES AO IMPOSTO DE RENDA PESSOA JURIDICA (IRPJ) E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO (CSSL), BEM COMO PIS/PASEP E COFINS (LEI Nº 9.718 DE 27/11/1998).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.04.00', 'IMPOSTO DE IMPORTACAO A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES A RECOLHER JUNTO AO GOVERNO FEDERAL, RELATIVAS AO IMPOSTO DE IMPORTACAO II).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.05.00', 'IOF A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO SOBRE OPERACOES FINANCEIRAS (IOF).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.06.00', 'ITR A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADETERRITORIAL RURAL (ITR).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.07.00', 'CPMF A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO PROVISORIA SOBRE MOVIMENTACAO OU TRANSMISSAO DE VALORES E DE CREDITOS DE NATUREZA FINANCEIRA (CPMF).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.08.00', 'CIDE A RECOLHER', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO (CIDE) (LEI Nº 10.168/2000).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.09.00', 'CSSL A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS (CSSL).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.10.00', 'COFINS A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO A RECOLHER RELATIVAS A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL (COFINS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.11.00', 'PIS/PASEP A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO PROGRAMA DE INTEGRACAO SOCIAL (PIS) E PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO ( PASEP).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.12.00', 'TRIBUTOS FEDERAIS RENEGOCIADOS', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS FEDERAIS QUE TENHAM SIDO RENEGOCIADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.13.00', 'RECURSOS FISCAIS - DARF A EMITIR', 'REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELAS REPARTICOES PUBLICAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, OU SEJA, VALORES A SEREM RECOLHIDOS POR MEIO DE DARF. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, POR MEIO DE DOCUMENTO DE ARRECADACAO DE RECEITAS FEDERAIS (DARF).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.99.00', 'OUTROS TRIBUTOS E CONTRIBUICOES FEDERAIS A RECOLHER', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.01.01', 'ICMS A RECOLHER - SOBRE MERCADORIAS PARA REVENDA', 'REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVICOS (ICMS), SUJEITAS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.01.02', 'ICMS A RECOLHER - SOBRE MERCADORIAS DE TERCEIROS PARA DEPOSITO', 'REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DA ENTRADA DE MERCADORIAS DE TERCEIROS ENTREGUES A UNIDADE PARA DEPOSITO EM ARMAZEM.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.02.00', 'IPVA A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES (IPVA).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.03.00', 'TRIBUTOS ESTADUAIS RENEGOCIADOS', 'REGISTRA OS VALORES DEVIDOS RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.04.00', 'TAXA DE COOPERACAO E DEFESA DA ORIZICULTURA - CDO', 'REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTES A TAXA DE COOPERACAO E DEFESA DA ORIZICULTURA - CDO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.05.00', 'TAXA CONTRA INCENDIO', 'REGISTRA O VALOR DAS OBRIGACOES REFERENTES A TAXA CONTRA INCENDIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.06.00', 'TAXA DE LICENCIAMENTO ANUAL DE VEICULOS', 'REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTE AO PAGAMENTO DA TAXA DE LICENCIAMENTO ANUAL DE VEICULOS, DECORRENTE DO SERVICO DE LICENCIAMENTO DE VEICULOS AUTOMOTORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.07.00', 'RECURSOS FISCAIS ESTADUAIS', 'REGISTRA O VALOR DOS CREDITOS FISCAIS ORIUNDOS DE RECEBIMENTOS DE TRIBUTOS ESTADUAIS CUJO RECOLHIMENTO E REALIZADO POR MEIO DE DAR. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, POR MEIO DE DOCUMENTO DE ARRECADACAO (DAR).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.99.00', 'OUTROS TRIBUTOS E CONTRIBUICOES ESTADUAIS A RECOLHER', 'REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.01.01', 'ICMS A RECOLHER - SOBRE MERCADORIAS PARA REVENDA', 'REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVICOS (ICMS), SUJEITAS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.01.02', 'ICMS A RECOLHER - SOBRE MERCADORIAS DE TERCEIROS PARA DEPOSITO', 'REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DA ENTRADA DE MERCADORIAS DE TERCEIROS ENTREGUES A UNIDADE PARA DEPOSITO EM ARMAZEM.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.02.00', 'IPVA A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES (IPVA).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.03.00', 'TRIBUTOS ESTADUAIS RENEGOCIADOS', 'REGISTRA OS VALORES DEVIDOS RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.04.00', 'TAXA DE COOPERACAO E DEFESA DA ORIZICULTURA - CDO', 'REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTES A TAXA DE COOPERACAO E DEFESA DA ORIZICULTURA (CDO).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.05.00', 'TAXA CONTRA INCENDIO', 'REGISTRA O VALOR DAS OBRIGACOES REFERENTES A TAXA CONTRA INCENDIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.06.00', 'TAXA DE LICENCIAMENTO ANUAL DE VEICULOS', 'REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTE AO PAGAMENTO DA TAXA DE LICENCIAMENTO ANUAL DE VEICULOS, DECORRENTE DO SERVICO DE LICENCIAMENTO DE VEICULOS AUTOMOTORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.07.00', 'RECURSOS FISCAIS ESTADUAIS', 'REGISTRA O VALOR DOS CREDITOS FISCAIS ORIUNDOS DE RECEBIMENTOS DE TRIBUTOS ESTADUAIS CUJO RECOLHIMENTO E REALIZADO POR MEIO DE DAR. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, POR MEIO DE DOCUMENTO DE ARRECADACAO (DAR).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.99.00', 'OUTROS TRIBUTOS E CONTRIBUICOES ESTADUAIS A RECOLHER', 'REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.01.00', 'ISS A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA (ISS) EM QUE A PROPRIA UNIDADE SEJA A PRESTADORA DO SERVICO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.02.00', 'IPTU/TLP A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA (IPTU) E TAXA DE LIMPEZA PUBLICA (TLP).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.03.00', 'TRIBUTOS MUNICIPAIS RENEGOCIADOS', 'REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.04.00', 'CONTRIBUICAO P/ CUSTEIO DE ILUM. PUBLICA A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL REFERENTES A CONTRIBUICAO PARA CUSTEIO DE ILUMINACAO PUBLICA.(ART.149-A DA CONSTITUICAO FEDERAL)', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.06.00', 'RECURSOS FISCAIS MUNICIPAIS', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO MUNICIPAL, POR MEIO DE DOCUMENTO DE ARRECADACAO (DAR).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.99.00', 'OUTROS TRIBUTOS E CONTRIBUICOES MUNICIPAIS A RECOLHER', 'REGISTRA OS COMPROMISSOS EXIGIVEIS, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.01.00', 'ISS A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA (ISS) EM QUE A PROPRIA UNIDADE SEJA A PRESTADORA DO SERVICO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.02.00', 'IPTU/TLP A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA (IPTU) E TAXA DE LIMPEZA PUBLICA (TLP).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.03.00', 'TRIBUTOS MUNICIPAIS RENEGOCIADOS', 'REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.04.00', 'CONTRIBUICAO P/ CUSTEIO DE ILUM. PUBLICA A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL REFERENTES A CONTRIBUICAO PARA CUSTEIO DE ILUMINACAO PUBLICA.(ART.149-A DA CONSTITUICAO FEDERAL)', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.06.00', 'RECURSOS FISCAIS MUNICIPAIS', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO MUNICIPAL, POR MEIO DE DOCUMENTO DE ARRECADACAO (DAR).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.99.00', 'OUTROS TRIBUTOS E CONTRIBUICOES MUNICIPAIS A RECOLHER', 'REGISTRA OS COMPROMISSOS EXIGIVEIS, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.5.0.4.00.00', 'OBRIGACOES DE REPARTICAO A OUTROS ENTES - INTER OFSS - ESTADO', 'REGISTRA OS VALORES ARRECADADOS DE IMPOSTOS E OUTRAS RECEITAS A SEREM REPARTIDOS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.5.0.5.00.00', 'OBRIGACOES DE REPARTICAO A OUTROS ENTES - INTER OFSS - MUNICIPIO', 'REGISTRA OS VALORES ARRECADADOS DE IMPOSTOS E OUTRAS RECEITAS A SEREM REPARTIDOS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.1.1.01.00', 'PROVISAO PARA INDENIZACOES TRABALHISTAS', 'REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE INDENIZACOES TRABALHISTAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.1.1.02.00', 'PROVISAO PARA PAGAMENTO DE DISSIDIOS COLETIVOS', 'REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE DISSIDIOS COLETIVOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.1.01.01', 'PROVISAO PARA PAGAMENTO DE AUTOS DE INFRACAO NAO RECORRIDOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTOS DE INFRACAO JA LAVRADOS, PARA OS QUAIS A UNIDADE AINDA NAO APRESENTOU RECURSO ADMINISTRATIVO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.1.01.02', 'PROVISAO PARA PAGAMENTO DE AUTOS DE INFRACAO RECORRIDOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTOS DE INFRACAO JA LAVRADOS, PARA OS QUAIS A UNIDADE APRESENTOU RECURSO ADMINISTRATIVO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.1.02.01', 'PROVISAO PARA PAGAMENTOS DE AUTUACOES FISCAIS NA ESFERA JUDICIAL NAO RECORRIDAS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTUACOES FISCAIS QUE SE ENCONTRAM NA ESFERA JUDICIAL E QUE NAO ESTAO EM FASE RECURSAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.1.02.02', 'PROVISAO PARA PAGAMENTOS DE AUTUACOES FISCAIS NA ESFERA JUDICIAL RECORRIDAS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTUACOES FISCAIS QUE SE ENCONTRAM NA ESFERA JUDICIAL EM FASE RECURSAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.1.01.00', 'PROVISAO PARA INDENIZACOES CIVEIS', 'REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS PARA O PAGAMENTO DE INDENIZACOES CIVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.1.02.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.1.03.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JA CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.1.04.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS NAO CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NAO CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.2.01.00', 'PROVISAO PARA INDENIZACOES CIVEIS', 'REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS PARA O PAGAMENTO DE INDENIZACOES CIVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.2.02.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.2.03.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JA CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.2.04.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS NAO CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NAO CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.4.01.00', 'PROVISAO PARA INDENIZACOES CIVEIS', 'REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS PARA O PAGAMENTO DE INDENIZACOES CIVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.4.02.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.4.03.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JA CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.4.04.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS NAO CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NAO CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.5.01.00', 'PROVISAO PARA INDENIZACOES CIVEIS', 'REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS PARA O PAGAMENTO DE INDENIZACOES CIVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.5.02.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.5.03.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JA CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.5.04.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS NAO CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NAO CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.5.4.00.00', 'PROVISAO PARA REPARTICAO DE CREDITOS A CURTO PRAZO - INTER OFSS - ESTADO', 'REGISTRA OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CREDITOS TRIBUTARIOS E NAO TRIBUTARIOS RECONHECIDOS NO LANCAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERACAO. NA ARRECADACAO, ESTA PROVISAO SERA REVERTIDA EM CONTA ESPECIFICA DE PASSIVO REFERENTE A OBRIGACOES DE REPARTICAO A OUTROS ENTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.5.5.00.00', 'PROVISAO PARA REPARTICAO DE CREDITOS A CURTO PRAZO - INTER OFSS - MUNICIPIO', 'REGISTRA OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CREDITOS TRIBUTARIOS E NAO TRIBUTARIOS RECONHECIDOS NO LANCAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERACAO. NA ARRECADACAO, ESTA PROVISAO SERA REVERTIDA EM CONTA ESPECIFICA DE PASSIVO REFERENTE A OBRIGACOES DE REPARTICAO A OUTROS ENTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.6.1.00.00', 'PROVISAO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO -CONSOLIDACAO', 'REGISTRA OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUCAO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.1.01.00', 'PROVISAO PARA GARANTIAS', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR DESPESAS COM A PRESTACAO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.1.02.00', 'PROVISAO PARA REESTRUTURACAO', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR OBRIGACOES ORIUNDAS DA VENDA OU EXTINCAO DE UMA LINHA DE NEGOCIOS, FECHAMENTO DE FABRICAS OU LOCAIS DE NEGOCIOS, MUDANCAS NA ESTRUTURA DA ADMINISTRACAO E REORGANIZACOES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERACOES DA ENTIDADE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.1.99.00', 'OUTRAS PROVISOES A CURTO PRAZO', 'REGISTRA OS VALORES DAS PROVISOES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.2.01.00', 'PROVISAO PARA GARANTIAS', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR DESPESAS COM A PRESTACAO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.2.02.00', 'PROVISAO PARA REESTRUTURACAO', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR OBRIGACOES ORIUNDAS DA VENDA OU EXTINCAO DE UMA LINHA DE NEGOCIOS, FECHAMENTO DE FABRICAS OU LOCAIS DE NEGOCIOS, MUDANCAS NA ESTRUTURA DA ADMINISTRACAO E REORGANIZACOES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERACOES DA ENTIDADE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.2.99.00', 'OUTRAS PROVISOES A CURTO PRAZO', 'REGISTRA OS VALORES DAS PROVISOES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.4.01.00', 'PROVISAO PARA GARANTIAS', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR DESPESAS COM A PRESTACAO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.4.02.00', 'PROVISAO PARA REESTRUTURACAO', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR OBRIGACOES ORIUNDAS DA VENDA OU EXTINCAO DE UMA LINHA DE NEGOCIOS, FECHAMENTO DE FABRICAS OU LOCAIS DE NEGOCIOS, MUDANCAS NA ESTRUTURA DA ADMINISTRACAO E REORGANIZACOES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERACOES DA ENTIDADE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.4.99.00', 'OUTRAS PROVISOES A CURTO PRAZO', 'REGISTRA OS VALORES DAS PROVISOES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.5.01.00', 'PROVISAO PARA GARANTIAS', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR DESPESAS COM A PRESTACAO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.5.02.00', 'PROVISAO PARA REESTRUTURACAO', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR OBRIGACOES ORIUNDAS DA VENDA OU EXTINCAO DE UMA LINHA DE NEGOCIOS, FECHAMENTO DE FABRICAS OU LOCAIS DE NEGOCIOS, MUDANCAS NA ESTRUTURA DA ADMINISTRACAO E REORGANIZACOES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERACOES DA ENTIDADE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.5.99.00', 'OUTRAS PROVISOES A CURTO PRAZO', 'REGISTRA OS VALORES DAS PROVISOES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.1.1.00.00', 'ADIANTAMENTOS DE CLIENTES-CONSOLIDACAO', 'COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.1.2.00.00', 'ADIANTAMENTOS DE CLIENTES-INTRA OFSS', 'COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.1.4.00.00', 'ADIANTAMENTOS DE CLIENTES - INTER OFSS - ESTADO', 'COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.1.5.00.00', 'ADIANTAMENTOS DE CLIENTES - INTER OFSS - MUNICIPIO', 'COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.2.1.00.00', 'OBRIGACOES POR DANOS A TERCEIROS - CONSOLIDACAO', 'COMPREENDE OS VALORES EXIGIVEIS NO CURTO PRAZO, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.2.2.00.00', 'OBRIGACOES POR DANOS A TERCEIROS - INTRA OFSS', 'COMPREENDE OS VALORES EXIGIVEIS NO CURTO PRAZO, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.2.4.00.00', 'OBRIGACOES POR DANOS A TERCEIROS - INTER OFSS - ESTADO', 'COMPREENDE OS VALORES EXIGIVEIS NO CURTO PRAZO, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.2.5.00.00', 'OBRIGACOES POR DANOS A TERCEIROS - INTER OFSS - MUNICIPIO', 'COMPREENDE OS VALORES EXIGIVEIS NO CURTO PRAZO, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.3.1.00.00', 'ARRENDAMENTO OPERACIONAL A PAGAR-CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES A CURTO PRAZO REFERENTES A ARRENDAMENTOS MERCANTIS, NOS QUAIS NAO SAO TRANSFERIDOS AO ARRENDADOR OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, NAO HAVENDO A POSSIBILIDADE DE OPCAO DE COMPRA DO BEM ARRENDADO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.3.2.00.00', 'ARRENDAMENTO OPERACIONAL A PAGAR-INTRA OFSS', 'COMPREENDE AS OBRIGACOES A CURTO PRAZO REFERENTES A ARRENDAMENTOS MERCANTIS, NOS QUAIS NAO SAO TRANSFERIDOS AO ARRENDADOR OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, NAO HAVENDO A POSSIBILIDADE DE OPCAO DE COMPRA DO BEM ARRENDADO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.3.4.00.00', 'ARRENDAMENTO OPERACIONAL A PAGAR- INTER OFSS - ESTADO', 'COMPREENDE AS OBRIGACOES A CURTO PRAZO REFERENTES A ARRENDAMENTOS MERCANTIS, NOS QUAIS NAO SAO TRANSFERIDOS AO ARRENDADOR OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, NAO HAVENDO A POSSIBILIDADE DE OPCAO DE COMPRA DO BEM ARRENDADO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.3.5.00.00', 'ARRENDAMENTO OPERACIONAL A PAGAR- INTER OFSS - MUNICIPIO', 'COMPREENDE AS OBRIGACOES A CURTO PRAZO REFERENTES A ARRENDAMENTOS MERCANTIS, NOS QUAIS NAO SAO TRANSFERIDOS AO ARRENDADOR OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, NAO HAVENDO A POSSIBILIDADE DE OPCAO DE COMPRA DO BEM ARRENDADO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.1.01.00', 'DEBENTURES CONVERSIVEIS EM ACOES NO CURTO PRAZO', 'REGISTRA OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO E QUE SAO CONVERSIVEIS EM ACOES, COM VENCIMENTO NO CURTO PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.1.02.00', 'DEBENTURES NAO-CONVERSIVEIS EM ACOES NO CURTO PRAZO', 'REGISTRA OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO E QUE NAO SAO CONVERSIVEIS EM ACOES, COM VENCIMENTO NO CURTO PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.1.96.00', 'AGIO NA EMISSAO DE DEBENTURES', 'REGISTRA OS VALORES DE AGIO NA EMISSAO DE DEBENTURES, QUE SAO OS VALORES RECEBIDOS QUE SUPERA O DE RESGATE DESSES TITULOS NA DATA DO PROPRIO RECEBIMENTO OU DO VALOR FORMALMENTE ATRIBUIDO AS DEBENTURES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.1.97.00', '(-) DESAGIO NA EMISSAO DE DEBENTURES', 'REGISTRA OS VALORES DE DESAGIO NA EMISSAO DE DEBENTURES, QUE SAO OS VALORES RECEBIDOS INFERIORES AO VALOR DE RESGATE DESSES TITULOS NA DATA DO PROPRIO RECEBIMENTO OU DO VALOR FORMALMENTE ATRIBUIDO AS DEBENTURES.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.1.98.00', '(-) CUSTO DA TRANSACAO A AMORTIZAR', 'REGISTRA OS CUSTOS DA TRANSACAO A AMORTIZAR, QUE SAO APENAS OS CUSTOS INCORRIDOS E DIRETAMENTE ATRIBUIVEIS AS ATIVIDADES NECESSARIAS EXCLUSIVAMENTE A CONSECUCAO DA TRANSACAO. POR EXEMPLO: TAXAS E COMISSOES. ENTRETANTO, NAO INCLUEM DESPESAS FINANCEIRAS, CUSTOS INTERNOS ADMINISTRATIVOS OU CUSTO DE CARREGAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.1.99.00', 'OUTROS TITULOS', 'REGISTRA OUTROS TITULOS DE DIVIDA COM VENCIMENTO NO CURTO PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.1.01.00', 'DIVIDENDOS A PAGAR - TESOURO NACIONAL', 'REGISTRA OS VALORES A SEREM PAGOS AO TESOURO NACIONAL A TITULO DE DIVIDENDOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.1.02.00', 'DIVIDENDOS A PAGAR - TERCEIROS', 'REGISTRA OS VALORES A SEREM PAGOS A TERCEIROS A TITULO DE DIVIDENDOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.2.01.00', 'DIVIDENDOS A PAGAR - TESOURO NACIONAL', 'REGISTRA OS VALORES A SEREM PAGOS AO TESOURO NACIONAL A TITULO DE DIVIDENDOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.2.02.00', 'DIVIDENDOS A PAGAR - TERCEIROS', 'REGISTRA OS VALORES A SEREM PAGOS A TERCEIROS A TITULO DE DIVIDENDOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.4.01.00', 'DIVIDENDOS A PAGAR - TESOURO NACIONAL', 'REGISTRA OS VALORES A SEREM PAGOS AO TESOURO NACIONAL A TITULO DE DIVIDENDOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.4.02.00', 'DIVIDENDOS A PAGAR - TERCEIROS', 'REGISTRA OS VALORES A SEREM PAGOS A TERCEIROS A TITULO DE DIVIDENDOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.5.01.00', 'DIVIDENDOS A PAGAR - TESOURO NACIONAL', 'REGISTRA OS VALORES A SEREM PAGOS AO TESOURO NACIONAL A TITULO DE DIVIDENDOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.5.02.00', 'DIVIDENDOS A PAGAR - TERCEIROS', 'REGISTRA OS VALORES A SEREM PAGOS A TERCEIROS A TITULO DE DIVIDENDOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.01', 'PSSS - VENCIMENTOS E VANTAGENS', 'REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE SERVIDORES REGIDOS PELA LEI Nº 8.112/90 A TITULO DE SEGURIDADE SOCIAL A SER RECOLHIDO AO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.02', 'INSS', 'REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE EMPREGADOS REGIDOS PELA CONSOLIDACAO DAS LEIS DO TRABALHO (CLT) OU DE SERVICOS DE TERCEIROS, A SER RECOLHIDO AO INSTITUTO NACIONAL DO SEGURO SOCIAL/PREVIDENCIA SOCIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.03', 'ENCARGOS SOCIAIS - OUTRAS ENTIDADES', 'REGISTRA O VALOR A SER RECOLHIDO A OUTRAS ENTIDADES, EM FUNCAO DE DISPOSITIVOS LEGAIS COM AS QUAIS A ENTIDADE MANTENHA CONVENIO DE ARRECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER, SEBRAE, SENAT, SESCOOP, SESC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.04', 'IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF DEVIDO AO TESOURO NACIONAL', 'REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DO IMPOSTO SOBRE A RENDA, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS OU CREDITADAS A SERVIDORES OU EMPREGADOS, SOBRE AS QUAIS INCIDA O REFERIDO IMPOSTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.05', 'INDENIZACOES E RESTITUICOES DEVIDAS AO TESOURO NACIONAL', 'REGISTRA OS VALORES RELATIVOS AS INDENIZACOES E RESTITUICOES DE TRIBUTOS COM AUTORIZACOES CONCEDIDAS, POREM NAO DEVOLVIDAS AOS LEGITIMOS CREDORES PELA ENTIDADE. REGISTRA OS VALORES A SEREM RECOLHIDOS AO TESOURO NACIONAL, A TITULO DE INDENIZACOES E RESTITUICOES DE TRIBUTOS, PROVENIENTES DE DESCONTO EM FOLHA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.06', 'IMPOSTOS E CONTRIBUICOES DIVERSOS DEVIDOS AO TESOURO NACIONAL', 'REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DE IMPOSTOS E CONTRIBUICOES DIVERSOS, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS, SOBRE OS QUAIS INCIDAM OS REFERIDOS TRIBUTOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.07', 'OUTROS TRIBUTOS DO TESOURO NACIONAL', 'REGISTRA OS VALORES RELATIVOS A OUTROS TRIBUTOS DO TESOURO NACIONAL RETIDOS PELA ENTIDADE SOBRE VALORES PAGOS OU CREDITADOS E QUE, SOBRE OS QUAIS, INCIDA O REFERIDO TRIBUTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.08', 'ICMS', 'REGISTRA OS VALORES RELATIVOS AO IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E SERVICOS RETIDOS POR FOCA DE LEGISLACAO OU POR ACORDO ENTRE AS PARTES ENVOLVIDAS NA TRANSACAO EM CONSIGNACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.09', 'ISS', 'REGISTRA OS VALORES DO IMPOSTO SOBRE SERVICOS RETIDOS EM CONSIGNACOES POR FORCA DE LEGISLACAO, CIRCUNSTANCIAS OU ACORDO ENTRE AS PARTES ENVOLVIDOS NA TRANSACAO, EM SITUACOES QUE A ENTIDADE COMO PARTE CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTARIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.11', 'IRRF/GDF', 'REGISTRA OS VALORES DO IMPOSTO DE RENDA RETIDO EM CONSIGNACOES POR FORCA DE LEGISLACAO/CONVENIOS, A SEREM REPASSADOS AO GOVERNO DO DISTRITO FEDERAL (GDF)', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.12', 'PSSS/GDF', 'REGISTRA OS VALORES DO PSSS EM CONSIGNACOES POR FORCA DE LEGISLACAO/CONVENIOS, A SEREM REPASSADOS AO GOVERNO DO DISTRITO FEDERAL (GDF).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.13', 'OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS', 'REGISTRA OS VALORES EM CONSIGNACAO RELATIVOS A OUTROS TRIBUTOS A SEREM REPASSADOS AOS ESTADOS E MUNICIPIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.14', 'PENSAO ALIMENTICIA', 'REGISTRA OS VALORES DAS RETENCOES EM FOLHA PROCEDIDAS EM PAGAMENTOS A EMPREGADOS OU A SERVIDORES, AUTORIZADOS POR ESSES OU POR DETERMINACAO JUDICIAL, A TITULO DE PENSAO ALIMENTICIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.15', 'PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA', 'REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DO PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES DE PREVIDENCIA E ASSISTENCIA MEDICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.16', 'ASSISTENCIA A SAUDE - ADMINISTRACAO PROPRIA', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, QUE SERAO ADMINISTRADOS PELO PROPRIO ORGAO/ENTIDADE PARA ASSISTENCIA A SAUDE DE SEUS SERVIDORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.17', 'RETENCOES - ENTIDADES REPRESENTATIVAS DE CLASSES', 'REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DE PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES REPRESENTATIVAS DE CLASSE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.18', 'RETENCOES - SINDICATOS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS AOS RESPECTIVOS SINDICATOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.19', 'RETENCOES - ASSOCIACOES', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS A ASSOCIACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.20', 'RETENCOES - COOPERATIVAS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS A COOPERATIVAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.21', 'RETENCOES - PLANOS DE SEGUROS', 'REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES AS CONTRIBUICOES A PLANOS DE SEGURO DE VIDA EM GRUPO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.22', 'RETENCOES - EMPRESTIMOS E FINANCIAMENTOS', 'REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR TERCEIROS, BEM COMO RETENCOES DE PARCELAS DE CONSORCIOS E SEGURADOS DO INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.23', 'RETENCAO A LOCADORES DE IMOVEIS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS E OU PAGAMENTOS A LOCADORES DE IMOVEIS A TITULO DE UTILIZACAO DE IMOVEIS FUNCIONAIS RESIDENCIAIS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.24', 'RETENCAO RELATIVA A VALE TRANSPORTE', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM RE-PASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO DE VALE-TRANSPORTE. TRATA-SE DOS VALORES REFERENTES AOS 6% INSTITUIDOS PELO ARTIGO 9º DO DECRETO Nº 95.247/1987 E SUAS ALTERACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.25', 'RETENCAO RELATIVA A VALE ALIMENTACAO', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO DE CARTAO-ALIMENTACAO/REFEICAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.26', 'SERVICOS DE PROCESSAMENTO DE DADOS', 'REGISTRA O VALOR TOTAL DA ARRECADACAO DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VALORES DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.99', 'OUTROS CONSIGNATARIOS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, EM CONFIANCA, POR DIVERSOS CONTRIBUINTES SUJEITOS A RECOLHIMENTOS E OU PAGAMENTOS AOS FAVORECIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.02.00', 'GARANTIAS', 'COMPREENDE A GARANTIA DO CUMPRIMENTO DE UMA OBRIGACAO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENCOES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.03.01', 'DEPOSITOS A EFETUAR POR DETERMINACAO JUDICIAL', 'REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS A EFETUAR PELA ENTIDADE POR DETERMINACAO JUDICIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.03.02', 'DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL', 'REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS RECEBIDOS PELA ENTIDADE POR DETERMINACAO JUDICIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.03.03', 'DEPOSITOS A EFETUAR PARA RECURSOS JUDICIAIS', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS A EFETUAR PELA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.03.04', 'DEPOSITOS RECEBIDOS PARA RECURSOS JUDICIAIS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS RECEBIDOS PELA ENTIDADE RELATIVOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.01', 'DEPOSITOS E CAUCOES A EFETUAR', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS REFERENTES A DEPOSITOS E/OU CAUCOES A EFETUAR PELA ENTIDADE VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.02', 'DEPOSITOS E CAUCOES RECEBIDOS', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS E/OU CAUCOES PELA ENTIDADE VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.03', 'DEPOSITOS A EFETUAR PARA RECURSOS ADMINISTRATIVOS', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS A EFETUAR PELA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO ADMINISTRATIVO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.04', 'DEPOSITOS RECEBIDOS PARA RECURSOS ADMINISTRATIVOS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS RECEBIDOS PELA ENTIDADE RELATIVOS AO EXERCICIO DE DIREITO DE RECURSO ADMINISTRATIVO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.05', 'DEPOSITOS ESPECIAIS', 'REGISTRA O VALOR RELATIVO A RETENCOES DE DEPOSITOS VINCULADOS A RESTITUIR NO CURSO DO EXERCICIO SEGUINTE A ENTIDADE TRANSFERIDORA, DECORRENTE DE CONTRATOS OU INSTRUMENTOS CONGENERES, CONVENCAO, ACORDO OU AJUSTE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.06', 'DEPOSITOS RETIDOS DE FORNECEDORES', 'REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE FORNECEDORES EM FUNCAO DE APLICACAO DE MULTAS E OUTRAS DETERMINACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.07', 'DEPOSITOS DE VEICULOS ALIENAVEIS', 'REGISTRA O VALOR DOS RECEBIMENTOS PROVENIENTES DA ALIENACAO DE VEICULOS REMOVIDOS, RECOLHIDOS OU APREENDIDOS DE ACORDO COM A RESOLUCAO DO CONTRAN Nº 178/2005, PENDENTES DE TRANSFERENCIAS DIVERSAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.08', 'DEPOSITOS A TRANSFERIR', 'REGISTRA OS VALORES DAS RETENCOES DE DEPOSITOS DE DIVERSAS ORIGENS RECEBIDOS POR UG CENTRAL CUJA DEVOLUCAO DEVE SER REALIZADA NO CURSO DO EXERCICIO SEGUINTE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.09', 'DEPOSITOS DE TERCEIROS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TERCEIROS DE DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NAO RECLAMADOS PELOS CREDORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.10', 'DEPOSITOS A DISTRIBUIR', 'REGISTRA OS DEPOSITOS DECORRENTES DA FITA 50, RELACIONADOS COM A FONTE 0150025074 QUE E DESTINADA 80% PARA O CODIGO 07401 E 20% PARA O CODIGO 07402 (DESVINCULACAO DE RRECEITAS DA UNIAO - DRU) E AINDA AS APROPRIACOES REFERENTES A DEVOLUCAO DO PSSS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.11', 'DEPOSITOS DE ENTIDADES', 'REGISTRA O VALOR DAS CONTRIBUICOES COM ENTIDADES TERCEIRAS TAIS COMO: SESI, SENAI, SESC, ETC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.12', 'DEPOSITOS DE RENDIMENTOS DO PIS/PASEP', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RENDIMENTOS DO PIS/PASEP PARA CREDITO EM FOLHA DE PAGAMENTO AOS SERVIDORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.13', 'DEPOSITOS DO ITR E CONTRIBUICOES RURAIS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL (ITR) E OUTRAS CONTRIBUICOES RURAIS PARA DISTRIBUICAO AOS BENEFICIARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.14', 'CONTRIBUICOES RURAIS A DISTRIBUIR', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES RURAIS CLASSIFICADAS E AINDA NAO DISTRIBUIDAS AOS BENEFICIARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.15', 'DEPOSITOS A DISTRIBUIR DO SALARIO-EDUCACAO', 'REGISTRA OS DEPOSITOS DECORRENTES DA ARRECADACAO DO SALARIO-EDUCACAO, PROVENIENTES DO DOCUMENTO GUIA DO SALARIO-EDUCACAO (GSE).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.16', 'DEPOSITOS DO FAT - PMC', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AO PROGRAMA PARA MELHORIA DA COMPETITIVIDADE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.17', 'DEPOSITOS DO FAT PRO-INOVACAO', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AO PROGRAMA PRO-INOVACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.18', 'DEPOSITOS PARA IMPORTACOES - PESQUISA CIENTIFICA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE ENTIDADES SEM FINS LUCRATIVOS ATIVAS NO FOMENTO, NA COORDENACAO OU NA EXECUCAO DE PROGRAMAS DE PESQUISA CIENTIFICA E TECNOLOGICA OU DE ENSINO, PARA A REALIZACAO DE IMPORTACOES DE BENS DESTINADOS A PESQUISA CIENTIFICA E TECNOLOGICA. BASE LEGAL: LEI Nº 8.010/1990.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.19', 'DEPOSITOS ISS A DISTRIBUIR - DAR SUBSTITUICAO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DO IMPOSTO SOBRE SERVICOS (ISS) - RECOLHIDOS POR DAR SUBSTITUICAO - A DISTRIBUIR PARA OS MUNICIPIOS PARTICIPANTES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.20', 'DEPOSITOS DAS RETENCOES DE IMPOSTOS DO SIMPLES PELOS ORGAOS PUBLICOS', 'REGISTRA OS VALORES A CLASSIFICAR RELATIVOS AOS DEPOSITOS DE IMPOSTOS E CONTRIBUICOES PELO SISTEMA SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.21', 'DEPOSITO DE IMPOSTOS DO SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTOS E CONTRIBUICOES PELO SISTEMA SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.22', 'PROGRAMA DE RECUPERACAO FISCAL - REFIS', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DO SEGURO SOCIAL (INSS).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.23', 'CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA ARRECADACAO DA CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO REGISTRADA PELA FITA 50 DA SECRETARIA DA RECEITA FEDERAL DO BRASIL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.24', 'DEPOSITOS DE RETENCOES DE CONTRIBUICOES SOBRE PAGAMENTO A PESSOA JURIDICA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RETENCOES DE CONTRIBUICOES SOBRE PAGAMENTOS DE PESSOA JURIDICA A PESSOA JURIDICA DE DIREITO PRIVADO (CSLL, COFINS, PIS/PASEP),Lei nº 10.833/2003', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.25', 'DEPOSITOS DO REGIME ESPECIAL TRIBUTARIO DO PATRIMONIO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO REGIME ESPECIAL DE TRIBUTACAO DO PATRIMONIO DE AFETACAO DE INCORPORACOES IMOBILIARIAS , INSTITUIDO PELA LEI Nº 10.931/2004.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.26', 'DEPOSITOS DE RETENCOES DE CONTRIBUICOES S/PAGAMENTO DE ESTADOS/DF/MUNICIPIOS A PESSOAS JURIDICAS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AS RETENCOES DE CONTRIBUICOES (CSLL, COFINS, PIS/PASEP) SOBRE PAGAMENTOS A PESSOA JURIDICA DE DIREITO PRIVADO PELOS ESTADOS OU MUNICIPIOS, DE ACORDO COM ART. 31 E 33 DA LEI Nº 10.833/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.27', 'PARCELAMENTO ESPECIAL PAES', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DO SEGURO SOCIAL (INSS), INSTITUIDO PELA LEI Nº 10.684/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.28', 'PARCELAMENTO MP Nº 303/2006 - PAEX', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DE SEGURIDADE SOCIAL - INSS, CONFORME MEDIDA PROVISORIA Nº Nº 303/2006.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.29', 'PARCELAMENTO PARA INGRESSO NO SIMPLES NACIONAL', 'REGISTRA O VALOR DOS RECURSOS DE PARCELAMENTO DE DEBITOS COM O INSS OU COM AS FAZENDAS PUBLICAS FEDERAL, ESTADUAL OU MUNICIPAL PARA INGRESSO NO PROGRAMA SIMPLES NACIONAL, CONFORME LEI COMPLEMENTAR Nº 123/2006 - ART. 79.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.30', 'PARCELAMENTO TIMEMANIA', 'REGISTRA O VALOR DAS RECEITAS ARRECADADAS DECORRENTES DA RENEGOCIACAO DE DIVIDAS DE ENTIDADES DESPORTIVAS JUNTO A PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), CONFORME LEI Nº 11.345/2006, ALTERADA PELA LEI Nº 11.505/2007.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.31', 'PARCELAMENTO FIES - LEI Nº 10.260/2001', 'REGISTRA O VALOR DAS RECEITAS ARRECADADAS DECORRENTES DE PARCELAMENTO DE TRIBUTOS ADMINISTRADOS PELA RECEITA FEDERAL DO BRASIL - RFB TENDO COMO SUJEITO PASSIVO AS PESSOAS JURIDICAS DE DIREITO PRIVADO MANTENEDORAS DE INSTITUICOES DE ENSINO SUPERIOR QUE POSSUEM OS CERTIFICADOS DE EMISSAO DO TESOURO NACIONAL E OPTARAM PELO PARCELAMENTO, DESDE QUE TODAS AS INSTITUICOES MANTIDAS TENHAM ADERIDO AO PROGRAMA UNIVERSIDADE PARA TODOS (PROUNI). BASE LEGAL: LEI 10.260/2001, ART. 10, §§ 3º E 5º (REDACAO DADA PELA LEI 11.552/2007).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.32', 'PARCELAMENTO MP Nº 449/2008', 'REGISTRA O VALOR DOS RECURSOS DECORRENTE DE PARCELAMENTO DE DIVIDAS DE PEQUENO VALOR COM A FAZENDA NACIONAL E DIVIDAS DECORRENTES DE APROVEITAMENTO INDEVIDO DE CREDITOS DE IPI, CONFORME DISPOE A A MEDIDA PROVISORIA Nº 449, DE 03 DE DEZEMBRO DE 2008 LEI Nº 11.941/2009', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.33', 'PARCELAMENTO DE ARREMATACAO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TRIBUTOS A CLASSIFICAR PROVENIENTES DO PARCELAMENTO DE VALOR CORRESPONDENTE A ARREMATACAO DE BEM EM HASTA PUBLICA NAS EXECUCOES FISCAIS PROMOVIDAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN) (PORTARIA 262 DE 11/06/2002).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.34', 'PARCELAMENTO - DEMAIS DEBITOS - LEI Nº 11.941/2009', 'REGISTRA OS VALORES RELATIVOS AOS PARCELAMENTOS DE QUE TRATA A LEI Nº 11.941/2009, EXCETO OS DECORRENTES DE DEBITOS PREVIDENCIARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.35', 'DEPOSITOS DE ICMS A DISTRIBUIR A ESTADOS', 'REGISTRA OS VALORES A DISTRIBUIR AOS ESTADOS RELATIVOS AOS DEPOSITOS DE ICMS IMPOSTO PELO SISTEMA SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.36', 'DEPOSITOS DE ISS A DISTRIBUIR A MUNICIPIOS', 'REGISTRA OS VALORES A DISTRIBUIR AOS MUNICIPIOS RELATIVOS AOS DEPOSITOS DE ISS IMPOSTO PELO SISTEMA SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.37', 'DEPOSITOS DO IMPOSTO SIMPLES - INSS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTO PELO SISTEMA SIMPLES, RELATIVOS AO INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.38', 'DEPOSITOS REFIS - INSS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PROGRAMA DE RECUPERACAO FISCAL (REFIS) INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.39', 'DEPOSITOS PAES INSS SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) DO INSS SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.40', 'DEPOSITOS PAES ISS SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) DO ISS SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.41', 'DEPOSITOS PAES ICMS SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003)DO ICMS SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.42', 'DEPOSITOS INSS SIMPLES NACIONAL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES A ARRECADACAO DO INSS SIMPLES NACIONAL,CONFORME LEI COMPLEMENTAR Nº 123,DE 14 DE DEZEMBRO DE 2006.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.43', 'INSS - PARCELAMENTO LEI Nº 11.941/2009', 'REGISTRA OS VALORES DECORRENTES DE DEBITOS PREVIDENCIARIOS, RELATIVOS AOS PARCELAMENTOS DE QUE TRATA A LEI Nº 11.941, DE 27 DE MAIO DE 2009.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.44', 'MULTA POR FALTA/ATRASO/ERRO/OMISSAO - GFIP', 'REGISTRA OS VALORES RELATIVOS A MULTA POR ERRO, OMISSAO, FALTA OU ATRASO NA ENTREGA DA DECLARACAO GFIP DE QUE TRATA O ART. 32A DA LEI Nº 8.212, DE 24 DE JULHO DE 1991.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.45', 'DEPOSITOS PAES PARCELAMENTO DE ARREMATACAO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) SOBRE O PARCELAMENTO DE ARREMATACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.46', 'DEPOSITOS DE TRIBUTOS A CLASSIFICAR', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) NAO CLASSIFICADOS EM CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.47', 'DEPOSITOS POR DEVOLUCAO DE VALORES NAO RECLAMADOS', 'REGISTRA OS DEPOSITOS POR DEVOLUCAO DE VALORES NAO RECLAMADOS EM DECORRENCIA DE CANCELAMENTO DE ORDEM BANCARIA, TAIS COMO: PAGAMENTO DE SERVIDOR ATIVO, INATIVO, PENSIONISTA OU DE FORNECEDORES. O VALOR DEVERA FICAR REGISTRADO ENQUANTO NAO FOR REALIZADO NOVO PAGAMENTO OU DEVERA SER CLASSIFICADO COMO RECEITA APOS DEFINICAO DA NAO REALIZACAO DO NOVO PAGAMENTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.48', 'DEPOSITOS DE TITULOS DO FIES A RECOLHER', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TITULOS DO FIES PARA RECOLHIMENTO DE TRIBUTOS FEDERAIS E CONTRIBUICOES PREVIDENCIARIAS DEVIDOS PELAS INSTITUICOES DE ENSINO, RECOLHIDOS PELO FNDE POR MEIO DO SIAFI.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.49', 'DEPOSITOS DE TERCEIROS - BACEN', 'REGISTRA OS VALORES RELATIVOS AOS DARF/GPS EMITIDOS PELO BACEN (UG 173057) A SEREM ENVIADOS PELA COFIN POR MEIO DE OBR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.50', 'DEPOSITOS NA CONTA ESPECIAL - EMPRESTIMOS EXTERNOS', 'REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS EXTERNOS DEPOSITADOS EM CONTA ESPECIAL NO BANCO DO BRASIL - ROTINA DE CONTROLE DOS EMPRESTIMOS EXTERNOS ANTES DO REGISTRO NA CONTA UNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.51', 'REMUNERACAO DEPOSITOS CONTA ESPECIAL -EMPRESTIMOS EXTERNOS', 'REGISTRA OS VALORES RELATIVOS AS REMUNERACOES DOS EMPRESTIMOS EXTERNOS DEPOSITADOS EM CONTA ESPECIAL NO BANCO DO BRASIL - ROTINA DE CONTROLE DOS EMPRESTIMOS EXTERNOS ANTES DO REGISTRO NA CONTA UNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.52', 'DEPOSITOS PARA SERVICOS DE PUBLICIDADE', 'REGISTRA OS DEPOSITOS DESTINADOS A VEICULOS DE COMUNICACAO, ORIGINARIOS DOS SERVICOS DE PUBLICIDADE CONTRATADOS POR MEIO DE AGENCIA DE PUBLICIDADE, CONFORME LEI Nº 4680, DE 18 DE JUNHO DE 1965, DECRETO Nº 57690, DE 1 DE FEVEREIRO DE 1966, DECRETO Nº 4563, DE 31 DE DEZEMBRO DE 2002 E NORMAS PADRAO DA ATIVIDADE PUBLICITARIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.53', 'PAGAMENTO / PARCELAMENTO - MP Nº 470', 'REGISTRA, CONFORME DISPOE A MEDIDA PROVISORIA Nº 470, DE 13 DE OUTUBRO DE 2009, O VALOR DECORRENTE DE PAGAMENTOS OU PARCELAMENTOS DE DEBITOS DECORRENTES DO APROVEITAMENTO INDEVIDO DO INCENTIVO FISCAL SETORIAL, INSTITUIDO PELO ART. 1º DO DECRETO-LEI Nº 491, DE 5 DE MARCO DE 1969, E OS ORIUNDOS DA AQUISICAO DE MATERIAS-PRIMAS, MATERIAL DE EMBALAGEM E PRODUTOS INTERMEDIARIOS RELACIONADOS NA TABELA DE INCIDENCIA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS - TIPI, APROVADA PELO DECRETO Nº 6.006, DE 28 DE DEZEMBRO DE 2006, COM INCIDENCIA DE ALIQUOTA ZERO OU COMO NAO TRIBUTADOS - NT.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.54', 'RECURSOS DEPOSITADOS NO BACEN', 'REGISTRA OS VALORES DEPOSITADOS NO BACEN CONFORME O ARTIGO 164 DA CONSTITUICAO FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.55', 'DEPOSITO DE RESTITUICOES DE TRIBUTOS SIEF', 'REGISTRA OS VALORES DEVOLVIDOS PELO BANCO DO BRASIL AO TESOURO NACIONAL DAS RESTITUICOES, POR LOTE, DE RECEITAS TRIBUTARIAS NAO CREDITADAS AOS CONTRIBUINTES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.56', 'DEPOSITO ITR', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE ITR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.57', 'DEPOSITOS RETIDOS PESSOAL/BENEFICIO A PAGAR', 'REGISTRA OS VALORES DE OBRIGACOES, EXIGIVEIS ATE O CURSO DO EXERCICIO SEGUINTE, DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE PESSOAL OU BENEFICIOS A PAGAR PARA POSTERIOR DESTINACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.58', 'DEPOSITOS ESPECIAIS FAT - APLICACAO EM PROJETOS - PRO-INOVACAO', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AOS RECURSOS APLICADOS EM PROJETOS PRO-INOVACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.59', 'DEPOSITOS ESPECIAIS FAT - DISPONIVEIS PARA APLICACAO - PRO-INOVACAO', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AOS RECURSOS DISPONIVEIS PARA APLICACAO EM PROJETOS PRO-INOVACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.60', 'PARCELAMENTO PARAMETRIZADO/COBRANCA INTEGRADA', 'REGISTRA O DEPOSITO DOS VALORES ARRECADADOS PELA SECRETARIA DA RECEITA FEDERAL DO BRASIL RELATIVO AO MACROPROCESSO DO CREDITO TRIBUTARIO A SEREM UTILIZADOS NO PARCELAMENTO PARAMETRIZADO E NA COBRANCA INTEGRADA (AMIGAVEL, ADMINISTRATIVA E EXECUTIVA).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.61', 'DEPOSITO DIVIDA ATIVA - ITR', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DA DIVIDA ATIVA REFERENTE AO ITR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.62', 'DEPOSITOS JUD.EXTRA-JUD ADMINISTRADOS PGF-AGU', 'REGISTRA OS DEPOSITOS JUDICIAIS E EXTRAJUDICIAIS RELATIVOS A UNIAO,FUNDOS PUBLICOS, AUTARQUIAS, FUNDACOES PUBLICAS E DEMAIS ENTIDADES FEDERAIS INTEGRANTES DOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, GERENCIADOS PELA PROCURADORIA-GERAL FEDERAL, DE QUE TRATA O DECRETO-LEI Nº 1.737, DE 20 DE DEZEMBRO DE 1979,CONFORME O DISPOSTO NO ARTIGO 3º DA LEI Nº 12.099 DE 27 DE NOVEMBRO DE 2009.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.63', 'DEPOSITO DE OUTRAS RECEITAS NAO IDENTIFICADAS', 'REGISTRA OS DEPOSITOS DE VALORES ARRECADADOS PELA SRFB E NÃO IDENTIFICADOS PELOS BANCOS, QUANDO ORIGINARIOS DE PAGAMENTOS EMITIDOS COM DOCUMENTOS DE ARRECADAÇÃO (DARF) COM CÓDIGO DE BARRAS POR SISTEMAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.64', 'REGIME TRIBUTACAO UNIFICADA RTU - IMPORTACAO', 'REGISTRA OS DEPOSITOS DE VALORES ARRECADADOS PELA SRFB, QUANDO ORIGINARIOS DE PAGAMENTOS EMITIDOS COM DOCUMENTOS DE ARRECADAÇÃO (DARF) DECORRENTE DO REGIME DE TRIBUTACAO UNIFICADA - IMPORTACAO, POR VIA TERRESTRE, DE MERCADORIAS PROCEDENTES DO PARAGUAI. BASE LEGAL: - LEI Nº 11.898, DE 8 DE JANEIRO DE 2009; - DECRETO Nº 6.956, DE 9 DE SETEMBRO DE 2009.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.65', 'CONTRIBUICAO PREVIDENCIARIA - PGTO UNIFICADO', 'REGISTRA OS DEPOSITOS DE VALORES ARRECADADOS PELA RECEITA FEDERAL DO BRASIL - RFB, QUANDO ORIGINADOS DE PAGAMENTOS EMITIDOS COM DOCUMENTOS DE ARRECADACAO (DARF) DECORRENTE DO PROGRAMA DE UNIFICACAO DOS CREDITOS RELATIVOS AA CONTRIBUICAO PREVIDENCIARIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.99', 'OUTROS DEPOSITOS', 'REGISTRA COMPROMISSOS EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, DECORRENTES DE RECEBIMENTOS A TITULO DE DEPOSITOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.05.00', 'SUBVENCOES E DOACOES PARA INVESTIMENTOS', 'REGISTRA OS VALORES EXIGIVEIS REFERENTES A SUBVENCOES E DOACOES PARA INVESTIMENTOS CONDICIONAIS, OU SEJA, QUE DEPENDAM DE FATO OU EVENTO FUTURO PARA SUA EFETIVACAO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.06.01', 'DEPOSITOS COMPULSORIOS - COMBUSTIVEIS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS REFERENTES AS AQUISICOES DE COMBUSTIVEIS POR ORGAOS, ENTIDADES, EMPRESAS E INSTITUICOES, COM DEVOLUCAO PREVISTA ATE O TERMINO DO EXERCICIO SEGUINTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.06.02', 'DEPOSITOS COMPULSORIOS - VEICULOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS REFERENTES AS AQUISICOES DE VEICULOS POR ORGAOS, ENTIDADES, EMPRESAS E INSTITUICOES, COM DEVOLUCAO PREVISTA NO CURTO PRAZO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.06.98', 'OUTROS DEPOSITOS COMPULSORIOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS, PARA OS QUAIS NAO EXISTAM CONTAS ESPECIFICAS, COM DEVOLUCAO PREVISTA NO CURTO PRAZO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.07.00', 'DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - ESTADOS/MUNICIPIOS', 'DESTINADA A ACOLHER OS VALORES DEPOSITADOS POR BLOQUEIO DE TRANSFERENCIAS CONSTITUCIONAIS A ESTADOS E MUNICIPIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.07.01', 'DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - MUNICIPIOS (FPM)', 'REGISTRA OS VALORES DE DEPOSITOS DE MUNICIPIOS, RELATIVOS A CREDITOS DE RECURSOS BLOQUEADOS DE FPM, REPASSADOS AOS MUNICIPIOS E DEVOLVIDOS A UNIAO POR MEIO DE GRU.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.07.02', 'DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - MUNICIPIOS (FUNDEF/FUNDEB)', 'REGISTRA OS VALORES DE DEPOSITOS DE MUNICIPIOS, RELATIVOS A CREDITOS DE RECURSOS BLOQUEADOS DO FUNDEF/FUNDEB POR ACAO JUDICIAL E DEPOSITADOS PELO BANCO DO BRASIL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.99.00', 'OUTROS VALORES RESTITUIVEIS', 'OUTROS VALORES RESTITUIVEIS EM POSSE DA ENTIDADE, NO PAPEL DE FIEL DEPOSITARIA.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.01', 'PSSS - VENCIMENTOS E VANTAGENS', 'REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE SERVIDORES REGIDOS PELA LEI Nº 8.112/90 A TITULO DE SEGURIDADE SOCIAL A SER RECOLHIDO AO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.02', 'INSS', 'REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE EMPREGADOS REGIDOS PELA CONSOLIDACAO DAS LEIS DO TRABALHO (CLT) OU DE SERVICOS DE TERCEIROS, A SER RECOLHIDO AO INSTITUTO NACIONAL DO SEGURO SOCIAL/PREVIDENCIA SOCIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.03', 'ENCARGOS SOCIAIS - OUTRAS ENTIDADES', 'REGISTRA O VALOR A SER RECOLHIDO A OUTRAS ENTIDADES, EM FUNCAO DE DISPOSITIVOS LEGAIS COM AS QUAIS A ENTIDADE MANTENHA CONVENIO DE ARRECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER, SEBRAE, SENAT, SESCOOP, SESC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.04', 'IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF DEVIDO AO TESOURO NACIONAL', 'REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DO IMPOSTO SOBRE A RENDA, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS OU CREDITADAS A SERVIDORES OU EMPREGADOS, SOBRE AS QUAIS INCIDA O REFERIDO IMPOSTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.05', 'INDENIZACOES E RESTITUICOES DEVIDAS AO TESOURO NACIONAL', 'REGISTRA OS VALORES RELATIVOS AS INDENIZACOES E RESTITUICOES DE TRIBUTOS COM AUTORIZACOES CONCEDIDAS, POREM NAO DEVOLVIDAS AOS LEGITIMOS CREDORES PELA ENTIDADE. REGISTRA OS VALORES A SEREM RECOLHIDOS AO TESOURO NACIONAL, A TITULO DE INDENIZACOES E RESTITUICOES DE TRIBUTOS, PROVENIENTES DE DESCONTO EM FOLHA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.06', 'IMPOSTOS E CONTRIBUICOES DIVERSOS DEVIDOS AO TESOURO NACIONAL', 'REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DE IMPOSTOS E CONTRIBUICOES DIVERSOS, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS, SOBRE OS QUAIS INCIDAM OS REFERIDOS TRIBUTOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.07', 'OUTROS TRIBUTOS DO TESOURO NACIONAL', 'REGISTRA OS VALORES RELATIVOS A OUTROS TRIBUTOS DO TESOURO NACIONAL RETIDOS PELA ENTIDADE SOBRE VALORES PAGOS OU CREDITADOS E QUE, SOBRE OS QUAIS, INCIDA O REFERIDO TRIBUTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.08', 'ICMS', 'REGISTRA OS VALORES RELATIVOS AO IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E SERVICOS RETIDOS POR FOCA DE LEGISLACAO OU POR ACORDO ENTRE AS PARTES ENVOLVIDAS NA TRANSACAO EM CONSIGNACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.09', 'ISS', 'REGISTRA OS VALORES DO IMPOSTO SOBRE SERVICOS RETIDOS EM CONSIGNACOES POR FORCA DE LEGISLACAO, CIRCUNSTANCIAS OU ACORDO ENTRE AS PARTES ENVOLVIDOS NA TRANSACAO, EM SITUACOES QUE A ENTIDADE COMO PARTE CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTARIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.11', 'IRRF/GDF', 'REGISTRA OS VALORES DO IMPOSTO DE RENDA RETIDO EM CONSIGNACOES POR FORCA DE LEGISLACAO/CONVENIOS, A SEREM REPASSADOS AO GOVERNO DO DISTRITO FEDERAL (GDF)', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.12', 'PSSS/GDF', 'REGISTRA OS VALORES DO PSSS EM CONSIGNACOES POR FORCA DE LEGISLACAO/CONVENIOS, A SEREM REPASSADOS AO GOVERNO DO DISTRITO FEDERAL (GDF).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.13', 'OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS', 'REGISTRA OS VALORES EM CONSIGNACAO RELATIVOS A OUTROS TRIBUTOS A SEREM REPASSADOS AOS ESTADOS E MUNICIPIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.14', 'PENSAO ALIMENTICIA', 'REGISTRA OS VALORES DAS RETENCOES EM FOLHA PROCEDIDAS EM PAGAMENTOS A EMPREGADOS OU A SERVIDORES, AUTORIZADOS POR ESSES OU POR DETERMINACAO JUDICIAL, A TITULO DE PENSAO ALIMENTICIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.15', 'PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA', 'REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DO PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES DE PREVIDENCIA E ASSISTENCIA MEDICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.16', 'ASSISTENCIA A SAUDE - ADMINISTRACAO PROPRIA', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, QUE SERAO ADMINISTRADOS PELO PROPRIO ORGAO/ENTIDADE PARA ASSISTENCIA A SAUDE DE SEUS SERVIDORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.17', 'RETENCOES - ENTIDADES REPRESENTATIVAS DE CLASSES', 'REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DE PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES REPRESENTATIVAS DE CLASSE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.18', 'RETENCOES - SINDICATOS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS AOS RESPECTIVOS SINDICATOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.19', 'RETENCOES - ASSOCIACOES', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS A ASSOCIACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.20', 'RETENCOES - COOPERATIVAS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS A COOPERATIVAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.21', 'RETENCOES - PLANOS DE SEGUROS', 'REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES AS CONTRIBUICOES A PLANOS DE SEGURO DE VIDA EM GRUPO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.22', 'RETENCOES - EMPRESTIMOS E FINANCIAMENTOS', 'REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR TERCEIROS, BEM COMO RETENCOES DE PARCELAS DE CONSORCIOS E SEGURADOS DO INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.23', 'RETENCAO A LOCADORES DE IMOVEIS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS E OU PAGAMENTOS A LOCADORES DE IMOVEIS A TITULO DE UTILIZACAO DE IMOVEIS FUNCIONAIS RESIDENCIAIS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.24', 'RETENCAO RELATIVA A VALE TRANSPORTE', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM RE-PASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO DE VALE-TRANSPORTE. TRATA-SE DOS VALORES REFERENTES AOS 6% INSTITUIDOS PELO ARTIGO 9º DO DECRETO Nº 95.247/1987 E SUAS ALTERACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.25', 'RETENCAO RELATIVA A VALE ALIMENTACAO', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO DE CARTAO-ALIMENTACAO/REFEICAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.26', 'SERVICOS DE PROCESSAMENTO DE DADOS', 'REGISTRA O VALOR TOTAL DA ARRECADACAO DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VALORES DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.99', 'OUTROS CONSIGNATARIOS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, EM CONFIANCA, POR DIVERSOS CONTRIBUINTES SUJEITOS A RECOLHIMENTOS E OU PAGAMENTOS AOS FAVORECIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.02.00', 'GARANTIAS', 'COMPREENDE A GARANTIA DO CUMPRIMENTO DE UMA OBRIGACAO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENCOES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.03.01', 'DEPOSITOS A EFETUAR POR DETERMINACAO JUDICIAL', 'REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS A EFETUAR PELA ENTIDADE POR DETERMINACAO JUDICIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.03.02', 'DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL', 'REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS RECEBIDOS PELA ENTIDADE POR DETERMINACAO JUDICIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.03.03', 'DEPOSITOS A EFETUAR PARA RECURSOS JUDICIAIS', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS A EFETUAR PELA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.03.04', 'DEPOSITOS RECEBIDOS PARA RECURSOS JUDICIAIS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS RECEBIDOS PELA ENTIDADE RELATIVOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.01', 'DEPOSITOS E CAUCOES A EFETUAR', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS REFERENTES A DEPOSITOS E/OU CAUCOES A EFETUAR PELA ENTIDADE VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.02', 'DEPOSITOS E CAUCOES RECEBIDOS', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS E/OU CAUCOES PELA ENTIDADE VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.03', 'DEPOSITOS A EFETUAR PARA RECURSOS ADMINISTRATIVOS', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS A EFETUAR PELA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO ADMINISTRATIVO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.04', 'DEPOSITOS RECEBIDOS PARA RECURSOS ADMINISTRATIVOS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS RECEBIDOS PELA ENTIDADE RELATIVOS AO EXERCICIO DE DIREITO DE RECURSO ADMINISTRATIVO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.05', 'DEPOSITOS ESPECIAIS', 'REGISTRA O VALOR RELATIVO A RETENCOES DE DEPOSITOS VINCULADOS A RESTITUIR NO CURSO DO EXERCICIO SEGUINTE A ENTIDADE TRANSFERIDORA, DECORRENTE DE CONTRATOS OU INSTRUMENTOS CONGENERES, CONVENCAO, ACORDO OU AJUSTE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.06', 'DEPOSITOS RETIDOS DE FORNECEDORES', 'REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE FORNECEDORES EM FUNCAO DE APLICACAO DE MULTAS E OUTRAS DETERMINACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.07', 'DEPOSITOS DE VEICULOS ALIENAVEIS', 'REGISTRA O VALOR DOS RECEBIMENTOS PROVENIENTES DA ALIENACAO DE VEICULOS REMOVIDOS, RECOLHIDOS OU APREENDIDOS DE ACORDO COM A RESOLUCAO DO CONTRAN Nº 178/2005, PENDENTES DE TRANSFERENCIAS DIVERSAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.08', 'DEPOSITOS A TRANSFERIR', 'REGISTRA OS VALORES DAS RETENCOES DE DEPOSITOS DE DIVERSAS ORIGENS RECEBIDOS POR UG CENTRAL CUJA DEVOLUCAO DEVE SER REALIZADA NO CURSO DO EXERCICIO SEGUINTE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.09', 'DEPOSITOS DE TERCEIROS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TERCEIROS DE DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NAO RECLAMADOS PELOS CREDORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.10', 'DEPOSITOS A DISTRIBUIR', 'REGISTRA OS DEPOSITOS DECORRENTES DA FITA 50, RELACIONADOS COM A FONTE 0150025074 QUE E DESTINADA 80% PARA O CODIGO 07401 E 20% PARA O CODIGO 07402 (DESVINCULACAO DE RRECEITAS DA UNIAO - DRU) E AINDA AS APROPRIACOES REFERENTES A DEVOLUCAO DO PSSS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.11', 'DEPOSITOS DE ENTIDADES', 'REGISTRA O VALOR DAS CONTRIBUICOES COM ENTIDADES TERCEIRAS TAIS COMO: SESI, SENAI, SESC, ETC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.12', 'DEPOSITOS DE RENDIMENTOS DO PIS/PASEP', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RENDIMENTOS DO PIS/PASEP PARA CREDITO EM FOLHA DE PAGAMENTO AOS SERVIDORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.13', 'DEPOSITOS DO ITR E CONTRIBUICOES RURAIS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL (ITR) E OUTRAS CONTRIBUICOES RURAIS PARA DISTRIBUICAO AOS BENEFICIARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.14', 'CONTRIBUICOES RURAIS A DISTRIBUIR', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES RURAIS CLASSIFICADAS E AINDA NAO DISTRIBUIDAS AOS BENEFICIARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.15', 'DEPOSITOS A DISTRIBUIR DO SALARIO-EDUCACAO', 'REGISTRA OS DEPOSITOS DECORRENTES DA ARRECADACAO DO SALARIO-EDUCACAO, PROVENIENTES DO DOCUMENTO GUIA DO SALARIO-EDUCACAO (GSE).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.16', 'DEPOSITOS DO FAT - PMC', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AO PROGRAMA PARA MELHORIA DA COMPETITIVIDADE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.17', 'DEPOSITOS DO FAT PRO-INOVACAO', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AO PROGRAMA PRO-INOVACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.18', 'DEPOSITOS PARA IMPORTACOES - PESQUISA CIENTIFICA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE ENTIDADES SEM FINS LUCRATIVOS ATIVAS NO FOMENTO, NA COORDENACAO OU NA EXECUCAO DE PROGRAMAS DE PESQUISA CIENTIFICA E TECNOLOGICA OU DE ENSINO, PARA A REALIZACAO DE IMPORTACOES DE BENS DESTINADOS A PESQUISA CIENTIFICA E TECNOLOGICA. BASE LEGAL: LEI Nº 8.010/1990.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.19', 'DEPOSITOS ISS A DISTRIBUIR - DAR SUBSTITUICAO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DO IMPOSTO SOBRE SERVICOS (ISS) - RECOLHIDOS POR DAR SUBSTITUICAO - A DISTRIBUIR PARA OS MUNICIPIOS PARTICIPANTES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.20', 'DEPOSITOS DAS RETENCOES DE IMPOSTOS DO SIMPLES PELOS ORGAOS PUBLICOS', 'REGISTRA OS VALORES A CLASSIFICAR RELATIVOS AOS DEPOSITOS DE IMPOSTOS E CONTRIBUICOES PELO SISTEMA SIMPLES. CUJOS VALORES SAO A CLASSIFICAR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.21', 'DEPOSITO DE IMPOSTOS DO SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTOS E CONTRIBUICOES PELO SISTEMA SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.22', 'PROGRAMA DE RECUPERACAO FISCAL - REFIS', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DO SEGURO SOCIAL (INSS).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.23', 'CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA ARRECADACAO DA CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO REGISTRADA PELA FITA 50 DA SECRETARIA DA RECEITA FEDERAL DO BRASIL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.24', 'DEPOSITOS DE RETENCOES DE CONTRIBUICOES SOBRE PAGAMENTO A PESSOA JURIDICA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RETENCOES DE CONTRIBUICOES SOBRE PAGAMENTOS DE PESSOA JURIDICA A PESSOA JURIDICA DE DIREITO PRIVADO (CSLL, COFINS, PIS/PASEP), Lei nº 10.833/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.25', 'DEPOSITOS DO REGIME ESPECIAL TRIBUTARIO DO PATRIMONIO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO REGIME ESPECIAL DE TRIBUTACAO DO PATRIMONIO DE AFETACAO DE INCORPORACOES IMOBILIARIAS , INSTITUIDO PELA LEI Nº 10.931/2004.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.26', 'DEPOSITOS DE RETENCOES DE CONTRIBUICOES S/PAGAMENTO DE ESTADOS/DF/MUNICIPIOS A PESSOAS JURIDICAS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES ASS RETENCOES DE CONTRIBUICOES (CSLL, COFINS, PIS/PASEP) SOBRE PAGAMENTOS A PESSOA JURIDICA DE DIREITO PRIVADO PELOS ESTADOS OU MUNICIPIOS, DE ACORDO COM ART. 31 E 33 DA LEI Nº 10.833/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.27', 'PARCELAMENTO ESPECIAL PAES', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DO SEGURO SOCIAL (INSS), INSTITUIDO PELA LEI Nº 10.684/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.28', 'PARCELAMENTO MP Nº 303/2006 - PAEX', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DE SEGURIDADE SOCIAL - INSS, CONFORME MEDIDA PROVISORIA Nº Nº 303/2006.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.29', 'PARCELAMENTO PARA INGRESSO NO SIMPLES NACIONAL', 'REGISTRA O VALOR DOS RECURSOS DE PARCELAMENTO DE DEBITOS COM O INSS OU COM AS FAZENDAS PUBLICAS FEDERAL, ESTADUAL OU MUNICIPAL PARA INGRESSO NO PROGRAMA SIMPLES NACIONAL, CONFORME LEI COMPLEMENTAR Nº 123/2006 - ART. 79.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.30', 'PARCELAMENTO TIMEMANIA', 'REGISTRA O VALOR DAS RECEITAS ARRECADADAS DECORRENTES DA RENEGOCIACAO DE DIVIDAS DE ENTIDADES DESPORTIVAS JUNTO A PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), CONFORME LEI Nº 11.345/2006, ALTERADA PELA LEI Nº 11.505/2007.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.31', 'PARCELAMENTO FIES - LEI Nº 10.260/2001', 'REGISTRA O VALOR DAS RECEITAS ARRECADADAS DECORRENTES DE PARCELAMENTO DE TRIBUTOS ADMINISTRADOS PELA RECEITA FEDERAL DO BRASIL - RFB TENDO COMO SUJEITO PASSIVO AS PESSOAS JURIDICAS DE DIREITO PRIVADO MANTENEDORAS DE INSTITUICOES DE ENSINO SUPERIOR QUE POSSUEM OS CERTIFICADOS DE EMISSAO DO TESOURO NACIONAL E OPTARAM PELO PARCELAMENTO, DESDE QUE TODAS AS INSTITUICOES MANTIDAS TENHAM ADERIDO AO PROGRAMA UNIVERSIDADE PARA TODOS (PROUNI). BASE LEGAL: LEI 10.260/2001, ART. 10, §§ 3º E 5º (REDACAO DADA PELA LEI 11.552/2007).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.32', 'PARCELAMENTO MP Nº 449/2008', 'REGISTRA O VALOR DOS RECURSOS DECORRENTE DE PARCELAMENTO DE DIVIDAS DE PEQUENO VALOR COM A FAZENDA NACIONAL E DIVIDAS DECORRENTES DE APROVEITAMENTO INDEVIDO DE CREDITOS DE IPI, CONFORME DISPOE A A MEDIDA PROVISORIA Nº 449, DE 03 DE DEZEMBRO DE 2008 LEI Nº 11.941/2009', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.33', 'PARCELAMENTO DE ARREMATACAO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TRIBUTOS A CLASSIFICAR PROVENIENTES DO PARCELAMENTO DE VALOR CORRESPONDENTE A ARREMATACAO DE BEM EM HASTA PUBLICA NAS EXECUCOES FISCAIS PROMOVIDAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN) (PORTARIA 262 DE 11/06/2002).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.34', 'PARCELAMENTO - DEMAIS DEBITOS - LEI Nº 11.941/2009', 'REGISTRA OS VALORES RELATIVOS AOS PARCELAMENTOS DE QUE TRATA A LEI Nº 11.941/2009, EXCETO OS DECORRENTES DE DEBITOS PREVIDENCIARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.35', 'DEPOSITOS DE ICMS A DISTRIBUIR A ESTADOS', 'REGISTRA OS VALORES A DISTRIBUIR AOS ESTADOS RELATIVOS AOS DEPOSITOS DE ICMS IMPOSTO PELO SISTEMA SIMPLES. CUJOS OS VALORES SAO A DISTRIBUIR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.36', 'DEPOSITOS DE ISS A DISTRIBUIR A MUNICIPIOS', 'REGISTRA OS VALORES A DISTRIBUIR AOS MUNICIPIOS RELATIVOS AOS DEPOSITOS DE ISS IMPOSTO PELO SISTEMA SIMPLES. CUJOS OS VALORES SAO A DISTRIBUIR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.37', 'DEPOSITOS DO IMPOSTO SIMPLES - INSS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTO PELO SISTEMA SIMPLES, RELATIVOS AO INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.38', 'DEPOSITOS REFIS - INSS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTE AO PROGRAMA DE RECUPERACAO FISCAL (REFIS) INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.39', 'DEPOSITOS PAES INSS SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) DO INSS SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.40', 'DEPOSITOS PAES ISS SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) DO ISS SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.41', 'DEPOSITOS PAES ICMS SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003)DO ICMS SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.42', 'DEPOSITOS INSS SIMPLES NACIONAL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES A ARRECADACAO DO INSS SIMPLES NACIONAL,CONFORME LEI COMPLEMENTAR Nº 123,DE 14 DE DEZEMBRO DE 2006.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.43', 'INSS - PARCELAMENTO LEI Nº 11.941/2009', 'REGISTRA OS VALORES DECORRENTES DE DEBITOS PREVIDENCIARIOS, RELATIVOS AOS PARCELAMENTOS DE QUE TRATA A LEI Nº 11.941, DE 27 DE MAIO DE 2009.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.44', 'MULTA POR FALTA/ATRASO/ERRO/OMISSAO - GFIP', 'REGISTRA OS VALORES RELATIVOS A MULTA POR ERRO, OMISSAO, FALTA OU ATRASO NA ENTREGA DA DECLARACAO GFIP DE QUE TRATA O ART. 32A DA LEI Nº 8.212, DE 24 DE JULHO DE 1991.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.45', 'DEPOSITOS PAES PARCELAMENTO DE ARREMATACAO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) SOBRE O PARCELAMENTO DE ARREMATACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.46', 'DEPOSITOS DE TRIBUTOS A CLASSIFICAR', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) NAO CLASSIFICADOS EM CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.47', 'DEPOSITOS POR DEVOLUCAO DE VALORES NAO RECLAMADOS', 'REGISTRA OS DEPOSITOS POR DEVOLUCAO DE VALORES NAO RECLAMADOS EM DECORRENCIA DE CANCELAMENTO DE ORDEM BANCARIA, TAIS COMO: PAGAMENTO DE SERVIDOR ATIVO, INATIVO, PENSIONISTA OU DE FORNECEDORES. O VALOR DEVERA FICAR REGISTRADO ENQUANTO NAO FOR REALIZADO NOVO PAGAMENTO OU DEVERA SER CLASSIFICADO COMO RECEITA APOS DEFINICAO DA NAO REALIZACAO DO NOVO PAGAMENTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.48', 'DEPOSITOS DE TITULOS DO FIES A RECOLHER', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TITULOS DO FIES PARA RECOLHIMENTO DE TRIBUTOS FEDERAIS E CONTRIBUICOES PREVIDENCIARIAS DEVIDOS PELAS INSTITUICOES DE ENSINO, RECOLHIDOS PELO FNDE POR MEIO DO SIAFI.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.49', 'DEPOSITOS DE TERCEIROS - BACEN', 'REGISTRA OS VALORES RELATIVOS AOS DARF/GPS EMITIDOS PELO BACEN (UG 173057) A SEREM ENVIADOS PELA COFIN POR MEIO DE OBR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.50', 'DEPOSITOS NA CONTA ESPECIAL - EMPRESTIMOS EXTERNOS', 'REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS EXTERNOS DEPOSITADOS EM CONTA ESPECIAL NO BANCO DO BRASIL - ROTINA DE CONTROLE DOS EMPRESTIMOS EXTERNOS ANTES DO REGISTRO NA CONTA UNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.51', 'REMUNERACAO DEPOSITOS CONTA ESPECIAL -EMPRESTIMOS EXTERNOS', 'REGISTRA OS VALORES RELATIVOS AS REMUNERACOES DOS EMPRESTIMOS EXTERNOS DEPOSITADOS EM CONTA ESPECIAL NO BANCO DO BRASIL - ROTINA DE CONTROLE DOS EMPRESTIMOS EXTERNOS ANTES DO REGISTRO NA CONTA UNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.52', 'DEPOSITOS PARA SERVICOS DE PUBLICIDADE', 'REGISTRA OS DEPOSITOS DESTINADOS A VEICULOS DE COMUNICACAO, ORIGINARIOS DOS SERVICOS DE PUBLICIDADE CONTRATADOS POR MEIO DE AGENCIA DE PUBLICIDADE, CONFORME LEI Nº 4680, DE 18 DE JUNHO DE 1965, DECRETO Nº 57690, DE 1 DE FEVEREIRO DE 1966, DECRETO Nº 4563, DE 31 DE DEZEMBRO DE 2002 E NORMAS PADRAO DA ATIVIDADE PUBLICITARIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.53', 'PAGAMENTO / PARCELAMENTO - MP Nº 470', 'REGISTRA, CONFORME DISPOE A MEDIDA PROVISORIA Nº 470, DE 13 DE OUTUBRO DE 2009, O VALOR DECORRENTE DE PAGAMENTOS OU PARCELAMENTOS DE DEBITOS DECORRENTES DO APROVEITAMENTO INDEVIDO DO INCENTIVO FISCAL SETORIAL, INSTITUIDO PELO ART. 1º DO DECRETO-LEI Nº 491, DE 5 DE MARCO DE 1969, E OS ORIUNDOS DA AQUISICAO DE MATERIAS-PRIMAS, MATERIAL DE EMBALAGEM E PRODUTOS INTERMEDIARIOS RELACIONADOS NA TABELA DE INCIDENCIA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS - TIPI, APROVADA PELO DECRETO Nº 6.006, DE 28 DE DEZEMBRO DE 2006, COM INCIDENCIA DE ALIQUOTA ZERO OU COMO NAO TRIBUTADOS - NT.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.54', 'RECURSOS DEPOSITADOS NO BACEN', 'REGISTRA OS VALORES DEPOSITADOS NO BACEN CONFORME O ARTIGO 164 DA CONSTITUICAO FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.55', 'DEPOSITO DE RESTITUICOES DE TRIBUTOS SIEF', 'REGISTRA OS VALORES DEVOLVIDOS PELO BANCO DO BRASIL AO TESOURO NACIONAL DAS RESTITUICOES, POR LOTE, DE RECEITAS TRIBUTARIAS NAO CREDITADAS AOS CONTRIBUINTES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.56', 'DEPOSITO ITR', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE ITR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.57', 'DEPOSITOS RETIDOS PESSOAL/BENEFICIO A PAGAR', 'REGISTRA OS VALORES DE OBRIGACOES, EXIGIVEIS ATE O CURSO DO EXERCICIO SEGUINTE, DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE PESSOAL OU BENEFICIOS A PAGAR PARA POSTERIOR DESTINACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.58', 'DEPOSITOS ESPECIAIS FAT - APLICACAO EM PROJETOS - PRO-INOVACAO', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AOS RECURSOS APLICADOS EM PROJETOS PRO-INOVACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.59', 'DEPOSITOS ESPECIAIS FAT - DISPONIVEIS PARA APLICACAO - PRO-INOVACAO', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AOS RECURSOS DISPONIVEIS PARA APLICACAO EM PROJETOS PRO-INOVACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.60', 'PARCELAMENTO PARAMETRIZADO/COBRANCA INTEGRADA', 'REGISTRA O DEPOSITO DOS VALORES ARRECADADOS PELA SECRETARIA DA RECEITA FEDERAL DO BRASIL RELATIVO AO MACROPROCESSO DO CREDITO TRIBUTARIO A SEREM UTILIZADOS NO PARCELAMENTO PARAMETRIZADO E NA COBRANCA INTEGRADA (AMIGAVEL, ADMINISTRATIVA E EXECUTIVA).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.61', 'DEPOSITO DIVIDA ATIVA - ITR', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DA DIVIDA ATIVA REFERENTE AO ITR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.62', 'DEPOSITOS JUD.EXTRA-JUD ADMINISTRADOS PGF-AGU', 'REGISTRA OS DEPOSITOS JUDICIAIS E EXTRAJUDICIAIS RELATIVOS A UNIAO,FUNDOS PUBLICOS, AUTARQUIAS, FUNDACOES PUBLICAS E DEMAIS ENTIDADES FEDERAIS INTEGRANTES DOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, GERENCIADOS PELA PROCURADORIA-GERAL FEDERAL, DE QUE TRATA O DECRETO-LEI Nº 1.737, DE 20 DE DEZEMBRO DE 1979,CONFORME O DISPOSTO NO ARTIGO 3º DA LEI Nº 12.099 DE 27 DE NOVEMBRO DE 2009.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.63', 'DEPOSITO DE OUTRAS RECEITAS NAO IDENTIFICADAS', 'REGISTRA OS DEPOSITOS DE VALORES ARRECADADOS PELA SRFB E NÃO IDENTIFICADOS PELOS BANCOS, QUANDO ORIGINARIOS DE PAGAMENTOS EMITIDOS COM DOCUMENTOS DE ARRECADAÇÃO (DARF) COM CÓDIGO DE BARRAS POR SISTEMAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.64', 'REGIME TRIBUTACAO UNIFICADA RTU - IMPORTACAO', 'REGISTRA OS DEPOSITOS DE VALORES ARRECADADOS PELA SRFB, QUANDO ORIGINARIOS DE PAGAMENTOS EMITIDOS COM DOCUMENTOS DE ARRECADAÇÃO (DARF) DECORRENTE DO REGIME DE TRIBUTACAO UNIFICADA - IMPORTACAO, POR VIA TERRESTRE, DE MERCADORIAS PROCEDENTES DO PARAGUAI. BASE LEGAL: - LEI Nº 11.898, DE 8 DE JANEIRO DE 2009; - DECRETO Nº 6.956, DE 9 DE SETEMBRO DE 2009.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.65', 'CONTRIBUICAO PREVIDENCIARIA - PGTO UNIFICADO', 'REGISTRA OS DEPOSITOS DE VALORES ARRECADADOS PELA RECEITA FEDERAL DO BRASIL - RFB, QUANDO ORIGINADOS DE PAGAMENTOS EMITIDOS COM DOCUMENTOS DE ARRECADACAO (DARF) DECORRENTE DO PROGRAMA DE UNIFICACAO DOS CREDITOS RELATIVOS AA CONTRIBUICAO PREVIDENCIARIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.99', 'OUTROS DEPOSITOS', 'REGISTRA COMPROMISSOS EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, DECORRENTES DE RECEBIMENTOS A TITULO DE DEPOSITOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.05.00', 'SUBVENCOES E DOACOES PARA INVESTIMENTOS', 'REGISTRA OS VALORES EXIGIVEIS REFERENTES A SUBVENCOES E DOACOES PARA INVESTIMENTOS CONDICIONAIS, OU SEJA, QUE DEPENDAM DE FATO OU EVENTO FUTURO PARA SUA EFETIVACAO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.06.01', 'DEPOSITOS COMPULSORIOS - COMBUSTIVEIS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS REFERENTES AS AQUISICOES DE COMBUSTIVEIS POR ORGAOS, ENTIDADES, EMPRESAS E INSTITUICOES, COM DEVOLUCAO PREVISTA ATE O TERMINO DO EXERCICIO SEGUINTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.06.02', 'DEPOSITOS COMPULSORIOS - VEICULOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS REFERENTES AS AQUISICOES DE VEICULOS POR ORGAOS, ENTIDADES, EMPRESAS E INSTITUICOES, COM DEVOLUCAO PREVISTA NO CURTO PRAZO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.06.98', 'OUTROS DEPOSITOS COMPULSORIOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS, PARA OS QUAIS NAO EXISTAM CONTAS ESPECIFICAS, COM DEVOLUCAO PREVISTA NO CURTO PRAZO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.07.00', 'DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - ESTADOS/MUNICIPIOS', 'DESTINADA A ACOLHER OS VALORES DEPOSITADOS POR BLOQUEIO DE TRANSFERENCIAS CONSTITUCIONAIS A ESTADOS E MUNICIPIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.07.01', 'DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - MUNICIPIOS (FPM)', 'REGISTRA OS VALORES DE DEPOSITOS DE MUNICIPIOS, RELATIVOS A CREDITOS DE RECURSOS BLOQUEADOS DE FPM, REPASSADOS AOS MUNICIPIOS E DEVOLVIDOS A UNIAO POR MEIO DE GRU.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.07.02', 'DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - MUNICIPIOS (FUNDEF/FUNDEB)', 'REGISTRA OS VALORES DE DEPOSITOS DE MUNICIPIOS, RELATIVOS A CREDITOS DE RECURSOS BLOQUEADOS DO FUNDEF/FUNDEB POR ACAO JUDICIAL E DEPOSITADOS PELO BANCO DO BRASIL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.99.00', 'OUTROS VALORES RESTITUIVEIS', 'OUTROS VALORES RESTITUIVEIS EM POSSE DA ENTIDADE, NO PAPEL DE FIEL DEPOSITARIA.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.01', 'PSSS - VENCIMENTOS E VANTAGENS', 'REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE SERVIDORES REGIDOS PELA LEI Nº 8.112/90 A TITULO DE SEGURIDADE SOCIAL A SER RECOLHIDO AO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.02', 'INSS', 'REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE EMPREGADOS REGIDOS PELA CONSOLIDACAO DAS LEIS DO TRABALHO (CLT) OU DE SERVICOS DE TERCEIROS, A SER RECOLHIDO AO INSTITUTO NACIONAL DO SEGURO SOCIAL/PREVIDENCIA SOCIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.03', 'ENCARGOS SOCIAIS - OUTRAS ENTIDADES', 'REGISTRA O VALOR A SER RECOLHIDO A OUTRAS ENTIDADES, EM FUNCAO DE DISPOSITIVOS LEGAIS COM AS QUAIS A ENTIDADE MANTENHA CONVENIO DE ARRECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER, SEBRAE, SENAT, SESCOOP, SESC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.04', 'IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF DEVIDO AO TESOURO NACIONAL', 'REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DO IMPOSTO SOBRE A RENDA, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS OU CREDITADAS A SERVIDORES OU EMPREGADOS, SOBRE AS QUAIS INCIDA O REFERIDO IMPOSTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.05', 'INDENIZACOES E RESTITUICOES DEVIDAS AO TESOURO NACIONAL', 'REGISTRA OS VALORES RELATIVOS AS INDENIZACOES E RESTITUICOES DE TRIBUTOS COM AUTORIZACOES CONCEDIDAS, POREM NAO DEVOLVIDAS AOS LEGITIMOS CREDORES PELA ENTIDADE. REGISTRA OS VALORES A SEREM RECOLHIDOS AO TESOURO NACIONAL, A TITULO DE INDENIZACOES E RESTITUICOES DE TRIBUTOS, PROVENIENTES DE DESCONTO EM FOLHA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.06', 'IMPOSTOS E CONTRIBUICOES DIVERSOS DEVIDOS AO TESOURO NACIONAL', 'REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DE IMPOSTOS E CONTRIBUICOES DIVERSOS, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS, SOBRE OS QUAIS INCIDAM OS REFERIDOS TRIBUTOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.07', 'OUTROS TRIBUTOS DO TESOURO NACIONAL', 'REGISTRA OS VALORES RELATIVOS A OUTROS TRIBUTOS DO TESOURO NACIONAL RETIDOS PELA ENTIDADE SOBRE VALORES PAGOS OU CREDITADOS E QUE, SOBRE OS QUAIS, INCIDA O REFERIDO TRIBUTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.08', 'ICMS', 'REGISTRA OS VALORES RELATIVOS AO IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E SERVICOS RETIDOS POR FOCA DE LEGISLACAO OU POR ACORDO ENTRE AS PARTES ENVOLVIDAS NA TRANSACAO EM CONSIGNACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.09', 'ISS', 'REGISTRA OS VALORES DO IMPOSTO SOBRE SERVICOS RETIDOS EM CONSIGNACOES POR FORCA DE LEGISLACAO, CIRCUNSTANCIAS OU ACORDO ENTRE AS PARTES ENVOLVIDOS NA TRANSACAO, EM SITUACOES QUE A ENTIDADE COMO PARTE CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTARIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.11', 'IRRF/GDF', 'REGISTRA OS VALORES DO IMPOSTO DE RENDA RETIDO EM CONSIGNACOES POR FORCA DE LEGISLACAO/CONVENIOS, A SEREM REPASSADOS AO GOVERNO DO DISTRITO FEDERAL (GDF)', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.12', 'PSSS/GDF', 'REGISTRA OS VALORES DO PSSS EM CONSIGNACOES POR FORCA DE LEGISLACAO/CONVENIOS, A SEREM REPASSADOS AO GOVERNO DO DISTRITO FEDERAL (GDF).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.13', 'OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS', 'REGISTRA OS VALORES EM CONSIGNACAO RELATIVOS A OUTROS TRIBUTOS A SEREM REPASSADOS AOS ESTADOS E MUNICIPIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.14', 'PENSAO ALIMENTICIA', 'REGISTRA OS VALORES DAS RETENCOES EM FOLHA PROCEDIDAS EM PAGAMENTOS A EMPREGADOS OU A SERVIDORES, AUTORIZADOS POR ESSES OU POR DETERMINACAO JUDICIAL, A TITULO DE PENSAO ALIMENTICIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.15', 'PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA', 'REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DO PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES DE PREVIDENCIA E ASSISTENCIA MEDICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.16', 'ASSISTENCIA A SAUDE - ADMINISTRACAO PROPRIA', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, QUE SERAO ADMINISTRADOS PELO PROPRIO ORGAO/ENTIDADE PARA ASSISTENCIA A SAUDE DE SEUS SERVIDORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.17', 'RETENCOES - ENTIDADES REPRESENTATIVAS DE CLASSES', 'REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DE PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES REPRESENTATIVAS DE CLASSE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.18', 'RETENCOES - SINDICATOS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS AOS RESPECTIVOS SINDICATOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.19', 'RETENCOES - ASSOCIACOES', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS A ASSOCIACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.20', 'RETENCOES - COOPERATIVAS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS A COOPERATIVAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.21', 'RETENCOES - PLANOS DE SEGUROS', 'REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES AS CONTRIBUICOES A PLANOS DE SEGURO DE VIDA EM GRUPO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.22', 'RETENCOES - EMPRESTIMOS E FINANCIAMENTOS', 'REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR TERCEIROS, BEM COMO RETENCOES DE PARCELAS DE CONSORCIOS E SEGURADOS DO INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.23', 'RETENCAO A LOCADORES DE IMOVEIS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS E OU PAGAMENTOS A LOCADORES DE IMOVEIS A TITULO DE UTILIZACAO DE IMOVEIS FUNCIONAIS RESIDENCIAIS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.24', 'RETENCAO RELATIVA A VALE TRANSPORTE', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM RE-PASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO DE VALE-TRANSPORTE. TRATA-SE DOS VALORES REFERENTES AOS 6% INSTITUIDOS PELO ARTIGO 9º DO DECRETO Nº 95.247/1987 E SUAS ALTERACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.25', 'RETENCAO RELATIVA A VALE ALIMENTACAO', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO DE CARTAO-ALIMENTACAO/REFEICAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.26', 'SERVICOS DE PROCESSAMENTO DE DADOS', 'REGISTRA O VALOR TOTAL DA ARRECADACAO DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VALORES DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.99', 'OUTROS CONSIGNATARIOS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, EM CONFIANCA, POR DIVERSOS CONTRIBUINTES SUJEITOS A RECOLHIMENTOS E OU PAGAMENTOS AOS FAVORECIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.02.00', 'GARANTIAS', 'COMPREENDE A GARANTIA DO CUMPRIMENTO DE UMA OBRIGACAO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENCOES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.03.01', 'DEPOSITOS A EFETUAR POR DETERMINACAO JUDICIAL', 'REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS A EFETUAR PELA ENTIDADE POR DETERMINACAO JUDICIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.03.02', 'DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL', 'REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS RECEBIDOS PELA ENTIDADE POR DETERMINACAO JUDICIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.03.03', 'DEPOSITOS A EFETUAR PARA RECURSOS JUDICIAIS', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS A EFETUAR PELA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.03.04', 'DEPOSITOS RECEBIDOS PARA RECURSOS JUDICIAIS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS RECEBIDOS PELA ENTIDADE RELATIVOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.01', 'DEPOSITOS E CAUCOES A EFETUAR', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS REFERENTES A DEPOSITOS E/OU CAUCOES A EFETUAR PELA ENTIDADE VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.02', 'DEPOSITOS E CAUCOES RECEBIDOS', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS E/OU CAUCOES PELA ENTIDADE VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.03', 'DEPOSITOS A EFETUAR PARA RECURSOS ADMINISTRATIVOS', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS A EFETUAR PELA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO ADMINISTRATIVO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.04', 'DEPOSITOS RECEBIDOS PARA RECURSOS ADMINISTRATIVOS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS RECEBIDOS PELA ENTIDADE RELATIVOS AO EXERCICIO DE DIREITO DE RECURSO ADMINISTRATIVO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.05', 'DEPOSITOS ESPECIAIS', 'REGISTRA O VALOR RELATIVO A RETENCOES DE DEPOSITOS VINCULADOS A RESTITUIR NO CURSO DO EXERCICIO SEGUINTE A ENTIDADE TRANSFERIDORA, DECORRENTE DE CONTRATOS OU INSTRUMENTOS CONGENERES, CONVENCAO, ACORDO OU AJUSTE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.06', 'DEPOSITOS RETIDOS DE FORNECEDORES', 'REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE FORNECEDORES EM FUNCAO DE APLICACAO DE MULTAS E OUTRAS DETERMINACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.07', 'DEPOSITOS DE VEICULOS ALIENAVEIS', 'REGISTRA O VALOR DOS RECEBIMENTOS PROVENIENTES DA ALIENACAO DE VEICULOS REMOVIDOS, RECOLHIDOS OU APREENDIDOS DE ACORDO COM A RESOLUCAO DO CONTRAN Nº 178/2005, PENDENTES DE TRANSFERENCIAS DIVERSAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.08', 'DEPOSITOS A TRANSFERIR', 'REGISTRA OS VALORES DAS RETENCOES DE DEPOSITOS DE DIVERSAS ORIGENS RECEBIDOS POR UG CENTRAL CUJA DEVOLUCAO DEVE SER REALIZADA NO CURSO DO EXERCICIO SEGUINTE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.09', 'DEPOSITOS DE TERCEIROS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TERCEIROS DE DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NAO RECLAMADOS PELOS CREDORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.10', 'DEPOSITOS A DISTRIBUIR', 'REGISTRA OS DEPOSITOS DECORRENTES DA FITA 50, RELACIONADOS COM A FONTE 0150025074 QUE E DESTINADA 80% PARA O CODIGO 07401 E 20% PARA O CODIGO 07402 (DESVINCULACAO DE RRECEITAS DA UNIAO - DRU) E AINDA AS APROPRIACOES REFERENTES A DEVOLUCAO DO PSSS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.11', 'DEPOSITOS DE ENTIDADES', 'REGISTRA O VALOR DAS CONTRIBUICOES COM ENTIDADES TERCEIRAS TAIS COMO: SESI, SENAI, SESC, ETC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.12', 'DEPOSITOS DE RENDIMENTOS DO PIS/PASEP', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RENDIMENTOS DO PIS/PASEP PARA CREDITO EM FOLHA DE PAGAMENTO AOS SERVIDORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.13', 'DEPOSITOS DO ITR E CONTRIBUICOES RURAIS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL (ITR) E OUTRAS CONTRIBUICOES RURAIS PARA DISTRIBUICAO AOS BENEFICIARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.14', 'CONTRIBUICOES RURAIS A DISTRIBUIR', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES RURAIS CLASSIFICADAS E AINDA NAO DISTRIBUIDAS AOS BENEFICIARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.15', 'DEPOSITOS A DISTRIBUIR DO SALARIO-EDUCACAO', 'REGISTRA OS DEPOSITOS DECORRENTES DA ARRECADACAO DO SALARIO-EDUCACAO, PROVENIENTES DO DOCUMENTO GUIA DO SALARIO-EDUCACAO (GSE).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.16', 'DEPOSITOS DO FAT - PMC', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AO PROGRAMA PARA MELHORIA DA COMPETITIVIDADE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.17', 'DEPOSITOS DO FAT PRO-INOVACAO', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AO PROGRAMA PRO-INOVACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.18', 'DEPOSITOS PARA IMPORTACOES - PESQUISA CIENTIFICA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE ENTIDADES SEM FINS LUCRATIVOS ATIVAS NO FOMENTO, NA COORDENACAO OU NA EXECUCAO DE PROGRAMAS DE PESQUISA CIENTIFICA E TECNOLOGICA OU DE ENSINO, PARA A REALIZACAO DE IMPORTACOES DE BENS DESTINADOS A PESQUISA CIENTIFICA E TECNOLOGICA. BASE LEGAL: LEI Nº 8.010/1990.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.19', 'DEPOSITOS ISS A DISTRIBUIR - DAR SUBSTITUICAO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DO IMPOSTO SOBRE SERVICOS (ISS) - RECOLHIDOS POR DAR SUBSTITUICAO - A DISTRIBUIR PARA OS MUNICIPIOS PARTICIPANTES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.20', 'DEPOSITOS DAS RETENCOES DE IMPOSTOS DO SIMPLES PELOS ORGAOS PUBLICOS', 'REGISTRA OS VALORES A CLASSIFICAR RELATIVOS AOS DEPOSITOS DE IMPOSTOS E CONTRIBUICOES PELO SISTEMA SIMPLES. CUJOS VALORES SAO A CLASSIFICAR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.21', 'DEPOSITO DE IMPOSTOS DO SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTOS E CONTRIBUICOES PELO SISTEMA SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.22', 'PROGRAMA DE RECUPERACAO FISCAL - REFIS', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DO SEGURO SOCIAL (INSS).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.23', 'CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA ARRECADACAO DA CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO REGISTRADA PELA FITA 50 DA SECRETARIA DA RECEITA FEDERAL DO BRASIL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.24', 'DEPOSITOS DE RETENCOES DE CONTRIBUICOES SOBRE PAGAMENTO A PESSOA JURIDICA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RETENCOES DE CONTRIBUICOES SOBRE PAGAMENTOS DE PESSOA JURIDICA A PESSOA JURIDICA DE DIREITO PRIVADO (CSLL, COFINS, PIS/PASEP), Lei nº 10.833/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.25', 'DEPOSITOS DO REGIME ESPECIAL TRIBUTARIO DO PATRIMONIO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO REGIME ESPECIAL DE TRIBUTACAO DO PATRIMONIO DE AFETACAO DE INCORPORACOES IMOBILIARIAS , INSTITUIDO PELA LEI Nº 10.931/2004.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.26', 'DEPOSITOS DE RETENCOES DE CONTRIBUICOES S/PAGAMENTO DE ESTADOS/DF/MUNICIPIOS A PESSOAS JURIDICAS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES ASS RETENCOES DE CONTRIBUICOES (CSLL, COFINS, PIS/PASEP) SOBRE PAGAMENTOS A PESSOA JURIDICA DE DIREITO PRIVADO PELOS ESTADOS OU MUNICIPIOS, DE ACORDO COM ART. 31 E 33 DA LEI Nº 10.833/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.27', 'PARCELAMENTO ESPECIAL PAES', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DO SEGURO SOCIAL (INSS), INSTITUIDO PELA LEI Nº 10.684/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.28', 'PARCELAMENTO MP Nº 303/2006 - PAEX', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DE SEGURIDADE SOCIAL - INSS, CONFORME MEDIDA PROVISORIA Nº Nº 303/2006.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.29', 'PARCELAMENTO PARA INGRESSO NO SIMPLES NACIONAL', 'REGISTRA O VALOR DOS RECURSOS DE PARCELAMENTO DE DEBITOS COM O INSS OU COM AS FAZENDAS PUBLICAS FEDERAL, ESTADUAL OU MUNICIPAL PARA INGRESSO NO PROGRAMA SIMPLES NACIONAL, CONFORME LEI COMPLEMENTAR Nº 123/2006 - ART. 79.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.30', 'PARCELAMENTO TIMEMANIA', 'REGISTRA O VALOR DAS RECEITAS ARRECADADAS DECORRENTES DA RENEGOCIACAO DE DIVIDAS DE ENTIDADES DESPORTIVAS JUNTO A PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), CONFORME LEI Nº 11.345/2006, ALTERADA PELA LEI Nº 11.505/2007.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.31', 'PARCELAMENTO FIES - LEI Nº 10.260/2001', 'REGISTRA O VALOR DAS RECEITAS ARRECADADAS DECORRENTES DE PARCELAMENTO DE TRIBUTOS ADMINISTRADOS PELA RECEITA FEDERAL DO BRASIL - RFB TENDO COMO SUJEITO PASSIVO AS PESSOAS JURIDICAS DE DIREITO PRIVADO MANTENEDORAS DE INSTITUICOES DE ENSINO SUPERIOR QUE POSSUEM OS CERTIFICADOS DE EMISSAO DO TESOURO NACIONAL E OPTARAM PELO PARCELAMENTO, DESDE QUE TODAS AS INSTITUICOES MANTIDAS TENHAM ADERIDO AO PROGRAMA UNIVERSIDADE PARA TODOS (PROUNI). BASE LEGAL: LEI 10.260/2001, ART. 10, §§ 3º E 5º (REDACAO DADA PELA LEI 11.552/2007).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.32', 'PARCELAMENTO MP Nº 449/2008', 'REGISTRA O VALOR DOS RECURSOS DECORRENTE DE PARCELAMENTO DE DIVIDAS DE PEQUENO VALOR COM A FAZENDA NACIONAL E DIVIDAS DECORRENTES DE APROVEITAMENTO INDEVIDO DE CREDITOS DE IPI, CONFORME DISPOE A A MEDIDA PROVISORIA Nº 449, DE 03 DE DEZEMBRO DE 2008 LEI Nº 11.941/2009', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.33', 'PARCELAMENTO DE ARREMATACAO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TRIBUTOS A CLASSIFICAR PROVENIENTES DO PARCELAMENTO DE VALOR CORRESPONDENTE A ARREMATACAO DE BEM EM HASTA PUBLICA NAS EXECUCOES FISCAIS PROMOVIDAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN) (PORTARIA 262 DE 11/06/2002).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.34', 'PARCELAMENTO - DEMAIS DEBITOS - LEI Nº 11.941/2009', 'REGISTRA OS VALORES RELATIVOS AOS PARCELAMENTOS DE QUE TRATA A LEI Nº 11.941/2009, EXCETO OS DECORRENTES DE DEBITOS PREVIDENCIARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.35', 'DEPOSITOS DE ICMS A DISTRIBUIR A ESTADOS', 'REGISTRA OS VALORES A DISTRIBUIR AOS ESTADOS RELATIVOS AOS DEPOSITOS DE ICMS IMPOSTO PELO SISTEMA SIMPLES. CUJOS OS VALORES SAO A DISTRIBUIR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.36', 'DEPOSITOS DE ISS A DISTRIBUIR A MUNICIPIOS', 'REGISTRA OS VALORES A DISTRIBUIR AOS MUNICIPIOS RELATIVOS AOS DEPOSITOS DE ISS IMPOSTO PELO SISTEMA SIMPLES. CUJOS OS VALORES SAO A DISTRIBUIR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.37', 'DEPOSITOS DO IMPOSTO SIMPLES - INSS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTO PELO SISTEMA SIMPLES, RELATIVOS AO INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.38', 'DEPOSITOS REFIS - INSS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTE AO PROGRAMA DE RECUPERACAO FISCAL (REFIS) INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.39', 'DEPOSITOS PAES INSS SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) DO INSS SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.40', 'DEPOSITOS PAES ISS SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) DO ISS SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.41', 'DEPOSITOS PAES ICMS SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003)DO ICMS SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.42', 'DEPOSITOS INSS SIMPLES NACIONAL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES A ARRECADACAO DO INSS SIMPLES NACIONAL,CONFORME LEI COMPLEMENTAR Nº 123,DE 14 DE DEZEMBRO DE 2006.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.43', 'INSS - PARCELAMENTO LEI Nº 11.941/2009', 'REGISTRA OS VALORES DECORRENTES DE DEBITOS PREVIDENCIARIOS, RELATIVOS AOS PARCELAMENTOS DE QUE TRATA A LEI Nº 11.941, DE 27 DE MAIO DE 2009.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.44', 'MULTA POR FALTA/ATRASO/ERRO/OMISSAO - GFIP', 'REGISTRA OS VALORES RELATIVOS A MULTA POR ERRO, OMISSAO, FALTA OU ATRASO NA ENTREGA DA DECLARACAO GFIP DE QUE TRATA O ART. 32A DA LEI Nº 8.212, DE 24 DE JULHO DE 1991.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.45', 'DEPOSITOS PAES PARCELAMENTO DE ARREMATACAO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) SOBRE O PARCELAMENTO DE ARREMATACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.46', 'DEPOSITOS DE TRIBUTOS A CLASSIFICAR', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) NAO CLASSIFICADOS EM CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.47', 'DEPOSITOS POR DEVOLUCAO DE VALORES NAO RECLAMADOS', 'REGISTRA OS DEPOSITOS POR DEVOLUCAO DE VALORES NAO RECLAMADOS EM DECORRENCIA DE CANCELAMENTO DE ORDEM BANCARIA, TAIS COMO: PAGAMENTO DE SERVIDOR ATIVO, INATIVO, PENSIONISTA OU DE FORNECEDORES. O VALOR DEVERA FICAR REGISTRADO ENQUANTO NAO FOR REALIZADO NOVO PAGAMENTO OU DEVERA SER CLASSIFICADO COMO RECEITA APOS DEFINICAO DA NAO REALIZACAO DO NOVO PAGAMENTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.48', 'DEPOSITOS DE TITULOS DO FIES A RECOLHER', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TITULOS DO FIES PARA RECOLHIMENTO DE TRIBUTOS FEDERAIS E CONTRIBUICOES PREVIDENCIARIAS DEVIDOS PELAS INSTITUICOES DE ENSINO, RECOLHIDOS PELO FNDE POR MEIO DO SIAFI.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.49', 'DEPOSITOS DE TERCEIROS - BACEN', 'REGISTRA OS VALORES RELATIVOS AOS DARF/GPS EMITIDOS PELO BACEN (UG 173057) A SEREM ENVIADOS PELA COFIN POR MEIO DE OBR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.50', 'DEPOSITOS NA CONTA ESPECIAL - EMPRESTIMOS EXTERNOS', 'REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS EXTERNOS DEPOSITADOS EM CONTA ESPECIAL NO BANCO DO BRASIL - ROTINA DE CONTROLE DOS EMPRESTIMOS EXTERNOS ANTES DO REGISTRO NA CONTA UNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.51', 'REMUNERACAO DEPOSITOS CONTA ESPECIAL -EMPRESTIMOS EXTERNOS', 'REGISTRA OS VALORES RELATIVOS AS REMUNERACOES DOS EMPRESTIMOS EXTERNOS DEPOSITADOS EM CONTA ESPECIAL NO BANCO DO BRASIL - ROTINA DE CONTROLE DOS EMPRESTIMOS EXTERNOS ANTES DO REGISTRO NA CONTA UNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.52', 'DEPOSITOS PARA SERVICOS DE PUBLICIDADE', 'REGISTRA OS DEPOSITOS DESTINADOS A VEICULOS DE COMUNICACAO, ORIGINARIOS DOS SERVICOS DE PUBLICIDADE CONTRATADOS POR MEIO DE AGENCIA DE PUBLICIDADE, CONFORME LEI Nº 4680, DE 18 DE JUNHO DE 1965, DECRETO Nº 57690, DE 1 DE FEVEREIRO DE 1966, DECRETO Nº 4563, DE 31 DE DEZEMBRO DE 2002 E NORMAS PADRAO DA ATIVIDADE PUBLICITARIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.53', 'PAGAMENTO / PARCELAMENTO - MP Nº 470', 'REGISTRA, CONFORME DISPOE A MEDIDA PROVISORIA Nº 470, DE 13 DE OUTUBRO DE 2009, O VALOR DECORRENTE DE PAGAMENTOS OU PARCELAMENTOS DE DEBITOS DECORRENTES DO APROVEITAMENTO INDEVIDO DO INCENTIVO FISCAL SETORIAL, INSTITUIDO PELO ART. 1º DO DECRETO-LEI Nº 491, DE 5 DE MARCO DE 1969, E OS ORIUNDOS DA AQUISICAO DE MATERIAS-PRIMAS, MATERIAL DE EMBALAGEM E PRODUTOS INTERMEDIARIOS RELACIONADOS NA TABELA DE INCIDENCIA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS - TIPI, APROVADA PELO DECRETO Nº 6.006, DE 28 DE DEZEMBRO DE 2006, COM INCIDENCIA DE ALIQUOTA ZERO OU COMO NAO TRIBUTADOS - NT.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.54', 'RECURSOS DEPOSITADOS NO BACEN', 'REGISTRA OS VALORES DEPOSITADOS NO BACEN CONFORME O ARTIGO 164 DA CONSTITUICAO FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.55', 'DEPOSITO DE RESTITUICOES DE TRIBUTOS SIEF', 'REGISTRA OS VALORES DEVOLVIDOS PELO BANCO DO BRASIL AO TESOURO NACIONAL DAS RESTITUICOES, POR LOTE, DE RECEITAS TRIBUTARIAS NAO CREDITADAS AOS CONTRIBUINTES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.56', 'DEPOSITO ITR', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE ITR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.57', 'DEPOSITOS RETIDOS PESSOAL/BENEFICIO A PAGAR', 'REGISTRA OS VALORES DE OBRIGACOES, EXIGIVEIS ATE O CURSO DO EXERCICIO SEGUINTE, DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE PESSOAL OU BENEFICIOS A PAGAR PARA POSTERIOR DESTINACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.58', 'DEPOSITOS ESPECIAIS FAT - APLICACAO EM PROJETOS - PRO-INOVACAO', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AOS RECURSOS APLICADOS EM PROJETOS PRO-INOVACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.59', 'DEPOSITOS ESPECIAIS FAT - DISPONIVEIS PARA APLICACAO - PRO-INOVACAO', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AOS RECURSOS DISPONIVEIS PARA APLICACAO EM PROJETOS PRO-INOVACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.60', 'PARCELAMENTO PARAMETRIZADO/COBRANCA INTEGRADA', 'REGISTRA O DEPOSITO DOS VALORES ARRECADADOS PELA SECRETARIA DA RECEITA FEDERAL DO BRASIL RELATIVO AO MACROPROCESSO DO CREDITO TRIBUTARIO A SEREM UTILIZADOS NO PARCELAMENTO PARAMETRIZADO E NA COBRANCA INTEGRADA (AMIGAVEL, ADMINISTRATIVA E EXECUTIVA).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.61', 'DEPOSITO DIVIDA ATIVA - ITR', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DA DIVIDA ATIVA REFERENTE AO ITR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.62', 'DEPOSITOS JUD.EXTRA-JUD ADMINISTRADOS PGF-AGU', 'REGISTRA OS DEPOSITOS JUDICIAIS E EXTRAJUDICIAIS RELATIVOS A UNIAO,FUNDOS PUBLICOS, AUTARQUIAS, FUNDACOES PUBLICAS E DEMAIS ENTIDADES FEDERAIS INTEGRANTES DOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, GERENCIADOS PELA PROCURADORIA-GERAL FEDERAL, DE QUE TRATA O DECRETO-LEI Nº 1.737, DE 20 DE DEZEMBRO DE 1979,CONFORME O DISPOSTO NO ARTIGO 3º DA LEI Nº 12.099 DE 27 DE NOVEMBRO DE 2009.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.63', 'DEPOSITO DE OUTRAS RECEITAS NAO IDENTIFICADAS', 'REGISTRA OS DEPOSITOS DE VALORES ARRECADADOS PELA SRFB E NÃO IDENTIFICADOS PELOS BANCOS, QUANDO ORIGINARIOS DE PAGAMENTOS EMITIDOS COM DOCUMENTOS DE ARRECADAÇÃO (DARF) COM CÓDIGO DE BARRAS POR SISTEMAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.64', 'REGIME TRIBUTACAO UNIFICADA RTU - IMPORTACAO', 'REGISTRA OS DEPOSITOS DE VALORES ARRECADADOS PELA SRFB, QUANDO ORIGINARIOS DE PAGAMENTOS EMITIDOS COM DOCUMENTOS DE ARRECADAÇÃO (DARF) DECORRENTE DO REGIME DE TRIBUTACAO UNIFICADA - IMPORTACAO, POR VIA TERRESTRE, DE MERCADORIAS PROCEDENTES DO PARAGUAI. BASE LEGAL: - LEI Nº 11.898, DE 8 DE JANEIRO DE 2009; - DECRETO Nº 6.956, DE 9 DE SETEMBRO DE 2009.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.65', 'CONTRIBUICAO PREVIDENCIARIA - PGTO UNIFICADO', 'REGISTRA OS DEPOSITOS DE VALORES ARRECADADOS PELA RECEITA FEDERAL DO BRASIL - RFB, QUANDO ORIGINADOS DE PAGAMENTOS EMITIDOS COM DOCUMENTOS DE ARRECADACAO (DARF) DECORRENTE DO PROGRAMA DE UNIFICACAO DOS CREDITOS RELATIVOS AA CONTRIBUICAO PREVIDENCIARIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.99', 'OUTROS DEPOSITOS', 'REGISTRA COMPROMISSOS EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, DECORRENTES DE RECEBIMENTOS A TITULO DE DEPOSITOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.05.00', 'SUBVENCOES E DOACOES PARA INVESTIMENTOS', 'REGISTRA OS VALORES EXIGIVEIS REFERENTES A SUBVENCOES E DOACOES PARA INVESTIMENTOS CONDICIONAIS, OU SEJA, QUE DEPENDAM DE FATO OU EVENTO FUTURO PARA SUA EFETIVACAO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.06.01', 'DEPOSITOS COMPULSORIOS - COMBUSTIVEIS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS REFERENTES AS AQUISICOES DE COMBUSTIVEIS POR ORGAOS, ENTIDADES, EMPRESAS E INSTITUICOES, COM DEVOLUCAO PREVISTA ATE O TERMINO DO EXERCICIO SEGUINTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.06.02', 'DEPOSITOS COMPULSORIOS - VEICULOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS REFERENTES AS AQUISICOES DE VEICULOS POR ORGAOS, ENTIDADES, EMPRESAS E INSTITUICOES, COM DEVOLUCAO PREVISTA NO CURTO PRAZO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.06.98', 'OUTROS DEPOSITOS COMPULSORIOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS, PARA OS QUAIS NAO EXISTAM CONTAS ESPECIFICAS, COM DEVOLUCAO PREVISTA NO CURTO PRAZO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.07.00', 'DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - ESTADOS/MUNICIPIOS', 'DESTINADA A ACOLHER OS VALORES DEPOSITADOS POR BLOQUEIO DE TRANSFERENCIAS CONSTITUCIONAIS A ESTADOS E MUNICIPIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.07.01', 'DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - MUNICIPIOS (FPM)', 'REGISTRA OS VALORES DE DEPOSITOS DE MUNICIPIOS, RELATIVOS A CREDITOS DE RECURSOS BLOQUEADOS DE FPM, REPASSADOS AOS MUNICIPIOS E DEVOLVIDOS A UNIAO POR MEIO DE GRU.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.07.02', 'DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - MUNICIPIOS (FUNDEF/FUNDEB)', 'REGISTRA OS VALORES DE DEPOSITOS DE MUNICIPIOS, RELATIVOS A CREDITOS DE RECURSOS BLOQUEADOS DO FUNDEF/FUNDEB POR ACAO JUDICIAL E DEPOSITADOS PELO BANCO DO BRASIL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.99.00', 'OUTROS VALORES RESTITUIVEIS', 'OUTROS VALORES RESTITUIVEIS EM POSSE DA ENTIDADE, NO PAPEL DE FIEL DEPOSITARIA.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.01', 'PSSS - VENCIMENTOS E VANTAGENS', 'REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE SERVIDORES REGIDOS PELA LEI Nº 8.112/90 A TITULO DE SEGURIDADE SOCIAL A SER RECOLHIDO AO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.02', 'INSS', 'REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE EMPREGADOS REGIDOS PELA CONSOLIDACAO DAS LEIS DO TRABALHO (CLT) OU DE SERVICOS DE TERCEIROS, A SER RECOLHIDO AO INSTITUTO NACIONAL DO SEGURO SOCIAL/PREVIDENCIA SOCIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.03', 'ENCARGOS SOCIAIS - OUTRAS ENTIDADES', 'REGISTRA O VALOR A SER RECOLHIDO A OUTRAS ENTIDADES, EM FUNCAO DE DISPOSITIVOS LEGAIS COM AS QUAIS A ENTIDADE MANTENHA CONVENIO DE ARRECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER, SEBRAE, SENAT, SESCOOP, SESC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.04', 'IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF DEVIDO AO TESOURO NACIONAL', 'REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DO IMPOSTO SOBRE A RENDA, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS OU CREDITADAS A SERVIDORES OU EMPREGADOS, SOBRE AS QUAIS INCIDA O REFERIDO IMPOSTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.05', 'INDENIZACOES E RESTITUICOES DEVIDAS AO TESOURO NACIONAL', 'REGISTRA OS VALORES RELATIVOS AS INDENIZACOES E RESTITUICOES DE TRIBUTOS COM AUTORIZACOES CONCEDIDAS, POREM NAO DEVOLVIDAS AOS LEGITIMOS CREDORES PELA ENTIDADE. REGISTRA OS VALORES A SEREM RECOLHIDOS AO TESOURO NACIONAL, A TITULO DE INDENIZACOES E RESTITUICOES DE TRIBUTOS, PROVENIENTES DE DESCONTO EM FOLHA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.06', 'IMPOSTOS E CONTRIBUICOES DIVERSOS DEVIDOS AO TESOURO NACIONAL', 'REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DE IMPOSTOS E CONTRIBUICOES DIVERSOS, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS, SOBRE OS QUAIS INCIDAM OS REFERIDOS TRIBUTOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.07', 'OUTROS TRIBUTOS DO TESOURO NACIONAL', 'REGISTRA OS VALORES RELATIVOS A OUTROS TRIBUTOS DO TESOURO NACIONAL RETIDOS PELA ENTIDADE SOBRE VALORES PAGOS OU CREDITADOS E QUE, SOBRE OS QUAIS, INCIDA O REFERIDO TRIBUTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.08', 'ICMS', 'REGISTRA OS VALORES RELATIVOS AO IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E SERVICOS RETIDOS POR FOCA DE LEGISLACAO OU POR ACORDO ENTRE AS PARTES ENVOLVIDAS NA TRANSACAO EM CONSIGNACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.09', 'ISS', 'REGISTRA OS VALORES DO IMPOSTO SOBRE SERVICOS RETIDOS EM CONSIGNACOES POR FORCA DE LEGISLACAO, CIRCUNSTANCIAS OU ACORDO ENTRE AS PARTES ENVOLVIDOS NA TRANSACAO, EM SITUACOES QUE A ENTIDADE COMO PARTE CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTARIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.11', 'IRRF/GDF', 'REGISTRA OS VALORES DO IMPOSTO DE RENDA RETIDO EM CONSIGNACOES POR FORCA DE LEGISLACAO/CONVENIOS, A SEREM REPASSADOS AO GOVERNO DO DISTRITO FEDERAL (GDF)', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.12', 'PSSS/GDF', 'REGISTRA OS VALORES DO PSSS EM CONSIGNACOES POR FORCA DE LEGISLACAO/CONVENIOS, A SEREM REPASSADOS AO GOVERNO DO DISTRITO FEDERAL (GDF).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.13', 'OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS', 'REGISTRA OS VALORES EM CONSIGNACAO RELATIVOS A OUTROS TRIBUTOS A SEREM REPASSADOS AOS ESTADOS E MUNICIPIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.14', 'PENSAO ALIMENTICIA', 'REGISTRA OS VALORES DAS RETENCOES EM FOLHA PROCEDIDAS EM PAGAMENTOS A EMPREGADOS OU A SERVIDORES, AUTORIZADOS POR ESSES OU POR DETERMINACAO JUDICIAL, A TITULO DE PENSAO ALIMENTICIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.15', 'PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA', 'REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DO PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES DE PREVIDENCIA E ASSISTENCIA MEDICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.16', 'ASSISTENCIA A SAUDE - ADMINISTRACAO PROPRIA', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, QUE SERAO ADMINISTRADOS PELO PROPRIO ORGAO/ENTIDADE PARA ASSISTENCIA A SAUDE DE SEUS SERVIDORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.17', 'RETENCOES - ENTIDADES REPRESENTATIVAS DE CLASSES', 'REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DE PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES REPRESENTATIVAS DE CLASSE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.18', 'RETENCOES - SINDICATOS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS AOS RESPECTIVOS SINDICATOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.19', 'RETENCOES - ASSOCIACOES', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS A ASSOCIACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.20', 'RETENCOES - COOPERATIVAS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS A COOPERATIVAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.21', 'RETENCOES - PLANOS DE SEGUROS', 'REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES AS CONTRIBUICOES A PLANOS DE SEGURO DE VIDA EM GRUPO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.22', 'RETENCOES - EMPRESTIMOS E FINANCIAMENTOS', 'REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR TERCEIROS, BEM COMO RETENCOES DE PARCELAS DE CONSORCIOS E SEGURADOS DO INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.23', 'RETENCAO A LOCADORES DE IMOVEIS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS E OU PAGAMENTOS A LOCADORES DE IMOVEIS A TITULO DE UTILIZACAO DE IMOVEIS FUNCIONAIS RESIDENCIAIS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.24', 'RETENCAO RELATIVA A VALE TRANSPORTE', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM RE-PASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO DE VALE-TRANSPORTE. TRATA-SE DOS VALORES REFERENTES AOS 6% INSTITUIDOS PELO ARTIGO 9º DO DECRETO Nº 95.247/1987 E SUAS ALTERACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.25', 'RETENCAO RELATIVA A VALE ALIMENTACAO', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO DE CARTAO-ALIMENTACAO/REFEICAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.26', 'SERVICOS DE PROCESSAMENTO DE DADOS', 'REGISTRA O VALOR TOTAL DA ARRECADACAO DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VALORES DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.99', 'OUTROS CONSIGNATARIOS', 'REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, EM CONFIANCA, POR DIVERSOS CONTRIBUINTES SUJEITOS A RECOLHIMENTOS E OU PAGAMENTOS AOS FAVORECIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.02.00', 'GARANTIAS', 'COMPREENDE A GARANTIA DO CUMPRIMENTO DE UMA OBRIGACAO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENCOES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.03.02', 'DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL', 'REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS RECEBIDOS PELA ENTIDADE POR DETERMINACAO JUDICIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.03.04', 'DEPOSITOS RECEBIDOS PARA RECURSOS JUDICIAIS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS RECEBIDOS PELA ENTIDADE RELATIVOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.01', 'DEPOSITOS E CAUCOES A EFETUAR', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS REFERENTES A DEPOSITOS E/OU CAUCOES A EFETUAR PELA ENTIDADE VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.02', 'DEPOSITOS E CAUCOES RECEBIDOS', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS E/OU CAUCOES PELA ENTIDADE VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.03', 'DEPOSITOS A EFETUAR PARA RECURSOS ADMINISTRATIVOS', 'REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS A EFETUAR PELA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO ADMINISTRATIVO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.04', 'DEPOSITOS RECEBIDOS PARA RECURSOS ADMINISTRATIVOS', 'REGISTRA OS VALORES RELATIVOS A DEPOSITOS RECEBIDOS PELA ENTIDADE RELATIVOS AO EXERCICIO DE DIREITO DE RECURSO ADMINISTRATIVO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.05', 'DEPOSITOS ESPECIAIS', 'REGISTRA O VALOR RELATIVO A RETENCOES DE DEPOSITOS VINCULADOS A RESTITUIR NO CURSO DO EXERCICIO SEGUINTE A ENTIDADE TRANSFERIDORA, DECORRENTE DE CONTRATOS OU INSTRUMENTOS CONGENERES, CONVENCAO, ACORDO OU AJUSTE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.06', 'DEPOSITOS RETIDOS DE FORNECEDORES', 'REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE FORNECEDORES EM FUNCAO DE APLICACAO DE MULTAS E OUTRAS DETERMINACOES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.07', 'DEPOSITOS DE VEICULOS ALIENAVEIS', 'REGISTRA O VALOR DOS RECEBIMENTOS PROVENIENTES DA ALIENACAO DE VEICULOS REMOVIDOS, RECOLHIDOS OU APREENDIDOS DE ACORDO COM A RESOLUCAO DO CONTRAN Nº 178/2005, PENDENTES DE TRANSFERENCIAS DIVERSAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.08', 'DEPOSITOS A TRANSFERIR', 'REGISTRA OS VALORES DAS RETENCOES DE DEPOSITOS DE DIVERSAS ORIGENS RECEBIDOS POR UG CENTRAL CUJA DEVOLUCAO DEVE SER REALIZADA NO CURSO DO EXERCICIO SEGUINTE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.09', 'DEPOSITOS DE TERCEIROS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TERCEIROS DE DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NAO RECLAMADOS PELOS CREDORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.10', 'DEPOSITOS A DISTRIBUIR', 'REGISTRA OS DEPOSITOS DECORRENTES DA FITA 50, RELACIONADOS COM A FONTE 0150025074 QUE E DESTINADA 80% PARA O CODIGO 07401 E 20% PARA O CODIGO 07402 (DESVINCULACAO DE RRECEITAS DA UNIAO - DRU) E AINDA AS APROPRIACOES REFERENTES A DEVOLUCAO DO PSSS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.11', 'DEPOSITOS DE ENTIDADES', 'REGISTRA O VALOR DAS CONTRIBUICOES COM ENTIDADES TERCEIRAS TAIS COMO: SESI, SENAI, SESC, ETC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.12', 'DEPOSITOS DE RENDIMENTOS DO PIS/PASEP', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RENDIMENTOS DO PIS/PASEP PARA CREDITO EM FOLHA DE PAGAMENTO AOS SERVIDORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.13', 'DEPOSITOS DO ITR E CONTRIBUICOES RURAIS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL (ITR) E OUTRAS CONTRIBUICOES RURAIS PARA DISTRIBUICAO AOS BENEFICIARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.14', 'CONTRIBUICOES RURAIS A DISTRIBUIR', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES RURAIS CLASSIFICADAS E AINDA NAO DISTRIBUIDAS AOS BENEFICIARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.15', 'DEPOSITOS A DISTRIBUIR DO SALARIO-EDUCACAO', 'REGISTRA OS DEPOSITOS DECORRENTES DA ARRECADACAO DO SALARIO-EDUCACAO, PROVENIENTES DO DOCUMENTO GUIA DO SALARIO-EDUCACAO (GSE).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.16', 'DEPOSITOS DO FAT - PMC', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AO PROGRAMA PARA MELHORIA DA COMPETITIVIDADE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.17', 'DEPOSITOS DO FAT PRO-INOVACAO', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AO PROGRAMA PRO-INOVACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.18', 'DEPOSITOS PARA IMPORTACOES - PESQUISA CIENTIFICA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE ENTIDADES SEM FINS LUCRATIVOS ATIVAS NO FOMENTO, NA COORDENACAO OU NA EXECUCAO DE PROGRAMAS DE PESQUISA CIENTIFICA E TECNOLOGICA OU DE ENSINO, PARA A REALIZACAO DE IMPORTACOES DE BENS DESTINADOS A PESQUISA CIENTIFICA E TECNOLOGICA. BASE LEGAL: LEI Nº 8.010/1990.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.19', 'DEPOSITOS ISS A DISTRIBUIR - DAR SUBSTITUICAO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DO IMPOSTO SOBRE SERVICOS (ISS) - RECOLHIDOS POR DAR SUBSTITUICAO - A DISTRIBUIR PARA OS MUNICIPIOS PARTICIPANTES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.20', 'DEPOSITOS DAS RETENCOES DE IMPOSTOS DO SIMPLES PELOS ORGAOS PUBLICOS', 'REGISTRA OS VALORES A CLASSIFICAR RELATIVOS AOS DEPOSITOS DE IMPOSTOS E CONTRIBUICOES PELO SISTEMA SIMPLES. CUJOS VALORES SAO A CLASSIFICAR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.21', 'DEPOSITO DE IMPOSTOS DO SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTOS E CONTRIBUICOES PELO SISTEMA SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.22', 'PROGRAMA DE RECUPERACAO FISCAL - REFIS', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DO SEGURO SOCIAL (INSS).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.23', 'CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA ARRECADACAO DA CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO REGISTRADA PELA FITA 50 DA SECRETARIA DA RECEITA FEDERAL DO BRASIL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.24', 'DEPOSITOS DE RETENCOES DE CONTRIBUICOES SOBRE PAGAMENTO A PESSOA JURIDICA', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RETENCOES DE CONTRIBUICOES SOBRE PAGAMENTOS DE PESSOA JURIDICA A PESSOA JURIDICA DE DIREITO PRIVADO (CSLL, COFINS, PIS/PASEP), Lei nº 10.833/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.25', 'DEPOSITOS DO REGIME ESPECIAL TRIBUTARIO DO PATRIMONIO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO REGIME ESPECIAL DE TRIBUTACAO DO PATRIMONIO DE AFETACAO DE INCORPORACOES IMOBILIARIAS , INSTITUIDO PELA LEI Nº 10.931/2004.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.26', 'DEPOSITOS DE RETENCOES DE CONTRIBUICOES S/PAGAMENTO DE ESTADOS/DF/MUNICIPIOS A PESSOAS JURIDICAS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES ASS RETENCOES DE CONTRIBUICOES (CSLL, COFINS, PIS/PASEP) SOBRE PAGAMENTOS A PESSOA JURIDICA DE DIREITO PRIVADO PELOS ESTADOS OU MUNICIPIOS, DE ACORDO COM ART. 31 E 33 DA LEI Nº 10.833/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.27', 'PARCELAMENTO ESPECIAL PAES', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DO SEGURO SOCIAL (INSS), INSTITUIDO PELA LEI Nº 10.684/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.28', 'PARCELAMENTO MP Nº 303/2006 - PAEX', 'REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DE SEGURIDADE SOCIAL - INSS, CONFORME MEDIDA PROVISORIA Nº Nº 303/2006.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.29', 'PARCELAMENTO PARA INGRESSO NO SIMPLES NACIONAL', 'REGISTRA O VALOR DOS RECURSOS DE PARCELAMENTO DE DEBITOS COM O INSS OU COM AS FAZENDAS PUBLICAS FEDERAL, ESTADUAL OU MUNICIPAL PARA INGRESSO NO PROGRAMA SIMPLES NACIONAL, CONFORME LEI COMPLEMENTAR Nº 123/2006 - ART. 79.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.30', 'PARCELAMENTO TIMEMANIA', 'REGISTRA O VALOR DAS RECEITAS ARRECADADAS DECORRENTES DA RENEGOCIACAO DE DIVIDAS DE ENTIDADES DESPORTIVAS JUNTO A PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), CONFORME LEI Nº 11.345/2006, ALTERADA PELA LEI Nº 11.505/2007.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.31', 'PARCELAMENTO FIES - LEI Nº 10.260/2001', 'REGISTRA O VALOR DAS RECEITAS ARRECADADAS DECORRENTES DE PARCELAMENTO DE TRIBUTOS ADMINISTRADOS PELA RECEITA FEDERAL DO BRASIL - RFB TENDO COMO SUJEITO PASSIVO AS PESSOAS JURIDICAS DE DIREITO PRIVADO MANTENEDORAS DE INSTITUICOES DE ENSINO SUPERIOR QUE POSSUEM OS CERTIFICADOS DE EMISSAO DO TESOURO NACIONAL E OPTARAM PELO PARCELAMENTO, DESDE QUE TODAS AS INSTITUICOES MANTIDAS TENHAM ADERIDO AO PROGRAMA UNIVERSIDADE PARA TODOS (PROUNI). BASE LEGAL: LEI 10.260/2001, ART. 10, §§ 3º E 5º (REDACAO DADA PELA LEI 11.552/2007).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.32', 'PARCELAMENTO MP Nº 449/2008', 'REGISTRA O VALOR DOS RECURSOS DECORRENTE DE PARCELAMENTO DE DIVIDAS DE PEQUENO VALOR COM A FAZENDA NACIONAL E DIVIDAS DECORRENTES DE APROVEITAMENTO INDEVIDO DE CREDITOS DE IPI, CONFORME DISPOE A A MEDIDA PROVISORIA Nº 449, DE 03 DE DEZEMBRO DE 2008 LEI Nº 11.941/2009', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.33', 'PARCELAMENTO DE ARREMATACAO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TRIBUTOS A CLASSIFICAR PROVENIENTES DO PARCELAMENTO DE VALOR CORRESPONDENTE A ARREMATACAO DE BEM EM HASTA PUBLICA NAS EXECUCOES FISCAIS PROMOVIDAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN) (PORTARIA 262 DE 11/06/2002).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.34', 'PARCELAMENTO - DEMAIS DEBITOS - LEI Nº 11.941/2009', 'REGISTRA OS VALORES RELATIVOS AOS PARCELAMENTOS DE QUE TRATA A LEI Nº 11.941/2009, EXCETO OS DECORRENTES DE DEBITOS PREVIDENCIARIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.35', 'DEPOSITOS DE ICMS A DISTRIBUIR A ESTADOS', 'REGISTRA OS VALORES A DISTRIBUIR AOS ESTADOS RELATIVOS AOS DEPOSITOS DE ICMS IMPOSTO PELO SISTEMA SIMPLES. CUJOS OS VALORES SAO A DISTRIBUIR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.36', 'DEPOSITOS DE ISS A DISTRIBUIR A MUNICIPIOS', 'REGISTRA OS VALORES A DISTRIBUIR AOS MUNICIPIOS RELATIVOS AOS DEPOSITOS DE ISS IMPOSTO PELO SISTEMA SIMPLES. CUJOS OS VALORES SAO A DISTRIBUIR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.37', 'DEPOSITOS DO IMPOSTO SIMPLES - INSS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTO PELO SISTEMA SIMPLES, RELATIVOS AO INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.38', 'DEPOSITOS REFIS - INSS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTE AO PROGRAMA DE RECUPERACAO FISCAL (REFIS) INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.39', 'DEPOSITOS PAES INSS SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) DO INSS SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.40', 'DEPOSITOS PAES ISS SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) DO ISS SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.41', 'DEPOSITOS PAES ICMS SIMPLES', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003)DO ICMS SIMPLES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.42', 'DEPOSITOS INSS SIMPLES NACIONAL', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES A ARRECADACAO DO INSS SIMPLES NACIONAL,CONFORME LEI COMPLEMENTAR Nº 123,DE 14 DE DEZEMBRO DE 2006.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.43', 'INSS - PARCELAMENTO LEI Nº 11.941/2009', 'REGISTRA OS VALORES DECORRENTES DE DEBITOS PREVIDENCIARIOS, RELATIVOS AOS PARCELAMENTOS DE QUE TRATA A LEI Nº 11.941, DE 27 DE MAIO DE 2009.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.44', 'MULTA POR FALTA/ATRASO/ERRO/OMISSAO - GFIP', 'REGISTRA OS VALORES RELATIVOS A MULTA POR ERRO, OMISSAO, FALTA OU ATRASO NA ENTREGA DA DECLARACAO GFIP DE QUE TRATA O ART. 32A DA LEI Nº 8.212, DE 24 DE JULHO DE 1991.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.45', 'DEPOSITOS PAES PARCELAMENTO DE ARREMATACAO', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) SOBRE O PARCELAMENTO DE ARREMATACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.46', 'DEPOSITOS DE TRIBUTOS A CLASSIFICAR', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) NAO CLASSIFICADOS EM CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.47', 'DEPOSITOS POR DEVOLUCAO DE VALORES NAO RECLAMADOS', 'REGISTRA OS DEPOSITOS POR DEVOLUCAO DE VALORES NAO RECLAMADOS EM DECORRENCIA DE CANCELAMENTO DE ORDEM BANCARIA, TAIS COMO: PAGAMENTO DE SERVIDOR ATIVO, INATIVO, PENSIONISTA OU DE FORNECEDORES. O VALOR DEVERA FICAR REGISTRADO ENQUANTO NAO FOR REALIZADO NOVO PAGAMENTO OU DEVERA SER CLASSIFICADO COMO RECEITA APOS DEFINICAO DA NAO REALIZACAO DO NOVO PAGAMENTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.48', 'DEPOSITOS DE TITULOS DO FIES A RECOLHER', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TITULOS DO FIES PARA RECOLHIMENTO DE TRIBUTOS FEDERAIS E CONTRIBUICOES PREVIDENCIARIAS DEVIDOS PELAS INSTITUICOES DE ENSINO, RECOLHIDOS PELO FNDE POR MEIO DO SIAFI.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.49', 'DEPOSITOS DE TERCEIROS - BACEN', 'REGISTRA OS VALORES RELATIVOS AOS DARF/GPS EMITIDOS PELO BACEN (UG 173057) A SEREM ENVIADOS PELA COFIN POR MEIO DE OBR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.50', 'DEPOSITOS NA CONTA ESPECIAL - EMPRESTIMOS EXTERNOS', 'REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS EXTERNOS DEPOSITADOS EM CONTA ESPECIAL NO BANCO DO BRASIL - ROTINA DE CONTROLE DOS EMPRESTIMOS EXTERNOS ANTES DO REGISTRO NA CONTA UNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.51', 'REMUNERACAO DEPOSITOS CONTA ESPECIAL -EMPRESTIMOS EXTERNOS', 'REGISTRA OS VALORES RELATIVOS AS REMUNERACOES DOS EMPRESTIMOS EXTERNOS DEPOSITADOS EM CONTA ESPECIAL NO BANCO DO BRASIL - ROTINA DE CONTROLE DOS EMPRESTIMOS EXTERNOS ANTES DO REGISTRO NA CONTA UNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.52', 'DEPOSITOS PARA SERVICOS DE PUBLICIDADE', 'REGISTRA OS DEPOSITOS DESTINADOS A VEICULOS DE COMUNICACAO, ORIGINARIOS DOS SERVICOS DE PUBLICIDADE CONTRATADOS POR MEIO DE AGENCIA DE PUBLICIDADE, CONFORME LEI Nº 4680, DE 18 DE JUNHO DE 1965, DECRETO Nº 57690, DE 1 DE FEVEREIRO DE 1966, DECRETO Nº 4563, DE 31 DE DEZEMBRO DE 2002 E NORMAS PADRAO DA ATIVIDADE PUBLICITARIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.53', 'PAGAMENTO / PARCELAMENTO - MP Nº 470', 'REGISTRA, CONFORME DISPOE A MEDIDA PROVISORIA Nº 470, DE 13 DE OUTUBRO DE 2009, O VALOR DECORRENTE DE PAGAMENTOS OU PARCELAMENTOS DE DEBITOS DECORRENTES DO APROVEITAMENTO INDEVIDO DO INCENTIVO FISCAL SETORIAL, INSTITUIDO PELO ART. 1º DO DECRETO-LEI Nº 491, DE 5 DE MARCO DE 1969, E OS ORIUNDOS DA AQUISICAO DE MATERIAS-PRIMAS, MATERIAL DE EMBALAGEM E PRODUTOS INTERMEDIARIOS RELACIONADOS NA TABELA DE INCIDENCIA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS - TIPI, APROVADA PELO DECRETO Nº 6.006, DE 28 DE DEZEMBRO DE 2006, COM INCIDENCIA DE ALIQUOTA ZERO OU COMO NAO TRIBUTADOS - NT.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.54', 'RECURSOS DEPOSITADOS NO BACEN', 'REGISTRA OS VALORES DEPOSITADOS NO BACEN CONFORME O ARTIGO 164 DA CONSTITUICAO FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.55', 'DEPOSITO DE RESTITUICOES DE TRIBUTOS SIEF', 'REGISTRA OS VALORES DEVOLVIDOS PELO BANCO DO BRASIL AO TESOURO NACIONAL DAS RESTITUICOES, POR LOTE, DE RECEITAS TRIBUTARIAS NAO CREDITADAS AOS CONTRIBUINTES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.56', 'DEPOSITO ITR', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE ITR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.57', 'DEPOSITOS RETIDOS PESSOAL/BENEFICIO A PAGAR', 'REGISTRA OS VALORES DE OBRIGACOES, EXIGIVEIS ATE O CURSO DO EXERCICIO SEGUINTE, DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE PESSOAL OU BENEFICIOS A PAGAR PARA POSTERIOR DESTINACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.58', 'DEPOSITOS ESPECIAIS FAT - APLICACAO EM PROJETOS - PRO-INOVACAO', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AOS RECURSOS APLICADOS EM PROJETOS PRO-INOVACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.59', 'DEPOSITOS ESPECIAIS FAT - DISPONIVEIS PARA APLICACAO - PRO-INOVACAO', 'REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AOS RECURSOS DISPONIVEIS PARA APLICACAO EM PROJETOS PRO-INOVACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.60', 'PARCELAMENTO PARAMETRIZADO/COBRANCA INTEGRADA', 'REGISTRA O DEPOSITO DOS VALORES ARRECADADOS PELA SECRETARIA DA RECEITA FEDERAL DO BRASIL RELATIVO AO MACROPROCESSO DO CREDITO TRIBUTARIO A SEREM UTILIZADOS NO PARCELAMENTO PARAMETRIZADO E NA COBRANCA INTEGRADA (AMIGAVEL, ADMINISTRATIVA E EXECUTIVA).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.61', 'DEPOSITO DIVIDA ATIVA - ITR', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DA DIVIDA ATIVA REFERENTE AO ITR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.62', 'DEPOSITOS JUD.EXTRA-JUD ADMINISTRADOS PGF-AGU', 'REGISTRA OS DEPOSITOS JUDICIAIS E EXTRAJUDICIAIS RELATIVOS A UNIAO,FUNDOS PUBLICOS, AUTARQUIAS, FUNDACOES PUBLICAS E DEMAIS ENTIDADES FEDERAIS INTEGRANTES DOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, GERENCIADOS PELA PROCURADORIA-GERAL FEDERAL, DE QUE TRATA O DECRETO-LEI Nº 1.737, DE 20 DE DEZEMBRO DE 1979,CONFORME O DISPOSTO NO ARTIGO 3º DA LEI Nº 12.099 DE 27 DE NOVEMBRO DE 2009.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.63', 'DEPOSITO DE OUTRAS RECEITAS NAO IDENTIFICADAS', 'REGISTRA OS DEPOSITOS DE VALORES ARRECADADOS PELA SRFB E NÃO IDENTIFICADOS PELOS BANCOS, QUANDO ORIGINARIOS DE PAGAMENTOS EMITIDOS COM DOCUMENTOS DE ARRECADAÇÃO (DARF) COM CÓDIGO DE BARRAS POR SISTEMAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.64', 'REGIME TRIBUTACAO UNIFICADA RTU - IMPORTACAO', 'REGISTRA OS DEPOSITOS DE VALORES ARRECADADOS PELA SRFB, QUANDO ORIGINARIOS DE PAGAMENTOS EMITIDOS COM DOCUMENTOS DE ARRECADAÇÃO (DARF) DECORRENTE DO REGIME DE TRIBUTACAO UNIFICADA - IMPORTACAO, POR VIA TERRESTRE, DE MERCADORIAS PROCEDENTES DO PARAGUAI. BASE LEGAL: - LEI Nº 11.898, DE 8 DE JANEIRO DE 2009; - DECRETO Nº 6.956, DE 9 DE SETEMBRO DE 2009.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.65', 'CONTRIBUICAO PREVIDENCIARIA - PGTO UNIFICADO', 'REGISTRA OS DEPOSITOS DE VALORES ARRECADADOS PELA RECEITA FEDERAL DO BRASIL - RFB, QUANDO ORIGINADOS DE PAGAMENTOS EMITIDOS COM DOCUMENTOS DE ARRECADACAO (DARF) DECORRENTE DO PROGRAMA DE UNIFICACAO DOS CREDITOS RELATIVOS AA CONTRIBUICAO PREVIDENCIARIA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.99', 'OUTROS DEPOSITOS', 'REGISTRA COMPROMISSOS EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, DECORRENTES DE RECEBIMENTOS A TITULO DE DEPOSITOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.05.00', 'SUBVENCOES E DOACOES PARA INVESTIMENTOS', 'REGISTRA OS VALORES EXIGIVEIS REFERENTES A SUBVENCOES E DOACOES PARA INVESTIMENTOS CONDICIONAIS, OU SEJA, QUE DEPENDAM DE FATO OU EVENTO FUTURO PARA SUA EFETIVACAO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.06.01', 'DEPOSITOS COMPULSORIOS - COMBUSTIVEIS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS REFERENTES AS AQUISICOES DE COMBUSTIVEIS POR ORGAOS, ENTIDADES, EMPRESAS E INSTITUICOES, COM DEVOLUCAO PREVISTA ATE O TERMINO DO EXERCICIO SEGUINTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.06.02', 'DEPOSITOS COMPULSORIOS - VEICULOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS REFERENTES AS AQUISICOES DE VEICULOS POR ORGAOS, ENTIDADES, EMPRESAS E INSTITUICOES, COM DEVOLUCAO PREVISTA NO CURTO PRAZO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.06.98', 'OUTROS DEPOSITOS COMPULSORIOS', 'REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS, PARA OS QUAIS NAO EXISTAM CONTAS ESPECIFICAS, COM DEVOLUCAO PREVISTA NO CURTO PRAZO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.07.00', 'DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - ESTADOS/MUNICIPIOS', 'DESTINADA A ACOLHER OS VALORES DEPOSITADOS POR BLOQUEIO DE TRANSFERENCIAS CONSTITUCIONAIS A ESTADOS E MUNICIPIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.07.01', 'DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - MUNICIPIOS (FPM)', 'REGISTRA OS VALORES DE DEPOSITOS DE MUNICIPIOS, RELATIVOS A CREDITOS DE RECURSOS BLOQUEADOS DE FPM, REPASSADOS AOS MUNICIPIOS E DEVOLVIDOS A UNIAO POR MEIO DE GRU.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.07.02', 'DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - MUNICIPIOS (FUNDEF/FUNDEB)', 'REGISTRA OS VALORES DE DEPOSITOS DE MUNICIPIOS, RELATIVOS A CREDITOS DE RECURSOS BLOQUEADOS DO FUNDEF/FUNDEB POR ACAO JUDICIAL E DEPOSITADOS PELO BANCO DO BRASIL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.99.00', 'OUTROS VALORES RESTITUIVEIS', 'OUTROS VALORES RESTITUIVEIS EM POSSE DA ENTIDADE, NO PAPEL DE FIEL DEPOSITARIA.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.01.01', 'INDENIZACOES A SERVIDORES', 'REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.01.02', 'INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.01.03', 'INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.01.04', 'RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS', 'REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS EFETIVADAS PELAS UG DO INSS, A SEREM PAGAS ATRAVES DE OB.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.02.00', 'DIARIAS A PAGAR', 'REGISTRA OS VALORES RELATIVOS AS DIARIAS A PAGAR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.03.00', 'SUPRIMENTOS DE FUNDOS A PAGAR', 'REGISTRA OS VALORES RELATIVOS AOS SUPRIMENTOS DE FUNDOS A PAGAR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.04.01', 'SALARIO-FAMILIA A PAGAR', 'REGISTRA OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM O DESEMBOLSO A TITULO DE SALARIO FAMILIA A SEUS EMPREGADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.04.02', 'AUXILIO - NATALIDADE A PAGAR', 'REGISTRA OS VALORES A SEREM PAGOS PELO INSS, A TITULO DE REEMBOLSO DO AUXILIO-NATALIDADE PAGO PELAS ENTIDADES A SEUS EMPREGADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.04.03', 'DEBITOS EM APURACAO - INSS', 'REGISTRA OS VALORES EM APURACAO A SEREM RESSARCIDOS PELO INSS A ENTIDADES, DECORRENTES DE PAGAMENTOS OU ANTECIPACOES EFETUADAS POR ESTAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.04.04', 'DEBITOS POR PREMIOS DE SEGURO - COMPREENSIVO - INSS', 'REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS AS COMPANHIAS SEGURADORAS, POR PREMIOS DE SEGURO PAGOS A MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO - LEI Nº 4380/64.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.04.99', 'OUTROS DEBITOS POR INDENIZACAO E ANTECIPACOES - INSS', 'REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS POR PAGAMENTOS OU ANTECIPACOES REALIZADAS POR ENTIDADES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.05.01', 'CONVENIOS A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.05.02', 'CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.06.01', 'CONVENIOS A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DO EXERCICIO, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.06.02', 'CONVENIOS A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DE EXERCICIOS ANTERIORES, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.07.01', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.07.02', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.08.01', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.08.02', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.09.01', 'TERMOS DE PARCERIA A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.09.02', 'TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.10.01', 'TERMOS DE PARCERIA A PAGAR DO EXERCICIO - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.10.02', 'TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.11.01', 'TERMO DE COMPROMISSO A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.11.02', 'TERMO DE COMPROMISSO A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.12.00', 'TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS -PORTAL', 'COMPREENDE OS VALORES DEVOLVIDOS REFERENTES A TRANSFERENCIAS VOLUNTARIAS FIRMADAS - CONVENIOS E CONTRATOS DE REPASSE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.13.01', 'PRECATORIOS DE TERCEIROS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.13.02', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.13.03', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000', 'REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.14.01', 'COMPENSACAO PREVIDENCIARIA DO EXERCICIO', 'REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.14.02', 'COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES', 'REGISTRA O VALOR DAS OBRIGACOES DE EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.15.00', 'TAXA DE FISCALIZACAO DE FUNCIONAMENTO - TFF', 'REGISTRA AS OBRIGACOES REFERENTES A TAXA DE FISCALIZACAO DE FUNCIONAMENTO - (TFF).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.16.00', 'OPERACOES COM DERIVATIVOS', 'REGISTRA AS OBRIGACOES DECORRENTES DE OPERACOES COM DERIVATIVOS REALIZADAS PELO BANCO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.17.00', 'DESPESAS ADMINISTRATIVAS - FUNDOS CONSTITUCIONAIS DE FINANCIAMENTO', 'REGISTRA AS OBRIGACOES DECORRENTES DE DESPESAS ADMINISTRATIVAS DOS FUNDOS CONSTITUCIONAIS DE FINANCIAMENTO, TAIS COMO TAXAS DE ADMINISTRACAO PAGAS AS INSTITUICOES FINANCEIRAS, REMUNERACAO DE AGENTES ETC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.18.00', 'DIVIDAS COM RESSARCIMENTO / COMISSOES - FMM', 'REGISTRA OS VALORES DAS OBRIGACOES COM DESPESAS DE RESSARCIMENTOS E COMISSOES DO FUNDO MARINHA MERCANTE, DEVIDAS AS EMPRESAS MARITIMAS E BNDES RESPECTIVAMENTE, MAS QUE AINDA NAO POSSUEM AUTORIZACAO LEGISLATIVA PARA EXECUCAO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.19.01', 'BOLSAS DE ESTUDOS - EXERCICIO', 'REGISTRA AS OBRIGACOES DO EXERCICIO RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.19.02', 'BOLSAS DE ESTUDOS - EXERCICIOS ANTERIORES', 'REGISTRA AS OBRIGACOES DE EXERCICIOS ANTERIORES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.20.00', 'CONTRATOS DE GESTAO', 'REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.21.00', 'SERVICOS EVENTUAIS - PESSOAL TECNICO', 'REGISTRA AS OBRIGACOES COM PESSOAL TECNICO CONTRATADO POR TEMPO DETERMINADO PARA DESEMPENHO DE TECNICAS ESPECIALIZADAS EM AMBITO DE PROJETOS DE COOPERACAO NOS TERMOS DA LEI Nº 8.745/93 CONFORME DECRETO Nº 4.748/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.22.01', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO', 'REGISTRA OS VALORES DO EXERCICIO EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.22.02', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO ANTERIOR', 'REGISTRA OS VALORES DE EXERCICIOS ANTERIORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.23.01', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.23.02', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO ANTERIOR', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.24.00', 'RESIDUOS DE CONTRATOS LIQUIDADOS - FCVS', 'REGISTRA AS OBRIGACOES DECORRENTES DA COBERTURA FINANCEIRA, PELO FCVS,DOS CONTRATOS LIQUIDADOS PELOS ADQUIRENTES POR DECURSO DE PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.01', 'MERENDA ESCOLAR - PNAE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ALIMENTACAO ESCOLAR - PNAE, COM OBJETIVO DE PRESTAR ASSISTENCIA FINANCEIRA, EM CARATER SUPLEMENTAR AS ESCOLAS PUBLICAS DE ENSINO FUNDAMENTAL DAS REDES ESTADUAIS, MUNICIPAIS E DO DISTRITO FEDERAL E AS ESCOLAS DE EDUCACAO ESPECIAL QUALIFICADAS COMO ENTIDADES FILANTROPICAS OU POR ELAS MANTIDAS. A ASSISTENCIA FINANCEIRA A SER CONCEDIDA A CADA ESTABELECIMENTO DE ENSINO BENEFICIARIO SERA DEFINIDA ANUALMENTE E TERA COMO BASE O NUMERO DE ALUNOS MATRICULADOS NO ENSINO FUNDAMENTAL E ESPECIAL, DE ACORDO COM DADOS EXTRAIDOS DO CENSO ESCOLAR REALIZADO PELO MINISTERIO DA EDUCACAO NO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.02', 'DINHEIRO DIRETO NA ESCOLA - PDDE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE), DESTINADOS AS ESCOLAS DE EDUCACAO ESPECIAL,QUALIFICADAS COMO ENTIDADES FILANTROPICAS OU POR ELAS MANTIDAS PARA COBERTURA DE DESPESA COM CUSTEIO, MANUTENCAO E PEQUENOS INVESTIMENTOS, CONFORME RESOLUCAO CD/FNDE N 04/2003. .', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.03', 'TRANSPORTE ESCOLAR - PNTE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DE TRANSPORTE ESCOLAR (PNTE), CONFORME RESOLUCAO CD/FNDE Nº 09/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.04', 'FUNDO MANUTENCAO E DESENVOLVIMENTO DO ENSINO FUNDAMENTAL - FUNDEF', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DO ENSINO FUNDAMENTAL E VALORIZACAO DO MAGISTERIO - FUNDEF, LEI 9.424/96', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.05', 'FUNDO DE FORTALECIMENTO DA ESCOLA- FUNDESCOLA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA FUNDO DE FORTALECIMENTO DA ESCOLA - FUNDESCOLA, PARA FINANCIAMENTO DE PROJETOS EDUCACIONAIS A ORGAOS OU ENTIDADES FEDERAIS, ESTADUAIS E MUNICIPAIS, CUJAS AS ACOES ESTEJAM VOLTADAS PARA O DESENVOLVIMENTO DO ENSINO PUBLICO FUNDAMENTAL REGULAR EM ZONAS DE ATENDIMENTO PRIORITARIO DOS ESTADOS DO NORTE, NORDESTE E CENTRO-OESTE. RESOLUCAO CD/FNDE Nº 10/2002', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.06', 'QUOTA ESTADUAL - SALARIO EDUCACAO', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO A QUOTA ESTADUAL DO SALARIO EDUCACAO, CONFORME LEI Nº 9.766/98.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.07', 'EDUCACAO DE JOVENS E ADULTOS - EJA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS VISANDO ATENDER AO PROGRAMA DE EDUCACAO DE JOVENS E ADULTOS(EJA), OS QUAIS SERAO DESTINADOS A AMPLIACAO DA OFERTA DE VAGAS NA EDUCACAO FUNDAMENTAL CUJOS BENEFICIARIOS SAO ALUNOS DA ESCOLA PUBLICA ESTADUAL E MUNICIPAL DO ENSINO FUNDAMENTAL, MATRICULADOS NOS CURSOS DA MODALIDADE "SUPLETIVO PRESENCIAL COM AVALIACAO NO PROCESSO". RESOLUCAO CD/FNDE N.05/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.08', 'PROGRAMA DE ATENDIMENTO EDUCACIONAL AS PESSOAS PORTADORES DE DEFICIENCIA - PAED', 'REGISTRA OS VALORES AS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DE ATENDIMENTO EDUCACIONAL ESPECIALIZADO AS PESSOAS PORTADORAS DE DEFICIENCIA - PAED - INSTITUIDA PELA LEI Nº 10.845/2004.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.09', 'BOLSA PROGRAMA FORMACAO INICIAL E CONTINUADA', 'REGISTRA OS VALORES REFERENTES A REPASSES DE BENEFICIOS DO PROGRAMA BOLSA ESCOLA, CONFORME LEI Nº 10.219/2001.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.10', 'APOIO AO TRANSPORTE DO ESCOLAR - PNATE', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO TRANSPORTE DO ESCOLAR - PNATE CONFORME MP Nº 173/2004, DOU 17/03/04', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.11', 'APOIO A EDUCACAO DE JOVENS E ADULTOS - PEJA', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO A EDUCACAO DE JOVENS E ADULTOS - PEJA - CONFORME MP Nº 173/2004, DOU 17/03/04.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.12', 'PROGRAMA BRASIL ALFABETIZADO - CONVENIOS', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI Nº 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). ESTA CONTA E UTILIZADA PARA CONVENIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.13', 'DINHEIRO DIRETO NA ESCOLA - PDDEF/PAPE', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE) DO PROJETO DE ADEQUACAO DE PREDIOS ESCOLARES DO FUNDESCOLA - PDDEF/PAPE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.14', 'DINHEIRO DIRETO NA ESCOLA - PDDEF/PME', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE) DO PROJETO DE MELHORIA DA ESCOLA DO FUNDESCOLA - PDDEF/PME.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.15', 'BOLSA ESCOLA DE FABRICA', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA E A LEI Nº 11.273, DE 06 DE FEVEREIRO DE 2006, QUE ATUALIZA A CONCESSAO DE BOLSA DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.16', 'FORMACAO DE PROFESSORES', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA FORMACAO DE PROFESSORES (LEIS 11.180,23/9/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.17', 'PROINFANTIL', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA(PROINFANTIL) (LEIS 11.180, DE 23 /09/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.18', 'PROFORMACAO', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA (PROFORMACAO) LEIS 11.180, DE 23/09/05, E A LEI 11.273, DE 06/02/06, QUE AUTORIZA A CONCESSAO DE BOLSA DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.19', 'PROLICENCIATURA', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA (PROLICENCIATURA) (LEIS 11.180, DE23/9/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.20', 'PROGRAMA UNIVERSIDADE ABERTA DO BRASIL', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA UNIVERSIDADE ABERTA DO BRASIL - CONFORME DECRETO Nº 5.800 DE 08JUN2006. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.21', 'BOLSAS BRASIL ALFABETIZADO', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). (UTILIZADA PARA BOLSAS).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.22', 'PROGRAMA BRASIL ALFABETIZADO - TRANSF. AUTOMATICAS', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). (UTILIZADA PARA TRANSFERENCIAS AUTOMATICAS)', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.23', 'FUNDO DE MANUTENCAO E DES. DA EDUCACAO BASICA - FUNDEB', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA - FUNDEB, RESOLUCAO MEC Nº. 01/2007 DE 15FEV2007.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.24', 'PROJOVEM URBANO', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, EFETUADOS PELO FUNDO NACIONAL DE DESENVOLVIMENTO DE EDUCACAO - FNDE PARA ATENDER JOVENS DE 15 A 29 ANOS COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL,SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. BASE LEGAL: MEDIDA PROVISORIA Nº Nº 411, DE 28 DE DEZEMBRO DE 2007. LEI Nº 11.129, DE 30 DE JUNHO DE 2005.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.25', 'PROJOVEM CAMPO - SABERES DA TERRA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, EFETUADOS PELO FUNDO NACIONAL DE DESENVOLVIMENTO DE EDUCACAO - FNDE PARA ATENDER JOVENS DE 15 A 29 ANOS COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL, SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. BASE LEGAL: MEDIDA PROVISORIA Nº Nº 411, DE 28 DE DEZEMBRO DE 2007. LEI Nº 11.129, DE 30 DE JUNHO DE 2005.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.26', 'PROJOVEM TRABALHADOR', 'REGISTRA OS VALORES A PAGAR DAS TRANSFERENCIAS LEGAIS DECORRENTES DE TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO - MTEE OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, CUJO OBJETIVO E TRANSFE-RIR RECURSOS SEM A NECESSIDADE DE CONVENIO, ACORDO, CONTRATO, AJUSTE OU INSTRUMENTO CONGENERE, CONFORME DISPOE O ART.39 DO DECRETO Nº 6629/08, QUE REGULAMENTA A LEI 11692/2008 (DISPOE SOBRE O PROGRAMA NACIONAL DE INCLUSAO DE JOVENS AO MERCADO DE TRABALHO).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.27', 'TERMO DE CONCESSAO DE APOIO FINANCEIRO -ANCINE', 'REGISTRA OS VALORES A PAGAR DAS TRANSFERENCIAS LEGAIS DECORRENTES DE TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A ANCINE E AS ENTIDADES PRIVADAS COM FINS LUCRATIVOS (MP 2228-1/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.28', 'PROGRAMA PRIMEIRO EMPREGO - PNPE', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ESTIMULO AO PRIMEIRO EMPREGO PARA OS JOVENS - PNPE, CONFORME LEI Nº 10.748, DE 22 DE OUTUBRO DE 2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.29', 'PROGRAMA ESPECIAL DE FORTALECIMENTO DO ENSINO MEDIO', 'REGISTRA VALORES A LIBERAR DE TRANSFERENCIAS DE RECURSOS PARA ATENDIMENTO DO PROGRAMA ESPECIAL DE FORTALECIMENTO DO ENSINO MEDIO, CONFORME MEDIDA PROVISORIA Nº Nº 484, DE 30 DE MARCO DE 2010.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.30', 'PROG.ESP. DE RECUP.REDE FISICA ESCOLA PUBLICA', 'REGISTRA VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA ESPECIAL DE RECUPERACAO DAS REDES FISICAS ESCOLARES PUBLICAS ESTADUAIS E MUNICIPAIS AFETADAS POR DESASTRES NATURAIS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.26.00', 'ENTIDADES CREDORAS - FEDERAIS', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE OBRIGACOES JUNTO A ENTIDADES FEDERAIS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.27.00', 'ENTIDADES CREDORAS - ESTADOS, DF E MUNICIPIOS', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DECORRENTES DE OBRIGACOES JUNTO A ESTADOS, DF E MUNICIPIOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.29.01', 'RESULTADO NEGATIVO DO BACEN - BALANCO APURADO', 'REGISTRA OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL CORRESPONDENTE AO APURADO NO BALANCO DE 31/12/XX DESTA INSTITUICAO A SER PAGO PELO TESOURO NACIONAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.29.02', 'RESULTADO NEGATIVO BACEN - CUSTO DAS RESERVAS', 'REGISTRA OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL CORRESPONDENTE AO CUSTO DAS RESERVAS DESTA INSTITUICAO A SER PAGO PELO TESOURO NACIONAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.30.00', 'EMPRESTIMOS E FINANCIAMENTOS A LIBERAR', 'REGISTRA A APROPRIACAO DE VALORES A SEREM LIBERADOS, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.31.00', 'INCENTIVOS A LIBERAR', 'REGISTRA O VALOR DOS INCENTIVOS FISCAIS A LIBERAR POR OCASIAO DA CLASSIFICACAO DA RECEITA ARRECADADA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.32.00', 'COMPENSACAO DE CONTRIBUICOES PREVIDENCIARIAS', 'REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS EFETIVADAS PELAS UG DO INSS, A SEREM RECOLHIDAS POR GPS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.33.01', 'ADIANTAMENTOS DE OPERACOES ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS AOS RECURSOS FINANCEIROS RECEBIDOS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE O MINISTERIO DAS RELACOES EXTERIORES E OUTRAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.33.02', 'ADIANTAMENTOS DE UNIDADES E ENTIDADES', 'REGISTRA OS VALORES EXIGIVEIS RELATIVOS A ADIANTAMENTOS CONCEDIDOS POR ORGAOS E ENTIDADES, INCLUSIVE UNIDADES GESTORAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.33.03', 'ADIANTAMENTOS DIVERSOS RECEBIDOS', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.34.02', 'OPERACOES COM DERIVATIVOS - SWAP', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - SWAP', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.34.03', 'OPERACOES COM DERIVATIVOS - FORWARD', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - FORWARD', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.34.04', 'OPERACOES COM DERIVATIVOS - FUTUROS', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - FUTUROS', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.34.05', 'OPERACOES COM DERIVATIVOS - TERMO', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - TERMO', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.35.01', 'VALORES DE INVESTIMENTOS A PAGAR', 'REGISTRA OS VALORES DE INVESTIMENTOS REALIZADOS NO MERCADO FINANCEIRO E NAO LIQUIDADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.36.01', 'GRU - VALORES EM TRANSITO PARA ESTORNO DESPESA', 'REGISTRA OS VALORES RECEBIDOS POR GRU A TITULO DE ESTORNO DE DESPESA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.36.02', 'ORDENS BANCARIAS A EMITIR', 'REGISTRA OS VALORES A LIBERAR A TITULO DE SUBREPASSE PARA AS UNIDADES GESTORAS DO EXTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.36.03', 'ORDENS BANCARIAS CANCELADAS', 'REGISTRA OS VALORES DE ORDENS BANCARIAS CANCELADAS PELO ORDENADOR DE DESPESA APOS REMESSA DE RELACAO AO BANCO, OU POR ESTE NA FALTA DE AUTORIZACAO DE PAGAMENTO PELO ORDENADOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.36.04', 'GRU A CLASSIFICAR - VALORES EM TRANSITO', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS POR MEIO DE GUIA DE RECOLHIMENTO DA UNIAO A CLASSIFICAR DE VALORES EM TRANSITO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.36.05', 'GRU A CLASSIFICAR - ROTINA AUTOMATICA', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS POR MEIO DE GUIA DE RECOLHIMENTO DA UNIAO A CLASSIFICAR DECORRENTES DE ROTINA AUTOMATICA(FUGA).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.36.06', 'SALDOS BANCARIOS EM UTILIZACAO', 'REGISTRA O VALOR DA APROPRIACAO DOS SALDOS BANCARIOS EM PROCESSO DE UTILIZACAO DE ACORDO COM CONTRATOS ASSINADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.36.07', 'DEPOSITO CONTA UNICA E INSTIT. A CLASSIFICAR', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS DIRETAMENTE NA CONTA UNICA INSTITUCIONAL', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.36.08', 'DEPOSITO CTU A CLASSIFICAR CODIGO PADRAO', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS DIRETAMENTE NA CONTA UNICA REFERENTE AOS CODIGOS PADRAO CRIADOS PELA COORDENACAO-GERAL DE CONTABILIDADE DA UNIAO (CCONT).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.36.09', 'SAQUE - CARTAO DE PAGAMENTO DO GOVERNO FEDERAL', 'REGISTRA OS VALORES REFERENTES AS DESPESAS COM SUPRIMENTO DE FUNDOS, PENDENTES DE SAQUE COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.36.10', 'FATURA - CARTAO DE PAGAMENTO DO GOVERNO FEDERAL', 'REGISTRA OS VALORES REFERENTES AS DESPESAS COM SUPRIMENTO DE FUNDOS, PENDENTES DE PAGAMENTO DA FATURA COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.36.11', 'TRANSFERENCIA AO BANCO DO BRASIL - OB SAQUE CARTAO', 'REGISTRA OS VALORES REFERENTES AS TRANSFERENCIAS DE RECURSOS AO BANCO DO BRASIL, RELATIVAS AOS SAQUES DE OB CARTAO EFETUADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.36.12', 'ORDENS BANCARIAS CANCELADAS (CARTAO CREDITO)', 'REGISTRA OS VALORES DE ORDENS BANCARIAS CANCELADAS PELO AGENTE FINANCEIRO, REFERENTE AO CARTAO DE CREDITO CORPORATIVO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.37.01', 'SUBVENCOES A PAGAR DO EXERCICIO', 'REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.37.02', 'SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.38.00', 'RESTITUICOES DE RECEITAS A PAGAR', 'REGISTRA O VALOR DAS RESTITUICOES DE RECEITAS A PAGAR APROPRIADAS PELAS UNIDADES GESTORAS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.39.00', 'TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS NAO EFETUADAS PELO PORTAL SICONV', 'REGISTRA OS VALORES DE DEVOLUCOES DE RECURSOS DE TRANSFERENCIAS VOLUNTARIAS, NAO GERADAS PELO PORTAL DE CONVENIOS, PARA POSTERIOR RECOLHIMENTO AO CONCEDENTE OU AO TESOURO NACIONAL POR MEIO DE GRU.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.01', 'RECURSOS A LIBERAR POR TRANSFERENCIA', 'REGISTRA OS VALORES A LIBERAR DA GESTAO TESOURO PARA A GESTAO FUNDO DA CAMARA E DO SENADO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.02', 'TRANSFERENCIAS ORCAMENTARIAS A LIBERAR PARA O DISTRITO FEDERAL', 'REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA A FAVOR DO DISTRITO FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.03', 'TRANSFERENCIAS ORCAMENTARIAS A LIBERAR PARA OS ESTADOS', 'REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA A FAVOR DE ESTADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.04', 'RECURSOS A LIBERAR POR VINCULACAO DE PAGAMENTO', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO, ESTABELECIDO PELO ORGAO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.05', 'RECURSOS A RESTITUIR - ADIANTAMENTOS RECEBIDOS PELO INSS', 'REGISTRA OS RECURSOS A RESTITUIR DE ADIANTAMENTOS RECEBIDOS PELO INSS EM DECORRENCIA DA ARRECADACAO DE PASSIVOS POR DARF E TRANSFERENCIA POR GPS PELA COFIN PARA O INSS. A CONTA SERA UTILIZADA QUANDO O VALOR A TRANSFERIR FOR MAIOR QUE O VALOR ARRECADADO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.06', 'RECURSOS ORCAMENTARIOS A LIBERAR', 'REGISTRA OS RECURSOS A LIBERAR REFERENTE AS PARCELAS NAO RECEBIDAS DO ORCAMENTO PARA A ENTIDADES DA ADMINISTRACAO INDIRETA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.07', 'RECURSOS A LIBERAR P/ VINCULACAO DE PAGAMENTO PARA O INSS', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO PARA O INSS, ESTABELECIDO PELO ORGAO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.08', 'RECURSOS A LIBERAR PARA EMPENHO CONTRA ENTREGA', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE PARA PAGAMENTO DE EMPENHO CONTRA ENTREGA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.09', 'RECURSOS DA PREVIDENCIA SOCIAL - BENEFICIOS', 'REGISTRA OS RECURSOS A LIBERAR REFERENTES AOS BENEFICIOS DA PREVIDENCIA SOCIAL', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.10', 'RECURSOS DA PREVIDENCIA SOCIAL - TERCEIROS', 'REGISTRA OS RECURSOS A LIBERAR REFERENTES A DEPOSITOS DE TERCEIROS PARA A PREVIDENCIA SOCIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.11', 'REMUNERACAO DA DISPONIBILIDADE CONTA UNICA INSS - BACEN', 'REGISTRA O VALOR DAS OBRIGACOES REFERENTES A REMUNERACAO DA DISPONIBILIDADE DA CTU INSS NO BACEN.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.12', 'LIMITE DE SAQUE RECURSOS DA DIVIDA PUBLICA', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR DA SUB-CONTA DA DIVIDA PUBLICA NO BANCO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.13', 'RECURSOS VINCULADOS - ENTIDADES TCT', 'REGISTRA O VALOR DOS RECURSOS VINCULADO REFERENTE A ENTIDADES QUE UTILIZAM A CONTA UNICA EM CUMPRIMENTO AO TERMO DE COOPERACAO TECNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.14', 'REC. A COMPENSAR P/ PERDAS EM APLICACOES NA CONTA UNICA', 'REGISTRA O VALOR DE RECURSOS A COMPENSAR POR PERDAS EM APLICACOES FINANCEIRAS NA CONTA UNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.41.01', 'PERDAS EM PARTICIPACAO EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO', 'COMPREENDE OS VALORES REFERENTES A PARTICIPACOES PELO METODO DA EQUIVALENCIA PATRIMONIAL EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO (PASSIVO A DESCOBERTO).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.41.99', 'PERDAS EM PARTICIPACAO - EMPRESAS DEPENDENTES', 'REGISTRA OS VALORES DAS PARTICIPACOES DA UNIAO NO PL NEGATIVO DAS EMPRESAS CONTROLADAS DEPENDENTES, PARA QUE OS REFERIDOS VALORES SEJAM EXPURGADOS NA CONSOLIDACAO DAS DEMONSTRACOES CONTABEIS DA UNIAO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.42.00', 'CONTRIBUICAO AO FUST A RECOLHER', 'REGISTRA OS VALORES DEVIDOS PELA UNIDADE EM FUNCAO DA RECEITA OPERACIONAL BRUTA, DECORRENTE DA PRESTACAO DE SERVICOS DE TELECOMUNICACOES NOS REGIMES PUBLICO E PRIVADO, EXCLUINDO-SE O ICMS, O PIS E A COFINS INCIDENTES SOBRE A MESMA BASE DE CALCULO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.44.00', 'OBRIGACOES A PAGAR EM MOEDA ESTRANGEIRA', 'REGISTRA OS VALORES DAS OBRIGACOES A PAGAR EM MOEDA ESTRANGEIRA, INCLUSIVE AS DESPESAS COM ADMINISTRACAO TERCEIRIZADA DE RECURSOS EM MOEDA ESTRANGEIRA. CONTA EXCLUSIVA DO BANCO CENTRAL DO BRASIL', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.45.00', 'RECURSOS DA GRU', 'REGISTRA O VALOR DOS CREDITOS DE GUIA DE RECOLHIMENTO DA UNIAO - GRU INTRA SIAFI.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.46.00', 'RECURSOS FISCAIS', 'REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELO TESOURO NACIONAL A SEREM POSTERIORMENTE CLASSIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.47.00', 'RESTITUICAO DE RECEITAS RECEBIDAS GRU', 'REGISTRA OS VALORES RELATIVOS A RESTITUICAO DE RECEITAS RECEBIDAS POR GRU.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.98.01', 'OUTROS CREDORES DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES NO EXERCICIO, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.98.02', 'OUTROS CREDORES DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCICIOS ANTERIORES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.01.01', 'INDENIZACOES A SERVIDORES', 'REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.01.02', 'INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.01.03', 'INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.01.04', 'RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS', 'REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS EFETIVADAS PELAS UG DO INSS, A SEREM PAGAS ATRAVES DE OB.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.02.00', 'DIARIAS A PAGAR', 'REGISTRA OS VALORES RELATIVOS A DIARIAS A PAGAR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.03.00', 'SUPRIMENTOS DE FUNDOS A PAGAR', 'REGISTRA OS VALORES RELATIVOS AOS SUPRIMENTOS DE FUNDOS A PAGAR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.04.01', 'SALARIO-FAMILIA A PAGAR', 'REGISTRA OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM O DESEMBOLSO A TITULO DE SALARIO FAMILIA A SEUS EMPREGADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.04.02', 'AUXILIO - NATALIDADE A PAGAR', 'REGISTRA OS VALORES A SEREM PAGOS PELO INSS, A TITULO DE REEMBOLSO DO AUXILIO-NATALIDADE PAGO PELAS ENTIDADES A SEUS EMPREGADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.04.03', 'DEBITOS EM APURACAO - INSS', 'REGISTRA OS VALORES EM APURACAO A SEREM RESSARCIDOS PELO INSS A ENTIDADES, DECORRENTES DE PAGAMENTOS OU ANTECIPACOES EFETUADAS POR ESTAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.04.04', 'DEBITOS POR PREMIOS DE SEGURO - COMPREENSIVO - INSS', 'REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS AS COMPANHIAS SEGURADORAS, POR PREMIOS DE SEGURO PAGOS A MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO - LEI 4380/64.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.04.99', 'OUTROS DEBITOS POR INDENIZACAO E ANTECIPACOES - INSS', 'REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS POR PAGAMENTOS OU ANTECIPACOES REALIZADAS POR ENTIDADES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.05.01', 'CONVENIOS A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.05.02', 'CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.06.01', 'CONVENIOS A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DO EXERCICIO, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.06.02', 'CONVENIOS A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DE EXERCICIOS ANTERIORES, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.07.01', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.07.02', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.08.01', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.08.02', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.09.01', 'TERMOS DE PARCERIA A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.09.02', 'TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.10.01', 'TERMOS DE PARCERIA A PAGAR DO EXERCICIO - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.10.02', 'TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.11.01', 'TERMO DE COMPROMISSO A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.11.02', 'TERMO DE COMPROMISSO A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.12.00', 'TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS -PORTAL', 'COMPREENDE OS VALORES DEVOLVIDOS REFERENTES A TRANSFERENCIAS VOLUNTARIAS FIRMADAS - CONVENIOS E CONTRATOS DE REPASSE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.13.01', 'PRECATORIOS DE TERCEIROS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.13.02', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.13.03', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000', 'REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.14.01', 'COMPENSACAO PREVIDENCIARIA DO EXERCICIO', 'REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.14.02', 'COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES', 'REGISTRA O VALOR DAS OBRIGACOES DE EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.15.00', 'TAXA DE FISCALIZACAO DE FUNCIONAMENTO - TFF', 'REGISTRA AS OBRIGACOES REFERENTES A TAXA DE FISCALIZACAO DE FUNCIONAMENTO - (TFF).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.16.00', 'OPERACOES COM DERIVATIVOS', 'REGISTRA AS OBRIGACOES DECORRENTES DE OPERACOES COM DERIVATIVOS REALIZADAS PELO BANCO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.17.00', 'DESPESAS ADMINISTRATIVAS - FUNDOS CONSTITUCIONAIS DE FINANCIAMENTO', 'REGISTRA AS OBRIGACOES DECORRENTES DE DESPESAS ADMINISTRATIVAS DOS FUNDOS CONSTITUCIONAIS DE FINANCIAMENTO, TAIS COMO TAXAS DE ADMINISTRACAO PAGAS AS INSTITUICOES FINANCEIRAS, REMUNERACAO DE AGENTES ETC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.18.00', 'DIVIDAS COM RESSARCIMENTO / COMISSOES - FMM', 'REGISTRA OS VALORES DAS OBRIGACOES COM DESPESAS DE RESSARCIMENTOS E COMISSOES DO FUNDO MARINHA MERCANTE, DEVIDAS AS EMPRESAS MARITIMAS E BNDES RESPECTIVAMENTE, MAS QUE AINDA NAO POSSUEM AUTORIZACAO LEGISLATIVA PARA EXECUCAO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.19.01', 'BOLSAS DE ESTUDOS - EXERCICIO', 'REGISTRA AS OBRIGACOES DO EXERCICIO RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.19.02', 'BOLSAS DE ESTUDOS - EXERCICIOS ANTERIORES', 'REGISTRA AS OBRIGACOES DE EXERCICIOS ANTERIORES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.20.00', 'CONTRATOS DE GESTAO', 'REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.21.00', 'SERVICOS EVENTUAIS - PESSOAL TECNICO', 'REGISTRA AS OBRIGACOES COM PESSOAL TECNICO CONTRATADO POR TEMPO DETERMINADO PARA DESEMPENHO DE TECNICAS ESPECIALIZADAS EM AMBITO DE PROJETOS DE COOPERACAO NOS TERMOS DA LEI 8745/93 CONFORME DECRETO Nº 4748/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.22.01', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO', 'REGISTRA OS VALORES DO EXERCICIO EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.22.02', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO ANTERIOR', 'REGISTRA OS VALORES DE EXERCICIOS ANTERIORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.23.01', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.23.02', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO ANTERIOR', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.24.00', 'RESIDUOS DE CONTRATOS LIQUIDADOS - FCVS', 'REGISTRA AS OBRIGACOES DECORRENTES DA COBERTURA FINANCEIRA, PELO FCVS,DOS CONTRATOS LIQUIDADOS PELOS ADQUIRENTES POR DECURSO DE PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.01', 'MERENDA ESCOLAR - PNAE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ALIMENTACAO ESCOLAR - PNAE, COM OBJETIVO DE PRESTAR ASSISTENCIA FINANCEIRA, EM CARATER SUPLEMENTAR AS ESCOLAS PUBLICAS DE ENSINO FUNDAMENTAL DAS REDES ESTADUAIS, MUNICIPAIS E DO DISTRITO FEDERAL E AS ESCOLAS DE EDUCACAO ESPECIAL QUALIFICADAS COMO ENTIDADES FILANTROPICAS OU POR ELAS MANTIDAS. A ASSISTENCIA FINANCEIRA A SER CONCEDIDA A CADA ESTABELECIMENTO DE ENSINO BENEFICIARIO SERA DEFINIDA ANUALMENTE E TERA COMO BASE O NUMERO DE ALUNOS MATRICULADOS NO ENSINO FUNDAMENTAL E ESPECIAL, DE ACORDO COM DADOS EXTRAIDOS DO CENSO ESCOLAR REALIZADO PELO MINISTERIO DA EDUCACAO NO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.02', 'DINHEIRO DIRETO NA ESCOLA - PDDE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE), DESTINADOS AS ESCOLAS DE EDUCACAO ESPECIAL,QUALIFICADAS COMO ENTIDADES FILANTROPICAS OU POR ELAS MANTIDAS PARA COBERTURA DE DESPESA COM CUSTEIO, MANUTENCAO E PEQUENOS INVESTIMENTOS, CONFORME RESOLUCAO CD/FNDE N 04/2003. .', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.03', 'TRANSPORTE ESCOLAR - PNTE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DE TRANSPORTE ESCOLAR (PNTE), CONFORME RESOLUCAO CD/FNDE Nº 09/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.04', 'FUNDO MANUTENCAO E DESENVOLVIMENTO DO ENSINO FUNDAMENTAL - FUNDEF', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DO ENSINO FUNDAMENTAL E VALORIZACAO DO MAGISTERIO - FUNDEF, LEI 9.424/96', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.05', 'FUNDO DE FORTALECIMENTO DA ESCOLA- FUNDESCOLA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA FUNDO DE FORTALECIMENTO DA ESCOLA - FUNDESCOLA, PARA FINANCIAMENTO DE PROJETOS EDUCACIONAIS A ORGAOS OU ENTIDADES FEDERAIS, ESTADUAIS E MUNICIPAIS, CUJAS AS ACOES ESTEJAM VOLTADAS PARA O DESENVOLVIMENTO DO ENSINO PUBLICO FUNDAMENTAL REGULAR EM ZONAS DE ATENDIMENTO PRIORITARIO DOS ESTADOS DO NORTE, NORDESTE E CENTRO-OESTE. RESOLUCAO CD/FNDE Nº 10/2002', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.06', 'QUOTA ESTADUAL - SALARIO EDUCACAO', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO A QUOTA ESTADUAL DO SALARIO EDUCACAO, CONFORME LEI 9.766/98.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.07', 'EDUCACAO DE JOVENS E ADULTOS - EJA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS VISANDO ATENDER AO PROGRAMA DE EDUCACAO DE JOVENS E ADULTOS(EJA), OS QUAIS SERAO DESTINADOS A AMPLIACAO DA OFERTA DE VAGAS NA EDUCACAO FUNDAMENTAL CUJOS BENEFICIARIOS SAO ALUNOS DA ESCOLA PUBLICA ESTADUAL E MUNICIPAL DO ENSINO FUNDAMENTAL, MATRICULADOS NOS CURSOS DA MODALIDADE "SUPLETIVO PRESENCIAL COM AVALIACAO NO PROCESSO". RESOLUCAO CD/FNDE Nº 05/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.08', 'PROGRAMA DE ATENDIMENTO EDUCACIONAL AS PESSOAS PORTADORES DE DEFICIENCIA - PAED', 'REGISTRA OS VALORES AS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DE ATENDIMENTO EDUCACIONAL ESPECIALIZADO AS PESSOAS PORTADORAS DE DEFICIENCIA - PAED - INSTITUIDA PELA LEI Nº 10845, DE 08/MAR/04.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.09', 'BOLSA PROGRAMA FORMACAO INICIAL E CONTINUADA', 'REGISTRA OS VALORES REFERENTES A REPASSES DE BENEFICIOS DO PROGRAMA BOLSA ESCOLA, CONFORME LEI Nº 10.219, DE 11/04/2001.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.10', 'APOIO AO TRANSPORTE DO ESCOLAR - PNATE', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO TRANSPORTE DO ESCOLAR - PNATE CONFORME MP 173/2004, DOU 17/03/04', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.11', 'APOIO A EDUCACAO DE JOVENS E ADULTOS - PEJA', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO A EDUCACAO DE JOVENS E ADULTOS - PEJA - CONFORME MP 173/2004, DOU 17/03/04.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.12', 'PROGRAMA BRASIL ALFABETIZADO - CONVENIOS', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI Nº 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). ESTA CONTA E UTILIZADA PARA CONVENIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.13', 'DINHEIRO DIRETO NA ESCOLA - PDDEF/PAPE', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE) DO PROJETO DE ADEQUACAO DE PREDIOS ESCOLARES DO FUNDESCOLA - PDDEF/PAPE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.14', 'DINHEIRO DIRETO NA ESCOLA - PDDEF/PME', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE) DO PROJETO DE MELHORIA DA ESCOLA DO FUNDESCOLA - PDDEF/PME.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.15', 'BOLSA ESCOLA DE FABRICA', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA E A LEI Nº 11.273, DE 06 DE FEVEREIRO DE 2006, QUE ATUALIZA A CONCESSAO DE BOLSA DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.16', 'FORMACAO DE PROFESSORES', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA FORMACAO DE PROFESSORES (LEIS 11.180,23/9/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.17', 'PROINFANTIL', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA(PROINFANTIL) (LEIS 11.180, DE 23 /09/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.18', 'PROFORMACAO', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA (PROFORMACAO) LEIS 11.180, DE 23/09/05, E A LEI 11.273, DE 06/02/06, QUE AUTORIZA A CONCESSAO DE BOLSA DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.19', 'PROLICENCIATURA', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA (PROLICENCIATURA) (LEIS 11.180, DE23/9/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.20', 'PROGRAMA UNIVERSIDADE ABERTA DO BRASIL', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA UNIVERSIDADE ABERTA DO BRASIL - CONFORME DECRETO Nº 5.800 DE 08JUN2006. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.21', 'BOLSAS BRASIL ALFABETIZADO', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). (UTILIZADA PARA BOLSAS).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.22', 'PROGRAMA BRASIL ALFABETIZADO - TRANSF. AUTOMATICAS', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). (UTILIZADA PARA TRANSFERENCIAS AUTOMATICAS)', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.23', 'FUNDO DE MANUTENCAO E DES. DA EDUCACAO BASICA - FUNDEB', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA - FUNDEB, RESOLUCAO MEC Nº. 01/2007 DE 15FEV2007.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.24', 'PROJOVEM URBANO', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, EFETUADOS PELO FUNDO NACIONAL DE DESENVOLVIMENTO DE EDUCACAO - FNDE PARA ATENDER JOVENS DE 15 A 29 ANOS COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL,SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. BASE LEGAL: MEDIDA PROVISORIA Nº Nº 411, DE 28 DE DEZEMBRO DE 2007. LEI Nº 11.129, DE 30 DE JUNHO DE 2005.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.25', 'PROJOVEM CAMPO - SABERES DA TERRA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, EFETUADOS PELO FUNDO NACIONAL DE DESENVOLVIMENTO DE EDUCACAO - FNDE PARA ATENDER JOVENS DE 15 A 29 ANOS COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL, SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. BASE LEGAL: MEDIDA PROVISORIA Nº Nº 411, DE 28 DE DEZEMBRO DE 2007. LEI Nº 11.129, DE 30 DE JUNHO DE 2005.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.26', 'PROJOVEM TRABALHADOR', 'REGISTRA OS VALORES A PAGAR DAS TRANSFERENCIAS LEGAIS DECORRENTES DE TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO - MTEE OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, CUJO OBJETIVO E TRANSFE-RIR RECURSOS SEM A NECESSIDADE DE CONVENIO, ACORDO, CONTRATO, AJUSTE OU INSTRUMENTO CONGENERE, CONFORME DISPOE O ART.39 DO DECRETO Nº 6629/08, QUE REGULAMENTA A LEI 11692/2008 (DISPOE SOBRE O PROGRAMA NACIONAL DE INCLUSAO DE JOVENS AO MERCADO DE TRABALHO).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.27', 'TERMO DE CONCESSAO DE APOIO FINANCEIRO -ANCINE', 'REGISTRA OS VALORES A PAGAR DAS TRANSFERENCIAS LEGAIS DECORRENTES DE TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A ANCINE E AS ENTIDADES PRIVADAS COM FINS LUCRATIVOS (MP 2228-1/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.28', 'PROGRAMA PRIMEIRO EMPREGO - PNPE', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ESTIMULO AO PRIMEIRO EMPREGO PARA OS JOVENS - PNPE, CONFORME LEI Nº 10.748, DE 22 DE OUTUBRO DE 2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.29', 'PROGRAMA ESPECIAL DE FORTALECIMENTO DO ENSINO MEDIO', 'REGISTRA VALORES A LIBERAR DE TRANSFERENCIAS DE RECURSOS PARA ATENDIMENTO DO PROGRAMA ESPECIAL DE FORTALECIMENTO DO ENSINO MEDIO, CONFORME MEDIDA PROVISORIA Nº Nº 484, DE 30 DE MARCO DE 2010.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.30', 'PROG.ESP. DE RECUP.REDE FISICA ESCOLA PUBLICA', 'REGISTRA VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA ESPECIAL DE RECUPERACAO DAS REDES FISICAS ESCOLARES PUBLICAS ESTADUAIS E MUNICIPAIS AFETADAS POR DESASTRES NATURAIS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.31', 'PROINFANCIA-MANUTENCAO', 'REGISTRA OS VALORES DAS TRANSFERENCIAS AOS MUNICIPIOS E AO DISTRITO FEDERAL,COM A FINALIDADE DE PRESTAR APOIO FINANCEIRO A MANUTENCAO DE NO-VOS ESTABELECIMENTOS PUBLICOS DE EDUCACAO INFANTIL(VISANDO O ATENDIMENTO DA MP 533,DE 10/05/2011).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.32', 'PAC 2 PROINFANCIA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS PARA CONSTRUCAO DA REDE ESCOLAR PUBLICA DE EDUCACAO INFANTIL - CONSTRUCAO DE CRECHES. (LEI Nº 11.578, DE 26/11/2007, CONSTA NA MSG 2011/0485958-UG 150003).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.33', 'PAC 2 QUADRAS', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS PARA CONTRUCAO DA REDE ESCOLAR PUBLICA DE EDUCACAO INFANTIL - CONSTRUCAO DE QUADRAS POLIESPORTIVAS COBERTAS. (LEI Nº 11.578, DE 26/11/2007, MSG 2011/0485958 DA UG_150003).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.34', 'CAMINHO DA ESCOLA - PTC', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS VISANDO ATENDER AO PROGRAMA TERRITORIOS DA CIDADANIA -PTC, DESTINADOS A AQUISICAO DE VEICULOS PARA TRANSPORTAR ALUNOS AS ESCOLAS. LEI 12.249/2010.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.35', 'PRONATEC', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ACESSO AO ENSINO TECNICO E EMPREGO - PRONATEC, CONFORME LEI Nº 12.513, DE 26 DE OUTUBRO DE 2011.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.36', 'PLANO DE ACOES ARTICULADAS - PAR', 'REGISTRAR AS TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS REFERENTES AO PLANO DE ACOES ARTICULADAS, VISANDO ATENDER À MEDIDA PROVISÓRIA Nº 562 DE 20 DE MARCO DE 2012.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.37', 'PROGRAMA AUXILIO DE AVALIACAO EDUCACIONAL-AAE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DE AUXILIO DE AVALIACAO EDUCACIONAL-AAE, CONFORME A LEI Nº 11.507, DE 20 DE JULHO DE 2007.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.38', 'ACOES E SERVICOS DE SAUDE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FEDERAIS PARA ACOE E SERVICOS DE SAUDE, NA FORMA DE BLOCOS DE FINANCIAMENTO, CONFORME DEFINIDO NA PORTARIA MS 204, DE 29 DE JANEIRO DE 2007. BLOCOS DE FINANCIAMENTO: 1 - ATENCAO BASICA; 2 - ATENCAO DE MEDIA E ALTA COMPLEXIDADE AMBULATORIAL; 3 - VIGILANCIA EM SAUDE; 4 - ASSISTENCIA FARMACEUTICA; 5 - GESTAO DO SUS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.26.00', 'ENTIDADES CREDORAS - FEDERAIS', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE OBRIGACOES JUNTO A ENTIDADES FEDERAIS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.27.00', 'ENTIDADES CREDORAS - ESTADOS, DF E MUNICIPIOS', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DECORRENTES DE OBRIGACOES JUNTO A ESTADOS, DF E MUNICIPIOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.29.01', 'RESULTADO NEGATIVO DO BACEN - BALANCO APURADO', 'REGISTRA OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL CORRESPONDENTE AO APURADO NO BALANCO DE 31/12/XX DESTA INSTITUICAO A SER PAGO PELO TESOURO NACIONAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.29.02', 'RESULTADO NEGATIVO BACEN - CUSTO DAS RESERVAS', 'REGISTRA OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL CORRESPONDENTE AO CUSTO DAS RESERVAS DESTA INSTITUICAO A SER PAGO PELO TESOURO NACIONAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.30.00', 'EMPRESTIMOS E FINANCIAMENTOS A LIBERAR', 'REGISTRA A APROPRIACAO DE VALORES A SEREM LIBERADOS, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.31.00', 'INCENTIVOS A LIBERAR', 'REGISTRA O VALOR DOS INCENTIVOS FISCAIS A LIBERAR POR OCASIAO DA CLASSIFICACAO DA RECEITA ARRECADADA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.32.00', 'COMPENSACAO DE CONTRIBUICOES PREVIDENCIARIAS', 'REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS EFETIVADAS PELAS UG DO INSS, A SEREM RECOLHIDAS POR GPS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.33.01', 'ADIANTAMENTOS DE OPERACOES ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS AOS RECURSOS FINANCEIROS RECEBIDOS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE O MINISTERIO DAS RELACOES EXTERIORES E OUTRAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.33.02', 'ADIANTAMENTOS DE UNIDADES E ENTIDADES', 'REGISTRA OS VALORES EXIGIVEIS RELATIVOS A ADIANTAMENTOS CONCEDIDOS POR ORGAOS E ENTIDADES, INCLUSIVE UNIDADES GESTORAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.33.03', 'ADIANTAMENTOS DIVERSOS RECEBIDOS', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.34.02', 'OPERACOES COM DERIVATIVOS - SWAP', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - SWAP', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.34.03', 'OPERACOES COM DERIVATIVOS - FORWARD', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - FORWARD', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.34.04', 'OPERACOES COM DERIVATIVOS - FUTUROS', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - FUTUROS', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.34.05', 'OPERACOES COM DERIVATIVOS - TERMO', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - TERMO', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.35.01', 'VALORES DE INVESTIMENTOS A PAGAR', 'REGISTRA OS VALORES DE INVESTIMENTOS REALIZADOS NO MERCADO FINANCEIRO E NAO LIQUIDADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.36.01', 'GRU - VALORES EM TRANSITO PARA ESTORNO DESPESA', 'REGISTRA OS VALORES RECEBIDOS POR GRU A TITULO DE ESTORNO DE DESPESA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.36.02', 'ORDENS BANCARIAS A EMITIR', 'REGISTRA OS VALORES A LIBERAR A TITULO DE SUBREPASSE PARA AS UNIDADES GESTORAS DO EXTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.36.03', 'ORDENS BANCARIAS CANCELADAS', 'REGISTRA OS VALORES DE ORDENS BANCARIAS CANCELADAS PELO ORDENADOR DE DESPESA APOS REMESSA DE RELACAO AO BANCO, OU POR ESTE NA FALTA DE AUTORIZACAO DE PAGAMENTO PELO ORDENADOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.36.04', 'GRU A CLASSIFICAR - VALORES EM TRANSITO', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS POR MEIO DE GUIA DE RECOLHIMENTO DA UNIAO A CLASSIFICAR DE VALORES EM TRANSITO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.36.05', 'GRU A CLASSIFICAR - ROTINA AUTOMATICA', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS POR MEIO DE GUIA DE RECOLHIMENTO DA UNIAO A CLASSIFICAR DECORRENTES DE ROTINA AUTOMATICA(FUGA).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.36.06', 'SALDOS BANCARIOS EM UTILIZACAO', 'REGISTRA O VALOR DA APROPRIACAO DOS SALDOS BANCARIOS EM PROCESSO DE UTILIZACAO DE ACORDO COM CONTRATOS ASSINADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.36.07', 'DEPOSITO CONTA UNICA E INSTIT. A CLASSIFICAR', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS DIRETAMENTE NA CONTA UNICA INSTITUCIONAL', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.36.08', 'DEPOSITO CTU A CLASSIFICAR CODIGO PADRAO', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS DIRETAMENTE NA CONTA UNICA REFERENTE AOS CODIGOS PADRAO CRIADOS PELA COORDENACAO-GERAL DE CONTABILIDADE DA UNIAO (CCONT).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.36.09', 'SAQUE - CARTAO DE PAGAMENTO DO GOVERNO FEDERAL', 'REGISTRA OS VALORES REFERENTES AS DESPESAS COM SUPRIMENTO DE FUNDOS, PENDENTES DE SAQUE COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.36.10', 'FATURA - CARTAO DE PAGAMENTO DO GOVERNO FEDERAL', 'REGISTRA OS VALORES REFERENTES AS DESPESAS COM SUPRIMENTO DE FUNDOS, PENDENTES DE PAGAMENTO DA FATURA COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.36.11', 'TRANSFERENCIA AO BANCO DO BRASIL - OB SAQUE CARTAO', 'REGISTRA OS VALORES REFERENTES AS TRANSFERENCIAS DE RECURSOS AO BANCO DO BRASIL, RELATIVAS AOS SAQUES DE OB CARTAO EFETUADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.36.12', 'ORDENS BANCARIAS CANCELADAS (CARTAO CREDITO)', 'REGISTRA OS VALORES DE ORDENS BANCARIAS CANCELADAS PELO AGENTE FINANCEIRO, REFERENTE AO CARTAO DE CREDITO CORPORATIVO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.37.01', 'SUBVENCOES A PAGAR DO EXERCICIO', 'REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.37.02', 'SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.38.00', 'RESTITUICOES DE RECEITAS A PAGAR', 'REGISTRA O VALOR DAS RESTITUICOES DE RECEITAS A PAGAR APROPRIADAS PELAS UNIDADES GESTORAS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.39.01', 'COTA RECEBIDA DIFERIDA', 'REGISTRA A PARCELA DE RECURSOS FINANCEIROS, NAO UTILIZADA DURANTE O EXERCICIO, RECEBIDA POR UM ORGAO SETORIAL DE PROGRAMACAO FINANCEIRA,QUETRANSFERIRA PARA OUTRO, MAIS O LIMITE DE RP RECEBIDO, MENOS O LIMITEDE RP CONCEDIDO, CONSTITUINDO O TOTAL, DESSA FORMA, EM ANTECIPACAO DE COTA DO EXERCICIO SEGUINTE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.39.02', 'REPASSE RECEBIDO DIFERIDO', 'REGISTRA A PARCELA DE RECURSOS FINANCEIROS COLOCADOS A DISPOSICAO DAS UNIDADES, PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA, QUE NAO FOI UTILIZADA DURANTE O EXERCICIO E CONSTITUIRA ANTECIPACAO DE REPASSE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.39.03', 'SUB-REPASSE RECEBIDO DIFERIDO', 'REGISTRA A PARCELA DE RECURSOS FINANCEIROS COLOCADOS A DISPOSICAO DAS UNIDADES, PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA, QUE NAO FOI UTILIZADA DURANTE O EXERCICIO E CONSTITUIRA ANTECIPACAO DE SUBREPASSE NO EXERCICIO SEGUINTE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.01', 'RECURSOS A LIBERAR POR TRANSFERENCIA', 'REGISTRA OS VALORES A LIBERAR DA GESTAO TESOURO PARA A GESTAO FUNDO DA CAMARA E DO SENADO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.02', 'TRANSFERENCIAS ORCAMENTARIAS A LIBERAR PARA O DISTRITO FEDERAL', 'REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA A FAVOR DO DISTRITO FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.03', 'TRANSFERENCIAS ORCAMENTARIAS A LIBERAR PARA OS ESTADOS', 'REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA A FAVOR DE ESTADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.04', 'RECURSOS A LIBERAR POR VINCULACAO DE PAGAMENTO', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO, ESTABELECIDO PELO ORGAO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.05', 'RECURSOS A RESTITUIR - ADIANTAMENTOS RECEBIDOS PELO INSS', 'REGISTRA OS RECURSOS A RESTITUIR DE ADIANTAMENTOS RECEBIDOS PELO INSS EM DECORRENCIA DA ARRECADACAO DE PASSIVOS POR DARF E TRANSFERENCIA POR GPS PELA COFIN PARA O INSS. A CONTA SERA UTILIZADA QUANDO O VALOR A TRANSFERIR FOR MAIOR QUE O VALOR ARRECADADO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.06', 'RECURSOS ORCAMENTARIOS A LIBERAR', 'REGISTRA OS RECURSOS A LIBERAR REFERENTE AS PARCELAS NAO RECEBIDAS DO ORCAMENTO PARA A ENTIDADES DA ADMINISTRACAO INDIRETA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.07', 'RECURSOS A LIBERAR P/ VINCULACAO DE PAGAMENTO PARA O INSS', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO PARA O INSS, ESTABELECIDO PELO ORGAO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.08', 'RECURSOS A LIBERAR PARA EMPENHO CONTRA ENTREGA', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE PARA PAGAMENTO DE EMPENHO CONTRA ENTREGA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.09', 'RECURSOS DA PREVIDENCIA SOCIAL - BENEFICIOS', 'REGISTRA OS RECURSOS A LIBERAR REFERENTES AOS BENEFICIOS DA PREVIDENCIA SOCIAL', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.10', 'RECURSOS DA PREVIDENCIA SOCIAL - TERCEIROS', 'REGISTRA OS RECURSOS A LIBERAR REFERENTES A DEPOSITOS DE TERCEIROS PARA A PREVIDENCIA SOCIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.11', 'REMUNERACAO DA DISPONIBILIDADE CONTA UNICA INSS - BACEN', 'REGISTRA O VALOR DAS OBRIGACOES REFERENTES A REMUNERACAO DA DISPONIBILIDADE DA CTU INSS NO BACEN.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.12', 'LIMITE DE SAQUE RECURSOS DA DIVIDA PUBLICA', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR DA SUB-CONTA DA DIVIDA PUBLICA NO BANCO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.13', 'RECURSOS VINCULADOS - ENTIDADES TCT', 'REGISTRA O VALOR DOS RECURSOS VINCULADO REFERENTE A ENTIDADES QUE UTILIZAM A CONTA UNICA EM CUMPRIMENTO AO TERMO DE COOPERACAO TECNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.14', 'REC. A COMPENSAR P/ PERDAS EM APLICACOES NA CONTA UNICA', 'REGISTRA O VALOR DE RECURSOS A COMPENSAR POR PERDAS EM APLICACOES FINANCEIRAS NA CONTA UNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.41.01', 'PERDAS EM PARTICIPACAO EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO', 'COMPREENDE OS VALORES REFERENTES A PARTICIPACOES PELO METODO DA EQUIVALENCIA PATRIMONIAL EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO (PASSIVO A DESCOBERTO).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.41.99', 'PERDAS EM PARTICIPACAO - EMPRESAS DEPENDENTES', 'REGISTRA OS VALORES DAS PARTICIPACOES DA UNIAO NO PL NEGATIVO DAS EMPRESAS CONTROLADAS DEPENDENTES, PARA QUE OS REFERIDOS VALORES SEJAM EXPURGADOS NA CONSOLIDACAO DAS DEMONSTRACOES CONTABEIS DA UNIAO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.42.00', 'CONTRIBUICAO AO FUST A RECOLHER', 'REGISTRA OS VALORES DEVIDOS PELA UNIDADE EM FUNCAO DA RECEITA OPERACIONAL BRUTA, DECORRENTE DA PRESTACAO DE SERVICOS DE TELECOMUNICACOES NOS REGIMES PUBLICO E PRIVADO, EXCLUINDO-SE O ICMS, O PIS E A COFINS INCIDENTES SOBRE A MESMA BASE DE CALCULO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.43.00', 'TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS NAO EFETUADAS PELO PORTAL SICONV', 'REGISTRA OS VALORES DE DEVOLUCOES DE RECURSOS DE TRANSFERENCIAS VOLUNTARIAS, NAO GERADAS PELO PORTAL DE CONVENIOS, PARA POSTERIOR RECOLHIMENTO AO CONCEDENTE OU AO TESOURO NACIONAL POR MEIO DE GRU.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.44.00', 'OBRIGACOES A PAGAR EM MOEDA ESTRANGEIRA', 'REGISTRA OS VALORES DAS OBRIGACOES A PAGAR EM MOEDA ESTRANGEIRA, INCLUSIVE AS DESPESAS COM ADMINISTRACAO TERCEIRIZADA DE RECURSOS EM MOEDA ESTRANGEIRA. CONTA EXCLUSIVA DO BANCO CENTRAL DO BRASIL', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.45.00', 'RECURSOS DA GRU', 'REGISTRA O VALOR DOS CREDITOS DE GUIA DE RECOLHIMENTO DA UNIAO - GRU INTRA SIAFI.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.46.00', 'RECURSOS FISCAIS', 'REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELO TESOURO NACIONAL A SEREM POSTERIORMENTE CLASSIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.47.00', 'RESTITUICAO DE RECEITAS RECEBIDAS GRU', 'REGISTRA OS VALORES RELATIVOS A RESTITUICAO DE RECEITAS RECEBIDAS POR GRU.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.98.01', 'OUTROS CREDORES DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES NO EXERCICIO, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.98.02', 'OUTROS CREDORES DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCICIOS ANTERIORES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.01.01', 'INDENIZACOES A SERVIDORES', 'REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.01.02', 'INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.01.03', 'INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.01.04', 'RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS', 'REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS EFETIVADAS PELAS UG DO INSS, A SEREM PAGAS ATRAVES DE OB.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.02.00', 'DIARIAS A PAGAR', 'REGISTRA OS VALORES RELATIVOS AS DIARIAS A PAGAR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.03.00', 'SUPRIMENTOS DE FUNDOS A PAGAR', 'REGISTRA OS VALORES RELATIVOS AOS SUPRIMENTOS DE FUNDOS A PAGAR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.04.01', 'SALARIO-FAMILIA A PAGAR', 'REGISTRA OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM O DESEMBOLSO A TITULO DE SALARIO FAMILIA A SEUS EMPREGADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.04.02', 'AUXILIO - NATALIDADE A PAGAR', 'REGISTRA OS VALORES A SEREM PAGOS PELO INSS, A TITULO DE REEMBOLSO DO AUXILIO-NATALIDADE PAGO PELAS ENTIDADES A SEUS EMPREGADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.04.03', 'DEBITOS EM APURACAO - INSS', 'REGISTRA OS VALORES EM APURACAO A SEREM RESSARCIDOS PELO INSS A ENTIDADES, DECORRENTES DE PAGAMENTOS OU ANTECIPACOES EFETUADAS POR ESTAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.04.04', 'DEBITOS POR PREMIOS DE SEGURO - COMPREENSIVO - INSS', 'REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS AS COMPANHIAS SEGURADORAS, POR PREMIOS DE SEGURO PAGOS A MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO - LEI Nº 4380/64.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.04.99', 'OUTROS DEBITOS POR INDENIZACAO E ANTECIPACOES - INSS', 'REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS POR PAGAMENTOS OU ANTECIPACOES REALIZADAS POR ENTIDADES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.05.01', 'CONVENIOS A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.05.02', 'CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.06.01', 'CONVENIOS A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DO EXERCICIO, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.06.02', 'CONVENIOS A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DE EXERCICIOS ANTERIORES, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.07.01', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.07.02', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.08.01', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.08.02', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.09.01', 'TERMOS DE PARCERIA A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.09.02', 'TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.10.01', 'TERMOS DE PARCERIA A PAGAR DO EXERCICIO - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.10.02', 'TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.11.01', 'TERMO DE COMPROMISSO A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.11.02', 'TERMO DE COMPROMISSO A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.12.00', 'TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS -PORTAL', 'COMPREENDE OS VALORES DEVOLVIDOS REFERENTES A TRANSFERENCIAS VOLUNTARIAS FIRMADAS - CONVENIOS E CONTRATOS DE REPASSE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.13.01', 'PRECATORIOS DE TERCEIROS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.13.02', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.13.03', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000', 'REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.14.01', 'COMPENSACAO PREVIDENCIARIA DO EXERCICIO', 'REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.14.02', 'COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES', 'REGISTRA O VALOR DAS OBRIGACOES DE EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.15.00', 'TAXA DE FISCALIZACAO DE FUNCIONAMENTO - TFF', 'REGISTRA AS OBRIGACOES REFERENTES A TAXA DE FISCALIZACAO DE FUNCIONAMENTO - (TFF).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.16.00', 'OPERACOES COM DERIVATIVOS', 'REGISTRA AS OBRIGACOES DECORRENTES DE OPERACOES COM DERIVATIVOS REALIZADAS PELO BANCO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.17.00', 'DESPESAS ADMINISTRATIVAS - FUNDOS CONSTITUCIONAIS DE FINANCIAMENTO', 'REGISTRA AS OBRIGACOES DECORRENTES DE DESPESAS ADMINISTRATIVAS DOS FUNDOS CONSTITUCIONAIS DE FINANCIAMENTO, TAIS COMO TAXAS DE ADMINISTRACAO PAGAS AS INSTITUICOES FINANCEIRAS, REMUNERACAO DE AGENTES ETC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.18.00', 'DIVIDAS COM RESSARCIMENTO / COMISSOES - FMM', 'REGISTRA OS VALORES DAS OBRIGACOES COM DESPESAS DE RESSARCIMENTOS E COMISSOES DO FUNDO MARINHA MERCANTE, DEVIDAS AS EMPRESAS MARITIMAS E BNDES RESPECTIVAMENTE, MAS QUE AINDA NAO POSSUEM AUTORIZACAO LEGISLATIVA PARA EXECUCAO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.19.01', 'BOLSAS DE ESTUDOS - EXERCICIO', 'REGISTRA AS OBRIGACOES DO EXERCICIO RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.19.02', 'BOLSAS DE ESTUDOS - EXERCICIOS ANTERIORES', 'REGISTRA AS OBRIGACOES DE EXERCICIOS ANTERIORES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.20.00', 'CONTRATOS DE GESTAO', 'REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.21.00', 'SERVICOS EVENTUAIS - PESSOAL TECNICO', 'REGISTRA AS OBRIGACOES COM PESSOAL TECNICO CONTRATADO POR TEMPO DETERMINADO PARA DESEMPENHO DE TECNICAS ESPECIALIZADAS EM AMBITO DE PROJETOS DE COOPERACAO NOS TERMOS DA LEI 8745/93 CONFORME DECRETO Nº 4748/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.22.01', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO', 'REGISTRA OS VALORES DO EXERCICIO EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.22.02', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO ANTERIOR', 'REGISTRA OS VALORES DE EXERCICIOS ANTERIORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.23.01', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.23.02', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO ANTERIOR', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.24.00', 'RESIDUOS DE CONTRATOS LIQUIDADOS - FCVS', 'REGISTRA AS OBRIGACOES DECORRENTES DA COBERTURA FINANCEIRA, PELO FCVS,DOS CONTRATOS LIQUIDADOS PELOS ADQUIRENTES POR DECURSO DE PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.01', 'MERENDA ESCOLAR - PNAE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ALIMENTACAO ESCOLAR - PNAE, COM OBJETIVO DE PRESTAR ASSISTENCIA FINANCEIRA, EM CARATER SUPLEMENTAR AS ESCOLAS PUBLICAS DE ENSINO FUNDAMENTAL DAS REDES ESTADUAIS, MUNICIPAIS E DO DISTRITO FEDERAL E AS ESCOLAS DE EDUCACAO ESPECIAL QUALIFICADAS COMO ENTIDADES FILANTROPICAS OU POR ELAS MANTIDAS. A ASSISTENCIA FINANCEIRA A SER CONCEDIDA A CADA ESTABELECIMENTO DE ENSINO BENEFICIARIO SERA DEFINIDA ANUALMENTE E TERA COMO BASE O NUMERO DE ALUNOS MATRICULADOS NO ENSINO FUNDAMENTAL E ESPECIAL, DE ACORDO COM DADOS EXTRAIDOS DO CENSO ESCOLAR REALIZADO PELO MINISTERIO DA EDUCACAO NO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.02', 'DINHEIRO DIRETO NA ESCOLA - PDDE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE), DESTINADOS AS ESCOLAS DE EDUCACAO ESPECIAL,QUALIFICADAS COMO ENTIDADES FILANTROPICAS OU POR ELAS MANTIDAS PARA COBERTURA DE DESPESA COM CUSTEIO, MANUTENCAO E PEQUENOS INVESTIMENTOS, CONFORME RESOLUCAO CD/FNDE N 04/2003. .', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.03', 'TRANSPORTE ESCOLAR - PNTE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DE TRANSPORTE ESCOLAR (PNTE), CONFORME RESOLUCAO CD/FNDE Nº 09/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.04', 'FUNDO MANUTENCAO E DESENVOLVIMENTO DO ENSINO FUNDAMENTAL - FUNDEF', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DO ENSINO FUNDAMENTAL E VALORIZACAO DO MAGISTERIO - FUNDEF, LEI 9.424/96', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.05', 'FUNDO DE FORTALECIMENTO DA ESCOLA- FUNDESCOLA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA FUNDO DE FORTALECIMENTO DA ESCOLA - FUNDESCOLA, PARA FINANCIAMENTO DE PROJETOS EDUCACIONAIS A ORGAOS OU ENTIDADES FEDERAIS, ESTADUAIS E MUNICIPAIS, CUJAS AS ACOES ESTEJAM VOLTADAS PARA O DESENVOLVIMENTO DO ENSINO PUBLICO FUNDAMENTAL REGULAR EM ZONAS DE ATENDIMENTO PRIORITARIO DOS ESTADOS DO NORTE, NORDESTE E CENTRO-OESTE. RESOLUCAO CD/FNDE Nº 10/2002', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.06', 'QUOTA ESTADUAL - SALARIO EDUCACAO', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO A QUOTA ESTADUAL DO SALARIO EDUCACAO, CONFORME LEI 9.766/98.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.07', 'EDUCACAO DE JOVENS E ADULTOS - EJA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS VISANDO ATENDER AO PROGRAMA DE EDUCACAO DE JOVENS E ADULTOS(EJA), OS QUAIS SERAO DESTINADOS A AMPLIACAO DA OFERTA DE VAGAS NA EDUCACAO FUNDAMENTAL CUJOS BENEFICIARIOS SAO ALUNOS DA ESCOLA PUBLICA ESTADUAL E MUNICIPAL DO ENSINO FUNDAMENTAL, MATRICULADOS NOS CURSOS DA MODALIDADE "SUPLETIVO PRESENCIAL COM AVALIACAO NO PROCESSO". RESOLUCAO CD/FNDE N.05/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.08', 'PROGRAMA DE ATENDIMENTO EDUCACIONAL AS PESSOAS PORTADORES DE DEFICIENCIA - PAED', 'REGISTRA OS VALORES AS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DE ATENDIMENTO EDUCACIONAL ESPECIALIZADO AS PESSOAS PORTADORAS DE DEFICIENCIA - PAED - INSTITUIDA PELA LEI N 10.845/2004.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.09', 'BOLSA PROGRAMA FORMACAO INICIAL E CONTINUADA', 'REGISTRA OS VALORES REFERENTES A REPASSES DE BENEFICIOS DO PROGRAMA BOLSA ESCOLA, CONFORME LEI 10.219/2001.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.10', 'APOIO AO TRANSPORTE DO ESCOLAR - PNATE', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO TRANSPORTE DO ESCOLAR - PNATE CONFORME MP Nº 173/2004, DOU 17/03/04', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.11', 'APOIO A EDUCACAO DE JOVENS E ADULTOS - PEJA', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO A EDUCACAO DE JOVENS E ADULTOS - PEJA - CONFORME MP Nº 173/2004, DOU 17/03/04.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.12', 'PROGRAMA BRASIL ALFABETIZADO - CONVENIOS', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). ESTA CONTA E UTILIZADA PARA CONVENIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.13', 'DINHEIRO DIRETO NA ESCOLA - PDDEF/PAPE', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE) DO PROJETO DE ADEQUACAO DE PREDIOS ESCOLARES DO FUNDESCOLA - PDDEF/PAPE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.14', 'DINHEIRO DIRETO NA ESCOLA - PDDEF/PME', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE) DO PROJETO DE ADEQUACAO DE PREDIOS ESCOLARES DO FUNDESCOLA - PDDEF/PME.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.15', 'BOLSA ESCOLA DE FABRICA', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA E A LEI Nº 11.273, DE 06 DE FEVEREIRO DE 2006, QUE ATUALIZA A CONCESSAO DE BOLSA DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.16', 'FORMACAO DE PROFESSORES', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA FORMACAO DE PROFESSORES (LEIS 11.180,23/9/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.17', 'PROINFANTIL', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO RSCOLA DE GABRICA(PROINFANTIL) (LEIS 11.180, DE 23 /09/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.18', 'PROFORMACAO', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA (PROFORMACAO) LEIS 11.180, DE 23/09/05, E A LEI 11.273, DE 06/02/06, QUE AUTORIZA A CONCESSAO DE BOLSA DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.19', 'PROLICENCIATURA', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA (PROLICENCIATURA) (LEIS 11.180, DE23/9/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.20', 'PROGRAMA UNIVERSIDADE ABERTA DO BRASIL', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA UNIVERSIDADE ABERTA DO BRASIL - CONFORME DECRETO Nº 5.800 DE 08JUN2006. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.21', 'BOLSAS BRASIL ALFABETIZADO', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI Nº 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). (UTILIZADA PARA BOLSAS).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.22', 'PROGRAMA BRASIL ALFABETIZADO - TRANSF. AUTOMATICAS', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). (UTILIZADA PARA TRANSFERENCIAS AUTOMATICAS)', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.23', 'FUNDO DE MANUTENCAO E DES. DA EDUCACAO BASICA - FUNDEB', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA - FUNDEB, RESOLUCAO MEC Nº. 01/2007 DE 15 DE FEVEREIRO DE 2007.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.24', 'PROJOVEM URBANO', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, EFETUADOS PELO FUNDO NACIONAL DE DESENVOLVIMENTO DE EDUCACAO - FNDE PARA ATENDER JOVENS DE 15 A 29 ANOS COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL,SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. BASE LEGAL: MEDIDA PROVISORIA Nº Nº 411, DE 28 DE DEZEMBRO DE 2007. LEI Nº 11.129, DE 30 DE JUNHO DE 2005.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.25', 'PROJOVEM CAMPO - SABERES DA TERRA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, EFETUADOS PELO FUNDO NACIONAL DE DESENVOLVIMENTO DE EDUCACAO - FNDE PARA ATENDER JOVENS DE 15 A 29 ANOS COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL, SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. BASE LEGAL: MEDIDA PROVISORIA Nº Nº 411, DE 28 DE DEZEMBRO DE 2007. LEI Nº 11.129, DE 30 DE JUNHO DE 2005.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.26', 'PROJOVEM TRABALHADOR', 'REGISTRA OS VALORES A PAGAR DAS TRANSFERENCIAS LEGAIS DECORRENTES DE TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO - MTEE OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, CUJO OBJETIVO E TRANSFE-RIR RECURSOS SEM A NECESSIDADE DE CONVENIO, ACORDO, CONTRATO, AJUSTE OU INSTRUMENTO CONGENERE, CONFORME DISPOE O ART.39 DO DECRETO Nº 6629/08, QUE REGULAMENTA A LEI 11692/2008 (DISPOE SOBRE O PROGRAMA NACIONAL DE INCLUSAO DE JOVENS AO MERCADO DE TRABALHO).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.27', 'TERMO DE CONCESSAO DE APOIO FINANCEIRO -ANCINE', 'REGISTRA OS VALORES A PAGAR DAS TRANSFERENCIAS LEGAIS DECORRENTES DE TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A ANCINE E AS ENTIDADES PRIVADAS COM FINS LUCRATIVOS (MP 2228-1/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.28', 'PROGRAMA PRIMEIRO EMPREGO - PNPE', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ESTIMULO AO PRIMEIRO EMPREGO PARA OS JOVENS - PNPE, CONFORME LEI Nº 10.748, DE 22 DE OUTUBRO DE 2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.29', 'PROGRAMA ESPECIAL DE FORTALECIMENTO DO ENSINO MEDIO', 'REGISTRA VALORES A LIBERAR DE TRANSFERENCIAS DE RECURSOS PARA ATENDIMENTO DO PROGRAMA ESPECIAL DE FORTALECIMENTO DO ENSINO MEDIO, CONFORME MEDIDA PROVISORIA Nº Nº 484, DE 30 DE MARCO DE 2010.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.30', 'PROG.ESP. DE RECUP.REDE FISICA ESCOLA PUBLICA', 'REGISTRA VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA ESPECIAL DE RECUPERACAO DAS REDES FISICAS ESCOLARES PUBLICAS ESTADUAIS E MUNICIPAIS AFETADAS POR DESASTRES NATURAIS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.31', 'PROINFANCIA-MANUTENCAO', 'REGISTRA OS VALORES DAS TRANSFERENCIAS AOS MUNICIPIOS E AO DISTRITO FEDERAL,COM A FINALIDADE DE PRESTAR APOIO FINANCEIRO A MANUTENCAO DE NO-VOS ESTABELECIMENTOS PUBLICOS DE EDUCACAO INFANTIL(VISANDO O ATENDIMENTO DA MP 533,DE 10/05/2011).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.32', 'PAC 2 PROINFANCIA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS PARA CONSTRUCAO DA REDE ESCOLAR PUBLICA DE EDUCACAO INFANTIL - CONSTRUCAO DE CRECHES. (LEI Nº 11.578, DE 26/11/2007, CONSTA NA MSG 2011/0485958-UG 150003).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.33', 'PAC 2 QUADRAS', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS PARA CONTRUCAO DA REDE ESCOLAR PUBLICA DE EDUCACAO INFANTIL - CONSTRUCAO DE QUADRAS POLIESPORTIVAS COBERTAS. (LEI Nº 11.578, DE 26/11/2007, MSG 2011/0485958 DA UG_150003).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.34', 'CAMINHO DA ESCOLA - PTC', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS VISANDO ATENDER AO PROGRAMA TERRITORIOS DA CIDADANIA -PTC, DESTINADOS A AQUISICAO DE VEICULOS PARA TRANSPORTAR ALUNOS AS ESCOLAS. LEI 12.249/2010.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.35', 'PRONATEC', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ACESSO AO ENSINO TECNICO E EMPREGO - PRONATEC, CONFORME LEI Nº 12.513, DE 26 DE OUTUBRO DE 2011.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.36', 'PLANO DE ACOES ARTICULADAS - PAR', 'REGISTRAR AS TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS REFERENTES AO PLANO DE ACOES ARTICULADAS, VISANDO ATENDER À MEDIDA PROVISÓRIA Nº 562 DE 20 DE MARCO DE 2012.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.37', 'PROGRAMA AUXILIO DE AVALIACAO EDUCACIONAL-AAE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DE AUXILIO DE AVALIACAO EDUCACIONAL-AAE, CONFORME A LEI Nº 11.507, DE 20 DE JULHO DE 2007.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.38', 'ACOES E SERVICOS DE SAUDE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FEDERAIS PARA ACOE E SERVICOS DE SAUDE, NA FORMA DE BLOCOS DE FINANCIAMENTO, CONFORME DEFINIDO NA PORTARIA MS 204, DE 29 DE JANEIRO DE 2007. BLOCOS DE FINANCIAMENTO: 1 - ATENCAO BASICA; 2 - ATENCAO DE MEDIA E ALTA COMPLEXIDADE AMBULATORIAL; 3 - VIGILANCIA EM SAUDE; 4 - ASSISTENCIA FARMACEUTICA; 5 - GESTAO DO SUS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.26.00', 'ENTIDADES CREDORAS - ESTADOS, DF E MUNICIPIOS', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DECORRENTES DE OBRIGACOES JUNTO A ESTADOS, DF E MUNICIPIOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.28.01', 'RESULTADO NEGATIVO DO BACEN - BALANCO APURADO', 'REGISTRA OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL CORRESPONDENTE AO APURADO NO BALANCO DE 31/12/XX DESTA INSTITUICAO A SER PAGO PELO TESOURO NACIONAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.28.02', 'RESULTADO NEGATIVO BACEN - CUSTO DAS RESERVAS', 'REGISTRA OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL CORRESPONDENTE AO CUSTO DAS RESERVAS DESTA INSTITUICAO A SER PAGO PELO TESOURO NACIONAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.29.00', 'EMPRESTIMOS E FINANCIAMENTOS A LIBERAR', 'REGISTRA A APROPRIACAO DE VALORES A SEREM LIBERADOS, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.30.00', 'INCENTIVOS A LIBERAR', 'REGISTRA O VALOR DOS INCENTIVOS FISCAIS A LIBERAR POR OCASIAO DA CLASSIFICACAO DA RECEITA ARRECADADA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.31.00', 'COMPENSACAO DE CONTRIBUICOES PREVIDENCIARIAS', 'REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS EFETIVADAS PELAS UG DO INSS, A SEREM RECOLHIDAS POR GPS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.32.01', 'ADIANTAMENTOS DE OPERACOES ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS AOS RECURSOS FINANCEIROS RECEBIDOS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE O MINISTERIO DAS RELACOES EXTERIORES E OUTRAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.32.02', 'ADIANTAMENTOS DE UNIDADES E ENTIDADES', 'REGISTRA OS VALORES EXIGIVEIS RELATIVOS A ADIANTAMENTOS CONCEDIDOS POR ORGAOS E ENTIDADES, INCLUSIVE UNIDADES GESTORAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.32.03', 'ADIANTAMENTOS DIVERSOS RECEBIDOS', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.33.02', 'OPERACOES COM DERIVATIVOS - SWAP', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - SWAP', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.33.03', 'OPERACOES COM DERIVATIVOS - FORWARD', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - FORWARD', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.33.04', 'OPERACOES COM DERIVATIVOS - FUTUROS', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - FUTUROS', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.33.05', 'OPERACOES COM DERIVATIVOS - TERMO', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - TERMO', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.34.01', 'VALORES DE INVESTIMENTOS A PAGAR', 'REGISTRA OS VALORES DE INVESTIMENTOS REALIZADOS NO MERCADO FINANCEIRO E NAO LIQUIDADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.35.01', 'GRU - VALORES EM TRANSITO PARA ESTORNO DESPESA', 'REGISTRA OS VALORES RECEBIDOS POR GRU A TITULO DE ESTORNO DE DESPESA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.35.02', 'ORDENS BANCARIAS A EMITIR', 'REGISTRA OS VALORES A LIBERAR A TITULO DE SUBREPASSE PARA AS UNIDADES GESTORAS DO EXTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.35.03', 'ORDENS BANCARIAS CANCELADAS', 'REGISTRA OS VALORES DE ORDENS BANCARIAS CANCELADAS PELO ORDENADOR DE DESPESA APOS REMESSA DE RELACAO AO BANCO, OU POR ESTE NA FALTA DE AUTORIZACAO DE PAGAMENTO PELO ORDENADOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.35.04', 'GRU A CLASSIFICAR - VALORES EM TRANSITO', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS POR MEIO DE GUIA DE RECOLHIMENTO DA UNIAO A CLASSIFICAR DE VALORES EM TRANSITO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.35.05', 'GRU A CLASSIFICAR - ROTINA AUTOMATICA', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS POR MEIO DE GUIA DE RECOLHIMENTO DA UNIAO A CLASSIFICAR DECORRENTES DE ROTINA AUTOMATICA(FUGA).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.35.06', 'SALDOS BANCARIOS EM UTILIZACAO', 'REGISTRA O VALOR DA APROPRIACAO DOS SALDOS BANCARIOS EM PROCESSO DE UTILIZACAO DE ACORDO COM CONTRATOS ASSINADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.35.07', 'DEPOSITO CONTA UNICA E INSTIT. A CLASSIFICAR', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS DIRETAMENTE NA CONTA UNICA INSTITUCIONAL', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.35.08', 'DEPOSITO CTU A CLASSIFICAR CODIGO PADRAO', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS DIRETAMENTE NA CONTA UNICA REFERENTE AOS CODIGOS PADRAO CRIADOS PELA COORDENACAO-GERAL DE CONTABILIDADE DA UNIAO (CCONT).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.35.09', 'SAQUE - CARTAO DE PAGAMENTO DO GOVERNO FEDERAL', 'REGISTRA OS VALORES REFERENTES AS DESPESAS COM SUPRIMENTO DE FUNDOS, PENDENTES DE SAQUE COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.35.10', 'FATURA - CARTAO DE PAGAMENTO DO GOVERNO FEDERAL', 'REGISTRA OS VALORES REFERENTES AS DESPESAS COM SUPRIMENTO DE FUNDOS, PENDENTES DE PAGAMENTO DA FATURA COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.35.11', 'TRANSFERENCIA AO BB - OB SAQUE CARTAO', 'REGISTRA OS VALORES REFERENTES AS TRANSFERENCIAS DE RECURSOS AO BANCO DO BRASIL, RELATIVAS AOS SAQUES DE OB CARTAO EFETUADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.35.12', 'ORDENS BANCARIAS CANCELADAS (CARTAO CREDITO)', 'REGISTRA OS VALORES DE ORDENS BANCARIAS CANCELADAS PELO AGENTE FINANCEIRO, REFERENTE AO CARTAO DE CREDITO CORPORATIVO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.36.01', 'SUBVENCOES A PAGAR DO EXERCICIO', 'REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.36.02', 'SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.37.00', 'RESTITUICOES DE RECEITAS A PAGAR', 'REGISTRA O VALOR DAS RESTITUICOES DE RECEITAS A PAGAR APROPRIADAS PELAS UNIDADES GESTORAS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.38.00', 'TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS NAO EFETUADAS PELO PORTAL SICONV', 'REGISTRA OS VALORES DE DEVOLUCOES DE RECURSOS DE TRANSFERENCIAS VOLUNTARIAS, NAO GERADAS PELO PORTAL DE CONVENIOS, PARA POSTERIOR RECOLHIMENTO AO CONCEDENTE OU AO TESOURO NACIONAL POR MEIO DE GRU.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.01', 'RECURSOS A LIBERAR POR TRANSFERENCIA', 'REGISTRA OS VALORES A LIBERAR DA GESTAO TESOURO PARA A GESTAO FUNDO DA CAMARA E DO SENADO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.02', 'TRANSFERENCIAS ORCAMENTARIAS A LIBERAR PARA O DISTRITO FEDERAL', 'REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA A FAVOR DO DISTRITO FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.03', 'TRANSFERENCIAS ORCAMENTARIAS A LIBERAR PARA OS ESTADOS', 'REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA A FAVOR DE ESTADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.04', 'RECURSOS A LIBERAR POR VINCULACAO DE PAGAMENTO', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO, ESTABELECIDO PELO ORGAO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.05', 'RECURSOS A RESTITUIR - ADIANTAMENTOS RECEBIDOS PELO INSS', 'REGISTRA OS RECURSOS A RESTITUIR DE ADIANTAMENTOS RECEBIDOS PELO INSS EM DECORRENCIA DA ARRECADACAO DE PASSIVOS POR DARF E TRANSFERENCIA POR GPS PELA COFIN PARA O INSS. A CONTA SERA UTILIZADA QUANDO O VALOR A TRANSFERIR FOR MAIOR QUE O VALOR ARRECADADO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.06', 'RECURSOS ORCAMENTARIOS A LIBERAR', 'REGISTRA OS RECURSOS A LIBERAR REFERENTE AS PARCELAS NAO RECEBIDAS DO ORCAMENTO PARA A ENTIDADES DA ADMINISTRACAO INDIRETA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.07', 'RECURSOS A LIBERAR P/ VINCULACAO DE PAGAMENTO PARA O INSS', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO PARA O INSS, ESTABELECIDO PELO ORGAO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.08', 'RECURSOS A LIBERAR PARA EMPENHO CONTRA ENTREGA', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE PARA PAGAMENTO DE EMPENHO CONTRA ENTREGA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.09', 'RECURSOS DA PREVIDENCIA SOCIAL - BENEFICIOS', 'REGISTRA OS RECURSOS A LIBERAR REFERENTES AOS BENEFICIOS DA PREVIDENCIA SOCIAL', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.10', 'RECURSOS DA PREVIDENCIA SOCIAL - TERCEIROS', 'REGISTRA OS RECURSOS A LIBERAR REFERENTES A DEPOSITOS DE TERCEIROS PARA A PREVIDENCIA SOCIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.11', 'REMUNERACAO DA DISPONIBILIDADE CONTA UNICA INSS - BACEN', 'REGISTRA O VALOR DAS OBRIGACOES REFERENTES A REMUNERACAO DA DISPONIBILIDADE DA CTU INSS NO BACEN.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.12', 'LIMITE DE SAQUE RECURSOS DA DIVIDA PUBLICA', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR DA SUB-CONTA DA DIVIDA PUBLICA NO BANCO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.13', 'RECURSOS VINCULADOS - ENTIDADES TCT', 'REGISTRA O VALOR DOS RECURSOS VINCULADO REFERENTE A ENTIDADES QUE UTILIZAM A CONTA UNICA EM CUMPRIMENTO AO TERMO DE COOPERACAO TECNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.14', 'REC. A COMPENSAR P/ PERDAS EM APLICACOES NA CONTA UNICA', 'REGISTRA O VALOR DE RECURSOS A COMPENSAR POR PERDAS EM APLICACOES FINANCEIRAS NA CONTA UNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.40.01', 'PERDAS EM PARTICIPACAO EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO', 'COMPREENDE OS VALORES REFERENTES A PARTICIPACOES PELO METODO DA EQUIVALENCIA PATRIMONIAL EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO (PASSIVO A DESCOBERTO).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.40.99', 'PERDAS EM PARTICIPACAO - EMPRESAS DEPENDENTES', 'REGISTRA OS VALORES DAS PARTICIPACOES DA UNIAO NO PL NEGATIVO DAS EMPRESAS CONTROLADAS DEPENDENTES, PARA QUE OS REFERIDOS VALORES SEJAM EXPURGADOS NA CONSOLIDACAO DAS DEMONSTRACOES CONTABEIS DA UNIAO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.41.00', 'CONTRIBUICAO AO FUST A RECOLHER', 'REGISTRA OS VALORES DEVIDOS PELA UNIDADE EM FUNCAO DA RECEITA OPERACIONAL BRUTA, DECORRENTE DA PRESTACAO DE SERVICOS DE TELECOMUNICACOES NOS REGIMES PUBLICO E PRIVADO, EXCLUINDO-SE O ICMS, O PIS E A COFINS INCIDENTES SOBRE A MESMA BASE DE CALCULO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.44.00', 'OBRIGACOES A PAGAR EM MOEDA ESTRANGEIRA', 'REGISTRA OS VALORES DAS OBRIGACOES A PAGAR EM MOEDA ESTRANGEIRA, INCLUSIVE AS DESPESAS COM ADMINISTRACAO TERCEIRIZADA DE RECURSOS EM MOEDA ESTRANGEIRA. CONTA EXCLUSIVA DO BANCO CENTRAL DO BRASIL', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.45.00', 'RECURSOS DA GRU', 'REGISTRA O VALOR DOS CREDITOS DE GUIA DE RECOLHIMENTO DA UNIAO - GRU INTRA SIAFI.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.46.00', 'RECURSOS FISCAIS', 'REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELO TESOURO NACIONAL A SEREM POSTERIORMENTE CLASSIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.47.00', 'RESTITUICAO DE RECEITAS RECEBIDAS GRU', 'REGISTRA OS VALORES RELATIVOS A RESTITUICAO DE RECEITAS RECEBIDAS POR GRU.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.98.01', 'OUTROS CREDORES DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES NO EXERCICIO, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.98.02', 'OUTROS CREDORES DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCICIOS ANTERIORES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.01.01', 'INDENIZACOES A SERVIDORES', 'REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.01.02', 'INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.01.03', 'INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.01.04', 'RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS', 'REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS EFETIVADAS PELAS UG DO INSS, A SEREM PAGAS ATRAVES DE OB.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.02.00', 'DIARIAS A PAGAR', 'REGISTRA OS VALORES RELATIVOS AS DIARIAS A PAGAR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.03.00', 'SUPRIMENTOS DE FUNDOS A PAGAR', 'REGISTRA OS VALORES RELATIVOS AOS SUPRIMENTOS DE FUNDOS A PAGAR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.04.01', 'SALARIO-FAMILIA A PAGAR', 'REGISTRA OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM O DESEMBOLSO A TITULO DE SALARIO FAMILIA A SEUS EMPREGADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.04.02', 'AUXILIO - NATALIDADE A PAGAR', 'REGISTRA OS VALORES A SEREM PAGOS PELO INSS, A TITULO DE REEMBOLSO DO AUXILIO-NATALIDADE PAGO PELAS ENTIDADES A SEUS EMPREGADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.04.03', 'DEBITOS EM APURACAO - INSS', 'REGISTRA OS VALORES EM APURACAO A SEREM RESSARCIDOS PELO INSS A ENTIDADES, DECORRENTES DE PAGAMENTOS OU ANTECIPACOES EFETUADAS POR ESTAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.04.04', 'DEBITOS POR PREMIOS DE SEGURO - COMPREENSIVO - INSS', 'REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS AS COMPANHIAS SEGURADORAS, POR PREMIOS DE SEGURO PAGOS A MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO - LEI Nº 4380/64.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.04.99', 'OUTROS DEBITOS POR INDENIZACAO E ANTECIPACOES - INSS', 'REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS POR PAGAMENTOS OU ANTECIPACOES REALIZADAS POR ENTIDADES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.05.01', 'CONVENIOS A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.05.02', 'CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.06.01', 'CONVENIOS A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DO EXERCICIO, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.06.02', 'CONVENIOS A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DE EXERCICIOS ANTERIORES, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.07.01', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.07.02', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.08.01', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.08.02', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.09.01', 'TERMOS DE PARCERIA A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.09.02', 'TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.10.01', 'TERMOS DE PARCERIA A PAGAR DO EXERCICIO - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.10.02', 'TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.11.01', 'TERMO DE COMPROMISSO A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.11.02', 'TERMO DE COMPROMISSO A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.12.00', 'TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS -PORTAL', 'COMPREENDE OS VALORES DEVOLVIDOS REFERENTES A TRANSFERENCIAS VOLUNTARIAS FIRMADAS - CONVENIOS E CONTRATOS DE REPASSE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.13.01', 'PRECATORIOS DE TERCEIROS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.13.02', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.13.03', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000', 'REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.14.01', 'COMPENSACAO PREVIDENCIARIA DO EXERCICIO', 'REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.14.02', 'COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES', 'REGISTRA O VALOR DAS OBRIGACOES DE EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.15.00', 'TAXA DE FISCALIZACAO DE FUNCIONAMENTO - TFF', 'REGISTRA AS OBRIGACOES REFERENTES A TAXA DE FISCALIZACAO DE FUNCIONAMENTO - (TFF).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.16.00', 'OPERACOES COM DERIVATIVOS', 'REGISTRA AS OBRIGACOES DECORRENTES DE OPERACOES COM DERIVATIVOS REALIZADAS PELO BANCO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.17.00', 'DESPESAS ADMINISTRATIVAS - FUNDOS CONSTITUCIONAIS DE FINANCIAMENTO', 'REGISTRA AS OBRIGACOES DECORRENTES DE DESPESAS ADMINISTRATIVAS DOS FUNDOS CONSTITUCIONAIS DE FINANCIAMENTO, TAIS COMO TAXAS DE ADMINISTRACAO PAGAS AS INSTITUICOES FINANCEIRAS, REMUNERACAO DE AGENTES ETC.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.18.00', 'DIVIDAS COM RESSARCIMENTO / COMISSOES - FMM', 'REGISTRA OS VALORES DAS OBRIGACOES COM DESPESAS DE RESSARCIMENTOS E COMISSOES DO FUNDO MARINHA MERCANTE, DEVIDAS AS EMPRESAS MARITIMAS E BNDES RESPECTIVAMENTE, MAS QUE AINDA NAO POSSUEM AUTORIZACAO LEGISLATIVA PARA EXECUCAO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.19.01', 'BOLSAS DE ESTUDOS - EXERCICIO', 'REGISTRA AS OBRIGACOES DO EXERCICIO RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.19.02', 'BOLSAS DE ESTUDOS - EXERCICIOS ANTERIORES', 'REGISTRA AS OBRIGACOES DE EXERCICIOS ANTERIORES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.20.00', 'CONTRATOS DE GESTAO', 'REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.21.00', 'SERVICOS EVENTUAIS - PESSOAL TECNICO', 'REGISTRA AS OBRIGACOES COM PESSOAL TECNICO CONTRATADO POR TEMPO DETERMINADO PARA DESEMPENHO DE TECNICAS ESPECIALIZADAS EM AMBITO DE PROJETOS DE COOPERACAO NOS TERMOS DA LEI 8745/93 CONFORME DECRETO Nº 4748/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.22.01', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO', 'REGISTRA OS VALORES DO EXERCICIO EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.22.02', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO ANTERIOR', 'REGISTRA OS VALORES DE EXERCICIOS ANTERIORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.23.01', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.23.02', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO ANTERIOR', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.24.00', 'RESIDUOS DE CONTRATOS LIQUIDADOS - FCVS', 'REGISTRA AS OBRIGACOES DECORRENTES DA COBERTURA FINANCEIRA, PELO FCVS,DOS CONTRATOS LIQUIDADOS PELOS ADQUIRENTES POR DECURSO DE PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.01', 'MERENDA ESCOLAR - PNAE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ALIMENTACAO ESCOLAR - PNAE, COM OBJETIVO DE PRESTAR ASSISTENCIA FINANCEIRA, EM CARATER SUPLEMENTAR AS ESCOLAS PUBLICAS DE ENSINO FUNDAMENTAL DAS REDES ESTADUAIS, MUNICIPAIS E DO DISTRITO FEDERAL E AS ESCOLAS DE EDUCACAO ESPECIAL QUALIFICADAS COMO ENTIDADES FILANTROPICAS OU POR ELAS MANTIDAS. A ASSISTENCIA FINANCEIRA A SER CONCEDIDA A CADA ESTABELECIMENTO DE ENSINO BENEFICIARIO SERA DEFINIDA ANUALMENTE E TERA COMO BASE O NUMERO DE ALUNOS MATRICULADOS NO ENSINO FUNDAMENTAL E ESPECIAL, DE ACORDO COM DADOS EXTRAIDOS DO CENSO ESCOLAR REALIZADO PELO MINISTERIO DA EDUCACAO NO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.02', 'DINHEIRO DIRETO NA ESCOLA - PDDE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE), DESTINADOS AS ESCOLAS DE EDUCACAO ESPECIAL,QUALIFICADAS COMO ENTIDADES FILANTROPICAS OU POR ELAS MANTIDAS PARA COBERTURA DE DESPESA COM CUSTEIO, MANUTENCAO E PEQUENOS INVESTIMENTOS, CONFORME RESOLUCAO CD/FNDE N 04/2003. .', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.03', 'TRANSPORTE ESCOLAR - PNTE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DE TRANSPORTE ESCOLAR (PNTE), CONFORME RESOLUCAO CD/FNDE Nº 09/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.04', 'FUNDO MANUTENCAO E DESENVOLVIMENTO DO ENSINO FUNDAMENTAL - FUNDEF', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DO ENSINO FUNDAMENTAL E VALORIZACAO DO MAGISTERIO - FUNDEF, LEI 9.424/96', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.05', 'FUNDO DE FORTALECIMENTO DA ESCOLA- FUNDESCOLA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA FUNDO DE FORTALECIMENTO DA ESCOLA - FUNDESCOLA, PARA FINANCIAMENTO DE PROJETOS EDUCACIONAIS A ORGAOS OU ENTIDADES FEDERAIS, ESTADUAIS E MUNICIPAIS, CUJAS AS ACOES ESTEJAM VOLTADAS PARA O DESENVOLVIMENTO DO ENSINO PUBLICO FUNDAMENTAL REGULAR EM ZONAS DE ATENDIMENTO PRIORITARIO DOS ESTADOS DO NORTE, NORDESTE E CENTRO-OESTE. RESOLUCAO CD/FNDE Nº 10/2002', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.06', 'QUOTA ESTADUAL - SALARIO EDUCACAO', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO A QUOTA ESTADUAL DO SALARIO EDUCACAO, CONFORME LEI 9.766/98.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.07', 'EDUCACAO DE JOVENS E ADULTOS - EJA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS VISANDO ATENDER AO PROGRAMA DE EDUCACAO DE JOVENS E ADULTOS(EJA), OS QUAIS SERAO DESTINADOS A AMPLIACAO DA OFERTA DE VAGAS NA EDUCACAO FUNDAMENTAL CUJOS BENEFICIARIOS SAO ALUNOS DA ESCOLA PUBLICA ESTADUAL E MUNICIPAL DO ENSINO FUNDAMENTAL, MATRICULADOS NOS CURSOS DA MODALIDADE "SUPLETIVO PRESENCIAL COM AVALIACAO NO PROCESSO". RESOLUCAO CD/FNDE N.05/2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.08', 'PROGRAMA DE ATENDIMENTO EDUCACIONAL AS PESSOAS PORTADORES DE DEFICIENCIA - PAED', 'REGISTRA OS VALORES AS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DE ATENDIMENTO EDUCACIONAL ESPECIALIZADO AS PESSOAS PORTADORAS DE DEFICIENCIA - PAED - INSTITUIDA PELA LEI N 10.845/2004.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.09', 'BOLSA PROGRAMA FORMACAO INICIAL E CONTINUADA', 'REGISTRA OS VALORES REFERENTES A REPASSES DE BENEFICIOS DO PROGRAMA BOLSA ESCOLA, CONFORME LEI 10.219/2001.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.10', 'APOIO AO TRANSPORTE DO ESCOLAR - PNATE', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO TRANSPORTE DO ESCOLAR - PNATE CONFORME MP Nº 173/2004, DOU 17/03/04', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.11', 'APOIO A EDUCACAO DE JOVENS E ADULTOS - PEJA', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO A EDUCACAO DE JOVENS E ADULTOS - PEJA - CONFORME MP Nº 173/2004, DOU 17/03/04.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.12', 'PROGRAMA BRASIL ALFABETIZADO - CONVENIOS', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). ESTA CONTA E UTILIZADA PARA CONVENIOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.13', 'DINHEIRO DIRETO NA ESCOLA - PDDEF/PAPE', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE) DO PROJETO DE ADEQUACAO DE PREDIOS ESCOLARES DO FUNDESCOLA - PDDEF/PAPE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.14', 'DINHEIRO DIRETO NA ESCOLA - PDDEF/PME', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE) DO PROJETO DE ADEQUACAO DE PREDIOS ESCOLARES DO FUNDESCOLA - PDDEF/PME.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.15', 'BOLSA ESCOLA DE FABRICA', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA E A LEI Nº 11.273, DE 06 DE FEVEREIRO DE 2006, QUE ATUALIZA A CONCESSAO DE BOLSA DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.16', 'FORMACAO DE PROFESSORES', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA FORMACAO DE PROFESSORES (LEIS 11.180,23/9/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.17', 'PROINFANTIL', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO RSCOLA DE GABRICA(PROINFANTIL) (LEIS 11.180, DE 23 /09/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.18', 'PROFORMACAO', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA (PROFORMACAO) LEIS 11.180, DE 23/09/05, E A LEI 11.273, DE 06/02/06, QUE AUTORIZA A CONCESSAO DE BOLSA DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.19', 'PROLICENCIATURA', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA (PROLICENCIATURA) (LEIS 11.180, DE23/9/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.20', 'PROGRAMA UNIVERSIDADE ABERTA DO BRASIL', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA UNIVERSIDADE ABERTA DO BRASIL - CONFORME DECRETO Nº 5.800 DE 08JUN2006. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.21', 'BOLSAS BRASIL ALFABETIZADO', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI Nº 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). (UTILIZADA PARA BOLSAS).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.22', 'PROGRAMA BRASIL ALFABETIZADO - TRANSF. AUTOMATICAS', 'REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). (UTILIZADA PARA TRANSFERENCIAS AUTOMATICAS)', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.23', 'FUNDO DE MANUTENCAO E DES. DA EDUCACAO BASICA - FUNDEB', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA - FUNDEB, RESOLUCAO MEC Nº. 01/2007 DE 15 DE FEVEREIRO DE 2007.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.24', 'PROJOVEM URBANO', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, EFETUADOS PELO FUNDO NACIONAL DE DESENVOLVIMENTO DE EDUCACAO - FNDE PARA ATENDER JOVENS DE 15 A 29 ANOS COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL,SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. BASE LEGAL: MEDIDA PROVISORIA Nº Nº 411, DE 28 DE DEZEMBRO DE 2007. LEI Nº 11.129, DE 30 DE JUNHO DE 2005.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.25', 'PROJOVEM CAMPO - SABERES DA TERRA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, EFETUADOS PELO FUNDO NACIONAL DE DESENVOLVIMENTO DE EDUCACAO - FNDE PARA ATENDER JOVENS DE 15 A 29 ANOS COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL, SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. BASE LEGAL: MEDIDA PROVISORIA Nº Nº 411, DE 28 DE DEZEMBRO DE 2007. LEI Nº 11.129, DE 30 DE JUNHO DE 2005.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.26', 'PROJOVEM TRABALHADOR', 'REGISTRA OS VALORES A PAGAR DAS TRANSFERENCIAS LEGAIS DECORRENTES DE TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO - MTEE OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, CUJO OBJETIVO E TRANSFE-RIR RECURSOS SEM A NECESSIDADE DE CONVENIO, ACORDO, CONTRATO, AJUSTE OU INSTRUMENTO CONGENERE, CONFORME DISPOE O ART.39 DO DECRETO Nº 6629/08, QUE REGULAMENTA A LEI 11692/2008 (DISPOE SOBRE O PROGRAMA NACIONAL DE INCLUSAO DE JOVENS AO MERCADO DE TRABALHO).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.27', 'TERMO DE CONCESSAO DE APOIO FINANCEIRO -ANCINE', 'REGISTRA OS VALORES A PAGAR DAS TRANSFERENCIAS LEGAIS DECORRENTES DE TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A ANCINE E AS ENTIDADES PRIVADAS COM FINS LUCRATIVOS (MP 2228-1/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.28', 'PROGRAMA PRIMEIRO EMPREGO - PNPE', 'REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ESTIMULO AO PRIMEIRO EMPREGO PARA OS JOVENS - PNPE, CONFORME LEI Nº 10.748, DE 22 DE OUTUBRO DE 2003.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.29', 'PROGRAMA ESPECIAL DE FORTALECIMENTO DO ENSINO MEDIO', 'REGISTRA VALORES A LIBERAR DE TRANSFERENCIAS DE RECURSOS PARA ATENDIMENTO DO PROGRAMA ESPECIAL DE FORTALECIMENTO DO ENSINO MEDIO, CONFORME MEDIDA PROVISORIA Nº Nº 484, DE 30 DE MARCO DE 2010.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.30', 'PROG.ESP. DE RECUP.REDE FISICA ESCOLA PUBLICA', 'REGISTRA VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA ESPECIAL DE RECUPERACAO DAS REDES FISICAS ESCOLARES PUBLICAS ESTADUAIS E MUNICIPAIS AFETADAS POR DESASTRES NATURAIS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.31', 'PROINFANCIA-MANUTENCAO', 'REGISTRA OS VALORES DAS TRANSFERENCIAS AOS MUNICIPIOS E AO DISTRITO FEDERAL,COM A FINALIDADE DE PRESTAR APOIO FINANCEIRO A MANUTENCAO DE NO-VOS ESTABELECIMENTOS PUBLICOS DE EDUCACAO INFANTIL(VISANDO O ATENDIMENTO DA MP 533,DE 10/05/2011).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.32', 'PAC 2 PROINFANCIA', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS PARA CONSTRUCAO DA REDE ESCOLAR PUBLICA DE EDUCACAO INFANTIL - CONSTRUCAO DE CRECHES. (LEI Nº 11.578, DE 26/11/2007, CONSTA NA MSG 2011/0485958-UG 150003).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.33', 'PAC 2 QUADRAS', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS PARA CONTRUCAO DA REDE ESCOLAR PUBLICA DE EDUCACAO INFANTIL - CONSTRUCAO DE QUADRAS POLIESPORTIVAS COBERTAS. (LEI Nº 11.578, DE 26/11/2007, MSG 2011/0485958 DA UG_150003).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.34', 'CAMINHO DA ESCOLA - PTC', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS VISANDO ATENDER AO PROGRAMA TERRITORIOS DA CIDADANIA -PTC, DESTINADOS A AQUISICAO DE VEICULOS PARA TRANSPORTAR ALUNOS AS ESCOLAS. LEI 12.249/2010.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.35', 'PRONATEC', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ACESSO AO ENSINO TECNICO E EMPREGO - PRONATEC, CONFORME LEI Nº 12.513, DE 26 DE OUTUBRO DE 2011.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.36', 'PLANO DE ACOES ARTICULADAS - PAR', 'REGISTRAR AS TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS REFERENTES AO PLANO DE ACOES ARTICULADAS, VISANDO ATENDER À MEDIDA PROVISÓRIA Nº 562 DE 20 DE MARCO DE 2012.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.37', 'PROGRAMA AUXILIO DE AVALIACAO EDUCACIONAL-AAE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DE AUXILIO DE AVALIACAO EDUCACIONAL-AAE, CONFORME A LEI Nº 11.507, DE 20 DE JULHO DE 2007.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.38', 'ACOES E SERVICOS DE SAUDE', 'REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FEDERAIS PARA ACOE E SERVICOS DE SAUDE, NA FORMA DE BLOCOS DE FINANCIAMENTO, CONFORME DEFINIDO NA PORTARIA MS 204, DE 29 DE JANEIRO DE 2007. BLOCOS DE FINANCIAMENTO: 1 - ATENCAO BASICA; 2 - ATENCAO DE MEDIA E ALTA COMPLEXIDADE AMBULATORIAL; 3 - VIGILANCIA EM SAUDE; 4 - ASSISTENCIA FARMACEUTICA; 5 - GESTAO DO SUS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.26.00', 'ENTIDADES CREDORAS - ESTADOS, DF E MUNICIPIOS', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DECORRENTES DE OBRIGACOES JUNTO A ESTADOS, DF E MUNICIPIOS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.28.01', 'RESULTADO NEGATIVO DO BACEN - BALANCO APURADO', 'REGISTRA OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL CORRESPONDENTE AO APURADO NO BALANCO DE 31/12/XX DESTA INSTITUICAO A SER PAGO PELO TESOURO NACIONAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.28.02', 'RESULTADO NEGATIVO BACEN - CUSTO DAS RESERVAS', 'REGISTRA OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL CORRESPONDENTE AO CUSTO DAS RESERVAS DESTA INSTITUICAO A SER PAGO PELO TESOURO NACIONAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.29.00', 'EMPRESTIMOS E FINANCIAMENTOS A LIBERAR', 'REGISTRA A APROPRIACAO DE VALORES A SEREM LIBERADOS, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.30.00', 'INCENTIVOS A LIBERAR', 'REGISTRA O VALOR DOS INCENTIVOS FISCAIS A LIBERAR POR OCASIAO DA CLASSIFICACAO DA RECEITA ARRECADADA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.31.00', 'COMPENSACAO DE CONTRIBUICOES PREVIDENCIARIAS', 'REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS EFETIVADAS PELAS UG DO INSS, A SEREM RECOLHIDAS POR GPS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.32.01', 'ADIANTAMENTOS DE OPERACOES ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS AOS RECURSOS FINANCEIROS RECEBIDOS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE O MINISTERIO DAS RELACOES EXTERIORES E OUTRAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.32.02', 'ADIANTAMENTOS DE UNIDADES E ENTIDADES', 'REGISTRA OS VALORES EXIGIVEIS RELATIVOS A ADIANTAMENTOS CONCEDIDOS POR ORGAOS E ENTIDADES, INCLUSIVE UNIDADES GESTORAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.32.03', 'ADIANTAMENTOS DIVERSOS RECEBIDOS', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.33.02', 'OPERACOES COM DERIVATIVOS - SWAP', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - SWAP', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.33.03', 'OPERACOES COM DERIVATIVOS - FORWARD', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - FORWARD', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.33.04', 'OPERACOES COM DERIVATIVOS - FUTUROS', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - FUTUROS', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.33.05', 'OPERACOES COM DERIVATIVOS - TERMO', 'REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - TERMO', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.34.01', 'VALORES DE INVESTIMENTOS A PAGAR', 'REGISTRA OS VALORES DE INVESTIMENTOS REALIZADOS NO MERCADO FINANCEIRO E NAO LIQUIDADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.35.01', 'GRU - VALORES EM TRANSITO PARA ESTORNO DESPESA', 'REGISTRA OS VALORES RECEBIDOS POR GRU A TITULO DE ESTORNO DE DESPESA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.35.02', 'ORDENS BANCARIAS A EMITIR', 'REGISTRA OS VALORES A LIBERAR A TITULO DE SUBREPASSE PARA AS UNIDADES GESTORAS DO EXTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.35.03', 'ORDENS BANCARIAS CANCELADAS', 'REGISTRA OS VALORES DE ORDENS BANCARIAS CANCELADAS PELO ORDENADOR DE DESPESA APOS REMESSA DE RELACAO AO BANCO, OU POR ESTE NA FALTA DE AUTORIZACAO DE PAGAMENTO PELO ORDENADOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.35.04', 'GRU A CLASSIFICAR - VALORES EM TRANSITO', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS POR MEIO DE GUIA DE RECOLHIMENTO DA UNIAO A CLASSIFICAR DE VALORES EM TRANSITO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.35.05', 'GRU A CLASSIFICAR - ROTINA AUTOMATICA', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS POR MEIO DE GUIA DE RECOLHIMENTO DA UNIAO A CLASSIFICAR DECORRENTES DE ROTINA AUTOMATICA(FUGA).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.35.06', 'SALDOS BANCARIOS EM UTILIZACAO', 'REGISTRA O VALOR DA APROPRIACAO DOS SALDOS BANCARIOS EM PROCESSO DE UTILIZACAO DE ACORDO COM CONTRATOS ASSINADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.35.07', 'DEPOSITO CONTA UNICA E INSTIT. A CLASSIFICAR', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS DIRETAMENTE NA CONTA UNICA INSTITUCIONAL', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.35.08', 'DEPOSITO CTU A CLASSIFICAR CODIGO PADRAO', 'REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS DIRETAMENTE NA CONTA UNICA REFERENTE AOS CODIGOS PADRAO CRIADOS PELA COORDENACAO-GERAL DE CONTABILIDADE DA UNIAO (CCONT).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.35.09', 'SAQUE - CARTAO DE PAGAMENTO DO GOVERNO FEDERAL', 'REGISTRA OS VALORES REFERENTES AS DESPESAS COM SUPRIMENTO DE FUNDOS, PENDENTES DE SAQUE COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.35.10', 'FATURA - CARTAO DE PAGAMENTO DO GOVERNO FEDERAL', 'REGISTRA OS VALORES REFERENTES AS DESPESAS COM SUPRIMENTO DE FUNDOS, PENDENTES DE PAGAMENTO DA FATURA COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.35.11', 'TRANSFERENCIA AO BB - OB SAQUE CARTAO', 'REGISTRA OS VALORES REFERENTES AS TRANSFERENCIAS DE RECURSOS AO BANCO DO BRASIL, RELATIVAS AOS SAQUES DE OB CARTAO EFETUADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.35.12', 'ORDENS BANCARIAS CANCELADAS (CARTAO CREDITO)', 'REGISTRA OS VALORES DE ORDENS BANCARIAS CANCELADAS PELO AGENTE FINANCEIRO, REFERENTE AO CARTAO DE CREDITO CORPORATIVO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.36.01', 'SUBVENCOES A PAGAR DO EXERCICIO', 'REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.36.02', 'SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.37.00', 'RESTITUICOES DE RECEITAS A PAGAR', 'REGISTRA O VALOR DAS RESTITUICOES DE RECEITAS A PAGAR APROPRIADAS PELAS UNIDADES GESTORAS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.38.00', 'TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS NAO EFETUADAS PELO PORTAL SICONV', 'REGISTRA OS VALORES DE DEVOLUCOES DE RECURSOS DE TRANSFERENCIAS VOLUNTARIAS, NAO GERADAS PELO PORTAL DE CONVENIOS, PARA POSTERIOR RECOLHIMENTO AO CONCEDENTE OU AO TESOURO NACIONAL POR MEIO DE GRU.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.01', 'RECURSOS A LIBERAR POR TRANSFERENCIA', 'REGISTRA OS VALORES A LIBERAR DA GESTAO TESOURO PARA A GESTAO FUNDO DA CAMARA E DO SENADO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.02', 'TRANSFERENCIAS ORCAMENTARIAS A LIBERAR PARA O DISTRITO FEDERAL', 'REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA A FAVOR DO DISTRITO FEDERAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.03', 'TRANSFERENCIAS ORCAMENTARIAS A LIBERAR PARA OS ESTADOS', 'REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA A FAVOR DE ESTADOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.04', 'RECURSOS A LIBERAR POR VINCULACAO DE PAGAMENTO', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO, ESTABELECIDO PELO ORGAO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.05', 'RECURSOS A RESTITUIR - ADIANTAMENTOS RECEBIDOS PELO INSS', 'REGISTRA OS RECURSOS A RESTITUIR DE ADIANTAMENTOS RECEBIDOS PELO INSS EM DECORRENCIA DA ARRECADACAO DE PASSIVOS POR DARF E TRANSFERENCIA POR GPS PELA COFIN PARA O INSS. A CONTA SERA UTILIZADA QUANDO O VALOR A TRANSFERIR FOR MAIOR QUE O VALOR ARRECADADO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.06', 'RECURSOS ORCAMENTARIOS A LIBERAR', 'REGISTRA OS RECURSOS A LIBERAR REFERENTE AS PARCELAS NAO RECEBIDAS DO ORCAMENTO PARA A ENTIDADES DA ADMINISTRACAO INDIRETA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.07', 'RECURSOS A LIBERAR P/ VINCULACAO DE PAGAMENTO PARA O INSS', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO PARA O INSS, ESTABELECIDO PELO ORGAO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.08', 'RECURSOS A LIBERAR PARA EMPENHO CONTRA ENTREGA', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE PARA PAGAMENTO DE EMPENHO CONTRA ENTREGA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.09', 'RECURSOS DA PREVIDENCIA SOCIAL - BENEFICIOS', 'REGISTRA OS RECURSOS A LIBERAR REFERENTES AOS BENEFICIOS DA PREVIDENCIA SOCIAL', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.10', 'RECURSOS DA PREVIDENCIA SOCIAL - TERCEIROS', 'REGISTRA OS RECURSOS A LIBERAR REFERENTES A DEPOSITOS DE TERCEIROS PARA A PREVIDENCIA SOCIAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.11', 'REMUNERACAO DA DISPONIBILIDADE CONTA UNICA INSS - BACEN', 'REGISTRA O VALOR DAS OBRIGACOES REFERENTES A REMUNERACAO DA DISPONIBILIDADE DA CTU INSS NO BACEN.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.12', 'LIMITE DE SAQUE RECURSOS DA DIVIDA PUBLICA', 'REGISTRA O VALOR DOS RECURSOS A LIBERAR DA SUB-CONTA DA DIVIDA PUBLICA NO BANCO CENTRAL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.13', 'RECURSOS VINCULADOS - ENTIDADES TCT', 'REGISTRA O VALOR DOS RECURSOS VINCULADO REFERENTE A ENTIDADES QUE UTILIZAM A CONTA UNICA EM CUMPRIMENTO AO TERMO DE COOPERACAO TECNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.14', 'REC. A COMPENSAR P/ PERDAS EM APLICACOES NA CONTA UNICA', 'REGISTRA O VALOR DE RECURSOS A COMPENSAR POR PERDAS EM APLICACOES FINANCEIRAS NA CONTA UNICA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.40.01', 'PERDAS EM PARTICIPACAO EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO', 'COMPREENDE OS VALORES REFERENTES A PARTICIPACOES PELO METODO DA EQUIVALENCIA PATRIMONIAL EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO (PASSIVO A DESCOBERTO).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.40.99', 'PERDAS EM PARTICIPACAO - EMPRESAS DEPENDENTES', 'REGISTRA OS VALORES DAS PARTICIPACOES DA UNIAO NO PL NEGATIVO DAS EMPRESAS CONTROLADAS DEPENDENTES, PARA QUE OS REFERIDOS VALORES SEJAM EXPURGADOS NA CONSOLIDACAO DAS DEMONSTRACOES CONTABEIS DA UNIAO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.41.00', 'CONTRIBUICAO AO FUST A RECOLHER', 'REGISTRA OS VALORES DEVIDOS PELA UNIDADE EM FUNCAO DA RECEITA OPERACIONAL BRUTA, DECORRENTE DA PRESTACAO DE SERVICOS DE TELECOMUNICACOES NOS REGIMES PUBLICO E PRIVADO, EXCLUINDO-SE O ICMS, O PIS E A COFINS INCIDENTES SOBRE A MESMA BASE DE CALCULO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.44.00', 'OBRIGACOES A PAGAR EM MOEDA ESTRANGEIRA', 'REGISTRA OS VALORES DAS OBRIGACOES A PAGAR EM MOEDA ESTRANGEIRA, INCLUSIVE AS DESPESAS COM ADMINISTRACAO TERCEIRIZADA DE RECURSOS EM MOEDA ESTRANGEIRA. CONTA EXCLUSIVA DO BANCO CENTRAL DO BRASIL', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.45.00', 'RECURSOS DA GRU', 'REGISTRA O VALOR DOS CREDITOS DE GUIA DE RECOLHIMENTO DA UNIAO - GRU INTRA SIAFI.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.46.00', 'RECURSOS FISCAIS', 'REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELO TESOURO NACIONAL A SEREM POSTERIORMENTE CLASSIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.47.00', 'RESTITUICAO DE RECEITAS RECEBIDAS GRU', 'REGISTRA OS VALORES RELATIVOS A RESTITUICAO DE RECEITAS RECEBIDAS POR GRU.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.98.01', 'OUTROS CREDORES DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES NO EXERCICIO, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.98.02', 'OUTROS CREDORES DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCICIOS ANTERIORES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.1.01.00', 'PESSOAL A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES RELATIVOS A VENCIMENTOS E VANTAGENS FIXAS E VARIAVEIS DEVIDAS AO SERVIDORES CIVIS E MILITARES, BEM COMO AS APOSENTADORIAS, REFORMAS E PENSOES, RELATIVAS A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.1.02.01', 'PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCICIOS ANTERIORES AO ANTERIOR.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.1.02.03', 'PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000', 'REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.2.1.01.02', 'PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.3.1.01.00', 'BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES RELATIVOS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.1.01.01', 'INSS - DEBITO PARCELADO', 'REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.1.02.01', 'RPPS - DEBITO PARCELADO', 'REGISTRA OS VALORES DE DEBITO PARCELADO RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.1.03.01', 'CONTRIBUICAO A ENTIDADES DE PREVIDENCIA PRIVADA', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.1.03.02', 'CONTRIBUICAO A ENTIDADES DE PREVIDENCIA COMPLEMENTAR', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES DE PREVIDENCIA COMPLEMENTAR.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.1.98.00', 'OUTROS ENCARGOS SOCIAIS', 'REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.2.01.01', 'INSS - DEBITO PARCELADO', 'REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.2.02.01', 'RPPS - DEBITO PARCELADO', 'REGISTRA OS VALORES DE DEBITO PARCELADO RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.2.03.01', 'CONTRIBUICAO A ENTIDADES DE PREVIDENCIA PRIVADA', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.2.03.02', 'CONTRIBUICAO A ENTIDADES DE PREVIDENCIA COMPLEMENTAR', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES DE PREVIDENCIA COMPLEMENTAR.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.2.98.00', 'OUTROS ENCARGOS SOCIAIS', 'REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.4.01.01', 'INSS - DEBITO PARCELADO', 'REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.4.02.01', 'RPPS - DEBITO PARCELADO', 'REGISTRA OS VALORES DE DEBITO PARCELADO RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.4.03.01', 'CONTRIBUICAO A ENTIDADES DE PREVIDENCIA PRIVADA', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.4.03.02', 'CONTRIBUICAO A ENTIDADES DE PREVIDENCIA COMPLEMENTAR', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES DE PREVIDENCIA COMPLEMENTAR.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.4.98.00', 'OUTROS ENCARGOS SOCIAIS', 'REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.5.01.01', 'INSS - DEBITO PARCELADO', 'REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.5.02.01', 'RPPS - DEBITO PARCELADO', 'REGISTRA OS VALORES DE DEBITO PARCELADO RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.5.03.01', 'CONTRIBUICAO A ENTIDADES DE PREVIDENCIA PRIVADA', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.5.03.02', 'CONTRIBUICAO A ENTIDADES DE PREVIDENCIA COMPLEMENTAR', 'REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES DE PREVIDENCIA COMPLEMENTAR.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.5.98.00', 'OUTROS ENCARGOS SOCIAIS', 'REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.01.01', 'DIVIDA MOBILIARIA', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA EMISSAO DE TITULOS DA DIVIDA MOBILIARIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.01.02', 'TITULOS DA DIVIDA AGRARIA (TDA)', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS DA DIVIDA AGRARIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.01.03', '(-) DESAGIO DE TITULOS', 'REGISTRA OS VALORES RELATIVOS A DESAGIO OCORRIDOS EM TITULOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.01.98', 'OUTROS TITULOS - EMPRESTIMOS INTERNOS', 'REGISTRA OS VALORES DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.02.00', 'EMPRESTIMOS INTERNOS - EM CONTRATOS', 'REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.01.01', 'DIVIDA MOBILIARIA', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA EMISSAO DE TITULOS DA DIVIDA MOBILIARIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.01.02', 'TITULOS DA DIVIDA AGRARIA (TDA)', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS DA DIVIDA AGRARIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.01.03', '(-) DESAGIO DE TITULOS', 'REGISTRA OS VALORES RELATIVOS A DESAGIO OCORRIDOS EM TITULOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.01.98', 'OUTROS TITULOS - EMPRESTIMOS INTERNOS', 'REGISTRA OS VALORES DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.02.00', 'EMPRESTIMOS INTERNOS - EM CONTRATOS', 'REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.01.01', 'DIVIDA MOBILIARIA', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA EMISSAO DE TITULOS DA DIVIDA MOBILIARIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.01.02', 'TITULOS DA DIVIDA AGRARIA (TDA)', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS DA DIVIDA AGRARIA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.01.03', '(-) DESAGIO DE TITULOS', 'REGISTRA OS VALORES RELATIVOS A DESAGIO OCORRIDOS EM TITULOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.01.98', 'OUTROS TITULOS - EMPRESTIMOS INTERNOS', 'REGISTRA OS VALORES DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.02.00', 'EMPRESTIMOS INTERNOS - EM CONTRATOS', 'REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.2.1.01.01', 'TITULOS DO TESOURO NACIONAL', 'REGISTRA OS TITULOS EXIGIVEIS A LONGO PRAZO EMITIDOS PELO TESOURO NACIONAL NO MERCADO INTERNACIONAL (BIB, BEA, BRADY, BONUS SOBERANOS E OUTROS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.2.1.01.98', 'OUTROS TITULOS - EMPRESTIMOS EXTERNOS', 'REGISTRA VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DA COLOCACAO DE TITULOS NO EXTERIOR, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.2.1.02.00', 'EMPRESTIMOS EXTERNOS - EM CONTRATOS', 'REGISTRA OS VALORES DAS OPERACOES DE CREDITO EXTERNAS EM CONTRATOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.1.01.01', 'FINANCIAMENTOS DO ATIVO PERMANENTE', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.1.01.02', 'FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS HABITACIONAIS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.1.01.03', 'FINANCIAMENTO DE CAPITAL DE GIRO', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.1.01.98', 'OUTROS FINANCIAMENTOS INTERNOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.1.02.00', 'FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO', 'REGISTRA AS OBRIGACOES A LONGO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.4.01.01', 'FINANCIAMENTOS DO ATIVO PERMANENTE', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.4.01.02', 'FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS HABITACIONAIS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.4.01.03', 'FINANCIAMENTO DE CAPITAL DE GIRO', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.4.01.98', 'OUTROS FINANCIAMENTOS INTERNOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.4.02.00', 'FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO', 'REGISTRA AS OBRIGACOES A LONGO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.5.01.01', 'FINANCIAMENTOS DO ATIVO PERMANENTE', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.5.01.02', 'FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS HABITACIONAIS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.5.01.03', 'FINANCIAMENTO DE CAPITAL DE GIRO', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.5.01.98', 'OUTROS FINANCIAMENTOS INTERNOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.5.02.00', 'FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO', 'REGISTRA AS OBRIGACOES A LONGO PRAZO REFERENTES A FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.01.01', 'FINANCIAMENTOS DO ATIVO PERMANENTE', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A LONGO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.01.02', 'FINANCIAMENTOS DE CAPITAL DE GIRO', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS EXTERNOS A LONGO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.02.00', 'FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO', 'REGISTRA AS OBRIGACOES A LONGO PRAZO REFERENTES A FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.03.01', 'CORRECAO MONETARIA FINANCEIRA', 'REGISTRA A CORRECAO MONETARIA DA CONTA ESPECIAL DE BANCOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.03.02', 'CORRECAO MONETARIA NAO FINANCEIRA', 'REGISTRA A CORRECAO MONETARIA DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.03.03', 'VARIACAO CAMBIAL FINANCEIRA', 'REGISTRA A VARIACAO CAMBIAL DA CONTA ESPECIAL DE BANCOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.03.04', 'VARIACAO CAMBIAL NAO FINANCEIRA', 'REGISTRA A VARIACAO CAMBIAL DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.03.05', 'AJUSTE BOLSA DE MOEDAS FINANCEIRA', 'REGISTRA O AJUSTE, COM BASE NA VARIACAO DA BOLSA DE MOEDAS, DA CONTA ESPECIAL DE BANCOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.03.06', 'AJUSTE BOLSA DE MOEDAS NAO FINANCEIRA', 'REGISTRA O AJUSTE, COM BASE NA VARIACAO DA BOLSA DE MOEDAS, DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.01.01', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.01.02', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.01.03', 'JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.02.01', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.02.02', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.03.01', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.03.02', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.03.03', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.04.01', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.04.02', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.01.01', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.01.02', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.01.03', 'JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.02.01', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.02.02', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.03.01', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.03.02', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.03.03', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.04.01', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.04.02', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.01.01', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.01.02', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.01.03', 'JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.02.01', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.02.02', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.03.01', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.03.02', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.03.03', 'JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS', 'REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.04.01', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.04.02', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.01.01', 'JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.01.02', 'JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.02.01', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.02.02', 'ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.03.01', 'JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.03.02', 'JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.04.01', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.04.02', 'ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.1.01.00', '(-) ENCARGOS PREFIXADOS DE EMPRESTIMOS INTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRESTIMOS INTERNOS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.1.02.00', '(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS INTERNOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.4.01.00', '(-) ENCARGOS PREFIXADOS DE EMPRESTIMOS INTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRESTIMOS INTERNOS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.4.02.00', '(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS INTERNOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.5.01.00', '(-) ENCARGOS PREFIXADOS DE EMPRESTIMOS INTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRESTIMOS INTERNOS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.5.02.00', '(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS INTERNOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.9.1.01.00', '(-) ENCARGOS PREFIXADOS DE EMPRESTIMOS EXTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRESTIMOS EXTERNOS.', 'D', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.9.1.02.00', '(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS EXTERNOS', 'REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS EXTERNOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.01.00', 'FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.02.00', 'FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.03.01', 'PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.2.01.00', 'FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.2.02.00', 'FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.2.03.01', 'PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.4.01.00', 'FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.4.02.00', 'FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.4.03.01', 'PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.5.01.00', 'FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.5.02.00', 'FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.5.03.01', 'PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.2.1.01.00', 'FORNECEDORES ESTRANGEIROS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.2.1.02.00', 'FORNECEDORES ESTRANGEIROS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.01.00', 'IPI A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES TRIBUTARIAS DAS UNIDADES INDUSTRIAIS OU COM CARACTERISTICAS DESSAS, GERADAS PELAS VENDAS DE PRODUTOS INDUSTRIAIS E SUJEITAS A COMPENSACAO COM OS CREDITOS ADQUIRIDOS POR COMPRAS DE MATERIAS-PRIMAS, EM CONFORMIDADE COM A SISTEMATICA DE APURACAO DESSE IMPOSTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.02.00', 'IRPJ A RECOLHER', 'REGISTRA OS VALORES DAS OBRIGACOES A PAGAR RELATIVAS AO IRPJ, APURADAS NA DECLARACAO DE RENDIMENTOS DA ENTIDADE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.03.00', 'PASSIVO FISCAL DIFERIDO', 'REGISTRA OS VALORES DE DEBITOS FISCAIS DE CURTO PRAZO RELATIVOS A DIFERENCAS INTERTEMPORAIS (DELIBERACAO DA CVM Nº 273, DE 20/08/98),CORRESPONDENTES AO IRPJ E CSSL, BEM COMO PIS/PASEP E COFINS (LEI Nº 9.718 DE 27/11/1998).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.04.00', 'IMPOSTO DE IMPORTACAO A RECOLHER', 'REGISTRA AS OBRIGACOES EXIGIVEIS A CURTO PRAZO JUNTO AO GOVERNO FEDERAL, RELATIVAS AO IMPOSTO DE IMPORTACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.05.00', 'IOF A RECOLHER', 'REGISTRA OS VALORES A RECOLHER RELATIVAS AO IMPOSTO SOBRE OPERACOES FINANCEIRAS (IOF).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.06.00', 'ITR A RECOLHER', 'REGISTRA OS VALORES A RECOLHER RELATIVAS AO ITR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.07.00', 'CPMF A RECOLHER', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO PROVISORIA SOBRE MOVIMENTACAO OU TRANSMISSAO DE VALORES E DE CREDITOS DE NATUREZA FINANCEIRA - CPMF.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.08.00', 'CIDE A RECOLHER', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE (LEI Nº 10.168 DE 2000).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.09.00', 'CONTRIBUICAO SOCIAL S/ LUCRO PESSOAS JURIDICAS', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS (CSSL).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.10.00', 'COFINS A RECOLHER', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A COFINS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.11.00', 'PIS/PASEP A RECOLHER', 'REGISTRA AS OBRIGACOES RELATIVAS AO PIS/ PASEP.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.12.00', 'TRIBUTOS FEDERAIS RENEGOCIADOS', 'REGISTRA OS VALORES DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.13.00', 'RECURSOS FISCAIS - DARF A EMITIR', 'REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELAS REPARTICOES PUBLICAS PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, OU SEJA, VALORES A SEREM RECOLHIDOS ATRAVES DE DARF.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.99.00', 'OUTROS TRIBUTOS E CONTRIBUICOES FEDERAIS A RECOLHER', 'REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.01.00', 'IPI A RECOLHER', 'REGISTRA O VALOR DAS OBRIGACOES TRIBUTARIAS DAS UNIDADES INDUSTRIAIS OU COM CARACTERISTICAS DESSAS, GERADAS PELAS VENDAS DE PRODUTOS INDUSTRIAIS E SUJEITAS A COMPENSACAO COM OS CREDITOS ADQUIRIDOS POR COMPRAS DE MATERIAS-PRIMAS, EM CONFORMIDADE COM A SISTEMATICA DE APURACAO DESSE IMPOSTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.02.00', 'IRPJ A RECOLHER', 'REGISTRA OS VALORES DAS OBRIGACOES A PAGAR RELATIVAS AO IRPJ, APURADAS NA DECLARACAO DE RENDIMENTOS DA ENTIDADE.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.03.00', 'PASSIVO FISCAL DIFERIDO - TRIBUTOS FEDERAIS', 'REGISTRA OS VALORES DE DEBITOS FISCAIS DE CURTO PRAZO RELATIVOS A DIFERENCAS INTERTEMPORAIS (DELIBERACAO DA CVM Nº 273, DE 20/08/98),CORRESPONDENTES AO IRPJ E CSSL, BEM COMO PIS/PASEP E COFINS (LEI Nº 9.718 DE 27/11/1998).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.04.00', 'IMPOSTO DE IMPORTACAO A RECOLHER', 'REGISTRA AS OBRIGACOES EXIGIVEIS A CURTO PRAZO JUNTO AO GOVERNO FEDERAL, RELATIVAS AO IMPOSTO DE IMPORTACAO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.05.00', 'IOF A RECOLHER', 'REGISTRA OS VALORES A RECOLHER RELATIVAS AO IMPOSTO SOBRE OPERACOES FINANCEIRAS (IOF).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.06.00', 'ITR A RECOLHER', 'REGISTRA OS VALORES A RECOLHER RELATIVAS AO ITR.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.07.00', 'CPMF A RECOLHER', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO PROVISORIA SOBRE MOVIMENTACAO OU TRANSMISSAO DE VALORES E DE CREDITOS DE NATUREZA FINANCEIRA - CPMF.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.08.00', 'CIDE A RECOLHER', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE (LEI Nº 10.168 DE 2000).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.09.00', 'CONTRIBUICAO SOCIAL S/ LUCRO PESSOAS JURIDICAS', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS (CSSL).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.10.00', 'COFINS A RECOLHER', 'REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A COFINS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.11.00', 'PIS/PASEP A RECOLHER', 'REGISTRA AS OBRIGACOES RELATIVAS AO PIS/ PASEP.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.12.00', 'TRIBUTOS FEDERAIS RENEGOCIADOS', 'REGISTRA OS VALORES DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.13.00', 'RECURSOS FISCAIS - DARF A EMITIR', 'REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELAS REPARTICOES PUBLICAS PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, OU SEJA, VALORES A SEREM RECOLHIDOS ATRAVES DE DARF.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.99.00', 'OUTROS TRIBUTOS E CONTRIBUICOES FEDERAIS A RECOLHER', 'REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.1.01.00', 'ICMS A RECOLHER', 'REGISTRA OS VALORES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDAM ICMS, SUJEITOS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.1.02.00', 'IPVA A RECOLHER', 'REGISTRA AS OBRIGACOES RELATIVAS AO IPVA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.1.03.00', 'TRIBUTOS ESTADUAIS RENEGOCIADOS', 'REGISTRA OS VALORES DEVIDOS RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.1.04.00', 'TAXA CONTRA INCENDIO', 'REGISTRA AS OBRIGACOES REFERENTES A TAXA CONTRA INCENDIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.1.05.00', 'TAXA DE LICENCIAMENTO ANUAL DE VEICULOS', 'REGISTRA AS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTE AO PAGAMENTO DA TAXA DE LICENCIAMENTO ANUAL DE VEICULOS, DECORRENTE DO SERVICO DE LICENCIAMENTO DE VEICULOS AUTOMOTORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.1.99.00', 'OUTROS TRIBUTOS E CONTRIBUICOES ESTADUAIS A RECOLHER', 'REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.4.01.00', 'ICMS A RECOLHER', 'REGISTRA OS VALORES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDAM ICMS, SUJEITOS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.4.02.00', 'IPVA A RECOLHER', 'REGISTRA AS OBRIGACOES RELATIVAS AO IPVA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.4.03.00', 'TRIBUTOS ESTADUAIS RENEGOCIADOS', 'REGISTRA OS VALORES DEVIDOS RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.4.04.00', 'TAXA CONTRA INCENDIO', 'REGISTRA AS OBRIGACOES REFERENTES A TAXA CONTRA INCENDIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.4.05.00', 'TAXA DE LICENCIAMENTO ANUAL DE VEICULOS', 'REGISTRA AS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTE AO PAGAMENTO DA TAXA DE LICENCIAMENTO ANUAL DE VEICULOS, DECORRENTE DO SERVICO DE LICENCIAMENTO DE VEICULOS AUTOMOTORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.4.99.00', 'OUTROS TRIBUTOS E CONTRIBUICOES ESTADUAIS A RECOLHER', 'REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.1.01.00', 'ISS A RECOLHER', 'REGISTRA AS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE OS SERVICOS PRESTADOS EM QUE A PROPRIA UNIDADE SEJA A PRESTADORA DO SERVICO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.1.02.00', 'IPTU/TLP A RECOLHER', 'REGISTRA AS OBRIGACOES RELATIVAS AO IPTU/TLP.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.1.03.00', 'TRIBUTOS MUNICIPAIS RENEGOCIADOS', 'REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.1.04.00', 'CONTRIBUICAO P/ CUSTEIO DE ILUM. PUBLICA A RECOLHER', 'REGISTRA OS VALORES DAS OBRIGACOES REFERENTES A CONTRIBUICAO PARA CUSTEIO DE ILUMINACAO PUBLICA.(ART.149-A DA C.F.)', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.1.99.00', 'OUTROS TRIBUTOS E CONTRIBUICOES MUNICIPAIS A RECOLHER', 'REGISTRA OS COMPROMISSOS EXIGIVEIS, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.5.01.00', 'ISS A RECOLHER', 'REGISTRA AS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE OS SERVICOS PRESTADOS EM QUE A PROPRIA UNIDADE SEJA A PRESTADORA DO SERVICO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.5.02.00', 'IPTU/TLP A RECOLHER', 'REGISTRA AS OBRIGACOES RELATIVAS AO IPTU/TLP.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.5.03.00', 'TRIBUTOS MUNICIPAIS RENEGOCIADOS', 'REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.5.04.00', 'CONTRIBUICAO P/ CUSTEIO DE ILUM. PUBLICA A RECOLHER', 'REGISTRA OS VALORES DAS OBRIGACOES REFERENTES A CONTRIBUICAO PARA CUSTEIO DE ILUMINACAO PUBLICA.(ART.149-A DA C.F.)', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.5.99.00', 'OUTROS TRIBUTOS E CONTRIBUICOES MUNICIPAIS A RECOLHER', 'REGISTRA OS COMPROMISSOS EXIGIVEIS, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.1.1.01.00', 'PROVISAO PARA INDENIZACOES TRABALHISTAS', 'REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE INDENIZACOES TRABALHISTAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.1.1.02.00', 'PROVISAO PARA PAGAMENTO DE DISSIDIOS COLETIVOS', 'REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE DISSIDIOS COLETIVOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.01', 'APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS CONCEDIDOS DO PLANO FINANCEIRO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS PRESTACOES FUTURAS DOS BENEFICIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTACAO CONTINUADA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.02', '(-) CONTRIBUICOES DO ENTE PARA O PLANO FINANCEIRO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.03', '(-) CONTRIBUICOES DO INATIVO PARA O PLANO FINANCEIRO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS INATIVOS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.04', '(-) CONTRIBUICOES DO PENSIONISTA PARA O PLANO FINANCEIRO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS PENSIONISTAS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.05', '(-) COMPENSACAO PREVIDENCIARIA DO PLANO FINANCEIRO DO RPPS', 'REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.06', '(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO FUNDO SOB O REGIME DE PARCELAMENTO DE DEBITOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.07', '(-) COBERTURA DE INSUFICIENCIA FINANCEIRA', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS INSUFICIENCIAS FINANCEIRAS FUTURAS DO PLANO FINANCEIRO CONSIDERANDO O § 1º DO ARTIGO 2º DA LEI 9717/98.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.02.01', 'APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS A CONCEDER DO PLANO FINANCEIRO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DOS BENEFICIOS A SEREM CONCEDIDOS AOS INTEGRANTES DA GERACAO ATUAL QUE AINDA NAO ESTEJAM EM GOZO DE BENEFICIOS DE PRESTACAO CONTINUADA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.02.02', '(-) CONTRIBUICOES DO ENTE PARA O PLANO FINANCEIRO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.02.03', '(-) CONTRIBUICOES DO ATIVO PARA O PLANO FINANCEIRO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O SOMATORIO DO VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS SERVIDORES ATIVOS, INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.02.04', '(-) COMPENSACAO PREVIDENCIARIA DO PLANO FINANCEIRO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.02.05', '(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO PLANO, CONSIDERANDO O PARCELAMENTO DOS VALORES NAO RECOLHIDOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.02.06', '(-) COBERTURA DE INSUFICIENCIA FINANCEIRA', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS INSUFICIENCIAS FINANCEIRAS FUTURAS DO PLANO FINANCEIRO, CONSIDERANDO O § 1º DO ARTIGO 2º DA LEI 9717/98', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.03.01', 'APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS CONCEDIDOS DO PLANO PREVIDENCIARIO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS PRESTACOES FUTURAS DOS BENEFICIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTACAO CONTINUADA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.03.02', '(-) CONTRIBUICOES DO ENTE PARA O PLANO PREVIDENCIARIO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.03.03', '(-) CONTRIBUICOES DO INATIVO PARA O PLANO PREVIDENCIARIO DO RPPS', 'REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS INATIVOS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.03.04', '(-) CONTRIBUICOES DO PENSIONISTA PARA O PLANO PREVIDENCIARIO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS PENSIONISTAS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.03.05', '(-) COMPENSACAO PREVIDENCIARIA DO PLANO PREVIDENCIARIO DO RPPS', 'REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11 DA PORTARIA MPS Nº 403/2008.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.03.06', '(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS DO PLANO PREVIDENCIARIO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO PLANO, CONSIDERANDO O PARCELAMENTO DE VALORES NAO RECOLHIDOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.04.01', 'APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS A CONCEDER DO PLANO PREVIDENCIARIO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DOS BENEFICIOS A SEREM CONCEDIDOS AOS INTEGRANTES DA GERACAO ATUAL QUE AINDA NAO ESTEJAM EM GOZO DE BENEFICIOS DE PRESTACAO CONTINUADA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.04.02', '(-) CONTRIBUICOES DO ENTE PARA O PLANO PREVIDENCIARIO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.04.03', '(-) CONTRIBUICOES DO ATIVO PARA O PLANO PREVIDENCIARIO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O SOMATORIO DO VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS SERVIDORES ATIVOS, INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.04.04', '(-) COMPENSACAO PREVIDENCIARIA DO PLANO PREVIDENCIARIO DO RPPS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.04.05', '(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO PLANO, SOB O REGIME DE PARCELAMENTO DE DEBITOS.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.05.98', '(-) OUTROS CREDITOS DO PLANO DE AMORTIZACAO', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE LIQUIDO DOS DIREITOS INCORPORADOS AO PATRIMONIO DO RPPS COM BASE EM LEGISLACAO ESPECIFICA, COMO EXEMPLO: DIREITOS SOBRE ROYALTIES, BEM COMO REGISTRO TEMPESTIVO DO PLANO DE AMORTIZACAO IMPLEMENTADO EM LEI DO ENTE FEDERATIVO, CONSIDERANDO QUE O AJUSTE CONTABIL DAS RESERVAS MATEMATICAS SOMENTE OCORRERA NA APRESENTACAO DE UMA NOVA REAVALIACAO ATUARIAL.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.06.01', 'PROVISAO ATUARIAL PARA OSCILACAO DE RISCOS', 'REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, A PROVISAO ATUARIAL CORRESPONDENTE A EVENTUAIS DESVIOS DOS COMPROMISSOS ESPERADOS OU PELA ADOCAO DE BASES TECNICAS QUE NAO SE ADAPTAM AO PLANO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.07.01', 'AJUSTE DE RESULTADO ATUARIAL SUPERAVITARIO', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, PROVISAO ATUARIAL PARA AJUSTE DO PLANO PREVIDENCIARIO QUANDO O PLANO APRESENTAR RESULTADO SUPERAVITARIO, CONSIDERANDO O ARTIGO 25, DA PORTARIA MPS 403/2008.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.07.02', 'PROVISAO ATUARIAL PARA OSCILACAO DE RISCOS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, PROVISAO ATUARIAL PARA AJUSTE DO PLANO PREVIDENCIARIO QUANDO O PLANO APRESENTAR OSCILACAO DE RISCOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.07.03', 'PROVISAO ATUARIAL PARA BENEFICIOS A REGULARIZAR', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, PROVISAO ATUARIAL PARA AJUSTE DO PLANO PREVIDENCIARIO QUANDO O PLANO APRESENTAR BENEFICIOS A REGULARIZAR.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.07.04', 'PROVISAO ATUARIAL PARA CONTINGENCIAS DE BENEFICIOS', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, PROVISAO ATUARIAL PARA AJUSTE DO PLANO PREVIDENCIARIO QUANDO O PLANO APRESENTAR CONTINGENCIAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.07.98', 'OUTRAS PROVISOES ATUARIAIS PARA AJUSTES DO PLANO', 'REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, PROVISAO ATUARIAL PARA AJUSTE DO PLANO PREVIDENCIARIO QUANDO O PLANO NECESSITAR DE OUTROS AJUSTES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.1.01.01', 'PROVISAO PARA PAGAMENTO DE AUTOS DE INFRACAO NAO RECORRIDOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTOS DE INFRACAO JA LAVRADOS, PARA OS QUAIS A UNIDADE AINDA NAO APRESENTOU RECURSO ADMINISTRATIVO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.1.01.02', 'PROVISAO PARA PAGAMENTO DE AUTOS DE INFRACAO RECORRIDOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTOS DE INFRACAO JA LAVRADOS, PARA OS QUAIS A UNIDADE APRESENTOU RECURSO ADMINISTRATIVO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.1.02.01', 'PROVISAO PARA PAGAMENTOS DE AUTUACOES FISCAIS NA ESFERA JUDICIAL NAO RECORRIDAS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTUACOES FISCAIS QUE SE ENCONTRAM NA ESFERA JUDICIAL E QUE NAO ESTAO EM FASE RECURSAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.1.02.02', 'PROVISAO PARA PAGAMENTOS DE AUTUACOES FISCAIS NA ESFERA JUDICIAL RECORRIDAS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTUACOES FISCAIS QUE SE ENCONTRAM NA ESFERA JUDICIAL EM FASE RECURSAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.1.01.00', 'PROVISAO PARA INDENIZACOES CIVEIS', 'REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS PARA O PAGAMENTO DE INDENIZACOES CIVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.1.02.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.1.03.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JA CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.1.04.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS NAO CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NAO CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.2.01.00', 'PROVISAO PARA INDENIZACOES CIVEIS', 'REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS PARA O PAGAMENTO DE INDENIZACOES CIVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.2.02.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.2.03.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JA CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.2.04.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS NAO CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NAO CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.4.01.00', 'PROVISAO PARA INDENIZACOES CIVEIS', 'REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS PARA O PAGAMENTO DE INDENIZACOES CIVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.4.02.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.4.03.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JA CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.4.04.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS NAO CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NAO CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.5.01.00', 'PROVISAO PARA INDENIZACOES CIVEIS', 'REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS PARA O PAGAMENTO DE INDENIZACOES CIVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.5.02.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.5.03.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JA CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.5.04.00', 'PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS NAO CIENTIFICADOS', 'REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NAO CIENTIFICADOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.5.4.00.00', 'PROVISAO PARA REPARTICAO DE CREDITOS A LONGO PRAZO - INTER OFSS - ESTADO', 'REGISTRA OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CREDITOS TRIBUTARIOS E NAO TRIBUTARIOS RECONHECIDOS NO LANCAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERACAO, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. NA ARRECADACAO, ESTA PROVISAO SERA REVERTIDA EM CONTA ESPECIFICA DE PASSIVO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.5.5.00.00', 'PROVISAO PARA REPARTICAO DE CREDITOS A LONGO PRAZO - INTER OFSS - MUNICIPIO', 'REGISTRA OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CREDITOS TRIBUTARIOS E NAO TRIBUTARIOS RECONHECIDOS NO LANCAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERACAO, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. NA ARRECADACAO, ESTA PROVISAO SERA REVERTIDA EM CONTA ESPECIFICA DE PASSIVO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.6.1.00.00', 'PROVISAO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO -CONSOLIDACAO', 'REGISTRA OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUCAO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.1.01.00', 'PROVISAO PARA GARANTIAS', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR DESPESAS COM A PRESTACAO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.1.02.00', 'PROVISAO PARA REESTRUTURACAO', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR OBRIGACOES ORIUNDAS DA VENDA OU EXTINCAO DE UMA LINHA DE NEGOCIOS, FECHAMENTO DE FABRICAS OU LOCAIS DE NEGOCIOS, MUDANCAS NA ESTRUTURA DA ADMINISTRACAO E REORGANIZACOES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERACOES DA ENTIDADE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.1.03.01', 'PROVISOES DO FCVS - RISCOS EXPIRADOS', 'REGISTRA OS RESIDUOS DE CONTRATOS LIQUIDADOS PELO MUTUARIO COM COBERTURA DO FCVS, DE ACORDO COM A AVALIACAO ATUARIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.1.03.02', 'PROVISOES DO FCVS - RISCOS NAO EXPIRADOS', 'REGISTRA O MONTANTE DE CONTRATOS COM COBERTURA DO FCVS EM FASE DE PAGAMENTO PELOS MUTUARIOS, DE ACORDO COM A AVALIACAO ATUARIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.1.99.00', 'OUTRAS PROVISOES A LONGO PRAZO', 'REGISTRA OS VALORES DAS PROVISOES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.2.01.00', 'PROVISAO PARA GARANTIAS', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR DESPESAS COM A PRESTACAO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.2.02.00', 'PROVISAO PARA REESTRUTURACAO', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR OBRIGACOES ORIUNDAS DA VENDA OU EXTINCAO DE UMA LINHA DE NEGOCIOS, FECHAMENTO DE FABRICAS OU LOCAIS DE NEGOCIOS, MUDANCAS NA ESTRUTURA DA ADMINISTRACAO E REORGANIZACOES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERACOES DA ENTIDADE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.2.03.01', 'PROVISOES DO FCVS - RISCOS EXPIRADOS', 'REGISTRA OS RESIDUOS DE CONTRATOS LIQUIDADOS PELO MUTUARIO COM COBERTURA DO FCVS, DE ACORDO COM A AVALIACAO ATUARIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.2.03.02', 'PROVISOES DO FCVS - RISCOS NAO EXPIRADOS', 'REGISTRA O MONTANTE DE CONTRATOS COM COBERTURA DO FCVS EM FASE DE PAGAMENTO PELOS MUTUARIOS, DE ACORDO COM A AVALIACAO ATUARIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.2.99.00', 'OUTRAS PROVISOES A LONGO PRAZO', 'REGISTRA OS VALORES DAS PROVISOES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.4.01.00', 'PROVISAO PARA GARANTIAS', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR DESPESAS COM A PRESTACAO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.4.02.00', 'PROVISAO PARA REESTRUTURACAO', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR OBRIGACOES ORIUNDAS DA VENDA OU EXTINCAO DE UMA LINHA DE NEGOCIOS, FECHAMENTO DE FABRICAS OU LOCAIS DE NEGOCIOS, MUDANCAS NA ESTRUTURA DA ADMINISTRACAO E REORGANIZACOES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERACOES DA ENTIDADE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.4.03.01', 'PROVISOES DO FCVS - RISCOS EXPIRADOS', 'REGISTRA OS RESIDUOS DE CONTRATOS LIQUIDADOS PELO MUTUARIO COM COBERTURA DO FCVS, DE ACORDO COM A AVALIACAO ATUARIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.4.03.02', 'PROVISOES DO FCVS - RISCOS NAO EXPIRADOS', 'REGISTRA O MONTANTE DE CONTRATOS COM COBERTURA DO FCVS EM FASE DE PAGAMENTO PELOS MUTUARIOS, DE ACORDO COM A AVALIACAO ATUARIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.4.99.00', 'OUTRAS PROVISOES A LONGO PRAZO', 'REGISTRA OS VALORES DAS PROVISOES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.5.01.00', 'PROVISAO PARA GARANTIAS', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR DESPESAS COM A PRESTACAO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.5.02.00', 'PROVISAO PARA REESTRUTURACAO', 'REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR OBRIGACOES ORIUNDAS DA VENDA OU EXTINCAO DE UMA LINHA DE NEGOCIOS, FECHAMENTO DE FABRICAS OU LOCAIS DE NEGOCIOS, MUDANCAS NA ESTRUTURA DA ADMINISTRACAO E REORGANIZACOES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERACOES DA ENTIDADE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.5.03.01', 'PROVISOES DO FCVS - RISCOS EXPIRADOS', 'REGISTRA OS RESIDUOS DE CONTRATOS LIQUIDADOS PELO MUTUARIO COM COBERTURA DO FCVS, DE ACORDO COM A AVALIACAO ATUARIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.5.03.02', 'PROVISOES DO FCVS - RISCOS NAO EXPIRADOS', 'REGISTRA O MONTANTE DE CONTRATOS COM COBERTURA DO FCVS EM FASE DE PAGAMENTO PELOS MUTUARIOS, DE ACORDO COM A AVALIACAO ATUARIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.5.99.00', 'OUTRAS PROVISOES A LONGO PRAZO', 'REGISTRA OS VALORES DAS PROVISOES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.1.1.00.00', 'ADIANTAMENTOS DE CLIENTES A LONGO PRAZO-CONSOLIDACAO', 'COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.1.2.00.00', 'ADIANTAMENTOS DE CLIENTES A LONGO PRAZO-INTRA OFSS', 'COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.1.4.00.00', 'ADIANTAMENTOS DE CLIENTES A LONGO PRAZO- INTER OFSS - ESTADO', 'COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.1.5.00.00', 'ADIANTAMENTOS DE CLIENTES A LONGO PRAZO- INTER OFSS - MUNICIPIO', 'COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.2.1.00.00', 'OBRIGACOES POR DANOS A TERCEIROS A LONGO PRAZO -CONSOLIDACAO', 'COMPREENDE OS VALORES EXIGIVEIS NO LONGO PRAZO, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.2.2.00.00', 'OBRIGACOES POR DANOS A TERCEIROS A LONGO PRAZO -INTRA OFSS', 'COMPREENDE OS VALORES EXIGIVEIS NO LONGO PRAZO, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.2.4.00.00', 'OBRIGACOES POR DANOS A TERCEIROS A LONGO PRAZO - INTER OFSS - ESTADO', 'COMPREENDE OS VALORES EXIGIVEIS NO LONGO PRAZO, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.2.5.00.00', 'OBRIGACOES POR DANOS A TERCEIROS A LONGO PRAZO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS VALORES EXIGIVEIS NO LONGO PRAZO, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.3.1.01.00', 'DEBENTURES CONVERSIVEIS EM ACOES NO LONGO PRAZO', 'COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO E QUE SAO CONVERSIVEIS EM ACOES, COM VENCIMENTO APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.3.1.02.00', 'DEBENTURES NAO CONVERSIVEIS EM ACOES NO LONGO PRAZO', 'COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO E QUE NAO SAO CONVERSIVEIS EM ACOES, COM VENCIMENTO APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.4.1.00.00', 'ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL -CONSOLIDACAO', 'REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.4.2.00.00', 'ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL -INTRA OFSS', 'REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.4.4.00.00', 'ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - ESTADO', 'REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.4.5.00.00', 'ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - MUNICIPIO', 'REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.01.01', 'INDENIZACOES A SERVIDORES', 'REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.01.02', 'INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.01.03', 'INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.01.04', 'RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS', 'REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS A SEREM EFETIVADAS PELAS UNIDADES DO INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.02.01', 'DEBITOS EM APURACAO', 'REGISTRA OS VALORES EM APURACAO A SEREM RESSARCIDOS PELO INSS A ENTIDADES, DECORRENTES DE PAGAMENTOS OU ANTECIPACOES EFETUADAS POR ESTAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.02.99', 'OUTROS DEBITOS POR INDENIZACAO E ANTECIPACOES', 'REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS POR PAGAMENTOS OU ANTECIPACOES REALIZADAS POR ENTIDADES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.03.01', 'CONVENIOS A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.03.02', 'CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.04.01', 'CONVENIOS A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DO EXERCICIO, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.04.02', 'CONVENIOS A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DE EXERCICIOS ANTERIORES, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.05.01', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.05.02', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.06.01', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.06.02', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.07.01', 'TERMOS DE PARCERIA DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.07.02', 'TERMOS DE PARCERIA DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.08.01', 'TERMOS DE PARCERIA A PAGAR DO EXERCICIO - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.08.02', 'TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.09.01', 'TERMO DE COMPROMISSO A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.09.02', 'TERMO DE COMPROMISSO A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.10.01', 'PRECATORIOS DE TERCEIROS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.10.02', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.10.03', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000', 'REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.11.01', 'COMPENSACAO PREVIDENCIARIA DO EXERCICIO', 'REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.11.02', 'COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES', 'REGISTRA O VALOR DAS OBRIGACOES DE EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.12.01', 'BOLSAS DE ESTUDOS - EXERCICIO', 'REGISTRA AS OBRIGACOES DO EXERCICIO RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.12.02', 'BOLSAS DE ESTUDOS - EXERCICIOS ANTERIORES', 'REGISTRA AS OBRIGACOES DE EXERCICIOS ANTERIORES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.13.00', 'CONTRATOS DE GESTAO', 'REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.14.01', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO', 'REGISTRA OS VALORES DO EXERCICIO EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.14.02', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO ANTERIOR', 'REGISTRA OS VALORES DE EXERCICIOS ANTERIORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.15.01', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.15.02', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO ANTERIOR', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.16.00', 'OBRIGACOES JUNTO A ENTIDADES FEDERAIS', 'REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DE OBRIGACOES JUNTO A ENTIDADES FEDERAIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.17.00', 'ENTIDADES PRIVADAS, EXCETO AS DE PREVIDENCIA', 'REGISTRA OS VALORES PARCELADOS DE DEBITOS JUNTO A ENTIDADES PRIVADAS, EXCETO AS DE PREVIDENCIA PRIVADA, A SEREM PAGOS NO LONGO PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.18.00', 'EMPRESTIMOS E FINANCIAMENTOS A LIBERAR', 'REGISTRA A APROPRIACAO DE VALORES A SEREM LIBERADOS, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.19.00', 'INCENTIVOS A LIBERAR', 'REGISTRA O VALOR DOS INCENTIVOS FISCAIS A LIBERAR POR OCASIAO DA CLASSIFICACAO DA RECEITA ARRECADADA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.20.01', 'ADIANTAMENTOS DE OPERACOES ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS AOS RECURSOS FINANCEIROS RECEBIDOS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE O MINISTERIO DAS RELACOES EXTERIORES E OUTRAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.20.02', 'ADIANTAMENTOS RECEBIDOS DE ORGAOS, ENTIDADES E UG', 'REGISTRA OS VALORES EXIGIVEIS RELATIVOS A ADIANTAMENTOS RECEBIDOS DE ORGAOS E ENTIDADES, INCLUSIVE UNIDADES GESTORAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.20.03', 'ADIANTAMENTOS DIVERSOS RECEBIDOS', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.99.00', 'OUTROS CREDORES A LONGO PRAZO', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.01.01', 'INDENIZACOES A SERVIDORES', 'REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.01.02', 'INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.01.03', 'INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.01.04', 'RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS', 'REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS A SEREM EFETIVADAS PELAS UNIDADES DO INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.02.01', 'DEBITOS EM APURACAO', 'REGISTRA OS VALORES EM APURACAO A SEREM RESSARCIDOS PELO INSS A ENTIDADES, DECORRENTES DE PAGAMENTOS OU ANTECIPACOES EFETUADAS POR ESTAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.02.99', 'OUTROS DEBITOS POR INDENIZACAO E ANTECIPACOES', 'REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS POR PAGAMENTOS OU ANTECIPACOES REALIZADAS POR ENTIDADES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.03.01', 'CONVENIOS A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.03.02', 'CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.04.01', 'CONVENIOS A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DO EXERCICIO, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.04.02', 'CONVENIOS A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DE EXERCICIOS ANTERIORES, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.05.01', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.05.02', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.06.01', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.06.02', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.07.01', 'TERMOS DE PARCERIA DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.07.02', 'TERMOS DE PARCERIA DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.08.01', 'TERMOS DE PARCERIA A PAGAR DO EXERCICIO - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.08.02', 'TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.09.01', 'TERMO DE COMPROMISSO A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.09.02', 'TERMO DE COMPROMISSO A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.10.01', 'PRECATORIOS DE TERCEIROS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.10.02', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.10.03', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000', 'REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.11.01', 'COMPENSACAO PREVIDENCIARIA DO EXERCICIO', 'REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.11.02', 'COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES', 'REGISTRA O VALOR DAS OBRIGACOES DE EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.12.01', 'BOLSAS DE ESTUDOS - EXERCICIO', 'REGISTRA AS OBRIGACOES DO EXERCICIO RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.12.02', 'BOLSAS DE ESTUDOS - EXERCICIOS ANTERIORES', 'REGISTRA AS OBRIGACOES DE EXERCICIOS ANTERIORES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.13.00', 'CONTRATOS DE GESTAO', 'REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.14.01', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO', 'REGISTRA OS VALORES DO EXERCICIO EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.14.02', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO ANTERIOR', 'REGISTRA OS VALORES DE EXERCICIOS ANTERIORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.15.01', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.15.02', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO ANTERIOR', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.16.00', 'OBRIGACOES JUNTO A ENTIDADES FEDERAIS', 'REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DE OBRIGACOES JUNTO A ENTIDADES FEDERAIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.17.00', 'ENTIDADES PRIVADAS, EXCETO AS DE PREVIDENCIA', 'REGISTRA OS VALORES PARCELADOS DE DEBITOS JUNTO A ENTIDADES PRIVADAS, EXCETO AS DE PREVIDENCIA PRIVADA, A SEREM PAGOS NO LONGO PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.18.00', 'EMPRESTIMOS E FINANCIAMENTOS A LIBERAR', 'REGISTRA A APROPRIACAO DE VALORES A SEREM LIBERADOS, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.19.00', 'INCENTIVOS A LIBERAR', 'REGISTRA O VALOR DOS INCENTIVOS FISCAIS A LIBERAR POR OCASIAO DA CLASSIFICACAO DA RECEITA ARRECADADA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.20.01', 'ADIANTAMENTOS DE OPERACOES ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS AOS RECURSOS FINANCEIROS RECEBIDOS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE O MINISTERIO DAS RELACOES EXTERIORES E OUTRAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.20.02', 'ADIANTAMENTOS RECEBIDOS DE ORGAOS, ENTIDADES E UG', 'REGISTRA OS VALORES EXIGIVEIS RELATIVOS A ADIANTAMENTOS RECEBIDOS DE ORGAOS E ENTIDADES, INCLUSIVE UNIDADES GESTORAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.20.03', 'ADIANTAMENTOS DIVERSOS RECEBIDOS', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.99.00', 'OUTROS CREDORES A LONGO PRAZO', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.01.01', 'INDENIZACOES A SERVIDORES', 'REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.01.02', 'INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.01.03', 'INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.01.04', 'RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS', 'REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS A SEREM EFETIVADAS PELAS UNIDADES DO INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.02.01', 'DEBITOS EM APURACAO', 'REGISTRA OS VALORES EM APURACAO A SEREM RESSARCIDOS PELO INSS A ENTIDADES, DECORRENTES DE PAGAMENTOS OU ANTECIPACOES EFETUADAS POR ESTAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.02.99', 'OUTROS DEBITOS POR INDENIZACAO E ANTECIPACOES', 'REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS POR PAGAMENTOS OU ANTECIPACOES REALIZADAS POR ENTIDADES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.03.01', 'CONVENIOS A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.03.02', 'CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.04.01', 'CONVENIOS A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DO EXERCICIO, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.04.02', 'CONVENIOS A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DE EXERCICIOS ANTERIORES, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.05.01', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.05.02', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.06.01', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.06.02', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.07.01', 'TERMOS DE PARCERIA DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.07.02', 'TERMOS DE PARCERIA DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.08.01', 'TERMOS DE PARCERIA A PAGAR DO EXERCICIO - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.08.02', 'TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.09.01', 'TERMO DE COMPROMISSO A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.09.02', 'TERMO DE COMPROMISSO A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.10.01', 'PRECATORIOS DE TERCEIROS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.10.02', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.10.03', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000', 'REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.11.01', 'COMPENSACAO PREVIDENCIARIA DO EXERCICIO', 'REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.11.02', 'COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES', 'REGISTRA O VALOR DAS OBRIGACOES DE EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.12.01', 'BOLSAS DE ESTUDOS - EXERCICIO', 'REGISTRA AS OBRIGACOES DO EXERCICIO RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.12.02', 'BOLSAS DE ESTUDOS - EXERCICIOS ANTERIORES', 'REGISTRA AS OBRIGACOES DE EXERCICIOS ANTERIORES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.13.00', 'CONTRATOS DE GESTAO', 'REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.14.01', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO', 'REGISTRA OS VALORES DO EXERCICIO EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.14.02', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO ANTERIOR', 'REGISTRA OS VALORES DE EXERCICIOS ANTERIORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.15.01', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.15.02', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO ANTERIOR', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.16.00', 'ENTIDADES PRIVADAS, EXCETO AS DE PREVIDENCIA', 'REGISTRA OS VALORES PARCELADOS DE DEBITOS JUNTO A ENTIDADES PRIVADAS, EXCETO AS DE PREVIDENCIA PRIVADA, A SEREM PAGOS NO LONGO PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.17.00', 'EMPRESTIMOS E FINANCIAMENTOS A LIBERAR', 'REGISTRA A APROPRIACAO DE VALORES A SEREM LIBERADOS, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.18.00', 'INCENTIVOS A LIBERAR', 'REGISTRA O VALOR DOS INCENTIVOS FISCAIS A LIBERAR POR OCASIAO DA CLASSIFICACAO DA RECEITA ARRECADADA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.19.01', 'ADIANTAMENTOS DE OPERACOES ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS AOS RECURSOS FINANCEIROS RECEBIDOS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE O MINISTERIO DAS RELACOES EXTERIORES E OUTRAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.19.02', 'ADIANTAMENTOS RECEBIDOS DE ORGAOS, ENTIDADES E UG', 'REGISTRA OS VALORES EXIGIVEIS RELATIVOS A ADIANTAMENTOS RECEBIDOS DE ORGAOS E ENTIDADES, INCLUSIVE UNIDADES GESTORAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.19.03', 'ADIANTAMENTOS DIVERSOS RECEBIDOS', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.99.00', 'OUTROS CREDORES A LONGO PRAZO', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.01.01', 'INDENIZACOES A SERVIDORES', 'REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.01.02', 'INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.01.03', 'INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.01.04', 'RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS', 'REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS A SEREM EFETIVADAS PELAS UNIDADES DO INSS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.02.01', 'DEBITOS EM APURACAO', 'REGISTRA OS VALORES EM APURACAO A SEREM RESSARCIDOS PELO INSS A ENTIDADES, DECORRENTES DE PAGAMENTOS OU ANTECIPACOES EFETUADAS POR ESTAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.02.99', 'OUTROS DEBITOS POR INDENIZACAO E ANTECIPACOES', 'REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS POR PAGAMENTOS OU ANTECIPACOES REALIZADAS POR ENTIDADES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.03.01', 'CONVENIOS A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.03.02', 'CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.04.01', 'CONVENIOS A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DO EXERCICIO, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.04.02', 'CONVENIOS A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DE EXERCICIOS ANTERIORES, REGISTRADOS PELO PORTAL / SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.05.01', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.05.02', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.06.01', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DO EXERCICIO', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.06.02', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES', 'REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES, REGISTRADOS NO PORTAL SICONV.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.07.01', 'TERMOS DE PARCERIA DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.07.02', 'TERMOS DE PARCERIA DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.08.01', 'TERMOS DE PARCERIA A PAGAR DO EXERCICIO - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.08.02', 'TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES - PORTAL SICONV', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.09.01', 'TERMO DE COMPROMISSO A PAGAR DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS NO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.09.02', 'TERMO DE COMPROMISSO A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS EM EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.10.01', 'PRECATORIOS DE TERCEIROS DO EXERCICIO', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.10.02', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000', 'REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.10.03', 'PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000', 'REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.11.01', 'COMPENSACAO PREVIDENCIARIA DO EXERCICIO', 'REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.11.02', 'COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES', 'REGISTRA O VALOR DAS OBRIGACOES DE EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.12.01', 'BOLSAS DE ESTUDOS - EXERCICIO', 'REGISTRA AS OBRIGACOES DO EXERCICIO RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.12.02', 'BOLSAS DE ESTUDOS - EXERCICIOS ANTERIORES', 'REGISTRA AS OBRIGACOES DE EXERCICIOS ANTERIORES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.13.00', 'CONTRATOS DE GESTAO', 'REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.14.01', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO', 'REGISTRA OS VALORES DO EXERCICIO EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.14.02', 'CONTRATOS DE COOPERACAO TECNICA - EXERCICIO ANTERIOR', 'REGISTRA OS VALORES DE EXERCICIOS ANTERIORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.15.01', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DO EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.15.02', 'AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO ANTERIOR', 'REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DE EXERCICIOS ANTERIORES.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.16.00', 'ENTIDADES PRIVADAS, EXCETO AS DE PREVIDENCIA', 'REGISTRA OS VALORES PARCELADOS DE DEBITOS JUNTO A ENTIDADES PRIVADAS, EXCETO AS DE PREVIDENCIA PRIVADA, A SEREM PAGOS NO LONGO PRAZO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.17.00', 'EMPRESTIMOS E FINANCIAMENTOS A LIBERAR', 'REGISTRA A APROPRIACAO DE VALORES A SEREM LIBERADOS, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.18.00', 'INCENTIVOS A LIBERAR', 'REGISTRA O VALOR DOS INCENTIVOS FISCAIS A LIBERAR POR OCASIAO DA CLASSIFICACAO DA RECEITA ARRECADADA.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.19.01', 'ADIANTAMENTOS DE OPERACOES ESPECIAIS', 'REGISTRA OS VALORES RELATIVOS AOS RECURSOS FINANCEIROS RECEBIDOS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE O MINISTERIO DAS RELACOES EXTERIORES E OUTRAS.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.19.02', 'ADIANTAMENTOS RECEBIDOS DE ORGAOS, ENTIDADES E UG', 'REGISTRA OS VALORES EXIGIVEIS RELATIVOS A ADIANTAMENTOS RECEBIDOS DE ORGAOS E ENTIDADES, INCLUSIVE UNIDADES GESTORAS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.19.03', 'ADIANTAMENTOS DIVERSOS RECEBIDOS', 'REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.99.00', 'OUTROS CREDORES A LONGO PRAZO', 'REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.1.1.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA DIFERIDA - CONSOLIDACAO', 'COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS JA RECEBIDAS QUE EFETIVAMENTE DEVEM SER RECONHECIDAS EM RESULTADOS EM ANOS FUTUROS E QUE NAO HAJA QUALQUER TIPO DE OBRIGACAO DE DEVOLUCAO POR PARTE DA ENTIDADE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.1.2.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA DIFERIDA - INTRA OFSS', 'COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS JA RECEBIDAS QUE EFETIVAMENTE DEVEM SER RECONHECIDAS EM RESULTADOS EM ANOS FUTUROS E QUE NAO HAJA QUALQUER TIPO DE OBRIGACAO DE DEVOLUCAO POR PARTE DA ENTIDADE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.1.4.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA DIFERIDA - INTER OFSS - ESTADO', 'COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS JA RECEBIDAS QUE EFETIVAMENTE DEVEM SER RECONHECIDAS EM RESULTADOS EM ANOS FUTUROS E QUE NAO HAJA QUALQUER TIPO DE OBRIGACAO DE DEVOLUCAO POR PARTE DA ENTIDADE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.1.5.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA DIFERIDA - INTER OFSS - MUNICIPIO', 'COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS JA RECEBIDAS QUE EFETIVAMENTE DEVEM SER RECONHECIDAS EM RESULTADOS EM ANOS FUTUROS E QUE NAO HAJA QUALQUER TIPO DE OBRIGACAO DE DEVOLUCAO POR PARTE DA ENTIDADE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.2.1.00.00', '(-) CUSTO DIFERIDO - CONSOLIDACAO', 'COMPREENDE O CUSTO RELACIONADO AS VARIACOES PATRIMONIAIS AUMENTATIVAS (VPA) DIFERIDAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.2.2.00.00', '(-) CUSTO DIFERIDO - INTRA OFSS', 'COMPREENDE O CUSTO RELACIONADO AS VARIACOES PATRIMONIAIS AUMENTATIVAS (VPA) DIFERIDAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.2.4.00.00', '(-) CUSTO DIFERIDO - INTER OFSS - ESTADO', 'COMPREENDE O CUSTO RELACIONADO AS VARIACOES PATRIMONIAIS AUMENTATIVAS (VPA) DIFERIDAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.2.5.00.00', '(-) CUSTO DIFERIDO - INTER OFSS - MUNICIPIO', 'COMPREENDE O CUSTO RELACIONADO AS VARIACOES PATRIMONIAIS AUMENTATIVAS (VPA) DIFERIDAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.1.1.00.00', 'PATRIMONIO SOCIAL - CONSOLIDACAO', 'REGISTRA O PATRIMONIO DAS AUTARQUIAS, FUNDACOES E FUNDOS, PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.1.01.00', 'CAPITAL SOCIAL SUBSCRITO', 'REGISTRA O VALOR DO CAPITAL SUBSCRITO DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.1.02.00', '(-) CAPITAL SOCIAL A REALIZAR', 'REGISTRA O VALOR DO CAPITAL SUBSCRITO A REALIZAR DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.1.03.00', '(-) GASTOS COM EMISSAO DE ACOES', 'REGISTRA TODOS OS GASTOS COM CAPTACAO DE RECURSOS POR EMISSAO DE ACOES OU OUTROS VALORES MOBILIARIOS PERTENCENTES AO PATRIMONIO LIQUIDO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.2.01.00', 'CAPITAL SOCIAL SUBSCRITO', 'REGISTRA O VALOR DO CAPITAL SUBSCRITO DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.2.02.00', '(-) CAPITAL SOCIAL A REALIZAR', 'REGISTRA O VALOR DO CAPITAL SUBSCRITO A REALIZAR DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.2.03.00', '(-) GASTOS COM EMISSAO DE ACOES', 'REGISTRA TODOS OS GASTOS COM CAPTACAO DE RECURSOS POR EMISSAO DE ACOES OU OUTROS VALORES MOBILIARIOS PERTENCENTES AO PATRIMONIO LIQUIDO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.4.01.00', 'CAPITAL SOCIAL SUBSCRITO', 'REGISTRA O VALOR DO CAPITAL SUBSCRITO DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.4.02.00', '(-) CAPITAL SOCIAL A REALIZAR', 'REGISTRA O VALOR DO CAPITAL SUBSCRITO A REALIZAR DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.4.03.00', '(-) GASTOS COM EMISSAO DE ACOES', 'REGISTRA TODOS OS GASTOS COM CAPTACAO DE RECURSOS POR EMISSAO DE ACOES OU OUTROS VALORES MOBILIARIOS PERTENCENTES AO PATRIMONIO LIQUIDO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.5.01.00', 'CAPITAL SOCIAL SUBSCRITO', 'REGISTRA O VALOR DO CAPITAL SUBSCRITO DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.5.02.00', '(-) CAPITAL SOCIAL A REALIZAR', 'REGISTRA O VALOR DO CAPITAL SUBSCRITO A REALIZAR DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.5.03.00', '(-) GASTOS COM EMISSAO DE ACOES', 'REGISTRA TODOS OS GASTOS COM CAPTACAO DE RECURSOS POR EMISSAO DE ACOES OU OUTROS VALORES MOBILIARIOS PERTENCENTES AO PATRIMONIO LIQUIDO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.2.0.1.00.00', 'ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDACAO', 'REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NAO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.2.0.2.00.00', 'ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTRA OFSS', 'REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NAO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.2.0.4.00.00', 'ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - ESTADO', 'REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NAO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.2.0.5.00.00', 'ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - MUNICIPIO', 'REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NAO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.1.1.00.00', 'AGIO NA EMISSAO DE ACOES - CONSOLIDACAO', 'REGISTRA A CONTRIBUICAO DO SUBSCRITOR DE ACOES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS ACOES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMACAO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM ACOES DE DEBENTURES OU PARTES BENEFICIARIAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.1.2.00.00', 'AGIO NA EMISSAO DE ACOES - INTRA OFSS', 'REGISTRA A CONTRIBUICAO DO SUBSCRITOR DE ACOES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS ACOES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMACAO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM ACOES DE DEBENTURES OU PARTES BENEFICIARIAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.1.4.00.00', 'AGIO NA EMISSAO DE ACOES - INTER OFSS - ESTADO', 'REGISTRA A CONTRIBUICAO DO SUBSCRITOR DE ACOES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS ACOES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMACAO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM ACOES DE DEBENTURES OU PARTES BENEFICIARIAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.1.5.00.00', 'AGIO NA EMISSAO DE ACOES - INTER OFSS - MUNICIPIO', 'REGISTRA A CONTRIBUICAO DO SUBSCRITOR DE ACOES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS ACOES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMACAO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM ACOES DE DEBENTURES OU PARTES BENEFICIARIAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.2.1.00.00', 'ALIENACAO DE PARTES BENEFICIARIAS - CONSOLIDACAO', 'REGISTRA O PRODUTO DA ALIENACAO DE PARTES BENEFICIARIAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.2.2.00.00', 'ALIENACAO DE PARTES BENEFICIARIAS - INTRA OFSS', 'REGISTRA O PRODUTO DA ALIENACAO DE PARTES BENEFICIARIAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.2.4.00.00', 'ALIENACAO DE PARTES BENEFICIARIAS - INTER OFSS - ESTADO', 'REGISTRA O PRODUTO DA ALIENACAO DE PARTES BENEFICIARIAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.2.5.00.00', 'ALIENACAO DE PARTES BENEFICIARIAS - INTER OFSS - MUNICIPIO', 'REGISTRA O PRODUTO DA ALIENACAO DE PARTES BENEFICIARIAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.3.1.00.00', 'ALIENACAO DE BONUS DE SUBSCRICAO - CONSOLIDACAO', 'REGISTRA O PRODUTO DA ALIENACAO DE BONUS DE SUBSCRICAO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.3.2.00.00', 'ALIENACAO DE BONUS DE SUBSCRICAO - INTRA OFSS', 'REGISTRA O PRODUTO DA ALIENACAO DE BONUS DE SUBSCRICAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.3.4.00.00', 'ALIENACAO DE BONUS DE SUBSCRICAO - INTER OFSS - ESTADO', 'REGISTRA O PRODUTO DA ALIENACAO DE BONUS DE SUBSCRICAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.3.5.00.00', 'ALIENACAO DE BONUS DE SUBSCRICAO - INTER OFSS - MUNICIPIO', 'REGISTRA O PRODUTO DA ALIENACAO DE BONUS DE SUBSCRICAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.4.1.00.00', 'CORRECAO MONETARIA DO CAPITAL REALIZADO - CONSOLIDACAO', 'REGISTRA O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NAO CAPITALIZADO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.4.2.00.00', 'CORRECAO MONETARIA DO CAPITAL REALIZADO - INTRA OFSS', 'REGISTRA O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NAO CAPITALIZADO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.4.4.00.00', 'CORRECAO MONETARIA DO CAPITAL REALIZADO - INTER OFSS - ESTADO', 'REGISTRA O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NAO CAPITALIZADO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.4.5.00.00', 'CORRECAO MONETARIA DO CAPITAL REALIZADO - INTER OFSS - MUNICIPIO', 'REGISTRA O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NAO CAPITALIZADO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.1.01.00', 'PREMIO NA EMISSAO DE DEBENTURES', 'REGISTRA OS VALORES DE PREMIO NA EMISSAO DE DEBENTURES, QUE OCORREM QUANDO O PRECO DA EMISSAO DE DEBENTURES FOR SUPERIOR A SEU VALOR NOMINAL. ESTA CONTA NAO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERIODO NECESSARIO PARA UTLIZACAO DOS SALDOS REMANESCENTES NELA .', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.1.02.00', 'RESERVAS DE DOACOES E SUBVENCOES PARA INVESTIMENTOS', 'REGISTRA OS VALORES DE DOACOES E SUBVENCOES PARA INVESTIMENTOS.ESTA CONTA NAO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERIODO NECESSARIO PARA UTLIZACAO DOS SALDOS REMANESCENTES NELA .', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.1.03.00', 'RESERVA DE CORRECAO MONETARIA ESPECIAL DEC. LEI 1.598/77', 'REGISTRA OS VALORES DO RESULTADO DA CORRECAO MONETARIA ESPECIAL, CONFORME O DECRETO-LEI Nº 1.598/77.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.1.98.00', 'DEMAIS RESERVAS DE CAPITAL', 'REGISTRA OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, NAO CONTABILIZAVEIS EM OUTRAS CONTAS DESTE PLANO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.2.01.00', 'PREMIO NA EMISSAO DE DEBENTURES', 'REGISTRA OS VALORES DE PREMIO NA EMISSAO DE DEBENTURES, QUE OCORREM QUANDO O PRECO DA EMISSAO DE DEBENTURES FOR SUPERIOR A SEU VALOR NOMINAL. ESTA CONTA NAO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERIODO NECESSARIO PARA UTLIZACAO DOS SALDOS REMANESCENTES NELA .', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.2.02.00', 'RESERVAS DE DOACOES E SUBVENCOES PARA INVESTIMENTOS', 'REGISTRA OS VALORES DE DOACOES E SUBVENCOES PARA INVESTIMENTOS.ESTA CONTA NAO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERIODO NECESSARIO PARA UTLIZACAO DOS SALDOS REMANESCENTES NELA .', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.2.03.00', 'RESERVA DE CORRECAO MONETARIA ESPECIAL DEC. LEI 1.598/77', 'REGISTRA OS VALORES DO RESULTADO DA CORRECAO MONETARIA ESPECIAL, CONFORME O DECRETO-LEI Nº 1.598/77.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.2.98.00', 'DEMAIS RESERVAS DE CAPITAL', 'REGISTRA OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, NAO CONTABILIZAVEIS EM OUTRAS CONTAS DESTE PLANO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.4.01.00', 'PREMIO NA EMISSAO DE DEBENTURES', 'REGISTRA OS VALORES DE PREMIO NA EMISSAO DE DEBENTURES, QUE OCORREM QUANDO O PRECO DA EMISSAO DE DEBENTURES FOR SUPERIOR A SEU VALOR NOMINAL. ESTA CONTA NAO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERIODO NECESSARIO PARA UTLIZACAO DOS SALDOS REMANESCENTES NELA .', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.4.02.00', 'RESERVAS DE DOACOES E SUBVENCOES PARA INVESTIMENTOS', 'REGISTRA OS VALORES DE DOACOES E SUBVENCOES PARA INVESTIMENTOS.ESTA CONTA NAO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERIODO NECESSARIO PARA UTLIZACAO DOS SALDOS REMANESCENTES NELA .', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.4.03.00', 'RESERVA DE CORRECAO MONETARIA ESPECIAL DEC. LEI 1.598/77', 'REGISTRA OS VALORES DO RESULTADO DA CORRECAO MONETARIA ESPECIAL, CONFORME O DECRETO-LEI Nº 1.598/77.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.4.98.00', 'DEMAIS RESERVAS DE CAPITAL', 'REGISTRA OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, NAO CONTABILIZAVEIS EM OUTRAS CONTAS DESTE PLANO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.5.01.00', 'PREMIO NA EMISSAO DE DEBENTURES', 'REGISTRA OS VALORES DE PREMIO NA EMISSAO DE DEBENTURES, QUE OCORREM QUANDO O PRECO DA EMISSAO DE DEBENTURES FOR SUPERIOR A SEU VALOR NOMINAL. ESTA CONTA NAO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERIODO NECESSARIO PARA UTLIZACAO DOS SALDOS REMANESCENTES NELA .', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.5.02.00', 'RESERVAS DE DOACOES E SUBVENCOES PARA INVESTIMENTOS', 'REGISTRA OS VALORES DE DOACOES E SUBVENCOES PARA INVESTIMENTOS.ESTA CONTA NAO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERIODO NECESSARIO PARA UTLIZACAO DOS SALDOS REMANESCENTES NELA .', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.5.03.00', 'RESERVA DE CORRECAO MONETARIA ESPECIAL DEC. LEI 1.598/77', 'REGISTRA OS VALORES DO RESULTADO DA CORRECAO MONETARIA ESPECIAL, CONFORME O DECRETO-LEI Nº 1.598/77.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.5.98.00', 'DEMAIS RESERVAS DE CAPITAL', 'REGISTRA OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, NAO CONTABILIZAVEIS EM OUTRAS CONTAS DESTE PLANO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.4.1.1.00.00', 'AJUSTES DE AVALIACAO PATRIMONIAL DE ATIVOS - CONSOLIDACAO', 'REGISTRA AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO EM DECORRENCIA DA SUA AVALIACAO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSAO DE VALORES MOBILIARIOS, ENQUANTO NAO COMPUTADAS NO RESULTADO DO EXERCICIO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.4.2.1.00.00', 'AJUSTES DE AVALIACAO PATRIMONIAL DE PASSIVOS - CONSOLIDACAO', 'REGISTRA AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO PASSIVO EM DECORRENCIA DA SUA AVALIACAO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSAO DE VALORES MOBILIARIOS, ENQUANTO NAO COMPUTADAS NO RESULTADO DO EXERCICIO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.1.1.00.00', 'RESERVA LEGAL- CONSOLIDACAO', 'REGISTRA OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCICIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.1.2.00.00', 'RESERVA LEGAL- INTRA OFSS', 'REGISTRA OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCICIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.1.4.00.00', 'RESERVA LEGAL- INTER OFSS - ESTADO', 'REGISTRA OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCICIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.1.5.00.00', 'RESERVA LEGAL- INTER OFSS - MUNICIPIO', 'REGISTRA OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCICIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.2.1.00.00', 'RESERVAS ESTATUTARIAS - CONSOLIDACAO', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.2.2.00.00', 'RESERVAS ESTATUTARIAS - INTRA OFSS', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.2.4.00.00', 'RESERVAS ESTATUTARIAS - INTER OFSS - ESTADO', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.2.5.00.00', 'RESERVAS ESTATUTARIAS - INTER OFSS - MUNICIPIO', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.3.1.00.00', 'RESERVA PARA CONTINGENCIAS - CONSOLIDACAO', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCICIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.3.2.00.00', 'RESERVA PARA CONTINGENCIAS - INTRA OFSS', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCICIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.3.4.00.00', 'RESERVA PARA CONTINGENCIAS - INTER OFSS - ESTADO', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCICIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.3.5.00.00', 'RESERVA PARA CONTINGENCIAS - INTER OFSS - MUNICIPIO', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCICIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.4.1.00.00', 'RESERVA DE INCENTIVOS FISCAIS - CONSOLIDACAO', 'REGISTRA A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOACOES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.4.2.00.00', 'RESERVA DE INCENTIVOS FISCAIS - INTRA OFSS', 'REGISTRA A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOACOES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.4.4.00.00', 'RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - ESTADO', 'REGISTRA A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOACOES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.4.5.00.00', 'RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - MUNICIPIO', 'REGISTRA A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOACOES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.1.01.00', 'RESERVAS DE LUCROS PARA EXPANSAO - DO EXERCICIO', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO DO EXERCICIO, COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.1.02.00', 'RESERVAS DE LUCROS PARA EXPANSAO - DE EXERCICIOS ANTERIORES', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO DE EXERCICIOS ANTERIORES, COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.2.01.00', 'RESERVAS DE LUCROS PARA EXPANSAO - DO EXERCICIO', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO DO EXERCICIO, COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.2.02.00', 'RESERVAS DE LUCROS PARA EXPANSAO - DE EXERCICIOS ANTERIORES', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO DE EXERCICIOS ANTERIORES, COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.4.01.00', 'RESERVAS DE LUCROS PARA EXPANSAO - DO EXERCICIO', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO DO EXERCICIO, COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.4.02.00', 'RESERVAS DE LUCROS PARA EXPANSAO - DE EXERCICIOS ANTERIORES', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO DE EXERCICIOS ANTERIORES, COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.5.01.00', 'RESERVAS DE LUCROS PARA EXPANSAO - DO EXERCICIO', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO DO EXERCICIO, COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.5.02.00', 'RESERVAS DE LUCROS PARA EXPANSAO - DE EXERCICIOS ANTERIORES', 'REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO DE EXERCICIOS ANTERIORES, COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.6.1.00.00', 'RESERVA DE LUCROS A REALIZAR- CONSOLIDACAO', 'REGISTRA A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCICIO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.6.2.00.00', 'RESERVA DE LUCROS A REALIZAR- INTRA OFSS', 'REGISTRA A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCICIO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.6.4.00.00', 'RESERVA DE LUCROS A REALIZAR- INTER OFSS - ESTADO', 'REGISTRA A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCICIO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.6.5.00.00', 'RESERVA DE LUCROS A REALIZAR- INTER OFSS - MUNICIPIO', 'REGISTRA A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCICIO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.7.1.00.00', 'RESERVA DE RETENCAO DE PREMIO NA EMISSAO DE DEBENTURES- CONSOLIDACAO', 'COMPREENDE A PARCELA DO LUCRO LIQUIDO DO EXERCICIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.7.2.00.00', 'RESERVA DE RETENCAO DE PREMIO NA EMISSAO DE DEBENTURES- INTRA OFSS', 'COMPREENDE A PARCELA DO LUCRO LIQUIDO DO EXERCICIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.7.4.00.00', 'RESERVA DE RETENCAO DE PREMIO NA EMISSAO DE DEBENTURES- INTER OFSS - ESTADO', 'COMPREENDE A PARCELA DO LUCRO LIQUIDO DO EXERCICIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.7.5.00.00', 'RESERVA DE RETENCAO DE PREMIO NA EMISSAO DE DEBENTURES- INTER OFSS - MUNICIPIO', 'COMPREENDE A PARCELA DO LUCRO LIQUIDO DO EXERCICIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.1.01.00', 'CREDITOS FISCAIS DIFERIDOS', 'REGISTRA AS PARCELAS DO LUCRO AINDA NAO REALIZADAS FINANCEIRAMENTE, RESULTANTE DE CREDITOS FISCAIS DIFERIDOS, DE ACORDO COM A DELIBERACAO DA CVM Nº 273, DE 20/08/98.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.1.98.00', 'DEMAIS RESERVAS DE LUCRO', 'REGISTRA AS DEMAIS RESERVAS DE LUCRO NAO CONTABILIZAVEIS EM OUTRAS CONTAS DESTE PLANO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.2.01.00', 'CREDITOS FISCAIS DIFERIDOS', 'REGISTRA AS PARCELAS DO LUCRO AINDA NAO REALIZADAS FINANCEIRAMENTE, RESULTANTE DE CREDITOS FISCAIS DIFERIDOS, DE ACORDO COM A DELIBERACAO DA CVM Nº 273, DE 20/08/98.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.2.98.00', 'DEMAIS RESERVAS DE LUCRO', 'REGISTRA AS DEMAIS RESERVAS DE LUCRO NAO CONTABILIZAVEIS EM OUTRAS CONTAS DESTE PLANO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.4.01.00', 'CREDITOS FISCAIS DIFERIDOS', 'REGISTRA AS PARCELAS DO LUCRO AINDA NAO REALIZADAS FINANCEIRAMENTE, RESULTANTE DE CREDITOS FISCAIS DIFERIDOS, DE ACORDO COM A DELIBERACAO DA CVM Nº 273, DE 20/08/98.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.4.98.00', 'DEMAIS RESERVAS DE LUCRO', 'REGISTRA AS DEMAIS RESERVAS DE LUCRO NAO CONTABILIZAVEIS EM OUTRAS CONTAS DESTE PLANO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.5.01.00', 'CREDITOS FISCAIS DIFERIDOS', 'REGISTRA AS PARCELAS DO LUCRO AINDA NAO REALIZADAS FINANCEIRAMENTE, RESULTANTE DE CREDITOS FISCAIS DIFERIDOS, DE ACORDO COM A DELIBERACAO DA CVM Nº 273, DE 20/08/98.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.5.98.00', 'DEMAIS RESERVAS DE LUCRO', 'REGISTRA AS DEMAIS RESERVAS DE LUCRO NAO CONTABILIZAVEIS EM OUTRAS CONTAS DESTE PLANO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.1.01.00', 'REAVALIACAO DE BENS IMOVEIS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR INSCRICAO GENERICA DO TIPO INDIVIDUALIZACAO DE IMOVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.1.02.00', 'REAVALIACAO DE BENS IMOVEIS - POR NUMERO DO RIP', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR NUMERO REGISTRO IMOBILIARIO PATRIMONIAL (RIP) DE IMOVEL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.1.03.00', 'REAVALIACAO DE BENS MOVEIS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS MOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.1.04.00', 'REAVALIACAO DE BENS INTANGIVEIS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS INTANGIVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR CGC, CPF, IG OU UG.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.1.05.00', 'REAVALIACAO DE ATIVOS DE COLIGADAS E CONTROLADAS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, DAS REAVALIACOES EFETUADAS NOS ATIVOS DAS COLIGADAS E CONTROLADAS AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.1.98.00', 'OUTRAS RESERVAS DE REAVALIACAO', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A OUTROS BENS DA ENTIDADE, DECORRENTES DE REAVALIACOES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.1.99.00', '(-) TRIBUTOS SOBRE A RESERVA DE REAVALIACAO', 'REGISTRA O VALOR DA CARGA TRIBUTARIA (IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL) DEVIDA SOBRE A FUTURA REALIZACAO DE ATIVO QUE A GERARAM (PARA EFEITO DE CONTROLE FISCAL).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.2.01.00', 'REAVALIACAO DE BENS IMOVEIS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR INSCRICAO GENERICA DO TIPO INDIVIDUALIZACAO DE IMOVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.2.02.00', 'REAVALIACAO DE BENS IMOVEIS - POR NUMERO DO RIP', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR NUMERO REGISTRO IMOBILIARIO PATRIMONIAL (RIP) DE IMOVEL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.2.03.00', 'REAVALIACAO DE BENS MOVEIS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS MOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.2.04.00', 'REAVALIACAO DE BENS INTANGIVEIS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS INTANGIVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR CGC, CPF, IG OU UG.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.2.05.00', 'REAVALIACAO DE ATIVOS DE COLIGADAS E CONTROLADAS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, DAS REAVALIACOES EFETUADAS NOS ATIVOS DAS COLIGADAS E CONTROLADAS AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.2.98.00', 'OUTRAS RESERVAS DE REAVALIACAO', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A OUTROS BENS DA ENTIDADE, DECORRENTES DE REAVALIACOES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.2.99.00', '(-) TRIBUTOS SOBRE A RESERVA DE REAVALIACAO', 'REGISTRA O VALOR DA CARGA TRIBUTARIA (IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL) DEVIDA SOBRE A FUTURA REALIZACAO DE ATIVO QUE A GERARAM (PARA EFEITO DE CONTROLE FISCAL).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.4.01.00', 'REAVALIACAO DE BENS IMOVEIS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR INSCRICAO GENERICA DO TIPO INDIVIDUALIZACAO DE IMOVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.4.02.00', 'REAVALIACAO DE BENS IMOVEIS - POR NUMERO DO RIP', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR NUMERO REGISTRO IMOBILIARIO PATRIMONIAL (RIP) DE IMOVEL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.4.03.00', 'REAVALIACAO DE BENS MOVEIS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS MOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.4.04.00', 'REAVALIACAO DE BENS INTANGIVEIS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS INTANGIVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR CGC, CPF, IG OU UG.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.4.05.00', 'REAVALIACAO DE ATIVOS DE COLIGADAS E CONTROLADAS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, DAS REAVALIACOES EFETUADAS NOS ATIVOS DAS COLIGADAS E CONTROLADAS AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.4.98.00', 'OUTRAS RESERVAS DE REAVALIACAO', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A OUTROS BENS DA ENTIDADE, DECORRENTES DE REAVALIACOES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.4.99.00', '(-) TRIBUTOS SOBRE A RESERVA DE REAVALIACAO', 'REGISTRA O VALOR DA CARGA TRIBUTARIA (IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL) DEVIDA SOBRE A FUTURA REALIZACAO DE ATIVO QUE A GERARAM (PARA EFEITO DE CONTROLE FISCAL).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.5.01.00', 'REAVALIACAO DE BENS IMOVEIS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR INSCRICAO GENERICA DO TIPO INDIVIDUALIZACAO DE IMOVEIS.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.5.02.00', 'REAVALIACAO DE BENS IMOVEIS - POR NUMERO DO RIP', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR NUMERO REGISTRO IMOBILIARIO PATRIMONIAL (RIP) DE IMOVEL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.5.03.00', 'REAVALIACAO DE BENS MOVEIS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS MOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.5.04.00', 'REAVALIACAO DE BENS INTANGIVEIS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS INTANGIVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR CGC, CPF, IG OU UG.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.5.05.00', 'REAVALIACAO DE ATIVOS DE COLIGADAS E CONTROLADAS', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, DAS REAVALIACOES EFETUADAS NOS ATIVOS DAS COLIGADAS E CONTROLADAS AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.5.98.00', 'OUTRAS RESERVAS DE REAVALIACAO', 'REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A OUTROS BENS DA ENTIDADE, DECORRENTES DE REAVALIACOES.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.5.99.00', '(-) TRIBUTOS SOBRE A RESERVA DE REAVALIACAO', 'REGISTRA O VALOR DA CARGA TRIBUTARIA (IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL) DEVIDA SOBRE A FUTURA REALIZACAO DE ATIVO QUE A GERARAM (PARA EFEITO DE CONTROLE FISCAL).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.9.1.00.00', 'OUTRAS RESERVAS - CONSOLIDACAO', 'REGISTRA OUTRAS RESERVAS QUE NAO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.9.2.00.00', 'OUTRAS RESERVAS - INTRA OFSS', 'REGISTRA OUTRAS RESERVAS QUE NAO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.9.4.00.00', 'OUTRAS RESERVAS - INTER OFSS - ESTADO', 'REGISTRA OUTRAS RESERVAS QUE NAO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.9.5.00.00', 'OUTRAS RESERVAS - INTER OFSS - MUNICIPIO', 'REGISTRA OUTRAS RESERVAS QUE NAO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.1.01.00', 'SUPERAVITS OU DEFICITS DO EXERCICIO', 'REGISTRA OS SUPERAVITS OU DEFICITS DO EXERCICIO DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.1.02.00', 'SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES', 'REGISTRA OS SUPERAVITS OU DEFICITS ACUMULADOS DE EXERCICIOS ANTERIORES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.1.03.00', 'AJUSTES DE EXERCICIOS ANTERIORES', 'REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANCA DE CRITERIO CONTABIL OU DA RETIFICACAO DE ERRO IMPUTAVEL A DETERMINADO EXERCICIO ANTERIOR, E QUE NAO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES. SERAO REGISTRADOS NESTA CONTA OS AJUSTES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.1.04.00', 'SUPERAVITS OU DEFICITS RESULTANTES DE EXTINCAO, FUSAO E CISAO', 'REGISTRA O RESULTADO APURADO POR EXTINCAO, CISAO OU FUSAO DE UNIDADE DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS, OCORRIDA DURANTE O EXERCICIO.', 'X', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.2.01.00', 'SUPERAVITS OU DEFICITS DO EXERCICIO', 'REGISTRA OS SUPERAVITS OU DEFICITS DO EXERCICIO DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.2.02.00', 'SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES', 'REGISTRA OS SUPERAVITS OU DEFICITS ACUMULADOS DE EXERCICIOS ANTERIORES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.2.03.00', 'AJUSTES DE EXERCICIOS ANTERIORES', 'REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANCA DE CRITERIO CONTABIL OU DA RETIFICACAO DE ERRO IMPUTAVEL A DETERMINADO EXERCICIO ANTERIOR, E QUE NAO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES. SERAO REGISTRADOS NESTA CONTA OS AJUSTES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.2.04.00', 'SUPERAVITS OU DEFICITS RESULTANTES DE EXTINCAO, FUSAO E CISAO', 'REGISTRA O RESULTADO APURADO POR EXTINCAO, CISAO OU FUSAO DE UNIDADE DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS, OCORRIDA DURANTE O EXERCICIO.', 'X', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.4.01.00', 'SUPERAVITS OU DEFICITS DO EXERCICIO', 'REGISTRA OS SUPERAVITS OU DEFICITS DO EXERCICIO DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.4.02.00', 'SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES', 'REGISTRA OS SUPERAVITS OU DEFICITS ACUMULADOS DE EXERCICIOS ANTERIORES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.4.03.00', 'AJUSTES DE EXERCICIOS ANTERIORES', 'REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANCA DE CRITERIO CONTABIL OU DA RETIFICACAO DE ERRO IMPUTAVEL A DETERMINADO EXERCICIO ANTERIOR, E QUE NAO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES. SERAO REGISTRADOS NESTA CONTA OS AJUSTES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.4.04.00', 'SUPERAVITS OU DEFICITS RESULTANTES DE EXTINCAO, FUSAO E CISAO', 'REGISTRA O RESULTADO APURADO POR EXTINCAO, CISAO OU FUSAO DE UNIDADE DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS, OCORRIDA DURANTE O EXERCICIO.', 'X', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.5.01.00', 'SUPERAVITS OU DEFICITS DO EXERCICIO', 'REGISTRA OS SUPERAVITS OU DEFICITS DO EXERCICIO DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.5.02.00', 'SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES', 'REGISTRA OS SUPERAVITS OU DEFICITS ACUMULADOS DE EXERCICIOS ANTERIORES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.5.03.00', 'AJUSTES DE EXERCICIOS ANTERIORES', 'REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANCA DE CRITERIO CONTABIL OU DA RETIFICACAO DE ERRO IMPUTAVEL A DETERMINADO EXERCICIO ANTERIOR, E QUE NAO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES. SERAO REGISTRADOS NESTA CONTA OS AJUSTES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.5.04.00', 'SUPERAVITS OU DEFICITS RESULTANTES DE EXTINCAO, FUSAO E CISAO', 'REGISTRA O RESULTADO APURADO POR EXTINCAO, CISAO OU FUSAO DE UNIDADE DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS, OCORRIDA DURANTE O EXERCICIO.', 'X', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.1.01.00', 'LUCROS E PREJUIZOS DO EXERCICIO', 'REGISTRA O SALDO DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS NO EXERCICIO.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.1.02.00', 'LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES', 'REGISTRA O SALDO DOS LUCROS E PREJUIZOS ACUMULADOS NOS EXERCICIOS ANTERIORES DAS EMPRESAS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.1.03.00', 'AJUSTES DE EXERCICIOS ANTERIORES', 'REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANCA DE CRITERIO CONTABIL OU DA RETIFICACAO DE ERRO IMPUTAVEL A DETERMINADO EXERCICIO ANTERIOR, E QUE NAO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES.', 'X', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.1.04.00', 'LUCROS A DESTINAR DO EXERCICIO', 'REGISTRA O VALOR DOS LUCROS DO EXERCICIO PENDENTES DE DESTINACAO, ATE A APROVACAO DA PROPOSTA PELA ASSEMBLEIA GERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.1.05.00', 'LUCROS A DESTINAR DE EXERCICIOS ANTERIORES', 'REGISTRA O VALOR DOS LUCROS DE EXERCICIOS ANTERIORES PENDENTES DE DESTINACAO, ATE A APROVACAO DA PROPOSTA PELA ASSEMBLEIA GERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.1.06.00', 'RESULTADOS APURADOS POR EXTINCAO, FUSAO E CISAO', 'REGISTRA O RESULTADO APURADO POR EXTINCAO, CISAO OU FUSAO DE EMPRESAS DURANTE O EXERCICIO.', 'X', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.2.01.00', 'LUCROS E PREJUIZOS DO EXERCICIO', 'REGISTRA O SALDO DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS NO EXERCICIO.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.2.02.00', 'LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES', 'REGISTRA O SALDO DOS LUCROS E PREJUIZOS ACUMULADOS NOS EXERCICIOS ANTERIORES DAS EMPRESAS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.2.03.00', 'AJUSTES DE EXERCICIOS ANTERIORES', 'REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANCA DE CRITERIO CONTABIL OU DA RETIFICACAO DE ERRO IMPUTAVEL A DETERMINADO EXERCICIO ANTERIOR, E QUE NAO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES.', 'X', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.2.04.00', 'LUCROS A DESTINAR DO EXERCICIO', 'REGISTRA O VALOR DOS LUCROS DO EXERCICIO PENDENTES DE DESTINACAO, ATE A APROVACAO DA PROPOSTA PELA ASSEMBLEIA GERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.2.05.00', 'LUCROS A DESTINAR DE EXERCICIOS ANTERIORES', 'REGISTRA O VALOR DOS LUCROS DE EXERCICIOS ANTERIORES PENDENTES DE DESTINACAO, ATE A APROVACAO DA PROPOSTA PELA ASSEMBLEIA GERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.2.06.00', 'RESULTADOS APURADOS POR EXTINCAO, FUSAO E CISAO', 'REGISTRA O RESULTADO APURADO POR EXTINCAO, CISAO OU FUSAO DE EMPRESAS DURANTE O EXERCICIO.', 'X', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.4.01.00', 'LUCROS E PREJUIZOS DO EXERCICIO', 'REGISTRA O SALDO DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS NO EXERCICIO.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.4.02.00', 'LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES', 'REGISTRA O SALDO DOS LUCROS E PREJUIZOS ACUMULADOS NOS EXERCICIOS ANTERIORES DAS EMPRESAS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.4.03.00', 'AJUSTES DE EXERCICIOS ANTERIORES', 'REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANCA DE CRITERIO CONTABIL OU DA RETIFICACAO DE ERRO IMPUTAVEL A DETERMINADO EXERCICIO ANTERIOR, E QUE NAO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES.', 'X', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.4.04.00', 'LUCROS A DESTINAR DO EXERCICIO', 'REGISTRA O VALOR DOS LUCROS DO EXERCICIO PENDENTES DE DESTINACAO, ATE A APROVACAO DA PROPOSTA PELA ASSEMBLEIA GERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.4.05.00', 'LUCROS A DESTINAR DE EXERCICIOS ANTERIORES', 'REGISTRA O VALOR DOS LUCROS DE EXERCICIOS ANTERIORES PENDENTES DE DESTINACAO, ATE A APROVACAO DA PROPOSTA PELA ASSEMBLEIA GERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.4.06.00', 'RESULTADOS APURADOS POR EXTINCAO, FUSAO E CISAO', 'COMPREENDE O RESULTADO APURADO POR EXTINCAO, CISAO OU FUSAO DE EMPRESAS DURANTE O EXERCICIO.', 'X', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.5.01.00', 'LUCROS E PREJUIZOS DO EXERCICIO', 'REGISTRA O SALDO DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS NO EXERCICIO.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.5.02.00', 'LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES', 'REGISTRA O SALDO DOS LUCROS E PREJUIZOS ACUMULADOS NOS EXERCICIOS ANTERIORES DAS EMPRESAS.', 'X', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.5.03.00', 'AJUSTES DE EXERCICIOS ANTERIORES', 'REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANCA DE CRITERIO CONTABIL OU DA RETIFICACAO DE ERRO IMPUTAVEL A DETERMINADO EXERCICIO ANTERIOR, E QUE NAO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES.', 'X', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.5.04.00', 'LUCROS A DESTINAR DO EXERCICIO', 'REGISTRA O VALOR DOS LUCROS DO EXERCICIO PENDENTES DE DESTINACAO, ATE A APROVACAO DA PROPOSTA PELA ASSEMBLEIA GERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.5.05.00', 'LUCROS A DESTINAR DE EXERCICIOS ANTERIORES', 'REGISTRA O VALOR DOS LUCROS DE EXERCICIOS ANTERIORES PENDENTES DE DESTINACAO, ATE A APROVACAO DA PROPOSTA PELA ASSEMBLEIA GERAL.', 'C', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.5.06.00', 'RESULTADOS APURADOS POR EXTINCAO, FUSAO E CISAO', 'REGISTRA O RESULTADO APURADO POR EXTINCAO, CISAO OU FUSAO DE EMPRESAS DURANTE O EXERCICIO.', 'X', 'S', 'P', 'X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.1.1.00.00', '(-) ACOES EM TESOURARIA - CONSOLIDACAO', 'REGISTRA O VALOR DAS ACOES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.1.2.00.00', '(-) ACOES EM TESOURARIA - INTRA OFSS', 'REGISTRA O VALOR DAS ACOES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.1.4.00.00', '(-) ACOES EM TESOURARIA - INTER OFSS - ESTADO', 'REGISTRA O VALOR DAS ACOES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.1.5.00.00', '(-) ACOES EM TESOURARIA - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR DAS ACOES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.2.1.00.00', '(-) COTAS EM TESOURARIA - CONSOLIDACAO', 'REGISTRA O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.2.2.00.00', '(-) COTAS EM TESOURARIA - INTRA OFSS', 'REGISTRA O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.2.4.00.00', '(-) COTAS EM TESOURARIA - INTER OFSS - ESTADO', 'REGISTRA O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.2.5.00.00', '(-) COTAS EM TESOURARIA - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', 'P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.01', 'SOLDO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VENCIMENTOS DOS MILITARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.1.1.02.00', 'AUXILIO TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-TRANSPORTE PAGAS EM FORMA DE PECUNIA DIRETAMENTE AOS SERVIDORES, DESTINADO AO CUSTEIO PARCIAL DAS DESPESAS REALIZADAS COM TRANSPORTE COLETIVO MUNICIPAL INTERMUNICIPAL OU INTERESTADUAL NOS DESLOCAMENTOS DE SUAS RESIDENCIAS PARA OS LOCAIS DE TRABALHO E VICE-VERSA, OU TRABALHO-TRABALHO NOS CASOS DE ACUMULACAO LICITA DE CARGOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.1.1.03.00', 'AUXILIO MORADIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AUXILIO DE MORADIA AO SERVIDOR, NOS TERMOS DOS ARTIGOS 60-A A 60-E, DA LEI Nº 8.112/90.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.08.00', 'LICENCA PREMIO PARA INATIVO CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PAGAMENTO DE LICENCA PREMIO PARA INATIVOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.12.00', 'MATERIAL DESTINADO A CONTRIBUINTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL (CD-ROM, FORMULARIOS, ETC.) PARA DISTRIBUICAO AOS CONTRIBUINTES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.03.00', 'AUDITORIA EXTERNA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE AUDITORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.47.00', 'SERVICOS FUNERARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REMOCOES, SEPULTAMENTOS E TRANSLADACOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.4.01.00', 'JUROS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.5.01.00', 'JUROS E ENCARGOS EM INDENIZACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES REFERENTES A JUROS E ENCARGOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.80.00', 'PASEP TRANSFERIDO A ESTADOS', 'REGISTRA OS VALORES TRANSFERIDOS PELA UNIAO AOS ESTADOS, RELATIVOS AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.99.00', 'OUTROS IMPOSTOS', 'REGISTRA O VALOR DE VPDS COM OUTROS IMPOSTOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.5.10.00', 'IMPOSTO S/ IMPORTACAO', 'REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS TEM COMO FATO GERADOR A ENTRADA DESTES NO TERRITORIO NACIONAL', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.2.01.00', 'CPV - IMPOSTOS', 'REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.02.01', 'TAXA DE FISCALIZACAO DE INSTALACAO', 'REGISTRA O VALOR TOTAL DA TAXA PAGA NO MOMENTO DA EMISSAO DO CERTIFICADO DE LICENCA PARA O FUNCIONAMENTO DAS ESTACOES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.13.01', 'TAXA POR PLANO DE ASSISTENCIA A SAUDE', 'REGISTRA A VPA PROVENIENTE DA TAXA POR PLANO DE ASSISTENCIA A SAUDE, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.99.00', '(-) OUTRAS DEDUCOES DE VENDAS', 'REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE MERCADORIAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.21.00', 'FORNECIMENTO DE MAO-DE-OBRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO FORNECIMENTO DE MAO-DE-OBRA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.15.01', 'SERVICOS DE PUBLICIDADE LEGAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE AGENCIAMENTO DE PUBLICIDADE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.45.05', 'SERVICOS DE REGISTRO PROGRAMA DE COMPUTADOR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE PROGRAMAS DE COMPUTADOR, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.37.05', 'INFORMACAO TECNOLOGICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES TECNOLOGICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.45.01', 'SERVICOS DE PATENTES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PETICOES, PEDIDOS DE PRIVILEGIO, ANUIDADES DE PEDIDOS, REGISTROS DE DESENHO INDUSTRIAL,ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.30.03', 'PERMISSAO DE USO AREA DA UNIAO CURTA DURACAO', 'REGISTRA VPA DECORRENTE DA PERMISSAO DE USO DE AREA DA UNIAO DE CURTA DURACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.99.00', '(-) OUTRAS DEDUCOES DE VENDAS', 'REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE SERVICOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.10.00', 'MUL.JUR.MORA TX FISC.VIGILANCIA SANITARIA', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.20.00', 'MULTA E JUROS DE MORA S/CONT.DOS CONC.E PROG.', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DE MULTA E JUROS DE MORA S/ CONTRIBUICOES DOS CONCURSOS DE PROGNOSTICOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.05.01', 'COTA DIFERIDA - BAIXA', 'REGISTRA O VALOR DA COTA DIFERIDA NO PROCESSO DE BAIXA DOS RECURSOS DIFERIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.17.00', 'MULTAS PREVISTAS NO COD.BRAS. DE AERONAUTICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES PREVISTAS NO CODIGO BRASILEIRO DE AERONAUTICA (LEI 7565, DE19/12/86; LEI NUM. 9614, DE 05/03/98).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.21.00', 'MULTAS POR DANOS AO MEIO AMBIENTE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS POR DANOS AO MEIO AMBIENTE. AMPARO LEGAL: LEI 9 605 DE 12FEV1998', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.01.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.03.01', 'CONTRAGARANTIAS SOBRE AVAIS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.01.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.08.04', 'CONTROLE DE ARRECADACAO DE RECEITAS (C/C 37)', 'REGISTRA O ESPELHO DA CONTA DE RECEITA, REGISTRADAS NAS UG ARRECADADORAS, COM CONTROLE POR NATUREZA DE RECEITA + FONTE + UO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.24', 'APOLICES DE SEGUROS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.01.09', 'CONVENIOS E INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.05', 'CONTR.REPASSE DE PROGR. A APROVAR', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.1.01.01', 'COTA DIFERIDA A CONCEDER', 'REGISTRA AS COTAS DIFERIDAS A CONCEDER.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.32.11', 'VALOR RENUNCIÁVEL', 'REGISTRA A PARCELA DO VALOR CAPTADO QUE PODE SER OBJETO DE RENUNCIA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.05.01.00.00.00', 'CREDORES - RESTOS A PAGAR PROCESSADOS - EXECUTIVO / INDIRETAS', 'REGISTRA O MONTANTE DAS DESPESAS COM CREDORES REALIZADAS E LIQUIDADAS PELO PODER EXECUTIVO E ENTIDADES DA ADMINISTRAÇÃO INDIRETA E NÃO PAGAS ATÉ 31 DE DEZEMBRO DO ANO ANTERIOR E DEVEM SER DESDOBRADAS POR EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.05.02.00.00.00', 'CREDORES - RESTOS A PAGAR PROCESSADOS - LEGISLATIVO', 'REGISTRA O MONTANTE DAS DESPESAS COM CREDORES REALIZADAS E LIQUIDADAS PELO PODER LEGISLATIVO E NÃO PAGAS ATÉ 31 DE DEZEMBRO DO ANO ANTERIOR E DEVERAO SER DESDOBRADAS POR EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.05.03.00.00.00', 'CREDORES - RESTOS A PAGAR PROCESSADOS - RPPS', 'REGISTRA O MONTANTE DAS DESPESAS COM CREDORES REALIZADAS E LIQUIDADAS PELO REGIME PRÓPRIO DE PREVIDÊNCIA DO SERVIDOR E NÃO PAGAS ATÉ 31 DE DEZEMBRO DO ANO ANTERIOR E DEVERAO SER DESDOBRADAS POR EXERCICIO.', 'C', 'S', 'P', 'F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.06.06.00.00.00', 'DISPENSA DE LICITAÇAO', 'REGISTRA O VALOR DO EMPENHOS LIQUIDADOS POR DISPENSA DE LICITACAO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.0.00.00', 'CONTRIBUICAO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO', 'COMPREENDE A CONTRIBUICAO SOBRE A RECEITA DE CONCURSOS DE PROGNOSTICOS, QUE SAO TODOS E QUAISQUER CONCURSOS DE SORTEIOS DE NUMEROS, LOTERIAS, APOSTAS, INCLUSIVE AS REALIZADAS EM REUNIOES HIPICAS, NOS AMBITOS FEDERAL, ESTADUAL, DO DISTRITO FEDERAL E MUNICIPAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.01.00', 'VPA COM OPERACOES DE AUTORIDADE MONETARIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES DE AUTORIDADE MONETARIA .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.0.0.0.0.00.00', 'ATIVO', 'COMPREENDE OS RECURSOS CONTROLADOS POR UMA ENTIDADE COMO CONSEQUENCIA DE EVENTOS PASSADOS E DOS QUAIS SE ESPERA QUE FLUAM BENEFICIOS ECONOMICOS OU POTENCIAL DE SERVICOS FUTUROS A UNIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.02.00', 'CONTA UNICA - SUBCONTA DO TESOURO NACIONAL', 'COMPREENDE OS VALORES DA CONTA UNICA DEPOSITADOS NO BANCO CENTRAL DO BRASIL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.04.00', 'ENCARGOS SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER', 'COMPREENDE OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.4.03.00', 'ADIANTAMENTOS A UNIDADES E ENTIDADES', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.01.00', 'MERCADORIAS - ESTOQUES PROGRAMAS PROPRIOS', 'COMPREENDE O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA, RELATIVAS A PROGRAMAS PROPRIOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.1.0.00.00', 'PREMIOS DE SEGUROS A APROPRIAR', 'COMPREENDE OS VALORES PAGOS A TITULO DE PREMIOS DE SEGURO A APROPRIAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.98.00', 'OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO', 'COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.04.00', 'MATERIAS-PRIMAS', 'COMPREENDE O ESTOQUE DE MATERIAS-PRIMAS QUE SERA UTILIZADO NO PROCESSO PRODUTIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.00.00', 'PARTICIPACOES PERMANENTES - CONSOLIDACAO', 'COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE ACOES OU COTAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.08.00', 'BENS MOVEIS EM ALMOXARIFADO', 'COMPREENDE OS VALORES DE BENS PERMANENTES A SEREM ESTOCADOS EM ALMOXARIFADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.00', 'BENS DE USO COMUM DO POVO', 'COMPREENDE OS BENS DE USO COMUM DO POVO CONSTRUIDOS OU ADQUIRIDOS POR PESSOAS JURIDICAS DE DIREITO PUBLICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.01.00', 'INSS A PAGAR', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.06.00', 'OPERACOES ESPECIAIS', 'COMPREENDE A APROPRIACAO DOS VALORES DAS OPERACOES ESPECIAIS CONTRAIDAS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULADAS A CONTRATOS E ACORDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.0.00.00', 'PROVISAO PARA RISCOS CIVEIS A CURTO PRAZO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.0.00.00', 'VALORES RESTITUIVEIS', 'COMPREENDE OS VALORES DE TERCEIROS OU RETENCOES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PUBLICO FOR FIEL DEPOSITARIA, INDEPENDENTEMENTE DO PRAZO DE EXIGIBILIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.11.00', 'TERMO DE COMPROMISSO A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.35.00', 'INTERMEDIARIOS DE INVESTIMENTOS', 'COMPREENDE OS VALORES DE OBRIGACOES A CURTO PRAZO COM INTERMEDIARIOS DE INVESTIMENTOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.11.00', 'TERMO DE COMPROMISSO A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.1.03.00', 'ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR', 'COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.01.00', 'EMPRESTIMOS INTERNOS - EM TITULOS', 'COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.1.01.00', 'FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.06.00', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR, REGISTRADOS NO PORTAL SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.1.0.00.00', 'PATRIMONIO SOCIAL', 'COMPREENDE O PATRIMONIO DAS AUTARQUIAS, FUNDACOES E FUNDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.00', 'VENCIMENTOS E VANTAGENS FIXAS - PES. MILITAR', 'COMPREENDE O SOMATORIO DOS VALORES COM VENCIMENTOS E VANTAGENS FIXAS DO PESSOAL MILITAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.0.00.00', 'CUSTO DE PRODUTOS VENDIDOS - PESSOAL E ENCARGOS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.9.0.00.00', 'OUTRAS PENSOES', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS PENSOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.0.0.00.00', 'OUTROS BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.55.00', 'ARRENDAMENTO MERCANTIL OPERACIONAL', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL OPERACIONAL', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.5.00.00', 'JUROS E ENCARGOS DE MORA DE OBRIGACOES TRIBUTARIAS - INTER OFSS - MUNICIPIO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.01.00', 'ORDEM DE TRANSFERENCIAS CONCEDIDAS', 'COMPREENDE O VALOR TOTAL DAS ORDENS DE TRANSFERENCIAS CONCEDIDAS REFERENTES A RECURSOS VINCULADOS QUE DEVERAO PERMANECER NA UG BENEFICIADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.0.00.00', 'OUTRAS TRANSFERENCIAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE DEMAIS TRANSFERENCIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.00', 'DIARIAS - CIVIL', 'COMPREENDE AS DESPESAS COM DIARIAS - CIVIL DECORRENTES DE DELEGACAO AOS ESTADOS E AO DISTRITO FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.00', 'VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CREDITOS - DIVIDA ATIVA TRIBUTARIA', 'COMPREENDE VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CREDITOS DA DIVIDA ATIVA TRIBUTARIA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.9.0.00.00', 'OUTRAS CONTRIBUICOES', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES QUE NAO SE ENQUADRAM NA CONDICAO DE SOCIAIS E ECONOMICAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.2.97.00', '(-)DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.4.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.5.02.00', 'IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA', 'COMPREENDE O VALOR DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I - DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II - DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.5.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.4.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.4.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.5.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.12.00', 'CONT.REL.AT.IMP.COM.PETR.DER.GAS NAT.ALC.CARB', 'COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO E COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.3.0.0.00.00', 'CONTRIBUICAO DE ILUMINACAO PUBLICA', 'COMPREENDE AS CONTRIBUICOES DE ILUMINACAO PUBLICA, NOS TERMOS DO ARTIGO 149-A DA CONSTITUICAO FEDERAL, ACRESCENTADO PELA EMENDA CONSTITUCIONAL Nº 39/02, SENDO FACULTADA A COBRANCA DA CONTRIBUICAO NA FATURA DE CONSUMO DE ENERGIA ELETRICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.00.00', 'VENDA BRUTA DE PRODUTOS - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE PRODUTOS,QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.18.00', 'PRESTACAO DE SERVICOS RELACIONADOS AO BENEFICIAMENTO DE GRAOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE BENEFICIAMENTO DE GRAOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.63.00', 'SERVICOS FINANCEIROS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM SERVICOS FINANCEIROS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.4.0.0.00.00', 'DESCONTOS FINANCEIROS OBTIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE DESCONTOS FINANCEIROS OBTIDOS EM VIRTUDE DE LIQUIDACAO ANTECIPADA DE OBRIGACOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.0.00.00', 'TRANSFERENCIAS VOLUNTARIAS', 'COMPREENDEM AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANFERENCIAS VOLUNTARIAS DA UNIAO, ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, BEM COMO AS DEMAIS ENTIDADES DE BENS E/OU VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.9.0.00.00', 'OUTROS GANHOS COM INCORPORACAO DE ATIVO', 'COMPREENDE A CONTRAPARTIDA DA INCORPORACAO DE OUTROS NOVOS ATIVOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.0.0.00.00', 'DIVERSAS VARIACOES PATRIMONIAIS AUMENTATIVAS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS NAO CLASSIFICADAS EM ITENS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.04.00', 'CONTRAGARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.0.0.00.00', 'PROGRAMACAO FINANCEIRA', 'COMPREENDE AS CONTAS QUE REGISTRAM AS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.8.0.0.0.00.00', 'CUSTOS', 'COMPREENDE AS CONTAS QUE CONTROLAM OS CUSTOS DE BENS E SERVICOS PRODUZIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.2.2.00.00', 'RECEBIMENTO DE PF DE EMPENHO CONTRA-ENTREGA', 'COMPREENDE AS CONTAS QUE REGISTRAM O RECEBIMENTO DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.00', 'EXECUCAO DE GARANTIAS RECEBIDAS NO PAIS', 'COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEDIDOS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.00.00', 'EXECUCAO DE DIREITOS CONTRATUAIS - CONSOLIDACAO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.00.00', 'EXECUCAO DAS OUTRAS UNIDADES GESTORAS', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DO LIMITE ORCAMENTARIO NAS OUTRAS UNIDADES GESTORAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.1.00.00.00.00.00', 'DOTAÇÃO INICIAL', 'Compreende a dotação inicial autorizada na lei orçamentária anual.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.00.00.00.00.00', 'EMPENHOS POR EMISSAO', 'COMPREENDE O SOMATORIO DOS VALORES EMPENHADOS POR DETALHAMENTO ESPECIFICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.06.02', 'Bancos Conta Movimento - Plano Financeiro', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.01.00', 'INSS a Pagar', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.08.00', 'TAXA DE LICENCIAMENTO AMBIENTAL', 'REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.08.00', 'TAXA DE LICENCIAMENTO AMBIENTAL', 'REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.07.00', 'TAXA DE LICENCIAMENTO AMBIENTAL', 'REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.08.00', 'TAXA DE INSPECAO VEICULAR', 'REGISTRA AS OBRIGACOES REFERENTES AO PAGAMENTO DA TAXA DE INSPECAO VEICULAR DE VEICULOS, DECORRENTES DO SERVICO DE INSPECAO VEICULAR AMBIENTAL IMPLEMENTADO PELA PREFEITURA DE SAO PAULO E OUTRAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.07.00', 'TAXA DE LICENCIAMENTO AMBIENTAL', 'REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.08.00', 'TAXA DE INSPECAO VEICULAR', 'REGISTRA AS OBRIGACOES REFERENTES AO PAGAMENTO DA TAXA DE INSPECAO VEICULAR DE VEICULOS, DECORRENTES DO SERVICO DE INSPECAO VEICULAR AMBIENTAL IMPLEMENTADO PELA PREFEITURA DE SAO PAULO E OUTRAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.03.00', 'BACEN-MEIO CIRCULANTE-OPERACAO DE CREDITO INTERNA', 'REGISTRA O VALOR DAS OBRIGACOES REFERENTES A OPERACOES DE CREDITO INTERNA REALIZADAS PELO BACEN - MEIO CIRCULANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.03.00', 'BACEN-MEIO CIRCULANTE-OPERACAO DE CREDITO INTERNA', 'REGISTRA O VALOR DAS OBRIGACOES REFERENTES A OPERACOES DE CREDITO INTERNA REALIZADAS PELO BACEN - MEIO CIRCULANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.03.00', 'BACEN-MEIO CIRCULANTE-OPERACAO DE CREDITO INTERNA', 'REGISTRA O VALOR DAS OBRIGACOES REFERENTES A OPERACOES DE CREDITO INTERNA REALIZADAS PELO BACEN - MEIO CIRCULANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.2.0.00.00', 'OBRIGACOES POR DANOS A TERCEIROS A LONGO PRAZO', 'COMPREENDE OS VALORES EXIGIVEIS NO LONGO PRAZO, PROVENIENTES DE DANOS A TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.01', 'VENCIMENTOS E SALARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VENCIMENTOS E SALARIOS DO PESSOAL CIVIL REGIDOS PELO REGIME PROPRIO DE PREVIDENCIA SOCIAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.02', 'ADICIONAL NOTURNO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACOES A SERVIDORES EM ATIVIDADE NOTURNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.03', 'INCORPORACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE VENCIMENTOS E VANTAGENS POR INCORPORACOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.04', 'ABONO DE PERMANENCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PAGAMENTO DO ABONO DE PERMANENCIA, DEVIDO AOS SERVIDORES QUE TENDO COMPLETADO AS EXIGENCIAS PARA APOSENTADORIA VOLUNTARIA, OPTE POR PERMANECER EM ATIVIDADE. (EMENDA CONSTITUCIONAL NR.41 DE 19/12/2003 E ORIENTACAO NORMATIVA DA SECRETARIA DE PREVIDENCIA SOCIAL NR.01 DE 06/01/2004). DE ACORDO COM A MEDIDA PROVISORIA 167, DE 19 DE FEVEREIRO DE 2004.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.05', 'ADICIONAL DE PERICULOSIDADE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE SERVIDORES QUE EXERCEM ATIVIDADES PERIGOSAS, CONFORME ART.68 DA LEI 8112/90.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.06', 'ADICIONAL DE INSALUBRIDADE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE SERVIDORES EM ATIVIDADE EM LOCAIS INSALUBRES, CONF. ART. 68 DA LEI 8112/90.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.07', 'ADICIONAL DE ATIVIDADES PENOSAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE SERVIDORES QUE EXERCEM ATIVIDADES PENOSAS, CONFORME ART.71 DA LEI 8112/90.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.08', 'INCENTIVO A QUALIFICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM INCENTIVO A QUALIFICACAO DE SERVIDORES QUE POSSUIREM EDUCACAO FORMAL SUPERIOR AO EXIGIDO PELOS CARGOS QUE OCUPAM, EM AREAS DE INTERESSE DO ORGAO, CONFORME ESTABELECIDO NA LEI Nº 11.091/2005 E NA LEI Nº 11.416/06.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.09', 'REMUNERACAO DE PESSOAL EM DISPONIBILIDADE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM VENCIMENTOS E VANTAGENS FIXAS A PESSOAL CIVIL EM DISPONIBILIDADE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.10', 'RETR.ADIC.VARIAVEL E PRO-LABORE(LEI 7711/88)', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE RETRIBUICAO ADICIONAL VARIAVEL E PRO-LABORE DE EXITO CONFORME LEI 7.711/88, ARTIGOS TERCEIRO E QUINTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.12', 'VANTAGEM PECUNIARIA INDIVIDUAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM A VANTAGEM PECUNIARIA INDIVIDUAL (INCLUSIVE DA LEI 10698, DE 02/07/03).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.13', 'ABONO PROVISORIO - PESSOAL CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ABONO PROVISORIO A PESSOAL CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.14', 'GRATIFICACAO POR EXERCICIO DE CARGOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO POR EXERCICIO DE CARGOS, COMO GAJ, ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.15', 'INCREMENTO PLANO DE CARGOS E SALARIOS JUDIC.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A DIFERENCA DE REMUNERACAO DOS CARGOS RESULTANTES DA TRANSFORMACAO SOBRE A DOS TRANSFORMADOS PELO PLANO DE CARGOS E SALARIOS DO PODER JUDICIARIO, CONFOR- ME DISPOSTO NO PARAGRAFO 2º DO ARTIGO 4 DA LEI 9.421/96.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.16', 'GRATIFICACAO POR EXERCICIO DE FUNCOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO POR EXERCICIO DE FUNCOES, DE COORDENACAO, ASSESSORAMENTO, CHEFIA E ENCARGO DE ATIVIDADES ESPECIFICAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.17', 'INDENIZACAO DE LOCALIZACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE INDENIZACAO DE LOCALIZACAO ESPECIFICA DETERMINADA POR LEI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.97.10', 'Renúncia', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.18', 'GRATIFICACAO DE TEMPO DE SERVICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES ADQUIRIDAS EM FUNCAO DE CONTAGEM DE TEMPO DE SERVICO, PESSOAL CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.19', 'GRATIFICACOES ESPECIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL, TAIS COMO: GRATIFICACAO ESPECIAL DE LOCALIZACAO, ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.20', 'GRATIFICACAO POR ATIVIDADES EXPOSTAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES, QUANDO PELO EXERCICIO, EXPOE O SERVIDOR A RISCOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.21', 'FERIAS VENCIDAS E PROPORCIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE FERIAS VENCIDAS E PROPORCIONAIS NA RESCISAO DE CONTRATO DE TRABALHO OU EXONERACAO DO SERVIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.22', '13. SALARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE NATAL (13 SALARIO) DO PESSOAL CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.23', 'FERIAS - ABONO PECUNIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM A CONVERSAO EM ABONO PECUNIARIO DE UM TERCO DO VALOR DA REMUNERACAO DEVIDA AO SERVIDOR NO PERIODO DE FERIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.24', 'FERIAS - ABONO CONSTITUCIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DO VALOR DO ABONO CONCEDIDO A TODOS EMPREGADOS E SERVIDORES COMO REMUNERACAO DO PERIODO DE FERIAS ANUAIS - UM TERCO A MAIS DO QUE O SALARIO NORMAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.25', 'LICENCA-PREMIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCA-PREMIO POR ASSIDUIDADE NO TRABALHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.26', 'LICENCA CAPACITACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCA PARA CAPACITACAO. ARTIGO 81, DA LEI 8112/90 - ALTERADO PELA MP 1537- 10/97.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.27', 'ADIANTAMENTO PECUNIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ADIANTAMENTO PECUNIARIO DEVIDOS AOS SERVIDORES EM DECORRENCIA DE DETERMINACAO LEGAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.28', 'REPRESENTACAO MENSAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM REPRESENTACAO MENSAL, POR EXEMPLO DO "DAS" E ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.29', 'COMPLEMENTACAO SALARIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM COMPLEMENTACAO DE REMUNERACAO PAGA A PESSOAL CIVIL - ART 40 - PARAGRAFO UNICO, DA LEI 8112/90 E O PARAGRAFO SEGUNDO, ART.15, DA LEI Nº 11.091, 12/01/2005.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.30', 'ADICIONAL - TETO PARLAMENTAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA AJUDA DE CUSTO CONCEDIDA AOS PARLAMENTARES NOS MESES DE FEVEREIRO, JUNHO E DEZEMBRO SOBRE A REMUNERACAO DOS SERVIDORES ATIVOS E INATIVOS DA CAMARA DOS DEPUTADOS E DO SENADO FEDERAL, AMPARADAS POR RESOLUCOES INTERNAS DESSAS CASAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.31', 'SUBSIDIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SUBSIDIOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.32', 'GRATIFICACAO P/EXERCICIO DE CARGO EM COMISSAO', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO POR EXERCICIO DE CARGOS EM COMISSAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.33', 'VENCIM. E SAL.- PROR. SALARIO MATERNIDADE', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VENCIMENTOS E SALARIOS DO PESSOAL CIVIL REFERENTE A PRORROGACAO DO SALARIO MATERNIDADE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.98', 'INTEGRACAO DE DADOS ENT. PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.99', 'OUTROS VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RPPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS DESPESAS FIXAS-PESSOAL CIVIL NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.01', 'SUBSTITUICOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE SUBSTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.02', 'ADICIONAL VARIAVEL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE ADICIONAL VARIAVEL SUJEITOS A INCIDENCIA DE TRIBUTOS E CONTRIBUICOES DE ACORDO COM A LEI 10.973/04 - DISTRIBUICAO DE ROYALTIES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.03', 'SERVICOS EXTRAORDINARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE SERVICOS EXTRAORDINARIOS, TAIS COMO HORA EXTRA E OUTROS DE CARATER EVENTUAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.04', 'GRATIFICACAO POR EMBARQUE FLUVIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE GRATIFICACAO POR EMBARQUE FLUVIAL PAGA AOS CAPITAES, PILOTOS FLUVIAIS, SUPERVISORES MAQUINISTAS, TAIFEIROS FLUVIAIS, CONTRAMESTRES, CONDUTORES, COZINHEIROS E MARINHEIROS CONFORME TABELA DE GRATIFICACAO MENSAL POR EMBARQUE EM ANEXO A RESOLUCAO N 002/98 DO CONSELHO DE ADMINISTRACAO DA COMPANHIA DE NAVEGACAO DO SAO FRANCISCO - FRANAVE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.05', 'GRATIFICACAO ELEITORAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE GRATIFICACAO ELEITORAL PARA JUIZES E PROMOTORES DESIGNADOS PARA APRECIACAO DAS RECLAMACOES OU REPRESENTACOES DIRIGIDAS AOS TRIBUNAIS ELEITORAIS (LEI Nº 9504, DE 30/09/97).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.06', 'LICENCA SEM REMUNERACAO INCENTIVADA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SERVIDORES QUE SOLICITARAM LICENCA SEM REMUNERACAO INCENTIVADA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.07', 'ADICIONAL POR PLANTAO HOSPITALAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE ADICIONAL POR PLANTAO HOSPITALAR - APH DEVIDO AOS SERVIDORES EM EFETIVO EXERCICIO DE ATIVIDADES HOSPITALARES, DESEMPENHADAS EM REGIME DE PLANTAO, NAS AREAS INDISPENSAVEIS AO FUNCIONAMENTO ININTERRUPTO DOS HOSPITAIS CONSTANTES NO ARTIGO 298 DA LEI 12.155, DE 2009, QUE ALTERA A LEI 11.907, DE 02 DE FEVEREIRO DE 2009.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.08', 'CONVOCACAO EXTRAORDINARIA LEGISLATIVA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM CONVOCACOES EXTRAORDINARIAS DO CONGRESSO NACIONAL, CONFORME INCISO II, DO PARAGRAFO 6, DO ARTIGO 57, DA CONSTITUICAO FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.98', 'INTEGRACAO DADOS ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.99', 'OUTRAS VPD VARIAVEIS - PESSOAL CIVIL - RPPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.03.00', 'SENTENCAS JUDICIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SENTENCAS JUDICIAIS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.01', 'VENCIMENTOS E SALARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VENCIMENTOS E SALARIOS DO PESSOAL CIVIL REGIDOS PELO REGIME GERAL DA PREVIDENCIA SOCIAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.02', 'ADICIONAL NOTURNO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACOES A EMPREGADOS EM ATIVIDADE NOTURNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.03', 'INCORPORACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE VENCIMENTOS E VANTAGENS POR INCORPORACOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.04', 'ABONO DE PERMANENCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PAGAMENTO DO ABONO DE PERMANENCIA, DEVIDO AOS EMPREGADOS QUE TENDO COMPLETADO AS EXIGENCIAS PARA APOSENTADORIA VOLUNTARIA, OPTE POR PERMANECER EM ATIVIDADE. (EMENDA CONSTITUCIONAL NR.41 DE 19/12/2003 E ORIENTACAO NORMATIVA DA SECRETARIA DE PREVIDENCIA SOCIAL NR.01 DE 06/01/2004). DE ACORDO COM A MEDIDA PROVISORIA 167, DE 19 DE FEVEREIRO DE 2004.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.05', 'ADICIONAL DE PERICULOSIDADE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE EMPREGADOS QUE EXERCEM ATIVIDADES PERIGOSAS, CONFORME O § 1º , DO ARTIGO 193, DO DECRETO-LEI N.º 5.452, DE 1º DE MAIO DE 1943 (CLT).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.06', 'ADICIONAL DE INSALUBRIDADE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE EMPREGADOS EM ATIVIDADE EM LOCAIS INSALUBRES, CONFORME ARTIGO 192, DO DECRETO-LEI N.º 5.452, DE 1º DE MAIO DE 1943 (CLT).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.07', 'REMUNERACAO PARTICIPANTES DE ORGAO DE DELIBERACAO COLETIVA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE REMUNERACAO DE MEMBROS DE ORGAOS DE DELIBERACAO COLETIVA (CONSELHO CONSULTIVO, CONSELHO DE ADMINISTRACAO, CONSELHO FISCAL OU OUTROS ORGAOS COLEGIADOS), OBSERVADO O DISPOSTO NA LEI N. 7733, DE 14/02/89.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.08', 'INCENTIVO A QUALIFICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM INCENTIVO A QUALIFICACAO DE EMPREGADOS QUE POSSUIREM EDUCACAO FORMAL SUPERIOR AO EXIGIDO PELO EMPREGO/CARGO QUE OCUPAM, EM AREAS DE INTERESSE DO ORGAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.09', 'ADICIONAL DE TRANSFERENCIA - ART. 469/CLT', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE SERVIDORES QUE EXERCEM FORAM TRANSFERIDOS CONFORME ART.469 DA CLT.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.10', 'RETR.ADIC.VARIAVEL E PRO-LABORE(LEI 7711/88)', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE RETRIBUICAO ADICIONAL VARIAVEL E PRO-LABORE DE EXITO CONFORME LEI 7.711/88, ARTIGOS TERCEIRO E QUINTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.11', 'REMUNERACAO DE DIRETORES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE REMUNERACAO DE DIRETORES DE EMPRESAS PUBLICAS E DE ECONOMIA MISTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.12', 'VANTAGEM PECUNIARIA INDIVIDUAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM A VANTAGEM PECUNIARIA INDIVIDUAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.13', 'ABONO PROVISORIO - PESSOAL CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ABONO PROVISORIO A PESSOAL CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.14', 'GRATIFICACAO POR EXERCICIO DE CARGOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO POR EXERCICIO DE CARGOS, COMO GAJ, ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.15', 'INDENIZACAO A ANISTIADO POLITICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE INDENIZACAO DE ANISTIADOS POLITICOS CONFORME A LEI 10.559/2002', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.16', 'GRATIFICACAO POR EXERCICIO DE FUNCOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO POR EXERCICIO DE FUNCOES, DE COORDENACAO, ASSESSORAMENTO, CHEFIA E ENCARGO DE ATIVIDADES ESPECIFICAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.17', 'INDENIZACAO DE LOCALIZACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE INDENIZACAO DE LOCALIZACAO ESPECIFICA DETERMINADA POR LEI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.18', 'GRATIFICACAO DE TEMPO DE SERVICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES ADQUIRIDAS EM FUNCAO DE CONTAGEM DE TEMPO DE SERVICO, PESSOAL CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.19', 'GRATIFICACOES ESPECIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL, TAIS COMO: GRATIFICACAO ESPECIAL DE LOCALIZACAO, ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.20', 'GRATIFICACAO POR ATIVIDADES EXPOSTAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES, QUANDO PELO EXERCICIO, EXPOE O SERVIDOR A RISCOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.21', 'FERIAS VENCIDAS E PROPORCIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE FERIAS VENCIDAS E PROPORCIONAIS NA RESCISAO DE CONTRATO DE TRABALHO OU DEMISSAO DO EMPREGADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.22', '13. SALARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE NATAL (13 SALARIO) DO PESSOAL CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.23', 'FERIAS - ABONO PECUNIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM A CONVERSAO EM ABONO PECUNIARIO DE UM TERCO DO VALOR DA REMUNERACAO DEVIDA AO EMPREGADO NO PERIODO DE FERIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.24', 'FERIAS - ABONO CONSTITUCIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DO VALOR DO ABONO CONCEDIDO A TODOS EMPREGADOS COMO REMUNERACAO DO PERIODO DE FERIAS ANUAIS - UM TERCO A MAIS DO QUE O SALARIO NORMAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.25', 'LICENCA-PREMIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCA-PREMIO POR ASSIDUIDADE NO TRABALHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.26', 'LICENCA CAPACITACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCA PARA CAPACITACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.27', 'ADIANTAMENTO PECUNIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ADIANTAMENTO PECUNIARIO DEVIDOS AOS SERVIDORES EM DECORRENCIA DE DETERMINACAO LEGAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.28', 'REPRESENTACAO MENSAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM REPRESENTACAO MENSAL, POR EXEMPLO DO "DAS" E ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.29', 'COMPLEMENTACAO SALARIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM COMPLEMENTACAO DE REMUNERACAO PAGA A PESSOAL CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.98', 'INTEGRACAO PARCIAL DE DADOS ORGAOS ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.99', 'OUTROS VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS DESPESAS FIXAS-PESSOAL CIVIL NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.01', 'SUBSTITUICOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE SUBSTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.02', 'ADICIONAL VARIAVEL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE ADICIONAL VARIAVEL SUJEITOS A INCIDENCIA DE TRIBUTOS E CONTRIBUICOES DE ACORDO COM A LEI 10.973/04 - DISTRIBUICAO DE ROYALTIES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.03', 'SERVICOS EXTRAORDINARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE SERVICOS EXTRAORDINARIOS, TAIS COMO HORA EXTRA E OUTROS DE CARATER EVENTUAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.04', 'GRATIFICACAO POR EMBARQUE FLUVIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE GRATIFICACAO POR EMBARQUE FLUVIAL PAGA AOS CAPITAES, PILOTOS FLUVIAIS, SUPERVISORES MAQUINISTAS, TAIFEIROS FLUVIAIS, CONTRAMESTRES, CONDUTORES, COZINHEIROS E MARINHEIROS CONFORME TABELA DE GRATIFICACAO MENSAL POR EMBARQUE EM ANEXO A RESOLUCAO N 002/98 DO CONSELHO DE ADMINISTRACAO DA COMPANHIA DE NAVEGACAO DO SAO FRANCISCO - FRANAVE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.05', 'AVISO PREVIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AVISO PREVIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.06', 'PARTICIPACAO A EMPREGADOS E ADMINISTRADORES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE PARTICIPACAO A EMPREGADOS OU ADMINISTRADORES DE ACORDO COM O CONSTANTE DO ESTATUTO SOCIAL DA EMPRESA DISTRIBUIDORA. A PARTICIPACAO DOS EMPREGADOS NO LUCRO - PL, TEM RESPALDO NO QUE CONSTA DO INCISO VI DO ART. 187 DA LEI Nº 6.404/76.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.98', 'INTEGRACAO DADOS ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.99', 'OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.03.00', 'SENTENCAS JUDICIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SENTENCAS JUDICIAIS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.01', 'SALARIO CONTRATO TEMPORARIO - LEI 8.745/93', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIOS DECORRENTES DE CONTRATOS TEMPORARIOS - LEI 8.745/93.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.02', 'ADICIONAL NOTURNO DE CONTRATO TEMPORARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL NOTURNO DECORRENTE DE CONTRATOS TEMPORARIOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.03', 'ADICIONAL DE PERICULOSIDADE CONTR. TEMPORARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL DE PERICULOSIDADE CONTR. TEMPORARIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.04', 'ADICIONAL DE INSALUBRIDADE CONTRATO TEMPORARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL DE INSALUBRIDADE CONTRATO TEMPORARIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.05', 'ADICIONAL DE ATIVIDADES PENOSAS - CONTR. TEMPORARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ADICIONAL DE ATIVIVIDADES PENOSAS - CONTRATO TEMPORARIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.06', 'SERVICOS EVENTUAIS DE MEDICOS RESIDENTES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SERVICOS EVENTUAIS DE MEDICOS RESIDENTES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.07', 'RESIDENCIA MULTIPROFISSIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESIDENCIA MULTIPROFISSIONAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.08', 'ADICIONAL DE IRRADIACAO IONIZANTE CONT. TEMP.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO DE PESSOAL COM CONTRATO TEMPORARIO QUE EXERCEM ATIVIDADES COM IRRADIACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.09', 'GRATIFICACAO DE RAIO-X CONTRATO TEMPORARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO DE PESSOAL COM CONTRATO TEMPORARIO QUE EXERCEM ATIVIDADES COM RAIO-X.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.10', 'SERVICOS EXTRAORDINARIOS CONTRATO TEMPORARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE PESSOAL POR TEMPO DETERMINADO REALIZADAS A TITULO DE SERVICOS EXTRAORDINARIOS, TAIS COMO: HORA EXTRA E OUTROS DE CARATER EVENTUAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.11', 'SERVICOS EXTRAORDINARIOS NOTURNO CONT. TEMP.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO DE PESSOAL COM CONTRATO TEMPORARIO EM ATIVIDADE NOTURNA REALIZADAS A TITULO DE SERVICOS EXTRAORDINARIOS, TAIS COMO: HORA EXTRA E OUTROS DE CARATER EVENTUAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.12', 'FERIAS VENCIDAS/PROPORCIONAIS CONT.TEMPORARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE FERIAS VENCIDAS E PROPORCIONAIS DE PESSOAL CONTRATADO TEMPORARIAMENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.13', '13º SALARIO CONTRATO TEMPORARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE 13º SALARIO COM PESSOAL CONTRATADO POR TEMPO DETERMINADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.14', 'FERIAS - ABONO CONSTITUCIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONCESSAO DE ABONO PELO PERIODO DE FERIAS ANUAIS-UM TERCO A MAIS DO QUE O SALARIO NORMAL-COM PESSOAL CONTRATADO POR TEMPO DETERMINADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.15', 'FERIAS - PAGAMENTO ANTECIPADO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FERIAS PAGAS ANTECIPADAMENTE COM PESSOAL CONTRADADO POR TEMPO DETERMINADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.16', 'SERVICOS EVENTUAIS DE AUXILIARES CIVIS NO EXT', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIARES CIVIS PARA ATENDER AOS ORGAOS DE REPRESENTACAO BRASILEIROS NO EXTERIOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.99', 'OUTRAS VANTAGENS CONTRATOS TEMPORARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PAGAMENTO DE OUTRAS VANTAGENS DE PESSOAL DE CONTRATO TEMPORARIOS, TAIS COMO: GRATIFICACAO NATALINA, FERIAS, ADICIONAL NOTURNO, ADICIONAL INSALUBRIDADE, ADICIONAL DE PERICULOSIDADE, ADICIONAL PARA SERVICOS EXTRAORDINARIOS, ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.02', 'ADICIONAL DE PERMANENCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ADICIONAL DE PERMANENCIA DE MILITARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.03', 'ADICIONAL DE TEMPO DE SERVICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ADICIONAL DE TEMPO DE SERVICO DE MILITARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.04', 'ADICIONAL MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ADICIONAL MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.05', 'ADICIONAL DE COMPENSACAO ORGANICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ADICIONAL DE COMPENSACAO ORGANICA DE MILITARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.06', 'ADICIONAL DE HABILITACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ADICIONAL DE HABILITACAO DE MILITARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.07', 'GRATIFICACAO DE LOCALIDADE ESPECIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE LOCALIDADE ESPECIAL DE MILITARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.08', 'GRATIFICACAO DE REPRESENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE REPRESENTACAO DE MILITARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.09', 'GRATIFICACAO DE FUNCAO DE NATUREZA ESPECIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE FUNCAO DE NATUREZA ESPECIAL (BASE LEGAL: LEI Nº 10.486/02, ART.3, INSICO VII)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.10', 'GRATIFICACAO DE SERVICO VOLUNTARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE SERVICO VOLUNTARIO (BASE LEGAL: LEI Nº 10.486/02, ART.3, INSICO VIII).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.11', 'VANTAGEM PECUNIARIA ESPECIAL - VPE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VANTAGEM PECUNIARIA ESPECIAL - VPE (BASE LEGAL: LEI Nº 11.134/05, ART.1).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.12', 'INDENIZACAO DE REPRESENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM INDENIZACAO DE REPRESENTACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.13', 'GRATIFICACAO DE EXERCICIOS DE CARGOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE EXERCICIO DE CARGOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.14', 'FERIAS VENCIDAS E PROPORCIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE FERIAS VENCIDAS E PROPORCIONAIS DEVIDAS A MILITARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.15', 'ADICIONAL NATALINO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ADICIONAL NATALINO (13 SALARIO) DE MILITARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.16', 'FERIAS - ABONO CONSTITUCIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS AO GOZO DE FERIAS ANUAIS REMUNERADAS PROVENIENTE DE UM TERCO DO SALARIO NORMAL - PAGO A MAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.17', 'COMPLEMENTACAO SALARIAL - PESSOAL MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM COMPLEMENTACAO DE REMUNERACAO PAGA A PESSOAL MILITAR - LEI NR. 5.594/87.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.98', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.99', 'OUTRAS VPD FIXAS - PESSOAL MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS FIXAS - PESSOAL MILITAR, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.02.01', 'INDENIZACOES/MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM INDENIZACOES PAGAS AOS MILITARES DAS FORCAS ARMADAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.02.02', 'ADICIONAL TAREFA TEMPO CERTO(ART. 23 MP 2131)', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS CONCEDIDAS A TITULO DE ADICIONAL AO MILITAR DA RESERVA REMUNERADA, E EXCEPCIONALMENTE O REFORMADO, QUE TENHA MODIFICADA SUA SITUACAO NA INATIVIDADE PARA AQUELA PREVISTA PARA A PRESTACAO DE TAREFA POR TEMPO CERTO CORRESPONDENTE A TRES DECIMOS DOS PROVENTOS QUE ESTIVER PERCEBENDO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.02.98', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.02.99', 'OUTRAS DESPESAS VARIAVEIS - PESSOAL MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS DESPESAS VARIAVEIS - PESSOAL MILITAR NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.03.00', 'SENTENCAS JUDICIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SENTENCAS JUDICIAIS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.2.01.00', 'CONTRIBUICAO PATRONAL PARA O RPPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.2.02.00', 'ENCARGOS DE PESSOAL REQUISIT. DE OUTROS ENTES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.2.06.00', 'CONTRIBUICAO PARA O PASEP S/ FOLHA PAGAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO PARA O PASEP, DETERMINADA COM BASE NA FOLHA DE PAGAMENTO, A ALIQUOTA DE 1%, PELAS FUNDACOES PUBLICAS INSTITUIDAS OU MANTIDAS PELO PODER PUBLICO (MP 2.158-35/2001).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.2.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.2.99.00', 'OUTROS ENCARGOS PATRONAIS - RPPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RPPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.4.01.00', 'CONTRIBUICAO PATRONAL PARA O RPPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.4.02.00', 'ENCARGOS DE PESSOAL REQUISIT. DE OUTROS ENTES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.4.06.00', 'CONTRIBUICAO PARA O PASEP S/ FOLHA PAGAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO PARA O PASEP, DETERMINADA COM BASE NA FOLHA DE PAGAMENTO, A ALIQUOTA DE 1%, PELAS FUNDACOES PUBLICAS INSTITUIDAS OU MANTIDAS PELO PODER PUBLICO (MP 2.158-35/2001).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.4.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.4.99.00', 'OUTROS ENCARGOS PATRONAIS - RPPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RPPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.5.01.00', 'CONTRIBUICAO PATRONAL PARA O RPPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.5.02.00', 'ENCARGOS DE PESSOAL REQUISIT. DE OUTROS ENTES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.5.06.00', 'CONTRIBUICAO PARA O PASEP S/ FOLHA PAGAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO PARA O PASEP, DETERMINADA COM BASE NA FOLHA DE PAGAMENTO, A ALIQUOTA DE 1%, PELAS FUNDACOES PUBLICAS INSTITUIDAS OU MANTIDAS PELO PODER PUBLICO (MP 2.158-35/2001).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.5.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.5.99.00', 'OUTROS ENCARGOS PATRONAIS - RPPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RPPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.01.00', 'CONTRIBUICOES PREVIDENCIARIAS - INSS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES QUE NAO PERTENCAM AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS AO INSS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.02.00', 'CONTRIBUICOES PREVIDENCIARIAS NO EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS REALIZADAS AOS AUXILIARES LOCAIS DOS POSTOS NO EXTERIOR. A LEI 7.501/1986, ALTERADA PELA LEI 8.745/1993, ESTABELECE, EM SEU ARTIGO 67, QUE AS RELACOES TRABALHISTAS E PREVIDENCIARIAS CONCERNENTES A ESSES AUXILIARES SERAO REGIDAS PELA LEGISLACAO VIGENTE NO PAIS EM QUE ESTIVER SEDIADA A REPARTICAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.03.00', 'SEGURO DE ACIDENTE NO TRABALHO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS DE SEGURO DE ACIDENTES DO TRABALHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.04.00', 'ENCARGOS DE PESSOAL REQUISIT. DE OUTROS ENTES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.05.00', 'CONTRIB PREVID-INSS_PRORR.SAL.MATERNIDADE', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES QUE NAO PERTENCAM AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS AO INSS_REFERENTE A PRORROGACAO DO SALARIO MATERNIDADE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.06.00', 'CONTRIBUICAO PARA O PIS S/ FOLHA PAGAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO PARA O PIS, DETERMINADA COM BASE NA FOLHA DE PAGAMENTO, A ALIQUOTA DE 1%, PELAS FUNDACOES PUBLICAS INSTITUIDAS OU MANTIDAS PELO PODER PUBLICO (MP 2.158-35/2001).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.99.00', 'OUTROS ENCARGOS PATRONAIS - RGPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.2.01.00', 'CONTRIBUICOES PREVIDENCIARIAS - INSS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES QUE NAO PERTENCAM AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS AO INSS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.2.02.00', 'CONTRIBUICOES PREVIDENCIARIAS NO EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS REALIZADAS AOS AUXILIARES LOCAIS DOS POSTOS NO EXTERIOR. A LEI 7.501/1986, ALTERADA PELA LEI 8.745/1993, ESTABELECE, EM SEU ARTIGO 67, QUE AS RELACOES TRABALHISTAS E PREVIDENCIARIAS CONCERNENTES A ESSES AUXILIARES SERAO REGIDAS PELA LEGISLACAO VIGENTE NO PAIS EM QUE ESTIVER SEDIADA A REPARTICAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.2.03.00', 'SEGURO DE ACIDENTE NO TRABALHO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS DE SEGURO DE ACIDENTES DO TRABALHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.2.04.00', 'ENCARGOS DE PESSOAL REQUISIT. DE OUTROS ENTES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.2.06.00', 'CONTRIBUICAO PARA O PIS S/ FOLHA PAGAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO PARA O PIS, DETERMINADA COM BASE NA FOLHA DE PAGAMENTO, A ALIQUOTA DE 1%, PELAS FUNDACOES PUBLICAS INSTITUIDAS OU MANTIDAS PELO PODER PUBLICO (MP 2.158-35/2001).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.2.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.2.99.00', 'OUTROS ENCARGOS PATRONAIS - RGPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.4.01.00', 'CONTRIBUICOES PREVIDENCIARIAS - INSS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES QUE NAO PERTENCAM AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS AO INSS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.4.02.00', 'CONTRIBUICOES PREVIDENCIARIAS NO EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS REALIZADAS AOS AUXILIARES LOCAIS DOS POSTOS NO EXTERIOR. A LEI 7.501/1986, ALTERADA PELA LEI 8.745/1993, ESTABELECE, EM SEU ARTIGO 67, QUE AS RELACOES TRABALHISTAS E PREVIDENCIARIAS CONCERNENTES A ESSES AUXILIARES SERAO REGIDAS PELA LEGISLACAO VIGENTE NO PAIS EM QUE ESTIVER SEDIADA A REPARTICAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.4.03.00', 'SEGURO DE ACIDENTE NO TRABALHO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS DE SEGURO DE ACIDENTES DO TRABALHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.4.04.00', 'ENCARGOS DE PESSOAL REQUISIT. DE OUTROS ENTES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.4.06.00', 'CONTRIBUICAO PARA O PIS S/ FOLHA PAGAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO PARA O PIS, DETERMINADA COM BASE NA FOLHA DE PAGAMENTO, A ALIQUOTA DE 1%, PELAS FUNDACOES PUBLICAS INSTITUIDAS OU MANTIDAS PELO PODER PUBLICO (MP 2.158-35/2001).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.4.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.4.99.00', 'OUTROS ENCARGOS PATRONAIS - RGPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.5.01.00', 'CONTRIBUICOES PREVIDENCIARIAS - INSS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES QUE NAO PERTENCAM AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS AO INSS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.5.02.00', 'CONTRIBUICOES PREVIDENCIARIAS NO EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS REALIZADAS AOS AUXILIARES LOCAIS DOS POSTOS NO EXTERIOR. A LEI 7.501/1986, ALTERADA PELA LEI 8.745/1993, ESTABELECE, EM SEU ARTIGO 67, QUE AS RELACOES TRABALHISTAS E PREVIDENCIARIAS CONCERNENTES A ESSES AUXILIARES SERAO REGIDAS PELA LEGISLACAO VIGENTE NO PAIS EM QUE ESTIVER SEDIADA A REPARTICAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.5.03.00', 'SEGURO DE ACIDENTE NO TRABALHO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS DE SEGURO DE ACIDENTES DO TRABALHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.5.04.00', 'ENCARGOS DE PESSOAL REQUISIT. DE OUTROS ENTES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.5.06.00', 'CONTRIBUICAO PARA O PIS S/ FOLHA PAGAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO PARA O PIS, DETERMINADA COM BASE NA FOLHA DE PAGAMENTO, A ALIQUOTA DE 1%, PELAS FUNDACOES PUBLICAS INSTITUIDAS OU MANTIDAS PELO PODER PUBLICO (MP 2.158-35/2001).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.5.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.5.99.00', 'OUTROS ENCARGOS PATRONAIS - RGPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.3.1.01.00', 'FGTS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OBRIGACOES RELATIVAS AO RECOLHIMENTO DO FGTS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.3.1.02.00', 'FGTS - PDV', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FGTS DE SERVIDORES QUE OPTARAM PELO PLANO DE DEMISSAO VOLUNTARIA - PDV.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.3.1.03.00', 'FGTS-PRORROGACAO DO SALARIO MATERNIDADE', 'REGISTRA OS VALORES DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OBRIGACOES RELATIVAS AO RECOLHIMENTO DO FGTS REFERENTE A PRORROGACAO DO SALARIO MATERNIDADE', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.4.1.01.00', 'SESI/SENAI ATIVO CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM CONTRIBUICOES PATRONAIS PARA O SESI/SENAI - ATIVO CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.4.1.02.00', 'CONTRIBUICAO DE SALARIO EDUCACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO DE SALARIO-EDUCACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.4.1.03.00', 'CONTRIB DE SALAR-EDUC PRORRO SALAR MATERN.', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO DE SALARIO-EDUCACAO REFERENTE A PRORROGACAO DO SALARIO MATERNIDADE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.1.01.00', 'COMPLEMENTACAO DE PREVIDENCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICOES DE RESPONSABILIDADE DAS ENTIDADES PATROCINADORAS PARA ATENDER PLANO DE PREVIDENCIA COMPLEMENTAR, ADMINISTRADO POR SUAS INSTITUICOES DE SEGURIDADE SOCIAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.1.02.00', 'SEGUROS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICOES A ENTIDADES DE PREVIDENCIA FECHADA, SOB A MODALIDADE DE SEGUROS, TAIS COMO: SEGURO DE VIDA-PAC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.1.03.00', 'CONT. PATRONAL PREVIDENCIA PRIVADA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICAO PATRONAL, DEVIDA A ENTIDADES DE PREVIDENCIA PRIVADA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.1.04.00', 'COMPLEM DE PREVID PRORROG SALARIO MATERNIDADE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICOES DE RESPONSABILIDADE DAS ENTIDADES PATROCINADORAS P/ ATENDER PLANO DE PREVIDENCIA COMPLEMENTAR, ADMINISTRADO POR SUAS INSTITUICOES DE SEGURIDADE SOCIAL REFERENTE A PRORROGACAO DO SALARIO MATERNIDADE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.1.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.1.99.00', 'OUTRAS CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICOES A ENTIDADES PRIVADAS NAO ENQUADRADAS NOS SUBITENS ANTERIORES. E AS DE ORGAOS NAO INTEGRANTES OU PARCIALMENTE INTEGRANTES NO SIAFI, DECORRENTE DA INCORPORACAO DE SEUS BALANCETES AO SISTEMA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.1.00.00', 'OUTROS ENCARGOS PATRONAIS - CONSOLIDACAO', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS AOS ENCARGOS PATRONAIS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.2.00.00', 'OUTROS ENCARGOS PATRONAIS - INTRA OFSS', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS AOS ENCARGOS PATRONAIS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.4.00.00', 'OUTROS ENCARGOS PATRONAIS - INTER OFSS - ESTADO', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADOS AOS ENCARGOS PATRONAIS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.5.00.00', 'OUTROS ENCARGOS PATRONAIS - INTER OFSS - MUNICIPIO', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADOS AOS ENCARGOS PATRONAIS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.1.1.01.00', 'AUXILIO ALIMENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM AUXILIO ALIMENTACAO EM PECUNIA AO SERVIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.1.1.04.00', 'AJUDA DE CUSTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AJUDA DE CUSTO DE PESSOAL CIVIL - RPPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.1.1.05.00', 'PLANO DE SAUDE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PLANO DE SAUDE AO SERVIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.1.1.06.00', 'AUXILIO CRECHE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-CRECHE, DEVIDO A SERVIDOR PUBLICO, DECORRENTE DE RESSARCIMENTO DE GASTOS COM A EDUCACAO PRE-ESCOLAR DE SEUS DEPENDENTES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.1.1.99.00', 'OUTROS BENEFICIOS A PESSOAL - RPPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTROS BENEFICIOS A PESSOAL - RPPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.2.1.01.00', 'AUXILIO ALIMENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM AUXILIO ALIMENTACAO EM PECUNIA AO EMPREGADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.2.1.02.00', 'AUXILIO TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-TRANSPORTE PAGAS EM FORMA DE PECUNIA DIRETAMENTE AOS EMPREGADOS, DESTINADO AO CUSTEIO PARCIAL DAS DESPESAS REALIZADAS COM TRANSPORTE COLETIVO MUNICIPAL INTERMUNICIPAL OU INTERESTADUAL NOS DESLOCAMENTOS DE SUAS RESIDENCIAS PARA OS LOCAIS DE TRABALHO E VICE-VERSA, OU TRABALHO-TRABALHO NOS CASOS DE ACUMULACAO LICITA DE EMPREGOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.2.1.03.00', 'AUXILIO MORADIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AUXILIO DE MORADIA AO EMPREGADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.2.1.04.00', 'AJUDA DE CUSTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AJUDA DE CUSTO DE PESSOAL CIVIL - RGPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.2.1.05.00', 'PLANO DE SAUDE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PLANO DE SAUDE AO EMPREGADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.2.1.06.00', 'AUXILIO CRECHE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-CRECHE, DEVIDO AO EMPREGADO, DECORRENTE DE RESSARCIMENTO DE GASTOS COM A EDUCACAO PRE-ESCOLAR DE SEUS DEPENDENTES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.2.1.99.00', 'OUTROS BENEFICIOS A PESSOAL - RGPS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTROS BENEFICIOS A PESSOAL - RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.3.1.01.00', 'ETAPA ALIMENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ETAPA DE ALIMENTACAO RELATIVA AO DIREITO REMUNERATORIO DOS MILITARES DAS FORCAS ARMADAS, CONFORME MP 2.215-10 DE 31/08/2001.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.3.1.02.00', 'AUXILIO TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM TRANSPORTE RELATIVO AO DIREITO REMUNERATORIO DOS MILITARES DAS FORCAS ARMADAS, CONFORME MP 2.215-10 DE 31/08/2001.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.3.1.03.00', 'AUXILIO MORADIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AUXILIO DE MORADIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.3.1.04.00', 'AJUDA DE CUSTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AJUDA DE CUSTO RELATIVA AO DIREITO REMUNERATORIO DOS MILITARES DAS FORCAS ARMADAS, CONFORME MP 2.215-10 DE 31/08/2001.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.3.1.05.00', 'PLANO DE SAUDE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PLANO DE SAUDE AO MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.3.1.06.00', 'AUXILIO CRECHE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-CRECHE, DEVIDO AO MILITAR, DECORRENTE DE RESSARCIMENTO DE GASTOS COM A EDUCACAO PRE-ESCOLAR DE SEUS DEPENDENTES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.3.1.07.00', 'AUXILIO FARDAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE VPD COM AUXILIO-FARDAMENTO PARA MILITARES DAS FORCAS ARMADAS, CONFORME DISPOSTO NA MP 2.215/2010 E DECRETO Nº 4.307/2002.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.3.1.08.00', 'AUXILIO FAMILIAR - NO EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-FAMILIAR, PREVISTO NO DECRETO Nº 71.733, DE 18 DE JANEIRO DE 1973.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.3.1.99.00', 'OUTROS BENEFICIOS A PESSOAL - MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTROS BENEFICIOS A PESSOAL - MILITAR, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.01.00', 'CMV - REMUNERACAO A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.02.00', 'CMV - REMUNERACAO A PESSOAL -RGPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.03.00', 'CMV - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.04.00', 'CMV - ENCARGOS PATRONAIS - RPPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.05.00', 'CMV - ENCARGOS PATRONAIS - RGPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.06.00', 'CMV - ENCARGOS PATRONAIS - FGTS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.07.00', 'CMV - CONTRIBUICOES SOCIAIS GERAIS', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.08.00', 'CMV - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.09.00', 'CMV - OUTROS ENCARGOS PATRONAIS', 'REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.10.00', 'CMV - BENEFICIOS A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.11.00', 'CMV - BENEFICIOS A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.12.00', 'CMV - BENEFICIOS A PESSOAL - MILITAR', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.13.00', 'CMV - INDENIZACOES E RESTITUICOES TRABALHISTAS', 'REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.14.00', 'CMV - OUTRAS VPD DE PESSOAL E ENCARGOS', 'REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.01.00', 'CMV - REMUNERACAO A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.02.00', 'CMV - REMUNERACAO A PESSOAL -RGPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.03.00', 'CMV - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.04.00', 'CMV - ENCARGOS PATRONAIS - RPPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.05.00', 'CMV - ENCARGOS PATRONAIS - RGPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.06.00', 'CMV - ENCARGOS PATRONAIS - FGTS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.07.00', 'CMV - CONTRIBUICOES SOCIAIS GERAIS', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.08.00', 'CMV - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.09.00', 'CMV - OUTROS ENCARGOS PATRONAIS', 'REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.10.00', 'CMV - BENEFICIOS A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.11.00', 'CMV - BENEFICIOS A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.12.00', 'CMV - BENEFICIOS A PESSOAL - MILITAR', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.13.00', 'CMV - INDENIZACOES E RESTITUICOES TRABALHISTAS', 'REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.14.00', 'CMV - OUTRAS VPD DE PESSOAL E ENCARGOS', 'REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.01.00', 'CMV - REMUNERACAO A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.02.00', 'CMV - REMUNERACAO A PESSOAL -RGPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.03.00', 'CMV - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.04.00', 'CMV - ENCARGOS PATRONAIS - RPPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.05.00', 'CMV - ENCARGOS PATRONAIS - RGPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.06.00', 'CMV - ENCARGOS PATRONAIS - FGTS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.07.00', 'CMV - CONTRIBUICOES SOCIAIS GERAIS', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.08.00', 'CMV - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.09.00', 'CMV - OUTROS ENCARGOS PATRONAIS', 'REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.10.00', 'CMV - BENEFICIOS A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.11.00', 'CMV - BENEFICIOS A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.12.00', 'CMV - BENEFICIOS A PESSOAL - MILITAR', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.13.00', 'CMV - INDENIZACOES E RESTITUICOES TRABALHISTAS', 'REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.14.00', 'CMV - OUTRAS VPD DE PESSOAL E ENCARGOS', 'REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.01.00', 'CMV - REMUNERACAO A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.02.00', 'CMV - REMUNERACAO A PESSOAL -RGPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.03.00', 'CMV - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.04.00', 'CMV - ENCARGOS PATRONAIS - RPPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.05.00', 'CMV - ENCARGOS PATRONAIS - RGPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.06.00', 'CMV - ENCARGOS PATRONAIS - FGTS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.07.00', 'CMV - CONTRIBUICOES SOCIAIS GERAIS', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.08.00', 'CMV - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.09.00', 'CMV - OUTROS ENCARGOS PATRONAIS', 'REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.10.00', 'CMV - BENEFICIOS A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.11.00', 'CMV - BENEFICIOS A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.12.00', 'CMV - BENEFICIOS A PESSOAL - MILITAR', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.13.00', 'CMV - INDENIZACOES E RESTITUICOES TRABALHISTAS', 'REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.14.00', 'CMV - OUTRAS VPD DE PESSOAL E ENCARGOS', 'REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DAS MERCADORIAS VENDIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.01.00', 'CPV - REMUNERACAO A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.02.00', 'CPV - REMUNERACAO A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.03.00', 'CPV - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.04.00', 'CPV - ENCARGOS PATRONAIS - RPPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.05.00', 'CPV - ENCARGOS PATRONAIS - RGPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.06.00', 'CPV - ENCARGOS PATRONAIS - FGTS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.07.00', 'CPV - CONTRIBUICOES SOCIAIS GERAIS', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.08.00', 'CPV - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.09.00', 'CPV - OUTROS ENCARGOS PATRONAIS', 'REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.10.00', 'CPV - BENEFICIOS A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.11.00', 'CPV - BENEFICIOS A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.12.00', 'CPV - BENEFICIOS A PESSOAL - MILITAR', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.13.00', 'CPV - INDENIZACOES E RESTITUICOES TRABALHISTAS', 'REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.14.00', 'CPV - OUTRAS VPD DE PESSOAL E ENCARGOS', 'REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.01.00', 'CPV - REMUNERACAO A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.02.00', 'CPV - REMUNERACAO A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.03.00', 'CPV - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.04.00', 'CPV - ENCARGOS PATRONAIS - RPPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.05.00', 'CPV - ENCARGOS PATRONAIS - RGPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.06.00', 'CPV - ENCARGOS PATRONAIS - FGTS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.07.00', 'CPV - CONTRIBUICOES SOCIAIS GERAIS', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.08.00', 'CPV - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.09.00', 'CPV - OUTROS ENCARGOS PATRONAIS', 'REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.10.00', 'CPV - BENEFICIOS A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.11.00', 'CPV - BENEFICIOS A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.12.00', 'CPV - BENEFICIOS A PESSOAL - MILITAR', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.13.00', 'CPV - INDENIZACOES E RESTITUICOES TRABALHISTAS', 'REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.14.00', 'CPV - OUTRAS VPD DE PESSOAL E ENCARGOS', 'REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.01.00', 'CPV - REMUNERACAO A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.02.00', 'CPV - REMUNERACAO A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.03.00', 'CPV - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.04.00', 'CPV - ENCARGOS PATRONAIS - RPPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.05.00', 'CPV - ENCARGOS PATRONAIS - RGPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.06.00', 'CPV - ENCARGOS PATRONAIS - FGTS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.07.00', 'CPV - CONTRIBUICOES SOCIAIS GERAIS', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.08.00', 'CPV - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.09.00', 'CPV - OUTROS ENCARGOS PATRONAIS', 'REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.10.00', 'CPV - BENEFICIOS A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.11.00', 'CPV - BENEFICIOS A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.12.00', 'CPV - BENEFICIOS A PESSOAL - MILITAR', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.13.00', 'CPV - INDENIZACOES E RESTITUICOES TRABALHISTAS', 'REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.14.00', 'CPV - OUTRAS VPD DE PESSOAL E ENCARGOS', 'REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.01.00', 'CPV - REMUNERACAO A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.02.00', 'CPV - REMUNERACAO A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.03.00', 'CPV - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.04.00', 'CPV - ENCARGOS PATRONAIS - RPPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.05.00', 'CPV - ENCARGOS PATRONAIS - RGPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.06.00', 'CPV - ENCARGOS PATRONAIS - FGTS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.07.00', 'CPV - CONTRIBUICOES SOCIAIS GERAIS', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.08.00', 'CPV - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.09.00', 'CPV - OUTROS ENCARGOS PATRONAIS', 'REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.10.00', 'CPV - BENEFICIOS A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.11.00', 'CPV - BENEFICIOS A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.12.00', 'CPV - BENEFICIOS A PESSOAL - MILITAR', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.13.00', 'CPV - INDENIZACOES E RESTITUICOES TRABALHISTAS', 'REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.14.00', 'CPV - OUTRAS VPD DE PESSOAL E ENCARGOS', 'REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DOS PRODUTOS VENDIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.01.00', 'CSP - REMUNERACAO A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.02.00', 'CSP - REMUNERACAO A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.03.00', 'CSP - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.04.00', 'CSP - ENCARGOS PATRONAIS - RPPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.05.00', 'CSP - ENCARGOS PATRONAIS - RGPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.06.00', 'CSP - ENCARGOS PATRONAIS - FGTS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.07.00', 'CSP - CONTRIBUICOES SOCIAIS GERAIS', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.08.00', 'CSP - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.09.00', 'CSP - OUTROS ENCARGOS PATRONAIS', 'REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.10.00', 'CSP - BENEFICIOS A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.11.00', 'CSP - BENEFICIOS A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.12.00', 'CSP - BENEFICIOS A PESSOAL - MILITAR', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.13.00', 'CSP - INDENIZACOES E RESTITUICOES TRABALHISTAS', 'REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.14.00', 'CSP - OUTRAS VPD DE PESSOAL E ENCARGOS', 'REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.01.00', 'CSP - REMUNERACAO A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.02.00', 'CSP - REMUNERACAO A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.03.00', 'CSP - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.04.00', 'CSP - ENCARGOS PATRONAIS - RPPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.05.00', 'CSP - ENCARGOS PATRONAIS - RGPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.06.00', 'CSP - ENCARGOS PATRONAIS - FGTS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.07.00', 'CSP - CONTRIBUICOES SOCIAIS GERAIS', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.08.00', 'CSP - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.09.00', 'CSP - OUTROS ENCARGOS PATRONAIS', 'REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.10.00', 'CSP - BENEFICIOS A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.11.00', 'CSP - BENEFICIOS A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.12.00', 'CSP - BENEFICIOS A PESSOAL - MILITAR', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.13.00', 'CSP - INDENIZACOES E RESTITUICOES TRABALHISTAS', 'REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.14.00', 'CSP - OUTRAS VPD DE PESSOAL E ENCARGOS', 'REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.01.00', 'CSP - REMUNERACAO A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.02.00', 'CSP - REMUNERACAO A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.03.00', 'CSP - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.04.00', 'CSP - ENCARGOS PATRONAIS - RPPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.05.00', 'CSP - ENCARGOS PATRONAIS - RGPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.06.00', 'CSP - ENCARGOS PATRONAIS - FGTS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.07.00', 'CSP - CONTRIBUICOES SOCIAIS GERAIS', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.08.00', 'CSP - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.09.00', 'CSP - OUTROS ENCARGOS PATRONAIS', 'REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.10.00', 'CSP - BENEFICIOS A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.11.00', 'CSP - BENEFICIOS A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.12.00', 'CSP - BENEFICIOS A PESSOAL - MILITAR', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.13.00', 'CSP - INDENIZACOES E RESTITUICOES TRABALHISTAS', 'REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.14.00', 'CSP - OUTRAS VPD DE PESSOAL E ENCARGOS', 'REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.01.00', 'CSP - REMUNERACAO A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.02.00', 'CSP - REMUNERACAO A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.03.00', 'CSP - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES', 'REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.04.00', 'CSP - ENCARGOS PATRONAIS - RPPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.05.00', 'CSP - ENCARGOS PATRONAIS - RGPS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.06.00', 'CSP - ENCARGOS PATRONAIS - FGTS', 'REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.07.00', 'CSP - CONTRIBUICOES SOCIAIS GERAIS', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.08.00', 'CSP - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA', 'REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.09.00', 'CSP - OUTROS ENCARGOS PATRONAIS', 'REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.10.00', 'CSP - BENEFICIOS A PESSOAL - RPPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.11.00', 'CSP - BENEFICIOS A PESSOAL - RGPS', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.12.00', 'CSP - BENEFICIOS A PESSOAL - MILITAR', 'REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.13.00', 'CSP - INDENIZACOES E RESTITUICOES TRABALHISTAS', 'REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.14.00', 'CSP - OUTRAS VPD DE PESSOAL E ENCARGOS', 'REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DE SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.1.01.00', 'INDENIZACOES E RESTITUICOES TRAB. ATIVO CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE A INDENIZACOES E RESTITUICOES TRABALHISTAS DO PESSOAL ATIVO CIVIL, INCLUSIVE AS DESPESAS COM PROGRAMA DE DESLIGAMENTO VOLUNTARIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.1.02.00', 'INDENIZACOES E RESTITUICOES TRAB. ATIVO MIL.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE A INDENIZACOES E RESTITUCOES TRABALHISTAS DO PESSOAL ATIVO MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.1.03.00', 'INDENIZACOES E RESTITUICOES TRAB. INAT. CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE A INDENIZACOES E RESTITUICOES TRABALHISTAS DO PESSOAL INATIVO CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.1.04.00', 'INDENIZACOES E RESTITUICOES TRAB. INAT. MIL.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESDE DESPESAS REFERENTE A INDENIZACOES E RESTITUICOES TRABALHISTAS DO PESSOAL INATIVO MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.1.05.00', 'INDENIZACOES E RESTITUICOES TRAB.-PENS. MIL.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESDE DESPESAS REFERENTE A INDENIZACOES E RESTITUICOES TRABALHISTAS DO PESSOAL PENSIONISTA MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.1.06.00', 'INDENIZACOES E RESTITUICOES TRAB.-PENS. CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESDE DESPESAS REFERENTE A INDENIZACOES E RESTITUICOES TRABALHISTAS DO PESSOAL PENSIONISTA CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.1.07.00', 'INDENIZACAO § 2º ART.12 LEI 8.745/93', 'REGISTRA AS DESPESAS COM INDENIZACAO REFERENTE A EXTINCAO DE CONTRATO,POR INICIATIVA DO ORGAO OU ENTIDADE CONTRATANTE, DE PESSOAL TECNICO CONTRATADO POR TEMPO DETERMINADO NOS TERMOS DA LEI 8.745/93.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.1.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.1.99.00', 'DIVERSAS INDENIZACOES TRABALHISTAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE INDENIZACOES TRABALHISTA QUE NAO SE PROCESSARAM NA EPOCA PROPRIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.2.1.00.00', 'PESSOAL REQUISITADO DE OUTROS ORGAOS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PESSOAL REQUISITADO DE OUTROS ORGAOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.9.1.01.00', 'AUXILIO A PARTICIPANTES DE CURSO DE FORMACAO', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM A CONCESSAO DE AUXILIO FINANCEIRO A CANDIDATOS PARTICIPANTES DE CURSO DE FORMACAO PARA O EXERCICIO DE CARGO DECORRENTE DE CONCURSO PUBLICO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.9.1.02.00', 'AUXILIO DE AVALIACAO EDUCACIONAL - AAE', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM A CONCESSAO DO AUXILIO DE AVALIACAO EDUCACIONAL - AAE, DEVIDO AO SERVIDOR OU COLOBORADOR EVENTUAL QUE,EM DECORRENCIA DO EXERCICIO DA DOCENCIA OU PESQUISA NO ENSINO BASICO OU SUPERIOR,PUBLICO OU PRIVADO,PARTICIPE,EM CARATER EVENTUAL,DE PROCESSO DE AVALIACAO EDUCACIONAL DE INSTITUICOES,CURSOS,PROJETOS OU DESEMPENHO DE ESTUDANTES A SER EXECUTADO PELO INSTITUTO NACIONAL DE ESTUDOS E PESQUISAS EDUCACIONAIS ANISIO TEIXEIRA-INEP,PELA COORDENACAO DE APERFEICOAMENTO DE PESSOAL DE NIVEL SUPERIOR-CAPES E PELO FUNDO NACIONAL DE DESENVOLVIMENTO DA EDUCACAO-FNDE(ART.1º DA LEI 11.507,DE 20JUL2007).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.9.1.03.00', 'BOLSA-FORMACAO PRONASCI - MP 416/2008', 'REGISTRA O VALOR DOS RECURSOS DESTINADOS AA QUALIFICACAO PROFISSIONAL DOS INTEGRANTES DAS POLICIAS MILITAR E CIVIL, DO CORPO DE BOMBEIROS, DOS AGENTES PENITENCIARIOS, DOS AGENTES CARCERARIOS E DOS PERITOS, NO AMBITO DO PROGRAMA NACIONAL DE SEGURANCA PUBLICA COM CIDADANIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.9.2.00.00', 'OUTRAS VPD DE PESSOAL E ENCARGOS - INTRA OFSS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL E ENCARGOS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.9.4.00.00', 'OUTRAS VPD DE PESSOAL E ENCARGOS - INTER OFSS - ESTADO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL E ENCARGOS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.9.5.00.00', 'OUTRAS VPD DE PESSOAL E ENCARGOS - INTER OFSS - MUNICIPIO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL E ENCARGOS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.01.00', 'PROVENTOS - PESSOAL CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PROVENTOS DE APOSENTADORIAS PESSOAL CIVIL REGIDOS PELO RPPS APROVADA PELO TRIBUNAL DE CONTAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.03.00', 'APOSENTADORIAS PENDENTES DE APROVACAO - PESSOAL CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM APOSENTADORIAS DE PESSOAL CIVIL CONCEDIDAS, MAS QUE SE ENCONTRAM EM FASE DE TRAMITACAO PARA APROVACAO PELO TRIBUNAL DE CONTAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.04.00', 'PROVENTOS ORIG. DE INCENTIVO/ADIC.A QUALIFICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INCENTIVO A QUALIFICACAO DE SERVIDORES QUE POSSUIREM EDUCACAO FORMAL SUPERIOR AO EXIGIDO PELOS CARGOS QUE OCUPAM. BASE LEGAL: LEI Nº 11.416/2006, BEM COMO CONHECIMENTOS ADICIONAIS ADQUIRIDOS EM AREA DE INTERESSE DE OUTROS ORGAOS, A SEREM ESTABELECIDOS EM REGULAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.05.00', 'VANTAGEM PESSOAL - LEI 8.216/91', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DOS VALORES RELATIVOS A VANTAGENS PESSOAIS CONCEDIDAS AOS APOSENTADOS CIVIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.06.00', '13 SALARIO - PESSOAL CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE 13 SALARIO - PESSOAL CIVIL - RPPS (APOSENTADORIAS JA APROVADAS PELO TCU).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.07.00', 'GRATIFICACAO TEMPO DE SERVICO - ANUENIO CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM O PAGAMENTO DA GRATIFICACAO DE TEMPO DE SERVICO (ANUENIO) DE SERVIDORES CIVIS - RPPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.09.00', 'PRO-LABORE (LEI 7711/88 ARTIGO 3)', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE PRO-LABORE DE EXITO CONFORME LEI 7.711/88, ARTIGO TERCEIRO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.10.00', 'VANTAGENS INCORPORADAS - PESSOAL CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VANTAGENS INCORPORADAS DE PESSOAL CIVIL, INCLUSIVE A VANTAGEM PECUNIARIA INDIVIDUAL, INSTITUIDA PELA LEI 10698, DE 2/7/2003.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.11.00', 'PROVENTOS ORIGINARIAS DE GRAT.P/EXERC/FUNCOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PROVENTOS ORIGINARIOS DE GRATIFICACOES POR EXERCICIO DE FUNCOES E CARGOS COMISSIONADOS, BEM COMO DA OPCAO PREVISTA EM LEI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.12.00', 'PROVENTOS ORIGINARIAS DE GRAT.P/EXERC. CARGO.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PROVENTOS ORIGINARIOS DE GRATIFICACOES POR EXERCICIO DE CARGOS, TAIS COMO GAJ, ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.13.00', 'INCREMENTO PLANO DE CARGOS E SALARIOS JUDIC.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A DIFERENCA DE REMUNERACAO DOS CARGOS RESULTANTES DA TRANSFORMACAO SOBRE A DOS TRANSFORMADOS PELO PLANO DE CARGOS E SALARIOS DO PODER JUDICIARIO, CONFORME DISPOSTO NO PARAGRAFO 2°, DO ART. 4°, DA LEI 9421/96.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.14.00', 'GRATIFICACAO DE ATIVIDADES EXTERNAS - GAE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES ADQUIRIDAS EM FUNCAO DO EXERCICIO DE ATIVIDADES EXTERNAS, A EXEMPLO DA ATIVIDADE EXERCIDA POR OFICIAIS DE JUSTICA, CONFORME ESTABELECIDO NO ART.16, DA LEI Nº 11.416/06 E ARTIGO 4°, DA PROTARIA STF N° 01, DE 07 DE MARCO DE 2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.15.00', 'GRATIFICACOES ESPECIAIS A APOSENTADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL - RPPS (APOSENTADO).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.16.00', 'COMPLEMENTACAO DE APOSENTADORIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DOS VALORES PERTINENTES AS DESPESAS COM COMPLEMENTACAO DE APOSENTADORIAS DEVIDAS AO PESSOAL CIVIL INATIVOS - RPPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.17.00', 'APOSENTADORIAS ORIGINARIAS DE SUBSIDIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM APOSENTADORIAS ORIGINARIAS DE SUBSIDIOS, APROVADAS OU PENDENTES DE APROVACAO PELO TRIBUNAL DE CONTAS DA UNIAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.18.00', 'ADICIONAL TETO PARLAMENTAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA AJUDA DE CUSTO CONCEDIDA AOS PARLAMENTARES NOS MESES DE FEVEREIRO, JUNHO E DEZEMBRO SOBRE A REMUNERACAO DOS SERVIDORES ATIVOS E INATIVOS DA CAMARA DOS DEPUTADOS E DO SENADO FEDERAL, AMPARADAS POR RESOLUCOES INTERNAS DESSAS CASAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.19.00', 'FERIAS VENCIDAS E PROPORCIONAIS APOSENTADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE FERIAS VENCIDAS E PROPORCIONAIS A APOSENTADOS.(CASO NAO RECEBIDO NO ATO DA APOSENTADORIA SEGUNDO ACORDAO TCU 1646/2003).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.99.00', 'OUTRAS APOSENTADORIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS APOSENTADORIAS NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU VALORES RELATIVOS A INTEGRACAO DE BALANCENTES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.01.00', 'APOSENTADORIA POR INVALIDEZ', 'REGISTRA AS DESPESAS COM APOSENTADORIAS POR INVALIDEZ, DEVIDAS AOS SEGURADOS CONSIDERADOS INCAPAZES PARA EXERCER SUAS ATIVIDADES PROFISSIONAIS E INSUSCEPTIVEIS DE REABILITACAO PARA OUTRAS ATIVIDADES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.02.00', 'APOSENTADORIA POR VELHICE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM APOSENTADORIAS POR VELHICE, DEVIDAS AOS SEGURADOS QUE TENHAM COMPLETADO A IDADE PREVISTA EM LEI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.03.00', 'APOSENTADORIA POR TEMPO DE SERVICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM APOSENTADORIAS POR TEMPO DE SERVICO, DEVIDAS AOS SEGURADOS QUE TENHAM COMPLETADO O TEMPO PREVISTO EM LEI, DE ACORDO COM A SUA CATEGORIA PROFISSIONAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.04.00', 'APOSENTADORIA ESPECIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM APOSENTADORIA ESPECIAL, DEVIDA AO SEGURADO QUE TENHA COMPLETADO O TEMPO PREVISTO EM LEI E QUE TRABALHOU EM SERVICOS CONSIDERADOS PENOSOS, INSALUBRES OU PERIGOSOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.05.00', 'APOSENTADORIA - ECONOMIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM APOSENTADORIAS DE ECONOMIARIOS, DEVIDAS AOS SEGURADOS SUJEITOS AO REGIME DO ANTIGO SASSE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.06.00', 'APOSENTADORIA POR INVALIDEZ - ACIDENTE DE TRABALHO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM APOSENTADORIAS POR INVALIDEZ, DECORRENTES DE ACIDENTES DE TRABALHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.07.00', 'ABONO PROVISORIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ABONO PROVISORIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.08.00', 'APOSENTADORIAS PENDENTES DE APROVACAO - PESSOAL CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM APOSENTADORIAS CONCEDIDAS DE PESSOAL CIVIL REGIDOS PELO RGPS, MAS QUE SE ENCONTRAM EM FASE DE TRAMITACAO PARA APROVACAO PELO TRIBUNAL DE CONTAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.09.00', 'PROVENTOS ORIG. DE INCENTIVO/ADIC.A QUALIFICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INCENTIVO A QUALIFICACAO DE EMPREGADOS QUE POSSUIREM EDUCACAO FORMAL SUPERIOR AO EXIGIDO PELOS CARGOS QUE OCUPAM. BEM COMO CONHECIMENTOS ADICIONAIS ADQUIRIDOS EM AREA DE INTERESSE DE OUTROS ORGAOS, A SEREM ESTABELECIDOS EM REGULAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.10.00', '13 SALARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE 13 SALARIO - PESSOAL CIVIL - RGPS (APOSENTADORIAS JA APROVADAS PELO TCU).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.11.00', 'GRATIFICACAO TEMPO DE SERVICO - ANUENIO CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM O PAGAMENTO DA GRATIFICACAO DE TEMPO DE SERVICO (ANUENIO) DE SERVIDORES CIVIS - RGPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.12.00', 'GRATIFICACOES ESPECIAIS A APOSENTADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL - RGPS (APOSENTADO).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.13.00', 'COMPLEMENTACAO DE APOSENTADORIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DOS VALORES PERTINENTES AS DESPESAS COM COMPLEMENTACAO DE APOSENTADORIAS DEVIDAS AO PESSOAL CIVIL INATIVOS - RGPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.14.00', 'FERIAS VENCIDAS E PROPORCIONAIS APOSENTADOS', 'REGISTRA AS DESPESAS COM APOSENTADORIAS POR INVALIDEZ, DEVIDAS AOS SEGURADOS CONSIDERADOS INCAPAZES PARA EXERCER SUAS ATIVIDADES PROFISSIONAIS E INSUSCEPTIVEIS DE REABILITACAO PARA OUTRAS ATIVIDADES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.15.00', 'INDENIZACAO A ANISTIADO POLITICO', 'REGISTRA O VALOR DAS DESPESAS REALIZADAS A TITULO DE REPARACAO ECONOMICA, DE CARATER INDENIZATORIO, CONFORME ESTABELECEM O ART.8º DO ATO DAS DISPOSICOES CONSTITUCIONAIS TRANSITORIAS E AS LEIS QUE A REGULAMENTAM (LEIS 10559/2002 E 11354/2006).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.99.00', 'OUTRAS APOSENTADORIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS APOSENTADORIAS NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU VALORES RELATIVOS A INTEGRACAO DE BALANCENTES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.01.00', 'PROVENTOS - PESSOAL MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PROVENTOS DE PESSOAL MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.02.00', 'GRATIFICACAO TEMPO DE SERVICO-ANUENIO MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM O PAGAMENTO DA GRATIFICACAO DE TEMPO DE SERVICO (ANUENIO) DE MILITARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.03.00', 'COMPENSACAO PECUNIARIA (LEI 7.963/89)', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM COMPENSACOES PECUNIARIAS DEVIDAS EM VIRTUDE DE NORMATIVO LEGAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.04.00', 'AJUDA DE CUSTO (TRANSF. P/ RESERVA REM.)', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AJUDA DE CUSTO DEVIDAS A PESSOAL MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.05.00', 'ADICIONAL MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ADICIONAL MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.06.00', 'COMPL. APOSENTADORIA - PESSOAL MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM COMPLEMENTACAO DE APOSENTADORIA DE PESSOAL MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.07.00', 'VANTAGENS INCORPORADAS - PESSOAL MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VANTAGENS INCORPORADAS DE PESSOAL MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.08.00', 'AUXILIO-INVALIDEZ - PESSOAL MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXILIO-INVALIDEZ DO PESSOAL MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.09.00', '13 SALARIO - PESSOAL MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE 13 SALARIO - PESSOAL MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.10.00', 'VANTAGEM PECUNIARIA ESPECIAL - VPE', 'REGISTRA O VALOR DAS DESPESAS REALIZADAS COM VANTAGEM PECUNIARIA ESPECIAL - VPE (BASE LEGAL: LEI N 11.134/05, ART. 1° - PARA INATIVOS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.99.00', 'OUTRAS REFORMAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS REFORMAS NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.9.1.00.00', 'OUTRAS APOSENTADORIAS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS APOSENTADORIAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.01.00', 'PENSOES CIVIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PENSOES ORIGINARIAS DE PESSOAL CIVIL - RPPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.02.00', '13 SALARIO - PESSOAL CIVIL - PENSIONISTAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE 13 SALARIO - PESSOAL MILITAR - PENSIONISTAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.03.00', 'PENSOES ESPECIAIS - PESSOAL CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES DEVIDAS EM FUNCAO DE LEIS ESPECIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.04.00', 'LICENCA-PREMIO PARA PENSIONISTA CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCAO-PREMIO PARA PENSIONISTA CIVIL - RPPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.05.00', 'PENSOES ORIG. DE INCENTIVO/ADIC.A QUALIFICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE PENSOES COM INCENTIVO A QUALIFICACAO DE SERVIDORES QUE POSSUIREM EDUCACAO FORMAL SUPERIOR AO EXIGIDO PELOS CARGOS QUE OCUPAM BASE LEGAL: LEI Nº 11.416/2006, BEM COMO CONHECIMENTOS ADICIONAIS ADQUIRIDOS EM AREA DE INTERESSE DE OUTROS ORGAOS, A SEREM ESTABELECIDOS EM REGULAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.06.00', 'PENSOES ORIGINARIAS DE GRATIF.P/EXERC. FUNCAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PENSOES ORIGINARIAS DE GRATIFICACAO POR EXERCICIO DE FUNCOES E CARGOS COMISSIONADOS, BEM COMO DA OPCAO PREVISTA EM LEI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.07.00', 'PENSOES ORIGINARIAS DE GRATIF.P/EXERC.DE CARG', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PENSOES ORIGINARIAS DE GRATIFICACAO POR EXERCICIO DE CARGOS, TAIS COMO GAJ, ETC', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.08.00', 'VANTAGENS INCORPORADAS - PENSIONISTAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM A VANTAGEM PECUNIARIA INDIVIDUAL (INCLUSIVE DA LEI 10698, DE 02/07/03).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.09.00', 'ABONO PROVISORIO - PENSIONISTAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO ABONO PROVISORIO PARA PENSIONISTAS - RPPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.10.00', 'INCREMENTO PLANO DE CARGOS E SALARIOS JUDIC.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A DIFERENCA DE REMUNERACAO DOS CARGOS RESULTANTES DA TRANSFORMACAO SOBRE A DOS TRANSFORMADOS PELO PLANO DE CARGOS E SALARIOS DO PODER JUDICIARIO, CONFORME DISPOSTO NO PARAGRAFO 2°, DO ARTIGO 4°, DA LEI 9421/96.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.11.00', 'GRATIFICACAO DE ATIVIDADES EXTERNAS - GAE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES ADQUIRIDAS EM FUNCAO DO EXERCICIO DE ATIVIDADES EXTERNAS, A EXEMPLO DA ATIVIDADE EXERCIDA POR OFICIAIS DE JUSTICA, CONFORME ESTABELECIDO NO ARTIGO 16, DA LEI Nº 11.416/06 E ARTIGO 4°, DA PROTARIA STF N° 01, DE 07 DE MARCO DE 2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.12.00', 'GRATIFICACOES ESPECIAIS A PENSIONISTA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL (PENSONISTAS) - RPPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.13.00', 'COMPLEMENTACAO DE PENSOES - PESSOAL CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE COMPLEMENTACAO DE PENSOES DE PESSOAL MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.14.00', 'PENSOES ORIGINARIAS DE SUBSIDIOS', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PENSOES ORIGINARIAS DE SUBSIDIOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.15.00', 'ADICIONAL TETO PARLAMENTAR', 'REGISTRA AS DESPESAS DECORRENTES DA AJUDA DE CUSTO CONCEDIDA AOS PARLAMENTARES NOS MESES DE FEVEREIRO, JUNHO E DEZEMBRO SOBRE A REMUNERACAO DOS SERVIDORES ATIVOS E INATIVOS DA CAMARA DOS DEPUTADOS E DO SENADO FEDERAL, AMPARADAS POR RESOLUCOES INTERNAS DESSAS CASAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.99.00', 'OUTRAS PENSOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS PENSOES NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.01.00', 'PENSOES CIVIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PENSOES ORIGINARIAS DE PESSOAL CIVIL - RGPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.02.00', '13 SALARIO - PENSIONISTAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE 13 SALARIO - PESSOAL CIVIL - PENSIONISTAS - RGPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.03.00', 'PENSOES ESPECIAIS - PESSOAL CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES DEVIDAS EM FUNCAO DE LEIS ESPECIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.04.00', 'PENSOES ORIG. DE INCENTIVO/ADIC.A QUALIFICACAO', 'DESTINADA AO REGISTRO DAS PENSOES COM INCENTIVO A QUALIFICACAO DE SERVIDORES QUE POSSUIREM EDUCACAO FORMAL SUPERIOR AO EXIGIDO PELOS CARGOS QUE OCUPAM. BASE LEGAL: LEI Nº 11.416/2006, BEM COMO CONHECIMENTOS ADICIONAIS ADQUIRIDOS EM AREA DE INTERESSE DE OUTROS ORGAOS, A SEREM ESTABELECIDOS EM REGULAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.05.00', 'VANTAGENS INCORPORADAS - PENSIONISTAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM A VANTAGEM PECUNIARIA INDIVIDUAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.06.00', 'ABONO PROVISORIO - PENSIONISTAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO ABONO PROVISORIO PARA PENSIONISTAS - RGPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.07.00', 'GRATIFICACOES ESPECIAIS A PENSIONISTA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL (PENSONISTAS) - RGPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.08.00', 'COMPLEMENTACAO DE PENSOES - PESSOAL CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DOS VALORES RELATIVOS AS COMPLEMENTACOES DE PENSOES PAGAS A PENSIONISTAS DE EMPREGADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.09.00', 'PENSOES A ANISTIADOS POLITICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES DEVIDAS A ANISTIADOS POLITICOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.10.00', 'INDENIZACAO A ANISTIADO POLITICO', 'REGISTRA O VALOR DAS DESPESAS REALIZADAS A TITULO DE REPARACAO ECONOMICA, DE CARATER INDENIZATORIO, CONFORME ESTABELECEM O ART.8º DO ATODAS DISPOSICOES CONSTITUCIONAIS TRANSITORIAS E AS LEIS QUE A REGULAMENTAM (LEIS 10559/2002 E 11354/2006).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.11.00', 'PENSOES INDENIZATORIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES DEVIDAS A ANISTIADOS POLITICOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.12.00', 'PENSOES ACIDENTARIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES, DEVIDAS AOS DEPENDENTES, POR MORTE DO SEGURADO, QUANDO A APOSENTADORIA OU MORTE FOR DECORRENTE DE ACIDENTE DE TRABALHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.13.00', 'PENSOES VITALICIAS DA SINDROME DA TALIDOMIDA', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES VITALICIAS, DEVIDAS AOS DEPENDENTES DE SEGURADOS, POR MORTE DECORRENTE DA SINDROME DA TALIDOMIDA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.14.00', 'PENSOES VITALICIAS DE SERINGUEIRO', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES VITALICIAS DEVIDAS AOS DEPENDENTES DE SERINGUEIROS, POR MOTIVO DE MORTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.15.00', 'PENSOES ESPECIAIS DAS VITIMAS DA HEMODIALISE', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES ESPECIAIS, DEVIDAS AOS DEPENDENTES DE SEGURADOS, POR MORTE DECORRENTE DAS VITIMAS FATAIS DE HEPATITE TOXICA, POR CONTAMINACAO EM PROCESSO DE HEMODIALISE NO INSTITUTO DE DOENCAS RENAIS, COM SEDE NA CIDADE DE CARUARU NO ESTADO DE PERNAMBUCO, CONFORME DISPOE A LEI Nº 9.422, DE 24 DE DEZEMBRO DE 1996.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.16.00', 'PENSOES ESPECIAIS DAS VITIMAS DA HANSENIASE', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSAO ESPECIAL, MENSAL, VITALICIA E INTRANSFERIVEL, AS PESSOAS ATINGIDAS PELA HASENIASE E QUE FORAM SUBMETIDAS A ISOLAMENTO E INTERNACAO COMPULSORIOS EM HOSPITAIS-COLONIA, ATE 31/12/1986, CONFORME DISPOE A LEI Nº 11.520, DE 18/09/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.99.00', 'OUTRAS PENSOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS PENSOES NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.3.1.01.00', 'PENSOES MILITARES', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES DE ORIGEM MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.3.1.02.00', '13 SALARIO - PESSOAL MILITAR - PENSIONISTAS', 'REGISTRA O VALOR DAS DESPESAS REALIZADAS A TITULO DE 13 SALARIO - PESSOAL MILITAR..', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.3.1.03.00', 'COMPL. PENSOES - PESSOAL MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AS COMPLEMENTACOES DE PENSOES PAGAS A PENSIONISTAS DE MILITARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.3.1.04.00', 'PENSOES ESPECIAIS - PESSOAL MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES DEVIDAS EM FUNCAO DE LEIS ESPECIAIS A MILITARES, TAIS COMO: LEIS 4.242/63, 6.592/78, 7.424/85 E 8.059/90 QUE TRATAM DE PENSIONISTAS DA FEB.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.3.1.05.00', 'PENSOES ORIGINARIAS DE GRATIF.P/EXERC.DE CARG', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES ORIGINARIAS DE GRATIFICACAO POR EXERCICIO DE FUNCOES E CARGOS COMISSIONADOS, BEM COMO DA OPCAO PREVISTA EM LEI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.3.1.06.00', 'ABONO PROVISORIO - PENSIONISTAS', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS A TITULO ABONO PROVISORIO PARA PENSIONISTAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.3.1.07.00', 'VANTAGENS INCORPORADAS - PESSOAL MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM VANTAGENS INCORPORADAS DE PESSOAL MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.3.1.08.00', 'VANTAGEM PECUNIARIA ESPECIAL - VPE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM VANTAGEM PECUNIARIA ESPECIAL - VPE', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.3.1.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.3.1.99.00', 'OUTRAS PENSOES - MILITARES', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS PENSOES PARA SERVIDORES MILITARES NAO CLSSIFICAVEIS NOS SUBITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.9.1.00.00', 'OUTRAS PENSOES - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS PENSOES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.1.1.01.00', 'BENEFICIOS DE PRESTACAO CONTINUADA AO IDOSO', 'REGISTRA O BENEFICIO DE PRESTACAO CONTINUADA QUE GARANTE 1 (UM) SALARIO MINIMO MENSAL AO IDOSO , QUE COMPROVE NAO POSSUIR MEIOS DE PROVER A PROPRIA MANUTENCAO E NEM DE TE - LA PROVIDA POR SUA FAMILIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.1.1.02.00', 'RENDA MENSAL VITALICIA - IDADE', 'REGISTRA AS DESPESAS COM RENDA MENSAL VITALICIA DE IDOSOS, DEVIDA A SEGURADOS MAIORES DE 70 ANOS DE IDADE, NA FORMA DA LEI 6.179/74.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.2.1.01.00', 'BENEFICIOS DE PRESTACAO CONTINUADA AO PORTADOR DE DEFICIENCIA', 'REGISTRA O BENEFICIO DE PRESTACAO CONTINUADA QUE GARANTE 1 (UM) SALARIO MINIMO MENSAL A PESSOA PORTADORA DE DEFICIENCIA, QUE COMPROVE NAO POSSUIR MEIOS DE PROVER A PROPRIA MANUTENCAO E NEM DE TE - LA PROVIDA POR SUA FAMILIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.2.1.02.00', 'RENDA MENSAL VITALICIA - INVALIDEZ', 'REGISTRA AS VPD COM RENDA MENSAL VITALICIA DE INVALIDOS, DEVIDA AOS SEGURADOS CONSIDERADOS DEFINITIVAMENTE INCAPAZES PARA O TRABALHO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.9.1.00.00', 'OUTROS BENEFICIOS DE PRESTACAO CONTINUADA - CONSOLIDACAO', 'REGISTRA OUTROS BENEFICIOS DE PRESTACAO CONTINUADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.1.1.00.00', 'AUXILIO POR NATALIDADE -CONSOLIDACAO', 'REGISTRA O BENEFICIO EVENTUAL QUE VISA O PAGAMENTO DE AUXILIO POR NATALIDADE AS FAMILIAS CUJA RENDA MENSAL PER CAPITA SEJA INFERIOR A 1/4 (UM QUARTO) DO SALARIO MINIMO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.2.1.00.00', 'AUXILIO POR MORTE - CONSOLIDACAO', 'REGISTRA O BENEFICIO EVENTUAL QUE VISA O PAGAMENTO DE AUXILIO POR MORTE AS FAMILIAS CUJA RENDA MENSAL PER CAPITA SEJA INFERIOR A 1/4 (UM QUARTO) DO SALARIO MINIMO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.3.1.00.00', 'BENEFICIOS EVENTUAIS POR SITUACOES DE VULNERABILIDADE TEMPORARIA CONSOLIDACAO', 'REGISTRA AS PROVISOES SUPLEMENTARES E PROVISORIAS, PRESTADAS AOS CIDADAOS E AS FAMILIAS EM VIRTUDE DE SITUACOES DE VULNERABILIDADE TEMPORARIA, COM PRIORIDADE PARA A CRIANCA, A FAMILIA, O IDOSO, A PESSOA PORTADORA DE DEFICIENCIA, A GESTANTE E A NUTRIZ. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.4.1.01.00', 'BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA BAIXAS E ALTAS TEMPERATURAS', 'REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA ,ADVINDA DE BAIXAS OU ALTAS TEMPERATURAS, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.4.1.02.00', 'BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA TEMPESTADES', 'REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA ,ADVINDA DE TEMPESTADE, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.4.1.03.00', 'BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA ENCHENTES', 'REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA ,ADVINDA DE ENCHENTE, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.4.1.04.00', 'BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA INVERSOES TERMICAS', 'REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA ,ADVINDA DE INVERSOES TERMICAS, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.4.1.05.00', 'BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA DESABAMENTOS', 'REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA ,ADVINDA DE DESABAMENTOS, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.4.1.06.00', 'BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA DESABAMENTOS', 'REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA ,ADVINDA DE INCENDIOS, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.4.1.07.00', 'BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA EPIDEMIAS', 'REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA ,ADVINDA DE EPIDEMIAS, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.4.1.99.00', 'BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA OUTRAS', 'REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE OUTROS TIPOS CALAMIDADE PUBLICA , DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.9.1.00.00', 'OUTROS BENEFICIOS EVENTUAIS - CONSOLIDACAO', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE OUTROS BENEFICIOS EVENTUAIS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.5.0.1.01.00', 'BOLSA FAMILIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O PROGRAMA BOLSA FAMILIA (PBF), QUE E UM PROGRAMA DE TRANSFERENCIA DIRETA DE RENDA COM CONDICIONALIDADES, QUE BENEFICIA FAMILIAS EM SITUACAO DE POBREZA E EXTREMA POBREZA, DE ACORDO COM A LEI 10.836, DE 09 DE JANEIRO DE 2004 E O DECRETO Nº 5.209, DE 17 DE SETEMBRO DE 2004.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.5.0.1.02.00', 'PRO JOVEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO FINANCEIRO DADO AOS BENEFICIARIOS DO PROGRAMA NACIONAL DE INCLUSAO DE JOVENS PRO JOVEM,QUE E DESTINADO A JOVENS DE 15 (QUINZE) A 29 (VINTE E NOVE) ANOS, COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL, SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. ESTE AUXILIO FINANCEIRO SERA CONCEDIDO NAS MODALIDADES: A) PRO JOVEM URBANO; B) PRO JOVEM CAMPO SABERES DA TERRA; E C) PRO JOVEM TRABALHADOR', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.5.0.1.03.00', 'PROGRAMA DE ERRADICACAO DO TRABALHO INFANTIL (PETI)', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TRANSFERENCIA DE RENDA DO PROGRAMA DE ERRADICACAO DO TRABALHO INFANTIL PETI, QUE TEM COMO OBJETIVO CONTRIBUIR PARA A ERRADICACAO DE TODAS AS FORMAS DE TRABALHO INFANTIL NO PAIS, ATENDENDO FAMILIAS CUJAS CRIANCAS E ADOLESCENTES COM IDADE INFERIOR A 16 ANOS FORAM RETIRADAS DAS DIVERSAS SITUACOES DE TRABALHO. O PROGRAMA ESTA INSERIDO EM UM PROCESSO DE RESGATE DA CIDADANIA E PROMOCAO DE DIREITOS DE SEUS USUARIOS, BEM COMO DE INCLUSAO SOCIAL DE SUAS FAMILIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.5.0.1.99.00', 'OUTRAS POLITICAS PUBLICAS DE TRANSFERENCIA DE RENDA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS POLITICAS PUBLICAS DE TRANSFERENCIA DE RENDA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.9.0.00.00', 'OUTROS BENEFICIOS EVENTUAIS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE OUTROS BENEFICIOS EVENTUAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.01.00', 'AUXILIO FUNERAL ATIVO CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO DEVIDO A FAMILIA DO SERVIDOR ATIVO CIVIL FALECIDO, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS DESPESAS COM FUNERAL DO SERVIDOR. TAMBEM SERA DEVIDO AUXILIO FUNERAL, EM CASO DE FALECIMENTO DE SERVIDOR EM SERVICO FORA DO LOCAL DE TRABALHO, INCLUSIVE NO EXTERIOR E AS DESPESAS DE TRANSPORTE DO CORPO (TRASLADO) CORRERAO A CONTA DOS RECURSOS DA UNIAO, AUTARQUIA OU FUNDACAO PUBLICA (ART. 228, LEI 8112/90)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.02.00', 'AUXILIO FUNERAL INATIVO CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR INATIVO CIVIL, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO INATIVO CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.03.00', 'AUXILIO NATALIDADE ATIVO CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE-ATIVO CIVIL, DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.04.00', 'AUXILIO NATALIDADE INATIVO CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE INATIVO CIVIL,DEVIDO, A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO E NASCIMENTO DE FILHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.05.00', 'AUXILIO RECLUSAO ATIVO CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO CIVIL, AFASTADO POR MOTIVO DE PRISAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.06.00', 'AUXILIO RECLUSAO INATIVO CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR INATIVO CIVIL, AFASTADO POR MOTIVO DE PRISAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.07.00', 'AUXILIO FUNERAL PENSIONISTA CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR PENSIONISTA, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO PENSIONISTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.08.00', 'AUXILIO RECLUSAO PENSIONISTA CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR PENSIONISTA, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO PENSIONISTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.09.00', 'AUXILIO NATALIDADE PENSIONISTA CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE A PENSIONISTA CIVIL, DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.10.00', 'AUXILIO-DOENCA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-DOENCA, DEVIDO AO SEGURADO QUE FICAR INCAPACITADO PARA O TRABALHO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.11.00', 'SALARIO MATERNIDADE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-MATERNIDADE, DEVIDO A SEGURADA GESTANTE, NA FORMA DA LEI 6.136/74, DURANTE O PERIODO DE LICENCA GESTANTE PREVISTO EM LEI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.12.01', 'SALARIO FAMILIA - ATIVO PESSOAL CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO FAMILIA - ATIVO PESSOAL CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.12.02', 'SALARIO FAMILIA-INATIVO PESSOAL CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA DEVIDOS A INATIVOS PESSOAL CIVIL', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.12.03', 'SALARIO FAMILIA-PENSIONISTA PESSOAL CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA DEVIDO A PENSIONISTA PESSOAL CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.01.00', 'AUXILIO RECLUSAO ATIVO CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO CIVIL, AFASTADO POR MOTIVO DE PRISAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.02.00', 'AUXILIO RECLUSAO INATIVO CIVIL', 'REGISTRA O VALOR DAS DESPESAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR INATIVO CIVIL, AFASTADO POR MOTIVO DE PRISAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.03.00', 'AUXILIO RECLUSAO PENSIONISTA CIVIL', 'REGISTRA O VALOR DAS DESPESAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR PENSIONISTA CIVIL AFASTADO POR MOTIVO DE PRISAO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.04.00', 'AUXILIO DOENCA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AUXILIO-DOENCA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.05.00', 'AUXILIO ACIDENTE', 'REGISTRA AS DESPESAS COM AUXILIO-ACIDENTE PREVIDENCIARIO CONCEDIDO, COMO INDENIZACAO, AO SEGURADO QUANDO APOS A CONSOLIDACAO DAS LESOES DECORRENTES DE ACIDENTES DE QUALQUER NATUREZA RESULTAR SEQUELAS QUE IMPLIQUEM REDUCAO DA CAPACIDADE FUNCIONAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.06.00', 'SALARIO MATERNIDADE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-MATERNIDADE, DEVIDO A SEGURADA GESTANTE, NA FORMA DA LEI 6.136/74, DURANTE O PERIODO DE LICENCA GESTANTE PREVISTO EM LEI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.07.00', 'PECULIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PECULIO, DEVIDO AOS SEGURADOS APOSENTADOS FILIADOS A PREVIDENCIA E A SEGURADOS FILIADOS A PREVIDENCIA, COM MAIS DE 60 ANOS DE IDADE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.08.00', 'ABONO DE PERMANENCIA DE SERVICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ABONO DE PERMANENCIA EM SERVICO, DEVIDO AOS SEGURADOS QUE PERMANECEM EM ATIVIDADE APOS COMPLETADO O PERIODO DE CARENCIA MINIMO PARA O REQUERIMENTO DE SUA APOSENTADORIA POR TEMPO DE SERVICO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.09.00', 'ABONO ANUAL 13. SALARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ABONO ANUAL - 13 SALARIO, DEVIDO AOS SEGURADOS BENEFICIARIOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.10.00', 'AUXILIO DOENCA - ACIDENTE DO TRABALHO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-DOENCA, DECORRENTE DE ACIDENTE DO TRABALHO, DEVIDO AO SEGURADO ACIDENTADO NO TRABALHO, A PARTIR DO 16. DIA APOS O ACIDENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.11.00', 'AUXILIO - ACIDENTE DO TRABALHO', 'REGISTRA AS DESPESAS COM AUXILIO-ACIDENTE DO TRABALHO, DEVIDO AO SEGURADO ACIDENTADO QUE SOFRA REDUCAO PARCIAL PERMANENTE DE SUA CAPACIDADE PARA O TRABALHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.12.00', 'AUXILIO SUPLEMENTAR ACIDENTE DO TRABALHO', 'REGISTRA AS DESPESAS COM AUXILIO SUPLEMENTAR-ACIDENTE DO TRABALHO, DEVIDO AO SEGURADO ACIDENTADO QUE, APOS A CONSOLIDACAO DAS LESOES DECORRENTES, APRESENTAR PERDAS ANATOMICAS OU REDUCAO DA CAPACIDADE FUNCIONAL DEFINITIVA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.13.00', 'AUXILIO PARA EXAMES FORA DO DOMICILIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO PARA EXAMES FORA DO DOMICILIO, DEVIDO AOS BENEFICIARIOS QUE SE DESLOCAM, POR DETERMINACAO DO INSS, PARA EXAMES OU TRATAMENTO EM PROCESSO DE REABILITACAO PROFISSIONAL, BEM COMO PARA AVALIACAO SOCIAL RELATIVA AOS BENEFICIOS ASSITENCIAS, EM LOCALIDADE DIVERSA DE SEU DOMICILIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.15.00', 'AUXILIO PARA EXAMES FORA DO DOMICILIO - ACIDENTE DO TRABALHO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO PARA EXAMES FORA DO DOMICILIO, DEVIDO AOS BENEFICIARIOS QUE SE DESLOCAM, POR DETERMINACAO DO INSS, PARA EXAMES OU TRATAMENTO EM PROCESSO DE REABILITACAO PROFISSIONAL, EM LOCALIDADE DIVERSA DE SEU DOMICILIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.16.00', 'AUXILIO - PROGRAMA DE REABILITACAO PROFISSIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO PARA SEGURADO INSCRITO EM PROGRAMA DE REABILITACAO PROFISSIONAL, PARA CUSTEAR DESPESAS COMO ALIMENTACAO E TRANSPORTE DO SEGURADO DURANTE A PARTICIPACAO EM CURSO DE REABILITACAO PROFISSIONAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.17.00', 'SEGURO DESEMPREGO - FAT', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SEGURO DESEMPREGO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.18.00', 'ABONO SALARIAL - PASEP - FAT', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ABONO SALARIAL-PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.19.00', 'ABONO SALARIAL - PIS - FAT', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ABONO SALARIAL-PIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.20.01', 'SALARIO FAMILIA - ATIVO PESSOAL CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO FAMILIA-ATIVO PESSOAL CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.20.02', 'SALARIO FAMILIA-INATIVO PESSOAL CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA DEVIDO A INATIVOS PESSOAL CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.20.03', 'SALARIO FAMILIA-PENSIONISTA PESSOAL CIVIL', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA DEVIDO A PENSIONISTA PESSOAL CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.20.04', 'SALARIO FAMILIA LEI 8.745/93', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE SALARIO FAMILIA DECORRENTE DE CONTRATOS TEMPORARIOS - LEI 8.745/93.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.21.00', 'AUXILIO COM DESLOC.P/EXAME FORA DO DOMICILIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO PARA EXAMES FORA DO DOMICILIO DEVIDO AOS BENEFICIARIOS QUE SE DESLOCAM,POR DETERMINACAO DO INSS,PARA EXAMES OU TRATAMENTO EM PROCESSO DE REABILITACAO PROFISSIONAL,EM LOCALIDADE DIVERSA DE SEU DOMICILIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.01.00', 'AUXILIO FUNERAL ATIVO MILITAR', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR ATIVO MILITAR, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS DESPESAS COM FUNERAL DO EX-SERVIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.02.00', 'AUXILIO FUNERAL INATIVO MILITAR', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUITIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR INATIVO MILITAR, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS DESPESAS COM FUNERAL DO INATIVO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.03.00', 'AUXILIO NATALIDADE ATIVO MILITAR', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE-ATIVO MILITAR DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.04.00', 'AUXILIO NATALIDADE INATIVO MILITAR', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE INATIVO MILITAR DEVIDO A SERVIDORA,CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.05.00', 'AUXILIO RECLUSAO ATIVO MILITAR', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO MILITAR, AFASTADO POR MOTIVO DE PRISAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.06.00', 'AUXILIO RECLUSAO INATIVO MILITAR', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO MILITAR, AFASTADO POR MOTIVO DE PRISAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.07.00', 'AUXILIO FUNERAL PENSIONISTA MILITAR', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO MILITAR, AFASTADO POR MOTIVO DE PRISAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.08.00', 'AUXILIO RECLUSAO PENSIONISTA MILITAR', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR PENSIONISTA MILITAR EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS DEVIDO TAMBEM A TERCEIRO E CUSTEAR COMPROVADAMENTE AS DESPESAS COM FUNERAL DO PENSIONISTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.09.00', 'AUXILIO NATALIDADE PENSIONISTA MILITAR', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE PENSIONISTA MILITAR DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO DO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.10.01', 'SALARIO FAMILIA-ATIVO PESSOAL MILITAR', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO FAMILIA-ATIVO PESSOAL MILITAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.10.02', 'SALARIO FAMILIA - INATIVO PESSOAL MILITAR', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVASCOM SALARIO FAMILIA A INATIVOS MILITARES, QUANDO O PAGAMENTO FOR EFETUADO PELA ENTIDADE CONSTITUIDA PARA ADMINISTRAR O RPPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.10.03', 'SALARIO FAMILIA - PENSIONIOSTA PESS. MILITAR', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO FAMILIA A PENSIONISTAS MILITARES, QUANDO O PAGAMENTO FOR EFETUADO PELA ENTIDADE CONSTITUIDA PARA ADMINISTRAR O RPPS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.98.00', 'INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.9.1.00.00', 'OUTROS BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTROS BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.01.00', 'COMBUSTIVEIS E LUBRIFICANTES AUTOMOTIVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COMBUSTIVEIS PARA MOTORES A COMBUSTAO INTERNA DE VEICULOS RODOVIARIOS, TRATORES EM GERAL, EMBARCACOES DIVERSAS E GRUPOS GERADORES ESTACIONADOS OU TRANSPORTAVEIS, E TODOS OS OLEOS LUBRIFICANTES DESTINADOS AOS SISTEMAS HIDRAULICOS, HIDRAMATICOS, DE CAIXA DE TRANSMISSAO DE FORCA E GRAXAS GRAFITADAS PARA ALTAS E BAIXAS TEMPERATURAS. ADITIVOS - ALCOOL HIDRATADO - FLUIDO PARA AMORTECEDOR - FLUIDO PARA TRANSMISSAO HIDRAULICA - GASOLINA - GRAXAS - OLEO DIESEL - OLEO PARA CARTER - OLEO PARA FREIO HIDRAULICO E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.02.00', 'COMBUSTIVEIS E LUBRIFICANTES DE AVIACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COMBUSTIVEIS E LUBRIFICANTES DESTINADOS A QUALQUER TIPO DE AERONAVE. ADITIVOS - GASOLINA - GRAXAS - OLEOS E FLUIDOS EM GERAL - QUEROSENE E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.03.00', 'COMBUSTIVEIS E LUBRIF. P/ OUTRAS FINALIDADES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COMBUSTIVEIS E LUBRIFICANTES PARA OUTRAS FINALIDADES QUE NAO SE ENQUADRAM EM ITENS ANTERIORES. CARBURETO - CARVAO MINERAL - CARVAO VEGETAL - LENHA - QUEROSENE COMUM - COMBUSTIVEIS E LUBRIFICANTES DE USO FERROVIARIO E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.04.00', 'GAS E OUTROS MATERIAIS ENGARRAFADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE GAS DE USO INDUSTRIAL, DE TRATAMENTO DE AGUA, DE ILUMINACAO, DE USO MEDICO, BEM COMO GASES NOBRES PARA USO EM LABORATORIO CIENTIFICO, TAIS COMO: ACETILENO - CARBONICO FREON - HELIO - HIDROGENIO - LIQUEFEITO DE PETROLEO - NITROGENIO - OXIGENIO E OUTROS. REGISTRA, AINDA, O VALOR DAS DESPESAS COM GAS, PO QUIMICO, AGUA PRESSURIZADA E OUTROS MATERIAIS UTILIZADOS NA RECARGA DE EXTINTORES DE INCENDIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.05.00', 'EXPLOSIVOS E MUNICOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE CARGAS DE PROJECAO EM PECAS DE ARTILHARIA, MISSEIS GUIADOS E NAO GUIADOS, CAPSULAS OU ESTOJOS PARA RECARGA E EXPLOSIVOS DE USO MILITAR E PARAMILITAR. BALAS E SIMILARES - ESTOPIM - EXPLOSIVOS, TAIS COMO: ARTEFATOS EXPLOSIVOS - ARTIGOS PIROTECNICOS - CAPSULAS DE DETONACAO - DINAMITE - ESPOLETA - FOGOS DE ARTIFICIO - GRANADA - POLVORA E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.06.00', 'ALIMENTOS PARA ANIMAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ALIMENTOS DESTINADOS A GADO BOVINO, EQUINO, MUAR E BUFALINO, CAPRINOS, SUINOS, OVINOS, AVES DE QUALQUER ESPECIE, COMO TAMBEM PARA ANIMAIS SILVESTRES EM CATIVEIRO (JARDINS ZOOLOGICOS OU LABORATORIOS) E OUTROS. ALFAFA - ALPISTE - CAPIM VERDE - FARELO - FARINHAS EM GERAL - FUBA GROSSO - MILHO EM GRAO - RACAO BALANCEADA - SAL MINERAL - SUPLEMENTOS VITAMINICOS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.07.00', 'GENEROS DE ALIMENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE GENEROS DE ALIMENTACAO AO NATURAL, BENEFICIADOS OU CONSERVADOS. ACUCAR - ADOCANTE - AGUA MINERAL - BEBIDAS - CAFE - CARNES EM GERAL - CEREAIS - CHAS - CONDIMENTOS - FRUTAS - GELO - LEGUMES - REFRIGERANTES - SUCOS - TEMPEROS - VERDURAS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.08.00', 'ANIMAIS PARA PESQUISA E ABATE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ANIMAIS PARA PESQUISA E ABATE. INCLUEM-SE NESTA CLASSIFICACAO OS PEIXES E MARISCOS, TODAS AS ESPECIES DE MAMIFEROS, ABELHAS PARA ESTUDOS, PESQUISA E PRODUCAO DE MEL, BEM ASSIM QUALQUER OUTRO ANIMAL DESTINADO A ESTUDO GENETICO OU ALIMENTACAO. BOI - CABRITO - COBAIAS EM GERAL - MACACO - RATO - RA E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.09.00', 'MATERIAL FARMACOLOGICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MEDICAMENTOS OU COMPONENTES DESTINADOS A MANIPULACAO DE DROGAS MEDICAMENTOSAS. MEDICAMENTOS - SORO - VACINAS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.10.00', 'MATERIAL ODONTOLOGICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA PACIENTES DA AREA ODONTOLOGICA, BEM COMO OS UTILIZADOS INDIRETAMENTE PELOS PROTETICOS NA CONFECCAO DE PROTESES DIVERSAS. AGULHAS - AMALGAMA - ANESTESICOS - BROCA - CIMENTO ODONTOLOGICO -ESPATULA ODONTOLOGICA - FILMES PARA RAIO X - PLATINA - RESINAS ODONTOLOGICAS - SERINGAS - SUGADOR E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.11.00', 'MATERIAL QUIMICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS ELEMENTOS OU COMPOSTOS QUIMICOS DESTINADOS AO FABRICO DE PRODUTOS QUIMICOS, ANALISES LABORATORIAIS, BEM COMO AQUELES DESTINADOS AO COMBATE DE PRAGAS OU EPIZOOTIAS. ACIDOS - INSETICIDAS - PRODUTOS QUIMICOS PARA TRATAMENTO DE AGUA -REAGENTES QUIMICOS - SAIS - SOLVENTES - SUBSTANCIAS UTILIZADAS PARA COMBATER INSETOS, FUNGOS E BACTERIAS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.12.00', 'MATERIAL DE COUDELARIA OU DE USO ZOOTECNICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS NO ARREAMENTO DE ANIMAIS DESTINADOS A MONTARIA, COM EXCECAO DA SELA, COMO TAMBEM AQUELES DESTINADOS AO ADESTRAMENTO DE CAES DE GUARDA OU OUTRO ANIMAL DOMESTICO. ARGOLAS DE METAL - ARREAMENTO - BARRIGUEIRAS - BRIDOES - CABRESTOS - CINCHAS - CRAVOS - ESCOVAS PARA ANIMAIS - ESTRIBOS - FERRADURAS - MANTAS DE PANO - MATERIAL PARA APICULTURA - MATERIAL DE FERRAGEM E CONTENCAO DE ANIMAIS - PEITORAIS -RASPADEIRAS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.13.00', 'MATERIAL DE CACA E PESCA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA CACA E PESCA DE ANIMAIS. ANZOIS - CORDOALHAS PARA REDES CHUMBADAS - ISCAS - LINHAS DE NYLON - MASCARAS PARA VISAO SUBMARINA - MOLINETES - NADADEIRAS DE BORRACHA - REDES - ROUPAS E ACESSORIOS PARA MERGULHO -VARAS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.14.00', 'MATERIAL EDUCATIVO E ESPORTIVO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS CONSUMIDOS DIRETAMENTE NAS ATIVIDADES EDUCATIVAS E ESPORTIVAS DE CRIANCAS E ADULTOS. APITOS - BOLAS - BONES - BOTAS ESPECIAIS - BRINQUEDOS EDUCATIVOS - CALCOES - CAMISAS DE MALHA - CHUTEIRAS - CORDAS - ESTEIRAS -JOELHEIRAS - LUVAS - MATERIAIS PEDAGOGICOS - MEIAS - OCULOS PARA MOTOCICLISTAS - PATINS - QUIMONOS - RAQUETES - REDES PARA PRATICA DE ESPORTES - TENIS E SAPATILHAS - TORNOZELEIRAS - TOUCA PARA NATACAO E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.15.00', 'MATERIAL P/ FESTIVIDADES E HOMENAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO UTILIZADOS EM FESTIVIDADES E HOMENAGENS, INCLUINDO ARTIGOS PARA DECORACAO E BUFFET. ARRANJOS E COROAS DE FLORES - BEBIDAS - DOCES - SALGADOS - PLACAS COMEMORATIVAS (EXCETO AS PLACAS PARA DISTRIBUICAO GRATUITA) E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.16.00', 'MATERIAL DE EXPEDIENTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS APLICADOS DIRETAMENTE NOS TRABALHOS ADMINISTRATIVOS, NOS ESCRITORIOS PUBLICOS, NOS CENTROS DE ESTUDOS E PESQUISAS, NAS ESCOLAS, NAS UNIVERSIDADES ETC. AGENDA - ALFINETE DE ACO - ALMOFADA P/ CARIMBOS - APAGADOR - APONTADOR DE LAPIS - ARQUIVO P/ DISQUETE - BANDEJA PARA PAPEIS - BLOCO P/ RASCU-NHO - BOBINA PAPEL P/ CALCULADORAS - BORRACHA - CADERNO - CANETA -CAPA DE PROCESSO - CARIMBOS EM GERAL - CARTOLINA - CLASSIFICADOR -CLIPE - COLA - COLCHETE - CORRETIVO - ENVELOPE - ESPATULA - ESTENCIL -ESTILETE - EXTRATOR DE GRAMPOS - FITA ADESIVA - FITA P/ MAQUINA DE ES-CREVER E CALCULAR - GIZ - GOMA ELASTICA - GRAFITE - GRAMPEADOR -GRAMPOS - GUIA P/ ARQUIVO - GUIA DE ENDERECAMENTO POSTAL - IMPRESSOS E FORMULARIOS EM GERAL - INTERCALADOR P/ FICHARIO - LACRE - LAPIS -LAPISEIRA - LIMPA TIPOS - LIVROS DE ATA, DE PONTO E DE PROTOCOLO -PAPEIS - PASTAS EM GERAL - PERCEVEJO - PERFURADOR - PINCA - PLACAS DE ACRILICO - PLASTICOS - PORTA-LAPIS - REGISTRADOR - REGUA - SELOS P/ CORRESPONDENCIA - TESOURA - TINTAS - TONER - TRANSPARENCIAS - ETIQUETAS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.17.00', 'MATERIAL DE PROCESSAMENTO DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SUPRIMENTOS DE TI, INCLUSIVE PECAS PARA REPOSICAO. CARTUCHOS DE TINTA - CAPAS PLASTICAS PROTETORAS PARA MICROS E IMPRES- SORAS - CD-ROM VIRGEM - DISQUETES - ETIQUETAS EM FORMULARIOS-CONTINUOS -LEITORA/SMARTCARD - MOUSE E TECLADO (REPOSICAO) - MOUSE PAD - PECAS E ACESSORIOS PARA COMPUTADORES E PERIFERICOS - RECARGA DE CARTUCHOS DE TINTA - TONER PARA IMPRESORAS A LASER - CARTOES MAGNETICOS - REPOSICAO DE LEITORA/TOKEN PEN-DRIVE/OUTROS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.18.00', 'MATERIAIS E MEDICAMENTOS P/ USO VETERINARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS E MEDICAMENTOS PARA USO VETERINARIO. VACINAS - MEDICAMENTOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.19.00', 'MATERIAL DE ACONDICIONAMENTO E EMBALAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS APLICADOS DIRETAMENTE NAS PRESERVACOES, ACOMODACOES OU EMBALAGENS DE QUALQUER PRODUTO. ARAME - BARBANTE - CAIXAS PLASTICAS, DE MADEIRA, PAPELAO E ISOPOR -CORDAS - ENGRADADOS - FITAS DE ACO OU METALICAS - FITAS GOMADORAS -GARRAFAS E POTES - LINHA - PAPEL DE EMBRULHO - PAPELAO - SACOLAS -SACOS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.20.00', 'MATERIAL DE CAMA, MESA E BANHO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS EM DORMITORIOS COLETIVOS, RESIDENCIAIS, HOTEIS, RESTAURANTES ETC. COBERTORES - COLCHAS - COLCHONETES - FRONHAS - GUARDANAPOS - LENCOIS -TOALHAS - TRAVESSEIROS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.21.00', 'MATERIAL DE COPA E COZINHA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA REFEITORIOS DE QUALQUER TIPO, COZINHAS RESIDENCIAIS, DE HOTEIS, DE HOSPITAIS, DEESCOLAS, DE UNIVERSIDADES, DE FABRICAS ETC. ABRIDOR DE GARRAFA - ACUCAREIROS - ARTIGOS DE VIDRO E PLASTICO -BANDEJAS - COADORES - COLHERES - COPOS - EBULIDORES - FACAS -FARINHEIROS - FOSFOROS - FRIGIDEIRAS - GARFOS - GARRAFAS TERMICAS -PALITEIROS - PANELAS - PANOS DE COZINHA - PAPEL ALUMINIO - PRATOS -RECIPIENTES PARA AGUA - SUPORTES DE COPOS P/ CAFEZINHO - TIGELAS -VELAS - XICARAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.22.00', 'MATERIAL DE LIMPEZA E PROD. DE HIGIENIZACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DESTINADOS A HIGIENIZACAO PESSOAL, DE AMBIENTES DE TRABALHO, DE HOSPITAIS ETC. ALCOOL ETILICO - ANTICORROSIVO - APARELHO DE BARBEAR DESCARTAVEL -BALDE PLASTICO - BOMBA P/ INSETICIDA - CAPACHO - CERA - CESTO P/ LIXO- CREME DENTAL - DESINFETANTE - DESODORIZANTE - DETERGENTE - ESCOVA DEDENTES - ESCOVA P/ ROUPAS E SAPATOS - ESPANADOR - ESPONJA - ESTOPA -FLANELA - INSETICIDA - LUSTRA-MOVEIS - MANGUEIRA - NAFTALINA - PA PARALIXO - PALHA DE ACO - PANOS P/ LIMPEZA - PAPEL HIGIENICO - PASTA PARALIMPEZA DE UTENSILIOS - PORTA-SABAO - REMOVEDOR - RODO - SABAO -SABONETE - SACO P/ LIXO - SAPONACEO - SODA CAUSTICA - TOALHA DE PAPEL- VASSOURA - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.23.00', 'UNIFORMES, TECIDOS E AVIAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE UNIFORMES OU QUALQUER TECIDO OU MATERIAL SINTETICO QUE SE DESTINE A CONFECCAO DE ROUPAS, COM LINHAS DE QUALQUER ESPECIE DESTINADAS A COSTURAS E OUTROS MATERIAIS DE CONSUMO EMPREGADOS DIRETA OU INDIRETAMENTE NA CONFECCAO DE ROUPAS. AGASALHOS - ARTIGOS DE COSTURA - AVENTAIS - BLUSAS - BOTOES - CADARCOS- CALCADOS - CALCAS - CAMISAS - CAPAS - CHAPEUS - CINTOS - ELASTICOS -GRAVATAS - GUARDA-POS - LINHAS - MACACOES - MEIAS - TECIDOS EM GERAL -UNIFORMES MILITARES OU DE USO CIVIL - ZIPERES - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.24.00', 'MATERIAL P/ MANUT.DE BENS IMOVEIS/INSTALACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO PARA APLICACAO,MANUTENCAO E REPOSICAO DE QUALQUER BEM PUBLICO. AMIANTO - APARELHOS SANITARIOS - ARAMES LISO E FARPADO - AREIA -BASCULANTE - BOCA DE LOBO - BOIA - BRITA - BROCHA - CABO METALICO -CAL - CANO - CERAMICA - CIMENTO - COLA - CONDUTORES DE FIOS - CONEXOES- CURVAS - ESQUADRIAS - FECHADURAS - FERRO - GAXETAS - GRADES -IMPERMEABILIZANTES - ISOLANTES ACUSTICOS E TERMICOS - JANELAS -JOELHOS - LADRILHOS - LAVATORIOS - LIXAS - MADEIRA - MARCOS DECONCRETO - MASSA CORRIDA - NIPLE - PAPEL DE PAREDE - PARAFUSOS - - PECAS P/ELEVADORES,PORTOES ELETRICOS, AR CONDICIONADO CENTRAL, ETC- PIAS- PIGMENTOS - PORTAS E PORTAIS - PREGOS - ROLOS SOLVENTES - SIFAO -TACOS - TAMPA P/ VASO - TAMPAO DE FERRO - TANQUE - TELA DE ESTUQUE -TELHA - TIJOLO - TINTA - TORNEIRA - TRINCHA - TUBO DE CONCRETO -VALVULAS - VERNIZ - VIDRO - AQUECEDORES A GAS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.25.00', 'MATERIAL P/ MANUTENCAO DE BENS MOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COMPONENTES, PECAS, ACESSORIOS E SOBRESSALENTES PARA APLICACAO, MANUTENCAO E REPOSICAO EM BENS MOVEIS EM GERAL. CABOS - CHAVES - CILINDROS P/ MAQUINAS COPIADORAS - COMPRESSOR P/ AR CONDICIONADO - MANGUEIRA P/ FOGAO - PECAS DE REPOSICAO DE APARELHOS E MAQUINAS EM GERAL -MATERIAIS DE REPOSICAO PARA INSTRUMENTOS MUSICAIS - VIDRO DE MESA E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.26.00', 'MATERIAL ELETRICO E ELETRONICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO PARA APLICACAO,MANUTENCAO E REPOSICAO DOS SISTEMAS, APARELHOS E EQUIPAMENTOS ELETRICOS E ELETRONICOS. BENJAMINS - BOCAIS - CALHAS - CAPACITORES E RESISTORES - CHAVES DE LIGACAO - CIRCUITOS ELETRONICOS - CONDUTORES - COMPONENTES DE APARELHOELETRONICO - DIODOS - DISJUNTORES - ELETRODOS - ELIMINADOR DE PILHAS -ESPELHOS PARA INTERRUPTORES - FIOS E CABOS - FITA ISOLANTE - FUSIVEIS- INTERRUPTORES - LAMPADAS E LUMINARIAS - PILHAS E BATERIAS - PINOS E PLUGS - PLACAS DE BAQUELITE - REATORES - RECEPTACULOS - RESISTENCIAS -STARTS - SUPORTES - TOMADA DE CORRENTE - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.27.00', 'MATERIAL DE MANOBRA E PATRULHAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO UTILIZADOS EM CAMPANHA MILITAR OU PARAMILITAR, EM MANOBRAS DE TROPAS, EM TREINAMENTOOU EM ACAO EM PATRULLHAMENTO OSTENSIVO OU RODOVIARIO, EM CAMPANHA DE SAUDE PUBLICA ETC. BINOCULO - CARTA NAUTICA - CANTIL - CORDAS - FLAMULAS E BANDEIRAS DESINALIZACAO - LANTERNAS - MEDICAMENTOS DE PRONTO-SOCORRO - MOCHILAS -PIQUETES - SACOLAS - SACOS DE DORMIR - SINALEIROS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.28.00', 'MATERIAL DE PROTECAO E SEGURANCA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO UTILIZADOS DIRETAMENTE NA PROTECAO DE PESSOAS OU BENS PUBLICOS, PARA SOCORRO DE PESSOAS E ANIMAIS OU PARA SOCORRO DE VEICULOS, AERONAVES E EMBARCACOES, ASSIM COMO QUALQUER OUTRO ITEM APLICADO DIRETAMENTE NAS ATIVIDADES DE SOBREVIVENCIA DE PESSOAS, NA SELVA, NO MAR OU EM SINISTROS DIVERSOS. BOTAS - CADEADOS - CALCADOS ESPECIAIS - CAPACETES - CHAVES - CINTOS -COLETES - DEDAIS - GUARDA-CHUVAS - LONA - LUVAS - MANGUEIRA DE LONA -MASCARAS - PASSADEIRA ANTIDERRAPANTE - OCULOS - CABINA DE PAPELAO E OUTROS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.29.00', 'MATERIAL P/ AUDIO, VIDEO E FOTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO DE EMPREGO DIRETO EM FILMAGEM E REVELACAO, AMPLIACOES E REPRODUCOES DE SONS E IMAGENS. AETZE ESPECIAL P/ CHAPA DE PAPEL - ALBUNS P/ RETRATOS - ALTO-FALANTES- ANTENAS - ARTIGOS PARA GRAVACAO EM ACETATO - FILMES VIRGENS - FITASVIRGENS DE AUDIO E VIDEO - LAMPADAS ESPECIAIS - MATERIAL P/ RADIOGRA-FIA, MICROFILMAGEM E CINEMATOGRAFIA - MOLDURAS - PAPEL P/ REVELACAO DEFOTOGRAFIAS - PEGADORES - REVELADORES - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.30.00', 'MATERIAL PARA COMUNICACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA COMUNICACOES, ASSIM COMO OS COMPONENTES, CIRCUITOS IMPRESSOS OU INTEGRADOS, PECAS OU ACESSORIOS DE REPOSICAO, CHIPS, E PARTES DE EQUIPAMENTOS DE COMUNIC.MATERIAIS PARA INSTALACOES: RADIOFONICAS, RADIOTELEGRAFICAS, TELEGRAFICAS E OUTROS. - BATERIA PARA TELEFONE CELULAR- BLOQUEADOR TELEFONICO - CHAVE COMUTADORA PARA TELEFONE - FIO PARA TELEFONE - TOMADA PARA TELEFONE - MATERIAIS PARA INSTALACOES RADIOFONICAS - RADIOTELEGRAFICAS - TELEGRAFICAS - OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.31.00', 'SEMENTES, MUDAS DE PLANTAS E INSUMOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE QUALQUER TIPO DE SEMENTE DESTINADA AAO PLANTIO E MUDAS DE PLANTAS FRUTIFERAS OU ORNAMENTAIS, ASSIM COMO TODOS OS INSUMOS UTILIZADOS PARA FERTILIZACAO. ADUBOS - ARGILA - PLANTAS ORNAMENTAIS - BORBULHAS - BULBOS - ENXERTOS- FERTILIZANTES - MUDAS ENVASADAS OU COM RAIZES NUAS - SEMENTES -TERRA - TUBERCULOS - XAXIM - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.32.00', 'SUPRIMENTO DE AVIACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS EMPREGADOS NA MANUTENCAO E REPARO DE AERONAVES. ACESSORIOS - PECAS DE REPOSICAO DE AERONAVES - SOBRESSALENTES -E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.33.00', 'MATERIAL P/ PRODUCAO INDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAS-PRIMAS UTILIZADAS NA TRANSFORMACAO, BENEFICIAMENTO E INDUSTRIALIZACAO DE UM PRODUTO FINAL. BORRACHA - COURO - MATERIAS-PRIMAS EM GERAL - MINERIOS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.34.00', 'SUPRIMENTOS PARA MAQ.E MOTORES NAVIOS E EMBARCACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA MANUTENCAO E REPARO DE MAQUINAS E MOTORES DE NAVIOS, INCLUSIVE DA ESQUADRA, E DE EMBARCACOES EM GERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.35.00', 'MATERIAL LABORATORIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS UTENSILIOS USADOS EM ANALISES LABORATORIAIS. ALMOFARIZES - BASTOES - BICO DE GAS - CALICES - CORANTES - FILTROS DEPAPEL - FIXADORAS - FRASCOS - FUNIS - GARRA METALICA - LAMINAS DEVIDRO P/ MICROSCOPIO - LAMPADAS ESPECIAIS - LUVAS DE BORRACHA - METAISE MATALOIDES P/ ANALISE - PINCAS - ROLHAS - VIDRARIA: BALAO VOLUMETRI-CO - BECKER - CONTA-GOTAS - ERLEMEYER - PIPETA - PROVETA - TERMOMETRO- TUBO DE ENSAIO - MATERIAL DE LABORATORIO DIDATICO E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.36.00', 'MATERIAL HOSPITALAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO PARA AREA HOSPITALAR OU AMBULATORIAL. AGULHAS HIPODERMICAS - ALGODAO - CANULAS - CATETERES - COMPRESSA DEGAZE - DRENOS - ESPARADRAPO - FIOS CIRURGICOS - LAMINAS P/ BISTURI -LUVAS - SERINGAS - TERMOMETRO CLINICO - E OUTROS. .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.37.00', 'SUPRIMENTOS DE ARMAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA MANUTENCAO E REPARO DE ARMAMENTO. MATERIAL DE MANUTENCAO E ARMAMENTO - PECAS DE REPOSICAO - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.38.00', 'SUPRIMENTO DE PROTECAO AO VOO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PECAS DE REPOSICAO DE RADARES E SISTEMAS DE COMUNICACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.39.00', 'MATERIAL P/ MANUTENCAO DE VEICULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA APLICACAO E MANUTENCAO DE VEICULOS RODOVIARIOS, VIATURAS BLINDADAS E TRATORES EM GERAL. AGUA DESTILADA - AMORTECEDORES - BATERIAS - BORRACHAS - BUZINA - CABOSDE ACELERADOR - CABOS DE EMBREAGEM - CAMARA DE AR - CARBURADOR COMPLETO - CIFA - COLAR DE EMBREAGEM - CONDENSADOR E PLATINADO - CORREIAS- DISCO DE EMBREAGEM - IGNICAO - JUNTA HOMOCINETICA - LAMPADAS E LANTERNAS P/ VEICULOS - LONAS E PASTILHAS DE FREIO - MANGUEIRAS -MATERIAL UTILIZADO EM LANTERNAGEM E PINTURA - MOTOR DE REPOSICAO -PARA-BRISA - PARA-CHOQUE - PLATO - PNEUS - REPAROS - RETENTORES -RETROVISORES - ROLAMENTOS - TAPETES - VALVULA DA MARCHA-LENTA E TERMOSTATICA - VELAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.40.00', 'MATERIAL BIOLOGICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE AMOSTRAS E OUTROS ITENS DE MATERIAIS BIOLOGICOS UTILIZADOS EM ESTUDOS E PESQUISAS CIENTIFICAS EM SERES VIVOS E INSEMINACAO ARTIFICIAL. MEIOS DE CULTURA - SEMEN - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.41.00', 'MATERIAL P/ UTILIZACAO EM GRAFICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS MATERIAIS DE CONSUMO DE USO GRAFICO, TAIS COMO: CHAPAS DE OFF-SET - CLICHES - COLA - ESPIRAIS - FOTOLITOS - LOGOTIPOS - PAPEL - SOLVENTES - TINTA - TIPOS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.42.00', 'FERRAMENTAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS TIPOS DE FERRAMENTAS UTILIZADAS EM OFICINAS, CARPINTARIAS, JARDINS ETC. ALICATE - BROCA - CAIXA P/ FERRAMENTAS - CANIVETE - CHAVES EM GERAL -ENXADA - ESPATULAS - FERRO DE SOLDA - FOICE - LAMINA DE SERRA - LIMA -MACHADO - MARTELO - PA - PICARETA - PONTEIRA - PRUMO - SERROTE -TESOURA DE PODAR - TRENA - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.43.00', 'MATERIAL P/ REABILITACAO PROFISSIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA PROGRAMAS DE REABILITACAO PROFISSIONAL. BASTOES - BENGALAS - JOELHEIRAS - MEIAS ELASTICAS E ASSEMELHADOS -OCULOS - ORTESES - PESOS - PROTESES, INSTRUMENTOS DE TRABALHO E IMPLEMENTOS PROFISSIONAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.44.00', 'MATERIAL DE SINALIZACAO VISUAL E OUTROS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA IDENTIFICACAO, SINALIZACAO VISUAL, ENDERECAMENTO E OUTROS. PLACAS DE SINALIZACAO EM GERAL, TAIS COMO, PLACAS INDICATIVAS PARA O SETORES E SECOES, PLACAS PARA VEICULOS, PLAQUETAS PARA TOMBAMENTO DE MATERIAL, PLACAS SINALIZADORAS DE TRANSITO, CONES SINALIZADORES DE TRANSITO, CRACHAS, BOTONS IDENTIFICADORES PARA SERVIDORES E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.45.00', 'MATERIAL TECNICO P/ SELECAO E TREINAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS TECNICOS UTILIZADOS EM PROCESSOS DE SELECAO E TREINAMENTO PELA PROPRIA UNIDADE GESTORA OU PARA DISTRIBUICAO NAO GRATUITA, TAIS COMO: APOSTILAS E SIMILARES - FOLHETOS DE ORIENTACAO - LIVROS - MANUAIS EXPLICATIVOS PARA CANDIDATOS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.46.00', 'MATERIAL BIBLIOGRAFICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL BIBLIOGRAFICO TAIS COMO: JORNAIS - REVISTAS - PERIODICOS EM GERAL - ANUARIOS MEDICOS - ANUARIO ESTATISCO - LIVROS EM GERAL E OUTROS, PODENDO ESTAR NA FORMA DE CD-ROM E OS MATERIAIS BIBLIOGRAFICOS PARA BIBLIOTECAS PUBLICAS, CONFORME MANUAL SIAFI CODIGO 02.11.35.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.48.00', 'BENS MOVEIS NAO ATIVAVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA AQUISICAO DE BENS MOVEIS DE NATUREZA PERMANENTE NAO ATIVAVEIS, OU SEJA, AQUELES CONSIDERADOS COMO DESPESA OPERACIONAL, PARA FINS DE DEDUCAO DE IMPOSTO DE RENDA, DESDE QUE ATENDA AS ESPECIFICACOES CONTIDAS NO ARTIGO 301 DO RIR (REGULAMENTO DE IMPOSTO DE RENDA). ESTA CONTA EH UTILIZADA EXCLUSIVAMENTE PELAS UNIDADES REGIDAS PELA LEI 6404/76.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.49.00', 'BILHETES DE PASSAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE BILHETES DE PASSAGEM PARA GUARDA EM ESTOQUE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.50.00', 'BANDEIRAS, FLAMULAS E INSIGNIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE BANDEIRAS, FLAMULAS E INSIGNIAS, A SABER: BRASOES, ESCUDOS, ARMAS DA REPUBLICA, SELO NACIONAL E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.51.00', 'DISCOTECAS E FILMOTECAS NAO IMOBILIZAVEL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA AQUISICAO DE DISCOS, CD E COLECOES DE FITAS GRAVADAS COM MUSICAS E FITAS CINEMATOGRAFICAS DE CARATER EDUCATIVO,CIENTIFICO E INFORMATIVO, CUJA DEFASAGEM CONTABIL OCORRE EM UM PRAZO MAXIMO DE DOIS ANOS E QUE ATENDA OS PARAMETROS EXCLUDENTES DE MATERIAL PERMANENTE, CONFORME MANUAL DE CONTABILIDADE APLICADO AO SETOR PUBLICO - MACASP, VOLUME I - PROCEDIMENTOS CONTABEIS ORCAMENTARIOS, TAIS COMO: - DISCO EDUCATIVO - FITA DE AUDIO E VIDEO COM AULA DE CARATER EDUCATIVO, MICROFILME E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.52.00', 'MATERIAL DE CARATER SECRETO OU RESERVADO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CARATER SIGILOSO CONSTANTES EM REGULAMENTO DO ORGAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.53.00', 'MATERIAL METEOROLOGICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL METEOROLOGICO, TAIS COMO: RADIOSSONDAS, BALAO DE LATEX, ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.54.00', 'MATERIAL P/MANUT.CONSERV.DE ESTRADAS E VIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA REPAROS, RECUPERACOES E ADAPTACOES DE ESTRADAS, FERROVIAS E RODOVIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.55.00', 'SELOS PARA CONTROLE FISCAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SELOS/CHANCELAS PARA CONTROLE FISCAL. (SELOS DE CONTROLE DE CIGARROS, DE BEBIDAS, ETC.)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.56.00', 'MATERIAL DE MARCACAO DA FAUNA SILVESTRE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA USO NA IDENTIFICACAO INDIVIDUAL (MARCACAO) DOS ESPECIMES DE ESPECIES SILVESTRES EM CRIADORES, MANTENEDORES E JARDINS ZOOLOGICOS. MAMIFERES: TATUAGENS,BRINCOS, MICROCHIP; AVES: ANILHAS, BRACADEIRA/BRINCO DE ASA, MICROCHIP; REPTEIS: LACRES E MICROCHIP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.57.00', 'MATERIAL DE CONSUMO - REPARTICOES NO EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL DE CONSUMO PARA MANUTENCAO DE EMBAIXADAS, CONSULADOS, VICE-CONSULADOS, MISSOES DIPLOMATICAS E OUTRAS REPARTICOES SEDIADAS NO EXTERIOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.58.00', 'SOBRESS.PARA MAQ.E EQP.PARA PRODU.INDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL UTILIZADO NA MANUTENCAO E REPARO DE MAQUINAS E EQUIPAMENTOS INDUSTRIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.99.00', 'OUTROS MATERIAIS DE CONSUMO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTROS MATERIAIS DE CONSUMO QUE NAO SE ENQUADREM NAS RUBRICAS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.01.00', 'MERCADORIAS DOADAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.02.00', 'MATERIAL DESTINADO A ASSISTENCIA SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MAT.DE SAUDE(FARMACOLOGICO,ODONTOLOGICO,HOSPITALAR,MEDICAMENTOS,ORTESE E PROTESE),GENEROS ALIMENTICIOS,MATER.DE CAMA,MESA,COPA,COZINHA,LIMPEZA,HIGIENIZACAO, UNIFORMES, TECIDOS, AVIAMENTOS,MANUT.MOV/IMOV.,FERRAMENTAS E OUTROS DISTINADOS A ASSISTENCIA SOCIAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.03.00', 'MATERIAL EDUCACIONAL E CULTURAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL EDUCACIONAL,(MATERIAL ESCOLAR, DIDATICO, TECNICO, MATERIAL P/AUDIO, VIDEO E FOTO)E MATERIAL CULTURAL (MATERIAL RELIGIOSO E ESPORTIVO).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.04.00', 'MATERIAL PARA CERIMONIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OFERECIDOS A AUTORIDADES ESTRANGEIRAS PELAS AUTORIDADES BRASILEIRAS A TITULO DE HOMENAGEM.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.05.00', 'MATERIAL PARA REABILITACAO PROFISSIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OU BEM DESTINADO A SEGURADO INSCRITO EM PROGRAMA DE REABILITACAO PROFISSIONAL, INDISPENSAVEIS AO DESENVOLVIMENTO DO PROCESSO DE REABILITACAO CONFORME LEIS 8212/91 E 8213/91, TAIS COMO: - PROTESES (APARELHOS DE SUBSTITUICAO) - ORTESES (APARELHOS DE CORRECAO OU COMPLEMENTACAO) - IMPLEMENTO PROFISSIONAL (INSTRUMENTOS TECNICOS E EQUIPAMENTOS DE PROTECAO INDIVIDUAL) - MAQUINAS ACESSORIOS E FERRAMENTAS INDISPENSAVEIS PARA O DESENVOLVIMENTO DE UMA FUNCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.06.00', 'MATERIAL PARA DIVULGACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA PUBLICIDADE E DIVULGACAO DE PROGRAMAS DO GOVERNO, PARA CONSCIENTIZACAO SOCIAL EX: CAMISETAS, BONES, CHAVEIROS, CANETAS, BOTONS, COM LOGOMARCAS,FOLDERS,CARTAZES,CARTILHAS E MANUAIS,ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.07.00', 'MERC. DOADAS -AGRIC.FAMILIAR-PF-COMPRA DIRETA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO A PESSOA FISICA, REFERENTE A AGRICULTURA FAMILIAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.08.00', 'MERC. DOADAS -AGRIC.FAMILIAR-PJ-COMPRA DIRETA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO A PESSOA JURIDICA, REFERENTE A AGRICULTURA FAMILIAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.09.00', 'MERC. DOADAS -- AGRIC.FAMILIAR - CPR ESPECIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS AGROPECUARIOS COMPRADOS ANTECIPADAMENTE, COM A FINALIDADE DE DOACAO, FORMALIZADA COM BASE NA "CEDULA DE PRODUTO RURAL" - "CPR ESPECIAL". (LEI 10.696, DE 02/07/03, ART. 19)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.10.00', 'MERC. DOADAS -AGRIC.FAMILIAR - CPR ALIMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DA PRODUCAO AGROPECUARIA DE PRODUTORES ENQUADRADOS NO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR - PRONAF, COMPRADOS ANTECIPADAMENTE, FORMALIZADA COM BASE NA "CEDULA DE PRODUTO RURAL - CPR - ALIMENTO" (LEI N. 10.696,DE 02/07/2003, ART. 19).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.11.00', 'MATERIAL DE ACONDICIONAMENTO E EMBALAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATE.DE ACONDIC.E EMBALAGEM DESTINADOS AOS PRODUTORES ENQUADRADOS NO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR - PRONAF, FORMALIZADA COMBASE NA "CEDULA DE PRODUTO RURAL - CPR - ALIMENTO" (LEI N. 10.696,DE 02/07/2003, ART. 19).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.13.00', 'MATERIAL P/ IDENTIFICACAO DE BENEFICIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS PARA IDENTIFICACAO DE BENEFICIARIOS E OUTROS, TAIS COMO: AQUISICAO DE CARTOES PARA DISTRIBUICAO A USUARIOS, INDIVIDUALIZADO POR BENEFICIARIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.98.00', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE DISTRIBUICAO GRATUITA DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS, NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.99.00', 'OUTROS MATERIAIS DE DISTRIBUICAO GRATUITA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA DISTRIBUICAO GRATUITA, NAO CONTEMPLADOS EM RUBRICAS ESPECIFICAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.01.00', 'MERCADORIAS DOADAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.02.00', 'MATERIAL DESTINADO A ASSISTENCIA SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MAT.DE SAUDE(FARMACOLOGICO,ODONTOLOGICO,HOSPITALAR,MEDICAMENTOS,ORTESE E PROTESE),GENEROS ALIMENTICIOS,MATER.DE CAMA,MESA,COPA,COZINHA,LIMPEZA,HIGIENIZACAO, UNIFORMES, TECIDOS, AVIAMENTOS,MANUT.MOV/IMOV.,FERRAMENTAS E OUTROS DISTINADOS A ASSISTENCIA SOCIAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.03.00', 'MATERIAL EDUCACIONAL E CULTURAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL EDUCACIONAL,(MATERIAL ESCOLAR, DIDATICO, TECNICO, MATERIAL P/AUDIO, VIDEO E FOTO)E MATERIAL CULTURAL (MATERIAL RELIGIOSO E ESPORTIVO).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.04.00', 'MATERIAL PARA CERIMONIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OFERECIDOS A AUTORIDADES ESTRANGEIRAS PELAS AUTORIDADES BRASILEIRAS A TITULO DE HOMENAGEM.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.05.00', 'MATERIAL PARA REABILITACAO PROFISSIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OU BEM DESTINADO A SEGURADO INSCRITO EM PROGRAMA DE REABILITACAO PROFISSIONAL, INDISPENSAVEIS AO DESENVOLVIMENTO DO PROCESSO DE REABILITACAO CONFORME LEIS 8212/91 E 8213/91, TAIS COMO: - PROTESES (APARELHOS DE SUBSTITUICAO) - ORTESES (APARELHOS DE CORRECAO OU COMPLEMENTACAO) - IMPLEMENTO PROFISSIONAL (INSTRUMENTOS TECNICOS E EQUIPAMENTOS DE PROTECAO INDIVIDUAL) - MAQUINAS ACESSORIOS E FERRAMENTAS INDISPENSAVEIS PARA O DESENVOLVIMENTO DE UMA FUNCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.06.00', 'MATERIAL PARA DIVULGACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA PUBLICIDADE E DIVULGACAO DE PROGRAMAS DO GOVERNO, PARA CONSCIENTIZACAO SOCIAL EX: CAMISETAS, BONES, CHAVEIROS, CANETAS, BOTONS, COM LOGOMARCAS,FOLDERS,CARTAZES,CARTILHAS E MANUAIS,ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.07.00', 'MERC. DOADAS -AGRIC.FAMILIAR-PF-COMPRA DIRETA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO A PESSOA FISICA, REFERENTE A AGRICULTURA FAMILIAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.08.00', 'MERC. DOADAS -AGRIC.FAMILIAR-PJ-COMPRA DIRETA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO A PESSOA JURIDICA, REFERENTE A AGRICULTURA FAMILIAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.09.00', 'MERC. DOADAS -- AGRIC.FAMILIAR - CPR ESPECIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS AGROPECUARIOS COMPRADOS ANTECIPADAMENTE, COM A FINALIDADE DE DOACAO, FORMALIZADA COM BASE NA "CEDULA DE PRODUTO RURAL" - "CPR ESPECIAL". (LEI 10.696, DE 02/07/03, ART. 19)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.10.00', 'MERC. DOADAS -AGRIC.FAMILIAR - CPR ALIMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DA PRODUCAO AGROPECUARIA DE PRODUTORES ENQUADRADOS NO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR - PRONAF, COMPRADOS ANTECIPADAMENTE, FORMALIZADA COM BASE NA "CEDULA DE PRODUTO RURAL - CPR - ALIMENTO" (LEI N. 10.696,DE 02/07/2003, ART. 19).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.11.00', 'MATERIAL DE ACONDICIONAMENTO E EMBALAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATE.DE ACONDIC.E EMBALAGEM DESTINADOS AOS PRODUTORES ENQUADRADOS NO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR - PRONAF, FORMALIZADA COMBASE NA "CEDULA DE PRODUTO RURAL - CPR - ALIMENTO" (LEI N. 10.696,DE 02/07/2003, ART. 19).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.12.00', 'MATERIAL DESTINADO A CONTRIBUINTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL (CD-ROM, FORMULARIOS, ETC.) PARA DISTRIBUICAO AOS CONTRIBUINTES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.13.00', 'MATERIAL P/ IDENTIFICACAO DE BENEFICIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS PARA IDENTIFICACAO DE BENEFICIARIOS E OUTROS, TAIS COMO: AQUISICAO DE CARTOES PARA DISTRIBUICAO A USUARIOS, INDIVIDUALIZADO POR BENEFICIARIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.98.00', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE DISTRIBUICAO GRATUITA DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS, NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.99.00', 'OUTROS MATERIAIS DE DISTRIBUICAO GRATUITA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA DISTRIBUICAO GRATUITA, NAO CONTEMPLADOS EM RUBRICAS ESPECIFICAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.01.00', 'MERCADORIAS DOADAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.02.00', 'MATERIAL DESTINADO A ASSISTENCIA SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MAT.DE SAUDE(FARMACOLOGICO,ODONTOLOGICO,HOSPITALAR,MEDICAMENTOS,ORTESE E PROTESE),GENEROS ALIMENTICIOS,MATER.DE CAMA,MESA,COPA,COZINHA,LIMPEZA,HIGIENIZACAO, UNIFORMES, TECIDOS, AVIAMENTOS,MANUT.MOV/IMOV.,FERRAMENTAS E OUTROS DISTINADOS A ASSISTENCIA SOCIAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.03.00', 'MATERIAL EDUCACIONAL E CULTURAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL EDUCACIONAL,(MATERIAL ESCOLAR, DIDATICO, TECNICO, MATERIAL P/AUDIO, VIDEO E FOTO)E MATERIAL CULTURAL (MATERIAL RELIGIOSO E ESPORTIVO).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.04.00', 'MATERIAL PARA CERIMONIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OFERECIDOS A AUTORIDADES ESTRANGEIRAS PELAS AUTORIDADES BRASILEIRAS A TITULO DE HOMENAGEM.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.05.00', 'MATERIAL PARA REABILITACAO PROFISSIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OU BEM DESTINADO A SEGURADO INSCRITO EM PROGRAMA DE REABILITACAO PROFISSIONAL, INDISPENSAVEIS AO DESENVOLVIMENTO DO PROCESSO DE REABILITACAO CONFORME LEIS 8212/91 E 8213/91, TAIS COMO: - PROTESES (APARELHOS DE SUBSTITUICAO) - ORTESES (APARELHOS DE CORRECAO OU COMPLEMENTACAO) - IMPLEMENTO PROFISSIONAL (INSTRUMENTOS TECNICOS E EQUIPAMENTOS DE PROTECAO INDIVIDUAL) - MAQUINAS ACESSORIOS E FERRAMENTAS INDISPENSAVEIS PARA O DESENVOLVIMENTO DE UMA FUNCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.06.00', 'MATERIAL PARA DIVULGACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA PUBLICIDADE E DIVULGACAO DE PROGRAMAS DO GOVERNO, PARA CONSCIENTIZACAO SOCIAL EX: CAMISETAS, BONES, CHAVEIROS, CANETAS, BOTONS, COM LOGOMARCAS,FOLDERS,CARTAZES,CARTILHAS E MANUAIS,ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.07.00', 'MERC. DOADAS -AGRIC.FAMILIAR-PF-COMPRA DIRETA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO A PESSOA FISICA, REFERENTE A AGRICULTURA FAMILIAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.08.00', 'MERC. DOADAS -AGRIC.FAMILIAR-PJ-COMPRA DIRETA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO A PESSOA JURIDICA, REFERENTE A AGRICULTURA FAMILIAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.09.00', 'MERC. DOADAS -- AGRIC.FAMILIAR - CPR ESPECIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS AGROPECUARIOS COMPRADOS ANTECIPADAMENTE, COM A FINALIDADE DE DOACAO, FORMALIZADA COM BASE NA "CEDULA DE PRODUTO RURAL" - "CPR ESPECIAL". (LEI 10.696, DE 02/07/03, ART. 19)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.10.00', 'MERC. DOADAS -AGRIC.FAMILIAR - CPR ALIMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DA PRODUCAO AGROPECUARIA DE PRODUTORES ENQUADRADOS NO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR - PRONAF, COMPRADOS ANTECIPADAMENTE, FORMALIZADA COM BASE NA "CEDULA DE PRODUTO RURAL - CPR - ALIMENTO" (LEI N. 10.696,DE 02/07/2003, ART. 19).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.11.00', 'MATERIAL DE ACONDICIONAMENTO E EMBALAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATE.DE ACONDIC.E EMBALAGEM DESTINADOS AOS PRODUTORES ENQUADRADOS NO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR - PRONAF, FORMALIZADA COMBASE NA "CEDULA DE PRODUTO RURAL - CPR - ALIMENTO" (LEI N. 10.696,DE 02/07/2003, ART. 19).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.12.00', 'MATERIAL DESTINADO A CONTRIBUINTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL (CD-ROM, FORMULARIOS, ETC.) PARA DISTRIBUICAO AOS CONTRIBUINTES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.13.00', 'MATERIAL P/ IDENTIFICACAO DE BENEFICIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS PARA IDENTIFICACAO DE BENEFICIARIOS E OUTROS, TAIS COMO: AQUISICAO DE CARTOES PARA DISTRIBUICAO A USUARIOS, INDIVIDUALIZADO POR BENEFICIARIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.98.00', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE DISTRIBUICAO GRATUITA DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS, NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.99.00', 'OUTROS MATERIAIS DE DISTRIBUICAO GRATUITA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA DISTRIBUICAO GRATUITA, NAO CONTEMPLADOS EM RUBRICAS ESPECIFICAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.01.00', 'MERCADORIAS DOADAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.02.00', 'MATERIAL DESTINADO A ASSISTENCIA SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MAT.DE SAUDE(FARMACOLOGICO,ODONTOLOGICO,HOSPITALAR,MEDICAMENTOS,ORTESE E PROTESE),GENEROS ALIMENTICIOS,MATER.DE CAMA,MESA,COPA,COZINHA,LIMPEZA,HIGIENIZACAO, UNIFORMES, TECIDOS, AVIAMENTOS,MANUT.MOV/IMOV.,FERRAMENTAS E OUTROS DISTINADOS A ASSISTENCIA SOCIAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.03.00', 'MATERIAL EDUCACIONAL E CULTURAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL EDUCACIONAL,(MATERIAL ESCOLAR, DIDATICO, TECNICO, MATERIAL P/AUDIO, VIDEO E FOTO)E MATERIAL CULTURAL (MATERIAL RELIGIOSO E ESPORTIVO).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.04.00', 'MATERIAL PARA CERIMONIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OFERECIDOS A AUTORIDADES ESTRANGEIRAS PELAS AUTORIDADES BRASILEIRAS A TITULO DE HOMENAGEM.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.05.00', 'MATERIAL PARA REABILITACAO PROFISSIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OU BEM DESTINADO A SEGURADO INSCRITO EM PROGRAMA DE REABILITACAO PROFISSIONAL, INDISPENSAVEIS AO DESENVOLVIMENTO DO PROCESSO DE REABILITACAO CONFORME LEIS 8212/91 E 8213/91, TAIS COMO: - PROTESES (APARELHOS DE SUBSTITUICAO) - ORTESES (APARELHOS DE CORRECAO OU COMPLEMENTACAO) - IMPLEMENTO PROFISSIONAL (INSTRUMENTOS TECNICOS E EQUIPAMENTOS DE PROTECAO INDIVIDUAL) - MAQUINAS ACESSORIOS E FERRAMENTAS INDISPENSAVEIS PARA O DESENVOLVIMENTO DE UMA FUNCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.06.00', 'MATERIAL PARA DIVULGACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA PUBLICIDADE E DIVULGACAO DE PROGRAMAS DO GOVERNO, PARA CONSCIENTIZACAO SOCIAL EX: CAMISETAS, BONES, CHAVEIROS, CANETAS, BOTONS, COM LOGOMARCAS,FOLDERS,CARTAZES,CARTILHAS E MANUAIS,ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.07.00', 'MERC. DOADAS -AGRIC.FAMILIAR-PF-COMPRA DIRETA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO A PESSOA FISICA, REFERENTE A AGRICULTURA FAMILIAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.08.00', 'MERC. DOADAS -AGRIC.FAMILIAR-PJ-COMPRA DIRETA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO A PESSOA JURIDICA, REFERENTE A AGRICULTURA FAMILIAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.09.00', 'MERC. DOADAS -- AGRIC.FAMILIAR - CPR ESPECIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS AGROPECUARIOS COMPRADOS ANTECIPADAMENTE, COM A FINALIDADE DE DOACAO, FORMALIZADA COM BASE NA "CEDULA DE PRODUTO RURAL" - "CPR ESPECIAL". (LEI 10.696, DE 02/07/03, ART. 19)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.10.00', 'MERC. DOADAS -AGRIC.FAMILIAR - CPR ALIMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DA PRODUCAO AGROPECUARIA DE PRODUTORES ENQUADRADOS NO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR - PRONAF, COMPRADOS ANTECIPADAMENTE, FORMALIZADA COM BASE NA "CEDULA DE PRODUTO RURAL - CPR - ALIMENTO" (LEI N. 10.696,DE 02/07/2003, ART. 19).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.11.00', 'MATERIAL DE ACONDICIONAMENTO E EMBALAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATE.DE ACONDIC.E EMBALAGEM DESTINADOS AOS PRODUTORES ENQUADRADOS NO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR - PRONAF, FORMALIZADA COMBASE NA "CEDULA DE PRODUTO RURAL - CPR - ALIMENTO" (LEI N. 10.696,DE 02/07/2003, ART. 19).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.12.00', 'MATERIAL DESTINADO A CONTRIBUINTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL (CD-ROM, FORMULARIOS, ETC.) PARA DISTRIBUICAO AOS CONTRIBUINTES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.13.00', 'MATERIAL P/ IDENTIFICACAO DE BENEFICIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS PARA IDENTIFICACAO DE BENEFICIARIOS E OUTROS, TAIS COMO: AQUISICAO DE CARTOES PARA DISTRIBUICAO A USUARIOS, INDIVIDUALIZADO POR BENEFICIARIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.98.00', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE DISTRIBUICAO GRATUITA DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS, NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.99.00', 'OUTROS MATERIAIS DE DISTRIBUICAO GRATUITA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA DISTRIBUICAO GRATUITA, NAO CONTEMPLADOS EM RUBRICAS ESPECIFICAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.01.01', 'DIARIAS - PESSOAL CIVIL - NO PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE PESSOAL CIVIL NO PAIS,COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO SERVIDOR PUBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.01.02', 'DIARIAS - PESSOAL CIVIL - NO EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE PESSOAL CIVIL NO EXTERIOR,COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO SERVIDOR PUBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.01.03', 'DIARIAS - PESSOAL CIVIL - DIARIAS NAO COMPENSAVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE EMPREGADOS OU DIRETORES QUANDO EM VIAGEM A SERVICO DA EMPRESA, INDEPENDENTEMENTE DE COMPROVACAO, EM VALOR SUPERIOR AO LIMITE DEDUTIVEL PARA FINS DE DETERMINACAO DO LUCRO REAL ESTABELECIDO PELA LEGISL. ESPECIFICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.01.98', 'DIARIAS - PESSOAL CIVIL - INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PESSOAL CIVIL DECORRENTES DA INTEGRACAO DOS BALANCETESDOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.01.99', 'DIARIAS - PESSOAL CIVIL - OUTRAS', 'REGISTRA O VALOR DAS DESPESAS REALIZADAS COM OUTRAS DIARIAS - PESSOAL CIVIL NAO CLASSIFICAVEIS NAS RUBRICAS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.02.01', 'DIARIAS - PESSOAL MILITAR - NO PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE PESSOAL MILITAR NO PAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.02.02', 'DIARIAS - PESSOAL MILITAR - NO EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PESSOAL MILITAR NO EXTERIOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.02.98', 'DIARIAS - PESSOAL MILITAR - INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PESSOAL MILITAR DECORRENTES DA INTEGRACAO DOS BALANCETESDOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.02.99', 'DIARIAS - PESSOAL MILITAR - OUTRAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTRAS DIARIAS - PESSOAL MILITAR NAO CLASSIFICAVEIS NAS RUBRICAS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.03.01', 'DIARIAS - COLABORADORES EVENTUAIS - NO PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS A PRESTADORES DE SERVICOS PARA A ADMINISTRACAO PUBLICA, EXCETO A SERVIDORES PUBLICOS OU CELETISTAS. (NO PAIS)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.03.02', 'DIARIAS - COLABORADORES EVENTUAIS - NO EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS A PRESTADORES DE SERVICOS DE CARATER EVENTUAL, SEM VINCULO COM A ADMINISTRACAO PUBLICA (NOEXTERIOR).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.03.98', 'DIARIAS - COLABORADORES EVENTUAIS - INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS A COLABORADORES EVENTUAIS, DECORRENTES DA INTEGRACAO DOS BALANCETESDOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.03.99', 'DIARIAS - COLABORADORES EVENTUAIS - OUTRAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTRAS DIARIAS A COLABORADORES EVENTUAIS NAO CLASSIFICAVEIS NAS RUBRICAS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.04.00', 'DIARIAS A CONSELHEIROS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS A MEMBROS DE ORGAOS DE DELIBERACAO COLETIVA (CONSELHOS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.01.01', 'CONSULTORIA E ASSESSORIA - JURIDICA E TECNICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIA TECNICA OU JURIDICA OU ASSEMELHADA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.01.02', 'CONSULTORIA E ASSESSORIA - TECNOLOGIA DA INFORMACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONSULTORIA OU ASSESSORIA NA AREA DE TECNOLOGIA DA INFORMACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.01.99', 'OUTROS SERVICOS DE CONSULTORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS NAO CONTEMPLADAS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.02.01', 'PERICIAS TECNICAS - JUSTICA GRATUITA', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PERICIAS REALIZADAS POR PROFISSIONAIS TECNICOS PARA A JUSTICA GRATUITA, NAS SEGUINTES AREAS: ADMINISTRACAO - ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA -ENGENHARIA - ESTATISTICA - INFORMATICA - E OUTRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.02.02', 'PERICIAS MEDICA POR BENEFICIOS', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SERVICOS DE PERICIAS MEDICAS POR BENEFICIOS DEVIDOS AOS MEDICOS CREDENCIADOS, PARA EXAMES REALIZADOS EM SEGURADOS E/OU SERVIDORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.02.99', 'OUTROS SERVICOS DE PERICIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR PROFISSIONAIS TECNICOS, NAO COMTEMPLADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.04.00', 'HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS HONORARIOS ADVOCATICIOS A VENCEDORA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.05.00', 'SERVICOS MEDICOS E ODONTOLOGICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS MEDICOS E ODONTOLOGICOS PRESTADOS POR PESSOA FISICA, SEM VINCULO EMPREGATICIO. CONSULTAS - RAIO X - TRATAMENTO ODONTOLOGICO - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.06.00', 'SELECAO E TREINAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTACAO PROFISSIONAL, RECRUTAMENTO E SELECAO DE PESSOAL E TREINAMENTO, POR PESSOA FISICA, INCLUSIVE A GRATIFICACAO POR ENCARGO DE CURSO OU CONCURSO, NORMATIZADA PELO ART. 76-A, DA LEI 8112/90 E O DECRETO 6114/2007, BOLSA SENIOR (SERVIDORES APOSENTADOS DO ORGAO) BOLSA DE MULTIPLICADORES (SERVIDORES DA ATIVA DO ORGAO).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.07.00', 'COMUNICACAO EM GERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE COMUNICACAO GERAL PRESTADOS POR PESSOA FISICA, TAIS COMO: CONFECCAO DE MATERIAL P/ COMUNICACAO VISUAL; GERACAO DE MATERIAS PARA DIVULGACAO POR MEIO DOS VEICULOS DE COMUNICACAO; E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.08.00', 'LIMPEZA E CONSERVACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LIMPEZA E CONSERVACAO DE BENS IMOVEIS. DEDETIZACAO - FAXINA - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.09.00', 'SERVICOS DOMESTICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DOMESTICOS PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO, TAIS COMO: COZINHA - LAVAGEM DE ROUPAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.10.00', 'VIGILANCIA OSTENSIVA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE VIGILANCIA OSTENSIVA NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.11.01', 'MANUTENCAO E CONSERVACAO DE ESTRADAS E VIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REPAROS, RECUPERACOES E ADAPTACOES DE ESTRADAS, FERROVIAS E RODOVIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.11.02', 'MANUTENCAO E CONSERVACAO DE BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE BENS IMOVEIS. PEDREIRO, CARPINTEIRO E SERRALHEIRO - PINTURA - REPAROS EM INSTALACOES ELETRICAS E HIDRAULICAS - REPAROS, RECUPERACOES E ADAPTACOES DE BIOMBOS, CARPETES, DIVISORIAS E LAMBRIS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.11.03', 'MANUTENCAO E CONSERVACAO DE REPARTICOES - EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS UTILIZADOS NA MANUTENCAO DE EMBAIXADAS, CONSULADOS, VICE-CONSULADOS, MISSOES DIPLOMATICAS E OUTRAS REPARTICOES SEDIADAS NO EXTERIOR', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.11.04', 'MANUTENCAO E CONSERVACAO DE VEICULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS E REVISOES DE VEICULOS. ESTOFAMENTO - FUNILARIA - INSTALACAO ELETRICA - LANTERNAGEM - MECANICA- PINTURA - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.11.05', 'MANUTENCAO E CONSERVACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS MANUTENCAO E CONSERVACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS - HARDWARE', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.11.06', 'MANUTENCAO E CONSERVACAO DE MAQUINAS E EQUIPAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE: MAQUINAS E EQUIPAMENTOS GRAFICOS - APARELHOS DE FAX - APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES ELABORATORIAIS - CALCULADORAS - ELETRODOMESTICOS - MAQUINAS DE ESCREVER- E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.11.07', 'MANUTENCAO E CONSERVACAO DE OUTROS BENS MOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE OUTROS BENS MOVEIS NAO ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.11.99', 'OUTROS SERVICOS DE MANUTENCAO E CONSERVACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS E IMOVEIS NAO ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.12.00', 'CONDOMINIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS CONDOMINIAIS A CONTA DO LOCATORIO, QUANDO PREVISTAS NO CONTRATO DE LOCACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.13.00', 'COMISSOES E CORRETAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR: CORRETORES - DESPACHANTES - LEILOEIROS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.14.00', 'DIREITOS AUTORAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE DIREITOS AUTORAIS DE PROPRIEDADE DE TERCEIROS SOBRE OBRAS CIENTIFICAS, LITERARIAS, ETC, EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO. REGISTRA O VALOR REFERENTE A UTILIZACAO DE SERVICOS DECORRENTES DE INCENTIVOS AOS AUTORES A TITULO DE ROYALTIES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.15.00', 'SERVICOS TECNICOS PROFISSIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PROFISSIONAIS TECNICOS, NAS SEGUINTES AREAS: ADMINISTRACAO - ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA -ENGENHARIA - ESTATISTICA E OUTRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.16.00', 'ESTAGIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR ESTUDANTES NA CONDICAO DE ESTAGIARIOS OU MONITORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.17.00', 'SALARIOS DE INTERNOS EM PENITENCIARIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PRESOS E INTERNOS, DE ACORDO COM A LEI NR. 3.274, DE 02/10/57.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.18.00', 'CAPATAZIA, ESTIVA E PESAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS NA MOVIMENTACAO E PESAGEM DE CARGAS(MERCADORIAS E PRODUTOS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.19.00', 'CONFERENCIAS, EXPOSICOES E ESPETACULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR CONFERENCISTAS, EXPOSITORES E ARTISTAS PELOS SERVICOS PRESTADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.20.00', 'ARMAZENAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ALUGUEL DE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, OS DISPENDIOS DE GARANTIA DOS ESTOQUES ARMAZENADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.21.01', 'LOCACAO DE IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ALUGUEL DE PREDIOS, SALAS E OUTROS IMOVEIS DE PROPRIEDADE DE PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.21.02', 'LOCACAO DE BENS MOVEIS E INTANGIVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ALUGUEIS DE MAQUINAS,EQUIPAMENTOS, TELEFONE FIXO E CELULAR E OUTROS BENS MOVEIS DE PROPRIEDADE DE PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.21.03', 'TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DOS TRIBUTOS A CONTA DO LOCATARIO OU DO CESSIONARIO, QUANDO PREVISTOS NO CONTRATO DE LOCACAO OU CESSAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.22.00', 'FORNECIMENTO DE ALIMENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE REFEICOES PREPARADAS,INCLUSIVE LANCHES E SIMILARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.23.00', 'SERVICOS DE CARATER SECRETO OU RESERVADO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE CARATER SIGILOSO CONSTANTES EM REGULAMENTO DO ORGAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.24.00', 'SERVICOS DE REABILITACAO PROFISSIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO, COMO OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE) OS MEIOS INDICADOS PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO. EX: CONTRATACAO DE PROFISSIONAL PARA MINISTRAR CURSO PROFISSIONALIZANTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.25.00', 'SERVICOS DE ASSISTENCIA SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ASSISTENCIA SOCIAL PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES,TAIS COMO AJUDA DE CUSTO SUPLETIVA, GENEROS ALIMENTICIOS, DOCUMENTACAO, TRANSPORTE E SEPULTAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.26.00', 'SERV. DE APOIO ADMIN., TECNICO E OPERACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE NATUREZA EVENTUAL PRESTADOS POR PESSOA FISICA, TAIS COMO: ASSISTENCIA TECNICA - CAPINA - JARDINAGEM - OPERADORES DE MAQUINAS E MOTORISTAS - RECEPCIONISTAS - SERVICOS AUXILIARES - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.27.00', 'SERV. DE CONSERV. E REBENEFIC. DE MERCADORIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE NATUREZA EVENTUAL PRESTADOS POR PESSOA FISICA NA CONSERVACAO E REBENEFICIAMENTO DE MERCADORIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.28.00', 'CONFECCAO DE MATERIAL DE ACONDIC. E EMBALAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA FISICA NA CONFECCAO DE: BOLSAS - CAIXAS - MOCHILAS - SACOLAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.29.00', 'CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE COSTUREIRAS, ALFAIATES E AFINS UTILIZADOS NA CONFECCAO DE UNIFORMES, BANDEIRAS, FLAMULAS, BRA-SOES E ESTANDARTES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.30.00', 'FRETES E TRANSPORTES DE ENCOMENDAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA FISICA EM: FRETES E CARRETOS - REMESSA DE ENCOMENDAS - TRANSPORTE DE MERCADORIASE PRODUTOS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.31.00', 'JETONS E GRATIFICACOES A CONSELHEIROS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA PARTICIPACAO EM ORGAOS DE DELIBERACOES COLETIVAS(CONSELHOS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.34.00', 'SERVICOS DE AUDIO, VIDEO E FOTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE FILMAGENS, GRAVACOES E FOTOGRAFIAS, PRESTADOS POR PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.35.00', 'SERVICOS JUDICIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE CUSTAS PROCESSUAIS DECORRENTES DE ACOES JUDICIAIS, DILIGENCIAS(INCLUSIVE CONDUCAO) SALARIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E SERVICOS DE CARTORIO, QUANDO A NOTA E EMITIDA EM NOME DO TABELIAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.36.00', 'SEGUROS EM GERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE PREMIOS PAGOS POR SEGUROS DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS OU BENS DE TERCEIROS, PREMIOS DE SEGUROS DE BENS DO ESTADO OU DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.37.00', 'HOSPEDAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE HOSPEDAGENS DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS, A LOCAIS ONDE NAO EXISTEM ESBELECIMENTOS COMERCIAIS HABILITADOS EM PRESTAR ESSE TIPO DE SERVICOS, PAGOS DIRETAMENTE A PESSOAS FISICAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.38.01', 'LOCACAO DE MEIOS DE TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA LOCACAO DE MEIOS DE TRANSPORTE, TAIS COMO: VEICULOS, AERONAVES, EMBARCACOES E ASSEMELHADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.38.02', 'MUDANCAS EM OBJETO DE SERVICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.38.03', 'LOCOMOCAO URBANA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIO DE TRANSPORTE URBANO, COMO: ONIBUS, TAXI E OUTROS VEICULOS DE TRANSPORTES URBANOS,PARA ATENDER NECESSIDADE DO SERVICO, COMPREENDENDO, TAMBEM, DESLOCAMENTOS PARA REALIZACAO DE PESQUISAS E REEMBOLSO COM TRANSPORTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.38.04', 'PASSAGENS E LOCOMOCAO NA SUPERVISAO DE VENDAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIO DE TRANSPORTE NA SUPERVISAO DE VENDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.38.05', 'TAXA DE SERV. EMISSAO BILHETES NAO UTILIZADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS C/ TAXA DE SERVICO PAGA PELA AQUISICAO DE PASSAGENS NAO UTILIZADAS, CANCELADAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.38.99', 'OUTRAS DESPESAS COM LOCOMOCAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIOS DE TRANSPORTES NAO ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.39.00', 'SERVICOS GRAFICOS E EDITORIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SERVICOS DE ARTES GRAFICAS PRESTADOS POR PESSOA FISICA, BEM COMO COM SERVICOS EDITORIAIS DIVERSOS. - CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS E REVISTAS - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVICOS DE IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVICOS EDITORIAIS DIVERSOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.98.00', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TERCEIROS - PESSOA FISICA DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS, NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.99.00', 'OUTROS SERVICOS PRESTADOS POR PESSOA FISICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTROS SERVICOS PRESTADOS POR PESSOA FISICA, NAO CONTEMPLADOS EM ITENS ESPECIFICOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.01.01', 'CONSULTORIA E ASSESSORIA - JURIDICA E TECNICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIA TECNICA OU JURIDICA OU ASSEMELHADA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.01.02', 'CONSULTORIA E ASSESSORIA - TECNOLOGIA DA INFORMACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONSULTORIA OU ASSESSORIA NA AREA DE TECNOLOGIA DA INFORMACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.01.99', 'OUTROS SERVICOS DE CONSULTORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS NAO CONTEMPLADAS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.02.01', 'PERICIAS TECNICAS - JUSTICA GRATUITA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS PARA A JUSTICA GRATUITA, NAS SEGUINTES_AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA ESTATISTICA - MEDICINA - VARAS JUDICIAIS DO TRABALHO E OUTRAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.02.02', 'PERICIAS MEDICA, ODONTOLOGICA POR BENEFICIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZACAO DE SERVICOS DE PERICIAS MEDICAS/ODONTO.POR BENEFICIO, DEVIDAS A ENTIDADES MEDICAS/ODONTOLOGICAS CREDENCIADAS,PARA EXAMES REALIZADOS EM SEGURADOS E/OU SERVIDORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.02.99', 'OUTROS SERVICOS DE PERICIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS, NAO CONTEMPLADAS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.03.00', 'AUDITORIA EXTERNA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AUDITORIA EXTERNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.04.01', 'TELECOMUNICACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TELECOMUNICACAO, INCLUSIVE TELEFONIA CELULAR, CENTREX 2000, TARIFA DE HABILITACAO E CARTOES TELEFONICOS PARA APARELHOS DE CELULAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.04.02', 'CORRESPONDENCIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CORRESPONDECIAS, PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - CORREIOS E TELEGRAFOS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.04.03', 'COMUNICACAO DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO DE DADOS: - LOCACAO DE CIRCUITO DE DADOS LOCAIS OU INTERURBANOS PARA ATENDIMENTO DE NOS DE COMUTACAO - CONCENTRACAO E NOS DE ACESSO DA REDE DE COMUNICACAO - SERVICOS DE REDE PRIVATIVA VIRTUAL - SLDD - TOPNET - DATASATPLUS - DATASAT-BI - ATMNET - INTERNET - IP DIRETO - STM400 - FASTNET -REMAV - FRAME-RELAY - SDH.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.04.99', 'OUTROS SERVICOS DE COMUNICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA, NAO COMTEMPLADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.05.01', 'PUBLICIDADE LEGAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE LEGAL, QUE SE REALIZA EM OBEDIENCIA A PRESCRICAO DE LEIS, DECRETOS, PORTARIAS, INSTRUCOES, ESTATUTOS, REGIMENTOS OU REGULAMENTOS INTERNOS DOS INTEGRANTES DO SISTEMA DE COMUNICACAO DE GOVERNO DO PODER EXECUTIVO FEDERAL - SICOM, PRESTADOS POR PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.05.02', 'PUBLICIDADE DE UTILIDADE PUBLICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE REFERENTES A DIVULGACAO DE ACOES DESTINADAS A INFORMAR, ESCLARECER, ORIENTAR, MOBILIZAR, PREVINIR OU ALERTAR A POPULACAO COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE E DE ESTIMULAR A ADOCAO DE COMPORTAMENTOS QUE PERMITAM MELHORAR SUA QUALIDADE DE VIDA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.05.03', 'PUBLICIDADE INSTITUCIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE, PESQUISAS,ASSESSORIA DE IMPRENSA, RELACOES PUBLICAS E COMUNICACAO DIGITAL REFERENTES AA DIVULGACAO DE ATOS, ACOES, PROGRAMAS, OBRAS, SERVICOS, CAMPANHAS METAS E RESULTADOS DOS ORGAOS E ENTIDADES GOVERNAMENTAIS, COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE, VALORIZAR E FORTALECER AS INSTITUICOES, ESTIMULAR A PARTICIPACAO SOCIAL NO DEBATE, NO CONTROLE E NA FORMULACAO DE POLITICAS PUBLICAS E PROMOVER O BRASIL NO EXTERIOR, CONFORME DISPOE O DECRETO 6555/2008', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.05.04', 'PUBLICIDADE MERCADOLOGICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE MERCADOLOGICA, QUE SE DESTINA A LANCAR, MODIFICAR, REPOSICIONAR OU PROMOVER PRODUTOS E SERVICOS DE INTEGRANTES DO SISTEMA DE COMUNICACAO DE GOVERNO DO PODER EXECUTIVO FEDERAL (SICOM), QUE ATUEM NUMA RELACAO DE CONCORRENCIA NO MERCADO, PRESTADOS POR PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.05.99', 'OUTROS SERVICOS DE PUBLICIDADE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE, NAO COMTEMPLADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.06.01', 'MANUT. CONSERV. ESTRADAS E VIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, RECUPERACOES E ADAPTACOES DE ESTRADAS, FERROVIAS E RODOVIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.06.02', 'MANUT. CONSERV. BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE BENS IMOVEIS. PINTURA - REPAROS E REFORMAS DE IMOVEIS EM GERAL - REPAROS EM INSTALACOES ELETRICAS E HIDRAULICAS - REPAROS, RECUPERACOES E ADAPTACOES DE BIOMBOS, CARPETES, DIVISORIAS E LAMBRIS - MANUTENCAO DE ELEVADORES -LIMPEZA DE FOSSA - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.06.03', 'MANUT. CONSERV. REPARTICOES - EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PARA A MANUTENCAO DE EMBAIXADAS, CONSULADOS, VICE-CONSULADOS, MISSOES DIPLOMATICAS E OUTRAS REPATICOES SEDIADAS NO EXTERIOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.06.04', 'MANUT. CONSERV. VEICULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, MANUTENCAO, CONSERTOS, CONSERVACAO E REVISOES DE VEICULOS, TAIS COMO: ALINHAMENTO E BALANCEAMENTO - ESTOFAMENTO - FUNILARIA - INSTALACAO ELETRICA - LANTERNAGEM - MECANICA - PINTURA - FRANQUIA E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.06.05', 'MANUT. CONSERV. EQUIPAMENTOS DE PROCESSAMENTO DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS - HARDWARE', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.06.06', 'MANUT. CONSERV. MAQUINAS E EQUIPAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COM SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE MAQUINAS E EQUIPAMENTOS. APARELHOS DE FAX E TELEX - APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - CALCULADORAS -ELETRODOMESTICOS - EQUIPAMENTOS DE PROTECAO E SEGURANCA - EQUIPAMENTOS GRAFICOS - EQUIPAMENTOS AGRICOLAS - MAQUINAS DE ESCREVER - TURBINAS EOUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.06.07', 'MANUT. CONSERV. SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTACAO (CORRETIVA OU PREVENTIVA) DE SOFTWARE E RENOVACAO DE LICENCA DE USO, SEM ACRESCIMO DE FUNCOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.06.08', 'MANUT. CONSERV. OUTROS BENS MOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES, INSPECOES E ADAPTACOES DE BENS MOVEIS NAO CONTEMPLADOS EM ITENS ESPECIFICOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.06.99', 'OUTROS SERVICOS DE MANUTENCAO E CONSERVACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS, NAO COMTEMPLADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.07.01', 'APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. - ASSISTENCIA TECNICA - COMISSARIA AEREA E APOIO SOLO - JARDINAGEM- OPERADORES DE MAQUINAS E MOTORISTAS - RECEPCIONISTAS - INSTALACOES DE EQUIPAMENTOS DE SEGURANCA - DA REDE ELETRICA - REDE HIDRAULICA - TELEFONIA - COMUNICACAO E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.07.02', 'LIMPEZA E CONSERVACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERV. DE LIMPEZA,HIGIENIZACAO, COLETA DE LIXO, RETIRADA DE ENTULHO,CONSERV.DEDETIZACAO E ASSEIO DOS ORGAOS PUBLICOS (NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVOFISICO DO PESSOAL A SER UTILIZADO).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.07.03', 'VIGILANCIA OSTENSIVA/ MONITORADA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE VIGILANCIA E SEGURANCA DE REPARTICOES PUBLICAS, DE AUTORIDADES (NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO),DESPESA COM MONITORAMENTO ELETRONICO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.07.04', 'SERVICOS DE MANOBRA E PATRULHAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE DAR SUPORTE AS OPERACOES ESPECIAIS REALIZADAS POR ORGAOS DAS FORCAS ARMADAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.07.05', 'SERVICOS DE SOCORRO E SALVAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS PARA PROTECAO,SOCORRO E SALVAMENTO DE PESSOAS E BENS PUBLICOS. SERVICOS PRESTADOS POR: - AMBULANCIAS PARTICULARES - U.T.I MOVEIS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.07.06', 'SERVICOS DE ESTACIONAMENTO DE VEICULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ESTACIONAMENTO DE VEICULOS, TAIS COMO: ALUGUEIS DE VAGAS, MANOBRISTAS, ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.07.07', 'SERVICOS DOMESTICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DOMESTICOS PRESTADOS POR PESSOA JURIDICA, SEM VINCULO EMPREGATICIO, TAIS COMO: COZINHA - LAVAGEM DE ROUPAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.07.99', 'OUTROS SERVICOS DE APOIO ADM, TECNICO E OPERACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO, NAO COMTEMPLADOS EM ITENS ANTERIORES..', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.08.01', 'SERVICOS DE AGUA E ESGOTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.08.02', 'SERVICOS DE ENERGIA ELETRICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ENERGIA ELETRICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.08.03', 'SERVICOS DE GAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE GAS CANALIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.09.01', 'PROGRAMA DE ALIMENTACAO DO TRABALHADOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE ALIMENTACAO A TRABALHADORES, EM QUE A PESSOA JURIDICA POSSUA PROGRAMA DE ALIMENTACAO APROVADO PELO MINISTERIO DO TRABALHO E POSSA USUFRUIR DE BENEFICIO FISCAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.09.02', 'FORNECIMENTO DE ALIMENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE REFEICOES PREPARADAS, INCLUSIVE LANCHES E SIMILARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.10.01', 'LOCACAO DE IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS E CESSOES DE PREDIOS, SALAS E OUTROS IMOVEIS DE INTERESSE DA ADMINISTRACAO PUBLICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.10.02', 'LOCACAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE PROGRAMAS DE PROCESSAMENTO DE DADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.10.03', 'LOCACAO DE MAQUINAS E EQUIPAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVASCOM ALUGUEIS DE MAQUINAS E EQUIPAMENTOS, TAIS COMO: APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - APARELHOS TELEFONICOS, TELES E FAX -CALCULADORAS - ELETRODOMESTICOS - EQUIPAMENTOS GRAFICOS - MAQUINAS DE ESCREVER -TURBINAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.10.04', 'LOCACAO DE BENS MOVEIS DE OUTRAS NATUREZAS E INTANGIVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE BENS MOVEIS NAO CONTEMPLADOS EM ITENS ESPECIFICOS E BENS INTANGIVEIS. LOCACAO DE LINHA TELEFONICA - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.10.05', 'LOCACAO DE EQUIPAMENTOS DE PROC. DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E PERIFERICOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.10.06', 'TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS TRIBUTOS A CONTA DO LOCATARIO OU DO CESSIONARIO, QUANDO PREVISTOS NO CONTRATO DE LOCACAO OU CESSAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.11.01', 'DESENVOLVIMENTO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ATUALIZACAO E ADAPTACAO DE SOFTWARE, SEM ACRESCIMO DE FUNCOES (NAO EVOLUTIVA), E SEM ALTERACAO SIGNIFICATIVA DE VALOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.11.02', 'SUPORTE DE INFRAESTRUTURA DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE OPERACAO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.11.03', 'SUPORTE A USUARIOS DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS AO ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVICOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVICOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVICOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.11.04', 'HOSPEDAGEM DE SISTEMAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE DATACENTER POR MODELOS COMO HOSTING OU COLOCATION.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.11.05', 'SERVICOS TECNICOS PROFISSIONAIS DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PROFISSIONAIS TECNICOS NA AREA DE TECNOLOGIA DA INFORMACAO, EXCETO QUANDO FOREM CLASSIFICADO EM UMA DAS SEGUINTES CONTAS: DESENVOLVIMENTO DE SOFTWARE; SUPORTE DE INFRAESTRUTURA DE T.I.; SUPORTE A USUARIOS DE T.I.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.12.01', 'VALE- TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS DEVIDO AO FORNECIMENTO DE VALE-TRANSPORTE PARA OS TRABALHADORES DE UMA ENTIDADE, TAIS COMO, SERVIDORES, EMPREGADOS,ESTAGIARIOS, ENTRE OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.12.02', 'TRANSPORTE DE SERVIDORES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUCAO DE TAREFAS PELOS SERVIDORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.12.03', 'FRETE E TRANSPORTE DE ENCOMENDAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE MERCADORIAS E PRODUTOS DIVERSOS, PRESTADOS POR PESSOA JURIDICA. - FRETES E CARRETOS - REMESSA DE ENCOMENDAS E OUTRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.13.00', 'ARMAZENAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ALUGUELDE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, AS VARIACOES PROVENIENTESS DE GARANTIA DOS ESTOQUES ARMAZENADOS E A UTILIZACAO DE SERVICO ESPECIALIZADO NA SOLUCAO DE GESTAO DE ESTOQUE, INCLUINDO GESTAO DE MATERIAIS E TRANSPORTE DE MATERIAIS E EQUIPAMENTOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.14.00', 'ASSINATURAS DE PERIODICOS E ANUIDADES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ASSINATURAS DE TV (TVA CABO), JORNAIS, INCLUSIVE DIARIO OFICIAL, REVISTAS, RECORTES DE PUBLICACOES, SOFTWARE, PODENDO ESTAR NA FORMA DE DISQUETE, CD-ROM, BOLE-INS E OUTROS QUE NAO SE DESTINEM A COLECOES OU BIBLIOTECAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.15.00', 'CAPATAZIA, ESTIVA E PESAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MOVIMENTACAO E PESAGEM DE CARGAS(MERCADORIAS E PRODUTOS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.16.00', 'CLASSIFICACAO DE PRODUTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CLASSIFICACAO DE PRODUTOS DE ORIGEM ANIMAL, MINERAL E VEGETAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.17.00', 'COMISSOES E CORRETAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE VALOR REFERENTE A COMISSOES E CORRETAGENS DECORRENTES DE SERVICOS PRESTADOS POR EMPRESAS DE INTERMEDIACAO E REPRESENTACAO COMERCIAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.18.00', 'CONDOMINIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DAS TAXAS CONDOMINIAIS A CONTA DO PROPRIETARIO, OU DO LOCATARIO, CONFORME PREVISTO NO CONTRATO DE LOCACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.19.00', 'CONFECCAO DE MATERIAL DE ACONDIC. E EMBALAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE MATERIAIS DESTINADOS A PRESERVACAO, ACOMODACAO OU EMBALAGEM DE PRODUTOS DIVERSOS, TAIS COMO: - BOLSAS - CAIXAS - MOCHILAS - SACOLAS E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.20.00', 'CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE:- BANDEIRAS - BRASOES - ESTANDARTES - FLAMULAS - UNIFORMES ( INCLUSIVEAS DESPESAS RELACIONADAS COM AUXILIO FARDAMENTO DESCRITOS NA LEI NUM.8237/91) E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.21.00', 'DIREITOS AUTORAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIREITOS AUTORAIS SOBRE OBRAS CIENTIFICAS, LITERARIAS OU EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.22.00', 'EXPOSICOES, CONGRESSOS, CONFERENCIAS E OUTROS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA INSTALACAO E MANUTENCAO DE: CONFERENCIAS - REUNIOES TECNICAS - CONGRESSOS - EXPOSICOES - FEIRAS - FESTEJOS POPULARES - FESTIVAIS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.23.00', 'FESTIVIDADES E HOMENAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA ORGANIZACAO DE EVENTOS, TAIS COMO: COQUETEIS - FESTAS DE CONGRACAMENTO - RECEPCOES - E OUTRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.24.00', 'HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS HONORARIOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS HONORARIOS ADVOCATICIOS A VENCEDORA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.25.00', 'HOSPEDAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE HOSPEDAGENS E ALIMENTACAO DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS OFICIAIS PAGOS DIRETAMENTE A ESTABELECIMENTOS HOTELEIROS (QUANDO NAO HOUVER PAGAMENTO DE DIARIAS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.26.00', 'PATROCINIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PATROCINIOS A ATIVIDADES OU EVENTOS, DE NATUREZA CULTURAL, ESPORTIVA, EDUCACIONAL, AMBIENTAL, CIENTIFICA,COMUNITARIA, PROMOCIONAL ETC. PARA INFLUENCIAR FAVORAVELMENTE O PUBLICO E/OU ATINGIR OUTROS OBJETIVOS RELACIONADOS COM A PROMOCAO DE ATOS, OBRAS, PLANOS, ACOES, BENS OU SERVICOS. NAO INCLUI O PATROCINIO DE MIDIA, ASSIM CONSIDERADOS AQUELES EM QUE O PROPONENTE E UM VEICULO DE COMUNICACAO OU UM GESTOR DE MEIOS OU INSTALACOES QUE FUNCIONEM COMO VEICULO DE MIDIA ALTERNATIVA E AQUELES EM QUE UM VEICULO DE COMUNICACAO E O UNICO OU O PRINCIPAL REALIZADOR DA ACAO PATROCINADA, AINDA QUE O PROPONENTE DO PROJETO E PROVEDOR DE CONTEUDO PARA A ACAO PATROCINADA NAO SE ENQUADRE NA DEFINICAO DE VEICULO DE COMUNICACAO OU MEIO DE MIDIA ALTERNATIVA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.27.00', 'PRODUCOES JORNALISTICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE EDICAO DE JORNAIS, REVISTAS, NOTICIARIOS E MATERIAIS JORNALISTICOS PARA VIDEOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.28.00', 'PROMOCAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS REALIZADOS POR INTEGRANTES DO SICOM OU POR TERCEIROS, QUE EMPREGUEM RECURSOS DE NAO-MIDIA, REALIZADAS COM OBJETIVO DE INCENTIVAR PUBLICOS DE INTERESSE A CONHECEREM OU COMPRAREM PRODUTOS, SERVICOS, MARCAS, CONCEITOS OU POLITICAS PUBLICAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.29.00', 'SEGUROS EM GERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE PREMIOS PAGOS POR SEGUROS DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS OU BENS DE TERCEIROS, PREMIOS DE SEGUROS DE BENS DO ESTADO OU DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.30.00', 'SELECAO E TREINAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTACAO PROFISSIONAL, RECRUTAMENTO E SELECAO DE PESSOAL(CONCURSO PUBLICO) E TREINAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.31.00', 'SERV.MEDICO-HOSPITALAR,ODONTOL.E LABORATORIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS MEDICO-HOSPITALARES, ODONTOLOGICOS E LABORATORIAIS, PRESTADOS POR PESSOAS JURIDICAS SEM VINCULO EMPREGATICIO, TAIS COMO: ANALISES CLINICAS - CIRURGIAS - CONSULTAS - ECOGRAFIAS - ENDOSCOPIAS -ENFERMAGEM - ESTERILIZACAO - EXAMES DE LABORATORIO - RAIO X -TOMOGRAFIAS - TRATAMENTO ODONTOLOGICO - ULTRASSONOGRAFIAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.32.00', 'SERVICOS BANCARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE COMISSOES, TARIFAS E REMUNERACOES DECORRENTES DE SERVICOS PRESTADOS POR BANCOS, INSTITUICOES FINANCEIRAS E AGENTES FINANCEIROS DO SFH, COMPRENDENDO OS SERVICOS DE ANALISE TECNICA, JURIDICA E DOCUMENTAL DAS PROPOSTAS DE PROJETOS DE ESTADO E MUNICIPIOS, BEM COMO OS CUSTOS DE ACOMPANHAMENTO DAS OBRAS ATE A CONCLUSAO DAS UNIDADES HABITACIONAIS. -BEM COMO DESPESAS COM AGUARDA/CUSTODIA DE VALORES (COFRES DE ALUGUEL)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.33.00', 'SERVICOS DE ANALISES E PESQUISA CIENTIFICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ANALISES FISICO-QUIMICAS E PESQUISAS CIENTIFICAS, NAO RELACIONADAS COM APOIO AO ENSINO. - ANALISES MINERAIS - ANALISES DE SOLO - ANALISES QUIMICAS - COLETA DE DADOS EM EXPERIMENTOS - TRATAMENTO E DESTINACAO DE RESIDUOS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.34.00', 'SERVICOS DE APOIO DO ENSINO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE PROPORCIONAR O DESENVOLVIMENTO E O APERFEICOAMENTO DO ENSINO, EM TODOS OS NIVEIS, INCLUSIVE PESQUISAS EXPERIENCIAS E ASSEMELHADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.35.00', 'SERVICOS DE ASSISTENCIA SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS DE ASSISTENCIA SOCIAL PRESTADA A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES, TAIS COMO: - AJUDA DE CUSTO SUPLETIVA - GENEROS ALIMENTICIOS - DOCUMENTACAO -TRANSPORTE E SEPULTAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.36.00', 'SERVICOS DE AUDIO VIDEO E FOTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE FILMAGENS, GRAVACOES, REVELACOES, AMPLIACOES E REPRODUCOES DE SONS E IMAGENS. - CONFECCAO DE ALBUNS - CONFECCAO DE CRACHAS FUNCIONAIS POR FIRMAS ESPECIALIZADAS - EMOLDURAMENTO DE FOTOGRAFIAS - IMAGENS DE SATELITES- REVELACAO DE FILMES - MICROFILMAGEM E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.37.00', 'SERVICOS DE CARATER SECRETO OU RESERVADO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CARATER SIGILOSO CONSTANTES EM REGULAMENTO DO ORGAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.38.00', 'SERVICOS DE CONFECCAO SELOS CONTROLE FISCAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE SELOS/CHANCELAS PARA CONTROLE FISCAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.39.00', 'SERVICOS DE CONSERV. E REBENEF. DE MERCADORIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS UTILIZADOS NA CONSERVACAO E REBEFICIAMENTO DE MERCADORIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.40.00', 'SERVICOS DE CONTROLE AMBIENTAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONTROLE AMBIENTAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.41.00', 'SERVICOS DE COPIAS E REPRODUCAO DE DOCUMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COPIAS XEROGRAFICAS, INCLUSIVE A LOCACAO E A MANUTENCAO DE EQUIPAMENTOS REPROGRAFICOS, COPIASE REPRODUCOES DE DOCUMENTOS E PUBLICACOES EM GERAL, INCLUSIVE POR MEIO MAGNETICO E DIGITALIZACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.42.00', 'SERVICOS DE CRECHE E ASSISTENCIA PRE ESCOLAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR ENTIDADES DE ASSISTENCIA SOCIAL PARA ATENDER OS DEPENDENTES DE SERVIDORES DO ORGAO, HABILITADOS A USUFRUIREM DESSE BENEFICIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.43.00', 'SERVICOS DE INCINERACAO/DESTRUICAO DE MATERIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICO DE PROCESSO DE INCINERACAO E DESTRUICAO DE MATERIAIS, BEM COMO RESIDUOS INDUSTRIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.44.00', 'SERVICOS DE PRODUCAO INDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE TRANSFORMACAO, BENEFICIAMENTO E INDUSTRIALIZACAO DE MATERIAS-PRIMAS QUE RESULTARAO EM UM PRODUTO FINAL. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.45.00', 'SERVICOS DE REABILITACAO PROFISSIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA JURIDICA, COM O OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE), OS MEIOS INDICADOS PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO. EX: CONTRATACAO DE EMPRESA PARA MINISTRAR CURSO PROFISSIONALIZANTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.46.00', 'SERVICOS DE ITENS REPARAVEIS DE AVIACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVASCOM A CONTRATACAO DE SERVICOS ESPECIFICOS PARA A MANUTENCAO DE ITENS REPARAVEIS DE AVIACAO: ASAS, MOTORES, FUSELAGEM, EQUIPAMENTO DE BORDO, ETC E AINDA, NA RECUPERACAO DE MATERIAL DE AVIACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.47.00', 'SERVICOS FUNERARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REMOCOES, SEPULTAMENTOS E TRANSLADACOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.48.00', 'SERVICOS GRAFICOS E EDITORIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ARTES GRAFICAS PRESTADOS POR PESSOA JURIDICA, BEM COMO COM SERVICOS EDITORIAIS DIVERSOS. - CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS E REVISTAS - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVICOS DE IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVICOS EDITORIAIS DIVERSOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.49.00', 'SERVICOS JUDICIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE CUSTAS PROCESSUAIS DECORRENTES DE ACOES JUDICIAIS, DILIGENCIAS(INCLUSIVE CONDUCAO) SALARIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E OFICIAIS DE JUSTICA E SERVICOS DE CARTORIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.50.00', 'SERVICOS RELACIONADOS A INDUSTRIA AEROESPACIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LANCAMENTO E COLOCACAO EM ORBITA DE SATELITES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.51.00', 'SERVICOS TECNICOS PROFISSIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NAS SEGUINTES AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA -ESTATISTICA E OUTRAS. EXCETO OS SERVICOS DE CONSULTORIA QUE DEVEM SER CLASSIFICADOS EM CONTA ESPECIFICA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.52.00', 'TAXA DE ADMINISTRACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ORGANIZACAO E ADMINISTRACAO PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - TAXA DE ADMINISTRACAO PAGA AO INSTITUTO EUVALDO LODI IEL E AO CEN-TRO DE INTEGRACAO EMPRESA-ESCOLA - CIEE, DECORRENTE DOS SERVICOS DE SELECAO E RECRUTAMENTO DE ESTUDANTES, TENDO COMO OBJETIVO O INGRESSO AO MERCADO DE TRABALHO E PROGRAMAS DE ESTAGIO; - TAXA DE ADMINISTRACAO PATRIMONIAL DAS CONTRIBUICOES DO BANCO CENTRALDO BRASIL, NA QUALIDADE DE PATROCINADOR, DESTINADO AO CUSTEIO DAS APOSENTADORIAS E PENSOES CONCEDIDAS COM BASE NA LEI 8.112/1990, E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.53.00', 'VISTOS CONSULARES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE VISTOS CONSULARES JUNTO A EMBAIXADAS E CONSULADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.54.01', 'LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTENCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGAO, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ASSISTENCIA TECNICA - CAPINA - JARDINAGEM - OPERADORES DE MAQUINA - MOTORISTAS - RECEPCIONISTAS - SERVICOS AUXILIARES E OUTROS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.54.02', 'LOCACAO DE MAO-DE-OBRA DE LIMPEZA E CONSERVACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LIMPEZA E CONSERVACAO EM GERAL, TAIS COMO: LIMPEZA E CONSERVACAO DE IMOVEIS, LAVAGEM DE VEICULOS, LAVAGEM E HIGIENIZACAO DE ROUPAS E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.54.03', 'LOCACAO DE MAO-DE-OBRA DE VIGILANCIA OSTENSIVA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE VIGILANCIA OSTENSIVA NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.54.04', 'LOCACAO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVACAO DE BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE MAO-DE-OBRA PARA EFETUAR REPAROS E REFORMAS DE IMOVEIS EM GERAL, INSTAL. ELETRICAS, HIDRAUL. E CORRELATAS DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DE PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.54.05', 'LOCACAO DE MAO-DE-OBRA DE SERVICOS DE COPA E COZINHA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE MAO-DE-OBRA PARA EFETUAR SERVICOS INERENTES A COPA E COZINHA, TAIS COMO: PREPARO DE ALIMENTACAO, LANCHES, CAFE E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.54.06', 'LOCACAO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.54.07', 'LOCACAO DE MAO-DE-OBRA DE SERVICOS DE BRIGADA DE INCENDIO.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE BRIGADA DE INCENDIO EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.54.08', 'LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO - MENORES-APRENDIZES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTENCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGAO, COM A CONTRATACAO DE MAO-DE-OBRA DE MENORES APRENDIZES. (BASE LEGAL - LEI N. 10.097 DE 19/12/2000). NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.54.09', 'LOCACAO DE MAO-DE-OBRA DE MANUTENCAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS, ATUALIZACAO E ADAPTACAO DE SOFTWARE, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTACAO (CORRETIVA, PREVENTIVA E ADAPTATIVA) DE SOFTWARE E RENOVACAO DE LICENCA DE USO DE SOFTWARE. ADAPTACOES DE SOFTWARE SEM ACRESCIMO DE FUNCOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.54.10', 'LOCACAO DE MAO-DE-OBRA DE SUPORTE DE INFRAESTRUTURA DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE OPERACAO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.54.11', 'LOCACAO DE MAO-DE-OBRA DE SUPORTE A USUARIOS DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVICOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVICOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVICOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.54.99', 'OUTRAS LOCACOES DE MAO DE OBRA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE OUTROS SERVICOS DE LOCACOES DE MAO-DE-OBRA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.55.01', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE MAQUINAS E APARELHOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE MAQUINAS E APARELHOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.55.02', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS FERROVIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS FERROVIARIOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.55.03', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS RODOVIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS RODOVIARIOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.55.04', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE OUTROS BENS MOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE OUTROS BENS MOVEIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.55.05', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE BENS IMOVEIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.55.99', 'OUTROS ARRENDAMENTOS MERCANTIS OPERACIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL, NAO ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.56.01', 'PASSAGENS PARA O PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO PAIS EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.56.02', 'PASSAGENS PARA O EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EM-BARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO EXTERIOR EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.56.03', 'LOCACAO DE MEIOS DE TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DA LOCACAO DE MEIOS DE TRANSPORTE, TAIS COMO: VEICULOS, AERONAVES, EMBARCACOES E ASSEMELHADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.56.04', 'MUDANCAS EM OBJETO DE SERVICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DA LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.56.05', 'LOCOMOCAO URBANA', 'REGISTRA AS APROPRIACOES DE DESPESAS COM LOCOMOCAO URBANA REALIZADA POR MEIO DE ONIBUS, TAXI E OUTROS VEICULOS DE TRANSPORTES URBANOS,PARA ATENDER NECESSIDADE DO SERVICO, COMPREENDENDO, TAMBEM, DESLOCAMENTOS PARA REALIZACAO DE PESQUISAS E REEMBOLSO COM TRANSPORTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.56.06', 'PASSAGENS E LOCOMOCAO NA SUPERVISAO DE VENDAS', 'REGISTRA O VALOR DAS APROPR.DAS DESPESAS COM PASSAGENS E LOCOMOCOES URBANAS NA SUPERVISAO DE VENDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.56.07', 'DESPESAS COM EXCESSO DE BAGAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACOES DE DESPESAS COM EXCESSO DE BAGAGEM ATINENTES AOS VOLUMES E MATERIAIS INDISPENSAVEL A EXECUCAO DO TRABALHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.56.08', 'PEDAGIOS', 'REGISTRA O VALOR DAS DESPESAS COM TARIFAS DE PEDAGIO, TAXA MENSAL PELA UTILIZACAO DO SISTEMA E ADESAO AO SISTEMA DE IDENTIFICACAO DO VEICULO SEM A NECESSIDADE DE PARA-LO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.56.09', 'TRANSPORTE DE SERVIDORES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUCAO DE TAREFAS PELOS SERVIDORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.56.10', 'TAXA DE SERV. EMISSAO BILHETES NAO UTILIZADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS C/ TAXA DE SERVICO PAGA PELA AQUISICAO DE PASSAGENS NAO UTILIZADAS, CANCELADAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.56.99', 'OUTRAS DESPESAS COM LOCOMOCAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS E MEIOS DE TRANSPORTE NAO ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.98.00', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE DESPESAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.99.00', 'OUTROS SERVICOS PRESTADOS POR PESSOA JURIDICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA, QUE NAO ESTEJA ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.01.01', 'CONSULTORIA E ASSESSORIA - JURIDICA E TECNICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIA TECNICA OU JURIDICA OU ASSEMELHADA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.01.02', 'CONSULTORIA E ASSESSORIA - TECNOLOGIA DA INFORMACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONSULTORIA OU ASSESSORIA NA AREA DE TECNOLOGIA DA INFORMACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.01.99', 'OUTROS SERVICOS DE CONSULTORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS NAO CONTEMPLADAS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.02.01', 'PERICIAS TECNICAS - JUSTICA GRATUITA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS PARA A JUSTICA GRATUITA, NAS SEGUINTES_AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA ESTATISTICA - MEDICINA - VARAS JUDICIAIS DO TRABALHO E OUTRAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.02.02', 'PERICIAS MEDICA, ODONTOLOGICA POR BENEFICIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZACAO DE SERVICOS DE PERICIAS MEDICAS/ODONTO.POR BENEFICIO, DEVIDAS A ENTIDADES MEDICAS/ODONTOLOGICAS CREDENCIADAS,PARA EXAMES REALIZADOS EM SEGURADOS E/OU SERVIDORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.02.99', 'OUTROS SERVICOS DE PERICIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS, NAO CONTEMPLADAS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.03.00', 'AUDITORIA EXTERNA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AUDITORIA EXTERNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.04.01', 'TELECOMUNICACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TELECOMUNICACAO, INCLUSIVE TELEFONIA CELULAR, CENTREX 2000, TARIFA DE HABILITACAO E CARTOES TELEFONICOS PARA APARELHOS DE CELULAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.04.02', 'CORRESPONDENCIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CORRESPONDECIAS, PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - CORREIOS E TELEGRAFOS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.04.03', 'COMUNICACAO DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO DE DADOS: - LOCACAO DE CIRCUITO DE DADOS LOCAIS OU INTERURBANOS PARA ATENDIMENTO DE NOS DE COMUTACAO - CONCENTRACAO E NOS DE ACESSO DA REDE DE COMUNICACAO - SERVICOS DE REDE PRIVATIVA VIRTUAL - SLDD - TOPNET - DATASATPLUS - DATASAT-BI - ATMNET - INTERNET - IP DIRETO - STM400 - FASTNET -REMAV - FRAME-RELAY - SDH.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.04.99', 'OUTROS SERVICOS DE COMUNICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA, NAO COMTEMPLADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.05.01', 'PUBLICIDADE LEGAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE LEGAL, QUE SE REALIZA EM OBEDIENCIA A PRESCRICAO DE LEIS, DECRETOS, PORTARIAS, INSTRUCOES, ESTATUTOS, REGIMENTOS OU REGULAMENTOS INTERNOS DOS INTEGRANTES DO SISTEMA DE COMUNICACAO DE GOVERNO DO PODER EXECUTIVO FEDERAL - SICOM, PRESTADOS POR PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.05.02', 'PUBLICIDADE DE UTILIDADE PUBLICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE REFERENTES A DIVULGACAO DE ACOES DESTINADAS A INFORMAR, ESCLARECER, ORIENTAR, MOBILIZAR, PREVINIR OU ALERTAR A POPULACAO COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE E DE ESTIMULAR A ADOCAO DE COMPORTAMENTOS QUE PERMITAM MELHORAR SUA QUALIDADE DE VIDA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.05.03', 'PUBLICIDADE INSTITUCIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE, PESQUISAS,ASSESSORIA DE IMPRENSA, RELACOES PUBLICAS E COMUNICACAO DIGITAL REFERENTES AA DIVULGACAO DE ATOS, ACOES, PROGRAMAS, OBRAS, SERVICOS, CAMPANHAS METAS E RESULTADOS DOS ORGAOS E ENTIDADES GOVERNAMENTAIS, COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE, VALORIZAR E FORTALECER AS INSTITUICOES, ESTIMULAR A PARTICIPACAO SOCIAL NO DEBATE, NO CONTROLE E NA FORMULACAO DE POLITICAS PUBLICAS E PROMOVER O BRASIL NO EXTERIOR, CONFORME DISPOE O DECRETO 6555/2008', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.05.04', 'PUBLICIDADE MERCADOLOGICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE MERCADOLOGICA, QUE SE DESTINA A LANCAR, MODIFICAR, REPOSICIONAR OU PROMOVER PRODUTOS E SERVICOS DE INTEGRANTES DO SISTEMA DE COMUNICACAO DE GOVERNO DO PODER EXECUTIVO FEDERAL (SICOM), QUE ATUEM NUMA RELACAO DE CONCORRENCIA NO MERCADO, PRESTADOS POR PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.05.99', 'OUTROS SERVICOS DE PUBLICIDADE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE, NAO COMTEMPLADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.06.01', 'MANUT. CONSERV. ESTRADAS E VIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, RECUPERACOES E ADAPTACOES DE ESTRADAS, FERROVIAS E RODOVIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.06.02', 'MANUT. CONSERV. BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE BENS IMOVEIS. PINTURA - REPAROS E REFORMAS DE IMOVEIS EM GERAL - REPAROS EM INSTALACOES ELETRICAS E HIDRAULICAS - REPAROS, RECUPERACOES E ADAPTACOES DE BIOMBOS, CARPETES, DIVISORIAS E LAMBRIS - MANUTENCAO DE ELEVADORES -LIMPEZA DE FOSSA - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.06.03', 'MANUT. CONSERV. REPARTICOES - EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PARA A MANUTENCAO DE EMBAIXADAS, CONSULADOS, VICE-CONSULADOS, MISSOES DIPLOMATICAS E OUTRAS REPATICOES SEDIADAS NO EXTERIOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.06.04', 'MANUT. CONSERV. VEICULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, MANUTENCAO, CONSERTOS, CONSERVACAO E REVISOES DE VEICULOS, TAIS COMO: ALINHAMENTO E BALANCEAMENTO - ESTOFAMENTO - FUNILARIA - INSTALACAO ELETRICA - LANTERNAGEM - MECANICA - PINTURA - FRANQUIA E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.06.05', 'MANUT. CONSERV. EQUIPAMENTOS DE PROCESSAMENTO DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS - HARDWARE', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.06.06', 'MANUT. CONSERV. MAQUINAS E EQUIPAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COM SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE MAQUINAS E EQUIPAMENTOS. APARELHOS DE FAX E TELEX - APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - CALCULADORAS -ELETRODOMESTICOS - EQUIPAMENTOS DE PROTECAO E SEGURANCA - EQUIPAMENTOS GRAFICOS - EQUIPAMENTOS AGRICOLAS - MAQUINAS DE ESCREVER - TURBINAS EOUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.06.07', 'MANUT. CONSERV. SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTACAO (CORRETIVA OU PREVENTIVA) DE SOFTWARE E RENOVACAO DE LICENCA DE USO, SEM ACRESCIMO DE FUNCOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.06.08', 'MANUT. CONSERV. OUTROS BENS MOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES, INSPECOES E ADAPTACOES DE BENS MOVEIS NAO CONTEMPLADOS EM ITENS ESPECIFICOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.06.99', 'OUTROS SERVICOS DE MANUTENCAO E CONSERVACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS, NAO COMTEMPLADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.07.01', 'APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. - ASSISTENCIA TECNICA - COMISSARIA AEREA E APOIO SOLO - JARDINAGEM- OPERADORES DE MAQUINAS E MOTORISTAS - RECEPCIONISTAS - INSTALACOES DE EQUIPAMENTOS DE SEGURANCA - DA REDE ELETRICA - REDE HIDRAULICA - TELEFONIA - COMUNICACAO E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.07.02', 'LIMPEZA E CONSERVACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERV. DE LIMPEZA,HIGIENIZACAO, COLETA DE LIXO, RETIRADA DE ENTULHO,CONSERV.DEDETIZACAO E ASSEIO DOS ORGAOS PUBLICOS (NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVOFISICO DO PESSOAL A SER UTILIZADO).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.07.03', 'VIGILANCIA OSTENSIVA/ MONITORADA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE VIGILANCIA E SEGURANCA DE REPARTICOES PUBLICAS, DE AUTORIDADES (NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO),DESPESA COM MONITORAMENTO ELETRONICO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.07.04', 'SERVICOS DE MANOBRA E PATRULHAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE DAR SUPORTE AS OPERACOES ESPECIAIS REALIZADAS POR ORGAOS DAS FORCAS ARMADAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.07.05', 'SERVICOS DE SOCORRO E SALVAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS PARA PROTECAO,SOCORRO E SALVAMENTO DE PESSOAS E BENS PUBLICOS. SERVICOS PRESTADOS POR: - AMBULANCIAS PARTICULARES - U.T.I MOVEIS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.07.06', 'SERVICOS DE ESTACIONAMENTO DE VEICULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ESTACIONAMENTO DE VEICULOS, TAIS COMO: ALUGUEIS DE VAGAS, MANOBRISTAS, ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.07.07', 'SERVICOS DOMESTICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DOMESTICOS PRESTADOS POR PESSOA JURIDICA, SEM VINCULO EMPREGATICIO, TAIS COMO: COZINHA - LAVAGEM DE ROUPAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.07.99', 'OUTROS SERVICOS DE APOIO ADM, TECNICO E OPERACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO, NAO COMTEMPLADOS EM ITENS ANTERIORES..', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.08.01', 'SERVICOS DE AGUA E ESGOTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.08.02', 'SERVICOS DE ENERGIA ELETRICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ENERGIA ELETRICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.08.03', 'SERVICOS DE GAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE GAS CANALIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.09.01', 'PROGRAMA DE ALIMENTACAO DO TRABALHADOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE ALIMENTACAO A TRABALHADORES, EM QUE A PESSOA JURIDICA POSSUA PROGRAMA DE ALIMENTACAO APROVADO PELO MINISTERIO DO TRABALHO E POSSA USUFRUIR DE BENEFICIO FISCAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.09.02', 'FORNECIMENTO DE ALIMENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE REFEICOES PREPARADAS, INCLUSIVE LANCHES E SIMILARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.10.01', 'LOCACAO DE IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS E CESSOES DE PREDIOS, SALAS E OUTROS IMOVEIS DE INTERESSE DA ADMINISTRACAO PUBLICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.10.02', 'LOCACAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE PROGRAMAS DE PROCESSAMENTO DE DADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.10.03', 'LOCACAO DE MAQUINAS E EQUIPAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVASCOM ALUGUEIS DE MAQUINAS E EQUIPAMENTOS, TAIS COMO: APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - APARELHOS TELEFONICOS, TELES E FAX -CALCULADORAS - ELETRODOMESTICOS - EQUIPAMENTOS GRAFICOS - MAQUINAS DE ESCREVER -TURBINAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.10.04', 'LOCACAO DE BENS MOVEIS DE OUTRAS NATUREZAS E INTANGIVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE BENS MOVEIS NAO CONTEMPLADOS EM ITENS ESPECIFICOS E BENS INTANGIVEIS. LOCACAO DE LINHA TELEFONICA - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.10.05', 'LOCACAO DE EQUIPAMENTOS DE PROC. DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E PERIFERICOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.10.06', 'TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS TRIBUTOS A CONTA DO LOCATARIO OU DO CESSIONARIO, QUANDO PREVISTOS NO CONTRATO DE LOCACAO OU CESSAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.11.01', 'DESENVOLVIMENTO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ATUALIZACAO E ADAPTACAO DE SOFTWARE, SEM ACRESCIMO DE FUNCOES (NAO EVOLUTIVA), E SEM ALTERACAO SIGNIFICATIVA DE VALOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.11.02', 'SUPORTE DE INFRAESTRUTURA DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE OPERACAO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.11.03', 'SUPORTE A USUARIOS DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS AO ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVICOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVICOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVICOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.11.04', 'HOSPEDAGEM DE SISTEMAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE DATACENTER POR MODELOS COMO HOSTING OU COLOCATION.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.11.05', 'SERVICOS TECNICOS PROFISSIONAIS DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PROFISSIONAIS TECNICOS NA AREA DE TECNOLOGIA DA INFORMACAO, EXCETO QUANDO FOREM CLASSIFICADO EM UMA DAS SEGUINTES CONTAS: DESENVOLVIMENTO DE SOFTWARE; SUPORTE DE INFRAESTRUTURA DE T.I.; SUPORTE A USUARIOS DE T.I.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.12.01', 'VALE- TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS DEVIDO AO FORNECIMENTO DE VALE-TRANSPORTE PARA OS TRABALHADORES DE UMA ENTIDADE, TAIS COMO, SERVIDORES, EMPREGADOS,ESTAGIARIOS, ENTRE OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.12.02', 'TRANSPORTE DE SERVIDORES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUCAO DE TAREFAS PELOS SERVIDORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.12.03', 'FRETE E TRANSPORTE DE ENCOMENDAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE MERCADORIAS E PRODUTOS DIVERSOS, PRESTADOS POR PESSOA JURIDICA. - FRETES E CARRETOS - REMESSA DE ENCOMENDAS E OUTRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.13.00', 'ARMAZENAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ALUGUELDE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, AS VARIACOES PROVENIENTESS DE GARANTIA DOS ESTOQUES ARMAZENADOS E A UTILIZACAO DE SERVICO ESPECIALIZADO NA SOLUCAO DE GESTAO DE ESTOQUE, INCLUINDO GESTAO DE MATERIAIS E TRANSPORTE DE MATERIAIS E EQUIPAMENTOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.14.00', 'ASSINATURAS DE PERIODICOS E ANUIDADES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ASSINATURAS DE TV (TVA CABO), JORNAIS, INCLUSIVE DIARIO OFICIAL, REVISTAS, RECORTES DE PUBLICACOES, SOFTWARE, PODENDO ESTAR NA FORMA DE DISQUETE, CD-ROM, BOLE-INS E OUTROS QUE NAO SE DESTINEM A COLECOES OU BIBLIOTECAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.15.00', 'CAPATAZIA, ESTIVA E PESAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MOVIMENTACAO E PESAGEM DE CARGAS(MERCADORIAS E PRODUTOS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.16.00', 'CLASSIFICACAO DE PRODUTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CLASSIFICACAO DE PRODUTOS DE ORIGEM ANIMAL, MINERAL E VEGETAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.17.00', 'COMISSOES E CORRETAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE VALOR REFERENTE A COMISSOES E CORRETAGENS DECORRENTES DE SERVICOS PRESTADOS POR EMPRESAS DE INTERMEDIACAO E REPRESENTACAO COMERCIAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.18.00', 'CONDOMINIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DAS TAXAS CONDOMINIAIS A CONTA DO PROPRIETARIO, OU DO LOCATARIO, CONFORME PREVISTO NO CONTRATO DE LOCACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.19.00', 'CONFECCAO DE MATERIAL DE ACONDIC. E EMBALAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE MATERIAIS DESTINADOS A PRESERVACAO, ACOMODACAO OU EMBALAGEM DE PRODUTOS DIVERSOS, TAIS COMO: - BOLSAS - CAIXAS - MOCHILAS - SACOLAS E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.20.00', 'CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE:- BANDEIRAS - BRASOES - ESTANDARTES - FLAMULAS - UNIFORMES ( INCLUSIVEAS DESPESAS RELACIONADAS COM AUXILIO FARDAMENTO DESCRITOS NA LEI NUM.8237/91) E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.21.00', 'DIREITOS AUTORAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIREITOS AUTORAIS SOBRE OBRAS CIENTIFICAS, LITERARIAS OU EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.22.00', 'EXPOSICOES, CONGRESSOS, CONFERENCIAS E OUTROS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA INSTALACAO E MANUTENCAO DE: CONFERENCIAS - REUNIOES TECNICAS - CONGRESSOS - EXPOSICOES - FEIRAS - FESTEJOS POPULARES - FESTIVAIS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.23.00', 'FESTIVIDADES E HOMENAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA ORGANIZACAO DE EVENTOS, TAIS COMO: COQUETEIS - FESTAS DE CONGRACAMENTO - RECEPCOES - E OUTRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.24.00', 'HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS HONORARIOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS HONORARIOS ADVOCATICIOS A VENCEDORA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.25.00', 'HOSPEDAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE HOSPEDAGENS E ALIMENTACAO DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS OFICIAIS PAGOS DIRETAMENTE A ESTABELECIMENTOS HOTELEIROS (QUANDO NAO HOUVER PAGAMENTO DE DIARIAS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.26.00', 'PATROCINIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PATROCINIOS A ATIVIDADES OU EVENTOS, DE NATUREZA CULTURAL, ESPORTIVA, EDUCACIONAL, AMBIENTAL, CIENTIFICA,COMUNITARIA, PROMOCIONAL ETC. PARA INFLUENCIAR FAVORAVELMENTE O PUBLICO E/OU ATINGIR OUTROS OBJETIVOS RELACIONADOS COM A PROMOCAO DE ATOS, OBRAS, PLANOS, ACOES, BENS OU SERVICOS. NAO INCLUI O PATROCINIO DE MIDIA, ASSIM CONSIDERADOS AQUELES EM QUE O PROPONENTE E UM VEICULO DE COMUNICACAO OU UM GESTOR DE MEIOS OU INSTALACOES QUE FUNCIONEM COMO VEICULO DE MIDIA ALTERNATIVA E AQUELES EM QUE UM VEICULO DE COMUNICACAO E O UNICO OU O PRINCIPAL REALIZADOR DA ACAO PATROCINADA, AINDA QUE O PROPONENTE DO PROJETO E PROVEDOR DE CONTEUDO PARA A ACAO PATROCINADA NAO SE ENQUADRE NA DEFINICAO DE VEICULO DE COMUNICACAO OU MEIO DE MIDIA ALTERNATIVA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.27.00', 'PRODUCOES JORNALISTICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE EDICAO DE JORNAIS, REVISTAS, NOTICIARIOS E MATERIAIS JORNALISTICOS PARA VIDEOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.28.00', 'PROMOCAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS REALIZADOS POR INTEGRANTES DO SICOM OU POR TERCEIROS, QUE EMPREGUEM RECURSOS DE NAO-MIDIA, REALIZADAS COM OBJETIVO DE INCENTIVAR PUBLICOS DE INTERESSE A CONHECEREM OU COMPRAREM PRODUTOS, SERVICOS, MARCAS, CONCEITOS OU POLITICAS PUBLICAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.29.00', 'SEGUROS EM GERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE PREMIOS PAGOS POR SEGUROS DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS OU BENS DE TERCEIROS, PREMIOS DE SEGUROS DE BENS DO ESTADO OU DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.30.00', 'SELECAO E TREINAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTACAO PROFISSIONAL, RECRUTAMENTO E SELECAO DE PESSOAL(CONCURSO PUBLICO) E TREINAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.31.00', 'SERV.MEDICO-HOSPITALAR,ODONTOL.E LABORATORIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS MEDICO-HOSPITALARES, ODONTOLOGICOS E LABORATORIAIS, PRESTADOS POR PESSOAS JURIDICAS SEM VINCULO EMPREGATICIO, TAIS COMO: ANALISES CLINICAS - CIRURGIAS - CONSULTAS - ECOGRAFIAS - ENDOSCOPIAS -ENFERMAGEM - ESTERILIZACAO - EXAMES DE LABORATORIO - RAIO X -TOMOGRAFIAS - TRATAMENTO ODONTOLOGICO - ULTRASSONOGRAFIAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.32.00', 'SERVICOS BANCARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE COMISSOES, TARIFAS E REMUNERACOES DECORRENTES DE SERVICOS PRESTADOS POR BANCOS, INSTITUICOES FINANCEIRAS E AGENTES FINANCEIROS DO SFH, COMPRENDENDO OS SERVICOS DE ANALISE TECNICA, JURIDICA E DOCUMENTAL DAS PROPOSTAS DE PROJETOS DE ESTADO E MUNICIPIOS, BEM COMO OS CUSTOS DE ACOMPANHAMENTO DAS OBRAS ATE A CONCLUSAO DAS UNIDADES HABITACIONAIS. -BEM COMO DESPESAS COM AGUARDA/CUSTODIA DE VALORES (COFRES DE ALUGUEL)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.33.00', 'SERVICOS DE ANALISES E PESQUISA CIENTIFICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ANALISES FISICO-QUIMICAS E PESQUISAS CIENTIFICAS, NAO RELACIONADAS COM APOIO AO ENSINO. - ANALISES MINERAIS - ANALISES DE SOLO - ANALISES QUIMICAS - COLETA DE DADOS EM EXPERIMENTOS - TRATAMENTO E DESTINACAO DE RESIDUOS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.34.00', 'SERVICOS DE APOIO DO ENSINO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE PROPORCIONAR O DESENVOLVIMENTO E O APERFEICOAMENTO DO ENSINO, EM TODOS OS NIVEIS, INCLUSIVE PESQUISAS EXPERIENCIAS E ASSEMELHADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.35.00', 'SERVICOS DE ASSISTENCIA SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS DE ASSISTENCIA SOCIAL PRESTADA A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES, TAIS COMO: - AJUDA DE CUSTO SUPLETIVA - GENEROS ALIMENTICIOS - DOCUMENTACAO -TRANSPORTE E SEPULTAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.36.00', 'SERVICOS DE AUDIO VIDEO E FOTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE FILMAGENS, GRAVACOES, REVELACOES, AMPLIACOES E REPRODUCOES DE SONS E IMAGENS. - CONFECCAO DE ALBUNS - CONFECCAO DE CRACHAS FUNCIONAIS POR FIRMAS ESPECIALIZADAS - EMOLDURAMENTO DE FOTOGRAFIAS - IMAGENS DE SATELITES- REVELACAO DE FILMES - MICROFILMAGEM E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.37.00', 'SERVICOS DE CARATER SECRETO OU RESERVADO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CARATER SIGILOSO CONSTANTES EM REGULAMENTO DO ORGAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.38.00', 'SERVICOS DE CONFECCAO SELOS CONTROLE FISCAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE SELOS/CHANCELAS PARA CONTROLE FISCAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.39.00', 'SERVICOS DE CONSERV. E REBENEF. DE MERCADORIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS UTILIZADOS NA CONSERVACAO E REBEFICIAMENTO DE MERCADORIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.40.00', 'SERVICOS DE CONTROLE AMBIENTAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONTROLE AMBIENTAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.41.00', 'SERVICOS DE COPIAS E REPRODUCAO DE DOCUMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COPIAS XEROGRAFICAS, INCLUSIVE A LOCACAO E A MANUTENCAO DE EQUIPAMENTOS REPROGRAFICOS, COPIASE REPRODUCOES DE DOCUMENTOS E PUBLICACOES EM GERAL, INCLUSIVE POR MEIO MAGNETICO E DIGITALIZACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.42.00', 'SERVICOS DE CRECHE E ASSISTENCIA PRE ESCOLAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR ENTIDADES DE ASSISTENCIA SOCIAL PARA ATENDER OS DEPENDENTES DE SERVIDORES DO ORGAO, HABILITADOS A USUFRUIREM DESSE BENEFICIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.43.00', 'SERVICOS DE INCINERACAO/DESTRUICAO DE MATERIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICO DE PROCESSO DE INCINERACAO E DESTRUICAO DE MATERIAIS, BEM COMO RESIDUOS INDUSTRIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.44.00', 'SERVICOS DE PRODUCAO INDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE TRANSFORMACAO, BENEFICIAMENTO E INDUSTRIALIZACAO DE MATERIAS-PRIMAS QUE RESULTARAO EM UM PRODUTO FINAL. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.45.00', 'SERVICOS DE REABILITACAO PROFISSIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA JURIDICA, COM O OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE), OS MEIOS INDICADOS PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO. EX: CONTRATACAO DE EMPRESA PARA MINISTRAR CURSO PROFISSIONALIZANTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.46.00', 'SERVICOS DE ITENS REPARAVEIS DE AVIACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVASCOM A CONTRATACAO DE SERVICOS ESPECIFICOS PARA A MANUTENCAO DE ITENS REPARAVEIS DE AVIACAO: ASAS, MOTORES, FUSELAGEM, EQUIPAMENTO DE BORDO, ETC E AINDA, NA RECUPERACAO DE MATERIAL DE AVIACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.47.00', 'SERVICOS FUNERARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REMOCOES, SEPULTAMENTOS E TRANSLADACOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.48.00', 'SERVICOS GRAFICOS E EDITORIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ARTES GRAFICAS PRESTADOS POR PESSOA JURIDICA, BEM COMO COM SERVICOS EDITORIAIS DIVERSOS. - CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS E REVISTAS - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVICOS DE IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVICOS EDITORIAIS DIVERSOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.49.00', 'SERVICOS JUDICIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE CUSTAS PROCESSUAIS DECORRENTES DE ACOES JUDICIAIS, DILIGENCIAS(INCLUSIVE CONDUCAO) SALARIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E OFICIAIS DE JUSTICA E SERVICOS DE CARTORIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.50.00', 'SERVICOS RELACIONADOS A INDUSTRIA AEROESPACIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LANCAMENTO E COLOCACAO EM ORBITA DE SATELITES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.51.00', 'SERVICOS TECNICOS PROFISSIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NAS SEGUINTES AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA -ESTATISTICA E OUTRAS. EXCETO OS SERVICOS DE CONSULTORIA QUE DEVEM SER CLASSIFICADOS EM CONTA ESPECIFICA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.52.00', 'TAXA DE ADMINISTRACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ORGANIZACAO E ADMINISTRACAO PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - TAXA DE ADMINISTRACAO PAGA AO INSTITUTO EUVALDO LODI IEL E AO CEN-TRO DE INTEGRACAO EMPRESA-ESCOLA - CIEE, DECORRENTE DOS SERVICOS DE SELECAO E RECRUTAMENTO DE ESTUDANTES, TENDO COMO OBJETIVO O INGRESSO AO MERCADO DE TRABALHO E PROGRAMAS DE ESTAGIO; - TAXA DE ADMINISTRACAO PATRIMONIAL DAS CONTRIBUICOES DO BANCO CENTRALDO BRASIL, NA QUALIDADE DE PATROCINADOR, DESTINADO AO CUSTEIO DAS APOSENTADORIAS E PENSOES CONCEDIDAS COM BASE NA LEI 8.112/1990, E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.53.00', 'VISTOS CONSULARES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE VISTOS CONSULARES JUNTO A EMBAIXADAS E CONSULADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.54.01', 'LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTENCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGAO, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ASSISTENCIA TECNICA - CAPINA - JARDINAGEM - OPERADORES DE MAQUINA - MOTORISTAS - RECEPCIONISTAS - SERVICOS AUXILIARES E OUTROS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.54.02', 'LOCACAO DE MAO-DE-OBRA DE LIMPEZA E CONSERVACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LIMPEZA E CONSERVACAO EM GERAL, TAIS COMO: LIMPEZA E CONSERVACAO DE IMOVEIS, LAVAGEM DE VEICULOS, LAVAGEM E HIGIENIZACAO DE ROUPAS E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.54.03', 'LOCACAO DE MAO-DE-OBRA DE VIGILANCIA OSTENSIVA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE VIGILANCIA OSTENSIVA NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.54.04', 'LOCACAO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVACAO DE BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE MAO-DE-OBRA PARA EFETUAR REPAROS E REFORMAS DE IMOVEIS EM GERAL, INSTAL. ELETRICAS, HIDRAUL. E CORRELATAS DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DE PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.54.05', 'LOCACAO DE MAO-DE-OBRA DE SERVICOS DE COPA E COZINHA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE MAO-DE-OBRA PARA EFETUAR SERVICOS INERENTES A COPA E COZINHA, TAIS COMO: PREPARO DE ALIMENTACAO, LANCHES, CAFE E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.54.06', 'LOCACAO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.54.07', 'LOCACAO DE MAO-DE-OBRA DE SERVICOS DE BRIGADA DE INCENDIO.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE BRIGADA DE INCENDIO EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.54.08', 'LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO - MENORES-APRENDIZES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTENCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGAO, COM A CONTRATACAO DE MAO-DE-OBRA DE MENORES APRENDIZES. (BASE LEGAL - LEI N. 10.097 DE 19/12/2000). NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.54.09', 'LOCACAO DE MAO-DE-OBRA DE MANUTENCAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS, ATUALIZACAO E ADAPTACAO DE SOFTWARE, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTACAO (CORRETIVA, PREVENTIVA E ADAPTATIVA) DE SOFTWARE E RENOVACAO DE LICENCA DE USO DE SOFTWARE. ADAPTACOES DE SOFTWARE SEM ACRESCIMO DE FUNCOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.54.10', 'LOCACAO DE MAO-DE-OBRA DE SUPORTE DE INFRAESTRUTURA DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE OPERACAO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.54.11', 'LOCACAO DE MAO-DE-OBRA DE SUPORTE A USUARIOS DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVICOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVICOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVICOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.54.99', 'OUTRAS LOCACOES DE MAO DE OBRA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE OUTROS SERVICOS DE LOCACOES DE MAO-DE-OBRA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.55.01', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE MAQUINAS E APARELHOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE MAQUINAS E APARELHOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.55.02', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS FERROVIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS FERROVIARIOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.55.03', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS RODOVIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS RODOVIARIOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.55.04', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE OUTROS BENS MOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE OUTROS BENS MOVEIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.55.05', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE BENS IMOVEIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.55.99', 'OUTROS ARRENDAMENTOS MERCANTIS OPERACIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL, NAO ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.56.01', 'PASSAGENS PARA O PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO PAIS EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.56.02', 'PASSAGENS PARA O EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EM-BARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO EXTERIOR EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.56.03', 'LOCACAO DE MEIOS DE TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DA LOCACAO DE MEIOS DE TRANSPORTE, TAIS COMO: VEICULOS, AERONAVES, EMBARCACOES E ASSEMELHADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.56.04', 'MUDANCAS EM OBJETO DE SERVICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DA LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.56.05', 'LOCOMOCAO URBANA', 'REGISTRA AS APROPRIACOES DE DESPESAS COM LOCOMOCAO URBANA REALIZADA POR MEIO DE ONIBUS, TAXI E OUTROS VEICULOS DE TRANSPORTES URBANOS,PARA ATENDER NECESSIDADE DO SERVICO, COMPREENDENDO, TAMBEM, DESLOCAMENTOS PARA REALIZACAO DE PESQUISAS E REEMBOLSO COM TRANSPORTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.56.06', 'PASSAGENS E LOCOMOCAO NA SUPERVISAO DE VENDAS', 'REGISTRA O VALOR DAS APROPR.DAS DESPESAS COM PASSAGENS E LOCOMOCOES URBANAS NA SUPERVISAO DE VENDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.56.07', 'DESPESAS COM EXCESSO DE BAGAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACOES DE DESPESAS COM EXCESSO DE BAGAGEM ATINENTES AOS VOLUMES E MATERIAIS INDISPENSAVEL A EXECUCAO DO TRABALHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.56.08', 'PEDAGIOS', 'REGISTRA O VALOR DAS DESPESAS COM TARIFAS DE PEDAGIO, TAXA MENSAL PELA UTILIZACAO DO SISTEMA E ADESAO AO SISTEMA DE IDENTIFICACAO DO VEICULO SEM A NECESSIDADE DE PARA-LO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.56.09', 'TRANSPORTE DE SERVIDORES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUCAO DE TAREFAS PELOS SERVIDORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.56.10', 'TAXA DE SERV. EMISSAO BILHETES NAO UTILIZADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS C/ TAXA DE SERVICO PAGA PELA AQUISICAO DE PASSAGENS NAO UTILIZADAS, CANCELADAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.56.99', 'OUTRAS DESPESAS COM LOCOMOCAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS E MEIOS DE TRANSPORTE NAO ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.57.00', 'TAXA SOBRE TERRENO DE MARINHA', 'REGISTRA O VALOR PAGO SOBRE A VENDA DE TERRENOS DE MARINHA, TAIS COMO FORO, LAUDEMIO E TAXA DE OCUPACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.98.00', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE DESPESAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.99.00', 'OUTROS SERVICOS PRESTADOS POR PESSOA JURIDICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA, QUE NAO ESTEJA ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.01.01', 'CONSULTORIA E ASSESSORIA - JURIDICA E TECNICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIA TECNICA OU JURIDICA OU ASSEMELHADA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.01.02', 'CONSULTORIA E ASSESSORIA - TECNOLOGIA DA INFORMACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONSULTORIA OU ASSESSORIA NA AREA DE TECNOLOGIA DA INFORMACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.01.99', 'OUTROS SERVICOS DE CONSULTORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS NAO CONTEMPLADAS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.02.01', 'PERICIAS TECNICAS - JUSTICA GRATUITA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS PARA A JUSTICA GRATUITA, NAS SEGUINTES AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA ESTATISTICA - MEDICINA - VARAS JUDICIAIS DO TRABALHO E OUTRAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.02.02', 'PERICIAS MEDICA, ODONTOLOGICA POR BENEFICIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZACAO DE SERVICOS DE PERICIAS MEDICAS/ODONTO.POR BENEFICIO, DEVIDAS A ENTIDADES MEDICAS/ODONTOLOGICAS CREDENCIADAS,PARA EXAMES REALIZADOS EM SEGURADOS E/OU SERVIDORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.02.99', 'OUTROS SERVICOS DE PERICIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS, NAO CONTEMPLADAS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.03.00', 'AUDITORIA EXTERNA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AUDITORIA EXTERNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.04.01', 'TELECOMUNICACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TELECOMUNICACAO, INCLUSIVE TELEFONIA CELULAR, CENTREX 2000, TARIFA DE HABILITACAO E CARTOES TELEFONICOS PARA APARELHOS DE CELULAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.04.02', 'CORRESPONDENCIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CORRESPONDECIAS, PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - CORREIOS E TELEGRAFOS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.04.03', 'COMUNICACAO DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO DE DADOS: - LOCACAO DE CIRCUITO DE DADOS LOCAIS OU INTERURBANOS PARA ATENDIMENTO DE NOS DE COMUTACAO - CONCENTRACAO E NOS DE ACESSO DA REDE DE COMUNICACAO - SERVICOS DE REDE PRIVATIVA VIRTUAL - SLDD - TOPNET - DATASATPLUS - DATASAT-BI - ATMNET - INTERNET - IP DIRETO - STM400 - FASTNET -REMAV - FRAME-RELAY - SDH.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.04.99', 'OUTROS SERVICOS DE COMUNICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA, NAO COMTEMPLADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.05.01', 'PUBLICIDADE LEGAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE LEGAL, QUE SE REALIZA EM OBEDIENCIA A PRESCRICAO DE LEIS, DECRETOS, PORTARIAS, INSTRUCOES, ESTATUTOS, REGIMENTOS OU REGULAMENTOS INTERNOS DOS INTEGRANTES DO SISTEMA DE COMUNICACAO DE GOVERNO DO PODER EXECUTIVO FEDERAL - SICOM, PRESTADOS POR PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.05.02', 'PUBLICIDADE DE UTILIDADE PUBLICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE REFERENTES A DIVULGACAO DE ACOES DESTINADAS A INFORMAR, ESCLARECER, ORIENTAR, MOBILIZAR, PREVINIR OU ALERTAR A POPULACAO COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE E DE ESTIMULAR A ADOCAO DE COMPORTAMENTOS QUE PERMITAM MELHORAR SUA QUALIDADE DE VIDA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.05.03', 'PUBLICIDADE INSTITUCIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE, PESQUISAS,ASSESSORIA DE IMPRENSA, RELACOES PUBLICAS E COMUNICACAO DIGITAL REFERENTES AA DIVULGACAO DE ATOS, ACOES, PROGRAMAS, OBRAS, SERVICOS, CAMPANHAS METAS E RESULTADOS DOS ORGAOS E ENTIDADES GOVERNAMENTAIS, COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE, VALORIZAR E FORTALECER AS INSTITUICOES, ESTIMULAR A PARTICIPACAO SOCIAL NO DEBATE, NO CONTROLE E NA FORMULACAO DE POLITICAS PUBLICAS E PROMOVER O BRASIL NO EXTERIOR, CONFORME DISPOE O DECRETO 6555/2008', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.05.04', 'PUBLICIDADE MERCADOLOGICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE MERCADOLOGICA, QUE SE DESTINA A LANCAR, MODIFICAR, REPOSICIONAR OU PROMOVER PRODUTOS E SERVICOS DE INTEGRANTES DO SISTEMA DE COMUNICACAO DE GOVERNO DO PODER EXECUTIVO FEDERAL (SICOM), QUE ATUEM NUMA RELACAO DE CONCORRENCIA NO MERCADO, PRESTADOS POR PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.05.99', 'OUTROS SERVICOS DE PUBLICIDADE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE, NAO COMTEMPLADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.06.01', 'MANUT. CONSERV. ESTRADAS E VIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, RECUPERACOES E ADAPTACOES DE ESTRADAS, FERROVIAS E RODOVIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.06.02', 'MANUT. CONSERV. BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE BENS IMOVEIS. PINTURA - REPAROS E REFORMAS DE IMOVEIS EM GERAL - REPAROS EM INSTALACOES ELETRICAS E HIDRAULICAS - REPAROS, RECUPERACOES E ADAPTACOES DE BIOMBOS, CARPETES, DIVISORIAS E LAMBRIS - MANUTENCAO DE ELEVADORES -LIMPEZA DE FOSSA - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.06.03', 'MANUT. CONSERV. REPARTICOES - EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PARA A MANUTENCAO DE EMBAIXADAS, CONSULADOS, VICE-CONSULADOS, MISSOES DIPLOMATICAS E OUTRAS REPATICOES SEDIADAS NO EXTERIOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.06.04', 'MANUT. CONSERV. VEICULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, MANUTENCAO, CONSERTOS, CONSERVACAO E REVISOES DE VEICULOS, TAIS COMO: ALINHAMENTO E BALANCEAMENTO - ESTOFAMENTO - FUNILARIA - INSTALACAO ELETRICA - LANTERNAGEM - MECANICA - PINTURA - FRANQUIA E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.06.05', 'MANUT. CONSERV. EQUIPAMENTOS DE PROCESSAMENTO DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS - HARDWARE', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.06.06', 'MANUT. CONSERV. MAQUINAS E EQUIPAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COM SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE MAQUINAS E EQUIPAMENTOS. APARELHOS DE FAX E TELEX - APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - CALCULADORAS -ELETRODOMESTICOS - EQUIPAMENTOS DE PROTECAO E SEGURANCA - EQUIPAMENTOS GRAFICOS - EQUIPAMENTOS AGRICOLAS - MAQUINAS DE ESCREVER - TURBINAS EOUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.06.07', 'MANUT. CONSERV. SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTACAO (CORRETIVA OU PREVENTIVA) DE SOFTWARE E RENOVACAO DE LICENCA DE USO, SEM ACRESCIMO DE FUNCOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.06.08', 'MANUT. CONSERV. OUTROS BENS MOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES, INSPECOES E ADAPTACOES DE BENS MOVEIS NAO CONTEMPLADOS EM ITENS ESPECIFICOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.06.99', 'OUTROS SERVICOS DE MANUTENCAO E CONSERVACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS, NAO COMTEMPLADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.07.01', 'APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. - ASSISTENCIA TECNICA - COMISSARIA AEREA E APOIO SOLO - JARDINAGEM- OPERADORES DE MAQUINAS E MOTORISTAS - RECEPCIONISTAS - INSTALACOES DE EQUIPAMENTOS DE SEGURANCA - DA REDE ELETRICA - REDE HIDRAULICA - TELEFONIA - COMUNICACAO E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.07.02', 'LIMPEZA E CONSERVACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERV. DE LIMPEZA,HIGIENIZACAO, COLETA DE LIXO, RETIRADA DE ENTULHO,CONSERV.DEDETIZACAO E ASSEIO DOS ORGAOS PUBLICOS (NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVOFISICO DO PESSOAL A SER UTILIZADO).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.07.03', 'VIGILANCIA OSTENSIVA/ MONITORADA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE VIGILANCIA E SEGURANCA DE REPARTICOES PUBLICAS, DE AUTORIDADES (NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO),DESPESA COM MONITORAMENTO ELETRONICO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.07.04', 'SERVICOS DE MANOBRA E PATRULHAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE DAR SUPORTE AS OPERACOES ESPECIAIS REALIZADAS POR ORGAOS DAS FORCAS ARMADAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.07.05', 'SERVICOS DE SOCORRO E SALVAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS PARA PROTECAO,SOCORRO E SALVAMENTO DE PESSOAS E BENS PUBLICOS. SERVICOS PRESTADOS POR: - AMBULANCIAS PARTICULARES - U.T.I MOVEIS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.07.06', 'SERVICOS DE ESTACIONAMENTO DE VEICULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ESTACIONAMENTO DE VEICULOS, TAIS COMO: ALUGUEIS DE VAGAS, MANOBRISTAS, ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.07.07', 'SERVICOS DOMESTICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DOMESTICOS PRESTADOS POR PESSOA JURIDICA, SEM VINCULO EMPREGATICIO, TAIS COMO: COZINHA - LAVAGEM DE ROUPAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.07.99', 'OUTROS SERVICOS DE APOIO ADM, TECNICO E OPERACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO, NAO COMTEMPLADOS EM ITENS ANTERIORES..', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.08.01', 'SERVICOS DE AGUA E ESGOTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.08.02', 'SERVICOS DE ENERGIA ELETRICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ENERGIA ELETRICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.08.03', 'SERVICOS DE GAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE GAS CANALIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.09.01', 'PROGRAMA DE ALIMENTACAO DO TRABALHADOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE ALIMENTACAO A TRABALHADORES, EM QUE A PESSOA JURIDICA POSSUA PROGRAMA DE ALIMENTACAO APROVADO PELO MINISTERIO DO TRABALHO E POSSA USUFRUIR DE BENEFICIO FISCAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.09.02', 'FORNECIMENTO DE ALIMENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE REFEICOES PREPARADAS, INCLUSIVE LANCHES E SIMILARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.10.01', 'LOCACAO DE IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS E CESSOES DE PREDIOS, SALAS E OUTROS IMOVEIS DE INTERESSE DA ADMINISTRACAO PUBLICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.10.02', 'LOCACAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE PROGRAMAS DE PROCESSAMENTO DE DADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.10.03', 'LOCACAO DE MAQUINAS E EQUIPAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVASCOM ALUGUEIS DE MAQUINAS E EQUIPAMENTOS, TAIS COMO: APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - APARELHOS TELEFONICOS, TELES E FAX -CALCULADORAS - ELETRODOMESTICOS - EQUIPAMENTOS GRAFICOS - MAQUINAS DE ESCREVER -TURBINAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.10.04', 'LOCACAO DE BENS MOVEIS DE OUTRAS NATUREZAS E INTANGIVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE BENS MOVEIS NAO CONTEMPLADOS EM ITENS ESPECIFICOS E BENS INTANGIVEIS. LOCACAO DE LINHA TELEFONICA - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.10.05', 'LOCACAO DE EQUIPAMENTOS DE PROC. DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E PERIFERICOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.10.06', 'TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS TRIBUTOS A CONTA DO LOCATARIO OU DO CESSIONARIO, QUANDO PREVISTOS NO CONTRATO DE LOCACAO OU CESSAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.11.01', 'DESENVOLVIMENTO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ATUALIZACAO E ADAPTACAO DE SOFTWARE, SEM ACRESCIMO DE FUNCOES (NAO EVOLUTIVA), E SEM ALTERACAO SIGNIFICATIVA DE VALOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.11.02', 'SUPORTE DE INFRAESTRUTURA DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE OPERACAO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.11.03', 'SUPORTE A USUARIOS DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS AO ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVICOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVICOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVICOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.11.04', 'HOSPEDAGEM DE SISTEMAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE DATACENTER POR MODELOS COMO HOSTING OU COLOCATION.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.11.05', 'SERVICOS TECNICOS PROFISSIONAIS DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PROFISSIONAIS TECNICOS NA AREA DE TECNOLOGIA DA INFORMACAO, EXCETO QUANDO FOREM CLASSIFICADO EM UMA DAS SEGUINTES CONTAS: DESENVOLVIMENTO DE SOFTWARE; SUPORTE DE INFRAESTRUTURA DE T.I.; SUPORTE A USUARIOS DE T.I.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.12.01', 'VALE- TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS DEVIDO AO FORNECIMENTO DE VALE-TRANSPORTE PARA OS TRABALHADORES DE UMA ENTIDADE, TAIS COMO, SERVIDORES, EMPREGADOS,ESTAGIARIOS, ENTRE OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.12.02', 'TRANSPORTE DE SERVIDORES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUCAO DE TAREFAS PELOS SERVIDORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.12.03', 'FRETE E TRANSPORTE DE ENCOMENDAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE MERCADORIAS E PRODUTOS DIVERSOS, PRESTADOS POR PESSOA JURIDICA. - FRETES E CARRETOS - REMESSA DE ENCOMENDAS E OUTRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.13.00', 'ARMAZENAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ALUGUELDE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, AS VARIACOES PROVENIENTESS DE GARANTIA DOS ESTOQUES ARMAZENADOS E A UTILIZACAO DE SERVICO ESPECIALIZADO NA SOLUCAO DE GESTAO DE ESTOQUE, INCLUINDO GESTAO DE MATERIAIS E TRANSPORTE DE MATERIAIS E EQUIPAMENTOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.14.00', 'ASSINATURAS DE PERIODICOS E ANUIDADES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ASSINATURAS DE TV (TVA CABO), JORNAIS, INCLUSIVE DIARIO OFICIAL, REVISTAS, RECORTES DE PUBLICACOES, SOFTWARE, PODENDO ESTAR NA FORMA DE DISQUETE, CD-ROM, BOLE-INS E OUTROS QUE NAO SE DESTINEM A COLECOES OU BIBLIOTECAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.15.00', 'CAPATAZIA, ESTIVA E PESAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MOVIMENTACAO E PESAGEM DE CARGAS(MERCADORIAS E PRODUTOS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.16.00', 'CLASSIFICACAO DE PRODUTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CLASSIFICACAO DE PRODUTOS DE ORIGEM ANIMAL, MINERAL E VEGETAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.17.00', 'COMISSOES E CORRETAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE VALOR REFERENTE A COMISSOES E CORRETAGENS DECORRENTES DE SERVICOS PRESTADOS POR EMPRESAS DE INTERMEDIACAO E REPRESENTACAO COMERCIAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.18.00', 'CONDOMINIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DAS TAXAS CONDOMINIAIS A CONTA DO PROPRIETARIO, OU DO LOCATARIO, CONFORME PREVISTO NO CONTRATO DE LOCACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.19.00', 'CONFECCAO DE MATERIAL DE ACONDIC. E EMBALAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE MATERIAIS DESTINADOS A PRESERVACAO, ACOMODACAO OU EMBALAGEM DE PRODUTOS DIVERSOS, TAIS COMO: - BOLSAS - CAIXAS - MOCHILAS - SACOLAS E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.20.00', 'CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE:- BANDEIRAS - BRASOES - ESTANDARTES - FLAMULAS - UNIFORMES ( INCLUSIVEAS DESPESAS RELACIONADAS COM AUXILIO FARDAMENTO DESCRITOS NA LEI NUM.8237/91) E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.21.00', 'DIREITOS AUTORAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIREITOS AUTORAIS SOBRE OBRAS CIENTIFICAS, LITERARIAS OU EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.22.00', 'EXPOSICOES, CONGRESSOS, CONFERENCIAS E OUTROS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA INSTALACAO E MANUTENCAO DE: CONFERENCIAS - REUNIOES TECNICAS - CONGRESSOS - EXPOSICOES - FEIRAS - FESTEJOS POPULARES - FESTIVAIS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.23.00', 'FESTIVIDADES E HOMENAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA ORGANIZACAO DE EVENTOS, TAIS COMO: COQUETEIS - FESTAS DE CONGRACAMENTO - RECEPCOES - E OUTRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.24.00', 'HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS HONORARIOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS HONORARIOS ADVOCATICIOS A VENCEDORA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.25.00', 'HOSPEDAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE HOSPEDAGENS E ALIMENTACAO DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS OFICIAIS PAGOS DIRETAMENTE A ESTABELECIMENTOS HOTELEIROS (QUANDO NAO HOUVER PAGAMENTO DE DIARIAS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.26.00', 'PATROCINIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PATROCINIOS A ATIVIDADES OU EVENTOS, DE NATUREZA CULTURAL, ESPORTIVA, EDUCACIONAL, AMBIENTAL, CIENTIFICA,COMUNITARIA, PROMOCIONAL ETC. PARA INFLUENCIAR FAVORAVELMENTE O PUBLICO E/OU ATINGIR OUTROS OBJETIVOS RELACIONADOS COM A PROMOCAO DE ATOS, OBRAS, PLANOS, ACOES, BENS OU SERVICOS. NAO INCLUI O PATROCINIO DE MIDIA, ASSIM CONSIDERADOS AQUELES EM QUE O PROPONENTE E UM VEICULO DE COMUNICACAO OU UM GESTOR DE MEIOS OU INSTALACOES QUE FUNCIONEM COMO VEICULO DE MIDIA ALTERNATIVA E AQUELES EM QUE UM VEICULO DE COMUNICACAO E O UNICO OU O PRINCIPAL REALIZADOR DA ACAO PATROCINADA, AINDA QUE O PROPONENTE DO PROJETO E PROVEDOR DE CONTEUDO PARA A ACAO PATROCINADA NAO SE ENQUADRE NA DEFINICAO DE VEICULO DE COMUNICACAO OU MEIO DE MIDIA ALTERNATIVA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.27.00', 'PRODUCOES JORNALISTICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE EDICAO DE JORNAIS, REVISTAS, NOTICIARIOS E MATERIAIS JORNALISTICOS PARA VIDEOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.28.00', 'PROMOCAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS REALIZADOS POR INTEGRANTES DO SICOM OU POR TERCEIROS, QUE EMPREGUEM RECURSOS DE NAO-MIDIA, REALIZADAS COM OBJETIVO DE INCENTIVAR PUBLICOS DE INTERESSE A CONHECEREM OU COMPRAREM PRODUTOS, SERVICOS, MARCAS, CONCEITOS OU POLITICAS PUBLICAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.29.00', 'SEGUROS EM GERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE PREMIOS PAGOS POR SEGUROS DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS OU BENS DE TERCEIROS, PREMIOS DE SEGUROS DE BENS DO ESTADO OU DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.30.00', 'SELECAO E TREINAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTACAO PROFISSIONAL, RECRUTAMENTO E SELECAO DE PESSOAL(CONCURSO PUBLICO) E TREINAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.31.00', 'SERV.MEDICO-HOSPITALAR,ODONTOL.E LABORATORIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS MEDICO-HOSPITALARES, ODONTOLOGICOS E LABORATORIAIS, PRESTADOS POR PESSOAS JURIDICAS SEM VINCULO EMPREGATICIO, TAIS COMO: ANALISES CLINICAS - CIRURGIAS - CONSULTAS - ECOGRAFIAS - ENDOSCOPIAS -ENFERMAGEM - ESTERILIZACAO - EXAMES DE LABORATORIO - RAIO X -TOMOGRAFIAS - TRATAMENTO ODONTOLOGICO - ULTRASSONOGRAFIAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.32.00', 'SERVICOS BANCARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE COMISSOES, TARIFAS E REMUNERACOES DECORRENTES DE SERVICOS PRESTADOS POR BANCOS, INSTITUICOES FINANCEIRAS E AGENTES FINANCEIROS DO SFH, COMPRENDENDO OS SERVICOS DE ANALISE TECNICA, JURIDICA E DOCUMENTAL DAS PROPOSTAS DE PROJETOS DE ESTADO E MUNICIPIOS, BEM COMO OS CUSTOS DE ACOMPANHAMENTO DAS OBRAS ATE A CONCLUSAO DAS UNIDADES HABITACIONAIS. -BEM COMO DESPESAS COM AGUARDA/CUSTODIA DE VALORES (COFRES DE ALUGUEL)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.33.00', 'SERVICOS DE ANALISES E PESQUISA CIENTIFICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ANALISES FISICO-QUIMICAS E PESQUISAS CIENTIFICAS, NAO RELACIONADAS COM APOIO AO ENSINO. - ANALISES MINERAIS - ANALISES DE SOLO - ANALISES QUIMICAS - COLETA DE DADOS EM EXPERIMENTOS - TRATAMENTO E DESTINACAO DE RESIDUOS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.34.00', 'SERVICOS DE APOIO DO ENSINO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE PROPORCIONAR O DESENVOLVIMENTO E O APERFEICOAMENTO DO ENSINO, EM TODOS OS NIVEIS, INCLUSIVE PESQUISAS EXPERIENCIAS E ASSEMELHADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.35.00', 'SERVICOS DE ASSISTENCIA SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS DE ASSISTENCIA SOCIAL PRESTADA A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES, TAIS COMO: - AJUDA DE CUSTO SUPLETIVA - GENEROS ALIMENTICIOS - DOCUMENTACAO -TRANSPORTE E SEPULTAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.36.00', 'SERVICOS DE AUDIO VIDEO E FOTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE FILMAGENS, GRAVACOES, REVELACOES, AMPLIACOES E REPRODUCOES DE SONS E IMAGENS. - CONFECCAO DE ALBUNS - CONFECCAO DE CRACHAS FUNCIONAIS POR FIRMAS ESPECIALIZADAS - EMOLDURAMENTO DE FOTOGRAFIAS - IMAGENS DE SATELITES- REVELACAO DE FILMES - MICROFILMAGEM E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.37.00', 'SERVICOS DE CARATER SECRETO OU RESERVADO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CARATER SIGILOSO CONSTANTES EM REGULAMENTO DO ORGAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.38.00', 'SERVICOS DE CONFECCAO SELOS CONTROLE FISCAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE SELOS/CHANCELAS PARA CONTROLE FISCAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.39.00', 'SERVICOS DE CONSERV. E REBENEF. DE MERCADORIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS UTILIZADOS NA CONSERVACAO E REBEFICIAMENTO DE MERCADORIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.40.00', 'SERVICOS DE CONTROLE AMBIENTAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONTROLE AMBIENTAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.41.00', 'SERVICOS DE COPIAS E REPRODUCAO DE DOCUMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COPIAS XEROGRAFICAS, INCLUSIVE A LOCACAO E A MANUTENCAO DE EQUIPAMENTOS REPROGRAFICOS, COPIASE REPRODUCOES DE DOCUMENTOS E PUBLICACOES EM GERAL, INCLUSIVE POR MEIO MAGNETICO E DIGITALIZACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.42.00', 'SERVICOS DE CRECHE E ASSISTENCIA PRE ESCOLAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR ENTIDADES DE ASSISTENCIA SOCIAL PARA ATENDER OS DEPENDENTES DE SERVIDORES DO ORGAO, HABILITADOS A USUFRUIREM DESSE BENEFICIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.43.00', 'SERVICOS DE INCINERACAO/DESTRUICAO DE MATERIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICO DE PROCESSO DE INCINERACAO E DESTRUICAO DE MATERIAIS, BEM COMO RESIDUOS INDUSTRIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.44.00', 'SERVICOS DE PRODUCAO INDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE TRANSFORMACAO, BENEFICIAMENTO E INDUSTRIALIZACAO DE MATERIAS-PRIMAS QUE RESULTARAO EM UM PRODUTO FINAL. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.45.00', 'SERVICOS DE REABILITACAO PROFISSIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA JURIDICA, COM O OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE), OS MEIOS INDICADOS PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO. EX: CONTRATACAO DE EMPRESA PARA MINISTRAR CURSO PROFISSIONALIZANTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.46.00', 'SERVICOS DE ITENS REPARAVEIS DE AVIACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVASCOM A CONTRATACAO DE SERVICOS ESPECIFICOS PARA A MANUTENCAO DE ITENS REPARAVEIS DE AVIACAO: ASAS, MOTORES, FUSELAGEM, EQUIPAMENTO DE BORDO, ETC E AINDA, NA RECUPERACAO DE MATERIAL DE AVIACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.47.00', 'SERVICOS FUNERARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REMOCOES, SEPULTAMENTOS E TRANSLADACOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.48.00', 'SERVICOS GRAFICOS E EDITORIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ARTES GRAFICAS PRESTADOS POR PESSOA JURIDICA, BEM COMO COM SERVICOS EDITORIAIS DIVERSOS. - CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS E REVISTAS - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVICOS DE IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVICOS EDITORIAIS DIVERSOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.49.00', 'SERVICOS JUDICIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE CUSTAS PROCESSUAIS DECORRENTES DE ACOES JUDICIAIS, DILIGENCIAS(INCLUSIVE CONDUCAO) SALARIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E OFICIAIS DE JUSTICA E SERVICOS DE CARTORIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.50.00', 'SERVICOS RELACIONADOS A INDUSTRIA AEROESPACIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LANCAMENTO E COLOCACAO EM ORBITA DE SATELITES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.51.00', 'SERVICOS TECNICOS PROFISSIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NAS SEGUINTES AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA -ESTATISTICA E OUTRAS. EXCETO OS SERVICOS DE CONSULTORIA QUE DEVEM SER CLASSIFICADOS EM CONTA ESPECIFICA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.52.00', 'TAXA DE ADMINISTRACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ORGANIZACAO E ADMINISTRACAO PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - TAXA DE ADMINISTRACAO PAGA AO INSTITUTO EUVALDO LODI IEL E AO CEN-TRO DE INTEGRACAO EMPRESA-ESCOLA - CIEE, DECORRENTE DOS SERVICOS DE SELECAO E RECRUTAMENTO DE ESTUDANTES, TENDO COMO OBJETIVO O INGRESSO AO MERCADO DE TRABALHO E PROGRAMAS DE ESTAGIO; - TAXA DE ADMINISTRACAO PATRIMONIAL DAS CONTRIBUICOES DO BANCO CENTRALDO BRASIL, NA QUALIDADE DE PATROCINADOR, DESTINADO AO CUSTEIO DAS APOSENTADORIAS E PENSOES CONCEDIDAS COM BASE NA LEI 8.112/1990, E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.53.00', 'VISTOS CONSULARES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE VISTOS CONSULARES JUNTO A EMBAIXADAS E CONSULADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.54.01', 'LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTENCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGAO, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ASSISTENCIA TECNICA - CAPINA - JARDINAGEM - OPERADORES DE MAQUINA - MOTORISTAS - RECEPCIONISTAS - SERVICOS AUXILIARES E OUTROS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.54.02', 'LOCACAO DE MAO-DE-OBRA DE LIMPEZA E CONSERVACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LIMPEZA E CONSERVACAO EM GERAL, TAIS COMO: LIMPEZA E CONSERVACAO DE IMOVEIS, LAVAGEM DE VEICULOS, LAVAGEM E HIGIENIZACAO DE ROUPAS E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.54.03', 'LOCACAO DE MAO-DE-OBRA DE VIGILANCIA OSTENSIVA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE VIGILANCIA OSTENSIVA NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.54.04', 'LOCACAO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVACAO DE BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE MAO-DE-OBRA PARA EFETUAR REPAROS E REFORMAS DE IMOVEIS EM GERAL, INSTAL. ELETRICAS, HIDRAUL. E CORRELATAS DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DE PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.54.05', 'LOCACAO DE MAO-DE-OBRA DE SERVICOS DE COPA E COZINHA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE MAO-DE-OBRA PARA EFETUAR SERVICOS INERENTES A COPA E COZINHA, TAIS COMO: PREPARO DE ALIMENTACAO, LANCHES, CAFE E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.54.06', 'LOCACAO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.54.07', 'LOCACAO DE MAO-DE-OBRA DE SERVICOS DE BRIGADA DE INCENDIO.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE BRIGADA DE INCENDIO EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.54.08', 'LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO - MENORES-APRENDIZES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTENCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGAO, COM A CONTRATACAO DE MAO-DE-OBRA DE MENORES APRENDIZES. (BASE LEGAL - LEI N. 10.097 DE 19/12/2000). NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.54.09', 'LOCACAO DE MAO-DE-OBRA DE MANUTENCAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS, ATUALIZACAO E ADAPTACAO DE SOFTWARE, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTACAO (CORRETIVA, PREVENTIVA E ADAPTATIVA) DE SOFTWARE E RENOVACAO DE LICENCA DE USO DE SOFTWARE. ADAPTACOES DE SOFTWARE SEM ACRESCIMO DE FUNCOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.54.10', 'LOCACAO DE MAO-DE-OBRA DE SUPORTE DE INFRAESTRUTURA DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE OPERACAO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.54.11', 'LOCACAO DE MAO-DE-OBRA DE SUPORTE A USUARIOS DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVICOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVICOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVICOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.54.99', 'OUTRAS LOCACOES DE MAO DE OBRA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE OUTROS SERVICOS DE LOCACOES DE MAO-DE-OBRA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.55.01', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE MAQUINAS E APARELHOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE MAQUINAS E APARELHOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.55.02', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS FERROVIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS FERROVIARIOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.55.03', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS RODOVIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS RODOVIARIOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.55.04', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE OUTROS BENS MOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE OUTROS BENS MOVEIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.55.05', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE BENS IMOVEIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.55.99', 'OUTROS ARRENDAMENTOS MERCANTIS OPERACIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL, NAO ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.56.01', 'PASSAGENS PARA O PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO PAIS EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.56.02', 'PASSAGENS PARA O EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EM-BARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO EXTERIOR EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.56.03', 'LOCACAO DE MEIOS DE TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DA LOCACAO DE MEIOS DE TRANSPORTE, TAIS COMO: VEICULOS, AERONAVES, EMBARCACOES E ASSEMELHADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.56.04', 'MUDANCAS EM OBJETO DE SERVICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DA LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.56.05', 'LOCOMOCAO URBANA', 'REGISTRA AS APROPRIACOES DE DESPESAS COM LOCOMOCAO URBANA REALIZADA POR MEIO DE ONIBUS, TAXI E OUTROS VEICULOS DE TRANSPORTES URBANOS,PARA ATENDER NECESSIDADE DO SERVICO, COMPREENDENDO, TAMBEM, DESLOCAMENTOS PARA REALIZACAO DE PESQUISAS E REEMBOLSO COM TRANSPORTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.56.06', 'PASSAGENS E LOCOMOCAO NA SUPERVISAO DE VENDAS', 'REGISTRA O VALOR DAS APROPR.DAS DESPESAS COM PASSAGENS E LOCOMOCOES URBANAS NA SUPERVISAO DE VENDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.56.07', 'DESPESAS COM EXCESSO DE BAGAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACOES DE DESPESAS COM EXCESSO DE BAGAGEM ATINENTES AOS VOLUMES E MATERIAIS INDISPENSAVEL A EXECUCAO DO TRABALHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.56.08', 'PEDAGIOS', 'REGISTRA O VALOR DAS DESPESAS COM TARIFAS DE PEDAGIO, TAXA MENSAL PELA UTILIZACAO DO SISTEMA E ADESAO AO SISTEMA DE IDENTIFICACAO DO VEICULO SEM A NECESSIDADE DE PARA-LO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.56.09', 'TRANSPORTE DE SERVIDORES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUCAO DE TAREFAS PELOS SERVIDORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.56.10', 'TAXA DE SERV. EMISSAO BILHETES NAO UTILIZADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS C/ TAXA DE SERVICO PAGA PELA AQUISICAO DE PASSAGENS NAO UTILIZADAS, CANCELADAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.56.99', 'OUTRAS DESPESAS COM LOCOMOCAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS E MEIOS DE TRANSPORTE NAO ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.98.00', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE DESPESAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.99.00', 'OUTROS SERVICOS PRESTADOS POR PESSOA JURIDICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA, QUE NAO ESTEJA ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.01.01', 'CONSULTORIA E ASSESSORIA - JURIDICA E TECNICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIA TECNICA OU JURIDICA OU ASSEMELHADA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.01.02', 'CONSULTORIA E ASSESSORIA - TECNOLOGIA DA INFORMACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONSULTORIA OU ASSESSORIA NA AREA DE TECNOLOGIA DA INFORMACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.01.99', 'OUTROS SERVICOS DE CONSULTORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS NAO CONTEMPLADAS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.02.01', 'PERICIAS TECNICAS - JUSTICA GRATUITA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS PARA A JUSTICA GRATUITA, NAS SEGUINTES AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA ESTATISTICA - MEDICINA - VARAS JUDICIAIS DO TRABALHO E OUTRAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.02.02', 'PERICIAS MEDICA, ODONTOLOGICA POR BENEFICIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZACAO DE SERVICOS DE PERICIAS MEDICAS/ODONTO.POR BENEFICIO, DEVIDAS A ENTIDADES MEDICAS/ODONTOLOGICAS CREDENCIADAS,PARA EXAMES REALIZADOS EM SEGURADOS E/OU SERVIDORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.02.99', 'OUTROS SERVICOS DE PERICIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS, NAO CONTEMPLADAS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.03.00', 'AUDITORIA EXTERNA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AUDITORIA EXTERNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.04.01', 'TELECOMUNICACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TELECOMUNICACAO, INCLUSIVE TELEFONIA CELULAR, CENTREX 2000, TARIFA DE HABILITACAO E CARTOES TELEFONICOS PARA APARELHOS DE CELULAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.04.02', 'CORRESPONDENCIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CORRESPONDECIAS, PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - CORREIOS E TELEGRAFOS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.04.03', 'COMUNICACAO DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO DE DADOS: - LOCACAO DE CIRCUITO DE DADOS LOCAIS OU INTERURBANOS PARA ATENDIMENTO DE NOS DE COMUTACAO - CONCENTRACAO E NOS DE ACESSO DA REDE DE COMUNICACAO - SERVICOS DE REDE PRIVATIVA VIRTUAL - SLDD - TOPNET - DATASATPLUS - DATASAT-BI - ATMNET - INTERNET - IP DIRETO - STM400 - FASTNET -REMAV - FRAME-RELAY - SDH.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.04.99', 'OUTROS SERVICOS DE COMUNICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA, NAO COMTEMPLADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.05.01', 'PUBLICIDADE LEGAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE LEGAL, QUE SE REALIZA EM OBEDIENCIA A PRESCRICAO DE LEIS, DECRETOS, PORTARIAS, INSTRUCOES, ESTATUTOS, REGIMENTOS OU REGULAMENTOS INTERNOS DOS INTEGRANTES DO SISTEMA DE COMUNICACAO DE GOVERNO DO PODER EXECUTIVO FEDERAL - SICOM, PRESTADOS POR PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.05.02', 'PUBLICIDADE DE UTILIDADE PUBLICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE REFERENTES A DIVULGACAO DE ACOES DESTINADAS A INFORMAR, ESCLARECER, ORIENTAR, MOBILIZAR, PREVINIR OU ALERTAR A POPULACAO COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE E DE ESTIMULAR A ADOCAO DE COMPORTAMENTOS QUE PERMITAM MELHORAR SUA QUALIDADE DE VIDA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.05.03', 'PUBLICIDADE INSTITUCIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE, PESQUISAS,ASSESSORIA DE IMPRENSA, RELACOES PUBLICAS E COMUNICACAO DIGITAL REFERENTES AA DIVULGACAO DE ATOS, ACOES, PROGRAMAS, OBRAS, SERVICOS, CAMPANHAS METAS E RESULTADOS DOS ORGAOS E ENTIDADES GOVERNAMENTAIS, COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE, VALORIZAR E FORTALECER AS INSTITUICOES, ESTIMULAR A PARTICIPACAO SOCIAL NO DEBATE, NO CONTROLE E NA FORMULACAO DE POLITICAS PUBLICAS E PROMOVER O BRASIL NO EXTERIOR, CONFORME DISPOE O DECRETO 6555/2008', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.05.04', 'PUBLICIDADE MERCADOLOGICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE MERCADOLOGICA, QUE SE DESTINA A LANCAR, MODIFICAR, REPOSICIONAR OU PROMOVER PRODUTOS E SERVICOS DE INTEGRANTES DO SISTEMA DE COMUNICACAO DE GOVERNO DO PODER EXECUTIVO FEDERAL (SICOM), QUE ATUEM NUMA RELACAO DE CONCORRENCIA NO MERCADO, PRESTADOS POR PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.05.99', 'OUTROS SERVICOS DE PUBLICIDADE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE, NAO COMTEMPLADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.06.01', 'MANUT. CONSERV. ESTRADAS E VIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, RECUPERACOES E ADAPTACOES DE ESTRADAS, FERROVIAS E RODOVIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.06.02', 'MANUT. CONSERV. BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE BENS IMOVEIS. PINTURA - REPAROS E REFORMAS DE IMOVEIS EM GERAL - REPAROS EM INSTALACOES ELETRICAS E HIDRAULICAS - REPAROS, RECUPERACOES E ADAPTACOES DE BIOMBOS, CARPETES, DIVISORIAS E LAMBRIS - MANUTENCAO DE ELEVADORES -LIMPEZA DE FOSSA - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.06.03', 'MANUT. CONSERV. REPARTICOES - EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PARA A MANUTENCAO DE EMBAIXADAS, CONSULADOS, VICE-CONSULADOS, MISSOES DIPLOMATICAS E OUTRAS REPATICOES SEDIADAS NO EXTERIOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.06.04', 'MANUT. CONSERV. VEICULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, MANUTENCAO, CONSERTOS, CONSERVACAO E REVISOES DE VEICULOS, TAIS COMO: ALINHAMENTO E BALANCEAMENTO - ESTOFAMENTO - FUNILARIA - INSTALACAO ELETRICA - LANTERNAGEM - MECANICA - PINTURA - FRANQUIA E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.06.05', 'MANUT. CONSERV. EQUIPAMENTOS DE PROCESSAMENTO DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS - HARDWARE', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.06.06', 'MANUT. CONSERV. MAQUINAS E EQUIPAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COM SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE MAQUINAS E EQUIPAMENTOS. APARELHOS DE FAX E TELEX - APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - CALCULADORAS -ELETRODOMESTICOS - EQUIPAMENTOS DE PROTECAO E SEGURANCA - EQUIPAMENTOS GRAFICOS - EQUIPAMENTOS AGRICOLAS - MAQUINAS DE ESCREVER - TURBINAS EOUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.06.07', 'MANUT. CONSERV. SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTACAO (CORRETIVA OU PREVENTIVA) DE SOFTWARE E RENOVACAO DE LICENCA DE USO, SEM ACRESCIMO DE FUNCOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.06.08', 'MANUT. CONSERV. OUTROS BENS MOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES, INSPECOES E ADAPTACOES DE BENS MOVEIS NAO CONTEMPLADOS EM ITENS ESPECIFICOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.06.99', 'OUTROS SERVICOS DE MANUTENCAO E CONSERVACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS, NAO COMTEMPLADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.07.01', 'APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. - ASSISTENCIA TECNICA - COMISSARIA AEREA E APOIO SOLO - JARDINAGEM- OPERADORES DE MAQUINAS E MOTORISTAS - RECEPCIONISTAS - INSTALACOES DE EQUIPAMENTOS DE SEGURANCA - DA REDE ELETRICA - REDE HIDRAULICA - TELEFONIA - COMUNICACAO E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.07.02', 'LIMPEZA E CONSERVACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERV. DE LIMPEZA,HIGIENIZACAO, COLETA DE LIXO, RETIRADA DE ENTULHO,CONSERV.DEDETIZACAO E ASSEIO DOS ORGAOS PUBLICOS (NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVOFISICO DO PESSOAL A SER UTILIZADO).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.07.03', 'VIGILANCIA OSTENSIVA/ MONITORADA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE VIGILANCIA E SEGURANCA DE REPARTICOES PUBLICAS, DE AUTORIDADES (NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO),DESPESA COM MONITORAMENTO ELETRONICO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.07.04', 'SERVICOS DE MANOBRA E PATRULHAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE DAR SUPORTE AS OPERACOES ESPECIAIS REALIZADAS POR ORGAOS DAS FORCAS ARMADAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.07.05', 'SERVICOS DE SOCORRO E SALVAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS PARA PROTECAO,SOCORRO E SALVAMENTO DE PESSOAS E BENS PUBLICOS. SERVICOS PRESTADOS POR: - AMBULANCIAS PARTICULARES - U.T.I MOVEIS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.07.06', 'SERVICOS DE ESTACIONAMENTO DE VEICULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ESTACIONAMENTO DE VEICULOS, TAIS COMO: ALUGUEIS DE VAGAS, MANOBRISTAS, ETC.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.07.07', 'SERVICOS DOMESTICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DOMESTICOS PRESTADOS POR PESSOA JURIDICA, SEM VINCULO EMPREGATICIO, TAIS COMO: COZINHA - LAVAGEM DE ROUPAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.07.99', 'OUTROS SERVICOS DE APOIO ADM, TECNICO E OPERACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO, NAO COMTEMPLADOS EM ITENS ANTERIORES..', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.08.01', 'SERVICOS DE AGUA E ESGOTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.08.02', 'SERVICOS DE ENERGIA ELETRICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ENERGIA ELETRICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.08.03', 'SERVICOS DE GAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE GAS CANALIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.09.01', 'PROGRAMA DE ALIMENTACAO DO TRABALHADOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE ALIMENTACAO A TRABALHADORES, EM QUE A PESSOA JURIDICA POSSUA PROGRAMA DE ALIMENTACAO APROVADO PELO MINISTERIO DO TRABALHO E POSSA USUFRUIR DE BENEFICIO FISCAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.09.02', 'FORNECIMENTO DE ALIMENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE REFEICOES PREPARADAS, INCLUSIVE LANCHES E SIMILARES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.10.01', 'LOCACAO DE IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS E CESSOES DE PREDIOS, SALAS E OUTROS IMOVEIS DE INTERESSE DA ADMINISTRACAO PUBLICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.10.02', 'LOCACAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE PROGRAMAS DE PROCESSAMENTO DE DADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.10.03', 'LOCACAO DE MAQUINAS E EQUIPAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVASCOM ALUGUEIS DE MAQUINAS E EQUIPAMENTOS, TAIS COMO: APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - APARELHOS TELEFONICOS, TELES E FAX -CALCULADORAS - ELETRODOMESTICOS - EQUIPAMENTOS GRAFICOS - MAQUINAS DE ESCREVER -TURBINAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.10.04', 'LOCACAO DE BENS MOVEIS DE OUTRAS NATUREZAS E INTANGIVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE BENS MOVEIS NAO CONTEMPLADOS EM ITENS ESPECIFICOS E BENS INTANGIVEIS. LOCACAO DE LINHA TELEFONICA - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.10.05', 'LOCACAO DE EQUIPAMENTOS DE PROC. DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E PERIFERICOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.10.06', 'TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS TRIBUTOS A CONTA DO LOCATARIO OU DO CESSIONARIO, QUANDO PREVISTOS NO CONTRATO DE LOCACAO OU CESSAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.11.01', 'DESENVOLVIMENTO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ATUALIZACAO E ADAPTACAO DE SOFTWARE, SEM ACRESCIMO DE FUNCOES (NAO EVOLUTIVA), E SEM ALTERACAO SIGNIFICATIVA DE VALOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.11.02', 'SUPORTE DE INFRAESTRUTURA DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE OPERACAO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.11.03', 'SUPORTE A USUARIOS DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS AO ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVICOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVICOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVICOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.11.04', 'HOSPEDAGEM DE SISTEMAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE DATACENTER POR MODELOS COMO HOSTING OU COLOCATION.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.11.05', 'SERVICOS TECNICOS PROFISSIONAIS DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PROFISSIONAIS TECNICOS NA AREA DE TECNOLOGIA DA INFORMACAO, EXCETO QUANDO FOREM CLASSIFICADO EM UMA DAS SEGUINTES CONTAS: DESENVOLVIMENTO DE SOFTWARE; SUPORTE DE INFRAESTRUTURA DE T.I.; SUPORTE A USUARIOS DE T.I.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.12.01', 'VALE- TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS DEVIDO AO FORNECIMENTO DE VALE-TRANSPORTE PARA OS TRABALHADORES DE UMA ENTIDADE, TAIS COMO, SERVIDORES, EMPREGADOS,ESTAGIARIOS, ENTRE OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.12.02', 'TRANSPORTE DE SERVIDORES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUCAO DE TAREFAS PELOS SERVIDORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.12.03', 'FRETE E TRANSPORTE DE ENCOMENDAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE MERCADORIAS E PRODUTOS DIVERSOS, PRESTADOS POR PESSOA JURIDICA. - FRETES E CARRETOS - REMESSA DE ENCOMENDAS E OUTRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.13.00', 'ARMAZENAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ALUGUELDE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, AS VARIACOES PROVENIENTESS DE GARANTIA DOS ESTOQUES ARMAZENADOS E A UTILIZACAO DE SERVICO ESPECIALIZADO NA SOLUCAO DE GESTAO DE ESTOQUE, INCLUINDO GESTAO DE MATERIAIS E TRANSPORTE DE MATERIAIS E EQUIPAMENTOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.14.00', 'ASSINATURAS DE PERIODICOS E ANUIDADES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ASSINATURAS DE TV (TVA CABO), JORNAIS, INCLUSIVE DIARIO OFICIAL, REVISTAS, RECORTES DE PUBLICACOES, SOFTWARE, PODENDO ESTAR NA FORMA DE DISQUETE, CD-ROM, BOLE-INS E OUTROS QUE NAO SE DESTINEM A COLECOES OU BIBLIOTECAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.15.00', 'CAPATAZIA, ESTIVA E PESAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MOVIMENTACAO E PESAGEM DE CARGAS(MERCADORIAS E PRODUTOS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.16.00', 'CLASSIFICACAO DE PRODUTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CLASSIFICACAO DE PRODUTOS DE ORIGEM ANIMAL, MINERAL E VEGETAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.17.00', 'COMISSOES E CORRETAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE VALOR REFERENTE A COMISSOES E CORRETAGENS DECORRENTES DE SERVICOS PRESTADOS POR EMPRESAS DE INTERMEDIACAO E REPRESENTACAO COMERCIAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.18.00', 'CONDOMINIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DAS TAXAS CONDOMINIAIS A CONTA DO PROPRIETARIO, OU DO LOCATARIO, CONFORME PREVISTO NO CONTRATO DE LOCACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.19.00', 'CONFECCAO DE MATERIAL DE ACONDIC. E EMBALAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE MATERIAIS DESTINADOS A PRESERVACAO, ACOMODACAO OU EMBALAGEM DE PRODUTOS DIVERSOS, TAIS COMO: - BOLSAS - CAIXAS - MOCHILAS - SACOLAS E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.20.00', 'CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE:- BANDEIRAS - BRASOES - ESTANDARTES - FLAMULAS - UNIFORMES ( INCLUSIVEAS DESPESAS RELACIONADAS COM AUXILIO FARDAMENTO DESCRITOS NA LEI NUM.8237/91) E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.21.00', 'DIREITOS AUTORAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIREITOS AUTORAIS SOBRE OBRAS CIENTIFICAS, LITERARIAS OU EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.22.00', 'EXPOSICOES, CONGRESSOS, CONFERENCIAS E OUTROS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA INSTALACAO E MANUTENCAO DE: CONFERENCIAS - REUNIOES TECNICAS - CONGRESSOS - EXPOSICOES - FEIRAS - FESTEJOS POPULARES - FESTIVAIS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.23.00', 'FESTIVIDADES E HOMENAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA ORGANIZACAO DE EVENTOS, TAIS COMO: COQUETEIS - FESTAS DE CONGRACAMENTO - RECEPCOES - E OUTRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.24.00', 'HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS HONORARIOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS HONORARIOS ADVOCATICIOS A VENCEDORA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.25.00', 'HOSPEDAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE HOSPEDAGENS E ALIMENTACAO DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS OFICIAIS PAGOS DIRETAMENTE A ESTABELECIMENTOS HOTELEIROS (QUANDO NAO HOUVER PAGAMENTO DE DIARIAS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.26.00', 'PATROCINIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PATROCINIOS A ATIVIDADES OU EVENTOS, DE NATUREZA CULTURAL, ESPORTIVA, EDUCACIONAL, AMBIENTAL, CIENTIFICA,COMUNITARIA, PROMOCIONAL ETC. PARA INFLUENCIAR FAVORAVELMENTE O PUBLICO E/OU ATINGIR OUTROS OBJETIVOS RELACIONADOS COM A PROMOCAO DE ATOS, OBRAS, PLANOS, ACOES, BENS OU SERVICOS. NAO INCLUI O PATROCINIO DE MIDIA, ASSIM CONSIDERADOS AQUELES EM QUE O PROPONENTE E UM VEICULO DE COMUNICACAO OU UM GESTOR DE MEIOS OU INSTALACOES QUE FUNCIONEM COMO VEICULO DE MIDIA ALTERNATIVA E AQUELES EM QUE UM VEICULO DE COMUNICACAO E O UNICO OU O PRINCIPAL REALIZADOR DA ACAO PATROCINADA, AINDA QUE O PROPONENTE DO PROJETO E PROVEDOR DE CONTEUDO PARA A ACAO PATROCINADA NAO SE ENQUADRE NA DEFINICAO DE VEICULO DE COMUNICACAO OU MEIO DE MIDIA ALTERNATIVA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.27.00', 'PRODUCOES JORNALISTICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE EDICAO DE JORNAIS, REVISTAS, NOTICIARIOS E MATERIAIS JORNALISTICOS PARA VIDEOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.28.00', 'PROMOCAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS REALIZADOS POR INTEGRANTES DO SICOM OU POR TERCEIROS, QUE EMPREGUEM RECURSOS DE NAO-MIDIA, REALIZADAS COM OBJETIVO DE INCENTIVAR PUBLICOS DE INTERESSE A CONHECEREM OU COMPRAREM PRODUTOS, SERVICOS, MARCAS, CONCEITOS OU POLITICAS PUBLICAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.29.00', 'SEGUROS EM GERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE PREMIOS PAGOS POR SEGUROS DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS OU BENS DE TERCEIROS, PREMIOS DE SEGUROS DE BENS DO ESTADO OU DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.30.00', 'SELECAO E TREINAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTACAO PROFISSIONAL, RECRUTAMENTO E SELECAO DE PESSOAL(CONCURSO PUBLICO) E TREINAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.31.00', 'SERV.MEDICO-HOSPITALAR,ODONTOL.E LABORATORIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS MEDICO-HOSPITALARES, ODONTOLOGICOS E LABORATORIAIS, PRESTADOS POR PESSOAS JURIDICAS SEM VINCULO EMPREGATICIO, TAIS COMO: ANALISES CLINICAS - CIRURGIAS - CONSULTAS - ECOGRAFIAS - ENDOSCOPIAS -ENFERMAGEM - ESTERILIZACAO - EXAMES DE LABORATORIO - RAIO X -TOMOGRAFIAS - TRATAMENTO ODONTOLOGICO - ULTRASSONOGRAFIAS - E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.32.00', 'SERVICOS BANCARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE COMISSOES, TARIFAS E REMUNERACOES DECORRENTES DE SERVICOS PRESTADOS POR BANCOS, INSTITUICOES FINANCEIRAS E AGENTES FINANCEIROS DO SFH, COMPRENDENDO OS SERVICOS DE ANALISE TECNICA, JURIDICA E DOCUMENTAL DAS PROPOSTAS DE PROJETOS DE ESTADO E MUNICIPIOS, BEM COMO OS CUSTOS DE ACOMPANHAMENTO DAS OBRAS ATE A CONCLUSAO DAS UNIDADES HABITACIONAIS. -BEM COMO DESPESAS COM AGUARDA/CUSTODIA DE VALORES (COFRES DE ALUGUEL)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.33.00', 'SERVICOS DE ANALISES E PESQUISA CIENTIFICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ANALISES FISICO-QUIMICAS E PESQUISAS CIENTIFICAS, NAO RELACIONADAS COM APOIO AO ENSINO. - ANALISES MINERAIS - ANALISES DE SOLO - ANALISES QUIMICAS - COLETA DE DADOS EM EXPERIMENTOS - TRATAMENTO E DESTINACAO DE RESIDUOS E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.34.00', 'SERVICOS DE APOIO DO ENSINO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE PROPORCIONAR O DESENVOLVIMENTO E O APERFEICOAMENTO DO ENSINO, EM TODOS OS NIVEIS, INCLUSIVE PESQUISAS EXPERIENCIAS E ASSEMELHADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.35.00', 'SERVICOS DE ASSISTENCIA SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS DE ASSISTENCIA SOCIAL PRESTADA A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES, TAIS COMO: - AJUDA DE CUSTO SUPLETIVA - GENEROS ALIMENTICIOS - DOCUMENTACAO -TRANSPORTE E SEPULTAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.36.00', 'SERVICOS DE AUDIO VIDEO E FOTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE FILMAGENS, GRAVACOES, REVELACOES, AMPLIACOES E REPRODUCOES DE SONS E IMAGENS. - CONFECCAO DE ALBUNS - CONFECCAO DE CRACHAS FUNCIONAIS POR FIRMAS ESPECIALIZADAS - EMOLDURAMENTO DE FOTOGRAFIAS - IMAGENS DE SATELITES- REVELACAO DE FILMES - MICROFILMAGEM E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.37.00', 'SERVICOS DE CARATER SECRETO OU RESERVADO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CARATER SIGILOSO CONSTANTES EM REGULAMENTO DO ORGAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.38.00', 'SERVICOS DE CONFECCAO SELOS CONTROLE FISCAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE SELOS/CHANCELAS PARA CONTROLE FISCAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.39.00', 'SERVICOS DE CONSERV. E REBENEF. DE MERCADORIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS UTILIZADOS NA CONSERVACAO E REBEFICIAMENTO DE MERCADORIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.40.00', 'SERVICOS DE CONTROLE AMBIENTAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONTROLE AMBIENTAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.41.00', 'SERVICOS DE COPIAS E REPRODUCAO DE DOCUMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COPIAS XEROGRAFICAS, INCLUSIVE A LOCACAO E A MANUTENCAO DE EQUIPAMENTOS REPROGRAFICOS, COPIASE REPRODUCOES DE DOCUMENTOS E PUBLICACOES EM GERAL, INCLUSIVE POR MEIO MAGNETICO E DIGITALIZACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.42.00', 'SERVICOS DE CRECHE E ASSISTENCIA PRE ESCOLAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR ENTIDADES DE ASSISTENCIA SOCIAL PARA ATENDER OS DEPENDENTES DE SERVIDORES DO ORGAO, HABILITADOS A USUFRUIREM DESSE BENEFICIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.43.00', 'SERVICOS DE INCINERACAO/DESTRUICAO DE MATERIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICO DE PROCESSO DE INCINERACAO E DESTRUICAO DE MATERIAIS, BEM COMO RESIDUOS INDUSTRIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.44.00', 'SERVICOS DE PRODUCAO INDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE TRANSFORMACAO, BENEFICIAMENTO E INDUSTRIALIZACAO DE MATERIAS-PRIMAS QUE RESULTARAO EM UM PRODUTO FINAL. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.45.00', 'SERVICOS DE REABILITACAO PROFISSIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA JURIDICA, COM O OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE), OS MEIOS INDICADOS PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO. EX: CONTRATACAO DE EMPRESA PARA MINISTRAR CURSO PROFISSIONALIZANTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.46.00', 'SERVICOS DE ITENS REPARAVEIS DE AVIACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVASCOM A CONTRATACAO DE SERVICOS ESPECIFICOS PARA A MANUTENCAO DE ITENS REPARAVEIS DE AVIACAO: ASAS, MOTORES, FUSELAGEM, EQUIPAMENTO DE BORDO, ETC E AINDA, NA RECUPERACAO DE MATERIAL DE AVIACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.48.00', 'SERVICOS GRAFICOS E EDITORIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ARTES GRAFICAS PRESTADOS POR PESSOA JURIDICA, BEM COMO COM SERVICOS EDITORIAIS DIVERSOS. - CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS E REVISTAS - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVICOS DE IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVICOS EDITORIAIS DIVERSOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.49.00', 'SERVICOS JUDICIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE CUSTAS PROCESSUAIS DECORRENTES DE ACOES JUDICIAIS, DILIGENCIAS(INCLUSIVE CONDUCAO) SALARIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E OFICIAIS DE JUSTICA E SERVICOS DE CARTORIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.50.00', 'SERVICOS RELACIONADOS A INDUSTRIA AEROESPACIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LANCAMENTO E COLOCACAO EM ORBITA DE SATELITES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.51.00', 'SERVICOS TECNICOS PROFISSIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NAS SEGUINTES AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA -ESTATISTICA E OUTRAS. EXCETO OS SERVICOS DE CONSULTORIA QUE DEVEM SER CLASSIFICADOS EM CONTA ESPECIFICA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.52.00', 'TAXA DE ADMINISTRACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ORGANIZACAO E ADMINISTRACAO PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - TAXA DE ADMINISTRACAO PAGA AO INSTITUTO EUVALDO LODI IEL E AO CEN-TRO DE INTEGRACAO EMPRESA-ESCOLA - CIEE, DECORRENTE DOS SERVICOS DE SELECAO E RECRUTAMENTO DE ESTUDANTES, TENDO COMO OBJETIVO O INGRESSO AO MERCADO DE TRABALHO E PROGRAMAS DE ESTAGIO; - TAXA DE ADMINISTRACAO PATRIMONIAL DAS CONTRIBUICOES DO BANCO CENTRALDO BRASIL, NA QUALIDADE DE PATROCINADOR, DESTINADO AO CUSTEIO DAS APOSENTADORIAS E PENSOES CONCEDIDAS COM BASE NA LEI 8.112/1990, E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.53.00', 'VISTOS CONSULARES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE VISTOS CONSULARES JUNTO A EMBAIXADAS E CONSULADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.54.01', 'LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTENCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGAO, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ASSISTENCIA TECNICA - CAPINA - JARDINAGEM - OPERADORES DE MAQUINA - MOTORISTAS - RECEPCIONISTAS - SERVICOS AUXILIARES E OUTROS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.54.02', 'LOCACAO DE MAO-DE-OBRA DE LIMPEZA E CONSERVACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LIMPEZA E CONSERVACAO EM GERAL, TAIS COMO: LIMPEZA E CONSERVACAO DE IMOVEIS, LAVAGEM DE VEICULOS, LAVAGEM E HIGIENIZACAO DE ROUPAS E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.54.03', 'LOCACAO DE MAO-DE-OBRA DE VIGILANCIA OSTENSIVA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE VIGILANCIA OSTENSIVA NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.54.04', 'LOCACAO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVACAO DE BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE MAO-DE-OBRA PARA EFETUAR REPAROS E REFORMAS DE IMOVEIS EM GERAL, INSTAL. ELETRICAS, HIDRAUL. E CORRELATAS DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DE PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.54.05', 'LOCACAO DE MAO-DE-OBRA DE SERVICOS DE COPA E COZINHA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE MAO-DE-OBRA PARA EFETUAR SERVICOS INERENTES A COPA E COZINHA, TAIS COMO: PREPARO DE ALIMENTACAO, LANCHES, CAFE E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.54.06', 'LOCACAO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.54.07', 'LOCACAO DE MAO-DE-OBRA DE SERVICOS DE BRIGADA DE INCENDIO.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE BRIGADA DE INCENDIO EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.54.08', 'LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO - MENORES-APRENDIZES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTENCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGAO, COM A CONTRATACAO DE MAO-DE-OBRA DE MENORES APRENDIZES. (BASE LEGAL - LEI N. 10.097 DE 19/12/2000). NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.54.09', 'LOCACAO DE MAO-DE-OBRA DE MANUTENCAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS, ATUALIZACAO E ADAPTACAO DE SOFTWARE, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTACAO (CORRETIVA, PREVENTIVA E ADAPTATIVA) DE SOFTWARE E RENOVACAO DE LICENCA DE USO DE SOFTWARE. ADAPTACOES DE SOFTWARE SEM ACRESCIMO DE FUNCOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.54.10', 'LOCACAO DE MAO-DE-OBRA DE SUPORTE DE INFRAESTRUTURA DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE OPERACAO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.54.11', 'LOCACAO DE MAO-DE-OBRA DE SUPORTE A USUARIOS DE T.I.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVICOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVICOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVICOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.54.99', 'OUTRAS LOCACOES DE MAO DE OBRA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE OUTROS SERVICOS DE LOCACOES DE MAO-DE-OBRA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.55.01', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE MAQUINAS E APARELHOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE MAQUINAS E APARELHOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.55.02', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS FERROVIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS FERROVIARIOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.55.03', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS RODOVIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS RODOVIARIOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.55.04', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE OUTROS BENS MOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE OUTROS BENS MOVEIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.55.05', 'ARRENDAMENTO MERCANTIL OPERACIONAL DE BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE BENS IMOVEIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.55.99', 'OUTROS ARRENDAMENTOS MERCANTIS OPERACIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL, NAO ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.56.01', 'PASSAGENS PARA O PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO PAIS EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.56.02', 'PASSAGENS PARA O EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EM-BARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO EXTERIOR EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRACAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.56.03', 'LOCACAO DE MEIOS DE TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DA LOCACAO DE MEIOS DE TRANSPORTE, TAIS COMO: VEICULOS, AERONAVES, EMBARCACOES E ASSEMELHADOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.56.04', 'MUDANCAS EM OBJETO DE SERVICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DA LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.56.05', 'LOCOMOCAO URBANA', 'REGISTRA AS APROPRIACOES DE DESPESAS COM LOCOMOCAO URBANA REALIZADA POR MEIO DE ONIBUS, TAXI E OUTROS VEICULOS DE TRANSPORTES URBANOS,PARA ATENDER NECESSIDADE DO SERVICO, COMPREENDENDO, TAMBEM, DESLOCAMENTOS PARA REALIZACAO DE PESQUISAS E REEMBOLSO COM TRANSPORTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.56.06', 'PASSAGENS E LOCOMOCAO NA SUPERVISAO DE VENDAS', 'REGISTRA O VALOR DAS APROPR.DAS DESPESAS COM PASSAGENS E LOCOMOCOES URBANAS NA SUPERVISAO DE VENDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.56.07', 'DESPESAS COM EXCESSO DE BAGAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACOES DE DESPESAS COM EXCESSO DE BAGAGEM ATINENTES AOS VOLUMES E MATERIAIS INDISPENSAVEL A EXECUCAO DO TRABALHO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.56.08', 'PEDAGIOS', 'REGISTRA O VALOR DAS DESPESAS COM TARIFAS DE PEDAGIO, TAXA MENSAL PELA UTILIZACAO DO SISTEMA E ADESAO AO SISTEMA DE IDENTIFICACAO DO VEICULO SEM A NECESSIDADE DE PARA-LO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.56.09', 'TRANSPORTE DE SERVIDORES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUCAO DE TAREFAS PELOS SERVIDORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.56.10', 'TAXA DE SERV. EMISSAO BILHETES NAO UTILIZADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS C/ TAXA DE SERVICO PAGA PELA AQUISICAO DE PASSAGENS NAO UTILIZADAS, CANCELADAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.56.99', 'OUTRAS DESPESAS COM LOCOMOCAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS E MEIOS DE TRANSPORTE NAO ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.98.00', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE DESPESAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.99.00', 'OUTROS SERVICOS PRESTADOS POR PESSOA JURIDICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA, QUE NAO ESTEJA ESPECIFICADOS EM ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.4.1.00.00', 'CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA - ART. 18 § 1, LC 101/00 - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MAO-DE-OBRA, CONSTANTES DOS CONTRATOS DE TERCEIRIZACAO, CLASSIFICAVEIS NO GRUPO DE DESPESA COM PESSOAL E ENCARGOS EM OBEDIENCIA AO DISPOSTO NO ARTIGO 18, § 1º, DA LEI COMPLEMENTAR Nº 101, DE 2000. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.1.1.01.00', 'DEPRECIACAO DE IMOBILIZADO', 'REGISTRA A REDUCAO DO VALOR DOS BENS TANGIVEIS ,DO ATIVO IMOBILIZADO, PELO DESGASTE OU PERDA DE UTILIDADE POR USO, ACAO DA NATUREZA OU OBSOLESCENCIA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.2.1.01.00', 'AMORTIZACAO DE IMOBILIZADO', 'REGISTRA A REDUCAO DO VALOR APLICADO NA AQUISICAO DE DIREITOS, DO ATIVO IMOBILIZADO, COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.2.1.02.00', 'AMORTIZACAO DE INTANGIVEL', 'REGISTRA A REDUCAO DO VALOR APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE E QUAISQUER OUTROS, INCLUSIVE ATIVOS INTANGIVEIS, COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.3.1.01.00', 'EXAUSTAO DE IMOBILIZADO', 'REGISTRA A REDUCAO DO VALOR, DECORRENTE DA EXPLORACAO, DOS RECURSOS MINERAIS, FLORESTAIS E OUTROS RECURSOS NATURAIS ESGOTAVEIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.1.01.00', 'CMV - CONSUMO DE MATERIAL', 'REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.1.02.00', 'CMV - MERCADORIAS PARA VENDA', 'REGISTRA A APROPRIACAO DE MERCADORIAS PARA VENDA NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.1.03.00', 'CMV -DIARIAS', 'REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.1.04.00', 'CMV -SERVICOS TERCEIROS - PF', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.1.05.00', 'CMV -SERVICOS TERCEIROS - PJ', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.1.06.00', 'CMV - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA', 'REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.1.07.00', 'CMV -DEPRECIACAO', 'REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.1.08.00', 'CMV -AMORTIZACAO', 'REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.1.09.00', 'CMV -EXAUSTAO', 'REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.2.01.00', 'CMV - CONSUMO DE MATERIAL', 'REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.2.02.00', 'CMV - MERCADORIAS PARA VENDA', 'REGISTRA A APROPRIACAO DE MERCADORIAS PARA VENDA NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.2.03.00', 'CMV -DIARIAS', 'REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.2.04.00', 'CMV -SERVICOS TERCEIROS - PF', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.2.05.00', 'CMV -SERVICOS TERCEIROS - PJ', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.2.06.00', 'CMV - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA', 'REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.2.07.00', 'CMV -DEPRECIACAO', 'REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.2.08.00', 'CMV -AMORTIZACAO', 'REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.2.09.00', 'CMV -EXAUSTAO', 'REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.4.01.00', 'CMV - CONSUMO DE MATERIAL', 'REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.4.02.00', 'CMV - MERCADORIAS PARA VENDA', 'REGISTRA A APROPRIACAO DE MERCADORIAS PARA VENDA NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.4.03.00', 'CMV -DIARIAS', 'REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.4.04.00', 'CMV -SERVICOS TERCEIROS - PF', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.4.05.00', 'CMV -SERVICOS TERCEIROS - PJ', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.4.06.00', 'CMV - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA', 'REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.4.07.00', 'CMV -DEPRECIACAO', 'REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.4.08.00', 'CMV -AMORTIZACAO', 'REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.4.09.00', 'CMV -EXAUSTAO', 'REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.5.01.00', 'CMV - CONSUMO DE MATERIAL', 'REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.5.02.00', 'CMV - MERCADORIAS PARA VENDA', 'REGISTRA A APROPRIACAO DE MERCADORIAS PARA VENDA NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.5.03.00', 'CMV -DIARIAS', 'REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.5.04.00', 'CMV -SERVICOS TERCEIROS - PF', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.5.05.00', 'CMV -SERVICOS TERCEIROS - PJ', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.5.06.00', 'CMV - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA', 'REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.5.07.00', 'CMV -DEPRECIACAO', 'REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.5.08.00', 'CMV -AMORTIZACAO', 'REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.5.09.00', 'CMV -EXAUSTAO', 'REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.1.01.00', 'CPV - CONSUMO DE MATERIAL', 'REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.1.02.00', 'CPV -DIARIAS', 'REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.1.03.00', 'CPV -SERVICOS TERCEIROS - PF', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.1.04.00', 'CPV -SERVICOS TERCEIROS - PJ', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.1.05.00', 'CPV - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA', 'REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DE PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.1.06.00', 'CPV -DEPRECIACAO', 'REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.1.07.00', 'CPV -AMORTIZACAO', 'REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.1.08.00', 'CPV -EXAUSTAO', 'REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.2.01.00', 'CPV - CONSUMO DE MATERIAL', 'REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.2.02.00', 'CPV -DIARIAS', 'REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.2.03.00', 'CPV -SERVICOS TERCEIROS - PF', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.2.04.00', 'CPV -SERVICOS TERCEIROS - PJ', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.2.05.00', 'CPV - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA', 'REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DE PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.2.06.00', 'CPV -DEPRECIACAO', 'REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.2.07.00', 'CPV -AMORTIZACAO', 'REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.2.08.00', 'CPV -EXAUSTAO', 'REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.4.01.00', 'CPV - CONSUMO DE MATERIAL', 'REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.4.02.00', 'CPV -DIARIAS', 'REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.4.03.00', 'CPV -SERVICOS TERCEIROS - PF', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.4.04.00', 'CPV -SERVICOS TERCEIROS - PJ', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.4.05.00', 'CPV - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA', 'REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DE PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.4.06.00', 'CPV -DEPRECIACAO', 'REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.4.07.00', 'CPV -AMORTIZACAO', 'REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.4.08.00', 'CPV -EXAUSTAO', 'REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.5.01.00', 'CPV - CONSUMO DE MATERIAL', 'REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.5.02.00', 'CPV -DIARIAS', 'REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.5.03.00', 'CPV -SERVICOS TERCEIROS - PF', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.5.04.00', 'CPV -SERVICOS TERCEIROS - PJ', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.5.05.00', 'CPV - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA', 'REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DE PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.5.06.00', 'CPV -DEPRECIACAO', 'REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.5.07.00', 'CPV -AMORTIZACAO', 'REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.5.08.00', 'CPV -EXAUSTAO', 'REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.1.01.00', 'CSP - CONSUMO DE MATERIAL', 'REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.1.02.00', 'CSP -DIARIAS', 'REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.1.03.00', 'CSP -SERVICOS TERCEIROS - PF', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.1.04.00', 'CSP -SERVICOS TERCEIROS - PJ', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.1.05.00', 'CSP - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA', 'REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DE SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.1.06.00', 'CSP -DEPRECIACAO', 'REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.1.07.00', 'CSP -AMORTIZACAO', 'REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.1.08.00', 'CSP -EXAUSTAO', 'REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.2.01.00', 'CSP - CONSUMO DE MATERIAL', 'REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.2.02.00', 'CSP -DIARIAS', 'REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.2.03.00', 'CSP -SERVICOS TERCEIROS - PF', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.2.04.00', 'CSP -SERVICOS TERCEIROS - PJ', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.2.05.00', 'CSP - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA', 'REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DE SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.2.06.00', 'CSP -DEPRECIACAO', 'REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.2.07.00', 'CSP -AMORTIZACAO', 'REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.2.08.00', 'CSP -EXAUSTAO', 'REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.4.01.00', 'CSP - CONSUMO DE MATERIAL', 'REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.4.02.00', 'CSP -DIARIAS', 'REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.4.03.00', 'CSP -SERVICOS TERCEIROS - PF', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.4.04.00', 'CSP -SERVICOS TERCEIROS - PJ', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.4.05.00', 'CSP - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA', 'REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DE SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.4.06.00', 'CSP -DEPRECIACAO', 'REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.4.07.00', 'CSP -AMORTIZACAO', 'REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.4.08.00', 'CSP -EXAUSTAO', 'REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.5.01.00', 'CSP - CONSUMO DE MATERIAL', 'REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.5.02.00', 'CSP -DIARIAS', 'REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.5.03.00', 'CSP -SERVICOS TERCEIROS - PF', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.5.04.00', 'CSP -SERVICOS TERCEIROS - PJ', 'REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.5.05.00', 'CSP - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA', 'REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DE SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.5.06.00', 'CSP -DEPRECIACAO', 'REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.5.07.00', 'CSP -AMORTIZACAO', 'REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.5.08.00', 'CSP -EXAUSTAO', 'REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DOS SERVICOS PRESTADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.1.01.00', 'JUROS DA DIVIDA CONTR.C/INSTIT.FINANCEIRAS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM INSTITUICOES FINANCEIRAS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.1.02.00', 'ENCARGOS DA DIVIDA CONTR.C/INSTIT.FINANCEIRAS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM INSTITUICOES FINANCEIRAS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.1.98.00', 'INTEGRACAO DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.1.99.00', 'JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATUAIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.4.01.00', 'JUROS DA DIVIDA CONTRATADA COM GOVERNOS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS JUROS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.4.02.00', 'ENCARGOS DA DIVIDA CONTRATADA COM GOVERNOS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS ENCARGIOS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.4.98.00', 'INTEGRACAO DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.5.01.00', 'JUROS DA DIVIDA CONTRATADA COM GOVERNOS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS JUROS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.5.02.00', 'ENCARGOS DA DIVIDA CONTRATADA COM GOVERNOS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS ENCARGIOS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.5.98.00', 'INTEGRACAO DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.2.1.01.00', 'JUROS DA DIVIDA CONTRATADA NO EXTERIOR', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA CONTRATADA NO EXTERIOR COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.2.1.02.00', 'ENCARGOS DA DIVIDA CONTRATADA NO EXTERIOR', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA CONTRATADA NO EXTERIOR COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.3.1.01.00', 'JUROS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS DA DIVIDA PUBLICA MOBILIARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.3.1.02.00', 'DESAGIOS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE DESAGIOS DA DIVIDA PUBLICA MOBILIARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.3.1.03.00', 'ENCARGOS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS DA DIVIDA PUBLICA MOBILIARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.3.1.98.00', 'INTEGRACAO DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.4.1.01.00', 'JUROS S/ ADIANTAMENTOS BANCARIOS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS INCIDENTES SOBRE ANTECIPACOES DE CREDITOS CONTRATADAS COM BANCOS E OUTROS AGENTES FINANCEIROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.4.1.98.00', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.8.1.00.00', 'OUTROS JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS- CONSOLIDACAO', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS QUE NAO SEJAM REFERENTES A DIVIDA CONTRATUAL, A DIVIDA MOBILIARIA E A POR ANTECIPACAO DE RECEITA ORCAMENTARIA.COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.8.4.00.00', 'OUTROS JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS- INTER OFSS - ESTADO', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS QUE NAO SEJAM REFERENTES A DIVIDA CONTRATUAL, A DIVIDA MOBILIARIA E A POR ANTECIPACAO DE RECEITA ORCAMENTARIA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.8.5.00.00', 'OUTROS JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS- INTER OFSS - MUNICIPIO', 'A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS QUE NAO SEJAM REFERENTES A DIVIDA CONTRATUAL, A DIVIDA MOBILIARIA E A POR ANTECIPACAO DE RECEITA ORCAMENTARIA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.9.1.00.00', 'OUTROS JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS EXTERNOS- CONSOLIDACAO', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS EXTERNOS QUE NAO SEJAM REFERENTES A DIVIDA CONTRATUAL, A DIVIDA MOBILIARIA E A POR ANTECIPACAO DE RECEITA ORCAMENTARIA.COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.1.01.00', 'JUROS DE MORA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.1.02.00', 'ENCARGOS DE MORA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.4.01.00', 'JUROS DE MORA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.4.02.00', 'ENCARGOS DE MORA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.5.01.00', 'JUROS DE MORA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.5.02.00', 'ENCARGOS DE MORA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.2.1.01.00', 'JUROS DE MORA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS EXTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.2.1.02.00', 'ENCARGOS DE MORA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS EXTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.01.01', 'JUROS DE SERVICOS TERCEIROS - PESSOA FISICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.01.02', 'JUROS DE SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.01.03', 'JUROS SOBRE FORNECIMENTOS DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.02.01', 'MULTAS DEDUTIVEIS SERVICOS TERCEIROS - PESSOA FISICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.02.02', 'MULTAS DEDUTIVEIS SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.02.03', 'MULTAS DEDUTIVEIS SOBRE FORNECIMENTOS DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.03.01', 'MULTAS INDEDUTIVEIS SERVICOS TERCEIROS - PESSOA FISICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.03.02', 'MULTAS INDEDUTIVEIS SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.03.03', 'MULTAS INDEDUTIVEIS SOBRE FORNECIMENTOS DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.99.01', 'OUTROS ENCARGOS S/ SERVICOS TERCEIROS - PESSOA FISICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOAS FISICAS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.99.02', 'OUTROS ENCARGOS S/ SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOAS JURIDICAS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.99.03', 'OUTROS ENCARGOS S/ FONECIMENTO DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.2.01.02', 'JUROS DE OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.2.01.03', 'JUROS SOBRE FORNECIMENTOS DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.2.02.02', 'MULTAS DEDUTIVEIS OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.2.02.03', 'MULTAS DEDUTIVEIS SOBRE FORNECIMENTOS DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.2.03.02', 'MULTAS INDEDUTIVEIS OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.2.03.03', 'MULTAS INDEDUTIVEIS SOBRE FORNECIMENTOS DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.2.99.02', 'OUTROS ENCARGOS S/ SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOAS JURIDICAS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.2.99.03', 'OUTROS ENCARGOS S/ FONECIMENTO DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.4.01.02', 'JUROS DE OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.4.01.03', 'JUROS SOBRE FORNECIMENTOS DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.4.02.02', 'MULTAS DEDUTIVEIS OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.4.02.03', 'MULTAS DEDUTIVEIS SOBRE FORNECIMENTOS DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.4.03.02', 'MULTAS INDEDUTIVEIS OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.4.03.03', 'MULTAS INDEDUTIVEIS SOBRE FORNECIMENTOS DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.4.99.02', 'OUTROS ENCARGOS S/ SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOAS JURIDICAS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.4.99.03', 'OUTROS ENCARGOS S/ FONECIMENTO DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.5.01.02', 'JUROS DE OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.5.01.03', 'JUROS SOBRE FORNECIMENTOS DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.5.02.02', 'MULTAS DEDUTIVEIS OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.5.02.03', 'MULTAS DEDUTIVEIS SOBRE FORNECIMENTOS DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.5.03.02', 'MULTAS INDEDUTIVEIS OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.5.03.03', 'MULTAS INDEDUTIVEIS SOBRE FORNECIMENTOS DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.5.99.02', 'OUTROS ENCARGOS S/ SERVICOS TERCEIROS - PESSOA JURIDICA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOAS JURIDICAS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.5.99.03', 'OUTROS ENCARGOS S/ FONECIMENTO DE BENS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.1.01.00', 'JUROS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.1.02.00', 'MULTAS DEDUTIVEIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS DEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, APENAS AS MULTAS POR INFRACOES FISCAIS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 - RIR/99).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.1.03.00', 'MULTAS INDEDUTIVEIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS INDEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, TODAS AS MULTAS POR INFRACOES FISCAIS, SALVO AS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 -RIR/99).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.2.01.00', 'JUROS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.2.02.00', 'MULTAS DEDUTIVEIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS DEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, APENAS AS MULTAS POR INFRACOES FISCAIS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 - RIR/99).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.2.03.00', 'MULTAS INDEDUTIVEIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS INDEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, TODAS AS MULTAS POR INFRACOES FISCAIS, SALVO AS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 -RIR/99).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.4.02.00', 'MULTAS DEDUTIVEIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS, COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS DEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, APENAS AS MULTAS POR INFRACOES FISCAIS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 - RIR/99).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.4.03.00', 'MULTAS INDEDUTIVEIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS INDEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, TODAS AS MULTAS POR INFRACOES FISCAIS, SALVO AS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 -RIR/99).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.5.01.00', 'JUROS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.5.02.00', 'MULTAS DEDUTIVEIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS, COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS DEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, APENAS AS MULTAS POR INFRACOES FISCAIS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 - RIR/99).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.5.03.00', 'MULTAS INDEDUTIVEIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS INDEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, TODAS AS MULTAS POR INFRACOES FISCAIS, SALVO AS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 -RIR/99).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.9.1.00.00', 'OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDACAO', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.9.2.00.00', 'OUTROS JUROS E ENCARGOS DE MORA - INTRA OFSS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.9.4.00.00', 'OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - ESTADO', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.9.5.00.00', 'OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - MUNICIPIO', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.1.01.00', 'VARIACOES MONETARIAS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL INTERNA. RESSALTE-QUE SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.1.02.00', 'VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL INTERNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.2.01.00', 'VARIACOES MONETARIAS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL INTERNA. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.2.02.00', 'VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL INTERNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.4.01.00', 'VARIACOES MONETARIAS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL INTERNA. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.4.02.00', 'VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL INTERNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.5.01.00', 'VARIACOES MONETARIAS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL INTERNA. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.5.02.00', 'VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL INTERNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.1.01.00', 'VARIACOES MONETARIAS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL EXTERNA. RESSALTE-QUE SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.1.02.00', 'VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL EXTERNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.2.01.00', 'VARIACOES MONETARIAS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL EXTERNA. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.2.02.00', 'VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL EXTERNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.4.01.00', 'VARIACOES MONETARIAS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL EXTERNA. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.4.02.00', 'VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL EXTERNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.5.01.00', 'VARIACOES MONETARIAS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL EXTERNA. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.5.02.00', 'VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL EXTERNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.3.1.01.00', 'VARIACOES MONETARIAS DE DIVIDA MOBILIARIA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA MOBILIARIA INTERNA. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.3.1.02.00', 'VARIACOES CAMBIAIS DE DIVIDA MOBILIARIA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA MOBILIARIA INTERNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.4.1.01.00', 'VARIACOES MONETARIAS DE DIVIDA MOBILIARIA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA MOBILIARIA EXTERNA. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.4.1.02.00', 'VARIACOES CAMBIAIS DE DIVIDA MOBILIARIA', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA MOBILIARIA EXTERNA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.1.01.01', 'ENCARGOS FINANCEIROS DEDUTIVEIS', 'REGISTRA O VALOR DAS DESPESAS COM CORRECAO MONETARIA/VARIACAO CAMBIAL INCIDENTES SOBRE OBRIGACOES DEVIDAS A PESSOAS FISICAS E JURIDICAS (CONSIDERADA COMO DESPESA OPERACIONAL PARA EFEITO DE APURACAO DO LUCRO TRIBUTAVEL).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.1.01.02', 'ENCARGOS FINANCEIROS INDEDUTIVEIS', 'REGISTRA O VALOR DAS DESPESAS COM CORRECAO MONETARIA/VARIACAO CAMBIAL INCIDENTE SOBRE OBRIGACOES DEVIDAS A PESSOAS FISICAS E JURIDICAS ( NAO CONSIDERADA COMO DESPESA OPERACIONAL PARA EFEITO DE APURACAO DO LUCRO TRIBUTAVEL).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.1.02.00', 'OUTRAS VARIACOES CAMBIAIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.2.01.01', 'ENCARGOS FINANCEIROS DEDUTIVEIS', 'REGISTRA O VALOR DAS DESPESAS COM CORRECAO MONETARIA/VARIACAO CAMBIAL INCIDENTES SOBRE OBRIGACOES DEVIDAS A PESSOAS JURIDICAS (CONSIDERADA COMO DESPESA OPERACIONAL PARA EFEITO DE APURACAO DO LUCRO TRIBUTAVEL).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.2.01.02', 'ENCARGOS FINANCEIROS INDEDUTIVEIS', 'REGISTRA O VALOR DAS DESPESAS COM CORRECAO MONETARIA/VARIACAO CAMBIAL INCIDENTE SOBRE OBRIGACOES DEVIDAS A PESSOAS JURIDICAS ( NAO CONSIDERADA COMO DESPESA OPERACIONAL PARA EFEITO DE APURACAO DO LUCRO TRIBUTAVEL).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.2.02.00', 'OUTRAS VARIACOES CAMBIAIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.4.01.01', 'ENCARGOS FINANCEIROS DEDUTIVEIS', 'REGISTRA O VALOR DAS DESPESAS COM CORRECAO MONETARIA/VARIACAO CAMBIAL INCIDENTES SOBRE OBRIGACOES DEVIDAS A PESSOAS FISICAS E JURIDICAS (CONSIDERADA COMO DESPESA OPERACIONAL PARA EFEITO DE APURACAO DO LUCRO TRIBUTAVEL).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.4.01.02', 'ENCARGOS FINANCEIROS INDEDUTIVEIS', 'REGISTRA O VALOR DAS DESPESAS COM CORRECAO MONETARIA/VARIACAO CAMBIAL INCIDENTE SOBRE OBRIGACOES DEVIDAS A PESSOAS FISICAS E JURIDICAS ( NAO CONSIDERADA COMO DESPESA OPERACIONAL PARA EFEITO DE APURACAO DO LUCRO TRIBUTAVEL).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.4.02.00', 'OUTRAS VARIACOES CAMBIAIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DA DIVIDA CONTRATUAL E MOBILIARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.5.01.01', 'ENCARGOS FINANCEIROS DEDUTIVEIS', 'REGISTRA O VALOR DAS DESPESAS COM CORRECAO MONETARIA/VARIACAO CAMBIAL INCIDENTES SOBRE OBRIGACOES DEVIDAS A PESSOAS FISICAS E JURIDICAS (CONSIDERADA COMO DESPESA OPERACIONAL PARA EFEITO DE APURACAO DO LUCRO TRIBUTAVEL).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.5.01.02', 'ENCARGOS FINANCEIROS INDEDUTIVEIS', 'REGISTRA O VALOR DAS DESPESAS COM CORRECAO MONETARIA/VARIACAO CAMBIAL INCIDENTE SOBRE OBRIGACOES DEVIDAS A PESSOAS FISICAS E JURIDICAS ( NAO CONSIDERADA COMO DESPESA OPERACIONAL PARA EFEITO DE APURACAO DO LUCRO TRIBUTAVEL).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.5.02.00', 'OUTRAS VARIACOES CAMBIAIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DA DIVIDA CONTRATUAL E MOBILIARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.4.0.1.00.00', 'DESCONTOS FINANCEIROS CONCEDIDOS - CONSOLIDACAO', 'COMPREENDE O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM DESCONTOS FINANCEIROS CONCEDIDOS A CLIENTES POR PAGAMENTOS ANTECIPADOS DE DUPLICATAS E OUTROS TITULOS.NAO SE CONFUNDEM COM DESCONTOS NOS PRECOS DE VENDA CONCEDIDOS INCONDICIONALMENTE, OU ABATIMENTOS DE PRECOS, QUE SAO DEDUCOES DA RECEITA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.4.0.2.00.00', 'DESCONTOS FINANCEIROS CONCEDIDOS - INTRA OFSS', 'COMPREENDE O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM DESCONTOS FINANCEIROS CONCEDIDOS A CLIENTES POR PAGAMENTOS ANTECIPADOS DE DUPLICATAS E OUTROS TITULOS.NAO SE CONFUNDEM COM DESCONTOS NOS PRECOS DE VENDA CONCEDIDOS INCONDICIONALMENTE, OU ABATIMENTOS DE PRECOS, QUE SAO DEDUCOES DA RECEITA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.4.0.4.00.00', 'DESCONTOS FINANCEIROS CONCEDIDOS - INTER OFSS - ESTADO', 'COMPREENDE O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM DESCONTOS FINANCEIROS CONCEDIDOS A CLIENTES POR PAGAMENTOS ANTECIPADOS DE DUPLICATAS E OUTROS TITULOS.NAO SE CONFUNDEM COM DESCONTOS NOS PRECOS DE VENDA CONCEDIDOS INCONDICIONALMENTE, OU ABATIMENTOS DE PRECOS, QUE SAO DEDUCOES DA RECEITA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.4.0.5.00.00', 'DESCONTOS FINANCEIROS CONCEDIDOS - INTER OFSS - MUNICIPIO', 'COMPREENDE O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM DESCONTOS FINANCEIROS CONCEDIDOS A CLIENTES POR PAGAMENTOS ANTECIPADOS DE DUPLICATAS E OUTROS TITULOS.NAO SE CONFUNDEM COM DESCONTOS NOS PRECOS DE VENDA CONCEDIDOS INCONDICIONALMENTE, OU ABATIMENTOS DE PRECOS, QUE SAO DEDUCOES DA RECEITA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.1.01.00', 'JUROS EM SENTENCAS JUDICIAIS', 'REGISTRA OS JUROS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.1.02.00', 'ENCARGOS EM SENTENCAS JUDICIAIS', 'REGISTRA OS ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.1.98.00', 'INTEGRACAO DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.2.01.00', 'JUROS EM SENTENCAS JUDICIAIS', 'REGISTRA OS JUROS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.2.02.00', 'ENCARGOS EM SENTECAS JUDICIAIS', 'REGISTRA OS ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.2.98.00', 'INTEGRACAO DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.4.01.00', 'JUROS EM SENTENCAS JUDICIAIS', 'REGISTRA OS JUROS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.4.02.00', 'ENCARGOS EM SENTECAS JUDICIAIS', 'REGISTRA OS ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.4.98.00', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.5.01.00', 'JUROS EM SENTENCAS JUDICIAIS', 'REGISTRA OS JUROS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.5.02.00', 'ENCARGOS EM SENTECAS JUDICIAIS', 'REGISTRA OS ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.5.98.00', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.1.01.00', 'JUROS E ENCARGOS EM INDENIZACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES REFERENTES A JUROS E ENCARGOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.1.02.00', 'JUROS E ENCARGOS EM RESTITUICOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUICOES REFERENTES A JUROS E ENCARGOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.2.01.00', 'JUROS E ENCARGOS EM INDENIZACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES REFERENTES A JUROS E ENCARGOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.2.02.00', 'JUROS E ENCARGOS EM RESTITUICOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUICOES REFERENTES A JUROS E ENCARGOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.4.01.00', 'JUROS E ENCARGOS EM INDENIZACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES REFERENTES A JUROS E ENCARGOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.4.02.00', 'JUROS E ENCARGOS EM RESTITUICOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUICOES REFERENTES A JUROS E ENCARGOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.5.02.00', 'JUROS E ENCARGOS EM RESTITUICOES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUICOES REFERENTES A JUROS E ENCARGOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.9.1.00.00', 'OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NAS CONTAS ANTERIORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.9.2.00.00', 'OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NAS CONTAS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.9.4.00.00', 'OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NAS CONTAS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.9.5.00.00', 'OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NAS CONTAS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.01.00', 'COTA CONCEDIDA', 'REGISTRA VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR DA CONCESSAO DE COTA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA PARA ORGAO SETORIAL CORRESPONDENTE AO ORCAMENTO ANUAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.02.00', 'REPASSE CONCEDIDO', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR DOS RECURSOS CONCEDIDOS A TITULO DE TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DIFERENTES DA ADMINISTRACAO DIRETA OU INDIRETA, CORRESPONDENTES AO ORCAMENTO ANUAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.03.00', 'SUB-REPASSE CONCEDIDO', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR TOTAL DOS SUB-REPASSES CONCEDIDOS POR TRANSFERENCIAS FINANCEIRAS ENTRE UG DE UM MESMO ORGAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.04.00', 'RECURSOS ARRECADADOS - CONCEDIDOS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR CONCEDIDO PARA OUTRA UG, REFERENTE A RECURSOS QUE FORAM ARRECADADOS (CLASSIFICADOS COMO RECEITA), PARA PAGAMENTO DE VARIACAO PATRIMONIAL DIMINUTIVA NA UG RECEBEDORA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.05.01', 'COTA DIFERIDA - BAIXA', 'REGISTRA O VALOR DA COTA DIFERIDA NO PROCESSO DE BAIXA DOS RECURSOS DIFERIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.05.02', 'REPASSE DIFERIDO - BAIXA', 'REGISTRA O VALOR DOS RECURSOS DE REPASSE DIFERIDO DECORRENTES DO PROCESSO DE BAIXA DE RECURSOS DIFERIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.05.03', 'SUB-REPASSE DIFERIDO - BAIXA', 'REGISTRA O VALOR DOS RECURSOS DE SUBREPASSE DIFERIDO DECORRENTES DO PROCESSO DE BAIXA DE RECURSOS DIFERIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.06.01', 'COTA DIFERIDA - INSCRICAO', 'REGISTRA O VALOR DA COTA DIFERIDA NO PROCESSO DE INSCRICAO DOSRECURSOS DIFERIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.06.02', 'REPASSE DIFERIDO - INSCRICAO', 'REGISTRA O VALOR DOS RECURSOS DE REPASSE DIFERIDO DECORRENTES DO PROCESSO DE INSCRICAO DE RECURSOS DIFERIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.06.03', 'SUB-REPASSE DIFERIDO - INSCRICAO', 'REGISTRA A APROPRIACAO DO VALOR REFERENTE AO SUB-REPASSE CONCEDIDO ENTRE AS UGS DA ADMINISTRACAO DIRETA OU INDIRETA POR OCASIAO DA INSCRICAO DOS VALORES DIRERIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.07.01', 'CORRESPONDENCIA DE CREDITOS -INCORPORACAO DE VARIACAO PATRIMONIAL AUMENTATIVA', 'REGISTRA A APROPRIACAO DE VARIACAO PATRIMONIAL AUMENTATIVA INCORPORADA POR TRANSFERENCIA DE OUTRA UG DE MESMA GESTAO, PARA APURACAO DE CUSTO E RESULTADO DE GESTAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.07.02', 'CORRESPONDENCIA DE CREDITOS -DESINCORPORACAO DE VARIACAO PATRIMONIAL DIMINUTIVA', 'REGISTRA A APROPRIACAO DA DESINCORPORACAO DE VARIACAO PATRIMONIAL DIMINUTIVA TRANSFERIDAS PARA OUTRA UG DE MESMA GESTAO, PARA APURACAO DE CUSTO E RESULTADO DE GESTAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.07.03', 'CORRESPONDENCIA DE CREDITOS - SALDOS FINANC.', 'REGISTRA A APROPRIACAO DA TRANSFERENCIA DE CREDITOS INTERNOS ENTRE UG DE MESMA GESTAO REFERENTES A CONTAS COM SALDOS FINANCEIROS EM ROTINAS CONTABEIS ORCAMENTARIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.01.01', 'TRANSFERENCIAS CONCEDIDAS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO TOTAL DAS TRANSFERENCIAS NAO VINCULADAS AO ORCAMENTO, INCLUSIVE TRANSFERENCIAS PARA ATENDER RESTOS A PAGAR E OUTROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.01.02', 'DEVOLUCAO DE TRANSFERENCIAS RECEBIDAS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR DAS DEVOLUCOES REFERENTES A RESTOS A PAGAR RECEBIDO E NAO UTILIZADO OU UTILIZADO PARCIALMENTE, SEM O RESTABELECIMENTO DO DIREITO CORRESPONDENTE AO LIMITE DE RP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.02.01', 'REGISTRO DE RESTITUICAO DE RECEITAS FEDERAIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA QUE PERMITE IDENTIFICAR OS REGISTROS DE RESTITUICAO DE RECEITAS FEDERAIS EFETIVADOS PELAS DELEGACIAS DA RECEITA FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.02.02', 'CLASSIFICACAO DA RESTITUICAO DE RECEITAS FEDERAIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA QUE PERMITE IDENTIFICAR A CLASSIFICACAO DE RESTITUICAO DE RECEITAS, REFERENTE A FITA DE ARRECADACAO DECENCIAL DE RECEITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.03.00', 'TRANSF CONC P/ PAGTO RESTITUICOES RECEITAS FEDERAIS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVAS AS LIBERACOES DE RECURSOS EXTRA-ORCAMENTARIOS PARA RESTITUICOES DE RECEITAS FEDERAIS PELAS UNIDADES GESTORAS DA SECRETARIA DA RECEITA FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.04.00', 'RESTITUICOES DE RECEITAS FEDERAIS - GRU', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVAS AS LIBERACOES DE RECURSOS EXTRA-ORCAMENTARIOS PARA RESTITUICOES DE RECEITAS FEDERAIS ARRECADADAS POR GRU PELAS UNIDADES RESPONSAVEIS PELO RECOLHIMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.05.01', 'TRANSFERENCIAS CONCEDIDAS ARREC/TERC. INSS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVAS AS TRANSFERENCIAS PELO TESOURO NACIONAL PARA O INSS REFERENTE A ARRECADACAO DE RECEITAS PROPRIAS E VALORES DE TERCEIROS POR MEIO DE GPS REDE BANCARIA E INTRA-SIAFI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.05.02', 'TRANSF.CONC. RECURSOS PREVIDENC. ARRECADADOS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS RECURSOS PREVIDENCIARIOS ARRECADADOS PELO INSS POR MEIO DAS GPS ELETRONICA E DA REDE BANCARIA, CENTRALIZADOS NO TESOURO NACIONAL, SUBCONTA DA CONTA UNICA INSS, PARA POSTERIOR REPASSE POR MEIO DE PROGRAMACAO FINANCEIRA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.06.00', 'TRANSFERENCIAS CONCEDIDAS ENTRE UG/ORGAO', 'COMPREENDE A TRANSFERENCIA DE RECURSOS ENTRE UG DE MESMO ORGAO OU DE ORGAOS DIFERENTES QUE NAO ESTEJA RELACIONADA A EXECUCAO ORCAMENTARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.06.01', 'TRANSFERENCIAS CONCEDIDAS ENTRE UG/ORGAO - NO EXERCICIO', 'REGISTRA A TRANSFERENCIA DE RECURSOS ENTRE UG DE MESMO ORGAO OU DE ORGAOS DIFERENTES QUE NAO ESTEJA RELACIONADA A EXECUCAO ORCAMENTARIA CONCEDIDAS NO EXERCICIO CORRENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.06.02', 'TRANSFERENCIAS CONCEDIDAS ENTRE UG/ORGAO-INSCRICAO DIFERIDO', 'REGISTRA A TRANSFERENCIA DE RECURSOS ENTRE UG DE MESMO ORGAO OU DE ORGAOS DIFERENTES QUE NAO ESTEJA RELACIONADA A EXECUCAO ORCAMENTARIA CONCEDIDAS REFERENTE A INSCRICAO DE RECURSOS DIFERIDOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.06.03', 'TRANSFERENCIAS CONCEDIDAS ENTRE UG/ORGAO - BAIXA DE DIFERIDO', 'REGISTRA A TRANSFERENCIA DE RECURSOS ENTRE UG DE MESMO ORGAO OU DE ORGAOS DIFERENTES QUE NAO ESTEJA RELACIONADA A EXECUCAO ORCAMENTARIA RECEBIDAS REFERENTE A BAIXA DA INSCRICAO DOS RECURSOS DIFERIDOS PELO PROCESSO DE ENCERRAMENTO DO EXERCICIO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.07.00', 'MOVIMENTO DE FUNDOS A CREDITO - CORRESPONDENCIA DE CREDITOS - SALDOS NAO FIN.', 'REGISTRA A APROPRIACAO DA TRANSFERENCIA DE CREDITOS INTERNOS ENTRE UG DE MESMA GESTAO REFERENTES A CONTAS NAO FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.08.00', 'MOVIMENTO DE FUNDOS A CREDITO - CORRESPONDENCIA DE CREDITOS - SALDOS FINANC.', 'REGISTRA A APROPRIACAO DA TRANSFERENCIA DE CREDITOS INTERNOS ENTRE ORGAOS CORREPONDENTES A SALDOS FINANCEIROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.09.01', 'MOVIMENTO DE FUNDOS A CREDITOS - PROPRIOS - INCORP/DESINCORP. DE SALDOS NAO FINANCEIROS', 'REGISTRA O VALOR DE SALDOS PATRIMONIAIS CREDORES INCORPORADOS E DEVEDORES DESINCORPORADOS POR INTEGRACAO,TRANSFERENCIA,FUSAO,CISAO OU MUDANCA DA MODAL.USO PARCIAL P/ TOTAL DE ORGAOS OU UNIDADE GEST./GESTAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.09.02', 'MOVIMENTO DE FUNDOS A CREDITOS - PROPRIOS - INCORP./DESINCORP. SALDO FINANC./DISP./LIMITE', 'REGISTRA O VALOR DE SALDOS FINANCEIROS CREDORES INCORPORADOS, E DEVEDORES DESINCORPORADOS, POR INTEGRACAO, TRANSFERENCIA, FUSAO, CISAO OU MUDANCA DA MODALIDADE DE USO PARCIAL PARA TOTAL, RELATIVOS AO DISPONIVEL E AO LIMITE DE PESSOAL, DE ORGAO OU UNIDADE GESTORA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.09.03', 'MOVIMENTO DE FUNDOS A CREDITOS - PROPRIOS - INCORP./DESINCORP. DEMAIS SALDOS FINANCEIROS', 'REGISTRA O VALOR DE SALDOS FINANCEIROS CREDORES INCORPORADOS, E DEVEDORES DESINCORPORADOS, POR INTEGRACAO, TRANSFERENCIA, FUSAO, CISAO OU MUDANCA DE MODALIDADE DE USO PARCIAL PARA TOTAL, COM EXCECAO OS DO DISPONIVEL E OS DO LIMITE DE PESSOAL, DE ORGAO OU UNIDADE GESTORA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.09.04', 'MOVIMENTO DE FUNDOS A CREDITOS - PROPRIOS - APURACAO RESULTADO INC/DESINC. SALDOS FINANC.', 'REGISTRA O VALOR DA APURACAO DE RESULTADO FINANCEIRO, QUANDO CREDOR, PELA INCORPORACAO DE SALDOS DEVEDORES E/OU DESINCORPORACAO DE SALDOS CREDORES, PELO PROCESSO DE TRANSFERENCIA, INTEGRACAO E FUSAO DE SALDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.10.01', 'OUTROS MOVIMENTOS DE FUNDOS A CREDITO-S.FIN.', 'REGISTRA O VALOR DA TRANSFERENCIA DE AJUSTES FINANCEIROS COM SALDO DEVEDOR OU CREDOR ENTRE UG DE EMPRESAS INTEGRANTES DO SIAFI E OUTROS MOVIMENTOS A CREDITO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.10.02', 'OUTROS MOVIMENTOS DE FUNDOS A CREDITO-S.PATR.', 'REGISTRA O VALOR DA TRANSFERENCIA DE AJUSTES PATRIMONIAIS COM SALDO DEVEDOR OU CREDOR ENTRE UG DE EMPRESAS INTEGRANTES DO SIAFI E OUTROS MOVIMENTOS A CREDITO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.11.00', 'TRANSFERENCIAS CONCEDIDAS DE BENS IMOVEIS', 'REGISTRA O VALOR DAS TRANSFERENCIAS DE BENS IMOVEIS ENTRE UNIDADES DO MESMO ORGAO .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.12.00', 'DOACOES CONCEDIDAS DE BENS IMOVEIS', 'REGISTRA O VALOR DE DOACOES DE BENS IMOVEIS ENTRE UNIDADES DE ORGAOS DIFERENTES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.13.00', 'TRANFERENCIAS CONCEDIDAS DE BENS MOVEIS', 'COMPREENDE O VALOR DOS BENS MOVEIS PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DO MESMO ORGAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.13.01', 'TRANFERENCIAS CONCEDIDAS DE BENS MOVEIS POR UNIDADE LOCALIZADA NO PAIS', 'REGISTRA O VALOR DOS BENS MOVEIS CONCEDIDOS POR UNIDADE LOCALIZADA NO PAIS PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DO MESMO ORGAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.13.02', 'TRANFERENCIAS CONCEDIDAS DE BENS MOVEIS POR UNIDADE LOCALIZADA DO EXTERIOR', 'REGISTRA O VALOR DOS BENS MOVEIS CONCEDIDOS POR UNIDADE LOCALIZADA NO EXTERIOR PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DO MESMO ORGAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.14.01', 'DOACOES CONCEDIDAS DE BENS MOVEIS POR UNIDADE LOCALIZADA NO PAIS', 'REGISTRA O VALOR DOS BENS MOVEIS CONCEDIDOS POR UNIDADE LOCALIZADA NO PAIS PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DE ORGAOS DIFERENTES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.14.02', 'DOACOES CONCEDIDAS DE BENS MOVEIS POR UNIDADE LOCALIZADA NO EXTERIOR', 'REGISTRA O VALOR DOS BENS MOVEIS CONCEDIDOS POR UNIDADE LOCALIZADA NO EXTERIOR PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DE ORGAOS DIFERENTES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.15.00', 'TRANSFERENCIAS CONCEDIDAS DE TITULOS E VALORES', 'REGISTRA O TOTAL DOS TITULOS E VALORES EM CIRCULACAO CONCEDIDOS POR UNIDADE DECORRENTE DE TRANSFERENCIA A OUTRA UNIDADE DE MESMA GESTAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.16.00', 'TRANSFERENCIAS CONCEDIDAS DE TITULOS DA DIVIDA ATIVA', 'REGISTRA A TRANSFERENCIA DE TITULOS DA DIVIDA ATIVA DE UMA UG PARA A PGFN OU ORGAO EQUIVALENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.3.2.00.00', 'TRANSFERENCIAS CONCEDIDAS PARA COBERTURA DO DEFICIT ATUARIAL DO RPPS POR APORTE PERIODICO - INTRA OFSS', 'COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS PARA APORTES PERIODICOS DESTINADOS A COBERTURA DO DEFICIT ATUARIAL DO REGIME PROPRIO DE PREVIDENCIA SOCIAL - RPPS, CONFORME PLANO DE AMORTIZACAO ESTABELECIDO EM LEI DO RESPECTIVO ENTE FEDERATIVO, EXCETO AS DECORRENTES DE ALIQUOTA DE CONTRIBUICAO SUPLEMENTAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.01.00', 'ACRE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO ACRE DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.02.00', 'ALAGOAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE ALAGOAS DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.03.00', 'AMAPA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO AMAPA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.04.00', 'AMAZONAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO AMAZONAS DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.05.00', 'BAHIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DA BAHIA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.06.00', 'CEARA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO CEARA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.07.00', 'DISTRITO FEDERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO DISTRITO FEDERAL DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.08.00', 'ESPIRITO SANTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO ESPIRITO SANTO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.09.00', 'GOIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE GOIAS DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.10.00', 'MARANHAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO MARANHAO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.11.00', 'MATO GROSSO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE MATO GROSSO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.12.00', 'MATO GROSSO DO SUL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE MATO GROSSO DO SUL DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.13.00', 'MINAS GERAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE MINAS GERAIS DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.14.00', 'PARA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO PARA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.15.00', 'PARAIBA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DA PARAIBA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.16.00', 'PARANA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO PARANA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.17.00', 'PERNAMBUCO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE PERNAMBUCO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.18.00', 'PIAUI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO PIAUI DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.19.00', 'RIO DE JANEIRO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO RIO DE JANEIRO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.20.00', 'RIO GRANDE DO NORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO RIO GRANDE DO NORTE DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.21.00', 'RIO GRANDE DO SUL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO RIO GRANDE DO SUL DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.22.00', 'RONDONIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE RONDONIA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.23.00', 'RORAIMA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE RORAIMA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.24.00', 'SANTA CATARINA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE SANTA CATARINA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.25.00', 'SAO PAULO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE SAO PAULO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.26.00', 'SERGIPE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE SERGIPE DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.27.00', 'TOCANTINS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE TOCANTINS DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.01.00', 'A MUNICIPIOS DO ESTADO DO ACRE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO ACRE DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.02.00', 'A MUNICIPIOS DO ESTADO DE ALAGOAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE ALAGOAS DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.03.00', 'A MUNICIPIOS DO ESTADO DO AMAPA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO AMAPA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.04.00', 'A MUNICIPIOS DO ESTADO DO AMAZONAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO AMAZONAS DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.05.00', 'A MUNICIPIOS DO ESTADO DA BAHIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DA BAHIA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.06.00', 'A MUNICIPIOS DO ESTADO DO CEARA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO CEARA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.07.00', 'A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.08.00', 'A MUNICIPIOS DO ESTADO DE GOIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE GOIAS DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.09.00', 'A MUNICIPIOS DO ESTADO DO MARANHAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO MARANHAO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.10.00', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE MATO GROSSO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.11.00', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE MATO GROSSO DO SUL DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.12.00', 'A MUNICIPIOS DO ESTADO DE MINAS GERAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE MINAS GERAIS DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.13.00', 'A MUNICIPIOS DO ESTADO DO PARA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO PARA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.14.00', 'A MUNICIPIOS DO ESTADO DA PARAIBA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DA PARAIBA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.15.00', 'A MUNICIPIOS DO ESTADO DO PARANA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO PARANA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.16.00', 'A MUNICIPIOS DO ESTADO DE PERNAMBUCO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE PERNAMBUCO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.17.00', 'A MUNICIPIOS DO ESTADO DO PIAUI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO PIAUI DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.18.00', 'A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.19.00', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.20.00', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.21.00', 'A MUNICIPIOS DO ESTADO DE RONDONIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE RONDONIA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.22.00', 'A MUNICIPIOS DO ESTADO DE RORAIMA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE RORAIMA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.23.00', 'A MUNICIPIOS DO ESTADO DE SANTA CATARINA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE SANTA CATARINA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.24.00', 'A MUNICIPIOS DO ESTADO DE SAO PAULO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE SAO PAULO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.25.00', 'A MUNICIPIOS DO ESTADO DE SERGIPE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE SERGIPE DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.26.00', 'A MUNICIPIOS DO ESTADO DE TOCANTINS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE TOCANTINS DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.80.00', 'PASEP TRANSFERIDO A MUNICIPIOS', 'REGISTRA OS VALORES TRANSFERIDOS PELA UNIAO OU PELOS ESTADOS AOS MUNICIPIOS, RELATIVOS AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.01.00', 'ACRE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO ACRE PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.02.00', 'ALAGOAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE ALAGOAS PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.03.00', 'AMAPA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO AMAPA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.04.00', 'AMAZONAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO AMAZONAS PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.05.00', 'BAHIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DA BAHIA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.06.00', 'CEARA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO CEARA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.07.00', 'DISTRITO FEDERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO DISTRITO FEDERAL PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.08.00', 'ESPIRITO SANTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO ESPIRITO SANTO PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.09.00', 'GOIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE GOIAS PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.10.00', 'MARANHAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO MARANHAO PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.11.00', 'MATO GROSSO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE MATO GROSSO PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.12.00', 'MATO GROSSO DO SUL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE MATO GROSSO DO SUL PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.13.00', 'MINAS GERAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE MINAS GERAIS PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.14.00', 'PARA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO PARA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.15.00', 'PARAIBA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DA PARAIBA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.16.00', 'PARANA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO PARANA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.17.00', 'PERNAMBUCO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE PERNAMBUCO PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.18.00', 'PIAUI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO PIAUI PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.19.00', 'RIO DE JANEIRO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO RIO DE JANEIRO PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.20.00', 'RIO GRANDE DO NORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO RIO GRANDE DO NORTE PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.21.00', 'RIO GRANDE DO SUL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DO RIO GRANDE DO SUL PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.22.00', 'RONDONIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE RONDONIA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.23.00', 'RORAIMA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE RORAIMA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.24.00', 'SANTA CATARINA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE SANTA CATARINA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.25.00', 'SAO PAULO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE SAO PAULO PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.26.00', 'SERGIPE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE SERGIPE PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.27.00', 'TOCANTINS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA AO ESTADO DE TOCANTINS PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.01.00', 'A MUNICIPIOS DO ESTADO DO ACRE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO ACRE PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.02.00', 'A MUNICIPIOS DO ESTADO DE ALAGOAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE ALAGOAS PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.03.00', 'A MUNICIPIOS DO ESTADO DO AMAPA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO AMAPA DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.04.00', 'A MUNICIPIOS DO ESTADO DO AMAZONAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO AMAZONAS PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.05.00', 'A MUNICIPIOS DO ESTADO DA BAHIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DA BAHIA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.06.00', 'A MUNICIPIOS DO ESTADO DO CEARA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO CEARA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.07.00', 'A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.08.00', 'A MUNICIPIOS DO ESTADO DE GOIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE GOIAS PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.09.00', 'A MUNICIPIOS DO ESTADO DO MARANHAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO MARANHAO PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.10.00', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE MATO GROSSO PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.11.00', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE MATO GROSSO DO SUL PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.12.00', 'A MUNICIPIOS DO ESTADO DE MINAS GERAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE MINAS GERAIS PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.13.00', 'A MUNICIPIOS DO ESTADO DO PARA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO PARA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.14.00', 'A MUNICIPIOS DO ESTADO DA PARAIBA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DA PARAIBA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.15.00', 'A MUNICIPIOS DO ESTADO DO PARANA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO PARANA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.16.00', 'A MUNICIPIOS DO ESTADO DE PERNAMBUCO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE PERNAMBUCO PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.17.00', 'A MUNICIPIOS DO ESTADO DO PIAUI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO PIAUI PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.18.00', 'A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.19.00', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.20.00', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.21.00', 'A MUNICIPIOS DO ESTADO DE RONDONIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE RONDONIA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.22.00', 'A MUNICIPIOS DO ESTADO DE RORAIMA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE RORAIMA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.23.00', 'A MUNICIPIOS DO ESTADO DE SANTA CATARINA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE SANTA CATARINA PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.24.00', 'A MUNICIPIOS DO ESTADO DE SAO PAULO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE SAO PAULO PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.25.00', 'A MUNICIPIOS DO ESTADO DE SERGIPE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE SERGIPE PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.26.00', 'A MUNICIPIOS DO ESTADO DE TOCANTINS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A MUNICIPIOS DO ESTADO DE TOCANTINS PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.01', 'ACRE', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO ACRE P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.02', 'ALAGOAS', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO ALAGOAS P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.03', 'AMAPA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO AMAPA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.04', 'AMAZONAS', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO AMAZONAS P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.05', 'BAHIA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO BAHIA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.06', 'CEARA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO CEARA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.07', 'DISTRITO FEDERAL', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO DISTRITO FEDERAL P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.08', 'ESPIRITO SANTO', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO ESPIRITO SANTO P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.09', 'GOIAS', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO GOIAS P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.10', 'MARANHAO', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MARANHAO P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.11', 'MATO GROSSO', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MATO GROSSO P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.12', 'MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MATO GROSSO DO SUL P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.13', 'MINAS GERAIS', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MINAS GERAIS P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.14', 'PARA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PARA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.15', 'PARAIBA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PARAIBA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.16', 'PARANA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PARANA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.17', 'PERNAMBUCO', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PERNAMBUCO P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.18', 'PIAUI', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PIAUI P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.19', 'RIO DE JANEIRO', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RIO DE JANEIRO P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.20', 'RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RIO GRANDE DO NORTE P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.21', 'RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RIO GRANDE DO SUL P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.22', 'RONDONIA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RONDONIA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.23', 'RORAIMA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RORAIMA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.24', 'SANTA CATARINA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO SANTA CATARINA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.25', 'SAO PAULO', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO SAO PAULO P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.26', 'SERGIPE', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO SERGIPE P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.27', 'TOCANTINS', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO TOCANTINS P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.99', 'OUTRAS CONTRIBUICOES', 'REGISTRA O VALOR DE OUTRAS CONTRIBUICOES EFETUADAS P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.01', 'ACRE', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO ACRE P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.02', 'ALAGOAS', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO ALAGOAS P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.03', 'AMAPA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO AMAPA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.04', 'AMAZONAS', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO AMAZONAS P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.05', 'BAHIA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO BAHIA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.06', 'CEARA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO CEARA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.07', 'DISTRITO FEDERAL', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO DISTRITO FEDERAL P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.08', 'ESPIRITO SANTO', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO ESPIRITO SANTO P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.09', 'GOIAS', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO GOIAS P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.10', 'MARANHAO', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MARANHAO P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.11', 'MATO GROSSO', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MATO GROSSO P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.12', 'MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MATO GROSSO DO SUL P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.13', 'MINAS GERAIS', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MINAS GERAIS P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.14', 'PARA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PARA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.15', 'PARAIBA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PARAIBA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.16', 'PARANA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PARANA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.17', 'PERNAMBUCO', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PERNAMBUCO P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.18', 'PIAUI', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PIAUI P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.19', 'RIO DE JANEIRO', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RIO DE JANEIRO P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.20', 'RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RIO GRANDE DO NORTE P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.21', 'RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RIO GRANDE DO SUL P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.22', 'RONDONIA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RONDONIA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.23', 'RORAIMA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RORAIMA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.24', 'SANTA CATARINA', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO SANTA CATARINA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.25', 'SAO PAULO', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO SAO PAULO P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.26', 'SERGIPE', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO SERGIPE P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.27', 'TOCANTINS', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO TOCANTINS P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.98', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.01', 'ACRE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO ACRE PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.02', 'ALAGOAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE ALAGOAS PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.03', 'AMAPA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO AMAPA PARA REALIZACAO DEOUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.04', 'AMAZONAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO AMAZONAS PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.05', 'BAHIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DA BAHIA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.06', 'CEARA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO CEARA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.07', 'DISTRITO FEDERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO DISTRITO FEDERAL PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.08', 'ESPIRITO SANTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO ESPIRITO SANTO PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.09', 'GOIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE GOIAS PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.10', 'MARANHAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO MARANHAO PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.11', 'MATO GROSSO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.12', 'MATO GROSSO DO SUL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO DO SUL PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.13', 'MINAS GERAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE MINAS GERAIS PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.14', 'PARA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO PARA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.15', 'PARAIBA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DA PARAIBA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.16', 'PARANA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO PARANA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.17', 'PERNAMBUCO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO PERNAMBUCO PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.18', 'PIAUI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO PIAUI PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.19', 'RIO DE JANEIRO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO ACRE PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.20', 'RIO GRANDE DO NORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO NORTE PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.21', 'RIO GRANDE DO SUL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO SUL PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.22', 'RONDONIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE RONDONIA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.23', 'RORAIMA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE RORAIMA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.24', 'SANTA CATARINA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE SANTA CATARINA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.25', 'SAO PAULO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE SAO PAULO PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.26', 'SERGIPE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE SERGIPE PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.27', 'TOCANTINS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE TOCANTINS PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.98', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.01', 'ACRE', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DO ACRE RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.02', 'ALAGOAS', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DE ALAGOAS RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.03', 'AMAPA', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DO AMAPA RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.04', 'AMAZONAS', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DO AMAZONAS RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.05', 'BAHIA', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DA BAHIA RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.06', 'CEARA', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DO CEARA RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.07', 'DISTRITO FEDERAL', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO DISTRITO FEDERAL RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.08', 'ESPIRITO SANTO', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DO ESPIRITO SANTO RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.09', 'GOIAS', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DE GOIAS RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.10', 'MARANHAO', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DO MARANHAO RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.11', 'MATO GROSSO', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DE MATO GROSSO RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.12', 'MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DE MATO GROSSO DO SUL RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.13', 'MINAS GERAIS', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DE MINAS GERAIS RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.14', 'PARA', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DO PARA RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.15', 'PARAIBA', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DA PARAIBA RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.16', 'PARANA', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DO PARANA RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.17', 'PERNAMBUCO', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DE PERNAMBUCO RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.18', 'PIAUI', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DO PIAUI RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.19', 'RIO DE JANEIRO', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DO RIO DE JANEIRO RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.20', 'RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DO RIO GRANDE DO NORTE RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.21', 'RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DO RIO GRANDE DO SUL RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.22', 'RONDONIA', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DE RONDONIA RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.23', 'RORAIMA', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DE RORAIMA RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.24', 'SANTA CATARINA', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DE SANTA CATARINA RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.25', 'SAO PAULO', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DE SÃO PAULO RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.26', 'SERGIPE', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DE SERGIPE RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.27', 'TOCANTINS', 'REGISTRA O VALOR DAS TRANSFERENCIAS EFETUADAS AO ESTADO DE TOCANTINS RELATIVAS A INDENIZACOES E RESTITUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.01', 'A MUNICIPIOS DO ESTADO DO ACRE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO ACRE PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.02', 'A MUNICIPIOS DO ESTADO DE ALAGOAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE ALAGOAS PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.03', 'A MUNICIPIOS DO ESTADO DO AMAPA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO AMAPA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.04', 'A MUNICIPIOS DO ESTADO DO AMAZONAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO AMAZONAS PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.05', 'A MUNICIPIOS DO ESTADO DA BAHIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DA BAHIA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.06', 'A MUNICIPIOS DO ESTADO DO CEARA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO CEARA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.07', 'A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO ESPIRITO SANTO PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.08', 'A MUNICIPIOS DO ESTADO DE GOIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE GOIAS PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.09', 'A MUNICIPIOS DO ESTADO DO MARANHAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO MARANHAO PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.10', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO MATO GROSSO PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.11', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.12', 'A MUNICIPIOS DO ESTADO DE MINAS GERAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE MINAS GERAIS PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.13', 'A MUNICIPIOS DO ESTADO DO PARA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO PARA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.14', 'A MUNICIPIOS DO ESTADO DA PARAIBA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DA PARAIBA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.15', 'A MUNICIPIOS DO ESTADO DO PARANA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO PARANA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.16', 'A MUNICIPIOS DO ESTADO DE PERNAMBUCO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE PERNAMBUCO PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.17', 'A MUNICIPIOS DO ESTADO DO PIAUI', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO PIAUI PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.18', 'A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO RIO DE JANEIRO PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.19', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.20', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.21', 'A MUNICIPIOS DO ESTADO DE RONDONIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE RONDONIA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.22', 'A MUNICIPIOS DO ESTADO DE RORAIMA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE RORAIMA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.23', 'A MUNICIPIOS DO ESTADO DE SANTA CATARINA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE SANTA CATARINA PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.24', 'A MUNICIPIOS DO ESTADO DE SAO PAULO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE SAO PAULO PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.25', 'A MUNICIPIOS DO ESTADO DE SERGIPE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE SERGIPE PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.26', 'A MUNICIPIOS DO ESTADO DE TOCANTINS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE TOCANTINS PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS .', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.80', 'INTEGRACAO DADOS ESTADOS E MUNICIPIOS - SAFEM', 'REGISTRA O VALOR DAS DESPESAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ESTADOS E MUNICIPIOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.81', 'ROYALTIES-ITAIPU', 'REGISTRA OS VALORES DAS CONTRIBUICOES A TITULO DE ROYALTIES PARA ITAIPU.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.82', 'PARTICIPACOES', 'DESTINADA AOS REGISTROS DOS VALORES DAS CONTRIBUICOES DA UNIAO OU DOS ESTADOS AOS MUNICIPIOS, RELATIVOS AS PARTICIPACOES NA ARRECADACAO DE RECEITAS DIVERSAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.83', 'PASEP TRANSFERIDO A MUNICIPIOS', 'DESTINADA AOS REGISTROS DOS VALORES TRANSFERIDOS PELA UNIAO OU PELOS ESTADOS AOS MUNICIPIOS, RELATIVOS AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.84', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.85', 'OUTRAS CONTRIBUICOES', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZ.ADAS PELOS ORGAOS NAO INTEGRANTES, OU INTEGRANTES PARCIALMENTE DO SIAFI, CUJO REGISTRO SERA EFETUADO POR INTEGRACAO DE BALANCETES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.01', 'A MUNICIPIOS DO ESTADO DO ACRE', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.02', 'A MUNICIPIOS DO ESTADO DE ALAGOAS', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.03', 'A MUNICIPIOS DO ESTADO DO AMAPA', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.04', 'A MUNICIPIOS DO ESTADO DO AMAZONAS', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.05', 'A MUNICIPIOS DO ESTADO DA BAHIA', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.06', 'A MUNICIPIOS DO ESTADO DO CEARA', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.07', 'A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.08', 'A MUNICIPIOS DO ESTADO DE GOIAS', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.09', 'A MUNICIPIOS DO ESTADO DO MARANHAO', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.10', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.11', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.12', 'A MUNICIPIOS DO ESTADO DE MINAS GERAIS', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.13', 'A MUNICIPIOS DO ESTADO DO PARA', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.14', 'A MUNICIPIOS DO ESTADO DA PARAIBA', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.15', 'A MUNICIPIOS DO ESTADO DO PARANA', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.16', 'A MUNICIPIOS DO ESTADO DE PERNAMBUCO', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.17', 'A MUNICIPIOS DO ESTADO DO PIAUI', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.18', 'A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.19', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.20', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.21', 'A MUNICIPIOS DO ESTADO DE RONDONIA', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.22', 'A MUNICIPIOS DO ESTADO DE RORAIMA', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.23', 'A MUNICIPIOS DO ESTADO DE SANTA CATARINA', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.24', 'A MUNICIPIOS DO ESTADO DE SAO PAULO', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.25', 'A MUNICIPIOS DO ESTADO DE SERGIPE', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.26', 'A MUNICIPIOS DO ESTADO DE TOCANTINS', 'REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.99', 'OUTRAS CONTRIBUICOES', 'REGISTRA OS VALORES DE OUTRAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.19.05', 'A MUNICIPIOS DO ESTADO DA BAHIA', 'REPRESENTA O SOMATORIO DA DESPESAS CORRENTES RESULTANTES DE: A) PAGAMENTO DE PRECATORIOS, EM CUMPRIMENTO AO DISPOSTO NO ART. 100 E SEUS PARAGRAFOS DA CONSTITUICAO, E NO ART. 78 DO ADCT; B) CUMPRIMENTO DE SENTENCAS JUDICIAIS, TRANSITADAS EM JULGADO, DE EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA, INTEGRANTES DOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL; C) CUMPRIMENTO DE SENTENCAS JUDICIAIS, TRANSITADAS EM JULGADO, DE PEQUENO VALOR, NA FORMA DEFINIDA EM LEI, NOS TERMOS DO § 3º DO ART. 100 DA CONSTITUICAO (RPV); E D) CUMPRIMENTO DE DECISOES JUDICIAIS, PROFERIDAS EM MANDADOS DE SEGURANCA E MEDIDAS CAUTELARES, REFERENTES A VANTAGENS PECUNIARIAS CONCEDIDAS E AINDA NAO INCORPORADAS EM CARATER DEFINITIVO AS REMUNERACOES DOS BENEFICIARIOS. OBS: TRANSFERENCIA A MINICIPIOS DO ESTADO DA BAHIA EM CUMPRIMENTO A DECISAO JUDICIAL', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.01', 'A MUNICIPIOS DO ESTADO DO ACRE', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO ACRE PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.02', 'A MUNICIPIOS DO ESTADO DE ALAGOAS', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DE ALAGOAS PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.03', 'A MUNICIPIOS DO ESTADO DO AMAPA', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO AMAPA PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.04', 'A MUNICIPIOS DO ESTADO DO AMAZONAS', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO AMAZONAS PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.05', 'A MUNICIPIOS DO ESTADO DA BAHIA', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DA BAHIA PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.06', 'A MUNICIPIOS DO ESTADO DO CEARA', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO CEARA PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.07', 'A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO ESPIRITO SANTO PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.08', 'A MUNICIPIOS DO ESTADO DE GOIAS', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DE GOIAS PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.09', 'A MUNICIPIOS DO ESTADO DO MARANHAO', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO MARANHAO PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.10', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO MATO GROSSO PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.11', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.12', 'A MUNICIPIOS DO ESTADO DE MINAS GERAIS', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DE MINAS GERAIS PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.13', 'A MUNICIPIOS DO ESTADO DO PARA', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO PARA PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.14', 'A MUNICIPIOS DO ESTADO DA PARAIBA', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DA PARAIBA PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.15', 'A MUNICIPIOS DO ESTADO DO PARANA', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO PARANA PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.16', 'A MUNICIPIOS DO ESTADO DE PERNAMBUCO', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DE PERNAMBUCO PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.17', 'A MUNICIPIOS DO ESTADO DO PIAUI', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO PIAUI PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.18', 'A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO RIO DE JANEIRO PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.19', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.20', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.21', 'A MUNICIPIOS DO ESTADO DE RONDONIA', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DE RONDONIA PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.22', 'A MUNICIPIOS DO ESTADO DE RORAIMA', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO RORAIMA PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.23', 'A MUNICIPIOS DO ESTADO DE SANTA CATARINA', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DE SANTA CATARINA PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.24', 'A MUNICIPIOS DO ESTADO DE SAO PAULO', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DE SAO PAULO PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.25', 'A MUNICIPIOS DO ESTADO DE SERGIPE', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO SERGIPE PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.26', 'A MUNICIPIOS DO ESTADO DE TOCANTINS', 'REGISTRA O VALOR DAS TRANSFERENCIAS AO MUNICIPIOS DO ESTADO DO TOCANTINS PARA ATENDER A OUTRAS DESPESAS CORRENTES COM INDENIZACOES E RESTITUICOES E DESPESAS COM COMPENSACAO PREVIDENCIARIA ENTRE RPPS E RGPS RELATIVOS A BENEFICIOS DE APOSENTADORIAS CONCEDIDOS A PARTIR DA CF-88.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.0.0.00.00', 'TRANSFERENCIAS A INSTITUICOES PRIVADAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS A INSTITUICOES PRIVADAS, INCLUSIVE DE BENS E VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.01', 'INST.DE CARATER ASSIST.CULT.E EDUCACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER ASSISTENCIAL, CULTURAL E EDUCACIONAL RELATIVOS A OUTRAS TRANSF.CORRENTES CONCEDIDAS EM VIRTUDE LEI ESPECIAL P/ATENDER ONUS OU ENC.ASSUM.P/UNIAO DE INSTIT.PRIV.DE CARATER ASSIST.,CULTURAL E EDUCACIONAL, SEM FINALIDADE LUCRATIVA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.02', 'ASSESSORIA JURIDICA ORGAN. POPULARES - GAJOP', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS RELATIVO A ASSESSORIA JURIDICA AS ORGANIZACOES POPULARES - GAJOP CONFORME CONVENIO 016/99.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.03', 'INSTITUICOES DE PESQ. E DESENVOLV.TECNOLOGICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE PESQUISA E DESENVOLVIMENTO TECNOLOGICO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.04', 'ENTIDADES DE INTERCAMBIO LEGISLATIVO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS , COMO CONTRIBUICAO, EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM PROMOCAO E INTERCAMBIO ENTRE PARLAMENTARES DE DIVERSOS PAISES, TAIS COMO FORTALECIMENTO DE INST. DEMOCRATICAS E PREGAR A PAZ E A UNIAO ENTRE OS POVOS; DESENVOLVER E HARMONIZAR A LEGISLACAO DE TURISMO; E INTERCAMBIO DOS PAISES LATINO-AMERICANOS ATRAVES DE COMISOES PERMANENTES (EDUCACAO, SAUDE, NARCOTRAFICO, ECONOMIA, ETC).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.05', 'INSTITUICOES DE CARATER AMBIENTAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER AMBIENTAL A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.06', 'INSTITUICOES DE CARATER AGROPECUARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER AGROPECUARIO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.07', 'ENTIDADES REPRESENTATIVAS DE CLASSE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ENTIDADES SINDICAIS, ASSOCIACOES E CONSELHOS DE CLASSE A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.08', 'INSTIT.DE ENSINO AERONAUTICO/AVIACAO REGIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE ENSINO AERONAUTICO E AVALIACAO REGIONAL A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.09', 'INSTITUICOES ASSISTENCIAIS DE REFORMA AGRARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES ASSISTENCIAIS DE REFORMA AGRARIA A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.10', 'ORGANIZACOES DE SOC. CIVIL DE INTERESSE PUB.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ORGANIZACOES DE SOCIEDADE CIVIL DE INTERESSE PUBLICO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.11', 'INSTITUICOES DE DESENVOLVIMENTO RURAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE DESENVOLVIMENTO RURAL A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.98', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.99', 'OUTRAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A OUTRAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.02.01', 'INST.DE CARATER ASSIST.CULT.E EDUCACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER ASSISTENCIAL CULTURAL E EDUCACIONAL A TITULO DE SUBVENCOES SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.02.02', 'PARTIDOS POLITICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A PARTIDOS POLITICOS A TITULO DE SUBVENCOES SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.02.98', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.02.99', 'OUTRAS INSTITUICOES PRIVADAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A OUTRAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE SUBVENCOES SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.2.1.01.01', 'INSTITUICOES DE CARATER INDUSTRIAL', 'REGISTRA O VALOR DAS SUBVENCOES ECONOMICAS CONCEDIDAS AS INSTITUICOES DE CARATER INDUSTRIAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.2.1.01.02', 'INSTITUICOES DE PESQUISA E DESENV.TECNOLOGICO', 'REGISTRA O VALOR DAS SUBVENCOES ECONOMICAS CONCEDIDAS AAS INSTITUICOES DE PESQUISA E DESENVOLVIMENTO TECNOLOGICO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.2.1.01.03', 'TRANSFERENCIAS A INSTITUICOES FINANCEIRAS', 'REGISTRA O VALOR DAS SUBVENCOES ECONOMICAS CONCEDIDAS AAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.2.1.01.04', 'INSTITUICOES DE CARATER COMERCIAL', 'REGISTRA O VALOR DAS SUBVENCOES ECONOMICAS CONCEDIDAS AAS INSTITUICOES DE CARATER COMERCIAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.2.1.01.05', 'INSTIT.DE ENSINO AERONAUTICO/AVIACAO REGIONAL', 'REGISTRA OS VALORES RELATIVOS A DESPESAS C/ SUBVENCOES ECONOMICAS CONCEDIDAS A INSTITUICOES DE ENSINO AERONAUTICO E AVIACAO REGIONAL COM FINS LUCRATIVOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.2.1.01.06', 'PNPE - PROGR.NAC.DE ESTIMULO AO PRIMEIRO EMPREGO', 'REGISTRA O VALOR DAS SUBVENCOES ECONOMICAS CONCEDIDAS AO PROGRAMA NACIONAL DE ESTIMULO AO PRIMEIRO EMPREGO PARA OS JOVENS - PNPE. * LEI 10748, 22/10/2003.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.4.0.1.01.01', 'CONSORCIOS PUBLICOS INTERMUNICIPAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A CONSORCIOS PUBLICOS INTERMUNICIPAIS NAO INTEGRADOS PELA UNIAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.4.0.1.01.02', 'ENTIDADES BINACIONAIS', 'REGISTRA O VALOR DAS CONTRIBUICOES CONCEDIDAS A ENTIDADES BINACIONAIS, CRIADAS E MANTIDAS POR DOIS OU MAIS PAISES, INCLUSIVE O BRASIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.4.0.1.02.00', 'TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS - CONTRIBUICOES PARA PESSOAL E ENCARGOS', 'REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS A INSTITUICOES MULTIGOVERNAMENTAIS P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.5.0.1.00.00', 'TRANSFERENCIAS A CONSORCIOS PUBLICOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS A CONSORCIOS PUBLICOS, DOS QUAIS O ENTE TRANSFERIDOR PARTICIPE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.5.0.1.01.01', 'TRANSFERENCIAS A CONSORCIOS PUBLICOS - CONTRIBUICOES', 'REGISTRA O VALOR DAS CONTRIBUICOES CONCEDIDAS VINCULADAS A TRANSFERENCIAS A CONSORCIOS PUBLICOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.5.0.1.20.01', 'TRANSFERENCIAS A CONSORCIOS PUBLICOS - INDENIZACOES E RESTITUICOES', 'COMPREENDE O VALOR DAS APROPRIACOES DE DESPESAS CORRENTES, COM INDENI ZACOES, EXCLUSIVE AS TRABALHISTAS, E RESTITUICOES, DEVIDAS POR ORGAOS E ENTIDADES A QUALQUER TITULO, INCLUSIVE DEVOLUCAO DE RECEITAS QUANDO NAO FOR POSSIVEL EFETUAR ESSA DEVOLUCAO MEDIANTE A COMPENSACAO COM A RECEITA CORRESPONDENTE, BEM COMO OUTRAS DESPESAS DE NATUREZA INDENIZATORIA, NAO CLASSIFICADAS EM ELEMENTOS DE DESPESA ESPECIFICOS. CONTA CRIADA PARA ATENDER CONTRATO DE RATEIO CELEBRADO ENTRE A UNIAO, O GOVERNO DO RIO DE JANEIRO E O MUNICIPIO DO RIO DE JANEIRO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.01.01', 'OPAS - ORGANIZACAO PANAMERICANA DE SAUDE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ORGANIZACAO PANAMERICANA DE SAUDE A TITULO DE DIARIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.01.02', 'PNUD - PROGRAMA DAS NACOES UNIDAS P/ O DESENV', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS AO PROGRAMA DAS NACOES UNIDAS PARA O DESENVOLVIMENTO A TITULO DE DIARIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.02.01', 'IICA - INSTIT. INTERAM. COOP. P/ AGRICULTURA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INSTITUTO INTERAMERICANO DE COOPERACAO PARA AGRICULTURA PARA ATENDER VPD COM MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.02.02', 'OPAS - ORGANIZACAO PANAMERICANA DE SAUDE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO PANAMERICANA DE SAUDE PARA ATENDER VPD COM MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.02.03', 'PNUD - PROGRAMA DAS NACOES UNIDAS P/ O DESENV', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRAMA DAS NACOES UNIDAS PARA O DESENVOLVIMENTO PARA ATENDER VPD COM MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.02.04', 'UNICEF - FUNDACAO DAS NACOES UNIDAS P/INFANCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A FUNDACAO DAS NACOES UNIDAS P/INFANCIA (UNICEF) PARA ATENDER VPD COM MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.03.01', 'IICA - INSTIT. INTERAM. COOP. P/ AGRICULTURA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INSTITUTO INTERAMERICANO COOPERACAO PARA AGRICULTURA A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.03.02', 'OPAS - ORGANIZACAO PANAMERICANA DE SAUDE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO PANAMERICANA DE SAUDE A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.03.03', 'PNUD - PROGRAMA DAS NACOES UNIDAS P/ O DESENV', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRAMA DAS NACOES UNIDAS PARA O DESENVOLVIMENTO A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.01', 'INSTITUICOES DE CARATER ASSIST. OU CULTURAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER ASSISTENCIAL OU CULTURAL A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.02', 'FAO - ORGAN.DAS NACOES UNIDAS P/ ALIM. E AGR.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DAS NACOES UNIDAS PARA ALIMENTACAO E AGRICULTURA A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.03', 'IICA - INSTIT. INTERAM. COOP. P/ AGRICULTURA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INSTITUTO INTERAMERICANO DE COOPERACAO PARA AGRICULTURA A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.04', 'OEI-ORGANIZACAO DOS ESTADOS IBERO-AMERICANOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANICAO DOS ESTADOS IBERO-AMERICANOS A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.05', 'OEA - ORGANIZACAO DOS ESTADOS AMERICANOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DOS ESTADOS AMERICANOS A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.06', 'OIT - ORGANIZACAO INTERNACIONAL DO TRABALHO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO INTERNACIONAL DO TRABALHO A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.07', 'OPAS - ORGANIZACAO PANAMERICANA DE SAUDE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO PANAMERICANA DE SAUDE A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.08', 'PNUD - PROGRAMA DAS NACOES UNIDAS P/ O DESENV', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRMA DAS NACOES UNIDAS PARA O DESENVOLVIMENTO A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.09', 'UNESCO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DAS NACOES UNIDAS PARA EDUCACAO, CIENCIA E CULTURA A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.10', 'UNODC- PROG. NACOES UNIDAS P/ PREV. AO CRIME', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRAMA DAS NACOES UNIDAS PARA PREVENCAO AO CRIME A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.11', 'UNICRI-INST,DE INVEST.INTER-REG.DO CRI.JUSTICA DAS NACOES UNIDAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INSTITUTO DE INVESTIGACAO INTER-REGIONAL DO CRIME E DA JUSTICA DAS NACOES UNIDAS A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.12', 'IFC - INTERNATIONAL FINANCE CORPORATION', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INTERNACIONAL FINANCE CORPORATION A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.13', 'OCDE - ORG. DE COOPERACAO E DESENV. ECONOMICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORG. DE COOPERACAO E DESENV. ECONOMICO A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.14', 'CPLP-COMUNIDADE P/PAISES DE LINGUA PORTUGUESA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A COMUNIDADE P/PAISES DE LINGUA PORTUGUESA A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.15', 'OTCA-ORG.DOS TRATADOS DE COOPERACAO ECONOMICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INSTITUTO DE INVESTIGACAO INTER-REGIONAL DO CRIME E DA JUSTICA DAS NACOES UNIDAS A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.16', 'UNODC-ESCITORIO UNIDAS CONTRA DROGAS E CRIME.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO UNODC A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.17', 'PMA- PROGRAMA MUNDIAL DE ALIMENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRAMA MUNDIAL DE ALIMENTACAO A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.18', 'UNITAR-INST DAS NACOES UNIDAS P TREIN E PESQ.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO UNITAR-INSTITUTO DAS NACOES UNIDAS PARA TREINAMENTO E PESQUISA A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA,CONFORME O DECRETO LEGISLATIVO NR.11/1966 E DECRETO PRESIDENCIAL NR.59.308/1966.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.01', 'INSTITUICOES DE CARATER ASSIST. OU CULTURAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER ASSISTENCIAL OU CULTURAL A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.02', 'INSTITUICOES DE CARATER TECNICO OU CIENTIFICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER TECNICO OU CIENTIFICO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.03', 'OMT - ORGANIZACAO MUNDIAL DO TURISMO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO MUNDIAL DO TURISMO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.04', 'ICCA - CONGRESSOS E CONVENCOES INTERNACIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INTERNATIONAL CONGRESS AND CONVENTION ASSOCIATION A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.05', 'AISS - ASSOC. INTERNACIONAL SEGURIDADE SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ASSOCIACAO INTERNACIONAL DE SEGURIDADE SOCIAL A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.06', 'ENTIDADES DE INTERCAMBIO LEGISLATIVO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS ENTIDADES DE INTERCAMBIO LEGISLATIVO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.07', 'PROG.DAS NACOES UNIDAS P/MEIO AMBIENTE-PUNMA.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRAMA DAS NACOES UNIDAS PARA O MEIO-AMBIENTE A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.08', 'FAO - ORGAN.DAS NACOES UNIDAS P/ ALIM. E AGR.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DAS NACOES UNIDAS PARA A ALIMENTACAO E AGRICULTURA A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.09', 'ICID - COMISSAO INTERN. IRRIGACAO E DRENAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A COMISSAO INTERNACIONAL DE IRRIGACAO E DRENAGEM A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.10', 'CEPAL - COMISSAO ECOMOMICA P/ AMER. E CARIBE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A COMISSAO ECONOMICA PARA AMERICA E CARIBE A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.11', 'SISTEMA DAS NACOES UNIDAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO SISTEMA DAS NACOES UNIDAS A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.12', 'MERCOSUL - MERCADO COMUM DO SUL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO MERCADO COMUM DO SUL A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.13', 'IICA - INSTIT. INTERAM. COOP. P/ AGRICULTURA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INSTITUTO INTERAMERICANO DE COOPERACAO PARA AGRICULTURA A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.14', 'CPLP - COMUNIDADE P/ PAISES DE LINGUA PORTUG.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A COMUNIDADE PARA PAISES DE LINGUA PORTUGUESA A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.15', 'OCDE - ORG. DE COOPERACAO E DESENV. ECONOMICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DE COOPERACAO E DESENVOLVIMENTO ECONOMICO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.16', 'OEI - ORGANIZ.DOS ESTADOS IBERO-AMERICANOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DOS ESTADOS IBERO-AMERICANOS A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.17', 'OEA - ORGANIZACAO DOS ESTADOS AMERICANOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DOS ESTADOS AMERICANOS A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.18', 'OIT - ORGANIZACAO INTERNACIONAL DO TRABALHO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO INTERNACIONAL DO TRABALHO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.19', 'OMS - ORGANIZACAO MUNDIAL DE SAUDE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO MUNDIAL DE SAUDE A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.20', 'OPAS - ORGANIZACAO PANAMERICANA DE SAUDE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO PANAMERICANA DE SAUDE A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.21', 'PNUD - PROGRAMA DAS NACOES UNIDAS P/ O DESENV', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRAMA DAS NACOES UNIDAS PARA O DESENVOLVIMENTO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.22', 'OTCA - ORG. DOS TRATADOS DE COOPERACAO ECON.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DOS TRATADOS DE COOPERACAO ECONOMICA A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.23', 'UNESCO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DAS NACOES UNIDAS PARA EDUCACAO, CIENCIA E CULTURA A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.24', 'OMC - ORGANIZACAO MUNDIAL DO COMERCIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO MUNDIAL DO COMERCIO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.25', 'AIEA - AGENCIA INTERN. DE ENERGIA ATOMICA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A AGENCIA INTERAMERICANA DE ENERGIA ATOMICA A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.26', 'INSTITUICOES DE CARATER SOCIAL OU HUMANITARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER SOCIAL OU HUMANITARIO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.27', 'ILANUD-INST.LAT.AMER.PREV.DELITO TRAT.DELINQ.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INSTITUTO LATINO-AMERICANO DAS NACOES UNIDAS PARA PREVENCAO DO DELITO E O TRATAMENTO DO DELINQUENTE A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.28', 'UNODC-ESCITORIO UNIDAS CONTRA DROGAS E CRIME.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRAMA DAS NACOES UNIDAS PARA O CONTROLE INTERNACIONAL DE DROGAS A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.29', 'CDES - CONSELHO DE DESENVOL.ECONOMICO E SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO CONSELHO DE DESENVOLVIMENTO ECONOMICO E SOCIAL A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.30', 'CPCM-COMISSAO PARLAM. CONJUNTA DO MERCOSUL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A COMISSAO PARLAMENTAR CONJUNTA DO MERCOSUL A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.31', 'INSTIT. DE CARATER COMERCIAL OU ECONOMICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER COMERCIAL OU ECONOMICO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.32', 'ORGANIZACAO INTERNACIONAL DO CAFE', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO INTERNACIONAL DO CAFE A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.33', 'INSTITUICOES DE CARATER JURIDICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER JURIDICO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.34', 'INSTIT. DE CARATER AMBIENTAL OU ECOLOGICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER AMBIENTAL OU ECOLOGICO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.35', 'UNICEF- FUNDO DAS NACOES UNIDAS P/ A INFANCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO FUNDO DAS NACOES UNIDAS PARA A INFANCIA A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.36', 'UNIFEM - FUNDO DESENV NACOES UNIDAS P/MULHER', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO FUNDO DE DESENVOLVIMENTO DAS NACOES UNIDAS PARA A MULHER A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.37', 'CAF - CORPORACAO ANDINA DE FOMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A CORPORACAO ANDINA DE FOMENTO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.38', 'FLACSO - FAC. LATINO-AMERICANA CIENC. SOCIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A FACULDADE LATINO-AMERICANA DE CIENCIAS SOCIAIS A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.39', 'FUNAP - FUNDO DE POPULACAO DA NACOES UNIDAS.', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO FUNDO DE POPULACAO DAS NACOES UNIDAS A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.40', 'INSTITUICOES DE CARATER POLITICO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER POLITICO A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.41', 'ORGANIZACAO INTER. DE MADEIRA TROPICAL-ITTO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO INTERNACIONAL DE MADEIRA TROPICAL A TITULO DE CONTRIBUICOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.06.00', 'VPD DE PESSOAL - TERCEIRIZACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MAO-DE-OBRA CONSTANTES DOS CONTRATOS DE TERCEIRIZACAO, DE ACORDO COM O ART. 18, § 1º, DA LEI COMPLEMENTAR Nº 101, DE 2000, COMPUTADAS PARA FINS DE LIMITES DA DESPESA TOTAL COM PESSOAL PREVISTOS NO ART. 19 DESSA LEI.(NR)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.01', 'ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ACRE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.02', 'ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE ALAGOAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.03', 'AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAPA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.04', 'AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAZONAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.05', 'BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA BAHIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.06', 'CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO CEARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.07', 'DISTRITO FEDERAL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO DISTRITO FEDERAL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.08', 'ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ESPIRITO SANTO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.09', 'GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE GOIAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.10', 'MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MARANHAO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.11', 'MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.12', 'MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.13', 'MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE MINAS GERAIS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.14', 'PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.15', 'PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA PARAIBA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.16', 'PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARANA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.17', 'PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE PARNAMBUCO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.18', 'PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PIAUI PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.19', 'RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO DE JANEIRO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.20', 'RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO NORTE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.21', 'RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.22', 'RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RONDONIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.23', 'RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RORAIMA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.24', 'SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SANTA CATARINA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.25', 'SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SAO PAULO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.26', 'SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SERGIPE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.27', 'TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE TOCANTINS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.01', 'ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ACRE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.02', 'ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE ALAGOAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.03', 'AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAPA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.04', 'AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAZONAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.05', 'BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA BAHIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.06', 'CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO CEARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.07', 'DISTRITO FEDERAL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO DISTRITO FEDERAL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.08', 'ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ESPIRITO SANTO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.09', 'GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO GOIAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.10', 'MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MARANHAO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.11', 'MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.12', 'MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.13', 'MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE MINAS GERAIS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.14', 'PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.15', 'PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA PARAIBA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.16', 'PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARANA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.17', 'PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE PERNAMBUCO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.18', 'PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PIAUI PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.19', 'RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO DE JANEIRO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.20', 'RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO NORTE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.21', 'RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.22', 'RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RONDONIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.23', 'RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RORAIMA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.24', 'SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SANTA CATARINA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.25', 'SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SAO PAULO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.26', 'SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SERGIPE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.27', 'TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE TOCANTINS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.01', 'ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ACRE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.02', 'ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE ALAGOAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.03', 'AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAPA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.04', 'AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAZONAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.05', 'BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA BAHIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.06', 'CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO CEARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.07', 'DISTRITO FEDERAL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO DISTRITO FEDERAL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.08', 'ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ESPIRITO SANTO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.09', 'GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE GOIAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.10', 'MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MARANHAO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.11', 'MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.12', 'MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.13', 'MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE MINAS GERAIS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.14', 'PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.15', 'PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA PARAIBA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.16', 'PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARANA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.17', 'PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PERNAMBUCO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.18', 'PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PIAUI PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.19', 'RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO DE JANEIRO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.20', 'RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO NORTE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.21', 'RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.22', 'RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RONDONIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.23', 'RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RORAIMA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.24', 'SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SANTA CATARINA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.25', 'SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SAO PAULO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.26', 'SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SERGIPE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.27', 'TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE TOCANTINS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOCAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.01', 'ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ACRE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.02', 'ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE ALAGOAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.03', 'AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAPA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.04', 'AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAZONAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.05', 'BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA BAHIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.06', 'CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO CEARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.07', 'DISTRITO FEDERAL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO DISTRITO FEDERAL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.08', 'ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ESPIRITO SANTO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.09', 'GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO GOIAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.10', 'MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MARANHAO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.11', 'MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.12', 'MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.13', 'MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE MINAS GERAIS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.14', 'PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.15', 'PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA PARAIBA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.16', 'PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARANA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.17', 'PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE PERNAMBUCO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.18', 'PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PIAUI PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.19', 'RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO DE JANEIRO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.20', 'RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO NORTE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.21', 'RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.22', 'RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RONDONIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.23', 'RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RORAIMA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.24', 'SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SANTA CATARINA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.25', 'SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SAO PAULO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.26', 'SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SERGIPE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.27', 'TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO TOCANTINS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.01', 'ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ACRE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.02', 'ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE ALAGOAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.03', 'AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAPA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.04', 'AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAZONAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.05', 'BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA BAHIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.06', 'CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO CEARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.07', 'DISTRITO FEDERAL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO DISTRITO FEDERAL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.08', 'ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ESPIRITO SANTO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.09', 'GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO GOIAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.10', 'MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MARANHAO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.11', 'MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.12', 'MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.13', 'MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE MINAS GERAIS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.14', 'PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.15', 'PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA PARAIBA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.16', 'PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARANA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.17', 'PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE PERNAMBUCO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.18', 'PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PIAUI PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.19', 'RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO DE JANEIRO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.20', 'RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO NORTE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.21', 'RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.22', 'RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RONDONIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.23', 'RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RORAIMA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.24', 'SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SANTA CATARINA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.25', 'SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SAO PAULO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.26', 'SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SERGIPE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.27', 'TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO TOCANTINS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.01', 'ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ACRE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.02', 'ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE ALAGOAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.03', 'AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAPA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.04', 'AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAZONAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.05', 'BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA BAHIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.06', 'CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO CEARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.07', 'DISTRITO FEDERAL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO DISTRITO FEDERAL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.08', 'ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ESPIRITO SANTO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.09', 'GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO GOIAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.10', 'MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MARANHAO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.11', 'MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.12', 'MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.13', 'MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE MINAS GERAIS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.14', 'PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.15', 'PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA PARAIBA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.16', 'PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARANA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.17', 'PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE PERNAMBUCO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.18', 'PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PIAUI PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.19', 'RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO DE JANEIRO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.20', 'RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO NORTE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.21', 'RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.22', 'RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RONDONIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.23', 'RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RORAIMA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.24', 'SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SANTA CATARINA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.25', 'SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SAO PAULO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.26', 'SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SERGIPE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.27', 'TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO TOCANTINS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-SERVIÇOS DE CONSULTORIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.01', 'ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ACRE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.02', 'ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE ALAGOAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.03', 'AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAPA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.04', 'AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAZONAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.05', 'BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA BAHIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.06', 'CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO CEARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.07', 'DISTRITO FEDERAL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO DISTRITO FEDERAL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.08', 'ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ESPIRITO SANTO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.09', 'GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO GOIAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.10', 'MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MARANHÃO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.11', 'MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.12', 'MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.13', 'MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE MINAS GERAIS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.14', 'PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.15', 'PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA PARAIBA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.16', 'PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARANA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.17', 'PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE PERNAMBUCO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.18', 'PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PIAUI PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.19', 'RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO DE JANEIRO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.20', 'RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO NORTE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.21', 'RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.22', 'RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RONDONIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.23', 'RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RORAIMA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.24', 'SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SANTA CATARINA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.25', 'SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SAO PAULO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.26', 'SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SERGIPE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.27', 'TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO TOCANTINS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.01', 'ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ACRE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.02', 'ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE ALAGOAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.03', 'AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAPA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.04', 'AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO AMAZONAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.05', 'BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA BAHIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.06', 'CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO CEARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.07', 'DISTRITO FEDERAL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO DISTRITO FEDERAL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.08', 'ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO ESPIRITO SANTO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.09', 'GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO GOIAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.10', 'MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MARANHAO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.11', 'MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.12', 'MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO MATO GROSSO DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.13', 'MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE MINAS GERAIS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.14', 'PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.15', 'PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DA PARAIBA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.16', 'PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PARANA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.17', 'PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE PERNAMBUCO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.18', 'PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO PIAUI PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.19', 'RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO DE JANEIRO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.20', 'RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO NORTE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.21', 'RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO RIO GRANDE DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.22', 'RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RONDONIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.23', 'RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE RORAIMA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.24', 'SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SANTA CATARINA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.25', 'SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SAO PAULO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.26', 'SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DE SERGIPE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.27', 'TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AO ESTADO DO TOCANTINS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE-INDENIZACOES E RESTITUICOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.01', 'A MUNICIPIOS DO ESTADO DO ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ACRE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.02', 'A MUNICIPIOS DO ESTADO DE ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ALAGOAS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.03', 'A MUNICIPIOS DO ESTADO DO AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO AMAPA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.04', 'A MUNICIPIOS DO ESTADO DO AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO AMAZONAS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.05', 'A MUNICIPIOS DO ESTADO DA BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DA BAHIA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.06', 'A MUNICIPIOS DO ESTADO DO CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO CEARA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.08', 'A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ESPIRITO SANTO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.09', 'A MUNICIPIOS DO ESTADO DO GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DE GOIAS DO ACRE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.10', 'A MUNICIPIOS DO ESTADO DO MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MARANHAO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.11', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MATO GROSSO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.12', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.13', 'A MUNICIPIOS DO ESTADO DE MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE MINAS GERAIS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.14', 'A MUNICIPIOS DO ESTADO DO PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PARA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.15', 'A MUNICIPIOS DO ESTADO DO PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DA PARAIBA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.16', 'A MUNICIPIOS DO ESTADO DO PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PARANA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.17', 'A MUNICIPIOS DO ESTADO DO PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE PERNAMBUCO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.18', 'A MUNICIPIOS DO ESTADO DO PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PIAUI P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.19', 'A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO DE JANEIRO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.20', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.21', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.22', 'A MUNICIPIOS DO ESTADO DE RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE RONDONIA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.23', 'A MUNICIPIOS DO ESTADO DE RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DE RORAIMA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.24', 'A MUNICIPIOS DO ESTADO DO SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SANTA CATARINA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.25', 'A MUNICIPIOS DO ESTADO DE SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SAO PAULO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.26', 'A MUNICIPIOS DO ESTADO DE SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO SERGIPE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.27', 'A MUNICIPIOS DO ESTADO DO TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE TOCANTINS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - DIARIAS - CIVIL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.01', 'A MUNICIPIOS DO ESTADO DO ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ACRE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.02', 'A MUNICIPIOS DO ESTADO DE ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ALAGOAS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.03', 'A MUNICIPIOS DO ESTADO DO AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO AMAPA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.04', 'A MUNICIPIOS DO ESTADO DO AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO AMAZONAS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.05', 'A MUNICIPIOS DO ESTADO DA BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DA BAHIA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.06', 'A MUNICIPIOS DO ESTADO DO CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO CEARA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.08', 'A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ESPIRITO SANTO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.09', 'A MUNICIPIOS DO ESTADO DO GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DE GOIAS DO ACRE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.10', 'A MUNICIPIOS DO ESTADO DO MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MARANHAO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.11', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MATO GROSSO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.12', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.13', 'A MUNICIPIOS DO ESTADO DE MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE MINAS GERAIS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.14', 'A MUNICIPIOS DO ESTADO DO PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PARA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.15', 'A MUNICIPIOS DO ESTADO DO PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DA PARAIBA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.16', 'A MUNICIPIOS DO ESTADO DO PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PARANA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.17', 'A MUNICIPIOS DO ESTADO DO PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE PERNAMBUCO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.18', 'A MUNICIPIOS DO ESTADO DO PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PIAUI P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.19', 'A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO DE JANEIRO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.20', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.21', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.22', 'A MUNICIPIOS DO ESTADO DE RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE RONDONIA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.23', 'A MUNICIPIOS DO ESTADO DE RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DE RORAIMA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.24', 'A MUNICIPIOS DO ESTADO DO SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SANTA CATARINA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.25', 'A MUNICIPIOS DO ESTADO DE SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SAO PAULO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.26', 'A MUNICIPIOS DO ESTADO DE SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO SERGIPE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.27', 'A MUNICIPIOS DO ESTADO DO TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE TOCANTINS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - PASSAGENS E DESPESAS COM LOCOMOÇAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.01', 'A MUNICIPIOS DO ESTADO DO ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ACRE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.02', 'A MUNICIPIOS DO ESTADO DE ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ALAGOAS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.03', 'A MUNICIPIOS DO ESTADO DO AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO AMAPA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.04', 'A MUNICIPIOS DO ESTADO DO AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO AMAZONAS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.05', 'A MUNICIPIOS DO ESTADO DA BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DA BAHIA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.06', 'A MUNICIPIOS DO ESTADO DO CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO CEARA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.08', 'A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ESPIRITO SANTO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.09', 'A MUNICIPIOS DO ESTADO DO GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DE GOIAS DO ACRE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.10', 'A MUNICIPIOS DO ESTADO DO MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MARANHAO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.11', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MATO GROSSO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.12', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.13', 'A MUNICIPIOS DO ESTADO DE MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE MINAS GERAIS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.14', 'A MUNICIPIOS DO ESTADO DO PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PARA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.15', 'A MUNICIPIOS DO ESTADO DO PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DA PARAIBA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.16', 'A MUNICIPIOS DO ESTADO DO PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PARANA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.17', 'A MUNICIPIOS DO ESTADO DO PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE PERNAMBUCO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.18', 'A MUNICIPIOS DO ESTADO DO PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PIAUI P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.19', 'A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO DE JANEIRO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.20', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.21', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.22', 'A MUNICIPIOS DO ESTADO DE RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE RONDONIA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.23', 'A MUNICIPIOS DO ESTADO DE RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DE RORAIMA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.24', 'A MUNICIPIOS DO ESTADO DO SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SANTA CATARINA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.25', 'A MUNICIPIOS DO ESTADO DE SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SAO PAULO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.26', 'A MUNICIPIOS DO ESTADO DE SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO SERGIPE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.27', 'A MUNICIPIOS DO ESTADO DO TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE TOCANTINS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.01', 'A MUNICIPIOS DO ESTADO DO ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ACRE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.02', 'A MUNICIPIOS DO ESTADO DE ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ALAGOAS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.03', 'A MUNICIPIOS DO ESTADO DO AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO AMAPA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.04', 'A MUNICIPIOS DO ESTADO DO AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO AMAZONAS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.05', 'A MUNICIPIOS DO ESTADO DA BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DA BAHIA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.06', 'A MUNICIPIOS DO ESTADO DO CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO CEARA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.08', 'A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ESPIRITO SANTO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.09', 'A MUNICIPIOS DO ESTADO DO GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DE GOIAS DO ACRE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.10', 'A MUNICIPIOS DO ESTADO DO MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MARANHAO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.11', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MATO GROSSO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.12', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.13', 'A MUNICIPIOS DO ESTADO DE MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE MINAS GERAIS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.14', 'A MUNICIPIOS DO ESTADO DO PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PARA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.15', 'A MUNICIPIOS DO ESTADO DO PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DA PARAIBA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.16', 'A MUNICIPIOS DO ESTADO DO PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PARANA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.17', 'A MUNICIPIOS DO ESTADO DO PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE PERNAMBUCO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.18', 'A MUNICIPIOS DO ESTADO DO PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PIAUI P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.19', 'A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO DE JANEIRO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.20', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.21', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.22', 'A MUNICIPIOS DO ESTADO DE RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE RONDONIA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.23', 'A MUNICIPIOS DO ESTADO DE RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DE RORAIMA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.24', 'A MUNICIPIOS DO ESTADO DO SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SANTA CATARINA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.25', 'A MUNICIPIOS DO ESTADO DE SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SAO PAULO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.26', 'A MUNICIPIOS DO ESTADO DE SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO SERGIPE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.27', 'A MUNICIPIOS DO ESTADO DO TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE TOCANTINS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.01', 'A MUNICIPIOS DO ESTADO DO ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ACRE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.02', 'A MUNICIPIOS DO ESTADO DE ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ALAGOAS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.03', 'A MUNICIPIOS DO ESTADO DO AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO AMAPA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.04', 'A MUNICIPIOS DO ESTADO DO AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO AMAZONAS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.05', 'A MUNICIPIOS DO ESTADO DA BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DA BAHIA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.06', 'A MUNICIPIOS DO ESTADO DO CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO CEARA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.08', 'A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ESPIRITO SANTO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.09', 'A MUNICIPIOS DO ESTADO DO GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DE GOIAS DO ACRE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.10', 'A MUNICIPIOS DO ESTADO DO MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MARANHAO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.11', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MATO GROSSO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.12', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.13', 'A MUNICIPIOS DO ESTADO DE MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE MINAS GERAIS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.14', 'A MUNICIPIOS DO ESTADO DO PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PARA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.15', 'A MUNICIPIOS DO ESTADO DO PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DA PARAIBA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.16', 'A MUNICIPIOS DO ESTADO DO PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PARANA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.17', 'A MUNICIPIOS DO ESTADO DO PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE PERNAMBUCO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.18', 'A MUNICIPIOS DO ESTADO DO PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PIAUI P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.19', 'A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO DE JANEIRO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.20', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.21', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.22', 'A MUNICIPIOS DO ESTADO DE RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE RONDONIA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.23', 'A MUNICIPIOS DO ESTADO DE RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DE RORAIMA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.24', 'A MUNICIPIOS DO ESTADO DO SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SANTA CATARINA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.25', 'A MUNICIPIOS DO ESTADO DE SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SAO PAULO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.26', 'A MUNICIPIOS DO ESTADO DE SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO SERGIPE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.27', 'A MUNICIPIOS DO ESTADO DO TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE TOCANTINS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.01', 'ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ACRE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.02', 'ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE ALAGOAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.03', 'AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO AMAPA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.04', 'AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO AMAZONAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.05', 'BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DA BAHIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.06', 'CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO CEARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.08', 'ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ESPIRITO SANTO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.09', 'GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO GOIAS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.10', 'MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MARANHÃO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.11', 'MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MATO GROSSO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.12', 'MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.13', 'MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE MINAS GERAIS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.14', 'PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PARA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.15', 'PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DA PARAIBA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.16', 'PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PARANA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.17', 'PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE PERNAMBUCO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.18', 'PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PIAUI PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.19', 'RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO DE JANEIRO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.20', 'RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.21', 'RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.22', 'RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE RONDONIA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.23', 'RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE RORAIMA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.24', 'SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SANTA CATARINA PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.25', 'SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SAO PAULO PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.26', 'SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SERGIPE PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.27', 'TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO TOCANTINS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL PARA DISTRIBUICAO GRATUITA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.01', 'A MUNICIPIOS DO ESTADO DO ACRE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ACRE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.02', 'A MUNICIPIOS DO ESTADO DE ALAGOAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ALAGOAS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.03', 'A MUNICIPIOS DO ESTADO DO AMAPA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO AMAPA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.04', 'A MUNICIPIOS DO ESTADO DO AMAZONAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO AMAZONAS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.05', 'A MUNICIPIOS DO ESTADO DA BAHIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DA BAHIA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.06', 'A MUNICIPIOS DO ESTADO DO CEARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO CEARA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.08', 'A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO ESPIRITO SANTO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.09', 'A MUNICIPIOS DO ESTADO DO GOIAS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DE GOIAS DO ACRE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.10', 'A MUNICIPIOS DO ESTADO DO MARANHAO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MARANHAO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.11', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MATO GROSSO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.12', 'A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.13', 'A MUNICIPIOS DO ESTADO DE MINAS GERAIS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE MINAS GERAIS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.14', 'A MUNICIPIOS DO ESTADO DO PARA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PARA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.15', 'A MUNICIPIOS DO ESTADO DO PARAIBA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DA PARAIBA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.16', 'A MUNICIPIOS DO ESTADO DO PARANA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PARANA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.17', 'A MUNICIPIOS DO ESTADO DO PERNAMBUCO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE PERNAMBUCO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.18', 'A MUNICIPIOS DO ESTADO DO PIAUI', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO PIAUI P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.19', 'A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO DE JANEIRO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.20', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.21', 'A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.22', 'A MUNICIPIOS DO ESTADO DE RONDONIA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE RONDONIA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.23', 'A MUNICIPIOS DO ESTADO DE RORAIMA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DE RORAIMA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.24', 'A MUNICIPIOS DO ESTADO DO SANTA CATARINA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SANTA CATARINA P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.25', 'A MUNICIPIOS DO ESTADO DE SAO PAULO', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE SAO PAULO P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.26', 'A MUNICIPIOS DO ESTADO DE SERGIPE', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DO SERGIPE P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - INDENIZAÇOES E RESTITUIÇOES', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.27', 'A MUNICIPIOS DO ESTADO DO TOCANTINS', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS MUNICIPIOS DO ESTADO DE TOCANTINS P/ EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.00.00', 'REDUCAO A VALOR RECUPERAVEL DE INVESTIMENTOS - CONSOLIDACAO', 'REGISTRA O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.2.00.00', 'REDUCAO A VALOR RECUPERAVEL DE INVESTIMENTOS - INTRA OFSS', 'REGISTRA O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.4.00.00', 'REDUCAO A VALOR RECUPERAVEL DE INVESTIMENTOS - INTER OFSS - ESTADO', 'REGISTRA O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.5.00.00', 'REDUCAO A VALOR RECUPERAVEL DE INVESTIMENTOS - INTER OFSS - MUNICIPIO', 'REGISTRA O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.2.1.00.00', 'REDUCAO A VALOR RECUPERAVEL DE IMOBILIZADO - CONSOLIDACAO', 'REGISTRA O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ITENS DO ATIVO IMOBILIZADO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.3.1.00.00', 'REDUCAO A VALOR RECUPERAVEL DE INTANGIVEIS - CONSOLIDACAO', 'REGISTRA O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ATIVOS INTANGIVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.01', 'DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - PRINCIPAL', 'REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DE CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.02', 'DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - MULTA', 'REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - MULTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.03', 'DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - JUROS', 'REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - JUROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.04', 'DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - ATUALIZACAO MONETARIA', 'REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MENETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.05', 'DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - PRINCIPAL', 'REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSAO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.06', 'DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - MULTA', 'REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSAO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - MULTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.07', 'DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - JUROS', 'REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSAO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - JUROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.08', 'DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA', 'REGISTRA OS VALORES RELATIVOS AS ANISTIAS/REMISSOES DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MOMETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.09', 'DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - PRINCIPAL', 'REGISTRA OS VALORES RELATIVOS A ADJUDICACAO DE CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.10', 'DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - MULTA', 'REGISTRA OS VALORES RELATIVOS A ADJUDICACAO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - MULTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.11', 'DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - JUROS', 'REGISTRA OS VALORES RELATIVOS AS ADJUDICACOES DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - JUROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.12', 'DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - ATUALIZACAO MONETARIA', 'REGISTRA OS VALORES RELATIVOS A ADJUDICACAO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MENETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.13', 'DIVIDA ATIVA TRIBUTARIA -ANULACAO - PRINCIPAL', 'REGISTRA OS VALORES RELATIVOS A ANULACAO DE CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.14', 'DIVIDA ATIVA TRIBUTARIA -ANULACAO - MULTA', 'REGISTRA OS VALORES RELATIVOS A ANULACAO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - MULTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.15', 'DIVIDA ATIVA TRIBUTARIA -ANULACAO - JUROS', 'REGISTRA OS VALORES RELATIVOS AS ANULACOES DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - JUROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.16', 'DIVIDA ATIVA TRIBUTARIA -ANULACAO - ATUALIZACAO MONETARIA', 'REGISTRA OS VALORES RELATIVOS A ANULACAO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MENETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.17', 'DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - PRINCIPAL', 'REGISTRA OS VALORES RELATIVOS A PRESCRICAO INTERCORRENTE DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.18', 'DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - MULTA', 'REGISTRA OS VALORES RELATIVOS A PRESCRICAO INTERCORRENTE DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - MULTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.19', 'DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - JUROS', 'REGISTRA OS VALORES RELATIVOS A PRESCRICAO INTERCORRENTE DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - JUROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.20', 'DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARI', 'REGISTRA OS VALORES RELATIVOS A PRESCRICAO INTERCORRENTE DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.21', 'DIVIDA ATIVA TRIBUTARIA -EXTINCAO - PRINCIPAL', 'REGISTRA OS VALORES RELATIVOS A EXTINCAO DE CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.22', 'DIVIDA ATIVA TRIBUTARIA -EXTINCAO - MULTA', 'REGISTRA OS VALORES RELATIVOS A EXTINCAO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - MULTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.23', 'DIVIDA ATIVA TRIBUTARIA -EXTINCAO - JUROS', 'REGISTRA OS VALORES RELATIVOS AS EXTINCOES DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - JUROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.24', 'DIVIDA ATIVA TRIBUTARIA -EXTINCAO - ATUALIZACAO MONETARIA', 'REGISTRA OS VALORES RELATIVOS A EXTINCAO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.25', 'DIVIDA ATIVA TRIBUTARIA -DESMEMBRAMENTO DE INSCRICAO - PRINCIPAL', 'REGISTRA OS VALORES RELATIVOS AO DESMEMBRAMENTO DE INSCRICAO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.26', 'DIVIDA ATIVA TRIBUTARIA -DESMEMBRAMENTO DE INSCRICAO - MULTA', 'REGISTRA OS VALORES RELATIVOS AO DESMEMBRAMENTO DE INSCRICAO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - MULTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.27', 'DIVIDA ATIVA TRIBUTARIA -DESMEMBRAMENTO DE INSCRICAO - JUROS', 'REGISTRA OS VALORES RELATIVOS AO DESMEMBRAMENTO DE INSCRICAO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - JUROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.28', 'DIVIDA ATIVA TRIBUTARIA -DESMEMBRAMENTO DE INSCRICAO-ATUAL. MONETARIA', 'REGISTRA OS VALORES RELATIVOS AO DESMEMBRAMENTO DE INSCRICAO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.29', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAES - PRINCIPAL', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAES DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.30', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAES - MULTA', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAES DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - MULTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.31', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAES - JUROS', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAES DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - JUROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.32', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAES - ATUALIZ. MONETARIA', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAES DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.33', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO REFIS - PRINCIPAL', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO REFIS DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.34', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO REFIS - MULTA', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO REFIS DOS CREDITOS INSCRITOS EM DIVIDA TRIBUTARIA - MULTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.35', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO REFIS - JUROS', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO REFIS DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - JUROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.36', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO REFIS-ATUALIZ. MONETARIA', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO REFIS DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.37', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAEX - PRINCIPAL', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAEX DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.38', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAEX - MULTA', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAEX DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - MULTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.39', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAEX - JUROS', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAEX DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - JUROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.40', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAEX - ATUALIZ. MONETARIA', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAEX DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.41', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO TIMEMANIA - PRINCIPAL', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO TIMEMANIA DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.42', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO TIMEMANIA - MULTA', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO TIMEMANIA DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - MULTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.43', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO TIMEMANIA - JUROS', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO TIMEMANIA DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - JUROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.44', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO TIMEMANIA-ATUAL.MONETARIA', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO TIMEMANIA DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.45', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCON. SIMPLES NACIONAL-PRINCIPAL', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO SIMPLES NACIONAL DO CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.46', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO SIMPLES NACIONAL - MULTA', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO SIMPLES NACIONAL DO CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - MULTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.47', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO SIMPLES NACIONAL - JUROS', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO SIMPLES NACIONAL DO CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - JUROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.48', 'DIVIDA ATIVA TRIBUTARIA -ABATIME./DESCO. SIMPLES NACIONAL-ATUA. MONETA', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO SIMPLES NACIONAL DO CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.49', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCON. CREDITO RURAL-PRINCIPAL', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO CREDITO RURAL DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.50', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO CREDITO RURAL - MULTA', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO CREDITO RURAL DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - MULTA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.51', 'DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO CREDITO RURAL - JUROS', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO CREDITO RURAL DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - JUROS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.52', 'DIVIDA ATIVA TRIBUTARIA -ABATIME./DESCO. CREDITO RURAL-ATUA. MONETA', 'REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO CREDITO RURAL DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.99.00', 'VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE OUTROS CREDITOS', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE OUTROS CREDITOS, NAO ESPECIFICADOS ACIMA,POR INADIMPLENCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CREDITOS. POR EXEMPLO, A VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA CREDITOS DE LIQUIDACAO DUVIDOSA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.2.00.00', 'VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CREDITOS - INTRA OFSS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CREDITOS POR INADIMPLENCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CREDITOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.4.00.00', 'VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CREDITOS - INTER OFSS - ESTADO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CREDITOS POR INADIMPLENCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CREDITOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.5.00.00', 'VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CREDITOS - INTER OFSS - MUNICIPIO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CREDITOS POR INADIMPLENCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CREDITOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.00.00', 'VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDACAO', 'REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA REDUCAO A VALOR DE MERCADO DE ESTOQUES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.1.1.00.00', 'PERDAS COM ALIENACAO DE INVESTIMENTOS - CONSOLIDACAO', 'REGISTRA A PERDA COM ALIENACAO DE INVESTIMENTOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.00.00', 'PERDAS COM ALIENACAO DE IMOBILIZADO - CONSOLIDACAO', 'REGISTRA A PERDA COM ALIENACAO DE ATIVOS IMOBILIZADOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.3.1.00.00', 'PERDAS COM ALIENACAO DE INTANGIVEIS - CONSOLIDACAO', 'REGISTRA A PERDA COM ALIENACAO DE ATIVOS INTANGIVEIS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.00.00', 'PERDAS INVOLUNTARIAS COM IMOBILIZADO - CONSOLIDACAO', 'REGISTRA O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ATIVO IMOBILIZADO, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDACOES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.2.1.00.00', 'PERDAS INVOLUNTARIAS COM INTANGIVEIS - CONSOLIDACAO', 'REGISTRA O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ATIVO INTANGIVEL, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDACOES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.3.1.00.00', 'PERDAS INVOLUNTARIAS COM ESTOQUES - CONSOLIDACAO', 'REGISTRA O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ESTOQUE, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDACOES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.9.1.00.00', 'OUTRAS PERDAS INVOLUNTARIAS - CONSOLIDACAO', 'REGISTRA O DESFAZIMENTO FISICO INVOLUNTARIO DE OUTROS BENS, COMO AS QUE RESULTAM DE SINISTROS COMO INCENDIO E INUNDACOES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.01.00', 'IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL', 'REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE PROPRIEDADE TERRITORIAL RURAL DE COMPETENCIA DA UNIAO RELATIVO A PROPRIEDADE, O DOMINIO UTIL OU POSSE DE IMOVEL POR NATUREZA LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO EM 01 DE JANEIRO DE CADA ANO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.02.00', 'IMPOSTO S/ PROPRIEDADE PREDIAL E TERRITORIAL URBANA', 'REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DOS MUNICIPIOS E DISTRITO FEDERAL, SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM IMOVEL POR NATUREZA OU POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICIPIO E DO DISTRITO FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.03.00', 'IMPOSTO DE RENDA', 'REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.04.00', 'ADICIONAL DO IMPOSTO DE RENDA', 'REGISTRA O VALOR DA VPD COM O ADICIONAL AO IRPJ.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.05.00', 'IMPOSTO S/ PROPRIEDADE DE VEICULOS AUTOMOTORES', 'REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.06.00', 'IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS', 'REGISTRA O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.07.00', 'IMPOSTO S/ CIRCULACAO DE MERCADORIAS E SERVICOS', 'REGISTRA O VALOR DA VPD COM IMPOSTO INCIDENTE SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTACOES DE SERVICOS DE TRANSPORTE INTERESTADUAL, INTERMUNICIPAL E DE COMUNICACAO, E E DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.08.00', 'IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA', 'REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA, DE COMPETENCIA DOS MUNICIPIOS E DO DISTRITO FEDERAL, TEM COMO FATO GERADOR A PRESTACAO DE SERVICOS CONSTANTES DA LISTA ANEXA DA LC 116/2003, AINDA QUE ESSES NAO SE CONSTITUAM COMO ATIVIDADE PREPONDERANTE DO PRESTADOR. PODE SER RECOLHIDO PELO SUBSTITUTO TRIBUTARIO CONFORME LC 116/2003.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.09.00', 'IMPOSTO S/ OPERACOES FINANCEIRAS', 'REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERACOES DE CREDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERACOES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERACOES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.10.00', 'IMPOSTO S/ IMPORTACAO', 'REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS TEM COMO FATO GERADOR A ENTRADA DESTES NO TERRITORIO NACIONAL', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.11.00', 'IMPOSTO S/ TRANSMISSAO DE IMOVEL INTER VIVOS', 'REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE A TRANSMISSAO "INTER VIVOS", A QUALQUER TITULO, POR ATO ONEROSO, DE BENS IMOVEIS, POR NATUREZA OU ACESSAO FISICA, E DE DIREITOS REAIS SOBRE IMOVEIS, EXCETO OS DE GARANTIA, BEM COMO CESSAO DE DIREITOS A SUA AQUISICAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.2.01.00', 'IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL', 'REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE PROPRIEDADE TERRITORIAL RURAL DE COMPETENCIA DA UNIAO RELATIVO A PROPRIEDADE, O DOMINIO UTIL OU POSSE DE IMOVEL POR NATUREZA LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO EM 01 DE JANEIRO DE CADA ANO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.2.02.00', 'IMPOSTO S/ PROPRIEDADE PREDIAL E TERRITORIAL URBANA', 'REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DOS MUNICIPIOS E DISTRITO FEDERAL, SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM IMOVEL POR NATUREZA OU POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICIPIO E DO DISTRITO FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.2.03.00', 'IMPOSTO DE RENDA', 'REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.2.04.00', 'ADICIONAL DO IMPOSTO DE RENDA', 'REGISTRA O VALOR DA VPD COM O ADICIONAL AO IRPJ.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.2.05.00', 'IMPOSTO S/ PROPRIEDADE DE VEICULOS AUTOMOTORES', 'REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.2.06.00', 'IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS', 'REGISTRA O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.2.07.00', 'IMPOSTO S/ CIRCULACAO DE MERCADORIAS E SERVICOS', 'REGISTRA O VALOR DA VPD COM IMPOSTO INCIDENTE SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTACOES DE SERVICOS DE TRANSPORTE INTERESTADUAL, INTERMUNICIPAL E DE COMUNICACAO, E E DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.2.08.00', 'IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA', 'REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA, DE COMPETENCIA DOS MUNICIPIOS E DO DISTRITO FEDERAL, TEM COMO FATO GERADOR A PRESTACAO DE SERVICOS CONSTANTES DA LISTA ANEXA DA LC 116/2003, AINDA QUE ESSES NAO SE CONSTITUAM COMO ATIVIDADE PREPONDERANTE DO PRESTADOR. PODE SER RECOLHIDO PELO SUBSTITUTO TRIBUTARIO CONFORME LC 116/2003.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.2.09.00', 'IMPOSTO S/ OPERACOES FINANCEIRAS', 'REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERACOES DE CREDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERACOES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERACOES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.2.10.00', 'IMPOSTO S/ IMPORTACAO', 'REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS TEM COMO FATO GERADOR A ENTRADA DESTES NO TERRITORIO NACIONAL', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.2.11.00', 'IMPOSTO S/ TRANSMISSAO DE IMOVEL INTER VIVOS', 'REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE A TRANSMISSAO "INTER VIVOS", A QUALQUER TITULO, POR ATO ONEROSO, DE BENS IMOVEIS, POR NATUREZA OU ACESSAO FISICA, E DE DIREITOS REAIS SOBRE IMOVEIS, EXCETO OS DE GARANTIA, BEM COMO CESSAO DE DIREITOS A SUA AQUISICAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.2.99.00', 'OUTROS IMPOSTOS', 'REGISTRA O VALOR DE VPDS COM OUTROS IMPOSTOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.4.01.00', 'IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL', 'REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE PROPRIEDADE TERRITORIAL RURAL DE COMPETENCIA DA UNIAO RELATIVO A PROPRIEDADE, O DOMINIO UTIL OU POSSE DE IMOVEL POR NATUREZA LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO EM 01 DE JANEIRO DE CADA ANO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.4.02.00', 'IMPOSTO S/ PROPRIEDADE PREDIAL E TERRITORIAL URBANA', 'REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DOS MUNICIPIOS E DISTRITO FEDERAL, SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM IMOVEL POR NATUREZA OU POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICIPIO E DO DISTRITO FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.4.03.00', 'IMPOSTO DE RENDA', 'REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I - DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II - DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.4.04.00', 'ADICIONAL DO IMPOSTO DE RENDA', 'REGISTRA O VALOR DA VPD COM O ADICIONAL AO IRPJ.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.4.05.00', 'IMPOSTO S/ PROPRIEDADE DE VEICULOS AUTOMOTORES', 'REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.4.06.00', 'IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS', 'REGISTRA O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I - O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II - A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III - A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA-SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.4.07.00', 'IMPOSTO S/ CIRCULACAO DE MERCADORIAS E SERVICOS', 'REGISTRA O VALOR DA VPD COM IMPOSTO INCIDENTE SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTACOES DE SERVICOS DE TRANSPORTE INTERESTADUAL, INTERMUNICIPAL E DE COMUNICACAO, E E DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.4.08.00', 'IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA', 'REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA, DE COMPETENCIA DOS MUNICIPIOS E DO DISTRITO FEDERAL, TEM COMO FATO GERADOR A PRESTACAO DE SERVICOS CONSTANTES DA LISTA ANEXA DA LC 116/2003, AINDA QUE ESSES NAO SE CONSTITUAM COMO ATIVIDADE PREPONDERANTE DO PRESTADOR. PODE SER RECOLHIDO PELO SUBSTITUTO TRIBUTARIO CONFORME LC 116/2003.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.4.09.00', 'IMPOSTO S/ OPERACOES FINANCEIRAS', 'REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERACOES DE CREDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERACOES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERACOES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.4.10.00', 'IMPOSTO S/ IMPORTACAO', 'REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS TEM COMO FATO GERADOR A ENTRADA DESTES NO TERRITORIO NACIONAL', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.4.11.00', 'IMPOSTO S/ TRANSMISSAO DE IMOVEL INTER VIVOS', 'REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE A TRANSMISSAO "INTER VIVOS", A QUALQUER TITULO, POR ATO ONEROSO, DE BENS IMOVEIS, POR NATUREZA OU ACESSAO FISICA, E DE DIREITOS REAIS SOBRE IMOVEIS, EXCETO OS DE GARANTIA, BEM COMO CESSAO DE DIREITOS A SUA AQUISICAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.4.99.00', 'OUTROS IMPOSTOS', 'REGISTRA O VALOR DE VPDS COM OUTROS IMPOSTOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.5.01.00', 'IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL', 'REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE PROPRIEDADE TERRITORIAL RURAL DE COMPETENCIA DA UNIAO RELATIVO A PROPRIEDADE, O DOMINIO UTIL OU POSSE DE IMOVEL POR NATUREZA LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO EM 01 DE JANEIRO DE CADA ANO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.5.02.00', 'IMPOSTO S/ PROPRIEDADE PREDIAL E TERRITORIAL URBANA', 'REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DOS MUNICIPIOS E DISTRITO FEDERAL, SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM IMOVEL POR NATUREZA OU POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICIPIO E DO DISTRITO FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.5.03.00', 'IMPOSTO DE RENDA', 'REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I - DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II - DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.5.04.00', 'ADICIONAL DO IMPOSTO DE RENDA', 'REGISTRA O VALOR DA VPD COM O ADICIONAL AO IRPJ.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.5.05.00', 'IMPOSTO S/ PROPRIEDADE DE VEICULOS AUTOMOTORES', 'REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.5.06.00', 'IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS', 'REGISTRA O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I - O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II - A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III - A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA-SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.5.07.00', 'IMPOSTO S/ CIRCULACAO DE MERCADORIAS E SERVICOS', 'REGISTRA O VALOR DA VPD COM IMPOSTO INCIDENTE SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTACOES DE SERVICOS DE TRANSPORTE INTERESTADUAL, INTERMUNICIPAL E DE COMUNICACAO, E E DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.5.08.00', 'IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA', 'REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA, DE COMPETENCIA DOS MUNICIPIOS E DO DISTRITO FEDERAL, TEM COMO FATO GERADOR A PRESTACAO DE SERVICOS CONSTANTES DA LISTA ANEXA DA LC 116/2003, AINDA QUE ESSES NAO SE CONSTITUAM COMO ATIVIDADE PREPONDERANTE DO PRESTADOR. PODE SER RECOLHIDO PELO SUBSTITUTO TRIBUTARIO CONFORME LC 116/2003.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.5.09.00', 'IMPOSTO S/ OPERACOES FINANCEIRAS', 'REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERACOES DE CREDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERACOES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERACOES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.5.11.00', 'IMPOSTO S/ TRANSMISSAO DE IMOVEL INTER VIVOS', 'REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE A TRANSMISSAO "INTER VIVOS", A QUALQUER TITULO, POR ATO ONEROSO, DE BENS IMOVEIS, POR NATUREZA OU ACESSAO FISICA, E DE DIREITOS REAIS SOBRE IMOVEIS, EXCETO OS DE GARANTIA, BEM COMO CESSAO DE DIREITOS A SUA AQUISICAO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.5.99.00', 'OUTROS IMPOSTOS', 'REGISTRA O VALOR DE VPDS COM OUTROS IMPOSTOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.2.1.00.00', 'TAXAS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TAXAS COBRADAS PELA UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS CONTRIBUICOES,DECORRENTES DA CONTRAPRESTACAO DE SERVICOS PUBLICOS AO CONTRIBUINTE POSTOS A SUA DISPOSICAO, INCLUSIVE O EXERCICIO DE PODER DE POLICIA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.2.2.00.00', 'TAXAS - INTRA OFSS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TAXAS COBRADAS PELA UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS CONTRIBUICOES,DECORRENTES DA CONTRAPRESTACAO DE SERVICOS PUBLICOS AO CONTRIBUINTE POSTOS A SUA DISPOSICAO, INCLUSIVE O EXERCICIO DE PODER DE POLICIA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.2.4.00.00', 'TAXAS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TAXAS COBRADAS PELA UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS CONTRIBUICOES, DECORRENTES DA CONTRAPRESTACAO DE SERVICOS PUBLICOS AO CONTRIBUINTE POSTOS A SUA DISPOSICAO, INCLUSIVE O EXERCICIO DE PODER DE POLICIA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.2.5.00.00', 'TAXAS - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TAXAS COBRADAS PELA UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS CONTRIBUICOES, DECORRENTES DA CONTRAPRESTACAO DE SERVICOS PUBLICOS AO CONTRIBUINTE POSTOS A SUA DISPOSICAO, INCLUSIVE O EXERCICIO DE PODER DE POLICIA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.3.1.00.00', 'CONTRIBUICOES DE MELHORIA - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TITULO CUJA OBRIGACAO TEM POR FATO GERADOR UM BENEFICIO ESPECIAL AUFERIDO PELO CONTRIBUINTE QUE POR CONSEQUENCIA PROMOVE UMA VALORIZACAO IMOBILIARIA E PATRIM ONIAL DECORRENTE DE OBRA PUBLICA DE COMPETENCIA DA UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS, AMPARADAS EM LEI E LIMITADAS AO TOTAL DA DESPESA PUBLICA REALIZADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.3.2.00.00', 'CONTRIBUICOES DE MELHORIA - INTRA OFSS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TRIBUTO CUJA OBRIGACAO TEM POR FATO GERADOR UM BENEFICIO ESPECIAL AUFERIDO PELO CONTRIBUINTE QUE POR CONSEQUENCIA PROMOVE UMA VALORIZACAO IMOBILIARIA E PATRIMONIAL DECORRENTE DE OBRA PUBLICA DE COMPETENCIA DA UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS, AMPARADAS EM LEI E LIMITADAS AO TOTAL DA DESPESA PUBLICA REALIZADA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.3.4.00.00', 'CONTRIBUICOES DE MELHORIA - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TRIBUTO CUJA OBRIGACAO TEM POR FATO GERADOR UM BENEFICIO ESPECIAL AUFERIDO PELO CONTRIBUINTE QUE POR CONSEQUENCIA PROMOVE UMA VALORIZACAO IMOBILIARIA E PATRIMONIAL DECORRENTE DE OBRA PUBLICA DE COMPETENCIA DA UNIAO, ESTADOS,DISTRITO FEDERAL OU MUNICIPIOS, AMPARADAS EM LEI E LIMITADAS AO TOTAL DA DESPESA PUBLICA REALIZADA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.3.5.00.00', 'CONTRIBUICOES DE MELHORIA - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TRIBUTO CUJA OBRIGACAO TEM POR FATO GERADOR UM BENEFICIO ESPECIAL AUFERIDO PELO CONTRIBUINTE QUE POR CONSEQUENCIA PROMOVE UMA VALORIZACAO IMOBILIARIA E PATRIMONIAL DECORRENTE DE OBRA PUBLICA DE COMPETENCIA DA UNIAO, ESTADOS,DISTRITO FEDERAL OU MUNICIPIOS, AMPARADAS EM LEI E LIMITADAS AO TOTAL DA DESPESA PUBLICA REALIZADA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.1.01.00', 'CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS', 'REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.1.02.00', 'PIS/PASEP', 'REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA O PROGRAMA DE INTEGRACAO SOCIAL(PIS) OU PARA O PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO(PASEP)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.1.03.00', 'CONTRIBUICAO SOCIAL S/ LUCRO LIQUIDO - CSLL', 'REGISTRA O VALOR DA VPD COM CONTRIBUICAO SOCIAL INCIDENTE SOBRE O LUCRO DA PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.1.04.00', 'OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA FISICA', 'REGISTRA O VALOR DA VPD COM CONTRIBUICOES PREVIDENCIARIAS SOBRE SERVICOS DE TERCEIROS PESSOAS FISICAS CONTRATADAS PARA A EXECUCAO DE SERVICOS, SEM VINCULO COM A ADMINISTRACAO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.1.05.00', 'OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA JURIDICA', 'REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES SOBRE SERVICOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO: - INSS (LEI 9876/99)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.1.99.00', 'OUTRAS CONTRIBUICOES SOCIAIS', 'REGISTRA O VALOR DA VPD COM OUTRAS CONTRIBUICOES SOCIAIS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.2.01.00', 'CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS', 'REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.2.02.00', 'PIS/PASEP', 'REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA O PROGRAMA DE INTEGRACAO SOCIAL(PIS) OU PARA O PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO(PASEP)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.2.03.00', 'CONTRIBUICAO SOCIAL S/ LUCRO LIQUIDO - CSLL', 'REGISTRA O VALOR DA VPD COM CONTRIBUICAO SOCIAL INCIDENTE SOBRE O LUCRO DA PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.2.04.00', 'OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA FISICA', 'REGISTRA O VALOR DA VPD COM CONTRIBUICOES PREVIDENCIARIAS SOBRE SERVICOS DE TERCEIROS PESSOAS FISICAS CONTRATADAS PARA A EXECUCAO DE SERVICOS, SEM VINCULO COM A ADMINISTRACAO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.2.05.00', 'OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA JURIDICA', 'REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES SOBRE SERVICOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO: - INSS (LEI 9876/99)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.2.99.00', 'OUTRAS CONTRIBUICOES SOCIAIS', 'REGISTRA O VALOR DA VPD COM OUTRAS CONTRIBUICOES SOCIAIS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.4.01.00', 'CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS', 'REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.4.02.00', 'PIS/PASEP', 'REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA O PROGRAMA DE INTEGRACAO SOCIAL(PIS) OU PARA O PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO(PASEP)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.4.03.00', 'CONTRIBUICAO SOCIAL S/ LUCRO LIQUIDO - CSLL', 'REGISTRA O VALOR DA VPD COM CONTRIBUICAO SOCIAL INCIDENTE SOBRE O LUCRO DA PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.4.04.00', 'OBRIGACOES PATRONAIS S/ SERVICOS DE FISICA', 'REGISTRA O VALOR DA VPD COM CONTRIBUICOES PREVIDENCIARIAS SOBRE SERVICOS DE TERCEIROS PESSOAS FISICAS CONTRATADAS PARA A EXECUCAO DE SERVICOS, SEM VINCULO COM A ADMINISTRACAO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.4.05.00', 'OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA JURIDICA', 'REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES SOBRE SERVICOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO: - INSS (LEI 9876/99)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.4.99.00', 'OUTRAS CONTRIBUICOES SOCIAIS', 'REGISTRA O VALOR DA VPD COM OUTRAS CONTRIBUICOES SOCIAIS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.5.01.00', 'CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS', 'REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.5.02.00', 'PIS/PASEP', 'REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA O PROGRAMA DE INTEGRACAO SOCIAL(PIS) OU PARA O PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO(PASEP)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.5.03.00', 'CONTRIBUICAO SOCIAL S/ LUCRO LIQUIDO - CSLL', 'REGISTRA O VALOR DA VPD COM CONTRIBUICAO SOCIAL INCIDENTE SOBRE O LUCRO DA PESSOA JURIDICA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.5.04.00', 'OBRIGACOES PATRONAIS S/ SERVICOS DE FISICA', 'REGISTRA O VALOR DA VPD COM CONTRIBUICOES PREVIDENCIARIAS SOBRE SERVICOS DE TERCEIROS PESSOAS FISICAS CONTRATADAS PARA A EXECUCAO DE SERVICOS, SEM VINCULO COM A ADMINISTRACAO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.5.05.00', 'OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA JURIDICA', 'REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES SOBRE SERVICOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO: - INSS (LEI 9876/99)', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.5.99.00', 'OUTRAS CONTRIBUICOES SOCIAIS', 'REGISTRA O VALOR DA VPD COM OUTRAS CONTRIBUICOES SOCIAIS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.1.01.00', 'CONTRIBUICAO SINDICAL', 'REGISTRA O VALOR DA DESPESA COM ENCARGOS PATRONAIS RELATIVO A CONTRIBUICAO SINDICAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.1.99.00', 'OUTRAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS CONTRIBUICOES ECONOMICAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.2.01.00', 'CONTRIBUICAO SINDICAL', 'REGISTRA O VALOR DA DESPESA COM ENCARGOS PATRONAIS RELATIVO A CONTRIBUICAO SINDICAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.2.99.00', 'OUTRAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS CONTRIBUICOES ECONOMICAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.4.01.00', 'CONTRIBUICAO SINDICAL', 'REGISTRA O VALOR DA DESPESA COM ENCARGOS PATRONAIS RELATIVO A CONTRIBUICAO SINDICAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.4.99.00', 'OUTRAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS CONTRIBUICOES ECONOMICAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.5.01.00', 'CONTRIBUICAO SINDICAL', 'REGISTRA O VALOR DA DESPESA COM ENCARGOS PATRONAIS RELATIVO A CONTRIBUICAO SINDICAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.5.99.00', 'OUTRAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS CONTRIBUICOES ECONOMICAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.3.1.00.00', 'CONTRIBUICAO PARA O CUSTEIO DO SERVICO DE ILUMINACAO PUBLICA - COSIP - CONSOLIDACAO', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM A CONTRIBUICAO PARA CUSTEIO DA ILUMINACAO PUBLICA ( ART.149-A DA CF). COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.3.2.00.00', 'CONTRIBUICAO PARA O CUSTEIO DO SERVICO DE ILUMINACAO PUBLICA - COSIP- INTRA OFSS', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM A CONTRIBUICAO PARA CUSTEIO DA ILUMINACAO PUBLICA ( ART.149-A DA CF).COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.3.4.00.00', 'CONTRIBUICAO PARA O CUSTEIO DO SERVICO DE ILUMINACAO PUBLICA - COSIP - INTER OFSS - ESTADO', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM A CONTRIBUICAO PARA CUSTEIO DA ILUMINACAO PUBLICA ( ART.149-A DA CF).COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.3.5.00.00', 'CONTRIBUICAO PARA O CUSTEIO DO SERVICO DE ILUMINACAO PUBLICA - COSIP - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM A CONTRIBUICAO PARA CUSTEIO DA ILUMINACAO PUBLICA ( ART.149-A DA CF).COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.9.1.01.00', 'CONTRIBUICAO DE CARATER EMERGENCIAL', 'REGISTRA O VALOR DA VPD COM CONTRIBUICOES DE CARATER EMERGENCIAL DE SERVICOS PRESTADOS PELAS CONCESSIONARIAS, PERMISSIONARIAS E AUTORIZADAS DE GERACAO E DE DISTRIBUICAO DE ENERGIA ELETRICA, REGULAMENTADA PELA LEI FEDERAL 10.438 DE 26 DE ABRIL DE 2002.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.9.1.02.00', 'CONTRIBUICAO P/ O FUST- FUNDO DE UNIVERSALIZACAO DOS SERVICOS DE TELECOMUNICACOES', 'REGISTRA O VALOR DAS APROPRIACOES DE VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DO PAGAMENTO DA CONTRIBUICAO AO FUST, A ALIQUOTA DE UM POR CENTO SOBRE A RECEITA OPERACCIONAL BRUTA, DECORRENTE DA PRESTACAO DE SERVICOS DE TELECOMUNICACOES NOS REGIMES PUBLICOS E PRIVADO, EXCLUINDO-SE O ICMS, O PIS E A COFINS INCIDENTES SOBRE A MESMA BASE DE CALCULO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.9.2.01.00', 'CONTRIBUICAO DE CARATER EMERGENCIAL', 'REGISTRA O VALOR DA VPD COM CONTRIBUICOES DE CARATER EMERGENCIAL DE SERVICOS PRESTADOS PELAS CONCESSIONARIAS, PERMISSIONARIAS E AUTORIZADAS DE GERACAO E DE DISTRIBUICAO DE ENERGIA ELETRICA, REGULAMENTADA PELA LEI FEDERAL 10.438 DE 26 DE ABRIL DE 2002.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.9.2.03.00', 'CONTRIBUICAO FOMENTO DA RADIODIFUSAO PUBLICA', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICAO PARA O FOMENTO DA RADIO- DIFUSAO PUBLICA, INSTITUIDA PELA LEI 11.652, DE 07 DE ABRIL DE 2008, ARTIGO 32.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.9.4.01.00', 'CONTRIBUICAO DE CARATER EMERGENCIAL', 'REGISTRA O VALOR DA VPD COM CONTRIBUICOES DE CARATER EMERGENCIAL DE SERVICOS PRESTADOS PELAS CONCESSIONARIAS, PERMISSIONARIAS E AUTORIZADAS DE GERACAO E DE DISTRIBUICAO DE ENERGIA ELETRICA, REGULAMENTADA PELA LEI FEDERAL 10.438 DE 26 DE ABRIL DE 2002.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.9.5.01.00', 'CONTRIBUICAO DE CARATER EMERGENCIAL', 'REGISTRA O VALOR DA VPD COM CONTRIBUICOES DE CARATER EMERGENCIAL DE SERVICOS PRESTADOS PELAS CONCESSIONARIAS, PERMISSIONARIAS E AUTORIZADAS DE GERACAO E DE DISTRIBUICAO DE ENERGIA ELETRICA, REGULAMENTADA PELA LEI FEDERAL 10.438 DE 26 DE ABRIL DE 2002.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.01.00', 'CMV - IMPOSTOS', 'REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.02.00', 'CMV - TAXAS', 'REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.03.00', 'CMV - CONTRIBUICAO DE MELHORIA', 'REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.04.00', 'CMV - CONTRIBUICOES SOCIAIS', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.05.00', 'CMV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.06.00', 'CMV - ContribuiCOes de IntervenCAo no DomInio EconOmico', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.07.00', 'CMV - OUTRAS CONTRIBUICOES', 'REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.2.01.00', 'CMV - IMPOSTOS', 'REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.2.02.00', 'CMV - TAXAS', 'REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.2.03.00', 'CMV - CONTRIBUICAO DE MELHORIA', 'REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.2.04.00', 'CMV - CONTRIBUICOES SOCIAIS', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.2.05.00', 'CMV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.2.06.00', 'CMV - ContribuiCOes de IntervenCAo no DomInio EconOmico', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.2.07.00', 'CMV - OUTRAS CONTRIBUICOES', 'REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.4.01.00', 'CMV - IMPOSTOS', 'REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.4.02.00', 'CMV - TAXAS', 'REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.4.03.00', 'CMV - CONTRIBUICAO DE MELHORIA', 'REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.4.04.00', 'CMV - CONTRIBUICOES SOCIAIS', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.4.05.00', 'CMV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.4.06.00', 'CMV - ContribuiCOes de IntervenCAo no DomInio EconOmico', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.4.07.00', 'CMV - OUTRAS CONTRIBUICOES', 'REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.5.01.00', 'CMV - IMPOSTOS', 'REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.5.02.00', 'CMV - TAXAS', 'REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.5.03.00', 'CMV - CONTRIBUICAO DE MELHORIA', 'REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.5.04.00', 'CMV - CONTRIBUICOES SOCIAIS', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.5.05.00', 'CMV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.5.06.00', 'CMV - ContribuiCOes de IntervenCAo no DomInio EconOmico', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.5.07.00', 'CMV - OUTRAS CONTRIBUICOES', 'REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DAS MERCADORIAS VENDIDAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.01.00', 'CPV - IMPOSTOS', 'REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.02.00', 'CPV - TAXAS', 'REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.03.00', 'CPV - CONTRIBUICAO DE MELHORIA', 'REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.04.00', 'CPV - CONTRIBUICOES SOCIAIS', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.05.00', 'CPV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.06.00', 'CPV - ContribuiCOes de IntervenCAo no DomInio EconOmico', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.07.00', 'CPV - OUTRAS CONTRIBUICOES', 'REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.2.02.00', 'CPV - TAXAS', 'REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.2.03.00', 'CPV - CONTRIBUICAO DE MELHORIA', 'REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.2.04.00', 'CPV - CONTRIBUICOES SOCIAIS', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.2.05.00', 'CPV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.2.06.00', 'CPV - ContribuiCOes de IntervenCAo no DomInio EconOmico', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.2.07.00', 'CPV - OUTRAS CONTRIBUICOES', 'REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.4.01.00', 'CPV - IMPOSTOS', 'REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.4.02.00', 'CPV - TAXAS', 'REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.4.03.00', 'CPV - CONTRIBUICAO DE MELHORIA', 'REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.4.04.00', 'CPV - CONTRIBUICOES SOCIAIS', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.4.05.00', 'CPV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.4.06.00', 'CPV - ContribuiCOes de IntervenCAo no DomInio EconOmico', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.4.07.00', 'CPV - OUTRAS CONTRIBUICOES', 'REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.5.01.00', 'CPV - IMPOSTOS', 'REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.5.02.00', 'CPV - TAXAS', 'REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.5.03.00', 'CPV - CONTRIBUICAO DE MELHORIA', 'REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.5.04.00', 'CPV - CONTRIBUICOES SOCIAIS', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.5.05.00', 'CPV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.5.06.00', 'CPV - ContribuiCOes de IntervenCAo no DomInio EconOmico', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.5.07.00', 'CPV - OUTRAS CONTRIBUICOES', 'REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS PRODUTOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.01.00', 'CSP - IMPOSTOS', 'REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.02.00', 'CSP - TAXAS', 'REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.03.00', 'CSP - CONTRIBUICAO DE MELHORIA', 'REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.04.00', 'CSP - CONTRIBUICOES SOCIAIS', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.05.00', 'CSP - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.06.00', 'CSP - ContribuiCOes de IntervenCAo no DomInio EconOmico', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.07.00', 'CSP - OUTRAS CONTRIBUICOES', 'REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.2.01.00', 'CSP - IMPOSTOS', 'REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.2.02.00', 'CSP - TAXAS', 'REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.2.03.00', 'CSP - CONTRIBUICAO DE MELHORIA', 'REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.2.04.00', 'CSP - CONTRIBUICOES SOCIAIS', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.2.05.00', 'CSP - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.2.06.00', 'CSP - ContribuiCOes de IntervenCAo no DomInio EconOmico', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.2.07.00', 'CSP - OUTRAS CONTRIBUICOES', 'REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.4.01.00', 'CSP - IMPOSTOS', 'REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.4.02.00', 'CSP - TAXAS', 'REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.4.03.00', 'CSP - CONTRIBUICAO DE MELHORIA', 'REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.4.04.00', 'CSP - CONTRIBUICOES SOCIAIS', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.4.05.00', 'CSP - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.4.06.00', 'CSP - ContribuiCOes de IntervenCAo no DomInio EconOmico', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.4.07.00', 'CSP - OUTRAS CONTRIBUICOES', 'REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.5.01.00', 'CSP - IMPOSTOS', 'REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.5.02.00', 'CSP - TAXAS', 'REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.5.03.00', 'CSP - CONTRIBUICAO DE MELHORIA', 'REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.5.04.00', 'CSP - CONTRIBUICOES SOCIAIS', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.5.05.00', 'CSP - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.5.06.00', 'CSP - ContribuiCOes de IntervenCAo no DomInio EconOmico', 'REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.5.07.00', 'CSP - OUTRAS CONTRIBUICOES', 'REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS SERVICOS VENDIDOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.1.1.00.00', 'PREMIACOES CULTURAIS - CONSOLIDACAO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CULTURAL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.1.2.00.00', 'PREMIACOES CULTURAIS - INTRA OFSS', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CULTURAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.1.4.00.00', 'PREMIACOES CULTURAIS - INTER OFSS - ESTADO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CULTURAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.1.5.00.00', 'PREMIACOES CULTURAIS - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CULTURAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.2.1.00.00', 'PREMIACOES ARTISTICAS - CONSOLIDACAO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER ARTISTICO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.2.2.00.00', 'PREMIACOES ARTISTICAS - INTRA OFSS', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER ARTISTICO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.2.4.00.00', 'PREMIACOES ARTISTICAS - INTER OFSS - ESTADO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER ARTISTICO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.2.5.00.00', 'PREMIACOES ARTISTICAS - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER ARTISTICO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.3.1.00.00', 'PREMIACOES CIENTIFICAS - CONSOLIDACAO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CIENTIFICO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.3.2.00.00', 'PREMIACOES CIENTIFICAS - INTRA OFSS', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CIENTIFICO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.3.4.00.00', 'PREMIACOES CIENTIFICAS - INTER OFSS - ESTADO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CIENTIFICO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.3.5.00.00', 'PREMIACOES CIENTIFICAS - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CIENTIFICO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.4.1.00.00', 'PREMIACOES DESPORTIVAS - CONSOLIDACAO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER DESPORTIVO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.4.2.00.00', 'PREMIACOES DESPORTIVAS - INTRA OFSS', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER DESPORTIVO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.4.4.00.00', 'PREMIACOES DESPORTIVAS - INTER OFSS - ESTADO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER DESPORTIVO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.4.5.00.00', 'PREMIACOES DESPORTIVAS - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER DESPORTIVO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.5.1.00.00', 'ORDENS HONORIFICAS - CONSOLIDACAO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, INSIGNIAS ETC, RELATIVO A ORDENS HONORIFICAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.5.2.00.00', 'ORDENS HONORIFICAS - INTRA OFSS', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, INSIGNIAS ETC, RELATIVO A ORDENS HONORIFICAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.5.4.00.00', 'ORDENS HONORIFICAS - INTER OFSS - ESTADO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, INSIGNIAS ETC, RELATIVO A ORDENS HONORIFICAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.5.5.00.00', 'ORDENS HONORIFICAS - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, INSIGNIAS ETC, RELATIVO A ORDENS HONORIFICAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.9.1.00.00', 'OUTRAS PREMIACOES - CONSOLIDACAO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, PARA FINALIDADES DIFERENTES DAS PREVISTAS NOS DETALHAMENTOS ANTERIORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.9.1.01.00', 'BONUS ESPECIAL DE DESEMPENHO INSTITUCIONAL - BESP/DNIT', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM BONUS ESPECIAL DE DESEMPENHO INSTITUCIONAL - BESP/DNIT AOS SERVIDORES DO DEPARTAMENTO DE INFRA-ESTRUTURA DE TRANSPORTE - DNIT - LEI Nº 12.155, DE 23/12/2009.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.9.2.00.00', 'OUTRAS PREMIACOES - INTRA OFSS', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, PARA FINALIDADES DIFERENTES DAS PREVISTAS NOS DETALHAMENTOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.9.4.00.00', 'OUTRAS PREMIACOES - INTER OFSS - ESTADO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, PARA FINALIDADES DIFERENTES DAS PREVISTAS NOS DETALHAMENTOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.9.5.00.00', 'OUTRAS PREMIACOES - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, PARA FINALIDADES DIFERENTES DAS PREVISTAS NOS DETALHAMENTOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.2.1.1.00.00', 'RESULTADO NEGATIVO DE EQUIVALENCIA PATRIMONIAL - CONSOLIDACAO', 'REGISTRA A APROPRIACAO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUIZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.2.1.2.00.00', 'RESULTADO NEGATIVO DE EQUIVALENCIA PATRIMONIAL - INTRA OFSS', 'REGISTRA A APROPRIACAO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUIZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.2.1.4.00.00', 'RESULTADO NEGATIVO DE EQUIVALENCIA PATRIMONIAL - INTER OFSS - ESTADO', 'REGISTRA A APROPRIACAO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUIZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.2.1.5.00.00', 'RESULTADO NEGATIVO DE EQUIVALENCIA PATRIMONIAL - INTER OFSS - MUNICIPIO', 'REGISTRA A APROPRIACAO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUIZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.01.01', 'VPD COM OPERACOES COM TITULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES DA AUTORIDADES MONETARIA COM TITULOS DE MERCADO E DE OUTRAS NATUREZAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.01.02', 'VPD COM OPERACOES DA AREA EXTERNA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES NA AREA EXTERNA REALIZADAS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.01.03', 'VPD COM OPERACOES DA AREA BANCARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES NA AREA BANCARIA REALIZADAS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.01.04', 'VPD COM REMUNERACAO SOBRE DEP.A ORDEM DO GOV.FEDERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO SOBRE DEPOSITOS A ORDEM DO GOVERNO FEDERAL EFETUADOS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.01.05', 'VPD COM TITULOS/VALORES OPERACOES C/DERIVATIVOS(SWAP) -OPERACOES COM DERIVATIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS OCORRIDAS EM OPERACOES COM DERIVATIVOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.01.99', 'VPD COM OUTRAS OPERACOES DE AUTORIDADE MONETARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A OUTRAS OPERACOES DE NATUREZA EVENTUAL REALIZADAS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.02.01', 'VPD DE CAPTACAO', 'REGISTRA O VALOR REFERENTE A VPD DE CAPTACAO DE RECURSOS PELAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.02.02', 'VPD DE OBRIGACOES EMPRESTIMOS E REPASSES', 'REGISTRA O VALOR REFERENTE A VPD DE OBRIGACOES COM EMPRESTIMOS E REPASSES DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.02.03', 'VPD COM RESULTADO DE CAMBIO', 'REGISTRA O VALOR DA VPD REFERENTE AO RESULTADO NEGATIVO DE CAMBIO DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.02.04', 'RES.DE TRANSACOES C/TIT.DE VAL.MOBILIARIOS', 'REGISTRA O VALOR DA VPD REFERENTES AO RESULTADO NEGATIVO DE TRAN SACOES COM TITULOS E VALORES MOBILIARIOS REALIZADOS PELAS INSTITUICOES FINANCEIRAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.02.05', 'VPD DE PARTICIPACOES', 'REGISTRA O VALOR DA VPD DE INSTITUICAO FINANCEIRA COM O RESULTADO NEGATIVO DAS PARTICIPACOES SOCIETARIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.02.06', 'VPD ADMINISTRATIVAS', 'REGISTRA O VALOR DA VPD QUE VISEM A DIRECAO OU GESTAO DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.02.07', 'APROVISIONAMENTO E AJUSTES PATRIMONIAIS', 'REGISTRA O VALOR DA VPD REFERENTE A APROVISIONAMENTO E AJUSTES PATRIMONIAIS REALIZADAS PELAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.02.99', 'OUTRAS DESPESAS OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'REGISTRA O VALOR REFERENTE A OUTRAS DESPESAS DE NATUREZA EVENTUAL VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.03.00', 'VPD NAO OPERACIONAIS', 'REGISTRA O VALOR DA VPD COM TRANSACOES REALIZADAS NO PERIODO, NAO VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.04.00', 'RATEIO DE RESULTADOS INTERNOS', 'REGISTRA O VALOR DA VPD DE INSTITUICOES FINANCEIRAS COM DISTRIBUICAO DE RESULTADOS INTERNOS NEGATIVOS DO EXERCICIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.01.01', 'VPD COM OPERACOES COM TITULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES DA AUTORIDADES MONETARIA COM TITULOS DE MERCADO E DE OUTRAS NATUREZAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.01.02', 'VPD COM OPERACOES DA AREA EXTERNA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES NA AREA EXTERNA REALIZADAS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.01.03', 'VPD COM OPERACOES DA AREA BANCARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES NA AREA BANCARIA REALIZADAS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.01.04', 'VPD COM REMUNERACAO SOBRE DEP.A ORDEM DO GOV.FEDERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO SOBRE DEPOSITOS A ORDEM DO GOVERNO FEDERAL EFETUADOS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.01.05', 'VPD COM TITULOS/VALORES OPERACOES C/DERIVATIVOS(SWAP) -OPERACOES COM DERIVATIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS OCORRIDAS EM OPERACOES COM DERIVATIVOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.01.99', 'VPD COM OUTRAS OPERACOES DE AUTORIDADE MONETARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A OUTRAS OPERACOES DE NATUREZA EVENTUAL REALIZADAS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.02.01', 'VPD DE CAPTACAO', 'REGISTRA O VALOR REFERENTE A VPD DE CAPTACAO DE RECURSOS PELAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.02.02', 'VPD DE OBRIGACOES EMPRESTIMOS E REPASSES', 'REGISTRA O VALOR REFERENTE A VPD DE OBRIGACOES COM EMPRESTIMOS E REPASSES DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.02.03', 'VPD COM RESULTADO DE CAMBIO', 'REGISTRA O VALOR DA VPD REFERENTE AO RESULTADO NEGATIVO DE CAMBIO DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.02.04', 'RES.DE TRANSACOES C/TIT.DE VAL.MOBILIARIOS', 'REGISTRA O VALOR DA VPD REFERENTES AO RESULTADO NEGATIVO DE TRANSACOES COM TITULOS E VALORES MOBILIARIOS REALIZADOS PELAS INSTITUICOES FINANCEIRAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.02.05', 'VPD DE PARTICIPACOES', 'REGISTRA O VALOR DA VPD DE INSTITUICAO FINANCEIRA COM O RESULTADO NEGATIVO DAS PARTICIPACOES SOCIETARIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.02.06', 'VPD ADMINISTRATIVAS', 'REGISTRA O VALOR DA VPD QUE VISEM A DIRECAO OU GESTAO DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.02.07', 'APROVISIONAMENTO E AJUSTES PATRIMONIAIS', 'REGISTRA O VALOR DA VPD REFERENTE A APROVISIONAMENTO E AJUSTES PATRIMONIAIS REALIZADAS PELAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.02.99', 'OUTRAS DESPESAS OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'REGISTRA O VALOR REFERENTE A OUTRAS DESPESAS DE NATUREZA EVENTUAL VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.03.00', 'VPD NAO OPERACIONAIS', 'REGISTRA O VALOR DA VPD COM TRANSACOES REALIZADAS NO PERIODO, NAO VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.04.00', 'RATEIO DE RESULTADOS INTERNOS', 'REGISTRA O VALOR DA VPD DE INSTITUICOES FINANCEIRAS COM DISTRIBUICAO DE RESULTADOS INTERNOS NEGATIVOS DO EXERCICIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.01.01', 'VPD COM OPERACOES COM TITULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES DA AUTORIDADES MONETARIA COM TITULOS DE MERCADO E DE OUTRAS NATUREZAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.01.02', 'VPD COM OPERACOES DA AREA EXTERNA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES NA AREA EXTERNA REALIZADAS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.01.03', 'VPD COM OPERACOES DA AREA BANCARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES NA AREA BANCARIA REALIZADAS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.01.04', 'VPD COM REMUNERACAO SOBRE DEP.A ORDEM DO GOV.FEDERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO SOBRE DEPOSITOS A ORDEM DO GOVERNO FEDERAL EFETUADOS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.01.05', 'VPD COM TITULOS/VALORES OPERACOES C/DERIVATIVOS(SWAP) -OPERACOES COM DERIVATIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS OCORRIDAS EM OPERACOES COM DERIVATIVOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.01.99', 'VPD COM OUTRAS OPERACOES DE AUTORIDADE MONETARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A OUTRAS OPERACOES DE NATUREZA EVENTUAL REALIZADAS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.02.01', 'VPD DE CAPTACAO', 'REGISTRA O VALOR REFERENTE A VPD DE CAPTACAO DE RECURSOS PELAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.02.02', 'VPD DE OBRIGACOES EMPRESTIMOS E REPASSES', 'REGISTRA O VALOR REFERENTE A VPD DE OBRIGACOES COM EMPRESTIMOS E REPASSES DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.02.03', 'VPD COM RESULTADO DE CAMBIO', 'REGISTRA O VALOR DA VPD REFERENTE AO RESULTADO NEGATIVO DE CAMBIO DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.02.04', 'RES.DE TRANSACOES C/TIT.DE VAL.MOBILIARIOS', 'REGISTRA O VALOR DA VPD REFERENTES AO RESULTADO NEGATIVO DE TRANSACOES COM TITULOS E VALORES MOBILIARIOS REALIZADOS PELAS INSTITUICOES FINANCEIRAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.02.05', 'VPD DE PARTICIPACOES', 'REGISTRA O VALOR DA VPD DE INSTITUICAO FINANCEIRA COM O RESULTADO NEGATIVO DAS PARTICIPACOES SOCIETARIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.02.06', 'VPD ADMINISTRATIVAS', 'REGISTRA O VALOR DA VPD QUE VISEM A DIRECAO OU GESTAO DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.02.07', 'APROVISIONAMENTO E AJUSTES PATRIMONIAIS', 'REGISTRA O VALOR DA VPD REFERENTE A APROVISIONAMENTO E AJUSTES PATRIMONIAIS REALIZADAS PELAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.02.99', 'OUTRAS DESPESAS OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'REGISTRA O VALOR REFERENTE A OUTRAS DESPESAS DE NATUREZA EVENTUAL VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.03.00', 'VPD NAO OPERACIONAIS', 'REGISTRA O VALOR DA VPD COM TRANSACOES REALIZADAS NO PERIODO, NAO VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.04.00', 'RATEIO DE RESULTADOS INTERNOS', 'REGISTRA O VALOR DA VPD DE INSTITUICOES FINANCEIRAS COM DISTRIBUICAO DE RESULTADOS INTERNOS NEGATIVOS DO EXERCICIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.01.01', 'VPD COM OPERACOES COM TITULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES DA AUTORIDADES MONETARIA COM TITULOS DE MERCADO E DE OUTRAS NATUREZAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.01.02', 'VPD COM OPERACOES DA AREA EXTERNA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES NA AREA EXTERNA REALIZADAS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.01.03', 'VPD COM OPERACOES DA AREA BANCARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES NA AREA BANCARIA REALIZADAS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.01.04', 'VPD COM REMUNERACAO SOBRE DEP.A ORDEM DO GOV.FEDERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO SOBRE DEPOSITOS A ORDEM DO GOVERNO FEDERAL EFETUADOS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.01.05', 'VPD COM TITULOS/VALORES OPERACOES C/DERIVATIVOS(SWAP) -OPERACOES COM DERIVATIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS OCORRIDAS EM OPERACOES COM DERIVATIVOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.01.99', 'VPD COM OUTRAS OPERACOES DE AUTORIDADE MONETARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A OUTRAS OPERACOES DE NATUREZA EVENTUAL REALIZADAS PELA AUTORIDADE MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.02.01', 'VPD DE CAPTACAO', 'REGISTRA O VALOR REFERENTE A VPD DE CAPTACAO DE RECURSOS PELAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.02.02', 'VPD DE OBRIGACOES EMPRESTIMOS E REPASSES', 'REGISTRA O VALOR REFERENTE A VPD DE OBRIGACOES COM EMPRESTIMOS E REPASSES DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.02.03', 'VPD COM RESULTADO DE CAMBIO', 'REGISTRA O VALOR DA VPD REFERENTE AO RESULTADO NEGATIVO DE CAMBIO DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.02.04', 'RES.DE TRANSACOES C/TIT.DE VAL.MOBILIARIOS', 'REGISTRA O VALOR DA VPD REFERENTES AO RESULTADO NEGATIVO DE TRANSACOES COM TITULOS E VALORES MOBILIARIOS REALIZADOS PELAS INSTITUICOES FINANCEIRAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.02.05', 'VPD DE PARTICIPACOES', 'REGISTRA O VALOR DA VPD DE INSTITUICAO FINANCEIRA COM O RESULTADO NEGATIVO DAS PARTICIPACOES SOCIETARIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.02.06', 'VPD ADMINISTRATIVAS', 'REGISTRA O VALOR DA VPD QUE VISEM A DIRECAO OU GESTAO DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.02.07', 'APROVISIONAMENTO E AJUSTES PATRIMONIAIS', 'REGISTRA O VALOR DA VPD REFERENTE A APROVISIONAMENTO E AJUSTES PATRIMONIAIS REALIZADAS PELAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.02.99', 'OUTRAS DESPESAS OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'REGISTRA O VALOR REFERENTE A OUTRAS DESPESAS DE NATUREZA EVENTUAL VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.03.00', 'VPD NAO OPERACIONAIS', 'REGISTRA O VALOR DA VPD COM TRANSACOES REALIZADAS NO PERIODO, NAO VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.04.00', 'RATEIO DE RESULTADOS INTERNOS', 'REGISTRA O VALOR DA VPD DE INSTITUICOES FINANCEIRAS COM DISTRIBUICAO DE RESULTADOS INTERNOS NEGATIVOS DO EXERCICIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.1.1.01.00', 'BOLSA DE ESTUDOS NO PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM BOLSAS DE ESTUDO NO PAIS, A QUALQUER TITULO, E DEMAIS AUXILIOS FINANCEIROS A ESTUDANTES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.1.1.02.00', 'BOLSA DE ESTUDOS NO EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM BOLSAS DE ESTUDO NO EXTERIOR, A QUALQUER TITULO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.1.1.03.00', 'AUXILIOS PARA DESENV. DE ESTUDOS E PESQUISAS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM CONCESSAO DE AUXILIOS FINANCEIROS A ESTUDANTES PARA DESENVOLVIMENTO DE ESTUDOS E PESQUISAS DE NATUREZA CIENTIFICA, OBSERVADO O DISPOSTO NO ART. 26 DA LEI COMPLEMENTAR N.101, DE 2000.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.1.1.98.00', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.1.1.99.00', 'OUTROS INCENTIVOS A EDUCACAO', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INCENTIVOS A EDUCACAO NAO CONTEMPLADOS NOS ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.2.1.01.00', 'AUXILIO A PESQUISADORES', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO FINANCEIRO A PESQUISADORES, INDIVIDUAL OU COLETIVAMENTE, EXCETO NA CONDICAO DE ESTUDANTE, NO DESENVOLVIMENTO DE PESQUISAS CIENTIFICAS E TECNOLOGICAS, NAS SUAS DIVERSAS MODALIDADES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.2.1.02.00', 'AUXILIO AS ATIVIDADES AUXILIARES DE PESQUISA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO FINANC.A PESQUISADOR RELAT.AO APOIO AAS ATIVIDADES AUXILIARES DE PESQUISA, EM ATENDIMENTO AA RESOLUCAO N° 08/06-COPLAD, EDITADA PELO CONSELHO DE PLANEJAMENTO E ADMINISTRACAO DA UNIVERSIDADE FEDERAL DO PARANA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.2.1.99.00', 'OUTROS INCENTIVOS A CIENCIA', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INCENTIVOS A CULTURA CONTEMPLADOS NOS ITENS ANTERIORES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.3.1.00.00', 'INCENTIVOS A CULTURA - CONSOLIDACAO', 'REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DA CULTURA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.3.2.00.00', 'INCENTIVOS A CULTURA - INTRA OFSS', 'REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DA CULTURA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.3.4.00.00', 'INCENTIVOS A CULTURA - INTER OFSS - ESTADO', 'REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DA CULTURA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.3.5.00.00', 'INCENTIVOS A CULTURA - INTER OFSS - MUNICIPIO', 'REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DA CULTURA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.4.1.00.00', 'INCENTIVOS AO ESPORTE - CONSOLIDACAO', 'REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DO ESPORTE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.4.2.00.00', 'INCENTIVOS AO ESPORTE - INTRA OFSS', 'REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DO ESPORTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.4.4.00.00', 'INCENTIVOS AO ESPORTE - INTER OFSS - ESTADO', 'REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DO ESPORTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.4.5.00.00', 'INCENTIVOS AO ESPORTE - INTER OFSS - MUNICIPIO', 'REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DO ESPORTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.9.1.00.00', 'OUTROS INCENTIVOS - CONSOLIDACAO', 'REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.9.2.00.00', 'OUTROS INCENTIVOS - INTRA OFSS', 'REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.9.4.00.00', 'OUTROS INCENTIVOS - INTER OFSS - ESTADO', 'REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.9.5.00.00', 'OUTROS INCENTIVOS - INTER OFSS - MUNICIPIO', 'REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.01.00', 'CORRECAO MONETARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CORRECAO MONETARIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.02.00', 'DIFERENCIAL DE JUROS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE EQUALIZACOES COM DIFERENCIAL DE TAXAS DE JUROS, PREVISTO EM CONTRATO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.03.00', 'PROGRAMA ESPECIAL DE SANEAMENTO ATIVOS - PESA', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O PROGRAMA ESPECIAL DE SANEAMENTO DE ATIVOS - PESA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.04.00', 'PROGRAMA DE INVESTIMENTO RURAL AGROINDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O PROGRAMA DE IN- VESTIMENTO RURAL AGROINDUSTRIAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.05.00', 'INCENTIVOS - FORNECIMENTO DE OLEO DIESEL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM EQUALIZACAO DE PRECOS REFERENTES A INCENTIVOS COM FORNECIMENTO DE OLEO DIESEL A EMBARCACOES PESQUEIRAS NACIONAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.06.00', 'GARANTIA E SUSTENTACAO DE PRECOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GARANTIA E SUSTENTACAO DE PRECOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.07.00', 'PROGRAMA DE SUBS.A HABIT.DE INTER.SOCIAL-PSH', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O PROGRAMA DE SUBISIDIO A HABITACAO DE INTERESSE SOCIAL - PSH', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.08.00', 'CUSTOS ADMINISTRATIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE EQUALIZACOES REFERENTES AOS CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO PREVISTO EM CONTRATO. DECISAO TCU 498/2002, 15/03/02', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.09.00', 'CUSTEIO AGROPECUARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DO CUSTO DE CAPTCAO E APLICACAO DE RECURSOS NO PROGRAMA DE ASSENTAMENTO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.10.00', 'EMPRESTIMOS DO GOVERNO FEDERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O DIFERENCIAL DE PRECO ENTRE A CAPTCAO E APLICACAO DE RECURSOS EM PROGRAMAS DE EMPRESTIMOS DO GOVERNO FEDERAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.11.00', 'AQUISICOES DO GOVERNO FEDERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O DIFERENCIAL DE PRECO NAS AQUISICOES DE PRODUTOS PARA O ESTOQUE REGULADOR DO GOVERNO FEDERAL', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.12.00', 'PROG. NAC. FORTALEC. AGRIC. FAMILIAR', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PRONAF, SUBSIDIO PARA ASSENTAMENTO FAMILIAR.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.13.00', 'SUBVENCAO ECONOMICA AO PREMIO DO SEGURO RURAL', 'REGISTRA A SUBVENCAO ECONOMICA AO PREMIO DO SEGURO RURAL.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.14.00', 'PARCELA NAO RECUPERAVEL-UNIVERSALIZACAO/FUST', 'REGISTRA AS APLICACOES DE RECURSOS DO FUNDO DE UNIVERSALIZACAO DAS TELECOMUNICACOES - FUST, NO AMBITO DO PROJETO DE "ATENDIMENTO AS INSTITUICOES DE ASSISTENCIA AAS PESSOAS COM DEFICIENCIA AUDITIVA", MEDIANTE SUBVENCAO AOS PRECOS COBRADOS PELAS OPERADORAS DO SISTEMA DE TELEFONIA, CORRESPONDENTE AOS CUSTOS NAO RECUPERAVEIS DAS CONCESSIONARIAS COM A EXECUCAO DO REFERIDO PROJETO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.15.00', 'REVITALIZACAO-REESTRUT.PRODUT.E EXPORT- JUROS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM EQUALIZACAO DE JUROS EM FINANCIAMENTOS DESTINADOS A REESTRUTURACAO PRODUTIVA E AS EXPORTACOES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.16.00', 'PROGRAMA DE FARMACIA POPULAR DO BRASIL', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O PROGRAMA DE SUBSIDIOS DE PRECOS DE MEDICAMENTOS DISPONIBILIZADOS POR INTERMEDIO DA REDE PRIVADA DE FARMACIAS E DROGARIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.17.00', 'PROGRAMA MINHA CASA, MINHA VIDA - PMCMV', 'REGISTRA O VALOR DAS APROPRIACOES DE VARIACOES PATRIMONIAIS DIMINUTIVAS COM O PROGRAMA MINHA CASA, MINHA VIDA - PMCMV - REGULAMENTADO PELA LEI NR. 11977/2009', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.18.00', 'SUBVENCAO ECONOMICA S/ PREMIO SEGURO GARANTIA', 'REGISTRA A SUBVENCAO ECONOMICA AO PREMIO DO SEGURO GARANTIA.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.19.00', 'AQUISICAO E PRODUCAO DE BENS DE CAPITAL', 'REGISTRA O VALOR DE APROPRIACAO DE VARIACOES PATRIMONIAIS DIMINUTIVAS COM EQUALIZACAO DE TAXAS DE JUROS NAS OPERACOES DE FINANCIAMENTO DESTINADOS A AQUISICAO E PRODUCAO DE BENS DE CAPITAL E A INOVACAO TECNOLOGICA (MP 465, DE 2009).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.98.00', 'INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI', 'REGISTRA O VALOR DAS DESPESAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.99.00', 'OUTRAS EQUALIZACOES DE PRECOS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS EQUALIZACOES DE PRECOS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.1.1.00.00', 'PARTICIPACOES DE DEBENTURES - CONSOLIDACAO', 'REGISTRA AS PARTICIPACOES DE DEBENTURES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.1.2.00.00', 'PARTICIPACOES DE DEBENTURES - INTRA OFSS', 'REGISTRA AS PARTICIPACOES DE DEBENTURES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.1.4.00.00', 'PARTICIPACOES DE DEBENTURES - INTER OFSS - ESTADO', 'REGISTRA AS PARTICIPACOES DE DEBENTURES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.1.5.00.00', 'PARTICIPACOES DE DEBENTURES - INTER OFSS - MUNICIPIO', 'REGISTRA AS PARTICIPACOES DE DEBENTURES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.2.1.00.00', 'PARTICIPACOES DE EMPREGADOS - CONSOLIDACAO', 'REGISTRA AS PARTICIPACOES DE EMPREGADOS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.3.1.00.00', 'PARTICIPACOES DE ADMINISTRADORES - CONSOLIDACAO', 'REGISTRA AS PARTICIPACOES DE ADMINISTRADORES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.4.1.00.00', 'PARTICIPACOES DE PARTES BENEFICIARIAS - CONSOLIDACAO', 'REGISTRA AS PARTICIPACOES DE PARTES BENEFICIARIAS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.4.2.00.00', 'PARTICIPACOES DE PARTES BENEFICIARIAS - INTRA OFSS', 'REGISTRA AS PARTICIPACOES DE PARTES BENEFICIARIAS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.4.4.00.00', 'PARTICIPACOES DE PARTES BENEFICIARIAS - INTER OFSS - ESTADO', 'REGISTRA AS PARTICIPACOES DE PARTES BENEFICIARIAS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.4.5.00.00', 'PARTICIPACOES DE PARTES BENEFICIARIAS - INTER OFSS - MUNICIPIO', 'REGISTRA AS PARTICIPACOES DE PARTES BENEFICIARIAS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.5.1.00.00', 'PARTICIPACOES DE INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS - CONSOLIDACAO', 'REGISTRA AS CONTRIBUICOES DA EMPRESA, INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO, PARA INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.5.2.00.00', 'PARTICIPACOES DE INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS - INTRA OFSS', 'REGISTRA AS CONTRIBUICOES DA EMPRESA, INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO, PARA INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.5.4.00.00', 'PARTICIPACOES DE INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS- INTER OFSS - ESTADO', 'REGISTRA AS CONTRIBUICOES DA EMPRESA, INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO, PARA INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.5.5.00.00', 'PARTICIPACOES DE INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS -INTER OFSS - MUNICIPIO', 'REGISTRA AS CONTRIBUICOES DA EMPRESA, INCIDENTES SOBRE O LUCRO APOS IM POSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO, PARA INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.1.1.00.00', 'VPD DE PROVISAO PARA RISCOS TRABALHISTAS - CONSOLIDACAO', 'REGISTRA OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE RECLAMACOES TRABALHISTAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.2.1.00.00', 'VPD DE PROVISOES MATEMATICAS PREVIDENCIARIAS A LONGO PRAZO - CONSOLIDACAO', 'REGISTRA A CONSTITUICAO DE PROVISOES DE PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A FUTUROS BENEFICIOS PREVIDENCIARIOS A SEREM PAGOS AOS CONTRIBUINTES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.3.1.00.00', 'VPD DE PROVISOES PARA RISCOS FISCAIS - CONSOLIDACAO', 'REGISTRA A CONSTITUICAO DE PROVISOES DE PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUACOES FISCAIS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.4.1.00.00', 'VPD DE PROVISAO PARA RISCOS CIVEIS - CONSOLIDACAO', 'REGISTRA A CONSTITUICAO DE PROVISOES DE PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.5.4.00.00', 'VPD DE PROVISAO PARA REPARTICAO DE CREDITOS - INTER OFSS - ESTADO', 'REGISTRA A CONSTITUICAO DE PROVISOES DE PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CREDITOS TRIBUTARIOS E NAO TRIBUTARIOS RECONHECIDOS NO LANCAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERACAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.5.5.00.00', 'VPD DE PROVISAO PARA REPARTICAO DE CREDITOS - INTER OFSS - MUNICIPIO', 'REGISTRA A CONSTITUICAO DE PROVISOES DE PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CREDITOS TRIBUTARIOS E NAO TRIBUTARIOS RECONHECIDOS NO LANCAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERACAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.6.1.00.00', 'VPD DE PROVISAO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP - CONSOLIDACAO', 'REGISTRA A CONSTITUICAO DE PROVISOES DE PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUCAO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.9.1.00.00', 'VPD DE OUTRAS PROVISOES - CONSOLIDACAO', 'REGISTRA A CONSTITUICAO DE PROVISOES DE PASSIVOS DE PRAZO OU DE VALOR INCERTOS NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.1.1.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - OUTRAS VPD - CONSOLIDACAO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.1.2.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - OUTRAS VPD - INTRA OFSS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.1.4.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - OUTRAS VPD - INTER OFSS - ESTADO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.1.5.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - OUTRAS VPD - INTER OFSS - MUNICIPIO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.2.1.00.00', 'CUSTO DE PRODUTOS VENDIDOS - OUTRAS VPD - CONSOLIDACAO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.2.2.00.00', 'CUSTO DE PRODUTOS VENDIDOS - OUTRAS VPD - INTRA OFSS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.2.4.00.00', 'CUSTO DE PRODUTOS VENDIDOS - OUTRAS VPD - INTER OFSS - ESTADO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.2.5.00.00', 'CUSTO DE PRODUTOS VENDIDOS - OUTRAS VPD - INTER OFSS - MUNICIPIO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.3.1.00.00', 'CUSTO DE SERVICOS PRESTADOS - OUTRAS VPD - CONSOLIDACAO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.3.2.00.00', 'CUSTO DE SERVICOS PRESTADOS - OUTRAS VPD - INTRA OFSS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.3.4.00.00', 'CUSTO DE SERVICOS PRESTADOS - OUTRAS VPD - INTER OFSS - ESTADO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.3.5.00.00', 'CUSTO DE SERVICOS PRESTADOS - OUTRAS VPD - INTER OFSS - MUNICIPIO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.1.2.00.00', 'COMPENSACAO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.1.4.00.00', 'COMPENSACAO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.1.5.00.00', 'COMPENSACAO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.2.4.00.00', 'COMPENSACAO FINANCEIRA ENTRE REGIMES PROPRIOS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.2.5.00.00', 'COMPENSACAO FINANCEIRA ENTRE REGIMES PROPRIOS- INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.3.1.00.00', 'VARIACAO PATRIMONIAL DIMINUTIVA COM BONIFICACOES - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE BONIFICACOES CONCEDIDAS NA VENDA DE MERCADORIAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.3.2.00.00', 'VARIACAO PATRIMONIAL DIMINUTIVA COM BONIFICACOES - INTRA OFSS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE BONIFICACOES CONCEDIDAS NA VENDA DE MERCADORIAS . COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.3.4.00.00', 'VARIACAO PATRIMONIAL DIMINUTIVA COM BONIFICACOES - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE BONIFICACOES CONCEDIDAS NA VENDA DE MERCADORIAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.3.5.00.00', 'VARIACAO PATRIMONIAL DIMINUTIVA COM BONIFICACOES - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE BONIFICACOES CONCEDIDAS NA VENDA DE MERCADORIAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.4.1.00.00', 'AMORTIZACAO DE AGIO EM INVESTIMENTOS -CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZACAO DE AGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.4.2.00.00', 'AMORTIZACAO DE AGIO EM INVESTIMENTOS - INTRA OFSS', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZACAO DE AGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.4.4.00.00', 'AMORTIZACAO DE AGIO EM INVESTIMENTOS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZACAO DE AGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.4.5.00.00', 'AMORTIZACAO DE AGIO EM INVESTIMENTOS - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZACAO DE AGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.9.1.01.00', 'PROVISAO MATEMATICAS PREVIDENCIARIAS', 'REGISTRA O VALOR DAS CONSTITUICOES DAS PROVISOES MATEMATICAS PREVIDENCIARIAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.9.1.02.00', 'HONRA DE AVAIS', 'REGISTRA OS VALORES QUE A ADMINISTRACAO E COMPELIDA A REALIZAR EM DECORRENCIA DE HONRA DE AVAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.9.2.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.9.2.02.00', 'HONRA DE AVAIS', 'REGISTRA OS VALORES QUE A ADMINISTRACAO E COMPELIDA A REALIZAR EM DECORRENCIA DE HONRA DE AVAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.9.4.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.9.4.02.00', 'HONRA DE AVAIS', 'REGISTRA OS VALORES QUE A ADMINISTRACAO E COMPELIDA A REALIZAR EM DECORRENCIA DE HONRA DE AVAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.9.5.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.9.5.02.00', 'HONRA DE AVAIS', 'REGISTRA OS VALORES QUE A ADMINISTRACAO E COMPELIDA A REALIZAR EM DECORRENCIA DE HONRA DE AVAIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.1.01.00', 'IMPOSTO S/ IMPORTACAO', 'REGISTRA VPA COM O IMPOSTO SOBRE IMPORTACAO, DE COMPETENCIA DA UNIAO, QUE INCIDE SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS E TEM COMO FATO GERADOR A ENTRADA DESSES PRODUTOS NO TERRITORIO NACIONAL, POR QUALQUER VIA DE ACESSO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.1.02.00', 'IMPOSTO S/ EXPORTACAO', 'REGISTRA VPA COM O IMPOSTO SOBRE A EXPORTACAO, DE COMPETENCIA DA UNIAO. INCIDE SOBRE A EXPORTACAO, PARA O ESTRANGEIRO, DE PRODUTOS NACIONAIS OU NACIONALIZADOS E TEM COMO FATO GERADOR A SAIDA DESSES PRODUTOS DO TERRITORIO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.1.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.2.01.00', 'IMPOSTO S/ IMPORTACAO', 'REGISTRA VPA COM O IMPOSTO SOBRE IMPORTACAO, DE COMPETENCIA DA UNIAO, QUE INCIDE SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS E TEM COMO FATO GERADOR A ENTRADA DESSES PRODUTOS NO TERRITORIO NACIONAL, POR QUALQUER VIA DE ACESSO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.2.02.00', 'IMPOSTO S/ EXPORTACAO', 'REGISTRA VPA COM O IMPOSTO SOBRE A EXPORTACAO, DE COMPETENCIA DA UNIAO. INCIDE SOBRE A EXPORTACAO, PARA O ESTRANGEIRO, DE PRODUTOS NACIONAIS OU NACIONALIZADOS E TEM COMO FATO GERADOR A SAIDA DESSES PRODUTOS DO TERRITORIO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.2.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.4.01.00', 'IMPOSTO S/ IMPORTACAO', 'REGISTRA VPA COM O IMPOSTO SOBRE IMPORTACAO, DE COMPETENCIA DA UNIAO, QUE INCIDE SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS E TEM COMO FATO GERADOR A ENTRADA DESSES PRODUTOS NO TERRITORIO NACIONAL, POR QUALQUER VIA DE ACESSO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.4.02.00', 'IMPOSTO S/ EXPORTACAO', 'REGISTRA VPA COM O IMPOSTO SOBRE A EXPORTACAO, DE COMPETENCIA DA UNIAO. INCIDE SOBRE A EXPORTACAO, PARA O ESTRANGEIRO, DE PRODUTOS NACIONAIS OU NACIONALIZADOS E TEM COMO FATO GERADOR A SAIDA DESSES PRODUTOS DO TERRITORIO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.4.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.5.01.00', 'IMPOSTO S/ IMPORTACAO', 'REGISTRA VPA COM O IMPOSTO SOBRE IMPORTACAO, DE COMPETENCIA DA UNIAO, QUE INCIDE SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS E TEM COMO FATO GERADOR A ENTRADA DESSES PRODUTOS NO TERRITORIO NACIONAL, POR QUALQUER VIA DE ACESSO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.5.02.00', 'IMPOSTO S/ EXPORTACAO', 'REGISTRA VPA COM O IMPOSTO SOBRE A EXPORTACAO, DE COMPETENCIA DA UNIAO. INCIDE SOBRE A EXPORTACAO, PARA O ESTRANGEIRO, DE PRODUTOS NACIONAIS OU NACIONALIZADOS E TEM COMO FATO GERADOR A SAIDA DESSES PRODUTOS DO TERRITORIO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.5.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.01.01', 'ITR - MUNICIPIOS CONVENIADOS', 'REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS. - FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO, CONFORME CONVENIO COM A UNIAO PARA FISCALIZACAO DO REFERIDO IMPOSTO; - DESTINACAO LEGAL: O MUNICIPIO OU O DISTRITO FEDERAL OPTANTE FARA JUS A TOTALIDADE DO PRODUTO DA ARRECADACAO DO ITR REFERENTE AOS IMOVEIS RURAIS NELE SITUADOS, A PARTIR DO MOMENTO DISCIPLINADO NO CONVENIO; - AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III B)LEI 5172/1966 ART 29 A 31 C) EC 42/2003 D) LEI 9393/1996 E) LEI 11250/2005', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.01.02', 'ITR - MUNICIPIOS NAO CONVENIADOS', 'REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS NAO-CONVENIADOS. - FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO NAO-CONVENIADO; _ 50% PERTENCEM A UNIAO E 50% PERTENCEM AOS MUNICIPIOS ONDE OS IMOVEIS ESTIVEREM SITUADOS, CONFORME ART 158, II DA CF/1988; - AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III; B)LEI 5172/1966 ART 29 A 31; C) EC 42/2003; D) LEI 9393/1996; C) EC 42/2003.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.02.01', 'IR - PESSOAS FISICAS', 'REGISTRA O VALOR TOTAL QUE INCIDE SOBRE OS RENDIMENTOS E GANHOS DE CAPITAL PERCEBIDOS PELAS PESSOAS FISICAS RESIDENTES OU DOMICILIADAS NO BRASIL. INTEGRAM O RENDIMENTO BRUTO SUJEITO A INCIDENCIA DESSE IMPOSTO O GANHO DE CAPITAL DECORRENTE DA ALIENACAO DE BENS E DIREITOS E OS GANHOS LIQUIDOS AUFERIDOS EM OPERACOES REALIZADAS NAS BOLSAS DE VALORES E ASSEMELHADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.02.02', 'IR - PESSOAS JURIDICAS - LIQUIDA DE INCENTIVOS', 'REGISTRA O VALOR DA VPA COM O IMPOSTO DE RENDA DAS PESSOAS JURIDICAS - LIQUIDA DE INCENTIVOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.02.03', 'IR RETIDO NAS FONTES - TRABALHO', 'REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - TRABALHO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.02.04', 'IR RETIDO NAS FONTES - CAPITAL', 'REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - CAPITAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.02.05', 'IR RETIDO NAS FONTES - REMESSA AO EXTERIOR', 'REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - REMESSA AO EXTERIOR', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.02.06', 'IR RETIDO NAS FONTES - OUTROS RENDIMENTOS', 'REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - OUTROS RENDIMENTOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.02.07', 'IRPJ - SIMPLES FEDERAL E NACIONAL', 'REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE IMPOSTO DE RENDA PESSO A JURIDICA - SIMPLES FEDERAL E NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.2.01.01', 'ITR - MUNICIPIOS CONVENIADOS', 'REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS. - FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO, CONFORME CONVENIO COM A UNIAO PARA FISCALIZACAO DO REFERIDO IMPOSTO; - DESTINACAO LEGAL: O MUNICIPIO OU O DISTRITO FEDERAL OPTANTE FARA JUS A TOTALIDADE DO PRODUTO DA ARRECADACAO DO ITR REFERENTE AOS IMOVEIS RURAIS NELE SITUADOS, A PARTIR DO MOMENTO DISCIPLINADO NO CONVENIO; - AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III B)LEI 5172/1966 ART 29 A 31 C) EC 42/2003 D) LEI 9393/1996 E) LEI 11250/2005', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.2.01.02', 'ITR - MUNICIPIOS NAO CONVENIADOS', 'REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS NAO-CONVENIADOS. - FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO NAO-CONVENIADO; _ 50% PERTENCEM A UNIAO E 50% PERTENCEM AOS MUNICIPIOS ONDE OS IMOVEIS ESTIVEREM SITUADOS, CONFORME ART 158, II DA CF/1988; - AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III; B)LEI 5172/1966 ART 29 A 31; C) EC 42/2003; D) LEI 9393/1996; C) EC 42/2003.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.2.02.02', 'IR - PESSOAS JURIDICAS - LIQUIDA DE INCENTIVOS', 'REGISTRA O VALOR DA VPA COM O IMPOSTO DE RENDA DAS PESSOAS JURIDICAS - LIQUIDA DE INCENTIVOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.2.02.04', 'IR RETIDO NAS FONTES - CAPITAL', 'REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - CAPITAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.2.02.05', 'IR RETIDO NAS FONTES - REMESSA AO EXTERIOR', 'REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - REMESSA AO EXTERIOR', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.2.02.06', 'IR RETIDO NAS FONTES - OUTROS RENDIMENTOS', 'REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - OUTROS RENDIMENTOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.2.02.07', 'IRPJ - SIMPLES FEDERAL E NACIONAL', 'REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE IMPOSTO DE RENDA PESSO A JURIDICA - SIMPLES FEDERAL E NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.2.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.4.01.01', 'ITR - MUNICIPIOS CONVENIADOS', 'REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS. - FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO, CONFORME CONVENIO COM A UNIAO PARA FISCALIZACAO DO REFERIDO IMPOSTO; - DESTINACAO LEGAL: O MUNICIPIO OU O DISTRITO FEDERAL OPTANTE FARA JUS A TOTALIDADE DO PRODUTO DA ARRECADACAO DO ITR REFERENTE AOS IMOVEIS RURAIS NELE SITUADOS, A PARTIR DO MOMENTO DISCIPLINADO NO CONVENIO; - AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III B)LEI 5172/1966 ART 29 A 31 C) EC 42/2003 D) LEI 9393/1996 E) LEI 11250/2005', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.4.01.02', 'ITR - MUNICIPIOS NAO CONVENIADOS', 'REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS NAO-CONVENIADOS. - FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO NAO-CONVENIADO; _ 50% PERTENCEM A UNIAO E 50% PERTENCEM AOS MUNICIPIOS ONDE OS IMOVEIS ESTIVEREM SITUADOS, CONFORME ART 158, II DA CF/1988; - AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III; B)LEI 5172/1966 ART 29 A 31; C) EC 42/2003; D) LEI 9393/1996; C) EC 42/2003.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.4.02.02', 'IR - PESSOAS JURIDICAS - LIQUIDA DE INCENTIVOS', 'REGISTRA O VALOR DA VPA COM O IMPOSTO DE RENDA DAS PESSOAS JURIDICAS - LIQUIDA DE INCENTIVOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.4.02.04', 'IR RETIDO NAS FONTES - CAPITAL', 'REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - CAPITAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.4.02.05', 'IR RETIDO NAS FONTES - REMESSA AO EXTERIOR', 'REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - REMESSA AO EXTERIOR', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.4.02.06', 'IR RETIDO NAS FONTES - OUTROS RENDIMENTOS', 'REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - OUTROS RENDIMENTOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.4.02.07', 'IRPJ - SIMPLES FEDERAL E NACIONAL', 'REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE IMPOSTO DE RENDA PESSOA JURIDICA - SIMPLES FEDERAL E NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.4.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.5.01.01', 'ITR - MUNICIPIOS CONVENIADOS', 'REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS. - FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO, CONFORME CONVENIO COM A UNIAO PARA FISCALIZACAO DO REFERIDO IMPOSTO; - DESTINACAO LEGAL: O MUNICIPIO OU O DISTRITO FEDERAL OPTANTE FARA JUS A TOTALIDADE DO PRODUTO DA ARRECADACAO DO ITR REFERENTE AOS IMOVEIS RURAIS NELE SITUADOS, A PARTIR DO MOMENTO DISCIPLINADO NO CONVENIO; - AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III B)LEI 5172/1966 ART 29 A 31 C) EC 42/2003 D) LEI 9393/1996 E) LEI 11250/2005', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.5.01.02', 'ITR - MUNICIPIOS NAO CONVENIADOS', 'REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS NAO-CONVENIADOS. - FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO NAO-CONVENIADO; _ 50% PERTENCEM A UNIAO E 50% PERTENCEM AOS MUNICIPIOS ONDE OS IMOVEIS ESTIVEREM SITUADOS, CONFORME ART 158, II DA CF/1988; - AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III; B)LEI 5172/1966 ART 29 A 31; C) EC 42/2003; D) LEI 9393/1996; C) EC 42/2003.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.5.02.02', 'IR - PESSOAS JURIDICAS - LIQUIDA DE INCENTIVOS', 'REGISTRA O VALOR DA VPA COM O IMPOSTO DE RENDA DAS PESSOAS JURIDICAS - LIQUIDA DE INCENTIVOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.5.02.04', 'IR RETIDO NAS FONTES - CAPITAL', 'REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - CAPITAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.5.02.05', 'IR RETIDO NAS FONTES - REMESSA AO EXTERIOR', 'REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - REMESSA AO EXTERIOR', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.5.02.06', 'IR RETIDO NAS FONTES - OUTROS RENDIMENTOS', 'REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - OUTROS RENDIMENTOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.5.02.07', 'IRPJ - SIMPLES FEDERAL E NACIONAL', 'REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE IMPOSTO DE RENDA PESSOA JURIDICA - SIMPLES FEDERAL E NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.5.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.01.01', 'IPI -PRODUTOS DO FUMO', 'REGISTRA A VPA COM O IPI - PRODUTOS DO FUMO. INCIDENTE SOBRE O FUMO (TABACO) NAO MANUFATURADO, CHARUTOS, CIGARRILHAS E CIGARROS DE FUMO E SOBRE OUTROS PRODUTOS DO FUMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.01.02', 'IPI - BEBIDAS', 'REGISTRA A VPA COM O IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS INCIDENTE SOBRE BEBIDAS ALCOOLICAS, REFRIGERANTES, REFRESCOS, AGUA MINERAL OU GASEIFICADA, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.01.03', 'IPI - VEICULOS', 'REGISTRA A VPA COM O IPI SOBRE VEICULOS AUTOMOTORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.01.04', 'IPI - VINCULADOS A IMPORTACAO', 'REGISTRA A VPA COM O IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS INCIDENTE SOBRE PRODUTOS INDUSTRIALIZADOS DE PROCEDENCIA ESTRANGEIRA, O FATO GERADOR E O DESEMBARACO ADUANEIRO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.01.05', 'IPI - SIMPLES FEDERAL E NACIONAL', 'REGISTRA A VPA DECORRENTE DE IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS - SIMPLES FEDERAL E NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.01.99', 'IPI - OUTROS PRODUTOS', 'REGISTRA A VPA COM O IPI RELATIVA AS DEMAIS MERCADORIAS AS QUAIS INCIDE O IPI, TAIS COMO FERRO FUNDIDO, FERRO E ACO, MAQUINAS, APARELHOS E MATERIAIS ELETRICOS E OUTRAS RELACIONADAS NA TABELA DE INCIDENCIA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.02.01', 'IOF - COMERCIALIZACAO DO OURO', 'REGISTRA A VPA COM O IOF QUE INCIDE SOBRE A PRIMEIRA AQUISICAO DO OURO, ATIVO FINANCEIRO OU INSTRUMENTO CAMBIAL, EFETUADA POR INSTITUICAO INTEGRANTE DO SISTEMA FINANCEIRO NACIONAL. NO CASO DE OURO FISICO ORIUNDO DO EXTERIOR, INGRESSADO NO PAIS, O FATO GERADOR E O SEU DESEMBARACO ADUANEIRO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.02.99', 'IOF - DEMAIS OPERACOES', 'REGISTRA A VPA COM O IOF INCIDENTE SOBRE AS DEMAIS OPERACOES: DE CREDITO - A ENTREGA DOS RECURSOS OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; DE CAMBIO RELATIVAS A IMPORTACAO DE SERVICOS - A LIQUIDACAO DO CONTRATO DE CAMBIO; DE SEGURO - O RECEBIMENTO DO PREMIO; COM TITULOS E VALORES MOBILIARIOS - A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.2.01.01', 'IPI -PRODUTOS DO FUMO', 'REGISTRA A VPA COM O IPI - PRODUTOS DO FUMO. INCIDENTE SOBRE O FUMO (TABACO) NAO MANUFATURADO, CHARUTOS, CIGARRILHAS E CIGARROS DE FUMO E SOBRE OUTROS PRODUTOS DO FUMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.2.01.02', 'IPI - BEBIDAS', 'REGISTRA A VPA COM O IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS INCIDENTE SOBRE BEBIDAS ALCOOLICAS, REFRIGERANTES, REFRESCOS, AGUA MINERAL OU GASEIFICADA, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.2.01.03', 'IPI - VEICULOS', 'REGISTRA A VPA COM O IPI SOBRE VEICULOS AUTOMOTORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.2.01.04', 'IPI - VINCULADOS A IMPORTACAO', 'REGISTRA A VPA COM O IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS INCIDENTE SOBRE PRODUTOS INDUSTRIALIZADOS DE PROCEDENCIA ESTRANGEIRA, O FATO GERADOR E O DESEMBARACO ADUANEIRO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.2.01.05', 'IPI - SIMPLES FEDERAL E NACIONAL', 'REGISTRA A VPA DECORRENTE DE IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS - SIMPLES FEDERAL E NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.2.01.99', 'IPI - OUTROS PRODUTOS', 'REGISTRA A VPA COM O IPI RELATIVA AS DEMAIS MERCADORIAS AS QUAIS INCIDE O IPI, TAIS COMO FERRO FUNDIDO, FERRO E ACO, MAQUINAS, APARELHOS E MATERIAIS ELETRICOS E OUTRAS RELACIONADAS NA TABELA DE INCIDENCIA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.2.02.01', 'IOF - COMERCIALIZACAO DO OURO', 'REGISTRA A VPA COM O IOF QUE INCIDE SOBRE A PRIMEIRA AQUISICAO DO OURO, ATIVO FINANCEIRO OU INSTRUMENTO CAMBIAL, EFETUADA POR INSTITUICAO INTEGRANTE DO SISTEMA FINANCEIRO NACIONAL. NO CASO DE OURO FISICO ORIUNDO DO EXTERIOR, INGRESSADO NO PAIS, O FATO GERADOR E O SEU DESEMBARACO ADUANEIRO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.2.02.99', 'IOF - DEMAIS OPERACOES', 'REGISTRA A VPA COM O IOF INCIDENTE SOBRE AS DEMAIS OPERACOES: DE CREDITO - A ENTREGA DOS RECURSOS OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; DE CAMBIO RELATIVAS A IMPORTACAO DE SERVICOS - A LIQUIDACAO DO CONTRATO DE CAMBIO; DE SEGURO - O RECEBIMENTO DO PREMIO; COM TITULOS E VALORES MOBILIARIOS - A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.2.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.4.01.01', 'IPI -PRODUTOS DO FUMO', 'REGISTRA A VPA COM O IPI - PRODUTOS DO FUMO. INCIDENTE SOBRE O FUMO (TABACO) NAO MANUFATURADO, CHARUTOS, CIGARRILHAS E CIGARROS DE FUMO E SOBRE OUTROS PRODUTOS DO FUMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.4.01.02', 'IPI - BEBIDAS', 'REGISTRA A VPA COM O IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS INCIDENTE SOBRE BEBIDAS ALCOOLICAS, REFRIGERANTES, REFRESCOS, AGUA MINERAL OU GASEIFICADA, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.4.01.03', 'IPI - VEICULOS', 'REGISTRA A VPA COM O IPI SOBRE VEICULOS AUTOMOTORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.4.01.04', 'IPI - VINCULADOS A IMPORTACAO', 'REGISTRA A VPA COM O IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS INCIDENTE SOBRE PRODUTOS INDUSTRIALIZADOS DE PROCEDENCIA ESTRANGEIRA, O FATO GERADOR E O DESEMBARACO ADUANEIRO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.4.01.05', 'IPI - SIMPLES FEDERAL E NACIONAL', 'REGISTRA A VPA DECORRENTE DE IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS - SIMPLES FEDERAL E NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.4.01.99', 'IPI - OUTROS PRODUTOS', 'REGISTRA A VPA COM O IPI RELATIVA AS DEMAIS MERCADORIAS AS QUAIS INCIDE O IPI, TAIS COMO FERRO FUNDIDO, FERRO E ACO, MAQUINAS, APARELHOS E MATERIAIS ELETRICOS E OUTRAS RELACIONADAS NA TABELA DE INCIDENCIA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.4.02.01', 'IOF - COMERCIALIZACAO DO OURO', 'REGISTRA A VPA COM O IOF QUE INCIDE SOBRE A PRIMEIRA AQUISICAO DO OURO, ATIVO FINANCEIRO OU INSTRUMENTO CAMBIAL, EFETUADA POR INSTITUICAO INTEGRANTE DO SISTEMA FINANCEIRO NACIONAL. NO CASO DE OURO FISICO ORIUNDO DO EXTERIOR, INGRESSADO NO PAIS, O FATO GERADOR E O SEU DESEMBARACO ADUANEIRO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.4.02.99', 'IOF - DEMAIS OPERACOES', 'REGISTRA A VPA COM O IOF INCIDENTE SOBRE AS DEMAIS OPERACOES: DE CREDITO - A ENTREGA DOS RECURSOS OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; DE CAMBIO RELATIVAS A IMPORTACAO DE SERVICOS - A LIQUIDACAO DO CONTRATO DE CAMBIO; DE SEGURO - O RECEBIMENTO DO PREMIO; COM TITULOS E VALORES MOBILIARIOS - A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.4.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.5.01.01', 'IPI -PRODUTOS DO FUMO', 'REGISTRA A VPA COM O IPI - PRODUTOS DO FUMO. INCIDENTE SOBRE O FUMO (TABACO) NAO MANUFATURADO, CHARUTOS, CIGARRILHAS E CIGARROS DE FUMO E SOBRE OUTROS PRODUTOS DO FUMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.5.01.02', 'IPI - BEBIDAS', 'REGISTRA A VPA COM O IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS INCIDENTE SOBRE BEBIDAS ALCOOLICAS, REFRIGERANTES, REFRESCOS, AGUA MINERAL OU GASEIFICADA, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.5.01.03', 'IPI - VEICULOS', 'REGISTRA A VPA COM O IPI SOBRE VEICULOS AUTOMOTORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.5.01.04', 'IPI - VINCULADOS A IMPORTACAO', 'REGISTRA A VPA COM O IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS INCIDENTE SOBRE PRODUTOS INDUSTRIALIZADOS DE PROCEDENCIA ESTRANGEIRA, O FATO GERADOR E O DESEMBARACO ADUANEIRO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.5.01.05', 'IPI - SIMPLES FEDERAL E NACIONAL', 'REGISTRA A VPA DECORRENTE DE IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS - SIMPLES FEDERAL E NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.5.01.99', 'IPI - OUTROS PRODUTOS', 'REGISTRA A VPA COM O IPI RELATIVA AS DEMAIS MERCADORIAS AS QUAIS INCIDE O IPI, TAIS COMO FERRO FUNDIDO, FERRO E ACO, MAQUINAS, APARELHOS E MATERIAIS ELETRICOS E OUTRAS RELACIONADAS NA TABELA DE INCIDENCIA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.5.02.01', 'IOF - COMERCIALIZACAO DO OURO', 'REGISTRA A VPA COM O IOF QUE INCIDE SOBRE A PRIMEIRA AQUISICAO DO OURO, ATIVO FINANCEIRO OU INSTRUMENTO CAMBIAL, EFETUADA POR INSTITUICAO INTEGRANTE DO SISTEMA FINANCEIRO NACIONAL. NO CASO DE OURO FISICO ORIUNDO DO EXTERIOR, INGRESSADO NO PAIS, O FATO GERADOR E O SEU DESEMBARACO ADUANEIRO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.5.02.99', 'IOF - DEMAIS OPERACOES', 'REGISTRA A VPA COM O IOF INCIDENTE SOBRE AS DEMAIS OPERACOES: DE CREDITO - A ENTREGA DOS RECURSOS OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; DE CAMBIO RELATIVAS A IMPORTACAO DE SERVICOS - A LIQUIDACAO DO CONTRATO DE CAMBIO; DE SEGURO - O RECEBIMENTO DO PREMIO; COM TITULOS E VALORES MOBILIARIOS - A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.5.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.4.1.00.00', 'IMPOSTOS EXTRAORDINARIOS - CONSOLIDACAO', 'REGISTRA OS IMPOSTOS INSTITUIDOS PELA UNIAO, TEMPORARIAMENTE, NA IMINENCIA OU NO CASO DE GUERRA EXTERNA, SUPRIMIDOS,GRADATIVAMENTE, NO PRAZO MAXIMO DE CINCO ANOS, CONTADOS DA CELEBRACAO DA PAZ. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.4.2.00.00', 'IMPOSTOS EXTRAORDINARIOS - INTRA OFSS', 'REGISTRA OS IMPOSTOS INSTITUIDOS PELA UNIAO, TEMPORARIAMENTE, NA IMINENCIA OU NO CASO DE GUERRA EXTERNA, SUPRIMIDOS,GRADATIVAMENTE, NO PRAZO MAXIMO DE CINCO ANOS, CONTADOS DA CELEBRACAO DA PAZ.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.4.4.00.00', 'IMPOSTOS EXTRAORDINARIOS - INTER OFSS - ESTADO', 'REGISTRA OS IMPOSTOS INSTITUIDOS PELA UNIAO, TEMPORARIAMENTE, NA IMINENCIA OU NO CASO DE GUERRA EXTERNA, SUPRIMIDOS, GRADATIVAMENTE,NO PRAZO MAXIMO DE CINCO ANOS,CONTADOS DA CELEBRACAO DA PAZ.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.4.5.00.00', 'IMPOSTOS EXTRAORDINARIOS - INTER OFSS - MUNICIPIO', 'REGISTRA OS IMPOSTOS INSTITUIDOS PELA UNIAO, TEMPORARIAMENTE, NA IMINENCIA OU NO CASO DE GUERRA EXTERNA, SUPRIMIDOS, GRADATIVAMENTE,NO PRAZO MAXIMO DE CINCO ANOS,CONTADOS DA CELEBRACAO DA PAZ.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.9.1.00.00', 'OUTROS IMPOSTOS - CONSOLIDACAO', 'COMPREENDE OS DEMAIS IMPOSTOS NAO CLASSIFICADOS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.9.2.00.00', 'OUTROS IMPOSTOS - INTRA OFSS', 'COMPREENDE OS DEMAIS IMPOSTOS NAO CLASSIFICADOS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.9.4.00.00', 'OUTROS IMPOSTOS - INTER OFSS - ESTADO', 'COMPREENDE OS DEMAIS IMPOSTOS NAO CLASSIFICADOS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.9.5.00.00', 'OUTROS IMPOSTOS - INTER OFSS - MUNICIPIO', 'COMPREENDE OS DEMAIS IMPOSTOS NAO CLASSIFICADOS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.01.00', 'TAXA FISC SERV IRRIGACAO E OPERACAO ADUCAO AGUA', 'REGISTRA A VPA COM TAXA DECORRENTE DO EXERCICIO DO PODER DE POLICIA PELA AGENCIA NACIONAL DE AGUAS - ANA, COMPREENDIDO NA FISCALIZACAO DA PRESTACAO DOS SERVICOS PUBLICOS DE IRRIGACAO E OPE- RACAO DE ADUCAO DE AGUA BRUTA. DESTINACAO LEGAL: AGENCIA NACIONAL DE AGUAS - ANA, DESTINADOS AO CUSTEIO DAS DESPESAS DECORRENTES DAS ATIVIDADES DE FISCALIZACAO E REGULACAO REFERIDAS; AMPARO LEGAL: LEI 9984/2000 E MP 437/2008.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.02.02', 'TAXA DE FISCALIZACAO DE FUNCIONAMENTO', 'REGISTRA O VALOR DA TAXA PAGA ANUALMENTE, ATE O DIA 31 DE MARCO, PELA FISCALIZACAO DO FUNCIONAMENTO DAS ESTACOES. SEUS VALORES CORRESPONDEM A 45% DOS FIXADOS PARA A TAXA DE FISCALIZACAO DE INSTALACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.03.00', 'TAXA DE CONTROLE E FISCALIZ. DE PROD.QUIMICOS', 'REGISTRA O VALOR DA VPA ADVINDA DO PAGAMENTO DA TAXA DE CONTROLE E FISCALIZACAO SOBRE PRODUTOS QUIMICOS QUE DIRETA OU INDIRETAMENTE POSSAM SER DESTINADOS A ELABORACAO ILICITA DE SUBSTANCIAS ENTORPECENTES, PSICOTROPICAS OU QUE DETERMINEM DEPENDENCIA FISICA OU PSIQUICA. OS RECURSOS CONSTITUEM RECEITA DO FUNDO NACIONAL ANTIDROGAS ­ FUNAD, DOS QUAIS SERAO DESTINADOS 80% AO DEPARTAMENTO DE POLICIA FEDERAL, PARA O REAPARELHAMENTO E CUSTEIO DAS ATIVIDADES DE CONTROLE E FISCALIZACAO DE PRODUTOS QUIMICOS E DE REPRESSAO AO TRAFICO ILICITO DE DROGAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.04.01', 'TX.DO DEPART.DE POLICIA FEDERAL - SEG.PRIVADA', 'REGISTRA A VPA COM TAXAS SOBRE A PRESTACAO DE SERVICOS RELATIVOS A FISCALIZACAO DE EMPRESAS DE SEGURANCA PRIVADA, SEGURANCA PROPRIA, DE TRANSPORTES DE VALORES DEESTABELECIMENTOS FINANCEIROS E DE ESTABELECIMENTOS DE FORMACAO DE VIGILANTES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.04.02', 'TX.DO DEPART.DE POLICIA FED. - SIST.NAC.ARMAS', 'REGISTRA A VPA COM TAXAS SOBRE A PRESTACAO E SERVICOS RELATIVOS A FISCALIZACAO SOBRE REGISTRO, POSSE E COMERCIAL ZACAO DE ARMAS DE FOGO PERMITIDAS E DE MUNICAO. FATO GERADOR: REGISTRO DE REGISTRO E POSSE DE ARMAS DE FOGO DE USO PERMITIDO, COMERCIALIZACAO DE ARMAS DE FOGO PERMITIDAS E COMERCIALIZACAO DE MUNICAO. PROPRIETARIO DE ARMA DE FOGO DEVERA TER EM SEU PODER O CERTIFICADO DE REGISTRO PROVISORIO OBTIDO JUNTO A POLICIA FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.05.00', 'TAXAS DE MIGRACAO', 'REGISTRA A VPA COM TAXAS DE MIGRACAO, PELO PODER NO SEU EXERCICIO REGULAR DO PODER DE POLICIA. CONSTITUEM-SE EM TAXAS COBRADAS PELA CONCESSAO DE VISTO DE SAIDA, PEDIDO DE AUTORIZACAO DE PERMANENCIA, PEDIDO DE PRORROGACAO DE PRAZO DE ESTADA, PEDIDO DE PASSAPORTE PARA O ESTRANGEIRO. RECEITA VINCULADA A SECRETARIA DE POLICIA FEDERAL DO MINISTERIO DA JUSTICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.06.00', 'TAXA LIC.,CONTR, FISC.MAT NUC.RADIOATIVO INSTAL', 'REGISTRA A VPA COM TAXA DE LICENCIAMENTO, CONTROLE E FISCALIZACAO, PESQUISA E DESENVOLVIMENTO, APOIO TECNICO OPERACIONAL E APOIO AO DESENVOLVIMENTO E APLICACAO DE MATERIAIS DIDATICOS E PEDAGOGICOS RELACIONADOS COM MATERIAIS NUCLEARES E RADIOATIVOS E SUAS INSTALACOES. AMPARO LEGAL: LEI NR. 9765, DE 17 DE DEZEMBRO DE 1998', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.07.00', 'TAXA DE FISCALIZACAO PROD.CONTR.MIN.EXERCITO', 'REGISTRA A VPA COM TAXA QUE TEM COMO FATO GERADOR A FISCALIZACAO DE PRODUTOS CONTROLADOS PELO MINISTERIO DO EXERCITO TAIS COMO: CONCESSAO PARA O COMERCIO, PARA ARMEIROS, CLUBES DE CACA E PESCA; CADASTRAMENTO DE EMPRESA DE VIGILANCIA; REVENDA DE ARMAS E MUNICOES. RECEITA VINCULADA AO MINISTERIO DO EXERCITO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.08.00', 'TAXA FISCAL.MERC.TITULOS E VAL. MOBILIARIOS', 'REGISTRA A VPA COM TAXA, DE COMPETENCIA DA UNIAO DECORRENTE DA FISCALIZACAO EXERCIDA PELA COMISSAO DE VALORES MOBILIARIOS, AS COMPANHIAS ABERTAS, SOCIEDADES BENEFICIARIAS DE INCENTIVOS FISCAIS, CORRETORAS, BANCOS DE INVESTIMENTO, BOLSAS DE VALORES E DE FUTUROS, DISTRIBUIDORAS E BANCOS MULTIPLOS COM CARTEIRA DE INVESTIMENTO, FUNDOS MUTUOS DE ACOES, FUNDOS DE CONVERSAO, FUNDOS DE INVESTIMENTO E CARTEIRAS DE TITULOS E VALORES MOBILIARIOS - CAPITAL ESTRANGEIRO. OS RECURSOS SAO VINCULADOS A CVM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.09.00', 'TAXA FISCAL.MERC.SEG.CAP.PREVID.PRIV.ABERTA', 'REGISTRA A VPA COM TAXA PELA FISCALIZACAO DOS MERCADOS DE SEGURO, DE CAPITALIZACAO E DA PREVIDENCIA PRIVADA ABERTA PELO SERVICO PUBLICO, TENDO COMO FATO GERADOR O EXERCICIO DO PODER DE POLICIA LEGALMENTE ATRIBUIDO A SUPERINTENDENCIA DE SEGUROS PRIVADOS ­ SUSEP, SENDO RECOLHIDA PELOS ESTABELECIMENTOS DE SEGURO, DE CAPITALIZACAO E DE PREVIDENCIA PRIVADA ABERTA COM OU SEM FINS LUCRATIVOS. OS RECURSOS SAO VINCULADOS A SUSEP.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.10.00', 'TAXA FISCAL. DOS SERVICOS DE ENERGIA ELETRICA', 'REGISTRA A VPA COM TAXA DECORRENTE DA PRESTACAO DO SERVICO PUBLICO DE FISCALIZACAO E REGULACAO DO SETOR DE ENERGIA ELETRICA NACIONAL PELA ANEEL - AGENCIA NACIONAL DE ENERGIA ELETRICA, RECOLHIDA EM DUODECIMOS DIRETAMENTE A AUTARQUIA, COM BASE NO BENEFICIO ECONOMICO ANUAL, AUFERIDO PELAS ENTIDADES DO SETOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.11.00', 'TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA', 'REGISTRA A VPA COM TAXA PELA FISCALIZACAO DE VIGILANCIA SANITARIA EXERCIDA PELA AGENCIA NACIONAL DE VIGILANCIA SANITARIA SOBRE AS PESSOAS FISICAS E JURIDICAS QUE EXERCAM ATIVIDADES DE FABRICACAO, DISTRIBUICAO E VENDA DE PRODUTOS E A PRESTACAO DE SERVICOS MENCIONADOS NO ARTIGO 8. DA LEI 9782/99. OS RECURSOS SAO VINCULADOS A AGENCIA NACIONAL DE VIGILANCIA SANITARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.12.00', 'TAXA DE FISCALIZ.S/ DISTRIB. GRAT.PREM. SORTEIO', 'REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZACAO E DISTRIBUICAO GRATUITA DE PREMIOS E SORTEIOS. OS VALORES CONSTANTES DA TABELA DO ANEXO II DA MEDIDA PROVISORIA 2113/27, DE 26JAN2001, OS QUAIS DEVERAO SER RETIDOS PELA CAIXA ECONOMICA A TITULO DE REMUNERACAO. DARF''S A SEREM REPASSADOS A SECRETARIA DE ACOMPANHAMENTO ECONOMICO DO MINISTERIO DA FAZENDA, QUANDO FOREM EMITIDOS PARA REPASSE DA DIFERENCA ENTRE O VALOR PAGO A TITULO DE REMUNERACAO A CAIXA ECONOMICA FEDERAL E O VALOR DA TAXA COBRADA. AMPARO LEGAL MP 2113/27, DE 26JAN01, PORTARIA MF 15, DE 12JAN01', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.13.01', 'TAXA POR PLANO DE ASSISTENCIA A SAUDE', 'REGISTRA A VPA PROVENIENTE DA TAXA POR PLANO DE ASSISTENCIA A SAUDE, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.13.02', 'TAXA POR REGISTRO DE PRODUTO', 'REGISTRA A VPA PROVENIENTE DA TAXA POR REGISTRO DE PRODUTO, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.13.03', 'TAXA POR ALTERACAO DE DADOS DE PRODUTO', 'REGISTRA A VPA PROVENIENTE DA TAXA POR ALTERACAO DE DADOS DE PRODUTO, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.13.04', 'TAXA POR REGISTRO DE OPERADORA', 'REGISTRA A VPA PROVENIENTE DA TAXA POR REGISTRO DE OPERADORA, DEVIDA POR PESSOAS JURIDICAS,CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.13.05', 'TAXA POR ALTERACAO DE DADOS DE OPERADORA', 'REGISTRA A VPA PROVENIENTE DA TAXA POR ALTERACAO DE DADOS DE OPERADORA, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.13.06', 'TAXA POR PEDIDO DE REAJ.DE CONTRAPR.PENCUNIAR', 'REGISTRA A VPA PROVENIENTE DA TAXA POR PEDIDO DE REAJUSTE DE CONTRAPRESTACAO PECUNIARIA DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.14.00', 'TAXA DE CONTROLE E FISCALIZACAO AMBIENTAL', 'REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZACAO AMBIENTAL, DEVIDA POR PESSOAS FISICAS OU JURIDICAS OBRIGADAS AO REGISTRO NO CADASTRO TECNICO FEDERAL DE ATIVIDADES POTENCIALMENTE POLUIDORAS OU UTILIZADORAS DE RECURSOS AMBIENTAIS O RECOLHIMENTO SERA EFETUADO EM CONTA BANCARIA VINCULADA AO IBAMA, POR INTERMEDIO DE DOCUMENTO PROPRIO DE ARRECADACAO DAQUELE INSTITUTO LEI 9960/2000', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.15.00', 'TAXA DE SERVICOS ADMINISTRATIVOS - TSA', 'REGISTRA A VPA PROVENIENTE DA TAXA DE SERVICOS ADMINISTRATIVOS, TENDO COMO FATO GERADOR O EXERCICIO REGULAR DO PODER DE POLICIA, OU A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO OU POSTO A SUA DISPOSICAO PELA SUPERINTENDENCIA DA ZONA FRANCA DE MANAUS - SUFRAMA. OS RECURSOS ARRECADADOS SERAO DESTINADOS EXCLUSIVAMENTE AO CUSTEIO E AS ATIVIDADES FINS DA SUFRAMA (LEI 9960 DE 28 DE JANEIRO DE 2000).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.16.00', 'TX.FISCALIZ. E CONTR. DA PREV.COMPL - TAFIC', 'REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE TAXA DE FISCALIZACAO E CONTROLE DA PREVIDENCIA COMPLEMENTAR - TAFIC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.01.00', 'TAXA FISC SERV IRRIGACAO E OPERACAO ADUCAO AGUA', 'REGISTRA A VPA COM TAXA DECORRENTE DO EXERCICIO DO PODER DE POLICIA PELA AGENCIA NACIONAL DE AGUAS - ANA, COMPREENDIDO NA FISCALIZACAO DA PRESTACAO DOS SERVICOS PUBLICOS DE IRRIGACAO E OPERACAO DE ADUCAO DE AGUA BRUTA. DESTINACAO LEGAL: AGENCIA NACIONAL DE AGUAS - ANA, DESTINADOS AO CUSTEIO DAS DESPESAS DECORRENTES DAS ATIVIDADES DE FISCALIZACAO E REGULACAO REFERIDAS; AMPARO LEGAL: LEI 9984/2000 E MP 437/2008.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.02.01', 'TAXA DE FISCALIZACAO DE INSTALACAO', 'REGISTRA O VALOR TOTAL DA TAXA PAGA NO MOMENTO DA EMISSAO DO CERTIFICADO DE LICENCA PARA O FUNCIONAMENTO DAS ESTACOES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.02.02', 'TAXA DE FISCALIZACAO DE FUNCIONAMENTO', 'REGISTRA O VALOR DA TAXA PAGA ANUALMENTE, ATE O DIA 31 DE MARCO, PELA FISCALIZACAO DO FUNCIONAMENTO DAS ESTACOES. SEUS VALORES CORRESPONDEM A 45% DOS FIXADOS PARA A TAXA DE FISCALIZACAO DE INSTALACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.03.00', 'TAXA DE CONTROLE E FISCALIZ. DE PROD.QUIMICOS', 'REGISTRA O VALOR DA VPA ADVINDA DO PAGAMENTO DA TAXA DE CONTROLE E FISCALIZACAO SOBRE PRODUTOS QUIMICOS QUE DIRETA OU INDIRETAMENTE POSSAM SER DESTINADOS A ELABORACAO ILICITA DE SUBSTANCIAS ENTORPECENTES, PSICOTROPICAS OU QUE DETERMINEM DEPENDENCIA FISICA OU PSIQUICA. OS RECURSOS CONSTITUEM RECEITA DO FUNDO NACIONAL ANTIDROGAS ­ FUNAD, DOS QUAIS SERAO DESTINADOS 80% AO DEPARTAMENTO DE POLICIA FEDERAL, PARA O REAPARELHAMENTO E CUSTEIO DAS ATIVIDADES DE CONTROLE E FISCALIZACAO DE PRODUTOS QUIMICOS E DE REPRESSAO AO TRAFICO ILICITO DE DROGAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.04.01', 'TX.DO DEPART.DE POLICIA FEDERAL - SEG.PRIVADA', 'REGISTRA A VPA COM TAXAS SOBRE A PRESTACAO DE SERVICOS RELATIVOS A FISCALIZACAO DE EMPRESAS DE SEGURANCA PRIVADA, SEGURANCA PROPRIA, DE TRANSPORTES DE VALORES DEESTABELECIMENTOS FINANCEIROS E DE ESTABELECIMENTOS DE FORMACAO DE VIGILANTES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.04.02', 'TX.DO DEPART.DE POLICIA FED. - SIST.NAC.ARMAS', 'REGISTRA A VPA COM TAXAS SOBRE A PRESTACAO E SERVICOS RELATIVOS A FISCALIZACAO SOBRE REGISTRO, POSSE E COMERCIAL ZACAO DE ARMAS DE FOGO PERMITIDAS E DE MUNICAO. FATO GERADOR: REGISTRO DE REGISTRO E POSSE DE ARMAS DE FOGO DE USO PERMITIDO, COMERCIALIZACAO DE ARMAS DE FOGO PERMITIDAS E COMERCIALIZACAO DE MUNICAO. PROPRIETARIO DE ARMA DE FOGO DEVERA TER EM SEU PODER O CERTIFICADO DE REGISTRO PROVISORIO OBTIDO JUNTO A POLICIA FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.05.00', 'TAXAS DE MIGRACAO', 'REGISTRA A VPA COM TAXAS DE MIGRACAO, PELO PODER NO SEU EXERCICIO REGULAR DO PODER DE POLICIA. CONSTITUEM-SE EM TAXAS COBRADAS PELA CONCESSAO DE VISTO DE SAIDA, PEDIDO DE AUTORIZACAO DE PERMANENCIA, PEDIDO DE PRORROGACAO DE PRAZO DE ESTADA, PEDIDO DE PASSAPORTE PARA O ESTRANGEIRO. RECEITA VINCULADA A SECRETARIA DE POLICIA FEDERAL DO MINISTERIO DA JUSTICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.06.00', 'TAXA LIC.,CONTR, FISC.MAT NUC.RADIOATIVO INSTAL', 'REGISTRA A VPA COM TAXA DE LICENCIAMENTO, CONTROLE E FISCALIZACAO, PESQUISA E DESENVOLVIMENTO, APOIO TECNICO OPERACIONAL E APOIO AO DESENVOLVIMENTO E APLICACAO DE MATERIAIS DIDATICOS E PEDAGOGICOS RELACIONADOS COM MATERIAIS NUCLEARES E RADIOATIVOS E SUAS INSTALACOES. AMPARO LEGAL: LEI NR. 9765, DE 17 DE DEZEMBRO DE 1998', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.07.00', 'TAXA DE FISCALIZACAO PROD.CONTR.MIN.EXERCITO', 'REGISTRA A VPA COM TAXA QUE TEM COMO FATO GERADOR A FISCALIZACAO DE PRODUTOS CONTROLADOS PELO MINISTERIO DO EXERCITO TAIS COMO: CONCESSAO PARA O COMERCIO, PARA ARMEIROS, CLUBES DE CACA E PESCA; CADASTRAMENTO DE EMPRESA DE VIGILANCIA; REVENDA DE ARMAS E MUNICOES. RECEITA VINCULADA AO MINISTERIO DO EXERCITO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.08.00', 'TAXA FISCAL.MERC.TITULOS E VAL. MOBILIARIOS', 'REGISTRA A VPA COM TAXA, DE COMPETENCIA DA UNIAO DECORRENTE DA FISCALIZACAO EXERCIDA PELA COMISSAO DE VALORES MOBILIARIOS, AS COMPANHIAS ABERTAS, SOCIEDADES BENEFICIARIAS DE INCENTIVOS FISCAIS, CORRETORAS, BANCOS DE INVESTIMENTO, BOLSAS DE VALORES E DE FUTUROS, DISTRIBUIDORAS E BANCOS MULTIPLOS COM CARTEIRA DE INVESTIMENTO, FUNDOS MUTUOS DE ACOES, FUNDOS DE CONVERSAO, FUNDOS DE INVESTIMENTO E CARTEIRAS DE TITULOS E VALORES MOBILIARIOS - CAPITAL ESTRANGEIRO. OS RECURSOS SAO VINCULADOS A CVM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.09.00', 'TAXA FISCAL.MERC.SEG.CAP.PREVID.PRIV.ABERTA', 'REGISTRA A VPA COM TAXA PELA FISCALIZACAO DOS MERCADOS DE SEGURO, DE CAPITALIZACAO E DA PREVIDENCIA PRIVADA ABERTA PELO SERVICO PUBLICO, TENDO COMO FATO GERADOR O EXERCICIO DO PODER DE POLICIA LEGALMENTE ATRIBUIDO A SUPERINTENDENCIA DE SEGUROS PRIVADOS ­ SUSEP, SENDO RECOLHIDA PELOS ESTABELECIMENTOS DE SEGURO, DE CAPITALIZACAO E DE PREVIDENCIA PRIVADA ABERTA COM OU SEM FINS LUCRATIVOS. OS RECURSOS SAO VINCULADOS A SUSEP.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.10.00', 'TAXA FISCAL. DOS SERVICOS DE ENERGIA ELETRICA', 'REGISTRA A VPA COM TAXA DECORRENTE DA PRESTACAO DO SERVICO PUBLICO DE FISCALIZACAO E REGULACAO DO SETOR DE ENERGIA ELETRICA NACIONAL PELA ANEEL - AGENCIA NACIONAL DE ENERGIA ELETRICA, RECOLHIDA EM DUODECIMOS DIRETAMENTE A AUTARQUIA, COM BASE NO BENEFICIO ECONOMICO ANUAL, AUFERIDO PELAS ENTIDADES DO SETOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.11.00', 'TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA', 'REGISTRA A VPA COM TAXA PELA FISCALIZACAO DE VIGILANCIA SANITARIA EXERCIDA PELA AGENCIA NACIONAL DE VIGILANCIA SANITARIA SOBRE AS PESSOAS FISICAS E JURIDICAS QUE EXERCAM ATIVIDADES DE FABRICACAO, DISTRIBUICAO E VENDA DE PRODUTOS E A PRESTACAO DE SERVICOS MENCIONADOS NO ARTIGO 8. DA LEI 9782/99. OS RECURSOS SAO VINCULADOS A AGENCIA NACIONAL DE VIGILANCIA SANITARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.12.00', 'TAXA DE FISCALIZ.S/ DISTRIB. GRAT.PREM. SORTEIO', 'REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZACAO E DISTRIBUICAO GRATUITA DE PREMIOS E SORTEIOS. OS VALORES CONSTANTES DA TABELA DO ANEXO II DA MEDIDA PROVISORIA 2113/27, DE 26JAN2001, OS QUAIS DEVERAO SER RETIDOS PELA CAIXA ECONOMICA A TITULO DE REMUNERACAO. DARF''S A SEREM REPASSADOS A SECRETARIA DE ACOMPANHAMENTO ECONOMICO DO MINISTERIO DA FAZENDA, QUANDO FOREM EMITIDOS PARA REPASSE DA DIFERENCA ENTRE O VALOR PAGO A TITULO DE REMUNERACAO A CAIXA ECONOMICA FEDERAL E O VALOR DA TAXA COBRADA. AMPARO LEGAL MP 2113/27, DE 26JAN01, PORTARIA MF 15, DE 12JAN01', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.13.01', 'TAXA POR PLANO DE ASSISTENCIA A SAUDE', 'REGISTRA A VPA PROVENIENTE DA TAXA POR PLANO DE ASSISTENCIA A SAUDE, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.13.02', 'TAXA POR REGISTRO DE PRODUTO', 'REGISTRA A VPA PROVENIENTE DA TAXA POR REGISTRO DE PRODUTO, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.13.03', 'TAXA POR ALTERACAO DE DADOS DE PRODUTO', 'REGISTRA A VPA PROVENIENTE DA TAXA POR ALTERACAO DE DADOS DE PRODUTO, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.13.04', 'TAXA POR REGISTRO DE OPERADORA', 'REGISTRA A VPA PROVENIENTE DA TAXA POR REGISTRO DE OPERADORA, DEVIDA POR PESSOAS JURIDICAS,CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.13.05', 'TAXA POR ALTERACAO DE DADOS DE OPERADORA', 'REGISTRA A VPA PROVENIENTE DA TAXA POR ALTERACAO DE DADOS DE OPERADORA, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.13.06', 'TAXA POR PEDIDO DE REAJ.DE CONTRAPR.PENCUNIAR', 'REGISTRA A VPA PROVENIENTE DA TAXA POR PEDIDO DE REAJUSTE DE CONTRAPRESTACAO PECUNIARIA DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.14.00', 'TAXA DE CONTROLE E FISCALIZACAO AMBIENTAL', 'REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZACAO AMBIENTAL, DEVIDA POR PESSOAS FISICAS OU JURIDICAS OBRIGADAS AO REGISTRO NO CADASTRO TECNICO FEDERAL DE ATIVIDADES POTENCIALMENTE POLUIDORAS OU UTILIZADORAS DE RECURSOS AMBIENTAIS O RECOLHIMENTO SERA EFETUADO EM CONTA BANCARIA VINCULADA AO IBAMA, POR INTERMEDIO DE DOCUMENTO PROPRIO DE ARRECADACAO DAQUELE INSTITUTO LEI 9960/2000', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.15.00', 'TAXA DE SERVICOS ADMINISTRATIVOS - TSA', 'REGISTRA A VPA PROVENIENTE DA TAXA DE SERVICOS ADMINISTRATIVOS, TENDO COMO FATO GERADOR O EXERCICIO REGULAR DO PODER DE POLICIA, OU A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO OU POSTO A SUA DISPOSICAO PELA SUPERINTENDENCIA DA ZONA FRANCA DE MANAUS - SUFRAMA. OS RECURSOS ARRECADADOS SERAO DESTINADOS EXCLUSIVAMENTE AO CUSTEIO E AS ATIVIDADES FINS DA SUFRAMA (LEI 9960 DE 28 DE JANEIRO DE 2000).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.16.00', 'TX.FISCALIZ. E CONTR. DA PREV.COMPL - TAFIC', 'REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE TAXA DE FISCALIZACAO E CONTROLE DA PREVIDENCIA COMPLEMENTAR - TAFIC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.01.00', 'TAXA FISC SERV IRRIGACAO E OPERACAO ADUCAO AGUA', 'REGISTRA A VPA COM TAXA DECORRENTE DO EXERCICIO DO PODER DE POLICIA PELA AGENCIA NACIONAL DE AGUAS - ANA, COMPREENDIDO NA FISCALIZACAO DA PRESTACAO DOS SERVICOS PUBLICOS DE IRRIGACAO E OPERACAO DE ADUCAO DE AGUA BRUTA. DESTINACAO LEGAL: AGENCIA NACIONAL DE AGUAS - ANA, DESTINADOS AO CUSTEIO DAS DESPESAS DECORRENTES DAS ATIVIDADES DE FISCALIZACAO E REGULACAO REFERIDAS; AMPARO LEGAL: LEI 9984/2000 E MP 437/2008.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.02.01', 'TAXA DE FISCALIZACAO DE INSTALACAO', 'REGISTRA O VALOR TOTAL DA TAXA PAGA NO MOMENTO DA EMISSAO DO CERTIFICADO DE LICENCA PARA O FUNCIONAMENTO DAS ESTACOES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.02.02', 'TAXA DE FISCALIZACAO DE FUNCIONAMENTO', 'REGISTRA O VALOR DA TAXA PAGA ANUALMENTE, ATE O DIA 31 DE MARCO, PELA FISCALIZACAO DO FUNCIONAMENTO DAS ESTACOES. SEUS VALORES CORRESPONDEM A 45% DOS FIXADOS PARA A TAXA DE FISCALIZACAO DE INSTALACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.03.00', 'TAXA DE CONTROLE E FISCALIZ. DE PROD.QUIMICOS', 'REGISTRA O VALOR DA VPA ADVINDA DO PAGAMENTO DA TAXA DE CONTROLE E FISCALIZACAO SOBRE PRODUTOS QUIMICOS QUE DIRETA OU INDIRETAMENTE POSSAM SER DESTINADOS A ELABORACAO ILICITA DE SUBSTANCIAS ENTORPECENTES, PSICOTROPICAS OU QUE DETERMINEM DEPENDENCIA FISICA OU PSIQUICA. OS RECURSOS CONSTITUEM RECEITA DO FUNDO NACIONAL ANTIDROGAS ­ FUNAD, DOS QUAIS SERAO DESTINADOS 80% AO DEPARTAMENTO DE POLICIA FEDERAL, PARA O REAPARELHAMENTO E CUSTEIO DAS ATIVIDADES DE CONTROLE E FISCALIZACAO DE PRODUTOS QUIMICOS E DE REPRESSAO AO TRAFICO ILICITO DE DROGAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.04.01', 'TX.DO DEPART.DE POLICIA FEDERAL - SEG.PRIVADA', 'REGISTRA A VPA COM TAXAS SOBRE A PRESTACAO DE SERVICOS RELATIVOS A FISCALIZACAO DE EMPRESAS DE SEGURANCA PRIVADA, SEGURANCA PROPRIA, DE TRANSPORTES DE VALORES DEESTABELECIMENTOS FINANCEIROS E DE ESTABELECIMENTOS DE FORMACAO DE VIGILANTES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.04.02', 'TX.DO DEPART.DE POLICIA FED. - SIST.NAC.ARMAS', 'REGISTRA A VPA COM TAXAS SOBRE A PRESTACAO E SERVICOS RELATIVOS A FISCALIZACAO SOBRE REGISTRO, POSSE E COMERCIAL ZACAO DE ARMAS DE FOGO PERMITIDAS E DE MUNICAO. FATO GERADOR: REGISTRO DE REGISTRO E POSSE DE ARMAS DE FOGO DE USO PERMITIDO, COMERCIALIZACAO DE ARMAS DE FOGO PERMITIDAS E COMERCIALIZACAO DE MUNICAO. PROPRIETARIO DE ARMA DE FOGO DEVERA TER EM SEU PODER O CERTIFICADO DE REGISTRO PROVISORIO OBTIDO JUNTO A POLICIA FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.05.00', 'TAXAS DE MIGRACAO', 'REGISTRA A VPA COM TAXAS DE MIGRACAO, PELO PODER NO SEU EXERCICIO REGULAR DO PODER DE POLICIA. CONSTITUEM-SE EM TAXAS COBRADAS PELA CONCESSAO DE VISTO DE SAIDA, PEDIDO DE AUTORIZACAO DE PERMANENCIA, PEDIDO DE PRORROGACAO DE PRAZO DE ESTADA, PEDIDO DE PASSAPORTE PARA O ESTRANGEIRO. RECEITA VINCULADA A SECRETARIA DE POLICIA FEDERAL DO MINISTERIO DA JUSTICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.06.00', 'TAXA LIC.,CONTR, FISC.MAT NUC.RADIOATIVO INSTAL', 'REGISTRA A VPA COM TAXA DE LICENCIAMENTO, CONTROLE E FISCALIZACAO, PESQUISA E DESENVOLVIMENTO, APOIO TECNICO OPERACIONAL E APOIO AO DESENVOLVIMENTO E APLICACAO DE MATERIAIS DIDATICOS E PEDAGOGICOS RELACIONADOS COM MATERIAIS NUCLEARES E RADIOATIVOS E SUAS INSTALACOES. AMPARO LEGAL: LEI NR. 9765, DE 17 DE DEZEMBRO DE 1998', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.07.00', 'TAXA DE FISCALIZACAO PROD.CONTR.MIN.EXERCITO', 'REGISTRA A VPA COM TAXA QUE TEM COMO FATO GERADOR A FISCALIZACAO DE PRODUTOS CONTROLADOS PELO MINISTERIO DO EXERCITO TAIS COMO: CONCESSAO PARA O COMERCIO, PARA ARMEIROS, CLUBES DE CACA E PESCA; CADASTRAMENTO DE EMPRESA DE VIGILANCIA; REVENDA DE ARMAS E MUNICOES. RECEITA VINCULADA AO MINISTERIO DO EXERCITO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.08.00', 'TAXA FISCAL.MERC.TITULOS E VAL. MOBILIARIOS', 'REGISTRA A VPA COM TAXA, DE COMPETENCIA DA UNIAO DECORRENTE DA FISCALIZACAO EXERCIDA PELA COMISSAO DE VALORES MOBILIARIOS, AS COMPANHIAS ABERTAS, SOCIEDADES BENEFICIARIAS DE INCENTIVOS FISCAIS, CORRETORAS, BANCOS DE INVESTIMENTO, BOLSAS DE VALORES E DE FUTUROS, DISTRIBUIDORAS E BANCOS MULTIPLOS COM CARTEIRA DE INVESTIMENTO, FUNDOS MUTUOS DE ACOES, FUNDOS DE CONVERSAO, FUNDOS DE INVESTIMENTO E CARTEIRAS DE TITULOS E VALORES MOBILIARIOS - CAPITAL ESTRANGEIRO. OS RECURSOS SAO VINCULADOS A CVM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.09.00', 'TAXA FISCAL.MERC.SEG.CAP.PREVID.PRIV.ABERTA', 'REGISTRA A VPA COM TAXA PELA FISCALIZACAO DOS MERCADOS DE SEGURO, DE CAPITALIZACAO E DA PREVIDENCIA PRIVADA ABERTA PELO SERVICO PUBLICO, TENDO COMO FATO GERADOR O EXERCICIO DO PODER DE POLICIA LEGALMENTE ATRIBUIDO A SUPERINTENDENCIA DE SEGUROS PRIVADOS ­ SUSEP, SENDO RECOLHIDA PELOS ESTABELECIMENTOS DE SEGURO, DE CAPITALIZACAO E DE PREVIDENCIA PRIVADA ABERTA COM OU SEM FINS LUCRATIVOS. OS RECURSOS SAO VINCULADOS A SUSEP.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.10.00', 'TAXA FISCAL. DOS SERVICOS DE ENERGIA ELETRICA', 'REGISTRA A VPA COM TAXA DECORRENTE DA PRESTACAO DO SERVICO PUBLICO DE FISCALIZACAO E REGULACAO DO SETOR DE ENERGIA ELETRICA NACIONAL PELA ANEEL - AGENCIA NACIONAL DE ENERGIA ELETRICA, RECOLHIDA EM DUODECIMOS DIRETAMENTE A AUTARQUIA, COM BASE NO BENEFICIO ECONOMICO ANUAL, AUFERIDO PELAS ENTIDADES DO SETOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.11.00', 'TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA', 'REGISTRA A VPA COM TAXA PELA FISCALIZACAO DE VIGILANCIA SANITARIA EXERCIDA PELA AGENCIA NACIONAL DE VIGILANCIA SANITARIA SOBRE AS PESSOAS FISICAS E JURIDICAS QUE EXERCAM ATIVIDADES DE FABRICACAO, DISTRIBUICAO E VENDA DE PRODUTOS E A PRESTACAO DE SERVICOS MENCIONADOS NO ARTIGO 8. DA LEI 9782/99. OS RECURSOS SAO VINCULADOS A AGENCIA NACIONAL DE VIGILANCIA SANITARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.12.00', 'TAXA DE FISCALIZ.S/ DISTRIB. GRAT.PREM. SORTEIO', 'REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZACAO E DISTRIBUICAO GRATUITA DE PREMIOS E SORTEIOS. OS VALORES CONSTANTES DA TABELA DO ANEXO II DA MEDIDA PROVISORIA 2113/27, DE 26JAN2001, OS QUAIS DEVERAO SER RETIDOS PELA CAIXA ECONOMICA A TITULO DE REMUNERACAO. DARF''S A SEREM REPASSADOS A SECRETARIA DE ACOMPANHAMENTO ECONOMICO DO MINISTERIO DA FAZENDA, QUANDO FOREM EMITIDOS PARA REPASSE DA DIFERENCA ENTRE O VALOR PAGO A TITULO DE REMUNERACAO A CAIXA ECONOMICA FEDERAL E O VALOR DA TAXA COBRADA. AMPARO LEGAL MP 2113/27, DE 26JAN01, PORTARIA MF 15, DE 12JAN01', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.13.02', 'TAXA POR REGISTRO DE PRODUTO', 'REGISTRA A VPA PROVENIENTE DA TAXA POR REGISTRO DE PRODUTO, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.13.03', 'TAXA POR ALTERACAO DE DADOS DE PRODUTO', 'REGISTRA A VPA PROVENIENTE DA TAXA POR ALTERACAO DE DADOS DE PRODUTO, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.13.04', 'TAXA POR REGISTRO DE OPERADORA', 'REGISTRA A VPA PROVENIENTE DA TAXA POR REGISTRO DE OPERADORA, DEVIDA POR PESSOAS JURIDICAS,CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.13.05', 'TAXA POR ALTERACAO DE DADOS DE OPERADORA', 'REGISTRA A VPA PROVENIENTE DA TAXA POR ALTERACAO DE DADOS DE OPERADORA, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.13.06', 'TAXA POR PEDIDO DE REAJ.DE CONTRAPR.PENCUNIAR', 'REGISTRA A VPA PROVENIENTE DA TAXA POR PEDIDO DE REAJUSTE DE CONTRAPRESTACAO PECUNIARIA DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.14.00', 'TAXA DE CONTROLE E FISCALIZACAO AMBIENTAL', 'REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZACAO AMBIENTAL, DEVIDA POR PESSOAS FISICAS OU JURIDICAS OBRIGADAS AO REGISTRO NO CADASTRO TECNICO FEDERAL DE ATIVIDADES POTENCIALMENTE POLUIDORAS OU UTILIZADORAS DE RECURSOS AMBIENTAIS O RECOLHIMENTO SERA EFETUADO EM CONTA BANCARIA VINCULADA AO IBAMA, POR INTERMEDIO DE DOCUMENTO PROPRIO DE ARRECADACAO DAQUELE INSTITUTO LEI 9960/2000', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.15.00', 'TAXA DE SERVICOS ADMINISTRATIVOS - TSA', 'REGISTRA A VPA PROVENIENTE DA TAXA DE SERVICOS ADMINISTRATIVOS, TENDO COMO FATO GERADOR O EXERCICIO REGULAR DO PODER DE POLICIA, OU A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO OU POSTO A SUA DISPOSICAO PELA SUPERINTENDENCIA DA ZONA FRANCA DE MANAUS - SUFRAMA. OS RECURSOS ARRECADADOS SERAO DESTINADOS EXCLUSIVAMENTE AO CUSTEIO E AS ATIVIDADES FINS DA SUFRAMA (LEI 9960 DE 28 DE JANEIRO DE 2000).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.16.00', 'TX.FISCALIZ. E CONTR. DA PREV.COMPL - TAFIC', 'REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE TAXA DE FISCALIZACAO E CONTROLE DA PREVIDENCIA COMPLEMENTAR - TAFIC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.01.00', 'TAXA FISC SERV IRRIGACAO E OPERACAO ADUCAO AGUA', 'REGISTRA A VPA COM TAXA DECORRENTE DO EXERCICIO DO PODER DE POLICIA PELA AGENCIA NACIONAL DE AGUAS - ANA, COMPREENDIDO NA FISCALIZACAO DA PRESTACAO DOS SERVICOS PUBLICOS DE IRRIGACAO E OPERACAO DE ADUCAO DE AGUA BRUTA. DESTINACAO LEGAL: AGENCIA NACIONAL DE AGUAS - ANA, DESTINADOS AO CUSTEIO DAS DESPESAS DECORRENTES DAS ATIVIDADES DE FISCALIZACAO E REGULACAO REFERIDAS; AMPARO LEGAL: LEI 9984/2000 E MP 437/2008.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.02.01', 'TAXA DE FISCALIZACAO DE INSTALACAO', 'REGISTRA O VALOR TOTAL DA TAXA PAGA NO MOMENTO DA EMISSAO DO CERTIFICADO DE LICENCA PARA O FUNCIONAMENTO DAS ESTACOES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.02.02', 'TAXA DE FISCALIZACAO DE FUNCIONAMENTO', 'REGISTRA O VALOR DA TAXA PAGA ANUALMENTE, ATE O DIA 31 DE MARCO, PELA FISCALIZACAO DO FUNCIONAMENTO DAS ESTACOES. SEUS VALORES CORRESPONDEM A 45% DOS FIXADOS PARA A TAXA DE FISCALIZACAO DE INSTALACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.03.00', 'TAXA DE CONTROLE E FISCALIZ. DE PROD.QUIMICOS', 'REGISTRA O VALOR DA VPA ADVINDA DO PAGAMENTO DA TAXA DE CONTROLE E FISCALIZACAO SOBRE PRODUTOS QUIMICOS QUE DIRETA OU INDIRETAMENTE POSSAM SER DESTINADOS A ELABORACAO ILICITA DE SUBSTANCIAS ENTORPECENTES, PSICOTROPICAS OU QUE DETERMINEM DEPENDENCIA FISICA OU PSIQUICA. OS RECURSOS CONSTITUEM RECEITA DO FUNDO NACIONAL ANTIDROGAS ­ FUNAD, DOS QUAIS SERAO DESTINADOS 80% AO DEPARTAMENTO DE POLICIA FEDERAL, PARA O REAPARELHAMENTO E CUSTEIO DAS ATIVIDADES DE CONTROLE E FISCALIZACAO DE PRODUTOS QUIMICOS E DE REPRESSAO AO TRAFICO ILICITO DE DROGAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.04.01', 'TX.DO DEPART.DE POLICIA FEDERAL - SEG.PRIVADA', 'REGISTRA A VPA COM TAXAS SOBRE A PRESTACAO DE SERVICOS RELATIVOS A FISCALIZACAO DE EMPRESAS DE SEGURANCA PRIVADA, SEGURANCA PROPRIA, DE TRANSPORTES DE VALORES DEESTABELECIMENTOS FINANCEIROS E DE ESTABELECIMENTOS DE FORMACAO DE VIGILANTES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.04.02', 'TX.DO DEPART.DE POLICIA FED. - SIST.NAC.ARMAS', 'REGISTRA A VPA COM TAXAS SOBRE A PRESTACAO E SERVICOS RELATIVOS A FISCALIZACAO SOBRE REGISTRO, POSSE E COMERCIAL ZACAO DE ARMAS DE FOGO PERMITIDAS E DE MUNICAO. FATO GERADOR: REGISTRO DE REGISTRO E POSSE DE ARMAS DE FOGO DE USO PERMITIDO, COMERCIALIZACAO DE ARMAS DE FOGO PERMITIDAS E COMERCIALIZACAO DE MUNICAO. PROPRIETARIO DE ARMA DE FOGO DEVERA TER EM SEU PODER O CERTIFICADO DE REGISTRO PROVISORIO OBTIDO JUNTO A POLICIA FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.05.00', 'TAXAS DE MIGRACAO', 'REGISTRA A VPA COM TAXAS DE MIGRACAO, PELO PODER NO SEU EXERCICIO REGULAR DO PODER DE POLICIA. CONSTITUEM-SE EM TAXAS COBRADAS PELA CONCESSAO DE VISTO DE SAIDA, PEDIDO DE AUTORIZACAO DE PERMANENCIA, PEDIDO DE PRORROGACAO DE PRAZO DE ESTADA, PEDIDO DE PASSAPORTE PARA O ESTRANGEIRO. RECEITA VINCULADA A SECRETARIA DE POLICIA FEDERAL DO MINISTERIO DA JUSTICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.06.00', 'TAXA LIC.,CONTR, FISC.MAT NUC.RADIOATIVO INSTAL', 'REGISTRA A VPA COM TAXA DE LICENCIAMENTO, CONTROLE E FISCALIZACAO, PESQUISA E DESENVOLVIMENTO, APOIO TECNICO OPERACIONAL E APOIO AO DESENVOLVIMENTO E APLICACAO DE MATERIAIS DIDATICOS E PEDAGOGICOS RELACIONADOS COM MATERIAIS NUCLEARES E RADIOATIVOS E SUAS INSTALACOES. AMPARO LEGAL: LEI NR. 9765, DE 17 DE DEZEMBRO DE 1998', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.07.00', 'TAXA DE FISCALIZACAO PROD.CONTR.MIN.EXERCITO', 'REGISTRA A VPA COM TAXA QUE TEM COMO FATO GERADOR A FISCALIZACAO DE PRODUTOS CONTROLADOS PELO MINISTERIO DO EXERCITO TAIS COMO: CONCESSAO PARA O COMERCIO, PARA ARMEIROS, CLUBES DE CACA E PESCA; CADASTRAMENTO DE EMPRESA DE VIGILANCIA; REVENDA DE ARMAS E MUNICOES. RECEITA VINCULADA AO MINISTERIO DO EXERCITO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.08.00', 'TAXA FISCAL.MERC.TITULOS E VAL. MOBILIARIOS', 'REGISTRA A VPA COM TAXA, DE COMPETENCIA DA UNIAO DECORRENTE DA FISCALIZACAO EXERCIDA PELA COMISSAO DE VALORES MOBILIARIOS, AS COMPANHIAS ABERTAS, SOCIEDADES BENEFICIARIAS DE INCENTIVOS FISCAIS, CORRETORAS, BANCOS DE INVESTIMENTO, BOLSAS DE VALORES E DE FUTUROS, DISTRIBUIDORAS E BANCOS MULTIPLOS COM CARTEIRA DE INVESTIMENTO, FUNDOS MUTUOS DE ACOES, FUNDOS DE CONVERSAO, FUNDOS DE INVESTIMENTO E CARTEIRAS DE TITULOS E VALORES MOBILIARIOS - CAPITAL ESTRANGEIRO. OS RECURSOS SAO VINCULADOS A CVM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.09.00', 'TAXA FISCAL.MERC.SEG.CAP.PREVID.PRIV.ABERTA', 'REGISTRA A VPA COM TAXA PELA FISCALIZACAO DOS MERCADOS DE SEGURO, DE CAPITALIZACAO E DA PREVIDENCIA PRIVADA ABERTA PELO SERVICO PUBLICO, TENDO COMO FATO GERADOR O EXERCICIO DO PODER DE POLICIA LEGALMENTE ATRIBUIDO A SUPERINTENDENCIA DE SEGUROS PRIVADOS ­ SUSEP, SENDO RECOLHIDA PELOS ESTABELECIMENTOS DE SEGURO, DE CAPITALIZACAO E DE PREVIDENCIA PRIVADA ABERTA COM OU SEM FINS LUCRATIVOS. OS RECURSOS SAO VINCULADOS A SUSEP.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.10.00', 'TAXA FISCAL. DOS SERVICOS DE ENERGIA ELETRICA', 'REGISTRA A VPA COM TAXA DECORRENTE DA PRESTACAO DO SERVICO PUBLICO DE FISCALIZACAO E REGULACAO DO SETOR DE ENERGIA ELETRICA NACIONAL PELA ANEEL - AGENCIA NACIONAL DE ENERGIA ELETRICA, RECOLHIDA EM DUODECIMOS DIRETAMENTE A AUTARQUIA, COM BASE NO BENEFICIO ECONOMICO ANUAL, AUFERIDO PELAS ENTIDADES DO SETOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.11.00', 'TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA', 'REGISTRA A VPA COM TAXA PELA FISCALIZACAO DE VIGILANCIA SANITARIA EXERCIDA PELA AGENCIA NACIONAL DE VIGILANCIA SANITARIA SOBRE AS PESSOAS FISICAS E JURIDICAS QUE EXERCAM ATIVIDADES DE FABRICACAO, DISTRIBUICAO E VENDA DE PRODUTOS E A PRESTACAO DE SERVICOS MENCIONADOS NO ARTIGO 8. DA LEI 9782/99. OS RECURSOS SAO VINCULADOS A AGENCIA NACIONAL DE VIGILANCIA SANITARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.12.00', 'TAXA DE FISCALIZ.S/ DISTRIB. GRAT.PREM. SORTEIO', 'REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZACAO E DISTRIBUICAO GRATUITA DE PREMIOS E SORTEIOS. OS VALORES CONSTANTES DA TABELA DO ANEXO II DA MEDIDA PROVISORIA 2113/27, DE 26JAN2001, OS QUAIS DEVERAO SER RETIDOS PELA CAIXA ECONOMICA A TITULO DE REMUNERACAO. DARF''S A SEREM REPASSADOS A SECRETARIA DE ACOMPANHAMENTO ECONOMICO DO MINISTERIO DA FAZENDA, QUANDO FOREM EMITIDOS PARA REPASSE DA DIFERENCA ENTRE O VALOR PAGO A TITULO DE REMUNERACAO A CAIXA ECONOMICA FEDERAL E O VALOR DA TAXA COBRADA. AMPARO LEGAL MP 2113/27, DE 26JAN01, PORTARIA MF 15, DE 12JAN01', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.13.01', 'TAXA POR PLANO DE ASSISTENCIA A SAUDE', 'REGISTRA A VPA PROVENIENTE DA TAXA POR PLANO DE ASSISTENCIA A SAUDE, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.13.02', 'TAXA POR REGISTRO DE PRODUTO', 'REGISTRA A VPA PROVENIENTE DA TAXA POR REGISTRO DE PRODUTO, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.13.03', 'TAXA POR ALTERACAO DE DADOS DE PRODUTO', 'REGISTRA A VPA PROVENIENTE DA TAXA POR ALTERACAO DE DADOS DE PRODUTO, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.13.04', 'TAXA POR REGISTRO DE OPERADORA', 'REGISTRA A VPA PROVENIENTE DA TAXA POR REGISTRO DE OPERADORA, DEVIDA POR PESSOAS JURIDICAS,CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.13.05', 'TAXA POR ALTERACAO DE DADOS DE OPERADORA', 'REGISTRA A VPA PROVENIENTE DA TAXA POR ALTERACAO DE DADOS DE OPERADORA, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.13.06', 'TAXA POR PEDIDO DE REAJ.DE CONTRAPR.PENCUNIAR', 'REGISTRA A VPA PROVENIENTE DA TAXA POR PEDIDO DE REAJUSTE DE CONTRAPRESTACAO PECUNIARIA DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.14.00', 'TAXA DE CONTROLE E FISCALIZACAO AMBIENTAL', 'REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZACAO AMBIENTAL, DEVIDA POR PESSOAS FISICAS OU JURIDICAS OBRIGADAS AO REGISTRO NO CADASTRO TECNICO FEDERAL DE ATIVIDADES POTENCIALMENTE POLUIDORAS OU UTILIZADORAS DE RECURSOS AMBIENTAIS O RECOLHIMENTO SERA EFETUADO EM CONTA BANCARIA VINCULADA AO IBAMA, POR INTERMEDIO DE DOCUMENTO PROPRIO DE ARRECADACAO DAQUELE INSTITUTO LEI 9960/2000', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.15.00', 'TAXA DE SERVICOS ADMINISTRATIVOS - TSA', 'REGISTRA A VPA PROVENIENTE DA TAXA DE SERVICOS ADMINISTRATIVOS, TENDO COMO FATO GERADOR O EXERCICIO REGULAR DO PODER DE POLICIA, OU A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO OU POSTO A SUA DISPOSICAO PELA SUPERINTENDENCIA DA ZONA FRANCA DE MANAUS - SUFRAMA. OS RECURSOS ARRECADADOS SERAO DESTINADOS EXCLUSIVAMENTE AO CUSTEIO E AS ATIVIDADES FINS DA SUFRAMA (LEI 9960 DE 28 DE JANEIRO DE 2000).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.16.00', 'TX.FISCALIZ. E CONTR. DA PREV.COMPL - TAFIC', 'REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE TAXA DE FISCALIZACAO E CONTROLE DA PREVIDENCIA COMPLEMENTAR - TAFIC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.01.00', 'EMOLUMENTOS CONSULARES', 'REGISTRA A VPA PROVENIENTE DAS TAXAS PELA PRESTACAO DE SERVICOS CONSULARES. DE COMPETENCIA DA UNIAO. SAO TAXAS COBRADAS PELOS CONSULADOS E VICE-CONSULADOS BRASILEIROS NO EXTERIOR, PELA EXPEDICAO OU LEGALIZACAO DE DOCUMENTOS E OUTRAS TAXAS RELATIVAS AS ATIVIDADES CONSULARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.02.00', 'TAXA PEDIDO VISTO EM CONTRATO TRAB. ESTRANGEIRO', 'REGISTRA A VPA PROVENIENTE DA TAXA DE PEDIDO DE VISTO EM CONTRATO DE TRABALHO DE ESTRANGEIRO, DESTINADA AO MINISTERIO DO TRABALHO E EMPREGO, DE ACORDO COM A LEI Nº 6815/80.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.03.00', 'TAXA SIST.CONTR. ARREC.ADIC.FRETE REN.MAR.MERC.', 'REGISTRA A VPA PROVENIENTE DA TAXA DE UTILIZACAO DO SISTEMA ELETRONICO DE CONTROLE DE ARRECADACAO DO ADICIONAL AO FRETE PARA A RENOVACAO DA MARINHA MERCANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.04.00', 'TAXA DE AVALIACAO DO ENSINO SUPERIOR', 'REGISTRA A VPA PROVENIENTE DA TAXA DE AVALIACAO DO ENSINO SUPERIOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.05.00', 'TAXA JUDICIARIA DA JUSTICA DO DISTR. FEDERAL', 'REGISTRA A VPA PROVENIENTE DE TAXA JUDICIARIA DA JUSTICA DO DISTRITO FEDERAL. TRIBUTO QUE TEM COMO FATO GERADOR A ADMINISTRACAO DA JUSTICA PELOS MAGISTRADOS ATRAVES DO PROCESSAMENTO, JULGAMENTO E EXECUCAO DOS FEITOS SUBMETIDOS A SEU EXAME, INCLUSIVE QUANDO SE TRATE DE PROCESSO DE JURISDICAO VOLUNTARIA. INCIDE SOBRE O VALOR DA CAUSA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.06.00', 'EMOLUMENTOS E CUSTAS DA JUSTICA DO DF', 'REGISTRA A VPA PROVENIENTE DE CUSTAS E EMOLUMENTOS DEVIDOS A JUSTICA DO DISTRITO FEDERAL, PELA EXPEDICAO, PREPARO E EXECUCAO DE TODOS OS FEITOS JUDICIAIS, DOS ATOS NOTARIAIS, JUDICIAIS E EXTRAJUDICIAIS, COBRADOS DE ACORDO COM O REGIMENTO ESTABELECIDO PELO DECRETO-LEI N° 115, DE 25/01/1967, E ALTERACOES POSTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.07.00', 'EMOLUMENTOS E CUSTAS JUDICIAIS', 'REGISTRA A VPA PROVENIENTE DA TAXA DE SERVICOS JUDICIAIS REFERENTES AOS ATOS PRATICADOS EM RAZAO DE OFICIO, TAIS COMO: A) SERVENTIAS JUDICIAIS: DESPESAS COM DILIGENCIAS FORA DO CARTORIO, PERICIAIS E AVALIACOES, PUBLICACOES DE EDITAIS NA IMPRENSA, EXPEDICOES DE CARTAS DE ORDEM E DE SENTENCAS, DENTRE OUTRAS; B) EXPEDICAO, MOVIMENTACAO E CERTIFICACAO DOS FEITOS, BEM COMO CUSTAS DEVIDAS POR ATOS DE DILIGENCIAS, EM PRIMEIRA INSTANCIA, COM BASE NO VALOR DAS CAUSAS EM GERAL, MANDADO DE SEGURANCA, PROCESSOS CRIMINAIS, RECURSOS E CARTAS TESTEMUNHAVEIS CRIMINAIS, DESPESA COM TRANSLADO E OUTRAS RELACIONADAS NAS TABELAS DE CUSTAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.08.00', 'TAXA UTIL. SISTEMA INT.COM.EXTER.-SISCOMEX', 'REGISTRA A VPA PROVENIENTE DA TAXA COBRADA PELA UTILIZACAO DOS SERVICOS DO SISTEMA INTEGRADO DE COMERCIO EXTERIOR - SISCOMEX, PAGA AO REGISTRO DA DECLARACAO DE IMPORTACAO E POR ADICAO DE MERCADORIAS A DECLARACAO DE IMPORTACAO. O PRODUTO DA ARRECADACAO DA TAXA E VINCULADO AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.09.00', 'EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRAT.', 'REGISTRA A VPA PROVENIENTE DA TAXA INCIDENTE SOBRE OS PROCESSOS DE COMPETENCIA DO CONSELHO ADMINISTRATIVO DE DEFESA ECONOMICA - CADE, COMO ATOS E CONTRATOS QUE POSSAM LIMITAR OU DE QUALQUER FORMA PREJUDICAR A LIVRE CONCORRENCIA, OU RESULTAR NA DOMINACAO DE MERCADOS RELEVANTES DE BENS OU SERVICOS; E DE CONSULTAS AO CADE. DESTINACAO LEGAL: CONSELHO ADMINISTRATIVO DE DEFESA ECONOMICA - CADE; SECRETARIA DE DIREITO ECONOMICO DO MINISTERIO DA JUSTICA E SECRETARIA DE ACOMPANHAMENTO ECONOMICO DO MINISTERIO DA FAZENDA. AMPARO LEGAL: LEI 8.884/1994; LEI 9.781/1999; DECRETO 2.978/1999 E LEI 10.149/2000.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.10.00', 'TAXA MILITAR', 'REGISTRA A VPA PROVENIENTE DE TAXA COBRADA A TODO CIDADAO QUE POR QUALQUER MOTIVO OBTIVER ISENCAO TEMPORARIA OU DEFINITIVA DE INCORPORACAO NO EXERCITO, MARINHA E AERONAUTICA. RECEITA VINCULADA AO EMFA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.11.00', 'TAXA DE CLASSIFICACAO DE PRODUTOS VEGETAIS', 'REGISTRA A VPA PROVENIENTE DAS TAXAS PARA CLASSIFICACAO DE PRODUTOS VEGETAIS. DE COMPETENCIA DA UNIAO, TEM COMO FATO GERADOR A CLASSIFICACAO DE PRODUTOS VEGETAIS PELO MINISTERIO DA AGRICULTURA E DO ABASTECIMENTO, BEM COMO O REGULAR EXERCICIO DO PODER DE POLICIA. RECURSO VINCULADO AO FUNDO FEDERAL AGROPECUARIO, DO MINISTERIO SUPRACITADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.12.00', 'TAXAS DE SERVICOS CADASTRAIS', 'REGISTRA A VPA PROVENIENTE DAS TAXAS DE SERVICOS CADASTRAIS, TENDO COMO FATO GERADOR A APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA, DA TAXA DE SERVICOS CADASTRAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.13.00', 'TAXA DE SERVICOS AQUICOLAS', 'REGISTRA A VPA PROVENIENTE DAS TAXAS PELA PRESTACAO DE SERVICOS AQUICOLAS, ORIGINARIAS DOS REGISTROS ANUAIS DE INDUSTRIA DE PESCA, DE EMPRESAS QUE COMERCIALIZAM ANIMAIS AQUATICOS VIVOS, DE PESQUE E PAGUE E DE ARMADOR DE PESCA E AINDA DE EXPEDICAO DE CARTEIRA DE PESCADOR PROFISSIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.99.00', 'OUTRAS TAXAS PELA PRESTACAO DE SERVICOS', 'REGISTRA A VPA PROVENIENTE DE OUTRAS TAXAS PELA UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO, QUE NAO ESTEJAM REFERENCIADAS NAS NATUREZAS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.01.00', 'EMOLUMENTOS CONSULARES', 'REGISTRA A VPA PROVENIENTE DAS TAXAS PELA PRESTACAO DE SERVICOS CONSULARES. DE COMPETENCIA DA UNIAO, SAO TAXAS COBRADAS PELOS CONSULADOS E VICE-CONSULADOS BRASILEIROS NO EXTERIOR, PELA EXPEDICAO OU LEGALIZACAO DE DOCUMENTOSE OUTRAS TAXAS RELATIVAS AS ATIVIDADES CONSULARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.02.00', 'TAXA PEDIDO VISTO EM CONTRATO TRAB. ESTRANGEIRO', 'REGISTRA A VPA PROVENIENTE DA TAXA DE PEDIDO DE VISTO EM CONTRATO DE TRABALHO DE ESTRANGEIRO, DESTINADA AO MINISTERIO DO TRABALHO E EMPREGO, DE ACORDO COM A LEI Nº 6815/80.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.03.00', 'TAXA SIST.CONTR. ARREC.ADIC.FRETE REN.MAR.MERC.', 'REGISTRA A VPA PROVENIENTE DA TAXA DE UTILIZACAO DO SISTEMA ELETRONICO DE CONTROLE DE ARRECADACAO DO ADICIONAL AO FRETE PARA A RENOVACAO DA MARINHA MERCANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.04.00', 'TAXA DE AVALIACAO DO ENSINO SUPERIOR', 'REGISTRA A VPA PROVENIENTE DA TAXA DE AVALIACAO DO ENSINO SUPERIOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.05.00', 'TAXA JUDICIARIA DA JUSTICA DO DISTR. FEDERAL', 'REGISTRA A VPA PROVENIENTE DE TAXA JUDICIARIA DA JUSTICA DO DISTRITO FEDERAL. TRIBUTO QUE TEM COMO FATO GERADOR A ADMINISTRACAO DA JUSTICA PELOS MAGISTRADOS ATRAVES DO PROCESSAMENTO, JULGAMENTO E EXECUCAO DOS FEITOS SUBMETIDOS A SEU EXAME, INCLUSIVE QUANDO SE TRATE DE PROCESSO DE JURISDICAO VOLUNTARIA. INCIDE SOBRE O VALOR DA CAUSA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.06.00', 'EMOLUMENTOS E CUSTAS DA JUSTICA DO DF', 'REGISTRA A VPA PROVENIENTE DE CUSTAS E EMOLUMENTOS DEVIDOS A JUSTICA DO DISTRITO FEDERAL, PELA EXPEDICAO, PREPARO E EXECUCAO DE TODOS OS FEITOS JUDICIAIS, DOS ATOS NOTARIAIS, JUDICIAIS E EXTRAJUDICIAIS, COBRADOS DE ACORDO COM O REGIMENTO ESTABELECIDO PELO DECRETO-LEI N° 115, DE 25/01/1967, E ALTERACOES POSTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.07.00', 'EMOLUMENTOS E CUSTAS JUDICIAIS', 'REGISTRA A VPA PROVENIENTE DA TAXA DE SERVICOS JUDICIAIS REFERENTES AOS ATOS PRATICADOS EM RAZAO DE OFICIO, TAIS COMO: A) SERVENTIAS JUDICIAIS: DESPESAS COM DILIGENCIAS FORA DO CARTORIO, PERICIAIS E AVALIACOES, PUBLICACOES DE EDITAIS NA IMPRENSA, EXPEDICOES DE CARTAS DE ORDEM E DE SENTENCAS, DENTRE OUTRAS; B) EXPEDICAO, MOVIMENTACAO E CERTIFICACAO DOS FEITOS, BEM COMO CUSTAS DEVIDAS POR ATOS DE DILIGENCIAS, EM PRIMEIRA INSTANCIA, COM BASE NO VALOR DAS CAUSAS EM GERAL, MANDADO DE SEGURANCA, PROCESSOS CRIMINAIS, RECURSOS E CARTAS TESTEMUNHAVEIS CRIMINAIS, DESPESA COM TRANSLADO E OUTRAS RELACIONADAS NAS TABELAS DE CUSTAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.08.00', 'TAXA UTIL. SISTEMA INT.COM.EXTER.-SISCOMEX', 'REGISTRA A VPA PROVENIENTE DA TAXA COBRADA PELA UTILIZACAO DOS SERVICOS DO SISTEMA INTEGRADO DE COMERCIO EXTERIOR - SISCOMEX, PAGA AO REGISTRO DA DECLARACAO DE IMPORTACAO E POR ADICAO DE MERCADORIAS A DECLARACAO DE IMPORTACAO. O PRODUTO DA ARRECADACAO DA TAXA E VINCULADO AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.09.00', 'EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRAT.', 'REGISTRA A VPA PROVENIENTE DA TAXA INCIDENTE SOBRE OS PROCESSOS DE COMPETENCIA DO CONSELHO ADMINISTRATIVO DE DEFESA ECONOMICA - CADE, COMO ATOS E CONTRATOS QUE POSSAM LIMITAR OU DE QUALQUER FORMA PREJUDICAR A LIVRE CONCORRENCIA, OU RESULTAR NA DOMINACAO DE MERCADOS RELEVANTES DE BENS OU SERVICOS; E DE CONSULTAS AO CADE. DESTINACAO LEGAL: CONSELHO ADMINISTRATIVO DE DEFESA ECONOMICA - CADE; SECRETARIA DE DIREITO ECONOMICO DO MINISTERIO DA JUSTICA E SECRETARIA DE ACOMPANHAMENTO ECONOMICO DO MINISTERIO DA FAZENDA. AMPARO LEGAL: LEI 8.884/1994; LEI 9.781/1999; DECRETO 2.978/1999 E LEI 10.149/2000.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.10.00', 'TAXA MILITAR', 'REGISTRA A VPA PROVENIENTE DE TAXA COBRADA A TODO CIDADAO QUE POR QUALQUER MOTIVO OBTIVER ISENCAO TEMPORARIA OU DEFINITIVA DE INCORPORACAO NO EXERCITO, MARINHA E AERONAUTICA. RECEITA VINCULADA AO EMFA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.11.00', 'TAXA DE CLASSIFICACAO DE PRODUTOS VEGETAIS', 'REGISTRA A VPA PROVENIENTE DAS TAXAS PARA CLASSIFICACAO DE PRODUTOS VEGETAIS. DE COMPETENCIA DA UNIAO, TEM COMO FATO GERADOR A CLASSIFICACAO DE PRODUTOS VEGETAIS PELO MINISTERIO DA AGRICULTURA E DO ABASTECIMENTO, BEM COMO O REGULAR EXERCICIO DO PODER DE POLICIA. RECURSO VINCULADO AO FUNDO FEDERAL AGROPECUARIO, DO MINISTERIO SUPRACITADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.12.00', 'TAXAS DE SERVICOS CADASTRAIS', 'REGISTRA A VPA PROVENIENTE DAS TAXAS DE SERVICOS CADASTRAIS, TENDO COMO FATO GERADOR A APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA, DA TAXA DE SERVICOS CADASTRAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.13.00', 'TAXA DE SERVICOS AQUICOLAS', 'REGISTRA A VPA PROVENIENTE DAS TAXAS PELA PRESTACAO DE SERVICOS AQUICOLAS, ORIGINARIAS DOS REGISTROS ANUAIS DE INDUSTRIA DE PESCA, DE EMPRESAS QUE COMERCIALIZAM ANIMAIS AQUATICOS VIVOS, DE PESQUE E PAGUE E DE ARMADOR DE PESCA E AINDA DE EXPEDICAO DE CARTEIRA DE PESCADOR PROFISSIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.99.00', 'OUTRAS TAXAS PELA PRESTACAO DE SERVICOS', 'REGISTRA A VPA PROVENIENTE DE OUTRAS TAXAS PELA UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO, QUE NAO ESTEJAM REFERENCIADAS NAS NATUREZAS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.01.00', 'EMOLUMENTOS CONSULARES', 'REGISTRA A VPA PROVENIENTE DAS TAXAS PELA PRESTACAO DE SERVICOS CONSULARES. DE COMPETENCIA DA UNIAO, SAO TAXAS COBRADAS PELOS CONSULADOS E VICE-CONSULADOS BRASILEIROS NO EXTERIOR, PELA EXPEDICAO OU LEGALIZACAO DE DOCUMENTOSE OUTRAS TAXAS RELATIVAS AS ATIVIDADES CONSULARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.02.00', 'TAXA PEDIDO VISTO EM CONTRATO TRAB. ESTRANGEIRO', 'REGISTRA A VPA PROVENIENTE DA TAXA DE PEDIDO DE VISTO EM CONTRATO DE TRABALHO DE ESTRANGEIRO, DESTINADA AO MINISTERIO DO TRABALHO E EMPREGO, DE ACORDO COM A LEI Nº 6815/80.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.03.00', 'TAXA SIST.CONTR. ARREC.ADIC.FRETE REN.MAR.MERC.', 'REGISTRA A VPA PROVENIENTE DA TAXA DE UTILIZACAO DO SISTEMA ELETRONICO DE CONTROLE DE ARRECADACAO DO ADICIONAL AO FRETE PARA A RENOVACAO DA MARINHA MERCANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.04.00', 'TAXA DE AVALIACAO DO ENSINO SUPERIOR', 'REGISTRA A VPA PROVENIENTE DA TAXA DE AVALIACAO DO ENSINO SUPERIOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.05.00', 'TAXA JUDICIARIA DA JUSTICA DO DISTR. FEDERAL', 'REGISTRA A VPA PROVENIENTE DE TAXA JUDICIARIA DA JUSTICA DO DISTRITO FEDERAL. TRIBUTO QUE TEM COMO FATO GERADOR A ADMINISTRACAO DA JUSTICA PELOS MAGISTRADOS ATRAVES DO PROCESSAMENTO, JULGAMENTO E EXECUCAO DOS FEITOS SUBMETIDOS A SEU EXAME, INCLUSIVE QUANDO SE TRATE DE PROCESSO DE JURISDICAO VOLUNTARIA. INCIDE SOBRE O VALOR DA CAUSA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.06.00', 'EMOLUMENTOS E CUSTAS DA JUSTICA DO DF', 'REGISTRA A VPA PROVENIENTE DE CUSTAS E EMOLUMENTOS DEVIDOS A JUSTICA DO DISTRITO FEDERAL, PELA EXPEDICAO, PREPARO E EXECUCAO DE TODOS OS FEITOS JUDICIAIS, DOS ATOS NOTARIAIS, JUDICIAIS E EXTRAJUDICIAIS, COBRADOS DE ACORDO COM O REGIMENTO ESTABELECIDO PELO DECRETO-LEI N° 115, DE 25/01/1967, E ALTERACOES POSTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.07.00', 'EMOLUMENTOS E CUSTAS JUDICIAIS', 'REGISTRA A VPA PROVENIENTE DA TAXA DE SERVICOS JUDICIAIS REFERENTES AOS ATOS PRATICADOS EM RAZAO DE OFICIO, TAIS COMO: A) SERVENTIAS JUDICIAIS: DESPESAS COM DILIGENCIAS FORA DO CARTORIO, PERICIAIS E AVALIACOES, PUBLICACOES DE EDITAIS NA IMPRENSA, EXPEDICOES DE CARTAS DE ORDEM E DE SENTENCAS, DENTRE OUTRAS; B) EXPEDICAO, MOVIMENTACAO E CERTIFICACAO DOS FEITOS, BEM COMO CUSTAS DEVIDAS POR ATOS DE DILIGENCIAS, EM PRIMEIRA INSTANCIA, COM BASE NO VALOR DAS CAUSAS EM GERAL, MANDADO DE SEGURANCA, PROCESSOS CRIMINAIS, RECURSOS E CARTAS TESTEMUNHAVEIS CRIMINAIS, DESPESA COM TRANSLADO E OUTRAS RELACIONADAS NAS TABELAS DE CUSTAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.08.00', 'TAXA UTIL. SISTEMA INT.COM.EXTER.-SISCOMEX', 'REGISTRA A VPA PROVENIENTE DA TAXA COBRADA PELA UTILIZACAO DOS SERVICOS DO SISTEMA INTEGRADO DE COMERCIO EXTERIOR - SISCOMEX, PAGA AO REGISTRO DA DECLARACAO DE IMPORTACAO E POR ADICAO DE MERCADORIAS A DECLARACAO DE IMPORTACAO. O PRODUTO DA ARRECADACAO DA TAXA E VINCULADO AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.09.00', 'EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRAT.', 'REGISTRA A VPA PROVENIENTE DA TAXA INCIDENTE SOBRE OS PROCESSOS DE COMPETENCIA DO CONSELHO ADMINISTRATIVO DE DEFESA ECONOMICA - CADE, COMO ATOS E CONTRATOS QUE POSSAM LIMITAR OU DE QUALQUER FORMA PREJUDICAR A LIVRE CONCORRENCIA, OU RESULTAR NA DOMINACAO DE MERCADOS RELEVANTES DE BENS OU SERVICOS; E DE CONSULTAS AO CADE. DESTINACAO LEGAL: CONSELHO ADMINISTRATIVO DE DEFESA ECONOMICA - CADE; SECRETARIA DE DIREITO ECONOMICO DO MINISTERIO DA JUSTICA E SECRETARIA DE ACOMPANHAMENTO ECONOMICO DO MINISTERIO DA FAZENDA. AMPARO LEGAL: LEI 8.884/1994; LEI 9.781/1999; DECRETO 2.978/1999 E LEI 10.149/2000.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.10.00', 'TAXA MILITAR', 'REGISTRA A VPA PROVENIENTE DE TAXA COBRADA A TODO CIDADAO QUE POR QUALQUER MOTIVO OBTIVER ISENCAO TEMPORARIA OU DEFINITIVA DE INCORPORACAO NO EXERCITO, MARINHA E AERONAUTICA. RECEITA VINCULADA AO EMFA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.11.00', 'TAXA DE CLASSIFICACAO DE PRODUTOS VEGETAIS', 'REGISTRA A VPA PROVENIENTE DAS TAXAS PARA CLASSIFICACAO DE PRODUTOS VEGETAIS. DE COMPETENCIA DA UNIAO, TEM COMO FATO GERADOR A CLASSIFICACAO DE PRODUTOS VEGETAIS PELO MINISTERIO DA AGRICULTURA E DO ABASTECIMENTO, BEM COMO O REGULAR EXERCICIO DO PODER DE POLICIA. RECURSO VINCULADO AO FUNDO FEDERAL AGROPECUARIO, DO MINISTERIO SUPRACITADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.12.00', 'TAXAS DE SERVICOS CADASTRAIS', 'REGISTRA A VPA PROVENIENTE DAS TAXAS DE SERVICOS CADASTRAIS, TENDO COMO FATO GERADOR A APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA, DA TAXA DE SERVICOS CADASTRAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.13.00', 'TAXA DE SERVICOS AQUICOLAS', 'REGISTRA A VPA PROVENIENTE DAS TAXAS PELA PRESTACAO DE SERVICOS AQUICOLAS, ORIGINARIAS DOS REGISTROS ANUAIS DE INDUSTRIA DE PESCA, DE EMPRESAS QUE COMERCIALIZAM ANIMAIS AQUATICOS VIVOS, DE PESQUE E PAGUE E DE ARMADOR DE PESCA E AINDA DE EXPEDICAO DE CARTEIRA DE PESCADOR PROFISSIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.99.00', 'OUTRAS TAXAS PELA PRESTACAO DE SERVICOS', 'REGISTRA A VPA PROVENIENTE DE OUTRAS TAXAS PELA UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO, QUE NAO ESTEJAM REFERENCIADAS NAS NATUREZAS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.01.00', 'EMOLUMENTOS CONSULARES', 'REGISTRA A VPA PROVENIENTE DAS TAXAS PELA PRESTACAO DE SERVICOS CONSULARES. DE COMPETENCIA DA UNIAO, SAO TAXAS COBRADAS PELOS CONSULADOS E VICE-CONSULADOS BRASILEIROS NO EXTERIOR, PELA EXPEDICAO OU LEGALIZACAO DE DOCUMENTOSE OUTRAS TAXAS RELATIVAS AS ATIVIDADES CONSULARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.02.00', 'TAXA PEDIDO VISTO EM CONTRATO TRAB. ESTRANGEIRO', 'REGISTRA A VPA PROVENIENTE DA TAXA DE PEDIDO DE VISTO EM CONTRATO DE TRABALHO DE ESTRANGEIRO, DESTINADA AO MINISTERIO DO TRABALHO E EMPREGO, DE ACORDO COM A LEI Nº 6815/80.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.03.00', 'TAXA SIST.CONTR. ARREC.ADIC.FRETE REN.MAR.MERC.', 'REGISTRA A VPA PROVENIENTE DA TAXA DE UTILIZACAO DO SISTEMA ELETRONICO DE CONTROLE DE ARRECADACAO DO ADICIONAL AO FRETE PARA A RENOVACAO DA MARINHA MERCANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.04.00', 'TAXA DE AVALIACAO DO ENSINO SUPERIOR', 'REGISTRA A VPA PROVENIENTE DA TAXA DE AVALIACAO DO ENSINO SUPERIOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.05.00', 'TAXA JUDICIARIA DA JUSTICA DO DISTR. FEDERAL', 'REGISTRA A VPA PROVENIENTE DE TAXA JUDICIARIA DA JUSTICA DO DISTRITO FEDERAL. TRIBUTO QUE TEM COMO FATO GERADOR A ADMINISTRACAO DA JUSTICA PELOS MAGISTRADOS ATRAVES DO PROCESSAMENTO, JULGAMENTO E EXECUCAO DOS FEITOS SUBMETIDOS A SEU EXAME, INCLUSIVE QUANDO SE TRATE DE PROCESSO DE JURISDICAO VOLUNTARIA. INCIDE SOBRE O VALOR DA CAUSA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.06.00', 'EMOLUMENTOS E CUSTAS DA JUSTICA DO DF', 'REGISTRA A VPA PROVENIENTE DE CUSTAS E EMOLUMENTOS DEVIDOS A JUSTICA DO DISTRITO FEDERAL, PELA EXPEDICAO, PREPARO E EXECUCAO DE TODOS OS FEITOS JUDICIAIS, DOS ATOS NOTARIAIS, JUDICIAIS E EXTRAJUDICIAIS, COBRADOS DE ACORDO COM O REGIMENTO ESTABELECIDO PELO DECRETO-LEI N° 115, DE 25/01/1967, E ALTERACOES POSTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.07.00', 'EMOLUMENTOS E CUSTAS JUDICIAIS', 'REGISTRA A VPA PROVENIENTE DA TAXA DE SERVICOS JUDICIAIS REFERENTES AOS ATOS PRATICADOS EM RAZAO DE OFICIO, TAIS COMO: A) SERVENTIAS JUDICIAIS: DESPESAS COM DILIGENCIAS FORA DO CARTORIO, PERICIAIS E AVALIACOES, PUBLICACOES DE EDITAIS NA IMPRENSA, EXPEDICOES DE CARTAS DE ORDEM E DE SENTENCAS, DENTRE OUTRAS; B) EXPEDICAO, MOVIMENTACAO E CERTIFICACAO DOS FEITOS, BEM COMO CUSTAS DEVIDAS POR ATOS DE DILIGENCIAS, EM PRIMEIRA INSTANCIA, COM BASE NO VALOR DAS CAUSAS EM GERAL, MANDADO DE SEGURANCA, PROCESSOS CRIMINAIS, RECURSOS E CARTAS TESTEMUNHAVEIS CRIMINAIS, DESPESA COM TRANSLADO E OUTRAS RELACIONADAS NAS TABELAS DE CUSTAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.08.00', 'TAXA UTIL. SISTEMA INT.COM.EXTER.-SISCOMEX', 'REGISTRA A VPA PROVENIENTE DA TAXA COBRADA PELA UTILIZACAO DOS SERVICOS DO SISTEMA INTEGRADO DE COMERCIO EXTERIOR - SISCOMEX, PAGA AO REGISTRO DA DECLARACAO DE IMPORTACAO E POR ADICAO DE MERCADORIAS A DECLARACAO DE IMPORTACAO. O PRODUTO DA ARRECADACAO DA TAXA E VINCULADO AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.09.00', 'EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRAT.', 'REGISTRA A VPA PROVENIENTE DA TAXA INCIDENTE SOBRE OS PROCESSOS DE COMPETENCIA DO CONSELHO ADMINISTRATIVO DE DEFESA ECONOMICA - CADE, COMO ATOS E CONTRATOS QUE POSSAM LIMITAR OU DE QUALQUER FORMA PREJUDICAR A LIVRE CONCORRENCIA, OU RESULTAR NA DOMINACAO DE MERCADOS RELEVANTES DE BENS OU SERVICOS; E DE CONSULTAS AO CADE. DESTINACAO LEGAL: CONSELHO ADMINISTRATIVO DE DEFESA ECONOMICA - CADE; SECRETARIA DE DIREITO ECONOMICO DO MINISTERIO DA JUSTICA E SECRETARIA DE ACOMPANHAMENTO ECONOMICO DO MINISTERIO DA FAZENDA. AMPARO LEGAL: LEI 8.884/1994; LEI 9.781/1999; DECRETO 2.978/1999 E LEI 10.149/2000.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.10.00', 'TAXA MILITAR', 'REGISTRA A VPA PROVENIENTE DE TAXA COBRADA A TODO CIDADAO QUE POR QUALQUER MOTIVO OBTIVER ISENCAO TEMPORARIA OU DEFINITIVA DE INCORPORACAO NO EXERCITO, MARINHA E AERONAUTICA. RECEITA VINCULADA AO EMFA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.11.00', 'TAXA DE CLASSIFICACAO DE PRODUTOS VEGETAIS', 'REGISTRA A VPA PROVENIENTE DAS TAXAS PARA CLASSIFICACAO DE PRODUTOS VEGETAIS. DE COMPETENCIA DA UNIAO, TEM COMO FATO GERADOR A CLASSIFICACAO DE PRODUTOS VEGETAIS PELO MINISTERIO DA AGRICULTURA E DO ABASTECIMENTO, BEM COMO O REGULAR EXERCICIO DO PODER DE POLICIA. RECURSO VINCULADO AO FUNDO FEDERAL AGROPECUARIO, DO MINISTERIO SUPRACITADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.12.00', 'TAXAS DE SERVICOS CADASTRAIS', 'REGISTRA A VPA PROVENIENTE DAS TAXAS DE SERVICOS CADASTRAIS, TENDO COMO FATO GERADOR A APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA, DA TAXA DE SERVICOS CADASTRAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.13.00', 'TAXA DE SERVICOS AQUICOLAS', 'REGISTRA A VPA PROVENIENTE DAS TAXAS PELA PRESTACAO DE SERVICOS AQUICOLAS, ORIGINARIAS DOS REGISTROS ANUAIS DE INDUSTRIA DE PESCA, DE EMPRESAS QUE COMERCIALIZAM ANIMAIS AQUATICOS VIVOS, DE PESQUE E PAGUE E DE ARMADOR DE PESCA E AINDA DE EXPEDICAO DE CARTEIRA DE PESCADOR PROFISSIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.99.00', 'OUTRAS TAXAS PELA PRESTACAO DE SERVICOS', 'REGISTRA A VPA PROVENIENTE DE OUTRAS TAXAS PELA UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO, QUE NAO ESTEJAM REFERENCIADAS NAS NATUREZAS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.1.1.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE AGUA POTAVEL E ESGOTO SANITARIO - CONSOLIDACAO', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADE EM FUNCAO DA PAVIMENTACAO ASFALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.1.2.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE AGUA POTAVEL E ESGOTO SANITARIO - INTRA OFSS', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADE EM FUNCAO DA PAVIMENTACAO ASFALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.1.4.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE AGUA POTAVEL E ESGOTO SANITARIO - INTER OFSS - ESTADO', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADE EM FUNCAO DA PAVIMENTACAO ASFALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.1.5.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE AGUA POTAVEL E ESGOTO SANITARIO - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADE EM FUNCAO DA PAVIMENTACAO ASFALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.2.1.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE - CONSOLIDACAO', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA RE DE DE ILUMINACAO PUBLICA NA CIDADE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.2.2.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE - INTRA OFSS', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.2.4.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE - INTER OFSS - ESTADO', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.2.5.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.3.1.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DE REDE DE ILUMINACAO PUBLICA RURAL -CONSOLIDACAO', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA RURAL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.3.2.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DE REDE DE ILUMINACAO PUBLICA RURAL -INTRA OFSS', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA RURAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.3.4.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DE REDE DE ILUMINACAO PUBLICA RURAL - INTER OFSS - ESTADO', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA RURAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.3.5.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DE REDE DE ILUMINACAO PUBLICA RURAL - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA RURAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.4.1.00.00', 'CONTRIBUICAO DE MELHORIA PELA PAVIMENTACAO E OBRAS COMPLEMENTARES - CONSOLIDACAO', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA PAVIMENTACAO AS FALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.4.2.00.00', 'CONTRIBUICAO DE MELHORIA PELA PAVIMENTACAO E OBRAS COMPLEMENTARES - INTRA OFSS', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA PAVIMENTACAO AS FALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.4.4.00.00', 'CONTRIBUICAO DE MELHORIA PELA PAVIMENTACAO E OBRAS COMPLEMENTARES - INTER OFSS - ESTADO', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA PAVIMENTACAO AS FALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.4.5.00.00', 'CONTRIBUICAO DE MELHORIA PELA PAVIMENTACAO E OBRAS COMPLEMENTARES - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA PAVIMENTACAO AS FALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.9.1.00.00', 'OUTRAS CONTRIBUICOES DE MELHORIA - CONSOLIDACAO', 'REGISTRA O VALOR DE OUTRAS CONTRIBUICOES DE MELHORIAS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.9.2.00.00', 'OUTRAS CONTRIBUICOES DE MELHORIA - INTRA OFSS', 'REGISTRA O VALOR DE OUTRAS CONTRIBUICOES DE MELHORIAS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.9.4.00.00', 'OUTRAS CONTRIBUICOES DE MELHORIA - INTER OFSS - ESTADO', 'REGISTRA O VALOR DE OUTRAS CONTRIBUICOES DE MELHORIAS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.9.5.00.00', 'OUTRAS CONTRIBUICOES DE MELHORIA - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR DE OUTRAS CONTRIBUICOES DE MELHORIAS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.01.01', 'CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS', 'REGISTRA A VPA ORIUNDA DA PARTICIPACAO DA UNIAO, AUTARQUIAS E FUNDACOES PUBLICAS FEDERAIS PARA O CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, SOBRE A REMUNERACAO MENSAL DOS SERVIDORES PUBLICOS ATIVOS CIVIS DA UNIAO, DAS AUTARQUIAS, INCLUSIVE AS EM REGIME ESPECIAL, E DAS FUNDACOES PUBLICAS FEDERAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.01.02', 'CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS', 'REGISTRA A VPA DE RECOLHIMENTO DA CONTRIBUICAO PATRONAL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.02.01', 'CONTRIBUICAO DO SERVIDOR ATIVO CIVIL - RPPS', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO SERVIDOR ATIVO CIVIL SOBRE SUA REMUNERACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.02.02', 'CONTRIBUICAO DO SERVIDOR INATIVO CIVIL - RPPS', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO SERVIDOR INATIVO CIVIL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.02.03', 'CONTRIBUICAO DE PENSIONISTA CIVIL - RPPS', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO PENSIONISTA CIVIL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.02.04', 'CONTR.SERV.ATIVO CIVIL-PAGTO SENT. JUDICIAIS', 'REGISTRA A VPA ORIUNDA DE RECOLHIMENTO DA CONTRIBUICAO DO SERVIDOR CIVIL ATIVO, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.02.05', 'CONTR.SERV.INAT.CIVIL - PAGTO SENT. JUDICIAIS', 'REGISTRA AVPA ORIUNDA DE RECOLHIMENTO DA CONTRIBUICAO DO SERVIDOR INATIVO CIVIL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.02.06', 'CONTR.PENSIONISTA CIVIL-PAGTO SENT. JUDICIAIS', 'REGISTRA A VPA ORIUNDA DE RECOLHIMENTO DE PENSIONISTA CIVIL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.03.00', 'CONTRIBUICAO PREVIDENCIARIA PARA AMORTIZACAO DO DEFICIT ATUARIAL', 'REGISTRA A VPA ORIUNDA DE CONTRIBUICOES PREVIDENCIARIAS PARA AMORTIZACAO DO DEFICIT ATUARIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.04.00', 'CONTRIBUICOES PARA CUSTEIO DAS PENSOES MILITARES', 'REGISTRA AS VPA PROVENIENTES DE CONTRIBUICAO PARA CUSTEIO DAS PENSOES MILITARES, EFETIVADAS POR TODOS OS MILITARES, COM VALOR CORRESPONDENTE A SEU POSTO OU GRADUACAO, OBSERVANDO AS EXCECOES PREVISTAS NA LEI ESPECIFICA. DE COMPETENCIA DA UNIAO E DOS ESTADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.99.00', 'OUTRAS CONTRIBUICOES SOCIAIS - RPPS', 'REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUICOES PREVIDENCIARIAS NAO EN-QUADRADAS NOS SUBITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.01.01', 'CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS', 'REGISTRA A VPA ORIUNDA DA PARTICIPACAO DA UNIAO, AUTARQUIAS E FUNDACOES PUBLICAS FEDERAIS PARA O CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, SOBRE A REMUNERACAO MENSAL DOS SERVIDORES PUBLICOS ATIVOS CIVIS DA UNIAO, DAS AUTARQUIAS, INCLUSIVE AS EM REGIME ESPECIAL, E DAS FUNDACOES PUBLICAS FEDERAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.01.02', 'CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS', 'REGISTRA A VPA DE RECOLHIMENTO DA CONTRIBUICAO PATRONAL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.99.00', 'OUTRAS CONTRIBUICOES SOCIAIS - RPPS', 'REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUICOES PREVIDENCIARIAS NAO EN-QUADRADAS NOS SUBITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.01.01', 'CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS', 'REGISTRA A VPA ORIUNDA DA PARTICIPACAO DA UNIAO, AUTARQUIAS E FUNDACOES PUBLICAS FEDERAIS PARA O CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, SOBRE A REMUNERACAO MENSAL DOS SERVIDORES PUBLICOS ATIVOS CIVIS DA UNIAO, DAS AUTARQUIAS, INCLUSIVE AS EM REGIME ESPECIAL, E DAS FUNDACOES PUBLICAS FEDERAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.01.02', 'CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS', 'REGISTRA A VPA DE RECOLHIMENTO DA CONTRIBUICAO PATRONAL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.99.00', 'OUTRAS CONTRIBUICOES SOCIAIS - RPPS', 'REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUICOES PREVIDENCIARIAS NAO EN-QUADRADAS NOS SUBITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.01.01', 'CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS', 'REGISTRA A VPA ORIUNDA DA PARTICIPACAO DA UNIAO, AUTARQUIAS E FUNDACOES PUBLICAS FEDERAIS PARA O CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, SOBRE A REMUNERACAO MENSAL DOS SERVIDORES PUBLICOS ATIVOS CIVIS DA UNIAO, DAS AUTARQUIAS, INCLUSIVE AS EM REGIME ESPECIAL, E DAS FUNDACOES PUBLICAS FEDERAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.01.02', 'CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS', 'REGISTRA A VPA DE RECOLHIMENTO DA CONTRIBUICAO PATRONAL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.99.00', 'OUTRAS CONTRIBUICOES SOCIAIS - RPPS', 'REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUICOES PREVIDENCIARIAS NAO ENQUADRADAS NOS SUBITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.01.01', 'CONTRIB. DE EMPRESAS S/SEGURADOS ASSALARIADOS', 'REGISTRA A CONTRIBUICAO A CARGO DA EMPRESA, PARA A SEGURIDADE SOCIAL, SOBRE O TOTAL DAS REMUNERACOES PAGAS OU CREDITADAS NO DECORRER DO MES AOS SEGURADOS EMPREGADOS, EMPRESARIOS, TRABALHADORES AVULSOS, AUTONOMOS E EQUIPARADOS QUE LHE PRESTEM SERVICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.01.02', 'CONTRIB. PREV. DOS ORGAOS DO PODER PUBLICO', 'REGISTRA AS VPA DE CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.01.03', 'CONTRIB. PREV. DAS ENTIDADES FILANTROPICAS', 'REGISTRA AS VPA DE CONTRIBUICAO PREVIDENCIARIA DAS ENTIDADES FILANTROPICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.01.04', 'SIMPLES', 'REGISTRA AS RECEITAS DECORRENTES DE CONTRIBUICOES DAS MICROEMPRESAS E EMPRESAS DE PEQUENO PORTE, ARRECADADAS DE ACORDO COM A LEI 9317, DE 05/12/96.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.01.05', 'EMPRESAS - ESPETACULOS ESPORTIVOS', 'REGISTRA AS CONTRIBUICOES ARRECADADAS SOBRE A RECEITA BRUTA DO ESPETACULO DE FUTEBOL PROFISSIONAL, DEVIDA PELOS CLUBES DE FUTEBOL E RECOLHIDA PELA ENTIDADE PROMOTORA DO EVENTO (FEDERACAO/CONFEDERACAO).(CAMPO 16 DA GRPS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.01.06', 'CONTRIBUICAO SOBRE PRODUCAO RURAL', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO DO EMPREGADOR RURAL PARA SEGURIDADE SOCIAL PROVENIENTE DA RECEITA BRUTA DA COMERCIALIZACAO DOS PRODUTOS_RURAIS ART.25 DA LEI 8.212 ALTERADA PELA LEI 8.540 DE 22/12/92. ( CAMPO16 DA GRPS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.01.07', 'SEGURO DE ACIDENTE DO TRABALHO', 'REGISTRA A CONTRIBUICAO PARA SEGURO DE ACIDENTE DE TRABALHO URBANO QUE REPRESENTA CONTRIBUICAO DA EMPRESA, DESTINADA AO FINANCIAMENTO DA COMPLEMENTACAO DAS PRESTACOES POR ACIDENTE DE TRABALHO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.01.08', 'CONTRIB.PREV.-RET. S/NOTA FISCAL- SUBROGACAO', 'REGISTRA AS VPA ORIUNDAS DE CONTRIBUICAO PREVIDENCIARIA DAS RETENCOES SOBRE NOTAS FISCAIS - SUBROGACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.01.09', 'CONTRIBUICAO RELATIVA A DESPEDIDA DE EMPREGADO SEM JUSTA CAUSA', 'REGISTRA A CONTRIBUICAO DEVIDA PELOS EMPREGADORES EM CASO DE DESPEDIDA SEM JUSTA CAUSA, RECOLHIDA NA REDE BANCARIA E REPASSADA A CAIXA ECONOMICA, SENDO INCORPORADA AO FGTS. ESTA CONTRIBUICAO TEM COMO FATO GERADOR A DESPEDIDA DE EMPREGADO SEM JUSTA CAUSA, INCINDINDO ALIQUOTA DE 10% ( DEZ POR CENTO) SOBRE O MONTANTE DE TODOS OS DEPOSITOS DEVIDOS, REFERENTES AO FGTS, DURANTE A VIGENCIA DO CONTRATO DE TRABALHO. DESTINACAO LEGAL: PARA FAZER FACE AS DESPESAS COM A REPOSICAO DA CORRECAO MONETARIA DOS SALDOS NAS CONTAS DO FGTS. AMPARO LEGAL: LEI COMPLEMENTAR NO 110, DE 20 DE JUNHO DE 2001; LEI NO 8.036, DE 11 DE MAIO DE 1990; LEI NO 8.844, DE 20 DE JANEIRO DE 1994; E DECRETO NO 3.914, DE 11 DE SETEMBRO DE 2001.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.01.10', 'CONTRIBUICAO SOBRE A REMUNERACAO DEVIDA AO TRABALHADOR', 'REGISTRA ADICIONAL A CONTRIBUICAO SOCIAL DE 8%, DEVIDA PELO EMPREGADOR, DETERMINADA PELA APLICACAO DE ALIQUOTA 0,5% SOBRE REMUNERACAO PAGA OU DEVIDA A CADA TRABALHADOR, REFERENTE AO MES ANTERIOR, PERFAZENDO UMA ALIQUOTA DE 8,5% . A CONTRIBUICAO SERA RECOLHIDA NA REDE BANCARIA E REPASSADA E A CAIXA ECONOMICA FEDERAL. DESTINACAO LEGAL: PARA FAZER FACE AS DESPESAS COM A REPOSICAO DA CORRECAO MONETARIA DOS SALDOS NAS CONTAS DO FGTS. AMPARO LEGAL: LEI COMPLEMENTAR NO 110, DE 20 DE JUNHO DE 2001; LEI NO 8.036, DE 11 DE MAIO DE 1990; LEI NO 8.844, DE 20 DE JANEIRO DE 1994; E DECRETO NO 3.914, DE 11 DE SETEMBRO DE 2001.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.02.01', 'CONTRIB. PREV. SEGURADO - CONTRIBUINTE INDIVIDUAL', 'REGISTRA A VPA DECORRENTE DA CONTRIBUICAO PREVIDENCIARIA DO CONTRIBUINTE INDIVIDUAL AO RGPS. DE ACORDO COM A LEI Nº 8212/91.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.02.02', 'CONTRIB. PREV. SEGURADO - EMPREGADO E TRABALHADOR AVULSO', 'REGISTRA A VPA DECORRENTE DA CONTRIBUICAO PREVIDENCIARIA DO EMPREGADO, EXCETO DOMESTICO, E DO TRABALHADOR AVULSO AO RGPS.DE ACORDO COM A LEI Nº 8212/91.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.02.03', 'CONTRIB. PREV. SEGURADO - SEG. ESPECIAL', 'REGISTRA A VPA DECORRENTE DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO ESPECIAL AO RGPS.DE ACORDO COM A LEI Nº 8212/91.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.02.04', 'CONTRIB. PREV. SEGURADO - EMPREGADO DOMESTICO', 'REGISTRA A VPA DECORRENTE DA CONTRIBUICAO PREVIDENCIARIA DO EMPREGADO DOMESTICO AO RGPS. CONSIDERA-SE EMPREGADO DOMESTICO AQUELE QUE PRESTA SERVICO DE NATUREZA CONTINUA A PESSOA OU FAMILIA, NO AMBITO RESIDENCIAL DESTA, EM ATIVIDADES SEM FINS LUCRATIVOS.DE ACORDO COM A LEI Nº 8212/91.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.02.05', 'CONTRIB. PREV. SEGURADO FACULTATIVO', 'REGISTRA A VPA DECORRENTE DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO FACULTATIVO AO RGPS.DE ACORDO COM A LEI Nº 8212/91.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.03.00', 'RECLAMATORIA TRABALHISTA', 'REGISTRA O TOTAL DAS VPA DECORRENTES DE RECLAMATORIAS TRABALHISTAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.04.00', 'ARRECADACAO FIES-CERTIFICADOS FINANC.TES.NAC.', 'REGISTRA AS VPA DE ARRECADACAO P/ O FIES - CERTIFICADOS FINANCEIROS DO TESOURO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.05.00', 'ARRECADACAO FNS-CERTIFICADOS FINANC.TES.NAC.', 'REGISTRA AS VPA DE ARRECADACAO P/ O FNS - CERTIFICADOS FINANCEIROS DO TESOURO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.06.00', 'CERTIFICADOS DA DIVIDA PUBLICA - CDP', 'REGISTRA AS VPA DE CERTIFICADOS DA DIVIDA PUBLICA - CDP.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.07.00', 'CONTR.PREV.NA FORMA DE DEP.JUD.,REC. E CUSTAS', 'REGISTRA AS VPA DE CONTRIBUICOES PREVIDENCIARIAS NA FORMA DE DEPOSITOS JUDICIAIS, RECURSAIS E CUSTAS JUDICIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.99.00', 'OUTRAS CONTRIBUICOES SOCIAIS AO RGPS', 'REGISTRA O VALOR DAS VPA DE CONTRIBUICOES PREVIDENCIARIAS NAO ENQUADRADAS NOS SUBITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.01.01', 'CONTRIB. DE EMPRESAS S/SEGURADOS ASSALARIADOS', 'REGISTRA A CONTRIBUICAO A CARGO DA EMPRESA, PARA A SEGURIDADE SOCIAL, SOBRE O TOTAL DAS REMUNERACOES PAGAS OU CREDITADAS NO DECORRER DO MES AOS SEGURADOS EMPREGADOS, EMPRESARIOS, TRABALHADORES AVULSOS, AUTONOMOS E EQUIPARADOS QUE LHE PRESTEM SERVICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.01.02', 'CONTRIB. PREV. DOS ORGAOS DO PODER PUBLICO', 'REGISTRA AS VPA DE CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.01.03', 'CONTRIB. PREV. DAS ENTIDADES FILANTROPICAS', 'REGISTRA AS VPA DE CONTRIBUICAO PREVIDENCIARIA DAS ENTIDADES FILANTROPICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.01.04', 'SIMPLES', 'REGISTRA AS RECEITAS DECORRENTES DE CONTRIBUICOES DAS MICROEMPRESAS E EMPRESAS DE PEQUENO PORTE, ARRECADADAS DE ACORDO COM A LEI 9317, DE 05/12/96.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.01.05', 'EMPRESAS - ESPETACULOS ESPORTIVOS', 'REGISTRA AS CONTRIBUICOES ARRECADADAS SOBRE A RECEITA BRUTA DO ESPETACULO DE FUTEBOL PROFISSIONAL, DEVIDA PELOS CLUBES DE FUTEBOL E RECOLHIDA PELA ENTIDADE PROMOTORA DO EVENTO (FEDERACAO/CONFEDERACAO).(CAMPO 16 DA GRPS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.01.06', 'CONTRIBUICAO SOBRE PRODUCAO RURAL', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO DO EMPREGADOR RURAL PARA SEGURIDADE SOCIAL PROVENIENTE DA RECEITA BRUTA DA COMERCIALIZACAO DOS PRODUTOS_RURAIS ART.25 DA LEI 8.212 ALTERADA PELA LEI 8.540 DE 22/12/92. ( CAMPO16 DA GRPS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.01.07', 'SEGURO DE ACIDENTE DO TRABALHO', 'REGISTRA A CONTRIBUICAO PARA SEGURO DE ACIDENTE DE TRABALHO URBANO QUE REPRESENTA CONTRIBUICAO DA EMPRESA, DESTINADA AO FINANCIAMENTO DA COMPLEMENTACAO DAS PRESTACOES POR ACIDENTE DE TRABALHO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.01.08', 'CONTRIB.PREV.-RET. S/NOTA FISCAL- SUBROGACAO', 'REGISTRA AS VPA ORIUNDAS DE CONTRIBUICAO PREVIDENCIARIA DAS RETENCOES SOBRE NOTAS FISCAIS - SUBROGACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.01.09', 'CONTRIBUICAO RELATIVA A DESPEDIDA DE EMPREGADO SEM JUSTA CAUSA', 'REGISTRA A CONTRIBUICAO DEVIDA PELOS EMPREGADORES EM CASO DE DESPEDIDA SEM JUSTA CAUSA, RECOLHIDA NA REDE BANCARIA E REPASSADA A CAIXA ECONOMICA, SENDO INCORPORADA AO FGTS. ESTA CONTRIBUICAO TEM COMO FATO GERADOR A DESPEDIDA DE EMPREGADO SEM JUSTA CAUSA, INCINDINDO ALIQUOTA DE 10% ( DEZ POR CENTO) SOBRE O MONTANTE DE TODOS OS DEPOSITOS DEVIDOS, REFERENTES AO FGTS, DURANTE A VIGENCIA DO CONTRATO DE TRABALHO. DESTINACAO LEGAL: PARA FAZER FACE AS DESPESAS COM A REPOSICAO DA CORRECAO MONETARIA DOS SALDOS NAS CONTAS DO FGTS. AMPARO LEGAL: LEI COMPLEMENTAR NO 110, DE 20 DE JUNHO DE 2001; LEI NO 8.036, DE 11 DE MAIO DE 1990; LEI NO 8.844, DE 20 DE JANEIRO DE 1994; E DECRETO NO 3.914, DE 11 DE SETEMBRO DE 2001.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.01.10', 'CONTRIBUICAO SOBRE A REMUNERACAO DEVIDA AO TRABALHADOR', 'REGISTRA ADICIONAL A CONTRIBUICAO SOCIAL DE 8%, DEVIDA PELO EMPREGADOR, DETERMINADA PELA APLICACAO DE ALIQUOTA 0,5% SOBRE REMUNERACAO PAGA OU DEVIDA A CADA TRABALHADOR, REFERENTE AO MES ANTERIOR, PERFAZENDO UMA ALIQUOTA DE 8,5% . A CONTRIBUICAO SERA RECOLHIDA NA REDE BANCARIA E REPASSADA E A CAIXA ECONOMICA FEDERAL. DESTINACAO LEGAL: PARA FAZER FACE AS DESPESAS COM A REPOSICAO DA CORRECAO MONETARIA DOS SALDOS NAS CONTAS DO FGTS. AMPARO LEGAL: LEI COMPLEMENTAR NO 110, DE 20 DE JUNHO DE 2001; LEI NO 8.036, DE 11 DE MAIO DE 1990; LEI NO 8.844, DE 20 DE JANEIRO DE 1994; E DECRETO NO 3.914, DE 11 DE SETEMBRO DE 2001.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.03.00', 'RECLAMATORIA TRABALHISTA', 'REGISTRA O TOTAL DAS VPA DECORRENTES DE RECLAMATORIAS TRABALHISTAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.04.00', 'ARRECADACAO FIES-CERTIFICADOS FINANC.TES.NAC.', 'REGISTRA AS VPA DE ARRECADACAO P/ O FIES - CERTIFICADOS FINANCEI-ROS DO TESOURO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.05.00', 'ARRECADACAO FNS-CERTIFICADOS FINANC.TES.NAC.', 'REGISTRA AS VPA DE ARRECADACAO P/ O FNS - CERTIFICADOS FINANCEIROS DO TESOURO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.06.00', 'CERTIFICADOS DA DIVIDA PUBLICA - CDP', 'REGISTRA AS VPA DE CERTIFICADOS DA DIVIDA PUBLICA - CDP.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.07.00', 'CONTR.PREV.NA FORMA DE DEP.JUD.,REC. E CUSTAS', 'REGISTRA AS VPA DE CONTRIBUICOES PREVIDENCIARIAS NA FORMA DE DEPOSITOS JUDICIAIS, RECURSAIS E CUSTAS JUDICIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.99.00', 'OUTRAS CONTRIBUICOES SOCIAIS AO RGPS', 'REGISTRA O VALOR DAS VPA DE CONTRIBUICOES PREVIDENCIARIAS NAO ENQUADRADAS NOS SUBITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.01.01', 'CONTRIB. DE EMPRESAS S/SEGURADOS ASSALARIADOS', 'REGISTRA A CONTRIBUICAO A CARGO DA EMPRESA, PARA A SEGURIDADE SOCIAL, SOBRE O TOTAL DAS REMUNERACOES PAGAS OU CREDITADAS NO DECORRER DO MES AOS SEGURADOS EMPREGADOS, EMPRESARIOS, TRABALHADORES AVULSOS, AUTONOMOS E EQUIPARADOS QUE LHE PRESTEM SERVICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.01.02', 'CONTRIB. PREV. DOS ORGAOS DO PODER PUBLICO', 'REGISTRA AS VPA DE CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.01.03', 'CONTRIB. PREV. DAS ENTIDADES FILANTROPICAS', 'REGISTRA AS VPA DE CONTRIBUICAO PREVIDENCIARIA DAS ENTIDADES FILANTROPICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.01.04', 'SIMPLES', 'REGISTRA AS RECEITAS DECORRENTES DE CONTRIBUICOES DAS MICROEMPRESAS E EMPRESAS DE PEQUENO PORTE, ARRECADADAS DE ACORDO COM A LEI 9317, DE 05/12/96.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.01.05', 'EMPRESAS - ESPETACULOS ESPORTIVOS', 'REGISTRA AS CONTRIBUICOES ARRECADADAS SOBRE A RECEITA BRUTA DO ESPETACULO DE FUTEBOL PROFISSIONAL, DEVIDA PELOS CLUBES DE FUTEBOL E RECOLHIDA PELA ENTIDADE PROMOTORA DO EVENTO (FEDERACAO/CONFEDERACAO).(CAMPO 16 DA GRPS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.01.06', 'CONTRIBUICAO SOBRE PRODUCAO RURAL', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO DO EMPREGADOR RURAL PARA SEGURIDADE SOCIAL PROVENIENTE DA RECEITA BRUTA DA COMERCIALIZACAO DOS PRODUTOS_RURAIS ART.25 DA LEI 8.212 ALTERADA PELA LEI 8.540 DE 22/12/92. ( CAMPO16 DA GRPS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.01.07', 'SEGURO DE ACIDENTE DO TRABALHO', 'REGISTRA A CONTRIBUICAO PARA SEGURO DE ACIDENTE DE TRABALHO URBANO QUE REPRESENTA CONTRIBUICAO DA EMPRESA, DESTINADA AO FINANCIAMENTO DA COMPLEMENTACAO DAS PRESTACOES POR ACIDENTE DE TRABALHO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.01.08', 'CONTRIB.PREV.-RET. S/NOTA FISCAL- SUBROGACAO', 'REGISTRA AS VPA ORIUNDAS DE CONTRIBUICAO PREVIDENCIARIA DAS RETENCOES SOBRE NOTAS FISCAIS - SUBROGACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.01.09', 'CONTRIBUICAO RELATIVA A DESPEDIDA DE EMPREGADO SEM JUSTA CAUSA', 'REGISTRA A CONTRIBUICAO DEVIDA PELOS EMPREGADORES EM CASO DE DESPEDIDA SEM JUSTA CAUSA, RECOLHIDA NA REDE BANCARIA E REPASSADA A CAIXA ECONOMICA, SENDO INCORPORADA AO FGTS. ESTA CONTRIBUICAO TEM COMO FATO GERADOR A DESPEDIDA DE EMPREGADO SEM JUSTA CAUSA, INCINDINDO ALIQUOTA DE 10% ( DEZ POR CENTO) SOBRE O MONTANTE DE TODOS OS DEPOSITOS DEVIDOS, REFERENTES AO FGTS, DURANTE A VIGENCIA DO CONTRATO DE TRABALHO. DESTINACAO LEGAL: PARA FAZER FACE AS DESPESAS COM A REPOSICAO DA CORRECAO MONETARIA DOS SALDOS NAS CONTAS DO FGTS. AMPARO LEGAL: LEI COMPLEMENTAR NO 110, DE 20 DE JUNHO DE 2001; LEI NO 8.036, DE 11 DE MAIO DE 1990; LEI NO 8.844, DE 20 DE JANEIRO DE 1994; E DECRETO NO 3.914, DE 11 DE SETEMBRO DE 2001.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.01.10', 'CONTRIBUICAO SOBRE A REMUNERACAO DEVIDA AO TRABALHADOR', 'REGISTRA ADICIONAL A CONTRIBUICAO SOCIAL DE 8%, DEVIDA PELO EMPREGADOR, DETERMINADA PELA APLICACAO DE ALIQUOTA 0,5% SOBRE REMUNERACAO PAGA OU DEVIDA A CADA TRABALHADOR, REFERENTE AO MES ANTERIOR, PERFAZENDO UMA ALIQUOTA DE 8,5% . A CONTRIBUICAO SERA RECOLHIDA NA REDE BANCARIA E REPASSADA E A CAIXA ECONOMICA FEDERAL. DESTINACAO LEGAL: PARA FAZER FACE AS DESPESAS COM A REPOSICAO DA CORRECAO MONETARIA DOS SALDOS NAS CONTAS DO FGTS. AMPARO LEGAL: LEI COMPLEMENTAR NO 110, DE 20 DE JUNHO DE 2001; LEI NO 8.036, DE 11 DE MAIO DE 1990; LEI NO 8.844, DE 20 DE JANEIRO DE 1994; E DECRETO NO 3.914, DE 11 DE SETEMBRO DE 2001.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.03.00', 'RECLAMATORIA TRABALHISTA', 'REGISTRA O TOTAL DAS VPA DECORRENTES DE RECLAMATORIAS TRABALHISTAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.04.00', 'ARRECADACAO FIES-CERTIFICADOS FINANC.TES.NAC.', 'REGISTRA AS VPA DE ARRECADACAO P/ O FIES - CERTIFICADOS FINANCEI-ROS DO TESOURO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.05.00', 'ARRECADACAO FNS-CERTIFICADOS FINANC.TES.NAC.', 'REGISTRA AS VPA DE ARRECADACAO P/ O FNS - CERTIFICADOS FINANCEIROS DO TESOURO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.06.00', 'CERTIFICADOS DA DIVIDA PUBLICA - CDP', 'REGISTRA AS VPA DE CERTIFICADOS DA DIVIDA PUBLICA - CDP.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.07.00', 'CONTR.PREV.NA FORMA DE DEP.JUD.,REC. E CUSTAS', 'REGISTRA AS VPA DE CONTRIBUICOES PREVIDENCIARIAS NA FORMA DE DEPOSITOS JUDICIAIS, RECURSAIS E CUSTAS JUDICIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.99.00', 'OUTRAS CONTRIBUICOES SOCIAIS AO RGPS', 'REGISTRA O VALOR DAS VPA DE CONTRIBUICOES PREVIDENCIARIAS NAO ENQUADRADAS NOS SUBITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.01.01', 'CONTRIB. DE EMPRESAS S/SEGURADOS ASSALARIADOS', 'REGISTRA A CONTRIBUICAO A CARGO DA EMPRESA, PARA A SEGURIDADE SOCIAL, SOBRE O TOTAL DAS REMUNERACOES PAGAS OU CREDITADAS NO DECORRER DO MES AOS SEGURADOS EMPREGADOS, EMPRESARIOS, TRABALHADORES AVULSOS, AUTONOMOS E EQUIPARADOS QUE LHE PRESTEM SERVICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.01.02', 'CONTRIB. PREV. DOS ORGAOS DO PODER PUBLICO', 'REGISTRA AS VPA DE CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.01.03', 'CONTRIB. PREV. DAS ENTIDADES FILANTROPICAS', 'REGISTRA AS VPA DE CONTRIBUICAO PREVIDENCIARIA DAS ENTIDADES FILANTROPICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.01.04', 'SIMPLES', 'REGISTRA AS RECEITAS DECORRENTES DE CONTRIBUICOES DAS MICROEMPRESAS E EMPRESAS DE PEQUENO PORTE, ARRECADADAS DE ACORDO COM A LEI 9317, DE 05/12/96.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.01.05', 'EMPRESAS - ESPETACULOS ESPORTIVOS', 'REGISTRA AS CONTRIBUICOES ARRECADADAS SOBRE A RECEITA BRUTA DO ESPETACULO DE FUTEBOL PROFISSIONAL, DEVIDA PELOS CLUBES DE FUTEBOL E RECOLHIDA PELA ENTIDADE PROMOTORA DO EVENTO (FEDERACAO/CONFEDERACAO).(CAMPO 16 DA GRPS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.01.06', 'CONTRIBUICAO SOBRE PRODUCAO RURAL', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO DO EMPREGADOR RURAL PARA SEGURIDADE SOCIAL PROVENIENTE DA RECEITA BRUTA DA COMERCIALIZACAO DOS PRODUTOS_RURAIS ART.25 DA LEI 8.212 ALTERADA PELA LEI 8.540 DE 22/12/92. ( CAMPO16 DA GRPS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.01.07', 'SEGURO DE ACIDENTE DO TRABALHO', 'REGISTRA A CONTRIBUICAO PARA SEGURO DE ACIDENTE DE TRABALHO URBANO QUE REPRESENTA CONTRIBUICAO DA EMPRESA, DESTINADA AO FINANCIAMENTO DA COMPLEMENTACAO DAS PRESTACOES POR ACIDENTE DE TRABALHO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.01.08', 'CONTRIB.PREV.-RET. S/NOTA FISCAL- SUBROGACAO', 'REGISTRA AS VPA ORIUNDAS DE CONTRIBUICAO PREVIDENCIARIA DAS RETENCOES SOBRE NOTAS FISCAIS - SUBROGACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.01.09', 'CONTRIBUICAO RELATIVA A DESPEDIDA DE EMPREGADO SEM JUSTA CAUSA', 'REGISTRA A CONTRIBUICAO DEVIDA PELOS EMPREGADORES EM CASO DE DESPEDIDA SEM JUSTA CAUSA, RECOLHIDA NA REDE BANCARIA E REPASSADA A CAIXA ECONOMICA, SENDO INCORPORADA AO FGTS. ESTA CONTRIBUICAO TEM COMO FATO GERADOR A DESPEDIDA DE EMPREGADO SEM JUSTA CAUSA, INCINDINDO ALIQUOTA DE 10% ( DEZ POR CENTO) SOBRE O MONTANTE DE TODOS OS DEPOSITOS DEVIDOS, REFERENTES AO FGTS, DURANTE A VIGENCIA DO CONTRATO DE TRABALHO. DESTINACAO LEGAL: PARA FAZER FACE AS DESPESAS COM A REPOSICAO DA CORRECAO MONETARIA DOS SALDOS NAS CONTAS DO FGTS. AMPARO LEGAL: LEI COMPLEMENTAR NO 110, DE 20 DE JUNHO DE 2001; LEI NO 8.036, DE 11 DE MAIO DE 1990; LEI NO 8.844, DE 20 DE JANEIRO DE 1994; E DECRETO NO 3.914, DE 11 DE SETEMBRO DE 2001.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.01.10', 'CONTRIBUICAO SOBRE A REMUNERACAO DEVIDA AO TRABALHADOR', 'REGISTRA ADICIONAL A CONTRIBUICAO SOCIAL DE 8%, DEVIDA PELO EMPREGADOR, DETERMINADA PELA APLICACAO DE ALIQUOTA 0,5% SOBRE REMUNERACAO PAGA OU DEVIDA A CADA TRABALHADOR, REFERENTE AO MES ANTERIOR, PERFAZENDO UMA ALIQUOTA DE 8,5% . A CONTRIBUICAO SERA RECOLHIDA NA REDE BANCARIA E REPASSADA E A CAIXA ECONOMICA FEDERAL. DESTINACAO LEGAL: PARA FAZER FACE AS DESPESAS COM A REPOSICAO DA CORRECAO MONETARIA DOS SALDOS NAS CONTAS DO FGTS. AMPARO LEGAL: LEI COMPLEMENTAR NO 110, DE 20 DE JUNHO DE 2001; LEI NO 8.036, DE 11 DE MAIO DE 1990; LEI NO 8.844, DE 20 DE JANEIRO DE 1994; E DECRETO NO 3.914, DE 11 DE SETEMBRO DE 2001.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.03.00', 'RECLAMATORIA TRABALHISTA', 'REGISTRA O TOTAL DAS VPA DECORRENTES DE RECLAMATORIAS TRABALHISTAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.04.00', 'ARRECADACAO FIES-CERTIFICADOS FINANC.TES.NAC.', 'REGISTRA AS VPA DE ARRECADACAO P/ O FIES - CERTIFICADOS FINANCEI-ROS DO TESOURO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.05.00', 'ARRECADACAO FNS-CERTIFICADOS FINANC.TES.NAC.', 'REGISTRA AS VPA DE ARRECADACAO P/ O FNS - CERTIFICADOS FINANCEIROS DO TESOURO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.06.00', 'CERTIFICADOS DA DIVIDA PUBLICA - CDP', 'REGISTRA AS VPA DE CERTIFICADOS DA DIVIDA PUBLICA - CDP.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.07.00', 'CONTR.PREV.NA FORMA DE DEP.JUD.,REC. E CUSTAS', 'REGISTRA AS VPA DE CONTRIBUICOES PREVIDENCIARIAS NA FORMA DE DEPOSITOS JUDICIAIS, RECURSAIS E CUSTAS JUDICIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.99.00', 'OUTRAS CONTRIBUICOES SOCIAIS AO RGPS', 'REGISTRA O VALOR DAS VPA DE CONTRIBUICOES PREVIDENCIARIAS NAO ENQUADRADAS NOS SUBITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.1.01.00', 'CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS', 'REGISTRA O PRINCIPAL DA VPA DECORRENTE DE CONTRIBUICOES PARA FINANCIAMENTO DA SEGURIDADE SOCIAL. TEM POR FATO GERADOR A VENDA DE MERCADORIAS E/OU SERVICOS DE QUALQUER NATUREZA E A PERCEPCAO DE RENDAS OU RECEITAS OPERACIONAIS E NAO OPERACIONAIS, E RENDAS OU RECEITAS PATRIMONIAIS (LEI COMPLEMENTAR NUM. 70, DE 07/09/70). INTEGRA O ORCAMENTO DA SEGURIDADE SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.1.02.00', 'CONTRIBUICOES P/ O PIS/PASEP', 'REGISTRA A VPA DECORRENTE DE CONTRIBUICOES PARA OS PROGRAMAS DE INTEGRACAO SOCIAL E DE FORMACAO DO PATRIMONIO DO SERVIDOS PUBLICO - PIS/PASEP. INCIDE SOBRE A RECEITA OPERACIONAL BRUTA DE EMPRESASPUBLICAS E PRIVADAS, SOBRE A FOLHA DE PAGAMENTO DAS ENTIDADES SEM FINSLUCRATIVOS, E SOBRE A RECEITA CORRENTE LIQUIDA DE TRANSFERENCIAS DA U-NIAO, ESTADOS, MUNICIPIOS, DF E AUTARQUIAS. DESTINA-SE AO FUNDO DE AM-PARO AO TRABALHADOR - FAT, PARA O CUSTEIO DO PROGRAMA DE SEGURO DESEMPREGO E CONCESSAO DE ABONOS SALARIAIS. PELO MENOS 40% (QUARENTA PORCENTO) SERAO REPASSADOS AO BNDES PARA APLICACAO EM PROGRAMAS DE DESEN-VOLVIMENTO ECONOMICO. INTEGRA O ORCAMENTO DA SEGURIDADE SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.1.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.2.01.00', 'CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS', 'REGISTRA O PRINCIPAL DA VPA DECORRENTE DE CONTRIBUICOES PARA FINANCIAMENTO DA SEGURIDADE SOCIAL. TEM POR FATO GERADOR A VENDA DE MERCADORIAS E/OU SERVICOS DE QUALQUER NATUREZA E A PERCEPCAO DE RENDAS OU RECEITAS OPERACIONAIS E NAO OPERACIONAIS, E RENDAS OU RECEITAS PATRIMONIAIS (LEI COMPLEMENTAR NUM. 70, DE 07/09/70). INTEGRA O ORCAMENTO DA SEGURIDADE SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.2.02.00', 'CONTRIBUICOES P/ O PIS/PASEP', 'REGISTRA A VPA DECORRENTE DE CONTRIBUICOES PARA OS PROGRAMAS DE INTEGRACAO SOCIAL E DE FORMACAO DO PATRIMONIO DO SERVIDOS PUBLICO - PIS/PASEP. INCIDE SOBRE A RECEITA OPERACIONAL BRUTA DE EMPRESASPUBLICAS E PRIVADAS, SOBRE A FOLHA DE PAGAMENTO DAS ENTIDADES SEM FINSLUCRATIVOS, E SOBRE A RECEITA CORRENTE LIQUIDA DE TRANSFERENCIAS DA U-NIAO, ESTADOS, MUNICIPIOS, DF E AUTARQUIAS. DESTINA-SE AO FUNDO DE AM-PARO AO TRABALHADOR - FAT, PARA O CUSTEIO DO PROGRAMA DE SEGURO DESEMPREGO E CONCESSAO DE ABONOS SALARIAIS. PELO MENOS 40% (QUARENTA PORCENTO) SERAO REPASSADOS AO BNDES PARA APLICACAO EM PROGRAMAS DE DESEN-VOLVIMENTO ECONOMICO. INTEGRA O ORCAMENTO DA SEGURIDADE SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.2.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.4.01.01', 'PRINCIPAL DA CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS', 'REGISTRA O PRINCIPAL DA VPA DECORRENTE DE CONTRIBUICOES PARA FINANCIAMENTO DA SEGURIDADE SOCIAL. TEM POR FATO GERADOR A VENDA DE MERCADORIAS E/OU SERVICOS DE QUALQUER NATUREZA E A PERCEPCAO DE RENDAS OU RE-CEITAS OPERACIONAIS E NAO OPERACIONAIS, E RENDAS OU RECEITAS PATRIMO-NIAIS (LEI COMPLEMENTAR NUM. 70, DE 07/09/70). INTEGRA O ORCAMENTO DASEGURIDADE SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.4.02.01', 'PRINCIPAL DAS CONTRIBUICOES P/ O PIS/PASEP', 'REGISTRA A VPA DECORRENTE DE CONTRIBUICOES PARA OS PROGRAMAS DE INTEGRACAO SOCIAL E DE FORMACAO DO PATRIMONIO DO SERVIDOS PUBLICO - PIS/PASEP. INCIDE SOBRE A RECEITA OPERACIONAL BRUTA DE EMPRESASPUBLICAS E PRIVADAS, SOBRE A FOLHA DE PAGAMENTO DAS ENTIDADES SEM FINSLUCRATIVOS, E SOBRE A RECEITA CORRENTE LIQUIDA DE TRANSFERENCIAS DA U-NIAO, ESTADOS, MUNICIPIOS, DF E AUTARQUIAS. DESTINA-SE AO FUNDO DE AM-PARO AO TRABALHADOR - FAT, PARA O CUSTEIO DO PROGRAMA DE SEGURO DESEMPREGO E CONCESSAO DE ABONOS SALARIAIS. PELO MENOS 40% (QUARENTA PORCENTO) SERAO REPASSADOS AO BNDES PARA APLICACAO EM PROGRAMAS DE DESEN-VOLVIMENTO ECONOMICO. INTEGRA O ORCAMENTO DA SEGURIDADE SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.4.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.5.01.01', 'PRINCIPAL DA CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS', 'REGISTRA O PRINCIPAL DA VPA DECORRENTE DE CONTRIBUICOES PARA FINANCIAMENTO DA SEGURIDADE SOCIAL. TEM POR FATO GERADOR A VENDA DE MERCADORIAS E/OU SERVICOS DE QUALQUER NATUREZA E A PERCEPCAO DE RENDAS OU RE-CEITAS OPERACIONAIS E NAO OPERACIONAIS, E RENDAS OU RECEITAS PATRIMO-NIAIS (LEI COMPLEMENTAR NUM. 70, DE 07/09/70). INTEGRA O ORCAMENTO DASEGURIDADE SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.5.02.01', 'PRINCIPAL DAS CONTRIBUICOES P/ O PIS/PASEP', 'REGISTRA A VPA DECORRENTE DE CONTRIBUICOES PARA OS PROGRAMAS DE INTEGRACAO SOCIAL E DE FORMACAO DO PATRIMONIO DO SERVIDOS PUBLICO - PIS/PASEP. INCIDE SOBRE A RECEITA OPERACIONAL BRUTA DE EMPRESASPUBLICAS E PRIVADAS, SOBRE A FOLHA DE PAGAMENTO DAS ENTIDADES SEM FINSLUCRATIVOS, E SOBRE A RECEITA CORRENTE LIQUIDA DE TRANSFERENCIAS DA U-NIAO, ESTADOS, MUNICIPIOS, DF E AUTARQUIAS. DESTINA-SE AO FUNDO DE AM-PARO AO TRABALHADOR - FAT, PARA O CUSTEIO DO PROGRAMA DE SEGURO DESEMPREGO E CONCESSAO DE ABONOS SALARIAIS. PELO MENOS 40% (QUARENTA PORCENTO) SERAO REPASSADOS AO BNDES PARA APLICACAO EM PROGRAMAS DE DESEN-VOLVIMENTO ECONOMICO. INTEGRA O ORCAMENTO DA SEGURIDADE SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.5.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.1.01.00', 'CONTRIBUICAO SOBRE O LUCRO', 'REGISTRA A CONTRIBUICAO DO EMPREGADOR,DA EMPRESA E DA ENTIDADE A ELA EQU IPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: O CSLL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.1.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.2.01.00', 'CONTRIBUICAO SOBRE O LUCRO', 'REGISTRA A CONTRIBUICAO DO EMPREGADOR,DA EMPRESA E DA ENTIDADE A ELA EQU IPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: O CSLL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.2.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.4.01.00', 'CONTRIBUICAO SOBRE O LUCRO', 'REGISTRA A CONTRIBUICAO DO EMPREGADOR,DA EMPRESA E DA ENTIDADE A ELA EQU IPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: O CSLL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.4.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.5.01.00', 'CONTRIBUICAO SOBRE O LUCRO', 'REGISTRA A CONTRIBUICAO DO EMPREGADOR,DA EMPRESA E DA ENTIDADE A ELA EQU IPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: O CSLL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.5.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.1.01.00', 'CONTRIBUICAO S/RECEITA DA LOTERIAL FEDERAL', 'REGISTRA A VPA DECORRENTE DA CONTRIBUICAO S/ RECEITA DE CONCURSOS DE PROGNOSTICOS - LOTERIA FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.1.02.00', 'CONTRIBUICAO S/RECEITA LOTERIA ESPORTIVA', 'REGISTRA A VPA DECORRENTE DA CONTRIBUICAO S/ RECEITA DE CONCURSOS DE PROGNOSTICOS - LOTERIA ESPORTIVA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.1.03.00', 'CONTRIBUICAO S/RECEITA LOTERIAS DE NUMEROS', 'REGISTRA A VPA DECORRENTE DA CONTRIBUICAO S/ RECEITA DE CONCURSOS DE PROGNOSTICOS - LOTERIAS DE NUMEROS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.1.04.00', 'CONTRIBUICAO S/RECEITA LOTERIA INSTANTANEA', 'REGISTRA A VPA DECORRENTE DA CONTRIBUICAO S/ RECEITA DE CONCURSOS DE PROGNOSTICOS - LOTERIA INSTANTANEA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.1.05.00', 'PREMIOS PRESCRITOS DE LOTERIAS FEDERAIS', 'REGISTRA A VPA DECORRENTE DA CONTRIBUICAO S/ RECEITA DE PREMIOS PRESCRITOS DE LOTERIAS FEDERAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.1.06.00', 'CONTR.S/REC.CONC.PROG.DEST.PRAT.DESP-MOD.FUTE', 'REGISTRA A VPA DECORRENTE DA CONTRIBUICAO SOBRE A RECEITA DE OUTROS CONCURSOS DE PROGNOSTICOS PARA O DESENVOLVIMENTO DA PRATICA ESPORTIVA - MODALIDADE FUTEBOL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.1.07.00', 'CONTRIBUICAO S/ RECEITAS SORTEIOS REALIZADOS P/ ENT. FILANTROPICAS', 'REGISTRA O A VPA DE CONTRIBUICAO SOBRE A RECEITA DE SORTEIOS REALIZADOS POR ENTIDADES FILANTROPICAS. CORRESPONDE A 8% (OITO POR CENTO) DA RECEITA BRUTA AUFERIDA NOS SORTE-IOS REALIZADOS POR ENTIDADES FILANTROPICAS A SEREM RATEADOS DA SEGUIN-TE FORMA: - 3% (TRES POR CENTO) DA RECEITA BRUTA AUFERIDA NO SORTEIO SERA DESTI-NADA AO FUNPEN; - 3% (TRES POR CENTO) DA RECEITA BRUTA AUFERIDA NO SORTEIO SERA DESTI-NADA PARA O FUNDO NACIONAL DE CULTURA - FNC; - 1% (UM POR CENTO) DA RECEITA BRUTA AUFERIDA NO SORTEIO PARA O FUNDO DA CRIANCA E DO ADOLESCENTE; - 1% (UM POR CENTO) DA RECEITA BRUTA PARA O FUNDO DE DEFESA DOS DIREI-TOS DIFUSOS - FDD.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.1.08.00', 'CONTRIBUICOES SOBRE JOGOS DE BINGOS', 'REGISTRA A VPA DECORRENTE DE CONTRIBUICAO SOBRE A RECEITA DE OUTROS JOGOS E BINGOS EM CASA DE JOGOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.1.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.1.99.00', 'CONTRIBUICAO S/RECEITA OUTROS CONC. PROGNOST.', 'REGISTRA A VPA DECORRENTE DA CONTRIBUICAO SOBRE A RECEITA DE OUTROS CONCURSOS DE PROGNOSTICOS. (NATUREZA 1210.18.07 INCLUIDA PELA PORTARIA SOF Nº 28, DE 13 DE SETEM-BRO DE 2006.)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.1.01.00', 'CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR -', 'REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.1.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.2.01.00', 'CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR -', 'REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOSDO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.2.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.4.01.00', 'CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR -', 'REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.4.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.5.01.00', 'CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR -', 'REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.5.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.1.01.00', 'CONTRIBUICAO DO SALARIO-EDUCACAO', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO DESTINADA AO SALARIO-EDUCACAO. CONSTITUI-SE NA OBRIGACAO POR PARTE DAS EMPRESAS COMERCIAIS, INDUSTRIAIS E AGRICOLAS DE MANTER O ENSINO PRIMARIO GRATUITODE SEUS EMPREGADOS E O ENSINO DOS FILHOS DESTES, ENTRE OS 7 (SETE) E14 (QUATORZE) AOS, OU A CONCORRER PARA AQUELE FIM MEDIANTE A CONTRIBU-ICAO DO SALARIO-EDUCACAO (LEI NUM. 4.440, DE 27/10/64). CALCULADA SO-BRE O VALOR DA FOLHA DO SALARIO DE CONTRIBUICAO, NO CASO DAS EMPRESASVINCULADAS A PREVIDENCIA SOCIAL URBANA, E SOBRE O VALOR COMERCIAL DOSPRODUTOS AGRICOLAS, NO CASO DAS EMPRESAS VINCULADAS A PREVIDENCIA SOCIAL RURAL. A ARRECADACAO E DESTINADA 2/3 EM FAVOR DA UNIDADE DA FEDE-RACAO ONDE HOUVER SIDO EFETUADA A ARRECADACAO, DESTINANDO-SE OS RECUR-SOS AS RESPECTIVAS SECRETARIAS DE EDUCACAO; 1/3 EM FAVOR DA UNIAO COMORECEITA VINCULADA AO FUNDO NACIONAL DE DESENVOLVIMENTO DA EDUCACAO -FNDE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.1.02.00', 'COTA-PARTE DA CONTRIBUICAO SINDICAL', 'REGISTRA A VPA PROVENIENTE DA COTA-PARTE DA CONTRIBUICAOSINDICAL. CORRESPONDE A 20% DA ARRECADACAO DA CONTRIBUICAO SINDICAL(NO CASO DA CONTRIBUICAO RURAL, O PERCENTUAL E DE 10%). CONSTITUI-SEEM UMA CONTRIBUICAO PARAFISCAL EQUIVALENTE A UM DIA DE REMUNERACAO DETODO O TRABALHADOR DO MERCADO FORMAL DE TRABALHO. INTEGRA O ORCAMENTODA SEGURIDADE SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.1.03.00', 'CONTRIBUICAO PARA O ENSINO AEROVIARIO', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO P/ENSINO AEROVIARIO. CONTRIBUICAO PELOS SERVICOS DE AVIACAO CIVIL, DEVIDA PELAS EMPRE-SAS DE: TRANSPORTE E SERVICOS AEREOS; TELECOMUNICACOES AERONAUTICAS;ATIVIDADES RELACIONADAS A INFRA-ESTRUTURA AEROPORTUARIA; FABRICACAO,REPARO E MANUTENCAO, OU REPRESENTACAO, DE AERONAVES E EQUIPAMENTOS A-ERONAUTICOS. CALCULADA SOBRE O SALARIO DE CONTRIBUICAO DOS EMPREGADOSSUBSTITUI A CONTRIBUICAO DEVIDA AO SENAI, SENAC, SESI E SESC. E VINCU-LADA AO FUNDO AEROVIARIO, PARA APLICACAO NO DESENVOLVIMENTO DO ENSINOPROFISSIONAL AERONAUTICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.1.04.00', 'CONTRIBUICAO PARA DESENV.ENS.PROFIS.MARITIMO', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO PARA CUSTEAR O DESENVOLVIMENTO DO ENSINO DO PROSSIONAL MARITIMO. CONTRIBUICAO PELA PRESTACAO DE SERVICOS DE NAVEGACAO, DEVIDA PELAS EMPRESAS DE NAVEGACAO MARITIMA, FLUVIAL OU LACUSTRE, DE SERVICOS PORTUARIOS, DE DRAGAGEM E DE ADMINISTRACAO E DE EXPLORACAO DE PORTOS. CALCULADA SOBRE O SALARIO DE CONTRIBUICAO DOS EMPREGADOS, SUBSTITUI A CONTRIBUICAO DEVIDA AO SENAI, SENAC, SESI E SESC. E VINCULADA AO FUNDO DE DESENVOLVIMENTO DOENSINO PROFISSIONAL MARITIMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.1.05.00', 'CONTRIBUICAO S/ARREC.FUNDOS INVEST.REGIONAIS', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AOS FUNDOS DE INVESTIMENTOS REGIONAIS. CONTRIBUICAO ORIUNDA DA DEDUCAO DE 1% (UM PORCENTO) DA ARRECADACAO DOS FUNDOS DE INVESTIMENTOS REGIONAIS ( FINAM,FINOR E FUNRES), OBEDECIDA NA APLICACAO A RESPECTIVA ORIGEM GEOGRAFICAREGIONAL. DESTINA-SE AO FUNDO NACIONAL DA CULTURA - FNC, GERIDO PELOMINISTERIO DA CULTURA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.1.06.01', 'CONTRIBUICAO INDUSTRIAL RURAL', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO INDUSTRIAL RURAL. CONTRIBUICAO DE 2,5% (DOIS E MEIO POR CENTO) INCIDENTE SOBRE AFOLHA DE SALARIOS DE CONTRIBUICAO DE PESSOAS NATURAIS E JURIDICAS, IN-CLUSIVE COOPERATIVAS, QUE EXERCAM AS SEGUINTES ATIVIDADES AGRO-INDUS-TRIAIS: INDUSTRIA DE CANA-DE-ACUCAR, DE LATICINIOS, DE BENEFICIAMENTODE CHA E DE MATE, INDUSTRIA DA UVA, DE EXTRACA E BENEFICIAMENTO DE FI-BRAS VEGETAIS E DE DESCAROCAMENTO DE ALGODAO, DE BENEFICIAMENTO DE CA-FE, DE EXTRACAO DE MADEIRA PARA SERRARIA, DE RESINA, LENHA E CARVAOVEGETAL, E MATADOUROS OU ABATEDOUROS DE ANIMAIS DE QUAISQUER ESPECIESE CHARQUEADAS. DO PRODUTO DA ARRECADACAO DESSA RECEITA, 85% (OITENTA ECINCO POR CENTO) SAO DESTINADOS AO INCRA E 15% (QUINZE POR CENTO) AOMINISTERIO DA AGRICULTURA E ABASTECIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.1.06.02', 'ADICIONAL A CONTRIBUICAO PREVIDENCIARIA', 'REGISTRA A VPA PROVENIENTE DO ADICIONAL A CONTRIBUICAO PREVIDENCIARIA. ADICIONAL DE 0,4% ( ZERO VIRGULA QUATRO POR CENTO) SOBREA FOLHA MENSAL TOTAL DE SALARIOS DE CONTRIBUICAO PREVIDENCIARIA DOSEMPREGADOS DAS EMPRESAS EM GERAL. E ARRECADADA PELO INSTITUTO NACIONALDE SEGURIDADE SOCIAL - INSS. DO PRODUTO DA ARRECADACAO, 50% SAO DESTI-NADOS AO INSTITUTO NACIONAL DE COLONIZACAO E REFORMA AGRARIA - INCRA EO RESTANTE AO INSS. DA PARCELA DO INCRA, 15% (QUINZE POR CENTO) SAOREPASSADOS AO MINISTERIO DA AGRICULTURA E ABASTECIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.1.07.00', 'CONTRIBUICOES P/O FUNDO DE SAUDE - PMDF', 'REGISTRA AS VPA DE CONTRIBUICAO PARA O FUNDO DE SAUDE DOS POLICIAIS MILITARES DO DISTRITO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.1.08.00', 'CONTRIBUICOES P/O FUNDO DE SAUDE - BMDF', 'REGISTRA AS VPA DE CONTRIBUICAO PARA O FUNDO DE SAUDE DOS BOMBEIROS MILITARES DO DISTRITO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.1.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.2.01.00', 'CONTRIBUICAO DO SALARIO-EDUCACAO', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO DESTINADA AO SALARIO-EDUCACAO. CONSTITUI-SE NA OBRIGACAO POR PARTE DAS EMPRESAS COMERCIAIS, INDUSTRIAIS E AGRICOLAS DE MANTER O ENSINO PRIMARIO GRATUITODE SEUS EMPREGADOS E O ENSINO DOS FILHOS DESTES, ENTRE OS 7 (SETE) E14 (QUATORZE) AOS, OU A CONCORRER PARA AQUELE FIM MEDIANTE A CONTRIBU-ICAO DO SALARIO-EDUCACAO (LEI NUM. 4.440, DE 27/10/64). CALCULADA SO-BRE O VALOR DA FOLHA DO SALARIO DE CONTRIBUICAO, NO CASO DAS EMPRESASVINCULADAS A PREVIDENCIA SOCIAL URBANA, E SOBRE O VALOR COMERCIAL DOSPRODUTOS AGRICOLAS, NO CASO DAS EMPRESAS VINCULADAS A PREVIDENCIA SOCIAL RURAL. A ARRECADACAO E DESTINADA 2/3 EM FAVOR DA UNIDADE DA FEDE-RACAO ONDE HOUVER SIDO EFETUADA A ARRECADACAO, DESTINANDO-SE OS RECUR-SOS AS RESPECTIVAS SECRETARIAS DE EDUCACAO; 1/3 EM FAVOR DA UNIAO COMORECEITA VINCULADA AO FUNDO NACIONAL DE DESENVOLVIMENTO DA EDUCACAO -FNDE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.2.02.00', 'COTA-PARTE DA CONTRIBUICAO SINDICAL', 'REGISTRA A VPA PROVENIENTE DA COTA-PARTE DA CONTRIBUICAOSINDICAL. CORRESPONDE A 20% DA ARRECADACAO DA CONTRIBUICAO SINDICAL(NO CASO DA CONTRIBUICAO RURAL, O PERCENTUAL E DE 10%). CONSTITUI-SEEM UMA CONTRIBUICAO PARAFISCAL EQUIVALENTE A UM DIA DE REMUNERACAO DETODO O TRABALHADOR DO MERCADO FORMAL DE TRABALHO. INTEGRA O ORCAMENTODA SEGURIDADE SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.2.03.00', 'CONTRIBUICAO PARA O ENSINO AEROVIARIO', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO P/ENSINO AEROVIARIO. CONTRIBUICAO PELOS SERVICOS DE AVIACAO CIVIL, DEVIDA PELAS EMPRE-SAS DE: TRANSPORTE E SERVICOS AEREOS; TELECOMUNICACOES AERONAUTICAS;ATIVIDADES RELACIONADAS A INFRA-ESTRUTURA AEROPORTUARIA; FABRICACAO,REPARO E MANUTENCAO, OU REPRESENTACAO, DE AERONAVES E EQUIPAMENTOS A-ERONAUTICOS. CALCULADA SOBRE O SALARIO DE CONTRIBUICAO DOS EMPREGADOSSUBSTITUI A CONTRIBUICAO DEVIDA AO SENAI, SENAC, SESI E SESC. E VINCU-LADA AO FUNDO AEROVIARIO, PARA APLICACAO NO DESENVOLVIMENTO DO ENSINOPROFISSIONAL AERONAUTICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.2.04.00', 'CONTRIBUICAO PARA DESENV.ENS.PROFIS.MARITIMO', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO PARA CUSTEAR O DESENVOLVIMENTO DO ENSINO DO PROSSIONAL MARITIMO. CONTRIBUICAO PELA PRESTACAO DE SERVICOS DE NAVEGACAO, DEVIDA PELAS EMPRESAS DE NAVEGACAO MARITIMA, FLUVIAL OU LACUSTRE, DE SERVICOS PORTUARIOS, DE DRAGAGEM E DE ADMINISTRACAO E DE EXPLORACAO DE PORTOS. CALCULADA SOBRE O SALARIO DE CONTRIBUICAO DOS EMPREGADOS, SUBSTITUI A CONTRIBUICAO DEVIDA AO SENAI, SENAC, SESI E SESC. E VINCULADA AO FUNDO DE DESENVOLVIMENTO DOENSINO PROFISSIONAL MARITIMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.2.05.00', 'CONTRIBUICAO S/ARREC.FUNDOS INVEST.REGIONAIS', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AOS FUNDOS DE INVESTIMENTOS REGIONAIS. CONTRIBUICAO ORIUNDA DA DEDUCAO DE 1% (UM PORCENTO) DA ARRECADACAO DOS FUNDOS DE INVESTIMENTOS REGIONAIS ( FINAM,FINOR E FUNRES), OBEDECIDA NA APLICACAO A RESPECTIVA ORIGEM GEOGRAFICAREGIONAL. DESTINA-SE AO FUNDO NACIONAL DA CULTURA - FNC, GERIDO PELOMINISTERIO DA CULTURA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.2.06.01', 'CONTRIBUICAO INDUSTRIAL RURAL', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO INDUSTRIAL RURAL. CONTRIBUICAO DE 2,5% (DOIS E MEIO POR CENTO) INCIDENTE SOBRE AFOLHA DE SALARIOS DE CONTRIBUICAO DE PESSOAS NATURAIS E JURIDICAS, IN-CLUSIVE COOPERATIVAS, QUE EXERCAM AS SEGUINTES ATIVIDADES AGRO-INDUS-TRIAIS: INDUSTRIA DE CANA-DE-ACUCAR, DE LATICINIOS, DE BENEFICIAMENTODE CHA E DE MATE, INDUSTRIA DA UVA, DE EXTRACA E BENEFICIAMENTO DE FI-BRAS VEGETAIS E DE DESCAROCAMENTO DE ALGODAO, DE BENEFICIAMENTO DE CA-FE, DE EXTRACAO DE MADEIRA PARA SERRARIA, DE RESINA, LENHA E CARVAOVEGETAL, E MATADOUROS OU ABATEDOUROS DE ANIMAIS DE QUAISQUER ESPECIESE CHARQUEADAS. DO PRODUTO DA ARRECADACAO DESSA RECEITA, 85% (OITENTA ECINCO POR CENTO) SAO DESTINADOS AO INCRA E 15% (QUINZE POR CENTO) AOMINISTERIO DA AGRICULTURA E ABASTECIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.2.06.02', 'ADICIONAL A CONTRIBUICAO PREVIDENCIARIA', 'REGISTRA A VPA PROVENIENTE DO ADICIONAL A CONTRIBUICAO PREVIDENCIARIA. ADICIONAL DE 0,4% ( ZERO VIRGULA QUATRO POR CENTO) SOBREA FOLHA MENSAL TOTAL DE SALARIOS DE CONTRIBUICAO PREVIDENCIARIA DOSEMPREGADOS DAS EMPRESAS EM GERAL. E ARRECADADA PELO INSTITUTO NACIONALDE SEGURIDADE SOCIAL - INSS. DO PRODUTO DA ARRECADACAO, 50% SAO DESTI-NADOS AO INSTITUTO NACIONAL DE COLONIZACAO E REFORMA AGRARIA - INCRA EO RESTANTE AO INSS. DA PARCELA DO INCRA, 15% (QUINZE POR CENTO) SAOREPASSADOS AO MINISTERIO DA AGRICULTURA E ABASTECIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.2.07.00', 'CONTRIBUICOES P/O FUNDO DE SAUDE - PMDF', 'REGISTRA AS VPA DE CONTRIBUICAO PARA O FUNDO DE SAUDE DOS POLICIAIS MILITARES DO DISTRITO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.2.08.00', 'CONTRIBUICOES P/O FUNDO DE SAUDE - BMDF', 'REGISTRA AS VPA DE CONTRIBUICAO PARA O FUNDO DE SAUDE DOS BOMBEIROS MILITARES DO DISTRITO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.2.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.4.01.00', 'CONTRIBUICAO DO SALARIO-EDUCACAO', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO DESTINADA AO SALARIO-EDUCACAO. CONSTITUI-SE NA OBRIGACAO POR PARTE DAS EMPRESAS COMERCIAIS, INDUSTRIAIS E AGRICOLAS DE MANTER O ENSINO PRIMARIO GRATUITODE SEUS EMPREGADOS E O ENSINO DOS FILHOS DESTES, ENTRE OS 7 (SETE) E14 (QUATORZE) AOS, OU A CONCORRER PARA AQUELE FIM MEDIANTE A CONTRIBU-ICAO DO SALARIO-EDUCACAO (LEI NUM. 4.440, DE 27/10/64). CALCULADA SO-BRE O VALOR DA FOLHA DO SALARIO DE CONTRIBUICAO, NO CASO DAS EMPRESASVINCULADAS A PREVIDENCIA SOCIAL URBANA, E SOBRE O VALOR COMERCIAL DOSPRODUTOS AGRICOLAS, NO CASO DAS EMPRESAS VINCULADAS A PREVIDENCIA SOCIAL RURAL. A ARRECADACAO E DESTINADA 2/3 EM FAVOR DA UNIDADE DA FEDE-RACAO ONDE HOUVER SIDO EFETUADA A ARRECADACAO, DESTINANDO-SE OS RECUR-SOS AS RESPECTIVAS SECRETARIAS DE EDUCACAO; 1/3 EM FAVOR DA UNIAO COMORECEITA VINCULADA AO FUNDO NACIONAL DE DESENVOLVIMENTO DA EDUCACAO -FNDE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.4.02.00', 'COTA-PARTE DA CONTRIBUICAO SINDICAL', 'REGISTRA A VPA PROVENIENTE DA COTA-PARTE DA CONTRIBUICAOSINDICAL. CORRESPONDE A 20% DA ARRECADACAO DA CONTRIBUICAO SINDICAL(NO CASO DA CONTRIBUICAO RURAL, O PERCENTUAL E DE 10%). CONSTITUI-SEEM UMA CONTRIBUICAO PARAFISCAL EQUIVALENTE A UM DIA DE REMUNERACAO DETODO O TRABALHADOR DO MERCADO FORMAL DE TRABALHO. INTEGRA O ORCAMENTODA SEGURIDADE SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.4.03.00', 'CONTRIBUICAO PARA O ENSINO AEROVIARIO', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO P/ENSINO AEROVIARIO. CONTRIBUICAO PELOS SERVICOS DE AVIACAO CIVIL, DEVIDA PELAS EMPRE-SAS DE: TRANSPORTE E SERVICOS AEREOS; TELECOMUNICACOES AERONAUTICAS;ATIVIDADES RELACIONADAS A INFRA-ESTRUTURA AEROPORTUARIA; FABRICACAO,REPARO E MANUTENCAO, OU REPRESENTACAO, DE AERONAVES E EQUIPAMENTOS A-ERONAUTICOS. CALCULADA SOBRE O SALARIO DE CONTRIBUICAO DOS EMPREGADOSSUBSTITUI A CONTRIBUICAO DEVIDA AO SENAI, SENAC, SESI E SESC. E VINCU-LADA AO FUNDO AEROVIARIO, PARA APLICACAO NO DESENVOLVIMENTO DO ENSINOPROFISSIONAL AERONAUTICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.4.04.00', 'CONTRIBUICAO PARA DESENV.ENS.PROFIS.MARITIMO', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO PARA CUSTEAR O DESENVOLVIMENTO DO ENSINO DO PROSSIONAL MARITIMO. CONTRIBUICAO PELA PRESTACAO DE SERVICOS DE NAVEGACAO, DEVIDA PELAS EMPRESAS DE NAVEGACAO MARITIMA, FLUVIAL OU LACUSTRE, DE SERVICOS PORTUARIOS, DE DRAGAGEM E DE ADMINISTRACAO E DE EXPLORACAO DE PORTOS. CALCULADA SOBRE O SALARIO DE CONTRIBUICAO DOS EMPREGADOS, SUBSTITUI A CONTRIBUICAO DEVIDA AO SENAI, SENAC, SESI E SESC. E VINCULADA AO FUNDO DE DESENVOLVIMENTO DOENSINO PROFISSIONAL MARITIMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.4.05.00', 'CONTRIBUICAO S/ARREC.FUNDOS INVEST.REGIONAIS', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AOS FUNDOS DE INVESTIMENTOS REGIONAIS. CONTRIBUICAO ORIUNDA DA DEDUCAO DE 1% (UM PORCENTO) DA ARRECADACAO DOS FUNDOS DE INVESTIMENTOS REGIONAIS ( FINAM,FINOR E FUNRES), OBEDECIDA NA APLICACAO A RESPECTIVA ORIGEM GEOGRAFICAREGIONAL. DESTINA-SE AO FUNDO NACIONAL DA CULTURA - FNC, GERIDO PELOMINISTERIO DA CULTURA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.4.06.01', 'CONTRIBUICAO INDUSTRIAL RURAL', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO INDUSTRIAL RURAL. CONTRIBUICAO DE 2,5% (DOIS E MEIO POR CENTO) INCIDENTE SOBRE AFOLHA DE SALARIOS DE CONTRIBUICAO DE PESSOAS NATURAIS E JURIDICAS, IN-CLUSIVE COOPERATIVAS, QUE EXERCAM AS SEGUINTES ATIVIDADES AGRO-INDUS-TRIAIS: INDUSTRIA DE CANA-DE-ACUCAR, DE LATICINIOS, DE BENEFICIAMENTODE CHA E DE MATE, INDUSTRIA DA UVA, DE EXTRACA E BENEFICIAMENTO DE FI-BRAS VEGETAIS E DE DESCAROCAMENTO DE ALGODAO, DE BENEFICIAMENTO DE CA-FE, DE EXTRACAO DE MADEIRA PARA SERRARIA, DE RESINA, LENHA E CARVAOVEGETAL, E MATADOUROS OU ABATEDOUROS DE ANIMAIS DE QUAISQUER ESPECIESE CHARQUEADAS. DO PRODUTO DA ARRECADACAO DESSA RECEITA, 85% (OITENTA ECINCO POR CENTO) SAO DESTINADOS AO INCRA E 15% (QUINZE POR CENTO) AOMINISTERIO DA AGRICULTURA E ABASTECIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.4.06.02', 'ADICIONAL A CONTRIBUICAO PREVIDENCIARIA', 'REGISTRA A VPA PROVENIENTE DO ADICIONAL A CONTRIBUICAO PREVIDENCIARIA. ADICIONAL DE 0,4% ( ZERO VIRGULA QUATRO POR CENTO) SOBREA FOLHA MENSAL TOTAL DE SALARIOS DE CONTRIBUICAO PREVIDENCIARIA DOSEMPREGADOS DAS EMPRESAS EM GERAL. E ARRECADADA PELO INSTITUTO NACIONALDE SEGURIDADE SOCIAL - INSS. DO PRODUTO DA ARRECADACAO, 50% SAO DESTI-NADOS AO INSTITUTO NACIONAL DE COLONIZACAO E REFORMA AGRARIA - INCRA EO RESTANTE AO INSS. DA PARCELA DO INCRA, 15% (QUINZE POR CENTO) SAOREPASSADOS AO MINISTERIO DA AGRICULTURA E ABASTECIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.4.07.00', 'CONTRIBUICOES P/O FUNDO DE SAUDE - PMDF', 'REGISTRA AS VPA DE CONTRIBUICAO PARA O FUNDO DE SAUDE DOS POLICIAIS MILITARES DO DISTRITO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.4.08.00', 'CONTRIBUICOES P/O FUNDO DE SAUDE - BMDF', 'REGISTRA AS VPA DE CONTRIBUICAO PARA O FUNDO DE SAUDE DOS BOMBEIROS MILITARES DO DISTRITO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.4.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.5.01.00', 'CONTRIBUICAO DO SALARIO-EDUCACAO', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO DESTINADA AO SALARIO-EDUCACAO. CONSTITUI-SE NA OBRIGACAO POR PARTE DAS EMPRESAS COMERCIAIS, INDUSTRIAIS E AGRICOLAS DE MANTER O ENSINO PRIMARIO GRATUITODE SEUS EMPREGADOS E O ENSINO DOS FILHOS DESTES, ENTRE OS 7 (SETE) E14 (QUATORZE) AOS, OU A CONCORRER PARA AQUELE FIM MEDIANTE A CONTRIBU-ICAO DO SALARIO-EDUCACAO (LEI NUM. 4.440, DE 27/10/64). CALCULADA SO-BRE O VALOR DA FOLHA DO SALARIO DE CONTRIBUICAO, NO CASO DAS EMPRESASVINCULADAS A PREVIDENCIA SOCIAL URBANA, E SOBRE O VALOR COMERCIAL DOSPRODUTOS AGRICOLAS, NO CASO DAS EMPRESAS VINCULADAS A PREVIDENCIA SOCIAL RURAL. A ARRECADACAO E DESTINADA 2/3 EM FAVOR DA UNIDADE DA FEDE-RACAO ONDE HOUVER SIDO EFETUADA A ARRECADACAO, DESTINANDO-SE OS RECUR-SOS AS RESPECTIVAS SECRETARIAS DE EDUCACAO; 1/3 EM FAVOR DA UNIAO COMORECEITA VINCULADA AO FUNDO NACIONAL DE DESENVOLVIMENTO DA EDUCACAO -FNDE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.5.02.00', 'COTA-PARTE DA CONTRIBUICAO SINDICAL', 'REGISTRA A VPA PROVENIENTE DA COTA-PARTE DA CONTRIBUICAOSINDICAL. CORRESPONDE A 20% DA ARRECADACAO DA CONTRIBUICAO SINDICAL(NO CASO DA CONTRIBUICAO RURAL, O PERCENTUAL E DE 10%). CONSTITUI-SEEM UMA CONTRIBUICAO PARAFISCAL EQUIVALENTE A UM DIA DE REMUNERACAO DETODO O TRABALHADOR DO MERCADO FORMAL DE TRABALHO. INTEGRA O ORCAMENTODA SEGURIDADE SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.5.03.00', 'CONTRIBUICAO PARA O ENSINO AEROVIARIO', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO P/ENSINO AEROVIARIO. CONTRIBUICAO PELOS SERVICOS DE AVIACAO CIVIL, DEVIDA PELAS EMPRE-SAS DE: TRANSPORTE E SERVICOS AEREOS; TELECOMUNICACOES AERONAUTICAS;ATIVIDADES RELACIONADAS A INFRA-ESTRUTURA AEROPORTUARIA; FABRICACAO,REPARO E MANUTENCAO, OU REPRESENTACAO, DE AERONAVES E EQUIPAMENTOS A-ERONAUTICOS. CALCULADA SOBRE O SALARIO DE CONTRIBUICAO DOS EMPREGADOSSUBSTITUI A CONTRIBUICAO DEVIDA AO SENAI, SENAC, SESI E SESC. E VINCU-LADA AO FUNDO AEROVIARIO, PARA APLICACAO NO DESENVOLVIMENTO DO ENSINOPROFISSIONAL AERONAUTICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.5.04.00', 'CONTRIBUICAO PARA DESENV.ENS.PROFIS.MARITIMO', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO PARA CUSTEAR O DESENVOLVIMENTO DO ENSINO DO PROSSIONAL MARITIMO. CONTRIBUICAO PELA PRESTACAO DE SERVICOS DE NAVEGACAO, DEVIDA PELAS EMPRESAS DE NAVEGACAO MARITIMA, FLUVIAL OU LACUSTRE, DE SERVICOS PORTUARIOS, DE DRAGAGEM E DE ADMINISTRACAO E DE EXPLORACAO DE PORTOS. CALCULADA SOBRE O SALARIO DE CONTRIBUICAO DOS EMPREGADOS, SUBSTITUI A CONTRIBUICAO DEVIDA AO SENAI, SENAC, SESI E SESC. E VINCULADA AO FUNDO DE DESENVOLVIMENTO DOENSINO PROFISSIONAL MARITIMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.5.05.00', 'CONTRIBUICAO S/ARREC.FUNDOS INVEST.REGIONAIS', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AOS FUNDOS DE INVESTIMENTOS REGIONAIS. CONTRIBUICAO ORIUNDA DA DEDUCAO DE 1% (UM PORCENTO) DA ARRECADACAO DOS FUNDOS DE INVESTIMENTOS REGIONAIS ( FINAM,FINOR E FUNRES), OBEDECIDA NA APLICACAO A RESPECTIVA ORIGEM GEOGRAFICAREGIONAL. DESTINA-SE AO FUNDO NACIONAL DA CULTURA - FNC, GERIDO PELOMINISTERIO DA CULTURA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.5.06.01', 'CONTRIBUICAO INDUSTRIAL RURAL', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO INDUSTRIAL RURAL. CONTRIBUICAO DE 2,5% (DOIS E MEIO POR CENTO) INCIDENTE SOBRE AFOLHA DE SALARIOS DE CONTRIBUICAO DE PESSOAS NATURAIS E JURIDICAS, IN-CLUSIVE COOPERATIVAS, QUE EXERCAM AS SEGUINTES ATIVIDADES AGRO-INDUS-TRIAIS: INDUSTRIA DE CANA-DE-ACUCAR, DE LATICINIOS, DE BENEFICIAMENTODE CHA E DE MATE, INDUSTRIA DA UVA, DE EXTRACA E BENEFICIAMENTO DE FI-BRAS VEGETAIS E DE DESCAROCAMENTO DE ALGODAO, DE BENEFICIAMENTO DE CA-FE, DE EXTRACAO DE MADEIRA PARA SERRARIA, DE RESINA, LENHA E CARVAOVEGETAL, E MATADOUROS OU ABATEDOUROS DE ANIMAIS DE QUAISQUER ESPECIESE CHARQUEADAS. DO PRODUTO DA ARRECADACAO DESSA RECEITA, 85% (OITENTA ECINCO POR CENTO) SAO DESTINADOS AO INCRA E 15% (QUINZE POR CENTO) AOMINISTERIO DA AGRICULTURA E ABASTECIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.5.06.02', 'ADICIONAL A CONTRIBUICAO PREVIDENCIARIA', 'REGISTRA A VPA PROVENIENTE DO ADICIONAL A CONTRIBUICAO PREVIDENCIARIA. ADICIONAL DE 0,4% ( ZERO VIRGULA QUATRO POR CENTO) SOBREA FOLHA MENSAL TOTAL DE SALARIOS DE CONTRIBUICAO PREVIDENCIARIA DOSEMPREGADOS DAS EMPRESAS EM GERAL. E ARRECADADA PELO INSTITUTO NACIONALDE SEGURIDADE SOCIAL - INSS. DO PRODUTO DA ARRECADACAO, 50% SAO DESTI-NADOS AO INSTITUTO NACIONAL DE COLONIZACAO E REFORMA AGRARIA - INCRA EO RESTANTE AO INSS. DA PARCELA DO INCRA, 15% (QUINZE POR CENTO) SAOREPASSADOS AO MINISTERIO DA AGRICULTURA E ABASTECIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.5.07.00', 'CONTRIBUICOES P/O FUNDO DE SAUDE - PMDF', 'REGISTRA AS VPA DE CONTRIBUICAO PARA O FUNDO DE SAUDE DOS POLICIAIS MILITARES DO DISTRITO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.5.08.00', 'CONTRIBUICOES P/O FUNDO DE SAUDE - BMDF', 'REGISTRA AS VPA DE CONTRIBUICAO PARA O FUNDO DE SAUDE DOS BOMBEIROS MILITARES DO DISTRITO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.5.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.01.00', 'CONTRIBUICAO PARA O PIN', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES ECONOMICAS DES-TINADAS AO PROGRAMA DE INTEGRACAO NACIONAL. DA PARCELA DO IMPOSTO DERENDA - PESSOAS JURIDICAS, QUE SERVIR DE BASE DE CALCULO PARA A APLI-CACAO EM INCENTIVOS FISCAIS, PERCENTUAL DE ATE 40% (QUARENTA POR CEN-TO) PODERA SER DEDUZIDO PARA APLICACAO NO GRUPO FINOR/FINAM/PIN/PROTERRA. DA PARCELA DEDUZIDA, 60% (SESSENTA POR CENTO) CORRESPONDERAO A APLICACAO NOS FUNDOS DE INVESTIMENTO DA AMAZONIA (FINAM) E DO NOR-DESTE (FINOR); 24% (VINTE E QUATRO POR CENTO) SERAO DESTINADOS AO PINE 16% (DEZESSEIS POR CENTO) AO PROTERRA. O PIN TEM COMO OBJETIVO PRO-MOVER A MAIOR INTEGRACAO A ECONOMIA NACIONAL DAS REGIOES COMPREENDIDASNAS AREAS DE ATUACAO DA SUDAM E DA SUDENE. OS RECURSOS SERAO APLICADOSEM PROGRAMAS E PROJETOS CONSIDERADOS PRIORITARIOS PELA SUDAM E SUDENE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.02.00', 'CONTRIBUICAO PARA O PROTERRA', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES ECONOMICAS DES-TINADAS AO PROGRAMA DE REDISTRIBUICAO DE TERRAS E DE ESTIMULO A AGRO-INDUSTRIA DO NORTE E DO NORDESTE. DA PARCELA DO IMPOSTO DE RENDA- PES-SOAS JURIDICAS QUE SERVIR DE BASE DE CALCULO PARA APLICACAO EM INCEN-TIVOS FISCAIS, PERCENTUAL DE ATE 40% (QUARENTA POR CENTO) PODERA SERDEDUZIDO PARA APLICACAO NO GRUPO FINOR/FINAM/PIN/PROTERRA. DA PARCELADEDUZIDA, 60% (SESSENTA POR CENTO) CORRESPONDERAO A APLICACAO NOS FUN-DOS DE INVESTIMENTO DA AMAZONIA (FINAM) E DO NORDESTE (FINOR); 24(VIN-TE E QUATRO POR CENTO) SERAO DESTINADOS AO PIN E 16% AO PROTERRA. OPROTERRA TEM COMO OBJETIVO PROMOVER O MAIS FACIL ACESSO DO HOMEM ATERRA, CRIAR MELHORES CONDICOES DE EMPREGO DE MAO-DE-OBRA E FOMENTAR AAGRO-INDUSTRIA NAS REGIOES COMPREENDIDAS NAS AREAS DE ATUACAO DA SUDAME DA SUDENE. OS RECURSOS SAO APLICADOS EM PROGRAMAS E PROJETOS CONSI-DERADOS PRIORITARIOS PELA SUDAM E SUDENE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.03.01', 'SELO ESPECIAL DE CONTROLE', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES FIS-CAIS PELO SELO DE CONTROLE. CONTRIBUICAO DEVIDA PELO RESSARCIMENTO DESELOS DE CONTROLE DESTINADOS A CIGARROS, CHAMPANHE DE PROCEDENCIA ES-TRANGEIRA, RUM, VODCA, UISQUE, LICORES, AGUARDENTES, BATIDAS, GIM, RE-LOGIOS DE BOLSO E DE PULSO, ETC. VINCULADO AO FUNDO DE DESENVOLVIMENTOE APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.03.02', 'LOJAS FRANCAS ENTREP.ADUAN. DEP.ALFANDEGADOS', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES FISCAIS ARRECADADAS PELAS LOJAS FRANCAS, PELOS ENTREPOSTOS ADUANEIROS E DEPOSITOS ALFANDEGADOS. CONTRIBUICAO DEVIDA PELO RESSARCIMENTO DAS DESPESAS ADMINISTRATI-VAS DECORRENTES DAS ATIVIDADES EXTRAORDINARIAS DE FISCALIZACAO, DEVIDAPOR: - PERMISSIONARIOS DE REGIME DE ENTREPOSTO ADUANEIRO NA IMPORTACAO DEUSO PUBLICO; - CONCESSIONARIO DE LOJAS FRANCA; - BENEFICIARIOS DE DEPOSITO ESPECIAL ALFANDEGADO; - PERMISSIONARIOS DE LOCAL ALFANDEGADO DE USO PUBLICO; - ANALISE E LAUDOS LABORATORIAIS REALIZADOS NA IMPORTACAO DE PRODUTOSDAS INDUSTRIAS QUIMICAS E PARAQUIMICAS E ALIMENTICIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.04.00', 'CONTRIBUICAO S/ APOSTAS EM COMPET. HIPICAS', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE APOSTAS EM COMPETICOES HIPICAS. INCIDE SOBRE O VALOR TOTAL DO MOVIMENTO GERAL DEAPOSTAS DE CADA ENTIDADE TURFISTICA, A CADA MES. DESTINA-SE A SECRETA-RIA DE DESENVOLVIMENTO RURAL. A APLICACAO DESSES RECURSOS SERA FEITAMEDIANTE PLANO ANUAL, APROVADO PELO MINISTERIO DA AGRICULTURA E DO ABASTECIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.05.01', 'CONTR.P/O DESENV. IND. CINEMAT.NAC. -REMESSAS', 'REGISTRA O VALOR DA CONTRIBUICAO INCIDENTE SOBRE O PAGAMENTO, O CREDI-TO, O EMPREGO, A REMESSA OU A ENTREGA, AOS PRODUTORES, DISTRIBUIDORES OU INTERMEDIARIOS NO EXTERIOR, DE IMPORTANCIAS RELATIVAS A RENDIMENTO DECORRENTE DA EXPLORACAO DE OBRAS CINEMATOGRAFICAS E VIDEOFONOGRAFICASOU POR SUA AQUISICAO OU IMPORTACAO, A PRECO FIXO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.05.02', 'CONTR.P/O DESENV. IND. CINEMAT.NAC. - TITULOS', 'REGISTRA O VALOR DA CONTRIBUICAO DEVIDA UMA UNICA VEZ A CADA CINCO ANOS, PARA CADA SEGMENTO DE MERCADO POR: - TITULO OU CAPITULO DE OBRA CINEMATOGRAFICA OU VIDEOFONOGRAFICA DES- TINADA AOS SEGUINTES SEGMENTOS DE MERCADO: SALA DE EXIBICAO; VIDEO DOMESTICO, EM QUALQUER SUPORTE; SERVICO DE RADIODIFUSAO DE SONS E IMAGENS; SERVICO DE COMUNICACAO ELETRONICA DE MASSA POR ASSINATURA; OUTROS SERVICOS. - TITULO DE OBRA PUBLICITARIA CINEMATOGRAFICA OU VIDEOFONOGRAFICA, PA-RA CADA SEGMENTO DE MERCADO A QUE SE DESTINAR. A CONTRIBUICAO REFERENTE AAS OBRAS CINEMATOGRAFICAS OU VIDEOFO- NOGRAFICAS PUBLICITARIAS SERA DEVIDA UMA UNICA VEZ A CADA DOZE MESES PARA CADA UM DOS SEGMENTOS DE MERCADO EM QUE A OBRA SEJA EFETIVAMENTE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.06.00', 'ADICIONAL S/TARIFAS DE PASS.AEREAS DOMESTICAS', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES COM O ADICIONALSOBRE TARIFAS DE PASSAGENS AEREAS DE VOO DOMESTICO. CONSTITUI-SE EM UMA DICIONAL DE ATE 3% (TRES POR CENTO) A INCIDIR SOBRE AS TARIFAS DEPASSAGENS AEREAS DAS LINHAS DOMESTICAS, OPERADAS PELAS EMPRESAS DETRANSPORTE AEREO REGULAR, INCLUSIVE AS DE TRANSPORTE AEREO REGIONAL EOS TRECHOS DE CABOTAGEM. O PRODUTO DA ARRECADACAO E VINCULADA AO FUNDOAERONAUTICO PARA APLICACAO EM SISTEMAS INTEGRADOS DE TRANSPORTE AEREOREGIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.07.00', 'COTA-PARTE ADIC.FRETE P/ RENOV.MARIN.MERCANTE', 'REGISTRA A VPA PROVENIENTE DAS COTA-PARTE DO ADICIONAL DE FRETE PARA RENOVACAO DA MARINHA MERCANTE. CONTRIBUICAO INCIDENTE SOBREO VALOR DO FRETE NO TRANSPORTE DE QUALQUER CARGA, POR VIA MARITIMA FLUVIAL OU LACUSTRE. OS RECURSOS SE DESTINAM AO FUNDO DE MARINHA MERCANTE - FMM; A EMPRESA BRASILEIRA DE NAVEGACAO, OPERANDO EMBARCACAOPROPRIA OU AFRETADA DE REGISTRO BRASILEIRO; E, A UMA CONTA ESPECIAL,36% (TRINTA E SEIS POR CENTO) DO AFMM GERADO NA NAVEGACAO DE LONGOCURSO, POR EMPRESA BRASILEIRA OPERANDO EMBARCACAO DE REGISTRO BRASI-LEIRO. ESSA CONTRIBUICAO E APLICADA PRIORITARIAMENTE NA AQUISICAO DEEMBARCACOES NOVAS, PARA USO PROPRIO DAS EMPRESS DE NAVEGACAO, CONSTRUIDAS EM ESTALEIROS BRASILEIROS; NO REPARO, MANUTENCAO E MODERNIZACAODE EMBARCACOES, REALIZADAS POR EMPRESAS NACIONAIS; E EM PAGAMENTOS DEAMORTIZACOES E ENCARGOS CONCEDIDOS COM RECURSOS DO FUNDO DA MARINHAMERCANTE. PODE TAMBEM SER APLICADA A FUNDO PERDIDO, NOS CASOS PREVISTOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.08.00', 'CONTRIBUICAO S/REC.CONCESS.PERMISS.ENERG.ELET', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE A RECEITA DAS CONCESSIONARIAS DE ENERGIA ELETRICA, ONDE: 50% DOS RECURSOS RESULTANTES DE APLICACAO ANUAL DO MONTANTE DE NO MINIMO 1% DE SUA RECEITA OPERACIONAL LIQUIDA DAS CONCESSIONARIAS E PERMISSIONARIAS DE ENERGIA ELETRICA EM P & D DO SETOR ELETRICO. PARA ESSES RECURSOS SERA CRIADA UMA CATEGORIA DE PROGRAMACAO ESPECIFICA NO AMBITO DO FUNDO NACIONAL DE DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO FNDCT, PARA APLICACAO NO FINANCIAMENTO DE PROGRAMAS E PROJETOS DE PESQUISA CIENTIFICA E DESENVOLVIMENTO TECNOLOGICO DO SETOR ELETRICO, BEM COMO NA EFICIENCIA ENERGETICA NO USO FINAL. LEI 9991 DE 24/07/2000', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.09.00', 'CONTRIBUICAO P/ LIC.USO,AQUIS.OU TRANSF.TECN.', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICAO PELA LICENCA DE USO, AQUISICAO OU TRANSFERENCIA DE TECNOLOGIA, REFERENTE A INTERVENCAO NO DOMINIO ECONOMICO DE EMPRESA DETENTORA DE LICENCA DE USO OU ADQUIRENTE DE CONHECIMENTOS TECNOLOGICOS, BEM COMO AQUELA SIGNATARIA DE CONTRATOS QUE IMPLIQUEM TRANSFERENCIA DE TECNOLOGIA, FIRMADOSCOM RESIDENTES OU DOMICILIADOS NO EXTERIOR (ALIQUOTA DE 10 POR CENTO SOBRE OS VALORES PAGOS, CREDITADOS, ENTREGUES, EMPREGADOS OU REMETIDOS, A CADA MES, A RESIDENTES OU DOMICILIADOS NO EXTERIOR). A CONTRIBUICAO SERA RECOLHIDA AO TESOURO NACIONAL E DESTINADA AO FUNDO NACIONALDE DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO - FNDCT. OS RECURSOS SERAO ALOCADOS EM CATEGORIA DE PROGRAMACAO ESPECIFICA E ADMINISTRADOS CON-FORME O DISPOSTO NO REGULAMENTO. (PL NUM. 2978/2000).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.10.01', 'CON. S/REC.OPER.BRUTA DECOR.PRES.SERV.TELECOM', 'REGISTRA A CONTRIBUICAO DEVIDA PELAS EMPRESAS QUE PRESTAM SERVICOS DE TELECOMUNICACOES, A ALIQUOTA DE UM POR CENTO SOBRE O VALOR DA RECEITA OPERACIONAL BRUTA EXCLUINDO-SE PARA DETERMINACAO DA BASE DE CALCULO AS VENDAS CANCELADAS, OS DESCONTOS CONCEDIDOS, O IMPOSTO SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTACOES DE SERVICOS DE TRANSPORTES INTERESTADUAIS, INTERMUNIPAIS E DE COMUNICACOES -ICMS, A CONTRIBUICAO AO PROGRAMA DE INTEGRACAO SOCIAL - PIS E A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL COFINS. OS RECURSOS DESTINADOS AO FUST QUANDO TENHAM A FINALIDADE DE COBRIR APARCELA DE CUSTO, EXCLUSIVOS DAS OBRIGACOES DE UNIVERSALIZACAO DE SERVICOS DE TELECOMUNICACOES QUE NAO POSSA SER RECUPERADA COM A EXPLORARACAO EFICIENTE DO SERVICO NOS TERMOS DO DISPOSTO NA LEI 9472 DEDE 16JUL1997 AMPARO LEGAL LEI 9989 DE 17AGO2000 E DECRETO 3624 DE 05OUT200', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.10.02', 'CON. S/REC.OPER.BRUTA EMPR.PREST.SERV.TELECOM', 'REGISTRA A CONTRIBUICAO DEVIDA PELAS EMPRESAS QUE PRESTAM SERVICOSDE TELECOMUNICACOES NO REGIME PUBLICO E PRIVADO, AA ALIQUOTA DE MEIOPOR CENTO SOBRE A RECEITA BRUTA, EXCLUINDO-SE PARA DETERMINACAO DA BA-SE DE CALCULO: AS VENDAS CANCELADAS, OS DESCONTOS CONCEDIDOS, OIMPOSTO SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE A PRESTACOES DE SERVICOS DE TRANSPORTES INTERESTADUAIS, INTERMUNICI- PAL E DE COMUNICACOES - ICMS, A CONTRIBUICAO AO PROGRAMA DE INTEGRACAOSOCIAL - PIS E A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADESOCIAL - COFINS OS RECURSOS DESTINADOS A FUNTTEL, PARA APLICACAO NO SETOR DE TELECOMU-NICACOES AMPARO LEGAL: LEI 10 052 DE 28NOV2000 E DECRETO 3 737 DE 30JAN2001', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.11.01', 'CONTR. DAS EMPRESAS INSTALADAS NA AMAZONIA', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.11.02', 'CONTR. EMPRESAS INSTALADAS NAS DEMAIS REGIOES', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.12.01', 'CONTR.REL.ATIV.IMP.PETR.DER. GAS NAT.ALC.CARB', 'REGISTRA O VALOR DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.12.02', 'CONTR.REL.ATIV.COM.PETR.DER. GAS NAT.ALC.CARB', 'REGISTRA O VALOR DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.13.00', 'CONTRIBUICAO PARA FOMENTO DA RADIODIFUSAO PUB', 'REGISTRA A VPA DECORRENTE DA PRESTACAO DE SERVICOS DA RADIODIFUSAO PUBLICA, EXPLORADOS DIRETAMENTE PELO PODER EXECUTIVO OU OU-TORGADOS POR ESTE A ENTIDADES DE SUA ADMINISTRACAO INDIRETA. DESTINACAO LEGAL: OS RECURSOS SAO DESTINADOS AA EMPRESA BRASIL DE COMUNICACAO S/A - EBC,VINCULADA AA SECRETARIA DE COMUNICACAO SOCIAL DA PRESIDENCIA DA REPU-BLICA, COM O OBJETIVO DE PROPICIAR MEIOS PARA A MELHORIA DOS SERVICOSDE RADIODIFUSAO PUBLICA E PARA A AMPLIACAO DE SUA PENETRACAO MEDIANTEA UTILIZACAO DE SERVICOS DE TELECOMUNICACOES. AMPARO LEGAL: LEI Nº 11.652, DE 07 DE ABRIL DE 2008.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.14.01', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PRINCIPAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PRINCIPAL. ESTA PARCELA DEVE SER APLICADA EM DIVERSAS AREAS ( COMO INSTITUTOS E CENTROS DE PESQUISA, UNIVERSIDADES, FACULDADES, FNDCT, DENTRE OUTROS). AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. INCISO III, § 1º, DO ART. 8º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.14.02', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - EXCEDENTE', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - EXCEDENTE. O RESTANTE DA CONTRIBUICAO PODERA SER APLICADO AO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIAS DA INFORMACAO -PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. § 3º, DO ART.10º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.14.03', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - RESIDUAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - RESIDUAL. ESTA PARCELA RESIDUAL OCORRE NA EVENTUALIDADE DE OS INVESTIMENTOS EM ATIVIDADES DE PESQUISA E DESENVOLVIMENTO NAO ATINGIREM AQUELE MINIMO FIXADO ( 5% DO FATURAMENTO BRUTO, DESCONTADO TRIBUTOS), OS RECURSOS FINANCEIROS RESIDUAIS, ATUALIZADOS E ACRESCIDOS DE DOZE POR CENTO, DEVERAO SER APLICADOS NO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIA DA INFORMACAO - PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991 ART. 35º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.14.04', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PARCELAMENTO', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PARCELAMENTO DE DEBITO. ESTA PARCELA REFERE-SE AOS DEBITOS DECORRENTES DA NAO REALIZACAO, TOTAL OU PARCIAL, A QUALQUER TITULO, ATE O PERIODO ENCERRADO EM 31 DE DEZEMBRO DE 2003, DE APLICACOES RELATIVAS AO INVESTIMENTO COMPULSORIO ANUAL EM PESQUISA E DESENVOLVIMENTO TECNOLOGICO, PODERAO SER OBJETO DE PARCELAMENTO (DEBITOS DE INVESTIMENTO) E SERAO DESTINADAS AO FNDCT. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. ART. 37º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.15.01', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PRINCIPAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PRINCIPAL. ESTA PARCELA DEVE SER APLICADA EM DIVERSAS AREAS ( COMO INSTITUTOS E CENTROS DE PESQUISA, UNIVERSIDADES, FACULDADES, FNDCT, DENTRE OUTROS). AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. INCISO III, § 1º, DO ART. 8º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.15.02', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - EXCEDENTE', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - EXCEDENTE. O RESTANTE DA CONTRIBUICAO PODERA SER APLICADO AO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIAS DA INFORMACAO -PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. § 3º, DO ART.10º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.15.03', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - RESIDUAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - RESIDUAL. ESTA PARCELA RESIDUAL OCORRE NA EVENTUALIDADE DE OS INVESTIMENTOS EM ATIVIDADES DE PESQUISA E DESENVOLVIMENTO NAO ATINGIREM AQUELE MINIMO FIXADO ( 5% DO FATURAMENTO BRUTO, DESCONTADO TRIBUTOS), OS RECURSOS FINANCEIROS RESIDUAIS, ATUALIZADOS E ACRESCIDOS DE DOZE POR CENTO, DEVERAO SER APLICADOS NO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIA DA INFORMACAO - PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991 ART. 35º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.15.04', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PARCELAMENTO', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PARCELAMENTO DE DEBITO. ESTA PARCELA REFERE-SE AOS DEBITOS DECORRENTES DA NAO REALIZACAO, TOTAL OU PARCIAL, A QUALQUER TITULO, ATE O PERIODO ENCERRADO EM 31 DE DEZEMBRO DE 2003, DE APLICACOES RELATIVAS AO INVESTIMENTO COMPULSORIO ANUAL EM PESQUISA E DESENVOLVIMENTO TECNOLOGICO, PODERAO SER OBJETO DE PARCELAMENTO (DEBITOS DE INVESTIMENTO) E SERAO DESTINADAS AO FNDCT. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. ART. 37º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.99.00', 'OUTRAS CONTRIBUICOES ECONOMICAS', 'COMPREENDE A VPA PROVENIENTE DAS OUTRAS CONTRIBUICOES ECONOMICAS DE NATUREZA EVENTUAL, PARA AS QUAIS NAO HA CONTA ESPECIFICA,INCLUSIVE RECURSOS ORIUNDOS DO PROGRAMA DE RECUPERACAO FISCAL E DO PARCELAMENTO ESPECIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.01.00', 'CONTRIBUICAO PARA O PIN', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES ECONOMICAS DES-TINADAS AO PROGRAMA DE INTEGRACAO NACIONAL. DA PARCELA DO IMPOSTO DERENDA - PESSOAS JURIDICAS, QUE SERVIR DE BASE DE CALCULO PARA A APLI-CACAO EM INCENTIVOS FISCAIS, PERCENTUAL DE ATE 40% (QUARENTA POR CEN-TO) PODERA SER DEDUZIDO PARA APLICACAO NO GRUPO FINOR/FINAM/PIN/PROTERRA. DA PARCELA DEDUZIDA, 60% (SESSENTA POR CENTO) CORRESPONDERAOA APLICACAO NOS FUNDOS DE INVESTIMENTO DA AMAZONIA (FINAM) E DO NOR-DESTE (FINOR); 24% (VINTE E QUATRO POR CENTO) SERAO DESTINADOS AO PINE 16% (DEZESSEIS POR CENTO) AO PROTERRA. O PIN TEM COMO OBJETIVO PRO-MOVER A MAIOR INTEGRACAO A ECONOMIA NACIONAL DAS REGIOES COMPREENDIDASNAS AREAS DE ATUACAO DA SUDAM E DA SUDENE. OS RECURSOS SERAO APLICADOSEM PROGRAMAS E PROJETOS CONSIDERADOS PRIORITARIOS PELA SUDAM E SUDENE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.02.00', 'CONTRIBUICAO PARA O PROTERRA', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES ECONOMICAS DES-TINADAS AO PROGRAMA DE REDISTRIBUICAO DE TERRAS E DE ESTIMULO A AGRO-INDUSTRIA DO NORTE E DO NORDESTE. DA PARCELA DO IMPOSTO DE RENDA- PES-SOAS JURIDICAS QUE SERVIR DE BASE DE CALCULO PARA APLICACAO EM INCEN-TIVOS FISCAIS, PERCENTUAL DE ATE 40% (QUARENTA POR CENTO) PODERA SERDEDUZIDO PARA APLICACAO NO GRUPO FINOR/FINAM/PIN/PROTERRA. DA PARCELADEDUZIDA, 60% (SESSENTA POR CENTO) CORRESPONDERAO A APLICACAO NOS FUN-DOS DE INVESTIMENTO DA AMAZONIA (FINAM) E DO NORDESTE (FINOR); 24(VIN-TE E QUATRO POR CENTO) SERAO DESTINADOS AO PIN E 16% AO PROTERRA. OPROTERRA TEM COMO OBJETIVO PROMOVER O MAIS FACIL ACESSO DO HOMEM ATERRA, CRIAR MELHORES CONDICOES DE EMPREGO DE MAO-DE-OBRA E FOMENTAR AAGRO-INDUSTRIA NAS REGIOES COMPREENDIDAS NAS AREAS DE ATUACAO DA SUDAME DA SUDENE. OS RECURSOS SAO APLICADOS EM PROGRAMAS E PROJETOS CONSI-DERADOS PRIORITARIOS PELA SUDAM E SUDENE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.03.01', 'SELO ESPECIAL DE CONTROLE', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES FIS-CAIS PELO SELO DE CONTROLE. CONTRIBUICAO DEVIDA PELO RESSARCIMENTO DESELOS DE CONTROLE DESTINADOS A CIGARROS, CHAMPANHE DE PROCEDENCIA ES-TRANGEIRA, RUM, VODCA, UISQUE, LICORES, AGUARDENTES, BATIDAS, GIM, RE-LOGIOS DE BOLSO E DE PULSO, ETC. VINCULADO AO FUNDO DE DESENVOLVIMENTOE APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.03.02', 'LOJAS FRANCAS ENTREP.ADUAN. DEP.ALFANDEGADOS', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES FISCAIS ARRECADADAS PELAS LOJAS FRANCAS, PELOS ENTREPOSTOS ADUANEIROS E DEPOSITOS ALFANDEGADOS. CONTRIBUICAO DEVIDA PELO RESSARCIMENTO DAS DESPESAS ADMINISTRATI-VAS DECORRENTES DAS ATIVIDADES EXTRAORDINARIAS DE FISCALIZACAO, DEVIDAPOR: - PERMISSIONARIOS DE REGIME DE ENTREPOSTO ADUANEIRO NA IMPORTACAO DEUSO PUBLICO; - CONCESSIONARIO DE LOJAS FRANCA; - BENEFICIARIOS DE DEPOSITO ESPECIAL ALFANDEGADO; - PERMISSIONARIOS DE LOCAL ALFANDEGADO DE USO PUBLICO; - ANALISE E LAUDOS LABORATORIAIS REALIZADOS NA IMPORTACAO DE PRODUTOSDAS INDUSTRIAS QUIMICAS E PARAQUIMICAS E ALIMENTICIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.04.00', 'CONTRIBUICAO S/ APOSTAS EM COMPET. HIPICAS', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE APOSTAS EM COMPETICOES HIPICAS. INCIDE SOBRE O VALOR TOTAL DO MOVIMENTO GERAL DEAPOSTAS DE CADA ENTIDADE TURFISTICA, A CADA MES. DESTINA-SE A SECRETA-RIA DE DESENVOLVIMENTO RURAL. A APLICACAO DESSES RECURSOS SERA FEITAMEDIANTE PLANO ANUAL, APROVADO PELO MINISTERIO DA AGRICULTURA E DO A-BASTECIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.05.01', 'CONTR.P/O DESENV. IND. CINEMAT.NAC. -REMESSAS', 'REGISTRA O VALOR DA CONTRIBUICAO INCIDENTE SOBRE O PAGAMENTO, O CREDI-TO, O EMPREGO, A REMESSA OU A ENTREGA, AOS PRODUTORES, DISTRIBUIDORES OU INTERMEDIARIOS NO EXTERIOR, DE IMPORTANCIAS RELATIVAS A RENDIMENTO DECORRENTE DA EXPLORACAO DE OBRAS CINEMATOGRAFICAS E VIDEOFONOGRAFICASOU POR SUA AQUISICAO OU IMPORTACAO, A PRECO FIXO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.05.02', 'CONTR.P/O DESENV. IND. CINEMAT.NAC. - TITULOS', 'REGISTRA O VALOR DA CONTRIBUICAO DEVIDA UMA UNICA VEZ A CADA CINCO ANOS, PARA CADA SEGMENTO DE MERCADO POR: - TITULO OU CAPITULO DE OBRA CINEMATOGRAFICA OU VIDEOFONOGRAFICA DES- TINADA AOS SEGUINTES SEGMENTOS DE MERCADO: SALA DE EXIBICAO; VIDEO DOMESTICO, EM QUALQUER SUPORTE; SERVICO DE RADIODIFUSAO DE SONS E IMAGENS; SERVICO DE COMUNICACAO ELETRONICA DE MASSA POR ASSINATURA; OUTROS SERVICOS. - TITULO DE OBRA PUBLICITARIA CINEMATOGRAFICA OU VIDEOFONOGRAFICA, PA-RA CADA SEGMENTO DE MERCADO A QUE SE DESTINAR. A CONTRIBUICAO REFERENTE AAS OBRAS CINEMATOGRAFICAS OU VIDEOFO- NOGRAFICAS PUBLICITARIAS SERA DEVIDA UMA UNICA VEZ A CADA DOZE MESES PARA CADA UM DOS SEGMENTOS DE MERCADO EM QUE A OBRA SEJA EFETIVAMENTE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.06.00', 'ADICIONAL S/TARIFAS DE PASS.AEREAS DOMESTICAS', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES COM O ADICIONALSOBRE TARIFAS DE PASSAGENS AEREAS DE VOO DOMESTICO. CONSTITUI-SE EM UMA DICIONAL DE ATE 3% (TRES POR CENTO) A INCIDIR SOBRE AS TARIFAS DEPASSAGENS AEREAS DAS LINHAS DOMESTICAS, OPERADAS PELAS EMPRESAS DETRANSPORTE AEREO REGULAR, INCLUSIVE AS DE TRANSPORTE AEREO REGIONAL EOS TRECHOS DE CABOTAGEM. O PRODUTO DA ARRECADACAO E VINCULADA AO FUNDOAERONAUTICO PARA APLICACAO EM SISTEMAS INTEGRADOS DE TRANSPORTE AEREOREGIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.07.00', 'COTA-PARTE ADIC.FRETE P/ RENOV.MARIN.MERCANTE', 'REGISTRA A VPA PROVENIENTE DAS COTA-PARTE DO ADICIONAL DE FRETE PARA RENOVACAO DA MARINHA MERCANTE. CONTRIBUICAO INCIDENTE SOBREO VALOR DO FRETE NO TRANSPORTE DE QUALQUER CARGA, POR VIA MARITIMA FLUVIAL OU LACUSTRE. OS RECURSOS SE DESTINAM AO FUNDO DE MARINHA MER-CANTE - FMM; A EMPRESA BRASILEIRA DE NAVEGACAO, OPERANDO EMBARCACAOPROPRIA OU AFRETADA DE REGISTRO BRASILEIRO; E, A UMA CONTA ESPECIAL,36% (TRINTA E SEIS POR CENTO) DO AFMM GERADO NA NAVEGACAO DE LONGOCURSO, POR EMPRESA BRASILEIRA OPERANDO EMBARCACAO DE REGISTRO BRASI-LEIRO. ESSA CONTRIBUICAO E APLICADA PRIORITARIAMENTE NA AQUISICAO DEEMBARCACOES NOVAS, PARA USO PROPRIO DAS EMPRESS DE NAVEGACAO, CONSTRU-IDAS EM ESTALEIROS BRASILEIROS; NO REPARO, MANUTENCAO E MODERNIZACAODE EMBARCACOES, REALIZADAS POR EMPRESAS NACIONAIS; E EM PAGAMENTOS DEAMORTIZACOES E ENCARGOS CONCEDIDOS COM RECURSOS DO FUNDO DA MARINHAMERCANTE. PODE TAMBEM SER APLICADA A FUNDO PERDIDO, NOS CASOS PREVISTOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.08.00', 'CONTRIBUICAO S/REC.CONCESS.PERMISS.ENERG.ELET', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE A RECEITA DAS CONCESSIONARIAS DE ENERGIA ELETRICA, ONDE: 50% DOS RECURSOS RESULTANTES DE APLICACAO ANUAL DO MONTANTE DE NO MINIMO 1% DE SUA RECEITA OPERACIONAL LIQUIDA DAS CONCESSIONARIAS E PERMISSIONARIAS DE ENERGIA ELETRICA EM P & D DO SETOR ELETRICO. PARA ESSES RECURSOS SERA CRIADA UMA CATEGORIA DE PROGRAMACAO ESPECIFI±CA NO AMBITO DO FUNDO NACIONAL DE DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO FNDCT, PARA APLICACAO NO FINANCIAMENTO DE PROGRAMAS E PROJE±TOS DE PESQUISA CIENTIFICA E DESENVOLVIMENTO TECNOLOGICO DO SETOR ELE±TRICO, BEM COMO NA EFICIENCIA ENERGETICA NO USO FINAL. LEI 9991 DE 24/07/2000', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.09.00', 'CONTRIBUICAO P/ LIC.USO,AQUIS.OU TRANSF.TECN.', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICAO PELA LICENCA DE USO, AQUISICAO OU TRANSFERENCIA DE TECNOLOGIA, REFERENTE A INTERVENCAO NO DOMINIO ECONOMICO DE EMPRESA DETENTORA DE LICENCA DE USO OU ADQUIRENTE DE CONHECIMENTOS TECNOLOGICOS, BEM COMO AQUELA SIGNATARIA DE CONTRATOS QUE IMPLIQUEM TRANSFERENCIA DE TECNOLOGIA, FIRMADOSCOM RESIDENTES OU DOMICILIADOS NO EXTERIOR (ALIQUOTA DE 10 POR CENTO SOBRE OS VALORES PAGOS, CREDITADOS, ENTREGUES, EMPREGADOS OU REMETIDOS, A CADA MES, A RESIDENTES OU DOMICILIADOS NO EXTERIOR). A CONTRIBUICAO SERA RECOLHIDA AO TESOURO NACIONAL E DESTINADA AO FUNDO NACIONALDE DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO - FNDCT. OS RECURSOS SERAOALOCADOS EM CATEGORIA DE PROGRAMACAO ESPECIFICA E ADMINISTRADOS CON-FORME O DISPOSTO NO REGULAMENTO. (PL NUM. 2978/2000).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.10.01', 'CON. S/REC.OPER.BRUTA DECOR.PRES.SERV.TELECOM', 'REGISTRA A CONTRIBUICAO DEVIDA PELAS EMPRESAS QUE PRESTAM SERVICOS DE TELECOMUNICACOES, A ALIQUOTA DE UM POR CENTO SOBRE O VALOR DA RECEITA OPERACIONAL BRUTA EXCLUINDO-SE PARA DETERMINACAO DA BASE DE CALCULO AS VENDAS CANCELADAS, OS DESCONTOS CONCEDIDOS, O IMPOSTO SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTACOES DE SERVICOS DE TRANSPORTES INTERESTADUAIS, INTERMUNIPAIS E DE COMUNICACOES -ICMS, A CONTRIBUICAO AO PROGRAMA DE INTEGRACAO SOCIAL - PIS E A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL COFINS. OS RECURSOS DESTINADOS AO FUST QUANDO TENHAM A FINALIDADE DE COBRIR APARCELA DE CUSTO, EXCLUSIVOS DAS OBRIGACOES DE UNIVERSALIZACAO DE SERVICOS DE TELECOMUNICACOES QUE NAO POSSA SER RECUPERADA COM A EXPLORARACAO EFICIENTE DO SERVICO NOS TERMOS DO DISPOSTO NA LEI 9472 DEDE 16JUL1997 AMPARO LEGAL LEI 9989 DE 17AGO2000 E DECRETO 3624 DE 05OUT200', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.10.02', 'CON. S/REC.OPER.BRUTA EMPR.PREST.SERV.TELECOM', 'REGISTRA A CONTRIBUICAO DEVIDA PELAS EMPRESAS QUE PRESTAM SERVICOSDE TELECOMUNICACOES NO REGIME PUBLICO E PRIVADO, AA ALIQUOTA DE MEIOPOR CENTO SOBRE A RECEITA BRUTA, EXCLUINDO-SE PARA DETERMINACAO DA BA-SE DE CALCULO: AS VENDAS CANCELADAS, OS DESCONTOS CONCEDIDOS, OIMPOSTO SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE A PRESTACOES DE SERVICOS DE TRANSPORTES INTERESTADUAIS, INTERMUNICI- PAL E DE COMUNICACOES - ICMS, A CONTRIBUICAO AO PROGRAMA DE INTEGRACAOSOCIAL - PIS E A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADESOCIAL - COFINS OS RECURSOS DESTINADOS A FUNTTEL, PARA APLICACAO NO SETOR DE TELECOMU-NICACOES AMPARO LEGAL: LEI 10 052 DE 28NOV2000 E DECRETO 3 737 DE 30JAN2001', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.11.01', 'CONTR. DAS EMPRESAS INSTALADAS NA AMAZONIA', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.11.02', 'CONTR. EMPRESAS INSTALADAS NAS DEMAIS REGIOES', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.12.01', 'CONTR.REL.ATIV.IMP.PETR.DER. GAS NAT.ALC.CARB', 'REGISTRA O VALOR DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.12.02', 'CONTR.REL.ATIV.COM.PETR.DER. GAS NAT.ALC.CARB', 'REGISTRA O VALOR DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.13.00', 'CONTRIBUICAO PARA FOMENTO DA RADIODIFUSAO PUB', 'REGISTRA A VPA DECORRENTE DA PRESTACAO DE SERVICOS DA RADIODIFUSAO PUBLICA, EXPLORADOS DIRETAMENTE PELO PODER EXECUTIVO OU OU-TORGADOS POR ESTE A ENTIDADES DE SUA ADMINISTRACAO INDIRETA. DESTINACAO LEGAL: OS RECURSOS SAO DESTINADOS AA EMPRESA BRASIL DE COMUNICACAO S/A - EBC,VINCULADA AA SECRETARIA DE COMUNICACAO SOCIAL DA PRESIDENCIA DA REPU-BLICA, COM O OBJETIVO DE PROPICIAR MEIOS PARA A MELHORIA DOS SERVICOSDE RADIODIFUSAO PUBLICA E PARA A AMPLIACAO DE SUA PENETRACAO MEDIANTEA UTILIZACAO DE SERVICOS DE TELECOMUNICACOES. AMPARO LEGAL: LEI Nº 11.652, DE 07 DE ABRIL DE 2008.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.14.01', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PRINCIPAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PRINCIPAL. ESTA PARCELA DEVE SER APLICADA EM DIVERSAS AREAS ( COMO INSTITUTOS E CENTROS DE PESQUISA, UNIVERSIDADES, FACULDADES, FNDCT, DENTRE OUTROS). AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. INCISO III, § 1º, DO ART. 8º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.14.02', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - EXCEDENTE', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - EXCEDENTE. O RESTANTE DA CONTRIBUICAO PODERA SER APLICADO AO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIAS DA INFORMACAO -PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. § 3º, DO ART.10º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.14.03', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - RESIDUAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - RESIDUAL. ESTA PARCELA RESIDUAL OCORRE NA EVENTUALIDADE DE OS INVESTIMENTOS EM ATIVIDADES DE PESQUISA E DESENVOLVIMENTO NAO ATINGIREM AQUELE MINIMO FIXADO ( 5% DO FATURAMENTO BRUTO, DESCONTADO TRIBUTOS), OS RECURSOS FINANCEIROS RESIDUAIS, ATUALIZADOS E ACRESCIDOS DE DOZE POR CENTO, DEVERAO SER APLICADOS NO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIA DA INFORMACAO - PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991 ART. 35º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.14.04', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PARCELAMENTO', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PARCELAMENTO DE DEBITO. ESTA PARCELA REFERE-SE AOS DEBITOS DECORRENTES DA NAO REALIZACAO, TOTAL OU PARCIAL, A QUALQUER TITULO, ATE O PERIODO ENCERRADO EM 31 DE DEZEMBRO DE 2003, DE APLICACOES RELATIVAS AO INVESTIMENTO COMPULSORIO ANUAL EM PESQUISA E DESENVOLVIMENTO TECNOLOGICO, PODERAO SER OBJETO DE PARCELAMENTO (DEBITOS DE INVESTIMENTO) E SERAO DESTINADAS AO FNDCT. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. ART. 37º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.15.01', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PRINCIPAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PRINCIPAL. ESTA PARCELA DEVE SER APLICADA EM DIVERSAS AREAS ( COMO INSTITUTOS E CENTROS DE PESQUISA, UNIVERSIDADES, FACULDADES, FNDCT, DENTRE OUTROS). AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. INCISO III, § 1º, DO ART. 8º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.15.02', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - EXCEDENTE', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - EXCEDENTE. O RESTANTE DA CONTRIBUICAO PODERA SER APLICADO AO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIAS DA INFORMACAO -PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. § 3º, DO ART.10º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.15.03', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - RESIDUAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - RESIDUAL. ESTA PARCELA RESIDUAL OCORRE NA EVENTUALIDADE DE OS INVESTIMENTOS EM ATIVIDADES DE PESQUISA E DESENVOLVIMENTO NAO ATINGIREM AQUELE MINIMO FIXADO ( 5% DO FATURAMENTO BRUTO, DESCONTADO TRIBUTOS), OS RECURSOS FINANCEIROS RESIDUAIS, ATUALIZADOS E ACRESCIDOS DE DOZE POR CENTO, DEVERAO SER APLICADOS NO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIA DA INFORMACAO - PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991 ART. 35º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.15.04', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PARCELAMENTO', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PARCELAMENTO DE DEBITO. ESTA PARCELA REFERE-SE AOS DEBITOS DECORRENTES DA NAO REALIZACAO, TOTAL OU PARCIAL, A QUALQUER TITULO, ATE O PERIODO ENCERRADO EM 31 DE DEZEMBRO DE 2003, DE APLICACOES RELATIVAS AO INVESTIMENTO COMPULSORIO ANUAL EM PESQUISA E DESENVOLVIMENTO TECNOLOGICO, PODERAO SER OBJETO DE PARCELAMENTO (DEBITOS DE INVESTIMENTO) E SERAO DESTINADAS AO FNDCT. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. ART. 37º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.99.00', 'OUTRAS CONTRIBUICOES ECONOMICAS', 'COMPREENDE A VPA PROVENIENTE DAS OUTRAS CONTRIBUICOES ECONOMICAS DE NATUREZA EVENTUAL, PARA AS QUAIS NAO HA CONTA ESPECIFICA,INCLUSIVE RECURSOS ORIUNDOS DO PROGRAMA DE RECUPERACAO FISCAL E DO PARCELAMENTO ESPECIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.01.00', 'CONTRIBUICAO PARA O PIN', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES ECONOMICAS DES-TINADAS AO PROGRAMA DE INTEGRACAO NACIONAL. DA PARCELA DO IMPOSTO DERENDA - PESSOAS JURIDICAS, QUE SERVIR DE BASE DE CALCULO PARA A APLICACAO EM INCENTIVOS FISCAIS, PERCENTUAL DE ATE 40% (QUARENTA POR CEN-TO) PODERA SER DEDUZIDO PARA APLICACAO NO GRUPO FINOR/FINAM/PIN/PROTERRA. DA PARCELA DEDUZIDA, 60% (SESSENTA POR CENTO) CORRESPONDERAOA APLICACAO NOS FUNDOS DE INVESTIMENTO DA AMAZONIA (FINAM) E DO NOR-DESTE (FINOR); 24% (VINTE E QUATRO POR CENTO) SERAO DESTINADOS AO PINE 16% (DEZESSEIS POR CENTO) AO PROTERRA. O PIN TEM COMO OBJETIVO PRO-MOVER A MAIOR INTEGRACAO A ECONOMIA NACIONAL DAS REGIOES COMPREENDIDASNAS AREAS DE ATUACAO DA SUDAM E DA SUDENE. OS RECURSOS SERAO APLICADOSEM PROGRAMAS E PROJETOS CONSIDERADOS PRIORITARIOS PELA SUDAM E SUDENE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.02.00', 'CONTRIBUICAO PARA O PROTERRA', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES ECONOMICAS DES-TINADAS AO PROGRAMA DE REDISTRIBUICAO DE TERRAS E DE ESTIMULO A AGROINDUSTRIA DO NORTE E DO NORDESTE. DA PARCELA DO IMPOSTO DE RENDA- PES-SOAS JURIDICAS QUE SERVIR DE BASE DE CALCULO PARA APLICACAO EM INCENTIVOS FISCAIS, PERCENTUAL DE ATE 40% (QUARENTA POR CENTO) PODERA SERDEDUZIDO PARA APLICACAO NO GRUPO FINOR/FINAM/PIN/PROTERRA. DA PARCELADEDUZIDA, 60% (SESSENTA POR CENTO) CORRESPONDERAO A APLICACAO NOS FUNDOS DE INVESTIMENTO DA AMAZONIA (FINAM) E DO NORDESTE (FINOR); 24(VINTE E QUATRO POR CENTO) SERAO DESTINADOS AO PIN E 16% AO PROTERRA. OPROTERRA TEM COMO OBJETIVO PROMOVER O MAIS FACIL ACESSO DO HOMEM ATERRA, CRIAR MELHORES CONDICOES DE EMPREGO DE MAO-DE-OBRA E FOMENTAR AAGRO-INDUSTRIA NAS REGIOES COMPREENDIDAS NAS AREAS DE ATUACAO DA SUDAME DA SUDENE. OS RECURSOS SAO APLICADOS EM PROGRAMAS E PROJETOS CONSI-DERADOS PRIORITARIOS PELA SUDAM E SUDENE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.03.01', 'SELO ESPECIAL DE CONTROLE', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES FIS-CAIS PELO SELO DE CONTROLE. CONTRIBUICAO DEVIDA PELO RESSARCIMENTO DESELOS DE CONTROLE DESTINADOS A CIGARROS, CHAMPANHE DE PROCEDENCIA ES-TRANGEIRA, RUM, VODCA, UISQUE, LICORES, AGUARDENTES, BATIDAS, GIM, RE-LOGIOS DE BOLSO E DE PULSO, ETC. VINCULADO AO FUNDO DE DESENVOLVIMENTOE APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.03.02', 'LOJAS FRANCAS ENTREP.ADUAN. DEP.ALFANDEGADOS', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES FISCAIS ARRECADADAS PELAS LOJAS FRANCAS, PELOS ENTREPOSTOS ADUANEIROS E DEPOSITOS ALFANDEGADOS. CONTRIBUICAO DEVIDA PELO RESSARCIMENTO DAS DESPESAS ADMINISTRATI-VAS DECORRENTES DAS ATIVIDADES EXTRAORDINARIAS DE FISCALIZACAO, DEVIDAPOR: - PERMISSIONARIOS DE REGIME DE ENTREPOSTO ADUANEIRO NA IMPORTACAO DEUSO PUBLICO; - CONCESSIONARIO DE LOJAS FRANCA; - BENEFICIARIOS DE DEPOSITO ESPECIAL ALFANDEGADO; - PERMISSIONARIOS DE LOCAL ALFANDEGADO DE USO PUBLICO; - ANALISE E LAUDOS LABORATORIAIS REALIZADOS NA IMPORTACAO DE PRODUTOSDAS INDUSTRIAS QUIMICAS E PARAQUIMICAS E ALIMENTICIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.04.00', 'CONTRIBUICAO S/ APOSTAS EM COMPET. HIPICAS', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE APOSTAS EM COMPETICOES HIPICAS. INCIDE SOBRE O VALOR TOTAL DO MOVIMENTO GERAL DEAPOSTAS DE CADA ENTIDADE TURFISTICA, A CADA MES. DESTINA-SE A SECRETA-RIA DE DESENVOLVIMENTO RURAL. A APLICACAO DESSES RECURSOS SERA FEITAMEDIANTE PLANO ANUAL, APROVADO PELO MINISTERIO DA AGRICULTURA E DO A-BASTECIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.05.01', 'CONTR.P/O DESENV. IND. CINEMAT.NAC. -REMESSAS', 'REGISTRA O VALOR DA CONTRIBUICAO INCIDENTE SOBRE O PAGAMENTO, O CREDITO, O EMPREGO, A REMESSA OU A ENTREGA, AOS PRODUTORES, DISTRIBUIDORES OU INTERMEDIARIOS NO EXTERIOR, DE IMPORTANCIAS RELATIVAS A RENDIMENTO DECORRENTE DA EXPLORACAO DE OBRAS CINEMATOGRAFICAS E VIDEOFONOGRAFICASOU POR SUA AQUISICAO OU IMPORTACAO, A PRECO FIXO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.05.02', 'CONTR.P/O DESENV. IND. CINEMAT.NAC. - TITULOS', 'REGISTRA O VALOR DA CONTRIBUICAO DEVIDA UMA UNICA VEZ A CADA CINCO ANOS, PARA CADA SEGMENTO DE MERCADO POR: - TITULO OU CAPITULO DE OBRA CINEMATOGRAFICA OU VIDEOFONOGRAFICA DESTINADA AOS SEGUINTES SEGMENTOS DE MERCADO: SALA DE EXIBICAO; VIDEO DOMESTICO, EM QUALQUER SUPORTE; SERVICO DE RADIODIFUSAO DE SONS E IMAGENS; SERVICO DE COMUNICACAO ELETRONICA DE MASSA POR ASSINATURA; OUTROS SERVICOS. - TITULO DE OBRA PUBLICITARIA CINEMATOGRAFICA OU VIDEOFONOGRAFICA, PA-RA CADA SEGMENTO DE MERCADO A QUE SE DESTINAR. A CONTRIBUICAO REFERENTE AAS OBRAS CINEMATOGRAFICAS OU VIDEOFONOGRAFICAS PUBLICITARIAS SERA DEVIDA UMA UNICA VEZ A CADA DOZE MESES PARA CADA UM DOS SEGMENTOS DE MERCADO EM QUE A OBRA SEJA EFETIVAMENTE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.06.00', 'ADICIONAL S/TARIFAS DE PASS.AEREAS DOMESTICAS', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES COM O ADICIONALSOBRE TARIFAS DE PASSAGENS AEREAS DE VOO DOMESTICO. CONSTITUI-SE EM UMA DICIONAL DE ATE 3% (TRES POR CENTO) A INCIDIR SOBRE AS TARIFAS DEPASSAGENS AEREAS DAS LINHAS DOMESTICAS, OPERADAS PELAS EMPRESAS DETRANSPORTE AEREO REGULAR, INCLUSIVE AS DE TRANSPORTE AEREO REGIONAL EOS TRECHOS DE CABOTAGEM. O PRODUTO DA ARRECADACAO E VINCULADA AO FUNDOAERONAUTICO PARA APLICACAO EM SISTEMAS INTEGRADOS DE TRANSPORTE AEREOREGIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.07.00', 'COTA-PARTE ADIC.FRETE P/ RENOV.MARIN.MERCANTE', 'REGISTRA A VPA PROVENIENTE DAS COTA-PARTE DO ADICIONAL DE FRETE PARA RENOVACAO DA MARINHA MERCANTE. CONTRIBUICAO INCIDENTE SOBREO VALOR DO FRETE NO TRANSPORTE DE QUALQUER CARGA, POR VIA MARITIMA FLUVIAL OU LACUSTRE. OS RECURSOS SE DESTINAM AO FUNDO DE MARINHA MER-CANTE - FMM; A EMPRESA BRASILEIRA DE NAVEGACAO, OPERANDO EMBARCACAOPROPRIA OU AFRETADA DE REGISTRO BRASILEIRO; E, A UMA CONTA ESPECIAL,36% (TRINTA E SEIS POR CENTO) DO AFMM GERADO NA NAVEGACAO DE LONGOCURSO, POR EMPRESA BRASILEIRA OPERANDO EMBARCACAO DE REGISTRO BRASI-LEIRO. ESSA CONTRIBUICAO E APLICADA PRIORITARIAMENTE NA AQUISICAO DEEMBARCACOES NOVAS, PARA USO PROPRIO DAS EMPRESS DE NAVEGACAO, CONSTRU-IDAS EM ESTALEIROS BRASILEIROS; NO REPARO, MANUTENCAO E MODERNIZACAODE EMBARCACOES, REALIZADAS POR EMPRESAS NACIONAIS; E EM PAGAMENTOS DEAMORTIZACOES E ENCARGOS CONCEDIDOS COM RECURSOS DO FUNDO DA MARINHAMERCANTE. PODE TAMBEM SER APLICADA A FUNDO PERDIDO, NOS CASOS PREVISTOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.08.00', 'CONTRIBUICAO S/REC.CONCESS.PERMISS.ENERG.ELET', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE A RECEITA DAS CONCESSIONARIAS DE ENERGIA ELETRICA, ONDE: 50% DOS RECURSOS RESULTANTES DE APLICACAO ANUAL DO MONTANTE DE NO MINIMO 1% DE SUA RECEITA OPERACIONAL LIQUIDA DAS CONCESSIONARIAS E PERMISSIONARIAS DE ENERGIA ELETRICA EM P & D DO SETOR ELETRICO. PARA ESSES RECURSOS SERA CRIADA UMA CATEGORIA DE PROGRAMACAO ESPECIFI±CA NO AMBITO DO FUNDO NACIONAL DE DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO FNDCT, PARA APLICACAO NO FINANCIAMENTO DE PROGRAMAS E PROJE±TOS DE PESQUISA CIENTIFICA E DESENVOLVIMENTO TECNOLOGICO DO SETOR ELE±TRICO, BEM COMO NA EFICIENCIA ENERGETICA NO USO FINAL. LEI 9991 DE 24/07/2000', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.09.00', 'CONTRIBUICAO P/ LIC.USO,AQUIS.OU TRANSF.TECN.', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICAO PELA LICENCA DE USO, AQUISICAO OU TRANSFERENCIA DE TECNOLOGIA, REFERENTE A INTERVENCAO NO DOMINIO ECONOMICO DE EMPRESA DETENTORA DE LICENCA DE USO OU ADQUIRENTE DE CONHECIMENTOS TECNOLOGICOS, BEM COMO AQUELA SIGNATARIA DE CONTRATOS QUE IMPLIQUEM TRANSFERENCIA DE TECNOLOGIA, FIRMADOSCOM RESIDENTES OU DOMICILIADOS NO EXTERIOR (ALIQUOTA DE 10 POR CENTO SOBRE OS VALORES PAGOS, CREDITADOS, ENTREGUES, EMPREGADOS OU REMETIDOS, A CADA MES, A RESIDENTES OU DOMICILIADOS NO EXTERIOR). A CONTRIBUICAO SERA RECOLHIDA AO TESOURO NACIONAL E DESTINADA AO FUNDO NACIONALDE DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO - FNDCT. OS RECURSOS SERAOALOCADOS EM CATEGORIA DE PROGRAMACAO ESPECIFICA E ADMINISTRADOS CON-FORME O DISPOSTO NO REGULAMENTO. (PL NUM. 2978/2000).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.10.01', 'CON. S/REC.OPER.BRUTA DECOR.PRES.SERV.TELECOM', 'REGISTRA A CONTRIBUICAO DEVIDA PELAS EMPRESAS QUE PRESTAM SERVICOS DE TELECOMUNICACOES, A ALIQUOTA DE UM POR CENTO SOBRE O VALOR DA RECEITA OPERACIONAL BRUTA EXCLUINDO-SE PARA DETERMINACAO DA BASE DE CALCULO AS VENDAS CANCELADAS, OS DESCONTOS CONCEDIDOS, O IMPOSTO SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTACOES DE SERVICOS DE TRANSPORTES INTERESTADUAIS, INTERMUNIPAIS E DE COMUNICACOES -ICMS, A CONTRIBUICAO AO PROGRAMA DE INTEGRACAO SOCIAL - PIS E A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL COFINS. OS RECURSOS DESTINADOS AO FUST QUANDO TENHAM A FINALIDADE DE COBRIR APARCELA DE CUSTO, EXCLUSIVOS DAS OBRIGACOES DE UNIVERSALIZACAO DE SERVICOS DE TELECOMUNICACOES QUE NAO POSSA SER RECUPERADA COM A EXPLORARACAO EFICIENTE DO SERVICO NOS TERMOS DO DISPOSTO NA LEI 9472 DEDE 16JUL1997 AMPARO LEGAL LEI 9989 DE 17AGO2000 E DECRETO 3624 DE 05OUT200', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.10.02', 'CON. S/REC.OPER.BRUTA EMPR.PREST.SERV.TELECOM', 'REGISTRA A CONTRIBUICAO DEVIDA PELAS EMPRESAS QUE PRESTAM SERVICOSDE TELECOMUNICACOES NO REGIME PUBLICO E PRIVADO, AA ALIQUOTA DE MEIOPOR CENTO SOBRE A RECEITA BRUTA, EXCLUINDO-SE PARA DETERMINACAO DA BA-SE DE CALCULO: AS VENDAS CANCELADAS, OS DESCONTOS CONCEDIDOS, OIMPOSTO SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE A PRESTACOES DE SERVICOS DE TRANSPORTES INTERESTADUAIS, INTERMUNICI- PAL E DE COMUNICACOES - ICMS, A CONTRIBUICAO AO PROGRAMA DE INTEGRACAOSOCIAL - PIS E A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADESOCIAL - COFINS OS RECURSOS DESTINADOS A FUNTTEL, PARA APLICACAO NO SETOR DE TELECOMU-NICACOES AMPARO LEGAL: LEI 10 052 DE 28NOV2000 E DECRETO 3 737 DE 30JAN2001', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.11.01', 'CONTR. DAS EMPRESAS INSTALADAS NA AMAZONIA', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.11.02', 'CONTR. EMPRESAS INSTALADAS NAS DEMAIS REGIOES', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.12.01', 'CONTR.REL.ATIV.IMP.PETR.DER. GAS NAT.ALC.CARB', 'REGISTRA O VALOR DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.12.02', 'CONTR.REL.ATIV.COM.PETR.DER. GAS NAT.ALC.CARB', 'REGISTRA O VALOR DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.13.00', 'CONTRIBUICAO PARA FOMENTO DA RADIODIFUSAO PUB', 'REGISTRA A VPA DECORRENTE DA PRESTACAO DE SERVICOS DA RADIODIFUSAO PUBLICA, EXPLORADOS DIRETAMENTE PELO PODER EXECUTIVO OU OU-TORGADOS POR ESTE A ENTIDADES DE SUA ADMINISTRACAO INDIRETA. DESTINACAO LEGAL: OS RECURSOS SAO DESTINADOS AA EMPRESA BRASIL DE COMUNICACAO S/A - EBC,VINCULADA AA SECRETARIA DE COMUNICACAO SOCIAL DA PRESIDENCIA DA REPU-BLICA, COM O OBJETIVO DE PROPICIAR MEIOS PARA A MELHORIA DOS SERVICOSDE RADIODIFUSAO PUBLICA E PARA A AMPLIACAO DE SUA PENETRACAO MEDIANTE A UTILIZACAO DE SERVICOS DE TELECOMUNICACOES. AMPARO LEGAL: LEI Nº 11.652, DE 07 DE ABRIL DE 2008.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.14.01', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PRINCIPAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PRINCIPAL. ESTA PARCELA DEVE SER APLICADA EM DIVERSAS AREAS ( COMO INSTITUTOS E CENTROS DE PESQUISA, UNIVERSIDADES, FACULDADES, FNDCT, DENTRE OUTROS). AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. INCISO III, § 1º, DO ART. 8º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.14.02', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - EXCEDENTE', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - EXCEDENTE. O RESTANTE DA CONTRIBUICAO PODERA SER APLICADO AO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIAS DA INFORMACAO -PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. § 3º, DO ART.10º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.14.03', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - RESIDUAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - RESIDUAL. ESTA PARCELA RESIDUAL OCORRE NA EVENTUALIDADE DE OS INVESTIMENTOS EM ATIVIDADES DE PESQUISA E DESENVOLVIMENTO NAO ATINGIREM AQUELE MINIMO FIXADO ( 5% DO FATURAMENTO BRUTO, DESCONTADO TRIBUTOS), OS RECURSOS FINANCEIROS RESIDUAIS, ATUALIZADOS E ACRESCIDOS DE DOZE POR CENTO, DEVERAO SER APLICADOS NO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIA DA INFORMACAO - PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991 ART. 35º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.14.04', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PARCELAMENTO', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PARCELAMENTO DE DEBITO. ESTA PARCELA REFERE-SE AOS DEBITOS DECORRENTES DA NAO REALIZACAO, TOTAL OU PARCIAL, A QUALQUER TITULO, ATE O PERIODO ENCERRADO EM 31 DE DEZEMBRO DE 2003, DE APLICACOES RELATIVAS AO INVESTIMENTO COMPULSORIO ANUAL EM PESQUISA E DESENVOLVIMENTO TECNOLOGICO, PODERAO SER OBJETO DE PARCELAMENTO (DEBITOS DE INVESTIMENTO) E SERAO DESTINADAS AO FNDCT. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. ART. 37º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.15.01', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PRINCIPAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PRINCIPAL. ESTA PARCELA DEVE SER APLICADA EM DIVERSAS AREAS ( COMO INSTITUTOS E CENTROS DE PESQUISA, UNIVERSIDADES, FACULDADES, FNDCT, DENTRE OUTROS). AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. INCISO III, § 1º, DO ART. 8º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.15.02', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - EXCEDENTE', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - EXCEDENTE. O RESTANTE DA CONTRIBUICAO PODERA SER APLICADO AO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIAS DA INFORMACAO -PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. § 3º, DO ART.10º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.15.03', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - RESIDUAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - RESIDUAL. ESTA PARCELA RESIDUAL OCORRE NA EVENTUALIDADE DE OS INVESTIMENTOS EM ATIVIDADES DE PESQUISA E DESENVOLVIMENTO NAO ATINGIREM AQUELE MINIMO FIXADO ( 5% DO FATURAMENTO BRUTO, DESCONTADO TRIBUTOS), OS RECURSOS FINANCEIROS RESIDUAIS, ATUALIZADOS E ACRESCIDOS DE DOZE POR CENTO, DEVERAO SER APLICADOS NO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIA DA INFORMACAO - PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991 ART. 35º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.15.04', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PARCELAMENTO', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PARCELAMENTO DE DEBITO. ESTA PARCELA REFERE-SE AOS DEBITOS DECORRENTES DA NAO REALIZACAO, TOTAL OU PARCIAL, A QUALQUER TITULO, ATE O PERIODO ENCERRADO EM 31 DE DEZEMBRO DE 2003, DE APLICACOES RELATIVAS AO INVESTIMENTO COMPULSORIO ANUAL EM PESQUISA E DESENVOLVIMENTO TECNOLOGICO, PODERAO SER OBJETO DE PARCELAMENTO (DEBITOS DE INVESTIMENTO) E SERAO DESTINADAS AO FNDCT. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. ART. 37º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.99.00', 'OUTRAS CONTRIBUICOES ECONOMICAS', 'COMPREENDE A VPA PROVENIENTE DAS OUTRAS CONTRIBUICOES ECONOMICAS DE NATUREZA EVENTUAL, PARA AS QUAIS NAO HA CONTA ESPECIFICA,INCLUSIVE RECURSOS ORIUNDOS DO PROGRAMA DE RECUPERACAO FISCAL E DO PARCELAMENTO ESPECIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.01.00', 'CONTRIBUICAO PARA O PIN', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES ECONOMICAS DES-TINADAS AO PROGRAMA DE INTEGRACAO NACIONAL. DA PARCELA DO IMPOSTO DERENDA - PESSOAS JURIDICAS, QUE SERVIR DE BASE DE CALCULO PARA A APLICACAO EM INCENTIVOS FISCAIS, PERCENTUAL DE ATE 40% (QUARENTA POR CEN-TO) PODERA SER DEDUZIDO PARA APLICACAO NO GRUPO FINOR/FINAM/PIN/PROTERRA. DA PARCELA DEDUZIDA, 60% (SESSENTA POR CENTO) CORRESPONDERAOA APLICACAO NOS FUNDOS DE INVESTIMENTO DA AMAZONIA (FINAM) E DO NOR-DESTE (FINOR); 24% (VINTE E QUATRO POR CENTO) SERAO DESTINADOS AO PINE 16% (DEZESSEIS POR CENTO) AO PROTERRA. O PIN TEM COMO OBJETIVO PRO-MOVER A MAIOR INTEGRACAO A ECONOMIA NACIONAL DAS REGIOES COMPREENDIDASNAS AREAS DE ATUACAO DA SUDAM E DA SUDENE. OS RECURSOS SERAO APLICADOSEM PROGRAMAS E PROJETOS CONSIDERADOS PRIORITARIOS PELA SUDAM E SUDENE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.02.00', 'CONTRIBUICAO PARA O PROTERRA', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES ECONOMICAS DES-TINADAS AO PROGRAMA DE REDISTRIBUICAO DE TERRAS E DE ESTIMULO A AGROINDUSTRIA DO NORTE E DO NORDESTE. DA PARCELA DO IMPOSTO DE RENDA- PES-SOAS JURIDICAS QUE SERVIR DE BASE DE CALCULO PARA APLICACAO EM INCENTIVOS FISCAIS, PERCENTUAL DE ATE 40% (QUARENTA POR CENTO) PODERA SERDEDUZIDO PARA APLICACAO NO GRUPO FINOR/FINAM/PIN/PROTERRA. DA PARCELADEDUZIDA, 60% (SESSENTA POR CENTO) CORRESPONDERAO A APLICACAO NOS FUNDOS DE INVESTIMENTO DA AMAZONIA (FINAM) E DO NORDESTE (FINOR); 24(VINTE E QUATRO POR CENTO) SERAO DESTINADOS AO PIN E 16% AO PROTERRA. OPROTERRA TEM COMO OBJETIVO PROMOVER O MAIS FACIL ACESSO DO HOMEM ATERRA, CRIAR MELHORES CONDICOES DE EMPREGO DE MAO-DE-OBRA E FOMENTAR AAGRO-INDUSTRIA NAS REGIOES COMPREENDIDAS NAS AREAS DE ATUACAO DA SUDAME DA SUDENE. OS RECURSOS SAO APLICADOS EM PROGRAMAS E PROJETOS CONSI-DERADOS PRIORITARIOS PELA SUDAM E SUDENE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.03.01', 'SELO ESPECIAL DE CONTROLE', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES FIS-CAIS PELO SELO DE CONTROLE. CONTRIBUICAO DEVIDA PELO RESSARCIMENTO DESELOS DE CONTROLE DESTINADOS A CIGARROS, CHAMPANHE DE PROCEDENCIA ES-TRANGEIRA, RUM, VODCA, UISQUE, LICORES, AGUARDENTES, BATIDAS, GIM, RE-LOGIOS DE BOLSO E DE PULSO, ETC. VINCULADO AO FUNDO DE DESENVOLVIMENTOE APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.03.02', 'LOJAS FRANCAS ENTREP.ADUAN. DEP.ALFANDEGADOS', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES FISCAIS ARRECADADAS PELAS LOJAS FRANCAS, PELOS ENTREPOSTOS ADUANEIROS E DEPOSITOS ALFANDEGADOS. CONTRIBUICAO DEVIDA PELO RESSARCIMENTO DAS DESPESAS ADMINISTRATI-VAS DECORRENTES DAS ATIVIDADES EXTRAORDINARIAS DE FISCALIZACAO, DEVIDAPOR: - PERMISSIONARIOS DE REGIME DE ENTREPOSTO ADUANEIRO NA IMPORTACAO DEUSO PUBLICO; - CONCESSIONARIO DE LOJAS FRANCA; - BENEFICIARIOS DE DEPOSITO ESPECIAL ALFANDEGADO; - PERMISSIONARIOS DE LOCAL ALFANDEGADO DE USO PUBLICO; - ANALISE E LAUDOS LABORATORIAIS REALIZADOS NA IMPORTACAO DE PRODUTOSDAS INDUSTRIAS QUIMICAS E PARAQUIMICAS E ALIMENTICIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.04.00', 'CONTRIBUICAO S/ APOSTAS EM COMPET. HIPICAS', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE APOSTAS EM COMPETICOES HIPICAS. INCIDE SOBRE O VALOR TOTAL DO MOVIMENTO GERAL DEAPOSTAS DE CADA ENTIDADE TURFISTICA, A CADA MES. DESTINA-SE A SECRETA-RIA DE DESENVOLVIMENTO RURAL. A APLICACAO DESSES RECURSOS SERA FEITAMEDIANTE PLANO ANUAL, APROVADO PELO MINISTERIO DA AGRICULTURA E DO A-BASTECIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.05.01', 'CONTR.P/O DESENV. IND. CINEMAT.NAC. -REMESSAS', 'REGISTRA O VALOR DA CONTRIBUICAO INCIDENTE SOBRE O PAGAMENTO, O CREDITO, O EMPREGO, A REMESSA OU A ENTREGA, AOS PRODUTORES, DISTRIBUIDORES OU INTERMEDIARIOS NO EXTERIOR, DE IMPORTANCIAS RELATIVAS A RENDIMENTO DECORRENTE DA EXPLORACAO DE OBRAS CINEMATOGRAFICAS E VIDEOFONOGRAFICASOU POR SUA AQUISICAO OU IMPORTACAO, A PRECO FIXO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.05.02', 'CONTR.P/O DESENV. IND. CINEMAT.NAC. - TITULOS', 'REGISTRA O VALOR DA CONTRIBUICAO DEVIDA UMA UNICA VEZ A CADA CINCO ANOS, PARA CADA SEGMENTO DE MERCADO POR: - TITULO OU CAPITULO DE OBRA CINEMATOGRAFICA OU VIDEOFONOGRAFICA DESTINADA AOS SEGUINTES SEGMENTOS DE MERCADO: SALA DE EXIBICAO; VIDEO DOMESTICO, EM QUALQUER SUPORTE; SERVICO DE RADIODIFUSAO DE SONS E IMAGENS; SERVICO DE COMUNICACAO ELETRONICA DE MASSA POR ASSINATURA; OUTROS SERVICOS. - TITULO DE OBRA PUBLICITARIA CINEMATOGRAFICA OU VIDEOFONOGRAFICA, PA-RA CADA SEGMENTO DE MERCADO A QUE SE DESTINAR. A CONTRIBUICAO REFERENTE AAS OBRAS CINEMATOGRAFICAS OU VIDEOFONOGRAFICAS PUBLICITARIAS SERA DEVIDA UMA UNICA VEZ A CADA DOZE MESES PARA CADA UM DOS SEGMENTOS DE MERCADO EM QUE A OBRA SEJA EFETIVAMENTE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.06.00', 'ADICIONAL S/TARIFAS DE PASS.AEREAS DOMESTICAS', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES COM O ADICIONALSOBRE TARIFAS DE PASSAGENS AEREAS DE VOO DOMESTICO. CONSTITUI-SE EM UMA DICIONAL DE ATE 3% (TRES POR CENTO) A INCIDIR SOBRE AS TARIFAS DEPASSAGENS AEREAS DAS LINHAS DOMESTICAS, OPERADAS PELAS EMPRESAS DETRANSPORTE AEREO REGULAR, INCLUSIVE AS DE TRANSPORTE AEREO REGIONAL EOS TRECHOS DE CABOTAGEM. O PRODUTO DA ARRECADACAO E VINCULADA AO FUNDOAERONAUTICO PARA APLICACAO EM SISTEMAS INTEGRADOS DE TRANSPORTE AEREOREGIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.07.00', 'COTA-PARTE ADIC.FRETE P/ RENOV.MARIN.MERCANTE', 'REGISTRA A VPA PROVENIENTE DAS COTA-PARTE DO ADICIONAL DE FRETE PARA RENOVACAO DA MARINHA MERCANTE. CONTRIBUICAO INCIDENTE SOBREO VALOR DO FRETE NO TRANSPORTE DE QUALQUER CARGA, POR VIA MARITIMA FLUVIAL OU LACUSTRE. OS RECURSOS SE DESTINAM AO FUNDO DE MARINHA MER-CANTE - FMM; A EMPRESA BRASILEIRA DE NAVEGACAO, OPERANDO EMBARCACAOPROPRIA OU AFRETADA DE REGISTRO BRASILEIRO; E, A UMA CONTA ESPECIAL,36% (TRINTA E SEIS POR CENTO) DO AFMM GERADO NA NAVEGACAO DE LONGOCURSO, POR EMPRESA BRASILEIRA OPERANDO EMBARCACAO DE REGISTRO BRASI-LEIRO. ESSA CONTRIBUICAO E APLICADA PRIORITARIAMENTE NA AQUISICAO DEEMBARCACOES NOVAS, PARA USO PROPRIO DAS EMPRESS DE NAVEGACAO, CONSTRU-IDAS EM ESTALEIROS BRASILEIROS; NO REPARO, MANUTENCAO E MODERNIZACAODE EMBARCACOES, REALIZADAS POR EMPRESAS NACIONAIS; E EM PAGAMENTOS DEAMORTIZACOES E ENCARGOS CONCEDIDOS COM RECURSOS DO FUNDO DA MARINHAMERCANTE. PODE TAMBEM SER APLICADA A FUNDO PERDIDO, NOS CASOS PREVISTOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.08.00', 'CONTRIBUICAO S/REC.CONCESS.PERMISS.ENERG.ELET', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE A RECEITA DAS CONCESSIONARIAS DE ENERGIA ELETRICA, ONDE: 50% DOS RECURSOS RESULTANTES DE APLICACAO ANUAL DO MONTANTE DE NO MINIMO 1% DE SUA RECEITA OPERACIONAL LIQUIDA DAS CONCESSIONARIAS E PERMISSIONARIAS DE ENERGIA ELETRICA EM P & D DO SETOR ELETRICO. PARA ESSES RECURSOS SERA CRIADA UMA CATEGORIA DE PROGRAMACAO ESPECIFI±CA NO AMBITO DO FUNDO NACIONAL DE DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO FNDCT, PARA APLICACAO NO FINANCIAMENTO DE PROGRAMAS E PROJE±TOS DE PESQUISA CIENTIFICA E DESENVOLVIMENTO TECNOLOGICO DO SETOR ELE±TRICO, BEM COMO NA EFICIENCIA ENERGETICA NO USO FINAL. LEI 9991 DE 24/07/2000', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.09.00', 'CONTRIBUICAO P/ LIC.USO,AQUIS.OU TRANSF.TECN.', 'REGISTRA A VPA PROVENIENTE DAS CONTRIBUICAO PELA LICENCA DE USO, AQUISICAO OU TRANSFERENCIA DE TECNOLOGIA, REFERENTE A INTERVENCAO NO DOMINIO ECONOMICO DE EMPRESA DETENTORA DE LICENCA DE USO OU ADQUIRENTE DE CONHECIMENTOS TECNOLOGICOS, BEM COMO AQUELA SIGNATARIA DE CONTRATOS QUE IMPLIQUEM TRANSFERENCIA DE TECNOLOGIA, FIRMADOSCOM RESIDENTES OU DOMICILIADOS NO EXTERIOR (ALIQUOTA DE 10 POR CENTO SOBRE OS VALORES PAGOS, CREDITADOS, ENTREGUES, EMPREGADOS OU REMETIDOS, A CADA MES, A RESIDENTES OU DOMICILIADOS NO EXTERIOR). A CONTRIBUICAO SERA RECOLHIDA AO TESOURO NACIONAL E DESTINADA AO FUNDO NACIONALDE DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO - FNDCT. OS RECURSOS SERAOALOCADOS EM CATEGORIA DE PROGRAMACAO ESPECIFICA E ADMINISTRADOS CON-FORME O DISPOSTO NO REGULAMENTO. (PL NUM. 2978/2000).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.10.01', 'CON. S/REC.OPER.BRUTA DECOR.PRES.SERV.TELECOM', 'REGISTRA A CONTRIBUICAO DEVIDA PELAS EMPRESAS QUE PRESTAM SERVICOS DE TELECOMUNICACOES, A ALIQUOTA DE UM POR CENTO SOBRE O VALOR DA RECEITA OPERACIONAL BRUTA EXCLUINDO-SE PARA DETERMINACAO DA BASE DE CALCULO AS VENDAS CANCELADAS, OS DESCONTOS CONCEDIDOS, O IMPOSTO SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTACOES DE SERVICOS DE TRANSPORTES INTERESTADUAIS, INTERMUNIPAIS E DE COMUNICACOES -ICMS, A CONTRIBUICAO AO PROGRAMA DE INTEGRACAO SOCIAL - PIS E A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL COFINS. OS RECURSOS DESTINADOS AO FUST QUANDO TENHAM A FINALIDADE DE COBRIR APARCELA DE CUSTO, EXCLUSIVOS DAS OBRIGACOES DE UNIVERSALIZACAO DE SERVICOS DE TELECOMUNICACOES QUE NAO POSSA SER RECUPERADA COM A EXPLORARACAO EFICIENTE DO SERVICO NOS TERMOS DO DISPOSTO NA LEI 9472 DEDE 16JUL1997 AMPARO LEGAL LEI 9989 DE 17AGO2000 E DECRETO 3624 DE 05OUT200', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.10.02', 'CON. S/REC.OPER.BRUTA EMPR.PREST.SERV.TELECOM', 'REGISTRA A CONTRIBUICAO DEVIDA PELAS EMPRESAS QUE PRESTAM SERVICOSDE TELECOMUNICACOES NO REGIME PUBLICO E PRIVADO, AA ALIQUOTA DE MEIOPOR CENTO SOBRE A RECEITA BRUTA, EXCLUINDO-SE PARA DETERMINACAO DA BA-SE DE CALCULO: AS VENDAS CANCELADAS, OS DESCONTOS CONCEDIDOS, OIMPOSTO SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE A PRESTACOES DE SERVICOS DE TRANSPORTES INTERESTADUAIS, INTERMUNICI- PAL E DE COMUNICACOES - ICMS, A CONTRIBUICAO AO PROGRAMA DE INTEGRACAOSOCIAL - PIS E A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADESOCIAL - COFINS OS RECURSOS DESTINADOS A FUNTTEL, PARA APLICACAO NO SETOR DE TELECOMU-NICACOES AMPARO LEGAL: LEI 10 052 DE 28NOV2000 E DECRETO 3 737 DE 30JAN2001', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.11.01', 'CONTR. DAS EMPRESAS INSTALADAS NA AMAZONIA', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.11.02', 'CONTR. EMPRESAS INSTALADAS NAS DEMAIS REGIOES', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.12.01', 'CONTR.REL.ATIV.IMP.PETR.DER. GAS NAT.ALC.CARB', 'REGISTRA O VALOR DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.12.02', 'CONTR.REL.ATIV.COM.PETR.DER. GAS NAT.ALC.CARB', 'REGISTRA O VALOR DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.13.00', 'CONTRIBUICAO PARA FOMENTO DA RADIODIFUSAO PUB', 'REGISTRA A VPA DECORRENTE DA PRESTACAO DE SERVICOS DA RADIODIFUSAO PUBLICA, EXPLORADOS DIRETAMENTE PELO PODER EXECUTIVO OU OU-TORGADOS POR ESTE A ENTIDADES DE SUA ADMINISTRACAO INDIRETA. DESTINACAO LEGAL: OS RECURSOS SAO DESTINADOS AA EMPRESA BRASIL DE COMUNICACAO S/A - EBC,VINCULADA AA SECRETARIA DE COMUNICACAO SOCIAL DA PRESIDENCIA DA REPU-BLICA, COM O OBJETIVO DE PROPICIAR MEIOS PARA A MELHORIA DOS SERVICOSDE RADIODIFUSAO PUBLICA E PARA A AMPLIACAO DE SUA PENETRACAO MEDIANTEA UTILIZACAO DE SERVICOS DE TELECOMUNICACOES. AMPARO LEGAL: LEI Nº 11.652, DE 07 DE ABRIL DE 2008.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.14.01', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PRINCIPAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PRINCIPAL. ESTA PARCELA DEVE SER APLICADA EM DIVERSAS AREAS ( COMO INSTITUTOS E CENTROS DE PESQUISA, UNIVERSIDADES, FACULDADES, FNDCT, DENTRE OUTROS). AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. INCISO III, § 1º, DO ART. 8º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.14.02', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - EXCEDENTE', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - EXCEDENTE. O RESTANTE DA CONTRIBUICAO PODERA SER APLICADO AO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIAS DA INFORMACAO -PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. § 3º, DO ART.10º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.14.03', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - RESIDUAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - RESIDUAL. ESTA PARCELA RESIDUAL OCORRE NA EVENTUALIDADE DE OS INVESTIMENTOS EM ATIVIDADES DE PESQUISA E DESENVOLVIMENTO NAO ATINGIREM AQUELE MINIMO FIXADO ( 5% DO FATURAMENTO BRUTO, DESCONTADO TRIBUTOS), OS RECURSOS FINANCEIROS RESIDUAIS, ATUALIZADOS E ACRESCIDOS DE DOZE POR CENTO, DEVERAO SER APLICADOS NO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIA DA INFORMACAO - PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991 ART. 35º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.14.04', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PARCELAMENTO', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PARCELAMENTO DE DEBITO. ESTA PARCELA REFERE-SE AOS DEBITOS DECORRENTES DA NAO REALIZACAO, TOTAL OU PARCIAL, A QUALQUER TITULO, ATE O PERIODO ENCERRADO EM 31 DE DEZEMBRO DE 2003, DE APLICACOES RELATIVAS AO INVESTIMENTO COMPULSORIO ANUAL EM PESQUISA E DESENVOLVIMENTO TECNOLOGICO, PODERAO SER OBJETO DE PARCELAMENTO (DEBITOS DE INVESTIMENTO) E SERAO DESTINADAS AO FNDCT. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. ART. 37º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.15.01', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PRINCIPAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PRINCIPAL. ESTA PARCELA DEVE SER APLICADA EM DIVERSAS AREAS ( COMO INSTITUTOS E CENTROS DE PESQUISA, UNIVERSIDADES, FACULDADES, FNDCT, DENTRE OUTROS). AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. INCISO III, § 1º, DO ART. 8º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.15.02', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - EXCEDENTE', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - EXCEDENTE. O RESTANTE DA CONTRIBUICAO PODERA SER APLICADO AO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIAS DA INFORMACAO -PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. § 3º, DO ART.10º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.15.03', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - RESIDUAL', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - RESIDUAL. ESTA PARCELA RESIDUAL OCORRE NA EVENTUALIDADE DE OS INVESTIMENTOS EM ATIVIDADES DE PESQUISA E DESENVOLVIMENTO NAO ATINGIREM AQUELE MINIMO FIXADO ( 5% DO FATURAMENTO BRUTO, DESCONTADO TRIBUTOS), OS RECURSOS FINANCEIROS RESIDUAIS, ATUALIZADOS E ACRESCIDOS DE DOZE POR CENTO, DEVERAO SER APLICADOS NO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIA DA INFORMACAO - PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991 ART. 35º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.15.04', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PARCELAMENTO', 'REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PARCELAMENTO DE DEBITO. ESTA PARCELA REFERE-SE AOS DEBITOS DECORRENTES DA NAO REALIZACAO, TOTAL OU PARCIAL, A QUALQUER TITULO, ATE O PERIODO ENCERRADO EM 31 DE DEZEMBRO DE 2003, DE APLICACOES RELATIVAS AO INVESTIMENTO COMPULSORIO ANUAL EM PESQUISA E DESENVOLVIMENTO TECNOLOGICO, PODERAO SER OBJETO DE PARCELAMENTO (DEBITOS DE INVESTIMENTO) E SERAO DESTINADAS AO FNDCT. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. ART. 37º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.99.00', 'OUTRAS CONTRIBUICOES ECONOMICAS', 'COMPREENDE A VPA PROVENIENTE DAS OUTRAS CONTRIBUICOES ECONOMICAS DE NATUREZA EVENTUAL, PARA AS QUAIS NAO HA CONTA ESPECIFICA,INCLUSIVE RECURSOS ORIUNDOS DO PROGRAMA DE RECUPERACAO FISCAL E DO PARCELAMENTO ESPECIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.3.0.1.00.00', 'CONTRIBUICAO DE ILUMINACAO PUBLICA - CONSOLIDACAO', 'REGISTRA AS CONTRIBUICOES DE ILUMINACAO PUBLICA, NOS TERMOS DO ARTIGO 149-A DA CONSTITUICAO FEDERAL, ACRESCENTADO PELA EMENDA CONSTITUCIONAL Nº 39/02, SENDO FACULTADA A COBRANCA DA CONTRIBUICAO NA FATURA DE CONSUMO DE ENERGIA ELETRICA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.3.0.2.00.00', 'CONTRIBUICAO DE ILUMINACAO PUBLICA - INTRA OFSS', 'REGISTRA AS CONTRIBUICOES DE ILUMINACAO PUBLICA, NOS TERMOS DO ARTIGO 149-A DA CONSTITUICAO FEDERAL, ACRESCENTADO PELA EMENDA CONSTITUCIONAL Nº 39/02, SENDO FACULTADA A COBRANCA DA CONTRIBUICAO NA FATURA DE CONSUMO DE ENERGIA ELETRICA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.3.0.4.00.00', 'CONTRIBUICAO DE ILUMINACAO PUBLICA - INTER OFSS - ESTADO', 'REGISTRA AS CONTRIBUICOES DE ILUMINACAO PUBLICA, NOS TERMOS DO ARTIGO 149-A DA CONSTITUICAO FEDERAL, ACRESCENTADO PELA EMENDA CONSTITUCIONAL Nº 39/02, SENDO FACULTADA A COBRANCA DA CONTRIBUICAO NA FATURA DE CONSUMO DE ENERGIA ELETRICA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.3.0.5.00.00', 'CONTRIBUICAO DE ILUMINACAO PUBLICA - INTER OFSS - MUNICIPIO', 'REGISTRA AS CONTRIBUICOES DE ILUMINACAO PUBLICA, NOS TERMOS DO ARTIGO 149-A DA CONSTITUICAO FEDERAL, ACRESCENTADO PELA EMENDA CONSTITUCIONAL Nº 39/02, SENDO FACULTADA A COBRANCA DA CONTRIBUICAO NA FATURA DE CONSUMO DE ENERGIA ELETRICA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.4.0.1.00.00', 'CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENINTES DE CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS.COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.4.0.2.00.00', 'CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS - INTRA OFSS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENINTES DE CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.4.0.4.00.00', 'CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENINTES DE CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.4.0.5.00.00', 'CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENINTES DE CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.01.00', 'VENDA DE ESTOQUE PROPRIO - PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE PROPRIO - NO PAIS. SERA REGISTRADA NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.02.00', 'VENDA DE ESTOQUE PROPRIO - EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE PROPRIO - NO EXTERIOR. SERA REGISTRADA NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.03.00', 'VENDA DE ESTOQUES ESTRATEGICOS', 'REGISTRA O VALOR DA VPA DAS ENTIDADES COMERCIAIS COM A VENDA DE MERCADORIAS DE ESTOQUE ESTRATEGICO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.04.00', 'VENDA DE ESTOQUES ESPECIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE DE PROGRAMAS ESPECIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.05.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.06.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR - MDA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR, ADQUIRIDOS COM RECURSOS DO MDA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.07.00', 'VENDA DE ESTOQUES REGULADORES - PGPM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES REGULADORES DO PROGRAMA DE GARANTIA DE PRECO MINIMO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.08.00', 'VENDA DE ESTOQUES - ABASTECIMENTO SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.09.00', 'VENDA DE ESTOQUES EM CONSIGNACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS EM CONSIGNACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.10.00', 'VENDA DE ESTOQUES POR ATACADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES POR ATACADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.11.00', 'VENDA DE ESTOQUE DE PRODUCAO VEGETAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LAVOURAS PERMANENTES, TEMPORARIAS E ESPONTANEAS (OU NATIVAS), SILVICULTURA E EXTRACAO DE PRODUTOS VEGETAIS, VENDA DE SEMENTES, MUDAS OU ASSEMELHADOS, DESDE QUE REALIZADAS DIRETAMENTE PELO PRODUTOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.12.00', 'VENDA DE ESTOQUE DE PRODUCAO ANIMAL E DERIVADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRODUCAO ANIMAL E DERIVADOS,DECORRENTES DE ATIVIDADES DE EXPLORACAO ECONOMICA DE: A) PECUARIA DE GRANDE PORTE - BOVINOS, BUFALINOS, EQUINOS E OUTROS(INCLUSIVE LEITE, CARNE E COURO); B) PECUARIA DE MEDIO PORTE - OVINOS, CAPRINOS, SUINOS E OUTROS (INCLUSIVE LA, CARNE E PELES); C) AVES E ANIMAIS DE PEQUENO PORTE (INCLUSIVE OVOS, MEL, CERA E CASULOS DO BICHO DA SEDA); D) CACA E PESCA. ESTAO INCLUIDAS NESSES TITULOS APENAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DE ATIVIDADES DE BE-NEFICIAMENTO OU TRANSFORMACAO OCORRIDAS EM INSTALACOES NOS PROPRIOSESTABELECIMENTOS. AS VARIACOES PATRIMONIAIS AUMENTATIVAS ORIUNDAS DE ATIVIDADES INDUSTRIAIS DEDICADAS A PRODUCAO DE ALIMENTOS (MATADOUROS, FABRICA DE LATICINIOS,ETC.)SAO CLASSIFICADAS EM RECEITA DA INDUSTRIA DE TRANSFORMACAO, BEM COMO SECAGEM, CURTIMENTO, OUTRAS PREPARACOES DE COUROS E PELES, ETC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.13.00', 'VENDA DE MEDICAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIO VAREJISTA E ATACADISTA DE MEDICAMENTOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.14.00', 'VENDA DE LIVROS PERIOD.MAT.ESC.E PUBLICID.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DE LIVROS, PERIODICOS, MATERIAL ESCOLAR E DE PUBLICIDADE, VAREJISTA OU ATACADISTA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.15.00', 'VENDA DE PRODUTOS AGROPECUARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIO VAREJISTA E ATACADISTA DE PRODUTOS AGROPECUARIOS. ESTAO INCLUIDAS NESSE ITEM AS VPA DECORRENTES DA COMERCIALIZACAO DE PRODUTOS ADQUIRIDOS COM GARANTIA DE PRECO MINIMO E PARA A FORMACAO DE ESTOQUES REGULADORES E DISTRIBUICAO DE GENEROS ALIMENTICIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.16.00', 'VENDA DE FARDAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMERCIALIZACAO DE PRODUTOS DESTINADOS A VESTIMENTAS, UNIFORMES E /OU FARDAS A DETERMINADAS CATEGORIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.17.00', 'VENDAS MONOPOLIZADAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DE MERCADORIAS MONOPOLIZADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.01.00', 'VENDA DE ESTOQUE PROPRIO - PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE PROPRIO - NO PAIS. SERA REGISTRADA NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.02.00', 'VENDA DE ESTOQUE PROPRIO - EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE PROPRIO - NO EXTERIOR. SERA REGISTRADA NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.03.00', 'VENDA DE ESTOQUES ESTRATEGICOS', 'REGISTRA O VALOR DA VPA DAS ENTIDADES COMERCIAIS COM A VENDA DE MERCADORIAS DE ESTOQUE ESTRATEGICO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.04.00', 'VENDA DE ESTOQUES ESPECIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE DE PROGRAMAS ESPECIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.05.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.06.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR - MDA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR, ADQUIRIDOS COM RECURSOS DO MDA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.07.00', 'VENDA DE ESTOQUES REGULADORES - PGPM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES REGULADORES DO PROGRAMA DE GARANTIA DE PRECO MINIMO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.08.00', 'VENDA DE ESTOQUES - ABASTECIMENTO SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.09.00', 'VENDA DE ESTOQUES EM CONSIGNACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS EM CONSIGNACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.10.00', 'VENDA DE ESTOQUES POR ATACADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES POR ATACADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.11.00', 'VENDA DE ESTOQUE DE PRODUCAO VEGETAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LAVOURAS PERMANENTES, TEMPORARIAS E ESPONTANEAS (OU NATIVAS), SILVICULTURA E EXTRACAO DE PRODUTOS VEGETAIS, VENDA DE SEMENTES, MUDAS OU ASSEMELHADOS, DESDE QUE REALIZADAS DIRETAMENTE PELO PRODUTOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.12.00', 'VENDA DE ESTOQUE DE PRODUCAO ANIMAL E DERIVADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRODUCAO ANIMAL E DERIVADOS,DECORRENTES DE ATIVIDADES DE EXPLORACAO ECONOMICA DE: A) PECUARIA DE GRANDE PORTE - BOVINOS, BUFALINOS, EQUINOS E OUTROS(INCLUSIVE LEITE, CARNE E COURO); B) PECUARIA DE MEDIO PORTE - OVINOS, CAPRINOS, SUINOS E OUTROS (INCLUSIVE LA, CARNE E PELES); C) AVES E ANIMAIS DE PEQUENO PORTE (INCLUSIVE OVOS, MEL, CERA E CASULOS DO BICHO DA SEDA); D) CACA E PESCA. ESTAO INCLUIDAS NESSES TITULOS APENAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DE ATIVIDADES DE BE-NEFICIAMENTO OU TRANSFORMACAO OCORRIDAS EM INSTALACOES NOS PROPRIOSESTABELECIMENTOS. AS VARIACOES PATRIMONIAIS AUMENTATIVAS ORIUNDAS DE ATIVIDADES INDUSTRIAIS DEDICADAS A PRODUCAO DE ALIMENTOS (MATADOUROS, FABRICA DE LATICINIOS,ETC.)SAO CLASSIFICADAS EM RECEITA DA INDUSTRIA DE TRANSFORMACAO, BEM COMO SECAGEM, CURTIMENTO, OUTRAS PREPARACOES DE COUROS E PELES, ETC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.13.00', 'VENDA DE MEDICAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIO VAREJISTA E ATACADISTA DE MEDICAMENTOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.14.00', 'VENDA DE LIVROS PERIOD.MAT.ESC.E PUBLICID.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DE LIVROS, PERIODICOS, MATERIAL ESCOLAR E DE PUBLICIDADE, VAREJISTA OU ATACADISTA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.15.00', 'VENDA DE PRODUTOS AGROPECUARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIO VAREJISTA E ATACADISTA DE PRODUTOS AGROPECUARIOS. ESTAO INCLUIDAS NESSE ITEM AS VPA DECORRENTES DA COMERCIALIZACAO DE PRODUTOS ADQUIRIDOS COM GARANTIA DE PRECO MINIMO E PARA A FORMACAO DE ESTOQUES REGULADORES E DISTRIBUICAO DE GENEROS ALIMENTICIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.16.00', 'VENDA DE FARDAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMERCIALIZACAO DE PRODUTOS DESTINADOS A VESTIMENTAS, UNIFORMES E /OU FARDAS A DETERMINADAS CATEGORIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.17.00', 'VENDAS MONOPOLIZADAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DE MERCADORIAS MONOPOLIZADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.01.00', 'VENDA DE ESTOQUE PROPRIO - PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE PROPRIO - NO PAIS. SERA REGISTRADA NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.02.00', 'VENDA DE ESTOQUE PROPRIO - EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE PROPRIO - NO EXTERIOR. SERA REGISTRADA NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.03.00', 'VENDA DE ESTOQUES ESTRATEGICOS', 'REGISTRA O VALOR DA VPA DAS ENTIDADES COMERCIAIS COM A VENDA DE MERCADORIAS DE ESTOQUE ESTRATEGICO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.04.00', 'VENDA DE ESTOQUES ESPECIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE DE PROGRAMAS ESPECIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.05.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.06.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR - MDA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR, ADQUIRIDOS COM RECURSOS DO MDA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.07.00', 'VENDA DE ESTOQUES REGULADORES - PGPM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES REGULADORES DO PROGRAMA DE GARANTIA DE PRECO MINIMO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.08.00', 'VENDA DE ESTOQUES - ABASTECIMENTO SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.09.00', 'VENDA DE ESTOQUES EM CONSIGNACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS EM CONSIGNACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.10.00', 'VENDA DE ESTOQUES POR ATACADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES POR ATACADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.11.00', 'VENDA DE ESTOQUE DE PRODUCAO VEGETAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LAVOURAS PERMANENTES, TEMPORARIAS E ESPONTANEAS (OU NATIVAS), SILVICULTURA E EXTRACAO DE PRODUTOS VEGETAIS, VENDA DE SEMENTES, MUDAS OU ASSEMELHADOS, DESDE QUE REALIZADAS DIRETAMENTE PELO PRODUTOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.12.00', 'VENDA DE ESTOQUE DE PRODUCAO ANIMAL E DERIVADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRODUCAO ANIMAL E DERIVADOS,DECORRENTES DE ATIVIDADES DE EXPLORACAO ECONOMICA DE: A) PECUARIA DE GRANDE PORTE - BOVINOS, BUFALINOS, EQUINOS E OUTROS(INCLUSIVE LEITE, CARNE E COURO); B) PECUARIA DE MEDIO PORTE - OVINOS, CAPRINOS, SUINOS E OUTROS (INCLUSIVE LA, CARNE E PELES); C) AVES E ANIMAIS DE PEQUENO PORTE (INCLUSIVE OVOS, MEL, CERA E CASULOS DO BICHO DA SEDA); D) CACA E PESCA. ESTAO INCLUIDAS NESSES TITULOS APENAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DE ATIVIDADES DE BE-NEFICIAMENTO OU TRANSFORMACAO OCORRIDAS EM INSTALACOES NOS PROPRIOSESTABELECIMENTOS. AS VARIACOES PATRIMONIAIS AUMENTATIVAS ORIUNDAS DE ATIVIDADES INDUSTRIAIS DEDICADAS A PRODUCAO DE ALIMENTOS (MATADOUROS, FABRICA DE LATICINIOS,ETC.)SAO CLASSIFICADAS EM RECEITA DA INDUSTRIA DE TRANSFORMACAO, BEM COMO SECAGEM, CURTIMENTO, OUTRAS PREPARACOES DE COUROS E PELES, ETC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.13.00', 'VENDA DE MEDICAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIO VAREJISTA E ATACADISTA DE MEDICAMENTOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.14.00', 'VENDA DE LIVROS PERIOD.MAT.ESC.E PUBLICID.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DE LIVROS, PERIODICOS, MATERIAL ESCOLAR E DE PUBLICIDADE, VAREJISTA OU ATACADISTA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.15.00', 'VENDA DE PRODUTOS AGROPECUARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIO VAREJISTA E ATACADISTA DE PRODUTOS AGROPECUARIOS. ESTAO INCLUIDAS NESSE ITEM AS VPA DECORRENTES DA COMERCIALIZACAO DE PRODUTOS ADQUIRIDOS COM GARANTIA DE PRECO MINIMO E PARA A FORMACAO DE ESTOQUES REGULADORES E DISTRIBUICAO DE GENEROS ALIMENTICIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.16.00', 'VENDA DE FARDAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMERCIALIZACAO DE PRODUTOS DESTINADOS A VESTIMENTAS, UNIFORMES E /OU FARDAS A DETERMINADAS CATEGORIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.17.00', 'VENDAS MONOPOLIZADAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DE MERCADORIAS MONOPOLIZADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.01.00', 'VENDA DE ESTOQUE PROPRIO - PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE PROPRIO - NO PAIS. SERA REGISTRADA NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.02.00', 'VENDA DE ESTOQUE PROPRIO - EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE PROPRIO - NO EXTERIOR. SERA REGISTRADA NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.03.00', 'VENDA DE ESTOQUES ESTRATEGICOS', 'REGISTRA O VALOR DA VPA DAS ENTIDADES COMERCIAIS COM A VENDA DE MERCADORIAS DE ESTOQUE ESTRATEGICO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.04.00', 'VENDA DE ESTOQUES ESPECIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE DE PROGRAMAS ESPECIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.05.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.06.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR - MDA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR, ADQUIRIDOS COM RECURSOS DO MDA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.07.00', 'VENDA DE ESTOQUES REGULADORES - PGPM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES REGULADORES DO PROGRAMA DE GARANTIA DE PRECO MINIMO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.08.00', 'VENDA DE ESTOQUES - ABASTECIMENTO SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.09.00', 'VENDA DE ESTOQUES EM CONSIGNACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS EM CONSIGNACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.10.00', 'VENDA DE ESTOQUES POR ATACADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES POR ATACADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.11.00', 'VENDA DE ESTOQUE DE PRODUCAO VEGETAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LAVOURAS PERMANENTES, TEMPORARIAS E ESPONTANEAS (OU NATIVAS), SILVICULTURA E EXTRACAO DE PRODUTOS VEGETAIS, VENDA DE SEMENTES, MUDAS OU ASSEMELHADOS, DESDE QUE REALIZADAS DIRETAMENTE PELO PRODUTOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.12.00', 'VENDA DE ESTOQUE DE PRODUCAO ANIMAL E DERIVADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRODUCAO ANIMAL E DERIVADOS,DECORRENTES DE ATIVIDADES DE EXPLORACAO ECONOMICA DE: A) PECUARIA DE GRANDE PORTE - BOVINOS, BUFALINOS, EQUINOS E OUTROS(INCLUSIVE LEITE, CARNE E COURO); B) PECUARIA DE MEDIO PORTE - OVINOS, CAPRINOS, SUINOS E OUTROS (INCLUSIVE LA, CARNE E PELES); C) AVES E ANIMAIS DE PEQUENO PORTE (INCLUSIVE OVOS, MEL, CERA E CASULOS DO BICHO DA SEDA); D) CACA E PESCA. ESTAO INCLUIDAS NESSES TITULOS APENAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DE ATIVIDADES DE BE-NEFICIAMENTO OU TRANSFORMACAO OCORRIDAS EM INSTALACOES NOS PROPRIOSESTABELECIMENTOS. AS VARIACOES PATRIMONIAIS AUMENTATIVAS ORIUNDAS DE ATIVIDADES INDUSTRIAIS DEDICADAS A PRODUCAO DE ALIMENTOS (MATADOUROS, FABRICA DE LATICINIOS,ETC.)SAO CLASSIFICADAS EM RECEITA DA INDUSTRIA DE TRANSFORMACAO, BEM COMO SECAGEM, CURTIMENTO, OUTRAS PREPARACOES DE COUROS E PELES, ETC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.13.00', 'VENDA DE MEDICAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIO VAREJISTA E ATACADISTA DE MEDICAMENTOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.14.00', 'VENDA DE LIVROS PERIOD.MAT.ESC.E PUBLICID.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DE LIVROS, PERIODICOS, MATERIAL ESCOLAR E DE PUBLICIDADE, VAREJISTA OU ATACADISTA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.15.00', 'VENDA DE PRODUTOS AGROPECUARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIO VAREJISTA E ATACADISTA DE PRODUTOS AGROPECUARIOS. ESTAO INCLUIDAS NESSE ITEM AS VPA DECORRENTES DA COMERCIALIZACAO DE PRODUTOS ADQUIRIDOS COM GARANTIA DE PRECO MINIMO E PARA A FORMACAO DE ESTOQUES REGULADORES E DISTRIBUICAO DE GENEROS ALIMENTICIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.16.00', 'VENDA DE FARDAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMERCIALIZACAO DE PRODUTOS DESTINADOS A VESTIMENTAS, UNIFORMES E /OU FARDAS A DETERMINADAS CATEGORIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.17.00', 'VENDAS MONOPOLIZADAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DE MERCADORIAS MONOPOLIZADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.01.00', '(-) VENDAS CANCELADAS E DEVOLUCOES', 'REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE MERCADORIAS DE ENTIDADES COMERCIAIS REFERENTES A CANCELAMENTO DE VENDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.02.00', '(-) ABATIMENTOS', 'REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NAS MERCADORIAS ENTREGUES OU DEFEITOS ORIUNDOS DO TRANSPORTE OU DESEMBARQUE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.03.00', '(-) DESCONTOS INCONDICIONAIS', 'REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.06.00', '(-) ICMS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO ICMS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.07.00', '(-) PIS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO PIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.08.00', '(-) PASEP', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.09.00', '(-) COFINS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES A COFINS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.2.01.00', '(-) VENDAS CANCELADAS E DEVOLUCOES', 'REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE MERCADORIAS DE ENTIDADES COMERCIAIS REFERENTES A CANCELAMENTO DE VENDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.2.02.00', '(-) ABATIMENTOS', 'REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NAS MERCADORIAS ENTREGUES OU DEFEITOS ORIUNDOS DO TRANSPORTE OU DESEMBARQUE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.2.03.00', '(-) DESCONTOS INCONDICIONAIS', 'REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.2.06.00', '(-) ICMS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO ICMS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.2.07.00', '(-) PIS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO PIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.2.08.00', '(-) PASEP', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.2.09.00', '(-) CONFINS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES A COFINS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.2.99.00', '(-) OUTRAS DEDUCOES DE VENDAS', 'REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE MERCADORIAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.4.01.00', '(-) VENDAS CANCELADAS E DEVOLUCOES', 'REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE MERCADORIAS DE ENTIDADES COMERCIAIS REFERENTES A CANCELAMENTO DE VENDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.4.02.00', '(-) ABATIMENTOS', 'REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NAS MERCADORIAS ENTREGUES OU DEFEITOS ORIUNDOS DO TRANSPORTE OU DESEMBARQUE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.4.03.00', '(-) DESCONTOS INCONDICIONAIS', 'REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.4.06.00', '(-) ICMS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO ICMS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.4.07.00', '(-) PIS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO PIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.4.08.00', '(-) PASEP', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.4.09.00', '(-) CONFINS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES A COFINS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.4.99.00', '(-) OUTRAS DEDUCOES DE VENDAS', 'REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE MERCADORIAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.5.01.00', '(-) VENDAS CANCELADAS E DEVOLUCOES', 'REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE MERCADORIAS DE ENTIDADES COMERCIAIS REFERENTES A CANCELAMENTO DE VENDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.5.02.00', '(-) ABATIMENTOS', 'REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NAS MERCADORIAS ENTREGUES OU DEFEITOS ORIUNDOS DO TRANSPORTE OU DESEMBARQUE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.5.03.00', '(-) DESCONTOS INCONDICIONAIS', 'REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.5.06.00', '(-) ICMS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO ICMS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.5.07.00', '(-) PIS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO PIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.5.08.00', '(-) PASEP', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.5.09.00', '(-) CONFINS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES A COFINS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.5.99.00', '(-) OUTRAS DEDUCOES DE VENDAS', 'REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE MERCADORIAS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.01.00', 'VENDA DE ESTOQUE PROPRIO - PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE PROPRIO - NO PAIS.NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.02.00', 'VENDA DE ESTOQUE PROPRIO - EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE PROPRIO - NO EXTERIOR.NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.03.00', 'VENDA DE ESTOQUES ESTRATEGICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE ESTRATEGICO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.04.00', 'VENDA DE ESTOQUES ESPECIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE DE PROGRAMAS ESPECIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.05.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.06.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR - MDA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR, ADQUIRIDOS COM RECURSOS DO MDA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.07.00', 'VENDA DE ESTOQUES REGULADORES - PGPM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES REGULADORES DO PROGRAMA DE GARANTIA DE PRECO MINIMO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.08.00', 'VENDA DE ESTOQUES - ABASTECIMENTO SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.09.00', 'VENDA DE ESTOQUES EM CONSIGNACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS EM CONSIGNACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.10.00', 'VENDA DE ESTOQUES POR ATACADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES POR ATACADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.11.00', 'VENDA DE ESTOQUE DE PRODUCAO VEGETAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LAVOURAS PERMANENTES, TEMPORARIAS E ESPONTANEAS (OU NATIVAS), SILVICULTURA E EXTRACAO DE PRODUTOS VEGETAIS, VENDA DE SEMENTES, MUDAS OU ASSEMELHADOS, DESDE QUE REALIZADAS DIRETAMENTE PELO PRODUTOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.12.00', 'VENDA DE ESTOQUE DE PRODUCAO ANIMAL E DERIVADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRODUCAO ANIMAL E DERIVADOS,DECORRENTES DE ATIVIDADES DE EXPLORACAO ECONOMICA DE: A) PECUARIA DE GRANDE PORTE - BOVINOS, BUFALINOS, EQUINOS E OUTROS(INCLUSIVE LEITE, CARNE E COURO); B) PECUARIA DE MEDIO PORTE - OVINOS, CAPRINOS, SUINOS E OUTROS (INCLUSIVE LA, CARNE E PELES); C) AVES E ANIMAIS DE PEQUENO PORTE (INCLUSIVE OVOS, MEL, CERA E CASULOS DO BICHO DA SEDA); D) CACA E PESCA. ESTAO INCLUIDAS NESSES TITULOS APENAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DE ATIVIDADES DE BE-NEFICIAMENTO OU TRANSFORMACAO OCORRIDAS EM INSTALACOES NOS PROPRIOSESTABELECIMENTOS. AS VARIACOES PATRIMONIAIS AUMENTATIVAS ORIUNDAS DE ATIVIDADES INDUSTRIAIS DEDICADAS A PRODUCAO DE ALIMENTOS (MATADOUROS, FABRICA DE LATICINIOS,ETC.)SAO CLASSIFICADAS EM RECEITA DA INDUSTRIA DE TRANSFORMACAO, BEM COMO SECAGEM, CURTIMENTO, OUTRAS PREPARACOES DE COUROS E PELES, ETC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.13.00', 'VENDA DE PRODUTOS DA INDUSTRIA EXTRATIVA MINERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXTRACAO MINERAL, PROVENIENTES DAS ATIVIDADES INDUSTRIAIS ASSIM DEFINIDAS PELA FUNDACAO INSTITUTO BRASILEIRO DE GEOGRAFIA E ESTATISTICA - IBGE. FATO GERADOR: ATIVIDADES LIGADAS AA INDUSTRIA EXTRATIVA MINERAL, CONF.CLASSIFICACAO DO IBGE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.14.01', 'VENDA DE PRODUTOS DA INDUSTRIA MECANICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES INDUSTRIA MECANICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.14.02', 'VENDA DE PRODUTOS DA INDUSTRIA QUIMICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DA INDUSTRIA QUIMICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.14.03', 'VENDA DE PRODUTOS DA INDUSTRIA DE PROD. FARMOQUIMICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS ORIGINARIOS DA INDUSTRIA DE PRODUTOS FARMOQUIMICOS. FATO GERADOR: ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS FARMOQUIMICOS, CONFORME CLASSIFICACAO DO IBGE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.14.04', 'VENDA DE PRODUTOS DA INDUSTRIA DE PRODUTOS ALIMENTARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA DE PRODUTOS ALIMENTARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.14.05', 'VENDA DE PRODUTOS DA INDUSTRIA DE BEBIDAS E DESTILADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA DE BEBIDAS E DESTILADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.14.06', 'VENDA DE PRODUTOS DA INDUSTRIA EDITORIAL E GRAFICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA EDITORIAL E GRAFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.14.07', 'VENDA DE PRODUTOS DA INDUSTRIA VETERINARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS VETERINARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.14.08', 'VENDA DE PRODUTOS DA INDUSTRIA FARMACEUTICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS FARMACEUTICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.15.00', 'VENDAS MONOPOLIZADAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DDE PRODUTOS MONOPOLIZADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.01.00', 'VENDA DE ESTOQUE PROPRIO - PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE PROPRIO - NO PAIS.NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.02.00', 'VENDA DE ESTOQUE PROPRIO - EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE PROPRIO - NO EXTERIOR.NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.03.00', 'VENDA DE ESTOQUES ESTRATEGICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE ESTRATEGICO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.04.00', 'VENDA DE ESTOQUES ESPECIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE DE PROGRAMAS ESPECIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.05.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.06.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR - MDA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR, ADQUIRIDOS COM RECURSOS DO MDA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.07.00', 'VENDA DE ESTOQUES REGULADORES - PGPM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES REGULADORES DO PROGRAMA DE GARANTIA DE PRECO MINIMO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.08.00', 'VENDA DE ESTOQUES - ABASTECIMENTO SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.09.00', 'VENDA DE ESTOQUES EM CONSIGNACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS EM CONSIGNACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.10.00', 'VENDA DE ESTOQUES POR ATACADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES POR ATACADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.11.00', 'VENDA DE ESTOQUE DE PRODUCAO VEGETAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LAVOURAS PERMANENTES, TEMPORARIAS E ESPONTANEAS (OU NATIVAS), SILVICULTURA E EXTRACAO DE PRODUTOS VEGETAIS, VENDA DE SEMENTES, MUDAS OU ASSEMELHADOS, DESDE QUE REALIZADAS DIRETAMENTE PELO PRODUTOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.12.00', 'VENDA DE ESTOQUE DE PRODUCAO ANIMAL E DERIVADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRODUCAO ANIMAL E DERIVADOS,DECORRENTES DE ATIVIDADES DE EXPLORACAO ECONOMICA DE: A) PECUARIA DE GRANDE PORTE - BOVINOS, BUFALINOS, EQUINOS E OUTROS(INCLUSIVE LEITE, CARNE E COURO); B) PECUARIA DE MEDIO PORTE - OVINOS, CAPRINOS, SUINOS E OUTROS (INCLUSIVE LA, CARNE E PELES); C) AVES E ANIMAIS DE PEQUENO PORTE (INCLUSIVE OVOS, MEL, CERA E CASULOS DO BICHO DA SEDA); D) CACA E PESCA. ESTAO INCLUIDAS NESSES TITULOS APENAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DE ATIVIDADES DE BE-NEFICIAMENTO OU TRANSFORMACAO OCORRIDAS EM INSTALACOES NOS PROPRIOSESTABELECIMENTOS. AS VARIACOES PATRIMONIAIS AUMENTATIVAS ORIUNDAS DE ATIVIDADES INDUSTRIAIS DEDICADAS A PRODUCAO DE ALIMENTOS (MATADOUROS, FABRICA DE LATICINIOS,ETC.)SAO CLASSIFICADAS EM RECEITA DA INDUSTRIA DE TRANSFORMACAO, BEM COMO SECAGEM, CURTIMENTO, OUTRAS PREPARACOES DE COUROS E PELES, ETC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.13.00', 'VENDA DE PRODUTOS DA INDUSTRIA EXTRATIVA MINERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXTRACAO MINERAL, PROVENIENTES DAS ATIVIDADES INDUSTRIAIS ASSIM DEFINIDAS PELA FUNDACAO INSTITUTO BRASILEIRO DE GEOGRAFIA E ESTATISTICA - IBGE. FATO GERADOR: ATIVIDADES LIGADAS AA INDUSTRIA EXTRATIVA MINERAL, CONF.CLASSIFICACAO DO IBGE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.14.01', 'VENDA DE PRODUTOS DA INDUSTRIA MECANICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES INDUSTRIA MECANICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.14.02', 'VENDA DE PRODUTOS DA INDUSTRIA QUIMICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DA INDUSTRIA QUIMICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.14.03', 'VENDA DE PRODUTOS DA INDUSTRIA DE PROD. FARMOQUIMICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS ORIGINARIOS DA INDUSTRIA DE PRODUTOS FARMOQUIMICOS. FATO GERADOR: ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS FARMOQUIMICOS, CONFORME CLASSIFICACAO DO IBGE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.14.04', 'VENDA DE PRODUTOS DA INDUSTRIA DE PRODUTOS ALIMENTARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA DE PRODUTOS ALIMENTARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.14.05', 'VENDA DE PRODUTOS DA INDUSTRIA DE BEBIDAS E DESTILADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA DE BEBIDAS E DESTILADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.14.06', 'VENDA DE PRODUTOS DA INDUSTRIA EDITORIAL E GRAFICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA EDITORIAL E GRAFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.14.07', 'VENDA DE PRODUTOS DA INDUSTRIA VETERINARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS VETERINARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.14.08', 'VENDA DE PRODUTOS DA INDUSTRIA FARMACEUTICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS FARMACEUTICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.15.00', 'VENDAS MONOPOLIZADAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DDE PRODUTOS MONOPOLIZADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.01.00', 'VENDA DE ESTOQUE PROPRIO - PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE PROPRIO - NO PAIS.NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.02.00', 'VENDA DE ESTOQUE PROPRIO - EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE PROPRIO - NO EXTERIOR.NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.03.00', 'VENDA DE ESTOQUES ESTRATEGICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE ESTRATEGICO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.04.00', 'VENDA DE ESTOQUES ESPECIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE DE PROGRAMAS ESPECIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.05.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.06.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR - MDA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR, ADQUIRIDOS COM RECURSOS DO MDA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.07.00', 'VENDA DE ESTOQUES REGULADORES - PGPM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES REGULADORES DO PROGRAMA DE GARANTIA DE PRECO MINIMO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.08.00', 'VENDA DE ESTOQUES - ABASTECIMENTO SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.09.00', 'VENDA DE ESTOQUES EM CONSIGNACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS EM CONSIGNACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.10.00', 'VENDA DE ESTOQUES POR ATACADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES POR ATACADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.11.00', 'VENDA DE ESTOQUE DE PRODUCAO VEGETAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LAVOURAS PERMANENTES, TEMPORARIAS E ESPONTANEAS (OU NATIVAS), SILVICULTURA E EXTRACAO DE PRODUTOS VEGETAIS, VENDA DE SEMENTES, MUDAS OU ASSEMELHADOS, DESDE QUE REALIZADAS DIRETAMENTE PELO PRODUTOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.12.00', 'VENDA DE ESTOQUE DE PRODUCAO ANIMAL E DERIVADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRODUCAO ANIMAL E DERIVADOS,DECORRENTES DE ATIVIDADES DE EXPLORACAO ECONOMICA DE: A) PECUARIA DE GRANDE PORTE - BOVINOS, BUFALINOS, EQUINOS E OUTROS(INCLUSIVE LEITE, CARNE E COURO); B) PECUARIA DE MEDIO PORTE - OVINOS, CAPRINOS, SUINOS E OUTROS (INCLUSIVE LA, CARNE E PELES); C) AVES E ANIMAIS DE PEQUENO PORTE (INCLUSIVE OVOS, MEL, CERA E CASULOS DO BICHO DA SEDA); D) CACA E PESCA. ESTAO INCLUIDAS NESSES TITULOS APENAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DE ATIVIDADES DE BE-NEFICIAMENTO OU TRANSFORMACAO OCORRIDAS EM INSTALACOES NOS PROPRIOSESTABELECIMENTOS. AS VARIACOES PATRIMONIAIS AUMENTATIVAS ORIUNDAS DE ATIVIDADES INDUSTRIAIS DEDICADAS A PRODUCAO DE ALIMENTOS (MATADOUROS, FABRICA DE LATICINIOS,ETC.)SAO CLASSIFICADAS EM RECEITA DA INDUSTRIA DE TRANSFORMACAO, BEM COMO SECAGEM, CURTIMENTO, OUTRAS PREPARACOES DE COUROS E PELES, ETC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.13.00', 'VENDA DE PRODUTOS DA INDUSTRIA EXTRATIVA MINERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXTRACAO MINERAL, PROVENIENTES DAS ATIVIDADES INDUSTRIAIS ASSIM DEFINIDAS PELA FUNDACAO INSTITUTO BRASILEIRO DE GEOGRAFIA E ESTATISTICA - IBGE. FATO GERADOR: ATIVIDADES LIGADAS AA INDUSTRIA EXTRATIVA MINERAL, CONF.CLASSIFICACAO DO IBGE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.14.01', 'VENDA DE PRODUTOS DA INDUSTRIA MECANICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES INDUSTRIA MECANICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.14.02', 'VENDA DE PRODUTOS DA INDUSTRIA QUIMICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DA INDUSTRIA QUIMICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.14.03', 'VENDA DE PRODUTOS DA INDUSTRIA DE PROD. FARMOQUIMICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS ORIGINARIOS DA INDUSTRIA DE PRODUTOS FARMOQUIMICOS. FATO GERADOR: ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS FARMOQUIMICOS, CONFORME CLASSIFICACAO DO IBGE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.14.04', 'VENDA DE PRODUTOS DA INDUSTRIA DE PRODUTOS ALIMENTARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA DE PRODUTOS ALIMENTARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.14.05', 'VENDA DE PRODUTOS DA INDUSTRIA DE BEBIDAS E DESTILADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA DE BEBIDAS E DESTILADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.14.06', 'VENDA DE PRODUTOS DA INDUSTRIA EDITORIAL E GRAFICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA EDITORIAL E GRAFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.14.07', 'VENDA DE PRODUTOS DA INDUSTRIA VETERINARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS VETERINARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.14.08', 'VENDA DE PRODUTOS DA INDUSTRIA FARMACEUTICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS FARMACEUTICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.15.00', 'VENDAS MONOPOLIZADAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DDE PRODUTOS MONOPOLIZADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.01.00', 'VENDA DE ESTOQUE PROPRIO - PAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE PROPRIO - NO PAIS.NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.02.00', 'VENDA DE ESTOQUE PROPRIO - EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE PROPRIO - NO EXTERIOR.NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.03.00', 'VENDA DE ESTOQUES ESTRATEGICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE ESTRATEGICO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.04.00', 'VENDA DE ESTOQUES ESPECIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE DE PROGRAMAS ESPECIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.05.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.06.00', 'VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR - MDA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR, ADQUIRIDOS COM RECURSOS DO MDA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.07.00', 'VENDA DE ESTOQUES REGULADORES - PGPM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES REGULADORES DO PROGRAMA DE GARANTIA DE PRECO MINIMO DO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.08.00', 'VENDA DE ESTOQUES - ABASTECIMENTO SOCIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES PARA ABASTECIMENTO SOCIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.09.00', 'VENDA DE ESTOQUES EM CONSIGNACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS EM CONSIGNACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.10.00', 'VENDA DE ESTOQUES POR ATACADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES POR ATACADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.11.00', 'VENDA DE ESTOQUE DE PRODUCAO VEGETAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LAVOURAS PERMANENTES, TEMPORARIAS E ESPONTANEAS (OU NATIVAS), SILVICULTURA E EXTRACAO DE PRODUTOS VEGETAIS, VENDA DE SEMENTES, MUDAS OU ASSEMELHADOS, DESDE QUE REALIZADAS DIRETAMENTE PELO PRODUTOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.12.00', 'VENDA DE ESTOQUE DE PRODUCAO ANIMAL E DERIVADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRODUCAO ANIMAL E DERIVADOS,DECORRENTES DE ATIVIDADES DE EXPLORACAO ECONOMICA DE: A) PECUARIA DE GRANDE PORTE - BOVINOS, BUFALINOS, EQUINOS E OUTROS(INCLUSIVE LEITE, CARNE E COURO); B) PECUARIA DE MEDIO PORTE - OVINOS, CAPRINOS, SUINOS E OUTROS (INCLUSIVE LA, CARNE E PELES); C) AVES E ANIMAIS DE PEQUENO PORTE (INCLUSIVE OVOS, MEL, CERA E CASULOS DO BICHO DA SEDA); D) CACA E PESCA. ESTAO INCLUIDAS NESSES TITULOS APENAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DE ATIVIDADES DE BE-NEFICIAMENTO OU TRANSFORMACAO OCORRIDAS EM INSTALACOES NOS PROPRIOSESTABELECIMENTOS. AS VARIACOES PATRIMONIAIS AUMENTATIVAS ORIUNDAS DE ATIVIDADES INDUSTRIAIS DEDICADAS A PRODUCAO DE ALIMENTOS (MATADOUROS, FABRICA DE LATICINIOS,ETC.)SAO CLASSIFICADAS EM RECEITA DA INDUSTRIA DE TRANSFORMACAO, BEM COMO SECAGEM, CURTIMENTO, OUTRAS PREPARACOES DE COUROS E PELES, ETC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.13.00', 'VENDA DE PRODUTOS DA INDUSTRIA EXTRATIVA MINERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXTRACAO MINERAL, PROVENIENTES DAS ATIVIDADES INDUSTRIAIS ASSIM DEFINIDAS PELA FUNDACAO INSTITUTO BRASILEIRO DE GEOGRAFIA E ESTATISTICA - IBGE. FATO GERADOR: ATIVIDADES LIGADAS AA INDUSTRIA EXTRATIVA MINERAL, CONF.CLASSIFICACAO DO IBGE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.14.01', 'VENDA DE PRODUTOS DA INDUSTRIA MECANICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES INDUSTRIA MECANICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.14.02', 'VENDA DE PRODUTOS DA INDUSTRIA QUIMICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DA INDUSTRIA QUIMICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.14.03', 'VENDA DE PRODUTOS DA INDUSTRIA DE PROD. FARMOQUIMICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS ORIGINARIOS DA INDUSTRIA DE PRODUTOS FARMOQUIMICOS. FATO GERADOR: ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS FARMOQUIMICOS, CONFORME CLASSIFICACAO DO IBGE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.14.04', 'VENDA DE PRODUTOS DA INDUSTRIA DE PRODUTOS ALIMENTARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA DE PRODUTOS ALIMENTARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.14.05', 'VENDA DE PRODUTOS DA INDUSTRIA DE BEBIDAS E DESTILADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA DE BEBIDAS E DESTILADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.14.06', 'VENDA DE PRODUTOS DA INDUSTRIA EDITORIAL E GRAFICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA EDITORIAL E GRAFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.14.07', 'VENDA DE PRODUTOS DA INDUSTRIA VETERINARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS VETERINARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.14.08', 'VENDA DE PRODUTOS DA INDUSTRIA FARMACEUTICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS FARMACEUTICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.15.00', 'VENDAS MONOPOLIZADAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DDE PRODUTOS MONOPOLIZADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.01.00', '(-) VENDAS CANCELADAS E DEVOLUCOES', 'REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE PRODUTOS REFERENTES A CANCELAMENTO DE VENDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.02.00', '(-) ABATIMENTOS', 'REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NAS PRODUTOS ENTREGUES OU DEFEITOS ORIUNDOS DO TRANSPORTE OU DESEMBARQUE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.03.00', '(-) DESCONTOS INCONDICIONAIS', 'REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.04.00', '(-) IPI', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO IPI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.05.00', '(-) ISS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO ISS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.06.00', '(-) ICMS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO ICMS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.07.00', '(-) PIS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO PIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.08.00', '(-) PASEP', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.09.00', '(-) COFINS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES A COFINS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.99.00', '(-) OUTRAS DEDUCOES DE VENDAS', 'REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE PRODUTOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.2.01.00', '(-) VENDAS CANCELADAS E DEVOLUCOES', 'REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE PRODUTOS REFERENTES A CANCELAMENTO DE VENDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.2.02.00', '(-) ABATIMENTOS', 'REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NAS PRODUTOS ENTREGUES OU DEFEITOS ORIUNDOS DO TRANSPORTE OU DESEMBARQUE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.2.03.00', '(-) DESCONTOS INCONDICIONAIS', 'REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.2.04.00', '(-) IPI', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO IPI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.2.05.00', '(-) ISS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO ISS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.2.06.00', '(-) ICMS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO ICMS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.2.07.00', '(-) PIS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO PIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.2.08.00', '(-) PASEP', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.2.09.00', '(-) CONFINS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES A COFINS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.2.99.00', '(-) OUTRAS DEDUCOES DE VENDAS', 'REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE PRODUTOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.4.01.00', '(-) VENDAS CANCELADAS E DEVOLUCOES', 'REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE PRODUTOS REFERENTES A CANCELAMENTO DE VENDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.4.02.00', '(-) ABATIMENTOS', 'REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NAS PRODUTOS ENTREGUES OU DEFEITOS ORIUNDOS DO TRANSPORTE OU DESEMBARQUE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.4.03.00', '(-) DESCONTOS INCONDICIONAIS', 'REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.4.04.00', '(-) IPI', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO IPI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.4.05.00', '(-) ISS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO ISS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.4.06.00', '(-) ICMS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO ICMS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.4.07.00', '(-) PIS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO PIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.4.08.00', '(-) PASEP', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.4.09.00', '(-) COFINS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES A COFINS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.4.99.00', '(-) OUTRAS DEDUCOES DE VENDAS', 'REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE PRODUTOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.5.01.00', '(-) VENDAS CANCELADAS E DEVOLUCOES', 'REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE PRODUTOS REFERENTES A CANCELAMENTO DE VENDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.5.02.00', '(-) ABATIMENTOS', 'REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NAS PRODUTOS ENTREGUES OU DEFEITOS ORIUNDOS DO TRANSPORTE OU DESEMBARQUE.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.5.03.00', '(-) DESCONTOS INCONDICIONAIS', 'REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.5.04.00', '(-) IPI', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO IPI.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.5.05.00', '(-) ISS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO ISS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.5.06.00', '(-) ICMS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO ICMS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.5.07.00', '(-) PIS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO PIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.5.08.00', '(-) PASEP', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.5.09.00', '(-) COFINS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES A COFINS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.5.99.00', '(-) OUTRAS DEDUCOES DE VENDAS', 'REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE PRODUTOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.01.00', 'PRESTACAO DE SERVICOS POSTAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POSTAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.02.00', 'PRESTACAO DE SERVICOS DE TREINAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE INSTRUCAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.03.01', 'ALUGUEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS PELA UTILIZACAO DE TERCEIROS DE IMOVEIS PROPRIOS DO PODER PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.03.02', 'ARRENDAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRATO PELO QUAL O PODER PUBLICO CEDE A TERCEIROS, POR CERTO TEMPO E PRECO, O USO E GOZO DE DE TERMINADA AREA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.03.03', 'FOROS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PAGAS PELA PESSOA QUE RECEBE POR ENFITEUSE O DOMINIO UTIL DE UM IMOVEL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.03.04', 'LAUDEMIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENSAO OU PREMIO QUE O FOREIRO PAGA, QUANDO HA ALIENACAO DO RESPECTIVO PREDIO POR PARTE DA PESSOA QUE RECEBE POR ENFITEUSE O DOMINIO DO IMOVEL, EXCETO NOS CASOS DE SUCESSAO HEREDITARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.03.05', 'TAXA DE OCUPACAO DE TERRENOS DA UNIAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE TERRENOS DE MARINHA E DEMAIS TERRENOS DE PROPRIEDADE DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.03.06', 'TAXA OCUPACAO IMOVEIS FUN. PROP. NAC. RESID.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE IMOVEIS FUNCIONAIS E PROPRIOS NACIONAIS RESIDENCIAIS DA UNIAO, AGENTES POLITICOS E SERVIDORES PUBLICOS FEDERAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.03.07', 'TAXA DE OCUPACAO DE OUTROS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE OUTROS BENS IMOVEIS DE PROPRIEDADE DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.03.99', 'OUTRAS VPA DE EXPLORACAO DE BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS ORIGENS NA FRUICAO DO PATRIMONIO IMOBILIARIO, NAO ENQUADRADAS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.04.00', 'PRESTACAO DE SERVICOS DE LOCACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS, EXCETO ALUGUEIS DE IMOVEIS, QUE JA POSSUI RUBRICA PROPRIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.05.00', 'PRESTACAO DE SERVICOS DE PESQUISAS E ANALISES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PESQUISAS E ANALISE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.06.00', 'SERVICOS DE ESTUDOS E PESQUISAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PESQUISAS E ESTUDOS TECNICO-SOCIAIS, ECONOMICOS, CIENTIFICOS, CULTURAIS ETC., REALIZADAS SOB CONTRATO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.07.00', 'PRESTACAO DE SERVICOS DE CONSULTORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ASSESSORIA E CONSULTORIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.08.01', 'SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS - APLICACOES LIVRES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONSULTORIAS TECNICO - FINACEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ASSISTENCIA TECNICA E EXTENSAO RURAL, ETC. REDIRECIONAMENTO DE 2% DAS LIBERACOES EFETIVADAS PELOS RESPECTIVOS FUNDOS, PARA APLICACOES LIVRES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.08.02', 'SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS - APLICACOES VINCULADAS A ATIVIDADES DE PESQUISA E DESENVOLVIMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONSULTORIAS TECNICO - FINACEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ASSISTENCIA TECNICA E EXTENSAO RURAL, ETC. REDIRECIONAMENTO DE 1,5 % DAS LIBERACOES EFETIVADAS PELOS RESPECTIVOS FUNDOS, PARA APLICACOES VINCULADAS A ATIVIDADES DE PESQUISA E DESENVOLVIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.09.01', 'PRESTACAO DE SERVICOS DE DESENVOLVIMENTO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ANALISE E DESENVOLVIMENTO DE SISTEMAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.09.02', 'PRESTACAO DE SERV. LICENC/CESSAO DE DIREITO USO PROGRAMAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE LICENCIAMENTO OU CESSAO DE DIREITO DE USO DE PROGRAMAS DE COMPUTADOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.09.03', 'PRESTACAO DE SERVICOS DE MANUT. E ATUALIZACAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE MANUTENCAO E ATUALIZACAO DE SOFTWARE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.09.04', 'PRESTACAO DE SERVICOS DE INSTAL.E CONFIGURACAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE INSTALACAO E CONFIGURACAO DE SOFTWARE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.09.05', 'PRESTACAO DE SERVICOS DE PAGINAS ELETRONICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE PLANEJAMENTO, CONFECCAO, MANUTENCAO E ATUALIZACAO DE PAGINAS ELETRONICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.10.00', 'PRESTACAO DE SERVICOS DE ADM. DE REDE DE COMUNIC. DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE GERENCIAMENTO DE REDES DE COMUNICACAO DE DADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.11.00', 'SERVICOS DE PROCESSAMENTO DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VPA DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.12.00', 'SERVICO DE INFORMACOES CIENTIFICAS E TECNOLOGICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES CIENTIFICAS E TECNOLOGICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.13.00', 'PRESTACAO DE SERVICOS CIENTIFICOS E TECNOLOGICOS NUCLEARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS QUE ENVOLVAM INFORMACAO CIENTIFICA E TECNOLOGICA, APLICACOES DE TECNICAS NUCLEARES E RADIOISOTOPOS, METROLOGIA CIENTIFICA E INDUSTRIAL, RADIOMETRIA E DOSIMETRIA, CONSULTORIAS ASSISTENCIA TECNICA, ANALISE DE PROJETOS, ESTUDOS, PESQUISAS E DESENVOLVIMENTO DA ENERGIA NUCLEAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.14.00', 'SERVICOS DE TECNOLOGIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS TECNOLOGICOS PRESTADOS.VPA PROPORCIONADA POR: A) ANALISES QUIMICAS, ENSAIOS FISICOS E MECANICOS, CONTROLE E EXPERI-MENTACAO QUALITATIVA DE MATERIAS-PRIMAS, INSUMOS E PRODUTOS FABRICADOS; PADRONIZACAO E ESPECIFICACAO DE PRODUTOS; AJUSTES DOS PROCESSOS ETECNICAS DE PRODUCAO INDUSTRIAL (SISTEMA DE TECNOLOGIA) B) ESPECIFICACAO E CONTROLE DE QUALIDADE DE MEDICAMENTOS, INSUMOS FAR-MACEUTICOS, DROGAS, COSMETICOS, PRODUTOS QUIMICOS, ALIMENTOS, E OUTROS, POR MEIO DE PROVAS ESPECIFICAS DE IDENTIFICACAO, DE PUREZA E DETESTES DE CONTAMINACAO MICROBIOLOGICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.15.01', 'SERVICOS DE PUBLICIDADE LEGAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE AGENCIAMENTO DE PUBLICIDADE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.15.02', 'SERVICOS DE RADIODIFUSAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE RADIODIFUSAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.15.03', 'PRESTACAO DE SERVICOS DE AGENCIAMENTO DE PUBLICIDADE', 'REGISTRA O VALOR DE VPA AUFERIDAS PELA PRESTACAO DE SERVICOS DE AGENCIAMENTO DE PUBLICIDADE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.15.99', 'OUTROS SERVICOS DE COMUNICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS DE COMUNICACAO, TAIS COMO: SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.16.01', 'PRESTACAO DE SERVICOS DE ARMAZENAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ARMAZENAGEM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.16.02', 'PRESTACAO DE SERVICOS DE GARANTIA DE PRODUTOS ARMAZENADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE GARANTIA DE PRODUTOS ARMAZENADOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.17.00', 'PRESTACAO DE SERVICOS COMPLEMENTARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS COMPLEMENTARES QUANDO DA ESTOCAGEM EM ARMAZENAGEM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.18.01', 'PRESTACAO DE SERVICOS EXPURGO DE GRAOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO INSETICIDAS LIQUIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.18.02', 'PRESTACAO DE SERVICOS SECAGEM DE GRAOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO LENHA, OLEO DIESEL,ETC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.18.03', 'PRESTACAO DE SERVICOS LIMPEZA DOS GRAOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO MAQUINARIOS, COMO PENEIRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.19.00', 'PRESTACAO DE SERVICOS RECEPCAO E EMBARQUE DE PRODUTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE MOVIMENTACAO DOS PRODUTOS NOS ARMAZENS/CAMINHAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.20.00', 'PRESTACAO DE SERVICOS SERVICO DE TRANSBORDO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE TRANSBORDO DE MERCADORIAS DE TREM PARA CAMINHAO E VICE-VERSA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.22.00', 'PRESTACAO DE SERVICOS DE DISTRIB. DE GENEROS ALIMENTICIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE DISTRIBUICAO DE GENEROS ALIMENTICIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.23.00', 'SERVICOS DE HOSPEDAGEM E ALIMENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE HOSPEDAGEM E ALIMENTACAO PRESTADOS. VPA PROPORCIONADA POR HOSPEDAGEM, COM OU SEM ALIMENTACAO, FORNECIMENTO DE REFEICOES, LANCHES E BEBIDAS PARA CONSUMO IMEDIATO. EXCLUEM AS VPA PROVENIENTES DE EMPRESAS FORNECEDORAS DE ALIMENTOS PREPARADOS PARA HOSPITAIS, FABRICAS, ETC... QUE SE CLASSIFICAM EM VPA DE PRODUTOS ALIMENTARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.24.01', 'OUTORGA DOS SERV. TRANSP. FERROV.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE FERROVIARIO A INICIATIVA PRIVADA, PROVENIENTE DA FISCALIZACAO, NORMATIZACAO E CONTROLE DOS SERVICOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.24.02', 'OUTORGA SERV.TRANSP.ROD.INTEREST.INTERNAC.PAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A CONCESSAO PELO PODER PUBLICO AO PARTICULAR DO DIREITO DE EXPLORACAO DOS SERVICOS DE TRANSPORTES RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.24.99', 'OUTRAS VPA DE CONC. PERMISS. SERV DE TRANSPORTE', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.25.01', 'OUTORGA DOS SERV. TELECOMUNICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE TELECOMUNICACOES, INCLUINDO O SERVICO MOVEL CELULAR E O SERVICO DE TRANSPORTE DE SINAIS DE TELECOMUNICACOES POR SATELITE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.25.02', 'OUTORGA SERV.RADIODIFUSAO SONORA SONS IMAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE RADIODIFUSAO SONORA E DE SONS E IMAGENS, INCLUINDO O USO DE RADIOFREQUENCIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.25.03', 'OUTORGA DIREITO DE USO RADIOFREQUENCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO ESTABELECIDA PELO PODER PUBLICO_AO PARTICULAR DO DIREITO DE USO DE RADIOFREQUENCIA PARA QUALQUER FIM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.25.04', 'TRANS.CONC.PERM.AUT.TELECOM.USO RADIOFREQ', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTE DE PRECO PUBLICO COBRADO PELA AGENCIA NACIONAL DE TELECOMUNICACOES - ANATEL, COMO CONDICAO PARA TRANSFERENCIA DE CONCESSAO, DE PERMISSAO OU DE AUTORIZACAO DE SERVICO DE TELECOMUNICACOES OU DE USO DE RADIOFREQUENCIA, A SER PAGO PELA CESSIONARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.25.05', 'TRANSF.CONC/PERM/AUTOR-RODOVIAS OU OBRAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO RATEIO DA VERBA DE FISCALIZACAO A SER COBRADA PELOS ESTADOS E DISTRITO FEDERAL (OU CONSORCIO ENTRE ELES), COM O MINISTERIO DOS TRANSPORTES - MT, NA PROPORCAO DE 5% SOBRE O VALOR PAGO MENSALMENTE, PELAS CONCESSIONARIAS, EM FUNCAO DE CONVENIOS FIRMADOS ENTRE A UNIAO E OS RESPECTIVOS ESTADOS, PARA DELEGACAO DE TRECHOS DE RODOVIAS FEDERAIS (OU OBRAS RODOVIARIAS FEDERAIS), CUJA EXPLORACAO, MEDIANTE CONTRATOS DE CONCESSAO, FOI ENTREGUE PELA UNIAO AOS ESTADOS PARA ADMINISTRACAO E EXPLORACAO. (EMENTARIO - PORTARIA Nº 39, DE 15 DE JUNHO DE 2009)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.25.06', 'OUTORGA UTILIZACAO POSICOES ORBITAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA PARA A UTILIZACAO DE POSICOES ORBITAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.25.07', 'OUTORGA LICENCA E AUTORIZ.AG.ESPAC.BRASILEIRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA DE LICENCAS E AUTORIZACOES DA AGENCIA ESPACIAL BRASILEIRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.25.99', 'OUTRAS VPA CONC. PERM. - SERV. COMUNIC', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICO DE COMUNICACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.26.01', 'BONUS DE ASSINATURA DE CONTRATO DE CONCESSAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO OFERECIDO NA PROPOSTA PARA OBTENCAO DA CONCESSAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.26.02', 'PAGAMENTO P/ RETENCAO AREA EXPLORACAO OU PROD', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO ANUAL PELA RETENCAO DE AREA PARA EXPLORACAO, DESENVOLVIMENTO OU PRODUCAO DE PETROLEO E GAS NATURAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.26.03', 'BONUS ASSINATURA CONTRATO PARTILHA PRODUCAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE BONUS DE ASSINATURA DE CONTRATO DE PARTILHA DE PRODUCAO RELATIVO AO PRE-SAL E AREAS ESTRATEGICAS. .', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.27.00', 'OUTORGA DE DIREITOS DE USO DE REC. HIDR.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA A PARTICULARES DE DIREITOS DE USO DA AGUA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.28.00', 'OUTORGA DIREITOS DE EXPL. E PESQ. MINER', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA PELA EXPLORACAO DE RECURSOS MINERAIS DEVIDO POR TODAS AS EMPRESAS QUE REALIZAM O APROVEITAMENTO DE UMA JAZIDA MINERAL GARANTIDA A ESSAS A PROPRIEDADE DO PRODUTO DA LAVRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.29.01', 'VPA DE CUSTOS DE EDITAL DE CONCESSAO FLORESTAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PRECO CALCULADO SOBRE OS CUSTOS DE REALIZACAO DO EDITAL DE LICITACAO DA CONCESSAO FLORESTAL DA UNIDADE DE MANEJO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.29.02', 'CONTRATOS TRANSICAO CONCESSAO FLORESTAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PRECO DECORRENTE DE CONTRATOS DE TRANSICAO DE CONCESSAO FLORESTAL PARA EXPLORACAO E GESTAO DE FLORESTAS PUBLICAS E RECURSOS FLORESTAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.30.01', 'CONCESS. DE DIREITO REAL USO AREA PUBLIC', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE AREA PUBLICA POR TERCEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.30.02', 'CONCESSAO DE USO DO POTENCIAL DE ENERGIA HIDR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA AUTORIZACAO OU CONCESSAO, POR PARTE DA UNIAO, DAEXPLORACAO E APROVEITAMENTO DOS POTENCIAIS DE ENERGIA HIDRAULICA. DESTINACAO LEGAL: MINISTERIO DE MINAS E ENERGIA;AMPARO LEGAL: - CONSTITUICAO FEDERAL (ART.20, VIII E 176, ÷1º) - LEI 8987/1995; LEI 9074/1995; - LEI 427/1996; - LEI 10438/2002; LEI 10762/2003; - LEI 10848/2004; - LEI 11488/2007.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.30.03', 'PERMISSAO DE USO AREA DA UNIAO CURTA DURACAO', 'REGISTRA VPA DECORRENTE DA PERMISSAO DE USO DE AREA DA UNIAO DE CURTA DURACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.30.04', 'RECEITA DA CESSAO DE USO DE BENS DA UNIAO', 'REGISTRA VPA DECORRENTE DA CESSAO DE USO DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.30.99', 'OUTRAS VPA CONC. PERM. - DIR. USO BENS PUBL.', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.01', 'UTIL.RECURSO HIDRICOS - ITAIPU', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMPENSACAO FINANCEIRA RELATIVA AOS ROYALTIES DEVIDOS POR ITAPU BINACIONAL DO BRASIL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.02', 'UTIL.RECURSO HIDRICOS - DEMAIS EMPRESAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMPENSACAO FINANCEIRA RELATIVA AOS ROYALTIES DEVIDOS PELA UTILIZACAO DE RECURSOS HIDRICOS PARA GERACAO DE ENERGIA ELETRICA POR OUTRAS EMPRESAS, EXCETO ITAIPU.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.03', 'EXPLORACAO DE RECURSOS MINERAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRIBUICOES ECONOMICAS A TITULO DE COTA-PARTE DE COMPENSACOES FINANCEIRAS SOBRE A EXPLORACAO DE RECURSOS MINERAIS. O PRODUTO DA ARRECADACAO DA COMPENSACAO FINANCEIRA PELAEXPLORACAO DE RECURSOS SAO DESTINADOS: A) 23% (VINTE E TRES POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; B) 65% (SESSENTA E CINCO POR CENTO) AOS MUNICIPIOS; C) 12% (DOZE POR CENTO) PARA O DEPARTAMENTO NACIONAL DE PRODUCAO MINE-RAL - DNPM. OS RECURSOS DA COTA-PARTE DESTINADOS AO DEPARTAMENTO NACIONAL DA PRO-DUCAO MINERAL - DNPM, QUE REPASSARA 2% (DOIS POR CENTO) AO IBAMA COM AFINALIDADE DE PROTECAO AMBIENTAL NAS REGIOES MINERADORAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.04', 'ROYALTIES PRODUCAO PETROLEO GAS.NAT.-EM TERRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA EXTRACAO DO OLEO BRUTO XISTO BETUMINOSO E GAS NATURAL. O PRODUTO DA COMPENSACAO FINANCEIRA PELA EXTRACAO, TEM A SEGUINTE DESTINACAO: - 3,5% (TRES E MEIO POR CENTO) AOS ESTADOS EXPORTADORES; 1% (UM PORCENTO) AOS MUNICIPIOS PRODUTORES;0,5%(MEIO POR CENTO) AOS MUNICIPIOSONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES DE EMBARQUE OUDESEMBARQUE DE OLEO OU GAS. E TAMBEM DEVIDA A COMPENSACAO FINANCEIRA AOS ESTADOS, DISTRITO FEDERALE MUNICIPIOS CONFRONTANTES, QUANDO O OLEO, XISTO E GAS FOREM EXTRAIDOSDA PLATAFORMA CONTINENTAL, NOS MESMOS 5% (CINCO POR CENTO) SENDO: - 1,5% (UM E MEIO POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIOPOR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OUTERRESTRES DE EMBARQUE E DESEMBARQUE DE OLEO OU GAS; 1,5% (UM E MEIO POR CENTO) AS MUNICIPIOS CONFRONTANTES E SUAS RESPECTIVAS AREAS GEOECONOMICAS; 0,5%(MEIO POR CENTO) PARA CONSTITUIR UM FUNDO ESPECIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.05', 'ROYALTIES PROD. PETR. GAS.NAT.-EM PLATAFORMA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM A EXTRACAO DO OLEO BRUTO, XISTO BETUMINOSO E GAS NATURAL. O PRODUTO DA ARRECADACAO DA COMPENSACAO FINANCEIRA PELA EXTRACAO, TEM A SEGUINTE DESTINACAO: - 3,5% (TRES E MEIO POR CENTO) AOS ESTADOS EXPORTADORES; 1% (UM POR CENTO) AOS MUNICIPIOS PRODUTORES;0,5%(MEIO POR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES DE EMBARQUE OU DESEMBARQUE DE OLEO OU GAS. E TAMBEM DEVIDA A COMPENSACAO FINANCEIRA AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS CONFRONTANTES, QUANDO O OLEO, XISTO E GAS FOREM EXTRAIDOS DA PLATAFORMA CONTINENTAL, NOS MESMOS 5% (CINCO POR CENTO) SENDO: POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIOPOR CENTO) - 1,5% (UM E MEIO POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIO POR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES E EMBARQUE E DESEMBARQUE DE OLEO OU GAS; 1,5% (UM E MEIO POR CENTO) AS MUNICIPIOS CONFRONTANTES E SUAS RESPECTIVAS AREAS GEOECONOMICAS; 0,5%(MEIO POR CENTO) PARA CONSTITUIR UM FUNDO ESPECIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.06', 'ROYALT.EXCED.PROD.PETR.OU GAS.NAT.-EM TERRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES COM A PARCELA DO VALOR DO ROYALTY QUE EXCEDER A 5% (CINCO POR CENTO) DA PRODUCAO DE PETROLEO OUGAS NATURAL TENDO A SEGUINTE DISTRIBUICAO: I - QUANDO A LAVRA OCORRER EM TERRA OU EM LAGOS, RIOS, ILHAS FLUVIAISE LACUSTRES: A) 52,5% (CINQUENTA E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS ES-TAODS ONDE OCORRER A PRODUCAO; B)15,0% (QUINZE POR CENTO) AOS MUNICIPIOS ONDE OCORRER A PRODUCAO; C)7,5% (SETE INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS QUESEJAM AFETADOS PELAS OPERACOES DE EMBARQUE E DESEMBARQUE DE PETROLEO EGAS NATURAL, NA FORMA E CRITERIO ESTABELECIDOS PELA ANP; D)25%(VINTE E CINCO POR CENTO) AO MINISTERIO DA CIENCIA E TECNOLOGIA; II - QUANDO A LAVRA OCORRER NA PLATAFORMA CONTINENTAL: A) 22,5%(VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.07', 'ROYALTIES EXCED.PROD.PETR.GAS.NAT.-PLATAFORMA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM A PARCELA DO VALOR DO ROYALTY QUE EXCEDER A 5% (CINCO POR CENTO) DA PRODUCAO DE PETROLEO OU GAS NATURAL TENDO A SEGUINTE DISTRIBUICAO: I QUANDO A LAVRA OCORRER EM TERRA OU EM LAGOS, RIOS, ILHAS FLUVIAIS E LACUSTRES: A) 5 ,5% (CINQUENTA E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS ESTADOS ONDE OCORRER A PRODUCAO; B)15,0 (QUINZE POR CENTO) AOS MUNICIPIOS ONDE OCORRER A PRODUCAO; C)7,5% (SETE INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS QUE SEJAM AFETADOS PELAS OPERACOES DE EMBARQUE E DESEMBARQUE DE PETROLEO E GAS NATURA L, NA FORMA E CRITERIO ESTABELECIDOS PELA ANP; D)25%(VINT E CINCO POR CENTO) AO MINISTERIO DA CIENCIA E TECNOLOGIA; II - QUANDO A LAVRA OCORRER NA PLATAFORMA CONTINENTAL: A) 22,5%(VIN E E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS PRODUTORES', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.08', 'PARTICIP.ESPEC.PROD.PETROLEO OU GAS NATURAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PARTICIPACAO ESPECIAL NOS CASOS DE GRANDE VOLUME DE PRODUCAO DE PETROLEO, OU GRANDE RENTABILIDADE. OS RECURSOS DA PARTICIPACAO ESPECIAL SERAO DISTRIBUIDOS NAS SEGUINTESPROPORCOES: - 40% AO MINISTERIO DAS MINAS E ENERGIA, PARA O FINANCIAMENTO DE ESTU-DOS E SERVICOS DE GEOLOGIA E GEOFISICA APLICADOS A PROSPECAO DE PETRO-LEO E GAS NATURAL, A SEREM PROMOVIDOS PELA ANP; - 10% AO MINISTERIO DO MEIO AMBIENTE, DOS RECURSOS HIDRICOS E DA AMAZONIA LEGAL, DESTINADOS AO DESENVOLVIMENTO DE ESTUDOS E PROJETOS RELA-CIONADOS COM A PRESERVACAO DO MEIO AMBIENTE E RECUPERACAO DE DANOS AM-BIENTAIS CAUSADOS PELA INDUSTRIA DO PETROLEO; - 40% QUARENTA POR CENTO PARA O ESTADO ONDE OCORRER A PRODUCAO EM TER-RA, OU CONFRONTANTE COM A PLATAFORMA CONTINENTE ONDE SE REALIZAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.09', 'SUPRESSAO VEGETAL NAS FLORESTAS NACIONAIS', 'REGISTRA O VALOR DA VPA DA SUPRESSAO VEGETAL NO INTERIOR DAS FLORESTAS NACIONAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.10', 'ROYAL.PROD.PETR. OU GAS NATU - EM TERRA              ', 'REGISTRA A VPA DECORRENTE DOS ROYALTIES PELA PRODUCAO DE PETROLEO OU GAS NATURAL NAS AREAS DO PRE-SAL E ESTRATEGICAS - EM TERRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.11', 'ROYAL.PROD.PETR. OU GAS NATU - EM PLATAFORMA         ', 'REGISTRA A VPA DECORRENTE DOS ROYALTIES PELA PRODUCAO DE PETROLEO OU GAS NATURAL NAS AREAS DO PRE-SAL E ESTRATEGICAS - EM PLATAFORMA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.12', 'ROYAL.EXCED.PROD.PETR. OU GAS NAT. - EM TERRA        ', 'REGISTRA A VPA DECORRENTE DOS ROYALTIES EXCEDENTES PELA PRODUCAO DE PETROLEO OU GAS NATURAL NAS AREAS DO PRE-SAL E ESTRATEGICAS - EM TERRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.13', 'ROYAL.EXCED.PROD.PETR. OU GAS NAT. - EM PLATAFORMA        ', 'REGISTRA A VPA DECORRENTE DOS ROYALTIES EXCEDENTES PELA PRODUCAO DE PETROLEO OU GAS NATURAL NAS AREAS DO PRE-SAL E ESTRATEGICAS - EM PLATAFORMA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.14', 'PART.ESPECIAL P/ PROD.PETRO OU GAS NATURAL           ', 'REGISTRA A VPA DECORRENTE DA PARTICIPACAO ESPECIAL PELA PRODUCAO DE PETROLEO OU GAS NATURAL NAS AREAS DO PRE-SAL E ESTRATEGICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.32.01', 'SERVICOS DE TRANSPORTE RODOVIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS COM TRANSPORTE RODOVIARIO, TRANSPORTE RODOVIARIO DE PASSAGEIROS, DE CARGA OU MISTO, DE ESCOLARES, TAXI, DE ENCOMENDAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.32.02', 'SERVICOS DE TRANSPORTE FERROVIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE FERROVIARIO. VPA AUFERIDA NO TRANSPORTE FERROVIARIO DE PASSAGEIROS E DE CARGA, INCLUSIVE METROPOLITANO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.32.03', 'SERVICOS DE TRANSPORTE HIDROVIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE HIDROVIARIO. VPA DE SERVICOS DE TRANSPORTE HIDROVIARIO DE PASSAGEIROS, DE CARGA OU MISTO, DE LONGO CURSO, DE CABOTAGEM E POR VIAS INTERNAS (RIOS, LAGOS, ETC...)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.32.04', 'SERVICOS DE TRANSPORTE AEREO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE AEREO. VPA DE SERVICOS DE TRANSPORTE AEREO DE PASSAGEIROS, DE CARGA OU MISTO, TRANSPORTE AEREO REGULAR,TRANSPORTE AEREO REGIONAL, TAXI AEREO, AERONAVES FRETADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.32.99', 'OUTROS SERVICOS DE TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTROS SERVICOS DE TRANSPORTE, NAO CLASSIFICADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.33.00', 'SERVICOS PORTUARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PORTUARIOS. ABRANGEM OS RECURSOS ORIUNDOS DA EXPLORACAO DOS PORTOS, TERMINAIS MARITIMOS, ATRACADOUROS E ANCORADOUROS, REFERENTES A ESTIVA, DESESTIVA, DRAGAGEM, ATRACACAO, SINALIZACAO, COMUNICACAO NAUTICA, DOCAGEM, ETC....', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.34.00', 'SERVICOS DE SOCORRO MARITIMO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICO DE SOCORRO MARITIMO PRESTADO. VPA DE SERVICOS DE SALVAMENTO, POR NAVIO DE SOCORRO OU EQUIPE DE SALVAMENTO DA MARINHA, DE EMBARCACAO E CARGAS PERIGO (DESENCALHE, MERGULHO, OUTROS SOCORROS), BEM COMO SERVICOS DE REBOQUE MARITIMO, DENTRE OUTROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.35.01', 'SERVICOS HOSPITALARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE HOSPITAL EM GERAL OU ESPECIALIZADO, MATERNIDADE, CENTRO DE REABILITACAO, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.35.02', 'SERV.REG.AN.CONTR.PROD.SUJ.A NORM.VIGIL.SANIT', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE ANALISE E DE CONTROLE DE PRODUTOS SUJEITOS A NORMAS DE VIGILANCIA SANITARIA E O REGISTRO DE TODOS OS MEDICAMENTOS, DROGAS, INSUMOS FARMACEUTICOS E CORRELATOS, SANEANTES E OUTROS PRODUTOS, INCLUSIVE OS IMPORTADOS, OS EXPOSTOS A VENDA OU ENTREGUE AO CONSUMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.35.03', 'SERVICOS RADIOLOGICOS E LABORATORIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RADIOLOGICOS E LABORATORIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.35.04', 'SERV ASSIST SAUDE SUPLEMENTAR SERVIDOR CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PARTICIPACAO DA UNIAO, SUAS AUTARQUIAS E FUNDACOES PUBLICAS E DE RECURSOS PROVENIENTES DA CONTRIBUICAO DOS SERVIDORES PUBLICOS CIVIS ATIVOS, INATIVOS E PENSIONISTAS, DESTINADA AO CUSTEIO DA ASSISTENCIA AA SAUDE SUPLEMENTAR DO SERVIDOR CIVIL, NO CASO DE PRESTACAO DIRETA PELOS ORGAOS (GESTAO PROPRIA). AMPARO LEGAL: LEI 8.112/90, ART. 230 LEI 11.302/2006, ART. 9º PORTARIA SRH/MP 1983/2006 DESTINACAO LEGAL: INTEGRALMENTE DESTINADA AO CUSTEIO DA ASSISTENCIA AA SAUDE SUPLEMENTAR DO SERVIDOR CIVIL DA ADMINISTRACAO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.35.99', 'OUTROS SERVICOS DE SAUDE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTROS SERVICOS DE SAUDE, E NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.36.00', 'CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.37.01', 'METROLOGIA LEGAL E CERTIFICATORIA DELEGADA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA LEGAL E CERTIFICATORIA DELEGADA, ORIUNDAS DE ENTIDADES PUBLICAS OU PRIVADAS CREDENCIADAS. ESTA VPA ESTA AMPARADA PELA LEI NUM 5966DE 11 DE DEZEMBRO DE 1973.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.37.02', 'METROLOGIA CIENTIFICA E INDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA CIENTIFICA E INDUSTRIAL, NO TOCANTE A AFERICAO DE INSTRUMENTOS DE MEDICOES, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC...ESTA VPA ESTA AMPARADA PELA LEI NUM 5966 DE 11 DE DEZEMBRO DE 1973', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.37.03', 'METROLOGIA LEGAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METRO-LOGIA LEGAL, ORIUNDA DE SERVICOS METROLOGICOS LEGAIS. BASICAMENTE,CONSISTE EM ASSEGURAR A UNIFORMIDADE E A RACIONALIZACAO DAS UNIDADESEM TODO O TERRITORIO NACIONAL, AFERICAO DE INSTRUMENTOS DE MEDICOES,ETC. ESTA VPA ESTA AMPARADA PELA LEI 5966 DE 11/12/1973.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.37.04', 'CERTIFICACAO DE PRODUTOS E SERVICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CERTIFICACAO DA QUALIDADE DE MATERIAIS, PRODUTOS E SERVICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.37.05', 'INFORMACAO TECNOLOGICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES TECNOLOGICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.38.00', 'SERVICOS DE INSPECAO E FISCALIZACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INSPECAO E FISCALIZACAO PRESTADOS. VPA PROPORCIONADA PELA CONSTATACAO DAS CONDICOES HIGIENICO-SANITARIAS E TECNICAS DE PRODUTOS OU ESTABELECIMENTOS, OU RESULTANTES DE ACAO EXTERNA E DIRETA DOS ORGAOS DO PODER PUBLICO DESTINADA A VERIFICACAO DO CUMPRIMENTO DA LEGISLACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.39.00', 'SERVICOS ADMINISTRATIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS ADMINISTRATIVOS PRESTADOS, DAS ATIVIDADES DE APOIO ADMINSITRATIVO EXECUTADAS EM ORGANIZACOES DE QUALQUER NATUREZA, TAIS COMO: A)TAXAS DE EXPEDICAO DE CERTIFICADOS; B)TAXAS DE REGISTRO, RENOVACAO, VISTORIA, LICENCA, CADASTRAMENTO, ETC. C)DATILOGRAFIA, MICROFILMAGEM, COPIAS XEROGRAFICAS, HELIOGRAFICAS,FOTOSTATICAS, ETC.. D)TAXAS DE INSCRICAO EM CONCURSOS. E)TAXA DE ADMINISTRACAO DE SERVICOS. F)VENDA DE EDITAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.40.00', 'SERVICOS DE METEOROLOGIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METEOROLOGIA PRESTADOS. VPA PROPORCIONADA PELO FORNECIMENTO DE DADOS METEOROLOGICOS E DE PARECERES TECNICOS, BEM COMO CONSERTO, COMPARACAO E AFERICAO DE EQUIPAMENTOS DE METEOROLOGIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.41.00', 'SERVICOS EDUCACIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DO SISTEMA EDUCACIONAL, CUJA NATUREZA ESTEJA DIRETAMENTE RELACIONADA A FORMACAO DO EDUCANDO (MATRICULAS, ANUIDADES, ETC...). AS VPA DE ATIVIDADES AUXILIARES, DE APOIO OU DERIVADAS DOS SERVICOS EDUCACIONAIS PROPRIAMENTE DITOS, DEVEM SER CLASSIFICADAS NOS TITULOS APROPRIADOS. EXEMPLOS: MATRICULAS E ANUIDADES, SERVICOS EDUCACIONAIS, TAXAS DE EXPEDICAO DE DOCUMENTOS, COPIAS XEROGRAFICAS, HELIOGRAFICAS, ETC.., SERVICO DE CREDENCIAMENTO, AUTORIZACAO E RECONHECIMENTO DE CURSOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.42.00', 'SERVICOS AGROPECUARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS AGROPECUARIO: A)PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO,ARACAO,GRADEACAO, CALAGEM,ADUBACAO, DRENAGEM, IRRIGACAO, CAPINA, DESMATAMENTO, ETC.); B)SEMEADURA E PLANTIO; C)COMBATE A PRAGAS (PULVERIZACAO, DEDETIZACAO); D)COLHEITA E PREPARACAO DE PRODUTOS AGRICOLAS; E)INSEMINACAO ARTIFICIAL; F)INCUBACAO DE OVOS; G)VACINACAO DE ANIMAIS; H)OUTROS SERVICOS AUXILIARES DE AGRICULTURA E PECUARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.43.00', 'SERVICOS DE REPARACAO,MANUTENCAO E INSTALACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REPARACAO, MANUTENCAO E INSTALACAO PRESTADOS. VPA DE SERVICOS DE REPARACAO DE ARTEFATOS DE METAL; REPARACAO E MANUTENCAO DE MAQUINAS E APARELHOS DE USO DOMESTICO; REPARACAO, MANUTENCAO E INSTALACAO DE MAQUINAS E APARELHOS ELETRICOS E ELETRONICOS E DE COMUNICACAO; REPARACAO E MANUTENCAO DE INSTALACOES ELETRICAS, DE GAS, DE AGUA, ETC...INCLUEM-SE TAMBEM, NESSE TITULO, OS SERVICOS DE CONFECCAO SOB MEDIDA. NAO SAO CONSIDERADOS NESSE TITULO, CLASSIFICANDO-SE EM VPA INDUSTRIAL: REPARACAO E MANUTENCAO DE VEICULOS FERROVIARIOS, EMBARCACOES E AERONAVES (INDUSTRIA DE MATERIAL DE TRANSPORTE).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.44.00', 'SERVICOS RECREATIVOS E CULTURAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RECREATIVOS E CULTURAIS PRESTADOS. VPA PROPORCIONADA PELA EXPLORACAO DE INSTALACOES PARA RECREACAO, PRATICA DESPORTIVA E CULTURAL ( CINEMAS,TEATROS, SALOES PARA RECITAIS, CONCERTOS, CONFERENCIAS, PLANETARIOS,ESTADIOS DESPORTIVOS, AUTODROMOS, MUSEUS, BIBLIOTECAS, PROMOCAO E/OUPRODUCAO DE ESPETACULOS ARTISTICOS CULTURAIS E ESPORTIVOS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.45.01', 'SERVICOS DE PATENTES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PETICOES, PEDIDOS DE PRIVILEGIO, ANUIDADES DE PEDIDOS, REGISTROS DE DESENHO INDUSTRIAL,ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.45.02', 'SERVICOS DE REGISTRO DE MARCAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PEDIDOS DE REGISTRO DE MARCAS, VIGENCIAS DE MARCAS, PETICOES, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.45.03', 'SERVICOS DE TRANSFERENCIA DE TECNOLOGIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE AVERBACOES DE CONTRATOS, PETICOES, RECURSOS, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.45.04', 'SERVICOS DE REGISTRO INDICACOES GEOGRAFICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE EXPEDICOES DE CERTIFICADOS DE REGISTRO, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.45.05', 'SERVICOS DE REGISTRO PROGRAMA DE COMPUTADOR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE PROGRAMAS DE COMPUTADOR, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.45.06', 'SERVICOS DE REGISTRO DE DESENHO INDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE DESENHO INDUSTRIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.45.07', 'SERV. PROTECAO TOPOGRAFIAS CIRCUITOS INTEGRAD', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROTECAO DAS TOPOGRAFIAS DE CIRCUITOS INTEGRADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.45.08', 'SERVICOS DE REMESSA DE DEPOSITOS OFICIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REMESSA DE DEPOSITOOFICIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.45.99', 'OUTROS SERV.REGIST.MARCAS,PATENTES,TRANSF.TEC', 'REGISTRA AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE REGISTRO DE MARCAS,PATENTES,TRANSFERENCIA DE TECNOLOGIA, NAO CLASSIFICADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.46.00', 'SERVICOS DE REGISTRO DO COMERCIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DO COMERCIO PRESTADOS. VPA ADVINDA DA PRESTACAO DE SERVICOS DE REGISTRO DO COMERCIO E ATIVIDADES AFINS, TRATANDO-SE DE: A) SERVICOS PRESTADOS PELA JUNTA COMERCIAL DO DISTRITO FEDERAL; B) SERVICOS CONSTANTES DO CADASTRO NACIONAL DE EMPRESA, DEVIDOS NO AMBITO DAS JUNTAS COMERCIAIS DOS ESTADOS E DO DISTRITO FEDERAL; C) REMUNERACAO DE SERVICOS PRESTADOS PELO DEPARTAMENTO NACIONAL DE REGISTRO DO COMERCIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.47.00', 'SERVICOS DE FORNECIMENTO DE AGUA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE FORNECIMENTO DE AGUA AOS IRRIGANTES AA AMORTIZACAO DOS INVESTIMENTOS DA INFRA-ESTRUTURA DE IRRIGACAO DOS PROJETOS PUBLICOS, CONFORME DEC.89.496, DE 29.03DE 84, RELATIVOS A TARIFAS K-1 E K-2.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.48.00', 'SERVICOS DE PERFURACAO E INSTALACAO DE POCOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE PERFURACAO EINSTALACAO DE POCOS TUBULARES PROFUNDOS, POCOS ARTESIANOS OU SIMILARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.49.00', 'SERVICOS DE GEOPROCESSAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS A TERCEIROS DE INTERPRETACAO DE IMAGEM AEROFOTOGRAMETRICA,EXECUCAO DE MAPAS DIGITALIZADOS DIVERSOS, VENDA DE CARTAS E IMAGENS DE SATELITES, VIDEOGRAFICAS E SIMILARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.50.00', 'SERVICOS DE CADASTRAMENTO DE FORNECEDORES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE CADASTRAMENTO DE EMPRESAS FORNECEDORAS DE BENS E SERVICOS AO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.51.00', 'TARIFA DE UTILIZACAO DE FAROIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA DE UTILIZACAO DE FAROIS. VPA PROVENIENTE DA EFETIVA UTILIZACAO, POR EMBARCACOES ESTRANGEIRAS, DOS SERVICOS DE SINALIZACAO NAUTICA DE PROTECAO A NAVEGACAO. O PRODUTO DA ARRECADACAO E DESTINADO INTEGRALMENTE AO FUNDO NAVAL PARA APLICACAO NOS SERVICOS QUE ENVOLVAM A MANUTENCAO E AMPLIACAO DA REDE DE BALIZAMENTO MARITIMO, FLUVIAL E LACUSTRE, A CARGO DA DIRETORIA DE HIDROGRAFIA E NAVEGACAO DO MINISTERIO DA MARINHA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.52.01', 'TARIFA AEROPORTUARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA COBRADA POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTILIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPA-TAZIA).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.52.02', 'ADICIONAL SOBRE TARIFA AEROPORTUARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ADICIONAL SOBRE TARIFA AEROPORTUARIA. VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO ADICIONAL SOBRE A TARIFA COBRADAPOR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AE-ROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTILIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIASEM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.52.03', 'PARCELA DA TARIFA DE EMBARQUE INTERNACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PARCELA DA TARIFA DE EMBARQUE INTERNACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.53.00', 'SERVICOS DE CADASTRO DA ATIVIDADE MINERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE AUTORIZACAO DE PESQUISA MINERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.54.01', 'TARIF USO COMUN E AUX.NAVEGACAO AEREA EM ROTA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE DA UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA,PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA OU POR ENTIDADE ESPECIA-LIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. FATO GERADOR: UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA. AMPARO LEGAL: DECRETO-LEI 1896/1981 E DECRETO 86.864/1982.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.54.02', 'ADICIONAL S/ TARIFA USO COM E AUX NAVEG AEREA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO ADICIONAL DE 50% SOBRE AS TARIFAS DE UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA,PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA OU POR ENTIDADE ESPECIALIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. FATO GERADOR: ADICIONAL SOBRE AS TARIFAS RELATIVAS AO USO DOS AUXILIOSAA NAVEGACAO AEREA E DAS TELECOMUNICACOES. DESTINACAO LEGAL: MINISTERIO DA AERONAUTICA OU ENTIDADE DA ADMINISTRA-CAO INDIRETA RESPONSAVEL PELA PRESTACAO DOS SERVICOS. AMPARO LEGAL: LEI 7920/1989 - ART 1.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.55.00', 'TAR.INSCR.CONCURSOS E PROCESSOS SELETIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE INSCRICAO EM CONCURSOS E PROCESSOS SELETIVOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.56.00', 'SERVICO DE COMPENSACAO DE VARIACOES SALARIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COBRANCA DE CONTRIBUICOES SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO-SFH E SOBRE O SALDO DOS FINANCIAMENTOS IMOBILIARIOS CONCEDIDOS PELOS AGENTES FINANCEIROS DO SFH,COM COBERTURA DO FCVS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.57.01', 'TARIFA PELO USO DO SISTEMA DE INFORM.DO BACEN', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO USO DO SISTEMA DE INFORMACOES DO BACEN.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.57.02', 'TARIFA PELO USO DO SIST.DE TRANSF. RES. BACEN', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO USO DO SISTEMA DE TRANSFERENCIA DE RESERVA DO BACEN.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.58.01', 'CONCESSAO DE AVAL DO TESOURO NACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO DE AVAL DO TESOURO NACIONAL, COBRADA A TITULO DE COMISSAO, EXECUCAO OU FISCALIZACAO PELA CONCESSAO DE GARANTIA DO TESOURO NACIONAL A CREDITOS OBTIDOS NO EXTERIOR. FATO GERADOR: A CONCESSAO DE GARANTIA DO TESOURO NACIONAL A CREDITOS OBTIDOS NO EXTERIOR. AMPARO LEGAL: LEI 5.000, DE 24 DE MAIO DE 1966.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.58.02', 'CONCESSAO GARANTIA DA ATIVIDADE AGROPECUARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ADICIONAL COBRADO SOBRE EMPRESTIMOS RURAIS DE CUSTEIO. TEM COMO FINALIDADE EXIMIR O PRODUTOR RURAL DE POSSIVEIS OBRIGACOES RELATIVAS A OPERACOES DE CREDITO CUJA LIQUIDACAO SEJA DIFICULTADA POR FENOMENOS NATURAIS, DOENCAS OUPRAGAS. FATO GERADOR: A REALIZACAO DE EMPRESTIMOS RURAIS DE CUSTEIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.58.03', 'COMISSOES PELA PRESTACAO DE GARANTIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMISSOES COBRADAS POR CONTA DA GARANTIA DE OPERACOES DE FINANCIAMENTO PARA AUMENTO DA COMPETITIVIDAD EE DA PRODUCAO DESTINADA AA EXPORTACAO. FATO GERADOR: COBRANCA DE COMISSOES, POR CONTA DA GARANTIA DE OPERACOES DE FINANCIAMENTO, PARA AUMENTO DA COMPETITIVIDADE E DA PRODUCAODESTINADA AA EXPORTACAO. DESTINACAO LEGAL: - MICROEMPRESAS E EMPRESAS DE PEQUENO PORTE; - MEDIAS EMPRESAS QUE SEJAM EXPORTADORAS OU FABRICANTES DE INSUMOS QUEINTEGREM O PROCESSO PRODUTIVO, OU DE MONTAGEM E DE EMBALAGEM DE MERCA-DORIAS DESTINADAS AA EXPORTACAO. AMPARO LEGAL: LEI 9531, DE 10 DE DEZEMBRO DE 1997, ÷ 1º, 2º E 3º.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.58.04', 'GARANTIA DOS FINANC.AA ESTOC.ALCOOL ETIL.COMB', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO DE GARANTIAS E AVAIS NOS FINANCIAMENTOS A ESTOCAGEM DE ALCOOL ETILICO COMBUSTIVEL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.58.05', 'RECEITA DE SEGURO DE CREDITO AA EXPORTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA GARANTIA DAS OPERACOES DE CREDITO AA EXPORTACAO CONTRA OS RISCOS COMERCIAIS, POLITICOS E EXTRAORDINARIOS QUE POSSAM AFETAR A PRODUCAO DE BENS E A PRESTACAO DE SERVICOS DESTINADOS AA EXPORTACAO OU AS EXPORTACOES BRASILEIRAS DE BENS E SERVICOS. AMPARO LEGAL: - LEI 9.818, DE 23 DE AGOSTO DE 1999 - LEI 6.704, DE 26 DE OUTUBRO DE 1979, ART.1º', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.59.00', 'CREDENCIAMENTO EMP.PREST.SERVICOS DE VISTORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO VALOR A SER PAGO POR EMPRESAS NA OBTENCAO DE CREDENCIAMENTO PARA PRESTACAO DE SERVICOS DE VISTORIA. - DESTINACAO LEGAL: ORGAO ARRECADADOR; - AMPARO LEGAL: RESOLUCAO CONTRAN 282, DE 26 DE JUNHO DE 2008.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.60.00', 'SERVICOS VETERINARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS VETERINARIOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.61.00', 'CERTIFICACAO E HOMOLOGACAO ATIVIDADE MINERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE REGISTRO DE LICENCA E DO REGISTRO DE PERMISSAO DE LAVRA GARIMPEIRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.62.01', 'SERV.PREST.DIRET. POR INST.CIENT.TECNOLOGICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DIRETAMENTE POR INSTITUICOES CIENTIFICAS E TECNOLOGICAS, VOLTADOS A INOVACAO E A PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.62.02', 'SERV.DECORREN.PARCEIR.C/OUTRAS INST.PUB.PRIV.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA CELEBRACAO DE ACORDOS DE PARCERIA PARA REALIZACAO DE ATIVI-DADES CONJUNTAS DE PESQUISA CIENTIFICA E TECNOLOGICA E DESENVOLVIMENTODE TECNOLOGIA, PRODUTO OU PROCESSO, COM INSTITUICOES PUBLICAS E PRIVA-DAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.63.01', 'SERV.FINANC.DE COMPENS.DE VARIACOES SALARIAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM SERVICOS FINANCEIROS DE COMPENSACAO DE VARIACOES SALARIAIS. VPA PROVENIENTE DE ADICIONAL COBRADO SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DA HABITACAO. TEM COMO FINALIDADE EXIMIR OS ADQUIRENTES DE CASA PROPRIA DO PAGAMENTO DE POSSIVEIS RESIDUOS DO SALDO DEVEDOR DO FINANCIAMENTO IMOBILIARIO EXISTENTES AO FINAL DO PRAZO CONTRATADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.63.02', 'SERVICOS DE REMUNERACAO REP. PROG.DES.ECONOM.', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM SERVICOS DE REMUNERACAO DE REPASSES DE PROGRAMA DE DESENVOLVIMENTO ECONOMOMICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.63.03', 'COMISSOES PELA PREST. DE GARANTIA', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM COMISSOES PELA PREST. DE GARANTIA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.63.99', 'OUTROS SERVICOS FINANCEIROS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM OUTROS SERVICOS FINANCEIROS, NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.64.01', 'SERVICO DE EMISSAO DE CERTIFICADOS DE ORIGEM', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE CERTIFICADOS DE ORIGEM', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.64.02', 'SERVICO DE EMISSAO DE LICENCA DE EXPORTACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE LICENCA DE EXPORTACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.65.00', 'VPA DE UTILIZACAO DE POSICOES ORBITAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE UTILIZACAO DE POSICOES ORBITAIS, CUJOS RECURSOS SAO PROVENIENTES DE: 25 POR CENTO DA VPA QUE SE REFEREM O ARTIGO 2 DA LEI 5070/96,PROVENIENTES DA UTILIZACAO DE POSICOES ORBITAIS 25 POR CENTO DA VPA DA UNIAO, PROVENIENTES DE LANCAMENTOS, EM CARATER COMERCIAL, DE SATELITES E FOGUETES DE SONDAGEM A PARTIR DO TERRITORIO BRASILEIRO 25 POR CENTO DA VPA AUFERIDAS PELA UNIAO, PROVENIENTES DA COMERCIALIZACAO DOS DADOS E IMAGENS OBTIDOS POR MEIOS DE RASTREAMENTO, TELEMEDIDAS E CONTROLE DE FOGUETES E SATELITES TOTAL DA VPA AUFERIDA PELA AGENCIA ESPACIAL BRASILEIRA - AEB, DECORRENTES DA CONCESSAO DE LICENCAS E AUTORIZACOES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.66.00', 'VPA COM.DADOS/IMAGENS UTIL.POSICOES ORBITAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DOS DADOS E IMAGENS ORIUNDOS DA UTILIZACAO DE POSICOES ORBITAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.67.00', 'VPA LANCAM.SATELITES E FOGUETES DE SONDAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LANCAMENTOS DE SATELITES E FOGUETES DE SONDAGEM, A PARTIR DO TERRITORIO BRASILEIRO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.68.00', 'SERV.COMERCIAIS DE PROD.DADOS E MAT.INFORMATI', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS, DADOS E MATERIAIS DE INFORMATICA, TAIS COMO DISQUETES,SOFTWARES, PROGRAMAS, CD-ROM, FITAS MAGNETICAS E ASSEMELHADOS, BEM COMO INFORMACOES EM REDES E SISTEMAS DE DADOS DISPONIVEIS EM MEIO DE HARDWARE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.69.00', 'REC.OUTORGA TIT ONEROSO ATIV PESQ/LAVRA-PETRO', 'REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CESSAO A TITULO ONEROSO DAS ATIVIDADES DE PESQUISA E LAVRA DAS JAZIDAS DE PETROLEO E GAS NATURAL E OUTROS HIDROCARBONETOS FLUIDOS, BEM COMO O SEU REFINO E TRANSPORTE MARITIMO. DESTINACAO LEGAL: TESOURO NACIONAL AMPARO LEGAL: ART 177 DA CONSTITUICAO FEDERAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.70.01', 'ROYALTIES - EXPLORACAO PATRIMONIO GENETICO - AREA DOMINIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE ROYALTIES PELA EXPLORACAO DO PATRIMONIO GENETICO EM AREA DE DOMINIO PUBLICO. (PORTARIA SOF Nº 132, DE 08/10/10)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.70.02', 'ROYALTIES - EXPLORACAO PATRIMONIO GENETICO - MAR TERRITORIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE ROYALTIES PELA EXPLORACAO DO PATRIMONIO GENETICO NO MAR TERRITORIAL, ZONA ECONOMICA EXCLUSIVA OU PLATAFORMA CONTINENTAL.(PORTARIA SOF Nº 132, DE 08/10/10)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.70.03', 'PARTICIPACAO - EXPLORACAO PATRIMONIO GENETICO - AREA DOMINIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE PARTICIPACOES PELA EXPLORACAO DO PATRIMONIO GENETICO EM AREAS DE DOMINIO DA UNIAO. (PORTARIA SOF Nº 132, DE 08/10/10)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.70.04', 'PARTICIPACAO - EXPLORACAO PATRIMONIO GENETICO - MAR TERRITORIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE PARTICIPACOES PELA EXPLORACAO DO PATRIMONIO GENETICO NO MAR TERRITORIAL, ZONA ECONOMICA EXCLUSIVA OU PLATAFORMA CONTINENTAL.(PORTARIA SOF Nº 132, DE 08/10/10)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.71.00', 'VPA OUTORGA A TITULO ONEROSO DAS ATIVIDADES DE PESQUISA/LAVRA JAZIDAS PETROLEO E OUTROS', 'REGISTRA AS VARIACOES PATRIMONAIS AUMENTATIVAS DECORRENTES DE CESSAO A TITULO ONEROSO DAS ATIVIDADES DE PESQUISA E LAVRA DAS JAZIDAS DE PETROLEO E GAS NATURAL E OUTROS HIDROCARBONETOS FLUIDOS, BEM COMO O SEU REFINO E TRANSPORTE MARITIMO. DESTINACAO LEGAL: TESOURO NACIONAL AMPARO LEGAL: ART 177 DA CONSTITUICAO FEDERAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.72.01', 'VPA DE CESSAO DIR.OPERACIONALIZACAO FOPAG', 'REGISTRA A VPA DECORRENTE DE CESSAO DO DIREITO DE OPERACIONALIZACAO DA FOLHA DE PAGAMENTO DE PESSOAL. PORTARIA SOF Nº 47, DE 21 DE JUNHO DE 2011.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.72.02', 'VPA DE CESSAO DIR.OPER.FOPAG DE BENEFICIOS', 'REGISTRA A VPA DECORRENTE DE CESSAO DO DIREITO DE OPERACIONALIZACAO DA FOLHA DE PAGAMENTO DE BENEFICIOS. PORTARIA SOF Nº 47, DE 21 DE JUNHO DE 2011.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.72.03', 'VPA DE CESSAO DIR.OPER.DE PGTO A FORNECEDORES', 'REGISTRA A VPA DECORRENTE DE CESSAO DO DIREITO DE OPERACIONALIZACAO DE PAGAMENTO A FORNECEDORES. PORTARIA SOF Nº 47, DE 21 DE JUNHO DE 2011.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.99.00', 'OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.01.00', 'PRESTACAO DE SERVICOS POSTAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POSTAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.02.00', 'PRESTACAO DE SERVICOS DE TREINAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE INSTRUCAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.03.01', 'ALUGUEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS PELA UTILIZACAO DE TERCEIROS DE IMOVEIS PROPRIOS DO PODER PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.03.02', 'ARRENDAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRATO PELO QUAL O PODER PUBLICO CEDE A TERCEIROS, POR CERTO TEMPO E PRECO, O USO E GOZO DE DE TERMINADA AREA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.03.03', 'FOROS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PAGAS PELA PESSOA QUE RECEBE POR ENFITEUSE O DOMINIO UTIL DE UM IMOVEL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.03.04', 'LAUDEMIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENSAO OU PREMIO QUE O FOREIRO PAGA, QUANDO HA ALIENACAO DO RESPECTIVO PREDIO POR PARTE DA PESSOA QUE RECEBE POR ENFITEUSE O DOMINIO DO IMOVEL, EXCETO NOS CASOS DE SUCESSAO HEREDITARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.03.05', 'TAXA DE OCUPACAO DE TERRENOS DA UNIAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE TERRENOS DE MARINHA E DEMAIS TERRENOS DE PROPRIEDADE DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.03.06', 'TAXA OCUPACAO IMOVEIS FUN. PROP. NAC. RESID.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE IMOVEIS FUNCIONAIS E PROPRIOS NACIONAIS RESIDENCIAIS DA UNIAO, AGENTES POLITICOS E SERVIDORES PUBLICOS FEDERAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.03.07', 'TAXA DE OCUPACAO DE OUTROS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE OUTROS BENS IMOVEIS DE PROPRIEDADE DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.03.99', 'OUTRAS VPA DE EXPLORACAO DE BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS ORIGENS NA FRUICAO DO PATRIMONIO IMOBILIARIO, NAO ENQUADRADAS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.04.00', 'PRESTACAO DE SERVICOS DE LOCACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS, EXCETO ALUGUEIS DE IMOVEIS, QUE JA POSSUI RUBRICA PROPRIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.05.00', 'PRESTACAO DE SERVICOS DE PESQUISAS E ANALISES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PESQUISAS E ANALISE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.06.00', 'SERVICOS DE ESTUDOS E PESQUISAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PESQUISAS E ESTUDOS TECNICO-SOCIAIS, ECONOMICOS, CIENTIFICOS, CULTURAIS ETC., REALIZADAS SOB CONTRATO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.07.00', 'PRESTACAO DE SERVICOS DE CONSULTORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ASSESSORIA E CONSULTORIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.08.01', 'SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS - APLICACOES LIVRES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONSULTORIAS TECNICO - FINACEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ASSISTENCIA TECNICA E EXTENSAO RURAL, ETC. REDIRECIONAMENTO DE 2% DAS LIBERACOES EFETIVADAS PELOS RESPECTIVOS FUNDOS, PARA APLICACOES LIVRES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.08.02', 'SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS - APLICACOES VINCULADAS A ATIVIDADES DE PESQUISA E DESENVOLVIMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONSULTORIAS TECNICO - FINACEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ASSISTENCIA TECNICA E EXTENSAO RURAL, ETC. REDIRECIONAMENTO DE 1,5 % DAS LIBERACOES EFETIVADAS PELOS RESPECTIVOS FUNDOS, PARA APLICACOES VINCULADAS A ATIVIDADES DE PESQUISA E DESENVOLVIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.09.01', 'PRESTACAO DE SERVICOS DE DESENVOLVIMENTO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ANALISE E DESENVOLVIMENTO DE SISTEMAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.09.02', 'PRESTACAO DE SERV. LICENC/CESSAO DE DIREITO USO PROGRAMAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE LICENCIAMENTO OU CESSAO DE DIREITO DE USO DE PROGRAMAS DE COMPUTADOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.09.03', 'PRESTACAO DE SERVICOS DE MANUT. E ATUALIZACAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE MANUTENCAO E ATUALIZACAO DE SOFTWARE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.09.04', 'PRESTACAO DE SERVICOS DE INSTAL.E CONFIGURACAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE INSTALACAO E CONFIGURACAO DE SOFTWARE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.09.05', 'PRESTACAO DE SERVICOS DE PAGINAS ELETRONICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE PLANEJAMENTO, CONFECCAO, MANUTENCAO E ATUALIZACAO DE PAGINAS ELETRONICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.10.00', 'PRESTACAO DE SERVICOS DE ADM. DE REDE DE COMUNIC. DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE GERENCIAMENTO DE REDES DE COMUNICACAO DE DADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.11.00', 'SERVICOS DE PROCESSAMENTO DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VPA DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.12.00', 'SERVICO DE INFORMACOES CIENTIFICAS E TECNOLOGICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES CIENTIFICAS E TECNOLOGICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.13.00', 'PRESTACAO DE SERVICOS CIENTIFICOS E TECNOLOGICOS NUCLEARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS QUE ENVOLVAM INFORMACAO CIENTIFICA E TECNOLOGICA, APLICACOES DE TECNICAS NUCLEARES E RADIOISOTOPOS, METROLOGIA CIENTIFICA E INDUSTRIAL, RADIOMETRIA E DOSIMETRIA, CONSULTORIAS ASSISTENCIA TECNICA, ANALISE DE PROJETOS, ESTUDOS, PESQUISAS E DESENVOLVIMENTO DA ENERGIA NUCLEAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.14.00', 'SERVICOS DE TECNOLOGIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS TECNOLOGICOS PRESTADOS.VPA PROPORCIONADA POR: A) ANALISES QUIMICAS, ENSAIOS FISICOS E MECANICOS, CONTROLE E EXPERI-MENTACAO QUALITATIVA DE MATERIAS-PRIMAS, INSUMOS E PRODUTOS FABRICADOS; PADRONIZACAO E ESPECIFICACAO DE PRODUTOS; AJUSTES DOS PROCESSOS ETECNICAS DE PRODUCAO INDUSTRIAL (SISTEMA DE TECNOLOGIA) B) ESPECIFICACAO E CONTROLE DE QUALIDADE DE MEDICAMENTOS, INSUMOS FAR-MACEUTICOS, DROGAS, COSMETICOS, PRODUTOS QUIMICOS, ALIMENTOS, E OUTROS, POR MEIO DE PROVAS ESPECIFICAS DE IDENTIFICACAO, DE PUREZA E DETESTES DE CONTAMINACAO MICROBIOLOGICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.15.02', 'SERVICOS DE RADIODIFUSAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE RADIODIFUSAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.15.03', 'PRESTACAO DE SERVICOS DE AGENCIAMENTO DE PUBLICIDADE', 'REGISTRA O VALOR DE VPA AUFERIDAS PELA PRESTACAO DE SERVICOS DE AGENCIAMENTO DE PUBLICIDADE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.15.99', 'OUTROS SERVICOS DE COMUNICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS DE COMUNICACAO, TAIS COMO: SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.16.01', 'PRESTACAO DE SERVICOS DE ARMAZENAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ARMAZENAGEM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.16.02', 'PRESTACAO DE SERVICOS DE GARANTIA DE PRODUTOS ARMAZENADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE GARANTIA DE PRODUTOS ARMAZENADOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.17.00', 'PRESTACAO DE SERVICOS COMPLEMENTARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS COMPLEMENTARES QUANDO DA ESTOCAGEM EM ARMAZENAGEM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.18.01', 'PRESTACAO DE SERVICOS EXPURGO DE GRAOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO INSETICIDAS LIQUIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.18.02', 'PRESTACAO DE SERVICOS SECAGEM DE GRAOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO LENHA, OLEO DIESEL,ETC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.18.03', 'PRESTACAO DE SERVICOS LIMPEZA DOS GRAOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO MAQUINARIOS, COMO PENEIRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.19.00', 'PRESTACAO DE SERVICOS RECEPCAO E EMBARQUE DE PRODUTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE MOVIMENTACAO DOS PRODUTOS NOS ARMAZENS/CAMINHAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.20.00', 'PRESTACAO DE SERVICOS SERVICO DE TRANSBORDO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE TRANSBORDO DE MERCADORIAS DE TREM PARA CAMINHAO E VICE-VERSA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.21.00', 'FORNECIMENTO DE MAO-DE-OBRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO FORNECIMENTO DE MAO-DE-OBRA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.22.00', 'PRESTACAO DE SERVICOS DE DISTRIB. DE GENEROS ALIMENTICIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE DISTRIBUICAO DE GENEROS ALIMENTICIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.23.00', 'SERVICOS DE HOSPEDAGEM E ALIMENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE HOSPEDAGEM E ALIMENTACAO PRESTADOS. VPA PROPORCIONADA POR HOSPEDAGEM, COM OU SEM ALIMENTACAO, FORNECIMENTO DE REFEICOES, LANCHES E BEBIDAS PARA CONSUMO IMEDIATO. EXCLUEM AS VPA PROVENIENTES DE EMPRESAS FORNECEDORAS DE ALIMENTOS PREPARADOS PARA HOSPITAIS, FABRICAS, ETC... QUE SE CLASSIFICAM EM VPA DE PRODUTOS ALIMENTARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.24.01', 'OUTORGA DOS SERV. TRANSP. FERROV.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE FERROVIARIO A INICIATIVA PRIVADA, PROVENIENTE DA FISCALIZACAO, NORMATIZACAO E CONTROLE DOS SERVICOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.24.02', 'OUTORGA SERV.TRANSP.ROD.INTEREST.INTERNAC.PAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A CONCESSAO PELO PODER PUBLICO AO PARTICULAR DO DIREITO DE EXPLORACAO DOS SERVICOS DE TRANSPORTES RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.24.99', 'OUTRAS VPA DE CONC. PERMISS. SERV DE TRANSPORTE', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.25.01', 'OUTORGA DOS SERV. TELECOMUNICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE TELECOMUNICACOES, INCLUINDO O SERVICO MOVEL CELULAR E O SERVICO DE TRANSPORTE DE SINAIS DE TELECOMUNICACOES POR SATELITE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.25.02', 'OUTORGA SERV.RADIODIFUSAO SONORA SONS IMAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE RADIODIFUSAO SONORA E DE SONS E IMAGENS, INCLUINDO O USO DE RADIOFREQUENCIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.25.03', 'OUTORGA DIREITO DE USO RADIOFREQUENCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO ESTABELECIDA PELO PODER PUBLICO_AO PARTICULAR DO DIREITO DE USO DE RADIOFREQUENCIA PARA QUALQUER FIM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.25.04', 'TRANS.CONC.PERM.AUT.TELECOM.USO RADIOFREQ', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTE DE PRECO PUBLICO COBRADO PELA AGENCIA NACIONAL DE TELECOMUNICACOES - ANATEL, COMO CONDICAO PARA TRANSFERENCIA DE CONCESSAO, DE PERMISSAO OU DE AUTORIZACAO DE SERVICO DE TELECOMUNICACOES OU DE USO DE RADIOFREQUENCIA, A SER PAGO PELA CESSIONARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.25.05', 'TRANSF.CONC/PERM/AUTOR-RODOVIAS OU OBRAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO RATEIO DA VERBA DE FISCALIZACAO A SER COBRADA PELOS ESTADOS E DISTRITO FEDERAL (OU CONSORCIO ENTRE ELES), COM O MINISTERIO DOS TRANSPORTES - MT, NA PROPORCAO DE 5% SOBRE O VALOR PAGO MENSALMENTE, PELAS CONCESSIONARIAS, EM FUNCAO DE CONVENIOS FIRMADOS ENTRE A UNIAO E OS RESPECTIVOS ESTADOS, PARA DELEGACAO DE TRECHOS DE RODOVIAS FEDERAIS (OU OBRAS RODOVIARIAS FEDERAIS), CUJA EXPLORACAO, MEDIANTE CONTRATOS DE CONCESSAO, FOI ENTREGUE PELA UNIAO AOS ESTADOS PARA ADMINISTRACAO E EXPLORACAO. (EMENTARIO - PORTARIA Nº 39, DE 15 DE JUNHO DE 2009)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.25.06', 'OUTORGA UTILIZACAO POSICOES ORBITAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA PARA A UTILIZACAO DE POSICOES ORBITAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.25.07', 'OUTORGA LICENCA E AUTORIZ.AG.ESPAC.BRASILEIRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA DE LICENCAS E AUTORIZACOES DA AGENCIA ESPACIAL BRASILEIRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.25.99', 'OUTRAS VPA CONC. PERM. - SERV. COMUNIC', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICO DE COMUNICACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.26.01', 'BONUS DE ASSINATURA DE CONTRATO DE CONCESSAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO OFERECIDO NA PROPOSTA PARA OBTENCAO DA CONCESSAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.26.02', 'PAGAMENTO P/ RETENCAO AREA EXPLORACAO OU PROD', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO ANUAL PELA RETENCAO DE AREA PARA EXPLORACAO, DESENVOLVIMENTO OU PRODUCAO DE PETROLEO E GAS NATURAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.27.00', 'OUTORGA DE DIREITOS DE USO DE REC. HIDR.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA A PARTICULARES DE DIREITOS DE USO DA AGUA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.28.00', 'OUTORGA DIREITOS DE EXPL. E PESQ. MINER', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA PELA EXPLORACAO DE RECURSOS MINERAIS DEVIDO POR TODAS AS EMPRESAS QUE REALIZAM O APROVEITAMENTO DE UMA JAZIDA MINERAL GARANTIDA A ESSAS A PROPRIEDADE DO PRODUTO DA LAVRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.29.01', 'VPA DE CUSTOS DE EDITAL DE CONCESSAO FLORESTAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PRECO CALCULADO SOBRE OS CUSTOS DE REALIZACAO DO EDITAL DE LICITACAO DA CONCESSAO FLORESTAL DA UNIDADE DE MANEJO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.29.02', 'CONTRATOS TRANSICAO CONCESSAO FLORESTAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PRECO DECORRENTE DE CONTRATOS DE TRANSICAO DE CONCESSAO FLORESTAL PARA EXPLORACAO E GESTAO DE FLORESTAS PUBLICAS E RECURSOS FLORESTAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.30.01', 'CONCESS. DE DIREITO REAL USO AREA PUBLIC', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE AREA PUBLICA POR TERCEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.30.02', 'CONCESSAO DE USO DO POTENCIAL DE ENERGIA HIDR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA AUTORIZACAO OU CONCESSAO, POR PARTE DA UNIAO, DAEXPLORACAO E APROVEITAMENTO DOS POTENCIAIS DE ENERGIA HIDRAULICA. DESTINACAO LEGAL: MINISTERIO DE MINAS E ENERGIA;AMPARO LEGAL: - CONSTITUICAO FEDERAL (ART.20, VIII E 176, ÷1º) - LEI 8987/1995; LEI 9074/1995; - LEI 427/1996; - LEI 10438/2002; LEI 10762/2003; - LEI 10848/2004; - LEI 11488/2007.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.30.03', 'PERMISSAO DE USO AREA DA UNIAO CURTA DURACAO', 'REGISTRA VPA DECORRENTE DA PERMISSAO DE USO DE AREA DA UNIAO DE CURTA DURACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.30.04', 'RECEITA DA CESSAO DE USO DE BENS DA UNIAO', 'REGISTRA VPA DECORRENTE DA CESSAO DE USO DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.30.99', 'OUTRAS VPA CONC. PERM. - DIR. USO BENS PUBL.', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.31.01', 'UTIL.RECURSO HIDRICOS - ITAIPU', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMPENSACAO FINANCEIRA RELATIVA AOS ROYALTIES DEVIDOS POR ITAPU BINACIONAL DO BRASIL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.31.02', 'UTIL.RECURSO HIDRICOS - DEMAIS EMPRESAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMPENSACAO FINANCEIRA RELATIVA AOS ROYALTIES DEVIDOS PELA UTILIZACAO DE RECURSOS HIDRICOS PARA GERACAO DE ENERGIA ELETRICA POR OUTRAS EMPRESAS, EXCETO ITAIPU.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.31.03', 'EXPLORACAO DE RECURSOS MINERAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRIBUICOES ECONOMICAS A TITULO DE COTA-PARTE DE COMPENSACOES FINANCEIRAS SOBRE A EXPLORACAO DE RECURSOS MINERAIS. O PRODUTO DA ARRECADACAO DA COMPENSACAO FINANCEIRA PELAEXPLORACAO DE RECURSOS SAO DESTINADOS: A) 23% (VINTE E TRES POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; B) 65% (SESSENTA E CINCO POR CENTO) AOS MUNICIPIOS; C) 12% (DOZE POR CENTO) PARA O DEPARTAMENTO NACIONAL DE PRODUCAO MINE-RAL - DNPM. OS RECURSOS DA COTA-PARTE DESTINADOS AO DEPARTAMENTO NACIONAL DA PRO-DUCAO MINERAL - DNPM, QUE REPASSARA 2% (DOIS POR CENTO) AO IBAMA COM AFINALIDADE DE PROTECAO AMBIENTAL NAS REGIOES MINERADORAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.31.04', 'ROYALTIES PRODUCAO PETROLEO GAS.NAT.-EM TERRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA EXTRACAO DO OLEO BRUTO XISTO BETUMINOSO E GAS NATURAL. O PRODUTO DA COMPENSACAO FINANCEIRA PELA EXTRACAO, TEM A SEGUINTE DESTINACAO: - 3,5% (TRES E MEIO POR CENTO) AOS ESTADOS EXPORTADORES; 1% (UM PORCENTO) AOS MUNICIPIOS PRODUTORES;0,5%(MEIO POR CENTO) AOS MUNICIPIOSONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES DE EMBARQUE OUDESEMBARQUE DE OLEO OU GAS. E TAMBEM DEVIDA A COMPENSACAO FINANCEIRA AOS ESTADOS, DISTRITO FEDERALE MUNICIPIOS CONFRONTANTES, QUANDO O OLEO, XISTO E GAS FOREM EXTRAIDOSDA PLATAFORMA CONTINENTAL, NOS MESMOS 5% (CINCO POR CENTO) SENDO: - 1,5% (UM E MEIO POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIOPOR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OUTERRESTRES DE EMBARQUE E DESEMBARQUE DE OLEO OU GAS; 1,5% (UM E MEIO POR CENTO) AS MUNICIPIOS CONFRONTANTES E SUAS RESPECTIVAS AREAS GEOECONOMICAS; 0,5%(MEIO POR CENTO) PARA CONSTITUIR UM FUNDO ESPECIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.31.05', 'ROYALTIES PROD. PETR. GAS.NAT.-EM PLATAFORMA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM A EXTRACAO DO OLEO BRUTO, XISTO BETUMINOSO E GAS NATURAL. O PRODUTO DA ARRECADACAO DA COMPENSACAO FINANCEIRA PELA EXTRACAO, TEM A SEGUINTE DESTINACAO: - 3,5% (TRES E MEIO POR CENTO) AOS ESTADOS EXPORTADORES; 1% (UM POR CENTO) AOS MUNICIPIOS PRODUTORES;0,5%(MEIO POR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES DE EMBARQUE OU DESEMBARQUE DE OLEO OU GAS. E TAMBEM DEVIDA A COMPENSACAO FINANCEIRA AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS CONFRONTANTES, QUANDO O OLEO, XISTO E GAS FOREM EXTRAIDOS DA PLATAFORMA CONTINENTAL, NOS MESMOS 5% (CINCO POR CENTO) SENDO: POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIOPOR CENTO) - 1,5% (UM E MEIO POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIO POR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES E EMBARQUE E DESEMBARQUE DE OLEO OU GAS; 1,5% (UM E MEIO POR CENTO) AS MUNICIPIOS CONFRONTANTES E SUAS RESPECTIVAS AREAS GEOECONOMICAS; 0,5%(MEIO POR CENTO) PARA CONSTITUIR UM FUNDO ESPECIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.31.06', 'ROYALT.EXCED.PROD.PETR.OU GAS.NAT.-EM TERRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES COM A PARCELA DO VALOR DO ROYALTY QUE EXCEDER A 5% (CINCO POR CENTO) DA PRODUCAO DE PETROLEO OUGAS NATURAL TENDO A SEGUINTE DISTRIBUICAO: I - QUANDO A LAVRA OCORRER EM TERRA OU EM LAGOS, RIOS, ILHAS FLUVIAISE LACUSTRES: A) 52,5% (CINQUENTA E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS ES-TAODS ONDE OCORRER A PRODUCAO; B)15,0% (QUINZE POR CENTO) AOS MUNICIPIOS ONDE OCORRER A PRODUCAO; C)7,5% (SETE INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS QUESEJAM AFETADOS PELAS OPERACOES DE EMBARQUE E DESEMBARQUE DE PETROLEO EGAS NATURAL, NA FORMA E CRITERIO ESTABELECIDOS PELA ANP; D)25%(VINTE E CINCO POR CENTO) AO MINISTERIO DA CIENCIA E TECNOLOGIA; II - QUANDO A LAVRA OCORRER NA PLATAFORMA CONTINENTAL: A) 22,5%(VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.31.07', 'ROYALTIES EXCED.PROD.PETR.GAS.NAT.-PLATAFORMA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM A PARCELA DO VALOR DO ROYALTY QUE EXCEDER A 5% (CINCO POR CENTO) DA PRODUCAO DE PETROLEO OU GAS NATURAL TENDO A SEGUINTE DISTRIBUICAO: I QUANDO A LAVRA OCORRER EM TERRA OU EM LAGOS, RIOS, ILHAS FLUVIAIS E LACUSTRES: A) 5,5% (CINQUENTA E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS ESTADOS ONDE OCORRER A PRODUCAO; B)15,0 (QUINZE POR CENTO) AOS MUNICIPIOS ONDE OCORRER A PRODUCAO; C)7,5% (SETE INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS QUE SEJAM AFE TADOS PELAS OPERACOES DE EMBARQUE E DESEMBARQUE DE PETROLEO E GAS NATURAL, NA FORMA E CRITERIO ESTABELECIDOS PELA ANP; D)25%(VINTE CINCO POR CENTO) AO MINISTERIO DA CIENCIA E TECNOLOGIA; II - QUANDO A LAVRA OCORRER NA PLATAFORMA CONTINENTAL: A) 22,5%(VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS PRODUTORES', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.31.08', 'PARTICIP.ESPEC.PROD.PETROLEO OU GAS NATURAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PARTICIPACAO ESPECIAL NOS CASOS DE GRANDE VOLUME DE PRODUCAO DE PETROLEO, OU GRANDE RENTABILIDADE. OS RECURSOS DA PARTICIPACAO ESPECIAL SERAO DISTRIBUIDOS NAS SEGUINTESPROPORCOES: - 40% AO MINISTERIO DAS MINAS E ENERGIA, PARA O FINANCIAMENTO DE ESTU-DOS E SERVICOS DE GEOLOGIA E GEOFISICA APLICADOS A PROSPECAO DE PETRO-LEO E GAS NATURAL, A SEREM PROMOVIDOS PELA ANP; - 10% AO MINISTERIO DO MEIO AMBIENTE, DOS RECURSOS HIDRICOS E DA AMA-ZONIA LEGAL, DESTINADOS AO DESENVOLVIMENTO DE ESTUDOS E PROJETOS RELA-CIONADOS COM A PRESERVACAO DO MEIO AMBIENTE E RECUPERACAO DE DANOS AM-BIENTAIS CAUSADOS PELA INDUSTRIA DO PETROLEO; - 40% QUARENTA POR CENTO PARA O ESTADO ONDE OCORRER A PRODUCAO EM TER-RA, OU CONFRONTANTE COM A PLATAFORMA CONTINENTE ONDE SE REALIZAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.31.09', 'SUPRESSAO VEGETAL NAS FLORESTAS NACIONAIS', 'REGISTRA O VALOR DA VPA DA SUPRESSAO VEGETAL NO INTERIOR DAS FLORESTAS NACIONAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.32.01', 'SERVICOS DE TRANSPORTE RODOVIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS COM TRANSPORTE RODOVIARIO, TRANSPORTE RODOVIARIO DE PASSAGEIROS, DE CARGA OU MISTO, DE ESCOLARES, TAXI, DE ENCOMENDAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.32.02', 'SERVICOS DE TRANSPORTE FERROVIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE FERROVIARIO. VPA AUFERIDA NO TRANSPORTE FERROVIARIO DE PASSAGEIROS E DE CARGA, INCLUSIVE METROPOLITANO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.32.03', 'SERVICOS DE TRANSPORTE HIDROVIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE HIDROVIARIO. VPA DE SERVICOS DE TRANSPORTE HIDROVIARIO DE PASSAGEIROS, DE CARGA OU MISTO, DE LONGO CURSO, DE CABOTAGEM E POR VIAS INTERNAS (RIOS, LAGOS, ETC...)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.32.04', 'SERVICOS DE TRANSPORTE AEREO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE AEREO. VPA DE SERVICOS DE TRANSPORTE AEREO DE PASSAGEIROS, DE CARGA OU MISTO, TRANSPORTE AEREO REGULAR,TRANSPORTE AEREO REGIONAL, TAXI AEREO, AERONAVES FRETADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.32.99', 'OUTROS SERVICOS DE TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTROS SERVICOS DE TRANSPORTE, NAO CLASSIFICADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.33.00', 'SERVICOS PORTUARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PORTUARIOS. ABRANGEM OS RECURSOS ORIUNDOS DA EXPLORACAO DOS PORTOS, TERMINAIS MARITIMOS, ATRACADOUROS E ANCORADOUROS, REFERENTES A ESTIVA, DESESTIVA, DRAGAGEM, ATRACACAO, SINALIZACAO, COMUNICACAO NAUTICA, DOCAGEM, ETC....', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.34.00', 'SERVICOS DE SOCORRO MARITIMO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICO DE SOCORRO MARITIMO PRESTADO. VPA DE SERVICOS DE SALVAMENTO, POR NAVIO DE SOCORRO OU EQUIPE DE SALVAMENTO DA MARINHA, DE EMBARCACAO E CARGAS PERIGO (DESENCALHE, MERGULHO, OUTROS SOCORROS), BEM COMO SERVICOS DE REBOQUE MARITIMO, DENTRE OUTROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.35.01', 'SERVICOS HOSPITALARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE HOSPITAL EM GERAL OU ESPECIALIZADO, MATERNIDADE, CENTRO DE REABILITACAO, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.35.02', 'SERV.REG.AN.CONTR.PROD.SUJ.A NORM.VIGIL.SANIT', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE ANALISE E DE CONTROLE DE PRODUTOS SUJEITOS A NORMAS DE VIGILANCIA SANITARIA E O REGISTRO DE TODOS OS MEDICAMENTOS, DROGAS, INSUMOS FARMACEUTICOS E CORRELATOS, SANEANTES E OUTROS PRODUTOS, INCLUSIVE OS IMPORTADOS, OS EXPOSTOS A VENDA OU ENTREGUE AO CONSUMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.35.03', 'SERVICOS RADIOLOGICOS E LABORATORIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RADIOLOGICOS E LABORATORIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.35.04', 'SERV ASSIST SAUDE SUPLEMENTAR SERVIDOR CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PARTICIPACAO DA UNIAO, SUAS AUTARQUIAS E FUNDACOES PUBLICAS E DE RECURSOS PROVENIENTES DA CONTRIBUICAO DOS SERVIDORES PUBLICOS CIVIS ATIVOS, INATIVOS E PENSIONISTAS, DESTINADA AO CUSTEIO DA ASSISTENCIA AA SAUDE SUPLEMENTAR DO SERVIDOR CIVIL, NO CASO DE PRESTACAO DIRETA PELOS ORGAOS (GESTAO PROPRIA). AMPARO LEGAL: LEI 8.112/90, ART. 230 LEI 11.302/2006, ART. 9º PORTARIA SRH/MP 1983/2006 DESTINACAO LEGAL: INTEGRALMENTE DESTINADA AO CUSTEIO DA ASSISTENCIA AA SAUDE SUPLEMENTAR DO SERVIDOR CIVIL DA ADMINISTRACAO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.35.99', 'OUTROS SERVICOS DE SAUDE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTROS SERVICOS DE SAUDE, E NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.36.00', 'CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.37.01', 'METROLOGIA LEGAL E CERTIFICATORIA DELEGADA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA LEGAL E CERTIFICATORIA DELEGADA, ORIUNDAS DE ENTIDADES PUBLICAS OU PRIVADAS CREDENCIADAS. ESTA VPA ESTA AMPARADA PELA LEI NUM 5966DE 11 DE DEZEMBRO DE 1973.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.37.02', 'METROLOGIA CIENTIFICA E INDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA CIENTIFICA E INDUSTRIAL, NO TOCANTE A AFERICAO DE INSTRUMENTOS DE MEDICOES, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC...ESTA VPA ESTA AMPARADA PELA LEI NUM 5966 DE 11 DE DEZEMBRO DE 1973', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.37.03', 'METROLOGIA LEGAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METRO-LOGIA LEGAL, ORIUNDA DE SERVICOS METROLOGICOS LEGAIS. BASICAMENTE,CONSISTE EM ASSEGURAR A UNIFORMIDADE E A RACIONALIZACAO DAS UNIDADESEM TODO O TERRITORIO NACIONAL, AFERICAO DE INSTRUMENTOS DE MEDICOES,ETC. ESTA VPA ESTA AMPARADA PELA LEI 5966 DE 11/12/1973.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.37.04', 'CERTIFICACAO DE PRODUTOS E SERVICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CERTIFICACAO DA QUALIDADE DE MATERIAIS, PRODUTOS E SERVICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.37.05', 'INFORMACAO TECNOLOGICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES TECNOLOGICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.38.00', 'SERVICOS DE INSPECAO E FISCALIZACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INSPECAO E FISCALIZACAO PRESTADOS. VPA PROPORCIONADA PELA CONSTATACAO DAS CONDICOES HIGIENICO-SANITARIAS E TECNICAS DE PRODUTOS OU ESTABELECIMENTOS, OU RESULTANTES DE ACAO EXTERNA E DIRETA DOS ORGAOS DO PODER PUBLICO DESTINADA A VERIFICACAO DO CUMPRIMENTO DA LEGISLACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.39.00', 'SERVICOS ADMINISTRATIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS ADMINISTRATIVOS PRESTADOS, DAS ATIVIDADES DE APOIO ADMINSITRATIVO EXECUTADAS EM ORGANIZACOES DE QUALQUER NATUREZA, TAIS COMO: A)TAXAS DE EXPEDICAO DE CERTIFICADOS; B)TAXAS DE REGISTRO, RENOVACAO, VISTORIA, LICENCA, CADASTRAMENTO, ETC. C)DATILOGRAFIA, MICROFILMAGEM, COPIAS XEROGRAFICAS, HELIOGRAFICAS,FOTOSTATICAS, ETC.. D)TAXAS DE INSCRICAO EM CONCURSOS. E)TAXA DE ADMINISTRACAO DE SERVICOS. F)VENDA DE EDITAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.40.00', 'SERVICOS DE METEOROLOGIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METEOROLOGIA PRESTADOS. VPA PROPORCIONADA PELO FORNECIMENTO DE DADOS METEOROLOGICOS E DE PARECERES TECNICOS, BEM COMO CONSERTO, COMPARACAO E AFERICAO DE EQUIPAMENTOS DE METEOROLOGIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.41.00', 'SERVICOS EDUCACIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DO SISTEMA EDUCACIONAL, CUJA NATUREZA ESTEJA DIRETAMENTE RELACIONADA A FORMACAO DO EDUCANDO (MATRICULAS, ANUIDADES, ETC...). AS VPA DE ATIVIDADES AUXILIARES, DE APOIO OU DERIVADAS DOS SERVICOS EDUCACIONAIS PROPRIAMENTE DITOS, DEVEM SER CLASSIFICADAS NOS TITULOS APROPRIADOS. EXEMPLOS: MATRICULAS E ANUIDADES, SERVICOS EDUCACIONAIS, TAXAS DE EXPEDICAO DE DOCUMENTOS, COPIAS XEROGRAFICAS, HELIOGRAFICAS, ETC.., SERVICO DE CREDENCIAMENTO, AUTORIZACAO E RECONHECIMENTO DE CURSOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.42.00', 'SERVICOS AGROPECUARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS AGROPECUARIO: A)PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO,ARACAO,GRADEACAO, CALAGEM,ADUBACAO, DRENAGEM, IRRIGACAO, CAPINA, DESMATAMENTO, ETC.); B)SEMEADURA E PLANTIO; C)COMBATE A PRAGAS (PULVERIZACAO, DEDETIZACAO); D)COLHEITA E PREPARACAO DE PRODUTOS AGRICOLAS; E)INSEMINACAO ARTIFICIAL; F)INCUBACAO DE OVOS; G)VACINACAO DE ANIMAIS; H)OUTROS SERVICOS AUXILIARES DE AGRICULTURA E PECUARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.43.00', 'SERVICOS DE REPARACAO,MANUTENCAO E INSTALACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REPARACAO, MANUTENCAO E INSTALACAO PRESTADOS. VPA DE SERVICOS DE REPARACAO DE ARTEFATOS DE METAL; REPARACAO E MANUTENCAO DE MAQUINAS E APARELHOS DE USO DOMESTICO; REPARACAO, MANUTENCAO E INSTALACAO DE MAQUINAS E APARELHOS ELETRICOS E ELETRONICOS E DE COMUNICACAO; REPARACAO E MANUTENCAO DE INSTALACOES ELETRICAS, DE GAS, DE AGUA, ETC...INCLUEM-SE TAMBEM, NESSE TITULO, OS SERVICOS DE CONFECCAO SOB MEDIDA. NAO SAO CONSIDERADOS NESSE TITULO, CLASSIFICANDO-SE EM VPA INDUSTRIAL: REPARACAO E MANUTENCAO DE VEICULOS FERROVIARIOS, EMBARCACOES E AERONAVES (INDUSTRIA DE MATERIAL DE TRANSPORTE).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.44.00', 'SERVICOS RECREATIVOS E CULTURAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RECREATIVOS E CULTURAIS PRESTADOS. VPA PROPORCIONADA PELA EXPLORACAO DE INSTALACOES PARA RECREACAO, PRATICA DESPORTIVA E CULTURAL ( CINEMAS,TEATROS, SALOES PARA RECITAIS, CONCERTOS, CONFERENCIAS, PLANETARIOS,ESTADIOS DESPORTIVOS, AUTODROMOS, MUSEUS, BIBLIOTECAS, PROMOCAO E/OUPRODUCAO DE ESPETACULOS ARTISTICOS CULTURAIS E ESPORTIVOS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.45.01', 'SERVICOS DE PATENTES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PETICOES, PEDIDOS DE PRIVILEGIO, ANUIDADES DE PEDIDOS, REGISTROS DE DESENHO INDUSTRIAL,ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.45.02', 'SERVICOS DE REGISTRO DE MARCAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PEDIDOS DE REGISTRO DE MARCAS, VIGENCIAS DE MARCAS, PETICOES, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.45.03', 'SERVICOS DE TRANSFERENCIA DE TECNOLOGIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE AVERBACOES DE CONTRATOS, PETICOES, RECURSOS, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.45.04', 'SERVICOS DE REGISTRO INDICACOES GEOGRAFICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE EXPEDICOES DE CERTIFICADOS DE REGISTRO, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.45.06', 'SERVICOS DE REGISTRO DE DESENHO INDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE DESENHO INDUSTRIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.45.07', 'SERV. PROTECAO TOPOGRAFIAS CIRCUITOS INTEGRAD', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROTECAO DAS TOPOGRAFIAS DE CIRCUITOS INTEGRADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.45.08', 'SERVICOS DE REMESSA DE DEPOSITOS OFICIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REMESSA DE DEPOSITOOFICIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.45.99', 'OUTROS SERV.REGIST.MARCAS,PATENTES,TRANSF.TEC', 'REGISTRA AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE REGISTRO DE MARCAS,PATENTES,TRANSFERENCIA DE TECNOLOGIA, NAO CLASSIFICADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.46.00', 'SERVICOS DE REGISTRO DO COMERCIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DO COMERCIO PRESTADOS. VPA ADVINDA DA PRESTACAO DE SERVICOS DE REGISTRO DO COMERCIO E ATIVIDADES AFINS, TRATANDO-SE DE: A) SERVICOS PRESTADOS PELA JUNTA COMERCIAL DO DISTRITO FEDERAL; B) SERVICOS CONSTANTES DO CADASTRO NACIONAL DE EMPRESA, DEVIDOS NO AMBITO DAS JUNTAS COMERCIAIS DOS ESTADOS E DO DISTRITO FEDERAL; C) REMUNERACAO DE SERVICOS PRESTADOS PELO DEPARTAMENTO NACIONAL DE REGISTRO DO COMERCIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.47.00', 'SERVICOS DE FORNECIMENTO DE AGUA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE FORNECIMENTO DE AGUA AOS IRRIGANTES AA AMORTIZACAO DOS INVESTIMENTOS DA INFRA-ESTRUTURA DE IRRIGACAO DOS PROJETOS PUBLICOS, CONFORME DEC.89.496, DE 29.03DE 84, RELATIVOS A TARIFAS K-1 E K-2.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.48.00', 'SERVICOS DE PERFURACAO E INSTALACAO DE POCOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE PERFURACAO EINSTALACAO DE POCOS TUBULARES PROFUNDOS, POCOS ARTESIANOS OU SIMILARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.49.00', 'SERVICOS DE GEOPROCESSAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS A TERCEIROS DE INTERPRETACAO DE IMAGEM AEROFOTOGRAMETRICA,EXECUCAO DE MAPAS DIGITALIZADOS DIVERSOS, VENDA DE CARTAS E IMAGENS DE SATELITES, VIDEOGRAFICAS E SIMILARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.50.00', 'SERVICOS DE CADASTRAMENTO DE FORNECEDORES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE CADASTRAMENTO DE EMPRESAS FORNECEDORAS DE BENS E SERVICOS AO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.51.00', 'TARIFA DE UTILIZACAO DE FAROIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA DE UTILIZACAO DE FAROIS. VPA PROVENIENTE DA EFETIVA UTILIZACAO, POR EMBARCACOES ESTRANGEIRAS, DOS SERVICOS DE SINALIZACAO NAUTICA DE PROTECAO A NAVEGACAO. O PRODUTO DA ARRECADACAO E DESTINADO INTEGRALMENTE AO FUNDO NAVAL PARA APLICACAO NOS SERVICOS QUE ENVOLVAM A MANUTENCAO E AMPLIACAO DA REDE DE BALIZAMENTO MARITIMO, FLUVIAL E LACUSTRE, A CARGO DA DIRETORIA DE HIDROGRAFIA E NAVEGACAO DO MINISTERIO DA MARINHA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.52.01', 'TARIFA AEROPORTUARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA COBRADA POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTILIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPA-TAZIA).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.52.02', 'ADICIONAL SOBRE TARIFA AEROPORTUARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ADICIONAL SOBRE TARIFA AEROPORTUARIA. VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO ADICIONAL SOBRE A TARIFA COBRADAPOR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AE-ROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTILIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIASEM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.52.03', 'PARCELA DA TARIFA DE EMBARQUE INTERNACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PARCELA DA TARIFA DE EMBARQUE INTERNACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.53.00', 'SERVICOS DE CADASTRO DA ATIVIDADE MINERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE AUTORIZACAO DE PESQUISA MINERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.54.01', 'TARIF USO COMUN E AUX.NAVEGACAO AEREA EM ROTA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE DA UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA,PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA OU POR ENTIDADE ESPECIA-LIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. FATO GERADOR: UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA. AMPARO LEGAL: DECRETO-LEI 1896/1981 E DECRETO 86.864/1982.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.54.02', 'ADICIONAL S/ TARIFA USO COM E AUX NAVEG AEREA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO ADICIONAL DE 50% SOBRE AS TARIFAS DE UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA,PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA OU POR ENTIDADE ESPECIALIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. FATO GERADOR: ADICIONAL SOBRE AS TARIFAS RELATIVAS AO USO DOS AUXILIOSAA NAVEGACAO AEREA E DAS TELECOMUNICACOES. DESTINACAO LEGAL: MINISTERIO DA AERONAUTICA OU ENTIDADE DA ADMINISTRA-CAO INDIRETA RESPONSAVEL PELA PRESTACAO DOS SERVICOS. AMPARO LEGAL: LEI 7920/1989 - ART 1.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.55.00', 'TAR.INSCR.CONCURSOS E PROCESSOS SELETIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE INSCRICAO EM CONCURSOS E PROCESSOS SELETIVOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.56.00', 'SERVICO DE COMPENSACAO DE VARIACOES SALARIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COBRANCA DE CONTRIBUICOES SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO-SFH E SOBRE O SALDO DOS FINANCIAMENTOS IMOBILIARIOS CONCEDIDOS PELOS AGENTES FINANCEIROS DO SFH,COM COBERTURA DO FCVS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.57.01', 'TARIFA PELO USO DO SISTEMA DE INFORM.DO BACEN', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO USO DO SISTEMA DE INFORMACOES DO BACEN.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.57.02', 'TARIFA PELO USO DO SIST.DE TRANSF. RES. BACEN', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO USO DO SISTEMA DE TRANSFERENCIA DE RESERVA DO BACEN.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.58.01', 'CONCESSAO DE AVAL DO TESOURO NACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO DE AVAL DO TESOURO NACIONAL, COBRADA A TITULO DE COMISSAO, EXECUCAO OU FISCALIZACAO PELA CONCESSAO DE GARANTIA DO TESOURO NACIONAL A CREDITOS OBTIDOS NO EXTERIOR. FATO GERADOR: A CONCESSAO DE GARANTIA DO TESOURO NACIONAL A CREDITOS OBTIDOS NO EXTERIOR. AMPARO LEGAL: LEI 5.000, DE 24 DE MAIO DE 1966.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.58.02', 'CONCESSAO GARANTIA DA ATIVIDADE AGROPECUARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ADICIONAL COBRADO SOBRE EMPRESTIMOS RURAIS DE CUSTEIO. TEM COMO FINALIDADE EXIMIR O PRODUTOR RURAL DE POSSIVEIS OBRIGACOES RELATIVAS A OPERACOES DE CREDITO CUJA LIQUIDACAO SEJA DIFICULTADA POR FENOMENOS NATURAIS, DOENCAS OUPRAGAS. FATO GERADOR: A REALIZACAO DE EMPRESTIMOS RURAIS DE CUSTEIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.58.03', 'COMISSOES PELA PRESTACAO DE GARANTIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMISSOES COBRADAS POR CONTA DA GARANTIA DE OPERACOES DE FINANCIAMENTO PARA AUMENTO DA COMPETITIVIDAD EE DA PRODUCAO DESTINADA AA EXPORTACAO. FATO GERADOR: COBRANCA DE COMISSOES, POR CONTA DA GARANTIA DE OPERACOES DE FINANCIAMENTO, PARA AUMENTO DA COMPETITIVIDADE E DA PRODUCAODESTINADA AA EXPORTACAO. DESTINACAO LEGAL: - MICROEMPRESAS E EMPRESAS DE PEQUENO PORTE; - MEDIAS EMPRESAS QUE SEJAM EXPORTADORAS OU FABRICANTES DE INSUMOS QUEINTEGREM O PROCESSO PRODUTIVO, OU DE MONTAGEM E DE EMBALAGEM DE MERCA-DORIAS DESTINADAS AA EXPORTACAO. AMPARO LEGAL: LEI 9531, DE 10 DE DEZEMBRO DE 1997, ÷ 1º, 2º E 3º.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.58.04', 'GARANTIA DOS FINANC.AA ESTOC.ALCOOL ETIL.COMB', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO DE GARANTIAS E AVAIS NOS FINANCIAMENTOS A ESTOCAGEM DE ALCOOL ETILICO COMBUSTIVEL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.58.05', 'RECEITA DE SEGURO DE CREDITO AA EXPORTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA GARANTIA DAS OPERACOES DE CREDITO AA EXPORTACAO CONTRA OS RISCOS COMERCIAIS, POLITICOS E EXTRAORDINARIOS QUE POSSAM AFETAR A PRODUCAO DE BENS E A PRESTACAO DE SERVICOS DESTINADOS AA EXPORTACAO OU AS EXPORTACOES BRASILEIRAS DE BENS E SERVICOS. AMPARO LEGAL: - LEI 9.818, DE 23 DE AGOSTO DE 1999 - LEI 6.704, DE 26 DE OUTUBRO DE 1979, ART.1º', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.59.00', 'CREDENCIAMENTO EMP.PREST.SERVICOS DE VISTORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO VALOR A SER PAGO POR EMPRESAS NA OBTENCAO DE CREDENCIAMENTO PARA PRESTACAO DE SERVICOS DE VISTORIA. - DESTINACAO LEGAL: ORGAO ARRECADADOR; - AMPARO LEGAL: RESOLUCAO CONTRAN 282, DE 26 DE JUNHO DE 2008.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.60.00', 'SERVICOS VETERINARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS VETERINARIOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.61.00', 'CERTIFICACAO E HOMOLOGACAO ATIVIDADE MINERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE REGISTRO DE LICENCA E DO REGISTRO DE PERMISSAO DE LAVRA GARIMPEIRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.62.01', 'SERV.PREST.DIRET. POR INST.CIENT.TECNOLOGICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DIRETAMENTE POR INSTITUICOES CIENTIFICAS E TECNOLOGICAS, VOLTADOS A INOVACAO E A PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.62.02', 'SERV.DECORREN.PARCEIR.C/OUTRAS INST.PUB.PRIV.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA CELEBRACAO DE ACORDOS DE PARCERIA PARA REALIZACAO DE ATIVI-DADES CONJUNTAS DE PESQUISA CIENTIFICA E TECNOLOGICA E DESENVOLVIMENTODE TECNOLOGIA, PRODUTO OU PROCESSO, COM INSTITUICOES PUBLICAS E PRIVA-DAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.63.01', 'SERV.FINANC.DE COMPENS.DE VARIACOES SALARIAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM SERVICOS FINANCEIROS DE COMPENSACAO DE VARIACOES SALARIAIS. VPA PROVENIENTE DE ADICIONAL COBRADO SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DA HABITACAO. TEM COMO FINALIDADE EXIMIR OS ADQUIRENTES DE CASA PROPRIA DO PAGAMENTO DE POSSIVEIS RESIDUOS DO SALDO DEVEDOR DO FINANCIAMENTO IMOBILIARIO EXISTENTES AO FINAL DO PRAZO CONTRATADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.63.02', 'SERVICOS DE REMUNERACAO REP. PROG.DES.ECONOM.', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM SERVICOS DE REMUNERACAO DE REPASSES DE PROGRAMA DE DESENVOLVIMENTO ECONOMOMICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.63.03', 'COMISSOES PELA PREST. DE GARANTIA', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM COMISSOES PELA PREST. DE GARANTIA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.63.99', 'OUTROS SERVICOS FINANCEIROS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM OUTROS SERVICOS FINANCEIROS, NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.64.01', 'SERVICO DE EMISSAO DE CERTIFICADOS DE ORIGEM', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE CERTIFICADOS DE ORIGEM', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.64.02', 'SERVICO DE EMISSAO DE LICENCA DE EXPORTACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE LICENCA DE EXPORTACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.65.00', 'VPA DE UTILIZACAO DE POSICOES ORBITAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE UTILIZACAO DE POSICOES ORBITAIS, CUJOS RECURSOS SAO PROVENIENTES DE: 25 POR CENTO DA VPA QUE SE REFEREM O ARTIGO 2 DA LEI 5070/96,PROVENIENTES DA UTILIZACAO DE POSICOES ORBITAIS 25 POR CENTO DA VPA DA UNIAO, PROVENIENTES DE LANCAMENTOS, EM CARATER COMERCIAL, DE SATELITES E FOGUETES DE SONDAGEM A PARTIR DO TERRITORIO BRASILEIRO 25 POR CENTO DA VPA AUFERIDAS PELA UNIAO, PROVENIENTES DA COMERCIALIZACAO DOS DADOS E IMAGENS OBTIDOS POR MEIOS DE RASTREAMENTO, TELEMEDIDAS E CONTROLE DE FOGUETES E SATELITES TOTAL DA VPA AUFERIDA PELA AGENCIA ESPACIAL BRASILEIRA - AEB, DECORRENTES DA CONCESSAO DE LICENCAS E AUTORIZACOES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.66.00', 'VPA COM.DADOS/IMAGENS UTIL.POSICOES ORBITAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DOS DADOS E IMAGENS ORIUNDOS DA UTILIZACAO DE POSICOES ORBITAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.67.00', 'VPA LANCAM.SATELITES E FOGUETES DE SONDAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LANCAMENTOS DE SATELITES E FOGUETES DE SONDAGEM, A PARTIR DO TERRITORIO BRASILEIRO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.68.00', 'SERV.COMERCIAIS DE PROD.DADOS E MAT.INFORMATI', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS, DADOS E MATERIAIS DE INFORMATICA, TAIS COMO DISQUETES,SOFTWARES, PROGRAMAS, CD-ROM, FITAS MAGNETICAS E ASSEMELHADOS, BEM COMO INFORMACOES EM REDES E SISTEMAS DE DADOS DISPONIVEIS EM MEIO DE HARDWARE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.69.00', 'REC.OUTORGA TIT ONEROSO ATIV PESQ/LAVRA-PETRO', 'REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CESSAO A TITULO ONEROSO DAS ATIVIDADES DE PESQUISA E LAVRA DAS JAZIDAS DE PETROLEO E GAS NATURAL E OUTROS HIDROCARBONETOS FLUIDOS, BEM COMO O SEU REFINO E TRANSPORTE MARITIMO. DESTINACAO LEGAL: TESOURO NACIONAL AMPARO LEGAL: ART 177 DA CONSTITUICAO FEDERAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.99.00', 'OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.01.00', 'PRESTACAO DE SERVICOS POSTAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POSTAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.02.00', 'PRESTACAO DE SERVICOS DE TREINAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE INSTRUCAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.03.01', 'ALUGUEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS PELA UTILIZACAO DE TERCEIROS DE IMOVEIS PROPRIOS DO PODER PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.03.02', 'ARRENDAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRATO PELO QUAL O PODER PUBLICO CEDE A TERCEIROS, POR CERTO TEMPO E PRECO, O USO E GOZO DE DE TERMINADA AREA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.03.03', 'FOROS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PAGAS PELA PESSOA QUE RECEBE POR ENFITEUSE O DOMINIO UTIL DE UM IMOVEL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.03.04', 'LAUDEMIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENSAO OU PREMIO QUE O FOREIRO PAGA, QUANDO HA ALIENACAO DO RESPECTIVO PREDIO POR PARTE DA PESSOA QUE RECEBE POR ENFITEUSE O DOMINIO DO IMOVEL, EXCETO NOS CASOS DE SUCESSAO HEREDITARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.03.05', 'TAXA DE OCUPACAO DE TERRENOS DA UNIAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE TERRENOS DE MARINHA E DEMAIS TERRENOS DE PROPRIEDADE DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.03.06', 'TAXA OCUPACAO IMOVEIS FUN. PROP. NAC. RESID.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE IMOVEIS FUNCIONAIS E PROPRIOS NACIONAIS RESIDENCIAIS DA UNIAO, AGENTES POLITICOS E SERVIDORES PUBLICOS FEDERAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.03.07', 'TAXA DE OCUPACAO DE OUTROS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE OUTROS BENS IMOVEIS DE PROPRIEDADE DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.03.99', 'OUTRAS VPA DE EXPLORACAO DE BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS ORIGENS NA FRUICAO DO PATRIMONIO IMOBILIARIO, NAO ENQUADRADAS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.04.00', 'PRESTACAO DE SERVICOS DE LOCACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS, EXCETO ALUGUEIS DE IMOVEIS, QUE JA POSSUI RUBRICA PROPRIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.05.00', 'PRESTACAO DE SERVICOS DE PESQUISAS E ANALISES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PESQUISAS E ANALISE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.06.00', 'SERVICOS DE ESTUDOS E PESQUISAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PESQUISAS E ESTUDOS TECNICO-SOCIAIS, ECONOMICOS, CIENTIFICOS, CULTURAIS ETC., REALIZADAS SOB CONTRATO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.07.00', 'PRESTACAO DE SERVICOS DE CONSULTORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ASSESSORIA E CONSULTORIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.08.01', 'SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS - APLICACOES LIVRES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONSULTORIAS TECNICO - FINACEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ASSISTENCIA TECNICA E EXTENSAO RURAL, ETC. REDIRECIONAMENTO DE 2% DAS LIBERACOES EFETIVADAS PELOS RESPECTIVOS FUNDOS, PARA APLICACOES LIVRES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.08.02', 'SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS - APLICACOES VINCULADAS A ATIVIDADES DE PESQUISA E DESENVOLVIMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONSULTORIAS TECNICO - FINACEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ASSISTENCIA TECNICA E EXTENSAO RURAL, ETC. REDIRECIONAMENTO DE 1,5 % DAS LIBERACOES EFETIVADAS PELOS RESPECTIVOS FUNDOS, PARA APLICACOES VINCULADAS A ATIVIDADES DE PESQUISA E DESENVOLVIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.09.01', 'PRESTACAO DE SERVICOS DE DESENVOLVIMENTO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ANALISE E DESENVOLVIMENTO DE SISTEMAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.09.02', 'PRESTACAO DE SERV. LICENC/CESSAO DE DIREITO USO PROGRAMAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE LICENCIAMENTO OU CESSAO DE DIREITO DE USO DE PROGRAMAS DE COMPUTADOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.09.03', 'PRESTACAO DE SERVICOS DE MANUT. E ATUALIZACAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE MANUTENCAO E ATUALIZACAO DE SOFTWARE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.09.04', 'PRESTACAO DE SERVICOS DE INSTAL.E CONFIGURACAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE INSTALACAO E CONFIGURACAO DE SOFTWARE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.09.05', 'PRESTACAO DE SERVICOS DE PAGINAS ELETRONICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE PLANEJAMENTO, CONFECCAO, MANUTENCAO E ATUALIZACAO DE PAGINAS ELETRONICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.10.00', 'PRESTACAO DE SERVICOS DE ADM. DE REDE DE COMUNIC. DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE GERENCIAMENTO DE REDES DE COMUNICACAO DE DADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.11.00', 'SERVICOS DE PROCESSAMENTO DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VPA DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.12.00', 'SERVICO DE INFORMACOES CIENTIFICAS E TECNOLOGICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES CIENTIFICAS E TECNOLOGICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.13.00', 'PRESTACAO DE SERVICOS CIENTIFICOS E TECNOLOGICOS NUCLEARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS QUE ENVOLVAM INFORMACAO CIENTIFICA E TECNOLOGICA, APLICACOES DE TECNICAS NUCLEARES E RADIOISOTOPOS, METROLOGIA CIENTIFICA E INDUSTRIAL, RADIOMETRIA E DOSIMETRIA, CONSULTORIAS ASSISTENCIA TECNICA, ANALISE DE PROJETOS, ESTUDOS, PESQUISAS E DESENVOLVIMENTO DA ENERGIA NUCLEAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.14.00', 'SERVICOS DE TECNOLOGIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS TECNOLOGICOS PRESTADOS.VPA PROPORCIONADA POR: A) ANALISES QUIMICAS, ENSAIOS FISICOS E MECANICOS, CONTROLE E EXPERI-MENTACAO QUALITATIVA DE MATERIAS-PRIMAS, INSUMOS E PRODUTOS FABRICADOS; PADRONIZACAO E ESPECIFICACAO DE PRODUTOS; AJUSTES DOS PROCESSOS ETECNICAS DE PRODUCAO INDUSTRIAL (SISTEMA DE TECNOLOGIA) B) ESPECIFICACAO E CONTROLE DE QUALIDADE DE MEDICAMENTOS, INSUMOS FAR-MACEUTICOS, DROGAS, COSMETICOS, PRODUTOS QUIMICOS, ALIMENTOS, E OUTROS, POR MEIO DE PROVAS ESPECIFICAS DE IDENTIFICACAO, DE PUREZA E DETESTES DE CONTAMINACAO MICROBIOLOGICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.15.01', 'SERVICOS DE PUBLICIDADE LEGAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE AGENCIAMENTO DE PUBLICIDADE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.15.02', 'SERVICOS DE RADIODIFUSAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE RADIODIFUSAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.15.03', 'PRESTACAO DE SERVICOS DE AGENCIAMENTO DE PUBLICIDADE', 'REGISTRA O VALOR DE VPA AUFERIDAS PELA PRESTACAO DE SERVICOS DE AGENCIAMENTO DE PUBLICIDADE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.15.99', 'OUTROS SERVICOS DE COMUNICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS DE COMUNICACAO, TAIS COMO: SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.16.01', 'PRESTACAO DE SERVICOS DE ARMAZENAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ARMAZENAGEM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.16.02', 'PRESTACAO DE SERVICOS DE GARANTIA DE PRODUTOS ARMAZENADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE GARANTIA DE PRODUTOS ARMAZENADOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.17.00', 'PRESTACAO DE SERVICOS COMPLEMENTARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS COMPLEMENTARES QUANDO DA ESTOCAGEM EM ARMAZENAGEM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.18.01', 'PRESTACAO DE SERVICOS EXPURGO DE GRAOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO INSETICIDAS LIQUIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.18.02', 'PRESTACAO DE SERVICOS SECAGEM DE GRAOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO LENHA, OLEO DIESEL,ETC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.18.03', 'PRESTACAO DE SERVICOS LIMPEZA DOS GRAOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO MAQUINARIOS, COMO PENEIRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.19.00', 'PRESTACAO DE SERVICOS RECEPCAO E EMBARQUE DE PRODUTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE MOVIMENTACAO DOS PRODUTOS NOS ARMAZENS/CAMINHAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.20.00', 'PRESTACAO DE SERVICOS SERVICO DE TRANSBORDO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE TRANSBORDO DE MERCADORIAS DE TREM PARA CAMINHAO E VICE-VERSA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.21.00', 'FORNECIMENTO DE MAO-DE-OBRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO FORNECIMENTO DE MAO-DE-OBRA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.22.00', 'PRESTACAO DE SERVICOS DE DISTRIB. DE GENEROS ALIMENTICIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE DISTRIBUICAO DE GENEROS ALIMENTICIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.23.00', 'SERVICOS DE HOSPEDAGEM E ALIMENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE HOSPEDAGEM E ALIMENTACAO PRESTADOS. VPA PROPORCIONADA POR HOSPEDAGEM, COM OU SEM ALIMENTACAO, FORNECIMENTO DE REFEICOES, LANCHES E BEBIDAS PARA CONSUMO IMEDIATO. EXCLUEM AS VPA PROVENIENTES DE EMPRESAS FORNECEDORAS DE ALIMENTOS PREPARADOS PARA HOSPITAIS, FABRICAS, ETC... QUE SE CLASSIFICAM EM VPA DE PRODUTOS ALIMENTARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.24.01', 'OUTORGA DOS SERV. TRANSP. FERROV.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE FERROVIARIO A INICIATIVA PRIVADA, PROVENIENTE DA FISCALIZACAO, NORMATIZACAO E CONTROLE DOS SERVICOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.24.02', 'OUTORGA SERV.TRANSP.ROD.INTEREST.INTERNAC.PAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A CONCESSAO PELO PODER PUBLICO AO PARTICULAR DO DIREITO DE EXPLORACAO DOS SERVICOS DE TRANSPORTES RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.24.99', 'OUTRAS VPA DE CONC. PERMISS. SERV DE TRANSPORTE', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.25.01', 'OUTORGA DOS SERV. TELECOMUNICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE TELECOMUNICACOES, INCLUINDO O SERVICO MOVEL CELULAR E O SERVICO DE TRANSPORTE DE SINAIS DE TELECOMUNICACOES POR SATELITE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.25.02', 'OUTORGA SERV.RADIODIFUSAO SONORA SONS IMAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE RADIODIFUSAO SONORA E DE SONS E IMAGENS, INCLUINDO O USO DE RADIOFREQUENCIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.25.03', 'OUTORGA DIREITO DE USO RADIOFREQUENCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO ESTABELECIDA PELO PODER PUBLICO_AO PARTICULAR DO DIREITO DE USO DE RADIOFREQUENCIA PARA QUALQUER FIM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.25.04', 'TRANS.CONC.PERM.AUT.TELECOM.USO RADIOFREQ', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTE DE PRECO PUBLICO COBRADO PELA AGENCIA NACIONAL DE TELECOMUNICACOES - ANATEL, COMO CONDICAO PARA TRANSFERENCIA DE CONCESSAO, DE PERMISSAO OU DE AUTORIZACAO DE SERVICO DE TELECOMUNICACOES OU DE USO DE RADIOFREQUENCIA, A SER PAGO PELA CESSIONARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.25.05', 'TRANSF.CONC/PERM/AUTOR-RODOVIAS OU OBRAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO RATEIO DA VERBA DE FISCALIZACAO A SER COBRADA PELOS ESTADOS E DISTRITO FEDERAL (OU CONSORCIO ENTRE ELES), COM O MINISTERIO DOS TRANSPORTES - MT, NA PROPORCAO DE 5% SOBRE O VALOR PAGO MENSALMENTE, PELAS CONCESSIONARIAS, EM FUNCAO DE CONVENIOS FIRMADOS ENTRE A UNIAO E OS RESPECTIVOS ESTADOS, PARA DELEGACAO DE TRECHOS DE RODOVIAS FEDERAIS (OU OBRAS RODOVIARIAS FEDERAIS), CUJA EXPLORACAO, MEDIANTE CONTRATOS DE CONCESSAO, FOI ENTREGUE PELA UNIAO AOS ESTADOS PARA ADMINISTRACAO E EXPLORACAO. (EMENTARIO - PORTARIA Nº 39, DE 15 DE JUNHO DE 2009)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.25.06', 'OUTORGA UTILIZACAO POSICOES ORBITAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA PARA A UTILIZACAO DE POSICOES ORBITAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.25.07', 'OUTORGA LICENCA E AUTORIZ.AG.ESPAC.BRASILEIRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA DE LICENCAS E AUTORIZACOES DA AGENCIA ESPACIAL BRASILEIRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.25.99', 'OUTRAS VPA CONC. PERM. - SERV. COMUNIC', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICO DE COMUNICACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.26.01', 'BONUS DE ASSINATURA DE CONTRATO DE CONCESSAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO OFERECIDO NA PROPOSTA PARA OBTENCAO DA CONCESSAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.26.02', 'PAGAMENTO P/ RETENCAO AREA EXPLORACAO OU PROD', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO ANUAL PELA RETENCAO DE AREA PARA EXPLORACAO, DESENVOLVIMENTO OU PRODUCAO DE PETROLEO E GAS NATURAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.27.00', 'OUTORGA DE DIREITOS DE USO DE REC. HIDR.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA A PARTICULARES DE DIREITOS DE USO DA AGUA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.28.00', 'OUTORGA DIREITOS DE EXPL. E PESQ. MINER', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA PELA EXPLORACAO DE RECURSOS MINERAIS DEVIDO POR TODAS AS EMPRESAS QUE REALIZAM O APROVEITAMENTO DE UMA JAZIDA MINERAL GARANTIDA A ESSAS A PROPRIEDADE DO PRODUTO DA LAVRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.29.01', 'VPA DE CUSTOS DE EDITAL DE CONCESSAO FLORESTAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PRECO CALCULADO SOBRE OS CUSTOS DE REALIZACAO DO EDITAL DE LICITACAO DA CONCESSAO FLORESTAL DA UNIDADE DE MANEJO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.29.02', 'CONTRATOS TRANSICAO CONCESSAO FLORESTAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PRECO DECORRENTE DE CONTRATOS DE TRANSICAO DE CONCESSAO FLORESTAL PARA EXPLORACAO E GESTAO DE FLORESTAS PUBLICAS E RECURSOS FLORESTAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.30.01', 'CONCESS. DE DIREITO REAL USO AREA PUBLIC', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE AREA PUBLICA POR TERCEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.30.02', 'CONCESSAO DE USO DO POTENCIAL DE ENERGIA HIDR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA AUTORIZACAO OU CONCESSAO, POR PARTE DA UNIAO, DAEXPLORACAO E APROVEITAMENTO DOS POTENCIAIS DE ENERGIA HIDRAULICA. DESTINACAO LEGAL: MINISTERIO DE MINAS E ENERGIA;AMPARO LEGAL: - CONSTITUICAO FEDERAL (ART.20, VIII E 176, ÷1º) - LEI 8987/1995; LEI 9074/1995; - LEI 427/1996; - LEI 10438/2002; LEI 10762/2003; - LEI 10848/2004; - LEI 11488/2007.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.30.03', 'PERMISSAO DE USO AREA DA UNIAO CURTA DURACAO', 'REGISTRA VPA DECORRENTE DA PERMISSAO DE USO DE AREA DA UNIAO DE CURTA DURACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.30.04', 'RECEITA DA CESSAO DE USO DE BENS DA UNIAO', 'REGISTRA VPA DECORRENTE DA CESSAO DE USO DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.30.99', 'OUTRAS VPA CONC. PERM. - DIR. USO BENS PUBL.', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.31.01', 'UTIL.RECURSO HIDRICOS - ITAIPU', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMPENSACAO FINANCEIRA RELATIVA AOS ROYALTIES DEVIDOS POR ITAPU BINACIONAL DO BRASIL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.31.02', 'UTIL.RECURSO HIDRICOS - DEMAIS EMPRESAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMPENSACAO FINANCEIRA RELATIVA AOS ROYALTIES DEVIDOS PELA UTILIZACAO DE RECURSOS HIDRICOS PARA GERACAO DE ENERGIA ELETRICA POR OUTRAS EMPRESAS, EXCETO ITAIPU.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.31.03', 'EXPLORACAO DE RECURSOS MINERAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRIBUICOES ECONOMICAS A TITULO DE COTA-PARTE DE COMPENSACOES FINANCEIRAS SOBRE A EXPLORACAO DE RECURSOS MINERAIS. O PRODUTO DA ARRECADACAO DA COMPENSACAO FINANCEIRA PELAEXPLORACAO DE RECURSOS SAO DESTINADOS: A) 23% (VINTE E TRES POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; B) 65% (SESSENTA E CINCO POR CENTO) AOS MUNICIPIOS; C) 12% (DOZE POR CENTO) PARA O DEPARTAMENTO NACIONAL DE PRODUCAO MINE-RAL - DNPM. OS RECURSOS DA COTA-PARTE DESTINADOS AO DEPARTAMENTO NACIONAL DA PRO-DUCAO MINERAL - DNPM, QUE REPASSARA 2% (DOIS POR CENTO) AO IBAMA COM AFINALIDADE DE PROTECAO AMBIENTAL NAS REGIOES MINERADORAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.31.04', 'ROYALTIES PRODUCAO PETROLEO GAS.NAT.-EM TERRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA EXTRACAO DO OLEO BRUTO XISTO BETUMINOSO E GAS NATURAL. O PRODUTO DA COMPENSACAO FINANCEIRA PELA EXTRACAO, TEM A SEGUINTE DESTINACAO: - 3,5% (TRES E MEIO POR CENTO) AOS ESTADOS EXPORTADORES; 1% (UM PORCENTO) AOS MUNICIPIOS PRODUTORES;0,5%(MEIO POR CENTO) AOS MUNICIPIOSONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES DE EMBARQUE OUDESEMBARQUE DE OLEO OU GAS. E TAMBEM DEVIDA A COMPENSACAO FINANCEIRA AOS ESTADOS, DISTRITO FEDERALE MUNICIPIOS CONFRONTANTES, QUANDO O OLEO, XISTO E GAS FOREM EXTRAIDOSDA PLATAFORMA CONTINENTAL, NOS MESMOS 5% (CINCO POR CENTO) SENDO: - 1,5% (UM E MEIO POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIOPOR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OUTERRESTRES DE EMBARQUE E DESEMBARQUE DE OLEO OU GAS; 1,5% (UM E MEIO POR CENTO) AS MUNICIPIOS CONFRONTANTES E SUAS RESPECTIVAS AREAS GEOECONOMICAS; 0,5%(MEIO POR CENTO) PARA CONSTITUIR UM FUNDO ESPECIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.31.05', 'ROYALTIES PROD. PETR. GAS.NAT.-EM PLATAFORMA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM A EXTRACAO DO OLEO BRUTO, XISTO BETUMINOSO E GAS NATURAL. O PRODUTO DA ARRECADACAO DA COM PENSACAO FINANCEIRA PELA EXTRACAO, TEM A SEGUINTE DESTINACAO: - 3,5% (TRES E MEIO POR CENTO) AOS ESTADOS EXPORTADORES; 1% (UM POR CENTO) AOS MUNICIPIOS PRODUTORES;0,5%(MEIO POR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES DE EMBARQUE OU DESEMBARQUE DE OLEO OU GAS. E TAMBEM DEVIDA A COMPENSACAO FINANCEIRA AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS CONFRONTANTES, QUANDO O OLEO, XISTO E GAS FOREM EXTRAIDOS DA PLATAFORMA CONTINENTAL, NOS MESMOS 5% (CINCO POR CENTO) SENDO: POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIOPOR CENTO) - 1,5% (UM E MEIO POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIO POR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES E EMBARQUE E DESEMBARQUE DE OLEO OU GAS; 1,5% (UM E MEIO POR CENTO) AS MUNICIPIOS CONFRONTANTES E SUAS RESPECTIVAS AREAS GEOECONOMICAS; 0,5%(MEIO POR CENTO) PARA CONSTITUIR UM FUNDO ESPECIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.31.06', 'ROYALT.EXCED.PROD.PETR.OU GAS.NAT.-EM TERRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES COM A PARCELA DO VALOR DO ROYALTY QUE EXCEDER A 5% (CINCO POR CENTO) DA PRODUCAO DE PETROLEO OUGAS NATURAL TENDO A SEGUINTE DISTRIBUICAO: I - QUANDO A LAVRA OCORRER EM TERRA OU EM LAGOS, RIOS, ILHAS FLUVIAISE LACUSTRES: A) 52,5% (CINQUENTA E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS ES-TAODS ONDE OCORRER A PRODUCAO; B)15,0% (QUINZE POR CENTO) AOS MUNICIPIOS ONDE OCORRER A PRODUCAO; C)7,5% (SETE INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS QUESEJAM AFETADOS PELAS OPERACOES DE EMBARQUE E DESEMBARQUE DE PETROLEO EGAS NATURAL, NA FORMA E CRITERIO ESTABELECIDOS PELA ANP; D)25%(VINTE E CINCO POR CENTO) AO MINISTERIO DA CIENCIA E TECNOLOGIA; II - QUANDO A LAVRA OCORRER NA PLATAFORMA CONTINENTAL: A) 22,5%(VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.31.07', 'ROYALTIES EXCED.PROD.PETR.GAS.NAT.-PLATAFORMA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM A PARCELA DO VALOR DO ROYALTY QUE EXCEDER A 5% (CINCO POR CENTO) DA PRODUCAO DE PETROLEO OU GAS NATURAL TENDO A SEGUINTE DISTRIBUICAO: I QUANDO A LAVRA OCORRER EM TERRA OU EM LAGOS, RIOS, ILHAS FLUVIAIS E LACUSTRES: A) 5,5% (CINQUENTA E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS ESTADOS ONDE OCORRER A PRODUCAO; B)15,0 (QUINZE POR CENTO) AOS MUNICIPIOS ONDE OCORRER A PRODUCAO; C)7,5% (SETE INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS QUE SEJAM AFETADOS PELAS OPERACOES DE EMBARQUE E DESEMBARQUE DE PETROLEO E GAS NATURAL, NA FORMA E CRITERIO ESTABELECIDOS PELA ANP; D)25%(VINTE CINCO POR CENTO) AO MINISTERIO DA CIENCIA E TECNOLOGIA; II - QUANDO A LAVRA OCORRER NA PLATAFORMA CONTINENTAL: A) 22,5%(VIN E E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS PRODUTORES', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.31.08', 'PARTICIP.ESPEC.PROD.PETROLEO OU GAS NATURAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PARTICIPACAO ESPECIAL NOS CASOS DE GRANDE VOLUME DE PRODUCAO DE PETROLEO, OU GRANDE RENTABILIDADE. OS RECURSOS DA PARTICIPACAO ESPECIAL SERAO DISTRIBUIDOS NAS SEGUINTESPROPORCOES: - 40% AO MINISTERIO DAS MINAS E ENERGIA, PARA O FINANCIAMENTO DE ESTU-DOS E SERVICOS DE GEOLOGIA E GEOFISICA APLICADOS A PROSPECAO DE PETRO-LEO E GAS NATURAL, A SEREM PROMOVIDOS PELA ANP; - 10% AO MINISTERIO DO MEIO AMBIENTE, DOS RECURSOS HIDRICOS E DA AMA-ZONIA LEGAL, DESTINADOS AO DESENVOLVIMENTO DE ESTUDOS E PROJETOS RELA-CIONADOS COM A PRESERVACAO DO MEIO AMBIENTE E RECUPERACAO DE DANOS AM-BIENTAIS CAUSADOS PELA INDUSTRIA DO PETROLEO; - 40% QUARENTA POR CENTO PARA O ESTADO ONDE OCORRER A PRODUCAO EM TER-RA, OU CONFRONTANTE COM A PLATAFORMA CONTINENTE ONDE SE REALIZAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.31.09', 'SUPRESSAO VEGETAL NAS FLORESTAS NACIONAIS', 'REGISTRA O VALOR DA VPA DA SUPRESSAO VEGETAL NO INTERIOR DAS FLORESTAS NACIONAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.32.01', 'SERVICOS DE TRANSPORTE RODOVIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS COM TRANSPORTE RODOVIARIO, TRANSPORTE RODOVIARIO DE PASSAGEIROS, DE CARGA OU MISTO, DE ESCOLARES, TAXI, DE ENCOMENDAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.32.02', 'SERVICOS DE TRANSPORTE FERROVIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE FERROVIARIO. VPA AUFERIDA NO TRANSPORTE FERROVIARIO DE PASSAGEIROS E DE CARGA, INCLUSIVE METROPOLITANO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.32.03', 'SERVICOS DE TRANSPORTE HIDROVIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE HIDROVIARIO. VPA DE SERVICOS DE TRANSPORTE HIDROVIARIO DE PASSAGEIROS, DE CARGA OU MISTO, DE LONGO CURSO, DE CABOTAGEM E POR VIAS INTERNAS (RIOS, LAGOS, ETC...)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.32.04', 'SERVICOS DE TRANSPORTE AEREO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE AEREO. VPA DE SERVICOS DE TRANSPORTE AEREO DE PASSAGEIROS, DE CARGA OU MISTO, TRANSPORTE AEREO REGULAR,TRANSPORTE AEREO REGIONAL, TAXI AEREO, AERONAVES FRETADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.32.99', 'OUTROS SERVICOS DE TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTROS SERVICOS DE TRANSPORTE, NAO CLASSIFICADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.33.00', 'SERVICOS PORTUARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PORTUARIOS. ABRANGEM OS RECURSOS ORIUNDOS DA EXPLORACAO DOS PORTOS, TERMINAIS MARITIMOS, ATRACADOUROS E ANCORADOUROS, REFERENTES A ESTIVA, DESESTIVA, DRAGAGEM, ATRACACAO, SINALIZACAO, COMUNICACAO NAUTICA, DOCAGEM, ETC....', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.34.00', 'SERVICOS DE SOCORRO MARITIMO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICO DE SOCORRO MARITIMO PRESTADO. VPA DE SERVICOS DE SALVAMENTO, POR NAVIO DE SOCORRO OU EQUIPE DE SALVAMENTO DA MARINHA, DE EMBARCACAO E CARGAS PERIGO (DESENCALHE, MERGULHO, OUTROS SOCORROS), BEM COMO SERVICOS DE REBOQUE MARITIMO, DENTRE OUTROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.35.01', 'SERVICOS HOSPITALARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE HOSPITAL EM GERAL OU ESPECIALIZADO, MATERNIDADE, CENTRO DE REABILITACAO, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.35.02', 'SERV.REG.AN.CONTR.PROD.SUJ.A NORM.VIGIL.SANIT', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE ANALISE E DE CONTROLE DE PRODUTOS SUJEITOS A NORMAS DE VIGILANCIA SANITARIA E O REGISTRO DE TODOS OS MEDICAMENTOS, DROGAS, INSUMOS FARMACEUTICOS E CORRELATOS, SANEANTES E OUTROS PRODUTOS, INCLUSIVE OS IMPORTADOS, OS EXPOSTOS A VENDA OU ENTREGUE AO CONSUMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.35.03', 'SERVICOS RADIOLOGICOS E LABORATORIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RADIOLOGICOS E LABORATORIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.35.04', 'SERV ASSIST SAUDE SUPLEMENTAR SERVIDOR CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PARTICIPACAO DA UNIAO, SUAS AUTARQUIAS E FUNDACOES PUBLICAS E DE RECURSOS PROVENIENTES DA CONTRIBUICAO DOS SERVIDORES PUBLICOS CIVIS ATIVOS, INATIVOS E PENSIONISTAS, DESTINADA AO CUSTEIO DA ASSISTENCIA AA SAUDE SUPLEMENTAR DO SERVIDOR CIVIL, NO CASO DE PRESTACAO DIRETA PELOS ORGAOS (GESTAO PROPRIA). AMPARO LEGAL: LEI 8.112/90, ART. 230 LEI 11.302/2006, ART. 9º PORTARIA SRH/MP 1983/2006 DESTINACAO LEGAL: INTEGRALMENTE DESTINADA AO CUSTEIO DA ASSISTENCIA AA SAUDE SUPLEMENTAR DO SERVIDOR CIVIL DA ADMINISTRACAO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.35.99', 'OUTROS SERVICOS DE SAUDE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTROS SERVICOS DE SAUDE, E NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.36.00', 'CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.37.01', 'METROLOGIA LEGAL E CERTIFICATORIA DELEGADA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA LEGAL E CERTIFICATORIA DELEGADA, ORIUNDAS DE ENTIDADES PUBLICAS OU PRIVADAS CREDENCIADAS. ESTA VPA ESTA AMPARADA PELA LEI NUM 5966DE 11 DE DEZEMBRO DE 1973.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.37.02', 'METROLOGIA CIENTIFICA E INDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA CIENTIFICA E INDUSTRIAL, NO TOCANTE A AFERICAO DE INSTRUMENTOS DE MEDICOES, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC...ESTA VPA ESTA AMPARADA PELA LEI NUM 5966 DE 11 DE DEZEMBRO DE 1973', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.37.03', 'METROLOGIA LEGAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METRO-LOGIA LEGAL, ORIUNDA DE SERVICOS METROLOGICOS LEGAIS. BASICAMENTE,CONSISTE EM ASSEGURAR A UNIFORMIDADE E A RACIONALIZACAO DAS UNIDADESEM TODO O TERRITORIO NACIONAL, AFERICAO DE INSTRUMENTOS DE MEDICOES,ETC. ESTA VPA ESTA AMPARADA PELA LEI 5966 DE 11/12/1973.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.37.04', 'CERTIFICACAO DE PRODUTOS E SERVICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CERTIFICACAO DA QUALIDADE DE MATERIAIS, PRODUTOS E SERVICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.38.00', 'SERVICOS DE INSPECAO E FISCALIZACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INSPECAO E FISCALIZACAO PRESTADOS. VPA PROPORCIONADA PELA CONSTATACAO DAS CONDICOES HIGIENICO-SANITARIAS E TECNICAS DE PRODUTOS OU ESTABELECIMENTOS, OU RESULTANTES DE ACAO EXTERNA E DIRETA DOS ORGAOS DO PODER PUBLICO DESTINADA A VERIFICACAO DO CUMPRIMENTO DA LEGISLACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.39.00', 'SERVICOS ADMINISTRATIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS ADMINISTRATIVOS PRESTADOS, DAS ATIVIDADES DE APOIO ADMINSITRATIVO EXECUTADAS EM ORGANIZACOES DE QUALQUER NATUREZA, TAIS COMO: A)TAXAS DE EXPEDICAO DE CERTIFICADOS; B)TAXAS DE REGISTRO, RENOVACAO, VISTORIA, LICENCA, CADASTRAMENTO, ETC. C)DATILOGRAFIA, MICROFILMAGEM, COPIAS XEROGRAFICAS, HELIOGRAFICAS,FOTOSTATICAS, ETC.. D)TAXAS DE INSCRICAO EM CONCURSOS. E)TAXA DE ADMINISTRACAO DE SERVICOS. F)VENDA DE EDITAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.40.00', 'SERVICOS DE METEOROLOGIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METEOROLOGIA PRESTADOS. VPA PROPORCIONADA PELO FORNECIMENTO DE DADOS METEOROLOGICOS E DE PARECERES TECNICOS, BEM COMO CONSERTO, COMPARACAO E AFERICAO DE EQUIPAMENTOS DE METEOROLOGIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.41.00', 'SERVICOS EDUCACIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DO SISTEMA EDUCACIONAL, CUJA NATUREZA ESTEJA DIRETAMENTE RELACIONADA A FORMACAO DO EDUCANDO (MATRICULAS, ANUIDADES, ETC...). AS VPA DE ATIVIDADES AUXILIARES, DE APOIO OU DERIVADAS DOS SERVICOS EDUCACIONAIS PROPRIAMENTE DITOS, DEVEM SER CLASSIFICADAS NOS TITULOS APROPRIADOS. EXEMPLOS: MATRICULAS E ANUIDADES, SERVICOS EDUCACIONAIS, TAXAS DE EXPEDICAO DE DOCUMENTOS, COPIAS XEROGRAFICAS, HELIOGRAFICAS, ETC.., SERVICO DE CREDENCIAMENTO, AUTORIZACAO E RECONHECIMENTO DE CURSOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.42.00', 'SERVICOS AGROPECUARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS AGROPECUARIO: A)PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO,ARACAO,GRADEACAO, CALAGEM,ADUBACAO, DRENAGEM, IRRIGACAO, CAPINA, DESMATAMENTO, ETC.); B)SEMEADURA E PLANTIO; C)COMBATE A PRAGAS (PULVERIZACAO, DEDETIZACAO); D)COLHEITA E PREPARACAO DE PRODUTOS AGRICOLAS; E)INSEMINACAO ARTIFICIAL; F)INCUBACAO DE OVOS; G)VACINACAO DE ANIMAIS; H)OUTROS SERVICOS AUXILIARES DE AGRICULTURA E PECUARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.43.00', 'SERVICOS DE REPARACAO,MANUTENCAO E INSTALACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REPARACAO, MANUTENCAO E INSTALACAO PRESTADOS. VPA DE SERVICOS DE REPARACAO DE ARTEFATOS DE METAL; REPARACAO E MANUTENCAO DE MAQUINAS E APARELHOS DE USO DOMESTICO; REPARACAO, MANUTENCAO E INSTALACAO DE MAQUINAS E APARELHOS ELETRICOS E ELETRONICOS E DE COMUNICACAO; REPARACAO E MANUTENCAO DE INSTALACOES ELETRICAS, DE GAS, DE AGUA, ETC...INCLUEM-SE TAMBEM, NESSE TITULO, OS SERVICOS DE CONFECCAO SOB MEDIDA. NAO SAO CONSIDERADOS NESSE TITULO, CLASSIFICANDO-SE EM VPA INDUSTRIAL: REPARACAO E MANUTENCAO DE VEICULOS FERROVIARIOS, EMBARCACOES E AERONAVES (INDUSTRIA DE MATERIAL DE TRANSPORTE).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.44.00', 'SERVICOS RECREATIVOS E CULTURAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RECREATIVOS E CULTURAIS PRESTADOS. VPA PROPORCIONADA PELA EXPLORACAO DE INSTALACOES PARA RECREACAO, PRATICA DESPORTIVA E CULTURAL ( CINEMAS,TEATROS, SALOES PARA RECITAIS, CONCERTOS, CONFERENCIAS, PLANETARIOS,ESTADIOS DESPORTIVOS, AUTODROMOS, MUSEUS, BIBLIOTECAS, PROMOCAO E/OUPRODUCAO DE ESPETACULOS ARTISTICOS CULTURAIS E ESPORTIVOS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.45.02', 'SERVICOS DE REGISTRO DE MARCAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PEDIDOS DE REGISTRO DE MARCAS, VIGENCIAS DE MARCAS, PETICOES, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.45.03', 'SERVICOS DE TRANSFERENCIA DE TECNOLOGIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE AVERBACOES DE CONTRATOS, PETICOES, RECURSOS, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.45.04', 'SERVICOS DE REGISTRO INDICACOES GEOGRAFICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE EXPEDICOES DE CERTIFICADOS DE REGISTRO, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.45.05', 'SERVICOS DE REGISTRO PROGRAMA DE COMPUTADOR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE PROGRAMAS DE COMPUTADOR, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.45.06', 'SERVICOS DE REGISTRO DE DESENHO INDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE DESENHO INDUSTRIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.45.07', 'SERV. PROTECAO TOPOGRAFIAS CIRCUITOS INTEGRAD', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROTECAO DAS TOPOGRAFIAS DE CIRCUITOS INTEGRADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.45.08', 'SERVICOS DE REMESSA DE DEPOSITOS OFICIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REMESSA DE DEPOSITOOFICIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.45.99', 'OUTROS SERV.REGIST.MARCAS,PATENTES,TRANSF.TEC', 'REGISTRA AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE REGISTRO DE MARCAS,PATENTES,TRANSFERENCIA DE TECNOLOGIA, NAO CLASSIFICADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.46.00', 'SERVICOS DE REGISTRO DO COMERCIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DO COMERCIO PRESTADOS. VPA ADVINDA DA PRESTACAO DE SERVICOS DE REGISTRO DO COMERCIO E ATIVIDADES AFINS, TRATANDO-SE DE: A) SERVICOS PRESTADOS PELA JUNTA COMERCIAL DO DISTRITO FEDERAL; B) SERVICOS CONSTANTES DO CADASTRO NACIONAL DE EMPRESA, DEVIDOS NO AMBITO DAS JUNTAS COMERCIAIS DOS ESTADOS E DO DISTRITO FEDERAL; C) REMUNERACAO DE SERVICOS PRESTADOS PELO DEPARTAMENTO NACIONAL DE REGISTRO DO COMERCIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.47.00', 'SERVICOS DE FORNECIMENTO DE AGUA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE FORNECIMENTO DE AGUA AOS IRRIGANTES AA AMORTIZACAO DOS INVESTIMENTOS DA INFRA-ESTRUTURA DE IRRIGACAO DOS PROJETOS PUBLICOS, CONFORME DEC.89.496, DE 29.03DE 84, RELATIVOS A TARIFAS K-1 E K-2.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.48.00', 'SERVICOS DE PERFURACAO E INSTALACAO DE POCOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE PERFURACAO EINSTALACAO DE POCOS TUBULARES PROFUNDOS, POCOS ARTESIANOS OU SIMILARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.49.00', 'SERVICOS DE GEOPROCESSAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS A TERCEIROS DE INTERPRETACAO DE IMAGEM AEROFOTOGRAMETRICA,EXECUCAO DE MAPAS DIGITALIZADOS DIVERSOS, VENDA DE CARTAS E IMAGENS DE SATELITES, VIDEOGRAFICAS E SIMILARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.50.00', 'SERVICOS DE CADASTRAMENTO DE FORNECEDORES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE CADASTRAMENTO DE EMPRESAS FORNECEDORAS DE BENS E SERVICOS AO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.51.00', 'TARIFA DE UTILIZACAO DE FAROIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA DE UTILIZACAO DE FAROIS. VPA PROVENIENTE DA EFETIVA UTILIZACAO, POR EMBARCACOES ESTRANGEIRAS, DOS SERVICOS DE SINALIZACAO NAUTICA DE PROTECAO A NAVEGACAO. O PRODUTO DA ARRECADACAO E DESTINADO INTEGRALMENTE AO FUNDO NAVAL PARA APLICACAO NOS SERVICOS QUE ENVOLVAM A MANUTENCAO E AMPLIACAO DA REDE DE BALIZAMENTO MARITIMO, FLUVIAL E LACUSTRE, A CARGO DA DIRETORIA DE HIDROGRAFIA E NAVEGACAO DO MINISTERIO DA MARINHA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.52.01', 'TARIFA AEROPORTUARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA COBRADA POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTILIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPA-TAZIA).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.52.02', 'ADICIONAL SOBRE TARIFA AEROPORTUARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ADICIONAL SOBRE TARIFA AEROPORTUARIA. VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO ADICIONAL SOBRE A TARIFA COBRADAPOR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AE-ROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTILIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIASEM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.52.03', 'PARCELA DA TARIFA DE EMBARQUE INTERNACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PARCELA DA TARIFA DE EMBARQUE INTERNACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.53.00', 'SERVICOS DE CADASTRO DA ATIVIDADE MINERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE AUTORIZACAO DE PESQUISA MINERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.54.01', 'TARIF USO COMUN E AUX.NAVEGACAO AEREA EM ROTA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE DA UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA,PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA OU POR ENTIDADE ESPECIA-LIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. FATO GERADOR: UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA. AMPARO LEGAL: DECRETO-LEI 1896/1981 E DECRETO 86.864/1982.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.54.02', 'ADICIONAL S/ TARIFA USO COM E AUX NAVEG AEREA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO ADICIONAL DE 50% SOBRE AS TARIFAS DE UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA,PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA OU POR ENTIDADE ESPECIALIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. FATO GERADOR: ADICIONAL SOBRE AS TARIFAS RELATIVAS AO USO DOS AUXILIOSAA NAVEGACAO AEREA E DAS TELECOMUNICACOES. DESTINACAO LEGAL: MINISTERIO DA AERONAUTICA OU ENTIDADE DA ADMINISTRA-CAO INDIRETA RESPONSAVEL PELA PRESTACAO DOS SERVICOS. AMPARO LEGAL: LEI 7920/1989 - ART 1.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.55.00', 'TAR.INSCR.CONCURSOS E PROCESSOS SELETIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE INSCRICAO EM CONCURSOS E PROCESSOS SELETIVOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.56.00', 'SERVICO DE COMPENSACAO DE VARIACOES SALARIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COBRANCA DE CONTRIBUICOES SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO-SFH E SOBRE O SALDO DOS FINANCIAMENTOS IMOBILIARIOS CONCEDIDOS PELOS AGENTES FINANCEIROS DO SFH,COM COBERTURA DO FCVS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.57.01', 'TARIFA PELO USO DO SISTEMA DE INFORM.DO BACEN', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO USO DO SISTEMA DE INFORMACOES DO BACEN.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.57.02', 'TARIFA PELO USO DO SIST.DE TRANSF. RES. BACEN', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO USO DO SISTEMA DE TRANSFERENCIA DE RESERVA DO BACEN.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.58.01', 'CONCESSAO DE AVAL DO TESOURO NACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO DE AVAL DO TESOURO NACIONAL, COBRADA A TITULO DE COMISSAO, EXECUCAO OU FISCALIZACAO PELA CONCESSAO DE GARANTIA DO TESOURO NACIONAL A CREDITOS OBTIDOS NO EXTERIOR. FATO GERADOR: A CONCESSAO DE GARANTIA DO TESOURO NACIONAL A CREDITOS OBTIDOS NO EXTERIOR. AMPARO LEGAL: LEI 5.000, DE 24 DE MAIO DE 1966.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.58.02', 'CONCESSAO GARANTIA DA ATIVIDADE AGROPECUARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ADICIONAL COBRADO SOBRE EMPRESTIMOS RURAIS DE CUSTEIO. TEM COMO FINALIDADE EXIMIR O PRODUTOR RURAL DE POSSIVEIS OBRIGACOES RELATIVAS A OPERACOES DE CREDITO CUJA LIQUIDACAO SEJA DIFICULTADA POR FENOMENOS NATURAIS, DOENCAS OUPRAGAS. FATO GERADOR: A REALIZACAO DE EMPRESTIMOS RURAIS DE CUSTEIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.58.03', 'COMISSOES PELA PRESTACAO DE GARANTIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMISSOES COBRADAS POR CONTA DA GARANTIA DE OPERACOES DE FINANCIAMENTO PARA AUMENTO DA COMPETITIVIDAD EE DA PRODUCAO DESTINADA AA EXPORTACAO. FATO GERADOR: COBRANCA DE COMISSOES, POR CONTA DA GARANTIA DE OPERACOES DE FINANCIAMENTO, PARA AUMENTO DA COMPETITIVIDADE E DA PRODUCAODESTINADA AA EXPORTACAO. DESTINACAO LEGAL: - MICROEMPRESAS E EMPRESAS DE PEQUENO PORTE; - MEDIAS EMPRESAS QUE SEJAM EXPORTADORAS OU FABRICANTES DE INSUMOS QUEINTEGREM O PROCESSO PRODUTIVO, OU DE MONTAGEM E DE EMBALAGEM DE MERCA-DORIAS DESTINADAS AA EXPORTACAO. AMPARO LEGAL: LEI 9531, DE 10 DE DEZEMBRO DE 1997, ÷ 1º, 2º E 3º.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.58.04', 'GARANTIA DOS FINANC.AA ESTOC.ALCOOL ETIL.COMB', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO DE GARANTIAS E AVAIS NOS FINANCIAMENTOS A ESTOCAGEM DE ALCOOL ETILICO COMBUSTIVEL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.58.05', 'RECEITA DE SEGURO DE CREDITO AA EXPORTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA GARANTIA DAS OPERACOES DE CREDITO AA EXPORTACAO CONTRA OS RISCOS COMERCIAIS, POLITICOS E EXTRAORDINARIOS QUE POSSAM AFETAR A PRODUCAO DE BENS E A PRESTACAO DE SERVICOS DESTINADOS AA EXPORTACAO OU AS EXPORTACOES BRASILEIRAS DE BENS E SERVICOS. AMPARO LEGAL: - LEI 9.818, DE 23 DE AGOSTO DE 1999 - LEI 6.704, DE 26 DE OUTUBRO DE 1979, ART.1º', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.59.00', 'CREDENCIAMENTO EMP.PREST.SERVICOS DE VISTORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO VALOR A SER PAGO POR EMPRESAS NA OBTENCAO DE CREDENCIAMENTO PARA PRESTACAO DE SERVICOS DE VISTORIA. - DESTINACAO LEGAL: ORGAO ARRECADADOR; - AMPARO LEGAL: RESOLUCAO CONTRAN 282, DE 26 DE JUNHO DE 2008.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.60.00', 'SERVICOS VETERINARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS VETERINARIOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.61.00', 'CERTIFICACAO E HOMOLOGACAO ATIVIDADE MINERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE REGISTRO DE LICENCA E DO REGISTRO DE PERMISSAO DE LAVRA GARIMPEIRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.62.01', 'SERV.PREST.DIRET. POR INST.CIENT.TECNOLOGICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DIRETAMENTE POR INSTITUICOES CIENTIFICAS E TECNOLOGICAS, VOLTADOS A INOVACAO E A PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.62.02', 'SERV.DECORREN.PARCEIR.C/OUTRAS INST.PUB.PRIV.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA CELEBRACAO DE ACORDOS DE PARCERIA PARA REALIZACAO DE ATIVI-DADES CONJUNTAS DE PESQUISA CIENTIFICA E TECNOLOGICA E DESENVOLVIMENTODE TECNOLOGIA, PRODUTO OU PROCESSO, COM INSTITUICOES PUBLICAS E PRIVA-DAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.63.01', 'SERV.FINANC.DE COMPENS.DE VARIACOES SALARIAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM SERVICOS FINANCEIROS DE COMPENSACAO DE VARIACOES SALARIAIS. VPA PROVENIENTE DE ADICIONAL COBRADO SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DA HABITACAO. TEM COMO FINALIDADE EXIMIR OS ADQUIRENTES DE CASA PROPRIA DO PAGAMENTO DE POSSIVEIS RESIDUOS DO SALDO DEVEDOR DO FINANCIAMENTO IMOBILIARIO EXISTENTES AO FINAL DO PRAZO CONTRATADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.63.02', 'SERVICOS DE REMUNERACAO REP. PROG.DES.ECONOM.', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM SERVICOS DE REMUNERACAO DE REPASSES DE PROGRAMA DE DESENVOLVIMENTO ECONOMOMICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.63.03', 'COMISSOES PELA PREST. DE GARANTIA', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM COMISSOES PELA PREST. DE GARANTIA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.63.99', 'OUTROS SERVICOS FINANCEIROS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM OUTROS SERVICOS FINANCEIROS, NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.64.01', 'SERVICO DE EMISSAO DE CERTIFICADOS DE ORIGEM', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE CERTIFICADOS DE ORIGEM', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.64.02', 'SERVICO DE EMISSAO DE LICENCA DE EXPORTACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE LICENCA DE EXPORTACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.65.00', 'VPA DE UTILIZACAO DE POSICOES ORBITAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE UTILIZACAO DE POSICOES ORBITAIS, CUJOS RECURSOS SAO PROVENIENTES DE: 25 POR CENTO DA VPA QUE SE REFEREM O ARTIGO 2 DA LEI 5070/96,PROVENIENTES DA UTILIZACAO DE POSICOES ORBITAIS 25 POR CENTO DA VPA DA UNIAO, PROVENIENTES DE LANCAMENTOS, EM CARATER COMERCIAL, DE SATELITES E FOGUETES DE SONDAGEM A PARTIR DO TERRITORIO BRASILEIRO 25 POR CENTO DA VPA AUFERIDAS PELA UNIAO, PROVENIENTES DA COMERCIALIZACAO DOS DADOS E IMAGENS OBTIDOS POR MEIOS DE RASTREAMENTO, TELEMEDIDAS E CONTROLE DE FOGUETES E SATELITES TOTAL DA VPA AUFERIDA PELA AGENCIA ESPACIAL BRASILEIRA - AEB, DECORRENTES DA CONCESSAO DE LICENCAS E AUTORIZACOES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.66.00', 'VPA COM.DADOS/IMAGENS UTIL.POSICOES ORBITAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DOS DADOS E IMAGENS ORIUNDOS DA UTILIZACAO DE POSICOES ORBITAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.67.00', 'VPA LANCAM.SATELITES E FOGUETES DE SONDAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LANCAMENTOS DE SATELITES E FOGUETES DE SONDAGEM, A PARTIR DO TERRITORIO BRASILEIRO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.68.00', 'SERV.COMERCIAIS DE PROD.DADOS E MAT.INFORMATI', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS, DADOS E MATERIAIS DE INFORMATICA, TAIS COMO DISQUETES,SOFTWARES, PROGRAMAS, CD-ROM, FITAS MAGNETICAS E ASSEMELHADOS, BEM COMO INFORMACOES EM REDES E SISTEMAS DE DADOS DISPONIVEIS EM MEIO DE HARDWARE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.69.00', 'REC.OUTORGA TIT ONEROSO ATIV PESQ/LAVRA-PETRO', 'REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CESSAO A TITULO ONEROSO DAS ATIVIDADES DE PESQUISA E LAVRA DAS JAZIDAS DE PETROLEO E GAS NATURAL E OUTROS HIDROCARBONETOS FLUIDOS, BEM COMO O SEU REFINO E TRANSPORTE MARITIMO. DESTINACAO LEGAL: TESOURO NACIONAL AMPARO LEGAL: ART 177 DA CONSTITUICAO FEDERAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.99.00', 'OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.01.00', 'PRESTACAO DE SERVICOS POSTAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POSTAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.02.00', 'PRESTACAO DE SERVICOS DE TREINAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE INSTRUCAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.03.01', 'ALUGUEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS PELA UTILIZACAO DE TERCEIROS DE IMOVEIS PROPRIOS DO PODER PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.03.02', 'ARRENDAMENTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRATO PELO QUAL O PODER PUBLICO CEDE A TERCEIROS, POR CERTO TEMPO E PRECO, O USO E GOZO DE DE TERMINADA AREA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.03.03', 'FOROS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PAGAS PELA PESSOA QUE RECEBE POR ENFITEUSE O DOMINIO UTIL DE UM IMOVEL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.03.04', 'LAUDEMIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENSAO OU PREMIO QUE O FOREIRO PAGA, QUANDO HA ALIENACAO DO RESPECTIVO PREDIO POR PARTE DA PESSOA QUE RECEBE POR ENFITEUSE O DOMINIO DO IMOVEL, EXCETO NOS CASOS DE SUCESSAO HEREDITARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.03.05', 'TAXA DE OCUPACAO DE TERRENOS DA UNIAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE TERRENOS DE MARINHA E DEMAIS TERRENOS DE PROPRIEDADE DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.03.06', 'TAXA OCUPACAO IMOVEIS FUN. PROP. NAC. RESID.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE IMOVEIS FUNCIONAIS E PROPRIOS NACIONAIS RESIDENCIAIS DA UNIAO, AGENTES POLITICOS E SERVIDORES PUBLICOS FEDERAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.03.07', 'TAXA DE OCUPACAO DE OUTROS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE OUTROS BENS IMOVEIS DE PROPRIEDADE DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.03.99', 'OUTRAS VPA DE EXPLORACAO DE BENS IMOVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS ORIGENS NA FRUICAO DO PATRIMONIO IMOBILIARIO, NAO ENQUADRADAS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.04.00', 'PRESTACAO DE SERVICOS DE LOCACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS, EXCETO ALUGUEIS DE IMOVEIS, QUE JA POSSUI RUBRICA PROPRIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.05.00', 'PRESTACAO DE SERVICOS DE PESQUISAS E ANALISES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PESQUISAS E ANALISE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.06.00', 'SERVICOS DE ESTUDOS E PESQUISAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PESQUISAS E ESTUDOS TECNICO-SOCIAIS, ECONOMICOS, CIENTIFICOS, CULTURAIS ETC., REALIZADAS SOB CONTRATO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.07.00', 'PRESTACAO DE SERVICOS DE CONSULTORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ASSESSORIA E CONSULTORIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.08.01', 'SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS - APLICACOES LIVRES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONSULTORIAS TECNICO - FINACEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ASSISTENCIA TECNICA E EXTENSAO RURAL, ETC. REDIRECIONAMENTO DE 2% DAS LIBERACOES EFETIVADAS PELOS RESPECTIVOS FUNDOS, PARA APLICACOES LIVRES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.08.02', 'SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS - APLICACOES VINCULADAS A ATIVIDADES DE PESQUISA E DESENVOLVIMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONSULTORIAS TECNICO - FINACEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ASSISTENCIA TECNICA E EXTENSAO RURAL, ETC. REDIRECIONAMENTO DE 1,5 % DAS LIBERACOES EFETIVADAS PELOS RESPECTIVOS FUNDOS, PARA APLICACOES VINCULADAS A ATIVIDADES DE PESQUISA E DESENVOLVIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.09.01', 'PRESTACAO DE SERVICOS DE DESENVOLVIMENTO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ANALISE E DESENVOLVIMENTO DE SISTEMAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.09.02', 'PRESTACAO DE SERV. LICENC/CESSAO DE DIREITO USO PROGRAMAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE LICENCIAMENTO OU CESSAO DE DIREITO DE USO DE PROGRAMAS DE COMPUTADOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.09.03', 'PRESTACAO DE SERVICOS DE MANUT. E ATUALIZACAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE MANUTENCAO E ATUALIZACAO DE SOFTWARE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.09.04', 'PRESTACAO DE SERVICOS DE INSTAL.E CONFIGURACAO DE SOFTWARE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE INSTALACAO E CONFIGURACAO DE SOFTWARE', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.09.05', 'PRESTACAO DE SERVICOS DE PAGINAS ELETRONICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE PLANEJAMENTO, CONFECCAO, MANUTENCAO E ATUALIZACAO DE PAGINAS ELETRONICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.10.00', 'PRESTACAO DE SERVICOS DE ADM. DE REDE DE COMUNIC. DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE GERENCIAMENTO DE REDES DE COMUNICACAO DE DADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.11.00', 'SERVICOS DE PROCESSAMENTO DE DADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VPA DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.12.00', 'SERVICO DE INFORMACOES CIENTIFICAS E TECNOLOGICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES CIENTIFICAS E TECNOLOGICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.13.00', 'PRESTACAO DE SERVICOS CIENTIFICOS E TECNOLOGICOS NUCLEARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS QUE ENVOLVAM INFORMACAO CIENTIFICA E TECNOLOGICA, APLICACOES DE TECNICAS NUCLEARES E RADIOISOTOPOS, METROLOGIA CIENTIFICA E INDUSTRIAL, RADIOMETRIA E DOSIMETRIA, CONSULTORIAS ASSISTENCIA TECNICA, ANALISE DE PROJETOS, ESTUDOS, PESQUISAS E DESENVOLVIMENTO DA ENERGIA NUCLEAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.14.00', 'SERVICOS DE TECNOLOGIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS TECNOLOGICOS PRESTADOS.VPA PROPORCIONADA POR: A) ANALISES QUIMICAS, ENSAIOS FISICOS E MECANICOS, CONTROLE E EXPERI-MENTACAO QUALITATIVA DE MATERIAS-PRIMAS, INSUMOS E PRODUTOS FABRICADOS; PADRONIZACAO E ESPECIFICACAO DE PRODUTOS; AJUSTES DOS PROCESSOS ETECNICAS DE PRODUCAO INDUSTRIAL (SISTEMA DE TECNOLOGIA) B) ESPECIFICACAO E CONTROLE DE QUALIDADE DE MEDICAMENTOS, INSUMOS FAR-MACEUTICOS, DROGAS, COSMETICOS, PRODUTOS QUIMICOS, ALIMENTOS, E OUTROS, POR MEIO DE PROVAS ESPECIFICAS DE IDENTIFICACAO, DE PUREZA E DETESTES DE CONTAMINACAO MICROBIOLOGICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.15.01', 'SERVICOS DE PUBLICIDADE LEGAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE AGENCIAMENTO DE PUBLICIDADE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.15.02', 'SERVICOS DE RADIODIFUSAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE RADIODIFUSAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.15.03', 'PRESTACAO DE SERVICOS DE AGENCIAMENTO DE PUBLICIDADE', 'REGISTRA O VALOR DE VPA AUFERIDAS PELA PRESTACAO DE SERVICOS DE AGENCIAMENTO DE PUBLICIDADE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.15.99', 'OUTROS SERVICOS DE COMUNICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS DE COMUNICACAO, TAIS COMO: SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.16.01', 'PRESTACAO DE SERVICOS DE ARMAZENAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ARMAZENAGEM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.16.02', 'PRESTACAO DE SERVICOS DE GARANTIA DE PRODUTOS ARMAZENADOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE GARANTIA DE PRODUTOS ARMAZENADOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.17.00', 'PRESTACAO DE SERVICOS COMPLEMENTARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS COMPLEMENTARES QUANDO DA ESTOCAGEM EM ARMAZENAGEM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.18.01', 'PRESTACAO DE SERVICOS EXPURGO DE GRAOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO INSETICIDAS LIQUIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.18.02', 'PRESTACAO DE SERVICOS SECAGEM DE GRAOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO LENHA, OLEO DIESEL,ETC.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.18.03', 'PRESTACAO DE SERVICOS LIMPEZA DOS GRAOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO MAQUINARIOS, COMO PENEIRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.19.00', 'PRESTACAO DE SERVICOS RECEPCAO E EMBARQUE DE PRODUTOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE MOVIMENTACAO DOS PRODUTOS NOS ARMAZENS/CAMINHAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.20.00', 'PRESTACAO DE SERVICOS SERVICO DE TRANSBORDO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE TRANSBORDO DE MERCADORIAS DE TREM PARA CAMINHAO E VICE-VERSA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.21.00', 'FORNECIMENTO DE MAO-DE-OBRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO FORNECIMENTO DE MAO-DE-OBRA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.22.00', 'PRESTACAO DE SERVICOS DE DISTRIB. DE GENEROS ALIMENTICIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE DISTRIBUICAO DE GENEROS ALIMENTICIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.23.00', 'SERVICOS DE HOSPEDAGEM E ALIMENTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE HOSPEDAGEM E ALIMENTACAO PRESTADOS. VPA PROPORCIONADA POR HOSPEDAGEM, COM OU SEM ALIMENTACAO, FORNECIMENTO DE REFEICOES, LANCHES E BEBIDAS PARA CONSUMO IMEDIATO. EXCLUEM AS VPA PROVENIENTES DE EMPRESAS FORNECEDORAS DE ALIMENTOS PREPARADOS PARA HOSPITAIS, FABRICAS, ETC... QUE SE CLASSIFICAM EM VPA DE PRODUTOS ALIMENTARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.24.01', 'OUTORGA DOS SERV. TRANSP. FERROV.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE FERROVIARIO A INICIATIVA PRIVADA, PROVENIENTE DA FISCALIZACAO, NORMATIZACAO E CONTROLE DOS SERVICOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.24.02', 'OUTORGA SERV.TRANSP.ROD.INTEREST.INTERNAC.PAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A CONCESSAO PELO PODER PUBLICO AO PARTICULAR DO DIREITO DE EXPLORACAO DOS SERVICOS DE TRANSPORTES RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.24.99', 'OUTRAS VPA DE CONC. PERMISS. SERV DE TRANSPORTE', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.25.01', 'OUTORGA DOS SERV. TELECOMUNICACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE TELECOMUNICACOES, INCLUINDO O SERVICO MOVEL CELULAR E O SERVICO DE TRANSPORTE DE SINAIS DE TELECOMUNICACOES POR SATELITE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.25.02', 'OUTORGA SERV.RADIODIFUSAO SONORA SONS IMAGENS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE RADIODIFUSAO SONORA E DE SONS E IMAGENS, INCLUINDO O USO DE RADIOFREQUENCIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.25.03', 'OUTORGA DIREITO DE USO RADIOFREQUENCIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO ESTABELECIDA PELO PODER PUBLICO_AO PARTICULAR DO DIREITO DE USO DE RADIOFREQUENCIA PARA QUALQUER FIM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.25.04', 'TRANS.CONC.PERM.AUT.TELECOM.USO RADIOFREQ', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTE DE PRECO PUBLICO COBRADO PELA AGENCIA NACIONAL DE TELECOMUNICACOES - ANATEL, COMO CONDICAO PARA TRANSFERENCIA DE CONCESSAO, DE PERMISSAO OU DE AUTORIZACAO DE SERVICO DE TELECOMUNICACOES OU DE USO DE RADIOFREQUENCIA, A SER PAGO PELA CESSIONARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.25.05', 'TRANSF.CONC/PERM/AUTOR-RODOVIAS OU OBRAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO RATEIO DA VERBA DE FISCALIZACAO A SER COBRADA PELOS ESTADOS E DISTRITO FEDERAL (OU CONSORCIO ENTRE ELES), COM O MINISTERIO DOS TRANSPORTES - MT, NA PROPORCAO DE 5% SOBRE O VALOR PAGO MENSALMENTE, PELAS CONCESSIONARIAS, EM FUNCAO DE CONVENIOS FIRMADOS ENTRE A UNIAO E OS RESPECTIVOS ESTADOS, PARA DELEGACAO DE TRECHOS DE RODOVIAS FEDERAIS (OU OBRAS RODOVIARIAS FEDERAIS), CUJA EXPLORACAO, MEDIANTE CONTRATOS DE CONCESSAO, FOI ENTREGUE PELA UNIAO AOS ESTADOS PARA ADMINISTRACAO E EXPLORACAO. (EMENTARIO - PORTARIA Nº 39, DE 15 DE JUNHO DE 2009)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.25.06', 'OUTORGA UTILIZACAO POSICOES ORBITAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA PARA A UTILIZACAO DE POSICOES ORBITAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.25.07', 'OUTORGA LICENCA E AUTORIZ.AG.ESPAC.BRASILEIRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA DE LICENCAS E AUTORIZACOES DA AGENCIA ESPACIAL BRASILEIRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.25.99', 'OUTRAS VPA CONC. PERM. - SERV. COMUNIC', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICO DE COMUNICACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.26.01', 'BONUS DE ASSINATURA DE CONTRATO DE CONCESSAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO OFERECIDO NA PROPOSTA PARA OBTENCAO DA CONCESSAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.26.02', 'PAGAMENTO P/ RETENCAO AREA EXPLORACAO OU PROD', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO ANUAL PELA RETENCAO DE AREA PARA EXPLORACAO, DESENVOLVIMENTO OU PRODUCAO DE PETROLEO E GAS NATURAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.27.00', 'OUTORGA DE DIREITOS DE USO DE REC. HIDR.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA A PARTICULARES DE DIREITOS DE USO DA AGUA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.28.00', 'OUTORGA DIREITOS DE EXPL. E PESQ. MINER', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA PELA EXPLORACAO DE RECURSOS MINERAIS DEVIDO POR TODAS AS EMPRESAS QUE REALIZAM O APROVEITAMENTO DE UMA JAZIDA MINERAL GARANTIDA A ESSAS A PROPRIEDADE DO PRODUTO DA LAVRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.29.01', 'VPA DE CUSTOS DE EDITAL DE CONCESSAO FLORESTAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PRECO CALCULADO SOBRE OS CUSTOS DE REALIZACAO DO EDITAL DE LICITACAO DA CONCESSAO FLORESTAL DA UNIDADE DE MANEJO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.29.02', 'CONTRATOS TRANSICAO CONCESSAO FLORESTAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PRECO DECORRENTE DE CONTRATOS DE TRANSICAO DE CONCESSAO FLORESTAL PARA EXPLORACAO E GESTAO DE FLORESTAS PUBLICAS E RECURSOS FLORESTAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.30.01', 'CONCESS. DE DIREITO REAL USO AREA PUBLIC', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE AREA PUBLICA POR TERCEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.30.02', 'CONCESSAO DE USO DO POTENCIAL DE ENERGIA HIDR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA AUTORIZACAO OU CONCESSAO, POR PARTE DA UNIAO, DAEXPLORACAO E APROVEITAMENTO DOS POTENCIAIS DE ENERGIA HIDRAULICA. DESTINACAO LEGAL: MINISTERIO DE MINAS E ENERGIA;AMPARO LEGAL: - CONSTITUICAO FEDERAL (ART.20, VIII E 176, ÷1º) - LEI 8987/1995; LEI 9074/1995; - LEI 427/1996; - LEI 10438/2002; LEI 10762/2003; - LEI 10848/2004; - LEI 11488/2007.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.30.04', 'RECEITA DA CESSAO DE USO DE BENS DA UNIAO', 'REGISTRA VPA DECORRENTE DA CESSAO DE USO DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.30.99', 'OUTRAS VPA CONC. PERM. - DIR. USO BENS PUBL.', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.31.01', 'UTIL.RECURSO HIDRICOS - ITAIPU', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMPENSACAO FINANCEIRA RELATIVA AOS ROYALTIES DEVIDOS POR ITAPU BINACIONAL DO BRASIL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.31.02', 'UTIL.RECURSO HIDRICOS - DEMAIS EMPRESAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMPENSACAO FINANCEIRA RELATIVA AOS ROYALTIES DEVIDOS PELA UTILIZACAO DE RECURSOS HIDRICOS PARA GERACAO DE ENERGIA ELETRICA POR OUTRAS EMPRESAS, EXCETO ITAIPU.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.31.03', 'EXPLORACAO DE RECURSOS MINERAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRIBUICOES ECONOMICAS A TITULO DE COTA-PARTE DE COMPENSACOES FINANCEIRAS SOBRE A EXPLORACAO DE RECURSOS MINERAIS. O PRODUTO DA ARRECADACAO DA COMPENSACAO FINANCEIRA PELAEXPLORACAO DE RECURSOS SAO DESTINADOS: A) 23% (VINTE E TRES POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; B) 65% (SESSENTA E CINCO POR CENTO) AOS MUNICIPIOS; C) 12% (DOZE POR CENTO) PARA O DEPARTAMENTO NACIONAL DE PRODUCAO MINE-RAL - DNPM. OS RECURSOS DA COTA-PARTE DESTINADOS AO DEPARTAMENTO NACIONAL DA PRO-DUCAO MINERAL - DNPM, QUE REPASSARA 2% (DOIS POR CENTO) AO IBAMA COM AFINALIDADE DE PROTECAO AMBIENTAL NAS REGIOES MINERADORAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.31.04', 'ROYALTIES PRODUCAO PETROLEO GAS.NAT.-EM TERRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA EXTRACAO DO OLEO BRUTO XISTO BETUMINOSO E GAS NATURAL. O PRODUTO DA COMPENSACAO FINANCEIRA PELA EXTRACAO, TEM A SEGUINTE DESTINACAO: - 3,5% (TRES E MEIO POR CENTO) AOS ESTADOS EXPORTADORES; 1% (UM PORCENTO) AOS MUNICIPIOS PRODUTORES;0,5%(MEIO POR CENTO) AOS MUNICIPIOSONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES DE EMBARQUE OUDESEMBARQUE DE OLEO OU GAS. E TAMBEM DEVIDA A COMPENSACAO FINANCEIRA AOS ESTADOS, DISTRITO FEDERALE MUNICIPIOS CONFRONTANTES, QUANDO O OLEO, XISTO E GAS FOREM EXTRAIDOSDA PLATAFORMA CONTINENTAL, NOS MESMOS 5% (CINCO POR CENTO) SENDO: - 1,5% (UM E MEIO POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIOPOR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OUTERRESTRES DE EMBARQUE E DESEMBARQUE DE OLEO OU GAS; 1,5% (UM E MEIO POR CENTO) AS MUNICIPIOS CONFRONTANTES E SUAS RESPECTIVAS AREAS GEOECONOMICAS; 0,5%(MEIO POR CENTO) PARA CONSTITUIR UM FUNDO ESPECIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.31.05', 'ROYALTIES PROD. PETR. GAS.NAT.-EM PLATAFORMA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM A EXTRACAO DO OLEO BRUTO, XISTO BETUMINOSO E GAS NATURAL. O PRODUTO DA ARRECADACAO DA COMPENSACAO FINANCEIRA PELA EXTRACAO, TEM A SEGUINTE DESTINACAO: - 3,5% (TRES E MEIO POR CENTO) AOS ESTADOS EXPORTADORES; 1% (UM POR CENTO) AOS MUNICIPIOS PRODUTORES;0,5%(MEIO POR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES DE EMBARQUE OU DESEMBARQUE DE OLEO OU GAS. E TAMBEM DEVIDA A COMPENSACAO FINANCEIRA AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS CONFRONTANTES, QUANDO O OLEO, XISTO E GAS FOREM EXTRAIDOS DA PLATAFORMA CONTINENTAL, NOS MESMOS 5% (CINCO POR CENTO) SENDO: POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIOPOR CENTO) - 1,5% (UM E MEIO POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIO POR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES E EMBARQUE E DESEMBARQUE DE OLEO OU GAS; 1,5% (UM E MEIO POR CENTO) AS MUNICIPIOS CONFRONTANTES E SUAS RESPECTIVAS AREAS GEOECONOMICAS; 0,5%(MEIO POR CENTO) PARA CONSTITUIR UM FUNDO ESPECIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.31.06', 'ROYALT.EXCED.PROD.PETR.OU GAS.NAT.-EM TERRA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES COM A PARCELA DO VALOR DO ROYALTY QUE EXCEDER A 5% (CINCO POR CENTO) DA PRODUCAO DE PETROLEO OUGAS NATURAL TENDO A SEGUINTE DISTRIBUICAO: I - QUANDO A LAVRA OCORRER EM TERRA OU EM LAGOS, RIOS, ILHAS FLUVIAISE LACUSTRES: A) 52,5% (CINQUENTA E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS ES-TAODS ONDE OCORRER A PRODUCAO; B)15,0% (QUINZE POR CENTO) AOS MUNICIPIOS ONDE OCORRER A PRODUCAO; C)7,5% (SETE INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS QUESEJAM AFETADOS PELAS OPERACOES DE EMBARQUE E DESEMBARQUE DE PETROLEO EGAS NATURAL, NA FORMA E CRITERIO ESTABELECIDOS PELA ANP; D)25%(VINTE E CINCO POR CENTO) AO MINISTERIO DA CIENCIA E TECNOLOGIA; II - QUANDO A LAVRA OCORRER NA PLATAFORMA CONTINENTAL: A) 22,5%(VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.31.07', 'ROYALTIES EXCED.PROD.PETR.GAS.NAT.-PLATAFORMA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM A PARCELA DO VALOR DO ROYALTY QUE EXCEDER A 5% (CINCO POR CENTO) DA PRODUCAO DE PETROLEO OU GAS NATURAL TENDO A SEGUINTE DISTRIBUICAO: I QUANDO A LAVRA OCORRER EM TERRA OU EM LAGOS, RIOS, ILHAS FLUVIAIS E LACUSTRES: A) 5,5% (CINQUENTA E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS ESTADOS ONDE OCORRER A PRODUCAO; B)15,0 (QUINZE POR CENTO) AOS MUNICIPIOS ONDE OCORRER A PRODUCAO; C) 7,5% (SETE INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS QUE SEJAM AFETADOS PELAS OPERACOES DE EMBARQUE E DESEMBARQUE DE PETROLEO E GAS NATURAL, NA FORMA E CRITERIO ESTABELECIDOS PELA ANP; D)25%(VINTE CINCO POR CENTO) AO MINISTERIO DA CIENCIA E TECNOLOGIA; II - QUANDO A LAVRA OCORRER NA PLATAFORMA CONTINENTAL: A) 22,5%(VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS PRODUTORES', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.31.08', 'PARTICIP.ESPEC.PROD.PETROLEO OU GAS NATURAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PARTICIPACAO ESPECIAL NOS CASOS DE GRANDE VOLUME DE PRODUCAO DE PETROLEO, OU GRANDE RENTABILIDADE. OS RECURSOS DA PARTICIPACAO ESPECIAL SERAO DISTRIBUIDOS NAS SEGUINTESPROPORCOES: - 40% AO MINISTERIO DAS MINAS E ENERGIA, PARA O FINANCIAMENTO DE ESTU-DOS E SERVICOS DE GEOLOGIA E GEOFISICA APLICADOS A PROSPECAO DE PETRO-LEO E GAS NATURAL, A SEREM PROMOVIDOS PELA ANP; - 10% AO MINISTERIO DO MEIO AMBIENTE, DOS RECURSOS HIDRICOS E DA AMA-ZONIA LEGAL, DESTINADOS AO DESENVOLVIMENTO DE ESTUDOS E PROJETOS RELA-CIONADOS COM A PRESERVACAO DO MEIO AMBIENTE E RECUPERACAO DE DANOS AM-BIENTAIS CAUSADOS PELA INDUSTRIA DO PETROLEO; - 40% QUARENTA POR CENTO PARA O ESTADO ONDE OCORRER A PRODUCAO EM TER-RA, OU CONFRONTANTE COM A PLATAFORMA CONTINENTE ONDE SE REALIZAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.31.09', 'SUPRESSAO VEGETAL NAS FLORESTAS NACIONAIS', 'REGISTRA O VALOR DA VPA DA SUPRESSAO VEGETAL NO INTERIOR DAS FLORESTAS NACIONAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.32.01', 'SERVICOS DE TRANSPORTE RODOVIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS COM TRANSPORTE RODOVIARIO, TRANSPORTE RODOVIARIO DE PASSAGEIROS, DE CARGA OU MISTO, DE ESCOLARES, TAXI, DE ENCOMENDAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.32.02', 'SERVICOS DE TRANSPORTE FERROVIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE FERROVIARIO. VPA AUFERIDA NO TRANSPORTE FERROVIARIO DE PASSAGEIROS E DE CARGA, INCLUSIVE METROPOLITANO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.32.03', 'SERVICOS DE TRANSPORTE HIDROVIARIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE HIDROVIARIO. VPA DE SERVICOS DE TRANSPORTE HIDROVIARIO DE PASSAGEIROS, DE CARGA OU MISTO, DE LONGO CURSO, DE CABOTAGEM E POR VIAS INTERNAS (RIOS, LAGOS, ETC...)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.32.04', 'SERVICOS DE TRANSPORTE AEREO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE AEREO. VPA DE SERVICOS DE TRANSPORTE AEREO DE PASSAGEIROS, DE CARGA OU MISTO, TRANSPORTE AEREO REGULAR,TRANSPORTE AEREO REGIONAL, TAXI AEREO, AERONAVES FRETADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.32.99', 'OUTROS SERVICOS DE TRANSPORTE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTROS SERVICOS DE TRANSPORTE, NAO CLASSIFICADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.33.00', 'SERVICOS PORTUARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PORTUARIOS. ABRANGEM OS RECURSOS ORIUNDOS DA EXPLORACAO DOS PORTOS, TERMINAIS MARITIMOS, ATRACADOUROS E ANCORADOUROS, REFERENTES A ESTIVA, DESESTIVA, DRAGAGEM, ATRACACAO, SINALIZACAO, COMUNICACAO NAUTICA, DOCAGEM, ETC....', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.34.00', 'SERVICOS DE SOCORRO MARITIMO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICO DE SOCORRO MARITIMO PRESTADO. VPA DE SERVICOS DE SALVAMENTO, POR NAVIO DE SOCORRO OU EQUIPE DE SALVAMENTO DA MARINHA, DE EMBARCACAO E CARGAS PERIGO (DESENCALHE, MERGULHO, OUTROS SOCORROS), BEM COMO SERVICOS DE REBOQUE MARITIMO, DENTRE OUTROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.35.01', 'SERVICOS HOSPITALARES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE HOSPITAL EM GERAL OU ESPECIALIZADO, MATERNIDADE, CENTRO DE REABILITACAO, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.35.02', 'SERV.REG.AN.CONTR.PROD.SUJ.A NORM.VIGIL.SANIT', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE ANALISE E DE CONTROLE DE PRODUTOS SUJEITOS A NORMAS DE VIGILANCIA SANITARIA E O REGISTRO DE TODOS OS MEDICAMENTOS, DROGAS, INSUMOS FARMACEUTICOS E CORRELATOS, SANEANTES E OUTROS PRODUTOS, INCLUSIVE OS IMPORTADOS, OS EXPOSTOS A VENDA OU ENTREGUE AO CONSUMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.35.03', 'SERVICOS RADIOLOGICOS E LABORATORIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RADIOLOGICOS E LABORATORIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.32.00', 'SERVICOS DE TRANSPORTE', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE TRANSPORTE RODOVIARIO, FERROVIARIO, HIDROVIARIO, AEREO, ESPECIAIS E TARIFA DE PEDAGIO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.35.04', 'SERV ASSIST SAUDE SUPLEMENTAR SERVIDOR CIVIL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PARTICIPACAO DA UNIAO, SUAS AUTARQUIAS E FUNDACOES PUBLICAS E DE RECURSOS PROVENIENTES DA CONTRIBUICAO DOS SERVIDORES PUBLICOS CIVIS ATIVOS, INATIVOS E PENSIONISTAS, DESTINADA AO CUSTEIO DA ASSISTENCIA AA SAUDE SUPLEMENTAR DO SERVIDOR CIVIL, NO CASO DE PRESTACAO DIRETA PELOS ORGAOS (GESTAO PROPRIA). AMPARO LEGAL: LEI 8.112/90, ART. 230 LEI 11.302/2006, ART. 9º PORTARIA SRH/MP 1983/2006 DESTINACAO LEGAL: INTEGRALMENTE DESTINADA AO CUSTEIO DA ASSISTENCIA AA SAUDE SUPLEMENTAR DO SERVIDOR CIVIL DA ADMINISTRACAO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.35.99', 'OUTROS SERVICOS DE SAUDE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTROS SERVICOS DE SAUDE, E NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.36.00', 'CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.37.01', 'METROLOGIA LEGAL E CERTIFICATORIA DELEGADA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA LEGAL E CERTIFICATORIA DELEGADA, ORIUNDAS DE ENTIDADES PUBLICAS OU PRIVADAS CREDENCIADAS. ESTA VPA ESTA AMPARADA PELA LEI NUM 5966DE 11 DE DEZEMBRO DE 1973.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.37.02', 'METROLOGIA CIENTIFICA E INDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA CIENTIFICA E INDUSTRIAL, NO TOCANTE A AFERICAO DE INSTRUMENTOS DE MEDICOES, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC...ESTA VPA ESTA AMPARADA PELA LEI NUM 5966 DE 11 DE DEZEMBRO DE 1973', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.37.03', 'METROLOGIA LEGAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METRO-LOGIA LEGAL, ORIUNDA DE SERVICOS METROLOGICOS LEGAIS. BASICAMENTE,CONSISTE EM ASSEGURAR A UNIFORMIDADE E A RACIONALIZACAO DAS UNIDADESEM TODO O TERRITORIO NACIONAL, AFERICAO DE INSTRUMENTOS DE MEDICOES,ETC. ESTA VPA ESTA AMPARADA PELA LEI 5966 DE 11/12/1973.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.37.04', 'CERTIFICACAO DE PRODUTOS E SERVICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CERTIFICACAO DA QUALIDADE DE MATERIAIS, PRODUTOS E SERVICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.37.05', 'INFORMACAO TECNOLOGICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES TECNOLOGICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.38.00', 'SERVICOS DE INSPECAO E FISCALIZACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INSPECAO E FISCALIZACAO PRESTADOS. VPA PROPORCIONADA PELA CONSTATACAO DAS CONDICOES HIGIENICO-SANITARIAS E TECNICAS DE PRODUTOS OU ESTABELECIMENTOS, OU RESULTANTES DE ACAO EXTERNA E DIRETA DOS ORGAOS DO PODER PUBLICO DESTINADA A VERIFICACAO DO CUMPRIMENTO DA LEGISLACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.39.00', 'SERVICOS ADMINISTRATIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS ADMINISTRATIVOS PRESTADOS, DAS ATIVIDADES DE APOIO ADMINSITRATIVO EXECUTADAS EM ORGANIZACOES DE QUALQUER NATUREZA, TAIS COMO: A)TAXAS DE EXPEDICAO DE CERTIFICADOS; B)TAXAS DE REGISTRO, RENOVACAO, VISTORIA, LICENCA, CADASTRAMENTO, ETC. C)DATILOGRAFIA, MICROFILMAGEM, COPIAS XEROGRAFICAS, HELIOGRAFICAS,FOTOSTATICAS, ETC.. D)TAXAS DE INSCRICAO EM CONCURSOS. E)TAXA DE ADMINISTRACAO DE SERVICOS. F)VENDA DE EDITAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.40.00', 'SERVICOS DE METEOROLOGIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METEOROLOGIA PRESTADOS. VPA PROPORCIONADA PELO FORNECIMENTO DE DADOS METEOROLOGICOS E DE PARECERES TECNICOS, BEM COMO CONSERTO, COMPARACAO E AFERICAO DE EQUIPAMENTOS DE METEOROLOGIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.41.00', 'SERVICOS EDUCACIONAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DO SISTEMA EDUCACIONAL, CUJA NATUREZA ESTEJA DIRETAMENTE RELACIONADA A FORMACAO DO EDUCANDO (MATRICULAS, ANUIDADES, ETC...). AS VPA DE ATIVIDADES AUXILIARES, DE APOIO OU DERIVADAS DOS SERVICOS EDUCACIONAIS PROPRIAMENTE DITOS, DEVEM SER CLASSIFICADAS NOS TITULOS APROPRIADOS. EXEMPLOS: MATRICULAS E ANUIDADES, SERVICOS EDUCACIONAIS, TAXAS DE EXPEDICAO DE DOCUMENTOS, COPIAS XEROGRAFICAS, HELIOGRAFICAS, ETC.., SERVICO DE CREDENCIAMENTO, AUTORIZACAO E RECONHECIMENTO DE CURSOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.42.00', 'SERVICOS AGROPECUARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS AGROPECUARIO: A)PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO,ARACAO,GRADEACAO, CALAGEM,ADUBACAO, DRENAGEM, IRRIGACAO, CAPINA, DESMATAMENTO, ETC.); B)SEMEADURA E PLANTIO; C)COMBATE A PRAGAS (PULVERIZACAO, DEDETIZACAO); D)COLHEITA E PREPARACAO DE PRODUTOS AGRICOLAS; E)INSEMINACAO ARTIFICIAL; F)INCUBACAO DE OVOS; G)VACINACAO DE ANIMAIS; H)OUTROS SERVICOS AUXILIARES DE AGRICULTURA E PECUARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.43.00', 'SERVICOS DE REPARACAO,MANUTENCAO E INSTALACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REPARACAO, MANUTENCAO E INSTALACAO PRESTADOS. VPA DE SERVICOS DE REPARACAO DE ARTEFATOS DE METAL; REPARACAO E MANUTENCAO DE MAQUINAS E APARELHOS DE USO DOMESTICO; REPARACAO, MANUTENCAO E INSTALACAO DE MAQUINAS E APARELHOS ELETRICOS E ELETRONICOS E DE COMUNICACAO; REPARACAO E MANUTENCAO DE INSTALACOES ELETRICAS, DE GAS, DE AGUA, ETC...INCLUEM-SE TAMBEM, NESSE TITULO, OS SERVICOS DE CONFECCAO SOB MEDIDA. NAO SAO CONSIDERADOS NESSE TITULO, CLASSIFICANDO-SE EM VPA INDUSTRIAL: REPARACAO E MANUTENCAO DE VEICULOS FERROVIARIOS, EMBARCACOES E AERONAVES (INDUSTRIA DE MATERIAL DE TRANSPORTE).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.44.00', 'SERVICOS RECREATIVOS E CULTURAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RECREATIVOS E CULTURAIS PRESTADOS. VPA PROPORCIONADA PELA EXPLORACAO DE INSTALACOES PARA RECREACAO, PRATICA DESPORTIVA E CULTURAL ( CINEMAS,TEATROS, SALOES PARA RECITAIS, CONCERTOS, CONFERENCIAS, PLANETARIOS,ESTADIOS DESPORTIVOS, AUTODROMOS, MUSEUS, BIBLIOTECAS, PROMOCAO E/OUPRODUCAO DE ESPETACULOS ARTISTICOS CULTURAIS E ESPORTIVOS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.45.01', 'SERVICOS DE PATENTES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PETICOES, PEDIDOS DE PRIVILEGIO, ANUIDADES DE PEDIDOS, REGISTROS DE DESENHO INDUSTRIAL,ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.45.02', 'SERVICOS DE REGISTRO DE MARCAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PEDIDOS DE REGISTRO DE MARCAS, VIGENCIAS DE MARCAS, PETICOES, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.45.03', 'SERVICOS DE TRANSFERENCIA DE TECNOLOGIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE AVERBACOES DE CONTRATOS, PETICOES, RECURSOS, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.45.04', 'SERVICOS DE REGISTRO INDICACOES GEOGRAFICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE EXPEDICOES DE CERTIFICADOS DE REGISTRO, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.45.05', 'SERVICOS DE REGISTRO PROGRAMA DE COMPUTADOR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE PROGRAMAS DE COMPUTADOR, ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.45.06', 'SERVICOS DE REGISTRO DE DESENHO INDUSTRIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE DESENHO INDUSTRIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.45.07', 'SERV. PROTECAO TOPOGRAFIAS CIRCUITOS INTEGRAD', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROTECAO DAS TOPOGRAFIAS DE CIRCUITOS INTEGRADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.45.08', 'SERVICOS DE REMESSA DE DEPOSITOS OFICIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REMESSA DE DEPOSITOOFICIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.45.99', 'OUTROS SERV.REGIST.MARCAS,PATENTES,TRANSF.TEC', 'REGISTRA AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE REGISTRO DE MARCAS,PATENTES,TRANSFERENCIA DE TECNOLOGIA, NAO CLASSIFICADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.46.00', 'SERVICOS DE REGISTRO DO COMERCIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DO COMERCIO PRESTADOS. VPA ADVINDA DA PRESTACAO DE SERVICOS DE REGISTRO DO COMERCIO E ATIVIDADES AFINS, TRATANDO-SE DE: A) SERVICOS PRESTADOS PELA JUNTA COMERCIAL DO DISTRITO FEDERAL; B) SERVICOS CONSTANTES DO CADASTRO NACIONAL DE EMPRESA, DEVIDOS NO AMBITO DAS JUNTAS COMERCIAIS DOS ESTADOS E DO DISTRITO FEDERAL; C) REMUNERACAO DE SERVICOS PRESTADOS PELO DEPARTAMENTO NACIONAL DE REGISTRO DO COMERCIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.47.00', 'SERVICOS DE FORNECIMENTO DE AGUA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE FORNECIMENTO DE AGUA AOS IRRIGANTES AA AMORTIZACAO DOS INVESTIMENTOS DA INFRA-ESTRUTURA DE IRRIGACAO DOS PROJETOS PUBLICOS, CONFORME DEC.89.496, DE 29.03DE 84, RELATIVOS A TARIFAS K-1 E K-2.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.48.00', 'SERVICOS DE PERFURACAO E INSTALACAO DE POCOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE PERFURACAO EINSTALACAO DE POCOS TUBULARES PROFUNDOS, POCOS ARTESIANOS OU SIMILARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.49.00', 'SERVICOS DE GEOPROCESSAMENTO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS A TERCEIROS DE INTERPRETACAO DE IMAGEM AEROFOTOGRAMETRICA,EXECUCAO DE MAPAS DIGITALIZADOS DIVERSOS, VENDA DE CARTAS E IMAGENS DE SATELITES, VIDEOGRAFICAS E SIMILARES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.50.00', 'SERVICOS DE CADASTRAMENTO DE FORNECEDORES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE CADASTRAMENTO DE EMPRESAS FORNECEDORAS DE BENS E SERVICOS AO GOVERNO FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.51.00', 'TARIFA DE UTILIZACAO DE FAROIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA DE UTILIZACAO DE FAROIS. VPA PROVENIENTE DA EFETIVA UTILIZACAO, POR EMBARCACOES ESTRANGEIRAS, DOS SERVICOS DE SINALIZACAO NAUTICA DE PROTECAO A NAVEGACAO. O PRODUTO DA ARRECADACAO E DESTINADO INTEGRALMENTE AO FUNDO NAVAL PARA APLICACAO NOS SERVICOS QUE ENVOLVAM A MANUTENCAO E AMPLIACAO DA REDE DE BALIZAMENTO MARITIMO, FLUVIAL E LACUSTRE, A CARGO DA DIRETORIA DE HIDROGRAFIA E NAVEGACAO DO MINISTERIO DA MARINHA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.52.01', 'TARIFA AEROPORTUARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA COBRADA POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTILIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPA-TAZIA).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.52.02', 'ADICIONAL SOBRE TARIFA AEROPORTUARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ADICIONAL SOBRE TARIFA AEROPORTUARIA. VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO ADICIONAL SOBRE A TARIFA COBRADAPOR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AE-ROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTILIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIASEM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.52.03', 'PARCELA DA TARIFA DE EMBARQUE INTERNACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PARCELA DA TARIFA DE EMBARQUE INTERNACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.53.00', 'SERVICOS DE CADASTRO DA ATIVIDADE MINERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE AUTORIZACAO DE PESQUISA MINERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.54.01', 'TARIF USO COMUN E AUX.NAVEGACAO AEREA EM ROTA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE DA UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA,PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA OU POR ENTIDADE ESPECIA-LIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. FATO GERADOR: UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA. AMPARO LEGAL: DECRETO-LEI 1896/1981 E DECRETO 86.864/1982.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.54.02', 'ADICIONAL S/ TARIFA USO COM E AUX NAVEG AEREA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO ADICIONAL DE 50% SOBRE AS TARIFAS DE UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA,PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA OU POR ENTIDADE ESPECIALIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. FATO GERADOR: ADICIONAL SOBRE AS TARIFAS RELATIVAS AO USO DOS AUXILIOSAA NAVEGACAO AEREA E DAS TELECOMUNICACOES. DESTINACAO LEGAL: MINISTERIO DA AERONAUTICA OU ENTIDADE DA ADMINISTRA-CAO INDIRETA RESPONSAVEL PELA PRESTACAO DOS SERVICOS. AMPARO LEGAL: LEI 7920/1989 - ART 1.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.55.00', 'TAR.INSCR.CONCURSOS E PROCESSOS SELETIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE INSCRICAO EM CONCURSOS E PROCESSOS SELETIVOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.56.00', 'SERVICO DE COMPENSACAO DE VARIACOES SALARIAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COBRANCA DE CONTRIBUICOES SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO-SFH E SOBRE O SALDO DOS FINANCIAMENTOS IMOBILIARIOS CONCEDIDOS PELOS AGENTES FINANCEIROS DO SFH,COM COBERTURA DO FCVS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.57.01', 'TARIFA PELO USO DO SISTEMA DE INFORM.DO BACEN', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO USO DO SISTEMA DE INFORMACOES DO BACEN.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.57.02', 'TARIFA PELO USO DO SIST.DE TRANSF. RES. BACEN', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO USO DO SISTEMA DE TRANSFERENCIA DE RESERVA DO BACEN.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.58.01', 'CONCESSAO DE AVAL DO TESOURO NACIONAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO DE AVAL DO TESOURO NACIONAL, COBRADA A TITULO DE COMISSAO, EXECUCAO OU FISCALIZACAO PELA CONCESSAO DE GARANTIA DO TESOURO NACIONAL A CREDITOS OBTIDOS NO EXTERIOR. FATO GERADOR: A CONCESSAO DE GARANTIA DO TESOURO NACIONAL A CREDITOS OBTIDOS NO EXTERIOR. AMPARO LEGAL: LEI 5.000, DE 24 DE MAIO DE 1966.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.58.02', 'CONCESSAO GARANTIA DA ATIVIDADE AGROPECUARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ADICIONAL COBRADO SOBRE EMPRESTIMOS RURAIS DE CUSTEIO. TEM COMO FINALIDADE EXIMIR O PRODUTOR RURAL DE POSSIVEIS OBRIGACOES RELATIVAS A OPERACOES DE CREDITO CUJA LIQUIDACAO SEJA DIFICULTADA POR FENOMENOS NATURAIS, DOENCAS OUPRAGAS. FATO GERADOR: A REALIZACAO DE EMPRESTIMOS RURAIS DE CUSTEIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.58.03', 'COMISSOES PELA PRESTACAO DE GARANTIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMISSOES COBRADAS POR CONTA DA GARANTIA DE OPERACOES DE FINANCIAMENTO PARA AUMENTO DA COMPETITIVIDAD EE DA PRODUCAO DESTINADA AA EXPORTACAO. FATO GERADOR: COBRANCA DE COMISSOES, POR CONTA DA GARANTIA DE OPERACOES DE FINANCIAMENTO, PARA AUMENTO DA COMPETITIVIDADE E DA PRODUCAODESTINADA AA EXPORTACAO. DESTINACAO LEGAL: - MICROEMPRESAS E EMPRESAS DE PEQUENO PORTE; - MEDIAS EMPRESAS QUE SEJAM EXPORTADORAS OU FABRICANTES DE INSUMOS QUEINTEGREM O PROCESSO PRODUTIVO, OU DE MONTAGEM E DE EMBALAGEM DE MERCA-DORIAS DESTINADAS AA EXPORTACAO. AMPARO LEGAL: LEI 9531, DE 10 DE DEZEMBRO DE 1997, ÷ 1º, 2º E 3º.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.58.04', 'GARANTIA DOS FINANC.AA ESTOC.ALCOOL ETIL.COMB', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO DE GARANTIAS E AVAIS NOS FINANCIAMENTOS A ESTOCAGEM DE ALCOOL ETILICO COMBUSTIVEL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.58.05', 'RECEITA DE SEGURO DE CREDITO AA EXPORTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA GARANTIA DAS OPERACOES DE CREDITO AA EXPORTACAO CONTRA OS RISCOS COMERCIAIS, POLITICOS E EXTRAORDINARIOS QUE POSSAM AFETAR A PRODUCAO DE BENS E A PRESTACAO DE SERVICOS DESTINADOS AA EXPORTACAO OU AS EXPORTACOES BRASILEIRAS DE BENS E SERVICOS. AMPARO LEGAL: - LEI 9.818, DE 23 DE AGOSTO DE 1999 - LEI 6.704, DE 26 DE OUTUBRO DE 1979, ART.1º', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.59.00', 'CREDENCIAMENTO EMP.PREST.SERVICOS DE VISTORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO VALOR A SER PAGO POR EMPRESAS NA OBTENCAO DE CREDENCIAMENTO PARA PRESTACAO DE SERVICOS DE VISTORIA. - DESTINACAO LEGAL: ORGAO ARRECADADOR; - AMPARO LEGAL: RESOLUCAO CONTRAN 282, DE 26 DE JUNHO DE 2008.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.60.00', 'SERVICOS VETERINARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS VETERINARIOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.61.00', 'CERTIFICACAO E HOMOLOGACAO ATIVIDADE MINERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE REGISTRO DE LICENCA E DO REGISTRO DE PERMISSAO DE LAVRA GARIMPEIRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.62.01', 'SERV.PREST.DIRET. POR INST.CIENT.TECNOLOGICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DIRETAMENTE POR INSTITUICOES CIENTIFICAS E TECNOLOGICAS, VOLTADOS A INOVACAO E A PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.62.02', 'SERV.DECORREN.PARCEIR.C/OUTRAS INST.PUB.PRIV.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA CELEBRACAO DE ACORDOS DE PARCERIA PARA REALIZACAO DE ATIVI-DADES CONJUNTAS DE PESQUISA CIENTIFICA E TECNOLOGICA E DESENVOLVIMENTODE TECNOLOGIA, PRODUTO OU PROCESSO, COM INSTITUICOES PUBLICAS E PRIVA-DAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.63.01', 'SERV.FINANC.DE COMPENS.DE VARIACOES SALARIAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM SERVICOS FINANCEIROS DE COMPENSACAO DE VARIACOES SALARIAIS. VPA PROVENIENTE DE ADICIONAL COBRADO SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DA HABITACAO. TEM COMO FINALIDADE EXIMIR OS ADQUIRENTES DE CASA PROPRIA DO PAGAMENTO DE POSSIVEIS RESIDUOS DO SALDO DEVEDOR DO FINANCIAMENTO IMOBILIARIO EXISTENTES AO FINAL DO PRAZO CONTRATADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.63.02', 'SERVICOS DE REMUNERACAO REP. PROG.DES.ECONOM.', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM SERVICOS DE REMUNERACAO DE REPASSES DE PROGRAMA DE DESENVOLVIMENTO ECONOMOMICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.63.03', 'COMISSOES PELA PREST. DE GARANTIA', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM COMISSOES PELA PREST. DE GARANTIA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.63.99', 'OUTROS SERVICOS FINANCEIROS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM OUTROS SERVICOS FINANCEIROS, NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.64.01', 'SERVICO DE EMISSAO DE CERTIFICADOS DE ORIGEM', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE CERTIFICADOS DE ORIGEM', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.64.02', 'SERVICO DE EMISSAO DE LICENCA DE EXPORTACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE LICENCA DE EXPORTACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.65.00', 'VPA DE UTILIZACAO DE POSICOES ORBITAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE UTILIZACAO DE POSICOES ORBITAIS, CUJOS RECURSOS SAO PROVENIENTES DE: 25 POR CENTO DA VPA QUE SE REFEREM O ARTIGO 2 DA LEI 5070/96,PROVENIENTES DA UTILIZACAO DE POSICOES ORBITAIS 25 POR CENTO DA VPA DA UNIAO, PROVENIENTES DE LANCAMENTOS, EM CARATER COMERCIAL, DE SATELITES E FOGUETES DE SONDAGEM A PARTIR DO TERRITORIO BRASILEIRO 25 POR CENTO DA VPA AUFERIDAS PELA UNIAO, PROVENIENTES DA COMERCIALIZACAO DOS DADOS E IMAGENS OBTIDOS POR MEIOS DE RASTREAMENTO, TELEMEDIDAS E CONTROLE DE FOGUETES E SATELITES TOTAL DA VPA AUFERIDA PELA AGENCIA ESPACIAL BRASILEIRA - AEB, DECORRENTES DA CONCESSAO DE LICENCAS E AUTORIZACOES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.66.00', 'VPA COM.DADOS/IMAGENS UTIL.POSICOES ORBITAIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DOS DADOS E IMAGENS ORIUNDOS DA UTILIZACAO DE POSICOES ORBITAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.67.00', 'VPA LANCAM.SATELITES E FOGUETES DE SONDAGEM', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LANCAMENTOS DE SATELITES E FOGUETES DE SONDAGEM, A PARTIR DO TERRITORIO BRASILEIRO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.68.00', 'SERV.COMERCIAIS DE PROD.DADOS E MAT.INFORMATI', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS, DADOS E MATERIAIS DE INFORMATICA, TAIS COMO DISQUETES,SOFTWARES, PROGRAMAS, CD-ROM, FITAS MAGNETICAS E ASSEMELHADOS, BEM COMO INFORMACOES EM REDES E SISTEMAS DE DADOS DISPONIVEIS EM MEIO DE HARDWARE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.69.00', 'REC.OUTORGA TIT ONEROSO ATIV PESQ/LAVRA-PETRO', 'REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CESSAO A TITULO ONEROSO DAS ATIVIDADES DE PESQUISA E LAVRA DAS JAZIDAS DE PETROLEO E GAS NATURAL E OUTROS HIDROCARBONETOS FLUIDOS, BEM COMO O SEU REFINO E TRANSPORTE MARITIMO. DESTINACAO LEGAL: TESOURO NACIONAL AMPARO LEGAL: ART 177 DA CONSTITUICAO FEDERAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.99.00', 'OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS NAO ENQUADRADOS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.01.00', '(-) VENDAS CANCELADAS E DEVOLUCOES', 'REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE SERVICOES REFERENTES A CANCELAMENTO DE VENDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.02.00', '(-) ABATIMENTOS', 'REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NOS SERVICOS ENTREGUES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.03.00', '(-) DESCONTOS INCONDICIONAIS', 'REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.05.00', '(-) ISS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ISS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.06.00', '(-) ICMS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ICMS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.07.00', '(-) PIS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.08.00', '(-) PASEP', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.09.00', '(-) COFINS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES A COFINS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.10.00', '(-) CONTRIBUICOES PREVIDENCIARIAS - INSS PATRONAL', 'REGISTRA O VALOR DA CONTRIBUICAO PATRONAL DEVIDA PELAS EMPRESAS QUE PRESTAM EXCLUSIVAMENTE OS SERVICOS DE TECNOLOGIA DA INFORMACAO (TI) E DE TECNOLOGIA DA INFORMACAO E COMUNICACAO (TIC), INCIDENTE SOBRE O VALOR DA RECEITA BRUTA, EXCLUIDAS AS VENDAS CANCELADAS E OS DESCONTOS INCONDICIONAIS CONCEDIDOS, CONFORME DISPOE O ART.7º DA LEI 12546/2011. A PRESENTE METODOLOGIA DE CALCULO DO INSS PATRONAL TERA VIGENCIA ATE 31 DE DEZEMBRO DE 2014.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.2.01.00', '(-) VENDAS CANCELADAS E DEVOLUCOES', 'REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE SERVICOES REFERENTES A CANCELAMENTO DE VENDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.2.02.00', '(-) ABATIMENTOS', 'REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NOS SERVICOS ENTREGUES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.2.03.00', '(-) DESCONTOS INCONDICIONAIS', 'REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.2.05.00', '(-) ISS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ISS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.2.06.00', '(-) ICMS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ICMS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.2.07.00', '(-) PIS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.2.08.00', '(-) PASEP', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.2.09.00', '(-) COFINS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES A COFINS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.2.10.00', '(-) CONTRIBUICOES PREVIDENCIARIAS - INSS PATRONAL', 'REGISTRA O VALOR DA CONTRIBUICAO PATRONAL DEVIDA PELAS EMPRESAS QUE PRESTAM EXCLUSIVAMENTE OS SERVICOS DE TECNOLOGIA DA INFORMACAO (TI) E DE TECNOLOGIA DA INFORMACAO E COMUNICACAO (TIC), INCIDENTE SOBRE O VALOR DA RECEITA BRUTA, EXCLUIDAS AS VENDAS CANCELADAS E OS DESCONTOS INCONDICIONAIS CONCEDIDOS, CONFORME DISPOE O ART.7º DA LEI 12546/2011. A PRESENTE METODOLOGIA DE CALCULO DO INSS PATRONAL TERA VIGENCIA ATE 31 DE DEZEMBRO DE 2014.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.2.99.00', '(-) OUTRAS DEDUCOES DE VENDAS', 'REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE SERVICOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.4.01.00', '(-) VENDAS CANCELADAS E DEVOLUCOES', 'REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE SERVICOES REFERENTES A CANCELAMENTO DE VENDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.4.02.00', '(-) ABATIMENTOS', 'REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NOS SERVICOS ENTREGUES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.4.03.00', '(-) DESCONTOS INCONDICIONAIS', 'REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.4.05.00', '(-) ISS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ISS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.4.06.00', '(-) ICMS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ICMS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.4.07.00', '(-) PIS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.4.08.00', '(-) PASEP', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.4.09.00', '(-) COFINS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES A COFINS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.4.10.00', '(-) CONTRIBUICOES PREVIDENCIARIAS - INSS PATRONAL', 'REGISTRA O VALOR DA CONTRIBUICAO PATRONAL DEVIDA PELAS EMPRESAS QUE PRESTAM EXCLUSIVAMENTE OS SERVICOS DE TECNOLOGIA DA INFORMACAO (TI) E DE TECNOLOGIA DA INFORMACAO E COMUNICACAO (TIC), INCIDENTE SOBRE O VALOR DA RECEITA BRUTA, EXCLUIDAS AS VENDAS CANCELADAS E OS DESCONTOS INCONDICIONAIS CONCEDIDOS, CONFORME DISPOE O ART.7º DA LEI 12546/2011. A PRESENTE METODOLOGIA DE CALCULO DO INSS PATRONAL TERA VIGENCIA ATE 31 DE DEZEMBRO DE 2014.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.4.99.00', '(-) OUTRAS DEDUCOES DE VENDAS', 'REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE SERVICOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.5.01.00', '(-) VENDAS CANCELADAS E DEVOLUCOES', 'REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE SERVICOES REFERENTES A CANCELAMENTO DE VENDAS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.5.02.00', '(-) ABATIMENTOS', 'REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NOS SERVICOS ENTREGUES.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.5.03.00', '(-) DESCONTOS INCONDICIONAIS', 'REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.5.05.00', '(-) ISS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ISS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.5.06.00', '(-) ICMS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ICMS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.5.07.00', '(-) PIS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PIS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.5.08.00', '(-) PASEP', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PASEP.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.5.09.00', '(-) COFINS', 'REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES A COFINS.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.5.10.00', '(-) CONTRIBUICOES PREVIDENCIARIAS - INSS PATRONAL', 'REGISTRA O VALOR DA CONTRIBUICAO PATRONAL DEVIDA PELAS EMPRESAS QUE PRESTAM EXCLUSIVAMENTE OS SERVICOS DE TECNOLOGIA DA INFORMACAO (TI) E DE TECNOLOGIA DA INFORMACAO E COMUNICACAO (TIC), INCIDENTE SOBRE O VALOR DA RECEITA BRUTA, EXCLUIDAS AS VENDAS CANCELADAS E OS DESCONTOS INCONDICIONAIS CONCEDIDOS, CONFORME DISPOE O ART.7º DA LEI 12546/2011. A PRESENTE METODOLOGIA DE CALCULO DO INSS PATRONAL TERA VIGENCIA ATE 31 DE DEZEMBRO DE 2014.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.5.99.00', '(-) OUTRAS DEDUCOES DE VENDAS', 'REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE SERVICOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.1.1.00.00', 'JUROS E ENCARGOS DE EMPRESTIMOS INTERNOS CONCEDIDOS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICACAO DAS TAXAS DE JUROS APLICADAS A EMPRESTIMOS INTERNOS CONCEDIDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.1.4.00.00', 'JUROS E ENCARGOS DE EMPRESTIMOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICACAO DAS TAXAS DE JUROS APLICADAS A EMPRESTIMOS INTERNOS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.1.5.00.00', 'JUROS E ENCARGOS DE EMPRESTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICACAO DAS TAXAS DE JUROS APLICADAS A EMPRESTIMOS INTERNOS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.2.1.00.00', 'JUROS E ENCARGOS DE EMPRESTIMOS EXTERNOS CONCEDIDOS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICACAO DAS TAXAS DE JUROS APLICADAS A EMPRESTIMOS EXTERNOS CONCEDIDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.3.1.00.00', 'JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS INTERNOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.3.4.00.00', 'JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS INTERNOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.3.5.00.00', 'JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS INTERNOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.4.1.00.00', 'JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS EXTERNOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.1.1.00.00', 'JUROS E ENCARGOS DE MORA SOBRE EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.1.4.00.00', 'JUROS E ENCARGOS DE MORA SOBRE EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.1.5.00.00', 'JUROS E ENCARGOS DE MORA SOBRE EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.2.1.00.00', 'JUROS E ENCARGOS DE MORA SOBRE EMPRESTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A EMPRESTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.1.01.00', 'MULT.J.MORA DIV.AT.OUTOR.DIR.EXPL.E PESQ.MIN.', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE CREDITO DA FAZENDA PUBLICA, PELO NAO PAGAMENTO DOS CONTRIBUINTES NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA RECEITA DE OUTORGA DE DIREITOS DE EXPLORACAO E PESQUISA MINERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.1.02.00', 'MULTAS E JUROS DE MORA DE ALUGUEIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUR. MORA APLIC. ATRAS. PAGAMEN. DE ALUGUEIS DEVIDOS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.1.03.00', 'MULTAS E JUROS DE MORA DE ARRENDAMENTOS', 'REGISTRAA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA APLIC.P/ ATRAS. NO PAGAMENTO DE RENDAS DEVIDAS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO SOB A FORMA DE ARRENDAMENTO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.1.04.00', 'MULTAS E JUROS DE MORA DE LAUDEMIOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA ATRASOS NOS RECOLHIMEN. DAS DIFERENCAS DE LAUDEMIOS, GERADAS ANTES DA EDICAO DA M.P NUM 1647 - 14, DE 24 DE MARCO DE 1998, DE ACORDO COM O PREVISTO NO ART. 5. DO DECRETO NUM. 95.760, DE 01 DE MARCO DE 1988.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.1.05.00', 'MULTAS E JUROS DE MORA DE FOROS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA APLIC. ATRASOS NO RECOLHIMENTO DE DEBITOS DE FORO PARA COM A UNIAO, DE ACORDO COM ART. 61 DA LEI NUM. 9430, DE 27 DE DEZEMBRO DE 1996 E O PARAGRAFO 4 DO ART. 36 DA LEI NUM. 9069, DE 29 DE JULHO DE 1995.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.1.06.00', 'MULTAS E JUROS DE MORA DE TAXAS DE OCUPACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR MORA APLIC. P/ ATRASOS RECOLHIMENTO DE DEBITOS DE TAXA DE OCUPACAO PARA COM A UNIAO, DE ACORDO COM O ART. 61 DA LEI 9430, DE 27 DE DEZEMBRO DE 1996, E O PARAGRAFO 4 DO ART. 36 DA LEI NUM. 9069, DE 29 DE JUNHO DE 1995.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.1.07.00', 'MULT.J.MORA REC. EXPLORACAO RECURSOS MINERAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLICADOS POR ATRASOS NO PAGAMENTO DA RECEITA DE EXPLORACAO DE RECURSOS MINERAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.1.08.00', 'MULT.J.MORA OUTORG.DIR.EXPLOR.E PESQU.MINERAL', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLICADOS POR ATRASOS NO PAGAMENTO DA RECEITA DE OUTORGA DE DIREITOS DE EXPLORACAO E PESQUISA MINERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.1.99.00', 'OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.2.01.00', 'MULT.J.MORA DIV.AT.OUTOR.DIR.EXPL.E PESQ.MIN.', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE CREDITO DA FAZENDA PUBLICA, PELO NAO PAGAMENTO DOS CONTRIBUINTES NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA RECEITA DE OUTORGA DE DIREITOS DE EXPLORACAO E PESQUISA MINERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.2.02.00', 'MULTAS E JUROS DE MORA DE ALUGUEIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUR. MORA APLIC. ATRAS. PAGAMEN. DE ALUGUEIS DEVIDOS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.2.03.00', 'MULTAS E JUROS DE MORA DE ARRENDAMENTOS', 'REGISTRAA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA APLIC.P/ ATRAS. NO PAGAMENTO DE RENDAS DEVIDAS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO SOB A FORMA DE ARRENDAMENTO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.2.04.00', 'MULTAS E JUROS DE MORA DE LAUDEMIOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA ATRASOS NOS RECOLHIMEN. DAS DIFERENCAS DE LAUDEMIOS, GERADAS ANTES DA EDICAO DA M.P NUM 1647 - 14, DE 24 DE MARCO DE 1998, DE ACORDO COM O PREVISTO NO ART. 5. DO DECRETO NUM. 95.760, DE 01 DE MARCO DE 1988.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.2.05.00', 'MULTAS E JUROS DE MORA DE FOROS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA APLIC. ATRASOS NO RECOLHIMENTO DE DEBITOS DE FORO PARA COM A UNIAO, DE ACORDO COM ART. 61 DA LEI NUM. 9430, DE 27 DE DEZEMBRO DE 1996 E O PARAGRAFO 4 DO ART. 36 DA LEI NUM. 9069, DE 29 DE JULHO DE 1995.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.2.06.00', 'MULTAS E JUROS DE MORA DE TAXAS DE OCUPACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR MORA APLIC. P/ ATRASOS RECOLHIMENTO DE DEBITOS DE TAXA DE OCUPACAO PARA COM A UNIAO, DE ACORDO COM O ART. 61 DA LEI 9430, DE 27 DE DEZEMBRO DE 1996, E O PARAGRAFO 4 DO ART. 36 DA LEI NUM. 9069, DE 29 DE JUNHO DE 1995.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.2.07.00', 'MULT.J.MORA REC. EXPLORACAO RECURSOS MINERAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLICADOS POR ATRASOS NO PAGAMENTO DA RECEITA DE EXPLORACAO DE RECURSOS MINERAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.2.08.00', 'MULT.J.MORA OUTORG.DIR.EXPLOR.E PESQU.MINERAL', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLICADOS POR ATRASOS NO PAGAMENTO DA RECEITA DE OUTORGA DE DIREITOS DE EXPLORACAO E PESQUISA MINERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.2.99.00', 'OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.4.01.00', 'MULT.J.MORA DIV.AT.OUTOR.DIR.EXPL.E PESQ.MIN.', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE CREDITO DA FAZENDA PUBLICA, PELO NAO PAGAMENTO DOS CONTRIBUINTES NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA RECEITA DE OUTORGA DE DIREITOS DE EXPLORACAO E PESQUISA MINERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.4.02.00', 'MULTAS E JUROS DE MORA DE ALUGUEIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUR. MORA APLIC. ATRAS. PAGAMEN. DE ALUGUEIS DEVIDOS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.4.03.00', 'MULTAS E JUROS DE MORA DE ARRENDAMENTOS', 'REGISTRAA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA APLIC.P/ ATRAS. NO PAGAMENTO DE RENDAS DEVIDAS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO SOB A FORMA DE ARRENDAMENTO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.4.04.00', 'MULTAS E JUROS DE MORA DE LAUDEMIOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA ATRASOS NOS RECOLHIMEN. DAS DIFERENCAS DE LAUDEMIOS, GERADAS ANTES DA EDICAO DA M.P NUM 1647 - 14, DE 24 DE MARCO DE 1998, DE ACORDO COM O PREVISTO NO ART. 5. DO DECRETO NUM. 95.760, DE 01 DE MARCO DE 1988.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.4.05.00', 'MULTAS E JUROS DE MORA DE FOROS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA APLIC. ATRASOS NO RECOLHIMENTO DE DEBITOS DE FORO PARA COM A UNIAO, DE ACORDO COM ART. 61 DA LEI NUM. 9430, DE 27 DE DEZEMBRO DE 1996 E O PARAGRAFO 4 DO ART. 36 DA LEI NUM. 9069, DE 29 DE JULHO DE 1995.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.4.06.00', 'MULTAS E JUROS DE MORA DE TAXAS DE OCUPACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR MORA APLIC. P/ ATRASOS RECOLHIMENTO DE DEBITOS DE TAXA DE OCUPACAO PARA COM A UNIAO, DE ACORDO COM O ART. 61 DA LEI 9430, DE 27 DE DEZEMBRO DE 1996, E O PARAGRAFO 4 DO ART. 36 DA LEI NUM. 9069, DE 29 DE JUNHO DE 1995.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.4.07.00', 'MULT.J.MORA REC. EXPLORACAO RECURSOS MINERAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLICADOS POR ATRASOS NO PAGAMENTO DA RECEITA DE EXPLORACAO DE RECURSOS MINERAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.4.08.00', 'MULT.J.MORA OUTORG.DIR.EXPLOR.E PESQU.MINERAL', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLICADOS POR ATRASOS NO PAGAMENTO DA RECEITA DE OUTORGA DE DIREITOS DE EXPLORACAO E PESQUISA MINERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.4.99.00', 'OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.5.01.00', 'MULT.J.MORA DIV.AT.OUTOR.DIR.EXPL.E PESQ.MIN.', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE CREDITO DA FAZENDA PUBLICA, PELO NAO PAGAMENTO DOS CONTRIBUINTES NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA RECEITA DE OUTORGA DE DIREITOS DE EXPLORACAO E PESQUISA MINERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.5.02.00', 'MULTAS E JUROS DE MORA DE ALUGUEIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUR. MORA APLIC. ATRAS. PAGAMEN. DE ALUGUEIS DEVIDOS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.5.03.00', 'MULTAS E JUROS DE MORA DE ARRENDAMENTOS', 'REGISTRAA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA APLIC.P/ ATRAS. NO PAGAMENTO DE RENDAS DEVIDAS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO SOB A FORMA DE ARRENDAMENTO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.5.04.00', 'MULTAS E JUROS DE MORA DE LAUDEMIOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA ATRASOS NOS RECOLHIMEN. DAS DIFERENCAS DE LAUDEMIOS, GERADAS ANTES DA EDICAO DA M.P NUM 1647 - 14, DE 24 DE MARCO DE 1998, DE ACORDO COM O PREVISTO NO ART. 5. DO DECRETO NUM. 95.760, DE 01 DE MARCO DE 1988.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.5.05.00', 'MULTAS E JUROS DE MORA DE FOROS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA APLIC. ATRASOS NO RECOLHIMENTO DE DEBITOS DE FORO PARA COM A UNIAO, DE ACORDO COM ART. 61 DA LEI NUM. 9430, DE 27 DE DEZEMBRO DE 1996 E O PARAGRAFO 4 DO ART. 36 DA LEI NUM. 9069, DE 29 DE JULHO DE 1995.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.5.06.00', 'MULTAS E JUROS DE MORA DE TAXAS DE OCUPACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR MORA APLIC. P/ ATRASOS RECOLHIMENTO DE DEBITOS DE TAXA DE OCUPACAO PARA COM A UNIAO, DE ACORDO COM O ART. 61 DA LEI 9430, DE 27 DE DEZEMBRO DE 1996, E O PARAGRAFO 4 DO ART. 36 DA LEI NUM. 9069, DE 29 DE JUNHO DE 1995.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.5.07.00', 'MULT.J.MORA REC. EXPLORACAO RECURSOS MINERAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLICADOS POR ATRASOS NO PAGAMENTO DA RECEITA DE EXPLORACAO DE RECURSOS MINERAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.5.08.00', 'MULT.J.MORA OUTORG.DIR.EXPLOR.E PESQU.MINERAL', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLICADOS POR ATRASOS NO PAGAMENTO DA RECEITA DE OUTORGA DE DIREITOS DE EXPLORACAO E PESQUISA MINERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.5.99.00', 'OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.01.00', 'MULTAS E JUROS DE MORA- IMP. IMPORTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS REFERENTES A MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTES REFERENTESAO IMPOSTO SOBRE IMPORTACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.02.01', 'MULTAS E JUROS DE MORA - IRPF', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS E JUROS DE MORA REFERENTES AO IMPOSTO SOBRE A RENDA DAS PESSOAS FISICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.02.02', 'MULTA E JUROS DE MORA - IRPJ', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS E JUROS DE MORA REFERENTES AO IMPOSTO SOBRE A RENDA DAS PESSOAS JURIDICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.02.03', 'MULTA E JUROS DE MORA - IRRF', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS E JUROS DE MORA REFERENTES AO IMPOSTO DE RENDA RETIDO NA FONTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.02.04', 'MULTA E JUROS DE MORA SIMPLES FED. E NAC-IRPJ', 'REGISTRA VPA ARRECADADA DECORRENTE DE MULTA E JUROS DE MORA SIMPLES FEDERAL E NACIONAL - IRPJ.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.03.00', 'MULTAS E JUROS DE MORA - IPI', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.04.00', 'MULTAS E JUROS DE MORA DO IOF', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, OU RELATIVAS A TITULOS E VALORES MOBILIARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.05.00', 'MULTAS E JUROS DE MORA - IMP. EXPORTACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS REFERENTES A MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE EXPORTACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.06.01', 'MULTA E JUROS DE MORA DO ITR MUNICIPIOS CONVENIADOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTE REFERENTES AO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.06.02', 'MULTA E JUROS DE MORA DO ITR - MUNIC NAO CONVENIADOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTE REFERENTESAO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS NAO CONVENIADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.07.00', 'MULTAS E JUROS MORA TX.FISC.TELECOMUNICACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTESA TAXA DE FISCALIZACAO DAS TELECOMUNICACOES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.08.00', 'MULTAS E JUROS DE MORA TAXA FISC. PROD. MEX', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTA AOS CONTRIBUINTES REFERENTES A TAXA DE FISCALIZACAO DOS PRODUTOS CONTROLADOS PELO MINISTERIO DO EXERCITO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.09.00', 'MUL.JUR.MORA TX FISC.MERC.SEG.CAPIT.PREV.ABER', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZACAO DOS MERCADOS DE SEGURO, DA CAPITALIZACAO E DA PREVIDENCIA PRIVADA ABERTA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.11.00', 'MUL.JUR.MORA TAXA DE SAUDE SUPLEMENTAR', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE SAUDE SUPLEMENTAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.12.00', 'MUL.JUR.MORA TX FISC.MERC.TIT. E VAL. MOBILI.', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZACAO DOS MERCADOS DE TITULOS E VALORES MOBILIARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.13.00', 'MULTAS E JUROS DE MORA DA CONTRIB. PREVIDENC. - COFINS', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA COM MULTAS E JUROS DE MORA REFERENTES A CONTRIBUICAO PREVIDENCIARIA PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.14.00', 'MULTAS E JUROS DE MORA CONT.SALARIO-EDUCACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA DECORRENTE DE INOBSERVANCIA DE NORMA ESPECIFICA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO PAGAMENTO DA CONTRIBUICAO DO SALARIO-EDUCACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.15.00', 'MULTA E JUROS DE MORA DA CIDE- COMBUSTIVEL', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA SOBRE A CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO E COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.16.01', 'MULTAS/JUROS CONTR.PATRONAL REGIME PROP.PREV', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS DE MORA DA CONTRIBUICAO PATRONAL PARA O REGIME PROPRIO DE PREVIDENCIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.16.02', 'MULTAS/JUROS CONTR.SERVIDOR REGIME PROP.PREV', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS DE MORA DA CONTRIBUICAO DO SERVIDOR PARA O REGIME PROPRIO DE PREVIDENCIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.01', 'MULTAS/J.MORA CONTR.PREV.SEG.OBRIGAT.C.INDIV.', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - CONTRIBUINTE INDIVIDUAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.02', 'MULTAS/J.MORA CONTR.PREV.SEGURADO EMPREGADO E TRABALHADOR AVULSO', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DO SEGURADO EMPREGADO E TRABALHADOR AVULSO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.03', 'MULTAS/J.MORA CONTR.PREV.EMPRESA S/SEG.ASSAL.', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DA EMPRESA SOBRE O SEGURADO ASSALARIADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.04', 'MULTAS/J.MORA CONTR.PREV.S/ ESPET. DESPORTIVO', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA SOBRE ESPETACULOS DESPORTIVOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.05', 'MULTAS/J.MORA CONTR.PREV.S/ PRODUCAO RURAL', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA SOBRE A PRODUCAO RURAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.06', 'MULTAS/J.MORA CONTR.PREV.P/SEG.ACIDENTE TRAB.', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA PARA O SEGURO ACIDENTE DE TRABALHO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.07', 'MULTAS/J.MORA CONTR.PREV.S/ RECLAM. TRABALH.', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA SOBRE RECLAMATORIA TRABALHISTA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.08', 'MULTAS/J.MORA CONTR.PREV.DO SEG. FACULTATIVO', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DO SEGURADO FACULTATIVO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.09', 'MULTAS/J.MORA CONTR.PREV.DO SEGURADO ESPECIAL', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DO SEGURADO ESPECIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.10', 'MULTAS/J.MORA CONTR.PREV. SEG.OBRIG.-EMPR.DOMESTICO', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - EMPREGADO DOMESTICO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.11', 'MULTAS/J.MORA CONTR.PREV. ORGAOS PODER PUBL.', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.12', 'MULTAS/J.MORA CONTR.PREV. ENTIDADES FILANTROPICO', 'REPRESENTA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DAS ENTIDADES FILANTROPICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.13', 'MULTAS/J.MORA CONTR.PREV. RET.S/NF-SUBROGACAO', 'REPRESENTA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DAS RETENCOES SOBRE NOTAS FISCAIS - SUBROGACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.14', 'MULTAS/J.MORA ARREC. FIES - CERT.FIN. TESOURO', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA ARRECADACAO DO FIES- CERTIFICADOS FINANCEIROS DO TESOURO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.15', 'MULTAS/J.MORA DA CONTR.PREV. DEP.JUD/REC/CUST', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PE-CUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA NA FORMA DE DEPOSITO JUDICIAL, RECURSAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.16', 'MULTAS/J.MORA CONTR.PREV.EM REG. PARCEL. DEB.', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA EM REGIME DE PARCELAMENTO DE DEBITOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.18.00', 'MULTAS E JUROS DE MORA CONTRIB. DO PIS/PASEP', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA DECORRENTE DE INOBSERVANCIA DENORMA ESPECIFICA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO PAGAMENTO DA CONTRIBUICAO PARA O PIS/PASEP.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.19.00', 'MULTAS E JUROS S/CONTR.SOCIAL S/LUCRO DE PJ', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA DECORRENTE DE INOBSERVANCIA DENORMA ESPECIFICA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO PAGAMENTO DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DE PESS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.21.00', 'MUL.JUR.MORA CONT.REC.CONCES.ENERGIA ELETRICA', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE PENALIDADES PECUNIARIAS PELO NAO RE-COLHIMENTO, NO PRAZO ESTABELECIDO, DA CONTRIBUICAO SOBRE A RECEITA DAS CONCESSIONARIAS DE ENERGIA ELETRICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.22.00', 'MUL.JUR.MORA DA COTA-PARTE DA CONTR.SINDICAL', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE PENALIDADES PECUNIARIAS PELO NAO RECOLHIMENTO, NO PRAZO ESTABELECIDO, DA COTA-PARTE DA CONTRIBUICAO SINDICAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.23.00', 'MUL.JUR.MORA CONTR.S/REC.SORTEIOS ENT.FILANTR', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE PENALIDADES PECUNIARIAS PELO NAO RECOLHIMENTO, NO PRAZO ESTABELECIDO, DA CONTRIBUICAO SOBRE A RECEITA DE SORTEIOS REALIZADOS POR ENTIDADES FILANTROPICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.24.00', 'MUL.JU.MORA COTA-PARTE FRETE REN.MAR.MERCANTE', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA COTA-PARTE DO ADICIONAL AO FRETE PARA A RENOVACAO DA MARINHA MERCANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.25.00', 'MULT. J.MORA CONTR.REL.DESP.EMP. S/ J.CAUSA', 'REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA MULT. J.MORA CONTR.REL.DESP.EMP. S/ J.CAUSA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.26.00', 'MULT. J.MORA CONTR. S/ REMUN. DEVIDA AO TRAB.', 'REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA MULT. J.MORA CONTR. S/ REMUN. DEVIDA AO TRAB..', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.27.01', 'JUROS MORA DO FUNDAF - CONTR. FIN. SEG.SOCIAL', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.27.02', 'JUROS MORA DO FUNDAF - CONTR. P/ PIS/PASEP', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA CONTRIBUICAO PARA OS PROGRAMAS PIS/PASEP. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.27.03', 'JUROS MORA DO FUNDAF - CONTR.SOC. S/LUCRO PJ', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.28.00', 'MULTA/JUROS DE COMPENS. FINANCEIRAS RG/RPPS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICOES NAO RECOLHIDAS ATE O VENCIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.29.00', 'MULTAS JUR. MORA DIV.ATIVA IMPOSTO IMPORTACAO', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL,', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.30.01', 'MULTAS JUR. MORA DIV.ATIVA IR-PESSOA FISICA', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA - PESSOA FISICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.30.02', 'MULTAS JUR. MORA DIV.ATIVA IR-PESSOA JURIDICA', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA - PESSOA JURIDICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.30.03', 'MULTAS JUR. MORA DIV.ATIVA IR-RETIDO NA FONTE', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA - RETIDO NAS FONTES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.31.00', 'MULTAS JUR. MORA DIV.ATIVA IMP. PROD.INDUSTR.', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.32.00', 'MUL.JUR.MORA DIV.AT.IMP.OP.CR.CAM.SEG.VAL.MOB', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO OU RELATIVAS A TITULOS OU VALORES MOBILIARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.33.00', 'MULTAS JUR. MORA DIV.ATIVA IMPOSTO EXPORTACAO', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COM A FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL,, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A EXPORTACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.34.00', 'MULTAS JUR. MORA DIV.ATIVA IMP.PROP.TER.RURAL', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.35.00', 'MULTAS JUR. MORA DIV.ATIVA TX FISC.TELECOMUN.', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DE TAXA DE FISCALIZACAO DE TELECOMUNICACAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.36.00', 'MULTAS J.MORA DIV.ATIVA-CONTR. FIN.SEG.SOCIAL', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL,INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.37.01', 'MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.OB.C.I.', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - CONTRIBUINTE INDIVIDUAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.37.02', 'MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.EMPREGADO E TRABALHADOR AVULSO', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO EMPREGADO E TRABALHADOR AVULSO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.37.03', 'MULTAS JUR.MORA DIV.AT.CONTR.PREV.EMPR.SEG.AS', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DA EMPRESA SOBRE SEGURADO ASSALARIADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.37.04', 'MULTAS JUR.MORA DIV.AT.CONTR.PREV.EMPR-SIMPLE', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DA EMPRESA OPTANTE PELO SIMPLES', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.37.05', 'MULTAS JUR.MORA DIV.AT.CONTR.PREV.ESPET.DESPO', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA SOBRE ESPETACULO DESPORTIVO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.37.06', 'MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.ACI.TRA', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA PARA O SEGURO DE ACIDENTE DO TRABALHO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.37.07', 'MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.ESPECIA', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO -ESPECIAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.37.08', 'MULTAS J.M.DIV.AT.CONTR.PREV.SEG.OBR.-EMP.DOM', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - EMPREGADO DOMESTICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.37.09', 'MULTAS J.M.DIV.AT.CONTR.PREV.SEG.ORG.POD.PUBL', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.38.00', 'MULTAS J.MORA DIV.ATIVA-CONTR. P/ PIS/PASEP', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PARA OS PROGRAMAS DE INTEGRACAO SOCIAL E DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.39.00', 'MULTAS JUR.MORA DIV.ATIVA CONTR.SOC.LUCRO PJ.', 'REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTES SOBRE A DIVIDA ATIVA DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.40.00', 'MULT.J.MORA DIV.AT.COTA ADIC.FR.MARINHA MERC.', 'REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DA DIVIDA ATIVA DA COTA-PARTE DO ADICIONAL AO FRETE PARA RENOVACAO DA MARINHA MERCANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.41.00', 'MULTAS JUR.MORA DIV.ATIVA CIDE - COMBUSTIVEL', 'REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO RELATIVA A ATIVIDADE DE COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.42.01', 'JUROS MORA DO FUNDAF - DIV. ATIVA DA COFINS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIALBASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.42.02', 'JUROS MORA DO FUNDAF - DIV. ATIVA PIS/PASEP', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA CONTRIBUICAO PARA OS PROGRAMAS PIS/PASEP. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.42.03', 'JUROS MORA DO FUNDAF - DIV. ATIVA CSLL', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA CONTRIBUICAO SOCIAL S/ O LUCRO DAS PESSOAS JURIDICAS BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.43.00', 'MULTA E JUROS DE MORA-SIMPLES FED. E NAC.-IPI', 'REGISTRA A VPA ARRECADADA DECORRENTE DE MULTA E JUROS DE MORA DO SIMPLES FEDERAL E NACIONAL - IPI.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.44.00', 'MULTAS/JUROS DAS CONTRIB. S/ SERV. TELECOMUN.', 'REGISTRA O SOMATORIO DA VPA COM MULTAS E JUROS DE MORA DAS CONTRIBUICOES SOBRE A PRESTACAO DOS SERVICOS DE TELECOMUNICACOES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.45.00', 'MULTAS E JUROS DE MORA DIVIDA ATIVA - TX FISCALIZACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTE DE MULTAS E JUROS DE MORA DA DIVIDA ATIVA DA TAXA DE FISCALIZACAO - TAFIC. PORTARIA SOF Nº 144 DE 27/10/10).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.97.01', '(-) RENUNCIA', 'REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.99.01', 'JUROS E ENCARGOS DE MORA SOBRE OUTROS TRIBUTOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE OUTROS TRIBUTOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.99.02', 'JUROS E ENCARGOS DE MORA SOBRE DIVIDA ATIVA DE OUTROS TRIBUTOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE DIVIDA ATIVA DE OUTROS TRIBUTOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.01.01', 'MULTA ALIEN.BENS IMOVEIS DOM.UNIAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE MULTA DE MORA DA ALIENACAO DE BENS IMOVEIS DO DOMINIO DA UNIAO- DOMINIO PLENO, UTIL E DIRETO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.01.02', 'JUROS ALIEN.BENS IMOVEIS DOM.UNIAO', 'REGISTRA A A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE JUROS DE MORA DA ALIENACAO DE BENS IMOVEIS DO DOMINIO DA UNIAO- DOMINIO PLENO, UTIL E DIRETO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.02.00', 'MUL.JUR. MORA ALIEN. DE OUTROS BENS IMOVEIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE ALIEN. DE OUTROS BENS IMOVEIS. MULTAS APLICADAS POR ATRASOS NOS RECOLHIMENTOS DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL OU PLENO DE IMOVEIS DA UNIAO, DE ACORDO COM O PREVISTO NOS ARTIGOS 25 A 27 DA MP NUM. 1647-14 DE 24 DE MARCO DE 1998.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.03.00', 'MULTAS E JUROS DE MORA DE PARCELAMENTO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE PARCELAMENTOS, APLICADAS POR ATRASOS NO RECOLHIMENTO DE DEBITOS PARA COM A UNIAO DE ACORDO COM O ARTIGO 61 DA LEI NUM. 9430, DE 27 DE DEZEMBRO DE 1996 E O PARAGRAFO QUARTO DO ART. 36 DA LEI NUM 9069, DE 29 DE JULHO DE 1995.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.04.00', 'MULTAS E JUROS DE MORA DE DIVIDENDOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE DIVIDENDOS DEVIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.05.00', 'MULTAS E JUROS DE MORA DE PARTICIPACOES', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE PARTICIPACOES DEVIDAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.06.00', 'MULT.JUROS MORA REC.DIR.ANTIDUMPING DIR.COMP', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS INCIDENTES SOBRE RECEITAS DOS DIREITOS "ANTIDUMPING" E DOS DIREITOS COMPENSATO- RIOS EM ATRASO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.07.00', 'MULT. JUROS MORA REC.DECORR. BENS APREENDIDOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS RECEITAS DECORRENTES DE BENS APREENDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.08.00', 'MULT.J.MORA DIV.AT. MULTAS INFR.A LEG. TRAB.', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES POR INFRACAO A LEGISLACAO TRABALHISTA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.09.00', 'MULT.J.MORA DIV.AT.MULT.PREV.LEGIS.MINERARIA', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE CREDITO DA FAZENDA PUBLICA, PELO NAO PAGAMENTO DOS CONTRIBUINTES NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA RECEITA PREVISTA NA LEGISTACAO MINERARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.10.00', 'MULTA MORA PELA CESSAO DE USO DE BENS UNIAO', 'REGISTRA O VALOR DA VPA DE MULTA DE MORA PELA CESSAO DE USO DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.11.00', 'JUROS MORA PELA CESSAO DE USO DE BENS UNIAO', 'REGISTRA O VALOR DA VPA DE JUROS DE MORA PELA CESSAO DE USO DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.12.00', 'MULTA INDEN.POSSE OU OCUP.ILICITA BENS UNIAO', 'REGISTRA O VALOR DA VPA DE MULTA DE MORA NA ARRECADACAO DA RECEITA DE INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.13.00', 'JUROS INDEN.POSSE OU OCUP.ILICITA BENS UNIAO', 'REGISTRA O VALOR DA VPA DE JUROS DE MORA NA ARRECADACAO DA RECEITA DE INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.14.00', 'MULTAS E JUROS DE MORA DIVIDA ATIVA - AUTO DE INFRACAO PREVIDENCIA COMPLEMENTAR', 'REGISTRA O VALOR DA VPA DECORRENTE DE MULTAS E JUROS DE MORA DA RECEITA DA DIVIDA ATIVA DO AUTO DE INFRACAO NO AMBITO DO REGIME DE PREVIDENCIA COMPLEMENTAR FECHADA.(PORTARIA SOF Nº 144 DE 27/10/10).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.15.00', 'MULTAS E JUROS - AUTO DE INFRACAO PREVIDENCIA COMPLEMENTAR', 'REGISTRA O VALOR DA VPA PROVENIENTE DE MULTAS E JUROS DE MORA DO AUTO DE INFRACAO NO AMBITO DO REGIME DE PREVIDENCIA COMPLEMENTAR FECHADA. (PORTARIA SOF Nº 144 DE 27/10/2010)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.16.00', 'MULT.J.MORA REC.SUSPENSAO DIR.PROPR.INTELEC', 'REGISTRA O VALOR DA VPA DECORRENTE DE MULTA E JUROS DE MORA DA VPA DECORRENTE DE MEDIDAS DE SUSPENSAO DE CONCESSOES DOS DIREITOS DE PROPRIEDADE INTELECTUAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.17.00', 'MULT.J.MORA RESSARC.DE ACOES REGRES.REL.TRAB.', 'REGISTRA A VPA DECORRENTE DE MULTA E JUROS DE MORA DO RESSARCIMENTO DE ACOES REGRESSIVAS ORIUNDAS DA RELACAO DE TRABALHO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.99.01', 'OUTRAS MULTAS E JUROS DE MORA DE OUTRAS RECEITAS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTRAS MULTAS DE CARATER PUNITIVO OU MORATO- RIO E DE JUROS DESTINADOS A INDENIZACAO PELO PAGAMENTO EM ATRASO DE OUTRAS RECEITAS NAO CLASSIFICADAS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.99.02', 'OUTRAS MULT.JUR.MORA DIV.ATIV.OUTR.RECEITAS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTRAS MULTAS E JUROS DE MORA DA DIVIDA ATIVA DE OUTRAS RECEITAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.01.01', 'MULTA ALIEN.BENS IMOVEIS DOM.UNIAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE MULTA DE MORA DA ALIENACAO DE BENS IMOVEIS DO DOMINIO DA UNIAO- DOMINIO PLENO, UTIL E DIRETO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.01.02', 'JUROS ALIEN.BENS IMOVEIS DOM.UNIAO', 'REGISTRA A A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE JUROS DE MORA DA ALIENACAO DE BENS IMOVEIS DO DOMINIO DA UNIAO- DOMINIO PLENO, UTIL E DIRETO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.02.00', 'MUL.JUR. MORA ALIEN. DE OUTROS BENS IMOVEIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE ALIEN. DE OUTROS BENS IMOVEIS. MULTAS APLICADAS POR ATRASOS NOS RECOLHIMENTOS DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL OU PLENO DE IMOVEIS DA UNIAO, DE ACORDO COM O PREVISTO NOS ARTIGOS 25 A 27 DA MP NUM. 1647-14 DE 24 DE MARCO DE 1998.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.03.00', 'MULTAS E JUROS DE MORA DE PARCELAMENTO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE PARCELAMENTOS, APLICADAS POR ATRASOS NO RECOLHIMENTO DE DEBITOS PARA COM A UNIAO DE ACORDO COM O ARTIGO 61 DA LEI NUM. 9430, DE 27 DE DEZEMBRO DE 1996 E O PARAGRAFO QUARTO DO ART. 36 DA LEI NUM 9069, DE 29 DE JULHO DE 1995.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.04.00', 'MULTAS E JUROS DE MORA DE DIVIDENDOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE DIVIDENDOS DEVIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.05.00', 'MULTAS E JUROS DE MORA DE PARTICIPACOES', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE PARTICIPACOES DEVIDAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.06.00', 'MULT.JUROS MORA REC.DIR.ANTIDUMPING DIR.COMP', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS INCIDENTES SOBRE RECEITAS DOS DIREITOS "ANTIDUMPING" E DOS DIREITOS COMPENSATO- RIOS EM ATRASO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.07.00', 'MULT. JUROS MORA REC.DECORR. BENS APREENDIDOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS RECEITAS DECORRENTES DE BENS APREENDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.08.00', 'MULT.J.MORA DIV.AT. MULTAS INFR.A LEG. TRAB.', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES POR INFRACAO A LEGISLACAO TRABALHISTA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.09.00', 'MULT.J.MORA DIV.AT.MULT.PREV.LEGIS.MINERARIA', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE CREDITO DA FAZENDA PUBLICA, PELO NAO PAGAMENTO DOS CONTRIBUINTES NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA RECEITA PREVISTA NA LEGISTACAO MINERARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.10.00', 'MULTA MORA PELA CESSAO DE USO DE BENS UNIAO', 'REGISTRA O VALOR DA VPA DE MULTA DE MORA PELA CESSAO DE USO DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.11.00', 'JUROS MORA PELA CESSAO DE USO DE BENS UNIAO', 'REGISTRA O VALOR DA VPA DE JUROS DE MORA PELA CESSAO DE USO DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.12.00', 'MULTA INDEN.POSSE OU OCUP.ILICITA BENS UNIAO', 'REGISTRA O VALOR DA VPA DE MULTA DE MORA NA ARRECADACAO DA RECEITA DE INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.13.00', 'JUROS INDEN.POSSE OU OCUP.ILICITA BENS UNIAO', 'REGISTRA O VALOR DA VPA DE JUROS DE MORA NA ARRECADACAO DA RECEITA DE INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.14.00', 'MULTAS E JUROS DE MORA DIVIDA ATIVA - AUTO DE INFRACAO PREVIDENCIA COMPLEMENTAR', 'REGISTRA O VALOR DA VPA DECORRENTE DE MULTAS E JUROS DE MORA DA RECEITA DA DIVIDA ATIVA DO AUTO DE INFRACAO NO AMBITO DO REGIME DE PREVIDENCIA COMPLEMENTAR FECHADA.(PORTARIA SOF Nº 144 DE 27/10/10).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.15.00', 'MULTAS E JUROS - AUTO DE INFRACAO PREVIDENCIA COMPLEMENTAR', 'REGISTRA O VALOR DA VPA PROVENIENTE DE MULTAS E JUROS DE MORA DO AUTO DE INFRACAO NO AMBITO DO REGIME DE PREVIDENCIA COMPLEMENTAR FECHADA. (PORTARIA SOF Nº 144 DE 27/10/2010)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.16.00', 'MULT.J.MORA REC.SUSPENSAO DIR.PROPR.INTELEC', 'REGISTRA O VALOR DA VPA DECORRENTE DE MULTA E JUROS DE MORA DA VPA DECORRENTE DE MEDIDAS DE SUSPENSAO DE CONCESSOES DOS DIREITOS DE PROPRIEDADE INTELECTUAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.17.00', 'MULT.J.MORA RESSARC.DE ACOES REGRES.REL.TRAB.', 'REGISTRA A VPA DECORRENTE DE MULTA E JUROS DE MORA DO RESSARCIMENTO DE ACOES REGRESSIVAS ORIUNDAS DA RELACAO DE TRABALHO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.99.01', 'OUTRAS MULTAS E JUROS DE MORA DE OUTRAS RECEITAS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTRAS MULTAS DE CARATER PUNITIVO OU MORATO- RIO E DE JUROS DESTINADOS A INDENIZACAO PELO PAGAMENTO EM ATRASO DE OUTRAS RECEITAS NAO CLASSIFICADAS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.99.02', 'OUTRAS MULT.JUR.MORA DIV.ATIV.OUTR.RECEITAS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTRAS MULTAS E JUROS DE MORA DA DIVIDA ATIVA DE OUTRAS RECEITAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.01.01', 'MULTA ALIEN.BENS IMOVEIS DOM.UNIAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE MULTA DE MORA DA ALIENACAO DE BENS IMOVEIS DO DOMINIO DA UNIAO- DOMINIO PLENO, UTIL E DIRETO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.01.02', 'JUROS ALIEN.BENS IMOVEIS DOM.UNIAO', 'REGISTRA A A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE JUROS DE MORA DA ALIENACAO DE BENS IMOVEIS DO DOMINIO DA UNIAO- DOMINIO PLENO, UTIL E DIRETO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.02.00', 'MUL.JUR. MORA ALIEN. DE OUTROS BENS IMOVEIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE ALIEN. DE OUTROS BENS IMOVEIS. MULTAS APLICADAS POR ATRASOS NOS RECOLHIMENTOS DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL OU PLENO DE IMOVEIS DA UNIAO, DE ACORDO COM O PREVISTO NOS ARTIGOS 25 A 27 DA MP NUM. 1647-14 DE 24 DE MARCO DE 1998.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.03.00', 'MULTAS E JUROS DE MORA DE PARCELAMENTO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE PARCELAMENTOS, APLICADAS POR ATRASOS NO RECOLHIMENTO DE DEBITOS PARA COM A UNIAO DE ACORDO COM O ARTIGO 61 DA LEI NUM. 9430, DE 27 DE DEZEMBRO DE 1996 E O PARAGRAFO QUARTO DO ART. 36 DA LEI NUM 9069, DE 29 DE JULHO DE 1995.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.04.00', 'MULTAS E JUROS DE MORA DE DIVIDENDOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE DIVIDENDOS DEVIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.05.00', 'MULTAS E JUROS DE MORA DE PARTICIPACOES', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE PARTICIPACOES DEVIDAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.06.00', 'MULT.JUROS MORA REC.DIR.ANTIDUMPING DIR.COMP', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS INCIDENTES SOBRE RECEITAS DOS DIREITOS "ANTIDUMPING" E DOS DIREITOS COMPENSATO- RIOS EM ATRASO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.07.00', 'MULT. JUROS MORA REC.DECORR. BENS APREENDIDOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS RECEITAS DECORRENTES DE BENS APREENDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.08.00', 'MULT.J.MORA DIV.AT. MULTAS INFR.A LEG. TRAB.', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES POR INFRACAO A LEGISLACAO TRABALHISTA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.09.00', 'MULT.J.MORA DIV.AT.MULT.PREV.LEGIS.MINERARIA', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE CREDITO DA FAZENDA PUBLICA, PELO NAO PAGAMENTO DOS CONTRIBUINTES NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA RECEITA PREVISTA NA LEGISTACAO MINERARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.10.00', 'MULTA MORA PELA CESSAO DE USO DE BENS UNIAO', 'REGISTRA O VALOR DA VPA DE MULTA DE MORA PELA CESSAO DE USO DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.11.00', 'JUROS MORA PELA CESSAO DE USO DE BENS UNIAO', 'REGISTRA O VALOR DA VPA DE JUROS DE MORA PELA CESSAO DE USO DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.12.00', 'MULTA INDEN.POSSE OU OCUP.ILICITA BENS UNIAO', 'REGISTRA O VALOR DA VPA DE MULTA DE MORA NA ARRECADACAO DA RECEITA DE INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.13.00', 'JUROS INDEN.POSSE OU OCUP.ILICITA BENS UNIAO', 'REGISTRA O VALOR DA VPA DE JUROS DE MORA NA ARRECADACAO DA RECEITA DE INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.14.00', 'MULTAS E JUROS DE MORA DIVIDA ATIVA - AUTO DE INFRACAO PREVIDENCIA COMPLEMENTAR', 'REGISTRA O VALOR DA VPA DECORRENTE DE MULTAS E JUROS DE MORA DA RECEITA DA DIVIDA ATIVA DO AUTO DE INFRACAO NO AMBITO DO REGIME DE PREVIDENCIA COMPLEMENTAR FECHADA.(PORTARIA SOF Nº 144 DE 27/10/10).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.15.00', 'MULTAS E JUROS - AUTO DE INFRACAO PREVIDENCIA COMPLEMENTAR', 'REGISTRA O VALOR DA VPA PROVENIENTE DE MULTAS E JUROS DE MORA DO AUTO DE INFRACAO NO AMBITO DO REGIME DE PREVIDENCIA COMPLEMENTAR FECHADA. (PORTARIA SOF Nº 144 DE 27/10/2010)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.16.00', 'MULT.J.MORA REC.SUSPENSAO DIR.PROPR.INTELEC', 'REGISTRA O VALOR DA VPA DECORRENTE DE MULTA E JUROS DE MORA DA VPA DECORRENTE DE MEDIDAS DE SUSPENSAO DE CONCESSOES DOS DIREITOS DE PROPRIEDADE INTELECTUAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.17.00', 'MULT.J.MORA RESSARC.DE ACOES REGRES.REL.TRAB.', 'REGISTRA A VPA DECORRENTE DE MULTA E JUROS DE MORA DO RESSARCIMENTO DE ACOES REGRESSIVAS ORIUNDAS DA RELACAO DE TRABALHO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.99.01', 'OUTRAS MULTAS E JUROS DE MORA DE OUTRAS RECEITAS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTRAS MULTAS DE CARATER PUNITIVO OU MORATORIO E DE JUROS DESTINADOS A INDENIZACAO PELO PAGAMENTO EM ATRASO DE OUTRAS RECEITAS NAO CLASSIFICADAS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.99.02', 'OUTRAS MULT.JUR.MORA DIV.ATIV.OUTR.RECEITAS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTRAS MULTAS E JUROS DE MORA DA DIVIDA ATIVA DE OUTRAS RECEITAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.01.01', 'MULTA ALIEN.BENS IMOVEIS DOM.UNIAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE MULTA DE MORA DA ALIENACAO DE BENS IMOVEIS DO DOMINIO DA UNIAO- DOMINIO PLENO, UTIL E DIRETO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.01.02', 'JUROS ALIEN.BENS IMOVEIS DOM.UNIAO', 'REGISTRA A A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE JUROS DE MORA DA ALIENACAO DE BENS IMOVEIS DO DOMINIO DA UNIAO- DOMINIO PLENO, UTIL E DIRETO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.02.00', 'MUL.JUR. MORA ALIEN. DE OUTROS BENS IMOVEIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE ALIEN. DE OUTROS BENS IMOVEIS. MULTAS APLICADAS POR ATRASOS NOS RECOLHIMENTOS DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL OU PLENO DE IMOVEIS DA UNIAO, DE ACORDO COM O PREVISTO NOS ARTIGOS 25 A 27 DA MP NUM. 1647-14 DE 24 DE MARCO DE 1998.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.03.00', 'MULTAS E JUROS DE MORA DE PARCELAMENTO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE PARCELAMENTOS, APLICADAS POR ATRASOS NO RECOLHIMENTO DE DEBITOS PARA COM A UNIAO DE ACORDO COM O ARTIGO 61 DA LEI NUM. 9430, DE 27 DE DEZEMBRO DE 1996 E O PARAGRAFO QUARTO DO ART. 36 DA LEI NUM 9069, DE 29 DE JULHO DE 1995.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.04.00', 'MULTAS E JUROS DE MORA DE DIVIDENDOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE DIVIDENDOS DEVIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.05.00', 'MULTAS E JUROS DE MORA DE PARTICIPACOES', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE PARTICIPACOES DEVIDAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.06.00', 'MULT.JUROS MORA REC.DIR.ANTIDUMPING DIR.COMP', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS INCIDENTES SOBRE RECEITAS DOS DIREITOS "ANTIDUMPING" E DOS DIREITOS COMPENSATORIOS EM ATRASO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.07.00', 'MULT. JUROS MORA REC.DECORR. BENS APREENDIDOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS RECEITAS DECORRENTES DE BENS APREENDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.08.00', 'MULT.J.MORA DIV.AT. MULTAS INFR.A LEG. TRAB.', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES POR INFRACAO A LEGISLACAO TRABALHISTA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.09.00', 'MULT.J.MORA DIV.AT.MULT.PREV.LEGIS.MINERARIA', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE CREDITO DA FAZENDA PUBLICA, PELO NAO PAGAMENTO DOS CONTRIBUINTES NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA RECEITA PREVISTA NA LEGISTACAO MINERARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.10.00', 'MULTA MORA PELA CESSAO DE USO DE BENS UNIAO', 'REGISTRA O VALOR DA VPA DE MULTA DE MORA PELA CESSAO DE USO DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.11.00', 'JUROS MORA PELA CESSAO DE USO DE BENS UNIAO', 'REGISTRA O VALOR DA VPA DE JUROS DE MORA PELA CESSAO DE USO DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.12.00', 'MULTA INDEN.POSSE OU OCUP.ILICITA BENS UNIAO', 'REGISTRA O VALOR DA VPA DE MULTA DE MORA NA ARRECADACAO DA RECEITA DE INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.13.00', 'JUROS INDEN.POSSE OU OCUP.ILICITA BENS UNIAO', 'REGISTRA O VALOR DA VPA DE JUROS DE MORA NA ARRECADACAO DA RECEITA DE INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.14.00', 'MULTAS E JUROS DE MORA DIVIDA ATIVA - AUTO DE INFRACAO PREVIDENCIA COMPLEMENTAR', 'REGISTRA O VALOR DA VPA DECORRENTE DE MULTAS E JUROS DE MORA DA RECEITA DA DIVIDA ATIVA DO AUTO DE INFRACAO NO AMBITO DO REGIME DE PREVIDENCIA COMPLEMENTAR FECHADA.(PORTARIA SOF Nº 144 DE 27/10/10).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.15.00', 'MULTAS E JUROS - AUTO DE INFRACAO PREVIDENCIA COMPLEMENTAR', 'REGISTRA O VALOR DA VPA PROVENIENTE DE MULTAS E JUROS DE MORA DO AUTO DE INFRACAO NO AMBITO DO REGIME DE PREVIDENCIA COMPLEMENTAR FECHADA. (PORTARIA SOF Nº 144 DE 27/10/2010)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.16.00', 'MULT.J.MORA REC.SUSPENSAO DIR.PROPR.INTELEC', 'REGISTRA O VALOR DA VPA DECORRENTE DE MULTA E JUROS DE MORA DA VPA DECORRENTE DE MEDIDAS DE SUSPENSAO DE CONCESSOES DOS DIREITOS DE PROPRIEDADE INTELECTUAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.17.00', 'MULT.J.MORA RESSARC.DE ACOES REGRES.REL.TRAB.', 'REGISTRA A VPA DECORRENTE DE MULTA E JUROS DE MORA DO RESSARCIMENTO DE ACOES REGRESSIVAS ORIUNDAS DA RELACAO DE TRABALHO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.99.01', 'OUTRAS MULTAS E JUROS DE MORA DE OUTRAS RECEITAS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTRAS MULTAS DE CARATER PUNITIVO OU MORATORIO E DE JUROS DESTINADOS A INDENIZACAO PELO PAGAMENTO EM ATRASO DE OUTRAS RECEITAS NAO CLASSIFICADAS NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.99.02', 'OUTRAS MULT.JUR.MORA DIV.ATIV.OUTR.RECEITAS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTRAS MULTAS E JUROS DE MORA DA DIVIDA ATIVA DE OUTRAS RECEITAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.1.01.00', 'VARIACOES MONETARIAS DE EMPRESTIMOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AOS EMPRESTIMOS INTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.1.02.00', 'VARIACOES CAMBIAIS DE EMPRESTIMOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS EMPRESTIMOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.2.01.00', 'VARIACOES MONETARIAS DE EMPRESTIMOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AOS EMPRESTIMOS INTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.2.02.00', 'VARIACOES CAMBIAIS DE EMPRESTIMOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS EMPRESTIMOS INTERNOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.4.01.00', 'VARIACOES MONETARIAS DE EMPRESTIMOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AOS EMPRESTIMOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.4.02.00', 'VARIACOES CAMBIAIS DE EMPRESTIMOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS EMPRESTIMOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.5.01.00', 'VARIACOES MONETARIAS DE EMPRESTIMOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AOS EMPRESTIMOS INTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.5.02.00', 'VARIACOES CAMBIAIS DE EMPRESTIMOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS EMPRESTIMOS INTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.2.1.01.00', 'VARIACOES MONETARIAS DE EMPRESTIMOS EXTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AOS EMPRESTIMOS EXTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.2.1.02.00', 'VARIACOES CAMBIAIS DE EMPRESTIMOS EXTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS EMPRESTIMOS EXTERNOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.1.01.00', 'VARIACOES MONETARIAS DE FINANCIAMENTOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AOS FINANCIAMENTOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.1.02.00', 'VARIACOES CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS INTERNOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.2.01.00', 'VARIACOES MONETARIAS DE FINANCIAMENTOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AOS FINANCIAMENTOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.2.02.00', 'VARIACOES CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS INTERNOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.4.01.00', 'VARIACOES MONETARIAS DE FINANCIAMENTOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AOS FINANCIAMENTOS INTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.4.02.00', 'VARIACOES CAMBIAIS DE FINANCIAMENTOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS INTERNOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.5.01.00', 'VARIACOES MONETARIAS DE FINANCIAMENTOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AOS FINANCIAMENTOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.5.02.00', 'VARIACOES CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS INTERNOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.4.1.01.00', 'VARIACOES MONETARIAS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AOS FINANCIAMENTOS EXTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.4.1.02.00', 'VARIACOES CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS EXTERNOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.1.01.00', 'OUTRAS VARIACOES MONETARIAS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.1.02.00', 'OUTRAS VARIACOES CAMBIAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.2.01.00', 'OUTRAS VARIACOES MONETARIAS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.2.02.00', 'OUTRAS VARIACOES CAMBIAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.4.01.00', 'OUTRAS VARIACOES MONETARIAS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.4.02.00', 'OUTRAS VARIACOES CAMBIAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.5.01.00', 'OUTRAS VARIACOES MONETARIAS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.5.02.00', 'OUTRAS VARIACOES CAMBIAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.4.0.1.00.00', 'DESCONTOS FINANCEIROS OBTIDOS - CONSOLIDACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE DESCONTOS FINANCEIROS OBTIDOS EM VIRTUDE DE LIQUIDACAO ANTECIPADA DE OBRIGACOES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.4.0.2.00.00', 'DESCONTOS FINANCEIROS OBTIDOS - INTRA OFSS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE DESCONTOS FINANCEIROS OBTIDOS EM VIRTUDE DE LIQUIDACAO ANTECIPADA DE OBRIGACOES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.4.0.4.00.00', 'DESCONTOS FINANCEIROS OBTIDOS - INTER OFSS - ESTADO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE DESCONTOS FINANCEIROS OBTIDOS EM VIRTUDE DE LIQUIDACAO ANTECIPADA DE OBRIGACOES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.4.0.5.00.00', 'DESCONTOS FINANCEIROS OBTIDOS - INTER OFSS - MUNICIPIO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE DESCONTOS FINANCEIROS OBTIDOS EM VIRTUDE DE LIQUIDACAO ANTECIPADA DE OBRIGACOES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.5.1.1.00.00', 'REMUNERACAO DE DEPOSITOS BANCARIOS - CONSOLIDACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DA REMUNERACAO DOS DEPOSITOS BANCARIOS DO ENTE EXISTENTES NO AGENTE FINANCEIRO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.5.2.1.00.00', 'REMUNERACAO DE APLICACOES FINANCEIRAS - CONSOLIDACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA REMUNERACAO DE DEPOSITOS BANCARIOS, RECURSOS ORIUNDOS DE APLICACOES DE ENTIDADES DA ADMINISTRACAO PUBLICA NO MERCADO FINANCEIRO, AUTORIZADAS POR LEI, EM CADERNETA DE POUPANCA, FUNDO DE INVESTIMENTO, CONTAS REMUNERADAS E OUTROS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.9.0.1.00.00', 'OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NOS SUBGRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.9.0.2.00.00', 'OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS - INTRA OFSS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NOS SUBGRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.9.0.4.00.00', 'OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NOS SUBGRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.9.0.5.00.00', 'OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NOS SUBGRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.01.00', 'COTA RECEBIDA', 'REGISTRA O VALOR DOS RECURSOS RECEBIDOS PELA ADMINISTRACAO DIRETA DECORRENTES DA PROGRAMACAO FINANCEIRA CORRESPONDENTE AO ORCAMENTO ANUAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.02.00', 'REPASSE RECEBIDO', 'REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA, CORRESPONDENTES AO ORCAMENTO ANUAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.03.00', 'SUB-REPASSE RECEBIDO', 'REGISTRA O VALOR DOS SUB-REPASSES RECEBIDOS NO EXERCICIO, DECORRENTES DE TRANSFERENCIAS ENTRE UGS DO MESMO ORGAO, CORRESPONDENTE AO ORCAMENTO ANUAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.04.00', 'RECURSOS ARRECADADOS - RECEBIDOS', 'REGISTRA O VALOR RECEBIDO DE OUTRA UG REFERENTE AO RECURSOS QUE FORAM ARRECADADOS (CLASSIFICADOS COMO RECEITA) PARA PAGAMENTO DE DESPESAS NA UG RECEBEDORA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.05.02', 'REPASSE DIFERIDO - BAIXA', 'REGISTRA O VALOR DOS RECURSOS DE REPASSE DIFERIDO DECORRENTES DO PROCESSO DE BAIXA DE RECURSOS DIFERIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.05.03', 'SUBREPASSE DIFERIDO - BAIXA', 'REGISTRA O VALOR DOS RECURSOS DE SUBREPASSE DIFERIDO DECORRENTES DO PROCESSO DE BAIXA DE RECURSOS DIFERIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.06.01', 'COTA DIFERIDA - INSCRICAO', 'REGISTRA O VALOR DA COTA DIFERIDA NO PROCESSO DE INSCRICAO DOS RECURSOS DIFERIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.06.02', 'REPASSE DIFERIDO - INSCRICAO', 'REGISTRA O VALOR DOS RECURSOS DE REPASSE DIFERIDO DECORRENTES DO PROCESSO DE INSCRICAO DE RECURSOS DIFERIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.06.03', 'SUBREPASSE DIFERIDO - INSCRICAO', 'REGISTRA O VALOR DOS RECURSOS DE SUBREPASSE DIFERIDO DECORRENTES DO PROCESSO DE INSCRICAO DE RECURSOS DIFERIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.07.01', 'CORRESPONDENCIA DE DEBITO -DESINCORPORACAO DE VARIACAO PATRIMONIAL AUMENTATIVA', 'REGISTRA A APROPRIACAO DAS VARIACOES PATRIMONIAIS AUMENTATIVAS DESINCORPORADAS PARA TRANSFERENCIA A OUTRA UG DE MESMA GESTAO, PARA APURACAO DE CUSTO E RESULTADO DE GESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.07.02', 'CORRESPONDENCIA DE DEBITO -INCORPORACAO DE VARIACAO PATRIMONIAL DIMINUTIVA', 'REGISTRA A APROPRIACAO DA INCORPORACAO DE VARIACOES PATRIMONIAIS DIMINUTIVAS TRANSFERIDAS DE OUTRA UG DA MESMA GESTAO PARA APURACAO DE CUSTO E RESULTADO DE GESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.07.03', 'CORRESPONDENCIA DE DEBITO - SALDOS FINANC.', 'REGISTRA A APROPRIACAO DA TRANSFERENCIA DE DEBITOS INTERNOS ENTRE UG DE MESMA GESTAO REFERENTES A CONTAS COM SALDOS FINANCEIROS EM ROTINAS CONTABEIS ORCAMENTARIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.08.01', 'REPASSE P/ COBERTURA DE INSUFICIENCIAS FINANCEIRAS - PLANO FINANCEIRO', 'REGISTRA OS RECURSOS ORCAMENTARIOS EFETIVAMENTE UTILIZADOS PARA COBERTURA DE INSUFICIENCIAS FINANCEIRAS ENTRE AS RECEITAS E DESPESAS PREVIDENCIARIAS, NO EXERCICIO DE REFERENCIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.08.02', 'REPASSE PREVIDENCIARIO P/ FORMACAO DE RESERVA - PLANO FINANCEIRO', 'REPRESENTA O MONTANTE DOS RECURSOS RECEBIDOS DO PROPRIO ENTE PARA FORMACAO DE RESERVA ESPONTANEA PARA FUTUROS PAGAMENTOS DE BENEFICIOS DO PLANO FINANCEIRO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.08.99', 'OUTROS APORTES PARA O RPPS - PLANO FINANCEIRO', 'REGISTRA O SOMATORIO DOS RECEBIMENTOS DE EVENTUAIS APORTES DE RECURSOS PARA O REGIME PROPRIO DE PREVIDENCIA DO SERVIDOR - RPPS, PARA OUTRAS NECESSIDADES FINANCEIRAS QUE NAO A COBERTURA DE INSUFICIENCIAS FINANCEIRAS E FORMACAO DE RESERVA. .', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.09.01', 'REPASSE PARA COBERTURA DE DEFICIT FINANCEIRO- PLANO PREVIDENCIARIO', 'REGISTRA O MONTANTE DOS RECURSOS RECEBIDOS DO PROPRIO ENTE, NECESSARIOS AO EQUILIBRIO FINANCEIRO DO PLANO PREVIDENCIARIO, OU SEJA, AA COBERTURA DE DEFICIT ENTRE AS RECEITAS E AS DESPESAS PREVIDENCIARIAS, REFERENTES AO EXERCICIO ATUAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.09.02', 'REPASSE PARA COBERTURA DE DEFICIT ATUARIAL - PLANO PREVIDENCIARIO', 'REGISTRA O MONTANTE DOS RECURSOS RECEBIDOS DO PROPRIO ENTE, NECESSARIOS AO EQUILIBRIO FINANCEIRO DO PLANO PREVIDENCIARIO, OU SEJA, AA COBERTURA DE DEFICIT ENTRE AS RECEITAS E AS DESPESAS PREVIDENCIARIAS, REFERENTES AO EXERCICIO ATUAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.09.99', 'OUTROS APORTES PARA O RPPS - PLANO PREVIDENCIARIO', 'REGISTRA OUTROS APORTES FINANCEIROS PARA O REGIME PROPRIO DE PREVIDENCIA DO SERVIDOR PUBLICO - RPPS, TAIS COMO CAPITALIZACOES DO REGIME.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.01.01', 'TRANSFERENCIAS RECEBIDAS', 'REGISTRA O VALOR DA TRANSFERENCIA DE OTR`S LIBERADAS PELAS SETORIAIS DE PROGRAMACAO FINANCEIRA DE CADA ORGAO PARA SUAS SUBORDINADAS, INDEPENDENTES DE EXECUCAO ORCAMENTARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.01.02', 'RECEBIMENTO DE TRANSFERENCIAS CONCEDIDAS', 'REGISTRA O VALOR DOS RECEBIMENTOS REFERENTES A RESTOS A PAGAR, QUE FORAM DEVOLVIDOS PELAS UG BENEFICIARIAS, QUE NAO FORAM UTILIZADOS OU UTILIZADOS PARCIALMENTE, SEM O RESTABELECIMENTO DA OBRIGACAO CORRESPONDENTE AO LIMITE DE RP .', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.02.01', 'REGISTRO DE RESTITUICAO DE RECEITAS FEDERAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA QUE PERMITE IDENTIFICAR OS REGISTROS DE RESTITUICAO DE RECEITAS FEDERAIS EFETIVADOS PELAS DELEGACIAS DA RECEITA FEDERAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.02.02', 'CLASSIFICACAO DA RESTITUICAO DE RECEITAS FEDERAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA QUE PERMITE IDENTIFICAR A CLASSIFICACAO DE RESTITUICAO DE RECEITAS, REFERENTE A FITA DE ARRECADACAO DECENDIAL DE RECEITA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.03.00', 'TRANSF RECEBIDA P/ PAGTO RESTITUICOES RECEITAS FEDERAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVAS A RECEBIMENTO DE RECURSOS EXTRA-ORCAMENTARIOS PARA RESTITUICOES DE RECEITAS FEDERAIS PELAS UNIDADES GESTORAS DA SECRETARIA DA RECEITA FEDERAL', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.04.00', 'RESTITUICOES DE RECEITAS FEDERAIS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVAS PROVENIENTES DE RECEBIMENTOS DE RECURSOS EXTRA-ORCAMENTARIOS PARA RESTITUICOES DE RECEITAS FEDERAIS PELAS UNIDADES GESTORAS RESPONSAVEIS PELO RECOLHIMENTO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.05.01', 'TRANSFERENCIAS RECEBIDAS ARREC/TERC. INSS', 'REGISTRA O VALOR REFERENTE AS TRANSFERENCIAS RECEBIDAS PELO INSS REFERENTES AS ARRECADACOES DE RECEITAS PROPRIAS E VALORES DE TERCEIROS POR MEIO DE GPS REDE BANCARIA E INTRA-SIAFI.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.05.02', 'TRANSF.RECEBIDA RECURSOS PREVIDENC.ARRECADADOS', 'REGISTRA O VALOR REFERENTE AOS RECURSOS PREVIDENCIARIOS ARRECADADOS PELO INSS POR MEIO DAS GPS ELETRONICA E DA REDE BANCARIA, CENTRALIZADOS NO TESOURO NACIONAL, SUBCONTA DA CONTA UNICA INSS, PARA POSTERIOR REPASSE POR MEIO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.06.01', 'TRANSFERENCIAS RECEBIDAS ENTRE UG/ORGAO - NO EXERCICIO', 'REGISTRA A TRANSFERENCIA DE RECURSOS ENTRE UG DE MESMO ORGAO OU DE ORGAOS DIFERENTES QUE NAO ESTEJA RELACIONADA A EXECUCAO ORCAMENTARIA RECEBIDAS NO EXERCICIO CORRENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.06.02', 'TRANSFERENCIAS RECEBIDAS ENTRE UG/ORGAO - INSCRICAO DIFERIDO', 'REGISTRA A TRANSFERENCIA DE RECURSOS ENTRE UG DE MESMO ORGAO OU DE ORGAOS DIFERENTES QUE NAO ESTEJA RELACIONADA A EXECUCAO ORCAMENTARIA RECEBIDAS REFERENTE A INSCRICAO DE RECURSOS DIFERIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.06.03', 'TRANSFERENCIAS RECEBIDAS ENTRE UG/ORGAO -BAIXA DE DIFERIDO', 'REGISTRA A TRANSFERENCIA DE RECURSOS ENTRE UG DE MESMO ORGAO OU DE ORGAOS DIFERENTES QUE NAO ESTEJA RELACIONADA A EXECUCAO ORCAMENTARIA RECEBIDAS REFERENTE A BAIXA DA INSCRICAO DOS RECURSOS DIFERIDOS PELO PROCESSO DE ENCERRAMENTO DO EXERCICIO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.07.00', 'MOVIMENTO DE FUNDOS A DEBITO - CORRESPONDENCIA DE DEBITOS - SALDOS NAO FIN.', 'REGISTRA A APROPRIACAO DA TRANSFERENCIA DE DEBITOS INTERNOS ENTRE UG DE MESMA GESTAO REFERENTES A CONTAS DE SALDOS NAO FINANCEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.08.00', 'MOVIMENTO DE FUNDOS A DEBITO - CORRESPONDENCIA DE DEBITOS - SALDOS FINANC.', 'REGISTRA A APROPRIACAO DA TRANSFERENCIA DE CREDITOS INTERNOS ENTRE ORGAOS CORREPONDENTES A SALDOS FINANCEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.09.01', 'MOVIMENTO DE FUNDOS A DEBITO - PROPRIOS - INCORP/DESINCORP. DE SALDOS NAO FINANCEIROS', 'REGISTRA O VALOR DE SALDOS PATRIMONIAIS DEVEDORES INCORPORADOS E CREDORES DESINCORPORADOS POR INTEGRACAO,TRANSFERENCIA,FUSAO,CISAO OU MUDANCA DA MODALIDADE USO PARCIAL PARA TOTAL DE ORGAO OU UNIDADE GESTORA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.09.02', 'MOVIMENTO DE FUNDOS A DEBITO - PROPRIOS - INCORP./DESINCORP. SALDO FINANC./DISP./LIMITE', 'REGISTRA O VALOR DOS SALDOS FINANCEIROS DEVEDORES INCORPORADOS, E CREDORES DESINCORPORADOS, POR INTEGRACAO, TRANSFERENCIA, FUSAO, CISAO OU MUDANCA DA MODALIDADE DE USO PARCIAL PARA TOTAL, RELATIVOS AO DISPONIVEL E AO LIMITE DE PESSOAL, DE ORGAO OU UNIDADE GESTORA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.09.03', 'MOVIMENTO DE FUNDOS A DEBITO - PROPRIOS - INCORP./DESINCORP. DEMAIS SALDOS FINANCEIROS', 'REGISTRA O VALOR DE SALDOS FINANCEIROS DEVEDORES INCORPORADOS, E CREDORES DESINCORPORADOS, POR INTEGRACAO, TRANSFERENCIA, FUSAO, CISAO OU MUDANCA DA MODALIDADE DE USO PARCIAL PARA TOTAL, COM EXCECAO OS DO DISPONIVEL E OS DO LIMITE DE PESSOAL, DE ORGAO OU UNIDADE GESTORA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.09.04', 'MOVIMENTO DE FUNDOS A DEBITO - PROPRIOS - APURACAO RESULTADO INC/DESINC. SALDO FINANC.', 'REGISTRA A APURACAO DO RESULTADO FINANCEIRO, QUANDO DEVEDOR, PELO INCORPORACAO DE SALDOS CREDORES OU DESINCORPORACAO DE SALDOS DEVEDORES, EM FUNCAO DA TRANSFERENCIA, INTEGRACAO, FUSAO E CISAO DE SALDOS CONTABEIS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.10.01', 'OUTROS MOVIMENTOS DE FUNDOS A DEBITO-S.FIN.', 'REGISTRA O VALOR DA TRANSFERENCIA DE AJUSTES FINANCEIROS COM SALDO DEVEDOR OU CREDOR ENTRE UG DE EMPRESAS INTEGRANTES DO SIAFI E OUTROS MOVIMENTOS A DEDITO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.10.02', 'OUTROS MOVIMENTOS DE FUNDOS A DEBITO-S.PATR.', 'REGISTRA O VALOR DA TRANSFERENCIA DE AJUSTES PATRIMONIAIS COM SALDO DEVEDOR OU CREDOR ENTRE UG DE EMPRESAS INTEGRANTES DO SIAFI E OUTROS MOVIMENTOS A DEBITO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.11.00', 'TRANSFERENCIAS RECEBIDAS DE BENS IMOVEIS', 'REGISTRA O VALOR DAS TRANSFERENCIAS DE BENS IMOVEIS ENTRE UNIDADES DO MESMO ORGAO .', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.12.00', 'DOACOES RECEBIDAS DE BENS IMOVEIS', 'REGISTRA O VALOR DAS TRANSFERENCIAS DE BENS IMOVEIS ENTRE UNIDADES ENTRE UG DE ORGAOS DIFERENTES', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.13.01', 'TRANFERENCIAS RECEBIDAS DE BENS MOVEIS DE UNIDADE LOCALIZADA NO PAIS', 'REGISTRA O VALOR DOS BENS MOVEIS RECEBIDOS DE UNIDADE LOCALIZADA NO PAIS POR OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DO MESMO ORGAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.13.02', 'TRANFERENCIAS RECEBIDAS DE BENS MOVEIS DE UNIDADE LOCALIZADA NO EXTERIOR', 'REGISTRA O VALOR DOS BENS MOVEIS RECEBIDOS DE UNIDADE LOCALIZADA NO EXTERIOR POR OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DO MESMO ORGAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.14.01', 'DOACOES RECEBIDAS DE BENS MOVEIS DE UNIDADE LOCALIZADA NO PAIS', 'REGISTRA O VALOR DOS BENS MOVEIS RECEBIDOS DE UNIDADE LOCALIZADA NO PAIS POR OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DE ORGAOS DIFERENTES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.14.02', 'DOACOES RECEBIDAS DE BENS MOVEIS DE UNIDADE LOCALIZADA NO EXTERIOR', 'REGISTRA O VALOR DOS BENS MOVEIS RECEBIDOS DE UNIDADE LOCALIZADA NO EXTERIOR POR OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DE ORGAOS DIFERENTES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.15.00', 'TRANSFERENCIAS RECEBIDAS DE TITULOS E VALORES', 'REGISTRA O TOTAL DOS TITULOS E VALORES EM CIRCULACAO RECEBIDOS POR UNIDADE DECORRENTE DE TRANSFERENCIA DE OUTRA UNIDADE DE MESMA GESTAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.16.00', 'TRANSFERENCIAS RECEBIDAS DE TITULOS DA DIVIDA ATIVA', 'REGISTRA O RECEBIMENTO DE TITULOS DA DIVIDA ATIVA DE UMA UG PARA A PGFN OU ORGAO EQUIVALENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.3.2.00.00', 'TRANSFERENCIAS RECEBIDAS PARA COBERTURA DO DEFICIT ATUARIAL DO RPPS POR APORTE PERIODICO - INTRA OFSS', 'COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS PARA APORTES PERIODICOS DESTINADOS A COBERTURA DO DEFICIT ATUARIAL DO REGIME PROPRIO DE PREVIDENCIA SOCIAL - RPPS, CONFORME PLANO DE AMORTIZAÇÃO ESTABELECIDO EM LEI DO RESPECTIVO ENTE FEDERATIVO, EXCETO AS DECORRENTES DE ALIQUOTA DE CONTRIBUICAO SUPLEMENTAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.4.01.01', 'TRANSFERENCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS DOS ESTADOS, DF E SUAS ENTIDADES PARA CONVENIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS CONSTITUCIONAIS E LEGAIS DOS ESTADOS, DISTRITO FEDERAL E SUAS ENTIDADES PARA CONVENIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.4.01.99', 'OUTRAS TRANSFERENCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS DOS ESTADOS E DF', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERENCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS DOS ESTADOS E DISTRITO FEDERAL A UNIAO, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.4.01.01', 'TRANSFERENCIAS VOLUNTARIAS DOS ESTADOS, DF E SUAS ENTIDADES PARA CONVENIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS VOLUNTARIAS DOS ESTADOS, DISTRITO FEDERAL E SUAS ENTIDADES PARA CONVENIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.4.01.99', 'OUTRAS TRANSFERENCIAS VOLUNTARIAS DOS ESTADOS E DF', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERENCIAS VOLUNTARIAS DOS ESTADOS E DISTRITO FEDERAL A UNIAO, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.5.01.01', 'TRANSFERENCIAS VOLUNTARIAS DOS MUNICIPIOS E SUAS ENTIDADES PARA CONVENIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS VOLUNTARIAS DOS MUNICIPIOS E SUAS ENTIDADES PARA CONVENIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.5.01.99', 'OUTRAS TRANSFERENCIAS VOLUNTARIAS DOS MUNICIPIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERENCIAS VOLUNTARIAS DOS MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.1.1.01.00', 'TRANSFERENCIA DAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS PARA CONVENIOS', 'REGISTRA O VALOR TOTAL DOS RECURSOS ORIUNDOS DE CONVENIOS FIRMADOS, COM OU SEM CONTRAPRESTACOES DE SERVICOS, COM INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS, PARA PARA REALIZACAO DE OBJETIVOS DE INTERESSE COMUM DOS PARTICIPES DESTINADOS A CUSTEAR VARIACOES PATRIMONIAIS DIMINUTIVAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.1.1.02.00', 'TRANSFERENCIA DAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS PARA COMBATE A FOME', 'REGISTRA O VALOR TOTAL DOS RECURSOS RECEBIDOS ATRAVES DE TRANSFERENCIAS DE INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS PARA O FUNDO DE COMBATE E ERRADICACAO DA POBREZA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.1.1.99.00', 'OUTRAS TRANSFERENCIAS DAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS', 'REGISTRA OUTRAS TRANSFERENCIAS DE INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.2.1.01.00', 'TRANSFERENCIA DAS INSTITUICOES PRIVADAS COM FINS LUCRATIVOS PARA CONVENIOS', 'REGISTRA O VALOR TOTAL DOS RECURSOS ORIUNDOS DE CONVENIOS FIRMADOS, COM OU SEM CONTRAPRESTACOES DE SERVICOS, COM INSTITUICOES PRIVADAS COM FINS LUCRATIVOS, PARA PARA REALIZACAO DE OBJETIVOS DE INTERESSE COMUM DOS PARTICIPES DESTINADOS A CUSTEAR VARIACOES PATRIMONIAIS DIMINUTIVAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.2.1.02.00', 'TRANSFERENCIA DAS INSTITUICOES PRIVADAS COM FINS LUCRATIVOS PARA COMBATE A FOME', 'REGISTRA O VALOR TOTAL DOS RECURSOS RECEBIDOS ATRAVES DE TRANSFERENCIAS DE INSTITUICOES PRIVADAS COM FINS LUCRATIVOS PARA O FUNDO DE COMBATE E ERRADICACAO DA POBREZA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.2.1.99.00', 'OUTRAS TRANSFERENCIAS DAS INSTITUICOES PRIVADAS COM FINS LUCRATIVOS', 'REGISTRA OUTRAS TRANSFERENCIAS DE INSTITUICOES PRIVADAS COM FINS LUCRATIVOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.4.0.1.00.00', 'TRANSFERENCIAS DAS INSTITUICOES MULTIGOVERNAMENTAIS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DAS INSTITUICOES MULTIGOVERNAMENTAIS, DAS QUAIS O ENTE RECEBEDOR NAO PARTICIPE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.5.0.1.00.00', 'TRANSFERENCIAS DE CONSORCIOS PUBLICOS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DE CONSORCIOS PUBLICOS, DOS QUAIS O ENTE RECEBEDOR PARTICIPE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.6.0.1.01.00', 'TRANSFERENCIA DO EXTERIOR PARA O COMBATE A FOME', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DE VALORES RECEBIDOS DO EXTERIOR PARA O FUNDO DE COMBATE A FOME.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.6.0.1.99.00', 'OUTRAS TRANSFERENCIAS DO EXTERIOR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERENCIAS DE VALORES RECEBIDOS DO EXTERIOR', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.8.0.1.01.00', 'TRANSFERENCIAS DE PESSOAS FISICAS PARA COMBATE A FOME', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DE VALORES RECEBIDOS DE PESSOAS FISICAS PARA O FUNDO DE COMBATE A FOME.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.8.0.1.99.00', 'OUTRAS TRANSFERENCIAS DE PESSOAS FISICAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERENCIAS DE VALORES RECEBIDOS DE PESSOAS FISICAS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.00.00', 'REAVALIACAO DE IMOBILIZADO - CONSOLIDACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS DO ATIVO IMOBILIZADO, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.2.1.00.00', 'REAVALIACAO DE INTANGIVEIS -CONSOLIDACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ATIVOS INTANGIVEIS, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.9.1.00.00', 'REAVALIACAO DE OUTROS ATIVOS - CONSOLIDACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OUTROS ATIVOS, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.1.1.00.00', 'GANHOS COM ALIENACAO DE INVESTIMENTOS - CONSOLIDACAO', 'REGISTRA O GANHO COM ALIENACAO DE INVESTIMENTOS, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.00.00', 'GANHOS COM ALIENACAO DE IMOBILIZADO - CONSOLIDACAO', 'REGISTRA O GANHO COM ALIENACAO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.3.1.00.00', 'GANHOS COM ALIENACAO DE INTANGIVEIS - CONSOLIDACAO', 'REGISTRA O GANHO COM ALIENACAO DE ATIVOS INTANGIVEIS, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.1.1.00.00', 'GANHOS COM INCORPORACAO DE ATIVOS POR DESCOBERTAS - CONSOLIDACAO', 'REGISTRA OS GANHOS COM A INCORPORACAO DE NOVOS ATIVOS DESCOBERTOS, COMO POR EXEMPLO, DESCOBERTA DE JAZIDAS DE RECURSOS NATURAIS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.2.1.00.00', 'GANHOS COM INCORPORACAO DE ATIVOS POR NASCIMENTOS - CONSOLIDACAO', 'REGISTRA OS GANHOS COM A INCORPORACAO DE SEMOVENTES NASCIDOS, COMO POR EXEMPLO, NASCIMENTO DE BOVINOS E AVES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.3.1.00.00', 'GANHOS COM INCORPORACAO DE VALORES APREENDIDOS - CONSOLIDACAO', 'REGISTRA OS GANHOS COM A INCORPORACAO DE VALORES APREENDIDOS, COMO POR EXEMPLO, OS VALORES APREENDIDOS ASSOCIADOS AO TRAFICO ILICITO DE ENTORPENCENTES E DROGAS AFINS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.9.1.00.00', 'OUTROS GANHOS COM INCORPORACAO DE ATIVO - CONSOLIDACAO', 'REGISTRA A CONTRAPARTIDA DA INCORPORACAO DE OUTROS NOVOS ATIVOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.1.01.00', 'VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR', 'REGISTRA OS VALORES REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVAS DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.1.99.00', '(-) DEDUCOES DA VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR', 'REGISTRAS OS VALORES REFERENTES AS DEDUCOES DAS VARIACAO PATRIMONIAL AUMENTATIVA DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.2.01.00', 'VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR', 'REGISTRA OS VALORES REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVAS DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.2.99.00', '(-) DEDUCOES DA VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR', 'REGISTRAS OS VALORES REFERENTES AS DEDUCOES DAS VARIACAO PATRIMONIAL AUMENTATIVAS DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.4.01.00', 'VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR', 'REGISTRA OS VALORES REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVAS DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.4.99.00', '(-) DEDUCOES DA VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR', 'REGISTRAS OS VALORES REFERENTES AS DEDUCOES DAS VARIACAO PATRIMONIAL AUMENTATIVAS DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.5.01.00', 'VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR', 'REGISTRA OS VALORES REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVAS DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.5.99.00', '(-) DEDUCOES DA VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR', 'REGISTRAS OS VALORES REFERENTES AS DEDUCOES DAS VARIACAO PATRIMONIAL AUMENTATIVAS DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS', 'D', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.1.1.00.00', 'RESULTADO POSITIVO DE EQUIVALENCIA PATRIMONIAL - CONSOLIDACAO', 'REGISTRA A APROPRIACAO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.1.2.00.00', 'RESULTADO POSITIVO DE EQUIVALENCIA PATRIMONIAL - INTRA OFSS', 'REGISTRA A APROPRIACAO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.1.4.00.00', 'RESULTADO POSITIVO DE EQUIVALENCIA PATRIMONIAL - INTER OFSS - ESTADO', 'REGISTRA A APROPRIACAO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.1.5.00.00', 'RESULTADO POSITIVO DE EQUIVALENCIA PATRIMONIAL - INTER OFSS - MUNICIPIO', 'REGISTRA A APROPRIACAO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.2.1.00.00', 'DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - CONSOLIDACAO', 'REGISTRA AS VARIACOES AUMENTATIVAS ORIUNDAS DE LUCROS APURADOS EM OUTROS INVESTIMENTOS NAO AVALIADOS PELO METODO DA EQUIVALENCIA PATRIMONIAL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.2.2.00.00', 'DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - INTRA OFSS', 'REGISTRA AS VARIACOES AUMENTATIVAS ORIUNDAS DE LUCROS APURADOS EM OUTROS INVESTIMENTOS NAO AVALIADOS PELO METODO DA EQUIVALENCIA PATRIMONIAL.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.2.4.00.00', 'DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES AUMENTATIVAS ORIUNDAS DE LUCROS APURADOS EM OUTROS INVESTIMENTOS NAO AVALIADOS PELO METODO DA EQUIVALENCIA PATRIMONIAL.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.2.5.00.00', 'DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES AUMENTATIVAS ORIUNDAS DE LUCROS APURADOS EM OUTROS INVESTIMENTOS NAO AVALIADOS PELO METODO DA EQUIVALENCIA PATRIMONIAL.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.01.01', 'VPA COM OPERACOES COM TITULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES DA AUTORIDADE MONETARIA COM TITULOS .', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.01.02', 'VPA COM OPERACOES NA AREA EXTERNA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES NA AREA EXTERNA REALIZADAS PELA AUTORIDADE MONETARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.01.03', 'VPA COM OPERACOES NA AREA BANCARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES NA AREA BANCARIA REALIZADAS PELA AUTORIDADE MONETARIA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.01.04', 'VPA COM REMUNERACAO SOBRE DEP.A ORDEM DO GOV.FEDERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS A TITULO DE REMUNERACAO SOBRE DEPOSITOS A ORDEM DO GOVERNO FEDERAL EFETUADOS PELA AUTORIDADE MONETARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.01.05', 'TITULOS/VALORES OPERACOES C/DERIVATIVOS(SWAP) -RENDAS DE OPERACOES COM DERIVATIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES COM DERIVATIVOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.01.99', 'VPA COM OUTRAS OPERACOES DE AUTORIDADE MONETARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS OPERACOES DE NATUREZA EVENTUAL REALIZADAS PELA AUTORIDADE MONETARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.02.01', 'VPA DE OPERACOES DE CREDITOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE OPERACOES DE CREDITO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.02.02', 'VPA COM RESULTADO DE CAMBIO', 'REGISTRA OS VALORES RELATIVOS A DIFERENCAS POSITIVAS DE CAMBIO DECORRENTES DE DEPOSITOS BANCARIOS OU DE TRANSFERENCIA DE RESULTADOS FINANCEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.02.03', 'RENDAS DE APLIC. INTERFINANCEIRA DE LIQUIDEZ', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE APLICACAO INTERFINANCEIRA DE LIQUIDEZ.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.02.04', 'RENDAS DE TITULOS E VALORES MOBILIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE TITULOS E VALORES MOBILIARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.02.05', 'RESULT. DE TRANSACOES C/TIT.E VAL.MOBILIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RESULTADO POSITIVO DE TRANSACOES COM TITULOS E VALORES MOBILIARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.02.06', 'RENDAS DE PRESTACAO DE SERVICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE PRESTACAO DE SERVICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.02.07', 'RENDAS DE PARTICIPACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE PARTICIPACOES SOCIETARIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.02.99', 'OUTRAS VPA OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DE NATUREZA EVENTUAL VINCULADAS DIRETAMENTE AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.03.00', 'VPA NAO OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES COM TRANSACOES REALIZADAS NO PERIODO,NAO VINCULADAS A EXPLORACAO DO OBJETO DAS INSTITUICOES FINANCEIRAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.01.01', 'VPA COM OPERACOES COM TITULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES DA AUTORIDADE MONETARIA COM TITULOS .', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.01.02', 'VPA COM OPERACOES NA AREA EXTERNA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES NA AREA EXTERNA REALIZADAS PELA AUTORIDADE MONETARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.01.03', 'VPA COM OPERACOES NA AREA BANCARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES NA AREA BANCARIA REALIZADAS PELA AUTORIDADE MONETARIA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.01.04', 'VPA COM REMUNERACAO SOBRE DEP.A ORDEM DO GOV.FEDERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS A TITULO DE REMUNERACAO SOBRE DEPOSITOS A ORDEM DO GOVERNO FEDERAL EFETUADOS PELA AUTORIDADE MONETARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.01.05', 'TITULOS/VALORES OPERACOES C/DERIVATIVOS(SWAP) -RENDAS DE OPERACOES COM DERIVATIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES COM DERIVATIVOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.01.99', 'VPA COM OUTRAS OPERACOES DE AUTORIDADE MONETARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS OPERACOES DE NATUREZA EVENTUAL REALIZADAS PELA AUTORIDADE MONETARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.02.01', 'VPA DE OPERACOES DE CREDITOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE OPERACOES DE CREDITO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.02.02', 'VPA COM RESULTADO DE CAMBIO', 'REGISTRA OS VALORES RELATIVOS A DIFERENCAS POSITIVAS DE CAMBIO DECORRENTES DE DEPOSITOS BANCARIOS OU DE TRANSFERENCIA DE RESULTADOS FINANCEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.02.03', 'RENDAS DE APLIC. INTERFINANCEIRA DE LIQUIDEZ', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE APLICACAO INTERFINANCEIRA DE LIQUIDEZ.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.02.04', 'RENDAS DE TITULOS E VALORES MOBILIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE TITULOS E VALORES MOBILIARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.02.05', 'RESULT. DE TRANSACOES C/TIT.E VAL.MOBILIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RESULTADO POSITIVO DE TRANSACOES COM TITULOS E VALORES MOBILIARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.02.06', 'RENDAS DE PRESTACAO DE SERVICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE PRESTACAO DE SERVICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.02.07', 'RENDAS DE PARTICIPACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE PARTICIPACOES SOCIETARIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.02.99', 'OUTRAS VPA OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DE NATUREZA EVENTUAL VINCULADAS DIRETAMENTE AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.05.00', 'VPA NAO OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES COM TRANSACOES REALIZADAS NO PERIODO,NAO VINCULADAS A EXPLORACAO DO OBJETO DAS INSTITUICOES FINANCEIRAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.01.01', 'VPA COM OPERACOES COM TITULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES DA AUTORIDADE MONETARIA COM TITULOS .', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.01.02', 'VPA COM OPERACOES NA AREA EXTERNA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES NA AREA EXTERNA REALIZADAS PELA AUTORIDADE MONETARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.01.03', 'VPA COM OPERACOES NA AREA BANCARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES NA AREA BANCARIA REALIZADAS PELA AUTORIDADE MONETARIA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.01.04', 'VPA COM REMUNERACAO SOBRE DEP.A ORDEM DO GOV.FEDERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS A TITULO DE REMUNERACAO SOBRE DEPOSITOS A ORDEM DO GOVERNO FEDERAL EFETUADOS PELA AUTORIDADE MONETARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.01.05', 'TITULOS/VALORES OPERACOES C/DERIVATIVOS(SWAP) -RENDAS DE OPERACOES COM DERIVATIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES COM DERIVATIVOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.01.99', 'VPA COM OUTRAS OPERACOES DE AUTORIDADE MONETARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS OPERACOES DE NATUREZA EVENTUAL REALIZADAS PELA AUTORIDADE MONETARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.02.01', 'VPA DE OPERACOES DE CREDITOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE OPERACOES DE CREDITO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.02.02', 'VPA COM RESULTADO DE CAMBIO', 'REGISTRA OS VALORES RELATIVOS A DIFERENCAS POSITIVAS DE CAMBIO DECORRENTES DE DEPOSITOS BANCARIOS OU DE TRANSFERENCIA DE RESULTADOS FINANCEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.02.03', 'RENDAS DE APLIC. INTERFINANCEIRA DE LIQUIDEZ', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE APLICACAO INTERFINANCEIRA DE LIQUIDEZ.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.02.04', 'RENDAS DE TITULOS E VALORES MOBILIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE TITULOS E VALORES MOBILIARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.02.05', 'RESULT. DE TRANSACOES C/TIT.E VAL.MOBILIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RESULTADO POSITIVO DE TRANSACOES COM TITULOS E VALORES MOBILIARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.02.06', 'RENDAS DE PRESTACAO DE SERVICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE PRESTACAO DE SERVICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.02.07', 'RENDAS DE PARTICIPACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE PARTICIPACOES SOCIETARIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.02.99', 'OUTRAS VPA OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DE NATUREZA EVENTUAL VINCULADAS DIRETAMENTE AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.03.00', 'VPA NAO OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES COM TRANSACOES REALIZADAS NO PERIODO,NAO VINCULADAS A EXPLORACAO DO OBJETO DAS INSTITUICOES FINANCEIRAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.01.01', 'VPA COM OPERACOES COM TITULOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES DA AUTORIDADE MONETARIA COM TITULOS .', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.01.02', 'VPA COM OPERACOES NA AREA EXTERNA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES NA AREA EXTERNA REALIZADAS PELA AUTORIDADE MONETARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.01.03', 'VPA COM OPERACOES NA AREA BANCARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES NA AREA BANCARIA REALIZADAS PELA AUTORIDADE MONETARIA', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.01.04', 'VPA COM REMUNERACAO SOBRE DEP.A ORDEM DO GOV.FEDERAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS A TITULO DE REMUNERACAO SOBRE DEPOSITOS A ORDEM DO GOVERNO FEDERAL EFETUADOS PELA AUTORIDADE MONETARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.01.05', 'TITULOS/VALORES OPERACOES C/DERIVATIVOS(SWAP) -RENDAS DE OPERACOES COM DERIVATIVOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES COM DERIVATIVOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.01.99', 'VPA COM OUTRAS OPERACOES DE AUTORIDADE MONETARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS OPERACOES DE NATUREZA EVENTUAL REALIZADAS PELA AUTORIDADE MONETARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.02.01', 'VPA DE OPERACOES DE CREDITOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE OPERACOES DE CREDITO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.02.02', 'VPA COM RESULTADO DE CAMBIO', 'REGISTRA OS VALORES RELATIVOS A DIFERENCAS POSITIVAS DE CAMBIO DECORRENTES DE DEPOSITOS BANCARIOS OU DE TRANSFERENCIA DE RESULTADOS FINANCEIROS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.02.03', 'RENDAS DE APLIC. INTERFINANCEIRA DE LIQUIDEZ', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE APLICACAO INTERFINANCEIRA DE LIQUIDEZ.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.02.04', 'RENDAS DE TITULOS E VALORES MOBILIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE TITULOS E VALORES MOBILIARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.02.05', 'RESULT. DE TRANSACOES C/TIT.E VAL.MOBILIARIOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RESULTADO POSITIVO DE TRANSACOES COM TITULOS E VALORES MOBILIARIOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.02.06', 'RENDAS DE PRESTACAO DE SERVICOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE PRESTACAO DE SERVICOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.02.07', 'RENDAS DE PARTICIPACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE PARTICIPACOES SOCIETARIAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.02.99', 'OUTRAS VPA OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DE NATUREZA EVENTUAL VINCULADAS DIRETAMENTE AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.03.00', 'VPA NAO OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES COM TRANSACOES REALIZADAS NO PERIODO,NAO VINCULADAS A EXPLORACAO DO OBJETO DAS INSTITUICOES FINANCEIRAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.1.00.00', 'REVERSAO DE PROVISOES - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REVERSOES DE PROVISOES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.4.00.00', 'REVERSAO DE PROVISOES - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REVERSOES DE PROVISOES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.5.00.00', 'REVERSAO DE PROVISOES - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REVERSOES DE PROVISOES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.2.1.00.00', 'REVERSAO DE AJUSTES DE PERDAS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REVERSOES DE AJUSTES DE PERDAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.2.2.00.00', 'REVERSAO DE AJUSTES DE PERDAS - INTRA OFSS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REVERSOES DE AJUSTES DE PERDAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.2.4.00.00', 'REVERSAO DE AJUSTES DE PERDAS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REVERSOES DE AJUSTES DE PERDAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.2.5.00.00', 'REVERSAO DE AJUSTES DE PERDAS - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REVERSOES DE AJUSTES DE PERDAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.1.2.00.00', 'COMPENSACAO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.1.4.00.00', 'COMPENSACAO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.1.5.00.00', 'COMPENSACAO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.2.4.00.00', 'COMPENSACAO FINANCEIRA ENTRE REGIMES PROPRIOS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.2.5.00.00', 'COMPENSACAO FINANCEIRA ENTRE REGIMES PROPRIOS - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE). COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.3.1.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA COM BONIFICACOES - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE BONIFICACOES RECEBIDAS NAS AQUISICOES DE MERCADORIAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.3.2.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA COM BONIFICACOES - INTRA OFSS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE BONIFICACOES RECEBIDAS NAS AQUISICOES DE MERCADORIAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.3.4.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA COM BONIFICACOES - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE BONIFICACOES RECEBIDAS NAS AQUISICOES DE MERCADORIAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.3.5.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA COM BONIFICACOES - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE BONIFICACOES RECEBIDAS NAS AQUISICOES DE MERCADORIAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.4.1.00.00', 'AMORTIZACAO DE DESAGIO EM INVESTIMENTOS -CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZACAO DE DESAGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.4.2.00.00', 'AMORTIZACAO DE DESAGIO EM INVESTIMENTOS - INTRA OFSS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZACAO DE DESAGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.4.4.00.00', 'AMORTIZACAO DE DESAGIO EM INVESTIMENTOS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZACAO DE DESAGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.4.5.00.00', 'AMORTIZACAO DE DESAGIO EM INVESTIMENTOS - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZACAO DE DESAGIO EM INVESTIMENTOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.01.00', 'MULTAS PREVISTA NA LEGISLACAO DE METROLOGIA', 'REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLIC. P/ PUNIR QUEM INFRIGE AO DISPOSTO NA LEGISLACAO DE METROLOGIA, DA NORMALIZACAO INDUSTRIAL E DA CERTIFICACAO DE QUALIDADE DE PRODUTOS INDUSTRIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.02.00', 'MULTAS DO REGULAMENTO P/ O TRAFEGO MARITIMO', 'REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS C/FIM DE PUNIR QUEM INFRINGE O REGULAMENTO PARA O TRAFEGO MARITIMO. MULTAS DEVIDAS POR EMBARCACOESBRASILEIRAS, SALVO AS PERTENCENTES A MARINHA, QUANDO EM AGUAS SOBJURISDICAO NACIONAL OU EM ALTO-MAR; POR EMBARCACOES ESTRANGEIRAS EMAGUAS TERRITORIAIS, NAVIOS DE GUERRA ESTRANGEIROS E OUTRAS EMBARCACOESQUE VIOLEM AS NORMAS EXPRESSAS NO REGULAMENTO PARA O TRAFEGO MARITIMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.03.00', 'MULTA DE POLUICAO DE AGUAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DESTINADAS A PUNIR O INFRATOR PELA POLUICAO DE AGUAS. MULTAS DEV. LANCAMENTO OLEOS,PRODUTOS OLEOSOS E SUBSTANCIAS QUIMICAS TOXICAS NAS AGUAS PUBLICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.04.00', 'MULTAS DO CODIGO ELEITORAL E LEIS CONEXAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE O CODIGO ELEITORAL E LEIS CONEXAS. COMPREENDE A MULTA DEVIDA PELOS ELEITORES QUE NAO COMPARECEREM E NAO JUSTIFICAREMSUA AUSENCIA PERANTE O JUIZ ELEITORAL ATE 30 DIAS APOS A REALIZACAO DAELEICAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.05.00', 'MULTAS PREVISTAS NA LEI DO SERVICO MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR O MILITAR POR INOBSERVANCIA DE LEIS ESPECIFICAS. DEVIDAS PELOCIDADAO BRASILEIRO DO SEXO MASCULINO QUE NAO SE ALISTAR ATE OS 19 ANOS PARA PRESTAR SERVICO MILITAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.06.00', 'MULTAS PREVISTAS NA LEI GERAL DAS TELECOMUN.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INFRACOES COMETIDAS POR CONCESSIONARIOS DE SERVICOS DE TELECOMUNICACOES E DE RADIOFUSAO, SEJA NO REGIME PUBLICO OU PRIVADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.07.00', 'MULTAS PREVISTAS NA LEGISL. SANITARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE O DISPOSTO NA LEGISLACAO SANITARIA. DEVIDASQUANDO DA INFRACAO, FRAUDE, FALSIFICACAO E ADULTERACAO DAS MATERIAS-PRIMAS E PRODUTOS FARMACEUTICOS, BEM COMO QUAISQUER PRODUTOS OU INSUMOS QUE INTERESSEM A SAUDE PUBLICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.08.00', 'MULTAS PREVISTAS LEGIS.DE REGISTRO COMERCIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE AS LEIS OU REGULAMENTOS QUE DISCIPLINAM AS ATIVIDADES DE AGENTES AUXILIARES DO COMERCIO, DE ARMAZENS GERAIS E OUTROS SUJEITOS AO CONTROLE E FISCALIZACAO DOS ORGAOS DE REGISTRO DO COMERCIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.09.00', 'MUL. PREVISTAS NA LEGIS LUBRIF.E COMBUSTIVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A COMBUSTIVEIS E LUBRIFICANTES. AS MULTAS SAO IMPOSTAS PELA AGENCIA NACIONAL DO PETROLEO-ANP.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.10.00', 'MULTAS POR INFRACAO A LEGIS. TRABALHISTA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE A LEGISLACAO TRABALHISTA, TAIS COMO: EXTRAVIO OU INUTILIZACAO DE CARTEIRA DE TRABALHO, FALTA DE REGISTRO DE EMPREGA-DO, PRORROGACAO DE JORNADA DE TRABALHO SEM ACORDO, PAGAMENTO DE SALARIO ATRASADO, INFRACOES AS NORMAS DE SEGURANCA E MEDICINA DO TRABALHO,ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.11.00', 'MULTAS PREVISTAS NA LEGISLAC. DE TRANSITO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A TRANSITO. CONSTITUEM VPA VINCULADA AO MINISTERIO DA JUSTICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.12.00', 'MUL. PREVISTAS NA LEG.SEG.DESEMP.AB. SALAR.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE A LEGISLACAO REFERENTE AO SEGURO-DESEMPREGO E AO ABONO SALARIAL. VPA CONSTITUIDA DO PRODUTO DOS ENCARGOS DEVIDO SPELOS CONTRIBUINTES, EM DECORRENCIA DE SUAS OBRIGACOES JUNTO AO PIS E AO PASEP. CONSTITUI RECURSO DO FUNDO DE AMPARO AO TRABALHADOR - FAT,VINCULADO AO MINISTERIO DO TRABALHO, SENDO DESTINADO AO CUSTEIO DO PROGRAMA DE SEGURO-DESEMPREGO, AO PAGAMENTO DO ABONO SALARIAL E AO FINANCIAMENTO DE PROGRAMAS DE DESENVOLVIMENTO ECONOMICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.13.01', 'MUL.PREV.LEGISL.S/DIREITOS DIFUSOS TRABALHIST', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE DIREITOS DIFUSOS TRABALHISTAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.13.02', 'MUL.PREV.LEGISL.S/DIREITOS DIFUSOS - OUTROS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE OUTROS DIREITOS DIFUSOS NAO ABRANGIDOS PELOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.14.00', 'MULTAS E JUROS PREVISTOS EM CONTRATOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS PREVISTOS EM CONTRATOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.15.00', 'MULTAS DEC.OP.TRANSP.ROD.PASSAGEIROS E CARGAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES DAS LEGISLACOES DE OPERACAO DO TRANSPORTE RODOVIARIO DE PASSAGEIROS E CARGAS, BEM COMO DOS CONTRATOS DE CONCESSAO DE SERVICOS DE TRANSPORTE RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS E CARGAS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.16.00', 'MUL.PREVISTAS POR.INFR.LEGIS.TRANSP. FERROV.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO RECOLHIMENTO PELO MINISTERIO DOS TRANSPORTES DE MULTAS POR INFRACOES A DISPOSICOES PREVISTAS NO REGULAMENTO DE TRANSPORTE FERROVIARIOS E CONTRATOS DE CONCESSOES DE SERVICOS DE TRANSPORTE FERROVIARIO DE PASSAGEIROS E CARGAS. AMPARO LEGAL: DECRETO 04/96, DECRETO 1832/96.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.17.00', 'MULTAS PREVISTAS NO COD.BRAS. DE AERONAUTICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES PREVISTAS NO CODIGO BRASILEIRO DE AERONAUTICA (LEI 7565, DE19/12/86; LEI NUM. 9614, DE 05/03/98).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.18.00', 'MULTA DE TARIFA PEDAGIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS SOBREA TARIFA DE PEDAGIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.19.00', 'MULTA DECOR.DE SENT.PENAL CONDENATORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS SOBRE SENTENCAS PENAIS CONDENATORIAS COM TRANSITO EM JULGADO. OS RECURSOS DESTINAM-SE AO FUNPEN PARA FINANCIAR E APOIAR AS ATIVIDADES E PROGRAMAS DE MODERNIZACAO E APRIMORAMENTO DO SISTEMA PENITENCIARIO BRASILEIRO. DECRETO LEI NUM.79N DE 07/01/94.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.20.00', 'MULTA DE QUEBRA DE FIANCA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PROVENIENTES DE MULTAS DECORRENTES DE FIANCA QUEBRADA OU PERDIDA, EM CONFORMIDADE COM O DISPOSTO NA LEI PROCESSUAL PENAL. OS RECURSOS DESTINAM-SE AO FUNPEN PARA FINANCIAR E APOIAR AS ATIVIDADES E PROGRAMAS DE MODERNIZACAO E APRIMORAMENTO DO SISTEMA PENITENCIARIO BRASILEIRO. DECRETO LEI NUM.79N DE 07/01/94.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.21.00', 'MULTAS POR DANOS AO MEIO AMBIENTE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS POR DANOS AO MEIO AMBIENTE. AMPARO LEGAL: LEI 9 605 DE 12FEV1998', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.22.00', 'MULTA E DE SEGURANCA PRIVADA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS POR INFRACOES PRATICADAS POR EMPRESAS PARTICULARES QUE EXPLOREM SERVICOS DE VIGILANCIA E DE TRANSPORTE DE VALORES (LEI 9017 DE 30/03/95).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.23.00', 'MULTA POR ATO ATENTATORIO AO EXERC JURISDICAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS QUE TEM COMO FATO GERADOR O NAO CUMPRIMENTO COM EXATIDAO DOS PROVIMENTOS MANDAMENTAIS OU A CRIACAO DE EMBARACOS A EFETIVACAO DE PROVIMENTOS JUDICIAIS DE NATUREZA ANTECIPATORIA OU FINAL. FUNDAMENTO LEGAL: LEI 5869/1973; LEI 5925/1973; LEI 8953/1994; LEI 10358/2001; LEI 11382/2006. DESTINACAO LEGAL: RECURSOS LIVRES PARA O TESOURO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.24.00', 'MULTAS POR INFRACOES A LEG. CINEMATOGRAFICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE NAO-PAGAMENTO NO TRANSCURSO DE PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DAS MULTAS POR INFRACOES A LEGISLACAO CINEMATOGRAFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.25.00', 'MUL.APLIC.PELOS TRIBUNAIS DE CONTAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS MULTAS APLICADAS PELOS TRIBUNAIS DE CONTAS, PELO NAO CUMPRIMENTO A DECISAO DOS MESMOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.26.00', 'MULT.PREV. LEG. S/ REG. PREV. PRIV. COMPLEM.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PREVISTAS NA LEGISLACAO REG. PREV. PRIV. COMPLEM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.27.00', 'MULTAS POR AUTOS DE INFRACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PUNITIVAS APLICADAS PELO NAO CUMPRIMENTO NOS CASOS PREVISTOS NOS REGULAMENTOS OU NOS CONTRATOS, OU PELA REINCIDENCIA EM FATOS QUE TENHAM GERADO ADVERTENCIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.28.00', 'MULTAS PREVISTAS NA LEGISLACAO MINERARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS EXERCIDAS PELO PODER DE POLICIA PREVISTAS NA LEGISLACAO MINERARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.29.00', 'MULTA POR FALTA/ATRASO NA APRESENTACAO GFIP', 'REGISTRA O VALOR DA VPA DECORRENTE DE MULTA POR FALTA OU ATRASO NA APRESENTACAO DA GUIA DE RECOLHIMENTO DO FUNDO DE GARANTIA DE TEMPO DE SERVICO E DE INFORMACOES A PREVIDENCIA SOCIAL - GFIP. PORTARIA Nº 09, DE 26/02/2010', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.30.01', 'MULTAS/INDENIZACOES - EXPLORACAO DO PATRIMONIO GENETICO - AREA DE DOMINIO DA UNIAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE MULTAS E INDENIZACOES PELA EXPLORACAO DO PATRIMONIO GENETICO EM AREAS DE DOMINIO DA UNIAO.(PORTARIA SOF Nº 132, DE 08/10/10)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.30.02', 'MULTAS/INDENIZACOES - EXPLORACAO DO PATRIMONIO GENETICO - MAR TERRITORIAL', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE MULTAS E INDENIZACOES PELA EXPLORACAO DO PATRIMONIO GENETICO NO MAR TERRITORIAL, ZONA ECONOMICA EXCLUSIVA OU PLATAFORMA CONTINENTAL.(PORTARIA SOF Nº 132, DE 08/10/10)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.99.00', 'OUTRAS MULTAS ADMINISTRATIVAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS MULTAS ADMINISTRATIVAS NAO ENQUADRADAS NAS CONTAS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.01.00', 'MULTAS PREVISTA NA LEGISLACAO DE METROLOGIA', 'REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLIC. P/ PUNIR QUEM INFRIGE AO DISPOSTO NA LEGISLACAO DE METROLOGIA, DA NORMALIZACAO INDUSTRIAL E DA CERTIFICACAO DE QUALIDADE DE PRODUTOS INDUSTRIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.02.00', 'MULTAS DO REGULAMENTO P/ O TRAFEGO MARITIMO', 'REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS C/FIM DE PUNIR QUEM INFRINGE O REGULAMENTO PARA O TRAFEGO MARITIMO. MULTAS DEVIDAS POR EMBARCACOESBRASILEIRAS, SALVO AS PERTENCENTES A MARINHA, QUANDO EM AGUAS SOBJURISDICAO NACIONAL OU EM ALTO-MAR; POR EMBARCACOES ESTRANGEIRAS EMAGUAS TERRITORIAIS, NAVIOS DE GUERRA ESTRANGEIROS E OUTRAS EMBARCACOESQUE VIOLEM AS NORMAS EXPRESSAS NO REGULAMENTO PARA O TRAFEGO MARITIMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.03.00', 'MULTA DE POLUICAO DE AGUAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DESTINADAS A PUNIR O INFRATOR PELA POLUICAO DE AGUAS. MULTAS DEV. LANCAMENTO OLEOS,PRODUTOS OLEOSOS E SUBSTANCIAS QUIMICAS TOXICAS NAS AGUAS PUBLICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.04.00', 'MULTAS DO CODIGO ELEITORAL E LEIS CONEXAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE O CODIGO ELEITORAL E LEIS CONEXAS. COMPREENDE A MULTA DEVIDA PELOS ELEITORES QUE NAO COMPARECEREM E NAO JUSTIFICAREMSUA AUSENCIA PERANTE O JUIZ ELEITORAL ATE 30 DIAS APOS A REALIZACAO DAELEICAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.05.00', 'MULTAS PREVISTAS NA LEI DO SERVICO MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR O MILITAR POR INOBSERVANCIA DE LEIS ESPECIFICAS. DEVIDAS PELOCIDADAO BRASILEIRO DO SEXO MASCULINO QUE NAO SE ALISTAR ATE OS 19 ANOS PARA PRESTAR SERVICO MILITAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.06.00', 'MULTAS PREVISTAS NA LEI GERAL DAS TELECOMUN.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INFRACOES COMETIDAS POR CONCESSIONARIOS DE SERVICOS DE TELECOMUNICACOES E DE RADIOFUSAO, SEJA NO REGIME PUBLICO OU PRIVADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.07.00', 'MULTAS PREVISTAS NA LEGISL. SANITARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE O DISPOSTO NA LEGISLACAO SANITARIA. DEVIDASQUANDO DA INFRACAO, FRAUDE, FALSIFICACAO E ADULTERACAO DAS MATERIAS-PRIMAS E PRODUTOS FARMACEUTICOS, BEM COMO QUAISQUER PRODUTOS OU INSUMOS QUE INTERESSEM A SAUDE PUBLICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.08.00', 'MULTAS PREVISTAS LEGIS.DE REGISTRO COMERCIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE AS LEIS OU REGULAMENTOS QUE DISCIPLINAM AS ATIVIDADES DE AGENTES AUXILIARES DO COMERCIO, DE ARMAZENS GERAIS E OUTROS SUJEITOS AO CONTROLE E FISCALIZACAO DOS ORGAOS DE REGISTRO DO COMERCIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.09.00', 'MUL. PREVISTAS NA LEGIS LUBRIF.E COMBUSTIVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A COMBUSTIVEIS E LUBRIFICANTES. AS MULTAS SAO IMPOSTAS PELA AGENCIA NACIONAL DO PETROLEO-ANP.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.10.00', 'MULTAS POR INFRACAO A LEGIS. TRABALHISTA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE A LEGISLACAO TRABALHISTA, TAIS COMO: EXTRAVIO OU INUTILIZACAO DE CARTEIRA DE TRABALHO, FALTA DE REGISTRO DE EMPREGA-DO, PRORROGACAO DE JORNADA DE TRABALHO SEM ACORDO, PAGAMENTO DE SALARIO ATRASADO, INFRACOES AS NORMAS DE SEGURANCA E MEDICINA DO TRABALHO,ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.11.00', 'MULTAS PREVISTAS NA LEGISLAC. DE TRANSITO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A TRANSITO. CONSTITUEM VPA VINCULADA AO MINISTERIO DA JUSTICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.12.00', 'MUL. PREVISTAS NA LEG.SEG.DESEMP.AB. SALAR.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE A LEGISLACAO REFERENTE AO SEGURO-DESEMPREGO E AO ABONO SALARIAL. VPA CONSTITUIDA DO PRODUTO DOS ENCARGOS DEVIDO SPELOS CONTRIBUINTES, EM DECORRENCIA DE SUAS OBRIGACOES JUNTO AO PIS E AO PASEP. CONSTITUI RECURSO DO FUNDO DE AMPARO AO TRABALHADOR - FAT,VINCULADO AO MINISTERIO DO TRABALHO, SENDO DESTINADO AO CUSTEIO DO PROGRAMA DE SEGURO-DESEMPREGO, AO PAGAMENTO DO ABONO SALARIAL E AO FINANCIAMENTO DE PROGRAMAS DE DESENVOLVIMENTO ECONOMICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.13.01', 'MUL.PREV.LEGISL.S/DIREITOS DIFUSOS TRABALHIST', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE DIREITOS DIFUSOS TRABALHISTAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.13.02', 'MUL.PREV.LEGISL.S/DIREITOS DIFUSOS - OUTROS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE OUTROS DIREITOS DIFUSOS NAO ABRANGIDOS PELOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.14.00', 'MULTAS E JUROS PREVISTOS EM CONTRATOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS PREVISTOS EM CONTRATOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.15.00', 'MULTAS DEC.OP.TRANSP.ROD.PASSAGEIROS E CARGAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES DAS LEGISLACOES DE OPERACAO DO TRANSPORTE RODOVIARIO DE PASSAGEIROS E CARGAS, BEM COMO DOS CONTRATOS DE CONCESSAO DE SERVICOS DE TRANSPORTE RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS E CARGAS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.16.00', 'MUL.PREVISTAS POR.INFR.LEGIS.TRANSP. FERROV.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO RECOLHIMENTO PELO MINISTERIO DOS TRANSPORTES DE MULTAS POR INFRACOES A DISPOSICOES PREVISTAS NO REGULAMENTO DE TRANSPORTE FERROVIARIOS E CONTRATOS DE CONCESSOES DE SERVICOS DE TRANSPORTE FERROVIARIO DE PASSAGEIROS E CARGAS. AMPARO LEGAL: DECRETO 04/96, DECRETO 1832/96.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.18.00', 'MULTA DE TARIFA PEDAGIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS SOBREA TARIFA DE PEDAGIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.19.00', 'MULTA DECOR.DE SENT.PENAL CONDENATORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS SOBRE SENTENCAS PENAIS CONDENATORIAS COM TRANSITO EM JULGADO. OS RECURSOS DESTINAM-SE AO FUNPEN PARA FINANCIAR E APOIAR AS ATIVIDADES E PROGRAMAS DE MODERNIZACAO E APRIMORAMENTO DO SISTEMA PENITENCIARIO BRASILEIRO. DECRETO LEI NUM.79N DE 07/01/94.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.20.00', 'MULTA DE QUEBRA DE FIANCA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PROVENIENTES DE MULTAS DECORRENTES DE FIANCA QUEBRADA OU PERDIDA, EM CONFORMIDADE COM O DISPOSTO NA LEI PROCESSUAL PENAL. OS RECURSOS DESTINAM-SE AO FUNPEN PARA FINANCIAR E APOIAR AS ATIVIDADES E PROGRAMAS DE MODERNIZACAO E APRIMORAMENTO DO SISTEMA PENITENCIARIO BRASILEIRO. DECRETO LEI NUM.79N DE 07/01/94.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.21.00', 'MULTAS POR DANOS AO MEIO AMBIENTE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS POR DANOS AO MEIO AMBIENTE. AMPARO LEGAL: LEI 9 605 DE 12FEV1998', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.22.00', 'MULTA E DE SEGURANCA PRIVADA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS POR INFRACOES PRATICADAS POR EMPRESAS PARTICULARES QUE EXPLOREM SERVICOS DE VIGILANCIA E DE TRANSPORTE DE VALORES (LEI 9017 DE 30/03/95).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.23.00', 'MULTA POR ATO ATENTATORIO AO EXERC JURISDICAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS QUE TEM COMO FATO GERADOR O NAO CUMPRIMENTO COM EXATIDAO DOS PROVIMENTOS MANDAMENTAIS OU A CRIACAO DE EMBARACOS A EFETIVACAO DE PROVIMENTOS JUDICIAIS DE NATUREZA ANTECIPATORIA OU FINAL. FUNDAMENTO LEGAL: LEI 5869/1973; LEI 5925/1973; LEI 8953/1994; LEI 10358/2001; LEI 11382/2006. DESTINACAO LEGAL: RECURSOS LIVRES PARA O TESOURO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.24.00', 'MULTAS POR INFRACOES A LEG. CINEMATOGRAFICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE NAO-PAGAMENTO NO TRANSCURSO DE PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DAS MULTAS POR INFRACOES A LEGISLACAO CINEMATOGRAFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.25.00', 'MUL.APLIC.PELOS TRIBUNAIS DE CONTAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS MULTAS APLICADAS PELOS TRIBUNAIS DE CONTAS, PELO NAO CUMPRIMENTO A DECISAO DOS MESMOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.26.00', 'MULT.PREV. LEG. S/ REG. PREV. PRIV. COMPLEM.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PREVISTAS NA LEGISLACAO REG. PREV. PRIV. COMPLEM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.27.00', 'MULTAS POR AUTOS DE INFRACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PUNITIVAS APLICADAS PELO NAO CUMPRIMENTO NOS CASOS PREVISTOS NOS REGULAMENTOS OU NOS CONTRATOS, OU PELA REINCIDENCIA EM FATOS QUE TENHAM GERADO ADVERTENCIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.28.00', 'MULTAS PREVISTAS NA LEGISLACAO MINERARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS EXERCIDAS PELO PODER DE POLICIA PREVISTAS NA LEGISLACAO MINERARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.29.00', 'MULTA POR FALTA/ATRASO NA APRESENTACAO GFIP', 'REGISTRA O VALOR DA VPA DECORRENTE DE MULTA POR FALTA OU ATRASO NA APRESENTACAO DA GUIA DE RECOLHIMENTO DO FUNDO DE GARANTIA DE TEMPO DE SERVICO E DE INFORMACOES A PREVIDENCIA SOCIAL - GFIP. PORTARIA Nº 09, DE 26/02/2010', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.99.00', 'OUTRAS MULTAS ADMINISTRATIVAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS MULTAS ADMINISTRATIVAS NAO ENQUADRADAS NAS CONTAS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.01.00', 'MULTAS PREVISTA NA LEGISLACAO DE METROLOGIA', 'REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLIC. P/ PUNIR QUEM INFRIGE AO DISPOSTO NA LEGISLACAO DE METROLOGIA, DA NORMALIZACAO INDUSTRIAL E DA CERTIFICACAO DE QUALIDADE DE PRODUTOS INDUSTRIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.02.00', 'MULTAS DO REGULAMENTO P/ O TRAFEGO MARITIMO', 'REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS C/FIM DE PUNIR QUEM INFRINGE O REGULAMENTO PARA O TRAFEGO MARITIMO. MULTAS DEVIDAS POR EMBARCACOESBRASILEIRAS, SALVO AS PERTENCENTES A MARINHA, QUANDO EM AGUAS SOBJURISDICAO NACIONAL OU EM ALTO-MAR; POR EMBARCACOES ESTRANGEIRAS EMAGUAS TERRITORIAIS, NAVIOS DE GUERRA ESTRANGEIROS E OUTRAS EMBARCACOESQUE VIOLEM AS NORMAS EXPRESSAS NO REGULAMENTO PARA O TRAFEGO MARITIMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.03.00', 'MULTA DE POLUICAO DE AGUAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DESTINADAS A PUNIR O INFRATOR PELA POLUICAO DE AGUAS. MULTAS DEV. LANCAMENTO OLEOS,PRODUTOS OLEOSOS E SUBSTANCIAS QUIMICAS TOXICAS NAS AGUAS PUBLICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.04.00', 'MULTAS DO CODIGO ELEITORAL E LEIS CONEXAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE O CODIGO ELEITORAL E LEIS CONEXAS. COMPREENDE A MULTA DEVIDA PELOS ELEITORES QUE NAO COMPARECEREM E NAO JUSTIFICAREMSUA AUSENCIA PERANTE O JUIZ ELEITORAL ATE 30 DIAS APOS A REALIZACAO DAELEICAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.05.00', 'MULTAS PREVISTAS NA LEI DO SERVICO MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR O MILITAR POR INOBSERVANCIA DE LEIS ESPECIFICAS. DEVIDAS PELOCIDADAO BRASILEIRO DO SEXO MASCULINO QUE NAO SE ALISTAR ATE OS 19 ANOSPARA PRESTAR SERVICO MILITAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.06.00', 'MULTAS PREVISTAS NA LEI GERAL DAS TELECOMUN.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INFRACOES COMETIDAS POR CONCESSIONARIOS DE SERVICOS DE TELECOMUNICACOES E DE RADIOFUSAO, SEJA NO REGIME PUBLICO OU PRIVADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.07.00', 'MULTAS PREVISTAS NA LEGISL. SANITARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE O DISPOSTO NA LEGISLACAO SANITARIA. DEVIDASQUANDO DA INFRACAO, FRAUDE, FALSIFICACAO E ADULTERACAO DAS MATERIAS-PRIMAS E PRODUTOS FARMACEUTICOS, BEM COMO QUAISQUER PRODUTOS OU INSUMOS QUE INTERESSEM A SAUDE PUBLICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.08.00', 'MULTAS PREVISTAS LEGIS.DE REGISTRO COMERCIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE AS LEIS OU REGULAMENTOS QUE DISCIPLINAM AS ATIVIDADES DE AGENTES AUXILIARES DO COMERCIO, DE ARMAZENS GERAIS E OUTROS SUJEITOS AO CONTROLE E FISCALIZACAO DOS ORGAOS DE REGISTRO DO COMERCIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.09.00', 'MUL. PREVISTAS NA LEGIS LUBRIF.E COMBUSTIVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A COMBUSTIVEIS E LUBRIFICANTES. AS MULTAS SAO IMPOSTAS PELA AGENCIA NACIONAL DO PETROLEO-ANP.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.10.00', 'MULTAS POR INFRACAO A LEGIS. TRABALHISTA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE A LEGISLACAO TRABALHISTA, TAIS COMO: EXTRAVIO OU INUTILIZACAO DE CARTEIRA DE TRABALHO, FALTA DE REGISTRO DE EMPREGADO, PRORROGACAO DE JORNADA DE TRABALHO SEM ACORDO, PAGAMENTO DE SALARIO ATRASADO, INFRACOES AS NORMAS DE SEGURANCA E MEDICINA DO TRABALHO,ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.11.00', 'MULTAS PREVISTAS NA LEGISLAC. DE TRANSITO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A TRANSITO. CONSTITUEM VPA VINCULADA AO MINISTERIO DA JUSTICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.12.00', 'MUL. PREVISTAS NA LEG.SEG.DESEMP.AB. SALAR.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE A LEGISLACAO REFERENTE AO SEGURO-DESEMPREGO E AO ABONO SALARIAL. VPA CONSTITUIDA DO PRODUTO DOS ENCARGOS DEVIDO SPELOS CONTRIBUINTES, EM DECORRENCIA DE SUAS OBRIGACOES JUNTO AO PIS E AO PASEP. CONSTITUI RECURSO DO FUNDO DE AMPARO AO TRABALHADOR - FAT,VINCULADO AO MINISTERIO DO TRABALHO, SENDO DESTINADO AO CUSTEIO DO PROGRAMA DE SEGURO-DESEMPREGO, AO PAGAMENTO DO ABONO SALARIAL E AO FINANCIAMENTO DE PROGRAMAS DE DESENVOLVIMENTO ECONOMICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.13.01', 'MUL.PREV.LEGISL.S/DIREITOS DIFUSOS TRABALHIST', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE DIREITOS DIFUSOS TRABALHISTAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.13.02', 'MUL.PREV.LEGISL.S/DIREITOS DIFUSOS - OUTROS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE OUTROS DIREITOS DIFUSOS NAO ABRANGIDOS PELOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.14.00', 'MULTAS E JUROS PREVISTOS EM CONTRATOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS PREVISTOS EM CONTRATOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.15.00', 'MULTAS DEC.OP.TRANSP.ROD.PASSAGEIROS E CARGAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES DAS LEGISLACOES DE OPERACAO DO TRANSPORTE RODOVIARIO DE PASSAGEIROS E CARGAS, BEM COMO DOS CONTRATOS DE CONCESSAO DE SERVICOS DE TRANSPORTE RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS E CARGAS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.16.00', 'MUL.PREVISTAS POR.INFR.LEGIS.TRANSP. FERROV.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO RECOLHIMENTO PELO MINISTERIO DOS TRANSPORTES DE MULTAS POR INFRACOES A DISPOSICOES PREVISTAS NO REGULAMENTO DE TRANSPORTE FERROVIARIOS E CONTRATOS DE CONCESSO-ES DE SERVICOS DE TRANSPORTE FERROVIARIO DE PASSAGEIROS E CARGAS. AMPARO LEGAL: DECRETO 04/96, DECRETO 1832/96.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.17.00', 'MULTAS PREVISTAS NO COD.BRAS. DE AERONAUTICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES PREVISTAS NO CODIGO BRASILEIRO DE AERONAUTICA (LEI 7565, DE19/12/86; LEI NUM. 9614, DE 05/03/98).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.18.00', 'MULTA DE TARIFA PEDAGIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS SOBREA TARIFA DE PEDAGIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.19.00', 'MULTA DECOR.DE SENT.PENAL CONDENATORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS SOBRE SENTENCAS PENAIS CONDENATORIAS COM TRANSITO EM JULGADO. OS RECURSOS DESTINAM-SE AO FUNPEN PARA FINANCIAR E APOIAR AS ATIVIDADES E PROGRAMAS DE MODERNIZACAO E APRIMORAMENTO DO SISTEMA PENITENCIARIO BRASILEIRO. DECRETO LEI NUM.79N DE 07/01/94.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.20.00', 'MULTA DE QUEBRA DE FIANCA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PROVENIENTES DE MULTAS DECORRENTES DE FIANCA QUEBRADA OU PERDIDA, EM CONFORMIDADE COM O DISPOSTO NA LEI PROCESSUAL PENAL. OS RECURSOS DESTINAM-SE AO FUNPEN PARA FINANCIAR E APOIAR AS ATIVIDADES E PROGRAMAS DE MODERNIZACAO E APRIMORAMENTO DO SISTEMA PENITENCIARIO BRASILEIRO. DECRETO LEI NUM.79N DE 07/01/94.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.22.00', 'MULTA E DE SEGURANCA PRIVADA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS POR INFRACOES PRATICADAS POR EMPRESAS PARTICULARES QUE EXPLOREM SERVICOS DE VIGILANCIA E DE TRANSPORTE DE VALORES (LEI 9017 DE 30/03/95).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.23.00', 'MULTA POR ATO ATENTATORIO AO EXERC JURISDICAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS QUE TEM COMO FATO GERADOR O NAO CUMPRIMENTO COM EXATIDAO DOS PROVIMENTOS MANDAMENTAIS OU A CRIACAO DE EMBARACOS A EFETIVACAO DE PROVIMENTOS JUDICIAIS DE NATUREZA ANTECIPATORIA OU FINAL. FUNDAMENTO LEGAL: LEI 5869/1973; LEI 5925/1973; LEI 8953/1994; LEI 10358/2001; LEI 11382/2006. DESTINACAO LEGAL: RECURSOS LIVRES PARA O TESOURO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.24.00', 'MULTAS POR INFRACOES A LEG. CINEMATOGRAFICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE NAO-PAGAMENTO NO TRANSCURSO DE PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DAS MULTAS POR INFRACOES A LEGISLACAO CINEMATOGRAFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.25.00', 'MUL.APLIC.PELOS TRIBUNAIS DE CONTAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS MULTAS APLICADAS PELOS TRIBUNAIS DE CONTAS, PELO NAO CUMPRIMENTO A DECISAO DOS MESMOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.26.00', 'MULT.PREV. LEG. S/ REG. PREV. PRIV. COMPLEM.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PREVISTAS NA LEGISLACAO REG. PREV. PRIV. COMPLEM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.27.00', 'MULTAS POR AUTOS DE INFRACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PUNITIVAS APLICADAS PELO NAO CUMPRIMENTO NOS CASOS PREVISTOS NOS REGULAMENTOS OU NOS CONTRATOS, OU PELA REINCIDENCIA EM FATOS QUE TENHAM GERADO ADVERTENCIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.28.00', 'MULTAS PREVISTAS NA LEGISLACAO MINERARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS EXERCIDAS PELO PODER DE POLICIA PREVISTAS NA LEGISLACAO MINERARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.29.00', 'MULTA POR FALTA/ATRASO NA APRESENTACAO GFIP', 'REGISTRA O VALOR DA VPA DECORRENTE DE MULTA POR FALTA OU ATRASO NA APRESENTACAO DA GUIA DE RECOLHIMENTO DO FUNDO DE GARANTIA DE TEMPO DE SERVICO E DE INFORMACOES A PREVIDENCIA SOCIAL - GFIP. PORTARIA Nº 09, DE 26/02/2010', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.99.00', 'OUTRAS MULTAS ADMINISTRATIVAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS MULTAS ADMINISTRATIVAS NAO ENQUADRADAS NAS CONTAS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.01.00', 'MULTAS PREVISTA NA LEGISLACAO DE METROLOGIA', 'REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLIC. P/ PUNIR QUEM INFRIGE AO DISPOSTO NA LEGISLACAO DE METROLOGIA, DA NORMALIZACAO INDUSTRIAL E DA CERTIFICACAO DE QUALIDADE DE PRODUTOS INDUSTRIAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.02.00', 'MULTAS DO REGULAMENTO P/ O TRAFEGO MARITIMO', 'REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS C/FIM DE PUNIR QUEM INFRINGE O REGULAMENTO PARA O TRAFEGO MARITIMO. MULTAS DEVIDAS POR EMBARCACOESBRASILEIRAS, SALVO AS PERTENCENTES A MARINHA, QUANDO EM AGUAS SOBJURISDICAO NACIONAL OU EM ALTO-MAR; POR EMBARCACOES ESTRANGEIRAS EMAGUAS TERRITORIAIS, NAVIOS DE GUERRA ESTRANGEIROS E OUTRAS EMBARCACOESQUE VIOLEM AS NORMAS EXPRESSAS NO REGULAMENTO PARA O TRAFEGO MARITIMO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.03.00', 'MULTA DE POLUICAO DE AGUAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DESTINADAS A PUNIR O INFRATOR PELA POLUICAO DE AGUAS. MULTAS DEV. LANCAMENTO OLEOS,PRODUTOS OLEOSOS E SUBSTANCIAS QUIMICAS TOXICAS NAS AGUAS PUBLICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.04.00', 'MULTAS DO CODIGO ELEITORAL E LEIS CONEXAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE O CODIGO ELEITORAL E LEIS CONEXAS. COMPREENDE A MULTA DEVIDA PELOS ELEITORES QUE NAO COMPARECEREM E NAO JUSTIFICAREMSUA AUSENCIA PERANTE O JUIZ ELEITORAL ATE 30 DIAS APOS A REALIZACAO DAELEICAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.05.00', 'MULTAS PREVISTAS NA LEI DO SERVICO MILITAR', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR O MILITAR POR INOBSERVANCIA DE LEIS ESPECIFICAS. DEVIDAS PELOCIDADAO BRASILEIRO DO SEXO MASCULINO QUE NAO SE ALISTAR ATE OS 19 ANOSPARA PRESTAR SERVICO MILITAR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.06.00', 'MULTAS PREVISTAS NA LEI GERAL DAS TELECOMUN.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INFRACOES COMETIDAS POR CONCESSIONARIOS DE SERVICOS DE TELECOMUNICACOES E DE RADIOFUSAO, SEJA NO REGIME PUBLICO OU PRIVADO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.07.00', 'MULTAS PREVISTAS NA LEGISL. SANITARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE O DISPOSTO NA LEGISLACAO SANITARIA. DEVIDASQUANDO DA INFRACAO, FRAUDE, FALSIFICACAO E ADULTERACAO DAS MATERIAS-PRIMAS E PRODUTOS FARMACEUTICOS, BEM COMO QUAISQUER PRODUTOS OU INSUMOS QUE INTERESSEM A SAUDE PUBLICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.08.00', 'MULTAS PREVISTAS LEGIS.DE REGISTRO COMERCIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE AS LEIS OU REGULAMENTOS QUE DISCIPLINAM AS ATIVIDADES DE AGENTES AUXILIARES DO COMERCIO, DE ARMAZENS GERAIS E OUTROS SUJEITOS AO CONTROLE E FISCALIZACAO DOS ORGAOS DE REGISTRO DO COMERCIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.09.00', 'MUL. PREVISTAS NA LEGIS LUBRIF.E COMBUSTIVEIS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A COMBUSTIVEIS E LUBRIFICANTES. AS MULTAS SAO IMPOSTAS PELA AGENCIA NACIONAL DO PETROLEO-ANP.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.10.00', 'MULTAS POR INFRACAO A LEGIS. TRABALHISTA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE A LEGISLACAO TRABALHISTA, TAIS COMO: EXTRAVIO OU INUTILIZACAO DE CARTEIRA DE TRABALHO, FALTA DE REGISTRO DE EMPREGADO, PRORROGACAO DE JORNADA DE TRABALHO SEM ACORDO, PAGAMENTO DE SALARIO ATRASADO, INFRACOES AS NORMAS DE SEGURANCA E MEDICINA DO TRABALHO,ETC...', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.11.00', 'MULTAS PREVISTAS NA LEGISLAC. DE TRANSITO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A TRANSITO. CONSTITUEM VPA VINCULADA AO MINISTERIO DA JUSTICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.12.00', 'MUL. PREVISTAS NA LEG.SEG.DESEMP.AB. SALAR.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE A LEGISLACAO REFERENTE AO SEGURO-DESEMPREGO E AO ABONO SALARIAL. VPA CONSTITUIDA DO PRODUTO DOS ENCARGOS DEVIDO SPELOS CONTRIBUINTES, EM DECORRENCIA DE SUAS OBRIGACOES JUNTO AO PIS E AO PASEP. CONSTITUI RECURSO DO FUNDO DE AMPARO AO TRABALHADOR - FAT,VINCULADO AO MINISTERIO DO TRABALHO, SENDO DESTINADO AO CUSTEIO DO PROGRAMA DE SEGURO-DESEMPREGO, AO PAGAMENTO DO ABONO SALARIAL E AO FINANCIAMENTO DE PROGRAMAS DE DESENVOLVIMENTO ECONOMICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.13.01', 'MUL.PREV.LEGISL.S/DIREITOS DIFUSOS TRABALHIST', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE DIREITOS DIFUSOS TRABALHISTAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.13.02', 'MUL.PREV.LEGISL.S/DIREITOS DIFUSOS - OUTROS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE OUTROS DIREITOS DIFUSOS NAO ABRANGIDOS PELOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.14.00', 'MULTAS E JUROS PREVISTOS EM CONTRATOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS PREVISTOS EM CONTRATOS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.15.00', 'MULTAS DEC.OP.TRANSP.ROD.PASSAGEIROS E CARGAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES DAS LEGISLACOES DE OPERACAO DO TRANSPORTE RODOVIARIO DE PASSAGEIROS E CARGAS, BEM COMO DOS CONTRATOS DE CONCESSAO DE SERVICOS DE TRANSPORTE RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS E CARGAS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.16.00', 'MUL.PREVISTAS POR.INFR.LEGIS.TRANSP. FERROV.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO RECOLHIMENTO PELO MINISTERIO DOS TRANSPORTES DE MULTAS POR INFRACOES A DISPOSICOES PREVISTAS NO REGULAMENTO DE TRANSPORTE FERROVIARIOS E CONTRATOS DE CONCESSO-ES DE SERVICOS DE TRANSPORTE FERROVIARIO DE PASSAGEIROS E CARGAS. AMPARO LEGAL: DECRETO 04/96, DECRETO 1832/96.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.17.00', 'MULTAS PREVISTAS NO COD.BRAS. DE AERONAUTICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES PREVISTAS NO CODIGO BRASILEIRO DE AERONAUTICA (LEI 7565, DE19/12/86; LEI NUM. 9614, DE 05/03/98).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.18.00', 'MULTA DE TARIFA PEDAGIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS SOBREA TARIFA DE PEDAGIO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.19.00', 'MULTA DECOR.DE SENT.PENAL CONDENATORIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS SOBRE SENTENCAS PENAIS CONDENATORIAS COM TRANSITO EM JULGADO. OS RECURSOS DESTINAM-SE AO FUNPEN PARA FINANCIAR E APOIAR AS ATIVIDADES E PROGRAMAS DE MODERNIZACAO E APRIMORAMENTO DO SISTEMA PENITENCIARIO BRASILEIRO. DECRETO LEI NUM.79N DE 07/01/94.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.20.00', 'MULTA DE QUEBRA DE FIANCA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PROVENIENTES DE MULTAS DECORRENTES DE FIANCA QUEBRADA OU PERDIDA, EM CONFORMIDADE COM O DISPOSTO NA LEI PROCESSUAL PENAL. OS RECURSOS DESTINAM-SE AO FUNPEN PARA FINANCIAR E APOIAR AS ATIVIDADES E PROGRAMAS DE MODERNIZACAO E APRIMORAMENTO DO SISTEMA PENITENCIARIO BRASILEIRO. DECRETO LEI NUM.79N DE 07/01/94.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.21.00', 'MULTAS POR DANOS AO MEIO AMBIENTE', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS POR DANOS AO MEIO AMBIENTE. AMPARO LEGAL: LEI 9 605 DE 12FEV1998', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.22.00', 'MULTA E DE SEGURANCA PRIVADA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS POR INFRACOES PRATICADAS POR EMPRESAS PARTICULARES QUE EXPLOREM SERVICOS DE VIGILANCIA E DE TRANSPORTE DE VALORES (LEI 9017 DE 30/03/95).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.23.00', 'MULTA POR ATO ATENTATORIO AO EXERC JURISDICAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS QUE TEM COMO FATO GERADOR O NAO CUMPRIMENTO COM EXATIDAO DOS PROVIMENTOS MANDAMENTAIS OU A CRIACAO DE EMBARACOS A EFETIVACAO DE PROVIMENTOS JUDICIAIS DE NATUREZA ANTECIPATORIA OU FINAL. FUNDAMENTO LEGAL: LEI 5869/1973; LEI 5925/1973; LEI 8953/1994; LEI 10358/2001; LEI 11382/2006. DESTINACAO LEGAL: RECURSOS LIVRES PARA O TESOURO NACIONAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.24.00', 'MULTAS POR INFRACOES A LEG. CINEMATOGRAFICA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE NAO-PAGAMENTO NO TRANSCURSO DE PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DAS MULTAS POR INFRACOES A LEGISLACAO CINEMATOGRAFICA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.25.00', 'MUL.APLIC.PELOS TRIBUNAIS DE CONTAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS MULTAS APLICADAS PELOS TRIBUNAIS DE CONTAS, PELO NAO CUMPRIMENTO A DECISAO DOS MESMOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.26.00', 'MULT.PREV. LEG. S/ REG. PREV. PRIV. COMPLEM.', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PREVISTAS NA LEGISLACAO REG. PREV. PRIV. COMPLEM.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.27.00', 'MULTAS POR AUTOS DE INFRACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PUNITIVAS APLICADAS PELO NAO CUMPRIMENTO NOS CASOS PREVISTOS NOS REGULAMENTOS OU NOS CONTRATOS, OU PELA REINCIDENCIA EM FATOS QUE TENHAM GERADO ADVERTENCIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.28.00', 'MULTAS PREVISTAS NA LEGISLACAO MINERARIA', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS EXERCIDAS PELO PODER DE POLICIA PREVISTAS NA LEGISLACAO MINERARIA.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.29.00', 'MULTA POR FALTA/ATRASO NA APRESENTACAO GFIP', 'REGISTRA O VALOR DA VPA DECORRENTE DE MULTA POR FALTA OU ATRASO NA APRESENTACAO DA GUIA DE RECOLHIMENTO DO FUNDO DE GARANTIA DE TEMPO DE SERVICO E DE INFORMACOES A PREVIDENCIA SOCIAL - GFIP. PORTARIA Nº 09, DE 26/02/2010', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.99.00', 'OUTRAS MULTAS ADMINISTRATIVAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS MULTAS ADMINISTRATIVAS NAO ENQUADRADAS NAS CONTAS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.1.01.00', 'INDENIZ. POR DANOS CAUSADOS AO PATR. PUBLICO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR DANOS CAUSADOS AO PATRIMONIO PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.1.02.00', 'INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.1.03.00', 'INDENIZ. POSSE OU OCUPACAO ILIC. BENS UNIAO', 'REGISTRA O VALOR DOS RECURSOS RECEBIDOS COMO INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.1.99.00', 'OUTRAS INDENIZACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES QUE NAO SE ENQUADRAM NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.2.01.00', 'INDENIZ. POR DANOS CAUSADOS AO PATR. PUBLICO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR DANOS CAUSADOS AO PATRIMONIO PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.2.02.00', 'INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS .', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.2.03.00', 'INDENIZ. POSSE OU OCUPACAO ILIC. BENS UNIAO', 'REGISTRA O VALOR DOS RECURSOS RECEBIDOS COMO INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.2.99.00', 'OUTRAS INDENIZACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES QUE NAO SE ENQUADRAM NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.4.01.00', 'INDENIZ. POR DANOS CAUSADOS AO PATR. PUBLICO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR DANOS CAUSADOS AO PATRIMONIO PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.4.02.00', 'INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.4.03.00', 'INDENIZ. POSSE OU OCUPACAO ILIC. BENS UNIAO', 'REGISTRA O VALOR DOS RECURSOS RECEBIDOS COMO INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.4.99.00', 'OUTRAS INDENIZACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES QUE NAO SE ENQUADRAM NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.5.01.00', 'INDENIZ. POR DANOS CAUSADOS AO PATR. PUBLICO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR DANOS CAUSADOS AO PATRIMONIO PUBLICO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.5.02.00', 'INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.5.03.00', 'INDENIZ. POSSE OU OCUPACAO ILIC. BENS UNIAO', 'REGISTRA O VALOR DOS RECURSOS RECEBIDOS COMO INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.5.99.00', 'OUTRAS INDENIZACOES', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES QUE NAO SE ENQUADRAM NOS ITENS ANTERIORES.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.7.1.01.00', 'VPA DE LEILOES DE MERCADORIAS APREENDIDAS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LEILOES DE MERCADORIAS APREENDIDAS', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.7.1.02.00', 'VPA DE ALIENACAO DE BENS APREENDIDOS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALIENACAO DE BENS APREENDIDOS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.7.1.03.00', 'VPA DE ALIEN.BENS APREE.TRAF.ILIC.ENT.DROG.AFINS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA ALIENACAO DE BENS E VALORES QUE TENHAM SIDO OBJETO DE PERDIMENTO EM FAVOR DA UNIAO, ASSOCIADOS AO TRAFICO ILICITO DE ENTORPECENTES E DROGAS AFINS, INCLUSIVE AS GLEBAS DE QUALQUER REGIAO DO PAIS ONDE FOREM LOCALIZADAS CULTURAS ILEGAIS DE PLANTAS PSICOTROPICAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.01.01', 'VPA DE HONORARIOS DE ADVOGADOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO. O PRODUTO DESTA ARRECADACAO CONSTITUI RECEITA VINCULADA AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO FUNDAF.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.01.02', 'VPA DE ONUS DE SUCUMBENCIA ', 'REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA ADVINDA DE SENTENCA CONDENATORIA PAGA PELO VENCIDO AO VENCEDOR,AS DESPESAS QUE ANTECIPOU E OS HONORARIOS ADVOCATICIOS. (LEI N. 5.869,DE 11/01/73, ART. 20).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.02.00', 'PRODUTO DEPOSITO ABANDONADO(DINHEIRO/OBJETO VALOR)', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO PRODUTO DE DEPOSITOS ABANDONADOS (DINHEIRO E/OU OBJETOS DE VALOR) SENDO ORIGINARIA DA EXTINCAO DE CONTRATOS DE DEPOSITO REGULAR E VOLUNTARIO DE BENS DE QUALQUER ESPECIE POR RESCISAO DE PRAZO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.03.00', 'VPA DE BENS E VALORES PERDIDOS EM FAVOR UNIAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE BENS OU VALORES EM QUE SE TENHA DECRETADO PERDIMENTO EM FAVOR DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.04.00', 'VPA DECORRENTE NAO APLICACAO INCENTIVO FISCAL PROJ.CULT.IND.CIN', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA NAO APLICACAO OU NAO COMPROMETIMENTO INTEGRAL DE INCENTIVOS FISCAIS POR CONTRIBUINTES DA INDUSTRIA CINEMATOGRAFICA NACIONAL E EM PROJETOS CULTURAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.05.00', 'VPA DECORRENTE DE DIREITOS ANTIDUMPING E DIREITOS COMPENSAT', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA IMPOSICAO DE DIREITOS ANTIDUMPING E DE DIREITOS COMPENSATORIOS, COBRADA MEDIANTE A APLICACAO DE PERCENTUAL DA MARGEM DE DUMPING OU DO MONTANTE DE SUBSIDIOS SUFICIENTE PARA SANAR O DANO OU AMEACA DE DANO AA INDUSTRIA DOMESTICA BRASILEIRA. FATO GERADOR: APURACAO DE PRATICA DE DUMPING OU DE SUBSIDIOS ASSOCIADA AA EXISTENCIA DE DANO OU AMEACA DE DANO AA INDUSTRIA DOMESTICA. DESTINACAO LEGAL: MINISTERIO DO DESENVOLVIMENTO, INDUSTRIA E COMERCIO EXTERIOR, PARA APLICACAO NA AREA DE COMERCIO EXTERIOR, CONFORME DIRETRIZES ESTABELECIDAS PELA CAMARA DE COMERCIO EXTERIOR - CAMEX. AMPARO LEGAL: LEI 9.019/1995 E SUAS ALTERACOES; MP 2.158, DE 24 DE AGOSTO DE 2001; LEI 10.833, DE 29 DE DEZEMBRO DE 2003.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.0.00.00', 'VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.06.00', 'VPA PART. SEGURO-DPVAT-SIST.NAC. TRANSITO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO SEGURO OBRIGATORIO DE DANOS PESSOAIS CAUSADOS POR VEICULOS AUTOMOTORES DE VIA TERRESTRE - DPVAT. ARRECADADOS PELA REDE BANCARIA E REPASSADOS DIRETAMENTE E SEM QUALQUER RETENCAO, DA SEGUINTE FORMA: A) 45% (QUARENTA E CINCO POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO A CREDITO DIRETO DO FUNDO NACIONAL DE SAUDE, PARA CUSTEIO DA ASSISTENCIA MEDICO-HOSPITALAR DOS SEGURADOS VITIMADOS EM ACIDENTE DE TRANSITO, NOS TERMOS DO PARAGRAFO UNICO DO ART. 27 DA LEI 8.212, DE 24 DE JULHO DE 1991; B) 5% (CINCO POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO AO DEPARTAMENTO DE TRANSITO, POR MEIO DE CREDITO DIRETO A CONTA UNICA DO TESOU RO NACIONAL, PARA APLICACAO EXCLUSIVA EM PROGRAMAS DESTINADOS A PREVEN CAO DE ACIDENTES DE TRANSITO, NOS TERMOS DO PARAGRAFO UNICO DO ART. 78 DA LEI Nº9.503, DE 23 DE SETEMBRO DE 1997; C) 50% (CINQUENTA POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO A COMPANHIA SEGURADORA, NA FORMA DA REGULAMENTACAO VIGENTE. O PREMIO DO SEGURO OBRIGATORIO DE DANOS PESSOAIS CAUSADOS POR VEICULOS AUTOMOTORES DE VIAS TERRESTRES - DPVAT, SERA PAGO JUNTO COM A COTA UNICA, OU COM A PRIMEIRA PARCELA, DO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES - IPVA (DECRETO Nº 2.867, DE 8 DE DEZEMBRO DE 1998.)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.07.00', 'RESERVA GLOBAL DE REVERSAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA REFERENTE A RESERVA GLOBAL DE REVERSAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.08.00', 'COTA-PARTE DO SERV.NO FUNDO DE SAUDE MILITAR', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA QUE INCIDE SOBRE A REMUNERACAO DOS MILITARES E DESTINA-SE A CONSTITUICAO DE FUNDOS DE SAUDE, EM CADA UMA DAS FORCAS ARMADAS, QUE VISEM AO CUSTEIO DO ATENDIMENTO MEDICO-HOSPITALAR DE MILITARES E DE SEUS DEPENDENTES ( MP Nº 2.215-10, DE 31/08/01).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.09.00', 'CONTRIBUICAO VOLUNTARIA - MONTEPIO CIVIL', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE COTAS ARRECADADAS DE CADA MEMBRO ADQUIRENTE DO DIREITO DE, POR MORTE, DEIXAR PENSAO PAGAVEL A ALGUEM DE SUA ESCOLHA. DE COMPETENCIA DA UNIAO. CONTRIBUICAO EFETUADA POR FUNCIONARIOS PUBLICOS FEDERAIS (CIVIS) INSCRITOS NO MONTEPIO. CALCULADA COM BASE NOS VENCIMENTOS E ACRESCIMOS PERCEBIDOS MENSALMENTE PELO SERVIDOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.10.00', 'VPA DECORRENTE DA INDENIZACAO POR SINISTRO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA OCORRENCIA DE SINISTRO NAS OPERACOES GARANTIDAS POR MEIO DE SEGUROS, NOS CONTRATOS JUNTO A ENTIDADES LEGALMENTE CONSTITUIDAS COMO SEGURADORAS, NAS QUAIS O PODER PUBLICO FIGURE COMO SEGURADO - PAGAMENTO DO PREMIO. AMPARO LEGAL: LEI 10.406, DE 10 DE JANEIRO DE 2002 - CODIGO CIVIL (ARTS. 757 A 802).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.13.00', 'VPA DECORRENTE DE LEILAO DE COTAS DE IMPORTACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE LEILAO DE COTAS DE IMPORTACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.14.00', 'RECUPERACAO DE SINISTROS', 'REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DO PAGAMENTO DE PRESTACAO INADIMPLIDA QUE JA FOI OBJETO DE INDENIZACAO NAS OPERACOES AMPARADAS PELO SEGURO DECREDITO AA EXPORTACAO, COM RECURSOS ORCAMENTARIOS E FINANCEIROS ALOCADOS NO FUNDO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.15.01', 'PRESTACAO DE CONTAS - FONTES VEDADAS', 'REGISTRA OS RECURSOS DECORRENTES DA PRESTACAO DE CONTAS DE CAMPANHA ELEITORAL - FONTES VEDADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.15.02', 'PRESTACAO DE CONTAS-FONTES NAO IDENTIFICADAS', 'REGISTRA OS RECURSOS DECORRENTES DA PRESTACAO DE CONTAS DE CAMPANHA ELEITORAL - FONTES NAO IDENTIFICADAS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.16.00', 'REC.SUSPENSAO CONCESSAO DIR.PROPR.INTELECTUAL', 'COMPREENDE VARIACAO PATRIMONIAL AUMENTATIVAS DECORRENTE DE MEDIDAS DE SUSPENSAO DE CONCESSOES DOS DIREITOS DE PROPRIEDADE INTELECTUAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.2.01.01', 'VPA DE HONORARIOS DE ADVOGADOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO. O PRODUTO DESTA ARRECADACAO CONSTITUI RECEITA VINCULADA AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO FUNDAF.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.2.01.02', 'VPA DE ONUS DE SUCUMBENCIA ', 'REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA ADVINDA DE SENTENCA CONDENATORIA PAGA PELO VENCIDO AO VENCEDOR,AS DESPESAS QUE ANTECIPOU E OS HONORARIOS ADVOCATICIOS. (LEI N. 5.869,DE 11/01/73, ART. 20).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.2.02.00', 'PRODUTO DEPOSITO ABANDONADO(DINHEIRO/OBJETO VALOR)', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO PRODUTO DE DEPOSITOS ABANDONADOS (DINHEIRO E/OU OBJETOS DE VALOR) SENDO ORIGINARIA DA EXTINCAO DE CONTRATOS DE DEPOSITO REGULAR E VOLUNTARIO DE BENS DE QUALQUER ESPECIE POR RESCISAO DE PRAZO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.2.03.00', 'VPA DE BENS E VALORES PERDIDOS EM FAVOR UNIAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE BENS OU VALORES EM QUE SE TENHA DECRETADO PERDIMENTO EM FAVOR DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.2.04.00', 'VPA DECORRENTE NAO APLICACAO INCENTIVO FISCAL PROJ.CULT.IND.CIN', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA NAO APLICACAO OU NAO COMPROMETIMENTO INTEGRAL DE INCENTIVOS FISCAIS POR CONTRIBUINTES DA INDUSTRIA CINEMATOGRAFICA NACIONAL E EM PROJETOS CULTURAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.15.00', 'PRESTACAO DE CONTAS DE CAMPANHA ELEITORAL', 'COMPREENDE O VALOR RECURSOS DECORRENTES DA PRESTACAO DE CONTAS DE CAMPANHA ELEITORAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.2.05.00', 'VPA DECORRENTE DE DIREITOS ANTIDUMPING E DIREITOS COMPENSAT', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA IMPOSICAO DE DIREITOS ANTIDUMPING E DE DIREITOS COMPENSATORIOS, COBRADA MEDIANTE A APLICACAO DE PERCENTUAL DA MARGEM DE DUMPING OU DO MONTANTE DE SUBSIDIOS SUFICIENTE PARA SANAR O DANO OU AMEACA DE DANO AA INDUSTRIA DOMESTICA BRASILEIRA. FATO GERADOR: APURACAO DE PRATICA DE DUMPING OU DE SUBSIDIOS ASSOCIADA AA EXISTENCIA DE DANO OU AMEACA DE DANO AA INDUSTRIA DOMESTICA. DESTINACAO LEGAL: MINISTERIO DO DESENVOLVIMENTO, INDUSTRIA E COMERCIO EXTERIOR, PARA A- PLICACAO NA AREA DE COMERCIO EXTERIOR, CONFORME DIRETRIZES ESTABELECI- DAS PELA CAMARA DE COMERCIO EXTERIOR - CAMEX. AMPARO LEGAL: LEI 9.019/1995 E SUAS ALTERACOES; MP 2.158, DE 24 DE AGOSTO DE 2001; LEI 10.833, DE 29 DE DEZEMBRO DE 2003.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.2.06.00', 'VPA PART. SEGURO-DPVAT-SIST.NAC. TRANSITO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO SEGURO OBRIGATORIO DE DANOS PESSOAIS CAUSADOS POR VEICULOS AUTOMOTORES DE VIA TERRESTRE - DPVAT. ARRECADADOS PELA REDE BANCARIA E REPASSADOS DIRETAMENTE E SEM QUALQUER RETENCAO, DA SEGUINTE FORMA: A) 45% (QUARENTA E CINCO POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGU- RADO A CREDITO DIRETO DO FUNDO NACIONAL DE SAUDE, PARA CUSTEIO DA AS- SISTENCIA MEDICO-HOSPITALAR DOS SEGURADOS VITIMADOS EM ACIDENTE DE TRANSITO, NOS TERMOS DO PARAGRAFO UNICO DO ART. 27 DA LEI 8.212, DE 24 DE JULHO DE 1991; B) 5% (CINCO POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO AO DEPAR- TAMENTO DE TRANSITO, POR MEIO DE CREDITO DIRETO A CONTA UNICA DO TESOU RO NACIONAL, PARA APLICACAO EXCLUSIVA EM PROGRAMAS DESTINADOS A PREVEN CAO DE ACIDENTES DE TRANSITO, NOS TERMOS DO PARAGRAFO UNICO DO ART. 78 DA LEI Nº9.503, DE 23 DE SETEMBRO DE 1997; C) 50% (CINQUENTA POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO A COMPANHIA SEGURADORA, NA FORMA DA REGULAMENTACAO VIGENTE. O PREMIO DO SEGURO OBRIGATORIO DE DANOS PESSOAIS CAUSADOS POR VEICULOS AUTOMOTORES DE VIAS TERRESTRES - DPVAT, SERA PAGO JUNTO COM A COTA UNICA, OU COM A PRIMEIRA PARCELA, DO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES - IPVA (DECRETO Nº 2.867, DE 8 DE DEZEMBRO DE 1998.)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.2.07.00', 'RESERVA GLOBAL DE REVERSAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA REFERENTE A RESERVA GLOBAL DE REVERSAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.2.09.00', 'CONTRIBUICAO VOLUNTARIA - MONTEPIO CIVIL', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE COTAS ARRECADADAS DE CADA MEMBRO ADQUIRENTE DO DIREITO DE, POR MORTE, DEIXAR PENSAO PAGAVEL A ALGUEM DE SUA ESCOLHA. DE COMPETENCIA DA UNIAO. CONTRIBUICAO EFETUADA POR FUNCIONARIOS PUBLICOS FEDERAIS (CIVIS) INSCRITOS NO MONTEPIO. CALCULADA COM BASE NOS VENCIMENTOS E ACRESCIMOS PERCEBIDOS MENSALMENTE PELO SERVIDOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.2.10.00', 'VPA DECORRENTE DA INDENIZACAO POR SINISTRO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA OCORRENCIA DE SINISTRO NAS OPERACOES GARANTIDAS POR MEIO DE SEGUROS, NOS CONTRATOS JUNTO A ENTIDADES LEGALMENTE CONSTITUIDAS COMO SEGURADORAS, NAS QUAIS O PODER PUBLICO FIGURE COMO SEGURADO - PAGAMENTO DO PREMIO. AMPARO LEGAL: LEI 10.406, DE 10 DE JANEIRO DE 2002 - CODIGO CIVIL (ARTS. 757 A 802).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.2.13.00', 'VPA DECORRENTE DE LEILAO DE COTAS DE IMPORTACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE LEILAO DE COTAS DE IMPORTACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.2.16.00', 'REC.SUSPENSAO CONCESSAO DIR.PROPR.INTELECTUAL', 'COMPREENDE VARIACAO PATRIMONIAL AUMENTATIVAS DECORRENTE DE MEDIDAS DE SUSPENSAO DE CONCESSOES DOS DIREITOS DE PROPRIEDADE INTELECTUAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.01.01', 'VPA DE HONORARIOS DE ADVOGADOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO. O PRODUTO DESTA ARRECADACAO CONSTITUI RECEITA VINCULADA AO FUNDO ESPECI- AL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO FUNDAF.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.01.02', 'VPA DE ONUS DE SUCUMBENCIA ', 'REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA ADVINDA DE SENTENCA CONDENATORIA PAGA PELO VENCIDO AO VENCEDOR,AS DESPESAS QUE ANTECIPOU E OS HONORARIOS ADVOCATICIOS. (LEI N. 5.869,DE 11/01/73, ART. 20).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.02.00', 'PRODUTO DEPOSITO ABANDONADO(DINHEIRO/OBJETO VALOR)', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO PRODUTO DE DEPOSITOS ABANDONADOS (DINHEIRO E/OU OBJETOS DE VALOR) SENDO ORIGINARIA DA EXTINCAO DE CONTRATOS DE DEPOSITO REGULAR E VOLUNTARIO DE BENS DE QUALQUER ESPECIE POR RESCISAO DE PRAZO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.03.00', 'VPA DE BENS E VALORES PERDIDOS EM FAVOR UNIAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE BENS OU VALORES EM QUE SE TENHA DECRETADO PERDIMENTO EM FAVOR DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.04.00', 'VPA DECORRENTE NAO APLICACAO INCENTIVO FISCAL PROJ.CULT.IND.CIN', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA NAO APLICACAO OU NAO COMPROMETIMENTO INTEGRAL DE INCENTIVOS FISCAIS POR CONTRIBUINTES DA INDUSTRIA CINEMATOGRAFICA NACIONAL E EM PROJETOS CULTURAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.05.00', 'VPA DECORRENTE DE DIREITOS ANTIDUMPING E DIREITOS COMPENSATORIOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA IMPOSICAO DE DIREITOS ANTIDUMPING E DE DIREITOS COMPENSATORIOS, COBRADA MEDIANTE A APLICACAO DE PERCENTUAL DA MARGEM DE DUMPING OU DO MONTANTE DE SUBSIDIOS SUFICIENTE PARA SANAR O DANO OU AMEACA DE DANO AA INDUSTRIA DOMESTICA BRASILEIRA. FATO GERADOR: APURACAO DE PRATICA DE DUMPING OU DE SUBSIDIOS ASSOCIADA AA EXISTENCIA DE DANO OU AMEACA DE DANO AA INDUSTRIA DOMESTICA. DESTINACAO LEGAL: MINISTERIO DO DESENVOLVIMENTO, INDUSTRIA E COMERCIO EXTERIOR, PARA APLICACAO NA AREA DE COMERCIO EXTERIOR, CONFORME DIRETRIZES ESTABELECIDAS PELA CAMARA DE COMERCIO EXTERIOR - CAMEX. AMPARO LEGAL: LEI 9.019/1995 E SUAS ALTERACOES; MP 2.158, DE 24 DE AGOSTO DE 2001; LEI 10.833, DE 29 DE DEZEMBRO DE 2003.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.06.00', 'VPA PART. SEGURO-DPVAT-SIST.NAC. TRANSITO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO SEGURO OBRIGATORIO DE DANOS PESSOAIS CAUSADOS POR VEICULOS AUTOMOTORES DE VIA TERRESTRE - DPVAT. ARRECADADOS PELA REDE BANCARIA E REPASSADOS DIRETAMENTE E SEM QUALQUER RETENCAO, DA SEGUINTE FORMA: A) 45% (QUARENTA E CINCO POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO A CREDITO DIRETO DO FUNDO NACIONAL DE SAUDE, PARA CUSTEIO DA ASSISTENCIA MEDICO-HOSPITALAR DOS SEGURADOS VITIMADOS EM ACIDENTE DE TRANSITO, NOS TERMOS DO PARAGRAFO UNICO DO ART. 27 DA LEI 8.212, DE 24 DE JULHO DE 1991; B) 5% (CINCO POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO AO DEPARTAMENTO DE TRANSITO, POR MEIO DE CREDITO DIRETO A CONTA UNICA DO TESOURO NACIONAL, PARA APLICACAO EXCLUSIVA EM PROGRAMAS DESTINADOS A PREVENCAO DE ACIDENTES DE TRANSITO, NOS TERMOS DO PARAGRAFO UNICO DO ART. 78 DA LEI Nº9.503, DE 23 DE SETEMBRO DE 1997; C) 50% (CINQUENTA POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO A COMPANHIA SEGURADORA, NA FORMA DA REGULAMENTACAO VIGENTE. O PREMIO DO SEGURO OBRIGATORIO DE DANOS PESSOAIS CAUSADOS POR VEICULOS AUTOMOTORES DE VIAS TERRESTRES - DPVAT, SERA PAGO JUNTO COM A COTA UNICA, OU COM A PRIMEIRA PARCELA, DO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES - IPVA (DECRETO Nº 2.867, DE 8 DE DEZEMBRO DE 1998.)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.07.00', 'RESERVA GLOBAL DE REVERSAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA REFERENTE A RESERVA GLOBAL DE REVERSAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.08.00', 'COTA-PARTE DO SERV.NO FUNDO DE SAUDE MILITAR', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA QUE INCIDE SOBRE A REMUNERACAO DOS MILITARES E DESTINA-SE A CONSTITUICAO DE FUNDOS DE SAUDE, EM CADA UMA DAS FORCAS ARMADAS, QUE VISEM AO CUSTEIO DO ATENDIMENTO MEDICO-HOSPITALAR DE MILITARES E DE SEUS DEPENDENTES ( MP Nº 2.215-10, DE 31/08/01).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.09.00', 'CONTRIBUICAO VOLUNTARIA - MONTEPIO CIVIL', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE COTAS ARRECADADAS DE CADA MEMBRO ADQUIRENTE DO DIREITO DE, POR MORTE, DEIXAR PENSAO PAGAVEL A ALGUEM DE SUA ESCOLHA. DE COMPETENCIA DA UNIAO. CONTRIBUICAO EFETUADA POR FUNCIONARIOS PUBLICOS FEDERAIS (CIVIS) INSCRITOS NO MONTEPIO. CALCULADA COM BASE NOS VENCIMENTOS E ACRESCIMOS PERCEBIDOS MENSALMENTE PELO SERVIDOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.10.00', 'VPA DECORRENTE DA INDENIZACAO POR SINISTRO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA OCORRENCIA DE SINISTRO NAS OPERACOES GARANTIDAS POR MEIO DE SEGUROS, NOS CONTRATOS JUNTO A ENTIDADES LEGALMENTE CONSTITUIDAS COMO SEGURADORAS, NAS QUAIS O PODER PUBLICO FIGURE COMO SEGURADO - PAGAMENTO DO PREMIO. AMPARO LEGAL: LEI 10.406, DE 10 DE JANEIRO DE 2002 - CODIGO CIVIL (ARTS. 757 A 802).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.13.00', 'VPA DECORRENTE DE LEILAO DE COTAS DE IMPORTACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE LEILAO DE COTAS DE IMPORTACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.16.00', 'REC.SUSPENSAO CONCESSAO DIR.PROPR.INTELECTUAL', 'COMPREENDE VARIACAO PATRIMONIAL AUMENTATIVAS DECORRENTE DE MEDIDAS DE SUSPENSAO DE CONCESSOES DOS DIREITOS DE PROPRIEDADE INTELECTUAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.01.01', 'VPA DE HONORARIOS DE ADVOGADOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO. O PRODUTO DESTA ARRECADACAO CONSTITUI RECEITA VINCULADA AO FUNDO ESPECI- AL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO FUNDAF.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.01.02', 'VPA DE ONUS DE SUCUMBENCIA ', 'REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA ADVINDA DE SENTENCA CONDENATORIA PAGA PELO VENCIDO AO VENCEDOR,AS DESPESAS QUE ANTECIPOU E OS HONORARIOS ADVOCATICIOS. (LEI N. 5.869,DE 11/01/73, ART. 20).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.02.00', 'PRODUTO DEPOSITO ABANDONADO(DINHEIRO/OBJETO VALOR)', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO PRODUTO DE DEPOSITOS ABANDONADOS (DINHEIRO E/OU OBJETOS DE VALOR) SENDO ORIGINARIA DA EXTINCAO DE CONTRATOS DE DEPOSITO REGULAR E VOLUNTARIO DE BENS DE QUALQUER ESPECIE POR RESCISAO DE PRAZO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.03.00', 'VPA DE BENS E VALORES PERDIDOS EM FAVOR UNIAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE BENS OU VALORES EM QUE SE TENHA DECRETADO PERDIMENTO EM FAVOR DA UNIAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.04.00', 'VPA DECORRENTE NAO APLICACAO INCENTIVO FISCAL PROJ.CULT.IND.CIN', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA NAO APLICACAO OU NAO COMPROMETIMENTO INTEGRAL DE INCENTIVOS FISCAIS POR CONTRIBUINTES DA INDUSTRIA CINEMATOGRAFICA NACIONAL E EM PROJETOS CULTURAIS.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.05.00', 'VPA DECORRENTE DE DIREITOS ANTIDUMPING E DIREITOS COMPENSATORIOS', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA IMPOSICAO DE DIREITOS ANTIDUMPING E DE DIREITOS COMPENSATORIOS, COBRADA MEDIANTE A APLICACAO DE PERCENTUAL DA MARGEM DE DUMPING OU DO MONTANTE DE SUBSIDIOS SUFICIENTE PARA SANAR O DANO OU AMEACA DE DANO AA INDUSTRIA DOMESTICA BRASILEIRA. FATO GERADOR: APURACAO DE PRATICA DE DUMPING OU DE SUBSIDIOS ASSOCIADA AA EXISTENCIA DE DANO OU AMEACA DE DANO AA INDUSTRIA DOMESTICA. DESTINACAO LEGAL: MINISTERIO DO DESENVOLVIMENTO, INDUSTRIA E COMERCIO EXTERIOR, PARA APLICACAO NA AREA DE COMERCIO EXTERIOR, CONFORME DIRETRIZES ESTABELECIDAS PELA CAMARA DE COMERCIO EXTERIOR - CAMEX. AMPARO LEGAL: LEI 9.019/1995 E SUAS ALTERACOES; MP 2.158, DE 24 DE AGOSTO DE 2001; LEI 10.833, DE 29 DE DEZEMBRO DE 2003.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.06.00', 'VPA PART. SEGURO-DPVAT-SIST.NAC. TRANSITO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO SEGURO OBRIGATORIO DE DANOS PESSOAIS CAUSADOS POR VEICULOS AUTOMOTORES DE VIA TERRESTRE - DPVAT. ARRECADADOS PELA REDE BANCARIA E REPASSADOS DIRETAMENTE E SEM QUALQUER RETENCAO, DA SEGUINTE FORMA: A) 45% (QUARENTA E CINCO POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO A CREDITO DIRETO DO FUNDO NACIONAL DE SAUDE, PARA CUSTEIO DA ASSISTENCIA MEDICO-HOSPITALAR DOS SEGURADOS VITIMADOS EM ACIDENTE DE TRANSITO, NOS TERMOS DO PARAGRAFO UNICO DO ART. 27 DA LEI 8.212, DE 24 DE JULHO DE 1991; B) 5% (CINCO POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO AO DEPARTAMENTO DE TRANSITO, POR MEIO DE CREDITO DIRETO A CONTA UNICA DO TESOURO NACIONAL, PARA APLICACAO EXCLUSIVA EM PROGRAMAS DESTINADOS A PREVENCAO DE ACIDENTES DE TRANSITO, NOS TERMOS DO PARAGRAFO UNICO DO ART. 78 DA LEI Nº9.503, DE 23 DE SETEMBRO DE 1997; C) 50% (CINQUENTA POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO A COMPANHIA SEGURADORA, NA FORMA DA REGULAMENTACAO VIGENTE. O PREMIO DO SEGURO OBRIGATORIO DE DANOS PESSOAIS CAUSADOS POR VEICULOS AUTOMOTORES DE VIAS TERRESTRES - DPVAT, SERA PAGO JUNTO COM A COTA UNICA, OU COM A PRIMEIRA PARCELA, DO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES - IPVA (DECRETO Nº 2.867, DE 8 DE DEZEMBRO DE 1998.)', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.07.00', 'RESERVA GLOBAL DE REVERSAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA REFERENTE A RESERVA GLOBAL DE REVERSAO.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.08.00', 'COTA-PARTE DO SERV.NO FUNDO DE SAUDE MILITAR', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA QUE INCIDE SOBRE A REMUNERACAO DOS MILITARES E DESTINA-SE A CONSTITUICAO DE FUNDOS DE SAUDE, EM CADA UMA DAS FORCAS ARMADAS, QUE VISEM AO CUSTEIO DO ATENDIMENTO MEDICO-HOSPITALAR DE MILITARES E DE SEUS DEPENDENTES ( MP Nº 2.215-10, DE 31/08/01).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.09.00', 'CONTRIBUICAO VOLUNTARIA - MONTEPIO CIVIL', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE COTAS ARRECADADAS DE CADA MEMBRO ADQUIRENTE DO DIREITO DE, POR MORTE, DEIXAR PENSAO PAGAVEL A ALGUEM DE SUA ESCOLHA. DE COMPETENCIA DA UNIAO. CONTRIBUICAO EFETUADA POR FUNCIONARIOS PUBLICOS FEDERAIS (CIVIS) INSCRITOS NO MONTEPIO. CALCULADA COM BASE NOS VENCIMENTOS E ACRESCIMOS PERCEBIDOS MENSALMENTE PELO SERVIDOR.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.10.00', 'VPA DECORRENTE DA INDENIZACAO POR SINISTRO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA OCORRENCIA DE SINISTRO NAS OPERACOES GARANTIDAS POR MEIO DE SEGUROS, NOS CONTRATOS JUNTO A ENTIDADES LEGALMENTE CONSTITUIDAS COMO SEGURADORAS, NAS QUAIS O PODER PUBLICO FIGURE COMO SEGURADO - PAGAMENTO DO PREMIO. AMPARO LEGAL: LEI 10.406, DE 10 DE JANEIRO DE 2002 - CODIGO CIVIL (ARTS. 757 A 802).', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.13.00', 'VPA DECORRENTE DE LEILAO DE COTAS DE IMPORTACAO', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE LEILAO DE COTAS DE IMPORTACAO', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.16.00', 'REC.SUSPENSAO CONCESSAO DIR.PROPR.INTELECTUAL', 'COMPREENDE VARIACAO PATRIMONIAL AUMENTATIVAS DECORRENTE DE MEDIDAS DE SUSPENSAO DE CONCESSOES DOS DIREITOS DE PROPRIEDADE INTELECTUAL.', 'C', 'S', 'P', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA NO PAIS, POR ORGAOS E ENTIDADES, PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.19', 'GARANTIAS DA DIVIDA PUBLICA', 'REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DIVIDA DE MEDIO E LONGO PRAZOS-DMLP, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.22', 'APOLICES DE SEGUROS', 'REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.25', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.19', 'GARANTIAS DA DIVIDA PUBLICA', 'REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DIVIDA DE MEDIO E LONGO PRAZOS-DMLP, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.22', 'APOLICES DE SEGUROS', 'REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.25', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.03.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS TERCEIROS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.03.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.04.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS EM VIRTUDE DE GARANTIAS INSTITUI-DAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.04.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.01.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.01.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA NO PAIS, POR ORGAOS E ENTIDADES, PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.01.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.01.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.01.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.01.19', 'GARANTIAS DA DIVIDA PUBLICA', 'REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DIVIDA DE MEDIO E LONGO PRAZOS-DMLP, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.01.22', 'APOLICES DE SEGUROS', 'REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.01.25', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.02.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.02.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.02.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.02.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.02.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.02.19', 'GARANTIAS DA DIVIDA PUBLICA', 'REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DIVIDA DE MEDIO E LONGO PRAZOS-DMLP, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.02.22', 'APOLICES DE SEGUROS', 'REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.02.25', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.03.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS TERCEIROS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.03.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.04.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS EM VIRTUDE DE GARANTIAS INSTITUI-DAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.04.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.01.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.01.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA NO PAIS, POR ORGAOS E ENTIDADES, PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.01.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.01.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.01.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.01.19', 'GARANTIAS DA DIVIDA PUBLICA', 'REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DIVIDA DE MEDIO E LONGO PRAZOS-DMLP, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.01.22', 'APOLICES DE SEGUROS', 'REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.01.25', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.02.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.02.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.02.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.02.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.02.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.02.19', 'GARANTIAS DA DIVIDA PUBLICA', 'REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DIVIDA DE MEDIO E LONGO PRAZOS-DMLP, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.02.22', 'APOLICES DE SEGUROS', 'REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.02.25', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.03.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS TERCEIROS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.03.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.04.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS EM VIRTUDE DE GARANTIAS INSTITUI-DAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.04.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.01.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.01.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA NO PAIS, POR ORGAOS E ENTIDADES, PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.01.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.01.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.01.19', 'GARANTIAS DA DIVIDA PUBLICA', 'REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DIVIDA DE MEDIO E LONGO PRAZOS-DMLP, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.01.22', 'APOLICES DE SEGUROS', 'REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.01.25', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.02.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.02.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.02.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.02.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.02.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.02.19', 'GARANTIAS DA DIVIDA PUBLICA', 'REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DIVIDA DE MEDIO E LONGO PRAZOS-DMLP, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.02.22', 'APOLICES DE SEGUROS', 'REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.02.25', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.03.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS TERCEIROS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.03.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.04.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS EM VIRTUDE DE GARANTIAS INSTITUI-DAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.04.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.1.01.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.1.02.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.1.03.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.2.01.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.2.02.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.2.03.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.4.01.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.4.02.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.4.03.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.5.01.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.5.02.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.5.03.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.01.00', 'CONTRATOS DE SEGUROS', 'REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.02.00', 'CONTRATOS DE SERVICOS', 'REGISTRA O VALOR DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.03.00', 'CONTRATOS DE ALUGUEIS', 'REGISTRA O VALOR DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'REGISTRA O VALOR DO CONTRATO DE OBRIGACAO DA ENTEDADE PUBLICA COM TERCEIROS REFEREN-E A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.06.00', 'CONTRATOS DE OBRIGACOES INTERNAS', 'REGISTRA O VALOR DO CONTRATO REFERENTE A OBRIGACAO INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.07.00', 'CONTRATOS DE OBRIGACOES EXTERNAS', 'REGISTRA O VALOR DE CONTRATO REFERENTE A OBRIGACOES DA DIVIDA E DAS OPERACOES DE CREDITO EXTERNAS CONTRATADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.08.00', 'TERMOS/ACOR.P/FOR. BENS C/PERM.SERV.S/EXE.ORC', 'REGISTRA O VALOR DE TERMOS E ACORDOS COM FORNECIMENTO DE BENS SEM SUPORTE ORCAMENTARIO. COMPENSACAO PATRIMONIAL COM PERMUTA DE SERVICOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.2.01.00', 'CONTRATOS DE SEGUROS', 'REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.2.02.00', 'CONTRATOS DE SERVICOS', 'REGISTRA O VALOR DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.2.03.00', 'CONTRATOS DE ALUGUEIS', 'REGISTRA O VALOR DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.2.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.2.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'REGISTRA O VALOR DO CONTRATO DE OBRIGACAO DA ENTEDADE PUBLICA COM TERCEIROS REFEREN-E A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.2.06.00', 'CONTRATOS DE OBRIGACOES INTERNAS', 'REGISTRA O VALOR DO CONTRATO REFERENTE A OBRIGACAO INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.2.07.00', 'CONTRATOS DE OBRIGACOES EXTERNAS', 'REGISTRA O VALOR DE CONTRATO REFERENTE A OBRIGACOES DA DIVIDA E DAS OPERACOES DE CREDITO EXTERNAS CONTRATADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.2.08.00', 'TERMOS/ACOR.P/FOR. BENS C/PERM.SERV.S/EXE.ORC', 'REGISTRA O VALOR DE TERMOS E ACORDOS COM FORNECIMENTO DE BENS SEM SUPORTE ORCAMENTARIO. COMPENSACAO PATRIMONIAL COM PERMUTA DE SERVICOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.4.01.00', 'CONTRATOS DE SEGUROS', 'REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.4.02.00', 'CONTRATOS DE SERVICOS', 'REGISTRA O VALOR DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.4.03.00', 'CONTRATOS DE ALUGUEIS', 'REGISTRA O VALOR DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.4.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.4.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'REGISTRA O VALOR DO CONTRATO DE OBRIGACAO DA ENTEDADE PUBLICA COM TERCEIROS REFEREN-E A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.4.06.00', 'CONTRATOS DE OBRIGACOES INTERNAS', 'REGISTRA O VALOR DO CONTRATO REFERENTE A OBRIGACAO INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.4.07.00', 'CONTRATOS DE OBRIGACOES EXTERNAS', 'REGISTRA O VALOR DE CONTRATO REFERENTE A OBRIGACOES DA DIVIDA E DAS OPERACOES DE CREDITO EXTERNAS CONTRATADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.4.08.00', 'TERMOS/ACOR.P/FOR. BENS C/PERM.SERV.S/EXE.ORC', 'REGISTRA O VALOR DE TERMOS E ACORDOS COM FORNECIMENTO DE BENS SEM SUPORTE ORCAMENTARIO. COMPENSACAO PATRIMONIAL COM PERMUTA DE SERVICOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.5.01.00', 'CONTRATOS DE SEGUROS', 'REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.5.02.00', 'CONTRATOS DE SERVICOS', 'REGISTRA O VALOR DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.5.03.00', 'CONTRATOS DE ALUGUEIS', 'REGISTRA O VALOR DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.5.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.5.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'REGISTRA O VALOR DO CONTRATO DE OBRIGACAO DA ENTEDADE PUBLICA COM TERCEIROS REFEREN-E A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.5.06.00', 'CONTRATOS DE OBRIGACOES INTERNAS', 'REGISTRA O VALOR DO CONTRATO REFERENTE A OBRIGACAO INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.5.07.00', 'CONTRATOS DE OBRIGACOES EXTERNAS', 'REGISTRA O VALOR DE CONTRATO REFERENTE A OBRIGACOES DA DIVIDA E DAS OPERACOES DE CREDITO EXTERNAS CONTRATADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.5.08.00', 'TERMOS/ACOR.P/FOR. BENS C/PERM.SERV.S/EXE.ORC', 'REGISTRA O VALOR DE TERMOS E ACORDOS COM FORNECIMENTO DE BENS SEM SUPORTE ORCAMENTARIO. COMPENSACAO PATRIMONIAL COM PERMUTA DE SERVICOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.9.1.00.00', 'OUTROS ATOS POTENCIAIS ATIVO - CONSOLIDACAO', 'COMPREENDE OS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.9.2.00.00', 'OUTROS ATOS POTENCIAIS ATIVO - INTRA OFSS', 'COMPREENDE OS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.9.4.00.00', 'OUTROS ATOS POTENCIAIS ATIVO - INTER OFSS - ESTADO', 'COMPREENDE OS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.9.5.00.00', 'OUTROS ATOS POTENCIAIS ATIVO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA A TERCEIROS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS CONCEDIDOS EM CAUCAO, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.19', 'OUTRAS GARANTIAS CONCEDIDAS', 'REGISTRA O VALOR REFERENTE A OUTRAS GARANTIAS CONCEDIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA A TERCEIROS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS CONCEDIDOS EM CAUCAO, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.19', 'OUTRAS GARANTIAS CONCEDIDAS', 'REGISTRA O VALOR REFERENTE A OUTRAS GARANTIAS CONCEDIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.03.01', 'CONTRAGARANTIAS SOBRE AVAIS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.03.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.04.01', 'CONTRAGARANTIAS SOBRE AVAIS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.04.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.01.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA A TERCEIROS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.01.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.01.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.01.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.01.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS CONCEDIDOS EM CAUCAO, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.01.19', 'OUTRAS GARANTIAS CONCEDIDAS', 'REGISTRA O VALOR REFERENTE A OUTRAS GARANTIAS CONCEDIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.02.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA A TERCEIROS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.02.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.02.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.02.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.02.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS CONCEDIDOS EM CAUCAO, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.02.19', 'OUTRAS GARANTIAS CONCEDIDAS', 'REGISTRA O VALOR REFERENTE A OUTRAS GARANTIAS CONCEDIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.03.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.04.01', 'CONTRAGARANTIAS SOBRE AVAIS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.04.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.01.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA A TERCEIROS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.01.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.01.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.01.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.01.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS CONCEDIDOS EM CAUCAO, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.01.19', 'OUTRAS GARANTIAS CONCEDIDAS', 'REGISTRA O VALOR REFERENTE A OUTRAS GARANTIAS CONCEDIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.02.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA A TERCEIROS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.02.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.02.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.02.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.02.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS CONCEDIDOS EM CAUCAO, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.02.19', 'OUTRAS GARANTIAS CONCEDIDAS', 'REGISTRA O VALOR REFERENTE A OUTRAS GARANTIAS CONCEDIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.03.01', 'CONTRAGARANTIAS SOBRE AVAIS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.03.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.04.01', 'CONTRAGARANTIAS SOBRE AVAIS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.04.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.01.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA A TERCEIROS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.01.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.01.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.01.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS CONCEDIDOS EM CAUCAO, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.01.19', 'OUTRAS GARANTIAS CONCEDIDAS', 'REGISTRA O VALOR REFERENTE A OUTRAS GARANTIAS CONCEDIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.02.01', 'AVAIS', 'REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA A TERCEIROS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.02.04', 'FIANCAS', 'REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.02.07', 'HIPOTECAS', 'REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.02.10', 'SEGUROS-GARANTIA', 'REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.02.13', 'CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS CONCEDIDOS EM CAUCAO, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.02.19', 'OUTRAS GARANTIAS CONCEDIDAS', 'REGISTRA O VALOR REFERENTE A OUTRAS GARANTIAS CONCEDIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.03.01', 'CONTRAGARANTIAS SOBRE AVAIS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS, NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.03.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.04.01', 'CONTRAGARANTIAS SOBRE AVAIS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA', 'REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.04.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR, NAO INCLUIDAS NOS ITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.1.01.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADOS NO PORTAL/SICONV, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.1.02.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR FIRMADO DOS CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.1.03.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO FIRMADOS NO AMBITO DA AGENCIA NACIONAL DE CINEMA - ANCINE E DO MINISTERIO DO TRABALHO E EMPREGO - MTE, RESPECTIVAMENTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.1.04.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADOS NO PORTAL/SICONV, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.2.01.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.2.02.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR FIRMADO DOS CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.2.03.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO FIRMADOS NO AMBITO DA AGENCIA NACIONAL DE CINEMA - ANCINE E DO MINISTERIO DO TRABALHO E EMPREGO - MTE, RESPECTIVAMENTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.2.04.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADOS NO PORTAL/SICONV, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.4.01.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.4.02.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR FIRMADO DOS CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.4.03.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO FIRMADOS NO AMBITO DA AGENCIA NACIONAL DE CINEMA - ANCINE E DO MINISTERIO DO TRABALHO E EMPREGO - MTE, RESPECTIVAMENTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.4.04.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADOS NO PORTAL/SICONV, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.5.01.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.5.02.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR FIRMADO DOS CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.5.03.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO FIRMADOS NO AMBITO DA AGENCIA NACIONAL DE CINEMA - ANCINE E DO MINISTERIO DO TRABALHO E EMPREGO - MTE, RESPECTIVAMENTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.5.04.01', 'VALORES FIRMADOS', 'REGISTRA O VALOR TOTAL DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADOS NO PORTAL/SICONV, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.01.00', 'CONTRATOS DE SEGUROS', 'REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.02.00', 'CONTRATOS DE SERVICOS', 'REGISTRA O VALOR DO CONTRATO ASSINADO ENTRE A ADMINISTRACAO PUBLICA E O PRESTADOR DE SERVICOS A TITULO DE OBRAS E INSTALACAO E DEMAIS SERVICOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.03.00', 'CONTRATOS DE ALUGUEIS', 'REGISTRA O VALOR DO CONTRATO DE LOCACAO DE BENS MOVEIS E IMOVEIS ENTRE A ADMINISTRACAO E TERCEIROS LOCADORES DE TAIS BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS ENTRE A ADMINISTRACAO E O FORNECEDOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'REGISTRA A APROPRIACAO DE AJUSTE OU ASSINATURA DE CONTRATOS DE CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.06.00', 'CONTRATOS DE EMPRESTIMOS DO OOOC', 'REGISTRA O SOMATORIO DOS VALORES DOS CONTRATOS ASSINADOS, A LIBERAR ELIBERADOS PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO - OOOC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.07.00', 'OPERACOES C/ BENS E SERVICOS NO EXTERIOR COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DAS OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.08.00', 'CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE SEGUROS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.09.00', 'CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.10.00', 'CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE ALUGUEIS COM CONROLE POR PC OU RC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.11.00', 'CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.12.00', 'CONTRATO DE GESTAO', 'COMPREENDE AS CONTAS QUE REGISTRAM OS CONTRATOS DE GESTAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.13.01', 'VALOR FIRMADO', 'REGISTRO DO VALOR TOTAL DO ACORDO FIRMADO COM ORGANISMOS INTERNACIONAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.14.00', 'CONTRATOS DE OPERACOES DE CREDITO', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.01.00', 'CONTRATOS DE SEGUROS', 'REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.02.00', 'CONTRATOS DE SERVICOS', 'REGISTRA O VALOR DO CONTRATO ASSINADO ENTRE A ADMINISTRACAO PUBLICA E O PRESTADOR DE SERVICOS A TITULO DE OBRAS E INSTALACAO E DEMAIS SERVICOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.03.00', 'CONTRATOS DE ALUGUEIS', 'REGISTRA O VALOR DO CONTRATO DE LOCACAO DE BENS MOVEIS E IMOVEIS ENTRE A ADMINISTRACAO E TERCEIROS LOCADORES DE TAIS BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS ENTRE A ADMINISTRACAO E O FORNECEDOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'REGISTRA A APROPRIACAO DE AJUSTE OU ASSINATURA DE CONTRATOS DE CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.06.00', 'CONTRATOS DE EMPRESTIMOS DO OOOC', 'REGISTRA O SOMATORIO DOS VALORES DOS CONTRATOS ASSINADOS, A LIBERAR ELIBERADOS PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO - OOOC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.07.00', 'OPERACOES C/ BENS E SERVICOS NO EXTERIOR COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DAS OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.08.00', 'CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE SEGUROS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.09.00', 'CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.10.00', 'CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.11.00', 'CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.12.00', 'CONTRATO DE GESTAO', 'COMPREENDE AS CONTAS QUE REGISTRAM OS CONTRATOS DE GESTAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.13.01', 'VALOR FIRMADO', 'REGISTRO DO VALOR TOTAL DO ACORDO FIRMADO COM ORGANISMOS INTERNACIONAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.14.00', 'CONTRATOS DE OPERACOES DE CREDITO', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.01.00', 'CONTRATOS DE SEGUROS', 'REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.02.00', 'CONTRATOS DE SERVICOS', 'REGISTRA O VALOR DO CONTRATO ASSINADO ENTRE A ADMINISTRACAO PUBLICA E O PRESTADOR DE SERVICOS A TITULO DE OBRAS E INSTALACAO E DEMAIS SERVICOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.03.00', 'CONTRATOS DE ALUGUEIS', 'REGISTRA O VALOR DO CONTRATO DE LOCACAO DE BENS MOVEIS E IMOVEIS ENTRE A ADMINISTRACAO E TERCEIROS LOCADORES DE TAIS BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS ENTRE A ADMINISTRACAO E O FORNECEDOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'REGISTRA A APROPRIACAO DE AJUSTE OU ASSINATURA DE CONTRATOS DE CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.06.00', 'CONTRATOS DE EMPRESTIMOS DO OOOC', 'REGISTRA O SOMATORIO DOS VALORES DOS CONTRATOS ASSINADOS, A LIBERAR ELIBERADOS PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO - OOOC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.07.00', 'OPERACOES C/ BENS E SERVICOS NO EXTERIOR COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DAS OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.08.00', 'CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE SEGUROS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.09.00', 'CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.10.00', 'CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.11.00', 'CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.12.00', 'CONTRATO DE GESTAO', 'COMPREENDE AS CONTAS QUE REGISTRAM OS CONTRATOS DE GESTAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.13.01', 'VALOR FIRMADO', 'REGISTRO DO VALOR TOTAL DO ACORDO FIRMADO COM ORGANISMOS INTERNACIONAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.14.00', 'CONTRATOS DE OPERACOES DE CREDITO', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.01.00', 'CONTRATOS DE SEGUROS', 'REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.02.00', 'CONTRATOS DE SERVICOS', 'REGISTRA O VALOR DO CONTRATO ASSINADO ENTRE A ADMINISTRACAO PUBLICA E O PRESTADOR DE SERVICOS A TITULO DE OBRAS E INSTALACAO E DEMAIS SERVICOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.03.00', 'CONTRATOS DE ALUGUEIS', 'REGISTRA O VALOR DO CONTRATO DE LOCACAO DE BENS MOVEIS E IMOVEIS ENTRE A ADMINISTRACAO E TERCEIROS LOCADORES DE TAIS BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS ENTRE A ADMINISTRACAO E O FORNECEDOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'REGISTRA A APROPRIACAO DE AJUSTE OU ASSINATURA DE CONTRATOS DE CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.06.00', 'CONTRATOS DE EMPRESTIMOS DO OOOC', 'REGISTRA O SOMATORIO DOS VALORES DOS CONTRATOS ASSINADOS, A LIBERAR ELIBERADOS PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO - OOOC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.07.00', 'OPERACOES C/ BENS E SERVICOS NO EXTERIOR COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DAS OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.08.00', 'CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE SEGUROS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.09.00', 'CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.10.00', 'CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.11.00', 'CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC', 'REGISTRA O VALOR DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.12.00', 'CONTRATO DE GESTAO', 'COMPREENDE AS CONTAS QUE REGISTRAM OS CONTRATOS DE GESTAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.13.01', 'VALOR FIRMADO', 'REGISTRO DO VALOR TOTAL DO ACORDO FIRMADO COM ORGANISMOS INTERNACIONAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.14.00', 'CONTRATOS DE OPERACOES DE CREDITO', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.9.1.00.00', 'OUTROS ATOS POTENCIAIS PASSIVO - CONSOLIDACAO', 'COMPREENDE OS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.9.2.00.00', 'OUTROS ATOS POTENCIAIS PASSIVO - INTRA OFSS', 'COMPREENDE OS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.9.4.00.00', 'OUTROS ATOS POTENCIAIS PASSIVO - INTER OFSS - ESTADO', 'COMPREENDE OS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.9.5.00.00', 'OUTROS ATOS POTENCIAIS PASSIVO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.1.1.00.00', 'DISPONIBILIDADE DE RECURSOS', 'REGISTRA O TOTAL DE RECURSOS DISPONIBILIZADOS, JA COMPROMETIDOS OU NAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.2.1.00.00', 'INSCRICAO DO LIMITE DE RESTOS A PAGAR CONCEDIDO POR DESTINACAO', 'COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS, NAS UG''S RESPONSAVEIS EM ENVIAR RECURSOS FINANCEIROS DESTINADOS AO PAGAMENTO DE RESTOS A PAGAR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.2.2.00.00', 'INSCRICAO DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINACAO', 'COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS, NAS UG''S CUJOS RECURSOS FINANCEIROS SAO INSUFICIENTES PARA HONRAREM TODOS OS COMPROMISSOS INSCRITOS EM RESTOS A PAGAR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.3.1.01.00', 'INSCRICAO DE COTA DIFERIDA', 'COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE COTAS DIFERIDAS QUE SERAO CONCEDIDAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.3.1.02.00', 'INSCRICAO DE REPASSE DIFERIDO', 'COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE REPASSES DIFERIDOS QUE SERAO CONCEDIDOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.3.1.03.00', 'INSCRICAO DE SUB-REPASSE DIFERIDO', 'COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE SUB-REPASSES DIFERIDOS QUE SERAO CONCEDIDOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.3.2.01.00', 'INSCRICAO DE COTA DIFERIDA', 'COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE COTAS DIFERIDAS QUE SERAO RECEBIDAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.3.2.02.00', 'INSCRICAO DE REPASSE DIFERIDO', 'COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE REPASSES DIFERIDOS QUE SERAO RECEBIDOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.3.2.03.00', 'INSCRICAO DE SUB-REPASSE DIFERIDO', 'COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE SUB-REPASSES DIFERIDOS QUE SERAO RECEBIDOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.1.1.00.00', 'COTAS DECORRENTES DO ORCAMENTO', 'REGISTRAM O VALOR TOTAL DAS COTAS, CONCEDIDAS OU NAO, DECORRENTES DO ORCAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.1.2.00.00', 'COTAS NAO DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR TOTAL DAS COTAS, CONCEDIDAS OU NAO, NAO DECORRENTES DO ORCAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.1.3.00.00', 'COTAS DE RESTITUICAO DE RECEITAS E DEPOSITOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS RECURSOS LIBERADOS PELA STN PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.1.4.00.00', 'REPASSES DECORRENTES DO ORCAMENTO', 'REGISTRA O VALOR TOTAL DOS REPASSES, CONCEDIDOS OU NAO, DECORRENTES DO ORCAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.1.5.00.00', 'REPASSES NAO DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR TOTAL DOS REPASSES, CONCEDIDOS OU NAO, NAO DECORRENTES DO ORCAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.1.6.00.00', 'REPASSE DE RESTITUICAO DE RECEITAS E DEPOSITOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS REPASSES, CONCEDIDOS OU NAO, PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.1.7.00.00', 'SUB-REPASSES DECORRENTES DO ORCAMENTO', 'REGISTRAM O VALOR TOTAL DOS SUB-REPASSES, CONCEDIDOS OU NAO, DECORRENTES DO ORCAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.1.8.00.00', 'SUB-REPASSES NAO DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR TOTAL DOS SUB-REPASSES, CONCEDIDOS OU NAO, NAO DECORRENTES DO ORCAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.1.9.00.00', 'SUB-REPASSE DE RESTITUICAO DE RECEITAS E DEPOSITOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS SUB-REPASSES CONCEDIDOS OU NAO, PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.2.1.00.00', 'COTAS DECORRENTES DO ORCAMENTO', 'REGISTRAM O VALOR TOTAL DAS COTAS, RECEBIDAS OU NAO, DECORRENTES DO ORCAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.2.2.00.00', 'COTAS NAO DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR TOTAL DAS COTAS, RECEBIDAS OU NAO, NAO DECORRENTES DO ORCAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.2.3.00.00', 'COTAS DE RESTITUICAO DE RECEITAS E DEPOSITOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS RECURSOS RECEBIDOS DA STN PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.2.4.00.00', 'REPASSES DECORRENTES DO ORCAMENTO', 'REGISTRAM O VALOR TOTAL DOS REPASSES, RECEBIDOS OU NAO, DECORRENTES DO ORCAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.2.5.00.00', 'REPASSES NAO DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR TOTAL DOS REPASSES, RECEBIDOS OU NAO, NAO DECORRENTES DO ORCAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.2.6.00.00', 'REPASSE DE RESTITUICAO DE RECEITAS E DEPOSITOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS REPASSES RECEBIDOS OU NAO, PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.2.7.00.00', 'SUB-REPASSES DECORRENTES DO ORCAMENTO', 'REGISTRA O VALOR TOTAL DOS SUB-REPASSES, RECEBIDOS OU NAO, DECORRENTES DO ORCAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.2.8.00.00', 'SUB-REPASSES NAO DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR TOTAL DOS SUB-REPASSES, RECEBIDOS OU NAO, NAO DECORRENTES DO ORCAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.2.9.00.00', 'SUB-REPASSE DE RESTITUICAO DE RECEITAS E DEPOSITOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS SUB-REPASSES, RECEBIDOS OU NAO, PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.1.1.00.00', 'LIMITE ORCAMENTARIO ESTABELECIDO', 'REGISTRA A INSCRICAO DO LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS ORCAMENTARIOS, CONFORME ESTABELECIDOS EM ATO PROPRIO DOS PODERES E MINISTERIO PUBLICO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.1.2.00.00', 'LIMITE ORCAMENTARIO ESTABELECIDO - ENCERRAMENTO', 'REGISTRA O VALOR DA COTA DE LIMITE ORCAMENTARIO DISPONIBILIZADA APOS O ENCERRAMENTO DO PRAZO DE EMISSAO DE NOTA DE EMPENHO DETERMINADO PELO DECRETO DE PROGRAMACAO FINANCEIRA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.2.0.01.00', 'LIMITE ORCAMENTARIO AUTORIZADO', 'REGISTRA O VALOR DO LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS AUTORIZADO PARA UTILIZACAO PELA SETORIAIS DE PROGRAMACAO FINANCEIRA, PARA POSSIBILITAR A EMISSAO DE NOTAS DE EMPENHO E DESCENTRALIZACAO DE CREDITOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.2.0.02.00', 'LIMITE ORCAMENTARIO RECEBIDO POR TRANSFERENCIA', 'REGISTRA O VALOR DO LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS TRANSFERIDO PELO ORGAO SETORIAL DE PROGRAMACAO FINANCEIRA PARA AS UNIDADES ORCAMENTARIAS PARA POSSIBILITAR A EMISSAO DE NOTAS DE EMPENHO E DESCENTRALIZACAO DE CREDITOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.2.0.03.00', 'COTA LIMITE ORCAMENTARIO P/ INSCRICAO RP', 'REGISTRA O VALOR DAS COTAS DE LIMITE ORCAMENTARIO DISPONIBILIZADA PARAAS UG, PARA VIABILIZAR A INSCRICAO DOS EMPENHOS EM RESTOS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.2.0.04.00', 'COTA LIMITE ORCAMENTARIO TRANSF. P/ INSC.RP', 'REGISTRA O VALOR DAS COTAS DE DESPESAS ORCAMENTARIAS RECEBIDO PORTRANSFERENCIA PARA INSCRICAO DOS EMPENHOS EM RESTOS A PAGAR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.2.0.05.00', 'LIMITE ORCAMENTARIO AUTORIZADO - ENCERRAMENTO', 'REGISTRA O VALOR DAS COTAS DE DESPESAS ORCAMENTARIAS AUTORIZADAS PARA UTILIZACAO PELAS SETORIAIS DE PROGRAMACAO FINANCEIRA, ROTINA DE ENCERRAMENTO DO EXERCICIO PARA UTILIZACAO DE NOVO LIMITE', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.2.0.06.00', 'LIMITE ORCAMENTARIO RECEBIDO POR TRANSFERENCIA - ENCERRAMENTO', 'REGISTRA O VALOR DA COTA DE LIMITE ORCAMENTARIO TRANSFERIDA APOS O ENCERRAMENTO DO PRAZO DE EMISSAO DE NOTA DE EMPENHO DETERMINADO PELO DECRETO DE PROGRAMACAO FINANCEIRA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.2.0.07.00', 'LIMITE ORCAMENTARIO ANULADO PELA UG DA UO - ENCERRAMENTO', 'REGISTRA O VALOR DAS COTAS DE DESPESAS ORCAMENTARIAS NO MOMENTO DA EMISSAO DA NOTA DE EMPENHO DE ANULACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.2.0.08.00', 'LIMITE ORCAMENTARIO ANULADO DESCENTRALIZACAO INTERNA - ENCERRAMENTO', 'REGISTRA O VALOR DAS COTAS DE DESPESAS ORCAMENTARIAS NO MOMENTO DA EMISSAO DA NOTA DE EMPENHO DE ANULACAO POR UG DIFERENTE DA UG RESPONSAVEL PELA UO, COM CREDITO RECEBIDO POR PROVISAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.2.0.09.00', 'LIMITE ORCAMENTARIO ANULADO DESCENTRALIZACAO EXTERNA - ENCERRAMENTO', 'REGISTRA O VALOR DAS COTAS DE DESPESAS ORCAMENTARIAS NO MOMENTO DA EMISSAO DA NOTA DE EMPENHO DE ANULACAO POR UG DIFERENTE DA UG RESPONSAVEL PELA UO, COM CREDITO RECEBIDO POR DESTAQUE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.2.0.10.00', 'LIMITE ORCAMENTARIO RECEBIDO -ENCERRAMENTO', 'REGISTRA O VALOR DAS COTAS DE DESPESAS ORCAMENTARIAS RECEBIDO PELA UG EMITENTE DO EMPENHO - ROTINA DO NOVO LIMITE PARA O ENCERRAMENTO .', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.2.0.11.00', 'LIMITE ORCAMENTARIO UTILIZADO/UG-ENCERRAMENTO', 'REGISTRA O VALOR DAS COTAS DE DESPESAS ORCAMENTARIAS UTILIZADAS PELA UG EMITENTE DO EMPENHO - ROTINA DO NOVO LIMITE PARA O ENCERRAMENTO .', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.1.1.01.00', 'ARRECADACAO LIQUIDA POR CODIGO DE RECEITA (DARF''S)', 'REGISTRA O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADA POR CODIGO DE RECEITA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.1.2.01.00', 'ARRECADACAO LIQUIDA POR CODIGO DE DESTINACAO PRIMARIA (DARF''S)', 'REGISTRA O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.1.3.01.00', 'ARRECADACAO LIQUIDA POR CODIGO DE DESTINACAO VINCULADA (DARF''S)', 'REGISTRA O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.2.1.01.00', 'ARRECADACAO LIQUIDA POR CODIGO DE RECOLHIMENTO (GRU''S)', 'REGISTRA O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE GRU, CLASSIFICADA POR CODIGO DE RECOLHIMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.2.2.01.00', 'ARRECADACAO LIQUIDA POR CODIGO DE DESTINACAO PRIMARIA (GRU''S)', 'REGISTRA O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE GRU, CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.2.3.01.00', 'ARRECADACAO LIQUIDA POR CODIGO DE DESTINACAO SECUNDARIA (GRU''S)', 'REGISTRA O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE GRU, CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.3.1.00.00', 'ISS SUBSTITUICAO A DISTRIBUIR', 'REGISTRA A TRANSFERENCIA DE ISS A DISTRIBUIR AOS MUNICIPIOS, PARA CONTROLE DA COFIN.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.1.1.0.00.00', 'ENCAMINHAMENTO DE CREDITOS', 'REGISTRA OS VALORES PASSIVEIS DE SEREM ENCAMINHADOS E INSCRITOS EM DIVIDA ATIVA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.2.1.0.00.00', 'INSCRICAO DE CREDITOS', 'REGISTRA OS VALORES DOS CREDITOS PASSIVEIS DE SEREM INSCRITOS EM DIVIDA ATIVA PELO ORGAO RESPONSAVEL PELA INSCRICAO EM DIVIDA ATIVA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.1.1.0.00.00', 'PASSIVOS CONTINGENTES', 'REGISTRA OS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.2.1.0.00.00', 'DEMAIS RISCOS FISCAIS', 'REGISTRA OS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.1.1.00.00', 'REMANEJAMENTO DE COTA - SETORIAL FINANCEIRA', 'REGISTRA NA SETORIAL FINANCEIRA O REMANEJAMENTO DE COTA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.1.2.00.00', 'REMANEJAMENTO DE COTA - UG BENEFICIADA', 'REGISTRA NA UG BENEFICIADA O REMANEJAMENTO DE COTA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.2.1.01.00', 'COTA DE EMPENHOS', 'REGISTRA A CONCESSAO DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.2.1.06.01', 'RETENCAO DE TRIBUTOS', 'REGISTRA O VALOR DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG 170500, ESSA RETENCAO FEITA POR UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. E UM MERO REFLEXO DA CONTA 7.9.1.2.2.11.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.2.2.01.00', 'COTA DE EMPENHO CONTRA-ENTREGA RECEBIDA DIRETAMENTE', 'REGISTRA O RECEBIMENTO DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA DIRETAMENTE DA SETORIAL FINANCEIRA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.2.2.02.00', 'COTA DE EMPENHO CONTRA-ENTREGA RECEBIDA POR TRANSFERENCIA', 'REGISTRA O RECEBIMENTO DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA DE OUTRA UG ANTERIORMENTE BENEFICIADA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.2.2.06.01', 'RETENCAO DE TRIBUTOS', 'REGISTRA O VALOR DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA, ESSA RETENCAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.2.1.1.00.00', 'EMISSAO DE DARF', 'REGISTRA O CONTROLE DA EMISSAO DE DARFS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.2.1.2.00.00', 'EMISSAO DE GPS', 'REGISTRA O CONTROLE DA EMISSAO DE GPSS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.2.1.3.00.00', 'EMISSAO DE DAR', 'REGISTRA O CONTROLE DA EMISSAO DE DARS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.2.1.4.00.00', 'EMISSAO DE GFIP', 'REGISTRA O CONTROLE DA EMISSAO DE GFIPS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.2.1.5.00.00', 'EMISSAO DE GRU', 'REGISTRA O CONTROLE DA EMISSAO DE GRUS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.2.1.6.00.00', 'PAGAMENTOS EFETUADOS', 'REGISTRA O VALOR DOS PAGAMENTOS EFETUADOS PELAS UNIDADES GESTORAS COM BASE NO LIMITE DE SAQUE DA CONTA UNICA DA SECRETARIA DO TESOURO NACIONAL OU DA CONTA UNICA INSTITUCIONAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.2.2.1.00.00', 'INGRESSOS', 'REGISTRA O VALOR DE INGRESSOS DE CAIXA DO TESOURO NACIONAL ORIUNDOS DE EMPRESTIMOS EXTERNOS, ANTES DA ETAPA DO REEMBOLSO (REGISTRO NACONTA UNICA).', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.2.2.2.00.00', 'DISPONIBILIDADES DE RECURSO POR DESTINACAO', 'REGISTRA A MOVIMENTACAO FINANCEIRA VINCULADA AOS INGRESSOS DOS RECURSOS EXTERNOS BEM COMO A APROVACAO DE REEMBOLSO DOS RECURSOS APLICADOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.3.1.1.00.00', 'BENEFICIOS PAGOS PELA REDE BANCARIA DO EXERCICIO', 'REGISTRAM OS BENEFICIOS PREVIDENCIARIOS PAGOS DIRETAMENTE PELA REDE BANCARIA NO EXERCICIO ATUAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.3.1.2.00.00', 'BENEFICIOS PAGOS PELA REDE BANCARIA DO EXERCICIO ANTERIOR', 'REGISTRA OS BENEFICIOS PREVIDENCIARIOS PAGOS DIRETAMENTE PELA REDE BANCARIA NO EXERCICIO ANTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.3.2.1.00.00', 'BENEFICIOS PAGOS POR EMPRESAS CONVENENTES DO EXERCICIO', 'REGISTRAM OS BENEFICIOS PREVIDENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.3.2.2.00.00', 'BENEFICIOS PAGOS POR EMPRESAS CONVENENTES DO EXERCICIO ANTERIOR', 'REGISTRA OS BENEFICIOS PREVIDENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.4.1.1.00.00', 'REMANEJAMENTO DE FONTE DE RECURSOS', 'REGISTRA OS VALORES RELATIVOS AO REMANEJAMENTO DE SALDO NA CONTA DE DISPONIBILIDADE POR FONTE DE RECURSOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.4.1.2.00.00', 'CONTROLE FR - CANCELAMENTO OBRIG. EXERC. ANT', 'REGISTRA O CONTROLE POR FONTE DE RECURSOS NO CANCELAMENTO DE OBRIGA-COES DE EXERCICIOS ANTERIORES QUE NAO TENHAM CONTAS DE CONTROLE DE EMPENHO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.4.1.3.00.00', 'INCORPORACAO/DESINCORPORACAO SALDOS', 'REGISTRA OS VALORES RELATIVOS A INCORPORACAO OU DESINCORPORACAO DE SALDOS DA DISPONIBILIDADE POR FONTE DE RECURSOSO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.4.1.4.00.00', 'CONTROLE FR - RESTITUICAO DE RECEITAS', 'REGISTRA O CONTROLE POR FONTE DE RECURSOS NAS ROTINAS DE RESTITUICAOO DE RECEITAS, ONDE NAO HA CONTAS DE CONTROLE DE EMPENHO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.4.2.1.00.00', 'CONTROLE DE INGRESSOS E SAIDAS DA CONTA UNICA', 'REGISTRA O VALOR DE INGRESSOS E SAIDAS FISCAIS DE CAIXA DA SECRETARIA DO TESOURO NACIONAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMACAO DO TESOURO NACIONAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.4.2.2.00.00', 'CONTROLE DE INGRESSOS E SAIDAS DO INSS', 'REGISTRA O VALOR DE INGRESSOS E SAIDAS DE FINANCIAMENTO PELA SECRETAIRA DO TESOURO NACIONAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMACAO FINANCEIRA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.4.2.3.00.00', 'CONTROLE DE INGRESSOS E SAIDAS DA CONTA ESPECIAL', 'REGISTRA O VALOR DE INGRESSOS E SAIDAS DOS RECURSOS DE EMPRESTIMOS EX-TERNOS DA CONTA ESPECIAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.4.3.0.00.00', 'CONTROLE DE TRANSFERENCIAS ENTRE CONTAS UNICAS (INSS E TESOURO NACIONAL)', 'REGISTRA O VALOR DA TRANSFERENCIA DE LIMITES DA CONTA UNICA DO INSSPARA O TESOURO NACIONAL E VICE-VERSA DENTRO DE UMA UG OU ENTRE UGSDIFERENTES, BEM COMO TRANSFERENCIAS DE LIMITES DA CONTA UNICA ENTRE UGS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.4.4.0.00.00', 'CONTROLE DE APLICACAO FINANCEIRA NA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO', 'REGISTRA OS VALORES REFERENTE AO CONTROLE DE FONTE DE RECURSOS NA NA PLICACAO FINANCEIRA NA CTU.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.5.0.0.00.00', 'OUTROS CONTROLES DE RA''S', 'COMPREENDEM AS CONTAS QUE CONTROLAM RA''S.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.1.1.01.00', 'LIMITE DE EMISSAO ORCAMENTARIA', 'REGISTRA O VALOR DA EMISSAO DE TITULO DA DIVIDA PUBLICA ATE O LIMITEPREVISTO NA EXECUCAO ORCAMENTARIA A FIM DE ATENDER SUAS DESPESAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.1.1.02.00', 'LIMITE DE EMISSAO - CREDITOS ADICIONAIS', 'REGISTRA O VALOR DA EMISSAO DE TITULOS ATE O LIMITE DOS CREDITOS ADI-CIONAIS SOLICITADOS PELO EXECUTIVO E QUE PASSARAO A INTEGRAR O ORCA-MENTO EM VIGOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.1.1.03.00', 'LIMITE DE EMISSAO - GIRO DA DIVIDA', 'REGISTRA O VALOR DO LIMITE DE EMISSOES DE TITULOS PARA FINS DE GIRO DADIVIDA PUBLICA, PREVISTOS NA PROGRAMACAO FINANCEIRA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.2.1.00.00', 'INCORPORACOES DE RECEITAS', 'REGISTRA OS VALORES REFERENTES AS INCORPORACOES DE RECEITAS PERTENCEN-TES A OUTRA UNIDADE GESTORA DO MESMO ORGAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.2.2.00.00', 'DESICORPORACOES DE RECEITAS', 'REGISTRA OS VALORES REFERENTES AS DESINCORPORACOES DE RECEITAS PERTENCENTES A OUTRA UNIDADE GESTORA DO MESMO ORGAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.3.1.00.00', 'ADIANTAMENTOS', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS ADIANTAMENTOS DE RECURSOS DA CONTA UNICA PARA A UNIDADE GESTORA CONTRATANTE DE EMPRESTIMO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.3.2.00.00', 'REEMBOLSOS/RESSARCIMENTOS', 'COMPREENDE AS CONTAS QUE REGISTRAM A SOCILITACAO DE REEMBOLSOS/RESSARCIMENTOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.4.1.00.00', 'OPERACOES DE CREDITO EXTERNAS CONCEDIDAS', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS CONCEDIDAS LIBERADOS PELA COFIN/STN.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.4.2.00.00', 'OPERACOES DE CREDITO EXTERNAS RECEBIDAS', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS RECEBIDAS LIBERADOS PELA COFIN/STN.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.4.3.00.00', 'CONTROLE DE REEMBOLSOS', 'COMPREENDE AS CONTAS QUE REGISTRAM A SOCILITACAO DE REEMBOLSOS A SEREM EFETUADOS PARA A CONTAUNICA DO TESOURO NACIONAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.4.4.00.00', 'CONTROLE DE DESEMBOLSOS', 'COMPREENDE AS CONTAS QUE REGISTRAM A SOLICITACAO DE DESEMBOLSO A SEREM EFETUADOSPARA A CONTA ESPECIAL DO TESOURO NACIONAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.4.5.01.00', 'CONTROLE DA COFIN', 'REGISTRA NA COFIN OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.4.5.02.00', 'CONTROLE DA UG', 'REGISTRA NA UG OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.5.1.00.00', 'CONTROLE DA COFIN', 'REGISTRA NA COFIN OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS SEM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL, EXCLUSIVE RECURSOS DE CONTRAPARTIDA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.5.2.00.00', 'CONTROLE DA UG RESPONSAVEL PELO PROJETO', 'REGISTRA NA UG RESPONSAVEL PELO PROJETO OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS SEM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL, EXCLUSIVE RECURSOS DE CONTRAPARTIDA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.7.1.1.00.00', 'RESPONSABILIDADES DE TERCEIROS', 'REGISTRA AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.7.2.1.00.00', 'RESPONSABILIDADE COM TERCEIROS', 'REGISTRA AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.7.3.0.00.00', 'DIVERSOS RESPONSAVEIS EM APURACAO', 'REGISTRA AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUIZOS PARA A FAZENDA NACIONAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.01.00', 'ESTUDOS E PROJETOS', 'REG. OS REC. APLIC. EM ESTUDOS BASICOS,TAIS COMO: GEOLOGICOS,GEOTECNICOS,TOPOGRAFICOS,LEVANTAMENTOS AEROFOGRAMETICOS,PEDAGOGICO MAPEAMENTOSE ESTUDOS DE PROJETOS, TAIS COMO:ESTUDO DEVIABILIDADE,ANTE PROJETO,PROJETO BASICO E EXECUTIVO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.02.00', 'TERRENOS', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NO LEVANTAMENTO CADASTRAL, INDENIZACAO POR DESAPROPRIACAO,DEMARCACAO DE LOTES E REGISTROS DE ESCRITURAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.03.01', 'BARRAGENS', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO REFERENTES A BARRAGENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.03.02', 'DIQUES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO REFERENTES A DIQUES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.03.03', 'ESTRUTURA E EQUIPAMENTOS DE ADUCAO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO C/ ESTRUTURA E DEQUIPAMENTOS DE ADUCAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.03.04', 'ESTRUT.E EQUIP.DE CONDUCAO E DISTRIB.DAGUA', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO DA ESTRUTURA E DEQUIPAMENTOS DE CONDUCAO E DISTRIBUICAO DAGUA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.03.05', 'ESTRADAS E CAMINHOS DE SERVICOS', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO DA ESTRUTURA REF. A ESTRADAS E CAMINHOS DE SERVICOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.03.06', 'LINHAS DE TRANSMISSAO DE ENERGIA', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO DA ESTRUTURA COM LINHAS DE TRANSMISSAO DE ENERGIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.03.07', 'REDE DE DRENAGEM PRINCIPAL', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO DA ESTRUTURA COM A REDE DE DRENAGEM PRINCIPAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.03.08', 'PREDIOS DE USO DA ADMINISTRACAO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO DA ESTRUTURA REFERENTE OS PREDIOS DE USO DA ADMINISTRACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.03.09', 'OUTROS INVEST.INFRA-ESTR.IRRIG.DE USO COMUM', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO DA ESTRUTURA DE OUTROS INVESTIMENTOS DE INFRAESTRUTURA DEIRRIGACAO DE USO COMUM INTERNA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.03.90', 'AMORTIZACAO INFRA-ESTRUT. DE IRRIGACAO', 'REGISTRA AS AMORTIZACOES DE VALORES APROPRIADOS COMO ENCARGOS RELATIVOS A EXECUCAO DE PROJETOS DE INFRAESTRUTURA DE IRRIGACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.04.01', 'PREDIOS DE USO HOSPITALAR E AMBULATORIAL', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO, MELHORAMENTO E MANUTENCAO EM PREDIOS DE USO HOSPITALAR EAMBULATORIAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.04.02', 'PREDIOS ESCOLARES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO, MELHORAMENTO E MANUTENCAO EM PREDIOS ESCOLARES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.04.03', 'EQUIPAMENTOS HOSPITALARES E AMBULATORIAIS', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO, MELHORAMENTO E MANUTENCAO EM EQUIPAMENTOS HOSPITALARES E AMBULATORIAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.04.04', 'EQUIPAMENTOS ESCOLARES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO, MELHORAMENTO E MANUTENCAO EM EQUIPAMENTOS ESCOLARES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.04.05', 'ESTRUTURA E EQUIP. URBANOS E DE SANEAMENTO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO, MELHORAMENTO E MANUTENCAO NA ESTRUTURA E EQUIPAMENTOS URBANOS E DE SANEAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.04.06', 'OUTROS INVEST. DE INFRA-ESTR. SOCIAL COMUM', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO, MELHORAMENTO E MANUTENCAO REFERENTE A OUTROS INVESTIMENTOS DE INFRAESTRUTURA SOCIAIS DE USO COMUM.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.05.01', 'DESMATAMENTO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO OU MELHORAMENTO DA PARCELA AGRICOLA, REFERENTE AO DESMATAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.05.02', 'SISTEMATIZACAO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO OU MELHORAMENTO DA PARCELA AGRICOLA, REFERENTE A SISTEMATIZACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.05.03', 'CANAIS E DRENOS PARCELARES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO OU MELHORAMENTO DA PARCELA AGRICOLA ,REFERENTE A CANAIS EDRENOS PARCELARES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.05.04', 'HABITACAO DE COLONOS', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO OU MELHORAMENTO DA PARCELA AGRICOLA ,REFERENTE AS HABITACOES DOS COLONOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.05.05', 'REDE DE ASPERSAO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO OU MELHORAMENTO DA PARCELA AGRICOLA , REFERENTE A REDE DEASPERSAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.05.06', 'OUTROS INVEST.DE BENFEIT.INTERNAS NOS LOTES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO OU MELHORAMENTO DA PARCELA AGRICOLA , REFERENTE A OUTROS INVESTIMENTOS DE BENFEITORIAS INTERNAS NOS LT', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.06.01', 'COMUNICACOES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NOSESTUDOS E OBRAS P/IMPLANTACAO DE SISTEMAS DE COMUNICACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.06.02', 'ENERGIA', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NOSESTUDOS E OBRAS P/IMPLANTACAO DE SISTEMAS DE ENERGIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.06.03', 'TRANSPORTES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NOSESTUDOS E OBRAS P/IMPLANTACAO DE SISTEMAS DE TRANSPORTES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.06.04', 'ESTRADAS E CAMINHOS EXTERNOS', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NOSESTUDOS E OBRAS P/IMPLANTACAO DE SISTEMAS DE ESTRADAS E CAMINHOS EXTERNOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.07.00', 'OPERACAO E CONSERV.DE INFRA-ESTR.DE IRRIG.', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAAQUISICAO DE VEICULOS, EQUP.E OUTROS BENS AFINS, BEM COMO OPERACAO,CONSERVACAO E MANUTENCAO DE INFRAESTRUTURA DE IRRIGACAO,EXECUTADAS DIRETAMENTE PELA CODEVASF.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.08.01', 'INFRA-ESTRUT.DE IRRIGACAO DE USO COMUM INT.', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO COMBARRAGENS,DIQUES,ESTRTURA E EQUIP.DE ADUCAO,DE CONDUCAO E DISTRIB. DAGUA,LINHAS DE TRANSMISSAO DE ENERGIA,REDE DE DRENAGEM PRINCIPAL, PREDIOS DA ADM. E OUTROS INVESTIMENTOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.08.02', 'INFRA-ESTRUTURAS SOCIAIS DE USO COMUM', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO COMPREDIOS DE USO HOSPITALAR E AMBULATORIAL, PREDIOS ESCOLARES,EQUIPAMENTOS HOSPITALARES E AMBULATORIAL,EQUIPAMENTOS ESCOLARES,ESTR.E EQUIP. URBANOS E DE SANEAM.E OUTROS INVESTIMENTOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.08.03', 'BENFEITORIAS INTERNAS NOS LOTES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO COMDESMATAMENTO,SISTEMATIZACAO,CANAIS E DRENOS PARCELARES, HABITACOES, REDE DE ASPERSAO, E OUTROS INVESTIMENTOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.08.04', 'OUTROS INVESTIMENTOS/ OBRAS DE RECUPERACAO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO COMOUTROS INVESTIMENTOS DE OBRAS DE RECUPERACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.09.01', 'BARRAGENS E DIQUES', 'REGISTRA OS RECURSOS APLICADOS NA CONSTRUCAO DE BARRAGENS E REPRESASOU ACUDES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.09.02', 'ESTRUTURA E EQUIPAMENTOS DE ADUCAO', 'REGISTRA OS RECURSOS APLICADOS EM ESTRUTURA E EQUIPAMENTOS QUE REALIZAM OPERACOES DE TRAZER AGUA, NOS SISTEMAS DE ABASTECIMENTOS, DESDE OPONTO DE CAPTACAO ATE A REDE DE DISTRIBUICAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.09.03', 'ESTR.E EQUIP.DE CONDUCAO E DISTRIB.DAGUA', 'REGISTRA OS RECURSOS APLICADOS EM ESTRUTURA E EQUIPAMENTOS DE CONDUCAO E DISTRIBUICAO DAGUA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.09.04', 'ESTRADAS E CAMINHOS DE SERVICOS', 'REGISTRA OS RECURSOS APLICADOS NA CONSTRUCAO DE ESTRADAS E CAMINHOSDE SERVICOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.09.05', 'LINHAS DE TRANSMISSAO DE ENERGIA', 'REGISTRA OS RECURSOS APLICADOS NA CONSTRUCAO DE LINHAS DE TRANSMISSAODE ENERGIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.09.06', 'REDE DE DRENAGEM', 'REGISTRA OS RECURSOS APLICADOS NA CONSTRUCAO DE REDES DE DRENAGEM.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.09.07', 'PREDIOS DE USO DA ADMINISTRACAO', 'REGISTRA OS RECURSOS APLICADOS NA CONSTRUCAO DE PREDIOS DE USO DA ADMINISTRACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.09.08', 'OUTROS INVESTIMENTOS', 'REGISTRA OS RECURSOS APLICADOS EM OUTROS INVESTIMENTOS, NAO ESPECIFICADOS NOS SUBITENS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.10.01', 'APOIO AO ASSOCIATIVISMO (INVEST.)', 'REGISTRA OS RECURSOS APLICADOS NA EMANCIPACAO DE PROJETOS EM INVESTIMENTOS NO ASSOCIATIVISMO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.10.02', 'OPERACAO E MANUTENCAO(INVEST.)DELEG.A TERC.', 'REGISTRA OS RECURSOS APLICADOS NA EMANCIPACAO DE PROJETOS EM INVESTIMENTOS NA OPERACAO E MANUTENCAO DELEGADAS A TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.10.03', 'APOIO AO ASSOCIATIVISMO (CUSTEIO)', 'REGISTRA OS RECURSOS APLICADOS NA EMANCIPACAO DE PROJETOS EM CUSTEIONO ASSOCIATIVISMO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.10.04', 'OPERACAO E MANUTENCAO(CUSTEIO)DELEG.A TERC.', 'REGISTRA OS RECURSOS APLICADOS NA EMANCIPACAO DE PROJETOS EM CUSTEIONA OPERACAO E MANUTENCAO DELEGADAS A TERCEIROS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.01', 'ARMAZENAMENTO, BENEFICIAM.E COMERCIALIZACAO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO EMUSINAS DE BENEFICIAMENTO, ARMAZENS, ARMAZENAGEM E GALPOES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.02', 'EXTENSAO RURAL', 'REGISTRA OS RECURSOS APLICADOS EM ACOES DE PROMOCAO SOCIAL DO HOMEMDO CAMPO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.03', 'LAVOURA', 'REGISTRA OS RECURSOS APLICADOS NA PRODUCAO E PRODUCAO DE SEMENTES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.04', 'MECANIZACAO - INVESTIMENTO', 'REGISTRA OS RECURSOS APLICADOS NOS PROJETOS PUBLICOS DE IRRIGACAO EINVESTIMENTO NA AQUISICAO DE MAQUINAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.05', 'MECANIZACAO - CUSTEIO', 'REGISTRA OS RECURSOS APLICADOS NOS PROJETOS PUBLICOS DE CUSTEIO NAMANUTENCAO DA PATRULHA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.06', 'OCUPACAO ESPACIAL E COLONIZACAO', 'REGISTRA OS RECURSOS APLICADOS NA TITULACAO, ASSENTAMENTO DE COLONOSE OUTROS AFINS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.07', 'PISCICULTURA - INVESTIMENTOS', 'REGISTRA OS RECURSOS APLICADOS EM INVESTIMENTOS (EQUIPAMENTOS E CONSTRUCOES) NA PSCICULTURA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.08', 'PISCICULTURA - CUSTEIO', 'REGISTRA OS RECURSOS APLICADOS EM CUSTEIO (RACOES, PRODUCAO DE ALEVINOS, PEIXAMENTO DE ACUDES, OPERACAO E MANUTENCAO) NA PSCICULTURA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.09', 'PRODUCAO ANIMAL - INVESTIMENTOS', 'REGISTRA OS RECURSOS APLICADOS NO DESENVOLVIMENTO DA PRODUCAO ANIMALEM INVESTIMENTOS (EQUIPAMENTOS, CONSTRUCOES, MATRIZES, ETC.).', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.10', 'PRODUCAO ANIMAL - CUSTEIO', 'REGISTRA OS RECURSOS APLICADOS EM CUSTEIO (RACOES, CERCAS, VACINAS,OPERACAO E MANUTENCAO E OUTROS AFINS)NA PRODUCAO ANIMAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.11', 'REFLORESTAMENTO', 'REGISTRA OS RECURSOS APLICADOS NOS PROJETOS PUBLICOS DE IRRIGACAO NAIMPLANTACAO E MANUTENCAO DE AREAS REFLORESTADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.12', 'UNIDADE DE OBSERVACAO E DEMONSTRACAO', 'REGISTRA OS RECURSOS APLICADOS EM TRABALHOS DE ADAPTACAO E TRANSFERENCIA DE TECNOLOGIA AGRICOLA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.13', 'ASSISTENCIA TECNICA INTERNACIONAL', 'REGISTRA OS RECURSOS APLICADOS NA PRESTACAO DE SERVICOS POR ENTIDADESINTERNACIONAIS (IICAFAO, ETC.)', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.14', 'FRUTICULTURA', 'REGISTRA OS RECURSOS APLICADOS PELA UNIDADE REF. A FRUTICULTURA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.12.01', 'MONITORIA', 'REGISTRA OS RECURSOS APLICADOS NA IMPLANTACAO E MANUTENCAO DE SISTEMASDE ACOMPANHAMENTO E AVALIACAO DOS PERIMETROS IRRIGADOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.12.02', 'RECUPERACAO DOS DANOS DAS ENCHENTES', 'REGISTRA OS RECURSOS APLICADOS EM INVESTIMENTOS EM REGIME DE EXECUCAOESPECIAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.12.03', 'COMBATE AOS EFEITOS DA SECA', 'REGISTRA OS RECURSOS APLICADOS EM INVESTIMENTOS EM REGIME DE EXECUCAOESPECIAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.12.04', 'PROG. PILOTO DE MUNIC. DA IRRIG. - PPMI', 'REGISTRA OS RECURSOS APLICADOS EM INVESTIMENTOS EM REGIME DE EXECUCAOESPECIAL NO PROGRAMA PILOTO DE MUNICIPALIZACAO DA IRRIGACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.13.01', 'COMUNICACAO', 'REGISTRA OS RECURSOS APLICADOS DE CONTRATOS, CONVENIOS E OUTROS INSTRUMENTOS PARA ESTUDO, IMPLANTACAO, OPERACAO E MANUTENCAO DE SISTEMAS DECOMUNICACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.13.02', 'DESENVOLVIMENTO RURAL', 'REGISTRA OS RECURSOS APLICADOS DE CONTRATOS, CONVENIOS E OUTROS INSTRUMENTOS PARA ESTUDO, IMPLANTACAO, OPERACAO E MANUTENCAO DE ADITORAS RURAIS, BARRAGENS E INFRAESTRUTURA DE IRRIGACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.13.03', 'DESENVOLVIMENTO URBANO', 'REGISTRA OS RECURSOS APLICADOS DE CONTRATOS, CONVENIOS E OUTROS INSTRUMENTOS PARA ESTUDO, IMPLANTACAO, OPERACAO E MANUTENCAO RELATIVOS AO;ABASTECIMENTO DAGUA, DESENVOLVIMENTO URBANO, EDUCACAO, HABITACAO, SANEAMENTO, SAUDE E OUTROS AFINS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.13.04', 'TRANSPORTES', 'REGISTRA OS RECURSOS APLICADOS DE CONTRATOS, CONVENIOS E OUTROS INSTRUMENTOS PARA ESTUDO, IMPLANTACAO, OPERACAO E MANUTENCAO DE SISTEMAS DETRANSPORTES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.14.01', 'ATIVIDADES COMPLEMENTARES', 'REGISTRA OS RECURSOS APLICADOS EM INVESTIMENTOS COM OBRAS OU DESENVOLVIMENTO DE ATIVIDADES NAO PREVISTAS, MAS INDISPENSAVEIS AO BOM ANDAMENTO DOS SISTEMAS OPERACIONAL E PRODUTIVO DOS PROJETOS DA CODEVASF.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.14.02', 'APOIO A IRRIGACAO COMUNITARIA', 'REGISTRA OS VALORES APLICADOS EM APOIO AA IRRIGACAO COMUNITARIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.14.03', 'PROJETO AMANHA', 'REGISTRA OS VALORES APLICADOS EM APOIO AO PROJETO AMANHA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.15.01', 'PLANEJAMENTO REGIONAL', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS DE IRRIGACAO C/PLANEJAMENTO REGIONAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.15.02', 'ESTUDOS MACRO-REGIONAIS', 'REGISTRA A APLICACAO DE RECURSOS COM PROJETOS DE IRRIGACAO NO QUE SEREFERE A ESTUDOS MACROREGIONAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.15.03', 'MONITORIA', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS DE IRRIGACAO COM MONITORIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.15.04', 'ESTUDOS E PROJETOS', 'REGISTRA A APLICACAO DE RECURSOS EM PROJETOS DE IRRIGACAO COM ESTUDOSE PROJETOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.15.05', 'TREINAMENTO', 'REGISTRA A APLICACAO DE RECURSOS COM EXECUCAO DE PROJETOS NO QUE SE REFERE A TREINAMENTOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.16.00', 'AVALIACAO QUALITATIVA DE CUSTOS', 'REGISTRA OS VALORES REFERENTES A AVALIACAO QUALITATIVA DE CUSTOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.17.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE OBRAS CIVIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.17.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.17.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.17.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.17.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM TREINAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.17.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS NAO ALOCADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.18.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE OBRAS CIVIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.18.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.18.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.18.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.18.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM TREINAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.18.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS NAO ALOCADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.19.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE OBRAS CIVIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.19.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.19.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.19.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.19.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM TREINAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.19.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS NAO ALOCADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.20.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE OBRAS CIVIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.20.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.20.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.20.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.20.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM TREINAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.20.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS NAO ALOCADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.21.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE OBRAS CIVIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.21.02', 'PROJETO BIRD RJ - REC.BIRD (REABIL./MAT.ROD', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.21.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.21.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.21.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM TREINAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.21.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS NAO ALOCADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.22.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE OBRAS CIVIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.22.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.22.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.22.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.22.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM TREINAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.22.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS NAO ALOCADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.23.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE OBRAS CIVIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.23.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.23.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.23.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.23.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM TREINAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.23.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS NAO ALOCADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.24.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE OBRAS CIVIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.24.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.24.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.24.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.24.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM TREINAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.24.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS NAO ALOCADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.25.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE OBRAS CIVIS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.25.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.25.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM BENS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.25.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.25.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM TERINAMENTO', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.25.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS NAO ALOCADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.26.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIODE JANEIRO REFERENTE OBRAS CIVIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.26.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.26.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM BENS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.26.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.26.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM TREINAMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.26.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS NAO ALOCADAS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.2.00.00', 'CONTROLE DA EXECUCAO FISICA DO PLANO INTERNO - CONCESSAO', 'REGISTRA A CONTRAPARTIDA DA EXECUCAO FISICA DO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.3.00.00', 'CONTROLE DA EXECUCAO FISICA DO PLANO INTERNO - RECEBIMENTO', 'REGISTRA A CONTRAPARTIDA DA EXECUCAO FISICA DO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.01.00', 'CONTROLE DE RESTITUICAO DE CONTRIBUICOES', 'REGISTRA OS VALORES DESEMBOLSADOS A TITULO DE RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS RECOLHIDAS A MAIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.02.00', 'CONTROLE INADIMPLENCIA EMPREST/FINANCIAMENT', 'REGISTRA OS VALORES REFERENTES AOS CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS QUE SE ENCONTRAM NA SITUACAO DE INADIMPLENTES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.03.00', 'CONTROLE DE PASSIVOS EM PROCESSO DE ASSUNCAO', 'REGISTRA OS VALORES RELATIVOS A PASSIVOS EM PROCESSO DE ASSUNCAO PELA UNIAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.04.01', 'CONTROLE DE PRECATORIOS PAGOS - EXERCICIO', 'REGISTRA OS VALORES RELATIVOS AS DESPESAS COM OS PRECATORIOS PAGOS NO EXERCICIO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.04.02', 'CONTROLE PRECATORIOS PAGOS - EXERCICIOS ANT', 'REGISTRA OS VALORES RELATIVOS AS DESPESAS COM OS PRECATORIOS PAGOS NOS EXERCICIOS ANTERIORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.05.00', 'DOCUMENTOS PENDENTES DE RECEBIMENTO', 'REGISTRA OS VALORES RELATIVOS AOS DOCUMENTOS PENDENTES DE RECEBIMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.06.00', 'CONTROLE DA EMISSAO DE TITULO DIVIDA', 'REGISTRA AS CONTRAPARTIDAS DOS VALORES RELATIVOS A EMISSAO DE TITULOS DA DIVIDA NO MERCADO INTERNACIONAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.07.00', 'CONTROLE DE BENEFICIARIO - AUXILIO MORADIA', 'REGISTRA OS VALORES A TITULO DE DESPESAS COM MORADIA, CONFORME DETERMINACAO TCU 1690/2002, DE 04/12/2002.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.08.01', 'CONTROLE DE ARRECADACAO DE RECEITAS - DEP.C', 'REGISTRA OS VALORES REFERENTES AS RECEITAS DIRETAMENTE ARRECADADAS POR DEPOSITO DIRETO NA CONTA UNICA, COM CONTROLE DA CLASSIFICACAO INSTITUCIONAL DA RECEITA ARRECADADA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.08.02', 'CONTROLE DE ARRECADACAO DE RECEITAS - GRU', 'REGISTRA OS VALORES REFERENTES AS RECEITAS DIRETAMENTE ARRECADADASATRAVES DO ARQUIVO DA GRU, COM CONTROLE DA CLASSIFICACAO INSTITUCIONAL DA RECEITA ARRECADADA.ESTA CONTA DEMONSTRA, NA ROTINA DE ARRECADACAO DE GRU, QUE UMA UNIDADEARRECADOU A RECEITA, POREM ESSA RECEITA FOI TRANSFERIDA PARA OUTR UNIDADE. ESTA CONTA EH O CONTROLE NA UNIDADE QUE ARRECADOU DE QUANTO ELA ARRECADOU E FOI TRANSFERIDO PARA OUTREM.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.08.03', 'CONTROLE DE ARRECADACAO DE RECEITAS UG EXT.', 'REGISTRA OS VALORES REFERENTES AS RECEITAS DIRETAMENTE ARRECADADAS POR DEPOSITO DIRETO NA CONTA UNICA, COM CONTROLE DA CLASSIFICACAO INSTITUCIONAL DA RECEITA ARRECADADA, PARA ATENDER ROTINA DE VARIACAO CAMBIAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.09.00', 'CONTROLE DE VALORES A RECEBER - FCVS', 'REGISTRA OS VALORES RELATIVOS A DIVIDAS DE FINANCIAMENTO DO FCVS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.10.00', 'CONTROLE EMPRESTIMO/FINANCIAMENTO CONCEDIDO', 'REGISTRA A CONTRAPARTIDA DAS APROPRIACOES DE VALORES REPASSADOS A AGENTES FINANCEIROS PARA CONTRATACAO DE EMPRESTIMOS E FINANCIAMENTOS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.11.00', 'CONTROLE DO CARTAO DE PAG. GOV.FEDER', 'REGISTRA A CONTRAPARTIDA DOS PAGAMENTOS DE VALORES REFERENTE AS DESPESAS EFETUADAS ATRAVES DE SAQUE OU FATURA COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.12.01', 'ORDENS BANCARIAS TV EMITIDAS A COMPENSAR', 'REGISTRA OS VALORES RELATIVOS AS ORDENS BANCARIAS EMITIDAS NAS TRANSFERENCIAS VOLUNTARIAS, EM TRANSITO OU A COMPENSAR PELO AGENTE FINANCEIRO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.12.02', 'PAGAMENTOS OB-TV EFETUADOS', 'REGISTRA O VALOR DOS PAGAMENTOS EFETUADOS PELAS UNIDADES GESTORAS COMBASE NO LIMITE DE SAQUE DA CONTA DE TRANSFERENCIA VOLUNTARIA MANTIDAJUNTO AOS BANCOS OFICIAIS (BB, CEF. BASA, BNB).', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.12.03', 'RECURSOS DE TRANSF.VOLUNTARIA APLICADOS', 'REGISTRA O VALOR DOS PAGAMENTOS EFETUADOS PELAS UNIDADES GESTORAS COMBASE NO LIMITE DE SAQUE DA CONTA DE TRANSFERENCIA VOLUNTARIA MANTIDAJUNTO AOS BANCOS OFICIAIS (BB, CEF. BASA, BNB).', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.12.04', 'OBTV DE TRANSF.CTA TV PARA A CTU A COMPENSA', 'REGISTRA OS VALORES RELATIVOS AS OBTV EMITIDAS PARA DEVOLUCAO DE RECURSOS PARA A CONCEDENTE DE RECURSOS NAO APLICADOS NO OBJETO DA TRANSFE RENCIA', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.12.05', 'TRANSFERENCIA DA CONTA TV PARA CTU', 'REGISTRA OS VALORES RELATIVOS AS OBTV EMITIDAS PARA DEVOLUCAO DE RECURSOS PARA A CONCEDENTE DE RECURSOS NAO APLICADOS NO OBJETO DA TRANSFE RENCIA, CONTROLE NA COFIN/STN UG 170500 PARA ACOMPANHAMENTO DA CONCILIACAO DA CTU', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.12.06', 'RECURSOS DE TRANSF. VOLUNTARIA - DISPONIVEL', 'REGISTRA, NA CONCEDENTE DA TRANSFERENCIA VOLUNTARIATV, OS INGRESSOS ESAIDAS DOS RECURSOS DA TV. A MOVIMENTACAO DOS RECURSOS DA CONTA BANCARIA SOMENTE OCORRERA VIA PORTAL SICONV. AS INSTITUICOES BANCARIAS OFICIAIS SAO BB, CEF, BASA E BNB.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.01', 'HON.DEFENSORES DATIVOS-ACOES PROC.ORDINARIO', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTO DE HONORARIOS DE DEFENSORES DATIVOS EM ACOES CUJOS ATOS PROCESSUAIS SEDESENVOLVEM POR MEIO DE PROCEDIMENTO COMUM, MAS SEGUNDO RITO ORDINARIO(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS).', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.02', 'HONORARIOS DEFENSORES DATIVOS-ACOES DIVERSA', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM ACOES CAUTELARES (CPC ARTS. 796A 889), AS ACOES CUJOS ATOS PROCESSUAIS SE DESENVOLVEM POR MEIO DEPROCEDIMENTOS ESPECIAIS (ART.890 A 1102C) E AS ACOES DE HABEAS DATAS,MANDATO DE INJUNCAO, ALEM DE OUTRAS NAO ELENCADAS NAS DEMAIS RUBRICAS.(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS).', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.03', 'HONORARIOS DEFENSORES DATIVOS-ACOES CRIMINA', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM ACOES PENAIS PUBLICAS E PRIVADAS QUE SEGUEM OS RITOS: ORDINARIO, SUMARIO, DOS CRIMES DE COMPETENCIADO JURI E DOS CRIMES CONTRA A HONRA PREVISTOS NO CODIGO DE PROCESSOPENAL, ALEM DE OUTROS PREVISTOS EM LEIS ESPECIAIS, COMO NA LEI Nº 9099/95 (LEI DOS JUIZADOS ESPECIAIS CRIMINAIS), NA LEI Nº 10409/02 (LEI DETOXICOS)(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.04', 'HONOR.DEFENSORES DATIVOS-MANDADO DE SEGURAN', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM ACOES CONSTITUCIONAIS POSTAS ADISPOSICAO DE TODA PESSOA FISICA OU JURIDICA, ORGAO COM CAPACIDADEPROCESSUAL, OU UNIVERSALIDADE RECONHECIDA POR LEI, P/ A PROTECAO DEDIREITO INDIVIDUAL OU COLETIVO, LIQUIDO E CERTO, NAO AMPARADO POR HABEAS CORPUS OU HABEAS DATA, LESADO OU AMEACADO DE LESAO, POR ATO DEAUTORIDADE, SEJA DE QUE CATEGORIA FOR E SEJAM QUAIS FOREM AS FUNCOESQUE EXERCAM.(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.05', 'HONORARIOS DEFENSORES DATIVOS-HABEAS CORPUS', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM ACOES CONSTITUCIONAIS DE CARACTER PENAL E DE PROCEDIMENTOS ESPECIAL, QUE VISA A EVITAR OU CESSAR VIOLENCIA OU AMEACA NA LIBERDADE DE LOCOMOCAO, POR ILEGALIDADE OU ABUSO DE PODER.(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS).', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.06', 'HONOR.DEFENSORES DATIVOS-EXECUCOES FISCAIS', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM ACOES DE EXECUCOES JUDICIAL PARA COBRANCA DA DIVIDA ATIVA DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERALDOS MUNICIPIOS E RESPECTIVAS AUTARQUIAS, DE NATUREZA TRIBUTARIA OU NAOTRIBUTARIA (LEI Nº 6.830/1980).(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.07', 'HONOR. DEFENSORES DATIVOS-EXECUCOES DIVERSA', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM ACOES DE EXECUCAO DE TITULOSJUDICIAIS OU EXTRAJUDICIAIS PREVISTAS NO CODIGO DE PROCESSO CIVIL. EX:EXECUCAO PARA ENTREGA DE COISA, DE OBRIGACAO DE FAZER OU NAO FAZER,PORQUANTIA CERTA, CONTRA DEVEDOR SOLVENTE E INSOLVENTE E A EXECUCAO DEPRESTACAO ALIMENTICIA.(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.08', 'HONOR.DEFENSORES DATIVOS-ACOES PROC.SUMARIO', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM ACOES CUJOS ATOS PROCESSUAIS SEDESENVOLVEM POR MEIO DE PROCEDIMENTO COMUM, MAS SEGUNDO O RITO SUMARIOO RITO SUMARIO EH APLICAVEL QUANDO NAO CABIVEL O RITO ORDINARIO OUQUALQUER PROCEDIMENTO ESPECIAL PREVISTO EM LEI.(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.09', 'HON.DEFENSORES DATIVOS-FEITO NAO CONTENCIOS', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS QUANDO ATUAREM NA JURISDICAO VOLUNTARIA, NA QUAL INEXISTE UM CONFLITO DE INTERESSES A SER DIRIMIDOPELO PODER JUDICIARIO, O QUAL AGE EM TAIS HIPOTESES COMO ADMINISTRADORPUBLICO DE INTERESSES PRIVADOS.(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.10', 'HON. DEFENSORES DATIVOS-PROCEDIMENTO CRIMIN', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM PROCEDIMENTOS TAIS COMO: PEDIDO DE BUSCA E APREENSAO CRIMINAL, PEDIDO DE LIBERDADE PROVISORIA COMOU SEM FIANCA, PEDIDO DE MEDIDAS ASSECURATORIAS, PEDIDO DE PRISAO/LIBERDADE VIGIADA PARA FINS DE EXPULSAO, PEDIDO DE PRISAO TEMPORARIA,PREVENTIVA. (EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.11', 'HON.DEFENSORES DATIVOS-PROCEDIMENTOS DIVERS', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS NOS DEMAIS PROCEDIMENTOS NAO ENQUADRADOS EM CONTAS ESPECIFICAS.(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.12', 'HONORARIOS PERICIAIS - ENGENHARIA', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS PERICIAIS, QUANDO DA PRESTACAO DE SERVICOS QUE NECESSITEM CONHECIMENTOS DA ESPECIALIDADE DE ENGENHARIA. (EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.13', 'HONORARIOS PERICIAIS - OUTROS', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS PERICIAIS, QUANDO DA PRESTACAO DE SERVICOS PERICIAL QUENECESSITE DE CONHECIMENTOS ESPECIFICOS, EXCETO A ESPECIALIDAE DE ENGENHARIA QUE SERAH CONTROLADA NA CONTA " HONORARIOS PERICIAIS - ENGENHARIA".(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.14', 'HONOR.DE TRADUTORES E INTERPRETES - TRADUCA', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS HA TRADUTORES E INTERPRETES RELATIVOS A TRADUCOES, EXCETO QUANDO FEITA EM AUDIENCIAS QUE DEVERAH SER REGISTRADO NA CONTA CONTABIL "HON.TRAD.INTERPR.-INTERPRETACAO EM AUDIENCIA".(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.15', 'HON.TRAD.INTERPR.-INTERPRETACAO EM AUDIENCI', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS HA TRADUTORES E INTERPRETES RELATIVOS A INTERPRETACOESEM AUDIENCIAS, OS DEMAIS HONORARIOS COM TRADUCAO DEVERAO SER REGISTRA DOS NA CONTA CONTABIL " HONOR.DE TRADUTORES E INTERPRETES - TRADUCAO".(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.16', 'HON.AUX.JUIZADOS ESPECIAIS FED. - DEFENSORE', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS A DEFENSORES QUANDO ATUAREM NOS JUIZADOS ESPECIAIS FEDERAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.17', 'HON.AUXILIARES JUIZADOS ESPEC.FED.-PERITOS', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS A PERITOS QUANDO ATUAREM NOS JUIZADOS ESPECIAIS FEDERAIS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.14.00', 'CONTROLE DE PAGAMENTOS TCT', 'REGISTRA OS VALORES DE PAGAMENTOS EFETUADOS PELAS ENTIDADES TCT.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.15.00', 'CONTROLE DE ESTOQUES', 'REGISTRA OS VALORES FISICO DE ESTOQUES GOVERNAMENTAIS DA REDE ARMAZENADORA DO GOVERNO FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.16.00', 'CONTROLE DOS PAGAMENTOS POR CPI', 'REGISTRA O CONTROLE DOS PAGAMENTOS EFETUADOS POR CPI - COMISSAO PARLAMENTAR DE INQUERITO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.17.01', 'CONTROLE CREDITO EMPENHADO LIQUIDADO - EXER', 'REGISTRA OS VALORES REFERENTES A APROPRIACAO DAS DESPESAS EMPENHADASCOM POSTERIOR VERIFICACAO DE SUA REGULARIDADE POR CONSTITUICAO DODIREITO DO CREDOR, APROPRIADAS NO EXERCICIO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.17.02', 'CONTROLE CREDITO EMPENHADO LIQUIDADO - EX.A', 'REGISTRA OS VALORES REFERENTES A APROPRIACAO DAS DESPESAS EMPENHADASCOM POSTERIOR VERIFICACAO DE SUA REGULARIDADE POR CONSTITUICAO DODIREITO DO CREDOR, APROPRIADAS NO EXERCICIO ANTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.17.03', 'CONTROLE DE VALORES DA CONTA ESPECIAL P/ C', 'REGISTRA OS VALORES TRANSFERIDOS DA CONTA ESPECIAL PARA CONTA UNICA: SALDO DEVEDOR REPRESENTA OS VALORES QUE SAIRAM DA CONTA ESPECIAL EAINDA NAO INGRESSARAM NA CONTA UNICA ; SALDO CREDOR REPRESENTA OS VALORES QUE SAIRAM DA CONTA ESPECIAL EQUE JAH INGRESSARAM NA CONTA UNICA (FALTA CONCILIACAO CONTA ESPECIAL); SALDO ZERADO REPRESENTA QUE AS SAIDAS DA CONTA ESPECIAL E O CORRES PONDENTES INGRESSOS NA CONTA UNICA JA FORAM REGISTRADOS.', 'X', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.18.00', 'CONTROLE DE ESTOQUE EM PROCESSO DE AVALIACAO', 'REGISTRA OS VALORES DE PRODUTOS QUE ANTES DE SEREM APROPRIADOS DEVEM SER SUBMETIDOS A UM PROCESSO DE AVALIACAO/TESTES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.19.01', 'DIARIAS - MEMBRO DE PODER', 'REGISTRA A APROPRIACAO DO VALOR DE DIARIAS PAGAS AOS MEMBROS DE PODER.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.19.02', 'DIARIAS - SERVIDOR', 'REGISTRA A APROPRIACAO DO VALOR DE DIARIAS PAGAS AOS SERVIDORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.19.03', 'DIARIAS - A COLABORADORES EVENTUAIS', 'REGISTRA A APROPRIACAO DO VALOR DE DIARIAS E ADICIONAL DE DESLOCAMENTOPAGAS AOS COLABORADORES EVENTUAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.20.01', 'PASSAGENS - MEMBRO DE PODER', 'REGISTRA A APROPRIACAO DO VALOR DE DIARIAS E ADICIONAL DE DESLOCAMENTOAOS MEMBROS DES PODER.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.20.02', 'PASSAGENS - SERVIDOR', 'REGISTRA A APROPRIACAO DO VALOR DE DIARIAS E ADICIONAL DE DESOLOCAMENTO PAGAS A SERVIDORES.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.20.03', 'PASSAGENS - A COLABORADORES EVENTUAIS', 'REGISTRA A APROPRIACAO DO VALOR DE PASSAGENS PAGAS A COLABORADORES EVENTUAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.21.01', 'CONTROLE DE VALORES (NR.REFERENCIA DA GRU)', 'REGISTRA OS VALORES RELATIVOS AOS CONTROLES POR NUMERO DE REFERENCIADA GRU.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.21.02', 'CONTROLE VALORES (NR.REFERENCIA GRU)EXERC.A', 'REGISTRA OS VALORES RELATIVOS AOS CONTROLES POR NUMERO DE REFERENCIADA GRU DO EXERCICIO ANTERIOR.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.21.03', 'CONTROLE DE VALORES (NR.REFERENCIA GRU) COF', 'REGISTRA OS VALORES RELATIVOS AOS CONTROLES POR NUMERO DE REFERENCIADA GRU, ARRECADADOS PELA COFIS/STN.ESTA CONTA DEVE PASSAR SALDO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.22.00', 'CONTROLE EMISSAO TITULOS DIVIDA INTERNA', 'REGISTRA A CONTRAPARTIDA DOS VALORES REFERENTE EMISSOES DE TITULOS DA DIVIDA PUBLICA MOBILIARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.23.00', 'CONTROLE EMISSAO TITULOS DA DIVIDA AGRARIA - TDA', 'REGISTRA A CONTRAPARTIDA DOS VALORES REFERENTE EMISSOES DE TITULOS DA DIVIDA PUBLICA AGRARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.24.00', 'CONTROLE REGISTRO SPIUNET', 'REGISTRA A CONTRAPARTIDA DOS VALORES DO CONTROLE DE REGISTRO POR INTEGRACAO COM SPIUNETNAS CONTAS DE BENS IMOVEIS DE USO ESPECIAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.25.00', 'CONTROLES DEVOLUCOES DE BENEFICIOS', 'REGISTRA A CONTRAPARTIDA DOS VALORES REFERENTES AS DEVOLUCOES DE PAGAMENTOS DE BENEFICIOS PELA REDE BANCARIA POR MEIO DE MENSAGEM SPB PARA POSTERIOR REGISTRO DE ESTORNO DE DESPESA PELO INSS. O REGISTRO OCORRERA NA COFIN/STN PARA CONTROLE DE RESTABELECIMENTO DE COTAS ORCAMENTARIAS A PROGRAMAR,VISANDO POSSIBILITAR A PROGRAMACAO FINANCEIRA ENTRE O INSS E A COFIN/STN PARA A REALIZACAO DE NOVOS PAGAMENTOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.26.00', 'CONTROLES DE PRECATORIOS EM TRANSITO', 'REGISTRA A CONTRAPARTIDA DOS VALORES EM TRANSITO REFERENTE CREDITO DE PRECATORIOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.27.01', 'VALORES PROGRAMADOS POR EXERCICIO - TV', 'REGISTRA O ACOMPANHAMENTO COM BASE NO CRONOGRAMA DA PROGRAMACAO ORCAMENTARIA DE TRANSFERENCIAS VOLUNTARIAS COM PRAZO DE VIGENCIA PLURIANUAL. ATENDER ARTIGO8º DA PORTARIA Nº 127, DE 29 DE MAIO 2008.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.27.02', 'VALORES EMPENHADOS POR EXERCICIO + TV', 'REGISTRA O ACOMPANHAMENTO DOS VALORES EMPENHADOS COM BASE NA PROGRAMACAO ORCAMENTARIADE TRANSFERENCIAS VOLUNTARIAS FORMALIZADAS COM PRAZO DE VIGENCIA PLURIANUAL', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.27.03', 'VALORES PAGOS POR CLASSIFICACAO DE DESPESA-', 'REGISTRA O ACOMPANHAMENTO DOS VALORES PAGOS PELO CONVENENTE CONTROLADOS POR CLASSIFICACAO DA DESPESA COM BASE NO PLANO DE CONTAS DA UNIAO', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.27.04', 'VALORES DEVOLVIDOS PARA CONTA UNICA', 'REGISTRA O ACOMPANHAMENTO DOS VALORES EXECUTADOS PELO CONVENENTE CONTROLADOS POR FONTEDE RECURSOS E NATUREZA DE DESPESA DETALHADA NO MOMENTO DA TRANSFERENCIA DE RECURSOS PARA A CONTA UNICAN PELO CONVENENTE PELA PRESTACAO DE CONTAS. O REGISTRO OCORRE NA UG CONCEDENTE DA TRANSFERENCIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.27.05', 'VALORES EMPENHADOS INSC. EM RESTOS A PAGAR', 'REGISTRA OS VALORES EMPENHADOS E INSCRITOS EM RESTOS A PAGAR RELATIVOSTRANSFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO, GERADOS A PARTIR DO PORTAL/SICONV', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.28.00', 'CONTROLE DE EST. DA DIVITA ATIVA TRIBUTARIA', 'REGISTRA OS VALORES RELATIVOS AO ESTOQUE DA DIVIDA ATIVA TRIBUTARIAPROVENIENTES DE TRIBUTOS, MULTAS DA FAZENDA NACIONAL LANCADOS NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO DE ORIGEM QUE CONSTITUIREM EM DIVIDA ATIVA. ROTINA INTEGRADA COM O SISTEMA DAU E O SIAFI.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.29.00', 'CONTROLE MATERIAL DE CONSUMO REQUISITADO', 'REGISTRA OS VALORES RELATIVOS AO CONTROLE DE MATERIAL DE CONSUMO REQUISITADO PELAS UNIDADES GESTORAS ÀS RESPECTIVAS SETORIAIS FINANCEIRAS', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.30.01', 'CONTROLE PASSIVO FINANCEIRO - PESSOAL', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO/CELULA DA DESPESA, POR EXEMPLO AS SEGUINTES SITUACÓES:OB CANCELADA REFERENTE A PAGAMENTO DE DESPESA DE EXERCICIO ANTERIORDECORRENTE DE FOLHA DE PESSOAL; OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLE DE EMPENHO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.30.02', 'CONTROLE PASSIVO FINANCEIRO - FORNECEDORES', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO/CELULA DA DESPESA, POR EXEMPLO AS SEGUINTES SITUACÓES: OB CANCELADA REFERENTE A PAGAMENTO DE DESPESA DE EXERCICIO ANTERIORDECORRENTE DE OUTRAS DESPESAS OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLE OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLEDE EMPENHO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.30.03', 'CONTROLE PASSIVO FINANCEIRO - SUPRIM. FUNDO', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO/CELULA DA DESPESA, POR EXEMPLO AS SEGUINTES SITUACÓES:OB CANCELADA REFERENTE A PAGAMENTO DE DESPESA DE EXERCICIO ANTERIOR DECORRENTE DE OUTRAS DESPESAS OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLE OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLEDE EMPENHO. RECOLHIMENTO DE TRIBUTO ESTADUAL EM OB, CUJO EMPENHO REFERESE A SUPRIMENTO DE FUNDOS, NAO PERMITINDO CONTA DIFERENTE DE TIPO "B"', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.30.04', 'CONTROLE PASSIVO FINANCEIRO - BENEFICIOS', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO/CELULA DA DESPESA, POR EXEMPLO AS SEGUINTES SITUACÓES: OB CANCELADA REFERENTE A PAGAMENTO DE DESPESA DE EXERCICIO ANTERIOR DECORRENTE PAGAMENTO DE PRECATORIOS DE BENEFICIOS OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLE OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLE DE EMPENHO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.30.05', 'CONTR.PASSIVO FINANC - OBRIG.TRIB SOBRE FAT', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO/CELULA DA DESPESA, POR EXEMPLO AS OBRIGACOES TRIBUTARIAS APROPRIADAS SOBRE O FATURAMENTO COMO PIS/PASEP, ISS, ETC.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.30.06', 'CONTR.PASSIVO FINANC - EMISSAO DARF SISCOME', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS APROPRIADOS NA ROTINA DO SISCOMEX, ONDE A APROPRIACAO REGISTRA DIRETAMENTO NOS VALORES PAGOS,POIS NO RECOLHIMENTO DO RESPECTIVO DARF NAO EH POSSIVEL INCLUIR O NUME RO DO EMPENHO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.30.07', 'CONTROLE PASSIVOS FINANCEIROS - NE', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO, PARA POSSIBILITAR APURACAO ESPECIAL E INCLUIR ESSES EMPENHOS NO CADASTRO DE EMPENHO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.30.08', 'CONTROLE DEMAIS PASSIVOS FINANCEIROS', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO/CELULA DA DESPESA, POREXEMPLO AS SEGUINTES SITUACÓES, NAO COMPREENDIDAS EM SUBITENS ESPECIFICOS: OB CANCELADA REFERENTE A PAGAMENTO DE DESPESA DE EXERCICIO ANTERIORDECORRENTE DE OUTRAS DESPESAS OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLE OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLE DE EMPENHO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.31.01', 'CUSTOS DE PRODUCAO A APROPRIAR', 'REGISTRA O CONTROLE ORCAMENTARIO DE CUSTOS DE PRODUCAO A APROPRIAR PELA COMPANHIA DE PESQUISA DE RECURSOS MINERAIS - CPRM.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.32.01', 'VALOR AUTORIZADO A CAPTAR', 'REGISTRAR A PREVISAO DE RECURSOS PUBLICOS NAO-FINANCEIROS E PRIVADOS, APROVADOS PARA CAPTACAO POSTERIOR JUNTO AAS PESSOAS FISICAS CONTRIBUINTES DO IMPOSTO DE RENDA NA MODALIDADE COMPLETA, E AAS PESSOAS JURIDICAS, CONTRIBUINTES DO IMPOSTO DE RENDA NA MODALIDADE DE LUCRO REAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.32.02', 'VALOR NÃO CAPTADO', 'REGISTRA OS VALORES DOS RECURSOS PUBLICOS NAO-FINANCEIROS DOS PROJETOS APROVADOS PELO MINC QUE NAO TIVERAM CAPTACAO OU REALIZARAM CAPTACAO PARCIAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.32.03', 'VALOR CAPTADO', 'REGISTRA OS RECURSOS PUBLICOS NAO-FINANCEIROS E PRIVADOS, CAPTADOS JUNTO AAS PESSOAS FISICAS CONTRIBUINTES DO IMPOSTO DE RENDA NA MODALIDADE COMPLETA, E AAS PESSOAS JURIDICAS, CONTRIBUINTES DO IMPOSTO DE RENDA NA MODALIDADE DE LUCRO REAL, DE ACORDO COM OS VALORES APROVADOS PELO MINISTERIO DA CULTURA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.32.11', 'VALOR RENUNCIÁVEL', 'REGISTRA A PARCELA DO VALOR CAPTADO QUE PODE SER OBJETO DE RENUNCIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.32.12', 'VALOR RENUNCIADO', 'REGISTRA OS RECURSOS NAO-FINANCEIROS DEBITADOS NO IMPOSTO DE RENDA DEVIDO DE PESSOAS FISICAS, NA MODALIDADE COMPLETA, E DE PESSOAS JURIDICAS, NA MODALIDADE DE LUCRO REAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.2.01.01', 'BENS DE ESTOQUE A RECEBER', 'REGISTRA O VALOR DOS BENS DE ESTOQUE A RECEBER,TRANSFERIDOS ENTRE UG,QUE NAO CHEGARAM AO SEU DESTINO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.2.01.02', 'BENS DE ESTOQUE ENVIADOS', 'REGISTRA O VALOR REFERENTE A TRANSFERENCIA DE BENS DE ESTOQUE ENVIADOS A OUTRA UG.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.2.01.03', 'MATERIAIS PARA REVENDA', 'REGISTRA O VALOR DAS TRANSFERENCIA DE MATERIAIS PARA REVENDA AINDA NAO RECEBIDOS PELA UG. BENEFICIADA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.2.02.01', 'BENS MOVEIS A RECEBER', 'REGISTRA O VALOR DOS BENS MOVEIS A RECEBER,TRANSFERIDOS ENTRE UG, QUE NAO CHEGARAM AO SEU DESTINO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.2.02.02', 'BENS MOVEIS ENVIADOS', 'REGISTRA O VALOR REFERENTE A TRANSFERENCIA DE BENS MOVEIS ENVIADOS AOUTRA UG.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.2.03.01', 'TITULOS E VALORES', 'REGISTRA OS VALORES E TITULOS TRANSFERIDOS PARA UNIDADES GESTORAS INTEGRANTES DO SIAFI .', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.2.03.02', 'CHEQUES DEVOLVIDOS', 'REGISTRA OS VALORES RECEBIDOS PELO BANCO DO BRASIL POR GRU COM CHEQUE SEM FUNDOS, QUE SERAO RESTITUIDOS AO BANCO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.2.04.00', 'MATERIAIS PARA REVENDA', 'REGISTRA OS VALORES DOS MATERIAIS PARA REVENDA EM TRANSITO ENTRE AS UG DO SIAFI.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.3.01.00', 'IMPORTACOES DE MATERIAIS', 'REGISTRA O VALOR DAS IMPORTACOES DE MATERIAIS EM CURSO, COM CONTROLE NAS CONTAS DE COMPENSACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.3.02.00', 'IMPORTACOES DE BENS', 'REGISTRA O VALOR DAS IMPORTACOES DE BENS EM CURSO, COM CONTROLE NAS CONTAS DE COMPENSACAO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.4.00.00', 'OBRAS EM FAVOR DE ENTIDADES', 'REGISTRA O VALOR REFERENTE A OBRAS EM PROPRIEDADE DE TERCEIROS, COM DOACAO IMEDIATA AO BENEFICIADO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.5.00.00', 'CONTAS EMITIDAS DE ENTIDADES', 'REGISTRA A PREVISAO DE RECEITAS PROVENIENTES DO FORNECIMENTO DE BENS OU SERVICOS, IDENTIFICANDO A SUA ORIGEM POR CONTROLE INDIVIDUALIZADO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.6.00.00', 'CREDORES - COMPRAS CENTRALIZADAS', 'REGISTRA OS VALORES DEVIDOS A FORNECEDORES REFERENTES A COMPRAS CENTRALIZADAS, COM OS BENS E/OU SERVICOS JA ENTREGUES A UNIDADE CONSUMIDORA E A DESPESA PENDENTE DE LIQUIDACAO PELA UNIDADE COMPRADORA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.7.00.00', 'RENEGOCIACAO DE DIVIDAS ESTADUAIS - SUBSIDIOS AOS ESTADOS', 'REGISTRA O VALOR DOS SUBSIDIOS RELATIVOS AOS REFINANCIAMENTO DE DIVIDAS ESTADUAIS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.8.00.00', 'CONTROLES DIVERSOS - EQUILIBRIO GRUPO', 'REGISTRA O VALOR RELATIVO COMPENSACOES DIVERSAS, PARA FECHAMENTO DO GRUPO 7999 X 8999.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.9.00.00', 'DIVERSOS CONTROLES', 'REGISTRA A RESPONSABILIDADE POR CONTROLES DIVERSOS.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS RECEBIDAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS RECEBIDAS POR AVAL NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR FIANCAS, PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.12', 'SEGUROS-GARANTIA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.19', 'GARANTIAS DA DIVIDA PUBLICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS DA DIVIDA PUBLICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.20', 'GARANTIAS DA DIVIDA PUBLICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS DA DIVIDA PUBLICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.21', 'GARANTIAS DA DIVIDA PUBLICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS DA DIVIDA PUBLICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.22', 'APOLICES DE SEGUROS A EXECUTAR', 'REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.23', 'APOLICES DE SEGUROS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.24', 'APOLICES DE SEGUROS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.25', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.26', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.27', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR AVAL NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.12', 'SEGUROS-GARANTIA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.19', 'GARANTIAS DA DIVIDA PUBLICA A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.20', 'GARANTIAS DA DIVIDA PUBLICA EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.21', 'GARANTIAS DA DIVIDA PUBLICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.22', 'APOLICES DE SEGUROS A EXECUTAR', 'REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.23', 'APOLICES DE SEGUROS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.24', 'APOLICES DE SEGUROS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.25', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.26', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.27', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.01', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.02', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.03', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.05', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.06', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.11', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.12', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.01', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.02', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.03', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.05', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.06', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.11', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.12', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS RECEBIDAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS RECEBIDAS POR AVAL NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR FIANCAS, PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.12', 'SEGUROS-GARANTIA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.19', 'GARANTIAS DA DIVIDA PUBLICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS DA DIVIDA PUBLICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.20', 'GARANTIAS DA DIVIDA PUBLICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS DA DIVIDA PUBLICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.21', 'GARANTIAS DA DIVIDA PUBLICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS DA DIVIDA PUBLICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.22', 'APOLICES DE SEGUROS A EXECUTAR', 'REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.23', 'APOLICES DE SEGUROS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.24', 'APOLICES DE SEGUROS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.25', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.26', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.27', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR AVAL NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.12', 'SEGUROS-GARANTIA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.19', 'GARANTIAS DA DIVIDA PUBLICA A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.20', 'GARANTIAS DA DIVIDA PUBLICA EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.21', 'GARANTIAS DA DIVIDA PUBLICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.22', 'APOLICES DE SEGUROS A EXECUTAR', 'REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.23', 'APOLICES DE SEGUROS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.24', 'APOLICES DE SEGUROS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.25', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.26', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.27', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.03.01', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.03.02', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.03.03', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.03.05', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.03.06', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.03.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.03.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.03.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.03.11', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.03.12', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.04.01', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.04.02', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.04.03', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.04.05', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.04.06', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.04.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.04.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.04.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.04.11', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.04.12', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS RECEBIDAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS RECEBIDAS POR AVAL NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR FIANCAS, PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.12', 'SEGUROS-GARANTIA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.19', 'GARANTIAS DA DIVIDA PUBLICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS DA DIVIDA PUBLICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.20', 'GARANTIAS DA DIVIDA PUBLICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS DA DIVIDA PUBLICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.21', 'GARANTIAS DA DIVIDA PUBLICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS DA DIVIDA PUBLICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.22', 'APOLICES DE SEGUROS A EXECUTAR', 'REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.23', 'APOLICES DE SEGUROS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.25', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.26', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.27', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR AVAL NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.12', 'SEGUROS-GARANTIA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.19', 'GARANTIAS DA DIVIDA PUBLICA A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.20', 'GARANTIAS DA DIVIDA PUBLICA EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.21', 'GARANTIAS DA DIVIDA PUBLICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.22', 'APOLICES DE SEGUROS A EXECUTAR', 'REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.23', 'APOLICES DE SEGUROS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.24', 'APOLICES DE SEGUROS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.25', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.26', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.27', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.03.01', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.03.02', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.03.03', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.03.05', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.03.06', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.03.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.03.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.03.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.03.11', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.03.12', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.04.01', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.04.02', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.04.03', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.04.05', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.04.06', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.04.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.04.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.04.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.04.11', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.04.12', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS RECEBIDAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS RECEBIDAS POR AVAL NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR FIANCAS, PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.12', 'SEGUROS-GARANTIA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.19', 'GARANTIAS DA DIVIDA PUBLICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS DA DIVIDA PUBLICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.20', 'GARANTIAS DA DIVIDA PUBLICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS DA DIVIDA PUBLICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.21', 'GARANTIAS DA DIVIDA PUBLICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS DA DIVIDA PUBLICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.22', 'APOLICES DE SEGUROS A EXECUTAR', 'REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.23', 'APOLICES DE SEGUROS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.24', 'APOLICES DE SEGUROS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.25', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.26', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.01.27', 'OUTRAS GARANTIAS RECEBIDAS NO PAIS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR AVAL NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.12', 'SEGUROS-GARANTIA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.19', 'GARANTIAS DA DIVIDA PUBLICA A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.20', 'GARANTIAS DA DIVIDA PUBLICA EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.21', 'GARANTIAS DA DIVIDA PUBLICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.22', 'APOLICES DE SEGUROS A EXECUTAR', 'REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.23', 'APOLICES DE SEGUROS EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.24', 'APOLICES DE SEGUROS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.25', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.26', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO', 'REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.27', 'OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.03.01', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.03.02', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.03.03', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.03.05', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.03.06', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.03.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.03.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.03.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.03.11', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.03.12', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.04.01', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.04.02', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.04.03', 'CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.04.05', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.04.06', 'CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.04.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.04.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.04.10', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.04.11', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.04.12', 'OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS', 'REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.01', 'CONVENIOS E INSTRUMENTOS CONGENERES A RECEBER', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.02', 'CONVENIOS E INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.03', 'CONVENIOS E INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.04', 'CONVENIOS E INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.05', 'CONVENIOS E INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.06', 'CONVENIOS E INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.07', 'CONVENIOS E INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIO FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.08', 'CONVENIOS E INSTRUMENTOS CONGENERES HOMOLOGADOS', 'REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.09', 'CONVENIOS E INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.10', 'CONVENIOS E INSTRUMENTOS CONGENERES NAO RECEBIDOS', 'REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.11', 'CONVENIOS E INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ENTRADA DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.12', 'CONVENIOS E INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.01', 'TERMO DE COOPERACAO A RECEBER', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERACAO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.02', 'TERMO DE COOPERACAO A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE TERMOS DE COOPERACAO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.03', 'TERMO DE COOPERACAO A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.04', 'TERMO DE COOPERACAO APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.05', 'TERMO DE COOPERACAO IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.06', 'TERMO DE COOPERACAO EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO TERMOS DE COOPERACAO FIRMADOS, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.07', 'TERMO DE COOPERACAO EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERACAO FIRMADOS, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.08', 'TERMO DE COOPERACAO CANCELADOS', 'REGISTRA O VALOR CANCELADO DO TERMOS DE COOPERACAO FIRMADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.09', 'TERMO DE COOPERACAO NAO RECEBIDOS', 'REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADOS DO TERMOS DE COOPERACAO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.10', 'TERMO DE COOPERACAO CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE TERMOS DE COOPERACAO FIRMADOS , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.01', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIQUIDAR', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIQUIDAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS - PORTAL/SICONV .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.02', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EXECUTADO POR INSCRICAO DE RESTOS A PAGAR', 'REGISTRA OS VALORES EXECUTADOS POR RESTOS A PAGAR PROVENIENTES DE TRANSFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO- PORTAL/SICONV.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.03', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES LIQUIDADO A RECEBER', 'REGISTRA OS VALORES LIQUIDADOS A RECEBER PROVENIENTES DE TRANSAFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.04', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A RECEBER', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.05', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.06', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.07', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.08', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.09', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.10', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.11', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS', 'REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.12', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.13', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO RECEBIDOS', 'REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.14', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.15', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.01.01', 'CONVENIOS E INSTRUMENTOS CONGENERES A RECEBER', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.01.02', 'CONVENIOS E INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.01.03', 'CONVENIOS E INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.01.04', 'CONVENIOS E INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.01.05', 'CONVENIOS E INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.01.06', 'CONVENIOS E INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.01.07', 'CONVENIOS E INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIO FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.01.08', 'CONVENIOS E INSTRUMENTOS CONGENERES HOMOLOGADOS', 'REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.01.09', 'CONVENIOS E INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.01.10', 'CONVENIOS E INSTRUMENTOS CONGENERES NAO RECEBIDOS', 'REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.01.11', 'CONVENIOS E INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ENTRADA DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.01.12', 'CONVENIOS E INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.02.01', 'TERMO DE COOPERACAO A RECEBER', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERACAO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.02.02', 'TERMO DE COOPERACAO A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE TERMOS DE COOPERACAO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.02.03', 'TERMO DE COOPERACAO A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.02.04', 'TERMO DE COOPERACAO APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.02.05', 'TERMO DE COOPERACAO IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.02.06', 'TERMO DE COOPERACAO EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO TERMOS DE COOPERACAO FIRMADOS, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.02.07', 'TERMO DE COOPERACAO EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERACAO FIRMADOS, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.02.08', 'TERMO DE COOPERACAO CANCELADOS', 'REGISTRA O VALOR CANCELADO DO TERMOS DE COOPERACAO FIRMADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.02.09', 'TERMO DE COOPERACAO NAO RECEBIDOS', 'REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADOS DO TERMOS DE COOPERACAO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.02.10', 'TERMO DE COOPERACAO CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE TERMOS DE COOPERACAO FIRMADOS , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.01', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIQUIDAR', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIQUIDAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS - PORTAL/SICONV', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.02', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EXECUTADO POR INSCRICAO DE RESTOS A PAGAR', 'REGISTRA OS VALORES EXECUTADOS POR RESTOS A PAGAR PROVENIENTES DE TRANSFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO- PORTAL/SICONV.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.03', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES LIQUIDADO A RECEBER', 'REGISTRA OS VALORES LIQUIDADOS A RECEBER PROVENIENTES DE TRANSAFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.04', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A RECEBER', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.05', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.06', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.07', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.08', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.09', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.10', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.11', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS', 'REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.12', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.13', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO RECEBIDOS', 'REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.14', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.15', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.01.01', 'CONVENIOS E INSTRUMENTOS CONGENERES A RECEBER', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.01.02', 'CONVENIOS E INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.01.03', 'CONVENIOS E INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.01.04', 'CONVENIOS E INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.01.05', 'CONVENIOS E INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.01.06', 'CONVENIOS E INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.01.07', 'CONVENIOS E INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIO FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.01.08', 'CONVENIOS E INSTRUMENTOS CONGENERES HOMOLOGADOS', 'REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.01.10', 'CONVENIOS E INSTRUMENTOS CONGENERES NAO RECEBIDOS', 'REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.01.11', 'CONVENIOS E INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ENTRADA DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.01.12', 'CONVENIOS E INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.02.01', 'TERMO DE COOPERACAO A RECEBER', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERACAO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.02.02', 'TERMO DE COOPERACAO A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE TERMOS DE COOPERACAO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.02.03', 'TERMO DE COOPERACAO A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.02.04', 'TERMO DE COOPERACAO APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.02.05', 'TERMO DE COOPERACAO IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.02.06', 'TERMO DE COOPERACAO EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO TERMOS DE COOPERACAO FIRMADOS, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.02.07', 'TERMO DE COOPERACAO EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERACAO FIRMADOS, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.02.08', 'TERMO DE COOPERACAO CANCELADOS', 'REGISTRA O VALOR CANCELADO DO TERMOS DE COOPERACAO FIRMADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.02.09', 'TERMO DE COOPERACAO NAO RECEBIDOS', 'REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADOS DO TERMOS DE COOPERACAO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.02.10', 'TERMO DE COOPERACAO CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE TERMOS DE COOPERACAO FIRMADOS , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.01', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIQUIDAR', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIQUIDAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS - PORTAL/SICONV', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.02', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EXECUTADO POR INSCRICAO DE RESTOS A PAGAR', 'REGISTRA OS VALORES EXECUTADOS POR RESTOS A PAGAR PROVENIENTES DE TRANSFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO- PORTAL/SICONV.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.03', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES LIQUIDADO A RECEBER', 'REGISTRA OS VALORES LIQUIDADOS A RECEBER PROVENIENTES DE TRANSAFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.04', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A RECEBER', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.05', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.06', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.07', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.08', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.09', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.10', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.11', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS', 'REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.12', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.13', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO RECEBIDOS', 'REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.14', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.15', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.01.01', 'CONVENIOS E INSTRUMENTOS CONGENERES A RECEBER', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.01.02', 'CONVENIOS E INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.01.03', 'CONVENIOS E INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.01.04', 'CONVENIOS E INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.01.05', 'CONVENIOS E INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.01.06', 'CONVENIOS E INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.01.07', 'CONVENIOS E INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIO FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.01.08', 'CONVENIOS E INSTRUMENTOS CONGENERES HOMOLOGADOS', 'REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.01.09', 'CONVENIOS E INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.01.10', 'CONVENIOS E INSTRUMENTOS CONGENERES NAO RECEBIDOS', 'REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.01.11', 'CONVENIOS E INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ENTRADA DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.01.12', 'CONVENIOS E INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.02.01', 'TERMO DE COOPERACAO A RECEBER', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERACAO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.02.02', 'TERMO DE COOPERACAO A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE TERMOS DE COOPERACAO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.02.03', 'TERMO DE COOPERACAO A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.02.04', 'TERMO DE COOPERACAO APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.02.05', 'TERMO DE COOPERACAO IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.02.06', 'TERMO DE COOPERACAO EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO TERMOS DE COOPERACAO FIRMADOS, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.02.07', 'TERMO DE COOPERACAO EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERACAO FIRMADOS, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.02.08', 'TERMO DE COOPERACAO CANCELADOS', 'REGISTRA O VALOR CANCELADO DO TERMOS DE COOPERACAO FIRMADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.02.09', 'TERMO DE COOPERACAO NAO RECEBIDOS', 'REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADOS DO TERMOS DE COOPERACAO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.02.10', 'TERMO DE COOPERACAO CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE TERMOS DE COOPERACAO FIRMADOS , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.01', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIQUIDAR', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIQUIDAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS - PORTAL/SICONV', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.02', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EXECUTADO POR INSCRICAO DE RESTOS A PAGAR', 'REGISTRA OS VALORES EXECUTADOS POR RESTOS A PAGAR PROVENIENTES DE TRANSFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO- PORTAL/SICONV.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.03', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES LIQUIDADO A RECEBER', 'REGISTRA OS VALORES LIQUIDADOS A RECEBER PROVENIENTES DE TRANSAFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.04', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A RECEBER', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.05', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.06', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.07', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.08', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.09', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.10', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.11', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS', 'REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.12', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.13', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO RECEBIDOS', 'REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.14', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.15', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.01.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS SERVICOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.01.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES APROPRIADOS RELATIVOS AOS SERVICOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.02.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A PRESTACAO DE SERVICOS, CONFORME INSTRUMENTO CONTRATUAL EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.02.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.03.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.03.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.04.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.04.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.05.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.05.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DE VALORES LIBERADOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.01', 'CONTRATOS A RECEBER', 'REGISTRA A APROPRIACAO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.02', 'CONTRATOS RECEBIDOS', 'REGISTRA A APROPRIACAO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.03', 'CONTRATOS AMORTIZADOS', 'REGISTRA A APROPRIACAO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETARIA E CAMBIAL REFERENTE A CONTRATOS DE OBRIGACOES INTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.04', 'JUROS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.05', 'JUROS PAGOS', 'REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.06', 'ENCARGOS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS ENCARGOS REFERENTES A CONTRATOS DE OBRIGA COES INTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.07', 'ENCARGOS PAGOS', 'REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES INTER-NAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.99', 'OUTROS CONTRATOS A RECEBER???', 'REGISTRA A APROPRIACAO OUTROS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE, NAO CONTEMPLADOS EM CONTA ESPECIFICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.01', 'CONTRATOS A RECEBER', 'REGISTRA A APROPRIACAO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES EXTERNAS CONSTANTES DO ORCAMENTO DO EXERCICIO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.02', 'CONTRATOS RECEBIDOS', 'REGISTRA A APROPRIACAO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGACOES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.03', 'CONTRATOS AMORTIZADOS', 'REGISTRA A APROPRIACAO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETA-RIA E CAMBIAL REFERENTES A CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.04', 'JUROS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES EXTER NAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.05', 'JUROS PAGOS', 'REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.06', 'ENCARGOS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.07', 'ENCARGOS PAGOS', 'REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.08', 'CONTRATOS TRANSFERIDOS', 'REGISTRA A APROPRIACAO DOS VALORES TRANSFERIDOS REFERENTES A CONTRATOS DE OBRIGACOES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.99', 'OUTROS CONTRATOS A RECEBER???', 'REGISTRA A APROPRIACAO DE OUTROS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES EXTERNAS, NAO CONTEMPLADOS EM CONTA ESPECIFICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.08.01', 'TERMOS/ACORDOS P/FORNECIM. DE BENS S/ORCAM.', 'REGISTRA O VALOR DE TERMOS E ACORDOS COM FORNECIMENTO DE BENS SEM SUPORTE ORCAMENTARIO. COMPENSACAO PATRIMONIAL COM PERMUTA DE SERVICOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.01.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS SERVICOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.01.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES APROPRIADOS RELATIVOS AOS SERVICOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.02.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A PRESTACAO DE SERVICOS, CONFORME INSTRUMENTO CONTRATUAL EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.02.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.03.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.03.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.04.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.04.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.05.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.05.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DE VALORES LIBERADOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.06.01', 'CONTRATOS A RECEBER', 'REGISTRA A APROPRIACAO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.06.02', 'CONTRATOS RECEBIDOS', 'REGISTRA A APROPRIACAO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.06.03', 'CONTRATOS AMORTIZADOS', 'REGISTRA A APROPRIACAO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETARIA E CAMBIAL REFERENTE A CONTRATOS DE OBRIGACOES INTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.06.04', 'JUROS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.06.05', 'JUROS PAGOS', 'REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.06.06', 'ENCARGOS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS ENCARGOS REFERENTES A CONTRATOS DE OBRIGA COES INTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.06.07', 'ENCARGOS PAGOS', 'REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES INTER-NAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.06.99', 'OUTROS CONTRATOS A RECEBER???', 'REGISTRA A APROPRIACAO OUTROS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE, NAO CONTEMPLADOS EM CONTA ESPECIFICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.07.01', 'CONTRATOS A RECEBER', 'REGISTRA A APROPRIACAO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES EXTERNAS CONSTANTES DO ORCAMENTO DO EXERCICIO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.07.02', 'CONTRATOS RECEBIDOS', 'REGISTRA A APROPRIACAO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGACOES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.07.03', 'CONTRATOS AMORTIZADOS', 'REGISTRA A APROPRIACAO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETA-RIA E CAMBIAL REFERENTES A CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.07.04', 'JUROS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES EXTER NAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.07.05', 'JUROS PAGOS', 'REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.07.06', 'ENCARGOS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.07.07', 'ENCARGOS PAGOS', 'REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.07.08', 'CONTRATOS TRANSFERIDOS', 'REGISTRA A APROPRIACAO DOS VALORES TRANSFERIDOS REFERENTES A CONTRATOS DE OBRIGACOES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.07.99', 'OUTROS CONTRATOS A RECEBER???', 'REGISTRA A APROPRIACAO DE OUTROS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES EXTERNAS, NAO CONTEMPLADOS EM CONTA ESPECIFICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.08.01', 'TERMOS/ACORDOS P/FORNECIM. DE BENS S/ORCAM.', 'REGISTRA O VALOR DE TERMOS E ACORDOS COM FORNECIMENTO DE BENS SEM SUPORTE ORCAMENTARIO. COMPENSACAO PATRIMONIAL COM PERMUTA DE SERVICOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.01.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS SERVICOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.01.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES APROPRIADOS RELATIVOS AOS SERVICOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.02.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A PRESTACAO DE SERVICOS, CONFORME INSTRUMENTO CONTRATUAL EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.02.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.03.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.03.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.04.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.04.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.05.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.05.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DE VALORES LIBERADOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.06.01', 'CONTRATOS A RECEBER', 'REGISTRA A APROPRIACAO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.06.02', 'CONTRATOS RECEBIDOS', 'REGISTRA A APROPRIACAO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.06.03', 'CONTRATOS AMORTIZADOS', 'REGISTRA A APROPRIACAO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETARIA E CAMBIAL REFERENTE A CONTRATOS DE OBRIGACOES INTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.06.04', 'JUROS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.06.05', 'JUROS PAGOS', 'REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.06.06', 'ENCARGOS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS ENCARGOS REFERENTES A CONTRATOS DE OBRIGA COES INTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.06.07', 'ENCARGOS PAGOS', 'REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES INTER-NAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.06.99', 'OUTROS CONTRATOS A RECEBER???', 'REGISTRA A APROPRIACAO OUTROS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE, NAO CONTEMPLADOS EM CONTA ESPECIFICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.07.01', 'CONTRATOS A RECEBER', 'REGISTRA A APROPRIACAO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES EXTERNAS CONSTANTES DO ORCAMENTO DO EXERCICIO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.07.02', 'CONTRATOS RECEBIDOS', 'REGISTRA A APROPRIACAO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGACOES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.07.03', 'CONTRATOS AMORTIZADOS', 'REGISTRA A APROPRIACAO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETA-RIA E CAMBIAL REFERENTES A CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.07.04', 'JUROS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES EXTER NAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.07.05', 'JUROS PAGOS', 'REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.07.06', 'ENCARGOS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.07.07', 'ENCARGOS PAGOS', 'REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.07.08', 'CONTRATOS TRANSFERIDOS', 'REGISTRA A APROPRIACAO DOS VALORES TRANSFERIDOS REFERENTES A CONTRATOS DE OBRIGACOES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.07.99', 'OUTROS CONTRATOS A RECEBER???', 'REGISTRA A APROPRIACAO DE OUTROS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES EXTERNAS, NAO CONTEMPLADOS EM CONTA ESPECIFICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.08.01', 'TERMOS/ACORDOS P/FORNECIM. DE BENS S/ORCAM.', 'REGISTRA O VALOR DE TERMOS E ACORDOS COM FORNECIMENTO DE BENS SEM SUPORTE ORCAMENTARIO. COMPENSACAO PATRIMONIAL COM PERMUTA DE SERVICOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.01.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS SERVICOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.01.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES APROPRIADOS RELATIVOS AOS SERVICOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.02.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A PRESTACAO DE SERVICOS, CONFORME INSTRUMENTO CONTRATUAL EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.02.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.03.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.03.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.04.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.04.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.05.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.05.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DE VALORES LIBERADOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.06.01', 'CONTRATOS A RECEBER', 'REGISTRA A APROPRIACAO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.06.02', 'CONTRATOS RECEBIDOS', 'REGISTRA A APROPRIACAO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.06.03', 'CONTRATOS AMORTIZADOS', 'REGISTRA A APROPRIACAO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETARIA E CAMBIAL REFERENTE A CONTRATOS DE OBRIGACOES INTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.06.04', 'JUROS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.06.05', 'JUROS PAGOS', 'REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.06.06', 'ENCARGOS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS ENCARGOS REFERENTES A CONTRATOS DE OBRIGA COES INTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.06.07', 'ENCARGOS PAGOS', 'REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES INTER-NAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.06.99', 'OUTROS CONTRATOS A RECEBER???', 'REGISTRA A APROPRIACAO OUTROS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE, NAO CONTEMPLADOS EM CONTA ESPECIFICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.07.01', 'CONTRATOS A RECEBER', 'REGISTRA A APROPRIACAO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES EXTERNAS CONSTANTES DO ORCAMENTO DO EXERCICIO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.07.02', 'CONTRATOS RECEBIDOS', 'REGISTRA A APROPRIACAO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGACOES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.07.03', 'CONTRATOS AMORTIZADOS', 'REGISTRA A APROPRIACAO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETA-RIA E CAMBIAL REFERENTES A CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.07.04', 'JUROS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES EXTER NAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.07.05', 'JUROS PAGOS', 'REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.07.06', 'ENCARGOS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.07.07', 'ENCARGOS PAGOS', 'REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.07.08', 'CONTRATOS TRANSFERIDOS', 'REGISTRA A APROPRIACAO DOS VALORES TRANSFERIDOS REFERENTES A CONTRATOS DE OBRIGACOES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.07.99', 'OUTROS CONTRATOS A RECEBER???', 'REGISTRA A APROPRIACAO DE OUTROS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES EXTERNAS, NAO CONTEMPLADOS EM CONTA ESPECIFICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.08.01', 'TERMOS/ACORDOS P/FORNECIM. DE BENS S/ORCAM.', 'REGISTRA O VALOR DE TERMOS E ACORDOS COM FORNECIMENTO DE BENS SEM SUPORTE ORCAMENTARIO. COMPENSACAO PATRIMONIAL COM PERMUTA DE SERVICOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.9.1.00.00', 'EXECUCAO DE OUTROS ATOS POTENCIAIS ATIVOS - CONSOLIDACAO', 'COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.9.2.00.00', 'EXECUCAO DE OUTROS ATOS POTENCIAIS ATIVOS - INTRA OFSS', 'COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.9.4.00.00', 'EXECUCAO DE OUTROS ATOS POTENCIAIS ATIVOS - INTER OFSS - ESTADO', 'COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.9.5.00.00', 'EXECUCAO DE OUTROS ATOS POTENCIAIS ATIVOS - INTER OFSS - MUNICIPIO', 'COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS GARANTIAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.12', 'SEGUROS-GARANTIA EXECUTADOS', 'REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.19', 'OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.20', 'OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.21', 'OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.12', 'SEGUROS-GARANTIA EXECUTADOS', 'REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.19', 'OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.20', 'OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.21', 'OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.02', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.03', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.05', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGOS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.06', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.11', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.12', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.02', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.03', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.05', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.06', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.11', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.12', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS GARANTIAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.12', 'SEGUROS-GARANTIA EXECUTADOS', 'REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.19', 'OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.20', 'OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.21', 'OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.12', 'SEGUROS-GARANTIA EXECUTADOS', 'REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.19', 'OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.20', 'OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.21', 'OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.03.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.03.02', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.03.03', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.03.05', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGOS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.03.06', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.03.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.03.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.03.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.03.11', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.03.12', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.04.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.04.02', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.04.03', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.04.05', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.04.06', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.04.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.04.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.04.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.04.11', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.04.12', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS GARANTIAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.12', 'SEGUROS-GARANTIA EXECUTADOS', 'REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.19', 'OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.20', 'OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.21', 'OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.12', 'SEGUROS-GARANTIA EXECUTADOS', 'REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.19', 'OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.20', 'OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.21', 'OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.03.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.03.02', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.03.03', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.03.05', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGOS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.03.06', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.03.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.03.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.03.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.03.11', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.03.12', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.04.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.04.02', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.04.03', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.04.05', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.04.06', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.04.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.04.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.04.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.04.11', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.04.12', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS GARANTIAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.12', 'SEGUROS-GARANTIA EXECUTADOS', 'REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.19', 'OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.20', 'OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS EM EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.21', 'OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.01', 'AVAIS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.02', 'AVAIS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.03', 'AVAIS EXECUTADOS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.04', 'FIANCAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.05', 'FIANCAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.06', 'FIANCAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.07', 'HIPOTECAS A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.08', 'HIPOTECAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.09', 'HIPOTECAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.10', 'SEGUROS-GARANTIA A EXECUTAR', 'REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.11', 'SEGUROS-GARANTIA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.12', 'SEGUROS-GARANTIA EXECUTADOS', 'REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.13', 'CAUCAO A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.14', 'CAUCAO EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.15', 'CAUCAO EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.16', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.17', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.18', 'GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA', 'REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.19', 'OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.20', 'OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO', 'REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.21', 'OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.03.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.03.02', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.03.03', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.03.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.03.05', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGOS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.03.06', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.03.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.03.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.03.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.03.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.03.11', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.03.12', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.04.01', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.04.02', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.04.03', 'CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.04.04', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.04.05', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.04.06', 'CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.04.07', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.04.08', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO', 'REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.04.09', 'CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS', 'REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.04.10', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR A EXECUTAR', 'REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.04.11', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EM EXECUCAO', 'REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.04.12', 'OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EXECUTADAS', 'REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.01', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIBERAR', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIBERAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.02', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.03', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.04', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.05', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.06', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.07', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIOE OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.08', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS', 'REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.09', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.10', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS', 'REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.11', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.12', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.01', 'CONTRATOS DE REPASSE DE PROGRAMAS A LIBERAR', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.02', 'CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.03', 'CONTRATOS DE REPASSE DE PROGRAMAS POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR, COM CONTROLE POR CNPJ', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.04', 'CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS, COM CONTROLE POR CNPJ', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.06', 'CONTR.REPASSE DE PROGR. APROVADO', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.07', 'CONTR.REPASSE DE PROGR. HOMOLOGADO', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.08', 'CONTR.REPASSE DE PROGR. IMPUGNADO', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.09', 'CONTR.REPASSE DE PROGR. INADIMPLENTE', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS PELO GESTOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.10', 'CONTR.REPASSE DE PROGR. A APROVAR POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.11', 'CONTR.REPASSE DE PROGR. APROVADO POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.12', 'CONTR.REPASSE DE PROGR. HOMOLOGADO POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.13', 'CONTR.REPASSE DE PROGR. IMPUGNADO POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.14', 'CONTR.REPASSE DE PROGR. INADIMPLENTE POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS PELO GESTOR, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.15', 'CONTR.REPASSE DE PROGR. NAO LIBERADO POR CNPJ.', 'REGISTRA OS VALORES NAO LIBERADOS DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.01', 'TRANSFERENCIAS LEGAIS A LIBERAR', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO A LIBERAR CELEBRADOS NO AMBITO DA ANCINE E DO MTE, RESPECTIVAMENTE', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.02', 'TRANSFERENCIAS LEGAIS A COMPROVAR', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO A COMPROVAR, FIRMADOS NO AMBITO DA ANCINE E DO MTE, RESPECTIVAMENTE', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.03', 'TRANSFERENCIAS LEGAIS A APROVAR', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELAS ENTIDADES COM FINS LUCRATIVOS E PELOS ESTADOS, DF E MUNICIPIOS, RESPECTIVAMENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.04', 'TRANSFERENCIAS LEGAIS APROVADO', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO, QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO CONCEDENTE, ANCINE E MTE, RESPECTIVAMENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.05', 'TRANSFERENCIAS LEGAIS IMPUGNADO', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.06', 'TRANSFERENCIAS LEGAIS INADIMPLENCIA', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADE SAO QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS A SER REALIZADA PE LAS ENTIDADES PRIVADAS COM FINS LUCRATIVOS E PELOS ESTADOS, DF E MUNICIPIOS, RESPECTIVAMENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.07', 'TRANSFERENCIAS LEGAIS CONCLUIDO', 'REGISTRA O VALOR CONCLUIDO DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO, APOS APROVACAO TOTAL DA PRESTACAO DE CONTAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.04.01', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIQUIDAR A LIBERAR', 'REGISTRA A EXECUCAO DOS VALORES A LIQUIDAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.04.02', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES LIQUIDADO A LIBERAR', 'REGISTRA OS VALORES LIQUIDADOS A LIBERAR PROVENIENTES DE TRANSAFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.04.03', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.04.04', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.04.05', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.04.06', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.04.07', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.04.08', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIOE OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.04.09', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.04.10', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS', 'REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.04.11', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.04.12', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.01.01', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIBERAR', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIBERAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.01.02', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.01.03', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.01.04', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.01.05', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.01.06', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.01.07', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIOE OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.01.08', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS', 'REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.01.09', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.01.10', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS', 'REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.01.11', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.01.12', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.01', 'CONTRATOS DE REPASSE DE PROGRAMAS A LIBERAR', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.02', 'CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.03', 'CONTRATOS DE REPASSE DE PROGRAMAS POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR, COM CONTROLE POR CNPJ', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.04', 'CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS, COM CONTROLE POR CNPJ', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.05', 'CONTR.REPASSE DE PROGR. A APROVAR', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.06', 'CONTR.REPASSE DE PROGR. APROVADO', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.07', 'CONTR.REPASSE DE PROGR. HOMOLOGADO', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.08', 'CONTR.REPASSE DE PROGR. IMPUGNADO', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.09', 'CONTR.REPASSE DE PROGR. INADIMPLENTE', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS PELO GESTOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.10', 'CONTR.REPASSE DE PROGR. A APROVAR POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.11', 'CONTR.REPASSE DE PROGR. APROVADO POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.12', 'CONTR.REPASSE DE PROGR. HOMOLOGADO POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.13', 'CONTR.REPASSE DE PROGR. IMPUGNADO POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.14', 'CONTR.REPASSE DE PROGR. INADIMPLENTE POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS PELO GESTOR, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.15', 'CONTR.REPASSE DE PROGR. NAO LIBERADO POR CNPJ.', 'REGISTRA OS VALORES NAO LIBERADOS DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.03.01', 'TRANSFERENCIAS LEGAIS A LIBERAR', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO A LIBERAR CELEBRADOS NO AMBITO DA ANCINE E DO MTE, RESPECTIVAMENTE', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.03.02', 'TRANSFERENCIAS LEGAIS A COMPROVAR', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO A COMPROVAR, FIRMADOS NO AMBITO DA ANCINE E DO MTE, RESPECTIVAMENTE', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.03.03', 'TRANSFERENCIAS LEGAIS A APROVAR', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELAS ENTIDADES COM FINS LUCRATIVOS E PELOS ESTADOS, DF E MUNICIPIOS, RESPECTIVAMENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.03.04', 'TRANSFERENCIAS LEGAIS APROVADO', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO, QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO CONCEDENTE, ANCINE E MTE, RESPECTIVAMENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.03.05', 'TRANSFERENCIAS LEGAIS IMPUGNADO', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.03.06', 'TRANSFERENCIAS LEGAIS INADIMPLENCIA', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADE SAO QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS A SER REALIZADA PE LAS ENTIDADES PRIVADAS COM FINS LUCRATIVOS E PELOS ESTADOS, DF E MUNICIPIOS, RESPECTIVAMENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.03.07', 'TRANSFERENCIAS LEGAIS CONCLUIDO', 'REGISTRA O VALOR CONCLUIDO DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO, APOS APROVACAO TOTAL DA PRESTACAO DE CONTAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.04.01', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIQUIDAR A LIBERAR', 'REGISTRA A EXECUCAO DOS VALORES A LIQUIDAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.04.02', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES LIQUIDADO A LIBERAR', 'REGISTRA OS VALORES LIQUIDADOS A LIBERAR PROVENIENTES DE TRANSAFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.04.03', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.04.04', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.04.05', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.04.06', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.04.07', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.04.08', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIOE OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.04.09', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.04.10', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS', 'REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.04.11', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.04.12', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.01.01', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIBERAR', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIBERAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.01.02', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.01.03', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.01.04', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.01.05', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.01.06', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.01.07', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIOE OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.01.08', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS', 'REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.01.09', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.01.10', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS', 'REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.01.11', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.01.12', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.01', 'CONTRATOS DE REPASSE DE PROGRAMAS A LIBERAR', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.02', 'CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.03', 'CONTRATOS DE REPASSE DE PROGRAMAS POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR, COM CONTROLE POR CNPJ', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.04', 'CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS, COM CONTROLE POR CNPJ', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.05', 'CONTR.REPASSE DE PROGR. A APROVAR', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.06', 'CONTR.REPASSE DE PROGR. APROVADO', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.07', 'CONTR.REPASSE DE PROGR. HOMOLOGADO', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.08', 'CONTR.REPASSE DE PROGR. IMPUGNADO', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.09', 'CONTR.REPASSE DE PROGR. INADIMPLENTE', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS PELO GESTOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.10', 'CONTR.REPASSE DE PROGR. A APROVAR POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.11', 'CONTR.REPASSE DE PROGR. APROVADO POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.12', 'CONTR.REPASSE DE PROGR. HOMOLOGADO POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.13', 'CONTR.REPASSE DE PROGR. IMPUGNADO POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.14', 'CONTR.REPASSE DE PROGR. INADIMPLENTE POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS PELO GESTOR, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.15', 'CONTR.REPASSE DE PROGR. NAO LIBERADO POR CNPJ.', 'REGISTRA OS VALORES NAO LIBERADOS DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.03.01', 'TRANSFERENCIAS LEGAIS A LIBERAR', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO A LIBERAR CELEBRADOS NO AMBITO DA ANCINE E DO MTE, RESPECTIVAMENTE', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.03.02', 'TRANSFERENCIAS LEGAIS A COMPROVAR', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO A COMPROVAR, FIRMADOS NO AMBITO DA ANCINE E DO MTE, RESPECTIVAMENTE', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.03.03', 'TRANSFERENCIAS LEGAIS A APROVAR', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELAS ENTIDADES COM FINS LUCRATIVOS E PELOS ESTADOS, DF E MUNICIPIOS, RESPECTIVAMENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.03.04', 'TRANSFERENCIAS LEGAIS APROVADO', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO, QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO CONCEDENTE, ANCINE E MTE, RESPECTIVAMENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.03.05', 'TRANSFERENCIAS LEGAIS IMPUGNADO', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.03.06', 'TRANSFERENCIAS LEGAIS INADIMPLENCIA', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADE SAO QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS A SER REALIZADA PE LAS ENTIDADES PRIVADAS COM FINS LUCRATIVOS E PELOS ESTADOS, DF E MUNICIPIOS, RESPECTIVAMENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.03.07', 'TRANSFERENCIAS LEGAIS CONCLUIDO', 'REGISTRA O VALOR CONCLUIDO DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO, APOS APROVACAO TOTAL DA PRESTACAO DE CONTAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.04.01', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIQUIDAR A LIBERAR', 'REGISTRA A EXECUCAO DOS VALORES A LIQUIDAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.04.02', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES LIQUIDADO A LIBERAR', 'REGISTRA OS VALORES LIQUIDADOS A LIBERAR PROVENIENTES DE TRANSAFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.04.03', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.04.04', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.04.05', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.04.06', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.04.07', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.04.08', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIOE OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.04.09', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.04.10', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS', 'REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.04.11', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.04.12', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.01.01', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIBERAR', 'REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIBERAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.01.02', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.01.03', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.01.04', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.01.05', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.01.06', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.01.07', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIOE OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.01.08', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS', 'REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.01.09', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.01.10', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS', 'REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.01.11', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.01.12', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.01', 'CONTRATOS DE REPASSE DE PROGRAMAS A LIBERAR', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.02', 'CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.03', 'CONTRATOS DE REPASSE DE PROGRAMAS POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR, COM CONTROLE POR CNPJ', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.04', 'CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS, COM CONTROLE POR CNPJ', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.05', 'CONTR.REPASSE DE PROGR. A APROVAR', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.06', 'CONTR.REPASSE DE PROGR. APROVADO', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.07', 'CONTR.REPASSE DE PROGR. HOMOLOGADO', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.08', 'CONTR.REPASSE DE PROGR. IMPUGNADO', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.09', 'CONTR.REPASSE DE PROGR. INADIMPLENTE', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS PELO GESTOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.10', 'CONTR.REPASSE DE PROGR. A APROVAR POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.11', 'CONTR.REPASSE DE PROGR. APROVADO POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.12', 'CONTR.REPASSE DE PROGR. HOMOLOGADO POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.13', 'CONTR.REPASSE DE PROGR. IMPUGNADO POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.14', 'CONTR.REPASSE DE PROGR. INADIMPLENTE POR CNPJ', 'REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS PELO GESTOR, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.15', 'CONTR.REPASSE DE PROGR. NAO LIBERADO POR CNPJ.', 'REGISTRA OS VALORES NAO LIBERADOS DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS, COM CONTROLE POR CNPJ.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.03.01', 'TRANSFERENCIAS LEGAIS A LIBERAR', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO A LIBERAR CELEBRADOS NO AMBITO DA ANCINE E DO MTE, RESPECTIVAMENTE', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.03.02', 'TRANSFERENCIAS LEGAIS A COMPROVAR', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO A COMPROVAR, FIRMADOS NO AMBITO DA ANCINE E DO MTE, RESPECTIVAMENTE', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.03.03', 'TRANSFERENCIAS LEGAIS A APROVAR', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELAS ENTIDADES COM FINS LUCRATIVOS E PELOS ESTADOS, DF E MUNICIPIOS, RESPECTIVAMENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.03.04', 'TRANSFERENCIAS LEGAIS APROVADO', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO, QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO CONCEDENTE, ANCINE E MTE, RESPECTIVAMENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.03.05', 'TRANSFERENCIAS LEGAIS IMPUGNADO', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.03.06', 'TRANSFERENCIAS LEGAIS INADIMPLENCIA', 'REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADE SAO QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS A SER REALIZADA PE LAS ENTIDADES PRIVADAS COM FINS LUCRATIVOS E PELOS ESTADOS, DF E MUNICIPIOS, RESPECTIVAMENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.03.07', 'TRANSFERENCIAS LEGAIS CONCLUIDO', 'REGISTRA O VALOR CONCLUIDO DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO, APOS APROVACAO TOTAL DA PRESTACAO DE CONTAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.04.01', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIQUIDAR A LIBERAR', 'REGISTRA A EXECUCAO DOS VALORES A LIQUIDAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.04.02', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES LIQUIDADO A LIBERAR', 'REGISTRA OS VALORES LIQUIDADOS A LIBERAR PROVENIENTES DE TRANSAFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.04.03', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR', 'REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.04.04', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR', 'REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.04.05', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS', 'REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.04.06', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS', 'REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.04.07', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA', 'REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.04.08', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA', 'REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIOE OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.04.09', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS', 'REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.04.10', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS', 'REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.04.11', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS', 'REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.04.12', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS', 'REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.01.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.01.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.02.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.02.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.03.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.03.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.04.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS POR TERCEIROS A ADMINISTRACAO PUBLICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.04.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS POR ADMINISTRACAO A PUBLICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.05.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.05.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DE VALORES A LIBERAREDOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.01', 'CONTRATOS A LIBERAR', 'REGISTRA A EXECUCAO DOS VALORES A LIBERAR DOS CONTRATOS DE EMPRESTIMO CONCEDIDO PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO COM OS BANCOS PRIVADOS E OFICIAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.02', 'EMPRESTIMOS LIBERADOS', 'REGISTRA A EXECUCAO DOS VALORES LIBERADOS DE EMPRESTIMOS VINCULADO A CONTRATO COM BANCOS PRIVADOS, PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.03', 'EMPRESTIMOS LIBERADOS - RP', 'REGISTRA A EXECUCAO DOS VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DECREDITO (PRINCIPAL).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.04', 'EMPRESTIMOS REEMBOLSADOS - PRINCIPAL', 'REGISTRA A EXECUCAO DOS VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (JUROS).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.05', 'EMPRESTIMOS REEMBOLSADOS - JUROS', 'REGISTRA A EXECUCAO DOS O VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (SANCOES).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.06', 'EMPRESTIMOS REEMBOLSADOS - SANCOES', 'REGISTRA A EXECUCAO DOS VALORES DAS OPERACOES EQUALIZADAS DECORRENTES DE CONTRATOS DEFINANCIAMENTO DE O2C.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.07', 'OPERACOES EQUALIZADAS', 'REGISTRA A EXECUCAO DOS VALORES DAS OPERACOES EQUALIZADAS REFERENTE A RESTOS A PAGAR,DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (PRINCIPAL).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.08', 'OPERACOES EQUALIZADAS - RP', 'REGISTRA A EXECUCAO DOS VALORES DOS EMPRESTIMOS LIBERADOS - REFERENTES A RESTOS APAGAR, PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.09', 'ALIENACAO ESTOQUES EST./REG./INDENIZ. - AGF', 'REGISTRA A EXECUCAO DOS VALORES DAS RECEITAS DECORRENTES DE ALINACOES DE ESTOQUES REGULADORES/ESTRATEGICOS E INDENIZACOES VINCULADOS A POLITICA DE GARANTIA DE PRECOS MINIMOS - PGPM - REALIZADAS PELA CONAB.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.10', 'REMUNERACAO - CUSTOS ADMINISTRATIVOS', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES AOS CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO, CONFORME PREVISTO EM CONTRATO. DECISAO TCU 498/2002, DE 15 DE MARCO DE 2002.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.11', 'REMUNERACAO - CUSTOS ADMINISTRATIVOS - RAP', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTOS A PAGAR DE CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO, CONFORME PREVISTO EM CONTRATO. DECISAO TCU 498, DE 15 DE MARCO DE 2002.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.12', 'RESTITUICAO', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTITUICOES DEVIDAS POR ORGAOS E ENTIDADES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.13', 'RESTITUICAO - RP', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTITUICOES DEVIDAS POR ORGAOS E ENTIDADES (RESTOS A PAGAR).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.07.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAOS DOS VALORES A LIBERAR RELATIVOS A OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.07.02', 'EXECUTADOS', 'REGISTRA A EXECUCAOS DOS VALORES LIBERADOS RELATIVOS A OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.08.00', 'CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC', 'COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORESDOS CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.08.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS SERVICOS A REALIZAR RELATIVOS A CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.08.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS SERVICOS REALIZADOS RELATIVOS A CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.09.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS SERVICOS A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.09.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS SERVICOS REALIZADOS RELATIVOS A CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.10.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES RELATIVOS A ALUGUEL A APROPRIAR DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.10.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES RELATIVOS A ALUGUEL APROPRIADO DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.11.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A EXECUTAR DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.11.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A EXECUTADOS DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.12.01', 'CONTRATOS DE GESTAO A LIQUIDAR', 'REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.12.02', 'CONTRATOS DE GESTAO LIQUIDADOS', 'REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.13.01', 'A LIBERAR', 'REGISTRO DO VALOR TOTAL DO ACORDO A LIBERAR, BAIXANDO A MEDIDA DA TRANSFERENCIA DOS RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.13.02', 'A COMPROVAR', 'REGISTRO DO VALOR TOTAL DO ACORDO LIBERADO E PENDENTE DE COMPROVACAO DA SUA EFETIVA UTILIZACAO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.13.03', 'COMPROVADO', 'REGISTRO O VALOR DOS RECURSOS LIBERADOS E QUE TIVERAM SUA EFETIVA UTILIZACAO COMPROVADA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.13.04', 'CONCLUIDO', 'REGISTRO O VALOR DOS RECURSOS LIBERADOS E QUE TIVERAM SUA EFETIVA UTILIZACAO CONCLUIDA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.14.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DO VALOR DO CONTRATO A LIBERAR DECORRENTE DE OPERACOES DE CREDITO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.14.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DO VALOR DO CONTRATO LIBERADO DECORRENTE DE OPERACOES DE CREDITO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.01.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.01.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.02.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.02.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.03.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.03.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.04.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS POR TERCEIROS A ADMINISTRACAO PUBLICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.04.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS POR ADMINISTRACAO A PUBLICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.05.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.05.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DE VALORES A LIBERAREDOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.06.01', 'CONTRATOS A LIBERAR', 'REGISTRA A EXECUCAO DOS VALORES A LIBERAR DOS CONTRATOS DE EMPRESTIMO CONCEDIDO PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO COM OS BANCOS PRIVADOS E OFICIAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.06.02', 'EMPRESTIMOS LIBERADOS', 'REGISTRA A EXECUCAO DOS VALORES LIBERADOS DE EMPRESTIMOS VINCULADO A CONTRATO COM BANCOS PRIVADOS, PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.06.03', 'EMPRESTIMOS LIBERADOS - RP', 'REGISTRA A EXECUCAO DOS VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DECREDITO (PRINCIPAL).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.06.04', 'EMPRESTIMOS REEMBOLSADOS - PRINCIPAL', 'REGISTRA A EXECUCAO DOS VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (JUROS).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.06.05', 'EMPRESTIMOS REEMBOLSADOS - JUROS', 'REGISTRA A EXECUCAO DOS O VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (SANCOES).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.06.06', 'EMPRESTIMOS REEMBOLSADOS - SANCOES', 'REGISTRA A EXECUCAO DOS VALORES DAS OPERACOES EQUALIZADAS DECORRENTES DE CONTRATOS DEFINANCIAMENTO DE O2C.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.06.07', 'OPERACOES EQUALIZADAS', 'REGISTRA A EXECUCAO DOS VALORES DAS OPERACOES EQUALIZADAS REFERENTE A RESTOS A PAGAR,DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (PRINCIPAL).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.06.08', 'OPERACOES EQUALIZADAS - RP', 'REGISTRA A EXECUCAO DOS VALORES DOS EMPRESTIMOS LIBERADOS - REFERENTES A RESTOS APAGAR, PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.06.09', 'ALIENACAO ESTOQUES EST./REG./INDENIZ. - AGF', 'REGISTRA A EXECUCAO DOS VALORES DAS RECEITAS DECORRENTES DE ALINACOES DE ESTOQUES REGULADORES/ESTRATEGICOS E INDENIZACOES VINCULADOS A POLITICA DE GARANTIA DE PRECOS MINIMOS - PGPM - REALIZADAS PELA CONAB.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.06.10', 'REMUNERACAO - CUSTOS ADMINISTRATIVOS', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES AOS CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO, CONFORME PREVISTO EM CONTRATO. DECISAO TCU 498/2002, DE 15 DE MARCO DE 2002.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.06.11', 'REMUNERACAO - CUSTOS ADMINISTRATIVOS - RAP', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTOS A PAGAR DE CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO, CONFORME PREVISTO EM CONTRATO. DECISAO TCU 498, DE 15 DE MARCO DE 2002.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.06.12', 'RESTITUICAO', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTITUICOES DEVIDAS POR ORGAOS E ENTIDADES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.06.13', 'RESTITUICAO - RP', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTITUICOES DEVIDAS POR ORGAOS E ENTIDADES (RESTOS A PAGAR).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.07.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAOS DOS VALORES A LIBERAR RELATIVOS A OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.07.02', 'EXECUTADOS', 'REGISTRA A EXECUCAOS DOS VALORES LIBERADOS RELATIVOS A OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.08.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS SERVICOS A REALIZAR RELATIVOS A CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.08.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS SERVICOS REALIZADOS RELATIVOS A CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.09.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS SERVICOS A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.09.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS SERVICOS REALIZADOS RELATIVOS A CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.10.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES RELATIVOS A ALUGUEL A APROPRIAR DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.10.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES RELATIVOS A ALUGUEL APROPRIADO DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.11.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A EXECUTAR DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.11.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A EXECUTADOS DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.12.01', 'CONTRATOS DE GESTAO A LIQUIDAR', 'REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.12.02', 'CONTRATOS DE GESTAO LIQUIDADOS', 'REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.13.01', 'A LIBERAR', 'REGISTRO DO VALOR TOTAL DO ACORDO A LIBERAR, BAIXANDO A MEDIDA DA TRANSFERENCIA DOS RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.13.02', 'A COMPROVAR', 'REGISTRO DO VALOR TOTAL DO ACORDO LIBERADO E PENDENTE DE COMPROVACAO DA SUA EFETIVA UTILIZACAO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.13.03', 'COMPROVADO', 'REGISTRO O VALOR DOS RECURSOS LIBERADOS E QUE TIVERAM SUA EFETIVA UTILIZACAO COMPROVADA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.13.04', 'CONCLUIDO', 'REGISTRO O VALOR DOS RECURSOS LIBERADOS E QUE TIVERAM SUA EFETIVA UTILIZACAO CONCLUIDA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.14.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DO VALOR DO CONTRATO A LIBERAR DECORRENTE DE OPERACOES DE CREDITO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.14.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DO VALOR DO CONTRATO LIBERADO DECORRENTE DE OPERACOES DE CREDITO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.01.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.01.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.02.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.02.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.03.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.03.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.04.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS POR TERCEIROS A ADMINISTRACAO PUBLICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.04.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS POR ADMINISTRACAO A PUBLICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.05.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.05.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DE VALORES A LIBERAREDOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.06.01', 'CONTRATOS A LIBERAR', 'REGISTRA A EXECUCAO DOS VALORES A LIBERAR DOS CONTRATOS DE EMPRESTIMO CONCEDIDO PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO COM OS BANCOS PRIVADOS E OFICIAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.06.02', 'EMPRESTIMOS LIBERADOS', 'REGISTRA A EXECUCAO DOS VALORES LIBERADOS DE EMPRESTIMOS VINCULADO A CONTRATO COM BANCOS PRIVADOS, PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.06.03', 'EMPRESTIMOS LIBERADOS - RP', 'REGISTRA A EXECUCAO DOS VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DECREDITO (PRINCIPAL).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.06.04', 'EMPRESTIMOS REEMBOLSADOS - PRINCIPAL', 'REGISTRA A EXECUCAO DOS VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (JUROS).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.06.05', 'EMPRESTIMOS REEMBOLSADOS - JUROS', 'REGISTRA A EXECUCAO DOS O VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (SANCOES).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.06.06', 'EMPRESTIMOS REEMBOLSADOS - SANCOES', 'REGISTRA A EXECUCAO DOS VALORES DAS OPERACOES EQUALIZADAS DECORRENTES DE CONTRATOS DEFINANCIAMENTO DE O2C.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.06.07', 'OPERACOES EQUALIZADAS', 'REGISTRA A EXECUCAO DOS VALORES DAS OPERACOES EQUALIZADAS REFERENTE A RESTOS A PAGAR,DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (PRINCIPAL).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.06.08', 'OPERACOES EQUALIZADAS - RP', 'REGISTRA A EXECUCAO DOS VALORES DOS EMPRESTIMOS LIBERADOS - REFERENTES A RESTOS APAGAR, PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.06.09', 'ALIENACAO ESTOQUES EST./REG./INDENIZ. - AGF', 'REGISTRA A EXECUCAO DOS VALORES DAS RECEITAS DECORRENTES DE ALINACOES DE ESTOQUES REGULADORES/ESTRATEGICOS E INDENIZACOES VINCULADOS A POLITICA DE GARANTIA DE PRECOS MINIMOS - PGPM - REALIZADAS PELA CONAB.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.06.10', 'REMUNERACAO - CUSTOS ADMINISTRATIVOS', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES AOS CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO, CONFORME PREVISTO EM CONTRATO. DECISAO TCU 498/2002, DE 15 DE MARCO DE 2002.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.06.11', 'REMUNERACAO - CUSTOS ADMINISTRATIVOS - RAP', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTOS A PAGAR DE CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO, CONFORME PREVISTO EM CONTRATO. DECISAO TCU 498, DE 15 DE MARCO DE 2002.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.06.12', 'RESTITUICAO', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTITUICOES DEVIDAS POR ORGAOS E ENTIDADES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.06.13', 'RESTITUICAO - RP', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTITUICOES DEVIDAS POR ORGAOS E ENTIDADES (RESTOS A PAGAR).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.07.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAOS DOS VALORES A LIBERAR RELATIVOS A OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.07.02', 'EXECUTADOS', 'REGISTRA A EXECUCAOS DOS VALORES LIBERADOS RELATIVOS A OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.08.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS SERVICOS A REALIZAR RELATIVOS A CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.08.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS SERVICOS REALIZADOS RELATIVOS A CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.09.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS SERVICOS A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.09.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS SERVICOS REALIZADOS RELATIVOS A CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.10.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES RELATIVOS A ALUGUEL A APROPRIAR DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.10.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES RELATIVOS A ALUGUEL APROPRIADO DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.11.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A EXECUTAR DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.11.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A EXECUTADOS DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.12.01', 'CONTRATOS DE GESTAO A LIQUIDAR', 'REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.12.02', 'CONTRATOS DE GESTAO LIQUIDADOS', 'REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.13.01', 'A LIBERAR', 'REGISTRO DO VALOR TOTAL DO ACORDO A LIBERAR, BAIXANDO A MEDIDA DA TRANSFERENCIA DOS RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.13.02', 'A COMPROVAR', 'REGISTRO DO VALOR TOTAL DO ACORDO LIBERADO E PENDENTE DE COMPROVACAO DA SUA EFETIVA UTILIZACAO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.13.03', 'COMPROVADO', 'REGISTRO O VALOR DOS RECURSOS LIBERADOS E QUE TIVERAM SUA EFETIVA UTILIZACAO COMPROVADA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.13.04', 'CONCLUIDO', 'REGISTRO O VALOR DOS RECURSOS LIBERADOS E QUE TIVERAM SUA EFETIVA UTILIZACAO CONCLUIDA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.14.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DO VALOR DO CONTRATO A LIBERAR DECORRENTE DE OPERACOES DE CREDITO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.14.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DO VALOR DO CONTRATO LIBERADO DECORRENTE DE OPERACOES DE CREDITO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.01.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.01.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.02.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.02.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.03.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.03.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.04.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS POR TERCEIROS A ADMINISTRACAO PUBLICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.04.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS POR ADMINISTRACAO A PUBLICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.05.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.05.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DE VALORES A LIBERAREDOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.06.01', 'CONTRATOS A LIBERAR', 'REGISTRA A EXECUCAO DOS VALORES A LIBERAR DOS CONTRATOS DE EMPRESTIMO CONCEDIDO PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO COM OS BANCOS PRIVADOS E OFICIAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.06.02', 'EMPRESTIMOS LIBERADOS', 'REGISTRA A EXECUCAO DOS VALORES LIBERADOS DE EMPRESTIMOS VINCULADO A CONTRATO COM BANCOS PRIVADOS, PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.06.03', 'EMPRESTIMOS LIBERADOS - RP', 'REGISTRA A EXECUCAO DOS VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DECREDITO (PRINCIPAL).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.06.04', 'EMPRESTIMOS REEMBOLSADOS - PRINCIPAL', 'REGISTRA A EXECUCAO DOS VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (JUROS).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.06.05', 'EMPRESTIMOS REEMBOLSADOS - JUROS', 'REGISTRA A EXECUCAO DOS O VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (SANCOES).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.06.06', 'EMPRESTIMOS REEMBOLSADOS - SANCOES', 'REGISTRA A EXECUCAO DOS VALORES DAS OPERACOES EQUALIZADAS DECORRENTES DE CONTRATOS DEFINANCIAMENTO DE O2C.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.06.07', 'OPERACOES EQUALIZADAS', 'REGISTRA A EXECUCAO DOS VALORES DAS OPERACOES EQUALIZADAS REFERENTE A RESTOS A PAGAR,DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (PRINCIPAL).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.06.08', 'OPERACOES EQUALIZADAS - RP', 'REGISTRA A EXECUCAO DOS VALORES DOS EMPRESTIMOS LIBERADOS - REFERENTES A RESTOS APAGAR, PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.06.09', 'ALIENACAO ESTOQUES EST./REG./INDENIZ. - AGF', 'REGISTRA A EXECUCAO DOS VALORES DAS RECEITAS DECORRENTES DE ALINACOES DE ESTOQUES REGULADORES/ESTRATEGICOS E INDENIZACOES VINCULADOS A POLITICA DE GARANTIA DE PRECOS MINIMOS - PGPM - REALIZADAS PELA CONAB.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.06.10', 'REMUNERACAO - CUSTOS ADMINISTRATIVOS', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES AOS CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO, CONFORME PREVISTO EM CONTRATO. DECISAO TCU 498/2002, DE 15 DE MARCO DE 2002.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.06.11', 'REMUNERACAO - CUSTOS ADMINISTRATIVOS - RAP', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTOS A PAGAR DE CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO, CONFORME PREVISTO EM CONTRATO. DECISAO TCU 498, DE 15 DE MARCO DE 2002.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.06.12', 'RESTITUICAO', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTITUICOES DEVIDAS POR ORGAOS E ENTIDADES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.06.13', 'RESTITUICAO - RP', 'REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTITUICOES DEVIDAS POR ORGAOS E ENTIDADES (RESTOS A PAGAR).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.07.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAOS DOS VALORES A LIBERAR RELATIVOS A OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.07.02', 'EXECUTADOS', 'REGISTRA A EXECUCAOS DOS VALORES LIBERADOS RELATIVOS A OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.08.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS SERVICOS A REALIZAR RELATIVOS A CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.08.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS SERVICOS REALIZADOS RELATIVOS A CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.09.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS SERVICOS A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.09.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS SERVICOS REALIZADOS RELATIVOS A CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.10.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES RELATIVOS A ALUGUEL A APROPRIAR DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.10.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES RELATIVOS A ALUGUEL APROPRIADO DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.11.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DOS VALORES A EXECUTAR DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.11.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DOS VALORES A EXECUTADOS DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.12.01', 'CONTRATOS DE GESTAO A LIQUIDAR', 'REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.12.02', 'CONTRATOS DE GESTAO LIQUIDADOS', 'REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.13.01', 'A LIBERAR', 'REGISTRO DO VALOR TOTAL DO ACORDO A LIBERAR, BAIXANDO A MEDIDA DA TRANSFERENCIA DOS RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.13.02', 'A COMPROVAR', 'REGISTRO DO VALOR TOTAL DO ACORDO LIBERADO E PENDENTE DE COMPROVACAO DA SUA EFETIVA UTILIZACAO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.13.03', 'COMPROVADO', 'REGISTRO O VALOR DOS RECURSOS LIBERADOS E QUE TIVERAM SUA EFETIVA UTILIZACAO COMPROVADA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.13.04', 'CONCLUIDO', 'REGISTRO O VALOR DOS RECURSOS LIBERADOS E QUE TIVERAM SUA EFETIVA UTILIZACAO CONCLUIDA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.14.01', 'EM EXECUCAO', 'REGISTRA A EXECUCAO DO VALOR DO CONTRATO A LIBERAR DECORRENTE DE OPERACOES DE CREDITO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.14.02', 'EXECUTADOS', 'REGISTRA A EXECUCAO DO VALOR DO CONTRATO LIBERADO DECORRENTE DE OPERACOES DE CREDITO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.9.1.00.00', 'EXECUCAO DE OUTROS ATOS POTENCIAIS PASSIVOS - CONSOLIDACAO', 'COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.9.2.00.00', 'EXECUCAO DE OUTROS ATOS POTENCIAIS PASSIVOS - INTRA OFSS', 'COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.9.4.00.00', 'EXECUCAO DE OUTROS ATOS POTENCIAIS PASSIVOS - INTER OFSS - ESTADO', 'COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.9.5.00.00', 'EXECUCAO DE OUTROS ATOS POTENCIAIS PASSIVOS - INTER OFSS - MUNICIPIO', 'COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.1.00.00', 'DISPONIBILIDADE POR DESTINACAO DE RECURSOS', 'REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS A UTILIZAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.2.00.00', 'DISPONIBILIDADE POR DESTINACAO DE RECURSOS COMPROMETIDA POR EMPENHO', 'REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS COMPROMETIDAS POR OCASIAO DO EMPENHO E NAO LIQUIDADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.3.00.00', 'DISPONIBILIDADE POR DESTINACAO DE RECURSOS COMPROMETIDA POR LIQUIDACAO E ENTRADAS COMPENSATORIAS', 'REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS COMPROMETIDAS POR OCASIAO DA LIQUIDACAO E DE ENTRADAS COMPENSATORIAS E NÃO PAGAS/DEVOLVIDAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.4.00.00', 'DISPONIBILIDADE POR DESTINACAO DE RECURSOS UTILIZADA', 'REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS UTILIZADAS POR MEIO DE PAGAMENTO DE DESPESA ORCAMENTARIA, DEPOSITOS E/OU OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.5.00.00', 'DISPONIBILIDADE POR DESTINACAO DE RECURSOS COMPROMETIDA POR PROGRAMAÇÃO FINANCEIRA', 'REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS COMPROMETIDAS POR PROGRAMACAO FINANCEIRA NO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.2.1.01.00', 'VALORES DE LIMITE DE RP A CONCEDER', 'REGISTRA O VALORES A CONCEDER, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.2.1.02.00', 'VALORES DE LIMITE DE RP CONCEDIDO', 'REGISTRA O VALORES CONCEDIDOS, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.2.2.01.00', 'VALORES DE LIMITE DE RP A RECEBER', 'REGISTRA O VALORES A RECEBER, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.2.2.02.00', 'VALORES DE LIMITE DE RP RECEBIDO', 'REGISTRA O VALORES RECEBIDOS, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.1.01.02', 'COTA DIFERIDA CONCEDIDA', 'REGISTRA AS COTAS DIFERIDAS CONCEDIDAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.1.01.03', 'CANCELAMENTO DE COTA DIFERIDA A CONCEDER', 'REGISTRAM O CANCELAMENTO DAS DISPONIBILIDADES DE COTAS DIFERIDAS INSCRITAS A CONCEDER.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.1.02.01', 'REPASSE DIFERIDO A CONCEDER', 'REGISTRA OS REPASSES DIFERIDOS A CONCEDER.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.1.02.02', 'REPASSE DIFERIDO CONCEDIDO', 'REGISTRA OS REPASSES DIFERIDOS CONCEDIDOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.1.02.03', 'CANCELAMENTO DE REPASSE DIFERIDO A CONCEDER', 'REGISTRAM O CANCELAMENTO DAS DISPONIBILIDADES DE REPASSES DIFERIDOS INSCRITOS A CONCEDER.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.1.03.01', 'SUB-REPASSE DIFERIDO A CONCEDER', 'REGISTRA OS SUB-REPASSES DIFERIDOS A CONCEDER.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.1.03.02', 'SUB-REPASSE DIFERIDO CONCEDIDO', 'REGISTRA OS SUB-REPASSES DIFERIDOS CONCEDIDOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.1.03.03', 'CANCELAMENTO DE SUB-REPASSE DIFERIDO A CONCEDER', 'REGISTRAM O CANCELAMENTO DAS DISPONIBILIDADES DE SUB-REPASSES DIFERIDOS INSCRITOS A CONCEDER.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.2.01.01', 'COTA DIFERIDA A RECEBER', 'REGISTRA AS COTAS DIFERIDAS A RECEBER.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.2.01.02', 'COTA DIFERIDA RECEBIDA', 'REGISTRA AS COTAS DIFERIDAS RECEBIDAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.2.01.03', 'CANCELAMENTO DE COTA DIFERIDA A RECEBER', 'REGISTRAM O CANCELAMENTO DAS DISPONIBILIDADES DE COTAS DIFERIDAS INSCRITAS A RECEDER.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.2.02.01', 'REPASSE DIFERIDO A RECEBER', 'REGISTRA OS REPASSES DIFERIDOS A RECEBER.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.2.02.02', 'REPASSE DIFERIDO RECEBIDO', 'REGISTRA OS REPASSES DIFERIDOS RECEBIDOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.2.02.03', 'CANCELAMENTO DE REPASSE DIFERIDO A RECEBER', 'REGISTRAM O CANCELAMENTO DAS DISPONIBILIDADES DE REPASSES DIFERIDOS INSCRITOS A RECEDER.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.2.03.01', 'SUB-REPASSE DIFERIDO A RECEBER', 'REGISTRA OS SUB-REPASSES DIFERIDOS A RECEBER.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.2.03.02', 'SUB-REPASSE DIFERIDO RECEBIDO', 'REGISTRA OS SUB-REPASSES DIFERIDOS RECEBIDOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.2.03.03', 'CANCELAMENTO DE SUB-REPASSE DIFERIDO A RECEBER', 'REGISTRAM O CANCELAMENTO DAS DISPONIBILIDADES DE SUB-REPASSES DIFERIDOS INSCRITOS A RECEDER.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.1.01.00', 'COTA INDISPONIVEL', 'REGISTRA AS COTAS A SEREM CONCEDIDAS, DECORRENTES DO ORCAMENTO, POREM INDISPONIVEIS EM VIRTUDE DE LEIS, DECRETOS E PORTARIAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.1.02.00', 'COTA A PROGRAMAR', 'REGISTRA AS COTAS A SEREM CONCEDIDAS, DECORRENTES DO ORCAMENTO, AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.1.03.00', 'COTA SOLICITADA A APROVAR', 'REGISTRA AS COTAS A SEREM CONCEDIDAS, JA SOLICITADAS, DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.1.04.00', 'COTA SOLICITADA APROVADA A LIBERAR', 'REGISTRA AS COTAS A SEREM CONCEDIDAS, JA SOLICITADAS E APROVADAS, DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.1.05.00', 'COTA SOLICITADA APROVADA LIBERADA', 'REGISTRA AS COTAS CONCEDIDAS, SOLICITADAS E APROVADAS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.1.06.00', 'COTA TRANSFERIDA', 'REGISTRA AS COTAS, DECORRENTES DO ORCAMENTO, TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.1.07.00', 'COTA PROVENIENTE DE DARF EMITIDO', 'REGISTRA OS VALORES DE COTAS CONCEDIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.1.08.00', 'COTA PROVENIENTE DE GPS EMITIDA', 'REGISTRA OS VALORES DE COTAS CONCEDIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.1.09.00', 'COTA PROVENIENTE DE DAR EMITIDO', 'REGISTRA OS VALORES DE COTAS CONCEDIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.1.10.00', 'COTA PROVENIENTE DE GFIP EMITIDA', 'REGISTRA OS VALORES DE COTAS CONCEDIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.1.11.00', 'COTA PROVENIENTE DE GRU EMITIDA.', 'REGISTRA OS VALORES DE COTAS CONCEDIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.1.12.00', 'COTA DIRETAMENTE ARRECADADA', 'REGISTRA OS VALORES DE COTAS CONCEDIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.1.13.00', 'COTA DE RESTOS A PAGAR LIBERADA', 'REGISTRA O VALOR DAS COTAS DE RESTOS A PAGAR LIBERADAS PELAS SETORIAS DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.2.01.00', 'COTA DE LIMITE DE RESTOS A PAGAR AUTORIZADO', 'REGISTRA O VALOR DOS LIMITES DE COTAS A SEREM CONCEDIDAS, AUTORIZADAS PELO MINISTERIO DA FAZENDA E PELAS COORDENACOES DE ORCAMENTO E FINANCAS DE CADA ORGAO PARA ATENDER DESPESAS COM RESTOS A PAGAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.2.02.00', 'COTA NAO DECORRENTE DO ORCAMENTO SOLICITADA A APROVAR', 'REGISTRA AS COTAS A SEREM CONCEDIDAS, JA SOLICITADAS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.2.03.00', 'COTA NAO DECORRENTE DO ORCAMENTO APROVADA A LIBERAR', 'REGISTRA AS COTAS A SEREM CONCEDIDAS, JA SOLICITADAS E APROVADAS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.2.04.00', 'COTA NAO DECORRENTE DO ORCAMENTO APROVADA LIBERADA', 'REGISTRA AS COTAS CONCEDIDAS, SOLICITADAS E APROVADAS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.2.05.00', 'COTA TRANSFERIDA', 'REGISTRA AS COTAS NAO DECORRENTES DO ORCAMENTO TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.2.06.00', 'COTA PROVENIENTE DE DARF EMITIDO', 'REGISTRA OS VALORES DE COTAS CONCEDIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.2.07.00', 'COTA PROVENIENTE DE GPS EMITIDA', 'REGISTRA OS VALORES DE COTAS CONCEDIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.2.08.00', 'COTA PROVENIENTE DE DAR EMITIDO', 'REGISTRA OS VALORES DE COTAS CONCEDIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.2.09.00', 'COTA PROVENIENTE DE GFIP EMITIDA', 'REGISTRA OS VALORES DE COTAS CONCEDIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.2.10.00', 'COTA PROVENIENTE DE GRU EMITIDA', 'REGISTRA OS VALORES DE COTAS CONCEDIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.2.11.00', 'COTA DE RESTOS A PAGAR AUTORIZADA POR DESTAQUE', 'REGISTRA O VALOR DAS COTAS DE REPASSE AUTORIZADO POR DESCENTRALIZACAO EXTERNA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.2.12.00', 'COTA DE RESTOS A PAGAR LIBERADA POR DESTAQUE', 'REGISTRA O VALOR DAS COTAS DE RESTOS A PAGAR LIBERADO POR DESCENTRALIZACAO EXTERNA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.2.13.00', 'COTA DIRETAMENTE ARRECADADA', 'REGISTRA OS VALORES DE COTAS CONCEDIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.3.01.01', 'COTA DE RESTITUICAO SOLICITADA A LIBERAR', 'REGISTRA OS VALORES DE COTAS SOLICITADAS A LIBERAR, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.3.01.02', 'COTA DE RESTITUICAO A LIBERAR', 'REGISTRA OS VALORES DE COTAS A LIBERAR, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.3.01.03', 'COTA DE RESTITUICAO LIBERADA', 'REGISTRA OS VALORES DE COTAS LIBERADAS, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.3.01.04', 'COTA DE RESTITUICAO UTILIZADA', 'REGISTRA OS VALORES DE COTAS UTILIZADAS NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.3.01.05', 'COTA DE RESTITUICAO UTILIZADA - GRU', 'REGISTRA OS VALORES DE COTAS UTILIZADAS NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL, POR MEIO DE GRU.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.3.02.00', 'COTA DE COMPENSACAO UTILIZADA', 'REGISTRA OS VALORES DE COTAS A SEREM CONCEDIDAS, PARA UTILIZACAO NAS COMPENSACOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.3.03.01', 'COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS SOLICITADA A LIBERAR', 'REGISTRA O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS SOLICITADAS AO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.3.03.02', 'COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS A LIBERAR', 'REGISTRA O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS A LIBERAR DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.3.03.03', 'COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS LIBERADA', 'REGISTRA O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS LIBERADAS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.01.00', 'REPASSE INDISPONIVEL', 'REGISTRA OS REPASSES A SEREM CONCEDIDOS, DECORRENTES DO ORCAMENTO, POREM INDISPONIVEIS EM VIRTUDE DE LEIS, DECRETOS E PORTARIAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.02.00', 'REPASSE A PROGRAMAR', 'REGISTRA OS REPASSES A SEREM CONCEDIDOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.03.00', 'REPASSE SOLICITADO A APROVAR', 'REGISTRA OS REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.04.00', 'REPASSE SOLICITADO APROVADO A LIBERAR', 'REGISTRA OS REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.05.00', 'REPASSE SOLICITADO APROVADO LIBERADO', 'REGISTRA OS REPASSES CONCEDIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.06.00', 'REPASSE A PROGRAMAR POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS REPASSES A SEREM CONCEDIDOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.07.00', 'REPASSE SOLICITADO A APROVAR POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.08.00', 'REPASSE SOLICITADO APROVADO A LIBERAR POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.09.00', 'REPASSE SOLICITADO APROVADO LIBERADO POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS REPASSES CONCEDIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.10.00', 'REPASSE TRANSFERIDO', 'REGISTRA AS COTAS, DECORRENTES DO ORCAMENTO, TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.11.00', 'REPASSE PROVENIENTE DE DARF EMITIDO', 'REGISTRA OS VALORES DE REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.12.00', 'REPASSE PROVENIENTE DE GPS EMITIDA', 'REGISTRA OS VALORES DE REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.13.00', 'REPASSE PROVENIENTE DE DAR EMITIDO', 'REGISTRA OS VALORES DE REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.14.00', 'REPASSE PROVENIENTE DE GFIP EMITIDA', 'REGISTRA OS VALORES DE REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.15.00', 'REPASSE PROVENIENTE DE GRU EMITIDA.', 'REGISTRA OS VALORES DE REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.16.00', 'REPASSE DIRETAMENTE ARRECADADO', 'REGISTRA OS VALORES DE REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.5.01.00', 'REPASSE DE LIMITE DE RESTOS A PAGAR AUTORIZADO', 'REGISTRA O VALOR DOS LIMITES DE REPASSES A SEREM CONCEDIDOS, AUTORIZADAS PELO MINISTERIO DA FAZENDA E PELAS COORDENACOES DE ORCAMENTO E FINANCAS DE CADA ORGAO PARA ATENDER DESPESAS COM RESTOS A PAGAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.5.02.00', 'REPASSE NAO DECORRENTE DO ORCAMENTO SOLICITADA A APROVAR', 'REGISTRA AS REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.5.03.00', 'REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO A LIBERAR', 'REGISTRA AS REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS E APROVADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.5.04.00', 'REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO LIBERADO', 'REGISTRA AS REPASSES CONCEDIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.5.05.00', 'REPASSE TRANSFERIDO', 'REGISTRA AS REPASSES NAO DECORRENTES DO ORCAMENTO TRANSFERIDOS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.5.06.00', 'REPASSE PROVENIENTE DE DARF EMITIDO', 'REGISTRA OS VALORES DE REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.5.07.00', 'REPASSE PROVENIENTE DE GPS EMITIDA', 'REGISTRA OS VALORES DE REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.5.08.00', 'REPASSE PROVENIENTE DE DAR EMITIDO', 'REGISTRA OS VALORES DE REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.5.09.00', 'REPASSE PROVENIENTE DE GFIP EMITIDA', 'REGISTRA OS VALORES DE REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.5.10.00', 'REPASSE PROVENIENTE DE GRU EMITIDA.', 'REGISTRA OS VALORES DE REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.5.11.00', 'REPASSE DIRETAMENTE ARRECADADO', 'REGISTRA OS VALORES DE REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.6.01.01', 'REPASSE DE RESTITUICAO SOLICITADO A LIBERAR', 'REGISTRA OS VALORES DE REPASSES SOLICITADOS A LIBERAR, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.6.01.02', 'REPASSE DE RESTITUICAO A LIBERAR', 'REGISTRA OS VALORES DE REPASSES A LIBERAR, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.6.01.03', 'REPASSE DE RESTITUICAO LIBERADO', 'REGISTRA OS VALORES DE REPASSES LIBERADOS, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.6.01.04', 'REPASSE DE RESTITUICAO UTILIZADO', 'REGISTRA OS VALORES DE REPASSES UTILIZADOS NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.6.02.00', 'REPASSE DE COMPENSACAO UTILIZADA', 'REGISTRA OS VALORES DE REPASSES A SEREM CONCEDIDOS, PARA UTILIZACAO NAS COMPENSACOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.6.03.01', 'REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS SOLICITADO A LIBERAR', 'REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS SOLICITADAS AO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.6.03.02', 'REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS A LIBERAR', 'REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS A LIBERAR DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.6.03.03', 'REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS LIBERADO', 'REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS LIBERADOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.01.00', 'SUB-REPASSE INDISPONIVEL', 'REGISTRA OS SUB-REPASSES A SEREM CONCEDIDOS, DECORRENTES DO ORCAMENTO, POREM INDISPONIVEIS EM VIRTUDE DE LEIS, DECRETOS E PORTARIAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.02.00', 'SUB-REPASSE A PROGRAMAR', 'REGISTRA OS SUB-REPASSES A SEREM CONCEDIDOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.03.00', 'SUB-REPASSE SOLICITADO A APROVAR', 'REGISTRA OS SUB-REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.04.00', 'SUB-REPASSE SOLICITADO APROVADO A LIBERAR', 'REGISTRA OS SUB-REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.05.00', 'SUB-REPASSE SOLICITADO APROVADO LIBERADO', 'REGISTRA OS SUB-REPASSES CONCEDIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.06.00', 'SUB-REPASSE A PROGRAMAR POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS SUB-REPASSES A SEREM CONCEDIDOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.07.00', 'SUB-REPASSE SOLICITADO A APROVAR POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS SUB-REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.08.00', 'SUB-REPASSE SOLICITADO APROVADO A LIBERAR POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS SUB-REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.09.00', 'SUB-REPASSE SOLICITADO APROVADO LIBERADO POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS SUB-REPASSES CONCEDIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.10.00', 'SUB-REPASSE TRANSFERIDO', 'REGISTRA AS COTAS, DECORRENTES DO ORCAMENTO, TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.11.00', 'SUB-REPASSE PROVENIENTE DE DARF EMITIDO', 'REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.12.00', 'SUB-REPASSE PROVENIENTE DE GPS EMITIDA', 'REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.13.00', 'SUB-REPASSE PROVENIENTE DE DAR EMITIDO', 'REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.14.00', 'SUB-REPASSE PROVENIENTE DE GFIP EMITIDA', 'REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.15.00', 'SUB-REPASSE PROVENIENTE DE GRU EMITIDA.', 'REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.16.00', 'SUB-REPASSE DIRETAMENTE ARRECADADO', 'REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.8.01.00', 'SUB-REPASSE DE LIMITE DE RESTOS A PAGAR AUTORIZADO', 'REGISTRA O VALOR DOS LIMITES DE SUB-REPASSES A SEREM CONCEDIDOS, AUTORIZADAS PELO MINISTERIO DA FAZENDA E PELAS COORDENACOES DE ORCAMENTO E FINANCAS DE CADA ORGAO PARA ATENDER DESPESAS COM RESTOS A PAGAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.8.02.00', 'SUB-REPASSE NAO DECORRENTE DO ORCAMENTO SOLICITADA A APROVAR', 'REGISTRA AS SUB-REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.8.03.00', 'SUB-REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO A LIBERAR', 'REGISTRA AS SUB-REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS E APROVADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.8.04.00', 'SUB-REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO LIBERADO', 'REGISTRA AS SUB-REPASSES CONCEDIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.8.05.00', 'SUB-REPASSE TRANSFERIDO', 'REGISTRA AS SUB-REPASSES NAO DECORRENTES DO ORCAMENTO TRANSFERIDOS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.8.06.00', 'SUB-REPASSE PROVENIENTE DE DARF EMITIDO', 'REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.8.07.00', 'SUB-REPASSE PROVENIENTE DE GPS EMITIDA', 'REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.8.08.00', 'SUB-REPASSE PROVENIENTE DE DAR EMITIDO', 'REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.8.09.00', 'SUB-REPASSE PROVENIENTE DE GFIP EMITIDA', 'REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.8.10.00', 'SUB-REPASSE PROVENIENTE DE GRU EMITIDA.', 'REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.8.11.00', 'SUB-REPASSE DIRETAMENTE ARRECADADO', 'REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.9.01.01', 'SUB-REPASSE DE RESTITUICAO SOLICITADO A LIBERAR', 'REGISTRA OS VALORES DE SUB-REPASSES SOLICITADOS A LIBERAR, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.9.01.02', 'SUB-REPASSE DE RESTITUICAO A LIBERAR', 'REGISTRA OS VALORES DE SUB-REPASSES A LIBERAR, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.9.01.03', 'SUB-REPASSE DE RESTITUICAO LIBERADO', 'REGISTRA OS VALORES DE SUB-REPASSES LIBERADOS, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.9.01.04', 'SUB-REPASSE DE RESTITUICAO UTILIZADO', 'REGISTRA OS VALORES DE SUB-REPASSES UTILIZADOS NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.9.02.00', 'SUB-REPASSE DE COMPENSACAO UTILIZADA', 'REGISTRA OS VALORES DE SUB-REPASSES A SEREM CONCEDIDOS, PARA UTILIZACAO NAS COMPENSACOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.9.03.01', 'SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS SOLICITADO A LIBERAR', 'REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS SOLICITADAS AO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.9.03.02', 'SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS A LIBERAR', 'REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS A LIBERAR DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.9.03.03', 'SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS LIBERADO', 'REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS LIBERADOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.1.01.00', 'COTA INDISPONIVEL', 'REGISTRA AS COTAS A SEREM RECEBIDAS, DECORRENTES DO ORCAMENTO, POREM INDISPONIVEIS EM VIRTUDE DE LEIS, DECRETOS E PORTARIAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.1.02.00', 'COTA A PROGRAMAR', 'REGISTRA AS COTAS A SEREM RECEBIDAS, DECORRENTES DO ORCAMENTO, AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.1.03.00', 'COTA SOLICITADA A APROVAR', 'REGISTRA AS COTAS A SEREM RECEBIDAS, JA SOLICITADAS, DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.1.04.00', 'COTA SOLICITADA APROVADA A RECEBER', 'REGISTRA AS COTAS A SEREM RECEBIDAS, JA SOLICITADAS E APROVADAS, DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.1.05.00', 'COTA SOLICITADA APROVADA RECEBIDA', 'REGISTRA AS COTAS RECEBIDAS, SOLICITADAS E APROVADAS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.1.06.00', 'COTA TRANSFERIDA', 'REGISTRA AS COTAS, DECORRENTES DO ORCAMENTO, TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.1.07.00', 'COTA PROVENIENTE DE DARF EMITIDO', 'REGISTRA OS VALORES DE COTAS RECEBIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.1.08.00', 'COTA PROVENIENTE DE GPS EMITIDA', 'REGISTRA OS VALORES DE COTAS RECEBIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.1.09.00', 'COTA PROVENIENTE DE DAR EMITIDO', 'REGISTRA OS VALORES DE COTAS RECEBIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.1.10.00', 'COTA PROVENIENTE DE GFIP EMITIDA', 'REGISTRA OS VALORES DE COTAS RECEBIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.1.11.00', 'COTA PROVENIENTE DE GRU EMITIDA.', 'REGISTRA OS VALORES DE COTAS RECEBIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.1.12.00', 'COTA DIRETAMENTE ARRECADADA', 'REGISTRA OS VALORES DE COTAS RECEBIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.1.13.00', 'COTA FINANCEIRA DE RESTOS A PAGAR - RECEBIDAS', 'REGISTRA O VALOR DAS COTAS DE RESTOS A PAGAR RECEBIDAS UNIDADES GESTORAS BENEFICIARIAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.2.01.00', 'COTA DE LIMITE DE RESTOS A PAGAR AUTORIZADO', 'REGISTRA O VALOR DOS LIMITES DE COTAS A SEREM RECEBIDAS, AUTORIZADAS PELO MINISTERIO DA FAZENDA E PELAS COORDENACOES DE ORCAMENTO E FINANCAS DE CADA ORGAO PARA ATENDER DESPESAS COM RESTOS A PAGAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.2.02.00', 'COTA NAO DECORRENTE DO ORCAMENTO SOLICITADA A APROVAR', 'REGISTRA AS COTAS A SEREM RECEBIDAS, JA SOLICITADAS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.2.03.00', 'COTA NAO DECORRENTE DO ORCAMENTO APROVADA A RECEBER', 'REGISTRA AS COTAS A SEREM RECEBIDAS, JA SOLICITADAS E APROVADAS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.2.04.00', 'COTA NAO DECORRENTE DO ORCAMENTO APROVADA RECEBIDA', 'REGISTRA AS COTAS RECEBIDAS, SOLICITADAS E APROVADAS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.2.05.00', 'COTA TRANSFERIDA', 'REGISTRA AS COTAS NAO DECORRENTES DO ORCAMENTO TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.2.06.00', 'COTA PROVENIENTE DE DARF EMITIDO', 'REGISTRA OS VALORES DE COTAS RECEBIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.2.07.00', 'COTA PROVENIENTE DE GPS EMITIDA', 'REGISTRA OS VALORES DE COTAS RECEBIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.2.08.00', 'COTA PROVENIENTE DE DAR EMITIDO', 'REGISTRA OS VALORES DE COTAS RECEBIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.2.09.00', 'COTA PROVENIENTE DE GFIP EMITIDA', 'REGISTRA OS VALORES DE COTAS RECEBIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.2.10.00', 'COTA PROVENIENTE DE GRU EMITIDA.', 'REGISTRA OS VALORES DE COTAS RECEBIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.2.11.00', 'COTA DE RESTOS A PAGAR AUTORIZADAS POR DESTAQUE', 'REGISTRA O VALOR DAS COTAS DE REPASSE AUTORIZADAS POR DESCENTRALIZACAO EXTERNA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.2.12.00', 'COTA DE RESTOS A PAGAR RECEBIDAS POR DESTAQUE', 'REGISTRA O VALOR DAS COTAS DE RESTOS A PAGAR RECEBIDAS POR DESCENTRALIZACAO EXTERNA DE CREDITO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.2.13.00', 'COTA DIRETAMENTE ARRECADADA', 'REGISTRA OS VALORES DE COTAS RECEBIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.3.01.01', 'COTA DE RESTITUICAO SOLICITADA A RECEBER', 'REGISTRA OS VALORES DE COTAS SOLICITADAS A SEREM RECEBIDAS, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.3.01.02', 'COTA DE RESTITUICAO A RECEBER', 'REGISTRA OS VALORES DE COTAS A SEREM RECEBIDAS , PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.3.01.03', 'COTA DE RESTITUICAO RECEBIDA', 'REGISTRA OS VALORES DE COTAS RECEBIDA, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.3.01.04', 'COTA DE RESTITUICAO UTILIZADA', 'REGISTRA O VALOR REFERENTE A COTA UTILIZADA PELAS UNIDADES DA SECRETARIA DA RECEITA FEDERAL PARA RESTITUICAO DE RECEITAS FEDERAIS APOS LIBERACAO DE RECURSOS PELA SECRETARIA DO TESOURO NACIONAL. O MOVIMENTO DESSA CONTA DISPARA A GERACAO DA FITA ST ENCAMINHADA A RFB COM A INFORMACAO DAS RESTITUICOES EFETUADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.3.01.05', 'COTA DE RESTITUICAO UTILIZADA - GRU', 'REGISTRA OS VALORES DE COTAS UTILIZADAS NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL, POR MEIO DE GRU.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.3.02.00', 'COTA DE COMPENSACAO UTILIZADA', 'REGISTRA OS VALORES DE COTAS A SEREM RECEBIDAS, PARA UTILIZACAO NAS COMPENSACOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.3.03.01', 'COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS SOLICITADA A RECEBER', 'REGISTRA O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS SOLICITADAS AO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.3.03.02', 'COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS A RECEBER', 'REGISTRA O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS A RECEBER DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.3.03.03', 'COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS RECEBIDAS', 'REGISTRA O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS RECEBIDAS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.01.00', 'REPASSE INDISPONIVEL', 'REGISTRA OS REPASSES A SEREM RECEBIDOS, DECORRENTES DO ORCAMENTO, POREM INDISPONIVEIS EM VIRTUDE DE LEIS, DECRETOS E PORTARIAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.02.00', 'REPASSE A PROGRAMAR', 'REGISTRA OS REPASSES A SEREM RECEBIDOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.03.00', 'REPASSE SOLICITADO A APROVAR', 'REGISTRA OS REPASSES A SEREM RECEBIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.04.00', 'REPASSE SOLICITADO APROVADO A RECEBER', 'REGISTRA OS REPASSES A SEREM RECEBIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.05.00', 'REPASSE SOLICITADO APROVADO RECEBIDO', 'REGISTRA OS REPASSES RECEBIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.06.00', 'REPASSE A PROGRAMAR POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS REPASSES A SEREM RECEBIDOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.07.00', 'REPASSE SOLICITADO A APROVAR POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS REPASSES A SEREM RECEBIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.08.00', 'REPASSE SOLICITADO APROVADO A RECEBER POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS REPASSES A SEREM RECEBIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.09.00', 'REPASSE SOLICITADO APROVADO RECEBIDO POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS REPASSES RECEBIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.10.00', 'REPASSE TRANSFERIDO', 'REGISTRA AS COTAS, DECORRENTES DO ORCAMENTO, TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.11.00', 'REPASSE PROVENIENTE DE DARF EMITIDO', 'REGISTRA OS VALORES DE REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.12.00', 'REPASSE PROVENIENTE DE GPS EMITIDA', 'REGISTRA OS VALORES DE REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.13.00', 'REPASSE PROVENIENTE DE DAR EMITIDO', 'REGISTRA OS VALORES DE REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.14.00', 'REPASSE PROVENIENTE DE GFIP EMITIDA', 'REGISTRA OS VALORES DE REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.15.00', 'REPASSE PROVENIENTE DE GRU EMITIDA.', 'REGISTRA OS VALORES DE REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.16.00', 'REPASSE DIRETAMENTE ARRECADADO', 'REGISTRA OS VALORES DE REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.5.01.00', 'REPASSE DE LIMITE DE RESTOS A PAGAR AUTORIZADO', 'REGISTRA O VALOR DOS LIMITES DE REPASSES A SEREM RECEBIDOS, AUTORIZADAS PELO MINISTERIO DA FAZENDA E PELAS COORDENACOES DE ORCAMENTO E FINANCAS DE CADA ORGAO PARA ATENDER DESPESAS COM RESTOS A PAGAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.5.02.00', 'REPASSE NAO DECORRENTE DO ORCAMENTO SOLICITADA A APROVAR', 'REGISTRA AS REPASSES A SEREM RECEBIDOS, JA SOLICITADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.5.03.00', 'REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO A LIBERAR', 'REGISTRA AS REPASSES A SEREM RECEBIDOS, JA SOLICITADOS E APROVADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.5.04.00', 'REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO LIBERADO', 'REGISTRA AS REPASSES RECEBIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.5.05.00', 'REPASSE TRANSFERIDO', 'REGISTRA AS REPASSES NAO DECORRENTES DO ORCAMENTO TRANSFERIDOS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.5.06.00', 'REPASSE PROVENIENTE DE DARF EMITIDO', 'REGISTRA OS VALORES DE REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.5.07.00', 'REPASSE PROVENIENTE DE GPS EMITIDA', 'REGISTRA OS VALORES DE REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.5.08.00', 'REPASSE PROVENIENTE DE DAR EMITIDO', 'REGISTRA OS VALORES DE REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.5.09.00', 'REPASSE PROVENIENTE DE GFIP EMITIDA', 'REGISTRA OS VALORES DE REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.5.10.00', 'REPASSE PROVENIENTE DE GRU EMITIDA.', 'REGISTRA OS VALORES DE REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.5.11.00', 'REPASSE DIRETAMENTE ARRECADADO', 'REGISTRA OS VALORES DE REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.6.01.01', 'REPASSE DE RESTITUICAO SOLICITADO A RECEBER', 'REGISTRA OS VALORES DE REPASSES SOLICITADOS A RECEBER, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.6.01.02', 'REPASSE DE RESTITUICAO A RECEBER', 'REGISTRA OS VALORES DE REPASSES A RECEBER, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.6.01.03', 'REPASSE DE RESTITUICAO RECEBIDO', 'REGISTRA OS VALORES DE REPASSES RECEBIDOS, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.6.01.04', 'REPASSE DE RESTITUICAO UTILIZADO', 'REGISTRA OS VALORES DE REPASSES UTILIZADOS NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.6.02.00', 'REPASSE DE COMPENSACAO UTILIZADA', 'REGISTRA OS VALORES DE REPASSES A RECEBER, PARA UTILIZACAO NAS COMPENSACOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.6.03.01', 'REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS SOLICITADO A RECEBER', 'REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS SOLICITADOS AO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.6.03.02', 'REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS A RECEBER', 'REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS A RECEBER DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.6.03.03', 'REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS RECEBER', 'REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS RECEBIDOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.01.00', 'SUB-REPASSE INDISPONIVEL', 'REGISTRA OS SUB-REPASSES A SEREM RECEBIDOS, DECORRENTES DO ORCAMENTO, POREM INDISPONIVEIS EM VIRTUDE DE LEIS, DECRETOS E PORTARIAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.02.00', 'SUB-REPASSE A PROGRAMAR', 'REGISTRA OS SUB-REPASSES A SEREM RECEBIDOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.03.00', 'SUB-REPASSE SOLICITADO A APROVAR', 'REGISTRA OS SUB-REPASSES A SEREM RECEBIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.04.00', 'SUB-REPASSE SOLICITADO APROVADO A RECEBER', 'REGISTRA OS SUB-REPASSES A SEREM RECEBIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.05.00', 'SUB-REPASSE SOLICITADO APROVADO RECEBIDO', 'REGISTRA OS SUB-REPASSES RECEBIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.06.00', 'SUB-REPASSE A PROGRAMAR POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS SUB-REPASSES A SEREM RECEBIDOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.07.00', 'SUB-REPASSE SOLICITADO A APROVAR POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS SUB-REPASSES A SEREM RECEBIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.08.00', 'SUB-REPASSE SOLICITADO APROVADO A RECEBER POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS SUB-REPASSES A SEREM RECEBIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.09.00', 'SUB-REPASSE SOLICITADO APROVADO RECEBIDO POR DESCENTRALIZACAO EXTERNA', 'REGISTRA OS SUB-REPASSES RECEBIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.10.00', 'SUB-REPASSE TRANSFERIDO', 'REGISTRA AS COTAS, DECORRENTES DO ORCAMENTO, TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.11.00', 'SUB-REPASSE PROVENIENTE DE DARF EMITIDO', 'REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.12.00', 'SUB-REPASSE PROVENIENTE DE GPS EMITIDA', 'REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.13.00', 'SUB-REPASSE PROVENIENTE DE DAR EMITIDO', 'REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.14.00', 'SUB-REPASSE PROVENIENTE DE GFIP EMITIDA', 'REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.15.00', 'SUB-REPASSE PROVENIENTE DE GRU EMITIDA.', 'REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.16.00', 'SUB-REPASSE DIRETAMENTE ARRECADADO', 'REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.8.01.00', 'SUB-REPASSE DE LIMITE DE RESTOS A PAGAR AUTORIZADO', 'REGISTRA O VALOR DOS LIMITES DE SUB-REPASSES A SEREM RECEBIDOS, AUTORIZADAS PELO MINISTERIO DA FAZENDA E PELAS COORDENACOES DE ORCAMENTO E FINANCAS DE CADA ORGAO PARA ATENDER DESPESAS COM RESTOS A PAGAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.8.02.00', 'SUB-REPASSE NAO DECORRENTE DO ORCAMENTO SOLICITADA A APROVAR', 'REGISTRA AS SUB-REPASSES A SEREM RECEBIDOS, JA SOLICITADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.8.03.00', 'SUB-REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO A LIBERAR', 'REGISTRA AS SUB-REPASSES A SEREM RECEBIDOS, JA SOLICITADOS E APROVADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.8.04.00', 'SUB-REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO LIBERADO', 'REGISTRA AS SUB-REPASSES RECEBIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.8.05.00', 'SUB-REPASSE TRANSFERIDO', 'REGISTRA AS SUB-REPASSES NAO DECORRENTES DO ORCAMENTO TRANSFERIDOS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.8.06.00', 'SUB-REPASSE PROVENIENTE DE DARF EMITIDO', 'REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.8.07.00', 'SUB-REPASSE PROVENIENTE DE GPS EMITIDA', 'REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.8.08.00', 'SUB-REPASSE PROVENIENTE DE DAR EMITIDO', 'REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.8.09.00', 'SUB-REPASSE PROVENIENTE DE GFIP EMITIDA', 'REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.8.10.00', 'SUB-REPASSE PROVENIENTE DE GRU EMITIDA.', 'REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.8.11.00', 'SUB-REPASSE DIRETAMENTE ARRECADADO', 'REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.9.01.01', 'SUB-REPASSE DE RESTITUICAO SOLICITADO A RECEBER', 'REGISTRA OS VALORES DE SUB-REPASSES SOLICITADOS A RECEBER, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.9.01.02', 'SUB-REPASSE DE RESTITUICAO A RECEBER', 'REGISTRA OS VALORES DE SUB-REPASSES A RECEBER, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.9.01.03', 'SUB-REPASSE DE RESTITUICAO RECEBIDO', 'REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.9.01.04', 'SUB-REPASSE DE RESTITUICAO UTILIZADO', 'REGISTRA OS VALORES DE SUB-REPASSES UTILIZADOS NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.9.02.00', 'SUB-REPASSE DE COMPENSACAO UTILIZADA', 'REGISTRA OS VALORES DE SUB-REPASSES A SEREM RECEBIDOS, PARA UTILIZACAO NAS COMPENSACOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.9.03.01', 'SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS SOLICITADO A RECEBER', 'REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS SOLICITADOS AO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.9.03.02', 'SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS A RECEBER', 'REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS A RECEBER DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.9.03.03', 'SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS RECEBIDO', 'REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS RECEBIDOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.1.1.00.00', 'LIMITE ORCAMENTARIO A DISPONIBILIZAR', 'REGISTRA O VALOR DO LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS A SER DISPONIBILIZADO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA PARA OS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.1.2.00.00', 'LIMITE ORCAMENTARIO DISPONIBILIZADO', 'REGISTRA O VALOR DO LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS DISPONIBILIZADO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA PARA OS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.1.3.00.00', 'LIMITE ORCAMENTARIO DISPONIBILIZADO - ENCERRAMENTO', 'REGISTRA O VALOR DO LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS DISPONIBILIZADO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA PARA OS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA APOS O ENCERRAMENTO DO PRAZO DE EMISSAO DE NOTA DE EMPENHO DETERMINADO PELO DECRETO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.01.00', 'LIMITE ORCAMENTARIO A UTILIZAR', 'REGISTRA O VALOR DO LIMITE ORCAMENTARIO A SER UTILIZADO PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA PARA MOVIMENTACAO DE CREDITOS E EMPENHO DA DESPESA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.02.00', 'LIMITE ORCAMENTARIO DE PRE-EMPENHO A UTILIZAR', 'REGISTRA O VALOR DO LIMITE ORCAMENTARIO PRE-EMPENHADO A SER UTILIZADO PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA PARA MOVIMENTACAO DE CREDITOS E EMPENHO DA DESPESA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.03.00', 'LIMITE ORCAMENTARIO UTILIZADO', 'REGISTRA O VALOR DO LIMITE ORCAMENTARIO UTILIZADO PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA POR MOVIMENTACAO DE CREDITOS OU EMPENHO DA DESPESA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.04.00', 'LIMITE ORCAMENTARIO TRANSFERIDO', 'REGISTRA O VALOR DO LIMITE ORCAMENTARIO TRANSFERIDO PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA PARA OS FUNDOS E ENTIDADES VINCULADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.05.00', 'LIMITE ORCAMENTARIO DESCENTRALIZADO', 'REGISTRA O VALOR DO LIMITE ORCAMENTARIO DESCENTRALIZADO POR PROVISAO OU DESTAQUE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.06.00', 'LIMITE ORCAMENTARIO POR DESCENTRALIZACAO INTERNA', 'REGISTRA O VALOR DO LIMITE ORCAMENTARIO UTILIZADO RECEBIDO POR PROVISAO DE CREDITOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.07.00', 'LIMITE ORCAMENTARIO POR DESCENTRALIZACAO EXTERNA', 'REGISTRA O VALOR DO LIMITE ORCAMENTARIO UTILIZADO POR DESTAQUE DE CREDITOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.08.00', 'LIMITE ORCAMENTARIO TRANSFERIDO PARA INSCRICAO EM RESTOS A PAGAR', 'REGISTRA O VALOR DO LIMITE ORCAMENTARIO TRANSFERIDO PARA INSCRICAO EM RESTOS A PAGAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.09.00', 'LIMITE ORCAMENTARIO A UTILIZAR - ENCERRAMENTO', 'REGISTRA O NOVO VALOR DO LIMITE ORCAMENTARIO A UTILIZAR APOS O ENCERRAMENTO DO PRAZO DE EMISSAO DE EMPENHO DEFINIDO PELO DECRETO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.10.00', 'LIMITE ORCAMENTARIO UTILIZADO PELA UO -ENCERRAMENTO', 'REGISTRA O VALOR DAS COTAS DE DESPESAS ORCAMENTARIAS UTILIZADAS PELAS SETORIAIS ORCAMENTARIAS NA ROTINA DE ENCERRAMENTO DO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.11.00', 'LIMITE ORCAMENTARIO TRANSFERIDO - ENCERRAMENTO', 'REGISTRA O VALOR DA COTA DE LIMITE ORCAMENTARIO TRANSFERIDO APOS O ENCERRAMENTO DO PRAZO DE EMISSAO DE NOTA DE EMPENHO DETERMINADO PELO DECRETO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.12.00', 'LIMITE ORCAMENTARIO DESCENTRALIZACAO - ENCERRAMENTO', 'REGISTRA O VALOR DA COTA DE LIMITE ORCAMENTARIO DESCENTRALIZADO APOS O ENCERRAMENTO DO PRAZO DE EMISSAO DE NOTA DE EMPENHO DETERMINADO PELO DECRETO DE PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.13.00', 'LIMITE ORCAMENTARIO UTILIZADO PARA DESCENTRALIZACAO INTERNA -ENCERRAMENTO', 'REGISTRA O VALOR DAS COTAS DE DESPESAS ORCAMENTARIAS UTILIZADAS PELA SETORIAL ORCAMENTARIA NO MOMENTO DA EMISSAO DA NOTA DE EMPENHO, QUANDO A SETORIAL FINANCEIRA DE ORGAO DA UNIDADE ORCAMENTARIA FOR A MESMA DA SETORIAL FINANCEIRA DO ORGAO DA UG EMITENTE DA NOTA DE EMPENHO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.2.0.14.00', 'LIMITE ORCAMENTARIO UTILIZADO PARA DESCENTRALIZACAO EXTERNA -ENCERRAMENTO', 'REGISTRA O VALOR DAS COTAS DE DESPESAS ORCAMENTARIAS UTILIZADAS PELA SETORIAL ORCAMENTARIA NO MOMENTO DA EMISSAO DA NOTA DE EMPENHO, QUANDO A SETORIAL FINANCEIRA DE ORGAO DA UNIDADE ORCAMENTARIA FOR DIFERENTE DA SETORIAL FINANCEIRA DO ORGAO DA UG EMITENTE DA NOTA DE EMPENHO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.01.00', 'ARRECADACAO BRUTA POR CODIGO DE RECEITA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.02.00', 'ARRECADACAO BRUTA POR RETIFICACAO POR CODIGO DE RECEITA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, RESULTANTE DE RETIFICACOES POSITIVAS, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.03.00', 'EQUALIZACOES???? POR CODIGO DE RECEITA', 'REGISTRA O VALOR DAS APROPRIACOES DAS EQUALIZACOES POR CODIGO DE RECEITA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.04.00', 'PROGRAMA DE RECUPERACAO FISCAL - REFIS POR CODIGO DE RECEITA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA DE ARRECADACAO FISCAL - REFIS, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.05.00', 'CONTRIB. INTERV. DOMINIO ECONOMICO - CIDE POR CODIGO DE RECEITA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.06.00', 'RETENCAO DE PGTO DE PJ POR PJ POR CODIGO DE RECEITA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE A RETENCAO DE PAGAMENTO DE PESSOA JURIDICA POR PESSOA JURIDICA (CONFORME IN SRF 459, DE 18/10/2004), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.07.00', 'DEPOS.REGIME ESPECIAL TRIBUTACAO PATRIMONIO???? POR CODIGO DE RECEITA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO REGIME ESPECIAL DE TRIBUTACAO DO PATRIMONIO (INSTITUIDO PELA LEI 10.931, DE 02/08/2004), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.08.00', 'DEP.RET.DE CONTRIB. S/PAGTO ESTAD/MUNIC. A PJ POR CODIGO DE RECEITA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AOS DEPOSITOS RELATIVOS AS RETENCOES DE CONTRIBUICOES (CSLL, COFINS, PIS/PASEP) SOBRE PAGAMENTOS A PESSOA JURIDICA DE DIREITO PRIVADO PELOS ESTADOS OU MUNICIPIOS (DE ACORDO COM OS ARTIGOS 31 E 33 DA LEI 10.833, DE 29/12/2003), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.09.00', 'PROGRAMA ESPECIAL - PAES POR CODIGO DE RECEITA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA ESPECIAL - PAES, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.10.00', 'RETENCAO DE ORGAOS PUBLICOS - ROP POR CODIGO DE RECEITA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE RETENCOES DE ORGAOS PUBLICOS - ROP, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.11.00', 'PROGRAMA EXCEPCIONAL - PAEX POR CODIGO DE RECEITA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA EXCEPCIONAL - PAEX (OCORRIDAS NA VIGENCIA DA MEDIDA PROVISORIA Nº 303/2006), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.12.00', 'SIMPLES NACIONAL POR CODIGO DE RECEITA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO SIMPLES NACIONAL (CONFORME LEI COMPLEMENTAR Nº 123, DE 14/12/2006), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.13.00', 'PROGRAMA EXCEPCIONAL - PAEX 2 POR CODIGO DE RECEITA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA EXCEPCIONAL - PAEX (OCORRIDAS NA VIGENCIA DA MEDIDA PROVISORIA Nº 303/2006, REFERENTE A DECOMPOSICAO DO CODIGO DE RECEITA 1927 - PARCELAMENTO MP 303/2006, ART. 8, PJ SIMPLES), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.14.00', '(-) RESTITUICOES POR CODIGO DE RECEITA', 'REGISTRA AS RESTITUICOES, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.15.00', '(-) INCENTIVOS FISCAIS POR CODIGO DE RECEITA', 'REGISTRA OS INCENTIVOS FISCAIS, CLASSIFICADOS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.16.00', '(-) COMPENSACOES POR CODIGO DE RECEITA', 'REGISTRA AS COMPENSACOES, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.17.00', '(-) RETIFICACOES POR CODIGO DE RECEITA', 'REGISTRA AS RETIFICACOES NEGATIVAS, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.18.00', 'ITR ARRECADACAO POR CODIGO DE RECEITA', 'REGISTRA A ARRECADACAO DA RECEITA DE ITR POR CODIGO DE RECEITA COM O OBJETIVO DE PERMITIR O CONTROLE E REGISTROS CONTIDOS NO ARQUIVO DA SECRETARIA DA RECEITA FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.19.00', 'ARRECADACAO POR CODIGO DE RECEITA - DIVIDA ATIVA ITR', 'REGISTRA A ARRECADACAO DE ITR POR CODIGO DE RECEITA COM BASE NO ARQUIVO FITA 50 DA RECEITA FEDERAL, REFERENTE A DIVIDA ATIVA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.01.00', 'ARRECADACAO BRUTA POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.02.00', 'ARRECADACAO BRUTA POR RETIFICACAO POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, RESULTANTE DE RETIFICACOES POSITIVAS, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.03.00', 'EQUALIZACOES???? POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA O VALOR DAS APROPRIACOES DAS EQUALIZACOES POR CODIGO DE DESTINACAO PRIMARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.04.00', 'PROGRAMA DE RECUPERACAO FISCAL - REFIS POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA DE ARRECADACAO FISCAL - REFIS, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.05.00', 'CONTRIB. INTERV. DOMINIO ECONOMICO - CIDE POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.06.00', 'RETENCAO DE PGTO DE PJ POR PJ POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE A RETENCAO DE PAGAMENTO DE PESSOA JURIDICA POR PESSOA JURIDICA (CONFORME IN SRF 459, DE 18/10/2004), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.07.00', 'DEPOS.REGIME ESPECIAL TRIBUTACAO PATRIMONIO???? POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO REGIME ESPECIAL DE TRIBUTACAO DO PATRIMONIO (INSTITUIDO PELA LEI 10.931, DE 02/08/2004), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.08.00', 'DEP.RET.DE CONTRIB. S/PAGTO ESTAD/MUNIC. A PJ POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AOS DEPOSITOS RELATIVOS AS RETENCOES DE CONTRIBUICOES (CSLL, COFINS, PIS/PASEP) SOBRE PAGAMENTOS A PESSOA JURIDICA DE DIREITO PRIVADO PELOS ESTADOS OU MUNICIPIOS (DE ACORDO COM OS ARTIGOS 31 E 33 DA LEI 10.833, DE 29/12/2003), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.09.00', 'PROGRAMA ESPECIAL - PAES POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA ESPECIAL - PAES, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.10.00', 'RETENCAO DE ORGAOS PUBLICOS - ROP POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE RETENCOES DE ORGAOS PUBLICOS - ROP, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.11.00', 'PROGRAMA EXCEPCIONAL - PAEX POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA EXCEPCIONAL - PAEX (OCORRIDAS NA VIGENCIA DA MEDIDA PROVISORIA Nº 303/2006), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.12.00', 'SIMPLES NACIONAL POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO SIMPLES NACIONAL (CONFORME LEI COMPLEMENTAR Nº 123, DE 14/12/2006), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.13.00', 'PROGRAMA EXCEPCIONAL - PAEX 2 POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA EXCEPCIONAL - PAEX (OCORRIDAS NA VIGENCIA DA MEDIDA PROVISORIA Nº 303/2006, REFERENTE A DECOMPOSICAO DO CODIGO DE DESTINACAO PRIMARIA 1927 - PARCELAMENTO MP 303/2006, ART. 8, PJ SIMPLES), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.14.00', '(-) RESTITUICOES POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA AS RESTITUICOES, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.15.00', '(-) INCENTIVOS FISCAIS POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA OS INCENTIVOS FISCAIS, CLASSIFICADOS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.16.00', '(-) COMPENSACOES POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA AS COMPENSACOES, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.17.00', '(-) RETIFICACOES POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA AS RETIFICACOES NEGATIVAS, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.18.00', 'ITR ARRECADACAO POR CODIGO DE DESTINACAO', 'REGISTRA A ARRECADACAO DA RECEITA DE ITR POR CODIGO DE DESTINACAO DA RECEITA COM O OBJETIVO DE CONTROLE E REGISTROS DOS DADOS CONTIDOS NOS ARQUIVOS DA SECRETARIA DA RECEITA FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.19.00', 'ARRECADACAO POR CODIGO DE DESTINACAO - DIVIDA ATIVA ITR', 'REGISTRA OS VALORES DA ARRECADACAO BRUTA POR CODIGO DE DESTINACAO COM BASE NO ARQUIVO FITA 50 DA RECEITA FEDERAL, REFERENTE AA DIVIDA ATIVA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.01.00', 'ARRECADACAO BRUTA POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.02.00', 'ARRECADACAO BRUTA POR RETIFICACAO POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, RESULTANTE DE RETIFICACOES POSITIVAS, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.03.00', 'EQUALIZACOES???? POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA O VALOR DAS APROPRIACOES DAS EQUALIZACOES POR CODIGO DE DESTINACAO VINCULADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.04.00', 'PROGRAMA DE RECUPERACAO FISCAL - REFIS POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA DE ARRECADACAO FISCAL - REFIS, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.05.00', 'CONTRIB. INTERV. DOMINIO ECONOMICO - CIDE POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.06.00', 'RETENCAO DE PGTO DE PJ POR PJ POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE A RETENCAO DE PAGAMENTO DE PESSOA JURIDICA POR PESSOA JURIDICA (CONFORME IN SRF 459, DE 18/10/2004), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.07.00', 'DEPOS.REGIME ESPECIAL TRIBUTACAO PATRIMONIO???? POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO REGIME ESPECIAL DE TRIBUTACAO DO PATRIMONIO (INSTITUIDO PELA LEI 10.931, DE 02/08/2004), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.08.00', 'DEP.RET.DE CONTRIB. S/PAGTO ESTAD/MUNIC. A PJ POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AOS DEPOSITOS RELATIVOS AS RETENCOES DE CONTRIBUICOES (CSLL, COFINS, PIS/PASEP) SOBRE PAGAMENTOS A PESSOA JURIDICA DE DIREITO PRIVADO PELOS ESTADOS OU MUNICIPIOS (DE ACORDO COM OS ARTIGOS 31 E 33 DA LEI 10.833, DE 29/12/2003), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.09.00', 'PROGRAMA ESPECIAL - PAES POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA ESPECIAL - PAES, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.10.00', 'RETENCAO DE ORGAOS PUBLICOS - ROP POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE RETENCOES DE ORGAOS PUBLICOS - ROP, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.11.00', 'PROGRAMA EXCEPCIONAL - PAEX POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA EXCEPCIONAL - PAEX (OCORRIDAS NA VIGENCIA DA MEDIDA PROVISORIA Nº 303/2006), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.12.00', 'SIMPLES NACIONAL POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO SIMPLES NACIONAL (CONFORME LEI COMPLEMENTAR Nº 123, DE 14/12/2006), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.13.00', 'PROGRAMA EXCEPCIONAL - PAEX 2 POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA EXCEPCIONAL - PAEX (OCORRIDAS NA VIGENCIA DA MEDIDA PROVISORIA Nº 303/2006, REFERENTE A DECOMPOSICAO DO CODIGO DE DESTINACAO VINCULADA 1927 - PARCELAMENTO MP 303/2006, ART. 8, PJ SIMPLES), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.14.00', '(-) RESTITUICOES POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA AS RESTITUICOES, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.15.00', '(-) INCENTIVOS FISCAIS POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA OS INCENTIVOS FISCAIS, CLASSIFICADOS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.16.00', '(-) COMPENSACOES POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA AS COMPENSACOES, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.17.00', '(-) RETIFICACOES POR CODIGO DE DESTINACAO VINCULADA', 'REGISTRA AS RETIFICACOES NEGATIVAS, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.18.00', 'ARRECADACAO LIQUIDA - DIVIDA ATIVA ITR', 'REGISTRA OS VALORES DA ARRECADACAO LIQUIDA DA RECEITA DO ITR DECORRENTE DA DIVIDA ATIVA PROVENIENTE DA FITA 50 DA RECEITA FEDERAL DO BRASIL.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.01.01', 'RECOLHIMENTO DO PRINCIPAL P/ COD.RECOLHIMENTO', 'REGISTRA A ARRECADACAO DO PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.01.02', 'RECOLHIMENTO DE MULTA/MORA/JUROS', 'REGISTRA A ARRECADACAO DE MULTA/MORA SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO. NA GR COBRANCA TAMBEM SAO REGISTRADOS OS JUROS NESSA CONTA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.01.03', 'RECOLHIMENTO OUTROS ACRESCIMOS', 'REGISTRA A ARRECADACAO DE OUTROS ACRESCIMOS DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.01.04', 'RECOLHIMENTO JUROS E ENCARGOS', 'REGISTRA A ARRECADACAO DE JUROS E ENCARGOS SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.01.05', '(-) DESCONTOS E ABATIMENTOS DO RECOLHIMENTO', 'REGISTRA DESCONTOS E ABATIMENTOS DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE RECOLHIMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.01.06', '(-) OUTRAS DEDUCOES DO RECOLHIMENTO', 'REGISTRA OUTRAS DEDUCOES DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE RECOLHIMENTO.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.02.01', 'RETIFICACOES DO PRINCIPAL', 'REGISTRA A RETIFICACAO DA ARRECADACAO DO PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.02.02', 'RETIFICACOES DE MULTA/MORA/JUROS', 'REGISTRA A RETIFICACAO DA ARRECADACAO DE MULTA/MORA SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO. NA GR COBRANCA TAMBEM SAO REGISTRADOS OS JUROS NESSA CONTA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.02.03', 'RETIFICACOES DE OUTROS ACRESCIMOS', 'REGISTRA A RETIFICACAO DA ARRECADACAO DE OUTROS ACRESCIMOS DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.02.04', 'RETIFICACOES JUROS/ENCARGOS', 'REGISTRA A RETIFICACAO DA ARRECADACAO DE JUROS E ENCARGOS SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.02.05', 'RETIFICACAO DE DESCONTOS E ABATIMENTOS', 'REGISTRA A RETIFICACAO DE DESCONTOS E ABATIMENTOS DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE RECOLHIMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.02.06', 'RETIFICACAO DE OUTRAS DEDUCOES RECOLHIMENTO', 'REGISTRA A RETIFICACAO DE OUTRAS DEDUCOES DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE RECOLHIMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.03.01', 'GRU''S RESTITUIDAS POR CODIGO DE RECOLHIMENTO', 'REGISTRA A RESTITUICAO DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.01.01', 'RECOLHIMENTO DO PRINCIPAL P/ COD. DEST. PRIM.', 'REGISTRA A ARRECADACAO DO PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.01.02', 'RECOLHIMENTO DE MULTA/MORA/JUROS', 'REGISTRA A ARRECADACAO DE MULTA/MORA SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA. NA GR COBRANCA TAMBEM SAO REGISTRADOS OS JUROS NESSA CONTA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.01.03', 'RECOLHIMENTO OUTROS ACRESCIMOS', 'REGISTRA A ARRECADACAO DE OUTROS ACRESCIMOS DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.01.04', 'RECOLHIMENTO JUROS E ENCARGOS', 'REGISTRA A ARRECADACAO DE JUROS E ENCARGOS SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.01.05', '(-) DESCONTOS E ABATIMENTOS DO RECOLHIMENTO', 'REGISTRA DESCONTOS E ABATIMENTOS DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO PRIMARIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.01.06', '(-) OUTRAS DEDUCOES DO RECOLHIMENTO', 'REGISTRA OUTRAS DEDUCOES DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO PRIMARIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.02.01', 'RETIFICACOES DO PRINCIPAL', 'REGISTRA A RETIFICACAO DA ARRECADACAO DO PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.02.02', 'RETIFICACOES DE MULTA/MORA/JUROS', 'REGISTRA A RETIFICACAO DA ARRECADACAO DE MULTA/MORA SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA. NA GR COBRANCA TAMBEM SAO REGISTRADOS OS JUROS NESSA CONTA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.02.03', 'RETIFICACOES DE OUTROS ACRESCIMOS', 'REGISTRA A RETIFICACAO DA ARRECADACAO DE OUTROS ACRESCIMOS DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.02.04', 'RETIFICACOES JUROS/ENCARGOS', 'REGISTRA A RETIFICACAO DA ARRECADACAO DE JUROS E ENCARGOS SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.02.05', 'RETIFICACAO DE DESCONTOS E ABATIMENTOS', 'REGISTRA A RETIFICACAO DE DESCONTOS E ABATIMENTOS DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO PRIMARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.02.06', 'RETIFICACAO DE OUTRAS DEDUCOES RECOLHIMENTO', 'REGISTRA A RETIFICACAO DE OUTRAS DEDUCOES DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO PRIMARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.03.01', 'GRU''S RESTITUIDAS POR CODIGO DE DESTINACAO PRIMARIA', 'REGISTRA A RESTITUICAO DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.01.01', 'RECOLHIMENTO DO PRINCIPAL P/ COD. DEST. SEC.', 'REGISTRA A ARRECADACAO DO PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.01.02', 'RECOLHIMENTO DE MULTA/MORA/JUROS', 'REGISTRA A ARRECADACAO DE MULTA/MORA SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA. NA GR COBRANCA TAMBEM SAO REGISTRADOS OS JUROS NESSA CONTA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.01.03', 'RECOLHIMENTO OUTROS ACRESCIMOS', 'REGISTRA A ARRECADACAO DE OUTROS ACRESCIMOS DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.01.04', 'RECOLHIMENTO JUROS E ENCARGOS', 'REGISTRA A ARRECADACAO DE JUROS E ENCARGOS SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.01.05', '(-) DESCONTOS E ABATIMENTOS DO RECOLHIMENTO', 'REGISTRA DESCONTOS E ABATIMENTOS DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO SECUNDARIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.01.06', '(-) OUTRAS DEDUCOES DO RECOLHIMENTO', 'REGISTRA OUTRAS DEDUCOES DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO SECUNDARIA.', 'D', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.02.01', 'RETIFICACOES DO PRINCIPAL', 'REGISTRA A RETIFICACAO DA ARRECADACAO DO PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.02.02', 'RETIFICACOES DE MULTA/MORA/JUROS', 'REGISTRA A RETIFICACAO DA ARRECADACAO DE MULTA/MORA SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA. NA GR COBRANCA TAMBEM SAO REGISTRADOS OS JUROS NESSA CONTA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.02.03', 'RETIFICACOES DE OUTROS ACRESCIMOS', 'REGISTRA A RETIFICACAO DA ARRECADACAO DE OUTROS ACRESCIMOS DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.02.04', 'RETIFICACOES JUROS/ENCARGOS', 'REGISTRA A RETIFICACAO DA ARRECADACAO DE JUROS E ENCARGOS SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.02.05', 'RETIFICACAO DE DESCONTOS E ABATIMENTOS', 'REGISTRA A RETIFICACAO DE DESCONTOS E ABATIMENTOS DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO SECUNDARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.02.06', 'RETIFICACAO DE OUTRAS DEDUCOES RECOLHIMENTO', 'REGISTRA A RETIFICACAO DE OUTRAS DEDUCOES DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO SECUNDARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.03.01', 'GRU''S RESTITUIDAS POR CODIGO DE DESTINACAO SECUNDARIA', 'REGISTRA A RESTITUICAO DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.3.1.00.00', 'ISS SUBSTITUICAO A DISTRIBUIR', 'REGISTRA A TRANSFERENCIA DE ISS A DISTRIBUIR AOS MUNICIPIOS, PARA CONTROLE DA COFIN.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.1.0.00.00', 'CREDITOS A ENCAMINHAR PARA A DIVIDA ATIVA', 'REGISTRA OS VALORES A SEREM ENCAMINHADOS PARA O ORGAO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.2.0.00.00', 'CREDITOS ENCAMINHADOS PARA A DIVIDA ATIVA', 'REGISTRA OS VALORES ENCAMINHADOS PARA O ORGAO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.3.0.00.00', 'CANCELAMENTO DE CREDITOS ENCAMINHADOS PARA A DIVIDA ATIVA', 'REGISTRA O CANCELAMENTO DOS VALORES INDEVIDAMENTE ENCAMINHADOS PARA O ORGAO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.1.0.00.00', 'CREDITOS A INSCREVER EM DIVIDA ATIVA', 'REGISTRA OS VALORES A SEREM INSCRITOS EM DIVIDA ATIVA PELO O ORGAO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.2.0.00.00', 'CREDITOS A INSCREVER EM DIVIDA ATIVA DEVOLVIDOS', 'REGISTRA OS VALORES A SEREM INSCRITOS EM DIVIDA ATIVA QUE FORAM DEVOLVIDOS PELO ORGAO COMPETENTE, POR INCORRECOES NA FORMALIZACAO DO PROCESSO DE ENCAMINHAMENTO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.3.0.00.00', 'CREDITOS INSCRITOS EM DIVIDA ATIVA A RECEBER', 'REGISTRA OS VALORES INSCRITOS EM DIVIDA ATIVA PELO O ORGAO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.4.0.00.00', 'CREDITOS INSCRITOS EM DIVIDA ATIVA RECEBIDOS', 'REGISTRA OS VALORES RECEBIDOS RELATIVOS AOS CREDITOS ANTERIORMENTE INSCRITOS EM DIVIDA ATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.5.0.00.00', 'BAIXA DE CREDITOS INSCRITOS EM DIVIDA ATIVA', 'REGISTRA OS VALORES RELATIVOS AS BAIXAS DE CREDITOS INSCRITOS EM DIVIDA ATIVA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.1.0.00.00', 'PASSIVOS CONTINGENTES PREVISTOS', 'REGISTRA A PREVISAO DOS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.2.0.00.00', 'PASSIVOS CONTINGENTES CONFIRMADOS', 'REGISTRA A CONFIRMACAO DA PREVISAO DOS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.2.1.0.00.00', 'DEMAIS RISCOS FISCAIS PREVISTOS', 'REGISTRA A PREVISAO DOS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.2.2.0.00.00', 'DEMAIS RISCOS FISCAIS CONFIRMADOS', 'REGISTRA A CONFIRMACAO DA PREVISAO DOS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.1.1.01.00', 'COTA FINANCEIRA A REMANEJAR', 'REGISTRA O VALOR SOLICITADO PARA REMANEJAMENTO DE RECURSO/FONTE/VINCULACAO/CATEGORIA DE GASTO DE COTA FINANCEIRA JA LIBERADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.1.1.02.00', 'COTA FINANCEIRA REMANEJADA', 'REGISTRA O VALOR DAS COTAS FINANCEIRAS REMANEJADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.1.2.01.00', 'COTA FINANCEIRA A REMANEJAR', 'REGISTRA O VALOR SOLICITADO PARA REMANEJAMENTO DE RECURSO/FONTE/VINCULACAO/CATEGORIA DE GASTO DE COTA FINANCEIRA JA LIBERADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.1.2.02.00', 'COTA FINANCEIRA REMANEJADA', 'REGISTRA O VALOR DAS COTAS FINANCEIRAS REMANEJADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.1.01.00', 'COTA DE EMPENHO CONTRA-ENTREGA CONCEDIDA', 'REGISTRA A COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA CONCEDIDA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.1.06.01', 'TRIBUTO RETIDO A RECOLHER', 'REGISTRA O VALOR RETIDO, POREM NAO RECOLHIDO, DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG 170500, ESSA RETENCAO FEITA POR UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. E UM MERO REFLEXO DA CONTA 7.9.1.2.2.11', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.1.06.02', 'TRIBUTO RETIDO RECOLHIDO', 'REGISTRA O VALOR RETIDO E RECOLHIDO, DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG 170500, ESSA RETENCAO FEITA POR UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. E UM MERO REFLEXO DA CONTA 7.9.1.2.2.11', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.2.01.00', 'COTA DE EMPENHO CONTRA-ENTREGA RECEBIDA A EMPENHAR', 'REGISTRA A DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA DIRETAMENTE DA SETORIAL FINANCEIRA A EMPENHAR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.2.02.00', 'COTA DE EMPENHO CONTRA-ENTREGA RECEBIDA EMPENHADA A LIQUIDAR', 'REGISTRA A DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA DIRETAMENTE DA SETORIAL FINANCEIRA EMPENHADOS A LIQUIDAR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.2.03.00', 'COTA DE EMPENHO CONTRA-ENTREGA RECEBIDA LIQUIDADA', 'REGISTRA A DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA DIRETAMENTE DA SETORIAL FINANCEIRA LIQUIDADOS A PAGAR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.2.04.00', 'COTA DE EMPENHO CONTRA-ENTREGA RECEBIDA PAGA', 'REGISTRA A DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA DIRETAMENTE DA SETORIAL FINANCEIRA LIQUIDADOS PAGOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.2.05.00', 'COTA DE EMPENHO CONTRA-ENTREGA TRANSFERIDA', 'REGISTRA O VALOR QUE ERA DESTINADO A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA, POREM QUE FOI DESTINADO A OUTRA UG, PARA O MESMO FIM (EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA)', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.2.06.01', 'TRIBUTO RETIDO A RECOLHER', 'REGISTRA O VALOR RETIDO, POREM NAO RECOLHIDO, DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA, ESSA RETENCAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.2.06.02', 'TRIBUTO RETIDO RECOLHIDO', 'REGISTRA O VALOR RETIDO E RECOLHIDO, DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA, ESSA RETENCAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.1.01.00', 'DARF A EMITIR', 'REGISTRA OS DARFS QUE SERAO EMITIDOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.1.02.00', 'DARF EMITIDO', 'REGISTRA OS DARFS EMITIDOS CORRESPONDENTES AO RECOLHIMENTO DE RECURSOS PELA RECEITA FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.1.03.00', 'DARF EMITIDO POR COMPENSACAO DE TRIBUTO', 'REGISTRA OS DARFS EMITIDOS, SEM TRANSFERENCIA DE RECURSOS, DEVIDO A COMPENSACAO DE TRIBUTOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.1.04.00', 'DARF EMITIDO POR COMPENSACAO - ATUFOLHA', 'REGISTRA OS DARFS EMITIDOS, SEM TRANSFERENCIA DE RECURSOS, DEVIDO A COMPENSACAO DE IRRF DECORRIDOS DO PAGAMENTO DA FOLHA .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.2.01.00', 'GPS A EMITIR', 'REGISTRA AS GPSS QUE SERAO EMITIDAS, CLASSIFICADAS POR CODIGO DE PAGAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.2.02.00', 'GPS EMITIDA - CONTROLE DO INSS', 'REGISTRA AS GPSS ELETRONICAS EMITIDAS NO SISTEMA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.2.03.00', 'GPS EMITIDA', 'REGISTRA AS GPSS EMITIDAS, CLASSIFICADAS POR CODIGO DE PAGAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.2.04.00', 'GPS EMITIDA POR COMPENSACAO - ATUFOLHA', 'REGISTRA AS GPSS EMITIDAS, SEM TRANSFERENCIA DE RECURSOS, DEVIDO A COMPENSACAO DE CONTRIBUICOES, DECORRIDAS DO PAGAMENTO DA FOLHA .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.3.01.00', 'DAR A EMITIR', 'REGISTRA OS DARS QUE SERAO EMITIDOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.3.02.00', 'DAR EMITIDO', 'REGISTRA OS DARS EMITIDOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.4.01.00', 'GFIP A EMITIR', 'REGISTRA AS GFIPS QUE SERAO EMITIDAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.4.02.00', 'GFIP EMITIDA', 'REGISTRA AS GFIPS EMITIDAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.5.01.00', 'GRU A EMITIR', 'REGISTRA AS GRUS QUE SERAO EMITIDAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.5.02.00', 'GRU EMITIDA', 'REGISTRA AS GRUS EMITIDAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.6.00.00', 'EXECUCAO DE PAGAMENTOS EFETUADOS', 'REGISTRA O VALOR DOS PAGAMENTOS EFETUADOS PELAS UNIDADES GESTORAS COM BASE NO LIMITE DE SAQUE DA CONTA UNICA DA SECRETARIA DO TESOURO NACIONAL OU DA CONTA UNICA INSTITUCIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.2.1.00.00', 'INGRESSOS', 'REGISTRA O VALOR DE INGRESSOS DE CAIXA DO TESOURO NACIONAL ORIUNDOS DE EMPRESTIMOS EXTERNOS, ANTES DA ETAPA DO REEMBOLSO (REGISTRO NA CONTA UNICA).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.2.2.00.00', 'DISPONIBILIDADES DE RECURSO POR DESTINACAO', 'REGISTRA A MOVIMENTACAO FINANCEIRA VINCULADA AOS INGRESSOS DOS RECURSOS EXTERNOS BEM COMO A APROVACAO DE REEMBOLSO DOS RECURSOS APLICADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.1.1.01.00', 'APOSENTADORIAS', 'REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM APOSENTADORIAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.1.1.02.00', 'PENSOES', 'REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM PENSOES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.1.1.03.00', 'OUTROS BENEFICIOS PREVIDENCIARIOS', 'REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM OUTROS BENEFICIOSPREVIDENCIARIOS NAO DISCRIMINADOS NOS ITENS ANTERIORES, PAGOS PELA RE-DE BANCARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.1.1.04.00', 'AUXILIO A PESSOAS FISICAS', 'REGISTRA O VALOR DAS DESPESAS COM A CONCESSAO DE AUXILIO FINANCEIRODIRETAMENTE A PESSOAS FISICAS, SOB AS MAIS DIVERSAS MODALIDADES, TAISCOMO AJUDA OU APOIO FINANCEIRO E SUBSIDIO OU COMPLEMENTACAO NA AQUISI-CAO DE BENS, NAO CLASSIFICADOS EXPLICITA OU IMPLICITAMENTE EM OUTROSELEMENTOS DE DESPESAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.1.1.05.00', 'SENTENCAS JUDICIAIS', 'REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM SENTENCAS JUDICIAIS RELATIVAS A BENEFICIOS DA PREVIDENCIA SOCIAL PAGOS PELA REDE BANCARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.1.2.00.00', 'EXECUCAO DE BENEFICIOS PAGOS PELA REDE BANCARIA DO EXERCICIO ANTERIOR', 'REGISTRA A EXECUCAO DOS BENEFICIOS PREVIDENCIARIOS PAGOS DIRETAMENTE PELA REDE BANCARIA NO EXERCICIO ANTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.2.1.01.00', 'APOSENTADORIAS', 'REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM APOSENTADORIAS REEM-BOLSADAS AS EMPRESAS SOB REGIME DE CONVENIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.2.1.02.00', 'PENSOES', 'REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM PENSOES PAGAS POREMPRESAS CONVENENTES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.2.1.03.00', 'OUTROS BENEFICIOS PREVIDENCIARIOS', 'REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM OUTROS BENEFICIOSPREVIDENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.2.1.04.00', 'BENEFICIO MENSAL AO DEFICIENTE E AO IDOSO', 'REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM OS BENEFICIOS PREVI-DENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO, A TITULODE BENEFICIO AO DEFICIENTE E AO IDOSO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.2.2.00.00', 'EXECUCAO DE BENEFICIOS PAGOS POR EMPRESAS CONVENENTES DO EXERCICIO ANTERIOR', 'REGISTRA A EXECUCAO DOS BENEFICIOS PREVIDENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO NO EXERCICIO ANTERIOR', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.1.1.01.00', 'ACRESCIMO POR REMANEJAMENTO FONTE RECURSOS', 'REGISTRA OS ACRESCIMOS POR REMANEJAMENTO DE FONTE DE RECURSOS COM USO DOS EVENTOS 540698 E 540699.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.1.1.02.00', 'REDUCAO POR REMANEJAMENTO FONTE RECURSOS', 'REGISTRA DAS REDUCOES POR REMANEJAMENTO DE FONTE DE RECURSOS COM USO DOS EVENTOS 540698 E 540699.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.1.2.00.00', 'EXECUCAO DE CONTROLE FR - CANCELAMENTO OBRIG. EXERC. ANT', 'REGISTRA A EXECUCAO DO CONTROLE POR FONTE DE RECURSOS NO CANCELAMENTO DE OBRIGA-COES DE EXERCICIOS ANTERIORES QUE NAO TENHAM CONTAS DE CONTROLE DE EMPENHO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.1.3.01.00', 'ACRESCIMO DE SALDO (CISAO/FUSAO/EXTINCAO)', 'REGISTRA OS ACRESCIMOS PELA INCORPORACAO DE SALDOS DA DISPONIBILIDADE POR FONTE DE RECURSOS NA ROTINA DE NSSALDO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.1.3.02.00', 'REDUCAO DE SALDO (CISAO/FUSAO/EXTINCAO)', 'REGISTRA O VALOR DAS REDUCOES POR DESINCORPORACAO DE SALDOS DA CONTA DE DISPONIBILIDADE POR FONTE DE RECURSOS NA ROTINA DE NSSALDO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.1.3.03.00', 'ACRESCIMO DE SALDO -TRANSF OBRIG PGTO OUTR UG', 'REGISTRA O CONTROLE DA RECOMPOSICAO DO SALDO DA DISPONIBILIDADE POR FONTE DE RECURSOS, OCASIONADO PELA TRANSFERENCIA DE OBRIGACAO A PAGAR PARA OUTRA UG.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.1.3.04.00', 'REDUCAO DE SALDO - TRANSF OBRIG PGTO OUTR UG', 'REGISTRA O CONTROLE DA REDUCAO DO SALDO DA DISPONIBILIDADE POR FONTE RECURSOS, OCASIONADO PELA TRANSFERENCIA RECEBIDA DE OUTRA UG DE OBRIGACAO A PAGAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.1.4.00.00', 'EXECUCAO DE CONTROLE FR - RESTITUICAO DE RECEITAS', 'REGISTRA A EXECUCAO DO CONTROLE POR FONTE DE RECURSOS NAS ROTINAS DE RESTITUICAOO DE RECEITAS, ONDE NAO HA CONTAS DE CONTROLE DE EMPENHO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.2.1.01.00', 'INGRESSOS', 'REGISTRA O VALOR DE INGRESSOS FISCAIS DE CAIXA DA SECRETARIA DOTESOURO NACIONAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMACAO DOTESOURO NACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.2.1.02.00', 'SAIDAS', 'REGISTRA O VALOR DE SAIDAS FISCAIS DE CAIXA DA SECRETARIA DO TESOURONACIONAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMACAO DO TESOSURONACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.2.1.03.00', 'INGRESSO DA GR', 'REGISTRA O VALOR DE INGRESSOS DE CAIXA DA SECRETARIA DO TESOURO NACIO-NAL PROVENIENTES DA GUIA DE RECOLHIMENTO DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.2.2.01.00', 'INGRESSOS', 'REGISTRA O VALOR DE INGRESSOS DE FINANCEIRAMENTO DE CAIXA DA SECRETA-RIA DO TESOURO NACIONAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMA-CAO FINANCEIRA DO TESOURO NACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.2.2.02.00', 'SAIDAS', 'REGISTRA O VALOR DE SAIDAS DE FINANCAIMENTO DE CAIXA DO TESOURO NACIO-NAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMACAO DO TESOURO NACIO-NAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.2.3.01.00', 'INGRESSOS NA CONTA ESPECIAL', 'REGISTRA O VALOR DE INGRESSOS NA CONTA ESPECIAL REFERENTE AOS RECUR-SOS DE EMPRESTIMOS EXTERNOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.2.3.02.00', 'SAIDAS DA CONTA ESPECIAL', 'REGISTRA O VALOR DE SAIDAS DA CONTA ESPECIAL REFERENTE AOS RECURSOS DE EMPRESTIMOS EXTERNOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.3.1.00.00', 'SALDOS DEVEDORES', 'REGISTRA O VALOR DE DISPONIBILIDADES FINANCEIRAS REFERENTE A TRANSFE-RENCIAS DE CONTAS COM SALDOS DEVEDORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.3.2.00.00', 'SALDOS CREDORES', 'REGISTRA O VALOR DE DISPONIBILIDADES FINANCEIRAS REFERENTE A TRANSFE-RENCIAS DE CONTAS COM SALDOS CREDORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.4.1.00.00', 'CONTROLE FONTE APLIC.RECURSOS DO TESOURO NAC.', 'REGISTRA O VALOR REFERENTE AO CONTROLE POR FONTE DE RECURSOS NA APLI- ACAO FINANCEIRA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.4.2.00.00', 'CONTROLE APLICACAO FINANCEIRA CTU (FTE+VINC)', 'REGISTRA O VALOR REFERENTE AO CONTROLE DOS RECURSOS APLICADOS NA CONTAUNICOS, POR FONTE DE RECURSOS E VINCULACAO DE PAGAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.5.1.1.00.00', 'RA A RETIFICAR (NUMERO DA RA)', 'REGISTRA OS VALORES DAS RETIFICACOES POR NUMERO DE RA (REGISTRO DE AR-RECADACAO).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.5.1.2.00.00', 'RA RETIFICADAS (NUMERO DA RA)', 'REGISTRA OS VALORES DAS RETIFICACOES POR NUMERO DE RA (REGISTRO DE AR-RECADACAO).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.1.1.01.00', 'TITULOS A EMITIR', 'REGISTRA O VALOR REFERENTE A APROPRIACAO DE TITULOS DA DIVIDA PUBLICA A EMITIR SOB A RESPONSABILIDADE DO TESOURO NACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.1.1.02.00', 'TITULOS EMITIDOS', 'REGISTRA O VALOR REFERENTE A APROPRIACAO DE OBRIGACOES RELATIVAS A E-MISSAO DE TITULOS DA DIVIDA PUBLICA SOB A RESPONSABILIDADE DO TESOURO NACIONAL, PREVISTA NA PROGRAMACAO FINANCEIRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.2.1.00.00', 'INCORPORACOES DE RECEITAS', 'REGISTRA OS VALORES REFERENTES AS INCORPORACOES DE RECEITAS PERTENCEN-TES A OUTRA UNIDADE GESTORA DO MESMO ORGAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.2.2.00.00', 'DESICORPORACOES DE RECEITAS', 'REGISTRA OS VALORES REFERENTES AS DESINCORPORACOES DE RECEITAS PERTENCENTES A OUTRA UNIDADE GESTORA DO MESMO ORGAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.3.1.01.01', 'DE RECURSOS EXTERNOS', 'REGISTRA OS VALORES DOS ADIANTAMENTOS DA CONTA UNICA DO TESOURO NACIO-NAL CORRESPONDETES AOS RECURSOS DE EMPRESTIMOS EXTERNOS PARA A UNIDADEGESTORA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.3.1.01.02', 'DE RECURSOS DE CONTRA-PARTIDA', 'REGISTRA OS VALORES DOS ADIANTAMENTOS DA CONTA UNICA DO TESOURO NACIO-NAL CORRESPONDETES AOS RECURSOS DE CONTRA-PARTIDA DE EMPRESTIMOS EX-TERNOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.3.1.02.01', 'DE RECURSOS EXTERNOS', 'REGISTRA OS VALORES DOS ADIANTAMENTOS DE RECURSOS DA CONTA UNICA DOTESOURO NACIONAL PARA A UNIDADE GESTORA CONTRATANTE REFERENTES A EM-PRESTIMOS EXTERNOS QUE FORAM COMPRAVADOS/UTILIZADOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.3.1.02.02', 'DE RECURSOS DE CONTRA-PARTIDA', 'REGISTRA OS VALORES DOS RECURSOS COMPROVADOS REFERENTES AOS ADIANTA-METOS DA CONTA UNICA DO TESOURO NACIONAL PARA A UNIDADE GESTORA CON-TRATANTE RELATIVOS A CONTRAPARTIDA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.3.2.01.00', 'REEMBOLSOS/RESSARCIMENTOS SOLICITADOS', 'REGISTRA A SOCILITACAO DE REEMBOLSOS/RESSARCIMENTOS A SEREM EFETUADOSPARA A CONTA UNICA DO TESOURO NACIONAL, APOS A APLICACAO E COMPROVACAODE RECURSOS ADIANTADOS A UNIDADE GESTORA CONTRATANTE', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.3.2.02.00', 'REEMBOLSOS/RESSARCIMENTOS APROVADOS', 'REGISTRA A APROVACAO DA SOCILITACAO DE REEMBOLSOS/RESSARCIMENTOS A SE-REM EFETUADOS PARA A CONTA UNICA DO TESOURO NACIONAL, APOS A APLICACAOE COMPROVACAO DE RECURSOS EXTERNOS ADIANTADOS A UNIDADE GESTORA CON-TRATANTE', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.3.2.03.00', 'REEMBOLSOS/RESSARCIMENTOS EFETUADOS', 'REGISTRA O REEMBOLSO/RESSARCIMENTO EFETUADOS NA CONTA UNICA DO TESOU-RO NACIONAL, APOS A APLICACAO E COMPROVACAO DE RECURSOS EXTERNOS ADIANTADOS A UNIDADE GESTORA CONTRATANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.01.01', 'CONCEDIDAS A EXECUTAR-RECURSOS EXTERNOS', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E PENDENTES DE EXECUCAO (PAGAMENTO) PELAS UNIDADES GESTORAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.01.02', 'CONCEDIDAS A EXECUTAR-CONTRAPARTIDA', 'REGISTRA OS VALORES DOS RECURSOS ORIUNDOS DE CONTRAPARTIDA NACIONAL LIBERADOS PELA COFIN/STN E PENDENTES DE EXECUCAO(PAGAMENTO) PELAS UNI-DADES GESTORAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.02.01', 'CONCEDIDAS EXECUTADAS-RECURSOS EXTERNOS', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.02.02', 'CONCEDIDAS EXECUTADAS-CONTRAPARTIDA', 'REGISTRA OS VALORES ORIUNDOS DE CONTRAPARTIDA NACIONAL LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.03.01', 'CONCEDIDAS EXECUTADAS-RECURSOS EXTERNOS - ND DET. - TAXA SAQUE', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA NA MOEDA DO PROJETO UTILIZANDO A TAXA DO SAQUE E ESPECIFICADOS PELA NATUREZA DE DESPESA DETALHADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.04.01', 'CONCEDIDAS EXECUTADAS-RECURSOS EXTERNOS - POR CREDOR - TAXA SAQUE', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA NA MOEDA DO PROJETO UTILIZANDO A TAXA DO SAQUE E ESPECIFICADOS POR CREDOR, NUMERO DA OBRIGACAO E PLANO INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.05.01', 'CONCEDIDAS EXECUTADAS-RECURSOS EXTERNOS - ND DET. - TAXA PTAX', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO A TAXA PTAX E ESPECIFICADOS PELA NATUREZA DE DESPESA DETALHADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.05.02', 'CONCEDIDAS EXECUTADAS-RECURSOS CONTRAPARTIDA - ND DET. - TAXA PTAX', 'REGISTRA OS VALORES ORIUNDOS DE CONTRAPARTIDA NACIONAL LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO TAXA PTAX E ESPECIFICADOS PELA NATUREZA DE DESPESA DETALHADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.06.01', 'CONCEDIDAS EXECUTADAS-RECURSOS EXTERNOS - POR CREDOR - TAXA PTAX', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA NA MOEDA DO PROJETO UTILIZANDO A TAXA PTAX E ESPECIFICADOS POR CREDOR, NUMERO DA OBRIGACAO E PLANO INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.06.02', 'CONCEDIDAS EXECUTADAS-RECURSOS CONTRAPARTIDA - POR CREDOR- TAXA PTAX', 'REGISTRA OS VALORES ORIUNDOS DE CONTRAPARTIDA NACIONAL LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO TAXA PTAX E ESPECIFICADOS POR CREDOR, NUMERO DA OBRIGACAO E PLANO INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.01.01', 'RECEBIDAS A EXECUTAR-RECURSO EXTERNO', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E PENDENTES DE EXECUCAO (PAGAMENTO) PELAS UNIDADES GESTORAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.01.02', 'RECEBIDAS A EXECUTAR-CONTRAPARTIDA', 'REGISTRA OS VALORES DOS RECURSOS ORIUNDOS DE CONTRAPARTIDA NACIONAL LIBERADOS PELA COFIN/STN E PENDENTES DE EXECUCAO(PAGAMENTO) PELAS UNI-DADES GESTORAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.02.01', 'RECEBIDAS EXECUTADAS-RECURSO EXTERNO', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.02.02', 'RECEBIDAS EXECUTADAS-CONTRAPARTIDA', 'REGISTRA OS VALORES ORIUNDOS DE CONTRAPARTIDA NACIONAL LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.03.01', 'RECEBIDAS EXECUTADAS-RECURSOS EXTERNOS - ND DET. - TAXA SAQUE', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA NA MOEDA DO PROJETO UTILIZANDO A TAXA DO SAQUE E ESPECIFICADOS PELA NATUREZA DE DESPESA DETALHADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.04.01', 'RECEBIDAS EXECUTADAS-RECURSOS EXTERNOS - POR CREDOR - TAXA SAQUE', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA NA MOEDA DO PROJETO UTILIZANDO A TAXA DO SAQUE E ESPECIFICADOS POR CREDOR, NUMERO DA OBRIGACAO E PLANO INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.05.01', 'RECEBIDAS EXECUTADAS-RECURSOS EXTERNOS - ND DET. - TAXA PTAX', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO A TAXA PTAX E ESPECIFICADOS PELA NATUREZA DE DESPESA DETALHADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.05.02', 'RECEBIDAS EXECUTADAS-RECURSOS CONTRAPARTIDA - ND DET. - TAXA PTAX', 'REGISTRA OS VALORES ORIUNDOS DE CONTRAPARTIDA NACIONAL LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO TAXA PTAX E ESPECIFICADOS PELA NATUREZA DE DESPESA DETALHADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.06.01', 'RECEBIDAS EXECUTADAS-RECURSOS EXTERNOS - POR CREDOR - TAXA PTAX', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA NA MOEDA DO PROJETO UTILIZANDO A TAXA PTAX E ESPECIFICADOS POR CREDOR, NUMERO DA OBRIGACAO E PLANO INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.06.02', 'RECEBIDAS EXECUTADAS-RECURSOS CONTRAPARTIDA - POR CREDOR- TAXA PTAX', 'REGISTRA OS VALORES ORIUNDOS DE CONTRAPARTIDA NACIONAL LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO TAXA PTAX E ESPECIFICADOS POR CREDOR, NUMERO DA OBRIGACAO E PLANO INTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.3.00.00', 'EXECUCAO DO CONTROLE DE REEMBOLSOS', 'REGISTRA A EXECUCAO DAS CONTAS DE SOLICITACAO DE REEMBOLSOS A SEREM EFETUADOS PARA A CONTA UNICA DO TESOURO NACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.4.00.00', 'EXECUCAO DO CONTROLE DE DESEMBOLSOS', 'REGISTRA A EXECUCAO DAS CONTAS DE SOLICITACAO DE DESEMBOLSOS A SEREM EFETUADOS PARA A CONTA UNICA DO TESOURO NACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.01.01', 'OPER.CRED.EXTENAS EXECUTADAS A COMPROVAR', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E PENDENTES DE COM-PROVACAO AOS ORGANISMOS INTERNACIONAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.01.02', 'VALORES NAO COMPROVADOS DEVOLVIDOS', 'REGISTRA O VALOR DE ADIANTAMENTO DO TESOURO, MAS NAO REEMBOLSADO PELO CREDOR EM RAZAO DA NAO COMPROVACAO DENTRO DO PRAZO CONTRATUAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.02.01', 'OPER.CRED.EXTERNAS EXECUTADAS A COMPROVAR', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E PENDENTES DE COM-PROVACAO AOS ORGANISMOS INTERNACIONAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.02.02', 'VALORES NAO COMPROVADOS DEVOLVIDOS', 'REGISTRA VALOR DE ADIANTAMENTO DO TESOURO, MAS NAO REEMBOLSADO PELO CREDOR EM RAZAO DA NAO COMPROVACAO DENTRO DO PRAZO CONTRATUAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.03.01', 'OPER.CRED.EXTERNAS EXECUTADAS A COMPROVAR - TAXA SAQUE', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN /STN, EXECUTADOS ( PAGOS) PELAS UNIDADES GESTORAS E A COMPROVAR, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO A TAXA DE CAMBIO DE SAQUE E ESPECIFICADOS PELO NUMERO DA OBRIGACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.03.02', 'VALORES NAO COMPROVADOS DEVOLVIDOS-TAXA SAQUE', 'REGISTRA O VALOR DE ADIANTAMENTO DO TESOURO, MAS NAO REEMBOLSADO PELO CREDOR EM RAZAO DA NAO COMPROVACAO DENTRO DO PRAZO CONTRATUAL, REFERENTE A PROJETO EXTERNO UTILIZANDO TAXA SAQUE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.04.01', 'OPER.CRED.EXTERNAS EXECUTADAS A COMPROVAR - TAXA PTAX', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN /STN, EXECUTADOS ( PAGOS) PELAS UNIDADES GESTORAS E A COMPROVAR, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO A TAXA DE CAMBIO PTAX E ESPECIFICADOS PELO NUMERO DA OBRIGACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.04.02', 'VALORES NAO COMPROVADOS DEVOLVIDOS- TAXA PTAX', 'REGISTRA VALOR DE ADIANTAMENTO DO TESOURO, MAS NAO REEMBOLSADO PELO CREDOR EM RAZAO DA NAO COMPROVACAO DENTRO DO PRAZO CONTRATUAL, REFERENTE A PROJETO EXTERNO UTILIZANDO TAXA PTAX.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.05.01', 'OPER.CRED.EXTERNAS EXECUTADAS A COMPROVAR - TAXA SAQUE', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN /STN, EXECUTADOS ( PAGOS) PELAS UNIDADES GESTORAS E A COMPROVAR, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO A TAXA DE CAMBIO DE SAQUE E ESPECIFICADOS PELO NUMERO DA OBRIGACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.05.02', 'VALORES NAO COMPROVADOS DEVOLVIDOS-TAXA SAQUE', 'REGISTRA O VALOR DE ADIANTAMENTO DO TESOURO, MAS NAO REEMBOLSADO PELO CREDOR EM RAZAO DA NAO COMPROVACAO DENTRO DO PRAZO CONTRATUAL, REFERENTE A PROJETO EXTERNO UTILIZANDO TAXA SAQUE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.06.01', 'OPER.CRED.EXTERNAS EXECUTADAS A COMPROVAR - TAXA PTAX', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN /STN, EXECUTADOS ( PAGOS) PELAS UNIDADES GESTORAS E A COMPROVAR, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO A TAXA DE CAMBIO PTAX E ESPECIFICADOS PELO NUMERO DA OBRIGACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.06.02', 'VALORES NAO COMPROVADOS DEVOLVIDOS- TAXA PTAX', 'REGISTRA O VALOR DE ADIANTAMENTO DO TESOURO, MAS NAO REEMBOLSADO PELO CREDOR EM RAZAO DA NAO COMPROVACAO DENTRO DO PRAZO CONTRATUAL, REFERENTE A PROJETO EXTERNO UTILIZANDO TAXA PTAX.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.6.01.00', 'CONTROLE DA LIBERACAO DE VALORES NA MOEDA DO PROJETO PELA COFIN', 'REGISTRA A LIBERACAO DE RECURSOS DE PROJETOS EXTERNOS PELA COFIN/STN PARA AS UNIDADES GESTORAS, CONTABILIZANDO NA UG RESPONSAVEL COFIN, NA MOEDA DO PROJETO EXTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.6.02.00', 'CONTROLE DA LIBERACAO DE VALORES NA MOEDA DO PROJETO PELA UG', 'REGISTRA A LIBERACAO DE RECURSOS DE PROJETOS EXTERNOS PELA COFIN/STN PARA AS UNIDADES GESTORAS, CONTABILIZANDO NA UG MOEDA ESTRANGEIRA, NA MOEDA DO PROJETO EXTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.01.00', 'VALORES CONTRATADOS A RECEBER', 'REGISTRA OS VALORES ORIUNDOS DAS OPERACOES DE CREDITO EXTERNAS CONTRA-TADAS A RECEBER DOS CREDORES EXTERNOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.02.00', 'VALORES LIBERADOS', 'REGISTRA O TOTAL DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN EM MOE-DA ESTRANGEIRA UTILIZANDO A TAXA DE CAMBIO APRESENTADA NA TRANSACAO"> CONCAMBIO".', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.03.00', 'SAQUE DA CONTA ESPECIAL SOLICITADO', 'REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APO PRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACA DO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.04.00', 'SAQUE DA CONTA ESPECIAL EFETUADO', 'REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.05.00', 'VALORES EXECUTADOS COMPROVADOS', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS AOSCREDORES EXTERNOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.06.00', 'VALORES CONTRATADOS SOLICITADOS', 'REGISTRA A SOLICITACAO DE RECURSOS EXTERNOS CONTRATADOS NO ATO DA COM-PROVACAO AOS CREDORES EXTERNOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.07.00', 'VALORES CONTRATADOS RECEBIDOS', 'REGISTRA O RECEBIMENTO DOS RECURSOS EXTERNOS CONTRATADOS E SOLICITA- DOS NO ATO DA COMPROVACAO AOS CREDORES EXTERNOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.08.00', 'VALORES GLOSADOS', 'REGISTRA OS VALORES DE RECURSOS EXTERNOS GLOSADOS PELOS CREDORES EXTERNOS NO ATO DA COMPROVACAO DOS DISPENDIOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.09.00', 'VALORES IMPUGNADOS', 'REGISTRA OS VALORES DE RECURSOS EXTERNOS IMPUGNADOS PELOS ORGAOS DECONTROLE, APOS O RECEBIMENTO POR PARTE DO TESOURO NACIONAL DOS VALORESCONTRATADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.10.00', 'DEVOLUCAO AO ORG.INTERNACIONAL SOLICITADA', 'REGISTRA A SOLICITACAO PELAS UNIDADES GESTORAS DE DEVOLUCAO DE RECUR-SOS EXTERNOS AOS ORGANISMOS INTERNACIONAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.11.00', 'DEVOLUCAO AO ORG.INTERNACIONAL EFETUADA', 'REGISTRA A ORDEM DE DEVOLUCAO DOS RECURSOS EXTERNOS EXPEDIDA PELACOFIN/STN AO AGENTE FINANCEIRO DA UNIAO EM FAVOR DO ORGANISMO INTERNA-CIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.12.00', 'VALORES CONTRATADOS CANCELADOS - FINAL', 'REGISTRA O TOTAL DE RECURSOS QUE FORAM CONTRATADOS E CANCELADOS DEVIDOAO TERMINO DA VIGENCIA CONTRATUAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.13.00', 'COMISSOES E TAXAS PAGAS AOS CREDORES EXTERNOS', 'REGISTRA OS VALORES DE COMISSOES E TAXAS (FEF E FIV) PAGAS AOS CREDO- RES EXTERNOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.14.00', 'ACRESCIMO AO VALOR DO CONTRATO', 'REGISTRA ACRESCIMOS AO VALOR VIGENTE DOS CONTRATOS DE OPERACOES DE CREDITO EXTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.15.00', 'CANCELAMENTO DE VALOR CONTRATUAL NA VIGENCIA', 'REGISTRA CANCELAMENTOS DO VALOR VIGENTE DOS CONTRATOS DE OPERACOES DE CREDITO EXTERNO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.17.01', 'RECURSOS EXTERNOS RECEBIDOS COMPROVADOS- TAXA PTAX', 'COMPREENDE O VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS, REGISTRADOS NA MOEDA DO PROJETO EXTERNO, UTILIZANDO A TAXA DE CAMBIO PTAX.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.19.01', 'VALORES GLOSADOS - TAXA PTAX', 'REGISTRA OS VALORES DE RECURSOS EXTERNOS GLOSADOS PELOS CREDORES EXTERNOS NO ATO DA COMPROVACAO DOS DISPENDIOS EM MOEDA ESTRANGEIRA, UTILIZANDO A TAXA PTAX.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.01.00', 'VALORES CONTRATADOS A RECEBER', 'REGISTRA OS VALORES ORIUNDOS DAS OPERACOES DE CREDITO EXTERNAS CONTRA-TADAS A RECEBER DOS ORGANISMOS INTERNACIONAIS, JA DESCONTADAS A TAXAINICIAL DE CONTRATACAO DESSAS OPERACOES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.02.00', 'VALORES LIBERADOS', 'REGISTRA O TOTAL DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN EM MOE-DA ESTRANGEIRA UTILIZANDO A TAXA DE CAMBIO APRESENTADA NA TRANSACAO">CONCAMBIO".', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.03.00', 'SAQUE DA CONTA ESPECIAL SOLICITADO', 'REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.04.00', 'SAQUE DA CONTA ESPECIAL EFETUADO', 'REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.05.00', 'EXECUTADOS COMPROVADOS', 'REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS AOSORGANISMOS INTERNACIONAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.06.00', 'VALORES CONTRATADOS SOLICITADOS', 'REGISTRA A SOLICITACAO DE RECURSOS EXTERNOS CONTRATADOS NO ATO DA COM-PROVACAO AOS ORGANISMOS INTERNACIONAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.07.00', 'VALORES CONTRATADOS RECEBIDOS', 'REGISTRA O RECEBIMENTO DOS RECURSOS EXTERNOS CONTRATADOS E SOLICITA- DOS NO ATO DA COMPROVACAO AOS ORGANISMOS INTERNACIONAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.08.00', 'VALORES GLOSADOS', 'REGISTRA OS VALORES DE RECURSOS EXTERNOS GLOSADOS PELOS ORGANISMOS IN-TERNACIONAIS NO ATO DA COMPROVACAO DOS DISPENDIOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.09.00', 'VALORES IMPUGNADOS', 'REGISTRA OS VALORES DE RECURSOS EXTERNOS IMPUGNADOS PELOS ORGAOS DECONTROLE, APOS O RECEBIMENTO POR PARTE DO TESOURO NACIONAL DOS VALORESCONTRATADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.10.00', 'DEVOLUCAO AO ORG.INTERNACIONAL SOLICITADA', 'REGISTRA A SOLICITACAO PELAS UNIDADES GESTORAS DE DEVOLUCAO DE RECUR-SOS EXTERNOS AOS CREDORES EXTERNOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.11.00', 'DEVOLUCAO AO ORG.INTERNACIONAL EFETUADA', 'REGISTRA A SOLICITACAO PELAS UNIDADES GESTORAS DE DEVOLUCAO DE RECUR-SOS EXTERNOS AOS CREDORES EXTERNOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.12.00', 'VALORES CONTRATADOS CANCELADOS - FINAL', 'REGISTRA O TOTAL DE RECURSOS QUE FORAM CONTRATADOS E CANCELADOS DEVIDO AO TERMINO DA VIGENCIA CONTRATUAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.13.00', 'COMISSOES E TAXAS PAGAS AOS CREDORES EXTERNOS', 'REGISTRA OS VALORES DE COMISSOES E TAXAS (FEF E FIV) PAGAS AOS CREDORES EXTERNOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.15.00', 'CANCELAMENTO DE VALOR CONTRATUAL NA VIGENCIA', 'REGISTRA CANCELAMENTOS DO VALOR VIGENTE DOS CONTRATOS DE OPERACOES DE CREDITO EXTERNO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.17.01', 'RECURSOS EXTERNOS RECEBIDOS COMPROVADOS- TAXA PTAX', 'COMPREENDE O VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS, REGISTRADOS NA MOEDA DO PROJETO EXTERNO, UTILIZANDO A TAXA DE CAMBIO PTAX.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.19.01', 'VALORES GLOSADOS - TAXA PTAX', 'REGISTRA OS VALORES DE RECURSOS EXTERNOS GLOSADOS PELOS CREDORES EXTERNOS NO ATO DA COMPROVACAO DOS DISPENDIOS EM MOEDA ESTRANGEIRA, UTILIZANDO A TAXA PTAX.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.01.00', 'EM CAUCAO', 'REGISTRA A RESPONSABILIDADE DE TERCEIROS POR TITULOS, VALORES E BENS OFERECIDOS EM CAUCAO PELA UNIDADE GESTORA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.02.00', 'CONCEDIDOS EM CUSTODIA', 'REGISTRA O CONTROLE DOS BENS, TITULOS E VALORES EM PODER DE TERCEIROSSOB CUSTODIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.03.00', 'DESPESAS MEDICAS', 'REGISTRA O VALOR DAS DESPESAS MEDICAS PAGAS A HOSPITAIS E CLINICASTENDO COMO USUARIO OS SENHORES PARLAMENTARES E SERVIDORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.04.00', 'EM COBRANCA - A RECEBER', 'REGISTRA O MONTANTE DA RESPONSABILIDADE DE TERCEIROS POR VALORES, TI-TULOS E BENS EM FASE DE COBRANCA PELA UNIDADE GESTORA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.05.00', 'SUPRIMENTO DE FUNDOS', 'REGISTRA OS VALORES CONCEDIDOS A SERVIDOR RESPONSAVEL PARA ATENDERDESPESAS QUE NAO POSSAM SUBORDINAR-SE AO PROCESSO NORMAL DE APLICACAO,ATEH A SUA PRESTACAO DE CONTAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.06.00', 'CONCEDIDOS EM CONSIGNACAO', 'REGISTRA A RESPONSABILIDADE DE TERCEIROS POR VALORES, TITULOS E BENSCONCEDIDOS A TITULO DE CONSIGNACAO PELA UNIDADE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.07.00', 'DIARIAS', 'REGISTRA O VALOR DAS DIARIAS CONCEDIDAS, COM REGISTRO DA RESPONSABILI-DADE MEDIANTE CONTROLE INDIVIDUALIZADO POR TITULAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.08.00', 'TITULOS DE CREDITO', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES DE TERCEIROS PORTITULOS DE CREDITO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.09.00', 'CESSAO DE USO - BENS CEDIDOS', 'REGISTRA A RESPONSABILIDADE DE TERCEIROS POR BENS CEDIDOS PELA UNIDADEA TITULO DE CESSAO DE USO, FORMALIZADA MEDIANTE TERMO, NO QUAL DEVERAOCONSTAR A FINALIDADE DA SUA REALIZACAO E O PRAZO PARA SEU CUMPRIMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.10.00', 'COMODATO DE BENS - CONCEDIDOS', 'REGISTRA A RESPONSABILIDADE DE TERCEIROS POR BENS NAO FUNGIVEIS CONCE-DIDOS PELA UNIDADE, A TITULO DE EMPRESTIMO GRATUITO, OS QUAIS DEVEMSER RESTITUIDOS NO TEMPO CONVENCIONADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.11.00', 'MERCADORIAS E BENS EM PODER DE TERCEIROS', 'REGISTRA O VALOR DAS MERCADORIAS E DOS BENS DAS UNIDADES GESTORAS QUEESTAO EM PODER DE TERCEIROS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.12.00', 'CONCEDIDOS EM DEPOSITO', 'REGISTRA O VALOR DOS BENS CONCEDIDOS DECORRENTE DE CONTRATO DE DEPOSI-TO (ART.1265 DO CODIGO CIVIL BRASILEIRO).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.13.00', 'BENS EM MANUTENCAO', 'REGISTRA A RESPONSABILIDADE DE TERCEIROS POR BENS MOVEIS CONCEDIDOSPELA UNIDADE EM CARATER PROVISORIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.14.00', 'PERMISSAO DE USO - BENS CONCEDIDOS', 'REGISTRA O VALOR DOS BENS CONCEDIDOS A PARTICULAR MEDIANTE PERMISSAODE USO, POR ATO NEGOCIAL, UNILATERAL, DISCRICIONARIO E PRECARIO DA AD-MINISTRACAO PUBLICA, E CUJA UTILIZACAO SEJA DE INTERESSE DA COLETIVI-DADE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.15.00', 'AUTORIZACAO DE USO', 'REGISTRA O CONTROLE DOS BENS PERTENCENTES A ADMINISTRACAO PUBLICA,SOBRE OS QUAIS FOI A AUTORIZADA A PRATICA DE ATIVIDADE INDIVIDUAL,TRANSITORIA E IRRELEVANTE PARA O PODER PUBLICO, POR ATO UNILATERAL,DISCRICIONARIO E PRECARIO, DISPENSANDO LEI AUTORIZATIVA E LICITACAOPARA SEU DEFERIMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.01', 'IMOVEIS RESIDENCIAL/COMERCIAL', 'REGISTRA OS VALORES RELATIVOS AOS IMOVEIS RESIDENCIAIS/COMERCIAIS DETERCEIROS ADMINISTRADOS PELA ENTIDADE', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.02', 'EDIFICIOS', 'REGISTRA OS VALORES RELATIVOS AOS IMOVEIS EDIFICIOS/PREDIOS E CONVEN-TOS COM TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.03', 'TERRENOS/GLEBAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME O CODIGO DA TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.04', 'ARMAZENS/GALPOES', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.05', 'AQUARTELAMENTOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU: BASES', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.06', 'AEROPORTOS/ESTACOES/AERODROMOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.07', 'IMOVEIS DE USO EDUCACIONAL', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.08', 'REPRESAS/ACUDES', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.09', 'AREAS DE PRESERVACAO AMBIENTAL', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.10', 'IMOVEIS DE USO RECREATIVO', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.11', 'ILHAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.12', 'FAROIS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.13', 'EMBAIXADAS E CONSULADOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.14', 'MUSEUS/PALACIOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.15', 'LABORATORIOS/OBSERVATORIOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.16', 'HOSPITAIS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.17', 'HOTEIS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.18', 'PRESIDIOS/DELEGACIAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.19', 'PORTOS/ESTALEIROS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.20', 'COMPLEXOS/FABRICAS/USINAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.21', 'CEMITERIOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.22', 'ESTACIONAMENTOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.23', 'LOJAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.24', 'SALAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CON-FOME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.25', 'ALFANDEGAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.26', 'AUTARQUIAS/FUNDACOES', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.98', 'BENS LOCADOS DE TERCEIROS', 'REGISTRA OS VALORES RELATIVOS AOS BENS LOCADOS PARA TERCEIROS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.17.00', 'CONCESSAO DE USO', 'REGISTRA A DELEGACAO DE SERVICO PUBLICO FEITA PELO PODER CEDENTE,MEDIANTE CONTRATO, PARA SUA EXPLORACAO SEGUNDO DESTINACAO ESPECIFICADE ACORDO COM A LEI 8987 DE 13/02/1995.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.18.00', 'ENCARGOS EM ATRASO - OPERACOES BANCARIAS', 'REGISTRA OS VALORES RELATIVOS A ENCARGOS EM ATRASO RELATIVOS A OPERA-COES BANCARIAS, TAIS COMO OS DECORRENTES DE EMPRESTIMOS, FINANCIAMEN-TOS, TITULOS DESCONTADOS E OUTROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.19.00', 'BENS DE REFORMA AGRARIA SUJEITOS A REVERSAO', 'REGISTRA O VALOR DOS BENS IMOVEIS OBJETO DE REFORMA AGRARIA JA TRANS-FERIDOS AOS ASSENTADOS, MAS QUE PODEM SER REVERTIDOS AO DOMINIO DOINCRA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.20.00', 'RESSARCIMENTO DE VERBA INDENIZATORIA', 'REGISTRA AS DESPESAS COM OS RESSARCIMENTOS REALIZADOS AOS PARLAMENTARES, A TITULO DE VERBA INDENIZATORIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.99.00', 'OUTRAS RESPONSABILIDADES DE TERCEIROS', 'REGISTRA O VALOR DE OUTRAS RESPONSABILIDADES DE TERCEIROS, DE NATUREZAEVENTUAL, POR TITULOS, VALORES E BENS, PARA AS QUAIS NAO HA CONTAS ES-PECIFICAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.01.00', 'RECEBIDOS EM CAUCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.02.00', 'RECEBIDOS EM CUSTODIA', 'REGISTRA O TOTAL DA RESPONSABILIDADE DA UNIDADE GESTORA COM TERCEIROSPELO RECEBIMENTO DE VALORES, TITULOS E BENS PARA GUARDA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.03.00', 'A COLOCAR', 'REGISTRA O VALOR DAS COMPENSACOES ATIVAS DIVERSAS REFERENTE A RESPONSABILIDADE POR VALORES, TITULOS E BENS COM TERCEIROS A COLOCAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.04.00', 'A ENTREGAR', 'REGISTRA O MONTANTE DA RESPONSABILIDADE POR TITULOS, VALORES E BENS DEORGAOS E ENTIDADES COM TERCEIROS, A SEREM ENTREGUES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.05.00', 'EM COBRANCA', 'REGISTRA O MONTANTE DA RESPONSABILIDADE DA UNIDADE GESTORA COM TERCEI-ROS POR VALORES, TITULOS E BENS EM FASE DE COBRANCA PELOS BENEFICIA-DOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.06.00', 'SUPRIMENTO DE FUNDOS', 'REGISTRA A RESPONSABILIDADE COM TERCEIROS REFERENTE A APROPRIACAO DEDESPESAS DE CONCESSAO DE SUPRIMENTO DE FUNDOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.07.00', 'RECEBIDOS EM CONSIGNACAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE COM TERCEIROS POR VALORES, TI-TULOS E BENS RECEBIDOS EM CONSIGNACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.08.00', 'FIANCA BANCARIA', 'REGISTRA A RESPONSABILIDADE DA UNIDADE COM TERCEIROS POR TITULOS, VALORES E BENS AFIANCADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.09.00', 'AUXILIOS A PESQUISA A COMPROVAR', 'REGISTRA A RESPONSABILIDADE DA UNIDADE COM AUXILIOS DE PESQUISA A COM-PROVAR PELA UTILIZACAO DE RECURSOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.10.00', 'SELOS CONSULARES', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR SELOS CONSULARES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.11.00', 'SELOS DE CONTROLE', 'REGISTRA A RESPONSABILIDADE DA UNIDADE POR SELOS DE CONTROLES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.12.00', 'BENEFICIOS TRABALHISTAS A LIQUIDAR', 'REGISTRA OS VALORES CONCEDIDOS A TITULO DE BENEFICIOS COM O SEGURO-DE-SEMPREGO E ABONO SALARIAL DO PIS/PASEP - FAT, A SEREM LIQUIDADOS ATRA-VES DE PRESTACAO DE CONTAS PELOS AGENTES PAGADORES', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.13.00', 'CESSAO DE USO - BENS RECEBIDOS', 'REGISTRA A RESPONSABILIDADE DA UNIDADE JUNTO A TERCEIROS POR BENS RE-CEBIDOS A TITULO DE CESSAO DE USO FORMALIZADA MEDIANTE TERMO, DO QUALDEVERAH CONSTAR A FINALIDADE DA SUA REALIZACAO E O PRAZO PARA SEU CUM-PRIMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.14.00', 'DEPOSITOS JUDICIAIS', 'REGISTRA OS DEPOSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EMCONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOSPOR ESTA PARA TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.15.00', 'DEPOSITOS PARA RECURSOS', 'REGISTRA OS DEPOSITOS PARA RECURSOS EFETUADOS POR TERCEIROS, EM TITU-LOS, EM CONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.16.00', 'COMODATO DE BENS - RECEBIDOS', 'REGISTRA A RESPONSABILIDADE DA UNIDADE JUNTO A TERCEIROS POR BENS NAOFUNGIVEIS RECEBIDOS A TITULO DE EMPRESTIMO GRATUITO, DEVENDO SER RES-TITUIDOS NO TEMPO CONVENCIONADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.17.00', 'BENS E PRODUTOS APREENDIDOS', 'REGISTRA O VALOR DE BENS E PRODUTOS APREENDIDOS SOB A RESPONSABILIDA-DE DA UNIDADE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.18.00', 'MERCADORIAS DE TERCEIROS EM DEPOSITO', 'REGISTRA O VALOR DAS MERCADORIAS DE TERCEIROS EM DEPOSITOS DA UNIDADE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.19.00', 'RECEBIDOS EM DEPOSITO', 'REGISTRA O VALOR DOS BENS RECEBIDOS EM DECORRENCIA DE CONTRATO DEDEPOSITO (ART. 1265 DO CODIGO CIVIL BRASILEIRO).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.20.00', 'BENS RECEBIDOS PARA MANUTENCAO', 'REGISTRA A RESPONSABILIDADE DA UNIDADE JUNTO A TERCEIROS POR BENS MO-VEIS RECEBIDOS EM CARATER PROVISORIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.21.00', 'OBRIG.CONTRATUAIS/CONCESSOES ANTERIORES A 9', 'REGISTRA O VALOR DE OUTRAS OBRIGACOES CONTRATUAIS (CONVENIOS, ACORDOSE AJUSTES) E CONCESSOES DE AUXILIOS, SUBVENCOES E CONTRIBUICOES COMCONTA-CORRENTE DO TIPO 02, EXISTENTES NAS CONTAS RESPECTIVAS AO FINALDO ANO DE 1995, QUANDO FORAM DESATIVADAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.22.00', 'PERMISSAO DE USO - BENS RECEBIDOS', 'REGISTRA O VALOR DOS BENS RECEBIDOS MEDIANTE PERMISSAO DE USO, POR ATONEGOCIAL, UNILATERAL, DISCRICIONARIO E PRECARIO DA ADMINISTRACAO PU-BLICA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.23.00', 'DEPOSITOS FGTS - NAO OPTANTES', 'REGISTRA OS DEPOSITOS EFETUADOS PELA UNIDADE PARA EMPREGADOS NAOOPTANTES PELO FGTS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.01', 'IMOVEIS RESIDENCIAL/COMERCIAL', 'REGISTRA OS VALORES RELATIVOS AOS IMOVEIS RESIDENCIAIS/COMERCIAIS DETERCEIROS EM FASE DE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.02', 'EDIFICIOS', 'REGISTRA OS VALORES RELATIVOS AOS IMOVEIS EDIFICIOS/PREDIOS E CONVEN-TOS DE TERCEIROS EM FASE DE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.03', 'TERRENOS/GLEBAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME O CODIGO DA TABELA SPIU: 53- TERRENOS; 34- GLEBASQUE ESTEJA EMFASE DE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.04', 'ARMAZENS/GALPOES', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: ARMAZENS E GALPOES, QUE ESTEJAM EM FASE DE REGU-LARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.05', 'AQUARTELAMENTOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: BASES; QUARTEIS; FORTES, QUE ESTEJAM EM FASE DEREGULARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.06', 'AEROPORTOS/ESTACOES/AERODROMOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: AERODROMO; AEROPORTO; ESTACAO, QUE ESTEJAM EM FA-SE DE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.07', 'IMOVEIS DE USO EDUCACIONAL', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: ESCOLAS; FACULDADES; UNIVERSIDADES; E BIBLIOTECASQUE ESTEJAM EM FASE DE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.08', 'REPRESAS/ACUDES', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: ACUDES; E REPRESAS, QUE ESTEJAM EM FASE DE REGU-LARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.09', 'AREAS DE PRESERVACAO AMBIENTAL', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: FAZENDAS; PARQUES; E RESERVAS, QUE ESTEJAM EM FA-SE DE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.10', 'IMOVEIS DE USO RECREATIVO', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: CLUBES; ESTADIOS; E TEATROS, QUE ESTEJAM EM FASEDE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.11', 'ILHAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: ILHAS(ILHOTAS), QUE ESTEJAM EM FASE DE REGULARI-ZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.12', 'FAROIS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: FAROIS (FAROLETES), QUE ESTEJAM EM FASE DE REGU-LARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.13', 'EMBAIXADAS E CONSULADOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: CONSULADOS; E EMBAIXADAS, QUE ESTEJAM EM FASE DEREGULARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.14', 'MUSEUS/PALACIOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU, MUSEUS E PALACIOS, QUE ESTEJAM EM FASE DE REGU-LARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.15', 'LABORATORIOS/OBSERVATORIOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU, LABORATORIOS E OBSERVATORIOS, QUE ESTEJAM EM FASEDE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.16', 'HOSPITAIS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: HOSPITAIS, QUE ESTEJAM EM FASE DE REGULARIZACAO//REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.17', 'HOTEIS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: HOTEIS, QUE ESTEJAM EM FASE DE REGULARIZACAO/RE-GISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.18', 'PRESIDIOS/DELEGACIAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: PRESIDIOS E DELEGACIAS, QUE ESTEJAM EM FASE DEREGULARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.19', 'PORTOS/ESTALEIROS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: ESTALEIROS E PORTOS, QUE ESTEJAM EM FASE DE REGU-LARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.20', 'COMPLEXOS/FABRICAS/USINAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: FABRICAS, USINAS E COMPLEXOS, QUE ESTEJAM EM FASEDE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.21', 'CEMITERIOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: CEMITERIOS, QUE ESTEJAM EM FASE DE REGULARIZACO//REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.22', 'ESTACIONAMENTOS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: ESTACIONAMENTOS, QUE ESTEJAM EM FASE DE REGULARI-ZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.23', 'LOJAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: LOJAS, QUE ESTEJAM EM FASE DE REGULARIZACAO/RE-GISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.24', 'SALAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CON-FOME A TABELA SPIU: SALAS, QUE ESTEJAM EM FASE DE REGULARIZACAO/REGIS-TRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.25', 'ALFANDEGAS', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: ALFANDEGAS, QUE ESTEJAM EM FASE DE REGULARIZACAO//REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.26', 'AUTARQUIAS/FUNDACOES', 'REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: AUTARQUIAS/FUNDACOES, QUE ESTEJAM EM FASE DE RE-GULARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.98', 'BENS LOCADOS DE TERCEIROS', 'REGISTRA OS VALORES RELATIVOS AOS BENS LOCADOS DE TERCEIROS QUE ESTE-JAM EM FASE DE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.99.00', 'OUTRAS RESPONSABILIDADES COM TERCEIROS', 'REGISTRA RESPONSABILIDADES COM TERCEIROS, NAO INDIVIDUALIZADAS NAS OU-TRAS CONTAS DESSE GRUPO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.01.00', 'PAGAMENTOS INDEVIDOS', 'REGISTRA AS RESPONSABILIDADES EM APURACAO DE GESTORES E OUTROS RESPON-SAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, IN-CLUSIVE EM CASOS DE SUPERFATURAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.02.00', 'SALDOS NAO RECOLHIDOS', 'REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NAO RECOLHIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU AD-MINISTRATIVAS CUJOS PROCESSOS ESTEJAM EM FASE DE APURACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.03.00', 'DESFALQUES OU DESVIOS', 'REGISTRA OS DESFALQUES OU DESVIOS DE BENS E VALORES DA UNIAO OU DE EN-TIDADES PUBLICAS, EM APURACAO,DECORRENTES DE PROCESSOS POR ACOES ADMI-NINISTRATIVAS, POLICIAIS OU JUDICIAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.04.00', 'DEBITOS DE TERCEIROS EM PREST. SERVICOS', 'REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADESEM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS ESTEJAM EM FA-SE DE APURACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.05.00', 'RESPONSAVEIS POR DANOS OU PERDAS', 'DESTINADA AO REGISTRO DAS RESPONSABILIDADES EM INQUERITOS ADMINISTRA-TIVOS OU POLICIAIS CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDASCAUSADOS A FAZENDA NACIONAL, E QUE ESTEJAM EM FASE DE APURACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.06.00', 'PAGAMENTOS SEM RESPALDO ORCAMENTARIO', 'REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COM-PORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSI-FICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), EM FASEDE APURACAO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.07.00', 'CREDITOS ANTECIPADOS', 'REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTE-CIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, EM FASE DE APU-RACAO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.08.00', 'FALTA OU IRREGULARIDADE DE COMPROVACAO', 'REGISTRA OS VALORES CORRESPOND.A FALTA DE DOCUMENTACAO COMPROBAT.DA E-XECUCAO DA DESPESA, INCLUSIVE AS APRESENT.FORA DO PRAZOLEGAL, BEM CO-MO A INADIMPLENCIA NA COMPROV.DE INSTRUMENT.DE TRANSFER.OU AINDA IRRE-GULARID. NA DOCUMENT., EM FASE DE APURACAO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.09.00', 'FALTA DE LICITACAO', 'REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NE-CESSARIA LICITACAO, INFRINGINDO A LEGISLACAO ESPECIFICA, EM PROCESSOSMOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, EM FASEDE APURACAO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.10.00', 'MULTAS E JUROS', 'REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO, PO-REM DE RESPONSABILIDADE DE SERVIDORES E QUE ESTEJAM EM FASE DE APURA-CAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.11.00', 'FALTA DE RECOLHIMENTO OBRIGACOES PECUNIARIA', 'REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGA-MENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS,NAO PAGAMENTO DE OBRIGAC. PARA COM A UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.12.00', 'FRAUDES EM BENEFICIOS', 'REGISTRAR OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIASOCIAL QUE SE ENCONTRAM EM FASE DE APURACAO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.13.00', 'ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE', 'REGISTRA AS RESPONSABILIDADES EM APURACAO DE GESTORES E OUTROS RESPON-SAVEIS E CO-RESPONSAVEIS POR CONCESSAO DE ADIANTAMENTOS EM DESACORDOCOM A LEGISLACAO PERTINENTE, TAIS COMO ADIANTAMENTOS A FORNECEDORES OUA EMPREGADOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.14.00', 'DEBITOS DECOR. DE UTILIZACAO INDEVIDA DE CO', 'REGISTRA OS DEBITOS (APURADOS E EM APURACAO) DE PARLAMENTARES EM RAZAODE RECEBIMENTO ENDIVIDO DE VALOR RELACIONADO A COTA DESTINA A CUSTEARGASTOS VINCULADOS AO EXERCICIO DE ATIVIDADE PARLAMENTAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.15.00', 'DEBITOS ORIUNDOS DE USO OU ALUGUEL DE IMOVE', 'REGISTRA OS DEBITOS (APURADOS E EM APURACAO) REFERENTES A DEBITOS DEPARLAMENTARES CONHECIDOS APOS SEU AFASTAMENTO DO MANDADO E QUE NAO PU-DERAM SER DESCONTADOS EM FOLHA DE PAGAMENTO. EXEMPLOS: REMANESCENTE DECONTA DE ENERGIA ELETRICA, GAS, TAXA DE LIMPEZA PUBLICA E ALUGUEIS DEOUTROS BENS IMOVEIS PERTENCENTE AO ORGAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.99.00', 'OUTRAS RESPONSABILIDADES EM APURACAO', 'REGISTRA RESPONSABILIDADES EM APURACAO NAO INDIVIDUALIZADAS NAS OUTRASCONTAS DESSE GRUPO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.01.00', 'ESTUDOS E PROJETOS', 'REG. OS REC. APLIC. EM ESTUDOS BASICOS,TAIS COMO: GEOLOGICOS,GEOTECNICOS,TOPOGRAFICOS,LEVANTAMENTOS AEROFOGRAMETICOS,PEDAGOGICO MAPEAMENTOSE ESTUDOS DE PROJETOS, TAIS COMO:ESTUDO DEVIABILIDADE,ANTE PROJETO,PROJETO BASICO E EXECUTIVO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.02.00', 'TERRENOS', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NO LEVANTAMENTO CADASTRAL, INDENIZACAO POR DESAPROPRIACAO,DEMARCACAO DE LOTES E REGISTROS DE ESCRITURAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.03.01', 'BARRAGENS', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO REFERENTES A BARRAGENS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.03.02', 'DIQUES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO REFERENTES A DIQUES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.03.03', 'ESTRUTURA E EQUIPAMENTOS DE ADUCAO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO C/ ESTRUTURA E DEQUIPAMENTOS DE ADUCAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.03.04', 'ESTRUT.E EQUIP.DE CONDUCAO E DISTRIB.DAGUA', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO DA ESTRUTURA E DEQUIPAMENTOS DE CONDUCAO E DISTRIBUICAO DAGUA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.03.05', 'ESTRADAS E CAMINHOS DE SERVICOS', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO DA ESTRUTURA REF. A ESTRADAS E CAMINHOS DE SERVICOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.03.06', 'LINHAS DE TRANSMISSAO DE ENERGIA', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO DA ESTRUTURA COM LINHAS DE TRANSMISSAO DE ENERGIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.03.07', 'REDE DE DRENAGEM PRINCIPAL', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO DA ESTRUTURA COM A REDE DE DRENAGEM PRINCIPAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.03.08', 'PREDIOS DE USO DA ADMINISTRACAO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO DA ESTRUTURA REFERENTE OS PREDIOS DE USO DA ADMINISTRACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.03.09', 'OUTROS INVEST.INFRA-ESTR.IRRIG.DE USO COMUM', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO DA ESTRUTURA DE OUTROS INVESTIMENTOS DE INFRAESTRUTURA DEIRRIGACAO DE USO COMUM INTERNA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.03.90', 'AMORTIZACAO INFRA-ESTRUT. DE IRRIGACAO', 'REGISTRA AS AMORTIZACOES DE VALORES APROPRIADOS COMO ENCARGOS RELATIVOS A EXECUCAO DE PROJETOS DE INFRAESTRUTURA DE IRRIGACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.04.01', 'PREDIOS DE USO HOSPITALAR E AMBULATORIAL', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO, MELHORAMENTO E MANUTENCAO EM PREDIOS DE USO HOSPITALAR EAMBULATORIAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.04.02', 'PREDIOS ESCOLARES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO, MELHORAMENTO E MANUTENCAO EM PREDIOS ESCOLARES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.04.03', 'EQUIPAMENTOS HOSPITALARES E AMBULATORIAIS', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO, MELHORAMENTO E MANUTENCAO EM EQUIPAMENTOS HOSPITALARES E AMBULATORIAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.04.04', 'EQUIPAMENTOS ESCOLARES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO, MELHORAMENTO E MANUTENCAO EM EQUIPAMENTOS ESCOLARES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.04.05', 'ESTRUTURA E EQUIP. URBANOS E DE SANEAMENTO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO, MELHORAMENTO E MANUTENCAO NA ESTRUTURA E EQUIPAMENTOS URBANOS E DE SANEAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.04.06', 'OUTROS INVEST. DE INFRA-ESTR. SOCIAL COMUM', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO, MELHORAMENTO E MANUTENCAO REFERENTE A OUTROS INVESTIMENTOS DE INFRAESTRUTURA SOCIAIS DE USO COMUM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.05.01', 'DESMATAMENTO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO OU MELHORAMENTO DA PARCELA AGRICOLA, REFERENTE AO DESMATAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.05.02', 'SISTEMATIZACAO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO OU MELHORAMENTO DA PARCELA AGRICOLA, REFERENTE A SISTEMATIZACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.05.03', 'CANAIS E DRENOS PARCELARES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO OU MELHORAMENTO DA PARCELA AGRICOLA ,REFERENTE A CANAIS EDRENOS PARCELARES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.05.04', 'HABITACAO DE COLONOS', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO OU MELHORAMENTO DA PARCELA AGRICOLA ,REFERENTE AS HABITACOES DOS COLONOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.05.05', 'REDE DE ASPERSAO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO OU MELHORAMENTO DA PARCELA AGRICOLA , REFERENTE A REDE DEASPERSAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.05.06', 'OUTROS INVEST.DE BENFEIT.INTERNAS NOS LOTES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO OU MELHORAMENTO DA PARCELA AGRICOLA , REFERENTE A OUTROS INVESTIMENTOS DE BENFEITORIAS INTERNAS NOS LT', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.06.01', 'COMUNICACOES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NOSESTUDOS E OBRAS P/IMPLANTACAO DE SISTEMAS DE COMUNICACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.06.02', 'ENERGIA', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NOSESTUDOS E OBRAS P/IMPLANTACAO DE SISTEMAS DE ENERGIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.06.03', 'TRANSPORTES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NOSESTUDOS E OBRAS P/IMPLANTACAO DE SISTEMAS DE TRANSPORTES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.06.04', 'ESTRADAS E CAMINHOS EXTERNOS', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NOSESTUDOS E OBRAS P/IMPLANTACAO DE SISTEMAS DE ESTRADAS E CAMINHOS EXTERNOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.07.00', 'OPERACAO E CONSERV.DE INFRA-ESTR.DE IRRIG.', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAAQUISICAO DE VEICULOS, EQUP.E OUTROS BENS AFINS, BEM COMO OPERACAO,CONSERVACAO E MANUTENCAO DE INFRAESTRUTURA DE IRRIGACAO,EXECUTADAS DIRETAMENTE PELA CODEVASF.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.08.01', 'INFRA-ESTRUT.DE IRRIGACAO DE USO COMUM INT.', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO COMBARRAGENS,DIQUES,ESTRTURA E EQUIP.DE ADUCAO,DE CONDUCAO E DISTRIB. DAGUA,LINHAS DE TRANSMISSAO DE ENERGIA,REDE DE DRENAGEM PRINCIPAL, PREDIOS DA ADM. E OUTROS INVESTIMENTOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.08.02', 'INFRA-ESTRUTURAS SOCIAIS DE USO COMUM', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO COMPREDIOS DE USO HOSPITALAR E AMBULATORIAL, PREDIOS ESCOLARES,EQUIPAMENTOS HOSPITALARES E AMBULATORIAL,EQUIPAMENTOS ESCOLARES,ESTR.E EQUIP. URBANOS E DE SANEAM.E OUTROS INVESTIMENTOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.08.03', 'BENFEITORIAS INTERNAS NOS LOTES', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO COMDESMATAMENTO,SISTEMATIZACAO,CANAIS E DRENOS PARCELARES, HABITACOES, REDE DE ASPERSAO, E OUTROS INVESTIMENTOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.08.04', 'OUTROS INVESTIMENTOS/ OBRAS DE RECUPERACAO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO COMOUTROS INVESTIMENTOS DE OBRAS DE RECUPERACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.09.01', 'BARRAGENS E DIQUES', 'REGISTRA OS RECURSOS APLICADOS NA CONSTRUCAO DE BARRAGENS E REPRESASOU ACUDES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.09.02', 'ESTRUTURA E EQUIPAMENTOS DE ADUCAO', 'REGISTRA OS RECURSOS APLICADOS EM ESTRUTURA E EQUIPAMENTOS QUE REALIZAM OPERACOES DE TRAZER AGUA, NOS SISTEMAS DE ABASTECIMENTOS, DESDE OPONTO DE CAPTACAO ATE A REDE DE DISTRIBUICAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.09.03', 'ESTR.E EQUIP.DE CONDUCAO E DISTRIB.DAGUA', 'REGISTRA OS RECURSOS APLICADOS EM ESTRUTURA E EQUIPAMENTOS DE CONDUCAO E DISTRIBUICAO DAGUA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.09.04', 'ESTRADAS E CAMINHOS DE SERVICOS', 'REGISTRA OS RECURSOS APLICADOS NA CONSTRUCAO DE ESTRADAS E CAMINHOSDE SERVICOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.09.05', 'LINHAS DE TRANSMISSAO DE ENERGIA', 'REGISTRA OS RECURSOS APLICADOS NA CONSTRUCAO DE LINHAS DE TRANSMISSAODE ENERGIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.09.06', 'REDE DE DRENAGEM', 'REGISTRA OS RECURSOS APLICADOS NA CONSTRUCAO DE REDES DE DRENAGEM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.09.07', 'PREDIOS DE USO DA ADMINISTRACAO', 'REGISTRA OS RECURSOS APLICADOS NA CONSTRUCAO DE PREDIOS DE USO DA ADMINISTRACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.09.08', 'OUTROS INVESTIMENTOS', 'REGISTRA OS RECURSOS APLICADOS EM OUTROS INVESTIMENTOS, NAO ESPECIFICADOS NOS SUBITENS ANTERIORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.10.01', 'APOIO AO ASSOCIATIVISMO (INVEST.)', 'REGISTRA OS RECURSOS APLICADOS NA EMANCIPACAO DE PROJETOS EM INVESTIMENTOS NO ASSOCIATIVISMO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.10.02', 'OPERACAO E MANUTENCAO(INVEST.)DELEG.A TERC.', 'REGISTRA OS RECURSOS APLICADOS NA EMANCIPACAO DE PROJETOS EM INVESTIMENTOS NA OPERACAO E MANUTENCAO DELEGADAS A TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.10.03', 'APOIO AO ASSOCIATIVISMO (CUSTEIO)', 'REGISTRA OS RECURSOS APLICADOS NA EMANCIPACAO DE PROJETOS EM CUSTEIONO ASSOCIATIVISMO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.10.04', 'OPERACAO E MANUTENCAO(CUSTEIO)DELEG.A TERC.', 'REGISTRA OS RECURSOS APLICADOS NA EMANCIPACAO DE PROJETOS EM CUSTEIONA OPERACAO E MANUTENCAO DELEGADAS A TERCEIROS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.01', 'ARMAZENAMENTO, BENEFICIAM.E COMERCIALIZACAO', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO EMUSINAS DE BENEFICIAMENTO, ARMAZENS, ARMAZENAGEM E GALPOES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.02', 'EXTENSAO RURAL', 'REGISTRA OS RECURSOS APLICADOS EM ACOES DE PROMOCAO SOCIAL DO HOMEMDO CAMPO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.03', 'LAVOURA', 'REGISTRA OS RECURSOS APLICADOS NA PRODUCAO E PRODUCAO DE SEMENTES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.04', 'MECANIZACAO - INVESTIMENTO', 'REGISTRA OS RECURSOS APLICADOS NOS PROJETOS PUBLICOS DE IRRIGACAO EINVESTIMENTO NA AQUISICAO DE MAQUINAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.05', 'MECANIZACAO - CUSTEIO', 'REGISTRA OS RECURSOS APLICADOS NOS PROJETOS PUBLICOS DE CUSTEIO NAMANUTENCAO DA PATRULHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.06', 'OCUPACAO ESPACIAL E COLONIZACAO', 'REGISTRA OS RECURSOS APLICADOS NA TITULACAO, ASSENTAMENTO DE COLONOSE OUTROS AFINS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.07', 'PISCICULTURA - INVESTIMENTOS', 'REGISTRA OS RECURSOS APLICADOS EM INVESTIMENTOS (EQUIPAMENTOS E CONSTRUCOES) NA PSCICULTURA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.08', 'PISCICULTURA - CUSTEIO', 'REGISTRA OS RECURSOS APLICADOS EM CUSTEIO (RACOES, PRODUCAO DE ALEVINOS, PEIXAMENTO DE ACUDES, OPERACAO E MANUTENCAO) NA PSCICULTURA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.09', 'PRODUCAO ANIMAL - INVESTIMENTOS', 'REGISTRA OS RECURSOS APLICADOS NO DESENVOLVIMENTO DA PRODUCAO ANIMALEM INVESTIMENTOS (EQUIPAMENTOS, CONSTRUCOES, MATRIZES, ETC.).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.10', 'PRODUCAO ANIMAL - CUSTEIO', 'REGISTRA OS RECURSOS APLICADOS EM CUSTEIO (RACOES, CERCAS, VACINAS,OPERACAO E MANUTENCAO E OUTROS AFINS)NA PRODUCAO ANIMAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.11', 'REFLORESTAMENTO', 'REGISTRA OS RECURSOS APLICADOS NOS PROJETOS PUBLICOS DE IRRIGACAO NAIMPLANTACAO E MANUTENCAO DE AREAS REFLORESTADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.12', 'UNIDADE DE OBSERVACAO E DEMONSTRACAO', 'REGISTRA OS RECURSOS APLICADOS EM TRABALHOS DE ADAPTACAO E TRANSFERENCIA DE TECNOLOGIA AGRICOLA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.13', 'ASSISTENCIA TECNICA INTERNACIONAL', 'REGISTRA OS RECURSOS APLICADOS NA PRESTACAO DE SERVICOS POR ENTIDADESINTERNACIONAIS (IICAFAO, ETC.)', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.14', 'FRUTICULTURA', 'REGISTRA OS RECURSOS APLICADOS PELA UNIDADE REF. A FRUTICULTURA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.12.01', 'MONITORIA', 'REGISTRA OS RECURSOS APLICADOS NA IMPLANTACAO E MANUTENCAO DE SISTEMASDE ACOMPANHAMENTO E AVALIACAO DOS PERIMETROS IRRIGADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.12.02', 'RECUPERACAO DOS DANOS DAS ENCHENTES', 'REGISTRA OS RECURSOS APLICADOS EM INVESTIMENTOS EM REGIME DE EXECUCAOESPECIAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.12.03', 'COMBATE AOS EFEITOS DA SECA', 'REGISTRA OS RECURSOS APLICADOS EM INVESTIMENTOS EM REGIME DE EXECUCAOESPECIAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.12.04', 'PROG. PILOTO DE MUNIC. DA IRRIG. - PPMI', 'REGISTRA OS RECURSOS APLICADOS EM INVESTIMENTOS EM REGIME DE EXECUCAOESPECIAL NO PROGRAMA PILOTO DE MUNICIPALIZACAO DA IRRIGACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.13.01', 'COMUNICACAO', 'REGISTRA OS RECURSOS APLICADOS DE CONTRATOS, CONVENIOS E OUTROS INSTRUMENTOS PARA ESTUDO, IMPLANTACAO, OPERACAO E MANUTENCAO DE SISTEMAS DECOMUNICACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.13.02', 'DESENVOLVIMENTO RURAL', 'REGISTRA OS RECURSOS APLICADOS DE CONTRATOS, CONVENIOS E OUTROS INSTRUMENTOS PARA ESTUDO, IMPLANTACAO, OPERACAO E MANUTENCAO DE ADITORAS RURAIS, BARRAGENS E INFRAESTRUTURA DE IRRIGACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.13.03', 'DESENVOLVIMENTO URBANO', 'REGISTRA OS RECURSOS APLICADOS DE CONTRATOS, CONVENIOS E OUTROS INSTRUMENTOS PARA ESTUDO, IMPLANTACAO, OPERACAO E MANUTENCAO RELATIVOS AO;ABASTECIMENTO DAGUA, DESENVOLVIMENTO URBANO, EDUCACAO, HABITACAO, SANEAMENTO, SAUDE E OUTROS AFINS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.13.04', 'TRANSPORTES', 'REGISTRA OS RECURSOS APLICADOS DE CONTRATOS, CONVENIOS E OUTROS INSTRUMENTOS PARA ESTUDO, IMPLANTACAO, OPERACAO E MANUTENCAO DE SISTEMAS DETRANSPORTES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.14.01', 'ATIVIDADES COMPLEMENTARES', 'REGISTRA OS RECURSOS APLICADOS EM INVESTIMENTOS COM OBRAS OU DESENVOLVIMENTO DE ATIVIDADES NAO PREVISTAS, MAS INDISPENSAVEIS AO BOM ANDAMENTO DOS SISTEMAS OPERACIONAL E PRODUTIVO DOS PROJETOS DA CODEVASF.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.14.02', 'APOIO A IRRIGACAO COMUNITARIA', 'REGISTRA OS VALORES APLICADOS EM APOIO AA IRRIGACAO COMUNITARIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.14.03', 'PROJETO AMANHA', 'REGISTRA OS VALORES APLICADOS EM APOIO AO PROJETO AMANHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.15.01', 'PLANEJAMENTO REGIONAL', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS DE IRRIGACAO C/PLANEJAMENTO REGIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.15.02', 'ESTUDOS MACRO-REGIONAIS', 'REGISTRA A APLICACAO DE RECURSOS COM PROJETOS DE IRRIGACAO NO QUE SEREFERE A ESTUDOS MACROREGIONAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.15.03', 'MONITORIA', 'REGISTRA OS RECURSOS APLICADOS EM PROJETOS DE IRRIGACAO COM MONITORIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.15.04', 'ESTUDOS E PROJETOS', 'REGISTRA A APLICACAO DE RECURSOS EM PROJETOS DE IRRIGACAO COM ESTUDOSE PROJETOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.15.05', 'TREINAMENTO', 'REGISTRA A APLICACAO DE RECURSOS COM EXECUCAO DE PROJETOS NO QUE SE REFERE A TREINAMENTOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.16.00', 'AVALIACAO QUALITATIVA DE CUSTOS', 'REGISTRA OS VALORES REFERENTES A AVALIACAO QUALITATIVA DE CUSTOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.17.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE OBRAS CIVIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.17.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.17.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM BENS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.17.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.17.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM TREINAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.17.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS NAO ALOCADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.18.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE OBRAS CIVIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.18.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.18.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM BENS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.18.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.18.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM TREINAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.18.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS NAO ALOCADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.19.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE OBRAS CIVIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.19.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.19.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM BENS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.19.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.19.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM TREINAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.19.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS NAO ALOCADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.20.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE OBRAS CIVIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.20.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.20.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM BENS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.20.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.20.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM TREINAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.20.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS NAO ALOCADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.21.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE OBRAS CIVIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.21.02', 'PROJETO BIRD RJ - REC.BIRD (REABIL./MAT.ROD', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.21.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM BENS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.21.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.21.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM TREINAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.21.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS NAO ALOCADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.22.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE OBRAS CIVIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.22.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.22.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM BENS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.22.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.22.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS COM TREINAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.22.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO REFERENTE DESPESAS NAO ALOCADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.23.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE OBRAS CIVIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.23.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.23.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM BENS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.23.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.23.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS COM TREINAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.23.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE REFERENTE DESPESAS NAO ALOCADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.24.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE OBRAS CIVIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.24.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.24.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM BENS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.24.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.24.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS COM TREINAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.24.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM RECIFEREFERENTE DESPESAS NAO ALOCADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.25.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE OBRAS CIVIS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.25.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.25.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM BENS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.25.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.25.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS COM TERINAMENTO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.25.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SALVADOR REFERENTE DESPESAS NAO ALOCADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.26.01', 'OBRAS CIVIS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIODE JANEIRO REFERENTE OBRAS CIVIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.26.02', 'REABILITACAO E MATERIAL RODANTE', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM REABILITACAO E MATERIAL RODANTE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.26.03', 'BENS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM BENS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.26.04', 'SERVICOS DE CONSULTORIA', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM SERVICOS DE CONSULTORIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.26.05', 'TREINAMENTO', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS COM TREINAMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.26.06', 'NAO ALOCADOS', 'REGISTRA O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO REFERENTE DESPESAS NAO ALOCADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.01.01', 'A CONCEDER', 'REGISTRA O VALOR DOS LIMITES AUTORIZADOS A CONCEDER NA EXECUCAO FISICADO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.01.02', 'CONCEDIDOS', 'REGISTRA O VALOR DOS LIMITES AUTORIZADOS CONCEDIDOS NA EXECUCAO FISICADO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.01.03', 'CONCEDIDOS NO EXERCICIO ANTERIOR', 'REGISTRA A DISPONIBILIZACAO DE CREDITO ESCRITURAL DE SOLICITACOES AOEXTERIOR SUPERESTIMADAS NO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.01.04', 'CONCEDIDOS EM EXERCICIOS ANTERIORES', 'REGISTRA A DISPONIBILIZACAO DE CREDITO ESCRITURAL DE SOLICITACOES AOEXTERIOR SUPERESTIMADAS DOS EXERCICIOS ANTERIORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.01.05', 'CONCEDIDOS DECORRENTE DA DOTACAO DO P.A.I', 'REGISTRA O VALOR DOS LIMITES AUTORIZADOS REFERENTE A DOTACAO DO PLANODE ACAO INICIAL REFERENTE A EXECUCAO FISICA DO PLANO INTERNO ESCRITURAL DO COMANDO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.02.01', 'COMPROMISSADOS', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.02.02', 'EXECUTADOS', 'REGISTRA O VALOR DOS LIMITES EXECUTADOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.02.03', 'SOLICITACAO AO EXTERIOR SEM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO MINISTERIO DA MARINHA, PARA SOLICITACOES AOEXTERIOR NO EXERCICIO, QUE AINDA NAO FORAM EMPENHADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.02.04', 'SOLICITACAO AO EXTERIOR COM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO MINISTERIO DA MARINHA, PARA SOLICITACOES AOEXTERIOR NO EXERCICIO, QUE ESTAO EMPENHADAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.02.05', 'SOLICITACAO AO EXTERIOR - RALIZADA', 'REGISTRA O VALOR DOS LIMITES EXECUTADOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.02.07', 'PEDIDO DE OBTENCAO SEM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO COMANDO DA MARINHA, PARA PEDIDOS DE OBTENCAO, NOEXERCICIO, QUE AINDA NAO FORAM EMPENHADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.02.08', 'PEDIDO DE OBTENCAO COM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO COMANDO DA MARINHA, PARA PEDIDOS DE OBTENCAO, NOEXERCICIO, QUE ESTAO EMPENHADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.02.09', 'PEDIDO DE OBTENCAO REALIZADO', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO COMANDO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.03.01', 'COMPROMISSADOS', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO MINISTERIO DA MARINHA NO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.03.02', 'EXECUTADOS', 'REGISTRA O VALOR DOS LIMITES EXECUTADOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO MINISTERIO DA MARINHA RELATIVO AO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.03.03', 'CANCELADOS', 'REGISTRA O VALOR DOS LIMITES CANCELADOS RELATIVOS A VALORES COMPROMISSADOS REFERENTE A EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DA MARINHA DO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.03.04', 'SOLICITACAO AO EXTERIOR SEM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO MINISTERIO DA MARINHA NO EXERCICIO ANTERIOR,PARA SOLICITACOES AO EXTERIOR QUE AINDA NAO FORAM EMPENHADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.03.05', 'SOLICITACOES AO EXTERIOR COM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO MINISTERIO DA MARINHA NO EXERCICIO ANTERIOR PARASOLICITACOES AO EXTERIOR, QUE ESTAO EMPENHADAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.03.06', 'SOLICITACAO AO EXTERIOR - REALIZADA', 'REGISTRA O VALOR DOS LIMITES EXECUTADOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO MINISTERIO DA MARINHA RELATIVO AO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.03.07', 'PEDIDO DE OBTENCAO S/EMPENHO - EXERC.ANTERI', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO COMANDO DA MARINHA, NO EXERCICIO ANTERIOR ,PARAPEDIDOS DE OBTENCAO QUE AINDA NAO FORAM EMPENHADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.03.08', 'PEDIDO DE OBTENCAO C/EMPENHO - EXERC.ANTERI', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO COMANDO DA MARINHA, NO EXERCICIO ANTERIOR ,PARAPEDIDOS DE OBTENCAO QUE ESTAO EMPENHADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.03.09', 'PEDIDO DE OBTENCAO REALIZADO - EXERC.ANTERI', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO COMANDO DA MARINHA, RELATIVO AO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.04.01', 'SOLICITACAO AO EXTERIOR SEM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMISSADOS NO EXTERIOR RELATIVO AEXERCICIOS ANTERIORES, DE SOLICITACOES AO EXTERIOR, QUE AINDA NAOFORAM EMPENHADOS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.04.02', 'SOLICITACAO AO EXTERIOR REALIZADA', 'REGISTRA O VALOR DOS LIMITES EXECUTADOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO MINISTERIO DA MARINHA RELATIVO A EXERCICIOSANTERIORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.04.03', 'CANCELADOS', 'REGISTRA O VALOR DOS LIMITES CANCELADOS RELATIVOS A VALORES COMPROMISSADOS REFERENTE A EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DA MARINHA DE EXERCICIOS ANTERIORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.04.04', 'SOLICITACAO AO EXTERIOR COM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMISSADOS NO EXTERIOR RELATIVO AEXERCICIOS ANTERIORES, DE SOLICITACOES AO EXTERIOR, QUE ESTAOEMPENHADOS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.01.01', 'A RECEBER', 'REGISTRA O VALOR DOS LIMITES AUTORIZADOS A RECEBER NA EXECUCAO FISICADO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.01.02', 'RECEBIDOS', 'REGISTRA O VALOR DOS LIMITES AUTORIZADOS RECEBIDOS NA EXECUCAO FISICADO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.01.03', 'RECEBIDOS NO EXERCICIO ANTERIOR', 'REGISTRA A DISPONIBILIZACAO DE CREDITO ESCRITURAL DE SOLICITACAO AOEXTERIOR SUPERESTIMADA NO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.01.04', 'RECEBIDOS EM EXERCICIOS ANTERIORES', 'REGISTRA A DISPONIBILICAZAO DE CREDITO ESCRITURAL DE SOLICITACOES AOEXTERIOR SUPERESTIMADAS DE EXERCICIOS ANTERIORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.01.05', 'RECEBIDOS DECORRENTE DA DOTACAO DO P.A.I', 'REGISTRA O VALOR DOS LIMITES RECEBIDOS REFERENTE A DOTACAO DO PLANODE ACAO INICIAL REFERENTE A EXECUCAO FISICA DO PLANO INTERNO ESCRITURAL DO COMANDO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.01.06', 'RECEBIDOS CNE', 'REGISTRA O VALOR DOS LIMITES AUTORIZADOS RECEBIDOS NA EXECUCAO FISICADO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA QUE SERAO EXECUTADOS NO EXTERIOR PELAS CNE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.01.07', 'RECEBIDOS CNE - EXERCICIO ANTERIOR', 'REGISTRA O VALOR DOS LIMITES AUTORIZADOS RECEBIDOS NO ANO ANTERIOR NAEXECUCAO FISICA DO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHAQUE SERAO EXECUTADOS NO EXTERIOR PELAS CNE.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.02.01', 'COMPROMISSADOS', 'REGISTRA O VALOR DOS LIMITES COMPROMISSADOS NO EXERCICIO NA EXECUCAODO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.02.02', 'EXECUTADOS', 'REGISTRA O VALOR DOS LIMITES EXECUTADOS NO EXERCICIO NA EXECUCAODO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.02.03', 'SOLICITACAO AO EXTERIOR SEM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMISSADOS NO EXERCICIO NA EXECUCAODO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA,PARA SOLICITACOESAO EXTERIOR DE EXERCICIOS ANTERIORES, QUE AINDA NAO FORAM EMPENHADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.02.04', 'SOLICITACAO AO EXTERIOR COM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMISSADOS NA EXECUCAO DO PLANOINTERNO ESCRITURAL DO MINISTERIO DA MARINHA, PARA SOLICITACOES AOEXTERIOR DE EXERCICIOS ANTERIORES, QUE ESTAO EMPENHADAS NO EXTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.02.05', 'SOLICITACAO AO EXTERIOR REALIZADA', 'REGISTRA O VALOR DOS LIMITES EXECUTADOS NO EXERCICIO NA EXECUCAO DOPLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.02.06', 'LIQUIDADOS', 'REGISTRA O VALOR DOS LIMITES LIQUIDADOS NO EXERCICIO NA EXECUCAO DOPLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.02.07', 'PEDIDO DE OBTENCAO SEM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS, NO EXERCICIO, NA EXECUCAOFISICA DO PLANO INTERNO ESCRITURAL DO COMANDO DA MARINHA, PARA PEDIDOSDE OBTENCAO QUE AINDA NAO FORAM EMPENHADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.02.08', 'PEDIDO DE OBTENCAO COM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS, NA EXECUCAO FISICA DO PLANO INTERNO ESCRITURAL DO COMANDO DA MARINHA, PARA PEDIDOS DE OBTENCAOQUE ESTAO EMPENHADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.02.09', 'CONCLUSAO DE PEDIDO DE OBTENCAO NO EXERCICI', 'REGISTRA O VALOR DOS LIMITES EXECUTADOS NO EXERCICIO NA EXECUCAO FISICA DO PLANO INTERNO ESCRITURAL DO COMANDO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.03.01', 'COMPROMISSADOS', 'REGISTRA O VALOR DOS LIMITES COMPROMISSADOS NO EXERCICIO ANTERIOR RELATIVO A EXECUCAO DO PLANO INTERNO DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.03.02', 'EXECUTADOS', 'REGISTRA O VALOR DOS LIMITES EXECUTADOS NA EXECUTACAO FISICA DO PLANOINTERNO DO MINISTERIO DA MARINHA, RELATIVO AO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.03.03', 'CANCELADOS', 'REGISTRA O VALOR DOS LIMITES CANCELADOS RELATIVOS A VALORES COMPROMISSADOS REFERENTE A EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DA MARINHA DE EXERCICIOS ANTERIORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.03.04', 'SOLICITACAO AO EXTERIOR SEM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMISSADOS NO EXERCICIO ANTERIORRELATIVO A EXECUCAO DO PLANO INTERNO DO MINISTERIO DA MARINHA, PARASOLICITACOES AO EXTERIOR QUE AINDA NAO FORAM EMPENHADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.03.05', 'SOLICITACAO AO EXTERIOR COM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMISSADOS NO EXERCICIO ANTERIORRELATIVO A EXECUCAO DO PLANO INTERNO DO MINISTERIO DA MARINHA, PARASOLICITACOES AO EXTERIOR QUE ESTAO EMPENHADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.03.06', 'SOLICITACAO AO EXTERIOR REALIZADA', 'REGISTRA O VALOR DOS LIMITES EXECUTADOS NA EXECUCAO FISICA DO PLANOINTERNO DO MINISTERIO DA MARINHA, RELATIVO AO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.03.07', 'LIQUIDADOS', 'REGISTRA O VALOR DOS LIMITES LIQUIDADOS NO EXERCICIO ANTERIOR NA EXECUCAO DO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.03.08', 'PEDIDO DE OBTENCAO S/EMPENHO - EXERC.ANTERI', 'REGISTRA O VALOR DOS LIMITES COMPROMETIDOS NO EXERCICIO ANTERIOR RELATIVO A EXECUCAO DO PLANO INTERNO ESCRITURAL DO COMANDO DA MARINHA, PARA PEDIDOS DE OBTENCAO QUE AINDA NAO FORAM EMPENHADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.03.09', 'PEDIDO DE OBTENCAO C/EMPENHO - EXERC.ANTERI', 'REGISTRA O VALOR DOS LIMITES COMPROMISSADOS NO EXERCICIO ANTERIOR RELATIVO A EXECUCAO DO PLANO INTERNO ESCRITURAL DO COMANDO DA MARINHA,PARA PEDIDOS DE OBTENCAO QUE ESTAO EMPENHADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.03.10', 'PEDIDO DE OBTENCAO REALIZADO - EXERC.ANTERI', 'REGISTRA O VALOR DOS LIMITES EXECUTADOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO COMANDO DA MARINHA, RELATIVO AO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.03.11', 'PEDIDO DE OBTENCAO CANCELADO', 'REGISTRA O VALOR DOS LIMITES CANCELADOS RELATIVOS A VALORES COMPROMISSADOS REFERENTE A EXECUCAO FISICA DO PLANO INTERNO ESCRITURAL DO COMANDO DA MARINHA, RELATIVO AO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.01', 'CONTRATADOS A REALIZAR', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS CONTRATADOS A REALIZAR NANA EXECUCAO DO PLANO INTERNO DO MINISTERIO DA MARINHA NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.02', 'COBRADOS A LIQUIDAR', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS COBRADOS A LIQUIDAR NANA EXECUCAO DO PLANO INTERNO DO MINISTERIO DA MARINHA NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.03', 'SOLICITACAO AO EXTERIOR A REALIZAR SEM EMPE', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS SOLICITADOS AO EXTERIOR AREALIZAR NA EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DA MARINHANO EXERCICIO, PARA SOLICITACOES AO EXTERIOR QUE AINDA NAO FORAMEMPENHADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.04', 'CONTRATADOS - REALIZADOS', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS CONTRATRADOS REALIZADOS NANA EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DA MARINHANO EXERCICIO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.05', 'COBRADOS-LIQUIDADOS', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS COBRADOS LIQUIDADOSNA EXECUCAO DO PLANO INTERNO DO MINISTERIO DA MARINHA NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.06', 'SOLICITACAO AO EXTERIOR A REALIZAR COM EMPE', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS SOLICITADOS AO EXTERIOR AREALIZAR NA EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DAMARINHA NO EXERCICIO, PARA SOLICITACOES AO EXTERIOR QUE ESTAOEMPENHADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.07', 'REQUISICAO DE MATERIAL DO EXERC. A REALIZAR', 'REGISTRA A REQUISICAO DE MATERIAL DO EXERCICIO A REALIZAR NA EXECUCAOFISICA DO PLANO INTERNO DO MINISTERIO DA MARINHA NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.08', 'REQUISICAO DE MATERIAL DO EXERC. REALIZADAS', 'REGISTRA A REQUISICAO DE MATERIAL DO EXERCICIO REALIZADAS NA EXECUCAOFISICA DO PLANO INTERNO DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.09', 'ORDEM DE COMPRA DO EXERCICIO A REALIZAR', 'REGISTRA A ORDEM DE COMPRA DO EXERCICIO A REALIZAR NA EXECUCAO DO PLANO INTERNO DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.10', 'ORDEM DE COMPRA DO EXERCICIO REALIZADA', 'REGISTRA A ORDEM DE COMPRA DO EXERCICIO REALIZADAS NA EXECUCAO FISICADO PLANO INTERNO DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.11', 'SOLICITACAO AO EXTERIOR - REALIZADOS', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS SOLICITADOS AO EXTERIORREALIZADOS NA EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DADA MARINHA NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.12', 'ORDEM DE COMPRA DO EXERCICIO LIQUIDADAS', 'REGISTRA A ORDEM DE COMPRA DO EXERCICIO LIQUIDADA NA EXECUCAO DO PLANOINTERNO DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.13', 'PEDIDO DE OBTENCAO A REALIZAR SEM EMPENHO', 'REGISTRA O FORNECIMENTO DE BENS SOLICITADOS A REALIZAR NA EXECUCAO FISICA DO PLANO INTERNO DO COMANDO DA MARINHA NO EXERCICIO, PARA PEDIDOSDE OBTENCAO QUE AINDA NAO FORAM EMPENHADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.14', 'PEDIDO DE OBTENCAO A REALIZAR COM EMPENHO', 'REGISTRA O FORNECIMENTO DE BENS SOLICITADOS A REALIZAR NA EXECUCAO FISICA DO PLANO INTERNO ESCRITURAL DO COMANDO DA MARINHA NO EXERCICIO,PARA PEDIDOS DE OBTENCAO QUE ESTAO EMPENHADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.15', 'PEDIDO DE OBTENCAO REALIZADO', 'REGISTRA O FORNECIMENTO DE BENS REALIZADOS NA EXECUCAO FISICA DO PLANOINTERNO ESCRITURAL DO COMANDO DA MARINHA NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.01', 'CONTRATADOS A REALIZAR', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS CONTRATADOS A REALIZAR NANA EXECUCAO DO PLANO INTERNO DO MINISTERIO DA MARINHA EM EXERCICIOSANTERIORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.02', 'COBRADOS A LIQUIDAR', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS COBRADOS A LIQUIDAR NANA EXECUCAO DO PLANO INTERNO DO MINISTERIO DA MARINHA EM EXERCICIOSANTERIORES', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.03', 'SOLICITACAO AO EXTERIOR A REALIZAR SEM EMPE', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS SOLICITADOS AO EXTERIOR AREALIZAR NA EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DA MARINHARELATIVO AO EXERCICIO ANTERIOR, PARA SOLICITACOES AO EXTERIOR QUE AINDA NAO FORAM EMPENHADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.04', 'CONTRATADOS - REALIZADOS', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS CONTRATRADOS REALIZADOS NANA EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DA MARINHAEM EXERCICIOS ANTERIORES', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.05', 'COBRADOS - LIQUIDADOS', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS COBRADOS LIQUIDADOSNA EXECUCAO DO PLANO INTERNO DO MINISTERIO DA MARINHA EM EXERCICIOSANTERIORES', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.06', 'SOLICITACAO AO EXTERIOR A REALIZAR C/ EMPEN', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS SOLICITADOS AO EXTERIOR AREALIZAR NA EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DA MARINHARELATIVO AO EXERCICIO ANTERIOR, PARA SOLICITACOES AO EXTERIOR QUE FORAM EMPENHADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.07', 'CANCELADOS', 'REGISTRA O VALOR DOS LIMITES CANCELADOS RELATIVOS A VALORES COMPROMISSADOS REFERENTE A EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DA MARINHA NO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.08', 'REQUISICAO DE MAT. DO EXERC. ANT. A REALIZA', 'REGISTRA A REQUISICAO DE MATERIAL DO EXERC. ANT.A REALIZAR NA EXECUCAOFISICA DO PLANO INTERNO DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.09', 'REQUISICAO DE MAT. DO EXERC. ANT. REALIZADA', 'REGISTRA A REQUISICAO DE MATERIAL DO EXERC.ANT. REALIZADAS NA EXECUCAOFISICA DO PLANO INTERNO DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.10', 'ORDEM DE COMPRA DO EXERCICIO ANT. A REALIZ', 'REGISTRA A ORDEM DE COMPRA DO EXERC. ANTERIOR A REALIZAR NA EXECUCAODO PLANO INTERNO DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.11', 'ORDEM DE COMPRA DO EXERCICIO ANT. REALIZADA', 'REGISTRA A ORDEM DE COMPRA DO EXERCICIO ANTERIOR REALIZADAS NA EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.12', 'SOLICITACAO AO EXTERIOR - REALIZADOS', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS SOLICITADOS AO EXTERIORREALIZADOS NA EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DAMARINHA RELATIVO AO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.13', 'ORDEM DE COMPRA EXERCICIO ANTERIOR LIQUIDAD', 'REGISTRA A ORDEM DE COMPRA DO EXERCICIO LIQUIDADAS NA EXECUCAO DO PLANO INTERNO DO MINISTERIO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.14', 'CANCELADOS SEM EMPENHO', 'REGISTRA O VALOR DOS LIMITES CANCELADOS RELATIVOS A VALORES COMPROMISSADOS REFERENTE A EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DAMARINHA NO EXERCICIO ANTERIOR, SEM EMPENHO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.15', 'PEDIDO OBTENCAO A REAL.SEM EMPENHO - EXERCI', 'REGISTRA O FORNECIMENTO DE BENS SOLICITADOS A REALIZAR NA EXECUCAOFISICA DO PLANO INTERNO ESCRITURAL DO COMANDO DA MARINHA, RELATIVO AOEXERCICIO ANTERIOR, PARA PEDIDOS DE OBTENCAO QUE AINDA NAO FORAM EMPE NHADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.16', 'PEDIDO OBTENCAO A REAL.C/EMPENHO-EXERC.ANTE', 'REGISTRA O FORNECIMENTO DE BENS SOLICITADOS A REALIZAR EXECUCAO FISICADO PLANO INTERNO ESCRITURAL DO COMANDO DA MARINHA, RELATIVO AO EXERCICIO ANTERIOR, PARA PEDIDOS DE OBTENCAO QUE FORAM EMPENHADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.17', 'PEDIDO DE OBTENCAO REAL.- DO EXERC.ANTERIOR', 'REGISTRA O FORNECIMENTO DE BENS SOLICITADOS, REALIZADOS NA EXECUCAOFISICA DO PLANO INTERNO ESCRITURAL DO COMANDO DA MARINHA, RELATIVO AOEXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.18', 'PEDIDO OBTENCAO CANCELADO S/EMPENHO-EX.ANTE', 'REGISTRA O VALOR DOS LIMITES CANCELADOS RELATIVOS A PEDIDOS DE OBTENCAO QUE NAO TINHAM EMPENHO, NA EXECUCAO FISICA DO PLANO INTERNO ESCRITURAL DO COMANDO DA MARINHA DO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.19', 'PEDIDO OBTENCAO CANCELADO C/EMPENHO-EX.ANTE', 'REGISTRA O VALOR DOS LIMITES CANCELADOS RELATIVOS A PEDIDOS DE OBTENCAO QUE TINHAM SIDO EMPENHADOS NA EXECUCAO FISICA DO PLANO INTERNO ESCRITURAL DO COMANDO DA MARINHA DO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.06.01', 'SOLICITACAO AO EXTERIOR SEM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMISSADOS NO EXTERIOR RELATIVO AEXERCICIOS ANTERIORES DO PLANO INTERNO DO MINISTERIO DA MARINHA, PARASOLICITACOES AO EXTERIOR QUE AINDA NAO FORAM EMPENHADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.06.02', 'SOLICITACAO AO EXTERIOR REALIZADA', 'REGISTRA O VALOR DOS LIMITES EXECUTADOS NO EXTERIOR RELATIVO AEXERCICIOS ANTERIORES DA EXECUCAO FISICA DO PLANO INTERNO DA MARINHA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.06.03', 'CANCELADOS', 'REGISTRA O VALOR DOS LIMITES CANCELADOS RELATIVOS A VALORES COMPROMISSADOS REFERENTE A EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DA MARINHA DE EXERCICIOS ANTERIORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.06.04', 'SOLICITACAO AO EXTERIOR COM EMPENHO', 'REGISTRA O VALOR DOS LIMITES COMPROMISSADOS NO EXTERIOR RELATIVO AEXERCICIOS ANTERIORES DO PLANO INTERNO DO MINISTERIO DA MARINHA, PARASOLICITACOES AO EXTERIOR QUE ESTAO EMPENHADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.07.01', 'SOLICITACAO AO EXTERIOR A REALIZAR SEM EMPE', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS SOLICITADOS AO EXTERIOR AREALIZAR NA EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DA MARINHARELATIVO A EXERCICIOS ANTERIORES, PARA SOLICITACOES AO EXTERIOR QUE AINDA NAO FORAM EMPENHADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.07.02', 'SOLICITACAO AO EXTERIOR REALIZADA', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS SOLICITADOS AO EXTERIORREALIZADOS NA EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DAMARINHA RELATIVO A EXERCICIOS ANTERIORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.07.03', 'CANCELADOS', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS SOLICITADOS AO EXTERIOR REALIZADOS NA EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DA MARINHARELATIVO A EXERCICIOS ANTERIORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.07.04', 'SOLICITACAO AO EXTERIOR A REALIZAR C/ EMPEN', 'REGISTRA O FORNECIMENTO DE BENS E SERVICOS SOLICITADOS AO EXTERIOR AREALIZAR NA EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DA MARINHARELATIVO A EXERCICIOS ANTERIORES, PARA SOLICITACOES AO EXTERIOR QUE ESTAO EMPENHADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.01.00', 'CONTROLE DE RESTITUICAO DE CONTRIBUICOES', 'REGISTRA OS VALORES DESEMBOLSADOS A TITULO DE RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS RECOLHIDAS A MAIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.02.00', 'CONTROLE INADIMPLENCIA EMPREST/FINANCIAMENT', 'REGISTRA OS VALORES REFERENTES AOS CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS QUE SE ENCONTRAM NA SITUACAO DE INADIMPLENTES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.03.00', 'CONTROLE DE PASSIVOS EM PROCESSO DE ASSUNCA', 'REGISTRA OS VALORES RELATIVOS A PASSIVOS EM PROCESSO DE ASSUNCAO PELA UNIAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.04.01', 'CONTROLE DE PRECATORIOS PAGOS - EXERCICIO', 'REGISTRA OS VALORES RELATIVOS AS DESPESAS COM OS PRECATORIOS PAGOS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.04.02', 'CONTROLE PRECATORIOS PAGOS - EXERCICIOS ANT', 'REGISTRA OS VALORES RELATIVOS AS DESPESAS COM OS PRECATORIOS PAGOS NOS EXERCICIOS ANTERIORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.05.00', 'CONTROLE DOCUMENTOS PENDENTES DE RECEBIMENTO', 'REGISTRA OS VALORES RELATIVOS AOS DOCUMENTOS PENDENTES DE RECEBIMENTO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.06.01', 'TITULOS DIVIDA EXTERNA - EMITIDOS', 'REGISTRA OS VALORES RELATIVOS A TITULOS DA DIVIDA EXTERNA EMITIDOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.06.02', 'TITULOS DIVIDA EXTERNA - AMORTIZADOS', 'REGISTRA OS VALORES RELATIVOS A TITULOS DA DIVIDA EXTERNA AMORTIZADOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.06.03', 'TITULOS DIVIDA EXTERNA - JUROS APROPRIADOS', 'REGISTRA A APROPRIACAO DOS JUROS REFERENTES EMISSAO DE TITULOS DA DIVIDA PUBLICA MOBILIARIA EXTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.06.04', 'TITULOS DIVIDA EXTERNA - ENCARGOS APROPRIAD', 'REGISTRA A APROPRIACAO DOS ENCARGOS REFERENTES EMISSAO DE TITULOS DADA PUBLICA MOBILIARIA EXTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.06.05', 'TITULOS DIVIDA EXTERNA - JUROS PAGOS', 'REGISTRA O PAGAMENTO DOS JUROS REFERENTE EMISSAO DE TITULOS DA DIVIDA PUBLICA MOBILIARIA EXTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.06.06', 'TITULOS DIVIDA EXTERNA - ENCARGOS PAGOS', 'REGISTRA O PAGAMENTO DOS ENCARGOS REFERENTE EMISSAO DE TITULOS DA DIVIDA PUBLICA MOBILIARIA EXTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.06.07', 'TITULOS DA DIVIDA EXTERNA - CANCELAMENTO', 'REGISTRA O VALOR DO CANCELAMENTO REFERENTE A EMISSAO DE TITULOS DA DIVIDA PUBLICA MOBILIARIA EXTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.06.08', 'TIT.DIV.EXT.-RECOMPR.A BAIXAR-PRINCIPAL', 'REGISTRA OS VALORES DO PRINCIPAL DE TITULOS DA DIVIDA EXTERNA RECOMPRADOS E PENDENTES DE BAIXA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.06.09', 'TIT.DIV.EXT.-RECOMPR. BAIXADOS-PRINCIPAL', 'REGISTRA O VALOR PRINCIPAL DE TITULOS DA DIVIDA PUBLICA MOBILIARIA EXTERNA RECOMPRADOS E BAIXADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.06.10', 'TIT.DIV.EXT.-RECOMPR.A BAIXAR-JUROS E ENCAR', 'REGISTRA OS VALORES DOS JUROS E ENCARGOS DOS TITULOS DE DIVIDA EXTERNA RECOMPRADOS A BAIXAR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.06.11', 'TIT.DIV.EXT.-RECOMPR.BAIXADOS-JUROS E ENCAR', 'REGISTRA O VALOR DOS JUROS E ENCARGOS DE TITULOS DA DIVIDA PUBLICA EXTERNA RECOMPRADOS PELO TESOURO NACIONAL E BAIXADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.07.00', 'CONTROLE DE BENEFICIARIO - AUXILIO MORADIA', 'REGISTRA OS VALORES A TITULO DE DESPESAS COM MORADIA, CONFORME DETERMINACAO TCU 1690/2002, DE 04/12/2002.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.08.01', 'CONTROLE DE ARRECADACAO DE RECEITAS - DEP.C', 'REGISTRA OS VALORES REFERENTES AS RECEITAS DIRETAMENTE ARRECADADAS POR DEPOSITO DIRETO NA CONTA UNICA, COM CONTROLE DA CLASSIFICACAO INSTITUCIONAL DA RECEITA ARRECADADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.08.02', 'CONTROLE DE ARRECADACAO DE RECEITAS - GRU', 'REGISTRA OS VALORES REFERENTES AS RECEITAS DIRETAMENTE ARRECADADASATRAVES DO ARQUIVO DA GRU, COM CONTROLE DA CLASSIFICACAO INSTITUCIONAL DA RECEITA ARRECADADA.ESTA CONTA DEMONSTRA, NA ROTINA DE ARRECADACAO DE GRU, QUE UMA UNIDADEARRECADOU A RECEITA, POREM ESSA RECEITA FOI TRANSFERIDA PARA OUTR UNIDADE. ESTA CONTA EH O CONTROLE NA UNIDADE QUE ARRECADOU DE QUANTO ELA ARRECADOU E FOI TRANSFERIDO PARA OUTREM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.08.03', 'CONTROLE DE ARRECADACAO DE RECEITAS UG EXT.', 'REGISTRA OS VALORES REFERENTES AS RECEITAS DIRETAMENTE ARRECADADAS POR DEPOSITO DIRETO NA CONTA UNICA, COM CONTROLE DA CLASSIFICACAO INSTITUCIONAL DA RECEITA ARRECADADA, PARA ATENDER ROTINA DE VARIACAO CAMBIAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.08.04', 'CONTROLE DE ARRECADACAO DE RECEITAS (C/C 37)', 'REGISTRA O ESPELHO DA CONTA DE RECEITA, REGISTRADAS NAS UG ARRECADADORAS, COM CONTROLE POR NATUREZA DE RECEITA + FONTE + UO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.09.00', 'CONTROLE DE VALORES A RECEBER - FCVS', 'REGISTRA OS VALORES RELATIVOS A DIVIDAS DE FINANCIAMENTO DO FCVS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.10.01', 'EMPRESTIMOS E FINANCIAMENTOS EM CONTRATACAO', 'REGISTRA A APROPRIACAO DE VALORES REPASSADOS A AGENTES FINANCEIROSPARA A CONTRATACAO DE EMPRESTIMOS E FINANCIAMENTOS CUJAS OPERACOES COM O PUBLICO ALVO EFETIVAMENTE NAO SE REALIZARAM', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.10.02', 'EMPRESTIMOS E FINANCIAMENTOS CONTRATADOS', 'REGISTRA A APROPRIACAO DE VALORES REPASSADOS A AGENTES FINANCEIROSPARA A CONTRATACAO DE EMPRESTIMOS E FINANCIAMENTOS CUJAS OPERACOES COM O PUBLICO ALVO EFETIVAMENTE SE REALIZARAM', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.10.03', 'EMPRESTIMOS E FINANCIAMENTOS AMORTIZADOS', 'REGISTRA A AMORTIZACAO DE VALORES QUE FORAM REPASSADOS A AGENTES FINANCEIROS REFERENTES A CONTRATACAO DE EMPRESTIMOS E FINANCIAMENTOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.11.01', 'SAQUE - CARTAO DE PAGAMENTO GOV. FEDERAL', 'REGISTRA OS VALORES REFERENTES AOS PAGAMENTOS EFETUADOS ATRAVES DESAQUE COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.11.02', 'FATURA - CARTAO DE PAGAMENTO DO GOV. FEDERA', 'REGISTRA OS VALORES REFERENTES AOS PAGAMENTOS EFETUADOS ATRAVES DEFATURA COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.11.03', 'SUPRIMENTO DE FUNDOS - CONTA TIPO "B" E OUT', 'REGISTRA OS VALORES REFERENTES AOS PAGAMENTOS EFETUADOS A TITULO DESUPRIMENTO DE FUNDOS POR MEIO DE CONTA CORRENTE BANCARIA E DE OUTRASMODALIDADES QUE NAO SEJAM O CARTAO DE PAGAMENTOS DO GOVERNO FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.11.04', 'DEVOLUCAO DE SAQUE - CPGF', 'REGISTRA OS VALORES REFERENTES AS DEVOLUCOES DE RECURSOS SACADOS E NAOUTILIZADOS COM O USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.11.05', 'DEVOLUCAO DE VALORES DE FATURA DO CPGF', 'REGISTRA OS VALORES REFERENTES AS DEVOLUCOES DE RECURSOS UTILIZADOSPARA PAGAMENTO DE FATURAS DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.11.06', 'DEVOLUCAO DE VALORES NAO UTILIZADOS-CTA "B"', 'REGISTRA OS VALORES REFERENTES AOS PAGAMENTOS DE SUPRIMENTO DE FUNDOSCREDITADOS NA CONTA TIPO "B".', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.12.01', 'ORDENS BANCARIAS TV EMITIDAS A COMPENSAR', 'REGISTRA OS VALORES RELATIVOS AS ORDENS BANCARIAS EMITIDAS NAS TRANSFERENCIAS VOLUNTARIAS, EM TRANSITO OU A COMPENSAR PELO AGENTE FINANCEIRO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.12.02', 'PAGAMENTOS OB-TV EFETUADOS', 'REGISTRA O VALOR DOS PAGAMENTOS EFETUADOS PELAS UNIDADES GESTORAS COMBASE NO LIMITE DE SAQUE DA CONTA DE TRANSFERENCIA VOLUNTARIA MANTIDAJUNTO AOS BANCOS OFICIAIS (BB, CEF. BASA, BNB).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.12.03', 'RECURSOS DE TRANSF.VOLUNTARIA APLICADOS', 'REGISTRA O VALOR DOS PAGAMENTOS EFETUADOS PELAS UNIDADES GESTORAS COMBASE NO LIMITE DE SAQUE DA CONTA DE TRANSFERENCIA VOLUNTARIA MANTIDA JUNTO AOS BANCOS OFICIAIS (BB, CEF. BASA, BNB).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.12.04', 'OBTV DE TRANSF.CTA TV PARA A CTU A COMPENSA', 'REGISTRA OS VALORES RELATIVOS AS OBTV EMITIDAS PARA DEVOLUCAO DE RECURSOS PARA A CONCEDENTE DE RECURSOS NAO APLICADOS NO OBJETO DA TRANSFERENCIA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.12.05', 'TRANSFERENCIA DA CONTA TV PARA CTU', 'REGISTRA OS VALORES RELATIVOS AS OBTV EMITIDAS PARA DEVOLUCAO DE RECURSOS PARA A CONCEDENTE DE RECURSOS NAO APLICADOS NO OBJETO DA TRANSFERENCIA, CONTROLE NA COFIN/STN UG 170500 PARA ACOMPANHAMENTO DA CONCILIACAO DA CTU', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.12.06', 'RECURSOS DE TRANSF. VOLUNTARIA - DISPONIVEL', 'REGISTRA, NA CONCEDENTE DA TRANSFERENCIA VOLUNTARIATV, OS INGRESSOS ESAIDAS DOS RECURSOS DA TV. A MOVIMENTACAO DOS RECURSOS DA CONTA BANCARIA SOMENTE OCORRERA VIA PORTAL SICONV. AS INSTITUICOES BANCARIAS OFICIAIS SAO BB, CEF, BASA E BNB.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.01', 'HON.DEFENSORES DATIVOS-ACOES PROC.ORDINARIO', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTO DE HONORARIOS DE DEFENSORES DATIVOS EM ACOES CUJOS ATOS PROCESSUAIS SEDESENVOLVEM POR MEIO DE PROCEDIMENTO COMUM, MAS SEGUNDO RITO ORDINARIO(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.02', 'HONORARIOS DEFENSORES DATIVOS-ACOES DIVERSA', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM ACOES CAUTELARES (CPC ARTS. 796A 889), AS ACOES CUJOS ATOS PROCESSUAIS SE DESENVOLVEM POR MEIO DE PROCEDIMENTOS ESPECIAIS (ART.890 A 1102C) E AS ACOES DE HABEAS DATAS,MANDATO DE INJUNCAO, ALEM DE OUTRAS NAO ELENCADAS NAS DEMAIS RUBRICAS.(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.03', 'HONORARIOS DEFENSORES DATIVOS-ACOES CRIMINA', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM ACOES PENAIS PUBLICAS E PRIVADAS QUE SEGUEM OS RITOS: ORDINARIO, SUMARIO, DOS CRIMES DE COMPETENCIADO JURI E DOS CRIMES CONTRA A HONRA PREVISTOS NO CODIGO DE PROCESSOPENAL, ALEM DE OUTROS PREVISTOS EM LEIS ESPECIAIS, COMO NA LEI Nº 9099/95 (LEI DOS JUIZADOS ESPECIAIS CRIMINAIS), NA LEI Nº 10409/02 (LEI DETOXICOS)(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.04', 'HONOR.DEFENSORES DATIVOS-MANDADO DE SEGURAN', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM ACOES CONSTITUCIONAIS POSTAS ADISPOSICAO DE TODA PESSOA FISICA OU JURIDICA, ORGAO COM CAPACIDADEPROCESSUAL, OU UNIVERSALIDADE RECONHECIDA POR LEI, P/ A PROTECAO DEDIREITO INDIVIDUAL OU COLETIVO, LIQUIDO E CERTO, NAO AMPARADO POR HABEAS CORPUS OU HABEAS DATA, LESADO OU AMEACADO DE LESAO, POR ATO DEAUTORIDADE, SEJA DE QUE CATEGORIA FOR E SEJAM QUAIS FOREM AS FUNCOESQUE EXERCAM.(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.05', 'HONORARIOS DEFENSORES DATIVOS-HABEAS CORPUS', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM ACOES CONSTITUCIONAIS DE CARACTER PENAL E DE PROCEDIMENTOS ESPECIAL, QUE VISA A EVITAR OU CESSAR VIOLENCIA OU AMEACA NA LIBERDADE DE LOCOMOCAO, POR ILEGALIDADE OU ABUSO DE PODER.(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS).', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.06', 'HONOR.DEFENSORES DATIVOS-EXECUCOES FISCAIS', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM ACOES DE EXECUCOES JUDICIAL PARA COBRANCA DA DIVIDA ATIVA DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERALDOS MUNICIPIOS E RESPECTIVAS AUTARQUIAS, DE NATUREZA TRIBUTARIA OU NAOTRIBUTARIA (LEI Nº 6.830/1980).(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.07', 'HONOR. DEFENSORES DATIVOS-EXECUCOES DIVERSA', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM ACOES DE EXECUCAO DE TITULOSJUDICIAIS OU EXTRAJUDICIAIS PREVISTAS NO CODIGO DE PROCESSO CIVIL. EX:EXECUCAO PARA ENTREGA DE COISA, DE OBRIGACAO DE FAZER OU NAO FAZER,PORQUANTIA CERTA, CONTRA DEVEDOR SOLVENTE E INSOLVENTE E A EXECUCAO DEPRESTACAO ALIMENTICIA.(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.08', 'HONOR.DEFENSORES DATIVOS-ACOES PROC.SUMARIO', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM ACOES CUJOS ATOS PROCESSUAIS SEDESENVOLVEM POR MEIO DE PROCEDIMENTO COMUM, MAS SEGUNDO O RITO SUMARIOO RITO SUMARIO EH APLICAVEL QUANDO NAO CABIVEL O RITO ORDINARIO OUQUALQUER PROCEDIMENTO ESPECIAL PREVISTO EM LEI.(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.09', 'HON.DEFENSORES DATIVOS-FEITO NAO CONTENCIOS', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS QUANDO ATUAREM NA JURISDICAO VOLUNTARIA, NA QUAL INEXISTE UM CONFLITO DE INTERESSES A SER DIRIMIDOPELO PODER JUDICIARIO, O QUAL AGE EM TAIS HIPOTESES COMO ADMINISTRADORPUBLICO DE INTERESSES PRIVADOS.(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.10', 'HON. DEFENSORES DATIVOS-PROCEDIMENTO CRIMIN', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS EM PROCEDIMENTOS TAIS COMO: PEDIDO DE BUSCA E APREENSAO CRIMINAL, PEDIDO DE LIBERDADE PROVISORIA COMOU SEM FIANCA, PEDIDO DE MEDIDAS ASSECURATORIAS, PEDIDO DE PRISAO/LIBERDADE VIGIADA PARA FINS DE EXPULSAO, PEDIDO DE PRISAO TEMPORARIA,PREVENTIVA. (EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.11', 'HON.DEFENSORES DATIVOS-PROCEDIMENTOS DIVERS', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS DE DEFENSORES DATIVOS NOS DEMAIS PROCEDIMENTOS NAO ENQUADRADOS EM CONTAS ESPECIFICAS.(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.12', 'HONORARIOS PERICIAIS - ENGENHARIA', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS PERICIAIS, QUANDO DA PRESTACAO DE SERVICOS QUE NECESSITEM CONHECIMENTOS DA ESPECIALIDADE DE ENGENHARIA. (EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.13', 'HONORARIOS PERICIAIS - OUTROS', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS PERICIAIS, QUANDO DA PRESTACAO DE SERVICOS PERICIAL QUENECESSITE DE CONHECIMENTOS ESPECIFICOS, EXCETO A ESPECIALIDAE DE ENGENHARIA QUE SERAH CONTROLADA NA CONTA " HONORARIOS PERICIAIS - ENGENHARIA".(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.14', 'HONOR.DE TRADUTORES E INTERPRETES - TRADUCA', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS HA TRADUTORES E INTERPRETES RELATIVOS A TRADUCOES, EXCETO QUANDO FEITA EM AUDIENCIAS QUE DEVERAH SER REGISTRADO NA CONTA CONTABIL "HON.TRAD.INTERPR.-INTERPRETACAO EM AUDIENCIA".(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.15', 'HON.TRAD.INTERPR.-INTERPRETACAO EM AUDIENCI', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS HA TRADUTORES E INTERPRETES RELATIVOS A INTERPRETACOESEM AUDIENCIAS, OS DEMAIS HONORARIOS COM TRADUCAO DEVERAO SER REGISTRA DOS NA CONTA CONTABIL " HONOR.DE TRADUTORES E INTERPRETES - TRADUCAO".(EXCETO QUANDO ATUACAO OCORRE NOS JUIZADOS ESPECIAIS FEDERAIS)', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.16', 'HON.AUX.JUIZADOS ESPECIAIS FED. - DEFENSORE', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS A DEFENSORES QUANDO ATUAREM NOS JUIZADOS ESPECIAIS FEDERAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.17', 'HON.AUXILIARES JUIZADOS ESPEC.FED.-PERITOS', 'REGISTRA OS VALORES REFERENTES A DESPESAS LIQUIDADAS PARA O PAGAMENTODE HONORARIOS A PERITOS QUANDO ATUAREM NOS JUIZADOS ESPECIAIS FEDERAIS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.14.00', 'CONTROLE DE PAGAMENTOS TCT', 'REGISTRA OS VALORES DE PAGAMENTOS EFETUADOS PELAS ENTIDADES TCT.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.15.00', 'CONTROLE DE ESTOQUES', 'REGISTRA OS VALORES FISICO DE ESTOQUES GOVERNAMENTAIS DA REDE ARMAZENADORA DO GOVERNO FEDERAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.16.00', 'CONTROLE DOS PAGAMENTOS POR CPI', 'REGISTRA O CONTROLE DOS PAGAMENTOS EFETUADOS POR CPI - COMISSAO PARLAMENTAR DE INQUERITO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.17.01', 'CONTROLE CREDITO EMPENHADO LIQUIDADO - EXER', 'REGISTRA OS VALORES REFERENTES A APROPRIACAO DAS DESPESAS EMPENHADASCOM POSTERIOR VERIFICACAO DE SUA REGULARIDADE POR CONSTITUICAO DODIREITO DO CREDOR, APROPRIADAS NO EXERCICIO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.17.02', 'CONTROLE CREDITO EMPENHADO LIQUIDADO - EX.A', 'REGISTRA OS VALORES REFERENTES A APROPRIACAO DAS DESPESAS EMPENHADASCOM POSTERIOR VERIFICACAO DE SUA REGULARIDADE POR CONSTITUICAO DODIREITO DO CREDOR, APROPRIADAS NO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.17.03', 'CONTROLE DE VALORES DA CONTA ESPECIAL P/ C', 'REGISTRA OS VALORES TRANSFERIDOS DA CONTA ESPECIAL PARA CONTA UNICA: SALDO DEVEDOR REPRESENTA OS VALORES QUE SAIRAM DA CONTA ESPECIAL EAINDA NAO INGRESSARAM NA CONTA UNICA ;SALDO CREDOR REPRESENTA OS VALORES QUE SAIRAM DA CONTA ESPECIAL E QUE JAH INGRESSARAM NA CONTA UNICA (FALTA CONCILIACAO CONTA ESPECIAL); SALDO ZERADO REPRESENTA QUE AS SAIDAS DA CONTA ESPECIAL E O CORRESPONDENTES INGRESSOS NA CONTA UNICA JA FORAM REGISTRADOS.', 'X', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.18.00', 'CONTROLE DE ESTOQUE EM PROCESSO DE AVALIACAO', 'REGISTRA OS VALORES DE PRODUTOS QUE ANTES DE SEREM APROPRIADOS DEVEM SER SUBMETIDOS A UM PROCESSO DE AVALIACAO/TESTES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.19.01', 'DIARIAS - MEMBRO DE PODER', 'REGISTRA A APROPRIACAO DO VALOR DE DIARIAS PAGAS AOS MEMBROS DE PODER.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.19.02', 'DIARIAS - SERVIDOR', 'REGISTRA A APROPRIACAO DO VALOR DE DIARIAS PAGAS AOS SERVIDORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.19.03', 'DIARIAS - A COLABORADORES EVENTUAIS', 'REGISTRA A APROPRIACAO DO VALOR DE DIARIAS E ADICIONAL DE DESLOCAMENTOPAGAS AOS COLABORADORES EVENTUAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.20.01', 'PASSAGENS - MEMBRO DE PODER', 'REGISTRA A APROPRIACAO DO VALOR DE DIARIAS E ADICIONAL DE DESLOCAMENTOAOS MEMBROS DES PODER.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.20.02', 'PASSAGENS - SERVIDOR', 'REGISTRA A APROPRIACAO DO VALOR DE DIARIAS E ADICIONAL DE DESOLOCAMENTO PAGAS A SERVIDORES.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.20.03', 'PASSAGENS - A COLABORADORES EVENTUAIS', 'REGISTRA A APROPRIACAO DO VALOR DE PASSAGENS PAGAS A COLABORADORES EVENTUAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.21.01', 'CONTROLE DE VALORES (NR.REFERENCIA DA GRU)', 'REGISTRA OS VALORES RELATIVOS AOS CONTROLES POR NUMERO DE REFERENCIADA GRU.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.21.02', 'CONTROLE VALORES (NR.REFERENCIA GRU)EXERC.A', 'REGISTRA OS VALORES RELATIVOS AOS CONTROLES POR NUMERO DE REFERENCIADA GRU DO EXERCICIO ANTERIOR.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.21.03', 'CONTROLE DE VALORES (NR.REFERENCIA GRU) COF', 'REGISTRA OS VALORES RELATIVOS AOS CONTROLES POR NUMERO DE REFERENCIADA GRU, ARRECADADOS PELA COFIS/STN.ESTA CONTA DEVE PASSAR SALDO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.22.01', 'TITULOS DA DIVIDA INTERNA - PRINCIPAL MERCA', 'REGISTRA A APROPRIACAO DO VALOR PRINCIPAL REFERENTE EMISSAO DE TITULOS DA DIVIDA PUBLICA MOBILIARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL - EM MERCADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.22.02', 'TIT. DA DIV.INTERNA-PRINCIPAL AMORT. MERCAD', 'REGISTRA A AMORTIZACAO DO VALOR PRINCIPAL REFERENTE ESTOQUE DE TITULOS DA DIVIDA PUBLICA MOBILIARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL - EM MERCADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.22.03', 'TIT. DA DIV.INTERNA -JUROS E ENCARGOS MERCA', 'REGISTRA A APROPRIACAO DOS JUROS E ENCARGOS REFERENTES EMISSAO DE TITULOS DA DIVIDA PUBLICA MOBILIARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL EM MERCADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.22.04', 'TIT.DA DIV.INTERNA-JUROS/ENCARGOS PAGOS_MER', 'REGISTRA O PAGAMENTO DOS JUROS E ENCARGOS INCIDENTES SOBRE A EMISSAO DE TITULOS DA DIVIDA PUBLICA MOBILIARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL EM MERCADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.22.06', 'TITULOS DA DIVIDA INTERNA - PRINCIPAL BACEN', 'REGISTRA A APROPRIACAO DO VALOR PRINCIPAL REFERENTE EMISSAO DE TITULOS DA DIVIDA PUBLICA MOBILIARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL - EM BACEN.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.22.07', 'TIT. DA DIV.INTERNA-PRINCIPAL AMORT. BACEN', 'REGISTRA A AMORTIZACAO DO VALOR PRINCIPAL REFERENTE ESTOQUE DE TITULOS DA DIVIDA PUBLICA MOBILIARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL - EM CARTEIRA DO BACEN.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.22.08', 'TIT. DA DIV.INTERNA -JUROS E ENCARGOS BACEN', 'REGISTRA A APROPRIACAO DOS JUROS E ENCARGOS REFERENTES EMISSAO DE TITULOS DA DIVIDA PUBLICA MOBILIARIA INTERNA DE RESPONSABILIDADE DO TESOURO CIONAL EM CARTEIRA DO BACEN.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.22.09', 'TIT.DA DIV.INTERNA-JUROS/ENCARGOS PAGOS_BAC', 'REGISTRA O PAGAMENTO DOS JUROS E ENCARGOS INCIDENTES SOBRE A EMISSAO DE TITULOS DA DIVIDA PUBLICA MOBILIARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL EM CARTEIRA DO BACEN.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.22.10', 'TIT. DA DIVIDA INTERNA-CANCELAMENTO BACEN', 'REGISTRA O VALOR DO CANCELAMENTO REFERENTE A EMISSAO DE TITULOS DA DIVIDA PUBLICA MOBILIARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL EM CARTEIRA DO BACEN.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.23.01', 'TDA - PRINCIPAL APROPRIADO', 'REGISTRA A APROPRIACAO DO VALOR PRINCIPAL REFERENTE EMISSAO DE TITULOS DA DIVIDA PUBLICA AGRARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.23.02', 'TDA - PRINCIPAL AMORTIZADO', 'REGISTRA A AMORTIZACAO DO VALOR PRINCIPAL REFERENTE EMISSAO DE TITULOS DA DIVIDA PUBLICA AGRARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.23.03', 'TDA - JUROS E ENCARGOS', 'REGISTRA A APROPRIACAO DOS JUROS E ENCARGOS REFERENTES EMISSAO DE TITULOS DA DIVIDA PUBLICA AGRARIA INTERNA DE RESPONSABILIDADE DO TESOURONACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.23.04', 'TDA - JUROS E ENCARGOS PAGOS', 'REGISTRA O PAGAMENTO DOS JUROS E ENCARGOS INCIDENTES SOBRE A EMISSAO DE TITULOS DA DIVIDA PUBLICA AGRARIA INTERNA DE RESPONSABILIDADE DOTESOURO NACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.23.05', 'TDA - CANCELAMENTO', 'REGISTRA O VALOR DO CANCELAMENTO REFERENTE A EMISSAO DE TITULOS DA DIVIDA PUBLICA AGRARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.24.01', 'CONTROLE REGISTRO SPIUNET A RATIFICAR', 'REGISTRA OS VALORES RELATIVOS AOS MOVIMENTOS DE REAVALIACAO OCORRIDOS ATRAVES DO SPIUNET NAS CONTAS CONTABEIS DO GRUPO BENS IMOVEIS DE USO ESPECIAL - PENDENTES DE RATIFICACAO PELO GESTOR, VISANDO COMPATIBILIZAR OS SALDOS ORIUNDOS DO SPIUNET COM AQUELES EXISTENTES NO SIAFI COM INTUITO DE EVITAR DIVERGENCIAS DE LANCAMENTOS ENTRE OS SISTEMAS, CONFORME ACORDAO TCU/639/2007.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.24.02', 'CONTROLE REGISTRO SPIUNET RATIFICADO', 'REGISTRA OS VALORES RELATIVOS AOS MOVIMENTOS DE REAVALIACAO OCORRIDOSATRAVES DO SPIUNET NAS CONTAS CONTABEIS DO GRUPO BENS IMOVEIS DE USO ESPECIAL - RATIFICADOS PELO GESTOR, VISANDO COMPATIBILIZAR OS SALDOS ORIUNDOS DO SPIUNET COM AQUELES EXISTENTES NO SIAFI COM O INTUITO DE EVITAR DIVERGENCIAS DE LANCAMENTOS ENTRE OS SISTEMAS, CONFORME ACORDAO TCU/639/2007', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.25.01', 'DEVOLUCOES DE BENEFICIOS A CLASSIFICAR', 'REGISTRA OS VALORES REFERENTES AS DEVOLUCOES DE PAGAMENTOS DE BENEFICIOS PELA REDE BANCARIA POR MEIO DE MENSAGEM SPB PARA POSTERIOR REGISTRO DE ESTORNO DE DESPESA PELO INSS. O REGISTRO OCORRERA NA COFIN/STN PARA CONTROLE DE RESTABELECIMENTO DE COTAS ORCAMENTARIAS A PROGRAMAR,VISANDO POSSIBILITAR A PROGRAMACAO FINANCEIRA ENTRE O INSS E A COFIN/STN PARA A REALIZACAO DE NOVOS PAGAMENTOS.O SALDO CORRESPONDE AO FINANCEIRO QUE INGRESSOU POR MENSAGEM SPB PENDENTE DE CLASSIFICACAO PELO INSS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.25.02', 'DEVOLUCOES DE BENEFICIOS CLASSIFICADOS', 'REGISTRA OS VALORES REFERENTES AS DEVOLUCOES DE PAGAMENTOS DE BENEFICIOS PELA REDE BANCARIA POR MEIO DE MENSAGEM SPB PARA POSTERIOR REGISTRO DE ESTORNO DE DESPESA PELO INSS. O REGISTRO OCORRERA NA COFIN/STN PARA CONTROLE DE RESTABELECIMENTO DE COTAS ORCAMENTARIAS A PROGRAMAR,VISANDO POSSIBILITAR A PROGRAMACAO FINANCEIRA ENTRE O INSS E A COFIN/STN PARA A REALIZACAO DE NOVOS PAGAMENTOS. O SALDO CORRESPONDE AO FINANCEIRO QUE INGRESSOU POR MENSAGEM SPB E JA FOI CLASSIFICADO PELO INSS PELO LANCAMENTO DE ESTORNO DA DESPESA', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.26.01', 'CANCELAMENTO DE PRECATORIOS EM TRANSITO', 'REGISTRA OS VALORES EM TRANSITO REFERENTE CANCELAMENTO DE PRECATORIO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.26.02', 'CONCESSAO DE PRECATORIOS EM TRANSITO', 'REGISTRA OS VALORES EM TRANSITO REFERENTE CREDITO DE PRECATORIOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.27.01', 'VALORES PROGRAMADOS POR EXERCICIO - TV', 'REGISTRA O ACOMPANHAMENTO COM BASE NO CRONOGRAMA DA PROGRAMACAO ORCAMENTARIA DE TRANSFERENCIAS VOLUNTARIAS COM PRAZO DE VIGENCIA PLURIANUAL. ATENDER ARTIGO8º DA PORTARIA Nº 127, DE 29 DE MAIO 2008.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.27.02', 'VALORES EMPENHADOS POR EXERCICIO + TV', 'REGISTRA O ACOMPANHAMENTO DOS VALORES EMPENHADOS COM BASE NA PROGRAMACAO ORCAMENTARIADE TRANSFERENCIAS VOLUNTARIAS FORMALIZADAS COM PRAZO DE VIGENCIA PLURIANUAL', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.27.03', 'VALORES PAGOS POR CLASSIFICACAO DE DESPESA-', 'REGISTRA O ACOMPANHAMENTO DOS VALORES PAGOS PELO CONVENENTE CONTROLADOS POR CLASSIFICACAO DA DESPESA COM BASE NO PLANO DE CONTAS DA UNIAO', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.27.04', 'VALORES DEVOLVIDOS PARA CONTA UNICA', 'REGISTRA O ACOMPANHAMENTO DOS VALORES EXECUTADOS PELO CONVENENTE CONTROLADOS POR FONTEDE RECURSOS E NATUREZA DE DESPESA DETALHADA NO MOMENTO DA TRANSFERENCIA DE RECURSOS PARA A CONTA UNICAN PELO CONVENENTE PELA PRESTACAO DE CONTAS. O REGISTRO OCORRE NA UG CONCEDENTE DA TRANSFERENCIA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.27.05', 'VALORES EMPENHADOS INSC. EM RESTOS A PAGAR', 'REGISTRA OS VALORES EMPENHADOS E INSCRITOS EM RESTOS A PAGAR RELATIVOSTRANSFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO, GERADOS A PARTIR DO PORTAL/SICONV', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.28.00', 'CONTROLE DE EST. DA DIVITA ATIVA TRIBUTARIA', 'REGISTRA OS VALORES RELATIVOS AO ESTOQUE DA DIVIDA ATIVA TRIBUTARIAPROVENIENTES DE TRIBUTOS, MULTAS DA FAZENDA NACIONAL LANCADOS NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO DE ORIGEM QUE CONSTITUIREM EM DIVIDA ATIVA. ROTINA INTEGRADA COM O SISTEMA DAU E O SIAFI.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.29.00', 'CONTROLE MATERIAL DE CONSUMO REQUISITADO', 'REGISTRA OS VALORES RELATIVOS AO CONTROLE DE MATERIAL DE CONSUMO REQUISITADO PELAS UNIDADES GESTORAS ÀS RESPECTIVAS SETORIAIS FINANCEIRAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.30.01', 'CONTROLE PASSIVO FINANCEIRO - PESSOAL', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO/CELULA DA DESPESA, POR EXEMPLO AS SEGUINTES SITUACÓES:OB CANCELADA REFERENTE A PAGAMENTO DE DESPESA DE EXERCICIO ANTERIOR DECORRENTE DE FOLHA DE PESSOAL; OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLE DE EMPENHO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.30.02', 'CONTROLE PASSIVO FINANCEIRO - FORNECEDORES', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO/CELULA DA DESPESA, POR EXEMPLO AS SEGUINTES SITUACÓES: OB CANCELADA REFERENTE A PAGAMENTO DE DESPESA DE EXERCICIO ANTERIOR DECORRENTE DE OUTRAS DESPESAS OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLE OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLEDE EMPENHO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.30.03', 'CONTROLE PASSIVO FINANCEIRO - SUPRIM. FUNDO', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO/CELULA DA DESPESA, POR EXEMPLO AS SEGUINTES SITUACÓES:OB CANCELADA REFERENTE A PAGAMENTO DE DESPESA DE EXERCICIO ANTERIOR DECORRENTE DE OUTRAS DESPESAS OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLE OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLEDE EMPENHO. RECOLHIMENTO DE TRIBUTO ESTADUAL EM OB, CUJO EMPENHO REFERESE A SUPRIMENTO DE FUNDOS, NAO PERMITINDO CONTA DIFERENTE DE TIPO "B".', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.30.04', 'CONTROLE PASSIVO FINANCEIRO - BENEFICIOS', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO/CELULA DA DESPESA, POR EXEMPLO AS SEGUINTES SITUACÓES: OB CANCELADA REFERENTE A PAGAMENTO DE DESPESA DE EXERCICIO ANTERIOR DECORRENTE PAGAMENTO DE PRECATORIOS DE BENEFICIOS OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLE OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLE DE EMPENHO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.30.05', 'CONTR.PASSIVO FINANC - OBRIG.TRIB SOBRE FAT', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO/CELULA DA DESPESA, POR EXEMPLO AS OBRIGACOES TRIBUTARIAS APROPRIADAS SOBRE O FATURAMENTO COMO PIS/PASEP, ISS, ETC.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.30.06', 'CONTR.PASSIVO FINANC - EMISSAO DARF SISCOME', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS APROPRIADOS NA ROTINA DO SISCOMEX, ONDE A APROPRIACAO REGISTRA DIRETAMENTO NOS VALORES PAGOS,POIS NO RECOLHIMENTO DO RESPECTIVO DARF NAO EH POSSIVEL INCLUIR O NUMERO DO EMPENHO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.30.07', 'CONTROLE PASSIVOS FINANCEIROS - NE', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO, PARA POSSIBILITAR APURACAO ESPECIAL E INCLUIR ESSES EMPENHOS NO CADASTRO DE EMPENHO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.30.08', 'CONTROLE DEMAIS PASSIVOS FINANCEIROS', 'REGISTRA OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO/CELULA DA DESPESA, POR EXEMPLO AS SEGUINTES SITUACÓES, NAO COMPREENDIDAS EM SUBITENS ESPECIFICOS: OB CANCELADA REFERENTE A PAGAMENTO DE DESPESA DE EXERCICIO ANTERIOR DECORRENTE DE OUTRAS DESPESAS OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLE OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLE DE EMPENHO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.31.01', 'CUSTOS DE PRODUCAO A APROPRIAR', 'REGISTRA O CONTROLE ORCAMENTARIO DE CUSTOS DE PRODUCAO A APROPRIAR PELA COMPANHIA DE PESQUISA DE RECURSOS MINERAIS - CPRM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.31.02', 'CUSTOS DE PRODUCAO A APROPRIADOS', 'REGISTRA O CONTROLE ORCAMENTARIO DE CUSTOS DE PRODUCAO APROPRIADOS PELA COMPANHIA DE PESQUISA DE RECURSOS MINERAIS - CPRM.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.32.01', 'VALOR AUTORIZADO A CAPTAR', 'REGISTRAR A PREVISAO DE RECURSOS PUBLICOS NAO-FINANCEIROS E PRIVADOS, APROVADOS PARA CAPTACAO POSTERIOR JUNTO AAS PESSOAS FISICAS CONTRIBUINTES DO IMPOSTO DE RENDA NA MODALIDADE COMPLETA, E AAS PESSOAS JURIDICAS, CONTRIBUINTES DO IMPOSTO DE RENDA NA MODALIDADE DE LUCRO REAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.32.02', 'VALOR NÃO CAPTADO', 'REGISTRA OS VALORES DOS RECURSOS PUBLICOS NAO-FINANCEIROS DOS PROJETOS APROVADOS PELO MINC QUE NAO TIVERAM CAPTACAO OU REALIZARAM CAPTACAO PARCIAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.32.04', 'VALOR CAPTADO A COMPROVAR', 'REGISTRA OS RECURSOS PUBLICOS NAO-FINANCEIROS REFERENTES AOS VALORES CAPTADOS EM PROJETOS APROVADOS PELO MINISTERIO DA CULTURA, DEPOSITADOS NAS CONTAS BANCARIAS DOS PROJETOS CULTURAIS, AINDA NAO INFORMADOS AO MINC ACERCA DA APLICACAO DOS RECURSOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.32.05', 'VALOR CAPTADO A APROVAR', 'REGISTRA OS RECURSOS PUBLICOS NAO-FINANCEIROS REFERENTES AOS VALORES CAPTADOS EM PROJETOS APROVADOS PELO MINISTERIO DA CULTURA, DEPOSITADOS NAS CONTAS BANCARIAS DOS PROJETOS CULTURAIS, INFORMADOS AO MINC PARA EFEITO DE COMPROVACAO DE APLICACAO DE RECURSOS E AINDA NAO ANALISADOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.32.06', 'VALOR CAPTADO APROVADO', 'REGISTRA OS RECURSOS PUBLICOS NAO-FINANCEIROS REFERENTES AOS VALORES CAPTADOS EM PROJETOS APROVADOS PELO MINISTERIO DA CULTURA, DEPOSITADOS NAS CONTAS BANCARIAS DOS PROJETOS CULTURAIS, E QUE FORAM APROVADOS QUANTO AA REGULARIDADE DA APLICACAO DOS RECURSOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.32.07', 'VALOR CAPTADO IMPUGNADO', 'REGISTRA OS RECURSOS PUBLICOS NAO-FINANCEIROS REFERENTES AOS VALORES CAPTADOS EM PROJETOS APROVADOS PELO MINISTERIO DA CULTURA, DEPOSITADOS NAS CONTAS BANCARIAS DOS PROJETOS CULTURAIS, CUJAS CONTAS NÃO FORAM APROVADAS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.32.08', 'VALOR CAPTADO INADIMPLÊNCIA EFETIVA', 'REGISTRA OS RECURSOS PUBLICOS NAO-FINANCEIROS REFERENTES AOS VALORES CAPTADOS EM PROJETOS APROVADOS PELO MINISTERIO DA CULTURA, DEPOSITADOS NAS CONTAS BANCARIAS DOS PROJETOS CULTURAIS, MAS QUE NAO HOUVE A DEVIDA PRESTACAO DE CONTAS QUANTO À REGULARIDADE DA APLICACAO DOS RECURSOS', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.32.09', 'VALOR CAPTADO DEVOLVIDO', 'REGISTRA A DEVOLUCAO DE VALORES CAPTADOS QUE NAO FORAM APLICADOS NA EXECUCAO DO PROJETO, BEM COMO A DEVOLUCAO DE VALORES RECOLHIDOS PELA NAO APROVACAO DA PRESTACAO DE CONTAS DO PROJETO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.32.10', 'VALOR CAPTADO CONCLUÍDO', 'REGISTRA OS RECURSOS PUBLICOS NAO-FINANCEIROS, REFERENTES AOS VALORES CAPTADOS EM PROJETOS PROVADOS PELO MINC, DEPOSITADOS NAS CONTAS BANCARIAS DOS PROJETOS CULTURAIS, QUE FORAM APROVADOS QUANTO AA REGULARIDADE DA APLICACAO DOS RECURSOS, CUJA EXECUCAO E PRESTACAO DE CONTAS FORAM DEFINITIVAMENTE FINALIZADAS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.32.12', 'VALOR RENUNCIADO', 'REGISTRA OS RECURSOS NAO-FINANCEIROS DEBITADOS NO IMPOSTO DE RENDA DEVIDO DE PESSOAS FISICAS, NA MODALIDADE COMPLETA, E DE PESSOAS JURIDICAS, NA MODALIDADE DE LUCRO REAL.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.2.01.01', 'BENS DE ESTOQUE A RECEBER', 'REGISTRA O VALOR DOS BENS DE ESTOQUE A RECEBER,TRANSFERIDOS ENTRE UG,QUE NAO CHEGARAM AO SEU DESTINO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.2.01.02', 'BENS DE ESTOQUE ENVIADOS', 'REGISTRA O VALOR REFERENTE A TRANSFERENCIA DE BENS DE ESTOQUE ENVIADOS A OUTRA UG.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.2.01.03', 'MATERIAIS PARA REVENDA', 'REGISTRA O VALOR DAS TRANSFERENCIA DE MATERIAIS PARA REVENDA AINDA NAO RECEBIDOS PELA UG. BENEFICIADA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.2.02.01', 'BENS MOVEIS A RECEBER', 'REGISTRA O VALOR DOS BENS MOVEIS A RECEBER,TRANSFERIDOS ENTRE UG, QUE NAO CHEGARAM AO SEU DESTINO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.2.02.02', 'BENS MOVEIS ENVIADOS', 'REGISTRA O VALOR REFERENTE A TRANSFERENCIA DE BENS MOVEIS ENVIADOS AOUTRA UG.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.2.03.01', 'TITULOS E VALORES', 'REGISTRA OS VALORES E TITULOS TRANSFERIDOS PARA UNIDADES GESTORAS INTEGRANTES DO SIAFI .', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.2.03.02', 'CHEQUES DEVOLVIDOS', 'REGISTRA OS VALORES RECEBIDOS PELO BANCO DO BRASIL POR GRU COM CHEQUE SEM FUNDOS, QUE SERAO RESTITUIDOS AO BANCO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.2.04.00', 'MATERIAIS PARA REVENDA', 'REGISTRA OS VALORES DOS MATERIAIS PARA REVENDA EM TRANSITO ENTRE AS UG DO SIAFI.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.3.01.00', 'IMPORTACOES DE MATERIAIS', 'REGISTRA O VALOR DAS IMPORTACOES DE MATERIAIS EM CURSO, COM CONTROLE NAS CONTAS DE COMPENSACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.3.02.00', 'IMPORTACOES DE BENS', 'REGISTRA O VALOR DAS IMPORTACOES DE BENS EM CURSO, COM CONTROLE NAS CONTAS DE COMPENSACAO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.4.00.00', 'OBRAS EM FAVOR DE ENTIDADES', 'REGISTRA O VALOR REFERENTE A OBRAS EM PROPRIEDADE DE TERCEIROS, COM DOACAO IMEDIATA AO BENEFICIADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.5.00.00', 'CONTAS EMITIDAS DE ENTIDADES', 'REGISTRA A PREVISAO DE RECEITAS PROVENIENTES DO FORNECIMENTO DE BENS OU SERVICOS, IDENTIFICANDO A SUA ORIGEM POR CONTROLE INDIVIDUALIZADO.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.6.00.00', 'CREDORES - COMPRAS CENTRALIZADAS', 'REGISTRA OS VALORES DEVIDOS A FORNECEDORES REFERENTES A COMPRAS CENTRALIZADAS, COM OS BENS E/OU SERVICOS JA ENTREGUES A UNIDADE CONSUMIDORA E A DESPESA PENDENTE DE LIQUIDACAO PELA UNIDADE COMPRADORA.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.7.00.00', 'RENEGOCIACAO DE DIVIDAS ESTADUAIS - SUBSIDIOS AOS ESTADOS', 'REGISTRA O VALOR DOS SUBSIDIOS RELATIVOS AOS REFINANCIAMENTO DE DIVIDAS ESTADUAIS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.8.00.00', 'CONTROLES DIVERSOS - EQUILIBRIO GRUPO', 'REGISTRA O VALOR RELATIVO COMPENSACOES DIVERSAS, PARA FECHAMENTO DO GRUPO 7999 X 8999.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.9.00.00', 'DIVERSOS CONTROLES', 'REGISTRA A RESPONSABILIDADE POR CONTROLES DIVERSOS.', 'C', 'S', 'C', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.1.1.0.00.00.00.00.00', 'PPA POR PROGRAMA DE TRABALHO', 'REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL APROVADO PARA O PERIODO DE QUATRO ANOS, DETALHADO POR PROGRAMA DE TRABALHO .', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.1.2.0.00.00.00.00.00', 'REVISAO DO PPA', 'REGISTRA O SOMATORIO DOS VALORES MONETARIOS DAS REVISOES ANUAIS AUTORIZADAS DURANTE O PERIODO DE VIGENCIA DO PLANO PLURIANUAL, DETALHADO POR PROGRAMA DE TRABALHO.', 'X', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.2.1.1.00.00.00.00.00', 'PLOA INICIAL DA RECEITA', 'REGISTRA O SOMATORIO DOS VALORES MONETARIOS DA PREVISAO DE RECEITA CONSTANTE DO PLOA INICIAL.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.2.1.2.00.00.00.00.00', 'ALTERACOES  DO PROJETO INICIAL DA LOA - RECEITA', 'REGISTRA O SOMATORIO DAS ALTERACOES NO PROJETO INICIAL DA LOA EM RELACAO A RECEITA.', 'X', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.2.2.1.00.00.00.00.00', 'PLOA INICIAL DA DESPESA', 'REGISTRA O SOMATORIO DOS VALORES MONETARIOS DA FIXACAO DA DESPESA CONSTANTE DO PLOA INICIAL.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.2.2.2.00.00.00.00.00', 'ALTERACOES DO PROJETO INICIAL DA LOA - DESPESA', 'REGISTRA O SOMATORIO DAS ALTERACOES NO PROJETO INICIAL DA LOA EM RELACAO A DESPESA.', 'X', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.1.0.01.00.00.00.00', 'PREVISAO INICIAL DA RECEITA  BRUTA', 'REGISTRA O VALOR BRUTO DA RECEITA PREVISÃO INICIAL DA RECEITA .', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.1.0.02.00.00.00.00', '(-) PREVISÃO DE DEDUÇÕES DA RECEITA', 'REGISTRA O VALOR DAS DEDUÇÕES DE  RECEITA ORÇAMENTÁRIA PREVISTAS  EM ORÇAMENTO PARA O EXERCÍCIO VIGENTE.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.2.1.00.00.00.00.00', 'PREVISÃO ADICIONAL DA RECEITA', 'Registra o valor adicional da receita para abertura de créditos adicionais.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.2.9.00.00.00.00.00', '(-) ANULAÇÃO DA PREVISÃO DA RECEITA', 'Registra o valor da anulação da receita prevista no orçamento, na gestão fundos e nas administrações direta e indireta.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.1.01.01.00.00.00', 'ORIGINARIO DO OGM', 'REGISTRA OS VALORES PERTINENTES AOS CREDITOS INICIAIS  APROVADOS  PELA LEI ORCAMENTARIA, PARA EXECUCAO DO ORCAMENTO DOS ORGAOS/ENTIDADES  INTEGRANTES DO OGM REFERENTES AO OFSS.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.01.00.00.00.00', 'CREDITO ADICIONAL - SUPLEMENTAR', 'Compreende o somatório dos valores relativos aos créditos adicionais suplementares com vista ao reforço da dotação orçamentária constante da lei orçamentária.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.02.01.00.00.00', 'CRÉDITOS ESPECIAIS ABERTOS', 'Registra os valores referentes à abertura de créditos especiais autorizados em lei especifica.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.02.02.00.00.00', 'CRÉDITOS ESPECIAIS REABERTOS', 'Registra os valores referentes à reabertura de créditos especiais cujo ato de autorização foi promulgado nos últimos quatro meses do exercício anterior.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.02.03.00.00.00', 'CRÉDITOS ESPECIAIS REABERTOS - SUPLEMENTAÇÃO', 'Registra os valores referentes à suplementação de créditos especiais reabertos nos termos do § 2º do art. 167 da C.F./88.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.03.01.00.00.00', 'CRÉDITOS EXTRAORDINÁRIOS ABERTOS', 'Registra os valores referentes aos créditos extraordinários abertos por decreto do poder executivo.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.03.02.00.00.00', 'CRÉDITOS EXTRAORDINÁRIOS REABERTOS', 'Registra os valores referentes à reabertura de créditos extraordinários cujo ato de autorização foi promulgado nos últimos quatro meses do exercício anterior.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.03.03.00.00.00', 'CRÉDITOS EXTRAORDINÁRIOS REABERTOS - SUPLEMENTAÇÃO', 'Registra os valores referentes à suplementação de créditos extraordinários reabertos nos termos do § 2º do art. 168 da C.F./88.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.01.01.00.00.00', 'SUPERAVIT FINANCEIRO DE EXERCICIO ANTERIOR', 'REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA SUPERAVIT FINANCEIRO APURADO NO BALANCO PATRIMONIAL DO EXERCICIO ANTERIOR.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.01.02.01.00.00', 'EXCESSO DE ARRECADACAO PROPRIAMENTE DITA', 'REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO DE VALORES RECEBIDOS A MAIOR QUE O PREVISTO NO ORÇAMENTO ORIGINAL.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.01.02.02.00.00', 'DOACOES', 'REGISTRA OS VALORES PERTINENTES AOS CREDITOS SUPLEMENTARES ABERTOS  NO EXERCICIO, PROVENIENTES DE  DOACOES RECEBIDAS.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.01.02.03.00.00', 'AUXILIOS E CONVENIOS', 'RECURSO OFERECIDO PARA ABERTURA DE CRÉDITOS SUPLEMENTARES ADICIONAIS PROVENIENTE DO RECEBIMENTO DE AUXÍLIOS E CONVÊNIOS.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.01.03.00.00.00', 'OPERACOES DE CREDITO', 'REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA OPERACOES DE CREDITO AUTORIZADAS.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.01.04.00.00.00', 'ANULACAO DE DOTACAO', 'REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA A ANULACAO PARCIAL OU TOTAL DE DOTACOES ORCAMENTARIAS OU CREDITOS ADICIONAIS, AUTORIZADOS EM LEI.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.02.01.00.00.00', 'SUPERAVIT FINANCEIRO DE EXERCICIO ANTERIOR', 'REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA SUPERAVIT FINANCEIRO APURADO NO BALANCO PATRIMONIAL DO EXERCICIO ANTERIOR.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.02.02.01.00.00', 'EXCESSO DE ARRECADACAO PROPRIAMENTE DITA', 'REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO DE VALORES RECEBIDOS A MAIOR QUE O PREVISTO NO ORÇAMENTO ORIGINAL.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.02.02.02.00.00', 'DOACOES', 'REGISTRA OS VALORES PERTINENTES AOS CREDITOS SUPLEMENTARES ABERTOS  NO EXERCICIO, PROVENIENTES DE  DOACOES RECEBIDAS.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.02.02.03.00.00', 'AUXILIOS E CONVENIOS', 'RECURSO OFERECIDO PARA ABERTURA DE CRÉDITOS SUPLEMENTARES ADICIONAIS PROVENIENTE DO RECEBIMENTO DE AUXÍLIOS E CONVÊNIOS.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.02.03.00.00.00', 'OPERACOES DE CREDITO', 'REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA OPERACOES DE CREDITO AUTORIZADAS.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.02.04.00.00.00', 'ANULACAO DE DOTACAO', 'REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA A ANULACAO PARCIAL OU TOTAL DE DOTACOES ORCAMENTARIAS OU CREDITOS ADICIONAIS, AUTORIZADOS EM LEI.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.09.00.00.00.00', '(-) CANCELAMENTO DE DOTACOES', 'REGISTRA O CANCELAMENTO / REMANEJAMENTO DE DOTACOES PARA ABERTURA DE CREDITOS ADICIONAIS.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.99.00.00.00.00', 'VALOR GLOBAL DA DOTACAO ADICIONAL POR FONTE', 'REGISTRA O VALOR DA CONTRAPARTIDA DOS LANCAMENTOS DAS DOTACOES ADICIONAIS POR ORIGEM DE CREDITO.', 'X', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.01.01.00.00.00', 'ACRESCIMO', 'REGISTRA  A MOVIMENTACAO DOS CREDITOS POR ACRESCIMO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.01.09.00.00.00', '(-) REDUCAO', 'REGISTRA  A MOVIMENTACAO DOS CREDITOS POR REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.02.01.00.00.00', 'ACRESCIMO', 'REGISTRA OS VALORES DOS ACRESCIMOS  RESULTANTES DE ALTERACOES  DA LEI ORCAMENTARIA EM VIRTUDE DE REMANEJAMENTO.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.02.09.00.00.00', '(-) REDUCAO', 'REGISTRA O VALOR DA REDUCAO DA DOTACAO DEVIDO A ALTERACAO DA LEI  ORCAMENTARIA EM VIRTUDE DE REMANEJAMENTO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.04.00.00.00.00', '(-) CANCELAMENTO DE DOTACOES', 'REGISTRA O VALOR DA REDUCAO DA DOTACAO DEVIDO A ALTERACAO DA LEI  ORCAMENTARIA EM VIRTUDE DE CANCELAMENTO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.1.01.00.00.00.00', 'PROVISAO RECEBIDA', 'REGISTRA A PARCELA DE CREDITO RECEBIDA POR UMA UNIDADE  ADMINISTRATIVA OU ORCAMENTARIA, DECORRENTE DA DESCENTRALIZACAO DO  CREDITO ORCAMENTARIO OU ADICIONAL, DENTRO DO PROPRIO ORGAO.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.01.01.00.00.00', 'CREDITOS RECEBIDOS', 'REGISTRA O VALOR DOS CREDITOS RECEBIDOS PELA ADMINISTRACAO DIRETA   DE OUTROS ORGAOS E ENTIDADES.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.01.09.00.00.00', '(-) CREDITOS TRANSFERIDOS', 'REGISTRA A MOVIMENTACAO DE CREDITOS DE ENTIDADES DA ADMINISTRACAO INDIRETA OU ENTRE ORGAOS DA ADMINISTRACAO DIRETA DE UNIDADE ORCAMENTARIA DIFERENTE.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.02.01.00.00.00', 'CREDITOS RECEBIDOS', 'REGISTRA O VALOR DOS CREDITOS RECEBIDOS PELA ADMINISTRACAO INDIRETA DE MESMA OU DE DIFERENTE UNIDADE ORCAMENTARIA DO ORGAO EMITENTE.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.02.09.00.00.00', '(-) CREDITOS TRANSFERIDOS', 'REGISTRA A MOVIMENTACAO DE CREDITOS DE ORGAOS DA ADMINISTRACAO DIRETA OU ENTRE ENTIDADES DA ADMINISTRACAO INDIRETA DE MESMA OU DE   DIFERENTE UNIDADE ORCAMENTARIA, NAO FORMALIZADA A TERMO DE CONTRATO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.9.00.00.00.00.00', 'OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS', 'Compreende as movimentações de créditos recebidos por cisão, fusão, extinção, compensação e outras transações.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.3.0.00.00.00.00.00', 'DETALHAMENTO DE CREDITO', 'Compreende o somatório relativos às dotações detalhadas relativas a cada ação orçamentária (projeto, atividade ou operações especiais).', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.01.01.00.00.00', 'EMISSAO DE EMPENHOS', 'REGISTRA O VALOR DA EMISSAO DE EMPENHO DA DESPESA, INCLUSIVE AQUELAS QUE FORAM OBJETO DE PRE-EMPENHO.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.01.04.00.00.00', 'ANULACAO DE EMPENHOS', 'REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA ORCAMENTARIA  A DOTACAO CORRESPONDENTE.', 'D', 'S', '0', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.01.05.00.00.00', 'CANCELAMENTO DE EMPENHO POR FALTA DE DISPONIBILIDADE DE CAIXA', 'REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA ORCAMENTARIA A DOTACAO CORRESPONDENTE POR FALTA DE DISPONIBILIDADE DE CAIXA.', 'D', 'S', '0', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.04.01.00.00.00', 'CONCURSO', 'REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO CONCURSO.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.04.02.00.00.00', 'CONVITE', 'REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO CONVITE.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.04.03.00.00.00', 'TOMADA DE PRECOS', 'REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO TOMADA DE PRECOS.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.04.04.00.00.00', 'CONCORRENCIA', 'REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO CONCORRENCIA.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.04.06.00.00.00', 'DISPENSA DE LICITAÇAO', 'REGISTRA O VALOR DO EMPENHOS EMITIDOS POR DISPENSA DE LICITACAO.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.04.07.00.00.00', 'LICITACAO INEXIGIVEL', 'REGISTRA O VALOR DOS EMPENHOS EMITIDOS PELA REALIZACAO DE DESPESAS  EM QUE E INEXIGIVEL A LICITACAO QUANDO HOUVER INVIABILIDADE DE  COMPETICAO.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.04.09.00.00.00', 'SUPRIMENTO DE FUNDOS', 'REGISTRA O VALOR DOS EMPENHOS EMITIDOS RELATIVOS A SUPRIMENTOS DE FUNDOS PARA ATENDER DESPESAS EVENTUAIS, INCLUSIVE EM VIAGENS E COM SERVICOS ESPECIAIS, DESPESA DE CARATER SIGILOSO OU PARA ATENDER DESPESAS  DE  PEQUENO VULTO, DE ACORDO COM A LEGISLACAO VIGENTE.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.04.12.00.00.00', 'PREGAO', 'REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE  PREGAO.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.09.01.00.00.00', 'VALORES COMPROMETIDOS', 'REGISTRA O VALOR DOS EMPENHOS EMITIDOS CONTROLADOS POR BENEFICIARIO DO EMPENHO.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.1.1.0.00.00.00.00.00', 'RP NÃO PROCESSADOS INSCRITOS', 'Registra os valores inscritos em restos a pagar não-processados relativos às despesas empenhadas e não liquidadas até o ultimo dia do exercício financeiro.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.1.2.0.00.00.00.00.00', 'RP NÃO PROCESSADOS - EXERCÍCIOS ANTERIORES', 'Registra o valor de restos a pagar não processados relativo a exercícios anteriores que não foram cancelados porque tiveram seu prazo de validade prorrogado.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.1.3.0.00.00.00.00.00', 'RP NÃO PROCESSADOS RESTABELECIDOS', 'Registra o valor por restabelecimento de empenho de restos a pagar já cancelados em exercícios anteriores com base em ato normativo específico.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.1.6.0.00.00.00.00.00', 'RP NÃO PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA', 'Registra o valor da transferência de restos a pagar não processados decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.1.7.0.00.00.00.00.00', 'RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO', 'Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 531100000.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.2.1.0.00.00.00.00.00', 'RP PROCESSADOS - INSCRITOS', 'Registra o somatório dos valores inscritos em restos a pagar processados relativos às despesas empenhadas, liquidadas e não pagas no exercício financeiro em que foi empenhado.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.2.2.0.00.00.00.00.00', 'RP PROCESSADOS - EXERCÍCIOS ANTERIORES', 'Registra os valores de restos a pagar processados relativos às despesas empenhadas, liquidadas e não pagas no exercício financeiro subseqüente.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.2.6.0.00.00.00.00.00', 'RP PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA', 'Registra o valor da transferência de restos a pagar processados decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.2.7.0.00.00.00.00.00', 'RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO', 'Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 532100000.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.1.1.0.00.00.00.00.00', 'PPA A ALOCAR NO PLOA', 'REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL DURANTE O SEU PERIODO DE VIGENCIA DETALHADO POR PROGRAMAS DE TRABALHO A SEREM SELECIONADOS NA ELABORACAO DO PLOA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.1.2.0.00.00.00.00.00', 'PPA ALOCADO NA LOA', 'REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL APROVADO, DETALHADO POR PROGRAMA DE TRABALHO ALOCADO NA LOA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.1.3.0.00.00.00.00.00', 'PPA EXECUTADO', 'REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL EXECUTADO NO SEU PERIODO DE VIGENCIA, DETALHADO POR PROGRAMA DE TRABALHO AUTORIZADO NAS LEIS ORCAMENTARIAS.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.2.1.0.00.00.00.00.00', 'PROCESSAMENTO DO PLOA -RECEITA', 'COMPREENDE O SOMATORIO DOS VALORES MONETARIOS DAS RECEITAS PREVISTAS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITACAO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.2.2.0.00.00.00.00.00', 'PROCESSAMENTO DO PLOA -DESPESA', 'COMPREENDE O SOMATORIO DOS VALORES MONETARIOS FIXADOS PARA AS DESPESAS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITACAO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.1.1.0.00.00.00.00.00', 'RECEITA A REALIZAR', 'Registra o somatório dos valores relativos à receita pública aprovada pela lei orçamentária anual e suas alterações, detalhada por natureza da receita.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.1.2.0.00.00.00.00.00', 'RECEITA REALIZADA', 'Registra o somatório dos valores relativos às receitas realizadas, detalhada por natureza de receita.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.1.3.0.00.00.00.00.00', '(-) DEDUÇÕES DA RECEITA ORÇAMENTÁRIA', 'Registra o somatório dos valores relativos às deduções de receitas realizadas (devoluções, restituições, e outras), detalhada por natureza de receita.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.1.00.00.00.00.00', 'CREDITO DISPONÍVEL', 'Registra o valor da disponibilidade de credito referente à dotação inicial e adicional aprovada no orçamento geral da União na loa ou lei especifica ou antecipada pela lei de diretrizes orçamentárias - LDO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.2.01.01.00.00.00', 'CREDITO BLOQUEADO PARA REMANEJAMENTO', 'REGISTRA O VALOR DA INDISPONIBILIDADE DE CREDITOS ORCAMENTARIOS PELA SETORIAIS DE ORCAMENTO PARA REMANEJAMENTO DE FONTE OU GRUPO DE DESPESA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.2.01.02.00.00.00', 'CREDITO BLOQUEADO PARA CONTROLE INTERNO', 'REGISTRA OS VALORES DE CREDITOS INDISPONIBILIZADOS INTERNAMENTE  PELOS ORGAOS PARA CONTROLE.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.2.99.00.00.00.00', 'OUTRAS INDISPONIBILIDADES', 'REGISTRA O VALOR DAS INDISPONIBILIDADES DE CREDITOS ORCAMENTARIOS DE NATUREZA EVENTUAL, PARA AS QUAIS NAO HA CONTAS ESPECIFICAS.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.01.00.00.00.00', 'CREDITO EMPENHADO A LIQUIDAR', 'Registra o valor da despesa empenhada a ser liquidada', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.02.00.00.00.00', 'CREDITO EMPENHADO EM LIQUIDAÇÃO', 'Registra o valor da despesa cujo fato gerador já ocorreu, mas que ainda não foram conferidos o objeto, e o valor, ou seja, não houve a liquidação.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.03.00.00.00.00', 'CREDITO EMPENHADO LIQUIDADO A PAGAR', 'Registra o valor da apropriação das despesas empenhadas com posterior verificação de sua regularidade por constituição do direto do credor.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.04.00.00.00.00', 'CREDITO EMPENHADO LIQUIDADO PAGO', 'Demonstra o valor da despesa empenhada liquidada paga.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.05.00.00.00.00', 'EMPENHOS A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NÃO PROCESSADOS', 'Registra o montante dos valores a liquidar inscritos em restos a pagar nao processados.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.06.00.00.00.00', 'EMPENHOS EM LIQUIDACAO INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS', 'Registra o montante dos valores em liquidação inscritos em restos a pagar nao processados.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.07.00.00.00.00', 'EMPENHOS LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS', 'Registra o montante dos valores liquidados inscritos em restos a pagar processados.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.99.00.00.00.00', '(-) OUTROS CRÉDITOS UTILIZADOS', 'Registra a contrapartida de despesas realizadas pelas entidades ou órgão da administração direta/indireta que utilizam o SIAFI no modulo parcial.   Registra a contrapartida de despesas liquidadas na rotina de suprimento de fundos para evitar a emissão de lista de item (li) para reclassificação da despesa.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.1.01.00.00.00.00', 'PROVISAO CONCEDIDA', 'REGISTRA O CREDITO CONCEDIDO PELA UNIDADE ORCAMENTARIA A PARTIR DE SUA PROPRIA DOTACAO OU DE UM DESTAQUE A SEU FAVOR, PARA UNIDADE ADMINISTRATIVA OU ORCAMENTARIA, NO AMBITO DO PROPRIO MINISTERIO OU ORGAO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.2.01.01.00.00.00', 'CREDITOS CONCEDIDOS', 'REGISTRA O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES   DE CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO DIRETA  TRANSFERIDORA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.2.02.01.00.00.00', 'CREDITOS CONCEDIDOS', 'REGISTRA O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES   DE SUA CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO  INDIRETA TRANSFERIDORA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.9.00.00.00.00.00', 'OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS', 'Compreende as movimentações de créditos concedidos por cisão, fusão, extinção, compensação e outras transações.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.3.0.00.00.00.00.00', 'DETALHAMENTO DE CREDITO', 'Registra o detalhamento das dotações orçamentárias relativas a cada programa de trabalho.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.01.00.00.00', 'EMPENHOS A LIQUIDAR', 'REGISTRA O VALOR DOS EMPENHOS DE DESPESAS PENDENTES DE  LIQUIDACAO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.02.00.00.00', 'EMPENHOS EM LIQUIDACAO', 'REGISTRA O SOMATORIO DAS DESPESAS  CUJO FATO GERADOR TENHA OCORRIDO, TENDO INICIADO E NAO CONCLUIDO O PROCESSO DE LIQUIDACAO DA DESPESA ORCAMENTARIA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.03.00.00.00', 'EMPENHOS LIQUIDADOS A PAGAR', 'REGISTRA O VALOR DOS EMPENHOS APOS VERIFICACAO DO DIREITO ADQUIRIDO PELO CREDOR OU ENTIDADE BENEFICIARIA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.04.00.00.00', 'EMPENHOS PAGOS', 'REGISTRA O MONTANTE DOS VALORES PAGOS, CONTROLADOS POR NOTA DE EMPENHO E SUBITEM.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.05.00.00.00', 'EMPENHOS A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS', 'REGISTRA O MONTANTE DOS VALORES A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS, CONTROLADOS POR NOTA DE EMPENHO E SUBITEM.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.06.00.00.00', 'EMPENHOS EM LIQUIDACAO INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS', 'REGISTRA O MONTANTE DOS VALORES EM LIQUIDACAO INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS, CONTROLADOS POR NOTA DE EMPENHO E SUBITEM.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.07.00.00.00', 'EMPENHOS LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS', 'REGISTRA O MONTANTE DOS VALORES LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS, CONTROLADOS POR NOTA DE EMPENHO E SUBITEM.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.10.00.00.00', 'ANULACAO DE EMPENHOS', 'REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA ORCAMENTARIA  A DOTACAO CORRESPONDENTE.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.11.00.00.00', 'CANCEL. DE EMPENHO POR FALTA DE DISPON. CAIXA', 'REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA  ORCAMENTARIA A DOTACAO CORRESPONDENTE POR FALTA DE DISPONIBILIDADE DE CAIXA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.04.01.00.00.00', 'CONCURSO', 'REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCURSO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.04.02.00.00.00', 'CONVITE', 'REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO-CONVITE.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.04.03.00.00.00', 'TOMADA DE PRECOS', 'REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO - TOMADA DE PRECOS.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.04.04.00.00.00', 'CONCORRENCIA', 'REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO - CONCORRENCIA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.04.06.00.00.00', 'DISPENSA DE LICITAÇAO', 'REGISTRA O VALOR DO EMPENHOS A LIQUIDAR POR DISPENSA DE LICITACAO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.04.07.00.00.00', 'LICITACAO INEXIGIVEL', 'REGISTRA O VALOR DO EMPENHOS A LIQUIDAR, CONTROLADOS POR INEXIGIBILIDADE DE LICITACAO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.04.08.00.00.00', 'NAO APLICAVEL', 'REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, ONDE NAO SE APLICA A LICITACAO, DENTRE OS QUAIS CABE DESTACAR: PESSOAL E ENCARGOS SOCIAIS, TRANSFERENCIAS CONSTITUCIONAIS, TRANSFERENCIAS VOLUNTARIAS, AMORTIZACAO DA DIVIDA E RESSARCIMENTO E RESTITUICOES.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.04.09.00.00.00', 'SUPRIMENTOS DE FUNDOS', 'REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR DESTINADOS A ATENDER SUPRIMENTOS DE FUNDOS, NA FORMA DA LEGISLACAO EM VIGOR.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.04.11.00.00.00', 'CONSULTA', 'REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS NA MODALIDADE DE CONSULTA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.04.12.00.00.00', 'PREGAO', 'REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS NA MODALIDADE DE PREGAO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.05.01.00.00.00', 'CONCURSO', 'REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCURSO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.05.02.00.00.00', 'CONVITE', 'REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, CONTROLADOS POR MODALIDADE DE LICITACAO-CONVITE.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.05.03.00.00.00', 'TOMADA DE PRECOS', 'REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, CONTROLADOS POR MODALIDADE DE LICITACAO - TOMADA DE PRECOS.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.05.04.00.00.00', 'CONCORRENCIA', 'REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, CONTROLADOS POR MODALIDADE DE LICITACAO - CONCORRENCIA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.05.06.00.00.00', 'DISPENSA DE LICITAÇAO', 'REGISTRA O VALOR DO EMPENHOS EM LIQUIDAÇÃO POR DISPENSA DE LICITACAO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.05.07.00.00.00', 'LICITACAO INEXIGIVEL', 'REGISTRA O VALOR DO EMPENHOS EM LIQUIDAÇÃO, CONTROLADOS POR INEXIGIBILIDADE DE LICITACAO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.05.08.00.00.00', 'NAO APLICAVEL', 'REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, ONDE NAO SE APLICA A LICITACAO, DENTRE OS QUAIS CABE DESTACAR: PESSOAL E ENCARGOS SOCIAIS, TRANSFERENCIAS CONSTITUCIONAIS, TRANSFERENCIAS VOLUNTARIAS, AMORTIZACAO DA DIVIDA E RESSARCIMENTO E RESTITUICOES.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.05.09.00.00.00', 'SUPRIMENTOS DE FUNDOS', 'REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO DESTINADOS A ATENDER SUPRIMENTOS DE FUNDOS, NA FORMA DA LEGISLACAO EM VIGOR.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.05.11.00.00.00', 'CONSULTA', 'REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, CONTROLADOS NA MODALIDADE DE CONSULTA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.05.12.00.00.00', 'PREGAO', 'REGISTRA O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, CONTROLADOS NA MODALIDADE DE PREGAO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.06.01.00.00.00', 'CONCURSO', 'REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCURSO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.06.02.00.00.00', 'CONVITE', 'REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONVITE.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.06.03.00.00.00', 'TOMADA DE PRECOS', 'REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-TOMADA DE PRECOS .', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.06.04.00.00.00', 'CONCORRENCIA', 'REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCORRENCIA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.06.07.00.00.00', 'LICITACAO INEXIGIVEL', 'REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR INEXIGIBILIDADE DE LICITACAO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.06.08.00.00.00', 'NAO APLICAVEL', 'REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, ONDE NAO SE APLICA A LICITACAO, DENTRE OS QUAIS CABE DESTACAR: PESSOAL E ENCARGOS SOCIAIS, TRANSFERENCIAS CONSTITUCIONAIS, TRANSFERENCIAS VOLUNTARIAS, AMORTIZACAO DA DIVIDA E RESSARCIMENTO E RESTITUICOES.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.06.09.00.00.00', 'SUPRIMENTOS DE FUNDOS', 'REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS DESTINADOS A ATENDER SUPRIMENTOS DE FUNDOS, NA FORMA DA LEGISLACAO EM VIGOR.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.06.11.00.00.00', 'CONSULTA', 'REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONSULTA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.06.12.00.00.00', 'PREGAO', 'REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-PREGAO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.07.01.00.00.00', 'RESTOS A PAGAR A LIQUIDAR', 'REGISTRA O VALOR DOS EMPENHOS DE RESTOS A PAGAR INSCRITOS NO  ENCERRAMENTO DO EXERCICIO FINANCEIRO DE EMISSAO DA NOTA DE EMPENHO E TRANSFERIDOS AUTOMATICAMENTE DA CONTA 292410505.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.07.02.00.00.00', 'RESTOS A PAGAR LIQUIDADOS - NO EXERCICIO CORRENTE', 'REGISTRA O VALOR DOS RESTOS A PAGAR, CONTROLADOS POR  BENEFICIARIO LIQUIDADOS.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.07.03.00.00.00', 'RESTOS A PAGAR PAGOS - CONTROLE POR CNPJ', 'REGISTRA O VALOR DOS RESTOS A PAGAR PAGOS, CONTROLADOS POR  BENEFICIARIO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.07.04.00.00.00', 'INSCRICAO DE RESTOS A PAGAR', 'REGISTRA O VALOR DOS EMPENHOS DE RESTOS A PAGAR INSCRITOS NO  ENCERRAMENTO DO EXERCICIO FINANCEIRO DE EMISSAO DA NOTA DE EMPENHO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.07.05.00.00.00', 'RESTOS A PAGAR LIQUIDADOS - NO EXERCICIO  ANTERIOR', 'REGISTRAR O VALOR DOS RESTOS A PAGAR LIQUIDADOS (A PAGAR) CONTROLADOS POR NÚMERO DE EMPENHO. O SALDO DESTA CONTA É ORIGINADO DA LEITURA DO SALDO EXISTENTE NA CONTA 2.9.2.4.1.04.02, SENDO TRANSPORTADO NO EXERCÍCIO POSTERIOR PARA A CONTA 2.9.2.3.1.05.08. SE', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.07.06.00.00.00', 'CANCELAMENTO DE RESTOS A PAGAR  NAO PROCESSADOS', 'REGISTRA OS VALORES DOS RESTOS A PAGAR CANCELADOS PELA UNIDADE  GESTORA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.07.07.00.00.00', 'RESTOS A PAGAR PROCESSADOS PAGOS - CONTROLE POR NE', 'REGISTRA O VALOR DOS RESTOS A PAGAR PAGOS, CONTROLADOS POR  NUMERO  DE EMPENHO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.07.08.00.00.00', 'CANCELAMENTO DE RESTOS A PAGAR PROCESSADOS', 'REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS CANCELADOS.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.07.99.00.00.00', 'OUTRAS INSCRICOES DE RESTOS A PAGAR', 'REGISTRA A CONTRAPARTIDA DOS LANCAMENTOS EFETUADOS EM EMPENHOS DE RESTOS A PAGAR CONTROLADOS POR BENEFICIARIO, POR OCASIAO DO ENCERRAMENTO DO EXERCICIO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.09.01.00.00.00', 'VALORES A LIQUIDAR', 'REGISTRA O MONTANTE DOS VALORES A LIQUIDAR, A SEREM PAGOS, POR BENEFICIARIOS.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.09.02.00.00.00', 'VALORES EM LIQUIDACAO', 'REGISTRA O SOMATORIO DAS DESPESAS  CUJO FATO GERADOR TENHA OCORRIDO, TENDO INICIADO E NAO CONCLUIDO O PROCESSO DE LIQUIDACAO DA DESPESA ORCAMENTARIA, CONTROLADOS POR BENEFICIARIO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.09.03.00.00.00', 'VALORES LIQUIDADOS A PAGAR', 'REGISTRA O MONTANTE DOS VALORES LIQUIDADOS, A SEREM PAGOS, POR BENEFICIARIOS.  O SALDO DESTA CONTA EM 31 DE DEZEMEBRO SERA TRANSFERIDO PARA A CONTA 532110000 - RP PROCESSADO INSCRITO EM 01 DE JANEIRO DO EXERCICIO SUBSEQUENTE.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.09.04.00.00.00', 'VALORES PAGOS', 'REGISTRA O MONTANTE DOS VALORES PAGOS, CONTROLADOS POR BENEFICIARIOS.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.09.05.00.00.00', 'EMPENHOS INSCRITOS EM RESTOS A PAGAR', 'REGISTRA O MONTANTE DOS VALORES DOS EMPENHOS INSCRITOS EM RESTOS A PAGAR, CONTROLADOS POR BENEFICIARIO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.1.0.00.00.00.00.00', 'RP NÃO PROCESSADOS A LIQUIDAR', 'Registra o valor dos RP não processados ainda não liquidados.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.2.0.00.00.00.00.00', 'RP NÃO PROCESSADOS EM LIQUIDAÇÃO', 'Registra o valor dos RP não processados ainda não liquidados cujo fato gerador já ocorreu.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.3.0.00.00.00.00.00', 'RP NÃO PROCESSADOS LIQUIDADOS A PAGAR', 'Registra o valor dos RP não processados, liquidados após sua inscrição e ainda não pagos.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.4.0.00.00.00.00.00', 'RP NÃO PROCESSADOS PAGOS', 'Registra o valor dos RP não processados, liquidados após sua inscrição e pagos.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.5.0.00.00.00.00.00', 'RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS', 'Registra o valor de restos a pagar não processados a liquidar, bloqueado por decreto.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.6.0.00.00.00.00.00', 'RP NÃO PROCESSADOS TRANSFERIDOS', 'Registra o valor da transferência de restos a pagar não processados pela desincorporação de saldos decorrentes de transformação, cisão, fusão e extinção de órgãos ou UG.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.7.0.00.00.00.00.00', 'RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO', 'Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 631100000 e 631200000.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.9.1.00.00.00.00.00', 'POR INSUFICIENCIA DE RECURSOS', 'REGISTRA O VALOR DOS RESTOS A PAGAR NAO PROCESSADOS  CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO POR INSUFICIENCIA DE RECURSOS FINANCEIROS.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.9.9.00.00.00.00.00', 'OUTROS CANCELAMENTOS DE RP', 'REGISTRA O VALOR DOS RESTOS A PAGAR NAO PROCESSADOS  CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO, EXCETO OS CANCELADOS POR INSUFICIENCIA DE RECURSOS FINANCEIROS.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.1.0.00.00.00.00.00', 'RP PROCESSADOS A PAGAR', 'Registra o valor dos RP processados e não pagos.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.2.0.00.00.00.00.00', 'RP PROCESSADOS PAGOS', 'Registra o valor dos RP processados pagos.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.6.0.00.00.00.00.00', 'RP PROCESSADOS TRANSFERIDOS', 'Registra o valor da transferência de restos a pagar pela desincorporação de saldos decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.7.0.00.00.00.00.00', 'RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO', 'Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 632100000.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.9.1.01.00.00.00.00', 'CANCELAMENTO DE RP PROCESSADOS - NE', 'REGISTRA O VALOR DE RESTOS A PAGAR PROCESSADOS CANCELADOS NO EXERCICIO SEGUINTE, CONTROLADOS POR NOTA DE EMPENHO, COM A RESPECTIVA BAIXA NO PASSIVO FINANCEIRO.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.9.1.02.00.00.00.00', 'AJUSTE DE CONTROLE RP DE EXERC ANTERIORES', 'REGISTRA O VALOR DO AJUSTE DE RESTOS A PAGAR PROCESSADOS CANCELADOS SEM PASSIVO CORRESPONDENTE.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.9.9.00.00.00.00.00', 'OUTROS CANCELAMENTOS DE RP', 'REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS  CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO, EXCETO OS CANCELADOS POR INSUFICIENCIA DE RECURSOS FINANCEIROS OU POR INSCRICAO INDEVIDA.', 'C', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.0.00.00', 'DIVIDA ATIVA TRIBUTARIA', 'COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA INSCRITOS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.04.00', 'ENCARGOS SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER', 'COMPREENDE OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.2.03.00', 'ADIANTAMENTOS A UNIDADES E ENTIDADES', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.00.00', 'ALMOXARIFADO - CONSOLIDACAO', 'COMPREENDE O VALOR DOS MATERIAIS DESTINADOS AO CONSUMO INTERNO DA UNIDADE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.02.00', 'TRIBUTOS A RECUPERAR / COMPENSAR', 'COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR / COMPENSAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.07.00', 'BENS MOVEIS EM ANDAMENTO', 'COMPREENDE OS VALORES DE BENS MOVEIS EM ANDAMENTO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.03.00', 'EMPRESTIMOS INTERNOS - EM CONTRATOS', 'COMPREENDE OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.5.0.0.00.00', 'OBRIGACOES DE REPARTICAO A OUTROS ENTES', 'COMPREENDE OS VALORES ARRECADADOS DE IMPOSTOS E OUTRAS RECEITAS A SEREM REPARTIDOS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.37.00', 'SUBVENCOES A PAGAR', 'COMPREENDE O SOMATORIO DAS SUBVENCOES A PAGAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.23.00', 'AUXILIOS FINANCEIROS A PESQUISADORES', 'COMPREENDE AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.23.00', 'AUXILIOS FINANCEIROS A PESQUISADORES', 'COMPREENDE AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.1.02.00', 'CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)', 'COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.04.00', 'ENCARGOS - FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.5.0.00.00', 'PROVISAO PARA REPARTICAO DE CREDITOS A LONGO PRAZO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CREDITOS TRIBUTARIOS E NAO TRIBUTARIOS RECONHECIDOS NO LANCAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERACAO, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. NA ARRECADACAO, ESTA PROVISAO SERA REVERTIDA EM CONTA ESPECIFICA DE PASSIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.15.00', 'AUXILIOS FINANCEIROS A PESQUISADORES', 'COMPREENDE AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.0.00.00', 'OUTRAS RESERVAS DE CAPITAL', 'COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.0.0.00.00', 'ENCARGOS PATRONAIS', 'COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS SERVIDORES E EMPREGADOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO, BEM COMO CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA E AINDA OUTRAS CONTRIBUICOES PATRONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.4.1.00.00', 'CONTRIBUICOES SOCIAIS GERAIS - CONSOLIDACAO', 'COMPREENDE OS ENCARGOS PATRONAIS RELATIVAO AO SALARIO EDUCACAO E AS CONTRIBUICOES COMPULSORIAS DOS EMPREGADORES SOBRE A FOLHA DE SALARIOS, DESTINADOS AS ENTIDADES PRIVADAS DE SERVICO SOCIAL E DE FORMACAO PROFISSIONAL, VINCULADAS AO SISTEMA SINDICAL, TAIS COMO SESI, SENAI, SESC E SENAC. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.9.0.00.00', 'OUTRAS APOSENTADORIAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS APOSENTADORIAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.02.00', 'RESTITUICAO DE RECEITAS FEDERAIS', 'COMPREENDE O VALOR TOTAL DE RESTITUICAO DE RECEITAS FEDERAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.4.0.0.00.00', 'TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS, DO QUAL O ENTE TRANSFERIDOR NAO PARTICIPE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.00', 'SERVICOS DE CONSULTORIA', 'REGISTRA DESPESAS COM SERVICOS DE CONSULTORIA DECORRENTES DE DELEGACAO AOS ESTADOS E AO DISTRITO FEDERAL. ', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.0.00.00', 'CONTRIBUICOES SOCIAIS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO, ENTRE ELAS O PIS/PASEP, CSLL E COFINS, ETC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.0.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS DE INSTITUICOES FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.0.0.00.00', 'INCENTIVOS', 'COMPREENDE OS INCENTIVOS FINANCEIROS CONCEDIDOS RELATIVOS A EDUCACAO, A CIENCIA E A CULTURA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.0.0.0.0.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA', 'COMPREENDE O AUMENTO NO BENEFICIO ECONOMICO DURANTE O PERIODO CONTABIL SOB A FORMA DE ENTRADA DE RECURSO OU AUMENTO DE ATIVO OU DIMINUICAO DE PASSIVO, QUE RESULTE EM AUMENTO DO PATRIMONIO LIQUIDO E QUE NAO SEJAM PROVENIENTES DE APORTE DOS PROPRIETARIOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.4.01.00', 'IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL', 'COMPREENDE A VPA COM O IMPOSTO S/PROPRIEDADE TERRITORIAL RURAL, DE COMPETENCIA DA UNIAO. TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL POR NATUREZA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.1.06.00', 'CONTRIBUICOES RURAIS', 'COMPREENDE A VPA PROVENIENTE DE CONTRIBUICOES RURAIS, TAIS COMO A INDUSTRIAL, CONTRIBUICAO SOBRE A PROPRIEDADE RURAL, O ADICIONA DA CONTRIBUICAO PREVIDENCIARIA E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.58.00', 'GARANTIAS E AVAIS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE GARANTIAS E AVAIS NAS OPERACOES DE CREDITO. FATO GERADOR: CONCESSAO DE GARANTIAS E AVAIS, DE NATUREZA NAO-FINANCEIRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.57.00', 'PREST. DE SERV. PELO BANCO CENTRAL DO BRASIL', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE DA PRESTACAO DE SERVICOS DE AUTORIDADE MONETARIA AO SETOR BANCARIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.37.00', 'MULTAS JUR.MORA DIV.ATIVA DO RGPS', 'COMPREENDE O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DAS CONTRIBUICOES DOS EMPREGADORES E TRABALHADORES PARA A SEGURIDADE SOCIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.01.00', 'VPA COM OPERACOES DE AUTORIDADE MONETARIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES DE AUTORIDADE MONETARIA .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.01.00', 'GARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO PAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.04.00', 'CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.01.00', 'GARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.0.0.0.00.00', 'OUTROS CONTROLES', 'COMPREENDE DE CONTROLES NAO ESPECIFICADOS ANTERIORMENTE NOS GRUPOS DESSA CLASSE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.03.00', 'INFRA-ESTRUT.DE IRRIGACAO/USO COMUM INTERNA', 'COMPREENDE OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.21.00', 'CONTROLE DE VALORES (NR.REF.DA GRU)', 'COMPREENDE OS VALORES RELATIVOS AOS CONTROLES POR NUMERO DE REFERENCIADA GRU.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.00', 'CONTRATOS DE OBRIGACOES INTERNAS', 'REGISTRA A APROPRIACAO DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.03.00', 'CONTRATOS DE ALUGUEIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.12.00', 'EXECUCAO DE CONTRATO DE GESTAO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DOS CONTRATOS DE GESTAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.12.00', 'EXECUCAO DE CONTRATO DE GESTAO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DOS CONTRATOS DE GESTAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.0.00.00.00.00.00', 'MOVIMENTAÇÃO DE CRÉDITOS RECEBIDOS', 'Compreende o somatório dos valores dos recebimentos de créditos orçamentários através de destaque, provisão ou por fusão, cisão ou extinção de unidades.', NULL, 'N', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.0.00.00.00.00.00', 'OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA', 'Compreende o somatório dos valores das despesas pré-empenhadas e empenhadas por detalhamento específico.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.06.00', 'FGTS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.10.00', 'Locações', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.03.00', 'ADIANTAMENTOS A UNIDADES E ENTIDADES', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.2.00.00', 'TRIBUTOS A RECUPERAR / COMPENSAR - INTRA OFSS', 'COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR/ COMPENSAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.00', 'CREDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL', 'COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.01.00', 'CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS', 'COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.07.00', 'DERIVATIVOS', 'COMPREENDE OS CREDITOS RELATIVOS A OPERACOES COM DERIVATIVOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.0.0.00.00', 'ESTOQUES', 'COMPREENDE O VALOR DOS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORACAO PELA ENTIDADE COM O OBJETIVO DE VENDA OU UTILIZACAO PROPRIA NO CURSO NORMAL DAS ATIVIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.4.0.00.00', 'MATERIAS-PRIMAS', 'COMPREENDE O ESTOQUE DE MATERIAS-PRIMAS QUE SERA UTILIZADO NO PROCESSO PRODUTIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.05.00', 'IMPORTACOES EM ANDAMENTO', 'COMPREENDE O VALOR DAS IMPORTACOES EM ANDAMENTO DE BENS DE ESTOQUE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.4.0.00.00', 'ALUGUEIS PAGOS A APROPRIAR', 'COMPREENDE OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.02.00', 'TRIBUTOS A RECUPERAR / COMPENSAR', 'COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR / COMPENSAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.99.00', 'DEMAIS VPD A APROPRIAR', 'COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.2.99.00', 'DEMAIS VPD A APROPRIAR', 'COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.08.00', 'ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR', 'COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.01.00', 'INSS A PAGAR', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.05.00', 'OPERACOES DO BACEN', 'COMPREENDE OS VALORES DE OPERACOES DO BACEN', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.04.00', 'OPERACOES COMPROMISSADAS - BACEN', 'COMPREENDE OS VALORES DAS OPERACOES COMPROMISSADAS - BACEN', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.04.00', 'OPERACOES COMPROMISSADAS - BACEN', 'COMPREENDE OS VALORES DAS OPERACOES COMPROMISSADAS - BACEN', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.02.00', 'ENCARGOS - EMPRESTIMOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.0.00.00', 'OBRIGACOES FISCAIS A CURTO PRAZO COM OS MUNICIPIOS', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA MUNICIPAL COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.0.00.00', 'PROVISOES PARA RISCOS FISCAIS A CURTO PRAZO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUACOES FISCAIS, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.03.00', 'DEPOSITOS JUDICIAIS', 'REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL E DEPOSITOS PARA RECURSOS JUDICIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.04.00', 'DEPOSITOS NAO JUDICIAIS', 'REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS, EXCETO DEPOSITOS JUDICIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.23.00', 'AUXILIOS FINANCEIROS A PESQUISADORES', 'COMPREENDE AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.29.00', 'RESULTADO NEGATIVO DO BANCO CENTRAL', 'COMPREENDE OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL A SER REEMBOLSADO PELO TESOURO NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.00.00', 'OUTRAS OBRIGACOES A CURTO PRAZO-INTRA OFSS', 'COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO CURTO PRAZO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.05.00', 'CONVENIOS A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.13.00', 'PRECATORIOS DE TERCEIROS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.01.00', 'INDENIZACOES E RESTITUICOES', 'COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.3.0.00.00', 'BENEFICIOS ASSISTENCIAIS A PAGAR', 'COMPREENDE AS OBRIGACOES A LONGO PRAZO RELATIVAS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.1.01.00', 'INSS A PAGAR', 'COMPREENDE OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.01.00', 'EMPRESTIMOS INTERNOS - EM TITULOS', 'COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.02.00', 'ENCARGOS - EMPRESTIMOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.2.03.00', 'PROVISOES DO FCVS', 'REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, OS VALORES ATUARIAIS DOS PASSIVOS DO FUNDO DE COMPENSACAO E VARIACOES SALARIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.0.00.00', 'OUTRAS OBRIGACOES A LONGO PRAZO', 'COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.01.00', 'INDENIZACOES E RESTITUICOES', 'COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.09.00', 'TERMO DE COMPROMISSO A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.12.00', 'BOLSAS PARA ESTUDOS', 'COMPREENDE AS OBRIGACOES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.0.0.0.00.00', 'PATRIMONIO LIQUIDO', 'COMPREENDE O VALOR RESIDUAL DOS ATIVOS DEPOIS DE DEDUZIDOS TODOS OS PASSIVOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.2.0.00.00', 'ALIENACAO DE PARTES BENEFICIARIAS', 'COMPREENDE O PRODUTO DA ALIENACAO DE PARTES BENEFICIARIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.0.0.00.00', 'RESERVAS DE LUCROS', 'COMPREENDE AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DAS ENTIDADES PARA FINALIDADES ESPECIFICAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.6.0.00.00', 'RESERVA DE LUCROS A REALIZAR', 'COMPREENDE A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.9.0.00.00', 'OUTRAS RESERVAS', 'COMPREENDE OUTRAS RESERVAS QUE NAO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.0.00.00', 'LUCROS E PREJUIZOS ACUMULADOS', 'COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.5.00.00', 'LUCROS E PREJUIZOS ACUMULADOS - INTER OFSS - MUNICIPIO', 'COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.02.00', 'OUTRAS DESPESAS VARIAVEIS - PESSOAL MILITAR', 'COMPREENDE AS DESPESAS ORCAMENTARIAS EVENTUAIS, DE NATUREZA REMUNERATORIA, DEVIDAS EM VIRTUDE DO EXERCICIO DA ATIVIDADE MILITAR, EXCETO AQUELAS CLASSIFICADAS EM ELEMENTO DE DESPESAS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.4.00.00', 'ENCARGOS PATRONAIS - RGPS - INTER OFSS - ESTADO', 'COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSAO NAO INVESTIDO EM CARGO EFETIVO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.5.00.00', 'ENCARGOS PATRONAIS - RGPS - INTER OFSS - MUNICIPIO', 'COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSAO NAO INVESTIDOS EM CARGO EFETIVO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.0.00.00', 'OUTROS ENCARGOS PATRONAIS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS AOS ENCARGOS PATRONAIS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.2.00.00', 'CUSTO DE PRODUTOS VENDIDOS - PESSOAL E ENCARGOS - INTRA OFSS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.2.00.00', 'CUSTO DE SERVICOS PRESTADOS - PESSOAL E ENCARGOS - INTRA OFSS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.0.0.00.00', 'BENEFICIOS DE PRESTACAO CONTINUADA', 'COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.9.0.00.00', 'OUTROS BENEFICIOS DE PRESTACAO CONTINUADA', 'COMPREENDEM OUTROS BENEFICIOS DE PRESTACAO CONTINUADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.10.00', 'SALARIO-FAMILIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.4.00.00', 'DISTRIBUICAO DE MATERIAL GRATUITO - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA DISTRIBUICAO DE MATERIAL GRATUITO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.0.0.00.00', 'SERVICOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS FORNECIDA A ENTIDADE GOVERNAMENTAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.02.00', 'PERICIAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR PROFISSIONAIS TECNICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.05.00', 'PUBLICIDADE', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.09.00', 'SERVICOS DE ALIMENTACAO', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE FORNECIMENTO DE ALIMENTACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.08.00', 'SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.4.0.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA MOBILIARIA EXTERNA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.0.00.00', 'JUROS E ENCARGOS EM INDENIZACOES E RESTITUICOES', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES E RESTITUICOES REFERENTES A JUROS E ENCARGOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.09.00', 'MOVIMENTO DE FUNDOS A CREDITOS - MOVIMENTO DE FUNDOS PROPRIOS', 'COMPREENDE O SOMATORIO DOS SALDOS CREDORES INCORPORADOS POR INTEGRACAO DE BALANCETES, FUSAO, CISAO MUDANCA DE MODALIDADE DE USO PARCIAL PARA TOTAL DE ORGAOS NO SIAFI, AGREGADOS EM PATRIMONIAIS E FINANCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.5.0.0.00.00', 'TRANSFERENCIAS A CONSORCIOS PUBLICOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS A CONSORCIOS PUBLICOS, DOS QUAIS O ENTE TRANSFERIDOR PARTICIPE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.00', 'MATERIAL DE CONSUMO', 'REGISTRA AS DESPESAS COM MATERIAL DE CONSUMO DECORRENTES DE DELEGACAO AOS ESTADOS E AO DISTRITO FEDERAL. ', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.00', 'PASSAGENS E DESPESAS COM LOCOMOCAO', 'REGISTRA AS DESPESAS COM PASSAGENS E LOCOMOCAO DECORRENTES DE DELEGACAO AOS ESTADOS E AO DISTRITO FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.00', 'DIARIAS - CIVIL', 'COMPREENDE AS DESPESAS COM DIARIAS - CIVIL DECORRENTES DE DELEGACAO AOS ESTADOS E AO DISTRITO FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.00', 'PASSAGENS E DESPESAS COM LOCOMOCAO', 'COMPREENDE AS DESPESAS COM PASSAGENS E LOCOMOCAO DECORRENTES DE DELEGACAO AOS ESTADOS E AO DISTRITO FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.2.0.00.00', 'EXECUCAO ORCAMENTARIA DELEGADA A CONSORCIOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIA DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS CONSORCIOS PUBLICOS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.0.0.00.00', 'CONTRIBUICOES', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICOES SOCIAIS, ECONOMICAS E OUTRAS, DECORRENTES DA INTERVENCAO DO ESTADO ( UNIAO, ESTADOS, DISTRITO FEDERAL E MUNICIPIOS) NO DOMINIO ECONOMICO E DE INTERESSE DA CATEGORIA DE PROFISSIONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.0.00.00', 'CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.1.0.00.00', 'PREMIACOES CULTURAIS', 'COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CULTURAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.1.0.00.00', 'PARTICIPACOES DE DEBENTURES', 'COMPREENDE AS PARTICIPACOES DE DEBENTURES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.1.0.00.00', 'VPD DE PROVISAO PARA RISCOS TRABALHISTAS', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE RECLAMACOES TRABALHISTAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.4.0.00.00', 'AMORTIZACAO DE AGIO EM INVESTIMENTOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZACAO DE AGIO EM INVESTIMENTOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.2.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.2.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.5.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.9.0.00.00', 'OUTROS IMPOSTOS', 'COMPREENDE OS DEMAIS IMPOSTOS NAO CLASSIFICADOS NOS GRUPOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.00.00', 'TAXAS PELA PRESTACAO DE SERVICOS - INTER OFSS - ESTADO', 'COMPREENDE AS TAXAS COBRADAS PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES TEM COMO FATO GERADOR A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.9.0.00.00', 'OUTRAS CONTRIBUICOES DE MELHORIA', 'COMPREENDE O VALOR DE OUTRAS CONTRIBUICOES DE MELHORIAS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.01.00', 'CONTRIBUICOES PATRONAIS E DA EMPRESA AO RGPS', 'COMPREENDE A VPA DECORRENTE DAS CONTRIBUICOES PATRONAIS, DAS EMPRESAS E EQUIPADAS PARA O REGIME GERAL DA PREVIDENCIA SOCIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.1.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.2.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.4.00.00', 'CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR - INTER OFSS - ESTADO', 'REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.4.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.1.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.4.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.00.00', 'CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO - CONSOLIDACAO', 'COMPREENDEM AS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO, COMO POR EXEMPLO, A CIDE-COMBUSTIVEL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.03.00', 'CONTRIBUICOES DESENV.APERF.ATIVID.FISCALIZ.', 'COMPREENDE A VPA PROVENIENTE DAS CONTRIBUICOES DESTINADAS AODESENVOLVIMENTO E APERFEICOAMENTO DE ATIVIDADES DE FISCALIZACAO. DES-TINAM-SE A FORNECER RECURSOS PARA FINANCIAR O REAPARELHAMENTO E O REE-QUIPAMENTO DA SECRETARIA DA RECEITA FEDERAL - SRF, E A ATENDER AOS DE-MAIS ENCARGOS ESPECIFICOS INERENTES AO DESENVOLVIMENTO E APERFEICOA-MENTO DAS ATIVIDADES DE FISCALIZACAO DOS TRIBUTOS FEDERAIS. VINCULADASAO FUNDO DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCA-LIZACAO - FUNDAF.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.03.00', 'CONTRIBUICOES DESENV.APERF.ATIVID.FISCALIZ.', 'COMPREENDE A VPA PROVENIENTE DAS CONTRIBUICOES DESTINADAS AODESENVOLVIMENTO E APERFEICOAMENTO DE ATIVIDADES DE FISCALIZACAO. DES-TINAM-SE A FORNECER RECURSOS PARA FINANCIAR O REAPARELHAMENTO E O REE-QUIPAMENTO DA SECRETARIA DA RECEITA FEDERAL - SRF, E A ATENDER AOS DE-MAIS ENCARGOS ESPECIFICOS INERENTES AO DESENVOLVIMENTO E APERFEICOA-MENTO DAS ATIVIDADES DE FISCALIZACAO DOS TRIBUTOS FEDERAIS. VINCULADASAO FUNDO DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCA-LIZACAO - FUNDAF.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.03.00', 'CONTRIBUICOES DESENV.APERF.ATIVID.FISCALIZ.', 'COMPREENDE A VPA PROVENIENTE DAS CONTRIBUICOES DESTINADAS AODESENVOLVIMENTO E APERFEICOAMENTO DE ATIVIDADES DE FISCALIZACAO. DES-TINAM-SE A FORNECER RECURSOS PARA FINANCIAR O REAPARELHAMENTO E O REE-QUIPAMENTO DA SECRETARIA DA RECEITA FEDERAL - SRF, E A ATENDER AOS DE-MAIS ENCARGOS ESPECIFICOS INERENTES AO DESENVOLVIMENTO E APERFEICOA-MENTO DAS ATIVIDADES DE FISCALIZACAO DOS TRIBUTOS FEDERAIS. VINCULADASAO FUNDO DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCA-LIZACAO - FUNDAF.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.03.00', 'EXPLORACAO DO PATRIMONIO IMOBILIARIO', 'COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO, POR TERCEIROS, DE BENS IMOVEIS PERTENCENTES AO SETOR PUBLICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.57.00', 'PREST. DE SERV. PELO BANCO CENTRAL DO BRASIL', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE DA PRESTACAO DE SERVICOS DE AUTORIDADE MONETARIA AO SETOR BANCARIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.63.00', 'SERVICOS FINANCEIROS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM SERVICOS FINANCEIROS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.30.00', 'CONCESSAO E PERMISSAO. - DIR. USO DE BENS PUB', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.32.00', 'SERVICOS DE TRANSPORTE', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE TRANSPORTE RODOVIARIO, FERROVIARIO, HIDROVIARIO, AEREO, ESPECIAIS E TARIFA DE PEDAGIO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.57.00', 'PREST. DE SERV. PELO BANCO CENTRAL DO BRASIL', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE DA PRESTACAO DE SERVICOS DE AUTORIDADE MONETARIA AO SETOR BANCARIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.63.00', 'SERVICOS FINANCEIROS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM SERVICOS FINANCEIROS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.35.00', 'SERVICOS DE SAUDE', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE SAUDE: HOSPITALARES GERAIS OU ESPECIALIZADOS, MATERNIDADE, CENTRO DE REABILITACAO, ASSISTENCIA MEDICO-ODONTOLOGICA (INCLUSIVE AMBULATORIAL), SAUDE PUBLICA, ETC...', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.24.00', 'CONCESSAO E PERMISSAO - SERV. DE TRANSPORT', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.30.00', 'CONCESSAO E PERMISSAO. - DIR. USO DE BENS PUB', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.37.00', 'SERVICOS DE METROLOGIA E CERTIFICACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA E CERTIFICACAO PRESTADOS.VPA DE SERVICOS METROLOGICOS EM GERAL, TAIS COMO AFERICAO DE MEDIDAS E INSTRUMENTOS DE MEDIR, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC..', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.0.00.00', 'JUROS E ENCARGOS DE MORA SOBRE CREDITOS TRIBUTARIOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE APLICADA EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE CREDITOS TRIBUTARIOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS, TAL COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.99.00', 'OUTROS JUROS E ENCARGOS DE MORA', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE OUTROS JUROS E ENCARGOS DE MORA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.4.0.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS EXTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.10.00', 'OUTROS MOVIMENTOS DE FUNDOS A DEBITO', 'COMPREENDE O VALOR DA TRANSFERENCIA DE AJUSTES COM SALDO CREDOR OU DEVEDOR, ENTRE UG DE EMPRESAS INTEGRANTES DO SIAFI E OUTROS MOVIMENTOS DE FUNDO A DEBITO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.13.00', 'TRANFERENCIAS RECEBIDAS DE BENS MOVEIS', 'COMPREENDE O VALOR DOS BENS MOVEIS RECEBIDOS PELA UG DO PAIS OU EXTERIOR DECORRENTE DE TRANSFERENCIA DE OUTRA UG DO MESMO ORGAO, INDEPENDENTE DE EXECUCAO ORCAMENTARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.13.00', 'MULTAS PREVISTAS NA LEGIS.DEFESA DIR. DIFUSOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE DIREITOS DIFUSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.13.00', 'MULTAS PREVISTAS NA LEGIS.DEFESA DIR. DIFUSOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE DIREITOS DIFUSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.0.00.00', 'INDENIZACOES', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES DIVERSAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.1.00.00', 'INDENIZACOES - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES DIVERSAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.7.0.00.00', 'VPA DECORRENTE ALIENACAO BENS APREENDIDOS', 'COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS AUMENTATIVAS GERADAS PELA ALIENACAO DE MERCADORIAS, OBJETO DA PENA DE PERDIMENTO. O PRODUTO DA ARRECADACAO TEM A SEGUINTE DESTINACAO: 60% AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF E 40% AO FUNDO NACIONAL DE ASSISTENCIA SOCIAL - MINISTERIO DA PREVIDENCIA E ASSISTENCIA SOCIAL. AO FUNDO NACIONAL ANTIDROGA ­ FUNAD, PARA APLICACAO CONFORME LEGISLACAO EM VIGOR, QUANDO DA APREENSAO DE BENS, DIREITOS E VALORES OBJETO DO CRIME DE TRAFICO ILICITO DE SUBSTANCIAS INTORPECENTES OU DROGAS AFINS. (LEI 6.368 DE 21/10/76, LEI 7.460 DE 19/12/86, LEI 9.804 DE 30/06/99)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.00.00', 'VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.0.0.0.0.00.00', 'CONTROLES DEVEDORES', 'COMPREENDE AS CONTAS EM QUE SAO REGISTRADOS ATOS POTENCIAIS E CONTROLES ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.0.00.00', 'DIREITOS CONTRATUAIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.7.0.0.00.00', 'OUTROS CONTROLES DE RESPONSABILIDADES POR VALORES, TITULOS E BENS', 'COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DAS RESPONSABILIDADES POR VALORES, TITULOS E BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.06.00', 'CONTRATOS DE OBRIGACOES INTERNAS', 'REGISTRA A APROPRIACAO DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.12.00', 'EXECUCAO DE CONTRATO DE GESTAO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DOS CONTRATOS DE GESTAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.14.00', 'CONTRATOS DE OPERACOES DE CREDITO', 'COMPREENDE A EXECUCAO DAS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.6.01.00', 'REPASSE DE RESTITUICAO', 'REGISTRA OS VALORES DE REPASSES PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.1.0.00.00', 'EXECUCAO DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DO LIMITE ORCAMENTARIO NO OCPF', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.4.00.00', 'EXECUCAO DE EMISSAO DE GFIP', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA EMISSAO DE GFIPS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.01.00', 'LIMITES AUTORIZADOS', 'COMPREENDE O VALOR DOS LIMITES AUTORIZADOS NA EXECUCAO DO PLANO INTERNOESCRITURAL DO MINISTERIO DA MARINHA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.12.00', 'CONTROLE DISP. DE RECURSOS DA TRANSF. VOLUNT.', 'COMPREENDE, NA CONCEDENTE DA TRANSFERENCIA VOLUNTARIA - TV, OS INGRESSOS E SAIDAS DOS RECURSOS DA TV. A MOVIMENTACAO DOS RECURSOS DA CONTA BANCARIA SOMENTE OCORRERA VIA PORTAL SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.25.00', 'EXECUCAO DO CONTROLE DEVOLUCOES DE PAGTO DE BENEFICIOS', 'COMPREENDE OS VALORES REFERENTES AS DEVOLUCOES DE PAGAMENTOS DE BENEFICIOS PELA REDE BANCARIA POR MEIO DE MENSAGEM SPB PARA POSTERIOR REGISTRO DE ESTORNO DE DESPESA PELO INSS. O REGISTRO OCORRERA NA COFIN/STN PARA CONTROLE DE RESTABELECIMENTO DE COTAS ORCAMENTARIAS A PROGRAMAR,VISANDO POSSIBILITAR A PROGRAMACAO FINANCEIRA ENTRE O INSS E A COFIN/STN PARA A REALIZACAO DE NOVOS PAGAMENTOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.2.00.00', 'BENS E VALORES EM TRANSITO', 'COMPREENDE O MONTANTE DOS BENS E VALORES TRANSFERIDOS ENTRE UGS COM CONTROLE NA CONTA DE COMPENSACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.00.00.00.00.00', 'CREDITO UTILIZADO', 'Compreende o somatório dos valores referentes aos créditos orçamentários empenhados.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.06.01', 'Bancos Conta Movimento - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.0.0.0.00.00', 'ATIVO CIRCULANTE', 'COMPREENDE OS ATIVOS QUE ATENDAM A QUALQUER UM DOS SEGUINTES CRITERIOS: SEJAM CAIXA OU EQUIVALENTE DE CAIXA; SEJAM REALIZAVEIS OU MANTIDOS PARA VENDA OU CONSUMO DENTRO DO CICLO OPERACIONAL DA ENTIDADE; SEJAM MANTIDOS PRIMARIAMENTE PARA NEGOCIACAO; SEJAM REALIZAVEIS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.0.0.00.00', 'CAIXA E EQUIVALENTES DE CAIXA', 'COMPREENDE O SOMATORIO DOS VALORES EM CAIXA E EM BANCOS, BEM COMO EQUIVALENTES, QUE REPRESENTAM RECURSOS COM LIVRE MOVIMENTACAO PARA APLICACAO NAS OPERACOES DA ENTIDADE E PARA OS QUAIS NAO HAJA RESTRICOES PARA USO IMEDIATO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.0.00.00', 'CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL', 'COMPREENDE O SOMATORIO DOS VALORES DE CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.00.00', 'CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - CONSOLIDACAO', 'COMPREENDE O SOMATORIO DOS VALORES DE CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.03.00', 'CONTA UNICA - SUBCONTA INSS', 'COMPREENDE A MOVIMENTACAO FINANCEIRA DO INSS JUNTO AO BANCO CENTRAL DO BRASIL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.04.00', 'CONTA UNICA - SUBCONTA DIVIDA PUBLICA', 'COMPREENDE O VALOR DOS RECURSOS RESERVADOS NO BANCO CENTRAL A DISPOSICAO DA DIVIDA PUBLICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.00', 'BANCOS CONTA MOVIMENTO - DEMAIS CONTAS', 'COMPREENDE O SOMATORIO DAS DISPONIBILIDADES EXISTENTES EM OUTRAS CONTAS BANCARIAS, QUE NAO SEJAM A CONTA UNICA, AGREGADAS PELOS SUBITENS IDENTIFICATIVOS DOS BANCOS CORRESPONDENTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.30.00', 'REDE BANCARIA - ARRECADACAO', 'COMPREENDE O SOMATORIO DOS RECURSOS REFERENTES A RECEITAS ARRECADADAS E NAO RECOLHIDAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.00', 'APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA', 'COMPREENDE AS APLICACOES FINANCEIRAS DE ALTA LIQUIDEZ EM MOEDA NACIONAL, QUE SAO PRONTAMENTE CONVERSIVEIS EM VALORES CONHECIDOS DE CAIXA E QUE ESTAO SUJEITAS A UM INSIGNIFICANTE RISCO DE MUDANCA DE VALOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.00.00', 'CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - INTRA OFSS', 'COMPREENDE O SOMATORIO DOS VALORES DE CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.20.00', 'RECURSOS LIBERADOS PELO TESOURO', 'COMPREENDE OS RECURSOS LIBERADOS PELO TESOURO NACIONAL, PARA ATENDER A DESPESAS DO EXERCICIO E DE EXERCICIO ANTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.2.0.00.00', 'CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA', 'COMPREENDE O SOMATORIO DOS VALORES DE CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.2.1.00.00', 'CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA - CONSOLIDACAO', 'COMPREENDE O SOMATORIO DOS VALORES DE CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.0.0.00.00', 'CREDITOS A CURTO PRAZO', 'COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVICOS, CREDITOS TRIBUTARIOS, DIVIDA ATIVA, TRANSFERENCIA E EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.0.00.00', 'CLIENTES', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORRAM NO CURSO NORMAL DAS OPERACOES DA ENTIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.00.00', 'CLIENTES-CONSOLIDACAO', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.00', 'FATURAS/DUPLICATAS A RECEBER', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, EALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.00.00', 'CLIENTES-INTRA OFSS', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.00', 'FATURAS/DUPLICATAS A RECEBER', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, EALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.00.00', 'CLIENTES - INTER OFSS - ESTADO', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.00', 'FATURAS/DUPLICATAS A RECEBER', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, EALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.00.00', 'CLIENTES - INTER OFSS - MUNICIPIO', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.00', 'FATURAS/DUPLICATAS A RECEBER', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, EALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.2.0.00.00', 'CREDITOS TRIBUTARIOS A RECEBER', 'COMPREENDE OS VALORES RELATIVOS A CREDITOS A RECEBER ORIUNDOS DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TRIBUTARIAS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIOS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.1.00.00', 'DIVIDA ATIVA TRIBUTARIA - CONSOLIDACAO', 'COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA INSCRITOS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.2.00.00', 'DIVIDA ATIVA TRIBUTARIA - INTRA OFSS', 'COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA INSCRITOS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.4.00.00', 'DIVIDA ATIVA TRIBUTARIA - INTER OFSS - ESTADO', 'COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA INSCRITOS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.5.00.00', 'DIVIDA ATIVA TRIBUTARIA - INTER OFSS - MUNICIPIO', 'COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA INSCRITOS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.0.00.00', 'DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES', 'COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, DERIVADOS DE CLIENTES, REALIZAVEIS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.0.00.00', 'CREDITOS DE TRANSFERENCIAS A RECEBER', 'COMPREENDE OS VALORES RELATIVOS A CREDITOS A RECEBER ORIUNDOS DAS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS OBRIGATORIAS DA UNIAO, ESTADOS, DISTRITO FEDERAL E MUNICIPIOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.0.00.00', 'EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.00.00', 'EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS-CONSOLIDACAO', 'COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.02.00', 'FINANCIAMENTOS CONCEDIDOS A RECEBER', 'COMPREENDE OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.03.00', 'OPERACOES ESPECIAIS', 'COMPREENDE OS VALORES DAS OPERACOES ESPECIAIS EFETUADAS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.04.00', 'ENCARGOS SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER', 'COMPREENDE OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.07.00', 'EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIARIOS', 'COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.00.00', 'EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS - INTRA OFSS', 'COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.02.00', 'FINANCIAMENTOS CONCEDIDOS A RECEBER', 'COMPREENDE OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.03.00', 'OPERACOES ESPECIAIS', 'COMPREENDE OS VALORES DAS OPERACOES ESPECIAIS EFETUADAS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.2.07.00', 'EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIARIOS', 'COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.00.00', 'EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS - INTER OFSS - ESTADO', 'COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.02.00', 'FINANCIAMENTOS CONCEDIDOS A RECEBER', 'COMPREENDE OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.03.00', 'OPERACOES ESPECIAIS', 'COMPREENDE OS VALORES DAS OPERACOES ESPECIAIS EFETUADAS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.07.00', 'EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIARIOS', 'COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.00.00', 'EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS - INTER OFSS - MUNICIPIO', 'COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.02.00', 'FINANCIAMENTOS CONCEDIDOS A RECEBER', 'COMPREENDE OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.03.00', 'OPERACOES ESPECIAIS', 'COMPREENDE OS VALORES DAS OPERACOES ESPECIAIS EFETUADAS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.04.00', 'ENCARGOS SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER', 'COMPREENDE OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.07.00', 'EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIARIOS', 'COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.0.00.00', '(-) AJUSTE DE PERDAS DE CREDITOS A CURTO PRAZO', 'COMPREENDE O AJUSTE PARA PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.00.00', '(-) AJUSTE DE PERDAS DE CREDITOS A CURTO PRAZO-CONSOLIDACAO', 'COMPREENDE O AJUSTE PARA PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.05.00', '(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.00.00', '(-) AJUSTE DE PERDAS DE CREDITOS A CURTO PRAZO - INTRA OFSS', 'COMPREENDE O AJUSTE PARA PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.05.00', '(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.00.00', '(-) AJUSTE DE PERDAS DE CREDITOS A CURTO PRAZO - INTER OFSS - ESTADO', 'COMPREENDE O AJUSTE PARA PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.05.00', '(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.00.00', '(-) AJUSTE DE PERDAS DE CREDITOS A CURTO PRAZO - INTER OFSS - MUNICIPIO', 'COMPREENDE O AJUSTE PARA PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.05.00', '(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.0.0.00.00', 'DEMAIS CREDITOS E VALORES A CURTO PRAZO', 'COMPREENDE OS VALORES A RECEBER POR DEMAIS TRANSACOES, REALIZAVEIS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.0.00.00', 'ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS', 'COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.00.00', 'ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS - CONSOLIDACAO', 'COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.00', 'ADIANTAMENTOS CONCEDIDOS A PESSOAL', 'COMPREENDE OS VALORES DAS ANTECIPACOES CONCEDIDAS A SERVIDORES E A DIRIGENTES DA UNIDADE, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E DE GRATIFICACOES NATALINAS, ENTRE OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.2.00.00', 'ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS - INTRA OFSS', 'COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.4.00.00', 'ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS - INTER OFSS - ESTADO', 'COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.5.00.00', 'ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.5.03.00', 'ADIANTAMENTOS A UNIDADES E ENTIDADES', 'REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.0.00.00', 'TRIBUTOS A RECUPERAR / COMPENSAR', 'COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR/ COMPENSAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.00.00', 'TRIBUTOS A RECUPERAR / COMPENSAR - CONSOLIDACAO', 'COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR /COMPENSAR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.4.00.00', 'TRIBUTOS A RECUPERAR / COMPENSAR - INTER OFSS - ESTADO', 'COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR / COMPENSAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.5.00.00', 'TRIBUTOS A RECUPERAR / COMPENSAR - INTER OFSS - MUNICIPIO', 'COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR / COMPENSAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.3.0.00.00', 'CREDITOS A RECEBER POR DESCENTRALIZACAO DA PRESTACAO DE SERVICOS PUBLICOS', 'COMPREENDE OS CREDITOS A RECEBER DECORRENTES DA DESCENTRALIZACAO DE SERVICOS PUBLICOS, TANTO POR MEIO DE OUTORGA A ENTIDADES DA ADMINISTRACAO INDIRETA COMO POR MEIO DE DELEGACAO, NAS FORMAS DE CONCESSAO, INCLUSIVE PARCERIAS PUBLICO-PRIVADAS -PPP, PERMISSAO OU AUTORIZACAO AO PARTICULAR DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.3.1.00.00', 'CREDITOS A RECEBER POR DESCENTRALIZACAO DA PRESTACAO DE SERVICOS PUBLICOS - CONSOLIDACAO', 'COMPREENDE OS CREDITOS A RECEBER DECORRENTES DA DESCENTRALIZACAO DE SERVICOS PUBLICOS, TANTO POR MEIO DE OUTORGA A ENTIDADES DA ADMINISTRACAO INDIRETA, COMO POR MEIO DE DELEGACAO, NAS FORMAS DE CONCESSAO, INCLUSIVE PARCERIAS PUBLICO-PRIVADAS -PPP, PERMISSAO OU AUTORIZACAO AO PARTICULAR DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.3.1.01.00', 'CREDITOS A RECEBER POR DESCENTRALIZACAO DE SERVICOS DE TELECOMUNICACOES', 'COMPREENDE OS CREDITOS A RECEBER DECORRENTES DA DESCENTRALIZACAO DA PRESTACAO DE SERVICOS DE TELECOMUNICACOES, NAS FORMAS DE OUTORGA A ENTIDADES DA ADMINISTRACAO INDIRETA , CONCESSAO, PERMISSAO OU AUTORIZACAO AO PARTICULAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.0.00.00', 'CREDITOS POR DANOS AO PATRIMONIO', 'COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM SINDICANCIA, PRESTACAO DE CONTAS, TOMADA DE CONTAS, PROCESSOS JUDICIAIS E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.00.00', 'CREDITOS POR DANOS AO PATRIMONIO-CONSOLIDACAO', 'COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM SINDICANCIA, PRESTACAO DE CONTAS, TOMADA DE CONTAS, PROCESSOS JUDICIAIS E OUTROS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.01.00', 'CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS', 'COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.00.00', 'CREDITOS POR DANOS AO PATRIMONIO-INTRA OFSS', 'COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM SINDICANCIA, PRESTACAO E TOMADA DE CONTAS E OUTROS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.01.00', 'CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS', 'COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.2.02.00', 'CREDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL', 'COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.00.00', 'CREDITOS POR DANOS AO PATRIMONIO - INTER OFSS - ESTADO', 'COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM SINDICANCIA, PRESTACAO E TOMADA DE CONTAS E OUTROS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.01.00', 'CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS', 'COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.4.02.00', 'CREDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL', 'COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.00.00', 'CREDITOS POR DANOS AO PATRIMONIO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM SINDICANCIA, PRESTACAO E TOMADA DE CONTAS E OUTROS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.5.02.00', 'CREDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL', 'COMPREENDE OS VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.0.00.00', 'DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS', 'COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.00.00', 'DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS-CONSOLIDACAO', 'COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.11.00', 'DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL S/A', 'COMPREENDE OS VALORES DOS DEPOSITOS ESPECIAIS DO FUNDO DE AMPARO AO TRABALHADOR - FAT NO BANCO DO BRASIL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.12.00', 'DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE', 'COMPREENDE OS VALORES DOS DEPOSITOS ESPECIAIS DO FUNDO DE AMPARO AO TRABALHADOR - FAT NO BANCO DO NORDESTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.13.00', 'DEPOSITOS ESPECIAIS DO FAT NO BNDES', 'COMPREENDE OS VALORES DOS DEPOSITOS ESPECIAIS DO FUNDO DE AMPARO AO TRABALHADOR - FAT NO BNDES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.14.00', 'DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL', 'COMPREENDE OS VALORES DOS DEPOSITOS ESPECIAIS DO FUNDO DE AMPARO AO TRABALHADOR - FAT NA CAIXA ECONOMICA FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.15.00', 'DEPOSITOS ESPECIAIS DO FAT NA FINANCIADORA DE ESTUDOS E PROJETOS - FINEP', 'COMPREENDE OS VALORES DOS DEPOSITOS ESPECIAIS DO FUNDO DE AMPARO AO TRABALHADOR - FAT NA FINANCIADORA DE ESTUDOS E PROJETOS - FINEP.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.16.00', 'DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA', 'COMPREENDE OS VALORES DOS DEPOSITOS ESPECIAIS DO FUNDO DE AMPARO AO TRABALHADOR - FAT NO BANCO DA AMAZONIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.00.00', 'DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS-INTRA OFSS', 'COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.00.00', 'DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS - INTER OFSS - ESTADO', 'COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.00.00', 'DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS - INTER OFSS - MUNICIPIO', 'COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.6.0.00.00', 'DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS', 'COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, EXCETO AS DERIVADAS DE CLIENTES, REALIZAVEIS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.0.00.00', 'OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO', 'COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.00.00', 'OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO -CONSOLIDACAO', 'COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.06.00', 'VALORES EM TRANSITO REALIZAVEIS A CURTO PRAZO', 'COMPREENDE O SOMATORIO DOS VALORES CONTABILIZADOS INDEVIDAMENTE EM CONTA BANCARIA, GUIA DE RECEBIMENTO E ORDENS BANCARIAS EMITIDAS A COMPENSAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.30.00', 'RESULTADO POSITIVO DO BACEN', 'COMPREENDE OS VALORES RELATIVOS AO RESULTADO POSITIVO DO BANCO CENTRAL A SER REEMBOLSADO PELO TESOURO NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.00.00', 'OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO-INTRA OFSS', 'COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.06.00', 'VALORES EM TRANSITO REALIZAVEIS A CURTO PRAZO', 'COMPREENDE O SOMATORIO DOS VALORES CONTABILIZADOS INDEVIDAMENTE EM CONTA BANCARIA, GUIA DE RECEBIMENTO E ORDENS BANCARIAS EMITIDAS A COMPENSAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.2.33.00', 'RECURSOS FINANCEIROS DIFERIDOS', 'COMPREENDE O VALOR DO SALDO FINANCEIRO REMANESCENTE DO FINAL DO EXERCICIO QUE CONSTITUIRA ANTECIPACAO DE COTA, REPASSE OU SUB-REPASSE NO EXERCICIO SEGUINTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.00.00', 'OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO - INTER OFSS - ESTADO', 'COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.4.06.00', 'VALORES EM TRANSITO REALIZAVEIS A CURTO PRAZO', 'COMPREENDE O SOMATORIO DOS VALORES CONTABILIZADOS INDEVIDAMENTE EM CONTA BANCARIA, GUIA DE RECEBIMENTO E ORDENS BANCARIAS EMITIDAS A COMPENSAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.00.00', 'OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS NO CURTO PRAZO, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.5.06.00', 'VALORES EM TRANSITO REALIZAVEIS A CURTO PRAZO', 'COMPREENDE O SOMATORIO DOS VALORES CONTABILIZADOS INDEVIDAMENTE EM CONTA BANCARIA, GUIA DE RECEBIMENTO E ORDENS BANCARIAS EMITIDAS A COMPENSAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.0.00.00', '(-) AJUSTE DE PERDAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS E VALORES A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.1.00.00', '(-) AJUSTE DE PERDAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO -CONSOLIDACAO', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS E VALORES A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.1.02.00', '(-) AJUSTE DE PERDAS DE CREDITOS POR DANOS AO PATRIMONIO', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS OU APURADOS EM TOMADA DE CONTAS ESPECIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.2.00.00', '(-) AJUSTE DE PERDAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO - INTRA OFSS', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS E VALORES A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.2.02.00', '(-) AJUSTE DE PERDAS DE CREDITOS POR DANOS AO PATRIMONIO', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS OU APURADOS EM TOMADA DE CONTAS ESPECIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.4.00.00', '(-) AJUSTE DE PERDAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO - INTER OFSS - ESTADO', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS E VALORES A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.4.02.00', '(-) AJUSTE DE PERDAS DE CREDITOS POR DANOS AO PATRIMONIO', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS OU APURADOS EM TOMADA DE CONTAS ESPECIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.5.00.00', '(-) AJUSTE DE PERDAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO - INTER OFSS - MUNICIPIO', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS E VALORES A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.5.02.00', '(-) AJUSTE DE PERDAS DE CREDITOS POR DANOS AO PATRIMONIO', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS OU APURADOS EM TOMADA DE CONTAS ESPECIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.0.0.00.00', 'INVESTIMENTOS E APLICACOES TEMPORARIAS A CURTO PRAZO', 'COMPREENDEM AS APLICACOES DE RECURSOS EM TITULOS E VALORES MOBILIARIOS, NAO DESTINADAS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS NO CURTO PRAZO, ALEM DAS APLICACOES TEMPORARIAS EM METAIS PRECIOSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.0.00.00', 'TITULOS E VALORES MOBILIARIOS', 'COMPREENDEM AS APLICACOES DE RECURSOS EM TITULOS E VALORES MOBILIARIOS, NAO DESTINADAS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.00.00', 'TITULOS E VALORES MOBILIARIOS-CONSOLIDACAO', 'COMPREENDEM AS APLICACOES DE RECURSOS EM TITULOS E VALORES MOBILIARIOS, NAO DESTINADAS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.03.00', 'TITULOS PUBLICOS - MERCADO ABERTO', 'COMPREENDE O VALOR RELATIVO A TITULOS PUBLICOS, EMITIDOS E EM CIRCULACAO NO MERCADO ABERTO PARA FINS DE NEGOCIACAO NO MERCADO DE ACOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.04.00', 'ACOES', 'COMPREENDE OS VALORES DAS ACOES REPRESENTATIVAS DAS PARTICIPACOES DOS ORGAOS E ENTIDADES NO CAPITAL DAS SOCIEDADES POR ACOES HAVIDAS POR AQUISICOES, SUBSCRICOES, BONIFICACOES E DOACOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.00', 'APLICACOES EM SEGMENTO DE RENDA FIXA', 'COMPREENDE O SOMATORIO DOS INVESTIMENTOS REALIZADOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, EFETUADOS EM CONFORMIDADE COM O ART. 6º, DA RESOLUCAO CMN N° 3.790/2009.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.10.00', 'APLICACOES EM SEGMENTO DE RENDA VARIAVEL', 'COMPREENDE O SOMATORIO DOS INVESTIMENTOS REALIZADOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, DA RESOLUCAO CMN N° 3.790/2009.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.2.0.00.00', 'APLICACAO TEMPORARIA EM METAIS PRECIOSOS', 'COMPREENDE AS APLICACOES DE RECURSOS EM METAIS PRECIOSOS, NAO DESTINADOS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.2.1.00.00', 'APLICACAO TEMPORARIA EM METAIS PRECIOSOS-CONSOLIDACAO', 'COMPREENDE AS APLICACOES DE RECURSOS EM METAIS PRECIOSOS, NAO DESTINADOS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.9.0.00.00', '(-) AJUSTES DE PERDAS DE INVESTIMENTOS E APLICACOES TEMPORARIAS', 'COMPREENDE A DIFERENCA ENTRE O VALOR RECUPERAVEL DO ATIVO E SEU VALOR CONTABIL, QUANDO O PRIMEIRO FOR MENOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.9.1.00.00', '(-) AJUSTES DE PERDAS DE INVESTIMENTOS TEMPORARIOS E APLICACOES TEMPORARIAS -CONSOLIDACAO', 'COMPREENDE A DIFERENCA ENTRE O VALOR RECUPERAVEL DO ATIVO E SEU VALOR CONTABIL, QUANDO O PRIMEIRO FOR MENOR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.0.00.00', 'MERCADORIAS PARA REVENDA', 'COMPREENDE TODOS OS PRODUTOS ADQUIRIDOS DE TERCEIROS PARA REVENDA, QUE NAO SOFREM NENHUM PROCESSO DE TRANSFORMACAO NA ENTIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.00.00', 'MERCADORIAS PARA REVENDA - CONSOLIDACAO', 'COMPREENDE TODOS OS PRODUTOS ADQUIRIDOS DE TERCEIROS PARA REVENDA, QUE NAO SOFREM NENHUM PROCESSO DE TRANSFORMACAO NA ENTIDADE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.02.00', 'MERCADORIAS - ESTOQUES PUBLICOS', 'COMPREENDE O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDAS RELATIVAS A ESTOQUES PUBLICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.03.00', 'MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES PUBLICOS', 'COMPREENDE O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA, RELATIVAS A ESTOQUES PUBLICOS EM ARMAZENS DE TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.2.0.00.00', 'PRODUTOS E SERVICOS ACABADOS', 'COMPREENDE OS PRODUTOS JA TERMINADOS E ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPOSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNACAO E OS SERVICOS ACABADOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.2.1.00.00', 'PRODUTOS E SERVICOS ACABADOS - CONSOLIDACAO', 'COMPREENDE OS PRODUTOS JA TERMINADOS E ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPOSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNACAO E OS SERVICOS ACABADOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.3.0.00.00', 'PRODUTOS E SERVICOS EM ELABORACAO', 'COMPREENDE OS PRODUTOS E SERVICOS EM ANDAMENTO NAO CONCLUIDOS NA DATA DO BALANCO PATRIMONIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.3.1.00.00', 'PRODUTOS E SERVICOS EM ELABORACAO - CONSOLIDACAO', 'COMPREENDE OS PRODUTOS E SERVICOS EM ANDAMENTO NAO CONCLUIDOS NA DATA DO BALANCO PATRIMONIAL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.4.1.00.00', 'MATERIAS-PRIMAS - CONSOLIDACAO', 'COMPREENDE O ESTOQUE DE MATERIAS-PRIMAS QUE SERA UTILIZADO NO PROCESSO PRODUTIVO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.0.00.00', 'MATERIAIS EM TRANSITO', 'COMPREENDE O VALOR DOS MATERIAIS EM PROCESSO DE TRANSFERENCIA PARA OUTRAS UNIDADES DA ENTIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.00.00', 'MATERIAIS EM TRANSITO - CONSOLIDACAO', 'COMPREENDE O VALOR DOS MATERIAIS EM PROCESSO DE TRANSFERENCIA PARA OUTRAS UNIDADES DA ENTIDADE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.10.00', 'MATERIAL DE CONSUMO EM TRANSITO', 'COMPREENDE OS VALORES DOS MATERIAIS DE CONSUMO EM TRANSITO RELATIVOS A TRANSFERENCIAS EFETUADAS ENTRE UNIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.0.00.00', 'ALMOXARIFADO', 'COMPREENDE O VALOR DOS MATERIAIS DESTINADOS AO CONSUMO INTERNO DA UNIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.7.0.00.00', 'ADIANTAMENTOS A FORNECEDORES', 'COMPREENDE OS ADIANTAMENTOS EFETUADOS PELA ENTIDADE A FORNECEDORES, VINCULADOS A COMPRAS ESPECIFICAS DE MATERIAIS QUE SERAO INCORPORADOS AOS ESTOQUES QUANDO DE SEU EFETIVO RECEBIMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.0.00.00', 'OUTROS ESTOQUES', 'COMPREENDE O VALOR DOS OUTROS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORACAO PELA ENTIDADE COM O OBJETIVO DE VENDA OU UTILIZACAO PROPRIA NO CURSO NORMAL DAS ATIVIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.00.00', 'OUTROS ESTOQUES - CONSOLIDACAO', 'COMPREENDE O VALOR DOS OUTROS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORACAO PELA ENTIDADE COM O OBJETIVO DE VENDA OU UTILIZACAO PROPRIA NO CURSO NORMAL DAS ATIVIDADES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.02.00', 'ESTOQUES PARA DISTRIBUICAO', 'COMPREENDE O VALOR DO MATERIAL EM ESTOQUE, DESTINADO A DISTRIBUICAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.03.00', 'ESTOQUES PARA DOACAO E/OU PERMUTA', 'COMPREENDE O VALOR DAS MERCADORIAS EM ESTOQUES PARA DOACAO E/OU PERMUTA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.04.00', 'ESTOQUES DE PRODUTOS PARA PESQUISA E ENSINO', 'COMPREENDE O VALOR DO MATERIAL EM ESTOQUE, RELATIVO A ANIMAL, VEGETAL OU MINERAL, DESTINADO A PESQUISA E ENSINO DA UNIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.06.00', 'CONSTRUCOES CIVIS', 'COMPREENDE OS VALORES DOS IMOVEIS QUE DEVAM SER COLOCADOS A VENDA OU QUE TENHAM SIDO ADQUIRIDOS PARA VENDA OU REVENDA, PODENDO A COMERCIALIZACAO SER OU NAO OBJETO PRINCIPAL DA EMPRESA, ENTIDADE, INSTITUICAO OU ORGAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.9.0.00.00', '(-) AJUSTES DE PERDAS DE ESTOQUES', 'COMPREENDE O REGISTRO DAS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NAO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NAO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS, BEM COMO O REGISTRO DO AJUSTE DE PERDAS PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.9.1.00.00', '(-) AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDACAO', 'COMPREENDE O REGISTRO DAS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NAO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NAO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS, BEM COMO O REGISTRO DO AJUSTE DE PERDAS PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.0.0.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE', 'COMPREENDE PAGAMENTOS DE VARIACOES PATRIMONIAIS DIMINUTIVAS (VPD) ANTECIPADAS, CUJOS BENEFICIOS OU PRESTACAO DE SERVICO A ENTIDADE OCORRERAO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.2.0.00.00', 'VPD FINANCEIRAS A APROPRIAR', 'COMPREENDE OS VALORES PAGOS A TITULO DE VPD FINANCEIRAS A APROPRIAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.3.0.00.00', 'ASSINATURAS E ANUIDADES A APROPRIAR', 'COMPREENDE OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.5.0.00.00', 'TRIBUTOS PAGOS A APROPRIAR', 'COMPREENDE OS VALORES PAGOS A TITULO DE TRIBUTOS PAGOS A APROPRIAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.6.0.00.00', 'CONTRIBUICOES CONFEDERATIVAS A APROPRIAR', 'COMPREENDE OS VALORES PAGOS A TITULO DE CONTRIBUICOES CONFEDERATIVAS A APROPRIAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.7.0.00.00', 'BENEFICIOS A PESSOAL A APROPRIAR', 'COMPREENDE OS VALORES PAGOS A TITULO DE BENEFICIO A PESSOAL A APROPRIAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.0.00.00', 'DEMAIS VPD A APROPRIAR', 'COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.1.00.00', 'DEMAIS VPD A APROPRIAR - CONSOLIDACAO', 'COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.2.00.00', 'DEMAIS VPD A APROPRIAR - INTRA OFSS', 'COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.4.00.00', 'DEMAIS VPD A APROPRIAR - INTER OFSS - ESTADO', 'COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.5.00.00', 'DEMAIS VPD A APROPRIAR - INTER OFSS - MUNICIPIO', 'COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.0.0.0.00.00', 'ATIVO NAO-CIRCULANTE', 'COMPREENDE O ATIVO NAO-CIRCULANTE : O ATIVO REALIZAVEL A LONGO PRAZO, OS INVESTIMENTOS, O IMOBILIZADO E O INTANGIVEL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.0.0.00.00', 'ATIVO REALIZAVEL A LONGO PRAZO', 'COMPREENDE OS BENS, DIREITOS E DESPESAS ANTECIPADAS REALIZAVEIS NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.0.00.00', 'CREDITOS A LONGO PRAZO', 'COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVICOS, CREDITOS TRIBUTARIOS, DIVIDA ATIVA, TRANSFERENCIAS E EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS E COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.00.00', 'CREDITOS A LONGO PRAZO - CONSOLIDACAO', 'COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVICOS, CREDITOS TRIBUTARIOS, DIVIDA ATIVA, TRANSFERENCIAS E EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.01.00', 'CLIENTES', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA ENTIDADE (COM VENCIMENTO NO LONGO PRAZO), REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.03.00', 'DIVIDA ATIVA TRIBUTARIA', 'COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA, EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.00', 'EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.99.00', '(-) AJUSTE DE PERDAS DE CREDITOS A LONGO PRAZO', 'COMPREENDE OS AJUSTES DE PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.00.00', 'CREDITOS A LONGO PRAZO - INTRA OFSS', 'COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVICOS, CREDITOS TRIBUTARIOS, DIVIDA ATIVA, TRANSFERENCIAS E EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, COM VENCIMENTO NO LONGO PRAZO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.01.00', 'CLIENTES', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA ENTIDADE (COM VENCIMENTO APOS TERMINO DO EXERCICIO SEGUINTE), REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.03.00', 'DIVIDA ATIVA TRIBUTARIA', 'COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA, EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.00', 'EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.99.00', '(-) AJUSTE DE PERDAS DE CREDITOS A LONGO PRAZO', 'COMPREENDE OS AJUSTES DE PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.00.00', 'CREDITOS A LONGO PRAZO - INTER OFSS - ESTADO', 'COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVICOS, CREDITOS TRIBUTARIOS, DIVIDA ATIVA, TRANSFERENCIAS E EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.01.00', 'CLIENTES', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA ENTIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.03.00', 'DIVIDA ATIVA TRIBUTARIA', 'COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA, EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.00', 'EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.99.00', '(-) AJUSTE DE PERDAS DE CREDITOS A LONGO PRAZO', 'COMPREENDE OS AJUSTES DE PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.00.00', 'CREDITOS A LONGO PRAZO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVICOS, CREDITOS TRIBUTARIOS, DIVIDA ATIVA, TRANSFERENCIAS E EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.01.00', 'CLIENTES', 'COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA ENTIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.03.00', 'DIVIDA ATIVA TRIBUTARIA', 'COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA, EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.00', 'EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.99.00', '(-) AJUSTE DE PERDAS DE CREDITOS A LONGO PRAZO', 'COMPREENDE OS AJUSTES DE PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.0.00.00', 'DEMAIS CREDITOS E VALORES A LONGO PRAZO', 'COMPREENDE OS VALORES A RECEBER POR DEMAIS TRANSACOES, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.00.00', 'DEMAIS CREDITOS E VALORES A LONGO PRAZO - CONSOLIDACAO', 'COMPREENDE OS VALORES A RECEBER POR DEMAIS TRANSACOES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.01.00', 'ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS', 'COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.00', 'TRIBUTOS A RECUPERAR / COMPENSAR', 'COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR / COMPENSAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.03.00', 'CREDITOS A RECEBER POR DESCENTRALIZACAO DA PRESTACAO DE SERVICOS PUBLICOS', 'COMPREENDE OS CREDITOS A RECEBER COM REALIZACAO APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, DECORRENTES DA DESCENTRALIZACAO DE SERVICOS PUBLICOS, TANTO POR MEIO DE OUTORGA A ENTIDADES DA ADMINISTRACAO INDIRETA COMO POR MEIO DE DELEGACAO, NAS FORMAS DE CONCESSAO, PERMISSAO OU AUTORIZACAO AO PARTICULAR DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.00', 'CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS', 'COMPREENDE OS VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.00', 'CREDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL', 'COMPREENDE OS VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.00', 'DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS', 'COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.00', 'OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO', 'COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.99.00', '(-) AJUSTE DE PERDAS DE DEMAIS CREDITOS E VALORES A LONGO PRAZO', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.00.00', 'DEMAIS CREDITOS E VALORES A LONGO PRAZO -INTRA OFSS', 'COMPREENDE OS VALORES A RECEBER POR DEMAIS TRANSACOES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.01.00', 'ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS', 'COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.02.00', 'TRIBUTOS A RECUPERAR / COMPENSAR', 'COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR / COMPENSAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.04.00', 'CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS', 'COMPREENDE OS VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.05.00', 'CREDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL', 'COMPREENDE OS VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.06.00', 'DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS', 'COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.2.99.00', '(-) AJUSTE DE PERDAS DE DEMAIS CREDITOS E VALORES A LONGO PRAZO', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.00.00', 'DEMAIS CREDITOS E VALORES A LONGO PRAZO - INTER OFSS - ESTADO', 'COMPREENDE OS VALORES A RECEBER POR DEMAIS TRANSACOES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.01.00', 'ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS', 'COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.04.00', 'CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS', 'COMPREENDE OS VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.05.00', 'CREDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL', 'COMPREENDE OS VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.06.00', 'DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS', 'COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.98.00', 'OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO', 'COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.4.99.00', '(-) AJUSTE DE PERDAS DE DEMAIS CREDITOS E VALORES A LONGO PRAZO', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.00.00', 'DEMAIS CREDITOS E VALORES A LONGO PRAZO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS VALORES A RECEBER POR DEMAIS TRANSACOES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.01.00', 'ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS', 'COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.04.00', 'CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS', 'COMPREENDE OS VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.05.00', 'CREDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL', 'COMPREENDE OS VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.06.00', 'DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS', 'COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.98.00', 'OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO', 'COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.5.99.00', '(-) AJUSTE DE PERDAS DE DEMAIS CREDITOS E VALORES A LONGO PRAZO', 'COMPREENDE O AJUSTE DE PERDAS ESTIMADAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.0.00.00', 'INVESTIMENTOS E APLICACOES TEMPORARIAS A LONGO PRAZO', 'COMPREENDE AS APLICACOES DE RECURSOS EM TITULOS, VALORES MOBILIARIOS E IMOBILIARIOS, NAO DESTINADAS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.00.00', 'INVESTIMENTOS E APLICACOES TEMPORARIAS A LONGO PRAZO - CONSOLIDACAO', 'COMPREENDE AS APLICACOES DE RECURSOS EM TITULOS, VALORES MOBILIARIOS E IMOBILIARIOS, NAO DESTINADAS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.00', 'TITULOS E VALORES MOBILIARIOS', 'COMPREENDEM AS APLICACOES DE RECURSOS EM TITULOS E VALORES MOBILIARIOS, NAO DESTINADAS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PUBLICACAO DAS DEMONSTRACOES CONTABEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.02.00', 'APLICACAO TEMPORARIA EM METAIS PRECIOSOS', 'COMPREENDEM AS APLICACOES DE RECURSOS EM METAIS PRECIOSOS, NAO DESTINADOS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PUBLICACAO DAS DEMONSTRACOES CONTABEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.99.00', '(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICACOES TEMPORARIAS A LONGO PRAZO', 'COMPREENDE A DIFERENCA ENTRE O VALOR RECUPERAVEL DO ATIVO E SEU VALOR CONTABIL, QUANDO O PRIMEIRO FOR MENOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.0.00.00', 'ESTOQUES', 'COMPREENDE O VALOR DOS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORACAO PELA ENTIDADE PARA UTILIZACAO PROPRIA OU PARA VENDA, PREVISTOS PARA PERIODO POSTERIOR AO TERMINO DO EXERCICIO SEGUINTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.00.00', 'ESTOQUES - CONSOLIDACAO', 'COMPREENDE O VALOR DOS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORACAO PELA ENTIDADE PARA UTILIZACAO PROPRIA OU PARA VENDA, PREVISTOS PARA PERIODO POSTERIOR AO TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.01.00', 'MERCADORIAS PARA REVENDA', 'COMPREENDE TODAS AS MERCADORIAS ADQUIRIDAS DE TERCEIROS PARA REVENDA, QUE NAO SOFREM NENHUM PROCESSO DE TRANSFORMACAO NA ENTIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.02.00', 'PRODUTOS E SERVICOS ACABADOS', 'COMPREENDE OS PRODUTOS JA TERMINADOS E ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPOSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNACAO E OS SERVICOS ACABADOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.03.00', 'PRODUTOS E SERVICOS EM ELABORACAO', 'COMPREENDE OS PRODUTOS E SERVICOS EM ANDAMENTO QUE NAO SERAO CONCLUIDOS ATE O TERMINO DO EXERCICIO SUBSEQUENTE A DATA DO BALANCO PATRIMONIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.05.00', 'MATERIAIS EM TRANSITO', 'COMPREENDE O VALOR DOS MATERIAIS EM PROCESSO DE TRANSFERENCIA PARA OUTRAS UNIDADES DA ENTIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.06.00', 'ALMOXARIFADO', 'COMPREENDE O VALOR DOS MATERIAIS DESTINADOS AO CONSUMO INTERNO DA UNIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.00', 'OUTROS ESTOQUES', 'COMPREENDE O VALOR DOS OUTROS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORACAO PELA ENTIDADE COM O OBJETIVO DE VENDA OU UTILIZACAO PROPRIA NO CURSO NORMAL DAS ATIVIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.99.00', '(-) AJUSTE DE PERDAS DE ESTOQUES', 'COMPREENDE O REGISTRO DAS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NAO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NAO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS, BEM COMO O REGISTRO DE PERDAS ESTIMADAS PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO. CONTA A SER UTILIZADA APENAS PARA OS ESTOQUES CLASSIFICADOS NO ATIVO REALIZAVEL A LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.0.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE', 'COMPREENDE PAGAMENTOS DE VARIACOES PATRIMONIAIS DIMINUTIVAS (VPD) ANTECIPADAS, CUJOS BENEFICIOS OU PRESTACAO DE SERVICO A ENTIDADE OCORRERAO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE- CONSOLIDACAO', 'COMPREENDE PAGAMENTOS DE VARIACOES PATRIMONIAIS DIMINUTIVAS (VPD) ANTECIPADAS, CUJOS BENEFICIOS OU PRESTACAO DE SERVICO A ENTIDADE OCORRERAO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.2.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE- INTRA OFSS', 'COMPREENDE PAGAMENTOS DE VARIACOES PATRIMONIAIS DIMINUTIVAS (VPD) ANTECIPADAS, CUJOS BENEFICIOS OU PRESTACAO DE SERVICO A ENTIDADE OCORRERAO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.4.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE - INTER OFSS - ESTADO', 'COMPREENDE PAGAMENTOS DE VARIACOES PATRIMONIAIS DIMINUTIVAS (VPD) ANTECIPADAS, CUJOS BENEFICIOS OU PRESTACAO DE SERVICO A ENTIDADE OCORRERAO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.4.99.00', 'DEMAIS VPD A APROPRIAR', 'COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.5.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE - INTER OFSS - MUNICIPIO', 'COMPREENDE PAGAMENTOS DE VARIACOES PATRIMONIAIS DIMINUTIVAS (VPD) ANTECIPADAS, CUJOS BENEFICIOS OU PRESTACAO DE SERVICO A ENTIDADE OCORRERAO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.5.99.00', 'DEMAIS VPD A APROPRIAR', 'COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.0.0.00.00', 'INVESTIMENTOS', 'COMPREENDE AS PARTICIPACOES PERMANENTES EM OUTRAS SOCIEDADES, BEM COMO OS BENS E DIREITOS NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO E QUE NAO SE DESTINEM A MANUTENCAO DA ATIVIDADE DA ENTIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.0.00.00', 'PARTICIPACOES PERMANENTES', 'COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE ACOES OU COTAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.00', 'PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.02.00', 'PARTICIPACOES AVALIADAS PELO METODO DE CUSTO', 'COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.00.00', 'PARTICIPACOES PERMANENTES - INTRA OFSS', 'COMPREENDE AS PARTICIPACOES PERMANENTES DA ENTIDADE EM OUTRAS SOCIEDADES EM FORMA DE ACOES OU COTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.00', 'PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.02.00', 'PARTICIPACOES AVALIADAS PELO METODO DE CUSTO', 'COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.00.00', 'PARTICIPACOES PERMANENTES - INTER OFSS - ESTADO', 'COMPREENDE AS PARTICIPACOES PERMANENTES DA ENTIDADE EM OUTRAS SOCIEDADES EM FORMA DE ACOES OU COTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.00', 'PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.02.00', 'PARTICIPACOES AVALIADAS PELO METODO DE CUSTO', 'COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.00.00', 'PARTICIPACOES PERMANENTES - INTER OFSS - MUNICIPIO', 'COMPREENDE AS PARTICIPACOES PERMANENTES DA ENTIDADE EM OUTRAS SOCIEDADES EM FORMA DE ACOES OU COTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.00', 'PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL', 'COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.02.00', 'PARTICIPACOES AVALIADAS PELO METODO DE CUSTO', 'COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.2.0.00.00', 'PROPRIEDADES PARA INVESTIMENTO', 'COMPREENDE A PROPRIEDADE (TERRENO OU EDIFICIO -OU PARTE DE EDIFICIO - OU AMBOS) MANTIDA (PELO PROPRIETARIO OU PELO ARRENDATARIO EM ARRENDAMENTO FINANCEIRO) PARA AUFERIR ALUGUEL OU PARA VALORIZACAO DO CAPITAL OU PARA AMBAS, E NAO PARA: (A) USO NA PRODUCAO OU FORNECIMENTO DE BENS OU SERVICOS OU PARA FINALIDADES ADMINISTRATIVAS; OU (B) VENDA NO CURSO ORDINARIO DO NEGOCIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.2.1.00.00', 'PROPRIEDADES PARA INVESTIMENTO - CONSOLIDACAO', 'COMPREENDE A PROPRIEDADE (TERRENO OU EDIFICIO -OU PARTE DE EDIFICIO - OU AMBOS) MANTIDA (PELO PROPRIETARIO OU PELO ARRENDATARIO EM ARRENDAMENTO FINANCEIRO) PARA AUFERIR ALUGUEL OU PARA VALORIZACAO DO CAPITAL OU PARA AMBAS, E NAO PARA: (A) USO NA PRODUCAO OU FORNECIMENTO DE BENS OU SERVICOS OU PARA FINALIDADES ADMINISTRATIVAS; OU (B) VENDA NO CURSO ORDINARIO DO NEGOCIO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.3.0.00.00', 'INVESTIMENTOS DO RPPS DE LONGO PRAZO', 'COMPREENDE OS INVESTIMENTOS REALIZADOS PELO REGIME PROPRIO DA PREVIDENCIA SOCIAL, EM CONFORMIDADE COM A LEGISLACAO QUE TRATA DAS APLICACOES E INVESTIMENTOS DOS RPPS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.3.1.00.00', 'INVESTIMENTOS DO RPPS DE LONGO PRAZO - CONSOLIDACAO', 'COMPREENDE OS INVESTIMENTOS REALIZADOS PELO REGIME PROPRIO DA PREVIDENCIA SOCIAL, EM CONFORMIDADE COM A LEGISLACAO QUE TRATA DAS APLICACOES E INVESTIMENTOS DOS RPPS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.0.00.00', 'DEMAIS INVESTIMENTOS PERMANENTES', 'COMPREENDE OS DEMAIS DIREITOS DE QUALQUER NATUREZA NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO E QUE NAO SE DESTINEM A MANUTENCAO DAS ATIVIDADES DA ENTIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.1.00.00', 'DEMAIS INVESTIMENTOS PERMANENTES - CONSOLIDACAO', 'COMPREENDE OS DEMAIS DIREITOS DE QUALQUER NATUREZA NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO E QUE NAO SE DESTINEM A MANUTENCAO DAS ATIVIDADES DA ENTIDADE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.2.00.00', 'DEMAIS INVESTIMENTOS PERMANENTES - INTRA OFSS', 'COMPREENDE OS DEMAIS DIREITOS DE QUALQUER NATUREZA NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO E QUE NAO SE DESTINEM A MANUTENCAO DAS ATIVIDADES DA ENTIDADE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.4.00.00', 'DEMAIS INVESTIMENTOS PERMANENTES - INTER OFSS - ESTADO', 'COMPREENDE OS DEMAIS DIREITOS DE QUALQUER NATUREZA NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO E QUE NAO SE DESTINEM A MANUTENCAO DAS ATIVIDADES DA ENTIDADE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.5.00.00', 'DEMAIS INVESTIMENTOS PERMANENTES - INTER OFSS - MUNICIPIO', 'COMPREENDE OS DEMAIS DIREITOS DE QUALQUER NATUREZA NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO E QUE NAO SE DESTINEM A MANUTENCAO DAS ATIVIDADES DA ENTIDADE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.8.0.00.00', '(-) DEPRECIACAO ACUMULADA DE INVESTIMENTOS', 'COMPREENDE A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO INVESTIMENTO DEVIDO A DESGASTE PELO USO, ACAO DA NATUREZA OU OBSOLESCENCIA, QUANDO COUBER, COMO A DEPRECIACAO DAS PROPRIEDADES MANTIDAS PARA INVESTIMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.8.1.00.00', '(-) DEPRECIACAO ACUMULADA DE INVESTIMENTOS - CONSOLIDACAO', 'COMPREENDE A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO INVESTIMENTO DEVIDO A DESGASTE PELO USO, ACAO DA NATUREZA OU OBSOLESCENCIA, QUANDO COUBER, COMO A DEPRECIACAO DAS PROPRIEDADES MANTIDAS PARA INVESTIMENTO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.0.00.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS', 'COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.1.00.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS -CONSOLIDACAO', 'COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.2.00.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS -INTRA OFSS', 'COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.4.00.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - INTER OFSS - ESTADO', 'COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.5.00.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - INTER OFSS - MUNICIPIO', 'COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.0.0.00.00', 'IMOBILIZADO', 'COMPREENDE OS DIREITOS QUE TENHAM POR OBJETO BENS CORPOREOS DESTINADOS A MANUTENCAO DAS ATIVIDADES DA ENTIDADE OU EXERCIDOS COM ESSA FINALIDADE, INCLUSIVE OS DECORRENTES DE OPERACOES QUE TRANSFIRAM A ELA OS BENEFICIOS, OS RISCOS E O CONTROLE DESSES BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.0.00.00', 'BENS MOVEIS', 'COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE BENS CORPOREOS, QUE TEM EXISTENCIA MATERIAL E QUE PODEM SER TRANSPORTADOS POR MOVIMENTO PROPRIO OU REMOVIDOS POR FORCA ALHEIA SEM ALTERACAO DA SUBSTANCIA OU DA DESTINACAO ECONOMICO-SOCIAL, QUE CONSTITUAM MEIO PARA A PRODUCAO DE OUTROS BENS OU SERVICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.00.00', 'BENS MOVEIS-CONSOLIDACAO', 'COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE BENS CORPOREOS, QUE TEM EXISTENCIA MATERIAL E QUE PODEM SER TRANSPORTADOS POR MOVIMENTO PROPRIO OU REMOVIDOS POR FORCA ALHEIA SEM ALTERACAO DA SUBSTANCIA OU DA DESTINACAO ECONOMICO-SOCIAL, QUE CONSTITUAM MEIO PARA A PRODUCAO DE OUTROS BENS OU SERVICOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.00', 'MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS', 'COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MAQUINAS, FERRAMENTAS, APARELHOS, EQUIPAMENTOS, ACESSORIOS ETC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.02.00', 'BENS DE INFORMATICA', 'COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E SISTEMAS APLICATIVOS, ENTRE OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.03.00', 'MOVEIS E UTENSILIOS', 'COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MOBILIARIO EM GERAL E UTENSILIOS, ENTRE OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.00', 'MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICACAO', 'COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MATERIAIS BIBLIOGRAFICOS, DISCOTECAS, FILMOTECAS, DE COMUNICACAO, ENTRE OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.05.00', 'VEICULOS', 'COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MEIOS DE TRANSPORTES AEREOS, AQUATICOS E TERRESTRES, ENTRE OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.00', 'DEMAIS BENS MOVEIS', 'COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DOS DEMAIS BENS MOVEIS NAO CLASSIFICADOS EM GRUPOS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.0.00.00', 'BENS IMOVEIS', 'COMPREENDE O VALOR DOS BENS IMOVEIS, OS QUAIS SAO BENS VINCULADOS AO SOLO E QUE NAO PODEM SER RETIRADOS SEM DESTRUICAO OU DANO, DESTINADOS AO USO E QUE A ENTIDADE NAO ESTEJA EXPLORANDO COMERCIALMENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.00.00', 'BENS IMOVEIS-CONSOLIDACAO', 'COMPREENDE O VALOR DOS BENS IMOVEIS, OS QUAIS SAO BENS VINCULADOS AO SOLO E QUE NAO PODEM SER RETIRADOS SEM DESTRUICAO OU DANO, DESTINADOS AO USO E QUE A ENTIDADE NAO ESTEJA EXPLORANDO COMERCIALMENTE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.00', 'BENS DE USO ESPECIAL REGISTRADOS NO SPIUNET', 'COMPREENDE OS BENS, TAIS COMO EDIFICIOS OU TERRENOS DESTINADOS A SERVICO OU ESTABELECIMENTO DA ADMINISTRACAO FEDERAL, INCLUSIVE OS DE SUAS AUTARQUIAS E FUNDACOES PUBLICAS, CADASTRADOS NO SPIUNET.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.02.00', 'BENS DE USO ESPECIAL NAO REGISTRADOS NO SPIUNET', 'COMPREENDE OS BENS, TAIS COMO EDIFICIOS OU TERRENOS DESTINADOS A SERVICO OU ESTABELECIMENTO DA ADMINISTRACAO FEDERAL, INCLUSIVE OS DE SUAS AUTARQUIAS E FUNDACOES PUBLICAS, NAO CADASTRADOS NO SPIUNET.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.00', 'BENS DOMINICAIS NAO REGISTRADOS NO SIAPA', 'COMPREENDE OS BENS NAO REGISTRADOS NO SIAPA QUE CONSTITUEM O PATRIMONIO DAS PESSOAS JURIDICAS DE DIREITO PUBLICO, COMO OBJETO DE DIREITO PESSOAL, OU REAL, DE CADA UMA DESSAS ENTIDADES. COMPREENDE AINDA, NAO DISPONDO A LEI EM CONTRARIO, OS BENS PERTENCENTES AS PESSOAS JURIDICAS DE DIREITO PUBLICO A QUE SE TENHA DADO ESTRUTURA DE DIREITO PRIVADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.06.00', 'BENS IMOVEIS EM ANDAMENTO', 'COMPREENDE OS VALORES DE BENS IMOVEIS EM ANDAMENTO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.00', 'DEMAIS BENS IMOVEIS', 'COMPREENDE OS DEMAIS BENS IMOVEIS NAO CLASSIFICADOS ANTERIORMENTE NESSE PLANO DE CONTAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.0.00.00', '(-) DEPRECIACAO, EXAUSTAO E AMORTIZACAO ACUMULADAS', 'COMPREENDE A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO DEVIDO A DESGASTE PELO USO, ACAO DA NATUREZA OU OBSOLESCENCIA, BEM COMO A PERDA DO VALOR, DECORRENTE DE SUA EXPLORACAO, DE DIREITOS CUJO OBJETO SEJAM RECURSOS MINERAIS OU FLORESTAIS OU BENS APLICADOS NESSA EXPLORACAO E A PERDA DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.00.00', '(-) DEPRECIACAO, EXAUSTAO E AMORTIZACAO ACUMULADAS -CONSOLIDACAO', 'COMPREENDE A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO DEVIDO A DESGASTE PELO USO, ACAO DA NATUREZA OU OBSOLESCENCIA, BEM COMO A PERDA DO VALOR, DECORRENTE DE SUA EXPLORACAO, DE DIREITOS CUJO OBJETO SEJAM RECURSOS MINERAIS OU FLORESTAIS OU BENS APLICADOS NESSA EXPLORACAO E A PERDA DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.0.00.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE IMOBILIZADO', 'COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO IMOBILIZADO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.CONTA DE USO EXCLUSIVO DAS EMPRESAS ESTATAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.00.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE IMOBILIZADO -CONSOLIDACAO', 'COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO IMOBILIZADO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS). CONTA DE USO EXCLUSIVO DAS EMPRESAS ESTATAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.0.0.00.00', 'INTANGIVEL', 'COMPREENDE OS DIREITOS QUE TENHAM POR OBJETO BENS INCORPOREOS DESTINADOS A MANUTENCAO DA ENTIDADE OU EXERCIDOS COM ESSA FINALIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.1.0.00.00', 'SOFTWARES', 'COMPREENDE OS VALORES DOS SOFTWARES PERTENCENTES A ENTIDADE E NAO INTEGRANTES A UM HARDWARE, ENGLOBANDO OS VALORES REFERENTES A SUA CONSTRUCAO, IMPLEMENTACAO E INSTALACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.0.00.00', 'MARCAS, DIREITOS E PATENTES INDUSTRIAIS', 'COMPREENDE OS VALORES PERTINENTES A BENS INTANGIVEIS, ENGLOBANDO OS GASTOS COM REGISTRO DE MARCA, NOME, INVENCOES PROPRIAS, DIREITOS DE USO DE COMUNICACAO E DIREITOS AUTORAIS, ALEM DE DESEMBOLSOS A TERCEIROS POR CONTRATOS DE USO DE MARCAS, PATENTES OU PROCESSOS DE FABRICACAO (TECNOLOGIA).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.1.00.00', 'MARCAS, DIREITOS E PATENTES INDUSTRIAIS-CONSOLIDACAO', 'COMPREENDE OS VALORES PERTINENTES A BENS INTANGIVEIS, ENGLOBANDO OS GASTOS COM REGISTRO DE MARCA, NOME, INVENCOES PROPRIAS, DIREITOS DE USO DE COMUNICACAO, DIREITOS AUTORAIS E DIREITOS SOBRE RECURSOS NATURAIS, ALEM DE DESEMBOLSOS A TERCEIROS POR CONTRATOS DE USO DE MARCAS, PATENTES OU PROCESSOS DE FABRICACAO (TECNOLOGIA). COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.3.0.00.00', 'DIREITO DE USO DE IMOVEIS', 'COMPREENDE OS VALORES PERTINENTES A BENS INTANGIVEIS REPRESENTADOS PELA AQUISICAO DO DIREITO DE USO DE IMOVEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.8.0.00.00', '(-) AMORTIZACAO ACUMULADA', 'COMPREENDE A DIMINUICAO DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DA PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.8.1.00.00', '(-) AMORTIZACAO ACUMULADA-CONSOLIDACAO', 'COMPREENDE A DIMINUICAO DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DA PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.9.0.00.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INTANGIVEL', 'COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO ATIVO INTANGIVEL, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. CONTA DE USO EXCLUSIVO DAS EMPRESAS ESTATAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.9.1.00.00', '(-) REDUCAO AO VALOR RECUPERAVEL DE INTANGIVEL -CONSOLIDACAO', 'COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO ATIVO INTANGIVEL, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS). CONTA DE USO EXCLUSIVO DAS EMPRESAS ESTATAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.0.0.0.0.00.00', 'PASSIVO E PATRIMONIO LIQUIDO', 'PASSIVO COMPREENDE AS OBRIGACOES EXISTENTES DA ENTIDADE ORIUNDAS DE EVENTOS PASSADOS DE CUJA LIQUIDACAO SE ESPERA QUE RESULTE EM FLUXO DE SAIDA DE RECURSOS QUE INCORPOREM BENEFICIOS ECONOMICOS OU SERVICOS EM POTENCIAL. PATRIMONIO LIQUIDO COMPREENDE A DIFERENCA ENTRE O ATIVO E O PASSIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.0.0.0.00.00', 'PASSIVO CIRCULANTE', 'COMPREENDE AS OBRIGACOES CONHECIDAS E ESTIMADAS QUE ATENDAM A QUALQUER UM DOS SEGUINTES CRITERIOS: TENHAM PRAZOS ESTABELECIDOS OU ESPERADOS DENTRO DO CICLO OPERACIONAL DA ENTIDADE; SEJAM MANTIDOS PRIMARIAMENTE PARA NEGOCIACAO; TENHAM PRAZOS ESTABELECIDOS OU ESPERADOS NO CURTO PRAZO; SEJAM VALORES DE TERCEIROS OU RETENCOES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PUBLICO FOR FIEL DEPOSITARIA, INDEPENDENTEMENTE DO PRAZO DE EXIGIBILIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.0.0.00.00', 'OBRIGACOES TRABALHISTAS, PREVIDENCIARIAS E ASSISTENCIAIS A PAGAR A CURTO PRAZO', 'COMPREENDE AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, APOSENTADORIAS, REFORMAS, PENSOES, ENCARGOS A PAGAR, BENEFICIOS ASSISTENCIAIS, INCLUSIVE OS PRECATORIOS DECORRENTES DESTAS OBRIGACOES, COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.0.00.00', 'PESSOAL A PAGAR', 'COMPREENDE AS OBRIGACOES A CURTO PRAZO REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.00.00', 'PESSOAL A PAGAR - CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.01.00', 'PESSOAL A PAGAR DO EXERCICIO', 'COMPREENDE AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS AO EXERCICIO ATUAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.02.00', 'PESSOAL A PAGAR DE EXERCICIOS ANTERIORES', 'REGISTRA AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS A EXERCICIOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.03.00', 'PRECATORIOS DE PESSOAL', 'COMPREENDE OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.0.00.00', 'BENEFICIOS PREVIDENCIARIOS A PAGAR', 'COMPREENDE AS OBRIGACOES A CURTO PRAZO REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.1.00.00', 'BENEFICIOS PREVIDENCIARIOS A PAGAR-CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.1.03.00', 'PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.3.0.00.00', 'BENEFICIOS ASSISTENCIAIS A PAGAR', 'COMPREENDE AS OBRIGACOES A CURTO PRAZO RELATIVAS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.3.1.00.00', 'BENEFICIOS ASSISTENCIAIS A PAGAR -CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES RELATIVAS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.0.00.00', 'ENCARGOS SOCIAIS A PAGAR', 'COMPREENDE AS OBRIGACOES A CURTO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.00.00', 'ENCARGOS SOCIAIS A PAGAR-CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.01.00', 'INSS A PAGAR', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.02.00', 'ENCARGOS PREVIDENCIARIOS DA UNIAO', 'REGISTRA OS VALORES DAS OBRIGACOES A TITULO DE ENCARGOS PREVIDENCIARIOS DA UNIAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.04.00', 'CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)', 'COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.08.00', 'ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR', 'COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.00.00', 'ENCARGOS SOCIAIS A PAGAR-INTRA OFSS', 'COMPREENDE AS OBRIGACOES DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.01.00', 'INSS A PAGAR', 'REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.02.00', 'ENCARGOS PREVIDENCIARIOS DA UNIAO', 'REGISTRA OS VALORES DAS OBRIGACOES A TITULO DE ENCARGOS PREVIDENCIARIOS DA UNIAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.04.00', 'CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)', 'COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.00.00', 'ENCARGOS SOCIAIS A PAGAR - INTER OFSS - ESTADO', 'COMPREENDE AS OBRIGACOES DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.02.00', 'ENCARGOS PREVIDENCIARIOS DA UNIAO', 'REGISTRA OS VALORES DAS OBRIGACOES A TITULO DE ENCARGOS PREVIDENCIARIOS DA UNIAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.04.00', 'CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)', 'COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.08.00', 'ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR', 'COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.00.00', 'ENCARGOS SOCIAIS A PAGAR - INTER OFSS - MUNICIPIO', 'COMPREENDE AS OBRIGACOES DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.02.00', 'ENCARGOS PREVIDENCIARIOS DA UNIAO', 'REGISTRA OS VALORES DAS OBRIGACOES A TITULO DE ENCARGOS PREVIDENCIARIOS DA UNIAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.04.00', 'CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)', 'COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.08.00', 'ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR', 'COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.0.0.00.00', 'EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO', 'COMPREENDE AS OBRIGACOES FINANCEIRAS, EXTERNAS E INTERNAS DA ENTIDADE A TITULO DE EMPRESTIMOS, BEM COMO FINANCIAMENTO DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR, COM VENCIMENTOS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.0.00.00', 'EMPRESTIMOS A CURTO PRAZO - INTERNO', 'COMPREENDE OS EMPRESTIMOS CONTRATUAIS OU MOBILIARIOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.00.00', 'EMPRESTIMOS A CURTO PRAZO - INTERNO-CONSOLIDACAO', 'COMPREENDE OS EMPRESTIMOS CONTRATUAIS OU MOBILIARIOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.01.00', 'PARCELA A CURTO PRAZO DOS EMPRESTIMOS INTERNOS', 'COMPREENDE AS PARCELAS DOS EMPRESTIMOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.02.00', 'EMPRESTIMOS INTERNOS - EM TITULOS', 'COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.04.00', 'OPERACOES COMPROMISSADAS - BACEN', 'REGISTRA VALORES DAS OPERACOES COMPROMISSADAS - BACEN', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.05.00', 'OPERACOES DO BACEN', 'REGISTRA OS VALORES DE OPERACOES DO BACEN', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.06.00', 'OPERACOES ESPECIAIS', 'REGISTRA A APROPRIACAO DOS VALORES DAS OPERACOES ESPECIAIS CONTRAIDAS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULADAS A CONTRATOS E ACORDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.00.00', 'EMPRESTIMOS A CURTO PRAZO - INTERNO- INTER OFSS - ESTADO', 'COMPREENDE OS EMPRESTIMOS CONTRATUAIS OU MOBILIARIOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.01.00', 'PARCELA A CURTO PRAZO DOS EMPRESTIMOS INTERNOS', 'COMPREENDE AS PARCELAS DOS EMPRESTIMOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.02.00', 'EMPRESTIMOS INTERNOS - EM TITULOS', 'COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.03.00', 'EMPRESTIMOS INTERNOS - EM CONTRATOS', 'COMPREENDE OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.04.00', 'OPERACOES COMPROMISSADAS - BACEN', 'COMPREENDE OS VALORES DAS OPERACOES COMPROMISSADAS - BACEN', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.06.00', 'OPERACOES ESPECIAIS', 'COMPREENDE A APROPRIACAO DOS VALORES DAS OPERACOES ESPECIAIS CONTRAIDAS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULADAS A CONTRATOS E ACORDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.00.00', 'EMPRESTIMOS A CURTO PRAZO - INTERNO- INTER OFSS - MUNICIPIO', 'COMPREENDE OS EMPRESTIMOS CONTRATUAIS OU MOBILIARIOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.01.00', 'PARCELA A CURTO PRAZO DOS EMPRESTIMOS INTERNOS', 'COMPREENDE AS PARCELAS DOS EMPRESTIMOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.02.00', 'EMPRESTIMOS INTERNOS - EM TITULOS', 'COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.03.00', 'EMPRESTIMOS INTERNOS - EM CONTRATOS', 'COMPREENDE OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.05.00', 'OPERACOES DO BACEN', 'COMPREENDE OS VALORES DE OPERACOES DO BACEN', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.0.00.00', 'EMPRESTIMOS A CURTO PRAZO - EXTERNO', 'COMPREENDE OS EMPRESTIMOS CONTRATUAIS OU MOBILIARIOS ASSUMIDOS NO EXTERIOR E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.00.00', 'EMPRESTIMOS A CURTO PRAZO - EXTERNO-CONSOLIDACAO', 'COMPREENDE OS EMPRESTIMOS CONTRATUAIS OU MOBILIARIOS ASSUMIDOS NO EXTERIOR E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.01.00', 'PARCELA A CURTO PRAZO DOS EMPRESTIMOS EXTERNOS', 'COMPREENDE AS PARCELAS DOS EMPRESTIMOS ASSUMIDOS NO EXTERIOR E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.02.00', 'EMPRESTIMOS EXTERNOS - EM TITULOS', 'COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS EXTERNAS DECORRENTES DA EMISSAO DE TITULOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.03.00', 'EMPRESTIMOS EXTERNOS - EM CONTRATOS', 'COMPREENDE OS VALORES DAS OPERACOES DE CREDITO EXTERNAS EM CONTRATOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.05.00', 'OPERACOES DO BACEN', 'COMPREENDE OS VALORES DE OPERACOES DO BACEN', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.06.00', 'OPERACOES ESPECIAIS', 'COMPREENDE A APROPRIACAO DOS VALORES DAS OPERACOES ESPECIAIS CONTRAIDAS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULADAS A CONTRATOS E ACORDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.0.00.00', 'FINANCIAMENTOS A CURTO PRAZO - INTERNO', 'COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUICAO FINANCEIRA ASSUMIDAS DENTRO DO PAIS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO ATÉ O TÉRMINO DO EXERCICIO SEGUINTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.00.00', 'FINANCIAMENTOS A CURTO PRAZO-INTERNO- CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUICAO FINANCEIRA ASSUMIDAS DENTRO DO PAIS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO ATÉ O TÉRMINO DO EXERCICIO SEGUINTE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.01.00', 'PARCELA A CURTO PRAZO DOS FINANCIAMENTOS INTERNOS', 'COMPREENDE AS PARCELAS DOS FINANCIAMENTOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.02.00', 'FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.00.00', 'FINANCIAMENTOS A CURTO PRAZO-INTERNO- INTER OFSS - ESTADO', 'COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUICAO FINANCEIRA ASSUMIDAS DENTRO DO PAIS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO ATÉ O TÉRMINO DO EXERCICIO SEGUINTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.01.00', 'PARCELA A CURTO PRAZO DOS FINANCIAMENTOS INTERNOS', 'COMPREENDE AS PARCELAS DOS FINANCIAMENTOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.02.00', 'FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.5.00.00', 'FINANCIAMENTOS A CURTO PRAZO-INTERNO- INTER OFSS - MUNICIPIO', 'COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUICAO FINANCEIRA ASSUMIDAS DENTRO DO PAIS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO ATÉ O TÉRMINO DO EXERCICIO SEGUINTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.5.01.00', 'PARCELA A CURTO PRAZO DOS FINANCIAMENTOS INTERNOS', 'COMPREENDE AS PARCELAS DOS FINANCIAMENTOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.5.02.00', 'FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.0.00.00', 'FINANCIAMENTOS A CURTO PRAZO - EXTERNO', 'COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUICAO FINANCEIRA ASSUMIDAS NO EXTERIOR E TRANSACIONADAS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO ATÉ O TÉRMINO DO EXERCICIO SEGUINTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.1.00.00', 'FINANCIAMENTOS A CURTO PRAZO-EXTERNO- CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUICAO FINANCEIRA ASSUMIDAS NO EXTERIOR E TRANSACIONADAS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO ATÉ O TÉRMINO DO EXERCICIO SEGUINTE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.1.01.00', 'PARCELA A CURTO PRAZO DOS FINANCIAMENTOS EXTERNOS', 'COMPREENDE AS PARCELAS DOS FINANCIAMENTOS ASSUMIDOS NO EXTERIOR E TRANSACIONADAS, EM REGRA, EM MOEDA ESTRANGEIRA, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.1.02.00', 'FINANCIAMENTOS EXTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.0.00.00', 'JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO', 'COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A CURTO PRAZO, ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.00.00', 'JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO -CONSOLIDACAO', 'COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A CURTO PRAZO, ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.01.00', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.02.00', 'ENCARGOS - EMPRESTIMOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.03.00', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.04.00', 'ENCARGOS - FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.00.00', 'JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO - INTER OFSS - ESTADO', 'COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A CURTO PRAZO, ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.01.00', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.03.00', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.04.00', 'ENCARGOS - FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.00.00', 'JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A CURTO PRAZO, ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.01.00', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.02.00', 'ENCARGOS - EMPRESTIMOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.03.00', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.04.00', 'ENCARGOS - FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.0.00.00', 'JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO - EXTERNO', 'COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A CURTO PRAZO, ASSUMIDOS NO EXTERIOR E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.00.00', 'JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO - EXTERNO -CONSOLIDACAO', 'COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A CURTO PRAZO, ASSUMIDOS NO EXTERIOR E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.01.00', 'JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.02.00', 'ENCARGOS - EMPRESTIMOS EXTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.03.00', 'JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.04.00', 'ENCARGOS - FINANCIAMENTOS EXTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.0.00.00', '(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO', 'COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A CURTO PRAZO - INTERNO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.1.00.00', '(-) ENCARGOS FINANCEIROS A APROPRIAR- INTERNO- CONSOLIDACAO', 'COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A CURTO PRAZO - INTERNO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.4.00.00', '(-) ENCARGOS FINANCEIROS A APROPRIAR- INTERNO- INTER OFSS - ESTADO', 'COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A CURTO PRAZO - INTERNO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.5.00.00', '(-) ENCARGOS FINANCEIROS A APROPRIAR- INTERNO- INTER OFSS - MUNICIPIO', 'COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A CURTO PRAZO - INTERNO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.9.0.00.00', '(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO', 'COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A CURTO PRAZO - EXTERNO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.9.1.00.00', '(-) ENCARGOS FINANCEIROS A APROPRIAR- EXTERNO- CONSOLIDACAO', 'COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A CURTO PRAZO - EXTERNO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.0.0.00.00', 'FORNECEDORES E CONTAS A PAGAR A CURTO PRAZO', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR, INCLUSIVE OS PRECATORIOS DECORRENTES DESSAS OBRIGACOES, COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.0.00.00', 'FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.00.00', 'FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.03.00', 'PRECATORIOS DE FORNECEDORES NACIONAIS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.04.00', 'CONTAS A PAGAR CREDORES NACIONAIS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES AO EXERCICIO ATUAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.06.00', 'PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.2.00.00', 'FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - INTRA OFSS', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.2.03.00', 'PRECATORIOS DE FORNECEDORES NACIONAIS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.2.04.00', 'CONTAS A PAGAR CREDORES NACIONAIS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES AO EXERCICIO ATUAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.2.06.00', 'PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.4.00.00', 'FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - INTER OFSS - ESTADO', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.4.03.00', 'PRECATORIOS DE FORNECEDORES NACIONAIS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.4.04.00', 'CONTAS A PAGAR CREDORES NACIONAIS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES AO EXERCICIO ATUAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.4.06.00', 'PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.5.00.00', 'FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - INTER OFSS - MUNICIPIO', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.5.03.00', 'PRECATORIOS DE FORNECEDORES NACIONAIS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.5.04.00', 'CONTAS A PAGAR CREDORES NACIONAIS DO EXERCICIO', 'REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES AO EXERCICIO ATUAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.5.06.00', 'PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.0.00.00', 'FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES ESTRANGEIROS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.00.00', 'FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO - CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES ESTRANGEIROS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.0.0.00.00', 'OBRIGACOES FISCAIS A CURTO PRAZO', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.0.00.00', 'OBRIGACOES FISCAIS A CURTO PRAZO COM A UNIAO', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.00.00', 'OBRIGACOES FISCAIS A CURTO PRAZO COM A UNIAO-CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.2.00.00', 'OBRIGACOES FISCAIS A CURTO PRAZO COM A UNIAO - INTRA OFSS', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.0.00.00', 'OBRIGACOES FISCAIS A CURTO PRAZO COM OS ESTADOS', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA ESTADUAL COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.00.00', 'OBRIGACOES FISCAIS A CURTO PRAZO COM OS ESTADOS-CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA ESTADUAL COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.01.00', 'ICMS A RECOLHER', 'COMPREENDE O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVICOS (ICMS), SUJEITOS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO OU SOBRE MERCADORIAS DE TERCEIROS ENTREGUES PARA DEPOSITO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.00.00', 'OBRIGACOES FISCAIS A CURTO PRAZO COM OS ESTADOS - INTER OFSS - ESTADO', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA ESTADUAL COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.01.00', 'ICMS A RECOLHER', 'COMPREENDE O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVICOS (ICMS), SUJEITOS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO OU SOBRE MERCADORIAS DE TERCEIROS ENTREGUES PARA DEPOSITO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.00.00', 'OBRIGACOES FISCAIS A CURTO PRAZO COM OS MUNICIPIOS -CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA MUNICIPAL COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.00.00', 'OBRIGACOES FISCAIS A CURTO PRAZO COM OS MUNICIPIOS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA MUNICIPAL COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.0.0.00.00', 'PROVISOES A CURTO PRAZO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.1.0.00.00', 'PROVISAO PARA RISCOS TRABALHISTAS A CURTO PRAZO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE RECLAMACOES TRABALHISTAS, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.1.1.00.00', 'PROVISAO PARA RISCOS TRABALHISTAS A CURTO PRAZO - CONSOLIDACAO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE RECLAMACOES TRABALHISTAS , COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.1.00.00', 'PROVISOES PARA RISCOS FISCAIS A CURTO PRAZO - CONSOLIDACAO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUACOES FISCAIS, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.1.01.00', 'PROVISAO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRACAO', 'COMPREENDE OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTOS DE INFRACAO JA LAVRADOS E QUE SE ENCONTRAM NA ESFERA ADMINISTRATIVA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.1.02.00', 'PROVISAO PARA PAGAMENTOS DE AUTUACOES FISCAIS - ESFERA JUDICIAL', 'COMPREENDE OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTUACOES FISCAIS QUE JA SE ENCONTRAM NA ESFERA JUDICIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.1.00.00', 'PROVISAO PARA RISCOS CIVEIS A CURTO PRAZO - CONSOLIDACAO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.2.00.00', 'PROVISAO PARA RISCOS CIVEIS A CURTO PRAZO - INTRA OFSS', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.4.00.00', 'PROVISAO PARA RISCOS CIVEIS A CURTO PRAZO - INTER OFSS - ESTADO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.5.00.00', 'PROVISAO PARA RISCOS CIVEIS A CURTO PRAZO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.5.0.00.00', 'PROVISAO PARA REPARTICAO DE CREDITOS A CURTO PRAZO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CREDITOS TRIBUTARIOS E NAO TRIBUTARIOS RECONHECIDOS NO LANCAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERACAO. NA ARRECADACAO, ESTA PROVISAO SERA REVERTIDA EM CONTA ESPECIFICA DE PASSIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.6.0.00.00', 'PROVISAO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUCAO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.0.00.00', 'OUTRAS PROVISOES A CURTO PRAZO', 'COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO, NAO CLASSIFICADOS ANTERIORMENTE NESTE PLANO DE CONTAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.1.00.00', 'OUTRAS PROVISOES A CURTO PRAZO -CONSOLIDACAO', 'COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS,COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO, NAO CLASSIFICADOS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.2.00.00', 'OUTRAS PROVISOES A CURTO PRAZO - INTRA OFSS', 'COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO, NAO CLASSIFICADOS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.4.00.00', 'OUTRAS PROVISOES A CURTO PRAZO - INTER OFSS - ESTADO', 'COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO, NAO CLASSIFICADOS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.5.00.00', 'OUTRAS PROVISOES A CURTO PRAZO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO CURTO PRAZO, NAO CLASSIFICADOS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.0.0.00.00', 'DEMAIS OBRIGACOES A CURTO PRAZO', 'COMPREENDE AS OBRIGACOES DA ENTIDADE JUNTO A TERCEIROS NAO INCLUSAS NOS SUBGRUPOS ANTERIORES,INCLUSIVE OS PRECATORIOS DECORRENTES DESTAS OBRIGACOES, COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.1.0.00.00', 'ADIANTAMENTOS DE CLIENTES', 'COMPREENDE AS ANTECIPACOES RECEBIDAS PELO ENTE POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.2.0.00.00', 'OBRIGACOES POR DANOS A TERCEIROS', 'COMPREENDE OS VALORES EXIGIVEIS NO CURTO PRAZO, PROVENIENTES DE DANOS A TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.3.0.00.00', 'ARRENDAMENTO OPERACIONAL A PAGAR', 'COMPREENDE AS OBRIGACOES A CURTO PRAZO REFERENTES A ARRENDAMENTOS MERCANTIS, NOS QUAIS NAO SAO TRANSFERIDOS AO ARRENDADOR OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, NAO HAVENDO A POSSIBILIDADE DE OPCAO DE COMPRA DO BEM ARRENDADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.0.00.00', 'DEBENTURES E OUTROS TITULOS DE DIVIDA A CURTO PRAZO', 'COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO, COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.1.00.00', 'DEBENTURES E OUTROS TITULOS DE DIVIDA A CURTO PRAZO-CONSOLIDACAO', 'COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.0.00.00', 'DIVIDENDOS A PAGAR', 'COMPREENDE OS DIVIDENDOS APROVADOS PELA ASSEMBLEIA GERAL A SEREM PAGOS AOS ACIONISTAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.1.00.00', 'DIVIDENDOS A PAGAR-CONSOLIDACAO', 'COMPREENDE OS DIVIDENDOS APROVADOS PELA ASSEMBLEIA GERAL A SEREM PAGOS AOS ACIONISTAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.2.00.00', 'DIVIDENDOS A PAGAR-INTRA OFSS', 'COMPREENDE OS DIVIDENDOS APROVADOS PELA ASSEMBLEIA GERAL A SEREM PAGOS AOS ACIONISTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.4.00.00', 'DIVIDENDOS A PAGAR- INTER OFSS - ESTADO', 'COMPREENDE OS DIVIDENDOS APROVADOS PELA ASSEMBLEIA GERAL A SEREM PAGOS AOS ACIONISTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.5.00.00', 'DIVIDENDOS A PAGAR- INTER OFSS - MUNICIPIO', 'COMPREENDE OS DIVIDENDOS APROVADOS PELA ASSEMBLEIA GERAL A SEREM PAGOS AOS ACIONISTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.00.00', 'VALORES RESTITUIVEIS - CONSOLIDACAO', 'COMPREENDE OS VALORES DE TERCEIROS OU RETENCOES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PUBLICO FOR FIEL DEPOSITARIA, INDEPENDENTEMENTE DO PRAZO DE EXIGIBILIDADE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.00', 'CONSIGNACOES', 'COMPREENDE OS VALORES ENTREGUES EM CONFIANCA OU EM CONSIGNACOES, GERALMENTE RETIDOS EM FOLHA DE PAGAMENTO DE EMPREGADOS OU SERVIDORES OU NOS PAGAMENTOS REFERENTES A COMPRAS DE BENS E SERVICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.03.00', 'DEPOSITOS JUDICIAIS', 'REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL E DEPOSITOS PARA RECURSOS JUDICIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.00', 'DEPOSITOS NAO JUDICIAIS', 'REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS, EXCETO DEPOSITOS JUDICIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.06.00', 'DEPOSITOS COMPULSORIOS', 'COMPREENDE OS VALORES DE OBRIGACOES CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS COMPULSORIOS RELATIVOS A COMBUSTIVEIS, VEICULOS E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.00.00', 'VALORES RESTITUIVEIS - INTRA OFSS', 'COMPREENDE OS VALORES DE TERCEIROS OU RETENCOES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PUBLICO FOR FIEL DEPOSITARIA, INDEPENDENTEMENTE DO PRAZO DE EXIGIBILIDADE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.01.00', 'CONSIGNACOES', 'COMPREENDE OS VALORES ENTREGUES EM CONFIANCA OU EM CONSIGNACOES, GERALMENTE RETIDOS EM FOLHA DE PAGAMENTO DE EMPREGADOS OU SERVIDORES OU NOS PAGAMENTOS REFERENTES A COMPRAS DE BENS E SERVICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.04.00', 'DEPOSITOS NAO JUDICIAIS', 'REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS, EXCETO DEPOSITOS JUDICIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.2.06.00', 'DEPOSITOS COMPULSORIOS', 'COMPREENDE OS VALORES DE OBRIGACOES CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS COMPULSORIOS RELATIVOS A COMBUSTIVEIS, VEICULOS E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.00.00', 'VALORES RESTITUIVEIS - INTER OFSS - ESTADO', 'COMPREENDE OS VALORES DE TERCEIROS OU RETENCOES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PUBLICO FOR FIEL DEPOSITARIA, INDEPENDENTEMENTE DO PRAZO DE EXIGIBILIDADE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.01.00', 'CONSIGNACOES', 'COMPREENDE OS VALORES ENTREGUES EM CONFIANCA OU EM CONSIGNACOES, GERALMENTE RETIDOS EM FOLHA DE PAGAMENTO DE EMPREGADOS OU SERVIDORES OU NOS PAGAMENTOS REFERENTES A COMPRAS DE BENS E SERVICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.03.00', 'DEPOSITOS JUDICIAIS', 'REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL E DEPOSITOS PARA RECURSOS JUDICIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.04.00', 'DEPOSITOS NAO JUDICIAIS', 'REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS, EXCETO DEPOSITOS JUDICIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.4.06.00', 'DEPOSITOS COMPULSORIOS', 'COMPREENDE OS VALORES DE OBRIGACOES CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS COMPULSORIOS RELATIVOS A COMBUSTIVEIS, VEICULOS E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.00.00', 'VALORES RESTITUIVEIS - INTER OFSS - MUNICIPIO', 'COMPREENDE OS VALORES DE TERCEIROS OU RETENCOES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PUBLICO FOR FIEL DEPOSITARIA, INDEPENDENTEMENTE DO PRAZO DE EXIGIBILIDADE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.01.00', 'CONSIGNACOES', 'COMPREENDE OS VALORES ENTREGUES EM CONFIANCA OU EM CONSIGNACOES, GERALMENTE RETIDOS EM FOLHA DE PAGAMENTO DE EMPREGADOS OU SERVIDORES OU NOS PAGAMENTOS REFERENTES A COMPRAS DE BENS E SERVICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.03.00', 'DEPOSITOS JUDICIAIS', 'REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL E DEPOSITOS PARA RECURSOS JUDICIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.5.06.00', 'DEPOSITOS COMPULSORIOS', 'COMPREENDE OS VALORES DE OBRIGACOES CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS COMPULSORIOS RELATIVOS A COMBUSTIVEIS, VEICULOS E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.0.00.00', 'OUTRAS OBRIGACOES A CURTO PRAZO', 'COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO CURTO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.00.00', 'OUTRAS OBRIGACOES A CURTO PRAZO-CONSOLIDACAO', 'COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.01.00', 'INDENIZACOES E RESTITUICOES', 'COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.04.00', 'REEMBOLSOS A SEREM EFETUADOS PELO INSS', 'COMPREENDE OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM O DESEMBOLSO A TITULO DE SALARIO FAMILIA E AUXILIO NATALIDADE A SEUS EMPREGADOS, BEM COMO EFETUARAM OUTROS PAGAMENTOS E ANTECIPACOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.05.00', 'CONVENIOS A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.06.00', 'CONVENIOS A PAGAR - PORTAL/SICONV', 'COMPREENDE OS VALORES A PAGAR REFERENTES A CONVENIOS REGISTRADOS PELO PORTAL / SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.07.00', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.08.00', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR, REGISTRADOS NO PORTAL SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.09.00', 'TERMOS DE PARCERIA A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.10.00', 'TERMOS DE PARCERIA A PAGAR- PORTAL SICONV', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV. O TERMO DE PARCERIA E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3.100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.11.00', 'TERMO DE COMPROMISSO A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.13.00', 'PRECATORIOS DE TERCEIROS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.14.00', 'COMPENSACAO PREVIDENCIARIA', 'COMPREENDE O VALOR DAS OBRIGACOES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3.112/1999.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.19.00', 'BOLSAS PARA ESTUDOS', 'COMPREENDE AS OBRIGACOES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.22.00', 'CONTRATOS DE COOPERACAO TECNICA', 'COMPREENDE OS VALORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001) DO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.25.00', 'TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS', 'COMPREENDE O VALOR A LIBERAR CONCERNENTE A TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS NAO ESPECIFICADAS EM OUTRAS CONTAS, A SABER: MERENDA ESCOLAR (PNAE), PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE), FUNDEF, QUOTA ESTADUAL (SALARIO EDUCACAO), EJA, PTA, TRANSPORTE ESCOLAR - PNTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.33.00', 'ADIANTAMENTOS RECEBIDOS', 'COMPREENDE OS VALORES EXIGIVEIS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, A TITULO DE ADIANTAMENTOS RECEBIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.34.00', 'DEBITOS COM OPERACOES TIPICAS DO SISTEMA FINANCEIRO', 'REGISTRA OS VALORES DEBITOS DECORRENTES DE OPERACOES TIPICAS DO SISTEMA FINANCEIRO, INCLUSIVE DE OPERACOES COM DERIVATIVOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.35.00', 'INTERMEDIARIOS DE INVESTIMENTOS', 'COMPREENDE OS VALORES DE OBRIGACOES A CURTO PRAZO COM INTERMEDIARIOS DE INVESTIMENTOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.36.00', 'VALORES EM TRANSITO EXIGIVEIS', 'COMPREENDE O VALOR DA ORDEM BANCARIA OU OUTRO DOCUMENTO EMITIDO PARA SAQUE CONTRA ESTABELECIMENTO BANCARIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.40.00', 'RECURSOS ESPECIAIS A LIBERAR', 'COMPREENDE A DESPESA EMPENHADA E NAO PAGA, APURADA AO FINAL DO EXERCICIO E INSCRITA EM RESTOS A PAGAR, PROCESSADOS E NAO PROCESSADOS, BEM COMO OS RECURSOS APROVADOS E NAO LIBERADOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.41.00', 'PARTICIPACOES EM EMPRESAS COM PL NEGATIVO', 'COMPREENDE OS VALORES REFERENTES A PARTICIPACOES PELO METODO DA EQUIVALENCIA PATRIMONIAL EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO (PASSIVO A DESCOBERTO).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.98.00', 'OUTROS CREDORES A CURTO PRAZO', 'COMPREENDE OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.01.00', 'INDENIZACOES E RESTITUICOES', 'COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.04.00', 'REEMBOLSOS A SEREM EFETUADOS PELO INSS', 'COMPREENDE OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM O DESEMBOLSO A TITULO DE SALARIO FAMILIA E AUXILIO NATALIDADE A SEUS EMPREGADOS, BEM COMO EFETUARAM OUTROS PAGAMENTOS E ANTECIPACOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.05.00', 'CONVENIOS A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.06.00', 'CONVENIOS A PAGAR - PORTAL/SICONV', 'COMPREENDE OS VALORES A PAGAR REFERENTES A CONVENIOS REGISTRADOS PELO PORTAL / SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.07.00', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.08.00', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR, REGISTRADOS NO PORTAL SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.09.00', 'TERMOS DE PARCERIA A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.10.00', 'TERMOS DE PARCERIA A PAGAR- PORTAL SICONV', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV. O TERMO DE PARCERIA E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.13.00', 'PRECATORIOS DE TERCEIROS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.14.00', 'COMPENSACAO PREVIDENCIARIA', 'COMPREENDE O VALOR DAS OBRIGACOES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.19.00', 'BOLSAS PARA ESTUDOS', 'COMPREENDE AS OBRIGACOES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.22.00', 'CONTRATOS DE COOPERACAO TECNICA', 'COMPREENDE OS VALORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001) DO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.25.00', 'TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS', 'COMPREENDE O VALOR A LIBERAR CONCERNENTE A TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS NAO ESPECIFICADAS EM OUTRAS CONTAS, A SABER: MERENDA ESCOLAR (PNAE), PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE), FUNDEF, QUOTA ESTADUAL (SALARIO EDUCACAO), EJA, PTA, TRANSPORTE ESCOLAR - PNTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.29.00', 'RESULTADO NEGATIVO DO BANCO CENTRAL', 'COMPREENDE OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL A SER REEMBOLSADO PELO TESOURO NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.33.00', 'ADIANTAMENTOS RECEBIDOS', 'COMPREENDE OS VALORES EXIGIVEIS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, A TITULO DE ADIANTAMENTOS RECEBIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.34.00', 'DEBITOS COM OPERACOES TIPICAS DO SISTEMA FINANCEIRO', 'REGISTRA OS VALORES DEBITOS DECORRENTES DE OPERACOES TIPICAS DO SISTEMA FINANCEIRO, INCLUSIVE DE OPERACOES COM DERIVATIVOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.36.00', 'VALORES EM TRANSITO EXIGIVEIS', 'COMPREENDE O VALOR DA ORDEM BANCARIA OU OUTRO DOCUMENTO EMITIDO PARA SAQUE CONTRA ESTABELECIMENTO BANCARIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.37.00', 'SUBVENCOES A PAGAR', 'COMPREENDE O SOMATORIO DAS SUBVENCOES A PAGAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.39.00', 'VALORES DIFERIDOS', 'COMPREENDE O SALDO FINANCEIRO TOTAL DISPONIVEL NO FINAL DO EXERCICIOQUE SE CONSTITUIRA ANTECIPACAO DE COTA, REPASSE OU SUB-REPASSE DO EXERCICIO SEGUINTE (DECRETO-LEI Nº 1205/72).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.40.00', 'RECURSOS ESPECIAIS A LIBERAR', 'COMPREENDE A DESPESA EMPENHADA E NAO PAGA, APURADA AO FINAL DO EXERCICIO E INSCRITA EM RESTOS A PAGAR, PROCESSADOS E NAO PROCESSADOS, BEM COMO OS RECURSOS APROVADOS E NAO LIBERADOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.41.00', 'PARTICIPACOES EM EMPRESAS COM PL NEGATIVO', 'COMPREENDE OS VALORES REFERENTES A PARTICIPACOES PELO METODO DA EQUIVALENCIA PATRIMONIAL EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO (PASSIVO A DESCOBERTO).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.98.00', 'OUTROS CREDORES A CURTO PRAZO', 'COMPREENDE OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.00.00', 'OUTRAS OBRIGACOES A CURTO PRAZO- INTER OFSS - ESTADO', 'COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.01.00', 'INDENIZACOES E RESTITUICOES', 'COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.04.00', 'REEMBOLSOS A SEREM EFETUADOS PELO INSS', 'COMPREENDE OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM O DESEMBOLSO A TITULO DE SALARIO FAMILIA E AUXILIO NATALIDADE A SEUS EMPREGADOS, BEM COMO EFETUARAM OUTROS PAGAMENTOS E ANTECIPACOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.06.00', 'CONVENIOS A PAGAR - PORTAL/SICONV', 'COMPREENDE OS VALORES A PAGAR REFERENTES A CONVENIOS REGISTRADOS PELO PORTAL / SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.07.00', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.08.00', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR, REGISTRADOS NO PORTAL SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.09.00', 'TERMOS DE PARCERIA A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.10.00', 'TERMOS DE PARCERIA A PAGAR - PORTAL SICONV', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV. O TERMO DE PARCERIA E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.11.00', 'TERMO DE COMPROMISSO A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.14.00', 'COMPENSACAO PREVIDENCIARIA', 'COMPREENDE O VALOR DAS OBRIGACOES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.19.00', 'BOLSAS PARA ESTUDOS', 'COMPREENDE AS OBRIGACOES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.22.00', 'CONTRATOS DE COOPERACAO TECNICA', 'COMPREENDE OS VALORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001) DO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.23.00', 'AUXILIOS FINANCEIROS A PESQUISADORES', 'COMPREENDE AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.25.00', 'TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS', 'COMPREENDE O VALOR A LIBERAR CONCERNENTE A TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS NAO ESPECIFICADAS EM OUTRAS CONTAS, A SABER: MERENDA ESCOLAR (PNAE), PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE), FUNDEF, QUOTA ESTADUAL (SALARIO EDUCACAO), EJA, PTA, TRANSPORTE ESCOLAR - PNTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.28.00', 'RESULTADO NEGATIVO DO BANCO CENTRAL', 'COMPREENDE OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL A SER REEMBOLSADO PELO TESOURO NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.32.00', 'ADIANTAMENTOS RECEBIDOS', 'COMPREENDE OS VALORES EXIGIVEIS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, A TITULO DE ADIANTAMENTOS RECEBIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.33.00', 'DEBITOS COM OPERACOES TIPICAS DO SISTEMA FINANCEIRO', 'REGISTRA OS VALORES DEBITOS DECORRENTES DE OPERACOES TIPICAS DO SISTEMA FINANCEIRO, INCLUSIVE DE OPERACOES COM DERIVATIVOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.34.00', 'INTERMEDIARIOS DE INVESTIMENTOS', 'COMPREENDE OS VALORES DE OBRIGACOES A CURTO PRAZO COM INTERMEDIARIOS DE INVESTIMENTOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.35.00', 'VALORES EM TRANSITO EXIGIVEIS', 'COMPREENDE O VALOR DA ORDEM BANCARIA OU OUTRO DOCUMENTO EMITIDO PARA SAQUE CONTRA ESTABELECIMENTO BANCARIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.36.00', 'SUBVENCOES A PAGAR', 'COMPREENDE O SOMATORIO DAS SUBVENCOES A PAGAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.39.00', 'RECURSOS ESPECIAIS A LIBERAR', 'COMPREENDE A DESPESA EMPENHADA E NAO PAGA, APURADA AO FINAL DO EXERCICIO E INSCRITA EM RESTOS A PAGAR, PROCESSADOS E NAO PROCESSADOS, BEM COMO OS RECURSOS APROVADOS E NAO LIBERADOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.40.00', 'PARTICIPACOES EM EMPRESAS COM PL NEGATIVO', 'COMPREENDE OS VALORES REFERENTES A PARTICIPACOES PELO METODO DA EQUIVALENCIA PATRIMONIAL EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO (PASSIVO A DESCOBERTO).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.4.98.00', 'OUTROS CREDORES A CURTO PRAZO', 'COMPREENDE OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.00.00', 'OUTRAS OBRIGACOES A CURTO PRAZO- INTER OFSS - MUNICIPIO', 'COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO CURTO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.04.00', 'REEMBOLSOS A SEREM EFETUADOS PELO INSS', 'COMPREENDE OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM O DESEMBOLSO A TITULO DE SALARIO FAMILIA E AUXILIO NATALIDADE A SEUS EMPREGADOS, BEM COMO EFETUARAM OUTROS PAGAMENTOS E ANTECIPACOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.05.00', 'CONVENIOS A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.06.00', 'CONVENIOS A PAGAR - PORTAL/SICONV', 'COMPREENDE OS VALORES A PAGAR REFERENTES A CONVENIOS REGISTRADOS PELO PORTAL / SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.07.00', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.08.00', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR, REGISTRADOS NO PORTAL SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.09.00', 'TERMOS DE PARCERIA A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.10.00', 'TERMOS DE PARCERIA A PAGAR - PORTAL SICONV', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV. O TERMO DE PARCERIA E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.13.00', 'PRECATORIOS DE TERCEIROS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.14.00', 'COMPENSACAO PREVIDENCIARIA', 'COMPREENDE O VALOR DAS OBRIGACOES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.19.00', 'BOLSAS PARA ESTUDOS', 'COMPREENDE AS OBRIGACOES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.22.00', 'CONTRATOS DE COOPERACAO TECNICA', 'COMPREENDE OS VALORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001) DO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.25.00', 'TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS', 'COMPREENDE O VALOR A LIBERAR CONCERNENTE A TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS NAO ESPECIFICADAS EM OUTRAS CONTAS, A SABER: MERENDA ESCOLAR (PNAE), PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE), FUNDEF, QUOTA ESTADUAL (SALARIO EDUCACAO), EJA, PTA, TRANSPORTE ESCOLAR - PNTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.28.00', 'RESULTADO NEGATIVO DO BANCO CENTRAL', 'COMPREENDE OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL A SER REEMBOLSADO PELO TESOURO NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.32.00', 'ADIANTAMENTOS RECEBIDOS', 'COMPREENDE OS VALORES EXIGIVEIS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, A TITULO DE ADIANTAMENTOS RECEBIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.33.00', 'DEBITOS COM OPERACOES TIPICAS DO SISTEMA FINANCEIRO', 'REGISTRA OS VALORES DEBITOS DECORRENTES DE OPERACOES TIPICAS DO SISTEMA FINANCEIRO, INCLUSIVE DE OPERACOES COM DERIVATIVOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.34.00', 'INTERMEDIARIOS DE INVESTIMENTOS', 'COMPREENDE OS VALORES DE OBRIGACOES A CURTO PRAZO COM INTERMEDIARIOS DE INVESTIMENTOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.35.00', 'VALORES EM TRANSITO EXIGIVEIS', 'COMPREENDE O VALOR DA ORDEM BANCARIA OU OUTRO DOCUMENTO EMITIDO PARA SAQUE CONTRA ESTABELECIMENTO BANCARIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.36.00', 'SUBVENCOES A PAGAR', 'COMPREENDE O SOMATORIO DAS SUBVENCOES A PAGAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.39.00', 'RECURSOS ESPECIAIS A LIBERAR', 'COMPREENDE A DESPESA EMPENHADA E NAO PAGA, APURADA AO FINAL DO EXERCICIO E INSCRITA EM RESTOS A PAGAR, PROCESSADOS E NAO PROCESSADOS, BEM COMO OS RECURSOS APROVADOS E NAO LIBERADOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.40.00', 'PARTICIPACOES EM EMPRESAS COM PL NEGATIVO', 'COMPREENDE OS VALORES REFERENTES A PARTICIPACOES PELO METODO DA EQUIVALENCIA PATRIMONIAL EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO (PASSIVO A DESCOBERTO).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.5.98.00', 'OUTROS CREDORES A CURTO PRAZO', 'COMPREENDE OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.0.0.0.00.00', 'PASSIVO NAO-CIRCULANTE', 'COMPREENDE AS OBRIGACOES CONHECIDAS E ESTIMADAS QUE NAO ATENDAM A NENHUM DOS CRITERIOS PARA SEREM CLASSIFICADAS NO PASSIVO CIRCULANTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.0.0.00.00', 'OBRIGACOES TRABALHISTAS, PREVIDENCIARIAS E ASSISTENCIAIS A PAGAR A LONGO PRAZO', 'COMPREENDE AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, APOSENTADORIAS, REFORMAS, PENSOES, ENCARGOS A PAGAR, BENEFICIOS ASSISTENCIAIS, INCLUSIVE OS PRECATORIOS DECORRENTES DESTAS OBRIGACOES, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.0.00.00', 'PESSOAL A PAGAR', 'COMPREENDE AS OBRIGACOES A LONGO PRAZO REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.1.00.00', 'PESSOAL A PAGAR-CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES A LONGO PRAZO REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.1.02.00', 'PRECATORIOS DE PESSOAL', 'COMPREENDE OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.2.0.00.00', 'BENEFICIOS PREVIDENCIARIOS A PAGAR', 'COMPREENDE AS OBRIGACOES A LONGO PRAZO REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.2.1.00.00', 'BENEFICIOS PREVIDENCIARIOS A PAGAR - CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES A LONGO PRAZO REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.2.1.01.00', 'PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.3.1.00.00', 'BENEFICIOS ASSISTENCIAIS A PAGAR - CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES A LONGO PRAZO RELATIVAS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.0.00.00', 'ENCARGOS SOCIAIS A PAGAR', 'COMPREENDE AS OBRIGACOES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.1.00.00', 'ENCARGOS SOCIAIS A PAGAR-CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.2.00.00', 'ENCARGOS SOCIAIS A PAGAR-INTRA OFSS', 'COMPREENDE AS OBRIGACOES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.2.01.00', 'INSS A PAGAR', 'COMPREENDE OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.2.02.00', 'CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)', 'COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.2.03.00', 'ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR', 'COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.4.00.00', 'ENCARGOS SOCIAIS A PAGAR- INTER OFSS - ESTADO', 'COMPREENDE AS OBRIGACOES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.4.01.00', 'INSS A PAGAR', 'COMPREENDE OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.4.02.00', 'CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)', 'COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.4.03.00', 'ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR', 'COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.5.00.00', 'ENCARGOS SOCIAIS A PAGAR- INTER OFSS - MUNICIPIO', 'COMPREENDE AS OBRIGACOES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.5.01.00', 'INSS A PAGAR', 'COMPREENDE OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.5.02.00', 'CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)', 'COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.5.03.00', 'ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR', 'COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.0.0.00.00', 'EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO', 'COMPREENDE AS OBRIGACOES FINANCEIRAS DA ENTIDADE A TITULO DE EMPRESTIMOS, BEM COMO AS AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR, COM VENCIMENTOS NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.0.00.00', 'EMPRESTIMOS A LONGO PRAZO - INTERNO', 'COMPREENDE OS EMPRESTIMOS CONTRATUAIS OU MOBILIARIOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.00.00', 'EMPRESTIMOS A LONGO PRAZO - INTERNO-CONSOLIDACAO', 'COMPREENDE OS EMPRESTIMOS CONTRATUAIS OU MOBILIARIOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.01.00', 'EMPRESTIMOS INTERNOS - EM TITULOS', 'COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.00.00', 'EMPRESTIMOS A LONGO PRAZO - INTERNO- INTER OFSS - ESTADO', 'COMPREENDE OS EMPRESTIMOS CONTRATUAIS OU MOBILIARIOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.00.00', 'EMPRESTIMOS A LONGO PRAZO - INTERNO- INTER OFSS - MUNICIPIO', 'COMPREENDE OS EMPRESTIMOS CONTRATUAIS OU MOBILIARIOS ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.2.0.00.00', 'EMPRESTIMOS A LONGO PRAZO - EXTERNO', 'COMPREENDE OS EMPRESTIMOS CONTRATUAIS OU MOBILIARIOS ASSUMIDOS NO EXTERIOR E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.2.1.00.00', 'EMPRESTIMOS A LONGO PRAZO - EXTERNO-CONSOLIDACAO', 'COMPREENDE OS EMPRESTIMOS CONTRATUAIS OU MOBILIARIOS ASSUMIDOS NO EXTERIOR E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.2.1.01.00', 'EMPRESTIMOS EXTERNOS - EM TITULOS', 'COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS EXTERNAS DECORRENTES DA EMISSAO DE TITULOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.0.00.00', 'FINANCIAMENTOS A LONGO PRAZO - INTERNO', 'COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUICAO FINANCEIRA ASSUMIDAS DENTRO DO PAIS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.1.00.00', 'FINANCIAMENTOS A LONGO PRAZO-INTERNO- CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUICAO FINANCEIRA ASSUMIDAS DENTRO DO PAIS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.4.00.00', 'FINANCIAMENTOS A LONGO PRAZO-INTERNO- INTER OFSS - ESTADO', 'COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUICAO FINANCEIRA ASSUMIDAS DENTRO DO PAIS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.4.01.00', 'FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.5.00.00', 'FINANCIAMENTOS A LONGO PRAZO-INTERNO- INTER OFSS - MUNICIPIO', 'COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUICAO FINANCEIRA ASSUMIDAS DENTRO DO PAIS E TRANSACIONADAS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.5.01.00', 'FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.0.00.00', 'FINANCIAMENTOS A LONGO PRAZO - EXTERNO', 'COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUICAO FINANCEIRA ASSUMIDAS NO EXTERIOR E TRANSACIONADAS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.00.00', 'FINANCIAMENTOS A LONGO PRAZO-EXTERNO- CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR OU INSTITUICAO FINANCEIRA ASSUMIDAS NO EXTERIOR E TRANSACIONADAS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.01.00', 'FINANCIAMENTOS EXTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.03.00', 'EFEITOS INFLACIONARIOS SOBRE OPERACOES ESPECIAIS', 'COMPREENDE AS VARIACOES ATIVAS DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS E DA CONTA ESPECIAL DE BANCOS QUANDO VARIACAO DEVEDORA E AINDA VARIACAO DAS OPERACOES DA BOLSA DE MOEDAS QUANDO DEVEDORAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.0.00.00', 'JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO', 'COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO, ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.00.00', 'JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO -CONSOLIDACAO', 'COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO, ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.01.00', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.02.00', 'ENCARGOS - EMPRESTIMOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.03.00', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.04.00', 'ENCARGOS - FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.00.00', 'JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO - INTER OFSS - ESTADO', 'COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO, ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.01.00', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.03.00', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.00.00', 'JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO, ASSUMIDOS DENTRO DO PAIS E TRANSACIONADOS, EM REGRA, EM MOEDA NACIONAL, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.01.00', 'JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.02.00', 'ENCARGOS - EMPRESTIMOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.03.00', 'JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.04.00', 'ENCARGOS - FINANCIAMENTOS INTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.0.00.00', 'JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTERNO', 'COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO, ASSUMIDOS NO EXTERIOR E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.00.00', 'JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTERNO -CONSOLIDACAO', 'COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO, ASSUMIDOS NO EXTERIOR E TRANSACIONADOS, EM REGRA, EM MOEDA ESTRANGEIRA, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.01.00', 'JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.02.00', 'ENCARGOS - EMPRESTIMOS EXTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.03.00', 'JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.04.00', 'ENCARGOS - FINANCIAMENTOS EXTERNOS', 'COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.0.00.00', '(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO', 'COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A LONGO PRAZO - INTERNO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.1.00.00', '(-) ENCARGOS FINANCEIROS A APROPRIAR- INTERNO- CONSOLIDACAO', 'COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A LONGO PRAZO - INTERNO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.4.00.00', '(-) ENCARGOS FINANCEIROS A APROPRIAR- INTERNO- INTER OFSS - ESTADO', 'COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A LONGO PRAZO - INTERNO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.5.00.00', '(-) ENCARGOS FINANCEIROS A APROPRIAR- INTERNO- INTER OFSS - MUNICIPIO', 'COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A LONGO PRAZO - INTERNO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.9.0.00.00', '(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO', 'COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A LONGO PRAZO - EXTERNO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.9.1.00.00', '(-) ENCARGOS FINANCEIROS A APROPRIAR- EXTERNO- CONSOLIDACAO', 'COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A LONGO PRAZO - EXTERNO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.0.0.00.00', 'FORNECEDORES A LONGO PRAZO', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE,INCLUSIVE OS PRECATORIOS DECORRENTES DESTAS OBRIGACOES, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.0.00.00', 'FORNECEDORES NACIONAIS A LONGO PRAZO', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.00.00', 'FORNECEDORES NACIONAIS A LONGO PRAZO - CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.03.00', 'PRECATORIOS DE FORNECEDORES NACIONAIS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.2.00.00', 'FORNECEDORES NACIONAIS A LONGO PRAZO - INTRA OFSS', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.2.03.00', 'PRECATORIOS DE FORNECEDORES NACIONAIS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.4.00.00', 'FORNECEDORES NACIONAIS A LONGO PRAZO - INTER OFSS - ESTADO', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.4.03.00', 'PRECATORIOS DE FORNECEDORES NACIONAIS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.5.00.00', 'FORNECEDORES NACIONAIS A LONGO PRAZO - INTER OFSS - MUNICIPIO', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.5.03.00', 'PRECATORIOS DE FORNECEDORES NACIONAIS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.2.0.00.00', 'FORNECEDORES ESTRANGEIROS A LONGO PRAZO', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES ESTRANGEIROS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.2.1.00.00', 'FORNECEDORES ESTRANGEIROS A LONGO PRAZO - CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES ESTRANGEIROS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.0.0.00.00', 'OBRIGACOES FISCAIS A LONGO PRAZO', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.0.00.00', 'OBRIGACOES FISCAIS A LONGO PRAZO COM A UNIAO', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.00.00', 'OBRIGACOES FISCAIS A LONGO PRAZO COM A UNIAO - CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.00.00', 'OBRIGACOES FISCAIS A LONGO PRAZO COM A UNIAO - INTRA OFSS', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.0.00.00', 'OBRIGACOES FISCAIS A LONGO PRAZO COM OS ESTADOS', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO ESTADUAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.1.00.00', 'OBRIGACOES FISCAIS A LONGO PRAZO COM OS ESTADOS - CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO ESTADUAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.4.00.00', 'OBRIGACOES FISCAIS A LONGO PRAZO COM OS ESTADOS - INTER OFSS - ESTADO', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO ESTADUAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.0.00.00', 'OBRIGACOES FISCAIS A LONGO PRAZO COM OS MUNICIPIOS', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO MUNICIPAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.1.00.00', 'OBRIGACOES FISCAIS A LONGO PRAZO COM OS MUNICIPIOS - CONSOLIDACAO', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO MUNICIPAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.5.00.00', 'OBRIGACOES FISCAIS A LONGO PRAZO COM OS MUNICIPIOS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO MUNICIPAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.0.0.00.00', 'PROVISOES A LONGO PRAZO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.1.0.00.00', 'PROVISAO PARA RISCOS TRABALHISTAS A LONGO PRAZO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE RECLAMACOES TRABALHISTAS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.1.1.00.00', 'PROVISAO PARA RISCOS TRABALHISTAS A LONGO PRAZO - CONSOLIDACAO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE RECLAMACOES TRABALHISTAS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.0.00.00', 'PROVISOES MATEMATICAS PREVIDENCIARIAS A LONGO PRAZO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A FUTUROS BENEFICIOS PREVIDENCIARIOS A SEREM PAGOS AOS CONTRIBUINTES, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.00.00', 'PROVISOES MATEMATICAS PREVIDENCIARIAS A LONGO PRAZO - CONSOLIDACAO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A FUTUROS BENEFICIOS PREVIDENCIARIOS A SEREM PAGOS AOS CONTRIBUINTES, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.00', 'PLANO FINANCEIRO - PROVISOES DE BENEFICIOS CONCEDIDOS', 'COMPREENDE, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, A PROVISAO MATEMATICA CORRESPONDENTE AO VALOR PRESENTE LIQUIDO DAS PRESTACOES FUTURAS DOS BENEFICIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTACAO CONTINUADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.02.00', 'PLANO FINANCEIRO - PROVISOES DE BENEFICIOS A CONCEDER', 'COMPREENDE, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, A PROVISAO MATEMATICA CORRESPONDENTE AO VALOR PRESENTE LIQUIDO DAS PRESTACOES FUTURAS DOS BENEFICIOS A CONCEDER PARA A GERACAO ATUAL (SERVIDORES ATIVOS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.03.00', 'PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS CONCEDIDOS', 'COMPREENDE, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, A PROVISAO MATEMATICA CORRESPONDENTE AO VALOR PRESENTE LIQUIDO DAS PRESTACOES FUTURAS DOS BENEFICIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTACAO CONTINUADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.04.00', 'PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS A CONCEDER', 'COMPREENDE, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, A PROVISAO MATEMATICA CORRESPONDENTE AO VALOR PRESENTE LIQUIDO DAS PRESTACOES FUTURAS DOS BENEFICIOS A CONCEDER PARA A GERACAO ATUAL (SERVIDORES ATIVOS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.05.00', 'PLANO PREVIDENCIARIO - PLANO DE AMORTIZACAO', 'COMPREENDE, DE ACORDO COM RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE LIQUIDO DOS DIREITOS INCORPORADOS AO PATRIMONIO DO RPPS COM BASE EM LEGISLACAO ESPECIFICA, BEM COMO REGISTRO TEMPESTIVO DO PLANO DE AMORTIZACAO IMPLEMENTADO EM LEI DO ENTE FEDERATIVO, CONSIDERANDO QUE O AJUSTE CONTABIL DAS RESERVAS MATEMATICAS SOMENTE OCORRERA NA APRESENTACAO DE UMA NOVA REAVALIACAO ATUARIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.06.00', 'PROVISOES ATUARIAIS PARA AJUSTES DO PLANO FINANCEIRO', 'COMPREENDE O SOMATORIO DAS PROVISOES ATUARIAIS CONSTITUIDAS PARA AJUSTES DO PLANO FINANCEIRO, CONFORME O RESULTADO DA AVALIACAO ATUARIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.07.00', 'PROVISOES ATUARIAIS PARA AJUSTES DO PLANO PREVIDENCIARIO', 'COMPREENDE O SOMATORIO DAS PROVISOES ATUARIAIS CONSTITUIDAS PARA AJUSTES DO PLANO PREVIDENCIARIO, CONFORME O RESULTADO DA AVALIACAO ATUARIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.0.00.00', 'PROVISAO PARA RISCOS FISCAIS A LONGO PRAZO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUACOES FISCAIS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.1.00.00', 'PROVISAO PARA RISCOS FISCAIS A LONGO PRAZO - CONSOLIDACAO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUACOES FISCAIS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.1.01.00', 'PROVISAO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRACAO', 'COMPREENDE OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTOS DE INFRACAO JA LAVRADOS E QUE SE ENCONTRAM NA ESFERA ADMINISTRATIVA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.1.02.00', 'PROVISAO PARA PAGAMENTOS DE AUTUACOES FISCAIS - ESFERA JUDICIAL', 'COMPREENDE OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTUACOES FISCAIS QUE JA SE ENCONTRAM NA ESFERA JUDICIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.0.00.00', 'PROVISAO PARA RISCOS CIVEIS A LONGO PRAZO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.1.00.00', 'PROVISAO PARA RISCOS CIVEIS A LONGO PRAZO - CONSOLIDACAO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.2.00.00', 'PROVISAO PARA RISCOS CIVEIS A LONGO PRAZO - INTRA OFSS', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES,COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.4.00.00', 'PROVISAO PARA RISCOS CIVEIS A LONGO PRAZO - INTER OFSS - ESTADO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.5.00.00', 'PROVISAO PARA RISCOS CIVEIS A LONGO PRAZO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.6.0.00.00', 'PROVISAO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO', 'COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUCAO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.0.00.00', 'OUTRAS PROVISOES A LONGO PRAZO', 'COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO, NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.1.00.00', 'OUTRAS PROVISOES A LONGO PRAZO - CONSOLIDACAO', 'COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO, NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.1.03.00', 'PROVISOES DO FCVS', 'REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, OS VALORES ATUARIAIS DOS PASSIVOS DO FUNDO DE COMPENSACAO E VARIACOES SALARIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.2.00.00', 'OUTRAS PROVISOES A LONGO PRAZO - INTRA OFSS', 'COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO, NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.4.00.00', 'OUTRAS PROVISOES A LONGO PRAZO - INTER OFSS - ESTADO', 'COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO, NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.4.03.00', 'PROVISOES DO FCVS', 'REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, OS VALORES ATUARIAIS DOS PASSIVOS DO FUNDO DE COMPENSACAO E VARIACOES SALARIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.5.00.00', 'OUTRAS PROVISOES A LONGO PRAZO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PROBABILIDADE DE OCORREREM NO LONGO PRAZO, NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.5.03.00', 'PROVISOES DO FCVS', 'REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, OS VALORES ATUARIAIS DOS PASSIVOS DO FUNDO DE COMPENSACAO E VARIACOES SALARIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.0.0.00.00', 'DEMAIS OBRIGACOES A LONGO PRAZO', 'COMPREENDE AS OBRIGACOES DA ENTIDADE JUNTO A TERCEIROS NAO INCLUSAS NOS SUBGRUPOS ANTERIORES, INCLUSIVE OS PRECATORIOS DECORRENTES DESTAS OBRIGACOES, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.1.0.00.00', 'ADIANTAMENTOS DE CLIENTES A LONGO PRAZO', 'COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.3.0.00.00', 'DEBENTURES E OUTROS TITULOS DE DIVIDA A LONGO PRAZO', 'COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO, COM VENCIMENTO NO LONGO PRAZO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.3.1.00.00', 'DEBENTURES E OUTROS TITULOS DE DIVIDA A LONGO PRAZO-CONSOLIDACAO', 'COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.4.0.00.00', 'ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL', 'COMPREENDE OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.00.00', 'OUTRAS OBRIGACOES A LONGO PRAZO-CONSOLIDACAO', 'COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.01.00', 'INDENIZACOES E RESTITUICOES', 'COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.02.00', 'REEMBOLSOS A SEREM EFETUADOS PELO INSS', 'COMPREENDE OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM PAGAMENTOS E ANTECIPACOES AOS SEUS EMPREGADOS OU SERVIDORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.03.00', 'CONVENIOS A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.04.00', 'CONVENIOS A PAGAR - PORTAL/SICONV', 'COMPREENDE OS VALORES A PAGAR REFERENTES A CONVENIOS REGISTRADOS PELO PORTAL / SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.05.00', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.06.00', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR, REGISTRADOS NO PORTAL SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.07.00', 'TERMOS DE PARCERIA A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.08.00', 'TERMOS DE PARCERIA A PAGAR- PORTAL SICONV', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV. O TERMO DE PARCERIA E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.09.00', 'TERMO DE COMPROMISSO A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.10.00', 'PRECATORIOS DE TERCEIROS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.11.00', 'COMPENSACAO PREVIDENCIARIA', 'COMPREENDE O VALOR DAS OBRIGACOES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.12.00', 'BOLSAS PARA ESTUDOS', 'COMPREENDE AS OBRIGACOES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.14.00', 'CONTRATOS DE COOPERACAO TECNICA', 'COMPREENDE OS VALORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001) DO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.15.00', 'AUXILIOS FINANCEIROS A PESQUISADORES', 'COMPREENDE AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.20.00', 'ADIANTAMENTOS RECEBIDOS', 'COMPREENDE OS VALORES EXIGIVEIS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, A TITULO DE ADIANTAMENTOS RECEBIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.00.00', 'OUTRAS OBRIGACOES A LONGO PRAZO-INTRA OFSS', 'COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.02.00', 'REEMBOLSOS A SEREM EFETUADOS PELO INSS', 'COMPREENDE OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM PAGAMENTOS E ANTECIPACOES AOS SEUS EMPREGADOS OU SERVIDORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.03.00', 'CONVENIOS A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.04.00', 'CONVENIOS A PAGAR - PORTAL/SICONV', 'COMPREENDE OS VALORES A PAGAR REFERENTES A CONVENIOS REGISTRADOS PELO PORTAL / SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.05.00', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.06.00', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR, REGISTRADOS NO PORTAL SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.07.00', 'TERMOS DE PARCERIA A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.08.00', 'TERMOS DE PARCERIA A PAGAR- PORTAL SICONV', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV. O TERMO DE PARCERIA E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.10.00', 'PRECATORIOS DE TERCEIROS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.11.00', 'COMPENSACAO PREVIDENCIARIA', 'COMPREENDE O VALOR DAS OBRIGACOES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.12.00', 'BOLSAS PARA ESTUDOS', 'COMPREENDE AS OBRIGACOES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.14.00', 'CONTRATOS DE COOPERACAO TECNICA', 'COMPREENDE OS VALORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001) DO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.2.20.00', 'ADIANTAMENTOS RECEBIDOS', 'COMPREENDE OS VALORES EXIGIVEIS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, A TITULO DE ADIANTAMENTOS RECEBIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.00.00', 'OUTRAS OBRIGACOES A LONGO PRAZO- INTER OFSS - ESTADO', 'COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.01.00', 'INDENIZACOES E RESTITUICOES', 'COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.02.00', 'REEMBOLSOS A SEREM EFETUADOS PELO INSS', 'COMPREENDE OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM PAGAMENTOS E ANTECIPACOES AOS SEUS EMPREGADOS OU SERVIDORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.03.00', 'CONVENIOS A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.04.00', 'CONVENIOS A PAGAR - PORTAL/SICONV', 'COMPREENDE OS VALORES A PAGAR REFERENTES A CONVENIOS REGISTRADOS PELO PORTAL / SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.05.00', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.07.00', 'TERMOS DE PARCERIA A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.08.00', 'TERMOS DE PARCERIA A PAGAR- PORTAL SICONV', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV. O TERMO DE PARCERIA E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.09.00', 'TERMO DE COMPROMISSO A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.10.00', 'PRECATORIOS DE TERCEIROS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.11.00', 'COMPENSACAO PREVIDENCIARIA', 'COMPREENDE O VALOR DAS OBRIGACOES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.12.00', 'BOLSAS PARA ESTUDOS', 'COMPREENDE AS OBRIGACOES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.14.00', 'CONTRATOS DE COOPERACAO TECNICA', 'COMPREENDE OS VALORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001) DO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.15.00', 'AUXILIOS FINANCEIROS A PESQUISADORES', 'COMPREENDE AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.4.19.00', 'ADIANTAMENTOS RECEBIDOS', 'COMPREENDE OS VALORES EXIGIVEIS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, A TITULO DE ADIANTAMENTOS RECEBIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.00.00', 'OUTRAS OBRIGACOES A LONGO PRAZO- INTER OFSS - MUNICIPIO', 'COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO NO LONGO PRAZO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.01.00', 'INDENIZACOES E RESTITUICOES', 'COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.02.00', 'REEMBOLSOS A SEREM EFETUADOS PELO INSS', 'COMPREENDE OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM PAGAMENTOS E ANTECIPACOES AOS SEUS EMPREGADOS OU SERVIDORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.03.00', 'CONVENIOS A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.04.00', 'CONVENIOS A PAGAR - PORTAL/SICONV', 'COMPREENDE OS VALORES A PAGAR REFERENTES A CONVENIOS REGISTRADOS PELO PORTAL / SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.05.00', 'CONTRATO DE PROGRAMA DE REPASSE A PAGAR', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.06.00', 'CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV', 'COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR, REGISTRADOS NO PORTAL SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.07.00', 'TERMOS DE PARCERIA A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.08.00', 'TERMOS DE PARCERIA A PAGAR- PORTAL SICONV', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV. O TERMO DE PARCERIA E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.09.00', 'TERMO DE COMPROMISSO A PAGAR', 'COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.10.00', 'PRECATORIOS DE TERCEIROS', 'COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.11.00', 'COMPENSACAO PREVIDENCIARIA', 'COMPREENDE O VALOR DAS OBRIGACOES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.14.00', 'CONTRATOS DE COOPERACAO TECNICA', 'COMPREENDE OS VALORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001) DO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.15.00', 'AUXILIOS FINANCEIROS A PESQUISADORES', 'COMPREENDE AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.5.19.00', 'ADIANTAMENTOS RECEBIDOS', 'COMPREENDE OS VALORES EXIGIVEIS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, A TITULO DE ADIANTAMENTOS RECEBIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.0.0.00.00', 'RESULTADO DIFERIDO', 'COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS JA RECEBIDAS QUE EFETIVAMENTE DEVEM SER RECONHECIDAS EM RESULTADOS EM ANOS FUTUROS E QUE NAO HAJA QUALQUER TIPO DE OBRIGACAO DE DEVOLUCAO POR PARTE DA ENTIDADE. COMPREENDE TAMBEM O SALDO EXISTENTE NA ANTIGA CONTA RESULTADO DE EXERCICIOS FUTUROS EM 31 DE DEZEMBRO DE 2008.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.1.0.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA (VPA) DIFERIDA', 'COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS JA RECEBIDAS QUE EFETIVAMENTE DEVEM SER RECONHECIDAS EM RESULTADOS EM ANOS FUTUROS E QUE NAO HAJA QUALQUER TIPO DE OBRIGACAO DE DEVOLUCAO POR PARTE DA ENTIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.2.0.00.00', '(-) CUSTO DIFERIDO', 'COMPREENDE O CUSTO RELACIONADO AS VARIACOES PATRIMONIAIS AUMENTATIVAS (VPA) DIFERIDAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.0.0.00.00', 'PATRIMONIO SOCIAL E CAPITAL SOCIAL', 'COMPREENDE O PATRIMONIO SOCIAL DAS AUTARQUIAS, FUNDACOES E FUNDOS E O CAPITAL SOCIAL DAS DEMAIS ENTIDADES DA ADMINISTRACAO INDIRETA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.0.00.00', 'CAPITAL SOCIAL REALIZADO', 'COMPREENDE O CAPITAL SOCIAL SUBSCRITO DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA, DEDUZIDO DA PARCELA AINDA NAO REALIZADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.1.00.00', 'CAPITAL SOCIAL REALIZADO - CONSOLIDACAO', 'COMPREENDE O CAPITAL SOCIAL SUBSCRITO DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA, DEDUZIDO DA PARCELA AINDA NAO REALIZADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.2.00.00', 'CAPITAL SOCIAL REALIZADO - INTRA OFSS', 'COMPREENDE O CAPITAL SOCIAL SUBSCRITO, DEDUZIDO DA PARCELA AINDA NAO REALIZADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.4.00.00', 'CAPITAL SOCIAL REALIZADO - INTER OFSS - ESTADO', 'COMPREENDE O CAPITAL SOCIAL SUBSCRITO, DEDUZIDO DA PARCELA AINDA NAO REALIZADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.5.00.00', 'CAPITAL SOCIAL REALIZADO - INTER OFSS - MUNICIPIO', 'COMPREENDE O CAPITAL SOCIAL SUBSCRITO, DEDUZIDO DA PARCELA AINDA NAO REALIZADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.2.0.0.00.00', 'ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL', 'COMPREENDE OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NAO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.0.0.00.00', 'RESERVAS DE CAPITAL', 'COMPREENDE OS VALORES ACRESCIDOS AO PATRIMONIO QUE NAO TRANSITARAM PELO RESULTADO COMO VARIACOES PATRIMONIAIS AUMENTATIVAS (VPA).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.1.0.00.00', 'AGIO NA EMISSAO DE ACOES', 'COMPREENDE A CONTRIBUICAO DO SUBSCRITOR DE ACOES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS ACOES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMACAO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM ACOES DE DEBENTURES OU PARTES BENEFICIARIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.3.0.00.00', 'ALIENACAO DE BONUS DE SUBSCRICAO', 'COMPREENDE O PRODUTO DA ALIENACAO DE BONUS DE SUBSCRICAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.4.0.00.00', 'CORRECAO MONETARIA DO CAPITAL REALIZADO', 'COMPREENDE O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NAO CAPITALIZADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.1.00.00', 'OUTRAS RESERVAS DE CAPITAL - CONSOLIDACAO', 'COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.2.00.00', 'OUTRAS RESERVAS DE CAPITAL - INTRA OFSS', 'COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.4.00.00', 'OUTRAS RESERVAS DE CAPITAL - INTER OFSS - ESTADO', 'COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.5.00.00', 'OUTRAS RESERVAS DE CAPITAL - INTER OFSS - MUNICIPIO', 'COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.4.0.0.00.00', 'AJUSTES DE AVALIACAO PATRIMONIAL', 'COMPREENDE AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO E DO PASSIVO EM DECORRENCIA DA SUA AVALIACAO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSAO DE VALORES MOBILIARIOS, ENQUANTO NAO COMPUTADAS NO RESULTADO DO EXERCICIO EM OBEDIENCIA AO REGIME DE COMPETENCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.4.1.0.00.00', 'AJUSTES DE AVALIACAO PATRIMONIAL DE ATIVOS', 'COMPREENDE AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO EM DECORRENCIA DA SUA AVALIACAO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSAO DE VALORES MOBILIARIOS, ENQUANTO NAO COMPUTADAS NO RESULTADO DO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.4.2.0.00.00', 'AJUSTES DE AVALIACAO PATRIMONIAL DE PASSIVOS', 'COMPREENDE AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO PASSIVO EM DECORRENCIA DA SUA AVALIACAO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSAO DE VALORES MOBILIARIOS, ENQUANTO NAO COMPUTADAS NO RESULTADO DO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.1.0.00.00', 'RESERVA LEGAL', 'COMPREENDE OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCICIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.2.0.00.00', 'RESERVAS ESTATUTARIAS', 'COMPREENDE AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.3.0.00.00', 'RESERVA PARA CONTINGENCIAS', 'COMPREENDE AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCICIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.4.0.00.00', 'RESERVA DE INCENTIVOS FISCAIS', 'COMPREENDE A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOACOES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.0.00.00', 'RESERVAS DE LUCROS PARA EXPANSAO', 'COMPREENDE AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.1.00.00', 'RESERVAS DE LUCROS PARA EXPANSAO - CONSOLIDACAO', 'COMPREENDE AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.2.00.00', 'RESERVAS DE LUCROS PARA EXPANSAO - INTRA OFSS', 'COMPREENDE AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.4.00.00', 'RESERVAS DE LUCROS PARA EXPANSAO - INTER OFSS - ESTADO', 'COMPREENDE AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.5.00.00', 'RESERVAS DE LUCROS PARA EXPANSAO - INTER OFSS - MUNICIPIO', 'COMPREENDE AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.7.0.00.00', 'RESERVA DE RETENCAO DE PREMIO NA EMISSAO DE DEBENTURES', 'COMPREENDE A PARCELA DO LUCRO LIQUIDO DO EXERCICIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.0.00.00', 'OUTRAS RESERVAS DE LUCRO', 'COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.1.00.00', 'OUTRAS RESERVAS DE LUCRO - CONSOLIDACAO', 'COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.2.00.00', 'OUTRAS RESERVAS DE LUCRO - INTRA OFSS', 'COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.4.00.00', 'OUTRAS RESERVAS DE LUCRO - INTER OFSS - ESTADO', 'COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.5.00.00', 'OUTRAS RESERVAS DE LUCRO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.0.0.00.00', 'DEMAIS RESERVAS', 'COMPREENDE AS DEMAIS RESERVAS, NAO CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR TEREM SIDO EXTINTAS PELA LEGISLACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.0.00.00', 'RESERVA DE REAVALIACAO', 'COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIACOES ANTERIORES), NOS CASOS PERMITIDOS PELA LEGISLACAO VIGENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.1.00.00', 'RESERVA DE REAVALIACAO - CONSOLIDACAO', 'COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIACOES ANTERIORES), NOS CASOS PERMITIDOS PELA LEGISLACAO VIGENTE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.2.00.00', 'RESERVA DE REAVALIACAO - INTRA OFSS', 'COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIACOES ANTERIORES), NOS CASOS PERMITIDOS PELA LEGISLACAO VIGENTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.4.00.00', 'RESERVA DE REAVALIACAO - INTER OFSS - ESTADO', 'COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIACOES ANTERIORES), NOS CASOS PERMITIDOS PELA LEGISLACAO VIGENTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.5.00.00', 'RESERVA DE REAVALIACAO - INTER OFSS - MUNICIPIO', 'COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIACOES ANTERIORES), NOS CASOS PERMITIDOS PELA LEGISLACAO VIGENTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.0.0.00.00', 'RESULTADOS ACUMULADOS', 'COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS E OS SUPERAVITS OU DEFICITS ACUMULADOS DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.0.00.00', 'SUPERAVITS OU DEFICITS ACUMULADOS', 'COMPREENDEM OS SUPERAVITS OU DEFICITS ACUMULADOS DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.1.00.00', 'SUPERAVITS OU DEFICITS ACUMULADOS - CONSOLIDACAO', 'COMPREENDEM OS SUPERAVITS OU DEFICITS ACUMULADOS DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.2.00.00', 'SUPERAVITS OU DEFICITS ACUMULADOS - INTRA OFSS', 'COMPREENDEM OS SUPERAVITS OU DEFICITS ACUMULADOS DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.4.00.00', 'SUPERAVITS OU DEFICITS ACUMULADOS - INTER OFSS - ESTADO', 'COMPREENDEM OS SUPERAVITS OU DEFICITS ACUMULADOS DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.5.00.00', 'SUPERAVITS OU DEFICITS ACUMULADOS - INTER OFSS - MUNICIPIO', 'COMPREENDE OS SUPERAVITS OU DEFICITS ACUMULADOS DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.1.00.00', 'LUCROS E PREJUIZOS ACUMULADOS - CONSOLIDACAO', 'COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.2.00.00', 'LUCROS E PREJUIZOS ACUMULADOS - INTRA OFSS', 'COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.4.00.00', 'LUCROS E PREJUIZOS ACUMULADOS - INTER OFSS - ESTADO', 'COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.0.0.00.00', '(-) ACOES / COTAS EM TESOURARIA', 'COMPREENDE O VALOR DAS ACOES OU COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.1.0.00.00', '(-) ACOES EM TESOURARIA', 'COMPREENDE O VALOR DAS ACOES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.2.0.00.00', '(-) COTAS EM TESOURARIA', 'COMPREENDE O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.0.0.0.0.00.00', 'VARIACAO PATRIMONIAL DIMINUTIVA', 'COMPREENDE O DECRESCIMO NO BENEFICIO ECONOMICO DURANTE O PERIODO CONTABIL SOB A FORMA DE SAIDA DE RECURSO OU REDUCAO DE ATIVO OU INCREMENTO EM PASSIVO, QUE RESULTE EM DECRESCIMO DO PATRIMONIO LIQUIDO E QUE NAO SEJA PROVENIENTE DE DISTRIBUICAO AOS PROPRIETARIOS DA ENTIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.0.0.0.00.00', 'PESSOAL E ENCARGOS', 'COMPREENDE A REMUNERACAO DO PESSOAL ATIVO CIVIL OU MILITAR, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SUBSIDIOS, VENCIMENTOS, SOLDOS E VANTAGENS PECUNIARIAS FIXAS OU VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO CARGO, EMPREGO OU FUNCAO DE CONFIANCA NO SETOR PUBLICO. COMPREENDE AINDA, OBRIGACOES TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO, CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA E BENEFICIOS EVENTUAIS A PESSOAL CIVIL E MILITAR , DESTACADOS OS CUSTOS DE PESSOAL E ENCARGOS INERENTES AS MERCADORIAS E PRODUTOS VENDIDOS E SERVICOS PRESTADOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.0.0.00.00', 'REMUNERACAO A PESSOAL', 'COMPREENDE A REMUNERACAO DO PESSOAL ATIVO CIVIL OU MILITAR, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SUBSIDIOS, VENCIMENTOS, SOLDOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO CARGO, EMPREGO OU FUNCAO DE CONFIANCA NO SETOR PUBLICO, BEM COMO AS COM CONTRATOS DE TERCEIRIZACAO DE MAO-DE-OBRA QUE SE REFIRAM A SUBSTITUICAO DE SERVIDORES E EMPREGADOS PUBLICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.0.00.00', 'REMUNERACAO A PESSOAL ATIVO CIVIL- ABRANGIDOS PELO RPPS', 'COMPREENDE A REMUNERACAO DO PESSOAL ATIVO CIVIL ABRANGIDOS PELO RPPS, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SUBSIDIOS, VENCIMENTOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO CARGO OU FUNCAO DE CONFIANCA NO SETOR PUBLICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.00.00', 'REMUNERACAO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO RPPS - CONSOLIDACAO', 'COMPREENDE A REMUNERACAO DO PESSOAL ATIVO CIVIL ABRANGIDOS PELO RPPS, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SUBSIDIOS, VENCIMENTOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO CARGO OU FUNCAO DE CONFIANCA NO SETOR PUBLICO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.00', 'VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RPPS', 'COMPREENDE O SOMATORIO DOS VALORES COM VENCIMENTOS E VANTAGENS FIXAS DO PESSOAL CIVIL DO TIPO: GRATIFICACAO, REPRESENTACAO, ADICIONAL INSALUBRIDADE, FERIAS, 13 SALARIO, LICENCA-PREMIO, ABONO PECUNIARIO, ADICIONAL NOTURNO, ETC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.00', 'OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL - RPPS', 'COMPREENDE O VALOR DAS APROPRIACOES DAS DESPESAS COM OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL ABRANGIDOS PELO REGIME PROPRIO, RELACIONADAS AS ATIVIDADES DO CARGO OU FUNCAO DO SERVIDOR E CUJO PAGAMENTO SO SE REALIZA EM CIRCUSTANCIAS ESPECIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.0.00.00', 'REMUNERACAO A PESSOAL ATIVO CIVIL - ABRANGIDOS PELO RGPS', 'COMPREENDE A REMUNERACAO DO PESSOAL ATIVO CIVIL ABRANGIDOS PELO RGPS, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM VENCIMENTOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO EMPREGO, INCLUSIVE OS OCUPANTES DE CARGOS EM COMISSAO NAO INVESTIDOS EM CARGO EFETIVO, NO SETOR PUBLICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.00.00', 'REMUNERACAO A PESSOAL ATIVO CIVIL- ABRANGIDOS PELO RGPS - CONSOLIDACAO', 'COMPREENDE A REMUNERACAO DO PESSOAL ATIVO CIVIL ABRANGIDOS PELO RGPS, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM VENCIMENTOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO EMPREGO, INCLUSIVE OS OCUPANTES DE CARGOS EM COMISSAO NAO INVESTIDOS EM CARGO EFETIVO, NO SETOR PUBLICO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.00', 'VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS', 'COMPREENDE O SOMATORIO DOS VALORES COM VENCIMENTOS E VANTAGENS FIXAS DO PESSOAL CIVIL DO TIPO: GRATIFICACAO, REPRESENTACAO, ADICIONAL INSALUBRIDADE, FERIAS, 13 SALARIO, LICENCA-PREMIO, ABONO PECUNIARIO, ADICIONAL NOTURNO, ETC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.00', 'OUTRAS VPD VARIAVEIS - PESSOAL CIVIL - RGPS', 'COMPREENDE O VALOR DAS APROPRIACOES DAS DESPESAS COM OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL ABRANGIDOS PELO REGIME GERAL, RELACIONADAS AS ATIVIDADES DO CARGO OU FUNCAO DO EMPREGADO E CUJO PAGAMENTO SO SE REALIZA EM CIRCUSTANCIAS ESPECIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.00', 'CONTRATACAO POR TEMPO DETERMINADO', 'COMPREENDE O VALOR DAS APROPRIACOES DE VARIACOES PATRIMONIAIS DIMINUTIVAS COM A CONTRATACAO DE PESSOAL POR TEMPO DETERMINADO PARA ATENDER A NECESSIDADE TEMPORARIA DE EXCEPCIONAL INTERESSE PUBLICO, DE ACORDO COM LEGISLACAO ESPECIFICA DE CADA ENTE DA FEDERACAO, INCLUSIVE OBRIGACOES PATRONAIS E OUTRAS DESPESAS VARIAVEIS, QUAND0 FOR O CASO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.0.00.00', 'REMUNERACAO A PESSOAL ATIVO MILITAR- ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES', 'COMPREENDE A REMUNERACAO DO PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SOLDOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO CARGO OU FUNCAO DE CONFIANCA NO SETOR PUBLICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.00.00', 'REMUNERACAO A PESSOAL ATIVO MILITAR- ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES - CONSOLIDACAO', 'COMPREENDE A REMUNERACAO DO PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SOLDOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO CARGO OU FUNCAO DE CONFIANCA NO SETOR PUBLICO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.0.00.00', 'ENCARGOS PATRONAIS - RPPS', 'COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS SERVIDORES PUBLICOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.2.00.00', 'ENCARGOS PATRONAIS - RPPS - INTRA OFSS', 'COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS SERVIDORES PUBLICOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.4.00.00', 'ENCARGOS PATRONAIS - RPPS - INTER OFSS - ESTADO', 'COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS SERVIDORES PUBLICOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.5.00.00', 'ENCARGOS PATRONAIS - RPPS - INTER OFSS - MUNICIPIO', 'COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS SERVIDORES PUBLICOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.0.00.00', 'ENCARGOS PATRONAIS - RGPS', 'COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSAO NAO INVESTIDOS EM CARGO EFETIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.00.00', 'ENCARGOS PATRONAIS - RGPS - CONSOLIDACAO', 'COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSAO NAO INVESTIDO EM CARGO EFETIVO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.2.00.00', 'ENCARGOS PATRONAIS - RGPS - INTRA OFSS', 'COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSAO NAO INVESTIDOS EM CARGO EFETIVO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.3.0.00.00', 'ENCARGOS PATRONAIS - FGTS', 'COMPREENDE OS VALORES RECOLHIDOS MENSALMENTE PELOS EMPREGADORES, EM CONTA BANCARIA VINCULADA DO TRABALHADOR NO FGTS, CORRESPONDENTE A PERCENTUAL DEFINIDO EM LEI SOBRE A REMUNERACAO PAGA OU DEVIDA, NO MES ANTERIOR, A CADA TRABALHADOR, INCLUIDAS NA REMUNERACAO AS PARCELAS DE QUE TRATAM OS ARTS. 457 E 458 DA CLT E A GRATIFICACAO DE NATAL A QUE SE REFERE A LEI Nº 4.090, DE 13 DE JULHO DE 1962, COM AS MODIFICACOES DA LEI Nº 4.749, DE 12 DE AGOSTO DE 1965. ENTENDE-SE POR EMPREGADOR A PESSOA FISICA OU A PESSOA JURIDICA DE DIREITO PRIVADO OU DE DIREITO PUBLICO, DA ADMINISTRACAO PUBLICA DIRETA, INDIRETA OU FUNDACIONAL DE QUALQUER DOS PODERES, DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS, QUE ADMITIR TRABALHADORES A SEU SERVICO, BEM ASSIM AQUELE QUE, REGIDO POR LEGISLACAO ESPECIAL, ENCONTRAR-SE NESSA CONDICAO OU FIGURAR COMO FORNECEDOR OU TOMADOR DE MAO-DE-OBRA, INDEPENDENTE DA RESPONSABILIDADE SOLIDARIA E/OU SUBSIDIARIA A QUE EVENTUALMENTE VENHA OBRIGAR-SE. CONSIDERA-SE TRABALHADOR TODA PESSOA FISICA QUE PRESTAR SERVICOS A EMPREGADOR, A LOCADOR OU TOMADOR DE MAO-DE-OBRA, EXCLUIDOS OS EVENTUAIS, OS AUTONOMOS E OS SERVIDORES PUBLICOS CIVIS E MILITARES SUJEITOS A REGIME JURIDICO PROPRIO. O RECOLHIMENTO DO FGTS E OBRIGATORIO TAMBEM NOS CASOS DE AFASTAMENTO PARA PRESTACAO DO SERVICO MILITAR OBRIGATORIO E LICENCA POR ACIDENTE DO TRABALHO. NAO SE INCLUEM NA REMUNERACAO, PARA OS FINS DESTA LEI, AS PARCELAS ELENCADAS NO § 9º DO ART. 28 DA LEI Nº 8.212, DE 24 DE JULHO DE 1991.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.3.1.00.00', 'ENCARGOS PATRONAIS - FGTS - CONSOLIDACAO', 'COMPREENDE OS VALORES RECOLHIDOS MENSALMENTE PELOS EMPREGADORES, EM CONTA BANCARIA VINCULADA DO TRABALHADOR NO FGTS, CORRESPONDENTE A PERCENTUAL DEFINIDO EM LEI SOBRE A REMUNERACAO PAGA OU DEVIDA, NO MES ANTERIOR, A CADA TRABALHADOR, INCLUIDAS NA REMUNERACAO AS PARCELAS DE QUE TRATAM OS ARTS. 457 E 458 DA CLT E A GRATIFICACAO DE NATAL A QUE SE REFERE A LEI Nº 4.090, DE 13 DE JULHO DE 1962, COM AS MODIFICACOES DA LEI Nº 4.749, DE 12 DE AGOSTO DE 1965. ENTENDE-SE POR EMPREGADOR A PESSOA FISICA OU A PESSOA JURIDICA DE DIREITO PRIVADO OU DE DIREITO PUBLICO, DA ADMINISTRACAO PUBLICA DIRETA, INDIRETA OU FUNDACIONAL DE QUALQUER DOS PODERES, DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS, QUE ADMITIR TRABALHADORES A SEU SERVICO, BEM ASSIM AQUELE QUE, REGIDO POR LEGISLACAO ESPECIAL, ENCONTRAR-SE NESSA CONDICAO OU FIGURAR COMO FORNECEDOR OU TOMADOR DE MAO-DE-OBRA, INDEPENDENTE DA RESPONSABILIDADE SOLIDARIA E/OU SUBSIDIARIA A QUE EVENTUALMENTE VENHA OBRIGAR-SE. CONSIDERA-SE TRABALHADOR TODA PESSOA FISICA QUE PRESTAR SERVICOS A EMPREGADOR, A LOCADOR OU TOMADOR DE MAO-DE-OBRA, EXCLUIDOS OS EVENTUAIS, OS AUTONOMOS E OS SERVIDORES PUBLICOS CIVIS E MILITARES SUJEITOS A REGIME JURIDICO PROPRIO. O RECOLHIMENTO DO FGTS E OBRIGATORIO TAMBEM NOS CASOS DE AFASTAMENTO PARA PRESTACAO DO SERVICO MILITAR OBRIGATORIO E LICENCA POR ACIDENTE DO TRABALHO. NAO SE INCLUEM NA REMUNERACAO, PARA OS FINS DESTA LEI, AS PARCELAS ELENCADAS NO § 9º DO ART. 28 DA LEI Nº 8.212, DE 24 DE JULHO DE 1991. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.4.0.00.00', 'CONTRIBUICOES SOCIAIS GERAIS', 'COMPREENDE OS ENCARGOS PATRONAIS RELATIVOS AO SALARIO EDUCACAO E AS CONTRIBUICOES COMPULSORIAS DOS EMPREGADORES SOBRE A FOLHA DE SALARIOS, DESTINADOS AS ENTIDADES PRIVADAS DE SERVICO SOCIAL E DE FORMACAO PROFISSIONAL, VINCULADAS AO SISTEMA SINDICAL, TAIS COMO SESI, SENAI, SESC E SENAC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.0.00.00', 'CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA', 'COMPREENDE O VALOR TOTAL DAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELACIONADAS AO REGIME DE PREVIDENCIA PRIVADA, DE CARATER COMPLEMENTAR, ORGANIZADO DE FORMA AUTONOMA EM RELACAO AO REGIME GERAL DE PREVIDENCIA SOCIAL, DE CARATER FACULTATIVO, BASEADO NA CONSTITUICAO DE RESERVAS QUE GARANTAM O BENEFICIO, NOS TERMOS DO CAPUT DO ART. 202 DA CONSTITUICAO FEDERAL. ENTENDE-SE POR ENTIDADES FECHADAS AQUELAS ACESSIVEIS, NA FORMA REGULAMENTADA PELO ORGAO REGULADOR E FISCALIZADOR, EXCLUSIVAMENTE AOS EMPREGADOS DE UMA EMPRESA OU GRUPO DE EMPRESAS E AOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS, ENTES DENOMINADOS PATROCINADORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.1.00.00', 'CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA - CONSOLIDACAO', 'COMPREENDE O VALOR TOTAL DAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELACIONADAS AO REGIME DE PREVIDENCIA PRIVADA, DE CARATER COMPLEMENTAR, ORGANIZADO DE FORMA AUTONOMA EM RELACAO AO REGIME GERAL DE PREVIDENCIA SOCIAL, DE CARATER FACULTATIVO, BASEADO NA CONSTITUICAO DE RESERVAS QUE GARANTAM O BENEFICIO, NOS TERMOS DO CAPUT DO ART. 202 DA CONSTITUICAO FEDERAL. ENTENDE-SE POR ENTIDADES FECHADAS AQUELAS ACESSIVEIS, NA FORMA REGULAMENTADA PELO ORGAO REGULADOR E FISCALIZADOR, EXCLUSIVAMENTE AOS EMPREGADOS DE UMA EMPRESA OU GRUPO DE EMPRESAS E AOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS, ENTES DENOMINADOS PATROCINADORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.0.0.00.00', 'BENEFICIOS A PESSOAL', 'COMPREENDE O VALOR TOTAL DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM BENEFICIOS DEVIDOS A PESSOAL CIVIL E MILITAR , TAIS COMO PARA O PESSOAL CIVIL: AJUDA-DE-CUSTO, INDENIZACAO DE TRANSPORTE, AUXILIO-MORADIA, AUXILIO-ALIMENTACAO,AUXILIO-TRANSPORTE BEM COMO OUTROS DECORRENTES DE ACORDO OU CONVENCAO COLETIVA NO QUE SE REFERE AOS EMPREGADOS PUBLICOS. PARA OS MILITARES: ADICIONAL DE COMPENSACAO ORGANICA NAO INCORPORADA, GRATIFICACAO DE LOCALIDADE ESPECIAL, GRATIFICACAO DE REPRESENTACAO, TRANSPORTE, AJUDA-DE-CUSTO, AUXILIO-FARDAMENTO, AUXILIO-ALIMENTACAO E OUTROS BENEFICIOS EVENTUAIS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO. ESTAO EXCLUIDAS DESTE GRUPO AS DESPESAS COM VENCIMENTOS, SOLDOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS, BEM COMO AS DESPESAS RELACIONADAS AOS BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, TAIS COMO: APOSENTADORIA, AUXILIO-NATALIDADE, SALARIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTENCIA A SAUDE, GARANTIA DE CONDICOES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATORIAS, PENSAO VITALICIA E TEMPORARIA, AUXILIO-FUNERAL, AUXILIO-RECLUSAO, AUXILIO-INVALIDEZ, ASSISTENCIA A SAUDE. ESTAO EXCLUIDAS AINDA AS INDENIZACOES E RESTITUICOES TRABALHISTAS DECORRENTES DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PREVIO INDENIZADOS E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.1.0.00.00', 'BENEFICIOS A PESSOAL - RPPS', 'COMPREENDE O VALOR TOTAL DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM BENEFICIOS A SERVIDOR PUBLICO, TAIS COMO: AJUDA-DE-CUSTO, INDENIZACAO DE TRANSPORTE, AUXILIO-MORADIA, AUXILIO-TRANSPORTE,AUXILIO-ALIMENTACAO E OUTROS BENEFICIOS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO. ESTAO EXCLUIDAS DESTE GRUPO OS VENCIMENTOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS PERMANENTES, BEM COMO OS BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, TAIS COMO: APOSENTADORIA, AUXILIO-NATALIDADE, SALARIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTENCIA A SAUDE, PENSAO VITALICIA E TEMPORARIA, AUXILIO-FUNERAL, AUXILIO-RECLUSAO, AUXILIO-INVALIDEZ, ASSISTENCIA A SAUDE. ESTAO EXCLUIDAS AINDA AS INDENIZACOES E RESTITUICOES TRABALHISTAS DECORRENTES DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PREVIO INDENIZADOS E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.1.1.00.00', 'BENEFICIOS A PESSOAL - RPPS - CONSOLIDACAO', 'COMPREENDE O VALOR TOTAL DAS V VARIACOES PATRIMONIAIS DIMINUTIVAS COM BENEFICIOS A SERVIDOR PUBLICO, TAIS COMO: AJUDA-DE-CUSTO, INDENIZACAO DE TRANSPORTE, AUXILIO-MORADIA, AUXILIO-TRANSPORTE,AUXILIO-ALIMENTACAO E OUTROS BENEFICIOS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO. ESTAO EXCLUIDAS DESTE GRUPO OS VENCIMENTOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS PERMANENTES, BEM COMO OS BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, TAIS COMO: APOSENTADORIA, AUXILIO-NATALIDADE, SALARIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTENCIA A SAUDE, PENSAO VITALICIA E TEMPORARIA, AUXILIO-FUNERAL, AUXILIO-RECLUSAO, AUXILIO-INVALIDEZ, ASSISTENCIA A SAUDE. ESTAO EXCLUIDAS AINDA AS INDENIZACOES E RESTITUICOES TRABALHISTAS DECORRENTES DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PREVIO INDENIZADOS E OUTRAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.2.0.00.00', 'BENEFICIOS A PESSOAL - RGPS', 'COMPREENDE O VALOR TOTAL DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM BENEFICIOS DEVIDOS AOS EMPREGADOS PUBLICOS, E AINDA OUTROS RELATIVOS A ACORDO OU CONVENCAO COLETIVA. ESTAO EXCLUIDOS DESTE GRUPO OS VENCIMENTOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS , BEM COMO OS BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, TAIS COMO: APOSENTADORIA, AUXILIO-NATALIDADE, SALARIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTENCIA A SAUDE, GARANTIA DE CONDICOES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATORIAS, PENSAO VITALICIA E TEMPORARIA, AUXILIO-FUNERAL, AUXILIO-RECLUSAO, AUXILIO-INVALIDEZ, ASSISTENCIA A SAUDE. ESTAO EXCLUIDAS AINDA AS INDENIZACOES E RESTITUICOES TRABALHISTAS DECORRENTES DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PREVIO INDENIZADOS E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.2.1.00.00', 'BENEFICIOS A PESSOAL - RGPS - CONSOLIDACAO', 'COMPREENDE O VALOR TOTAL DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM BENEFICIOS DEVIDOS AOS EMPREGADOS PUBLICOS, E AINDA OUTROS RELATIVOS A ACORDO OU CONVENCAO COLETIVA. ESTAO EXCLUIDOS DESTE GRUPO OS VENCIMENTOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS , BEM COMO OS BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, TAIS COMO: APOSENTADORIA, AUXILIO-NATALIDADE, SALARIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTENCIA A SAUDE, GARANTIA DE CONDICOES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATORIAS, PENSAO VITALICIA E TEMPORARIA, AUXILIO-FUNERAL, AUXILIO-RECLUSAO, AUXILIO-INVALIDEZ, ASSISTENCIA A SAUDE. ESTAO EXCLUIDAS AINDA AS INDENIZACOES E RESTITUICOES TRABALHISTAS DECORRENTES DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PREVIO INDENIZADOS E OUTRAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.3.0.00.00', 'BENEFICIOS A PESSOAL - MILITAR', 'COMPREENDE O VALOR TOTAL DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM BENEFICIOS DEVIDOS A PESSOAL MILITAR, TAIS COMO: ADICIONAL DE COMPENSACAO ORGANICA NAO INCORPORADA, GRATIFICACAO DE LOCALIDADE ESPECIAL, GRATIFICACAO DE REPRESENTACAO, TRANSPORTE, AJUDA-DE-CUSTO, AUXILIO-FARDAMENTO, AUXILIO-ALIMENTACAO E OUTROS BENEFICIOS EVENTUAIS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO.ESTAO EXCLUIDOS DESTE GRUPO OS SOLDOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS PERMANENTES, BEM COMO AS OS BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, TAIS COMO: APOSENTADORIA, AUXILIO-NATALIDADE, SALARIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTENCIA A SAUDE, GARANTIA DE CONDICOES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATORIAS, PENSAO VITALICIA E TEMPORARIA, AUXILIO-FUNERAL, AUXILIO-RECLUSAO, AUXILIO-INVALIDEZ, ASSISTENCIA A SAUDE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.3.1.00.00', 'BENEFICIOS A PESSOAL - MILITAR - CONSOLIDACAO', 'COMPREENDE O VALOR TOTAL DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM BENEFICIOS DEVIDOS A PESSOAL MILITAR, TAIS COMO: ADICIONAL DE COMPENSACAO ORGANICA NAO INCORPORADA, GRATIFICACAO DE LOCALIDADE ESPECIAL, GRATIFICACAO DE REPRESENTACAO, TRANSPORTE, AJUDA-DE-CUSTO, AUXILIO-FARDAMENTO, AUXILIO-ALIMENTACAO E OUTROS BENEFICIOS EVENTUAIS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO. ESTAO EXCLUIDOS DESTE GRUPO OS SOLDOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS PERMANENTES, BEM COMO AS OS BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, TAIS COMO: APOSENTADORIA, AUXILIO-NATALIDADE, SALARIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTENCIA A SAUDE, GARANTIA DE CONDICOES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATORIAS, PENSAO VITALICIA E TEMPORARIA, AUXILIO-FUNERAL, AUXILIO-RECLUSAO, AUXILIO-INVALIDEZ, ASSISTENCIA A SAUDE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.0.0.00.00', 'CUSTO DE PESSOAL E ENCARGOS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA A PESSOAL E ENCARGOS UTILIZADOS NA PRODUCAO DE BENS OU SERVICOS, SENDO REGISTRADA APENAS NO MOMENTO DA VENDA DESTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.0.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - PESSOAL E ENCARGOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - PESSOAL E ENCARGOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.2.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - PESSOAL E ENCARGOS - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.4.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - PESSOAL E ENCARGOS - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.5.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - PESSOAL E ENCARGOS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.00.00', 'CUSTO DE PRODUTOS VENDIDOS - PESSOAL E ENCARGOS - CONSOLIDACAO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.4.00.00', 'CUSTO DE PRODUTOS VENDIDOS - PESSOAL E ENCARGOS - INTER OFSS - ESTADO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.5.00.00', 'CUSTO DE PRODUTOS VENDIDOS - PESSOAL E ENCARGOS - INTER OFSS - MUNICIPIO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.0.00.00', 'CUSTO DE SERVICOS PRESTADOS - PESSOAL E ENCARGOS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADAS APENAS NO MOMENTO DA VENDA DESTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.00.00', 'CUSTO DE SERVICOS PRESTADOS - PESSOAL E ENCARGOS - CONSOLIDACAO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.4.00.00', 'CUSTO DE SERVICOS PRESTADOS - PESSOAL E ENCARGOS - INTER OFSS - ESTADO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.5.00.00', 'CUSTO DE SERVICOS PRESTADOS - PESSOAL E ENCARGOS - INTER OFSS - MUNICIPIO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.0.0.00.00', 'OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS - PESSOAL E ENCARGOS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL E ENCARGOS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES, TAIS COMO AS INDENIZACOES E RESTITUICOES TRABALHISTAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.0.00.00', 'INDENIZACOES E RESTITUICOES TRABALHISTAS', 'COMPREENDE O VALOR TOTAL COM VARIACOES PATRIMONIAIS DIMINUTIVAS RESULTANTE DO PAGAMENTO EFETUADO A SERVIDORES PUBLICOS CIVIS E EMPREGADOS DE ENTIDADES INTEGRANTES DA ADMINISTRACAO PUBLICA, INCLUSIVE FERIAS E AVISO PREVIO INDENIZADOS, MULTAS E CONTRIBUICOES INCIDENTES SOBRE OS DEPOSITOS DO FUNDO DE GARANTIA POR TEMPO DE SERVICO, ETC, EM FUNCAO DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, PODENDO SER EM DECORRENCIA DA PARTICIPACAO EM PROGRAMA DE DESLIGAMENTO VOLUNTARIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.1.00.00', 'INDENIZACOES E RESTITUICOES TRABALHISTAS - CONSOLIDACAO', 'COMPREENDE O VALOR TOTAL COM VARIACOES PATRIMONIAIS DIMINUTIVAS RESULTANTE DO PAGAMENTO EFETUADO A SERVIDORES PUBLICOS CIVIS E EMPREGADOS DE ENTIDADES INTEGRANTES DA ADMINISTRACAO PUBLICA, INCLUSIVE FERIAS E AVISO PREVIO INDENIZADOS, MULTAS E CONTRIBUICOES INCIDENTES SOBRE OS DEPOSITOS DO FUNDO DE GARANTIA POR TEMPO DE SERVICO, ETC, EM FUNCAO DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, PODENDO SER EM DECORRENCIA DA PARTICIPACAO EM PROGRAMA DE DESLIGAMENTO VOLUNTARIO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.2.0.00.00', 'PESSOAL REQUISITADO DE OUTROS ORGAOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PESSOAL REQUISITADO DE OUTROS ORGAOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.9.0.00.00', 'OUTRAS VPD DE PESSOAL E ENCARGOS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL E ENCARGOS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.9.1.00.00', 'OUTRAS VPD DE PESSOAL E ENCARGOS - CONSOLIDACAO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL E ENCARGOS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.0.0.0.00.00', 'BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS', 'COMPREENDEM AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS AS APOSENTADORIAS, PENSOES, REFORMAS, RESERVA REMUNERADA E OUTROS BENEFICIOS PREVIDENCIARIOS DE CARATER CONTRIBUTIVO,DO REGIME PROPRIO DA PREVIDENCIA SOCIAL - RPPS E DO REGIME GERAL DA PREVIDENCIA SOCIAL - RGPS, BEM COMO AS ACOES DE ASSISTENCIA SOCIAL, QUE SAO POLITICAS DE SEGURIDADE SOCIAL NAO CONTRIBUTIVA, VISANDO AO ENFRENTAMENTO DA POBREZA, A GARANTIA DOS MINIMOS SOCIAIS, AO PROVIMENTO DE CONDICOES PARA ATENDER CONTINGENCIAS SOCIAIS E A UNIVERSALIZACAO DOS DIREITOS SOCIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.0.0.00.00', 'APOSENTADORIAS E REFORMAS', 'COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.0.00.00', 'APOSENTADORIAS - RPPS', 'COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO, ABRANGIDAS PELO RPPS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.00.00', 'APOSENTADORIAS - RPPS - CONSOLIDACAO', 'COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO, ABRANGIDAS PELO RPPS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.0.00.00', 'APOSENTADORIAS - RGPS', 'COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO, ABRANGIDAS PELO RGPS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.00.00', 'APOSENTADORIAS - RGPS - CONSOLIDACAO', 'COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO, ABRANGIDOS PELO RGPS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.0.00.00', 'RESERVA REMUNERADA E REFORMAS - MILITAR', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESERVA REMUNERADA E REFORMAS DOS MILITARES', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.00.00', 'RESERVA REMUNERADA E REFORMAS - MILITAR - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESERVA REMUNERADA E REFORMAS DOS MILITARES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.0.0.00.00', 'PENSOES', 'COMPREENDEM OS BENEFICIOS DA PREVIDENCIA SOCIAL QUE GARANTEM UMA RENDA AOS DEPENDENTES DO SEGURADO FALECIDO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.0.00.00', 'PENSOES - RPPS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSOES AOS DEPENDENTES DOS SEGURADOS, APOS SEU OBITO, PELO REGIME PROPRIO DA PREVIDENCIA SOCIAL -RPPS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.00.00', 'PENSOES - RPPS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSOES AOS DEPENDENTES DOS SEGURADOS, APOS SEU OBITO, PELO REGIME PROPRIO DA PREVIDENCIA SOCIAL -RPPS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.0.00.00', 'PENSOES - RGPS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSOES AOS DEPENDENTES DOS SEGURADOS, APOS SEU OBITO, REGIDOS PELO REGIME GERAL DA PREVIDENCIA SOCIAL -RGPS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.00.00', 'PENSOES - RGPS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSOES AOS DEPENDENTES DOS SEGURADOS, APOS SEU OBITO, REGIDOS PELO REGIME GERAL DA PREVIDENCIA SOCIAL -RGPS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.3.0.00.00', 'PENSOES - MILITAR', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSOES AOS DEPENDENTES DOS MILITARES, APOS SEU OBITO, REGIDOS PELO REGIME PROPRIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.3.1.00.00', 'PENSOES - MILITAR - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSOES AOS DEPENDENTES DOS MILITARES, APOS SEU OBITO, REGIDOS PELO REGIME PROPRIO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.1.0.00.00', 'BENEFICIOS DE PRESTACAO CONTINUADA AO IDOSO', 'COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA AO IDOSO E RENDA MENSAL VITALICIA POR IDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.1.1.00.00', 'BENEFICIOS DE PRESTACAO CONTINUADA AO IDOSO - CONSOLIDACAO', 'COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA E RENDA MENSAL VITALICIA POR IDADE . COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.2.0.00.00', 'BENEFICIOS DE PRESTACAO CONTINUADA AO PORTADOR DE DEFICIENCIA', 'COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA AO PORTADOR DE DEFICIENCIA E RENDA MENSAL VITALICIA - INVALIDEZ', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.2.1.00.00', 'BENEFICIOS DE PRESTACAO CONTINUADA AO PORTADOR DE DEFICIENCIA - CONSOLIDACAO', 'COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA AO PORTADOR DE DEFICIENCIA E RENDA MENSAL VITALICIA - INVALIDEZ. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.0.0.00.00', 'BENEFICIOS EVENTUAIS', 'COMPREENDEM AS PROVISOES SUPLEMENTARES E PROVISORIAS, PRESTADAS AOS CIDADAOS E AS FAMILIAS EM VIRTUDE DE NASCIMENTO, MORTE, SITUACOES DE VULNERABILIDADE TEMPORARIA E DE CALAMIDADE PUBLICA. AS PROVISOES RELATIVAS A PROGRAMAS, PROJETOS, SERVICOS E BENEFICIOS DIRETAMENTE VINCULADOS AO CAMPO DA SAUDE, EDUCACAO, INTEGRACAO NACIONAL E DAS DEMAIS POLITICAS SETORIAIS NAO SE INCLUEM NA MODALIDADE DE BENEFICIOS EVENTUAIS DA ASSISTENCIA SOCIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.1.0.00.00', 'AUXILIO POR NATALIDADE', 'COMPREENDE O BENEFICIO EVENTUAL QUE VISA O PAGAMENTO DE AUXILIO POR NATALIDADE AS FAMILIAS CUJA RENDA MENSAL PER CAPITA SEJA INFERIOR A 1/4 (UM QUARTO) DO SALARIO MINIMO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.2.0.00.00', 'AUXILIO POR MORTE', 'COMPREENDE O BENEFICIO EVENTUAL QUE VISA O PAGAMENTO DE AUXILIO POR MORTE AS FAMILIAS CUJA RENDA MENSAL PER CAPITA SEJA INFERIOR A 1/4 (UM QUARTO) DO SALARIO MINIMO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.3.0.00.00', 'BENEFICIOS EVENTUAIS POR SITUACOES DE VULNERABILIDADE TEMPORARIA', 'COMPREENDE AS PROVISOES SUPLEMENTARES E PROVISORIAS, PRESTADAS AOS CIDADAOS E AS FAMILIAS EM VIRTUDE DE SITUACOES DE VULNERABILIDADE TEMPORARIA, COM PRIORIDADE PARA A CRIANCA, A FAMILIA, O IDOSO, A PESSOA PORTADORA DE DEFICIENCIA, A GESTANTE E A NUTRIZ.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.4.0.00.00', 'BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA', 'COMPREENDEM OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA.ENTENDE SE POR ESTADO DE CALAMIDADE PUBLICA O RECONHECIMENTO PELO PODER PUBLICO DE SITUACAO ANORMAL, ADVINDA DE BAIXAS OU ALTAS TEMPERATURAS, TEMPESTADES, ENCHENTES, INVERSAO TERMICA, DESABAMENTOS, INCENDIOS, EPIDEMIAS, CAUSANDO SERIOS DANOS A COMUNIDADE AFETADA, INCLUSIVE A INCOLUMIDADE OU A VIDA DE SEUS INTEGRANTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.4.1.00.00', 'BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA- CONSOLIDACAO', 'COMPREENDEM OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA, DE MODO A ASSEGURAR - LHES A SOBREVIVENCIA E A ECONSTRUCAO DE SUA AUTONOMIA.ENTENDE SE POR ESTADO DE CALAMIDADE PUBLICA O RECONHECIMENTO PELO PODER PUBLICO DE SITUACAO ANORMAL, ADVINDA DE BAIXAS OU ALTAS TEMPERATURAS, TEMPESTADES, ENCHENTES, INVERSAO TERMICA, DESABAMENTOS, INCENDIOS, EPIDEMIAS, CAUSANDO SERIOS DANOS A COMUNIDADE AFETADA, INCLUSIVE A INCOLUMIDADE OU A VIDA DE SEUS INTEGRANTES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.5.0.0.00.00', 'POLITICAS PUBLICAS DE TRANSFERENCIA DE RENDA', 'COMPREENDE AS POLITICAS PUBLICAS QUE VISEM CONTRIBUIR PARA A REDUCAO DA FOME, DA POBREZA, DA DESIGUALDADE E DE OUTRAS FORMAS DE PRIVACAO VIVIDAS PELAS FAMILIAS MAIS EXCLUIDAS, CONSIDERANDO TRES DIMENSOES: O ALIVIO IMEDIATO DA POBREZA, POR MEIO DA TRANSFERENCIA DE RENDA DIRETAMENTE AS FAMILIAS POBRES E EXTREMAMENTE POBRES; A CONTRIBUICAO PARA A REDUCAO DA POBREZA DA GERACAO SEGUINTE, POR MEIO DO REFORCO DO DIREITO DE ACESSO AOS SERVICOS DE SAUDE E DE EDUCACAO, COM O CUMPRIMENTO DAS CONDICIONALIDADES NESTAS AREAS; E A ARTICULACAO DE ACOES COMPLEMENTARES, DE FORMA A DESENVOLVER AS CAPACIDADES DAS FAMILIAS BENEFICIARIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.5.0.1.00.00', 'POLITICAS PUBLICAS DE TRANSFERENCIA DE RENDA - CONSOLIDACAO', 'COMPREENDE AS POLITICAS PUBLICAS QUE VISEM CONTRIBUIR PARA A REDUCAO DA FOME, DA POBREZA, DA DESIGUALDADE E DE OUTRAS FORMAS DE PRIVACAO VIVIDAS PELAS FAMILIAS MAIS EXCLUIDAS, CONSIDERANDO TRES DIMENSOES: O ALIVIO IMEDIATO DA POBREZA, POR MEIO DA TRANSFERENCIA DE RENDA DIRETAMENTE AS FAMILIAS POBRES E EXTREMAMENTE POBRES; A CONTRIBUICAO PARA A REDUCAO DA POBREZA DA GERACAO SEGUINTE, POR MEIO DO REFORCO DO DIREITO DE ACESSO AOS SERVICOS DE SAUDE E DE EDUCACAO, COM O CUMPRIMENTO DAS CONDICIONALIDADES NESTAS AREAS; E A ARTICULACAO DE ACOES COMPLEMENTARES, DE FORMA A DESENVOLVER AS CAPACIDADES DAS FAMILIAS BENEFICIARIAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.0.00.00', 'OUTROS BENEFICIOS PREVIDENCIARIOS - RPPS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFICIOS PREVIDENCIARIOS DO RPPS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.00.00', 'OUTROS BENEFICIOS PREVIDENCIARIOS - RPPS - CONSOLIDACAO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFICIOS PREVIDENCIARIOS DO RPPS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.12.00', 'SALARIO-FAMILIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.0.00.00', 'OUTROS BENEFICIOS PREVIDENCIARIOS - RGPS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFICIOS PREVIDENCIARIOS DO RGPS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.00.00', 'OUTROS BENEFICIOS PREVIDENCIARIOS - RGPS - CONSOLIDACAO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFICIOS PREVIDENCIARIOS DO RGPS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.20.00', 'SALARIO-FAMILIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.0.00.00', 'OUTROS BENEFICIOS PREVIDENCIARIOS - MILITAR', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFICIOS PREVIDENCIARIOS DO REGIME PROPRIO DOS MILITARES, NAO ABRANGIDAS NOS GRUPOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.00.00', 'OUTROS BENEFICIOS PREVIDENCIARIOS - MILITAR - CONSOLIDACAO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFICIOS PREVIDENCIARIOS DO REGIME PROPRIO DOS MILITARES, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.9.0.00.00', 'OUTROS BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTROS BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.0.0.0.00.00', 'USO DE BENS, SERVICOS E CONSUMO DE CAPITAL FIXO', 'COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM MANUTENCAO E OPERACAO DA MAQUINA PUBLICA, EXCETO DESPESAS COM PESSOAL E ENCARGOS QUE SERAO REGISTRADAS EM GRUPO ESPECIFICO (DESPESAS DE PESSOAL E ENCARGOS). COMPREENDE: DIARIAS, MATERIAL DE CONSUMO,MATERIAL DE DISTRIBUICAO GRATUITA, PASSAGENS E DESPESAS COM LOCOMOCAO, SERVICOS DE TERCEIROS, ARRENDAMENTO MERCANTIL OPERACIONAL, ALUGUEL, DEPRECIACAO, AMORTIZACAO, EXAUSTAO, ENTRE OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.0.0.00.00', 'USO DE MATERIAL DE CONSUMO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA DISTRIBUICAO DO MATERIAL DE CONSUMO. UM MATERIAL E CONSIDERADO DE CONSUMO QUANDO FOR DE DURACAO INFERIOR A DOIS ANOS, FRAGIL, PERECIVEL, INCORPORAVEL, TRANSFORMAVEL OU CUJA FINALIDADE SEJA PARA CONSUMO IMEDIATO OU PARA REPOSICAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.0.00.00', 'CONSUMO DE MATERIAL', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE REQUISICAO DE MATERIAL DE CONSUMO PARA USO INTERNO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.00.00', 'CONSUMO DE MATERIAL - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE REQUISICAO DE MATERIAL DE CONSUMO PARA USO INTERNO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.0.00.00', 'DISTRIBUICAO DE MATERIAL GRATUITO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA DISTRIBUICAO DE MATERIAL GRATUITO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.00.00', 'DISTRIBUICAO DE MATERIAL GRATUITO - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA DISTRIBUICAO DE MATERIAL GRATUITO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.2.00.00', 'DISTRIBUICAO DE MATERIAL GRATUITO - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA DISTRIBUICAO DE MATERIAL GRATUITO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.5.00.00', 'DISTRIBUICAO DE MATERIAL GRATUITO - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA DISTRIBUICAO DE MATERIAL GRATUITO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.0.00.00', 'DIARIAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS AOS SERVIDORES, EMPREGADOS PUBLICOS E COLABORADORES EVENTUAIS, PARA FAZER FACE A DESPESAS COM POUSADA, ALIMENTACAO E LOCOMOCAO URBANA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.00.00', 'DIARIAS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS AOS SERVIDORES, EMPREGADOS PUBLICOS E COLABORADORES EVENTUAIS, PARA FAZER FACE A DESPESAS COM POUSADA, ALIMENTACAO E LOCOMOCAO URBANA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.01.00', 'DIARIAS PESSOAL CIVIL', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE PESSOAL CIVIL,COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO SERVIDOR PUBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.02.00', 'DIARIAS - PESSOAL MILITAR', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DECORRENTES DO DESLOCAMENTO DO MILITAR DA SEDE DE SUA UNIDADE POR MOTIVO DE SERVICO, DESTINADAS AA INDENIZACAO DAS DESPESAS DE ALIMENTACAO E POUSADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.03.00', 'DIARIAS - COLABORADORES EVENTUAIS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS A PRESTADORES DE SERVICOS DE CARATER EVENTUAL, SEM VINCULO COM A ADMINISTRACAO PUBLICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.0.00.00', 'SERVICOS TERCEIROS - PF', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POR PESSOA FISICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICACAO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIACAO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVICOS DE TERCEIROS SE O PROPRIO ORGAO OU ENTIDADE FORNECER A MATERIA-PRIMA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.00.00', 'SERVICOS TERCEIROS - PF - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POR PESSOA FISICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICACAO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIACAO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVICOS DE TERCEIROS SE O PROPRIO ORGAO OU ENTIDADE FORNECER A MATERIA-PRIMA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.01.00', 'CONSULTORIA E ASSESSORIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.11.00', 'MANUTENCAO E CONSERVACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS E IMOVEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.21.00', 'LOCACOES', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE BENS MOVEIS E IMOVEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.38.00', 'DESPESAS COM LOCOMOCAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIOS DE TRANSPORTES AEREOS,TERRESTRES, FLUVIAIS OU MARITIMAS, LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.0.00.00', 'SERVICOS TERCEIROS - PJ', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POR PESSOA JURIDICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICACAO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIACAO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVICOS DE TERCEIROS SE O PROPRIO ORGAO OU ENTIDADE FORNECER A MATERIA-PRIMA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.00.00', 'SERVICOS TERCEIROS - PJ - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POR PESSOA JURIDICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICACAO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIACAO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVICOS DE TERCEIROS SE O PROPRIO ORGAO OU ENTIDADE FORNECER A MATERIA-PRIMA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.01.00', 'CONSULTORIA E ASSESSORIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.02.00', 'PERICIAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.04.00', 'COMUNICACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.06.00', 'MANUTENCAO E CONSERVACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.07.00', 'SERVICOS DE APOIO', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.08.00', 'SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.10.00', 'LOCACOES', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE LOCACAO DE BENS MOVEIS, IMOVEIS OU INTAGIVEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.11.00', 'SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NA AREA DE INFORMATICA; ATUALIZACAO E ADAPTACAO DE PROGRAMAS DE PROCESSAMENTO DE DADOS; SUPORTE TECNICO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS,ANALISE P/ACRESCENTAR NOVAS FUNCOES, HOSPEDAGEM DE SISTEMAS E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.12.00', 'SERVICOS DE TRANSPORTE', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE SERVIDORES, TRABALHADORES DE UMA ENTIDADE OU DE MERCADORIAS E PRODUTOS DIVERSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.54.00', 'LOCACAO DE MAO-DE-OBRA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOAS JURIDICAS PARA ORGAOS PUBLICOS, TAIS COMO LIMPEZA E HIGIENE, VIGILANCIA OSTENSIVA E OUTROS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.55.00', 'ARRENDAMENTO MERCANTIL OPERACIONAL', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL OPERACIONAL', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.56.00', 'PASSAGENS E DESPESAS COM LOCOMOCAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS,TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE, SEGUROS, FRETAMENTO, PEDAGIOS, LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOASE SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.00.00', 'SERVICOS TERCEIROS - PJ - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POR PESSOA JURIDICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICACAO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIACAO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVICOS DE TERCEIROS SE O PROPRIO ORGAO OU ENTIDADE FORNECER A MATERIA-PRIMA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.01.00', 'CONSULTORIA E ASSESSORIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.02.00', 'PERICIAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.04.00', 'COMUNICACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.05.00', 'PUBLICIDADE', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.06.00', 'MANUTENCAO E CONSERVACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.07.00', 'SERVICOS DE APOIO', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.09.00', 'SERVICOS DE ALIMENTACAO', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE FORNECIMENTO DE ALIMENTACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.10.00', 'LOCACOES', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE LOCACAO DE BENS MOVEIS, IMOVEIS OU INTAGIVEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.11.00', 'SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NA AREA DE INFORMATICA; ATUALIZACAO E ADAPTACAO DE PROGRAMAS DE PROCESSAMENTO DE DADOS; SUPORTE TECNICO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS,ANALISE P/ACRESCENTAR NOVAS FUNCOES, HOSPEDAGEM DE SISTEMAS E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.12.00', 'SERVICOS DE TRANSPORTE', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE SERVIDORES, TRABALHADORES DE UMA ENTIDADE OU DE MERCADORIAS E PRODUTOS DIVERSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.54.00', 'LOCACAO DE MAO-DE-OBRA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOAS JURIDICAS PARA ORGAOS PUBLICOS, TAIS COMO LIMPEZA E HIGIENE, VIGILANCIA OSTENSIVA E OUTROS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.55.00', 'ARRENDAMENTO MERCANTIL OPERACIONAL', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL OPERACIONAL', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.2.56.00', 'PASSAGENS E DESPESAS COM LOCOMOCAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS,TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE, SEGUROS, FRETAMENTO, PEDAGIOS, LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOASE SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.00.00', 'SERVICOS TERCEIROS - PJ - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POR PESSOA JURIDICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICACAO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIACAO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVICOS DE TERCEIROS SE O PROPRIO ORGAO OU ENTIDADE FORNECER A MATERIA-PRIMA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.01.00', 'CONSULTORIA E ASSESSORIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.02.00', 'PERICIAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.04.00', 'COMUNICACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.05.00', 'PUBLICIDADE', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.06.00', 'MANUTENCAO E CONSERVACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.07.00', 'SERVICOS DE APOIO', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.08.00', 'SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.09.00', 'SERVICOS DE ALIMENTACAO', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE FORNECIMENTO DE ALIMENTACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.10.00', 'LOCACOES', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE LOCACAO DE BENS MOVEIS, IMOVEIS OU INTAGIVEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.11.00', 'SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NA AREA DE INFORMATICA; ATUALIZACAO E ADAPTACAO DE PROGRAMAS DE PROCESSAMENTO DE DADOS; SUPORTE TECNICO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS,ANALISE P/ACRESCENTAR NOVAS FUNCOES, HOSPEDAGEM DE SISTEMAS E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.12.00', 'SERVICOS DE TRANSPORTE', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE SERVIDORES, TRABALHADORES DE UMA ENTIDADE OU DE MERCADORIAS E PRODUTOS DIVERSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.54.00', 'LOCACAO DE MAO-DE-OBRA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOAS JURIDICAS PARA ORGAOS PUBLICOS, TAIS COMO LIMPEZA E HIGIENE, VIGILANCIA OSTENSIVA E OUTROS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.55.00', 'ARRENDAMENTO MERCANTIL OPERACIONAL', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL OPERACIONAL', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.4.56.00', 'PASSAGENS E DESPESAS COM LOCOMOCAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS,TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE, SEGUROS, FRETAMENTO, PEDAGIOS, LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOASE SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.00.00', 'SERVICOS TERCEIROS - PJ - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POR PESSOA JURIDICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICACAO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIACAO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVICOS DE TERCEIROS SE O PROPRIO ORGAO OU ENTIDADE FORNECER A MATERIA-PRIMA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.01.00', 'CONSULTORIA E ASSESSORIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.02.00', 'PERICIAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.04.00', 'COMUNICACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.05.00', 'PUBLICIDADE', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.06.00', 'MANUTENCAO E CONSERVACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.07.00', 'SERVICOS DE APOIO', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.08.00', 'SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.09.00', 'SERVICOS DE ALIMENTACAO', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE FORNECIMENTO DE ALIMENTACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.10.00', 'LOCACOES', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE LOCACAO DE BENS MOVEIS, IMOVEIS OU INTAGIVEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.11.00', 'SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NA AREA DE INFORMATICA; ATUALIZACAO E ADAPTACAO DE PROGRAMAS DE PROCESSAMENTO DE DADOS; SUPORTE TECNICO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS,ANALISE P/ACRESCENTAR NOVAS FUNCOES, HOSPEDAGEM DE SISTEMAS E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.12.00', 'SERVICOS DE TRANSPORTE', 'COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE SERVIDORES, TRABALHADORES DE UMA ENTIDADE OU DE MERCADORIAS E PRODUTOS DIVERSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.54.00', 'LOCACAO DE MAO-DE-OBRA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOAS JURIDICAS PARA ORGAOS PUBLICOS, TAIS COMO LIMPEZA E HIGIENE, VIGILANCIA OSTENSIVA E OUTROS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.5.56.00', 'PASSAGENS E DESPESAS COM LOCOMOCAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS,TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE, SEGUROS, FRETAMENTO, PEDAGIOS, LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOASE SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.4.0.00.00', 'CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA - ART. 18 § 1, LC 101/00', 'COMPREENDE A APROPRIACAO DAS DESPESAS RELATIVAS A MAO-DE-OBRA, CONSTANTES DOS CONTRATOS DE TERCEIRIZACAO, CLASSIFICAVEIS NO GRUPO DE DESPESA COM PESSOAL E ENCARGOS EM OBEDIENCIA AO DISPOSTO NO ARTIGO 18, § 1º, DA LEI COMPLEMENTAR Nº 101, DE 2000.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.0.0.00.00', 'DEPRECIACAO, AMORTIZACAO E EXAUSTAO', 'COMPREENDE O DECRESCIMO NO BENEFICIO DE UM BEM DURANTE O PERIODO CONTABIL DECORRENTE DE DEPRECIACAO, AMORTIZACAO E EXAUSTAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.1.0.00.00', 'DEPRECIACAO', 'COMPREENDE A REDUCAO DO VALOR DOS BENS TANGIVEIS PELO DESGASTE OU PERDA DE UTILIDADE POR USO, ACAO DA NATUREZA OU OBSOLESCENCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.1.1.00.00', 'DEPRECIACAO - CONSOLIDACAO', 'COMPREENDE A REDUCAO DO VALOR DOS BENS TANGIVEIS PELO DESGASTE OU PERDA DE UTILIDADE POR USO, ACAO DA NATUREZA OU OBSOLESCENCIA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.2.0.00.00', 'AMORTIZACAO', 'COMPREENDE A REDUCAO DO VALOR APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE E QUAISQUER OUTROS, INCLUSIVE ATIVOS INTANGIVEIS, COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.2.1.00.00', 'AMORTIZACAO - CONSOLIDACAO', 'COMPREENDE A REDUCAO DO VALOR APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE E QUAISQUER OUTROS, INCLUSIVE ATIVOS INTANGIVEIS, COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.3.0.00.00', 'EXAUSTAO', 'COMPREENDE A REDUCAO DO VALOR DECORRENTE DA EXPLORACAO DOS RECURSOS MINERAIS, FLORESTAIS E OUTROS RECURSOS NATURAIS ESGOTAVEIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.3.1.00.00', 'EXAUSTAO - CONSOLIDACAO', 'COMPREENDE A REDUCAO DO VALOR DECORRENTE DA EXPLORACAO DOS RECURSOS MINERAIS, FLORESTAIS E OUTROS RECURSOS NATURAIS ESGOTAVEIS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.0.0.00.00', 'CUSTO DE MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADOS NA PRODUCAO DE BENS OU SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.0.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.1.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.2.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.4.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.5.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.0.00.00', 'CUSTO DE PRODUTOS VENDIDOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.1.00.00', 'CUSTO DE PRODUTOS VENDIDOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - CONSOLIDACAO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.2.00.00', 'CUSTO DE PRODUTOS VENDIDOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTRA OFSS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.4.00.00', 'CUSTO DE PRODUTOS VENDIDOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTER OFSS - ESTADO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.5.00.00', 'CUSTO DE PRODUTOS VENDIDOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTER OFSS - MUNICIPIO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.0.00.00', 'CUSTO DE SERVICOS PRESTADOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.1.00.00', 'CUSTO DE SERVICOS PRESTADOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - CONSOLIDACAO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.2.00.00', 'CUSTO DE SERVICOS PRESTADOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTRA OFSS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.4.00.00', 'CUSTO DE SERVICOS PRESTADOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTER OFSS - ESTADO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.5.00.00', 'CUSTO DE SERVICOS PRESTADOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTER OFSS - MUNICIPIO', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.0.0.0.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES FINANCEIRAS, TAIS COMO: JUROS INCORRIDOS, DESCONTOS CONCEDIDOS, COMISSOES, DESPESAS BANCARIAS E CORRECOES MONETARIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.0.0.00.00', 'JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS OBTIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.0.00.00', 'JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DIVIDA PUBLICA INTERNA DERIVADA DE OBRIGACOES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.1.00.00', 'JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA- CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DIVIDA PUBLICA INTERNA DERIVADA DE OBRIGACOES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.4.00.00', 'JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DIVIDA PUBLICA INTERNA DERIVADA DE OBRIGACOES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.5.00.00', 'JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICIPIO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DIVIDA PUBLICA INTERNA DERIVADA DE OBRIGACOES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.2.0.00.00', 'JUROS E ENCARGOS DA DIVIDA CONTRATUAL EXTERNA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DIVIDA PUBLICA EXTERNA DERIVADA DE OBRIGACOES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.2.1.00.00', 'JUROS E ENCARGOS DA DIVIDA CONTRATUAL EXTERNA- CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DIVIDA PUBLICA EXTERNA DERIVADA DE OBRIGACOES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.3.0.00.00', 'JUROS E ENCARGOS DA DIVIDA MOBILIARIA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DIVIDA PUBLICA REPRESENTADA POR TITULOS EMITIDOS PELO GOVERNO. SAO CONSIDERADOS ENCARGOS DA DIVIDA MOBILIARIA: COMISSOES, CORRETAGENS, SEGUROS, DESAGIO E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.3.1.00.00', 'JUROS E ENCARGOS DA DIVIDA MOBILIARIA - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DIVIDA PUBLICA REPRESENTADA POR TITULOS EMITIDOS PELO GOVERNO. SAO CONSIDERADOS ENCARGOS DA DIVIDA MOBILIARIA: COMISSOES, CORRETAGENS, SEGUROS, DESAGIO E OUTROS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.4.0.00.00', 'JUROS E ENCARGOS DE EMPRESTIMOS POR ANTECIPACAO DE RECEITA ORCAMENTARIA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS SOBRE EMPRESTIMOS CONTRAIDOS POR ANTECIPACAO DE RECEITA ORCAMENTARIA PARA ATENDER INSUFICIENCIA DE CAIXA DURANTE O EXERCICIO FINANCEIRO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.4.1.00.00', 'JUROS E ENCARGOS DE EMPRESTIMOS POR ANTECIPACAO DE RECEITA ORCAMENTARIA - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS SOBRE EMPRESTIMOS CONTRAIDOS POR ANTECIPACAO DE RECEITA ORCAMENTARIA PARA ATENDER INSUFICIENCIA DE CAIXA DURANTE O EXERCICIO FINANCEIRO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.8.0.00.00', 'OUTROS JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS QUE NAO SEJAM REFERENTES A DIVIDA CONTRATUAL, A DIVIDA MOBILIARIA E A POR ANTECIPACAO DE RECEITA ORCAMENTARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.9.0.00.00', 'OUTROS JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS EXTERNOS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS EXTERNOS QUE NAO SEJAM REFERENTES A DIVIDA CONTRATUAL, A DIVIDA MOBILIARIA E A POR ANTECIPACAO DE RECEITA ORCAMENTARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.0.0.00.00', 'JUROS E ENCARGOS DE MORA', 'COMPREENDE O MONTANTE DE VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.0.00.00', 'JUROS E ENCARGOS DE MORA DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.1.00.00', 'JUROS E ENCARGOS DE MORA DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.4.00.00', 'JUROS E ENCARGOS DE MORA DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - ESTADO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.5.00.00', 'JUROS E ENCARGOS DE MORA DE EMPRESTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - MUNICIPIO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.2.0.00.00', 'JUROS E ENCARGOS DE MORA DE EMPRESTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS EXTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.2.1.00.00', 'JUROS E ENCARGOS DE MORA DE EMPRESTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS EXTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.0.00.00', 'JUROS E ENCARGOS DE MORA DE AQUISICAO DE BENS E SERVICOS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.00.00', 'JUROS E ENCARGOS DE MORA DE AQUISICAO DE BENS E SERVICOS - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.01.00', 'JUROS DE MORA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.02.00', 'MULTAS DEDUTIVEIS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.03.00', 'MULTAS INDEDUTIVEIS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.99.00', 'OUTROS ENCARGOS DE MORA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.2.00.00', 'JUROS E ENCARGOS DE MORA DE AQUISICAO DE BENS E SERVICOS - INTRA OFSS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.2.01.00', 'JUROS DE MORA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.2.02.00', 'MULTAS DEDUTIVEIS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.2.03.00', 'MULTAS INDEDUTIVEIS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.2.99.00', 'OUTROS ENCARGOS DE MORA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.4.00.00', 'JUROS E ENCARGOS DE MORA DE AQUISICAO DE BENS E SERVICOS - INTER OFSS - ESTADO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.4.01.00', 'JUROS DE MORA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.4.02.00', 'MULTAS DEDUTIVEIS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.4.03.00', 'MULTAS INDEDUTIVEIS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.4.99.00', 'OUTROS ENCARGOS DE MORA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.5.00.00', 'JUROS E ENCARGOS DE MORA DE AQUISICAO DE BENS E SERVICOS - INTER OFSS - MUNICIPIO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.5.01.00', 'JUROS DE MORA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.5.02.00', 'MULTAS DEDUTIVEIS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.5.03.00', 'MULTAS INDEDUTIVEIS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.5.99.00', 'OUTROS ENCARGOS DE MORA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.0.00.00', 'JUROS E ENCARGOS DE MORA DE OBRIGACOES TRIBUTARIAS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.1.00.00', 'JUROS E ENCARGOS DE MORA DE OBRIGACOES TRIBUTARIAS - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.2.00.00', 'JUROS E ENCARGOS DE MORA DE OBRIGACOES TRIBUTARIAS - INTRA OFSS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.4.00.00', 'JUROS E ENCARGOS DE MORA DE OBRIGACOES TRIBUTARIAS - INTER OFSS - ESTADO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.9.0.00.00', 'OUTROS JUROS E ENCARGOS DE MORA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.0.0.00.00', 'VARIACOES MONETARIAS E CAMBIAIS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.0.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL INTERNA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.1.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL INTERNA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.2.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA- INTRA OFSS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL INTERNA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.4.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA CONTRATUAL - INTER OFSS - ESTADO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL INTERNA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.5.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICIPIO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL INTERNA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.0.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL EXTERNA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.1.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL EXTERNA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.2.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA- INTRA OFSS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL EXTERNA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.4.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA CONTRATUAL - INTER OFSS - ESTADO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL EXTERNA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.5.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA - INTER OFSS - MUNICIPIO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL EXTERNA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.3.0.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA MOBILIARIA INTERNA', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA MOBILIARIA INTERNA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.3.1.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA MOBILIARIA INTERNA- CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA MOBILIARIA INTERNA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.4.1.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA- CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA MOBILIARIA EXTERNA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.0.00.00', 'OUTRAS VARIACOES MONETARIAS E CAMBIAIS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.1.00.00', 'OUTRAS VARIACOES MONETARIAS E CAMBIAIS - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.1.01.00', 'OUTRAS VARIACOES MONETARIAS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.2.00.00', 'OUTRAS VARIACOES MONETARIAS E CAMBIAIS - INTRA OFSS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.2.01.00', 'OUTRAS VARIACOES MONETARIAS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.4.00.00', 'OUTRAS VARIACOES MONETARIAS E CAMBIAIS - INTER OFSS - ESTADO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.4.01.00', 'OUTRAS VARIACOES MONETARIAS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.5.00.00', 'OUTRAS VARIACOES MONETARIAS E CAMBIAIS - INTER OFSS - MUNICIPIO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.5.01.00', 'OUTRAS VARIACOES MONETARIAS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.4.0.0.00.00', 'DESCONTOS FINANCEIROS CONCEDIDOS', 'COMPREENDE O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM DESCONTOS FINANCEIROS CONCEDIDOS A CLIENTES POR PAGAMENTOS ANTECIPADOS DE DUPLICATAS E OUTROS TITULOS. NAO SE CONFUNDEM COM DESCONTOS NOS PRECOS DE VENDA CONCEDIDOS INCONDICIONALMENTE, OU ABATIMENTOS DE PRECOS, QUE SAO DEDUCOES DA RECEITA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.0.0.00.00', 'OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS - FINANCEIRAS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.0.00.00', 'JUROS E ENCARGOS EM SENTENCAS JUDICIAIS', 'COMPREENDE OS JUROS E ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.1.00.00', 'JUROS E ENCARGOS EM SENTENCAS JUDICIAIS - CONSOLIDACAO', 'COMPREENDE OS JUROS E ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.2.00.00', 'JUROS E ENCARGOS EM SENTENCAS JUDICIAIS - INTRA OFSS', 'COMPREENDE OS JUROS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.4.00.00', 'JUROS E ENCARGOS EM SENTENCAS JUDICIAIS - INTER OFSS - ESTADO', 'COMPREENDE OS JUROS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.5.00.00', 'JUROS E ENCARGOS EM SENTENCAS JUDICIAIS - INTER OFSS - MUNICIPIO', 'COMPREENDE OS JUROS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.1.00.00', 'JUROS E ENCARGOS EM INDENIZACOES E RESTITUICOES - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES E RESTITUICOES REFERENTES A JUROS E ENCARGOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.2.00.00', 'JUROS E ENCARGOS EM INDENIZACOES E RESTITUICOES - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES E RESTITUICOES REFERENTES A JUROS E ENCARGOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.4.00.00', 'JUROS E ENCARGOS EM INDENIZACOES E RESTITUICOES - INTER OFSS - ESTADO', 'CCOMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES E RESTITUICOES REFERENTES A JUROS E ENCARGOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.5.00.00', 'JUROS E ENCARGOS EM INDENIZACOES E RESTITUICOES - INTER OFSS - MUNICIPIO', 'CCOMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES E RESTITUICOES REFERENTES A JUROS E ENCARGOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.9.0.00.00', 'OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NAS CONTAS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.0.0.0.00.00', 'TRANSFERENCIAS E DELEGACOES CONCEDIDAS', 'COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TRANSFERENCIAS INTER GOVERNAMENTAIS, TRANSFERENCIAS INTRAGOVERNAMENTAIS, TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS, TRANSFERENCIAS A INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS, TRANSFERENCIAS A CONVENIOS, TRANSFERENCIAS AO EXTERIOR E EXECUCOES ORCAMENTARIAS DELEGADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.0.0.00.00', 'TRANSFERENCIAS INTRAGOVERNAMENTAIS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS RELATIVAS A EXECUCAO ORCAMENTARIA, E DE BENS E VALORES, REFERENTES AS TRANSACOES INTRA GOVERNAMENTAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.0.00.00', 'TRANSFERENCIAS CONCEDIDAS PARA A EXECUCAO ORCAMENTARIA', 'COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS CONCEDIDAS E CORRESPONDENCIA DE CREDITOS EM VIRTUDE DA EXECUCAO ORCAMENTARIA (COTA, REPASSSE E SUB-REPASSE). INCLUI TAMBEM O VALOR REPASSADO PARA A COBERTURA DO DEFICIT FINANCEIRO DO RPPS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.00.00', 'TRANSFERENCIAS CONCEDIDAS PARA A EXECUCAO ORCAMENTARIA - INTRA OFSS', 'COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS CONCEDIDAS E CORRESPONDENCIA DE CREDITOS EM VIRTUDE DA EXECUCAO ORÇAMENTARIA (COTA, REPASSE E SUB-REPASSE). INCLUI TAMBEM O VALOR REPASSADO PARA A COBERTURA DO DEFICIT FINANCEIRO DO RPPS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.05.00', 'VALORES DIFERIDOS - BAIXA', 'COMPREENDE O VALOR TOTAL DOS VALORES DIFERIDOS NO PROCESSO DE BAIXA, SUBDIVIDINDO-SE EM COTA, REPASSE E SUB-REPASSE DIFERIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.06.00', 'VALORES DIFERIDOS - INSCRICAO', 'COMPREENDE O VALOR TOTAL DOS VALORES DIFERIDOS NO PROCESSO DE INSCRICAO, SUBDIVIDINDO-SE EM COTA, REPASSE E SUB-REPASSE DIFERIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.07.00', 'CORRESPONDENCIA DE CREDITOS', 'COMPREENDE OS VALORES REFERENTES AS TRANSFERENCIAS DE CREDITOS EFETUADOS ENTRE UGS DE UMA MESMA GESTAO, PARA APURACAO DE CUSTO E RESULTADO DE GESTAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.0.00.00', 'TRANSFERENCIAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORCAMENTARIA', 'COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS, DE BENS OU VALORES CONCEDIDAS PARA RESTOS A PAGAR E OUTRAS FINALIDADES INDEPENDENTES DA EXECUCAO ORCAMENTARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.00.00', 'TRANSFERENCIAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORCAMENTARIA - INTRA OFSS', 'COMPREENDE O VALOR DAS TRANSFERÊNCIAS FINANCEIRAS, DE BENS OU VALORES CONCEDIDAS PARA RESTOS A PAGAR E OUTRAS FINALIDADES INDEPENDENTES DA EXECUCAO ORCAMENTARIA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.05.00', 'TRANSFERENCIAS DIVERSAS CONCEDIDAS', 'COMPREENDE O VALOR REFERENTE AS TRANSFERENCIAS DIVERSAS DE NATUREZA EVENTUAL CONCEDIDAS ENTRE UG DE MESMA GESTAO INDEPENDENTE DE EXECUCAO ORCAMENTARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.10.00', 'OUTROS MOVIMENTOS DE FUNDOS A CREDITO', 'COMPREENDE O VALOR DA TRANSFERENCIA DE AJUSTES COM SALDO DEVEDOR OU CREDOR, ENTRE UG DE EMPRESAS INTEGRANTES DO SIAFI E OUTROS MOVIMENTOS A CREDITO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.14.00', 'DOACOES CONCEDIDAS DE BENS MOVEIS', 'COMPREENDE O VALOR DOS BENS MOVEIS CONCEDIDOS PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DE ORGAOS DIFERENTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.3.0.00.00', 'TRANSFERENCIAS CONCEDIDAS PARA COBERTURA DO DEFICIT ATUARIAL DO RPPS POR APORTE PERIODICO', 'COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS PARA APORTES PERIODICOS DESTINADOS A COBERTURA DO DEFICIT ATUARIAL DO REGIME PROPRIO DE PREVIDENCIA SOCIAL - RPPS, CONFORME PLANO DE AMORTIZACAO ESTABELECIDO EM LEI DO RESPECTIVO ENTE FEDERATIVO, EXCETO AS DECORRENTES DE ALIQUOTA DE CONTRIBUICAO SUPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.0.0.00.00', 'TRANSFERENCIAS INTER GOVERNAMENTAIS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.0.00.00', 'DISTRIBUICAO CONSTITUCIONAL OU LEGAL DE RECEITAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A OUTRAS ESFERAS DE GOVERNO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.1.00.00', 'DISTRIBUICAO CONSTITUCIONAL OU LEGAL DE RECEITAS- CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A OUTRAS ESFERAS DE GOVERNO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS). POR EXEMPLO, EMPRESA INDEPENDENTE DE UM ENTE RECEBENDO TRANSFERENCIA DE OUTRO ENTE (A EMPRESA INDEPENDENTE NAO PERTENCE AO OFSS MAS PERTENCE AO CONCEITO DE GOVERNAMENTAL).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.00.00', 'DISTRIBUICAO CONSTITUCIONAL OU LEGAL DE RECEITAS- INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A OUTRAS ESFERAS DE GOVERNO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.00.00', 'DISTRIBUICAO CONSTITUCIONAL OU LEGAL DE RECEITAS- INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA A OUTRAS ESFERAS DE GOVERNO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.0.00.00', 'TRANSFERENCIAS AO FUNDEB', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA DE RECURSOS DOS ENTES, INCLUINDO A COMPLEMENTACAO DA UNIAO, PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.00.00', 'TRANSFERENCIAS AO FUNDEB - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA DE RECURSOS DOS ENTES, INCLUINDO A COMPLEMENTACAO DA UNIAO, PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.5.00.00', 'TRANSFERENCIAS AO FUNDEB - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA TRANSFERENCIA DE RECURSOS DOS ENTES, INCLUINDO A COMPLEMENTACAO DA UNIAO, PARA A COMPOSICAO DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA E DE VALORIZACAO DOS PROFISSIONAIS DA EDUCACAO, INSTITUIDO PELA E.C. N.º 53/2006 E REGULAMENTADO PELA LEI 11.494/2007. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.0.00.00', 'TRANSFERENCIAS VOLUNTARIAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIAS VOLUNTARIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, BEM COMO A DEMAIS ENTIDADES, DE BENS E/OU VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.1.00.00', 'TRANSFERENCIAS VOLUNTARIAS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIAS VOLUNTARIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, BEM COMO A DEMAIS ENTIDADES, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS). POR EXEMPLO, EMPRESA INDEPENDENTE DE UM ENTE RECEBENDO TRANSFERÊNCIA DE OUTRO ENTE. (A EMPRESA INDEPENDENTE NÃO PERTENCE AO OFSS, MAS PERTENCE AO CONCEITO DE GOVERNAMENTAL).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.4.00.00', 'TRANSFERENCIAS VOLUNTARIAS- INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIAS VOLUNTARIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, BEM COMO A DEMAIS ENTIDADES, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.5.00.00', 'TRANSFERENCIAS VOLUNTARIAS- INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIAS VOLUNTARIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, BEM COMO A DEMAIS ENTIDADES, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.1.00.00', 'OUTRAS TRANSFERENCIAS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE DEMAIS TRANSFERENCIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.00.00', 'OUTRAS TRANSFERENCIAS- INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE DEMAIS TRANSFERENCIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.01.00', 'TRANSFER. A ESTADOS E AO DF - FUNDO A FUNDO - CONTRIBUICOES', 'COMPREENDE O SOMATORIO DAS TRANSFERENCIAS A ESTADOS E D.F. A TITULO DE CONTRIBUICOES P/REALIZ.DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.02.00', 'TRANSF. A ESTADOS E AO DISTRITO FEDERAL - CONTRIBUICOES P/ PESSOAL E ENCARGOS SOCIAIS', 'COMPREENDE O SOMATORIO DAS TRANSFERENCIAS EFETUADAS AOS ESTADOS E AO DISTRITO FEDERAL PELA UNIAO PARA REALIZACOES DE VPD COM PESSOAL E ENCARGOS SOCIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.03.00', 'TRANSF. A ESTADOS E AO DISTRITO FEDERAL -CONTRIBUICOES P/ OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ESTADOS E DISTRITO FEDERAL PARA REALIZACAO DE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.20.00', 'INDENIZACOES E RESTITUICOES', 'COMPREENDE O SOMATORIO DAS DESPESAS COM INDENIZACOES, EXCLUSIVE AS TRABALHISTAS, E RESTITUICOES, DEVIDAS POR ORGAOS E ENTIDADES A QUALQUER TITULO , INCLUSIVE DEVOLUCAO DE RECEITAS QUANDO NAO FOR POSSIVEL EFETUAR ESSA DEVOLUCAO MEDIANTE A COMPENSACAO COM A RECEITA CORRESPONDENTE, BEM COMO OUTRAS DESPESAS DE NATUREZA INDENIZATORIA NAO CLASSIFICADAS EM ELEMENTOS DE DESPESAS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.00.00', 'OUTRAS TRANSFERÊNCIAS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE DEMAIS TRANSFERENCIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PÚBLICOS DISTINTOS, RESULTANTES DAS TRANSAÇÕES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.01.00', 'TRANSFERENCIAS A MUNICIPIOS - CONTRIBUICOES P/ OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.02.00', 'TRANSFERENCIAS A MUNICIPIOS - FUNDO A FUNDO - CONTRIBUICOES', 'COMPREENDE O SOMATORIO DAS TRANSFERENCIAS EFETUADAS AOS MUNICIPIOS PARA REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.19.00', 'SENTENCAS JUDICIAIS', 'REPRESENTA O SOMATORIO DA DESPESAS CORRENTES RESULTANTES DE: A) PAGAMENTO DE PRECATORIOS, EM CUMPRIMENTO AO DISPOSTO NO ART. 100 E SEUS PARAGRAFOS DA CONSTITUICAO, E NO ART. 78 DO ADCT; B) CUMPRIMENTO DE SENTENCAS JUDICIAIS, TRANSITADAS EM JULGADO, DE EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA, INTEGRANTES DOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL; C) CUMPRIMENTO DE SENTENCAS JUDICIAIS, TRANSITADAS EM JULGADO, DE PEQUENO VALOR, NA FORMA DEFINIDA EM LEI, NOS TERMOS DO § 3º DO ART. 100 DA CONSTITUICAO (RPV); E D) CUMPRIMENTO DE DECISOES JUDICIAIS, PROFERIDAS EM MANDADOS DE SEGURACA E MEDIDAS CAUTELARES, REFERENTES A VANTAGENS PECUNIARIAS CONCEDIDAS E AINDA NAO INCORPORADAS EM CARATER DEFINITIVO AS REMUNERACOES DOS BENEFICIARIOS. OBS: TRANSFERENCIA A MINICIPIOS DO ESTADO DA BAHIA EM CUMPRIMENTO A DE', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.20.00', 'INDENIZACOES E RESTITUICOES', 'REPRESENTA O SOMATORIO DAS DESPESAS COM INDENIZACOES, EXCLUSIVE AS TRABALHISTAS, E RESTITUICOES, DEVIDAS POR ORGAOS E ENTIDADES A QUALQUER TITULO , INCLUSIVE DEVOLUCAO DE RECEITAS QUANDO NAO FOR POSSIVEL EFETUAR ESSA DEVOLUCAO MEDIANTE A COMPENSACAO COM A RECEITA CORRESPONDENTE, BEM COMO OUTRAS DESPESAS DE NATUREZA INDENIZATORIA NAO CLASSIFICADAS EM ELEMENTOS DE DESPESAS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.0.00.00', 'TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS DE BENS E VALORES A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS QUE NAO TENHAM VINCULO COM A ADMINISTRACAO PUBLICA, EXEMPLO: ONGS,OSCIPS E OS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.00.00', 'TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS DE BENS E VALORES A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS QUE NAO TENHAM VINCULO COM A ADMINISTRACAO PUBLICA, EXEMPLO: ONGS,OSCIPS E OS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.00', 'TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - CONTRIBUICOES', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE CONTRIBUICOES - VPD AS QUAIS NAO CORRESPONDA CONTRAPRESTACAO DIRETA EM BENS E SERVICOS E NAO SEJA REEMBOLSAVEL PELO RECEBEDOR, INCLUSIVE AS DESTINADAS A ATENDER A VARIACAO PATRIMONIAL DIMINUTIVA DE MANUTENCAO DE OUTRAS ENTIDADES DE DIREITO PUBLICO OU PRIVADO, OBSERVADO O DISPOSTO NA LEGISLACAO VIGENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.02.00', 'TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - SUBVENCOES SOCIAIS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE SUBVENCOES SOCIAIS - COBERTURA DE VARIACAO PATRIMONIAL DIMINUTIVA DE INSTITUICOES PRIVADAS DE CARATER ASSISTENCIAL OU CULTURAL, SEM FINALIDADE LUCRATIVA, DE ACORDO COM OS ARTS. 16, PARAGRAFO UNICO, E 17 DA LEI N. 4.320, DE 1964, OBSERVADO O DISPOSTO NO ART. 26 DA LEI COMPLEMENTAR N. 101, DE 2000.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.2.0.00.00', 'TRANSFERENCIAS A INSTITUICOES PRIVADAS COM FINS LUCRATIVOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS DE BENS E VALORES A INSTITUICOES PRIVADAS COM FINS LUCRATIVOS QUE NAO TENHAM VINCULOS COM ADMINISTRACAO PUBLICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.2.1.00.00', 'TRANSFERENCIAS A INSTITUICOES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS DE BENS E VALORES A INSTITUICOES PRIVADAS COM FINS LUCRATIVOS, QUE NAO TENHAM VINCULOS COM A ADMINISTRACAO PUBLICA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.2.1.01.00', 'SUBVENCOES ECONOMICAS', 'COMPREENDE O VALOR DAS DESPESAS ORCAMENTARIAS COM O PAGAMENTO DE SUBVENCOES ECONOMICAS, A QUALQUER TITULO, AUTORIZADAS EM LEIS ESPECIFICAS, TAIS COMO: AJUDA FINANCEIRA A ENTIDADES PRIVADAS COM FINS LUCRATIVOS; CONCESSAO DE BONIFICACOES A PRODUTORES, DISTRIBUIDORES E VENDEDORES; COBERTURA, DIRETA OU INDIRETA, DE PARCELA DE ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS E DOS CUSTOS DE AQUISICAO, DE PRODUCAO, DE ESCOAMENTO, DE DISTRIBUICAO, DE VENDA E DE MANUTENCAO DE BENS, PRODUTOS E SERVICOS EM GERAL; E, AINDA, OUTRAS OPERACOES COM CARACTERISTICAS SEMELHANTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.4.0.1.00.00', 'TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS, DAS QUAIS O ENTE TRANSFERIDOR NAO PARTICIPE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.4.0.1.01.00', 'TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS - CONTRIBUICOES', 'COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS AS QUAIS NAO CORRESPONDA CONTRAPRESTACAO DIRETA EM BENS E SERVICOS E NAO SEJA REEMBOLSAVEL PELO RECEBEDOR, INCLUSIVE AS DESTINADAS A ATENDER A DESPESAS DE MANUTENCAO DE OUTRAS ENTIDADES DE DIREITO PUBLICO E PRIVADO, OBSERVADO O DISPOSTO NA LEGISLACAO VIGENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.5.0.1.01.00', 'CONTRIBUICOES', 'COMPREENDE O VALOR DAS CONTRIBUICOES CONCEDIDAS VINCULADAS A CONSORCIOS PUBLICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.5.0.1.20.00', 'INDENIZACOES E RESTITUICOES', 'COMPREENDE O VALOR DAS APROPRIACOES DE DESPESAS CORRENTES, COM INDENI ZACOES, EXCLUSIVE AS TRABALHISTAS, E RESTITUICOES, DEVIDAS POR ORGAOS E ENTIDADES A QUALQUER TITULO, INCLUSIVE DEVOLUCAO DE RECEITAS QUANDO NAO FOR POSSIVEL EFETUAR ESSA DEVOLUCAO MEDIANTE A COMPENSACAO COM A RECEITA CORRESPONDENTE, BEM COMO OUTRAS DESPESAS DE NATUREZA INDENIZATORIA, NAO CLASSIFICADAS EM ELEMENTOS DE DESPESA ESPECIFICOS. CONTA CRIADA PARA ATENDER CONTRATO DE RATEIO CELEBRADO ENTRE A UNIAO, O GOVERNO DO RIO DE JANEIRO E O MUNICIPIO DO RIO DE JANEIRO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.0.00.00', 'TRANSFERENCIAS AO EXTERIOR', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIAS A ORGANISMOS E FUNDOS INTERNACIONAIS, DE GOVERNOS ESTRANGEIROS E INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.00.00', 'TRANSFERENCIAS AO EXTERIOR - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIAS A ORGANISMOS E FUNDOS INTERNACIONAIS, DE GOVERNOS ESTRANGEIROS E INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS NO EXTERIOR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.01.00', 'TRANSFERENCIAS AO EXTERIOR - DIARIAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO EXTERIOR PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM DIARIAS DE PESSOAL CIVIL NO PAIS E NO EXTERIOR, COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO SERVIDOR PUBLICO ESTATUTARIO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.02.00', 'TRANSFERENCIAS AO EXTERIOR -MATERIAL DE CONSUMO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO EXTERIOR PARA ATENDER VPD COM MATERIAL DE CONSUMO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.03.00', 'TRANSFERENCIAS AO EXTERIOR - SERVICOS DE TERCEIROS ­ PF', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO EXTERIOR A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.04.00', 'TRANSFERENCIAS AO EXTERIOR - SERVICOS DE TERCEIROS-PJ', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO EXTERIOR A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.05.00', 'TRANSFERENCIAS AO EXTERIOR - CONTRIBUICOES', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO EXTERIOR AS QUAIS NAO CORRESPONDA CONTRAPRESTACAO DIRETA EM BENS E SERVICOS E NAO SEJA REEMBOLSAVEL PELO RECEBEDOR, BEM COMO AS DESTINADAS A ATENDER A VARIACAO PATRIMONIAL DIMINUTIVA DE MANUTENCAO DE OUTRAS ENTIDADES DE DIREITO PUBLICO OU PRIVADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.0.0.00.00', 'EXECUCAO ORCAMENTARIA DELEGADA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIA DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS ENTES (UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS) OU CONSORCIOS PUBLICOS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.0.00.00', 'EXECUCAO ORCAMENTARIA DELEGADA A ENTES', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIA DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS ENTES (UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS) PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.00.00', 'EXECUCAO ORCAMENTARIA DELEGADA A ENTES - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIA DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS ENTES (UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS) PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.00', 'OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS ESTADOS E AO DISTRITO FEDERAL PARA A EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA. ', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.00', 'OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS ESTADOS E AO DISTRITO FEDERAL PARA A EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA. ', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.00', 'MATERIAL, BEM OU SERVICO P/ DISTRIB. GRATUITA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS COM AQUISICAO DE MATERIAIS BENS OU SERVICOS PARA DISTRIBUICAO GRATUITA TAIS COMO LIVROS DIDATICOS MEDICAMENTOS, GENEROS ALIMENTICIOS E OUTROS MATERIAIS, BENS E SERVICOS QUE POSSAM SER DISTRIBUIDOS GRATUITAMENTE, EXCETO SE DESTINADOS A PREMIACOES CULTURAIS, ARTISTICAS, CIENTIFICAS, DESPORTIVAS E OUTRAS (EXECUCAO DELEGADA)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.20.00', 'INDENIZACOES E RESTITUICOES', 'REPRESENTA O SOMATORIO DAS DESPESAS COM INDENIZACOES, EXCLUSIVE AS TRABALHISTAS, E RESTITUICOES, DEVIDAS POR ORGAOS E ENTIDADES A QUALQUER TITULO, INCLUSIVE DEVOLUCAO DE RECEITA QUANDO NAO FOR POSSIVEL EFETUAR ESSA DEVOLUCAO MEDIANTE A COMPENSACAO COM A RECEITA CORRESPONDENTE BEM COMO OUTRAS DESPESAS DE NATUREZA INDENIZATORIA NAO CLASSIFICADAS EM ELEMENTOS DE DESPESAS ESPECIFICOS. ', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.00.00', 'EXECUCAO ORCAMENTARIA DELEGADA A ENTES - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIA DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS ENTES (UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS) PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.00', 'MATERIAL DE CONSUMO', 'COMPREENDE O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO A MUNICIPIOS PARA A EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - MATERIAL DE CONSUMO. ', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.00', 'OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA', 'COMPREENDE O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO A MUNICIPIOS PARA A EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA FISICA. ', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.00', 'OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA', 'COMPREENDE O VALOR DAS DESPESAS ORCAMENTARIAS REALIZADAS POR MEIO DE TRANSFERENCIAS DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO A MUNICIPIOS PARA A EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE - OUTROS SERVIÇOS DE TERCEIROS - PESSOA JURIDICA. ', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.00', 'MATERIAL, BEM OU SERVICO P/ DISTRIB. GRATUITA', 'REGISTRA O VALOR DAS DESPESAS ORCAMENTARIAS COM AQUISICAO DE MATERIAIS BENS OU SERVICOS PARA DISTRIBUICAO GRATUITA TAIS COMO LIVROS DIDATICOS MEDICAMENTOS, GENEROS ALIMENTICIOS E OUTROS MATERIAIS, BENS E SERVICOS QUE POSSAM SER DISTRIBUIDOS GRATUITAMENTE, EXCETO SE DESTINADOS A PREMIACOES CULTURAIS, ARTISTICAS, CIENTIFICAS, DESPORTIVAS E OUTRAS (EXECUCAO DELEGADA)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.20.00', 'INDENIZACOES E RESTITUICOES', 'COMPREENDE O SOMATORIO DAS DESPESAS COM INDENIZACOES, EXCLUSIVE AS TRABALHISTAS, E RESTITUICOES, DEVIDAS POR ORGAOS E ENTIDADES A QUALQUER TITULO, INCLUSIVE DEVOLUCAO DE RECEITA QUANDO NAO FOR POSSIVEL EFETUAR ESSA DEVOLUCAO MEDIANTE A COMPENSACAO COM A RECEITA CORRESPONDENTE BEM COMO OUTRAS DESPESAS DE NATUREZA INDENIZATORIA NAO CLASSIFICADAS EM ELEMENTOS DE DESPESAS ESPECIFICOS. EXECUCAO ORCAMENTARIA DELEDAGA A MUNICIPIOS. ', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.2.1.00.00', 'EXECUCAO ORCAMENTARIA DELEGADA A CONSORCIOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIA DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO AOS CONSORCIOS PUBLICOS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.0.0.0.00.00', 'DESVALORIZACAO E PERDA DE ATIVOS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM DESVALORIZACAO E PERDAS DE ATIVOS, COM REDUCAO A VALOR RECUPERAVEL, COM PROVISOES PARA PERDAS, PERDAS COM ALIENACAO E PERDAS INVOLUNTARIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.0.0.00.00', 'REDUCAO A VALOR RECUPERAVEL E AJUSTE PARA PERDAS', 'COMPREENDE O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ITENS DO ATIVO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE OS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA E TAMBEM REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AJUSTE PARA PERDAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.0.00.00', 'REDUCAO A VALOR RECUPERAVEL DE INVESTIMENTOS', 'COMPREENDE O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.2.0.00.00', 'REDUCAO A VALOR RECUPERAVEL DE IMOBILIZADO', 'COMPREENDE O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ITENS DO ATIVO IMOBILIZADO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.3.0.00.00', 'REDUCAO A VALOR RECUPERAVEL DE INTANGIVEIS', 'COMPREENDE O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ATIVOS INTANGIVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.0.00.00', 'VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CREDITOS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CREDITOS POR INADIMPLENCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CREDITOS. POR EXEMPLO, A VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA CREDITOS DE LIQUIDACAO DUVIDOSA E AJUSTE PARA CREDITOS DA DIVIDA ATIVA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.00.00', 'VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CREDITOS - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CREDITOS POR INADIMPLENCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CREDITOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.0.00.00', 'VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM AJUSTE PARA REDUCAO A VALOR DE MERCADO DE ESTOQUES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.0.0.00.00', 'PERDAS COM ALIENACAO', 'COMPREENDE A PERDA COM ALIENACAO DE ATIVOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.1.0.00.00', 'PERDAS COM ALIENACAO DE INVESTIMENTOS', 'COMPREENDE A PERDA COM ALIENACAO DE INVESTIMENTOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.0.00.00', 'PERDAS COM ALIENACAO DE IMOBILIZADO', 'COMPREENDE A PERDA COM ALIENACAO DE ATIVOS IMOBILIZADOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.3.0.00.00', 'PERDAS COM ALIENACAO DE INTANGIVEIS', 'COMPREENDE A PERDA COM ALIENACAO DE ATIVOS INTANGIVEIS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.0.0.00.00', 'PERDAS INVOLUNTARIAS', 'COMPREENDEM O DESFAZIMENTO FISICO INVOLUNTARIO DO BEM, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDACOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.0.00.00', 'PERDAS INVOLUNTARIAS COM IMOBILIZADO', 'COMPREENDEM O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ATIVO IMOBILIZADO, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDACOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.2.0.00.00', 'PERDAS INVOLUNTARIAS COM INTANGIVEIS', 'COMPREENDEM O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ATIVO INTANGIVEL, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDACOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.3.0.00.00', 'PERDAS INVOLUNTARIAS COM ESTOQUES', 'COMPREENDEM O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ESTOQUE, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDACOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.9.0.00.00', 'OUTRAS PERDAS INVOLUNTARIAS', 'COMPREENDEM O DESFAZIMENTO FISICO INVOLUNTARIO DE OUTROS BENS, COMO AS QUE RESULTAM DE SINISTROS COMO INCENDIO E INUNDACOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.0.0.0.00.00', 'TRIBUTARIAS', 'COMPREENDEM AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS AOS IMPOSTOS, TAXAS, CONTRIBUICOES DE MELHORIA, CONTRIBUICOES SOCIAIS, CONTRIBUICOES ECONOMICAS E CONTRIBUICOES ESPECIAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.0.0.00.00', 'IMPOSTOS, TAXAS E CONTRIBUICOES DE MELHORIA', 'COMPREENDEM AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS AS OBRIGACOES RELATIVAS AS PRESTACOES PECUNIARIAS COMPULSORIAS, EM MOEDA OU CUJO VALOR NELA POSSA SE EXPRIMIR, QUE NAO CONSTITUA SANCAO DE ATO ILICITO, INSTITUIDA EM LEI E COBRADA MEDIANTE ATIVIDADE VINCULADA. COMO: IMPOSTOS, TAXAS E CONTRIBUICOES DE MELHORIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.0.00.00', 'IMPOSTOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM IMPOSTOS, APURADOS NO PERIODO DE COMPETENCIA, E VINCULADOS A ATIVIDADE ADMINISTRATIVA DO CONTRIBUINTE, DEFINIDOS NO CTN.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.00.00', 'IMPOSTOS CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM IMPOSTOS, APURADOS NO PERIODO DE COMPETENCIA E VINCULADOS ATIVIDADE ADMINISTRATIVA DO CONTRIBUINTE, DEFINIDOS NO CTN. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.2.00.00', 'IMPOSTOS INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM IMPOSTOS APURADOS NO PERIODO DE COMPETENCIA E VINCULADOS ATIVIDADE ADMINISTRATIVA DO CONTRIBUINTE, DEFINIDOS NO CTN. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.4.00.00', 'IMPOSTOS - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM IMPOSTOS APURADOS NO PERIODO DE COMPETENCIA, E VINCULADOS ATIVIDADE ADMINISTRATIVA DO CONTRIBUINTE, DEFINIDOS NO CTN. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.5.00.00', 'IMPOSTOS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM IMPOSTOS APURADOS NO PERIODO DE COMPETENCIA, E VINCULADOS ATIVIDADE ADMINISTRATIVA DO CONTRIBUINTE, DEFINIDOS NO CTN. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.2.0.00.00', 'TAXAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TAXAS COBRADAS PELA UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS CONTRIBUICOES, DECORRENTES DA CONTRAPRESTACAO DE SERVICOS PUBLICOS AO CONTRIBUINTE POSTOS A SUA DISPOSICAO, INCLUSIVE O EXERCICIO DE PODER DE POLICIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.3.0.00.00', 'CONTRIBUICOES DE MELHORIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TRIBUTO CUJA OBRIGACAO TEM POR FATO GERADOR UM BENEFICIO ESPECIAL AUFERIDO PELO CONTRIBUINTE QUE POR CONSEQUENCIA PROMOVE UMA VALORIZACAO IMOBILIARIA E PATRIMONIAL DECORRENTE DE OBRA PUBLICA DE COMPETENCIA DA UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS, AMPARADAS EM LEI E LIMITADAS AO TOTAL DA DESPESA PUBLICA REALIZADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.1.00.00', 'CONTRIBUICOES SOCIAIS - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO, ENTRE ELAS O PIS/PASEP,CSLL E COFINS, ETC. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.2.00.00', 'CONTRIBUICOES SOCIAIS - INTRA OFSS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO, ENTRE ELAS O PSI/PASEP, CSLL E COFINS, ETC.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.4.00.00', 'CONTRIBUICOES SOCIAIS - INTER OFSS - ESTADO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO, ENTRE ELAS O PIS/PSASEP,CSLL E COFINS, ETC.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.5.00.00', 'CONTRIBUICOES SOCIAIS - INTER OFSS - MUNICIPIO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO, ENTRE ELAS O PIS/PSASEP,CSLL E COFINS, ETC.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.1.00.00', 'CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMUNITIVA COM CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.2.00.00', 'CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO - INTRA OFSS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMUNITIVA COM CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.4.00.00', 'CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO - INTER OFSS - ESTADO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMUNITIVA COM CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO. .COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.5.00.00', 'CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO - INTER OFSS - MUNICIPIO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMUNITIVA COM CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO. .COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.3.0.00.00', 'CONTRIBUICAO PARA O CUSTEIO DO SERVICO DE ILUMINACAO PUBLICA - COSIP', 'COMPREENDE O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM A CONTRIBUICAO PARA CUSTEIO DA ILUMINACAO PUBLICA ( ART.149-A DA CF)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.9.1.00.00', 'OUTRAS CONTRIBUICOES - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES QUE NAO SE ENQUADRAM NA CONDICAO DE SOCIAIS E ECONOMICAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.9.2.00.00', 'OUTRAS CONTRIBUICOES - INTRA OFSS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES QUE NAO SE ENQUADRAM NA CONDICAO DE SOCIAIS E ECONOMICAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.9.4.00.00', 'OUTRAS CONTRIBUICOES - INTER OFSS - ESTADO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES QUE NAO SE ENQUADRAM NA CONDICAO DE SOCIAIS E ECONOMICAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.9.5.00.00', 'OUTRAS CONTRIBUICOES - INTER OFSS - MUNICIPIO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES QUE NAO SE ENQUADRAM NA CONDICAO DE SOCIAIS E ECONOMICAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.0.0.00.00', 'CUSTO COM TRIBUTOS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS OU SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.0.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.2.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.4.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.5.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.0.00.00', 'CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.00.00', 'CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.2.00.00', 'CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.4.00.00', 'CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.5.00.00', 'CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.0.00.00', 'CUSTO DE SERVICOS PRESTADOS-TRIBUTOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.00.00', 'CUSTO DE SERVICOS PRESTADOS -TRIBUTOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVICOS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.2.00.00', 'CUSTO DE SERVICOS PRESTADOS -TRIBUTOS -INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVICOS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.4.00.00', 'CUSTO DE SERVICOS PRESTADOS-TRIBUTOS - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVICOS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.5.00.00', 'CUSTO DE SERVICOS PRESTADOS-TRIBUTOS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVICOS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.0.0.0.00.00', 'OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS', 'COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS NAO INCLUIDAS NOS GRUPOS ANTERIORES. COMPREENDE: PREMIACOES, INCENTIVOS, EQUALIZACOES DE PRECOS E TAXAS, PARTICIPACOES E CONTRIBUICOES, RESULTADO NEGATIVO COM PARTICIPACOES, DENTRE OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.0.0.00.00', 'PREMIACOES', 'COMPREENDE AS AQUISICOES DE PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC., BEM COMO COM O PAGAMENTO DE PREMIOS EM PECUNIA, INCLUSIVE DECORRENTES DE SORTEIOS LOTERICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.2.0.00.00', 'PREMIACOES ARTISTICAS', 'COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER ARTISTICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.3.0.00.00', 'PREMIACOES CIENTIFICAS', 'COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CIENTIFICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.4.0.00.00', 'PREMIACOES DESPORTIVAS', 'COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER DESPORTIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.5.0.00.00', 'ORDENS HONORIFICAS', 'COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, INSIGNIAS ETC, RELATIVO A ORDENS HONORIFICAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.9.0.00.00', 'OUTRAS PREMIACOES', 'COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, PARA FINALIDADES DIFERENTES DAS PREVISTAS NOS DETALHAMENTOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.2.0.0.00.00', 'RESULTADO NEGATIVO DE PARTICIPACOES', 'COMPREENDE A APROPRIACAO DO RESULTADO NEGATIVO DE PARTICIPACOES, ORIUNDO DE PREJUIZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.2.1.0.00.00', 'RESULTADO NEGATIVO DE EQUIVALENCIA PATRIMONIAL', 'COMPREENDE A APROPRIACAO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUIZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS DE INSTITUICOES FINANCEIRAS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.01.00', 'VPD COM OPERACOES DE AUTORIDADE MONETARIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A OPERACOES DA AUTORIDADE MONETARIA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.1.02.00', 'VPD OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A TRANSACOES REALIZADAS NO PERIODO, VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS DE INSTITUICOES FINANCEIRAS - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.01.00', 'VPD COM OPERACOES DE AUTORIDADE MONETARIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A OPERACOES DA AUTORIDADE MONETARIA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.2.02.00', 'VPD OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A TRANSACOES REALIZADAS NO PERIODO, VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS DE INSTITUICOES FINANCEIRAS - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.01.00', 'VPD COM OPERACOES DE AUTORIDADE MONETARIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A OPERACOES DA AUTORIDADE MONETARIA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.4.02.00', 'VPD OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A TRANSACOES REALIZADAS NO PERIODO, VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS DE INSTITUICOES FINANCEIRAS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.01.00', 'VPD COM OPERACOES DE AUTORIDADE MONETARIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A OPERACOES DA AUTORIDADE MONETARIA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.3.0.5.02.00', 'VPD OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A TRANSACOES REALIZADAS NO PERIODO, VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.1.0.00.00', 'INCENTIVOS A EDUCACAO', 'COMPREENDE A AJUDA FINANCEIRA CONCEDIDA PELO ESTADO A ESTUDANTES COMPROVADAMENTE CARENTES, E CONCESSAO DE AUXILIO PARA O DESENVOLVIMENTO DE ESTUDOS E PESQUISAS DE NATUREZA CIENTIFICA REALIZADAS POR PESSOAS FISICAS NA CONDICAO DE ESTUDANTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.1.1.00.00', 'INCENTIVOS A EDUCACAO - CONSOLIDACAO', 'COMPREENDE A AJUDA FINANCEIRA CONCEDIDA PELO ESTADO A ESTUDANTES COMPROVADAMENTE CARENTES, E CONCESSAO DE AUXILIO PARA O DESENVOLVIMENTO DE ESTUDOS E PESQUISAS DE NATUREZA CIENTIFICA REALIZADAS POR PESSOAS FISICAS NA CONDICAO DE ESTUDANTE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.2.0.00.00', 'INCENTIVOS A CIENCIA', 'COMPREENDE O APOIO FINANCEIRO CONCEDIDO A PESQUISADORES, INDIVIDUAL OU COLETIVAMENTE, EXCETO NA CONDICAO DE ESTUDANTE, NO DESENVOLVIMENTO DE PESQUISAS CIENTIFICAS E TECNOLOGICAS, NAS SUAS MAIS DIVERSAS MODALIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.2.1.00.00', 'INCENTIVOS A CIENCIA - CONSOLIDACAO', 'COMPREENDE O APOIO FINANCEIRO CONCEDIDO A PESQUISADORES, INDIVIDUAL OU COLETIVAMENTE, EXCETO NA CONDICAO DE ESTUDANTE, NO DESENVOLVIMENTO DE PESQUISAS CIENTIFICAS E TECNOLOGICAS, NAS SUAS MAIS DIVERSAS MODALIDADES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.3.0.00.00', 'INCENTIVOS A CULTURA', 'COMPREENDE OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DA CULTURA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.4.0.00.00', 'INCENTIVOS AO ESPORTE', 'COMPREENDE OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DO ESPORTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.9.0.00.00', 'OUTROS INCENTIVOS', 'COMPREENDE OUTROS INCENTIVOS FINANCEIROS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.0.00.00', 'SUBVENCOES ECONOMICAS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM O PAGAMENTO DE SUBVENCOES ECONOMICAS, A QUALQUER TITULO, AUTORIZADAS EM LEIS ESPECIFICAS, TAIS COMO: AJUDA FINANCEIRA A ENTIDADES PRIVADAS COM FINS LUCRATIVOS; CONCESSAO DE BONIFICACOES A PRODUTORES, DISTRIBUIDORES E VENDEDORES; COBERTURA, DIRETA OU INDIRETA, DE PARCELA DE ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS E DOS CUSTOS DE AQUISICAO, DE PRODUCAO, DE ESCOAMENTO, DE DISTRIBUICAO, DE VENDA E DE MANUTENCAO DE BENS, PRODUTOS E SERVICOS EM GERAL; E, AINDA, OUTRAS OPERACOES COM CARACTERISTICAS SEMELHANTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.00.00', 'SUBVENCOES ECONOMICAS - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM O PAGAMENTO DE SUBVENCOES ECONOMICAS, A QUALQUER TITULO, AUTORIZADAS EM LEIS ESPECIFICAS, TAIS COMO: AJUDA FINANCEIRA A ENTIDADES PRIVADAS COM FINS LUCRATIVOS; CONCESSAO DE BONIFICACOES A PRODUTORES, DISTRIBUIDORES E VENDEDORES; COBERTURA, DIRETA OU INDIRETA, DE PARCELA DE ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS E DOS CUSTOS DE AQUISICAO, DE PRODUCAO, DE ESCOAMENTO, DE DISTRIBUICAO, DE VENDA E DE MANUTENCAO DE BENS, PRODUTOS E SERVICOS EM GERAL; E, AINDA, OUTRAS OPERACOES COM CARACTERISTICAS SEMELHANTES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.0.0.00.00', 'PARTICIPACOES E CONTRIBUICOES', 'COMPREENDE AS PARTICIPACOES DE TERCEIROS NOS LUCROS, NAO RELATIVAS AO INVESTIMENTO DOS ACIONISTAS, TAIS COMO: PARTICIPACOES DE DEBENTURES, EMPREGADOS, ADMINISTRADORES E PARTES BENEFICIARIAS, MESMO NA FORMA DE INSTRUMENTOS FINANCEIROS, ALEM DA CONTRIBUICAO A INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.2.0.00.00', 'PARTICIPACOES DE EMPREGADOS', 'COMPREENDE AS PARTICIPACOES DE EMPREGADOS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.3.0.00.00', 'PARTICIPACOES DE ADMINISTRADORES', 'COMPREENDE AS PARTICIPACOES DE ADMINISTRADORES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.4.0.00.00', 'PARTICIPACOES DE PARTES BENEFICIARIAS', 'COMPREENDE AS PARTICIPACOES DE PARTES BENEFICIARIAS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.5.0.00.00', 'PARTICIPACOES DE INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS', 'COMPREENDE AS CONTRIBUICOES DA EMPRESA, INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO, PARA INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.0.0.00.00', 'VPD DE CONSTITUICAO DE PROVISOES', 'COMPREENDE A CONSTITUICAO DE PROVISOES, ENTENDIDAS COMO OS PASSIVOS DE VENCIMENTO OU MONTANTE INCERTOS. NAO SE CONFUNDEM COM OS PASSIVOS DERIVADOS DE APROPRIACAO POR COMPETENCIA, COMO FERIAS E DECIMO - TERCEIRO SALARIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.2.0.00.00', 'VPD DE PROVISOES MATEMATICAS PREVIDENCIARIAS A LONGO PRAZO', 'COMPREENDE A CONSTITUICAO DE PROVISOES DE PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A FUTUROS BENEFICIOS PREVIDENCIARIOS A SEREM PAGOS AOS CONTRIBUINTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.3.0.00.00', 'VPD DE PROVISOES PARA RISCOS FISCAIS', 'COMPREENDE A CONSTITUICAO DE PROVISOES DE PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUACOES FISCAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.4.0.00.00', 'VPD DE PROVISAO PARA RISCOS CIVEIS', 'COMPREENDE A CONSTITUICAO DE PROVISOES DE PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.5.0.00.00', 'VPD DE PROVISAO PARA REPARTICAO DE CREDITOS', 'COMPREENDE A CONSTITUICAO DE PROVISOES DE PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CREDITOS TRIBUTARIOS E NAO TRIBUTARIOS RECONHECIDOS NO LANCAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.6.0.00.00', 'VPD DE PROVISAO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP', 'COMPREENDE A CONSTITUICAO DE PROVISOES DE PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUCAO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.9.0.00.00', 'VPD DE OUTRAS PROVISOES', 'COMPREENDE A CONSTITUICAO DE PROVISOES DE PASSIVOS DE PRAZO OU DE VALOR INCERTOS NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.0.0.00.00', 'CUSTO DE OUTRAS VPD', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE BENS OU SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.1.0.00.00', 'CUSTO DE MERCADORIAS VENDIDAS - OUTRAS VPD', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.2.0.00.00', 'CUSTO DE PRODUTOS VENDIDOS - OUTRAS VPD', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.3.0.00.00', 'CUSTO DE SERVICOS PRESTADOS - OUTRAS VPD', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.0.0.00.00', 'DIVERSAS VARIACOES PATRIMONIAIS DIMINUTIVAS', 'COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS NAO CLASSIFICADAS EM ITENS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.1.0.00.00', 'COMPENSACAO FINANCEIRA ENTRE RGPS/RPPS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.2.0.00.00', 'COMPENSACAO FINANCEIRA ENTRE REGIMES PROPRIOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.3.0.00.00', 'VARIACAO PATRIMONIAL DIMINUTIVA COM BONIFICACOES', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE BONIFICACOES CONCEDIDAS NA VENDA DE MERCADORIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.9.0.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.9.1.00.00', 'VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORESS DIVERSOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.0.0.0.00.00', 'IMPOSTOS, TAXAS E CONTRIBUICOES DE MELHORIA', 'COMPREENDE TODA PRESTACAO PECUNIARIA COMPULSORIA, EM MOEDA OU CUJO VALOR NELA SE POSSA EXPRIMIR, QUE NAO CONSTITUA SANCAO DE ATO ILICITO, INSTITUIDA EM LEI E COBRADA MEDIANTE ATIVIDADE ADMINISTRATIVA PLENAMENTE VINCULADA. COMO : IMPOSTOS , TAXAS E CONTRIBUICOES DE MELHORIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.0.0.00.00', 'IMPOSTOS', 'COMPREENDE OS TRIBUTOS CUJA OBRIGACAO TEM POR FATO GERADOR UMA SITUACAO INDEPENDENTE DE QUALQUER ATIVIDADE ESTATAL ESPECIFICA, RELATIVA AO CONTRIBUINTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.0.00.00', 'IMPOSTOS SOBRE COMERCIO EXTERIOR', 'COMPREENDE OS IMPOSTOS SOBRE OPERACOES DE COMERCIO EXTERIOR, COMO POR EXEMPLO: IMPOSTOS SOBRE A IMPORTACAO E IMPOSTO SOBRE A EXPORTACAO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.1.00.00', 'IMPOSTOS SOBRE COMERCIO EXTERIOR - CONSOLIDACAO', 'COMPREENDE OS IMPOSTOS SOBRE OPERACOES DE COMERCIO EXTERIOR,COMO EXEMPLO: IMPOSTOS SOBRE A IMPORTACAO E IMPOSTOS SOBRE A EXPORTACAO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.1.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.2.00.00', 'IMPOSTOS SOBRE COMERCIO EXTERIOR - INTRA OFSS', 'COMPREENDE OS IMPOSTOS SOBRE OPERACOES DE COMERCIO EXTERIOR, COMO POR EXEMPLO: IMPOSTOS SOBRE A IMPORTACAO E IMPOSTO SOBRE A EXPORTACAO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.4.00.00', 'IMPOSTOS SOBRE COMERCIO EXTERIOR - INTER OFSS - ESTADO', 'COMPREENDE OS IMPOSTOS SOBRE OPERACOES DE COMERCIO EXTERIOR, COMO POR EXEMPLO: IMPOSTOS SOBRE A IMPORTACAO E IMPOSTO SOBRE A EXPORTACAO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.5.00.00', 'IMPOSTOS SOBRE COMERCIO EXTERIOR - INTER OFSS - MUNICIPIO', 'COMPREENDE OS IMPOSTOS SOBRE OPERACOES DE COMERCIO EXTERIOR, COMO POR EXEMPLO: IMPOSTOS SOBRE A IMPORTACAO E IMPOSTO SOBRE A EXPORTACAO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.5.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.0.00.00', 'IMPOSTOS SOBRE PATRIMONIO E A RENDA', 'COMPREENDE OS IMPOSTOS SOBRE PATRIMONIO E A RENDA, COMO POR EXEMPLO: IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL, IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA, IMPOSTO SOBRE A TRANSMISSAO DE BENS IMOVEIS E DE DIREITOS A ELES RELATIVOS E IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.00.00', 'IMPOSTOS SOBRE PATRIMONIO E A RENDA - CONSOLIDACAO', 'COMPREENDE OS IMPOSTOS SOBRE PATRIMONIO E A RENDA,COMO EXEMPLO: IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL,IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA,IMPOSTO SOBRE A TRANSMISSAO DE BENS IMOVEIS E DE DIREITOS A ELES RELATIVOS E IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.01.00', 'IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL', 'COMPREENDE A VPA COM O IMPOSTO S/PROPRIEDADE TERRITORIAL RURAL, DE COMPETENCIA DA UNIAO. TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL POR NATUREZA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.02.00', 'IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA', 'COMPREENDE O VALOR DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA. TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I - DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II - DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.2.00.00', 'IMPOSTOS SOBRE PATRIMONIO E A RENDA - INTRA OFSS', 'COMPREENDE OS IMPOSTOS SOBRE PATRIMONIO E A RENDA,COMO POR EXEMPLO: IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL, IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA, IMPOSTO SOBRE A TRANSMISSAO DE BENS IMOVEIS E DE DIREITOS A ELES RELATIVOS E IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.2.01.00', 'IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL', 'COMPREENDE A VPA COM O IMPOSTO S/PROPRIEDADE TERRITORIAL RURAL, DE COMPETENCIA DA UNIAO. TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL POR NATUREZA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.2.02.00', 'IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA', 'COMPREENDE O VALOR DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I - DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II - DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.4.00.00', 'IMPOSTOS SOBRE PATRIMONIO E A RENDA - INTER OFSS - ESTADO', 'COMPREENDE OS IMPOSTOS SOBRE PATRIMONIO E A RENDA,COM POR EXEMPLO:IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA, IMPOSTO SOBRE A TRANSMISSAO DE BENS IMOVEIS E DE DIREITOS A ELES RELATIVOS E IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.4.02.00', 'IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA', 'COMPREENDE O VALOR DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I - DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II - DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.4.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.5.00.00', 'IMPOSTOS SOBRE PATRIMONIO E A RENDA - INTER OFSS - MUNICIPIO', 'COMPREENDE OS IMPOSTOS SOBRE PATRIMONIO E A RENDA,COM POR EXEMPLO:IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA, IMPOSTO SOBRE A TRANSMISSAO DE BENS IMOVEIS E DE DIREITOS A ELES RELATIVOS E IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.5.01.00', 'IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL', 'COMPREENDE A VPA COM O IMPOSTO S/PROPRIEDADE TERRITORIAL RURAL, DE COMPETENCIA DA UNIAO. TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL POR NATUREZA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.0.00.00', 'IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO', 'COMPREENDE OS IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO, COMO POR EXEMPLO: IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS; IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS;IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.00.00', 'IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO -CONSOLIDACAO', 'COMPRENDE OS IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO,COMO POR EXEMPLO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS;IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.01.00', 'IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS', 'COMPREENDE O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I - O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II - A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III - A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO.PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA-SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.02.00', 'IMPOSTOS S/ OPERACAO DE CREDITO, CAMBIO, SEGUROS OU RELATIVOS A TITULOS E VALORES MOBILIARIOS', 'COMPREENDE O VALOR DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERACOES DE CREDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERACOES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERACOES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.2.00.00', 'IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO -INTRA OFSS', 'COMPREENDE OS IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO, COMO POR EXEMPLO: IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS; IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS; IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.2.01.00', 'IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS', 'COMPREENDE O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I - O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II - A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III - A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA-SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.2.02.00', 'IMPOSTOS S/ OPERACAO DE CREDITO, CAMBIO, SEGUROS OU RELATIVOS A TITULOS E VALORES MOBILIARIOS', 'COMPREENDE O VALOR DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERACOES DE CREDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERACOES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERACOES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.4.00.00', 'IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO - INTER OFSS - ESTADO', 'COMPREENDE OS IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO, POR EXEMPLO: IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS;IMPOSTO SOBRE OPERACOES DE CREDITO;CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS; IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.4.01.00', 'IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS', 'COMPREENDE O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I - O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II - A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III - A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA-SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.4.02.00', 'IMPOSTOS S/ OPERACAO DE CREDITO, CAMBIO, SEGUROS OU RELATIVOS A TITULOS E VALORES MOBILIARIOS', 'COMPREENDE O VALOR DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERACOES DE CREDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERACOES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERACOES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.5.00.00', 'IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO - INTER OFSS - MUNICIPIO', 'COMPREENDE OS IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO, POR EXEMPLO: IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS;IMPOSTO SOBRE OPERACOES DE CREDITO;CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS; IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.5.01.00', 'IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS', 'COMPREENDE O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I - O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II - A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III - A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA-SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.5.02.00', 'IMPOSTOS S/ OPERACAO DE CREDITO, CAMBIO, SEGUROS OU RELATIVOS A TITULOS E VALORES MOBILIARIOS', 'COMPREENDE O VALOR DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERACOES DE CREDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERACOES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERACOES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.4.0.00.00', 'IMPOSTOS EXTRAORDINARIOS', 'COMPREENDE OS IMPOSTOS INSTITUIDOS PELA UNIAO, TEMPORARIAMENTE, NA IMINENCIA OU NO CASO DE GUERRA EXTERNA, SUPRIMIDOS, GRADATIVAMENTE, NO PRAZO MAXIMO DE CINCO ANOS, CONTADOS DA CELEBRACAO DA PAZ.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.0.0.00.00', 'TAXAS', 'COMPREENDE AS TAXAS COBRADAS PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES. TEM COMO FATO GERADOR O EXERCICIO REGULAR DO PODER DE POLICIA, OU A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.0.00.00', 'TAXAS PELO EXERCICIO DO PODER DE POLICIA', 'COMPREENDE AS TAXAS PELO PODER DE POLICIA AQUELAS DECORRENTES DAS ATIVIDADES DA ADMINISTRACAO PUBLICA QUE, LIMITANDO OU DISCIPLINANDO DIREITO, INTERESSE OU LIBERDADE, REGULA A PRATICA DE ATO OU ABSTENCAO DE FATO, EM RAZAO DE INTERESSE PUBLICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.00.00', 'TAXAS PELO EXERCICIO DO PODER DE POLICIA - CONSOLIDACAO', 'COMPREENDE AS TAXAS PELO PODER DE POLICIA AQUELAS DECORRENTES DAS ATIVIDADES DA ADMINISTRACAO PUBLICA QUE, LIMITANDO OU DISCIPLINANDO DIREITO, INTERESSE OU LIBERDADE, REGULA A PRATICA DE ATO OU ABSTENCAO DE FATO EM RAZAO DE INTERESSE PUBLICO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.02.00', 'TAXA DE FISCALIZACAO DAS TELECOMUNICACOES', 'COMPREENDE A VPA COM TAXA QUANDO DA FISCALIZACAO SERVICOS DE TELECOMUNICACOES PELO PODER PUBLICO, NO EXERCICIO REGULAR DO PODER DE POLICIA. TAXAS DEVIDAS PELAS CONCESSIONARIAS E PERMISSIONARIAS DE SERVICOS DE TELECOMUNICACOES, COMPREENDENDO: A TAXA DE FISCALIZACAO DE INSTALACAO, DEVIDA NO MOMENTO EM QUE E OUTORGADA AUTORIZACAO PARA A EXECUCAO DO SERVICO E A TAXA DE FISCALIZACAO DO FUNCIONAMENTO, DEVIDA PELA FISCALIZACAO DA EXECUCAO DOS SERVICOS. RECEITA VINCULADA AO FUNDO DE FISCALIZACAO DAS TELECOMUNICACOES - FISTEL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.04.00', 'TAXAS DO DEPARTAMENTO DE POLICIA FEDERAL', 'REGISTRA A VPA COM TAXAS DO DEPARTAMENTO DE POLICIA FEDERAL, AUFERIDA PELA PRESTACAO DE SERVICOS RELATIVOS A FISCALIZACAO DE EMPRESAS DE SEGURANCAO PRIVADA, SEGURANCA PROPRIA, DE TRANSPORTE DE VALORES, DE ESTABELECIMENTOS FINANCEIROS E DE ESTABELECIMENTOS DE FORMACAO DE VIGILANTES. OS VALORES ARRECADADOS DESTINAM-SE AO CUSTEIO E MANUTENCAO DE ATIVIDADES-FIM DO DEPARTAMENTO DE POLICIA FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.13.00', 'TAXA DE SAUDE SUPLEMENTAR', 'COMPREENDE A VPA PROVENIENTE DA TAXA DE SAUDE SUPLEMENTAR, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO, QUE OPEREM O PRODUTO, SERVICOS OU CONTRATO DE COM A FINALIDADE DE GARANTIR A ASSISTENCIA A SAUDE VISANDO A ASSISTENCIA MEDICA HOSPITALAR OU ODONTOLOGICA. OS RE- CURSOS SERAO VINCULADOS A AGENCIA NACIONAL DE SAUDE - ANS (LEI 9961 DE 28/01/2000).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.00.00', 'TAXAS PELO EXERCICIO DO PODER DE POLICIA - INTRA OFSS', 'COMPREENDE AS TAXAS PELO PODER DE POLICIA AQUELAS DECORRENTES DAS ATIVIDADES DA ADMINISTRACAO PUBLICA QUE,LIMITANDO OU DISCIPLINANDO DIREITO,INTERESSE OU LIBERDADE, REGULA A PRATICA DE ATO OU ABSTEMCAO DE FATO, EM RAZAO DE INTERESSE PUBLICO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.02.00', 'TAXA DE FISCALIZACAO DAS TELECOMUNICACOES', 'COMPREENDE A VPA COM TAXA QUANDO DA FISCALIZACAO SERVICOS DE TELECOMUNICACOES PELO PODER PUBLICO, NO EXERCICIO REGULAR DO PODER DE POLICIA. TAXAS DEVIDAS PELAS CONCESSIONARIAS E PERMISSIONARIAS DE SERVICOS DE TELECOMUNICACOES, COMPREENDENDO: A TAXA DE FISCALIZACAO DE INSTALACAO, DEVIDA NO MOMENTO EM QUE E OUTORGADA AUTORIZACAO PARA A EXECUCAO DO SERVICO E A TAXA DE FISCALIZACAO DO FUNCIONAMENTO, DEVIDA PELA FISCALIZACAO DA EXECUCAO DOS SERVICOS. RECEITA VINCULADA AO FUNDO DE FISCALIZACAO DAS TELECOMUNICACOES - FISTEL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.04.00', 'TAXAS DO DEPARTAMENTO DE POLICIA FEDERAL', 'REGISTRA A VPA COM TAXAS DO DEPARTAMENTO DE POLICIA FEDERAL, AUFERIDA PELA PRESTACAO DE SERVICOS RELATIVOS A FISCALIZACAO DE EMPRESAS DE SEGURANCAO PRIVADA, SEGURANCA PROPRIA, DE TRANSPORTE DE VALORES, DE ESTABELECIMENTOS FINANCEIROS E DE ESTABELECIMENTOS DE FORMACAO DE VIGILANTES. OS VALORES ARRECADADOS DESTINAM-SE AO CUSTEIO E MANUTENCAO DE ATIVIDADES-FIM DO DEPARTAMENTO DE POLICIA FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.2.13.00', 'TAXA DE SAUDE SUPLEMENTAR', 'COMPREENDE A VPA PROVENIENTE DA TAXA DE SAUDE SUPLEMENTAR, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO, QUE OPEREM O PRODUTO, SERVICOS OU CONTRATO DE COM A FINALIDADE DE GARANTIR A ASSISTENCIA A SAUDE VISANDO A ASSISTENCIA MEDICA HOSPITALAR OU ODONTOLOGICA. OS RE- CURSOS SERAO VINCULADOS A AGENCIA NACIONAL DE SAUDE - ANS (LEI 9961 DE 28/01/2000).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.00.00', 'TAXAS PELO EXERCICIO DO PODER DE POLICIA - INTER OFSS - ESTADO', 'COMPREENDE AS TAXAS PELO PODER DE POLICIA AQUELAS DECORRENTES DAS ATIVIDADES DA ADMINISTRACAO PUBLICA QUE,LIMITANDO OU DISCIPLINANDO DIREITO, INTERESSE OU LIBERDADE,REGULA A PRATICA DE ATO OU ABSTENCAO DE FATO,EM RAZAO DE INTERESSE PUBLICO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.02.00', 'TAXA DE FISCALIZACAO DAS TELECOMUNICACOES', 'COMPREENDE A VPA COM TAXA QUANDO DA FISCALIZACAO SERVICOS DE TELECOMUNICACOES PELO PODER PUBLICO, NO EXERCICIO REGULAR DO PODER DE POLICIA. TAXAS DEVIDAS PELAS CONCESSIONARIAS E PERMISSIONARIAS DE SERVICOS DE TELECOMUNICACOES, COMPREENDENDO: A TAXA DE FISCALIZACAO DE INSTALACAO, DEVIDA NO MOMENTO EM QUE E OUTORGADA AUTORIZACAO PARA A EXECUCAO DO SERVICO E A TAXA DE FISCALIZACAO DO FUNCIONAMENTO, DEVIDA PELA FISCALIZACAO DA EXECUCAO DOS SERVICOS. RECEITA VINCULADA AO FUNDO DE FISCALIZACAO DAS TELECOMUNICACOES - FISTEL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.04.00', 'TAXAS DO DEPARTAMENTO DE POLICIA FEDERAL', 'REGISTRA A VPA COM TAXAS DO DEPARTAMENTO DE POLICIA FEDERAL, AUFERIDA PELA PRESTACAO DE SERVICOS RELATIVOS A FISCALIZACAO DE EMPRESAS DE SEGURANCAO PRIVADA, SEGURANCA PROPRIA, DE TRANSPORTE DE VALORES, DE ESTABELECIMENTOS FINANCEIROS E DE ESTABELECIMENTOS DE FORMACAO DE VIGILANTES. OS VALORES ARRECADADOS DESTINAM-SE AO CUSTEIO E MANUTENCAO DE ATIVIDADES-FIM DO DEPARTAMENTO DE POLICIA FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.4.13.00', 'TAXA DE SAUDE SUPLEMENTAR', 'COMPREENDE A VPA PROVENIENTE DA TAXA DE SAUDE SUPLEMENTAR, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO, QUE OPEREM O PRODUTO, SERVICOS OU CONTRATO DE COM A FINALIDADE DE GARANTIR A ASSISTENCIA A SAUDE VISANDO A ASSISTENCIA MEDICA HOSPITALAR OU ODONTOLOGICA. OS RECURSOS SERAO VINCULADOS A AGENCIA NACIONAL DE SAUDE - ANS (LEI 9961 DE 28/01/2000).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.00.00', 'TAXAS PELO EXERCICIO DO PODER DE POLICIA - INTER OFSS - MUNICIPIO', 'COMPREENDE AS TAXAS PELO PODER DE POLICIA AQUELAS DECORRENTES DAS ATIVIDADES DA ADMINISTRACAO PUBLICA QUE,LIMITANDO OU DISCIPLINANDO DIREITO, INTERESSE OU LIBERDADE,REGULA A PRATICA DE ATO OU ABSTENCAO DE FATO,EM RAZAO DE INTERESSE PUBLICO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.02.00', 'TAXA DE FISCALIZACAO DAS TELECOMUNICACOES', 'COMPREENDE A VPA COM TAXA QUANDO DA FISCALIZACAO SERVICOS DE TELECOMUNICACOES PELO PODER PUBLICO, NO EXERCICIO REGULAR DO PODER DE POLICIA. TAXAS DEVIDAS PELAS CONCESSIONARIAS E PERMISSIONARIAS DE SERVICOS DE TELECOMUNICACOES, COMPREENDENDO: A TAXA DE FISCALIZACAO DE INSTALACAO, DEVIDA NO MOMENTO EM QUE E OUTORGADA AUTORIZACAO PARA A EXECUCAO DO SERVICO E A TAXA DE FISCALIZACAO DO FUNCIONAMENTO, DEVIDA PELA FISCALIZACAO DA EXECUCAO DOS SERVICOS. RECEITA VINCULADA AO FUNDO DE FISCALIZACAO DAS TELECOMUNICACOES - FISTEL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.04.00', 'TAXAS DO DEPARTAMENTO DE POLICIA FEDERAL', 'REGISTRA A VPA COM TAXAS DO DEPARTAMENTO DE POLICIA FEDERAL, AUFERIDA PELA PRESTACAO DE SERVICOS RELATIVOS A FISCALIZACAO DE EMPRESAS DE SEGURANCAO PRIVADA, SEGURANCA PROPRIA, DE TRANSPORTE DE VALORES, DE ESTABELECIMENTOS FINANCEIROS E DE ESTABELECIMENTOS DE FORMACAO DE VIGILANTES. OS VALORES ARRECADADOS DESTINAM-SE AO CUSTEIO E MANUTENCAO DE ATIVIDADES-FIM DO DEPARTAMENTO DE POLICIA FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.5.13.00', 'TAXA DE SAUDE SUPLEMENTAR', 'COMPREENDE A VPA PROVENIENTE DA TAXA DE SAUDE SUPLEMENTAR, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO, QUE OPEREM O PRODUTO, SERVICOS OU CONTRATO DE COM A FINALIDADE DE GARANTIR A ASSISTENCIA A SAUDE VISANDO A ASSISTENCIA MEDICA HOSPITALAR OU ODONTOLOGICA. OS RE- CURSOS SERAO VINCULADOS A AGENCIA NACIONAL DE SAUDE - ANS (LEI 9961 DE 28/01/2000).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.0.00.00', 'TAXAS PELA PRESTACAO DE SERVICOS', 'COMPREENDE AS TAXAS COBRADAS PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES, TEM COMO FATO GERADOR A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.00.00', 'TAXAS PELA PRESTACAO DE SERVICOS - CONSOLIDACAO', 'COMPREENDE AS TAXAS COBRADAS PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES TEM COMO FATO GERADOR A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.2.00.00', 'TAXAS PELA PRESTACAO DE SERVICOS - INTRA OFSS', 'COMPREENDE AS TAXAS COBRADAS PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES TEM COMO FATO GERADOR A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.4.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.00.00', 'TAXAS PELA PRESTACAO DE SERVICOS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS TAXAS COBRADAS PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES TEM COMO FATO GERADOR A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.5.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.0.0.00.00', 'CONTRIBUICOES DE MELHORIA', 'COMPREENDE O TRIBUTO COBRADO PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES, SENDO INSTITUIDA PARA FAZER FACE AO CUSTO DE OBRAS PUBLICAS DE QUE DECORRA VALORIZACAO IMOBILIARIA, TENDO COMO LIMITE TOTAL A DESPESA REALIZADA E COMO LIMITE INDIVIDUAL O ACRESCIMO DE VALOR QUE DA OBRA RESULTAR PARA CADA IMOVEL BENEFICIADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.1.0.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE AGUA POTAVEL E ESGOTO SANITARIO', 'COMPREENDE O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE AGUA POTAVEL E ESGOTO SANITARIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.2.0.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE', 'COMPREENDE O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.3.0.00.00', 'CONTRIBUICAO DE MELHORIA PELA EXPANSAO DE REDE DE ILUMINACAO PUBLICA RURAL', 'COMPREENDE O VALOR DA ARRECADACAO DE RECEITA SOBRE A COBRANCA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA RURAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.4.0.00.00', 'CONTRIBUICAO DE MELHORIA PELA PAVIMENTACAO E OBRAS COMPLEMENTARES', 'COMPREENDE O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA PAVIMENTACAO ASFALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.0.0.0.00.00', 'CONTRIBUICOES', 'COMPREENDE TODA PRESTACAO PECUNIARIA COMPULSORIA, EM MOEDA OU CUJO VALOR NELA SE POSSA EXPRIMIR, QUE NAO CONSTITUA SANCAO DE ATO ILICITO, INSTITUIDA EM LEI E COBRADA MEDIANTE ATIVIDADE ADMINISTRATIVA PLENAMENTE VINCULADA. COMO : CONTRIBUICOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.0.0.00.00', 'CONTRIBUICOES SOCIAIS', 'COMPREENDEM COMO CONTRIBUICOES SOCIAIS: A) AS DAS EMPRESAS, INCIDENTES SOBRE A REMUNERACAO PAGA OU CREDITADA AOS SEGURADOS A SEU SERVICO; B) AS DOS EMPREGADORES DOMESTICOS; C) AS DOS TRABALHADORES, INCIDENTES SOBRE O SEU SALARIO-DE-CONTRIBUICAO; D) AS SOBRE A RECEITA E FATURAMENTO; E) AS SOBRE O LUCRO; F ) DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR G) E OUTROS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.0.00.00', 'CONTRIBUICOES SOCIAIS - RPPS', 'COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.00.00', 'CONTRIBUICOES SOCIAIS - RPPS -CONSOLIDACAO', 'COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.01.00', 'CONTRIBUICOES PATRONAIS AO RPPS', 'COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.02.00', 'CONTRIBUICAO DO SEGURADO AO RPPS', 'COMPREENDE A CONTRIBUICAO AO RPPS DOS SEGURADOS SERVIDOR ATIVO, SERVIDOR INATIVO E PENSIONISTA SOBRE A SUA REMUNERACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.00.00', 'CONTRIBUICOES SOCIAIS - RPPS - INTRA OFSS', 'COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.01.00', 'CONTRIBUICOES PATRONAIS AO RPPS', 'COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.00.00', 'CONTRIBUICOES SOCIAIS - RPPS - INTER OFSS - ESTADO', 'COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.01.00', 'CONTRIBUICOES PATRONAIS AO RPPS', 'COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.00.00', 'CONTRIBUICOES SOCIAIS - RPPS - INTER OFSS - MUNICIPIO', 'COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.01.00', 'CONTRIBUICOES PATRONAIS AO RPPS', 'COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.0.00.00', 'CONTRIBUICOES SOCIAIS - RGPS', 'COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.00.00', 'CONTRIBUICOES SOCIAIS - RGPS -CONSOLIDACAO', 'COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DEST. AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.01.00', 'CONTRIBUICOES PATRONAIS E DA EMPRESA AO RGPS', 'COMPREENDE A VPA DECORRENTE DAS CONTRIBUICOES PATRONAIS, DAS EMPRESAS E EQUIPADAS PARA O REGIME GERAL DA PREVIDENCIA SOCIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.02.00', 'CONTRIBUICOES DO SEGURADO AO RGPS', 'COMPREENDE AS CONTRIBUICOES DOS SEGURADOS AO RGPS INCIDENTES SOBRE O SALARIO DE CONTRIBUICAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.00.00', 'CONTRIBUICOES SOCIAIS - RGPS - INTRA OFSS', 'COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.01.00', 'CONTRIBUICOES PATRONAIS E DA EMPRESA AO RGPS', 'COMPREENDE A VPA DECORRENTE DAS CONTRIBUICOES PATRONAIS, DAS EMPRESAS E EQUIPADAS PARA O REGIME GERAL DA PREVIDENCIA SOCIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.00.00', 'CONTRIBUICOES SOCIAIS - RGPS - INTER OFSS - ESTADO', 'COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.01.00', 'CONTRIBUICOES PATRONAIS E DA EMPRESA AO RGPS', 'COMPREENDE A VPA DECORRENTE DAS CONTRIBUICOES PATRONAIS, DAS EMPRESAS E EQUIPADAS PARA O REGIME GERAL DA PREVIDENCIA SOCIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.00.00', 'CONTRIBUICOES SOCIAIS - RGPS - INTER OFSS - MUNICIPIO', 'COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.0.00.00', 'CONTRIBUICAO SOBRE A RECEITA OU O FATURAMENTO', 'COMPREENDE A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE A RECEITA OU O FATURAMENTO, COMO POR EXEMPLO: COFINS, PIS/PASEP.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.1.00.00', 'CONTRIBUICAO SOBRE A RECEITA OU O FATURAMENTO - CONSOLIDACAO', 'COMPREENDE A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQ UIPARADA NA FORMA DA LEI, INCIDENTES SOBRE A RECEITA OU O FATURAMENTO, COMO POR EXEMPLO: COFINS, PIS/PASEP. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.2.00.00', 'CONTRIBUICAO SOBRE A RECEITA OU O FATURAMENTO - INTRA OFSS', 'COMPREENDE A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQ UIPARADA NA FORMA DA LEI, INCIDENTES SOBRE A RECEITA OU O FATURAMENTO, COMO POR EXEMPLO: COFINS, PIS/PASEP. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.4.00.00', 'CONTRIBUICAO SOBRE A RECEITA OU O FATURAMENTO - INTER OFSS - ESTADO', 'COMPREENDE A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE A RECEITA OU O FATURAMENTO,COMO POR EXEMPLO: COFINS, PIS/PASEP. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.4.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.5.00.00', 'CONTRIBUICAO SOBRE A RECEITA OU O FATURAMENTO - INTER OFSS - MUNICIPIO', 'COMPREENDE A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE A RECEITA OU O FATURAMENTO,COMO POR EXEMPLO: COFINS, PIS/PASEP. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.5.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.0.00.00', 'CONTRIBUICAO SOBRE O LUCRO', 'COMPREENDE A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: CSLL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.1.00.00', 'CONTRIBUICAO SOBRE O LUCRO - CONSOLIDACAO', 'REGISTRA A CONTRIBUICAO DO EMPREGADOR,DA EMPRESA E DA ENTIDADE A ELA EQU IPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: CSLL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.1.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.2.00.00', 'CONTRIBUICAO SOBRE O LUCRO - INTRA OFSS', 'REGISTRA A CONTRIBUICAO DO EMPREGADOR,DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: CSLL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.2.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.4.00.00', 'CONTRIBUICAO SOBRE O LUCRO - INTER OFSS - ESTADO', 'REGISTRA A CONTRIBUICAO DO EMPREGADOR,DA EMPRESA E DA ENTIDADE A ELA EQU IPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: CSLL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.5.00.00', 'CONTRIBUICAO SOBRE O LUCRO - INTER OFSS - MUNICIPIO', 'REGISTRA A CONTRIBUICAO DO EMPREGADOR,DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: CSLL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.1.00.00', 'CONTRIBUICAO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO - CONSOLIDACAO', 'COMPREENDE A CONTRIBUICAO SOBRE A RECEITA DE CONCURSOS DE PROGNOSTICOS,QUE SAO TODOS E QUAISQUER CONCURSOS DE SORTEIOS DE NUMEROS,LOTERIAIS, APOSTAS, INCLUSIVE AS REALIZADAS EM REUNIOES HIPICAS, NOS AMBITOS FEDERAL, ESTADUAL, DO DISTRITO FEDERAL E MUNICIPAIS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.1.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.0.00.00', 'CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR', 'COMPREENDE A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.1.00.00', 'CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR - CONSOLIDACAO', 'REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.1.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.2.00.00', 'CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR - INTRA OFSS', 'REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.2.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.5.00.00', 'CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR - INTER OFSS - MUNICIPIO', 'REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.5.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.0.00.00', 'OUTRAS CONTRIBUICOES SOCIAIS', 'COMPREENDE O VALOR DE OUTRAS CONTRIBUICOES SOCIAIS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.1.00.00', 'OUTRAS CONTRIBUICOES SOCIAIS - CONSOLIDACAO', 'COMPREENDE O VALOR DE OUTRAS CONTRIBUICOES SOCIAIS,NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.2.00.00', 'OUTRAS CONTRIBUICOES SOCIAIS - INTRA OFSS', 'COMPREENDE O VALOR DE OUTRAS CONTRIBUICOES SOCIAIS,NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.2.06.00', 'CONTRIBUICOES RURAIS', 'COMPREENDE A VPA PROVENIENTE DE CONTRIBUICOES RURAIS, TAIS COMO A INDUSTRIAL, CONTRIBUICAO SOBRE A PROPRIEDADE RURAL, O ADICIONA DA CONTRIBUICAO PREVIDENCIARIA E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.2.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.4.00.00', 'OUTRAS CONTRIBUICOES SOCIAIS - INTER OFSS - ESTADO', 'COMPREENDE O VALOR DE OUTRAS CONTRIBUICOES SOCIAIS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.4.06.00', 'CONTRIBUICOES RURAIS', 'COMPREENDE A VPA PROVENIENTE DE CONTRIBUICOES RURAIS, TAIS COMO A INDUSTRIAL, CONTRIBUICAO SOBRE A PROPRIEDADE RURAL, O ADICIONA DA CONTRIBUICAO PREVIDENCIARIA E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.5.00.00', 'OUTRAS CONTRIBUICOES SOCIAIS - INTER OFSS - MUNICIPIO', 'COMPREENDE O VALOR DE OUTRAS CONTRIBUICOES SOCIAIS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.5.06.00', 'CONTRIBUICOES RURAIS', 'COMPREENDE A VPA PROVENIENTE DE CONTRIBUICOES RURAIS, TAIS COMO A INDUSTRIAL, CONTRIBUICAO SOBRE A PROPRIEDADE RURAL, O ADICIONA DA CONTRIBUICAO PREVIDENCIARIA E OUTRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.5.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS TAIS COMO RENUNCIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.0.00.00', 'CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO', 'COMPREENDEM AS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO, COMO POR EXEMPLO, A CIDE-COMBUSTIVEL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.03.00', 'CONTRIBUICOES DESENV.APERF.ATIVID.FISCALIZ.', 'COMPREENDE A VPA PROVENIENTE DAS CONTRIBUICOES DESTINADAS AODESENVOLVIMENTO E APERFEICOAMENTO DE ATIVIDADES DE FISCALIZACAO. DES-TINAM-SE A FORNECER RECURSOS PARA FINANCIAR O REAPARELHAMENTO E O REE-QUIPAMENTO DA SECRETARIA DA RECEITA FEDERAL - SRF, E A ATENDER AOS DE-MAIS ENCARGOS ESPECIFICOS INERENTES AO DESENVOLVIMENTO E APERFEICOA-MENTO DAS ATIVIDADES DE FISCALIZACAO DOS TRIBUTOS FEDERAIS. VINCULADASAO FUNDO DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCA-LIZACAO - FUNDAF.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.05.00', 'CONTRIB.P/DESENV.DA IND.CINEMATOGRAF.NACIONAL', 'COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO PARA O DESENVOL-VIMENTO DA INDUSTRIA CINEMATOGRAFICA NACIONAL. CONTRIBUICAO DEVIDA PE-LOS PRODUTORES OU DISTRIBUIDORES DE FILMES, OU POR QUEM, A QUALQUERTITULO, PROMOVER A IMPORTACAO DE FILMES, E SERA CALCULADA, POR TITULODE FILME, SEGUNDO A IMPORTANCIA A SER CALCULADA PELO PODER EXECUTIVO.OS RECURSOS DEVEM SER APLICADOS PELO MINISTERIO DA CULTURA E PELAS EN-TIDADES A ELA VINCULADAS, EM PROGRAMAS RELATIVOS A ATIVIDADE AUDIOVI-SUAL NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.10.00', 'CONTRIB. REC. EMPR. PREST. SERV. TELECOMUNIC.', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE A RECEITA DAS EMPRESAS PRESTADORAS DE SERVICOS DE TELECOMUNICACOES REFERENTES A UM POR CENTO SOBRE A RECEITA OPERACIONAL BRUTA, DECORRENTE DE PRESTACAO DE SERVICOS DE TELECOMUNICACOES, EXCLUINDO-SE O ICMS, O PIS, E O COFINS. OS RECURSOS DO FUST SERAO APLICADOS EM PROGRAMAS, PROJETOS E ATIVIDADES QUE ESTEJAM EM CONSONANCIA COM O PLANO GERAL DE METAS PARA UNIVERSALIZACAO DE SERVICO DE TELECOMUNICACOES OU SUAS AMPLIACOES. LEI 9998, DE 17/08/2000.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.11.00', 'CONTRIB. S/ FATURAMENTO EMPRESAS INFORMATICA', 'COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA, CORRESPONDENTE A 0,5 DOS RECURSOS RESULTANTES DA OBRIGACAO DAS EMPRESAS DE DESENVOLVIMENTO OUPRODUCAO DE BENS E SERVICOS DE INFORMATICA E AUTOMACAO, INVESTIREM NO MINIMO 5 DO SEU FATURAMENTO BRUTO EM P & D PARA FAZER JUS A REDUCAO DE 95 DO IMPOSTO DEVIDO SOBRE PRODUTOS INDUSTRIALIZADOS - IPI. PL N 2514/96', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.12.00', 'CONT.REL.AT.IMP.COM.PETR.DER.GAS NAT.ALC.CARB', 'COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO E COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.14.00', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA', 'COMPREENDE A CONTRIBUICAO QUE TEM COMO FATO GERADOR A VENDA DE BENS E SERVICOS DE INFORMATICA PELAS EMPRESAS, QUE INDUSTRIALIZAM BENS DE INFORMATICA NA ZONA FRANCA DE MANUAUS, QUE OPTAREM POR INVESTIR EM PESQUISA E DESENVOLVIMENTO A SEREM REALIZADAS NA AMAZONIA. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.15.00', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES', 'COMPREENDE A CONTRIBUICAO QUE TEM COMO FATO GERADOR A VENDA DE BENS E SERVICOS DE INFORMATICA PELAS EMPRESAS, QUE INDUSTRIALIZAM BENS DE INFORMATICA NAS DEMAIS REGIOES DO PAIS ( COM EXCECAO DA ZONA FRANCA DE MANAUS), QUE OPTAREM POR INVESTIR EM PESQUISA E DESENVOLVIMENTO A SEREM REALIZADAS EM DIVERSAS REGIOES. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.00.00', 'CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO - INTRA OFSS', 'COMPREENDEM AS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO, COMO POR EXEMPLO, A CIDE-COMBUSTIVEL . COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.05.00', 'CONTRIB.P/DESENV.DA IND.CINEMATOGRAF.NACIONAL', 'COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO PARA O DESENVOL-VIMENTO DA INDUSTRIA CINEMATOGRAFICA NACIONAL. CONTRIBUICAO DEVIDA PE-LOS PRODUTORES OU DISTRIBUIDORES DE FILMES, OU POR QUEM, A QUALQUERTITULO, PROMOVER A IMPORTACAO DE FILMES, E SERA CALCULADA, POR TITULODE FILME, SEGUNDO A IMPORTANCIA A SER CALCULADA PELO PODER EXECUTIVO.OS RECURSOS DEVEM SER APLICADOS PELO MINISTERIO DA CULTURA E PELAS EN-TIDADES A ELA VINCULADAS, EM PROGRAMAS RELATIVOS A ATIVIDADE AUDIOVI-SUAL NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.10.00', 'CONTRIB. REC. EMPR. PREST. SERV. TELECOMUNIC.', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE A RECEITA DAS EMPRESAS PRESTADORAS DE SERVICOS DE TELECOMUNICACOES REFERENTES A UM POR CENTO SOBRE A RECEITA OPERACIONAL BRUTA, DECORRENTE DE PRESTACAO DE SERVICOS DE TELECOMUNICACOES, EXCLUINDO-SE O ICMS, O PIS, E O COFINS. OS RECURSOS DO FUST SERAO APLICADOS EM PROGRAMAS, PROJETOS E ATIVIDADES QUE ESTEJAM EM CONSONANCIA COM O PLANO GERAL DE METAS PARA UNIVERSALIZACAO DE SERVICO DE TELECOMUNICACOES OU SUAS AMPLIACOES. LEI 9998, DE 17/08/2000.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.11.00', 'CONTRIB. S/ FATURAMENTO EMPRESAS INFORMATICA', 'COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA, CORRESPONDENTE A 0,5 DOS RECURSOS RESULTANTES DA OBRIGACAO DAS EMPRESAS DE DESENVOLVIMENTO OUPRODUCAO DE BENS E SERVICOS DE INFORMATICA E AUTOMACAO, INVESTIREM NO MINIMO 5 DO SEU FATURAMENTO BRUTO EM P & D PARA FAZER JUS A REDUCAO DE 95 DO IMPOSTO DEVIDO SOBRE PRODUTOS INDUSTRIALIZADOS - IPI. PL N 2514/96', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.12.00', 'CONT.REL.AT.IMP.COM.PETR.DER.GAS NAT.ALC.CARB', 'COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO E COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.14.00', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA', 'COMPREENDE A CONTRIBUICAO QUE TEM COMO FATO GERADOR A VENDA DE BENS E SERVICOS DE INFORMATICA PELAS EMPRESAS, QUE INDUSTRIALIZAM BENS DE INFORMATICA NA ZONA FRANCA DE MANUAUS, QUE OPTAREM POR INVESTIR EM PESQUISA E DESENVOLVIMENTO A SEREM REALIZADAS NA AMAZONIA. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.15.00', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES', 'COMPREENDE A CONTRIBUICAO QUE TEM COMO FATO GERADOR A VENDA DE BENS E SERVICOS DE INFORMATICA PELAS EMPRESAS, QUE INDUSTRIALIZAM BENS DE INFORMATICA NAS DEMAIS REGIOES DO PAIS ( COM EXCECAO DA ZONA FRANCA DE MANAUS), QUE OPTAREM POR INVESTIR EM PESQUISA E DESENVOLVIMENTO A SEREM REALIZADAS EM DIVERSAS REGIOES. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.2.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.00.00', 'CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO - INTER OFSS - ESTADO', 'COMPREENDEM AS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO, COMO POR EXEMPLO, A CIDE-COMBUSTIVEL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.05.00', 'CONTRIB.P/DESENV.DA IND.CINEMATOGRAF.NACIONAL', 'COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO PARA O DESENVOLVIMENTO DA INDUSTRIA CINEMATOGRAFICA NACIONAL. CONTRIBUICAO DEVIDA PELOS PRODUTORES OU DISTRIBUIDORES DE FILMES, OU POR QUEM, A QUALQUER TITULO, PROMOVER A IMPORTACAO DE FILMES, E SERA CALCULADA, POR TITULODE FILME, SEGUNDO A IMPORTANCIA A SER CALCULADA PELO PODER EXECUTIVO.OS RECURSOS DEVEM SER APLICADOS PELO MINISTERIO DA CULTURA E PELAS ENTIDADES A ELA VINCULADAS, EM PROGRAMAS RELATIVOS A ATIVIDADE AUDIOVISUAL NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.10.00', 'CONTRIB. REC. EMPR. PREST. SERV. TELECOMUNIC.', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE A RECEITA DAS EMPRESAS PRESTADORAS DE SERVICOS DE TELECOMUNICACOES REFERENTES A UM POR CENTO SOBRE A RECEITA OPERACIONAL BRUTA, DECORRENTE DE PRESTACAO DE SERVICOS DE TELECOMUNICACOES, EXCLUINDO-SE O ICMS, O PIS, E O COFINS. OS RECURSOS DO FUST SERAO APLICADOS EM PROGRAMAS, PROJETOS E ATIVIDADES QUE ESTEJAM EM CONSONANCIA COM O PLANO GERAL DE METAS PARA UNIVERSALIZACAO DE SERVICO DE TELECOMUNICACOES OU SUAS AMPLIACOES. LEI 9998, DE 17/08/2000.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.11.00', 'CONTRIB. S/ FATURAMENTO EMPRESAS INFORMATICA', 'COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA, CORRESPONDENTE A 0,5 DOS RECURSOS RESULTANTES DA OBRIGACAO DAS EMPRESAS DE DESENVOLVIMENTO OUPRODUCAO DE BENS E SERVICOS DE INFORMATICA E AUTOMACAO, INVESTIREM NO MINIMO 5 DO SEU FATURAMENTO BRUTO EM P & D PARA FAZER JUS A REDUCAO DE 95 DO IMPOSTO DEVIDO SOBRE PRODUTOS INDUSTRIALIZADOS - IPI. PL N 2514/96', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.14.00', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA', 'COMPREENDE A CONTRIBUICAO QUE TEM COMO FATO GERADOR A VENDA DE BENS E SERVICOS DE INFORMATICA PELAS EMPRESAS, QUE INDUSTRIALIZAM BENS DE INFORMATICA NA ZONA FRANCA DE MANUAUS, QUE OPTAREM POR INVESTIR EM PESQUISA E DESENVOLVIMENTO A SEREM REALIZADAS NA AMAZONIA. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.15.00', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES', 'COMPREENDE A CONTRIBUICAO QUE TEM COMO FATO GERADOR A VENDA DE BENS E SERVICOS DE INFORMATICA PELAS EMPRESAS, QUE INDUSTRIALIZAM BENS DE INFORMATICA NAS DEMAIS REGIOES DO PAIS ( COM EXCECAO DA ZONA FRANCA DE MANAUS), QUE OPTAREM POR INVESTIR EM PESQUISA E DESENVOLVIMENTO A SEREM REALIZADAS EM DIVERSAS REGIOES. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.4.97.00', '(-) DEDUCOES', 'COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.00.00', 'CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO - INTER OFSS - MUNICIPIO', 'COMPREENDEM AS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO, COMO POR EXEMPLO, A CIDE-COMBUSTIVEL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.05.00', 'CONTRIB.P/DESENV.DA IND.CINEMATOGRAF.NACIONAL', 'COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO PARA O DESENVOLVIMENTO DA INDUSTRIA CINEMATOGRAFICA NACIONAL. CONTRIBUICAO DEVIDA PELOS PRODUTORES OU DISTRIBUIDORES DE FILMES, OU POR QUEM, A QUALQUER TITULO, PROMOVER A IMPORTACAO DE FILMES, E SERA CALCULADA, POR TITULODE FILME, SEGUNDO A IMPORTANCIA A SER CALCULADA PELO PODER EXECUTIVO.OS RECURSOS DEVEM SER APLICADOS PELO MINISTERIO DA CULTURA E PELAS ENTIDADES A ELA VINCULADAS, EM PROGRAMAS RELATIVOS A ATIVIDADE AUDIOVISUAL NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.10.00', 'CONTRIB. REC. EMPR. PREST. SERV. TELECOMUNIC.', 'REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE A RECEITA DAS EMPRESAS PRESTADORAS DE SERVICOS DE TELECOMUNICACOES REFERENTES A UM POR CENTO SOBRE A RECEITA OPERACIONAL BRUTA, DECORRENTE DE PRESTACAO DE SERVICOS DE TELECOMUNICACOES, EXCLUINDO-SE O ICMS, O PIS, E O COFINS. OS RECURSOS DO FUST SERAO APLICADOS EM PROGRAMAS, PROJETOS E ATIVIDADES QUE ESTEJAM EM CONSONANCIA COM O PLANO GERAL DE METAS PARA UNIVERSALIZACAO DE SERVICO DE TELECOMUNICACOES OU SUAS AMPLIACOES. LEI 9998, DE 17/08/2000.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.11.00', 'CONTRIB. S/ FATURAMENTO EMPRESAS INFORMATICA', 'COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA, CORRESPONDENTE A 0,5 DOS RECURSOS RESULTANTES DA OBRIGACAO DAS EMPRESAS DE DESENVOLVIMENTO OUPRODUCAO DE BENS E SERVICOS DE INFORMATICA E AUTOMACAO, INVESTIREM NO MINIMO 5 DO SEU FATURAMENTO BRUTO EM P & D PARA FAZER JUS A REDUCAO DE 95 DO IMPOSTO DEVIDO SOBRE PRODUTOS INDUSTRIALIZADOS - IPI. PL N 2514/96', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.12.00', 'CONT.REL.AT.IMP.COM.PETR.DER.GAS NAT.ALC.CARB', 'COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO E COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.14.00', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA', 'COMPREENDE A CONTRIBUICAO QUE TEM COMO FATO GERADOR A VENDA DE BENS E SERVICOS DE INFORMATICA PELAS EMPRESAS, QUE INDUSTRIALIZAM BENS DE INFORMATICA NA ZONA FRANCA DE MANUAUS, QUE OPTAREM POR INVESTIR EM PESQUISA E DESENVOLVIMENTO A SEREM REALIZADAS NA AMAZONIA. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.5.15.00', 'CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES', 'COMPREENDE A CONTRIBUICAO QUE TEM COMO FATO GERADOR A VENDA DE BENS E SERVICOS DE INFORMATICA PELAS EMPRESAS, QUE INDUSTRIALIZAM BENS DE INFORMATICA NAS DEMAIS REGIOES DO PAIS ( COM EXCECAO DA ZONA FRANCA DE MANAUS), QUE OPTAREM POR INVESTIR EM PESQUISA E DESENVOLVIMENTO A SEREM REALIZADAS EM DIVERSAS REGIOES. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.4.0.0.00.00', 'CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.0.0.0.00.00', 'EXPLORACAO E VENDA DE BENS, SERVICOS E DIREITOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A EXPLORACAO DE BENS E SERVICOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO, SEGREGANDO-SE A VENDA BRUTA DAS DEDUCOES COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.0.0.00.00', 'VENDA DE MERCADORIAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, SEGREGANDO-SE A VENDA BRUTA DAS DEDUCOES COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.0.00.00', 'VENDA BRUTA DE MERCADORIAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.00.00', 'VENDA BRUTA DE MERCADORIAS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.2.00.00', 'VENDA BRUTA DE MERCADORIAS - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS,QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.4.00.00', 'VENDA BRUTA DE MERCADORIAS - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS,QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.5.00.00', 'VENDA BRUTA DE MERCADORIAS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE MERCADORIAS,QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.0.00.00', '(-) DEDUCOES DA VENDA BRUTA DE MERCADORIAS', 'COMPREENDE AS DEDUCOES DAS VENDAS DE MERCADORIAS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.00.00', '(-) DEDUCOES DA VENDA BRUTA DE MERCADORIAS - CONSOLIDACAO', 'COMPREENDE AS DEDUCOES DAS VENDAS DE MERCADORIAS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.2.00.00', '(-) DEDUCOES DA VENDA BRUTA DE MERCADORIAS - INTRA OFSS', 'COMPREENDE AS DEDUCOES DAS VENDAS DE MERCADORIAS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.4.00.00', '(-) DEDUCOES DA VENDA BRUTA DE MERCADORIAS - INTER OFSS - ESTADO', 'REGISTRA O VALOR DE OUTRAS CONTRIBUICOES DE MELHORIAS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.5.00.00', '(-) DEDUCOES DA VENDA BRUTA DE MERCADORIAS - INTER OFSS - MUNICIPIO', 'REGISTRA O VALOR DE OUTRAS CONTRIBUICOES DE MELHORIAS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.0.0.00.00', 'VENDA DE PRODUTOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA DE PRODUTOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, SEGREGANDO-SE A VENDA BRUTA DAS DEDUCOES COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.0.00.00', 'VENDA BRUTA DE PRODUTOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE PRODUTOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.00.00', 'VENDA BRUTA DE PRODUTOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE PRODUTOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.14.00', 'VENDA DE PRODUTOS DA INDUSTRIA DE TRANSFORMACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES LIGADAS A INDUSTRIA DE TRANSFORMACAO, BASEADAS NA CLASSIFICACAO DA FUNDACAO IBGE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.00.00', 'VENDA BRUTA DE PRODUTOS - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE PRODUTOS,QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.2.14.00', 'VENDA DE PRODUTOS DA INDUSTRIA DE TRANSFORMACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES LIGADAS A INDUSTRIA DE TRANSFORMACAO, BASEADAS NA CLASSIFICACAO DA FUNDACAO IBGE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.4.14.00', 'VENDA DE PRODUTOS DA INDUSTRIA DE TRANSFORMACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES LIGADAS A INDUSTRIA DE TRANSFORMACAO, BASEADAS NA CLASSIFICACAO DA FUNDACAO IBGE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.00.00', 'VENDA BRUTA DE PRODUTOS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A VENDA BRUTA DE PRODUTOS,QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.5.14.00', 'VENDA DE PRODUTOS DA INDUSTRIA DE TRANSFORMACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES LIGADAS A INDUSTRIA DE TRANSFORMACAO, BASEADAS NA CLASSIFICACAO DA FUNDACAO IBGE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.0.00.00', '(-) DEDUCOES DE VENDA BRUTA DE PRODUTOS', 'COMPREENDE AS DEDUCOES DAS VENDAS DE PRODUTOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.00.00', '(-) DEDUCOES DA VENDA BRUTA DE PRODUTOS - CONSOLIDACAO', 'COMPREENDE AS DEDUCOES DAS VENDAS DE PRODUTOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.2.00.00', '(-) DEDUCOES DA VENDA BRUTA DE PRODUTOS - INTRA OFSS', 'COMPREENDE AS DEDUCOES DAS VENDAS DE PRODUTOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.4.00.00', '(-) DEDUCOES DA VENDA BRUTA DE PRODUTOS - INTER OFSS - ESTADO', 'COMPREENDE AS DEDUCOES DAS VENDAS DE PRODUTOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.5.00.00', '(-) DEDUCOES DA VENDA BRUTA DE PRODUTOS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS DEDUCOES DAS VENDAS DE PRODUTOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.0.0.00.00', 'EXPLORACAO DE BENS E DIREITOS E PRESTACAO DE SERVICOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A PRESTACAO DE SERVICOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, SEGREGANDO-SE A VENDA BRUTA DAS DEDUCOES COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.0.00.00', 'VALOR BRUTO DE EXPLORACAO DE BENS E DIREITOS E PRESTACAO DE SERVICOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A PRESTACAO DE SERVICOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.00.00', 'VALOR BRUTO DE EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A PRESTACAO DE SERVICOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.08.00', 'SERVICOS CONSULT.ASSIST.TEC. ANALISE PROJETOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS PRESTADOS. VPA PROPORCIONADA POR CONSULTORIAS TECNICO-FINANCEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO,PERICIAS CONTABEIS, ANALISE DE PROJETOS, ETC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.09.00', 'PRESTACAO DE SERVICOS RELACIONADOS A T.I', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.15.00', 'SERVICOS DE COMUNICACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMUNICACAO, CONFORME DESCRICAO ABAIXO: A) SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; B) SERVICO DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS; C) SERVICO DE RADIODIFUSAO E DE AGENCIAMENTO DE PUBLICIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.16.00', 'PRESTACAO DE SERVICOS RELACIONADOS A ARMAZENAGEM', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ARMAZENAGEM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.18.00', 'PRESTACAO DE SERVICOS RELACIONADOS AO BENEFICIAMENTO DE GRAOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE BENEFICIAMENTO DE GRAOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.24.00', 'CONCESSAO E PERMISSAO - SERV. DE TRANSPORT', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.25.00', 'CONCESSAO E PERMISSAO - SERV. DE COMUNIC.', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE COMUNICACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.26.00', 'OUTORGA SERV. EXPL. PROD PETR. GAS NATURA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO, DESENVOLVIMENTO E PRODUCAO DE PETROLEO E GAS NATURAL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.29.00', 'CONCESSAO FLORESTAL', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO E GESTAO DE DIREITOS DE USO DE FLORESTAS PUBLICAS, RECURSOS FLORESTAIS, PRODUTOS E SERVICOS DELAS DECORRENTES, PARA PRODUCAO SUSTENTAVEL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO, A PARTICULARES QUE ESTEJAM EM CONDICOES DE ATENDER AS EXIGENCIAS DO RESPECTIVO EDITAL DE LICITACAO E QUE DEMONSTREM CAPACIDADE PARA SEU DESEMPENHO, POR SUA CONTA E RISCO E PRAZO DETERMINADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.30.00', 'CONCESSAO E PERMISSAO. - DIR. USO DE BENS PUB', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.00', 'COMPENSACOES FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DOS RECURSOS DECORRENTES DO ARTIGO 20, PARAGRAFO 1º DA CONSTITUICAO FEDERAL, O QUAL DISPOE: "E ASSEGURADA, NOS TERMOS DA LEI, AOS ESTADOS, AO DISTRI-TO FEDERAL E AOS MUNICIPIOS, BEM COMO AOS ORGAOS DA ADMINISTRACAO DIRETA DA UNIAO, PARTICIPACAO NO RESULTADO DA EXPLORACAO DE PETROLEO OU GAS NATURAL, DE RECURSOS HIDRICOS PARA FINS DE GERACAO DE ENERGIA ELETRICA E DE OUTROS RECURSOS MINERAIS NO RESPECTIVO TERRITORIO, PLATAFORMA CONTINENTAL, MAR TERRITORIAL OU ZONA ECONOMIA EXCLUSIVA, OU COMPENSACAO FINANCEIRA POR ESSA EXPLORACAO".', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.32.00', 'SERVICOS DE TRANSPORTE', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE TRANSPORTE RODOVIARIO, FERROVIARIO, HIDROVIARIO, AEREO, ESPECIAIS E TARIFA DE PEDAGIO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.35.00', 'SERVICOS DE SAUDE', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE SAUDE: HOSPITALARES GERAIS OU ESPECIALIZADOS, MATERNIDADE, CENTRO DE REABILITACAO, ASSISTENCIA MEDICO-ODONTOLOGICA (INCLUSIVE AMBULATORIAL), SAUDE PUBLICA, ETC...', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.37.00', 'SERVICOS DE METROLOGIA E CERTIFICACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA E CERTIFICACAO PRESTADOS.VPA DE SERVICOS METROLOGICOS EM GERAL, TAIS COMO AFERICAO DE MEDIDAS E INSTRUMENTOS DE MEDIR, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC..', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.45.00', 'SERVICOS REG. MARCAS,PAT.TRANSF.DE TECNOLOGIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE MARCAS, PATENTES E TRANSFERENCIA DE TECNOLOGIAS. VPA CORRESPONDENTE AOS SERVICOS PREVISTOS NO CODIGO DA PROPRIEDADE INDUSTRIAL, PETICOES GERAIS, PEDIDOS E PETICOS RELATI-VAS A PRIVILEGIOS, PEDIDOS E PETICOES RELATIVAS A MARCAS E PATENTES,PEDIDOS E PETICOES RELATIVOS A CONTRATOS DE TRANSFERENCIA DE TECNOLOGIA E CORRELATOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.52.00', 'TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA E ADICIONAL COBRADOS POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTI-LIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA). VPA VINCULADA AO MINISTERIO DA AERONAUTICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.54.00', 'TARIFAS USO COMUN.AUX.A NAVEG.AEREA EM ROTA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE USO DAS COMUNICACOES E DOS AUXILIOS AA NAVEGACAO AEREA EM ROTA. VPA PROVENIENTE DE TARIFAS COBRADAS PELA UTILIZACAO DOS SERVICOS DE INFORMACOES AERONAUTICAS, TRAFEGO AEREO, METEOROLOGIA, AUXILIOS A NAVEGACAO AEREA, FACILIDADES DE COMUNICACOES, E OUTROS SERVICOS AUXILIARES DE PROTECAO AO VOO, PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA E POR EMPRESA ESPECIALIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. ESSAS TARIFAS SAO FORMADAS: - PELA TARIFA DE USO DAS COMUNICACOES E DOS AUXILIOS A NAVEGACAO AEREA(TAN); - PELA TARIFA DE USO DAS COMUNICACOES E DOS AUXILIOS DE RADIO E VISU-AIS EM AREA DE TERMINAL AEREO (TAT).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.62.00', 'SERV.INOV.A.PESQ.AMBIENT.PROD.-INST.CIEN.TEC.', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS VOLTADOS A INOVACAO E AA PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.64.00', 'SERVICO DE EMISSAO DE CERTIFICADOS DE ORIGEM E DE EMISSAO DE LICENCA DE EXPORTACAO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE CERTIFICADOS DE ORIGEM E DE EMISSAO DE LICENCA DE EXPORTACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.70.00', 'ROYALTIES E PARTICIPACOES - EXPLORACAO PATRIMONIO GENETICO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE ROYALTIES E PARTICIPACOES PELA EXPLORACAO DO PATRIMONIO GENETICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.72.00', 'VPA CESSAO DIREITO OPERACIONALIZACAO PGTO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CESSAO DO DIREITO DE OPERACIONALIZACAO DE PAGAMENTOS. PORTARIA SOF 47, DE 21 DE JUNHO DE 2011.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.00.00', 'VALOR BRUTO EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A PRESTACAO DE SERVICOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.03.00', 'EXPLORACAO DO PATRIMONIO IMOBILIARIO', 'COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO, POR TERCEIROS, DE BENS IMOVEIS PERTENCENTES AO SETOR PUBLICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.08.00', 'SERVICOS CONSULT.ASSIST.TEC. ANALISE PROJETOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS PRESTADOS. VPA PROPORCIONADA POR CONSULTORIAS TECNICO-FINANCEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO,PERICIAS CONTABEIS, ANALISE DE PROJETOS, ETC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.09.00', 'PRESTACAO DE SERVICOS RELACIONADOS A T.I', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.15.00', 'SERVICOS DE COMUNICACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMUNICACAO, CONFORME DESCRICAO ABAIXO: A) SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; B) SERVICO DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS; C) SERVICO DE RADIODIFUSAO E DE AGENCIAMENTO DE PUBLICIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.16.00', 'PRESTACAO DE SERVICOS RELACIONADOS A ARMAZENAGEM', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ARMAZENAGEM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.24.00', 'CONCESSAO E PERMISSAO - SERV. DE TRANSPORT', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.25.00', 'CONCESSAO E PERMISSAO - SERV. DE COMUNIC.', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE COMUNICACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.26.00', 'OUTORGA SERV. EXPL. PROD PETR. GAS NATURA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO, DESENVOLVIMENTO E PRODUCAO DE PETROLEO E GAS NATURAL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.29.00', 'CONCESSAO FLORESTAL', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO E GESTAO DE DIREITOS DE USO DE FLORESTAS PUBLICAS, RECURSOS FLORESTAIS, PRODUTOS E SERVICOS DELAS DECORRENTES, PARA PRODUCAO SUSTENTAVEL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO, A PARTICULARES QUE ESTEJAM EM CONDICOES DE ATENDER AS EXIGENCIAS DO RESPECTIVO EDITAL DE LICITACAO E QUE DEMONSTREM CAPACIDADE PARA SEU DESEMPENHO, POR SUA CONTA E RISCO E PRAZO DETERMINADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.31.00', 'COMPENSACOES FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DOS RECURSOS DECORRENTES DO ARTIGO 20, PARAGRAFO 1º DA CONSTITUICAO FEDERAL, O QUAL DISPOE: "E ASSEGURADA, NOS TERMOS DA LEI, AOS ESTADOS, AO DISTRI-TO FEDERAL E AOS MUNICIPIOS, BEM COMO AOS ORGAOS DA ADMINISTRACAO DIRETA DA UNIAO, PARTICIPACAO NO RESULTADO DA EXPLORACAO DE PETROLEO OU GAS NATURAL, DE RECURSOS HIDRICOS PARA FINS DE GERACAO DE ENERGIA ELETRICA E DE OUTROS RECURSOS MINERAIS NO RESPECTIVO TERRITORIO, PLATAFORMA CONTINENTAL, MAR TERRITORIAL OU ZONA ECONOMIA EXCLUSIVA, OU COMPENSACAO FINANCEIRA POR ESSA EXPLORACAO".', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.35.00', 'SERVICOS DE SAUDE', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE SAUDE: HOSPITALARES GERAIS OU ESPECIALIZADOS, MATERNIDADE, CENTRO DE REABILITACAO, ASSISTENCIA MEDICO-ODONTOLOGICA (INCLUSIVE AMBULATORIAL), SAUDE PUBLICA, ETC...', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.37.00', 'SERVICOS DE METROLOGIA E CERTIFICACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA E CERTIFICACAO PRESTADOS.VPA DE SERVICOS METROLOGICOS EM GERAL, TAIS COMO AFERICAO DE MEDIDAS E INSTRUMENTOS DE MEDIR, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC..', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.45.00', 'SERVICOS REG. MARCAS,PAT.TRANSF.DE TECNOLOGIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE MARCAS, PATENTES E TRANSFERENCIA DE TECNOLOGIAS. VPA CORRESPONDENTE AOS SERVICOS PREVISTOS NO CODIGO DA PROPRIEDADE INDUSTRIAL, PETICOES GERAIS, PEDIDOS E PETICOS RELATI-VAS A PRIVILEGIOS, PEDIDOS E PETICOES RELATIVAS A MARCAS E PATENTES,PEDIDOS E PETICOES RELATIVOS A CONTRATOS DE TRANSFERENCIA DE TECNOLOGIA E CORRELATOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.52.00', 'TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA E ADICIONAL COBRADOS POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTI-LIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA). VPA VINCULADA AO MINISTERIO DA AERONAUTICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.54.00', 'TARIFAS USO COMUN.AUX.A NAVEG.AEREA EM ROTA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE USO DAS COMUNICACOES E DOS AUXILIOS AA NAVEGACAO AEREA EM ROTA. VPA PROVENIENTE DE TARIFAS COBRADAS PELA UTILIZACAO DOS SERVICOS DE INFORMACOES AERONAUTICAS, TRAFEGO AEREO, METEOROLOGIA, AUXILIOS A NAVEGACAO AEREA, FACILIDADES DE COMUNICACOES, E OUTROS SERVICOS AUXILIARES DE PROTECAO AO VOO, PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA E POR EMPRESA ESPECIALIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. ESSAS TARIFAS SAO FORMADAS: - PELA TARIFA DE USO DAS COMUNICACOES E DOS AUXILIOS A NAVEGACAO AEREA(TAN); - PELA TARIFA DE USO DAS COMUNICACOES E DOS AUXILIOS DE RADIO E VISU-AIS EM AREA DE TERMINAL AEREO (TAT).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.58.00', 'GARANTIAS E AVAIS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE GARANTIAS E AVAIS NAS OPERACOES DE CREDITO. FATO GERADOR: CONCESSAO DE GARANTIAS E AVAIS, DE NATUREZA NAO-FINANCEIRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.62.00', 'SERV.INOV.A.PESQ.AMBIENT.PROD.-INST.CIEN.TEC.', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS VOLTADOS A INOVACAO E AA PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.2.64.00', 'SERVICO DE EMISSAO DE CERTIFICADOS DE ORIGEM E DE EMISSAO DE LICENCA DE EXPORTACAO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE CERTIFICADOS DE ORIGEM E DE EMISSAO DE LICENCA DE EXPORTACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.00.00', 'VALOR BRUTO EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A PRESTACAO DE SERVICOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.03.00', 'EXPLORACAO DO PATRIMONIO IMOBILIARIO', 'COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO, POR TERCEIROS, DE BENS IMOVEIS PERTENCENTES AO SETOR PUBLICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.08.00', 'SERVICOS CONSULT.ASSIST.TEC. ANALISE PROJETOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS PRESTADOS. VPA PROPORCIONADA POR CONSULTORIAS TECNICO-FINANCEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO,PERICIAS CONTABEIS, ANALISE DE PROJETOS, ETC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.09.00', 'PRESTACAO DE SERVICOS RELACIONADOS A T.I', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.15.00', 'SERVICOS DE COMUNICACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMUNICACAO, CONFORME DESCRICAO ABAIXO: A) SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; B) SERVICO DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS; C) SERVICO DE RADIODIFUSAO E DE AGENCIAMENTO DE PUBLICIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.16.00', 'PRESTACAO DE SERVICOS RELACIONADOS A ARMAZENAGEM', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ARMAZENAGEM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.18.00', 'PRESTACAO DE SERVICOS RELACIONADOS AO BENEFICIAMENTO DE GRAOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE BENEFICIAMENTO DE GRAOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.24.00', 'CONCESSAO E PERMISSAO - SERV. DE TRANSPORT', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.25.00', 'CONCESSAO E PERMISSAO - SERV. DE COMUNIC.', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE COMUNICACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.26.00', 'OUTORGA SERV. EXPL. PROD PETR. GAS NATURA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO, DESENVOLVIMENTO E PRODUCAO DE PETROLEO E GAS NATURAL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.29.00', 'CONCESSAO FLORESTAL', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO E GESTAO DE DIREITOS DE USO DE FLORESTAS PUBLICAS, RECURSOS FLORESTAIS, PRODUTOS E SERVICOS DELAS DECORRENTES, PARA PRODUCAO SUSTENTAVEL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO, A PARTICULARES QUE ESTEJAM EM CONDICOES DE ATENDER AS EXIGENCIAS DO RESPECTIVO EDITAL DE LICITACAO E QUE DEMONSTREM CAPACIDADE PARA SEU DESEMPENHO, POR SUA CONTA E RISCO E PRAZO DETERMINADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.30.00', 'CONCESSAO E PERMISSAO. - DIR. USO DE BENS PUB', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.31.00', 'COMPENSACOES FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DOS RECURSOS DECORRENTES DO ARTIGO 20, PARAGRAFO 1º DA CONSTITUICAO FEDERAL, O QUAL DISPOE: "E ASSEGURADA, NOS TERMOS DA LEI, AOS ESTADOS, AO DISTRI-TO FEDERAL E AOS MUNICIPIOS, BEM COMO AOS ORGAOS DA ADMINISTRACAO DIRETA DA UNIAO, PARTICIPACAO NO RESULTADO DA EXPLORACAO DE PETROLEO OU GAS NATURAL, DE RECURSOS HIDRICOS PARA FINS DE GERACAO DE ENERGIA ELETRICA E DE OUTROS RECURSOS MINERAIS NO RESPECTIVO TERRITORIO, PLATAFORMA CONTINENTAL, MAR TERRITORIAL OU ZONA ECONOMIA EXCLUSIVA, OU COMPENSACAO FINANCEIRA POR ESSA EXPLORACAO".', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.32.00', 'SERVICOS DE TRANSPORTE', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE TRANSPORTE RODOVIARIO, FERROVIARIO, HIDROVIARIO, AEREO, ESPECIAIS E TARIFA DE PEDAGIO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.37.00', 'SERVICOS DE METROLOGIA E CERTIFICACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA E CERTIFICACAO PRESTADOS.VPA DE SERVICOS METROLOGICOS EM GERAL, TAIS COMO AFERICAO DE MEDIDAS E INSTRUMENTOS DE MEDIR, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC..', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.45.00', 'SERVICOS REG. MARCAS,PAT.TRANSF.DE TECNOLOGIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE MARCAS, PATENTES E TRANSFERENCIA DE TECNOLOGIAS. VPA CORRESPONDENTE AOS SERVICOS PREVISTOS NO CODIGO DA PROPRIEDADE INDUSTRIAL, PETICOES GERAIS, PEDIDOS E PETICOS RELATI-VAS A PRIVILEGIOS, PEDIDOS E PETICOES RELATIVAS A MARCAS E PATENTES,PEDIDOS E PETICOES RELATIVOS A CONTRATOS DE TRANSFERENCIA DE TECNOLOGIA E CORRELATOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.52.00', 'TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA E ADICIONAL COBRADOS POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTI-LIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA). VPA VINCULADA AO MINISTERIO DA AERONAUTICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.54.00', 'TARIFAS USO COMUN.AUX.A NAVEG.AEREA EM ROTA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE USO DAS COMUNICACOES E DOS AUXILIOS AA NAVEGACAO AEREA EM ROTA. VPA PROVENIENTE DE TARIFAS COBRADAS PELA UTILIZACAO DOS SERVICOS DE INFORMACOES AERONAUTICAS, TRAFEGO AEREO, METEOROLOGIA, AUXILIOS A NAVEGACAO AEREA, FACILIDADES DE COMUNICACOES, E OUTROS SERVICOS AUXILIARES DE PROTECAO AO VOO, PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA E POR EMPRESA ESPECIALIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. ESSAS TARIFAS SAO FORMADAS: - PELA TARIFA DE USO DAS COMUNICACOES E DOS AUXILIOS A NAVEGACAO AEREA(TAN); - PELA TARIFA DE USO DAS COMUNICACOES E DOS AUXILIOS DE RADIO E VISU-AIS EM AREA DE TERMINAL AEREO (TAT).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.58.00', 'GARANTIAS E AVAIS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE GARANTIAS E AVAIS NAS OPERACOES DE CREDITO. FATO GERADOR: CONCESSAO DE GARANTIAS E AVAIS, DE NATUREZA NAO-FINANCEIRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.62.00', 'SERV.INOV.A.PESQ.AMBIENT.PROD.-INST.CIEN.TEC.', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS VOLTADOS A INOVACAO E AA PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.4.64.00', 'SERVICO DE EMISSAO DE CERTIFICADOS DE ORIGEM E DE EMISSAO DE LICENCA DE EXPORTACAO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE CERTIFICADOS DE ORIGEM E DE EMISSAO DE LICENCA DE EXPORTACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.00.00', 'VALOR BRUTO EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS COM A PRESTACAO DE SERVICOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.03.00', 'EXPLORACAO DO PATRIMONIO IMOBILIARIO', 'COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO, POR TERCEIROS, DE BENS IMOVEIS PERTENCENTES AO SETOR PUBLICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.08.00', 'SERVICOS CONSULT.ASSIST.TEC. ANALISE PROJETOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS PRESTADOS. VPA PROPORCIONADA POR CONSULTORIAS TECNICO-FINANCEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO,PERICIAS CONTABEIS, ANALISE DE PROJETOS, ETC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.09.00', 'PRESTACAO DE SERVICOS RELACIONADOS A T.I', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.15.00', 'SERVICOS DE COMUNICACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMUNICACAO, CONFORME DESCRICAO ABAIXO: A) SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; B) SERVICO DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS; C) SERVICO DE RADIODIFUSAO E DE AGENCIAMENTO DE PUBLICIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.16.00', 'PRESTACAO DE SERVICOS RELACIONADOS A ARMAZENAGEM', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ARMAZENAGEM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.18.00', 'PRESTACAO DE SERVICOS RELACIONADOS AO BENEFICIAMENTO DE GRAOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE BENEFICIAMENTO DE GRAOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.25.00', 'CONCESSAO E PERMISSAO - SERV. DE COMUNIC.', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE COMUNICACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.26.00', 'OUTORGA SERV. EXPL. PROD PETR. GAS NATURA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO, DESENVOLVIMENTO E PRODUCAO DE PETROLEO E GAS NATURAL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.29.00', 'CONCESSAO FLORESTAL', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO E GESTAO DE DIREITOS DE USO DE FLORESTAS PUBLICAS, RECURSOS FLORESTAIS, PRODUTOS E SERVICOS DELAS DECORRENTES, PARA PRODUCAO SUSTENTAVEL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO, A PARTICULARES QUE ESTEJAM EM CONDICOES DE ATENDER AS EXIGENCIAS DO RESPECTIVO EDITAL DE LICITACAO E QUE DEMONSTREM CAPACIDADE PARA SEU DESEMPENHO, POR SUA CONTA E RISCO E PRAZO DETERMINADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.31.00', 'COMPENSACOES FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DOS RECURSOS DECORRENTES DO ARTIGO 20, PARAGRAFO 1º DA CONSTITUICAO FEDERAL, O QUAL DISPOE: "E ASSEGURADA, NOS TERMOS DA LEI, AOS ESTADOS, AO DISTRI-TO FEDERAL E AOS MUNICIPIOS, BEM COMO AOS ORGAOS DA ADMINISTRACAO DIRETA DA UNIAO, PARTICIPACAO NO RESULTADO DA EXPLORACAO DE PETROLEO OU GAS NATURAL, DE RECURSOS HIDRICOS PARA FINS DE GERACAO DE ENERGIA ELETRICA E DE OUTROS RECURSOS MINERAIS NO RESPECTIVO TERRITORIO, PLATAFORMA CONTINENTAL, MAR TERRITORIAL OU ZONA ECONOMIA EXCLUSIVA, OU COMPENSACAO FINANCEIRA POR ESSA EXPLORACAO".', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.35.00', 'SERVICOS DE SAUDE', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE SAUDE: HOSPITALARES GERAIS OU ESPECIALIZADOS, MATERNIDADE, CENTRO DE REABILITACAO, ASSISTENCIA MEDICO-ODONTOLOGICA (INCLUSIVE AMBULATORIAL), SAUDE PUBLICA, ETC...', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.45.00', 'SERVICOS REG. MARCAS,PAT.TRANSF.DE TECNOLOGIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE MARCAS, PATENTES E TRANSFERENCIA DE TECNOLOGIAS. VPA CORRESPONDENTE AOS SERVICOS PREVISTOS NO CODIGO DA PROPRIEDADE INDUSTRIAL, PETICOES GERAIS, PEDIDOS E PETICOS RELATI-VAS A PRIVILEGIOS, PEDIDOS E PETICOES RELATIVAS A MARCAS E PATENTES,PEDIDOS E PETICOES RELATIVOS A CONTRATOS DE TRANSFERENCIA DE TECNOLOGIA E CORRELATOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.52.00', 'TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA E ADICIONAL COBRADOS POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTI-LIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA). VPA VINCULADA AO MINISTERIO DA AERONAUTICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.54.00', 'TARIFAS USO COMUN.AUX.A NAVEG.AEREA EM ROTA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE USO DAS COMUNICACOES E DOS AUXILIOS AA NAVEGACAO AEREA EM ROTA. VPA PROVENIENTE DE TARIFAS COBRADAS PELA UTILIZACAO DOS SERVICOS DE INFORMACOES AERONAUTICAS, TRAFEGO AEREO, METEOROLOGIA, AUXILIOS A NAVEGACAO AEREA, FACILIDADES DE COMUNICACOES, E OUTROS SERVICOS AUXILIARES DE PROTECAO AO VOO, PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA E POR EMPRESA ESPECIALIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. ESSAS TARIFAS SAO FORMADAS: - PELA TARIFA DE USO DAS COMUNICACOES E DOS AUXILIOS A NAVEGACAO AEREA(TAN); - PELA TARIFA DE USO DAS COMUNICACOES E DOS AUXILIOS DE RADIO E VISU-AIS EM AREA DE TERMINAL AEREO (TAT).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.57.00', 'PREST. DE SERV. PELO BANCO CENTRAL DO BRASIL', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE DA PRESTACAO DE SERVICOS DE AUTORIDADE MONETARIA AO SETOR BANCARIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.58.00', 'GARANTIAS E AVAIS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE GARANTIAS E AVAIS NAS OPERACOES DE CREDITO. FATO GERADOR: CONCESSAO DE GARANTIAS E AVAIS, DE NATUREZA NAO-FINANCEIRAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.62.00', 'SERV.INOV.A.PESQ.AMBIENT.PROD.-INST.CIEN.TEC.', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS VOLTADOS A INOVACAO E AA PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.63.00', 'SERVICOS FINANCEIROS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM SERVICOS FINANCEIROS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.5.64.00', 'SERVICO DE EMISSAO DE CERTIFICADOS DE ORIGEM E DE EMISSAO DE LICENCA DE EXPORTACAO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE CERTIFICADOS DE ORIGEM E DE EMISSAO DE LICENCA DE EXPORTACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.0.00.00', '(-) DEDUCOES DO VALOR BRUTO DE EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS', 'COMPREENDE AS DEDUCOES DAS PRESTACOES DE SERVICOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.00.00', '(-) DEDUCOES DO VALOR BRUTO DE EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS - CONSOLIDACAO', 'COMPREENDE AS DEDUCOES DAS PRESTACOES DE SERVICOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.2.00.00', '(-) DEDUCOES DO VALOR BRUTO DE EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS - INTRA OFSS', 'COMPREENDE AS DEDUCOES DAS PRESTACOES DE SERVICOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.4.00.00', '(-) DEDUCOES DO VALOR BRUTO DE EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS- INTER OFSS - ESTADO', 'COMPREENDE AS DEDUCOES DAS PRESTACOES DE SERVICOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.5.00.00', '(-) DEDUCOES DO VALOR BRUTO DE EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS- INTER OFSS - MUNICIPIO', 'COMPREENDE AS DEDUCOES DAS PRESTACOES DE SERVICOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.0.0.0.00.00', 'VARIACOES PATRIMONIAIS AUMENTATIVAS FINANCEIRAS', 'COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM OPERACOES FINANCEIRAS. COMPREENDE: DESCONTOS OBTIDOS, JUROS AUFERIDOS, PREMIO DE RESGATE DE TITULOS E DEBENTURES, ENTRE OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.0.0.00.00', 'JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.1.0.00.00', 'JUROS E ENCARGOS DE EMPRESTIMOS INTERNOS CONCEDIDOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICACAO DAS TAXAS DE JUROS APLICADAS A EMPRESTIMOS INTERNOS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.2.0.00.00', 'JUROS E ENCARGOS DE EMPRESTIMOS EXTERNOS CONCEDIDOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICACAO DAS TAXAS DE JUROS APLICADAS A EMPRESTIMOS EXTERNOS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.3.0.00.00', 'JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS INTERNOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.4.0.00.00', 'JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS EXTERNOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.0.0.00.00', 'JUROS E ENCARGOS DE MORA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO REPRESENTANDO O RESULTADO DAS APLICACOES IMPOSTAS AO CONTRIBUINTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.1.0.00.00', 'JUROS E ENCARGOS DE MORA SOBRE EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.2.0.00.00', 'JUROS E ENCARGOS DE MORA SOBRE EMPRESTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A EMPRESTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.0.00.00', 'JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVICOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A FORNECIMENTO DE BENS E SERVICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.1.00.00', 'JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVICOS - CONSOLIDACAO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A FORNECIMENTO DE BENS E SERVICOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.2.00.00', 'JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVICOS - INTRA OFSS', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A FORNECIMENTO DE BENS E SERVICOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.4.00.00', 'JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVICOS - INTER OFSS - ESTADO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A FORNECIMENTO DE BENS E SERVICOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.5.00.00', 'JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVICOS - INTER OFSS - MUNICIPIO', 'REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A FORNECIMENTO DE BENS E SERVICOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.00.00', 'JUROS E ENCARGOS DE MORA SOBRE CREDITOS TRIBUTARIOS - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE APLICADA EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE CREDITOS TRIBUTARIOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.02.00', 'MULTAS E JUROS DE MORA- IR', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRITUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.06.00', 'MULTAS E JUROS DE MORA IMP. PROP.TERRIT.RURAL', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE A PROPRIEDADE RURAL.- FATO GERADOR: NAO PAGAMENTO NOS PRAZOS PREVISTOS NA LEGISLACAO DESTE TRIBUTO; AMPARO LEGAL: A) LEI 9430/1996; B) LEI 9393/1996; C) DECRETO 4382/2002; D) LEI 8383/1991, ART 69; E) LEI 9069/1995; F) LEI 5172/1966, ART 161.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.16.00', 'MULTA/JUROS MORA CONTR.REG.PROP. PREV. SERV.', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVAS ORIGINADAS DE MULTAS E JUROS DE MORA DAS CONTRIBUICOES PARA O REGIME PROPRIO DE PREVIDENCIADO SERVIDOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.17.00', 'MULTAS E JUROS DE MORA CONT.PARA O RGPS', 'COMPREENDE O VALOR DAS PENALIDADES PECUNIARIAS INCIDENTES SOBRE AS CONTRIBUICOES DEVIDAS A SEGURIDADE SOCIAL E NAO RECOLHIDAS ATE A DATA DO SEU VENCIMENTO, COM BASE NO ART. 58, INCISO III, DO DECRETO NO 2.173, DE 06 DE MARCO DE 1997.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.27.00', 'JUROS DE MORA DO FUNDAF - REC. DE CONTRIB.', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA RESPECTIVA CONTRIBUICAO. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.30.00', 'MUL. JUR.MORA DIV.ATIVA IR S/PROV.QQ.NATUREZA', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA COM O RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COM A FAZENDA PUBLICA, DE NATUREZA TRIBUTARIA, NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA DO IMPOSTO SOBRE A RENDA E PROVENTES DE QUALQUER NATUREZA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.42.00', 'JUROS DE MORA DO FUNDAF - DIV.ATIVA DAS CONTR', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA RESPECTIVA CONTRIBUICAO. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.99.00', 'JUROS E ENCARGOS DE MORA SOBRE OUTROS CREDITOS TRIBUTARIOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE OUTRAS CREDITOS TRIBUTARIOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.0.00.00', 'OUTROS JUROS E ENCARGOS DE MORA', 'COMPREENDE AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.00.00', 'OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDACAO', 'COMPREENDE AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.01.00', 'MULTAS JUR.MORA ALIENACAO DE DOMINIO UTIL', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS JUROS DE MORA ALIEN. DOM.UTIL. MULTAS APLICADAS POR ATRASOS NO RECOLHIMENTO DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL DE TERRENOS DA UNIAO, DE ACORDO COM O PREVISTO NO ARTIGO 4 DO DECRETO-LEI NUM 1561, DE 13 DE JULHO DE 1977 E ARTIGOS 25 A 27 DA MP NUM. 1647-14, DE 24 DE FEVEREIRO DE 1998.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.00.00', 'OUTROS JUROS E ENCARGOS DE MORA - INTRA OFSS', 'COMPREENDE AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.01.00', 'MULTAS JUR.MORA ALIENACAO DE DOMINIO UTIL', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS JUROS DE MORA ALIEN. DOM.UTIL. MULTAS APLICADAS POR ATRASOS NO RECOLHIMENTO DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL DE TERRENOS DA UNIAO, DE ACORDO COM O PRE- VISTO NO ARTIGO 4 DO DECRETO-LEI NUM 1561, DE 13 DE JULHO DE 1977 E ARTIGOS 25 A 27 DA MP NUM. 1647-14, DE 24 DE FEVEREIRO DE 1998.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.2.99.00', 'OUTROS JUROS E ENCARGOS DE MORA', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE OUTROS JUROS E ENCARGOS DE MORA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.00.00', 'OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - ESTADO', 'COMPREENDE AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.01.00', 'MULTAS JUR.MORA ALIENACAO DE DOMINIO UTIL', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS JUROS DE MORA ALIEN. DOM.UTIL. MULTAS APLICADAS POR ATRASOS NO RECOLHIMENTO DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL DE TERRENOS DA UNIAO, DE ACORDO COM O PRE- VISTO NO ARTIGO 4 DO DECRETO-LEI NUM 1561, DE 13 DE JULHO DE 1977 E ARTIGOS 25 A 27 DA MP NUM. 1647-14, DE 24 DE FEVEREIRO DE 1998.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.4.99.00', 'OUTROS JUROS E ENCARGOS DE MORA', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE OUTROS JUROS E ENCARGOS DE MORA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.00.00', 'OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - MUNICIPIO', 'COMPREENDE AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.01.00', 'MULTAS JUR.MORA ALIENACAO DE DOMINIO UTIL', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS JUROS DE MORA ALIEN. DOM.UTIL. MULTAS APLICADAS POR ATRASOS NO RECOLHIMENTO DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL DE TERRENOS DA UNIAO, DE ACORDO COM O PRE- VISTO NO ARTIGO 4 DO DECRETO-LEI NUM 1561, DE 13 DE JULHO DE 1977 E ARTIGOS 25 A 27 DA MP NUM. 1647-14, DE 24 DE FEVEREIRO DE 1998.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.5.99.00', 'OUTROS JUROS E ENCARGOS DE MORA', 'REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE OUTROS JUROS E ENCARGOS DE MORA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.0.0.00.00', 'VARIACOES MONETARIAS E CAMBIAIS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A A CORRECAO MONETARIA POS-FIXADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.0.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE EMPRESTIMOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS EMPRESTIMOS INTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.1.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE EMPRESTIMOS INTERNOS CONCEDIDOS - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS EMPRESTIMOS INTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.2.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE EMPRESTIMOS INTERNOS CONCEDIDOS - INTRA OFSS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS EMPRESTIMOS INTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.4.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE EMPRESTIMOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS EMPRESTIMOS INTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.5.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE EMPRESTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICIPIO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS EMPRESTIMOS INTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.2.0.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE EMPRESTIMOS EXTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS EMPRESTIMOS EXTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.2.1.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE EMPRESTIMOS EXTERNOS CONCEDIDOS - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS EMPRESTIMOS EXTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.0.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS INTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.1.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS INTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.2.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTRA OFSS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS INTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.4.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.5.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICIPIO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS INTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.4.1.00.00', 'VARIACOES MONETARIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS EXTERNOS CONCEDIDOS. RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.0.00.00', 'OUTRAS VARIACOES MONETARIAS E CAMBIAIS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.1.00.00', 'OUTRAS VARIACOES MONETARIAS E CAMBIAIS - CONSOLIDACAO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.2.00.00', 'OUTRAS VARIACOES MONETARIAS E CAMBIAIS - INTRA OFSS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.4.00.00', 'OUTRAS VARIACOES MONETARIAS E CAMBIAIS - INTER OFSS - ESTADO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.5.00.00', 'OUTRAS VARIACOES MONETARIAS E CAMBIAIS - INTER OFSS - MUNICIPIO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE QUE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.5.0.0.00.00', 'REMUNERACAO DE DEPOSITOS BANCARIOS E APLICACOES FINANCEIRAS', 'COMPREENDE O VALOR TOTAL DAS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DA REMUNERACAO DO SALDO DIARIO DOS DEPOSITO DA UNIAO EXISTENTES NO BANCO CENTRAL, BEM COMO APLICACAO DE RECURSOS DA CONTA UNICA DE ACORDO COM A RENTABILIDADE MEDIA INTRINSECA DOS TITULOS DO TESOURO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.5.1.0.00.00', 'REMUNERACAO DE DEPOSITOS BANCARIOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DA REMUNERACAO DOS DEPOSITOS BANCARIOS DO ENTE EXISTENTES NO AGENTE FINANCEIRO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.5.2.0.00.00', 'REMUNERACAO DE APLICACOES FINANCEIRAS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA REMUNERACAO DE DEPOSITOS BANCARIOS, RECURSOS ORIUNDOS DE APLICACOES DE ENTIDADES DA ADMINISTRACAO PUBLICA NO MERCADO FINANCEIRO, AUTORIZADAS POR LEI, EM CADERNETA DE POUPANCA, FUNDO DE INVESTIMENTO, CONTAS REMUNERADAS E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.9.0.0.00.00', 'OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NOS SUBGRUPOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.0.0.0.00.00', 'TRANSFERENCIAS E DELEGACOES RECEBIDAS', 'COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM TRANSFERENCIAS INTER GOVERNAMENTAIS, TRANSFERENCIAS INTRAGOVERNAMENTAIS, TRANSFERENCIAS DE INSTITUICOES MULTIGOVERNAMENTAIS, TRANSFERENCIAS DE INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS, TRANSFERENCIAS DE CONVENIOS, TRANSFERENCIAS DO EXTERIOR E EXECUCOES ORCAMENTARIAS DELEGADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.0.0.00.00', 'TRANSFERENCIAS INTRAGOVERNAMENTAIS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS RELATIVAS A EXECUCAO ORCAMENTARIA, E DE BENS E VALORES, REFERENTES AS TRANSACOES INTRAGOVERNAMENTAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.0.00.00', 'TRANSFERENCIAS RECEBIDAS PARA A EXECUCAO ORCAMENTARIA', 'COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS RECEBIDAS E CORRESPONDENCIA DE CREDITOS EM VIRTUDE DA EXECUCAO ORÇAMENTARIA (COTA, REPASSE E SUB-REPASSE). INCLUI TAMBEM O VALOR REPASSADO PARA A COBERTURA DO DEFICIT FINANCEIRO DO RPPS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.00.00', 'TRANSFERENCIAS RECEBIDAS PARA A EXECUCAO ORCAMENTARIA-INTRA OFSS', 'COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS RECEBIDAS E CORRESPONDENCIA DE CREDITOS EM VIRTUDE DA EXECUCAO ORÇAMENTARIA (COTA, REPASSE E SUB-REPASSE). INCLUI TAMBEM O VALOR REPASSADO PARA A COBERTURA DO DÉFICIT FINANCEIRO DO RPPS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.05.00', 'VALORES DIFERIDOS - BAIXA', 'COMPREENDE OS VALORES NO PROCESSO DE BAIXA DOS RECURSOS DIFERIDOS, SUBDIVIDINDO-SE EM: COTA, REPASSE E SUB-REPASSE DIFERIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.06.00', 'VALORES DIFERIDOS - INSCRICAO', 'COMPREENDE OS VALORES NO PROCESSO DE INSCRICAO DOS RECURSOS DIFERIDOS, SUBDIVIDINDO-SE EM: COTA, REPASSE E SUB-REPASSE DIFERIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.07.00', 'CORRESPONDENCIA DE DEBITO', 'COMPREENDE A APROPRIACAO DAS VARIACOES PATRIMONIAIS AUMENTATIVAS DESINCORPORADAS PARA TRANSFERENCIA A OUTRA UG DE MESMA GESTAO, PARA APURACAO DE CUSTO E RESULTADO DE GESTAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.08.00', 'APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO', 'COMPREENDE O MONTANTE DOS VALORES RECEBIDOS DO PROPRIO ENTE, NECESSARIOS AA COBERTURA DE INSIFICIENCIAS FINANCEIRAS, FORMACAO DE RESERVAS E OUTRAS NECESSIDADES DE RECURSOS PARA O REGIME PROPRIO DE PREVIDENCIA DO SERVIDOR PUBLICO - RPPS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.09.00', 'APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDENCIARIO', 'REPRESENTA O MONTANTE DOS VALORES RECEBIDOS DO PROPRIO ENTE, NECESSA RIOS AA COBERTURA DE DEFICIT FINANCEIRO OU ATUARIAL, NO AMBITO DO PLA NO PREVIDENCIARIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.0.00.00', 'TRANSFERENCIAS RECEBIDAS INDEPENDENTES DE EXECUCAO ORCAMENTARIA', 'COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS, DE BENS OU VALORES RECEBIDAS PARA RESTOS A PAGAR E OUTRAS FINALIDADES INDEPENDENTES DA EXECUCAO ORÇAMENTARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.00.00', 'TRANSFERENCIAS RECEBIDAS INDEPENDENTES DE EXECUCAO ORCAMENTARIA - INTRA OFSS', 'COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS, DE BENS OU VALORES RECEBIDAS PARA RESTOS A PAGAR E OUTRAS FINALIDADES INDEPENDENTES DA EXECUCAO ORCAMENTARIA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.01.00', 'ORDEM DE TRANSFERENCIAS RECEBIDAS', 'COMPREENDE O VALOR DA ORDEM DE TRANSFERENCIA RECEBIDA - OTR A TITULO DE RECURSOS VINCULADOS QUE DEVERAO PERMANECER NA PROPRIA UG BENEFICIADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.02.00', 'RESTITUICAO DE RECEITAS FEDERAIS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA QUE PERMITE IDENTIFICAR OS REGISTROS DE RESTITUICAO DE RECEITAS FEDERAIS EFETIVADOS PELAS DELEGACIAS DA RECEITA FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.05.00', 'TRANSFERENCIAS DIVERSAS RECEBIDAS', 'COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS DE NATUREZA EVENTUAL, RECEBIDAS DE UG DE MESMA GESTAO, NAO VINCULADAS A ORCAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.06.00', 'TRANSFERENCIAS RECEBIDAS ENTRE UG/ORGAO', 'COMPREENDE A TRANSFERENCIA DE RECURSOS ENTRE UG DE MESMO ORGAO OU DE ORGAOS DIFERENTES QUE NAO ESTEJA RELACIONADA A EXECUCAO ORCAMENTARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.09.00', 'MOVIMENTO DE FUNDOS A DEBITO - MOVIMENTO DE FUNDOS PROPRIOS', 'COMPREENDE O SOMATORIO DOS SALDOS DEVEDORES INCORPORADOS POR INTEGRACAO DE BALANCETES, FUSAO, CISAO E MUDANCA DE MODALIDADE DE USO PARCIAL PARA TOTAL DE ORGAOS DO SIAFI, AGREGADOS EM PATRIMONIAIS E FINANCEIROS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.14.00', 'DOACOES RECEBIDAS DE BENS MOVEIS', 'COMPREENDE O VALOR DOS BENS MOVEIS RECEBIDOS DE UNIDADE LOCALIZADA NO PAIS OU NO EXTERIOR POR OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DE ORGAOS DIFERENTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.3.0.00.00', 'TRANSFERENCIAS RECEBIDAS PARA COBERTURA DO DEFICIT ATUARIAL DO RPPS POR APORTE PERIODICO', 'COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS PARA APORTES PERIODICOS DESTINADOS A COBERTURA DO DEFICIT ATUARIAL DO REGIME PROPRIO DE PREVIDENCIA SOCIAL - RPPS, CONFORME PLANO DE AMORTIZACAO ESTABELECIDO EM LEI DO RESPECTIVO ENTE FEDERATIVO, EXCETO AS DECORRENTES DE ALIQUOTA DE CONTRIBUICAO SUPLEMENTAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.0.0.00.00', 'TRANSFERENCIAS INTER GOVERNAMENTAIS', 'COMPREENDEM AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS DA UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.0.00.00', 'TRANSFERENCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS', 'COMPREENDEM AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DA TRANSFERENCIA DE OUTRAS ESFERAS DE GOVERNO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.1.00.00', 'TRANSFERENCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS- CONSOLIDACAO', 'COMPREENDEM AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DA TRANSFERENCIA DE OUTRAS ESFERAS DE GOVERNO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS). POR EXEMPLO, EMPRESA INDEPENDENTE DE UM ENTE RECEBENDO TRANSFERENCIA DE OUTRO ENTE (A EMPRESA INDEPENDENTE NAO PERTENCE AO OFSS MAS PERTENCE AO CONCEITO DE GOVERNAMENTAL).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.4.00.00', 'TRANSFERENCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS - ESTADO', 'COMPREENDEM AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DA TRANSFERENCIA DE OUTRAS ESFERAS DE GOVERNO DE RECEITAS TRIBUTARIAS, DE CONTRIBUICOES E DE OUTRAS RECEITAS VINCULADAS, PREVISTA NA CONSTITUICAO OU EM LEIS ESPECIFICAS, CUJA COMPETENCIA DE ARRECADACAO E DO ORGAO TRANSFERIDOR. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.4.01.00', 'TRANSFERENCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS DOS ESTADOS E DO DF', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS DOS ESTADOS E DISTRITO FEDERAL A UNIAO, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.1.00.00', 'TRANSFERENCIAS VOLUNTARIAS - CONSOLIDACAO', 'COMPREENDEM AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANFERENCIAS VOLUNTARIAS DA UNIAO, ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, BEM COMO AS DEMAIS ENTIDADES DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.4.00.00', 'TRANSFERENCIAS VOLUNTARIAS - INTER OFSS - ESTADO', 'COMPREENDEM AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANFERENCIAS VOLUNTARIAS DA UNIAO, ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, BEM COMO AS DEMAIS ENTIDADES DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.4.01.00', 'TRANSFERENCIAS VOLUNTARIAS DOS ESTADOS E DO DF', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS VOLUNTARIAS DOS ESTADOS E DISTRITO FEDERAL A UNIAO, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.5.00.00', 'TRANSFERENCIAS VOLUNTARIAS - INTER OFSS - MUNICIPIO', 'COMPREENDEM AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANFERENCIAS VOLUNTARIAS DA UNIAO, ESTADOS E DISTRITO FEDERAL, INCLUSIVE DAS ENTIDADES VINCULADAS, BEM COMO AS DEMAIS ENTIDADES DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.5.01.00', 'TRANSFERENCIAS VOLUNTARIAS DOS MUNICIPIOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS VOLUNTARIAS DOS MUNICIPIOS A UNIAO, ESTADOS E DISTRITO FEDERAL, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.4.0.00.00', 'OUTRAS TRANSFERENCIAS', 'COMPREENDEM AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE DEMAIS TRANFERENCIAS DA UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, DE BENS E/OU VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.4.1.00.00', 'OUTRAS TRANSFERENCIAS - CONSOLIDACAO', 'COMPREENDEM AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE DEMAIS TRANFERENCIAS DA UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.4.4.00.00', 'OUTRAS TRANSFERENCIAS - INTER OFSS - ESTADO', 'COMPREENDEM AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE DEMAIS TRANFERENCIAS DA UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.4.5.00.00', 'OUTRAS TRANSFERENCIAS - INTER OFSS - MUNICIPIO', 'COMPREENDEM AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE DEMAIS TRANFERENCIAS DA UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE DAS ENTIDADES VINCULADAS, DE BENS E/OU VALORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.0.0.00.00', 'TRANSFERENCIAS DAS INSTITUICOES PRIVADAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS DAS INSTITUICOES PRIVADAS, INCLUSIVE DE BENS E VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.1.0.00.00', 'TRANSFERENCIAS DAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS DAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS, INCLUSIVE DE BENS E VALORES. EXEMPLO: ONGS,OSCIPS E OS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.1.1.00.00', 'TRANSFERENCIAS DAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS DAS INTITUICOES PRIVADAS SEM FINS LUCRATIVOS, INCLUSIVE DE BENS E VALORES. EXEMPLO: ONGS,OSCIPS E OS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.2.0.00.00', 'TRANSFERENCIAS DAS INSTITUICOES PRIVADAS COM FINS LUCRATIVOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS DAS INSTITUICOES PRIVADAS COM FINS LUCRATIVOS, INCLUSIVE DE BENS E VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.2.1.00.00', 'TRANSFERENCIAS DAS INSTITUICOES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS DAS INSTITUICOES PRIVADAS COM FINS LUCRATIVAS, INCLUSIVE DE BENS E VALORES. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.4.0.0.00.00', 'TRANSFERENCIAS DAS INSTITUICOES MULTIGOVERNAMENTAIS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DAS INSTITUICOES MULTIGOVERNAMENTAIS, DAS QUAIS O ENTE RECEBEDOR NAO PARTICIPE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.5.0.0.00.00', 'TRANSFERENCIAS DE CONSORCIOS PUBLICOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DE CONSORCIOS PUBLICOS, DOS QUAIS O ENTE RECEBEDOR PARTICIPE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.6.0.0.00.00', 'TRANSFERENCIAS DO EXTERIOR', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS DE ORGANISMOS E FUNDOS INTERNACIONAIS, DE GOVERNOS ESTRANGEIROS E INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.6.0.1.00.00', 'TRANSFERENCIAS DO EXTERIOR - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS DE ORGANISMOS E FUNDOS INTERNACIONAIS, DE GOVERNOS ESTRANGEIROS E INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS NO EXTERIOR. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.0.0.00.00', 'EXECUCAO ORCAMENTARIA DELEGADA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIA DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO DOS ENTES (UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS) OU CONSORCIOS PUBLICOS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.0.00.00', 'EXECUCAO ORCAMENTARIA DELEGADA DE ENTES', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIA DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO DOS ENTES (UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS) PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.4.00.00', 'EXECUCAO ORCAMENTARIA DELEGADA DE ENTES - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIA DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO DOS ENTES (UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS) PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.5.00.00', 'EXECUCAO ORCAMENTARIA DELEGADA DE ENTES - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIA DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO DOS ENTES (UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS) PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.2.0.00.00', 'EXECUCAO ORCAMENTARIA DELEGADA DE CONSORCIOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIA DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO DE CONSORCIOS PUBLICOS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.2.1.00.00', 'EXECUCAO ORCAMENTARIA DELEGADA DE CONSORCIOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIA DE RECURSOS FINANCEIROS, DECORRENTES DE DELEGACAO OU DESCENTRALIZACAO DE CONSORCIOS PUBLICOS PARA EXECUCAO DE ACOES DE RESPONSABILIDADE EXCLUSIVA DO DELEGANTE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.8.0.0.00.00', 'TRANSFERENCIAS DE PESSOAS FISICAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CONTRIBUICOES E DOACOES A GOVERNOS E ENTIDADES DA ADMINISTRACAO DESCENTRALIZADA REALIZADAS POR PESSOAS FISICAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.8.0.1.00.00', 'TRANSFERENCIAS DE PESSOAS FISICAS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CONTRIBUICOES E DOACOES A GOVERNOS E ENTIDADES DA ADMINISTRACAO DESCENTRALIZADA REALIZADAS POR PESSOAS FISICAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.0.0.0.00.00', 'VALORIZACAO E GANHOS COM ATIVOS', 'COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM REAVALIACAO E GANHOS DE ATIVOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.0.0.00.00', 'REAVALIACAO DE ATIVOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS DO ATIVO, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.0.00.00', 'REAVALIACAO DE IMOBILIZADO', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS DO ATIVO IMOBILIZADO, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.2.0.00.00', 'REAVALIACAO DE INTANGIVEIS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ATIVOS INTANGIVEIS, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.9.0.00.00', 'REAVALIACAO DE OUTROS ATIVOS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OUTROS ATIVOS, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.0.0.00.00', 'GANHOS COM ALIENACAO', 'COMPREENDE O GANHO COM ALIENACAO DE ATIVOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.1.0.00.00', 'GANHOS COM ALIENACAO DE INVESTIMENTOS', 'COMPREENDE O GANHO COM ALIENACAO DE INVESTIMENTOS, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.0.00.00', 'GANHOS COM ALIENACAO DE IMOBILIZADO', 'COMPREENDE O GANHO COM ALIENACAO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.3.0.00.00', 'GANHOS COM ALIENACAO DE INTANGIVEIS', 'COMPREENDE O GANHO COM ALIENACAO DE ATIVOS INTANGIVEIS, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.0.0.00.00', 'GANHOS COM INCORPORACAO DE ATIVOS', 'COMPREENDE A CONTRAPARTIDA DA INCORPORACAO DE NOVOS ATIVOS DESCOBERTOS, A CONTRAPARTIDA DA INCORPORACAO DE ATIVOS SEMOVENTES NASCIDOS, POR EXEMPLO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.1.0.00.00', 'GANHOS COM INCORPORACAO DE ATIVOS POR DESCOBERTAS', 'COMPREENDE OS GANHOS COM A INCORPORACAO DE NOVOS ATIVOS DESCOBERTOS, COMO POR EXEMPLO, DESCOBERTA DE JAZIDAS DE RECURSOS NATURAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.2.0.00.00', 'GANHOS COM INCORPORACAO DE ATIVOS POR NASCIMENTOS', 'COMPREENDE OS GANHOS COM A INCORPORACAO DE SEMOVENTES NASCIDOS, COMO POR EXEMPLO, NASCIMENTO DE BOVINOS E AVES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.3.0.00.00', 'GANHOS COM INCORPORACAO DE VALORES APREENDIDOS', 'COMPREENDE OS GANHOS COM A INCORPORACAO DE VALORES APREENDIDOS, COMO POR EXEMPLO, OS VALORES APREENDIDOS ASSOCIADOS AO TRAFICO ILICITO DE ENTORPENCENTES E DROGAS AFINS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.0.0.0.00.00', 'OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS', 'COMPREENDE O SOMATORIO DAS DEMAIS VARIACOES PATRIMONIAIS AUMENTATIVAS NAO INCLUIDAS NOS GRUPOS ANTERIORES,TAIS COMO: RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, DIVIDENDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.0.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA A CLASSIFICAR', 'COMPREENDE OS RECURSOS REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVA RECEBIDAS E NAO CLASSIFICADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.1.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - CONSOLIDACAO', 'COMPREENDE OS RECURSOS REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVA RECEBIDAS E NAO CLASSIFICADAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.2.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - INTRA OFSS', 'COMPREENDE OS RECURSOS REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVA RECEBIDAS E NAO CLASSIFICADAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.4.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - INTER OFSS - ESTADO', 'COMPREENDE OS RECURSOS REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVA RECEBIDAS E NAO CLASSIFICADAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.5.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - INTER OFSS - MUNICIPIO', 'COMPREENDE OS RECURSOS REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVA RECEBIDAS E NAO CLASSIFICADAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.0.0.00.00', 'RESULTADO POSITIVO DE PARTICIPACOES', 'COMPREENDE O RESULTADO POSITIVO DAS PARTICIPACOES DE CARATER PERMANENTE NO CAPITAL SOCIAL DE SOCIEDADES INVESTIDAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.1.0.00.00', 'RESULTADO POSITIVO DE EQUIVALENCIA PATRIMONIAL', 'COMPREENDE A APROPRIACAO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.2.0.00.00', 'DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS', 'COMPREENDE AS VARIACOES AUMENTATIVAS ORIUNDAS DE LUCROS APURADOS EM OUTROS INVESTIMENTOS NAO AVALIADOS PELO METODO DA EQUIVALENCIA PATRIMONIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.0.00.00', 'VARIACOES PATRIMONIAIS AUMENTATIVAS DE INSTITUICOES FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA DE INSTITUICOES FINANCEIRAS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.1.02.00', 'VPA OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TRANSACOES REALIZADAS NO PERIODO, VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA DE INSTITUICOES FINANCEIRAS - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.2.02.00', 'VPA OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TRANSACOES REALIZADAS NO PERIODO, VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA DE INSTITUICOES FINANCEIRAS - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.01.00', 'VPA COM OPERACOES DE AUTORIDADE MONETARIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES DE AUTORIDADE MONETARIA .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.4.02.00', 'VPA OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TRANSACOES REALIZADAS NO PERIODO, VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA DE INSTITUICOES FINANCEIRAS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.01.00', 'VPA COM OPERACOES DE AUTORIDADE MONETARIA', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES DE AUTORIDADE MONETARIA .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.3.0.5.02.00', 'VPA OPERACIONAIS DE INSTITUICOES FINANCEIRAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TRANSACOES REALIZADAS NO PERIODO, VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.0.0.00.00', 'REVERSAO DE PROVISOES E AJUSTES DE PERDAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REVERSAO DE PROVISOES E AJUSTES DE PERDAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.0.00.00', 'REVERSAO DE PROVISOES', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REVERSOES DE PROVISOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.2.0.00.00', 'REVERSAO DE AJUSTES DE PERDAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REVERSOES DE AJUSTES DE PERDAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.1.0.00.00', 'COMPENSACAO FINANCEIRA ENTRE RGPS/RPPS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.2.0.00.00', 'COMPENSACAO FINANCEIRA ENTRE REGIMES PROPRIOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.3.0.00.00', 'VARIACAO PATRIMONIAL AUMENTATIVA COM BONIFICACOES', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE BONIFICACOES RECEBIDAS NAS AQUISICOES DE MERCADORIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.4.0.00.00', 'AMORTIZACAO DE DESAGIO EM INVESTIMENTOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZACAO DE DESAGIO EM INVESTIMENTOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.0.00.00', 'MULTAS ADMINISTRATIVAS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS, E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO. REPRESENTA O RESULTADO DAS APLICACOES IMPOSTAS AO CONTRIBUINTE FALTOSO, COMO SANCAO LEGAL NO CAMPO TRIBUTARIO (IMPOSTOS, TAXAS E CONTRIBUICAO DE MELHORIA) E NAO-TRIBUTARIO (CONTRIBUICOES SOCIAIS E ECONOMICAS, PATRIMONIAIS, INDUSTRIAIS, SERVICOS E DIVERSAS) E DE NATUREZA ADMINISTRATIVA, POR INFRACOES A REGULAMENTOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.00.00', 'MULTAS ADMINISTRATIVAS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS, E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO. REPRESENTA O RESULTADO DAS APLICACOES IMPOSTAS AO CONTRIBUINTE FALTOSO, COMO SANCAO LEGAL NO CAMPO TRIBUTARIO (IMPOSTOS, TAXAS E CONTRIBUICAO DE MELHORIA) E NAO-TRIBUTARIO (CONTRIBUICOES SOCIAIS E ECONOMICAS, PATRIMONIAIS, INDUSTRIAIS, SERVICOS E DIVERSAS) E DE NATUREZA ADMINISTRATIVA, POR INFRACOES A REGULAMENTOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.13.00', 'MULTAS PREVISTAS NA LEGIS.DEFESA DIR. DIFUSOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE DIREITOS DIFUSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.30.00', 'MULTAS/INDENIZACOES - EXPLORACAO DO PATRIMONIO GENETICO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTE DE MULTAS E INDENIZACOES PELA EXPLORACAO DO PATRIMONIO GENETICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.2.00.00', 'MULTAS ADMINISTRATIVAS - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS, E COM RENDIMENTOS DESTINADOS AINDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO. REPRESENTA O RESULTADO DA APLICACOES IMPOSTAS AO CONTRIBUINTE FALTOSO, COMO SANCAO LEGAL NO CAMPO TRIBUTARIO (IMPOSTOS, TAXAS E CONTRIBUICAO DE MELHORIA) NAO-TRIBUTARIO (CONTRIBUICOES SOCIAIS E ECONOMICAS, PATRIMONIAIS, INDUSTRIAIS, SERVICOS E DIVERSAS) E DE NATUREZA ADMINISTRATIVA, POR INFRACOES A REGULAMENTOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.4.00.00', 'MULTAS ADMINISTRATIVAS - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS, E COM RENDIMENTOS DESTINADOS AINDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO. REPRESENTA O RESULTADO DA APLICACOES IMPOSTAS AO CONTRIBUINTE FALTOSO, COMO SANCAO LEGAL NO CAMPO TRIBUTARIO (IMPOSTOS, TAXAS E CONTRIBUICAO DE MELHORIA) NAO-TRIBUTARIO (CONTRIBUICOES SOCIAIS E ECONOMICAS, PATRIMONIAIS, INDUSTRIAIS, SERVICOS E DIVERSAS) E DE NATUREZA ADMINISTRATIVA, POR INFRACOES A REGULAMENTOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.00.00', 'MULTAS ADMINISTRATIVAS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS, E COM RENDIMENTOS DESTINADOS AINDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO. REPRESENTA O RESULTADO DA APLICACOES IMPOSTAS AO CONTRIBUINTE FALTOSO, COMO SANCAO LEGAL NO CAMPO TRIBUTARIO (IMPOSTOS, TAXAS E CONTRIBUICAO DE MELHORIA) NAO-TRIBUTARIO (CONTRIBUICOES SOCIAIS E ECONOMICAS, PATRIMONIAIS, INDUSTRIAIS, SERVICOS E DIVERSAS) E DE NATUREZA ADMINISTRATIVA, POR INFRACOES A REGULAMENTOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.5.13.00', 'MULTAS PREVISTAS NA LEGIS.DEFESA DIR. DIFUSOS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE DIREITOS DIFUSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.2.00.00', 'INDENIZACOES - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES DIVERSAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.4.00.00', 'INDENIZACOES - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES DIVERSAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.5.00.00', 'INDENIZACOES - INTER OFSS - MUNICIPIO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES DIVERSAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.7.1.00.00', 'VPA DECORRENTE ALIENACAO BENS APREENDIDOS - CONSOLIDACAO', 'COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS AUMENTATIVAS GERADAS PELA ALIENACAO DE MERCADORIAS, OBJETO DA PENA DE PERDIMENTO. O PRODUTO DA ARRECADACAO TEM A SEGUINTE DESTINACAO: 60% AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF E 40% AO FUNDO NACIONAL DE ASSISTENCIA SOCIAL - MINISTERIO DA PREVIDENCIA E ASSISTENCIA SOCIAL. AO FUNDO NACIONAL ANTIDROGA ­ FUNAD, PARA APLICACAO CONFORME LEGISLACAO EM VIGOR, QUANDO DA APREENSAO DE BENS, DIREITOS E VALORES OBJETO DO CRIME DE TRAFICO ILICITO DE SUBSTANCIAS INTORPECENTES OU DROGAS AFINS. (LEI 6368 DE 21/10/76, LEI 7460 DE 19/12/86, LEI 9804 DE 30/06/99) COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.00.00', 'VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDACAO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.01.00', 'VPA DE ONUS SUCUMBENCIA DE ACOES JUDICIAIS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO. O PRODUTO DESTA ARRECADACAO CONSTITUI RECEITA VINCULADA AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO FUNDAF.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.2.00.00', 'VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - INTRA OFSS', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.2.01.00', 'VPA DE ONUS SUCUMBENCIA DE ACOES JUDICIAIS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO. O PRODUTO DESTA ARRECADACAO CONSTITUI RECEITA VINCULADA AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO FUNDAF.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.00.00', 'VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - INTER OFSS - ESTADO', 'COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.4.01.00', 'VPA DE ONUS SUCUMBENCIA DE ACOES JUDICIAIS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO. O PRODUTO DESTA ARRECADACAO CONSTITUI RECEITA VINCULADA AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO FUNDAF.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.5.01.00', 'VPA DE ONUS SUCUMBENCIA DE ACOES JUDICIAIS', 'COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO. O PRODUTO DESTA ARRECADACAO CONSTITUI RECEITA VINCULADA AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO FUNDAF.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.0.0.0.00.00', 'ATOS POTENCIAIS', 'COMPREENDE CONTAS RELACIONADAS AS SITUACOES NAO COMPREENDIDAS NO PATRIMONIO, MAS QUE, DIRETA OU INDIRETAMENTE, POSSAM VIR A AFETA-LO, EXCLUSIVE AS QUE DIZEM RESPEITO A ATOS E FATOS LIGADOS A EXECUCAO ORCAMENTARIA E FINANCEIRA E AS CONTAS COM FUNCAO PRECIPUA DE CONTROLE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.0.0.00.00', 'ATOS POTENCIAIS ATIVOS', 'REGISTRA OS ATOS E FATOS QUE POSSAM VIR A AUMENTAR O ATIVO DA ENTIDADE GOVERNAMENTAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.0.00.00', 'GARANTIAS E CONTRAGARANTIAS RECEBIDAS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.00.00', 'GARANTIAS E CONTRAGARANTIAS RECEBIDAS - CONSOLIDACAO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.00', 'GARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO PAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.00', 'GARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.03.00', 'CONTRAGARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.04.00', 'CONTRAGARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.00.00', 'GARANTIAS E CONTRAGARANTIAS RECEBIDAS - INTRA OFSS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.01.00', 'GARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO PAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.02.00', 'GARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.2.03.00', 'CONTRAGARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.00.00', 'GARANTIAS E CONTRAGARANTIAS RECEBIDAS - INTER OFSS - ESTADO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.02.00', 'GARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.03.00', 'CONTRAGARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.4.04.00', 'CONTRAGARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.00.00', 'GARANTIAS E CONTRAGARANTIAS RECEBIDAS - INTER OFSS - MUNICIPIO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.01.00', 'GARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO PAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.02.00', 'GARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.03.00', 'CONTRAGARANTIAS RECEBIDAS NO PAIS', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.5.04.00', 'CONTRAGARANTIAS RECEBIDAS NO EXTERIOR', 'REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.0.00.00', 'DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE , DOS CONVENIOS FIRMADOS ENTRE ENTIDADES OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.1.00.00', 'DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - CONSOLIDACAO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE , DOS CONVENIOS FIRMADOS ENTRE ENTIDADES OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.1.01.00', 'DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.1.02.00', 'TERMO DE COOPERACAO', 'COMPREENDEO VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.1.03.00', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES- PORTAL / SICONV', 'COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.2.00.00', 'DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - INTRA OFSS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE , DOS CONVENIOS FIRMADOS ENTRE ENTIDADES OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.2.01.00', 'DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.2.02.00', 'TERMO DE COOPERACAO', 'COMPREENDEO VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.2.03.00', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES- PORTAL / SICONV', 'COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.4.00.00', 'DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - INTER OFSS - ESTADO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE , DOS CONVENIOS FIRMADOS ENTRE ENTIDADES OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.4.01.00', 'DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.4.02.00', 'TERMO DE COOPERACAO', 'COMPREENDEO VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.4.03.00', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES- PORTAL / SICONV', 'COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.5.00.00', 'DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - INTER OFSS - MUNICIPIO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE , DOS CONVENIOS FIRMADOS ENTRE ENTIDADES OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.5.01.00', 'DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.5.02.00', 'TERMO DE COOPERACAO', 'COMPREENDEO VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.5.03.00', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES- PORTAL / SICONV', 'COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.00.00', 'DIREITOS CONTRATUAIS - CONSOLIDACAO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.2.00.00', 'DIREITOS CONTRATUAIS - INTRA OFSS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.4.00.00', 'DIREITOS CONTRATUAIS - INTER OFSS - ESTADO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.5.00.00', 'DIREITOS CONTRATUAIS - INTER OFSS - MUNICIPIO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.9.0.00.00', 'OUTROS ATOS POTENCIAIS ATIVOS', 'COMPREENDE OS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.0.0.00.00', 'ATOS POTENCIAIS PASSIVOS', 'REGISTRA OS ATOS E FATOS QUE POSSAM VIR A AUMENTAR O PASSIVO OU DIMINUIR O ATIVO DA ENTIDADE GOVERNAMENTAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.0.00.00', 'GARANTIAS E CONTRAGARANTIAS CONCEDIDAS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.00.00', 'GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - CONSOLIDACAO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.00', 'GARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.00', 'GARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.03.00', 'CONTRAGARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.04.00', 'CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.00.00', 'GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - INTRA OFSS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.01.00', 'GARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.02.00', 'GARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.03.00', 'CONTRAGARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.2.04.00', 'CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.00.00', 'GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - INTER OFSS - ESTADO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.01.00', 'GARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.02.00', 'GARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.4.03.00', 'CONTRAGARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.00.00', 'GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - INTER OFSS - MUNICIPIO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.02.00', 'GARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.03.00', 'CONTRAGARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.5.04.00', 'CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.0.00.00', 'OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.1.00.00', 'OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES - CONSOLIDACAO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.1.01.00', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE OS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.1.02.00', 'CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS', 'COMPREENDE O VALOR DOS CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.1.03.00', 'TRANSFERENCIAS LEGAIS', 'COMPREENDE O VALOR DAS TRANSFERENCIAS LEGAIS ABAIXO ESPECIFICADAS: - TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A AGENCIA NACIONAL DE CINEMA - ANCINE E AS ENTIDADES COM FINS LUCRATIVOS, CUJO OBJETIVO E FOMENTAR PROJETOS VOLTADOS AO DESENVOLVIMENTO DO SETOR AUDIOVISUAL BRASILEIRO (MP 2.228-1/2001 E PARECER 393 - TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO E OS ESTADOS, DF E MUNICIPIOS, CUJO OBJETIVO E PREPARAR JOVEM PARA OCUPACOES COM VINCULO EMPREGATICIO OU PARA OUTRAS ATIVIDADES PRODUTIVAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.1.04.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV', 'COMPREENDE OS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.2.00.00', 'OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES - INTRA OFSS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.2.01.00', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE OS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.2.02.00', 'CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS', 'COMPREENDE O VALOR DOS CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.2.03.00', 'TRANSFERENCIAS LEGAIS', 'COMPREENDE O VALOR DAS TRANSFERENCIAS LEGAIS ABAIXO ESPECIFICADAS: - TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A AGENCIA NACIONAL DE CINEMA - ANCINE E AS ENTIDADES COM FINS LUCRATIVOS, CUJO OBJETIVO E FOMENTAR PROJETOS VOLTADOS AO DESENVOLVIMENTO DO SETOR AUDIOVISUAL BRASILEIRO (MP 2.228-1/2001 E PARECER 393 - TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO E OS ESTADOS, DF E MUNICIPIOS, CUJO OBJETIVO E PREPARAR JOVEM PARA OCUPACOES COM VINCULO EMPREGATICIO OU PARA OUTRAS ATIVIDADES PRODUTIVAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.2.04.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV', 'COMPREENDE OS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.4.00.00', 'OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES - INTER OFSS - ESTADO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.4.01.00', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE OS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.4.02.00', 'CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS', 'COMPREENDE O VALOR DOS CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.4.03.00', 'TRANSFERENCIAS LEGAIS', 'COMPREENDE O VALOR DAS TRANSFERENCIAS LEGAIS ABAIXO ESPECIFICADAS: - TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A AGENCIA NACIONAL DE CINEMA - ANCINE E AS ENTIDADES COM FINS LUCRATIVOS, CUJO OBJETIVO E FOMENTAR PROJETOS VOLTADOS AO DESENVOLVIMENTO DO SETOR AUDIOVISUAL BRASILEIRO (MP 2.228-1/2001 E PARECER 393 - TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO E OS ESTADOS, DF E MUNICIPIOS, CUJO OBJETIVO E PREPARAR JOVEM PARA OCUPACOES COM VINCULO EMPREGATICIO OU PARA OUTRAS ATIVIDADES PRODUTIVAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.4.04.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV', 'COMPREENDE OS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.5.00.00', 'OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES - INTER OFSS - MUNICIPIO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.5.01.00', 'CONVENIOS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE OS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.5.02.00', 'CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS', 'COMPREENDE O VALOR DOS CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.5.03.00', 'TRANSFERENCIAS LEGAIS', 'COMPREENDE O VALOR DAS TRANSFERENCIAS LEGAIS ABAIXO ESPECIFICADAS: - TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A AGENCIA NACIONAL DE CINEMA - ANCINE E AS ENTIDADES COM FINS LUCRATIVOS, CUJO OBJETIVO E FOMENTAR PROJETOS VOLTADOS AO DESENVOLVIMENTO DO SETOR AUDIOVISUAL BRASILEIRO (MP 2.228-1/2001 E PARECER 393 - TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO E OS ESTADOS, DF E MUNICIPIOS, CUJO OBJETIVO E PREPARAR JOVEM PARA OCUPACOES COM VINCULO EMPREGATICIO OU PARA OUTRAS ATIVIDADES PRODUTIVAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.5.04.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV', 'COMPREENDE OS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.0.00.00', 'OBRIGACOES CONTRATUAIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.00.00', 'OBRIGACOES CONTRATUAIS - CONSOLIDACAO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.13.00', 'ACORDO TRANSF.RECURSOS P/ORG. INTERNACIONAIS', 'COMPREENDE OS VALORES DE ACORDOS PARA SAIDA DE RECURSOS FIRMADOS COMORGANISMOS INTERNACIONAIS, CONTROLANDO A EFETIVA UTILIZACAO DOS MESMOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.00.00', 'OBRIGACOES CONTRATUAIS - INTRA OFSS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.2.13.00', 'ACORDO TRANSF.RECURSOS P/ORG. INTERNACIONAIS', 'COMPREENDE OS VALORES DE ACORDOS PARA SAIDA DE RECURSOS FIRMADOS COMORGANISMOS INTERNACIONAIS, CONTROLANDO A EFETIVA UTILIZACAO DOS MESMOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.00.00', 'OBRIGACOES CONTRATUAIS - INTER OFSS - ESTADO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.4.13.00', 'ACORDO TRANSF.RECURSOS P/ORG. INTERNACIONAIS', 'COMPREENDE OS VALORES DE ACORDOS PARA SAIDA DE RECURSOS FIRMADOS COMORGANISMOS INTERNACIONAIS, CONTROLANDO A EFETIVA UTILIZACAO DOS MESMOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.00.00', 'OBRIGACOES CONTRATUAIS - INTER OFSS - MUNICIPIO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.5.13.00', 'ACORDO TRANSF.RECURSOS P/ORG. INTERNACIONAIS', 'COMPREENDE OS VALORES DE ACORDOS PARA SAIDA DE RECURSOS FIRMADOS COMORGANISMOS INTERNACIONAIS, CONTROLANDO A EFETIVA UTILIZACAO DOS MESMOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.9.0.00.00', 'OUTROS ATOS POTENCIAIS PASSIVOS', 'COMPREENDE OS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.0.0.0.00.00', 'ADMINISTRACAO FINANCEIRA', 'COMPREENDE AS CONTAS DE REGISTRO DA PROGRAMACAO FINANCEIRA E DE CONTROLE DAS DISPONIBILIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.0.0.00.00', 'DISPONIBILIDADES POR DESTINACAO', 'COMPREENDE AS CONTAS QUE REGISTRAM OS CONTROLES SOBRE AS DISPONIBILIDADES POR DESTINACAO DE RECURSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.1.0.00.00', 'CONTROLE DA DISPONIBILIDADE DE RECURSOS', 'COMPREENDE AS CONTAS QUE REGISTRAM AS DISPONIBILIDADES DE RECURSOS RECEBIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.2.0.00.00', 'LIMITE DE RESTOS A PAGAR POR DESTINACAO', 'COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.3.0.00.00', 'RECURSO DIFERIDO POR DESTINACAO', 'COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DOS RECURSOS DIFERIDOS. RECURSOS DIFERIDOS SAO AS SOBRAS DE RECURSOS FINANCEIROS AO FINAL DO EXERCICIO (RECURSO DIFERIDO), QUE DEVERIAM SER DEVOLVIDAS A CONTA UNICA, POREM, AO INVES DISSO, ESSAS SOBRAS SAO LIBERADAS PARA USO (APENAS NO EXERCICIO SEGUINTE) ATRAVES DE DESCONTOS DAS TRANSFERENCIAS FINANCEIRAS (COTA, REPASSE E SUB-REPASSE) DO EXERCICIO SEGUINTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.3.1.00.00', 'CONCESSAO DE RECURSO DIFERIDO POR DESTINACAO', 'COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE RECURSOS DIFERIDOS QUE SERAO CONCEDIDOS. RECURSOS DIFERIDOS SAO AS SOBRAS DE RECURSOS FINANCEIROS AO FINAL DO EXERCICIO (RECURSO DIFERIDO), QUE DEVERIAM SER DEVOLVIDAS A CONTA UNICA, POREM, AO INVES DISSO, ESSAS SOBRAS SAO LIBERADAS PARA USO (APENAS NO EXERCICIO SEGUINTE) ATRAVES DE DESCONTOS DAS TRANSFERENCIAS FINANCEIRAS (COTA, REPASSE E SUB-REPASSE) DO EXERCICIO SEGUINTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.3.2.00.00', 'RECEBIMENTO DE RECURSO DIFERIDO POR DESTINACAO', 'COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE RECURSOS DIFERIDOS QUE SERAO RECEBIDOS. RECURSOS DIFERIDOS SAO AS SOBRAS DE RECURSOS FINANCEIROS AO FINAL DO EXERCICIO (RECURSO DIFERIDO), QUE DEVERIAM SER DEVOLVIDAS A CONTA UNICA, POREM, AO INVES DISSO, ESSAS SOBRAS SAO LIBERADAS PARA USO (APENAS NO EXERCICIO SEGUINTE) ATRAVES DE DESCONTOS DAS TRANSFERENCIAS FINANCEIRAS (COTA, REPASSE E SUB-REPASSE) DO EXERCICIO SEGUINTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.1.0.00.00', 'CONCESSAO DE RECURSOS FINANCEIROS', 'COMPREENDE AS CONTAS QUE REGISTRAM A CONCESSAO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.2.0.00.00', 'RECEBIMENTO DE RECURSOS FINANCEIROS', 'COMPREENDE AS CONTAS QUE REGISTRAM O RECEBIMENTO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.0.0.00.00', 'INSCRICAO DO LIMITE ORCAMENTARIO', 'COMPREENDE AS CONTAS QUE CONTROLAM O LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS ORCAMENTARIOS, CONFORME ESTABELECIDOS EM ATO PROPRIO DOS PODERES E MINISTERIO PUBLICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.1.0.00.00', 'CONTROLE DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA', 'COMPREENDE AS CONTAS QUE CONTROLAM O LIMITE ORCAMENTARIO NO OCPF', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.2.0.00.00', 'CONTROLE DAS OUTRAS UNIDADES GESTORAS', 'COMPREENDE AS CONTAS QUE CONTROLAM O LIMITE ORCAMENTARIO NAS OUTRAS UNIDADES GESTORAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.0.0.00.00', 'CONTROLES DA ARRECADACAO', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADACAO COMO DARF, GRU, DAR, ENTRE OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.1.0.00.00', 'CONTROLES DE DARF`S', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DARF.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.1.1.00.00', 'CONTROLES DE DARF`S POR CODIGO DE RECEITA', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADA POR CODIGO DE RECEITA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.1.2.00.00', 'CONTROLES DE DARF`S POR CODIGO DE DESTINACAO PRIMARIA', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.1.3.00.00', 'CONTROLES DE DARF`S POR CODIGO DE DESTINACAO VINCULADA', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADA POR CODIGO DE DESTINACAO VINCULADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.2.0.00.00', 'CONTROLES DE GRU`S', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE GRU.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.2.1.00.00', 'CONTROLES DE GRU`S POR CODIGO DE RECOLHIMENTO', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE GRU, CLASSIFICADA POR CODIGO DE RECOLHIMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.2.2.00.00', 'CONTROLES DE GRU`S POR CODIGO DE DESTINACAO PRIMARIA', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE GRU, CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.2.3.00.00', 'CONTROLES DE GRU`S POR CODIGO DE DESTINACAO SECUNDARIA', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE GRU, CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.3.0.00.00', 'CONTROLES DE DAR''S', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA DE ESTADOS E MUNICIPIOS, RETIDA PELA UG, DE PAGAMENTOS REALIZADOS A EMPRESAS PRESTADORAS DE SERVICOS ENQUADRADAS PELA LC 116.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.0.0.0.00.00', 'DIVIDA ATIVA', 'REGISTRA O CONTROLE DOS CREDITOS A SEREM INSCRITOS EM DIVIDA ATIVA, DOS QUE SE ENCONTRAM EM PROCESSAMENTO. COMPREENDE AS CONTAS QUE CONTROLAM OS CREDITOS PASSIVEIS DE SEREM ENCAMINHADOS E INSCRITOS EM DIVIDA ATIVA O DE INSCRICAO E A TRAMITACAO DOS CREDITOS INSCRITOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.1.0.0.00.00', 'CONTROLE DO ENCAMINHAMENTO DE CREDITOS PARA INSCRICAO EM DIVIDA ATIVA', 'REGISTRA OS VALORES PASSIVEIS DE SEREM ENCAMINHADOS E INSCRITOS EM DIVIDA ATIVA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.2.0.0.00.00', 'CONTROLE DA INSCRICAO DE CREDITOS EM DIVIDA ATIVA', 'COMPREENDE AS CONTAS QUE CONTROLAM OS CREDITOS PASSIVEIS DE SEREM INSCRITOS EM DIVIDA ATIVA PELO ORGAO RESPONSAVEL PELA INSCRICAO EM DIVIDA ATIVA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.0.0.0.00.00', 'RISCOS FISCAIS', 'COMPREENDE AS CONTAS QUE CONTROLAM OS RISCOS FISCAIS QUE NAO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.1.0.0.00.00', 'CONTROLE DE PASSIVOS CONTINGENTES', 'COMPREENDE AS CONTAS QUE REGISTRAM O CONTROLE DOS RISCOS FISCAIS QUE NAO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, CLASSIFICADOS COMO PASSIVOS CONTINGENTES, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.2.0.0.00.00', 'CONTROLE DOS DEMAIS RISCOS FISCAIS', 'COMPREENDE AS CONTAS QUE REGISTRAM OS RISCOS FISCAIS QUE NAO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.0.0.00.00', 'OUTROS CONTROLES DE PROGRAMACAO FINANCEIRA', 'COMPREENDE AS CONTAS QUE CONTROLAM OUTRAS PECULIARIDADES DA PROGRAMACAO FINANCEIRA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.1.0.00.00', 'REMANEJAMENTO DE COTA', 'COMPREENDE AS CONTAS QUE CONTROLAM REMANEJAMENTO DE COTA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.2.0.00.00', 'COTA DE EMPENHO PARA PAGAMENTO CONTRA-ENTREGA', 'COMPREENDE AS CONTAS QUE CONTROLAM COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.2.1.00.00', 'CONCESSAO DE EMPENHO CONTRA-ENTREGA', 'COMPREENDE AS CONTAS QUE REGISTRAM A CONCESSAO DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.2.1.06.00', 'RETENCAO DE TRIBUTOS DE PAGAMENTOS DE EMPENHOS CONTRA-ENTREGA', 'COMPRENDE AS CONTAS QUE REGISTRAM O VALOR DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG 170500, ESSA RETENCAO FEITA POR UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. E UM MERO REFLEXO DA CONTA 7.9.1.2.2.11.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.2.2.06.00', 'RETENCAO DE TRIBUTOS DE PAGAMENTOS DE EMPENHOS CONTRA-ENTREGA', 'COMPRENDE AS CONTAS QUE REGISTRAM O VALOR DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA, ESSA RETENCAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.2.0.0.00.00', 'OUTROS CONTROLES DE DISPONIBILIDADES', 'COMPREENDE AS CONTAS QUE CONTROLAM OUTROS CONTROLES DE DISPONIBILIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.2.1.0.00.00', 'DISPONIBILIDADES DA CONTA UNICA', 'COMPREENDE AS CONTAS QUE CONTROLAM A EMISSAO DE DOCUMENTOS DE ARRECADACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.2.2.0.00.00', 'DISPONIBILIDADES DA CONTA ESPECIAL', 'COMPREENDE AS CONTAS QUE REGISTRAM A MOVIMENTACAO FINANCEIRA VINCULADA AOS EMPRESTIMOS EXTERNOS RECEBIDOS (ANTES DE REGISTRAR NA CONTA UNICA).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.3.0.0.00.00', 'OUTROS CONTROLES DE BENEFICIOS PAGOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O PAGAMENTO DE BENEFICIOS PREVIDENCIARIOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.3.1.0.00.00', 'BENEFICIOS PAGOS PELA REDE BANCARIA', 'COMPREENDE AS CONTAS QUE REGISTRAM OS BENEFICIOS PREVIDENCIARIOS PAGOS DIRETAMENTE PELA REDE BANCARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.3.2.0.00.00', 'BENEFICIOS PAGOS POR EMPRESAS CONVENENTES', 'COMPREENDE AS CONTAS QUE REGISTRAM OS BENEFICIOS PREVIDENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.4.0.0.00.00', 'OUTROS CONTROLES DA CONTA UNICA', 'COMPREENDE AS CONTAS QUE CONTROLAM A CONTA ÚNICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.4.1.0.00.00', 'CONCILIACAO DA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO', 'COMPREENDE AS CONTAS QUE CONTROLAM A CONCILIACAO DA CONTA ÚNICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.4.2.0.00.00', 'CONTROLE DE CAIXA DO TESOURO NACIONAL', 'COMPREENDE AS CONTAS QUE CONTROLAM O SALDO DA CONTA UNICA DO TESOURO NACIONAL', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.0.0.00.00', 'OUTROS CONTROLES DE OPERACOES DE CREDITOS', 'COMPREENDE AS CONTAS QUE CONTROLAM OPERACOES DE CREDITO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.1.0.00.00', 'OPERACOES EM TITULOS', 'COMPREENDE AS CONTAS QUE CONTROLAM OPERACOES DE CREDITO RESULTANTES DE TITULOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.1.1.00.00', 'EMISSOES DE TITULOS', 'COMPREENDE AS CONTAS QUE CONTROLAM OPERACOES DE CREDITO RESULTANTES DE EMISSOES DE TITULOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.2.0.00.00', 'MOVIMENTACAO DE RECEITAS', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES REFERENTES AS MOVIMENTACOES DE RECEITAS PERTENCENTES A OUTRA UNIDADE GESTORA DO MESMO ORGAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.3.0.00.00', 'OPERACOES COM EMPRESTIMOS EXTERNOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O CONTROLE DAS OPERACOES COM EMPRESTIMOS EXTERNOS CUJOS RECURSOS SAO DEPOSITADOS EM CONTA ESPECIAL DO TESOURO NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.4.0.00.00', 'OPERACOES DE CREDITO EXTERNAS', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS LIBERADOS PELA COFIN/STN.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.4.5.00.00', 'CONTROLE DA COMPROVACAO DE VALORES', 'COMPREENDE AS CONTAS QUE CONTROLAM A COMPROVACAO DE VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.6.5.0.00.00', 'OPERACOES DE CREDITO EXTERNAS SEM ANTECIPACAO', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS SEM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL, EXCLUSIVE RECURSOS DE CONTRAPARTIDA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.7.1.0.00.00', 'RESPONSABILIDADES DE TERCEIROS POR VALORES, TITULOS E BENS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.7.2.0.00.00', 'RESPONSABILIDADES COM TERCEIROS POR VALORES, TITULOS E BENS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.0.0.00.00', 'DEMAIS CONTROLES', 'COMPREENDE AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS SUBGRUPOS DESTE GRUPO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.0.00.00', 'CONTROLE DA EXECUCAO FISICA', 'COMPREENDE AS CONTAS REFERENTES AOS DIVERSOS CONTROLES DE EXECUCAO FISICA, COMO: EXECUCAO FISICA DE PROJETOS E EXECUCAO FISICA DO PLANO INTERNO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.00.00', 'CONTROLE DA EXECUCAO FISICA DE PROJETOS', 'COMPREENDE OS INVESTIMENTOS E APLICACAO DE RECURSOS NA INFRAESTRUTURA E BENFEITORIAS EM PROJETOS PUBLICOS DE IRRIGACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.04.00', 'INFRA-ESTRUTURAS SOCIAIS DE USO COMUM', 'COMPREENDE OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO, MELHORAMENTO E MANUTENCAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.05.00', 'BENFEITORIAS INTERNAS NOS LOTES', 'COMPREENDE OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO OU MELHORAMENTO DA PARCELA AGRICOLA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.06.00', 'INFRA-ESTRUTURA EXTERNAS DE APOIO', 'COMPREENDE OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NOSESTUDOS E OBRAS P/IMPLANTACAO DE SISTEMAS DE COMUNICACAO DE PROJETO ESTRADAS EXTERNAS QUE INTERLIGA A MALHA VIARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.08.00', 'OBRAS DE RECUPERACAO', 'COMPREENDE OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS,FORNECIMENTO DE EQUIP.E FISCALIZACAO NA RECUPERACAODE INFRAESTRUTURA DE IRRIGACAO DE USO COMUM, INFRAESTRUTURA SOCIAISDE USO COMUM E BENFEITORIAS NOS LOTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.09.00', 'OBRAS COMPLEMENTARES E DE MELHORAMENTO', 'COMPREENDE OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO PARACOMPLEMENTACAO OU PARA MELHORAMENTO DA INFRAESTRUTURA DE IRRIGACAO DEUSO COMUM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.10.00', 'EMANCIPACAO DE PERIMETROS', 'COMPREENDE OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO E PROJETOS DE PERIMETROS EM EMANCIPACAO E EMANCIPADOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.11.00', 'AGRICULTURA', 'COMPREENDE OS INVESTIMENTOS E APLICACAO DE RECURSOS NAS ATIVIDADES RELACIONADAS A AGRICULTURA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.12.00', 'SERVICOS ESPECIAIS', 'COMPREENDE OS INVESTIMENTOS APLICADOS RELACIONADOS A PROGRAMAS ESPECIAISOU SERVICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.13.00', 'PARTIC. EM OUTRAS ACOES DE DESENV. REGIONAL', 'COMPREENDE OS INVESTIMENTOS APLICADOS RELACIONADOS A PARTICIPACAO EMOUTRAS ACOES DE DESENVOLVIMENTO REGIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.14.00', 'APOIO A PROJ. COMP. NO VALE DE SAO FRANCISCO', 'COMPREENDE OS INVESTIMENTOS APLICADOS RELACIONADOS AO APOIO A PROJETOSCOMPLEMENTARES NO VALE DO SAO FRANCISCO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.15.00', 'OUTROS INVESTIMENTOS PUBLICOS', 'COMPREENDE AS APLICACOES VOLTADAS AOS PROJETOS DE IRRIGACAO, VISANDO ASATIVIDADES DE PLANEJAMENTO, EXECUCAO, ADMINISTRACAO, OPERACAO E MANUTENCAO A FIM DE OBTER UM BOM APROVEITAMENTO DOS RECURSOS DE AGUA ESOLO EM DETERMINADA AREA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.17.00', 'PROJETO BIRD SP - RECURSOS TESOURO', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.18.00', 'PROJETO BIRD BH - RECURSOS TESOURO', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.19.00', 'PROJETO BIRD RECIFE - RECURSOS TESOURO', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EMRECIFE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.20.00', 'PROJETO BIRD SSA - RECURSOS TESOURO', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EMSALVADOR', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.21.00', 'PROJETO BIRD RJ - RECURSOS BIRD', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.22.00', 'PROJETO BIRD SP - RECURSOS BIRD', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.23.00', 'PROJETO BIRD BH - RECURSOS BIRD', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.24.00', 'PROJETO BIRD RECIFE - RECURSOS BIRD', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EMRECIFE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.25.00', 'PROJETO BIRD SALVADOR - RECURSOS BIRD', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EMSALVADOR', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.1.1.26.00', 'PROJETO BIRD RJ - RECURSOS TESOURO', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.0.00.00', 'DEMAIS CONTROLES', 'COMPREENDE AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS TITULOS DESTE SUBGRUPO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.00.00', 'CONTROLE DE BENS E VALORES', 'COMPREENDE AS CONTAS DE CONTROLE DE DIVERSOS BENS E VALORES, POSSIBILITANDO O ACOMPANHAMENTO MAIS DETALHADO DESTES BENS E VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.04.00', 'CONTROLE DE PRECATORIOS PAGOS', 'COMPREENDE OS VALORES RELATIVOS AS DESPESAS COM OS PRECATORIOS PAGOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.08.00', 'CONTROLE ARRECADACAO RECEITAS', 'COMPREENDE OS VALORES RELATIVOS A ARRECADACAO DE RECEITAS, COM CONTACORRENTE CLASSIFICACAO DE RECEITA, PELAS AGENCIAS DE SAUDE E OUTRAS CUJA ARRECADACAO SEJA EFETIVADA NA COFIN/STN E NECESSITE CONTROLE ESPE CIFICO NA UG.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.12.00', 'CONTROLE DISP. DE RECURSOS DA TRANSF. VOLUNT.', 'COMPREENDE, NA CONCEDENTE DA TRANSFERENCIA VOLUNTARIA - TV, OS INGRESSOS E SAIDAS DOS RECURSOS DA TV. A MOVIMENTACAO DOS RECURSOS DA CONTA BANCARIA SOMENTE OCORRERA VIA PORTAL SICONV.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.13.00', 'CONTROLE DE HONORARIOS - ASSIST.JUD.GRATUITA', 'COMPREENDE OS VALORES RELATIVOS AS DESPESAS COM HONORARIOS, EXECUTADASTENDO COMO FIM A ASSISTENCIA JUDICIARIA GRATUITA AS PESSOAS QUE COMPROVEM INSUFICIENCIA DE RECURSOS, DE ACORDO COM ART.5º, INCISOS LXXIV, DA CONSTITUICAO DA REPUBLICA FEDERATIVA DO BRASIL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.17.00', 'CONTROLE CREDITO EMPENHADO LIQUIDADO', 'COMPREENDE OS VALORES REFERENTES A APROPRIACAO DAS DESPESAS EMPENHADASCOM POSTERIOR VERIFICACAO DE SUA REGULARIDADE POR CONSTITUICAO DODIREITO DO CREDOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.19.00', 'CONTROLE DE DIARIAS', 'COMPREENDE O VALOR REFERENTE AO PAGAMENTO DE DIARIAS, POSSIBILITANDO DISTINGUIR NAS SUAS CONTAS DE ESCRITURARACAO, OS VALORES PAGOS A SERVIDORES E OS PAGOS AOS MEMBROS DO RESPECTIVO PODER.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.20.00', 'CONTROLE DE PASSAGENS', 'COMPREENDE O VALOR REFERENTE AO PAGAMENTO DE DIARIAS E ADICIONAL DE DESLOCAMENTO PARA DESTINGUIR NAS SUAS CONTAS DE ESCRITURACAO, OS VALORESPAGOS A SERVIDORES E OS PAGOS AOS MEMBROS DO RESPECTIVO PODER.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.27.00', 'CONTROLE PROGRAMACAO ORCAMENTARIA ANUAL - TV', 'COMPREENDE O ACOMPANHAMENTO COM BASE NO CRONOGRAMA DA PROGRAMACAO ORCAMENTARIA DE TRANSFERENCIAS VOLUNTARIAS COM PRAZO DE VIGENCIA PLURIANUAL', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.30.00', 'CONTROLE PASSIVO FINANCEIRO SEM NE/CELULA', 'COMPREENDE OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO/CELULA DA DESPESA, POREXEMPLO AS SEGUINTES SITUACÓES:OB CANCELADA REFERENTE A PAGAMENTO DE DESPESA DE EXERCICIO ANTERIORDECORRENTE DE FOLHA DE PESSOAL OU OUTRAS DESPESAS; RECOLHIMENTO DE TRIBUTO ESTADUAL EM OB, CUJO EMPENHO REFERESE A SU PRIMENTO DE FUNDOS, NAO PERMITINDO CONTA DIFERENTE DE TIPO "B"; OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLEDE EMPENHO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.31.00', 'CONTROLE DE CUSTOS DE PRODUCAO', 'COMPREENDE O CONTROLE ORCAMENTARIO DE CUSTOS DE PRODUCAO PELA COMPANHIADE PESQUISA DE RECURSOS MINERAIS - CPRM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.1.32.00', 'CAPTACAO DE RECURSOS INCENTIVADOS', 'COMPRRENDE O CONTROLE DE RECURSOS RECEBIDOS DE PESSOAS FISICAS E JURIDICAS A TITULO DE INCENTIVOS DE PROJETOS CULTURAIS NO AMBITO DO MINISTERIO DA CULTURA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.2.00.00', 'BENS E VALORES EM TRANSITO', 'COMPREENDE O MONTANTE DOS BENS E VALORES TRANSFERIDOS ENTRE UGS COM CONTROLE NA CONTA DE COMPENSACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.2.01.00', 'BENS DE ESTOQUE EM TRANSITO', 'COMPREENDE O VALOR DE BENS DE ESTOQUE EM TRANSITO REFERENTE AS TRANSFERENCIAS DO EXERCICIO E DE EXERCICIOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.2.02.00', 'BENS MOVEIS EM TRANSITO', 'COMPREENDE O VALOR DE BENS MOVEIS EM TRANSITO REFERENTE AS TRANSFERENCIAS DO EXERCICIO E DE EXERCICIOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.2.03.00', 'VALORES EM TRANSITO', 'COMPREENDE OS VALORES E TITULOS EM TRANSITO TRANSFERIDOS ENTRE UNIDADES GESTORAS INTEGRANTES DO SIAFI .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.9.9.3.00.00', 'IMPORTACOES EM ANDAMENTO', 'COMPREENDE O VALOR DAS IMPORTACOES DE MATERIAIS E BENS EM CURSO COM CONTROLE NAS CONTAS DE COMPENSACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.0.0.0.0.00.00', 'CONTROLES CREDORES', 'COMPREENDE AS CONTAS EM QUE SAO REGISTRADAS A EXECUCAO DE ATOS POTENCIAIS E CONTROLES ESPECIFICOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.0.0.0.00.00', 'EXECUCAO DOS ATOS POTENCIAIS', 'COMPREENDE CONTAS RELACIONADAS A EXECUCAO DE SITUACOES NAO COMPREENDIDAS NO PATRIMONIO, MAS QUE, DIRETA OU INDIRETAMENTE, POSSAM VIR A AFETA-LO, EXCLUSIVE AS QUE DIZEM RESPEITO A ATOS E FATOS LIGADOS A EXECUCAO ORCAMENTARIA E FINANCEIRA E AS CONTAS COM FUNCAO PRECIPUA DE CONTROLE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.0.0.00.00', 'EXECUCAO DOS ATOS POTENCIAIS ATIVOS', 'REGISTRA A EXECUCAO DOS ATOS E FATOS QUE POSSA VIR A AFETAR O ATIVO DA ENTIDADE GOVERNAMENTAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.0.00.00', 'EXECUCAO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS', 'COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDOS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.00.00', 'EXECUCAO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS - CONSOLIDACAO', 'COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDOS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.00', 'EXECUCAO DE GARANTIAS RECEBIDAS NO PAIS', 'COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEDIDOS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.00', 'EXECUCAO DE GARANTIAS RECEBIDAS NO EXTERIOR', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.00', 'EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO PAIS', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS RECEBIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.00', 'EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.00.00', 'EXECUCAO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS - INTRA OFSS', 'COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDOS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.01.00', 'EXECUCAO DE GARANTIAS RECEBIDAS NO PAIS', 'COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEDIDOS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.02.00', 'EXECUCAO DE GARANTIAS RECEBIDAS NO EXTERIOR', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.03.00', 'EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO PAIS', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS RECEBIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.2.04.00', 'EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.00.00', 'EXECUCAO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS - INTER OFSS - ESTADO', 'COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDOS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.01.00', 'EXECUCAO DE GARANTIAS RECEBIDAS NO PAIS', 'COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEDIDOS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.02.00', 'EXECUCAO DE GARANTIAS RECEBIDAS NO EXTERIOR', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.03.00', 'EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO PAIS', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS RECEBIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.4.04.00', 'EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.00.00', 'EXECUCAO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS - INTER OFSS - MUNICIPIO', 'COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDOS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.02.00', 'EXECUCAO DE GARANTIAS RECEBIDAS NO EXTERIOR', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.03.00', 'EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO PAIS', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS RECEBIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.5.04.00', 'EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.0.00.00', 'EXECUCAO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUCAO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.00.00', 'EXECUCAO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - CONSOLIDACAO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUCAO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.00', 'EXECUCAO DE CONVENIOS E INSTRUMENTOS CONGENERES', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.00', 'TERMO DE COOPERACAO', 'COMPREENDE A EXECUCAO DOS VALORES DE TERMO DE COOPERACAO PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.00.00', 'EXECUCAO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - INTRA OFSS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUCAO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.01.00', 'EXECUCAO DE CONVENIOS E INSTRUMENTOS CONGENERES', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.02.00', 'TERMO DE COOPERACAO', 'COMPREENDE A EXECUCAO DOS VALORES DE TERMO DE COOPERACAO PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.2.03.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.00.00', 'EXECUCAO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - INTER OFSS - ESTADO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUCAO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.01.00', 'EXECUCAO DE CONVENIOS E INSTRUMENTOS CONGENERES', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.02.00', 'TERMO DE COOPERACAO', 'COMPREENDE A EXECUCAO DOS VALORES DE TERMO DE COOPERACAO PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.4.03.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.00.00', 'EXECUCAO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - INTER OFSS - MUNICIPIO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUCAO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.01.00', 'EXECUCAO DE CONVENIOS E INSTRUMENTOS CONGENERES', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.02.00', 'TERMO DE COOPERACAO', 'COMPREENDE A EXECUCAO DOS VALORES DE TERMO DE COOPERACAO PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.5.03.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.0.00.00', 'EXECUCAO DE DIREITOS CONTRATUAIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.01.00', 'CONTRATOS DE SEGUROS', 'COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.02.00', 'CONTRATOS DE SERVICOS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.03.00', 'CONTRATOS DE ALUGUEIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.00', 'CONTRATOS DE OBRIGACOES EXTERNAS', 'COMPREENDE VALORES RELACIONADOA A EXECUCAO DE CONTRATO REFERENTE A OBRIGACOES DA DIVIDA E DAS OPERACOES DE CREDITO EXTERNAS CONTRATADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.08.00', 'TERMOS/ACORDOS DE COOPERACAO S/EXEC. ORCAMEN.', 'REGISTRA O VALOR DE TERMOS E ACORDO DE COOPERACAO SEM EXECUCAO ORCA-MENTARIA EM QUE A ADMINISTRACAO PUBLICA SEJA CONTRATADA DO INSTRUMENTO CONTRATUAL COM TERCEIROS. CADA ENTIDADE DEVERA VERIFICAR A LEGALIDADE PARA SUPORTE DO PROCEDIMENTO ADMINISTRATIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.00.00', 'EXECUCAO DE DIREITOS CONTRATUAIS INTRA OFSS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.01.00', 'CONTRATOS DE SEGUROS', 'COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.02.00', 'CONTRATOS DE SERVICOS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.03.00', 'CONTRATOS DE ALUGUEIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.06.00', 'CONTRATOS DE OBRIGACOES INTERNAS', 'REGISTRA A APROPRIACAO DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.07.00', 'CONTRATOS DE OBRIGACOES EXTERNAS', 'COMPREENDE VALORES RELACIONADOA A EXECUCAO DE CONTRATO REFERENTE A OBRIGACOES DA DIVIDA E DAS OPERACOES DE CREDITO EXTERNAS CONTRATADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.2.08.00', 'TERMOS/ACORDOS DE COOPERACAO S/EXEC. ORCAMEN.', 'REGISTRA O VALOR DE TERMOS E ACORDO DE COOPERACAO SEM EXECUCAO ORCA-MENTARIA EM QUE A ADMINISTRACAO PUBLICA SEJA CONTRATADA DO INSTRUMENTO CONTRATUAL COM TERCEIROS. CADA ENTIDADE DEVERA VERIFICAR A LEGALIDADE PARA SUPORTE DO PROCEDIMENTO ADMINISTRATIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.00.00', 'EXECUCAO DE DIREITOS CONTRATUAIS - INTER OFSS - ESTADO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.01.00', 'CONTRATOS DE SEGUROS', 'COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.02.00', 'CONTRATOS DE SERVICOS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.06.00', 'CONTRATOS DE OBRIGACOES INTERNAS', 'REGISTRA A APROPRIACAO DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.07.00', 'CONTRATOS DE OBRIGACOES EXTERNAS', 'COMPREENDE VALORES RELACIONADOA A EXECUCAO DE CONTRATO REFERENTE A OBRIGACOES DA DIVIDA E DAS OPERACOES DE CREDITO EXTERNAS CONTRATADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.4.08.00', 'TERMOS/ACORDOS DE COOPERACAO S/EXEC. ORCAMEN.', 'REGISTRA O VALOR DE TERMOS E ACORDO DE COOPERACAO SEM EXECUCAO ORCA-MENTARIA EM QUE A ADMINISTRACAO PUBLICA SEJA CONTRATADA DO INSTRUMENTO CONTRATUAL COM TERCEIROS. CADA ENTIDADE DEVERA VERIFICAR A LEGALIDADE PARA SUPORTE DO PROCEDIMENTO ADMINISTRATIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.00.00', 'EXECUCAO DE DIREITOS CONTRATUAIS - INTER OFSS - MUNICIPIO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.01.00', 'CONTRATOS DE SEGUROS', 'COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.02.00', 'CONTRATOS DE SERVICOS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.03.00', 'CONTRATOS DE ALUGUEIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.07.00', 'CONTRATOS DE OBRIGACOES EXTERNAS', 'COMPREENDE VALORES RELACIONADOA A EXECUCAO DE CONTRATO REFERENTE A OBRIGACOES DA DIVIDA E DAS OPERACOES DE CREDITO EXTERNAS CONTRATADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.5.08.00', 'TERMOS/ACORDOS DE COOPERACAO S/EXEC. ORCAMEN.', 'REGISTRA O VALOR DE TERMOS E ACORDO DE COOPERACAO SEM EXECUCAO ORCA-MENTARIA EM QUE A ADMINISTRACAO PUBLICA SEJA CONTRATADA DO INSTRUMENTO CONTRATUAL COM TERCEIROS. CADA ENTIDADE DEVERA VERIFICAR A LEGALIDADE PARA SUPORTE DO PROCEDIMENTO ADMINISTRATIVO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.9.0.00.00', 'EXECUCAO DE OUTROS ATOS POTENCIAIS ATIVOS', 'COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.0.0.00.00', 'EXECUCAO DOS ATOS POTENCIAIS PASSIVOS', 'REGISTRA A EXECUCAO DOS ATOS E FATOS QUE POSSA VIR A AFETAR O PASSIVO DA ENTIDADE GOVERNAMENTAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.0.00.00', 'EXECUCAO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.00.00', 'EXECUCAO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - CONSOLIDACAO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.00', 'EXECUCAO DE GARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.00', 'EXECUCAO DE GARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.00', 'EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.00', 'EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.00.00', 'EXECUCAO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - INTRA OFSS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.01.00', 'EXECUCAO DE GARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.02.00', 'EXECUCAO DE GARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.03.00', 'EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.2.04.00', 'EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.00.00', 'EXECUCAO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - INTER OFSS - ESTADO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.01.00', 'EXECUCAO DE GARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.02.00', 'EXECUCAO DE GARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.03.00', 'EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.4.04.00', 'EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.00.00', 'EXECUCAO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - INTER OFSS - MUNICIPIO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.01.00', 'EXECUCAO DE GARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.02.00', 'EXECUCAO DE GARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.03.00', 'EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO PAIS', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.5.04.00', 'EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR', 'COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.0.00.00', 'EXECUCAO DE OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DA EXECUCAO DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.00.00', 'EXECUCAO DE OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES - CONSOLIDACAO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DA EXECUCAO DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.00', 'EXECUCAO DE CONTRATOS DE REPASSE DE PROGRAMAS ESPECIFICOS', 'COMPREENDE O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.00', 'TRANSFERENCIAS LEGAIS', 'COMPREENDE A EXECUCAO DO VALOR DAS TRANSFERENCIAS LEGAIS ABAIXO ESPECIFICADAS: - TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A AGENCIA NACIONAL DE CINEMA - ANCINE E AS ENTIDADES COM FINS LUCRATIVOS, CUJO OBJETIVO E FOMENTAR PROJETOS VOLTADOS AO DESENVOLVIMENTO DO SETOR AUDIOVISUAL BRASILEIRO (MP 2.228-1/2001 E PARECER 393 - TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO E OS ESTADOS, DF E MUNICIPIOS, CUJO OBJETIVO E PREPARAR JOVEM PARA OCUPACOES COM VINCULO EMPREGATICIO OU PARA OUTRAS ATIVIDADES PRODUTIVAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.04.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.00.00', 'EXECUCAO DE OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES - INTRA OFSS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DA EXECUCAO DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.01.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.02.00', 'EXECUCAO DE CONTRATOS DE REPASSE DE PROGRAMAS ESPECIFICOS', 'COMPREENDE O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.03.00', 'TRANSFERENCIAS LEGAIS', 'COMPREENDE A EXECUCAO DO VALOR DAS TRANSFERENCIAS LEGAIS ABAIXO ESPECIFICADAS: - TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A AGENCIA NACIONAL DE CINEMA - ANCINE E AS ENTIDADES COM FINS LUCRATIVOS, CUJO OBJETIVO E FOMENTAR PROJETOS VOLTADOS AO DESENVOLVIMENTO DO SETOR AUDIOVISUAL BRASILEIRO (MP 2.228-1/2001 E PARECER 393 - TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO E OS ESTADOS, DF E MUNICIPIOS, CUJO OBJETIVO E PREPARAR JOVEM PARA OCUPACOES COM VINCULO EMPREGATICIO OU PARA OUTRAS ATIVIDADES PRODUTIVAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.2.04.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.00.00', 'EXECUCAO DE OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES - INTER OFSS - ESTADO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DA EXECUCAO DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.01.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.02.00', 'EXECUCAO DE CONTRATOS DE REPASSE DE PROGRAMAS ESPECIFICOS', 'COMPREENDE O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.03.00', 'TRANSFERENCIAS LEGAIS', 'COMPREENDE A EXECUCAO DO VALOR DAS TRANSFERENCIAS LEGAIS ABAIXO ESPECIFICADAS: - TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A AGENCIA NACIONAL DE CINEMA - ANCINE E AS ENTIDADES COM FINS LUCRATIVOS, CUJO OBJETIVO E FOMENTAR PROJETOS VOLTADOS AO DESENVOLVIMENTO DO SETOR AUDIOVISUAL BRASILEIRO (MP 2.228-1/2001 E PARECER 393 - TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO E OS ESTADOS, DF E MUNICIPIOS, CUJO OBJETIVO E PREPARAR JOVEM PARA OCUPACOES COM VINCULO EMPREGATICIO OU PARA OUTRAS ATIVIDADES PRODUTIVAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.4.04.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.00.00', 'EXECUCAO DE OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES - INTER OFSS - MUNICIPIO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DA EXECUCAO DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.01.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.02.00', 'EXECUCAO DE CONTRATOS DE REPASSE DE PROGRAMAS ESPECIFICOS', 'COMPREENDE O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.03.00', 'TRANSFERENCIAS LEGAIS', 'COMPREENDE A EXECUCAO DO VALOR DAS TRANSFERENCIAS LEGAIS ABAIXO ESPECIFICADAS: - TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A AGENCIA NACIONAL DE CINEMA - ANCINE E AS ENTIDADES COM FINS LUCRATIVOS, CUJO OBJETIVO E FOMENTAR PROJETOS VOLTADOS AO DESENVOLVIMENTO DO SETOR AUDIOVISUAL BRASILEIRO (MP 2.228-1/2001 E PARECER 393 - TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO E OS ESTADOS, DF E MUNICIPIOS, CUJO OBJETIVO E PREPARAR JOVEM PARA OCUPACOES COM VINCULO EMPREGATICIO OU PARA OUTRAS ATIVIDADES PRODUTIVAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.5.04.00', 'EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV', 'COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.0.00.00', 'EXECUCAO DE OBRIGACOES CONTRATUAIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.00.00', 'EXECUCAO DE OBRIGACOES CONTRATUAIS - CONSOLIDACAO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.01.00', 'CONTRATOS DE SEGUROS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.02.00', 'CONTRATOS DE SERVICOS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.03.00', 'CONTRATOS DE ALUGUEIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.00', 'CONTRATOS DE EMPRESTIMOS DO OOOC', 'COMPREENDE A CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DOS CONTRATOS ASSINADOS, A LIBERAR E LIBERADOS PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO - OOOC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.07.00', 'OPERACOES C/ BENS E SERVICOS NO EXTERIOR COM CONTROLE POR PC OU RC', 'COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORES DAS OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.09.00', 'CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC', 'COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORES DOS CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.10.00', 'CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC', 'COMPREENDE CONTAS RELACIONADOS A EXECUCAO DOS VALORES DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.11.00', 'CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC', 'COMPREENDE CONTAS RELACIONADAS A EXECUCAO DOS VALORES DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.13.00', 'ACORDO TRANSF.RECURSOS P/ORG. INTERNACIONAIS', 'COMPREENDE OS VALORES DE ACORDOS PARA SAIDA DE RECURSOS FIRMADOS COMORGANISMOS INTERNACIONAIS, CONTROLANDO A EFETIVA UTILIZACAO DOS MESMOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.14.00', 'CONTRATOS DE OPERACOES DE CREDITO', 'COMPREENDE A EXECUCAO DAS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.00.00', 'EXECUCAO DE OBRIGACOES CONTRATUAIS - INTRA OFSS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.01.00', 'CONTRATOS DE SEGUROS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.02.00', 'CONTRATOS DE SERVICOS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.03.00', 'CONTRATOS DE ALUGUEIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.06.00', 'CONTRATOS DE EMPRESTIMOS DO OOOC', 'COMPREENDE A CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DOS CONTRATOS ASSINADOS, A LIBERAR E LIBERADOS PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO - OOOC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.07.00', 'OPERACOES C/ BENS E SERVICOS NO EXTERIOR COM CONTROLE POR PC OU RC', 'COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORES DAS OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.08.00', 'CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC', 'COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORESDOS CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.09.00', 'CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC', 'COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORES DOS CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.10.00', 'CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC', 'COMPREENDE CONTAS RELACIONADOS A EXECUCAO DOS VALORES DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.11.00', 'CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC', 'COMPREENDE CONTAS RELACIONADAS A EXECUCAO DOS VALORES DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.13.00', 'ACORDO TRANSF.RECURSOS P/ORG. INTERNACIONAIS', 'COMPREENDE OS VALORES DE ACORDOS PARA SAIDA DE RECURSOS FIRMADOS COMORGANISMOS INTERNACIONAIS, CONTROLANDO A EFETIVA UTILIZACAO DOS MESMOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.2.14.00', 'CONTRATOS DE OPERACOES DE CREDITO', 'COMPREENDE A EXECUCAO DAS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.00.00', 'EXECUCAO DE OBRIGACOES CONTRATUAIS - INTER OFSS - ESTADO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.01.00', 'CONTRATOS DE SEGUROS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.02.00', 'CONTRATOS DE SERVICOS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.03.00', 'CONTRATOS DE ALUGUEIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.06.00', 'CONTRATOS DE EMPRESTIMOS DO OOOC', 'COMPREENDE A CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DOS CONTRATOS ASSINADOS, A LIBERAR E LIBERADOS PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO - OOOC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.07.00', 'OPERACOES C/ BENS E SERVICOS NO EXTERIOR COM CONTROLE POR PC OU RC', 'COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORES DAS OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.08.00', 'CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC', 'COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORESDOS CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.09.00', 'CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC', 'COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORES DOS CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.10.00', 'CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC', 'COMPREENDE CONTAS RELACIONADOS A EXECUCAO DOS VALORES DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.11.00', 'CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC', 'COMPREENDE CONTAS RELACIONADAS A EXECUCAO DOS VALORES DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.4.13.00', 'ACORDO TRANSF.RECURSOS P/ORG. INTERNACIONAIS', 'COMPREENDE OS VALORES DE ACORDOS PARA SAIDA DE RECURSOS FIRMADOS COMORGANISMOS INTERNACIONAIS, CONTROLANDO A EFETIVA UTILIZACAO DOS MESMOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.00.00', 'EXECUCAO DE OBRIGACOES CONTRATUAIS - INTER OFSS - MUNICIPIO', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.01.00', 'CONTRATOS DE SEGUROS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.02.00', 'CONTRATOS DE SERVICOS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.03.00', 'CONTRATOS DE ALUGUEIS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.04.00', 'CONTRATOS DE FORNECIMENTO DE BENS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.05.00', 'CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS', 'COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.06.00', 'CONTRATOS DE EMPRESTIMOS DO OOOC', 'COMPREENDE A CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DOS CONTRATOS ASSINADOS, A LIBERAR E LIBERADOS PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO - OOOC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.07.00', 'OPERACOES C/ BENS E SERVICOS NO EXTERIOR COM CONTROLE POR PC OU RC', 'COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORES DAS OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE ADMINISTRACAO PUBLICA SEJA A CONTRATADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.08.00', 'CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC', 'COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORESDOS CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.09.00', 'CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC', 'COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORES DOS CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.10.00', 'CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC', 'COMPREENDE CONTAS RELACIONADOS A EXECUCAO DOS VALORES DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.11.00', 'CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC', 'COMPREENDE CONTAS RELACIONADAS A EXECUCAO DOS VALORES DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.12.00', 'EXECUCAO DE CONTRATO DE GESTAO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DOS CONTRATOS DE GESTAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.13.00', 'ACORDO TRANSF.RECURSOS P/ORG. INTERNACIONAIS', 'COMPREENDE OS VALORES DE ACORDOS PARA SAIDA DE RECURSOS FIRMADOS COMORGANISMOS INTERNACIONAIS, CONTROLANDO A EFETIVA UTILIZACAO DOS MESMOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.5.14.00', 'CONTRATOS DE OPERACOES DE CREDITO', 'COMPREENDE A EXECUCAO DAS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.9.0.00.00', 'EXECUCAO DE OUTROS ATOS POTENCIAIS PASSIVOS', 'COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.0.0.0.00.00', 'EXECUCAO DA ADMINISTRACAO FINANCEIRA', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA PROGRAMACAO FINANCEIRA E DE CONTROLE DAS DISPONIBILIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.0.0.00.00', 'EXECUCAO DAS DISPONIBILIDADES POR DESTINACAO', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS CONTROLES DAS DISPONIBILIDADES POR DESTINACAO DE RECURSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.0.00.00', 'EXECUCAO DA DISPONIBILIDADE DE RECURSOS', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DAS DISPONIBILIDADES DE RECURSOS A UTILIZAR, COMPROMETIDAS E UTILIZADAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.2.0.00.00', 'EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.2.1.00.00', 'EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR CONCEDIDO POR DESTINACAO', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR CONCEDIDO POR DESTINACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.2.2.00.00', 'EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINACAO', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.0.00.00', 'EXECUCAO DO RECURSO DIFERIDO POR DESTINACAO', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DOS RECURSOS DIFERIDOS. RECURSOS DIFERIDOS SAO AS SOBRAS DE RECURSOS FINANCEIROS AO FINAL DO EXERCICIO (RECURSO DIFERIDO), QUE DEVERIAM SER DEVOLVIDAS A CONTA UNICA, POREM, AO INVES DISSO, ESSAS SOBRAS SAO LIBERADAS PARA USO (APENAS NO EXERCICIO SEGUINTE) ATRAVES DE DESCONTOS DAS TRANSFERENCIAS FINANCEIRAS (COTA, REPASSE E SUB-REPASSE) DO EXERCICIO SEGUINTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.1.00.00', 'EXECUCAO DE CONCESSAO DE RECURSO DIFERIDO POR DESTINACAO', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE RECURSOS DIFERIDOS QUE SERAO CONCEDIDOS. RECURSOS DIFERIDOS SAO AS SOBRAS DE RECURSOS FINANCEIROS AO FINAL DO EXERCICIO (RECURSO DIFERIDO), QUE DEVERIAM SER DEVOLVIDAS A CONTA UNICA, POREM, AO INVES DISSO, ESSAS SOBRAS SAO LIBERADAS PARA USO (APENAS NO EXERCICIO SEGUINTE) ATRAVES DE DESCONTOS DAS TRANSFERENCIAS FINANCEIRAS (COTA, REPASSE E SUB-REPASSE) DO EXERCICIO SEGUINTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.1.01.00', 'EXECUCAO DE COTA DIFERIDA', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE COTAS DIFERIDAS QUE SERAO CONCEDIDAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.1.02.00', 'EXECUCAO DE REPASSE DIFERIDO', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE REPASSES DIFERIDOS QUE SERAO CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.1.03.00', 'EXECUCAO DE SUB-REPASSE DIFERIDO', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE SUB-REPASSES DIFERIDOS QUE SERAO CONCEDIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.2.00.00', 'EXECUCAO DE RECEBIMENTO DE RECURSO DIFERIDO POR DESTINACAO', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE RECURSOS DIFERIDOS QUE SERAO RECEBIDOS. RECURSOS DIFERIDOS SAO AS SOBRAS DE RECURSOS FINANCEIROS AO FINAL DO EXERCICIO (RECURSO DIFERIDO), QUE DEVERIAM SER DEVOLVIDAS A CONTA UNICA, POREM, AO INVES DISSO, ESSAS SOBRAS SAO LIBERADAS PARA USO (APENAS NO EXERCICIO SEGUINTE) ATRAVES DE DESCONTOS DAS TRANSFERENCIAS FINANCEIRAS (COTA, REPASSE E SUB-REPASSE) DO EXERCICIO SEGUINTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.2.01.00', 'EXECUCAO DE COTA DIFERIDA', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE COTAS DIFERIDAS QUE SERAO RECEBIDAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.2.02.00', 'EXECUCAO DE REPASSE DIFERIDO', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE REPASSES DIFERIDOS QUE SERAO RECEBIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.2.03.00', 'EXECUCAO DE SUB-REPASSE DIFERIDO', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE SUB-REPASSES DIFERIDOS QUE SERAO RECEBIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.0.0.00.00', 'EXECUCAO DA PROGRAMACAO FINANCEIRA', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.0.00.00', 'EXECUCAO DE CONCESSAO DE RECURSOS FINANCEIROS', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DAS COTAS, REPASSES E SUB-REPASSES A CONCEDER PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.1.00.00', 'CONCESSAO DE COTAS DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DAS COTAS DECORRENTES DO ORCAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.2.00.00', 'CONCESSAO DE COTAS NAO DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DAS COTAS NAO DECORRENTES DO ORCAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.3.00.00', 'CONCESSAO DE COTAS DE RESTITUICAO DE RECEITAS E DEPOSITOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS RECURSOS LIBERADOS PELA STN PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.3.01.00', 'COTA DE RESTITUICAO', 'COMPREENDE OS VALORES DE COTAS PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.3.03.00', 'COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS', 'COMPREENDE O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS PARA A UNIDADE GESTORA DA CAIXA ECONOMICA FEDERAL (CEF).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.4.00.00', 'CONCESSAO DE REPASSES DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DOS REPASSES DECORRENTES DO ORCAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.5.00.00', 'CONCESSAO DE REPASSES NAO DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DOS REPASSES NAO DECORRENTES DO ORCAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.6.00.00', 'CONCESSAO DE REPASSES DE RESTITUICAO DE RECEITAS E DEPOSITOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS REPASSES CONCEDIDOS PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.6.01.00', 'REPASSE DE RESTITUICAO', 'REGISTRA OS VALORES DE REPASSES PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.6.03.00', 'REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS', 'REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRFE DO INSS PARA A UNIDADE GESTORA DA CAIXA ECONOMICA FEDERAL (CEF).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.7.00.00', 'CONCESSAO DE SUB-REPASSES DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DOS SUB-REPASSES DECORRENTES DO ORCAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.8.00.00', 'CONCESSAO DE SUB-REPASSES NAO DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DOS SUB-REPASSES NAO DECORRENTES DO ORCAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.9.00.00', 'CONCESSAO DE SUB-REPASSES DE RESTITUICAO DE RECEITAS E DEPOSITOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS SUB-REPASSES LIBERADOS PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.9.01.00', 'SUB-REPASSE DE RESTITUICAO', 'REGISTRA OS VALORES DE SUB-REPASSES A SEREM LIBERADOS, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.1.9.03.00', 'SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS', 'REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRFE DO INSS PARA A UNIDADE GESTORA DA CAIXA ECONOMICA FEDERAL (CEF).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.0.00.00', 'EXECUCAO DO RECEBIMENTO DE RECURSOS FINANCEIROS', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DO RECEBIMENTO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.1.00.00', 'RECEBIMENTO DE COTAS DECORRENTES DO ORCAMENTO', 'COMPREENDE O VALOR TOTAL DAS COTAS, RECEBIDAS OU NAO, DECORRENTES DO ORCAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.2.00.00', 'RECEBIMENTO DE COTAS NAO DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA RECEBIMENTO DAS COTAS NAO DECORRENTES DO ORCAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.3.00.00', 'RECEBIMENTO DE COTAS DE RESTITUICAO DE RECEITAS E DEPOSITOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS RECURSOS RECEBIDOS PELA STN PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.3.01.00', 'COTA DE RESTITUICAO', 'COMPREENDE OS VALORES DE COTAS PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.3.03.00', 'COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS', 'COMPREENDE O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS PARA A UNIDADE GESTORA DA CAIXA ECONOMICA FEDERAL (CEF).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.4.00.00', 'RECEBIMENTO DE REPASSES DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA RECEBIMENTO DOS REPASSES DECORRENTES DO ORCAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.5.00.00', 'RECEBIMENTO DE REPASSES NAO DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA RECEBIMENTO DOS REPASSES NAO DECORRENTES DO ORCAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.6.00.00', 'RECEBIMENTO DE REPASSES DE RESTITUICAO DE RECEITAS E DEPOSITOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS REPASSES RECEBIDOS PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.6.03.00', 'REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS', 'REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRFE DO INSS PARA A UNIDADE GESTORA DA CAIXA ECONOMICA FEDERAL (CEF).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.7.00.00', 'RECEBIMENTO DE SUB-REPASSES DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA RECEBIMENTO DOS SUB-REPASSES DECORRENTES DO ORCAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.8.00.00', 'RECEBIMENTO DE SUB-REPASSES NAO DECORRENTES DO ORCAMENTO', 'COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA RECEBIMENTO DOS SUB-REPASSES NAO DECORRENTES DO ORCAMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.9.00.00', 'RECEBIMENTO DE SUB-REPASSES DE RESTITUICAO DE RECEITAS E DEPOSITOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS SUB-REPASSES RECEBIDOS PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.9.01.00', 'SUB-REPASSE DE RESTITUICAO', 'REGISTRA OS VALORES DE SUB-REPASSES A RECEBER, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UGS DA SECRETARIA DA RECEITA FEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.2.9.03.00', 'SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS', 'REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRFE DO INSS PARA A UNIDADE GESTORA DA CAIXA ECONOMICA FEDERAL (CEF).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.0.0.00.00', 'EXECUCAO DO LIMITE ORCAMENTARIO', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DO LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS ORCAMENTARIOS, CONFORME ESTABELECIDOS EM ATO PROPRIO DOS PODERES E MINISTERIO PUBLICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.0.0.00.00', 'CONTROLES DA ARRECADACAO', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADACAO COMO DARF, GRU, DAR, ENTRE OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.0.00.00', 'CONTROLES DE DARF`S', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DARF.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.1.00.00', 'CONTROLES DE DARF`S POR CODIGO DE RECEITA', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.2.00.00', 'CONTROLES DE DARF`S POR CODIGO DE DESTINACAO PRIMARIA', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.1.3.00.00', 'CONTROLES DE DARF`S POR CODIGO DE DESTINACAO VINCULADA', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.0.00.00', 'CONTROLES DE GRU`S', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU (INCLUSIVE SUAS RETIFICACOES).', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.00.00', 'CONTROLES DE GRU`S POR CODIGO DE RECOLHIMENTO', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU (INCLUSIVE SUAS RETIFICACOES), CLASSIFICADAS POR CODIGO DE RECOLHIMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.01.00', 'GRU POR CODIGO DE RECOLHIMENTO', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU, CLASSIFICADAS POR CODIGO DE RECOLHIMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.02.00', 'GRU POR CODIGO DE RECOLHIMENTO - RETIFICACOES', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E QUE POSTERIORMENTE FORAM RETIFICADAS, CLASSIFICADAS POR CODIGO DE RECOLHIMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.1.03.00', 'GRU POR CODIGO DE RECOLHIMENTO - RESTITUICOES', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E QUE POSTERIORMENTE FORAM RESTITUIDAS, CLASSIFICADAS POR CODIGO DE RECOLHIMENTO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.00.00', 'CONTROLES DE GRU`S POR CODIGO DE DESTINACAO PRIMARIA', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU (INCLUSIVE SUAS RETIFICACOES), CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.01.00', 'GRU POR CODIGO DE DESTINACAO PRIMARIA - NORMAIS', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.02.00', 'GRU POR CODIGO DE DESTINACAO PRIMARIA - RETIFICACOES', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E QUE POSTERIORMENTE FORAM RETIFICADAS, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.2.03.00', 'GRU POR CODIGO DE DESTINACAO PRIMARIA - RESTITUICOES', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E QUE POSTERIORMENTE FORAM RESTITUIDAS, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.00.00', 'CONTROLES DE GRU`S POR CODIGO DE DESTINACAO SECUNDARIA', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU (INCLUSIVE SUAS RETIFICACOES), CLASSIFICADAS POR CODIGO DE DESTINACAO SECUNDARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.01.00', 'GRU POR CODIGO DE DESTINACAO SECUNDARIA- NORMAIS', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU, CLASSIFICADAS POR CODIGO DE DESTINACAO SECUNDARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.02.00', 'GRU POR CODIGO DE DESTINACAO SECUNDARIA- RETIFICACÒES', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E QUE POSTERIORMENTE FORAM RETIFICADAS, CLASSIFICADAS POR CODIGO DE DESTINACAO SECUNDARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.2.3.03.00', 'GRU POR CODIGO DE DESTINACAO SECUNDARIA - RESTITUICOES', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E QUE POSTERIORMENTE FORAM RESTITUIDAS, CLASSIFICADAS POR CODIGO DE DESTINACAO SECUNDARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.3.0.00.00', 'CONTROLES DE DAR''S', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA DE ESTADOS E MUNICIPIOS, RETIDA PELA UG, DE PAGAMENTOS REALIZADOS A EMPRESAS PRESTADORAS DE SERVICOS ENQUADRADAS PELA LC 116.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.0.0.0.00.00', 'EXECUCAO DA DIVIDA ATIVA', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DOS CREDITOS PASSIVEIS DE SEREM ENCAMINHADOS E INSCRITOS EM DIVIDA ATIVA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.0.0.00.00', 'EXECUCAO DO ENCAMINHAMENTO DE CREDITOS PARA INSCRICAO EM DIVIDA ATIVA', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES A SEREM ENCAMINHADOS E OS JA ENCAMINHADOS PARA O ORGAO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.0.0.00.00', 'EXECUCAO DA INSCRICAO DE CREDITOS EM DIVIDA ATIVA', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES A SEREM INSCRITOS EM DIVIDA ATIVA PELO ORGAO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.0.0.0.00.00', 'EXECUCAO DOS RISCOS FISCAIS', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DOS RISCOS FISCAIS QUE NAO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.0.0.00.00', 'EXECUCAO DE PASSIVOS CONTINGENTES', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DOS RISCOS FISCAIS QUE NAO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, CLASSIFICADOS COMO PASSIVOS CONTINGENTES, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.2.0.0.00.00', 'EXECUCAO DOS DEMAIS RISCOS FISCAIS', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DOS RISCOS FISCAIS QUE NAO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.8.0.0.0.00.00', 'APURACAO DE CUSTOS', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DOS CUSTOS DOS BENS E SERVICOS PRODUZIDOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.0.0.0.00.00', 'OUTROS CONTROLES', 'COMPREENDE AS CONTAS DE CONTROLES DA EXECUCAO NAO ESPECIFICADOS ANTERIORMENTE NOS GRUPOS DESSA CLASSE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.0.0.00.00', 'EXECUCAO DE OUTROS CONTROLES DE PROGRAMACAO FINANCEIRA', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE OUTRAS PECULIARIDADES DA PROGRAMACAO FINANCEIRA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.1.0.00.00', 'EXECUCAO DE REMANEJAMENTO DE COTA', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE REMANEJAMENTO DE COTA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.1.1.00.00', 'EXECUCAO DE REMANEJAMENTO DE COTA - SETORIAL FINANCEIRA', 'REGISTRA NA SETORIAL FINANCEIRA A EXECUCAO DO REMANEJAMENTO DE COTA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.1.2.00.00', 'EXECUCAO DE REMANEJAMENTO DE COTA - UG BENEFICIADA', 'REGISTRA NA UG BENEFICIADA A EXECUCAO DO REMANEJAMENTO DE COTA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.0.00.00', 'EXECUCAO DE PF DE EMPENHO PARA PAGAMENTO CONTRA-ENTREGA', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.1.00.00', 'EXECUCAO DA CONCESSAO DE PF DE EMPENHO CONTRA-ENTREGA', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DA CONCESSAO DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.1.06.00', 'EXECUCAO DE RETENCAO DE TRIBUTOS PARA RECOLHIMENTO', 'COMPRENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG 170500, ESSA RETENCAO FEITA POR UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. E UM MERO REFLEXO DA CONTA 7.9.1.2.2.11', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.2.00.00', 'EXECUCAO DO RECEBIMENTO DE PF DE EMPENHO CONTRA-ENTREGA', 'COMPREENDE AS CONTAS QUE REGISTRAM O RECEBIMENTO DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.2.06.00', 'EXECUCAO DE RETENCAO DE TRIBUTOS PARA RECOLHIMENTO', 'COMPRENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA, ESSA RETENCAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.0.0.00.00', 'EXECUCAO DE OUTROS CONTROLES DE DISPONIBILIDADES', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE OUTROS CONTROLES DE DISPONIBILIDADES', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.0.00.00', 'EXECUCAO DE DOCUMENTOS DE ARRECADACAO', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA EMISSAO DE DOCUMENTOS DE ARRECADACAO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.1.00.00', 'EXECUCAO DE EMISSAO DE DARF', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA EMISSAO DE DARFS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.2.00.00', 'EXECUCAO DE EMISSAO DE GPS', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA EMISSAO DE GPSS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.3.00.00', 'EXECUCAO DE EMISSAO DE DAR', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA EMISSAO DE DARS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.5.00.00', 'EXECUCAO DE EMISSAO DE GRU', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA EMISSAO DE GRUS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.2.0.00.00', 'EXECUCAO DE DISPONIBILIDADES DA CONTA ESPECIAL', 'COMPREENDE AS CONTAS QUE REGISTRAM A MOVIMENTACAO FINANCEIRA VINCULADA AOS EMPRESTIMOS EXTERNOS RECEBIDOS (ANTES DE REGISTRAR NA CONTA UNICA)', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.0.0.00.00', 'EXECUCAO DE CONTROLES DE BENEFICIOS PAGOS', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DO PAGAMENTO DE BENEFICIOS PREVIDENCIARIOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.1.0.00.00', 'EXECUCAO DE BENEFICIOS PAGOS PELA REDE BANCARIA', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS BENEFICIOS PREVIDENCIARIOS PAGOS DIRETAMENTE PELA REDE BANCARIA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.1.1.00.00', 'EXECUCAO DE BENEFICIOS PAGOS PELA REDE BANCARIA DO EXERCICIO', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS BENEFICIOS PREVIDENCIARIOS PAGOS DIRETAMENTE PELA REDE BANCARIA NO EXERCICIO ATUAL', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.2.0.00.00', 'EXECUCAO DE BENEFICIOS PAGOS POR EMPRESAS CONVENENTES', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS BENEFICIOS PREVIDENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.3.2.1.00.00', 'EXECUCAO DE BENEFICIOS PAGOS POR EMPRESAS CONVENENTES DO EXERCICIO', 'COMPREENDE AS CONTAS QUE REGISTRAM OS BENEFICIOS PREVIDENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.0.0.00.00', 'EXECUCAO DE CONTROLES DA CONTA UNICA', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA CONTA UNICA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.1.0.00.00', 'EXECUCAO DA CONCILIACAO DA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA CONCILIACAO DA CONTA UNICA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.1.1.00.00', 'EXECUCAO DE REMANEJAMENTO DE FONTE DE RECURSOS', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES RELATIVOS AO REMANEJAMENTO DE SALDO NA CONTA DE DISPONIBILIDADE POR FONTE DE RECURSOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.1.3.00.00', 'EXECUCAO DE INCORPORACAO/DESINCORPORACAO SALDOS', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES RELATIVOS A INCORPORACAO OU DESINCORPORACAO DE SALDOS DA DISPONIBILIDADE POR FONTE DE RECURSOSO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.2.0.00.00', 'EXECUCAO DO CONTROLE DE CAIXA DO TESOURO NACIONAL', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DOS INGRESSOS E SAIDAS DA CONTA UNICA DO TESOURO NACIONAL', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.2.1.00.00', 'CONTROLE DA EXECUCAO DE INGRESSOS E SAIDAS DA CONTA UNICA', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DE INGRESSOS E SAIDAS FISCAIS DE CAIXA DA SECRETARIA DO TESOURO NACIONAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMACAO DOTESOURO NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.2.2.00.00', 'CONTROLE DA EXECUCAO DE INGRESSOS E SAIDAS DO INSS', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DE INGRESSOS E SAIDAS DE FINANCIAMENTO PELA SECRETARIA DO TESOURO NACIONAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMACAOFINANCEIRA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.2.3.00.00', 'CONTROLE DA EXECUCAO DE INGRESSOS E SAIDAS DA CONTA ESPECIAL', 'COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DE INGRESSOS E SAIDAS DOS RECURSOS DE EMPRESTIMOS EX-TERNOS DA CONTA ESPECIAL', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.3.0.00.00', 'EXECUCAO DO CONTROLE DE TRANSFERENCIAS ENTRE CONTAS UNICAS (INSS E TESOURO NACIONAL)', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DO VALOR DA TRANSFERENCIA DE LIMITES DA CONTA UNICA DO INSSPARA O TESOURO NACIONAL E VICE-VERSA DENTRO DE UMA UG OU ENTRE UGSDIFERENTES, BEM COMO TRANSFERENCIAS DE LIMITES DA CONTA UNICA ENTREUGS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.4.4.0.00.00', 'EXECUCAO DE CONTROLE DE APLICACAO FINANCEIRA NA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES REFERENTE AO CONTROLE DE FONTE DE RECURSOS NA NA PLICACAO FINANCEIRA NA CTU', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.5.0.0.00.00', 'EXECUCAO DE RA''S', 'COMPREENDEM AS CONTAS QUE CONTROLAM A EXECUCAO DE RA''S', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.5.1.0.00.00', 'EXECUCAO DE RETIFICACAO DE RA''S', 'COMPREENDEM AS CONTAS QUE REGISTRAM AS RETIFICACOES DE RA''S', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.0.0.00.00', 'CONTROLES DE OPERACOES DE CREDITOS', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE OPERACOES DE CREDITO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.1.0.00.00', 'EXECUCAO DE OPERACOES EM TITULOS', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE OPERACOES DE CREDITO RESULTANTES DE TITULOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.1.1.00.00', 'EXECUCAO DE EMISSAO DE TITULOS', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE OPERACOES DE CREDITO RESULTANTES DE EMISSOES DE TITULOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.2.0.00.00', 'EXECUCAO DE MOVIMENTACOES DE RECEITAS', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES REFERENTES AS MOVIMENTACOES DE RECEITAS PERTENCENTES A OUTRA UNIDADE GESTORA DO MESMO ORGAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.3.0.00.00', 'EXECUCAO DE OPERACOES COM EMPRESTIMOS EXTERNOS', 'COMPREENDE AS CONTAS QUE REGISTRAM O CONTROLE DA EXECUCAO DAS OPERACOES COM EMPRESTIMOS EXTERNOS CUJOS RECURSOS SAO DEPOSITADOS EM CONTA ESPECIAL DO TESOURO NACIONAL', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.3.1.00.00', 'EXECUCAO DE ADIANTAMENTOS', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES DOS ADIANTAMENTOS DE RECURSOS DA CONTA UNICA PARA A UNIDADE GESTORA CONTRATANTE DE EMPRESTIMO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.3.1.01.00', 'ADIANTAMENTOS A COMPROVAR', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS ADIANTAMENTOS DE RECURSOS DA CONTA UNICA PARA A UNIDADE GESTORA CONTRATANTE DE EMPRESTIMO PENDENTE DE COMPROVACAO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.3.1.02.00', 'ADIANTAMENTOS COMPROVADOS', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS ADIANTAMENTOS DE RECURSOS DA CONTA UNICA PARA A UNIDADE GESTORA CONTRATANTE DE EMPRESTIMO CUJA UTILIZACAO FOI COM- PROVADA PELA UG.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.3.2.00.00', 'EXECUCAO DE REEMBOLSOS/RESSARCIMENTOS', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DA SOCILITACAO DE REEMBOLSOS/RESSARCIMENTOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.0.00.00', 'EXECUCAO DE OPERACOES DE CREDITO EXTERNAS', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EXTERNAS LIBERADOS PELA COFIN/STN', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.00.00', 'EXECUCAO DE OPERACOES DE CREDITO EXTERNAS CONCEDIDAS', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS CONCEDIDAS LIBERADOS PELA COFIN/STN', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.01.00', 'OPERACOES DE CREDITO EXTERNAS CONCEDIDAS A EXECUTAR', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS LIBERADOS PELA COFIN/STN, PENDENTES DE EXECUCAO (PAGAMENTO) PELAS UNIDADES GESTORAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.02.00', 'OPERACOES DE CREDITO EXTERNAS CONCEDIDAS EXECUTADAS', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.03.00', 'OPERACOES DE CREDITO EXTERNAS CONCEDIDAS EXECUTADAS - ND DET. - TAXA SAQUE', 'COMPREENDE OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO A TAXA DO SAQUE E ESPECIFICADOS PELA NATUREZA DE DESPESA DETALHADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.04.00', 'OPERACOES DE CREDITO EXTERNAS CONCEDIDAS EXECUTADAS - POR CREDOR- TAXA SAQUE', 'COMPREENDE OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO A TAXA DE SAQUE E ESPECIFICADOS POR CREDOR, NUMERO DA OBRIGACAO E PLANO INTERNO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.05.00', 'OPERACOES DE CREDITO EXTERNAS CONCEDIDAS EXECUTADAS - ND DET. - TAXA PTAX', 'COMPREENDE OS VALORES ORIUNDOS DE RECURSOS EXTERNOS E DE CONTRAPARTIDA LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO A TAXA DE CAMBIO PTAX E ESPECIFICADOS PELA NATUREZA DE DESPESA DETALHADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.1.06.00', 'OPERACOES DE CREDITO EXTERNAS CONCEDIDAS EXECUTADAS - POR CREDOR - TAXA PTAX', 'COMPREENDE OS VALORES ORIUNDOS DE RECURSOS EXTERNOS E DE CONTRAPARTIDA LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO A TAXA DE CAMBIO PTAX E ESPECIFICADOS POR CREDOR, NUMERO DA OBRIGACAO E PLANO INTERNO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.00.00', 'EXECUCAO DE OPERACOES DE CREDITO EXTERNAS RECEBIDAS', 'COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EXTERNAS RECEBIDAS LIBERADOS PELA COFIN/STN.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.01.00', 'OPERACOES DE CREDITO EXTERNAS RECEBIDAS A EXECUTAR', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS LIBERADOS PELA COFIN/STN, PENDENTES DE EXECUCAO (PAGAMENTO) PE-LAS UNIDADES GESTORAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.02.00', 'OPERACOES DE CREDITO EXTERNAS RECEBIDAS EXECUTADAS', 'COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADESGESTORAS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.03.00', 'OPERACOES DE CREDITO EXTERNAS RECEBIDAS EXECUTADAS - ND DET. - TAXA SAQUE', 'COMPREENDE OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO A TAXA DO SAQUE E ESPECIFICADOS PELA NATUREZA DE DESPESA DETALHADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.04.00', 'OPERACOES DE CREDITO EXTERNAS RECEBIDAS EXECUTADAS - POR CREDOR- TAXA SAQUE', 'COMPREENDE OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO A TAXA DE SAQUE E ESPECIFICADOS POR CREDOR, NUMERO DA OBRIGACAO E PLANO INTERNO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.05.00', 'OPERACOES DE CREDITO EXTERNAS RECEBIDAS EXECUTADAS - ND DET. - TAXA PTAX', 'COMPREENDE OS VALORES ORIUNDOS DE RECURSOS EXTERNOS E DE CONTRAPARTIDA LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO A TAXA DE CAMBIO PTAX E ESPECIFICADOS PELA NATUREZA DE DESPESA DETALHADA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.2.06.00', 'OPERACOES DE CREDITO EXTERNAS RECEBIDAS EXECUTADAS - POR CREDOR - TAXA PTAX', 'COMPREENDE OS VALORES ORIUNDOS DE RECURSOS EXTERNOS E DE CONTRAPARTIDA LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS, REGISTRADOS NA MOEDA DO PROJETO UTILIZANDO A TAXA DE CAMBIO PTAX E ESPECIFICADOS POR CREDOR, NUMERO DA OBRIGACAO E PLANO INTERNO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.00.00', 'CONTROLE DA EXECUCAO DA COMPROVACAO DE VALORES', 'COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA COMPROVACAO DE VALORES', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.01.00', 'CONTROLE DA EXECUCAO DA COMPROVACAO DE VALORES REALIZADOS PELA COFIN', 'COMPREENDE AS CONTAS QUE REGISTRAM NA COFIN OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.02.00', 'CONTROLE DA EXECUCAO DA COMPROVACAO DE VALORES REALIZADOS PELA UG', 'COMPREENDE AS CONTAS QUE REGISTRAM NA UG OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.03.00', 'CONTROLE DA EXECUCAO DA COMPROVACAO DE VALORES REALIZADOS PELA COFIN - TAXA SAQUE', 'COMPREENDE OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E A COMPROVAR A SEREM REGISTRADOS EM MOEDA ESTRANGEIRA UTILIZANDO A TAXA DE SAQUE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.04.00', 'CONTROLE DA EXECUCAO DA COMPROVACAO DE VALORES REALIZADOS PELA COFIN - TAXA PTAX', 'COMPREENDE OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E A COMPROVAR A SEREM REGISTRADOS EM MOEDA ESTRANGEIRA UTILIZANDO A TAXA PTAX.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.05.00', 'CONTROLE DA EXECUCAO DA COMPROVACAO DE VALORES REALIZADOS PELA UG - TAXA SAQUE', 'COMPREENDE OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E A COMPROVAR A SEREM REGISTRADOS EM MOEDA ESTRANGEIRA UTILIZANDO A TAXA DE SAQUE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.5.06.00', 'CONTROLE DA EXECUCAO DA COMPROVACAO DE VALORES REALIZADOS PELA UG - TAXA PTAX', 'COMPREENDE OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E A COMPROVAR A SEREM REGISTRADOS EM MOEDA ESTRANGEIRA UTILIZANDO A TAXA PTAX.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.4.6.00.00', 'CONTROLE DA LIBERACAO DE VALORES NA MOEDA DO PROJETO', 'COMPREENDE AS CONTAS QUE CONTROLAM A LIBERACAO DE VALORES NA MOEDA DO PROJETO', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.0.00.00', 'EXECUCAO DE OPERACOES DE CREDITO EXTERNAS SEM ANTECIPACAO', 'COMPREEDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS SEM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL, EXCLUSIVE RECURSOS DE CONTRAPARTIDA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.00.00', 'EXECUCAO DO CONTROLE NA COFIN DE OPERACOES DE CREDITO EXTERNAS SEM ANTECIPACAO', 'COMPREENDE NA COFIN A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS SEM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL, EXCLUSIVE RECURSOS DE CONTRAPARTIDA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.17.00', 'OP.CRED.EXT.RECEB. COMPROVADOS-TAXA PTAX', 'COMPREENDE O VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS, REGISTRADOS NA MOEDA DO PROJETO EXTERNO, UTILIZANDO A TAXA DE CAMBIO PTAX.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.1.19.00', 'OP.CRED.EXT.VALORES GLOSADOS - TAXA PTAX', 'COMPREENDE OS VALORES DE RECURSOS EXTERNOS GLOSADOS PELOS CREDORES EXTERNOS NO ATO DA COMPROVACAO DOS DISPENDIOS EM MOEDA ESTRANGEIRA, UTILIZANDO A TAXA PTAX.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.00.00', 'EXECUCAO DO CONTROLE NA UG DE OPERACOES DE CREDITO EXTERNAS SEM ANTECIPACAO', 'COMPREENDE NA UNIDADE GESTORA A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS SEM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL, EXCLUSIVE RECURSOS DE CONTRAPARTIDA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.17.00', 'OP.CRED.EXT.RECEB. COMPROVADOS-TAXA PTAX', 'COMPREENDE O VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS, REGISTRADOS NA MOEDA DO PROJETO EXTERNO, UTILIZANDO A TAXA DE CAMBIO PTAX.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.6.5.2.19.00', 'OP.CRED.EXT.VALORES GLOSADOS - TAXA PTAX', 'COMPREENDE OS VALORES DE RECURSOS EXTERNOS GLOSADOS PELOS CREDORES EXTERNOS NO ATO DA COMPROVACAO DOS DISPENDIOS EM MOEDA ESTRANGEIRA, UTILIZANDO A TAXA PTAX.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.0.0.00.00', 'OUTROS CONTROLES DE RESPONSABILIDADES POR VALORES, TITULOS E BENS', 'COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DAS RESPONSABILIDADES POR VALORES, TITULOS E BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.0.00.00', 'EXECUCAO DE RESPONSABILIDADES DE TERCEIROS POR VALORES, TITULOS E BENS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.00.00', 'RESPONSABILIDADES DE TERCEIROS', 'COMPREENDE A RESPONSABILIDADE DE TERCEIROS POR TITULOS, VALORES E BENS CONCEDIDOS PELA UNIDADE GESTORA QUE EFETUA O REGISTRO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.1.1.16.00', 'IMOVEIS DE INTERESSE DA UNIAO', 'REGISTRA O CONTROLE DE IMOVEIS DE TERCEIROS QUE ESTAO SENDO ADMINISTRADOS PELA ENTIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.0.00.00', 'EXECUCAO DE RESPONSABILIDADES COM TERCEIROS POR VALORES, TITULOS E BENS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.00.00', 'EXECUCAO DE RESPONSABILIDADES COM TERCEIROS', 'COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.2.1.24.00', 'IMOVEIS DE INTERESSE DA UNIAO', 'REGISTRA O CONTROLE DE IMOVEIS DE TERCEIROS QUE ESTAO EM FASE DE RE-GULARIZACAO/REGISTRO EM NOME DA UNIAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.0.00.00', 'DIVERSOS RESPONSAVEIS EM APURACAO', 'REGISTRA AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUIZOS PARA A FAZENDA NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.7.3.1.00.00', 'DIVERSOS RESPONSAVEIS EM APURACAO', 'REGISTRA AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUIZOS PARA A FAZENDA NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.0.0.00.00', 'DEMAIS CONTROLES', 'COMPREENDE AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS SUBGRUPOS DESTE GRUPO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.0.00.00', 'EXECUCAO CONTROLE DA EXECUCAO FISICA', 'COMPREENDE AS CONTAS REFERENTES A EXECUCAO DOS DIVERSOS CONTROLES DE EXECUCAO FISICA, COMO: EXECUCAO FISICA DE PROJETOS E EXECUCAO FISICA DO PLANO INTERNO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.00.00', 'EXECUCAO FISICA DE PROJETOS', 'COMPREENDE OS INVESTIMENTOS E APLICACAO DE RECURSOS NA INFRAESTRUTURA E BENFEITORIAS EM PROJETOS PUBLICOS DE IRRIGACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.03.00', 'INFRA-ESTRUT.DE IRRIGACAO/USO COMUM INTERNA', 'COMPREENDE OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.04.00', 'INFRA-ESTRUTURAS SOCIAIS DE USO COMUM', 'COMPREENDE OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO, MELHORAMENTO E MANUTENCAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.05.00', 'BENFEITORIAS INTERNAS NOS LOTES', 'COMPREENDE OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO NA IMPLANTACAO OU MELHORAMENTO DA PARCELA AGRICOLA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.06.00', 'INFRA-ESTRUTURA EXTERNAS DE APOIO', 'COMPREENDE OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NOSESTUDOS E OBRAS P/IMPLANTACAO DE SISTEMAS DE COMUNICACAO DE PROJETO ESTRADAS EXTERNAS QUE INTERLIGA A MALHA VIARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.08.00', 'OBRAS DE RECUPERACAO', 'COMPREENDE OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS,FORNECIMENTO DE EQUIP.E FISCALIZACAO NA RECUPERACAODE INFRAESTRUTURA DE IRRIGACAO DE USO COMUM, INFRAESTRUTURA SOCIAISDE USO COMUM E BENFEITORIAS NOS LOTES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.09.00', 'OBRAS COMPLEMENTARES E DE MELHORAMENTO', 'COMPREENDE OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO NAEXECUCAO DE OBRAS, FORNECIMENTO DE EQUIPAMENTOS E FISCALIZACAO PARACOMPLEMENTACAO OU PARA MELHORAMENTO DA INFRAESTRUTURA DE IRRIGACAO DEUSO COMUM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.10.00', 'EMANCIPACAO DE PERIMETROS', 'COMPREENDE OS RECURSOS APLICADOS EM PROJETOS PUBLICOS DE IRRIGACAO E PROJETOS DE PERIMETROS EM EMANCIPACAO E EMANCIPADOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.11.00', 'AGRICULTURA', 'COMPREENDE OS INVESTIMENTOS E APLICACAO DE RECURSOS NAS ATIVIDADES RELACIONADAS A AGRICULTURA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.12.00', 'SERVICOS ESPECIAIS', 'COMPREENDE OS INVESTIMENTOS APLICADOS RELACIONADOS A PROGRAMAS ESPECIAISOU SERVICOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.13.00', 'PARTIC. EM OUTRAS ACOES DE DESENV. REGIONAL', 'COMPREENDE OS INVESTIMENTOS APLICADOS RELACIONADOS A PARTICIPACAO EMOUTRAS ACOES DE DESENVOLVIMENTO REGIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.14.00', 'APOIO A PROJ. COMP. NO VALE DE SAO FRANCISCO', 'COMPREENDE OS INVESTIMENTOS APLICADOS RELACIONADOS AO APOIO A PROJETOSCOMPLEMENTARES NO VALE DO SAO FRANCISCO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.15.00', 'OUTROS INVESTIMENTOS PUBLICOS', 'COMPREENDE AS APLICACOES VOLTADAS AOS PROJETOS DE IRRIGACAO, VISANDO ASATIVIDADES DE PLANEJAMENTO, EXECUCAO, ADMINISTRACAO, OPERACAO E MANUTENCAO A FIM DE OBTER UM BOM APROVEITAMENTO DOS RECURSOS DE AGUA ESOLO EM DETERMINADA AREA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.17.00', 'PROJETO BIRD SP - RECURSOS TESOURO', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.18.00', 'PROJETO BIRD BH - RECURSOS TESOURO', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.19.00', 'PROJETO BIRD RECIFE - RECURSOS TESOURO', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EMRECIFE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.20.00', 'PROJETO BIRD SSA - RECURSOS TESOURO', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EMSALVADOR', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.21.00', 'PROJETO BIRD RJ - RECURSOS BIRD', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.22.00', 'PROJETO BIRD SP - RECURSOS BIRD', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM SAOPAULO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.23.00', 'PROJETO BIRD BH - RECURSOS BIRD', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EM BELOHORIZONTE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.24.00', 'PROJETO BIRD RECIFE - RECURSOS BIRD', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EMRECIFE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.25.00', 'PROJETO BIRD SALVADOR - RECURSOS BIRD', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU EMSALVADOR', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.1.26.00', 'PROJETO BIRD RJ - RECURSOS TESOURO', 'COMPREENDE O CONTROLE DA EXECUCAO DE PROJETO DO BIRD PELA CBTU NO RIO DEJANEIRO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.00.00', 'EXECUCAO FISICA DO PLANO INTERNO - CONCESSAO', 'COMPREENDE O CONTROLE DA EXECUCAO FISICA DO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.02.00', 'LIMITES EXECUTADOS NO EXERCICIO', 'COMPREENDE O VALOR DOS LIMITES EXECUTADOS NO EXERCICIO RELATIVO AO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.03.00', 'LIMITES EXECUTADOS EM EXERCICIOS ANTERIORES.', 'COMPREENDE O VALOR DOS LIMITES EXECUTADOS EM EXERCICIOS ANTERIORES RELATIVOS AO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.2.04.00', 'LIMITES COMPROMISSADOS EXTER.EXERC.ANTERIORES', 'COMPREENDE O VALOR DOS LIMITES COMPROMISSADOS NO EXTERIOR RELATIVO AEXERCICIOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.00.00', 'EXECUCAO FISICA DO PLANO INTERNO - RECEBIMENTO', 'COMPREENDER O CONTROLE DA EXECUCAO FISICA DO PLANO INTERNO ESCRITURAL DOMINISTERIO DA MARINHA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.01.00', 'LIMITES AUTORIZADOS', 'COMPREENDE O VALOR DOS LIMITES AUTORIZADOS NA EXECUCAO DO PLANO INTERNOESCRITURAL DO MINISTERIO DA MARINHA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.02.00', 'LIMITES EXECUTADOS NO EXERCICIO', 'COMPREENDE O VALOR DOS LIMITES EXECUTADOS NO EXERCICIO RELATIVO AO PLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.03.00', 'LIMITES EXECUTADOS RELATIVOS EXERCIC.ANTERIOR', 'COMPREENDE O VALOR DOS LIMITES EXECUTADOS DO RELATIVO AO EXERCICIO ANTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.04.00', 'FORNECIMENTO DE BENS E SERVICOS NO EXERCICIO', 'COMPREENDE O VALOR DO FORNECIMENTO DE BENS E SERVICOS NO EXERCICIO NAEXECUCAO DOPLANO INTERNO ESCRITURAL DO MINISTERIO DA MARINHA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.05.00', 'FORNECIMENTO DE BENS E SERV.- EXERC. ANTERIOR', 'COMPREENDE O VALOR DO FORNECIMENTO DE BENS E SERVICOS NA EXECUCAO FISICADO PLANO INTERNO DO MINISTERIO DA MARINHA, RELATIVO AO EXERCICIO ANTERIOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.06.00', 'LIMITES COMPROMISSADOS EXTERIOR EX.ANTERIORES', 'COMPREENDE O VALOR DOS LIMITES COMPROMISSADOS NO EXTERIOR RELATIVO AEXERCICIOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.1.3.07.00', 'SOLIC.EXTER.A REALIZAR RELATIVA EX.ANTERIORES', 'COMPREENDE O VALOR DE FORNECIMENTO DE BENS E SERVICOS SOLICITADAS NO EXTEIOR A REALIZAR DA EXECUCAO FISICA DO PLANO INTERNO DO MINISTERIO DAMARINHA, RELATIVAS A EXERCICIOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.0.00.00', 'DEMAIS CONTROLES', 'COMPREENDE AS CONTAS REFERENTES AOS DEMAIS CONTROLES NAO ESPECIFICADOS NOS TITULOS DESTE SUBGRUPO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.00.00', 'EXECUCAO DO CONTROLE DE BENS E VALORES', 'COMPREENDE AS CONTAS DE CONTROLE DE DIVERSOS BENS E VALORES, POSSIBILITANDO O ACOMPANHAMENTO MAIS DETALHADO DESTES BENS E VALORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.04.00', 'CONTROLE DE PRECATORIOS PAGOS', 'COMPREENDE OS VALORES RELATIVOS AS DESPESAS COM OS PRECATORIOS PAGOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.06.00', 'EXECUCAO DO CONTROLE DE EMISSAO DE TITULO DIVIDA EXTERNA', 'COMPREENDE OS VALORES RELATIVOS A EMISSAO DE TITULOS DA DIVIDA NO MERCADO INTERNACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.08.00', 'CONTROLE ARRECADACAO RECEITAS', 'COMPREENDE OS VALORES RELATIVOS A ARRECADACAO DE RECEITAS, COM CONTACORRENTE CLASSIFICACAO DE RECEITA, PELAS AGENCIAS DE SAUDE E OUTRAS CUJA ARRECADACAO SEJA EFETIVADA NA COFIN/STN E NECESSITE CONTROLE ESPE CIFICO NA UG.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.10.00', 'EXECUCAO DO CONTROLE DE EMPRESTIMOS E FINANCIAMENTOS', 'COMPREENDE A APROPRIACAO DE VALORES REPASSADOS A AGENTES FINANCEIROS PARA CONTRATACAO DE EMPRESTIMOS E FINANCIAMENTOS', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.11.00', 'EXECUCAO DO CONTROLE DE PAGTOS SUPRIMENTO DE FUNDOS', 'COMPREENDE OS PAGAMENTOS DE VALORES REFERENTE AS DESPESAS EFETUADAS ATRAVES DE SAQUE OU FATURA COM USO DO CARTAO DE PAGAMENTO DO GOVERNOFEDERAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.13.00', 'CONTROLE DE HONORARIOS - ASSIST.JUD.GRATUITA', 'COMPREENDE OS VALORES RELATIVOS AS DESPESAS COM HONORARIOS, EXECUTADASTENDO COMO FIM A ASSISTENCIA JUDICIARIA GRATUITA AS PESSOAS QUE COMPROVEM INSUFICIENCIA DE RECURSOS, DE ACORDO COM ART.5º, INCISOS LXXIV, DA CONSTITUICAO DA REPUBLICA FEDERATIVA DO BRASIL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.17.00', 'CONTROLE CREDITO EMPENHADO LIQUIDADO', 'COMPREENDE OS VALORES REFERENTES A APROPRIACAO DAS DESPESAS EMPENHADASCOM POSTERIOR VERIFICACAO DE SUA REGULARIDADE POR CONSTITUICAO DODIREITO DO CREDOR.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.19.00', 'CONTROLE DE DIARIAS', 'COMPREENDE O VALOR REFERENTE AO PAGAMENTO DE DIARIAS, POSSIBILITANDO DISTINGUIR NAS SUAS CONTAS DE ESCRITURARACAO, OS VALORES PAGOS A SERVIDORES E OS PAGOS AOS MEMBROS DO RESPECTIVO PODER.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.20.00', 'CONTROLE DE PASSAGENS', 'COMPREENDE O VALOR REFERENTE AO PAGAMENTO DE DIARIAS E ADICIONAL DE DESLOCAMENTO PARA DESTINGUIR NAS SUAS CONTAS DE ESCRITURACAO, OS VALORESPAGOS A SERVIDORES E OS PAGOS AOS MEMBROS DO RESPECTIVO PODER.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.21.00', 'CONTROLE DE VALORES (NR.REF.DA GRU)', 'COMPREENDE OS VALORES RELATIVOS AOS CONTROLES POR NUMERO DE REFERENCIADA GRU.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.22.00', 'EXECUCAO DO CONTROLE DE EMISSAO DE TITULOS-DIVIDA INTERNA', 'COMPREENDE O VALOR REFERENTE EMISSOES DE TITULOS DA DIVIDA PUBLICA MOBILIARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.23.00', 'EXECUCAO DO CONTROLE DE EMISSAO DE TITULOS - TDA', 'COMPREENDE O VALOR REFERENTE EMISSOES DE TITULOS DA DIVIDA PUBLICA AGRARIA INTERNA DE RESPONSABILIDADE DO TESOURO NACIONAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.24.00', 'EXECUCAO DO CONTROLE DE REGISTRO P/INTEG.SPIUNET', 'COMPREENDE OS VALORES DO CONTROLE DE REGISTRO POR INTEGRACAO COM SPIUNET NAS CONTAS DE BENS IMOVEIS DE USO ESPECIAL.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.26.00', 'EXECUCAO DO CONTROLE DE CREDITO DE PRECATORIOS EM TRANSITO', 'COMPREENDE OS VALORES EM TRANSITO REFERENTE CREDITO DE PRECATORIOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.27.00', 'CONTROLE PROGRAMACAO ORCAMENTARIA ANUAL - TV', 'COMPREENDE O ACOMPANHAMENTO COM BASE NO CRONOGRAMA DA PROGRAMACAO ORCAMENTARIA DE TRANSFERENCIAS VOLUNTARIAS COM PRAZO DE VIGENCIA PLURIANUAL', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.30.00', 'CONTROLE PASSIVO FINANCEIRO SEM NE/CELULA', 'COMPREENDE OS VALORES DE PASSIVOS FINANCEIROS QUE NAO POSSUEM CORRESPONDENTE CONTA DE COMPENSADO POR NOTA DE EMPENHO/CELULA DA DESPESA, POR EXEMPLO AS SEGUINTES SITUACÓES:OB CANCELADA REFERENTE A PAGAMENTO DE DESPESA DE EXERCICIO ANTERIORDECORRENTE DE FOLHA DE PESSOAL OU OUTRAS DESPESAS; RECOLHIMENTO DE TRIBUTO ESTADUAL EM OB, CUJO EMPENHO REFERESE A SUPRIMENTO DE FUNDOS, NAO PERMITINDO CONTA DIFERENTE DE TIPO "B"; OBRIGACOES A PAGAR REFERENTES A EXERCICIOS ANTERIORES SEM O CONTROLEDE EMPENHO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.31.00', 'EXECUCAO DO CONTROLE DE CUSTOS DE PRODUCAO', 'COMPREENDE A EXECUCAO DO CONTROLE ORCAMENTARIO DE CUSTOS DE PRODUCAO PELA COMPANHIADE PESQUISA DE RECURSOS MINERAIS - CPRM.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.1.32.00', 'CAPTACAO DE RECURSOS INCENTIVADOS', 'COMPRRENDE O CONTROLE DE RECURSOS RECEBIDOS DE PESSOAS FISICAS E JURIDICAS A TITULO DE INCENTIVOS DE PROJETOS CULTURAIS NO AMBITO DO MINISTERIO DA CULTURA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.2.01.00', 'BENS DE ESTOQUE EM TRANSITO', 'COMPREENDE O VALOR DE BENS DE ESTOQUE EM TRANSITO REFERENTE AS TRANSFERENCIAS DO EXERCICIO E DE EXERCICIOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.2.02.00', 'BENS MOVEIS EM TRANSITO', 'COMPREENDE O VALOR DE BENS MOVEIS EM TRANSITO REFERENTE AS TRANSFERENCIAS DO EXERCICIO E DE EXERCICIOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.2.03.00', 'VALORES EM TRANSITO', 'COMPREENDE OS VALORES E TITULOS EM TRANSITO TRANSFERIDOS ENTRE UNIDADES GESTORAS INTEGRANTES DO SIAFI .', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.9.9.3.00.00', 'IMPORTACOES EM ANDAMENTO', 'COMPREENDE O VALOR DAS IMPORTACOES DE MATERIAIS E BENS EM CURSO COM CONTROLE NAS CONTAS DE COMPENSACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.05.00.00.00.00', 'CONTAS A PAGAR CREDORES NACIONAIS DE EXERCICIOS ANTERIORES', 'COMPREENDE OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES A EXERCICIOS ANTERIORES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.0.0.0.0.00.00.00.00.00', 'CONTROLES DA APROVAÇÃO DO PLANEJAMENTO E ORÇAMENTO', 'Compreende as contas com função de registrar os atos e fatos ligados a execução orçamentária.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.0.0.0.00.00.00.00.00', 'PLANEJAMENTO APROVADO', 'Compreende o somatório dos valores monetários previstos para execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei orçamentária anual.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.1.0.0.00.00.00.00.00', 'PPA - APROVADO', 'Compreende o somatório dos valores monetários previstos para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.2.0.0.00.00.00.00.00', 'PLOA', 'Compreende o somatório dos valores monetários previstos para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no projeto de lei orçamentária anual.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.2.1.0.00.00.00.00.00', 'PROJETO INICIAL DA LEI ORCAMENTARIA  - RECEITA', 'COMPREENDE O SOMATORIO DOS VALORES MONETARIOS CONSTANTES DO PROJETO DA LEI ORCAMENTARIA ANUAL REMETIDO PELO PODER EXECUTIVO AO PODER LEGISLATIVO PARA APRECIACAO E APROVACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.2.2.0.00.00.00.00.00', 'PROJETO INICIAL DA LOA - DESPESA', 'COMPREENDE O SOMATORIO DOS VALORES MONETARIOS CONSTANTES DO PROJETO DA LEI ORCAMENTARIA ANUAL REMETIDO PELO PODER EXECUTIVO AO PODER LEGISLATIVO PARA APRECIACAO E APROVACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.0.0.0.00.00.00.00.00', 'ORÇAMENTO APROVADO', 'Compreende o somatório dos valores relativos à previsão da receita, fixação da despesa e suas alterações no orçamento geral da União durante o exercício financeiro.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.0.0.00.00.00.00.00', 'PREVISÃO DA RECEITA', 'Compreende o somatório dos valores relativos à previsão da receita pública aprovada pela lei orçamentária anual e suas alterações.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.1.0.00.00.00.00.00', 'PREVISÃO INICIAL DA RECEITA', 'Compreende o valor da receita previsão inicial da receita aprovado na LOA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.2.0.00.00.00.00.00', 'ALTERAÇÃO DA PREVISÃO DA RECEITA', 'Registra o valor dos créditos previstos após a aprovação do orçamento independente da autorização já concedida na lei orçamentária para abertura de credito suplementar.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.0.0.00.00.00.00.00', 'FIXAÇÃO DA DESPESA', 'Compreende o somatório dos valores relativos à fixação da despesa pública aprovada pela lei orçamentária e suas alterações.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.0.00.00.00.00.00', 'DOTAÇÃO ORÇAMENTÁRIA', 'Compreende o somatório dos valores monetários da dotação orçamentária inicial, adicional e seus cancelamentos.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.1.01.00.00.00.00', 'CREDITO INICIAL', 'COMPREENDE OS VALORES PERTINENTES AOS CREDITOS INICIALMENTE APROVADOS PARA DAR SUPORTE A EXECUCAO ORCAMENTARIA', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.00.00.00.00.00', 'DOTAÇÃO ADICIONAL POR TIPO DE CREDITO', 'Compreende o somatório dos valores monetários da dotação orçamentária decorrentes da abertura de créditos adicionais e seus cancelamentos.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.02.00.00.00.00', 'CREDITO ADICIONAL - ESPECIAL', 'Compreende o somatório dos valores dos créditos adicionais especiais destinados a atender programas não contemplados na lei orçamentária anual.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.03.00.00.00.00', 'CREDITO ADICIONAL - EXTRAORDINÁRIO', 'Compreende o somatório dos valores referentes à abertura de créditos adicionais extraordinários destinados a despesas imprevisíveis e urgentes como as decorrentes de guerra, comoção interna ou calamidade pública.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.00.00.00.00.00', 'DOTAÇÃO ADICIONAL POR FONTE', 'Compreende o somatório dos valores da dotação adicional por fonte de recursos para abertura do credito adicional.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.01.00.00.00.00', 'CREDITO SUPLEMENTAR', 'REGISTRA O SOMATÓRIO DA  MOVIMENTACAO DOS CREDITOS SUPLEMENTARES, DESTINADOS A REFORCO DE DOTACAO ORCAMENTARIA JA EXISTENTE NO ORCAMENTO EM VIGOR, PARA  A REALIZACAO DE DESPESAS,  AUTORIZADA POR LEI E ABERTA POR DECRETOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.01.02.00.00.00', 'EXCESSO DE ARRECADACAO.', 'REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.02.00.00.00.00', 'CREDITO ESPECIAL', 'REGISTRA O SOMATÓRIO DA  MOVIMENTACAO DOS CREDITOS ESPECIAIS, DESTINADOS A NOVAS DOTACÕES ORCAMENTARIAS NÇAO EXISTENTES NO ORCAMENTO EM VIGOR, PARA  A REALIZACAO DE DESPESAS,  AUTORIZADA POR LEI E ABERTA POR DECRETOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.02.02.00.00.00', 'EXCESSO DE ARRECADACAO.', 'REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS SUPLEMENTARES ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.00.00.00.00.00', 'CANCELAMENTO/REMANEJAMENTO DE DOTAÇÃO', 'Compreende o somatório dos valores relativos aos créditos inicial, suplementar, especial e extraordinário cancelados ou remanejados, em casos regularmente previstos.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.01.00.00.00.00', 'ALTERACAO DO QUADRO DE DETALHAMENTO DA DESPESA', 'REGISTRA  A MOVIMENTACAO DOS CREDITOS POR ACRESCIMO OU REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.02.00.00.00.00', 'ALTERACAO DA LEI ORCAMENTARIA', 'REGISTRA OS VALORES DOS CREDITOS ORCAMENTARIOS INDISPONIVEIS PARA EXECUCAO DA DESPESA, POR MEDIDA DE VETO, CONTINGENCIAMENTO OU  CONTENCAO, E POSTERIORMENTE CANCELADAS, NOS CASOS REGULARMENTE PREVISTOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.1.00.00.00.00.00', 'DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO', 'Compreende os valores dos créditos descentralizados das unidades orçamentárias para as unidades administrativas sob sua jurisdição ou entre estas, no âmbito do próprio ministério, secretaria ou órgão equivalente, recebidos ao longo do exercício.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.00.00.00.00.00', 'DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE', 'Compreende a descentralização do credito inicial ou adicional recebido de unidades ou órgãos pertencentes a ministérios, secretarias e órgãos equivalentes distintos ou entre estes e entidades da administração indireta.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.01.00.00.00.00', 'ADMINISTRACAO DIRETA', 'COMPREENDE O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES  DE RECEBIMENTO OU DE TRANSFERENCIA DE OUTROS ORGAOS E ENTIDADES  DE   IGUAL OU DE DIFERENTE UNIDADE ORCAMENTARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.02.00.00.00.00', 'ADMINISTRACAO INDIRETA', 'COMPREENDE O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES   DE RECEBIMENTO OU DE TRANSFERENCIA DE OUTROS ORGAOS E ENTIDADES DE   IGUAL OU DE DIFERENTE UNIDADE ORCAMENTARIA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.01.00.00.00.00', 'EMPENHOS POR NOTA DE EMPENHO', 'COMPREENDE O CONTROLE DOS EMPENHOS EMITIDOS, REFORCADOS E TRANSFERIDOS, QUE ENVOLVAM DESPESAS ORCAMENTARIAS REALIZADAS PELA ADMINISTRACAO PUBLICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.04.00.00.00.00', 'EMPENHOS POR MODALIDADE DE LICITACAO', 'COMPREENDE O SOMATORIO DOS VALORES DA EMISSAO DE EMPENHOS DE DESPESAS COM LICITACOES PARA OBRAS, SERVICOS, FORNECIMENTOS OU ALIENACOES, BEM COMO SUAS DISPENSAS E INEXIGIBILIDADES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.04.08.00.00.00', 'NAO APLICAVEL', 'COMPREENDE O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS  EM QUE NAO SE APLICA A LICITACAO.', 'D', 'S', 'O', NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.09.00.00.00.00', 'EMPENHOS POR CREDOR', 'COMPREENDE O SOMATARIO DOS VALORES DOS EMPENHOS EMITIDOS CONTROLADOS POR   BENEFICIARIOS DO EMPENHO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.0.0.0.00.00.00.00.00', 'INSCRIÇÃO DE RESTOS A PAGAR', 'Compreende o somatório relativo ao valor da inscrição das despesas empenhadas e não pagas.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.1.0.0.00.00.00.00.00', 'INSCRIÇÃO DE RP NÃO PROCESSADOS', 'Compreende o somatório dos valores inscritos em restos a pagar não-processados relativos às despesas empenhadas e não liquidadas.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.2.0.0.00.00.00.00.00', 'INSCRIÇÃO DE RP PROCESSADOS', 'Compreende o somatório dos valores inscritos em restos a pagar processados.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.0.0.0.0.00.00.00.00.00', 'CONTROLES DA EXECUÇÃO DO PLANEJAMENTO E ORÇAMENTO', 'Compreende as contas com função de registra os atos e fatos ligados a execução orçamentária.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.0.0.0.00.00.00.00.00', 'EXECUÇÃO DO PLANEJAMENTO', 'Compreende o somatório dos valores monetários relativos à execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei orçamentária anual.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.1.0.0.00.00.00.00.00', 'EXECUÇÃO DO PPA', 'Compreende o somatório dos valores monetários relativos à execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.2.0.0.00.00.00.00.00', 'EXECUÇÃO DO PLOA', 'Compreende o somatório dos valores monetários de receitas e despesas previstos no projeto de lei orçamentária durante as suas fases de tramitação.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.0.0.0.00.00.00.00.00', 'EXECUÇÃO DO ORÇAMENTO', 'Compreende o somatório dos valores relativos à realização da receita, execução da despesa e suas alterações no orçamento geral da União durante o exercício financeiro.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.1.0.0.00.00.00.00.00', 'EXECUÇÃO DA RECEITA', 'Compreende o somatório dos valores relativos à realização da receita pública aprovada pela lei orçamentária anual e suas alterações.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.0.0.00.00.00.00.00', 'EXECUÇÃO DA DESPESA', 'Compreende o somatório da disponibilidade de credito orçamentário e da execução da despesa em suas diversas etapas.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.0.00.00.00.00.00', 'DISPONIBILIDADES DE CREDITO', 'Compreende o somatório da disponibilidade de credito orçamentário e suas alterações.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.2.00.00.00.00.00', 'CREDITO INDISPONÍVEL', 'Compreende o valor da indisponibilidade de credito orçamentário pelo seu contingenciamento ou liberação pendentes de autorização legislativa.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.2.01.00.00.00.00', 'BLOQUEIO DE CREDITO', 'COMPREENDE O VALOR DA DISPONIBILIDADE DE CREDITOS ORCAMENTARIOS   POR CONTENCAO OU CONTINGENCIAMENTO PELA SETORIAL ORCAMENTARIA, SOF E OUTROS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.0.00.00.00.00.00', 'MOVIMENTAÇÃO DE CRÉDITOS CONCEDIDOS', 'Compreende o somatório dos valores dos créditos orçamentários concedidos através de destaque, provisão ou por fusão, cisão ou extinção de unidades.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.1.00.00.00.00.00', 'DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO', 'Compreende os valores dos créditos descentralizados das unidades orçamentárias para as unidades administrativas sob sua jurisdição ou entre estas, no âmbito do próprio ministério, secretaria ou órgão equivalente, concedidos ao longo do exercício.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.2.00.00.00.00.00', 'DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE', 'Compreende a descentralização do credito inicial ou adicional concedido de unidades ou órgãos pertencentes a ministérios, secretarias e órgãos equivalentes distintos ou entre estes e entidades da administração indireta.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.2.01.00.00.00.00', 'ADMINISTRACAO DIRETA', 'REGISTRA O VALOR REFERENTE AO MOVIMENTO DE CREDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO DIRETA TRANSFERIDORA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.2.02.00.00.00.00', 'ADMINISTRACAO INDIRETA', 'REGISTRA O VALOR REFERENTE AO MOVIMENTO DE CREDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DA ENTIDADE DA ADMINISTRACAO INDIRETA TRANSFERIDORA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.0.00.00.00.00.00', 'OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA', 'Compreende o somatório dos valores executados das despesas pré-empenhadas e empenhadas por detalhamento específico.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.00.00.00.00.00', 'EMISSAO DE EMPENHO', 'COMPREENDE O SOMATORIO DOS VALORES EXECUTADOS DAS DESPESAS EMPENHADAS POR DETALHAMENTO ESPECIFICO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.00.00.00.00', 'EMPENHOS POR NOTA DE EMPENHO', 'COMPREENDE O VALOR DA EMISSAO DE DOCUMENTOS ATRAVES DOS QUAIS SAO REGISTRADOS OS ESTAGIOS DAS DESPESAS ORCAMENTARIAS REALIZADAS PELA ADMINISTRACAO PUBLICA.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.04.00.00.00.00', 'EMPENHOS POR MODALIDADE DE LICITACAO - A LIQUIDAR', 'COMPREENDE O VALOR DOS EMPENHOS A LIQUIDAR, COM CONTROLE POR MODALIDADE DE LICITACAO OU POR SUA DISPENSA OU INEXIGIBILIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.05.00.00.00.00', 'EMPENHOS POR MODALIDADE DE LICITACAO - EM LIQUIDAÇÃO', 'COMPREENDE O VALOR DOS EMPENHOS EM LIQUIDAÇÃO, COM CONTROLE POR MODALIDADE DE LICITACAO OU POR SUA DISPENSA OU INEXIGIBILIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.06.00.00.00.00', 'EMPENHOS POR MODALIDADE DE LICITACAO - LIQUIDADO', 'COMPREENDE O VALOR DOS EMPENHOS LIQUIDADOS, COM CONTROLE POR MODALIDADE DE LICITACAO OU POR SUA DISPENSA OU INEXIGIBILIDADE.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.07.00.00.00.00', 'EMPENHOS DE RESTOS A PAGAR - POR CREDOR', 'REGISTRA O VALOR DOS EMPENHOS DE RESTOS A PAGAR, CONTROLADOS POR BENEFICIARIOS.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.09.00.00.00.00', 'EMPENHOS POR CREDOR', 'COMPREENDE O SOMATORIO DA EXECUCAO DE CREDITOS ORCAMENTARIOS, CONTROLADOS POR BENEFICIARIO.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.0.0.0.00.00.00.00.00', 'EXECUÇÃO DE RESTOS A PAGAR', 'Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas e não pagas.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.0.0.00.00.00.00.00', 'EXECUÇÃO DE RP NÃO PROCESSADOS', 'Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, não liquidadas no exercício financeiro de sua inscrição e não pagas.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.9.0.00.00.00.00.00', 'RP NÃO PROCESSADOS CANCELADOS', 'Compreende o cancelamento de restos a pagar não processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.0.0.00.00.00.00.00', 'EXECUÇÃO DE RP PROCESSADOS', 'Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, liquidadas no exercício financeiro de sua inscrição e não pagas.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.9.0.00.00.00.00.00', 'RP PROCESSADOS CANCELADOS', 'Compreende o cancelamento de restos a pagar processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.9.1.00.00.00.00.00', 'POR VALORES E/OU INSCRICOES INDEVIDAS', 'REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS  CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO POR VALORES E/OU INSCRICOES.', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.06.03', 'Bancos Conta Movimento - Plano Previdenciário', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.06.04', 'Bancos Conta Movimento - Taxa de Administração', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.06.00', 'Conta Única - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.06.01', 'Bancos Conta Movimento - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.06.02', 'Bancos Conta Movimento - Plano Financeiro', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.06.03', 'Bancos Conta Movimento - Plano Previdenciário', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.06.04', 'Conta Movimento - Taxa de Administração', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.07.03', 'Juros e Encargos sobre Empréstimos a Receber RPPS - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.07.04', 'Juros e Encargos sobre Financiamentos a Receber RPPS - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.3.00.00', 'Empréstimos e Financiamentos Concedidos - Inter OFSS - União', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.3.07.00', 'Empréstimos e Financiamentos Concedidos com Recursos Previdenciários', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.3.07.01', 'Empréstimos a Receber - RPPS ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.3.07.02', 'Financiamentos a Receber - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.3.07.03', 'Juros e Encargos sobre Empréstimos a Receber RPPS - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.3.07.04', 'Juros e Encargos sobre Financiamentos a Receber RPPS - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.07.03', 'Juros e Encargos sobre Empréstimos a Receber RPPS - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.4.07.04', 'Juros e Encargos sobre Financiamentos a Receber RPPS - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.07.03', 'Juros e Encargos sobre Empréstimos a Receber RPPS - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.5.07.04', 'Juros e Encargos sobre Financiamentos a Receber RPPS - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.06.00', 'Perdas Estimadas em Créditos de Empréstimos e Financiamentos Concedidos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.06.00', 'Perdas Estimadas em Créditos de Empréstimos e Financiamentos Concedidos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.00.00', 'Ajustes de Perdas de Créditos a Curto Prazo - Inter OFSS - União', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.06.00', 'Perdas Estimadas em Créditos de Empréstimos e Financiamentos Concedidos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.06.00', 'Perdas Estimadas em Créditos de Empréstimos e Financiamentos Concedidos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.06.00', 'Perdas Estimadas em Créditos de Empréstimos e Financiamentos Concedidos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.10.06', 'Fundos de Investimentos Imobiliários', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.11.01', 'Fundos de Investimentos Imobiliários', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.12.01', 'Títulos e Valores em Enquadramento', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.13.01', 'Títulos e Valores Não Sujeitos ao Enquadramento', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.14.01', 'Aplicações com a Taxa de Administração do RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.99.06', 'Ajustes de Perdas de Empréstimos e Financiamentos Concedidos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.99.06', 'Ajustes de Perdas de Empréstimos e Financiamentos Concedidos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.00.00', 'Créditos a Longo Prazo - Inter OFSS - União', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.03.00', 'Dívida Ativa Tributária', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.03.01', 'Créditos Não Previdenciários Inscritos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.03.02', 'Créditos Previdenciários Inscritos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.05.00', 'Empréstimos e Financiamentos Concedidos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.05.03', 'Empréstimos a Receber - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.99.00', 'Ajustes de Perdas de Créditos a Longo Prazo', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.99.03', 'Ajustes de Perdas de Dívida Ativa Tributária', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.99.04', 'Ajustes de Perdas de Dívida Ativa Não Tributária', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.99.06', 'Ajustes de Perdas de Empréstimos e Financiamentos Concedidos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.99.06', 'Ajustes de Perdas de Empréstimos e Financiamentos Concedidos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.99.06', 'Ajustes de Perdas de Empréstimos e Financiamentos Concedidos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.3.1.01.00', 'Títulos e Valores Mobiliários - RPPS ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.3.1.01.01', 'Aplicações em Ativos em Enquadramento - Títulos e Valores', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.3.1.01.02', 'Aplicações em Ativos Não Sujeitos à Resolução do CMN - Títulos e Valores', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.3.1.02.00', 'Aplicações em Segmento de Imóveis - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.3.1.02.01', 'Imóveis - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.3.00.00', 'Benefícios Previdenciários a Pagar - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.3.04.00', 'Precatórios Encaminhados - Justiça', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.5.00.00', 'Benefícios Previdenciários a Pagar - Inter OFSS - Município ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.5.04.00', 'Precatórios Encaminhados - Justiça', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.00.00', 'Encargos Sociais a Pagar - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.01.01', 'INSS - Contribuição sobre Salários e Remunerações', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.01.02', 'INSS - Débito Parcelado', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.01.03', 'INSS - Contribuição sobre Serviços de Terceiros ou Contribuintes Avulsos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.01.04', 'INSS - Fundo da Previdência e Assistência Social FPAS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.03.00', 'PSSS- Contribuição sobre Vencimentos e Vantagens', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.04.00', 'Contribuição a Regime Próprio de Previdência', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.04.01', 'Contribuição a Regime Próprio de Previdência do Ente', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.04.02', 'Contribuição a Regime Próprio de Previdência - Pessoal Requisitado de Outros Entes', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.05.00', 'Previdência Social Rural', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.09.00', 'Recursos Previdenciários - GPS a Emitir', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.98.00', 'Outros Encargos Sociais', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.3.00.00', 'Empréstimos e Financiamentos a Curto Prazo - Interno - Inter OFSS - União', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.3.00.00', 'Encargos Sociais a Pagar - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.3.01.00', 'INSS a Pagar', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.3.01.01', 'INSS a Pagar - Débito Parcelado', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.3.02.00', 'Contribuição ao Regime Próprio de Previdência Social', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.3.02.01', 'RPPS - Débito Parcelado', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.3.98.00', 'Outros Encargos Sociais', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.3.00.00', 'Financiamentos a Longo Prazo - Interno Inter OFSS - União  ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.3.00.00', 'Financiamentos a Longo Prazo - Interno Inter OFSS - União  ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.3.00.00', 'Reserva de Reavaliação - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.3.01.00', 'Reavaliação de Bens Imóveis', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.3.03.00', 'Reavaliação de Bens Móveis', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.3.04.00', 'Reavaliação de Bens Intangíveis', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.3.98.00', 'Outras Reservas de Reavaliação ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.9.3.00.00', 'Outras Reservas - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.3.00.00', 'Superávits ou Déficits Acumulados - Inter OFSS - União', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.3.01.00', 'Superávits ou Déficits do Exercício ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.3.02.00', 'Superávits ou Déficits de Exercícios Anteriores', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.3.03.00', 'Ajustes de Exercícios Anteriores', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.3.00.00', 'Encargos Patronais - RPPS - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.3.01.00', 'Contribuição Patronal para o RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.3.02.00', 'Encargos de Pessoal Requisitado de Outros Entes', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.3.06.00', 'Contribuição para o Pasep sobre Folha de Pagamento', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.3.99.00', 'Outros Encargos Patronais - RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.3.00.00', 'Encargos Patronais - RGPS - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.3.01.00', 'Contribuições Previdenciárias - INSS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.3.02.00', 'Contribuições Previdenciárias no Exterior', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.3.03.00', 'Seguro de Acidente no Trabalho', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.3.04.00', 'Encargos de Pessoal Requisitado de Outros Entes', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.3.06.00', 'Contribuição para o PIS sobre Folha de Pagamento', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.3.99.00', 'Encargos de Pessoal Requisitado de Outros Entes', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.3.00.00', 'Encargos Patronais - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.00.00', 'Serviços Terceiros - Pessoa Jurídica - Inter OFSS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.01.00', 'Consultoria e Assessoria', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.01.01', 'Consultoria e Assessoria - Jurídica e Técnica', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.01.02', 'Consultoria e Assessoria - Tecnologia da Informação', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.01.99', 'Outros Serviços de Consultoria', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.02.00', 'Perícias', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.02.02', 'Perícia Médica, Odontológica  por Benefícios', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.02.99', 'Outros Serviços de Perícia', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.03.00', 'Auditoria Externa', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.04.00', 'Comunicação ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.04.01', 'Telecomunicações', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.04.02', 'Correspondências', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.04.03', 'Comunicação de Dados', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.04.99', 'Outros Serviços de Comunicação', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.05.00', 'Publicidade', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.05.01', 'Publicidade Legal', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.05.03', 'Publicidade Institucional', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.05.99', 'Outros Serviços de Publicidade', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.06.00', 'Manutenção e Conservação', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.06.02', 'Manutenção e Conservação de Bens Imóveis', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.06.04', 'Manutenção e Conservação de Veículos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.06.05', 'Manutenção e Conservação de Equipamentos de Processamento de Dados', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.06.06', 'Manutenção e Conservação de Máquinas e Equipamentos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.06.07', 'Manutenção e Conservação de Software', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.06.08', 'Manutenção e Conservação de Outros Bens Móveis', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.06.99', 'Outros Serviços de Manutenção e Conservação', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.07.00', 'Serviços de Apoio', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.07.01', 'Apoio Administrativo, Técnico e Operacional', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.07.02', 'Limpeza e Conservação', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.07.03', 'Vigilância Ostensiva Monitorada', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.07.99', 'Outros Serviços de Apoio Administrativo, Técnico e Operacional', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.08.00', 'Serviços de Água e Esgoto, Energia Elétrica, Gás e Outros', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.08.01', 'Serviços de Água e Esgoto', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.08.02', 'Serviços de Energia Elétrica', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.08.03', 'Serviços de Gás', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.10.01', 'Locações de Imóveis', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.10.02', 'Locações de Software', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.10.03', 'Locação de Máquinas e Equipamentos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.10.04', 'Locação de Bens Móveis de Outras Naturezas e Intangíveis', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.10.05', 'Locação de Equipamentos de Processamento de Dados', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.11.00', 'Serviços Relacionados a Tecnologia da Informação', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.11.01', 'Desenvolvimento de Software', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.11.02', 'Suporte de Infraestrutura de TI', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.11.03', 'Suporte a Usuários de  TI', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.11.04', 'Hospedagens de Sistemas', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.11.05', 'Serviços Técnicos Profissionais de TI', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.14.00', 'Assinaturas de Periódicos e Anuidades', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.21.00', 'Direitos Autorais', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.25.00', 'Hospedagens', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.29.00', 'Seguros em Geral', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.30.00', 'Seleção e Treinamento', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.32.00', 'Serviços Bancários', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.36.00', 'Serviços de Áudio, Vídeo e Foto', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.48.00', 'Serviços Gráficos e Editoriais', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.51.00', 'Serviços Técnicos Profissionais', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.54.00', 'Locação de Mão-de-Obra', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.54.01', 'Locação de Mão-de-Obra de Apoio Administrativo, Técnico e Operacional', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.54.02', 'Locação de Mão-de-Obra de Limpeza e Conservação', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.54.03', 'Locação de Mão-de-Obra de Vigilância Ostensiva', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.54.04', 'Locação de Mão-de-Obra de Manutenção e Conservação de Bens Imóveis', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.54.06', 'Locação de Mão-de-Obra de Manutenção e Conservação de Bens Móveis', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.54.09', 'Locação de Mão-de-Obra de Manutenção de Software', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.54.99', 'Outras Locações de Mão-de-Obra', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.55.00', 'Arrendamento Mercantil Operacional', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.55.01', 'Arrendamento Mercantil Operacional de Máquinas e Aparelhos', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.55.03', 'Arrendamento Mercantil Operacional de Veículos Rodoviários', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.55.04', 'Arrendamento Mercantil Operacional de Outros Bens Móveis', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.55.05', 'Arrendamento Mercantil Operacional de Bens Imóveis', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.55.99', 'Outros Arrendamentos Mercantis Operacionais', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.56.00', 'Passagens e Despesas com Locomoção', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.56.01', 'Passagens para o  País', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.56.02', 'Passagens para o  Exterior', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.56.03', 'Locação de Meios de Transporte', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.56.08', 'Pedágios', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.56.99', 'Outras Despesas com Locomoção', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.3.99.00', 'Outros Serviços Prestados por Pessoa Jurídica', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.3.00.00', 'Outras Variações Monetárias e Cambiais - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.3.02.00', 'Outras Variações Cambiais', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.3.00.00', 'Outras Transferências - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.3.00.00', 'Redução a Valor Recuperável de Investimentos -Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.3.00.00', 'Variação Patrimonial Diminutiva com Ajustes de Perdas de Créditos - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.1.3.00.00', 'Compensação Financeira entre RGPS/RPPS - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.97.10', 'Renúncia', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.97.10', 'Renúncia', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.3.00.00', 'Contribuições Sociais RPPS - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.3.01.00', 'Contribuições Patronais ao RPPS', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.3.01.01', 'Contribuição Patronal de Servidor Civil - RPPS ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.3.01.02', 'Contribuição Patronal - Pagamento de Sentenças Judiciais', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.3.97.00', 'Deduções', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.3.97.10', 'Renúncia', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.3.99.00', 'Outras Contribuições Sociais - RPPS ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.97.10', 'Renúncia', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.4.3.00.00', 'Outras Transferências - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.1.3.00.00', 'Compensação Financeira entre RGPS/RPPS - Inter OFSS - União ', '', NULL, 'N', NULL, NULL);

UPDATE contabilidade.plano_conta_estrutura SET escrituracao = 'S' WHERE escrituracao = 's';


----------------
-- Ticket #19888
----------------

DELETE FROM contabilidade.classificacao_plano WHERE exercicio = '2013';
DELETE FROM contabilidade.plano_banco         WHERE exercicio = '2013';
DELETE FROM contabilidade.plano_recurso       WHERE exercicio = '2013';
DELETE FROM contabilidade.plano_analitica     WHERE exercicio = '2013';
DELETE FROM contabilidade.plano_conta         WHERE exercicio = '2013';


----------------
-- Ticket #19764
----------------

UPDATE administracao.funcionalidade SET ativo = FALSE WHERE cod_funcionalidade =  162;
UPDATE administracao.acao           SET ativo = FALSE WHERE cod_acao           = 2390;

